(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   3042167,     203867]*)
(*NotebookOutlinePosition[   3044491,     203936]*)
(*  CellTagsIndexPosition[   3044113,     203923]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["\<\

Evolutionary Programming of 2D Fractals\
\>", "Title",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Christian Jacob, jacob@cpsc.ucalgary.ca  January 1995 / February \
2001 \[Copyright]\
\>", "Subsubtitle"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.0238095 0.952381 0.0147151 0.588604 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
% Start of sub-graphic
p
0.0238095 0.0147151 0.97619 0.603319 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.136054 0.0169173 0.136054 [
p
/Times findfont 14 scalefont setfont
[(Gen. 80)] .5 .71053 0 -2 Msboxa
P
[ 0 0 0 0 ]
[ 1 .71053 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
p
/Times findfont 14 scalefont setfont
[(Gen. 80)] .5 .71053 0 -2 Mshowa
P
P
0 0 m
1 0 L
1 .71053 L
0 .71053 L
closepath
clip
newpath
p
p
% Start of sub-graphic
p
0.0238095 0.0169173 0.149123 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.758303 2.5909 0.0163524 0.959656 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.65693 .26414 m
.65922 .32981 L
s
P
p
0 .4 1 r
.02 w
.5475 .21345 m
.65693 .26414 L
s
P
p
0 .4 1 r
.02 w
.65922 .32981 m
.5477 .27966 L
s
P
p
0 .4 1 r
.02 w
.5477 .27966 m
.5475 .21345 L
s
P
p
.2 1 0 r
.02 w
.86547 .63433 m
.75767 .59089 L
s
P
p
.2 1 0 r
.02 w
.87194 .70928 m
.86547 .63433 L
s
P
p
.2 1 0 r
.02 w
.75339 .51794 m
.64249 .47155 L
s
P
p
.2 1 0 r
.02 w
.75767 .59089 m
.75339 .51794 L
s
P
p
0 .4 1 r
.02 w
.5477 .27966 m
.43082 .22711 L
s
P
p
.2 1 0 r
.02 w
.76212 .66678 m
.87194 .70928 L
s
P
p
.2 1 0 r
.02 w
.64249 .47155 m
.64463 .54533 L
s
P
p
0 .4 1 r
.02 w
.66408 .46898 m
.66666 .5428 L
s
P
p
0 .4 1 r
.02 w
.54813 .4202 m
.66408 .46898 L
s
P
p
.2 1 0 r
.02 w
.52639 .35127 m
.40675 .29947 L
s
P
p
.2 1 0 r
.02 w
.52617 .4229 m
.52639 .35127 L
s
P
p
0 .4 1 r
.02 w
.54792 .34853 m
.42864 .29659 L
s
P
p
0 .4 1 r
.02 w
.54813 .4202 m
.54792 .34853 L
s
P
p
0 .4 1 r
.02 w
.43082 .22711 m
.42864 .29659 L
s
P
p
0 .4 1 r
.02 w
.31278 .10471 m
.30817 .17196 L
s
P
p
0 .4 1 r
.02 w
.1867 .04631 m
.31278 .10471 L
s
P
p
.2 1 0 r
.02 w
.64685 .62217 m
.76212 .66678 L
s
P
p
.2 1 0 r
.02 w
.64463 .54533 m
.52594 .49751 L
s
P
p
0 .4 1 r
.02 w
.66666 .5428 m
.54836 .49485 L
s
P
p
.2 1 0 r
.02 w
.52594 .49751 m
.52617 .4229 L
s
P
p
0 .4 1 r
.02 w
.54836 .49485 m
.54813 .4202 L
s
P
p
.2 1 0 r
.02 w
.40675 .29947 m
.40403 .37181 L
s
P
p
0 .4 1 r
.02 w
.42864 .29659 m
.42637 .36897 L
s
P
p
0 .4 1 r
.02 w
.30336 .24203 m
.42864 .29659 L
s
P
p
0 .4 1 r
.02 w
.30817 .17196 m
.30336 .24203 L
s
P
p
0 .4 1 r
.02 w
.30817 .17196 m
.17931 .11402 L
s
P
p
.2 1 0 r
.02 w
.76676 .7458 m
.64917 .70225 L
s
P
p
.2 1 0 r
.02 w
.77159 .82814 m
.76676 .7458 L
s
P
p
0 .4 1 r
.02 w
.17931 .11402 m
.1867 .04631 L
s
P
p
.2 1 0 r
.02 w
.64917 .70225 m
.64685 .62217 L
s
P
p
.2 1 0 r
.02 w
.40403 .37181 m
.27561 .31809 L
s
P
p
0 .4 1 r
.02 w
.42637 .36897 m
.29835 .31511 L
s
P
p
.2 1 0 r
.02 w
.65159 .78579 m
.77159 .82814 L
s
P
p
.2 1 0 r
.02 w
.40119 .44724 m
.39823 .52595 L
s
P
p
.2 1 0 r
.02 w
.26989 .39433 m
.40119 .44724 L
s
P
p
.01 w
.27561 .31809 Mdot
P
p
.2 1 0 r
.02 w
.27561 .31809 m
.26989 .39433 L
s
P
p
.01 w
.29835 .31511 Mdot
P
p
0 .4 1 r
.02 w
.16357 .2584 m
.29835 .31511 L
s
P
p
0 .4 1 r
.02 w
.29835 .31511 m
.29312 .39138 L
s
P
p
.2 1 0 r
.02 w
.65411 .87301 m
.65159 .78579 L
s
P
p
.2 1 0 r
.02 w
.52546 .65643 m
.5252 .74118 L
s
P
p
.2 1 0 r
.02 w
.39514 .60817 m
.52546 .65643 L
s
P
p
.2 1 0 r
.02 w
.39823 .52595 m
.26391 .47397 L
s
P
p
0 .4 1 r
.02 w
.29312 .39138 m
.15517 .33546 L
s
P
p
0 .4 1 r
.02 w
.15517 .33546 m
.16357 .2584 L
s
P
p
.2 1 0 r
.02 w
.52493 .82976 m
.65411 .87301 L
s
P
p
.2 1 0 r
.02 w
.5252 .74118 m
.52493 .82976 L
s
P
p
.2 1 0 r
.02 w
.3919 .69413 m
.39514 .60817 L
s
P
p
.2 1 0 r
.02 w
.26391 .47397 m
.12219 .41912 L
s
P
p
.2 1 0 r
.02 w
.25112 .64444 m
.3919 .69413 L
s
P
p
.2 1 0 r
.02 w
.25766 .55725 m
.25112 .64444 L
s
P
p
.2 1 0 r
.02 w
.11243 .50347 m
.25766 .55725 L
s
P
p
.2 1 0 r
.02 w
.12219 .41912 m
.11243 .50347 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.0169173 0.286967 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.7867 .53145 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.89777 .66825 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56304 .80672 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.15169 .31032 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.139 .40899 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.0169173 0.424812 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.17486 .13016 L
s
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
0 .4 1 r
.02 w
.16362 .21754 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.17486 .13016 m
.16362 .21754 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.0169173 0.562657 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.67773 .47655 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.68474 .65693 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.15169 .31032 L
s
P
p
0 .4 1 r
.02 w
.42373 .75116 m
.56304 .80672 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.42373 .75116 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.139 .40899 L
s
P
p
0 .4 1 r
.02 w
.12548 .51415 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.12548 .51415 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.0169173 0.700501 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.559341 2.21998 0.0242236 0.968945 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.86902 .56205 m
.78139 .51778 L
s
P
p
.2 1 0 r
.02 w
.87582 .63372 m
.86902 .56205 L
s
P
p
.2 1 0 r
.02 w
.77654 .44823 m
.68613 .40083 L
s
P
p
.2 1 0 r
.02 w
.78139 .51778 m
.77654 .44823 L
s
P
p
.2 1 0 r
.02 w
.78644 .59037 m
.87582 .63372 L
s
P
p
0 .4 1 r
.02 w
.89392 .63143 m
.80489 .58796 L
s
P
p
0 .4 1 r
.02 w
.90142 .70629 m
.89392 .63143 L
s
P
p
0 .4 1 r
.02 w
.79942 .51531 m
.7075 .46857 L
s
P
p
0 .4 1 r
.02 w
.80489 .58796 m
.79942 .51531 L
s
P
p
.2 1 0 r
.02 w
.68613 .40083 m
.68912 .47117 L
s
P
p
.2 1 0 r
.02 w
.59006 .28288 m
.49187 .22959 L
s
P
p
.2 1 0 r
.02 w
.59093 .35091 m
.59006 .28288 L
s
P
p
0 .4 1 r
.02 w
.60798 .28006 m
.51013 .22662 L
s
P
p
0 .4 1 r
.02 w
.60925 .34813 m
.60798 .28006 L
s
P
p
0 .4 1 r
.02 w
.81059 .66386 m
.90142 .70629 L
s
P
p
.2 1 0 r
.02 w
.69223 .54467 m
.78644 .59037 L
s
P
p
.2 1 0 r
.02 w
.68912 .47117 m
.59184 .42203 L
s
P
p
0 .4 1 r
.02 w
.7075 .46857 m
.61058 .41929 L
s
P
p
.2 1 0 r
.02 w
.59184 .42203 m
.59093 .35091 L
s
P
p
0 .4 1 r
.02 w
.61058 .41929 m
.60925 .34813 L
s
P
p
.2 1 0 r
.02 w
.49187 .22959 m
.49053 .29827 L
s
P
p
0 .4 1 r
.02 w
.51013 .22662 m
.50921 .29534 L
s
P
p
.2 1 0 r
.02 w
.79173 .66622 m
.6955 .62156 L
s
P
p
.2 1 0 r
.02 w
.79726 .74554 m
.79173 .66622 L
s
P
p
0 .4 1 r
.02 w
.71474 .61907 m
.81059 .66386 L
s
P
p
.2 1 0 r
.02 w
.6955 .62156 m
.69223 .54467 L
s
P
p
.2 1 0 r
.02 w
.49053 .29827 m
.38451 .24268 L
s
P
p
0 .4 1 r
.02 w
.50921 .29534 m
.40355 .23958 L
s
P
p
.2 1 0 r
.02 w
.69891 .70208 m
.79726 .74554 L
s
P
p
0 .4 1 r
.02 w
.71861 .69966 m
.71474 .61907 L
s
P
p
.2 1 0 r
.02 w
.48913 .37015 m
.48767 .44545 L
s
P
p
.2 1 0 r
.02 w
.38053 .31529 m
.48913 .37015 L
s
P
p
.01 w
.38451 .24268 Mdot
P
p
.2 1 0 r
.02 w
.38451 .24268 m
.38053 .31529 L
s
P
p
.01 w
.40355 .23958 Mdot
P
p
0 .4 1 r
.02 w
.40355 .23958 m
.40002 .31223 L
s
P
p
.2 1 0 r
.02 w
.70249 .78649 m
.69891 .70208 L
s
P
p
0 .4 1 r
.02 w
.72268 .78413 m
.71861 .69966 L
s
P
p
.2 1 0 r
.02 w
.59379 .57437 m
.59484 .65609 L
s
P
p
.2 1 0 r
.02 w
.48613 .52442 m
.59379 .57437 L
s
P
p
.2 1 0 r
.02 w
.48767 .44545 m
.37637 .39146 L
s
P
p
0 .4 1 r
.02 w
.40002 .31223 m
.39633 .38845 L
s
P
p
.2 1 0 r
.02 w
.59594 .74187 m
.70249 .78649 L
s
P
p
0 .4 1 r
.02 w
.61655 .73938 m
.72268 .78413 L
s
P
p
.2 1 0 r
.02 w
.59484 .65609 m
.59594 .74187 L
s
P
p
.2 1 0 r
.02 w
.48452 .60734 m
.48613 .52442 L
s
P
p
.2 1 0 r
.02 w
.37637 .39146 m
.25832 .3342 L
s
P
p
0 .4 1 r
.02 w
.39633 .38845 m
.27869 .331 L
s
P
p
0 .4 1 r
.02 w
.61824 .82962 m
.61655 .73938 L
s
P
p
.2 1 0 r
.02 w
.36738 .55557 m
.48452 .60734 L
s
P
p
0 .4 1 r
.02 w
.50506 .60461 m
.50389 .69186 L
s
P
p
0 .4 1 r
.02 w
.38836 .55268 m
.50506 .60461 L
s
P
p
.2 1 0 r
.02 w
.37199 .47146 m
.36738 .55557 L
s
P
p
.2 1 0 r
.02 w
.25075 .4152 m
.37199 .47146 L
s
P
p
.2 1 0 r
.02 w
.25832 .3342 m
.25075 .4152 L
s
P
p
0 .4 1 r
.02 w
.27869 .331 m
.15369 .26996 L
s
P
p
0 .4 1 r
.02 w
.50266 .7837 m
.61824 .82962 L
s
P
p
0 .4 1 r
.02 w
.50389 .69186 m
.50266 .7837 L
s
P
p
0 .4 1 r
.02 w
.2642 .49742 m
.38836 .55268 L
s
P
p
0 .4 1 r
.02 w
.27163 .41205 m
.2642 .49742 L
s
P
p
0 .4 1 r
.02 w
.14306 .35198 m
.27163 .41205 L
s
P
p
0 .4 1 r
.02 w
.15369 .26996 m
.14306 .35198 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.0169173 0.838346 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.559341 2.21998 0.0242236 0.968945 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.88673 .5597 m
.79942 .51531 L
s
P
p
0 .4 1 r
.02 w
.89392 .63143 m
.88673 .5597 L
s
P
p
0 .4 1 r
.02 w
.79419 .44573 m
.70412 .39819 L
s
P
p
0 .4 1 r
.02 w
.79942 .51531 m
.79419 .44573 L
s
P
p
0 .4 1 r
.02 w
.90142 .70629 m
.89392 .63143 L
s
P
p
.2 1 0 r
.02 w
.78139 .51778 m
.68912 .47117 L
s
P
p
.2 1 0 r
.02 w
.78644 .59037 m
.78139 .51778 L
s
P
p
.2 1 0 r
.02 w
.68613 .40083 m
.59093 .35091 L
s
P
p
.2 1 0 r
.02 w
.68912 .47117 m
.68613 .40083 L
s
P
p
0 .4 1 r
.02 w
.70412 .39819 m
.7075 .46857 L
s
P
p
0 .4 1 r
.02 w
.60798 .28006 m
.51013 .22662 L
s
P
p
0 .4 1 r
.02 w
.60925 .34813 m
.60798 .28006 L
s
P
p
0 .4 1 r
.02 w
.81059 .66386 m
.90142 .70629 L
s
P
p
.2 1 0 r
.02 w
.69223 .54467 m
.78644 .59037 L
s
P
p
0 .4 1 r
.02 w
.7075 .46857 m
.61058 .41929 L
s
P
p
.2 1 0 r
.02 w
.59093 .35091 m
.59184 .42203 L
s
P
p
0 .4 1 r
.02 w
.61058 .41929 m
.60925 .34813 L
s
P
p
.2 1 0 r
.02 w
.49187 .22959 m
.3883 .17339 L
s
P
p
.2 1 0 r
.02 w
.49053 .29827 m
.49187 .22959 L
s
P
p
0 .4 1 r
.02 w
.51013 .22662 m
.40691 .17026 L
s
P
p
0 .4 1 r
.02 w
.71474 .61907 m
.81059 .66386 L
s
P
p
.2 1 0 r
.02 w
.59279 .49644 m
.69223 .54467 L
s
P
p
.2 1 0 r
.02 w
.59184 .42203 m
.48913 .37015 L
s
P
p
.2 1 0 r
.02 w
.48913 .37015 m
.49053 .29827 L
s
P
p
.2 1 0 r
.02 w
.3883 .17339 m
.38451 .24268 L
s
P
p
0 .4 1 r
.02 w
.40691 .17026 m
.40355 .23958 L
s
P
p
0 .4 1 r
.02 w
.81656 .74325 m
.71861 .69966 L
s
P
p
0 .4 1 r
.02 w
.82281 .82637 m
.81656 .74325 L
s
P
p
.2 1 0 r
.02 w
.6955 .62156 m
.59379 .57437 L
s
P
p
.2 1 0 r
.02 w
.69891 .70208 m
.6955 .62156 L
s
P
p
0 .4 1 r
.02 w
.71861 .69966 m
.71474 .61907 L
s
P
p
.2 1 0 r
.02 w
.59379 .57437 m
.59279 .49644 L
s
P
p
.2 1 0 r
.02 w
.38451 .24268 m
.27237 .18389 L
s
P
p
0 .4 1 r
.02 w
.40355 .23958 m
.29178 .1806 L
s
P
p
0 .4 1 r
.02 w
.72268 .78413 m
.82281 .82637 L
s
P
p
.2 1 0 r
.02 w
.59484 .65609 m
.69891 .70208 L
s
P
p
.2 1 0 r
.02 w
.38053 .31529 m
.37637 .39146 L
s
P
p
.2 1 0 r
.02 w
.26551 .25719 m
.38053 .31529 L
s
P
p
0 .4 1 r
.02 w
.40002 .31223 m
.39633 .38845 L
s
P
p
0 .4 1 r
.02 w
.2854 .25395 m
.40002 .31223 L
s
P
p
.01 w
.27237 .18389 Mdot
P
p
.2 1 0 r
.02 w
.27237 .18389 m
.26551 .25719 L
s
P
p
.01 w
.29178 .1806 Mdot
P
p
0 .4 1 r
.02 w
.29178 .1806 m
.2854 .25395 L
s
P
p
0 .4 1 r
.02 w
.72694 .8728 m
.72268 .78413 L
s
P
p
.2 1 0 r
.02 w
.59594 .74187 m
.59484 .65609 L
s
P
p
.2 1 0 r
.02 w
.48613 .52442 m
.48452 .60734 L
s
P
p
.2 1 0 r
.02 w
.37199 .47146 m
.48613 .52442 L
s
P
p
.2 1 0 r
.02 w
.37637 .39146 m
.25832 .3342 L
s
P
p
0 .4 1 r
.02 w
.39633 .38845 m
.27869 .331 L
s
P
p
0 .4 1 r
.02 w
.61824 .82962 m
.72694 .8728 L
s
P
p
.2 1 0 r
.02 w
.48283 .69451 m
.59594 .74187 L
s
P
p
.2 1 0 r
.02 w
.48452 .60734 m
.48283 .69451 L
s
P
p
0 .4 1 r
.02 w
.50506 .60461 m
.50389 .69186 L
s
P
p
0 .4 1 r
.02 w
.38836 .55268 m
.50506 .60461 L
s
P
p
.2 1 0 r
.02 w
.36738 .55557 m
.37199 .47146 L
s
P
p
.2 1 0 r
.02 w
.25832 .3342 m
.13289 .27337 L
s
P
p
0 .4 1 r
.02 w
.27869 .331 m
.15369 .26996 L
s
P
p
0 .4 1 r
.02 w
.50266 .7837 m
.61824 .82962 L
s
P
p
0 .4 1 r
.02 w
.50389 .69186 m
.50266 .7837 L
s
P
p
.2 1 0 r
.02 w
.24277 .50051 m
.36738 .55557 L
s
P
p
0 .4 1 r
.02 w
.38406 .64132 m
.38836 .55268 L
s
P
p
.2 1 0 r
.02 w
.25075 .4152 m
.24277 .50051 L
s
P
p
.2 1 0 r
.02 w
.12173 .35534 m
.25075 .4152 L
s
P
p
.2 1 0 r
.02 w
.13289 .27337 m
.12173 .35534 L
s
P
p
0 .4 1 r
.02 w
.15369 .26996 m
.14306 .35198 L
s
P
p
0 .4 1 r
.02 w
.25636 .58746 m
.38406 .64132 L
s
P
p
0 .4 1 r
.02 w
.2642 .49742 m
.25636 .58746 L
s
P
p
0 .4 1 r
.02 w
.13185 .43852 m
.2642 .49742 L
s
P
p
0 .4 1 r
.02 w
.14306 .35198 m
.13185 .43852 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.0169173 0.97619 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.494082 2.089 0.0245703 0.982813 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.88743 .49346 m
.85947 .47756 L
s
P
p
0 .4 1 r
.02 w
.88964 .51768 m
.88743 .49346 L
s
P
p
0 .4 1 r
.02 w
.89188 .54222 m
.88964 .51768 L
s
P
p
0 .4 1 r
.02 w
.85947 .47756 m
.83106 .46141 L
s
P
p
0 .4 1 r
.02 w
.82921 .43734 m
.83106 .46141 L
s
P
p
0 .4 1 r
.02 w
.80052 .42084 m
.82921 .43734 L
s
P
p
0 .4 1 r
.02 w
.86358 .5265 m
.89188 .54222 L
s
P
p
0 .4 1 r
.02 w
.83106 .46141 m
.83293 .4858 L
s
P
p
0 .4 1 r
.02 w
.83106 .46141 m
.80219 .445 L
s
P
p
0 .4 1 r
.02 w
.80052 .42084 m
.77137 .40409 L
s
P
p
0 .4 1 r
.02 w
.80219 .445 m
.80052 .42084 L
s
P
p
0 .4 1 r
.02 w
.86568 .55146 m
.86358 .5265 L
s
P
p
0 .4 1 r
.02 w
.83293 .4858 m
.80388 .46948 L
s
P
p
0 .4 1 r
.02 w
.80388 .46948 m
.80219 .445 L
s
P
p
0 .4 1 r
.02 w
.77137 .40409 m
.77286 .42832 L
s
P
p
0 .4 1 r
.02 w
.83674 .53558 m
.86568 .55146 L
s
P
p
0 .4 1 r
.02 w
.77286 .42832 m
.74305 .41138 L
s
P
p
0 .4 1 r
.02 w
.83869 .56097 m
.83674 .53558 L
s
P
p
0 .4 1 r
.02 w
.84067 .58672 m
.83869 .56097 L
s
P
p
0 .4 1 r
.02 w
.81088 .57078 m
.84067 .58672 L
s
P
p
0 .4 1 r
.02 w
.77744 .50304 m
.74705 .48636 L
s
P
p
0 .4 1 r
.02 w
.77901 .52863 m
.77744 .50304 L
s
P
p
0 .4 1 r
.02 w
.7806 .55458 m
.81088 .57078 L
s
P
p
0 .4 1 r
.02 w
.7806 .55458 m
.77901 .52863 L
s
P
p
0 .4 1 r
.02 w
.74705 .48636 m
.71615 .4694 L
s
P
p
0 .4 1 r
.02 w
.715 .44397 m
.71615 .4694 L
s
P
p
0 .4 1 r
.02 w
.68379 .42664 m
.715 .44397 L
s
P
p
0 .4 1 r
.02 w
.74981 .5381 m
.7806 .55458 L
s
P
p
0 .4 1 r
.02 w
.71615 .4694 m
.71732 .49519 L
s
P
p
0 .4 1 r
.02 w
.71615 .4694 m
.68473 .45216 L
s
P
p
0 .4 1 r
.02 w
.68379 .42664 m
.65205 .40901 L
s
P
p
0 .4 1 r
.02 w
.68473 .45216 m
.68379 .42664 L
s
P
p
0 .4 1 r
.02 w
.75122 .56452 m
.74981 .5381 L
s
P
p
0 .4 1 r
.02 w
.71732 .49519 m
.68569 .47804 L
s
P
p
0 .4 1 r
.02 w
.68569 .47804 m
.68473 .45216 L
s
P
p
0 .4 1 r
.02 w
.65205 .40901 m
.65278 .43462 L
s
P
p
0 .4 1 r
.02 w
.7197 .54787 m
.75122 .56452 L
s
P
p
0 .4 1 r
.02 w
.7185 .52134 m
.7197 .54787 L
s
P
p
0 .4 1 r
.02 w
.68665 .5043 m
.7185 .52134 L
s
P
p
0 .4 1 r
.02 w
.65278 .43462 m
.62027 .41678 L
s
P
p
0 .4 1 r
.02 w
.72092 .57478 m
.7197 .54787 L
s
P
p
0 .4 1 r
.02 w
.68763 .53093 m
.68665 .5043 L
s
P
p
0 .4 1 r
.02 w
.65351 .4606 m
.65425 .48696 L
s
P
p
0 .4 1 r
.02 w
.62077 .44286 m
.65351 .4606 L
s
P
p
0 .4 1 r
.02 w
.62027 .41678 m
.62077 .44286 L
s
P
p
0 .4 1 r
.02 w
.72215 .60207 m
.72092 .57478 L
s
P
p
0 .4 1 r
.02 w
.655 .5137 m
.68763 .53093 L
s
P
p
0 .4 1 r
.02 w
.65425 .48696 m
.655 .5137 L
s
P
p
0 .4 1 r
.02 w
.68963 .58536 m
.72215 .60207 L
s
P
p
0 .4 1 r
.02 w
.655 .5137 m
.6218 .49616 L
s
P
p
0 .4 1 r
.02 w
.65577 .54083 m
.655 .5137 L
s
P
p
0 .4 1 r
.02 w
.65654 .56836 m
.68963 .58536 L
s
P
p
0 .4 1 r
.02 w
.65654 .56836 m
.65577 .54083 L
s
P
p
0 .4 1 r
.02 w
.6218 .49616 m
.58801 .47832 L
s
P
p
0 .4 1 r
.02 w
.58774 .45137 m
.58801 .47832 L
s
P
p
0 .4 1 r
.02 w
.5536 .4331 m
.58774 .45137 L
s
P
p
0 .4 1 r
.02 w
.62286 .55105 m
.65654 .56836 L
s
P
p
0 .4 1 r
.02 w
.58801 .47832 m
.58829 .50567 L
s
P
p
0 .4 1 r
.02 w
.58801 .47832 m
.55362 .46015 L
s
P
p
0 .4 1 r
.02 w
.5536 .4331 m
.51884 .4145 L
s
P
p
0 .4 1 r
.02 w
.55362 .46015 m
.5536 .4331 L
s
P
p
0 .4 1 r
.02 w
.62341 .57911 m
.62286 .55105 L
s
P
p
0 .4 1 r
.02 w
.58829 .50567 m
.55365 .48761 L
s
P
p
0 .4 1 r
.02 w
.55365 .48761 m
.55362 .46015 L
s
P
p
0 .4 1 r
.02 w
.51884 .4145 m
.51861 .44166 L
s
P
p
0 .4 1 r
.02 w
.58887 .56161 m
.62341 .57911 L
s
P
p
0 .4 1 r
.02 w
.58858 .53343 m
.58887 .56161 L
s
P
p
0 .4 1 r
.02 w
.55367 .51549 m
.58858 .53343 L
s
P
p
0 .4 1 r
.02 w
.51861 .44166 m
.48296 .42283 L
s
P
p
0 .4 1 r
.02 w
.58916 .59022 m
.58887 .56161 L
s
P
p
0 .4 1 r
.02 w
.55369 .54379 m
.55367 .51549 L
s
P
p
0 .4 1 r
.02 w
.51837 .46923 m
.51812 .49722 L
s
P
p
0 .4 1 r
.02 w
.48244 .45051 m
.51837 .46923 L
s
P
p
0 .4 1 r
.02 w
.48296 .42283 m
.48244 .45051 L
s
P
p
0 .4 1 r
.02 w
.58946 .61926 m
.58916 .59022 L
s
P
p
0 .4 1 r
.02 w
.51787 .52564 m
.55369 .54379 L
s
P
p
0 .4 1 r
.02 w
.51812 .49722 m
.51787 .52564 L
s
P
p
0 .4 1 r
.02 w
.55375 .6017 m
.58946 .61926 L
s
P
p
0 .4 1 r
.02 w
.51787 .52564 m
.48139 .50715 L
s
P
p
0 .4 1 r
.02 w
.51762 .5545 m
.51787 .52564 L
s
P
p
0 .4 1 r
.02 w
.51737 .58381 m
.55375 .6017 L
s
P
p
0 .4 1 r
.02 w
.51737 .58381 m
.51762 .5545 L
s
P
p
0 .4 1 r
.02 w
.48139 .50715 m
.44421 .48832 L
s
P
p
0 .4 1 r
.02 w
.44504 .45966 m
.44421 .48832 L
s
P
p
0 .4 1 r
.02 w
.40746 .44035 m
.44504 .45966 L
s
P
p
0 .4 1 r
.02 w
.4803 .56559 m
.51737 .58381 L
s
P
p
0 .4 1 r
.02 w
.44421 .48832 m
.44337 .51743 L
s
P
p
0 .4 1 r
.02 w
.44421 .48832 m
.40633 .46913 L
s
P
p
0 .4 1 r
.02 w
.40746 .44035 m
.36917 .42067 L
s
P
p
0 .4 1 r
.02 w
.40633 .46913 m
.40746 .44035 L
s
P
p
0 .4 1 r
.02 w
.47974 .5955 m
.4803 .56559 L
s
P
p
0 .4 1 r
.02 w
.44337 .51743 m
.40518 .49837 L
s
P
p
0 .4 1 r
.02 w
.40518 .49837 m
.40633 .46913 L
s
P
p
0 .4 1 r
.02 w
.36917 .42067 m
.36772 .44957 L
s
P
p
0 .4 1 r
.02 w
.44165 .57706 m
.47974 .5955 L
s
P
p
0 .4 1 r
.02 w
.44252 .54701 m
.44165 .57706 L
s
P
p
0 .4 1 r
.02 w
.40401 .52808 m
.44252 .54701 L
s
P
p
0 .4 1 r
.02 w
.36772 .44957 m
.32837 .42963 L
s
P
p
0 .4 1 r
.02 w
.44077 .6076 m
.44165 .57706 L
s
P
p
0 .4 1 r
.02 w
.40283 .55827 m
.40401 .52808 L
s
P
p
0 .4 1 r
.02 w
.36625 .47893 m
.36476 .50877 L
s
P
p
0 .4 1 r
.02 w
.32657 .45912 m
.36625 .47893 L
s
P
p
0 .4 1 r
.02 w
.32837 .42963 m
.32657 .45912 L
s
P
p
0 .4 1 r
.02 w
.43988 .63864 m
.44077 .6076 L
s
P
p
0 .4 1 r
.02 w
.36324 .5391 m
.40283 .55827 L
s
P
p
0 .4 1 r
.02 w
.36476 .50877 m
.36324 .5391 L
s
P
p
0 .4 1 r
.02 w
.4004 .62014 m
.43988 .63864 L
s
P
p
0 .4 1 r
.02 w
.36013 .60128 m
.4004 .62014 L
s
P
p
.2 1 0 r
.02 w
.3547 .57098 m
.31393 .5516 L
s
P
p
.2 1 0 r
.02 w
.35307 .60231 m
.3547 .57098 L
s
P
p
.2 1 0 r
.02 w
.31588 .52063 m
.27465 .50071 L
s
P
p
.2 1 0 r
.02 w
.31393 .5516 m
.31588 .52063 L
s
P
p
.2 1 0 r
.02 w
.31194 .58309 m
.35307 .60231 L
s
P
p
0 .4 1 r
.02 w
.31904 .58203 m
.36013 .60128 L
s
P
p
.2 1 0 r
.02 w
.27465 .50071 m
.27233 .53183 L
s
P
p
.2 1 0 r
.02 w
.23524 .44966 m
.19271 .42879 L
s
P
p
.2 1 0 r
.02 w
.23259 .4804 m
.23524 .44966 L
s
P
p
.2 1 0 r
.02 w
.26997 .56347 m
.31194 .58309 L
s
P
p
0 .4 1 r
.02 w
.31708 .61406 m
.31904 .58203 L
s
P
p
.2 1 0 r
.02 w
.27233 .53183 m
.22989 .51166 L
s
P
p
.2 1 0 r
.02 w
.22989 .51166 m
.23259 .4804 L
s
P
p
.2 1 0 r
.02 w
.19271 .42879 m
.18966 .45967 L
s
P
p
.2 1 0 r
.02 w
.30992 .61511 m
.26757 .59565 L
s
P
p
.2 1 0 r
.02 w
.30787 .64768 m
.30992 .61511 L
s
P
p
0 .4 1 r
.02 w
.27478 .59459 m
.31708 .61406 L
s
P
p
.2 1 0 r
.02 w
.26757 .59565 m
.26997 .56347 L
s
P
p
0 .4 1 r
.02 w
.27712 .5624 m
.27478 .59459 L
s
P
p
0 .4 1 r
.02 w
.23434 .54235 m
.27712 .5624 L
s
P
p
.2 1 0 r
.02 w
.18966 .45967 m
.14586 .43851 L
s
P
p
.2 1 0 r
.02 w
.26513 .62839 m
.30787 .64768 L
s
P
p
0 .4 1 r
.02 w
.2316 .5747 m
.23434 .54235 L
s
P
p
.2 1 0 r
.02 w
.18657 .49107 m
.18342 .52301 L
s
P
p
.2 1 0 r
.02 w
.14235 .47005 m
.18657 .49107 L
s
P
p
0 .4 1 r
.02 w
.19376 .48994 m
.19067 .52189 L
s
P
p
0 .4 1 r
.02 w
.14958 .4689 m
.19376 .48994 L
s
P
p
.01 w
.14586 .43851 Mdot
P
p
.2 1 0 r
.02 w
.14586 .43851 m
.14235 .47005 L
s
P
p
.01 w
.15303 .43735 Mdot
P
p
0 .4 1 r
.02 w
.15303 .43735 m
.14958 .4689 L
s
P
p
.2 1 0 r
.02 w
.26265 .6617 m
.26513 .62839 L
s
P
p
.2 1 0 r
.02 w
.22434 .57579 m
.2215 .6087 L
s
P
p
.2 1 0 r
.02 w
.18021 .55552 m
.22434 .57579 L
s
P
p
0 .4 1 r
.02 w
.18752 .55441 m
.2316 .5747 L
s
P
p
.2 1 0 r
.02 w
.18342 .52301 m
.13878 .50215 L
s
P
p
0 .4 1 r
.02 w
.19067 .52189 m
.18752 .55441 L
s
P
p
.2 1 0 r
.02 w
.21861 .64219 m
.26265 .6617 L
s
P
p
.2 1 0 r
.02 w
.2215 .6087 m
.21861 .64219 L
s
P
p
.2 1 0 r
.02 w
.17695 .58859 m
.18021 .55552 L
s
P
p
.2 1 0 r
.02 w
.13878 .50215 m
.09319 .48084 L
s
P
p
.2 1 0 r
.02 w
.13144 .56806 m
.17695 .58859 L
s
P
p
.2 1 0 r
.02 w
.13514 .53481 m
.13144 .56806 L
s
P
p
.2 1 0 r
.02 w
.08911 .51366 m
.13514 .53481 L
s
P
p
.2 1 0 r
.02 w
.09319 .48084 m
.08911 .51366 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.154762 0.149123 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.154762 0.286967 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.8811 .50206 m
.78086 .44927 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.8811 .50206 L
s
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.31889 .12085 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.44385 .18936 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.31889 .12085 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.81335 .90655 m
.80614 .80506 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68855 .7548 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.81335 .90655 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43123 .54175 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.139 .40899 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.12548 .51415 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.12548 .51415 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.154762 0.424812 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.7867 .53145 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.89777 .66825 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56304 .80672 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.15169 .31032 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.139 .40899 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.154762 0.562657 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.79284 .61791 L
s
P
p
0 .4 1 r
.02 w
.90676 .7578 m
.89777 .66825 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.91622 .85211 m
.90676 .7578 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.91622 .85211 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68855 .7548 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.154762 0.700501 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.154762 0.838346 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.154762 0.97619 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.8811 .50206 m
.78086 .44927 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.8811 .50206 L
s
P
p
0 .4 1 r
.02 w
.7753 .37106 m
.67141 .31411 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.7753 .37106 L
s
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.88923 .58311 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.67141 .31411 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.90676 .7578 m
.89777 .66825 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.7867 .53145 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.90676 .7578 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68855 .7548 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.43465 .44607 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.42759 .64327 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.292607 0.149123 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.308424 1.71627 0.0252773 1.01109 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.91024 .71077 m
.85823 .67661 L
s
P
p
.2 1 0 r
.02 w
.91443 .76965 m
.91024 .71077 L
s
P
p
.2 1 0 r
.02 w
.85467 .61866 m
.80176 .58313 L
s
P
p
.2 1 0 r
.02 w
.85823 .67661 m
.85467 .61866 L
s
P
p
.2 1 0 r
.02 w
.86187 .73592 m
.91443 .76965 L
s
P
p
.2 1 0 r
.02 w
.80176 .58313 m
.80474 .64148 L
s
P
p
.2 1 0 r
.02 w
.74504 .48922 m
.68968 .45125 L
s
P
p
.2 1 0 r
.02 w
.74735 .54659 m
.74504 .48922 L
s
P
p
.2 1 0 r
.02 w
.8078 .70123 m
.86187 .73592 L
s
P
p
.2 1 0 r
.02 w
.80474 .64148 m
.74972 .60534 L
s
P
p
.2 1 0 r
.02 w
.74972 .60534 m
.74735 .54659 L
s
P
p
.2 1 0 r
.02 w
.68968 .45125 m
.69137 .509 L
s
P
p
.2 1 0 r
.02 w
.86559 .79665 m
.81092 .76242 L
s
P
p
.2 1 0 r
.02 w
.86941 .85885 m
.86559 .79665 L
s
P
p
.2 1 0 r
.02 w
.81092 .76242 m
.8078 .70123 L
s
P
p
.2 1 0 r
.02 w
.69137 .509 m
.63374 .4703 L
s
P
p
0 .4 1 r
.02 w
.64369 .41004 m
.58518 .36977 L
s
P
p
0 .4 1 r
.02 w
.64484 .46817 m
.64369 .41004 L
s
P
p
.2 1 0 r
.02 w
.81412 .82511 m
.86941 .85885 L
s
P
p
.2 1 0 r
.02 w
.69309 .56815 m
.69486 .62876 L
s
P
p
.2 1 0 r
.02 w
.63478 .52985 m
.69309 .56815 L
s
P
p
0 .4 1 r
.02 w
.70421 .5661 m
.64602 .52775 L
s
P
p
.01 w
.63374 .4703 Mdot
P
p
.2 1 0 r
.02 w
.63374 .4703 m
.63478 .52985 L
s
P
p
.01 w
.64484 .46817 Mdot
P
p
0 .4 1 r
.02 w
.64602 .52775 m
.64484 .46817 L
s
P
p
0 .4 1 r
.02 w
.58518 .36977 m
.58562 .42827 L
s
P
p
.2 1 0 r
.02 w
.8174 .88936 m
.81412 .82511 L
s
P
p
.2 1 0 r
.02 w
.75464 .72718 m
.75719 .79037 L
s
P
p
.2 1 0 r
.02 w
.69667 .69088 m
.75464 .72718 L
s
P
p
.2 1 0 r
.02 w
.69486 .62876 m
.63584 .59089 L
s
P
p
0 .4 1 r
.02 w
.58562 .42827 m
.52462 .38715 L
s
P
p
.2 1 0 r
.02 w
.7598 .85515 m
.8174 .88936 L
s
P
p
0 .4 1 r
.02 w
.52493 .32829 m
.46285 .28556 L
s
P
p
0 .4 1 r
.02 w
.52462 .38715 m
.52493 .32829 L
s
P
p
.2 1 0 r
.02 w
.75719 .79037 m
.7598 .85515 L
s
P
p
.2 1 0 r
.02 w
.69852 .75457 m
.69667 .69088 L
s
P
p
.2 1 0 r
.02 w
.63584 .59089 m
.57504 .55187 L
s
P
p
0 .4 1 r
.02 w
.58607 .48823 m
.5243 .44751 L
s
P
p
0 .4 1 r
.02 w
.5243 .44751 m
.52462 .38715 L
s
P
p
0 .4 1 r
.02 w
.46285 .28556 m
.46174 .34478 L
s
P
p
.2 1 0 r
.02 w
.63805 .71767 m
.69852 .75457 L
s
P
p
.2 1 0 r
.02 w
.63694 .65348 m
.63805 .71767 L
s
P
p
.2 1 0 r
.02 w
.57536 .61492 m
.63694 .65348 L
s
P
p
.2 1 0 r
.02 w
.57504 .55187 m
.57536 .61492 L
s
P
p
0 .4 1 r
.02 w
.46174 .34478 m
.39691 .30109 L
s
P
p
0 .4 1 r
.02 w
.39887 .24152 m
.33289 .19611 L
s
P
p
0 .4 1 r
.02 w
.39691 .30109 m
.39887 .24152 L
s
P
p
0 .4 1 r
.02 w
.4606 .40553 m
.3949 .36222 L
s
P
p
0 .4 1 r
.02 w
.3949 .36222 m
.39691 .30109 L
s
P
p
0 .4 1 r
.02 w
.33289 .19611 m
.33003 .25602 L
s
P
p
0 .4 1 r
.02 w
.33003 .25602 m
.261 .2095 L
s
P
p
0 .4 1 r
.02 w
.26481 .14925 m
.19455 .10089 L
s
P
p
0 .4 1 r
.02 w
.261 .2095 m
.26481 .14925 L
s
P
p
0 .4 1 r
.02 w
.3271 .31753 m
.25708 .27138 L
s
P
p
0 .4 1 r
.02 w
.25708 .27138 m
.261 .2095 L
s
P
p
0 .4 1 r
.02 w
.19455 .10089 m
.18972 .16146 L
s
P
p
0 .4 1 r
.02 w
.18972 .16146 m
.11607 .11182 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.292607 0.286967 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.559341 2.21998 0.0242236 0.968945 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.88673 .5597 m
.79942 .51531 L
s
P
p
0 .4 1 r
.02 w
.89392 .63143 m
.88673 .5597 L
s
P
p
0 .4 1 r
.02 w
.80489 .58796 m
.89392 .63143 L
s
P
p
0 .4 1 r
.02 w
.79942 .51531 m
.7075 .46857 L
s
P
p
0 .4 1 r
.02 w
.70412 .39819 m
.60925 .34813 L
s
P
p
0 .4 1 r
.02 w
.7075 .46857 m
.70412 .39819 L
s
P
p
.2 1 0 r
.02 w
.78644 .59037 m
.69223 .54467 L
s
P
p
.2 1 0 r
.02 w
.79173 .66622 m
.78644 .59037 L
s
P
p
0 .4 1 r
.02 w
.71104 .54213 m
.80489 .58796 L
s
P
p
.2 1 0 r
.02 w
.68912 .47117 m
.59184 .42203 L
s
P
p
.2 1 0 r
.02 w
.69223 .54467 m
.68912 .47117 L
s
P
p
0 .4 1 r
.02 w
.60925 .34813 m
.61058 .41929 L
s
P
p
0 .4 1 r
.02 w
.51013 .22662 m
.40691 .17026 L
s
P
p
0 .4 1 r
.02 w
.50921 .29534 m
.51013 .22662 L
s
P
p
.2 1 0 r
.02 w
.6955 .62156 m
.79173 .66622 L
s
P
p
0 .4 1 r
.02 w
.81059 .66386 m
.71474 .61907 L
s
P
p
0 .4 1 r
.02 w
.81656 .74325 m
.81059 .66386 L
s
P
p
0 .4 1 r
.02 w
.71474 .61907 m
.71104 .54213 L
s
P
p
.2 1 0 r
.02 w
.59184 .42203 m
.59279 .49644 L
s
P
p
0 .4 1 r
.02 w
.61058 .41929 m
.50824 .36726 L
s
P
p
.2 1 0 r
.02 w
.49053 .29827 m
.38451 .24268 L
s
P
p
.2 1 0 r
.02 w
.48913 .37015 m
.49053 .29827 L
s
P
p
0 .4 1 r
.02 w
.50824 .36726 m
.50921 .29534 L
s
P
p
0 .4 1 r
.02 w
.40691 .17026 m
.40355 .23958 L
s
P
p
0 .4 1 r
.02 w
.71861 .69966 m
.81656 .74325 L
s
P
p
.2 1 0 r
.02 w
.59379 .57437 m
.6955 .62156 L
s
P
p
.2 1 0 r
.02 w
.59279 .49644 m
.48767 .44545 L
s
P
p
.2 1 0 r
.02 w
.48767 .44545 m
.48913 .37015 L
s
P
p
.2 1 0 r
.02 w
.38451 .24268 m
.38053 .31529 L
s
P
p
0 .4 1 r
.02 w
.40355 .23958 m
.40002 .31223 L
s
P
p
.2 1 0 r
.02 w
.69891 .70208 m
.59484 .65609 L
s
P
p
.2 1 0 r
.02 w
.70249 .78649 m
.69891 .70208 L
s
P
p
0 .4 1 r
.02 w
.72268 .78413 m
.71861 .69966 L
s
P
p
.2 1 0 r
.02 w
.59484 .65609 m
.59379 .57437 L
s
P
p
.2 1 0 r
.02 w
.38053 .31529 m
.26551 .25719 L
s
P
p
0 .4 1 r
.02 w
.40002 .31223 m
.2854 .25395 L
s
P
p
.2 1 0 r
.02 w
.59594 .74187 m
.70249 .78649 L
s
P
p
0 .4 1 r
.02 w
.72694 .8728 m
.72268 .78413 L
s
P
p
0 .4 1 r
.02 w
.61495 .65352 m
.61655 .73938 L
s
P
p
0 .4 1 r
.02 w
.50506 .60461 m
.61495 .65352 L
s
P
p
.2 1 0 r
.02 w
.37637 .39146 m
.37199 .47146 L
s
P
p
.2 1 0 r
.02 w
.25832 .3342 m
.37637 .39146 L
s
P
p
0 .4 1 r
.02 w
.39633 .38845 m
.39244 .4685 L
s
P
p
0 .4 1 r
.02 w
.27869 .331 m
.39633 .38845 L
s
P
p
.01 w
.26551 .25719 Mdot
P
p
.2 1 0 r
.02 w
.26551 .25719 m
.25832 .3342 L
s
P
p
.01 w
.2854 .25395 Mdot
P
p
0 .4 1 r
.02 w
.2854 .25395 m
.27869 .331 L
s
P
p
0 .4 1 r
.02 w
.61824 .82962 m
.72694 .8728 L
s
P
p
.2 1 0 r
.02 w
.59709 .83202 m
.59594 .74187 L
s
P
p
0 .4 1 r
.02 w
.61655 .73938 m
.61824 .82962 L
s
P
p
.2 1 0 r
.02 w
.48452 .60734 m
.48283 .69451 L
s
P
p
.2 1 0 r
.02 w
.36738 .55557 m
.48452 .60734 L
s
P
p
0 .4 1 r
.02 w
.50389 .69186 m
.50506 .60461 L
s
P
p
.2 1 0 r
.02 w
.37199 .47146 m
.25075 .4152 L
s
P
p
0 .4 1 r
.02 w
.39244 .4685 m
.27163 .41205 L
s
P
p
.2 1 0 r
.02 w
.48104 .78626 m
.59709 .83202 L
s
P
p
.2 1 0 r
.02 w
.48283 .69451 m
.48104 .78626 L
s
P
p
0 .4 1 r
.02 w
.38406 .64132 m
.50389 .69186 L
s
P
p
.2 1 0 r
.02 w
.36254 .64414 m
.36738 .55557 L
s
P
p
0 .4 1 r
.02 w
.38836 .55268 m
.38406 .64132 L
s
P
p
0 .4 1 r
.02 w
.2642 .49742 m
.38836 .55268 L
s
P
p
.2 1 0 r
.02 w
.25075 .4152 m
.12173 .35534 L
s
P
p
0 .4 1 r
.02 w
.27163 .41205 m
.14306 .35198 L
s
P
p
.2 1 0 r
.02 w
.23436 .59047 m
.36254 .64414 L
s
P
p
.2 1 0 r
.02 w
.24277 .50051 m
.23436 .59047 L
s
P
p
.2 1 0 r
.02 w
.10995 .44181 m
.24277 .50051 L
s
P
p
0 .4 1 r
.02 w
.13185 .43852 m
.2642 .49742 L
s
P
p
.2 1 0 r
.02 w
.12173 .35534 m
.10995 .44181 L
s
P
p
0 .4 1 r
.02 w
.14306 .35198 m
.13185 .43852 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.292607 0.424812 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.292607 0.562657 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.605781 2.3072 0.0240806 0.963223 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.86855 .46507 m
.83313 .44713 L
s
P
p
.2 1 0 r
.02 w
.87112 .49193 m
.86855 .46507 L
s
P
p
.2 1 0 r
.02 w
.83085 .42059 m
.79501 .40219 L
s
P
p
.2 1 0 r
.02 w
.83313 .44713 m
.83085 .42059 L
s
P
p
.2 1 0 r
.02 w
.83544 .47411 m
.87112 .49193 L
s
P
p
.2 1 0 r
.02 w
.79501 .40219 m
.79702 .42884 L
s
P
p
.2 1 0 r
.02 w
.75677 .3571 m
.7198 .33787 L
s
P
p
.2 1 0 r
.02 w
.75847 .38343 m
.75677 .3571 L
s
P
p
.2 1 0 r
.02 w
.79906 .45594 m
.83544 .47411 L
s
P
p
.2 1 0 r
.02 w
.79702 .42884 m
.7602 .4102 L
s
P
p
.2 1 0 r
.02 w
.7602 .4102 m
.75847 .38343 L
s
P
p
.2 1 0 r
.02 w
.7198 .33787 m
.72121 .3643 L
s
P
p
.2 1 0 r
.02 w
.8378 .50153 m
.80114 .48348 L
s
P
p
.2 1 0 r
.02 w
.84019 .5294 m
.8378 .50153 L
s
P
p
.2 1 0 r
.02 w
.80114 .48348 m
.79906 .45594 L
s
P
p
.2 1 0 r
.02 w
.72121 .3643 m
.68321 .3448 L
s
P
p
.2 1 0 r
.02 w
.80325 .51148 m
.84019 .5294 L
s
P
p
.2 1 0 r
.02 w
.72265 .39118 m
.72411 .4185 L
s
P
p
.2 1 0 r
.02 w
.68434 .37178 m
.72265 .39118 L
s
P
p
0 .4 1 r
.02 w
.73007 .39014 m
.73159 .41746 L
s
P
p
0 .4 1 r
.02 w
.69182 .37071 m
.73007 .39014 L
s
P
p
.01 w
.68321 .3448 Mdot
P
p
.2 1 0 r
.02 w
.68321 .3448 m
.68434 .37178 L
s
P
p
.01 w
.69062 .34373 Mdot
P
p
0 .4 1 r
.02 w
.69062 .34373 m
.69182 .37071 L
s
P
p
.2 1 0 r
.02 w
.8054 .53995 m
.80325 .51148 L
s
P
p
.2 1 0 r
.02 w
.76375 .46507 m
.76556 .4932 L
s
P
p
.2 1 0 r
.02 w
.7256 .44628 m
.76375 .46507 L
s
P
p
.2 1 0 r
.02 w
.72411 .4185 m
.68549 .39921 L
s
P
p
0 .4 1 r
.02 w
.73159 .41746 m
.69303 .39816 L
s
P
p
.2 1 0 r
.02 w
.76741 .5218 m
.8054 .53995 L
s
P
p
.2 1 0 r
.02 w
.76556 .4932 m
.76741 .5218 L
s
P
p
.2 1 0 r
.02 w
.72711 .47454 m
.7256 .44628 L
s
P
p
.2 1 0 r
.02 w
.68549 .39921 m
.64609 .37953 L
s
P
p
0 .4 1 r
.02 w
.69303 .39816 m
.65368 .37845 L
s
P
p
.2 1 0 r
.02 w
.68786 .4555 m
.72711 .47454 L
s
P
p
.2 1 0 r
.02 w
.68667 .42711 m
.68786 .4555 L
s
P
p
.2 1 0 r
.02 w
.64693 .40755 m
.68667 .42711 L
s
P
p
0 .4 1 r
.02 w
.69427 .42606 m
.69553 .45445 L
s
P
p
0 .4 1 r
.02 w
.65459 .40648 m
.69427 .42606 L
s
P
p
.2 1 0 r
.02 w
.64609 .37953 m
.64693 .40755 L
s
P
p
0 .4 1 r
.02 w
.65368 .37845 m
.65459 .40648 L
s
P
p
0 .4 1 r
.02 w
.69553 .45445 m
.69681 .48333 L
s
P
p
0 .4 1 r
.02 w
.65459 .40648 m
.61409 .38648 L
s
P
p
0 .4 1 r
.02 w
.65552 .43499 m
.65459 .40648 L
s
P
p
0 .4 1 r
.02 w
.69681 .48333 m
.65646 .46401 L
s
P
p
0 .4 1 r
.02 w
.65646 .46401 m
.65552 .43499 L
s
P
p
0 .4 1 r
.02 w
.61409 .38648 m
.61467 .41512 L
s
P
p
0 .4 1 r
.02 w
.61467 .41512 m
.57295 .39483 L
s
P
p
0 .4 1 r
.02 w
.61526 .44427 m
.61586 .47394 L
s
P
p
0 .4 1 r
.02 w
.57318 .42411 m
.61526 .44427 L
s
P
p
0 .4 1 r
.02 w
.57295 .39483 m
.57318 .42411 L
s
P
p
0 .4 1 r
.02 w
.61586 .47394 m
.5734 .45391 L
s
P
p
0 .4 1 r
.02 w
.5734 .45391 m
.53001 .43345 L
s
P
p
0 .4 1 r
.02 w
.57364 .48426 m
.57387 .51517 L
s
P
p
0 .4 1 r
.02 w
.52985 .46395 m
.57364 .48426 L
s
P
p
0 .4 1 r
.02 w
.53001 .43345 m
.52985 .46395 L
s
P
p
0 .4 1 r
.02 w
.57387 .51517 m
.57412 .54665 L
s
P
p
0 .4 1 r
.02 w
.52985 .46395 m
.48508 .44318 L
s
P
p
0 .4 1 r
.02 w
.52968 .49501 m
.52985 .46395 L
s
P
p
0 .4 1 r
.02 w
.57412 .54665 m
.52951 .52666 L
s
P
p
0 .4 1 r
.02 w
.52951 .52666 m
.52968 .49501 L
s
P
p
0 .4 1 r
.02 w
.48508 .44318 m
.48449 .4744 L
s
P
p
0 .4 1 r
.02 w
.48449 .4744 m
.43827 .45331 L
s
P
p
0 .4 1 r
.02 w
.48389 .50621 m
.48328 .53863 L
s
P
p
0 .4 1 r
.02 w
.43722 .48529 m
.48389 .50621 L
s
P
p
0 .4 1 r
.02 w
.43827 .45331 m
.43722 .48529 L
s
P
p
0 .4 1 r
.02 w
.48328 .53863 m
.43615 .51788 L
s
P
p
0 .4 1 r
.02 w
.43615 .51788 m
.38791 .49665 L
s
P
p
0 .4 1 r
.02 w
.43506 .55112 m
.43394 .58501 L
s
P
p
0 .4 1 r
.02 w
.38633 .53007 m
.43506 .55112 L
s
P
p
0 .4 1 r
.02 w
.38791 .49665 m
.38633 .53007 L
s
P
p
0 .4 1 r
.02 w
.43394 .58501 m
.43281 .61957 L
s
P
p
0 .4 1 r
.02 w
.38633 .53007 m
.33642 .50851 L
s
P
p
0 .4 1 r
.02 w
.38471 .56416 m
.38633 .53007 L
s
P
p
0 .4 1 r
.02 w
.43281 .61957 m
.38306 .59893 L
s
P
p
0 .4 1 r
.02 w
.38306 .59893 m
.38471 .56416 L
s
P
p
0 .4 1 r
.02 w
.33642 .50851 m
.33428 .5428 L
s
P
p
0 .4 1 r
.02 w
.33428 .5428 m
.28262 .52091 L
s
P
p
0 .4 1 r
.02 w
.3321 .57778 m
.32987 .61349 L
s
P
p
0 .4 1 r
.02 w
.27987 .5561 m
.3321 .57778 L
s
P
p
0 .4 1 r
.02 w
.28262 .52091 m
.27987 .5561 L
s
P
p
0 .4 1 r
.02 w
.32987 .61349 m
.27707 .59203 L
s
P
p
0 .4 1 r
.02 w
.27707 .59203 m
.22292 .57003 L
s
P
p
0 .4 1 r
.02 w
.2742 .62872 m
.27128 .66619 L
s
P
p
0 .4 1 r
.02 w
.21944 .60695 m
.2742 .62872 L
s
P
p
0 .4 1 r
.02 w
.22292 .57003 m
.21944 .60695 L
s
P
p
0 .4 1 r
.02 w
.27128 .66619 m
.26829 .70447 L
s
P
p
0 .4 1 r
.02 w
.21944 .60695 m
.16325 .58462 L
s
P
p
0 .4 1 r
.02 w
.21588 .64468 m
.21944 .60695 L
s
P
p
0 .4 1 r
.02 w
.26829 .70447 m
.21225 .68323 L
s
P
p
0 .4 1 r
.02 w
.21225 .68323 m
.21588 .64468 L
s
P
p
0 .4 1 r
.02 w
.16325 .58462 m
.15903 .6226 L
s
P
p
0 .4 1 r
.02 w
.15903 .6226 m
.10066 .59993 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.292607 0.700501 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.292607 0.838346 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.649333 2.38458 0.0238845 0.955379 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.77289 .40994 m
.66614 .35823 L
s
P
p
0 .4 1 r
.02 w
.7779 .48414 m
.77289 .40994 L
s
P
p
.2 1 0 r
.02 w
.86758 .61144 m
.76162 .56426 L
s
P
p
.2 1 0 r
.02 w
.87476 .6913 m
.86758 .61144 L
s
P
p
.2 1 0 r
.02 w
.75686 .48682 m
.64746 .43609 L
s
P
p
.2 1 0 r
.02 w
.76162 .56426 m
.75686 .48682 L
s
P
p
0 .4 1 r
.02 w
.6689 .43326 m
.7779 .48414 L
s
P
p
0 .4 1 r
.02 w
.66614 .35823 m
.6689 .43326 L
s
P
p
0 .4 1 r
.02 w
.66614 .35823 m
.55365 .30374 L
s
P
p
0 .4 1 r
.02 w
.55341 .23122 m
.43735 .17304 L
s
P
p
0 .4 1 r
.02 w
.55365 .30374 m
.55341 .23122 L
s
P
p
.2 1 0 r
.02 w
.76658 .64523 m
.87476 .6913 L
s
P
p
.2 1 0 r
.02 w
.64746 .43609 m
.64984 .5145 L
s
P
p
0 .4 1 r
.02 w
.6689 .43326 m
.55389 .37958 L
s
P
p
0 .4 1 r
.02 w
.67178 .51172 m
.6689 .43326 L
s
P
p
.2 1 0 r
.02 w
.53228 .30676 m
.41314 .24942 L
s
P
p
.2 1 0 r
.02 w
.53203 .38257 m
.53228 .30676 L
s
P
p
0 .4 1 r
.02 w
.55365 .30374 m
.43492 .24623 L
s
P
p
0 .4 1 r
.02 w
.55389 .37958 m
.55365 .30374 L
s
P
p
0 .4 1 r
.02 w
.43735 .17304 m
.43492 .24623 L
s
P
p
.2 1 0 r
.02 w
.65234 .59657 m
.76658 .64523 L
s
P
p
.2 1 0 r
.02 w
.64984 .5145 m
.53178 .46193 L
s
P
p
0 .4 1 r
.02 w
.67178 .51172 m
.55415 .459 L
s
P
p
0 .4 1 r
.02 w
.67479 .59386 m
.67178 .51172 L
s
P
p
.2 1 0 r
.02 w
.53178 .46193 m
.53203 .38257 L
s
P
p
0 .4 1 r
.02 w
.55415 .459 m
.55389 .37958 L
s
P
p
0 .4 1 r
.02 w
.55389 .37958 m
.43237 .32286 L
s
P
p
.2 1 0 r
.02 w
.41314 .24942 m
.41008 .32602 L
s
P
p
0 .4 1 r
.02 w
.43492 .24623 m
.43237 .32286 L
s
P
p
.2 1 0 r
.02 w
.77178 .72996 m
.65496 .68257 L
s
P
p
.2 1 0 r
.02 w
.77723 .81872 m
.77178 .72996 L
s
P
p
.2 1 0 r
.02 w
.65496 .68257 m
.65234 .59657 L
s
P
p
0 .4 1 r
.02 w
.55442 .54223 m
.67479 .59386 L
s
P
p
0 .4 1 r
.02 w
.55415 .459 m
.55442 .54223 L
s
P
p
0 .4 1 r
.02 w
.42969 .40321 m
.55415 .459 L
s
P
p
.2 1 0 r
.02 w
.41008 .32602 m
.28102 .26618 L
s
P
p
0 .4 1 r
.02 w
.43237 .32286 m
.30375 .26284 L
s
P
p
0 .4 1 r
.02 w
.43237 .32286 m
.42969 .40321 L
s
P
p
.2 1 0 r
.02 w
.6577 .77278 m
.77723 .81872 L
s
P
p
.2 1 0 r
.02 w
.40687 .40632 m
.4035 .49059 L
s
P
p
.2 1 0 r
.02 w
.27451 .34738 m
.40687 .40632 L
s
P
p
0 .4 1 r
.02 w
.2978 .34409 m
.42969 .40321 L
s
P
p
.01 w
.28102 .26618 Mdot
P
p
.2 1 0 r
.02 w
.28102 .26618 m
.27451 .34738 L
s
P
p
.01 w
.30375 .26284 Mdot
P
p
0 .4 1 r
.02 w
.30375 .26284 m
.2978 .34409 L
s
P
p
.2 1 0 r
.02 w
.66058 .86753 m
.6577 .77278 L
s
P
p
.2 1 0 r
.02 w
.53123 .63238 m
.53093 .72406 L
s
P
p
.2 1 0 r
.02 w
.39996 .57913 m
.53123 .63238 L
s
P
p
.2 1 0 r
.02 w
.4035 .49059 m
.26766 .43273 L
s
P
p
.2 1 0 r
.02 w
.53062 .82049 m
.66058 .86753 L
s
P
p
.2 1 0 r
.02 w
.53093 .72406 m
.53062 .82049 L
s
P
p
.2 1 0 r
.02 w
.39624 .67229 m
.39996 .57913 L
s
P
p
.2 1 0 r
.02 w
.26766 .43273 m
.12324 .37122 L
s
P
p
.2 1 0 r
.02 w
.25286 .61718 m
.39624 .67229 L
s
P
p
.2 1 0 r
.02 w
.26046 .52254 m
.25286 .61718 L
s
P
p
.2 1 0 r
.02 w
.1119 .46228 m
.26046 .52254 L
s
P
p
.2 1 0 r
.02 w
.12324 .37122 m
.1119 .46228 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.292607 0.97619 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.451366 2.00297 0.0247151 0.988603 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.90323 .63152 m
.82303 .58655 L
s
P
p
0 .4 1 r
.02 w
.90991 .70714 m
.90323 .63152 L
s
P
p
0 .4 1 r
.02 w
.81794 .51289 m
.73548 .46504 L
s
P
p
0 .4 1 r
.02 w
.82303 .58655 m
.81794 .51289 L
s
P
p
0 .4 1 r
.02 w
.82831 .66306 m
.90991 .70714 L
s
P
p
.2 1 0 r
.02 w
.80642 .58904 m
.72219 .54209 L
s
P
p
.2 1 0 r
.02 w
.81137 .6655 m
.80642 .58904 L
s
P
p
.2 1 0 r
.02 w
.71891 .46769 m
.63231 .41772 L
s
P
p
.2 1 0 r
.02 w
.72219 .54209 m
.71891 .46769 L
s
P
p
0 .4 1 r
.02 w
.73548 .46504 m
.73908 .53949 L
s
P
p
0 .4 1 r
.02 w
.64726 .3426 m
.55852 .28944 L
s
P
p
0 .4 1 r
.02 w
.64915 .41495 m
.64726 .3426 L
s
P
p
.2 1 0 r
.02 w
.72559 .61944 m
.81137 .6655 L
s
P
p
0 .4 1 r
.02 w
.74282 .61688 m
.82831 .66306 L
s
P
p
0 .4 1 r
.02 w
.73908 .53949 m
.65112 .49017 L
s
P
p
.2 1 0 r
.02 w
.63231 .41772 m
.63394 .4929 L
s
P
p
0 .4 1 r
.02 w
.65112 .49017 m
.64915 .41495 L
s
P
p
.2 1 0 r
.02 w
.54173 .29238 m
.44844 .2368 L
s
P
p
.2 1 0 r
.02 w
.54156 .36536 m
.54173 .29238 L
s
P
p
0 .4 1 r
.02 w
.55852 .28944 m
.55869 .36245 L
s
P
p
.2 1 0 r
.02 w
.63564 .57114 m
.72559 .61944 L
s
P
p
0 .4 1 r
.02 w
.65317 .56845 m
.74282 .61688 L
s
P
p
.2 1 0 r
.02 w
.63394 .4929 m
.54138 .44132 L
s
P
p
.2 1 0 r
.02 w
.54138 .44132 m
.54156 .36536 L
s
P
p
0 .4 1 r
.02 w
.55869 .36245 m
.46378 .30738 L
s
P
p
.2 1 0 r
.02 w
.44844 .2368 m
.44636 .31043 L
s
P
p
.2 1 0 r
.02 w
.72914 .69991 m
.63741 .6526 L
s
P
p
.2 1 0 r
.02 w
.73283 .78369 m
.72914 .69991 L
s
P
p
0 .4 1 r
.02 w
.74672 .6974 m
.65531 .64998 L
s
P
p
0 .4 1 r
.02 w
.75078 .78125 m
.74672 .6974 L
s
P
p
.2 1 0 r
.02 w
.63741 .6526 m
.63564 .57114 L
s
P
p
0 .4 1 r
.02 w
.65531 .64998 m
.65317 .56845 L
s
P
p
.2 1 0 r
.02 w
.44636 .31043 m
.34637 .25274 L
s
P
p
0 .4 1 r
.02 w
.46378 .30738 m
.36409 .24953 L
s
P
p
.2 1 0 r
.02 w
.63926 .73752 m
.73283 .78369 L
s
P
p
0 .4 1 r
.02 w
.65753 .73495 m
.75078 .78125 L
s
P
p
.2 1 0 r
.02 w
.44419 .38714 m
.44193 .46712 L
s
P
p
.2 1 0 r
.02 w
.34201 .33019 m
.44419 .38714 L
s
P
p
0 .4 1 r
.02 w
.46198 .38413 m
.46009 .46416 L
s
P
p
0 .4 1 r
.02 w
.36011 .32702 m
.46198 .38413 L
s
P
p
.01 w
.34637 .25274 Mdot
P
p
.2 1 0 r
.02 w
.34637 .25274 m
.34201 .33019 L
s
P
p
.01 w
.36409 .24953 Mdot
P
p
0 .4 1 r
.02 w
.36409 .24953 m
.36011 .32702 L
s
P
p
.2 1 0 r
.02 w
.64118 .82609 m
.63926 .73752 L
s
P
p
0 .4 1 r
.02 w
.55943 .68623 m
.65753 .73495 L
s
P
p
.2 1 0 r
.02 w
.54101 .60289 m
.54082 .68894 L
s
P
p
.2 1 0 r
.02 w
.43958 .55058 m
.54101 .60289 L
s
P
p
.2 1 0 r
.02 w
.44193 .46712 m
.33746 .41102 L
s
P
p
0 .4 1 r
.02 w
.46009 .46416 m
.35594 .4079 L
s
P
p
.2 1 0 r
.02 w
.54061 .77879 m
.64118 .82609 L
s
P
p
.2 1 0 r
.02 w
.54082 .68894 m
.54061 .77879 L
s
P
p
0 .4 1 r
.02 w
.55964 .77616 m
.55943 .68623 L
s
P
p
.2 1 0 r
.02 w
.43712 .63776 m
.43958 .55058 L
s
P
p
0 .4 1 r
.02 w
.45813 .54767 m
.45608 .63491 L
s
P
p
0 .4 1 r
.02 w
.3516 .49239 m
.45813 .54767 L
s
P
p
.2 1 0 r
.02 w
.33746 .41102 m
.22734 .35189 L
s
P
p
0 .4 1 r
.02 w
.35594 .4079 m
.24617 .3486 L
s
P
p
0 .4 1 r
.02 w
.45394 .72613 m
.55964 .77616 L
s
P
p
.2 1 0 r
.02 w
.32773 .58377 m
.43712 .63776 L
s
P
p
0 .4 1 r
.02 w
.45608 .63491 m
.45394 .72613 L
s
P
p
.2 1 0 r
.02 w
.3327 .49546 m
.32773 .58377 L
s
P
p
.2 1 0 r
.02 w
.21993 .43731 m
.3327 .49546 L
s
P
p
0 .4 1 r
.02 w
.34705 .58077 m
.3516 .49239 L
s
P
p
.2 1 0 r
.02 w
.22734 .35189 m
.21993 .43731 L
s
P
p
0 .4 1 r
.02 w
.24617 .3486 m
.13031 .28601 L
s
P
p
0 .4 1 r
.02 w
.23185 .52356 m
.34705 .58077 L
s
P
p
0 .4 1 r
.02 w
.23918 .43407 m
.23185 .52356 L
s
P
p
0 .4 1 r
.02 w
.12037 .37243 m
.23918 .43407 L
s
P
p
0 .4 1 r
.02 w
.13031 .28601 m
.12037 .37243 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.430451 0.149123 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.430451 0.286967 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.498191 2.097 0.0245059 0.980236 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87882 .61174 m
.78846 .56381 L
s
P
p
.2 1 0 r
.02 w
.88591 .6918 m
.87882 .61174 L
s
P
p
.2 1 0 r
.02 w
.7834 .48613 m
.69015 .43471 L
s
P
p
.2 1 0 r
.02 w
.78846 .56381 m
.7834 .48613 L
s
P
p
.2 1 0 r
.02 w
.79374 .64494 m
.88591 .6918 L
s
P
p
.2 1 0 r
.02 w
.69015 .43471 m
.69327 .51333 L
s
P
p
.2 1 0 r
.02 w
.59099 .30448 m
.48962 .24655 L
s
P
p
.2 1 0 r
.02 w
.5919 .38054 m
.59099 .30448 L
s
P
p
.2 1 0 r
.02 w
.69652 .59553 m
.79374 .64494 L
s
P
p
.2 1 0 r
.02 w
.69327 .51333 m
.59285 .46007 L
s
P
p
.2 1 0 r
.02 w
.59285 .46007 m
.5919 .38054 L
s
P
p
.2 1 0 r
.02 w
.48962 .24655 m
.48822 .32337 L
s
P
p
.2 1 0 r
.02 w
.79926 .72975 m
.69993 .68156 L
s
P
p
.2 1 0 r
.02 w
.80503 .8185 m
.79926 .72975 L
s
P
p
.2 1 0 r
.02 w
.69993 .68156 m
.69652 .59553 L
s
P
p
.2 1 0 r
.02 w
.48822 .32337 m
.37867 .26297 L
s
P
p
0 .4 1 r
.02 w
.50751 .32019 m
.39834 .2596 L
s
P
p
.2 1 0 r
.02 w
.7035 .77169 m
.80503 .8185 L
s
P
p
.2 1 0 r
.02 w
.48676 .40381 m
.48523 .48812 L
s
P
p
.2 1 0 r
.02 w
.37451 .34428 m
.48676 .40381 L
s
P
p
0 .4 1 r
.02 w
.5065 .40067 m
.50545 .48504 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.5065 .40067 L
s
P
p
.01 w
.37867 .26297 Mdot
P
p
.2 1 0 r
.02 w
.37867 .26297 m
.37451 .34428 L
s
P
p
.01 w
.39834 .2596 Mdot
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.39834 .2596 L
s
P
p
.2 1 0 r
.02 w
.70724 .86623 m
.7035 .77169 L
s
P
p
.2 1 0 r
.02 w
.59489 .63059 m
.59598 .72212 L
s
P
p
.2 1 0 r
.02 w
.48363 .5766 m
.59489 .63059 L
s
P
p
.2 1 0 r
.02 w
.48523 .48812 m
.37015 .42962 L
s
P
p
0 .4 1 r
.02 w
.50545 .48504 m
.39078 .42635 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.39465 .34095 L
s
P
p
.2 1 0 r
.02 w
.59713 .81827 m
.70724 .86623 L
s
P
p
.2 1 0 r
.02 w
.59598 .72212 m
.59713 .81827 L
s
P
p
.2 1 0 r
.02 w
.48194 .66955 m
.48363 .5766 L
s
P
p
.2 1 0 r
.02 w
.37015 .42962 m
.24801 .36753 L
s
P
p
0 .4 1 r
.02 w
.39078 .42635 m
.26907 .36406 L
s
P
p
0 .4 1 r
.02 w
.15022 .21045 m
.2761 .27766 L
s
P
p
.2 1 0 r
.02 w
.36075 .61368 m
.48194 .66955 L
s
P
p
.2 1 0 r
.02 w
.36557 .51931 m
.36075 .61368 L
s
P
p
.2 1 0 r
.02 w
.24008 .45841 m
.36557 .51931 L
s
P
p
.2 1 0 r
.02 w
.24801 .36753 m
.24008 .45841 L
s
P
p
0 .4 1 r
.02 w
.26907 .36406 m
.13964 .29782 L
s
P
p
0 .4 1 r
.02 w
.26168 .45501 m
.26907 .36406 L
s
P
p
0 .4 1 r
.02 w
.13964 .29782 m
.15022 .21045 L
s
P
p
0 .4 1 r
.02 w
.1285 .38993 m
.26168 .45501 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.430451 0.424812 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.451366 2.00297 0.0247151 0.988603 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8869 .6339 m
.80642 .58904 L
s
P
p
.2 1 0 r
.02 w
.89326 .70947 m
.8869 .6339 L
s
P
p
.2 1 0 r
.02 w
.80165 .51543 m
.71891 .46769 L
s
P
p
.2 1 0 r
.02 w
.80642 .58904 m
.80165 .51543 L
s
P
p
.2 1 0 r
.02 w
.81137 .6655 m
.89326 .70947 L
s
P
p
.2 1 0 r
.02 w
.71891 .46769 m
.72219 .54209 L
s
P
p
.2 1 0 r
.02 w
.63074 .34541 m
.54173 .29238 L
s
P
p
.2 1 0 r
.02 w
.63231 .41772 m
.63074 .34541 L
s
P
p
.2 1 0 r
.02 w
.72559 .61944 m
.81137 .6655 L
s
P
p
.2 1 0 r
.02 w
.72219 .54209 m
.63394 .4929 L
s
P
p
.2 1 0 r
.02 w
.63394 .4929 m
.63231 .41772 L
s
P
p
.2 1 0 r
.02 w
.54173 .29238 m
.54156 .36536 L
s
P
p
.2 1 0 r
.02 w
.81652 .74497 m
.72914 .69991 L
s
P
p
.2 1 0 r
.02 w
.82188 .82764 m
.81652 .74497 L
s
P
p
.2 1 0 r
.02 w
.72914 .69991 m
.72559 .61944 L
s
P
p
.2 1 0 r
.02 w
.54156 .36536 m
.44636 .31043 L
s
P
p
0 .4 1 r
.02 w
.55869 .36245 m
.46378 .30738 L
s
P
p
0 .4 1 r
.02 w
.55886 .43845 m
.55869 .36245 L
s
P
p
0 .4 1 r
.02 w
.46551 .23371 m
.46378 .30738 L
s
P
p
0 .4 1 r
.02 w
.36792 .17524 m
.46551 .23371 L
s
P
p
.2 1 0 r
.02 w
.73283 .78369 m
.82188 .82764 L
s
P
p
.2 1 0 r
.02 w
.54138 .44132 m
.5412 .52043 L
s
P
p
.2 1 0 r
.02 w
.44419 .38714 m
.54138 .44132 L
s
P
p
0 .4 1 r
.02 w
.46198 .38413 m
.55886 .43845 L
s
P
p
0 .4 1 r
.02 w
.55886 .43845 m
.55904 .51761 L
s
P
p
.01 w
.44636 .31043 Mdot
P
p
.2 1 0 r
.02 w
.44636 .31043 m
.44419 .38714 L
s
P
p
.01 w
.46378 .30738 Mdot
P
p
0 .4 1 r
.02 w
.46378 .30738 m
.46198 .38413 L
s
P
p
0 .4 1 r
.02 w
.36409 .24953 m
.36792 .17524 L
s
P
p
0 .4 1 r
.02 w
.36792 .17524 m
.26538 .1138 L
s
P
p
.2 1 0 r
.02 w
.73667 .87101 m
.73283 .78369 L
s
P
p
.2 1 0 r
.02 w
.63741 .6526 m
.63926 .73752 L
s
P
p
.2 1 0 r
.02 w
.54101 .60289 m
.63741 .6526 L
s
P
p
.2 1 0 r
.02 w
.5412 .52043 m
.44193 .46712 L
s
P
p
0 .4 1 r
.02 w
.55904 .51761 m
.46009 .46416 L
s
P
p
0 .4 1 r
.02 w
.25926 .1887 m
.36409 .24953 L
s
P
p
.2 1 0 r
.02 w
.64118 .82609 m
.73667 .87101 L
s
P
p
0 .4 1 r
.02 w
.26538 .1138 m
.25926 .1887 L
s
P
p
.2 1 0 r
.02 w
.63926 .73752 m
.64118 .82609 L
s
P
p
.2 1 0 r
.02 w
.54082 .68894 m
.54101 .60289 L
s
P
p
.2 1 0 r
.02 w
.44193 .46712 m
.33746 .41102 L
s
P
p
0 .4 1 r
.02 w
.46009 .46416 m
.35594 .4079 L
s
P
p
0 .4 1 r
.02 w
.45813 .54767 m
.46009 .46416 L
s
P
p
0 .4 1 r
.02 w
.14886 .12464 m
.25926 .1887 L
s
P
p
.2 1 0 r
.02 w
.43712 .63776 m
.54082 .68894 L
s
P
p
.2 1 0 r
.02 w
.43958 .55058 m
.43712 .63776 L
s
P
p
.2 1 0 r
.02 w
.3327 .49546 m
.43958 .55058 L
s
P
p
0 .4 1 r
.02 w
.3516 .49239 m
.45813 .54767 L
s
P
p
.2 1 0 r
.02 w
.33746 .41102 m
.3327 .49546 L
s
P
p
0 .4 1 r
.02 w
.35594 .4079 m
.3516 .49239 L
s
P
p
0 .4 1 r
.02 w
.25286 .26689 m
.13979 .2035 L
s
P
p
0 .4 1 r
.02 w
.24617 .3486 m
.25286 .26689 L
s
P
p
0 .4 1 r
.02 w
.13979 .2035 m
.14886 .12464 L
s
P
p
0 .4 1 r
.02 w
.3516 .49239 m
.23918 .43407 L
s
P
p
0 .4 1 r
.02 w
.13031 .28601 m
.24617 .3486 L
s
P
p
0 .4 1 r
.02 w
.23918 .43407 m
.24617 .3486 L
s
P
p
0 .4 1 r
.02 w
.13979 .2035 m
.13031 .28601 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.430451 0.562657 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.430451 0.700501 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.498191 2.097 0.0245059 0.980236 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87882 .61174 m
.78846 .56381 L
s
P
p
.2 1 0 r
.02 w
.88591 .6918 m
.87882 .61174 L
s
P
p
.2 1 0 r
.02 w
.7834 .48613 m
.69015 .43471 L
s
P
p
.2 1 0 r
.02 w
.78846 .56381 m
.7834 .48613 L
s
P
p
.2 1 0 r
.02 w
.79374 .64494 m
.88591 .6918 L
s
P
p
.2 1 0 r
.02 w
.69015 .43471 m
.69327 .51333 L
s
P
p
.2 1 0 r
.02 w
.59099 .30448 m
.48962 .24655 L
s
P
p
.2 1 0 r
.02 w
.5919 .38054 m
.59099 .30448 L
s
P
p
0 .4 1 r
.02 w
.60949 .30142 m
.50847 .24332 L
s
P
p
0 .4 1 r
.02 w
.61082 .37752 m
.60949 .30142 L
s
P
p
.2 1 0 r
.02 w
.69652 .59553 m
.79374 .64494 L
s
P
p
0 .4 1 r
.02 w
.81278 .64233 m
.71594 .59277 L
s
P
p
0 .4 1 r
.02 w
.81874 .72721 m
.81278 .64233 L
s
P
p
.2 1 0 r
.02 w
.69327 .51333 m
.59285 .46007 L
s
P
p
0 .4 1 r
.02 w
.71225 .51052 m
.61221 .4571 L
s
P
p
0 .4 1 r
.02 w
.71594 .59277 m
.71225 .51052 L
s
P
p
.2 1 0 r
.02 w
.59285 .46007 m
.5919 .38054 L
s
P
p
0 .4 1 r
.02 w
.61221 .4571 m
.61082 .37752 L
s
P
p
.2 1 0 r
.02 w
.48962 .24655 m
.48822 .32337 L
s
P
p
0 .4 1 r
.02 w
.50847 .24332 m
.50751 .32019 L
s
P
p
.2 1 0 r
.02 w
.79926 .72975 m
.69993 .68156 L
s
P
p
.2 1 0 r
.02 w
.80503 .8185 m
.79926 .72975 L
s
P
p
0 .4 1 r
.02 w
.71981 .67887 m
.81874 .72721 L
s
P
p
.2 1 0 r
.02 w
.69993 .68156 m
.69652 .59553 L
s
P
p
0 .4 1 r
.02 w
.61366 .54042 m
.61221 .4571 L
s
P
p
.2 1 0 r
.02 w
.48822 .32337 m
.37867 .26297 L
s
P
p
0 .4 1 r
.02 w
.50751 .32019 m
.39834 .2596 L
s
P
p
.2 1 0 r
.02 w
.7035 .77169 m
.80503 .8185 L
s
P
p
0 .4 1 r
.02 w
.61518 .62774 m
.71981 .67887 L
s
P
p
.2 1 0 r
.02 w
.48676 .40381 m
.48523 .48812 L
s
P
p
.2 1 0 r
.02 w
.37451 .34428 m
.48676 .40381 L
s
P
p
0 .4 1 r
.02 w
.5065 .40067 m
.39465 .34095 L
s
P
p
.01 w
.37867 .26297 Mdot
P
p
.2 1 0 r
.02 w
.37867 .26297 m
.37451 .34428 L
s
P
p
.01 w
.39834 .2596 Mdot
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.39465 .34095 L
s
P
p
.2 1 0 r
.02 w
.70724 .86623 m
.7035 .77169 L
s
P
p
.2 1 0 r
.02 w
.59489 .63059 m
.59598 .72212 L
s
P
p
.2 1 0 r
.02 w
.48363 .5766 m
.59489 .63059 L
s
P
p
0 .4 1 r
.02 w
.50434 .57358 m
.61518 .62774 L
s
P
p
0 .4 1 r
.02 w
.61677 .71936 m
.61518 .62774 L
s
P
p
.2 1 0 r
.02 w
.48523 .48812 m
.37015 .42962 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.2761 .27766 L
s
P
p
.2 1 0 r
.02 w
.59713 .81827 m
.70724 .86623 L
s
P
p
.2 1 0 r
.02 w
.59598 .72212 m
.59713 .81827 L
s
P
p
0 .4 1 r
.02 w
.50317 .66661 m
.61677 .71936 L
s
P
p
.2 1 0 r
.02 w
.48194 .66955 m
.48363 .5766 L
s
P
p
.2 1 0 r
.02 w
.37015 .42962 m
.24801 .36753 L
s
P
p
0 .4 1 r
.02 w
.39078 .42635 m
.38672 .51611 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.15022 .21045 L
s
P
p
.2 1 0 r
.02 w
.36075 .61368 m
.48194 .66955 L
s
P
p
0 .4 1 r
.02 w
.50195 .76448 m
.50317 .66661 L
s
P
p
.2 1 0 r
.02 w
.36557 .51931 m
.36075 .61368 L
s
P
p
.2 1 0 r
.02 w
.24008 .45841 m
.36557 .51931 L
s
P
p
0 .4 1 r
.02 w
.38672 .51611 m
.38244 .61055 L
s
P
p
0 .4 1 r
.02 w
.26168 .45501 m
.38672 .51611 L
s
P
p
.2 1 0 r
.02 w
.24801 .36753 m
.24008 .45841 L
s
P
p
0 .4 1 r
.02 w
.26907 .36406 m
.26168 .45501 L
s
P
p
0 .4 1 r
.02 w
.13964 .29782 m
.26907 .36406 L
s
P
p
0 .4 1 r
.02 w
.15022 .21045 m
.13964 .29782 L
s
P
p
0 .4 1 r
.02 w
.37793 .71007 m
.50195 .76448 L
s
P
p
0 .4 1 r
.02 w
.38244 .61055 m
.37793 .71007 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.430451 0.838346 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.430451 0.97619 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.508603 2.11798 0.0244683 0.978733 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87797 .58565 m
.79963 .54405 L
s
P
p
.2 1 0 r
.02 w
.8841 .65383 m
.87797 .58565 L
s
P
p
.2 1 0 r
.02 w
.79504 .47764 m
.71453 .43343 L
s
P
p
.2 1 0 r
.02 w
.79963 .54405 m
.79504 .47764 L
s
P
p
.2 1 0 r
.02 w
.80441 .613 m
.8841 .65383 L
s
P
p
.2 1 0 r
.02 w
.71453 .43343 m
.71768 .50052 L
s
P
p
.2 1 0 r
.02 w
.62878 .32198 m
.54223 .27296 L
s
P
p
.2 1 0 r
.02 w
.63029 .38718 m
.62878 .32198 L
s
P
p
0 .4 1 r
.02 w
.64484 .31939 m
.55855 .27024 L
s
P
p
0 .4 1 r
.02 w
.64667 .38461 m
.64484 .31939 L
s
P
p
.2 1 0 r
.02 w
.72096 .57024 m
.80441 .613 L
s
P
p
.2 1 0 r
.02 w
.71768 .50052 m
.63187 .45494 L
s
P
p
.2 1 0 r
.02 w
.63187 .45494 m
.63029 .38718 L
s
P
p
0 .4 1 r
.02 w
.64857 .45241 m
.64667 .38461 L
s
P
p
.2 1 0 r
.02 w
.54223 .27296 m
.54207 .33874 L
s
P
p
0 .4 1 r
.02 w
.55855 .27024 m
.55872 .33605 L
s
P
p
.2 1 0 r
.02 w
.80936 .68464 m
.72437 .64275 L
s
P
p
.2 1 0 r
.02 w
.81452 .75913 m
.80936 .68464 L
s
P
p
0 .4 1 r
.02 w
.82616 .68242 m
.74146 .64042 L
s
P
p
0 .4 1 r
.02 w
.83166 .75697 m
.82616 .68242 L
s
P
p
.2 1 0 r
.02 w
.72437 .64275 m
.72096 .57024 L
s
P
p
0 .4 1 r
.02 w
.73771 .56787 m
.65054 .52294 L
s
P
p
0 .4 1 r
.02 w
.74146 .64042 m
.73771 .56787 L
s
P
p
0 .4 1 r
.02 w
.65054 .52294 m
.64857 .45241 L
s
P
p
.2 1 0 r
.02 w
.54207 .33874 m
.44955 .28794 L
s
P
p
0 .4 1 r
.02 w
.55872 .33605 m
.46649 .28512 L
s
P
p
.2 1 0 r
.02 w
.72792 .71821 m
.81452 .75913 L
s
P
p
0 .4 1 r
.02 w
.74536 .71594 m
.83166 .75697 L
s
P
p
.2 1 0 r
.02 w
.5419 .40716 m
.54172 .4784 L
s
P
p
.2 1 0 r
.02 w
.44747 .35701 m
.5419 .40716 L
s
P
p
.01 w
.44955 .28794 Mdot
P
p
.2 1 0 r
.02 w
.44955 .28794 m
.44747 .35701 L
s
P
p
.01 w
.46649 .28512 Mdot
P
p
0 .4 1 r
.02 w
.46649 .28512 m
.46475 .35422 L
s
P
p
.2 1 0 r
.02 w
.73162 .79682 m
.72792 .71821 L
s
P
p
0 .4 1 r
.02 w
.65473 .67284 m
.74536 .71594 L
s
P
p
.2 1 0 r
.02 w
.63521 .5988 m
.63698 .67523 L
s
P
p
.2 1 0 r
.02 w
.54154 .55263 m
.63521 .5988 L
s
P
p
.2 1 0 r
.02 w
.54172 .4784 m
.4453 .42899 L
s
P
p
0 .4 1 r
.02 w
.46475 .35422 m
.36583 .30138 L
s
P
p
.2 1 0 r
.02 w
.63883 .75494 m
.73162 .79682 L
s
P
p
.2 1 0 r
.02 w
.63698 .67523 m
.63883 .75494 L
s
P
p
0 .4 1 r
.02 w
.55943 .62753 m
.65473 .67284 L
s
P
p
.2 1 0 r
.02 w
.54135 .63005 m
.54154 .55263 L
s
P
p
.2 1 0 r
.02 w
.4453 .42899 m
.34387 .37702 L
s
P
p
0 .4 1 r
.02 w
.36583 .30138 m
.26174 .24577 L
s
P
p
.2 1 0 r
.02 w
.44067 .58247 m
.54135 .63005 L
s
P
p
0 .4 1 r
.02 w
.55963 .7084 m
.55943 .62753 L
s
P
p
.2 1 0 r
.02 w
.44304 .50408 m
.44067 .58247 L
s
P
p
.2 1 0 r
.02 w
.33931 .45295 m
.44304 .50408 L
s
P
p
.2 1 0 r
.02 w
.34387 .37702 m
.33931 .45295 L
s
P
p
0 .4 1 r
.02 w
.26174 .24577 m
.15207 .18719 L
s
P
p
0 .4 1 r
.02 w
.45703 .6618 m
.55963 .7084 L
s
P
p
0 .4 1 r
.02 w
.35765 .4501 m
.35329 .52952 L
s
P
p
0 .4 1 r
.02 w
.2486 .39603 m
.35765 .4501 L
s
P
p
0 .4 1 r
.02 w
.25532 .31923 m
.2486 .39603 L
s
P
p
0 .4 1 r
.02 w
.14296 .26132 m
.25532 .31923 L
s
P
p
0 .4 1 r
.02 w
.15207 .18719 m
.14296 .26132 L
s
P
p
0 .4 1 r
.02 w
.45488 .74757 m
.45703 .6618 L
s
P
p
0 .4 1 r
.02 w
.35329 .52952 m
.34872 .61261 L
s
P
p
0 .4 1 r
.02 w
.34394 .69965 m
.45488 .74757 L
s
P
p
0 .4 1 r
.02 w
.34872 .61261 m
.34394 .69965 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.568296 0.149123 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.7867 .53145 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.89777 .66825 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56304 .80672 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.15169 .31032 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.139 .40899 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.568296 0.286967 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.380258 1.86028 0.0250076 1.0003 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.89873 .67009 m
.8327 .63026 L
s
P
p
.2 1 0 r
.02 w
.904 .73799 m
.89873 .67009 L
s
P
p
.2 1 0 r
.02 w
.82848 .56377 m
.76097 .52188 L
s
P
p
.2 1 0 r
.02 w
.8327 .63026 m
.82848 .56377 L
s
P
p
.2 1 0 r
.02 w
.83706 .6988 m
.904 .73799 L
s
P
p
.2 1 0 r
.02 w
.76097 .52188 m
.76423 .58896 L
s
P
p
.2 1 0 r
.02 w
.6888 .41283 m
.61721 .36721 L
s
P
p
.2 1 0 r
.02 w
.69095 .47843 m
.6888 .41283 L
s
P
p
.2 1 0 r
.02 w
.76759 .65814 m
.83706 .6988 L
s
P
p
.2 1 0 r
.02 w
.76423 .58896 m
.69317 .54609 L
s
P
p
.2 1 0 r
.02 w
.69317 .54609 m
.69095 .47843 L
s
P
p
.2 1 0 r
.02 w
.61721 .36721 m
.61827 .43334 L
s
P
p
.2 1 0 r
.02 w
.84155 .76949 m
.77106 .72953 L
s
P
p
.2 1 0 r
.02 w
.84618 .84242 m
.84155 .76949 L
s
P
p
.2 1 0 r
.02 w
.77106 .72953 m
.76759 .65814 L
s
P
p
.2 1 0 r
.02 w
.61827 .43334 m
.54279 .3865 L
s
P
p
.2 1 0 r
.02 w
.77464 .80324 m
.84618 .84242 L
s
P
p
.2 1 0 r
.02 w
.61937 .50158 m
.6205 .57205 L
s
P
p
.2 1 0 r
.02 w
.54268 .45532 m
.61937 .50158 L
s
P
p
.01 w
.54279 .3865 Mdot
P
p
.2 1 0 r
.02 w
.54279 .3865 m
.54268 .45532 L
s
P
p
.01 w
.55698 .38391 Mdot
P
p
0 .4 1 r
.02 w
.5571 .45276 m
.55698 .38391 L
s
P
p
0 .4 1 r
.02 w
.47987 .26796 m
.39984 .21672 L
s
P
p
0 .4 1 r
.02 w
.47872 .33513 m
.47987 .26796 L
s
P
p
.2 1 0 r
.02 w
.77834 .87937 m
.77464 .80324 L
s
P
p
.2 1 0 r
.02 w
.69782 .68802 m
.70027 .7625 L
s
P
p
.2 1 0 r
.02 w
.62167 .64485 m
.69782 .68802 L
s
P
p
.2 1 0 r
.02 w
.6205 .57205 m
.54256 .52642 L
s
P
p
0 .4 1 r
.02 w
.63496 .56962 m
.55722 .5239 L
s
P
p
0 .4 1 r
.02 w
.63637 .64246 m
.63496 .56962 L
s
P
p
0 .4 1 r
.02 w
.55722 .5239 m
.5571 .45276 L
s
P
p
0 .4 1 r
.02 w
.5571 .45276 m
.47754 .40454 L
s
P
p
0 .4 1 r
.02 w
.47754 .40454 m
.47872 .33513 L
s
P
p
.2 1 0 r
.02 w
.70279 .83947 m
.77834 .87937 L
s
P
p
0 .4 1 r
.02 w
.39984 .21672 m
.39732 .28439 L
s
P
p
.2 1 0 r
.02 w
.70027 .7625 m
.70279 .83947 L
s
P
p
.2 1 0 r
.02 w
.62288 .72011 m
.62167 .64485 L
s
P
p
0 .4 1 r
.02 w
.55734 .59744 m
.63637 .64246 L
s
P
p
.2 1 0 r
.02 w
.54256 .52642 m
.46144 .47894 L
s
P
p
0 .4 1 r
.02 w
.39732 .28439 m
.31258 .23156 L
s
P
p
.2 1 0 r
.02 w
.54231 .67597 m
.62288 .72011 L
s
P
p
.2 1 0 r
.02 w
.54244 .59993 m
.54231 .67597 L
s
P
p
.2 1 0 r
.02 w
.45991 .55315 m
.54244 .59993 L
s
P
p
0 .4 1 r
.02 w
.47504 .55056 m
.55734 .59744 L
s
P
p
.2 1 0 r
.02 w
.46144 .47894 m
.45991 .55315 L
s
P
p
0 .4 1 r
.02 w
.31258 .23156 m
.30845 .30207 L
s
P
p
0 .4 1 r
.02 w
.22428 .17652 m
.31258 .23156 L
s
P
p
0 .4 1 r
.02 w
.55747 .67352 m
.47372 .62742 L
s
P
p
0 .4 1 r
.02 w
.47372 .62742 m
.47504 .55056 L
s
P
p
0 .4 1 r
.02 w
.30845 .30207 m
.2185 .24755 L
s
P
p
0 .4 1 r
.02 w
.38636 .57933 m
.47372 .62742 L
s
P
p
0 .4 1 r
.02 w
.2185 .24755 m
.12463 .19066 L
s
P
p
0 .4 1 r
.02 w
.38337 .65981 m
.38636 .57933 L
s
P
p
0 .4 1 r
.02 w
.29975 .45071 m
.29515 .52912 L
s
P
p
0 .4 1 r
.02 w
.20629 .39747 m
.29975 .45071 L
s
P
p
0 .4 1 r
.02 w
.2125 .32116 m
.20629 .39747 L
s
P
p
0 .4 1 r
.02 w
.11676 .26485 m
.2125 .32116 L
s
P
p
0 .4 1 r
.02 w
.12463 .19066 m
.11676 .26485 L
s
P
p
0 .4 1 r
.02 w
.29039 .61047 m
.38337 .65981 L
s
P
p
0 .4 1 r
.02 w
.29515 .52912 m
.29039 .61047 L
s
P
p
0 .4 1 r
.02 w
.19984 .47665 m
.20629 .39747 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.568296 0.424812 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.564051 2.22952 0.0242196 0.968782 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.67113 .36663 m
.6732 .42081 L
s
P
p
0 .4 1 r
.02 w
.59643 .32711 m
.67113 .36663 L
s
P
p
.2 1 0 r
.02 w
.88595 .69985 m
.81527 .66701 L
s
P
p
.2 1 0 r
.02 w
.89172 .76008 m
.88595 .69985 L
s
P
p
.2 1 0 r
.02 w
.81077 .60816 m
.73828 .57329 L
s
P
p
.2 1 0 r
.02 w
.81527 .66701 m
.81077 .60816 L
s
P
p
0 .4 1 r
.02 w
.6732 .42081 m
.67533 .47687 L
s
P
p
0 .4 1 r
.02 w
.59723 .38173 m
.59643 .32711 L
s
P
p
.2 1 0 r
.02 w
.81992 .72794 m
.89172 .76008 L
s
P
p
.2 1 0 r
.02 w
.73828 .57329 m
.74159 .63278 L
s
P
p
.2 1 0 r
.02 w
.66076 .47892 m
.58326 .44043 L
s
P
p
.2 1 0 r
.02 w
.66271 .53694 m
.66076 .47892 L
s
P
p
0 .4 1 r
.02 w
.67533 .47687 m
.59806 .4383 L
s
P
p
0 .4 1 r
.02 w
.518 .34097 m
.59723 .38173 L
s
P
p
0 .4 1 r
.02 w
.51858 .28591 m
.518 .34097 L
s
P
p
0 .4 1 r
.02 w
.43738 .24295 m
.51858 .28591 L
s
P
p
.2 1 0 r
.02 w
.74502 .6944 m
.81992 .72794 L
s
P
p
0 .4 1 r
.02 w
.43937 .18942 m
.43738 .24295 L
s
P
p
0 .4 1 r
.02 w
.35617 .14422 m
.43937 .18942 L
s
P
p
.2 1 0 r
.02 w
.74159 .63278 m
.66473 .59706 L
s
P
p
.2 1 0 r
.02 w
.66473 .59706 m
.66271 .53694 L
s
P
p
.2 1 0 r
.02 w
.58326 .44043 m
.58385 .49902 L
s
P
p
0 .4 1 r
.02 w
.59806 .4383 m
.59891 .49691 L
s
P
p
.2 1 0 r
.02 w
.82474 .79104 m
.74858 .75828 L
s
P
p
.2 1 0 r
.02 w
.82974 .85645 m
.82474 .79104 L
s
P
p
.2 1 0 r
.02 w
.74858 .75828 m
.74502 .6944 L
s
P
p
0 .4 1 r
.02 w
.26929 .09702 m
.35617 .14422 L
s
P
p
.2 1 0 r
.02 w
.58385 .49902 m
.50149 .4594 L
s
P
p
0 .4 1 r
.02 w
.59891 .49691 m
.51679 .45721 L
s
P
p
.2 1 0 r
.02 w
.75227 .82454 m
.82974 .85645 L
s
P
p
0 .4 1 r
.02 w
.3526 .19809 m
.26402 .15122 L
s
P
p
0 .4 1 r
.02 w
.3489 .25398 m
.3526 .19809 L
s
P
p
0 .4 1 r
.02 w
.26402 .15122 m
.26929 .09702 L
s
P
p
.2 1 0 r
.02 w
.58446 .55976 m
.5851 .62279 L
s
P
p
.2 1 0 r
.02 w
.50056 .52078 m
.58446 .55976 L
s
P
p
0 .4 1 r
.02 w
.5998 .5577 m
.60073 .62076 L
s
P
p
0 .4 1 r
.02 w
.51615 .51862 m
.5998 .5577 L
s
P
p
.01 w
.50149 .4594 Mdot
P
p
.2 1 0 r
.02 w
.50149 .4594 m
.50056 .52078 L
s
P
p
.01 w
.51679 .45721 Mdot
P
p
0 .4 1 r
.02 w
.51679 .45721 m
.51615 .51862 L
s
P
p
.2 1 0 r
.02 w
.7561 .89332 m
.75227 .82454 L
s
P
p
0 .4 1 r
.02 w
.25854 .20749 m
.3489 .25398 L
s
P
p
.2 1 0 r
.02 w
.66899 .72405 m
.67125 .79117 L
s
P
p
.2 1 0 r
.02 w
.58575 .68824 m
.66899 .72405 L
s
P
p
.2 1 0 r
.02 w
.5851 .62279 m
.4996 .58451 L
s
P
p
0 .4 1 r
.02 w
.60073 .62076 m
.51549 .58239 L
s
P
p
.2 1 0 r
.02 w
.67359 .86091 m
.7561 .89332 L
s
P
p
.2 1 0 r
.02 w
.67125 .79117 m
.67359 .86091 L
s
P
p
0 .4 1 r
.02 w
.25285 .26595 m
.25854 .20749 L
s
P
p
.2 1 0 r
.02 w
.58644 .75624 m
.58575 .68824 L
s
P
p
.2 1 0 r
.02 w
.4996 .58451 m
.41007 .54443 L
s
P
p
0 .4 1 r
.02 w
.51549 .58239 m
.42621 .5422 L
s
P
p
0 .4 1 r
.02 w
.42862 .47773 m
.33693 .43489 L
s
P
p
0 .4 1 r
.02 w
.42621 .5422 m
.42862 .47773 L
s
P
p
0 .4 1 r
.02 w
.34108 .37225 m
.24694 .32673 L
s
P
p
0 .4 1 r
.02 w
.33693 .43489 m
.34108 .37225 L
s
P
p
0 .4 1 r
.02 w
.15623 .21771 m
.25285 .26595 L
s
P
p
.2 1 0 r
.02 w
.49756 .71963 m
.58644 .75624 L
s
P
p
.2 1 0 r
.02 w
.4986 .65075 m
.49756 .71963 L
s
P
p
.2 1 0 r
.02 w
.40724 .61145 m
.4986 .65075 L
s
P
p
.2 1 0 r
.02 w
.41007 .54443 m
.40724 .61145 L
s
P
p
0 .4 1 r
.02 w
.24694 .32673 m
.24079 .38998 L
s
P
p
0 .4 1 r
.02 w
.14821 .279 m
.15623 .21771 L
s
P
p
0 .4 1 r
.02 w
.24079 .38998 m
.13985 .34283 L
s
P
p
0 .4 1 r
.02 w
.13985 .34283 m
.14821 .279 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.568296 0.562657 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.568296 0.700501 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.7867 .53145 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.89777 .66825 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56304 .80672 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.15169 .31032 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.139 .40899 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.568296 0.838346 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.559341 2.21998 0.0242236 0.968945 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.88673 .5597 m
.79942 .51531 L
s
P
p
0 .4 1 r
.02 w
.89392 .63143 m
.88673 .5597 L
s
P
p
0 .4 1 r
.02 w
.79419 .44573 m
.70412 .39819 L
s
P
p
0 .4 1 r
.02 w
.79942 .51531 m
.79419 .44573 L
s
P
p
0 .4 1 r
.02 w
.80489 .58796 m
.89392 .63143 L
s
P
p
.2 1 0 r
.02 w
.78139 .51778 m
.68912 .47117 L
s
P
p
.2 1 0 r
.02 w
.78644 .59037 m
.78139 .51778 L
s
P
p
.2 1 0 r
.02 w
.68613 .40083 m
.59093 .35091 L
s
P
p
.2 1 0 r
.02 w
.68912 .47117 m
.68613 .40083 L
s
P
p
0 .4 1 r
.02 w
.70412 .39819 m
.7075 .46857 L
s
P
p
.2 1 0 r
.02 w
.69223 .54467 m
.78644 .59037 L
s
P
p
0 .4 1 r
.02 w
.71104 .54213 m
.80489 .58796 L
s
P
p
0 .4 1 r
.02 w
.7075 .46857 m
.61058 .41929 L
s
P
p
.2 1 0 r
.02 w
.59093 .35091 m
.59184 .42203 L
s
P
p
.2 1 0 r
.02 w
.49187 .22959 m
.3883 .17339 L
s
P
p
.2 1 0 r
.02 w
.49053 .29827 m
.49187 .22959 L
s
P
p
0 .4 1 r
.02 w
.51013 .22662 m
.40691 .17026 L
s
P
p
0 .4 1 r
.02 w
.50921 .29534 m
.51013 .22662 L
s
P
p
.2 1 0 r
.02 w
.59279 .49644 m
.69223 .54467 L
s
P
p
0 .4 1 r
.02 w
.71474 .61907 m
.71104 .54213 L
s
P
p
.2 1 0 r
.02 w
.59184 .42203 m
.48913 .37015 L
s
P
p
0 .4 1 r
.02 w
.61058 .41929 m
.50824 .36726 L
s
P
p
.2 1 0 r
.02 w
.48913 .37015 m
.49053 .29827 L
s
P
p
0 .4 1 r
.02 w
.50824 .36726 m
.50921 .29534 L
s
P
p
.2 1 0 r
.02 w
.3883 .17339 m
.38451 .24268 L
s
P
p
0 .4 1 r
.02 w
.40691 .17026 m
.40355 .23958 L
s
P
p
0 .4 1 r
.02 w
.81656 .74325 m
.71861 .69966 L
s
P
p
0 .4 1 r
.02 w
.82281 .82637 m
.81656 .74325 L
s
P
p
.2 1 0 r
.02 w
.6955 .62156 m
.59379 .57437 L
s
P
p
.2 1 0 r
.02 w
.69891 .70208 m
.6955 .62156 L
s
P
p
0 .4 1 r
.02 w
.71861 .69966 m
.71474 .61907 L
s
P
p
.2 1 0 r
.02 w
.59379 .57437 m
.59279 .49644 L
s
P
p
.2 1 0 r
.02 w
.38451 .24268 m
.27237 .18389 L
s
P
p
0 .4 1 r
.02 w
.40355 .23958 m
.29178 .1806 L
s
P
p
0 .4 1 r
.02 w
.72268 .78413 m
.82281 .82637 L
s
P
p
.2 1 0 r
.02 w
.59484 .65609 m
.69891 .70208 L
s
P
p
.2 1 0 r
.02 w
.38053 .31529 m
.37637 .39146 L
s
P
p
.2 1 0 r
.02 w
.26551 .25719 m
.38053 .31529 L
s
P
p
0 .4 1 r
.02 w
.40002 .31223 m
.39633 .38845 L
s
P
p
0 .4 1 r
.02 w
.2854 .25395 m
.40002 .31223 L
s
P
p
.01 w
.27237 .18389 Mdot
P
p
.2 1 0 r
.02 w
.27237 .18389 m
.26551 .25719 L
s
P
p
.01 w
.29178 .1806 Mdot
P
p
0 .4 1 r
.02 w
.29178 .1806 m
.2854 .25395 L
s
P
p
0 .4 1 r
.02 w
.72694 .8728 m
.72268 .78413 L
s
P
p
.2 1 0 r
.02 w
.59594 .74187 m
.59484 .65609 L
s
P
p
0 .4 1 r
.02 w
.61495 .65352 m
.61655 .73938 L
s
P
p
0 .4 1 r
.02 w
.50506 .60461 m
.61495 .65352 L
s
P
p
.2 1 0 r
.02 w
.48613 .52442 m
.48452 .60734 L
s
P
p
.2 1 0 r
.02 w
.37199 .47146 m
.48613 .52442 L
s
P
p
.2 1 0 r
.02 w
.37637 .39146 m
.25832 .3342 L
s
P
p
0 .4 1 r
.02 w
.39633 .38845 m
.39244 .4685 L
s
P
p
0 .4 1 r
.02 w
.61824 .82962 m
.72694 .8728 L
s
P
p
.2 1 0 r
.02 w
.48283 .69451 m
.59594 .74187 L
s
P
p
0 .4 1 r
.02 w
.61655 .73938 m
.61824 .82962 L
s
P
p
.2 1 0 r
.02 w
.48452 .60734 m
.48283 .69451 L
s
P
p
0 .4 1 r
.02 w
.38836 .55268 m
.50506 .60461 L
s
P
p
.2 1 0 r
.02 w
.36738 .55557 m
.37199 .47146 L
s
P
p
0 .4 1 r
.02 w
.39244 .4685 m
.27163 .41205 L
s
P
p
.2 1 0 r
.02 w
.25832 .3342 m
.13289 .27337 L
s
P
p
.2 1 0 r
.02 w
.24277 .50051 m
.36738 .55557 L
s
P
p
0 .4 1 r
.02 w
.38406 .64132 m
.38836 .55268 L
s
P
p
.2 1 0 r
.02 w
.25075 .4152 m
.24277 .50051 L
s
P
p
.2 1 0 r
.02 w
.12173 .35534 m
.25075 .4152 L
s
P
p
0 .4 1 r
.02 w
.27163 .41205 m
.14306 .35198 L
s
P
p
.2 1 0 r
.02 w
.13289 .27337 m
.12173 .35534 L
s
P
p
0 .4 1 r
.02 w
.25636 .58746 m
.38406 .64132 L
s
P
p
0 .4 1 r
.02 w
.2642 .49742 m
.25636 .58746 L
s
P
p
0 .4 1 r
.02 w
.13185 .43852 m
.2642 .49742 L
s
P
p
0 .4 1 r
.02 w
.14306 .35198 m
.13185 .43852 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.568296 0.97619 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.758303 2.5909 0.0163524 0.959656 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.65693 .26414 m
.65922 .32981 L
s
P
p
0 .4 1 r
.02 w
.5475 .21345 m
.65693 .26414 L
s
P
p
0 .4 1 r
.02 w
.65922 .32981 m
.5477 .27966 L
s
P
p
0 .4 1 r
.02 w
.5477 .27966 m
.5475 .21345 L
s
P
p
.2 1 0 r
.02 w
.86547 .63433 m
.75767 .59089 L
s
P
p
.2 1 0 r
.02 w
.87194 .70928 m
.86547 .63433 L
s
P
p
.2 1 0 r
.02 w
.75339 .51794 m
.64249 .47155 L
s
P
p
.2 1 0 r
.02 w
.75767 .59089 m
.75339 .51794 L
s
P
p
0 .4 1 r
.02 w
.5477 .27966 m
.43082 .22711 L
s
P
p
.2 1 0 r
.02 w
.76212 .66678 m
.87194 .70928 L
s
P
p
.2 1 0 r
.02 w
.64249 .47155 m
.64463 .54533 L
s
P
p
0 .4 1 r
.02 w
.66408 .46898 m
.66666 .5428 L
s
P
p
0 .4 1 r
.02 w
.54813 .4202 m
.66408 .46898 L
s
P
p
.2 1 0 r
.02 w
.52639 .35127 m
.40675 .29947 L
s
P
p
.2 1 0 r
.02 w
.52617 .4229 m
.52639 .35127 L
s
P
p
0 .4 1 r
.02 w
.54792 .34853 m
.42864 .29659 L
s
P
p
0 .4 1 r
.02 w
.54813 .4202 m
.54792 .34853 L
s
P
p
0 .4 1 r
.02 w
.43082 .22711 m
.42864 .29659 L
s
P
p
0 .4 1 r
.02 w
.31278 .10471 m
.30817 .17196 L
s
P
p
0 .4 1 r
.02 w
.1867 .04631 m
.31278 .10471 L
s
P
p
.2 1 0 r
.02 w
.64685 .62217 m
.76212 .66678 L
s
P
p
.2 1 0 r
.02 w
.64463 .54533 m
.52594 .49751 L
s
P
p
0 .4 1 r
.02 w
.66666 .5428 m
.54836 .49485 L
s
P
p
.2 1 0 r
.02 w
.52594 .49751 m
.52617 .4229 L
s
P
p
0 .4 1 r
.02 w
.54836 .49485 m
.54813 .4202 L
s
P
p
.2 1 0 r
.02 w
.40675 .29947 m
.40403 .37181 L
s
P
p
0 .4 1 r
.02 w
.42864 .29659 m
.42637 .36897 L
s
P
p
0 .4 1 r
.02 w
.30336 .24203 m
.42864 .29659 L
s
P
p
0 .4 1 r
.02 w
.30817 .17196 m
.30336 .24203 L
s
P
p
0 .4 1 r
.02 w
.30817 .17196 m
.17931 .11402 L
s
P
p
.2 1 0 r
.02 w
.76676 .7458 m
.64917 .70225 L
s
P
p
.2 1 0 r
.02 w
.77159 .82814 m
.76676 .7458 L
s
P
p
0 .4 1 r
.02 w
.17931 .11402 m
.1867 .04631 L
s
P
p
.2 1 0 r
.02 w
.64917 .70225 m
.64685 .62217 L
s
P
p
.2 1 0 r
.02 w
.40403 .37181 m
.27561 .31809 L
s
P
p
0 .4 1 r
.02 w
.42637 .36897 m
.29835 .31511 L
s
P
p
.2 1 0 r
.02 w
.65159 .78579 m
.77159 .82814 L
s
P
p
.2 1 0 r
.02 w
.40119 .44724 m
.39823 .52595 L
s
P
p
.2 1 0 r
.02 w
.26989 .39433 m
.40119 .44724 L
s
P
p
.01 w
.27561 .31809 Mdot
P
p
.2 1 0 r
.02 w
.27561 .31809 m
.26989 .39433 L
s
P
p
.01 w
.29835 .31511 Mdot
P
p
0 .4 1 r
.02 w
.16357 .2584 m
.29835 .31511 L
s
P
p
0 .4 1 r
.02 w
.29835 .31511 m
.29312 .39138 L
s
P
p
.2 1 0 r
.02 w
.65411 .87301 m
.65159 .78579 L
s
P
p
.2 1 0 r
.02 w
.52546 .65643 m
.5252 .74118 L
s
P
p
.2 1 0 r
.02 w
.39514 .60817 m
.52546 .65643 L
s
P
p
.2 1 0 r
.02 w
.39823 .52595 m
.26391 .47397 L
s
P
p
0 .4 1 r
.02 w
.29312 .39138 m
.15517 .33546 L
s
P
p
0 .4 1 r
.02 w
.15517 .33546 m
.16357 .2584 L
s
P
p
.2 1 0 r
.02 w
.52493 .82976 m
.65411 .87301 L
s
P
p
.2 1 0 r
.02 w
.5252 .74118 m
.52493 .82976 L
s
P
p
.2 1 0 r
.02 w
.3919 .69413 m
.39514 .60817 L
s
P
p
.2 1 0 r
.02 w
.26391 .47397 m
.12219 .41912 L
s
P
p
.2 1 0 r
.02 w
.25112 .64444 m
.3919 .69413 L
s
P
p
.2 1 0 r
.02 w
.25766 .55725 m
.25112 .64444 L
s
P
p
.2 1 0 r
.02 w
.11243 .50347 m
.25766 .55725 L
s
P
p
.2 1 0 r
.02 w
.12219 .41912 m
.11243 .50347 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
P
MathSubEnd
P
% End of sub-graphic
p
/Times-Italic findfont 18 scalefont setfont
[(Fractals)] .02381 .57389 -1 0 Mshowa
P
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{435, 269.625},
  ImageMargins->{{33, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006c00013A000`40O003h00Oog>L/g>L0G=i003o
LibcLi`1LgT00?mcW;=cW05cN@00og>L/g>L0G=i003oLibcLi`1LgT00?mcW;=cW05cN@00og>L/g>L
0G=i003oLibcLi`1LgT00?mcW;=cW05cN@00og>L/g>L0G=i003oLibcLi`1LgT00?mcW;=cW05cN@00
og>L/g>L0G=i003oLibcLi`1LgT004=cW081WomcW6icW05cN@00@g>L00<1Wg>L0Il00P6Oog>LJg>L
0G=i0013Li`00`6OLiacW002Li`00`6OLiacW03oLiaXLi`1LgT004=cW081W`=cW0030ImcW7>L0?mc
W6QcW05cN@00AG>L106OEG>L0P6Oog>L4g>L0G=i0018Li`00`6OLiacW01CLi`00`6OLi`1W`020In7
Li`20003Li`00a_P0Il1W`20Li`1LgT004QcW0030ImcW7>L02YcW0030001W`6O009cW0036n01W`6O
021cW0030ImcW7>L00=cW0030Il007>L009cW0036n01W`6O02EcW0030001W`6O009cW08Kh5=cW003
6n01W`6O009cW0036n01Wa_P0081WgicW05cN@00B7>L00<1Wg>LLi`01g>L0P6O8G>L00<Kh06OLi`0
0P6O00<Kh06O6n000P6O7W>L0P6O0g>L00<Kh06O6n000P6O00EcW1_P0IlKh06O02AcW0036n01Wg>L
0081W`046n1cW1_P6n0]Li`20IlRLi`00a_P0IlKh0030Il2Li`011_PLi`1W`6OO7>L0G=i0018Li`2
0Il3Li`20Il3Li`0106OLi`1W`6O7g>L00<Kh06O6n000Q_P0P6O0W>L00<Kh06OLi`07W>L0P6O00Ac
W1_P0ImcW08Kh0<1W`9cW0030ImcW7>L025cW0036n01Wa_P008Kh0050ImcW7>LLi`Kh00WLi`00a_P
0Il1W`02Li`00`6O6n01W`0QLi`00a_P0ImcW002Li`01@6OLiacW7>L6n000W>L00<1Wg>LLi`0NG>L
0G=i0012Li`30Il5Li`40Il00g>L0Il1W`020Il3Li`00`6OLiacW00KLi`00a_P0ImcW003Li`00a_P
0ImcW002Li`00a_P0ImcW00OLi`30Il4Li`00a_P0Il1W`02Li`00`6OLiacW00OLi`00a_P0ImcW003
Li`00a_P0Il1W`02Li`00a_PLiacW00KLi`20Il7Li`00a_P0IlKh0030Il00g>L6n01W`0JLi`00a_P
0Il1W`03Li`00a_P0Il1W`06Li`01A_PLiacW7>L0Il0NW>L0G=i0012Li`00`6OLiacW0030Il4Li`0
0a_P0Il1W`03Li`20Il2Li`00`6OLiacW00KLi`00a_P0Il1W`08Li`00a_P0ImcW00PLi`00a_P0Il1
W`04Li`00`6OLi`1W`020IlQLi`00a_P0ImcW006Li`20Il00a_PLiacW00KLi`0106OLi`1W`6O1G>L
00<Kh06OLi`00W>L00D1Wg>LLiacW06O01UcW0036n01Wa_P0081W`=cW0036n01W`6O00AcW0036n1c
W7>L009cW0030ImcW7>L07McW05cN@00@W>L00<1Wg>LLi`00W>L00<Kh06O0Il00W>L00<Kh06O6n00
0P6O0g>L106O5W>L00<Kh06O0Il01G>L00<Kh06O0Il01W>L00<Kh06OLi`06W>L0Q_P1G>L00@1Wa_P
0Il1W`9cW0040ImcW7>LLi`20IlJLi`00a_P0Il1W`04Li`00`6O6n0Kh007Li`00`6OLiacW00KLi`0
1@6OLiacW7>L0Il017>L00<Kh06OLi`01W>L00<1Wg>LLi`05g>L00HKh06OLiacW1_P0Il4Li`00a_P
0ImcW002Li`00a_PLiacW002Li`00`6OLiacW01gLi`1LgT0049cW081W`=cW0036n01Wa_P00@1W`9c
W0036n01Wg>L00AcW0030ImcW7>L01AcW0036n01Wa_P0081W`EcW0036n01W`6O00AcW0036n01Wg>L
01YcW0046n1cW1_P6n03Li`0106OLiacW1_P0P6O17>L00<Kh06OLi`06G>L00<Kh06O6n000P6O0W>L
00<1Wg>LLi`00Q_P1G>L00<Kh06OLi`06W>L00<1Wg>LLi`00W>L00<Kh06O0Il00g>L00<1Wa_P6n00
1G>L00<1Wg>LLi`05g>L00<Kh06OLi`00W>L00<Kh06O0Il00W>L00<Kh06OLi`00W>L00<Kh7>LLi`0
0W>L00<1Wg>LLi`0Mg>L0G=i0014Li`40Il4Li`00a_P0ImcW002Li`00a_P0ImcW00JLi`01A_P0Imc
W7>L6n000P6O1G>L00<Kh06OLi`00W>L00<Kh06OLi`06W>L00@Kh7>LLiacW08Kh003Li`1Wg>L009c
W0046n01W`6O0Il2Li`00a_P0ImcW00ILi`01A_P0ImcW7>L6n000`6O17>L00<Kh7>LLi`00W>L00<K
h06OLi`06W>L0P6O0g>L00<Kh7>L6n00106O0W>L00<Kh7>LLi`00W>L00<1Wg>LLi`05g>L00<Kh06O
Li`017>L00<Kh06O0Il00P6O0g>L0Q_P0W>L00<Kh06OLi`0N7>L0G=i0016Li`00a_P0ImcW008Li`0
0a_P0ImcW00JLi`00a_P0ImcW003Li`00a_P0Il1W`03Li`00a_P0ImcW002Li`00a_P0ImcW002Li`0
0a_P0Il1W`0DLi`00a_PLiacW004Li`00a_P0Il1W`02Li`011_P0ImcW7>L106O0W>L0Q_P5G>L00<K
h7>L0Il017>L00<Kh06OLi`00g>L00<Kh7>LLi`00W>L00<Kh06OLi`00W>L0Q_P67>L0`6O00<Kh7>L
Li`00W>L00DKh06OLiacW1_P00AcW0030ImcW7>L01QcW0040IlKh1_P6n05Li`00a_P0ImcW004Li`0
11_PLi`Kh06O0Q_PMg>L0G=i0010Li`26n06Li`26n07Li`00a_P0Il1W`0JLi`00a_P0Il1W`05Li`0
1Q_P0Il1Wg>L6n01W`=cW0036n01W`6O009cW0046n01Wa_P0IlCLi`26n06Li`01P6O6n01W`6O6n01
W`AcW0066n01W`6OLi`Kh7>L0Q_P4g>L0Q_P00<1Wg>LLi`017>L0Q_P0W>L00<Kh7>LLi`00W>L00<K
h06O0Il00W>L00<Kh7>L6n006W>L00<1Wa_PLi`017>L00<Kh7>L6n0017>L0P6O0W>L0Q_P57>L00<1
Wg>LLi`00W>L00<Kh7>LLi`02W>L0Q_P0P6O00AcW1_P0Il1WbAcW0040ImcW7>LLi`20Il3Li`20Im5
Li`1LgT0041cW0046n1cW1_P6n06Li`26n05Li`00a_P0ImcW0030IlILi`00a_P0Il1W`05Li`011_P
0Il1W`6O0g>L0Q_P00QcW06O0IlKh06OLi`Kh06O57>L0Q_P17>L00@1Wg>LLi`Kh081W`AcW0056n01
Wg>L0IlKh003Li`00a_PLiacW00BLi`00`6O6n0Kh006Li`36n04Li`26n0017>L0Il1Wa_P0W>L00<K
h7>LLi`05g>L00@1Wg>L6n0Kh0AcW08Kh0AcW08Kh081W`036n1cW1_P01=cW081W`=cW0036n1cW7>L
00]cW0036n1cW7>L00<1W`03Li`1W`6O019cW0046n01Wa_P6n04Li`50Il00g>L0Il1W`030Il00g>L
0Il1W`030Il017>L0Il1W`6O@g>L0G=i0010Li`011_PLiacW7>L0Q_P1W>L00<Kh7>LLi`00W>L00<K
h06OLi`00g>L00<1Wg>LLi`067>L00<Kh06O0Il01G>L00<Kh06OLi`017>L0a_P0P6O0W>L00<Kh06O
Li`057>L0Q_P00=cW06OLi`00g>L00@Kh06O0Il1W`=cW0040IlKh1_P0Il4Li`00a_PLiacW00ALi`0
0`6OLiacW0026n06Li`00a_PLiacW004Li`36n001@6OLiacW7>L6n0067>L00D1Wg>LLiacW1_P00Ac
W0036n1cW7>L00AcW08Kh081W`03Li`Kh7>L01=cW081W`03Li`Kh7>L011cW0036n01Wg>L009cW003
0ImcW7>L00mcW081W`036n1cW1_P00=cW081W`03Li`1Wg>L00<1W`07Li`1W`6O0ImcW06OLi`00P6O
0W>L0`6O@W>L0G=i0010Li`00a_PLiacW003Li`36n03Li`00a_PLiacW002Li`00a_P0ImcW002Li`0
0a_P0ImcW00KLi`00a_P0ImcW00=Li`01Q_P0ImcW7>L6n01WaMcW0036n01W`6O00AcW0030ImcW7>L
00@1W`9cW0036n01Wg>L009cW0036n1cW7>L011cW0030ImcW7>L00=cW0036n1cW7>L00ecW0056n01
W`6OLi`Kh00HLi`00`6OLiacW002Li`00a_PLiacW00:Li`011_PLi`1W`6O5W>L0P6O17>L0Q_P2g>L
0Q_P0g>L00<1Wg>LLi`03G>L11_P00<1Wg>L6n0017>L00<1Wg>L0Il00P6O0W>L106O00=cW06OLi`0
0`6O00=cW06O0Il00P6O@G>L0G=i0010Li`36n06Li`46n04Li`00a_P0Il1W`02Li`011_P0IlKh1_P
6W>L00<Kh06OLi`04G>L00<Kh06OLi`05W>L00<Kh7>LLi`00P6O0W>L00<1Wg>LLi`00g>L0P6O0W>L
00D1Wg>LLiacW1_P019cW081W`AcW0036n1cW7>L011cW081WaQcW081W`=cW0036n1cW7>L00icW003
0ImcW7>L01AcW0036n01Wg>L009cW0036n1cW1_P008Kh0AcW08Kh0AcW08Kh003Li`1W`6O00icW0@K
h0050ImcW1_PLi`Kh002Li`00`6OLi`1W`0=0Il00g>L0ImcW003Li`00`6OLiacW00nLi`1LgT004=c
W0<Kh0IcW0036n1cW7>L00AcW0036n01W`6O0081W`9cW0036n1cW7>L01McW0036n01Wg>L015cW003
6n01W`6O01IcW0036n1cW7>L009cW0<1W`McW0<1W`=cW08Kh1=cW081W`9cW0036n1cW7>L015cW003
6n01Wg>L01QcW0<1W`AcW08Kh0]cW0030IlKh1_P01EcW0030IlKh1_P008Kh0AcW0066n1cW7>LLi`K
h7>L0Q_P17>L00@Kh7>LLi`1W`mcW0036n1cW06O009cW0046n1cW1_PLi`40Il3Li`20Il01G>L0Imc
W06OLi`0106O0W>L0`6O@7>L0G=i0016Li`00a_PLiacW00=Li`01A_P0ImcW7>L6n0067>L00<Kh06O
Li`017>L00<Kh06O0Il027>L0P6O0g>L00@Kh06O0Il1Wa=cW0036n1cW7>L00=cW0036n01Wa_P00Qc
W0030ImcW7>L00=cW08Kh1=cW081W`IcW08Kh0ecW0040IlKh1_P6n0HLi`00a_P0Il1W`02Li`00a_P
Li`Kh0026n04Li`26n03Li`00`6OLi`Kh00CLi`00`6OLiacW002Li`00a_P0Il1W`02Li`01A_PLiac
W7>L6n000g>L0Q_P0W>L00DKh7>LLiacW06O00icW0036n1cW1_P00@1W`8Kh09cW0030ImcW06O00@1
W`04Li`1W`6O0Il2Li`40Il017>L0Il1W`6O@7>L0G=i0016Li`00a_PLiacW00BLi`00a_PLiacW00E
Li`00a_P0Il1W`04Li`00a_P0IlKh0030Il4Li`00a_P0ImcW0020Il4Li`00a_P0ImcW00ALi`26n04
Li`00a_PLiacW0036n05Li`26n06Li`00a_PLiacW00ALi`00a_P0Il1W`04Li`00a_PLi`Kh0026n05
Li`26n03Li`01@6OLiacW7>L6n006G>L00@Kh06O0Il1W`AcW0066n1cW7>LLi`Kh7>L0Q_P00AcW06O
0IlKh1=cW081W`AcW0030ImcW06O0081W`=cW08Kh0AcW0<Kh0=cW0030ImcW7>L00acW0@Kh0030IlK
h06O0081W`036n1cW7>L00<1W`04Li`1Wg>LLi`60Il3Li`20Im2Li`1LgT004IcW0036n1cW7>L00=c
W08Kh0ecW0<Kh1McW0036n01W`6O009cW0036n01Wg>L009cW0036n01Wg>L009cW0036n01Wa_P008K
h0060ImcW7>LLi`Kh06O57>L0Q_P0W>L00<Kh7>LLi`00g>L00<Kh7>LLi`00W>L00@Kh7>L6n0Kh0Ac
W0036n1cW7>L01=cW0036n01W`6O009cW0036n1cW7>L009cW0036n1cW7>L009cW0036n1cW1_P008K
h005Li`1Wg>LLi`Kh00LLi`00a_P0ImcW002Li`01A_PLiacW7>L6n000g>L0a_P00<1Wg>LLi`04g>L
0P6O0W>L00H1Wg>LLiacW1_P0Il4Li`26n04Li`00a_PLiacW002Li`00`6OLiacW00>Li`00a_PLi`K
h0020Il01g>L0Il1Wg>L0ImcW06O009cW0<1W`AcW0030ImcW7>L04EcW05cN@00AW>L00<Kh7>LLi`0
0g>L00<Kh7>L6n000Q_P1G>L0Q_P1W>L0Q_P5g>L00@Kh06O0Il1W`AcW0036n01Wg>L009cW0036n01
Wg>L009cW0066n01W`6OLi`Kh06O5W>L0a_P1G>L00<Kh7>LLi`00W>L00@Kh7>LLiacW08Kh09cW003
6n1cW7>L01EcW0036n01W`6O00EcW0036n1cW7>L009cW0036n1cW7>L009cW0056n01Wg>LLi`Kh00M
Li`01@6OLiacW7>L6n000g>L00<Kh06O0Il017>L00<Kh06OLi`05G>L0`6O0g>L00<Kh06OLi`01G>L
00<Kh06O0Il01W>L00<1Wg>LLi`03W>L00<Kh7>L6n000Q_P0g>L0P6O1W>L00<1Wg>LLi`0BW>L0G=i
0016Li`36n03Li`00a_PLiacW002Li`00a_PLiacW002Li`00a_PLi`Kh0026n04Li`00a_PLiacW00G
Li`00a_P0ImcW003Li`00a_P0ImcW002Li`00a_P0Il1W`04Li`011_P0Il1W`6O67>L00<Kh7>LLi`0
0g>L00<Kh7>LLi`00W>L0Q_P17>L11_P67>L00<Kh06OLi`00g>L00<Kh7>LLi`00W>L00<Kh06O0Il0
0g>L00@1Wa_P6n0Kh1ecW0050ImcW7>LLi`Kh004Li`0106O6n01W`6O0g>L00<1Wg>LLi`05W>L00H1
Wg>LLiacW1_P0Il2Li`26n02Li`00a_P0ImcW0020Il4Li`00`6OLiacW00>Li`36n000g>L6n1cW003
Li`00`6OLiacW01ALi`1LgT004UcW0@Kh0AcW0036n1cW7>L009cW0036n1cW7>L009cW0<Kh003Li`K
h7>L01icW0036n01Wg>L00AcW0046n01W`6O0Il3Li`00a_P0ImcW00MLi`00a_PLiacW004Li`00a_P
LiacW004Li`00a_PLiacW00GLi`00`6OLiacW002Li`00a_PLiacW003Li`00`6O6n01W`030Il2Li`0
0a_PLiacW00KLi`01@6OLiacW7>L6n0017>L00@1Wg>LLi`Kh0@1WaacW0066n01Wg>LLi`Kh7>L0a_P
00@1Wg>LLiacW0<1W`03Li`1Wg>L06acW05cN@00C7>L00<Kh7>LLi`00W>L00<Kh7>LLi`00W>L0Q_P
1W>L0Q_P7g>L00<Kh06OLi`01W>L00<Kh7>L0Il08W>L00<Kh7>LLi`01G>L00<Kh7>LLi`07G>L00<1
Wg>LLi`00W>L00<Kh7>LLi`00g>L00H1Wg>LLi`Kh7>L0IlPLi`01@6OLiacW7>L6n000g>L00DKh06O
LiacW1_P00=cW0030ImcW7>L01YcW0056n01Wg>LLi`Kh004Li`00a_P0ImcW004Li`20Im]Li`1LgT0
055cW0036n1cW7>L00AcW0<Kh2AcW0036n01Wg>L00McW0036n01Wg>L025cW0036n1cW7>L00IcW003
6n1cW7>L01acW0030ImcW7>L009cW0036n1cW7>L00=cW0050ImcW7>LLi`Kh00QLi`01@6OLiacW7>L
6n000g>L00<Kh06O6n000Q_P8G>L00@1Wa_P6n0Kh0IcW081Wg9cW05cN@00DG>L00<Kh7>LLi`01g>L
00<Kh7>LLi`08G>L00<Kh06OLi`00W>L00<Kh06O0Il00W>L00<Kh06OLi`08G>L00<Kh7>LLi`00W>L
0Q_P0W>L00<Kh7>LLi`077>L0`6O0W>L00<Kh7>LLi`00W>L00<Kh06OLi`00W>L00<Kh7>LLi`07g>L
00D1Wg>LLiacW1_P0081W`03Li`Kh06O009cW0036n1cW7>L01mcW0040ImcW7>L6n08Li`00`6OLiac
W01_Li`1LgT0055cW0036n1cW7>L00McW0036n1cW7>L025cW0036n01Wg>L009cW0036n01Wa_P00@1
Wb9cW0036n1cW7>L009cW0036n1cW1_P00<Kh21cW0<1W`AcW0036n01Wa_P00<Kh25cW081W`=cW003
0IlKh06O0081WbAcW081W`YcW0030ImcW7>L06mcW05cN@00DG>L00<Kh7>LLi`00W>L11_P00=cW1_P
Li`08W>L00<Kh06O0Il00W>L00<Kh06OLi`00W>L00<Kh06OLi`08G>L00<Kh7>LLi`00W>L00<Kh7>L
Li`00W>L00<Kh7>LLi`087>L00<Kh06O0Il00W>L00<Kh06OLi`00W>L00<Kh7>LLi`08G>L106O0W>L
00<Kh06OLi`09G>L0P6O1G>L0`6O00=cW06OLi`0Kg>L0G=i001ALi`26n03Li`011_PLiacW7>L0Q_P
8g>L0Q_P00EcW06O0IlKh06O02McW08Kh0=cW0036n1cW7>L02EcW08Kh005Li`1W`6O6n01W`0ZLi`0
0`6OLiacW00ZLi`20Il3Li`00`6OLiacW0020Im`Li`1LgT005=cW0@Kh2YcW0<Kh081WbUcW0@Kh2Uc
W0<Kh081WeUcW0@1WgAcW05cN@00EW>L00<Kh7>LLi`0:g>L00<Kh06OLi`0:g>L00<Kh7>LLi`0:W>L
00<Kh06OLi`0Fg>L00<1Wg>LLi`0LW>L0G=i003oLibcLi`1LgT00?mcW;=cW05cN@00og>L/g>L0G=i
003oLibcLi`1LgT00?mcW;=cW05cN@00og>L/g>L0G=i003oLibcLi`1LgT00?mcW;=cW05cN@00og>L
/g>L0G=i003oLibcLi`1LgT00?mcW;=cW05cN@00og>L/g>L0G=i003oLibcLi`1LgT00?mcW;=cW05c
N@00MW>L0P6Oog>L>g>L0G=i001fLi`00`6OLi`1W`020IooLi`hLi`1LgT007IcW0030ImcW7>L009c
W0030ImcW7>L02]cW081WkAcW081We5cW05cN@00Ag>L00<Kh06O00000g>L0Q_P9W>L00<Kh06OLi`0
0W>L00<Kh06OLi`09G>L00<Kh06O00000g>L00@Kh06OLi`1WbAcW0036n01W`6O009cW08Kh2IcW003
6n01W`6O00=cW08Kh2IcW0036n01W`6O009cW08Kh2IcW0036n01W`6O00=cW0046n01Wg>L0Im@Li`1
LgT004McW0046n01Wa_P6n02Li`00a_PLi`Kh0026n0SLi`01a_P0IlKh1_PLi`Kh06O00<Kh2=cW003
6n01Wa_P0081W`03Li`Kh06O008Kh0030ImcW7>L025cW0036n01Wa_P0081W`036n1cW1_P008Kh2=c
W0036n01Wa_P0081W`03Li`Kh7>L00<Kh2=cW0036n01Wa_P0081W`036n1cW1_P008Kh2=cW0036n01
Wa_P0081W`03Li`Kh06O008Kh0030ImcW7>L04ecW05cN@00Ag>L00@Kh06OLiacW0<Kh0AcW0036n1c
W7>L021cW0046n01Wg>LLi`26n001@6OLiacW7>L6n008W>L00DKh06OLiacW1_P00<1W`=cW0030Imc
W7>L021cW0066n01Wg>LLi`Kh06O17>L00<Kh7>LLi`087>L00LKh06OLiacW1_P0IlKh004Li`00a_P
LiacW00PLi`01Q_P0ImcW7>L6n01W`AcW0036n1cW7>L021cW0056n01Wg>LLi`Kh0020Il4Li`20Im=
Li`1LgT004McW0036n01Wg>L00=cW0036n1cW7>L009cW0036n1cW7>L01mcW0036n01Wg>L00=cW003
6n01Wg>L009cW0036n1cW7>L021cW0036n01Wg>L00=cW0036n01Wg>L009cW0030ImcW7>L01mcW003
6n01Wg>L00=cW0036n01W`6O009cW0036n1cW7>L021cW0036n01Wg>L00=cW0030ImcW7>L009cW003
6n1cW7>L01mcW0036n01Wg>L00=cW0036n01Wg>L009cW0036n1cW7>L021cW0036n01Wg>L00=cW003
0ImcW7>L009cW0040ImcW06O0Im;Li`1LgT004McW0036n01Wg>L00QcW0036n1cW7>L01mcW0036n01
Wa_P00AcW0050ImcW7>LLi`Kh00MLi`20Il3Li`00a_P0Il1W`08Li`00a_P0ImcW00OLi`00a_P0IlK
h006Li`30IlRLi`00a_P0Il1W`03Li`00`6OLiacW002Li`00a_PLiacW00OLi`011_P0Il1W`6O0g>L
00D1Wg>LLiacW1_P029cW0036n01Wg>L00QcW0050ImcW7>LLi`1W`1:Li`1LgT0045cW0<Kh0AcW004
0IlKh1_P6n06Li`00a_PLiacW00ILi`36n04Li`00`6OLi`Kh0026n000g>L0ImcW002Li`00a_P0Il1
W`0JLi`00a_P0IlKh0020Il3Li`011_P0Il1W`6O1G>L00<Kh06OLi`06G>L0a_P17>L00<1Wg>L6n00
0Q_P1G>L00<Kh06OLi`06W>L0a_P1G>L00<Kh06O0Il00P6O17>L0P6O6W>L0a_P1W>L00<Kh06O0Il0
0P6O0g>L00<Kh06O0Il06G>L0a_P1G>L00@1Wa_P6n0Kh0IcW081W`=cW081WdQcW05cN@00@G>L00<K
h7>LLi`00a_P00=cW06OLi`00W>L00<Kh7>LLi`00g>L00<Kh7>LLi`06G>L00<Kh7>LLi`00a_P00=c
W06OLi`00g>L00<Kh06O0Il00W>L00<Kh06OLi`00P6O67>L00<Kh06OLi`00Q_P0P6O17>L00<Kh06O
Li`00g>L00<Kh06OLi`06G>L00<Kh7>LLi`00a_P00=cW06OLi`00g>L00<Kh06O0Il00W>L00<Kh06O
Li`06W>L00<Kh7>LLi`00a_P1G>L00<Kh06O0Il00g>L00@1Wg>L0Il1WaQcW0036n1cW7>L00<Kh0Ic
W0036n01W`6O009cW0036n01Wg>L0081WaMcW0036n1cW7>L00<Kh09cW0050ImcW7>LLi`Kh0020Il3
Li`0106OLi`1W`6O0g>L0P6OAW>L0G=i0011Li`00a_PLiacW003Li`00a_P0ImcW002Li`00a_PLiac
W003Li`00a_PLiacW00ILi`00a_PLiacW003Li`00a_P0Il1W`03Li`00a_PLiacW0020Il00a_P0Imc
W002Li`00`6OLiacW00ELi`00`6OLiacW003Li`00a_P0Il1W`02Li`00a_P0ImcW003Li`00a_P0Imc
W00ILi`00a_PLiacW003Li`00a_P0Il1W`03Li`00a_P0ImcW0020Il00a_P0ImcW00JLi`00a_PLiac
W003Li`00a_P0Il1W`02Li`00a_P0ImcW0020Il00g>L0ImcW002Li`00`6OLiacW00ELi`00a_PLiac
W003Li`00a_P0Il1W`03Li`00a_P0ImcW0020Il00a_P0ImcW002Li`00`6OLiacW00DLi`00a_PLiac
W003Li`26n020Il2Li`00a_P0ImcW0020Il00g>L0ImcW002Li`00`6OLiacW002Li`00`6OLiacW013
Li`1LgT0041cW0036n1cW7>L00EcW0050IlKh1_PLi`Kh005Li`011_PLiacW7>L0Q_P5W>L00<Kh06O
0Il01G>L00DKh06O0ImcW1_P00AcW081W`=cW0036n01W`6O01AcW0036n01W`6O00IcW0056n01W`6O
6n01W`04Li`01A_P0ImcW7>L6n000P6O57>L00<Kh7>LLi`01W>L00HKh06O0ImcW1_P0Il3Li`20Il3
Li`26n0ELi`00a_PLiacW005Li`01P6O6n01W`6O6n01W`=cW081W`=cW0036n01Wg>L01AcW0036n1c
W7>L00EcW0070IlKh06O0ImcW1_P0Il00g>L0P6O0g>L00<Kh06OLi`057>L00<Kh7>LLi`01G>L00H1
Wa_P0Il1Wa_P0Il3Li`20Il3Li`00a_P0ImcW002Li`00`6OLiacW013Li`1LgT0041cW0<Kh0EcW003
0ImcW7>L008Kh0EcW08Kh09cW0036n1cW1_P008Kh1=cW0036n01Wa_P0081W`EcW0036n01W`6O00Ac
W0036n01Wg>L009cW0036n1cW1_P0081Wa9cW0<Kh081W`IcW0036n01W`6O00AcW0076n01W`6OLi`K
h06O6n000`6O4G>L0a_P27>L00@Kh06O0Il1W`=cW0036n01W`6O009cW0046n1cW1_P6n0CLi`36n05
Li`0106OLiacW1_P0P6O17>L0P6O0W>L00<Kh06O6n000Q_P4W>L0a_P1G>L00@1Wg>LLi`Kh0<1W`=c
W0036n01W`6O009cW0046n01Wa_P6n0CLi`36n05Li`0106OLiacW1_P0P6O17>L0P6O0W>L00<Kh06O
6n000Q_P00<1Wg>LLi`0@g>L0G=i0013Li`36n000g>L0ImcW003Li`00a_PLiacW005Li`36n04Li`0
0a_PLiacW00ALi`0106OLi`Kh1_P0P6O1G>L00<Kh06OLi`017>L11_P0g>L00<Kh06O0Il04g>L0Q_P
0P6O1G>L00<Kh06OLi`01G>L00@Kh06O0Il1W`=cW0036n01Wg>L019cW0<Kh0McW0036n01Wg>L00=c
W0030IlKh06O0081W`=cW0036n1cW7>L01=cW0<Kh003Li`1Wg>L00=cW0036n01W`6O00=cW0030Imc
W06O00<1W`=cW0036n1cW7>L019cW0<Kh09cW0030ImcW7>L009cW0036n01W`6O00=cW0030IlKh06O
00<1W`9cW0036n1cW7>L01=cW0<Kh003Li`1Wg>L00=cW0036n01W`6O00=cW0030ImcW06O00<1W`=c
W0036n01Wg>L04=cW05cN@00AW>L00<Kh06OLi`03G>L00<Kh7>LLi`00W>L00<Kh7>LLi`047>L00<1
Wg>LLi`00g>L00<Kh06O0Il017>L00<1Wg>LLi`01W>L00DKh06O0ImcW1_P009cW081WaAcW0036n01
Wg>L00ecW0036n01Wg>L009cW0036n01Wg>L01EcW08Kh0]cW0060ImcW7>LLi`Kh06O0W>L00<Kh7>L
Li`05W>L00<Kh06O0Il017>L00H1Wg>L0Il1Wg>L0Il3Li`00a_P0ImcW002Li`00a_PLiacW00ELi`2
6n020Il4Li`01P6OLi`1W`6OLi`1W`=cW0056n01Wg>LLi`Kh00HLi`00a_P0Il1W`06Li`20Il00g>L
0ImcW002Li`00a_P0Il1W`02Li`00a_PLi`1W`020Im1Li`1LgT004IcW0036n01Wg>L019cW0036n1c
W7>L011cW0030ImcW7>L00=cW0036n1cW7>L0081W`9cW0030ImcW7>L00McW0040ImcW06O6n04Li`0
0`6OLiacW00ALi`00a_P0ImcW00BLi`00a_P0ImcW00FLi`00a_PLiacW009Li`00`6OLiacW002Li`0
106OLiacW1_P67>L00<Kh7>LLi`00P6O0W>L00@1Wg>LLiacW081W`QcW0036n1cW7>L01IcW0036n1c
W7>L0081W`9cW0040ImcW7>LLi`20Il7Li`00a_PLiacW00FLi`00a_PLiacW0020Il6Li`20Il4Li`0
1@6OLi`1W`6O6n0017>L00<1Wg>LLi`0?W>L0G=i0016Li`00a_P0ImcW00BLi`00a_PLiacW00@Li`2
0Il4Li`00a_PLiacW002Li`30Il9Li`0106OLiacW06O17>L00<1Wg>LLi`04G>L00<Kh06OLi`04W>L
00<Kh06OLi`05W>L00<Kh7>LLi`02G>L00<1Wg>LLi`00W>L00@1Wg>LLi`Kh1QcW0036n1cW7>L009c
W0<1W`AcW081W`McW0036n1cW7>L01IcW0036n1cW7>L009cW0<1W`AcW081W`IcW0036n1cW7>L01Ic
W0036n1cW7>L009cW081W`EcW081W`=cW0050ImcW7>LLi`1W`04Li`00`6OLiacW00nLi`1LgT004Ic
W0036n01Wg>L00=cW08Kh0ecW08Kh1=cW081W`03Li`Kh7>L00EcW0036n01Wg>L00QcW0040ImcW7>L
6n020Il2Li`00`6OLiacW00ALi`00a_P0ImcW003Li`011_P0Il1W`6O2g>L00<Kh06O0Il05G>L00<K
h7>LLi`017>L0Q_P17>L00<1Wg>LLi`00W>L00<1Wg>LLi`00Q_P5g>L00<Kh7>LLi`00g>L00<Kh06O
Li`00g>L00<1Wg>L0Il00P6O17>L0Q_P5W>L00<Kh7>LLi`017>L00<Kh06OLi`00g>L00<1Wg>L0Il0
0P6O0g>L0Q_P5g>L00<Kh7>LLi`00g>L00<Kh06OLi`00g>L00<1Wg>L0Il00`6O0g>L00<Kh06O0Il0
0W>L00<1Wg>LLi`0?W>L0G=i0016Li`00a_P0ImcW003Li`011_PLi`Kh1_P1g>L0Q_P17>L0Q_P4g>L
0P6O1W>L00@Kh7>L6n0Kh0IcW0036n01W`6O00=cW0036n01W`6O0081Wa9cW0036n01Wg>L00=cW004
6n01Wa_P6n030Il4Li`20Il4Li`00a_P0Il1W`0CLi`00a_PLiacW004Li`011_PLi`Kh1_P0W>L00H1
Wg>LLiacW1_P0Il4Li`36n0DLi`00a_PLiacW003Li`011_PLi`Kh1_P0W>L00H1Wg>LLiacW1_P0Il5
Li`26n0DLi`00a_PLiacW004Li`011_PLi`Kh1_P0W>L00H1Wg>LLiacW1_P0Il4Li`36n0DLi`00a_P
LiacW003Li`011_P0IlKh1_P0W>L00D1Wg>LLiacW1_P0081W`=cW0030IlKh06O0081Wd1cW05cN@00
AW>L00<Kh06O6n000g>L00@Kh7>LLiacW08Kh0EcW0046n1cW1_P6n04Li`00a_PLiacW00ALi`011_P
0Il1W`6O0g>L00HKh7>LLiacW1_PLi`20Il2Li`00a_PLi`Kh0030Il3Li`00a_P0ImcW00ALi`011_P
0Il1W`6O0W>L00@Kh06OLiacW08Kh003Li`1Wg>L009cW0030ImcW06O0081W`=cW0036n01Wg>L015c
W0<Kh0AcW0066n1cW7>LLi`Kh7>L0P6O0W>L00<Kh06O6n000Q_P17>L00<Kh7>LLi`04G>L0a_P0g>L
00@Kh7>LLiacW08Kh081W`9cW0036n01Wa_P008Kh0AcW0036n1cW7>L015cW0<Kh0AcW0066n1cW7>L
Li`Kh7>L0P6O0W>L00<Kh06O6n000Q_P17>L00<Kh7>LLi`04G>L0a_P0g>L00HKh06OLiacW1_PLi`2
0Il2Li`00a_P0IlKh0040Il2Li`00a_P0ImcW00oLi`1LgT004UcW0@Kh0EcW0036n1cW7>L009cW004
6n1cW7>LLi`26n02Li`00a_PLiacW00DLi`011_P0Il1W`6O1G>L00<Kh06OLi`00P6O00<Kh7>LLi`0
0W>L00DKh06OLiacW1_P01IcW0036n01W`6O0081W`AcW0036n01Wg>L009cW0050ImcW7>LLi`Kh002
0Il00g>L6n01W`0ELi`46n05Li`00a_PLiacW0020Il00a_P0ImcW002Li`01A_P0Il1Wg>L6n005W>L
11_P1G>L00HKh7>L0Il1Wa_P0Il3Li`26n02Li`00a_PLiacW00DLi`46n05Li`00a_PLiacW0020Il0
0a_P0ImcW002Li`26n02Li`00a_PLiacW00DLi`46n001@6OLiacW7>L6n000W>L0P6O00<Kh06OLi`0
0W>L00HKh06OLiacW1_P0Im0Li`1LgT004acW0036n1cW7>L00=cW0036n1cW7>L009cW0036n1cW7>L
00=cW0@Kh1QcW0036n01W`6O00=cW0036n01Wg>L009cW0030ImcW7>L00=cW0040IlKh1_P6n0ILi`0
0a_P0ImcW003Li`00a_P0ImcW002Li`00a_P0ImcW003Li`011_P0Il1W`6O67>L00<Kh7>LLi`00g>L
00<Kh7>LLi`00W>L0P6O17>L00@1Wa_P0Il1WaUcW0036n1cW7>L00=cW0046n1cW7>LLi`30Il4Li`3
6n0ILi`00a_PLiacW003Li`00a_PLiacW002Li`20Il5Li`36n0ILi`00a_P0Il1W`02Li`00a_PLiac
W002Li`30Il4Li`36n000`6OLiacW00nLi`1LgT0059cW0036n1cW7>L009cW08Kh0McW0036n1cW7>L
01UcW081W`03Li`Kh06O00=cW0036n01Wg>L00=cW0040ImcW7>L6n0OLi`00a_P0ImcW002Li`00a_P
0Il1W`06Li`00`6OLiacW00LLi`00a_PLiacW002Li`00a_P0Il1W`03Li`01@6OLiacW1_P0Il07W>L
00<Kh7>LLi`00W>L00<Kh06OLi`01G>L00<Kh7>LLi`07G>L00<Kh7>LLi`00W>L00<Kh06OLi`01W>L
00<Kh7>LLi`06W>L0P6O00<Kh7>LLi`00g>L00<Kh06OLi`01G>L00<Kh06OLi`0?g>L0G=i001BLi`0
0a_PLiacW004Li`26n0SLi`30Il4Li`01P6O6n0Kh1_PLi`1Wb9cW0036n01Wg>L00AcW0036n01W`6O
02=cW0036n1cW7>L00=cW0030IlKh06O00<1W`=cW0030ImcW7>L01acW0036n1cW7>L00AcW08Kh2Ac
W0036n1cW7>L00AcW0<Kh2=cW0030ImcW7>L00AcW0030IlKh1_P00EcW0030ImcW7>L03icW05cN@00
DW>L00<Kh7>LLi`01W>L00<Kh7>LLi`08G>L00<Kh06OLi`00g>L00H1Wg>LLiacW1_P0IlRLi`00a_P
0ImcW006Li`00a_P0ImcW00QLi`00a_PLiacW003Li`01P6OLiacW7>L6n01W`=cW0030ImcW7>L01ac
W0036n1cW7>L00IcW0036n1cW7>L025cW0036n1cW7>L00McW0036n1cW7>L021cW0046n01W`6O0Il3
Li`0106OLiacW1_P0P6O0W>L00<1Wg>LLi`0?W>L0G=i001BLi`00a_PLiacW006Li`00a_PLiacW00Q
Li`00a_PLiacW003Li`01P6OLiacW7>L6n01Wb9cW0036n01Wg>L00IcW0036n01Wg>L025cW0036n1c
W7>L00=cW0050ImcW7>LLi`Kh004Li`00`6OLiacW00LLi`00a_PLiacW006Li`00a_PLiacW00QLi`0
0a_PLiacW007Li`00a_PLiacW00PLi`011_PLiacW7>L106O0W>L00<Kh06OLi`0106O?g>L0G=i001B
Li`00a_PLiacW002Li`26n02Li`00a_PLiacW00QLi`00a_PLiacW002Li`00a_P0ImcW002Li`00a_P
0ImcW00QLi`00a_P0ImcW002Li`01Q_P0Il1Wg>L6n01Wb9cW0036n1cW7>L009cW0036n01W`6O009c
W0036n1cW7>L009cW0030ImcW7>L01acW0036n1cW7>L009cW08Kh09cW0036n1cW7>L025cW0036n1c
W7>L009cW08Kh0=cW0036n1cW7>L021cW0036n1cW7>L00=cW0066n01W`6OLi`Kh06O17>L00<1Wg>L
Li`0?G>L0G=i001BLi`00a_PLiacW002Li`00a_PLi`Kh0036n0RLi`00a_PLiacW002Li`00a_P0IlK
h0036n000`6OLiacW00PLi`00a_P0ImcW002Li`00a_P0IlKh0040IlQLi`00a_PLiacW002Li`00a_P
Li`Kh0030Il4Li`00`6OLiacW00KLi`00a_PLiacW003Li`00a_PLi`Kh0036n0RLi`00a_PLiacW002
Li`00a_PLi`Kh0036n0RLi`00a_PLiacW003Li`00a_PLi`Kh0040Im3Li`1LgT0059cW08Kh0=cW003
6n1cW7>L009cW0036n1cW7>L021cW08Kh0=cW0036n01Wg>L009cW0036n01Wg>L025cW0036n01W`6O
009cW0036n01Wg>L009cW0036n01Wg>L021cW08Kh0=cW0036n1cW7>L009cW0036n01W`6O009cW003
0ImcW7>L01]cW0<Kh0=cW0036n1cW7>L009cW0036n1cW7>L021cW08Kh0=cW0036n1cW7>L009cW003
6n1cW7>L021cW0<Kh0=cW0036n1cW7>L009cW0036n01Wg>L049cW05cN@00E7>L11_P:G>L11_P00<1
Wg>LLi`00W>L00<1Wg>LLi`08W>L00<Kh06O0Il00P6O:7>L11_P1g>L106O7g>L11_P:G>L11_P:W>L
11_PBG>L0G=i001GLi`00a_PLiacW00ZLi`00a_P0Il1W`03Li`00`6OLiacW00ULi`00a_P0ImcW00Z
Li`00a_PLiacW008Li`00`6OLiacW00PLi`00a_PLiacW00ZLi`00a_PLiacW00[Li`00a_PLiacW017
Li`1LgT008McW0@1WomcW2QcW05cN@00RW>L00<1Wg>LLi`0og>L9W>L0G=i003oLibcLi`1LgT00?mc
W;=cW05cN@00og>L/g>L0G=i003oLibcLi`1LgT00?mcW;=cW05cN@00og>L/g>L0G=i003oLibcLi`1
LgT00?mcW;=cW05cN@00og>L/g>L0G=i003oLibcLi`1LgT00?mcW;=cW05cN@00@g>L0P6Oog>LKW>L
0G=i0010Li`20Il017>L0ImcW06Oog>LKG>L0G=i0012Li`20Il2Li`00`6OLiacW03oLiaZLi`1LgT0
04=cW0040ImcW7>L0IlcLi`20IneLi`20ImoLi`1LgT004IcW0030ImcW7>L0081WbmcW0040ImcW06O
0IlULi`00`6O001cW002Li`26n1DLi`00`6OLiacW002Li`26n0/Li`0106OLi`1W`6OOG>L0G=i0016
Li`20Il017>L0ImcW06O;G>L00<1Wg>LLi`00W>L00<1Wg>LLi`08G>L00<Kh06O6n000g>L00@Kh7>L
6n0Kh55cW0036n01Wa_P00=cW0046n1cW1_P6n0ZLi`01@6OLiacW7>L0Il0O7>L0G=i0016Li`0106O
Li`1W`6O0W>L00<1Wg>LLi`09G>L0P000g>L00<1Wa_PLi`00W>L00<1Wg>LLi`08G>L00<Kh06OLi`0
11_P0g>L00<Kh7>LLi`0CW>L00<Kh06OLi`011_P0g>L00<Kh7>LLi`09W>L00<Kh06O0Il00g>L00<1
Wg>LLi`08W>L00@1W`00LiacW08Kh55cW05cN@00AW>L0P6O00EcW06OLiacW06O02McW0036n01W`6O
009cW0060ImcW1_P6n1cW06O8g>L00<Kh06OLi`00g>L00<Kh7>LLi`00W>L00<Kh7>LLi`0CG>L00<K
h06OLi`00g>L00<Kh7>LLi`00W>L00<Kh7>LLi`07g>L00@Kh06O0001W`9cW0036n01Wa_P0081W`03
Li`1Wg>L02=cW0060IlKh06OLi`Kh7>L0Q_PCg>L0G=i0018Li`01P6OLiacW7>L0ImcW081WbAcW003
6n01Wa_P00<1W`=cW0036n01Wg>L029cW0036n01Wg>L00QcW0036n1cW7>L04ecW0036n01Wg>L00Qc
W0036n1cW7>L01mcW0046n01Wa_P6n040Il2Li`00a_P0Il1W`0KLi`20Il7Li`01@6OLi`Kh06O6n00
0g>L0P6OCG>L0G=i0019Li`00`6OLiacW0030Il00g>L0ImcW00QLi`00a_P0ImcW003Li`01P6OLiac
W7>L6n01WaecW08Kh0EcW0030IlKh1_P00McW0036n1cW7>L04McW08Kh0IcW08Kh0McW0036n1cW7>L
01mcW0046n01Wg>LLi`36n020Il2Li`00a_P0Il1W`0JLi`0106OLi`1W`6O17>L00<Kh06OLi`00W>L
0P6O0W>L00@1Wg>L0Il1Wd]cW05cN@00C7>L00<1Wg>L0Il00W>L00<1Wg>LLi`07g>L00<Kh06O0Il0
1g>L00<Kh06OLi`00W>L0P6O67>L00@Kh7>L6n0Kh0=cW0040ImcW7>L6n06Li`00a_PLiacW00`Li`0
0`6O000Kh00DLi`011_PLi`Kh1_P1W>L00<Kh7>LLi`017>L00<Kh7>LLi`07g>L00<Kh06O0Il00g>L
00<Kh06OLi`00P6O00<Kh06OLi`00P6O5g>L00<1Wg>LLi`00W>L0P6O0W>L00<Kh06O0Il017>L0`6O
0g>L00<1Wg>LLi`0B7>L0G=i001<Li`00`6OLiacW002Li`0106OLiacW06O6G>L00<Kh06O0Il017>L
00@Kh06O0Il1W`AcW0036n01W`6O009cW0030ImcW06O01McW0046n1cW7>LLi`26n000g>L0ImcW002
Li`00a_PLiacW003Li`00a_PLiacW00`Li`20Il26n0CLi`011_PLiacW7>L0Q_P1G>L00<Kh7>LLi`0
0g>L00<Kh7>LLi`06G>L0Q_P1W>L00<Kh06O0Il00W>L00@1Wg>LLiacW081W`=cW081WaEcW081W`=c
W08Kh081W`9cW0036n01W`6O00AcW0050ImcW7>LLi`1W`1:Li`1LgT004ecW0040ImcW7>LLi`20Il0
0g>L0Il1W`0HLi`00a_P0IlKh0030Il4Li`00a_P0ImcW002Li`00a_PLiacW0030Il2Li`00`6OLiac
W00CLi`00a_PLiacW004Li`00a_P0ImcW002Li`00a_PLiacW003Li`011_PLiacW7>L0Q_P:7>L1@6O
0W>L00<1Wa_PLi`04G>L00<Kh7>LLi`017>L0Q_P0g>L00<Kh7>LLi`00g>L00@Kh7>LLiacW08Kh1Ic
W0046n1cW1_P6n06Li`011_P0Il1W`6O0g>L00<Kh06O0Il00W>L00<1Wg>L0Il00P6O57>L0P6O00=c
W1_PLi`00Q_P00<1Wg>LLi`00W>L00D1Wg>LLiacW1_P00=cW0030ImcW7>L04QcW05cN@00CW>L00D1
Wg>LLi`1Wg>L0081W`03Li`1Wg>L01EcW0036n01Wg>L00=cW0036n01W`6O009cW0036n01Wg>L009c
W0036n1cW7>L009cW0050ImcW7>LLi`1W`0DLi`26n06Li`01@6O6n0Kh7>L6n001G>L0Q_P0W>L00@K
h7>L6n0Kh2IcW0040ImcW06OLi`40Il46n0?Li`26n07Li`26n000g>L6n1cW004Li`26n02Li`011_P
Li`Kh1_P57>L00@Kh7>LLiacW08Kh0IcW0036n01W`6O009cW0036n01Wg>L00<1W`AcW0030ImcW7>L
01=cW0030ImcW7>L009cW0036n01W`6O009cW0050ImcW7>LLi`Kh002Li`00a_P0ImcW019Li`1LgT0
055cW0060ImcW7>L0ImcW06O5W>L00<Kh06O0Il01G>L00<Kh06O0Il00P6O0g>L0Q_P0W>L0Q_P0g>L
00<1Wg>LLi`057>L0Q_P17>L00<1Wg>LLi`00Q_P1g>L00<Kh7>L6n000g>L00<Kh7>LLi`087>L1P6O
00=cW06O0Il017>L0Q_P4G>L0Q_P1g>L0Q_P1g>L00<Kh7>L6n000g>L00<Kh7>LLi`047>L00<Kh7>L
Li`017>L0Q_P17>L00<Kh7>LLi`0106O0g>L0P6O0g>L00<1Wg>LLi`04g>L00<Kh06OLi`017>L00@K
h06O0Il1W`=cW08Kh003Li`Kh06O008Kh4QcW05cN@00DG>L0`6O0W>L00@1Wg>L6n0Kh1EcW0036n01
W`6O00EcW08Kh0030ImcW7>L00=cW0046n1cW1_PLi`26n000g>L0Il1W`0GLi`26n000g>L0ImcW003
Li`00a_PLiacW006Li`26n04Li`00a_PLiacW00MLi`30Il00g>L0Il1W`020Il017>L0Il1W`6O0Q_P
00=cW1_P6n000Q_P4G>L0Q_P1W>L00<Kh7>LLi`01W>L0Q_P17>L00<Kh7>LLi`03g>L0Q_P1g>L11_P
1G>L00<Kh06O0Il00W>L00<1Wg>L0Il00`6O5W>L00<1Wa_P6n001G>L00<Kh06OLi`017>L0Q_P00@1
Wg>LLi`Kh081WdEcW05cN@00E7>L00<1Wg>L0Il00Q_P00=cW1_PLi`05G>L00<Kh06O0Il017>L00<K
h7>LLi`01G>L0Q_P0g>L00<Kh7>LLi`00P6O5g>L00<Kh06OLi`03G>L00<Kh7>LLi`00W>L00<Kh7>L
Li`07G>L0`6O00EcW06O0ImcW06O00=cW0040IlKh1_PLi`46n0CLi`00a_PLiacW00=Li`00a_PLiac
W002Li`00a_PLiacW00ALi`36n07Li`00a_PLiacW004Li`00`6O6n01W`030Il2Li`00a_P0ImcW00E
Li`01@6OLiacW1_PLi`00P6O2G>L00PKh06O0ImcW1_P0ImcW06OA7>L0G=i001FLi`01@6OLi`Kh7>L
6n0067>L00<Kh06O0Il02g>L00DKh7>LLiacW1_P00AcW081WaEcW0036n01Wg>L019cW0036n1cW7>L
01UcW0L1W`03Li`1W`6O00McW0046n1cW1_P6n0ELi`00a_PLiacW00BLi`00a_PLiacW00DLi`26n0<
Li`01P6OLiacW7>L6n01W`9cW0036n1cW7>L01EcW0080ImcW7>LLi`Kh06OLi`1W`]cW0<1W`9cW003
0ImcW7>L045cW05cN@00EW>L0P6O0W>L00<Kh7>LLi`05W>L00<Kh7>LLi`00`6O37>L00<Kh06O0Il0
17>L00<1Wg>LLi`04W>L00<Kh06OLi`04W>L0Q_P5g>L106O00=cW06O0Il00W>L00@1Wg>L0Il1W`Qc
W08Kh003Li`Kh7>L01=cW0036n1cW7>L019cW08Kh1McW0036n1cW7>L00UcW081W`=cW0040ImcW7>L
6n0GLi`20Il2Li`01A_P0ImcW7>L0Il02g>L00DKh06OLiacW06O04=cW05cN@00Dg>L0Q_P0W>L00@K
h06OLi`Kh1McW0036n1cW7>L00=cW0036n01Wg>L00YcW0036n01Wa_P0081W`=cW0030ImcW7>L015c
W0036n01Wg>L00=cW0<Kh0icW08Kh1EcW081W`06Li`1Wg>L0ImcW06O1G>L00<1Wg>LLi`07G>L00<K
h7>LLi`00g>L0a_P3W>L0Q_P5G>L00<Kh7>LLi`02g>L0P6O00AcW06OLiacW08Kh1QcW0@1W`9cW003
6n01Wg>L00]cW08Kh0030ImcW7>L045cW05cN@00Dg>L00<Kh7>L6n000W>L00@Kh7>L6n1cW08Kh1Ac
W08Kh0AcW0036n01Wa_P008Kh0AcW08Kh0=cW0040ImcW1_P6n020Il00g>L0ImcW00BLi`00a_P0Imc
W003Li`00a_PLiacW0036n05Li`26n06Li`00a_PLiacW00>Li`40Il2Li`01P6OLiacW06OLi`1WbEc
W08Kh0AcW0036n1cW7>L00<Kh0AcW08Kh0McW0036n1cW7>L019cW0036n1cW7>L009cW0<Kh0QcW081
W`AcW0<Kh1McW0066n01Wg>LLi`Kh06O0a_P0g>L00<Kh06O0Il01G>L00<Kh06OLi`0@G>L0G=i001C
Li`00a_PLiacW0036n001W>L6n0Kh1_PLi`Kh1EcW08Kh09cW0036n01Wg>L009cW0066n01W`6OLi`K
h7>L0a_P00@1Wg>LLi`Kh09cW0<1WaAcW08Kh09cW0036n1cW7>L00=cW0036n1cW7>L009cW0046n1c
W1_P6n04Li`00a_PLiacW00;Li`20Il00g>L0ImcW0050Il2Li`30IlWLi`26n02Li`00a_PLiacW003
Li`01Q_PLiacW7>L6n1cW0<Kh0AcW0036n1cW7>L015cW0036n1cW7>L00=cW0036n1cW7>L00<Kh0Ec
W0036n01Wg>L00IcW0036n1cW7>L01IcW0<Kh0050ImcW7>LLi`Kh002Li`00a_P0IlKh0020Il3Li`0
11_PLi`1W`6O@7>L0G=i001CLi`36n02Li`011_PLiacW7>L0Q_P00=cW1_PLi`05G>L0a_P00L1Wg>L
LiacW1_P0ImcW0020Il4Li`011_P0ImcW1_P17>L00<1Wg>LLi`057>L0a_P1G>L00<Kh7>LLi`00W>L
00@Kh7>LLiacW08Kh09cW0036n1cW7>L00ecW0060ImcW7>L0ImcW06O1W>L00<1Wg>LLi`09g>L0a_P
1G>L00<Kh7>LLi`00W>L00@Kh7>LLiacW08Kh09cW0036n1cW7>L015cW0<Kh0=cW0036n1cW7>L00=c
W0036n1cW7>L009cW0046n1cW1_P6n05Li`00a_PLiacW00HLi`00a_P0ImcW002Li`01A_PLiacW7>L
0Il00W>L00DKh06O0Il1Wa_P00=cW0030ImcW7>L03ecW05cN@00EW>L00<Kh7>LLi`017>L00<Kh7>L
6n0067>L00<Kh06O0Il00W>L00HKh06OLiacW1_P0Il5Li`20Il00a_PLiacW00JLi`00a_PLiacW003
Li`00a_PLiacW002Li`26n04Li`46n0ALi`00`6OLi`1W`0bLi`00a_PLiacW003Li`00a_PLiacW002
Li`26n04Li`36n0FLi`46n05Li`00a_PLiacW002Li`011_PLiacW7>L0Q_P0g>L00<Kh7>LLi`06G>L
00D1Wg>LLiacW1_P00=cW081W`=cW08Kh081W`9cW0030ImcW7>L03ecW05cN@00EW>L00<Kh7>LLi`0
1W>L0Q_P6W>L106O0g>L00@1Wa_P6n0Kh0AcW0030ImcW7>L021cW0036n1cW7>L00AcW08Kh0EcW003
6n1cW7>L00mcW0<1WcQcW0036n1cW7>L00AcW08Kh0AcW0036n1cW7>L01McW0036n1cW7>L00=cW003
6n1cW7>L009cW08Kh0AcW0@Kh1]cW0040ImcW7>LLi`20Il4Li`20Il3Li`00a_PLi`1W`020IloLi`1
LgT005IcW0036n1cW1_P008Kh09cW0056n1cW7>LLi`Kh00KLi`00a_P0ImcW002Li`01@6OLiacW7>L
6n000P6O00=cW06OLi`08G>L00<Kh7>LLi`01W>L00<Kh7>LLi`05W>L00<1Wg>LLi`0=W>L00<Kh7>L
Li`01W>L00<Kh7>LLi`08G>L00<Kh7>LLi`017>L0a_P17>L00<Kh7>LLi`06G>L00H1Wg>LLiacW06O
Li`20Il3Li`00a_P0ImcW005Li`00`6OLiacW00mLi`1LgT005IcW0<Kh09cW0046n1cW1_P6n02Li`0
0a_PLiacW00ILi`00a_PLiacW002Li`01`6OLiacW7>L6n01Wg>L00<1Wb5cW0036n1cW7>L00IcW003
6n1cW7>L04mcW0036n1cW7>L00IcW0036n1cW7>L025cW0036n1cW7>L00McW0036n1cW7>L01ecW081
W`9cW0040ImcW7>LLi`20Il00g>L6n01W`16Li`1LgT005QcW0076n1cW7>L6n1cW1_PLi`00a_P6g>L
00HKh7>LLiacW1_P0Il3Li`00a_P0ImcW002Li`00`6OLiacW00OLi`00a_PLiacW002Li`26n02Li`0
0a_PLiacW01?Li`00a_PLiacW002Li`26n02Li`00a_PLiacW00QLi`00a_PLiacW007Li`00a_PLiac
W00OLi`30Il3Li`26n030Im6Li`1LgT005]cW0046n1cW1_P6n02Li`00a_PLiacW00ILi`01Q_PLiac
W7>L6n01W`@Kh0030ImcW7>L02=cW0036n1cW7>L009cW0036n1cW1_P00<Kh4mcW0036n1cW7>L00=c
W0036n1cW1_P00<Kh29cW0036n1cW7>L009cW08Kh0=cW0036n1cW7>L025cW0050IlKh7>LLi`Kh002
Li`00a_P0ImcW015Li`1LgT005]cW0056n1cW7>LLi`Kh00MLi`36n000g>L6n01W`03Li`00a_P0Imc
W00TLi`00a_PLiacW002Li`00a_PLiacW002Li`00a_PLiacW01=Li`00a_PLiacW003Li`00a_PLiac
W002Li`00a_PLiacW00PLi`00a_PLiacW002Li`00a_PLi`Kh0036n0ULi`36n1:Li`1LgT005]cW005
6n1cW1_PLi`Kh00PLi`26n020Il3Li`00`6OLiacW00SLi`26n03Li`00a_PLiacW01BLi`36n03Li`0
0a_PLiacW00ULi`26n03Li`00a_PLiacW002Li`00a_PLiacW00ULi`00a_PLiacW018Li`1LgT005]c
W0036n1cW1_P008Kh2AcW0@1WbMcW0@Kh5McW0@Kh2UcW0@Kh7McW05cN@00G7>L0Q_P00=cW1_PLi`0
9W>L00<1Wg>LLi`0:7>L00<Kh7>LLi`0F7>L00<Kh7>LLi`0:W>L00<Kh7>LLi`0MG>L0G=i001MLi`0
0a_PLiacW03oLiaCLi`1LgT00?mcW;=cW05cN@00og>L/g>L0G=i003oLibcLi`1LgT00?mcW;=cW05c
N@00og>L/g>L0G=i003oLibcLi`1LgT00?mcW;=cW05cN@00og>L/g>L0G=i003oLibcLi`1LgT00?mc
W;=cW05cN@00og>L/g>L0G=i003oLibcLi`1LgT00:5cW081WomcW11cW05cN@00W7>L0P6O0g>L00@1
Wg>L0Il1WomcW0icW05cN@00W7>L00<1Wg>L0Il00`6O0g>L00<1Wg>LLi`0og>L2g>L0G=i002LLi`0
0`6OLiacW002Li`20Il3Li`20Il^Li`00`6OLiacW01HLi`20IlPLi`20ImMLi`1LgT004McW0036n01
W`0000=cW08Kh21cW081Wb]cW081W`EcW0050ImcW7>L0ImcW0020IlVLi`00a_P0Il1W`02Li`00a_P
0ImcW00OLi`20IlbLi`00a_P0Il1W`02Li`00a_P0ImcW0020IlNLi`00`6OLi`1W`1LLi`1LgT004Mc
W0036n01Wa_P0081W`03Li`Kh7>L00<Kh1ecW0040ImcW06O0IlYLi`0106OLi`1W`6O17>L0P6O17>L
00<1Wg>LLi`08g>L00<Kh06O6n000P6O00<Kh06O6n000Q_P7G>L00@1Wg>L0Il1Wc1cW0036n01Wa_P
0081W`036n01Wa_P008Kh0030ImcW7>L01YcW0050ImcW7>LLi`1W`1KLi`1LgT004McW0056n01Wg>L
Li`Kh0020Il4Li`00a_PLiacW00JLi`01@6OLiacW7>L0Il017>L00<Kh06O00000W>L0Q_P7G>L00D1
Wg>LLiacW06O00AcW0030ImcW7>L009cW0030ImcW7>L02=cW0056n01Wg>LLi`Kh0020Il3Li`00a_P
LiacW00JLi`0106OLiacW7>L0P6O17>L00DKh06O0ImcW1_P0081Wb=cW0056n01Wg>LLi`Kh0020Il3
Li`00a_P0ImcW00JLi`20Il3Li`20ImILi`1LgT004McW0036n01Wg>L00=cW0036n01W`6O009cW003
6n1cW7>L01YcW0030ImcW7>L009cW081W`9cW0036n01Wa_P0081W`046n1cW1_P6n0KLi`20Il3Li`0
0`6OLiacW005Li`00`6OLiacW00SLi`00a_P0ImcW003Li`00a_P0ImcW002Li`00a_PLiacW00JLi`0
0`6OLiacW003Li`20Il2Li`01a_P0IlKh06O6n01Wa_P0081Wb1cW0036n01Wg>L00=cW0036n01Wg>L
009cW0036n01Wg>L01acW081W`=cW081W`AcW0040Il007>LLi`20Im=Li`1LgT004McW0036n01W`6O
00AcW0030ImcW06O0081WaacW081W`EcW081W`066n01Wg>LLi`Kh06O0g>L00<Kh7>LLi`06W>L00@1
Wg>LLi`1W`McW0040Il007>LLi`26n0KLi`20Il3Li`011_P0Il1W`6O0g>L00D1Wg>LLiacW1_P01ac
W081W`IcW081W`046n01Wg>L6n020Il3Li`00`6OLiacW00MLi`011_P0Il1W`6O1g>L00<Kh06OLi`0
7W>L00<1Wg>LLi`00W>L0P6O0W>L00<1Wg>L0Il00P6O00=cW06O0Il0Bg>L0G=i0011Li`36n04Li`0
0`6O6n01W`030Il4Li`00a_P0ImcW00LLi`20Il5Li`20Il3Li`01A_P0ImcW7>L6n007G>L0P6O27>L
00L1Wg>L0ImcW1_PLi`Kh00ILi`36n020Il4Li`00a_P0Il1W`020Il3Li`00a_P0Il1W`0LLi`20Il6
Li`20Il2Li`00a_P0ImcW002Li`00`6OLiacW00GLi`36n06Li`011_P0Il1W`6O17>L00<Kh06OLi`0
7g>L00<1Wg>LLi`00g>L0`6O0W>L00HKh06OLiacW1_P0Im:Li`1LgT0045cW0036n1cW7>L00<Kh003
Li`1Wg>L009cW0036n01W`6O00=cW0036n01Wg>L01icW0030ImcW7>L009cW0036n01W`6O00IcW003
6n1cW7>L01acW0030ImcW7>L00IcW0050ImcW7>L0IlKh002Li`00a_PLiacW00FLi`00a_PLiacW002
6n020Il5Li`00a_P0Il1W`02Li`00a_P0ImcW0020IlLLi`00`6OLiacW003Li`00a_P0Il1W`06Li`0
0`6OLiacW00GLi`00a_PLiacW0036n06Li`00a_P0ImcW002Li`00a_P0ImcW00OLi`00`6OLiacW005
Li`01@6O6n1cW7>L6n000W>L00<Kh06OLi`0BG>L0G=i0011Li`00a_PLiacW003Li`00a_P0Il1W`02
Li`00a_P0ImcW0020Il00g>L6n01W`0OLi`00a_P0Il1W`04Li`011_P0Il1W`6O0g>L00<Kh7>LLi`0
77>L00<1Wg>LLi`01W>L0P6O0W>L00@1Wg>LLi`Kh1QcW0036n1cW7>L00=cW0036n01W`6O00=cW003
6n01Wg>L0081W`036n01Wg>L009cW0030ImcW7>L01UcW0036n01Wa_P00EcW0036n01W`6O00AcW003
0ImcW7>L01McW0036n1cW7>L00=cW08Kh0AcW0036n01Wg>L009cW0036n01Wg>L01icW0040ImcW7>L
Li`26n05Li`26n03Li`00a_P0ImcW019Li`1LgT0041cW0036n1cW7>L00IcW0056n01W`6O6n01W`03
Li`30Il2Li`26n0FLi`30Il2Li`00a_P0IlKh0030Il4Li`01A_P0ImcW7>L6n007W>L00<1Wg>LLi`0
0W>L0P6O0W>L0Q_P00<1Wg>L0Il00W>L00<Kh7>LLi`05G>L00<Kh7>LLi`01G>L00L1Wa_P0Il1Wg>L
6n01W`03Li`20Il3Li`00a_P0ImcW00ILi`00a_P0ImcW0036n04Li`00a_P0ImcW002Li`00`6OLiac
W00FLi`00a_PLiacW006Li`26n02Li`00a_P0ImcW002Li`00a_P0ImcW002Li`26n0JLi`20Il2Li`0
0a_PLi`Kh0026n04Li`01A_PLiacW1_P0Il0BW>L0G=i0010Li`36n08Li`00a_P0Il1W`04Li`01Q_P
0ImcW7>L6n1cW0<Kh1IcW0@1W`=cW0036n01W`6O009cW0056n01Wg>LLi`Kh00NLi`20Il2Li`011_P
0ImcW06O0g>L00<Kh06O0Il00W>L00<Kh7>LLi`05G>L0a_P1G>L00@1Wg>LLi`Kh0<1W`=cW0036n01
W`6O009cW0046n01Wa_P6n0HLi`00a_P0ImcW003Li`01@6O6n1cW7>L6n0017>L00<Kh06OLi`05W>L
0a_P27>L0a_P00D1Wg>LLiacW1_P0081W`9cW0046n1cW1_P6n0JLi`30Il4Li`26n02Li`01A_PLiac
W1_P0Il00W>L0Q_PAW>L0G=i0013Li`36n06Li`00a_P0Il1W`04Li`0106O6n0Kh1_P17>L00<Kh7>L
Li`05G>L00<Kh06OLi`017>L00DKh06O0IlKh06O009cW0046n1cW7>LLi`26n0KLi`20Il01A_P0IlK
h1_P0Il017>L00@1Wg>LLi`Kh1YcW0<Kh09cW0030ImcW7>L009cW0036n01W`6O00=cW0030IlKh06O
00<1W`9cW0036n1cW7>L01EcW0036n01W`6O00=cW0050ImcW1_PLi`Kh004Li`011_P0Il1Wg>L0Q_P
5W>L0a_P1g>L00<Kh06OLi`017>L00@Kh06O0Il1W`=cW0036n1cW7>L01UcW0036n01Wg>L00AcW0<K
h09cW0076n01Wg>LLi`Kh7>L6n00AG>L0G=i0016Li`00a_PLiacW006Li`20Il2Li`0106OLiacW1_P
17>L00<Kh7>LLi`05g>L0Q_P1G>L00<Kh06O0Il00W>L0Q_P0W>L00@Kh7>L6n0Kh1]cW081W`=cW081
W`9cW0050ImcW7>LLi`Kh002Li`26n0HLi`26n020Il4Li`01P6OLi`1W`6OLi`1W`=cW0056n01W`6O
Li`Kh00ILi`01A_P0Il1Wg>L0Il00W>L0Q_P17>L00HKh06OLi`1Wa_PLi`26n0GLi`26n06Li`00`6O
LiacW006Li`01A_P0ImcW7>L6n0077>L00@1Wa_P6n0Kh0AcW0056n1cW7>LLi`1W`036n02Li`00a_P
LiacW012Li`1LgT004IcW0036n1cW7>L00QcW0<1W`McW0036n1cW7>L01UcW0036n1cW7>L00=cW003
6n01Wg>L00=cW0<Kh0=cW0036n1cW7>L01QcW0036n01W`6O009cW0030ImcW06O0081W`=cW08Kh004
Li`Kh7>L6n0HLi`00a_PLiacW0020Il2Li`0106OLiacW7>L0P6O1W>L00<1Wa_PLi`06W>L00<Kh06O
0Il00g>L00<Kh7>LLi`00g>L00@1Wa_P6n01W`=cW0036n1cW7>L01EcW0036n1cW7>L00AcW0030Imc
W7>L00McW0040ImcW7>L6n0LLi`01@6OLiacW7>L6n001g>L00@1Wg>LLi`Kh09cW0036n1cW7>L049c
W05cN@00AW>L00<Kh7>LLi`02W>L00<1Wg>LLi`01G>L00<Kh7>LLi`06W>L00<Kh7>LLi`02W>L00DK
h7>LLiacW1_P01acW0046n01W`6O0Il3Li`00`6OLiacW003Li`26n02Li`00a_PLiacW00ELi`00a_P
LiacW002Li`30Il4Li`20Il6Li`00`6OLiacW00JLi`00a_P0ImcW008Li`01@6OLiacW1_P0Il00W>L
00<Kh7>LLi`05G>L00<Kh7>LLi`017>L00<1Wg>LLi`00W>L0P6O0g>L00@1Wg>LLi`Kh1acW0050Imc
W7>LLi`Kh007Li`20Il4Li`00a_PLiacW012Li`1LgT004IcW0036n1cW7>L00=cW08Kh0ecW08Kh1]c
W0036n1cW7>L00icW0036n1cW7>L01acW0036n01Wg>L00UcW0046n1cW7>L6n0FLi`00a_PLiacW004
Li`00a_P0ImcW003Li`00`6OLi`1W`020Il3Li`00a_P0ImcW00JLi`00a_P0ImcW008Li`01@6OLiac
W7>L0Il00W>L00<Kh7>LLi`057>L00<Kh7>LLi`017>L00<Kh06O0Il00g>L00<1Wg>L0Il00`6O0W>L
0Q_P6g>L00D1Wg>LLiacW1_P00=cW08Kh0AcW081W`9cW08Kh4=cW05cN@00AW>L00<Kh7>LLi`00g>L
00@Kh7>L6n0Kh0McW08Kh0AcW08Kh1UcW0036n1cW7>L009cW08Kh0YcW08Kh1ecW0036n1cW7>L00ec
W0036n1cW7>L01=cW0036n1cW7>L00AcW0046n1cW1_P6n02Li`01P6OLiacW7>L6n01W`AcW0<Kh1Qc
W0036n01Wg>L009cW0036n01W`6O00McW0030ImcW7>L008Kh1EcW0036n1cW7>L00AcW0036n1cW1_P
00@1W`=cW0036n01Wg>L00=cW0<Kh1QcW0040ImcW7>L6n04Li`00a_PLi`Kh004Li`00a_P0ImcW002
Li`00a_PLiacW010Li`1LgT004IcW0<Kh0=cW0046n1cW7>LLi`26n05Li`011_PLi`Kh1_P17>L00<K
h7>LLi`05W>L00<Kh7>LLi`00W>L00<Kh7>L6n001W>L0Q_P0g>L0Q_P6g>L00<Kh7>LLi`00W>L0Q_P
2G>L0Q_P57>L0a_P17>L00HKh7>LLiacW1_PLi`20Il2Li`00a_P0IlKh0026n04Li`00a_PLiacW00E
Li`00a_P0ImcW002Li`00a_PLi`Kh0030Il3Li`00a_P0Il1W`03Li`26n0CLi`36n04Li`01a_PLiac
W7>L6n1cW06O00=cW0036n1cW1_P008Kh0AcW0036n1cW7>L01EcW0030ImcW7>L008Kh0=cW0046n1c
W7>L6n03Li`00a_P0IlKh003Li`00a_PLiacW00oLi`1LgT004UcW0@Kh0EcW0036n1cW7>L009cW004
6n1cW7>LLi`26n02Li`00a_PLiacW00FLi`26n03Li`011_PLiacW1_P1G>L00@Kh7>L6n0Kh0=cW003
6n1cW7>L01QcW0036n1cW7>L009cW0036n1cW1_P00AcW08Kh0AcW0036n1cW7>L01AcW0@Kh0EcW003
6n01Wg>L0081W`036n01Wg>L009cW08Kh09cW0036n1cW7>L01EcW0036n01Wg>L009cW0066n1cW7>L
Li`Kh7>L0P6O00AcW1_PLi`Kh081W`=cW0036n1cW7>L01=cW0@Kh0EcW0036n1cW7>L009cW0036n1c
W7>L009cW08Kh09cW0036n1cW7>L01EcW0030ImcW7>L009cW0<Kh081W`03Li`Kh7>L009cW0036n01
Wg>L008Kh003Li`Kh7>L041cW05cN@00C7>L00<Kh7>LLi`00g>L00<Kh7>LLi`00W>L00<Kh7>LLi`0
0g>L11_P6G>L11_P0g>L00<Kh7>LLi`00W>L00@Kh7>LLiacW08Kh003Li`Kh7>L01UcW08Kh0=cW004
6n1cW7>L6n03Li`011_PLi`Kh1_P0g>L00<Kh7>LLi`05W>L00<Kh7>LLi`00g>L00<Kh06OLi`00W>L
0P6O1G>L0a_P67>L00<1Wa_P6n000Q_P17>L00DKh06OLi`1Wa_P00=cW0056n01Wg>LLi`Kh00HLi`0
0a_PLiacW003Li`00a_PLiacW002Li`00a_PLiacW004Li`36n0GLi`00`6OLiacW005Li`01@6OLi`1
W`6O6n000W>L00<Kh06O0Il00W>L0a_P@7>L0G=i001BLi`00a_PLiacW002Li`26n07Li`00a_PLiac
W00JLi`01A_PLiacW7>L6n0017>L00<Kh7>LLi`00g>L0Q_P77>L11_P0g>L00@Kh7>LLi`Kh0=cW08K
h003Li`Kh7>L01ecW0036n01Wg>L009cW0036n01Wg>L00IcW0036n1cW7>L01IcW0050ImcW7>LLi`K
h0020Il2Li`01A_P0ImcW7>L0Il017>L00@1Wa_P6n0Kh1icW0036n1cW7>L009cW08Kh0McW0036n1c
W7>L01AcW0030ImcW7>L009cW081W`9cW0040ImcW7>LLi`20Il3Li`00a_P0ImcW002Li`00a_PLiac
W00nLi`1LgT0059cW0036n1cW7>L00AcW08Kh2IcW0036n1cW7>L009cW08Kh0EcW0036n1cW7>L01ec
W0056n1cW7>LLi`Kh002Li`26n04Li`26n0NLi`00a_P0ImcW004Li`36n0MLi`00`6OLiacW002Li`0
0`6OLi`1W`030Il2Li`00a_P0Il1W`02Li`0106OLiacW1_P7W>L00<Kh7>LLi`017>L0a_P6g>L0P6O
0g>L00<1Wg>L0Il00P6O0g>L00@Kh7>L0Il1W`=cW0030ImcW7>L045cW05cN@00DW>L00<Kh7>LLi`0
1W>L00<Kh7>LLi`08g>L00<Kh7>LLi`017>L0Q_P9g>L00<Kh7>LLi`00W>L0Q_P0g>L00<Kh7>LLi`0
77>L00<Kh06OLi`01g>L00<Kh7>LLi`06W>L0P6O0g>L00H1Wg>LLiacW1_P0Il4Li`011_P0Il1W`6O
8G>L00<Kh7>LLi`01g>L00<Kh7>LLi`06W>L106O0g>L00D1Wg>LLiacW1_P009cW0056n01W`6OLi`1
W`13Li`1LgT0059cW0036n1cW7>L00IcW0036n1cW7>L02=cW0036n1cW7>L00IcW0036n1cW7>L02Ac
W0036n1cW7>L00AcW0036n1cW7>L01mcW0036n1cW7>L00McW0036n1cW7>L01acW0@1W`=cW0036n1c
W7>L00EcW0036n01Wg>L021cW0036n1cW7>L00McW0036n1cW7>L01ecW0030ImcW7>L00EcW0066n1c
W7>L6n1cW1_P0`6O@W>L0G=i001BLi`00a_PLiacW002Li`26n02Li`00a_PLiacW00SLi`00a_PLiac
W002Li`26n02Li`00a_PLiacW00TLi`00a_PLiacW004Li`00a_PLiacW00OLi`00a_PLiacW002Li`2
6n03Li`00a_PLiacW00OLi`01@6OLiacW7>L6n000g>L0Q_P0W>L00<Kh7>LLi`087>L00<Kh7>LLi`0
0W>L0Q_P0g>L00<Kh7>LLi`09G>L11_P0g>L00<Kh06OLi`0@G>L0G=i001BLi`00a_PLiacW002Li`0
0a_PLi`Kh0036n0TLi`00a_PLiacW002Li`00a_PLi`Kh0026n0VLi`011_PLiacW7>L0Q_P00=cW1_P
Li`087>L00<Kh7>LLi`00W>L00<Kh7>L6n000a_P9G>L00HKh7>LLiacW1_PLi`46n0QLi`00a_PLiac
W002Li`00a_PLi`Kh0036n0ZLi`00a_PLiacW015Li`1LgT0059cW08Kh0=cW0036n1cW7>L009cW003
6n1cW7>L029cW08Kh0=cW0056n1cW7>LLi`Kh00VLi`01Q_PLiacW7>L6n1cW08Kh25cW08Kh0=cW003
6n1cW7>L009cW0036n1cW7>L02=cW08Kh09cW0036n1cW7>L009cW0036n1cW7>L01mcW08Kh0=cW003
6n1cW7>L009cW0036n1cW7>L071cW05cN@00E7>L11_P:g>L11_P:W>L0Q_P0W>L00@Kh7>LLi`Kh2=c
W0@Kh2acW0<Kh2QcW0@Kh7McW05cN@00Eg>L00<Kh7>LLi`0;7>L00<Kh7>LLi`0:W>L0a_P:G>L00<K
h7>LLi`0;7>L00<Kh7>LLi`0:G>L00<Kh7>LLi`0MG>L0G=i002eLi`00a_PLiacW03jLi`1LgT00?mc
W;=cW05cN@00og>L/g>L0G=i003oLibcLi`1LgT00?mcW;=cW05cN@00og>L/g>L0G=i003oLibcLi`1
LgT00?mcW;=cW05cN@00og>L/g>L0G=i003oLibcLi`1LgT00?mcW;=cW05cN@00og>LEG>L0P6OG7>L
0G=i003oLiaELi`00`6OLi`1W`020ImILi`1LgT00:5cW081Wk5cW0030ImcW7>L009cW0030ImcW7>L
05IcW05cN@00XG>L00@1Wg>L0Il1WjmcW081W`=cW0030ImcW7>L05IcW05cN@00XG>L0P6O0W>L0P6O
[g>L106OF7>L0G=i001bLi`20Il_Li`20Il2Li`00`6OLiacW020Li`20003Li`00a_P0Il1W`0WLi`0
0`6OLiacW01FLi`1LgT004QcW0030Il007>L009cW0036n01W`6O01icW081W`AcW0030ImcW7>L02ic
W0040ImcW7>L0IlWLi`00`000Il1W`02Li`00a_P0Il1W`0VLi`20Il3Li`00a_P0Il1W`0TLi`00a_P
0Il1W`02Li`00a_P0IlKh0020IlULi`00`6OLiacW01FLi`1LgT004McW0036n01Wa_P0081W`04Li`K
h06O6n020IlLLi`0106OLi`1W`6O0g>L00@1Wg>LLiacW081Wb9cW081W`9cW081W`9cW0040ImcW7>L
0IlWLi`00a_P0ImcW0020Il00a_P0IlKh0020IlSLi`00a_P0IlKh0020Il01G>L6n01Wa_P0Il08g>L
00<Kh06O6n000`6O0W>L00<Kh7>L0Il097>L00<1Wg>LLi`00W>L0P6O0g>L0P6OCG>L0G=i0017Li`0
0a_P0ImcW0026n030Il2Li`00a_P0ImcW00JLi`0106OLiacW7>L0P6O0W>L0P6O00=cW06OLi`00P6O
87>L00<1Wg>L0Il00P6O00AcW06O0Il1W`9cW081WbIcW0036n01Wa_P008Kh081W`9cW0036n01Wg>L
025cW0036n01Wg>L008Kh081W`=cW0030ImcW7>L021cW0036n01Wg>L009cW0060ImcW7>LLi`Kh06O
97>L0P6O0g>L00L1Wg>L0Il1Wg>L0ImcW0020Im;Li`1LgT004McW0036n01Wg>L00=cW0036n01Wg>L
009cW0036n01Wg>L01UcW081W`AcW0040ImcW06OLi`20Il3Li`00`6OLiacW00LLi`00`6OLiacW002
Li`01@6OLiacW7>L0Il017>L0P6O8g>L00<Kh06OLi`00g>L00<Kh06O0Il00W>L00<Kh06OLi`087>L
00<Kh06OLi`00g>L00<1Wg>LLi`00W>L00<1Wg>LLi`06G>L0Q_P17>L00<Kh06O0Il01W>L00<Kh06O
Li`07G>L0`6O1G>L106O0g>L0P6O0g>L00<1Wg>LLi`0B7>L0G=i0017Li`00a_P0Il1W`08Li`00a_P
0ImcW00KLi`20Il3Li`20Il2Li`01@6OLiacW7>L0Il07W>L00<1Wg>LLi`03G>L00<1Wg>LLi`087>L
00<Kh06O0Il017>L00H1Wg>L0Il1Wa_P0IlQLi`00a_P0Il1W`08Li`00`6OLiacW00ILi`011_PLi`K
h1_P17>L00<Kh06O0Il017>L00<Kh06OLi`07G>L00<1Wg>LLi`00`6O17>L00<Kh06O0Il00g>L0P6O
0W>L00<1Wg>LLi`0B7>L0G=i0011Li`00a_P0Il1W`05Li`00a_P0Il1W`06Li`00a_P0ImcW00MLi`0
1@6OLiacW7>L0Il01W>L00<1Wg>LLi`077>L00<1Wg>LLi`03G>L00<1Wg>LLi`06W>L0Q_P1W>L00<K
h06O0Il00W>L00@1Wg>LLiacW081Wa]cW0036n01W`6O00EcW0036n01W`6O00IcW0030ImcW7>L01Uc
W0056n1cW7>LLi`Kh005Li`00a_P0ImcW002Li`00a_P0ImcW00MLi`00`6OLiacW002Li`00a_P0Il1
W`02Li`00a_P0IlKh0030Il2Li`30Im:Li`1LgT0045cW0036n01Wa_P0081W`EcW0036n01Wg>L00Ac
W0036n01Wg>L01ecW0030ImcW7>L00QcW0030ImcW7>L01acW081W`=cW0<1W`QcW081W`04Li`1W`6O
0IlGLi`011_PLi`Kh1_P1W>L00@Kh06O0Il1W`=cW0036n01W`6O01YcW0036n01Wa_P0081W`EcW003
6n01Wg>L00AcW0030ImcW7>L01UcW0036n1cW7>L009cW08Kh0=cW0036n01Wg>L009cW0036n01Wg>L
01ecW081W`=cW0036n01Wa_P00@1W`9cW0036n1cW06O00=cW0030ImcW7>L04QcW05cN@00@G>L00DK
h06OLiacW1_P0081W`AcW0036n01Wg>L00=cW0036n01Wg>L01acW0030ImcW7>L00UcW0030ImcW7>L
009cW08Kh1YcW081W`05Li`1Wg>LLi`1W`09Li`20Il2Li`00`6OLiacW00DLi`011_PLiacW7>L0Q_P
1W>L00<Kh06O0Il00W>L00<Kh06OLi`00`6O5g>L00DKh06OLiacW1_P0081W`AcW0036n01Wg>L00=c
W0030ImcW7>L01UcW0036n01W`6O00AcW0@Kh0050ImcW7>LLi`Kh0020Il00g>L6n0Kh00LLi`40Il4
Li`00a_P0ImcW002Li`00a_P0ImcW01=Li`1LgT0041cW0036n01Wg>L00AcW0036n01W`6O009cW003
6n01Wg>L00=cW0056n01Wg>LLi`Kh0020IlHLi`20Il:Li`0206OLi`Kh06OLi`Kh7>L6n0KLi`01@6O
LiacW7>L0Il02W>L00@1Wg>LLi`1WaEcW0036n1cW7>L00AcW08Kh0AcW0036n01Wg>L00@1W`=cW003
6n01Wg>L01AcW0036n01Wg>L00AcW0036n01W`6O009cW0036n01Wg>L00=cW0050ImcW7>LLi`Kh002
0IlFLi`00`6O6n01W`020Il4Li`00a_P0ImcW004Li`011_P0Il1Wg>L0Q_P77>L00<Kh06OLi`027>L
00<Kh06OLi`0CG>L0G=i0010Li`00a_P0Il1W`06Li`00a_P0Il1W`020Il4Li`01a_P0Il1Wg>L6n01
Wa_P0081WaIcW0030ImcW06O00UcW081W`046n01Wa_P6n02Li`00a_PLiacW00LLi`00`6OLiacW00;
Li`00`6OLiacW00CLi`26n07Li`26n02Li`00a_P0ImcW002Li`00a_P0Il1W`02Li`00a_P0IlKh00D
Li`00a_P0Il1W`06Li`00a_P0Il1W`020Il4Li`20Il2Li`00a_P0IlKh0020IlCLi`00`6OLiacW002
Li`00a_P0Il1W`03Li`00`6OLiacW005Li`01A_P0Il1Wg>L6n000`6O4W>L0Q_P1W>L0Q_P1g>L00<K
h06O0Il0CG>L0G=i0012Li`00a_P0Il1W`06Li`26n000`6OLiacW004Li`011_P0IlKh06O0W>L00<K
h06OLi`057>L00@1Wg>LLi`1W`YcW081W`05Li`Kh7>LLi`Kh00NLi`20Il8Li`01A_P0Il1Wg>L0Il0
5g>L0a_P1W>L0a_P0P6O0g>L00P1Wa_P0Il1Wa_P0ImcW1_P5G>L00<Kh06O0Il01W>L0Q_P00<1Wg>L
Li`017>L0P6O00HKh06OLiacW1_P0IlBLi`20Il3Li`00a_PLiacW0040Il:Li`30Il2Li`20Il@Li`0
11_PLi`Kh1_P1W>L0Q_P1G>L00<Kh06OLi`00`6OBW>L0G=i0014Li`00a_P0Il1W`05Li`00a_PLiac
W006Li`00a_P0Il1W`03Li`00a_P0ImcW00CLi`01@6OLiacW7>L0Il02G>L00<Kh06OLi`00g>L00<K
h7>LLi`07W>L0P6O0g>L00HKh06O0IlKh06O6n020IlJLi`26n06Li`00a_PLiacW0020Il01G>L0Imc
W7>L6n000P6O0W>L00<Kh7>LLi`057>L00<Kh06O0Il01G>L00<Kh7>LLi`01W>L00<Kh06O0Il00g>L
00<Kh06OLi`04W>L0P6O00=cW1_PLi`017>L00<1Wg>LLi`02G>L00<Kh06OLi`00W>L00<1Wg>LLi`0
3W>L00@Kh7>LLiacW08Kh0IcW0036n1cW7>L009cW0036n01Wg>L00=cW0030ImcW7>L04McW05cN@00
AW>L00<Kh06OLi`03G>L00<Kh06OLi`00W>L00<Kh06OLi`04g>L00D1Wg>LLiacW06O00IcW08Kh09c
W0030IlKh7>L009cW0036n1cW7>L021cW0060ImcW7>L6n01Wa_P0P6O0W>L00<1Wg>LLi`06W>L00<K
h7>LLi`027>L0P6O0g>L00DKh06OLiacW1_P01QcW0036n01Wg>L00ecW0036n01Wg>L009cW0036n01
Wg>L01AcW081W`AcW08Kh0]cW0<Kh09cW0030ImcW7>L00icW0036n1cW7>L00=cW0<Kh0=cW0036n1c
W7>L009cW0036n01Wg>L009cW0036n01Wa_P04QcW05cN@00AW>L00<Kh06OLi`04W>L00<Kh06OLi`0
5g>L00<1Wg>LLi`017>L00LKh7>L6n1cW06OLi`Kh002Li`00a_PLiacW00PLi`0106OLiacW1_P0P6O
00DKh06OLiacW1_P01acW0036n1cW7>L00UcW0030ImcW7>L00EcW0036n1cW7>L01IcW0036n01Wg>L
019cW0036n01Wg>L01EcW0036n01Wg>L009cW0036n1cW1_P008Kh0AcW08Kh0EcW08Kh081W`mcW0<K
h0IcW0@Kh0AcW0036n01W`6O0081W`036n01Wg>L008Kh4IcW05cN@00AW>L00<Kh06OLi`017>L0P6O
37>L00<Kh06O0Il05g>L00<1Wg>LLi`017>L00@Kh7>LLi`Kh081W`046n1cW7>L6n02Li`36n0MLi`2
0Il01G>L6n0Kh1_P0Il00g>L00<Kh7>LLi`06W>L00<Kh7>LLi`04G>L0Q_P5g>L00<Kh06OLi`017>L
0P6O37>L00<Kh06O0Il05W>L00<1Wa_P6n000Q_P17>L00HKh7>LLiacW1_PLi`26n001G>L0Il1Wg>L
6n000W>L00<1Wg>LLi`03g>L0a_P1W>L00<Kh7>LLi`017>L0a_P0P6O0W>L00<Kh7>LLi`0A7>L0G=i
0016Li`00a_P0ImcW003Li`00a_P0IlKh0020Il6Li`20Il4Li`00a_P0Il1W`0ELi`00`6OLiacW004
Li`20Il3Li`011_P0ImcW7>L11_P0W>L00<Kh7>LLi`06G>L0a_P0P6O0W>L00DKh06OLiacW1_P01]c
W0036n1cW7>L00AcW08Kh0QcW08Kh0AcW0<Kh1AcW0036n01Wg>L00=cW0036n01Wa_P0081W`EcW003
6n01W`6O00AcW0036n01W`6O01=cW0030ImcW7>L009cW0036n01W`6O009cW0056n1cW7>LLi`Kh003
Li`00a_P0IlKh0020Il3Li`00`6OLiacW00ALi`00a_PLiacW00=Li`00a_PLiacW002Li`00a_PLiac
W013Li`1LgT004IcW0036n01W`6O00=cW0036n01Wg>L008Kh081W`AcW0040ImcW06O0Il4Li`00a_P
0ImcW00CLi`0106OLiacW7>L0P6O00=cW06OLi`00P6O0W>L00<Kh06OLi`00g>L00@Kh7>LLi`Kh1]c
W0036n1cW7>L008Kh081W`056n01Wg>LLi`Kh002Li`36n0FLi`26n05Li`00a_PLi`Kh0026n05Li`0
11_PLi`Kh1_P1G>L00<Kh7>LLi`04G>L00<Kh06O0Il00g>L00<Kh06OLi`00Q_P00<1Wg>LLi`00W>L
00<Kh06O6n000P6O17>L00<Kh06OLi`04G>L0P6O17>L00<1Wg>L0Il00P6O0g>L0Q_P0g>L00@1Wg>L
6n0Kh081W`03Li`1Wg>L019cW0036n1cW7>L019cW08Kh4AcW05cN@00B7>L00HKh06O0ImcW1_P0Il4
Li`00a_P0ImcW002Li`01@6OLiacW1_P0Il00g>L00<Kh06OLi`04g>L0P6O0W>L00@1Wg>L0Il1W`9c
W0056n01W`6OLi`1W`07Li`00a_PLiacW00ILi`26n04Li`00a_P0Il1W`02Li`46n02Li`00a_PLiac
W00ELi`26n03Li`00a_PLiacW002Li`00a_PLiacW002Li`01A_PLiacW7>L6n0017>L00<Kh7>LLi`0
4g>L00HKh06O0ImcW1_P0Il4Li`01P6OLiacW7>L6n01W`9cW0036n01Wg>L009cW0036n01Wg>L01=c
W081W`9cW0050ImcW7>LLi`Kh0020Il3Li`26n000g>L0ImcW004Li`30IlBLi`00a_PLiacW003Li`2
6n0?Li`26n12Li`1LgT004YcW0046n01W`6O0Il4Li`00a_P0ImcW002Li`01A_P0ImcW7>L6n000P6O
00=cW1_P0Il05W>L0`6O0W>L0P6O00AcW1_PLiacW081W`McW08Kh1acW08Kh0=cW0036n01Wg>L00Ac
W0046n1cW7>L6n0ILi`36n05Li`00a_PLiacW002Li`00a_PLiacW002Li`26n02Li`00a_PLiacW00E
Li`011_P0Il1W`6O17>L00<1Wg>LLi`00W>L00DKh06OLiacW1_P0081W`03Li`Kh06O01IcW0<1W`=c
W0036n1cW7>L0081W`=cW0036n01Wg>L00IcW0030ImcW7>L011cW0036n1cW7>L00=cW0036n1cW1_P
008Kh0EcW08Kh0McW0036n1cW7>L03mcW05cN@00C7>L00<Kh06OLi`00g>L00<Kh06OLi`00W>L00<K
h06O0Il00g>L00@Kh06O0Il1WaQcW0030ImcW7>L009cW081W`9cW0036n01Wa_P00AcW0056n1cW7>L
Li`Kh00MLi`00a_PLiacW00:Li`00a_PLiacW00ILi`00a_PLiacW003Li`00a_PLiacW002Li`26n05
Li`36n0ILi`00a_P0ImcW003Li`00`6OLiacW002Li`00a_P0Il1W`03Li`011_P0Il1W`6O67>L00D1
Wg>LLiacW1_P00=cW0066n01Wg>LLi`Kh06O6W>L0Q_P17>L00<Kh7>LLi`00W>L00<Kh7>LLi`00W>L
00<Kh7>L6n000Q_P17>L00<Kh7>LLi`0?g>L0G=i001BLi`00a_P0ImcW004Li`00a_P0Il1W`04Li`0
0`6OLiacW00LLi`011_P0ImcW1_P0W>L0Q_P0W>L0Q_P0g>L00<Kh7>LLi`06W>L00@Kh7>LLiacW08K
h0McW0<Kh1mcW0036n1cW7>L00AcW0<Kh0AcW0036n1cW7>L01ecW0030ImcW7>L00AcW0036n01W`6O
00=cW0036n01Wg>L01]cW0066n1cW7>LLi`Kh06O0a_P00<1Wg>LLi`06W>L11_P1G>L00<Kh7>LLi`0
0W>L00<Kh7>LLi`00W>L0a_P00=cW1_PLi`0@7>L0G=i001BLi`00a_P0ImcW006Li`00a_P0ImcW00S
Li`36n02Li`01A_PLiacW1_PLi`00Q_P00=cW1_PLi`06g>L00LKh7>LLiacW1_PLi`Kh003Li`36n03
Li`00a_PLiacW00LLi`00a_PLiacW007Li`00a_PLiacW00QLi`00`6OLiacW006Li`00a_P0ImcW00O
Li`26n02Li`00a_P0ImcW002Li`00a_P0ImcW00MLi`00a_PLiacW003Li`00a_PLiacW002Li`26n06
Li`26n11Li`1LgT0059cW0036n01Wg>L00IcW0036n01Wg>L02EcW0046n1cW7>L6n02Li`26n02Li`2
6n0LLi`36n001G>L6n1cW7>L6n000W>L00<Kh7>LLi`011_P7W>L00<Kh7>LLi`01g>L00<Kh7>LLi`0
8G>L00<1Wg>LLi`01W>L00<Kh06OLi`08G>L0a_P00<1Wg>LLi`00g>L0P6O8W>L00<Kh7>LLi`017>L
0a_PAW>L0G=i001BLi`00a_P0ImcW002Li`01Q_P0Il1Wg>L6n01WbUcW0036n1cW7>L009cW0046n1c
W7>L6n0OLi`26n02Li`00a_PLiacW0026n04Li`00a_PLiacW00LLi`00a_PLiacW002Li`26n03Li`0
0a_PLiacW00QLi`00`6OLiacW002Li`01Q_P0Il1Wg>L6n01WbAcW0036n01Wg>L00IcW0030ImcW7>L
01mcW0036n1cW7>L00McW0036n1cW7>L04=cW05cN@00DW>L00<Kh06OLi`00W>L00<Kh06O6n00106O
:7>L00<Kh7>LLi`00g>L00<Kh7>LLi`08g>L00<Kh7>LLi`00W>L00<Kh7>LLi`087>L00<Kh7>LLi`0
0W>L00<Kh7>L6n000a_P8W>L00<Kh7>L0Il00g>L00<Kh06O6n00106O97>L00<1Wg>LLi`00W>L0P6O
00=cW06OLi`087>L00<Kh7>LLi`01g>L00<Kh7>LLi`0@g>L0G=i001BLi`00a_P0Il1W`02Li`00a_P
0ImcW002Li`00a_P0ImcW00WLi`00a_PLiacW0026n000g>L6n1cW00TLi`00a_PLiacW003Li`00a_P
LiacW00OLi`00a_PLiacW002Li`00a_PLiacW002Li`00a_PLiacW00PLi`011_PLi`1W`6O0W>L00<K
h06OLi`00W>L00<Kh06OLi`08g>L00<1Wg>LLi`00W>L00<1Wg>L0Il00P6O87>L00<Kh7>LLi`00W>L
11_P00=cW1_PLi`0A7>L0G=i001BLi`26n001G>L0Il1Wa_P0Il0;G>L00DKh7>LLi`Kh7>L008Kh2Ec
W0036n1cW7>L00@Kh25cW08Kh0=cW0036n1cW7>L02EcW0<Kh005Li`1W`6O6n01W`0YLi`20Il3Li`0
1@6OLiacW7>L0Il087>L0Q_P0g>L00@Kh7>LLiacW08Kh4EcW05cN@00E7>L0a_P0P6O;G>L11_P0W>L
00<Kh7>LLi`08g>L00@Kh7>LLi`Kh09cW08Kh29cW0@Kh2YcW0<Kh081Wb]cW0@1WbIcW0@Kh4YcW05c
N@00Eg>L00<Kh06OLi`0;g>L00<Kh7>LLi`09W>L0a_P00=cW1_PLi`09g>L00<Kh7>LLi`0:g>L00<K
h06OLi`0;G>L00<1Wg>LLi`09g>L00<Kh7>LLi`0B7>L0G=i002eLi`26n3kLi`1LgT00?mcW;=cW05c
N@00og>L/g>L0G=i003oLibcLi`1LgT00?mcW;=cW05cN@00og>L/g>L0G=i003oLibcLi`1LgT00?mc
W;=cW05cN@00og>L/g>L0G=i003oLibcLi`1LgT00?mcW;=cW05cN@00og>L/g>L0G=i003oLibcLi`1
LgT000UcW0D000IcW08000IcW0800004Li`000000003Li`30004Li`30003Li`2000017>L00000000
0W>L0`000W>L1000og>LL7>L0G=i000:Li`20008Li`20005Li`200001g>L00000000Li`007>L0080
009cW004001cW7>LLi`200000g>L001cW00200001g>L00000000Li`007>L00800004Li`007>L0002
Li`2003oLia_Li`1LgT000]cW08000QcW08000AcW080009cW0@00003Li`0000000=cW004001cW7>L
Li`20002Li`20002Li`40002Li`200000g>L00000002Li`2003oLia_Li`1LgT000]cW08000QcW080
00AcW08000=cW080009cW08000McW080009cW08000=cW08000=cW08000EcW0800?mcW6mcW05cN@00
2g>L0P000g>L00<007>LLi`00W>L0`0017>L0P000W>L0P000W>L0P001g>L0P000g>L0P000W>L0P00
0g>L0P0017>L0P00og>LL7>L0G=i000;Li`20003Li`00`00LiacW002Li`30004Li`20002Li`20003
Li`20002Li`20002Li`20003Li`20002Li`20003Li`20003Li`20002Li`00`00LiacW03oLia/Li`1
LgT000acW0H000AcW0<00004Li`007>LLi`2000017>L000000000g>L0P000W>L00@007>LLiacW080
00=cW0800004Li`000000003Li`20002Li`20002Li`00`00LiacW03oLia/Li`1LgT000acW08000=c
W004001cW7>LLi`300000g>L00000003Li`200000g>L00000004Li`30002Li`50003Li`200000g>L
00000003Li`20003Li`4003oLia^Li`1LgT000acW08000=cW003001cW7>L01YcW08000acW08008Ec
W003@Q00000000800005;F]cW7>LLia2400200000acWLiacW00300001W>L00000000Li`DY@EcW003
@Q00000000800003@Q1cW48@00@00003@Q1cW7>L0<=cW05cN@0037>L0P008G>L00<007>LLi`02W>L
0P00Q7>L00=24000@Q000g>L00UJeP00LiacW000@Q1cW3W>9BT00W>L00D007>LLiacW00000QcW009
001247>LLia24000Li`0048@009cW003@Q0007>L0<AcW05cN@003G>L0P0017>L00<007>LLi`09g>L
0P00Pg>L00<0048@Li`017>L00@007>LLi`000=cW004@Q1cW7>L0003Li`00`00LiacW006Li`00`00
LiacW002Li`00`00Li`00004Li`00`00LiacW033Li`1LgT000ecW08000AcW003001cW7>L02McW080
08=cW003001cW7>L00AcW004001cW7>L0006Li`01@00LiacW7>L000027>L00PLif<HLiacW5:D5:Ec
W00017>L00<007>LLi`0`g>L0G=i000;Li`9000XLi`30023Li`00`00LiacW003Li`300000g>L0000
00030002Li`01@00LiacW7>L00002G>L00@icT8@@Q0Li`9cW003001cW7>L009cW003001cW7>L0<=c
W05cN@00`W>L00<007>LLi`01g>L00D0048@Lia24000009cW005001247>L@Q000009Li`015[F0004
8E[F0W>L00<007>LLi`00W>L00<007>LLi`0`g>L0G=i0032Li`00`00LiacW007Li`01T8@00000000
@Q1cW0800004F]H<H`00@Q08Li`0248@5:ES67>L=Je247>L0004Li`00`00LiacW033Li`1LgT00<9c
W003001247>L00AcW00336=cW7>L01AcW003001cW7>L009cW003001cW00000AcW003001cW7>L0<=c
W05cN@00`W>L00=24000@Q000W>L00=S61cW00005W>L00T0048@LiacW48@001cW000@Q000W>L00=2
4000Li`0a7>L0G=i0033Li`01d8@000000005:D]J`0001IcW003@Q00000000800003@Q1cW48@00@0
0003@Q1cW7>L0<=cW05cN@00og>L/g>L0G=i003oLibcLi`1LgT00?mcW;=cW05cN@00og>L/g>L0G=i
003oLibcLi`1LgT00?mcW;=cW05cN@00og>L/g>L0G=i0000\
\>"],
  ImageRangeCache->{{{0, 434}, {268.625, 0}} -> {-0.0250052, -0.0257881, \
0.00241938, 0.00391464}, {{10.3125, 423.625}, {262, 6.5625}} -> {-1.33331, \
-0.271951, 0.0222766, 0.0222766}, {{59.8125, 101.188}, {256.375, 215.062}} -> \
{-0.266425, -0.326034, 0.0093427, 0.0252236}, {{105.312, 146.625}, {256.375, \
215.062}} -> {-0.900794, -0.330993, 0.0109386, 0.0249786}, {{150.812, \
192.125}, {256.375, 215.062}} -> {-1.3985, -0.330993, 0.0109386, 0.0249786}, \
{{196.25, 237.625}, {256.375, 215.062}} -> {-1.89587, -0.330993, 0.0109386, \
0.0249786}, {{241.75, 283.062}, {256.375, 215.062}} -> {-2.38401, -0.331032, \
0.0109037, 0.0249818}, {{287.25, 328.562}, {256.375, 215.062}} -> {-2.88013, \
-0.331032, 0.0109037, 0.0249818}, {{332.688, 374.062}, {256.375, 215.062}} -> \
{-3.61882, -0.326714, 0.0115874, 0.0246293}, {{59.8125, 101.188}, {210.938, \
169.562}} -> {-0.402098, -1.46378, 0.0109221, 0.0249409}, {{105.312, \
146.625}, {210.938, 169.562}} -> {-0.900794, -1.46674, 0.0109386, 0.0249786}, \
{{150.812, 192.125}, {210.938, 169.562}} -> {-1.3985, -1.46674, 0.0109386, \
0.0249786}, {{196.25, 237.625}, {210.938, 169.562}} -> {-1.89228, -1.46378, \
0.0109221, 0.0249409}, {{241.75, 283.062}, {210.938, 169.562}} -> {-2.39323, \
-1.46674, 0.0109386, 0.0249786}, {{287.25, 328.562}, {210.938, 169.562}} -> \
{-2.89094, -1.46674, 0.0109386, 0.0249786}, {{332.688, 374.062}, {210.938, \
169.562}} -> {-3.38247, -1.46378, 0.0109221, 0.0249409}, {{59.8125, 101.188}, \
{165.438, 124.062}} -> {-0.662608, -2.49163, 0.0140825, 0.0239043}, \
{{105.312, 146.625}, {165.438, 124.062}} -> {-0.89634, -2.6036, 0.0109037, \
0.0249818}, {{150.812, 192.125}, {165.438, 124.062}} -> {-1.3985, -2.60327, \
0.0109386, 0.0249786}, {{196.25, 237.625}, {165.438, 124.062}} -> {-1.79329, \
-2.61421, 0.0104757, 0.0250922}, {{241.75, 283.062}, {165.438, 124.062}} -> \
{-2.39323, -2.60327, 0.0109386, 0.0249786}, {{287.25, 328.562}, {165.438, \
124.062}} -> {-2.64359, -2.64021, 0.0101511, 0.0253365}, {{332.688, 374.062}, \
{165.438, 124.062}} -> {-3.78913, -2.54774, 0.0120668, 0.0244481}, {{59.8125, \
101.188}, {119.938, 78.625}} -> {-0.403428, -3.73902, 0.0109386, 0.0249786}, \
{{105.312, 146.625}, {119.938, 78.625}} -> {-0.978067, -3.6967, 0.0115432, \
0.024694}, {{150.812, 192.125}, {119.938, 78.625}} -> {-1.59723, -3.66563, \
0.012085, 0.024485}, {{196.25, 237.625}, {119.938, 78.625}} -> {-1.89587, \
-3.73902, 0.0109386, 0.0249786}, {{241.75, 283.062}, {119.938, 78.625}} -> \
{-2.55299, -3.6967, 0.0115432, 0.024694}, {{287.25, 328.562}, {119.938, \
78.625}} -> {-2.89094, -3.73902, 0.0109386, 0.0249786}, {{332.688, 374.062}, \
{119.938, 78.625}} -> {-3.56245, -3.70234, 0.0114288, 0.024732}, {{59.8125, \
101.188}, {74.4375, 33.125}} -> {-0.403428, -4.87554, 0.0109386, 0.0249786}, \
{{105.312, 146.625}, {74.4375, 33.125}} -> {-1.16592, -4.7241, 0.013012, \
0.0241987}, {{150.812, 192.125}, {74.4375, 33.125}} -> {-1.38439, -4.87698, \
0.010857, 0.024986}, {{196.25, 237.625}, {74.4375, 33.125}} -> {-1.89587, \
-4.87554, 0.0109386, 0.0249786}, {{241.75, 283.062}, {74.4375, 33.125}} -> \
{-2.39323, -4.87554, 0.0109386, 0.0249786}, {{287.25, 328.562}, {74.4375, \
33.125}} -> {-2.88013, -4.87616, 0.0109037, 0.0249818}, {{332.688, 374.062}, \
{74.4375, 33.125}} -> {-2.81581, -4.91516, 0.0093427, 0.0252236}}],

Cell[TextData[{
  ButtonBox["Evolution Overview",
    ButtonData:>"EvolutionOverview",
    ButtonStyle->"Hyperlink"],
  "  ",
  ButtonBox["Fitnesses",
    ButtonData:>"Fitnesses-Gen20",
    ButtonStyle->"Hyperlink"],
  "  ",
  ButtonBox["Min-Max-Average Fitnesses",
    ButtonData:>"MinMaxAverage-Fitnesses",
    ButtonStyle->"Hyperlink"],
  "  ",
  ButtonBox["The Champions",
    ButtonData:>"Champion-L-systems",
    ButtonStyle->"Hyperlink"],
  " \n\n",
  ButtonBox["Important Evolution Steps",
    ButtonData:>"EvolutionSteps",
    ButtonStyle->"Hyperlink"]
}], "Text",
  TextAlignment->Center],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Preparations ...",
  FontFamily->"Times"]], "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Basic directory"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "Note",
  StyleBox[": Evaluate the following cells to load the definitions needed to \
perform any calculations in this notebook.",
    FontWeight->"Plain"]
}], "Text",
  FontWeight->"Bold"],

Cell[TextData[{
  "For setting the ",
  StyleBox["Evolvica Directory",
    FontWeight->"Bold"],
  StyleBox[" ",
    FontSlant->"Italic"],
  "please refer to the ",
  ButtonBox["IEC Notebook",
    ButtonData:>{
      FrontEnd`FileName[ {"..", "..", "..", "IEC-Contents.nb"}], 
      "Setting EVOLVICA Directory"},
    ButtonStyle->"Hyperlink"],
  "."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \($basicDirectory = \
\[IndentingNewLine]SetDirectory[\[IndentingNewLine]ToFileName[{\
EvolvicaDirectory, "\<Chapters\>", \
\[IndentingNewLine]"\<10-LSystemInference\>", "\<FractalEvolution\>", \
"\<Packages\>"}]]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \("/Users/jacob/Desktop/EvolvicaNotebooks/EvolvicaNotebooks/Chapters/10-\
LSystemInference/FractalEvolution/Packages"\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["System Defaults"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData["Print a message whenever a new symbol is created:"], "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Off[General::newsym]", "Input",
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Imported Packages and Notebooks"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["General packages"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Needs[\"LinearAlgebra`CrossProduct`\"]", "Input",
  AspectRatioFixed->True],

Cell["Needs[\"DiscreteMath`Tree`\"];", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Needs[\"Graphics`Graphics`\"];", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Needs[\"Graphics`Shapes`\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Needs[\"Graphics`Graphics3D`\"];", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Special notebooks"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Get[\"kLSystems.m\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Get[\"TurtleInterpretation.m\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["General notebooks"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Get[\"ExprGeneration.m\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Get[\"ExprModification.m\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Expression Generation Templates", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Constants"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
numbers = Range[1,10];

constants = 
  Flatten[ numbers ];
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Patterns"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
patterns = 
{ 
  anExpression[], 
  anExpressionSequence[], 
  aBlank[],
  aSequence[],
  aNull[]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Parameters"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
maxSequenceLength = 5;

stepSize   := Random[Integer, {1,1}];
pitchAngle := Random[Integer,{90,90}];
yawAngle   := Random[Integer,{90,90}];
rollAngle  := Random[Integer,{90,90}];

aIndex     := Random[Integer,{0,4}];
iiIndex    := Random[Integer,{0,4}];
lIndex     := Random[Integer,{0,4}];
mIndex     := Random[Integer,{0,4}];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(lIndex\)\" is similar \
to existing symbol \"\!\(aIndex\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(mIndex\)\" is similar \
to existing symbols \!\({aIndex, lIndex}\)."\)], "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Templates", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Editable templates", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(doGenerateExprWithStart[_LSystem, \ IterationDepth\  -> \ 10, \ 
      MaxTrials -> 1]\)], "Input"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"-- startPattern: \"\>", "\[InvisibleSpace]", 
        TagBox[
          StyleBox[\(Blank[LSystem]\),
            ShowSpecialCharacters->False,
            ShowStringCharacters->True,
            NumberMarks->True],
          FullForm]}],
      SequenceForm[ "-- startPattern: ", 
        FullForm[ 
          Blank[ LSystem]]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("-- iterDepth: "\[InvisibleSpace]10\),
      SequenceForm[ "-- iterDepth: ", 10],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("possiblePositions = "\[InvisibleSpace]{{1}}\),
      SequenceForm[ "possiblePositions = ", {{1}}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("selected          = "\[InvisibleSpace]{1}\),
      SequenceForm[ "selected          = ", {1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("startExpr         = \
"\[InvisibleSpace]LSystem[_AXIOM, _LRULES]\),
      SequenceForm[ "startExpr         = ", 
        LSystem[ 
          Blank[ AXIOM], 
          Blank[ LRULES]]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("doFixedPoint ..."\)], "Print"],

Cell[BoxData[
    \("doFixedPoint ..."\)], "Print"],

Cell[BoxData[
    \("doFixedPoint ..."\)], "Print"],

Cell[BoxData[
    \("doFixedPoint ..."\)], "Print"],

Cell[BoxData[
    \("doFixedPoint ..."\)], "Print"],

Cell[BoxData[
    \("doFixedPoint ..."\)], "Print"],

Cell[BoxData[
    \("doFixedPoint ..."\)], "Print"],

Cell[BoxData[
    \(LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
      LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
          SUCC[SEQ[SEQ[FO[1], RR[90]], SEQ[SEQ[FO[1], RL[90]]], 
              SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], 
              SEQ[FO[1], RL[90]]]]]]]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
exprGenerationPATTERNSsole :=
{
  LSystem[_AXIOM,_LRULES],
  
  AXIOM[seq[_FO,_RL,_FO,_RL,_FO,_RL,_FO]],
  
 
  LRULES[
    LRule[
      LEFT[],
      _PRED,
      RIGHT[],
      _SUCC
    ]
  ],

  LRule[LEFT[],_PRED,RIGHT[],_SUCC],
  
  PRED[_FO ],
  (* SUCC[BlankSequence[Alternatives[_SEQ]] ], *)
  SUCC[_SEQ],
  
  SEQ[_FO, _RL],
  SEQ[_FO, _RR],
  SEQ[BlankSequence[_FO | _SEQ ]],
  
  STACK[BlankSequence[_FO | _RL | _RR ]],
  STACK[BlankSequence[_FO | _RL | _RR | _SEQ | _STACK ]],
  
  FO[stepSize],
  RL[rollAngle], 
  RR[rollAngle]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(seq\)\" is similar to \
existing symbol \"\!\(SEQ\)\"."\)], "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Template ranks"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprGenerationRANKS = (* selection probabilities *)
  Flatten[
    {
      {1,    (** LSystem **)
       1,    (** AXIOM **)
       1,    (** LRULES **)
       1,    (** LRule **)
       1,    (** PRED **)
       1,    (** SUCC **)
       
       2,    (** SEQ **)
       2,    (** SEQ **)
       1,    (** SEQ **)
       
       2,    (** STACK **)
       1,    (** STACK **)
       
       1,    (** FO **)
       1,    (** RL **)
       1     (** RR **)
    }, 

      Table[1,{Length[constants]}]       (* constants *)
      
      (* Table[1,{Length[patterns]}] *)      (* patterns *)
    },
    Infinity
  ];
  \
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["Templates collection ",
    FontFamily->"Times"],
  StyleBox["(do not edit ! )",
    FontFamily->"Times",
    FontSlant->"Italic"]
}], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprGenerationPATTERNS :=
  Flatten[
  Join[
    exprGenerationPATTERNSsole,
    {
     constants

     (* patterns *)
    }
  ]];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell["", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Expression Modification", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Expression template ranks"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[
"The hierarchical descriptions of ranked expressions are used by the genetic \
operators in order to find expressions for modification."], "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Mutation"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprMutationRANKS =
{
  PRexpr[_SEQ,4,{}]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
exprMutationRANKS::usage = 
\"The ranks used by the mutation operator\";\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Crossover"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprCrossoverRANKS = 
{
  PRexpr[_SEQ,4,{}]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
exprCrossoverRANKS::usage = 
\"The ranks used by the crossover operator\";\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Shrink"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprShrinkRANKS =
{
  PRexpr[SEQ[k__]/;Length[{k}] > 1,4,{}]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
exprShrinkRANKS::usage = 
\"The ranks used by the shrink operator\";\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Duplication"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprDuplicationRANKS =
{
  PRexpr[_SEQ,4,{}]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
exprDuplicationRANKS::usage = 
\"The ranks used by the duplication operator\";\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Permutation"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprPermutationRANKS =
{ 
  PRexpr[_SEQ,4,{}]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
exprPermutationRANKS::usage = 
\"The ranks used by the permutation operator\";\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Encapsulation"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprEncapsulationRANKS =
{
  PRexpr[_SEQ,4,{}]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
exprEncapsulationRANKS::usage = 
\"The ranks used by the encapsulation operator\";\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["GP operator ranks"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "gpOperatorRanksInitial =\n{\n  {REPRO,  0}, ",
  StyleBox["(* reproduction *)\n",
    FontSlant->"Italic"],
  "  (**{ELITIST,0},**) ",
  StyleBox["(* elitist reproduction *)",
    FontSlant->"Italic"],
  "\n  {MUTAT,  2}, ",
  StyleBox["(* mutation *)",
    FontSlant->"Italic"],
  "\n  {CROSS,  2}, ",
  StyleBox["(* crossover *)",
    FontSlant->"Italic"],
  "\n  {SHRINK, 1}, ",
  StyleBox["(* shrink *)\n  ",
    FontSlant->"Italic"],
  "{DUPL,   1}, ",
  StyleBox["(* duplication *)",
    FontSlant->"Italic"],
  "\n  {PERM,   1}, ",
  StyleBox["(* permutation *)",
    FontSlant->"Italic"],
  "\n  {ENCAPS, 0}  ",
  StyleBox["(* encapsulation *)",
    FontSlant->"Italic"],
  "\n};"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[TextData[{
  StyleBox["(* These ranks will be adjusted automatically ... *)",
    FontSlant->"Italic"],
  "\n\ngpOperatorRanks = Sort[gpOperatorRanksInitial];"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
gaOperatorAttributes := Map[Last[#]&,Sort[gpOperatorRanks]];
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["GP Evolution", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Evolution control"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Global symbols"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
population = {};
newPopulation = {};

generationsList = {};

populationHistory = {};
populationHistoryList = {};

populationFitnesses = {};

(* populationFitnessesList = {}; *) 
(* only needed for fitness histogram *)\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Control algorithm"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["From Generation to Generation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{\(createNextGeneration[initialPopulation_List, 
            fitnesses_List, generationIndex_Integer, opts___]\), ":=", 
          "\[IndentingNewLine]", 
          RowBox[{"Module", "[", "\[IndentingNewLine]", 
            
            RowBox[{\({currentGeneration = {}, \
\[IndentingNewLine]currentFitnesses = {}, \[IndentingNewLine]nextGeneration = \
{}, \[IndentingNewLine]members, maxMembers, 
                restMembers, \[IndentingNewLine]generationGap = \
\[IndentingNewLine]\(GenerationGap /. {opts}\) /. 
                    Options[createNextGeneration], 
                startPattern = \(StartPattern /. {opts}\) /. 
                    Options[
                      createNextGeneration], \
\[IndentingNewLine]gaOpAttributes \
:= \[IndentingNewLine]\(GeneticOperatorRanks /. {opts}\) /. 
                    Options[createNextGeneration], operatorCounter, 
                operatorIndex, operatorLabel, 
                operatorRanks = \(GeneticOperatorRanks /. {opts}\) /. 
                    Options[createNextGeneration]\[IndentingNewLine]}\), ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              
              StyleBox[\( (*\ Reset\ global\ population\ history\ list\ *) \),
                
                FontSlant->"Italic"], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              
              RowBox[{\(populationHistory = {}\), ";", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                
                StyleBox[\( (*\ \(--\(-\ 
                            Set\)\)\ current\ population\ and\ fitnesses\  \
... \ *) \),
                  FontSlant->"Italic"], "\[IndentingNewLine]", 
                "\[IndentingNewLine]", \(currentGeneration = 
                  initialPopulation\), ";", 
                "\[IndentingNewLine]", \(maxMembers = 
                  Length[currentGeneration]\), ";", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", \(members = 
                  Max[1, Floor[maxMembers*generationGap]]\), ";", 
                "\[IndentingNewLine]", \(restMembers = maxMembers - members\),
                 ";", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", \(currentFitnesses = fitnesses\), ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                
                StyleBox[\( (*\ \(--\(-\ 
                            Apply\)\)\ reproduction\ and\ genetic\ operators\ \
 ... \ *) \),
                  FontSlant->"Italic"], "\[IndentingNewLine]", 
                "\[IndentingNewLine]", \(operatorCounter = 0\), ";", 
                "\[IndentingNewLine]", 
                
                StyleBox[\( (*\ 
                    Elitist\ \(selection : \n\t\ \ \ always\ reproduce\ the\ \
best\ so\ far\ individual\)\n\t*) \),
                  FontSlant->"Italic"], 
                StyleBox["\n",
                  FontSlant->"Italic"], 
                "\[IndentingNewLine]", \(nextGeneration = \
\[IndentingNewLine]gpElitistReproduction[currentGeneration, currentFitnesses, 
                    nextGeneration]\), ";", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", \(operatorCounter += 1\), ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                
                StyleBox[\( (*\ \(--\(-\ 
                            Apply\)\)\ genetic\ operators\ till\ next\ \
population\ is\ completed\  ... \ *) \),
                  FontSlant->"Italic"], 
                StyleBox["\n",
                  FontSlant->"Italic"], 
                StyleBox["    ",
                  FontSlant->"Italic"], "\[IndentingNewLine]", 
                RowBox[{"While", "[", 
                  
                  RowBox[{\(operatorCounter < members\), ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    
                    StyleBox[\( (*\ 
                        select\ genetic\ operation\ \(probabilistically : \n\ \
\ \ \ \ \ \ \ \ \ \ \ \ reproduction\), \ mutation, \ 
                        crossover, \  ... \n\ \ \ \ \ \ *) \),
                      FontSlant->"Italic"], "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", \(operatorIndex = 
                      rouletteWheelSelectionAttributesOnly[
                        gaOpAttributes]; \[IndentingNewLine]\
\[IndentingNewLine]operatorLabel = 
                      First[gpOperatorRanks[\([operatorIndex]\)]]; \
\[IndentingNewLine]\[IndentingNewLine]protoPrint["\<Operator index: \>", 
                      operatorIndex]; \
\[IndentingNewLine]protoPrint["\<Operator label: \>", 
                      operatorLabel]; \
\[IndentingNewLine]\[IndentingNewLine]Switch[
                      operatorLabel, \[IndentingNewLine]ELITIST, \
\[IndentingNewLine]operatorCounter += 
                        0, \[IndentingNewLine]\[IndentingNewLine]REPRO, \
\[IndentingNewLine]nextGeneration = 
                        gpReproduction[
                          currentGeneration, \
\[IndentingNewLine]currentFitnesses, 
                          nextGeneration]; \ \
\[IndentingNewLine]operatorCounter += 
                        1, \[IndentingNewLine]\[IndentingNewLine]MUTAT, \
\[IndentingNewLine]nextGeneration = 
                        gpMutation[currentGeneration, currentFitnesses, 
                          nextGeneration]; \ \
\[IndentingNewLine]operatorCounter += 
                        1, \[IndentingNewLine]\[IndentingNewLine]CROSS, \
\[IndentingNewLine]nextGeneration = 
                        gpCrossover[currentGeneration, currentFitnesses, 
                          nextGeneration]; \ \
\[IndentingNewLine]operatorCounter += 
                        2, \[IndentingNewLine]\[IndentingNewLine]SHRINK, \
\[IndentingNewLine]nextGeneration = 
                        gpShrink[currentGeneration, currentFitnesses, 
                          nextGeneration]; \ \
\[IndentingNewLine]operatorCounter += 
                        1, \[IndentingNewLine]\[IndentingNewLine]DUPL, \
\[IndentingNewLine]nextGeneration = 
                        gpDuplication[currentGeneration, currentFitnesses, 
                          nextGeneration]; \ \
\[IndentingNewLine]operatorCounter += 
                        1, \[IndentingNewLine]\[IndentingNewLine]PERM, \
\[IndentingNewLine]nextGeneration = 
                        gpPermutation[currentGeneration, currentFitnesses, 
                          nextGeneration]; \ \
\[IndentingNewLine]operatorCounter += 
                        1, \[IndentingNewLine]\[IndentingNewLine]ENCAPS, \
\[IndentingNewLine]nextGeneration = 
                        gpEncapsulation[currentGeneration, currentFitnesses, 
                          nextGeneration]; \ \
\[IndentingNewLine]operatorCounter += 1\[IndentingNewLine]];\)}], " ", 
                  "\[IndentingNewLine]", \( (*end\ switch*) \), 
                  "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ";", 
                " ", \( (*end\ while\ operators*) \), "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                
                StyleBox[\( (*\ 
                    Fill\ up\ the\ rest\ with\ new\ expressions\ *) \),
                  FontSlant->"Italic"], 
                StyleBox["\n",
                  FontSlant->"Italic"], 
                StyleBox["    ",
                  FontSlant->"Italic"], 
                "\[IndentingNewLine]", \(If[
                  restMembers > 0, \[IndentingNewLine]nextGeneration = 
                    Join[nextGeneration, 
                      exprGeneration[restMembers, startPattern]]]\), ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                StyleBox[\( (*\ Return\ next\ generation\ *) \),
                  FontSlant->"Italic"], "\[IndentingNewLine]", 
                "\[IndentingNewLine]", "nextGeneration"}]}], 
            "\[IndentingNewLine]", "]"}]}], ";"}], " ", 
      "\[IndentingNewLine]", \( (*end\ \(module : 
            createNextGeneration\)*) \)}]], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(GenerationGap\)\" is \
similar to existing symbol \"\!\(generationGap\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(StartPattern\)\" is \
similar to existing symbol \"\!\(startPattern\)\"."\)], "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Options"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Options[createNextGeneration] =
{
  GeneticOperatorRanks :> gaOperatorAttributes,
  
  GenerationGap -> 1.0
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Interactive Evolution"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["Expression ",
    FontFamily->"Times"],
  StyleBox["generation",
    FontFamily->"Times",
    FontSlant->"Italic"]
}], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Function"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprGeneration[howManyIndividuals_Integer,startPattern_,opts___] :=

Module[{newGeneration = {}},
  
  newGeneration =
  Table[
    doGenerateExprWithStart[
      startPattern,
      opts
    ],
    {howManyIndividuals}
  ];
  
  resultInfo[
    \"Generated expressions:\",newGeneration,
      Formatter -> ColumnForm
    ];
    
  newGeneration
  
]; (* end module *)
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[exprGeneration] =
{
  GenerationPatterns -> exprGenerationPATTERNS,
  GenerationRanks -> exprGenerationRANKS
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["exprGeneration[1,_f]"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
{f[g[a | b | c] | a, h[c], k[3 | 3 | 1 | g[a | b | c]]]}\
\>", 
"\<\
{f[g[a | b | c] | a, h[c], k[3 | 3 | 1 | g[a | b | c]]]}\
\>"], "Output",\

  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["Expression ",
    FontFamily->"Times"],
  StyleBox["interpretation",
    FontFamily->"Times",
    FontSlant->"Italic"]
}], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Expression Evaluation Function", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[{
  "exprEvaluation[expr_, generation_, index_, opts___] :=\n  \
Module[{exprDecoded,exprFitness,d,l,\n          LSysExpr,\n          \
turtleGraphic,\n          lineCoordinates, forwards, rolls, yaws, pitches,\n  \
        maxXCoord,maxYCoord,maxZCoord},\n         \n     ",
  StyleBox["(** Convert all strings to expressions \n         and replace all \
encapsulated expressions\n         by their extended definitions **)",
    FontSlant->"Italic"],
  "\n     \n     LSysExpr = expr /. {x_/;StringQ[x] :> ToExpression[x]}\n     \
                //. encapsRulesList;\n     \n     ",
  StyleBox["(** Call expr. decoding ... **)\n     \n     ",
    FontSlant->"Italic"],
  "skipPattern = {Null};\n          ",
  StyleBox["\n     ",
    FontSlant->"Italic"],
  "exprDecoded = \n       runKLSystem[\n         LSysExpr,\n         \
LSystemIterations /. {opts} /. Options[exprEvaluation] ];\n         \n     \
(*Print[\"Decoded expr.: \",exprDecoded];*)\n     \n     ",
  StyleBox["(** Extract the number of flowers of the plant **)",
    FontSlant->"Italic"],
  "\n     \n     forwards = Count[Last[exprDecoded],_FO,Infinity];\n     \
rolls =    Count[Last[exprDecoded],_RL | _RR,Infinity];\n     yaws =     \
Count[Last[exprDecoded],_YL | _YR,Infinity];\n     pitches =  \
Count[Last[exprDecoded],_PU | _PD,Infinity];\n     \n     ",
  StyleBox["(** Call expr. interpretation here ... **)",
    FontSlant->"Italic"],
  "\n     \n     (*Print[\"exprDecoded: \",exprDecoded];*)\n     \n     \
turtleGraphic =\n     turtleInterpretation[\n       Last[exprDecoded] /. \
interpretTable,\n       GraphicOptions -> {AspectRatio -> 1,\n                \
          Axes -> False,\n                          Boxed -> False,\n         \
                 PlotRange -> All,\n                          DisplayFunction \
-> Identity\n                         }\n     ];\n     \n     \
(*AppendTo[globalTurtleGraphics,turtleGraphic];*)\n     \n     ",
  StyleBox["(** Calculate phenotype fitness ... **)",
    FontSlant->"Italic"],
  "\n     \n     \n     exprFitness =\n       \
compareLineGraphics[kochGraphic,turtleGraphic];\n       \n     \
AppendTo[globalTurtleGraphics,\n       Show[{turtleGraphic,kochGraphicMoved},\
\n         DisplayFunction -> Identity]];\n     \n     exprFitness\n  ];"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(forwards\)\" is similar \
to existing symbol \"\!\(forward\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(maxYCoord\)\" is \
similar to existing symbol \"\!\(maxXCoord\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(maxZCoord\)\" is \
similar to existing symbols \!\({maxXCoord, maxYCoord}\)."\)], "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Options"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Options[exprEvaluation] =
{
  decodingRules -> \"not yet implemented\",
  decodingFunction -> \"not yet implemented\",
  interpretationFunction -> \"not yet implemented\",
  LSystemIterations -> 1
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Turtle interpretation and graphics"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
interpretTable =
{ 
  AXIOM -> List,
  
  f -> FO[1.],
  l -> RL[90],
  r -> RR[90],
  
  seq -> SEQ
};
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
bloomGraphics[scale_] :=
GRAPHICS[Show[
  {
   Table[
     RotateShape[
       Graphics3D[Polygon[
         bloomPoly[{1,1,1}]]],
       n 72 Degree,0,0
     ],
     {n,0,4}
   ]
  } // Flatten,
  DisplayFunction -> Identity
],scale];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
bloomPoly[dir_] :=
Module[{bloomShape},

  bloomShape = {{0,0,0},{-3,4,0},{-4,6,0},
                {-4,7,0},{-3,8,0},{-2,8.5,0},{0,8,0}};
                
  Join[
    Map[Cross[dir,#] &,bloomShape],
    Map[Cross[dir,#] &,Map[{-1,1,1} #&,bloomShape]]
  ]
    
];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Reference graphics"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
kochLSystem =
LSystem[
  AXIOM[SEQ[f,l,f,l,f,l,f]],
  LRULES[
    LRule[
      LEFT[],
      PRED[f],
      RIGHT[],
      SUCC[SEQ[f,l,f,r,f,r,f,f,l,f,l,f,r,f]]]]];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
skipPattern = {L};

decodedKoch = runKLSystem[kochLSystem,1];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
kochGraphic =
turtleInterpretation[
       Last[decodedKoch] /. interpretTable,
       GraphicOptions -> {AspectRatio -> 1,
                          Axes -> False,
                          Boxed -> False,
                          PlotRange -> All,
                          DisplayFunction -> Identity
                         },
       DefaultDrawColor -> 0.1
     ];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
kochGraphicMoved =
turtleInterpretation[
       Last[decodedKoch] /. interpretTable,
       GraphicOptions -> {AspectRatio -> 1,
                          Axes -> False,
                          Boxed -> False,
                          PlotRange -> All,
                          DisplayFunction -> Identity
                         },
       DefaultDrawColor -> 0.3,
       StartPosition -> {0.9,1,0}
     ];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[
"Show[kochGraphicMoved,\n  DisplayFunction -> $DisplayFunction];"], "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0222419 0.95391 -0.0375432 1.1373 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.58674 .46823 m
.40237 .20964 L
s
P
p
.2 1 0 r
.02 w
.59434 .84699 m
.58674 .46823 L
s
P
p
.2 1 0 r
.02 w
.39299 .60739 m
.59434 .84699 L
s
P
p
.01 w
.40237 .20964 Mdot
P
p
.2 1 0 r
.02 w
.40237 .20964 m
.39299 .60739 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{126, 126},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40001n0000OPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP0007h0001n0000OP0007h0001n0000OP0007h0
001n0000OP0007h0001n0000OP0007h0001n0000OP0007h0001n0000OP0007h0001n0000OP0007h0
001n0000OP0007h0001n0000OP0003400YE;0000<@02UD/0000a00>EBP00034019E90000<@05UDP0
000a00:E00<0UID0B00003400YD0102EUIE70000<@02U@800iE60000<@02U@<00YE60000<@02U@<0
0iE50000<@02U@@00iE40000<@02U@D00iE30000<@02U@H00YE30000<@02U@H00iE20000<@02U@L0
0iE10000<@02U@P00YE10000<@02U@P00iE00000<@02U@T00iDo0000<@02U@X00iDn0000<@02U@/0
0YDn0000<@02U@/00iDm0000<@02U@`00iDl0000<@02U@d00YDl0000<@02U@d00iDk0000<@02U@h0
0iDj0000<003U@l00iDi0000<002UA400YDi0000<002UA400iDh0000<002UA800iDg0000<002UA<0
0YDg0000<002UA<00iDf0000<002UA@00iDe0000<002UAD00iDd0000<002UAH00YDd0000<002UAH0
0YDd0000<002UAH00YDd0000<002UAH00YDd0000<002UAH00YDd0000<002UAH00YDd0000<002UAH0
0YDd0000<002UAH00YDd0000<002UAH00YDd0000<002UAH00YDd0000<002UAH00YDd0000<002UAH0
0YDd0000<002UAH00YDd0000<002UAH00YDd0000<002UAH00YDd0000<002UAH00YDd0000<002UAH0
0YDd0000<002UAH00YDd0000<003UAD00YDd0000<@03UA@00YDd0000<P03UA<00YDd0000<`03UA80
0YDd0000=003UA400YDd0000=@02UA400iDc0000=@03UA400YDc0000=P03UA000YDc0000=`03U@l0
0YDc0000>003U@h00YDc0000>@03U@d00YDc0000>P02U@d00YDc0000>P03U@`00YDc0000>`03U@/0
0YDc0000?003U@X00YDc0000?@03U@T00YDc0000?P03U@P00YDc0000?`02U@P00YDc0000?`03U@L0
0YDc0000@003U@H00YDc0000@@03U@D00YDc0000@P03U@@00YDc0000@`03U@<00YDc0000A002U@<0
0YDc0000A003U@800YDc0000A@03U@0309FE03<0001600FE<`0004L019Dc0000B003UC<0001900:E
<`0007h0001n0000OP0007h0001n0000OP0007h0001n0000OP0007h0001n0000OP0007h0001n0000
OP0007h0001n0000OP000001\
\>"],
  ImageRangeCache->{{{0, 125}, {125, 0}} -> {-0.0233218, 0.0330064, 
  0.00838662, 0.00703427}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"Show[kochGraphicMoved,\n  DisplayFunction -> $DisplayFunction];"], "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.264482 1.61641 0.0246119 0.984475 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.76528 .58792 m
.69592 .5395 L
s
P
p
.2 1 0 r
.02 w
.77087 .66781 m
.76528 .58792 L
s
P
p
.2 1 0 r
.02 w
.69216 .46239 m
.62021 .40989 L
s
P
p
.2 1 0 r
.02 w
.69592 .5395 m
.69216 .46239 L
s
P
p
.2 1 0 r
.02 w
.69988 .62063 m
.77087 .66781 L
s
P
p
.2 1 0 r
.02 w
.62021 .40989 m
.62221 .48805 L
s
P
p
.2 1 0 r
.02 w
.54372 .27896 m
.46441 .21871 L
s
P
p
.2 1 0 r
.02 w
.54372 .35409 m
.54372 .27896 L
s
P
p
.2 1 0 r
.02 w
.62431 .57041 m
.69988 .62063 L
s
P
p
.2 1 0 r
.02 w
.62221 .48805 m
.54372 .43327 L
s
P
p
.2 1 0 r
.02 w
.54372 .43327 m
.54372 .35409 L
s
P
p
.2 1 0 r
.02 w
.46441 .21871 m
.46226 .29465 L
s
P
p
.2 1 0 r
.02 w
.70404 .70608 m
.62654 .65731 L
s
P
p
.2 1 0 r
.02 w
.70844 .79622 m
.70404 .70608 L
s
P
p
.2 1 0 r
.02 w
.62654 .65731 m
.62431 .57041 L
s
P
p
.2 1 0 r
.02 w
.46226 .29465 m
.37531 .23121 L
s
P
p
.2 1 0 r
.02 w
.62888 .74913 m
.70844 .79622 L
s
P
p
.2 1 0 r
.02 w
.45999 .37483 m
.45759 .4596 L
s
P
p
.2 1 0 r
.02 w
.37045 .31234 m
.45999 .37483 L
s
P
p
.01 w
.37531 .23121 Mdot
P
p
.2 1 0 r
.02 w
.37531 .23121 m
.37045 .31234 L
s
P
p
.2 1 0 r
.02 w
.63137 .84631 m
.62888 .74913 L
s
P
p
.2 1 0 r
.02 w
.54372 .60519 m
.54372 .69872 L
s
P
p
.2 1 0 r
.02 w
.45504 .54939 m
.54372 .60519 L
s
P
p
.2 1 0 r
.02 w
.45759 .4596 m
.36531 .39828 L
s
P
p
.2 1 0 r
.02 w
.54372 .79791 m
.63137 .84631 L
s
P
p
.2 1 0 r
.02 w
.54372 .69872 m
.54372 .79791 L
s
P
p
.2 1 0 r
.02 w
.45234 .64463 m
.45504 .54939 L
s
P
p
.2 1 0 r
.02 w
.36531 .39828 m
.26621 .33242 L
s
P
p
.2 1 0 r
.02 w
.35404 .58645 m
.45234 .64463 L
s
P
p
.2 1 0 r
.02 w
.35985 .48948 m
.35404 .58645 L
s
P
p
.2 1 0 r
.02 w
.25739 .42501 m
.35985 .48948 L
s
P
p
.2 1 0 r
.02 w
.26621 .33242 m
.25739 .42501 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{140, 141},
  ImageMargins->{{31, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002<0000S@P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP0008`0002<0000S00008`0002<0000S00008`0
002<0000S00008`0002<0000S00008`0002<0000S00008`0002<0000S00008`0002<0000S00008`0
002<0000S00008`0002<0000S00008`0002<0000S00008`0000o00>EBP0003l019E90000<`03U@T0
1IE80000<`04U@P00YD0102EUIE70000<`05U@L00YD200BEA@0003<00YD00`2EU@02U@D00YD300BE
A00003<00YD200BE1002U@D00iE30000<`02U@@00iD300:E1P03UD80000b00>E1@04U@0309FE00L0
0iE10000<P02U@L01YD800>E@00003800YD900BE2@02UD00000b00:E2P03U@T00YE00000<P02U@/0
0YD900:E@00003800iDE00:E@000038019DD00:E@00003@00iDC00:E@00002@00iD>00BE4@02UD00
000T00BE3P04UA000YE000009006U@h00iD?00:E@00002@00YD00`2EU@02U@h019D=00:E@00002<0
0iD300BE3@04U@`00YE000008`02U@D019D>00>E2`02UD00000S00:E1`03U@h00iD:00:E@00002<0
0YD800BE3@02U@X00YE000008`02U@T019D<00:E2P02UD00000S00:E2`04U@X00YD:00:E@00002<0
0YD<00BE2@02U@X00YE000008P03U@h019D700:E2P02U@T00iDd00008P02UA0019D600:E2P02U@T0
19Dc00008P03UA4019D400:E2P02U@T01YDa00008P05UA0019D300:E2P03U@P00YD00`2EU@02UC00
000T00BE4@03U@800YD:00BE1`02U@<00iD_00009P04UA001YD<00>E1P02U@@019D]00009`05U@l0
1ID=00BE1002U@D019D/0000:@04UA000iD>00BE0`02U@L00iD[0000:`04U@l00YD@00BE00<0UID0
2002UB/0000/00FE8006U@P00YD[0000;P04UB4019D800:E:`0003000iDQ00>E2002UB/0000a00:E
8P02U@P00YD[0000<@02UB`00YD[0000<@02UB`00YD[0000<@02UB`00YD[0000<@02UB`00YD[0000
<@02UB`00YD[0000<@02UB`00iDZ0000<003U@/00iDN00BE:@0003000YD<00BE7`04UBL0000`00:E
3006UAh019DV0000<002U@`00YD00`2EU@02UA000iD<00>E9@0003000YD<00:E0`04U@h019D<00BE
8`0003000YD<00:E1004U@d01YD;00BE8P0003000iD;00:E1P04U@/00YD00`2EU@03U@/00iDQ0000
<004U@X00YD700BE2P02U@<019D;00:E8@00038019D700>E2@03U@T00YD500BE2@02UB40000c00FE
1@02U@/00YD900:E1P04U@P00YDQ0000=@04U@@00YD;00:E2@03U@L019D600:E8@0003L019D200:E
2`02U@X00YD800BE1@02UB40000h00NE2`02U@X00YD:00BE0`03UB00000j00FE2`02U@X00YD;00BE
0`02UB00000l00>E2`02U@X00YD=00>E0P02UB00000m00:E2`02U@X00iD=00JE800004X00YD:00BE
3@05UB00001:00:E3004U@d00iDP0000BP02U@d019D=00:E800004X00YD?00>E;P0004X00YD@00BE
;00004X00YDA00BE:`0004X00YDC00>E:P0004X00YDD00:E:P0004X00YDD00:E:P0004X00YDD00:E
:P0004X00YDD00:E:P0004X00YDD00:E:P0004X00YD:00>E1`02UBX0001:00:E2P04U@H00iDY0000
BP02U@X01YD500:E:@0004X00YD:00:E00<0UID00iD300:E:@0004X00YD:00:E0`04U@800YDY0000
BP02U@X00YD500JE:@0004X00YD:00:E1P05UBT0001:00>E2@02U@P00iDY0000BP05U@L00YD900:E
:@0004`019D600:E=00004h019D400:E=00004l01ID200:E=000054019D00`2EU@0d0000D`05UC@0
001D00BE=00005H00YDd0000S00008`0002<0000S00008`0002<0000S00008`0002<0000S00008`0
002<0000S00008`0002<0000S00008`0002<0000S00008`00000\
\>"],
  ImageRangeCache->{{{0, 139}, {140, 0}} -> {0.16362, -0.028659, 0.0044508, 
  0.00730777}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"Show[kochGraphicMoved,\n  DisplayFunction -> $DisplayFunction];"], "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.475701 2.05017 0.0243041 0.972165 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
1 .6 0 r
2 Mabswid
.85091 .61052 m
.82964 .59913 L
s
P
p
1 .6 0 r
2 Mabswid
.85264 .62983 m
.85091 .61052 L
s
P
p
1 .6 0 r
2 Mabswid
.82804 .57997 m
.80658 .56836 L
s
P
p
1 .6 0 r
2 Mabswid
.82964 .59913 m
.82804 .57997 L
s
P
p
1 .6 0 r
2 Mabswid
.75909 .48791 m
.73709 .47561 L
s
P
p
1 .6 0 r
2 Mabswid
.7603 .5066 m
.75909 .48791 L
s
P
p
1 .6 0 r
2 Mabswid
.83126 .61851 m
.85264 .62983 L
s
P
p
1 .6 0 r
2 Mabswid
.73601 .45708 m
.71381 .44455 L
s
P
p
1 .6 0 r
2 Mabswid
.73709 .47561 m
.73601 .45708 L
s
P
p
1 .6 0 r
2 Mabswid
.80658 .56836 m
.80807 .58758 L
s
P
p
1 .6 0 r
2 Mabswid
.78347 .53751 m
.76153 .52551 L
s
P
p
1 .6 0 r
2 Mabswid
.78483 .55658 m
.78347 .53751 L
s
P
p
1 .6 0 r
2 Mabswid
.73818 .49436 m
.7603 .5066 L
s
P
p
1 .6 0 r
2 Mabswid
.80958 .60703 m
.83126 .61851 L
s
P
p
1 .6 0 r
2 Mabswid
.71381 .44455 m
.71477 .46314 L
s
P
p
1 .6 0 r
2 Mabswid
.80807 .58758 m
.7862 .57587 L
s
P
p
1 .6 0 r
2 Mabswid
.69049 .41342 m
.66779 .40049 L
s
P
p
1 .6 0 r
2 Mabswid
.69131 .43185 m
.69049 .41342 L
s
P
p
1 .6 0 r
2 Mabswid
.7862 .57587 m
.78483 .55658 L
s
P
p
1 .6 0 r
2 Mabswid
.76153 .52551 m
.76277 .54463 L
s
P
p
1 .6 0 r
2 Mabswid
.71574 .48195 m
.73818 .49436 L
s
P
p
1 .6 0 r
2 Mabswid
.8329 .63811 m
.81111 .6267 L
s
P
p
1 .6 0 r
2 Mabswid
.83456 .65795 m
.8329 .63811 L
s
P
p
1 .6 0 r
2 Mabswid
.71477 .46314 m
.69214 .4505 L
s
P
p
1 .6 0 r
2 Mabswid
.81111 .6267 m
.80958 .60703 L
s
P
p
1 .6 0 r
2 Mabswid
.69214 .4505 m
.69131 .43185 L
s
P
p
1 .6 0 r
2 Mabswid
.66779 .40049 m
.66849 .41897 L
s
P
p
1 .6 0 r
2 Mabswid
.76277 .54463 m
.7404 .53252 L
s
P
p
1 .6 0 r
2 Mabswid
.73928 .51333 m
.71672 .50098 L
s
P
p
1 .6 0 r
2 Mabswid
.7404 .53252 m
.73928 .51333 L
s
P
p
1 .6 0 r
2 Mabswid
.81265 .64661 m
.83456 .65795 L
s
P
p
1 .6 0 r
2 Mabswid
.71672 .50098 m
.71574 .48195 L
s
P
p
1 .6 0 r
2 Mabswid
.66849 .41897 m
.64534 .40591 L
s
P
p
1 .6 0 r
2 Mabswid
.81421 .66675 m
.81265 .64661 L
s
P
p
1 .6 0 r
2 Mabswid
.789 .61513 m
.79042 .63511 L
s
P
p
1 .6 0 r
2 Mabswid
.76658 .60339 m
.789 .61513 L
s
P
p
1 .6 0 r
2 Mabswid
.66919 .43768 m
.6699 .4566 L
s
P
p
1 .6 0 r
2 Mabswid
.64591 .42467 m
.66919 .43768 L
s
P
p
1 .6 0 r
2 Mabswid
.64534 .40591 m
.64591 .42467 L
s
P
p
1 .6 0 r
2 Mabswid
.79186 .65532 m
.81421 .66675 L
s
P
p
1 .6 0 r
2 Mabswid
.57346 .31016 m
.54938 .29618 L
s
P
p
1 .6 0 r
2 Mabswid
.5736 .32842 m
.57346 .31016 L
s
P
p
1 .6 0 r
2 Mabswid
.79042 .63511 m
.79186 .65532 L
s
P
p
1 .6 0 r
2 Mabswid
.6699 .4566 m
.64649 .44365 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .2781 m
.52511 .26387 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .29618 m
.54938 .2781 L
s
P
p
1 .6 0 r
2 Mabswid
.76788 .62344 m
.76658 .60339 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .31448 m
.5736 .32842 L
s
P
p
1 .6 0 r
2 Mabswid
.74501 .61161 m
.76788 .62344 L
s
P
p
1 .6 0 r
2 Mabswid
.64649 .44365 m
.62274 .43052 L
s
P
p
1 .6 0 r
2 Mabswid
.52511 .26387 m
.52496 .282 L
s
P
p
1 .6 0 r
2 Mabswid
.50077 .23147 m
.47594 .21679 L
s
P
p
1 .6 0 r
2 Mabswid
.50048 .24943 m
.50077 .23147 L
s
P
p
1 .6 0 r
2 Mabswid
.52481 .30035 m
.54938 .31448 L
s
P
p
1 .6 0 r
2 Mabswid
.64708 .46287 m
.64767 .48231 L
s
P
p
1 .6 0 r
2 Mabswid
.62319 .44979 m
.64708 .46287 L
s
P
p
1 .6 0 r
2 Mabswid
.52496 .282 m
.50018 .2676 L
s
P
p
1 .6 0 r
2 Mabswid
.7218 .5996 m
.74501 .61161 L
s
P
p
1 .6 0 r
2 Mabswid
.62274 .43052 m
.62319 .44979 L
s
P
p
1 .6 0 r
2 Mabswid
.50018 .2676 m
.50048 .24943 L
s
P
p
1 .6 0 r
2 Mabswid
.47594 .21679 m
.47549 .23478 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .33301 m
.52466 .31892 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .35176 m
.54938 .33301 L
s
P
p
1 .6 0 r
2 Mabswid
.64767 .48231 m
.62364 .4693 L
s
P
p
1 .6 0 r
2 Mabswid
.52466 .31892 m
.52481 .30035 L
s
P
p
1 .6 0 r
2 Mabswid
.72285 .62005 m
.7218 .5996 L
s
P
p
1 .6 0 r
2 Mabswid
.47549 .23478 m
.45014 .21992 L
s
P
p
1 .6 0 r
2 Mabswid
.69735 .56714 m
.69825 .58742 L
s
P
p
1 .6 0 r
2 Mabswid
.67359 .55471 m
.69735 .56714 L
s
P
p
1 .6 0 r
2 Mabswid
.57404 .38451 m
.54938 .37073 L
s
P
p
1 .6 0 r
2 Mabswid
.5742 .40367 m
.57404 .38451 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .37073 m
.54938 .35176 L
s
P
p
1 .6 0 r
2 Mabswid
.62364 .4693 m
.62409 .48904 L
s
P
p
1 .6 0 r
2 Mabswid
.69917 .60794 m
.72285 .62005 L
s
P
p
1 .6 0 r
2 Mabswid
.59895 .43652 m
.57435 .42306 L
s
P
p
1 .6 0 r
2 Mabswid
.59925 .45609 m
.59895 .43652 L
s
P
p
1 .6 0 r
2 Mabswid
.47504 .253 m
.47458 .27144 L
s
P
p
1 .6 0 r
2 Mabswid
.44953 .23818 m
.47504 .253 L
s
P
p
1 .6 0 r
2 Mabswid
.69825 .58742 m
.69917 .60794 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .38995 m
.5742 .40367 L
s
P
p
1 .6 0 r
2 Mabswid
.45014 .21992 m
.44953 .23818 L
s
P
p
1 .6 0 r
2 Mabswid
.67436 .57505 m
.67359 .55471 L
s
P
p
1 .6 0 r
2 Mabswid
.62409 .48904 m
.59956 .47591 L
s
P
p
1 .6 0 r
2 Mabswid
.59956 .47591 m
.59925 .45609 L
s
P
p
1 .6 0 r
2 Mabswid
.47458 .27144 m
.44891 .25667 L
s
P
p
1 .6 0 r
2 Mabswid
.57435 .42306 m
.5745 .44269 L
s
P
p
1 .6 0 r
2 Mabswid
.65011 .5625 m
.67436 .57505 L
s
P
p
1 .6 0 r
2 Mabswid
.5242 .37602 m
.54938 .38995 L
s
P
p
1 .6 0 r
2 Mabswid
.77462 .72742 m
.75108 .71599 L
s
P
p
1 .6 0 r
2 Mabswid
.77602 .74899 m
.77462 .72742 L
s
P
p
1 .6 0 r
2 Mabswid
.74984 .6946 m
.72609 .68291 L
s
P
p
1 .6 0 r
2 Mabswid
.75108 .71599 m
.74984 .6946 L
s
P
p
1 .6 0 r
2 Mabswid
.5745 .44269 m
.54938 .42909 L
s
P
p
1 .6 0 r
2 Mabswid
.44891 .25667 m
.42285 .24168 L
s
P
p
1 .6 0 r
2 Mabswid
.67513 .59565 m
.65074 .58318 L
s
P
p
1 .6 0 r
2 Mabswid
.67592 .61651 m
.67513 .59565 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .4094 m
.52404 .39553 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .42909 m
.54938 .4094 L
s
P
p
1 .6 0 r
2 Mabswid
.75235 .73765 m
.77602 .74899 L
s
P
p
1 .6 0 r
2 Mabswid
.65074 .58318 m
.65011 .5625 L
s
P
p
1 .6 0 r
2 Mabswid
.52404 .39553 m
.5242 .37602 L
s
P
p
1 .6 0 r
2 Mabswid
.72609 .68291 m
.7272 .70439 L
s
P
p
1 .6 0 r
2 Mabswid
.70104 .64975 m
.67671 .63762 L
s
P
p
1 .6 0 r
2 Mabswid
.70199 .67105 m
.70104 .64975 L
s
P
p
1 .6 0 r
2 Mabswid
.44828 .27539 m
.44765 .29434 L
s
P
p
1 .6 0 r
2 Mabswid
.42205 .26044 m
.44828 .27539 L
s
P
p
1 .6 0 r
2 Mabswid
.65138 .60411 m
.67592 .61651 L
s
P
p
1 .6 0 r
2 Mabswid
.42285 .24168 m
.42205 .26044 L
s
P
p
1 .6 0 r
2 Mabswid
.72832 .72614 m
.75235 .73765 L
s
P
p
1 .6 0 r
2 Mabswid
.7272 .70439 m
.70295 .69262 L
s
P
p
1 .6 0 r
2 Mabswid
.70295 .69262 m
.70199 .67105 L
s
P
p
1 .6 0 r
2 Mabswid
.44765 .29434 m
.42125 .27944 L
s
P
p
1 .6 0 r
2 Mabswid
.67671 .63762 m
.67752 .65901 L
s
P
p
1 .6 0 r
2 Mabswid
.62646 .59153 m
.65138 .60411 L
s
P
p
1 .6 0 r
2 Mabswid
.75362 .75958 m
.72945 .74817 L
s
P
p
1 .6 0 r
2 Mabswid
.75492 .78179 m
.75362 .75958 L
s
P
p
1 .6 0 r
2 Mabswid
.72945 .74817 m
.72832 .72614 L
s
P
p
1 .6 0 r
2 Mabswid
.67752 .65901 m
.65267 .64678 L
s
P
p
1 .6 0 r
2 Mabswid
.42125 .27944 m
.42043 .29869 L
s
P
p
1 .6 0 r
2 Mabswid
.65202 .62531 m
.62695 .61281 L
s
P
p
1 .6 0 r
2 Mabswid
.65267 .64678 m
.65202 .62531 L
s
P
p
1 .6 0 r
2 Mabswid
.39543 .24527 m
.3684 .22986 L
s
P
p
1 .6 0 r
2 Mabswid
.39445 .26432 m
.39543 .24527 L
s
P
p
1 .6 0 r
2 Mabswid
.7306 .77048 m
.75492 .78179 L
s
P
p
1 .6 0 r
2 Mabswid
.62695 .61281 m
.62646 .59153 L
s
P
p
1 .6 0 r
2 Mabswid
.42043 .29869 m
.39346 .28361 L
s
P
p
1 .6 0 r
2 Mabswid
.39346 .28361 m
.39445 .26432 L
s
P
p
1 .6 0 r
2 Mabswid
.3684 .22986 m
.36723 .24896 L
s
P
p
1 .6 0 r
2 Mabswid
.73177 .79307 m
.7306 .77048 L
s
P
p
1 .6 0 r
2 Mabswid
.70491 .73658 m
.70591 .75899 L
s
P
p
1 .6 0 r
2 Mabswid
.67999 .72481 m
.70491 .73658 L
s
P
p
1 .6 0 r
2 Mabswid
.36723 .24896 m
.3396 .23336 L
s
P
p
1 .6 0 r
2 Mabswid
.70693 .78168 m
.73177 .79307 L
s
P
p
1 .6 0 r
2 Mabswid
.47122 .40717 m
.47071 .42756 L
s
P
p
1 .6 0 r
2 Mabswid
.44436 .39278 m
.47122 .40717 L
s
P
p
1 .6 0 r
2 Mabswid
.70591 .75899 m
.70693 .78168 L
s
P
p
1 .6 0 r
2 Mabswid
.44503 .37259 m
.44436 .39278 L
s
P
p
1 .6 0 r
2 Mabswid
.41793 .35791 m
.44503 .37259 L
s
P
p
1 .6 0 r
2 Mabswid
.68084 .74732 m
.67999 .72481 L
s
P
p
1 .6 0 r
2 Mabswid
.36606 .2683 m
.36487 .2879 L
s
P
p
1 .6 0 r
2 Mabswid
.33823 .25276 m
.36606 .2683 L
s
P
p
1 .6 0 r
2 Mabswid
.47071 .42756 m
.44367 .41324 L
s
P
p
.01 w
.3396 .23336 Mdot
P
p
1 .6 0 r
2 Mabswid
.3396 .23336 m
.33823 .25276 L
s
P
p
1 .6 0 r
2 Mabswid
.65537 .73546 m
.68084 .74732 L
s
P
p
1 .6 0 r
2 Mabswid
.41707 .37817 m
.41793 .35791 L
s
P
p
1 .6 0 r
2 Mabswid
.39143 .32295 m
.3904 .34301 L
s
P
p
1 .6 0 r
2 Mabswid
.36366 .30775 m
.39143 .32295 L
s
P
p
1 .6 0 r
2 Mabswid
.36487 .2879 m
.33685 .27241 L
s
P
p
1 .6 0 r
2 Mabswid
.44367 .41324 m
.4162 .39869 L
s
P
p
1 .6 0 r
2 Mabswid
.6817 .77011 m
.65607 .75836 L
s
P
p
1 .6 0 r
2 Mabswid
.68257 .79321 m
.6817 .77011 L
s
P
p
1 .6 0 r
2 Mabswid
.38935 .36333 m
.41707 .37817 L
s
P
p
1 .6 0 r
2 Mabswid
.65607 .75836 m
.65537 .73546 L
s
P
p
1 .6 0 r
2 Mabswid
.3904 .34301 m
.38935 .36333 L
s
P
p
1 .6 0 r
2 Mabswid
.36244 .32787 m
.36366 .30775 L
s
P
p
1 .6 0 r
2 Mabswid
.33685 .27241 m
.30839 .25667 L
s
P
p
1 .6 0 r
2 Mabswid
.57598 .63097 m
.57616 .65327 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .61805 m
.57598 .63097 L
s
P
p
1 .6 0 r
2 Mabswid
.44298 .43397 m
.44228 .45497 L
s
P
p
1 .6 0 r
2 Mabswid
.41532 .41949 m
.44298 .43397 L
s
P
p
1 .6 0 r
2 Mabswid
.65678 .78156 m
.68257 .79321 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .59595 m
.54938 .61805 L
s
P
p
1 .6 0 r
2 Mabswid
.52254 .58274 m
.54938 .59595 L
s
P
p
1 .6 0 r
2 Mabswid
.4162 .39869 m
.41532 .41949 L
s
P
p
1 .6 0 r
2 Mabswid
.33403 .31248 m
.36244 .32787 L
s
P
p
1 .6 0 r
2 Mabswid
.33545 .29231 m
.33403 .31248 L
s
P
p
1 .6 0 r
2 Mabswid
.30679 .27663 m
.33545 .29231 L
s
P
p
1 .6 0 r
2 Mabswid
.57616 .65327 m
.54938 .64044 L
s
P
p
1 .6 0 r
2 Mabswid
.44228 .45497 m
.41443 .44056 L
s
P
p
1 .6 0 r
2 Mabswid
.30839 .25667 m
.30679 .27663 L
s
P
p
1 .6 0 r
2 Mabswid
.63057 .76973 m
.65678 .78156 L
s
P
p
1 .6 0 r
2 Mabswid
.52236 .60493 m
.52254 .58274 L
s
P
p
1 .6 0 r
2 Mabswid
.49562 .54734 m
.49526 .56932 L
s
P
p
1 .6 0 r
2 Mabswid
.46809 .53361 m
.49562 .54734 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .64044 m
.52218 .62741 L
s
P
p
1 .6 0 r
2 Mabswid
.41443 .44056 m
.41353 .46191 L
s
P
p
1 .6 0 r
2 Mabswid
.65749 .80508 m
.63112 .79335 L
s
P
p
1 .6 0 r
2 Mabswid
.65822 .8289 m
.65749 .80508 L
s
P
p
1 .6 0 r
2 Mabswid
.49489 .59159 m
.52236 .60493 L
s
P
p
1 .6 0 r
2 Mabswid
.38722 .40478 m
.35867 .38983 L
s
P
p
1 .6 0 r
2 Mabswid
.38613 .42592 m
.38722 .40478 L
s
P
p
1 .6 0 r
2 Mabswid
.63112 .79335 m
.63057 .76973 L
s
P
p
1 .6 0 r
2 Mabswid
.49526 .56932 m
.49489 .59159 L
s
P
p
1 .6 0 r
2 Mabswid
.46754 .55568 m
.46809 .53361 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .66313 m
.54938 .68613 L
s
P
p
1 .6 0 r
2 Mabswid
.52199 .6502 m
.54938 .66313 L
s
P
p
1 .6 0 r
2 Mabswid
.41353 .46191 m
.38503 .44735 L
s
P
p
1 .6 0 r
2 Mabswid
.63167 .8173 m
.65822 .8289 L
s
P
p
1 .6 0 r
2 Mabswid
.52218 .62741 m
.52199 .6502 L
s
P
p
1 .6 0 r
2 Mabswid
.38503 .44735 m
.38613 .42592 L
s
P
p
1 .6 0 r
2 Mabswid
.35867 .38983 m
.35738 .41104 L
s
P
p
1 .6 0 r
2 Mabswid
.43937 .54181 m
.46754 .55568 L
s
P
p
1 .6 0 r
2 Mabswid
.5767 .72197 m
.57689 .74549 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .70944 m
.5767 .72197 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .68613 m
.54938 .70944 L
s
P
p
1 .6 0 r
2 Mabswid
.63223 .84156 m
.63167 .8173 L
s
P
p
1 .6 0 r
2 Mabswid
.35738 .41104 m
.32816 .39592 L
s
P
p
1 .6 0 r
2 Mabswid
.60432 .78144 m
.60469 .8055 L
s
P
p
1 .6 0 r
2 Mabswid
.57707 .76933 m
.60432 .78144 L
s
P
p
1 .6 0 r
2 Mabswid
.46699 .57804 m
.43862 .56427 L
s
P
p
1 .6 0 r
2 Mabswid
.46642 .60071 m
.46699 .57804 L
s
P
p
1 .6 0 r
2 Mabswid
.57689 .74549 m
.54938 .73307 L
s
P
p
1 .6 0 r
2 Mabswid
.43862 .56427 m
.43937 .54181 L
s
P
p
1 .6 0 r
2 Mabswid
.60507 .82988 m
.63223 .84156 L
s
P
p
1 .6 0 r
2 Mabswid
.60469 .8055 m
.60507 .82988 L
s
P
p
1 .6 0 r
2 Mabswid
.43786 .58703 m
.46642 .60071 L
s
P
p
1 .6 0 r
2 Mabswid
.32816 .39592 m
.29845 .38055 L
s
P
p
1 .6 0 r
2 Mabswid
.57726 .79351 m
.57707 .76933 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .73307 m
.52143 .72045 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .78131 m
.57726 .79351 L
s
P
p
1 .6 0 r
2 Mabswid
.40882 .57312 m
.43786 .58703 L
s
P
p
1 .6 0 r
2 Mabswid
.29845 .38055 m
.29671 .4022 L
s
P
p
1 .6 0 r
2 Mabswid
.54938 .75703 m
.54938 .78131 L
s
P
p
1 .6 0 r
2 Mabswid
.52123 .74451 m
.54938 .75703 L
s
P
p
1 .6 0 r
2 Mabswid
.27019 .3435 m
.23971 .32755 L
s
P
p
1 .6 0 r
2 Mabswid
.26825 .36492 m
.27019 .3435 L
s
P
p
1 .6 0 r
2 Mabswid
.52143 .72045 m
.52123 .74451 L
s
P
p
1 .6 0 r
2 Mabswid
.43709 .6101 m
.40784 .59629 L
s
P
p
1 .6 0 r
2 Mabswid
.4363 .6335 m
.43709 .6101 L
s
P
p
1 .6 0 r
2 Mabswid
.29671 .4022 m
.26629 .38664 L
s
P
p
1 .6 0 r
2 Mabswid
.40784 .59629 m
.40882 .57312 L
s
P
p
1 .6 0 r
2 Mabswid
.26629 .38664 m
.26825 .36492 L
s
P
p
1 .6 0 r
2 Mabswid
.23971 .32755 m
.23754 .34903 L
s
P
p
1 .6 0 r
2 Mabswid
.40684 .61979 m
.4363 .6335 L
s
P
p
1 .6 0 r
2 Mabswid
.23754 .34903 m
.20632 .33288 L
s
P
p
1 .6 0 r
2 Mabswid
.35066 .52156 m
.34926 .54459 L
s
P
p
1 .6 0 r
2 Mabswid
.32035 .50684 m
.35066 .52156 L
s
P
p
1 .6 0 r
2 Mabswid
.32196 .48403 m
.32035 .50684 L
s
P
p
1 .6 0 r
2 Mabswid
.29136 .46897 m
.32196 .48403 L
s
P
p
1 .6 0 r
2 Mabswid
.40583 .64362 m
.40684 .61979 L
s
P
p
1 .6 0 r
2 Mabswid
.37809 .58224 m
.37688 .60584 L
s
P
p
1 .6 0 r
2 Mabswid
.34784 .56796 m
.37809 .58224 L
s
P
p
1 .6 0 r
2 Mabswid
.23535 .37083 m
.23312 .39293 L
s
P
p
1 .6 0 r
2 Mabswid
.20388 .35474 m
.23535 .37083 L
s
P
p
1 .6 0 r
2 Mabswid
.34926 .54459 m
.31872 .52997 L
s
P
p
1 .6 0 r
2 Mabswid
.20632 .33288 m
.20388 .35474 L
s
P
p
1 .6 0 r
2 Mabswid
.28952 .49187 m
.29136 .46897 L
s
P
p
1 .6 0 r
2 Mabswid
.37565 .62978 m
.40583 .64362 L
s
P
p
1 .6 0 r
2 Mabswid
.26228 .431 m
.26024 .45366 L
s
P
p
1 .6 0 r
2 Mabswid
.23087 .41534 m
.26228 .431 L
s
P
p
1 .6 0 r
2 Mabswid
.37688 .60584 m
.37565 .62978 L
s
P
p
1 .6 0 r
2 Mabswid
.23312 .39293 m
.20141 .37691 L
s
P
p
1 .6 0 r
2 Mabswid
.3464 .59166 m
.34784 .56796 L
s
P
p
1 .6 0 r
2 Mabswid
.31872 .52997 m
.28766 .51509 L
s
P
p
1 .6 0 r
2 Mabswid
.25816 .47664 m
.28952 .49187 L
s
P
p
1 .6 0 r
2 Mabswid
.26024 .45366 m
.25816 .47664 L
s
P
p
1 .6 0 r
2 Mabswid
.22858 .43808 m
.23087 .41534 L
s
P
p
1 .6 0 r
2 Mabswid
.3154 .57723 m
.3464 .59166 L
s
P
p
1 .6 0 r
2 Mabswid
.20141 .37691 m
.16915 .36063 L
s
P
p
1 .6 0 r
2 Mabswid
.31707 .55343 m
.3154 .57723 L
s
P
p
1 .6 0 r
2 Mabswid
.28577 .53865 m
.31707 .55343 L
s
P
p
1 .6 0 r
2 Mabswid
.28766 .51509 m
.28577 .53865 L
s
P
p
1 .6 0 r
2 Mabswid
.19637 .42223 m
.22858 .43808 L
s
P
p
1 .6 0 r
2 Mabswid
.19891 .39941 m
.19637 .42223 L
s
P
p
1 .6 0 r
2 Mabswid
.16639 .3832 m
.19891 .39941 L
s
P
p
1 .6 0 r
2 Mabswid
.16915 .36063 m
.16639 .3832 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{266, 266},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004:00012PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`0007d00a6:0000MP034@@011690000MP054@801Q670000H0034A<0
1Q40100A4@044HH0001H008A00?o00000`054A400Q4200DA0`034HD0001H008A00?o4A400`064A00
0Q4300@A10024HD0001H00LA00<04A400P044@h00a44008A10024HD0001H008A0P064@<0114600<A
10044@T00Q650000F0024@@01145008A1P044@D01147008AQ@0005P00a45008A1@024@H01Q4400@A
1P024HD0001H00@A2`024@D00a400`0A4@024@D00a45008AQ@0005000a4700@A2@024@D00Q4400@A
10024@D00Q650000D0054@H01A47008A1@034@@01Q400`0A4@05008A1@034Gd0001@00LA1P044@H0
0Q4500HA0`074@D00a4400@AO00005000Q4200DA1P034@D00Q4700HA10044@D01A4200HANP000500
0Q4400DA1@024@D00Q4:00@A1@024@L01140100A4@044GT0001@00<A1@054@<00Q45008A30024A00
1A4300<AN00005001A4500@A00@04A4A1@024@D00a44008A4@044@@00Q5h0000DP044@H01A4600<A
10064@03014A01<00Q44008AN00005@0114500@A1P054@802A4I008AN00005D01146008A20044@03
014A00<0114I008AN00005L00Q4B00DA1@024AT00a5g0000E`024A<0114J00<A0`044GH0001G008A
5@024AX0114400@AM00005L00Q4600<A:0064@<0115c0000E`034@D01A4V008A00<04A400Q4400<A
LP0005L01A4300HA9@024@<01143008ALP0005T01A400`0A4@0200@A8`034@<01A400`0A4@1b0000
F`064@<0114R00@A10074G40000n00<A70044@D00Q4T00@A10054G40000n00@A7@024@D00Q4U00@A
10044G40000e00<A1P064B800Q4W00<A1@024G40000e00DA10024@03014A00<A80024BP00Q5h0000
=@074@04014A4@<0114O008A:0024GP0000e008A0P064@H00a4N008A:0024GP0000e008A10044@L0
0Q4N008A:0024GP0000e008A1P024@L00Q4N008A:0024GP0000e00<A3P024Ah00Q4500<A80024GP0
000[00<A1`054@`00Q4N008A1@054Ah00Q5h0000:`054@L01A4:008A7P034@@01Q4M008AN00002/0
214600DA20024Ah01A42008A0P044A/00Q5h0000:`024@801Q4600@A1`024B0011400`0A4@0300@A
6P034GL0000[008A1@054@H00Q47008A8P054@D00Q4C00<A10064G@0000[008A1`044@D00Q4600<A
1P034AX01145008A4`054@@01Q5b0000:`034@P01143008A1P024@L01A4J008A1@024A<01Q4600@A
L@0002/01A4700PA1P034@H01Q4P008A4`024@801146008AL@0002d01A4700DA1`054@@00Q4200@A
20034A<00Q4C008A0`054@@00Q5a0000;`054@L00a4900DA00@04A4A0`054@H01A4A00<A4P034@@0
1Q400`0A4@1a0000<@044@L00Q4;00HA1P054@@01Q4900<A10064@l01A4400LAL@0003<00Q4F00@A
20054@04014A4@80114700DA10064@l0114600@A5P034EP0000c008A60024@X01Q4400@A1P064@H0
114@00@A1P024A400a4200DAEP0003<00Q4V00@A1P024@H00Q4200@A1P024A40114H00@A00<04A40
1A5D0000<`024BP00Q46008A1P024@<01A44008A4`024AP021400`0A4@024E<0000c008A1`034BH0
0Q46008A1@054@800Q4C008A60024@03014A00<A0`024E<0000c00<A1P054B@00Q4600<A1P044@03
014A01<00Q4H008A0`034@<00Q5C0000<`044@D01a4R008A1P054@H01A4C008A1@034A000a43008A
0`034E80000e00@A0`024@801A4P008A20044@H0114C00<A10054@h01A47008ADP0003H0214400@A
7`024@X01146008A4`054@801a4600<A1@054@D00Q5B0000>0054@L00Q4O008A2`044A`011400`0A
4@0200@A1@054@D01144008ADP0003X00a47008A7`024@D00a45008A7P054@@00Q4500LA1@024@@0
0Q5B0000>`024@L00Q4O008A1@054@<00Q4O00@A10024@D00Q4200DA0`024@@00Q4400<AB`0004<0
0a4O00<A10074@03014A02400Q44008A1@024@@01A400`0A4@04008A10044DX00013008A80054@80
0Q4200HA9`024@D00a4500HA10034@<01Q580000@`024B8011400`0A4@0400@A9`024@D01A4500@A
10054@04014A00@AA`0004<00Q4T00DA1P024BL00Q4700DA1@024@H01Q4300<AAP0004<00Q4U00@A
;`024@T0114>00@A10024DH00013008A9`024Bl00Q4;008A40024@@00Q560000@`024@L00a5>008A
1@034@<00Q4F008AAP0004<00Q4700DAC0024@D01A400`0A4@0F008AAP0004<00a4600LABP034@@0
214F00<AA@0004<01A44008A0P054DP01Q400`0A4@0200@A40034@<01A530000A@054@04014A4@@0
115900LA10024A00114400DA@@0004L01Q47008AC0044AH01Q4400@A@00004T01147008ACP024AH0
0Q400`0A4@024@D00Q500000B`024@L00Q5V008A0`044@<00Q500000D`034FH00a4300DA00<04A40
@00005<00Q5W00@A10064D00001C00<AJ0044@@011500000D`054FL01145008A@00004/00a4700DA
I`034DH0001;00DA1`054FH00Q560000B`074@L0115U008AAP0004/00Q4200DA1`024FD00a4300<A
?`0004X00a4400DA1@024FH00Q4300DA?@0004X00Q4700DA0`024Ah00a5500<A0P074C/0001:00<A
20054@03014A01h01A5300PA00<04A400Q4j0000BP054@P01Q4F00<A1@064D@01Q43008A>P0004`0
1Q4700@A5P054@<00Q4200@AA0044@<00Q4j0000CP064@L00Q4F00HA00@04A4A0`044DD00Q43008A
>P000540114N008A0P054@H00Q4]00<A6P024CX0001C008A7P024@<01146008A;@044AT00Q4j0000
D`024Ah00Q45008A1P024Bd01Q4G008A>P0005<00Q4N00<A30024BL00a43008A00<04A400Q4F008A
>P0005800a4600<A5@054@X00Q4W00DA00<04A400`034AD00a4300<A<`0005800Q4700DA2`034@L0
1149008A9`084@@00Q4F008A0`054C40001B00<A1P074@T01A4700@A1`024BL00Q4200@A10024AH0
0a4200LA;`0005801A44008A0P054@L01a4600@A1P024BL00Q44008A10034AD021400`0A4@024Bh0
001D00DA00@04A4A10044@H00Q4200DA1P024@H00Q4500<A7`034@X00Q4G00HA0`024Bh0001F00HA
1`024@H00Q4400DA10024@H00Q4500HA70054@P00Q4I00@A0`024Bh0001H00@A1`024@H00Q4600DA
0P024@H00a4400PA50034@D01A46008A6`024@<00Q4^0000FP024@L00Q46008A20044@03014A00H0
1A42008A0`044A<0114600@A1@024B000Q4^0000HP034@H00a4900DA20044@03014A00D00Q4C00HA
1P024@D00Q4400<A6@034Bd0001R008A1`064@L0114:00DA1@024A<00Q400`0A4@024@D00Q45008A
10044@P00a4=00DA:`0006800Q4900HA1`024@/01145008A4`024@<01143008A1@024@@01Q4600@A
1`034@@01A4Y0000HP024@`0114E008A1@024A<00Q4400TA10034@<00Q400`0A4@024@D01Q4500DA
10044BP0001R008A3P024A`00Q4C00<A1@074@@01A400`0A4@0300@A0`024@03014A008A10074@@0
0Q4X0000HP024@h00Q4L00<A4P054@H0114600HA10054@03014A00<00a43008A0P054@800Q4X0000
HP024@H00a45008A70054A801A46008A20044@H01Q44008A0`024@@01a4X0000HP024@H01Q42008A
7P044A<0114A008A20044@@00Q43008A1P054BP0001R00<A1@0:4AD00a4800@A4`024Ad00Q44008A
0`034@L00a4X0000HP054@<00Q4300DA5@064@H0114B008A8`024@<01A46008A:00006@01A400`0A
4@06008A5@084@H00Q4B008A1@034A/00Q4500DA;P0006H01Q4M008A0`054@@00Q4B008A1@044AX0
0Q4700@A;@0006P0114M008A1@054@800Q4B008A1@064AP00Q49008A;@0006X00Q4M008A1`044@03
014A01800a44008A00<04A400Q4G008A10034@800Q4]0000R@034@P01A4B00HA00<04A400`034AH0
0Q4400PA;00008T01Q4600@A50074@@00Q4F00<A0`084B`0002;00HA1P024AL01144008A5P054@03
014A0080114/0000SP044B000Q4400<A5`064@@00Q4/0000T0024BL00Q4I00@A<P0009000Q4W008A
6`024C80002@008A9`024Dl0002@008A9`024Dl0002@008A9`024@@00a580000T0024BL00Q4400@A
A`0009000Q4W008A10064DD0002@008A9`034@<00Q400`0A4@024D@0002@008A9`054@03014A00<0
0a530000T0024BT01Q44008A@`0009000Q4[00@A10024D<0002@00<A;0024@@00a520000T0054C40
0Q520000TP044C000a510000R@034@P0114^00DA?`0008T01A4700@A;`054Cd0002900HA20024AX0
0a4:00<A1`044C`00029008A0P044@H00Q4J00DA20054@L00Q4l0000R@024@<01A44008A4`034@@0
1a4600LA1@024C`00029008A1@064@03014A01<01A42008A0P044@D00Q4200DA0`024C`00029008A
1`074A<01Q400`0A4@04008A1@024@@01A400`0A4@0l0000R@034@T0114C008A0P054@@00Q45008A
1P064C`0002900HA20024A<00Q4300@A10024@D00a4700@A?00008/01Q4K008A1@024@@00a4400DA
1`024C`0002>00@A6P034@/00Q4600DA@`0009000Q4J00DA2@024@P011520000T0024A`01148008A
2P024D80002@008A1@034@`00a4700@A1P024@X00Q520000T0024@D01A4:00DA1P044@D00Q4400<A
0`024D80002@008A1@074@P01Q47008A1@024@@02A510000T0024@D00Q4200DA1P024@801145008A
1@024@@02A510000T0034@@00Q4400@A1@024@<01A43008A1@034@<00Q4300@A@@0009001Q400`0A
4@06008A1@024@D01A400`0A4@0500DA00<04A401@024D40002B00LA1P024@D00Q4700HA1`064DP0
002E00@A1P024@D00a4800@A2@044DP0002G008A1P024@D01Q47008A2`024DP0002O008A1`064E`0
002O008A2P044E/0002O008A30024E/0002O008A30024E/0002O008A1@034@@00Q5K0000W`024@D0
1Q400`0A4@1K0000W`024@D02A5K0000W`034@@00Q4300@AF`0009l01A42008A1@024E/0002Q00@A
00<04A40HP000:<01A5R0000Y0044F80002V008AHP000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000001\
\>"],
  ImageRangeCache->{{{0, 265}, {265, 0}} -> {0.232028, -0.0250051, 0.00184064,
   0.00388167}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"Show[{kochGraphic,kochGraphicMoved},\n  DisplayFunction -> \
$DisplayFunction];"], "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
2 Mabswid
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
2 Mabswid
.87651 .67089 m
.8685 .58582 L
s
P
p
1 .6 0 r
2 Mabswid
.88923 .58311 m
.7867 .53145 L
s
P
p
1 .6 0 r
2 Mabswid
.89777 .66825 m
.88923 .58311 L
s
P
p
.2 1 0 r
2 Mabswid
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
2 Mabswid
.76551 .53433 m
.7602 .45221 L
s
P
p
1 .6 0 r
2 Mabswid
.78086 .44927 m
.67449 .39326 L
s
P
p
1 .6 0 r
2 Mabswid
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
2 Mabswid
.77109 .62071 m
.87651 .67089 L
s
P
p
1 .6 0 r
2 Mabswid
.79284 .61791 m
.89777 .66825 L
s
P
p
.2 1 0 r
2 Mabswid
.65338 .39638 m
.65606 .47961 L
s
P
p
1 .6 0 r
2 Mabswid
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
2 Mabswid
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
2 Mabswid
.53982 .33703 m
.5401 .25702 L
s
P
p
1 .6 0 r
2 Mabswid
.56113 .25365 m
.44385 .18936 L
s
P
p
1 .6 0 r
2 Mabswid
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
2 Mabswid
.65889 .56731 m
.77109 .62071 L
s
P
p
1 .6 0 r
2 Mabswid
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
2 Mabswid
.65606 .47961 m
.53953 .42136 L
s
P
p
1 .6 0 r
2 Mabswid
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
2 Mabswid
.53953 .42136 m
.53982 .33703 L
s
P
p
1 .6 0 r
2 Mabswid
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
2 Mabswid
.42236 .19294 m
.41888 .27382 L
s
P
p
1 .6 0 r
2 Mabswid
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
2 Mabswid
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
2 Mabswid
.78317 .80768 m
.77697 .71171 L
s
P
p
1 .6 0 r
2 Mabswid
.79931 .70898 m
.68474 .65693 L
s
P
p
1 .6 0 r
2 Mabswid
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
2 Mabswid
.66187 .65984 m
.65889 .56731 L
s
P
p
1 .6 0 r
2 Mabswid
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
2 Mabswid
.41888 .27382 m
.28981 .20636 L
s
P
p
1 .6 0 r
2 Mabswid
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
2 Mabswid
.66502 .75761 m
.78317 .80768 L
s
P
p
1 .6 0 r
2 Mabswid
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
2 Mabswid
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
2 Mabswid
.28229 .29276 m
.41521 .35921 L
s
P
p
1 .6 0 r
2 Mabswid
.43789 .35572 m
.43465 .44607 L
s
P
p
1 .6 0 r
2 Mabswid
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
2 Mabswid
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
1 .6 0 r
2 Mabswid
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
2 Mabswid
.66836 .86108 m
.66502 .75761 L
s
P
p
1 .6 0 r
2 Mabswid
.69258 .85839 m
.68855 .7548 L
s
P
p
.2 1 0 r
2 Mabswid
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
2 Mabswid
.40722 .54509 m
.5389 .60443 L
s
P
p
1 .6 0 r
2 Mabswid
.56233 .60132 m
.56267 .701 L
s
P
p
1 .6 0 r
2 Mabswid
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
2 Mabswid
.41133 .44948 m
.27433 .38428 L
s
P
p
1 .6 0 r
2 Mabswid
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
2 Mabswid
.53819 .80962 m
.66836 .86108 L
s
P
p
1 .6 0 r
2 Mabswid
.56304 .80672 m
.69258 .85839 L
s
P
p
.2 1 0 r
2 Mabswid
.53856 .70401 m
.53819 .80962 L
s
P
p
1 .6 0 r
2 Mabswid
.56267 .701 m
.56304 .80672 L
s
P
p
.2 1 0 r
2 Mabswid
.40287 .6465 m
.40722 .54509 L
s
P
p
1 .6 0 r
2 Mabswid
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
2 Mabswid
.27433 .38428 m
.12721 .31426 L
s
P
p
1 .6 0 r
2 Mabswid
.29822 .38061 m
.15169 .31032 L
s
P
p
.2 1 0 r
2 Mabswid
.2569 .58464 m
.40287 .6465 L
s
P
p
1 .6 0 r
2 Mabswid
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
2 Mabswid
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
2 Mabswid
.11377 .41285 m
.26588 .4814 L
s
P
p
1 .6 0 r
2 Mabswid
.29049 .47781 m
.28227 .58116 L
s
P
p
1 .6 0 r
2 Mabswid
.139 .40899 m
.29049 .47781 L
s
P
p
.2 1 0 r
2 Mabswid
.12721 .31426 m
.11377 .41285 L
s
P
p
1 .6 0 r
2 Mabswid
.15169 .31032 m
.139 .40899 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{164, 164},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002T0000Y0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:@0002T0000Y0000:@0002T0000Y0000:@0
002T0000Y0000:@0002T0000Y0000:@0002T0000Y0000:@0002T0000Y0000:@0002T0000Y0000:@0
002T0000Y0000:@0002T0000Y0000:@0002T0000Y0000:@0001700<AFP0004<00iD00`0A4@034EP0
001300BE1Q5G0000;P03U@<A3`04U@8A00>E01400a5E0000;P03U@DA3@02U@800Q43U@DAD`0002h0
0iD74@/00YD2008A1ID54E40000^00:E00<04A400YD54@T00YD2008A0P05U@@AD00002h00YD0100A
4@03U@DA1`02U@800Q4400FE115>0000;P02U@03014A00<00iD54@D00YD0100A4A4600BE1A5<0000
;P02U@03014A00D00iD44@@00YD00`0A4@0900BE115;0000;P02U@03014A00L00iD44@800YD00`0A
4@0;00BE11590000;@03U@<A2003U@DA0YD00`0A4@0=00>E11580000;@02U@03014A00/00iD54@03
014A00l00YD00`0A4@180000;@02U@03014A00d00iD64@l00YD00`0A4@180000;@02U@03014A00l0
0iD44@l00YD00`0A4@180000;@02U@03014A01400YD00`0A4@0?00:E00<04A40B00002d00YD00`0A
4@0U00:E00<04A40B00002d00iD34B@00YD00`0A4@180000;@03U@DA8@03U@03014A04P0000_00>E
1Q4N00:E0P024DP0000G00<A5`03U@HA7002U@800Q5800004`03U@03014A00<A5`04U@DA6P02U@80
0Q5800004`04U@LA5`04U@DA6002U@800Q5800004`04U@8A00>E0140114G00BE1A4F00:E0P024DP0
000C00:E0P024@BE1A4G00BE1Q4C00:E0P024DP0000C00:E00@04A4A1YD54AH01ID64A400YD2008A
B00001800iD00`0A4@0400FE1A4F00FE00<04A400a4?00:E0P024DP0000B00:E0P024@H01ID54AH0
1ID00`0A4@024@h00YD2008AB00001800YD2008A2005U@DA5P04U@800Q4>00:E0P024DP0000B00:E
0P024@X01ID54AH00YD2008A3P02U@800Q5800004P02U@800Q4<00FE1A4D00:E0P024@h00YD2008A
B00001800YD2008A3`04U@DA4P02U@800Q4>00:E0P024DP0000B00:E0P024A4019D54A000YD2008A
3P02U@800Q5800004P02U@04014A4A<019D54@h00YD2008A3P02U@800Q5800004@03U@03014A01H0
19D64@/00YD2008A3P02U@800Q4=00>E0a4e00004@02U@800Q4H00BE1Q4900:E00@04A4A3P02U@80
0Q4=00>E1A4c00004@02U@800a4I00FE1A4700:E00<04A403`02U@800Q4=00>E1a4a00004@03U@03
014A00<A6@05U@DA1@02U@03014A00l00YD2008A3@02U@03014A00:E1A4_00004@05U@03014A00@A
6005U@DA0`02U@03014A00l00iD0100A4A4<00:E00@04A400iD54Bd0000C00JE1Q4I00BE1Q42U@03
014A00l019D54@X00YD00`0A4@0300>E1A4[00005@06U@03014A00<A6@04U@HA00<04A404@04U@DA
2002U@03014A00D00iD54BT0000H00FE00<04A40114H00FE1Q4C00BE1A4600:E00@04A4A1@04U@DA
9`0001X01YD64AP01ID44AD019D64@<00YD2008A1`04U@DA9@0001`01YD00`0A4@034AP019D00`0A
4@0G00BE1Q400`2EU@02008A2@04U@@A900001l01ID00`0A4@034AP00YDL00BE00<04A400a400iD0
00024@/00YD2008A900002401ID00`0A4@044C@01ID00`0A4@034@03014A00/00YD2008A900002<0
1YD64C@01ID00`0A4@044@/00YD2008A900002D01YD00`0A4@024CD01YD44@/00YD2008A900002P0
19D2008A=`04U@800Q4;00:E0P024B@0000Z00:E0P024CT00YD?00:E0P024B@0000Z00:E0P024DX0
0YD200<A8`0002X00YD2008ABP03U@800Q4S0000:P02U@800Q5;00:E0P024B<0000Y00>E0P024D/0
0YD2008A8`0002T00YD3008AB`02U@800Q4S0000:@02U@<00Q5;00:E0P024B<0000Y00:E0P034D/0
0YD200<A8P0002T00YD2008AC003U@03014A00<A800002T00YD2008A4P03U@04014A4C<01ID00`0A
4@024Al0000Y00:E0P024A8019D54C<01ID00`0A4@024Ad0000Y00:E0P024A8019D74C<01ID54A/0
000Y00:E0P024A800YD2008A0YD54B000a4@00FE1A4I0000:003U@800Q4B00:E0P024@BE1A4J00>E
00<04A400a4@00FE1A4G0000:002U@<00Q4B00:E0P024@8019D64AL019D74A4019D44AH0000X00:E
0`034A400YD2008A1004U@HA5@04U@8A00>E0140114A00BE114D0000:003U@801A4?00:E0P024@L0
19D54A<00YD2008A0iD00`0A4@034A400iD44A<0000X00JE00<04A40114<00:E0P024@T019D54A40
0YD2008A1ID00`0A4@034A400YD00`0A4@0C0000:P06U@03014A00@A2@03U@04014A4@/019D54@l0
0YD2008A0P05U@03014A00<A3`02U@03014A01<0000]00FE0P054@L00YD2008A3P04U@@A3P02U@80
0Q4400FE00<04A400a4=00:E00<04A404`0002l01YD00`0A4@044@@00YD2008A4002U@800Q4>00:E
0P024@H01ID00`0A4@034@/00YD0100A4A4B0000<@06U@03014A00@A0P02U@800Q4@00:E0P024@h0
0YD2008A2005U@03014A00<A2@02U@800Q4B0000=006U@03014A00<A0YD2008A4002U@800Q4>00:E
0P024@X01ID00`0A4@034@L00YD2008A4P0003H01YD00`0A4@044@03014A01000YD2008A3P02U@80
0Q4<00FE00<04A400a4500:E0P024A80000i00FE00<04A401A4@00:E0P024@h00YD2008A3P05U@03
014A00<A0`03U@03014A0180000k00NE114@00:E0P024@h00YD2008A4005U@03014A00@A00@0UID0
0Q4B0000?@05U@800Q4@00:E0P024@h00YD2008A4P06U@HA00BE014A4P0004000YDD00:E0P024@h0
0YD2008A5006U@03014A00HA4@0005H00YD2008A3P03U@04014A4AH01ID00`0A4@044A40001F00:E
0P024@h019D64AD01YD44A40001F00:E0P024A0019D64AD019D2008A4@0005H00YD2008A4P05U@DA
5@02UAD0001F00:E0P024A@01ID64BT0001F00:E0P024AH01ID64BL0001F00:E0P024AT01ID54BD0
001F00:E0P024A/01ID64B80001F00:E0P024Ad01ID54B40001F00:E0P024Al019D2008A8@0005H0
0YD2008A8@02U@800Q4Q0000EP02U@800Q4Q00:E0P024B40001F00:E0P024B400YD2008A8@0005H0
0YD2008A8@02U@800Q4Q0000EP02U@800Q4Q00:E0P024B40001F00:E0P024B400YD2008A8@0005H0
0YD2008A3`03U@04014A4@/00YD2008A8@0005H00YD2008A3`04U@HA2003U@04014A4B00001F00:E
0P024@l019D84@L00YD2008A800005H00YD2008A3`02U@800Q43U@DA1@02U@800Q4P0000EP02U@80
0Q4?00:E0P024@0309FE00:E1Q4200:E0P024B00001F00:E0P024@l00YD2008A0`04U@HA0YD2008A
800005H00YD2008A3`02U@800Q4600BE1A42008A800005H00YD2008A3`02U@800Q4800BE1a4P0000
EP03U@04014A4@h00YD2008A2P04U@DA800005H019D64@/00YD2008A3@02U@800Q4P0000F004U@LA
2002U@800Q4c0000F`04U@HA1P02U@800Q4c0000G@05U@HA0`02U@800Q4c0000G`05U@HA00<0UID0
0P024C<0001R00FE1Q42008A<`0006@01ID84C<0001V00JE1A4c0000J@04U@800Q4c0000J`02UCL0
002T0000Y0000:@0002T0000Y0000:@0002T0000Y0000:@0002T0000Y0000:@0002T0000Y0000:@0
002T0000Y0000:@0002T0000Y0000:@00000\
\>"],
  ImageRangeCache->{{{0, 163}, {163, 0}} -> {0.251181, -0.0250052, 0.00277241,
   0.00633086}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Comparing graphics"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
compareLineGraphics[refGraph_,compGraph_] :=

Module[{refGraphLines,compGraphLines},

  refGraphLines = Cases[refGraph,_Line,Infinity];
  compGraphLines = Cases[compGraph,_Line,Infinity];
  
  Max[{0,
    9 * Length[Intersection[refGraphLines,compGraphLines]]
     - Length[Complement[compGraphLines,refGraphLines]]}];
     
  refGraphLines
];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["Population ",
    FontFamily->"Times"],
  StyleBox["evaluation",
    FontFamily->"Times",
    FontSlant->"Italic"]
}], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Function"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "populationEvaluation[population_,generation_, opts___] :=\n  Module[{},\n  \
  \n    ",
  StyleBox["(* Reset global graphics lists *)",
    FontSlant->"Italic"],
  "\n    \n    globalTurtleGraphics = {};\n    \n    ",
  StyleBox["(* Compute new fitnesses ... *)",
    FontSlant->"Italic"],
  "\n    \n    populationFitnesses = \n      MapIndexed[\n        \
exprEvaluation[#1,generation,#2,opts]&,\n        population\n      ];\n    \n \
   protoPrint[\"Population fitnesses: \"];\n    \
protoPrint[populationFitnesses];\n    \n    AppendTo[fitnessesListSorted,\n   \
   Reverse[Sort[populationFitnesses]]];\n    \n    If[(DisplayFitnessCharts \
/. {opts}) === True,\n      fitnessChart3D[fitnessesListSorted,\n        \
DisplayGeneration -> generation,opts]\n    ];\n    \n    ",
  StyleBox["(* Display art flowers graphics array *)",
    FontSlant->"Italic"],
  "\n    \n    (**\n    showTurtleGraphics[globalTurtleGraphics,generation];\n\
    **)\n    \n    ",
  StyleBox["(** protocolling is now in evolveExpressions **)\n    (**\n    \
protocolPopulation[\n      population,\n      populationFitnesses,\n      \
Generation -> generation,\n      opts];\n    **)",
    FontSlant->"Italic"],
  "\n  ];"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Options"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
 Options[populationEvaluation] = 
  {
  \tExperimentName ->    \"Turtles\",
  \tExperimentDirectoryName -> \"Examples\",
  \t
  \tRuleApplications -> 3,
  \t
  \tDisplayInteractiveSelection -> False
  };\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(ExperimentName\)\" is \
similar to existing symbol \"\!\(experimentName\)\"."\)], "Message"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Interactive Control"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Initialization "], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "doEPInitialize[] :=\nModule[{},\n\n",
  StyleBox["  (* Initialize global variables *)\n",
    FontSlant->"Italic"],
  "  \n  population = {};\n  newPopulation = {};\n\n  generationsList = {};\n\
\n  populationHistory = {};\n  populationHistoryList = {};\n\n  \
populationFitnesses = {};  \n    (* ... for the current generation *)\n  \
previousPopFitnesses = {}; \n    (* ... for the previous generation *)\n  \n  \
fitnessesListSorted = {}; (* cumulates all fitnesses *)\n\t\n  \
encapsulationList = {};\n  \n  \n  ",
  StyleBox["(* Reset GA operator ranks to their initial values *)\n  \n  ",
    FontSlant->"Italic"],
  "gpOperatorRanks = Sort[gpOperatorRanksInitial];\n  \n  gpOperatorRanksList \
= {gpOperatorRanks};\n\t\n\t\n\t",
  StyleBox["(* Graphics ... *)",
    FontSlant->"Italic"],
  "\n\t\n\tglobalTurtleGraphics = {};\n\t\n\t\n]; (* end module *)\n"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
 resetFitnesses[] :=
   (populationFitnesses = {}; 
    
    minFitness = {}; 
    maxFitness = {}; 
    aveFitness = {};
   );\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Function for Evolving Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
evolveExpressions::generationInfo =
 \"Generation: `1`\";
 
evolveExpressions::fitnessesInfo =
 \"Fitnesses: `1`\";
 
evolveExpressions::fitnessMax =
 \"Max. Fitness: `1`\";
 
 evolveExpressions::gpOperatorRanksInfo =
 \"GA Operator Ranks: `1`\";\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(evolveExpressions[startPattern_, 
          opts___] \
:= \[IndentingNewLine]Module[\[IndentingNewLine]{initialPopulationPrivate = \
{}, \[IndentingNewLine]newPopulationPrivate = {}, \
\[IndentingNewLine]restPopulation = {}, \[IndentingNewLine]gen = 0, r, 
            runDirName, backupDirName, doDisplayOnScreen, 
            theInput, \[IndentingNewLine]howManyIndividuals = \
\[IndentingNewLine]\(Individuals /. {opts}\) /. Options[evolveExpressions], 
            genCounter = \[IndentingNewLine]\(howManyGenerations = \
\(Generations /. {opts}\) /. 
                  Options[
                    evolveExpressions]\), \[IndentingNewLine]runName = \
\(ExperimentName /. {opts}\) /. 
                Options[
                  evolveExpressions], \[IndentingNewLine]examplesDir = \
\(ExamplesDirectory /. {opts}\) /. 
                Options[
                  evolveExpressions], \[IndentingNewLine]newOpts = "\<DEFAULT\
\>" \[Rule] "\<DEFAULT\>"\[IndentingNewLine]}, \[IndentingNewLine]\
\[IndentingNewLine] (*\(\(*\)\(Initialize\)\(\ \)\(global\)\(\ \
\)\(symbols\)\) \
... **) \[IndentingNewLine]\[IndentingNewLine]doEPInitialize[]; \
\[IndentingNewLine]\[IndentingNewLine] (*\(\(*\)\(Then\)\(\ \)\(start\)\(\ \)\
\(interactive/
                  automatic\)\(\ \)\(expression\)\(\ \)\(evolution\)\) \
... **) \[IndentingNewLine]\[IndentingNewLine] (*\(--\(-First\)\)\ create\ a\ \
directory\ where\ to\ put\ evolution\ data*) \[IndentingNewLine]\
\[IndentingNewLine]If[\((runDirName = \[IndentingNewLine]doCreateDirectory[
                    examplesDir, runName])\) === False, 
            Return[]]; \[IndentingNewLine]\[IndentingNewLine] \
(*\(--\(-Generate\)\)\ an\ initial\ population\ of\ expressions\
*) \[IndentingNewLine]\[IndentingNewLine]Off[
            General::stop]; \[IndentingNewLine]Message[
            evolveExpressions::generationInfo, 
            gen + \((\(GenerationOffset /. {opts}\) /. 
                  Options[evolveExpressions])\)]; \[IndentingNewLine]On[
            General::stop]; \
\[IndentingNewLine]\[IndentingNewLine]userInfo["\<Generating initial \
population of expressions ...\>"]; \
\[IndentingNewLine]\[IndentingNewLine]theInput = 
            
            getUserInputInitialPop[]; \
\[IndentingNewLine]\[IndentingNewLine]If[theInput === stop, 
            Break[]]; \
\[IndentingNewLine]\[IndentingNewLine]initialPopulationPrivate = \
\[IndentingNewLine]Which[\[IndentingNewLine]theInput === {}, 
              exprGeneration[howManyIndividuals, startPattern, 
                opts], \[IndentingNewLine]\[IndentingNewLine]StringQ[
                  theInput[\([1]\)]] && 
                NumberQ[
                  theInput[\([2]\)]] && \((theInput[\([3]\)] === all)\), 
              Get[StringJoin[examplesDir, $PathnameSeparator, 
                  theInput[\([1]\)], $PathnameSeparator, 
                  theInput[\([1]\)], "\<.\>", 
                  ToString[
                    theInput[\([2]\)]], "\<.pop\>"]], \[IndentingNewLine]\
\[IndentingNewLine]StringQ[theInput[\([1]\)]] && 
                Length[theInput] \[Equal] 
                  3, {\(Get[
                    StringJoin[examplesDir, $PathnameSeparator, 
                      theInput[\([1]\)], $PathnameSeparator, 
                      theInput[\([1]\)], "\<.\>", 
                      ToString[
                        theInput[\([2]\)]], \
"\<.pop\>"]]\)[\([theInput[\([3]\)]]\)]}, \[IndentingNewLine]\
\[IndentingNewLine]True, \[IndentingNewLine]Print["\<Do not understand the \
input:\>", 
                theInput]; \[IndentingNewLine]Print["\<Generating new \
expressions ...\>"]; \[IndentingNewLine]exprGeneration[howManyIndividuals, 
                startPattern, \ 
                opts]\[IndentingNewLine]]; \[IndentingNewLine]\
\[IndentingNewLine] (*\(--\(-Evaluate\)\)\ expressions \
... *) \[IndentingNewLine]\[IndentingNewLine]userInfo["\<Starting expression \
evaluation ...\>"]; \[IndentingNewLine]\[IndentingNewLine]resetFitnesses[]; \
\[IndentingNewLine]\[IndentingNewLine]population = 
            initialPopulationPrivate; \
\[IndentingNewLine]\[IndentingNewLine]populationEvaluation[population, gen, 
            ExperimentDirectoryName \[Rule] runDirName, 
            ExperimentName \[Rule] runName, 
            opts]; \[IndentingNewLine]\[IndentingNewLine]Off[
            General::stop]; \[IndentingNewLine]Message[
            evolveExpressions::fitnessesInfo, 
            populationFitnesses]; \[IndentingNewLine]On[
            General::stop]; \[IndentingNewLine]Off[
            General::stop]; \[IndentingNewLine]Message[
            evolveExpressions::fitnessMax, 
            Max[populationFitnesses]]; \[IndentingNewLine]On[
            General::stop]; \
\[IndentingNewLine]\[IndentingNewLine]protocolPopulation[population, 
            populationFitnesses, Generation \[Rule] gen, 
            ExperimentDirectoryName \[Rule] runDirName, 
            ExperimentName \[Rule] runName, newOpts, 
            opts]; \[IndentingNewLine]\[IndentingNewLine]If[\((\
DisplayPopulationGraphics /. {opts})\) === True, 
            showTurtleGraphics[globalTurtleGraphics, gen, 
              opts]]; \[IndentingNewLine]\[IndentingNewLine] (*\(--\(-Now\)\)\
\ populationFitnesses\ contains\ the\ fitness\ values*) \[IndentingNewLine]\
\[IndentingNewLine] (*\(--\(-The\)\)\ interactive\ evolution\ loop \
... *) \[IndentingNewLine]\[IndentingNewLine]While[
            True, \[IndentingNewLine]\[IndentingNewLine] (*Interactive\ \
dialog\ panels ... *) \[IndentingNewLine]\[IndentingNewLine] (*Indices \
... *) \[IndentingNewLine]userInputIndices = 
              getUserInputIndices[]; \[IndentingNewLine]If[
              userInputIndices === stop, 
              Print["\<Evolution aborted ...\>"]; \ 
              Break[]]; \[IndentingNewLine]\[IndentingNewLine] (*Generations ... *) 
              userInputGen = 
              getUserInputGen[
                genCounter]; \[IndentingNewLine]\[IndentingNewLine] (*Options \
... *) \[IndentingNewLine]userInputOpts = 
              getUserInputOpts[]; \[IndentingNewLine]If[
              userInputOpts \[NotEqual] {}, 
              newOpts = 
                Apply[Sequence, 
                  userInputOpts]]; \[IndentingNewLine]\[IndentingNewLine] \
(*\(--\(-Now\)\)\ construct\ a\ new\ population ... *)  (*\(--\(-Collect\)\)\ \
expressions\ due\ to\ user\ input ... *) \[IndentingNewLine]\
\[IndentingNewLine]If[userInputIndices === all, 
              userInputIndices = 
                Range[1, 
                  Length[population]]]; \
\[IndentingNewLine]\[IndentingNewLine]If[
              userInputIndices === {}, \
\[IndentingNewLine]newPopulationPrivate = {}, \
\[IndentingNewLine]newPopulationPrivate = 
                Flatten[
                  Table[theInput = 
                      userInputIndices[\([i]\)]; \[IndentingNewLine]Which[\
\[IndentingNewLine]NumberQ[
                        theInput], \[IndentingNewLine]population[\([theInput]\
\)], \[IndentingNewLine]\[IndentingNewLine]VectorQ[theInput] && 
                        Length[theInput] \[Equal] 0, 
                      First[exprGeneration[1, startPattern, \ 
                          opts]], \
\[IndentingNewLine]\[IndentingNewLine]VectorQ[theInput] && 
                        Length[theInput] \[Equal] 1, 
                      population[\([First[
                            theInput]]\)], \[IndentingNewLine]\
\[IndentingNewLine]VectorQ[theInput] && 
                        Length[theInput] \[Equal] 2, \(Get[
                          StringJoin[examplesDir, $PathnameSeparator, 
                            runName, $PathnameSeparator, runName, "\<.\>", 
                            ToString[First[theInput]], "\<.pop\>"]]\)[\([Last[
                            theInput]]\)], \[IndentingNewLine]\
\[IndentingNewLine]VectorQ[theInput] && Length[theInput] \[Equal] 3 && 
                        NumberQ[theInput[\([3]\)]], \(Get[
                          StringJoin[examplesDir, $PathnameSeparator, 
                            theInput[\([1]\)], $PathnameSeparator, 
                            theInput[\([1]\)], "\<.\>", 
                            ToString[
                              theInput[\([2]\)]], "\<.pop\>"]]\)[\([theInput[\
\([3]\)]]\)], \[IndentingNewLine]\[IndentingNewLine]StringQ[
                          theInput[\([1]\)]] && 
                        NumberQ[
                          theInput[\([2]\)]] && \((theInput[\([3]\)] === 
                            all)\), 
                      Get[StringJoin[examplesDir, $PathnameSeparator, 
                          theInput[\([1]\)], $PathnameSeparator, 
                          theInput[\([1]\)], "\<.\>", 
                          ToString[
                            theInput[\([2]\)]], "\<.pop\>"]], \
\[IndentingNewLine]\[IndentingNewLine]True, 
                      Print["\<Do not understand: \>", 
                        ToString[
                          theInput]]; \[IndentingNewLine]Print["\<New \
individual generated ...\>"]; \[IndentingNewLine]First[
                        exprGeneration[1, startPattern, \ 
                          opts]]\[IndentingNewLine]], \[IndentingNewLine]{i, 
                      1, Length[
                        userInputIndices]}\[IndentingNewLine]]\
\[IndentingNewLine]]\[IndentingNewLine]]; \[IndentingNewLine]\
\[IndentingNewLine] (*\(--\(-Add\)\)\ new\ expressions\ up\ to\ population\ \
capacity ... *) \[IndentingNewLine]\[IndentingNewLine]If[\((r = 
                    Length[population] - Length[newPopulationPrivate])\) > 0, 
              userInfo["\<Generating \>", 
                ToString[
                  r], "\< individuals ...\>"]; \
\[IndentingNewLine]restPopulation = 
                exprGeneration[r, startPattern, \ 
                  opts]; \[IndentingNewLine]newPopulationPrivate = 
                Join[newPopulationPrivate, 
                  restPopulation];\[IndentingNewLine]]; \[IndentingNewLine]\
\[IndentingNewLine] (*Now\ evaluate\ this\ new\ population \
... *) \[IndentingNewLine]\[IndentingNewLine]\(gen++\); \[IndentingNewLine]\
\[IndentingNewLine]population = 
              newPopulationPrivate; \[IndentingNewLine]\[IndentingNewLine]Off[
              General::stop]; \[IndentingNewLine]Message[
              evolveExpressions::generationInfo, 
              gen + \((\(GenerationOffset /. {opts}\) /. 
                    Options[evolveExpressions])\)]; \[IndentingNewLine]On[
              General::stop]; \
\[IndentingNewLine]\[IndentingNewLine]userInfo["\<Starting expression \
evaluation (after IS dialogue) ... \>" <> "\<(Gen: \>" <> 
                ToString[
                  gen] <> "\<)\>"]; \
\[IndentingNewLine]\[IndentingNewLine]populationFitnesses = {}; \
\[IndentingNewLine]\[IndentingNewLine]populationEvaluation[population, gen, 
              ExperimentDirectoryName \[Rule] runDirName, 
              ExperimentName \[Rule] runName, 
              DisplayInteractiveSelection \[Rule] True, 
              opts]; \[IndentingNewLine]\[IndentingNewLine]Off[
              General::stop]; \[IndentingNewLine]Message[
              evolveExpressions::fitnessesInfo, 
              populationFitnesses]; \[IndentingNewLine]On[
              General::stop]; \[IndentingNewLine]Off[
              General::stop]; \[IndentingNewLine]Message[
              evolveExpressions::fitnessMax, 
              Max[populationFitnesses]]; \[IndentingNewLine]On[
              General::stop]; \
\[IndentingNewLine]\[IndentingNewLine]protocolPopulation[population, 
              populationFitnesses, Generation \[Rule] gen, 
              ExperimentDirectoryName \[Rule] runDirName, 
              ExperimentName \[Rule] runName, newOpts, 
              opts]; \[IndentingNewLine]\[IndentingNewLine]If[\((\
DisplayPopulationGraphics /. {opts})\) === True, 
              showTurtleGraphics[globalTurtleGraphics, gen, 
                opts]]; \[IndentingNewLine]\[IndentingNewLine] (*Start\ \
automatic\ evolution\ loop ... *) \[IndentingNewLine]\[IndentingNewLine]If[
              NumberQ[userInputGen], genCounter = userInputGen; \ 
              protoPrint["\< \>"]; \
\[IndentingNewLine]protoPrint["\<genCounter set to \>", 
                genCounter]]; \[IndentingNewLine]\[IndentingNewLine]Do[
              userInfo["\<Starting expression evolution process ... \>" <> \
"\<(Gen: \>" <> ToString[
                    gen] <> "\<)\>"]; \[IndentingNewLine]\[IndentingNewLine] \
(*\(--\(-Create\)\)\ the\ next\ generation ... *) \[IndentingNewLine]\
\[IndentingNewLine]population = 
                createNextGeneration[population, populationFitnesses, gen, 
                  StartPattern \[Rule] startPattern, newOpts, 
                  opts]; \[IndentingNewLine]\[IndentingNewLine]\(gen++\); \
\[IndentingNewLine]\[IndentingNewLine]Off[
                General::stop]; \[IndentingNewLine]Message[
                evolveExpressions::generationInfo, 
                gen + \((\(GenerationOffset /. {opts}\) /. 
                      Options[evolveExpressions])\)]; \[IndentingNewLine]On[
                General::stop]; \[IndentingNewLine]\[IndentingNewLine] (*\(\(\
\(*\)\(resultInfo["\<Generation \>" <> ToString[gen] <> "\<:\>", population, 
                      Formatter \[Rule] 
                        ColumnForm]\)\);\)**) \[IndentingNewLine]\
\[IndentingNewLine] (*\(--\(-Evaluate\)\)\ this\ new\ generation \
... *) \[IndentingNewLine]\[IndentingNewLine]userInfo["\<Starting expression \
interpretation ...\>" <> "\<(Gen: \>" <> 
                  ToString[
                    gen] <> "\<)\>"]; \[IndentingNewLine]\[IndentingNewLine] \
(*Keep\ fitnesses\ of\ the\ previous\ generation ... *) 
                previousPopFitnesses = 
                populationFitnesses; \[IndentingNewLine]\[IndentingNewLine] \
(*\(--\(-Evaluate\)\)\ new\ generation ... *) \[IndentingNewLine]\
\[IndentingNewLine]populationFitnesses = {}; \
\[IndentingNewLine]populationEvaluation[population, gen, 
                ExperimentDirectoryName \[Rule] runDirName, 
                ExperimentName \[Rule] runName, 
                opts]; \[IndentingNewLine]\[IndentingNewLine]Off[
                General::stop]; \[IndentingNewLine]Message[
                evolveExpressions::fitnessesInfo, 
                populationFitnesses]; \[IndentingNewLine]On[
                General::stop]; \[IndentingNewLine]Off[
                General::stop]; \[IndentingNewLine]Message[
                evolveExpressions::fitnessMax, 
                Max[populationFitnesses]]; \[IndentingNewLine]On[
                General::stop]; \[IndentingNewLine]\[IndentingNewLine] (*\(\
--\(-Adjust\)\)\ GA\ operator\ ranks ... *)  \
(*\(\(\(*\)\(adjustgpOperatorRanks[opts]\)\);\)**) Off[
                General::stop]; \[IndentingNewLine]\[IndentingNewLine]Message[
                evolveExpressions::gpOperatorRanksInfo, 
                ColumnForm[gpOperatorRanks]]; \[IndentingNewLine]Off[
                General::stop]; \
\[IndentingNewLine]\[IndentingNewLine]protocolPopulation[population, 
                populationFitnesses, Generation \[Rule] gen, 
                ExperimentDirectoryName \[Rule] runDirName, 
                ExperimentName \[Rule] runName, newOpts, 
                opts]; \[IndentingNewLine]\[IndentingNewLine]If[\((\
DisplayPopulationGraphics /. {opts})\) === True, 
                showTurtleGraphics[globalTurtleGraphics, gen, 
                  opts]], \
\[IndentingNewLine]{genCounter}\[IndentingNewLine]]; \[IndentingNewLine] (*\(\
--\(-end\)\)\ \(of : 
                  automatic\ evolution\ loop ... \)*) \[IndentingNewLine]\
\[IndentingNewLine] (*Visualize\ GP\ operator\ ranks*)  \
(*\(\(\(**\)\(gaRanksChart3D[
                    gpOperatorRanksList]\)\);\)***) \[IndentingNewLine]]; \ \
\[IndentingNewLine]\[IndentingNewLine] (*end\ while*) \[IndentingNewLine] \
(*\(--\(-end\)\)\ \(of : 
                interactive\ evolution\ loop ... \)*) \[IndentingNewLine]];\)\
\(\ \)\( (*end\ module*) \)\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(ExamplesDirectory\)\" \
is similar to existing symbol \"\!\(examplesDirectory\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(all\)\" is similar to \
existing symbol \"\!\(All\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(Generation\)\" is \
similar to existing symbols \!\({generation, Generations}\)."\)], "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Options"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Options[evolveExpressions] =
{
  Individuals -> 4,
  Generations -> 1,
  
  GenerationPatterns -> exprGenerationPATTERNS,
  GenerationRanks -> exprGenerationRANKS,
  
  DisplayPopulationGraphics -> True,
  DisplayFitnessCharts -> True,
  
  GenerationOffset -> 0,
  
  ExperimentName -> \"ExprTest\",
  ExamplesDirectory -> EvolvicaDirectory <> $PathnameSeparator <> \
\"Examples\"
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Protocolling"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{\(protocolPopulation[population_List, fitnesses_List, 
            opts___]\), ":=", "\[IndentingNewLine]", 
          RowBox[{"Module", "[", "\[IndentingNewLine]", 
            
            RowBox[{\({dumpFileName, expFileName, 
                protoFile, \[IndentingNewLine]gen = \((\(Generation /. {opts}\
\) /. Options[protocolPopulation])\) + \((\(GenerationOffset /. {opts}\) /. 
                        Options[protocolPopulation])\)\[IndentingNewLine]}\), 
              ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              
              RowBox[{\(expFileName = \((\(ExperimentDirectoryName /. \
{opts}\) /. 
                        Options[
                          protocolPopulation])\) <> $PathnameSeparator <> \((\
\(ExperimentName /. {opts}\) /. Options[protocolPopulation])\)\), ";", 
                "\[IndentingNewLine]", 
                "\[IndentingNewLine]", \(dumpFileName = 
                  expFileName <> "\<.\>" <> ToString[gen]\), ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                StyleBox[\( (*\ Save\ population\  ... \ *) \),
                  FontSlant->"Italic"], 
                "\[IndentingNewLine]", \(protoFile = 
                  dumpFileName <> "\<.pop\>"\), ";", 
                "\[IndentingNewLine]", \(Put[population, protoFile]\), ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                
                StyleBox[\( (*\ 
                    Save\ fitness\ function\ definition\  ... \ *) \),
                  FontSlant->"Italic"], \(If[gen === 0, 
                  protoFile = 
                    dumpFileName <> "\<.fitFct\>"; \[IndentingNewLine]Save[
                    protoFile, exprEvaluation]]\), ";", "\[IndentingNewLine]",
                 "\[IndentingNewLine]", 
                StyleBox[\( (*\ Save\ fitnesses\  ... \ *) \),
                  FontSlant->"Italic"], 
                "\[IndentingNewLine]", \(protoFile = 
                  dumpFileName <> "\<.fit\>"\), ";", 
                "\[IndentingNewLine]", \(Put[fitnesses, protoFile]\), ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                StyleBox[\( (*\ Save\ operator\ history\  ... \ *) \),
                  FontSlant->"Italic"], \(protoFile = 
                  dumpFileName <> "\<.hist\>"\), ";", 
                "\[IndentingNewLine]", \(Put[populationHistory, protoFile]\), 
                ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                
                StyleBox[\( (*\ 
                    Save\ encapsulation\ definitions\  ... \ *) \),
                  FontSlant->"Italic"], \(protoFile = 
                  dumpFileName <> "\<.enc\>"\), ";", 
                "\[IndentingNewLine]", \(Put[encapsPatternList, 
                  encapsRulesList, protoFile]\), ";", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                StyleBox[\( (*\ Save\ GP\ operator\ ranks\  ... \ *) \),
                  FontSlant->"Italic"], \(protoFile = 
                  expFileName <> "\<.opr\>"\), ";", 
                "\[IndentingNewLine]", \(Put[gpOperatorRanksList, 
                  protoFile]\), ";"}]}], "\[IndentingNewLine]", "]"}]}], 
        ";"}], " ", \( (*end\ module*) \)}]], "Input",
  InitializationCell->True],

Cell["\<\
Options[protocolPopulation] :=
{
  
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Utilities"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["File Input/Output"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
doCreateDirectory[examplesDir_String, runName_String] :=

  Module[{runDirName, backupDirName, userInput},
    
    Off[RenameDirectory::filex]; 
    (** Switch off warning message **)
    
    runDirName =  StringJoin[examplesDir,$PathnameSeparator,runName];
    backupDirName = StringJoin[runDirName,\"~\"];

    If[CreateDirectory[runDirName] =!= runDirName,
      Print[\"***\"];
      Print[\"Could not create directory \",runDirName];
      Print[\"--------------------------------------------------------------\"\
];

      If[RenameDirectory[runDirName, backupDirName] =!= backupDirName,

        Print[\"***\"];
        Print[\"Directory \",runDirName,\" and backup \",backupDirName,\" \
already exist!\"];
        Print[\"--------------------------------------------------------------\
\"];

        While[True,
          userInput = InputString[\"Delete backup? (y/n) \"];
          If[userInput == \"y\",
            DeleteDirectory[backupDirName, DeleteContents -> True];
            RenameDirectory[runDirName, backupDirName];
            Break[],
            Return[False];
          ];
        ];
      ];

      CreateDirectory[runDirName],

      Print[\"***\"];
      Print[\"Directory created: \",runDirName];
      Print[\"--------------------------------------------------------------\"\
];
    ];
    
    On[RenameDirectory::filex]; (** Switch warning message on again **)
    
    Return[runDirName];

  ];

\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Screen output and formatting"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
userInfo[message_String] :=
  Module[{},

    Print[\" \"];
    Print[\"----------------------------------------------------------\"];
    Print[message];
    Print[\"----------------------------------------------------------\"];
    Print[\" \"];
  ];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
resultInfo[message_String, result_, opts___] :=
  Module[
    {theFormatter =
      Formatter /. {opts} /. Options[resultInfo]
    },
    
    Print[\" \"];
    Print[message];
    Print[\"----------------------------------------------------------\"];
    Print[result // theFormatter];
  ];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[resultInfo] =
{
  Formatter -> Identity
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
ClearAll[theMessage];

theMessage[message__] :=
Module[{},

  i::info = First[{message}];
  Off[General::stop];
  Message[i::info,Apply[Sequence,Rest[{message}]]];
  On[General::stop]
];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Input panel utilities"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
getInput[
  panelMessage_String,
  notebookMessage_List 
] :=
  Module[{theInput},
    
    Print[\" \"];
    Print[\"***** Input panel information: *****\"];
    Print[\" \"];
    Print[notebookMessage // ColumnForm];
    Print[\" \"];
    
    theInput = Input[panelMessage];
    
    Print[\"INPUT: \",theInput];
    Print[\" \"];
    Print[\"***** End of input panel info *****\"];
    Print[\" \"];

    theInput
  ];
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
getUserInputIndices[] :=
  Module[{},
  
    getInput[
      \"Index list: { {generation,index}.. }\",
      {
       \"Enter an index list for the expressions to be selected.\",
       \"Enter a list of the form: { {generation,index}.. }\",
       \" \",
       \"If you only enter an index this refers to the last generation.\",
       \" \",
       \"Enter 'all' to refer to the whole population.\",
       \" \",
       \"Enter 'stop' to abort.\"
       }
     ]
  ];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
getUserInputOpts[] :=
  Module[{},
  
    getInput[
      \"Options: { symbol -> value .. }\",
      {
       \"Enter a list of rules: { symbol -> value .. }\",

       \"Enter {} for no additonal options.\"
       }
     ]
  ];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
  getUserInputGen[genCounter_Integer] :=
  Module[{},
  
    getInput[
      \"Evolution steps:\",
      {
       \"How many evolution steps? (current value: \",
       StringJoin[\"Current value: \",ToString[genCounter]],
       \" \",
       \"Enter a single number.\"
      }
     ]
   ];
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
  getUserInputInitialPop[] :=
  Module[{},
  
    getInput[
      \"Initial population: (Enter {} for random generation.)\",
      {\"\"}
     ]
   ];
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Visualization"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Expression visualization"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Initialization "], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "doVisuInitialize[] :=\nModule[{},\n\n",
  StyleBox["  (* Initialize global variables *)\n",
    FontSlant->"Italic"],
  "  \n  population = {};\n  newPopulation = {};\n\n  generationsList = {};\n\
\n  populationHistory = {};\n  populationHistoryList = {};\n\n  \
populationFitnesses = {};  (* ... for the current generation *)\n  \
previousPopFitnesses = {}; (* ... for the previous generation *)\n  \n  \
fitnessesListSorted = {}; (* cumulates all fitnesses *)\n\t\n  \
encapsulationList = {};\n  \n  \n  ",
  StyleBox["(* Reset GA operator ranks to their initial values *)\n  \n  ",
    FontSlant->"Italic"],
  "gpOperatorRanks = Sort[gpOperatorRanksInitial];\n  \n  gpOperatorRanksList \
= {gpOperatorRanks};\n\t\n\t\n\t",
  StyleBox["(* Graphics ... *)",
    FontSlant->"Italic"],
  "\n\t\n\tglobalTurtleGraphics = {};\n\t\n\tdisplayGenIndexList = {}; (* the \
indices of the generations *)\n\t                          (* to be displayed \
               *)\n\t\n]; (* end module *)\n"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
 resetFitnesses[] :=
   (populationFitnesses = {}; 
    
    minFitness = {}; 
    maxFitness = {}; 
    aveFitness = {};
   );\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Function"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
visualizeExpressions::generationInfo =
 \"Generation: `1`\";
 
visualizeExpressions::fitnessesInfo =
 \"Fitnesses: `1`\";
 
visualizeExpressions::fitnessMax =
 \"Max. Fitness: `1`\";
 
 visualizeExpressions::gpOperatorRanksInfo =
 \"GA Operator Ranks: `1`\";\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(visualizeExpressions[
          opts___] \
:= \[IndentingNewLine]Module[\[IndentingNewLine]{initialPopulationPrivate = \
{}, \[IndentingNewLine]newPopulationPrivate = {}, \
\[IndentingNewLine]restPopulation = {}, gen = 0, r, runDirName, 
            backupDirName, doDisplayOnScreen, 
            theInput, \[IndentingNewLine]initialInput = \(InitialInput /. \
{opts}\) /. Options[
                  visualizeExpressions], \[IndentingNewLine]runName = \
\(ExperimentName /. {opts}\) /. Options[visualizeExpressions], 
            examplesDir = \(ExamplesDirectory /. {opts}\) /. 
                Options[visualizeExpressions], 
            newOpts = "\<DEFAULT\>" \[Rule] \
"\<DEFAULT\>"\[IndentingNewLine]}, \[IndentingNewLine]\[IndentingNewLine] (*\ 
            Define\ some\ local\ function\ modules\ *) \[IndentingNewLine] \
(*\ \(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(\
---\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\ *) \[IndentingNewLine]\
\[IndentingNewLine]populationEvaluateAndVisualize[pop_, 
              gen_] := \(( (*\(--\(-Evaluate\)\)\ expressions \
... *) \[IndentingNewLine]userInfo["\<Starting expression evaluation ...\>"]; \
\[IndentingNewLine]resetFitnesses[]; \[IndentingNewLine]\[IndentingNewLine] \
(*Update\ the\ list\ of\ generation\ indices*) AppendTo[displayGenIndexList, 
                gen]; \[IndentingNewLine]\[IndentingNewLine] (*Evaluate\ \
population*) \[IndentingNewLine]population = 
                pop; \[IndentingNewLine]populationEvaluation[population, gen, 
                ExperimentDirectoryName \[Rule] runDirName, 
                ExperimentName \[Rule] runName, 
                GenIndices \[Rule] displayGenIndexList, 
                opts]; \[IndentingNewLine]\[IndentingNewLine]Off[
                General::stop]; \[IndentingNewLine]Message[
                visualizeExpressions::fitnessesInfo, 
                populationFitnesses]; \[IndentingNewLine]On[
                General::stop]; \[IndentingNewLine]Off[
                General::stop]; \[IndentingNewLine]Message[
                visualizeExpressions::fitnessMax, 
                Max[populationFitnesses]]; \[IndentingNewLine]On[
                General::stop]; \
\[IndentingNewLine]\[IndentingNewLine]protocolPopulation[population, 
                populationFitnesses, Generation \[Rule] gen, 
                ExperimentDirectoryName \[Rule] runDirName, 
                ExperimentName \[Rule] runName, newOpts, 
                opts]; \[IndentingNewLine]\[IndentingNewLine]If[\((\
DisplayPopulationGraphics /. {opts})\) === True, 
                showTurtleGraphics[globalTurtleGraphics, gen, 
                  opts]];)\); \ \[IndentingNewLine]\[IndentingNewLine] (*end\ \
of\ first\ function\ definition*) \[IndentingNewLine]\[IndentingNewLine] (*\ 
            Second\ local\ function\ definition\ *) \[IndentingNewLine] (*\ \
\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(---\)\)\
\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\ \
*) \[IndentingNewLine]\[IndentingNewLine]doEvaluateInput[
              inputExpr_] := \((\(Map[\((initialPopulationPrivate = \
\[IndentingNewLine]Which[# === {}, \[IndentingNewLine]exprGeneration[
                            howManyIndividuals, 
                            startPattern], \[IndentingNewLine]\
\[IndentingNewLine]StringQ[#[\([1]\)]] && 
                            NumberQ[#[\([2]\)]] && \((#[\([3]\)] === all)\), 
                          Get[StringJoin[
                              examplesDir, $PathnameSeparator, #[\([1]\)], \
$PathnameSeparator, #[\([1]\)], "\<.\>", 
                              ToString[#[\([2]\)]], "\<.pop\>"]], \
\[IndentingNewLine]\[IndentingNewLine]StringQ[#[\([1]\)]] && 
                            Length[#] \[Equal] 
                              3, {\(Get[
                                StringJoin[
                                  examplesDir, $PathnameSeparator, \
#[\([1]\)], $PathnameSeparator, #[\([1]\)], "\<.\>", 
                                  ToString[#[\([2]\)]], \
"\<.pop\>"]]\)[\([#[\([3]\)]]\)]}, \
\[IndentingNewLine]\[IndentingNewLine]True, \[IndentingNewLine]Print["\<Do \
not understand the input:\>", #]; \[IndentingNewLine]Print["\<Generating new \
expressions ...\>"]; \[IndentingNewLine]exprGeneration[howManyIndividuals, 
                            startPattern]\[IndentingNewLine]]; \
\[IndentingNewLine]\[IndentingNewLine]populationEvaluateAndVisualize[
                        initialPopulationPrivate, #[\([2]\)]])\) &, 
                  inputExpr];\)\  (*end\ map*) \[IndentingNewLine])\); \ \
\[IndentingNewLine] (*end\ of\ second\ function\ definition\
*) \[IndentingNewLine]\[IndentingNewLine] (*end\ of\ function\ definitions\
*) \[IndentingNewLine]\[IndentingNewLine]\[IndentingNewLine] (*\(--\(--\(--\(\
--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(\
--\(--\(--\(----\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\
*) \[IndentingNewLine] (*Now\ start\ the\ evaluation\ and\ visualization\ \
process ... *)  (*\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(\
--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(----\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\
\)\)\)\)\)\)\)\)\)\)\)*) \[IndentingNewLine]\[IndentingNewLine] \
(*\(\(*\)\(Initialize\)\(\ \)\(global\)\(\ \)\(symbols\)\) \
... **) \[IndentingNewLine]\[IndentingNewLine]doVisuInitialize[]; \
\[IndentingNewLine]\[IndentingNewLine] (*\(--\(-First\)\)\ create\ a\ \
directory\ where\ to\ put\ visualization\ data*) \[IndentingNewLine]\
\[IndentingNewLine]If[\((runDirName = 
                  doCreateDirectory[examplesDir, runName])\) === False, 
            Return[]]; \[IndentingNewLine]\[IndentingNewLine] (*If\ there\ is\
\ an\ initial\ input\ process\ this\ one\ first*) \[IndentingNewLine]\
\[IndentingNewLine]If[initialInput =!= {}, 
            doEvaluateInput[
              initialInput]]; \[IndentingNewLine]\[IndentingNewLine] \
(*\(--\(-Now\)\)\ start\ the\ interactive\ visualization\ loop\
*) \[IndentingNewLine]\[IndentingNewLine]While[
            True, \[IndentingNewLine]theInput = 
              getUserInputInitialPop[]; \[IndentingNewLine]If[
              theInput === stop, Break[]]; \[IndentingNewLine]doEvaluateInput[
              theInput]\[IndentingNewLine]]\  (*end\ while\
*) \[IndentingNewLine]];\)\(\ \)\( (*end\ module*) \)\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(InitialInput\)\" is \
similar to existing symbol \"\!\(initialInput\)\"."\)], "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Options"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Options[visualizeExpressions] =
{
  InitialInput -> {},
  
  DisplayPopulationGraphics -> True,
  DisplayFitnessCharts -> True,
  
  ExperimentName -> \"ExprVisuTest\",
  ExamplesDirectory -> EvolvicaDirectory <> $PathnameSeparator <> \
\"Examples\"
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Graphics"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Fitness charts"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\

fitnessChart[fitnesses_List] :=
Module[{},
  (**
  BarChart[Reverse[Sort[fitnesses]],
    BarEdges -> True,
    BarLabels -> 
      Append[Table[\" \",{Length[fitnesses]-1}],
        Length[fitnesses]],
    BarSpacing -> Automatic,
    BarStyle -> (GrayLevel[0.0]&),
    BarOrientation -> Horizontal,
    DefaultFont -> {\"Helvetica\",12},
    PlotLabel -> \"Sorted Fitnesses Histogram\"
  ];
  **)
  
  ListPlot[Reverse[Sort[fitnesses]],
    PlotJoined -> True
  ];
  
]; (* end module *)\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[{
  "\nfitnessChart3D[fitnesses_List,opts___] :=\nModule[{l,r,\n        \
theFitnesses,\n        maxLength,\n        gen =\n          DisplayGeneration \
/. {opts} /. Options[fitnessChart3D],\n        genIndices =\n          \
GenIndices /. {opts} /. Options[fitnessChart3D],\n        genAxisTicks\n      \
 },\n\n  ",
  StyleBox["(* First scale all lists to the same length ... *)",
    FontSlant->"Italic"],
  "\n  \n  theFitnesses = fitnesses;\n  \n  maxLength = \
Max[Map[Length[#]&,theFitnesses]];\n  \n  theFitnesses =\n    Map[\n      \
If[(r = maxLength - Length[#]) > 0,\n        Join[#,Table[-1.,{r}]],\n        \
#\n      ]&,\n      theFitnesses\n    ];\n  \n  ",
  StyleBox["(* Graphics generation and display ... *)",
    FontSlant->"Italic"],
  "\n  \n  l = Length[theFitnesses];\n  \n  If[gen === {},gen = l-1];\n  \
If[genIndices === {},genIndices = Range[l]];\n  \n  (**genAxisTicks = \
MapIndexed[{First[#2],#1}&,genIndices];**)\n  genAxisTicks = genIndices;\n  \n\
  If[l > 1,\n    \n    ListShadowPlot3D[theFitnesses,\n      ViewPoint -> \
{1.3, -2.4, 0.7},\n      Ticks -> {Automatic,genAxisTicks,Automatic},\n      \
Color -> True,\n      SurfaceMesh -> True,\n      ShadowMesh -> False,\n      \
PlotLabel -> \n       FontForm[\n         \"Sorted Fitnesses History, Gen. \" \
<> ToString[gen],\n         {\"Helvetica-Bold\",12}\n       ],\n      \
FaceGrids -> {{-1,0,0},{0,1,0}},\n      Boxed -> False,\n      Axes -> True,\n\
      AxesEdge -> {Automatic,{1,-1},Automatic},\n      AxesLabel -> {\"Indiv.\
\",\"Gen.\",\"Fit.\"},\n      DefaultFont -> {\"Helvetica\",12},\n      \
Background -> GrayLevel[0.8]\n    ],\n    \n    BarChart[First[theFitnesses],\
\n      BarEdges -> True,\n      BarLabels -> \n        Append[Table[\" \
\",{Length[First[theFitnesses]]-1}],\n        Length[First[theFitnesses]]],\n \
     BarSpacing -> Automatic,\n      BarStyle -> (GrayLevel[0.0]&),\n      \
BarOrientation -> Vertical,\n      DefaultFont -> {\"Helvetica\",12},\n      \
PlotLabel -> \n        FontForm[\n          \"Sorted Fitnesses Histogram, \
Gen. \" <> ToString[gen],\n          {\"Helvetica-Bold\",12}\n        ],\n    \
  PlotRange -> All,\n      Background -> GrayLevel[0.8]\n    ]\n  ];\n  \n]; \
(* end module *)"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(genIndices\)\" is \
similar to existing symbol \"\!\(GenIndices\)\"."\)], "Message"]
}, Open  ]],

Cell["\<\
Options[fitnessChart3D] =
{
  DisplayGeneration -> {},
  GenIndices -> {}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Turtle graphics"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Options[showTurtleGraphics] =
{
  TableWidth -> 3
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[TextData[{
  "showTurtleGraphics[\n  graphicsList_List,generation_Integer,opts___] :=\n\
Module[{\n  width = TableWidth /. {opts} /. Options[showTurtleGraphics], \n  \
listLength = Length[graphicsList],\n  dummyGraphic,\n  restLength, \
restGraphics,\n  displayGraphicsArray},\n\n  dummyGraphic = \
Show[Graphics3D[{Hue[0.0]}],\n                   Boxed -> False, \
DisplayFunction -> Identity];\n       \n  restLength = Mod[listLength,width]; \
        \n  restGraphics =  \n    If[restLength === 0,\n      {},\n      \
Table[dummyGraphic,{width - restLength}]\n    ];\n  \n  displayGraphicsArray \
= \n    Partition[Join[graphicsList,restGraphics],width];\n    \n  ",
  StyleBox["(* Display the graphics table *)",
    FontSlant->"Italic"],
  "\n  \n  theGraphics =\n  Show[\n    GraphicsArray[displayGraphicsArray],\n \
   PlotLabel -> \n      FontForm[\"Gen. \" <> ToString[generation],\n        \
{\"Times\",14}\n      ],\n    DisplayFunction -> Identity\n  ];\n  \n  Show[\n\
    Graphics[\n     {\n      Rectangle[{0,0},{1,1},theGraphics],\n      Text[\
\n          FontForm[\"Fractals\",{\"Times-Italic\",18}],{0,0.95},{-1,0}\n    \
  ]\n     }\n    ],\n    Background -> GrayLevel[0.9]\n  ];\n  \n];"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[TextData[
"Show[\n  Graphics[\n   {\n    Rectangle[{0,0},{1,1},Graphics3D[{Hue[1]}]],\n \
   Rectangle[Scaled[{0.0,0.8}],Scaled[{0.3,1.0}],\n      \
Graphics[Text[\"Hallo\",{0,0}]]]\n   }\n  ]\n];"], "Input",
  AspectRatioFixed->True]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Evolution of Fractals ...", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(\($basicDirectory = \[IndentingNewLine]ToFileName[{EvolvicaDirectory, \
\[IndentingNewLine]"\<Chapters\>", "\<10-LSystemInference\>", \
"\<FractalEvolution\>"}];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(protoPrint\  = \ Print\)], "Input"],

Cell[BoxData[
    \(Print\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
$RecursionLimit = 100;

evolveExpressions[
  _LSystem,
  LSystemIterations -> 1,
  Individuals -> 5,
  Generations -> 1,
  
  GenerationGap -> 1.0,
  
  GenerationPatterns -> exprGenerationPATTERNS,
  GenerationRanks -> exprGenerationRANKS,
  
  TableWidth -> 7,
  
  DisplayPopulationGraphics -> False,
  DisplayFitnessCharts -> True,
  
  GenerationOffset -> 0,
  
  ExperimentName -> \"Fractals-Evolved\",
  
  ExamplesDirectory -> $basicDirectory <> $PathnameSeparator <>
                       \"Examples\"
]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(CreateDirectory::"ioerr" \(\(:\)\(\ \)\) 
      "I/O error occurred during \
\!\(CreateDirectory[\(\(\"~jacob/Desktop/EvolvicaNotebooks/Ev\" \[Ellipsis] \
\"Evolution//Examples/Fractals-Evolved\"\)\)]\)."\)], "Message"],

Cell[BoxData[
    \("***"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Could not create directory \
"\[InvisibleSpace]"~jacob/Desktop/EvolvicaNotebooks/EvolvicaNotebooks/\
Chapters/10-LSystemInference/FractalEvolution//Examples/Fractals-Evolved"\),
      SequenceForm[ 
      "Could not create directory ", 
        "~jacob/Desktop/EvolvicaNotebooks/EvolvicaNotebooks/Chapters/10-\
LSystemInference/FractalEvolution//Examples/Fractals-Evolved"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    \("***"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Directory \
"\[InvisibleSpace]"~jacob/Desktop/EvolvicaNotebooks/EvolvicaNotebooks/\
Chapters/10-LSystemInference/FractalEvolution//Examples/Fractals-Evolved"\
\[InvisibleSpace]" and backup \
"\[InvisibleSpace]"~jacob/Desktop/EvolvicaNotebooks/EvolvicaNotebooks/\
Chapters/10-LSystemInference/FractalEvolution//Examples/Fractals-Evolved~"\
\[InvisibleSpace]" already exist!"\),
      SequenceForm[ 
      "Directory ", 
        "~jacob/Desktop/EvolvicaNotebooks/EvolvicaNotebooks/Chapters/10-\
LSystemInference/FractalEvolution//Examples/Fractals-Evolved", " and backup ",
         "~jacob/Desktop/EvolvicaNotebooks/EvolvicaNotebooks/Chapters/10-\
LSystemInference/FractalEvolution//Examples/Fractals-Evolved~", 
        " already exist!"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    \(evolveExpressions::"generationInfo" \(\(:\)\(\ \)\) 
      "Generation: \!\(0\)"\)], "Message"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("Generating initial population of expressions ..."\)], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \("***** Input panel information: *****"\)], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"\<\"\"\>"}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ {""}],
      Editable->False]], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("INPUT: "\[InvisibleSpace]{}\),
      SequenceForm[ "INPUT: ", {}],
      Editable->False]], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \("***** End of input panel info *****"\)], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"-- startPattern: \"\>", "\[InvisibleSpace]", 
        TagBox[
          StyleBox[\(Blank[LSystem]\),
            ShowSpecialCharacters->False,
            ShowStringCharacters->True,
            NumberMarks->True],
          FullForm]}],
      SequenceForm[ "-- startPattern: ", 
        FullForm[ 
          Blank[ LSystem]]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"-- iterDepth: \"\>", "\[InvisibleSpace]", 
        InterpretationBox["\[Infinity]",
          DirectedInfinity[ 1]]}],
      SequenceForm[ "-- iterDepth: ", 
        DirectedInfinity[ 1]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("possiblePositions = "\[InvisibleSpace]{{1}}\),
      SequenceForm[ "possiblePositions = ", {{1}}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("selected          = "\[InvisibleSpace]{1}\),
      SequenceForm[ "selected          = ", {1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("startExpr         = \
"\[InvisibleSpace]LSystem[_AXIOM, _LRULES]\),
      SequenceForm[ "startExpr         = ", 
        LSystem[ 
          Blank[ AXIOM], 
          Blank[ LRULES]]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("doFixedPoint ..."\)], "Print"],

Cell[BoxData[
    \($Aborted\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Visualization and Analysis ..."], "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Visualizing the fractals"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Setting the directory of the evolved data (Examples)", "Subsubsection"],

Cell[BoxData[
    \($basicDirectory = \[IndentingNewLine]ToFileName[{EvolvicaDirectory, \
\[IndentingNewLine]"\<EvolutionPrograms\>", "\<GLP\>", \
"\<FractalEvolution\>"}]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"Invoking turtle-interpretations for populations 0, 20, 40, 60, and 80"], 
  "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[
"visualizeExpressions[\n  InitialInput -> \n  Table[\n    \
{\"Fractals-10-1\",i,all},{i,0,80,20}\n  ],\n  LSystemIterations -> 1,\n  \n  \
TableWidth -> 7,\n  \n  DisplayPopulationGraphics -> True,\n  \
DisplayFitnessCharts -> True,\n  \n  ExperimentName -> \
\"Fractals-10-2.Visu\",\n  \n  ExamplesDirectory -> $basicDirectory <> \
$PathnameSeparator <>\n                       \"Examples\"\n];"], "Input",
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Generation 0"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"EvolutionOverview"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
0.00738916 0.0273673 0.0147151 0.0140144 [
[( )] .03476 .01472 0 2 Msboxa
[( )] .06212 .01472 0 2 Msboxa
[( )] .08949 .01472 0 2 Msboxa
[( )] .11686 .01472 0 2 Msboxa
[( )] .14423 .01472 0 2 Msboxa
[( )] .17159 .01472 0 2 Msboxa
[( )] .19896 .01472 0 2 Msboxa
[( )] .22633 .01472 0 2 Msboxa
[( )] .25369 .01472 0 2 Msboxa
[( )] .28106 .01472 0 2 Msboxa
[( )] .30843 .01472 0 2 Msboxa
[( )] .3358 .01472 0 2 Msboxa
[( )] .36316 .01472 0 2 Msboxa
[( )] .39053 .01472 0 2 Msboxa
[( )] .4179 .01472 0 2 Msboxa
[( )] .44527 .01472 0 2 Msboxa
[( )] .47263 .01472 0 2 Msboxa
[( )] .5 .01472 0 2 Msboxa
[( )] .52737 .01472 0 2 Msboxa
[( )] .55473 .01472 0 2 Msboxa
[( )] .5821 .01472 0 2 Msboxa
[( )] .60947 .01472 0 2 Msboxa
[( )] .63684 .01472 0 2 Msboxa
[( )] .6642 .01472 0 2 Msboxa
[( )] .69157 .01472 0 2 Msboxa
[( )] .71894 .01472 0 2 Msboxa
[( )] .74631 .01472 0 2 Msboxa
[( )] .77367 .01472 0 2 Msboxa
[( )] .80104 .01472 0 2 Msboxa
[( )] .82841 .01472 0 2 Msboxa
[( )] .85577 .01472 0 2 Msboxa
[( )] .88314 .01472 0 2 Msboxa
[( )] .91051 .01472 0 2 Msboxa
[( )] .93788 .01472 0 2 Msboxa
[(35)] .96524 .01472 0 2 Msboxa
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses Histogram, Gen. 0)] .5 .61803 0 -2 Msboxa
P
[(10)] .00584 .15486 1 0 Msboxa
[(20)] .00584 .295 1 0 Msboxa
[(30)] .00584 .43515 1 0 Msboxa
[(40)] .00584 .57529 1 0 Msboxa
[ -0.001 -0.001 0 0 ]
[ 1.001 .61903 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
p
.002 w
.03476 .01472 m
.03476 .02097 L
s
P
[( )] .03476 .01472 0 2 Mshowa
p
.002 w
.06212 .01472 m
.06212 .02097 L
s
P
[( )] .06212 .01472 0 2 Mshowa
p
.002 w
.08949 .01472 m
.08949 .02097 L
s
P
[( )] .08949 .01472 0 2 Mshowa
p
.002 w
.11686 .01472 m
.11686 .02097 L
s
P
[( )] .11686 .01472 0 2 Mshowa
p
.002 w
.14423 .01472 m
.14423 .02097 L
s
P
[( )] .14423 .01472 0 2 Mshowa
p
.002 w
.17159 .01472 m
.17159 .02097 L
s
P
[( )] .17159 .01472 0 2 Mshowa
p
.002 w
.19896 .01472 m
.19896 .02097 L
s
P
[( )] .19896 .01472 0 2 Mshowa
p
.002 w
.22633 .01472 m
.22633 .02097 L
s
P
[( )] .22633 .01472 0 2 Mshowa
p
.002 w
.25369 .01472 m
.25369 .02097 L
s
P
[( )] .25369 .01472 0 2 Mshowa
p
.002 w
.28106 .01472 m
.28106 .02097 L
s
P
[( )] .28106 .01472 0 2 Mshowa
p
.002 w
.30843 .01472 m
.30843 .02097 L
s
P
[( )] .30843 .01472 0 2 Mshowa
p
.002 w
.3358 .01472 m
.3358 .02097 L
s
P
[( )] .3358 .01472 0 2 Mshowa
p
.002 w
.36316 .01472 m
.36316 .02097 L
s
P
[( )] .36316 .01472 0 2 Mshowa
p
.002 w
.39053 .01472 m
.39053 .02097 L
s
P
[( )] .39053 .01472 0 2 Mshowa
p
.002 w
.4179 .01472 m
.4179 .02097 L
s
P
[( )] .4179 .01472 0 2 Mshowa
p
.002 w
.44527 .01472 m
.44527 .02097 L
s
P
[( )] .44527 .01472 0 2 Mshowa
p
.002 w
.47263 .01472 m
.47263 .02097 L
s
P
[( )] .47263 .01472 0 2 Mshowa
p
.002 w
.5 .01472 m
.5 .02097 L
s
P
[( )] .5 .01472 0 2 Mshowa
p
.002 w
.52737 .01472 m
.52737 .02097 L
s
P
[( )] .52737 .01472 0 2 Mshowa
p
.002 w
.55473 .01472 m
.55473 .02097 L
s
P
[( )] .55473 .01472 0 2 Mshowa
p
.002 w
.5821 .01472 m
.5821 .02097 L
s
P
[( )] .5821 .01472 0 2 Mshowa
p
.002 w
.60947 .01472 m
.60947 .02097 L
s
P
[( )] .60947 .01472 0 2 Mshowa
p
.002 w
.63684 .01472 m
.63684 .02097 L
s
P
[( )] .63684 .01472 0 2 Mshowa
p
.002 w
.6642 .01472 m
.6642 .02097 L
s
P
[( )] .6642 .01472 0 2 Mshowa
p
.002 w
.69157 .01472 m
.69157 .02097 L
s
P
[( )] .69157 .01472 0 2 Mshowa
p
.002 w
.71894 .01472 m
.71894 .02097 L
s
P
[( )] .71894 .01472 0 2 Mshowa
p
.002 w
.74631 .01472 m
.74631 .02097 L
s
P
[( )] .74631 .01472 0 2 Mshowa
p
.002 w
.77367 .01472 m
.77367 .02097 L
s
P
[( )] .77367 .01472 0 2 Mshowa
p
.002 w
.80104 .01472 m
.80104 .02097 L
s
P
[( )] .80104 .01472 0 2 Mshowa
p
.002 w
.82841 .01472 m
.82841 .02097 L
s
P
[( )] .82841 .01472 0 2 Mshowa
p
.002 w
.85577 .01472 m
.85577 .02097 L
s
P
[( )] .85577 .01472 0 2 Mshowa
p
.002 w
.88314 .01472 m
.88314 .02097 L
s
P
[( )] .88314 .01472 0 2 Mshowa
p
.002 w
.91051 .01472 m
.91051 .02097 L
s
P
[( )] .91051 .01472 0 2 Mshowa
p
.002 w
.93788 .01472 m
.93788 .02097 L
s
P
[( )] .93788 .01472 0 2 Mshowa
p
.002 w
.96524 .01472 m
.96524 .02097 L
s
P
[(35)] .96524 .01472 0 2 Mshowa
p
.002 w
0 .01472 m
1 .01472 L
s
P
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses Histogram, Gen. 0)] .5 .61803 0 -2 Mshowa
P
p
.002 w
.01834 .15486 m
.02459 .15486 L
s
P
[(10)] .00584 .15486 1 0 Mshowa
p
.002 w
.01834 .295 m
.02459 .295 L
s
P
[(20)] .00584 .295 1 0 Mshowa
p
.002 w
.01834 .43515 m
.02459 .43515 L
s
P
[(30)] .00584 .43515 1 0 Mshowa
p
.002 w
.01834 .57529 m
.02459 .57529 L
s
P
[(40)] .00584 .57529 1 0 Mshowa
p
.001 w
.01834 .04274 m
.02209 .04274 L
s
P
p
.001 w
.01834 .07077 m
.02209 .07077 L
s
P
p
.001 w
.01834 .0988 m
.02209 .0988 L
s
P
p
.001 w
.01834 .12683 m
.02209 .12683 L
s
P
p
.001 w
.01834 .18289 m
.02209 .18289 L
s
P
p
.001 w
.01834 .21092 m
.02209 .21092 L
s
P
p
.001 w
.01834 .23895 m
.02209 .23895 L
s
P
p
.001 w
.01834 .26697 m
.02209 .26697 L
s
P
p
.001 w
.01834 .32303 m
.02209 .32303 L
s
P
p
.001 w
.01834 .35106 m
.02209 .35106 L
s
P
p
.001 w
.01834 .37909 m
.02209 .37909 L
s
P
p
.001 w
.01834 .40712 m
.02209 .40712 L
s
P
p
.001 w
.01834 .46318 m
.02209 .46318 L
s
P
p
.001 w
.01834 .4912 m
.02209 .4912 L
s
P
p
.001 w
.01834 .51923 m
.02209 .51923 L
s
P
p
.001 w
.01834 .54726 m
.02209 .54726 L
s
P
p
.001 w
.01834 .60332 m
.02209 .60332 L
s
P
p
.002 w
.01834 0 m
.01834 .61803 L
s
P
P
p
p
p
.02381 .01472 m
.02381 .60332 L
.0457 .60332 L
.0457 .01472 L
F
P
p
.004 w
.02381 .01472 m
.02381 .60332 L
.0457 .60332 L
.0457 .01472 L
.02381 .01472 L
s
P
P
p
p
.05118 .01472 m
.05118 .54726 L
.07307 .54726 L
.07307 .01472 L
F
P
p
.004 w
.05118 .01472 m
.05118 .54726 L
.07307 .54726 L
.07307 .01472 L
.05118 .01472 L
s
P
P
p
p
.07854 .01472 m
.07854 .40712 L
.10044 .40712 L
.10044 .01472 L
F
P
p
.004 w
.07854 .01472 m
.07854 .40712 L
.10044 .40712 L
.10044 .01472 L
.07854 .01472 L
s
P
P
p
p
.10591 .01472 m
.10591 .35106 L
.12781 .35106 L
.12781 .01472 L
F
P
p
.004 w
.10591 .01472 m
.10591 .35106 L
.12781 .35106 L
.12781 .01472 L
.10591 .01472 L
s
P
P
p
p
.13328 .01472 m
.13328 .32303 L
.15517 .32303 L
.15517 .01472 L
F
P
p
.004 w
.13328 .01472 m
.13328 .32303 L
.15517 .32303 L
.15517 .01472 L
.13328 .01472 L
s
P
P
p
p
.16065 .01472 m
.16065 .26697 L
.18254 .26697 L
.18254 .01472 L
F
P
p
.004 w
.16065 .01472 m
.16065 .26697 L
.18254 .26697 L
.18254 .01472 L
.16065 .01472 L
s
P
P
p
p
.18801 .01472 m
.18801 .23895 L
.20991 .23895 L
.20991 .01472 L
F
P
p
.004 w
.18801 .01472 m
.18801 .23895 L
.20991 .23895 L
.20991 .01472 L
.18801 .01472 L
s
P
P
p
p
.21538 .01472 m
.21538 .23895 L
.23727 .23895 L
.23727 .01472 L
F
P
p
.004 w
.21538 .01472 m
.21538 .23895 L
.23727 .23895 L
.23727 .01472 L
.21538 .01472 L
s
P
P
p
p
.24275 .01472 m
.24275 .23895 L
.26464 .23895 L
.26464 .01472 L
F
P
p
.004 w
.24275 .01472 m
.24275 .23895 L
.26464 .23895 L
.26464 .01472 L
.24275 .01472 L
s
P
P
p
p
.27011 .01472 m
.27011 .18289 L
.29201 .18289 L
.29201 .01472 L
F
P
p
.004 w
.27011 .01472 m
.27011 .18289 L
.29201 .18289 L
.29201 .01472 L
.27011 .01472 L
s
P
P
p
p
.29748 .01472 m
.29748 .18289 L
.31938 .18289 L
.31938 .01472 L
F
P
p
.004 w
.29748 .01472 m
.29748 .18289 L
.31938 .18289 L
.31938 .01472 L
.29748 .01472 L
s
P
P
p
p
.32485 .01472 m
.32485 .18289 L
.34674 .18289 L
.34674 .01472 L
F
P
p
.004 w
.32485 .01472 m
.32485 .18289 L
.34674 .18289 L
.34674 .01472 L
.32485 .01472 L
s
P
P
p
p
.35222 .01472 m
.35222 .12683 L
.37411 .12683 L
.37411 .01472 L
F
P
p
.004 w
.35222 .01472 m
.35222 .12683 L
.37411 .12683 L
.37411 .01472 L
.35222 .01472 L
s
P
P
p
p
.37958 .01472 m
.37958 .12683 L
.40148 .12683 L
.40148 .01472 L
F
P
p
.004 w
.37958 .01472 m
.37958 .12683 L
.40148 .12683 L
.40148 .01472 L
.37958 .01472 L
s
P
P
p
p
.40695 .01472 m
.40695 .12683 L
.42885 .12683 L
.42885 .01472 L
F
P
p
.004 w
.40695 .01472 m
.40695 .12683 L
.42885 .12683 L
.42885 .01472 L
.40695 .01472 L
s
P
P
p
p
.43432 .01472 m
.43432 .12683 L
.45621 .12683 L
.45621 .01472 L
F
P
p
.004 w
.43432 .01472 m
.43432 .12683 L
.45621 .12683 L
.45621 .01472 L
.43432 .01472 L
s
P
P
p
p
.46169 .01472 m
.46169 .0988 L
.48358 .0988 L
.48358 .01472 L
F
P
p
.004 w
.46169 .01472 m
.46169 .0988 L
.48358 .0988 L
.48358 .01472 L
.46169 .01472 L
s
P
P
p
p
.48905 .01472 m
.48905 .07077 L
.51095 .07077 L
.51095 .01472 L
F
P
p
.004 w
.48905 .01472 m
.48905 .07077 L
.51095 .07077 L
.51095 .01472 L
.48905 .01472 L
s
P
P
p
p
.51642 .01472 m
.51642 .07077 L
.53831 .07077 L
.53831 .01472 L
F
P
p
.004 w
.51642 .01472 m
.51642 .07077 L
.53831 .07077 L
.53831 .01472 L
.51642 .01472 L
s
P
P
p
p
.54379 .01472 m
.54379 .07077 L
.56568 .07077 L
.56568 .01472 L
F
P
p
.004 w
.54379 .01472 m
.54379 .07077 L
.56568 .07077 L
.56568 .01472 L
.54379 .01472 L
s
P
P
p
p
.57115 .01472 m
.57115 .04274 L
.59305 .04274 L
.59305 .01472 L
F
P
p
.004 w
.57115 .01472 m
.57115 .04274 L
.59305 .04274 L
.59305 .01472 L
.57115 .01472 L
s
P
P
p
p
.59852 .01472 m
.59852 .04274 L
.62042 .04274 L
.62042 .01472 L
F
P
p
.004 w
.59852 .01472 m
.59852 .04274 L
.62042 .04274 L
.62042 .01472 L
.59852 .01472 L
s
P
P
p
p
.62589 .01472 m
.62589 .01472 L
.64778 .01472 L
.64778 .01472 L
F
P
p
.004 w
.62589 .01472 m
.62589 .01472 L
.64778 .01472 L
.64778 .01472 L
.62589 .01472 L
s
P
P
p
p
.65326 .01472 m
.65326 .01472 L
.67515 .01472 L
.67515 .01472 L
F
P
p
.004 w
.65326 .01472 m
.65326 .01472 L
.67515 .01472 L
.67515 .01472 L
.65326 .01472 L
s
P
P
p
p
.68062 .01472 m
.68062 .01472 L
.70252 .01472 L
.70252 .01472 L
F
P
p
.004 w
.68062 .01472 m
.68062 .01472 L
.70252 .01472 L
.70252 .01472 L
.68062 .01472 L
s
P
P
p
p
.70799 .01472 m
.70799 .01472 L
.72989 .01472 L
.72989 .01472 L
F
P
p
.004 w
.70799 .01472 m
.70799 .01472 L
.72989 .01472 L
.72989 .01472 L
.70799 .01472 L
s
P
P
p
p
.73536 .01472 m
.73536 .01472 L
.75725 .01472 L
.75725 .01472 L
F
P
p
.004 w
.73536 .01472 m
.73536 .01472 L
.75725 .01472 L
.75725 .01472 L
.73536 .01472 L
s
P
P
p
p
.76273 .01472 m
.76273 .01472 L
.78462 .01472 L
.78462 .01472 L
F
P
p
.004 w
.76273 .01472 m
.76273 .01472 L
.78462 .01472 L
.78462 .01472 L
.76273 .01472 L
s
P
P
p
p
.79009 .01472 m
.79009 .01472 L
.81199 .01472 L
.81199 .01472 L
F
P
p
.004 w
.79009 .01472 m
.79009 .01472 L
.81199 .01472 L
.81199 .01472 L
.79009 .01472 L
s
P
P
p
p
.81746 .01472 m
.81746 .01472 L
.83935 .01472 L
.83935 .01472 L
F
P
p
.004 w
.81746 .01472 m
.81746 .01472 L
.83935 .01472 L
.83935 .01472 L
.81746 .01472 L
s
P
P
p
p
.84483 .01472 m
.84483 .01472 L
.86672 .01472 L
.86672 .01472 L
F
P
p
.004 w
.84483 .01472 m
.84483 .01472 L
.86672 .01472 L
.86672 .01472 L
.84483 .01472 L
s
P
P
p
p
.87219 .01472 m
.87219 .01472 L
.89409 .01472 L
.89409 .01472 L
F
P
p
.004 w
.87219 .01472 m
.87219 .01472 L
.89409 .01472 L
.89409 .01472 L
.87219 .01472 L
s
P
P
p
p
.89956 .01472 m
.89956 .01472 L
.92146 .01472 L
.92146 .01472 L
F
P
p
.004 w
.89956 .01472 m
.89956 .01472 L
.92146 .01472 L
.92146 .01472 L
.89956 .01472 L
s
P
P
p
p
.92693 .01472 m
.92693 .01472 L
.94882 .01472 L
.94882 .01472 L
F
P
p
.004 w
.92693 .01472 m
.92693 .01472 L
.94882 .01472 L
.94882 .01472 L
.92693 .01472 L
s
P
P
p
p
.9543 .01472 m
.9543 .01472 L
.97619 .01472 L
.97619 .01472 L
F
P
p
.004 w
.9543 .01472 m
.9543 .01472 L
.97619 .01472 L
.97619 .01472 L
.9543 .01472 L
s
P
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{413, 256},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006M000100P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0WP000?mKWE/10000oe^MF`40003oFieK
0@000?mKMe/4o`=K1?lKF`40003oFgIK00?oFe/00U/00omKo`04F`03oe]K01QK0@000?mKMU/00omK
F`02F`03oe]K00AK00?oFe/065/10000oe]kF`03oe]K00AK00?oFe/065/10000oe]hF`?o0U/00omK
F`02F`03oe]K01QK0@000?mKNe/00omKo`04oa]K0@000?mKMU/00omKF`02F`03oe_o01mK0@000?mK
MU/00omKF`02F`04oe]KoaiK0@000?mKMe/4o`=K1OlJF`40000TF`03oe]K0?mKMU/1000095/00omK
F`3oFgIK0@0002AK00?oFe/0oe]fF`40000TF`03oe]K0?mKMU/1000095/00omKF`3oFgIK0@0001eK
oom]oa=K0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool02?l4F`06oe]Koe_o15/01_mKFomKo`=K00OoFe]Koe_o00=K00OoFe]Koe_o00=K00OoFe]K
oe_o00=K00OoFe]Koe_o00=K00OoFe]Koe_o00=K00OoFe]Koe_o00=K00OoFe]Koe_o00=K00OoFe]K
oe_o00=K00OoFe]Koe_o00=K00OoFe]Koe_o00=K00GoFe]Ko`0KF`40000TF`03oe_o00So00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`06o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo1E/00omKF`07F`03oe]K00IK
00?oFe/01e/00omKF`07F`03oe]K00MK00?oFe/01e/00omKF`07F`03oe]K00MK00?oFe/01e/00omK
F`07F`03oe]K00MK00?oFe/01e/00omKF`0MF`40000TF`03oe_o00So00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`06o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo1E/00omKF`07F`03oe]K00IK00?oFe/01e/00omK
F`07F`03oe]K00MK00?oFe/01e/00omKF`07F`03oe]K00MK00?oFe/01e/00omKF`07F`03oe]K00MK
00?oFe/01e/00omKF`0MF`40000TF`03oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`06o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00OoW5/1000095/00omKo`08o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01_l00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07oiaK0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01onLF`40000TF`03oe_o00So00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`06o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00OoW5/1000095/00omKo`08o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01_l00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07oiaK0@0002AK00?oFol02?l00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01onLF`40000TF`03oe_o00So00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`06o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00OoW5/1000095/;o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01_l00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07oiaK0@0002AK00?oFol02?l00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07ok1K0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07ok1K0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07ok1K0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07ok1K0@0002AK
00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07ok1K0@0002AK00?oFol02?l00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07ok1K0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07ok1K0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07ok1K0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07ok1K0@0002AK
2ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07ok1K0@0002AK00?oFol02?l00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07oliK
0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07oliK0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07oliK0@0002AK00?oFol0
2?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07oliK0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07oliK0@0002AK00?oFol02?l00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07oliK
0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07oliK0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07oliK0@0002AK00?oFol0
2?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07oliK0@0002AK2ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07oliK0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ooHF`40000TF`03oe_o00So
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`06o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
f5/1000095/00omKo`08o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01_l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07omQK0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ooHF`40000TF`03oe_o00So00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`06o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oof5/1000095/00omK
o`08o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01_l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07omQK0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ooHF`40000TF`03oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`06o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oof5/1000095/00omKo`08o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01_l00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07omQK0@0002AK
2ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ooHF`40000TF`03oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`06o`03Fooo00Oo00=Kool01ol00e_oo`07oomK0E/1000095/00omK
o`08o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01_l00e_oo`07o`03Fooo00Oo00=Kool01oooF`5K0@0002AK00?oFol02?l00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool0
1ol00e_oo`07o`03Fooo00Oooe/1F`40000TF`03oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`06o`03Fooo00Oo00=Kool01ol00e_o
o`07oomK0E/1000095/00omKo`08o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01_l00e_oo`07o`03Fooo00Oo00=Kool01oooF`5K0@0002AK
00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oooe/1F`40000TF`03oe_o00So00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`06o`03
Fooo00Oo00=Kool01ol00e_oo`07oomK0E/100005E/00omKF`02F`Co1U/00omKo`08o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01_l00e_o
o`07o`03Fooo00Oo00=Kool01oooF`5K0@0001EK00GoFe]Ko`04F`03oe]K00=K00?oFol02?l00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko
00=Kool01ol00e_oo`07o`03Fooo00Oooe/1F`40000EF`05oe]KFol015/00omKF`03F`_o00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`06o`03
Fooo00Oo00=Kool01ol00e_oo`07oomK0E/100005E/01OmKFe_o00AK00?oFe/00e/00omKo`08o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1_l00e_oo`07o`03Fooo00Oo00=Kool01oooF`5K0@0001EK00GoFe]Ko`04F`03oe]K00=K00?oFol0
2?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oooe/1F`40000EF`05oe]KFol015/00omKF`03F`03
oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`06o`03Fooo00Oo00=Kool01ol00e_oo`07oomK0E/100004e/3o`=K00?oFe/00U/00omK
F`03F`03oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`06o`03Fooo00Oo00=Kool01ol00e_oo`07oomK0E/100005E/01OmKFe_o00AK
00?oFe/00e/00omKo`08o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01_l00e_oo`07o`03Fooo00Oo00=Kool01oooF`5K0@0001EK00?oFe/0
0U/4o`IK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oooe/1F`40000TF`03oe_o00So
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`06o`03Fooo00Oo00=Kool01ol00e_oo`07oomK0E/1000095/00omKo`08o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01_l00e_oo`07o`03
Fooo00Oo00=Kool01oooF`5K0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko00=Kool01ol00e_oo`07o`03Fooo00Oo
oe/1F`40000TF`03oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`06o`03Fooo00Oo00=Kool01ol00e_oo`07oomK0E/1000095/;o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1_l00e_oo`07o`03Fooo00Oo00=Kool01oooF`5K0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Kooe/OF`40000TF`03
oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`06oomK7e/1000095/00omKo`08o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01_ooFamK0@0002AK00?oFol02?l00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Kooe/OF`40
000TF`03oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`06oomK7e/1000095/00omKo`08o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01_ooFamK0@0002AK00?oFol02?l00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko
oe/OF`40000TF`03oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`06oomK7e/1000095/00omKo`08o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01_ooFamK0@0002AK2ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Ko
oe/OF`40000TF`03oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`06oomK7e/1000095/00omKo`08o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01_ooFamK0@0002AK00?oFol0
2?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Kooe/OF`40000TF`03oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`06oomK7e/1000095/00omKo`08o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01_ooFamK0@0002AK
00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Kooe/OF`40000TF`03oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`06oomK7e/1000095/00omKo`08o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01_ooFamK
0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Kooe/OF`40000TF`_o00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`06oomK7e/1000095/00omKo`08o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01oooFcaK0@0002AK00?oFol02?l00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oooe/lF`40000TF`03oe_o00So00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07oomK?5/1000095/00omKo`08o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oo00=Kool01oooFcaK0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07o`03Fooo00Oooe/lF`40000TF`03oe_o00So00=Kool01ol00e_oo`07o`03
Fooo00Oo00=Kool01ol00e_oo`07oomK?5/1000095/00omKo`08o`03Fooo00Oo00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01oooFcaK0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oooe/lF`40000TF`03oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01ol00e_oo`07oomK?5/1000095/;o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01oooFcaK0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07oomK
AU/1000095/00omKo`08o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oooe]6F`40000TF`03
oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01oooFdIK0@0002AK00?oFol02?l00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07oomKAU/1000095/00omKo`08o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oooe]6F`40000TF`03oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01oooFdIK0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07oomK
AU/100004U/6o`9K1?l6F`03oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01oooFdIK
0@00019K00?oFe/015/00omKF`02F`03oe]K00=K00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool0
1ol00e_oo`07oomKAU/100004e/00omKF`03F`03oe]K009K00?oFe/00e/;o`03Fooo00Oo00=Kool0
1ol00e_oo`07o`03Fooo00Oooe]6F`40000DF`;o0e/00omKF`02F`03oe]K00=K00?oFol02?l00e_o
o`07o`03Fooo00Oo00=Kool01ol00e_oo`07oomKAU/100005U/01?mKFol4F`03oe]K00=K00?oFol0
2?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07oomKAU/100005e/00omKo`04F`03oe]K00=K
00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07oomKAU/100004U/00omKF`02F`03
oe_o00AK00?oFe/00e/00omKo`08o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oooe]6F`40
000BF`03oe]K009K00?oFol015/00omKF`03F`03oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo
00=Kool01oooFdIK0@0001=K1?l3F`Co1U/00omKo`08o`03Fooo00Oo00=Kool01ol00e_oo`07o`03
Fooo00Oooe]6F`40000TF`03oe_o00So00=Kool01ol00e_oo`07o`03Fooo00Oo00=Kool01oooFdIK
0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01ol00e_oo`07oomKAU/1000095/00omK
o`08o`03Fooo00Oo00=Kool01ol00e_oo`07o`03Fooo00Oooe]6F`40000TF`_o00=Kool01ol00e_o
o`07o`03Fooo00Oo00=Kool01oooFdIK0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool0
1oooFe1K0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01oooFe1K0@0002AK00?oFol0
2?l00e_oo`07o`03Fooo00Oo00=Kool01oooFe1K0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo
00=Kool01oooFe1K0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01oooFe1K0@0002AK
00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01oooFe1K0@0002AK00?oFol02?l00e_oo`07o`03
Fooo00Oo00=Kool01oooFe1K0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01oooFe1K
0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oo00=Kool01oooFe1K0@0002AK00?oFol02?l00e_o
o`07o`03Fooo00Oo00=Kool01oooFe1K0@0002AK2ol00e_oo`07o`03Fooo00Oo00=Kool01oooFe1K
0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oooe]JF`40000TF`03oe_o00So00=Kool01ol00e_o
o`07oomKFU/1000095/00omKo`08o`03Fooo00Oo00=Kool01oooFeYK0@0002AK00?oFol02?l00e_o
o`07o`03Fooo00Oooe]JF`40000TF`03oe_o00So00=Kool01ol00e_oo`07oomKFU/1000095/00omK
o`08o`03Fooo00Oo00=Kool01oooFeYK0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oooe]JF`40
000TF`03oe_o00So00=Kool01ol00e_oo`07oomKFU/1000095/00omKo`08o`03Fooo00Oo00=Kool0
1oooFeYK0@0002AK2ol00e_oo`07o`03Fooo00Oooe]JF`40000TF`03oe_o00So00=Kool01ol00e_o
o`07oomKFU/1000095/00omKo`08o`03Fooo00Oo00=Kool01oooFeYK0@0002AK00?oFol02?l00e_o
o`07o`03Fooo00Oooe]JF`40000TF`03oe_o00So00=Kool01ol00e_oo`07oomKFU/1000095/00omK
o`08o`03Fooo00Oo00=Kool01oooFeYK0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oooe]JF`40
000TF`03oe_o00So00=Kool01ol00e_oo`07oomKFU/1000095/00omKo`08o`03Fooo00Oo00=Kool0
1oooFeYK0@0002AK00?oFol02?l00e_oo`07o`03Fooo00Oooe]JF`40000TF`_o00=Kool01ol00e_o
o`07oomKFU/1000095/00omKo`08o`03Fooo00Oooe]TF`40000TF`03oe_o00So00=Kool01oooFfAK
0@0002AK00?oFol02?l00e_oo`07oomKI5/1000095/00omKo`08o`03Fooo00Oooe]TF`40000TF`03
oe_o00So00=Kool01oooFfAK0@0002AK00?oFol02?l00e_oo`07oomKI5/1000095/00omKo`08o`03
Fooo00Oooe]TF`40000CF`Co0e/4o`IK00?oFol02?l00e_oo`07oomKI5/100004U/00omKF`02F`03
oe_o00AK00?oFe/00e/00omKo`08o`03Fooo00Oooe]TF`40000BF`03oe]K009K00?oFol015/00omK
F`03F`_o00=Kool01oooFfAK0@0001MK00?oFol015/00omKF`03F`03oe_o00So00=Kool01oooFfAK
0@0001AK0ol2F`03oe]K009K00?oFe/00e/00omKo`08o`03Fooo00Oooe]TF`40000GF`03oe_o00AK
00?oFe/00e/00omKo`08o`03Fooo00Oooe]TF`40000BF`03oe]K009K00?oFol015/00omKF`03F`03
oe_o00So00=Kool01oooFfAK0@00019K00?oFe/00U/00omKo`04F`03oe]K00=K00?oFol02?l00e_o
o`07oomKI5/100004e/4o`=K1?l6F`03oe_o00So00=Kool01oooFfAK0@0002AK00?oFol02?l00e_o
o`07oomKI5/1000095/00omKo`08o`03Fooo00Oooe]TF`40000TF`03oe_o00So00=Kool01oooFfAK
0@0002AK2ol00e_oo`07oomKI5/1000095/00omKo`08o`03Fooo00Oooe]TF`40000TF`03oe_o00So
00=Kool01oooFfAK0@0002AK00?oFol02?l00e_oo`07oomKI5/1000095/00omKo`08o`03Fooo00Oo
oe]TF`40000TF`03oe_o00So00=Kool01oooFfAK0@0002AK00?oFol02?l00e_oo`07oomKI5/10000
95/00omKo`08o`03Fooo00Oooe]TF`40000TF`03oe_o00So00=Kool01oooFfAK0@0002AK00?oFol0
2?l00e_oo`07oomKI5/1000095/;o`03Fooo00Oooe]TF`40000TF`03oe_o00So00=Kool01oooFfAK
0@0002AK00?oFol02?l00e_oo`07oomKI5/1000095/00omKo`08o`03Fooo00Oooe]TF`40000TF`03
oe_o00So00=Kool01oooFfAK0@0002AK00?oFol02?l00e_oo`07oomKI5/1000095/00omKo`08o`03
Fooo00Oooe]TF`40000TF`03oe_o00So00=Kool01oooFfAK0@0002AK00?oFol02?l00e_oo`07oomK
I5/1000095/00omKo`08o`03Fooo00Oooe]TF`40000TF`03oe_o00So00=Kool01oooFfAK0@0002AK
2ol00e_oo`07oomKI5/1000095/00omKo`08o`03Fooo00Oooe]TF`40000TF`03oe_o00So00=Kool0
1oooFfAK0@0002AK00?oFol02?l00e_oo`07oomKI5/1000095/00omKo`08o`03Fooo00Oooe]TF`40
000TF`03oe_o00So00=Kool01oooFfAK0@0002AK00?oFol02?l00e_oo`07oomKI5/1000095/00omK
o`08o`03Fooo00Oooe]TF`40000TF`03oe_o00So00=Kool01oooFfAK0@0002AK00?oFol02?l00e_o
o`07oomKI5/1000095/;o`03Fooo00Oooe]TF`40000TF`03oe_o00Sooe]^F`40000TF`03oe_o00So
oe]^F`40000TF`03oe_o00Sooe]^F`40000TF`03oe_o00Sooe]^F`40000TF`03oe_o00Sooe]^F`40
000TF`03oe_o00Sooe]^F`40000TF`03oe_o00Sooe]^F`40000FF`04oe]KF`Co1U/00omKo`08oomK
KU/100005U/01?mKFol4F`03oe]K00=K00?oFol02?ooFfiK0@00019K1_l00e_oF`03F`03oe]K00=K
2oooFfiK0@00019K00GoFe]Ko`02F`03oe]K009K00?oFe/00e/00omKo`08oomKKU/100004e/01?mK
Fol2F`03oe]K009K00?oFe/00e/00omKo`08oomKKU/1000055/00omKo`02F`03oe]K009K00?oFe/0
0e/00omKo`08oomKKU/1000055/00omKo`02F`03oe]K009K00?oFe/00e/00omKo`08oomKKU/10000
5E/2o`9K00?oFe/00U/00omKF`03F`03oe_o00Sooe]^F`40000FF`04oe]KF`Co1U/00omKo`08oomK
KU/1000095/00omKo`08oomKKU/1000095/00omKo`08oomKKU/1000095/00omKo`08oomKKU/10000
95/;oomKKU/1000095/00omKF`3oFgIK0@0002AK00?oFe/0oe]fF`40000TF`03oe]K0?mKMU/10000
95/00omKF`3oFgIK0@0002AK00?oFe/0oe]fF`40003oFieK0@000?mKWE/10000oe^MF`40003oFieK
0@000?mKWE/10000oe^MF`40003aF`CoYe/10000l5/2o`9K0_lHF`03oe]K08]K0@000?AK0_lIF`03
oe]K08YK0@00071K1Ol3F`?o0U/2o`AK0ol00e_oo`02o`=K1Ol5F`;o1E/2o`9K1Ol2F`;o0U/4o`=K
1?l3F`Co0U/4o`=K1?l6F`;o0e/2o`03Fooo009K1?l3F`?o0U/3o`=K1Ol00e_oo`04F`Go00=Kool0
0U/2o`9K0_l00e_oo`07F`Co00=Koe/01?l2F`;o0U/2o`9K0_l5F`CoIE/10000Ke/2o`=K0_l015_o
oe/2o`03Fooo00AK0_l00e_oo`02F`;o00=Kool00U/2o`EK0_l5F`;o0U/2o`03Fooo009K0_l00e_o
o`02F`;o00=Kool00U/2o`03Fooo009K1?l2F`;o00=Kool00U/2o`EK0_l3F`;o00AKoomK0_l2F`;o
0U/2o`9K0_l015_ooe/2o`9K0_l00e_oo`03F`;o0U/2o`03Fooo009K0_l2F`;o00=Kool01U/2o`9K
1Ol2F`;o00=Kool00U/2o`9K0_l4F`;o0U/2ofAK0@0006mK0_l3F`Co0e/4o`AK0_l00e_oo`05F`;o
0U/2o`EK0_l5F`;o0U/2o`03Fooo009K0_l00e_oo`08F`?o15/5o`QK0ol5F`;o0e/2o`03Fooo00AK
0ol2F`;o00=Kool00e/4o`9K0_l00e_oo`03F`;o0U/2o`03Fooo009K0_l2F`;o25/2o`AK1?l5F`;o
0U/2o`QK0_l2F`;oI5/10000Le/5o`=K1?l4F`;o00=Kool01?l00e_oo`02F`;o1E/2o`EK0_l2F`;o
00=Kool00U/2o`03Fooo00Co0U/4o`=K1?l00e_oo`04o`9K1?l6F`;o0e/2o`03Fooo009K1?l3F`;o
00=Kool00e/4o`9K0_l00e_oo`04F`;o00AKoomK0_l2F`;o0U/2o`QK0_l4F`So00=Kool00U/2o`QK
0_l2F`;oI5/10000L5/5o`03Fooo00=K1?l4F`;o00=Kool00U/2o`03Fooo009K0_l5F`Go0U/2o`9K
0_l00e_oo`02F`;o00=Kool00U/2o`04Foooo`AK0ol3F`;o0U/2o`04Foooo`QK0_l3F`;o00AKoomK
0ol5F`;o00=Kool00e/4o`9K0_l00e_oo`06F`?o00=Kool00U/2o`9K0_l8F`;o0U/6o`9K0_l00e_o
o`02F`;o25/2o`9K0_mTF`40001_F`?o1E/2o`04FoooF`?o0e/2o`03Fooo009K0_l00e_oo`02F`;o
1E/2o`EK0_l2F`;o00=Kool00U/2o`03Fooo009K0_l00e_oo`02F`;o00=Kool00U/4o`9K0_l00e_o
o`02F`;o1E/7o`04FoooF`;o0U/2o`9K0_l2F`;o00AKoomK0_l2F`;o00AKoooo0U/2o`9K0_l00e_o
o`02F`;o0U/2o`QK0_l6F`;o0U/2o`03Fooo009K0_l8F`;o0U/2ofAK0@0006mK0_l3F`;o0U/3o`9K
0ol2F`Co00=Kool00_l3F`Go1E/2o`EK0_l00e_oo`07o`=K1?l3F`Co0e/4o`9K1?l3F`Co1U/2o`=K
0_l00e_oo`02F`Co0U/4o`9K0ol3F`Go00AKoooo0e/5o`03Fooo00Oo2E/2o`AK0_l00e_oo`02o`9K
1Ol9F`;o0U/2ofAK0@0006mK0_l3F`;o3E/2o`aK0_l5F`;o2E/2obiK0_l3F`;o35/2obiK0_l2F`;o
5U/2o`9K0_mTF`40001`F`Go3U/2o`aK0_l5F`Ko00=Kool00U/2obiK0_l3F`;o00=Kool02E/2obmK
1?lHF`CoIE/10000\
\>"],
  ImageRangeCache->{{{0, 412}, {255, 0}} -> {-3.28162, -3.5382, 0.100663, 
  0.196574}}],

Cell[TextData[
"visualizeExpressions::fitnessesInfo: \n   Fitnesses: {12, 42, 8, 8, 8, 0, 8, \
6, 38, 12, 16, 4, <<17>>, 22, 0, 0, \n     4, 18, 0}"], "Message",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData["visualizeExpressions::fitnessMax: Max. Fitness: 42"], "Message",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.0238095 0.952381 0.0147151 0.588604 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
% Start of sub-graphic
p
0.0238095 0.0147151 0.97619 0.603319 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.136054 0.0169173 0.136054 [
p
/Times findfont 14 scalefont setfont
[(Gen. 0)] .5 .71053 0 -2 Msboxa
P
[ 0 0 0 0 ]
[ 1 .71053 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
p
/Times findfont 14 scalefont setfont
[(Gen. 0)] .5 .71053 0 -2 Mshowa
P
P
0 0 m
1 0 L
1 .71053 L
0 .71053 L
closepath
clip
newpath
p
p
% Start of sub-graphic
p
0.0238095 0.0169173 0.149123 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.0169173 0.286967 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.80614 .80506 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.68855 .7548 L
s
P
p
0 .4 1 r
.02 w
.81335 .90655 m
.80614 .80506 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.0169173 0.424812 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.416205 1.93249 0.0248741 0.994963 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.89832 .67057 m
.84375 .6392 L
s
P
p
.2 1 0 r
.02 w
.90271 .72449 m
.89832 .67057 L
s
P
p
.2 1 0 r
.02 w
.84009 .5862 m
.7845 .55347 L
s
P
p
.2 1 0 r
.02 w
.84375 .6392 m
.84009 .5862 L
s
P
p
.2 1 0 r
.02 w
.84751 .69354 m
.90271 .72449 L
s
P
p
.2 1 0 r
.02 w
.7845 .55347 m
.78751 .60685 L
s
P
p
.2 1 0 r
.02 w
.72494 .4673 m
.66657 .43213 L
s
P
p
.2 1 0 r
.02 w
.72719 .51972 m
.72494 .4673 L
s
P
p
.2 1 0 r
.02 w
.79059 .66163 m
.84751 .69354 L
s
P
p
.2 1 0 r
.02 w
.78751 .60685 m
.7295 .5735 L
s
P
p
.2 1 0 r
.02 w
.7295 .5735 m
.72719 .51972 L
s
P
p
.2 1 0 r
.02 w
.66657 .43213 m
.66809 .48491 L
s
P
p
.2 1 0 r
.02 w
.85137 .7493 m
.79376 .71785 L
s
P
p
.2 1 0 r
.02 w
.85532 .80652 m
.85137 .7493 L
s
P
p
.2 1 0 r
.02 w
.79376 .71785 m
.79059 .66163 L
s
P
p
.2 1 0 r
.02 w
.66809 .48491 m
.6071 .449 L
s
P
p
.2 1 0 r
.02 w
.79701 .77556 m
.85532 .80652 L
s
P
p
.2 1 0 r
.02 w
.66965 .53909 m
.67125 .59472 L
s
P
p
.2 1 0 r
.02 w
.60787 .50356 m
.66965 .53909 L
s
P
p
.01 w
.6071 .449 Mdot
P
p
.2 1 0 r
.02 w
.6071 .449 m
.60787 .50356 L
s
P
p
.01 w
.61877 .44702 Mdot
P
p
0 .4 1 r
.02 w
.61969 .50161 m
.61877 .44702 L
s
P
p
0 .4 1 r
.02 w
.55586 .35636 m
.49184 .31765 L
s
P
p
0 .4 1 r
.02 w
.55594 .40988 m
.55586 .35636 L
s
P
p
.2 1 0 r
.02 w
.80035 .83484 m
.79701 .77556 L
s
P
p
.2 1 0 r
.02 w
.7343 .68538 m
.7368 .7436 L
s
P
p
.2 1 0 r
.02 w
.6729 .65186 m
.7343 .68538 L
s
P
p
.2 1 0 r
.02 w
.67125 .59472 m
.60866 .55962 L
s
P
p
0 .4 1 r
.02 w
.62064 .55769 m
.61969 .50161 L
s
P
p
0 .4 1 r
.02 w
.55602 .46485 m
.61969 .50161 L
s
P
p
0 .4 1 r
.02 w
.55594 .40988 m
.55602 .46485 L
s
P
p
0 .4 1 r
.02 w
.49105 .37151 m
.55594 .40988 L
s
P
p
.2 1 0 r
.02 w
.73936 .80341 m
.80035 .83484 L
s
P
p
0 .4 1 r
.02 w
.49184 .31765 m
.49105 .37151 L
s
P
p
.2 1 0 r
.02 w
.7368 .7436 m
.73936 .80341 L
s
P
p
.2 1 0 r
.02 w
.67459 .71058 m
.6729 .65186 L
s
P
p
.2 1 0 r
.02 w
.60866 .55962 m
.54398 .52335 L
s
P
p
0 .4 1 r
.02 w
.62162 .61531 m
.62064 .55769 L
s
P
p
0 .4 1 r
.02 w
.62064 .55769 m
.5561 .52136 L
s
P
p
.2 1 0 r
.02 w
.6103 .67644 m
.67459 .71058 L
s
P
p
.2 1 0 r
.02 w
.60947 .61722 m
.6103 .67644 L
s
P
p
.2 1 0 r
.02 w
.54389 .58142 m
.60947 .61722 L
s
P
p
0 .4 1 r
.02 w
.62262 .67456 m
.62162 .61531 L
s
P
p
.2 1 0 r
.02 w
.54398 .52335 m
.54389 .58142 L
s
P
p
0 .4 1 r
.02 w
.5561 .52136 m
.48938 .4838 L
s
P
p
0 .4 1 r
.02 w
.49023 .42687 m
.48938 .4838 L
s
P
p
0 .4 1 r
.02 w
.4222 .38761 m
.49023 .42687 L
s
P
p
0 .4 1 r
.02 w
.35736 .23633 m
.28668 .19358 L
s
P
p
0 .4 1 r
.02 w
.35463 .29087 m
.35736 .23633 L
s
P
p
0 .4 1 r
.02 w
.62365 .73549 m
.62262 .67456 L
s
P
p
0 .4 1 r
.02 w
.29037 .14025 m
.21834 .09574 L
s
P
p
0 .4 1 r
.02 w
.28668 .19358 m
.29037 .14025 L
s
P
p
0 .4 1 r
.02 w
.48938 .4838 m
.48851 .54235 L
s
P
p
0 .4 1 r
.02 w
.42036 .44494 m
.48938 .4838 L
s
P
p
0 .4 1 r
.02 w
.42036 .44494 m
.4222 .38761 L
s
P
p
0 .4 1 r
.02 w
.35182 .34698 m
.35463 .29087 L
s
P
p
0 .4 1 r
.02 w
.62472 .79818 m
.62365 .73549 L
s
P
p
0 .4 1 r
.02 w
.21834 .09574 m
.1438 .04968 L
s
P
p
0 .4 1 r
.02 w
.48851 .54235 m
.41848 .50395 L
s
P
p
0 .4 1 r
.02 w
.34893 .40473 m
.42036 .44494 L
s
P
p
0 .4 1 r
.02 w
.27897 .30493 m
.35182 .34698 L
s
P
p
0 .4 1 r
.02 w
.55646 .76396 m
.62472 .79818 L
s
P
p
0 .4 1 r
.02 w
.1438 .04968 m
.13782 .10356 L
s
P
p
0 .4 1 r
.02 w
.41848 .50395 m
.41653 .5647 L
s
P
p
0 .4 1 r
.02 w
.27494 .36308 m
.34893 .40473 L
s
P
p
0 .4 1 r
.02 w
.34893 .40473 m
.34595 .46419 L
s
P
p
0 .4 1 r
.02 w
.27494 .36308 m
.27897 .30493 L
s
P
p
0 .4 1 r
.02 w
.48576 .7285 m
.55646 .76396 L
s
P
p
0 .4 1 r
.02 w
.4867 .66462 m
.48576 .7285 L
s
P
p
0 .4 1 r
.02 w
.41453 .62728 m
.4867 .66462 L
s
P
p
0 .4 1 r
.02 w
.13782 .10356 m
.13166 .15905 L
s
P
p
0 .4 1 r
.02 w
.41653 .5647 m
.41453 .62728 L
s
P
p
0 .4 1 r
.02 w
.34595 .46419 m
.27079 .42299 L
s
P
p
0 .4 1 r
.02 w
.27079 .42299 m
.27494 .36308 L
s
P
p
0 .4 1 r
.02 w
.19827 .31992 m
.27494 .36308 L
s
P
p
0 .4 1 r
.02 w
.13166 .15905 m
.12531 .21623 L
s
P
p
0 .4 1 r
.02 w
.11876 .27517 m
.19827 .31992 L
s
P
p
0 .4 1 r
.02 w
.12531 .21623 m
.11876 .27517 L
s
P
p
0 .4 1 r
.02 w
.26651 .48474 m
.18729 .44251 L
s
P
p
0 .4 1 r
.02 w
.26211 .5484 m
.26651 .48474 L
s
P
p
0 .4 1 r
.02 w
.19287 .38027 m
.11201 .33595 L
s
P
p
0 .4 1 r
.02 w
.18729 .44251 m
.19287 .38027 L
s
P
p
0 .4 1 r
.02 w
.11201 .33595 m
.11876 .27517 L
s
P
p
0 .4 1 r
.02 w
.18155 .50671 m
.26211 .5484 L
s
P
p
0 .4 1 r
.02 w
.18729 .44251 m
.18155 .50671 L
s
P
p
0 .4 1 r
.02 w
.10505 .39867 m
.11201 .33595 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.0169173 0.562657 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.639927 2.36775 0.0239246 0.956984 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87469 .65339 m
.78312 .61313 L
s
P
p
.2 1 0 r
.02 w
.88113 .72406 m
.87469 .65339 L
s
P
p
.2 1 0 r
.02 w
.77853 .54431 m
.68433 .50132 L
s
P
p
.2 1 0 r
.02 w
.78312 .61313 m
.77853 .54431 L
s
P
p
.2 1 0 r
.02 w
.78789 .68469 m
.88113 .72406 L
s
P
p
.2 1 0 r
.02 w
.68433 .50132 m
.68714 .57092 L
s
P
p
.2 1 0 r
.02 w
.58477 .38863 m
.48321 .34065 L
s
P
p
.2 1 0 r
.02 w
.58559 .45625 m
.58477 .38863 L
s
P
p
0 .4 1 r
.02 w
.50292 .27235 m
.50209 .33798 L
s
P
p
0 .4 1 r
.02 w
.39882 .22127 m
.50292 .27235 L
s
P
p
0 .4 1 r
.02 w
.40171 .1577 m
.39882 .22127 L
s
P
p
0 .4 1 r
.02 w
.29471 .10362 m
.40171 .1577 L
s
P
p
.2 1 0 r
.02 w
.69007 .64338 m
.78789 .68469 L
s
P
p
.2 1 0 r
.02 w
.68714 .57092 m
.58644 .52665 L
s
P
p
.2 1 0 r
.02 w
.58644 .52665 m
.58559 .45625 L
s
P
p
.2 1 0 r
.02 w
.48321 .34065 m
.48196 .40895 L
s
P
p
0 .4 1 r
.02 w
.50209 .33798 m
.39581 .28748 L
s
P
p
.2 1 0 r
.02 w
.79285 .75916 m
.69312 .71886 L
s
P
p
.2 1 0 r
.02 w
.79803 .83673 m
.79285 .75916 L
s
P
p
0 .4 1 r
.02 w
.28953 .16765 m
.29471 .10362 L
s
P
p
.2 1 0 r
.02 w
.69312 .71886 m
.69007 .64338 L
s
P
p
.2 1 0 r
.02 w
.48196 .40895 m
.37308 .35925 L
s
P
p
0 .4 1 r
.02 w
.39581 .28748 m
.39268 .35649 L
s
P
p
.2 1 0 r
.02 w
.6963 .79755 m
.79803 .83673 L
s
P
p
0 .4 1 r
.02 w
.28412 .23441 m
.28953 .16765 L
s
P
p
.2 1 0 r
.02 w
.48066 .48013 m
.47929 .55437 L
s
P
p
.2 1 0 r
.02 w
.36939 .4312 m
.48066 .48013 L
s
P
p
.01 w
.37308 .35925 Mdot
P
p
.2 1 0 r
.02 w
.37308 .35925 m
.36939 .4312 L
s
P
p
.01 w
.39268 .35649 Mdot
P
p
0 .4 1 r
.02 w
.39268 .35649 m
.38941 .42848 L
s
P
p
0 .4 1 r
.02 w
.16658 .17855 m
.28412 .23441 L
s
P
p
.2 1 0 r
.02 w
.69961 .87967 m
.6963 .79755 L
s
P
p
.2 1 0 r
.02 w
.58826 .67648 m
.58923 .75631 L
s
P
p
.2 1 0 r
.02 w
.47787 .63187 m
.58826 .67648 L
s
P
p
.2 1 0 r
.02 w
.47929 .55437 m
.36554 .50633 L
s
P
p
0 .4 1 r
.02 w
.38941 .42848 m
.27259 .37681 L
s
P
p
0 .4 1 r
.02 w
.27848 .30406 m
.15817 .24883 L
s
P
p
0 .4 1 r
.02 w
.27259 .37681 m
.27848 .30406 L
s
P
p
.2 1 0 r
.02 w
.59024 .83971 m
.69961 .87967 L
s
P
p
0 .4 1 r
.02 w
.15817 .24883 m
.16658 .17855 L
s
P
p
.2 1 0 r
.02 w
.58923 .75631 m
.59024 .83971 L
s
P
p
.2 1 0 r
.02 w
.47639 .71285 m
.47787 .63187 L
s
P
p
.2 1 0 r
.02 w
.36554 .50633 m
.24559 .45568 L
s
P
p
.2 1 0 r
.02 w
.3573 .66698 m
.47639 .71285 L
s
P
p
.2 1 0 r
.02 w
.36151 .58484 m
.3573 .66698 L
s
P
p
.2 1 0 r
.02 w
.23867 .5352 m
.36151 .58484 L
s
P
p
.2 1 0 r
.02 w
.24559 .45568 m
.23867 .5352 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.0169173 0.700501 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.466291 2.03299 0.0246585 0.986339 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.88519 .6063 m
.81439 .56704 L
s
P
p
.2 1 0 r
.02 w
.89077 .67127 m
.88519 .6063 L
s
P
p
.2 1 0 r
.02 w
.81004 .50357 m
.73749 .46211 L
s
P
p
.2 1 0 r
.02 w
.81439 .56704 m
.81004 .50357 L
s
P
p
.2 1 0 r
.02 w
.81888 .63266 m
.89077 .67127 L
s
P
p
.2 1 0 r
.02 w
.73749 .46211 m
.74068 .52616 L
s
P
p
.2 1 0 r
.02 w
.66007 .35647 m
.58268 .31097 L
s
P
p
.2 1 0 r
.02 w
.66195 .41894 m
.66007 .35647 L
s
P
p
.2 1 0 r
.02 w
.74399 .59244 m
.81888 .63266 L
s
P
p
.2 1 0 r
.02 w
.74068 .52616 m
.66389 .48358 L
s
P
p
.2 1 0 r
.02 w
.66389 .48358 m
.66195 .41894 L
s
P
p
.2 1 0 r
.02 w
.58268 .31097 m
.58324 .37396 L
s
P
p
.2 1 0 r
.02 w
.82352 .70055 m
.74741 .66106 L
s
P
p
.2 1 0 r
.02 w
.82833 .77083 m
.82352 .70055 L
s
P
p
.2 1 0 r
.02 w
.74741 .66106 m
.74399 .59244 L
s
P
p
0 .4 1 r
.02 w
.75908 .59021 m
.68124 .54819 L
s
P
p
0 .4 1 r
.02 w
.76277 .65887 m
.75908 .59021 L
s
P
p
.2 1 0 r
.02 w
.58324 .37396 m
.50117 .32705 L
s
P
p
0 .4 1 r
.02 w
.51701 .26094 m
.43311 .21138 L
s
P
p
0 .4 1 r
.02 w
.51641 .32445 m
.51701 .26094 L
s
P
p
.2 1 0 r
.02 w
.75095 .73214 m
.82833 .77083 L
s
P
p
0 .4 1 r
.02 w
.6836 .61757 m
.76277 .65887 L
s
P
p
0 .4 1 r
.02 w
.68124 .54819 m
.6 .50434 L
s
P
p
.2 1 0 r
.02 w
.58383 .43918 m
.58444 .50676 L
s
P
p
.2 1 0 r
.02 w
.50028 .39284 m
.58383 .43918 L
s
P
p
.01 w
.50117 .32705 Mdot
P
p
.2 1 0 r
.02 w
.50117 .32705 m
.50028 .39284 L
s
P
p
.01 w
.51641 .32445 Mdot
P
p
0 .4 1 r
.02 w
.5158 .39027 m
.51641 .32445 L
s
P
p
0 .4 1 r
.02 w
.43311 .21138 m
.43098 .27538 L
s
P
p
.2 1 0 r
.02 w
.75463 .80583 m
.75095 .73214 L
s
P
p
.2 1 0 r
.02 w
.668 .61986 m
.67016 .69175 L
s
P
p
.2 1 0 r
.02 w
.58507 .57683 m
.668 .61986 L
s
P
p
0 .4 1 r
.02 w
.6836 .61757 m
.60092 .57445 L
s
P
p
.2 1 0 r
.02 w
.58444 .50676 m
.49935 .46107 L
s
P
p
0 .4 1 r
.02 w
.6 .50434 m
.60092 .57445 L
s
P
p
0 .4 1 r
.02 w
.51516 .45853 m
.6 .50434 L
s
P
p
0 .4 1 r
.02 w
.42876 .34175 m
.5158 .39027 L
s
P
p
0 .4 1 r
.02 w
.5158 .39027 m
.51516 .45853 L
s
P
p
0 .4 1 r
.02 w
.43098 .27538 m
.42876 .34175 L
s
P
p
.2 1 0 r
.02 w
.67241 .76634 m
.75463 .80583 L
s
P
p
.2 1 0 r
.02 w
.67016 .69175 m
.67241 .76634 L
s
P
p
.2 1 0 r
.02 w
.58573 .64954 m
.58507 .57683 L
s
P
p
0 .4 1 r
.02 w
.60092 .57445 m
.5145 .52937 L
s
P
p
.2 1 0 r
.02 w
.49935 .46107 m
.4104 .4133 L
s
P
p
0 .4 1 r
.02 w
.42646 .41065 m
.42876 .34175 L
s
P
p
.2 1 0 r
.02 w
.4974 .60538 m
.58573 .64954 L
s
P
p
.2 1 0 r
.02 w
.49839 .53186 m
.4974 .60538 L
s
P
p
.2 1 0 r
.02 w
.4077 .48481 m
.49839 .53186 L
s
P
p
0 .4 1 r
.02 w
.5145 .52937 m
.51381 .60293 L
s
P
p
.2 1 0 r
.02 w
.4104 .4133 m
.4077 .48481 L
s
P
p
0 .4 1 r
.02 w
.33363 .36053 m
.42646 .41065 L
s
P
p
0 .4 1 r
.02 w
.51381 .60293 m
.42158 .55658 L
s
P
p
0 .4 1 r
.02 w
.5131 .67939 m
.51381 .60293 L
s
P
p
0 .4 1 r
.02 w
.42407 .4822 m
.32934 .43279 L
s
P
p
0 .4 1 r
.02 w
.42158 .55658 m
.42407 .4822 L
s
P
p
0 .4 1 r
.02 w
.23637 .30803 m
.33363 .36053 L
s
P
p
0 .4 1 r
.02 w
.32934 .43279 m
.33363 .36053 L
s
P
p
0 .4 1 r
.02 w
.51236 .7589 m
.5131 .67939 L
s
P
p
0 .4 1 r
.02 w
.419 .63394 m
.42158 .55658 L
s
P
p
0 .4 1 r
.02 w
.23002 .38098 m
.32934 .43279 L
s
P
p
0 .4 1 r
.02 w
.23637 .30803 m
.13437 .25296 L
s
P
p
0 .4 1 r
.02 w
.41631 .71447 m
.51236 .7589 L
s
P
p
0 .4 1 r
.02 w
.419 .63394 m
.41631 .71447 L
s
P
p
0 .4 1 r
.02 w
.12574 .32659 m
.23002 .38098 L
s
P
p
0 .4 1 r
.02 w
.13437 .25296 m
.12574 .32659 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.0169173 0.838346 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.559341 2.21998 0.0242236 0.968945 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87582 .63372 m
.78644 .59037 L
s
P
p
.2 1 0 r
.02 w
.88292 .70853 m
.87582 .63372 L
s
P
p
.2 1 0 r
.02 w
.78139 .51778 m
.68912 .47117 L
s
P
p
.2 1 0 r
.02 w
.78644 .59037 m
.78139 .51778 L
s
P
p
.2 1 0 r
.02 w
.79173 .66622 m
.88292 .70853 L
s
P
p
.2 1 0 r
.02 w
.68912 .47117 m
.69223 .54467 L
s
P
p
.2 1 0 r
.02 w
.59093 .35091 m
.49053 .29827 L
s
P
p
.2 1 0 r
.02 w
.59184 .42203 m
.59093 .35091 L
s
P
p
.2 1 0 r
.02 w
.6955 .62156 m
.79173 .66622 L
s
P
p
.2 1 0 r
.02 w
.69223 .54467 m
.59279 .49644 L
s
P
p
.2 1 0 r
.02 w
.59279 .49644 m
.59184 .42203 L
s
P
p
.2 1 0 r
.02 w
.49053 .29827 m
.48913 .37015 L
s
P
p
.2 1 0 r
.02 w
.79726 .74554 m
.69891 .70208 L
s
P
p
.2 1 0 r
.02 w
.80305 .82859 m
.79726 .74554 L
s
P
p
.2 1 0 r
.02 w
.69891 .70208 m
.6955 .62156 L
s
P
p
.2 1 0 r
.02 w
.48913 .37015 m
.38053 .31529 L
s
P
p
0 .4 1 r
.02 w
.50824 .36726 m
.40002 .31223 L
s
P
p
0 .4 1 r
.02 w
.50723 .4426 m
.50824 .36726 L
s
P
p
0 .4 1 r
.02 w
.40355 .23958 m
.40002 .31223 L
s
P
p
0 .4 1 r
.02 w
.29178 .1806 m
.40355 .23958 L
s
P
p
.2 1 0 r
.02 w
.70249 .78649 m
.80305 .82859 L
s
P
p
0 .4 1 r
.02 w
.29787 .11071 m
.18249 .0477 L
s
P
p
0 .4 1 r
.02 w
.29178 .1806 m
.29787 .11071 L
s
P
p
.2 1 0 r
.02 w
.48767 .44545 m
.48613 .52442 L
s
P
p
.2 1 0 r
.02 w
.37637 .39146 m
.48767 .44545 L
s
P
p
0 .4 1 r
.02 w
.39633 .38845 m
.50723 .4426 L
s
P
p
.01 w
.38053 .31529 Mdot
P
p
.2 1 0 r
.02 w
.38053 .31529 m
.37637 .39146 L
s
P
p
.01 w
.40002 .31223 Mdot
P
p
0 .4 1 r
.02 w
.40002 .31223 m
.2854 .25395 L
s
P
p
0 .4 1 r
.02 w
.40002 .31223 m
.39633 .38845 L
s
P
p
0 .4 1 r
.02 w
.17337 .11812 m
.29178 .1806 L
s
P
p
0 .4 1 r
.02 w
.2854 .25395 m
.29178 .1806 L
s
P
p
.2 1 0 r
.02 w
.70625 .87507 m
.70249 .78649 L
s
P
p
0 .4 1 r
.02 w
.18249 .0477 m
.17337 .11812 L
s
P
p
.2 1 0 r
.02 w
.59484 .65609 m
.59594 .74187 L
s
P
p
.2 1 0 r
.02 w
.48452 .60734 m
.59484 .65609 L
s
P
p
.2 1 0 r
.02 w
.48613 .52442 m
.37199 .47146 L
s
P
p
.2 1 0 r
.02 w
.59709 .83202 m
.70625 .87507 L
s
P
p
.2 1 0 r
.02 w
.59594 .74187 m
.59709 .83202 L
s
P
p
.2 1 0 r
.02 w
.48283 .69451 m
.48452 .60734 L
s
P
p
.2 1 0 r
.02 w
.37199 .47146 m
.25075 .4152 L
s
P
p
.2 1 0 r
.02 w
.36254 .64414 m
.48283 .69451 L
s
P
p
.2 1 0 r
.02 w
.36738 .55557 m
.36254 .64414 L
s
P
p
.2 1 0 r
.02 w
.24277 .50051 m
.36738 .55557 L
s
P
p
.2 1 0 r
.02 w
.25075 .4152 m
.24277 .50051 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.0169173 0.97619 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-1.18416 3.41557 -0.00823958 0.983648 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.83069 .36371 m
.7434 .33347 L
s
P
p
.2 1 0 r
.02 w
.83401 .40684 m
.83069 .36371 L
s
P
p
.2 1 0 r
.02 w
.74104 .29103 m
.6524 .25977 L
s
P
p
.2 1 0 r
.02 w
.7434 .33347 m
.74104 .29103 L
s
P
p
.2 1 0 r
.02 w
.74581 .37683 m
.83401 .40684 L
s
P
p
.2 1 0 r
.02 w
.6524 .25977 m
.65381 .30242 L
s
P
p
.2 1 0 r
.02 w
.561 .18576 m
.4686 .15262 L
s
P
p
.2 1 0 r
.02 w
.56141 .22769 m
.561 .18576 L
s
P
p
.2 1 0 r
.02 w
.65526 .34602 m
.74581 .37683 L
s
P
p
.2 1 0 r
.02 w
.65381 .30242 m
.56183 .27055 L
s
P
p
.2 1 0 r
.02 w
.56183 .27055 m
.56141 .22769 L
s
P
p
.2 1 0 r
.02 w
.4686 .15262 m
.46799 .19474 L
s
P
p
.2 1 0 r
.02 w
.74827 .42115 m
.65674 .3906 L
s
P
p
.2 1 0 r
.02 w
.75079 .46647 m
.74827 .42115 L
s
P
p
.2 1 0 r
.02 w
.65674 .3906 m
.65526 .34602 L
s
P
p
0 .4 1 r
.02 w
.57917 .2688 m
.5798 .31264 L
s
P
p
0 .4 1 r
.02 w
.48487 .23601 m
.57917 .2688 L
s
P
p
.2 1 0 r
.02 w
.46799 .19474 m
.37202 .1609 L
s
P
p
.2 1 0 r
.02 w
.65825 .43619 m
.75079 .46647 L
s
P
p
0 .4 1 r
.02 w
.5798 .31264 m
.58044 .35748 L
s
P
p
.2 1 0 r
.02 w
.46736 .23781 m
.46671 .28187 L
s
P
p
.2 1 0 r
.02 w
.37029 .20418 m
.46736 .23781 L
s
P
p
0 .4 1 r
.02 w
.48442 .28008 m
.48487 .23601 L
s
P
p
.01 w
.37202 .1609 Mdot
P
p
.2 1 0 r
.02 w
.37202 .1609 m
.37029 .20418 L
s
P
p
.01 w
.3895 .15904 Mdot
P
p
0 .4 1 r
.02 w
.3895 .15904 m
.38797 .20233 L
s
P
p
.2 1 0 r
.02 w
.6598 .48282 m
.65825 .43619 L
s
P
p
.2 1 0 r
.02 w
.5627 .3592 m
.56315 .40506 L
s
P
p
.2 1 0 r
.02 w
.46606 .32694 m
.5627 .3592 L
s
P
p
0 .4 1 r
.02 w
.58044 .35748 m
.48397 .32516 L
s
P
p
.2 1 0 r
.02 w
.46671 .28187 m
.36851 .24845 L
s
P
p
0 .4 1 r
.02 w
.38639 .24662 m
.48442 .28008 L
s
P
p
0 .4 1 r
.02 w
.48442 .28008 m
.48397 .32516 L
s
P
p
0 .4 1 r
.02 w
.38797 .20233 m
.38639 .24662 L
s
P
p
0 .4 1 r
.02 w
.28836 .1677 m
.38797 .20233 L
s
P
p
.2 1 0 r
.02 w
.56361 .45199 m
.6598 .48282 L
s
P
p
.2 1 0 r
.02 w
.56315 .40506 m
.56361 .45199 L
s
P
p
0 .4 1 r
.02 w
.5811 .40335 m
.58177 .45029 L
s
P
p
0 .4 1 r
.02 w
.48351 .3713 m
.5811 .40335 L
s
P
p
.2 1 0 r
.02 w
.46538 .37306 m
.46606 .32694 L
s
P
p
0 .4 1 r
.02 w
.48397 .32516 m
.38479 .29194 L
s
P
p
0 .4 1 r
.02 w
.48397 .32516 m
.48351 .3713 L
s
P
p
.2 1 0 r
.02 w
.36851 .24845 m
.26755 .2141 L
s
P
p
0 .4 1 r
.02 w
.2856 .21221 m
.38639 .24662 L
s
P
p
0 .4 1 r
.02 w
.38639 .24662 m
.38479 .29194 L
s
P
p
0 .4 1 r
.02 w
.2856 .21221 m
.28836 .1677 L
s
P
p
0 .4 1 r
.02 w
.58177 .45029 m
.58245 .49835 L
s
P
p
.2 1 0 r
.02 w
.36484 .34015 m
.46538 .37306 L
s
P
p
0 .4 1 r
.02 w
.48303 .41853 m
.48351 .3713 L
s
P
p
0 .4 1 r
.02 w
.48351 .3713 m
.38314 .33835 L
s
P
p
.2 1 0 r
.02 w
.3667 .29377 m
.36484 .34015 L
s
P
p
.2 1 0 r
.02 w
.2645 .25965 m
.3667 .29377 L
s
P
p
0 .4 1 r
.02 w
.38479 .29194 m
.38314 .33835 L
s
P
p
0 .4 1 r
.02 w
.38479 .29194 m
.28277 .25777 L
s
P
p
.2 1 0 r
.02 w
.26755 .2141 m
.2645 .25965 L
s
P
p
0 .4 1 r
.02 w
.28277 .25777 m
.2856 .21221 L
s
P
p
0 .4 1 r
.02 w
.58245 .49835 m
.48255 .4669 L
s
P
p
0 .4 1 r
.02 w
.38145 .38586 m
.48303 .41853 L
s
P
p
0 .4 1 r
.02 w
.48303 .41853 m
.48255 .4669 L
s
P
p
0 .4 1 r
.02 w
.38314 .33835 m
.38145 .38586 L
s
P
p
0 .4 1 r
.02 w
.27987 .30444 m
.38314 .33835 L
s
P
p
0 .4 1 r
.02 w
.28277 .25777 m
.27987 .30444 L
s
P
p
0 .4 1 r
.02 w
.17781 .22262 m
.28277 .25777 L
s
P
p
0 .4 1 r
.02 w
.58315 .54755 m
.58387 .59793 L
s
P
p
0 .4 1 r
.02 w
.48205 .51643 m
.58315 .54755 L
s
P
p
0 .4 1 r
.02 w
.48255 .4669 m
.37973 .43453 L
s
P
p
0 .4 1 r
.02 w
.48255 .4669 m
.48205 .51643 L
s
P
p
0 .4 1 r
.02 w
.27691 .35223 m
.38145 .38586 L
s
P
p
0 .4 1 r
.02 w
.38145 .38586 m
.37973 .43453 L
s
P
p
0 .4 1 r
.02 w
.27691 .35223 m
.27987 .30444 L
s
P
p
0 .4 1 r
.02 w
.27987 .30444 m
.17358 .26953 L
s
P
p
0 .4 1 r
.02 w
.17358 .26953 m
.17781 .22262 L
s
P
p
0 .4 1 r
.02 w
.58387 .59793 m
.58461 .64956 L
s
P
p
0 .4 1 r
.02 w
.48154 .56718 m
.48205 .51643 L
s
P
p
0 .4 1 r
.02 w
.48205 .51643 m
.37796 .4844 L
s
P
p
0 .4 1 r
.02 w
.37973 .43453 m
.37796 .4844 L
s
P
p
0 .4 1 r
.02 w
.37973 .43453 m
.27387 .40121 L
s
P
p
0 .4 1 r
.02 w
.27387 .40121 m
.27691 .35223 L
s
P
p
0 .4 1 r
.02 w
.58461 .64956 m
.48102 .61919 L
s
P
p
0 .4 1 r
.02 w
.37614 .53551 m
.48154 .56718 L
s
P
p
0 .4 1 r
.02 w
.48154 .56718 m
.48102 .61919 L
s
P
p
0 .4 1 r
.02 w
.37796 .4844 m
.37614 .53551 L
s
P
p
0 .4 1 r
.02 w
.27075 .45141 m
.37796 .4844 L
s
P
p
0 .4 1 r
.02 w
.27387 .40121 m
.27075 .45141 L
s
P
p
0 .4 1 r
.02 w
.16483 .36688 m
.27387 .40121 L
s
P
p
0 .4 1 r
.02 w
.58537 .70246 m
.58614 .75669 L
s
P
p
0 .4 1 r
.02 w
.48048 .67251 m
.58537 .70246 L
s
P
p
0 .4 1 r
.02 w
.48102 .61919 m
.37428 .5879 L
s
P
p
0 .4 1 r
.02 w
.48102 .61919 m
.48048 .67251 L
s
P
p
0 .4 1 r
.02 w
.26755 .50287 m
.37614 .53551 L
s
P
p
0 .4 1 r
.02 w
.37614 .53551 m
.37428 .5879 L
s
P
p
0 .4 1 r
.02 w
.26755 .50287 m
.27075 .45141 L
s
P
p
0 .4 1 r
.02 w
.27075 .45141 m
.16028 .41741 L
s
P
p
0 .4 1 r
.02 w
.16028 .41741 m
.16483 .36688 L
s
P
p
0 .4 1 r
.02 w
.58614 .75669 m
.58694 .81229 L
s
P
p
0 .4 1 r
.02 w
.47993 .72718 m
.48048 .67251 L
s
P
p
0 .4 1 r
.02 w
.48048 .67251 m
.37238 .64164 L
s
P
p
0 .4 1 r
.02 w
.37428 .5879 m
.37238 .64164 L
s
P
p
0 .4 1 r
.02 w
.37428 .5879 m
.26427 .55566 L
s
P
p
0 .4 1 r
.02 w
.26427 .55566 m
.26755 .50287 L
s
P
p
0 .4 1 r
.02 w
.58694 .81229 m
.47937 .78327 L
s
P
p
0 .4 1 r
.02 w
.37042 .69676 m
.47993 .72718 L
s
P
p
0 .4 1 r
.02 w
.47993 .72718 m
.47937 .78327 L
s
P
p
0 .4 1 r
.02 w
.37238 .64164 m
.37042 .69676 L
s
P
p
0 .4 1 r
.02 w
.26091 .60981 m
.37238 .64164 L
s
P
p
0 .4 1 r
.02 w
.26427 .55566 m
.26091 .60981 L
s
P
p
0 .4 1 r
.02 w
.15083 .5224 m
.26427 .55566 L
s
P
p
0 .4 1 r
.02 w
.47937 .78327 m
.36841 .75333 L
s
P
p
0 .4 1 r
.02 w
.47937 .78327 m
.47879 .84082 L
s
P
p
0 .4 1 r
.02 w
.25746 .66538 m
.37042 .69676 L
s
P
p
0 .4 1 r
.02 w
.37042 .69676 m
.36841 .75333 L
s
P
p
0 .4 1 r
.02 w
.25746 .66538 m
.26091 .60981 L
s
P
p
0 .4 1 r
.02 w
.26091 .60981 m
.14592 .57697 L
s
P
p
0 .4 1 r
.02 w
.14592 .57697 m
.15083 .5224 L
s
P
p
0 .4 1 r
.02 w
.47879 .84082 m
.36635 .8114 L
s
P
p
0 .4 1 r
.02 w
.36841 .75333 m
.25392 .72244 L
s
P
p
0 .4 1 r
.02 w
.36635 .8114 m
.36841 .75333 L
s
P
p
0 .4 1 r
.02 w
.25392 .72244 m
.25746 .66538 L
s
P
p
0 .4 1 r
.02 w
.25028 .78103 m
.36635 .8114 L
s
P
p
0 .4 1 r
.02 w
.25392 .72244 m
.25028 .78103 L
s
P
p
0 .4 1 r
.02 w
.1357 .69054 m
.25392 .72244 L
s
P
p
0 .4 1 r
.02 w
.25028 .78103 m
.13039 .74967 L
s
P
p
0 .4 1 r
.02 w
.13039 .74967 m
.1357 .69054 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.154762 0.149123 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.632797 2.35504 0.0239558 0.958232 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.71689 .31998 m
.71976 .37458 L
s
P
p
0 .4 1 r
.02 w
.63641 .27904 m
.71689 .31998 L
s
P
p
0 .4 1 r
.02 w
.71976 .37458 m
.72273 .43103 L
s
P
p
0 .4 1 r
.02 w
.55263 .23642 m
.63641 .27904 L
s
P
p
0 .4 1 r
.02 w
.72273 .43103 m
.63958 .39097 L
s
P
p
0 .4 1 r
.02 w
.46534 .19202 m
.55263 .23642 L
s
P
p
.2 1 0 r
.02 w
.88022 .68616 m
.7996 .65108 L
s
P
p
.2 1 0 r
.02 w
.88606 .74954 m
.88022 .68616 L
s
P
p
.2 1 0 r
.02 w
.79522 .58917 m
.71253 .55193 L
s
P
p
.2 1 0 r
.02 w
.7996 .65108 m
.79522 .58917 L
s
P
p
0 .4 1 r
.02 w
.7258 .48942 m
.72898 .54987 L
s
P
p
0 .4 1 r
.02 w
.64125 .4499 m
.7258 .48942 L
s
P
p
0 .4 1 r
.02 w
.63958 .39097 m
.64125 .4499 L
s
P
p
.2 1 0 r
.02 w
.80413 .71519 m
.88606 .74954 L
s
P
p
0 .4 1 r
.02 w
.46394 .24783 m
.46534 .19202 L
s
P
p
.2 1 0 r
.02 w
.71253 .55193 m
.71552 .6145 L
s
P
p
0 .4 1 r
.02 w
.72898 .54987 m
.73227 .61247 L
s
P
p
.2 1 0 r
.02 w
.62485 .45208 m
.5364 .41094 L
s
P
p
.2 1 0 r
.02 w
.62628 .51309 m
.62485 .45208 L
s
P
p
0 .4 1 r
.02 w
.55306 .40867 m
.64125 .4499 L
s
P
p
0 .4 1 r
.02 w
.55291 .34922 m
.55306 .40867 L
s
P
p
0 .4 1 r
.02 w
.46248 .30566 m
.55291 .34922 L
s
P
p
0 .4 1 r
.02 w
.46248 .30566 m
.46394 .24783 L
s
P
p
0 .4 1 r
.02 w
.37124 .2019 m
.46394 .24783 L
s
P
p
.2 1 0 r
.02 w
.71863 .67934 m
.80413 .71519 L
s
P
p
0 .4 1 r
.02 w
.37433 .14571 m
.37124 .2019 L
s
P
p
0 .4 1 r
.02 w
.27934 .09739 m
.37433 .14571 L
s
P
p
.2 1 0 r
.02 w
.71552 .6145 m
.62777 .57632 L
s
P
p
0 .4 1 r
.02 w
.73227 .61247 m
.73568 .67736 L
s
P
p
.2 1 0 r
.02 w
.62777 .57632 m
.62628 .51309 L
s
P
p
.2 1 0 r
.02 w
.5364 .41094 m
.53625 .47254 L
s
P
p
0 .4 1 r
.02 w
.46096 .36561 m
.55306 .40867 L
s
P
p
0 .4 1 r
.02 w
.55306 .40867 m
.55321 .47029 L
s
P
p
0 .4 1 r
.02 w
.46096 .36561 m
.46248 .30566 L
s
P
p
0 .4 1 r
.02 w
.36804 .26016 m
.46248 .30566 L
s
P
p
.2 1 0 r
.02 w
.80883 .78162 m
.72185 .74659 L
s
P
p
.2 1 0 r
.02 w
.8137 .8505 m
.80883 .78162 L
s
P
p
.2 1 0 r
.02 w
.72185 .74659 m
.71863 .67934 L
s
P
p
0 .4 1 r
.02 w
.18012 .04691 m
.27934 .09739 L
s
P
p
0 .4 1 r
.02 w
.73568 .67736 m
.64664 .63982 L
s
P
p
.2 1 0 r
.02 w
.53625 .47254 m
.44217 .43017 L
s
P
p
0 .4 1 r
.02 w
.55321 .47029 m
.4594 .42782 L
s
P
p
0 .4 1 r
.02 w
.46096 .36561 m
.4594 .42782 L
s
P
p
0 .4 1 r
.02 w
.36472 .32062 m
.46096 .36561 L
s
P
p
.2 1 0 r
.02 w
.72519 .81637 m
.8137 .8505 L
s
P
p
0 .4 1 r
.02 w
.36472 .32062 m
.36804 .26016 L
s
P
p
0 .4 1 r
.02 w
.17321 .10378 m
.18012 .04691 L
s
P
p
0 .4 1 r
.02 w
.64664 .63982 m
.55353 .60057 L
s
P
p
.2 1 0 r
.02 w
.53609 .53643 m
.53592 .60274 L
s
P
p
.2 1 0 r
.02 w
.44021 .49471 m
.53609 .53643 L
s
P
p
0 .4 1 r
.02 w
.55337 .53421 m
.45777 .49239 L
s
P
p
0 .4 1 r
.02 w
.55353 .60057 m
.55337 .53421 L
s
P
p
.01 w
.44217 .43017 Mdot
P
p
.2 1 0 r
.02 w
.44217 .43017 m
.44021 .49471 L
s
P
p
.01 w
.4594 .42782 Mdot
P
p
0 .4 1 r
.02 w
.4594 .42782 m
.36127 .38339 L
s
P
p
0 .4 1 r
.02 w
.45777 .49239 m
.4594 .42782 L
s
P
p
0 .4 1 r
.02 w
.36127 .38339 m
.36472 .32062 L
s
P
p
0 .4 1 r
.02 w
.36472 .32062 m
.26402 .27354 L
s
P
p
.2 1 0 r
.02 w
.72865 .88883 m
.72519 .81637 L
s
P
p
.2 1 0 r
.02 w
.63091 .70996 m
.63258 .78065 L
s
P
p
.2 1 0 r
.02 w
.53575 .67163 m
.63091 .70996 L
s
P
p
0 .4 1 r
.02 w
.16603 .16285 m
.17321 .10378 L
s
P
p
.2 1 0 r
.02 w
.53592 .60274 m
.43818 .56176 L
s
P
p
0 .4 1 r
.02 w
.45777 .49239 m
.45607 .55949 L
s
P
p
.2 1 0 r
.02 w
.6343 .85412 m
.72865 .88883 L
s
P
p
0 .4 1 r
.02 w
.26402 .27354 m
.15857 .22424 L
s
P
p
0 .4 1 r
.02 w
.25852 .33687 m
.26402 .27354 L
s
P
p
.2 1 0 r
.02 w
.63258 .78065 m
.6343 .85412 L
s
P
p
0 .4 1 r
.02 w
.15857 .22424 m
.16603 .16285 L
s
P
p
.2 1 0 r
.02 w
.53558 .74323 m
.53575 .67163 L
s
P
p
.2 1 0 r
.02 w
.43818 .56176 m
.33576 .51882 L
s
P
p
0 .4 1 r
.02 w
.45607 .55949 m
.35395 .51644 L
s
P
p
0 .4 1 r
.02 w
.15081 .28811 m
.25852 .33687 L
s
P
p
.2 1 0 r
.02 w
.43387 .70401 m
.53558 .74323 L
s
P
p
.2 1 0 r
.02 w
.43607 .63147 m
.43387 .70401 L
s
P
p
.2 1 0 r
.02 w
.33152 .58936 m
.43607 .63147 L
s
P
p
.2 1 0 r
.02 w
.33576 .51882 m
.33152 .58936 L
s
P
p
0 .4 1 r
.02 w
.35395 .51644 m
.24683 .47128 L
s
P
p
0 .4 1 r
.02 w
.14273 .35459 m
.15081 .28811 L
s
P
p
0 .4 1 r
.02 w
.24683 .47128 m
.13432 .42385 L
s
P
p
0 .4 1 r
.02 w
.13432 .42385 m
.14273 .35459 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.154762 0.286967 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.48977 2.08033 0.0245877 0.983507 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.88442 .5236 m
.85484 .50697 L
s
P
p
.2 1 0 r
.02 w
.88673 .54953 m
.88442 .5236 L
s
P
p
.2 1 0 r
.02 w
.85274 .4813 m
.82286 .46429 L
s
P
p
.2 1 0 r
.02 w
.85484 .50697 m
.85274 .4813 L
s
P
p
.2 1 0 r
.02 w
.85697 .53299 m
.88673 .54953 L
s
P
p
.2 1 0 r
.02 w
.82286 .46429 m
.82476 .49006 L
s
P
p
.2 1 0 r
.02 w
.79078 .42149 m
.76008 .40381 L
s
P
p
.2 1 0 r
.02 w
.79247 .447 m
.79078 .42149 L
s
P
p
.2 1 0 r
.02 w
.82669 .51618 m
.85697 .53299 L
s
P
p
.2 1 0 r
.02 w
.82476 .49006 m
.79418 .47286 L
s
P
p
.2 1 0 r
.02 w
.79418 .47286 m
.79247 .447 L
s
P
p
.2 1 0 r
.02 w
.76008 .40381 m
.76156 .42941 L
s
P
p
.2 1 0 r
.02 w
.85912 .55939 m
.82865 .54268 L
s
P
p
.2 1 0 r
.02 w
.86131 .58615 m
.85912 .55939 L
s
P
p
.2 1 0 r
.02 w
.82865 .54268 m
.82669 .51618 L
s
P
p
.2 1 0 r
.02 w
.76156 .42941 m
.73013 .41152 L
s
P
p
.2 1 0 r
.02 w
.83064 .56956 m
.86131 .58615 L
s
P
p
.2 1 0 r
.02 w
.76307 .45536 m
.76459 .48169 L
s
P
p
.2 1 0 r
.02 w
.73142 .43757 m
.76307 .45536 L
s
P
p
.01 w
.73013 .41152 Mdot
P
p
.2 1 0 r
.02 w
.73013 .41152 m
.73142 .43757 L
s
P
p
.01 w
.73635 .41054 Mdot
P
p
0 .4 1 r
.02 w
.73635 .41054 m
.73769 .4366 L
s
P
p
.2 1 0 r
.02 w
.83266 .59682 m
.83064 .56956 L
s
P
p
.2 1 0 r
.02 w
.79766 .52569 m
.79945 .55267 L
s
P
p
.2 1 0 r
.02 w
.76614 .5084 m
.79766 .52569 L
s
P
p
.2 1 0 r
.02 w
.76459 .48169 m
.73273 .464 L
s
P
p
0 .4 1 r
.02 w
.73769 .4366 m
.70553 .41847 L
s
P
p
.2 1 0 r
.02 w
.80125 .58005 m
.83266 .59682 L
s
P
p
.2 1 0 r
.02 w
.79945 .55267 m
.80125 .58005 L
s
P
p
.2 1 0 r
.02 w
.7677 .5355 m
.76614 .5084 L
s
P
p
.2 1 0 r
.02 w
.73273 .464 m
.70031 .44599 L
s
P
p
0 .4 1 r
.02 w
.70553 .41847 m
.70666 .44501 L
s
P
p
.2 1 0 r
.02 w
.7354 .51801 m
.7677 .5355 L
s
P
p
.2 1 0 r
.02 w
.73406 .49081 m
.7354 .51801 L
s
P
p
.2 1 0 r
.02 w
.70141 .47291 m
.73406 .49081 L
s
P
p
.2 1 0 r
.02 w
.70031 .44599 m
.70141 .47291 L
s
P
p
0 .4 1 r
.02 w
.70666 .44501 m
.70781 .47193 L
s
P
p
0 .4 1 r
.02 w
.70781 .47193 m
.67463 .45369 L
s
P
p
0 .4 1 r
.02 w
.67463 .45369 m
.64085 .43513 L
s
P
p
0 .4 1 r
.02 w
.64085 .43513 m
.60646 .41623 L
s
P
p
0 .4 1 r
.02 w
.60646 .41623 m
.60689 .44388 L
s
P
p
0 .4 1 r
.02 w
.60689 .44388 m
.60732 .47195 L
s
P
p
0 .4 1 r
.02 w
.60732 .47195 m
.57176 .45292 L
s
P
p
0 .4 1 r
.02 w
.57176 .45292 m
.57193 .48154 L
s
P
p
0 .4 1 r
.02 w
.57193 .48154 m
.5721 .51061 L
s
P
p
0 .4 1 r
.02 w
.5721 .51061 m
.53531 .49147 L
s
P
p
0 .4 1 r
.02 w
.53531 .49147 m
.49781 .47196 L
s
P
p
0 .4 1 r
.02 w
.49781 .47196 m
.45959 .45208 L
s
P
p
0 .4 1 r
.02 w
.45959 .45208 m
.45885 .482 L
s
P
p
0 .4 1 r
.02 w
.45885 .482 m
.45809 .51241 L
s
P
p
0 .4 1 r
.02 w
.45809 .51241 m
.41846 .49239 L
s
P
p
0 .4 1 r
.02 w
.41846 .49239 m
.41735 .52345 L
s
P
p
0 .4 1 r
.02 w
.41735 .52345 m
.41623 .55504 L
s
P
p
0 .4 1 r
.02 w
.41623 .55504 m
.37509 .53491 L
s
P
p
0 .4 1 r
.02 w
.37509 .53491 m
.33309 .51438 L
s
P
p
0 .4 1 r
.02 w
.33309 .51438 m
.29022 .49341 L
s
P
p
0 .4 1 r
.02 w
.29022 .49341 m
.28793 .526 L
s
P
p
0 .4 1 r
.02 w
.28793 .526 m
.28561 .55918 L
s
P
p
0 .4 1 r
.02 w
.28561 .55918 m
.241 .53809 L
s
P
p
0 .4 1 r
.02 w
.241 .53809 m
.2382 .57203 L
s
P
p
0 .4 1 r
.02 w
.2382 .57203 m
.23536 .60659 L
s
P
p
0 .4 1 r
.02 w
.23536 .60659 m
.18887 .58541 L
s
P
p
0 .4 1 r
.02 w
.18887 .58541 m
.14135 .56375 L
s
P
p
0 .4 1 r
.02 w
.14135 .56375 m
.09275 .5416 L
s
P
p
0 .4 1 r
.02 w
.09275 .5416 m
.0884 .57738 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.154762 0.424812 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.794352 2.66062 0.0139601 0.96199 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.62669 .24709 m
.62795 .29521 L
s
P
p
0 .4 1 r
.02 w
.54375 .20962 m
.62669 .24709 L
s
P
p
0 .4 1 r
.02 w
.62795 .29521 m
.62925 .34469 L
s
P
p
0 .4 1 r
.02 w
.54386 .25802 m
.54375 .20962 L
s
P
p
0 .4 1 r
.02 w
.79859 .51656 m
.80233 .56962 L
s
P
p
0 .4 1 r
.02 w
.7167 .48285 m
.79859 .51656 L
s
P
p
0 .4 1 r
.02 w
.62925 .34469 m
.63059 .39558 L
s
P
p
0 .4 1 r
.02 w
.54398 .30782 m
.54386 .25802 L
s
P
p
0 .4 1 r
.02 w
.80233 .56962 m
.71932 .53634 L
s
P
p
0 .4 1 r
.02 w
.63196 .44796 m
.7167 .48285 L
s
P
p
0 .4 1 r
.02 w
.63059 .39558 m
.63196 .44796 L
s
P
p
0 .4 1 r
.02 w
.45571 .26966 m
.54398 .30782 L
s
P
p
.2 1 0 r
.02 w
.87613 .71322 m
.79353 .68211 L
s
P
p
.2 1 0 r
.02 w
.8811 .77049 m
.87613 .71322 L
s
P
p
.2 1 0 r
.02 w
.78981 .62595 m
.70544 .59321 L
s
P
p
.2 1 0 r
.02 w
.79353 .68211 m
.78981 .62595 L
s
P
p
0 .4 1 r
.02 w
.71932 .53634 m
.63338 .50188 L
s
P
p
.2 1 0 r
.02 w
.79735 .73994 m
.8811 .77049 L
s
P
p
0 .4 1 r
.02 w
.36429 .23013 m
.45571 .26966 L
s
P
p
.2 1 0 r
.02 w
.70544 .59321 m
.70797 .64989 L
s
P
p
.2 1 0 r
.02 w
.61684 .50378 m
.52758 .46815 L
s
P
p
.2 1 0 r
.02 w
.61805 .55929 m
.61684 .50378 L
s
P
p
0 .4 1 r
.02 w
.63338 .50188 m
.54434 .46619 L
s
P
p
.2 1 0 r
.02 w
.71057 .70828 m
.79735 .73994 L
s
P
p
0 .4 1 r
.02 w
.26955 .18917 m
.36429 .23013 L
s
P
p
.2 1 0 r
.02 w
.70797 .64989 m
.61929 .61649 L
s
P
p
.2 1 0 r
.02 w
.61929 .61649 m
.61805 .55929 L
s
P
p
.2 1 0 r
.02 w
.52758 .46815 m
.52746 .52413 L
s
P
p
0 .4 1 r
.02 w
.54434 .46619 m
.45203 .42918 L
s
P
p
.2 1 0 r
.02 w
.8013 .79952 m
.71326 .76847 L
s
P
p
.2 1 0 r
.02 w
.80537 .86092 m
.8013 .79952 L
s
P
p
0 .4 1 r
.02 w
.3617 .28206 m
.26545 .24143 L
s
P
p
0 .4 1 r
.02 w
.35903 .33559 m
.3617 .28206 L
s
P
p
.2 1 0 r
.02 w
.71326 .76847 m
.71057 .70828 L
s
P
p
0 .4 1 r
.02 w
.1713 .14669 m
.26955 .18917 L
s
P
p
.2 1 0 r
.02 w
.52746 .52413 m
.43349 .48767 L
s
P
p
0 .4 1 r
.02 w
.45203 .42918 m
.45073 .48566 L
s
P
p
.2 1 0 r
.02 w
.71602 .83054 m
.80537 .86092 L
s
P
p
0 .4 1 r
.02 w
.35627 .39079 m
.35903 .33559 L
s
P
p
0 .4 1 r
.02 w
.26545 .24143 m
.16558 .19927 L
s
P
p
0 .4 1 r
.02 w
.16558 .19927 m
.1713 .14669 L
s
P
p
.2 1 0 r
.02 w
.52733 .58185 m
.52719 .64138 L
s
P
p
.2 1 0 r
.02 w
.43188 .5459 m
.52733 .58185 L
s
P
p
.01 w
.43349 .48767 Mdot
P
p
.2 1 0 r
.02 w
.43349 .48767 m
.43188 .5459 L
s
P
p
.01 w
.45073 .48566 Mdot
P
p
0 .4 1 r
.02 w
.45073 .48566 m
.44938 .54391 L
s
P
p
0 .4 1 r
.02 w
.35343 .44773 m
.35627 .39079 L
s
P
p
.2 1 0 r
.02 w
.71888 .89458 m
.71602 .83054 L
s
P
p
.2 1 0 r
.02 w
.6219 .73625 m
.62327 .799 L
s
P
p
.2 1 0 r
.02 w
.52705 .7028 m
.6219 .73625 L
s
P
p
.2 1 0 r
.02 w
.52719 .64138 m
.43021 .606 L
s
P
p
0 .4 1 r
.02 w
.44938 .54391 m
.35049 .5065 L
s
P
p
0 .4 1 r
.02 w
.35049 .5065 m
.35343 .44773 L
s
P
p
.2 1 0 r
.02 w
.62468 .86377 m
.71888 .89458 L
s
P
p
.2 1 0 r
.02 w
.62327 .799 m
.62468 .86377 L
s
P
p
.2 1 0 r
.02 w
.52691 .76622 m
.52705 .7028 L
s
P
p
.2 1 0 r
.02 w
.43021 .606 m
.32944 .56923 L
s
P
p
.2 1 0 r
.02 w
.42672 .73215 m
.52691 .76622 L
s
P
p
.2 1 0 r
.02 w
.42849 .66805 m
.42672 .73215 L
s
P
p
.2 1 0 r
.02 w
.32601 .63191 m
.42849 .66805 L
s
P
p
.2 1 0 r
.02 w
.32944 .56923 m
.32601 .63191 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.154762 0.562657 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.475381 2.05135 0.0246377 0.985509 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.90396 .76848 m
.8568 .74463 L
s
P
p
.2 1 0 r
.02 w
.90788 .81338 m
.90396 .76848 L
s
P
p
.2 1 0 r
.02 w
.85342 .70038 m
.80548 .67557 L
s
P
p
.2 1 0 r
.02 w
.8568 .74463 m
.85342 .70038 L
s
P
p
0 .4 1 r
.02 w
.71013 .49281 m
.6599 .46502 L
s
P
p
0 .4 1 r
.02 w
.71193 .53506 m
.71013 .49281 L
s
P
p
.2 1 0 r
.02 w
.86024 .78988 m
.90788 .81338 L
s
P
p
.2 1 0 r
.02 w
.80548 .67557 m
.80836 .72014 L
s
P
p
.2 1 0 r
.02 w
.75394 .60621 m
.70389 .57972 L
s
P
p
.2 1 0 r
.02 w
.75624 .65009 m
.75394 .60621 L
s
P
p
0 .4 1 r
.02 w
.66115 .50753 m
.71193 .53506 L
s
P
p
0 .4 1 r
.02 w
.6599 .46502 m
.6083 .43646 L
s
P
p
.2 1 0 r
.02 w
.8113 .76572 m
.86024 .78988 L
s
P
p
.2 1 0 r
.02 w
.80836 .72014 m
.75859 .69498 L
s
P
p
0 .4 1 r
.02 w
.55515 .32398 m
.55521 .36507 L
s
P
p
0 .4 1 r
.02 w
.50188 .29336 m
.55515 .32398 L
s
P
p
.2 1 0 r
.02 w
.75859 .69498 m
.75624 .65009 L
s
P
p
.2 1 0 r
.02 w
.70389 .57972 m
.70564 .62391 L
s
P
p
0 .4 1 r
.02 w
.60897 .47923 m
.66115 .50753 L
s
P
p
.2 1 0 r
.02 w
.86377 .83615 m
.81431 .81236 L
s
P
p
.2 1 0 r
.02 w
.86738 .88349 m
.86377 .83615 L
s
P
p
0 .4 1 r
.02 w
.6083 .43646 m
.60897 .47923 L
s
P
p
0 .4 1 r
.02 w
.55527 .40712 m
.6083 .43646 L
s
P
p
.2 1 0 r
.02 w
.81431 .81236 m
.8113 .76572 L
s
P
p
0 .4 1 r
.02 w
.55521 .36507 m
.50132 .33467 L
s
P
p
0 .4 1 r
.02 w
.44712 .26189 m
.50188 .29336 L
s
P
p
0 .4 1 r
.02 w
.50132 .33467 m
.50188 .29336 L
s
P
p
.2 1 0 r
.02 w
.70564 .62391 m
.65364 .597 L
s
P
p
0 .4 1 r
.02 w
.66242 .55102 m
.66373 .59552 L
s
P
p
0 .4 1 r
.02 w
.60965 .523 m
.66242 .55102 L
s
P
p
.2 1 0 r
.02 w
.81739 .86008 m
.86738 .88349 L
s
P
p
0 .4 1 r
.02 w
.60897 .47923 m
.60965 .523 L
s
P
p
0 .4 1 r
.02 w
.55532 .45015 m
.60897 .47923 L
s
P
p
0 .4 1 r
.02 w
.50074 .37695 m
.55527 .40712 L
s
P
p
0 .4 1 r
.02 w
.50132 .33467 m
.50074 .37695 L
s
P
p
0 .4 1 r
.02 w
.44591 .30341 m
.50132 .33467 L
s
P
p
.2 1 0 r
.02 w
.70745 .66912 m
.70929 .71538 L
s
P
p
.2 1 0 r
.02 w
.65485 .64252 m
.70745 .66912 L
s
P
p
0 .4 1 r
.02 w
.44591 .30341 m
.44712 .26189 L
s
P
p
.01 w
.65364 .597 Mdot
P
p
.2 1 0 r
.02 w
.65364 .597 m
.65485 .64252 L
s
P
p
.01 w
.66373 .59552 Mdot
P
p
0 .4 1 r
.02 w
.61035 .5678 m
.66373 .59552 L
s
P
p
0 .4 1 r
.02 w
.66373 .59552 m
.66506 .64106 L
s
P
p
0 .4 1 r
.02 w
.39266 .18876 m
.33545 .15529 L
s
P
p
0 .4 1 r
.02 w
.39081 .22953 m
.39266 .18876 L
s
P
p
0 .4 1 r
.02 w
.60965 .523 m
.61035 .5678 L
s
P
p
.2 1 0 r
.02 w
.82055 .90893 m
.81739 .86008 L
s
P
p
0 .4 1 r
.02 w
.55538 .49419 m
.55532 .45015 L
s
P
p
.2 1 0 r
.02 w
.76347 .7879 m
.76599 .83602 L
s
P
p
.2 1 0 r
.02 w
.71117 .76275 m
.76347 .7879 L
s
P
p
0 .4 1 r
.02 w
.50074 .37695 m
.44467 .34592 L
s
P
p
.2 1 0 r
.02 w
.70929 .71538 m
.6561 .68914 L
s
P
p
0 .4 1 r
.02 w
.38891 .27126 m
.44591 .30341 L
s
P
p
0 .4 1 r
.02 w
.66506 .64106 m
.61107 .61367 L
s
P
p
0 .4 1 r
.02 w
.38891 .27126 m
.39081 .22953 L
s
P
p
0 .4 1 r
.02 w
.61035 .5678 m
.55544 .53929 L
s
P
p
0 .4 1 r
.02 w
.61107 .61367 m
.61035 .5678 L
s
P
p
0 .4 1 r
.02 w
.33545 .15529 m
.33289 .19624 L
s
P
p
.2 1 0 r
.02 w
.76857 .88528 m
.82055 .90893 L
s
P
p
0 .4 1 r
.02 w
.55544 .53929 m
.55538 .49419 L
s
P
p
.2 1 0 r
.02 w
.76599 .83602 m
.76857 .88528 L
s
P
p
.2 1 0 r
.02 w
.71311 .81125 m
.71117 .76275 L
s
P
p
0 .4 1 r
.02 w
.44467 .34592 m
.38697 .314 L
s
P
p
.2 1 0 r
.02 w
.6561 .68914 m
.60137 .66213 L
s
P
p
0 .4 1 r
.02 w
.38697 .314 m
.38891 .27126 L
s
P
p
0 .4 1 r
.02 w
.33027 .23818 m
.38891 .27126 L
s
P
p
0 .4 1 r
.02 w
.33289 .19624 m
.33027 .23818 L
s
P
p
0 .4 1 r
.02 w
.55544 .53929 m
.55551 .58548 L
s
P
p
.2 1 0 r
.02 w
.65867 .78577 m
.71311 .81125 L
s
P
p
.2 1 0 r
.02 w
.65737 .73687 m
.65867 .78577 L
s
P
p
.2 1 0 r
.02 w
.60199 .71023 m
.65737 .73687 L
s
P
p
.2 1 0 r
.02 w
.60137 .66213 m
.60199 .71023 L
s
P
p
0 .4 1 r
.02 w
.32758 .28114 m
.33027 .23818 L
s
P
p
0 .4 1 r
.02 w
.55551 .58548 m
.55557 .6328 L
s
P
p
0 .4 1 r
.02 w
.32482 .32516 m
.32758 .28114 L
s
P
p
0 .4 1 r
.02 w
.55557 .6328 m
.49766 .60412 L
s
P
p
0 .4 1 r
.02 w
.55564 .68129 m
.55557 .6328 L
s
P
p
0 .4 1 r
.02 w
.49831 .55646 m
.49766 .60412 L
s
P
p
0 .4 1 r
.02 w
.4394 .52657 m
.49831 .55646 L
s
P
p
0 .4 1 r
.02 w
.26285 .29156 m
.32482 .32516 L
s
P
p
0 .4 1 r
.02 w
.32482 .32516 m
.322 .37029 L
s
P
p
0 .4 1 r
.02 w
.5557 .73101 m
.55564 .68129 L
s
P
p
0 .4 1 r
.02 w
.26642 .2473 m
.26285 .29156 L
s
P
p
0 .4 1 r
.02 w
.20341 .21244 m
.26642 .2473 L
s
P
p
0 .4 1 r
.02 w
.49766 .60412 m
.438 .57458 L
s
P
p
0 .4 1 r
.02 w
.49766 .60412 m
.497 .65299 L
s
P
p
0 .4 1 r
.02 w
.3787 .49577 m
.4394 .52657 L
s
P
p
0 .4 1 r
.02 w
.322 .37029 m
.3191 .41656 L
s
P
p
0 .4 1 r
.02 w
.49632 .7031 m
.5557 .73101 L
s
P
p
0 .4 1 r
.02 w
.2592 .33695 m
.26285 .29156 L
s
P
p
0 .4 1 r
.02 w
.26285 .29156 m
.19899 .25693 L
s
P
p
0 .4 1 r
.02 w
.497 .65299 m
.49632 .7031 L
s
P
p
0 .4 1 r
.02 w
.19899 .25693 m
.20341 .21244 L
s
P
p
0 .4 1 r
.02 w
.438 .57458 m
.43656 .62382 L
s
P
p
0 .4 1 r
.02 w
.438 .57458 m
.3765 .54412 L
s
P
p
0 .4 1 r
.02 w
.3787 .49577 m
.31613 .46402 L
s
P
p
0 .4 1 r
.02 w
.3765 .54412 m
.3787 .49577 L
s
P
p
0 .4 1 r
.02 w
.3191 .41656 m
.25545 .38351 L
s
P
p
0 .4 1 r
.02 w
.2592 .33695 m
.19445 .30258 L
s
P
p
0 .4 1 r
.02 w
.25545 .38351 m
.2592 .33695 L
s
P
p
0 .4 1 r
.02 w
.19445 .30258 m
.19899 .25693 L
s
P
p
0 .4 1 r
.02 w
.43656 .62382 m
.37425 .59373 L
s
P
p
0 .4 1 r
.02 w
.31308 .51272 m
.3765 .54412 L
s
P
p
0 .4 1 r
.02 w
.3765 .54412 m
.37425 .59373 L
s
P
p
0 .4 1 r
.02 w
.31613 .46402 m
.2516 .43128 L
s
P
p
0 .4 1 r
.02 w
.2516 .43128 m
.25545 .38351 L
s
P
p
0 .4 1 r
.02 w
.25545 .38351 m
.1898 .34942 L
s
P
p
0 .4 1 r
.02 w
.37425 .59373 m
.30995 .5627 L
s
P
p
0 .4 1 r
.02 w
.30995 .5627 m
.31308 .51272 L
s
P
p
0 .4 1 r
.02 w
.18502 .3975 m
.2516 .43128 L
s
P
p
0 .4 1 r
.02 w
.1898 .34942 m
.12205 .31424 L
s
P
p
0 .4 1 r
.02 w
.11628 .36262 m
.18502 .3975 L
s
P
p
0 .4 1 r
.02 w
.12205 .31424 m
.11628 .36262 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.154762 0.700501 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.498191 2.097 0.0245059 0.980236 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87882 .61174 m
.78846 .56381 L
s
P
p
.2 1 0 r
.02 w
.88591 .6918 m
.87882 .61174 L
s
P
p
.2 1 0 r
.02 w
.7834 .48613 m
.69015 .43471 L
s
P
p
.2 1 0 r
.02 w
.78846 .56381 m
.7834 .48613 L
s
P
p
.2 1 0 r
.02 w
.79374 .64494 m
.88591 .6918 L
s
P
p
.2 1 0 r
.02 w
.69015 .43471 m
.69327 .51333 L
s
P
p
.2 1 0 r
.02 w
.59099 .30448 m
.48962 .24655 L
s
P
p
.2 1 0 r
.02 w
.5919 .38054 m
.59099 .30448 L
s
P
p
.2 1 0 r
.02 w
.69652 .59553 m
.79374 .64494 L
s
P
p
.2 1 0 r
.02 w
.69327 .51333 m
.59285 .46007 L
s
P
p
.2 1 0 r
.02 w
.59285 .46007 m
.5919 .38054 L
s
P
p
.2 1 0 r
.02 w
.48962 .24655 m
.48822 .32337 L
s
P
p
.2 1 0 r
.02 w
.79926 .72975 m
.69993 .68156 L
s
P
p
.2 1 0 r
.02 w
.80503 .8185 m
.79926 .72975 L
s
P
p
.2 1 0 r
.02 w
.69993 .68156 m
.69652 .59553 L
s
P
p
.2 1 0 r
.02 w
.48822 .32337 m
.37867 .26297 L
s
P
p
.2 1 0 r
.02 w
.7035 .77169 m
.80503 .8185 L
s
P
p
.2 1 0 r
.02 w
.48676 .40381 m
.48523 .48812 L
s
P
p
.2 1 0 r
.02 w
.37451 .34428 m
.48676 .40381 L
s
P
p
.01 w
.37867 .26297 Mdot
P
p
.2 1 0 r
.02 w
.37867 .26297 m
.37451 .34428 L
s
P
p
.01 w
.39834 .2596 Mdot
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.39834 .2596 L
s
P
p
.2 1 0 r
.02 w
.70724 .86623 m
.7035 .77169 L
s
P
p
.2 1 0 r
.02 w
.59489 .63059 m
.59598 .72212 L
s
P
p
.2 1 0 r
.02 w
.48363 .5766 m
.59489 .63059 L
s
P
p
.2 1 0 r
.02 w
.48523 .48812 m
.37015 .42962 L
s
P
p
0 .4 1 r
.02 w
.50545 .48504 m
.39078 .42635 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.39078 .42635 L
s
P
p
.2 1 0 r
.02 w
.59713 .81827 m
.70724 .86623 L
s
P
p
.2 1 0 r
.02 w
.59598 .72212 m
.59713 .81827 L
s
P
p
.2 1 0 r
.02 w
.48194 .66955 m
.48363 .5766 L
s
P
p
.2 1 0 r
.02 w
.37015 .42962 m
.24801 .36753 L
s
P
p
0 .4 1 r
.02 w
.39078 .42635 m
.26907 .36406 L
s
P
p
0 .4 1 r
.02 w
.15022 .21045 m
.2761 .27766 L
s
P
p
0 .4 1 r
.02 w
.26907 .36406 m
.2761 .27766 L
s
P
p
.2 1 0 r
.02 w
.36075 .61368 m
.48194 .66955 L
s
P
p
.2 1 0 r
.02 w
.36557 .51931 m
.36075 .61368 L
s
P
p
.2 1 0 r
.02 w
.24008 .45841 m
.36557 .51931 L
s
P
p
.2 1 0 r
.02 w
.24801 .36753 m
.24008 .45841 L
s
P
p
0 .4 1 r
.02 w
.26168 .45501 m
.26907 .36406 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.154762 0.838346 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.869129 2.80349 0.00816909 0.96764 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.7594 .35077 m
.65343 .30623 L
s
P
p
0 .4 1 r
.02 w
.76325 .41281 m
.7594 .35077 L
s
P
p
0 .4 1 r
.02 w
.65141 .24576 m
.54286 .19892 L
s
P
p
0 .4 1 r
.02 w
.65343 .30623 m
.65141 .24576 L
s
P
p
0 .4 1 r
.02 w
.87233 .51867 m
.76723 .47699 L
s
P
p
0 .4 1 r
.02 w
.87817 .58445 m
.87233 .51867 L
s
P
p
0 .4 1 r
.02 w
.76723 .47699 m
.76325 .41281 L
s
P
p
0 .4 1 r
.02 w
.54286 .19892 m
.54304 .25983 L
s
P
p
0 .4 1 r
.02 w
.77135 .54342 m
.87817 .58445 L
s
P
p
0 .4 1 r
.02 w
.54304 .25983 m
.42795 .21146 L
s
P
p
.2 1 0 r
.02 w
.86284 .65466 m
.75391 .61446 L
s
P
p
.2 1 0 r
.02 w
.86872 .72513 m
.86284 .65466 L
s
P
p
.2 1 0 r
.02 w
.75003 .54569 m
.63829 .503 L
s
P
p
.2 1 0 r
.02 w
.75391 .61446 m
.75003 .54569 L
s
P
p
0 .4 1 r
.02 w
.77561 .61223 m
.77135 .54342 L
s
P
p
0 .4 1 r
.02 w
.42795 .21146 m
.30785 .16098 L
s
P
p
.2 1 0 r
.02 w
.75793 .68572 m
.86872 .72513 L
s
P
p
0 .4 1 r
.02 w
.66225 .57017 m
.77561 .61223 L
s
P
p
.2 1 0 r
.02 w
.63829 .503 m
.64021 .57249 L
s
P
p
.2 1 0 r
.02 w
.52183 .39073 m
.40218 .34353 L
s
P
p
.2 1 0 r
.02 w
.52163 .45843 m
.52183 .39073 L
s
P
p
0 .4 1 r
.02 w
.30785 .16098 m
.3037 .22501 L
s
P
p
.2 1 0 r
.02 w
.64221 .64457 m
.75793 .68572 L
s
P
p
.2 1 0 r
.02 w
.64021 .57249 m
.52143 .52865 L
s
P
p
0 .4 1 r
.02 w
.54382 .52622 m
.66225 .57017 L
s
P
p
.2 1 0 r
.02 w
.52143 .52865 m
.52163 .45843 L
s
P
p
.2 1 0 r
.02 w
.40218 .34353 m
.39974 .41186 L
s
P
p
0 .4 1 r
.02 w
.3037 .22501 m
.1758 .17275 L
s
P
p
.2 1 0 r
.02 w
.7621 .75963 m
.64429 .71937 L
s
P
p
.2 1 0 r
.02 w
.76643 .83632 m
.7621 .75963 L
s
P
p
.2 1 0 r
.02 w
.64429 .71937 m
.64221 .64457 L
s
P
p
0 .4 1 r
.02 w
.54403 .59915 m
.54382 .52622 L
s
P
p
.2 1 0 r
.02 w
.39974 .41186 m
.27224 .36315 L
s
P
p
0 .4 1 r
.02 w
.29939 .29146 m
.29492 .36045 L
s
P
p
0 .4 1 r
.02 w
.16893 .23972 m
.29939 .29146 L
s
P
p
.2 1 0 r
.02 w
.64644 .79707 m
.76643 .83632 L
s
P
p
0 .4 1 r
.02 w
.1758 .17275 m
.16893 .23972 L
s
P
p
0 .4 1 r
.02 w
.41776 .55399 m
.54403 .59915 L
s
P
p
.2 1 0 r
.02 w
.3972 .4828 m
.39457 .55649 L
s
P
p
.2 1 0 r
.02 w
.26716 .4348 m
.3972 .4828 L
s
P
p
0 .4 1 r
.02 w
.41995 .48025 m
.41776 .55399 L
s
P
p
0 .4 1 r
.02 w
.29028 .43213 m
.41995 .48025 L
s
P
p
.01 w
.27224 .36315 Mdot
P
p
.2 1 0 r
.02 w
.27224 .36315 m
.26716 .4348 L
s
P
p
.01 w
.29492 .36045 Mdot
P
p
0 .4 1 r
.02 w
.29492 .36045 m
.29028 .43213 L
s
P
p
.2 1 0 r
.02 w
.64868 .87781 m
.64644 .79707 L
s
P
p
.2 1 0 r
.02 w
.52099 .67725 m
.52076 .75595 L
s
P
p
.2 1 0 r
.02 w
.39183 .63311 m
.52099 .67725 L
s
P
p
.2 1 0 r
.02 w
.39457 .55649 m
.26188 .5093 L
s
P
p
.2 1 0 r
.02 w
.52053 .83782 m
.64868 .87781 L
s
P
p
.2 1 0 r
.02 w
.52076 .75595 m
.52053 .83782 L
s
P
p
.2 1 0 r
.02 w
.38899 .71283 m
.39183 .63311 L
s
P
p
.2 1 0 r
.02 w
.26188 .5093 m
.12269 .4598 L
s
P
p
.2 1 0 r
.02 w
.25065 .66757 m
.38899 .71283 L
s
P
p
.2 1 0 r
.02 w
.25638 .58683 m
.25065 .66757 L
s
P
p
.2 1 0 r
.02 w
.11415 .53823 m
.25638 .58683 L
s
P
p
.2 1 0 r
.02 w
.12269 .4598 m
.11415 .53823 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.154762 0.97619 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.351932 1.80373 0.0251385 1.00554 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.90634 .59278 m
.89398 .58476 L
s
P
p
.2 1 0 r
.02 w
.90732 .60574 m
.90634 .59278 L
s
P
p
.2 1 0 r
.02 w
.89303 .57186 m
.88062 .56376 L
s
P
p
.2 1 0 r
.02 w
.89398 .58476 m
.89303 .57186 L
s
P
p
.2 1 0 r
.02 w
.89494 .59774 m
.90732 .60574 L
s
P
p
.2 1 0 r
.02 w
.88062 .56376 m
.88154 .57669 L
s
P
p
.2 1 0 r
.02 w
.86725 .54273 m
.85471 .53451 L
s
P
p
.2 1 0 r
.02 w
.86813 .55561 m
.86725 .54273 L
s
P
p
.2 1 0 r
.02 w
.88246 .58969 m
.89494 .59774 L
s
P
p
.2 1 0 r
.02 w
.88154 .57669 m
.86902 .56856 L
s
P
p
.2 1 0 r
.02 w
.86902 .56856 m
.86813 .55561 L
s
P
p
.2 1 0 r
.02 w
.85471 .53451 m
.85556 .54741 L
s
P
p
.2 1 0 r
.02 w
.8959 .61079 m
.88339 .60276 L
s
P
p
.2 1 0 r
.02 w
.89686 .62391 m
.8959 .61079 L
s
P
p
.2 1 0 r
.02 w
.88339 .60276 m
.88246 .58969 L
s
P
p
.2 1 0 r
.02 w
.85556 .54741 m
.8429 .53915 L
s
P
p
.2 1 0 r
.02 w
.88433 .6159 m
.89686 .62391 L
s
P
p
.2 1 0 r
.02 w
.85641 .56037 m
.85727 .57341 L
s
P
p
.2 1 0 r
.02 w
.84372 .55213 m
.85641 .56037 L
s
P
p
0 .4 1 r
.02 w
.85899 .55993 m
.85986 .57297 L
s
P
p
0 .4 1 r
.02 w
.84631 .55169 m
.85899 .55993 L
s
P
p
.01 w
.8429 .53915 Mdot
P
p
.2 1 0 r
.02 w
.8429 .53915 m
.84372 .55213 L
s
P
p
.01 w
.84548 .5387 Mdot
P
p
0 .4 1 r
.02 w
.84548 .5387 m
.84631 .55169 L
s
P
p
0 .4 1 r
.02 w
.83274 .53038 m
.84548 .5387 L
s
P
p
.2 1 0 r
.02 w
.88527 .62912 m
.88433 .6159 L
s
P
p
.2 1 0 r
.02 w
.87081 .59467 m
.87171 .60784 L
s
P
p
.2 1 0 r
.02 w
.85814 .58653 m
.87081 .59467 L
s
P
p
.2 1 0 r
.02 w
.85727 .57341 m
.84455 .5652 L
s
P
p
0 .4 1 r
.02 w
.85986 .57297 m
.84714 .56475 L
s
P
p
0 .4 1 r
.02 w
.84631 .55169 m
.84714 .56475 L
s
P
p
0 .4 1 r
.02 w
.83354 .54339 m
.83274 .53038 L
s
P
p
.2 1 0 r
.02 w
.87262 .62108 m
.88527 .62912 L
s
P
p
.2 1 0 r
.02 w
.87171 .60784 m
.87262 .62108 L
s
P
p
.2 1 0 r
.02 w
.859 .59972 m
.85814 .58653 L
s
P
p
.2 1 0 r
.02 w
.84455 .5652 m
.83174 .55692 L
s
P
p
0 .4 1 r
.02 w
.84714 .56475 m
.84798 .57789 L
s
P
p
0 .4 1 r
.02 w
.84714 .56475 m
.83434 .55647 L
s
P
p
0 .4 1 r
.02 w
.83434 .55647 m
.83354 .54339 L
s
P
p
.2 1 0 r
.02 w
.84621 .59154 m
.859 .59972 L
s
P
p
.2 1 0 r
.02 w
.84538 .57833 m
.84621 .59154 L
s
P
p
.2 1 0 r
.02 w
.83253 .57008 m
.84538 .57833 L
s
P
p
0 .4 1 r
.02 w
.84798 .57789 m
.83514 .56963 L
s
P
p
0 .4 1 r
.02 w
.84882 .5911 m
.84798 .57789 L
s
P
p
.2 1 0 r
.02 w
.83174 .55692 m
.83253 .57008 L
s
P
p
0 .4 1 r
.02 w
.83595 .58286 m
.84882 .5911 L
s
P
p
0 .4 1 r
.02 w
.83514 .56963 m
.83595 .58286 L
s
P
p
0 .4 1 r
.02 w
.83514 .56963 m
.82222 .56132 L
s
P
p
0 .4 1 r
.02 w
.83595 .58286 m
.83677 .59617 L
s
P
p
0 .4 1 r
.02 w
.82299 .57457 m
.83595 .58286 L
s
P
p
0 .4 1 r
.02 w
.82222 .56132 m
.82299 .57457 L
s
P
p
0 .4 1 r
.02 w
.83677 .59617 m
.82377 .5879 L
s
P
p
0 .4 1 r
.02 w
.82377 .5879 m
.81069 .57958 L
s
P
p
0 .4 1 r
.02 w
.81069 .57958 m
.79752 .57119 L
s
P
p
0 .4 1 r
.02 w
.79752 .57119 m
.79823 .58465 L
s
P
p
0 .4 1 r
.02 w
.78358 .54936 m
.78425 .56275 L
s
P
p
0 .4 1 r
.02 w
.77026 .54084 m
.78358 .54936 L
s
P
p
0 .4 1 r
.02 w
.79823 .58465 m
.78493 .57623 L
s
P
p
0 .4 1 r
.02 w
.78425 .56275 m
.78493 .57623 L
s
P
p
0 .4 1 r
.02 w
.78425 .56275 m
.7709 .55425 L
s
P
p
0 .4 1 r
.02 w
.7709 .55425 m
.77026 .54084 L
s
P
p
0 .4 1 r
.02 w
.79895 .59817 m
.79967 .61178 L
s
P
p
0 .4 1 r
.02 w
.78561 .58978 m
.79895 .59817 L
s
P
p
0 .4 1 r
.02 w
.78493 .57623 m
.78561 .58978 L
s
P
p
0 .4 1 r
.02 w
.79967 .61178 m
.8004 .62547 L
s
P
p
0 .4 1 r
.02 w
.78561 .58978 m
.77218 .58132 L
s
P
p
0 .4 1 r
.02 w
.7863 .60341 m
.78561 .58978 L
s
P
p
0 .4 1 r
.02 w
.8004 .62547 m
.78699 .61712 L
s
P
p
0 .4 1 r
.02 w
.78699 .61712 m
.7863 .60341 L
s
P
p
0 .4 1 r
.02 w
.77218 .58132 m
.75866 .57281 L
s
P
p
0 .4 1 r
.02 w
.75805 .55921 m
.74447 .55062 L
s
P
p
0 .4 1 r
.02 w
.75866 .57281 m
.75805 .55921 L
s
P
p
0 .4 1 r
.02 w
.74447 .55062 m
.73079 .54196 L
s
P
p
0 .4 1 r
.02 w
.73079 .54196 m
.71702 .53324 L
s
P
p
0 .4 1 r
.02 w
.70225 .49733 m
.68835 .48844 L
s
P
p
0 .4 1 r
.02 w
.70269 .51086 m
.70225 .49733 L
s
P
p
0 .4 1 r
.02 w
.71702 .53324 m
.70315 .52446 L
s
P
p
0 .4 1 r
.02 w
.68876 .50199 m
.70269 .51086 L
s
P
p
0 .4 1 r
.02 w
.68835 .48844 m
.68876 .50199 L
s
P
p
0 .4 1 r
.02 w
.70315 .52446 m
.68918 .51562 L
s
P
p
0 .4 1 r
.02 w
.68876 .50199 m
.68918 .51562 L
s
P
p
0 .4 1 r
.02 w
.7036 .53815 m
.70406 .55192 L
s
P
p
0 .4 1 r
.02 w
.68959 .52933 m
.7036 .53815 L
s
P
p
0 .4 1 r
.02 w
.68918 .51562 m
.68959 .52933 L
s
P
p
0 .4 1 r
.02 w
.67511 .50671 m
.68918 .51562 L
s
P
p
0 .4 1 r
.02 w
.70406 .55192 m
.69001 .54312 L
s
P
p
0 .4 1 r
.02 w
.68959 .52933 m
.69001 .54312 L
s
P
p
0 .4 1 r
.02 w
.67548 .52045 m
.67511 .50671 L
s
P
p
0 .4 1 r
.02 w
.69001 .54312 m
.69043 .55699 L
s
P
p
0 .4 1 r
.02 w
.69001 .54312 m
.67586 .53426 L
s
P
p
0 .4 1 r
.02 w
.67586 .53426 m
.67548 .52045 L
s
P
p
0 .4 1 r
.02 w
.69043 .55699 m
.67623 .54816 L
s
P
p
0 .4 1 r
.02 w
.69085 .57095 m
.69043 .55699 L
s
P
p
0 .4 1 r
.02 w
.67661 .56214 m
.69085 .57095 L
s
P
p
0 .4 1 r
.02 w
.67623 .54816 m
.67661 .56214 L
s
P
p
0 .4 1 r
.02 w
.67623 .54816 m
.66194 .53926 L
s
P
p
0 .4 1 r
.02 w
.67661 .56214 m
.677 .5762 L
s
P
p
0 .4 1 r
.02 w
.66228 .55326 m
.67661 .56214 L
s
P
p
0 .4 1 r
.02 w
.66194 .53926 m
.66228 .55326 L
s
P
p
0 .4 1 r
.02 w
.677 .5762 m
.66262 .56735 L
s
P
p
0 .4 1 r
.02 w
.66262 .56735 m
.64813 .55843 L
s
P
p
0 .4 1 r
.02 w
.64813 .55843 m
.63354 .54945 L
s
P
p
0 .4 1 r
.02 w
.63354 .54945 m
.6338 .56368 L
s
P
p
0 .4 1 r
.02 w
.61863 .52624 m
.61884 .5404 L
s
P
p
0 .4 1 r
.02 w
.60387 .5171 m
.61863 .52624 L
s
P
p
0 .4 1 r
.02 w
.6338 .56368 m
.61906 .55465 L
s
P
p
0 .4 1 r
.02 w
.61884 .5404 m
.61906 .55465 L
s
P
p
0 .4 1 r
.02 w
.61884 .5404 m
.60404 .53129 L
s
P
p
0 .4 1 r
.02 w
.60404 .53129 m
.60387 .5171 L
s
P
p
0 .4 1 r
.02 w
.63406 .57799 m
.63432 .59239 L
s
P
p
0 .4 1 r
.02 w
.61927 .56899 m
.63406 .57799 L
s
P
p
0 .4 1 r
.02 w
.61906 .55465 m
.61927 .56899 L
s
P
p
0 .4 1 r
.02 w
.63432 .59239 m
.63458 .60688 L
s
P
p
0 .4 1 r
.02 w
.61927 .56899 m
.60437 .55992 L
s
P
p
0 .4 1 r
.02 w
.61948 .58342 m
.61927 .56899 L
s
P
p
0 .4 1 r
.02 w
.63458 .60688 m
.6197 .59793 L
s
P
p
0 .4 1 r
.02 w
.6197 .59793 m
.61948 .58342 L
s
P
p
0 .4 1 r
.02 w
.60437 .55992 m
.58936 .55079 L
s
P
p
0 .4 1 r
.02 w
.58924 .5364 m
.57417 .52717 L
s
P
p
0 .4 1 r
.02 w
.58936 .55079 m
.58924 .5364 L
s
P
p
0 .4 1 r
.02 w
.57417 .52717 m
.55898 .51788 L
s
P
p
0 .4 1 r
.02 w
.55898 .51788 m
.54368 .50851 L
s
P
p
0 .4 1 r
.02 w
.5284 .47037 m
.51296 .46081 L
s
P
p
0 .4 1 r
.02 w
.52833 .48468 m
.5284 .47037 L
s
P
p
0 .4 1 r
.02 w
.54368 .50851 m
.52826 .49907 L
s
P
p
0 .4 1 r
.02 w
.51285 .47514 m
.52833 .48468 L
s
P
p
0 .4 1 r
.02 w
.51296 .46081 m
.51285 .47514 L
s
P
p
0 .4 1 r
.02 w
.52826 .49907 m
.51273 .48957 L
s
P
p
0 .4 1 r
.02 w
.51285 .47514 m
.51273 .48957 L
s
P
p
0 .4 1 r
.02 w
.52819 .51356 m
.52812 .52814 L
s
P
p
0 .4 1 r
.02 w
.51261 .50408 m
.52819 .51356 L
s
P
p
0 .4 1 r
.02 w
.51273 .48957 m
.51261 .50408 L
s
P
p
0 .4 1 r
.02 w
.49708 .47999 m
.51273 .48957 L
s
P
p
0 .4 1 r
.02 w
.52812 .52814 m
.51249 .51869 L
s
P
p
0 .4 1 r
.02 w
.51261 .50408 m
.51249 .51869 L
s
P
p
0 .4 1 r
.02 w
.49691 .49452 m
.49708 .47999 L
s
P
p
0 .4 1 r
.02 w
.51249 .51869 m
.51237 .53338 L
s
P
p
0 .4 1 r
.02 w
.51249 .51869 m
.49674 .50915 L
s
P
p
0 .4 1 r
.02 w
.49674 .50915 m
.49691 .49452 L
s
P
p
0 .4 1 r
.02 w
.51237 .53338 m
.49657 .52388 L
s
P
p
0 .4 1 r
.02 w
.51225 .54818 m
.51237 .53338 L
s
P
p
0 .4 1 r
.02 w
.4964 .5387 m
.51225 .54818 L
s
P
p
0 .4 1 r
.02 w
.49657 .52388 m
.4964 .5387 L
s
P
p
0 .4 1 r
.02 w
.49657 .52388 m
.48064 .5143 L
s
P
p
0 .4 1 r
.02 w
.4964 .5387 m
.49622 .55361 L
s
P
p
0 .4 1 r
.02 w
.48042 .52915 m
.4964 .5387 L
s
P
p
0 .4 1 r
.02 w
.48064 .5143 m
.48042 .52915 L
s
P
p
0 .4 1 r
.02 w
.49622 .55361 m
.48019 .54409 L
s
P
p
0 .4 1 r
.02 w
.48019 .54409 m
.46404 .53449 L
s
P
p
0 .4 1 r
.02 w
.46404 .53449 m
.44776 .52482 L
s
P
p
0 .4 1 r
.02 w
.44776 .52482 m
.44742 .53991 L
s
P
p
0 .4 1 r
.02 w
.43174 .50004 m
.43135 .51507 L
s
P
p
0 .4 1 r
.02 w
.41525 .49019 m
.43174 .50004 L
s
P
p
0 .4 1 r
.02 w
.44742 .53991 m
.43096 .53019 L
s
P
p
0 .4 1 r
.02 w
.43135 .51507 m
.43096 .53019 L
s
P
p
0 .4 1 r
.02 w
.43135 .51507 m
.41481 .50524 L
s
P
p
0 .4 1 r
.02 w
.41481 .50524 m
.41525 .49019 L
s
P
p
0 .4 1 r
.02 w
.44709 .5551 m
.44675 .5704 L
s
P
p
0 .4 1 r
.02 w
.43057 .54541 m
.44709 .5551 L
s
P
p
0 .4 1 r
.02 w
.43096 .53019 m
.43057 .54541 L
s
P
p
0 .4 1 r
.02 w
.44675 .5704 m
.44641 .58579 L
s
P
p
0 .4 1 r
.02 w
.43057 .54541 m
.41392 .53564 L
s
P
p
0 .4 1 r
.02 w
.43017 .56073 m
.43057 .54541 L
s
P
p
0 .4 1 r
.02 w
.44641 .58579 m
.42978 .57615 L
s
P
p
0 .4 1 r
.02 w
.42978 .57615 m
.43017 .56073 L
s
P
p
0 .4 1 r
.02 w
.41392 .53564 m
.39713 .52579 L
s
P
p
0 .4 1 r
.02 w
.39764 .51051 m
.38078 .50055 L
s
P
p
0 .4 1 r
.02 w
.39713 .52579 m
.39764 .51051 L
s
P
p
0 .4 1 r
.02 w
.38078 .50055 m
.36378 .49052 L
s
P
p
0 .4 1 r
.02 w
.36378 .49052 m
.34665 .4804 L
s
P
p
0 .4 1 r
.02 w
.33086 .43974 m
.31357 .4294 L
s
P
p
0 .4 1 r
.02 w
.33012 .45492 m
.33086 .43974 L
s
P
p
0 .4 1 r
.02 w
.34665 .4804 m
.32938 .4702 L
s
P
p
0 .4 1 r
.02 w
.31277 .44461 m
.33012 .45492 L
s
P
p
0 .4 1 r
.02 w
.31357 .4294 m
.31277 .44461 L
s
P
p
0 .4 1 r
.02 w
.32938 .4702 m
.31197 .45992 L
s
P
p
0 .4 1 r
.02 w
.31277 .44461 m
.31197 .45992 L
s
P
p
0 .4 1 r
.02 w
.32864 .48559 m
.32789 .50109 L
s
P
p
0 .4 1 r
.02 w
.31117 .47534 m
.32864 .48559 L
s
P
p
0 .4 1 r
.02 w
.31197 .45992 m
.31117 .47534 L
s
P
p
0 .4 1 r
.02 w
.29442 .44956 m
.31197 .45992 L
s
P
p
0 .4 1 r
.02 w
.32789 .50109 m
.31035 .49086 L
s
P
p
0 .4 1 r
.02 w
.31117 .47534 m
.31035 .49086 L
s
P
p
0 .4 1 r
.02 w
.29355 .465 m
.29442 .44956 L
s
P
p
0 .4 1 r
.02 w
.31035 .49086 m
.30954 .50649 L
s
P
p
0 .4 1 r
.02 w
.31035 .49086 m
.29268 .48055 L
s
P
p
0 .4 1 r
.02 w
.29268 .48055 m
.29355 .465 L
s
P
p
0 .4 1 r
.02 w
.30954 .50649 m
.2918 .49621 L
s
P
p
0 .4 1 r
.02 w
.30871 .52222 m
.30954 .50649 L
s
P
p
0 .4 1 r
.02 w
.29091 .51197 m
.30871 .52222 L
s
P
p
0 .4 1 r
.02 w
.2918 .49621 m
.29091 .51197 L
s
P
p
0 .4 1 r
.02 w
.2918 .49621 m
.27391 .48584 L
s
P
p
0 .4 1 r
.02 w
.29091 .51197 m
.29002 .52784 L
s
P
p
0 .4 1 r
.02 w
.27295 .50164 m
.29091 .51197 L
s
P
p
0 .4 1 r
.02 w
.27391 .48584 m
.27295 .50164 L
s
P
p
0 .4 1 r
.02 w
.29002 .52784 m
.272 .51754 L
s
P
p
0 .4 1 r
.02 w
.272 .51754 m
.25383 .50715 L
s
P
p
0 .4 1 r
.02 w
.25383 .50715 m
.2355 .49667 L
s
P
p
0 .4 1 r
.02 w
.2355 .49667 m
.2344 .51275 L
s
P
p
0 .4 1 r
.02 w
.21819 .47011 m
.21703 .48611 L
s
P
p
0 .4 1 r
.02 w
.19963 .45943 m
.21819 .47011 L
s
P
p
0 .4 1 r
.02 w
.2344 .51275 m
.21586 .50221 L
s
P
p
0 .4 1 r
.02 w
.21703 .48611 m
.21586 .50221 L
s
P
p
0 .4 1 r
.02 w
.21703 .48611 m
.1984 .47545 L
s
P
p
0 .4 1 r
.02 w
.1984 .47545 m
.19963 .45943 L
s
P
p
0 .4 1 r
.02 w
.23329 .52893 m
.23217 .54523 L
s
P
p
0 .4 1 r
.02 w
.21468 .51843 m
.23329 .52893 L
s
P
p
0 .4 1 r
.02 w
.21586 .50221 m
.21468 .51843 L
s
P
p
0 .4 1 r
.02 w
.23217 .54523 m
.23105 .56165 L
s
P
p
0 .4 1 r
.02 w
.21468 .51843 m
.1959 .50784 L
s
P
p
0 .4 1 r
.02 w
.21349 .53476 m
.21468 .51843 L
s
P
p
0 .4 1 r
.02 w
.23105 .56165 m
.21229 .55121 L
s
P
p
0 .4 1 r
.02 w
.21229 .55121 m
.21349 .53476 L
s
P
p
0 .4 1 r
.02 w
.1959 .50784 m
.17697 .49715 L
s
P
p
0 .4 1 r
.02 w
.17829 .48087 m
.15927 .47006 L
s
P
p
0 .4 1 r
.02 w
.17697 .49715 m
.17829 .48087 L
s
P
p
0 .4 1 r
.02 w
.15927 .47006 m
.14008 .45916 L
s
P
p
0 .4 1 r
.02 w
.14008 .45916 m
.12073 .44817 L
s
P
p
0 .4 1 r
.02 w
.10442 .40462 m
.08489 .39338 L
s
P
p
0 .4 1 r
.02 w
.10282 .42079 m
.10442 .40462 L
s
P
p
0 .4 1 r
.02 w
.12073 .44817 m
.10121 .43708 L
s
P
p
0 .4 1 r
.02 w
.08321 .40958 m
.10282 .42079 L
s
P
p
0 .4 1 r
.02 w
.08489 .39338 m
.08321 .40958 L
s
P
p
0 .4 1 r
.02 w
.10121 .43708 m
.08151 .4259 L
s
P
p
0 .4 1 r
.02 w
.08321 .40958 m
.08151 .4259 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.292607 0.149123 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.920195 2.90238 0.00511523 0.970619 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.39378 .13247 m
.2922 .09001 L
s
P
p
0 .4 1 r
.02 w
.39178 .18327 m
.39378 .13247 L
s
P
p
.2 1 0 r
.02 w
.86767 .70152 m
.77309 .66857 L
s
P
p
.2 1 0 r
.02 w
.87263 .76141 m
.86767 .70152 L
s
P
p
0 .4 1 r
.02 w
.38973 .23558 m
.39178 .18327 L
s
P
p
.2 1 0 r
.02 w
.76956 .60986 m
.67296 .57518 L
s
P
p
.2 1 0 r
.02 w
.77309 .66857 m
.76956 .60986 L
s
P
p
0 .4 1 r
.02 w
.2922 .09001 m
.28867 .14109 L
s
P
p
.2 1 0 r
.02 w
.77672 .72905 m
.87263 .76141 L
s
P
p
0 .4 1 r
.02 w
.28503 .19371 m
.38973 .23558 L
s
P
p
0 .4 1 r
.02 w
.28867 .14109 m
.28503 .19371 L
s
P
p
0 .4 1 r
.02 w
.18182 .09739 m
.28867 .14109 L
s
P
p
.2 1 0 r
.02 w
.67296 .57518 m
.67509 .63444 L
s
P
p
.2 1 0 r
.02 w
.57223 .48124 m
.46999 .44349 L
s
P
p
.2 1 0 r
.02 w
.57285 .53925 m
.57223 .48124 L
s
P
p
0 .4 1 r
.02 w
.38762 .28945 m
.28128 .24793 L
s
P
p
0 .4 1 r
.02 w
.38544 .34496 m
.38762 .28945 L
s
P
p
.2 1 0 r
.02 w
.6773 .6955 m
.77672 .72905 L
s
P
p
0 .4 1 r
.02 w
.28503 .19371 m
.28128 .24793 L
s
P
p
.2 1 0 r
.02 w
.67509 .63444 m
.57349 .59904 L
s
P
p
0 .4 1 r
.02 w
.17648 .1503 m
.18182 .09739 L
s
P
p
.2 1 0 r
.02 w
.57349 .59904 m
.57285 .53925 L
s
P
p
.2 1 0 r
.02 w
.46999 .44349 m
.46906 .50199 L
s
P
p
0 .4 1 r
.02 w
.27741 .30382 m
.38544 .34496 L
s
P
p
.2 1 0 r
.02 w
.78046 .79137 m
.67956 .75846 L
s
P
p
.2 1 0 r
.02 w
.78432 .85561 m
.78046 .79137 L
s
P
p
0 .4 1 r
.02 w
.28128 .24793 m
.27741 .30382 L
s
P
p
0 .4 1 r
.02 w
.28128 .24793 m
.17097 .20485 L
s
P
p
.2 1 0 r
.02 w
.67956 .75846 m
.6773 .6955 L
s
P
p
0 .4 1 r
.02 w
.17097 .20485 m
.17648 .1503 L
s
P
p
.2 1 0 r
.02 w
.46906 .50199 m
.36136 .46333 L
s
P
p
0 .4 1 r
.02 w
.38319 .40218 m
.38087 .4612 L
s
P
p
0 .4 1 r
.02 w
.27342 .36148 m
.38319 .40218 L
s
P
p
.2 1 0 r
.02 w
.68191 .8234 m
.78432 .85561 L
s
P
p
0 .4 1 r
.02 w
.27741 .30382 m
.1653 .26113 L
s
P
p
0 .4 1 r
.02 w
.27342 .36148 m
.27741 .30382 L
s
P
p
.2 1 0 r
.02 w
.46809 .56232 m
.46709 .62457 L
s
P
p
.2 1 0 r
.02 w
.35866 .5242 m
.46809 .56232 L
s
P
p
.01 w
.36136 .46333 Mdot
P
p
.2 1 0 r
.02 w
.36136 .46333 m
.35866 .5242 L
s
P
p
.01 w
.38087 .4612 Mdot
P
p
0 .4 1 r
.02 w
.38087 .4612 m
.37848 .52209 L
s
P
p
0 .4 1 r
.02 w
.15943 .31921 m
.27342 .36148 L
s
P
p
0 .4 1 r
.02 w
.26931 .42098 m
.27342 .36148 L
s
P
p
.2 1 0 r
.02 w
.68432 .89042 m
.68191 .8234 L
s
P
p
0 .4 1 r
.02 w
.1653 .26113 m
.15943 .31921 L
s
P
p
.2 1 0 r
.02 w
.57484 .7243 m
.57554 .78994 L
s
P
p
.2 1 0 r
.02 w
.46606 .68882 m
.57484 .7243 L
s
P
p
.2 1 0 r
.02 w
.46709 .62457 m
.35587 .58704 L
s
P
p
0 .4 1 r
.02 w
.37848 .52209 m
.26506 .48241 L
s
P
p
0 .4 1 r
.02 w
.26506 .48241 m
.26931 .42098 L
s
P
p
0 .4 1 r
.02 w
.26931 .42098 m
.15338 .37918 L
s
P
p
.2 1 0 r
.02 w
.57627 .85773 m
.68432 .89042 L
s
P
p
.2 1 0 r
.02 w
.57554 .78994 m
.57627 .85773 L
s
P
p
.2 1 0 r
.02 w
.465 .75517 m
.46606 .68882 L
s
P
p
.2 1 0 r
.02 w
.35587 .58704 m
.24025 .54802 L
s
P
p
0 .4 1 r
.02 w
.26067 .54586 m
.26506 .48241 L
s
P
p
0 .4 1 r
.02 w
.15338 .37918 m
.14713 .44114 L
s
P
p
.2 1 0 r
.02 w
.35002 .71901 m
.465 .75517 L
s
P
p
.2 1 0 r
.02 w
.353 .65194 m
.35002 .71901 L
s
P
p
.2 1 0 r
.02 w
.23538 .61357 m
.353 .65194 L
s
P
p
.2 1 0 r
.02 w
.24025 .54802 m
.23538 .61357 L
s
P
p
0 .4 1 r
.02 w
.14067 .50518 m
.26067 .54586 L
s
P
p
0 .4 1 r
.02 w
.14713 .44114 m
.14067 .50518 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.292607 0.286967 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.912497 2.88859 0.00622593 0.969536 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8494 .38408 m
.80222 .36481 L
s
P
p
.2 1 0 r
.02 w
.85175 .41167 m
.8494 .38408 L
s
P
p
.2 1 0 r
.02 w
.80022 .33753 m
.75254 .31782 L
s
P
p
.2 1 0 r
.02 w
.80222 .36481 m
.80022 .33753 L
s
P
p
.2 1 0 r
.02 w
.80424 .39251 m
.85175 .41167 L
s
P
p
.2 1 0 r
.02 w
.75254 .31782 m
.75419 .3452 L
s
P
p
.2 1 0 r
.02 w
.70271 .27068 m
.65364 .25016 L
s
P
p
.2 1 0 r
.02 w
.70399 .29775 m
.70271 .27068 L
s
P
p
.2 1 0 r
.02 w
.75586 .373 m
.80424 .39251 L
s
P
p
.2 1 0 r
.02 w
.75419 .3452 m
.70529 .32524 L
s
P
p
.2 1 0 r
.02 w
.70529 .32524 m
.70399 .29775 L
s
P
p
.2 1 0 r
.02 w
.65364 .25016 m
.65456 .27733 L
s
P
p
.2 1 0 r
.02 w
.80629 .42062 m
.75757 .40122 L
s
P
p
.2 1 0 r
.02 w
.80837 .44916 m
.80629 .42062 L
s
P
p
.2 1 0 r
.02 w
.75757 .40122 m
.75586 .373 L
s
P
p
.2 1 0 r
.02 w
.65456 .27733 m
.60423 .25652 L
s
P
p
.2 1 0 r
.02 w
.75929 .42987 m
.80837 .44916 L
s
P
p
.2 1 0 r
.02 w
.6555 .3049 m
.65645 .3329 L
s
P
p
.2 1 0 r
.02 w
.60479 .2842 m
.6555 .3049 L
s
P
p
.01 w
.60423 .25652 Mdot
P
p
.2 1 0 r
.02 w
.60423 .25652 m
.60479 .2842 L
s
P
p
.01 w
.61377 .25539 Mdot
P
p
0 .4 1 r
.02 w
.61377 .25539 m
.6144 .28306 L
s
P
p
.2 1 0 r
.02 w
.76105 .45897 m
.75929 .42987 L
s
P
p
.2 1 0 r
.02 w
.70795 .38146 m
.70931 .41023 L
s
P
p
.2 1 0 r
.02 w
.65741 .36134 m
.70795 .38146 L
s
P
p
.2 1 0 r
.02 w
.65645 .3329 m
.60535 .3123 L
s
P
p
0 .4 1 r
.02 w
.6144 .28306 m
.61504 .31117 L
s
P
p
.2 1 0 r
.02 w
.71069 .43944 m
.76105 .45897 L
s
P
p
.2 1 0 r
.02 w
.70931 .41023 m
.71069 .43944 L
s
P
p
.2 1 0 r
.02 w
.65839 .39022 m
.65741 .36134 L
s
P
p
0 .4 1 r
.02 w
.66711 .36024 m
.66817 .38912 L
s
P
p
0 .4 1 r
.02 w
.61569 .33971 m
.66711 .36024 L
s
P
p
.2 1 0 r
.02 w
.60535 .3123 m
.5533 .2913 L
s
P
p
0 .4 1 r
.02 w
.61504 .31117 m
.56305 .29015 L
s
P
p
0 .4 1 r
.02 w
.77263 .48747 m
.72196 .46805 L
s
P
p
0 .4 1 r
.02 w
.77452 .51749 m
.77263 .48747 L
s
P
p
0 .4 1 r
.02 w
.72048 .43837 m
.66924 .41846 L
s
P
p
0 .4 1 r
.02 w
.72196 .46805 m
.72048 .43837 L
s
P
p
.2 1 0 r
.02 w
.60651 .36982 m
.65839 .39022 L
s
P
p
0 .4 1 r
.02 w
.66817 .38912 m
.66924 .41846 L
s
P
p
.2 1 0 r
.02 w
.60593 .34084 m
.60651 .36982 L
s
P
p
.2 1 0 r
.02 w
.55347 .31995 m
.60593 .34084 L
s
P
p
0 .4 1 r
.02 w
.5633 .3188 m
.61569 .33971 L
s
P
p
.2 1 0 r
.02 w
.5533 .2913 m
.55347 .31995 L
s
P
p
0 .4 1 r
.02 w
.56305 .29015 m
.5633 .3188 L
s
P
p
0 .4 1 r
.02 w
.72347 .4982 m
.77452 .51749 L
s
P
p
0 .4 1 r
.02 w
.66924 .41846 m
.61703 .39816 L
s
P
p
0 .4 1 r
.02 w
.66924 .41846 m
.67033 .44826 L
s
P
p
0 .4 1 r
.02 w
.67144 .47854 m
.72347 .4982 L
s
P
p
0 .4 1 r
.02 w
.67033 .44826 m
.67144 .47854 L
s
P
p
0 .4 1 r
.02 w
.61703 .39816 m
.56381 .37748 L
s
P
p
0 .4 1 r
.02 w
.56381 .37748 m
.50955 .35639 L
s
P
p
0 .4 1 r
.02 w
.50973 .32671 m
.50955 .35639 L
s
P
p
0 .4 1 r
.02 w
.50955 .35639 m
.50937 .38657 L
s
P
p
0 .4 1 r
.02 w
.56433 .43807 m
.56459 .46911 L
s
P
p
0 .4 1 r
.02 w
.50919 .41723 m
.56433 .43807 L
s
P
p
0 .4 1 r
.02 w
.50937 .38657 m
.4536 .36519 L
s
P
p
0 .4 1 r
.02 w
.67486 .57235 m
.62055 .55274 L
s
P
p
0 .4 1 r
.02 w
.67605 .60465 m
.67486 .57235 L
s
P
p
0 .4 1 r
.02 w
.61982 .52081 m
.56487 .50066 L
s
P
p
0 .4 1 r
.02 w
.62055 .55274 m
.61982 .52081 L
s
P
p
0 .4 1 r
.02 w
.56459 .46911 m
.56487 .50066 L
s
P
p
0 .4 1 r
.02 w
.45295 .39598 m
.50919 .41723 L
s
P
p
0 .4 1 r
.02 w
.4536 .36519 m
.45295 .39598 L
s
P
p
0 .4 1 r
.02 w
.62129 .58521 m
.67605 .60465 L
s
P
p
0 .4 1 r
.02 w
.56487 .50066 m
.50881 .48011 L
s
P
p
0 .4 1 r
.02 w
.56487 .50066 m
.56514 .53274 L
s
P
p
0 .4 1 r
.02 w
.56542 .56537 m
.62129 .58521 L
s
P
p
0 .4 1 r
.02 w
.56514 .53274 m
.56542 .56537 L
s
P
p
0 .4 1 r
.02 w
.50881 .48011 m
.45161 .45914 L
s
P
p
0 .4 1 r
.02 w
.45161 .45914 m
.39325 .43773 L
s
P
p
0 .4 1 r
.02 w
.39442 .40575 m
.39325 .43773 L
s
P
p
0 .4 1 r
.02 w
.39325 .43773 m
.39206 .47027 L
s
P
p
0 .4 1 r
.02 w
.45024 .52446 m
.44953 .55797 L
s
P
p
0 .4 1 r
.02 w
.39084 .50337 m
.45024 .52446 L
s
P
p
0 .4 1 r
.02 w
.39206 .47027 m
.33195 .44857 L
s
P
p
0 .4 1 r
.02 w
.56629 .66661 m
.5078 .6469 L
s
P
p
0 .4 1 r
.02 w
.56659 .70154 m
.56629 .66661 L
s
P
p
0 .4 1 r
.02 w
.50801 .61238 m
.44881 .59207 L
s
P
p
0 .4 1 r
.02 w
.5078 .6469 m
.50801 .61238 L
s
P
p
0 .4 1 r
.02 w
.44953 .55797 m
.44881 .59207 L
s
P
p
0 .4 1 r
.02 w
.3302 .48183 m
.39084 .50337 L
s
P
p
0 .4 1 r
.02 w
.33195 .44857 m
.3302 .48183 L
s
P
p
0 .4 1 r
.02 w
.50759 .68202 m
.56659 .70154 L
s
P
p
0 .4 1 r
.02 w
.44881 .59207 m
.38835 .57132 L
s
P
p
0 .4 1 r
.02 w
.44881 .59207 m
.44808 .62676 L
s
P
p
0 .4 1 r
.02 w
.44733 .66208 m
.50759 .68202 L
s
P
p
0 .4 1 r
.02 w
.44808 .62676 m
.44733 .66208 L
s
P
p
0 .4 1 r
.02 w
.38835 .57132 m
.3266 .55013 L
s
P
p
0 .4 1 r
.02 w
.3266 .55013 m
.26351 .52847 L
s
P
p
0 .4 1 r
.02 w
.26591 .49385 m
.26351 .52847 L
s
P
p
0 .4 1 r
.02 w
.26351 .52847 m
.26107 .56373 L
s
P
p
0 .4 1 r
.02 w
.32287 .6209 m
.32095 .65727 L
s
P
p
0 .4 1 r
.02 w
.25858 .59963 m
.32287 .6209 L
s
P
p
0 .4 1 r
.02 w
.26107 .56373 m
.19597 .54179 L
s
P
p
0 .4 1 r
.02 w
.44502 .7719 m
.38172 .75219 L
s
P
p
0 .4 1 r
.02 w
.44422 .80986 m
.44502 .7719 L
s
P
p
0 .4 1 r
.02 w
.3831 .71469 m
.319 .6943 L
s
P
p
0 .4 1 r
.02 w
.38172 .75219 m
.3831 .71469 L
s
P
p
0 .4 1 r
.02 w
.32095 .65727 m
.319 .6943 L
s
P
p
0 .4 1 r
.02 w
.19285 .57789 m
.25858 .59963 L
s
P
p
0 .4 1 r
.02 w
.19597 .54179 m
.19285 .57789 L
s
P
p
0 .4 1 r
.02 w
.38032 .79039 m
.44422 .80986 L
s
P
p
0 .4 1 r
.02 w
.319 .6943 m
.25346 .67346 L
s
P
p
0 .4 1 r
.02 w
.319 .6943 m
.31701 .73203 L
s
P
p
0 .4 1 r
.02 w
.31499 .77047 m
.38032 .79039 L
s
P
p
0 .4 1 r
.02 w
.31701 .73203 m
.31499 .77047 L
s
P
p
0 .4 1 r
.02 w
.25346 .67346 m
.18643 .65214 L
s
P
p
0 .4 1 r
.02 w
.18643 .65214 m
.11786 .63034 L
s
P
p
0 .4 1 r
.02 w
.11786 .63034 m
.12179 .59264 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.292607 0.424812 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.498191 2.097 0.0245059 0.980236 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87882 .61174 m
.78846 .56381 L
s
P
p
.2 1 0 r
.02 w
.88591 .6918 m
.87882 .61174 L
s
P
p
.2 1 0 r
.02 w
.7834 .48613 m
.69015 .43471 L
s
P
p
.2 1 0 r
.02 w
.78846 .56381 m
.7834 .48613 L
s
P
p
.2 1 0 r
.02 w
.79374 .64494 m
.88591 .6918 L
s
P
p
.2 1 0 r
.02 w
.69015 .43471 m
.69327 .51333 L
s
P
p
.2 1 0 r
.02 w
.59099 .30448 m
.48962 .24655 L
s
P
p
.2 1 0 r
.02 w
.5919 .38054 m
.59099 .30448 L
s
P
p
.2 1 0 r
.02 w
.69652 .59553 m
.79374 .64494 L
s
P
p
.2 1 0 r
.02 w
.69327 .51333 m
.59285 .46007 L
s
P
p
.2 1 0 r
.02 w
.59285 .46007 m
.5919 .38054 L
s
P
p
.2 1 0 r
.02 w
.48962 .24655 m
.48822 .32337 L
s
P
p
.2 1 0 r
.02 w
.79926 .72975 m
.69993 .68156 L
s
P
p
.2 1 0 r
.02 w
.80503 .8185 m
.79926 .72975 L
s
P
p
.2 1 0 r
.02 w
.69993 .68156 m
.69652 .59553 L
s
P
p
.2 1 0 r
.02 w
.48822 .32337 m
.37867 .26297 L
s
P
p
0 .4 1 r
.02 w
.40185 .182 m
.39834 .2596 L
s
P
p
0 .4 1 r
.02 w
.28914 .11718 m
.40185 .182 L
s
P
p
.2 1 0 r
.02 w
.7035 .77169 m
.80503 .8185 L
s
P
p
.2 1 0 r
.02 w
.48676 .40381 m
.48523 .48812 L
s
P
p
.2 1 0 r
.02 w
.37451 .34428 m
.48676 .40381 L
s
P
p
.01 w
.37867 .26297 Mdot
P
p
.2 1 0 r
.02 w
.37867 .26297 m
.37451 .34428 L
s
P
p
.01 w
.39834 .2596 Mdot
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.16981 .04855 m
.28914 .11718 L
s
P
p
.2 1 0 r
.02 w
.70724 .86623 m
.7035 .77169 L
s
P
p
.2 1 0 r
.02 w
.59489 .63059 m
.59598 .72212 L
s
P
p
.2 1 0 r
.02 w
.48363 .5766 m
.59489 .63059 L
s
P
p
.2 1 0 r
.02 w
.48523 .48812 m
.37015 .42962 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.2761 .27766 L
s
P
p
.2 1 0 r
.02 w
.59713 .81827 m
.70724 .86623 L
s
P
p
0 .4 1 r
.02 w
.16026 .12747 m
.16981 .04855 L
s
P
p
.2 1 0 r
.02 w
.59598 .72212 m
.59713 .81827 L
s
P
p
.2 1 0 r
.02 w
.48194 .66955 m
.48363 .5766 L
s
P
p
.2 1 0 r
.02 w
.37015 .42962 m
.24801 .36753 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.15022 .21045 L
s
P
p
0 .4 1 r
.02 w
.15022 .21045 m
.16026 .12747 L
s
P
p
.2 1 0 r
.02 w
.36075 .61368 m
.48194 .66955 L
s
P
p
.2 1 0 r
.02 w
.36557 .51931 m
.36075 .61368 L
s
P
p
.2 1 0 r
.02 w
.24008 .45841 m
.36557 .51931 L
s
P
p
.2 1 0 r
.02 w
.24801 .36753 m
.24008 .45841 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.292607 0.562657 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.43789 .35572 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.292607 0.700501 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.430548 1.96123 0.0248105 0.99242 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.89627 .6866 m
.83078 .64997 L
s
P
p
.2 1 0 r
.02 w
.90155 .7505 m
.89627 .6866 L
s
P
p
.2 1 0 r
.02 w
.82656 .5874 m
.75959 .54883 L
s
P
p
.2 1 0 r
.02 w
.83078 .64997 m
.82656 .5874 L
s
P
p
.2 1 0 r
.02 w
.83514 .71449 m
.90155 .7505 L
s
P
p
.2 1 0 r
.02 w
.75959 .54883 m
.76285 .61198 L
s
P
p
.2 1 0 r
.02 w
.68795 .44706 m
.61691 .40501 L
s
P
p
.2 1 0 r
.02 w
.69011 .50882 m
.68795 .44706 L
s
P
p
.2 1 0 r
.02 w
.76621 .67712 m
.83514 .71449 L
s
P
p
.2 1 0 r
.02 w
.76285 .61198 m
.69233 .57253 L
s
P
p
.2 1 0 r
.02 w
.69233 .57253 m
.69011 .50882 L
s
P
p
.2 1 0 r
.02 w
.61691 .40501 m
.61797 .46728 L
s
P
p
.2 1 0 r
.02 w
.83963 .78105 m
.76969 .74436 L
s
P
p
.2 1 0 r
.02 w
.84427 .84973 m
.83963 .78105 L
s
P
p
.2 1 0 r
.02 w
.76969 .74436 m
.76621 .67712 L
s
P
p
.2 1 0 r
.02 w
.61797 .46728 m
.54303 .42412 L
s
P
p
.2 1 0 r
.02 w
.77327 .81379 m
.84427 .84973 L
s
P
p
0 .4 1 r
.02 w
.48166 .25222 m
.40347 .20452 L
s
P
p
0 .4 1 r
.02 w
.48054 .31348 m
.48166 .25222 L
s
P
p
.2 1 0 r
.02 w
.61907 .53156 m
.6202 .59795 L
s
P
p
.2 1 0 r
.02 w
.54291 .48896 m
.61907 .53156 L
s
P
p
0 .4 1 r
.02 w
.63319 .52929 m
.55723 .48661 L
s
P
p
0 .4 1 r
.02 w
.63456 .59572 m
.63319 .52929 L
s
P
p
.01 w
.54303 .42412 Mdot
P
p
.2 1 0 r
.02 w
.54303 .42412 m
.54291 .48896 L
s
P
p
.01 w
.55712 .42174 Mdot
P
p
0 .4 1 r
.02 w
.55723 .48661 m
.55712 .42174 L
s
P
p
0 .4 1 r
.02 w
.48054 .31348 m
.40104 .26621 L
s
P
p
0 .4 1 r
.02 w
.47939 .37677 m
.48054 .31348 L
s
P
p
.2 1 0 r
.02 w
.77698 .88553 m
.77327 .81379 L
s
P
p
0 .4 1 r
.02 w
.40347 .20452 m
.40104 .26621 L
s
P
p
.2 1 0 r
.02 w
.69699 .70622 m
.69944 .77641 L
s
P
p
.2 1 0 r
.02 w
.62138 .66656 m
.69699 .70622 L
s
P
p
.2 1 0 r
.02 w
.6202 .59795 m
.54279 .55597 L
s
P
p
0 .4 1 r
.02 w
.55735 .55365 m
.63456 .59572 L
s
P
p
0 .4 1 r
.02 w
.4782 .44219 m
.55723 .48661 L
s
P
p
0 .4 1 r
.02 w
.55723 .48661 m
.55735 .55365 L
s
P
p
0 .4 1 r
.02 w
.47939 .37677 m
.4782 .44219 L
s
P
p
0 .4 1 r
.02 w
.39852 .32998 m
.47939 .37677 L
s
P
p
.2 1 0 r
.02 w
.70197 .84897 m
.77698 .88553 L
s
P
p
0 .4 1 r
.02 w
.40104 .26621 m
.39852 .32998 L
s
P
p
0 .4 1 r
.02 w
.31829 .21701 m
.40104 .26621 L
s
P
p
.2 1 0 r
.02 w
.69944 .77641 m
.70197 .84897 L
s
P
p
.2 1 0 r
.02 w
.62259 .7375 m
.62138 .66656 L
s
P
p
.2 1 0 r
.02 w
.54279 .55597 m
.4622 .51228 L
s
P
p
0 .4 1 r
.02 w
.47697 .50986 m
.55735 .55365 L
s
P
p
0 .4 1 r
.02 w
.39591 .39595 m
.4782 .44219 L
s
P
p
0 .4 1 r
.02 w
.4782 .44219 m
.47697 .50986 L
s
P
p
0 .4 1 r
.02 w
.39852 .32998 m
.39591 .39595 L
s
P
p
0 .4 1 r
.02 w
.31429 .28126 m
.39852 .32998 L
s
P
p
.2 1 0 r
.02 w
.54254 .69697 m
.62259 .7375 L
s
P
p
.2 1 0 r
.02 w
.54267 .62527 m
.54254 .69697 L
s
P
p
.2 1 0 r
.02 w
.46067 .58226 m
.54267 .62527 L
s
P
p
.2 1 0 r
.02 w
.4622 .51228 m
.46067 .58226 L
s
P
p
0 .4 1 r
.02 w
.47697 .50986 m
.39322 .46422 L
s
P
p
0 .4 1 r
.02 w
.39322 .46422 m
.39591 .39595 L
s
P
p
0 .4 1 r
.02 w
.31016 .34776 m
.39591 .39595 L
s
P
p
0 .4 1 r
.02 w
.31016 .34776 m
.31429 .28126 L
s
P
p
0 .4 1 r
.02 w
.31429 .28126 m
.22651 .23047 L
s
P
p
0 .4 1 r
.02 w
.4757 .57988 m
.39042 .53493 L
s
P
p
0 .4 1 r
.02 w
.39042 .53493 m
.39322 .46422 L
s
P
p
0 .4 1 r
.02 w
.39322 .46422 m
.30587 .41664 L
s
P
p
0 .4 1 r
.02 w
.22071 .29749 m
.31016 .34776 L
s
P
p
0 .4 1 r
.02 w
.30587 .41664 m
.31016 .34776 L
s
P
p
0 .4 1 r
.02 w
.22651 .23047 m
.13494 .17749 L
s
P
p
0 .4 1 r
.02 w
.22071 .29749 m
.22651 .23047 L
s
P
p
0 .4 1 r
.02 w
.38753 .6082 m
.39042 .53493 L
s
P
p
0 .4 1 r
.02 w
.39042 .53493 m
.30143 .48802 L
s
P
p
0 .4 1 r
.02 w
.30587 .41664 m
.30143 .48802 L
s
P
p
0 .4 1 r
.02 w
.2147 .36696 m
.22071 .29749 L
s
P
p
0 .4 1 r
.02 w
.12733 .24502 m
.22071 .29749 L
s
P
p
0 .4 1 r
.02 w
.13494 .17749 m
.12733 .24502 L
s
P
p
0 .4 1 r
.02 w
.29682 .56205 m
.38753 .6082 L
s
P
p
0 .4 1 r
.02 w
.30143 .48802 m
.29682 .56205 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.292607 0.838346 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.632797 2.35504 0.0239558 0.958232 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.71976 .37458 m
.63797 .33406 L
s
P
p
0 .4 1 r
.02 w
.72273 .43103 m
.71976 .37458 L
s
P
p
0 .4 1 r
.02 w
.63958 .39097 m
.72273 .43103 L
s
P
p
0 .4 1 r
.02 w
.63797 .33406 m
.63958 .39097 L
s
P
p
.2 1 0 r
.02 w
.88022 .68616 m
.7996 .65108 L
s
P
p
.2 1 0 r
.02 w
.88606 .74954 m
.88022 .68616 L
s
P
p
.2 1 0 r
.02 w
.79522 .58917 m
.71253 .55193 L
s
P
p
.2 1 0 r
.02 w
.7996 .65108 m
.79522 .58917 L
s
P
p
0 .4 1 r
.02 w
.63958 .39097 m
.64125 .4499 L
s
P
p
0 .4 1 r
.02 w
.55277 .29184 m
.55291 .34922 L
s
P
p
0 .4 1 r
.02 w
.46394 .24783 m
.55277 .29184 L
s
P
p
.2 1 0 r
.02 w
.80413 .71519 m
.88606 .74954 L
s
P
p
.2 1 0 r
.02 w
.71253 .55193 m
.71552 .6145 L
s
P
p
.2 1 0 r
.02 w
.62485 .45208 m
.5364 .41094 L
s
P
p
.2 1 0 r
.02 w
.62628 .51309 m
.62485 .45208 L
s
P
p
0 .4 1 r
.02 w
.64125 .4499 m
.64298 .51094 L
s
P
p
0 .4 1 r
.02 w
.55306 .40867 m
.64125 .4499 L
s
P
p
0 .4 1 r
.02 w
.55291 .34922 m
.46248 .30566 L
s
P
p
0 .4 1 r
.02 w
.46248 .30566 m
.46394 .24783 L
s
P
p
0 .4 1 r
.02 w
.37124 .2019 m
.46394 .24783 L
s
P
p
.2 1 0 r
.02 w
.71863 .67934 m
.80413 .71519 L
s
P
p
0 .4 1 r
.02 w
.37433 .14571 m
.27934 .09739 L
s
P
p
0 .4 1 r
.02 w
.37124 .2019 m
.37433 .14571 L
s
P
p
.2 1 0 r
.02 w
.71552 .6145 m
.62777 .57632 L
s
P
p
.2 1 0 r
.02 w
.62777 .57632 m
.62628 .51309 L
s
P
p
0 .4 1 r
.02 w
.64298 .51094 m
.55321 .47029 L
s
P
p
.2 1 0 r
.02 w
.5364 .41094 m
.53625 .47254 L
s
P
p
0 .4 1 r
.02 w
.55306 .40867 m
.46096 .36561 L
s
P
p
0 .4 1 r
.02 w
.55321 .47029 m
.55306 .40867 L
s
P
p
0 .4 1 r
.02 w
.46248 .30566 m
.46096 .36561 L
s
P
p
.2 1 0 r
.02 w
.80883 .78162 m
.72185 .74659 L
s
P
p
.2 1 0 r
.02 w
.8137 .8505 m
.80883 .78162 L
s
P
p
0 .4 1 r
.02 w
.27443 .15393 m
.37124 .2019 L
s
P
p
.2 1 0 r
.02 w
.72185 .74659 m
.71863 .67934 L
s
P
p
0 .4 1 r
.02 w
.27934 .09739 m
.27443 .15393 L
s
P
p
0 .4 1 r
.02 w
.64478 .5742 m
.55337 .53421 L
s
P
p
0 .4 1 r
.02 w
.64664 .63982 m
.64478 .5742 L
s
P
p
.2 1 0 r
.02 w
.53625 .47254 m
.44217 .43017 L
s
P
p
0 .4 1 r
.02 w
.46096 .36561 m
.4594 .42782 L
s
P
p
0 .4 1 r
.02 w
.36472 .32062 m
.46096 .36561 L
s
P
p
.2 1 0 r
.02 w
.72519 .81637 m
.8137 .8505 L
s
P
p
0 .4 1 r
.02 w
.36804 .26016 m
.36472 .32062 L
s
P
p
0 .4 1 r
.02 w
.26932 .21261 m
.36804 .26016 L
s
P
p
0 .4 1 r
.02 w
.55353 .60057 m
.64664 .63982 L
s
P
p
.2 1 0 r
.02 w
.53609 .53643 m
.53592 .60274 L
s
P
p
.2 1 0 r
.02 w
.44021 .49471 m
.53609 .53643 L
s
P
p
0 .4 1 r
.02 w
.55337 .53421 m
.45777 .49239 L
s
P
p
0 .4 1 r
.02 w
.55337 .53421 m
.55353 .60057 L
s
P
p
.01 w
.44217 .43017 Mdot
P
p
.2 1 0 r
.02 w
.44217 .43017 m
.44021 .49471 L
s
P
p
.01 w
.4594 .42782 Mdot
P
p
0 .4 1 r
.02 w
.36127 .38339 m
.4594 .42782 L
s
P
p
0 .4 1 r
.02 w
.4594 .42782 m
.45777 .49239 L
s
P
p
0 .4 1 r
.02 w
.36472 .32062 m
.26402 .27354 L
s
P
p
.2 1 0 r
.02 w
.72865 .88883 m
.72519 .81637 L
s
P
p
0 .4 1 r
.02 w
.26402 .27354 m
.26932 .21261 L
s
P
p
.2 1 0 r
.02 w
.63091 .70996 m
.63258 .78065 L
s
P
p
.2 1 0 r
.02 w
.53575 .67163 m
.63091 .70996 L
s
P
p
.2 1 0 r
.02 w
.53592 .60274 m
.43818 .56176 L
s
P
p
0 .4 1 r
.02 w
.45777 .49239 m
.35768 .44861 L
s
P
p
0 .4 1 r
.02 w
.35768 .44861 m
.36127 .38339 L
s
P
p
.2 1 0 r
.02 w
.6343 .85412 m
.72865 .88883 L
s
P
p
0 .4 1 r
.02 w
.25852 .33687 m
.26402 .27354 L
s
P
p
.2 1 0 r
.02 w
.63258 .78065 m
.6343 .85412 L
s
P
p
.2 1 0 r
.02 w
.53558 .74323 m
.53575 .67163 L
s
P
p
.2 1 0 r
.02 w
.43818 .56176 m
.33576 .51882 L
s
P
p
0 .4 1 r
.02 w
.25279 .40273 m
.25852 .33687 L
s
P
p
0 .4 1 r
.02 w
.25852 .33687 m
.15081 .28811 L
s
P
p
.2 1 0 r
.02 w
.43387 .70401 m
.53558 .74323 L
s
P
p
.2 1 0 r
.02 w
.43607 .63147 m
.43387 .70401 L
s
P
p
.2 1 0 r
.02 w
.33152 .58936 m
.43607 .63147 L
s
P
p
.2 1 0 r
.02 w
.33576 .51882 m
.33152 .58936 L
s
P
p
0 .4 1 r
.02 w
.14273 .35459 m
.25279 .40273 L
s
P
p
0 .4 1 r
.02 w
.15081 .28811 m
.14273 .35459 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.292607 0.97619 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.41833 1.9368 0.024872 0.994878 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.89647 .51496 m
.89983 .55496 L
s
P
p
0 .4 1 r
.02 w
.85435 .489 m
.89647 .51496 L
s
P
p
0 .4 1 r
.02 w
.89983 .55496 m
.85734 .52922 L
s
P
p
0 .4 1 r
.02 w
.85734 .52922 m
.85435 .489 L
s
P
p
0 .4 1 r
.02 w
.85734 .52922 m
.81383 .50287 L
s
P
p
0 .4 1 r
.02 w
.81648 .54412 m
.81383 .50287 L
s
P
p
0 .4 1 r
.02 w
.7715 .51736 m
.81648 .54412 L
s
P
p
0 .4 1 r
.02 w
.76928 .47588 m
.7715 .51736 L
s
P
p
0 .4 1 r
.02 w
.72364 .44823 m
.76928 .47588 L
s
P
p
0 .4 1 r
.02 w
.77377 .55968 m
.7715 .51736 L
s
P
p
0 .4 1 r
.02 w
.7715 .51736 m
.72542 .48994 L
s
P
p
0 .4 1 r
.02 w
.72542 .48994 m
.72364 .44823 L
s
P
p
0 .4 1 r
.02 w
.72724 .5325 m
.77377 .55968 L
s
P
p
0 .4 1 r
.02 w
.72542 .48994 m
.67819 .46183 L
s
P
p
0 .4 1 r
.02 w
.7291 .57597 m
.72724 .5325 L
s
P
p
0 .4 1 r
.02 w
.67819 .46183 m
.67953 .50464 L
s
P
p
0 .4 1 r
.02 w
.68091 .54836 m
.7291 .57597 L
s
P
p
0 .4 1 r
.02 w
.67953 .50464 m
.68091 .54836 L
s
P
p
0 .4 1 r
.02 w
.63061 .47607 m
.67953 .50464 L
s
P
p
0 .4 1 r
.02 w
.62976 .43301 m
.63061 .47607 L
s
P
p
0 .4 1 r
.02 w
.58009 .40346 m
.62976 .43301 L
s
P
p
0 .4 1 r
.02 w
.63148 .52004 m
.63061 .47607 L
s
P
p
0 .4 1 r
.02 w
.63061 .47607 m
.58042 .44675 L
s
P
p
0 .4 1 r
.02 w
.58042 .44675 m
.58009 .40346 L
s
P
p
0 .4 1 r
.02 w
.58075 .49098 m
.63148 .52004 L
s
P
p
0 .4 1 r
.02 w
.58042 .44675 m
.52891 .41667 L
s
P
p
0 .4 1 r
.02 w
.58109 .53619 m
.58075 .49098 L
s
P
p
0 .4 1 r
.02 w
.52891 .41667 m
.52868 .46115 L
s
P
p
0 .4 1 r
.02 w
.52844 .50663 m
.58109 .53619 L
s
P
p
0 .4 1 r
.02 w
.52868 .46115 m
.52844 .50663 L
s
P
p
0 .4 1 r
.02 w
.47521 .43052 m
.52868 .46115 L
s
P
p
0 .4 1 r
.02 w
.47603 .38578 m
.47521 .43052 L
s
P
p
0 .4 1 r
.02 w
.42174 .35407 m
.47603 .38578 L
s
P
p
0 .4 1 r
.02 w
.47436 .47627 m
.47521 .43052 L
s
P
p
0 .4 1 r
.02 w
.47521 .43052 m
.42028 .39906 L
s
P
p
0 .4 1 r
.02 w
.42028 .39906 m
.42174 .35407 L
s
P
p
0 .4 1 r
.02 w
.41879 .44508 m
.47436 .47627 L
s
P
p
0 .4 1 r
.02 w
.42028 .39906 m
.36384 .36672 L
s
P
p
.2 1 0 r
.02 w
.46351 .52472 m
.40719 .49386 L
s
P
p
.2 1 0 r
.02 w
.46251 .57259 m
.46351 .52472 L
s
P
p
.2 1 0 r
.02 w
.40883 .44679 m
.35161 .41477 L
s
P
p
.2 1 0 r
.02 w
.40719 .49386 m
.40883 .44679 L
s
P
p
0 .4 1 r
.02 w
.41727 .49217 m
.41879 .44508 L
s
P
p
0 .4 1 r
.02 w
.36384 .36672 m
.36167 .41301 L
s
P
p
.2 1 0 r
.02 w
.40551 .54204 m
.46251 .57259 L
s
P
p
0 .4 1 r
.02 w
.35945 .46039 m
.41727 .49217 L
s
P
p
.2 1 0 r
.02 w
.35161 .41477 m
.34928 .46213 L
s
P
p
0 .4 1 r
.02 w
.36167 .41301 m
.35945 .46039 L
s
P
p
0 .4 1 r
.02 w
.30293 .38004 m
.36167 .41301 L
s
P
p
.2 1 0 r
.02 w
.29578 .33531 m
.23601 .30118 L
s
P
p
.2 1 0 r
.02 w
.29278 .38185 m
.29578 .33531 L
s
P
p
.2 1 0 r
.02 w
.34689 .51062 m
.40551 .54204 L
s
P
p
.2 1 0 r
.02 w
.34928 .46213 m
.28971 .42949 L
s
P
p
.2 1 0 r
.02 w
.28971 .42949 m
.29278 .38185 L
s
P
p
0 .4 1 r
.02 w
.29998 .4277 m
.30293 .38004 L
s
P
p
.2 1 0 r
.02 w
.23601 .30118 m
.23225 .34797 L
s
P
p
.2 1 0 r
.02 w
.4038 .59136 m
.34444 .56028 L
s
P
p
.2 1 0 r
.02 w
.40204 .64187 m
.4038 .59136 L
s
P
p
.2 1 0 r
.02 w
.34444 .56028 m
.34689 .51062 L
s
P
p
0 .4 1 r
.02 w
.23878 .39406 m
.29998 .4277 L
s
P
p
.2 1 0 r
.02 w
.23225 .34797 m
.16996 .31312 L
s
P
p
.2 1 0 r
.02 w
.34193 .61115 m
.40204 .64187 L
s
P
p
.2 1 0 r
.02 w
.2284 .3959 m
.22446 .44501 L
s
P
p
.2 1 0 r
.02 w
.16529 .36132 m
.2284 .3959 L
s
P
p
0 .4 1 r
.02 w
.23496 .44318 m
.23878 .39406 L
s
P
p
.01 w
.16996 .31312 Mdot
P
p
.2 1 0 r
.02 w
.16996 .31312 m
.16529 .36132 L
s
P
p
.01 w
.18032 .3112 Mdot
P
p
0 .4 1 r
.02 w
.18032 .3112 m
.17577 .35942 L
s
P
p
.2 1 0 r
.02 w
.33936 .66327 m
.34193 .61115 L
s
P
p
.2 1 0 r
.02 w
.28334 .52828 m
.28004 .57951 L
s
P
p
.2 1 0 r
.02 w
.22042 .49533 m
.28334 .52828 L
s
P
p
.2 1 0 r
.02 w
.22446 .44501 m
.16051 .41073 L
s
P
p
0 .4 1 r
.02 w
.17111 .40884 m
.23496 .44318 L
s
P
p
0 .4 1 r
.02 w
.17577 .35942 m
.17111 .40884 L
s
P
p
.2 1 0 r
.02 w
.27666 .63202 m
.33936 .66327 L
s
P
p
.2 1 0 r
.02 w
.28004 .57951 m
.27666 .63202 L
s
P
p
.2 1 0 r
.02 w
.21628 .54691 m
.22042 .49533 L
s
P
p
.2 1 0 r
.02 w
.16051 .41073 m
.09462 .37542 L
s
P
p
.2 1 0 r
.02 w
.15057 .51332 m
.21628 .54691 L
s
P
p
.2 1 0 r
.02 w
.1556 .46138 m
.15057 .51332 L
s
P
p
.2 1 0 r
.02 w
.08879 .42639 m
.1556 .46138 L
s
P
p
.2 1 0 r
.02 w
.09462 .37542 m
.08879 .42639 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.430451 0.149123 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.430451 0.286967 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.43789 .35572 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.430451 0.424812 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.308424 1.71627 0.0252773 1.01109 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.91024 .71077 m
.85823 .67661 L
s
P
p
.2 1 0 r
.02 w
.91443 .76965 m
.91024 .71077 L
s
P
p
.2 1 0 r
.02 w
.85467 .61866 m
.80176 .58313 L
s
P
p
.2 1 0 r
.02 w
.85823 .67661 m
.85467 .61866 L
s
P
p
.2 1 0 r
.02 w
.86187 .73592 m
.91443 .76965 L
s
P
p
.2 1 0 r
.02 w
.80176 .58313 m
.80474 .64148 L
s
P
p
.2 1 0 r
.02 w
.74504 .48922 m
.68968 .45125 L
s
P
p
.2 1 0 r
.02 w
.74735 .54659 m
.74504 .48922 L
s
P
p
0 .4 1 r
.02 w
.75577 .48719 m
.70053 .44916 L
s
P
p
0 .4 1 r
.02 w
.75822 .54458 m
.75577 .48719 L
s
P
p
.2 1 0 r
.02 w
.8078 .70123 m
.86187 .73592 L
s
P
p
.2 1 0 r
.02 w
.80474 .64148 m
.74972 .60534 L
s
P
p
.2 1 0 r
.02 w
.74972 .60534 m
.74735 .54659 L
s
P
p
0 .4 1 r
.02 w
.70235 .50693 m
.75822 .54458 L
s
P
p
.2 1 0 r
.02 w
.68968 .45125 m
.69137 .509 L
s
P
p
0 .4 1 r
.02 w
.70053 .44916 m
.70235 .50693 L
s
P
p
.2 1 0 r
.02 w
.86559 .79665 m
.81092 .76242 L
s
P
p
.2 1 0 r
.02 w
.86941 .85885 m
.86559 .79665 L
s
P
p
.2 1 0 r
.02 w
.81092 .76242 m
.8078 .70123 L
s
P
p
.2 1 0 r
.02 w
.69137 .509 m
.63374 .4703 L
s
P
p
0 .4 1 r
.02 w
.70235 .50693 m
.64484 .46817 L
s
P
p
0 .4 1 r
.02 w
.70421 .5661 m
.70235 .50693 L
s
P
p
0 .4 1 r
.02 w
.64369 .41004 m
.58518 .36977 L
s
P
p
0 .4 1 r
.02 w
.64484 .46817 m
.64369 .41004 L
s
P
p
.2 1 0 r
.02 w
.81412 .82511 m
.86941 .85885 L
s
P
p
.2 1 0 r
.02 w
.69309 .56815 m
.69486 .62876 L
s
P
p
.2 1 0 r
.02 w
.63478 .52985 m
.69309 .56815 L
s
P
p
0 .4 1 r
.02 w
.64602 .52775 m
.70421 .5661 L
s
P
p
.01 w
.63374 .4703 Mdot
P
p
.2 1 0 r
.02 w
.63374 .4703 m
.63478 .52985 L
s
P
p
.01 w
.64484 .46817 Mdot
P
p
0 .4 1 r
.02 w
.58562 .42827 m
.64484 .46817 L
s
P
p
0 .4 1 r
.02 w
.64484 .46817 m
.64602 .52775 L
s
P
p
0 .4 1 r
.02 w
.58518 .36977 m
.58562 .42827 L
s
P
p
0 .4 1 r
.02 w
.58518 .36977 m
.52493 .32829 L
s
P
p
.2 1 0 r
.02 w
.8174 .88936 m
.81412 .82511 L
s
P
p
.2 1 0 r
.02 w
.75464 .72718 m
.75719 .79037 L
s
P
p
.2 1 0 r
.02 w
.69667 .69088 m
.75464 .72718 L
s
P
p
.2 1 0 r
.02 w
.69486 .62876 m
.63584 .59089 L
s
P
p
0 .4 1 r
.02 w
.58562 .42827 m
.52462 .38715 L
s
P
p
0 .4 1 r
.02 w
.58607 .48823 m
.58562 .42827 L
s
P
p
.2 1 0 r
.02 w
.7598 .85515 m
.8174 .88936 L
s
P
p
0 .4 1 r
.02 w
.52493 .32829 m
.46285 .28556 L
s
P
p
0 .4 1 r
.02 w
.52462 .38715 m
.52493 .32829 L
s
P
p
.2 1 0 r
.02 w
.75719 .79037 m
.7598 .85515 L
s
P
p
.2 1 0 r
.02 w
.69852 .75457 m
.69667 .69088 L
s
P
p
.2 1 0 r
.02 w
.63584 .59089 m
.57504 .55187 L
s
P
p
0 .4 1 r
.02 w
.5243 .44751 m
.58607 .48823 L
s
P
p
0 .4 1 r
.02 w
.46174 .34478 m
.52462 .38715 L
s
P
p
0 .4 1 r
.02 w
.52462 .38715 m
.5243 .44751 L
s
P
p
0 .4 1 r
.02 w
.46285 .28556 m
.46174 .34478 L
s
P
p
0 .4 1 r
.02 w
.46285 .28556 m
.39887 .24152 L
s
P
p
.2 1 0 r
.02 w
.63805 .71767 m
.69852 .75457 L
s
P
p
.2 1 0 r
.02 w
.63694 .65348 m
.63805 .71767 L
s
P
p
.2 1 0 r
.02 w
.57536 .61492 m
.63694 .65348 L
s
P
p
.2 1 0 r
.02 w
.57504 .55187 m
.57536 .61492 L
s
P
p
0 .4 1 r
.02 w
.46174 .34478 m
.39691 .30109 L
s
P
p
0 .4 1 r
.02 w
.4606 .40553 m
.46174 .34478 L
s
P
p
0 .4 1 r
.02 w
.39887 .24152 m
.33289 .19611 L
s
P
p
0 .4 1 r
.02 w
.39691 .30109 m
.39887 .24152 L
s
P
p
0 .4 1 r
.02 w
.3949 .36222 m
.4606 .40553 L
s
P
p
0 .4 1 r
.02 w
.33003 .25602 m
.39691 .30109 L
s
P
p
0 .4 1 r
.02 w
.39691 .30109 m
.3949 .36222 L
s
P
p
0 .4 1 r
.02 w
.33289 .19611 m
.33003 .25602 L
s
P
p
0 .4 1 r
.02 w
.33289 .19611 m
.26481 .14925 L
s
P
p
0 .4 1 r
.02 w
.33003 .25602 m
.261 .2095 L
s
P
p
0 .4 1 r
.02 w
.3271 .31753 m
.33003 .25602 L
s
P
p
0 .4 1 r
.02 w
.26481 .14925 m
.261 .2095 L
s
P
p
0 .4 1 r
.02 w
.25708 .27138 m
.3271 .31753 L
s
P
p
0 .4 1 r
.02 w
.261 .2095 m
.18972 .16146 L
s
P
p
0 .4 1 r
.02 w
.261 .2095 m
.25708 .27138 L
s
P
p
0 .4 1 r
.02 w
.19455 .10089 m
.12198 .05094 L
s
P
p
0 .4 1 r
.02 w
.18972 .16146 m
.19455 .10089 L
s
P
p
0 .4 1 r
.02 w
.12198 .05094 m
.11607 .11182 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.430451 0.562657 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.430451 0.700501 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.31889 .12085 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.18547 .04771 m
.31889 .12085 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.17486 .13016 m
.18547 .04771 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.16362 .21754 L
s
P
p
0 .4 1 r
.02 w
.16362 .21754 m
.17486 .13016 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.430451 0.838346 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.498191 2.097 0.0245059 0.980236 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87882 .61174 m
.78846 .56381 L
s
P
p
.2 1 0 r
.02 w
.88591 .6918 m
.87882 .61174 L
s
P
p
.2 1 0 r
.02 w
.7834 .48613 m
.69015 .43471 L
s
P
p
.2 1 0 r
.02 w
.78846 .56381 m
.7834 .48613 L
s
P
p
.2 1 0 r
.02 w
.79374 .64494 m
.88591 .6918 L
s
P
p
.2 1 0 r
.02 w
.69015 .43471 m
.69327 .51333 L
s
P
p
.2 1 0 r
.02 w
.59099 .30448 m
.48962 .24655 L
s
P
p
.2 1 0 r
.02 w
.5919 .38054 m
.59099 .30448 L
s
P
p
.2 1 0 r
.02 w
.69652 .59553 m
.79374 .64494 L
s
P
p
.2 1 0 r
.02 w
.69327 .51333 m
.59285 .46007 L
s
P
p
.2 1 0 r
.02 w
.59285 .46007 m
.5919 .38054 L
s
P
p
.2 1 0 r
.02 w
.48962 .24655 m
.48822 .32337 L
s
P
p
.2 1 0 r
.02 w
.79926 .72975 m
.69993 .68156 L
s
P
p
.2 1 0 r
.02 w
.80503 .8185 m
.79926 .72975 L
s
P
p
.2 1 0 r
.02 w
.69993 .68156 m
.69652 .59553 L
s
P
p
.2 1 0 r
.02 w
.48822 .32337 m
.37867 .26297 L
s
P
p
0 .4 1 r
.02 w
.40185 .182 m
.39834 .2596 L
s
P
p
0 .4 1 r
.02 w
.28914 .11718 m
.40185 .182 L
s
P
p
.2 1 0 r
.02 w
.7035 .77169 m
.80503 .8185 L
s
P
p
.2 1 0 r
.02 w
.48676 .40381 m
.48523 .48812 L
s
P
p
.2 1 0 r
.02 w
.37451 .34428 m
.48676 .40381 L
s
P
p
.01 w
.37867 .26297 Mdot
P
p
.2 1 0 r
.02 w
.37867 .26297 m
.37451 .34428 L
s
P
p
.01 w
.39834 .2596 Mdot
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.16981 .04855 m
.28914 .11718 L
s
P
p
.2 1 0 r
.02 w
.70724 .86623 m
.7035 .77169 L
s
P
p
.2 1 0 r
.02 w
.59489 .63059 m
.59598 .72212 L
s
P
p
.2 1 0 r
.02 w
.48363 .5766 m
.59489 .63059 L
s
P
p
.2 1 0 r
.02 w
.48523 .48812 m
.37015 .42962 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.2761 .27766 L
s
P
p
.2 1 0 r
.02 w
.59713 .81827 m
.70724 .86623 L
s
P
p
0 .4 1 r
.02 w
.16026 .12747 m
.16981 .04855 L
s
P
p
.2 1 0 r
.02 w
.59598 .72212 m
.59713 .81827 L
s
P
p
.2 1 0 r
.02 w
.48194 .66955 m
.48363 .5766 L
s
P
p
.2 1 0 r
.02 w
.37015 .42962 m
.24801 .36753 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.15022 .21045 L
s
P
p
0 .4 1 r
.02 w
.15022 .21045 m
.16026 .12747 L
s
P
p
.2 1 0 r
.02 w
.36075 .61368 m
.48194 .66955 L
s
P
p
.2 1 0 r
.02 w
.36557 .51931 m
.36075 .61368 L
s
P
p
.2 1 0 r
.02 w
.24008 .45841 m
.36557 .51931 L
s
P
p
.2 1 0 r
.02 w
.24801 .36753 m
.24008 .45841 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.430451 0.97619 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.16362 .21754 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.568296 0.149123 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.649333 2.38458 0.0238845 0.955379 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.86758 .61144 m
.76162 .56426 L
s
P
p
.2 1 0 r
.02 w
.87476 .6913 m
.86758 .61144 L
s
P
p
.2 1 0 r
.02 w
.75686 .48682 m
.64746 .43609 L
s
P
p
.2 1 0 r
.02 w
.76162 .56426 m
.75686 .48682 L
s
P
p
0 .4 1 r
.02 w
.7779 .48414 m
.78312 .56164 L
s
P
p
0 .4 1 r
.02 w
.6689 .43326 m
.7779 .48414 L
s
P
p
0 .4 1 r
.02 w
.66614 .35823 m
.6689 .43326 L
s
P
p
0 .4 1 r
.02 w
.55365 .30374 m
.66614 .35823 L
s
P
p
0 .4 1 r
.02 w
.55341 .23122 m
.55365 .30374 L
s
P
p
0 .4 1 r
.02 w
.43735 .17304 m
.55341 .23122 L
s
P
p
.2 1 0 r
.02 w
.76658 .64523 m
.87476 .6913 L
s
P
p
0 .4 1 r
.02 w
.78312 .56164 m
.67178 .51172 L
s
P
p
.2 1 0 r
.02 w
.64746 .43609 m
.64984 .5145 L
s
P
p
0 .4 1 r
.02 w
.67178 .51172 m
.6689 .43326 L
s
P
p
.2 1 0 r
.02 w
.53228 .30676 m
.41314 .24942 L
s
P
p
.2 1 0 r
.02 w
.53203 .38257 m
.53228 .30676 L
s
P
p
0 .4 1 r
.02 w
.55365 .30374 m
.43492 .24623 L
s
P
p
0 .4 1 r
.02 w
.43492 .24623 m
.43735 .17304 L
s
P
p
.2 1 0 r
.02 w
.65234 .59657 m
.76658 .64523 L
s
P
p
.2 1 0 r
.02 w
.64984 .5145 m
.53178 .46193 L
s
P
p
0 .4 1 r
.02 w
.67178 .51172 m
.67479 .59386 L
s
P
p
.2 1 0 r
.02 w
.53178 .46193 m
.53203 .38257 L
s
P
p
.2 1 0 r
.02 w
.41314 .24942 m
.41008 .32602 L
s
P
p
0 .4 1 r
.02 w
.30943 .18544 m
.43492 .24623 L
s
P
p
.2 1 0 r
.02 w
.77178 .72996 m
.65496 .68257 L
s
P
p
.2 1 0 r
.02 w
.77723 .81872 m
.77178 .72996 L
s
P
p
.2 1 0 r
.02 w
.65496 .68257 m
.65234 .59657 L
s
P
p
0 .4 1 r
.02 w
.67479 .59386 m
.55442 .54223 L
s
P
p
.2 1 0 r
.02 w
.41008 .32602 m
.28102 .26618 L
s
P
p
0 .4 1 r
.02 w
.30375 .26284 m
.30943 .18544 L
s
P
p
.2 1 0 r
.02 w
.6577 .77278 m
.77723 .81872 L
s
P
p
0 .4 1 r
.02 w
.55442 .54223 m
.5547 .62958 L
s
P
p
0 .4 1 r
.02 w
.42689 .48754 m
.55442 .54223 L
s
P
p
.2 1 0 r
.02 w
.40687 .40632 m
.4035 .49059 L
s
P
p
.2 1 0 r
.02 w
.27451 .34738 m
.40687 .40632 L
s
P
p
.01 w
.28102 .26618 Mdot
P
p
.2 1 0 r
.02 w
.28102 .26618 m
.27451 .34738 L
s
P
p
.01 w
.30375 .26284 Mdot
P
p
0 .4 1 r
.02 w
.2978 .34409 m
.30375 .26284 L
s
P
p
0 .4 1 r
.02 w
.16742 .1992 m
.30375 .26284 L
s
P
p
.2 1 0 r
.02 w
.66058 .86753 m
.6577 .77278 L
s
P
p
.2 1 0 r
.02 w
.53123 .63238 m
.53093 .72406 L
s
P
p
.2 1 0 r
.02 w
.39996 .57913 m
.53123 .63238 L
s
P
p
0 .4 1 r
.02 w
.5547 .62958 m
.42394 .57616 L
s
P
p
.2 1 0 r
.02 w
.4035 .49059 m
.26766 .43273 L
s
P
p
0 .4 1 r
.02 w
.42689 .48754 m
.29153 .42949 L
s
P
p
0 .4 1 r
.02 w
.42394 .57616 m
.42689 .48754 L
s
P
p
0 .4 1 r
.02 w
.29153 .42949 m
.2978 .34409 L
s
P
p
0 .4 1 r
.02 w
.2978 .34409 m
.15777 .28132 L
s
P
p
0 .4 1 r
.02 w
.15777 .28132 m
.16742 .1992 L
s
P
p
.2 1 0 r
.02 w
.53062 .82049 m
.66058 .86753 L
s
P
p
.2 1 0 r
.02 w
.53093 .72406 m
.53062 .82049 L
s
P
p
.2 1 0 r
.02 w
.39624 .67229 m
.39996 .57913 L
s
P
p
.2 1 0 r
.02 w
.26766 .43273 m
.12324 .37122 L
s
P
p
.2 1 0 r
.02 w
.25286 .61718 m
.39624 .67229 L
s
P
p
.2 1 0 r
.02 w
.26046 .52254 m
.25286 .61718 L
s
P
p
.2 1 0 r
.02 w
.1119 .46228 m
.26046 .52254 L
s
P
p
.2 1 0 r
.02 w
.12324 .37122 m
.1119 .46228 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.568296 0.286967 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.31889 .12085 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.31889 .12085 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.568296 0.424812 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.568296 0.562657 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.516688 2.13426 0.0244391 0.977565 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.88829 .68665 m
.81702 .65112 L
s
P
p
.2 1 0 r
.02 w
.89407 .75009 m
.88829 .68665 L
s
P
p
.2 1 0 r
.02 w
.81253 .58914 m
.73944 .55147 L
s
P
p
.2 1 0 r
.02 w
.81702 .65112 m
.81253 .58914 L
s
P
p
0 .4 1 r
.02 w
.59651 .29026 m
.59731 .34778 L
s
P
p
0 .4 1 r
.02 w
.51807 .24592 m
.59651 .29026 L
s
P
p
.2 1 0 r
.02 w
.82167 .71527 m
.89407 .75009 L
s
P
p
.2 1 0 r
.02 w
.73944 .55147 m
.74275 .6141 L
s
P
p
.2 1 0 r
.02 w
.66132 .45114 m
.58324 .40962 L
s
P
p
.2 1 0 r
.02 w
.66327 .51222 m
.66132 .45114 L
s
P
p
0 .4 1 r
.02 w
.59731 .34778 m
.5175 .30387 L
s
P
p
0 .4 1 r
.02 w
.5175 .30387 m
.51807 .24592 L
s
P
p
.2 1 0 r
.02 w
.74617 .67896 m
.82167 .71527 L
s
P
p
.2 1 0 r
.02 w
.74275 .6141 m
.66529 .57549 L
s
P
p
.2 1 0 r
.02 w
.66529 .57549 m
.66327 .51222 L
s
P
p
.2 1 0 r
.02 w
.58324 .40962 m
.58382 .47128 L
s
P
p
0 .4 1 r
.02 w
.5175 .30387 m
.43422 .25806 L
s
P
p
0 .4 1 r
.02 w
.5169 .36392 m
.5175 .30387 L
s
P
p
.2 1 0 r
.02 w
.82648 .78169 m
.74972 .74617 L
s
P
p
.2 1 0 r
.02 w
.83147 .85052 m
.82648 .78169 L
s
P
p
.2 1 0 r
.02 w
.74972 .74617 m
.74617 .67896 L
s
P
p
.2 1 0 r
.02 w
.58382 .47128 m
.50088 .42853 L
s
P
p
0 .4 1 r
.02 w
.51629 .42616 m
.5169 .36392 L
s
P
p
.2 1 0 r
.02 w
.7534 .81586 m
.83147 .85052 L
s
P
p
0 .4 1 r
.02 w
.43422 .25806 m
.34724 .21022 L
s
P
p
.2 1 0 r
.02 w
.58443 .53518 m
.58507 .60147 L
s
P
p
.2 1 0 r
.02 w
.49996 .49307 m
.58443 .53518 L
s
P
p
0 .4 1 r
.02 w
.59988 .53295 m
.60081 .59928 L
s
P
p
0 .4 1 r
.02 w
.51565 .49074 m
.59988 .53295 L
s
P
p
.01 w
.50088 .42853 Mdot
P
p
.2 1 0 r
.02 w
.50088 .42853 m
.49996 .49307 L
s
P
p
.01 w
.51629 .42616 Mdot
P
p
0 .4 1 r
.02 w
.51565 .49074 m
.51629 .42616 L
s
P
p
.2 1 0 r
.02 w
.75722 .88818 m
.7534 .81586 L
s
P
p
0 .4 1 r
.02 w
.34724 .21022 m
.25631 .1602 L
s
P
p
.2 1 0 r
.02 w
.66955 .70906 m
.6718 .77964 L
s
P
p
.2 1 0 r
.02 w
.58572 .67027 m
.66955 .70906 L
s
P
p
0 .4 1 r
.02 w
.26178 .10104 m
.25631 .1602 L
s
P
p
0 .4 1 r
.02 w
.16856 .04835 m
.26178 .10104 L
s
P
p
.2 1 0 r
.02 w
.58507 .60147 m
.49899 .56007 L
s
P
p
0 .4 1 r
.02 w
.60081 .59928 m
.51499 .55778 L
s
P
p
0 .4 1 r
.02 w
.42755 .44659 m
.51565 .49074 L
s
P
p
0 .4 1 r
.02 w
.51499 .55778 m
.51565 .49074 L
s
P
p
.2 1 0 r
.02 w
.67413 .85293 m
.75722 .88818 L
s
P
p
.2 1 0 r
.02 w
.6718 .77964 m
.67413 .85293 L
s
P
p
0 .4 1 r
.02 w
.25631 .1602 m
.25064 .22164 L
s
P
p
0 .4 1 r
.02 w
.25631 .1602 m
.16117 .10786 L
s
P
p
.2 1 0 r
.02 w
.58641 .74173 m
.58572 .67027 L
s
P
p
0 .4 1 r
.02 w
.16117 .10786 m
.16856 .04835 L
s
P
p
.2 1 0 r
.02 w
.49899 .56007 m
.4089 .51674 L
s
P
p
0 .4 1 r
.02 w
.3353 .40036 m
.42755 .44659 L
s
P
p
0 .4 1 r
.02 w
.25064 .22164 m
.24475 .2855 L
s
P
p
.2 1 0 r
.02 w
.49696 .70203 m
.58641 .74173 L
s
P
p
.2 1 0 r
.02 w
.498 .62967 m
.49696 .70203 L
s
P
p
.2 1 0 r
.02 w
.40608 .58714 m
.498 .62967 L
s
P
p
.2 1 0 r
.02 w
.4089 .51674 m
.40608 .58714 L
s
P
p
0 .4 1 r
.02 w
.23862 .35191 m
.3353 .40036 L
s
P
p
0 .4 1 r
.02 w
.24475 .2855 m
.23862 .35191 L
s
P
p
0 .4 1 r
.02 w
.13717 .30107 m
.23862 .35191 L
s
P
p
0 .4 1 r
.02 w
.23862 .35191 m
.23224 .42105 L
s
P
p
0 .4 1 r
.02 w
.23224 .42105 m
.1285 .37088 L
s
P
p
0 .4 1 r
.02 w
.1285 .37088 m
.13717 .30107 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.568296 0.700501 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.568296 0.838346 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-2.5642 6.14465 -0.0369819 1.01169 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.76902 .19715 m
.69346 .18185 L
s
P
p
.2 1 0 r
.02 w
.7702 .21737 m
.76902 .19715 L
s
P
p
.2 1 0 r
.02 w
.69263 .16177 m
.61658 .14627 L
s
P
p
.2 1 0 r
.02 w
.69346 .18185 m
.69263 .16177 L
s
P
p
.2 1 0 r
.02 w
.69429 .20212 m
.7702 .21737 L
s
P
p
.2 1 0 r
.02 w
.61658 .14627 m
.61707 .16639 L
s
P
p
.2 1 0 r
.02 w
.53956 .11062 m
.4622 .09475 L
s
P
p
.2 1 0 r
.02 w
.53971 .1306 m
.53956 .11062 L
s
P
p
.2 1 0 r
.02 w
.61756 .1867 m
.69429 .20212 L
s
P
p
.2 1 0 r
.02 w
.61707 .16639 m
.53985 .15076 L
s
P
p
.2 1 0 r
.02 w
.53985 .15076 m
.53971 .1306 L
s
P
p
.2 1 0 r
.02 w
.4622 .09475 m
.46199 .11476 L
s
P
p
.2 1 0 r
.02 w
.69514 .22257 m
.61806 .20719 L
s
P
p
.2 1 0 r
.02 w
.69599 .2432 m
.69514 .22257 L
s
P
p
.2 1 0 r
.02 w
.61806 .20719 m
.61756 .1867 L
s
P
p
.2 1 0 r
.02 w
.46199 .11476 m
.38343 .09875 L
s
P
p
.2 1 0 r
.02 w
.61857 .22786 m
.69599 .2432 L
s
P
p
.2 1 0 r
.02 w
.46178 .13496 m
.46157 .15535 L
s
P
p
.2 1 0 r
.02 w
.38286 .11899 m
.46178 .13496 L
s
P
p
.01 w
.38343 .09875 Mdot
P
p
.2 1 0 r
.02 w
.38343 .09875 m
.38286 .11899 L
s
P
p
.01 w
.39785 .09788 Mdot
P
p
0 .4 1 r
.02 w
.39785 .09788 m
.39735 .11812 L
s
P
p
.2 1 0 r
.02 w
.61908 .24873 m
.61857 .22786 L
s
P
p
.2 1 0 r
.02 w
.54014 .19164 m
.54029 .21236 L
s
P
p
.2 1 0 r
.02 w
.46136 .17592 m
.54014 .19164 L
s
P
p
.2 1 0 r
.02 w
.46157 .15535 m
.38228 .13941 L
s
P
p
0 .4 1 r
.02 w
.39735 .11812 m
.3176 .10195 L
s
P
p
.2 1 0 r
.02 w
.54044 .23327 m
.61908 .24873 L
s
P
p
.2 1 0 r
.02 w
.54029 .21236 m
.54044 .23327 L
s
P
p
.2 1 0 r
.02 w
.46114 .19668 m
.46136 .17592 L
s
P
p
.2 1 0 r
.02 w
.38228 .13941 m
.3021 .1233 L
s
P
p
0 .4 1 r
.02 w
.39683 .13854 m
.39632 .15916 L
s
P
p
0 .4 1 r
.02 w
.31672 .12242 m
.39683 .13854 L
s
P
p
0 .4 1 r
.02 w
.3176 .10195 m
.31672 .12242 L
s
P
p
.2 1 0 r
.02 w
.3811 .18083 m
.46114 .19668 L
s
P
p
.2 1 0 r
.02 w
.38169 .16002 m
.3811 .18083 L
s
P
p
.2 1 0 r
.02 w
.30114 .14395 m
.38169 .16002 L
s
P
p
0 .4 1 r
.02 w
.39632 .15916 m
.31582 .14307 L
s
P
p
.2 1 0 r
.02 w
.3021 .1233 m
.30114 .14395 L
s
P
p
0 .4 1 r
.02 w
.31582 .14307 m
.31492 .16392 L
s
P
p
0 .4 1 r
.02 w
.31492 .16392 m
.23313 .1477 L
s
P
p
0 .4 1 r
.02 w
.23313 .1477 m
.23183 .16879 L
s
P
p
0 .4 1 r
.02 w
.47516 .28085 m
.47501 .30261 L
s
P
p
0 .4 1 r
.02 w
.23183 .16879 m
.23051 .19008 L
s
P
p
0 .4 1 r
.02 w
.47501 .30261 m
.39312 .28698 L
s
P
p
0 .4 1 r
.02 w
.39366 .26517 m
.39312 .28698 L
s
P
p
0 .4 1 r
.02 w
.31123 .24931 m
.39366 .26517 L
s
P
p
0 .4 1 r
.02 w
.31217 .22766 m
.31123 .24931 L
s
P
p
0 .4 1 r
.02 w
.22918 .21157 m
.31217 .22766 L
s
P
p
0 .4 1 r
.02 w
.23051 .19008 m
.22918 .21157 L
s
P
p
0 .4 1 r
.02 w
.47485 .32457 m
.47469 .34675 L
s
P
p
0 .4 1 r
.02 w
.39257 .309 m
.47485 .32457 L
s
P
p
0 .4 1 r
.02 w
.39312 .28698 m
.39257 .309 L
s
P
p
0 .4 1 r
.02 w
.47469 .34675 m
.39201 .33123 L
s
P
p
0 .4 1 r
.02 w
.39201 .33123 m
.39145 .35367 L
s
P
p
0 .4 1 r
.02 w
.39145 .35367 m
.30739 .33802 L
s
P
p
0 .4 1 r
.02 w
.30739 .33802 m
.30641 .36074 L
s
P
p
0 .4 1 r
.02 w
.5576 .47596 m
.55785 .4994 L
s
P
p
0 .4 1 r
.02 w
.30641 .36074 m
.30542 .38369 L
s
P
p
0 .4 1 r
.02 w
.55785 .4994 m
.4737 .48441 L
s
P
p
0 .4 1 r
.02 w
.47387 .46091 m
.4737 .48441 L
s
P
p
0 .4 1 r
.02 w
.38914 .44567 m
.47387 .46091 L
s
P
p
0 .4 1 r
.02 w
.38973 .42233 m
.38914 .44567 L
s
P
p
0 .4 1 r
.02 w
.30442 .40686 m
.38973 .42233 L
s
P
p
0 .4 1 r
.02 w
.30542 .38369 m
.30442 .40686 L
s
P
p
0 .4 1 r
.02 w
.55809 .52307 m
.55834 .54698 L
s
P
p
0 .4 1 r
.02 w
.47353 .50815 m
.55809 .52307 L
s
P
p
0 .4 1 r
.02 w
.4737 .48441 m
.47353 .50815 L
s
P
p
0 .4 1 r
.02 w
.55834 .54698 m
.47336 .53213 L
s
P
p
0 .4 1 r
.02 w
.47336 .53213 m
.47318 .55634 L
s
P
p
0 .4 1 r
.02 w
.47318 .55634 m
.38675 .54138 L
s
P
p
0 .4 1 r
.02 w
.38675 .54138 m
.38613 .56591 L
s
P
p
0 .4 1 r
.02 w
.6457 .68446 m
.6464 .70977 L
s
P
p
0 .4 1 r
.02 w
.38613 .56591 m
.38551 .5907 L
s
P
p
0 .4 1 r
.02 w
.6464 .70977 m
.55988 .69555 L
s
P
p
0 .4 1 r
.02 w
.55961 .67016 m
.55988 .69555 L
s
P
p
0 .4 1 r
.02 w
.47247 .65568 m
.55961 .67016 L
s
P
p
0 .4 1 r
.02 w
.47265 .63047 m
.47247 .65568 L
s
P
p
0 .4 1 r
.02 w
.38488 .61573 m
.47265 .63047 L
s
P
p
0 .4 1 r
.02 w
.38551 .5907 m
.38488 .61573 L
s
P
p
0 .4 1 r
.02 w
.6471 .73534 m
.64782 .76117 L
s
P
p
0 .4 1 r
.02 w
.56014 .7212 m
.6471 .73534 L
s
P
p
0 .4 1 r
.02 w
.55988 .69555 m
.56014 .7212 L
s
P
p
0 .4 1 r
.02 w
.64782 .76117 m
.56041 .74712 L
s
P
p
0 .4 1 r
.02 w
.56041 .74712 m
.56068 .7733 L
s
P
p
0 .4 1 r
.02 w
.56068 .7733 m
.47173 .75916 L
s
P
p
0 .4 1 r
.02 w
.47173 .75916 m
.47153 .78571 L
s
P
p
0 .4 1 r
.02 w
.74128 .93517 m
.74006 .90779 L
s
P
p
0 .4 1 r
.02 w
.47153 .78571 m
.47134 .81254 L
s
P
p
0 .4 1 r
.02 w
.65225 .92187 m
.74128 .93517 L
s
P
p
0 .4 1 r
.02 w
.65149 .89438 m
.65225 .92187 L
s
P
p
0 .4 1 r
.02 w
.56179 .88081 m
.65149 .89438 L
s
P
p
0 .4 1 r
.02 w
.56151 .8535 m
.56179 .88081 L
s
P
p
0 .4 1 r
.02 w
.47115 .83965 m
.56151 .8535 L
s
P
p
0 .4 1 r
.02 w
.47134 .81254 m
.47115 .83965 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.568296 0.97619 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
P
MathSubEnd
P
% End of sub-graphic
p
/Times-Italic findfont 18 scalefont setfont
[(Fractals)] .02381 .57389 -1 0 Mshowa
P
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{468, 290},
  ImageMargins->{{33, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007D00018PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0e@00003obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;003D
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000ok_D^`400000ol^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`00e<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@000?nke;/100000?o;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00=C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40003o^mBk0@00003obk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;003Dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000ok_D^`400000ol^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`00e<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@000?nke;/10000
0?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/00=C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40003o^mBk
0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;003Dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000
ok_D^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00e<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
0@000:Rk0/JC^`;6U;/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_6^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0043;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0/H0T[_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;0@000:Nk00C6^k^k0/Hc^`;6Fk/01LJk^k_6096k0@00003Rbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^l_6bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^`;605W;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`02aP2D^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40002W^`03a[^k00Bk00?6^k/0
;k/01LJk^k_605Zk0/H00k_6^`0d^`03ok^k00:EE[/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l^kbk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/004;;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/2aP0`^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0/H02;_;
ULJEbiG;0YD0E;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40001=^`03ok^k00:k0YDZ^`03ok^k00:k
0YDR^`03a[^k00Bk0/HZ^`;61;/00lJk^`02^`03a[^k05Zk0/H_^`03a[_600?600>kUID00k/00iFk
^`1A^`400000E<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^Ea/^kbk^E^`:E02o;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^Ea[_;^l^Eb`02U@1E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l_6bk_;^l^kbk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^`04aP0g
bk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02aP0[
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^`03aP0/^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD2aP1N^l^EaYG;^l^kbiG;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`40001<^`04ULJEU@:k00FE^k^kU@0V^`04ULJEU@:k00FE^k^kU@0O^`03a[^k00Nk
00?6^k/09[/00lJk^`02^`03a[^k00:k0/Ha^`04a[_6aRNk00?6^k/00[/00lJk^`0T^`C600>EaYD0
1<H00k^EU@02aP03^iFk05:k0@00001@bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk/3U@0^^l^kbiG;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkb`>E05K;^l^kUK_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kblK;^l^kbk_;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`;600[;^l^kbk_;^l^k0lH08K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02aP0f
bk_;^l^kbk_;^l_6bk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0/H0;/^k
blK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk/3aP03^l^E00?600>Ea[/0
0/H01<^kbk/2U@1=bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@0004^k00>Ea[/01;/00iFk^`02^`03UK^k02>k
00>Ea[/00k/00iFk^`02^`03UK^k01bk0/H8^`03a[^k02Rk0lH:^`03a[^k01jk00C6^lK62K/01LJk
^k_602Rk0/H00k_6^`0U^`C600>kaYD01<H01;^Ea/H2^`08ULJEUK^E^iE<^`400000O/^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbiG6^l^kbk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;U@;6
02k;^l^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6blK;^l^k0/H0=<_6bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kbk/2aP0Xbk_;a/^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^`;603_;^l^kbk_;a/^kblK;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6ol^kb`02U@0U^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^`03aP03^l^E00?600Rka[_;^lJkb`:E04jkbiG;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000
AK/2U@Fk00?6UID02;/00iFk^`0L^`:E1[/01<JEa/H6^`03UK^k01^k00C6^k^k0/H2^`04a[_6aPFk
0/HV^`03a[^k00:k00?6^lH00lHO^`;61K/2aPFk00G6^k^EaP02^`:E9[/00iG6aP02^`03UK^E00:E
8k/01/Jka/JEaP:k0lH2^`03a[^k00Bk00>E^k/0BK/1000004O;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Eb`02U@06^l^ka[_;
0YD09k_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^`02U@08bk_;^lJkbiD2aP0R
bk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;600C;^l^k0lH0G;_;a/^kbk_;a/_6bk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l^kok_;^iG6bk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;0/H02[_;^l^ka[_;^l/2aP03^iG600>E02ZkUK_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^EaYD3aP0Wbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;00;600>kblH00lH00iG6U@03aP03^l^k00:E00?;^iD00YD0B;_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40
0015^`04UK^k^`:E00>ka[/00k/00iFk^`03^`03UK^k01bk00BE^k^k0YD00k_6^`04^`03ULJk00:k
00>E^k/06k/01<Jka/H4^`;61k/2aP03^lJk02>k00K6^k^kULH3^`03UK^E00:E8;/00lJk^`03^`;6
0[/00lJkaP02aP:k00BE^k^E9;/00iG6^`02^`03ULJk00:k00>E^k/06k/2aP>k00?6^lH00/H2^`07
ULK6a[^EaP03^`04UK^EU@>k00>E^k/0AK/1000005c;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^Ea[_;^l^Ebk_;^l^E
bk_;^`:E01o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk^E00;600jkbk_;ULJkbk^E^l^kb`:E
02Fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_6^l^ka[_6^l^k00;600?;^l/00/H09;_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;600BkbiG619D09K_;^l^Ebk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/00/H01L^kblK;00?602o;^iG6bk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kU@02aP0W^l^ka[_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^lJk00C600?;^l/01<H00k_6^`02aP04bk_;^`:E00?;^iD00iD0Al^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00400014^`:E
1[/00lJEU@02^`03UK^k00>k00>E^k/00[/019FkUIDE^`:E1k/01iG6a/JkULH00k/00iFk^`02^`04
UK^EUAVk00C6^k_60k/2aP04^lJkaP>k00?6^k/09;/4aP>k00>E^k/00[/00iFk^`0P^`C60[/00iG6
^`02^`03aYFE00>k00>E^k/07;/2U@Jk00>Ea/H00/H3^`03UK^k01Zk0/H4^`?600>ka[/00[/2aP>k
00?6^k/00k/2U@>k0YE6^`400000A/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3U@06^l^ka[_;0iD01L^kbk_;00:E01jkbk^E
^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l/3U@06bk_;^l^k0YD3aP03^l^k00:E023;^l^Ebk_;UL^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;600O;a/K6blK;00;600ZkblK;^lJkboo;0YD0D[_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ea[_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l/2aP03^iFk00:E02S;a/^kUK_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iFk0YD0:l^kbk_;^iFka[_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00lH01<_6
bk/3aP0;^l^ka[_;^lJkbk/00YD0CL^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00400019^`:E00>ka[/00k/00iFk
^`05^`BE1;/00iFk^`0F^`:E1[/019Fka/H4^`BE1;/00iFk^`0E^`03a[_600>k0/H2^`C60[/2aP06
ULJEUK^E7;/2U@Fk0iD5^`03UK^k02Fk0/H3^`05ULK6^iD00k/00iFk^`02UAVk00BE^k^k0YD5^`03
UK^k00:k00>E^k/07k/4aP03^lJk00C60k/01/JEUK^E^`>EB[/1000008K;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E
a[_;^l^kbk_;^l^kbk_;^iFkbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^`?6
02jkbk_;UL^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l_6bk_;^l^kbk_;0/H00k_;^`02aP0R
biG;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^`>E03Zkbk_;^iFkbk_;UL^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^Ea/^kbk^E0/H00k_;^`02U@0RbiG;UL^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^iFkbk_;^`:E00c;^l^Ebk_;^iFkbk/2U@0Pbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^lJkbk/3aP03^l^k00?600Bka[_;0YD0C[_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40001;^`03
ULJk01>k00>E^k/06;/00iFk^`0:^`03a[^k00Jk00>E^k/05;/2aP:k00?6^k/01;/2aP04^lJkaP>k
00?6^k/00[/00iFk^`0I^`03UK^k00:k0YD3^`03UK^k00:k00BE^k^k0YDT^`03aYFE00Bk00>Ea/H0
0k/2U@:k00>E^k/05K/2U@Jk19D4^`:E0[/019FkUIDJ^`;60k/00lJkaP03aP:k0/IB^`400000Zl^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbiG6^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk^E^l^kbk_;^l^kbk_;a/^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03aP08bk_;^l^k
a[/2aP0]bk_6a/_6UK_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_;00BE00Bkbk_;
0YD01;_;UL/2U@0V^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^iD2aP0U^l_6blK;
^l^Ebk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02U@0>bk_;^l^kbiG;^l^kbk/3U@0H^l^kUK_;
^l^kbk_;^l^kbk_;^l^kbk_;0/H01K_;^lJk00C600C;^l^k0lH0E;_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kb`40001:^`03ULJk00Bk0YD>^`:E6K/00iFk^`03^`:E1K/00lJk^`06^`:E6K/00lJk^`04^`04
a[^kaP:k00JE^lK6^iD2^`04UK^EUANk0iD8^`03UK^k00Bk0iD3^`03UK^k01nk00K6^k^Ea[/3aP:k
0/H4^`03UK^k01Vk0YD>^`05UK^k^iD05;/00lJkaP03aPBk1<H01;_6^k/2aU:k0@00001Cbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk^Ea/^kbk_;UL/00YD01k_;^l^kbk/00YD01L^kbk_;00>E01k;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kUK_;^l^kUK/2U@08bk_;a/^kbk/2U@04bk_;^`>E02Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^lJkbk_;^iFkblH00YD00l^kU@02U@0K^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00>E
03Bkbk_;^l^kbk_;^l^kbiG;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0/H01[^E
a/^kU@;600>kbk/00/H0Al^kUIG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^k
bk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;00;600>kbk/01<H01L_6bk_;00;605Jkbk_6^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kb`40001:^`03ULJk00Bk00BE^k^k0YD5^`03UK^E00:E1K/00iFk^`0C^`:E
1;/019Fk^k/2U@03^lJk00>k00>E^iD00YD4^`03UK^k01Zk00?6^k/00k/3U@03a[^E00Bk0YD00k^E
^`0J^`03UK^k012k00>E^k/07[/00lJkaP02aP:k00BE^iG60k/00iG6^`02^`03UK^k01Vk00>E^k/0
3k/2UAFk1<H3^`G600>ka[/00[/00lJk^`1@^`400000C<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3U@0B^l^Ebk_;
^l^Ebk_;^iFkbk_;0YD06k_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02U@09bk^E^l^kbk^E00?6
00O;^iFkbk_;00:E066kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^l^kbk_;a/^kbk_;
^l^EbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^k00:E02[;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kULK;^iFkbk/2aP0WbiG6UL^kbiG;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;UL^kbk_;00:E00Nkbk_;^l^k00:E00C;^l^k0YD05/^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/4aP05blK;^l/00lH0EL^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@0004nk0iD5^`03
UK^k00:k00>E^k/01;/2U@03^iFk01Rk0iD5^`04UK^k^`?61[/00iFkU@0L^`?61[/00lJk^`07^`:E
6[/00iFk^`02^`:E1k/2U@Fk0YDM^`05a[^k^lH00iD3^`03UK_600;600FkUIFkU@0I^`:E1;/00iFk
U@02U@Bk00BE^iFE1;/00iFk^`0C^`04a[^k^`?60k/00lJkaP02aU:k0@00001Lbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;UL^kbk_;UL^kbk/2U@07bk_;^l^kb`02U@0X^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kUK_;^l^kUK_;^l^kU@;600Fkbk_;^`02U@0Wbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
blK;^l^kblK;00>E02S;^l^Ebk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^iFk0iD01[_;
^l^Eb`>E03C;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;a/^kUK_;^iFkbiG6^l^k
0iD06[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0YD03k_;UL^kbk^E^l^kUK_;^`02U@0Hbk^E^l^k
bk_;^l^kbk_;^l^kbk_;^l^k0/H01L^kblK;00C605Jkbk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40
001G^`03UK^k00Bk0YD6^`03UK^k01nk00>E^k/01;/00lJEaP02aP>k00>E^k/07K/00lJk^`03^`03
aYFE00:k00>E^k/00YD3^`03UK^k01Jk0YD3^`03UK^k00:k00FE^k^kU@04^`:E0[/00iFk^`0J^`05
a[^k^lH01[/00iFk^`02^`:E0k/00iFk^`0J^`>E1;/01IFk^k^E00Fk19DD^`03a[_600?61;/4aU>k
0@00001Pbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^k0YD0IL^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kblK;^iFka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l_6bk_;^l_6bk^E^iFkbiG;00BE01Zkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`BE
00nkbk_;UL^kbk^E^l^kbk/00iD0FK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;a/^kbk_;
^iFkbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk^E^l^k00:E01K;^l^k
bk_;UL^kbk_;^l^kbk_;^l^k1<H01l^ka[_;^l/01<H01K_6^l^k00;6057;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00@0005Nk00>E^k/02;/00iFk^`0S^`03UK^k00Bk00K6^k^kULHR^`;61;/00lJk^`02^`03
UK^k00:E0k/00iFk^`0K^`03UK^k00:k00>E^k/00[/2U@Jk00>E^k/06K/2aP>k00?6^k/01;/00iFk
^`02U@:k00>E^k/09;/00iFk^`03^`>E4k/01<Jk^k/6aP03^lJk00:k0/H4^`03a[^k04nk0@00002?
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^iFkbk_;^l/00/H0Hk_;ULJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l_6bk_;a/^kbk^E^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
UL^kbk_;^`02U@0Rbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`C600_;^l^kbk^E^l^E
b`03U@12bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^Ebk_;^l^k
bk_;^l^kbk_;^l^k0lH01k_;^lJkbk/00lH0F[_;^lJkbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40
001G^`03UK^k00>k0YD3^`03UK^k02>k00>E^k/00k/2U@05^lK6ULH09K/4aPBk00>E^k/00iDU^`03
UK^k00Jk00>E^k/08[/00lJk^`04^`:E00>kUK/00[/00iFk^`0T^`03UK^k00Jk00>E^k/04k/4aPBk
00?6^lH00lH4^`03a[^k04nk0@00001Obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;UL/0
19D0;K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk^E^`03U@;603:kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kbk^E^l^Eb`:E02Vkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^`02U@0`bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0iD0;[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kUK_;^l/2U@0K^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00C600K;a/^kbk/4aP1C
blK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@0005Nk0iD3^`03UK^k00:k00>E^k/08k/3U@>k00>E^k/0
0[/00iG6^`0/^`BE0[/00iFk^`0R^`03UK^k00:k00>E^iD00YD_^`03UK^k02Nk00>E^k/00[/00iFk
U@02UAbk1LH00k_6^`02^`;6DK/1000005[;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/4U@0]
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00BE05jkbk_;^lJkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0YD0HK_;^iFkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00YD0:L^kbiG;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;605Jkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40001M^`03UK^k02jk00>E^k/00k/00lJk^`1H^`BEGk/4UGfk
0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk^E^l^kbk_;^l^kbk_;003Dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000
U;/00lJk^`3o^cfk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;003Dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/10000ok_D^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00e<^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0@000?nke;/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00=C;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`40003o^mBk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;003Dbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/10000ok_D^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00e<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@000?nke;/1000004O;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02aP3o^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^k002;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000Ak/01<Jka/Ko^hVk0@00001;bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l_6bk_;00;60?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/008Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004Nk00?6^k/0
0k/3a_nkQ;/100000:W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l^kbk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00;60?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/002Vkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^`010000A[/00lJk^`07^`03a[^k05Jk00C6^lK6=K/2aUnk0/J>^`400000E<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_6^l^kbk_;^l_6bk_;^`;605O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l/00/H0S[_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJka[_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l/3aP05bk_;a//00lH0Rl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@0004Jk00?6^k/0
1[/2aP>k00C6^lK6DK/2aPBk0lH8^`;68;/00lJk^`02^`04a[^kaRJk0/H`^`03a[^k00C61;/2aP>k
0/J4^`400000A/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/2aP09bk_;^l^kbk_;00C600>kbk/00/H0DL^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`02aP05^l^kbk/00/H0:<^kbk_;^lJka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/2aP0_bk_;a/^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00/H0>k_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^l_6bk_;^l^k00;6
00?;a//00lH0PL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`010000B;/3aPVk00?6^k/00k/00lJk^`1@^`;61K/2aPBk00C6^k_6
7K/2aP04^lJk^`C6:[/00lJk^`03^`;o0k/2UB6k0/H=^`;61;/00lJk^`1n^`400000Bl^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`02aP0>^l_6a[_;^lJkbk_;^l/2aP1B^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?600C;^l^k
0/H09L^ka[_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a//00/H01K_;a/^k00G602Nkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00/H0;L^kbiG6^l^kUK^E^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03aP2Abk_;^l^kbk_;^l_6bk_;^lJkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000
A[/2aP>k00?6^lH00/H00k_6aP02aPRk0/IC^`03a[^k00>k0lH2^`03a[^k01^k0/H00k_6aP02aP:k
00G6^k_6^`02aRFk00O6^lK6^iG600BE0[/00iFk^`0R^`03a[^k00fk00?6^k/0O[/1000004S;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^ka[/3aP04^l^kb`;600>kbk/00/H0P/^kbk_;^l^kblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
a[_;^l^kbk_6^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2aP03bk_;00;600FkblK;^`02aP0^
bk_6a/_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^`;603c;^l^kUK_;^iFk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;^l^kbk_;^l^kbk/2aP1obk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`010000AK/00lJk^`02^`03a[^k00:k00O6^lK6^lJk00;61k/00lJk^`1?^`03a[^k00Vk00?6^k/0
6;/00lJkaP03^`04a[^kaPBk0/H01;_6a/HT^`03a[^k00:k00?6UK/01[/00iFk^`0Q^`03a[^k00:k
0YD;^`?6O;/1000005?;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^l^kbk_;a/^kb`02aP23^l^ka[_;^l^kblK;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l_6bk_;^l^kbk_;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00/H00l_6
aP02aP09^l_6bk_;^l^k00;602K;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;U@;6
00G;^l_6b`02U@0`^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6ol^kbiG;
0iD0Ql^kbk_;^l^kbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`010000AK/00lJk^`07^`;60[/00lJkaP03aP:k0/H2^`03a[^k04nk
00?6^k/02[/00lJk^`0I^`04a[^k^`;600>ka[/01[/2aRBk00>EaYD00/H00k_6^`02^`03UK^k00:k
00>E^k/08;/00iG6^`04U@Bk00>E^k/02;/00lJk^`1i^`400000DL^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l^kbk_;^l^k
b`03aP04bk_;U@;600?;a//00lH0Nl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l_6UK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l^kbk_;^l^kbk_6^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04aP0<^lK6bk_;^l^kbk_;0lH09/^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^E0/H0E<^kbk^E^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^Ea[_;^l^Ebk_;^iFkbk_;^l^kbk_;a/^kbk_;^l^kbk_;^l^kbk_;^`;606O;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00400015^`;63;/01lKo^k^EaYD0
0lH2^`03a[^k02Vk0lH2^`;60YDM^`03a[^k00:k0/H6^`03a[^k01fk0/H00k_6^`0;^`03a[^k01jk
00>Ea[/00[/00iG6aP03^`05UK^k^iD01;/2UAbk00BEa/K61k/00iFk^`08^`03a[^k012k0/H8^`03
a[^k05bk0@000017bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00lH02l^kbk_;^l^kblK;00C600>kbiD00/H0;<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l^k0/H00l^kaP02aP0W^iFkUK_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^lJk00;600C;^l^k0/H0:l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^ka[_;^l^kbk_;^l/01LH09l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E
a[_;^l^kU@02aP05^iFkbk/00YD06l^kbiG;UL^kbk_;^l^kbk_;^l^kbk_;^l^kb`02U@06^l^kbk_;
0YD3aP0Tbk_;^iFkbk_;^l^kbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^k0/H01L_6bk_;00?605g;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@0004Zk0/H7^`06a[^k^iG60[/019Fk^lHV^`?6
0[/2aP>k00FEaYFE^`03UAZk00C6^k^k0_l2^`04ULK6aP>k00?6^k/07[/3aPNk00G6^k_6^`02aQnk
0YD5^`03ULJE00Fk0YD01K^E^k^E01Bk00BE^iFE1[/2U@03^lJk00:k00>E^k/02;/2aQBk1<H2^`C6
1[/2aUBk0@00001<bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?600Bkbk_;0/H0:;_;^l^kbiG;^l_6bk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l/2aP04^l^kb`?600?;^lH00/H02[_;^l^kbiG;^l/2U@0O^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;aP02U@05biG;^iD00lH09<_6a/K;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`;600S;^l^kblK;^`;603;;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbiG;^l^kbk_6^l^kbk_;^`:E01_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbiG;^l/00YD04K_;
^l^kbiG6^l^kUK_;^l^k00:E00G;^l^kb`03aP0Dbk_;^l^kbk_;^l^kbk_;^l^ka[/2aP07blK6a/_6
b`02aP0:^l_6a[_;^l^kb`;604bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0@0004jk00>Ea/H00[/00lJkaP02aP>k
00FE^k^kaP0M^`04a[_6aP:k00?6^lH01;/00lJk^`04^`RE6;/3aP04^lJk^`:E0k/00iFk^`02aP:k
0/HK^`;600>ka[/00/H3^`05a[^ka[/00lHQ^`03UK^k00bk00FE^k^kU@0B^`03UK^k00Bk0iD3^`03
ULJk00:k00BEa/K60[/00iFkU@02U@Fk00?6^k/04;/6aP>k0lH00k_6aP05aP:k0/I<^`400000DL^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^iFkU@03aP0Pbk_;ULJkbiG;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk/2aP05
bk_;^l/00lH00l^kb`03aP0@bk_;^l^kbk_;^l^kbk^E^`FE01^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00/H039Fkbk_;^l^Ebk_;^`C601g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6b`02aP06
^l^ka[_;1LH0B/^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;^l^k
bk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^k0iD01k_;^l^kbk/019D02<Jkbk^EaYFk0lH01K_;^l^E00;6
01K;^lJkbk_;^l^kbk_;^l^kbk_;^l^k0/H01l_6bk_;^l/01/H00k_;aP06aP1;blK;^lJEbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;0040001>^`06UK^k^iG60k/01IG6^k^E00>k00?6UID04[/00lJkaP02aP:k00?6^lH01K/00lJk
^`0>^`BE6;/2U@Fk0YD4^`03UK^k00Fk00?6^k/06;/4aP03^lJk00:k00?6^lH00[/00lJkaP0S^`03
UK^k012k0YDD^`>E1k/00iG6aP03^`03a[^E00>E0/H2^`03ULJk00?64k/2aPRk00C6^k_60k/6aP03
^lK600C600>E^k/0@[/1000004k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2U@04bk_;^`BE00?6^l/00iD06l_6
bk^E^l^kbk_;^l^kbk_;^l^kbk_6^l^kb`03aP0Hbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0YD07<^E
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK/3U@0<^l^kbiG;^l^Ebk_;0YD08;_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;0/H00k_6aP02aP04blK;^`;60_l2U@0Ubk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk^E^l^kb`02U@0>^l^kbk_;^l^kbk_;^l/2U@0E^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00:E00S;^l^kbk_;^`C600O;^l^kUK_;00C602Vkbk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_6^l^kbk_;^`02aP04blK;^`G60iD0@l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@00052k0YD5^`03ULK600Bk0YD00lJk
U@0H^`03a[^k01Nk00>E^k/06;/00iFk^`02^`:E0[/019Fk^k/2U@:k00BE^iFE8;/2aP:k0lH2^`03
a[_600:E00>kUK/07[/2U@>k00>E^iD00YD5^`:E1[/00iFk^`0C^`03UK^k00Vk00?6^k/01k/00iG6
^`0X^`;61[/00lJkaP03UD>k0@00001Jbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^k0/H0E<^k
bk_6^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`:E00G;^l^kb`03U@05bk_;^l/00iD0;L^kbiG;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkblK;a/^kb`02aP0U^iFkUK_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^`02U@0=biG;^l^kUK_;^l^Eb`02U@0P^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;
^l^Ebk_;^l/2U@0@^l^kbk_;^l^kbk_;^l^kb`>E037;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^ka[_;00:E04Bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40001B^`03UK^k00Nk0lH01;_6^k/2UDfk
0YD5^`03UK^k00Fk00FE^k^kU@0S^`03a[_600Bk00G6UK^kU@0S^`:E1;/00iFk^`02^`04UK^k^`:E
0[/00iFk^`0B^`03UK^k00Bk00>E^iD00YD6^`:E2;/00iFk^`1d^`400000El^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk^E^l^kb`02U@06^l^kbk_;0/H0I;_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;
^l^kbk_;^l/2U@0V^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;a//3U@07bk^E^iFk
b`02U@0Z^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^iFkbk_;0YD01;_;^l/3U@0D
bk_;^l^kbk_;^l^kbk_;^l^kbk/3U@0A^l^kbiG;^l^kUK_;^l^kUK/00iD0O;_;^l^kUK_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000D[/2U@>k
00BE^iFE1;/019FkUID3^`03UK^k04^k00>E^k/00[/2U@bk0YDP^`05a[_6^iD00[/3U@:k0iD00k^E
^`0S^`03UK^k00Bk0YD4^`03UK^k01Fk19D5^`03UK^k00>k00>E^k/00[/4U@03^iFk07Fk0@00001D
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k19D02l^kbiG;^l^Ebk_;00BE05Bkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^iFkbk_;UL/2U@04^l^kb`>E02K;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;6
06K;^iFEbk^E^l^kbiG;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^k
biG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk^E^l^kbk/2U@07bk_;^l^kb`02U@1f
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40
001G^`05UK^k^iD00k/2U@Fk00>E^k/0Bk/4U@03^iFk00:k00FE^k^kU@02^`BE00>kUK/08;/00lJk
^`02^`03UK^k00Jk0YDS^`03UK^k00Nk00>E^k/08K/00iFk^`05^`>EO;/10000067;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;00:E05Fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00:E
00O;^l^Ebk_;00:E00Fkbk_;^`02U@0Xbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk^E^`>E02jkbiFE^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;0YD0[[_;
^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;UL^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40001K^`03
UK^k00Fk00>E^k/0Ek/00iFk^`03^`:E:k/3U@:k00BE^iFk0iDS^`06UK^k^iFk0YD00k^E^`0R^`03
UK^k00Rk00>E^k/0NK/1000005o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kb`02U@2F
^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbiG;0YD0;[_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;UL^kbiG;^l/2U@0Y^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E
^l^kbk/019D0OL^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;0040001K^`06UK^k^iFk0iEI^`04UK^k^`>E00>kUK/0;[/01IFk^k^E02Fk
0YD2^`03UK^k00:k00>E^k/08K/3U@>k00BE^k^k0YEk^`400000Fl^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/00YD0Ik_;UL^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^Ebk/0
0YD0<L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL/00iD09l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03U@0[bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04U@20^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000GK/3UEfk0iD00k^E^`0b^`05
UK^E^iD0:K/00iFk^`0/^`03UK^k07jk0@000030bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0YD0<l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03U@3Kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003g^`03UK^k0=Vk0@00003obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;003D
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000ok_D^`400000ol^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`00e<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@000?nke;/100000?o;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00=C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40003o^mBk0@00003obk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;003Dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000ok_D^`400000ol^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`00e<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@000:Vk0/Ko^bVk
0@00002[bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;00;6
0?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/002Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
0@0004bk0/IK^`05a[^k^lH0ok/V^`400000Al^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00C600>ka[/00/H0G/^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_6^l^kbk/2aP2Bbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2aP2?
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@0004Nk00C6^k^k0/H3^`03a[^k05Fk00?6^k/01K/2aY2k
00C6^lK6SK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l^ka[_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_6^l^kbk_;^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/004;;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2aP2@^l^ka[_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;0@0004Nk00?6^k/00[/01LJk^k_605Nk00?6^k/02;/00lJk^`1D^`;6=k/4aXbk0@000016
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`;600C;^l^k0/H0Ul^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;^l^k
bk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^l/00YD09K_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[/00/H02<^kbk_;^l^k0/H0;/^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2aP2;bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`010000B;/3aP03^lJk00?6Ek/2aPVk00?6^k/0:[/01iG6UIFkUK/00YDQ^`04a[^k^`;60[/2aP:k
00?6^lH0:;/2aPFk0/J9^`400000Bl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02aP0n^l^ka[_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2o`>E01[;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`;600_;^l^kbk_;ol^kb`02U@0[^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kULK;^`02U@03bk_;00:E01nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00;600S;^lJka[_;^`?602bkblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l_6b`?600C;^l^k0/H0Ql^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000A[/2aP>k00?6^lH00/Hk^`03ULJE00:k
00>E^k/06K/2aPBk00>Ea[/00[/019FkUIDT^`03ULJk00>k00>Ea/H00k/00iFk^`0N^`?60[/00lJk
^`02^`;600>ka[/09[/2aP>k00K6^k^ka[/2aXFk0@000018bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJk1<H0?L^kbk_6^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01<H08IG;
^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02aP04bk^EaP:E02[;UL^kbiG;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiD2aP06bk_;^lJk0/H09<^Ebk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`;600S;^lK6bk_6^`;602;;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0/H0UL^kblK;a/^ka[_;^lJkbk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00400016^`;60k/2aP>k00?6^k/0
=[/4aP05UK^kUK/00YDL^`C60[/2U@Bk00>E^k/06K/2U@Nk00>Ea/H00[/01<Jk^k/2aR:k00K6^lJk
a[/3aP:k00?6^k/08;/00lJkaP03aP:k0/H4^`;60[/00lJk^`0M^`03a_nk00>EGk/1000004S;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/4aP03blK600;603^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l_6bk_;U@02aP03bk^E00:E04NkUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kULK;^l^Ebk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^`03U@07^l^kbk_;U@03aP0Z
^l^kbiG6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;0/H00k_;^`02aP0]blK;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^l_6bk_;00;600Fkbk_6^`03aP03^l^k00;6
01c;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJk0YD0HL^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/00@0004^k0/H3^`03a[^k036k1LH2^`05UK^EaYD00[/019FkUIDL^`:E2;/00iFk
^`0I^`03UK^k00:k0YD6^`03ULK600>k00>E^k/07k/00lJk^`02^`;60[/01<Jka/HQ^`;61;/00lJk
^`03^`C60k/01lJk^k_6^lH06K/01<JE^iD2^`03UK^k00:k0lIG^`400000A/^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2aP05
bk_;a//00lH0>L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_6^l_6b`03aP:E00C6^iFk0YD06<^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^`>E00Fkbk_;^`03U@0Y
^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbiD00/H01/^kbiG6^`;602[;UL^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l^ka[/3aP0V^l_6bk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l/4aP04^l^kb`;600>kbk/00lH0:[_;^l^ka[_;a/^kbk_;^l^kbk_;
^l^kbk_;^l^kbiG;^lJkUK_;ULJkb`?605W;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000
A[/00lJkaP03aPBk00?6^k/0;k/00lJkaP02aPFk0lH00k^E^`05UAFk00>E^k/00iD5^`03UK^k00:k
00>E^k/06K/00iFk^`06^`06ULK6^iG60k/2aPBk0YDP^`04a[^k^`;600>ka[/01;/2UAnk00?6^k/0
0[/00lJkaP03aP:k0lH2^`C65K/2U@04^lK6^`G600>ka[/01<H3^`03a[^k052k0@000027bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;a/^kbk_;a/^kbk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^lJkbk_;00;600Fkbk_;^`02aP03UK^E00:E01fkUK_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;
^`02U@0Tbk_;UL^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0YD02/^kbk_;^l^kbiD3aP0;
^l^kbiG6^l^kUK/00iD07K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;600C;^lJk0/H01l^k
ULK;UL/00YD0;K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;ULJkbiG6U@03aP0G
^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk/00YD01<^EUID2aP05biG6^lH00YD01K_;^lJk00C6057;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/00@0004Fk00?6^k/00k/00lJk^`02^`04ok^k^`:E:K/5aPFk00?6^k/0
0[/00lJkaP02U@03^iFk01Jk00>E^k/01K/2U@03^iFk00>k00BE^k^k0YDH^`:E2K/00iG6^`04^`05
aYFE^iD01;/00iFk^`0J^`04a[_6aP>k0/H00k^EaP02U@>k00>E^k/07k/2aP:k00>EaYD00YD01LJk
UIG601Vk00JE^k^kULH3^`04ULJk^`K600Bka/K61;/2aTZk0@00001Fbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kbk_;a/^k
biG6^l^kUK/2U@0/bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^ka[/3aP09
^l_6bk_;^lJk00?601Vkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00>E00Nkbk_;^l^k00:E00C;^l^k
0YD01<^kUK/2U@0Hbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0YD04L^kbk_;^l^kbk_;^l^ka[_;00:E
02Bkbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l/2aP04^l_6b`?602W;UL^kbiG;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04aP03^l^E00;602O;ULJkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbiG;^l^kbk_;^iD00lH02l^ka[_6^l^kblK;00?604_;a/^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0@0004Fk00?6^k/00k/2aP:k00>EaYD00iD3^`03UK^k026k00?6^k/00lH5^`?61;/6aQ^k0iD5^`03
UK^k00Bk0iD3^`03UK^k01Nk00>E^k/02k/01LJk^k^E00Bk00>E^k/06K/2aP:k00?6^lH00/H2^`03
ULK600Bk00>E^k/08k/00iG6aP04^`?66[/00iFk^`02U@Nk00?6^k/00[/00lJkaP05aP04^lK6aP>k
00?6^k/0@k/1000004G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00/H01[_;^l_6b`C6036kbk^E^l^kUK_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^l^k00;600G;^l^kb`04aP26^l^kbk_;a/^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;^l^kUK_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kUK_;^l^kbk_;^l^kbk_6^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a//3aP03
bk^E00;602VkblJEa/^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02U@06bk_;^l^E
0/H07l^kbiG6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD01k^E^iFkbk/00YD01/^kUK_;^`?6
00ZkblK;a/^kblK;1<H0A;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0@0004Nk1<H4^`04ULJEU@Fk00>E^k/07[/6aPFk00?6^k/0
0[/01<Jk^lHU^`03UK^k012k00>E^k/05[/00iFk^`0D^`:E6[/01<Jk^k/2aP04^iFkU@?60[/01<Jk
^iDP^`03UK^E00:E1;/01IG6a[^E01fk0YD2^`05UK^kUK/00YD00k^E^`03^`03a[^k00:k00?6^lH0
1<H00k_6aP14^`400000Bl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kaP03U@05bk_;^l/00YD0:[_;^iFkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^lJkb`;600Rkbk_6^l^kb`G603O;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;00:E01jkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^iFkbk_;^l/3U@0?bk_;^l^kbk_;^l^kbk_;00:E01Rkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l/2aP04^l_6b`;600Bkbk^E0/H01k_6^l^Ebk/00iD08;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^iFkbk_;0YD01K_;ULJk00;600?;^l/00YD08k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^Ebk^E
^l^k00:E00W;^l^kbk_;^l/00lH0Bl_6blK;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000B[/019Fk^k/3U@>k00FE^k^k
U@04^`>E6K/3aPFk1<H7^`?68[/00iFk^`03^`:E3[/00iFk^`0D^`:E1K/00iFk^`03U@Fk0YD7^`03
UK^k01Nk0lH2^`03ULJk00>k00>Ea/H00[/2U@05^iFk^iD06[/00iFk^`04^`>E00G6^k^EaP02^`04
UK^EUAZk00FE^k^kU@03^`03UK^k00Vk00?6^k/0BK/10000057;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l/0
19D00k_;^`02U@06bk_;UL^k0YD06/^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^l^k0lH01K_;^l^k00?6
03:kbk_;^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^Eb`>E00C;^l^k
0YD07/^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`>E00nkbiG;^l^kbiG;^l^kUK/00iD09K_;
^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kbk/00YD02L^kbk_6^l^kb`02U@0M^l^Ebk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/019D01/^kbk_;U@;600?;^lH00iD0OL^kbiG;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;UL^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00400019^`BE
1k/00iFk^`03^`BE0k/00iFk^`0A^`?61k/00lJk^`02^`04a[^kaRVk0iD3^`03UK^k00:k00JE^k^k
UK/3U@Bk00>E^k/05k/3U@Fk00>E^k/00[/00iFk^`02^`:E0[/00iFk^`0P^`03UK^k00Nk00BE^k^E
7[/2U@Jk0lH2^`05UK^k^iD06K/2U@04^iFEUEZk0@00001=bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00iD0:<^k
bk_;^l^kbk_;^l^Ebk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3aP0<^l^kblK;^l^ka[_;0/H0:k_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/019D03L^kbk^E^l^kUK_;^l/0
0YD0<;_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbiG;^l^kUK_;^l^kb`BE02jkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^kbk_;0YD0;[_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_;^lJkbk_;^l/2U@0J^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l/2U@1L^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000Ck/00iFk^`0?^`:E6;/4aPFk
0lH2^`03a[^k02^k00>E^k/00[/00iFk^`02^`03UK^k00>k0iDQ^`03UK^k00:k0YD8^`03UK^k01nk
00BE^k^k0YD4^`:E0k/00iFk^`0K^`04UK^k^`:E3;/00iFk^`0H^`03UK^k05Zk0@00001Dbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kUK_;^l^k0YD01l^kbk_;^l/00YD01;_;^l/3U@0Hbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0lH01[_;^l^kb`?603O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^iFkbk_;00:E02nkbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
UL^kbk_;^`03U@0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00:E037;^iFk
UK_;^iFkUK_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbiG;00:E00Bkbk_;0iD0Nl^k
bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`010000C[/3U@>k00>E^iD00YD4^`03UK^E00:E1;/00iFk^`0E^`04a[^kaPNk00?6^k/0<;/00iFk
^`04^`:E9[/00iFk^`07^`03UK^k02Jk0iD2^`04UK^kU@:k0YD00k^E^`0J^`BE00>kUK/00[/01IFk
^k^E00:k0iD00k^E^`1e^`400000DL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04U@0=^l^kbiG;^l^Ebk_;
^`03U@31^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^iFkbiG;^`02U@03bk_;00:E01nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00:E00g;^l^Ebk_;UL^kbk_;00>E07G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@0005Bk00>E^k/00[/019Fk^k/2U@Jk0YDG^`03a[^k00?6
>;/00iFk^`06^`03UK^k02>k00>E^k/00[/3U@:k00>E^k/0:k/00iFk^`02^`05UK^k^iD09;/019Fk
^k/3U@Fk00>E^k/0Lk/1000005o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kb`03U@0L
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?6042kbk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;0YD0<;_;UL^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^iFkb`BE066kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbiG;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^Ebk_;^l^k00:E07W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;0040001I^`03UK^k00Jk00>E^k/07;/4aSNk00>E^k/00[/00iFkU@02UBFk
0YD3^`03UK^k00>k00>E^k/0:[/00iFk^`03^`03UK^k02Fk00>E^k/01K/00iFk^`1g^`400000GL^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kb`04U@1K^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^`02U@0_bk_;UL^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0YD0=k^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk/0
0iD0;K^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^`04U@1ibk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000
FK/01IFk^k^E00>k0YEK^`BE;K/2UC:k0YD01;^E^k/2UBJk0YD3^`04UK^kUGVk0@00001Ibk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00iD0bL^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03U@0[bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04U@1l^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40001L^`:EbK/00iFk
^`0/^`03UK^k07Zk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;003Dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/10000ok_D^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00e<^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0@000?nke;/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00=C;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`40003o^mBk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;003Dbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/10000ok_D^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00e<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@000?nke;/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00=C;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40002W^`;6Hk/2aRnk0/JD^`400000ol^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/_6bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`003l^kbk_;^l^kbk_;^l^kb`02aP0_bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;a//00/H0T[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0@000:Nk00C6^k_6
HK/01<Jk^k/2aRZk00?6^k/00[/00lJk^`2?^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00@l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0/H0Sl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040002Z^`03a[^k00;6GK/00lJk^`03^`03a[^k02Nk
00?6^k/01K/2aXfk0@00002Zbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/2aP3oblK;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^l^ka[_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^l^kbk_;^lJkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;000XblK;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`40001<^`03olJk00>k0YDY^`03olJk00>k0YDW^`;60[/2aRjk00?oa[/00[/2UBBk
00?6^k/00k/00oo6^`03^`:E8k/00lJk^`08^`03a[^k02Zk00?6ok/00[/2UERk0@00001Dbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^iG6bk_;^iFk0YD0;l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
biG6^l^kbiG;00:E02Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;603Rka[_6
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^l^Eb`:E02:kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0/H03;_;^l^Ea[_;^l^Eb`:E026kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00/H0<<^kbk_;^l^kblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`;600_;^l^Ea[_;^l^Eb`02U@1F^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l/10000C;/019G6UID2^`05UK^k^iD09[/019G6UID2^`05UK^k^iD09K/01<Jka/H2^`;6:k/01YG6
UIFkU@>k0YDR^`;60[/019G6UID2^`05UK^k^iD08[/2aPNk00C6^k^k0YDS^`;600>kULH00YD2^`05
UK^k^iD0EK/10000053;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^`>E02jkbk_;UL^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^Ea[_;0iD0;<Jkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;a/^k0/H0</_6blK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_6^l^k0YD0:L^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?600?;^l/0
0iD0=L^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^l^kbk^Ea/^kbiG;00:E
02>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03aP03^l^E00:E05W;^l^kUK_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`010000Bk/00iG6^`04^`03UK^k00:k00>E^k/08k/00iG6aP03^`03
ULJk00:k00>E^k/08[/2aP03^lJk00;60[/2aRNk00>Ea[/00k/00iFk^`03^`03UK^k02:k00>Ea[/0
1;/00iFk^`02^`03UK^k02:k0/H3^`06ULJEUK^E0k/00iFk^`0Q^`03ULK600>k00>E^k/00[/00iFk
^`1B^`400000AL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`02U@0_^l^kbiG6UL^kbk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00YD01L^kbk_;00>E0/H0;L^ka[_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`02aP0W^l_6a[_6^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00:E
033;^l^kbiG6UL^kbk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2U@04bk_;^`>E
032kbk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2aP05^iG6bk/0
0YD08<^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0YD02<^kbk_;ULJE0/H0Fl^kbk_;^iFk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@0004Fk00>E^iD01;/00lJkU@02U@Jk00>E^k/07;/00iFk
U@07^`:E0lH3^`03ULJk02Fk00G6^k_6^`02aP:k0/HM^`04UK^EU@Bk00?6^iD00YD6^`03UK^k01bk
00>E^iD01[/3U@Jk00>E^k/09[/3aP>k00>E^k/00[/00iFk^`0I^`04UK^EU@Bk00C6^iFE0/H4^`03
UK^k05:k0@000018bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^k0YD0;l^ka[_;^l^Ebk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kUK_;00:E00Vkbk_;^l^kbiD00/H0<<^kULK;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kblK;^`;605G;a/_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFk
bk^E^l^ka[_;^l^Ebk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;00:E0<Bkbk_;
^l^kUK_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^l^kbk_;
^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kUK_;^lJkbk_;ULJkbk^E^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;0@0004Bk00>E^k/00k/00iFkaP04^`03UK^k00>k00>E^k/06k/00iFk^`03^`03
UK^k00Fk00>E^k/00/H00iG6^`0X^`;600>ka[/00/H2^`03a[^k01Vk00>E^k/00[/2U@03^lJk00>k
00>E^k/00k/00iFk^`0K^`03UK^k00>k00>E^k/01;/00iFk^`03^`03UK^k026k0YD6^`>E1K/00iFk
^`0H^`03UK^k00>k0YD00k_6^`03^`03UK^k00:k00>E^k/0D[/1000004_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l/0
0YD03k_;^l^Ebk_;^l^Ebk_;^`02U@0Nbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^k0YD02/^k
bk_;UL^kbk/2aP0[bk_;ULJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02aP05
^l_6a[/00/H0</^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbiG6^l^kbiG;^l^kbiG;^l^k
0YD07/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^`:E00o;^l^kUK_;^l^kUK_;^l/00YD07k_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK/00YD0;l^kbk_;^l^Ebk_;^iFkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbiG;^l^kbk_;00:E00nkbk_;UL^kbk^E^l^kbk/00YD0CL^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00400014^`:E1k/2U@:k00>E^k/00k/2U@>k00BE^iFE5K/2U@Nk0YD2^`03UK^k00>k00>Ea/H0
0[/019G6UIDU^`05a[^ka[/00/H00k_6^`0H^`:E1[/00lJEU@02^`03UK^k00>k0YD3^`04UK^EUAFk
0YD7^`:E0[/00iFk^`03^`:E0k/019FkUIDK^`04UK^k^`:E1K/00iFk^`02^`03UK^k01Rk0YD8^`:E
0[/00iFk^`02^`:E1;/00iFkU@1<^`400000A/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3U@06^l^kbk_;0iD01l^kbk_;^l/0
0YD07;^E^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l/3U@06bk_;^l^k0iD02;_;^l^kbk^E0/H0;9G6
^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0/H07k_6a/Jkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/00YD01l^kbk_6^l/00iD01l^kbk_;^l/00YD07;^E^l^kUK_;^l^kbk_;
^l^kbk_;^l^kbk_;^l/3U@06bk_;^l^k0iD01k_;^l^kbk/00YD09/^Ebk_;UL^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kUK_;^l^k0YD03<^kbiG;^l^kUK_;^`:E01O;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`03U@07bk_;^l^kb`03U@06bk_;^l^k0YD0DL^kUK_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000BK/2U@Jk
00>E^k/01k/2U@Bk00>E^k/05[/2U@Jk00>E^k/01k/00iG6aP03^`03ULJk02Jk0/H01;_6aYD2aQVk
0YD2^`03a[^k00:k00>E^k/01k/2U@Bk00>E^k/05[/2U@Jk00>E^k/01k/2U@Bk00>E^k/05k/2U@Jk
19D4^`:E0[/019FkUIDH^`:E1k/00iFk^`06^`>E0k/00iFk^`18^`400000S/^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
biG;^l^kbk_;^l^kbk_;^l^kUK_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^k
bk_;^l^kbiD2aP0`bk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^lJE
0/H0P<_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^lJkbk_;^l^kbk_;^l^kbk^E^l^kbiG;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;UL^kbk^E^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0YD03/^kbk_;^l^Ebk_;^l^k0iD0O[_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kUK_;^l^kbk_;^l^kbk_;^l^kUK_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40001;^`03UK^k01>k00>E^k/0
6;/00iFk^`0A^`C6:[/01/JkULJkaQZk00>E^lH05;/00iFk^`0H^`03UK^k01>k00>E^k/06k/00iFk
^`0=^`05UK^k^iD06K/00iFk^`0D^`03UK^k04Nk0@00001Qbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^k
bk_;^l^kbk_;^l^kb`02U@1K^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;
^l^kbk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02aP0eblK6a/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_6^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD0;k_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^k00:E067;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;00:E04Rkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000B[/00iFk^`04^`>E3k/2UANk
00>E^k/00k/3U@nk0YDU^`:E0[/01IG6a[_601Zk00>Ea[/01;/3U@nk00>E^k/05K/00iFk^`04^`>E
3k/2UA^k00>E^k/04;/00iFk^`0G^`03UK^k00Bk0YD@^`03UK^k04Fk0@00001Dbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk^E^l^kbk_;UL^k0iD01K_;^l^k00:E02O;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^k
bk^E^l/00iD01/^kbk_;^`:E03G;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;UL^Ebk^Ea/^Eb`02U@0Q^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^Ea/^kbk_;UL^k00>E00Fkbk_;
^`02U@0Wbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kUK_;00>E00G;^l^kb`02U@0X
^l^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kb`:E00^kbk_;^l^kbk_;^`02U@0Q
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbiG;00>E00K;^l^kbk/2U@1=bk_;^l^kUK_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00@0004Zk0iD4^`03UK^k00>k00>E^k/00[/00iFkU@02U@Fk00>E^k/04k/3U@>k00>E^k/0
0k/00iFk^`03^`03UK^E00:E1;/00iFk^`0Q^`06UK^kUK^E0[/01IFkUK^E01Jk0iD4^`03UK^k00>k
00>E^k/00[/00iFkU@02U@Bk00>E^k/04k/3U@Bk00>E^k/00k/00iFk^`02^`03UK^E00:E1K/00iFk
^`0G^`03UK^k00>k00BE^iFE1K/2U@Bk0YDF^`>E1;/00iFk^`02^`03UK^k00>k00>E^iD00YD4^`03
UK^k04>k0@00001=bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00iD04L^Ebk_;^l^Ebk_;^iFkbk_;00:E01bkbk^E
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;19D04;_;^l^kUK_;^l^kUK_;^l/2U@0V^l^Ebk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2U@07^l^EUK_;^`02U@0Kbk^E^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;00>E017;UL^kbk_;UL^kbk^E^l^kb`02U@0K^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00>E016kUK_;^l^kUK_;^l^Ebk_;^`02U@0Mbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0iD03/^kbiG;^l^Ebk_;^iFk0iD07;_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/4U@0@^l^kbk^E
^l^kbk^E^l^kb`:E04RkbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000D;/2U@Fk00>E^k/00[/00iFk^`04^`BE6k/00iFk
^`03^`03UK^k00>k00>E^k/01;/3UBFk00BE^k^E1;/019Fk^iDK^`:E1K/00iFk^`02^`03UK^k00Bk
19DJ^`:E1K/00iFk^`02^`03UK^k00Bk19DL^`BE1;/01IFk^k^E00Bk0YD00k^E^`0J^`03UK^k00>k
00>E^k/00k/00iFk^`04^`BEA;/1000005c;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^`>E
02nkbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^`02U@1Pbk_;^l^k
biG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk^E^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^k0YD0;l^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^iFkbk_;00>E03O;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^Ebk_;^iFkbk^E^l^kbk_;00>E02K;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFk
bk_;^`:E04g;^l^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000Ek/00iFk^`05^`>E9[/00iFk^`05^`>E:k/019Fk
UID6^`:E8K/00iFk^`04^`>E9k/00iFk^`05^`>E:K/019Fk^k/2U@Nk00>E^k/07[/00iFk^`05^`>E
B[/100000<G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^iFkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kUK^E^iFkb`03U@2>bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^Ebk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^k
bk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^`>E07Zkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40
001G^`03UK^k00Rk00>E^k/08k/00iFk^`08^`03UK^k02Rk19D01;^E^iD2^`03UK^E022k00>E^k/0
1k/00iFk^`0T^`03UK^k00Rk00>E^k/09[/00iFk^`06^`03UK^k02:k00>E^k/02;/00iFk^`17^`40
0000GL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kb`02U@0_^l^kUK_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk/00YD0>L^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^EbiG;^iFkb`02U@0U^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^Ebk_;^`02U@0`bk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
UK_;^l^k0YD0H<^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^k
bk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^`:E04g;^l^Ebk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`010000Ek/00iFk^`03^`06UK^EUK^E9K/00iFk^`03^`06UK^EUK^E;k/00iFk^`02U@:k
00>E^k/07[/00iFk^`02^`04UK^EU@:k00>E^k/08k/00iFk^`03^`06UK^EUK^E:;/00iFk^`02^`:E
0[/00iFk^`0R^`03UK^k00>k00JE^iFE^iE9^`400000HL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
biG;^l^kbiG;^l/00YD0;k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk^E
^l^k00:E063;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^k
UK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^iFkbk/3U@0_^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^iFkbk/00YD0;l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbiG;00>E02k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk^E^l^kbk^E^l^k0YD0BL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@0005Nk0iD3^`03UK^k00:k00>E^k/0
8k/3U@>k00>E^k/00[/00iFk^`0]^`06UK^kUK^E8[/2U@>k00>E^k/00k/00iFk^`0S^`>E0k/00iFk
^`02^`03UK^k02Jk0YD3^`05UK^k^iD09;/3U@>k00>E^k/00[/00iFk^`17^`400000F/^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`BE02g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/019D0=k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^Ebk/00iD09;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`BE02jkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;19D0;k_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00BE02_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;00BE04jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000GK/00iFk^`0^^`03
UK^k03:k19D00k^E^`0V^`03UK^k02nk00>E^k/0<;/00iFk^`0/^`03UK^k04bk0@00003obk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;003Dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^kbk/10000ok_D^`400000ol^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`00e<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@000?nke;/10000
0?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/00=C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40003o^mBk
0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;003Dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000
ok_D^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00e<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
0@000?nke;/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00=C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`40003o^mBk0@00003Jbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2aP3g
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`010000f[/01<Jka/Ke^`400000f/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0/H0Il^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00lH019G6
UK/3U@26^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l/10000O[/2aUbk00?6^lH0I;/00iG6aP02aP>E0[/00iFk^`23^`40
0000P<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^lJk0/H0Fl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00/H0H;_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?600?;a/H00lH3U@03^l^E00:E08?;UIFEbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`010000D[/2aRZk00C6^k^k0/IJ^`;6Gk/00lJk^`02aP:k0/H00k^EU@05^`:E0[/00iFk^`1l^`40
0000CL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;00;600Fkbk_6^`02aP0^bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^onkbk_;U@;602k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_o^l^k0YD0:/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^`;6
03G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o^l^kb`02U@0]
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^l^k00RE00?;^l/01iD08L^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kb`02U@1H^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kb`400016^`?61;/01/Jka/JkaP>k0/HU^`03ULJk00>k00>E^iD00/HV^`03ULJk00>k00BE^iFE
9[/01<Jk^k/2aRfk00>Ea[/00k/019FkUIDT^`?62k/019Fk^k/8UAZk00>Ea[/00k/019FkUIEF^`40
0000BL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_6^l/01<H01;_;^l/2aP0/^l^kbk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;ULH2U@0_^l^Ebk_;ULJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kULH00YD0</^kUK_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^l^k
0/H0;L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^EaP02U@0]^l^Ebk_;
UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;600W;^l^kbk_;^l/00iD00l^E
U@02U@0P^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULH2U@1L^l^Ebk_;UL^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l/10000A[/00lJk^`03^`03a_nk00:k00BEa/K60k/00lJk^`0R^`04ULJk^`>E
1;/00iG6^`0S^`04ULJk^`>E1;/00iFk^`0R^`03a[^k00Fk0/H2^`;69K/019G6^k/3U@Bk00>E^k/0
9;/3aPZk0YD2^`03UK^k01bk00BEa[^k0iD4^`03UK^k05:k0@000016bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;600g;^l^E
aYG;^l^Ebk^E00C608nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ea[_;^l^Ebk_;
^iG6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^l^kUK_;^l^Ebk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^l^kbk_;^`03aP1K^lJkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk_;^l^Ebk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^`05aP28^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6
^l^kbiG;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`400018^`;600BkULJk19D5^`03ULK602>k
00>Ea/H02;/00iG6^`0S^`03ULJk00Rk00>E^k/07K/2aP>k00?6^k/02K/2aP03^lJk026k00>Ea[/0
2K/00iFk^`0X^`C6:;/00iG6^`08^`03UK^k05:k0@00001:bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3aP0=^l^kbiG;
^l^kbiG;^`02aP0Jbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2U@08bk_;^l^kbiD2aP0Ubk_;^l^k
ULK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02U@07^l^kbk_;^`02U@0Ybk_;^l^kbiG;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a//00lH03/^kbk_;^l^kbk_;^lJk0/H07<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/2U@06bk_;^l^k0YD0<l^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04aP0Q^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00:E00O;^l^kbk_;00:E05bkbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40001;^`03
ULJk00Vk00>E^k/00[/00lJk^`0G^`04UK^EU@Nk00>Ea/H01;/00iG6^`0L^`03UK^E00:E1[/2U@Fk
00>E^k/07;/00lJk^`02^`;62k/01<Jk^lHL^`04UK^EU@Jk0YD6^`03UK^k02Bk1LH2^`03a[^k01nk
00>E^iD00YD6^`:E1K/00iFk^`1B^`400000A<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0YD01l^kbk_;^lH00YD0:k_;^l^kbk_;
UL^kbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk/00YD02<^kbk_;^l^E0/H09/^kULK;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^k0YD0:/^kbk_;^iFkbk_;UL^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`;600G;^l_6b`02aP0]^l^kbk_;^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk^E^l^k00:E067;^l^kbk^E^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;00:E
062kbk_;^l^Ebk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000A;/00iFkU@02U@>k00?6^k/0
0YD6^`03UK^k00>k00?6^k/05K/00iFk^`04^`:E1K/00iFk^`04aP>k0YDG^`03UK^k00Fk0YD4^`03
UK^k00:k00>E^k/00k/2UAVk1<H3^`03a[^k00Jk00?6^k/07;/00iFk^`04^`:E1;/00iFk^`03^`03
UK^k00:k0YDP^`03a[^k02Fk00>E^k/01K/2U@Bk00>E^k/00[/00iFk^`03^`:ECK/1000004W;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iFkbk_;00:E02Zka[_;^l^Ebk_;^l^Ebk_;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2U@07
^l^kbk_;^`02U@0?bk_;UL^kbk^Ea/^kbiG;00:E01Fkbk_;^l^kbk_;^l^kbk_;^l^kbk/00YD02<^k
bk_;^l^k0YD0<<^kUK_;^l^Ebk_;^l^EbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^`;6
00W;^l^kbk_o^l/00YD06[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0YD01k_;^l^kbk/00YD03l^k
UK_;^l^kUK_;^l^Eb`02U@0N^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0lH09L^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD02;_;^l^kbk_;0YD0G;_;UL^kbk^E^l^kbk^E
^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;0@0004Bk00>E^k/01;/019G6a/H2^`03UK^k00>k00>E^k/00[/00iG6
aP0H^`>E1[/3U@Fk0YD3^`05UK^k^iD05[/3U@Nk0iD4^`>E0k/019Fk^iDQ^`;60k/01iG6^k^E^iD0
6k/3U@Jk0iD5^`:E0k/01IFk^k^E022k0/HU^`>E1k/3U@Bk0iD3^`04UK^kUD^k0@000014bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/2U@07bk_;^l^kb`02U@?600G;^l^kb`02U@06^l^kULJE0lH06<^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`:E00k;^l^kbk^E^l^kbk_;^`BE01g;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02U@0?
^l^kbk_;^iFkbk_;^l^k00BE02K;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;6
00?;ULH00iD08<^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0YD03/^kbk_;^iFkbk_;^l^k
19D09<^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`G602Fkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k00:E00o;^l^kbk_;UL^kbk_;^l/019D0C[_;^iFkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kb`400016^`:E1k/3U@;61K/2U@03^iG600>k00>Ea[/06;/00iFk^`0>^`03UK^k00:k00>E^k/0
6;/00iFk^`0?^`05UK^k^iD09;/3aP:k00BE^k^E7k/00iFk^`0>^`03UK^k00:k00>E^k/08K/3aP03
^lJk02:k00>E^k/03k/01IFk^k^E04Zk0@000018bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0YD02/^kbk_;^l^Ea[/2aP05
bk_;^l/00YD0SLK;^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;
^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;U@02aP1Nbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`G608Bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;
^l^kbk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000B[/00iFk^`05^`04a[^k^`;61;/00iG6aP02^`03
ULJk01Rk00>E^k/04k/00iFk^`0H^`03UK^k01Bk00>E^k/07[/2U@>k00?6ULH00k/00iFk^`0M^`03
UK^k01>k00>E^k/08K/5aR>k00>E^k/05;/00iFk^`17^`400000F<^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^k
bk_6^l^kbk/2aP05bk_;a//01<H07k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk/00YD03/^k
bk_;^l^kbk_;^l^k0YD08<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^k0YD03/^kbk_;^l^k
bk_;^l^k0YD08L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Eb`02U@0;^lJkblK;^iFkbk/0
0YD08<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^k0YD03/^kbk_;^l^kbk_;^l^k0YD07/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?600Bka[_;0/H0:[_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kUK_;^l^kb`:E00jkbk_;^l^kbk_;^l^kb`:E04Rkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000
B[/00iFk^`05^`;61;/00lJkaP03aP>k00>Ea[/06;/00iFk^`03^`04UK^EU@Rk0YD4^`>E5[/00iFk
^`04^`04UK^EU@Nk0YD5^`:E7K/01IFk^k^E00C60[/2U@:k00>E^iD06;/00iFk^`04^`04UK^EU@Nk
0YD5^`>E6k/00lJk^`02aRNk00>E^k/01;/019FkUID7^`:E1K/2UDJk0@00001Abk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk^E^l^kbk_;00>E0/H03L^ka[_;^iG6bk_;^l/00iD05/^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2U@08
bk_;^iFkbk/2U@08bk_;^l^kUK/3U@0J^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l/2U@0B^l^kbk^E
^l^kUK_;^l^kbiG;0iD08L^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02U@04^l^kb`:E
00G6bk_;^`03U@0J^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2U@09^l^kbk^E^l^k00:E00O;^l^k
biG;00>E04c;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0YD04/^kbk_;UL^kbiG;^l^kbk^E^`>E04Zkbk_;UL^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kb`40001:^`:E1K/00iFk^`02U@?60k/019FkUID6^`03UK^k01Fk0YD2^`03UK^k00>k00>E^k/0
0k/00iFk^`02^`:E0[/00iFk^`0E^`:E0[/00iFk^`03^`03UK^k00>k00>E^k/00[/2U@:k00>E^k/0
7;/2U@Bk00>E^k/01;/019Fk^iDI^`>E0[/00iFk^`03^`03UK^k00:k00>E^k/00[/2U@>k00>E^k/0
6;/3aR^k0YD2^`03UK^k00>k00>E^k/00k/00iFk^`02^`:E0[/00iFk^`13^`400000C<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/3U@0a^l^Ebk_;^l^Ea[_;^iFkbk^E^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^`03U@0^^l^kbk^E^l^kbk^E^l^kbk_;UL^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`>E01;;^l^k
biG;^l^kbiG;^l^kbk/3U@1;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;
^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00>E016kbk_;^iFkbk_;UL^kbk_;^`02U@0O
biG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02aP0[^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`03U@0B^l^kbk^E^l^kbk^E^l^kbk_;0iD0AL^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000
Ck/3U@Fk00>E^k/00[/00iFk^`02^`:E0k/00iFk^`0I^`03UK^k00>k00>E^k/00k/2U@Jk0YDK^`03
UK^k00>k00>E^k/00k/2U@Nk0YDO^`03UK^k00^k0iDL^`03UK^k00>k00>E^k/00[/2U@Nk0YDN^`?6
:k/00iFk^`03^`03UK^k00>k0YD7^`:EA;/1000005c;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^E
bk_;^`:E00G;^l^kb`04U@0Y^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk/0
0YD0;l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_;00:E02Zkbk_;
^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l/3U@04bk_;^`:E02g;^l^kUK_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l/00YD0:;_;^l^kbiG;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l/2aP0g^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk^E^l^kbk_;^`02U@1;bk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040001G^`03UK^k00Bk0iD5^`03
UK^k01nk00>E^k/01k/00iFk^`0T^`03UK^k00Nk00>E^k/08k/2U@:k00>E^k/00YD2^`03UK^E00>k
00>E^k/07k/00iFk^`06^`:E9k/5aR^k00>E^k/01k/00iFk^`18^`400000jl^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbiG;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk^E^l^kbk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^k
bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00iD02L^kbiG;^iFkb`03U@1D
biG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0lH0P[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000Ek/00iFk^`07^`03UK^k02Bk
00>E^k/02;/00iFk^`0S^`03UK^k00Rk00>E^k/09[/01IFk^k^E00:k0YD4^`:E8;/00iFk^`08^`03
UK^k02Bk1LH[^`03UK^k00Rk00>E^k/0Ak/1000005c;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E
bk_;^`>E02nkbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^`02U@0_
bk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l/00YD0=K_;^iFkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^k00:E02[;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk/2U@0Vbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/5aP0e^l_6a[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk^E^l^kbk/00YD0CL^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040001G^`03UK^k00:k00>E^k/019DU^`03
UK^k00>k00>E^iD00iDU^`03UK^k00>k00>E^iD00iD/^`03UK^k00Bk00>E^k/08K/00iFk^`03^`03
UK^E00>E8[/00lJk^`0a^`03UK^k00>k00>E^iD00iE9^`400000El^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`02U@0_^l^kUK_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
0iD0;[_;^iFkbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/3U@0hbk_;UL^k
bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk/2U@0Vbk^E^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3U@1O^l^kUK_;^l^Ebk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00iD0D[_;^iFkbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000FK/4UBjk19D]^`BE<K/01IFk
^iFk00>E9[/4UBNk0lHd^`BEC[/100000?7;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00BE05Rkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
0/H0Q;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kb`40003d^`03UK^k05Nk0lJ2^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00D/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/2aP20^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000ok]C^`?600>ka[/0Nk/100000?o;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/005K;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;607bkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0@000?nke;/10000
0?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/00=C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40003o^mBk
0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;003Dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000
ok_D^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00e<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
0@000?nke;/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00=C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`40003o^mBk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;003Dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/10000ok_D^`4000002l^kbk_;^l^kbk_;00Go00K;^l^kbk/2o`06bk_;^l^k0_l01l_o
ooo;^l/00ol01<^kbk/3o`03^l^k00;o00K;oooobk/3o`03^l_o00?o0?nkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
08nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`0100003;/2o`Rk0_l5^`;o00Nkoooo^onk00;o0[/01?nk
^k/2o`03^onk00;o00Nkoooo^onk00;o00Bkok_o0[/2oonkS[/1000000g;^l^kbk_;^l^kbk_;00;o
00Rkbk_;^l^kb`;o00Bkbk_;0_l00k_;o`03o`0:^ooobk_;ol^kb`;o00Jkbooo^l/4o`05^l_ook/0
0_l0ol^kooo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`00T/^kooo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0000fk0_l8^`;o
1;/2o`>k0_l2^`;o1k/2o`:k0_l3^`;o0k/2o`Fk0_oo^hjk0@00000=bk_;^l^kbk_;^l^kb`02o`08
^l^kok_;^l/3o`04bk_;^`;o00K;^ooobk/2o`07bk_;^l^kb`02o`03^l^k00;o00O;^ooobk_;00;o
00Bkbk_;0_l0ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`00Sk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040000=^`;o
0k/00onk^`02^`?o1;/2o`:k0_l3^`;o0[/2o`:k0_l3^`;o0[/2o`>k0_l3^`;o0[/00onk^`3o^h^k
0@00000>bk_;^l^kbk_;^l^kbk/6o`04bk_;^`?o00Bkok_;0_l01k_ooonkbk/00_l01/^kok_;^`;o
00?;^l/00_l01k_ooonkbk/00_l0ol^kooo;^onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00U<^kooo;^onkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/100003[/2o`>k00Co^k^k0ol00k_oo`03^`;o00>kool01;/3o`:k1Ol3^`;o00>kool0
0k/2o`>k1?nA^`Go1;/3o`:k0ol01[_ooonko`Jk1?oJ^`4000003/^kbk_;^l^kbk_;^l^k0_l08<^k
boo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0_l03<^kbk_;^l^kbk_;^`;o0?o;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kbk_;ol^kok_;^onkboo;^l_obk_;^l^kbk_o^l^kboo;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/009C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0000jk0_lQ^`03ok^k00Zk0_nF^`03
ok^k00Bk00Co^k_o1[/01Onk^k_o00Rk00?o^k/00[/00onk^`3G^`4000003l^kbk_;^l^kbk_;^l^k
b`02o`0^^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;o0?nkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^onkbk_;^l_obk_o^l^kbk_;ol^kboo;^l^kbk_;^onkbk_;
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/009>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0000nk0_l4^`03ok^k02Nk
0_nE^`03ok^k00>k0ol00k_oo`03o`:k00Go^k^ko`08^`03ok^k00:k00?o^k/0ek/1000000g;^l^k
bk_;^l^kbk_;00Wo02S;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol0Y[_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kok_;^l^kbk_;^onkbk_o^l/2o`3Z^l_obk_;^l^kbk_o
^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0@000=Jk00?o^k/02;/3o`:k
0_l00k_oo`09^`03ok^k00:k00?o^k/0ek/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kok_;^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kok_;^l_obk_;^l/00=C;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40003G^`03ok^k00:k0_lF^`03ok^k00:k00?o^k/0ek/10000
0=S;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/4o`0Iboo;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`04o`3J^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000ok_D^`40
0000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`00e<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@000?nk
e;/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00=C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40
003o^mBk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;003Dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/10000ok_D^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00e<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0@000001\
\>"],
  ImageRangeCache->{{{0, 467}, {289, 0}} -> {-0.0250052, -0.0256965, 
  0.00224842, 0.00363801}, {{11.0625, 455.875}, {281.938, 7.0625}} ->
   {-1.30268, -0.269651, 0.020571, 0.020571}, {{63.3125, 108.062}, {275.875, 
  231.062}} -> {-0.388172, -0.328387, 0.0100984, 0.0230599}, {{112.562, 
  157.312}, {275.875, 231.062}} -> {-0.885517, -0.328387, 0.0100984, 
  0.0230599}, {{161.812, 206.562}, {275.875, 231.062}} -> {-1.65577,
   -0.320491, 0.0115636, 0.0224597}, {{211.062, 255.812}, {275.875, 231.062}}
   -> {-1.72172, -0.332218, 0.0094379, 0.0233511}, {{260.312, 305.062}, {
  275.875, 231.062}} -> {-2.63199, -0.323074, 0.010992, 0.0226561}, {{309.562,
   354.312}, {275.875, 231.062}} -> {-2.86414, -0.328425, 0.0100661, 
  0.0230628}, {{358.812, 403.562}, {275.875, 231.062}} -> {-2.00086,
   -0.290513, 0.00654257, 0.0227181}, {{63.3125, 108.062}, {226.625, 181.812}}
   -> {-0.332065, -1.48036, 0.00948884, 0.0233206}, {{112.562, 157.312}, {
  226.625, 181.812}} -> {-0.973703, -1.44296, 0.0107419, 0.0227213}, {{
  161.812, 206.562}, {226.625, 181.812}} -> {-1.06051, -1.46419, 0.00839902, 
  0.0232295}, {{211.062, 255.812}, {226.625, 181.812}} -> {-2.06749, -1.44008,
   0.0108936, 0.0226752}, {{260.312, 305.062}, {226.625, 181.812}} ->
   {-2.53644, -1.44769, 0.0106565, 0.0227972}, {{309.562, 354.312}, {226.625, 
  181.812}} -> {-2.1575, -1.44965, 0.00797099, 0.0230939}, {{358.812, 
  403.562}, {226.625, 181.812}} -> {-4.25025, -1.41189, 0.0123891, 0.0222235},
   {{63.3125, 108.062}, {177.375, 132.562}} -> {-0.170422, -2.57594, 
  0.0076994, 0.023023}, {{112.562, 157.312}, {177.375, 132.562}} ->
   {-0.554906, -2.57996, 0.00773616, 0.0230487}, {{161.812, 206.562}, {
  177.375, 132.562}} -> {-1.48678, -2.57045, 0.0106565, 0.0227972}, {{211.062,
   255.812}, {177.375, 132.562}} -> {-1.88021, -2.59978, 0.0100984, 
  0.0230599}, {{260.312, 305.062}, {177.375, 132.562}} -> {-2.74652, -2.5392, 
  0.0113942, 0.0225173}, {{309.562, 354.312}, {177.375, 132.562}} ->
   {-2.66869, -2.6289, 0.00948884, 0.0233206}, {{358.812, 403.562}, {177.375, 
  132.562}} -> {-3.92395, -2.53299, 0.0115379, 0.0224616}, {{63.3125, 
  108.062}, {128.125, 83.3125}} -> {-0.388172, -3.73548, 0.0100984, 
  0.0230599}, {{112.562, 157.312}, {128.125, 83.3125}} -> {-0.885517,
   -3.73548, 0.0100984, 0.0230599}, {{161.812, 206.562}, {128.125, 83.3125}}
   -> {-1.92717, -3.58127, 0.0130204, 0.0221015}, {{211.062, 255.812}, {
  128.125, 83.3125}} -> {-1.88021, -3.73548, 0.0100984, 0.0230599}, {{260.312,
   305.062}, {128.125, 83.3125}} -> {-2.37755, -3.73548, 0.0100984, 
  0.0230599}, {{309.562, 354.312}, {128.125, 83.3125}} -> {-3.06127, -3.69321,
   0.0106565, 0.0227972}, {{358.812, 403.562}, {128.125, 83.3125}} ->
   {-3.37224, -3.73548, 0.0100984, 0.0230599}, {{63.3125, 108.062}, {78.875, 
  34.0625}} -> {-0.321017, -4.94062, 0.00937129, 0.0233903}, {{112.562, 
  157.312}, {78.875, 34.0625}} -> {-0.885517, -4.87118, 0.0100984, 0.0230599},
   {{161.812, 206.562}, {78.875, 34.0625}} -> {-1.38286, -4.87118, 0.0100984, 
  0.0230599}, {{211.062, 255.812}, {78.875, 34.0625}} -> {-1.96782, -4.82906, 
  0.0104704, 0.0228594}, {{260.312, 305.062}, {78.875, 34.0625}} -> {-2.37755,
   -4.87118, 0.0100984, 0.0230599}, {{309.562, 354.312}, {78.875, 34.0625}} ->
   {-0.708498, -4.60546, 0.00363676, 0.0220884}, {{358.812, 403.562}, {78.875,
   34.0625}} -> {-3.37224, -4.87118, 0.0100984, 0.0230599}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Generation 20"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .95229 
MathPictureStart
%% Graphics3D
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-3.75585e-05 1.06867 0.0267167 1.06867 [
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 20)] .5 .95229 0 -1.5 Msboxa
P
[(0)] .08595 .18034 -0.06484 1 Msboxa
[(10)] .23556 .13958 -0.04346 1 Msboxa
[(20)] .40028 .0947 -0.01962 1 Msboxa
[(30)] .58253 .04506 .00711 1 Msboxa
[(Indiv.)] .35928 .03957 -0.02584 1 Msboxa
[(Gen.)] .91594 .16872 -1 .22094 Msboxa
[(-50)] .05928 .20717 1 -0.26973 Msboxa
[(0)] .04482 .42044 1 -0.20167 Msboxa
[(50)] .0295 .64725 1 -0.12859 Msboxa
[(Fit.)] -0.0283 .53856 1 -0.16726 Msboxa
[ 0 0 0 0 ]
[ 1 .95229 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 20)] .5 .95229 0 -1.5 Mshowa
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.08509 .19367 m
.08465 .20033 L
s
P
[(0)] .08595 .18034 -0.06484 1 Mshowa
p
.002 w
.23498 .15292 m
.23469 .15959 L
s
P
[(10)] .23556 .13958 -0.04346 1 Mshowa
p
.002 w
.40002 .10806 m
.39989 .11474 L
s
P
[(20)] .40028 .0947 -0.01962 1 Mshowa
p
.002 w
.58262 .05842 m
.58267 .0651 L
s
P
[(30)] .58253 .04506 .00711 1 Mshowa
p
.001 w
.11395 .18582 m
.11371 .18982 L
s
P
p
.001 w
.14336 .17783 m
.14314 .18183 L
s
P
p
.001 w
.17332 .16968 m
.17311 .17368 L
s
P
p
.001 w
.20386 .16138 m
.20367 .16538 L
s
P
p
.001 w
.2667 .1443 m
.26655 .1483 L
s
P
p
.001 w
.29905 .1355 m
.29892 .13951 L
s
P
p
.001 w
.33204 .12654 m
.33192 .13054 L
s
P
p
.001 w
.36569 .11739 m
.36559 .1214 L
s
P
p
.001 w
.43505 .09854 m
.43499 .10254 L
s
P
p
.001 w
.4708 .08882 m
.47076 .09283 L
s
P
p
.001 w
.5073 .0789 m
.50728 .0829 L
s
P
p
.001 w
.54456 .06877 m
.54457 .07277 L
s
P
p
.001 w
.6215 .04785 m
.62155 .05186 L
s
P
p
.001 w
.66122 .03706 m
.6613 .04106 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
p
.002 w
.69926 .02672 m
.93852 .30206 L
s
P
[(Gen.)] .91594 .16872 -1 .22094 Mshowa
P
p
p
.002 w
.07262 .19706 m
.02672 .88626 L
s
P
p
.002 w
.07218 .2037 m
.07863 .20196 L
s
P
[(-50)] .05928 .20717 1 -0.26973 Mshowa
p
.002 w
.05792 .4178 m
.06447 .41648 L
s
P
[(0)] .04482 .42044 1 -0.20167 Mshowa
p
.002 w
.04275 .64555 m
.04937 .64469 L
s
P
[(50)] .0295 .64725 1 -0.12859 Mshowa
p
.001 w
.0694 .24548 m
.07328 .24449 L
s
P
p
.001 w
.06658 .28778 m
.07047 .28683 L
s
P
p
.001 w
.06373 .33059 m
.06763 .3297 L
s
P
p
.001 w
.06084 .37393 m
.06476 .37309 L
s
P
p
.001 w
.05496 .46222 m
.0589 .46148 L
s
P
p
.001 w
.05196 .50719 m
.05591 .50651 L
s
P
p
.001 w
.04893 .55273 m
.05289 .5521 L
s
P
p
.001 w
.04586 .59884 m
.04983 .59827 L
s
P
p
.001 w
.0396 .69285 m
.04358 .69239 L
s
P
p
.001 w
.03641 .74076 m
.0404 .74037 L
s
P
p
.001 w
.03318 .78929 m
.03717 .78896 L
s
P
p
.001 w
.0299 .83845 m
.0339 .83819 L
s
P
[(Fit.)] -0.0283 .53856 1 -0.16726 Mshowa
P
0 0 m
1 0 L
1 .95229 L
0 .95229 L
closepath
clip
newpath
p
p
.4 g
.002 w
.07218 .2037 m
.42945 .40199 L
s
P
p
.4 g
.002 w
.05792 .4178 m
.427 .56884 L
s
P
p
.4 g
.002 w
.04275 .64555 m
.42443 .74367 L
s
P
p
.4 g
.002 w
.02658 .88827 m
.42174 .92708 L
s
P
p
.4 g
.002 w
.08367 .20324 m
.03923 .88751 L
s
P
p
.4 g
.002 w
.18588 .26044 m
.15408 .89894 L
s
P
p
.4 g
.002 w
.27503 .31032 m
.253 .90878 L
s
P
p
.4 g
.002 w
.35346 .35421 m
.3391 .91735 L
s
P
p
.4 g
.002 w
.423 .39313 m
.4147 .92487 L
s
P
p
.4 g
.002 w
.44013 .39481 m
.43312 .92519 L
s
P
p
.4 g
.002 w
.56602 .37138 m
.56847 .92068 L
s
P
p
.4 g
.002 w
.70138 .34619 m
.71482 .91579 L
s
P
p
.4 g
.002 w
.84733 .31903 m
.87358 .91049 L
s
P
p
.4 g
.002 w
.42945 .40199 m
.93886 .30796 L
s
P
p
.4 g
.002 w
.427 .56884 m
.94975 .49749 L
s
P
p
.4 g
.002 w
.42443 .74367 m
.96124 .6975 L
s
P
p
.4 g
.002 w
.42174 .92708 m
.97338 .9089 L
s
P
P
p
.10948 .21103 m .45808 .39844 L .44573 .40071 L 0 .094 1 r
F
P
p
.12396 .2072 m .47051 .39615 L .45808 .39844 L 0 .844 1 r
F
P
p
.10948 .21103 m .12396 .2072 L .45808 .39844 L 0 .094 1 r
F
P
p
.13856 .20334 m .48303 .39384 L .47051 .39615 L 0 1 .719 r
F
P
p
.12396 .2072 m .13856 .20334 L .47051 .39615 L 0 .844 1 r
F
P
p
.1533 .19945 m .49564 .39152 L .48303 .39384 L 0 1 .594 r
F
P
p
.13856 .20334 m .1533 .19945 L .48303 .39384 L 0 1 .719 r
F
P
p
.16818 .19552 m .50835 .38918 L .49564 .39152 L 0 1 .5 r
F
P
p
.1533 .19945 m .16818 .19552 L .49564 .39152 L 0 1 .594 r
F
P
p
.18319 .19155 m .52114 .38683 L .50835 .38918 L 0 1 .406 r
F
P
p
.16818 .19552 m .18319 .19155 L .50835 .38918 L 0 1 .5 r
F
P
p
.19835 .18755 m .53403 .38446 L .52114 .38683 L 0 1 .375 r
F
P
p
.18319 .19155 m .19835 .18755 L .52114 .38683 L 0 1 .406 r
F
P
p
.21366 .1835 m .54701 .38207 L .53403 .38446 L 0 1 .375 r
F
P
p
.19835 .18755 m .21366 .1835 L .53403 .38446 L 0 1 .375 r
F
P
p
.2291 .17942 m .56008 .37966 L .54701 .38207 L 0 1 .313 r
F
P
p
.21366 .1835 m .2291 .17942 L .54701 .38207 L 0 1 .375 r
F
P
p
.2447 .1753 m .57325 .37723 L .56008 .37966 L 0 1 .219 r
F
P
p
.2291 .17942 m .2447 .1753 L .56008 .37966 L 0 1 .313 r
F
P
p
.26045 .17114 m .58652 .37479 L .57325 .37723 L .094 1 0 r
F
P
p
.2447 .1753 m .26045 .17114 L .57325 .37723 L 0 1 .219 r
F
P
p
.27635 .16694 m .59989 .37233 L .58652 .37479 L .469 1 0 r
F
P
p
.26045 .17114 m .27635 .16694 L .58652 .37479 L .094 1 0 r
F
P
p
.2924 .1627 m .61335 .36985 L .59989 .37233 L .563 1 0 r
F
P
p
.27635 .16694 m .2924 .1627 L .59989 .37233 L .469 1 0 r
F
P
p
.30861 .15842 m .62692 .36735 L .61335 .36985 L .594 1 0 r
F
P
p
.2924 .1627 m .30861 .15842 L .61335 .36985 L .563 1 0 r
F
P
p
.32497 .1541 m .64059 .36484 L .62692 .36735 L .625 1 0 r
F
P
p
.30861 .15842 m .32497 .1541 L .62692 .36735 L .594 1 0 r
F
P
p
.3415 .14973 m .65436 .3623 L .64059 .36484 L .781 1 0 r
F
P
p
.32497 .1541 m .3415 .14973 L .64059 .36484 L .625 1 0 r
F
P
p
.3582 .14532 m .66823 .35975 L .65436 .3623 L 1 1 0 r
F
P
p
.3415 .14973 m .3582 .14532 L .65436 .3623 L .781 1 0 r
F
P
p
.002 w
.4803 .77326 m .46706 .78164 L .11946 .53812 L p
0 1 .719 r
F P
0 0 0 r
s
P
p
.002 w
.46706 .78164 m .4535 .82704 L .10152 .58681 L p
0 .844 1 r
F P
0 0 0 r
s
P
p
.002 w
.10152 .58681 m .11946 .53812 L .46706 .78164 L p
0 .844 1 r
F P
0 0 0 r
s
P
p
.002 w
.4535 .82704 m .43941 .91037 L .08523 .60759 L p
0 .094 1 r
F P
0 0 0 r
s
P
p
.002 w
.08523 .60759 m .10152 .58681 L .4535 .82704 L p
0 .094 1 r
F P
0 0 0 r
s
P
p
.37505 .14086 m .68221 .35718 L .66823 .35975 L 1 .938 0 r
F
P
p
.3582 .14532 m .37505 .14086 L .66823 .35975 L 1 1 0 r
F
P
p
.002 w
.49358 .77225 m .4803 .77326 L .13584 .51717 L p
0 1 .594 r
F P
0 0 0 r
s
P
p
.002 w
.11946 .53812 m .13584 .51717 L .4803 .77326 L p
0 1 .719 r
F P
0 0 0 r
s
P
p
.39208 .13637 m .69629 .35458 L .68221 .35718 L 1 .938 0 r
F
P
p
.37505 .14086 m .39208 .13637 L .68221 .35718 L 1 .938 0 r
F
P
p
.002 w
.50695 .77123 m .49358 .77225 L .15181 .50535 L p
0 1 .5 r
F P
0 0 0 r
s
P
p
.002 w
.13584 .51717 m .15181 .50535 L .49358 .77225 L p
0 1 .594 r
F P
0 0 0 r
s
P
p
.40928 .13182 m .71048 .35197 L .69629 .35458 L 1 .813 0 r
F
P
p
.39208 .13637 m .40928 .13182 L .69629 .35458 L 1 .938 0 r
F
P
p
.002 w
.52043 .7702 m .50695 .77123 L .16836 .48419 L p
0 1 .406 r
F P
0 0 0 r
s
P
p
.002 w
.15181 .50535 m .16836 .48419 L .50695 .77123 L p
0 1 .5 r
F P
0 0 0 r
s
P
p
.42665 .12723 m .72478 .34934 L .71048 .35197 L 1 .625 0 r
F
P
p
.40928 .13182 m .42665 .12723 L .71048 .35197 L 1 .813 0 r
F
P
p
.002 w
.53401 .76917 m .52043 .7702 L .18454 .47218 L p
0 1 .375 r
F P
0 0 0 r
s
P
p
.002 w
.16836 .48419 m .18454 .47218 L .52043 .7702 L p
0 1 .406 r
F P
0 0 0 r
s
P
p
.4442 .1226 m .73919 .34669 L .72478 .34934 L 1 .531 0 r
F
P
p
.42665 .12723 m .4442 .1226 L .72478 .34934 L 1 .625 0 r
F
P
p
.002 w
.5477 .76812 m .53401 .76917 L .20041 .46937 L p
0 1 .375 r
F P
0 0 0 r
s
P
p
.002 w
.18454 .47218 m .20041 .46937 L .53401 .76917 L p
0 1 .375 r
F P
0 0 0 r
s
P
p
.46193 .11791 m .75371 .34401 L .73919 .34669 L 1 .406 0 r
F
P
p
.4442 .1226 m .46193 .11791 L .73919 .34669 L 1 .531 0 r
F
P
p
.002 w
.56149 .76707 m .5477 .76812 L .21643 .46654 L p
0 1 .313 r
F P
0 0 0 r
s
P
p
.002 w
.20041 .46937 m .21643 .46654 L .5477 .76812 L p
0 1 .375 r
F P
0 0 0 r
s
P
p
.002 w
.60273 .68065 m .58883 .6895 L .26618 .43897 L p
.469 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58883 .6895 m .57534 .75843 L .24971 .44198 L p
.094 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24971 .44198 m .26618 .43897 L .58883 .6895 L p
.094 1 0 r
F P
0 0 0 r
s
P
p
.47984 .11318 m .76835 .34132 L .75371 .34401 L 1 .281 0 r
F
P
p
.46193 .11791 m .47984 .11318 L .75371 .34401 L 1 .406 0 r
F
P
p
.002 w
.57534 .75843 m .56149 .76707 L .2334 .44495 L p
0 1 .219 r
F P
0 0 0 r
s
P
p
.002 w
.21643 .46654 m .2334 .44495 L .56149 .76707 L p
0 1 .313 r
F P
0 0 0 r
s
P
p
.002 w
.6168 .67926 m .60273 .68065 L .28348 .41705 L p
.563 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26618 .43897 m .28348 .41705 L .60273 .68065 L p
.469 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.2334 .44495 m .24971 .44198 L .57534 .75843 L p
0 1 .219 r
F P
0 0 0 r
s
P
p
.49793 .1084 m .78309 .3386 L .76835 .34132 L 1 .25 0 r
F
P
p
.47984 .11318 m .49793 .1084 L .76835 .34132 L 1 .281 0 r
F
P
p
.002 w
.63087 .67033 m .6168 .67926 L .30024 .41389 L p
.594 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28348 .41705 m .30024 .41389 L .6168 .67926 L p
.563 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64514 .66888 m .63087 .67033 L .31718 .4107 L p
.625 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30024 .41389 m .31718 .4107 L .63087 .67033 L p
.594 1 0 r
F P
0 0 0 r
s
P
p
.51621 .10357 m .79796 .33587 L .78309 .3386 L 1 .219 0 r
F
P
p
.49793 .1084 m .51621 .10357 L .78309 .3386 L 1 .25 0 r
F
P
p
.002 w
.6733 .62813 m .65901 .63724 L .35181 .39465 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65901 .63724 m .64514 .66888 L .33429 .40749 L p
.781 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33429 .40749 m .35181 .39465 L .65901 .63724 L p
.781 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31718 .4107 m .33429 .40749 L .64514 .66888 L p
.625 1 0 r
F P
0 0 0 r
s
P
p
.53468 .09869 m .81293 .33311 L .79796 .33587 L 1 .156 0 r
F
P
p
.51621 .10357 m .53468 .09869 L .79796 .33587 L 1 .219 0 r
F
P
p
.002 w
.68783 .62651 m .6733 .62813 L .36948 .38172 L p
1 .938 0 r
F P
0 0 0 r
s
P
p
.002 w
.35181 .39465 m .36948 .38172 L .6733 .62813 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.55335 .09376 m .82803 .33033 L .81293 .33311 L 1 .125 0 r
F
P
p
.53468 .09869 m .55335 .09376 L .81293 .33311 L 1 .156 0 r
F
P
p
.002 w
.70247 .62488 m .68783 .62651 L .38707 .37831 L p
1 .938 0 r
F P
0 0 0 r
s
P
p
.002 w
.36948 .38172 m .38707 .37831 L .68783 .62651 L p
1 .938 0 r
F P
0 0 0 r
s
P
p
.57221 .08878 m .84324 .32753 L .82803 .33033 L 1 .094 0 r
F
P
p
.55335 .09376 m .57221 .08878 L .82803 .33033 L 1 .125 0 r
F
P
p
.002 w
.71666 .60047 m .70247 .62488 L .40486 .37486 L p
1 .813 0 r
F P
0 0 0 r
s
P
p
.002 w
.38707 .37831 m .40486 .37486 L .70247 .62488 L p
1 .938 0 r
F P
0 0 0 r
s
P
p
.002 w
.73108 .58357 m .71666 .60047 L .42297 .36167 L p
1 .625 0 r
F P
0 0 0 r
s
P
p
.002 w
.40486 .37486 m .42297 .36167 L .71666 .60047 L p
1 .813 0 r
F P
0 0 0 r
s
P
p
.59127 .08374 m .85858 .32471 L .84324 .32753 L 1 .031 0 r
F
P
p
.57221 .08878 m .59127 .08374 L .84324 .32753 L 1 .094 0 r
F
P
p
.002 w
.746 .58176 m .73108 .58357 L .44111 .3581 L p
1 .531 0 r
F P
0 0 0 r
s
P
p
.002 w
.42297 .36167 m .44111 .3581 L .73108 .58357 L p
1 .625 0 r
F P
0 0 0 r
s
P
p
.61053 .07865 m .87403 .32186 L .85858 .32471 L 1 0 0 r
F
P
p
.59127 .08374 m .61053 .07865 L .85858 .32471 L 1 .031 0 r
F
P
p
.002 w
.76032 .55715 m .746 .58176 L .45953 .34472 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.002 w
.44111 .3581 m .45953 .34472 L .746 .58176 L p
1 .531 0 r
F P
0 0 0 r
s
P
p
.002 w
.77517 .54763 m .76032 .55715 L .47802 .34104 L p
1 .281 0 r
F P
0 0 0 r
s
P
p
.002 w
.45953 .34472 m .47802 .34104 L .76032 .55715 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.63 .07351 m .88961 .31899 L .87403 .32186 L 1 0 0 r
F
P
p
.61053 .07865 m .63 .07351 L .87403 .32186 L 1 0 0 r
F
P
p
.002 w
.79038 .54566 m .77517 .54763 L .49671 .33731 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.47802 .34104 m .49671 .33731 L .77517 .54763 L p
1 .281 0 r
F P
0 0 0 r
s
P
p
.64968 .06831 m .90532 .3161 L .88961 .31899 L 1 0 0 r
F
P
p
.63 .07351 m .64968 .06831 L .88961 .31899 L 1 0 0 r
F
P
p
.002 w
.80542 .53604 m .79038 .54566 L .5156 .33354 L p
1 .219 0 r
F P
0 0 0 r
s
P
p
.002 w
.49671 .33731 m .5156 .33354 L .79038 .54566 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.66957 .06306 m .92115 .31319 L .90532 .3161 L 1 0 0 r
F
P
p
.64968 .06831 m .66957 .06306 L .90532 .3161 L 1 0 0 r
F
P
p
.002 w
.82055 .52637 m .80542 .53604 L .5347 .32974 L p
1 .156 0 r
F P
0 0 0 r
s
P
p
.002 w
.5156 .33354 m .5347 .32974 L .80542 .53604 L p
1 .219 0 r
F P
0 0 0 r
s
P
p
.002 w
.83609 .52429 m .82055 .52637 L .554 .32589 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.5347 .32974 m .554 .32589 L .82055 .52637 L p
1 .156 0 r
F P
0 0 0 r
s
P
p
.66957 .06306 m .68968 .05774 L .92115 .31319 L 1 0 0 r
F
P
p
.002 w
.85142 .51451 m .83609 .52429 L .5735 .322 L p
1 .094 0 r
F P
0 0 0 r
s
P
p
.002 w
.554 .32589 m .5735 .322 L .83609 .52429 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.86684 .50468 m .85142 .51451 L .59323 .31806 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.5735 .322 m .59323 .31806 L .85142 .51451 L p
1 .094 0 r
F P
0 0 0 r
s
P
p
.002 w
.88273 .50249 m .86684 .50468 L .61317 .31409 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59323 .31806 m .61317 .31409 L .86684 .50468 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.89875 .50029 m .88273 .50249 L .63333 .31007 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.61317 .31409 m .63333 .31007 L .88273 .50249 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.91489 .49807 m .89875 .50029 L .65371 .306 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63333 .31007 m .65371 .306 L .89875 .50029 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.93117 .49583 m .91489 .49807 L .67432 .30189 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65371 .306 m .67432 .30189 L .91489 .49807 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67432 .30189 m .69517 .29774 L .93117 .49583 L p
1 0 0 r
F P
0 0 0 r
s
P
p
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.08509 .19367 m
.08465 .20033 L
s
P
[(0)] .08595 .18034 -0.06484 1 Mshowa
p
.002 w
.23498 .15292 m
.23469 .15959 L
s
P
[(10)] .23556 .13958 -0.04346 1 Mshowa
p
.002 w
.40002 .10806 m
.39989 .11474 L
s
P
[(20)] .40028 .0947 -0.01962 1 Mshowa
p
.002 w
.58262 .05842 m
.58267 .0651 L
s
P
[(30)] .58253 .04506 .00711 1 Mshowa
p
.001 w
.11395 .18582 m
.11371 .18982 L
s
P
p
.001 w
.14336 .17783 m
.14314 .18183 L
s
P
p
.001 w
.17332 .16968 m
.17311 .17368 L
s
P
p
.001 w
.20386 .16138 m
.20367 .16538 L
s
P
p
.001 w
.2667 .1443 m
.26655 .1483 L
s
P
p
.001 w
.29905 .1355 m
.29892 .13951 L
s
P
p
.001 w
.33204 .12654 m
.33192 .13054 L
s
P
p
.001 w
.36569 .11739 m
.36559 .1214 L
s
P
p
.001 w
.43505 .09854 m
.43499 .10254 L
s
P
p
.001 w
.4708 .08882 m
.47076 .09283 L
s
P
p
.001 w
.5073 .0789 m
.50728 .0829 L
s
P
p
.001 w
.54456 .06877 m
.54457 .07277 L
s
P
p
.001 w
.6215 .04785 m
.62155 .05186 L
s
P
p
.001 w
.66122 .03706 m
.6613 .04106 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{333, 317},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005=0001?@P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0CP000?mKCE/10000oe]=F`40003oFdeK
0@000?mKCE/10000oe]=F`40003oFdeK0@000?mKCE/10000oe]=F`40001jF`03oe_o00=K00CoFe]K
0ol015_oFol4F`05oe]KFol0^5/10000NU/00omKo`03F`04oe]Ko`=K0_l00e_oF`02F`03oe_o0;]K
0@0007YK00?oFol00e/01?mKFol4F`03oe_o00=K00?oFol0=E/4o`=K1?mkF`40001jF`03oe_o00=K
00CoFe_o15/00omKo`03F`03oe_o03AK00?oFe/00U/00omKo`04F`03oe]K07QK0@0007YK00?oFol0
0e/01?mKFol4F`03oe_o00=K00?oFol0=5/00omKF`02F`03oe_o00AK00?oFe/06E/3oeaK0@0007YK
00CoFooo0U/01?mKFol3F`;o00EKoe]Ko`03F`03oe]K03IK00?oFol015/00omKF`0EF`Co0U/00omK
F`1JF`40001jF`04oe_oF`;o15/3o`04FomKo`9K00GoFe]Ko`0eF`?o0U/00omKF`02F`03oe]K019K
0ol7F`03oe]K05UK0@0007YK00?oFe/02e/00omKF`0oF`03oe_o00AK00?oFe/03U/4o`]K00?oFe/0
F5/10000NU/00omKF`0;F`03oe_o03YK00?oFe/00U/00omKo`04F`03oe]K00YK1?l00e_oF`0=F`03
oe]K05MK0@000<EK00?oFe/00U/00omKo`04F`03oe]K00MK0ol5F`03oe]K00eK00?oFe/0EU/10000
aU/4o`=K1?l6F`Co6E/00omKF`1EF`40003CF`Go7E/00omKF`1DF`40003@F`?o15/00omKF`0KF`03
oe]K05AK0@000<aK1?lVF`03oe]K05=K0@000<QK1?l[F`03oe]K059K0@000<EK0ol3F`03oe]K01]K
0b<<F`03oe]K055K0@000<5K1?l6F`03oe]K01MK22<<F`03oe]K051K0@0008eK1_l2F`Co95/4ob5K
32<<F`03oe]K04mK0@0008eK00?oFe/015/00omKF`02F`03oe]K01eK1?l3F`03oe]K01aK42<<F`03
oe]K04iK0@0008iK00?oFe/00e/00omKF`02F`03oe]K01YK0olSFa@S2e/00omKF`1>F`40002?F`;o
0e/00omKF`02F`03oe]K01IK1?lQFaXS2e/00omKF`1=F`40002AF`04oe]Ko`AK00?oFe/04U/4o`9K
00?oFe/075/00elO8`0L8`]K00?oFe/0C5/10000TU/00omKo`04F`03oe]K00mK0olRF`HO7B<;F`03
oe]K04]K0@0008eK00?oFe/00U/00omKo`04F`03oe]K00]K1?lPF`HO00IO7elOGalM8`]K00?oFe/0
BU/10000SE/00omKF`02F`03oe_o00AK00?oFe/01e/4o`9K00?oFe/06e/02ElOGamO7elOG`087adS
2e/00omKF`19F`40002>F`Co0e/4o`MK0ol6F`03oe]K01QK00HOGamO7el97`06GamO7elO7B<;F`03
oe]K04QK0@0009aK1?lPF`AO00hOGamO7elOGamO7elOG`PO72<;F`03oe]K04QK0@0009QK1?l2F`03
oe]K01]K011O7emO7elOGamO7elOGamO2Al01UlOGamO7a`S2e/00omKF`17F`40002EF`?o1U/00omK
F`0HF`077elOGamO7`06G`0>7elOGamO7elOGamO7el87a`S2e/00omKF`16F`40002AF`Co7e/5G`07
7elOGamO7`02G`0<7elOGamO7elOGamO2Al01UlOGamO7a`S2e/00omKF`15F`40002=F`Co0U/00omK
F`0JF`0B7elO7elOGamO7elOGamO7elO1Ul03QmO7elOGamO7elOGamO21lL8`]K00?oFe/0A5/10000
GU/00omKF`02F`Co8U/4o`IK00?oFe/05e/>G`077elOGamO7`02G`0<7elOGamO7elOGamO2Al01UlO
GamO7a`S2e/00omKF`13F`40001NF`05oe]KFol015/00omKF`0LF`Co7e/55`067elOGamO0Ql03UlO
GamO7elOGamO7elO1Ul03QmO7elOGamO7elOGamO21lL8`]K00?oFe/0@U/10000GU/01OmKFe_o00AK
00?oFe/065/4o`=K00?oFe/06E/00aLA5`075`iO00LOGamO7elO009O00`OGamO7elOGamO7el97`06
GamO7elO72<:F`03oe]K049K0@0005iK00GoFe]Ko`04F`03oe]K01AK1?lPF`074ALA5a4G4@075`06
7elOGamO0Ql03UlOGamO7elOGamO7elO1Ul03QmO7elOGamO7elOGamO21lL8`YK00?oFe/0@E/10000
GU/01OmKFe_o00AK00?oFe/04E/3o`03FomK01iK11401QLA5a4G4@PG3Ul01amO7elOGal00Ul031mO
7elOGamO7elOG`TO00IO7elOGalL8`YK00?oFe/0@5/10000GU/01OmKFe_o00AK00?oFe/03E/4o`AK
00?oFe/05e/019lAWa47W`074ALA5a4G4@075`067elOGamO0Ql03UlOGamO7elOGamO7elO25l031mO
7elOGamO7elOG`PO72<:F`03oe]K03mK0@0005aK0ol3F`03oe]K009K00?oFe/02E/4oaiK1=l01Q7O
4MlAg`HA00HG4ALA5a495`mO00HOGamO7el27`0;GamO7elOGamO7el02Al01UlOGamO7a/S2e/00omK
F`0nF`40001NF`05oe]KFol015/00omKF`06F`?o00=Koe/075/01YoOWmnOg`:O00DAWa6O4@07W`07
4ALA5a4G4@085`06GamO7elO0Ul03AmO7elOGamO7elOGal025l031mO7elOGamO7elOG`PO6b<;F`03
oe]K03eK0@0005iK00?oFe/00U/4o`EK1?l4F`03oe]K01QK3=l01Q7O4MlAg`PA00HG4ALA5a475`mO
00HOGamO7el27`0=GamO7elOGamO7elOG`077`06GamO7elO6b<;F`03oe]K03aK0@0006QK1?lOF`<5
00bOgioOWmnOgioOWml2W`074IlAWa6O4@06W`065a4G4ALA21L01UlOGamO7`9O00dOGamO7elOGamO
7elO00QO00`OGamO7elOGamO7el87a/S2U/00omKF`0lF`40001UF`?o0e/00omKF`0JF`L53]l01Q7O
4MlAg`PA00HG4ALA5a475`mO00HOGamO7el27`0=GamO7elOGamO7elOG`077`06GamO7elO6b<:F`03
oe]K03]K0@00065K1?l5F`03oe]K01MK00GNgmkOgP071@0EWmnOgioOWmnOgioOWmlAWa6O4IlA00JO
00PG4ALA5a4G4@HG00IO7elOGal2G`0=7elOGamO7elOGamO7`08G`0<7elOGamO7elOGamO21lK8`YK
00?oFe/0>U/10000<E/4obQK1OlMF`CN00OOg]oNgmkO00P53Ml01Q7O4MlAg`PA00HG4ALA5a485`iO
00HOGamO7el27`0=GamO7elOGamO7elOG`077`06GamO7elO6b<:F`03oe]K03UK0@00031K00?oFe/0
0U/00omKF`0QF`Co15/00omKF`0GF`08LMiaLMiagW42gP06gmkOg]oN20D03MnOgioOWmnOgioOWml0
0Yl01A6O4IlA00NO00LA5a4G4ALA00LG00HOGamO7el27`0<GamO7elOGamO7elO25l031mO7elOGamO
7elOG`PO6b<:F`03oe]K025K1?l00e_oF`04o`9K00GoFe]Ko`03F`7o0E/10000<5/00omKF`02F`03
oe]K01iK0ol8F`03oe]K01AK3Mh02=oNgmkOg]oN1`D?g`064MlAga7O1Q401QLA5a4G4@PG3Ul01QmO
7elOG`8O00eO7elOGamO7elOGamO00LO00IO7elOGalK8`YK00?oFe/07e/00omKF`02F`?o15/00omK
o`03F`03oe]K00=K0@00031K00?oFe/00U/00omKF`0JF`Co00=Koe/075/5L@06gW7NLMia0]h0377N
LMiagmkOg]oNg`P500bOgioOWmnOgioOWml2W`054IlAWa401il01a4G4ALA5a401aL01QmO7elOG`8O
00aO7elOGamO7elOGal8G`0<7elOGamO7elOGamO21lK8`YK00?oFe/07E/00omKF`04F`;o1U/01OmK
Fe_o00EK0@00031K00?oFe/00U/00omKF`0FF`Co1E/00omKF`0FF`03LMia01KN00OOg]oNgmkO00L5
3]l01Q7O4MlAg`PA00HG4ALA5a465`iO00HOGamO7el27`0=GamO7elOGamO7elOG`077`06GamO7elO
6b<:F`03oe]K01aK00?oFe/015/7o`03FomK009K00?oFe/00e/10000<5/00omKF`02F`03oe]K01=K
1?lMF`>E00IagW7NLMh7L@06gW7NLMia0]h01G7NLMia00;N00KOg]oNgmh71@0EWmnOgioOWmnOgioO
WmlAWa6O4IlA00JO00HG4ALA5a485`05GamO7el00Ql03UlOGamO7elOGamO7elO1Ul03QmO7elOGamO
7elOGamO1QlJ8`YK00?oFe/075/01?mKFe/5o`AK00?oFol00e/00omKF`03F`40000`F`03oe]K009K
00?oFe/03e/4o`=K00?oFe/06E/03MbEg9GLUG7NLMiagW405=h01moNgmkOg]l020D=g`064MlAga7O
21401QLA5a4G4@LG3El01amO7elOGal00Ul031mO7elOGamO7elOG`LO00IO7elOGalJ8`YK00?oFe/0
6e/00omKF`05F`03oe]K009K00CoFooo0U/00omKF`03F`40000`F`03oe]K009K00?oFe/02e/4ob1K
00CLk=c/1iD01MiagW7N00Ua00GNLMiagP02L@04gW7NL@;N00OOg]oNgmkO00L501COWmnOgioOWmnO
gioO4IlAWa6O4@JO00HG4ALA5a485`06GamO7elO0Ul03AmO7elOGamO7elOGal01Ul03QmO7elOGamO
7elOGamO1QlJ8`YK00?oFe/06U/00omKF`04F`03oe_o00?o0U/01?mKool6F`40000aF`Co2e/3o`9K
00?oFe/06U/02NcLk=c/g>cLk002g00<UMbEg9GLgW7NLMia5]h01]oNgmkOgPL53Ml0217O4MlAga7O
1Q401QLA5a4G4@LG3el01AmO7elO009O00`OGamO7elOGamO7el77`06GamO7elO6R<:F`03oe]K01YK
00?oFe/00U/00omKF`0@F`40000lF`Co1E/00omKF`0EF`Bg1^`01mc/g>cLk=`01iD01W7NLMiagPMa
00KNLMiagW42gP0<LMiagW7Og]oNgmkO20D039oOWmnOgioOWmnOg`:O00DAWa6O4@07W`074ALA5a4G
4@065`06GamO7elO0Ul03AmO7elOGamO7elOGal01Ul03QmO7elOGamO7elOGamO1QlJ8`YK00?oFe/0
6U/4oa=K0@0003QK1OlLF`0T]nbgk;O/]nbgk=c/g>cLk=c/g>cLk9GLUMbEg9EagW7NLMia5=h01moN
gmkOg]l01`D>g`064MlAga7O1Q401QLA5a4G4@LG3el01AmO7elO009O00`OGamO7elOGamO7el77`06
GamO7elO6R<:F`03oe]K031K0@0003EK0ol4F`03oe]K01QK3KL7k006g>cLk=c/1iD01MiagW7N00Ma
00ONLMiagW7N009a00CNLMia0]h01]oNgmkOgPL500bOgioOWmnOgioOWml2W`054IlAWa401il01a4G
4ALA5a401aL01AmO7elO009O00dOGamO7elOGamO7elO00IO00hOGamO7elOGamO7elOG`HO6R<:F`03
oe]K02mK0@00035K1?lOF`Bg01W/]nbgk;O/]nbgk;O/g>cLk=c/g>cLk=c/00;L00bEg9GLUMcNLMia
gW4DgP07gmkOg]oNg`081@gO00HAga7O4Ml84@045a4G4@PG3Ul01AmO7elO009O00`OGamO7elOGamO
7el77`06GamO7elO6R<9F`03oe]K02mK0@0002mK0_l2F`03oe]K01UK1;HD]`S/00GLk=c/g007U@06
LMiagW7N1g401]iagW7NL@;N00aagW7NLMoNgmkOg]l71@0DgioOWmnOgioOWmnOga6O4IlAWa46W`06
5a4G4ALA1aL01QmO7elOG`8O00aO7elOGamO7elOGal6G`0>7elOGamO7elOGamO7el67aXS2E/00omK
F`0^F`40000_F`05oe]KFol05U/4]P06]kJg][Nf2;L09nbgk;O/]nbgk;O/]ncLk=c/g>cLk=c/g>bE
g9GLUMbELMiagW7NL@0DgP06gmkOg]oN20D<g`064MlAga7O21401QLA5a4G4@HG3Ul01AmO7elO009O
00`OGamO7elOGamO7el77`06GamO7elO6R<9F`03oe]K02eK0@0002mK0ol00h5KF`0AF`04]_bfo0bf
5;L7k006g>cLk=c/1iD01MiagW7N00Ma00KNLMiagW42gP05LMiagW400]h01]oNgmkOgPL501>OgioO
WmnOgioOWmlAWa6O4IlA00JO00HG4ALA5a475`067elOGamO0Ql035lOGamO7elOGamO7`QO00`OGamO
7elOGamO7el67aXS2E/00omKF`0/F`40000OF`Co0e/4o`EK0X400e^1F`0>F`093L`=][Ff]KJe00Nf
00Jg][Nf]kH6]`0Ik;O/]nbgk;O/]nbgk;O/g>cLk=c/g>cLk002g00<UMbEg9GLgW7NLMia5=h01moN
gmkOg]l01`D>g`064MlAga7O1Q401QLA5a4G4@LG3El01QmO7elOG`8O00]O7elOGamO7elOG`077`06
GamO7elO6R<9F`03oe]K02]K0@0001iK00?oFe/00U/00omKo`04F`03oe]K009K00CoFh613E/7c005
o;Kl]_`03[HC]`S/00GLk=c/g007U@06LMiagW7N1g401MiagW7N009a00CNLMia0]h01]oNgmkOgPP5
00_OWmnOgioOWmnOg`02W`054IlAWa401il01A4G4ALA00PG00EO7elOG`027`0<GamO7elOGamO7elO
25l031mO7elOGamO7elOG`HO6B<:F`03oe]K02YK0@0002=K00?oFol015/00omKF`02F`03oe]K00>1
25/4C00>c0g<3L`=c;Ff]KJe][D7]P04]kJg]PRg02O/]nbgk;O/]nbgk;O/g>cLk=c/g>cLk=c/UMbE
g9GLUG7NLMiagW405=h01]oNgmkOgPL53Ml01Q7O4MlAg`HA00HG4ALA5a475`eO00HOGamO7el27`0;
GamO7elOGamO7el01al01UlOGamO7aTS2U/00omKF`0YF`40000JF`?o1U/00omKo`04F`03oe]K009K
00CoFe^10U/00h5KF`04F`07C8a<S4b<C007c006]_bfo;Kl3KHC]`O/00KLk=c/g>`7U@05gW7NLMh0
1g401]iagW7NL@;N00aagW7NLMoNgmkOg]l71@0BgioOWmnOgioOWmnOga6O4IlA1il01a4G4ALA5a40
1QL01ElOGamO008O00aO7elOGamO7elOGal8G`0<7elOGamO7elOGamO1QlI8`UK00?oFe/0:E/10000
7U/00omKF`02F`03oe_o00AK00?oFe/00U/01?mKFh43F`:11U/6C00=3L`=c0g<3Lbe][Ff]@07]P06
]kJg][Nf2;L05nbgk;O/]nbgk;O/]ncLk=c/g>cLk=c/00;L00bEg9GLUMcNLMiagW4DgP06gmkOg]oN
20D<g`064MlAga7O214011LA5a475`eO00HOGamO7el27`0;GamO7elOGamO7el01al01UlOGamO7aTS
2E/00omKF`0XF`40000NF`Go0U/00omKF`02F`03oe]K009K00CoFe^11E/2P@EK00N<C8a<S4b<00S<
00Jfo;Kl]_`<]QBg1n`01Mc/g>cL00NE00IagW7NLMh7L@05gW7NLMh00W401=iagW42gP06gmkOg]oN
1`D04ioOWmnOgioOWmnOga6O4IlAWa401Yl01QLA5a4G4@HG00IO7elOGal2G`0;7elOGamO7elOGal0
25l031mO7elOGamO7elOG`HO6B<9F`03oe]K02MK0@0001iK00?oFe/015/00omKF`02F`05oe]KFol0
0e/00h5KF`05F`:11E/7C00=3L`=c0g<3KJe][Ff]@07]P06]kJg][Nf1[L09Nbgk;O/]nbgk;O/]ncL
k=c/g>cLk=c/g>bEg9GLUMbELMiagW405=h01moNgmkOg]l01`D<g`064MlAga7O214011LA5a485`iO
00@OGamO0Ql02elOGamO7elOGamO00LO00IO7elOGalI8`UK00?oFe/09U/100007e/00omKF`03F`03
oe]K009K00GoFe]Ko`03F`03PE]K00MK0X45F`07S4b<C8a<S007c005o;Kl]_`03[HC]`K/00KLk=c/
g>`7U@05gW7NLMh01g401]iagW7NL@;N00]agW7NLMoNgmkOgP081@0;gioOWmnOgioOWml00Yl01A6O
4IlA00JO00HG4ALA5a475`057elOGal00Ul02amO7elOGamO7elO00QO00`OGamO7elOGamO7el67aTS
2E/00omKF`0UF`40000OF`Go0U/4o`AK00CoFe^135/00h5KF`04F`I<00k<3L`=c0g<3KJe][Ff]@Nf
00Bg][Nf2;L05nbgk;O/]nbgk;O/]ncLk=c/g>cLk=c/00;L00bEg9GLUMcNLMiagW4DgP06gmkOg]oN
1`D=g`064MlAga7O1Q401QLA5a4G4@HG3Ul011mO7el27`0;GamO7elOGamO7el01al01UlOGamO7aTS
2E/00omKF`0TF`40000^F`04oe]KP@eK0X46F`06S4b<C8a<1l`01[Kl]_bfo0ff4kL7k005g>cLk=`0
1iD01W7NLMiagPMa00GNLMiagP02L@04gW7NL@;N00GOg]oNg`071@0;gioOWmnOgioOWml00Yl01A6O
4IlA00NO00DA5a4G4@075`057elOGal00Ul02amO7elOGamO7elO00QO00`OGamO7elOGamO7el67aTS
2E/00omKF`0SF`40000^F`04oe]KP@mK0X45F`M<00c<3L`=c0g<]KJe][D7]P06]kJg][Nf2;L08nbg
k;O/]nbgk;O/g>cLk=c/g>cLk=c/UMbEg9GLUG7NLMia01CN00OOg]oNgmkO00L53=l01Q7O4MlAg`HA
00HG4ALA5a465`iO00DOGamO7`02G`0<7elOGamO7elOGamO1Al01UlOGamO7aTS25/00omKF`0SF`40
000^F`04oe]KPA5K0X45F`07C8a<S4b<C007c006]_bfo;Kl3;HC]`K/00KLk=c/g>`7U@05gW7NLMh0
1g401MiagW7N009a00CNLMia0]h01]oNgmkOgPL501>OgioOWmnOgioOWmlAWa6O4IlA00FO00LA5a4G
4ALA00HG00EO7elOG`027`0<GamO7elOGamO7elO1Ul031mO7elOGamO7elOG`HO6B<8F`03oe]K029K
0@0002iK0_l00e^1F`0BF`:11E/6C00=3L`=c0g<3Lbe][Ff]@07]P06]kJg][Nf1[L05nbgk;O/]nbg
k;O/]ncLk=c/g>cLk=c/00;L00bEg9GLUMcNLMiagW4DgP05gmkOg]l01`D<g`064MlAga7O1Q401QLA
5a4G4@LG3El01AmO7elO009O00`OGamO7elOGamO7el57`06GamO7elO62<9F`03oe]K025K0@0002iK
00CoFe^15E/2P@EK00I<S4b<C8`7c005o;Kl]_`03[HB]`O/00GLk=c/g007U@06LMiagW7N1g401=ia
gW42gP0<LMiagW7Og]oNgmkO1`D04]nOgioOWmnOgioO4IlAWa6O4@JO00HG4ALA5a465`05GamO7el0
0Ql035lOGamO7elOGamO7`IO00`OGamO7elOGamO7el67aPS2E/00omKF`0PF`40000^F`04oe]KPAMK
00>1Fe/00e/7C00=3L`=c0g<3KJe][Ff]@07]P04]kJg]PRg02?/]nbgk;O/]nbgk;O/g>cLk=c/g>cL
k9GLUMbEg9EagW7NL@0DgP06gmkOg]oN1`D=g`044MlAg`PA00@G4ALA1aL=G`057elOGal00Ul031mO
7elOGamO7elOG`LO00AO7elO62<9F`03oe]K01mK0@0002iK00CoFe^165/2P@EK00N<C8a<S4b<00O<
00Gl]_bfo00=]Q:g1^`01]c/g>cLk0NE00GNLMiagP07L@05gW7NLMh00W401=iagW42gP05gmkOg]l0
1`D02mnOgioOWmnOgioO00:O00DAWa6O4@06W`065a4G4ALA1QL01ElOGamO008O00aO7elOGamO7elO
Gal6G`0<7elOGamO7elOGamO1QlH8`UK00?oFe/07U/10000;U/01?mKFh4JF`:11E/7C00;3L`=c0g<
3KJe][D01kH01[Nf]kJg]PJg01O/]nbgk;O/]nbgk;O/g>cLk=c/g>cLk002g00<UMbEg9GLgW7NLMia
4]h01moNgmkOg]l01`D<g`064MlAga7O1Q401QLA5a4G4@DG3El01AmO7elO009O00`OGamO7elOGamO
7el77`04GamO7aPS2E/00omKF`0MF`40000^F`04oe]KPAaK0X42F`09PE]KS4b<C8a<00O<00Jfo;Kl
]_`<]Q:g1n`01Mc/g>cL00NE00IagW7NLMh7L@04gW7NL@;N00]agW7NLMoNgmkOgP071@0:WmnOgioO
WmnOg`:O00DAWa6O4@07W`054ALA5a401aL01AmO7elO009O00/OGamO7elOGamO7`06G`0<7elOGamO
7elOGamO1QlH8`QK00?oFe/07E/10000;U/01?mKFh4NF`>115/6C00<c0g<3L`=c;Ff]KJe1kH01[Nf
]kJg]PJg02?/]nbgk;O/]nbgk;O/g>cLk=c/g>cLk9GLUMbEg9EagW7NL@0DgP05gmkOg]l01`D<g`06
4MlAga7O1Q401QLA5a4G4@HG35l01AmO7elO009O00`OGamO7elOGamO7el77`04GamO7aPS25/00omK
F`0LF`40000^F`04oe]KPB1K00>1Fe/00e/01db<C8a<S4`01l`01[Kl]_bfo0bf4KL8k004g>cLk0NE
00GNLMiagP07L@05gW7NLMh00W402miagW7Og]oNgmkO00L501;OWmnOgioOWmnOga6O4IlAWa45W`05
4ALA5a401aL01AmO7elO009O00/OGamO7elOGamO7`08G`0:7elOGamO7elOG`HO62<8F`03oe]K01]K
0@0002iK00CoFe^185/3P@EK1d`03<`=c0g<3KJe][Ff]@Nf00Bg][Nf2;L05Nbgk;O/]nbgk;O/g>cL
k=c/g>cLk002g00<UMbEg9GLgW7NLMia4]h01]oNgmkOgPL52ml01Q7O4MlAg`HA00HG4ALA5a465`iO
00@OGamO0Ql02elOGamO7elOGamO00LO00AO7elO62<8F`03oe]K01YK0@0002eK00GoFe]KP@0PF`03
PE]K00:11E/01Tb<C8a<S0O<00Gl]_bfo00=]Q:g1^`01Mc/g>cL00NE00IagW7NLMh7L@03gW7N009a
00CNLMia0]h01]oNgmkOgPH501;OWmnOgioOWmnOga6O4IlAWa46W`065a4G4ALA1AL01AmO7elO009O
00/OGamO7elOGamO7`08G`0:7elOGamO7elOG`HO62<8F`03oe]K01UK0@0002eK00GoFe]KP@0PF`03
PE]K009K0X45F`I<00d=c0g<3L`=][Ff]KJe00Ff00Jg][Nf]kH6]`0Gk;O/]nbgk;O/]nbgk=c/g>cL
k=c/g>`00]`02YGLUMbELMiagW4DgP05gmkOg]l01`D<g`044MlAg`PA00@G4ALA1aL=G`047elOG`8O
00]O7elOGamO7elOG`077`04GamO7aPS25/00omKF`0HF`40000]F`05oe]KFh4085/00h5KF`04F`:1
15/01ha<S4b<C8`01l`01Obfo;Kl00bf4[L7k004g>cLk0NE00GNLMiagP07L@04gW7NL@;N00]agW7N
LMoNgmkOgP071@0:WmnOgioOWmnOg`:O00DAWa6O4@06W`065a4G4ALA1QL01ElOGamO008O00YO7elO
GamO7elO25l02QmO7elOGamO7el67aLS2E/00omKF`0GF`40000]F`04oe]KPB5K00>1Fe/01U/2P@AK
1d`02`g<3L`=c;Ff]KJe00Nf00Jg][Nf]kH6]`0Sk;O/]nbgk;O/]ncLk=c/g>cLk=c/g>bEg9GLUMcN
LMiagW404]h01]oNgmkOgPH53=l01Q7O4MlAg`HA00@G4ALA1aL=G`047elOG`8O00]O7elOGamO7elO
G`077`04GamO7aLS25/00omKF`0GF`40000]F`;o00=KPE/085/00h5KF`08F`03PE]K00=K00J<C8a<
S4`7c006]_bfo;Kl3;HA]`K/00GLk=c/g007U@06LMiagW7N1g400miagP02L@04gW7NL@;N00GOg]oN
g`071@0@gioOWmnOgioOWmlAWa6O4@NO00DA5a4G4@065`05GamO7el00Ql02UlOGamO7elOGal8G`0:
7elOGamO7elOG`HO5b<8F`03oe]K01IK0@0002eK00CoFe^18E/00h5KF`09F`:11E/6C00<c0g<3L`=
c;Ff]KJe1kH01;Nf]kH8]`0Ek;O/]nbgk;O/]ncLk=c/g>cLk=c/00;L00ZEg9GLUG7NLMia4]h01]oN
gmkOgPL52ml01Q7O4MlAg`HA00HG4ALA5a455`eO00@OGamO0Ql02elOGamO7elOGamO00LO00AO7elO
5b<8F`03oe]K01EK0@0002eK00CoFe^18E/00h5KF`0;F`:11E/01Xa<S4b<C0O<00Bfo;Kl3KHA]`O/
00CLk=c/1iD01MiagW7N00Ma00CNLMia0]h02g7NLMiagmkOg]oN00H501;OWmnOgioOWmnOga6O4IlA
Wa45W`054ALA5a401QL01ElOGamO008O00YO7elOGamO7elO25l02QmO7elOGamO7el67aLS25/00omK
F`0DF`40000]F`04oe]KPB1K00>1Fe/03U/2P@AK1d`03<`=c0g<3KJe][Ff]@Ff00Jg][Nf]kH6]`0S
k;O/]nbgk;O/]nbgk=c/g>cLk=c/g>bEg9GLUMcNLMiagW404]h01MoNgmkO00L52]l01Q7O4MlAg`HA
00HG4ALA5a435`Co2el011mO7el27`0;GamO7elOGamO7el01al015lOGalG8`QK00?oFe/04e/10000
;E/01?mKFh4PF`03PE]K011K0X44F`06C8a<S4b<1l`01Obfo;Kl00bf4KL6k005g>cLk=`01iD01W7N
LMiagPEa00GNLMiagP02L@0:gW7NLMoNgmkOgPL500ZOgioOWmnOgioO0Yl01A6O4IlA00JO00@G4ALA
0ol48`04oelOG`8O00YO7elOGamO7elO25l02QmO7elOGamO7el67aLS25/00omKF`0BF`40000]F`04
oe]KPB1K00>1Fe/04U/00h5KF`03F`I<00/=c0g<3L`=][Ff]@07]P06]kJg][Nf1[L05Nbgk;O/]nbg
k;O/g>cLk=c/g>cLk002g00:UMbEg9EagW7NLA;N00KOg]oNgmh61@cO00@Aga7O1A45o`PS00?oGel0
2El011mO7el27`0;GamO7elOGamO7el01al015lOGalG8`QK00?oFe/04E/10000;E/01?mKFh4PF`03
PE]K01=K0X45F`06C8a<S4b<1/`01[Kl]_bfo0bf4;L7k004g>cLk0NE00GNLMiagP07L@04gW7NL@;N
00=agW400]h01MoNgmkO00L500WOWmnOgioOWml00Yl00a6Oo`05o`hS00GoGamO7`02G`0;7elOGamO
7elOGal01Ul02QmO7elOGamO7el67aLS1E/4PA9K0@0002eK00CoFe^185/00h5KF`0EF`:10U/00h5K
C006C00;3L`=c0g<]KJe][D01kH01;Nf]kH6]`0Sk;O/]nbgk;O/]nbgk=c/g>cLk=c/g>bEg9GLUMcN
LMiagW404]h01MoNgmkO00H51]l6oaDS00?oGel02El01AmO7elO009O00XOGamO7elOGamO1al015lO
GalG8`B15U/10000;E/01?mKFh4PF`03PE]K01MK0h43F`06S4b<C8a<1l`01;Kl]_`=]Q2g1^`01Mc/
g>cL00NE00IagW7NLMh5L@04gW7NL@;N00]agW7NLMoNgmkOgP071@Co72<01OmO7elO009O00/OGamO
7elOGamO7`06G`0:7elOGamO7elOG`HO5b<IF`40000]F`04oe]KPB1K00>1Fe/06E/2P@AK1T`03<`=
c0g<3Lbe][Ff]@Ff00Jg][Nf]kH6]`0Ek;O/]nbgk;O/]ncLk=c/g>cLk=c/00;L00ZEg9GLUG7NLMia
4]h01MoNgmkO00<50ol00amO7`0E8`03ob<S00HS0_l:G`057elOGal00Ul02QmO7elOGamO7el77`04
GamO7a@S6e/10000;E/01?mKFh4PF`03PE]K01UK00>1Fh401E/01Xa<S4b<C0K<00Gl]_bfo00<]Q2g
1n`01=c/g>`7U@05gW7NLMh01g400miagP02L@04gW7NL@;N00?Oool00ol77`hS00?o8b<03R<01?lO
Gal2G`0;7elOGamO7elOGal01Ul02QmO7elOGamO7el67`hS85/10000;5/01OmKFe^1021K00>1Fe/0
6E/00h5KF`02P@AK1d`02/`=c0g<3KJe][D7]P06]kJg][Nf1[L08Nbgk;O/]nbgk;O/g>cLk=c/g>cL
k9GLUMbEg=iagW7NL@0;gPKo1Al02ElOGamO7elOo`0N8`03oemO00YO00<OGal00Ul02QmO7elOGamO
7el77`04GamO7`PS9E/10000;5/01OmKFe^1021K00>1Fe/06E/00h5KF`02F`:115/01Tb<C8a<S0O<
00Gl]_bfo00<]Q2g1N`01Mc/g>cL00NE00AagW7N1G46o`0<7elOGamO7elOGamO2AlE8`03ob<S00HS
00Go7elOG`027`0:GamO7elOGamO7`IO00XOGamO7elOGamO1Ql38bUK0@0002aK0ol00e^1F`0OF`03
PE]K01UK00>1Fe/015/2P@AK1T`02`g<3L`=c0ff]KJe00Nf00Bg][Nf1[L05Nbgk;O/]nbgk;O/g>cL
k=c/g>cLk002g007UMbEg9EagP06o`0<7elOGamO7elOGamO1al02OlOGamO7elOG`078`03ob<S00@S
00?o8b<012<00olS8`068`03oemO00YO00<OGal00Ul02QmO7elOGamO7el37`=K00>1Fe/0;E/10000
;5/01OmKFe^1021K00>1Fe/06E/00h5KF`06F`:115/01Tb<C8a<S0K<00Bfo;Kl3KH@]`K/00GLk=c/
U@06o`04GamO7`QO00hOGamO7elOoamO7elOG`TO00?o8b<012<00olS8`0;8`03ob<S00HS0_l00elO
G`027`0:GamO7elOGamO7`IO00<OGal01e/00h5KF`0]F`40000/F`04oe]KPB5K00>1Fe/06E/00h5K
F`08F`:115/6C00;3L`=c0g<]KJe][D01kH01;Nf]kH6]`0@k;O/]nbgk;O/]ncLk=c/g0Co1El01QmO
7elOG`8O00eO7elOGaoo7elOGamO00PO00WoGamO7elOGol03R<00olS8`048`03ob<S00HS00?oGel0
2El00amO7`02G`037emK00]K00>1Fe/0;E/10000;5/01?mKFh4QF`03PE]K01UK00>1Fe/02U/00h5K
F`02F`06S4b<C8a<1l`01;Kl]_`<]Q2g00K/oooo7el27`0>GamO7elOGamO7elOGol8G`0>7elOGamO
7elOGamO7ol87`03ob<S00@S00?o8b<012<00olS8`048`03ob<S00HS00CoGamO0Ql01elOGamO7el0
4E/00h5KF`0]F`40000/F`04oe]KPB5K00>1Fe/06E/00h5KF`0;F`:115/6C00:c0g<3L`=][Ff]@Nf
00Jg][Nf]kH4]`07k;O/]nbgk004o`iO00OoGamO7elO009O00hOGamO7elOGamO7elOo`LO00UO7elO
GamO7ol01R<00olS8`048`03ob<S00@S00?o8b<01R<00omOG`05GaEK00>1Fe/0;E/10000;5/01?mK
Fh4QF`03PE]K01UK00>1Fe/03E/2P@AK00J<C8a<S4`6c005o;Kl]_`03;H5]`Co11L065lOGamO7elO
oelOGamO7elOGamO7elOo`IO013o7elOGamOoelOGamO7eoo1al00olS8`058`03ob<S00@S00?o8b<0
0b<2o`LS00?oGe/06E/00h5KF`0]F`40000/F`04oe]KPB5K00>1Fe/06E/00h5KF`0?F`:115/6C00:
c0g<3L`=][Ff]@Nf00Bg][Nf1;L00olG4@075a5O01HOGamO7eoo7elOGamO7elOGamO7eoo1Ql02_lO
GamO7elOGol68`03ob<S00@S00?o8b<012<00olS8`058`03oe]K01QK00>1Fe/0;E/10000;5/01?mK
Fh4QF`03PE]K01UK00>1Fe/04E/2P@=K00M<S4b<C8a<00K<00?l]_`03;H2o`054ALA5a401QL02?lO
GamO7elO0Ul03AmO7elOGomO7elOGal025l04?mO7elOGaoo7elOGamO7ol77`03ob<S00@S00?o8b<0
12<00olS8`048`03ob<S00DS0_lHF`03PE]K02eK0@0002aK00CoFe^18E/00h5KF`0HF`03PE]K01AK
00>1Fh400U/6C00;3L`=c0g<]KJe][D01kH02kOo4ALA5a4G4AOo00HG25l00omOG`04G`0FoamO7elO
GaooGamO7elOoamO7elOG`;o1Ql02?mO7elOGamO0_l58`;o1B<2o`DS00?o8b<01R<00omKF`0FF`03
PE]K02aK0@0002aK00CoFe^185/00h5KF`0IF`03PE]K01EK0X44F`06C8a<S4b<1/`01;Kl]_`3]PCo
00/G4ALA5a4G4ALAo`065`08oelOGamO7el27`0>GamO7elOoamO7elOGol8G`0>7elOGamOoelOGamO
7ol87`03ob<S00@S00?o8b<012<00olS8`038`;o1b<00omKF`0EF`03PE]K02aK0@0002aK00CoFe^1
85/00h5KF`0IF`03PE]K01IK0h44F`I<00L=c0g<3Lbe00Co1Q402QLA5a4G4ALA5ol65`03oemO00IO
00?oGel015l05omO7elOGamOoamO7elOGomO7elOGaoo00HO0_l021mO7elOGaoo1R<00olS8`048`03
ob<S00@S00?o8b<01B<00omKF`0DF`03PE]K02aK0@0002aK00CoFe^185/00h5KF`0IF`03PE]K01IK
00>1Fe/00X44F`06C8a<S4b<1<`00onO4@08W`0<5a4G4ALA5a4G4AOo1QL03elOGamO7elOoelOGamO
7`02o`07GamO7elOo`06G`0@oamO7elOGomO7elOGamOo`LO0_l58`;o1B<2o`DS00?o8b<01B<00omK
F`0CF`03PE]K02aK0@0002aK00CoFe^185/00h5KF`0IF`03PE]K01IK00>1Fe/00U/2P@=K1T`02<`=
omlAga7O21402aLA5a4G4ALA5a7o00HG00?oGel01El00omOG`05G`0EoamO7elOGolOGamO7elOoamO
7elO00;o1Ql02_lOGamO7elOGol68`03ob<S00@S00?o8b<00b<00olS8`058`;o4e/00h5KF`0/F`40
000[F`?o00=KPE/07e/00h5KF`0IF`03PE]K01IK00>1Fe/015/2P@=K00b<C8a<S?nO4IlAWa49W`0;
4ALA5a4G4ALA5ol01QL05olOGamO7elOGolOGamO7eooGamO7elO00;o1Ul03_mO7elOGaoo7elOGamO
0_l77`03ob<S00@S00?o8b<012<00olS8`038`;o1b<00omKF`0@F`03PE]K02aK0@0002]K00GoFe]K
P@0PF`03PE]K01UK00>1Fe/05U/00h5KF`06F`04PE]KF`Co00[O4MlAga7O4Moo1a402aLA5a4G4ALA
5a7o00LG00?oGel01El00omOG`04G`0GoamO7elOGaooGamO7elOoamO7elOGol01al02OmO7elOGamO
o`068`03ob<S00@S00?o8b<012<00olS8`058`03oe]K00mK00>1Fe/0;5/10000:e/01OmKFe^1021K
00>1Fe/06E/00h5KF`0FF`03PE]K00EK1Ol019oOWml2W`094IlAWa6O4IlA00NO00[o5a4G4ALA5a4G
0_l65`08oelOGamO7el2o`05GamO7el00_l01amO7elOGol01el01_lOGamO7`;o00MO7elOGaoo00LO
0_l58`;o1B<2o`DS00?o8b<01B<00omKF`0>F`03PE]K02aK0@0002]K00GoFe]KP@0PF`03PE]K01UK
00>1Fe/05U/0185KFe/4o`cO00XAga7O4MlAga7o1Q403?lA5a4G4ALA5a4Go`HG00?oGel01Ul00omO
G`04G`07oelOGamO7`02o`0>7elOGamOoelOGamO7ol67`;o00POGamO7elOo`HS00?o8b<012<00olS
8`038`03ob<S00DS00?oFe/03E/00h5KF`0/F`40000[F`05oe]KFh4085/00h5KF`0IF`03PE]K01IK
00B1Fe_o0`D039oOWmnOgioOWmnOg`:O00XAWa6O4IlAWa7o1il02aLA5a4G4ALA5a7o00HG0_l05amO
7elOGaooGamO7elOoamO7elOGaoo00IO0_l03UlOGamOoelOGamO7eoo1al00olS8`048`03ob<S00@S
00?o8b<00b<00olS8`058`03oe]K00aK00>1Fe/0;5/10000:e/01OmKFe^1021K00>1Fe/06E/00h5K
F`0FF`03PE_o00D53Ml02olAga7O4MlAga7o00LA00_o5a4G4ALA5a4Go`075`03oemO00EO0_l5G`;o
01DOGamO7eoo7elOGamO7olOGamO7ol01al02?lOGamO7elO0_l58`;o1B<00olS8`038`;o1R<2o`aK
00>1Fe/0;5/10000:e/01?mKFh4QF`03PE]K01UK00>1Fe/05U/00h7o1@061@0GWmnOgioOWmnOgioO
WolAWa6O4IlAWa400_l6W`0:oa4G4ALA5a4G4@;o1QL05olOGamO7elOGolOGamO7eooGamO7elO00;o
1Ul01_mO7elOG`;o00HOGamO7el2o`LO00?o8b<012<00olS8`038`;o1B<00olS8`058`03oe]K00UK
00>1Fe/0;5/10000:e/01?mKFh4QF`03PE]K01UK00>1Fe/05E/2o`T500?ogml02ml02ooO4MlAga7O
4Moo00LA00/G4ALA5a4G4ALAo`065`;o1el00omOG`04G`0?oamO7elOGaooGamO7elO00;o00IO7elO
Gol77`09oelOGamO7eoo00HS00?o8b<012<00olS8`038`03ob<S00DS00?oFe/025/00h5KF`0/F`40
000[F`04oe]KPB5K00>1Fe/06E/00h5KF`0DF`04omkOgPX501SOWmnOgioOWmnOgioOoilAWa6O4IlA
Wol7W`0;oaLA5a4G4ALA5ol01aL02?mO7elOGamO0_l03UlOGamOoelOGamO7eoo1el03olOGamO7olO
GamO7elOo`077`;o1B<00olS8`048`03ob<S00<S00?o8b<01B<00omKF`07F`03PE]K02aK0@0002]K
00CoFe^18E/00h5KF`0IF`03PE]K019K0_l01MoNgmkO00X53Ml02ooO4MlAga7O4Moo00LA00_o4ALA
5a4G4ALAo`075`03oemO00IO00?oGel00el2o`06GamO7elO0_l031mO7elOGomO7elOG`;o1Ql2o`08
7elOGamO7ol58`;o1B<2o`@S0_l68`03oe]K00IK00>1Fe/0;5/10000:e/01?mKFh4QF`03PE]K01UK
00>1Fe/04E/02OoOg]oNgmkOgP0:1@0GgioOWmnOoioOWmnOgonO4IlAWa6O4Il00_l6W`0;oaLA5a4G
4ALA5ol01aL2o`0G7elOGamO7omO7elOGaoo7elOGamO7ol01Ul2o`0>GamO7eooGamO7elOGol77`03
ob<S00@S00?o8b<012<00olS8`038`03ob<S00@S0_l6F`03PE]K02aK0@0002]K00CoFe^18E/00h5K
F`0IF`03PE]K00iK1?l02]oNgmkOg]oNgol91@03omoO00?O00?ogml01=l03?oO4MlAga7O4MlAo`LA
00Wo5a4G4ALA5a400_l75`03oemO00EO00?oGel015l05omO7elOGamOoamO7elOGaoo7elOGaoo00LO
00So7elOGamO7`;o1B<00olS8`048`03ob<S00<S00?o8b<01B<00omKF`03F`03PE]K02aK0@0002]K
00CoFe^18E/00h5KF`0IF`03PE]K00UK1Ol03miagW7og]oNgmkOg]oNg`091@0=oioOWmnOgioOWmnO
g`02o`0:4IlAWa6O4IlAo`NO00_o4ALA5a4G4ALAo`075`08oamO7elOGal2o`057elOGal00_l01UlO
GamO7`;o1Ul03_mO7elOGomO7elOGamO0_l77`03ob<S00<S0_l58`03ob<S00<S00?o8b<01B<00omK
F`02F`03PE]K02aK0@0002]K00CoFe^18E/00h5KF`0IF`03PE]K00AK1Ol:gP0;omoNgmkOg]oNgmh0
2PD=g`0;oa7O4MlAga7O4Ol01a42o`094ALA5a4G4AOo00LG0_l7G`03oemO00AO00oo7elOGamO7omO
7elOGal00_l015lOGal2o`LO00WoGamO7elOGol01R<00olS8`038`;o12<2o`HS00GoFe]KP@0^F`40
000QF`Co1U/2P@03oh5K021K00>1Fe/06E/0185KFe/3o`Ea00CNLMia0]h04G7NLMiaomkOg]oNgmkO
g]oo00T501OogioOWmoogioOWmnOoa6O4IlAWa6O4@02o`NO00[o5a4G4ALA5a7o21L06?mO7elOGamO
oamO7elOGomO7elOGamOo`MO00oo7elOGaoo7elOGamO7ol01al00olS8`048`03ob<S00@S00?o8b<0
0b<00olS8`048`04oe]KPBiK0@00021K00?oFe/00U/00omKF`02F`03oe]K00>185/00h5KF`0IF`05
PE]KFol04mh03?oOg]oNgmkOg]oNg`T500?ogml00ml00ooOg`04g`0<oa7O4MlAga7O4Moo1a402_lA
5a4G4ALA5ol85`03oemO00EO0_l5G`;o00IO7elOGal2o`0=7elOGamOoelOGamOo`077`08oelOGamO
7el2o`DS00?o8b<012<00olS8`038`03ob<S00@S00CoFe^1;E/1000085/00omKF`02F`03oe]K009K
00KoFe]KPE/2PAeK00>1Fe/06U/01h5KFooNLMh01g401=iagW42gP05LMiagW400_l02moNgmkOg]oN
gmko00P501WogioOWmnOgioOWmnOoa6O4IlAWa6O4Ioo00NO00Wo5a4G4ALA5a400_l75`;o01LOGamO
7elOoelOGamO7olOGamO7elOo`06G`;o00AO7elO0_l01UlOGamO7`;o1al00olS8`038`;o1B<00olS
8`038`03ob<S00@S0_l00h5KF`0[F`40000PF`03oe]K009K00?oFe/00U/01OmKFe^100=K0h4JF`03
PE]K01YK00N1FooNLMia00gN00?og]h01=h03?oNgmkOg]oNgmkOo`T500?ogml00ml00ooOg`03g`;o
00[O4MlAga7O4Moo1a42o`095a4G4ALA5a7o00PG00?oGel01El00omOG`04G`0GoelOGamO7eoo7elO
GamO7olOGamO7ol01al02OlOGamO7elOo`068`03ob<S00<S0_l48`03ob<S00DS00?oFe/0:e/10000
85/00omKF`02F`03oe]K009K00GoFe]KP@06F`:165/00h5KF`0JF`09POoNLMiagW7N00Ia00KogW7N
LMh2L@0AgW7NLMkogmkOg]oNgmkOg_l02@D05onOgioOWonOgioOWmooWa6O4IlAWa6O00;o1il02_lA
5a4G4ALA5ol85`08oamO7elOGal2o`0=7elOGaoo7elOGamO7`02o`IO00ooGamO7eooGamO7elOGol0
1al2o`DS00?o8b<012<00olS8`028`;o1R<00omKF`0ZF`40000PF`03oe]K009K00?oFe/00U/01OmK
Fe^100QK0h4EF`03PE]K01YK00_ogW7NLMiagW7No`0BgP0=omkOg]oNgmkOg]oNo`081@03omoO00?O
00?ogml01=l03?oO4MlAga7O4MlAo`LA00[o5a4G4ALA5a7o21L2o`MO00?oGel00el2o`0D7elOGamO
7omO7elOGaoo7elOGal2o`HO0_l025lOGamO7eoo1B<2o`DS00?o8b<00b<00olS8`048`03oe]K02UK
0@00021K00?oFe/00U/00omKF`02F`05oe]KFh402e/2PA=K00>1Fe/06E/03?oNLMiagW7NLMiagPMa
01WNLMiagW7ogW7NLMkogmkOg]oNgmkOg]oo00P501WoWmnOgiooWmnOgioOoilAWa6O4IlAWa7o00NO
0_l021LA5a4G4AOo2AL06?mO7elOGamOoamO7elOGomO7elOGamOo`IO0_l03QmO7elOoamO7elOGaoo
1al00olS8`048`03ob<S00<S00?o8b<00b<00olS8`048`03oe]K02QK0@00021K00?oFe/00U/00omK
F`02F`05oe]KFh403E/2PA5K00>1Fe/05U/3o`0>gW7NLMiagW7NLMiagW46gP03omkN00?N00?og]h0
0mh2o`0;gmkOg]oNgmkOg_l020D2o`GO00?ogml00ml03?oO4MlAga7O4MlAo`PA00So4ALA5a4G4@;o
21L00omOG`05G`;o1El05olOGamO7elOoelOGamO7eooGamO7eoo00LO00SoGamO7elOG`;o1B<00olS
8`038`;o12<00olS8`048`;o:5/100008E/4o`EK00CoFe^145/3P@iK00>1Fe/03U/8o`BE00oNLMia
gW7NLMiagW7NLOl01G406?magW7NLOoNLMiagW7og]oNgmkOg]oNg`;o20D06?oOWmnOgooOWmnOgonO
4IlAWa6O4IlAo`RO00[o5a4G4ALA5a7o21L2o`0=7elOGamO7omO7elOG`02o`067elOGamO0_l6G`0>
oamO7elOoamO7elOGal2o`LO00?o8b<00b<00olS8`048`03ob<S008S0_l68`03oe]K02EK0@0002YK
00CoFe^14e/2P@aK00>1Fe/03U/07?oLk=c/g>cog9GLUMcNLMiagW7NLMiagW7NLOl5gP03omkN00[N
00gogmkOg]oNgmkOg]oo00P500?ogml00ml00ooOg`03g`;o00TAga7O4MlAga400_l74@0:oa4G4ALA
5a4Go`TG00?oGel01El00omOG`04G`0?oelOGamO7eoo7elOGamO00;o00@OGamO0_l77`09oamO7elO
Gaoo00DS0_l58`03ob<S00<S00?o8b<012<00omKF`0TF`40000ZF`04oe]KPAEK0h49F`03PE]K00eK
00[ok>c/g>cLk=co1ID03omagW7NLMiagW7NLMiao`07L@0HgW7NLMkoLMiagW7og]oNgmkOg]oNgmko
20D06OoOWmnOgooOWmnOgioo4IlAWa6O4IlAWol01il2o`084ALA5a4G4Ol95`0HoamO7elOGaooGamO
7elOoamO7elOGaoo1el03omO7elOGomO7elOGamOo`077`03ob<S00@S00?o8b<00b<2o`@S00?o8b<0
12<00omKF`0SF`40000ZF`04oe]KPAQK0X47F`03PE]K00aK01oog>cLk=c/g>cLk?oLUMbEg9EagW7N
LMiagW7NLMia00ON00?og]h00mh00ooNgP03gP0<omoNgmkOg]oNgmkO0_l71@;o1Ml00ooOg`03g`0<
oa7O4MlAga7O4Moo21402OlG4ALA5a4Go`095`03oemO00EO0_l5G`08oelOGamO7el2o`0=GamO7elO
oamO7elOo`077`;o00IO7elOGal2o`DS00?o8b<012<00olS8`028`03ob<S00@S00?oFe/08U/10000
:U/01?mKFh4JF`>115/00h5KF`0;F`03onc/00G/00KLk=c/g?l6U@0?LMiagW7NLMiagW7NLMko00Ea
00cogW7NLMkoLMiagW42o`0<gmkOg]oNgmkOg]oo20D06?nOgioOWonOgioOWolAWa6O4IlAWa6Oo`RO
00So4ALA5a4G4@;o21L2o`0=GamO7elOGolOGamO7`02o`08GamO7elOGol6G`;o00@OGamO0_l021mO
7elOGaoo1al00olS8`038`;o1B<00olS8`028`;o1B<00omKF`0QF`40000ZF`04oe]KPAeK0X42F`03
PE]K00]K02Cok=c/g>cLk=c/g>cLk?oLUMbEg9GogW7NLMiagW7NLMiag_l5gP03omkN00?N0_l5gP0=
omkOg]oNgmkOg]oNo`081@03omoO00?O00?ogml00ml02olAga7O4MlAga7O00;o1a42o`084ALA5a4G
4Ol95`03oemO00EO00?oGel015l05olOGamO7elOoelOGamO7eooGamO7eoo00LO00WoGamO7elOGol0
1R<00olS8`038`03ob<S00<S00?o8b<00b<2ob5K0@0002YK0_l00e^1F`0NF`>135/00oo/k008k006
g>cLk=co1YD03ooNLMiagW7NLMiagW7No`05L@;o01QagW7NLOoNLMiag_oOg]oNgmkOg]oNgol81@0<
oioOWmnOoioOWmnO0_l02ilAWa6O4IlAWa7o00RO00Wo5a4G4ALA5ol02AL02?mO7elOGamO0_l03ElO
GamOoelOGamO7el00_l6G`0>oamO7elOoamO7elOGal2o`HO0_l58`03ob<S00<S0_l48`03ob<S00@S
00?oFe/07U/10000:U/01?mKFh4QF`>11e/3o`0Wk=c/g>cLk=c/g>cLk=c/g>cog9GLUMbEg?magW7N
LMiagW7NLMia00KN00?og]h00mh00ooNgP03gP0<omkOg]oNgmkOg]oN0_l71@03omoO00?O0_l5g`0<
omlAga7O4MlAga7o21402OlA5a4G4ALAo`095`;o1el00omOG`03G`;o00iO7elOGamOoamO7elOG`;o
00DOGamOo`087`09oamO7elOGaoo00DS00?o8b<012<00olS8`028`03ob<S00@S00?oFe/07E/10000
:E/01OmKFe^1025K00>1Fe/00X45o`Bg3>`01]c/g>cLo`NE00ooLMiagW7NLMiagW7NLOl01G406_ma
gW7NLOoNLMiag_oOg]oNgmkOg]oNgmko1`D2o`0GgioOWmoogioOWmooWa6O4IlAWa6O4Ol029l2o`06
4ALA5a4G0_l95`0HoamO7elOGaooGamO7elOoamO7elOGaoo1el01OmO7elO00;o00QO7elOGamOo`LO
00?o8b<00b<2o`DS00?o8b<00R<2o`DS00?oFe/075/10000:E/01OmKFe^1025K00>1ool00_l0<^bg
k;O/]nbgk;O/g>cLk=c/g>cLk=c/g>cLk?oLUMbEg9GLog7NLMiagW7NLMiagW7o1Mh00ooNgP03gP03
omkN00?N0_l03=oNgmkOg]oNgmkOo`P500?ogml00ml00ooOg`03g`0;omlAga7O4MlAga400_l84@09
oaLA5a4G4AOo00TG00?oGel01El2o`EO00SoGamO7elOG`;o00eO7elOGaoo7elOGaoo00LO0_l01UlO
GamO7`;o1B<00olS8`038`03ob<S00<S00?o8b<00b<00omKF`0KF`40000YF`05oe]KFh4085/2o`ng
3>`01]c/g>cLo`RE00kogW7NLMiagW7NLMiao`Ea00KoLMiagW42o`0BLMiagW7og]oNgmkOg]oNgmko
20D06OoOWmnOgooOWmnOgonO4IlAWa6O4IlAWol029l02OlA5a4G4ALAo`095`;o00eO7elOGamOoamO
7elO00;o00QO7elOGamOo`IO0_l03QmO7eooGamO7elOGaoo1al00olS8`038`03ob<S00<S0_l48`03
ob<S00<S0_lKF`40000YF`05oe]KFh407e/00ong]`04]`0ck;O/]nbgk;O/]nbgk=c/g>cLk=c/g>cL
k=c/g>cog9GLUMbEg9GogW7NLMiagW7NLMia00;o1=h2o`GN00?og]h00mh03?oOg]oNgmkOg]oNg`;o
1`D00ooOg`03g`;o1=l03OoO4MlAga7O4MlAgol021402OlG4ALA5a4Go`0:5`03oemO00EO00?oGel0
15l05OlOGamO7elOoelOGamO7eooGamO7`02o`LO00WoGamO7elOGol01B<2o`DS00?o8b<00R<00olS
8`048`03oe]K01QK0@0002UK00GoFe]KP@0NF`03okNg01:g3>`01]c/g>cLo`RE0_l03G7NLMiagW7N
LMiag_l01G406_oNLMiag_magW7NLOoNgmkOg]oNgmkOg]oo1`D2o`0:WmnOgiooWmnOg`;o00/AWa6O
4IlAWa6Oo`08W`;o00LG4ALA5a7o00XG00SoGamO7elOG`;o00eO7elOGomO7elOGamO00;o1Ul03olO
GamO7olOGamO7elOo`077`;o1B<00olS8`038`03ob<S008S00?o8b<012<00omKF`0GF`40000YF`05
oe]KFh407U/00onf]`07]`0ek;O/]nbgk;O/]nbgk=c/g>cLk=c/g>cLomc/g>cog9GLUMbEg9GLog7N
LMiagW7NLMiag_l01Mh00ooNgP03gP03omkN00?N00kogmkOg]oNgmkOg]oNo`P500?ogml00ml00ooO
g`03g`0<oa7O4MlAga7O4Moo2A401olA5a4G4AL00_l95`;o1el00omOG`03G`0@oamO7elOGamOoamO
7elOG`;o00DOGamOo`077`;o00POGamO7elOo`DS00?o8b<00b<2o`<S0_l58`03oe]K01IK0@0002UK
00GoFe]KP@0MF`04okJf]QBg3>`01_o/g>cLo`VE00koLMiagW7NLMiagW7No`Ea00cogW7NLMkoLMia
gW42o`0<gmkOg]oNgmkOg]oo20D05onOgioOWonOgioOWolAWa6O4IlAWa6O00;o29l02OlG4ALA5a4G
o`0:5`0>oamO7elOGaooGamO7el2o`087elOGamO7ol7G`0?oelOGaoo7elOGamO7eoo00LO00?o8b<0
0b<00olS8`048`03ob<S008S00?o8b<00b<00omKF`0EF`40000YF`05oe]KFh4075/01_nf]kJg]PRg
03G/]nbgk;Oo]nbgk;Oog>cLk=c/g>cLk=cog>cLk?oLUMbEg9GLUMcoLMiagW7NLMiagW7No`05gP03
omkN00?N0_l5gP0<omkOg]oNgmkOg]oN0_l71@03omoO00?O00?ogml00ml03OlAga7O4MlAga7O4Ol0
2142o`075a4G4ALAo`0:5`03oemO00EO00?oGel015l02?mO7elOGamO0_l02elOGamO7olOGamO00;o
1al02OlOGamO7elOo`058`;o1B<00olS8`028`03ob<S00<S00?oFe/055/10000:E/01?mKFh4LF`03
okJf00Ff2;L00ong]`03]`03okNg00>g00?ok>`02N`01_o/g>cLo`VE0_l02miagW7NLMiagW7N00;o
1742o`0ILMiagW7ogW7NLMkogmkOg]oNgmkOg]oNo`071@06oioOWmnO0_l04MnOgioo4IlAWa6O4IlA
Wa7o00VO00So4ALA5a4Go`XG0_l01UlOGamO7`;o00lOGamO7olOGamO7elOGol01Ul2o`0<7elOGomO
7elOGamO0_l67`;o1B<00olS8`038`03ob<S008S00Co8b<S0olEF`40000YF`04oe]KPAaK00[o]kJg
][Nf]kKo1kL0=_ngk;O/]ongk;O/]ncLk=c/g>cLk=c/g?oLk=c/ombEg9GLUMbEg9GogW7NLMiagW7N
LMiao`GN00?og]h00mh00ooNgP03gP0>omkOg]oNgmkOg]oNgol71@;o1Ml00ooOg`02g`;o00_O4MlA
ga7O4MlAo`094@08oaLA5a4G4Ol;5`03oemO00EO00?oGel00el2o`0E7elOGamO7omO7elOGamOoelO
Gaoo00PO00WoGamO7elOGol01B<01?lS8b<:o`AK1H4?F`40000YF`04oe]KPA]K00?o][H02KHD]`_/
00Kok=c/g?l:U@0>omiagW7NLMiagW7NLOl5L@0Iog7NLMiaomiagW7NomoNgmkOg]oNgmkOgP02o`L5
01OogioOWmoogioOWmooWa6O4IlAWa6O4@02o`RO00Oo4ALA5a4G00;o2QL06?mO7elOGamOoamO7elO
GomO7elOGamOo`MO00Go7elOG`02o`087elOGamO7ol77`04ob<S8`Go1e/7PAAK0@0002UK0_l00e^1
F`0HF`;o00bg][Nf]kJg][Nf]kH:]`0Vk;O/]nbgk;O/]ncLk=c/g>cLk=c/g?oLk=c/ombEg9GLUMbE
g9D2o`0<LMiagW7NLMiagW7o1Mh00ooNgP03gP03omkN00?N0_l03MoNgmkOg]oNgmkOg_l01`D00ooO
g`03g`03omoO00?O00goga7O4MlAga7O4Moo00PA0_l01a4G4ALA5ol02QL2o`IO0_l5G`08oamO7elO
Gal2o`067elOGamO0_l01AmO7eoo00LO0_l01AmO7elO00Co15/8PA]K0@0002UK00CoFe^165/00onf
]P0>]Pjg00?o]kL00kL;k006oncLk=co2iD03OmagW7NLMiagW7NLOl01G401_magW7NL@;o01=agW7N
LOoNgmkOg]oNgmkOg]oo00L500KogioOWml2o`0AWmnOgonO4IlAWa6O4IlAWol02Il02?lG4ALA5a7o
2aL06?lOGamO7elOoelOGamOoelOGamO7elOo`MO00ooGamO7olOGamO7elOGol00al00on1P@06PB=K
0@0002UK00CoFe^15e/00onf]P03]P0<]kJg][Nf]kJg][Nf2KL0=?o/]nbgk?o/]nbgk?o/g>cLk=c/
g>cLomc/g>cog9GLUMbEg9GLUMcoLMiagW7NLMiagW42o`CN0_l5gP03omkN00?N00kogmkOg]oNgmkO
g]oNo`L50_l5g`03omoO00;O00goga7O4MlAga7O4Moo00TA00So4ALA5a4Go`/G00?oGel01El00omO
G`03G`;o01EO7elOGamOoamO7elOGaoo7elOGol021l01?lOoh4[F`40000YF`04oe]KPAIK00?o][H0
4[H00ong]`05]`03okNg00>g00?o]kL00kL00oo/k008k006oncLk=co2iD2o`0<gW7NLMiagW7NLMko
1G406OoNLMiag_magW7NLOoNgmkOg]oNgmkOg]l00_l71@0GoioOWmnOoioOWmooWa6O4IlAWa6O4Il0
0_l8W`;o00HA5a4G4Ol;5`;o00IO7elOGal2o`0=7elOGaoo7elOGamO7`02o`IO0_l00amO7`02o`06
GamO7elO0_l00h5KF`0ZF`40000XF`05oe]KFh405E/00onf]P07]P0>okJg][Nf]kJg][Nf]ol7]`0f
onbgk;O/onbgk;O/oncLk=c/g>cLk=cog>cLk?oLUMbEg9GLUMbEg9GogW7NLMiagW7NLMko1Mh00ooN
gP03gP03omkN00?N00oogmkOg]oNgmkOg]oNgol01`D00ooOg`03g`03omoO00;O0_l0317O4MlAga7O
4MlAo`TA00Ko5a4G4AL2o`/G00?oGel01El00omOG`03G`0GoelOGamO7elOoelOGamO7eooGamO7ol0
0al2o`9K00>1Fe/0:U/10000:5/01OmKFe^101EK00?oo;H05[H7]`03okNg00>g00?o]kL00kL00oo/
k008k006oncLk=co39D03OoNLMiagW7NLMiag_l01G403?oNLMiag_magW7NL@;o00gOg]oNgmkOg]oN
gmko00L501WoWmnOgiooWmnOgioo4IlAWa6O4IlAWa7o00VO00So4ALA5a4Go`/G00koGamO7elOGolO
GamO7`;o00QO7elOGamOo`MO00So7elOGomOo`AK00>1Fe/0:U/10000:5/01OmKFe^101AK00Co]KJe
2kH03;Nf]kJg][Nf]kJg]PRg02S/]nbgk?o/]nbgk?o/g>cLk=c/g>cLomc/g>cog9GLUMbEg9GLUMbE
0_l02W7NLMiagW7NLMh2o`CN00?og]h00mh2o`GN00kog]oNgmkOg]oNgmkOo`L500?ogml00ml2o`CO
00go4MlAga7O4MlAga7o00TA00So5a4G4ALAo`/G00?oGel01El2o`EO00So7elOGamO7`;o00DOGamO
7`07o`EK00>1Fe/0:U/10000:5/01OmKFe^101=K00Ooo;Kl]_co00Vf00?o][H02[H00ong]`0:]`;o
1KL:k006oncLk=co3ID03OmagW7NLMiagW7NLOl01742o`0HLMiagW7ogW7NLMkogmkOg]oNgmkOg]oN
0_l61@;o01OOWmnOgooOWmnOoa6O4IlAWa6O4IlAo`09W`;o00HG4ALA5ol;5`;o01LOGamO7elOoelO
GamOoelOGamO7elOo`03G`03oe]K00YK00>1Fe/0:U/10000:5/01OmKFe^1019K00So]KJe][Ff]@^f
00fg][Nf]kJg][Nf]kKo00Ng03Ko]nbgk;Oo]nbgk;O/g>cLk=c/g>cLomc/g>cog9GLUMbEg9GLUMbE
g?magW7NLMiagW7NLOl5gP03omkN00?N00?og]h00mh03ooNgmkOg]oNgmkOg]oNo`071@03omoO00?O
00?ogml00]l03?lAga7O4MlAga7O4@;o2A401olA5a4G4Ol031L00omOG`05G`03oemO00=O00co7elO
GamO7eoo7ol=F`03PE]K02YK0@000003FomK00AK00CoFe]K0_l00e_oF`0HF`05oe]KFh404E/02_ol
]_bfo;Kl]_`G]P03okNg00Fg00?o]kL00kL00ong]`03]`03onc/00O/00Kok=c/g?l=U@0=og7NLMia
gW7NLMiao`05L@0Kog7NLMiaomiagW7NomoNgmkOg]oNgmkOg]oo00L500_ogioOWmoogioOW`02o`0<
Wa6O4IlAWa6O4Ioo2Il01_lG4ALA5`;o2aL03_lOGamO7elOoelOGamO0_l01QmO7elOG`;o3U/00h5K
F`0ZF`4000000e_oF`04F`05oe]KFol075/01OmKFe^1011K00ko]KJe][Ff]KJe][Ffo`Vf00co][Nf
]kJg][Nf]kH8]`0YokO/]nbgokO/]nbgomc/g>cLk=c/g?oLk=c/ombEg9GLUMbEg9GLUM`00_l02mia
gW7NLMiagW7o00GN00?og]h00mh00ooNgP03gP;o00cOg]oNgmkOg]oNgmh2o`H500?ogml00ml2o`CO
00goga7O4MlAga7O4Moo00TA0_l01QLA5a4Go`/G0_l6G`;o1El01?mO7el2oa1K00>1Fe/0:U/10000
00=Koe/015/01OmKFe_o01aK00GoFe]KP@0@F`0?olcl]_bfo;Kl]_bfo;Kl00Vf00?o][H02[H7]`03
okNg00>g00?o]kL00kL00oo/k007k006oncLk=co3YD02ooNLMiagW7NLMia00;o17401_magW7NL@;o
01AagW7NLOoNgmkOg]oNgmkOg]oNo`H50_l05ioOWmnOoioOWmooWa6O4IlAWa6O4Ioo00ZO00Oo4ALA
5a7o00`G017oGamO7elOGolOGamO7olOo`0BF`03PE]K02YK0@000003FomK00AK00GoFe]Ko`0LF`05
oe]KFh403e/04_o<3Lbe][Ff]KJe][Ff]KJeo`Zf00bg][Nf]kJg][Nf]ol6]`0gokO/]nbgokO/]nbg
omc/g>cLk=c/g?oLk=c/ombEg9GLUMbEg9GLUMbEomiagW7NLMiagW7No`04gP;o1Mh00ooNgP03gP0?
omoNgmkOg]oNgmkOg]oo00L500?ogml00ml00ooOg`02g`0<omlAga7O4MlAga7O0_l94@07oaLA5a4G
o`0<5`03oemO00EO00CoGemO0olCF`03PE]K02YK0@000003Fooo00Go0e/00omKF`0JF`04oe]KPA1K
00?oc<`00l`03;Kl]_bfo;Kl]_bfo0Zf00?o][H02KH00ong]`04]`03okNg00>g00?o]kL00kL00oo/
k007k005oncLk=`00_l=U@;o00]agW7NLMiagW7No`05L@0KomiagW7Nog7NLMiaomkOg]oNgmkOg]oN
gmko00L501WoWmnOgiooWmnOgonO4IlAWa6O4IlAWa7o00VO00Ko4ALA5a42o`/G0_l01AmO7elO00Co
5U/00h5KF`0ZF`4000000e_oF`04F`05oe]KFol075/2o`03Fh5K00mK01?oc0g<3L`=][Ff]KJe][Ff
]KJe00Zf00go]kJg][Nf]kJg][Oo00Ng03Kok;O/]ongk;O/]ooLk=c/g>cLk=cog>cLk=coUMbEg9GL
UMbEg9GLUMcoLMiagW7NLMiag_l5gP03omkN00?N00?og]h00mh03_oOg]oNgmkOg]oNgmkO0_l61@03
omoO00?O00?ogml00]l03_oO4MlAga7O4MlAga7o2A42o`064ALA5a7o31L01OmOGeoo01]K00>1Fe/0
:E/1000000=Koe/015/00omKF`03oa]K00CoFe^13e/00oo<c006c00>oobfo;Kl]_bfo;Kl]_l9]P03
okJf00Rf00?o]kL01KL00ong]`02]`03okNg00>g00?ok>`01n`01oo/g>cLk?l03YD03?magW7NLMia
gW7No`Ea00cogW7NLMkoLMiagW42o`0>gmkOg]oNgmkOg]oNgol61@06oioOWmnO0_l00mnOg`02o`0<
4IlAWa6O4IlAWa7o2Yl01olG4ALA5ol031L00olOo`0LF`03PE]K02UK0@000003FomK00QK00?oFe/0
6U/01?mKFh4?F`0Ho`g<3L`=c0g<3Lbe][Ff]KJe][Ff]KJe2KH03Onf]kJg][Nf]kJg]_l01[L02oo/
]nbgokO/]nbg00;o01g/g>cLk=c/g?oLk=c/g?nEg9GLUMbEg9GLUMbEg002o`09gW7NLMiagW7N00;o
1=h00ooNgP03gP;o1Mh03ooNgmkOg]oNgmkOg]oNo`061@;o1Ml00ooOg`02g`0<oa7O4MlAga7O4MlA
0_l94@07oa4G4ALAo`0<5`03oe]K01]K00>1Fe/0:E/1000000=Kool01Ol3F`03oe]K01YK00CoFe^1
3e/00oo<c009c00>okKl]_bfo;Kl]_bfo?l8]P03okJf00Vf00?o]kL01;L00ong]`02]`;o1KL00oo/
k006k007oncLk=c/o`0?U@0<omiagW7NLMiagW7o17407?oNLMiagW7ogW7NLMkogmkOg]oNgmkOg]oN
gol71@0IomnOgioOomnOgioo4IlAWa6O4IlAWa6Oo`09W`;o00DA5a4Go`0;5`03oe]K01]K00>1Fe/0
:E/10000:5/01?mKFh4>F`0Lol`=c0g<3L`=c0g<3L`=okFf]KJe][Ff]KJeo`Rf0_l02kNf]kJg][Nf
]kKo00Jg03Ook;O/]ncok;O/]ncok=c/g>cLk=cog>cLk=coUMbEg9GLUMbEg9GLUMbEomiagW7NLMia
gW7o00CN0_l5gP03omkN00?N00kog]oNgmkOg]oNgmkOgP;o1PD00ooOg`03g`03omoO00;O00ko4MlA
ga7O4MlAga7Oo`XA00Go5a4G4@02o`PG00?oFe/075/00h5KF`0YF`40000XF`04oe]KP@iK00?oc<`0
3L`03?ol]_bfo;Kl]_bfo0Zf00?o][H02;H00ong]`04]`03okNg00>g00?o]kL00kL00oo/k006k007
oncLk=c/o`0?U@0<omiagW7NLMiagW7o1G407?magW7NLOoNLMiag_oOg]oNgmkOg]oNgmkOg_l61@06
omnOgioO0_l04IoOWolAWa6O4IlAWa6O4Ioo00ZO00Oo4ALA5a7o00HG00?oFe/07E/00h5KF`0YF`40
000WF`05oe]KFh403U/07oo<3L`=c0g<3L`=c0g<3L`=c?nf]KJe][Ff]KJe]_l02;H02ong][Nf]kJg
][Nf00;o1KL2o`0Y]nbgk?o/]nbgk?o/g>cLk=c/g?oLk=c/g?nEg9GLUMbEg9GLUMbEg9D00_l02W7N
LMiagW7NLOl5gP03omkN00?N00?og]h00mh2o`0>gmkOg]oNgmkOg]oNgol61@;o1Ml01?oOgml2o`0;
ga7O4MlAga7O4Ml00_l94@07oaLA5a4Go`045`03oe]K01iK00>1Fe/0:E/100009e/01OmKFe^100eK
00?oc<`04L`03Onfo;Kl]_bfo;Kl]_l02;H2o`Zf00?o]kL01;L00ong]`02]`03okNg00>g00?ok>`0
1^`01oo/g>cLk?l049D02_magW7NLMiagW42o`Aa00KoLMiagW42o`0CLMiagW7og]oNgmkOg]oNgmkO
gP02o`H501WoWmnOgiooWmnOgonO4IlAWa6O4IlAWa7o00VO0_l01ALA5a7o00<G00?oFe/07U/00h5K
F`0YF`40000WF`05oe]KFh403E/05Ol=c0g<3L`=c0g<3L`=c0g<3L`=c002o`0<]KJe][Ff]KJe][Go
2;H03?nf]kJg][Nf]kJgo`Jg03Oo]nbgk?o/]nbgk?o/g>cLk=c/g?oLk=c/g?nEg9GLUMbEg9GLUMbE
g9GLog7NLMiagW7NLMko00CN00?og]h01=h00ooNgP03gP0@omoNgmkOg]oNgmkOg]oNo`H500?ogml0
0ml00ooOg`02g`0>omlAga7O4MlAga7O4Ol:4@08oa4G4AOo5olQF`03PE]K02UK0@0002MK00GoFe]K
P@0=F`03olc<01C<00goo;Kl]_bfo;Kl]_co00Rf00?o][H02;H00ong]`04]`03okNg00:g00?o]kL0
0kL00oo/k006k007oncLk=c/o`0@U@;o00[NLMiagW7NLMko1742o`0KgW7NLMkoLMiagW7og]oNgmkO
g]oNgmkOg]oo00H501WoWmnOgiooWmnOgonO4IlAWa6O4IlAWa7o00ZO00?o5a400olRF`03PE]K02UK
0@0002MK00GoFe]KP@0<F`0Iol`=c0g<3L`=c0g<3L`=c0g<3L`=c0g<3@02o`0<][Ff]KJe][Ff]KKo
1kH03?nf]kJg][Nf]kJgo`Jg03Oo]nbgk?o/]nbgk?o/g>cLk=c/g?oLk=c/g?nEg9GLUMbEg9GLUMbE
g9GLUOoNLMiagW7NLMko00GN00?og]h00mh00ooNgP03gP0@omoNgmkOg]oNgmkOg]oNo`H500?ogml0
0ml2o`?O00koga7O4MlAga7O4MlAo`XA0_lUF`03PE]K02UK0@0002MK00GoFe]KP@0<F`;o6L`03Onf
o;Kl]_bfo;Kl]_l01kH2o`Vf00?o]kL01;L00ong]`02]`03okNg00>g0_l7k007oncLk=c/o`0AU@0:
omiagW7NLMiagP;o17403?oNLMiag_magW7NL@;o00gOg]oNgmkOg]oNgmkO00;o1@D2o`0FgioOWmoo
gioOoilAWa6O4IlAWa6O4@;o1il00omKF`0UF`03PE]K02UK0@0002MK00GoFe]KP@0<F`0Lodcoc0g<
3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0;o00^e][Ff]KJe][Ffo`08]P0:okNf]kJg][Nf]`;o1KL01Ong
k;O/00;o02Fgk;O/]ooLk=c/g>cLomc/g>cLoiGLUMbEg9GLUMbEg9GLUMbE00;o00YagW7NLMiagW7o
1=h00ooNgP03gP;o1Mh04?oNgmkOg]oNgmkOg]oNgol61@03omoO00?O00CogmoO0_l03A7O4MlAga7O
4MlAgol01A400omKF`0VF`03PE]K02UK0@0002MK00GoFe]KP@0;F`04odb<C0;o6L`03Ool]_bfo;Kl
]_bfo?l01kH00onf]P08]P03okNg00>g00?o]kL00kL00ong]`03]`03onc/00G/00Ook=c/g>co01:E
00_oLMiagW7NLMiao`04L@0MomiagW7NLOoNLMiag_oOg]oNgmkOg]oNgmkOg_l01PD06OoOWmnOgooO
WmnOoa6O4IlAWa6O4IlAWol00il00omKF`0WF`03PE]K02UK0@0002MK0_l2F`03PE]K00QK00?oC4`0
14`09ol=c0g<3L`=c0g<3L`=c0g<3L`=c0g<3L`=okFf]KJe][Ff]KJeo`07]P0<okNf]kJg][Nf]kKo
1KL2o`0fk;O/]ongk;O/]ooLk=c/g>cLomc/g>cLoiGLUMbEg9GLUMbEg9GLUMbEg?magW7NLMiagW7o
1=h2o`GN00?og]h00mh04?oNgmkOg]oNgmkOg]oNgol61@03omoO00?O0_l3g`0@oa7O4MlAga7O4MlA
golAobYK00>1Fe/0:E/100009e/01?mKFh4:F`09odb<C8a<S4b<00;o6<`2o`0:]_bfo;Kl]_bfo0;o
1[H2o`Vf00?o]kL01;L00ong]`02]`03okNg00>g00?ok>`01N`01oo/g>cLk?l04YD02omagW7NLMia
gW7o00Ea01_oLMiagW7ogW7NLMkogmkOg]oNgmkOg]oNgmh00_l51@;o01NOgioOWonOgioo4IlAWa6O
4IlAWa6Oo`0[F`03PE]K02UK0@0002MK00CoFe^12E/00om<C009C00Wol`=c0g<3L`=c0g<3L`=c0g<
3L`=c0g<3Lco][Ff]KJe][Ff]KKo00Nf00_o][Nf]kJg][Nfo`06]`0Conbgk;Oo]nbgk;Oog>cLk=c/
g002o`0Gk=c/g?nEg9GLUMbEg9GLUMbEg9GLUM`00_l02=iagW7NLMia0_l4gP03omkN00?N00?og]h0
0mh2o`0?gmkOg]oNgmkOg]oNgmko00H500?ogml00ml04OoOgmoo4MlAga7O4MlAga7o02]K00>1Fe/0
:E/100009e/01?mKFh48F`0?odb<C8a<S4b<C8a<S4co01W<0_l02obfo;Kl]_bfo;Ko00Nf00?o][H0
1kH2o`Fg00?o]kL00[L00ong]`03]`03onc/00K/00Kog>cLk?lCU@0;omiagW7NLMiag_l017401_ma
gW7NL@;o01EagW7NLOoNgmkOg]oNgmkOg]oNgol01PD02_nOgioOWonOgil2o`09Wa6O4IlAWa7o02aK
00>1Fe/0:E/100009e/01?mKFh4:F`e<0_l090g<3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0go]KJe][Ff
]KJe]P;o1[H2o`0:]kJg][Nf]kJgo`Fg03Sok;O/]ongk;O/]ooLk=c/g>cLk?o/g>cLoiGLUMbEg9GL
UMbEg9GLUMbEg9GogW7NLMiagW7No`CN00?og]h01=h00ooNgP03gP0@omoNgmkOg]oNgmkOg]oNo`H5
00?ogml00ml00ooOg`02g`09omlAga7O4Moo02aK00>1Fe/0:E/100009e/01?mKFh4;F`0?C8a<S4b<
C8a<S4b<C8co01W<0_l02kKl]_bfo;Kl]_co00Nf00?o][H01kH00ong]`03]`03okNg00:g00?o]kL0
0kL00oo/k006k006omc/g>co4iD2o`09LMiagW7NLMko00Aa0_l06]iagW7Nog7NLMiaomkOg]oNgmkO
g]oNgmkO0_l51@06oioOWmnO0_l02]nOgonO4IlAWol]F`03PE]K02UK0@0002MK00CoFe^135/00om<
C00;C0;o02G<3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0g<okJe][Ff]KJe][Go00Nf00_o]kJg][Nf]kJg
o`05]`0;onbgk;Oo]nbgk;L00_l0:ncLk=c/g>cok=c/g?nEg9GLUMbEg9GLUMbEg9GLUMbEg?magW7N
LMiag_l01Mh00ooNgP03gP03omkN00?N017ogmkOg]oNgmkOg]oNgmkOo`051@;o1Ml02_oOgmooga7O
4Ol^F`03PE]K02QK0@0002IK00GoFe]KP@0=F`0@oha<S4b<C8a<S4b<C8a<oaW<00_o]_bfo;Kl]_bf
o002o`Jf00?o][H01kH00ong]`03]`;o0kL2o`Fg00?ok>`01N`01_oLk=c/oaBE00WoLMiagW7NLMh0
0_l4L@0<omiagW7Nog7NLMia0_l03moNgmkOg]oNgmkOg]oNo`061@0?omnOgioOomnOgonO4On102iK
00>1Fe/0:5/100009U/01OmKFe^100iK00?oC4`034`2o`0H3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0g<
0_l02kFf]KJe][Ff]KKo00Jf0_l02KJg][Nf]kJgo`06]`0]okO/]ncok;O/]ncok=c/g>cLk?o/g>cL
oiGLUMbEg9GLUMbEg9GLUMbEg9GL00;o00WNLMiagW7NLOl01=h00ooNgP03gP;o1Mh03ooNgmkOg]oN
gmkOg]oNg`02o`D500?ogml00ml02?oOgmoogon1;U/00h5KF`0XF`40000VF`05oe]KFh403e/2o`0?
C8a<S4b<C8a<S4b<C8co01W<00_oo;Kl]_bfo;Kl]P02o`Jf00?o][H01[H2o`Fg00?o]kL00[L00ong
]`03]`03onc/00G/00Kog>cLk?lEU@0:omiagW7NLMiao`Aa01kogW7NLMiaomiagW7NomoNgmkOg]oN
gmkOg]oNgol51@04omnOg`Oo00=KPE/0;E/00h5KF`0XF`40000VF`05oe]KFh404E/00om<C00<C0;o
01S<3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0d2o`0;][Ff]KJe][Ff]Ol01[H02onf]kJg][Nf]kKo00Fg
03So]nbgk?o/]nbgk?o/g>cLk=c/oncLk=coUMbEg9GLUMbEg9GLUMbEg9GLUMbEomiagW7NLMiao`CN
0_l5gP03omkN00?N017og]oNgmkOg]oNgmkOg]oNo`041@Co25/00h5KF`0/F`03PE]K02QK0@0002IK
00GoFe]KP@0BF`0Aodb<C8a<S4b<C8a<S4b<C?l06L`03?nfo;Kl]_bfo;Klo`Jf0_l8]P03okNg00>g
00?o]kL00[L00ong]`03]`03onc/00G/00Kog>cLk?lEU@;o00QagW7NLMiao`Ea01koLMiagW7ogW7N
LMkogmkOg]oNgmkOg]oNgmkOo`D2o`aK00>1Fe/0;5/00h5KF`0XF`40000VF`05oe]KFh404e/00om<
C00=C0;o01P=c0g<3L`=c0g<3L`=c0g<3L`=c0g<3L`2o`09]KJe][Ff]KJe00;o1[H02_ng][Nf]kJg
]_l5]`0gokO/]ncok;O/]ncok=c/g>cLk?o/g>cLoiGLUMbEg9GLUMbEg9GLUMbEg9GLUMcoLMiagW7N
L@02o`CN00?og]h00mh00ooNgP03gP;o00oOg]oNgmkOg]oNgmkOg_l03U/00h5KF`0/F`03PE]K02QK
0@0002IK00GoFe]KP@0DF`0Bodb<C8a<S4b<C8a<S4b<C8co6L`03?ol]_bfo;Kl]_bfo`Jf00?o][H0
1[H00ong]`03]`03okNg00:g00?o]kL00kL00oo/k005k006omc/g>co5YD02_magW7NLMiag_l4L@06
og7NLMia0_l0577NLMiaomkOg]oNgmkOg]oNgmko3U/00h5KF`0/F`03PE]K02QK0@0001IK1?l3F`Co
1E/01OmKFe^101EK00?oC4`03T`2o`0Tc0g<3L`=c0g<3L`=c0g<3L`=c0g<3L`=okFf]KJe][Ff]KKo
1[H02Ong][Nf]kJg]P02o`Bg03Wo]nbgk?o/]nbgk?o/g>cLk=c/oncLk=coUMbEg9GLUMbEg9GLUMbE
g9GLUMbEg?magW7NLMiag_l01=h00ooNgP04gP03omkN00?N00gogmkOg]oNgmkOg]oo00mK00>1Fe/0
;5/00h5KF`0XF`40000EF`03oe]K009K00?oFol015/00omKF`02F`>100=KPE/05E/2o`0AS4b<C8a<
S4b<C8a<S4b<C?l06<`2o`09]_bfo;Kl]_bf00;o1KH2o`Rf00?o]kL00[L2o`>g00?o]kL00kL2o`K/
00Kog>cLk?lFU@;o00SNLMiagW7No`Aa0_l05miagW7Nog7NLMiaomkOg]oNgmkOg]oo00mK00>1Fe/0
;5/00h5KF`0XF`40000JF`03oe_o00AK00?oFe/00U/00omKF`04PAIK00?oC4`03T`09_o<3L`=c0g<
3L`=c0g<3L`=c0g<3L`=c0g<okJe][Ff]KJe][Go1[H02_nf]kJg][Nf]ol5]`04onbgk0;o036gk;O/
]ooLk=c/g>cok=c/g?nEg9GLUMbEg9GLUMbEg9GLUMbEg9GLUOoNLMiagW7N00;o1=h00ooNgP03gP03
omkN00?N00_ogmkOg]oNgmkOo`0?F`03PE]K02aK00>1Fe/0:5/100006U/00omKo`04F`03oe]K009K
00CoFe^10e/4PA=K017oS4b<C8a<S4b<C8a<S4b<C002oaS<0_l02_bfo;Kl]_bfo?l6]P03okJf00Jf
00?o]kL00kL00ong]`02]`03okNg00>g00?ok>`01>`01_oLk=c/oaNE00[ogW7NLMiagW7o17403?oN
LMiag_magW7NL@;o00OOg]oNgmko011K00>1Fe/0;5/00h5KF`0XF`40000EF`03oe]K009K00?oFol0
15/00omKF`02F`04oe]KP@MK184@F`03oda<00m<02Co3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0g<3One
][Ff]KJe][D2o`Ff0_l02;Nf]kJg][Oo1KL05oo/]nbgokO/]nbgomc/g>cLk?o/g>cL00;o01KLUMbE
g9GLUMbEg9GLUMbEg9GLUMbE0_l0277NLMiagW7o1=h00ooNgP03gP;o1Mh01ooNgmkOg_l045/00h5K
F`0/F`03PE]K02QK0@0001EK1Ol2F`03oe]K009K00?oFe/00U/01?mKFh4;F`B13E/04_n<C8a<S4b<
C8a<S4b<C8a<S0;o6<`2o`0:]_bfo;Kl]_bfo`Jf00?o][H01KH00ong]`03]`03okNg00:g00?o]kL0
0kL00oo/k004k007omc/g>cLo`0GU@09og7NLMiagW7o00Aa01;ogW7NLMiaomiagW7NomoNgolAF`03
PE]K02aK00>1Fe/0:5/100005E/00omKF`04F`03oe]K009K00?oFe/00U/01?mKFh4?F`>12e/00om<
C00@C00Uol`=c0g<3L`=c0g<3L`=c0g<3L`=c0g<3Lco][Ff]KJe][Ffo`06]P08okNf]kJg][L2o`Bg
03Wok;O/]ongk;O/]ooLk=c/g>cok=c/g>cog9GLUMbEg9GLUMbEg9GLUMbEg9GLUMcoLMiagW7NLOl0
1=h2o`GN00?og]h00mh01?oNgolAF`03PE]K02aK00>1Fe/0:5/100005U/00omKF`03F`03oe]K009K
00?oFe/00U/01?mKFh4BF`B125/04on<C8a<S4b<C8a<S4b<C8a<S4`00_lHc00:okKl]_bfo;Kl]P;o
1KH00onf]P06]P03okNg00:g00?o]kL00[L00ong]`03]`03onc/00C/00Oog>cLk=co01NE0_l01]ia
gW7NL@;o17403omagW7NLOoNLMiag_oOo`0AF`03PE]K02aK00>1Fe/0:5/100005U/5o`9K1?l4F`05
oe]KFh405U/4P@EK0_lBC00Io`g<3L`=c0g<3L`=c0g<3L`=c0g<3L`=c002o`0:]KJe][Ff]KJeo`Ff
0_l02;Jg][Nf]kKo1;L0>_o/]nbgokO/]nbgomc/g>cLk?o/g>cLk?oLUMbEg9GLUMbEg9GLUMbEg9GL
UMbEg9GogW7NLMiag_l4gP03omkN00?N00Cog]kN0olBF`03PE]K02aK00>1Fe/0:5/100009E/01OmK
Fe^101YK1843F`0Codb<C8a<S4b<C8a<S4b<C8a<S002oaS<00[oo;Kl]_bfo;Kl0_l5]P03okJf00Ff
00?o]kL00[L2o`>g00?o]kL00kL00oo/k004k007omc/g>cLo`0HU@09omiagW7NLMko00Aa00GoLMia
gP04oaEK00>1Fe/0;5/00h5KF`0XF`40000UF`05oe]KFh407U/4P@03oda<015<01Woc0g<3L`=c0g<
3L`=c0g<3L`=c0g<3L`=00;o00Zf]KJe][Ff]KKo1KH02Onf]kJg][Nfo`05]`0:okO/]ongk;O/]`;o
02g/g>cLk?o/g>cLk?oLUMbEg9GLUMbEg9GLUMbEg9GLUMbEg9GogW7NLMiag_l01=h01?oNoolIF`03
PE]K02aK00>1Fe/0:5/100009E/01OmKFe^1025K0X405?m<S4b<C8a<S4b<C8a<S4b<C8a<0_lHc00;
okKl]_bfo;Kl]_l01KH2o`Jf0_l4]`04okNg]`;o1KL00oo/k003k007omc/g>cLo`0HU@;o00MagW7N
LMko009a0olKF`03PE]K02aK00>1Fe/0:5/100009E/01OmKFe^1025K00B1Fe_o54`08ol=c0g<3L`=
c0g<3L`=c0g<3L`=c0g<3Lco][Ff]KJe][Ff00;o1KH02Ong][Nf]kJgo`04]`0gokO/]ncok;O/]nco
k=c/g>cok=c/g>cog9GLUMbEg9GLUMbEg9GLUMbEg9GLUMbEg?magW7NL@03oaiK00>1Fe/0;5/00h5K
F`0XF`40000UF`05oe]KFh408E/06H5KFe_oC8a<S4b<C8a<S4b<C8a<S4b<C8`00_lGc0;o00[l]_bf
o;Kl]_co1KH00onf]P05]P03okNg00:g00?o]kL00[L00ong]`03]`03onc/00?/00Oog>cLk=co01VE
00?oLOl00_lQF`03PE]K02eK00>1Fe/09e/100009E/01OmKFe^1025K00>1Fe/00U/2oaA<02Coc0g<
3L`=c0g<3L`=c0g<3L`=c0g<3L`=okFf]KJe][Ff]Ol5]P09okNf]kJg][Oo00Bg03;o]nbgk?o/]nbg
k?o/g>cLk?o/g>cLk?oLUMbEg9GLUMbEg9GLUMbEg9GLUMbEg9GLobAK00>1Fe/0;E/00h5KF`0WF`40
000UF`;o0U/00h5KF`0OF`03PE]K00AK01KoS4b<C8a<S4b<C8a<S4b<C8a<S4co6<`2o`08]_bfo;Kl
]_`2o`Bf0_l6]P03okNg00:g00?o]kL00[L00ong]`03]`03onc/00?/00Oog>cLk=co01RE00?oFe/0
8U/00h5KF`0]F`03PE]K02MK0@0002EK00GoFe]KP@0QF`03PE]K00EK00?oC4`04T`2o`0S3L`=c0g<
3L`=c0g<3L`=c0g<3L`=c0g<okJe][Ff]KJe]_l01KH02?nf]kJg][Oo1;L2o`0^k;O/onbgk;O/oncL
k=c/oncLk=c/ombEg9GLUMbEg9GLUMbEg9GLUMbEg9GLobAK00>1Fe/0;E/00h5KF`0WF`40000UF`05
oe]KFh408E/00h5KF`06F`0Goha<S4b<C8a<S4b<C8a<S4b<C8a<S?l06<`2o`09o;Kl]_bfo;Ko00Ff
00?o][H01;H2o`Bg00Go]kNgo`05]`03onc/00?/00Oog>cLk=co01JE00?oFe/08U/00h5KF`0]F`03
PE]K01AK1h4<F`40000UF`05oe]KFh408E/00h5KF`07F`03oda<01=<0_l08L`=c0g<3L`=c0g<3L`=
c0g<3L`=c0g<3One][Ff]KJe]P02o`Bf00Wo][Nf]kJg]_l01;L0;?o/]ncok;O/]ncok=c/g>cok=c/
g>cog9GLUMbEg9GLUMbEg9GLUMbEg9Go9E/00h5KF`0]F`03PE]K00QK384CF`40000UF`04oe]KPB9K
00>1Fe/025/06?n<C8a<S4b<C8a<S4b<C8a<S4b<C8a<oaS<00_oo;Kl]_bfo;Klo`04]P;o1[H00ong
]`02]`05okNg]ol01KL00oo/k003k007omc/g>cLo`0CU@03oe]K02AK00>1Fe/0;5/;PAmK0@0002EK
00CoFe^18U/00h5KF`09F`;o5D`2o`0G3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0d00_l02;Je][Ff]KJe
0_l4]P08okNf]kJg]_l4]`0:onbgk?o/]nbgk0;o01kLk=c/oncLk=c/ombEg9GLUMbEg9GLUMbEg9GL
UOlVF`03PE]K021K3H4YF`40000UF`04oe]KPB9K00>1Fe/02e/06?m<S4b<C8a<S4b<C8a<S4b<C8a<
S4b<oaS<00_o]_bfo;Kl]_bfo`04]P03okJf00Bf00?o]kL00[L01?ng]kL2o`Fg00?ok>`00^`01ooL
k=c/g?l04ID00omKF`0TF`03PE]K01AK384<F`03PE]K02MK0@0002EK00CoFe^18U/00h5KF`0<F`03
oda<01A<0_l05l`=c0g<3L`=c0g<3L`=c0g<3L`=c0g<00;o00Ve][Ff]KJe]_l01;H2o`05][Nf]kH0
0_l3]`0Xonbgk;Oo]nbgk;Oog>cLk?o/g>cLk?oLUMbEg9GLUMbEg9GLUMbEobIK00>1Fe/02E/;PAQK
00>1Fe/09e/1000095/01OmKFe^1029K00>1Fe/03E/06Om<S4b<C8a<S4b<C8a<S4b<C8a<S4b<C?l0
6<`02Ool]_bfo;Kl]P02o`Bf00?o][H01;H01Ong]kOo00Bg00?o]kL00kL00oo/k002k007omc/g>cL
o`0>U@03oe]K02EK384SF`03PE]K02MK0@0002AK00GoFe]KP@0RF`03PE]K00iK00?oC4`05D`2o`0G
3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0d00_l02KJe][Ff]KJeo`04]P08okJg][Nf]ol3]`;o02>gk;Oo
]nbgk;Oog>cLk?o/g>cLk?oLUMbEg9GLUMbEg9GLo`0KF`f1;U/00h5KF`0WF`40000TF`05oe]KFh40
8U/00h5KF`0?F`0Jodb<C8a<S4b<C8a<S4b<C8a<S4b<C8a<S?lHc00:okKl]_bfo;Klo`Bf00?o][H0
1;H00ong]`02]`05okNg]ol01KL00oo/k002k007omc/g>cLo`0<U@03oe]K00eK384<F`03PE]K02aK
00>1Fe/09e/1000095/01OmKFe^1029K00>1Fe/045/2oaM<02;o3L`=c0g<3L`=c0g<3L`=c0g<3L`=
c0g<okJe][Ff]KJe0_l3]P;o00Jg][Nf]ol4]`0RokO/]ongk;O/]ooLk=c/oncLk=c/ombEg9GLUMbE
g9GLo`AK2h4HF`03PE]K02aK00>1Fe/09e/1000095/01OmKFe^1029K00>1Fe/04U/06?n<C8a<S4b<
C8a<S4b<C8a<S4b<C8a<S0;o5l`2o`09o;Kl]_bfo;Ko00Bf00?o][H00kH00ong]`02]`05okNg]ol0
1KL00oo/k002k007omc/g>cLo`0:U@03oh6100:18e/00h5KF`0/F`03PE]K02MK0@0002AK00GoFe]K
P@0RF`03PE]K01=K00?oC4`05T`08oo<3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0go]KJe][Ff]KKo00Bf
00Ko]kJg][L2o`>g023o]nbgokO/]nbgomc/g>cok=c/g>cog9GLUMbEg9GLobMK00>1Fe/0;5/00h5K
F`0WF`40000TF`05oe]KFh408U/00h5KF`0DF`0Ioha<S4b<C8a<S4b<C8a<S4b<C8a<S4b<C002oaO<
0_l01kKl]_bfo;H00_l3]P;o1KH01Ong]kOo00>g00?o]kL00kL2o`?/00Oog>cLk=co00NE00?oFe/0
9U/00h5KF`0/F`03PE]K02MK0@0002AK0_l2F`03PE]K021K00>1Fe/05E/00om<C00GC00So`g<3L`=
c0g<3L`=c0g<3L`=c0g<3L`=c?nf]KJe][Ff]Ol01;H01onf]kJg]_l00kL01?ngk;L2o`0Gk;O/]nco
k=c/oncLk=c/ombEg9GLUOl0:5/00h5KF`0/F`03PE]K02MK0@0002AK00GoFe]KP@0QF`03PE]K01MK
01[oS4b<C8a<S4b<C8a<S4b<C8a<S4b<C8a<S0;o5l`2o`08o;Kl]_bfo?l4]P03okJf00>f00Co]kNg
0_l3]`03okNg00>g00_ok>c/omc/g>cLo`05U@03oe]K02IK00>1Fe/0;5/00h5KF`0WF`40000TF`05
oe]KFh408E/00h5KF`0HF`;o6D`08Oo<3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0go]KJe][Ff]@02o`>f
00Oo][Nf]kKo00Bg01[ok;O/onbgk;O/oncLk?o/g>cLk?oLUMbEobQK00>1Fe/0;5/00h5KF`0WF`40
000TF`05oe]KFh408E/00h5KF`0JF`0Jodb<C8a<S4b<C8a<S4b<C8a<S4b<C8a<S4`2oaO<00[oo;Kl
]_bfo;Ko0kH2o`Bf0_l3]`05okNg]ol01KL02oo/k>cog>cLk=co00>E00?oFe/09U/00h5KF`0]F`03
PE]K02IK0@0002AK00GoFe]KP@0QF`03PE]K01]K00?oC4`064`06?l=c0g<3L`=c0g<3L`=c0g<3L`=
c0g<3@;o00Nf]KJe][Ff00;o0kH01ong][Nf]ol00kL05oo/]ncok;O/]ncok=c/oncLk=c/omco02UK
00>1Fe/0;E/00h5KF`0VF`40000TF`05oe]KFh408E/00h5KF`0KF`0LPOm<S4b<C8a<S4b<C8a<S4b<
C8a<S4b<C8a<S0;o5l`02_nfo;Kl]_bfo?l3]P03okJf00>f00Go]kNgo`03]`03okNg00>g00[ok>c/
omc/g>cL0_lYF`03PE]K02eK00>1Fe/09U/1000095/01?mKFh4RF`03PE]K01]K00>1Fol06d`06?o<
3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0;o00Re][Ff]KJeo`>f0_l01KJg][Oo00>g01?ok;O/onbgk;O/
oncLk?o/g>cL00;o:E/00h5KF`0]F`03PE]K02IK0@0002AK00CoFe^18U/00h5KF`0KF`0OPE]Kodb<
C8a<S4b<C8a<S4b<C8a<S4b<C8a<S4b<C002oaO<00Soo;Kl]_bfo0;o0kH00onf]P02]P05okNg]ol0
0kL00ong]`03]`06onc/k?oL0_l[F`03PE]K02eK00>1Fe/09U/100008e/01OmKFe^1029K00>1Fe/0
6e/01H5KFe_o01a<01So3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0d2o`08][Ff]KJe]_l3]P06okJg][Oo
0kL02?o/]ncok;O/1ol00e^1F`0ZF`03PE]K02eK00>1Fe/09U/100008e/01OmKFe^1029K00>1Fe/0
6e/00h5KF`02F`;o01b<C8a<S4b<C8a<S4b<C8a<S4b<C8a<S4b<C8co6<`02Onfo;Kl]_bfo`03]P03
okJf00go25/00h5KF`0YF`03PE]K02eK00>1Fe/09U/100008e/01OmKFe^1029K00>1Fe/06e/00h5K
F`04F`03oda<01U<0_l07/`=c0g<3L`=c0g<3L`=c0g<3L`=c0g<okJe][Ff]@Oo5E/00h5KF`0YF`03
PE]K02eK00>1Fe/09U/100008e/01OmKFe^1029K00>1Fe/06e/00h5KF`05F`0Noha<S4b<C8a<S4b<
C8a<S4b<C8a<S4b<C8a<S4co5l`2o`04o;KloaaK00>1Fe/0:E/00h5KF`0]F`03PE]K02IK0@0002=K
00GoFe]KP@0RF`03PE]K01]K00>1Fe/01U/00om<C00JC0;o01X=c0g<3L`=c0g<3L`=c0g<3L`=c0g<
3OneoaeK00>1Fe/0:E/00h5KF`0]F`03PE]K02IK0@0002=K00GoFe]KP@0RF`03PE]K01]K00>1Fe/0
1e/07on<C8a<S4b<C8a<S4b<C8a<S4b<C8a<S4b<C8a<S?l05l`00omKF`0LF`03PE]K02UK00>1Fe/0
;E/00h5KF`0VF`40000SF`05oe]KFh408U/00h5KF`0JF`03PE]K00UK00?oC4`06d`2o`0Fc0g<3L`=
c0g<3L`=c0g<3L`=c0g<oaiK00>1Fe/0:E/00h5KF`0]F`03PE]K02IK0@0002=K0_l2F`03PE]K021K
00>1Fe/06U/00h5KF`0:F`;o01i<S4b<C8a<S4b<C8a<S4b<C8a<S4b<C8a<S4b<C?lDc003oe]K01aK
00>1Fe/0:E/00h5KF`0]F`03PE]K02IK0@0002=K00GoFe]KP@0RF`03PE]K01YK00>1Fe/035/00om<
C00KC0;o018=c0g<3L`=c0g<3L`=c0g<3OlOF`03PE]K02UK00>1Fe/0;E/00h5KF`0VF`40000SF`05
oe]KFh408U/00h5KF`0JF`03PE]K00eK023oC8a<S4b<C8a<S4b<C8a<S4b<C8a<S4b<C8a<S4b<oa3<
00?oFe/07E/00h5KF`0YF`03PE]K02eK00>1Fe/09U/100008e/01OmKFe^1029K00>1Fe/06U/00h5K
F`0>F`03oda<01a<0_l03l`=c0g<3L`=c0g<3L`=o`0OF`03PE]K02UK00>1Fe/0;E/00h5KF`0VF`40
000SF`05oe]KFh408U/00h5KF`0JF`03PE]K00mK027oC8a<S4b<C8a<S4b<C8a<S4b<C8a<S4b<C8a<
S4b<C?l03<`00omKF`0NF`03PE]K02UK00>1Fe/0;E/00h5KF`0VF`40000SF`05oe]KFh408U/00h5K
F`0JF`03PE]K011K00?oC4`07D`2o`0;3L`=c0g<3L`=c?l085/00h5KF`0YF`03PE]K02eK00>1Fe/0
9U/100008e/01OmKFe^1025K00>1Fe/06e/00h5KF`0AF`;o022<C8a<S4b<C8a<S4b<C8a<S4b<C8a<
S4b<C8a<S4b<o`W<00?oFe/07U/00h5KF`0YF`03PE]K02eK00>1Fe/09U/100008e/01?mKFh4RF`03
PE]K01]K00>1Fe/04e/00om<C00MC00:o`g<3L`=c0g<ob1K00>1Fe/0:E/00h5KF`0]F`03PE]K02IK
0@00029K00GoFe]KP@0RF`03PE]K01]K00>1Fe/055/08?n<C8a<S4b<C8a<S4b<C8a<S4b<C8a<S4b<
C8a<S4b<0_l5c003oe]K01mK00>1Fe/0:E/00h5KF`0^F`03PE]K02EK0@00029K00GoFe]KP@0RF`03
PE]K01]K00>1Fe/05E/00om<C00NC006ol`=c0go8E/00h5KF`0YF`03PE]K02iK00>1Fe/09E/10000
8U/01OmKFe^1029K00>1Fe/06e/00h5KF`0FF`0Qoha<S4b<C8a<S4b<C8a<S4b<C8a<S4b<C8a<S4b<
C8a<00;o0/`00omKF`0OF`03PE]K02UK00>1Fe/0;U/00h5KF`0UF`40000RF`05oe]KFh408U/00h5K
F`0KF`03PE]K01MK00?oC4`07d`2ob9K00>1Fe/0:E/00h5KF`0^F`03PE]K02EK0@00029K00GoFe]K
P@0RF`03PE]K01]K00>1Fe/065/2o`0QC8a<S4b<C8a<S4b<C8a<S4b<C8a<S4b<C8a<S4b<C8co029K
00>1Fe/0:E/00h5KF`0^F`03PE]K02EK0@00029K00GoFe]KP@0RF`03PE]K01]K00>1Fe/065/00h5K
o`0OC003oe]K021K00>1Fe/0:E/00h5KF`0^F`03PE]K02EK0@00029K00GoFe]KP@0RF`03PE]K01]K
00>1Fe/065/08h5KFom<S4b<C8a<S4b<C8a<S4b<C8a<S4b<C8a<S4b<C8co029K00>1Fe/0:E/00h5K
F`0^F`03PE]K02EK0@00029K0_l2F`03PE]K021K00>1Fe/06e/00h5KF`0HF`05PE]KFol074`00omK
F`0QF`03PE]K02UK00>1Fe/0;U/00h5KF`0UF`40000RF`05oe]KFh408U/00h5KF`0KF`03PE]K01QK
00>1Fe/00U/07Om<S4b<C8a<S4b<C8a<S4b<C8a<S4b<C8a<S4co02=K00>1Fe/0:E/00h5KF`0^F`03
PE]K02EK0@00029K00GoFe]KP@0RF`03PE]K01]K00>1Fe/065/00h5KF`03F`03oda<01Q<00?oFe/0
8E/00h5KF`0YF`03PE]K02iK00>1Fe/09E/100008U/01OmKFe^1029K00>1Fe/06e/00h5KF`0GF`03
PE]K00EK0_l06Ha<S4b<C8a<S4b<C8a<S4b<C8a<S4b<C?l08e/00h5KF`0ZF`03PE]K02eK00>1Fe/0
9E/100008U/01OmKFe^1029K00>1Fe/06e/00h5KF`0GF`03PE]K00MK00?oC4`05D`00omKF`0QF`03
PE]K02YK00>1Fe/0;E/00h5KF`0UF`40000RF`05oe]KFh408U/00h5KF`0KF`03PE]K01MK00>1Fe/0
25/05on<C8a<S4b<C8a<S4b<C8a<S4b<C8co02AK00>1Fe/0:U/00h5KF`0]F`03PE]K02EK0@00029K
00GoFe]KP@0RF`03PE]K01]K00>1Fe/05e/00h5KF`09F`03oda<019<00?oFe/08U/00h5KF`0ZF`03
PE]K02eK00>1Fe/09E/100008U/01OmKFe^1029K00>1Fe/06e/00h5KF`0GF`03PE]K00YK01GoS4b<
C8a<S4b<C8a<S4b<C8a<S?l095/00h5KF`0ZF`03PE]K02eK00>1Fe/09E/100008E/01OmKFe^102=K
00>1Fe/06e/00h5KF`0GF`03PE]K00]K00?oC4`044`00omKF`0RF`03PE]K02YK00>1Fe/0;E/00h5K
F`0UF`40000QF`05oe]KFh408e/00h5KF`0KF`03PE]K01MK00>1Fe/035/04on<C8a<S4b<C8a<S4b<
C8a<S?l095/00h5KF`0ZF`03PE]K02eK00>1Fe/09E/100008E/01OmKFe^1029K00>1Fe/06e/00h5K
F`0HF`03PE]K00eK0_l>C003oe]K02=K00>1Fe/0:U/00h5KF`0]F`03PE]K02EK0@00025K00GoFe]K
P@0RF`03PE]K01]K00>1Fe/065/00h5KF`0?F`0?odb<C8a<S4b<C8a<S4co02EK00>1Fe/0:U/00h5K
F`0]F`03PE]K02EK0@00025K00GoFe]KP@0RF`03PE]K01]K00>1Fe/065/00h5KF`0@F`03oda<00Y<
00?oFe/08e/00h5KF`0ZF`03PE]K02eK00>1Fe/09E/100008E/01OmKFe^1029K00>1Fe/06e/00h5K
F`0HF`03PE]K015K00goC8a<S4b<C8a<S4co02EK00>1Fe/0:U/00h5KF`0^F`03PE]K02AK0@00025K
00GoFe]KP@0RF`03PE]K01]K00>1Fe/065/00h5KF`0BF`03oda<00Q<00?oFe/08e/00h5KF`0ZF`03
PE]K02iK00>1Fe/095/100008E/6PB5K00>1Fe/06e/00h5KF`0HF`03PE]K01=K00[oC8a<S4b<C8co
9U/00h5KF`0ZF`03PE]K02iK00>1Fe/095/100009e/:PAMK00>1Fe/06e/00h5KF`0HF`03PE]K01AK
0_l6C003oe]K02AK00>1Fe/0:U/00h5KF`0^F`03PE]K02AK0@00035K2X4=F`03PE]K01]K00>1Fe/0
65/00h5KF`0DF`09PE_oS4b<C8co02IK00>1Fe/0:U/00h5KF`0^F`03PE]K02AK0@0003]K2X43F`03
PE]K01]K00>1Fe/065/00h5KF`0DF`04PE]Ko`A<00?oFe/095/00h5KF`0ZF`03PE]K02iK00>1Fe/0
95/10000AE/:PAMK00>1Fe/065/00h5KF`0DF`09PE]KFon<C8co02IK00>1Fe/0:U/00h5KF`0^F`03
PE]K02AK0@0004mK2X4=F`03PE]K01QK00>1Fe/055/00h5KF`02F`03odco02MK00>1Fe/0:U/00h5K
F`0^F`03PE]K02AK0@0005UK2h42F`03PE]K01QK00>1Fe/055/00h5KF`03F`;o9e/00h5KF`0ZF`03
PE]K02iK00>1Fe/095/10000I5/:PA=K00>1Fe/055/00h5KF`03F`03POmK02IK00>1Fe/0:U/00h5K
F`0^F`03PE]K00YK4X48F`40001^F`Z12E/00h5KF`0DF`03PE]K00=K00>1Fe/09U/00h5KF`0ZF`03
PE]K01UK8X4JF`40001hF`Z15U/00h5KF`03F`03PE]K02IK00>1Fe/095/RPCaK0@00089K2X4<F`03
PE]K00=K00>1Fe/09U/00h5KF`03Fb61GU/10000S5/:P@9K00>1Fe/00e/00h5KF`0:Fb:1Oe/10000
UU/EPJ5K0@000?mKCE/10000oe]=F`40003oFdeK0@000?mKCE/10000oe]=F`40003oFdeK0@000?mK
CE/10000oe]=F`40003oFdeK0@000?mKCE/10000oe]=F`40003JF`;oL5/10000fe/2o`=K00?oFe/0
JE/10000g5/2o`=K00?oFe/0J5/10000E5/5o`=K0ol2F`;o15/3o`03Fooo00;o0e/5o`EK0_l5F`;o
0U/5o`9K0_l2F`Co0e/4o`=K1?l2F`Co0e/4o`IK0_l3F`;o00=Kool00U/4o`=K0ol2F`?o0U/2o`EK
0ol2F`;o1e/4o`03FomK00Co0U/2o`9K0_l2F`;o15/6o`9K1?llF`40001CF`;o0e/2o`04FoooF`;o
00=Kool015/2o`03Fooo009K0_l00e_oo`02F`;o1E/2o`EK0_l2F`;o00=Kool00U/2o`03Fooo009K
0_l00e_oo`02F`;o00=Kool00U/4o`9K0_l00e_oo`02F`;o1E/2o`=K0_l015_ooe/2o`9K0_l2F`;o
0U/2o`04FoooF`;o1E/3o`9K0_l6F`;o0U/5o`9K0_l00e_oo`02F`;o0U/2o`AK0_l5F`;o0U/2oc]K
0@0005=K0_l3F`Co0e/4o`AK0_l00e_oo`05F`;o0U/2o`EK0_l5F`;o0U/2o`03Fooo009K0_l00e_o
o`08F`?o15/5o`QK0ol5F`;o0e/2o`03Fooo00AK0ol2F`;o00=Kool00e/4o`AK0_l00e_oo`08F`;o
15/4o`EK0_l2F`;o2E/2o`AK0_l2F`;o>e/10000Ee/5o`=K1?l4F`;o00=Kool01?l00e_oo`02F`;o
1E/2o`EK0_l2F`;o00=Kool00U/2o`03Fooo00Co0U/4o`=K1?l00e_oo`04o`9K1?l6F`;o0e/2o`03
Fooo009K1?l3F`;o00=Kool00e/4o`AK0_l00e_oo`08F`;o15/8o`03Fooo009K0_l:F`;o0e/2o`9K
0_lkF`40001DF`Go00=Kool00e/4o`AK0_l00e_oo`02F`;o00=Kool00U/2o`EK1Ol2F`;o0U/2o`03
Fooo009K0_l00e_oo`02F`;o00AKoooo15/3o`=K0_l2F`;o00AKoooo25/2o`=K0_l015_ooe/3o`EK
0_l00e_oo`03F`Co15/2o`03Fooo00QK0_l2F`Ko0U/2o`03Fooo009K0_l;F`;o0U/2o`9K0_lkF`40
001CF`?o1E/2o`04FoooF`?o0e/2o`03Fooo009K0_l00e_oo`02F`;o1E/2o`EK0_l2F`;o00=Kool0
0U/2o`03Fooo009K0_l00e_oo`02F`;o00=Kool00U/4o`9K0_l00e_oo`02F`;o1E/7o`04FoooF`;o
0U/2o`9K0_l2F`;o00AKoomK0ol3F`;o00=Kool025/2o`IK0_l2F`;o00=Kool00U/2o`aK0_l00e_o
o`02F`;o>e/10000De/2o`=K0_l2F`?o0U/3o`9K1?l00e_oo`02o`=K1Ol5F`;o1E/2o`03Fooo00Oo
0e/4o`=K1?l3F`Co0U/4o`=K1?l6F`;o0e/2o`03Fooo009K1?l2F`Co0U/3o`9K0ol2F`;o0e/2o`MK
0_l4F`;o00=Kool00_l2F`Go2E/2o`9K0_l00e_oo`02F`;o>e/10000De/2o`=K0_l=F`;o35/2o`EK
0_l9F`;o;U/2o`=K0_l<F`;o75/2o`9K0_lFF`;o0U/2o`03Fooo009K0_lkF`40001DF`Go3U/2o`aK
0_l5F`Ko00=Kool00U/2obiK0_l3F`;o00=Kool02E/2oaeK1?lHF`Co0e/4ocaK0@000?mKCE/10000
oe]=F`40003oFdeK0@000?mKCE/10000\
\>"],
  ImageRangeCache->{{{0, 332}, {316, 0}} -> {-0.0772134, -0.0389858, 
  0.00305339, 0.00305339}}],

Cell[TextData[
"visualizeExpressions::fitnessesInfo: \n   Fitnesses: {60, 60, 16, 4, 40, 60, \
36, 36, 60, 0, 62, <<19>>, 58, 26, 0, \n     0, 0}"], "Message",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData["visualizeExpressions::fitnessMax: Max. Fitness: 96"], "Message",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.0238095 0.952381 0.0147151 0.588604 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
% Start of sub-graphic
p
0.0238095 0.0147151 0.97619 0.603319 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.136054 0.0169173 0.136054 [
p
/Times findfont 14 scalefont setfont
[(Gen. 20)] .5 .71053 0 -2 Msboxa
P
[ 0 0 0 0 ]
[ 1 .71053 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
p
/Times findfont 14 scalefont setfont
[(Gen. 20)] .5 .71053 0 -2 Mshowa
P
P
0 0 m
1 0 L
1 .71053 L
0 .71053 L
closepath
clip
newpath
p
p
% Start of sub-graphic
p
0.0238095 0.0169173 0.149123 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
0 .4 1 r
.02 w
.67141 .31411 m
.56113 .25365 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67141 .31411 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43123 .54175 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.0169173 0.286967 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.79931 .70898 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.0169173 0.424812 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.0169173 0.562657 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.429751 1.9597 0.0248227 0.992908 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.89228 .59942 m
.84284 .57057 L
s
P
p
.2 1 0 r
.02 w
.89619 .64666 m
.89228 .59942 L
s
P
p
.2 1 0 r
.02 w
.83953 .52408 m
.78926 .49412 L
s
P
p
.2 1 0 r
.02 w
.84284 .57057 m
.83953 .52408 L
s
P
p
.2 1 0 r
.02 w
.84624 .61813 m
.89619 .64666 L
s
P
p
.2 1 0 r
.02 w
.78926 .49412 m
.79204 .54091 L
s
P
p
.2 1 0 r
.02 w
.73542 .41733 m
.68287 .38538 L
s
P
p
.2 1 0 r
.02 w
.73758 .46333 m
.73542 .41733 L
s
P
p
.2 1 0 r
.02 w
.79488 .58879 m
.84624 .61813 L
s
P
p
.2 1 0 r
.02 w
.79204 .54091 m
.73979 .51041 L
s
P
p
.2 1 0 r
.02 w
.73979 .51041 m
.73758 .46333 L
s
P
p
.2 1 0 r
.02 w
.68287 .38538 m
.68444 .43166 L
s
P
p
.2 1 0 r
.02 w
.84971 .66681 m
.79779 .63781 L
s
P
p
.2 1 0 r
.02 w
.85327 .71664 m
.84971 .66681 L
s
P
p
.2 1 0 r
.02 w
.79779 .63781 m
.79488 .58879 L
s
P
p
.2 1 0 r
.02 w
.68444 .43166 m
.62977 .39908 L
s
P
p
.2 1 0 r
.02 w
.80077 .68802 m
.85327 .71664 L
s
P
p
.2 1 0 r
.02 w
.68605 .47904 m
.68769 .52756 L
s
P
p
.2 1 0 r
.02 w
.63074 .44675 m
.68605 .47904 L
s
P
p
0 .4 1 r
.02 w
.69659 .47731 m
.69836 .52586 L
s
P
p
0 .4 1 r
.02 w
.64139 .44498 m
.69659 .47731 L
s
P
p
.01 w
.62977 .39908 Mdot
P
p
.2 1 0 r
.02 w
.62977 .39908 m
.63074 .44675 L
s
P
p
.01 w
.64029 .39729 Mdot
P
p
0 .4 1 r
.02 w
.64029 .39729 m
.64139 .44498 L
s
P
p
.2 1 0 r
.02 w
.80383 .73944 m
.80077 .68802 L
s
P
p
.2 1 0 r
.02 w
.74437 .60798 m
.74674 .65856 L
s
P
p
.2 1 0 r
.02 w
.68938 .57728 m
.74437 .60798 L
s
P
p
.2 1 0 r
.02 w
.68769 .52756 m
.63173 .4956 L
s
P
p
0 .4 1 r
.02 w
.69836 .52586 m
.64251 .49384 L
s
P
p
.2 1 0 r
.02 w
.74917 .71038 m
.80383 .73944 L
s
P
p
.2 1 0 r
.02 w
.74674 .65856 m
.74917 .71038 L
s
P
p
.2 1 0 r
.02 w
.6911 .62822 m
.68938 .57728 L
s
P
p
.2 1 0 r
.02 w
.63173 .4956 m
.57409 .46267 L
s
P
p
0 .4 1 r
.02 w
.64251 .49384 m
.58499 .46086 L
s
P
p
.2 1 0 r
.02 w
.63378 .59697 m
.6911 .62822 L
s
P
p
.2 1 0 r
.02 w
.63274 .54565 m
.63378 .59697 L
s
P
p
.2 1 0 r
.02 w
.5744 .51307 m
.63274 .54565 L
s
P
p
.2 1 0 r
.02 w
.57409 .46267 m
.5744 .51307 L
s
P
p
0 .4 1 r
.02 w
.58499 .46086 m
.52572 .42688 L
s
P
p
0 .4 1 r
.02 w
.58543 .51128 m
.58588 .56299 L
s
P
p
0 .4 1 r
.02 w
.52541 .47764 m
.58543 .51128 L
s
P
p
0 .4 1 r
.02 w
.52572 .42688 m
.52541 .47764 L
s
P
p
0 .4 1 r
.02 w
.58588 .56299 m
.52509 .52972 L
s
P
p
0 .4 1 r
.02 w
.52509 .52972 m
.46237 .4954 L
s
P
p
0 .4 1 r
.02 w
.46237 .4954 m
.39763 .45997 L
s
P
p
0 .4 1 r
.02 w
.4612 .54925 m
.45999 .60455 L
s
P
p
0 .4 1 r
.02 w
.39556 .51422 m
.4612 .54925 L
s
P
p
0 .4 1 r
.02 w
.39763 .45997 m
.39556 .51422 L
s
P
p
0 .4 1 r
.02 w
.45999 .60455 m
.39344 .56995 L
s
P
p
0 .4 1 r
.02 w
.39344 .56995 m
.32464 .53419 L
s
P
p
0 .4 1 r
.02 w
.32464 .53419 m
.2535 .49721 L
s
P
p
0 .4 1 r
.02 w
.32144 .59196 m
.31815 .65138 L
s
P
p
0 .4 1 r
.02 w
.24921 .55544 m
.32144 .59196 L
s
P
p
0 .4 1 r
.02 w
.2535 .49721 m
.24921 .55544 L
s
P
p
0 .4 1 r
.02 w
.31815 .65138 m
.2448 .61538 L
s
P
p
0 .4 1 r
.02 w
.2448 .61538 m
.16883 .57808 L
s
P
p
0 .4 1 r
.02 w
.16883 .57808 m
.09009 .53943 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.0169173 0.700501 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.429751 1.9597 0.0248227 0.992908 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.90428 .74445 m
.85327 .71664 L
s
P
p
.2 1 0 r
.02 w
.90848 .79509 m
.90428 .74445 L
s
P
p
.2 1 0 r
.02 w
.84971 .66681 m
.79779 .63781 L
s
P
p
.2 1 0 r
.02 w
.85327 .71664 m
.84971 .66681 L
s
P
p
.2 1 0 r
.02 w
.85691 .76767 m
.90848 .79509 L
s
P
p
.2 1 0 r
.02 w
.79779 .63781 m
.80077 .68802 L
s
P
p
.2 1 0 r
.02 w
.74205 .55861 m
.68769 .52756 L
s
P
p
.2 1 0 r
.02 w
.74437 .60798 m
.74205 .55861 L
s
P
p
.2 1 0 r
.02 w
.80383 .73944 m
.85691 .76767 L
s
P
p
.2 1 0 r
.02 w
.80077 .68802 m
.74674 .65856 L
s
P
p
.2 1 0 r
.02 w
.74674 .65856 m
.74437 .60798 L
s
P
p
.2 1 0 r
.02 w
.68769 .52756 m
.68938 .57728 L
s
P
p
.2 1 0 r
.02 w
.86063 .81994 m
.80696 .79214 L
s
P
p
.2 1 0 r
.02 w
.86446 .87349 m
.86063 .81994 L
s
P
p
.2 1 0 r
.02 w
.80696 .79214 m
.80383 .73944 L
s
P
p
.2 1 0 r
.02 w
.68938 .57728 m
.63274 .54565 L
s
P
p
.2 1 0 r
.02 w
.81016 .84615 m
.86446 .87349 L
s
P
p
.2 1 0 r
.02 w
.6911 .62822 m
.69287 .68045 L
s
P
p
.2 1 0 r
.02 w
.63378 .59697 m
.6911 .62822 L
s
P
p
.01 w
.63274 .54565 Mdot
P
p
.2 1 0 r
.02 w
.63274 .54565 m
.63378 .59697 L
s
P
p
.01 w
.64366 .54391 Mdot
P
p
0 .4 1 r
.02 w
.64366 .54391 m
.64484 .59525 L
s
P
p
0 .4 1 r
.02 w
.58499 .46086 m
.52572 .42688 L
s
P
p
0 .4 1 r
.02 w
.58543 .51128 m
.58499 .46086 L
s
P
p
.2 1 0 r
.02 w
.81345 .90153 m
.81016 .84615 L
s
P
p
.2 1 0 r
.02 w
.75166 .76351 m
.75422 .81798 L
s
P
p
.2 1 0 r
.02 w
.69469 .734 m
.75166 .76351 L
s
P
p
.2 1 0 r
.02 w
.69287 .68045 m
.63485 .6496 L
s
P
p
0 .4 1 r
.02 w
.64484 .59525 m
.58588 .56299 L
s
P
p
0 .4 1 r
.02 w
.58588 .56299 m
.58543 .51128 L
s
P
p
.2 1 0 r
.02 w
.75684 .87385 m
.81345 .90153 L
s
P
p
0 .4 1 r
.02 w
.52572 .42688 m
.52541 .47764 L
s
P
p
.2 1 0 r
.02 w
.75422 .81798 m
.75684 .87385 L
s
P
p
0 .4 1 r
.02 w
.46571 .34206 m
.40353 .30563 L
s
P
p
0 .4 1 r
.02 w
.46462 .39186 m
.46571 .34206 L
s
P
p
.2 1 0 r
.02 w
.69655 .78893 m
.69469 .734 L
s
P
p
.2 1 0 r
.02 w
.63485 .6496 m
.57503 .61779 L
s
P
p
0 .4 1 r
.02 w
.52541 .47764 m
.46351 .44296 L
s
P
p
0 .4 1 r
.02 w
.46351 .44296 m
.46462 .39186 L
s
P
p
.2 1 0 r
.02 w
.63707 .75898 m
.69655 .78893 L
s
P
p
0 .4 1 r
.02 w
.40353 .30563 m
.40162 .35574 L
s
P
p
.2 1 0 r
.02 w
.63594 .70358 m
.63707 .75898 L
s
P
p
.2 1 0 r
.02 w
.57535 .6722 m
.63594 .70358 L
s
P
p
0 .4 1 r
.02 w
.34212 .21896 m
.27685 .17993 L
s
P
p
0 .4 1 r
.02 w
.33939 .26806 m
.34212 .21896 L
s
P
p
.2 1 0 r
.02 w
.57503 .61779 m
.57535 .6722 L
s
P
p
0 .4 1 r
.02 w
.40162 .35574 m
.3366 .31847 L
s
P
p
0 .4 1 r
.02 w
.3366 .31847 m
.33939 .26806 L
s
P
p
0 .4 1 r
.02 w
.27685 .17993 m
.27321 .22929 L
s
P
p
0 .4 1 r
.02 w
.21397 .09133 m
.14542 .04952 L
s
P
p
0 .4 1 r
.02 w
.20949 .13964 m
.21397 .09133 L
s
P
p
0 .4 1 r
.02 w
.27321 .22929 m
.20489 .18927 L
s
P
p
0 .4 1 r
.02 w
.20489 .18927 m
.20949 .13964 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.0169173 0.838346 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.843591 2.75532 0.0104836 0.965382 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.85118 .42558 m
.78262 .39677 L
s
P
p
.2 1 0 r
.02 w
.85482 .46799 m
.85118 .42558 L
s
P
p
.2 1 0 r
.02 w
.77979 .35507 m
.71009 .32521 L
s
P
p
.2 1 0 r
.02 w
.78262 .39677 m
.77979 .35507 L
s
P
p
.2 1 0 r
.02 w
.78552 .43943 m
.85482 .46799 L
s
P
p
.2 1 0 r
.02 w
.71009 .32521 m
.71214 .36714 L
s
P
p
.2 1 0 r
.02 w
.63722 .25333 m
.56436 .22154 L
s
P
p
.2 1 0 r
.02 w
.63842 .29451 m
.63722 .25333 L
s
P
p
.2 1 0 r
.02 w
.71424 .41006 m
.78552 .43943 L
s
P
p
.2 1 0 r
.02 w
.71214 .36714 m
.63966 .33667 L
s
P
p
.2 1 0 r
.02 w
.63966 .33667 m
.63842 .29451 L
s
P
p
.2 1 0 r
.02 w
.56436 .22154 m
.56472 .26294 L
s
P
p
.2 1 0 r
.02 w
.78848 .4831 m
.7164 .454 L
s
P
p
.2 1 0 r
.02 w
.79151 .5278 m
.78848 .4831 L
s
P
p
.2 1 0 r
.02 w
.7164 .454 m
.71424 .41006 L
s
P
p
.2 1 0 r
.02 w
.56472 .26294 m
.48889 .23045 L
s
P
p
.2 1 0 r
.02 w
.7186 .499 m
.79151 .5278 L
s
P
p
.2 1 0 r
.02 w
.56509 .30532 m
.56547 .34874 L
s
P
p
.2 1 0 r
.02 w
.48834 .27306 m
.56509 .30532 L
s
P
p
.01 w
.48889 .23045 Mdot
P
p
.2 1 0 r
.02 w
.48889 .23045 m
.48834 .27306 L
s
P
p
.01 w
.50295 .22866 Mdot
P
p
0 .4 1 r
.02 w
.50295 .22866 m
.50257 .27129 L
s
P
p
.2 1 0 r
.02 w
.72086 .54511 m
.7186 .499 L
s
P
p
.2 1 0 r
.02 w
.64222 .42406 m
.64355 .46936 L
s
P
p
.2 1 0 r
.02 w
.56585 .39323 m
.64222 .42406 L
s
P
p
.2 1 0 r
.02 w
.56547 .34874 m
.48777 .31672 L
s
P
p
0 .4 1 r
.02 w
.57972 .34703 m
.58028 .39153 L
s
P
p
0 .4 1 r
.02 w
.50218 .31496 m
.57972 .34703 L
s
P
p
0 .4 1 r
.02 w
.50257 .27129 m
.50218 .31496 L
s
P
p
.2 1 0 r
.02 w
.64491 .51578 m
.72086 .54511 L
s
P
p
.2 1 0 r
.02 w
.64355 .46936 m
.64491 .51578 L
s
P
p
.2 1 0 r
.02 w
.56625 .43882 m
.56585 .39323 L
s
P
p
0 .4 1 r
.02 w
.58028 .39153 m
.50178 .35973 L
s
P
p
.2 1 0 r
.02 w
.48777 .31672 m
.40775 .28374 L
s
P
p
.2 1 0 r
.02 w
.4866 .40736 m
.56625 .43882 L
s
P
p
.2 1 0 r
.02 w
.4872 .36148 m
.4866 .40736 L
s
P
p
.2 1 0 r
.02 w
.40615 .32876 m
.4872 .36148 L
s
P
p
0 .4 1 r
.02 w
.50178 .35973 m
.42088 .32696 L
s
P
p
.2 1 0 r
.02 w
.40775 .28374 m
.40615 .32876 L
s
P
p
0 .4 1 r
.02 w
.42088 .32696 m
.41943 .37315 L
s
P
p
0 .4 1 r
.02 w
.50095 .45271 m
.50052 .50101 L
s
P
p
0 .4 1 r
.02 w
.41794 .42053 m
.50095 .45271 L
s
P
p
0 .4 1 r
.02 w
.41943 .37315 m
.41794 .42053 L
s
P
p
0 .4 1 r
.02 w
.50052 .50101 m
.41641 .46917 L
s
P
p
0 .4 1 r
.02 w
.41641 .46917 m
.32959 .43632 L
s
P
p
0 .4 1 r
.02 w
.32959 .43632 m
.32681 .48663 L
s
P
p
0 .4 1 r
.02 w
.41322 .57041 m
.41156 .62311 L
s
P
p
0 .4 1 r
.02 w
.32395 .53832 m
.41322 .57041 L
s
P
p
0 .4 1 r
.02 w
.32681 .48663 m
.32395 .53832 L
s
P
p
0 .4 1 r
.02 w
.41156 .62311 m
.32102 .59146 L
s
P
p
0 .4 1 r
.02 w
.32102 .59146 m
.22739 .55873 L
s
P
p
0 .4 1 r
.02 w
.22739 .55873 m
.22298 .61384 L
s
P
p
0 .4 1 r
.02 w
.3149 .70231 m
.3117 .76016 L
s
P
p
0 .4 1 r
.02 w
.21843 .67057 m
.3149 .70231 L
s
P
p
0 .4 1 r
.02 w
.22298 .61384 m
.21843 .67057 L
s
P
p
0 .4 1 r
.02 w
.3117 .76016 m
.21375 .72898 L
s
P
p
0 .4 1 r
.02 w
.21375 .72898 m
.11224 .69666 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.0169173 0.97619 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.620876 2.33546 0.0240342 0.961369 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.86828 .44279 m
.84426 .43069 L
s
P
p
.2 1 0 r
.02 w
.86999 .46062 m
.86828 .44279 L
s
P
p
.2 1 0 r
.02 w
.84268 .413 m
.81848 .40069 L
s
P
p
.2 1 0 r
.02 w
.84426 .43069 m
.84268 .413 L
s
P
p
.2 1 0 r
.02 w
.84585 .44856 m
.86999 .46062 L
s
P
p
.2 1 0 r
.02 w
.81848 .40069 m
.81994 .41843 L
s
P
p
.2 1 0 r
.02 w
.79264 .37063 m
.76793 .35795 L
s
P
p
.2 1 0 r
.02 w
.79396 .38822 m
.79264 .37063 L
s
P
p
.2 1 0 r
.02 w
.82141 .43635 m
.84585 .44856 L
s
P
p
.2 1 0 r
.02 w
.81994 .41843 m
.7953 .406 L
s
P
p
.2 1 0 r
.02 w
.7953 .406 m
.79396 .38822 L
s
P
p
.2 1 0 r
.02 w
.76793 .35795 m
.76913 .37559 L
s
P
p
.2 1 0 r
.02 w
.84747 .46663 m
.8229 .45447 L
s
P
p
.2 1 0 r
.02 w
.84909 .4849 m
.84747 .46663 L
s
P
p
.2 1 0 r
.02 w
.8229 .45447 m
.82141 .43635 L
s
P
p
.2 1 0 r
.02 w
.76913 .37559 m
.74397 .3628 L
s
P
p
.2 1 0 r
.02 w
.8244 .47279 m
.84909 .4849 L
s
P
p
0 .4 1 r
.02 w
.80164 .4233 m
.80303 .44148 L
s
P
p
0 .4 1 r
.02 w
.77657 .41076 m
.80164 .4233 L
s
P
p
.2 1 0 r
.02 w
.77034 .39342 m
.77156 .41145 L
s
P
p
.2 1 0 r
.02 w
.74505 .38067 m
.77034 .39342 L
s
P
p
0 .4 1 r
.02 w
.77532 .39274 m
.77657 .41076 L
s
P
p
0 .4 1 r
.02 w
.75006 .37998 m
.77532 .39274 L
s
P
p
.01 w
.74397 .3628 Mdot
P
p
.2 1 0 r
.02 w
.74397 .3628 m
.74505 .38067 L
s
P
p
.01 w
.74895 .3621 Mdot
P
p
0 .4 1 r
.02 w
.74895 .3621 m
.75006 .37998 L
s
P
p
.2 1 0 r
.02 w
.82592 .49131 m
.8244 .47279 L
s
P
p
.2 1 0 r
.02 w
.79801 .44215 m
.79939 .46052 L
s
P
p
.2 1 0 r
.02 w
.77279 .42967 m
.79801 .44215 L
s
P
p
0 .4 1 r
.02 w
.80303 .44148 m
.77784 .42899 L
s
P
p
.2 1 0 r
.02 w
.77156 .41145 m
.74614 .39875 L
s
P
p
.2 1 0 r
.02 w
.80078 .47909 m
.82592 .49131 L
s
P
p
.2 1 0 r
.02 w
.79939 .46052 m
.80078 .47909 L
s
P
p
.2 1 0 r
.02 w
.77404 .44809 m
.77279 .42967 L
s
P
p
0 .4 1 r
.02 w
.77784 .42899 m
.77911 .44741 L
s
P
p
.2 1 0 r
.02 w
.74614 .39875 m
.72038 .38588 L
s
P
p
.2 1 0 r
.02 w
.74835 .4355 m
.77404 .44809 L
s
P
p
0 .4 1 r
.02 w
.77911 .44741 m
.75345 .43481 L
s
P
p
.2 1 0 r
.02 w
.74724 .41702 m
.74835 .4355 L
s
P
p
.2 1 0 r
.02 w
.72135 .4042 m
.74724 .41702 L
s
P
p
.2 1 0 r
.02 w
.72038 .38588 m
.72135 .4042 L
s
P
p
0 .4 1 r
.02 w
.75345 .43481 m
.72744 .42203 L
s
P
p
0 .4 1 r
.02 w
.75461 .45349 m
.75577 .47239 L
s
P
p
0 .4 1 r
.02 w
.72846 .44077 m
.75461 .45349 L
s
P
p
0 .4 1 r
.02 w
.72744 .42203 m
.72846 .44077 L
s
P
p
0 .4 1 r
.02 w
.75577 .47239 m
.75696 .4915 L
s
P
p
0 .4 1 r
.02 w
.75577 .47239 m
.72949 .45973 L
s
P
p
0 .4 1 r
.02 w
.72949 .45973 m
.72846 .44077 L
s
P
p
0 .4 1 r
.02 w
.75696 .4915 m
.73053 .47889 L
s
P
p
0 .4 1 r
.02 w
.73053 .47889 m
.73158 .49828 L
s
P
p
0 .4 1 r
.02 w
.70285 .44689 m
.67583 .43387 L
s
P
p
0 .4 1 r
.02 w
.70374 .46611 m
.70285 .44689 L
s
P
p
0 .4 1 r
.02 w
.73158 .49828 m
.70465 .48556 L
s
P
p
0 .4 1 r
.02 w
.70465 .48556 m
.70374 .46611 L
s
P
p
0 .4 1 r
.02 w
.67583 .43387 m
.64845 .42068 L
s
P
p
0 .4 1 r
.02 w
.64845 .42068 m
.62068 .4073 L
s
P
p
0 .4 1 r
.02 w
.67733 .47267 m
.67809 .4924 L
s
P
p
0 .4 1 r
.02 w
.64964 .45959 m
.67733 .47267 L
s
P
p
0 .4 1 r
.02 w
.64904 .44002 m
.64964 .45959 L
s
P
p
0 .4 1 r
.02 w
.62111 .4267 m
.64904 .44002 L
s
P
p
0 .4 1 r
.02 w
.62068 .4073 m
.62111 .4267 L
s
P
p
0 .4 1 r
.02 w
.67809 .4924 m
.65024 .47939 L
s
P
p
0 .4 1 r
.02 w
.65024 .47939 m
.65085 .49942 L
s
P
p
0 .4 1 r
.02 w
.65085 .49942 m
.62244 .48629 L
s
P
p
0 .4 1 r
.02 w
.62244 .48629 m
.59362 .47296 L
s
P
p
0 .4 1 r
.02 w
.62289 .50663 m
.62335 .52721 L
s
P
p
0 .4 1 r
.02 w
.5939 .49337 m
.62289 .50663 L
s
P
p
0 .4 1 r
.02 w
.59362 .47296 m
.5939 .49337 L
s
P
p
0 .4 1 r
.02 w
.62335 .52721 m
.62382 .54804 L
s
P
p
0 .4 1 r
.02 w
.62335 .52721 m
.59418 .51402 L
s
P
p
0 .4 1 r
.02 w
.59418 .51402 m
.5939 .49337 L
s
P
p
0 .4 1 r
.02 w
.62382 .54804 m
.59447 .53493 L
s
P
p
0 .4 1 r
.02 w
.59447 .53493 m
.59477 .55609 L
s
P
p
0 .4 1 r
.02 w
.56459 .50064 m
.53456 .48706 L
s
P
p
0 .4 1 r
.02 w
.5647 .52162 m
.56459 .50064 L
s
P
p
0 .4 1 r
.02 w
.59477 .55609 m
.56481 .54286 L
s
P
p
0 .4 1 r
.02 w
.56481 .54286 m
.5647 .52162 L
s
P
p
0 .4 1 r
.02 w
.53456 .48706 m
.50407 .47328 L
s
P
p
0 .4 1 r
.02 w
.50407 .47328 m
.47314 .45929 L
s
P
p
0 .4 1 r
.02 w
.5344 .52943 m
.53432 .55101 L
s
P
p
0 .4 1 r
.02 w
.50354 .51579 m
.5344 .52943 L
s
P
p
0 .4 1 r
.02 w
.50381 .4944 m
.50354 .51579 L
s
P
p
0 .4 1 r
.02 w
.47267 .48049 m
.50381 .4944 L
s
P
p
0 .4 1 r
.02 w
.47314 .45929 m
.47267 .48049 L
s
P
p
0 .4 1 r
.02 w
.53432 .55101 m
.50326 .53745 L
s
P
p
0 .4 1 r
.02 w
.50326 .53745 m
.50298 .55938 L
s
P
p
0 .4 1 r
.02 w
.50298 .55938 m
.47124 .5457 L
s
P
p
0 .4 1 r
.02 w
.47124 .5457 m
.43901 .5318 L
s
P
p
0 .4 1 r
.02 w
.47075 .568 m
.47026 .59059 L
s
P
p
0 .4 1 r
.02 w
.43831 .55419 m
.47075 .568 L
s
P
p
0 .4 1 r
.02 w
.43901 .5318 m
.43831 .55419 L
s
P
p
0 .4 1 r
.02 w
.47026 .59059 m
.46976 .61347 L
s
P
p
0 .4 1 r
.02 w
.47026 .59059 m
.43759 .57686 L
s
P
p
0 .4 1 r
.02 w
.43759 .57686 m
.43831 .55419 L
s
P
p
0 .4 1 r
.02 w
.46976 .61347 m
.43687 .59984 L
s
P
p
0 .4 1 r
.02 w
.43687 .59984 m
.43614 .62312 L
s
P
p
0 .4 1 r
.02 w
.40441 .56292 m
.3707 .54875 L
s
P
p
0 .4 1 r
.02 w
.40346 .58598 m
.40441 .56292 L
s
P
p
0 .4 1 r
.02 w
.43614 .62312 m
.4025 .60936 L
s
P
p
0 .4 1 r
.02 w
.4025 .60936 m
.40346 .58598 L
s
P
p
0 .4 1 r
.02 w
.3707 .54875 m
.33644 .53436 L
s
P
p
0 .4 1 r
.02 w
.33644 .53436 m
.30163 .51973 L
s
P
p
0 .4 1 r
.02 w
.36832 .59538 m
.36711 .61917 L
s
P
p
0 .4 1 r
.02 w
.33358 .58117 m
.36832 .59538 L
s
P
p
0 .4 1 r
.02 w
.33502 .5576 m
.33358 .58117 L
s
P
p
0 .4 1 r
.02 w
.29996 .54307 m
.33502 .5576 L
s
P
p
0 .4 1 r
.02 w
.30163 .51973 m
.29996 .54307 L
s
P
p
0 .4 1 r
.02 w
.36711 .61917 m
.33212 .60506 L
s
P
p
0 .4 1 r
.02 w
.33212 .60506 m
.33064 .62927 L
s
P
p
0 .4 1 r
.02 w
.33064 .62927 m
.29481 .61503 L
s
P
p
0 .4 1 r
.02 w
.29481 .61503 m
.25837 .60054 L
s
P
p
0 .4 1 r
.02 w
.29304 .63969 m
.29125 .66469 L
s
P
p
0 .4 1 r
.02 w
.25634 .62531 m
.29304 .63969 L
s
P
p
0 .4 1 r
.02 w
.25837 .60054 m
.25634 .62531 L
s
P
p
0 .4 1 r
.02 w
.29125 .66469 m
.28943 .69006 L
s
P
p
0 .4 1 r
.02 w
.29125 .66469 m
.25427 .65043 L
s
P
p
0 .4 1 r
.02 w
.25427 .65043 m
.25634 .62531 L
s
P
p
0 .4 1 r
.02 w
.28943 .69006 m
.25217 .67591 L
s
P
p
0 .4 1 r
.02 w
.25217 .67591 m
.25005 .70175 L
s
P
p
0 .4 1 r
.02 w
.21665 .63592 m
.17838 .62116 L
s
P
p
0 .4 1 r
.02 w
.21426 .66151 m
.21665 .63592 L
s
P
p
0 .4 1 r
.02 w
.25005 .70175 m
.21184 .68748 L
s
P
p
0 .4 1 r
.02 w
.21184 .68748 m
.21426 .66151 L
s
P
p
0 .4 1 r
.02 w
.17838 .62116 m
.13944 .60613 L
s
P
p
0 .4 1 r
.02 w
.13944 .60613 m
.09981 .59085 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.154762 0.149123 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.154762 0.286967 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.154762 0.424812 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.67773 .47655 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.154762 0.562657 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.572415 2.24646 0.0242124 0.968497 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.81733 .52198 m
.78206 .50426 L
s
P
p
0 .4 1 r
.02 w
.81956 .54976 m
.81733 .52198 L
s
P
p
0 .4 1 r
.02 w
.85694 .59511 m
.82183 .57801 L
s
P
p
0 .4 1 r
.02 w
.85952 .62369 m
.85694 .59511 L
s
P
p
0 .4 1 r
.02 w
.78401 .53217 m
.81956 .54976 L
s
P
p
0 .4 1 r
.02 w
.82183 .57801 m
.81956 .54976 L
s
P
p
0 .4 1 r
.02 w
.78206 .50426 m
.78401 .53217 L
s
P
p
0 .4 1 r
.02 w
.89708 .66922 m
.86214 .65276 L
s
P
p
0 .4 1 r
.02 w
.90002 .69862 m
.89708 .66922 L
s
P
p
.2 1 0 r
.02 w
.66168 .36789 m
.62429 .34833 L
s
P
p
.2 1 0 r
.02 w
.66262 .39477 m
.66168 .36789 L
s
P
p
0 .4 1 r
.02 w
.86214 .65276 m
.85952 .62369 L
s
P
p
.2 1 0 r
.02 w
.62367 .3218 m
.58583 .30174 L
s
P
p
.2 1 0 r
.02 w
.62429 .34833 m
.62367 .3218 L
s
P
p
0 .4 1 r
.02 w
.82183 .57801 m
.786 .56056 L
s
P
p
0 .4 1 r
.02 w
.82413 .60674 m
.82183 .57801 L
s
P
p
0 .4 1 r
.02 w
.59262 .27445 m
.55438 .25386 L
s
P
p
0 .4 1 r
.02 w
.59298 .30064 m
.59262 .27445 L
s
P
p
0 .4 1 r
.02 w
.78401 .53217 m
.786 .56056 L
s
P
p
0 .4 1 r
.02 w
.78401 .53217 m
.74773 .51422 L
s
P
p
0 .4 1 r
.02 w
.86481 .68232 m
.90002 .69862 L
s
P
p
.2 1 0 r
.02 w
.62492 .37532 m
.66262 .39477 L
s
P
p
0 .4 1 r
.02 w
.63145 .34726 m
.59334 .32728 L
s
P
p
0 .4 1 r
.02 w
.63214 .37426 m
.63145 .34726 L
s
P
p
0 .4 1 r
.02 w
.78802 .58943 m
.82413 .60674 L
s
P
p
.2 1 0 r
.02 w
.58583 .30174 m
.58613 .32838 L
s
P
p
0 .4 1 r
.02 w
.59334 .32728 m
.59298 .30064 L
s
P
p
0 .4 1 r
.02 w
.786 .56056 m
.74942 .54275 L
s
P
p
0 .4 1 r
.02 w
.786 .56056 m
.78802 .58943 L
s
P
p
.2 1 0 r
.02 w
.54725 .25499 m
.50816 .234 L
s
P
p
.2 1 0 r
.02 w
.54722 .28127 m
.54725 .25499 L
s
P
p
0 .4 1 r
.02 w
.55438 .25386 m
.55441 .28015 L
s
P
p
0 .4 1 r
.02 w
.74773 .51422 m
.7107 .4959 L
s
P
p
0 .4 1 r
.02 w
.74942 .54275 m
.74773 .51422 L
s
P
p
0 .4 1 r
.02 w
.6708 .42107 m
.63284 .40172 L
s
P
p
0 .4 1 r
.02 w
.67184 .44889 m
.6708 .42107 L
s
P
p
0 .4 1 r
.02 w
.82886 .66569 m
.86481 .68232 L
s
P
p
.2 1 0 r
.02 w
.58644 .35547 m
.62492 .37532 L
s
P
p
0 .4 1 r
.02 w
.63284 .40172 m
.63214 .37426 L
s
P
p
.2 1 0 r
.02 w
.58613 .32838 m
.54718 .308 L
s
P
p
0 .4 1 r
.02 w
.78802 .58943 m
.75115 .57177 L
s
P
p
.2 1 0 r
.02 w
.54718 .308 m
.54722 .28127 L
s
P
p
0 .4 1 r
.02 w
.55441 .28015 m
.51504 .25922 L
s
P
p
0 .4 1 r
.02 w
.75115 .57177 m
.74942 .54275 L
s
P
p
.2 1 0 r
.02 w
.50816 .234 m
.50779 .26037 L
s
P
p
0 .4 1 r
.02 w
.7107 .4959 m
.67289 .4772 L
s
P
p
0 .4 1 r
.02 w
.67289 .4772 m
.67184 .44889 L
s
P
p
.2 1 0 r
.02 w
.62556 .40278 m
.58675 .38305 L
s
P
p
.2 1 0 r
.02 w
.62621 .43072 m
.62556 .40278 L
s
P
p
0 .4 1 r
.02 w
.83129 .69593 m
.82886 .66569 L
s
P
p
.2 1 0 r
.02 w
.58675 .38305 m
.58644 .35547 L
s
P
p
.2 1 0 r
.02 w
.50779 .26037 m
.46754 .23903 L
s
P
p
0 .4 1 r
.02 w
.51504 .25922 m
.47484 .23786 L
s
P
p
.2 1 0 r
.02 w
.58707 .4111 m
.62621 .43072 L
s
P
p
0 .4 1 r
.02 w
.79429 .67912 m
.83129 .69593 L
s
P
p
.2 1 0 r
.02 w
.50741 .2872 m
.50703 .31451 L
s
P
p
.2 1 0 r
.02 w
.4668 .26596 m
.50741 .2872 L
s
P
p
0 .4 1 r
.02 w
.51473 .28606 m
.47417 .2648 L
s
P
p
0 .4 1 r
.02 w
.51441 .31338 m
.51473 .28606 L
s
P
p
.01 w
.46754 .23903 Mdot
P
p
.2 1 0 r
.02 w
.46754 .23903 m
.4668 .26596 L
s
P
p
.01 w
.47484 .23786 Mdot
P
p
0 .4 1 r
.02 w
.47484 .23786 m
.47417 .2648 L
s
P
p
.2 1 0 r
.02 w
.58739 .43966 m
.58707 .4111 L
s
P
p
0 .4 1 r
.02 w
.75651 .66194 m
.79429 .67912 L
s
P
p
.2 1 0 r
.02 w
.54712 .36289 m
.54709 .39107 L
s
P
p
.2 1 0 r
.02 w
.50664 .34231 m
.54712 .36289 L
s
P
p
.2 1 0 r
.02 w
.50703 .31451 m
.46605 .29337 L
s
P
p
0 .4 1 r
.02 w
.47348 .29222 m
.51441 .31338 L
s
P
p
0 .4 1 r
.02 w
.51441 .31338 m
.51408 .34118 L
s
P
p
0 .4 1 r
.02 w
.47417 .2648 m
.47348 .29222 L
s
P
p
0 .4 1 r
.02 w
.47417 .2648 m
.43273 .24307 L
s
P
p
.2 1 0 r
.02 w
.54705 .41976 m
.58739 .43966 L
s
P
p
.2 1 0 r
.02 w
.54709 .39107 m
.54705 .41976 L
s
P
p
0 .4 1 r
.02 w
.75836 .69308 m
.75651 .66194 L
s
P
p
.2 1 0 r
.02 w
.50624 .37061 m
.50664 .34231 L
s
P
p
0 .4 1 r
.02 w
.51408 .34118 m
.47278 .32013 L
s
P
p
.2 1 0 r
.02 w
.46605 .29337 m
.42417 .27178 L
s
P
p
0 .4 1 r
.02 w
.47348 .29222 m
.47278 .32013 L
s
P
p
0 .4 1 r
.02 w
.43166 .27059 m
.47348 .29222 L
s
P
p
0 .4 1 r
.02 w
.43273 .24307 m
.3904 .22088 L
s
P
p
0 .4 1 r
.02 w
.43166 .27059 m
.43273 .24307 L
s
P
p
0 .4 1 r
.02 w
.71942 .67571 m
.75836 .69308 L
s
P
p
.2 1 0 r
.02 w
.4645 .3497 m
.50624 .37061 L
s
P
p
.2 1 0 r
.02 w
.46528 .32128 m
.4645 .3497 L
s
P
p
.2 1 0 r
.02 w
.42302 .29979 m
.46528 .32128 L
s
P
p
0 .4 1 r
.02 w
.47278 .32013 m
.43058 .29861 L
s
P
p
.2 1 0 r
.02 w
.42417 .27178 m
.42302 .29979 L
s
P
p
0 .4 1 r
.02 w
.38893 .24849 m
.43166 .27059 L
s
P
p
0 .4 1 r
.02 w
.43166 .27059 m
.43058 .29861 L
s
P
p
0 .4 1 r
.02 w
.3904 .22088 m
.38893 .24849 L
s
P
p
0 .4 1 r
.02 w
.67962 .65796 m
.71942 .67571 L
s
P
p
0 .4 1 r
.02 w
.43058 .29861 m
.42947 .32715 L
s
P
p
0 .4 1 r
.02 w
.68082 .69005 m
.67962 .65796 L
s
P
p
0 .4 1 r
.02 w
.42947 .32715 m
.42834 .35622 L
s
P
p
0 .4 1 r
.02 w
.68204 .72273 m
.68082 .69005 L
s
P
p
0 .4 1 r
.02 w
.42834 .35622 m
.38436 .33446 L
s
P
p
0 .4 1 r
.02 w
.72415 .77318 m
.68328 .75603 L
s
P
p
0 .4 1 r
.02 w
.72578 .8069 m
.72415 .77318 L
s
P
p
0 .4 1 r
.02 w
.64061 .70498 m
.68204 .72273 L
s
P
p
0 .4 1 r
.02 w
.68328 .75603 m
.68204 .72273 L
s
P
p
0 .4 1 r
.02 w
.38436 .33446 m
.33938 .31221 L
s
P
p
0 .4 1 r
.02 w
.68454 .78997 m
.72578 .8069 L
s
P
p
0 .4 1 r
.02 w
.68328 .75603 m
.64147 .73849 L
s
P
p
0 .4 1 r
.02 w
.68328 .75603 m
.68454 .78997 L
s
P
p
0 .4 1 r
.02 w
.64147 .73849 m
.64061 .70498 L
s
P
p
0 .4 1 r
.02 w
.59823 .68681 m
.64061 .70498 L
s
P
p
0 .4 1 r
.02 w
.33938 .31221 m
.33735 .34209 L
s
P
p
0 .4 1 r
.02 w
.64235 .77265 m
.68454 .78997 L
s
P
p
0 .4 1 r
.02 w
.64235 .77265 m
.64147 .73849 L
s
P
p
0 .4 1 r
.02 w
.64147 .73849 m
.59869 .72054 L
s
P
p
0 .4 1 r
.02 w
.59869 .72054 m
.59823 .68681 L
s
P
p
0 .4 1 r
.02 w
.33735 .34209 m
.29087 .31945 L
s
P
p
0 .4 1 r
.02 w
.59916 .75493 m
.64235 .77265 L
s
P
p
0 .4 1 r
.02 w
.64324 .80748 m
.64235 .77265 L
s
P
p
0 .4 1 r
.02 w
.59869 .72054 m
.59916 .75493 L
s
P
p
0 .4 1 r
.02 w
.29087 .31945 m
.24328 .29627 L
s
P
p
0 .4 1 r
.02 w
.59964 .79 m
.64324 .80748 L
s
P
p
0 .4 1 r
.02 w
.24328 .29627 m
.24023 .327 L
s
P
p
0 .4 1 r
.02 w
.42111 .54265 m
.41982 .57588 L
s
P
p
0 .4 1 r
.02 w
.37441 .52182 m
.42111 .54265 L
s
P
p
0 .4 1 r
.02 w
.55499 .77209 m
.59964 .79 L
s
P
p
0 .4 1 r
.02 w
.33103 .43525 m
.32883 .46754 L
s
P
p
0 .4 1 r
.02 w
.28306 .41305 m
.33103 .43525 L
s
P
p
0 .4 1 r
.02 w
.24023 .327 m
.19098 .3034 L
s
P
p
0 .4 1 r
.02 w
.46504 .62973 m
.46418 .6641 L
s
P
p
0 .4 1 r
.02 w
.4185 .60978 m
.46504 .62973 L
s
P
p
0 .4 1 r
.02 w
.41982 .57588 m
.4185 .60978 L
s
P
p
0 .4 1 r
.02 w
.32659 .50049 m
.37441 .52182 L
s
P
p
0 .4 1 r
.02 w
.32883 .46754 m
.32659 .50049 L
s
P
p
0 .4 1 r
.02 w
.28036 .44551 m
.32883 .46754 L
s
P
p
0 .4 1 r
.02 w
.55503 .80811 m
.55499 .77209 L
s
P
p
0 .4 1 r
.02 w
.28306 .41305 m
.23394 .39031 L
s
P
p
0 .4 1 r
.02 w
.28036 .44551 m
.28306 .41305 L
s
P
p
0 .4 1 r
.02 w
.50968 .7182 m
.50926 .75375 L
s
P
p
0 .4 1 r
.02 w
.4633 .69917 m
.50968 .7182 L
s
P
p
0 .4 1 r
.02 w
.46418 .6641 m
.4633 .69917 L
s
P
p
0 .4 1 r
.02 w
.19098 .3034 m
.14053 .27924 L
s
P
p
0 .4 1 r
.02 w
.2776 .47864 m
.32659 .50049 L
s
P
p
0 .4 1 r
.02 w
.50884 .79002 m
.55503 .80811 L
s
P
p
0 .4 1 r
.02 w
.2776 .47864 m
.28036 .44551 L
s
P
p
0 .4 1 r
.02 w
.2307 .42294 m
.28036 .44551 L
s
P
p
0 .4 1 r
.02 w
.50926 .75375 m
.50884 .79002 L
s
P
p
0 .4 1 r
.02 w
.23394 .39031 m
.2307 .42294 L
s
P
p
0 .4 1 r
.02 w
.18733 .33489 m
.1836 .36701 L
s
P
p
0 .4 1 r
.02 w
.13632 .31086 m
.18733 .33489 L
s
P
p
0 .4 1 r
.02 w
.14053 .27924 m
.13632 .31086 L
s
P
p
0 .4 1 r
.02 w
.27478 .51244 m
.2776 .47864 L
s
P
p
0 .4 1 r
.02 w
.2776 .47864 m
.22739 .45624 L
s
P
p
0 .4 1 r
.02 w
.2307 .42294 m
.22739 .45624 L
s
P
p
0 .4 1 r
.02 w
.1798 .3998 m
.2307 .42294 L
s
P
p
0 .4 1 r
.02 w
.1836 .36701 m
.1798 .3998 L
s
P
p
0 .4 1 r
.02 w
.22401 .49024 m
.27478 .51244 L
s
P
p
0 .4 1 r
.02 w
.22739 .45624 m
.22401 .49024 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.154762 0.700501 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.564051 2.22952 0.0242196 0.968782 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.65887 .42288 m
.58269 .38389 L
s
P
p
.2 1 0 r
.02 w
.66076 .47892 m
.65887 .42288 L
s
P
p
.2 1 0 r
.02 w
.58214 .32929 m
.50408 .28819 L
s
P
p
.2 1 0 r
.02 w
.58269 .38389 m
.58214 .32929 L
s
P
p
.2 1 0 r
.02 w
.58326 .44043 m
.66076 .47892 L
s
P
p
.2 1 0 r
.02 w
.50408 .28819 m
.50325 .34322 L
s
P
p
.2 1 0 r
.02 w
.42491 .19182 m
.3415 .14672 L
s
P
p
.2 1 0 r
.02 w
.42266 .24532 m
.42491 .19182 L
s
P
p
.2 1 0 r
.02 w
.50239 .40026 m
.58326 .44043 L
s
P
p
.2 1 0 r
.02 w
.50325 .34322 m
.42033 .30078 L
s
P
p
0 .4 1 r
.02 w
.91912 .88538 m
.92582 .95234 L
s
P
p
0 .4 1 r
.02 w
.84521 .85476 m
.91912 .88538 L
s
P
p
.2 1 0 r
.02 w
.42033 .30078 m
.42266 .24532 L
s
P
p
.2 1 0 r
.02 w
.3415 .14672 m
.33767 .20057 L
s
P
p
0 .4 1 r
.02 w
.76017 .69254 m
.76401 .75646 L
s
P
p
0 .4 1 r
.02 w
.68221 .65745 m
.76017 .69254 L
s
P
p
.2 1 0 r
.02 w
.58385 .49902 m
.50149 .4594 L
s
P
p
.2 1 0 r
.02 w
.58446 .55976 m
.58385 .49902 L
s
P
p
0 .4 1 r
.02 w
.59891 .49691 m
.5998 .5577 L
s
P
p
0 .4 1 r
.02 w
.51679 .45721 m
.59891 .49691 L
s
P
p
.2 1 0 r
.02 w
.50149 .4594 m
.50239 .40026 L
s
P
p
0 .4 1 r
.02 w
.43531 .29843 m
.43316 .35597 L
s
P
p
0 .4 1 r
.02 w
.3489 .25398 m
.43531 .29843 L
s
P
p
0 .4 1 r
.02 w
.76799 .82277 m
.84521 .85476 L
s
P
p
.2 1 0 r
.02 w
.33767 .20057 m
.24885 .15381 L
s
P
p
0 .4 1 r
.02 w
.76401 .75646 m
.76799 .82277 L
s
P
p
0 .4 1 r
.02 w
.60073 .62076 m
.68221 .65745 L
s
P
p
.2 1 0 r
.02 w
.50056 .52078 m
.58446 .55976 L
s
P
p
0 .4 1 r
.02 w
.5998 .5577 m
.60073 .62076 L
s
P
p
0 .4 1 r
.02 w
.43093 .41569 m
.51679 .45721 L
s
P
p
0 .4 1 r
.02 w
.43316 .35597 m
.43093 .41569 L
s
P
p
.2 1 0 r
.02 w
.33369 .25644 m
.32957 .31442 L
s
P
p
.2 1 0 r
.02 w
.2431 .21006 m
.33369 .25644 L
s
P
p
0 .4 1 r
.02 w
.25854 .20749 m
.3489 .25398 L
s
P
p
.01 w
.24885 .15381 Mdot
P
p
.2 1 0 r
.02 w
.24885 .15381 m
.2431 .21006 L
s
P
p
.01 w
.26402 .15122 Mdot
P
p
0 .4 1 r
.02 w
.26402 .15122 m
.25854 .20749 L
s
P
p
.2 1 0 r
.02 w
.4996 .58451 m
.50056 .52078 L
s
P
p
.2 1 0 r
.02 w
.41539 .41799 m
.41278 .47999 L
s
P
p
.2 1 0 r
.02 w
.32529 .37465 m
.41539 .41799 L
s
P
p
.2 1 0 r
.02 w
.32957 .31442 m
.23712 .2685 L
s
P
p
.2 1 0 r
.02 w
.41007 .54443 m
.4996 .58451 L
s
P
p
.2 1 0 r
.02 w
.41278 .47999 m
.41007 .54443 L
s
P
p
.2 1 0 r
.02 w
.32084 .43727 m
.32529 .37465 L
s
P
p
.2 1 0 r
.02 w
.23712 .2685 m
.14024 .22039 L
s
P
p
.2 1 0 r
.02 w
.22443 .39247 m
.32084 .43727 L
s
P
p
.2 1 0 r
.02 w
.2309 .32926 m
.22443 .39247 L
s
P
p
.2 1 0 r
.02 w
.13191 .28164 m
.2309 .32926 L
s
P
p
.2 1 0 r
.02 w
.14024 .22039 m
.13191 .28164 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.154762 0.838346 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.564051 2.22952 0.0242196 0.968782 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.86973 .53081 m
.80222 .49625 L
s
P
p
.2 1 0 r
.02 w
.87496 .58531 m
.86973 .53081 L
s
P
p
.2 1 0 r
.02 w
.79815 .44302 m
.729 .40661 L
s
P
p
.2 1 0 r
.02 w
.80222 .49625 m
.79815 .44302 L
s
P
p
.2 1 0 r
.02 w
.80642 .55127 m
.87496 .58531 L
s
P
p
.2 1 0 r
.02 w
.729 .40661 m
.73199 .46031 L
s
P
p
.2 1 0 r
.02 w
.65529 .31637 m
.58161 .27653 L
s
P
p
.2 1 0 r
.02 w
.65705 .36873 m
.65529 .31637 L
s
P
p
.2 1 0 r
.02 w
.73508 .51583 m
.80642 .55127 L
s
P
p
.2 1 0 r
.02 w
.73199 .46031 m
.65887 .42288 L
s
P
p
.2 1 0 r
.02 w
.65887 .42288 m
.65705 .36873 L
s
P
p
.2 1 0 r
.02 w
.58161 .27653 m
.58214 .32929 L
s
P
p
.2 1 0 r
.02 w
.81077 .60816 m
.73828 .57329 L
s
P
p
.2 1 0 r
.02 w
.81527 .66701 m
.81077 .60816 L
s
P
p
.2 1 0 r
.02 w
.73828 .57329 m
.73508 .51583 L
s
P
p
.2 1 0 r
.02 w
.58214 .32929 m
.50408 .28819 L
s
P
p
.2 1 0 r
.02 w
.74159 .63278 m
.81527 .66701 L
s
P
p
.2 1 0 r
.02 w
.58269 .38389 m
.58326 .44043 L
s
P
p
.2 1 0 r
.02 w
.50325 .34322 m
.58269 .38389 L
s
P
p
0 .4 1 r
.02 w
.59723 .38173 m
.59806 .4383 L
s
P
p
0 .4 1 r
.02 w
.518 .34097 m
.59723 .38173 L
s
P
p
.01 w
.50408 .28819 Mdot
P
p
.2 1 0 r
.02 w
.50408 .28819 m
.50325 .34322 L
s
P
p
.01 w
.51858 .28591 Mdot
P
p
0 .4 1 r
.02 w
.51858 .28591 m
.518 .34097 L
s
P
p
.2 1 0 r
.02 w
.74502 .6944 m
.74159 .63278 L
s
P
p
.2 1 0 r
.02 w
.66271 .53694 m
.66473 .59706 L
s
P
p
.2 1 0 r
.02 w
.58385 .49902 m
.66271 .53694 L
s
P
p
.2 1 0 r
.02 w
.58326 .44043 m
.50239 .40026 L
s
P
p
0 .4 1 r
.02 w
.59806 .4383 m
.51741 .39803 L
s
P
p
.2 1 0 r
.02 w
.66682 .65939 m
.74502 .6944 L
s
P
p
.2 1 0 r
.02 w
.66473 .59706 m
.66682 .65939 L
s
P
p
.2 1 0 r
.02 w
.58446 .55976 m
.58385 .49902 L
s
P
p
.2 1 0 r
.02 w
.50239 .40026 m
.4179 .3583 L
s
P
p
0 .4 1 r
.02 w
.51741 .39803 m
.43316 .35597 L
s
P
p
.2 1 0 r
.02 w
.50056 .52078 m
.58446 .55976 L
s
P
p
.2 1 0 r
.02 w
.50149 .4594 m
.50056 .52078 L
s
P
p
.2 1 0 r
.02 w
.41539 .41799 m
.50149 .4594 L
s
P
p
0 .4 1 r
.02 w
.51679 .45721 m
.51615 .51862 L
s
P
p
0 .4 1 r
.02 w
.43093 .41569 m
.51679 .45721 L
s
P
p
.2 1 0 r
.02 w
.4179 .3583 m
.41539 .41799 L
s
P
p
0 .4 1 r
.02 w
.43316 .35597 m
.43093 .41569 L
s
P
p
0 .4 1 r
.02 w
.51615 .51862 m
.42862 .47773 L
s
P
p
0 .4 1 r
.02 w
.42862 .47773 m
.33693 .43489 L
s
P
p
0 .4 1 r
.02 w
.42621 .5422 m
.42371 .60927 L
s
P
p
0 .4 1 r
.02 w
.33262 .50007 m
.42621 .5422 L
s
P
p
0 .4 1 r
.02 w
.33693 .43489 m
.33262 .50007 L
s
P
p
0 .4 1 r
.02 w
.42371 .60927 m
.32813 .56792 L
s
P
p
0 .4 1 r
.02 w
.32813 .56792 m
.2277 .52448 L
s
P
p
0 .4 1 r
.02 w
.32345 .63863 m
.31857 .71238 L
s
P
p
0 .4 1 r
.02 w
.22074 .59608 m
.32345 .63863 L
s
P
p
0 .4 1 r
.02 w
.2277 .52448 m
.22074 .59608 L
s
P
p
0 .4 1 r
.02 w
.31857 .71238 m
.21346 .67084 L
s
P
p
0 .4 1 r
.02 w
.21346 .67084 m
.10265 .62705 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.154762 0.97619 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.564051 2.22952 0.0242196 0.968782 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.86973 .53081 m
.80222 .49625 L
s
P
p
.2 1 0 r
.02 w
.87496 .58531 m
.86973 .53081 L
s
P
p
.2 1 0 r
.02 w
.79815 .44302 m
.729 .40661 L
s
P
p
.2 1 0 r
.02 w
.80222 .49625 m
.79815 .44302 L
s
P
p
.2 1 0 r
.02 w
.80642 .55127 m
.87496 .58531 L
s
P
p
.2 1 0 r
.02 w
.729 .40661 m
.73199 .46031 L
s
P
p
.2 1 0 r
.02 w
.65529 .31637 m
.58161 .27653 L
s
P
p
.2 1 0 r
.02 w
.65705 .36873 m
.65529 .31637 L
s
P
p
.2 1 0 r
.02 w
.73508 .51583 m
.80642 .55127 L
s
P
p
.2 1 0 r
.02 w
.73199 .46031 m
.65887 .42288 L
s
P
p
.2 1 0 r
.02 w
.65887 .42288 m
.65705 .36873 L
s
P
p
.2 1 0 r
.02 w
.58161 .27653 m
.58214 .32929 L
s
P
p
.2 1 0 r
.02 w
.81077 .60816 m
.73828 .57329 L
s
P
p
.2 1 0 r
.02 w
.81527 .66701 m
.81077 .60816 L
s
P
p
.2 1 0 r
.02 w
.73828 .57329 m
.73508 .51583 L
s
P
p
.2 1 0 r
.02 w
.58214 .32929 m
.50408 .28819 L
s
P
p
.2 1 0 r
.02 w
.74159 .63278 m
.81527 .66701 L
s
P
p
.2 1 0 r
.02 w
.58269 .38389 m
.58326 .44043 L
s
P
p
.2 1 0 r
.02 w
.50325 .34322 m
.58269 .38389 L
s
P
p
0 .4 1 r
.02 w
.59723 .38173 m
.59806 .4383 L
s
P
p
0 .4 1 r
.02 w
.518 .34097 m
.59723 .38173 L
s
P
p
.01 w
.50408 .28819 Mdot
P
p
.2 1 0 r
.02 w
.50408 .28819 m
.50325 .34322 L
s
P
p
.01 w
.51858 .28591 Mdot
P
p
0 .4 1 r
.02 w
.51858 .28591 m
.518 .34097 L
s
P
p
.2 1 0 r
.02 w
.74502 .6944 m
.74159 .63278 L
s
P
p
.2 1 0 r
.02 w
.66271 .53694 m
.66473 .59706 L
s
P
p
.2 1 0 r
.02 w
.58385 .49902 m
.66271 .53694 L
s
P
p
.2 1 0 r
.02 w
.58326 .44043 m
.50239 .40026 L
s
P
p
0 .4 1 r
.02 w
.59806 .4383 m
.51741 .39803 L
s
P
p
.2 1 0 r
.02 w
.66682 .65939 m
.74502 .6944 L
s
P
p
.2 1 0 r
.02 w
.66473 .59706 m
.66682 .65939 L
s
P
p
.2 1 0 r
.02 w
.58446 .55976 m
.58385 .49902 L
s
P
p
.2 1 0 r
.02 w
.50239 .40026 m
.4179 .3583 L
s
P
p
0 .4 1 r
.02 w
.51741 .39803 m
.43316 .35597 L
s
P
p
.2 1 0 r
.02 w
.50056 .52078 m
.58446 .55976 L
s
P
p
.2 1 0 r
.02 w
.50149 .4594 m
.50056 .52078 L
s
P
p
.2 1 0 r
.02 w
.41539 .41799 m
.50149 .4594 L
s
P
p
0 .4 1 r
.02 w
.51679 .45721 m
.51615 .51862 L
s
P
p
0 .4 1 r
.02 w
.43093 .41569 m
.51679 .45721 L
s
P
p
.2 1 0 r
.02 w
.4179 .3583 m
.41539 .41799 L
s
P
p
0 .4 1 r
.02 w
.43316 .35597 m
.43093 .41569 L
s
P
p
0 .4 1 r
.02 w
.51615 .51862 m
.42862 .47773 L
s
P
p
0 .4 1 r
.02 w
.42862 .47773 m
.33693 .43489 L
s
P
p
0 .4 1 r
.02 w
.42621 .5422 m
.42371 .60927 L
s
P
p
0 .4 1 r
.02 w
.33262 .50007 m
.42621 .5422 L
s
P
p
0 .4 1 r
.02 w
.33693 .43489 m
.33262 .50007 L
s
P
p
0 .4 1 r
.02 w
.42371 .60927 m
.32813 .56792 L
s
P
p
0 .4 1 r
.02 w
.32813 .56792 m
.2277 .52448 L
s
P
p
0 .4 1 r
.02 w
.32345 .63863 m
.31857 .71238 L
s
P
p
0 .4 1 r
.02 w
.22074 .59608 m
.32345 .63863 L
s
P
p
0 .4 1 r
.02 w
.2277 .52448 m
.22074 .59608 L
s
P
p
0 .4 1 r
.02 w
.31857 .71238 m
.21346 .67084 L
s
P
p
0 .4 1 r
.02 w
.21346 .67084 m
.10265 .62705 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.292607 0.149123 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.466291 2.03299 0.0246585 0.986339 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.88519 .6063 m
.81439 .56704 L
s
P
p
.2 1 0 r
.02 w
.89077 .67127 m
.88519 .6063 L
s
P
p
.2 1 0 r
.02 w
.81004 .50357 m
.73749 .46211 L
s
P
p
.2 1 0 r
.02 w
.81439 .56704 m
.81004 .50357 L
s
P
p
.2 1 0 r
.02 w
.81888 .63266 m
.89077 .67127 L
s
P
p
.2 1 0 r
.02 w
.73749 .46211 m
.74068 .52616 L
s
P
p
.2 1 0 r
.02 w
.66007 .35647 m
.58268 .31097 L
s
P
p
.2 1 0 r
.02 w
.66195 .41894 m
.66007 .35647 L
s
P
p
.2 1 0 r
.02 w
.74399 .59244 m
.81888 .63266 L
s
P
p
.2 1 0 r
.02 w
.74068 .52616 m
.66389 .48358 L
s
P
p
.2 1 0 r
.02 w
.66389 .48358 m
.66195 .41894 L
s
P
p
.2 1 0 r
.02 w
.58268 .31097 m
.58324 .37396 L
s
P
p
.2 1 0 r
.02 w
.82352 .70055 m
.74741 .66106 L
s
P
p
.2 1 0 r
.02 w
.82833 .77083 m
.82352 .70055 L
s
P
p
.2 1 0 r
.02 w
.74741 .66106 m
.74399 .59244 L
s
P
p
.2 1 0 r
.02 w
.58324 .37396 m
.50117 .32705 L
s
P
p
.2 1 0 r
.02 w
.75095 .73214 m
.82833 .77083 L
s
P
p
.2 1 0 r
.02 w
.58383 .43918 m
.58444 .50676 L
s
P
p
.2 1 0 r
.02 w
.50028 .39284 m
.58383 .43918 L
s
P
p
0 .4 1 r
.02 w
.59912 .43672 m
.6 .50434 L
s
P
p
0 .4 1 r
.02 w
.5158 .39027 m
.59912 .43672 L
s
P
p
.01 w
.50117 .32705 Mdot
P
p
.2 1 0 r
.02 w
.50117 .32705 m
.50028 .39284 L
s
P
p
.01 w
.51641 .32445 Mdot
P
p
0 .4 1 r
.02 w
.5158 .39027 m
.51641 .32445 L
s
P
p
.2 1 0 r
.02 w
.75463 .80583 m
.75095 .73214 L
s
P
p
.2 1 0 r
.02 w
.668 .61986 m
.67016 .69175 L
s
P
p
.2 1 0 r
.02 w
.58507 .57683 m
.668 .61986 L
s
P
p
.2 1 0 r
.02 w
.58444 .50676 m
.49935 .46107 L
s
P
p
0 .4 1 r
.02 w
.6 .50434 m
.60092 .57445 L
s
P
p
0 .4 1 r
.02 w
.42876 .34175 m
.5158 .39027 L
s
P
p
.2 1 0 r
.02 w
.67241 .76634 m
.75463 .80583 L
s
P
p
.2 1 0 r
.02 w
.67016 .69175 m
.67241 .76634 L
s
P
p
0 .4 1 r
.02 w
.68606 .68951 m
.60188 .6472 L
s
P
p
.2 1 0 r
.02 w
.58573 .64954 m
.58507 .57683 L
s
P
p
0 .4 1 r
.02 w
.60092 .57445 m
.60188 .6472 L
s
P
p
.2 1 0 r
.02 w
.49935 .46107 m
.4104 .4133 L
s
P
p
0 .4 1 r
.02 w
.33775 .29102 m
.42876 .34175 L
s
P
p
.2 1 0 r
.02 w
.4974 .60538 m
.58573 .64954 L
s
P
p
0 .4 1 r
.02 w
.60188 .6472 m
.60287 .72274 L
s
P
p
.2 1 0 r
.02 w
.49839 .53186 m
.4974 .60538 L
s
P
p
.2 1 0 r
.02 w
.4077 .48481 m
.49839 .53186 L
s
P
p
.2 1 0 r
.02 w
.4104 .4133 m
.4077 .48481 L
s
P
p
0 .4 1 r
.02 w
.24248 .23791 m
.33775 .29102 L
s
P
p
0 .4 1 r
.02 w
.60287 .72274 m
.5131 .67939 L
s
P
p
0 .4 1 r
.02 w
.23637 .30803 m
.24248 .23791 L
s
P
p
0 .4 1 r
.02 w
.5131 .67939 m
.419 .63394 L
s
P
p
0 .4 1 r
.02 w
.13437 .25296 m
.23637 .30803 L
s
P
p
0 .4 1 r
.02 w
.23002 .38098 m
.23637 .30803 L
s
P
p
0 .4 1 r
.02 w
.419 .63394 m
.32025 .58624 L
s
P
p
0 .4 1 r
.02 w
.2234 .45696 m
.23002 .38098 L
s
P
p
0 .4 1 r
.02 w
.32025 .58624 m
.2165 .53614 L
s
P
p
0 .4 1 r
.02 w
.31542 .66781 m
.32025 .58624 L
s
P
p
0 .4 1 r
.02 w
.2165 .53614 m
.2234 .45696 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.292607 0.286967 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.869129 2.80349 0.00816909 0.96764 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8464 .45732 m
.74267 .41514 L
s
P
p
.2 1 0 r
.02 w
.85169 .52088 m
.8464 .45732 L
s
P
p
.2 1 0 r
.02 w
.73917 .35313 m
.6329 .30869 L
s
P
p
.2 1 0 r
.02 w
.74267 .41514 m
.73917 .35313 L
s
P
p
.2 1 0 r
.02 w
.74629 .47929 m
.85169 .52088 L
s
P
p
.2 1 0 r
.02 w
.6329 .30869 m
.63463 .37122 L
s
P
p
.2 1 0 r
.02 w
.52238 .2015 m
.40899 .15281 L
s
P
p
.2 1 0 r
.02 w
.5222 .26239 m
.52238 .2015 L
s
P
p
.2 1 0 r
.02 w
.63643 .43595 m
.74629 .47929 L
s
P
p
.2 1 0 r
.02 w
.63463 .37122 m
.52202 .32543 L
s
P
p
.2 1 0 r
.02 w
.52202 .32543 m
.5222 .26239 L
s
P
p
.2 1 0 r
.02 w
.40899 .15281 m
.4068 .21413 L
s
P
p
.2 1 0 r
.02 w
.75003 .54569 m
.63829 .503 L
s
P
p
.2 1 0 r
.02 w
.75391 .61446 m
.75003 .54569 L
s
P
p
.2 1 0 r
.02 w
.63829 .503 m
.63643 .43595 L
s
P
p
0 .4 1 r
.02 w
.54322 .32289 m
.54341 .38823 L
s
P
p
0 .4 1 r
.02 w
.42605 .27502 m
.54322 .32289 L
s
P
p
.2 1 0 r
.02 w
.4068 .21413 m
.28638 .16377 L
s
P
p
.2 1 0 r
.02 w
.64021 .57249 m
.75391 .61446 L
s
P
p
0 .4 1 r
.02 w
.54341 .38823 m
.4241 .34091 L
s
P
p
.2 1 0 r
.02 w
.40453 .27766 m
.40218 .34353 L
s
P
p
.2 1 0 r
.02 w
.28184 .22778 m
.40453 .27766 L
s
P
p
0 .4 1 r
.02 w
.3037 .22501 m
.42605 .27502 L
s
P
p
.01 w
.28638 .16377 Mdot
P
p
.2 1 0 r
.02 w
.28638 .16377 m
.28184 .22778 L
s
P
p
.01 w
.30785 .16098 Mdot
P
p
0 .4 1 r
.02 w
.30785 .16098 m
.3037 .22501 L
s
P
p
.2 1 0 r
.02 w
.64221 .64457 m
.64021 .57249 L
s
P
p
.2 1 0 r
.02 w
.52163 .45843 m
.52143 .52865 L
s
P
p
.2 1 0 r
.02 w
.39974 .41186 m
.52163 .45843 L
s
P
p
0 .4 1 r
.02 w
.54361 .45596 m
.54382 .52622 L
s
P
p
0 .4 1 r
.02 w
.42206 .40928 m
.54361 .45596 L
s
P
p
.2 1 0 r
.02 w
.40218 .34353 m
.27713 .29419 L
s
P
p
0 .4 1 r
.02 w
.4241 .34091 m
.29939 .29146 L
s
P
p
.2 1 0 r
.02 w
.52122 .60153 m
.64221 .64457 L
s
P
p
.2 1 0 r
.02 w
.52143 .52865 m
.52122 .60153 L
s
P
p
0 .4 1 r
.02 w
.54382 .52622 m
.41995 .48025 L
s
P
p
.2 1 0 r
.02 w
.3972 .4828 m
.39974 .41186 L
s
P
p
0 .4 1 r
.02 w
.29492 .36045 m
.42206 .40928 L
s
P
p
.2 1 0 r
.02 w
.27713 .29419 m
.14632 .24258 L
s
P
p
0 .4 1 r
.02 w
.29939 .29146 m
.29492 .36045 L
s
P
p
0 .4 1 r
.02 w
.54403 .59915 m
.54425 .67491 L
s
P
p
0 .4 1 r
.02 w
.41776 .55399 m
.54403 .59915 L
s
P
p
.2 1 0 r
.02 w
.26716 .4348 m
.3972 .4828 L
s
P
p
0 .4 1 r
.02 w
.41995 .48025 m
.29028 .43213 L
s
P
p
.2 1 0 r
.02 w
.27224 .36315 m
.26716 .4348 L
s
P
p
.2 1 0 r
.02 w
.13875 .31215 m
.27224 .36315 L
s
P
p
.2 1 0 r
.02 w
.14632 .24258 m
.13875 .31215 L
s
P
p
0 .4 1 r
.02 w
.54425 .67491 m
.41548 .63066 L
s
P
p
0 .4 1 r
.02 w
.28545 .50668 m
.41776 .55399 L
s
P
p
0 .4 1 r
.02 w
.29028 .43213 m
.28545 .50668 L
s
P
p
0 .4 1 r
.02 w
.54448 .75366 m
.54472 .8356 L
s
P
p
0 .4 1 r
.02 w
.4131 .71044 m
.54448 .75366 L
s
P
p
0 .4 1 r
.02 w
.41548 .63066 m
.28042 .58426 L
s
P
p
0 .4 1 r
.02 w
.54472 .8356 m
.41063 .79351 L
s
P
p
0 .4 1 r
.02 w
.27518 .66505 m
.4131 .71044 L
s
P
p
0 .4 1 r
.02 w
.28042 .58426 m
.27518 .66505 L
s
P
p
0 .4 1 r
.02 w
.41063 .79351 m
.26973 .74928 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.292607 0.424812 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.292607 0.562657 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.292607 0.700501 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.429751 1.9597 0.0248227 0.992908 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.89228 .59942 m
.84284 .57057 L
s
P
p
.2 1 0 r
.02 w
.89619 .64666 m
.89228 .59942 L
s
P
p
.2 1 0 r
.02 w
.83953 .52408 m
.78926 .49412 L
s
P
p
.2 1 0 r
.02 w
.84284 .57057 m
.83953 .52408 L
s
P
p
.2 1 0 r
.02 w
.84624 .61813 m
.89619 .64666 L
s
P
p
.2 1 0 r
.02 w
.78926 .49412 m
.79204 .54091 L
s
P
p
.2 1 0 r
.02 w
.73542 .41733 m
.68287 .38538 L
s
P
p
.2 1 0 r
.02 w
.73758 .46333 m
.73542 .41733 L
s
P
p
.2 1 0 r
.02 w
.79488 .58879 m
.84624 .61813 L
s
P
p
.2 1 0 r
.02 w
.79204 .54091 m
.73979 .51041 L
s
P
p
.2 1 0 r
.02 w
.73979 .51041 m
.73758 .46333 L
s
P
p
.2 1 0 r
.02 w
.68287 .38538 m
.68444 .43166 L
s
P
p
.2 1 0 r
.02 w
.84971 .66681 m
.79779 .63781 L
s
P
p
.2 1 0 r
.02 w
.85327 .71664 m
.84971 .66681 L
s
P
p
.2 1 0 r
.02 w
.79779 .63781 m
.79488 .58879 L
s
P
p
.2 1 0 r
.02 w
.68444 .43166 m
.62977 .39908 L
s
P
p
.2 1 0 r
.02 w
.80077 .68802 m
.85327 .71664 L
s
P
p
.2 1 0 r
.02 w
.68605 .47904 m
.68769 .52756 L
s
P
p
.2 1 0 r
.02 w
.63074 .44675 m
.68605 .47904 L
s
P
p
0 .4 1 r
.02 w
.69659 .47731 m
.69836 .52586 L
s
P
p
0 .4 1 r
.02 w
.64139 .44498 m
.69659 .47731 L
s
P
p
.01 w
.62977 .39908 Mdot
P
p
.2 1 0 r
.02 w
.62977 .39908 m
.63074 .44675 L
s
P
p
.01 w
.64029 .39729 Mdot
P
p
0 .4 1 r
.02 w
.64029 .39729 m
.64139 .44498 L
s
P
p
.2 1 0 r
.02 w
.80383 .73944 m
.80077 .68802 L
s
P
p
.2 1 0 r
.02 w
.74437 .60798 m
.74674 .65856 L
s
P
p
.2 1 0 r
.02 w
.68938 .57728 m
.74437 .60798 L
s
P
p
.2 1 0 r
.02 w
.68769 .52756 m
.63173 .4956 L
s
P
p
0 .4 1 r
.02 w
.69836 .52586 m
.64251 .49384 L
s
P
p
.2 1 0 r
.02 w
.74917 .71038 m
.80383 .73944 L
s
P
p
.2 1 0 r
.02 w
.74674 .65856 m
.74917 .71038 L
s
P
p
.2 1 0 r
.02 w
.6911 .62822 m
.68938 .57728 L
s
P
p
.2 1 0 r
.02 w
.63173 .4956 m
.57409 .46267 L
s
P
p
0 .4 1 r
.02 w
.64251 .49384 m
.58499 .46086 L
s
P
p
.2 1 0 r
.02 w
.63378 .59697 m
.6911 .62822 L
s
P
p
.2 1 0 r
.02 w
.63274 .54565 m
.63378 .59697 L
s
P
p
.2 1 0 r
.02 w
.5744 .51307 m
.63274 .54565 L
s
P
p
.2 1 0 r
.02 w
.57409 .46267 m
.5744 .51307 L
s
P
p
0 .4 1 r
.02 w
.58499 .46086 m
.52572 .42688 L
s
P
p
0 .4 1 r
.02 w
.58543 .51128 m
.58588 .56299 L
s
P
p
0 .4 1 r
.02 w
.52541 .47764 m
.58543 .51128 L
s
P
p
0 .4 1 r
.02 w
.52572 .42688 m
.52541 .47764 L
s
P
p
0 .4 1 r
.02 w
.58588 .56299 m
.52509 .52972 L
s
P
p
0 .4 1 r
.02 w
.52509 .52972 m
.46237 .4954 L
s
P
p
0 .4 1 r
.02 w
.46237 .4954 m
.39763 .45997 L
s
P
p
0 .4 1 r
.02 w
.4612 .54925 m
.45999 .60455 L
s
P
p
0 .4 1 r
.02 w
.39556 .51422 m
.4612 .54925 L
s
P
p
0 .4 1 r
.02 w
.39763 .45997 m
.39556 .51422 L
s
P
p
0 .4 1 r
.02 w
.45999 .60455 m
.39344 .56995 L
s
P
p
0 .4 1 r
.02 w
.39344 .56995 m
.32464 .53419 L
s
P
p
0 .4 1 r
.02 w
.32464 .53419 m
.2535 .49721 L
s
P
p
0 .4 1 r
.02 w
.32144 .59196 m
.31815 .65138 L
s
P
p
0 .4 1 r
.02 w
.24921 .55544 m
.32144 .59196 L
s
P
p
0 .4 1 r
.02 w
.2535 .49721 m
.24921 .55544 L
s
P
p
0 .4 1 r
.02 w
.31815 .65138 m
.2448 .61538 L
s
P
p
0 .4 1 r
.02 w
.2448 .61538 m
.16883 .57808 L
s
P
p
0 .4 1 r
.02 w
.16883 .57808 m
.09009 .53943 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.292607 0.838346 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.561984 2.22533 0.0242213 0.968854 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.88147 .67059 m
.80253 .6332 L
s
P
p
.2 1 0 r
.02 w
.88784 .73733 m
.88147 .67059 L
s
P
p
.2 1 0 r
.02 w
.79775 .56819 m
.71655 .52827 L
s
P
p
.2 1 0 r
.02 w
.80253 .6332 m
.79775 .56819 L
s
P
p
.2 1 0 r
.02 w
.80749 .70078 m
.88784 .73733 L
s
P
p
.2 1 0 r
.02 w
.71655 .52827 m
.71984 .59404 L
s
P
p
.2 1 0 r
.02 w
.62991 .42252 m
.54243 .37799 L
s
P
p
.2 1 0 r
.02 w
.63149 .48644 m
.62991 .42252 L
s
P
p
0 .4 1 r
.02 w
.64615 .42016 m
.64805 .48412 L
s
P
p
0 .4 1 r
.02 w
.55894 .37552 m
.64615 .42016 L
s
P
p
0 .4 1 r
.02 w
.47073 .20587 m
.46912 .26605 L
s
P
p
0 .4 1 r
.02 w
.37858 .15569 m
.47073 .20587 L
s
P
p
.2 1 0 r
.02 w
.72325 .66246 m
.80749 .70078 L
s
P
p
.2 1 0 r
.02 w
.71984 .59404 m
.63313 .55297 L
s
P
p
.2 1 0 r
.02 w
.63313 .55297 m
.63149 .48644 L
s
P
p
0 .4 1 r
.02 w
.64805 .48412 m
.55911 .44014 L
s
P
p
.2 1 0 r
.02 w
.54243 .37799 m
.54226 .44258 L
s
P
p
0 .4 1 r
.02 w
.46745 .32869 m
.55894 .37552 L
s
P
p
0 .4 1 r
.02 w
.46912 .26605 m
.46745 .32869 L
s
P
p
.2 1 0 r
.02 w
.81266 .77108 m
.72681 .73371 L
s
P
p
.2 1 0 r
.02 w
.81803 .84426 m
.81266 .77108 L
s
P
p
0 .4 1 r
.02 w
.37504 .21632 m
.37858 .15569 L
s
P
p
.2 1 0 r
.02 w
.72681 .73371 m
.72325 .66246 L
s
P
p
.2 1 0 r
.02 w
.54226 .44258 m
.44857 .39651 L
s
P
p
0 .4 1 r
.02 w
.55911 .44014 m
.46572 .39395 L
s
P
p
.2 1 0 r
.02 w
.73052 .80795 m
.81803 .84426 L
s
P
p
0 .4 1 r
.02 w
.37136 .2795 m
.37504 .21632 L
s
P
p
.2 1 0 r
.02 w
.54209 .50985 m
.54191 .57997 L
s
P
p
.2 1 0 r
.02 w
.4464 .46452 m
.54209 .50985 L
s
P
p
.01 w
.44857 .39651 Mdot
P
p
.2 1 0 r
.02 w
.44857 .39651 m
.4464 .46452 L
s
P
p
.01 w
.46572 .39395 Mdot
P
p
0 .4 1 r
.02 w
.46572 .39395 m
.4639 .462 L
s
P
p
0 .4 1 r
.02 w
.2703 .22777 m
.37136 .2795 L
s
P
p
.2 1 0 r
.02 w
.73438 .88539 m
.73052 .80795 L
s
P
p
.2 1 0 r
.02 w
.63661 .69444 m
.63847 .76976 L
s
P
p
.2 1 0 r
.02 w
.54172 .65313 m
.63661 .69444 L
s
P
p
.2 1 0 r
.02 w
.54191 .57997 m
.44413 .53549 L
s
P
p
0 .4 1 r
.02 w
.4639 .462 m
.46201 .53301 L
s
P
p
0 .4 1 r
.02 w
.36751 .34539 m
.26413 .29426 L
s
P
p
0 .4 1 r
.02 w
.3635 .41416 m
.36751 .34539 L
s
P
p
.2 1 0 r
.02 w
.6404 .84841 m
.73438 .88539 L
s
P
p
0 .4 1 r
.02 w
.16388 .1733 m
.2703 .22777 L
s
P
p
.2 1 0 r
.02 w
.63847 .76976 m
.6404 .84841 L
s
P
p
.2 1 0 r
.02 w
.54152 .72954 m
.54172 .65313 L
s
P
p
.2 1 0 r
.02 w
.44413 .53549 m
.3411 .48862 L
s
P
p
0 .4 1 r
.02 w
.46201 .53301 m
.35931 .48601 L
s
P
p
0 .4 1 r
.02 w
.35931 .48601 m
.3635 .41416 L
s
P
p
0 .4 1 r
.02 w
.26413 .29426 m
.15514 .24036 L
s
P
p
0 .4 1 r
.02 w
.15514 .24036 m
.16388 .1733 L
s
P
p
.2 1 0 r
.02 w
.43927 .68712 m
.54152 .72954 L
s
P
p
.2 1 0 r
.02 w
.44175 .60962 m
.43927 .68712 L
s
P
p
.2 1 0 r
.02 w
.3363 .56371 m
.44175 .60962 L
s
P
p
.2 1 0 r
.02 w
.3411 .48862 m
.3363 .56371 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.292607 0.97619 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.649333 2.38458 0.0238845 0.955379 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.86758 .61144 m
.76162 .56426 L
s
P
p
.2 1 0 r
.02 w
.87476 .6913 m
.86758 .61144 L
s
P
p
.2 1 0 r
.02 w
.75686 .48682 m
.64746 .43609 L
s
P
p
.2 1 0 r
.02 w
.76162 .56426 m
.75686 .48682 L
s
P
p
.2 1 0 r
.02 w
.76658 .64523 m
.87476 .6913 L
s
P
p
.2 1 0 r
.02 w
.64746 .43609 m
.64984 .5145 L
s
P
p
.2 1 0 r
.02 w
.53228 .30676 m
.41314 .24942 L
s
P
p
.2 1 0 r
.02 w
.53203 .38257 m
.53228 .30676 L
s
P
p
0 .4 1 r
.02 w
.43735 .17304 m
.43492 .24623 L
s
P
p
0 .4 1 r
.02 w
.31484 .11163 m
.43735 .17304 L
s
P
p
.2 1 0 r
.02 w
.65234 .59657 m
.76658 .64523 L
s
P
p
.2 1 0 r
.02 w
.64984 .5145 m
.53178 .46193 L
s
P
p
.2 1 0 r
.02 w
.53178 .46193 m
.53203 .38257 L
s
P
p
0 .4 1 r
.02 w
.55389 .37958 m
.43237 .32286 L
s
P
p
0 .4 1 r
.02 w
.55415 .459 m
.55389 .37958 L
s
P
p
.2 1 0 r
.02 w
.41314 .24942 m
.41008 .32602 L
s
P
p
0 .4 1 r
.02 w
.43492 .24623 m
.43237 .32286 L
s
P
p
0 .4 1 r
.02 w
.30943 .18544 m
.31484 .11163 L
s
P
p
.2 1 0 r
.02 w
.77178 .72996 m
.65496 .68257 L
s
P
p
.2 1 0 r
.02 w
.77723 .81872 m
.77178 .72996 L
s
P
p
.2 1 0 r
.02 w
.65496 .68257 m
.65234 .59657 L
s
P
p
0 .4 1 r
.02 w
.42969 .40321 m
.55415 .459 L
s
P
p
0 .4 1 r
.02 w
.55415 .459 m
.55442 .54223 L
s
P
p
.2 1 0 r
.02 w
.41008 .32602 m
.28102 .26618 L
s
P
p
0 .4 1 r
.02 w
.43237 .32286 m
.30375 .26284 L
s
P
p
0 .4 1 r
.02 w
.43237 .32286 m
.42969 .40321 L
s
P
p
0 .4 1 r
.02 w
.30375 .26284 m
.30943 .18544 L
s
P
p
.2 1 0 r
.02 w
.6577 .77278 m
.77723 .81872 L
s
P
p
0 .4 1 r
.02 w
.55442 .54223 m
.5547 .62958 L
s
P
p
.2 1 0 r
.02 w
.40687 .40632 m
.4035 .49059 L
s
P
p
.2 1 0 r
.02 w
.27451 .34738 m
.40687 .40632 L
s
P
p
0 .4 1 r
.02 w
.42969 .40321 m
.2978 .34409 L
s
P
p
0 .4 1 r
.02 w
.42689 .48754 m
.42969 .40321 L
s
P
p
.01 w
.28102 .26618 Mdot
P
p
.2 1 0 r
.02 w
.28102 .26618 m
.27451 .34738 L
s
P
p
.01 w
.30375 .26284 Mdot
P
p
0 .4 1 r
.02 w
.2978 .34409 m
.30375 .26284 L
s
P
p
.2 1 0 r
.02 w
.66058 .86753 m
.6577 .77278 L
s
P
p
.2 1 0 r
.02 w
.53123 .63238 m
.53093 .72406 L
s
P
p
.2 1 0 r
.02 w
.39996 .57913 m
.53123 .63238 L
s
P
p
0 .4 1 r
.02 w
.5547 .62958 m
.42394 .57616 L
s
P
p
.2 1 0 r
.02 w
.4035 .49059 m
.26766 .43273 L
s
P
p
0 .4 1 r
.02 w
.42394 .57616 m
.42689 .48754 L
s
P
p
.2 1 0 r
.02 w
.53062 .82049 m
.66058 .86753 L
s
P
p
.2 1 0 r
.02 w
.53093 .72406 m
.53062 .82049 L
s
P
p
.2 1 0 r
.02 w
.39624 .67229 m
.39996 .57913 L
s
P
p
.2 1 0 r
.02 w
.26766 .43273 m
.12324 .37122 L
s
P
p
.2 1 0 r
.02 w
.25286 .61718 m
.39624 .67229 L
s
P
p
.2 1 0 r
.02 w
.26046 .52254 m
.25286 .61718 L
s
P
p
.2 1 0 r
.02 w
.1119 .46228 m
.26046 .52254 L
s
P
p
.2 1 0 r
.02 w
.12324 .37122 m
.1119 .46228 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.430451 0.149123 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.758303 2.5909 0.0163524 0.959656 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.65693 .26414 m
.5475 .21345 L
s
P
p
0 .4 1 r
.02 w
.65922 .32981 m
.65693 .26414 L
s
P
p
0 .4 1 r
.02 w
.5477 .27966 m
.65922 .32981 L
s
P
p
0 .4 1 r
.02 w
.5475 .21345 m
.5477 .27966 L
s
P
p
.2 1 0 r
.02 w
.86547 .63433 m
.75767 .59089 L
s
P
p
.2 1 0 r
.02 w
.87194 .70928 m
.86547 .63433 L
s
P
p
.2 1 0 r
.02 w
.75339 .51794 m
.64249 .47155 L
s
P
p
.2 1 0 r
.02 w
.75767 .59089 m
.75339 .51794 L
s
P
p
0 .4 1 r
.02 w
.5477 .27966 m
.43082 .22711 L
s
P
p
0 .4 1 r
.02 w
.54792 .34853 m
.5477 .27966 L
s
P
p
.2 1 0 r
.02 w
.76212 .66678 m
.87194 .70928 L
s
P
p
.2 1 0 r
.02 w
.64249 .47155 m
.64463 .54533 L
s
P
p
.2 1 0 r
.02 w
.52639 .35127 m
.40675 .29947 L
s
P
p
.2 1 0 r
.02 w
.52617 .4229 m
.52639 .35127 L
s
P
p
0 .4 1 r
.02 w
.54813 .4202 m
.54792 .34853 L
s
P
p
0 .4 1 r
.02 w
.43082 .22711 m
.42864 .29659 L
s
P
p
.2 1 0 r
.02 w
.64685 .62217 m
.76212 .66678 L
s
P
p
.2 1 0 r
.02 w
.64463 .54533 m
.52594 .49751 L
s
P
p
.2 1 0 r
.02 w
.52594 .49751 m
.52617 .4229 L
s
P
p
0 .4 1 r
.02 w
.42637 .36897 m
.54813 .4202 L
s
P
p
.2 1 0 r
.02 w
.40675 .29947 m
.40403 .37181 L
s
P
p
0 .4 1 r
.02 w
.42864 .29659 m
.42637 .36897 L
s
P
p
.2 1 0 r
.02 w
.76676 .7458 m
.64917 .70225 L
s
P
p
.2 1 0 r
.02 w
.77159 .82814 m
.76676 .7458 L
s
P
p
.2 1 0 r
.02 w
.64917 .70225 m
.64685 .62217 L
s
P
p
.2 1 0 r
.02 w
.40403 .37181 m
.27561 .31809 L
s
P
p
0 .4 1 r
.02 w
.42637 .36897 m
.29835 .31511 L
s
P
p
0 .4 1 r
.02 w
.42401 .44444 m
.42637 .36897 L
s
P
p
.2 1 0 r
.02 w
.65159 .78579 m
.77159 .82814 L
s
P
p
.2 1 0 r
.02 w
.40119 .44724 m
.39823 .52595 L
s
P
p
.2 1 0 r
.02 w
.26989 .39433 m
.40119 .44724 L
s
P
p
0 .4 1 r
.02 w
.29312 .39138 m
.42401 .44444 L
s
P
p
.01 w
.27561 .31809 Mdot
P
p
.2 1 0 r
.02 w
.27561 .31809 m
.26989 .39433 L
s
P
p
.01 w
.29835 .31511 Mdot
P
p
0 .4 1 r
.02 w
.29835 .31511 m
.29312 .39138 L
s
P
p
.2 1 0 r
.02 w
.65411 .87301 m
.65159 .78579 L
s
P
p
.2 1 0 r
.02 w
.52546 .65643 m
.5252 .74118 L
s
P
p
.2 1 0 r
.02 w
.39514 .60817 m
.52546 .65643 L
s
P
p
.2 1 0 r
.02 w
.39823 .52595 m
.26391 .47397 L
s
P
p
.2 1 0 r
.02 w
.52493 .82976 m
.65411 .87301 L
s
P
p
.2 1 0 r
.02 w
.5252 .74118 m
.52493 .82976 L
s
P
p
.2 1 0 r
.02 w
.3919 .69413 m
.39514 .60817 L
s
P
p
.2 1 0 r
.02 w
.26391 .47397 m
.12219 .41912 L
s
P
p
.2 1 0 r
.02 w
.25112 .64444 m
.3919 .69413 L
s
P
p
.2 1 0 r
.02 w
.25766 .55725 m
.25112 .64444 L
s
P
p
.2 1 0 r
.02 w
.11243 .50347 m
.25766 .55725 L
s
P
p
.2 1 0 r
.02 w
.12219 .41912 m
.11243 .50347 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.430451 0.286967 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.564051 2.22952 0.0242196 0.968782 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.86973 .53081 m
.80222 .49625 L
s
P
p
.2 1 0 r
.02 w
.87496 .58531 m
.86973 .53081 L
s
P
p
.2 1 0 r
.02 w
.79815 .44302 m
.729 .40661 L
s
P
p
.2 1 0 r
.02 w
.80222 .49625 m
.79815 .44302 L
s
P
p
.2 1 0 r
.02 w
.80642 .55127 m
.87496 .58531 L
s
P
p
.2 1 0 r
.02 w
.729 .40661 m
.73199 .46031 L
s
P
p
.2 1 0 r
.02 w
.65529 .31637 m
.58161 .27653 L
s
P
p
.2 1 0 r
.02 w
.65705 .36873 m
.65529 .31637 L
s
P
p
.2 1 0 r
.02 w
.73508 .51583 m
.80642 .55127 L
s
P
p
.2 1 0 r
.02 w
.73199 .46031 m
.65887 .42288 L
s
P
p
.2 1 0 r
.02 w
.65887 .42288 m
.65705 .36873 L
s
P
p
.2 1 0 r
.02 w
.58161 .27653 m
.58214 .32929 L
s
P
p
.2 1 0 r
.02 w
.81077 .60816 m
.73828 .57329 L
s
P
p
.2 1 0 r
.02 w
.81527 .66701 m
.81077 .60816 L
s
P
p
.2 1 0 r
.02 w
.73828 .57329 m
.73508 .51583 L
s
P
p
.2 1 0 r
.02 w
.58214 .32929 m
.50408 .28819 L
s
P
p
.2 1 0 r
.02 w
.74159 .63278 m
.81527 .66701 L
s
P
p
.2 1 0 r
.02 w
.58269 .38389 m
.58326 .44043 L
s
P
p
.2 1 0 r
.02 w
.50325 .34322 m
.58269 .38389 L
s
P
p
0 .4 1 r
.02 w
.59723 .38173 m
.59806 .4383 L
s
P
p
0 .4 1 r
.02 w
.518 .34097 m
.59723 .38173 L
s
P
p
.01 w
.50408 .28819 Mdot
P
p
.2 1 0 r
.02 w
.50408 .28819 m
.50325 .34322 L
s
P
p
.01 w
.51858 .28591 Mdot
P
p
0 .4 1 r
.02 w
.51858 .28591 m
.518 .34097 L
s
P
p
.2 1 0 r
.02 w
.74502 .6944 m
.74159 .63278 L
s
P
p
.2 1 0 r
.02 w
.66271 .53694 m
.66473 .59706 L
s
P
p
.2 1 0 r
.02 w
.58385 .49902 m
.66271 .53694 L
s
P
p
.2 1 0 r
.02 w
.58326 .44043 m
.50239 .40026 L
s
P
p
0 .4 1 r
.02 w
.59806 .4383 m
.51741 .39803 L
s
P
p
.2 1 0 r
.02 w
.66682 .65939 m
.74502 .6944 L
s
P
p
.2 1 0 r
.02 w
.66473 .59706 m
.66682 .65939 L
s
P
p
.2 1 0 r
.02 w
.58446 .55976 m
.58385 .49902 L
s
P
p
.2 1 0 r
.02 w
.50239 .40026 m
.4179 .3583 L
s
P
p
0 .4 1 r
.02 w
.51741 .39803 m
.43316 .35597 L
s
P
p
.2 1 0 r
.02 w
.50056 .52078 m
.58446 .55976 L
s
P
p
.2 1 0 r
.02 w
.50149 .4594 m
.50056 .52078 L
s
P
p
.2 1 0 r
.02 w
.41539 .41799 m
.50149 .4594 L
s
P
p
0 .4 1 r
.02 w
.51679 .45721 m
.51615 .51862 L
s
P
p
0 .4 1 r
.02 w
.43093 .41569 m
.51679 .45721 L
s
P
p
.2 1 0 r
.02 w
.4179 .3583 m
.41539 .41799 L
s
P
p
0 .4 1 r
.02 w
.43316 .35597 m
.43093 .41569 L
s
P
p
0 .4 1 r
.02 w
.51615 .51862 m
.42862 .47773 L
s
P
p
0 .4 1 r
.02 w
.42862 .47773 m
.33693 .43489 L
s
P
p
0 .4 1 r
.02 w
.42621 .5422 m
.42371 .60927 L
s
P
p
0 .4 1 r
.02 w
.33262 .50007 m
.42621 .5422 L
s
P
p
0 .4 1 r
.02 w
.33693 .43489 m
.33262 .50007 L
s
P
p
0 .4 1 r
.02 w
.42371 .60927 m
.32813 .56792 L
s
P
p
0 .4 1 r
.02 w
.32813 .56792 m
.2277 .52448 L
s
P
p
0 .4 1 r
.02 w
.32345 .63863 m
.31857 .71238 L
s
P
p
0 .4 1 r
.02 w
.22074 .59608 m
.32345 .63863 L
s
P
p
0 .4 1 r
.02 w
.2277 .52448 m
.22074 .59608 L
s
P
p
0 .4 1 r
.02 w
.31857 .71238 m
.21346 .67084 L
s
P
p
0 .4 1 r
.02 w
.21346 .67084 m
.10265 .62705 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.430451 0.424812 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-1.27536 3.5938 -0.0119452 0.987264 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.82433 .35816 m
.723 .32476 L
s
P
p
.2 1 0 r
.02 w
.82788 .40573 m
.82433 .35816 L
s
P
p
.2 1 0 r
.02 w
.72066 .27802 m
.61762 .24341 L
s
P
p
.2 1 0 r
.02 w
.723 .32476 m
.72066 .27802 L
s
P
p
.2 1 0 r
.02 w
.72539 .37261 m
.82788 .40573 L
s
P
p
.2 1 0 r
.02 w
.61762 .24341 m
.61877 .29041 L
s
P
p
.2 1 0 r
.02 w
.51175 .16168 m
.40398 .12482 L
s
P
p
.2 1 0 r
.02 w
.51163 .20781 m
.51175 .16168 L
s
P
p
.2 1 0 r
.02 w
.61994 .33854 m
.72539 .37261 L
s
P
p
.2 1 0 r
.02 w
.61877 .29041 m
.51151 .25506 L
s
P
p
.2 1 0 r
.02 w
.51151 .25506 m
.51163 .20781 L
s
P
p
.2 1 0 r
.02 w
.40398 .12482 m
.40256 .17117 L
s
P
p
.2 1 0 r
.02 w
.72785 .42161 m
.62114 .38784 L
s
P
p
.2 1 0 r
.02 w
.73036 .47181 m
.72785 .42161 L
s
P
p
.2 1 0 r
.02 w
.62114 .38784 m
.61994 .33854 L
s
P
p
.2 1 0 r
.02 w
.40256 .17117 m
.29026 .13345 L
s
P
p
.2 1 0 r
.02 w
.62237 .43836 m
.73036 .47181 L
s
P
p
.2 1 0 r
.02 w
.40109 .21867 m
.3996 .26734 L
s
P
p
.2 1 0 r
.02 w
.28738 .18119 m
.40109 .21867 L
s
P
p
.01 w
.29026 .13345 Mdot
P
p
.2 1 0 r
.02 w
.29026 .13345 m
.28738 .18119 L
s
P
p
.01 w
.3105 .13138 Mdot
P
p
0 .4 1 r
.02 w
.3105 .13138 m
.30787 .17912 L
s
P
p
.2 1 0 r
.02 w
.62364 .49015 m
.62237 .43836 L
s
P
p
.2 1 0 r
.02 w
.51126 .35306 m
.51113 .40391 L
s
P
p
.2 1 0 r
.02 w
.39806 .31723 m
.51126 .35306 L
s
P
p
.2 1 0 r
.02 w
.3996 .26734 m
.28442 .23012 L
s
P
p
0 .4 1 r
.02 w
.42013 .26535 m
.41885 .31526 L
s
P
p
0 .4 1 r
.02 w
.30517 .22807 m
.42013 .26535 L
s
P
p
0 .4 1 r
.02 w
.30787 .17912 m
.30517 .22807 L
s
P
p
.2 1 0 r
.02 w
.511 .45605 m
.62364 .49015 L
s
P
p
.2 1 0 r
.02 w
.51113 .40391 m
.511 .45605 L
s
P
p
.2 1 0 r
.02 w
.39649 .3684 m
.39806 .31723 L
s
P
p
0 .4 1 r
.02 w
.41885 .31526 m
.41754 .36645 L
s
P
p
.2 1 0 r
.02 w
.28442 .23012 m
.16571 .19176 L
s
P
p
0 .4 1 r
.02 w
.53209 .45417 m
.53223 .50768 L
s
P
p
0 .4 1 r
.02 w
.4162 .41896 m
.53209 .45417 L
s
P
p
.2 1 0 r
.02 w
.27829 .33179 m
.39649 .3684 L
s
P
p
0 .4 1 r
.02 w
.41754 .36645 m
.4162 .41896 L
s
P
p
.2 1 0 r
.02 w
.28139 .28031 m
.27829 .33179 L
s
P
p
.2 1 0 r
.02 w
.16109 .24223 m
.28139 .28031 L
s
P
p
.2 1 0 r
.02 w
.16571 .19176 m
.16109 .24223 L
s
P
p
0 .4 1 r
.02 w
.53223 .50768 m
.53237 .56258 L
s
P
p
0 .4 1 r
.02 w
.6493 .65184 m
.65099 .70922 L
s
P
p
0 .4 1 r
.02 w
.53251 .61893 m
.6493 .65184 L
s
P
p
0 .4 1 r
.02 w
.53237 .56258 m
.53251 .61893 L
s
P
p
0 .4 1 r
.02 w
.65099 .70922 m
.65272 .76814 L
s
P
p
0 .4 1 r
.02 w
.77214 .859 m
.77553 .92058 L
s
P
p
0 .4 1 r
.02 w
.6545 .82865 m
.77214 .859 L
s
P
p
0 .4 1 r
.02 w
.65272 .76814 m
.6545 .82865 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.430451 0.562657 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.498191 2.097 0.0245059 0.980236 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87882 .61174 m
.78846 .56381 L
s
P
p
.2 1 0 r
.02 w
.88591 .6918 m
.87882 .61174 L
s
P
p
.2 1 0 r
.02 w
.7834 .48613 m
.69015 .43471 L
s
P
p
.2 1 0 r
.02 w
.78846 .56381 m
.7834 .48613 L
s
P
p
.2 1 0 r
.02 w
.79374 .64494 m
.88591 .6918 L
s
P
p
.2 1 0 r
.02 w
.69015 .43471 m
.69327 .51333 L
s
P
p
.2 1 0 r
.02 w
.59099 .30448 m
.48962 .24655 L
s
P
p
.2 1 0 r
.02 w
.5919 .38054 m
.59099 .30448 L
s
P
p
.2 1 0 r
.02 w
.69652 .59553 m
.79374 .64494 L
s
P
p
.2 1 0 r
.02 w
.69327 .51333 m
.59285 .46007 L
s
P
p
.2 1 0 r
.02 w
.59285 .46007 m
.5919 .38054 L
s
P
p
.2 1 0 r
.02 w
.48962 .24655 m
.48822 .32337 L
s
P
p
.2 1 0 r
.02 w
.79926 .72975 m
.69993 .68156 L
s
P
p
.2 1 0 r
.02 w
.80503 .8185 m
.79926 .72975 L
s
P
p
.2 1 0 r
.02 w
.69993 .68156 m
.69652 .59553 L
s
P
p
0 .4 1 r
.02 w
.71594 .59277 m
.61366 .54042 L
s
P
p
0 .4 1 r
.02 w
.71981 .67887 m
.71594 .59277 L
s
P
p
.2 1 0 r
.02 w
.48822 .32337 m
.37867 .26297 L
s
P
p
0 .4 1 r
.02 w
.50751 .32019 m
.39834 .2596 L
s
P
p
0 .4 1 r
.02 w
.5065 .40067 m
.50751 .32019 L
s
P
p
.2 1 0 r
.02 w
.7035 .77169 m
.80503 .8185 L
s
P
p
0 .4 1 r
.02 w
.61518 .62774 m
.71981 .67887 L
s
P
p
0 .4 1 r
.02 w
.61366 .54042 m
.61518 .62774 L
s
P
p
.2 1 0 r
.02 w
.48676 .40381 m
.48523 .48812 L
s
P
p
.2 1 0 r
.02 w
.37451 .34428 m
.48676 .40381 L
s
P
p
0 .4 1 r
.02 w
.50545 .48504 m
.5065 .40067 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.5065 .40067 L
s
P
p
.01 w
.37867 .26297 Mdot
P
p
.2 1 0 r
.02 w
.37867 .26297 m
.37451 .34428 L
s
P
p
.01 w
.39834 .2596 Mdot
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.39465 .34095 L
s
P
p
.2 1 0 r
.02 w
.70724 .86623 m
.7035 .77169 L
s
P
p
.2 1 0 r
.02 w
.59489 .63059 m
.59598 .72212 L
s
P
p
.2 1 0 r
.02 w
.48363 .5766 m
.59489 .63059 L
s
P
p
0 .4 1 r
.02 w
.61518 .62774 m
.50434 .57358 L
s
P
p
.2 1 0 r
.02 w
.48523 .48812 m
.37015 .42962 L
s
P
p
0 .4 1 r
.02 w
.50434 .57358 m
.50545 .48504 L
s
P
p
0 .4 1 r
.02 w
.50545 .48504 m
.39078 .42635 L
s
P
p
.2 1 0 r
.02 w
.59713 .81827 m
.70724 .86623 L
s
P
p
.2 1 0 r
.02 w
.59598 .72212 m
.59713 .81827 L
s
P
p
.2 1 0 r
.02 w
.48194 .66955 m
.48363 .5766 L
s
P
p
0 .4 1 r
.02 w
.38672 .51611 m
.50434 .57358 L
s
P
p
.2 1 0 r
.02 w
.37015 .42962 m
.24801 .36753 L
s
P
p
0 .4 1 r
.02 w
.39078 .42635 m
.38672 .51611 L
s
P
p
0 .4 1 r
.02 w
.26907 .36406 m
.39078 .42635 L
s
P
p
.2 1 0 r
.02 w
.36075 .61368 m
.48194 .66955 L
s
P
p
0 .4 1 r
.02 w
.50317 .66661 m
.38244 .61055 L
s
P
p
0 .4 1 r
.02 w
.50195 .76448 m
.50317 .66661 L
s
P
p
.2 1 0 r
.02 w
.36557 .51931 m
.36075 .61368 L
s
P
p
.2 1 0 r
.02 w
.24008 .45841 m
.36557 .51931 L
s
P
p
0 .4 1 r
.02 w
.38244 .61055 m
.38672 .51611 L
s
P
p
.2 1 0 r
.02 w
.24801 .36753 m
.24008 .45841 L
s
P
p
0 .4 1 r
.02 w
.26168 .45501 m
.26907 .36406 L
s
P
p
0 .4 1 r
.02 w
.26907 .36406 m
.13964 .29782 L
s
P
p
0 .4 1 r
.02 w
.37793 .71007 m
.50195 .76448 L
s
P
p
0 .4 1 r
.02 w
.38244 .61055 m
.37793 .71007 L
s
P
p
0 .4 1 r
.02 w
.1285 .38993 m
.26168 .45501 L
s
P
p
0 .4 1 r
.02 w
.13964 .29782 m
.1285 .38993 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.430451 0.700501 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.451366 2.00297 0.0247151 0.988603 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8869 .6339 m
.80642 .58904 L
s
P
p
.2 1 0 r
.02 w
.89326 .70947 m
.8869 .6339 L
s
P
p
.2 1 0 r
.02 w
.80165 .51543 m
.71891 .46769 L
s
P
p
.2 1 0 r
.02 w
.80642 .58904 m
.80165 .51543 L
s
P
p
.2 1 0 r
.02 w
.81137 .6655 m
.89326 .70947 L
s
P
p
.2 1 0 r
.02 w
.71891 .46769 m
.72219 .54209 L
s
P
p
.2 1 0 r
.02 w
.63074 .34541 m
.54173 .29238 L
s
P
p
.2 1 0 r
.02 w
.63231 .41772 m
.63074 .34541 L
s
P
p
.2 1 0 r
.02 w
.72559 .61944 m
.81137 .6655 L
s
P
p
.2 1 0 r
.02 w
.72219 .54209 m
.63394 .4929 L
s
P
p
.2 1 0 r
.02 w
.63394 .4929 m
.63231 .41772 L
s
P
p
.2 1 0 r
.02 w
.54173 .29238 m
.54156 .36536 L
s
P
p
.2 1 0 r
.02 w
.81652 .74497 m
.72914 .69991 L
s
P
p
.2 1 0 r
.02 w
.82188 .82764 m
.81652 .74497 L
s
P
p
.2 1 0 r
.02 w
.72914 .69991 m
.72559 .61944 L
s
P
p
.2 1 0 r
.02 w
.54156 .36536 m
.44636 .31043 L
s
P
p
0 .4 1 r
.02 w
.46551 .23371 m
.46378 .30738 L
s
P
p
0 .4 1 r
.02 w
.36792 .17524 m
.46551 .23371 L
s
P
p
.2 1 0 r
.02 w
.73283 .78369 m
.82188 .82764 L
s
P
p
.2 1 0 r
.02 w
.54138 .44132 m
.5412 .52043 L
s
P
p
.2 1 0 r
.02 w
.44419 .38714 m
.54138 .44132 L
s
P
p
.01 w
.44636 .31043 Mdot
P
p
.2 1 0 r
.02 w
.44636 .31043 m
.44419 .38714 L
s
P
p
.01 w
.46378 .30738 Mdot
P
p
0 .4 1 r
.02 w
.46378 .30738 m
.46198 .38413 L
s
P
p
0 .4 1 r
.02 w
.26538 .1138 m
.36792 .17524 L
s
P
p
.2 1 0 r
.02 w
.73667 .87101 m
.73283 .78369 L
s
P
p
.2 1 0 r
.02 w
.63741 .6526 m
.63926 .73752 L
s
P
p
.2 1 0 r
.02 w
.54101 .60289 m
.63741 .6526 L
s
P
p
.2 1 0 r
.02 w
.5412 .52043 m
.44193 .46712 L
s
P
p
0 .4 1 r
.02 w
.46198 .38413 m
.46009 .46416 L
s
P
p
.2 1 0 r
.02 w
.64118 .82609 m
.73667 .87101 L
s
P
p
0 .4 1 r
.02 w
.15753 .04919 m
.26538 .1138 L
s
P
p
.2 1 0 r
.02 w
.63926 .73752 m
.64118 .82609 L
s
P
p
.2 1 0 r
.02 w
.54082 .68894 m
.54101 .60289 L
s
P
p
.2 1 0 r
.02 w
.44193 .46712 m
.33746 .41102 L
s
P
p
0 .4 1 r
.02 w
.46009 .46416 m
.35594 .4079 L
s
P
p
0 .4 1 r
.02 w
.14886 .12464 m
.15753 .04919 L
s
P
p
.2 1 0 r
.02 w
.43712 .63776 m
.54082 .68894 L
s
P
p
.2 1 0 r
.02 w
.43958 .55058 m
.43712 .63776 L
s
P
p
.2 1 0 r
.02 w
.3327 .49546 m
.43958 .55058 L
s
P
p
.2 1 0 r
.02 w
.33746 .41102 m
.3327 .49546 L
s
P
p
0 .4 1 r
.02 w
.35594 .4079 m
.24617 .3486 L
s
P
p
0 .4 1 r
.02 w
.13979 .2035 m
.14886 .12464 L
s
P
p
0 .4 1 r
.02 w
.24617 .3486 m
.13031 .28601 L
s
P
p
0 .4 1 r
.02 w
.13031 .28601 m
.13979 .2035 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.430451 0.838346 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.564051 2.22952 0.0242196 0.968782 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.86973 .53081 m
.80222 .49625 L
s
P
p
.2 1 0 r
.02 w
.87496 .58531 m
.86973 .53081 L
s
P
p
.2 1 0 r
.02 w
.79815 .44302 m
.729 .40661 L
s
P
p
.2 1 0 r
.02 w
.80222 .49625 m
.79815 .44302 L
s
P
p
.2 1 0 r
.02 w
.80642 .55127 m
.87496 .58531 L
s
P
p
.2 1 0 r
.02 w
.729 .40661 m
.73199 .46031 L
s
P
p
.2 1 0 r
.02 w
.65529 .31637 m
.58161 .27653 L
s
P
p
.2 1 0 r
.02 w
.65705 .36873 m
.65529 .31637 L
s
P
p
.2 1 0 r
.02 w
.73508 .51583 m
.80642 .55127 L
s
P
p
.2 1 0 r
.02 w
.73199 .46031 m
.65887 .42288 L
s
P
p
.2 1 0 r
.02 w
.65887 .42288 m
.65705 .36873 L
s
P
p
.2 1 0 r
.02 w
.58161 .27653 m
.58214 .32929 L
s
P
p
.2 1 0 r
.02 w
.81077 .60816 m
.73828 .57329 L
s
P
p
.2 1 0 r
.02 w
.81527 .66701 m
.81077 .60816 L
s
P
p
.2 1 0 r
.02 w
.73828 .57329 m
.73508 .51583 L
s
P
p
.2 1 0 r
.02 w
.58214 .32929 m
.50408 .28819 L
s
P
p
.2 1 0 r
.02 w
.74159 .63278 m
.81527 .66701 L
s
P
p
.2 1 0 r
.02 w
.58269 .38389 m
.58326 .44043 L
s
P
p
.2 1 0 r
.02 w
.50325 .34322 m
.58269 .38389 L
s
P
p
0 .4 1 r
.02 w
.59723 .38173 m
.59806 .4383 L
s
P
p
0 .4 1 r
.02 w
.518 .34097 m
.59723 .38173 L
s
P
p
.01 w
.50408 .28819 Mdot
P
p
.2 1 0 r
.02 w
.50408 .28819 m
.50325 .34322 L
s
P
p
.01 w
.51858 .28591 Mdot
P
p
0 .4 1 r
.02 w
.51858 .28591 m
.518 .34097 L
s
P
p
.2 1 0 r
.02 w
.74502 .6944 m
.74159 .63278 L
s
P
p
.2 1 0 r
.02 w
.66271 .53694 m
.66473 .59706 L
s
P
p
.2 1 0 r
.02 w
.58385 .49902 m
.66271 .53694 L
s
P
p
.2 1 0 r
.02 w
.58326 .44043 m
.50239 .40026 L
s
P
p
0 .4 1 r
.02 w
.59806 .4383 m
.51741 .39803 L
s
P
p
.2 1 0 r
.02 w
.66682 .65939 m
.74502 .6944 L
s
P
p
.2 1 0 r
.02 w
.66473 .59706 m
.66682 .65939 L
s
P
p
.2 1 0 r
.02 w
.58446 .55976 m
.58385 .49902 L
s
P
p
.2 1 0 r
.02 w
.50239 .40026 m
.4179 .3583 L
s
P
p
0 .4 1 r
.02 w
.51741 .39803 m
.43316 .35597 L
s
P
p
.2 1 0 r
.02 w
.50056 .52078 m
.58446 .55976 L
s
P
p
.2 1 0 r
.02 w
.50149 .4594 m
.50056 .52078 L
s
P
p
.2 1 0 r
.02 w
.41539 .41799 m
.50149 .4594 L
s
P
p
0 .4 1 r
.02 w
.51679 .45721 m
.51615 .51862 L
s
P
p
0 .4 1 r
.02 w
.43093 .41569 m
.51679 .45721 L
s
P
p
.2 1 0 r
.02 w
.4179 .3583 m
.41539 .41799 L
s
P
p
0 .4 1 r
.02 w
.43316 .35597 m
.43093 .41569 L
s
P
p
0 .4 1 r
.02 w
.51615 .51862 m
.42862 .47773 L
s
P
p
0 .4 1 r
.02 w
.42862 .47773 m
.33693 .43489 L
s
P
p
0 .4 1 r
.02 w
.42621 .5422 m
.42371 .60927 L
s
P
p
0 .4 1 r
.02 w
.33262 .50007 m
.42621 .5422 L
s
P
p
0 .4 1 r
.02 w
.33693 .43489 m
.33262 .50007 L
s
P
p
0 .4 1 r
.02 w
.42371 .60927 m
.32813 .56792 L
s
P
p
0 .4 1 r
.02 w
.32813 .56792 m
.2277 .52448 L
s
P
p
0 .4 1 r
.02 w
.32345 .63863 m
.31857 .71238 L
s
P
p
0 .4 1 r
.02 w
.22074 .59608 m
.32345 .63863 L
s
P
p
0 .4 1 r
.02 w
.2277 .52448 m
.22074 .59608 L
s
P
p
0 .4 1 r
.02 w
.31857 .71238 m
.21346 .67084 L
s
P
p
0 .4 1 r
.02 w
.21346 .67084 m
.10265 .62705 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.430451 0.97619 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.308424 1.71627 0.0252773 1.01109 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.91024 .71077 m
.85823 .67661 L
s
P
p
.2 1 0 r
.02 w
.91443 .76965 m
.91024 .71077 L
s
P
p
.2 1 0 r
.02 w
.85467 .61866 m
.80176 .58313 L
s
P
p
.2 1 0 r
.02 w
.85823 .67661 m
.85467 .61866 L
s
P
p
.2 1 0 r
.02 w
.86187 .73592 m
.91443 .76965 L
s
P
p
.2 1 0 r
.02 w
.80176 .58313 m
.80474 .64148 L
s
P
p
.2 1 0 r
.02 w
.74504 .48922 m
.68968 .45125 L
s
P
p
.2 1 0 r
.02 w
.74735 .54659 m
.74504 .48922 L
s
P
p
.2 1 0 r
.02 w
.8078 .70123 m
.86187 .73592 L
s
P
p
.2 1 0 r
.02 w
.80474 .64148 m
.74972 .60534 L
s
P
p
.2 1 0 r
.02 w
.74972 .60534 m
.74735 .54659 L
s
P
p
.2 1 0 r
.02 w
.68968 .45125 m
.69137 .509 L
s
P
p
.2 1 0 r
.02 w
.86559 .79665 m
.81092 .76242 L
s
P
p
.2 1 0 r
.02 w
.86941 .85885 m
.86559 .79665 L
s
P
p
.2 1 0 r
.02 w
.81092 .76242 m
.8078 .70123 L
s
P
p
.2 1 0 r
.02 w
.69137 .509 m
.63374 .4703 L
s
P
p
.2 1 0 r
.02 w
.81412 .82511 m
.86941 .85885 L
s
P
p
.2 1 0 r
.02 w
.69309 .56815 m
.69486 .62876 L
s
P
p
.2 1 0 r
.02 w
.63478 .52985 m
.69309 .56815 L
s
P
p
0 .4 1 r
.02 w
.70421 .5661 m
.64602 .52775 L
s
P
p
.01 w
.63374 .4703 Mdot
P
p
.2 1 0 r
.02 w
.63374 .4703 m
.63478 .52985 L
s
P
p
.01 w
.64484 .46817 Mdot
P
p
0 .4 1 r
.02 w
.64484 .46817 m
.64602 .52775 L
s
P
p
.2 1 0 r
.02 w
.8174 .88936 m
.81412 .82511 L
s
P
p
.2 1 0 r
.02 w
.75464 .72718 m
.75719 .79037 L
s
P
p
.2 1 0 r
.02 w
.69667 .69088 m
.75464 .72718 L
s
P
p
.2 1 0 r
.02 w
.69486 .62876 m
.63584 .59089 L
s
P
p
0 .4 1 r
.02 w
.64602 .52775 m
.64722 .58881 L
s
P
p
.2 1 0 r
.02 w
.7598 .85515 m
.8174 .88936 L
s
P
p
.2 1 0 r
.02 w
.75719 .79037 m
.7598 .85515 L
s
P
p
.2 1 0 r
.02 w
.69852 .75457 m
.69667 .69088 L
s
P
p
.2 1 0 r
.02 w
.63584 .59089 m
.57504 .55187 L
s
P
p
0 .4 1 r
.02 w
.64722 .58881 m
.58653 .54973 L
s
P
p
0 .4 1 r
.02 w
.58607 .48823 m
.5243 .44751 L
s
P
p
0 .4 1 r
.02 w
.58653 .54973 m
.58607 .48823 L
s
P
p
.2 1 0 r
.02 w
.63805 .71767 m
.69852 .75457 L
s
P
p
.2 1 0 r
.02 w
.63694 .65348 m
.63805 .71767 L
s
P
p
.2 1 0 r
.02 w
.57536 .61492 m
.63694 .65348 L
s
P
p
.2 1 0 r
.02 w
.57504 .55187 m
.57536 .61492 L
s
P
p
0 .4 1 r
.02 w
.58653 .54973 m
.52397 .50943 L
s
P
p
0 .4 1 r
.02 w
.5243 .44751 m
.52397 .50943 L
s
P
p
0 .4 1 r
.02 w
.52397 .50943 m
.52363 .57297 L
s
P
p
0 .4 1 r
.02 w
.52363 .57297 m
.45824 .53187 L
s
P
p
0 .4 1 r
.02 w
.45944 .46787 m
.39284 .42498 L
s
P
p
0 .4 1 r
.02 w
.45824 .53187 m
.45944 .46787 L
s
P
p
0 .4 1 r
.02 w
.45824 .53187 m
.39073 .48944 L
s
P
p
0 .4 1 r
.02 w
.39284 .42498 m
.39073 .48944 L
s
P
p
0 .4 1 r
.02 w
.39073 .48944 m
.38855 .55566 L
s
P
p
0 .4 1 r
.02 w
.38855 .55566 m
.31781 .51232 L
s
P
p
0 .4 1 r
.02 w
.32099 .44561 m
.24892 .40032 L
s
P
p
0 .4 1 r
.02 w
.31781 .51232 m
.32099 .44561 L
s
P
p
0 .4 1 r
.02 w
.31781 .51232 m
.24467 .46752 L
s
P
p
0 .4 1 r
.02 w
.24892 .40032 m
.24467 .46752 L
s
P
p
0 .4 1 r
.02 w
.24467 .46752 m
.24029 .53665 L
s
P
p
0 .4 1 r
.02 w
.24029 .53665 m
.16344 .49084 L
s
P
p
0 .4 1 r
.02 w
.169 .42117 m
.09068 .37319 L
s
P
p
0 .4 1 r
.02 w
.16344 .49084 m
.169 .42117 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.568296 0.149123 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.564051 2.22952 0.0242196 0.968782 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.86973 .53081 m
.80222 .49625 L
s
P
p
.2 1 0 r
.02 w
.87496 .58531 m
.86973 .53081 L
s
P
p
.2 1 0 r
.02 w
.79815 .44302 m
.729 .40661 L
s
P
p
.2 1 0 r
.02 w
.80222 .49625 m
.79815 .44302 L
s
P
p
.2 1 0 r
.02 w
.80642 .55127 m
.87496 .58531 L
s
P
p
.2 1 0 r
.02 w
.729 .40661 m
.73199 .46031 L
s
P
p
.2 1 0 r
.02 w
.65529 .31637 m
.58161 .27653 L
s
P
p
.2 1 0 r
.02 w
.65705 .36873 m
.65529 .31637 L
s
P
p
.2 1 0 r
.02 w
.73508 .51583 m
.80642 .55127 L
s
P
p
.2 1 0 r
.02 w
.73199 .46031 m
.65887 .42288 L
s
P
p
.2 1 0 r
.02 w
.65887 .42288 m
.65705 .36873 L
s
P
p
.2 1 0 r
.02 w
.58161 .27653 m
.58214 .32929 L
s
P
p
.2 1 0 r
.02 w
.81077 .60816 m
.73828 .57329 L
s
P
p
.2 1 0 r
.02 w
.81527 .66701 m
.81077 .60816 L
s
P
p
.2 1 0 r
.02 w
.73828 .57329 m
.73508 .51583 L
s
P
p
.2 1 0 r
.02 w
.58214 .32929 m
.50408 .28819 L
s
P
p
.2 1 0 r
.02 w
.74159 .63278 m
.81527 .66701 L
s
P
p
.2 1 0 r
.02 w
.58269 .38389 m
.58326 .44043 L
s
P
p
.2 1 0 r
.02 w
.50325 .34322 m
.58269 .38389 L
s
P
p
0 .4 1 r
.02 w
.59723 .38173 m
.59806 .4383 L
s
P
p
0 .4 1 r
.02 w
.518 .34097 m
.59723 .38173 L
s
P
p
.01 w
.50408 .28819 Mdot
P
p
.2 1 0 r
.02 w
.50408 .28819 m
.50325 .34322 L
s
P
p
.01 w
.51858 .28591 Mdot
P
p
0 .4 1 r
.02 w
.51858 .28591 m
.518 .34097 L
s
P
p
.2 1 0 r
.02 w
.74502 .6944 m
.74159 .63278 L
s
P
p
.2 1 0 r
.02 w
.66271 .53694 m
.66473 .59706 L
s
P
p
.2 1 0 r
.02 w
.58385 .49902 m
.66271 .53694 L
s
P
p
.2 1 0 r
.02 w
.58326 .44043 m
.50239 .40026 L
s
P
p
0 .4 1 r
.02 w
.59806 .4383 m
.51741 .39803 L
s
P
p
.2 1 0 r
.02 w
.66682 .65939 m
.74502 .6944 L
s
P
p
.2 1 0 r
.02 w
.66473 .59706 m
.66682 .65939 L
s
P
p
.2 1 0 r
.02 w
.58446 .55976 m
.58385 .49902 L
s
P
p
.2 1 0 r
.02 w
.50239 .40026 m
.4179 .3583 L
s
P
p
0 .4 1 r
.02 w
.51741 .39803 m
.43316 .35597 L
s
P
p
.2 1 0 r
.02 w
.50056 .52078 m
.58446 .55976 L
s
P
p
.2 1 0 r
.02 w
.50149 .4594 m
.50056 .52078 L
s
P
p
.2 1 0 r
.02 w
.41539 .41799 m
.50149 .4594 L
s
P
p
0 .4 1 r
.02 w
.51679 .45721 m
.51615 .51862 L
s
P
p
0 .4 1 r
.02 w
.43093 .41569 m
.51679 .45721 L
s
P
p
.2 1 0 r
.02 w
.4179 .3583 m
.41539 .41799 L
s
P
p
0 .4 1 r
.02 w
.43316 .35597 m
.43093 .41569 L
s
P
p
0 .4 1 r
.02 w
.51615 .51862 m
.42862 .47773 L
s
P
p
0 .4 1 r
.02 w
.42862 .47773 m
.33693 .43489 L
s
P
p
0 .4 1 r
.02 w
.42621 .5422 m
.42371 .60927 L
s
P
p
0 .4 1 r
.02 w
.33262 .50007 m
.42621 .5422 L
s
P
p
0 .4 1 r
.02 w
.33693 .43489 m
.33262 .50007 L
s
P
p
0 .4 1 r
.02 w
.42371 .60927 m
.32813 .56792 L
s
P
p
0 .4 1 r
.02 w
.32813 .56792 m
.2277 .52448 L
s
P
p
0 .4 1 r
.02 w
.32345 .63863 m
.31857 .71238 L
s
P
p
0 .4 1 r
.02 w
.22074 .59608 m
.32345 .63863 L
s
P
p
0 .4 1 r
.02 w
.2277 .52448 m
.22074 .59608 L
s
P
p
0 .4 1 r
.02 w
.31857 .71238 m
.21346 .67084 L
s
P
p
0 .4 1 r
.02 w
.21346 .67084 m
.10265 .62705 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.568296 0.286967 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.649333 2.38458 0.0238845 0.955379 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.88135 .53242 m
.7779 .48414 L
s
P
p
0 .4 1 r
.02 w
.88868 .60895 m
.88135 .53242 L
s
P
p
0 .4 1 r
.02 w
.77289 .40994 m
.66614 .35823 L
s
P
p
0 .4 1 r
.02 w
.7779 .48414 m
.77289 .40994 L
s
P
p
0 .4 1 r
.02 w
.66351 .28641 m
.55341 .23122 L
s
P
p
0 .4 1 r
.02 w
.66614 .35823 m
.66351 .28641 L
s
P
p
.2 1 0 r
.02 w
.86758 .61144 m
.76162 .56426 L
s
P
p
.2 1 0 r
.02 w
.87476 .6913 m
.86758 .61144 L
s
P
p
0 .4 1 r
.02 w
.78312 .56164 m
.88868 .60895 L
s
P
p
.2 1 0 r
.02 w
.75686 .48682 m
.64746 .43609 L
s
P
p
.2 1 0 r
.02 w
.76162 .56426 m
.75686 .48682 L
s
P
p
0 .4 1 r
.02 w
.55341 .23122 m
.55365 .30374 L
s
P
p
.2 1 0 r
.02 w
.76658 .64523 m
.87476 .6913 L
s
P
p
0 .4 1 r
.02 w
.78859 .64266 m
.78312 .56164 L
s
P
p
.2 1 0 r
.02 w
.64746 .43609 m
.64984 .5145 L
s
P
p
.2 1 0 r
.02 w
.53228 .30676 m
.41314 .24942 L
s
P
p
.2 1 0 r
.02 w
.53203 .38257 m
.53228 .30676 L
s
P
p
0 .4 1 r
.02 w
.55365 .30374 m
.43492 .24623 L
s
P
p
.2 1 0 r
.02 w
.65234 .59657 m
.76658 .64523 L
s
P
p
0 .4 1 r
.02 w
.67479 .59386 m
.78859 .64266 L
s
P
p
.2 1 0 r
.02 w
.64984 .5145 m
.53178 .46193 L
s
P
p
.2 1 0 r
.02 w
.53178 .46193 m
.53203 .38257 L
s
P
p
.2 1 0 r
.02 w
.41314 .24942 m
.41008 .32602 L
s
P
p
0 .4 1 r
.02 w
.43492 .24623 m
.43237 .32286 L
s
P
p
.2 1 0 r
.02 w
.77178 .72996 m
.65496 .68257 L
s
P
p
.2 1 0 r
.02 w
.77723 .81872 m
.77178 .72996 L
s
P
p
.2 1 0 r
.02 w
.65496 .68257 m
.65234 .59657 L
s
P
p
0 .4 1 r
.02 w
.67795 .67993 m
.67479 .59386 L
s
P
p
.2 1 0 r
.02 w
.41008 .32602 m
.28102 .26618 L
s
P
p
0 .4 1 r
.02 w
.43237 .32286 m
.30375 .26284 L
s
P
p
.2 1 0 r
.02 w
.6577 .77278 m
.77723 .81872 L
s
P
p
0 .4 1 r
.02 w
.5547 .62958 m
.67795 .67993 L
s
P
p
0 .4 1 r
.02 w
.55442 .54223 m
.5547 .62958 L
s
P
p
0 .4 1 r
.02 w
.42689 .48754 m
.55442 .54223 L
s
P
p
.2 1 0 r
.02 w
.40687 .40632 m
.4035 .49059 L
s
P
p
.2 1 0 r
.02 w
.27451 .34738 m
.40687 .40632 L
s
P
p
0 .4 1 r
.02 w
.42969 .40321 m
.42689 .48754 L
s
P
p
0 .4 1 r
.02 w
.2978 .34409 m
.42969 .40321 L
s
P
p
.01 w
.28102 .26618 Mdot
P
p
.2 1 0 r
.02 w
.28102 .26618 m
.27451 .34738 L
s
P
p
.01 w
.30375 .26284 Mdot
P
p
0 .4 1 r
.02 w
.30375 .26284 m
.2978 .34409 L
s
P
p
.2 1 0 r
.02 w
.66058 .86753 m
.6577 .77278 L
s
P
p
.2 1 0 r
.02 w
.53123 .63238 m
.53093 .72406 L
s
P
p
.2 1 0 r
.02 w
.39996 .57913 m
.53123 .63238 L
s
P
p
.2 1 0 r
.02 w
.4035 .49059 m
.26766 .43273 L
s
P
p
.2 1 0 r
.02 w
.53062 .82049 m
.66058 .86753 L
s
P
p
.2 1 0 r
.02 w
.53093 .72406 m
.53062 .82049 L
s
P
p
.2 1 0 r
.02 w
.39624 .67229 m
.39996 .57913 L
s
P
p
.2 1 0 r
.02 w
.26766 .43273 m
.12324 .37122 L
s
P
p
.2 1 0 r
.02 w
.25286 .61718 m
.39624 .67229 L
s
P
p
.2 1 0 r
.02 w
.26046 .52254 m
.25286 .61718 L
s
P
p
.2 1 0 r
.02 w
.1119 .46228 m
.26046 .52254 L
s
P
p
.2 1 0 r
.02 w
.12324 .37122 m
.1119 .46228 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.568296 0.424812 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.568296 0.562657 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.730065 2.53751 0.018984 0.957089 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.76761 .44458 m
.67528 .40356 L
s
P
p
.2 1 0 r
.02 w
.77151 .50545 m
.76761 .44458 L
s
P
p
.2 1 0 r
.02 w
.67298 .3442 m
.57838 .30097 L
s
P
p
.2 1 0 r
.02 w
.67528 .40356 m
.67298 .3442 L
s
P
p
0 .4 1 r
.02 w
.59545 .24072 m
.59642 .29857 L
s
P
p
0 .4 1 r
.02 w
.49881 .19515 m
.59545 .24072 L
s
P
p
.2 1 0 r
.02 w
.67766 .46498 m
.77151 .50545 L
s
P
p
0 .4 1 r
.02 w
.69337 .40129 m
.69606 .46274 L
s
P
p
0 .4 1 r
.02 w
.59743 .35845 m
.69337 .40129 L
s
P
p
.2 1 0 r
.02 w
.57838 .30097 m
.57908 .36081 L
s
P
p
0 .4 1 r
.02 w
.59642 .29857 m
.59743 .35845 L
s
P
p
.2 1 0 r
.02 w
.48082 .19767 m
.37984 .15028 L
s
P
p
.2 1 0 r
.02 w
.47981 .25592 m
.48082 .19767 L
s
P
p
0 .4 1 r
.02 w
.49811 .25342 m
.49881 .19515 L
s
P
p
0 .4 1 r
.02 w
.794 .56631 m
.79852 .63155 L
s
P
p
0 .4 1 r
.02 w
.69885 .52638 m
.794 .56631 L
s
P
p
.2 1 0 r
.02 w
.5798 .42279 m
.67766 .46498 L
s
P
p
0 .4 1 r
.02 w
.69606 .46274 m
.69885 .52638 L
s
P
p
.2 1 0 r
.02 w
.57908 .36081 m
.47876 .31624 L
s
P
p
0 .4 1 r
.02 w
.59848 .42045 m
.59743 .35845 L
s
P
p
.2 1 0 r
.02 w
.47876 .31624 m
.47981 .25592 L
s
P
p
0 .4 1 r
.02 w
.39557 .20633 m
.49811 .25342 L
s
P
p
.2 1 0 r
.02 w
.37984 .15028 m
.37699 .20893 L
s
P
p
0 .4 1 r
.02 w
.89748 .73599 m
.90391 .80521 L
s
P
p
0 .4 1 r
.02 w
.80319 .69914 m
.89748 .73599 L
s
P
p
0 .4 1 r
.02 w
.79852 .63155 m
.80319 .69914 L
s
P
p
.2 1 0 r
.02 w
.68012 .52858 m
.58054 .48701 L
s
P
p
.2 1 0 r
.02 w
.68267 .59448 m
.68012 .52858 L
s
P
p
0 .4 1 r
.02 w
.70175 .59231 m
.69885 .52638 L
s
P
p
.2 1 0 r
.02 w
.58054 .48701 m
.5798 .42279 L
s
P
p
0 .4 1 r
.02 w
.49664 .37632 m
.59848 .42045 L
s
P
p
.2 1 0 r
.02 w
.37699 .20893 m
.26966 .15988 L
s
P
p
0 .4 1 r
.02 w
.28852 .15716 m
.39557 .20633 L
s
P
p
0 .4 1 r
.02 w
.90391 .80521 m
.91058 .87696 L
s
P
p
0 .4 1 r
.02 w
.80804 .76921 m
.80319 .69914 L
s
P
p
.2 1 0 r
.02 w
.58131 .5536 m
.68267 .59448 L
s
P
p
0 .4 1 r
.02 w
.60069 .55133 m
.70175 .59231 L
s
P
p
0 .4 1 r
.02 w
.39025 .33021 m
.49664 .37632 L
s
P
p
.2 1 0 r
.02 w
.37404 .26972 m
.37098 .33276 L
s
P
p
.2 1 0 r
.02 w
.26464 .22111 m
.37404 .26972 L
s
P
p
0 .4 1 r
.02 w
.91058 .87696 m
.9175 .95137 L
s
P
p
.01 w
.26966 .15988 Mdot
P
p
.2 1 0 r
.02 w
.26966 .15988 m
.26464 .22111 L
s
P
p
.01 w
.28852 .15716 Mdot
P
p
0 .4 1 r
.02 w
.70786 .73159 m
.80804 .76921 L
s
P
p
.2 1 0 r
.02 w
.58211 .62269 m
.58131 .5536 L
s
P
p
0 .4 1 r
.02 w
.49505 .5085 m
.60069 .55133 L
s
P
p
.2 1 0 r
.02 w
.47654 .44359 m
.47536 .51087 L
s
P
p
.2 1 0 r
.02 w
.36781 .3982 m
.47654 .44359 L
s
P
p
.2 1 0 r
.02 w
.37098 .33276 m
.25944 .28467 L
s
P
p
0 .4 1 r
.02 w
.9175 .95137 m
.81829 .91734 L
s
P
p
0 .4 1 r
.02 w
.60306 .69225 m
.70786 .73159 L
s
P
p
.2 1 0 r
.02 w
.47415 .58073 m
.58211 .62269 L
s
P
p
.2 1 0 r
.02 w
.47536 .51087 m
.47415 .58073 L
s
P
p
.2 1 0 r
.02 w
.36451 .46616 m
.36781 .3982 L
s
P
p
.2 1 0 r
.02 w
.25944 .28467 m
.14268 .23434 L
s
P
p
0 .4 1 r
.02 w
.81829 .91734 m
.71444 .88172 L
s
P
p
.2 1 0 r
.02 w
.24841 .41932 m
.36451 .46616 L
s
P
p
.2 1 0 r
.02 w
.25403 .35069 m
.24841 .41932 L
s
P
p
.2 1 0 r
.02 w
.13483 .30093 m
.25403 .35069 L
s
P
p
.2 1 0 r
.02 w
.14268 .23434 m
.13483 .30093 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.568296 0.700501 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.498191 2.097 0.0245059 0.980236 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87882 .61174 m
.78846 .56381 L
s
P
p
.2 1 0 r
.02 w
.88591 .6918 m
.87882 .61174 L
s
P
p
.2 1 0 r
.02 w
.7834 .48613 m
.69015 .43471 L
s
P
p
.2 1 0 r
.02 w
.78846 .56381 m
.7834 .48613 L
s
P
p
.2 1 0 r
.02 w
.79374 .64494 m
.88591 .6918 L
s
P
p
.2 1 0 r
.02 w
.69015 .43471 m
.69327 .51333 L
s
P
p
.2 1 0 r
.02 w
.59099 .30448 m
.48962 .24655 L
s
P
p
.2 1 0 r
.02 w
.5919 .38054 m
.59099 .30448 L
s
P
p
.2 1 0 r
.02 w
.69652 .59553 m
.79374 .64494 L
s
P
p
.2 1 0 r
.02 w
.69327 .51333 m
.59285 .46007 L
s
P
p
.2 1 0 r
.02 w
.59285 .46007 m
.5919 .38054 L
s
P
p
.2 1 0 r
.02 w
.48962 .24655 m
.48822 .32337 L
s
P
p
0 .4 1 r
.02 w
.50847 .24332 m
.50751 .32019 L
s
P
p
0 .4 1 r
.02 w
.40185 .182 m
.50847 .24332 L
s
P
p
.2 1 0 r
.02 w
.79926 .72975 m
.69993 .68156 L
s
P
p
.2 1 0 r
.02 w
.80503 .8185 m
.79926 .72975 L
s
P
p
.2 1 0 r
.02 w
.69993 .68156 m
.69652 .59553 L
s
P
p
.2 1 0 r
.02 w
.48822 .32337 m
.37867 .26297 L
s
P
p
0 .4 1 r
.02 w
.50751 .32019 m
.39834 .2596 L
s
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.40185 .182 L
s
P
p
.2 1 0 r
.02 w
.7035 .77169 m
.80503 .8185 L
s
P
p
.2 1 0 r
.02 w
.48676 .40381 m
.48523 .48812 L
s
P
p
.2 1 0 r
.02 w
.37451 .34428 m
.48676 .40381 L
s
P
p
0 .4 1 r
.02 w
.5065 .40067 m
.50545 .48504 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.5065 .40067 L
s
P
p
.01 w
.37867 .26297 Mdot
P
p
.2 1 0 r
.02 w
.37867 .26297 m
.37451 .34428 L
s
P
p
.01 w
.39834 .2596 Mdot
P
p
0 .4 1 r
.02 w
.28278 .19546 m
.39834 .2596 L
s
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.28914 .11718 m
.28278 .19546 L
s
P
p
0 .4 1 r
.02 w
.16981 .04855 m
.28914 .11718 L
s
P
p
.2 1 0 r
.02 w
.70724 .86623 m
.7035 .77169 L
s
P
p
.2 1 0 r
.02 w
.59489 .63059 m
.59598 .72212 L
s
P
p
.2 1 0 r
.02 w
.48363 .5766 m
.59489 .63059 L
s
P
p
.2 1 0 r
.02 w
.48523 .48812 m
.37015 .42962 L
s
P
p
0 .4 1 r
.02 w
.50545 .48504 m
.39078 .42635 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.2761 .27766 L
s
P
p
0 .4 1 r
.02 w
.39078 .42635 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.28278 .19546 m
.16026 .12747 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.28278 .19546 L
s
P
p
.2 1 0 r
.02 w
.59713 .81827 m
.70724 .86623 L
s
P
p
0 .4 1 r
.02 w
.16026 .12747 m
.16981 .04855 L
s
P
p
.2 1 0 r
.02 w
.59598 .72212 m
.59713 .81827 L
s
P
p
.2 1 0 r
.02 w
.48194 .66955 m
.48363 .5766 L
s
P
p
.2 1 0 r
.02 w
.37015 .42962 m
.24801 .36753 L
s
P
p
0 .4 1 r
.02 w
.15022 .21045 m
.2761 .27766 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.26907 .36406 L
s
P
p
.2 1 0 r
.02 w
.36075 .61368 m
.48194 .66955 L
s
P
p
.2 1 0 r
.02 w
.36557 .51931 m
.36075 .61368 L
s
P
p
.2 1 0 r
.02 w
.24008 .45841 m
.36557 .51931 L
s
P
p
.2 1 0 r
.02 w
.24801 .36753 m
.24008 .45841 L
s
P
p
0 .4 1 r
.02 w
.26907 .36406 m
.13964 .29782 L
s
P
p
0 .4 1 r
.02 w
.13964 .29782 m
.15022 .21045 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.568296 0.838346 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.564051 2.22952 0.0242196 0.968782 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.86973 .53081 m
.80222 .49625 L
s
P
p
.2 1 0 r
.02 w
.87496 .58531 m
.86973 .53081 L
s
P
p
.2 1 0 r
.02 w
.79815 .44302 m
.729 .40661 L
s
P
p
.2 1 0 r
.02 w
.80222 .49625 m
.79815 .44302 L
s
P
p
.2 1 0 r
.02 w
.80642 .55127 m
.87496 .58531 L
s
P
p
.2 1 0 r
.02 w
.729 .40661 m
.73199 .46031 L
s
P
p
.2 1 0 r
.02 w
.65529 .31637 m
.58161 .27653 L
s
P
p
.2 1 0 r
.02 w
.65705 .36873 m
.65529 .31637 L
s
P
p
.2 1 0 r
.02 w
.73508 .51583 m
.80642 .55127 L
s
P
p
.2 1 0 r
.02 w
.73199 .46031 m
.65887 .42288 L
s
P
p
.2 1 0 r
.02 w
.65887 .42288 m
.65705 .36873 L
s
P
p
.2 1 0 r
.02 w
.58161 .27653 m
.58214 .32929 L
s
P
p
.2 1 0 r
.02 w
.81077 .60816 m
.73828 .57329 L
s
P
p
.2 1 0 r
.02 w
.81527 .66701 m
.81077 .60816 L
s
P
p
.2 1 0 r
.02 w
.73828 .57329 m
.73508 .51583 L
s
P
p
.2 1 0 r
.02 w
.58214 .32929 m
.50408 .28819 L
s
P
p
.2 1 0 r
.02 w
.74159 .63278 m
.81527 .66701 L
s
P
p
.2 1 0 r
.02 w
.58269 .38389 m
.58326 .44043 L
s
P
p
.2 1 0 r
.02 w
.50325 .34322 m
.58269 .38389 L
s
P
p
0 .4 1 r
.02 w
.59723 .38173 m
.59806 .4383 L
s
P
p
0 .4 1 r
.02 w
.518 .34097 m
.59723 .38173 L
s
P
p
.01 w
.50408 .28819 Mdot
P
p
.2 1 0 r
.02 w
.50408 .28819 m
.50325 .34322 L
s
P
p
.01 w
.51858 .28591 Mdot
P
p
0 .4 1 r
.02 w
.51858 .28591 m
.518 .34097 L
s
P
p
.2 1 0 r
.02 w
.74502 .6944 m
.74159 .63278 L
s
P
p
.2 1 0 r
.02 w
.66271 .53694 m
.66473 .59706 L
s
P
p
.2 1 0 r
.02 w
.58385 .49902 m
.66271 .53694 L
s
P
p
.2 1 0 r
.02 w
.58326 .44043 m
.50239 .40026 L
s
P
p
0 .4 1 r
.02 w
.59806 .4383 m
.51741 .39803 L
s
P
p
.2 1 0 r
.02 w
.66682 .65939 m
.74502 .6944 L
s
P
p
.2 1 0 r
.02 w
.66473 .59706 m
.66682 .65939 L
s
P
p
.2 1 0 r
.02 w
.58446 .55976 m
.58385 .49902 L
s
P
p
.2 1 0 r
.02 w
.50239 .40026 m
.4179 .3583 L
s
P
p
0 .4 1 r
.02 w
.51741 .39803 m
.43316 .35597 L
s
P
p
.2 1 0 r
.02 w
.50056 .52078 m
.58446 .55976 L
s
P
p
.2 1 0 r
.02 w
.50149 .4594 m
.50056 .52078 L
s
P
p
.2 1 0 r
.02 w
.41539 .41799 m
.50149 .4594 L
s
P
p
0 .4 1 r
.02 w
.51679 .45721 m
.51615 .51862 L
s
P
p
0 .4 1 r
.02 w
.43093 .41569 m
.51679 .45721 L
s
P
p
.2 1 0 r
.02 w
.4179 .3583 m
.41539 .41799 L
s
P
p
0 .4 1 r
.02 w
.43316 .35597 m
.43093 .41569 L
s
P
p
0 .4 1 r
.02 w
.51615 .51862 m
.42862 .47773 L
s
P
p
0 .4 1 r
.02 w
.42862 .47773 m
.33693 .43489 L
s
P
p
0 .4 1 r
.02 w
.42621 .5422 m
.42371 .60927 L
s
P
p
0 .4 1 r
.02 w
.33262 .50007 m
.42621 .5422 L
s
P
p
0 .4 1 r
.02 w
.33693 .43489 m
.33262 .50007 L
s
P
p
0 .4 1 r
.02 w
.42371 .60927 m
.32813 .56792 L
s
P
p
0 .4 1 r
.02 w
.32813 .56792 m
.2277 .52448 L
s
P
p
0 .4 1 r
.02 w
.32345 .63863 m
.31857 .71238 L
s
P
p
0 .4 1 r
.02 w
.22074 .59608 m
.32345 .63863 L
s
P
p
0 .4 1 r
.02 w
.2277 .52448 m
.22074 .59608 L
s
P
p
0 .4 1 r
.02 w
.31857 .71238 m
.21346 .67084 L
s
P
p
0 .4 1 r
.02 w
.21346 .67084 m
.10265 .62705 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.568296 0.97619 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.41269 1.92534 0.0248776 0.995106 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.89339 .65315 m
.82085 .61097 L
s
P
p
.2 1 0 r
.02 w
.89916 .72469 m
.89339 .65315 L
s
P
p
.2 1 0 r
.02 w
.81636 .54107 m
.74201 .49647 L
s
P
p
.2 1 0 r
.02 w
.82085 .61097 m
.81636 .54107 L
s
P
p
.2 1 0 r
.02 w
.82549 .68325 m
.89916 .72469 L
s
P
p
.2 1 0 r
.02 w
.74201 .49647 m
.74531 .56704 L
s
P
p
.2 1 0 r
.02 w
.66264 .3812 m
.58329 .3322 L
s
P
p
.2 1 0 r
.02 w
.66458 .45002 m
.66264 .3812 L
s
P
p
.2 1 0 r
.02 w
.74873 .64008 m
.82549 .68325 L
s
P
p
.2 1 0 r
.02 w
.74531 .56704 m
.66659 .52126 L
s
P
p
.2 1 0 r
.02 w
.66659 .52126 m
.66458 .45002 L
s
P
p
.2 1 0 r
.02 w
.58329 .3322 m
.58387 .40161 L
s
P
p
.2 1 0 r
.02 w
.8303 .75806 m
.75227 .71572 L
s
P
p
.2 1 0 r
.02 w
.83527 .83553 m
.8303 .75806 L
s
P
p
.2 1 0 r
.02 w
.75227 .71572 m
.74873 .64008 L
s
P
p
.2 1 0 r
.02 w
.58387 .40161 m
.49968 .3511 L
s
P
p
.2 1 0 r
.02 w
.75594 .7941 m
.83527 .83553 L
s
P
p
.2 1 0 r
.02 w
.58448 .47351 m
.58511 .54804 L
s
P
p
.2 1 0 r
.02 w
.49876 .42366 m
.58448 .47351 L
s
P
p
0 .4 1 r
.02 w
.60016 .47087 m
.60108 .54544 L
s
P
p
0 .4 1 r
.02 w
.51468 .4209 m
.60016 .47087 L
s
P
p
.01 w
.49968 .3511 Mdot
P
p
.2 1 0 r
.02 w
.49968 .3511 m
.49876 .42366 L
s
P
p
.01 w
.51532 .34831 Mdot
P
p
0 .4 1 r
.02 w
.42765 .29544 m
.51532 .34831 L
s
P
p
0 .4 1 r
.02 w
.51532 .34831 m
.51468 .4209 L
s
P
p
.2 1 0 r
.02 w
.75975 .87538 m
.75594 .7941 L
s
P
p
.2 1 0 r
.02 w
.67084 .67152 m
.67308 .75083 L
s
P
p
.2 1 0 r
.02 w
.58577 .62535 m
.67084 .67152 L
s
P
p
.2 1 0 r
.02 w
.58511 .54804 m
.4978 .49893 L
s
P
p
0 .4 1 r
.02 w
.60108 .54544 m
.51402 .49621 L
s
P
p
0 .4 1 r
.02 w
.33601 .24019 m
.42765 .29544 L
s
P
p
.2 1 0 r
.02 w
.6754 .83313 m
.75975 .87538 L
s
P
p
.2 1 0 r
.02 w
.67308 .75083 m
.6754 .83313 L
s
P
p
.2 1 0 r
.02 w
.58644 .70559 m
.58577 .62535 L
s
P
p
.2 1 0 r
.02 w
.4978 .49893 m
.40649 .44757 L
s
P
p
0 .4 1 r
.02 w
.51402 .49621 m
.42296 .44472 L
s
P
p
0 .4 1 r
.02 w
.24013 .18238 m
.33601 .24019 L
s
P
p
.2 1 0 r
.02 w
.49578 .65824 m
.58644 .70559 L
s
P
p
.2 1 0 r
.02 w
.49681 .57707 m
.49578 .65824 L
s
P
p
.2 1 0 r
.02 w
.40369 .52653 m
.49681 .57707 L
s
P
p
.2 1 0 r
.02 w
.40649 .44757 m
.40369 .52653 L
s
P
p
0 .4 1 r
.02 w
.42296 .44472 m
.32763 .39081 L
s
P
p
0 .4 1 r
.02 w
.13971 .12183 m
.24013 .18238 L
s
P
p
0 .4 1 r
.02 w
.32763 .39081 m
.2277 .33431 L
s
P
p
0 .4 1 r
.02 w
.23404 .25685 m
.13145 .19688 L
s
P
p
0 .4 1 r
.02 w
.2277 .33431 m
.23404 .25685 L
s
P
p
0 .4 1 r
.02 w
.13145 .19688 m
.13971 .12183 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
P
MathSubEnd
P
% End of sub-graphic
p
/Times-Italic findfont 18 scalefont setfont
[(Fractals)] .02381 .57389 -1 0 Mshowa
P
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{413, 256},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006M000100P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0WP00003obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002M
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/10000
0?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040
003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002M
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000jk/00lJk^`2^^`400000ol^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^l^k
bk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000>fk
00?6^k/0[;/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l_6bk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;0040003]^`03a[^k0:bk0@00001:bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2aP1Dbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0/H0Bl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02aP2]^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004Bk00>Ea_l00k/01<JEa/HQ^`03ULK600:k
0YDT^`03ULK600:k00>Ea[/00/I;^`?6Z[/1000004O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6U@02aP03^lJk00:E02C6^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^EaYD2aP03UK^E00:E02Bkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk^EaYD2aP03ULJE00:E0876^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_6^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULH019D0Lk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004Bk00FEa[^kU@02aP>k
00>Ea/H07[/01YG6^k^EaPBk00>E^k/07[/01IG6^k^E00;60k/00iG6^`1;^`03a[^k02jk00BEa[^E
0[/00iFk^`1`^`400000DL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^l^Ea[_;^iFkb`02aP0M^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbiD00/H00l^kU@02aP0T^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E
0/H0Pk_;ULJkbk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^k00BE07S6UL^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/10000?[/2U@Fk00?6UID01[/00iFk^`02^`03a[^k01>k0YD5^`04
aYG6aP>k0lHJ^`:E1[/00iG6aP05^`03ULJk04^k00?6^k/00/HY^`04UK^kU@;600BE^k^EL[/10000
043;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iFk0YD0:L^kblK;^iFkbk_;^iFkbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;00:E00fkbk_6
^l^Ea[_;^l^E00;601[;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^`:E00g;^l^kbk^Ea/^kbk^E00;6
04^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/01<H0:/_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`?600JkbiG6^l/5U@1^bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/10000?[/019Fk^k/2U@03^lJk00:k00>E^k/00[/00iFk^`02^`03a[^k01>k00BE^k^k
0YD00k_6^`02^`03ULJk00:k00>E^k/00/HF^`04UK^k^`:E1K/00iG6^`02^`03UK^k00;6C;/00lJk
aP0X^`03a[^k00G61;/00iFkU@0Y^`03aYFk046k0@000015bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk^E00;600bkbiG;^l^kUK_;
^l/2aP0Y^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^Ea[_;^iFkbk_;UL^kbk/00/H06/^kbk_;^l^k
bk_;^l^kbk_;^l^Ebk_;^l^k0YD0>L^kbiG6^l^kUK_;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_ob`02U@21^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbiG;^iG6bk_;^l^kUK_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E00;604:E^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000?K/2U@Nk00BEa/K6
1;/00iFk^`02^`:E0/HA^`:E1[/01LJEUK^E00Bk00RE^k^kULJkaQ:k0YD7^`:E00>kULH00k/01YG6
a[^EaRVk00G6UIFkU@0O^`03a[^k02Jk0/H00k^EU@02U@03^iFk00:k1IDR^`;60[/6UCnk0@00000o
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00:E00Nkbk_;^l^k00:E00C6^l^k0YD01L^kbiG;00:E01?6bk_;^l^kbk_;^l^kbk_;^l^k00:E
00O;^l^ka[_;00:E00Bkbk_;0YD01;_;ULH2U@0Da/^kbk_;^l^kbk_;^l^kbk_;^l/2U@07^l^kbk_;
^`02U@;600S;^iG6blJEaP>E026kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00lH0:;_;
a/^EbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a//3aP0Qbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00?600o;^lJkbk^E^l^Ebk^E^l/00iD08L^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`03aP03blK600;60iD0?/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@00046k0YD6^`03ULJk00Bk19D3^`03ULJk01:k
0YD00k_6^`03^`03UK^k00Bk0iD01LJk^k_601Bk0YD6^`03UK^k00;600BkaYFE0/H3^`03UK^k01Vk
0lH2^`03a[^E00;600FEa[^kU@0P^`;60[/00lJk^`0N^`03a[^k00;600>ka[/01;/00iFk^`03U@:k
00>E^k/06K/2aPFk00?6^lH00lH4UCjk0@00002Tbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_6^l^kbk_;^l^Ebk_;ULJk
bk_;^l^kbk_;^l^kbk_;^l^kbk^Ea/^kbk_;^l^kbk_;^l^kUK_;^lJkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;UL^kbk_;^l^kbk/2aP0Nbk_;a/^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0/H02<^kblK;^lJk
0lH0DK_;a/_6biG;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_6^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^`02aP0Ybk_;^l^Ebk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/01<H00k_6aP05aP13^iFEUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000@k/00iFk^`04^`03a[^k00Zk00>Ea[/0
5;/00iG6^`0A^`03ULJk01Bk00>E^k/02K/00lJk^`05^`03UK^k01Bk00?6^lH00[/2aP:k00O6^k^E
aYFk00;600>kUID00YDQ^`03a[^k01jk00?6^k/00k/00lJk^`03^`NE5k/00lJk^`05^`03a[_600?6
0[/00lJk^`12^`400000B/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^E0/H0Dl^kbk_;^l^kbk_;ULJkbk_;^l^kbk_;^l^k
bk_;^l^kbk^Ea/^kbk^Ea/^kbk_;^l^kbk_;^iG6bk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;00:E
00bkbk_;^l^kbk_;^l/2U@0>^l^kbk_;^l^kbk_;^l/2aP08^l^kbk_6^l/2aP05^l_6bk/01<H0;/^E
blK;^l^EbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJka[/2U@0Kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00?602O;^l^kbk_;^l^kbk^E^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
1<H00k_6aP06aP18bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004>k00>E^k/00k/00iFkU@02aPFk00>Ea/H00[/00lJE
U@0C^`03ULJk00>k00BEaYFE1[/2U@>k00?6UID04k/00iFk^`03^`04UK^EU@Jk0YD4^`:E3[/2aP>k
0/H3^`;600>ka[/00k/00lJkU@07^`:E7k/3aP:E00>kUK/05K/3aPBk00?6^k/09K/00lJk^`03aP05
^lK6^lH0BK/1000004?;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;00>E013;^l^Ebk_;ULJkbk_;ULJE0lH05[_;UL^kbk_;^l^kbk_;
^l^kbk_;^iD3aP0>bk^Ea/^kUK_;^l^kUK/2U@0GblK;^iFkbk_;^l^kbk_;^l^kbk_;^l/00iD03l^k
biG;^l^Ebk_;^l^Eb`02U@0D^l^kbiG;^l^kbk_;^l^kbk_;^l/3aP07bk_6^l^kb`02aP08^l^kbk_;
UL/2U@15^l^EUK_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[^E^iFkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;a/^k00?602Vka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l^kbk_;
^`02aP1BblK6a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`400016^`BE1;/00iG6aP02^`06ULJk^iG60[/00iFk
^`0C^`03ULK600;60k/00iFk^`02^`06UK^k^iG60[/00iFk^`0C^`BE1;/00iFk^`02^`04UK^k^`:E
0[/00iFk^`0@^`03a[_600Fk00?6^k/01K/2U@05^iFkUK/00iDM^`>E00FkUK^kU@0F^`03a[^k00>k
0/HO^`?60[/5aP04^lK6aTjk0@00001Abk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kUK_;00C600Bkbk_;0iD06L^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD00/H03K_;UL^kbk^E^l^kblH00iD0:;_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbiG;^l^kUK_;^l^Ebk_;^l/3U@0Cbk_;^l^kbk_;^l^kbk_;^l^kb`02aP0B^l^kbk_;
^l^kbk_;^l^EbiG;0YD0:K_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kUK^E^iFk00:E
03o;^l^kbk_;^l^kbk_;^l^kbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;a//00/H0EK_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004jk00>E^k/00[/00iG6^`05^`03
UK^k01Vk0lH4^`03ULK600:k00C6^k^E7K/00iFk^`02^`:E1[/00iFk^`0B^`03a[^k00jk00FE^k^k
U@0O^`:E0[/2U@06^iFEUK^E4K/3aRRk00C6^lK6EK/1000005G;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^k
bk_;00:E02>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;U@02aP05bk_;^iD00lH09l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kb`02U@0/^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL/3U@0hbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;UL^kUK_;^iFkUK_;^l^kbk_;^l^kbk/2aP05bk_;^l/00/H09[_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;1<H0EK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004jk00>E^k/0
1[/00iFk^`0O^`03UK^k00;61;/00iG6^`0O^`03UK^k00Jk00>E^k/09k/3U@03^iFk026k00>E^k/0
1K/2U@jk0/H4^`03a[^k07fk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;UL^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^ka[_;^iG6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk^E^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
biG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E007;0YD05/^kUIG;^iFkbk_;^l^k
bk_;^l^kbk/3aP21^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040001>^`03UK^k00:k0YD2^`03UK^k01nk00>E^k/00[/01YG6
a[^EaR2k00>E^k/00[/2U@:k00>E^k/0C[/3U@05^iFkUK/00iDB^`;6Ok/1000005G;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk^E^l^kbiG;00BE02Rkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kUK^E
0lH09l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^Eb`04U@1E^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kUK^E^`03U@2E^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004jk0YD3^`03
UK^k00:k00>E^k/07[/2U@>k00>E^k/00[/00lJk^`0N^`:E0k/00iFk^`02^`03UK^k056k00>E^k/0
0[/00iFk^`2B^`400000D<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k19D09l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`04U@0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00BE05_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;00>E09C;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0@0005>k00>E^k/0:;/00iFk^`0X^`03UK^k05Nk0iD00k^E^`2C^`400000ol^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nk
WK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;0040003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`400000ol^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nk
WK/100000?;;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kblKo^`:E0:S;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/10000kk/01LJkUIFk00:EY[/1000004[;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6ok_;^`:E02S;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^k0YD09L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iD00/H0D[_;UIFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD2aP2[^iFkbk^E^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00400014^`04ULJEU@:k00BE^iFE8K/01iG6UIFkUK/0
0iDQ^`03ULJE00;600>E^iD00YDU^`;600Bka_nE6k/2U@Bk00>Ea/H00k/00iFk^`2S^`400000B<^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kULK;^`:E02W;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkb`02U@1D
^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk^Ea/^kbk^E^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;2<H06k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^`02U@05
bk_;^iD00/H0YiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040
0014^`03ULJk00:k00>E^k/00[/00iFk^`0N^`03ULK600:k00>E^k/00[/00iFk^`0N^`03ULK600:k
00>Ea/H00[/00iFk^`0H^`;62[/4aP03ULK601Rk0YD2^`>E00FkUK^kaP03^`:E:K/00lJE^`03UBFk
00?6UK/00YE8^`400000?/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^k0YD01/^kbk_;^`:E027;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00YD01k_;^l^kaYD00/H08<^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0YD01l^k
bk_;^iD00/H00k_;^`03aP0J^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/6aP06^l_6a[^E0/H07iG6
UIG6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00YD00l^kb`02U@0c^l^EaYG;UL^Ebk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJk00:E02W;^iFkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_6b`02U@19^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000?[/019FkUID6^`03UK^k00>k
00>E^k/06;/019FkUID3^`05a[^kULH01;/00iFk^`0H^`04UK^EU@Jk00>Ea[/00k/00iG6aP0J^`04
a[_6^`?600>ka/H01<H2^`03ULJk01Zk00>E^k/01K/01<JkUID2^`03UK^k02Fk0/H01K^E^k^E02Bk
0/H01;^E^iE7^`400000@/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kUK_;^`:E02W;^l^kbiG;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;UL^kb`02U@0Y^lJkbk^Ea/^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk/00YD03L^k
bk_;ULJkbk^E^l/00/H08k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l^kbk_;^l_600BE057;UIG6
UK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^lJkbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^iD00/H0:K_;^lJkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^E00;604k;^l_6bk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000?K/00iFk^`04^`:E0k/00iFk^`02^`03UK^k01Nk
00>E^k/01;/00iG6aP02^`03UK^k00:k00>E^k/05k/00iFk^`04^`:E0k/00iG6^`02^`03UK^k00:k
00?6^k/05K/01<Jka/H9^`:E00FkUIG6U@0I^`:E0[/3U@03^lJk00Bk0YDR^`04ULJEaP>k00C6^k^E
8;/019G6ULH3^`04a[^kUDJk0@00000mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02U@07^l^kbk_;^`02U@0;biG;^l^kUK_;^l/00YD04k_;
^l^kbk_;^l^kbk_;^l^kbk/00YD02<^kbk_;^lJE0lH02;_;^l^Ebk_;0YD05;_;^l^kbk_;^l^kbk_;
^l^kbk_;0YD01k_;^l^kbk/00YD08l^Ea[_;^iFkbk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?6
00_;a/Jkbk_;^l^kb`04U@0Sa/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^iFkbiD00/H0:L^E
UIG;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E00;600>ka/H00/H01<^kUK/3U@0M
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiD00/H00l_6aP02aP04^l^Eb`>E04;;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000
?k/2U@Nk0YD4^`:E0k/019FkUIDC^`:E1;/00lJk^`02U@04a[^k^`:E0[/00iFkU@02UA>k0YD7^`:E
0/H2^`:E0[/00iG6U@02UAJk1LH9^`:E00>ka[/06k/01IFk^k^E00:k00C6UK^k0YD00k^E^`0L^`;6
0k/00iG6^`02^`03a[^k00>E0[/00iFk^`0F^`;60k/00iG6^`02^`03a[^k00>E0[/00iFk^`0o^`40
0000@L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;00:E00fkbk_;^l^Ebk_;^l^k00BE01S;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk/2U@0=
blK;^l^kUK_;^l^kb`04U@0H^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;0YD02K_;^l^kbiG;^`02aP03
bk^E00:E01[6bk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kb`?603?;a/^kbk_;^l^kbk_;^lJkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l/00lH08l^kUIG;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kblK;00;602VkbiG6^l^kbk_;^l^EbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^`02aP1@
bk^Ea/^kbk_;^l^Ebk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/10000@k/00iFk^`0=^`05UK^k^iD05[/019G6a/H<^`05UK^k^iD0
5[/00iFk^`08^`03a[^k00:k00FEa[^kU@0E^`G63;/3aQjk00>E^k/00k/01IG6^k^E01fk00C6^k^k
1<H:^`:E5k/01<Jk^k/4aPZk0YE0^`400000L/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kULK;^`?6032kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^Ebk_;^l^kbk_;^l/2aP04^l^kb`?601W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;00?600g;^l^k
bk_;^l^kbk_;00C601fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^`02U@0Sbk_6^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00lH01l^kbiG6^l/00iD07/^kbiG;^l^Ebk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`?600Nkbk^Ea/^k00>E04Nkbk^E^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000@k/00iFk^`03^`:E3;/2UAFk
00>Ea[/00k/00iG6^`0;^`:E5K/00iFk^`03^`:E1[/3aP>k00>Ea[/06[/00lJk^`0:^`C66[/2U@03
^iFk00:E00?6^k/06[/3aPBk0/H3^`>E0[/00iFk^`02U@>k00>E^k/03k/3aPBk0/H3^`>E0[/00iFk
^`02U@>k00>E^k/0?;/1000004_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;UL/00YD01[_;^l^kb`:E00Bkbk_;0YD06k_;
^l^kbk_;^l^kbk_;^l^kbk^Ea/^kbk^E^`02U@06bk_;^l^k0YD01<^kbk/2U@0Kbk_;^l^kbk_;^l^k
bk_;^l^kbiG;^l^kbiG;00:E00Nkbk_;^l^E00;600?;^lH00YD09[_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_6^l^kbk_;^l^kbk_;1<H07;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2U@0S^l^ka[_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk/00lH03[_;a/^kbk_;UL^kUK_;1YD05;_;^l^kbk_;
^l^kbk_;^l^ka[_;0lH03/^ka[_;^l^kUK_;UL^k1YD0?/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004>k0iD3^`05UK^k^iD01K/019Fk
UID4^`03UK^k012k00BEa/K60[/01IFk^k^E00Fk00BE^iFE1;/00iFk^`0@^`>E0k/01IFk^k^E00Fk
00>E^iD00lH2^`03UK^k01Jk00?6^k/03;/3aQbk00FE^k^kaP0L^`;61;/2aPVk00>E^k/00[/019Fk
^iD@^`;61K/2aPVk00>E^k/00[/019Fk^iDn^`400000A/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/4U@0=bk_;^iFkbk_;UL^k
b`02U@0I^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;U@03aP0=^l^kbiG;^l^kUK_;^`02U@0Hbk^E^l^k
bk_;^l^kbk_;^l^kbk_;^l^k19D0:/^kbk^E^l^kbiG;^l^Ea[_;UL^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`;6033;^l^kbk_;^l^kbk_;^lJka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2aP0M
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00/H0:;_;^lJkbk_;^l^kbk^E^l^kbk^E^l^kbk_;
^l^kbk_;^l^kbk_;^l/3aP1Dbk_;a/^kbk_;^l^kbiG;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004Vk00>E^k/00[/00iFk
^`02^`03UK^k00>k0iDH^`03ULJk00:k00>E^k/00[/00iFk^`03^`>E6;/00iFk^`02^`03UK^k00:k
00>E^k/00k/3UAZk00?6^k/03K/00lJk^`0O^`;65;/3aPJk00?6^k/02[/00iFk^`04U@jk0lH6^`03
a[^k00Zk00>E^k/019E0^`400000Dl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;00:E02Vkbk_;^l^Ebk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^`02U@0Ybk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kUK_;^l/00YD0:K_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;
^l^k00G600>ka/H00/H08/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3aP0D^l^kbk_;
^l^kbk_;^l^kbk_;^l/3aP0@bk_;a/^kbk_;^l^kbk_;^`BE01C;^iFkbk_;^l^kbk_;^l^kbk_;^`?6
012kbk_6^l^kbk_;^l^kbk_;19D0@k_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004jk00>E^k/01;/2UB:k00>E^k/01;/2UB:k
00>E^k/01;/2UAnk0/H3^`;60[/00lJk^`03aP03^lK602Fk00?6^k/05;/3aQ2k00>E^k/05K/3aQ2k
00>E^k/0@K/100000=7;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFk
bk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkb`05aP36bk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0@0004jk00>E^k/01[/00iFk^`0O^`03UK^k00Jk00>E^k/07k/00iFk^`06^`03UK^k01jk
00G6^k_6^`03aRfk00?6^k/0U[/1000005?;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kb`02U@0Y^l^Ebk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk/00YD0:L^kUK_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^iFkbk_;00:E02FkbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^lJk00O60<Fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000C[/00iFk^`02^`03UK^E00>E8;/00iFk^`02^`03
UK^E00>E8;/00iFk^`02^`03UK^E00>E7k/6aP03^lK602bk00?6^k/0U[/1000004k;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/2U@0Ybk_;UL^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD0:K_;
^iFkbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00:E05g;^l^Ebk_;^iFkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^l_6bk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/00lH0U/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40001@^`BE
9k/4UBNk19EL^`;6U;/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
biG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;0040003o^`Zk00?6^k/0T;/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^`Zk00?6^k/0T;/100000?o;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk
0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000ok]8^`;6Dk/100000?o;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/004[;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;6056kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0006nk00>Ea[/0
0[/2UJVk0/HV^`05a[^k^lH0D;/10000077;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^EaP04U@2Q^iFEbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00/H0Q<^kbk_;^l_6blK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^k
bk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40001_^`03ULJk00:k00FE^k^kU@0Q^`03UOo600:k0YDT^`03
ULJk00:k0YE:^`04a[_6aPFk00C6^k_69;/00lJk^`02^`03a[^k04fk0@000012bk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0/H09/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0YD01<^kbiD2aP0[bk_;^l^kUK_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkU@02aP03UL^E00:E02?;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^EaP02U@03^iFk00>E04Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02aP24bk_6a/^kblK;^lJk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
0@0003jk0/H2^`04a[_6aRBk00BE^iFE0k/019G6a/H3^`03UK^k01nk00JE^k^kULH4^`03UK^k01jk
00BEa[^k0YD4^`03UK^k04Jk00C6^k^k0lH3^`03a[^k026k00>Ea/H00[/00iG6^`1>^`400000@<^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/3aP03^l^k00;602S;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^iFk0/H00l^k
U@02aP0T^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E0/H00k_;U@02aP2Wbk^E^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ea[_;^iFkbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^lJk
bk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^EaYD00/H00iG6U@02U@1<bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`400012^`03a[^k00>k0/H3^`03ok^k00:E5k/3U@>k00>EaYD00lH2^`;61;/2UAFk
0YD6^`03ULK600>k0lHJ^`:E1K/00lJEU@06^`03UK^k04Rk0/H6^`03a[^k026k00FEa[^kU@02aP>k
00>E^k/0BK/1000004[;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_6^l^kbk_;^`;6023;aYFkUK^E^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`>E00C6bk_;0YD2aP08^iG6bk_;UL/2U@0E^l^kbk_;^l^kbk_;^l^kbk_;^iFk00:E02W;^l^k
bk^Ea/^kbk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Eb`02U@1I^l^ka[_;UL^kbk_;UL^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00/H01<^kbk/2aP0Sbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD0
0/H00k_;U@02aP1>bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004:k00?6^k/01k/2aP03^iFE00:k00>E^k/0
6K/00iG6^`05^`?619D3^`03UK^k012k00BE^k^k0YD5^`03ULK600:k00>Ea[/06;/019Fk^k/2U@03
^lJk00:k00>E^k/00[/00iFk^`1<^`03a[^k00>k0/HP^`:E00Jka/Jka[/3aT^k0@00001=bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
a[_;^l^kbk_;^l/00/H08[^E^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL/3aP0Wbk_;^l_6
bk_;UL^kbiG;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk^E00;600FkbiG;^`04aP1Jbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kUK_;^l^kbiG6^l^kUK_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^onk0YD08<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^l^k0/H00l^E
aP02aP0G^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00YD01/^kbk_;^`>E0/H0Ck_;^iG6bk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00@0004:k00?6^k/01;/2U@Bk00G6^k^kU@0J^`03UK^k00>k0/H;^`:E4;/2U@Nk00BEa/K6
1;/019G6^k/2UABk0YD6^`05aYFE^iD01;/2U@:k0YDY^`05aYFE^iD06k/01/Jk^iG6U@;600BkUIG6
5[/00iFkU@02U@Jk00>Ea/H00[/00iG6^`19^`400000Bl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;^l^Eb`02U@0R^l^ka[_;
UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kU@;600Fkbk^E^`03aP04^l^kb`:E00Bkbk_;0YD04;_;
^l^kbk_;^l^kbk_;^l/2U@07^l^kbk_;^`02U@;600C;^l_60iD05k^EUIFkbk_;^l^kbk_;^l^kbk_;
^l^k00:E00O;^l^ka[_;00:E00Jkbk_;^l/3U@0UbiFEUL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`03aP0Xbk_6^iFkUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbiG6^`:E0/H07L_6
bk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;00>E00K;^l^Ea[/4aP1:bk^EUL^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000
@[/00lJk^`04^`04UK^k^`:E00Fka[^kU@02^`:E5k/00lJEaP02aPBk00>Ea[/00[/019FkUID4^`03
UK^k00nk0YD6^`03UK^k00;600Bka[^k0YD3^`03UK^k01:k0YD00k_6^`03^`03UK^k00Jk0YD3^`03
UK^k01Vk0lH2^`03a[^E00;600Fka[^kU@0K^`05a[^kULH01K/2aQFk0iD6^`BE00K6^k^kULH2^`04
UK^EUDBk0@000019bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^ka[_;^l^kb`02U@08^l^kbiG6^l/2U@0O^iFkUK_;^l^kbk_;^l^kbk_;
^l^kbk_;^l_6bk_;U@02aP0;bk^Ea/^kbiG;^l/00iD05/^Ebk_;^l^kbk_;^l^kbk_;^l^kbiD3aP07
^l^kbk_;^`02aP19bk_;UL^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^l^kbk_;^l^kbk_;^iFk
bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02aP08^l^ka[_;a//3aP0Rbk_6^lJkUK^E^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;U@;600?;^lH00YD07K_;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00>E
00fkbk_;^l^Ea[_;^l_600>E04Nkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000@K/00lJk^`07^`03UK^k00:k00?6^k/0
0[/2U@:k00>E^k/04k/2aPFk1<H3^`>E1;/2UA>k00BE^k^k0lH5^`03a[^k00Fk00>E^k/05;/00iG6
^`0A^`03UK^k01Bk00?6^lH00[/3aP08^lJk^iG6UK/2aP03^iFE00:E5k/00iFkU@03aP:k00FE^k^k
U@0K^`03UK^k00Bk00?6^k/00[/01<Jk^iD3^`03UK^k046k0@000011bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00/H0;[_;^l^kbk_;
^iFkbk_6^l^kbk^E^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/3aP0<bk_;^iG6bk_;^l^k0YD07/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;U@;600_;^l_6bk_;^l^kb`02U@0K^l^kbk_;^l^kbk_;
^l^kbk_;^l^kULK;^l^k00:E00c;^l^kbk_;^l^kbk/2U@0>bk_;^l^kbk_;^l^kbk/2aP08bk_;^l_6
bk/2aP05bk_;a//01<H0;k^E^lJkbk^E^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbiG6^l^Ebk_;
UL^k00>E06fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^lJkbk_;a/^kbk_;^l^Ebk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040
0013^`?61[/01IFk^k_600Rk0YDI^`C600>E^k/00[/2U@:k00>E^k/05K/00iFk^`03^`03UK^E00;6
00>ka[/00[/2U@Bk0YDC^`03ULJk00>k00BE^iFE1[/2U@Bk0YD>^`;60k/2aP>k0/H00k_6^`03^`03
a[^E00Nk0YDE^`:E1;/3U@>k19D2^`03UK^k01>k00>E^k/00k/00lJk^`03^`03a[^k00Fk0YE1^`40
0000A/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/2aP09bk_;^iFkbk_600:E00>kbk/00YD05l^kbiG;^l^kbk_;^l^kbk_;^l^k
bk_;00;600Nkbk_;^l^k00;600G;^l^Eb`03U@0Hbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E0lH01k_;
UL^kbiD00/H01L^kbiG;00:E02Vkbk_;UL^kbk_;^l^kbk_;^l^kbk_;^iG6UK_;^iFkbk^E^l^kbk^E
^`02U@0Dbk_;^iFkbk_;^l^kbk_;^l^kbk/3aP07^l_6bk_;^`02aP08bk_;^l^kUK/2U@0Mbk^EUL^k
UK_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD0:k_;^l^Ebk_;^l^kUK_;UL^kbk_;^l^kbk_;^l^kbk_;
^l^kbiG;^l^kbiD00/H01/^kblK;^`:E00G;^l^kb`02U@0o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00400016^`03a[_600>k0iD01K^E
a[^E00:k00>E^iD00k/00iFk^`0@^`03a[_600;61;/01YG6UIFkU@>k00>E^k/06;/019G6a/H4^`03
ULJk00:k00BE^k^k0YD2^`03UK^k01>k19D4^`03UK^k00:k00BE^k^k0YD2^`03UK^k012k0lH5^`03
a[^k00Fk0YD01K^E^iFk00>E6;/00iFk^`0;^`03UK^k01>k0YD4^`03UK^E00C60[/00iFkU@02U@Bk
00>E^k/0?;/1000004W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;00;600Bkbk_;0YD2aP06UL^kUK_;19D05k_;^l^kbk_;
^l^kbk_;^l^kblK;^l^k00C600C;a/^k0YD08/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
biD2aP0=bk^Ea/^kbiG;^l^kb`03U@0Xbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^Ebk_;^iFk
bk_;^`>E02Nkbk_;^l^kbk_;^l^kbk_;^l^kblK;^l^kbk_;^l^kbk_;^iFkUK/00YD0:L^kUK_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_;^l^kbk_;00>E01G;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
19D03[_;^l^kULK;^iFkbk_;0YD0@K_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00400015^`03a[^k00>k0/H4^`03a[_600:k0iD3^`03
UK^k012k0/H7^`;6:;/4aP>k0YD6^`03UK^k01^k00>E^k/00[/2U@Jk00>E^k/08k/01IFk^k^E01Zk
00BE^k^k0iD4^`>E0k/00iFk^`0E^`03UK^k00>k00FE^k^kU@06^`>E?[/1000004g;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`03aP0QblK;ULJkbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?603O;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^Ea/^kbk_;00:E02Vkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^`02U@0/bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kUK/3U@0J^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2U@05^l^Ebk/0
0YD01L^kUK_;00:E02>kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^`02U@16bk_;^l^k
biG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`40001@^`;600>kUK/01;/00iFk^`0H^`C6;;/00iFk^`06^`03UK^k01nk00>E^k/01[/00iFk
^`0W^`>E00>kUK/06k/3U@>k00BE^k^E1;/3UAbk00>E^k/00k/3UD>k0@00001Fbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^Ebk/4U@0Dbk_;^l^kbk_;^l^kbk_;^l^kbk/3aP07^l^kbk_;^`02aP2bbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;UL^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbiG;^`>E06fkbk_;
UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040001C^`:E00FkUK^k
U@0G^`?61K/00lJk^`0X^`03UK^k00:k0YD2^`03UK^k01nk00>E^k/00[/2U@:k00>E^k/0C[/00iFk
^`03^`:E7k/00iFk^`02^`:E0[/00iFk^`10^`400000EL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0YD07K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;603G;^l_6bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^Eb`04U@0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^Ebk_;^iFk00BE07g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^iFkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^Eb`03U@12bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0005Jk00>E^k/07K/4aRZk0YD3^`03
UK^k00:k00>E^k/07[/2U@>k00>E^k/00[/00iFk^`1=^`03UK^k00>E00>kUK/07[/2U@>k00FE^k^k
U@12^`400000Y/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/4U@0W
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00BE05Bkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l/2U@04^iFkb`:E026kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/019D0A/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/10000ZK/00iFk^`0X^`03UK^k05Bk0iDW^`03UK^k04Bk0@00003obk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`400000ol^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nk
WK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;0040003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/100000>_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;60:nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040003[^`04a[_6aZfk0@00003_bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l/00/H0Zk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000V[/00iG6
^`02^`>EBK/00lJk^`03^`03a[^k0:Rk0@00002Lbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iG619D0o<^kUIG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l^kbk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40002E^`:E0k/00iG6^`02^`05UK^k^iD0A[/00lJk^`06^`;6
Yk/1000004k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2aP17bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL/00iD00l_6U@02U@1F^l^kbiG;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^ka[_;^l^kbk_;^l/2aP2U^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^k0040001:^`;60[/00lJkaP02aT:k0YD3^`06ULK6a[^E0k/00iFk^`14^`03a[^k00Zk
00?6^k/0X[/1000004c;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJk0lH0B;_;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`>E00C;^l^k0/H00l^k
b`03U@0WbiFEUL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6ok_;00:E0<fkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_6^l^kbk_;^l^kbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^k0040001:^`04a[^k^`;60k/00lJk^`0R^`03a_nk00>E7;/00iFk^`02^`03
a[^k00Bk0YD2^`:E7K/01/Jka/JE^`:E6K/2aP^k00?6^k/00YDX^`03aYFk00>EL[/1000004G;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iD00/H02K_;ULJkbk_6^`04aP0Vbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
a[/2U@13bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^iG6bk_;^l^kbk_;^l^Ebk_;^l^k
bk_;^l^kbk_;^l^kb`02aP0[^l^kbk_;^l_6bk^Ea/^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^`02aP0>bk_;^l^kbk^Ea/^kUK/2U@0Xbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_6^`:E07C;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`400014^`03ULJE00C60iD00lJk^`02^`03a[^k02:k0/H01K^E^k^E01^k0iD00k^EaP03U@Bk
0YD2^`>E4K/00lJkaP02aPFk0/H2^`05ULJk^iD07;/00lJk^`05^`03ULJE00:E0k/00iFk^`0S^`;6
00FkUK^kU@1a^`400000B<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^`:E0/H0:L^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk^E00;602Jkbk_6^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`:E
00[6bk_;UL^kbiG;0YD00k_;^`02U@0Dbk_;^l^kbk_;^l^kbk_;a/^kbk/2aP05bk_;^l/00/H08[_6
^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2aP0`^l^kbk^Ea/^kUK_;^iFkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E0/H0NK_;^lJkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004Bk0lH2^`03ULJk00?69K/019G6ULH3^`04
a[^kUB2k00G6^k^kU@03^`>E00JkUIFE^iD?^`;60k/01<Jka/H4^`03ULK600:k00>E^k/07K/2aP>k
00>Ea[/01K/00iFk^`0O^`04ULJEaP>k00C6^k^E4k/3aU^k0@00000nbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2U@07bk_;^l^kU@04aP0Z
^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E0/H00k_6aP02aP04bk^E^`>E
01bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0/H02K_;UL^kbk_;^`02U@0Ebk^EUL^kbk_;^l^k
bk_;^l^kbk_;00;6032ka[_;ULJkbk_;ULJkbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^iD2aP03^l_600:E02O;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD00/H00k_6
aP02aP04bk^E^`>E01Jkbk_;^l^kbk_;^l^kbk_;^l_6bk_;0/H0EK_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00@0003jk00BE^iFE1k/00iG6^`02^`03UK^k022k0/H3^`03ULJk00:k00?6^k/00iD2^`03
UK^k01^k0lH3^`>E00>kUK/05[/2aP>k00>Ea/H00[/01IG6^k^E00>k0YDK^`03UK^E00?60[/01IFk
^k^E01jk0/H3^`03ULJk00:k00?6^k/00iD2^`03UK^k00nk00O6^k^ka[_600:k0lH2^`;6Bk/10000
05;;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iFkbk^E^l^kbk_;UL^kbk^E^l^k0YD07l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a//0
0/H0=K_;^lJkbk_;^l^kbiG;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^EaYG;UL^k00:E
01o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^kblJE00C600RkbiFE^l^Eb`:E02Rkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kUK_;^iG6bk^E^l^kUK_;0YD07;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
a//2aP0S^l^Ea[_;^l^kbk_;UL^Ebk_;^l^kbk_;^l^kbk_;^l_6bk/00/H04<_6bk_6^l_6blK;a/^k
a[/2U@14bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/10000?K/00iFk^`03^`>E0k/00iFk^`02^`:E0[/019FkUIDK^`04a[^k^`C6
0[/2U@Jk0YDO^`04a[^EUAfk0iD00k_6^`02^`03ULJk00>k0iD3^`03UK^k01Jk0YD4^`>E0k/2U@04
^iFkUAVk00C6^k^k1<H2^`:E1[/2UA2k0/H00k_6^`02aP:k0/H01;_6^lH2^`03a[_600:E00>kUK/0
@[/1000003g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;00>E00K;^l^kbk/4U@06bk_;^l^k0iD06[_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
0/H00k_;aP02aP1Ebk_;^lJEbiG;UL^kbiG;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
a[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kU@02aP0e^l^ka[_;^l^kbiG;^l^Ebk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk^E^l^kbk/00YD05l^kUK_;^l^kbk_;^l^kbk_;^l^k
bk_;00;600>kblH00/H08l^kbiG6^l^EbiG;^l^Ebk_;UL^kbk_;^l^kbk_;^l^kbk_;00;600NkblK6
^lJk00;600?;a/H00/H0BK_6^iFkUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@00042k0iD6^`03UK^k00Jk00FE^k^kU@0F^`04
a[_6aP>k0/H4^`:E0[/00iFk^`02U@>k00>E^k/06k/00lJk^`0Q^`03ULJk00C60k/2aPFk00>E^k/0
6K/00iFk^`09^`04UK^kUABk00C6^lK60k/2aP>k0iD2^`03UK^k00:E0k/00iFk^`0?^`03a[^k00:k
0/H2^`?60[/01<Jka/H2^`03UK^k046k0@00001abk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;UL^k
bk_;^l^kbk_;^l^kbk_;^l^kblK;^l/00/H03[_;a/^kbk_;UL^kUK_;1YD0Ak_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^l^k00;6
00C;^lJk0/H00l^kb`02U@12^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^kbk^E
^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;0/H03[_;a/^kbk_;UL^kUK_;1YD07[_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^ka[_;^l_6b`:E0/H0Ak_6^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00400013^`03UK^k016k0YDD^`;61;/3aPRk
00>E^k/00[/019Fk^iDM^`03a[^k026k00>Ea[/00[/2U@04^lJkaP:k00>Ea[/00k/00iFk^`0H^`03
UK^k00^k0YDC^`;61;/2aPVk00>E^k/00[/019Fk^iDN^`09UK^ka[^E^iFk00:E@;/1000004S;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;UL^kbk/3U@07^l^kbk_;^`02U@05bk_;^l/00YD03K_;^l^kbk_;^l^kbk/00/H01L^kbk_;00;6
03>kbk_;a/^kbk_;^l^kUK_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00lH08[_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD2aP04^l^Eb`:E0/H01;_;ULH2U@0Q^l^kUK_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^k00>E00Bkbk_;0YD00k_;^`02U@0<bk_;^l^kbk_;^l^k
0/H01L^kbk_;00;603Bkbk_6^l^kbk_;^l^kUK_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;0YD01K_;UIFk00>E046kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000@k/2U@>k00>E^k/00iD4^`03UK^E00:E1;/00iFk
^`0<^`;61K/00lJk^`0:^`03UK^k00BE8[/2aR2k00?6ULH00/H3^`06ULK6^iG60[/2U@03^iFk01Rk
0YD2^`03UK^k00:E0[/019FkUID3^`03UK^k00^k0/H5^`03a[^k00Zk00>E^k/019DR^`04UK^kU@>k
00>E^iD0?k/1000004G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/019D03[_;^l^kUK_;^iFkbk_;0YD04k_;UL^kbk_;^l^kbk_;
^l^kbk/00/H04<^kblK;^l^kbk_;^l^kbk/4U@1Bbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;ULJkbiG;^`?600Bkbk_;
0iD06/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0iD02[_;^iFkbiG;^l/2U@0A^iFkbk_;^l^kbk_;
^l^kbk/00/H04<^kblK;^l^kbk_;^l^kbk/4U@1^bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk^E^l^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/10000B;/00iFk^`03^`04UK^k^`:E1K/3UA:k0lH@^`03UK^k02Bk
00?6^k/07[/00lJk^`02^`04a[^kU@>k00>Ea[/01K/00iFk^`0J^`05UK^k^iD00[/2U@Bk0YDA^`?6
4;/00iFk^`0T^`04UK^EU@:k0YD00k^E^`0m^`400000E<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^`>E
07:kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2aP0<
^l^ka[_;UL^kbk_;0YD0:[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kb`:E
04nkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k00>E04FkUK^E^iFkUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004jk00>E^k/01[/00iFk^`1>^`03
a[^k022k1<H2^`03UK^k00Fk00>E^k/08[/00iFk^`04^`03UK^k04jk00>E^iD00[/019FkUIDm^`40
0000eL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;UL^kb`02U@24^l^Ebk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;0YD0?k_;
UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^`010000C[/019Fk^k/4U@03^iFk04nk00?6^k/09[/01YFk^k^E^`>E9;/019Fk^k/4UE:k00>E^k/0
0[/00iFk^`0l^`400000C/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`:E00K;^iFkbk/2U@1Abk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;00;602Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`:E02^kbiG;
^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00:E09c;^iFkbiG;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kUK_;UL^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/10000D;/4UENk0/HV^`BE:K/3UEJk00>E^iD00YDn^`400000ol^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`00Fl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l/00YD0@<^Ebk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000
[K/00lJk^`2[^`03UK^k03jk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
09g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`40
0000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0@000>bk0/J^^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^ka[_6^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/00@000>^k00G6^k^kaP2/^`400000jl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00/H0Dk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;6
05[;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000a;/00iGoo`02^`:E8[/2aP03^lJk04jk
00C6^lK6F;/100000<O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK^E00;602JEbiFE^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kb`;600Bkbk_;0/H0CK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^l^k00;605K;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`40002J^`03ULJk00:k0YDS^`03UK^k00:k0/H2^`?66k/2aP>k0/H3^`03
a[_604Rk0/H4^`;6E;/1000007[;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;6023;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^EaP:E
00?;UL/00iD07<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2U@09bk^EUL^kbk_;00?601o;^lK6
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;00;600>ka[/00lH0CK_;^lJkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;6
00C;^l^k0/H0D/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000Kk/00iG6aP02^`03ULK600>k00C6^lK6
7;/019G6^k/2U@Bk00>E^k/06K/019FkUID2^`>E1;/01LJk^k_601Vk00C6^k^k0/H3^`06a_nk^iG6
B[/00lJk^`03^`03a[^k04nk0@00001@bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6ok/3U@0O^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbiG6U@02aP03ULJE00C604Vkbk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kULK;^l^Ebk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^k00:E02[;^l^Ebk_;UL^k
blK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^l^kbk/2aP04bk_6^`;602nEaYFEbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJEb`03U@1bbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_6^l^kbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004fk00C6^iFE0[/00iFk^`0I^`05ULJk^iD0
0/H3^`03ULJk00:k00?6^k/04k/2U@Fk00?6UID01[/00iFk^`0H^`:E1K/2U@03^iFk00:k0YD2^`03
aYFE01Jk0/H4^`03a[_600;60[/00iG6aP02^`03UK^k02Fk00C6^iFE0[/00iFk^`0G^`03a[^k00Fk
0/I>^`400000CL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;6026kUK_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbiD00/H09<^kULK;^l^Ebk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk^E^`:E02W;^l_6bk^E^l^k
bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03U@05bk_;^iD00/H01;_;^l/2U@0Ka/^kUK_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k00C600C;^l^k0/H0;/^kULK;^iFkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/2aP0NbiG;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0/H03<^k
bk_;^l^ka_o;^`:E04S;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000BK/00iG6aP03^`05a[^k^iD05K/2U@Bk0YD00k_6
aP05^`03UK^k00:k0/HD^`04UK^k^`:E00>ka[/00[/00iFk^`02^`03UK^k01fk00>E^k/01;/2aPBk
0/H00k^E^`0I^`03aYFk00:k00C6^lK61;/00iFk^`0Q^`03ULK600>k00G6^k^kU@0K^`;61[/01iG6
^k^E^iD0Ak/1000006_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJEa[_;^lJkbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^E
b`02U@04^l^kb`>E00c6^l^kbiG;^l^kbk/2aP0Vbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kULK;^l^E
bk_;^iFkbk/2U@0Sbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l/00lH00l_6b`02aP1c
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^EbiG;^lJkbiG6^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kULJEa/^kblK;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02aP06
bk_;^iG60iD0BK_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004Vk00BEa/Jk1<H2^`03UK^E00:E4K/01IFk^k^E00Jk
00>Ea[/00[/00iFk^`06^`03a[^k00jk0YD6^`05aYFE^iD01;/2U@:k00BE^iFE6;/2U@:k19D4^`;6
0[/00iG6U@0H^`06UK^kUK_60k/01IG6^k^E02>k00BEa/Jk1<H2^`03UK^E00:E6k/01LJk^k^E00;6
00FkUK^kU@16^`400000A/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2aP0;bk_;ULJkbk_6^l/00iD06<^kUK_;^l^kbk_;^l^k
bk_;^iFkbk_;^`>E00bkbk^Ea/^kbiG;^l/2U@0F^l^ka[_;^l^kbk_;^l^kbk_;^l^kb`:E00Nkbk_;
a/^k00:E00K;^l^kbk/3U@0M^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00iD00k_;^`02U@03
bk_;00>E00?;a//00YD06k_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;U@02aP0:bk^Ea/^kUK_;^`:E
01_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00/H02k_;^iG6bk_;a/^k00>E01jkbiG;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l/2aP1?^iFEULK;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000A[/01<Jka/H3^`03
a[^k00Jk00>E^iD03k/3U@Jk19D01<Jk^k/2U@:k00>E^iD00YD00lJk^`0B^`:E00>ka[/00k/00iFk
^`06^`:E0k/00iFk^`0H^`03UK^k00:k00FE^k^kU@02^`05ULJk^iD05K/2U@Fk00>Ea/H00/H2^`:E
0[/019FkUIDI^`04a[_6aP:k00>Ea[/01k/00iFkU@0K^`04UK_6aP:k00FEa[^kU@16^`400000B/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_6^l^k1<H02/^kUIG;^l^kbk/2U@0Abk_;^l^kbk_;^l^kbk_;^l/00iD01l^kbk_;^iD0
0/H01;_;^l/3U@1Cbk_;^iG6bk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkbk_;^l^kbk_;^l^kbiG;^l^E
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l/00YD00k_;aP03U@0G^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00iD02k_;^l^kULK;^l^k00>E022kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
a/^kb`C600ZkbiFE^l^kbk_;0YD07[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kU@;600Nka[_;
UL^k00:E04;;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/10000@[/2aP:k0lH4^`06aYFkUK^E0k/2U@:k00>E^k/04K/00iFk^`06^`?6
0k/00iFk^`02^`04UK_6aQ>k00>Ea[/04K/00iFk^`0M^`03ULJk00>k0YD01<Jk^iDJ^`03UK^k00Zk
00FE^k^kU@0D^`;60[/3aP>k00NEa[^kUK^E00>k00FE^k^kU@0I^`03UK^k00:k00>Ea/H00[/2U@04
^iFkUD6k0@000014bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^ka[/2aP03bk_;00;600Bkbk_;0YD0C[_;UL^kUK^E^l^Ebk_;^l^kbk_;
^l^kbk_;^l^kUK_;^l^kbk_;^l^ka[_;^l^kbk^E^l^ka[_;^l^kbk_;^l^kbk_;^l^kbiG6^l^kb`:E
00bkbk_;^l^kbk_;^l/2U@0P^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL/2aP04^l^kb`?6
04?;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;^l^k
bk_;^l^kblK;00;600>kbk/00/H00l^kb`03U@05bk^E^l/00YD07;_;^iFkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l/2U@0:^l^kbk_6^l^kb`:E04>kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00400012^`04a[^k^`;60[/00lJk^`03^`04
UK^kU@:k0YD01;^EUIDB^`03UK^k00Vk00?6^k/01K/01IG6a[_601:k00>Ea[/00k/019FkUID6^`:E
1;/2UA^k00>E^k/00[/3aP04^lJk^`;66K/00iFk^`0>^`:E4k/01<Jk^k/2aP:k00?6^k/00k/019Fk
^iD2^`JE6[/00iFk^`08^`04UK^kUD2k0@000012bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0/H01<^kbk/3aP0Y^l^kbk_;^l^Ebk_;
^iFkbiG;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk/00YD02<^kbk_6^l^E0/H01L^kblJE00?602?;^l^k
bk_;^l^kbk_;^l^kbiG6UL^kbiG;^l^Ebk_;^l^Eb`02U@0O^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^`04U@04biG;^`;602;;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^k0YD01/^k
bk_;^`:E01O;^l^kUK_;^l^kbk_;^l^kbk_;^l^kb`02aP04^l^kb`;607^kbk_;^l^kbk^E^l^kbiG;
^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0003fk0/H5^`;6
1;/00lJk^`06^`03UK^k00>k00>E^k/04[/2U@Bk00>E^iD00YD01k_6^k^EaYD01<H2^`03ULJk01>k
19D4^`03UK^k00:k00BE^k^k0YD2^`03UK^k01bk0YD7^`03a[^k01Nk0YD3^`04UK^EU@Bk00BE^iFE
0k/00iFk^`0:^`;61K/2aP>k00?6^k/01k/00iFk^`03^`03UK^k01^k00BE^k^k0YD7^`:E?k/10000
03o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00/H05K_;^l^ka[_;^l^kbk_;^l^kbiG;^`04U@0Fbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`BE
00K;^l^kbiD2aP0cbiG6^l^kULK;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^iFkbk_;UL^k
bk_;00>E04?;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00BE00^kbk^E^l^kUK_;^`02U@0@biG;^l^kbk_;^l^kbk_;^`;601G;^l^k
blK;^l^kbk_;^l^kbk^E^l/019D09k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^iFkUK_;
^`02U@12bk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0@00046k0/H3^`03a[^k00Zk19D2^`03UK^k01Nk00>E^k/00k/00iFk^`03aPFk
0iDM^`03UK^k00:k0YD6^`03UK^k02Fk00?6^k/07;/01IFk^k^E00>k00>E^k/00k/3U@nk0/H3^`03
a[^k00Zk19D2^`03UK^k01^k0YD2^`04UK^kU@:k00>E^iD00k/00iFk^`0k^`400000@l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0lH0IL^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^k
aYG;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;00:E02Bkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2aP06^l^kbk_;0/H09K_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^iFkbk/00YD06<^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^`?603>kbk_;^l^kbk_;
^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00iD02;_;UL^kUK_;19D0?K_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
0@0004Fk00?6^k/0<K/00iFk^`04^`:E8[/00iFk^`06^`03UK^k02>k0lH3^`04a[_6aQnk00>E^k/0
0k/2UARk00?6^k/0<k/019Fk^iD2^`:E1;/00iFk^`0k^`400000e/^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk^E^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/3aP33^lJkblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;
^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040001i^`03UK^k00:k0YD2^`03UK^k01nk
00>E^k/00[/2U@:k00>E^k/0:K/2aP:k00?6^k/07;/019Fk^k/2U@:k00>E^k/0C[/00iFk^`03^`03
UK^k03jk0@000020bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbiG;^l^kUK/3U@0X^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;
^l^Eb`BE05>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk^E^`03U@1C^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk/0
0YD0@/^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`40001i^`:E0k/01IFk^k^E026k0YD3^`03UK^k00:k00>E^k/0;;/00lJk^`0L^`:E
0[/01IFk^k^E052k00FE^k^E^`03UCnk0@00001kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00BE02Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/019D0E<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`BE05?;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`03U@14biG;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000O[/00iFk^`0X^`03UK^k02Zk0/H6^`03a[^k022k
00>E^k/0E;/2UD:k0@00003Hbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0/H0`/^k
bk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0@000=Zk0lH00k_6^`2l^`400000gL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00;60;fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
09g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`40
0000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`4000002L^kbk_;^l^kb`05o`06bk_;^l^k0_l01/^k
bk_;^`;o00O;oooobk_;00?o00C;^l^k0ol00k_;^`02o`06booool^k0ol00k_;o`03o`3o^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^k001J^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0@0000Zk0_l8^`;o1K/2o`07
^ooook_o^`02o`:k00Co^k^k0_l00k_o^`02o`07^ooook_o^`02o`04^onko`:k0_oo^eVk0@00000;
bk_;^l^kbk_;^l/00_l02;_;^l^kbk_;0_l01;_;^l/2o`03^l_o00?o00Zkooo;^l_obk_;0_l01[_;
oonkb`Co00Fkbooo^`02o`3obk_ool^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;001Mbk_ool^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;0040000;^`;o2;/2o`Bk0_l3^`;o0[/2o`Nk0_l2^`;o0k/2o`>k0_l5^`;ook]I^`40
00002l^kbk_;^l^kbk_;00;o00Rkbk_o^l^kb`?o00C;^l^k0_l01/^kooo;^`;o00O;^l^kbk_;00;o
00>kbk/00_l01l^kooo;^l/00_l01;_;^l/2o`3o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k001J^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;0@0000^k0_l3^`03ok^k00:k0ol4^`;o0[/2o`>k0_l2^`;o0[/2o`>k
0_l2^`;o0k/2o`>k0_l2^`03ok^k0?nkE[/1000000c;^l^kbk_;^l^kbk/6o`04bk_;^`?o00Bkok_;
0_l01k_ooonkbk/00_l01/^kok_;^`;o00?;^l/00_l01k_ooonkbk/00_l0Nl^kooo;^onkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`05o`04bk_;^`?o
00>kbol00_l02l_oooo;ol^kbk_;00Go00?;^l/01?l0^k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0000bk0_l3^`04ok^k^`?o
00>kool00k/2o`03^ooo00Bk0ol2^`Go0k/2o`03^ooo00>k0_l3^`CoLk/00onk^`03^`04ok^ko`>k
00Co^k_o0k/00onk^`06^`03ok^k00:k00?o^ol01;/00onk^`2h^`4000003<^kbk_;^l^kbk_;^`;o
023;^l_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o00c;^l^kbk_;^l^kbk/2o`3obk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l^k
bk_o^l_obk_;^l^kok_;^onkbk_;^l^kbk_o^l^kbk_o^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;001Obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@0000bk0_lQ^`03
ok^k00Zk0_mi^`03ok^k00Bk00Co^k_o1[/01Onk^k_o00Zk00?o^k/00[/00onk^`02^`03ok^k0;Rk
0@00000=bk_;^l^kbk_;^l^kb`02o`0^^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`;o07jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l_obk_;^l/3o`03booo00?o0=K;^onkbk_o^l^kbk_;^l^kbk_o^l^kok_;^l_o
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0@0000fk0_l4^`03ok^k02Nk0_mh^`03ok^k00Nk00Go^k^ko`02^`;o0[/00onk^`09^`05
ok^k^ol01;/00onk^`2h^`4000002l^kbk_;^l^kbk_;00Wo02S;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^k0ol0Pk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l^kbk_;^l^k00?o00Fkbooo^`02o`3@bk_;^l^kbk_;^l^k
boo;^onkbk_;ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`40002g^`03ok^k00Bk00?o^k/05;/01Onk^k_o00:k00?o^k/00[/00onk
^`2h^`400000_L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_o^l^kb`02o`3M^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l_obk_o^l^kboo;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00@000;Vk1?l00k_o^`0F^`?o1;/4ok^k0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk
0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`010000\
\>"],
  ImageRangeCache->{{{0, 412}, {255, 0}} -> {-0.0250052, -0.0257715, 
  0.00254857, 0.00412367}, {{9.8125, 402.188}, {248.75, 6.1875}} -> {-1.35563,
   -0.271688, 0.0235711, 0.0235711}, {{57.5, 96.5625}, {243.438, 204.375}} ->
   {-0.414019, -0.330456, 0.0115687, 0.0264174}, {{100.438, 139.562}, {
  243.438, 204.375}} -> {-0.911112, -0.330456, 0.0115687, 0.0264174}, {{
  143.438, 182.5}, {243.438, 204.375}} -> {-1.4082, -0.330456, 0.0115687, 
  0.0264174}, {{186.438, 225.5}, {243.438, 204.375}} -> {-2.21621, -0.323122, 
  0.0130634, 0.0257831}, {{229.438, 268.5}, {243.438, 204.375}} -> {-2.77793,
   -0.323122, 0.0130634, 0.0257831}, {{272.375, 311.5}, {243.438, 204.375}} ->
   {-2.22482, -0.317482, 0.00929121, 0.0265183}, {{315.375, 354.438}, {
  243.438, 204.375}} -> {-3.19115, -0.332903, 0.0109615, 0.026629}, {{57.5, 
  96.5625}, {200.438, 161.375}} -> {-0.414019, -1.4664, 0.0115687, 0.0264174},
   {{100.438, 139.562}, {200.438, 161.375}} -> {-0.911112, -1.4664, 0.0115687,
   0.0264174}, {{143.438, 182.5}, {200.438, 161.375}} -> {-1.4082, -1.4664, 
  0.0115687, 0.0264174}, {{186.438, 225.5}, {200.438, 161.375}} -> {-1.8698,
   -1.46725, 0.0113958, 0.026433}, {{229.438, 268.5}, {200.438, 161.375}} ->
   {-2.3815, -1.46683, 0.0114824, 0.0264252}, {{272.375, 311.5}, {200.438, 
  161.375}} -> {-2.87489, -1.46683, 0.0114824, 0.0264252}, {{315.375, 
  354.438}, {200.438, 161.375}} -> {-3.36827, -1.46683, 0.0114824, 0.0264252},
   {{57.5, 96.5625}, {157.5, 118.375}} -> {-0.494704, -2.55641, 0.0125924, 
  0.0259548}, {{100.438, 139.562}, {157.5, 118.375}} -> {-0.605672, -2.58382, 
  0.00911698, 0.0264141}, {{143.438, 182.5}, {157.5, 118.375}} -> {-1.4082,
   -2.60153, 0.0115687, 0.0264174}, {{186.438, 225.5}, {157.5, 118.375}} ->
   {-1.90566, -2.60153, 0.0115687, 0.0264174}, {{229.438, 268.5}, {157.5, 
  118.375}} -> {-2.77793, -2.53966, 0.0130634, 0.0257831}, {{272.375, 311.5},
   {157.5, 118.375}} -> {-2.87587, -2.59715, 0.0114856, 0.026381}, {{315.375, 
  354.438}, {157.5, 118.375}} -> {-3.11348, -2.63844, 0.0107358, 0.0267959},
   {{57.5, 96.5625}, {114.5, 75.4375}} -> {-0.275471, -3.76509, 0.00988084, 
  0.0266765}, {{100.438, 139.562}, {114.5, 75.4375}} -> {-0.900633, -3.73775, 
  0.0114824, 0.0264252}, {{143.438, 182.5}, {114.5, 75.4375}} -> {-0.666893,
   -3.63114, 0.00712345, 0.0259305}, {{186.438, 225.5}, {114.5, 75.4375}} ->
   {-2.03847, -3.69436, 0.012208, 0.0261164}, {{229.438, 268.5}, {114.5, 
  75.4375}} -> {-2.70713, -3.66331, 0.0127811, 0.0258954}, {{272.375, 311.5},
   {114.5, 75.4375}} -> {-2.87489, -3.73775, 0.0114824, 0.0264252}, {{315.375,
   354.438}, {114.5, 75.4375}} -> {-4.5245, -3.58239, 0.0149162, 0.0253195},
   {{57.5, 96.5625}, {71.5, 32.4375}} -> {-0.407249, -4.87403, 0.0114824, 
  0.0264252}, {{100.438, 139.562}, {71.5, 32.4375}} -> {-0.806305, -4.94206, 
  0.0107358, 0.0267959}, {{143.438, 182.5}, {71.5, 32.4375}} -> {-1.4082,
   -4.8726, 0.0115687, 0.0264174}, {{186.438, 225.5}, {71.5, 32.4375}} ->
   {-1.59321, -4.92811, 0.0100887, 0.026748}, {{229.438, 268.5}, {71.5, 
  32.4375}} -> {-2.56341, -4.81737, 0.012208, 0.0261164}, {{272.375, 311.5}, {
  71.5, 32.4375}} -> {-2.87489, -4.87403, 0.0114824, 0.0264252}, {{315.375, 
  354.438}, {71.5, 32.4375}} -> {-3.97904, -4.74576, 0.0132965, 0.0257262}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Generation 40"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .95229 
MathPictureStart
%% Graphics3D
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-3.75585e-05 1.06867 0.0267167 1.06867 [
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 40)] .5 .95229 0 -1.5 Msboxa
P
[(0)] .08595 .18034 -0.06484 1 Msboxa
[(10)] .23556 .13958 -0.04346 1 Msboxa
[(20)] .40028 .0947 -0.01962 1 Msboxa
[(30)] .58253 .04506 .00711 1 Msboxa
[(Indiv.)] .35928 .03957 -0.02584 1 Msboxa
[(Gen.)] .91594 .16872 -1 .22094 Msboxa
[(0)] .04482 .42044 1 -0.20167 Msboxa
[(100)] .02806 .66858 1 -0.12168 Msboxa
[(Fit.)] -0.0283 .53856 1 -0.16726 Msboxa
[ 0 0 0 0 ]
[ 1 .95229 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 40)] .5 .95229 0 -1.5 Mshowa
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.08509 .19367 m
.08465 .20033 L
s
P
[(0)] .08595 .18034 -0.06484 1 Mshowa
p
.002 w
.23498 .15292 m
.23469 .15959 L
s
P
[(10)] .23556 .13958 -0.04346 1 Mshowa
p
.002 w
.40002 .10806 m
.39989 .11474 L
s
P
[(20)] .40028 .0947 -0.01962 1 Mshowa
p
.002 w
.58262 .05842 m
.58267 .0651 L
s
P
[(30)] .58253 .04506 .00711 1 Mshowa
p
.001 w
.11395 .18582 m
.11371 .18982 L
s
P
p
.001 w
.14336 .17783 m
.14314 .18183 L
s
P
p
.001 w
.17332 .16968 m
.17311 .17368 L
s
P
p
.001 w
.20386 .16138 m
.20367 .16538 L
s
P
p
.001 w
.2667 .1443 m
.26655 .1483 L
s
P
p
.001 w
.29905 .1355 m
.29892 .13951 L
s
P
p
.001 w
.33204 .12654 m
.33192 .13054 L
s
P
p
.001 w
.36569 .11739 m
.36559 .1214 L
s
P
p
.001 w
.43505 .09854 m
.43499 .10254 L
s
P
p
.001 w
.4708 .08882 m
.47076 .09283 L
s
P
p
.001 w
.5073 .0789 m
.50728 .0829 L
s
P
p
.001 w
.54456 .06877 m
.54457 .07277 L
s
P
p
.001 w
.6215 .04785 m
.62155 .05186 L
s
P
p
.001 w
.66122 .03706 m
.6613 .04106 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
p
.002 w
.69926 .02672 m
.93852 .30206 L
s
P
[(Gen.)] .91594 .16872 -1 .22094 Mshowa
P
p
p
.002 w
.07262 .19706 m
.02672 .88626 L
s
P
p
.002 w
.05792 .4178 m
.06447 .41648 L
s
P
[(0)] .04482 .42044 1 -0.20167 Mshowa
p
.002 w
.04132 .66697 m
.04795 .66616 L
s
P
[(100)] .02806 .66858 1 -0.12168 Mshowa
p
.001 w
.05469 .46628 m
.05863 .46555 L
s
P
p
.001 w
.05142 .51543 m
.05537 .51476 L
s
P
p
.001 w
.0481 .56525 m
.05206 .56464 L
s
P
p
.001 w
.04473 .61576 m
.0487 .61521 L
s
P
p
.001 w
.0611 .36997 m
.06502 .36912 L
s
P
p
.001 w
.06425 .32277 m
.06815 .32186 L
s
P
p
.001 w
.06735 .2762 m
.07124 .27523 L
s
P
p
.001 w
.07041 .23023 m
.07429 .22922 L
s
P
p
.001 w
.03786 .7189 m
.04185 .71848 L
s
P
p
.001 w
.03436 .77157 m
.03835 .77122 L
s
P
p
.001 w
.0308 .82498 m
.0348 .8247 L
s
P
p
.001 w
.02719 .87916 m
.03119 .87895 L
s
P
[(Fit.)] -0.0283 .53856 1 -0.16726 Mshowa
P
0 0 m
1 0 L
1 .95229 L
0 .95229 L
closepath
clip
newpath
p
p
.4 g
.002 w
.05792 .4178 m
.427 .56884 L
s
P
p
.4 g
.002 w
.04132 .66697 m
.42419 .75998 L
s
P
p
.4 g
.002 w
.08367 .20324 m
.03923 .88751 L
s
P
p
.4 g
.002 w
.18588 .26044 m
.15408 .89894 L
s
P
p
.4 g
.002 w
.27503 .31032 m
.253 .90878 L
s
P
p
.4 g
.002 w
.35346 .35421 m
.3391 .91735 L
s
P
p
.4 g
.002 w
.423 .39313 m
.4147 .92487 L
s
P
p
.4 g
.002 w
.44013 .39481 m
.43312 .92519 L
s
P
p
.4 g
.002 w
.56602 .37138 m
.56847 .92068 L
s
P
p
.4 g
.002 w
.70138 .34619 m
.71482 .91579 L
s
P
p
.4 g
.002 w
.84733 .31903 m
.87358 .91049 L
s
P
p
.4 g
.002 w
.427 .56884 m
.94975 .49749 L
s
P
p
.4 g
.002 w
.42419 .75998 m
.96232 .71624 L
s
P
P
p
.2993 .31811 m .45808 .39844 L .44573 .40071 L .449 0 1 r
F
P
p
.31266 .31521 m .47051 .39615 L .45808 .39844 L .159 0 1 r
F
P
p
.2993 .31811 m .31266 .31521 L .45808 .39844 L .449 0 1 r
F
P
p
.32612 .31229 m .48303 .39384 L .47051 .39615 L .04 0 1 r
F
P
p
.31266 .31521 m .32612 .31229 L .47051 .39615 L .159 0 1 r
F
P
p
.3397 .30934 m .49564 .39152 L .48303 .39384 L 0 .744 1 r
F
P
p
.32612 .31229 m .3397 .30934 L .48303 .39384 L .04 0 1 r
F
P
p
.35338 .30637 m .50835 .38918 L .49564 .39152 L 0 1 .489 r
F
P
p
.3397 .30934 m .35338 .30637 L .49564 .39152 L 0 .744 1 r
F
P
p
.36718 .30338 m .52114 .38683 L .50835 .38918 L 0 1 .472 r
F
P
p
.35338 .30637 m .36718 .30338 L .50835 .38918 L 0 1 .489 r
F
P
p
.38108 .30036 m .53403 .38446 L .52114 .38683 L 0 1 .335 r
F
P
p
.36718 .30338 m .38108 .30036 L .52114 .38683 L 0 1 .472 r
F
P
p
.39511 .29732 m .54701 .38207 L .53403 .38446 L 0 1 .182 r
F
P
p
.38108 .30036 m .39511 .29732 L .53403 .38446 L 0 1 .335 r
F
P
p
.40924 .29425 m .56008 .37966 L .54701 .38207 L 0 1 .114 r
F
P
p
.39511 .29732 m .40924 .29425 L .54701 .38207 L 0 1 .182 r
F
P
p
.4235 .29116 m .57325 .37723 L .56008 .37966 L 0 1 .063 r
F
P
p
.40924 .29425 m .4235 .29116 L .56008 .37966 L 0 1 .114 r
F
P
p
.43787 .28804 m .58652 .37479 L .57325 .37723 L .193 1 0 r
F
P
p
.4235 .29116 m .43787 .28804 L .57325 .37723 L 0 1 .063 r
F
P
p
.45237 .28489 m .59989 .37233 L .58652 .37479 L .466 1 0 r
F
P
p
.43787 .28804 m .45237 .28489 L .58652 .37479 L .193 1 0 r
F
P
p
.46698 .28172 m .61335 .36985 L .59989 .37233 L .517 1 0 r
F
P
p
.45237 .28489 m .46698 .28172 L .59989 .37233 L .466 1 0 r
F
P
p
.48172 .27852 m .62692 .36735 L .61335 .36985 L .602 1 0 r
F
P
p
.46698 .28172 m .48172 .27852 L .61335 .36985 L .517 1 0 r
F
P
p
.49658 .2753 m .64059 .36484 L .62692 .36735 L .67 1 0 r
F
P
p
.48172 .27852 m .49658 .2753 L .62692 .36735 L .602 1 0 r
F
P
p
.51157 .27205 m .65436 .3623 L .64059 .36484 L .756 1 0 r
F
P
p
.49658 .2753 m .51157 .27205 L .64059 .36484 L .67 1 0 r
F
P
p
.52669 .26877 m .66823 .35975 L .65436 .3623 L .858 1 0 r
F
P
p
.51157 .27205 m .52669 .26877 L .65436 .3623 L .756 1 0 r
F
P
p
.002 w
.50713 .72275 m .49384 .72395 L .34527 .62182 L p
0 1 .489 r
F P
0 0 0 r
s
P
p
.002 w
.49384 .72395 m .47933 .90887 L .33102 .62359 L p
0 .744 1 r
F P
0 0 0 r
s
P
p
.002 w
.33102 .62359 m .34527 .62182 L .49384 .72395 L p
0 .744 1 r
F P
0 0 0 r
s
P
p
.54194 .26546 m .68221 .35718 L .66823 .35975 L .875 1 0 r
F
P
p
.52669 .26877 m .54194 .26546 L .66823 .35975 L .858 1 0 r
F
P
p
.002 w
.52053 .71752 m .50713 .72275 L .35966 .62004 L p
0 1 .472 r
F P
0 0 0 r
s
P
p
.002 w
.34527 .62182 m .35966 .62004 L .50713 .72275 L p
0 1 .489 r
F P
0 0 0 r
s
P
p
.55731 .26212 m .69629 .35458 L .68221 .35718 L .909 1 0 r
F
P
p
.54194 .26546 m .55731 .26212 L .68221 .35718 L .875 1 0 r
F
P
p
.002 w
.53401 .68813 m .52053 .71752 L .37416 .61824 L p
0 1 .335 r
F P
0 0 0 r
s
P
p
.002 w
.35966 .62004 m .37416 .61824 L .52053 .71752 L p
0 1 .472 r
F P
0 0 0 r
s
P
p
.002 w
.54754 .67876 m .53401 .68813 L .38879 .61642 L p
0 1 .182 r
F P
0 0 0 r
s
P
p
.002 w
.37416 .61824 m .38879 .61642 L .53401 .68813 L p
0 1 .335 r
F P
0 0 0 r
s
P
p
.002 w
.45261 .90987 m .43941 .91037 L .28629 .70857 L p
.449 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.56113 .66933 m .54754 .67876 L .40354 .61459 L p
0 1 .114 r
F P
0 0 0 r
s
P
p
.002 w
.38879 .61642 m .40354 .61459 L .54754 .67876 L p
0 1 .182 r
F P
0 0 0 r
s
P
p
.57282 .25875 m .71048 .35197 L .69629 .35458 L .994 1 0 r
F
P
p
.55731 .26212 m .57282 .25875 L .69629 .35458 L .909 1 0 r
F
P
p
.002 w
.57485 .66791 m .56113 .66933 L .41843 .61274 L p
0 1 .063 r
F P
0 0 0 r
s
P
p
.002 w
.40354 .61459 m .41843 .61274 L .56113 .66933 L p
0 1 .114 r
F P
0 0 0 r
s
P
p
.002 w
.46592 .90937 m .45261 .90987 L .30188 .65802 L p
.159 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.28629 .70857 m .30188 .65802 L .45261 .90987 L p
.449 0 1 r
F P
0 0 0 r
s
P
p
.58847 .25536 m .72478 .34934 L .71048 .35197 L 1 .92 0 r
F
P
p
.57282 .25875 m .58847 .25536 L .71048 .35197 L .994 1 0 r
F
P
p
.002 w
.58852 .64629 m .57485 .66791 L .4335 .60632 L p
.193 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41843 .61274 m .4335 .60632 L .57485 .66791 L p
0 1 .063 r
F P
0 0 0 r
s
P
p
.002 w
.47933 .90887 m .46592 .90937 L .31674 .62977 L p
.04 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.30188 .65802 m .31674 .62977 L .46592 .90937 L p
.159 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.60237 .64074 m .58852 .64629 L .44911 .56346 L p
.466 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4335 .60632 m .44911 .56346 L .58852 .64629 L p
.193 1 0 r
F P
0 0 0 r
s
P
p
.60425 .25194 m .73919 .34669 L .72478 .34934 L 1 .869 0 r
F
P
p
.58847 .25536 m .60425 .25194 L .72478 .34934 L 1 .92 0 r
F
P
p
.002 w
.31674 .62977 m .33102 .62359 L .47933 .90887 L p
.04 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.61631 .63515 m .60237 .64074 L .46434 .55684 L p
.517 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44911 .56346 m .46434 .55684 L .60237 .64074 L p
.466 1 0 r
F P
0 0 0 r
s
P
p
.62017 .24848 m .75371 .34401 L .73919 .34669 L 1 .801 0 r
F
P
p
.60425 .25194 m .62017 .24848 L .73919 .34669 L 1 .869 0 r
F
P
p
.002 w
.63023 .62142 m .61631 .63515 L .47965 .55472 L p
.602 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46434 .55684 m .47965 .55472 L .61631 .63515 L p
.517 1 0 r
F P
0 0 0 r
s
P
p
.63623 .245 m .76835 .34132 L .75371 .34401 L 1 .699 0 r
F
P
p
.62017 .24848 m .63623 .245 L .75371 .34401 L 1 .801 0 r
F
P
p
.002 w
.64441 .6198 m .63023 .62142 L .49511 .54801 L p
.67 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47965 .55472 m .49511 .54801 L .63023 .62142 L p
.602 1 0 r
F P
0 0 0 r
s
P
p
.65244 .24148 m .78309 .3386 L .76835 .34132 L 1 .614 0 r
F
P
p
.63623 .245 m .65244 .24148 L .76835 .34132 L 1 .699 0 r
F
P
p
.002 w
.65862 .61408 m .64441 .6198 L .51068 .54584 L p
.756 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49511 .54801 m .51068 .54584 L .64441 .6198 L p
.67 1 0 r
F P
0 0 0 r
s
P
p
.66878 .23793 m .79796 .33587 L .78309 .3386 L 1 .563 0 r
F
P
p
.65244 .24148 m .66878 .23793 L .78309 .3386 L 1 .614 0 r
F
P
p
.002 w
.673 .61242 m .65862 .61408 L .52641 .52526 L p
.858 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51068 .54584 m .52641 .52526 L .65862 .61408 L p
.756 1 0 r
F P
0 0 0 r
s
P
p
.68527 .23435 m .81293 .33311 L .79796 .33587 L 1 .528 0 r
F
P
p
.66878 .23793 m .68527 .23435 L .79796 .33587 L 1 .563 0 r
F
P
p
.002 w
.6875 .61074 m .673 .61242 L .54221 .51837 L p
.875 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52641 .52526 m .54221 .51837 L .673 .61242 L p
.858 1 0 r
F P
0 0 0 r
s
P
p
.70191 .23074 m .82803 .33033 L .81293 .33311 L 1 .511 0 r
F
P
p
.68527 .23435 m .70191 .23074 L .81293 .33311 L 1 .528 0 r
F
P
p
.002 w
.70192 .60083 m .6875 .61074 L .55815 .51604 L p
.909 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54221 .51837 m .55815 .51604 L .6875 .61074 L p
.875 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71663 .59909 m .70192 .60083 L .57423 .51368 L p
.994 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55815 .51604 m .57423 .51368 L .70192 .60083 L p
.909 1 0 r
F P
0 0 0 r
s
P
p
.7187 .2271 m .84324 .32753 L .82803 .33033 L 1 .477 0 r
F
P
p
.70191 .23074 m .7187 .2271 L .82803 .33033 L 1 .511 0 r
F
P
p
.002 w
.73145 .59735 m .71663 .59909 L .59035 .49737 L p
1 .92 0 r
F P
0 0 0 r
s
P
p
.002 w
.57423 .51368 m .59035 .49737 L .71663 .59909 L p
.994 1 0 r
F P
0 0 0 r
s
P
p
.73564 .22343 m .85858 .32471 L .84324 .32753 L 1 .392 0 r
F
P
p
.7187 .2271 m .73564 .22343 L .84324 .32753 L 1 .477 0 r
F
P
p
.002 w
.74628 .59143 m .73145 .59735 L .60659 .48562 L p
1 .869 0 r
F P
0 0 0 r
s
P
p
.002 w
.59035 .49737 m .60659 .48562 L .73145 .59735 L p
1 .92 0 r
F P
0 0 0 r
s
P
p
.75274 .21972 m .87403 .32186 L .85858 .32471 L 1 .29 0 r
F
P
p
.73564 .22343 m .75274 .21972 L .85858 .32471 L 1 .392 0 r
F
P
p
.002 w
.76133 .58964 m .74628 .59143 L .62306 .48311 L p
1 .801 0 r
F P
0 0 0 r
s
P
p
.002 w
.60659 .48562 m .62306 .48311 L .74628 .59143 L p
1 .869 0 r
F P
0 0 0 r
s
P
p
.76999 .21597 m .88961 .31899 L .87403 .32186 L 1 .188 0 r
F
P
p
.75274 .21972 m .76999 .21597 L .87403 .32186 L 1 .29 0 r
F
P
p
.002 w
.77623 .57948 m .76133 .58964 L .63947 .46655 L p
1 .699 0 r
F P
0 0 0 r
s
P
p
.002 w
.62306 .48311 m .63947 .46655 L .76133 .58964 L p
1 .801 0 r
F P
0 0 0 r
s
P
p
.78739 .2122 m .90532 .3161 L .88961 .31899 L 1 .136 0 r
F
P
p
.76999 .21597 m .78739 .2122 L .88961 .31899 L 1 .188 0 r
F
P
p
.10948 .21103 m .31266 .31521 L .2993 .31811 L 0 1 .131 r
F
P
p
.002 w
.79121 .56926 m .77623 .57948 L .65612 .45925 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.63947 .46655 m .65612 .45925 L .77623 .57948 L p
1 .699 0 r
F P
0 0 0 r
s
P
p
.80496 .20838 m .92115 .31319 L .90532 .3161 L 1 .068 0 r
F
P
p
.78739 .2122 m .80496 .20838 L .90532 .3161 L 1 .136 0 r
F
P
p
.002 w
.80659 .56736 m .79121 .56926 L .673 .45659 L p
1 .563 0 r
F P
0 0 0 r
s
P
p
.002 w
.65612 .45925 m .673 .45659 L .79121 .56926 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.12396 .2072 m .32612 .31229 L .31266 .31521 L .278 1 0 r
F
P
p
.10948 .21103 m .12396 .2072 L .31266 .31521 L 0 1 .131 r
F
P
p
.80496 .20838 m .82269 .20454 L .92115 .31319 L 1 .068 0 r
F
P
p
.002 w
.82209 .56545 m .80659 .56736 L .68993 .44919 L p
1 .528 0 r
F P
0 0 0 r
s
P
p
.002 w
.673 .45659 m .68993 .44919 L .80659 .56736 L p
1 .563 0 r
F P
0 0 0 r
s
P
p
.13856 .20334 m .3397 .30934 L .32612 .31229 L .517 1 0 r
F
P
p
.12396 .2072 m .13856 .20334 L .32612 .31229 L .278 1 0 r
F
P
p
.002 w
.83772 .56352 m .82209 .56545 L .70699 .44173 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.68993 .44919 m .70699 .44173 L .82209 .56545 L p
1 .528 0 r
F P
0 0 0 r
s
P
p
.1533 .19945 m .35338 .30637 L .3397 .30934 L .585 1 0 r
F
P
p
.13856 .20334 m .1533 .19945 L .3397 .30934 L .517 1 0 r
F
P
p
.002 w
.8533 .55734 m .83772 .56352 L .72431 .43895 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.70699 .44173 m .72431 .43895 L .83772 .56352 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.16818 .19552 m .36718 .30338 L .35338 .30637 L .636 1 0 r
F
P
p
.1533 .19945 m .16818 .19552 L .35338 .30637 L .585 1 0 r
F
P
p
.002 w
.86878 .54687 m .8533 .55734 L .74166 .43139 L p
1 .392 0 r
F P
0 0 0 r
s
P
p
.002 w
.72431 .43895 m .74166 .43139 L .8533 .55734 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.18319 .19155 m .38108 .30036 L .36718 .30338 L .688 1 0 r
F
P
p
.16818 .19552 m .18319 .19155 L .36718 .30338 L .636 1 0 r
F
P
p
.002 w
.88415 .53209 m .86878 .54687 L .75915 .42376 L p
1 .29 0 r
F P
0 0 0 r
s
P
p
.002 w
.74166 .43139 m .75915 .42376 L .86878 .54687 L p
1 .392 0 r
F P
0 0 0 r
s
P
p
.002 w
.8996 .51723 m .88415 .53209 L .77693 .42087 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.002 w
.75915 .42376 m .77693 .42087 L .88415 .53209 L p
1 .29 0 r
F P
0 0 0 r
s
P
p
.19835 .18755 m .39511 .29732 L .38108 .30036 L .705 1 0 r
F
P
p
.18319 .19155 m .19835 .18755 L .38108 .30036 L .688 1 0 r
F
P
p
.002 w
.91579 .51508 m .8996 .51723 L .79489 .41794 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.77693 .42087 m .79489 .41794 L .8996 .51723 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.21366 .1835 m .40924 .29425 L .39511 .29732 L .705 1 0 r
F
P
p
.19835 .18755 m .21366 .1835 L .39511 .29732 L .705 1 0 r
F
P
p
.002 w
.93117 .49583 m .91579 .51508 L .81302 .41499 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.79489 .41794 m .81302 .41499 L .91579 .51508 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.81302 .41499 m .83132 .41201 L .93117 .49583 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.2291 .17942 m .4235 .29116 L .40924 .29425 L .739 1 0 r
F
P
p
.21366 .1835 m .2291 .17942 L .40924 .29425 L .705 1 0 r
F
P
p
.2447 .1753 m .43787 .28804 L .4235 .29116 L .79 1 0 r
F
P
p
.2291 .17942 m .2447 .1753 L .4235 .29116 L .739 1 0 r
F
P
p
.26045 .17114 m .45237 .28489 L .43787 .28804 L .96 1 0 r
F
P
p
.2447 .1753 m .26045 .17114 L .43787 .28804 L .79 1 0 r
F
P
p
.27635 .16694 m .46698 .28172 L .45237 .28489 L 1 .835 0 r
F
P
p
.26045 .17114 m .27635 .16694 L .45237 .28489 L .96 1 0 r
F
P
p
.2924 .1627 m .48172 .27852 L .46698 .28172 L 1 .784 0 r
F
P
p
.27635 .16694 m .2924 .1627 L .46698 .28172 L 1 .835 0 r
F
P
p
.002 w
.31674 .62977 m .30188 .65802 L .10622 .50727 L p
.278 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30188 .65802 m .28629 .70857 L .0906 .51973 L p
0 1 .131 r
F P
0 0 0 r
s
P
p
.002 w
.0906 .51973 m .10622 .50727 L .30188 .65802 L p
0 1 .131 r
F P
0 0 0 r
s
P
p
.002 w
.33102 .62359 m .31674 .62977 L .12279 .47983 L p
.517 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.10622 .50727 m .12279 .47983 L .31674 .62977 L p
.278 1 0 r
F P
0 0 0 r
s
P
p
.30861 .15842 m .49658 .2753 L .48172 .27852 L 1 .767 0 r
F
P
p
.2924 .1627 m .30861 .15842 L .48172 .27852 L 1 .784 0 r
F
P
p
.002 w
.34527 .62182 m .33102 .62359 L .13859 .46717 L p
.585 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.12279 .47983 m .13859 .46717 L .33102 .62359 L p
.517 1 0 r
F P
0 0 0 r
s
P
p
.32497 .1541 m .51157 .27205 L .49658 .2753 L 1 .75 0 r
F
P
p
.30861 .15842 m .32497 .1541 L .49658 .2753 L 1 .767 0 r
F
P
p
.002 w
.35966 .62004 m .34527 .62182 L .15424 .4594 L p
.636 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.13859 .46717 m .15424 .4594 L .34527 .62182 L p
.585 1 0 r
F P
0 0 0 r
s
P
p
.3415 .14973 m .52669 .26877 L .51157 .27205 L 1 .665 0 r
F
P
p
.32497 .1541 m .3415 .14973 L .51157 .27205 L 1 .75 0 r
F
P
p
.002 w
.37416 .61824 m .35966 .62004 L .17027 .44658 L p
.688 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.15424 .4594 m .17027 .44658 L .35966 .62004 L p
.636 1 0 r
F P
0 0 0 r
s
P
p
.3582 .14532 m .54194 .26546 L .52669 .26877 L 1 .545 0 r
F
P
p
.3415 .14973 m .3582 .14532 L .52669 .26877 L 1 .665 0 r
F
P
p
.002 w
.38879 .61642 m .37416 .61824 L .18617 .43866 L p
.705 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.17027 .44658 m .18617 .43866 L .37416 .61824 L p
.688 1 0 r
F P
0 0 0 r
s
P
p
.37505 .14086 m .55731 .26212 L .54194 .26546 L 1 .511 0 r
F
P
p
.3582 .14532 m .37505 .14086 L .54194 .26546 L 1 .545 0 r
F
P
p
.002 w
.40354 .61459 m .38879 .61642 L .20197 .43571 L p
.705 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.18617 .43866 m .20197 .43571 L .38879 .61642 L p
.705 1 0 r
F P
0 0 0 r
s
P
p
.39208 .13637 m .57282 .25875 L .55731 .26212 L 1 .511 0 r
F
P
p
.37505 .14086 m .39208 .13637 L .55731 .26212 L 1 .511 0 r
F
P
p
.002 w
.41843 .61274 m .40354 .61459 L .21792 .43272 L p
.739 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20197 .43571 m .21792 .43272 L .40354 .61459 L p
.705 1 0 r
F P
0 0 0 r
s
P
p
.40928 .13182 m .58847 .25536 L .57282 .25875 L 1 .443 0 r
F
P
p
.39208 .13637 m .40928 .13182 L .57282 .25875 L 1 .511 0 r
F
P
p
.002 w
.4335 .60632 m .41843 .61274 L .23446 .41957 L p
.79 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.21792 .43272 m .23446 .41957 L .41843 .61274 L p
.739 1 0 r
F P
0 0 0 r
s
P
p
.42665 .12723 m .60425 .25194 L .58847 .25536 L 1 .341 0 r
F
P
p
.40928 .13182 m .42665 .12723 L .58847 .25536 L 1 .443 0 r
F
P
p
.002 w
.46434 .55684 m .44911 .56346 L .26714 .41336 L p
1 .835 0 r
F P
0 0 0 r
s
P
p
.002 w
.44911 .56346 m .4335 .60632 L .25072 .41648 L p
.96 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25072 .41648 m .26714 .41336 L .44911 .56346 L p
.96 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.23446 .41957 m .25072 .41648 L .4335 .60632 L p
.79 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47965 .55472 m .46434 .55684 L .28408 .39996 L p
1 .784 0 r
F P
0 0 0 r
s
P
p
.002 w
.26714 .41336 m .28408 .39996 L .46434 .55684 L p
1 .835 0 r
F P
0 0 0 r
s
P
p
.4442 .1226 m .62017 .24848 L .60425 .25194 L 1 .29 0 r
F
P
p
.42665 .12723 m .4442 .1226 L .60425 .25194 L 1 .341 0 r
F
P
p
.002 w
.49511 .54801 m .47965 .55472 L .3008 .39673 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.28408 .39996 m .3008 .39673 L .47965 .55472 L p
1 .784 0 r
F P
0 0 0 r
s
P
p
.46193 .11791 m .63623 .245 L .62017 .24848 L 1 .222 0 r
F
P
p
.4442 .1226 m .46193 .11791 L .62017 .24848 L 1 .29 0 r
F
P
p
.002 w
.51068 .54584 m .49511 .54801 L .3177 .39346 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.3008 .39673 m .3177 .39346 L .49511 .54801 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.47984 .11318 m .65244 .24148 L .63623 .245 L 1 .153 0 r
F
P
p
.46193 .11791 m .47984 .11318 L .63623 .245 L 1 .222 0 r
F
P
p
.002 w
.52641 .52526 m .51068 .54584 L .33477 .39016 L p
1 .665 0 r
F P
0 0 0 r
s
P
p
.002 w
.3177 .39346 m .33477 .39016 L .51068 .54584 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.49793 .1084 m .66878 .23793 L .65244 .24148 L 1 .136 0 r
F
P
p
.47984 .11318 m .49793 .1084 L .65244 .24148 L 1 .153 0 r
F
P
p
.002 w
.54221 .51837 m .52641 .52526 L .35215 .38163 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.33477 .39016 m .35215 .38163 L .52641 .52526 L p
1 .665 0 r
F P
0 0 0 r
s
P
p
.51621 .10357 m .68527 .23435 L .66878 .23793 L 1 .119 0 r
F
P
p
.49793 .1084 m .51621 .10357 L .66878 .23793 L 1 .136 0 r
F
P
p
.002 w
.55815 .51604 m .54221 .51837 L .36968 .37301 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.35215 .38163 m .36968 .37301 L .54221 .51837 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.53468 .09869 m .70191 .23074 L .68527 .23435 L 1 .085 0 r
F
P
p
.51621 .10357 m .53468 .09869 L .68527 .23435 L 1 .119 0 r
F
P
p
.002 w
.57423 .51368 m .55815 .51604 L .38726 .36956 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.36968 .37301 m .38726 .36956 L .55815 .51604 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.55335 .09376 m .7187 .2271 L .70191 .23074 L 1 .068 0 r
F
P
p
.53468 .09869 m .55335 .09376 L .70191 .23074 L 1 .085 0 r
F
P
p
.002 w
.59035 .49737 m .57423 .51368 L .40502 .36607 L p
1 .443 0 r
F P
0 0 0 r
s
P
p
.002 w
.38726 .36956 m .40502 .36607 L .57423 .51368 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.60659 .48562 m .59035 .49737 L .42304 .35726 L p
1 .341 0 r
F P
0 0 0 r
s
P
p
.002 w
.40502 .36607 m .42304 .35726 L .59035 .49737 L p
1 .443 0 r
F P
0 0 0 r
s
P
p
.57221 .08878 m .73564 .22343 L .7187 .2271 L 1 .051 0 r
F
P
p
.55335 .09376 m .57221 .08878 L .7187 .2271 L 1 .068 0 r
F
P
p
.002 w
.62306 .48311 m .60659 .48562 L .44116 .35368 L p
1 .29 0 r
F P
0 0 0 r
s
P
p
.002 w
.42304 .35726 m .44116 .35368 L .60659 .48562 L p
1 .341 0 r
F P
0 0 0 r
s
P
p
.59127 .08374 m .75274 .21972 L .73564 .22343 L 1 .017 0 r
F
P
p
.57221 .08878 m .59127 .08374 L .73564 .22343 L 1 .051 0 r
F
P
p
.002 w
.63947 .46655 m .62306 .48311 L .45953 .34472 L p
1 .222 0 r
F P
0 0 0 r
s
P
p
.002 w
.44116 .35368 m .45953 .34472 L .62306 .48311 L p
1 .29 0 r
F P
0 0 0 r
s
P
p
.002 w
.65612 .45925 m .63947 .46655 L .47802 .34104 L p
1 .153 0 r
F P
0 0 0 r
s
P
p
.002 w
.45953 .34472 m .47802 .34104 L .63947 .46655 L p
1 .222 0 r
F P
0 0 0 r
s
P
p
.61053 .07865 m .76999 .21597 L .75274 .21972 L 1 0 0 r
F
P
p
.59127 .08374 m .61053 .07865 L .75274 .21972 L 1 .017 0 r
F
P
p
.002 w
.673 .45659 m .65612 .45925 L .49671 .33731 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.47802 .34104 m .49671 .33731 L .65612 .45925 L p
1 .153 0 r
F P
0 0 0 r
s
P
p
.63 .07351 m .78739 .2122 L .76999 .21597 L 1 0 0 r
F
P
p
.61053 .07865 m .63 .07351 L .76999 .21597 L 1 0 0 r
F
P
p
.002 w
.68993 .44919 m .673 .45659 L .5156 .33354 L p
1 .119 0 r
F P
0 0 0 r
s
P
p
.002 w
.49671 .33731 m .5156 .33354 L .673 .45659 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.64968 .06831 m .80496 .20838 L .78739 .2122 L 1 0 0 r
F
P
p
.63 .07351 m .64968 .06831 L .78739 .2122 L 1 0 0 r
F
P
p
.002 w
.70699 .44173 m .68993 .44919 L .5347 .32974 L p
1 .085 0 r
F P
0 0 0 r
s
P
p
.002 w
.5156 .33354 m .5347 .32974 L .68993 .44919 L p
1 .119 0 r
F P
0 0 0 r
s
P
p
.66957 .06306 m .82269 .20454 L .80496 .20838 L 1 0 0 r
F
P
p
.64968 .06831 m .66957 .06306 L .80496 .20838 L 1 0 0 r
F
P
p
.002 w
.72431 .43895 m .70699 .44173 L .554 .32589 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.5347 .32974 m .554 .32589 L .70699 .44173 L p
1 .085 0 r
F P
0 0 0 r
s
P
p
.66957 .06306 m .68968 .05774 L .82269 .20454 L 1 0 0 r
F
P
p
.002 w
.74166 .43139 m .72431 .43895 L .5735 .322 L p
1 .051 0 r
F P
0 0 0 r
s
P
p
.002 w
.554 .32589 m .5735 .322 L .72431 .43895 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.75915 .42376 m .74166 .43139 L .59323 .31806 L p
1 .017 0 r
F P
0 0 0 r
s
P
p
.002 w
.5735 .322 m .59323 .31806 L .74166 .43139 L p
1 .051 0 r
F P
0 0 0 r
s
P
p
.002 w
.77693 .42087 m .75915 .42376 L .61317 .31409 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59323 .31806 m .61317 .31409 L .75915 .42376 L p
1 .017 0 r
F P
0 0 0 r
s
P
p
.002 w
.79489 .41794 m .77693 .42087 L .63333 .31007 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.61317 .31409 m .63333 .31007 L .77693 .42087 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81302 .41499 m .79489 .41794 L .65371 .306 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63333 .31007 m .65371 .306 L .79489 .41794 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83132 .41201 m .81302 .41499 L .67432 .30189 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65371 .306 m .67432 .30189 L .81302 .41499 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67432 .30189 m .69517 .29774 L .83132 .41201 L p
1 0 0 r
F P
0 0 0 r
s
P
p
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.08509 .19367 m
.08465 .20033 L
s
P
[(0)] .08595 .18034 -0.06484 1 Mshowa
p
.002 w
.23498 .15292 m
.23469 .15959 L
s
P
[(10)] .23556 .13958 -0.04346 1 Mshowa
p
.002 w
.40002 .10806 m
.39989 .11474 L
s
P
[(20)] .40028 .0947 -0.01962 1 Mshowa
p
.002 w
.58262 .05842 m
.58267 .0651 L
s
P
[(30)] .58253 .04506 .00711 1 Mshowa
p
.001 w
.11395 .18582 m
.11371 .18982 L
s
P
p
.001 w
.14336 .17783 m
.14314 .18183 L
s
P
p
.001 w
.17332 .16968 m
.17311 .17368 L
s
P
p
.001 w
.20386 .16138 m
.20367 .16538 L
s
P
p
.001 w
.2667 .1443 m
.26655 .1483 L
s
P
p
.001 w
.29905 .1355 m
.29892 .13951 L
s
P
p
.001 w
.33204 .12654 m
.33192 .13054 L
s
P
p
.001 w
.36569 .11739 m
.36559 .1214 L
s
P
p
.001 w
.43505 .09854 m
.43499 .10254 L
s
P
p
.001 w
.4708 .08882 m
.47076 .09283 L
s
P
p
.001 w
.5073 .0789 m
.50728 .0829 L
s
P
p
.001 w
.54456 .06877 m
.54457 .07277 L
s
P
p
.001 w
.6215 .04785 m
.62155 .05186 L
s
P
p
.001 w
.66122 .03706 m
.6613 .04106 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{333, 317},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005=0001?@P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0CP000?mKCE/10000oe]=F`40003oFdeK
0@000?mKCE/10000oe]=F`40003oFdeK0@000?mKCE/10000oe]=F`40001jF`03oe_o00=K00CoFe]K
0ol015_oFol4F`05oe]KFol0^5/10000NU/00omKo`03F`04oe]Ko`=K0_l00e_oF`02F`03oe_o0;]K
0@0007YK00?oFol00e/01?mKFol4F`03oe_o00=K00?oFol0=E/4o`=K1?mkF`40001jF`03oe_o00=K
00CoFe_o15/00omKo`03F`03oe_o03AK00?oFe/00U/00omKo`04F`03oe]K07QK0@0007YK00?oFol0
0e/01?mKFol4F`03oe_o00=K00?oFol0=5/00omKF`02F`03oe_o00AK00?oFe/06E/3oeaK0@0007YK
00CoFooo0U/01?mKFol3F`;o00EKoe]Ko`03F`03oe]K03IK00?oFol015/00omKF`0EF`Co0U/00omK
F`1JF`40001jF`04oe_oF`;o15/3o`04FomKo`9K00GoFe]Ko`0eF`?o0U/00omKF`02F`03oe]K019K
0ol7F`03oe]K05UK0@0007YK00?oFe/02e/00omKF`0oF`03oe_o00AK00?oFe/03U/4o`]K00?oFe/0
F5/10000NU/00omKF`0;F`03oe_o03YK00?oFe/00U/00omKo`04F`03oe]K00YK1?l00e_oF`0=F`03
oe]K05MK0@000<EK00?oFe/00U/00omKo`04F`03oe]K00MK0ol5F`03oe]K00eK00?oFe/0EU/10000
aU/4o`=K1?l6F`Co6E/00omKF`1EF`40003CF`Go7E/00omKF`1DF`40003@F`?o15/00omKF`0KF`03
oe]K05AK0@000<aK1?lVF`03oe]K05=K0@000<QK1?l[F`03oe]K059K0@000<EK0ol3F`03oe]K01]K
0b<<F`03oe]K055K0@000<5K1?l6F`03oe]K01MK22<<F`03oe]K051K0@0008eK1_l2F`Co95/4ob5K
32<<F`03oe]K04mK0@0008eK00?oFe/015/00omKF`02F`03oe]K01eK1?l3F`03oe]K01aK42<<F`03
oe]K04iK0@0008iK00?oFe/00e/00omKF`02F`03oe]K01YK0olSFa@S2e/00omKF`1>F`40002?F`;o
0e/00omKF`02F`03oe]K01IK1?lQFaXS2e/00omKF`1=F`40002AF`04oe]Ko`AK00?oFe/04U/4o`9K
00?oFe/075/27adS2e/00omKF`1<F`40002BF`03oe_o00AK00?oFe/03e/3ob9K1QlM8`]K00?oFe/0
Be/10000SE/00omKF`02F`03oe_o00AK00?oFe/02e/4ob1K31lM8`]K00?oFe/0BU/10000SE/00omK
F`02F`03oe_o00AK00?oFe/01e/4o`9K00?oFe/06e/02QmO7elOGamO7el77adS2e/00omKF`19F`40
002>F`Co0e/4o`MK0ol6F`03oe]K01QK00HOGamO7el?7adS2e/00omKF`18F`40002LF`Co85/04elO
GamO7elOGamO7elOGamO7el01alL8`]K00?oFe/0B5/10000V5/4o`9K00?oFe/06e/041mO7elOGamO
7elOGamO7el?7a`S2e/00omKF`17F`40002EF`?o1U/00omKF`0HF`06GamO7elO0Ul051mO7elOGamO
7elOGamO7elOGamO1alL8`]K00?oFe/0AU/10000TE/4oamK1Al05ElOGamO7elOGamO7elOGamO7elO
G`0?7a`S2e/00omKF`15F`40002=F`Co0U/00omKF`0JF`YO00LOGamO7elO009O01@OGamO7elOGamO
7elOGamO7elOG`LO72<;F`03oe]K04AK0@0005iK00?oFe/00U/4ob9K1?l6F`03oe]K01MK00MO7elO
GamO00LO01EO7elOGamO7elOGamO7elOGamO7el03alL8`]K00?oFe/0@e/10000GU/01OmKFe_o00AK
00?oFe/075/4oamK00DOGamO7`0>G`077elOGamO7`02G`0D7elOGamO7elOGamO7elOGamO7el77a`S
2e/00omKF`12F`40001NF`05oe]KFol015/00omKF`0HF`Co0e/00omKF`0IF`AO00DOGamO7`02G`06
7elOGamO1al05ElOGamO7elOGamO7elOGamO7elOG`0?7a`S2U/00omKF`12F`40001NF`05oe]KFol0
15/00omKF`0DF`Co85/01QmO7elOG`8O00IO7elOGal>G`077elOGamO7`02G`0D7elOGamO7elOGamO
7elOGamO7el77a`S2U/00omKF`11F`40001NF`05oe]KFol015/00omKF`0AF`?o00=Koe/07U/00aMO
5`09G`057elOGal00Ul01QmO7elOG`LO01EO7elOGamO7elOGamO7elOGamO7el03alL8`YK00?oFe/0
@5/10000GU/01OmKFe_o00AK00?oFe/03E/4o`AK00?oFe/05e/01ALA5a4G00IO00HOGamO7el27`06
GamO7elO45l01AmO7elO009O01@OGamO7elOGamO7elOGamO7elOG`LO72<:F`03oe]K03mK0@0005aK
0ol3F`03oe]K009K00?oFe/02E/4oaiK00TG4ALG4ALA5a400QL015lGGaL9G`067elOGamO0Ql01ElO
GamO00TO01=O7elOGamO7elOGamO7elOGamO00lO72<:F`03oe]K03iK0@0005iK00GoFe]Ko`04F`03
oe]K00IK0ol00e_oF`0LF`PG00HA5a4G4AL6G`077elOGamO7`02G`057elOGal045l01QmO7elOG`8O
01=O7elOGamO7elOGamO7elOGamO00LO6b<;F`03oe]K03eK0@0005iK00?oFe/00U/4o`EK1?l4F`03
oe]K01QK00XG4ALA5a4G4ALA0QL01A4G4ALA008G00IO5elGGaL7G`067elOGamO0Ql01ElOGamO00TO
01=O7elOGamO7elOGamO7elOGamO00lO6b<;F`03oe]K03aK0@0006QK1?lOF`035a4G00hG00LA5a4G
4ALA00MO00DOGamO7`02G`057elOGal045l01QmO7elOG`8O01=O7elOGamO7elOGamO7elOGamO00LO
6b<:F`03oe]K03aK0@0006EK0ol3F`03oe]K01YK1a403ALA5a4G4ALA5a4G4AL00Q4031LA5a4G4ElG
GaMO5`MO00HOGamO7el27`05GamO7el02Al04elOGamO7elOGamO7elOGamO7el03alK8`YK00?oFe/0
>e/10000HE/4o`EK00?oFe/05e/5W`065a4G4ALA3aL01a4G4ALA5a401el01QmO7elOG`8O00IO7elO
Gal>G`067elOGamO0Ql04elOGamO7elOGamO7elOGamO7el01alK8`YK00?oFe/0>U/10000<E/4obQK
1OlMF`^O2A402aLA5a4G4ALA5a4G008A00`G4ALA5a5O5elGGaL9G`057elOGal00Ul01QmO7elOG`LO
01=O7elOGamO7elOGamO7elOGamO00lO6b<:F`03oe]K03UK0@00031K00?oFe/00U/00omKF`0QF`Co
15/00omKF`0GF`09gioOWmnOgioO00NO00PG4ALA5a4G4@lG00HA5a4G4AL6G`067elOGamO0Ql01UlO
GamO7`iO00HOGamO7el27`0CGamO7elOGamO7elOGamO7elOG`077a/S2U/00omKF`0QF`Co00=Koe/0
1?l2F`05oe]KFol00e/1o`5K0@00031K00?oFe/00U/00omKF`0NF`?o25/00omKF`0DFaFO214031LA
5a4G4ALA5a4G4@8G00DA5a4G4@025`04GaMO5`UO00DOGamO7`02G`067elOGamO1al05ElOGamO7elO
GamO7elOGamO7elOG`0=7a/S2U/00omKF`0OF`03oe]K009K0ol4F`03oe_o00=K00?oFe/00e/10000
<5/00omKF`02F`03oe]K01YK1?l00e_oF`0LF`0AgioOWmnOgioOWmnOgioOWml029l01a4G4ALA5a40
3aL01Q4G4ALA5`IO00LOGamO7elO009O00DOGamO7`0>G`067elOGamO0Ql04elOGamO7elOGamO7elO
GamO7el01alK8`YK00?oFe/07E/00omKF`04F`;o1U/01OmKFe_o00EK0@00031K00?oFe/00U/00omK
F`0FF`Co1E/00omKF`0FF`03gioO00:O00GOWmnOg`0FW`LA00`G4ALA5a4G4ALA5a425`054ALA5a40
0QL01UlGGaMO5`MO00HOGamO7el27`05GamO7el01al05ElOGamO7elOGamO7elOGamO7elOG`0=7a/S
2U/00omKF`0LF`03oe]K00AK1ol00e_oF`02F`03oe]K00=K0@00031K00?oFe/00U/00omKF`0CF`Co
7E/3g`JO01GOWmnOgioOWmnOgioOWmnOgioOWml01il01QLA5a4G4@lG00LA5a4G4ALA00MO00DOGamO
7`02G`057elOGal03Ul01amO7elOGal00Ul04QmO7elOGamO7elOGamO7elOG`LO6b<9F`03oe]K01aK
00CoFe]K1Ol4F`03oe_o00=K00?oFe/00e/10000<5/00omKF`02F`03oe]K00mK1?l3F`03oe]K01UK
00cOg]oNgmkOWmnOgil2g`04WmnOgaJO2A402aLA5a4G4ALA5a4G008A00`G4ALA5a5O5elGGaL7G`06
7elOGamO0Ql01ElOGamO00TO01=O7elOGamO7elOGamO7elOGamO00dO6R<:F`03oe]K01]K00?oFe/0
1E/00omKF`02F`04oe_oo`9K00?oFe/00e/10000<5/00omKF`02F`03oe]K00]K1?lPF`_O1il04mnO
gioOWmnOgioOWmnOgioOWml029l01a4G4ALA5a403AL01a4G4ALA5a401el01AmO7elO009O00DOGamO
7`0@G`057elOGal00Ul04QmO7elOGamO7elOGamO7elOG`LO6R<:F`03oe]K01YK00?oFe/015/00omK
o`03o`9K00CoFooo1U/10000<E/4o`]K0ol2F`03oe]K01YK00CNgmkO1]h03MoNgmkOg]nOgioOWml0
0Yl01MnOgioO01FO214031LA5a4G4ALA5a4G4@8G00/A5a4G4ElGGaMO5`09G`047elOG`8O00EO7elO
G`097`0CGamO7elOGamO7elOGamO7elOG`0=7aXS2U/00omKF`0JF`03oe]K009K00?oFe/045/10000
?5/4o`EK00?oFe/05E/02MkOg]oNgmkOgP0?g`JO01GOWmnOgioOWmnOgioOWmnOgioOWml01Yl01a4G
4ALA5a403aL01Q4G4ALA5`IO00HOGamO7el27`06GamO7elO3Ul01AmO7elO009O018OGamO7elOGamO
7elOGamO7el77aXS2U/00omKF`0JF`Co4e/10000>5/5oaaK2]h01MoNgmkO00SN00cOg]oNgmkOWmnO
gil2g`04WmnOgaJO1a4031LA5a4G4ALA5a4G4@8G00DA5a4G4@025`04GaMO5`UO00DOGamO7`02G`06
7elOGamO1al04elOGamO7elOGamO7elOGamO7el03AlJ8`YK00?oFe/0<5/10000=E/3o`AK00?oFe/0
65/04mkOg]oNgmkOg]oNgmkOg]oNgmh03]l7W`0CgioOWmnOgioOWmnOgioOWmnOg`07W`065a4G4ALA
3aL01Q4G4ALA5`QO00@OGamO0Ql01UlOGamO7`iO00DOGamO7`02G`0B7elOGamO7elOGamO7elOGamO
1alJ8`YK00?oFe/0;e/10000<E/4oamK00CNgmkO3mh01MoNgmkO00KN00gOg]oNgmkOWmnOgioO00:O
00GOWmnOg`0EW`PA00/G4ALA5a4G4ALA5`024@0<5a4G4ALAGaMO5elG1el01AmO7elO009O00HOGamO
7el77`0CGamO7elOGamO7elOGamO7elOG`0=7aXS2E/00omKF`0_F`40000_F`;o0U/00omKF`0IF`04
gW7NL@ON01COg]oNgmkOg]oNgmkOg]oNgmkOgPgO1Yl04mnOgioOWmnOgioOWmnOgioOWml029l01a4G
4ALA5a403AL01a4G4ALA5a401el01AmO7elO009O00DOGamO7`0>G`057elOGal00Ul04QmO7elOGamO
7elOGamO7elOG`LO6R<9F`03oe]K02iK0@0002mK00GoFe]Ko`0FF`04gW7NL@ON00GOg]oNg`0?gP05
gmkOg]l02=h03=oNgmkOg]nOgioOW`;O00BOgioO5Il84@0;5a4G4ALA5a4G4AL00Q4031LA5a4G4ElG
GaMO5`MO00HOGamO7el27`05GamO7el01al04elOGamO7elOGamO7elOGamO7el03AlJ8`UK00?oFe/0
;E/10000;e/01?mKFh4CF`GN00AagW7N0W401=iagW49gP0BgmkOg]oNgmkOg]oNgmkOg]oN3]l7W`0C
gioOWmnOgioOWmnOgioOWmnOg`07W`065a4G4ALA3aL01A4G4ALA00MO00DOGamO7`02G`057elOGal0
3Ul01QmO7elOG`8O015O7elOGamO7elOGamO7elOG`077aXS2E/00omKF`0/F`40000_F`04oe]KP@mK
00>EgID01g401=iagW49gP05gmkOg]l03mh01MoNgmkO00SN00_Og]oNgioOWmnOg`02W`05gioOWml0
59l74@0<5a4G4ALA5a4G4ALA0QL01A4G4ALA008G00AO5elG1el01QmO7elOG`8O00EO7elOG`077`0C
GamO7elOGamO7elOGamO7elOG`0=7aXS2E/00omKF`0[F`40000_F`04oe]KP@eK00MagG7MLMea00KN
00EagW7NL@02gP05LMiagW401mh05=oNgmkOg]oNgmkOg]oNgmkOg]oN3Ml6W`0CgioOWmnOgioOWmnO
gioOWmnOg`08W`074ALA5a4G4@0=5`064ALA5a4G1Ul01QmO7elOG`8O00AO7elO3Ul01QmO7elOG`8O
015O7elOGamO7elOGamO7elOG`077aHS00=O7el02U/00omKF`0ZF`40000_F`04oe]KP@YK1=`01mfE
gIGMUMd027401=iagW47gP07gmkOg]oNg`0=gP07gmkOg]oNg`06gP0<gmkOg]oNgioOWmnO0]l019oO
WmlEW`PA00XG4ALA5a4G4ALA0QL01A4G4ALA008G00AO5elG2El011mO7el27`05GamO7el01al04elO
GamO7elOGamO7elOGamO7el03Al@8`8O00MO7elOGamO00YK00?oFe/0:E/10000;e/01?mKFh49F`O/
00OMLMeagG7M00ON00AagW7N0W401]iagW7NL@ON01;Og]oNgmkOg]oNgmkOg]oNgmh>g`NO01?OWmnO
gioOWmnOgioOWmnOgioO00JO00LA5a4G4ALA00dG00HA5a4G4AL8G`047elOG`8O00IO7elOGal<G`06
7elOGamO0Ql04ElOGamO7elOGamO7elOGamO00LO2R<27`MO00HOGamO7el9F`03oe]K02UK0@0002mK
00CoFe^12e/6g008UMfEgIGMUMd6L@06gW7NLMia1mh01MoNgmkO00oN00GOg]oNg`08gP0;gmkOg]nO
gioOWml00Yl01MnOgioO01BO1a402aLA5a4G4ALA5a4G008A00`G4ALA5a5O5elGGaL7G`057elOGal0
0Ul011mO7el97`0AGamO7elOGamO7elOGamO7el03Al38`=O00HOGamO7el67`07GamO7elOG`09F`03
oe]K02QK0@0002mK00CoFe^135/7k007LMeagG7ML@08gP04LMiagP9a00CNLMia2Mh04]oNgmkOg]oN
gmkOg]oNgmkOgPgO1Yl04mnOgioOWmnOgioOWmnOgioOWml01il01QLA5a4G4@dG00LA5a4G4ALA00MO
00DOGamO7`02G`057elOGal03Ul011mO7el27`0AGamO7elOGamO7elOGamO7el01Al025lG7elOGamO
1Ql7G`067elOGamO2E/00omKF`0WF`40000^F`05oe]KFh403U/7g007UMfEgIGMU@07L@04gW7NL@WN
00GOg]oNg`0=gP07gmkOg]oNg`06gP0<gmkOg]oNgioOWmnO0]l019oOWmlDW`LA00`G4ALA5a4G4ALA
5a425`0;4ALA5a5O5elGGaL01el01AmO7elO009O00HOGamO7el77`0AGamO7elOGamO7elOGamO7el0
1al65`IO00HOGamO7el67`07GamO7elOG`09F`03oe]K02IK0@0002iK0ol00e^1F`0?F`O/00MagG7M
LMea00KN00EagW7NL@02gP05LMiagW401mh04]oNgmkOg]oNgmkOg]oNgmkOgPkO1il04mnOgioOWmnO
gioOWmnOgioOWml01Yl01a4G4ALA5a403AL01A4G4ALA00MO00DOGamO7`02G`057elOGal03Ul011mO
7el27`0>GamO7elOGamO7elOGal44@0<GaMO5elG7elOGamO1Ql7G`067elOGamO2E/00omKF`0UF`40
000^F`04oe]KPA=K1]`02=fEgIGMUMfE1g401=iagW47gP07gmkOg]oNg`0=gP05gmkOg]l02=h02moN
gmkOWmnOgioO00:O00GOWmnOg`0CW`PA00XG4ALA5a4G4ALA0QL01A4G4ALA008G00AO5elG1el01QmO
7elOG`8O00EO7elOG`077`0BGamO7elOGamO7elOGalG4ALA31L6G`067elOGamO1Ql01elOGamO7el0
2E/00omKF`0TF`40000^F`04oe]KPAEK1^`01meagG7MLMd01mh0177NLMh2L@06gW7NLMia1mh04]oN
gmkOg]oNgmkOg]oNgmkOgPgO1Yl04mnOgioOWmnOgioOWmnOgioOWml01il01QLA5a4G4@dG00HA5a4G
4AL6G`057elOGal00Ul01AmO7elO00iO00@OGamO0Ql01ElO4ALA00LG1Q4035lGGaMO5amO7elOG`HO
1el01QmO7elOG`UK00?oFe/08e/10000;U/01?mKFh4FF`OL00OMUMfEgIGM00Ia00KNLMiagW47gP05
gmkOg]l03mh01MoNgmkO00KN00cOg]oNgmkOWmnOgil2g`04WmnOgaBO1a402aLA5a4G4ALA5a4G008A
00@G4ALA0QL015lGGaL9G`047elOG`8O00EO7elOG`077`03GalA00<A00`G4ALA5a4G4ALA5a4<5`IO
00HOGamO7el67`07GamO7elOG`08F`03oe]K02=K0@0002iK00CoFe^165/7k007gG7MLMeag@07gP04
LMiagP9a00CNLMia2Mh04]oNgmkOg]oNgmkOg]oNgmkOgPcO1il04MnOgioOWmnOgioOWmnOgioO00NO
00HG4ALA5a4=5`064ALA5a4G25l011mO7el27`04GamO7`YO00TAWa6O5a4G4AL00Q4011LA5a475`HA
00aO5elGGaLOGamO7el67`MO00HOGamO7el8F`03oe]K029K0@0002iK00CoFe^16U/6g007UMfEgIGM
U@07L@04gW7NL@WN00GOg]oNg`0=gP05gmkOg]l02=h02moNgmkOWmnOgioO00:O00GOWmnOg`0CW`HA
00/G4ALA5a4G4ALA5`024@0<5a4G4ALAGaMO5elG1el011mO7el27`06GaoOWmnO314031LA5a4G4ALA
5a4G4@`G1Ul01QmO7elOG`HO00IO7elOGal9F`03oe]K025K0@0002iK00CoFe^175/6k007LMeagG7M
L@06gP05LMiagW400]h01G7NLMia00ON01;Og]oNgmkOg]oNgmkOg]oNgmh=g`JO01?OWmnOgioOWmnO
gioOWmnOgioO00JO00LA5a4G4ALA00dG00DA5a4G4@07G`047elOG`8O00=O7ml00ml6W`0;4IlAWa6O
5a4G4AL00Q4011LA5a475`HA00aO5elGGaLOGamO7el67`MO00DOGamO7`09F`03oe]K021K0@0002iK
00CoFe^17U/6g007UMfEgIGMU@07L@04gW7NL@ON00GOg]oNg`0?gP05gmkOg]l01]h03=oNgmkOg]nO
gioOW`;O00BOgioO4il84@0:5a4G4ALA5a4G4@8G00/A5a4G4ElGGaMO5`03G`CO1Yl01]nOgioOW``A
00`G4ALA5a4G4ALA5a4<5`IO00HOGamO7el67`06GamO7elO2E/00omKF`0OF`40000^F`04oe]KPAmK
1n`01W7MLMeag@ON00AagW7N0W401=iagW49gP0BgmkOg]oNgmkOg]oNgmkOg]oN3=l7W`0AgioOWmnO
gioOWmnOgioOWml01il01QLA5a4G4@dG00DA5a4G4@03G`04WmnOg`JO1]l6W`0;4IlAWa6O5a4G4AL0
0Q4011LA5a475`HA00aO5elGGaLOGamO7el67`MO00DOGamO7`09F`03oe]K01iK0@0002iK00CoFe^1
8E/6g007gIGMUMfEg@06L@06gW7NLMia1mh01MoNgmkO00gN00OOg]oNgmkO00KN00_Og]oNgioOWmnO
g`02W`03gioO01BO1a402QLA5a4G4ALA5a425`034AOO00?O00FOgioOW`07g`JO00KOWmnOgil<4@0<
5a4G4ALA5a4G4ALA31L6G`067elOGamO1Ql01UlOGamO7`UK00?oFe/07E/10000;U/01?mKFh4PF`03
PE]K00K/00OMLMeagG7M00ON00AagW7N0W401=iagW47gP0BgmkOg]oNgmkOg]oNgmkOg]oN3Ml6W`0C
gioOWmnOgioOWmnOgioOWmnOg`06W`054ALA5a402AL00mkOgP07g`06WmnOgioO1Yl6g`JO00/AWa6O
4IlG4ALA5`024@045a4G4@LG1Q4035lGGaMO5amO7elOG`HO1el01AmO7elO00QK00?oFe/07E/10000
;U/01?mKFh4PF`03PE]K009K1]`01mfEgIGMUMd01W401=iagW47gP07gmkOg]oNg`0=gP05gmkOg]l0
1]h03=oNgmkOg]nOgioOW`;O00BOgioO4il64@0;5a4GgmkOg]oNgmh01ml01IoOWmnO00OO1Yl01]nO
gioOW``A00`G4ALA5a4G4ALA5a4<5`IO00HOGamO7el67`06GamO7elO25/00omKF`0LF`40000^F`04
oe]KPB1K00>1Fe/015/6k006gG7MLMea1]h01G7NLMia00;N00EagW7NL@07gP0BgmkOg]oNgmkOg]oN
gmkOg]oN3=l7W`0AgioOWmnOgioOWmnOgioOWml01Yl00a4G4@05gP04gmkOgP;O00?Ngmh01ml01YoO
WmnOg`NO1]l5W`064IlAWa6O0Q400aLA5`024@065a4G4ALA1QL54@0<GaMO5elG7elOGamO1Ql5G`07
7elOGamO7`08F`03oe]K01]K0@0002iK00CoFe^185/00h5KF`05F`OL00KMUMfEgID7L@04gW7NL@ON
00GOg]oNg`0=gP07gmkOg]oNg`06gP0;gmkOg]nOgioOWml00Yl00mnOg`0@W`CN1ml02MkOg]oNgmkO
gP09g`05WmnOgil01]l7W`05gioOWml03A402QLA5a4G4ALA5a4<5`IO00@OGamO21l01UlOGamO7`QK
00?oFe/06U/10000;E/3o`03Fh5K01mK00>1Fe/01e/6k007LMeagG7ML@06gP04LMiagP9a00CNLMia
2Mh04=oNgmkOg]oNgmkOg]oNgmh=g`JO00oOWmnOgioOWmnOgioOWml01Mh00moNg`08gP04gmkOgP;O
00GNgmkOgP07g`04WmnOg`NO1]l7W`044IlAW`8A00@G4ALA0QL01A4G4ALA00HG1A4035lGGaMO5amO
7elOG`DO1Ul01amO7elOGal025/00omKF`0IF`40000]F`05oe]KFh4085/00h5KF`09F`KL00JEgIGM
UMd6L@06gW7NLMia1mh01MoNgmkO00gN00GOg]oNg`08gP0:gmkOg]nOgioOW`;O00BOgioO0il?gPOO
00_NgmkOg]oNgmkOgP07g`05WmnOgil01]l7W`05gioOWml03A402QLA5a4G4ALA5a4<5`IO00@OGamO
21l01UlOGamO7`QK00?oFe/065/10000;E/01OmKFe^1021K00>1Fe/02e/6k006LMeagG7M1mh0177N
LMh2L@04gW7NL@ON01;Og]oNgmkOg]oNgmkOg]oNgmh<g`NO00?Og]h00mh01G7NLMia00ON00GOg]oN
g`06gP05gmkOg]l00]h01=oNgmh7g`04WmnOg`NO1]l7W`044IlAW`8A00@G4ALA0QL01A4G4ALA00HG
1Q402aMO5elG7elOGamO00DO1Ul01QmO7elOG`UK00?oFe/05e/10000;E/01?mKFh4QF`03PE]K00aK
1m`01YGMUMfEg@Ia00CNLMia1mh01moNgmkOg]l03Mh01MoNgmkO00KN00cOg]oNgioOWg7NLMh5LA;N
1]l02mkOg]oNgmkOg]oN00OO00FOgioOW`07g`JO00GOWmnOg`0=4@0:5a4G4ALA5a4G4@`G1Ul011mO
7el87`05GamO7el025/00omKF`0GF`40000]F`04oe]KPB5K00>1Fe/03U/6k007gG7MLMeag@05gP05
LMiagW400]h01G7NLMia00ON01;Og]oNgmkOg]oNgmkOg]oNgmh7g`BE00EagW7NL@07gP05LMiagW40
1mh01MoNgmkO00SN00COg]oN0]l00mkOgP07g`06WmnOgioO1Yl6g`JO00@AWa6O0Q4011LA5a425`05
4ALA5a401QL64@0;5elGGaLOGamO7el01Al6G`067elOGamO25/00omKF`0FF`40000]F`04oe]KPB5K
00>1Fe/045/6g006gIGMUMfE1g401=iagW47gP05gmkOg]l03Mh01MoNgmkO00?N1=`5U@06LMiagW7N
1W4BgPOO00WNgmkOg]oNgmh01ml01IoOWmnO00OO1Yl01MnOgioO00dA00XG4ALA5a4G4ALA31L6G`04
7elOG`PO00EO7elOG`08F`03oe]K01EK0@0002eK00CoFe^18E/00h5KF`0BF`K/00KMLMeagG46gP04
LMiagP9a00CNLMia2Mh04=oNgmkOg]oNgmkOg]o/g>`2g004k=c/g0JE00KNLMiagW47gP05LMiagW40
1mh00moNg`08gP04gmkOgP;O00?Ngmh02Ml019oOWml6W`KO1Yl02Q6O4IlAWaLA5a425`054ALA5a40
1QL64@0;5elGGaLOGamO7el01Al6G`067elOGamO25/00omKF`0DF`40000]F`04oe]KPB1K00>1Fe/0
5E/6g006gIGMUMfE1G401]iagW7NL@ON00GOg]oNg`08gP0:g;OL]mc/g>cLk0KL1ID01miagW7NLMh0
1G4AgPOO00_NgmkOg]oNgmkOgP07g`05WmnOgil01Ml3W`Co00FOgioOW`0<4@0:5a4G4ALA5a4G4@`G
1Ul011mO7el87`05GamO7el025/00omKF`0CF`40000]F`04oe]KPB1K00>1Fe/05U/6k006LMeagG7M
1mh0177NLMh2L@04gW7NL@ON00?Og^`00n`02kO/]nbgk=c/g>cL00;/00CLk=c/1YD01G7NLMia00ON
00EagW7NL@07gP05gmkOg]l01]h01MoNgmkO00;N00COg]oN1ml019oOWml5W`?o12<00onOW`03W`0:
4IlAWa6O5a4G4@8G00DA5a4G4@075`DA00/GGaMO5amO7elOG`057`IO00HOGamO7el8F`03oe]K019K
0@0002eK00CoFe^185/00h5KF`0HF`KL00JEgIGMUMd6L@04gW7NL@ON00OOg]ng][Nf00G/00^gg;OL
]mc/g>cLk007g0FE00IagW7NLMh6LA7N1]l02mkOg]oNgmkOg]oN00OO00>Ogil01Ol88`06oioOWmnO
314031LA5a4G4ALA5a4G4@XG1Ul011mO7el87`05GamO7el025/00omKF`0AF`40000]F`04oe]KPB1K
00>1Fe/06U/6k006LMeagG7M1Mh01G7NLMia00;N00=a][H00kH01KNf]kJg00O/00Zgk;O/g>cLk=c/
0]`01>cLk=`6U@06gW7NLMia1Mh01G7NLMia00ON00GOg]oNg`08gP03gmkO00;N00COg]oN0ml6o`hS
00?oWil00il02a6O4IlAWaLA5a4G008A00@G4ALA1aL54@0;5elGGaLOGamO7el01Al6G`067elOGamO
6e/10000;E/01?mKFh4PF`03PE]K01UK00>1Fe/01]`01IGMUMfE00Ma017N`<c0c;Jg][Nf]kJg][Nf
]`05k00<g;OL]mbgg>cLk=c/1]`5U@05gW7NLMh01g4AgPOO00GNgmkOgP06oaDS00KoWmnOgil<4@0<
5a4G4ALA5a4G4ALA2QL6G`047elOG`PO00EO7elOG`0JF`40000]F`04oe]KPB1K00>1Fe/06E/00h5K
F`02F`G/00KMLMeagG42gPA<00H=c0g<3L`5]P07]kJg][Nf]`05k00;]nbgk;O/g>cLk=`00^`01=c/
g>`6U@05LMiagW401mh01G7NLMia00ON00?Og]l02=h4oa<S00?o8b<01R<2o`BO00/AWa6O4IlG4ALA
5`024@045a4G4@LG1A402aMO5elG7elOGamO00DO1Ul01QmO7elOGaUK0@0002eK00CoFe^185/00h5K
F`0IF`03PE]K00=K1]`07MfECDa=C4e<CDa=C<3<`<c0]kJg][Nf]kJg][Nf00K/00[L]mbgg>cLk=c/
1]`6U@06LMiagW7N1W4AgP;O0ol37`hS00?o8b<012<00olS8`078`05omnOgil0314031LA5a4G4ALA
5a4G4@XG1Ul011mO7el87`03GamK01YK0@0002eK00CoFe^185/00h5KF`0IF`03PE]K00EK0^`4IPI=
1D`01/`=c0g<3@Jf00Jg][Nf]kH6k00:]nbgk;O/g>cLk0;L00C/g>cL1YD01]iagW7NL@GN00EagW7N
L@07gP03gooo00?o1al78`03ob<S00@S00?o8b<01B<00olS8`068`03oinO00BO00@AWa6O0Q400aLA
5`024@045a4G4@LG1A402aMO5elG7elOGamO00DO0elPF`40000/F`?o00=KPE/07e/00h5KF`0IF`03
PE]K00MK1dd06da=C4e<CDa=C4g<`<c0c<2g][Nf]kJg][Nf]`06k00;]mbgg;OLk=c/g>`01M`6U@05
gW7NLMh01g45gPKo3Al00olS8`0<8`03ob<S00@S00?o8b<01R<01_oOWmnOg`/A00`G4ALA5a4G4ALA
5a4:5`IO00<OGe/095/10000;5/01OmKFe^1021K00>1Fe/06E/00h5KF`09F`EV1Td6C005c0g<3L`0
1kH01KNf]kJg00G/00^gk;O/]ncLk=c/g002k004g>cLk0JE00EagW7NL@04gPKo00]O7elOGamO7elO
G`0:7`LS00?o8b<012<00olS8`048`03ob<S00HS00?oWil019l0116O4Il24@035a4G008A00@G4ALA
1aL54@085elGGaLOGalYF`40000/F`05oe]KFh4085/00h5KF`0IF`03PE]K00YK1Td07Da=C4e<CDa=
C4e<`<c0c<3<][Nf]kJg][Nf]kJg00G/00[L]mbgg>cLk=c/1]`6U@03LMko00Go00`OGamO7elOGamO
7el77`03oalO00HO00?o8b<012<00olS8`048`03ob<S00@S0_l78`;o00BOgioO2a4031LA5a4G4ALA
5a4G4@8G0e/00h5KF`0]F`40000/F`05oe]KFh4085/00h5KF`0IF`03PE]K00aK1VH6C@E<00H=c0g<
3L`5]P06]kJg][Nf1^`02[O/]nbgk=c/g>`2g004k=c/g0Ko00@OGamO0Ql05ElOGamO7elOGamO7eoo
GamO7elOG`087`03ob<S00@S0_l58`;o1R<00olS8`068`03oinO00>O00@AWa6O0Q400aLA5`024@04
5a4G4@@G1e/00h5KF`0]F`40000/F`04oe]KPB5K00>1Fe/06E/00h5KF`0>F`I=01a<CDa=C4e<CDa=
C<3<`<c0]kJg][Nf]kJg][Nf1N`02kOL]mbgg>cLk=c/00Co1Al05UlOGamO7elOGamO7elOoamO7elO
Gol77`03oalO00DO0_l68`03ob<S00@S00?o8b<012<00olS8`068`05oioOWml02a400aLA5`0<F`03
PE]K02eK0@0002aK00CoFe^18E/00h5KF`0IF`03PE]K011K1FH6C@E<00K<3L`=c0d6]P05]kJg][L0
1N`01kO/]nbgk=`00ol:G`0M7elOGamO7omO7elOGamO7elOGamO7olOGamO7el00_l77`03ob<S00@S
00?o8b<012<00olS8`048`;o1b<00onOW`03W`044IlAW`8A00<GFe/03e/00h5KF`0]F`40000/F`04
oe]KPB5K00>1Fe/06E/00h5KF`0AF`M=01]<CDa=C4e<CDa=c<3<`<c0]kJg][Nf]kJg][L01N`00mco
o`02o`07GamO7elOG`077`0GoamO7elOGomO7elOGamOoelOGamO7ol01al00olO7`057`03ob<S00@S
0_l58`;o1R<00olS8`058`05oioOWml00a4EF`03PE]K02eK0@0002aK00CoFe^18E/00h5KF`0IF`03
PE]K01=K1VH6C@E<00G<3L`=c007]P05]kJg][L01?l00amO7`09G`03oemO00AO01KoGamO7elOGolO
GamO7eooGamO7elO0_l01elOGamO7ol01al2o`HS00?o8b<012<00olS8`048`03ob<S00DS0_lJF`03
PE]K02eK0@0002aK00CoFe^18E/00h5KF`0IF`03PE]K01EK1dd05Ta=C4e<CDa=C<3<`<c0c;Jg][Nf
]kH3o`AO00@OGamO0Ql01elOGamO7el021l05omO7elOGaoo7elOGamO7olOGamO7eoo00HO0_l77`03
ob<S00@S00?o8b<012<00olS8`048`03ob<S00HS00?oFe/05e/00h5KF`0]F`40000/F`04oe]KPB5K
00>1Fe/06E/00h5KF`0GF`EV1Td5C0063L`=c0g<0[H3o`067elOGamO0Ql01UlOGamOo`QO00?oGel0
15l01olOGamO7el00_l05UlOGamO7olOGamO7eooGamO7elOGol77`03ob<S00@S00?o8b<012<00olS
8`048`;o1b<00omKF`0FF`03PE]K02eK0@0002aK00CoFe^18E/00h5KF`0HF`03PE]K01IK00>1Fe/0
1Td03Ta=C4e<CDa=C4e<`<c00ol00aMO5`08G`06oamO7elO0Ul021mO7elOGaoo1Ql05omO7elOGamO
oelOGamO7olOGamO7eoo00LO00?o7al01Al00olS8`048`;o1B<2o`HS00?o8b<01B<00omKF`0FF`03
PE]K02aK0@0002aK00CoFe^185/00h5KF`0IF`03PE]K01IK00>1Fe/00U/6IPI=0d`3o`QO00lOGamO
7elOoelOGamO7ol01el00omOG`04G`;o00eO7elOGaooGamO7elO00;o00EO7elOG`02o`067elOGamO
0_l67`;o1R<00olS8`048`03ob<S00@S00?o8b<01B<00omKF`0EF`03PE]K02aK0@0002aK00CoFe^1
85/00h5KF`0IF`03PE]K01IK00>1Fe/015/6C@04C4e<C@?o00`A5a5O5elGGaMO5ol7G`;o00mO7elO
GolOGamO7elOGol01Ql05olOGamO7eooGamO7elOGomO7elOGaoo00LO00?o7al01Al00olS8`048`03
ob<S00@S00?o8b<012<00olS8`058`;o5E/00h5KF`0/F`40000/F`04oe]KPB1K00>1Fe/06E/00h5K
F`0FF`03PE]K00IK16H4o`074ALA5a4G4@08G`0AoamO7elOGamOoamO7elOGol01el00omOG`04G`07
oelOGamO7`02o`0F7elOGamOoelOGamO7olOGamO7elOo`LO00?o8b<012<2o`DS00?o8b<012<2o`LS
00?oFe/04U/00h5KF`0/F`40000/F`;o00=KPE/07e/00h5KF`0IF`03PE]K01IK00>1Fe/01E/5o`04
4ALA5`8A00hG4ALA5a7o5elGGaMO5`UO00ooGamO7elOoelOGamO7el00_l57`;o00eO7elOGaoo7elO
GamO00;o00DOGamO7`02o`HO0_l67`;o1R<00olS8`038`;o1R<00olS8`058`03oe]K015K00>1Fe/0
;5/10000:e/01OmKFe^1021K00>1Fe/06E/00h5KF`0FF`04PE]KF`Co2aL0214G4ALA5a7o25l03omO
7elOGamOoamO7elOG`02o`MO00?oGel015l07olOGamO7eoo7elOGamO7olOGamO7eooGamO7elOGol0
1al00olS8`048`03ob<S00@S00?o8b<012<00olS8`058`03oe]K011K00>1Fe/0;5/10000:e/01OmK
Fe^1021K00>1Fe/06E/00h5KF`0FF`04PE_oo`@A00/G4ALA5a4G4ALA5`024@065a4G4ALA0_l025lG
GaMO5eoo1el04OmO7elOGamOoamO7elOGaoo00HO01OoGamO7elOoamO7elOGaoo7elOGamOo`077`03
oalO00DO00?o8b<012<2o`DS00?o8b<012<00olS8`058`03oe]K00mK00>1Fe/0;5/10000:e/01OmK
Fe^1021K00>1Fe/06E/00h5KF`0FF`08POlG4ALA5a4=5`09oaLA5a4G4AOo00MO0_l01QmO7elOG`;o
00MO7elOGaoo00MO00?oGel015l01olOGamO7el00_l01UlOGamO7`;o00iO7elOGomO7elOGamOo`LO
0_l68`03ob<S00<S00?o8b<012<2o`HS0_l?F`03PE]K02aK0@0002]K00GoFe]KP@0PF`03PE]K01UK
00>1Fe/05E/2o`TA01hG4ALA5olG4ALA5a7o5a4G4ALA5omO5elGGaMO5ol7G`0?oamO7elOGolOGamO
7elO00;o1Al2o`0D7elOGamOoelOGamO7eooGamO7el2o`HO0_l77`03ob<S00@S00?o8b<00b<2o`HS
00?o8b<01B<00omKF`0<F`03PE]K02aK0@0002]K00GoFe]KP@0PF`03PE]K01UK00>1Fe/04e/2o`>O
00TG4ALA5a4G4Ol01AL00olG5`045`09oaLA5a4G4AOo00QO00oo7elOGamO7omO7elOGal00_l7G`03
oemO00AO01ooGamO7elOoelOGamO7eooGamO7elOoamO7elOGaoo00LO00?o8b<012<00olS8`048`03
ob<S00@S00?o8b<01B<00omKF`0;F`03PE]K02aK0@0002]K00GoFe]KP@0PF`03PE]K01UK00>1Fe/0
4E/2o`JO21407olG4ALA5olG4ALA5a7o5a4G4ALA5omO5elGGaMO5ol01el04OlOGamO7elOoelOGamO
7eoo00HO00Oo7elOGamO00;o00HOGamO7el2o`067elOGaoo1al00olO7`057`03ob<S00@S0_l58`03
ob<S00@S0_l68`03oe]K00YK00>1Fe/0;5/10000:e/01?mKFh4QF`03PE]K01UK00>1Fe/03U/3o`VO
00TG4ALA5a4G4Ol031L2o`064ALA5a4G0_l7G`;o00mO7elOGaooGamO7elOGol01el2o`EO01koGamO
7elOGolOGamO7elOoamO7elOoamO7elOGal2o`HO0_l68`03ob<S00<S0_l68`03ob<S00@S00?oFe/0
2E/00h5KF`0/F`40000[F`04oe]KPB5K00>1Fe/06E/00h5KF`09F`Go3Il00olA4@064@0Ooa4G4ALA
oa4G4ALA5olA5a4G4ALAoaMO5elGGaMOo`06G`08oamO7elOGal2o`087elOGamO7ol57`;o01AO7elO
Gaoo7elOGamO7olOGamO7`;o1al00olO7`057`03ob<S00@S00?o8b<012<00olS8`048`03ob<S00@S
0_l9F`03PE]K02aK0@0002]K00CoFe^18E/00h5KF`0IF`03PE]K00AK1Ol02YoOWmnOgioOWml9W`0:
oa4G4ALA5a4Go`DG00?o5aL011L02OlA5a4G4ALAo`08G`07oelOGamO7`02o`087elOGamO7ol7G`03
oemO00AO00oo7elOGamOoamO7elOGal00_l03UlOGamOoelOGamO7eoo1al00olS8`048`;o1B<00olS
8`048`03ob<S00DS00?oFe/01U/00h5KF`0/F`40000[F`04oe]KPB5K00>1Fe/06E/00h5KF`04o`03
gioO00fO00?oWil01il00olA4@054@0Ooa4G4ALAoa4G4ALA5olA5a4G4ALAoaMO5elGGaMOo`07G`0A
oelOGamO7eoo7elOGamO7ol01Ql01omO7elOGal00_l03UlOGamO7eooGamO7eoo1al2o`HO0_l68`03
ob<S00<S00?o8b<012<2o`HS00?oFe/01E/00h5KF`0/F`40000[F`04oe]KPB5K00>1Fe/06E/00h5K
o`04W`0BgioOWmnOgioOWmnOgioOWmoo2Il02OlG4ALA5a4Go`055`;o1AL02?lA5a4G4ALA0_l7G`;o
00hOGamO7eoo7elOGamO7`;o1Ul2o`EO01Ko7elOGamO7omO7elOGamOoelOGamO0_l021mO7elOGaoo
1al00olS8`048`03ob<S00<S0_l68`03ob<S00@S00?oFe/015/00h5KF`0/F`40000[F`04oe]KPB5K
00>1Fe/06E/01X7ogioOW`;O00BOgioO3Il00onOW`07W`03oa4A00DA0_l07QLA5a4GoaLA5a4Goa4G
4ALA5a4GoelGGaMO5elGo`IO01;oGamO7elOGaooGamO7elOGol57`;o00hOGamO7eooGamO7elOG`;o
00HOGamO7ol77`03oalO00DO00?o8b<012<00olS8`048`03ob<S00@S00?o8b<012<00omKF`03F`03
PE]K02aK0@0002]K00CoFe^18E/00h5KF`0IF`03oinO00JO01;OWmnOgooOWmnOgooOWmnOgol9W`0:
oaLA5a4G4ALAo`DG00?o5aL00aL02_lA5a4G4ALA5ol8G`0AoamO7elOGolOGamO7elOGol01el00omO
G`04G`0NoelOGamO7omO7elOGamO7olOGamO7olOGamO7elO0_l67`03ob<S00@S0_l58`03ob<S00@S
00Co8b<S1Ol3F`03PE]K02aK0@0002]K00CoFe^18E/00h5KF`0FF`?o00SOWmnOgioOW`;O00JOgioO
Wol5W`03oinO00>O0_l8W`;o1a403?lG4ALA5olG4ALA5`;o014G4ALA5a4GoelGGaMO5elGo`06G`;o
00LOGamO7elO00;o00HOGamO7el2o`DO00Oo7elOGamO00;o00hOGamO7elOoamO7elOo`PO00?o7al0
11l2o`HS00?o8b<00b<01?lS8b<6o`06GamO7eoo0U/00h5KF`0/F`40000QF`Co1U/2P@03oh5K021K
00>1Fe/04E/5o`CO2Il05?oOWmnOgooOWmnOgioOWmnOgioo2Il02OlA5a4G4ALAo`055`03oaLG00@G
00Wo5a4G4ALA5ol025l2o`0@GamO7elOoelOGamO7elOo`MO00?oGel00el05_mO7elOGamOoamO7elO
Gaoo7elOGal2o`08GamO7elOGol77`03ob<S00@S00Co8b<S1Ol4G`0;oelOGamO7eooFh40;U/10000
85/00omKF`02F`03oe]K009K00?oFe/00h4PF`03PE]K00eK1?l2gP0HomkOg]oNgmkOWmnOgioOWmoo
WmnOgioo1Yl00onOW`03W`03oinO00NO00?o4A401A405OlG4ALA5olG4ALA5a7o5a4G4ALA5`02o`09
5elGGaMO5eoo00IO01;o7elOGamO7eoo7elOGamO7ol57`;o00iO7elOGaoo7elOGamO7`;o00IO7elO
Gol77`;o1Ql01?lS8b<6o`03GamO00LO00_oGamO7elOGomKP@0]F`40000PF`03oe]K009K00?oFe/0
0U/01_mKFe^1F`:17E/00h5KF`0=F`03omoo00GO00?ogml01Ml9W`0DomnOgioOWonOgioOWonOgioO
Wol9W`09oa4G4ALA5a7o00DG0_l55`0:oaLA5a4G4ALAo`QO013oGamO7elOoelOGamO7elO0_l6G`03
oemO00AO023o7elOGamOoamO7elOGamOoelOGamOoelOGamO7elOo`DO1?l011mO7ol77`IO00[oGamO
7elOGon1;E/1000085/00omKF`02F`03oe]K009K00GoFe]KP@03F`>16U/00h5KF`0<F`05omoNgol0
1Mh06OoNgmkOg]oNoioOWmnOgioOWooOWmnOgol01Il00onOW`03W`03oinO00NO00?o4A401A42o`0N
4ALA5a7o4ALA5a7o5a4G4ALA5a7o5elGGaMO5eoo1Ul04OlOGamO7elOGaooGamO7elO00;o1Al01omO
7elOGal00_l03ElOGamO7eooGamO7el00_l77`03oaoo00;o00<Goel01El01olOGamO7el01al02OmO
7elOGamOo`0]F`40000PF`03oe]K009K00?oFe/00U/01OmKFe^100IK0X4HF`03PE]K00]K00OogmkO
g]oo00GO00?ogml01Ml00onOW`07W`0CoioOWmnOoioOWmnOoioOWmnOo`09W`;o00PG4ALA5a4Go`DG
00?o5aL00aL02_lG4ALA5a4G4Ol8G`07oelOGamO7`02o`097elOGamO7eoo00MO00?oGel00el2o`0>
GamO7elOoelOGamO7el2o`0<7elOGaoo7elOGamO0_l03AMO5elGoelOGamO7ol01al6G`08oelOGamO
7el2ob]K0@00021K00?oFe/00U/00omKF`02F`05oe]KFh4025/3PAEK00>1Fe/025/3o`08gmkOg]oN
gol5gP0IomkOg]oNgmkOomnOgioOWmnOomnOgioOo`05W`;o19l2o`VO00?o4A401A407_lA5a4G4OlA
5a4G4OlG4ALA5a4G4OlGGaMO5elGG`;o1Ul02OmO7elOGamO7`02o`077elOGamOo`067`0GoamO7elO
GomO7elOGamO7olOGamO7ol00al2o`035olG00DG00?oGel015l02OlOGamO7elOo`057`0:oelOGamO
7elOobYK0@00021K00?oFe/00U/00omKF`02F`05oe]KFh402e/2PA=K00>1Fe/00e/5o`0<gmkOg]oN
gmkOg]oo1Ml00ooOg`06g`03oinO00JO01CoWmnOgiooWmnOgioOomnOgioOo`VO00Wo5a4G4ALA5ol0
1AL00olG5`035`09oaLA5a4G4ALA00;o25l04_lOGamO7eoo7elOGamO7elOo`IO0_l5G`07oelOGamO
7`02o`0@7elOGamO7olOGamO7olOo`@A00ooGaMO5elGoelOGamO7ol01al00omOG`03G`0:oelOGamO
7elOobUK0@00021K00?oFe/00U/00omKF`02F`05oe]KFh403E/2PA5K00>1Fol00ol:gP08gmkOg]oN
gol5gP0IomkOg]oNgmkOomnOgioOWmnOomnOgioOo`06W`03oinO00>O00?oWil01il00olA4@054@06
oa4G4ALA0_l011LA5a42o`0B4ALA5a4G4AOoGaMO5elGGaOo1Ul04omO7elOGamO7eoo7elOGamO7ol0
1Al03olOGamO7elOoamO7elOG`08o`HG00?o5aL011L00omOG`04G`09oamO7elOGaoo00DO00[oGamO
7elOGaoo:5/100008E/4o`EK00CoFe^145/3P@eK0ol3gP0DgmkOg]oNgmkOg]oNgmkOg]oNgol5g`03
omoO00KO00?oWil01Yl01_nOgioOW`;o00cOWmnOgooOWmnOgol9W`08oaLA5a4G4AL2o`DG00?o5aL0
0aL02_lA5a4G4ALA5ol8G`0BoamO7elOGolOGamO7elOGaoo1el00omOG`03G`;o00XOGamO7eoo7elO
0_l00a7o5`045`03oa4A00DA00ooGaMO5elGoelOGamO7ol01al00omOG`03G`0:oelOGamO7elOobMK
0@0002YK00CoFe^14e/2P@UK0_l01]kOg]oNg`gN00SOg]oNgmkOo`GN00Wog]oNgmkOg]l00_l01ioO
WmnOgil00_l01YoOWmnOo`FO00?oWil00il00onOW`07W`;o1a407_lG4ALA5olG4ALA5olA5a4G4ALA
5omO5elGGaMO5`;o1El2o`087elOGamO7el2o`07GamO7elOo`067`0EoelOGamO7olOoa4G4AOo5a4G
4AOo00LG00?o5aL011L00omOG`04G`09oamO7elOGaoo00DO00[oGamO7elOGaoo9U/10000:U/01?mK
Fh4EF`>11E/01?magW47gP0DgmkOg]oNgmkOg]oNgmkOg]oNgol5g`03omoO00OO00?oWil01Yl04ooO
WmnOgooOWmnOgooOWmnOgol02Yl02OlA5a4G4ALAo`055`03oaLG00<G00[o4ALA5a4G4AOo2El04_mO
7elOGaooGamO7elOGamOo`IO0_l5G`06oamO7elO0_l01aLA5a4G4Ol01AL00olA4@054@0?oelGGaMO
5omO7elOGaoo00LO00?oGel00el02_mO7elOGamO7olUF`40000ZF`04oe]KPAQK0X42F`03omkN00CN
00GOg]oNg`0=gP08gmkOg]oNgol5gP0JomkOg]oNgmkOg_nOgioOWmnOgonOgioOWol5W`;o19l00onO
W`08W`03oa4A00DA01Go5a4G4AOo5a4G4AOo4ALA5a4G4AL00_l02AMO5elGGaMOo`06G`0CoamO7elO
GamO7omO7elOGamOo`057`03oeoo00;o0Q403_lA5a4G4AOo5a4G4AOo1aL00olG5`045`03oemO00AO
00Wo7elOGamO7ol01Al02OmO7elOGamO7`02ob=K0@0002YK00CoFe^16U/02H7oLMiagW7NL@07gP0D
gmkOg]oNgmkOg]oNgmkOg]oNgol5g`03omoO00OO00?oWil01Yl04_oOWmnOgooOWmnOgiooWmnOg`;o
2Il02OlA5a4G4ALAo`055`03oaLG00<G00_o4ALA5a4G4ALAo`08G`0AoelOGamO7omO7elOGamO7el0
0_l6G`04oemOG`?o00hG4ALA5a7o5a4G4ALAo`DG00?o4A401A403omO5elGGaOoGamO7elOo`077`03
oemO00=O00_oGamO7elOGamOo`0RF`40000ZF`04oe]KPAUK0_l:gP05gmkOg]l03Mh02=oNgmkOg]oo
1Mh06_oNgmkOg]oNgmkoWmnOgioOWmooWmnOgioo1Yl00onOW`03W`03oinO00NO0_l64@06oaLA5a4G
0_l05a4G4AOo4ALA5a4G4ALAoaMO5elGGaMO00;o1El04OlOGamO7elOGamOoamO7elO00Co2Q403_lA
5a4G4AOo5a4G4AOo1QL00olG5`045`03oemO00EO00Wo7elOGamO7ol01Al02omO7elOGamO7eoo025K
0@0002YK00CoFe^15U/3o`0<LMiaLMiagW7NLMia1mh05=oNgmkOg]oNgmkOg]oNgmkOg]oo1Ml00ooO
g`07g`;o1il05?oOWmnOgooOWmnOgiooWmnOgioo2Yl01olG4ALA5a400_l55`03oaLG008G00_o4ALA
5a4G4ALAo`09G`0CoamO7elOoelOGamO7elOGaooG`03o`:O01Go4IlAWa6O5a4G4ALAoaLA5a4G4Ol0
1AL00olA4@044@0@oaMO5elGGolOGamO7elOo`LO00?oGel00el02omO7elOGamO7eoo021K0@0002YK
0_l00e^1F`0CF`;o00KNLMiagW4;gP07gmkOg]oNo`05gP03omkN00?N00Sog]oNgmkOo`GN01Wog]oN
gmkOg]oNgooOWmnOgioOoioOWmnO00;o1Il00onOW`03W`03oinO00RO00?o4A401A402olA5a4G4OlA
5a4G00;o00PG4ALA5a4G4@;o00UO5elGGaMO5ol01El2o`0AGamO7elOGamOoioOWmnOgol031403_lA
5a4G4AOo5a4G4AOo1QL00olG5`045`03oemO00EO00Wo7elOGamO7ol01Al02omO7elOGamO7eoo01mK
0@0002UK00GoFe]KP@0CF`0:omkNgW7NLMiagP9a00WNLMiagW7NLOl01]h05?oNgmkOg_oNgmkOg_oN
gmkOg]oo1Ml00ooOg`08g`03oinO00FO0_l02ioOWmnOoioOWmnO00;o00GOWmnOo`0:W`09oaLA5a4G
4AOo00DG00?o5aL00aL02olG4ALA5a4G4AOo00QO00oo7elOGamOoamO7elOGal00_l7W`0Eoa6O4IlA
WaLA5a4G4OlG4ALA5a7o00DG00?o4A4011404?lGGaMO5eoo7elOGamO7ol77`03oemO00=O00_oGamO
7elOGamOo`0NF`40000YF`05oe]KFh404U/00omaL@03L@08gW7NLMiag_l8gP08omoNgmkOg_l5gP03
omkN00?N00Sog]oNgmkOo`GN01_og]oNgmkOg]oNgooOWmnOgioOWooOWmnOgol01Yl00onOW`02W`03
oinO00RO00?o4A401A407olA5a4G4OlA5a4G4OlG4ALA5a4G4AOoGaMO5elGGaL00_l5G`07oelOGamO
o`02W`09omnOgioOWmoo00`A00ko4ALA5a4GoaLA5a4Go`HG00?o5aL011L00omOG`05G`09oamO7elO
Gaoo00DO00[oGamO7elOGamO0_lLF`40000YF`05oe]KFh404E/00ooNgP05gP0ALMiagW7NLOoNLMia
gW7NLOl01]h05?oNgmkOg_oNgmkOg_oNgmkOg]oo1Ml00ooOg`08g`03oinO00JO01?oWmnOgiooWmnO
gioOomnOgioo00ZO0_l01a4G4ALA5ol01AL00olG5`035`0;oaLA5a4G4ALA5ol02El02omO7elOGolO
Gaoo00CO00?oWil01Il05OlAWa6O4Ioo4ALA5a7o5a4G4ALAo`055`03oa4A00@A013o5elGGaMOoamO
7elOGaoo1al00omOG`03G`0<oelOGamO7elOGaoo6e/10000:E/01OmKFe^1011K00?oLG401g402?ma
gW7NLMko2=h02?oOg]oNgmko1Mh00ooNgP03gP08omkOg]oNgol5gP0;omkOg]oNgmkOg]l00_l03YoO
WmnOgioogioOWmoo1Yl00onOW`02W`;o2Yl00olA4@044@06oa4G4ALA0_l06ALA5a7o5a4G4ALA5a4G
oelGGaMO5elGGol01El00omOo`06W`09omnOgioOWmoo00HA00?o4A400a403_lA5a4G4AOo5a4G4AOo
1QL00olG5`045`03oemO00EO00Wo7elOGamO7ol01Al03?mO7elOGamO7elOoaYK0@0002UK00GoFe]K
P@0@F`03omgN00[N00EagW7NL@02gP08LMiagW7NLOl6gP0DomkOg]oNomkOg]oNomkOg]oNgol5g`03
omoO00WO00?oWil01Il05?nOgioOWonOgioOWmoogioOWmoo2Yl01olA5a4G4AL00_l55`03oaLG008G
00[o5a4G4ALA5a4G0_l8G`04oelOG`?o2=l00onOW`05W`0Eoa6O4IlAWolA5a4G4OlG4ALA5a7o00DG
00?o4A4011404?lGGaMO5eoo7elOGamO7ol77`03oemO00=O00coGamO7elOGamO7olIF`40000YF`05
oe]KFh403e/01?nEgID;L@07gW7NLMiao`08gP07gmkOg]oNo`05gP03omkN00?N00Sog]oNgmkOo`GN
01[og]oNgmkOg]oNgmkoWmnOgioOWooOWmnOg`;o1Il00onOW`03W`03oinO00RO00?o4A401A407_lG
4ALA5olG4ALAoaLA5a4G4ALA5a7o5elGGaMO5`Co1=l8W`09omnOgioOWmoo00HA00?o4A400a403OlA
5a4G4AOo5a4G4Ol01QL00olG5`055`03oemO00EO00Wo7elOGamO7ol01Al03?mO7elOGamO7elOoaQK
0@0002UK00GoFe]KP@0?F`06og7MLMgo2Mh04OmagW7NLMkoLMiagW7NLMko00GN01?og]oNgmkog]oN
gmkog]oNgmko00KO00?ogml02Ml00onOW`05W`;o00_OWmnOgooOWmnOg`02o`05WmnOgol02Yl02OlA
5a4G4ALAo`055`03oaLG008G0_l02Q4G4ALA5a4G4Ol5G`03oioO00NO2=l00onOW`05W`0Eoa6O4IlA
WolA5a4G4OlG4ALA5a7o00@G00?o4A4011404OmO5elGGaOoGamO7elOGaoo00LO00?oGel00el03?mO
7elOGamO7elOoaMK0@0002UK00GoFe]KP@0>F`08omfEgIGMUMd9L@08omiagW7NLOl8gP07omkOg]oN
o`05gP03omkN00?N00Oog]oNgmko00KN01cog]oNgmkOg]oNgmkoWmnOgioOWmooWmnOgioo1Yl00onO
W`02W`03oinO00RO0_l64@0PoaLA5a4GoaLA5a4Goa4G4ALA5a4G4OlGGaOoWmnOgil6g`RO00WogioO
WmnOgol01Q400olA4@034@0=oa4G4ALA5olG4ALAo`065`03oaLG00@G00?oGel01Ul02OlOGamO7elO
o`057`0<oelOGamO7elOGaoo5U/10000:E/01?mKFh4>F`0;og7MLMeagG7MLOl02=h01omagW7NLMh0
0_l02=iagW7NLMko1Mh04ooNgmkOg_oNgmkOg_oNgmkOg_l01]l00ooOg`09g`03oinO00JO01?ogioO
WmoogioOWmnOoioOWmoo00^O00So5a4G4ALAo`DG0_l45`0Coa4G4ALA5a4G4OmOoioOWmnOg`07W`SO
00?oWil01Il05OlAWa6O4Ioo4ALA5a7o5a4G4ALAo`045`03oa4A00@A017oGaMO5elGoelOGamO7elO
o`077`03oemO00=O00coGamO7elOGamO7olEF`40000YF`04oe]KP@iK00coUMfEgIGMUMfEgOl9L@08
og7NLMiag_l7gP07omkOg]oNo`05gP03omkN00?N00Oog]oNgmko00KN00cog]oNgmkOg]oNgmh2o`0>
gioOWmnOgonOgioOWol6W`03oinO00:O00?oWil02Il00olA4@044@;o01lA5a4G4OlA5a4Goa4G4ALA
5a4G4OnOgioOWmnOgioo00GO00?oWil01Il02OoOWmnOgioOo`064@03oa4A00<A00go4ALA5a4GoaLA
5a7o00HG00?o5aL011L00omOG`06G`09oamO7elOGaoo00DO00coGamO7elOGamOoe/5P@mK0@0002UK
00CoFe^13E/03_oMLMeagG7MLMeagG7o2Mh04?oNLMiagW7ogW7NLMiag_l5gP0ComkOg]oNomkOg]oN
omkOg]oNo`06g`03omoO00[O00?oWil01Il04_oOWmnOgooOWmnOgiooWmnOg`;o2Yl02OlG4ALA5a4G
o`055`03oaLG008G00Wo4ALA5a4G4Ol00]l02YoOWmnOgioOWol5W`03omoO00GO00?oWil01Il05OlA
Wa6O4Ioo4ALA5a7o5a4G4ALAo`045`03oa4A00@A017oGaMO5elGoelOGamO7elOo`077`03oemO00=O
00WoGamO7elOGol00X4DF`40000YF`04oe]KP@eK013ogIGMUMfEgIGMUMfEgIGo27402?magW7NLMko
1mh01ooNgmkOg_l01Mh00ooNgP03gP07omkOg]oNo`06gP0LomkOg]oNgmkOg]oNgooOWmnOgioOoioO
WmnOo`JO00?oWil00il00onOW`08W`03oa4A00DA01;o4ALA5a7o4ALA5olA5a4G4Ol4g`0:WmnOgioO
WmnOo`GO00?oWil01Il02OoOWmnOgioOo`064@03oa4A00<A00go4ALA5a7o4ALA5a7o00HG00?o5aL0
11L00omOG`06G`09oamO7elOGaoo00DO00OoGamO7eoo01MK0@0002UK00CoFe^12e/2o`0ALMeagG7M
LMeagG7MLMeagOl02=h2o`0>LMiagW7ogW7NLMiag_l5gP0ComkOg]oNomkOg]oNomkOg]oNo`06g`03
omoO00[O00?oWil01Il01_oOWmnOg`;o00FOgioOW`02o`05gioOWol02Yl2o`074ALA5a4Go`055`03
oaLG008G00Go4ALAo`06g`0:omnOgioOWmnOo`JO00?ogml01=l00onOW`05W`0Doa6O4IlAWolA5a4G
4OlG4ALA5ol55`03oa4A00<A01;o5elGGaMO5omO7elOGamO7ol77`03oemO00=O00GoGamOo`0HF`40
000YF`04oe]KP@YK01Cog=cLgIGMUMfEgIGMUMfEgIGMU@;o27401ooNLMiag_l01mh01ooNgmkOg_l0
1Mh00ooNgP03gP07omkOg]oNo`06gP0EomkOg]oNgmkOg]oNgooOWmnOgioO00;o00KOWmnOgol6W`03
oinO00:O00?oWil02Il00olA4@044@0>oa4G4ALAoa4G4AOo4Ol8g`09omnOgioOWmnO00;o1Ml00onO
W`04W`09omnOgioOWmoo00HA00?o4A400a403OlA5a4G4OlA5a4G4Ol01AL00olG5`055`03oemO00IO
00Wo7elOGamO7ol01Al00omOo`0IF`40000YF`;o00=KPE/025/00oo/k003k00BomeagG7MLMeagG7M
LMeagG7o2=h01_magW7NL@;o00IagW7NLMh2o`CN01?og]oNgmkog]oNgmkog]oNgmko00GO00?ogml0
2ml2o`NO01?oWmnOgiooWmnOgioOomnOgioo00^O00So4ALA5a4Go`<G2?l<g`09WmnOgioOWmoo00FO
00?ogml01=l00onOW`05W`0Doa6O4IlAWolA5a4G4OlG4ALA5ol55`03oa4A00<A01;o5elGGaMO5omO
7elOGamO7ol77`04oemOG`?o6U/10000:5/01OmKFe^100QK00?og=`01M`04_nEgIGMUMfEgIGMUMfE
gIGMo`Qa00SogW7NLMiao`ON00KogmkOg_l5gP03omkN00?N00Oog]oNgmko00GN01kogmkOg]oNgmkO
g]oNgmkoWmnOgioOWooOWmnOgol6W`03oinO00:O00?oWil02Il00olA4@034@Co00SOg]oNgmkOgPcO
00[oWmnOgioOWmoo1Ml00onOW`04W`09omnOgioOWmoo00HA00?o4A400a403OlA5a4G4OlA5a4G4Ol0
1AL00olG5`055`03oemO00IO00So7elOGamO7`?o7E/10000:5/01OmKFe^100YK2>`04?magG7MLMea
gG7MLMeagG42o`ON0_l03]iagW7Nog7NLMiagW7o1=h04ooNgmkOg_oNgmkOg_oNgmkOg_l01Ml00ooO
g`0<g`03oinO00FO01;oWmnOgiooWmnOgioOomnOgil2o`ZO00?o4Ol00_l4gP09gmkOg]oog]oN00cO
00[oWmnOgioOWmoo1Il00ooOg`04g`03oinO00FO01Co4IlAWa6Ooa4G4ALAoaLA5a4Go`DG00?o4A40
0a404_lGGaMO5eoo7elOGamO7elOo`DO00?oFe/07U/10000:5/01OmKFe^100]K2=`04_oMUMfEgIGM
UMfEgIGMUMfEo`Qa00OoLMiagW7o00ON00KogmkOg_l5gP;o1=h01ooNgmkOg_l01Mh07_oOg]oNgmkO
g]oNgmkOg_nOgioOWmnOomnOgioOo`JO00?oWil00il00onOW`08W`03omoO00KO00_NgmkOg_oNgmkO
gP0:g`0:oioOWmnOgioOo`GO0_l5W`09omnOgioOWmoo00HA00?o4A400a403?lA5a4G4OlA5a4Go`HG
00?o5aL011L00omOG`07G`05oamO7ol08E/10000:5/01OmKFe^100aK00?ok>`01N`04_magG7MLMea
gG7MLMeagG7Mo`SN00oogW7NLMkoLMiagW7NLOl01=h2o`0AgmkOg]oogmkOg_oNgmkOg_l01Ml00ooO
g`0<g`03oinO00FO00goWmnOgiooWmnOgioO00;o00FOgioOo`09W`03omoN00KN00gogmkOg]oNomoN
gmko00WO0_l02=nOgioOWmoo1Yl00ooOg`03g`03oinO00FO01Co4IlAWa6Ooa4G4ALAoaLA5a4Go`@G
00?o4A4011405?lGGaMO5eoo7elOGamO7elOoaoo8U/10000:5/01OmKFe^100eK00?og=`01M`2o`0?
UMfEgIGMUMfEgIGMUMfE00;o1g401_magW7NL@;o1]h01ooOg]oNgol01Mh00ooNgP02gP07omkOg]oN
o`05gP0?omoNgmkOg]oNgmkOg]oN00;o00cOWmnOgioogioOWml2o`JO00?oWil00Yl00onOW`05W`05
omkNg_l01ml02ooOg]oNgooOg]oN00_O00WogioOWmnOgol01]l00onOW`03W`09omnOgioOWmoo00HA
00?o4A400a403?lA5a4G4OlA5a4Go`HG00?o5aL011L00omOG`07G`03oe]K025K0@000003FomK00AK
00CoFe]K0_l00e_oF`0HF`05oe]KFh403U/00oo/k006k00BomeagG7MLMeagG7MLMeagG7o1mh03ooN
LMiagW7ogW7NLMiao`05gP0BomoNgmkOomoNgmkog]oNgmko1Ml00ooOg`0=g`03oinO00BO0_l04]nO
gioOomnOgioOWonOgioOo`FO00KogmkOg]l8gP06omkOg]oN0_l01MkOg]oo00WO00WogioOWmnOgol0
1Yl00ooOg`03g`03oinO00FO01Co4IlAWa6Ooa4G4ALAoaLA5a4Go`@G00?o4A400a404OmO5elGGaMO
oamO7elOGaoo02AK0@000003FomK00AK00GoFe]Ko`0LF`05oe]KFh403e/00ooLg006g00BoiGMUMfE
gIGMUMfEgIGMUMgo1g42o`06gW7NLMko1]h01ooOg]oNgol01Mh00ooNgP02gP07omkOg]oNo`05gP0O
omoNgmkOg]oNgmkOg]oNgooOWmnOgioOoioOWmnOo`06W`03oinO00:O00GoWinOo`08gP03omoO00GO
00gog]oNgmkog]oNgmko00SO00WogioOWmnOgol01]l00onOW`03W`09omnOgioOWmoo00HA00?o4A40
0a403?lA5a4G4OlA5a4Go`DG00?o5aL01AL00omOG`03G`03oe]K02=K0@000003FomK00AK00GoFe]K
o`0LF`05oe]KFh4045/00oo/k006k0;o011agG7MLMeagG7MLMeagG7o2=h03_magW7NLOoNLMiagW7o
1Mh04_oOg]oNgooOg]oNomkOg]oNo`GO00?ogml03Ml00onOW`05W`0QomnOgioOomnOgioOWonOgioO
oioogmkOg]oNgmkOg]oo00KN00gogmkOg]oog]oNgmko00SO0_l01YoOWmnOg`;o1Il00ooOg`03g`03
oinO00FO01Co4IlAWa6Ooa4G4ALAoaLA5a4Go`@G00?o4A400a403OmO5elGGaMOoamO7ol09U/10000
00=Koe/015/01OmKFe_o01aK00GoFe]KP@0AF`03omcL00OL013ogIGMUMfEgIGMUMfEgIGM0_l7L@07
omiagW7No`06gP07omoNgmkOo`05gP03omkN00;N00Oog]oNgmko00GN01oogmkOg]oNgmkOg]oNgmkO
omnOgioOWmooWmnOgioo00JO00?oWil00ol=gP03omoO00CO0_l01=oNgmh2o`06gmkOg]oo2=l02OnO
gioOWmnOo`05g`03oinO00>O00WogioOWmnOgol01Q400olA4@034@0<oa4G4ALAoa4G4AOo1AL00olG
5`055`03oeoo02MK0@000003Fooo00Go0e/00omKF`0JF`04oe]KPA=K00?ok>`01n`04_magG7MLMea
gG7MLMeagG7Mo`ON00koLMiagW7ogW7NLMiao`GN01;ogmkOg]oogmkOg_oNgmkOg_l5g`03omoO00gO
0_l6W`0<omnOgioOomnOgioO0ol4gP0?gmkOg]oNgmkOg]oNgmko00KN00cog]oNgmkogmkOg]l2o`OO
00WoWmnOgioOWol01Il2o`CO00?oWil01Il05?lAWa6O4Ioo4ALA5a7o5a4G4AOo11L00olA4@034@07
oelGGaMO5`02obQK0@000003FomK00AK00GoFe]Ko`0LF`04oe]KPAAK00?og=`01m`2o`0@UMfEgIGM
UMfEgIGMUMfEo`Ma0_l0177NLMh2o`GN0_l01MkOg]oo00GN00?og]h00]h01_oNgmkOo`KN023ogmkO
g]oNgmkOg]oNgmkOg_nOgioOWmooWmnOgiooW`?o5]h2o`GO00kogmkOg]oogmkOg]oNo`OO00WoWmnO
gioOWol01]l00onOW`02W`09omnOgioOWmoo00HA00?o4A400a403?lA5a4G4OlA5a4Go`DG00Co5aLG
0_lZF`4000000e_oF`04F`03oe]K00?o6e/01?mKFh4EF`03onc/00S/013ogG7MLMeagG7MLMeagG7M
0_l7gP0>omiagW7Nog7NLMiag_l4gP0AomoNgmkOomoNgmkog]oNgol01]l00ooOg`0>g`03oinO00BO
00CogioO0ol01g7NLMiagW401]h03ooOg]oNgmkOg]oNgmkOo`05gP;o00COg]oN0_l01MkOg]oN00;o
1]l02OnOgioOWmnOo`06W`03omoO00;O00?oWil01Il05?lAWa6O4Ioo4ALA5a7o5a4G4AOo11L00olA
4@034@04oeooPB]K0@000003FomK00QK00?oFe/06U/01?mKFh4FF`03omcL00SL01;oUMfEgIGMUMfE
gIGMUMfEgOl7L@07og7NLMiao`06gP06omkOg]oo1Mh00ooNgP02gP06omkOg]oo1]h05ooOg]oNgmkO
g]oNgmkOg]oNoioOWmnO00Co1748gP03omkN00?N0_l;gP;o1Ml03_oNgmkOg_oNgmkOg]oo1]l2o`07
gioOWmnOo`06g`03oinO00:O00WogioOWmnOgol01Q400olA4@034@0<oa4G4ALAoa4G4AOo11L2o`03
Fh5K02YK0@000003Fooo00Go0e/00omKF`0JF`04oe]KPAMK00?ok>`02>`2o`0@LMeagG7MLMeagG7M
LMeao`ON00kogW7NLMkoLMiagW7No`CN017ogmkOg]oogmkOg_oNgmkOo`06g`03omoO00kO00?oWol0
0_l00miagP08gP08LMiagW7NLOl5gP;o00cNgmkOg]oNgmkOg_l5gP;o00CNgmkO0_l01MoNgmkO00;o
1]l02?oOWmnOgioo1Yl00ooOg`02g`03oinO00FO01Co4IlAWa6Ooa4G4ALAoaLA5a4Go`@G00Co4Ooo
0e/00h5KF`0YF`40000XF`;o00=KPE/05e/00ooLg009g00@omfEgIGMUMfEgIGMUMfEg@;o1W401oma
gW7NLOl01]h01_oNgmkOo`GN00?og]h00]h01_oNgmkOo`KN01WogmkOg]oNgmkOg]oNgmkOg_oNLMia
gW7N00Ma00?og]h01]h00ooNgP03gP;o2]h2o`GO00kogmkOg]oogmkOg]oNo`KO00SogioOWmnOo`KO
00?oWil00Yl02OoOWmnOgioOo`064@03oa4A00<A00Co4ALA2?l5F`03PE]K02UK0@0002QK00CoFe^1
6E/00oo/k009k00Bog7MLMeagG7MLMeagG7MLMgo1]h2o`04LMiagP;o00KNLMiag_l4gP0AomoNgmkO
omoNgmkog]oNgol01]l00ooOg`0=g`0;oiGNLMiagW7NLOl01]h2o`08LMiagW7NLOl5gP0<omoNgmkO
g]oNgmkO0_l4gP0=omkOg]oNomoNgmkOgP02o`GO00OogioOWmnO00;o1Il2o`?O00?oWil01Il02olA
Wa6O4Ioo4ALA00Go3E/00h5KF`0YF`40000WF`05oe]KFh406U/00ooLg009g00BomfEgIGMUMfEgIGM
UMfEgIGo1g401ooNLMiag_l01Mh01_oNgmkOo`GN00?og]h00]h01_oNgmkOo`KN013ogmkOg]oNgmkO
g]oNgmko0iD02G7NLMiagW7No`06L@03omkN00KN00?og]h00]h2o`_N00?ogml00]l2o`04g]oNg`;o
00ONgmkOg]oo00GO0_l01ioOWmnOgol01]l03OnOWioogioOWmnOgol01A44oa9K00>1Fe/0:E/10000
9e/01OmKFe^101]K00?ok>`02N`2o`0@gG7MLMeagG7MLMeagG7Mo`ON00goLMiagW7ogW7NLMko00CN
017ogmkOg]oogmkOg_oNgmkOo`06g`03omoO00[O00?oUID00iD02_oNLMiagW7NLOl5gP;o00ONLMia
gW7N00;o1=h2o`0:gmkOg]oNgmkOgP;o1=h03OoOg]oNgooNgmkOg]l00_l5g`08oioOWmnOgol6W`05
omoOgol01il01OlAWa7o01IK00>1Fe/0:E/100009e/01OmKFe^101aK00?og=`02]`04?nEgIGMUMfE
gIGMUMfEgID2o`Ia00OogW7NLMko00GN00Kog]oNgol5gP03omkN00;N00Kog]oNgol6gP0=omoNgmkO
g]oNgmkOo`07U@08og7NLMiagW42o`Ea0_l7gP;o1=h2o`[N00?ogml00]l2o`0=gmkOg_oNgmkOg]oN
o`05g`08oioOWmnOgol6g`0?oinOWooOWmnOgioOoa7o01MK00>1Fe/0:E/100009e/01OmKFe^101eK
00?ok>`02^`04_oMLMeagG7MLMeagG7MLMeao`KN0_l02miagW7ogW7NLMko00CN017ogmkOg]oogmkO
g_oNgmkOo`06g`03omoO00SO00?oUID01iD02?oNLMiagW7N0_l5gP09og7NLMiagW7N00;o1=h2o`09
gmkOg]oNgmkO00;o1=h01OoNgmkO00;o00KOg]oNgmh2o`CO00SoWmnOgioOo`JO00GogmoOo`06W`;o
65/00h5KF`0YF`40000WF`05oe]KFh407U/00ooLg00:g0;o013MUMfEgIGMUMfEgIGMUMgo1g401_ma
gW7No`GN0_l01=oNgol5gP03omkN00;N00Kog]oNgol6gP0:omoNgmkOg]oNo`^E0_l0277NLMiagW7o
1G42o`SN0_l4gP03omkN00SN00?ogml00]l03ooOg]oNgooOg]oNgmkOo`04g`08oioOWmnOgol6g`08
oinOWooOWml2oaYK00>1Fe/0:E/100009e/01OmKFe^101mK00?ok>`02n`04?magG7MLMeagG7MLMea
gG42o`KN00GogW7NL@02o`06LMiagW7o0mh04OoOg]oNgooOg]oNomkOg]oo00KO00?ogml01Ml00onE
U@0;U@;o00KNLMiagW42o`GN0_l02G7NLMiagW7No`04gP;o00WNgmkOg]oNgmh00_l3gP;o00cOg]oN
omoNgmkOg]l2o`?O0_l01]nOgioOo`JO00OogmoOoioo01aK00>1Fe/0:E/100009e/01OmKFe^1021K
00?og=`02m`04_oMUMfEgIGMUMfEgIGMUMfEo`Ia00OoLMiagW7o00GN00GogmkOo`05gP03omkN00;N
00Kog]oNgol6gP08omoNgmkOg_l?U@;o00IagW7NLMh2o`Ea00?og]h01]h2o`CN0_l9gP03omoO00;O
00Gog]oNg`02o`08g]oNgmkOg_l4g`07omnOgioOo`05g`Ko7E/00h5KF`0YF`40000WF`05oe]KFh40
8E/00oo/k00;k0;o013MLMeagG7MLMeagG7MLMgo1]h2o`0;LMiag_magW7NLOl00mh04OoOg]oNgooO
g]oNomkOg]oo00KO00?ogml00]l00onEU@0@U@09og7NLMiagW7o00GN0_l02=iagW7NLMia0_l4gP;o
00SNgmkOg]oNg`;o0mh03_oOg]oNgooNgmkOg]oN0_l3g`08omnOgioOoil3ob=K00>1Fe/0:E/10000
9e/01OmKFe^1025K00>1om`03M`04?nEgIGMUMfEgIGMUMfEgID2o`Ia00KogW7NLOl5gP05omoNgol0
1Mh00ooNgP02gP06omkOg]oo1]h01OoOg]oo01>E0_l01]iagW7NL@;o1G42o`SN0_l4gP03omkN00ON
00CogmoO0_l03]oNgmkog]oNgmkOg]oo0ml01?oOWml3obIK00>1Fe/0:E/100009e/01?mKFh4RF`03
PE_o00k/01;ogG7MLMeagG7MLMeagG7MLOl6gP0<og7NLMkoLMiagW7o0mh04OoOg]oNgooOg]oNomkO
g]oo00KO00Cogmoo5ID2o`06LMiagW7N0_l5gP0;og7NLMiagW7NLOl01=h2o`08gmkOg]oNgmh2o`?N
00Gog]oNg`02o`06gmkOg]oN2?lYF`03PE]K02UK0@0002MK00CoFe^18U/0185KFol>g00BoiGMUMfE
gIGMUMfEgIGMUMgo1W401OoNLMia00;o1=h01OoOg]oo00GN00?og]h00]h01_oNgmkOo`KN0_lHU@;o
00ONLMiagW7o00Ea0_l8gP;o1=h2o`SN00CogmoO0_l02=kOg]oogmkO0_l3F`03PE]K02]K00>1Fe/0
:E/100009e/01?mKFh4RF`05PE]KFol03^`2o`0?LMeagG7MLMeagG7MLMea00;o1Mh03?magW7NLOoN
LMiao`?N017ogmkOg]oogmkOg_oNgmkOo`05g`;o6YD01ooNLMiagW400_l5gP;o00QagW7NLMiagP;o
1=h2o`07gmkOg]oNg`02o`?N00SogmkOg_oOo`EK00>1Fe/0:e/00h5KF`0YF`40000WF`04oe]KPB9K
00>1Fe/00U/00ooLg00=g00BomfEgIGMUMfEgIGMUMfEgIGo1G42o`05LMiag_l01=h01OoOg]oo00GN
00?og]h00]h01ooNgmkOomh00ol3g003oiFE01NE0_l01W7NLMiagP;o1G400ooNgP07gP;o1=h2o`ON
00OogmoOomkO00?o1U/00h5KF`0[F`03PE]K02UK0@0002MK00CoFe^18U/00h5KF`03F`;o3^`04_ma
gG7MLMeagG7MLMeagG7Mo`KN00_ogW7NLOoNLMiao`03gP09omoNgmkOomoN00So00S/g>cLk=c/g0?o
5iD2o`07gW7NLMiao`05gP;o00WNLMiagW7NLMh00_l4gP07omkOg]oNg`07o`UK00>1Fe/0:e/00h5K
F`0YF`40000WF`;o00=KPE/085/00h5KF`06F`03omcL00cL0_l049GMUMfEgIGMUMfEgIGMUOl6L@06
og7NLMko1=h01OoOg]oo00?N1?l02=bgg;OLk=c/2m`2oaNE00OogW7NLMia00;o1G42o`WN00?og]h0
0]h2o`04g_oooa1K00>1Fe/0;5/00h5KF`0XF`40000VF`05oe]KFh408E/00h5KF`07F`03onc/00g/
013ogG7MLMeagG7MLMeagG7M0_l5gP08omiagW7ogW49o`C/00^gk;O/]ncok=c/g002k008g>cLk=c/
g>`2oaJE0_l01W7NLMiagP;o1Mh02_magW7NLMiagW42o`;N0olCF`03PE]K02aK00>1Fe/0:5/10000
9U/01OmKFe^1025K00>1Fe/025/00ooLg00=g00BoiGMUMfEgIGMUMfEgIGMUMgo1748o`08][Nf]kJg
][L7k00=okOL]mbgg?oLk=c/o`08g0;o5YD2o`07gW7NLMiao`05L@;o2Mh2oaIK00>1Fe/0;5/00h5K
F`0XF`40000VF`05oe]KFh408E/00h5KF`09F`03onc/00g/0_l04G7MLMeagG7MLMeagG7MLOoN00;o
00Q<o`g<3L`=c0Ff00Bg][Nf0_l6k007onbgk;O/]`02o`0<k=c/g?o/g>cLk=c/0olEU@;o00EagW7N
L@02o`GN0_l01g7NLMiag_l065/00h5KF`0/F`03PE]K02QK0@0002IK00GoFe]KP@0QF`03PE]K00YK
00?og=`03]`09ooMUMfEgIGMUMfEgIGMUMgoCDa=C?o<`<c0c<2g][Nf]kJg][Nfo`07k0;o00GL]mbg
g002o`06k=c/g>co1m`2oaFE00OoLMiagW7N00;o1G400ooNgP02gP03oe]K01MK00>1Fe/0;5/00h5K
F`0XF`40000VF`05oe]KFh408E/00h5KF`0;F`03onc/00k/013oLMeagG7MLMeagG7MLMgo14`02Oo<
3L`=c0g<3@05]P04okNf]`;o1n`2o`05]nbgk;L00ol01=c/g>`2o`06k=c/g>cL0_lDU@;o00ONLMia
gW7o00GN0_l00mkoF`0IF`03PE]K02aK00>1Fe/0:5/100009U/01OmKFe^1025K00>1Fe/035/00ooL
g00>g0;o02JEgIGMUMfEgIGMUOm<CDa=C4go`<c0c<3<`<co]kJg]_nf]kJgo`S/0_l01]bgg;OL]`;o
00KLk=c/g?l6g0?o4iD2o`05LMiagW400_l3L@?o6e/00h5KF`0/F`03PE]K02QK0@0002IK00GoFe]K
P@0QF`03PE]K00eK00?ok>`03n`03OoMLMeagG7MLMeaodd01D`02ol=c0g<3L`=c0g<00Ff00Co][Nf
0_l8k0;o00Jgk;O/]n`2o`05g>cLk=`00_l01]c/g>cLk0;o4iD01_magW7NL@Co7U/00h5KF`0/F`03
PE]K02QK0@0002IK00GoFe]KP@0QF`03PE]K00iK00?og=`03m`08_nEgIGMUMfEgOm=C4e<CDa=C?o<
`<c0c<3<`<c0okJg][L2o`04][Nfo`W/0_l01]bgg;OL]`;o00KLk=c/g>`2o`GL0_lBU@;o00?Nool0
8U/00h5KF`0/F`03PE]K02QK0@0002IK00GoFe]KP@0QF`03PE]K00mK00?ok>`03n`02?oMLMeagG7o
14d00om<C002C00=ol`=c0g<3L`=c0g<o`05]P04okNf]`;o2N`2o`06]nbgk;O/0ol01^cLk=c/g0;o
00CLk=c/0_lBU@03oe]K029K00>1Fe/0;5/00h5KF`0XF`40000VF`05oe]KFh408E/00h5KF`0@F`03
omcL00oL0_l09mfEgIGoC4e<CDa=C4e<COo0c<3<`<c0c<3<`<co]kJg]_nf]kJgo`0:k0;o00OL]mbg
g;OL00;o00K/g>cLk=`3o`?L0ol?U@03oe]K029K00>1Fe/0;5/00h5KF`0XF`40000VF`04oe]KPB9K
00>1Fe/04E/00oo/k00@k004og7Mo`I=00?oC4`00T`03ol=c0g<3L`=c0g<3L`=o`04]P;o00>f]kH0
0_l:k0;o00Ngk;O/]nbg00;o00O/g>cLk=c/00;o00C/g>cL0_l<U@03oe]K02=K00>1Fe/0;5/00h5K
F`0XF`40000VF`04oe]KPB9K00>1Fe/04U/00ooLg00@g00YomgoCDa=C4e<CDa=C4e<olc0c<3<`<c0
c<3<`<c0okJg][Oo]kJg]_l02n`2o`07g;OL]mbgg002o`07k=c/g>cLk003o`?L0_l:U@03oe]K02=K
00>1Fe/0;5/00h5KF`0XF`40000VF`04oe]KPB9K00>1Fe/04e/00oo/k00@k003ode=00M=14`04?o<
3L`=c0g<3L`=c0g<3L`2o`>f0_l00kNf]`02o`_/0_l01kO/]nbgk;L00ol01mc/g>cLk=`00ol01>cL
ool7U@03oe]K02AK00>1Fe/0;5/00h5KF`0XF`40000VF`04oe]KPB9K00>1Fe/055/00ooLg00?g00[
oda=C4e<CDa=C?m<CDa=ol3<`<c0c<3<`<c0c<3<`<co]kJg]_nf]kJgo`0<k0;o00SL]mbgg;OL]`;o
00SLk=c/g>cLk0;o0]`3o`>E00?oFe/09E/00h5KF`0/F`03PE]K02QK0@00011K00?oFe/00U/4o`9K
1?l6F`>100=KPE/08E/00h5KF`0EF`03onc/00k/00?oCDd024d5C00Aol`=c0g<3L`=c0g<3L`=c0d0
0_l3]P05okNf]kH00_l<k0;o00Rgk;O/]nbgk0;o00SLk=c/g>cLk0?o00KLk?ooUOlWF`03PE]K02aK
00>1Fe/0:5/1000045/01OmKFe_o00AK0_l4F`03oe]K00=K00?oFe/0184PF`03PE]K01IK00?og=`0
3=`0:?m=CDe<CDa=C4e<COm=C4e<olc0c<3<`<c0c<3<`<c0c<3<`?nf]kH2o`05]kJg]_l03N`2o`08
g;OL]mbgg;L2o`08g>cLk=c/g>`6obQK00>1Fe/0;5/00h5KF`0XF`40000@F`05oe]KFol015/2o`AK
00?oFe/00e/01OmKFe^1009K184LF`03PE]K01MK00?ok>`02n`00omVIP0:C@E<01?o3L`=c0g<3L`=
c0g<3L`=c0g<00;o0kH01Onf]kJg00;o3N`2o`08]nbgk;O/]n`3o`05k=c/g?l00e/00h5KF`0XF`03
PE]K02aK00>1Fe/0:5/1000045/01OmKFe_o00AK0_l4F`03oe]K00=K00GoFe]KP@06F`B165/00h5K
F`0HF`03omcL00[L02_oCDe=C4e<CDa=C4e<oda=C4go`<c0c<3<`<c0c<3<`<c0c<3<`<co]kJg00;o
00Ff]kJgo`0>k0;o00WL]mbgg;OL]m`00_l00ncoF`03F`03PE]K02QK00>1Fe/0;5/00h5KF`0XF`40
000@F`05oe]KFol015/2o`AK00?oFe/00e/01OmKFe^100YK184CF`03PE]K01YK00?ok>`02N`01OmV
IVKo00U=1D`05_o<3L`=c0g<3L`=c0g<3L`=c0g<3Ol4]P05okNf]kH00_l>k0;o00Rgk;O/]nbgk0;o
1E/00h5KF`0XF`03PE]K02aK00>1Fe/0:5/1000045/01OmKFe_o00AK0_l4F`03oe]K00=K00GoFe]K
P@0>F`B13e/00h5KF`0KF`03omcL00OL00?oCDd014d08da=C4e<CDa=ode<CDcoc<3<`<c0c<3<`<c0
c<3<`<c0c<3<00;o00Zf]kKo][Nf]kKo3n`2o`04g;OL]`;o1e/00h5KF`0XF`03PE]K02aK00>1Fe/0
:5/100003U/3o`=K00?oFe/00U/2o`AK00?oFe/00e/01OmKFe^1019K184;F`03PE]K01]K00>1on`0
1n`00omVIP04IPU=00?oC4`00T`06?l=c0g<3L`=c0g<3L`=c0g<3L`=c0g<o`>f0_l01;Jg][L2o`o/
0_l00kOoF`08F`03PE]K02QK00>1Fe/0;E/00h5KF`0WF`40000@F`05oe]KFol015/2o`AK00?oFe/0
0e/01OmKFe^101IK1H46F`03PE]K01]K00>1Fol01m`00om=C@04C@0Vode<CDa=C4e<oda=C4go`<c0
c<3<`<c0c<3<`<c0c<3<`<c0c<02o`0:]kJgokNf]kJgoa3/00?oFe/025/00h5KF`0XF`03PE]K02eK
00>1Fe/09e/1000045/00omKF`02F`Co0U/4o`IK00GoFe]KP@0KF`B10U/00h5KF`0KF`04PE]Ko`G/
00?oIVH01VH9C@03oda<009<01[oc0g<3L`=c0g<3L`=c0g<3L`=c0g<3L`=o`>f0_l01;Nf]kH2o`k/
00?oFe/025/00h5KF`0XF`03PE]K02eK00>1Fe/09e/100009E/01OmKFe^101mK184LF`05PE]KFol0
1=`00om=C@06C@0Xoda=C4e<CDa=ode<CDcoc<3<`<c0c<3<`<c0c<3<`<c0c<3<`<c0c0;o00Zf]kKo
][Nf]kKo3>`00omKF`09F`03PE]K02QK00>1Fe/0;E/00h5KF`0WF`40000UF`05oe]KFh408E/00h5K
P@03PAMK00>1Fe/00e/01Oo/k>co00UV00?oCDd01Td00om<C002C00Lo`g<3L`=c0g<3L`=c0g<3L`=
c0g<3L`=c0g<o`>f00Ko]kJg][L2o`[/00?oFe/02E/00h5KF`0XF`03PE]K02eK00>1Fe/09e/10000
9E/01OmKFe^1025K00>1Fe/00e/4PA=K00>1Fe/015/01?oLg?l;C@0XC4e<CDa=C4goCDa=ol3<`<c0
c<3<`<c0c<3<`<c0c<3<`<c0c<3<`0;o00Zg]_oo]kJg][Oo2>`00omKF`0:F`03PE]K02QK00>1Fe/0
;E/00h5KF`0WF`40000UF`04oe]KPB9K00>1Fe/01e/4P@mK00>1Fe/01E/2o`]V00?oCDd01Td00om<
C002C00Nol`=c0g<3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0go0kH01_nf]kJg]P;o1^`00omKF`0:F`03
PE]K02UK00>1Fe/0;5/00h5KF`0WF`40000UF`04oe]KPB9K00>1Fe/02e/4P@]K00>1Fe/01U/00om=
C@0:C@0_ode<CDa=C4e<oda=C?o<`<c0c<3<`<c0c<3<`<c0c<3<`<c0c<3<`<c0c?ng][L00_l01[Jg
][Nfo`G/00?oFe/02U/00h5KF`0YF`03PE]K02aK00>1Fe/09e/100009E/01?mKFh4RF`03PE]K00mK
1847F`03PE]K00IK3FH00om=C@06C@03oda<009<01ko3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0g<3L`=
c0d2o`>f00Ko]kJg][L2o`;/00?oFe/02e/00h5KF`0YF`03PE]K02aK00>1Fe/09e/100009E/01?mK
Fh4RF`03PE]K01=K1843F`03PE]K00MK3Dd0>om<CDa=C4e<COm=C4go`<c0c<3<`<c0c<3<`<c0c<3<
`<c0c<3<`<c0c<3<`?nf]kKo][Nf]kJgonco00eK00>1Fe/0:E/00h5KF`0/F`03PE]K02MK0@0002AK
0ol00e^1F`0QF`03PE]K01MK184:F`eV00?oCDd01Dd00om<C002C00Pol`=c0g<3L`=c0g<3L`=c0g<
3L`=c0g<3L`=c0g<3L`2o`:f0_l01;Jg][L2o`iK00>1Fe/0:E/00h5KF`0/F`03PE]K01EK1h4;F`40
000TF`05oe]KFh408U/00h5KF`0JF`F11e/<C@0eode<CDa=C4e<oda=C?o<`<c0c<3<`<c0c<3<`<c0
c<3<`<c0c<3<`<c0c<3<`<co]kJgokL00_l@F`03PE]K02UK00>1Fe/0;5/00h5KF`08F`f14U/10000
95/01OmKFe^1029K00>1Fe/06U/00h5KF`02F`B10e/00omVIP0:IP03ode=00E=00?oC4`00T`08_l=
c0g<3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0d5oa9K00>1Fe/0:E/00h5KF`0ZF`f17e/10000
95/01OmKFe^1029K00>1Fe/06U/00h5KF`06F`B100?oCDd02Td0;om=C4e<CDa=ode<COo0c<3<`<c0
c<3<`<c0c<3<`<c0c<3<`<c0c<3<`<c0c<3o01IK00>1Fe/0:E/00h5KF`0NF`b10U/00h5KF`0WF`40
000TF`05oe]KFh408U/00h5KF`0JF`03PE]K00YK00>1IVH02VH00om=C@05C@03oda<009<02;oc0g<
3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0go5U/00h5KF`0YF`03PE]K015K3H4>F`03PE]K02MK
0@0002AK00GoFe]KP@0RF`03PE]K01YK00>1Fe/035/<C@0^oda=C4e<CDcoC4e<COo0c<3<`<c0c<3<
`<c0c<3<`<c0c<3<`<c0c<3<`<c0oaIK00>1Fe/0:E/00h5KF`04F`f16e/00h5KF`0WF`40000TF`05
oe]KFh408U/00h5KF`0JF`03PE]K00aK00?oIVH02FH00om=C@05C@03oda<009<027o3L`=c0g<3L`=
c0g<3L`=c0g<3L`=c0g<3L`=c0g<3Ol05U/00h5KF`0SF`f1:5/00h5KF`0WF`40000TF`05oe]KFh40
8U/00h5KF`0JF`03PE]K00eK00?oCDd02Dd0;Om=C4e<CDa=ode<CDcoc<3<`<c0c<3<`<c0c<3<`<c0
c<3<`<c0c<3<`<c0o`0FF`03PE]K01MK3846F`03PE]K02aK00>1Fe/09e/1000095/01OmKFe^1025K
00>1Fe/06e/00h5KF`0>F`03ofIV00UV00?oCDd014d00om<C002C00Pol`=c0g<3L`=c0g<3L`=c0g<
3L`=c0g<3L`=c0g<3OlFF`03PE]K00YK3H4BF`03PE]K02aK00>1Fe/09e/1000095/01OmKFe^1025K
00>1Fe/06e/00h5KF`0?F`]=02coC4e<CDa=C?m<CDa=ol3<`<c0c<3<`<c0c<3<`<c0c<3<`<c0c<3<
`<c0oaIK3H4OF`03PE]K02aK00>1Fe/09e/1000095/01OmKFe^1025K00>1Fe/06e/00h5KF`0?F`03
ofIV00UV00?oCDd01Dd08_m<C4co3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0g<3L`=c?l;F`f1:e/00h5K
F`0]F`03PE]K02IK0@0002AK00GoFe]KP@0QF`03PE]K01]K00>1Fe/045/00om=C@08C@0Zode<CDa=
C4goCDa=C?o<`<c0c<3<`<c0c<3<`<c0c<3<`<c0c<3<`<co2h4<F`03PE]K02UK00>1Fe/0;E/00h5K
F`0VF`40000TF`05oe]KFh408E/00h5KF`0KF`03PE]K015K00?oIVH026H00om=C@05C@0Qoda<C?o<
3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0g<3Lco01MK00>1Fe/0:E/00h5KF`0]F`03PE]K02IK0@0002AK
00CoFe^18U/00h5KF`0KF`03PE]K019K00?oCDd024d0:?m=C4e<CDcoC4e<COo0c<3<`<c0c<3<`<c0
c<3<`<c0c<3<`<c0c?lGF`03PE]K02UK00>1Fe/0;E/00h5KF`0VF`40000TF`04oe]KPB9K00>1Fe/0
6e/00h5KF`0BF`03ofIV00QV00?oCDd01Dd08?m<C4co3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0g<3Lco
5e/00h5KF`0YF`03PE]K02eK00>1Fe/09U/100008e/01OmKFe^1029K00>1Fe/06e/00h5KF`0CF`03
ode=00Q=02OoC4e<CDa=ode<CDcoc<3<`<c0c<3<`<c0c<3<`<c0c<3<`<c0c?l05e/00h5KF`0YF`03
PE]K02eK00>1Fe/09U/100008e/3o`03Fh5K025K00>1Fe/06e/00h5KF`0DF`03ofIV00MV00?oCDd0
1Dd07om<C4coc0g<3L`=c0g<3L`=c0g<3L`=c0g<3L`=c?l05e/00h5KF`0YF`03PE]K02eK00>1Fe/0
9U/100008e/01OmKFe^1029K00>1Fe/06e/00h5KF`0DF`03ode=00Q=02KoCDa=C4e<oda=C4go`<c0
c<3<`<c0c<3<`<c0c<3<`<c0c<3<oaMK00>1Fe/0:E/00h5KF`0]F`03PE]K02IK0@0002=K00GoFe]K
P@0RF`03PE]K01]K00>1Fe/05E/00omVIP08IP03ode=00A=01koC4a<o`g<3L`=c0g<3L`=c0g<3L`=
c0g<3L`=c?lGF`03PE]K02UK00>1Fe/0;E/00h5KF`0VF`40000SF`05oe]KFh408U/00h5KF`0KF`03
PE]K01IK00?oCDd01dd09Om<CDa=C4goCDa=C?o<`<c0c<3<`<c0c<3<`<c0c<3<`<c0c?l05e/00h5K
F`0YF`03PE]K02eK00>1Fe/09U/100008e/01OmKFe^1029K00>1Fe/06e/00h5KF`0GF`03ofIV00MV
00?oCDd014d07Om<C4coc0g<3L`=c0g<3L`=c0g<3L`=c0g<3Lco01MK00>1Fe/0:E/00h5KF`0]F`03
PE]K02IK0@0002=K00GoFe]KP@0RF`03PE]K01YK00>1Fe/065/00om=C@08C@0Soda=C4e<oda=C4go
`<c0c<3<`<c0c<3<`<c0c<3<`<c0c?l05e/00h5KF`0YF`03PE]K02eK00>1Fe/09U/100008e/01OmK
Fe^1029K00>1Fe/06U/00h5KF`0HF`03POmV00QV00?oCDd014d07?m<C4co3L`=c0g<3L`=c0g<3L`=
c0g<3L`=c?lGF`03PE]K02UK00>1Fe/0;E/00h5KF`0VF`40000SF`05oe]KFh408U/00h5KF`0JF`03
PE]K01QK00>1Fol02Dd08_m=C4e<COm=C4e<olc0c<3<`<c0c<3<`<c0c<3<`<c0c?lGF`03PE]K02UK
00>1Fe/0;E/00h5KF`0VF`40000SF`05oe]KFh408U/00h5KF`0JF`03PE]K01QK00B1Fe_o26H00om=
C@04C@0Joda<C?o<3L`=c0g<3L`=c0g<3L`=c0g<3OlHF`03PE]K02UK00>1Fe/0;E/00h5KF`0VF`40
000SF`05oe]KFh408U/00h5KF`0JF`03PE]K01QK00B1Fe_o2Dd08?m<CDa=C4goCDa=ol3<`<c0c<3<
`<c0c<3<`<c0c<3o65/00h5KF`0YF`03PE]K02eK00>1Fe/09U/100008e/01OmKFe^1029K00>1Fe/0
6U/00h5KF`0HF`05PE]KFol02FH00om=C@03C@0Ioda<C?l=c0g<3L`=c0g<3L`=c0g<3L`=o`0HF`03
PE]K02UK00>1Fe/0;E/00h5KF`0VF`40000SF`05oe]KFh408U/00h5KF`0JF`03PE]K01QK00>1Fe/0
0U/00om=C@06C@0Oode<CDa=C?m<CDcoc<3<`<c0c<3<`<c0c<3<`<c0o`0HF`03PE]K02UK00>1Fe/0
;E/00h5KF`0VF`40000SF`05oe]KFh408E/00h5KF`0KF`03PE]K01QK00>1Fe/00e/00omVIP06IP03
ode=00==00?oC4`00T`04ol=c0g<3L`=c0g<3L`=c0g<3Ol065/00h5KF`0YF`03PE]K02eK00>1Fe/0
9U/100008e/01?mKFh4RF`03PE]K01]K00>1Fe/065/00h5KF`03F`03ode=00I=01koC4e<CDa=ode<
COo0c<3<`<c0c<3<`<c0c<3<`?lHF`03PE]K02UK00>1Fe/0;E/00h5KF`0VF`40000RF`05oe]KFh40
8U/00h5KF`0KF`03PE]K01QK00>1Fe/015/00omVIP06IP03ode=00==00?oC4`00T`04_o<3L`=c0g<
3L`=c0g<3L`=oaQK00>1Fe/0:E/00h5KF`0^F`03PE]K02EK0@00029K00GoFe]KP@0RF`03PE]K01]K
00>1Fe/065/00h5KF`05F`03ode=00I=01coC4e<CDcoC4e<olc0c<3<`<c0c<3<`<c0c<3o65/00h5K
F`0YF`03PE]K02iK00>1Fe/09E/100008U/01OmKFe^1029K00>1Fe/06e/00h5KF`0HF`03PE]K00IK
00?oIVH01FH00om=C@03C@03oda<009<017o3L`=c0g<3L`=c0g<3L`=o`0HF`03PE]K02UK00>1Fe/0
;U/00h5KF`0UF`40000RF`;o0U/00h5KF`0PF`03PE]K01]K00>1Fe/065/00h5KF`06F`03ode=00I=
01_oCDa=C4goCDa=ol3<`<c0c<3<`<c0c<3<`?l065/00h5KF`0YF`03PE]K02iK00>1Fe/09E/10000
8U/01OmKFe^1029K00>1Fe/06e/00h5KF`0HF`03PE]K00MK00?oIVH01FH00om=C@03C@03oda<009<
013oc0g<3L`=c0g<3L`=c0go65/00h5KF`0YF`03PE]K02iK00>1Fe/09E/100008U/01OmKFe^1029K
00>1Fe/06e/00h5KF`0HF`03PE]K00QK00?oCDd01Dd06_m<CDa=C?m<CDcoc<3<`<c0c<3<`<c0c<3o
65/00h5KF`0YF`03PE]K02iK00>1Fe/09E/100008U/01OmKFe^1029K00>1Fe/06e/00h5KF`0HF`03
PE]K00UK00?oIVH01FH00om=C@02C@03oda<009<00oo3L`=c0g<3L`=c0g<3Ol065/00h5KF`0YF`03
PE]K02iK00>1Fe/09E/100008U/01OmKFe^1029K00>1Fe/06e/00h5KF`0HF`03PE]K00UK00?oCDd0
1Dd06Om=C4e<COm=C4go`<c0c<3<`<c0c<3<`?l065/00h5KF`0YF`03PE]K02iK00>1Fe/09E/10000
8U/01OmKFe^1029K00>1Fe/06e/00h5KF`0HF`03PE]K00YK00?oIVH01FH00om=C@03C@0Boda<C?o<
3L`=c0g<3L`=c0go65/00h5KF`0YF`03PE]K02iK00>1Fe/09E/100008U/01OmKFe^1029K00>1Fe/0
6e/00h5KF`0HF`03PE]K00]K00?oCDd014d05om<CDa=C?m<CDcoc<3<`<c0c<3<`<co01UK00>1Fe/0
:E/00h5KF`0^F`03PE]K02EK0@00029K00GoFe]KP@0RF`03PE]K01]K00>1Fe/05e/00h5KF`0=F`03
ofIV00AV00?oCDd00dd04?m<C4co3L`=c0g<3L`=c?lIF`03PE]K02YK00>1Fe/0;E/00h5KF`0UF`40
000RF`05oe]KFh408U/00h5KF`0KF`03PE]K01MK00>1Fe/03E/00om=C@05C@0Eoda=C4goCDa=ol3<
`<c0c<3<`<co01UK00>1Fe/0:U/00h5KF`0]F`03PE]K02EK0@00029K00GoFe]KP@0RF`03PE]K01]K
00>1Fe/05e/00h5KF`0>F`03ofIV00AV00?oCDd00dd03om<C4coc0g<3L`=c0g<o`0IF`03PE]K02YK
00>1Fe/0;E/00h5KF`0UF`40000RF`05oe]KFh408U/00h5KF`0KF`03PE]K01MK00>1Fe/03e/00om=
C@04C@0Dode<CDcoC4e<olc0c<3<`<c0c?lIF`03PE]K02YK00>1Fe/0;E/00h5KF`0UF`40000RF`05
oe]KFh408U/00h5KF`0KF`03PE]K01MK00>1Fe/045/00omVIP04IP03ode=009=00koC4a<o`g<3L`=
c0g<oaUK00>1Fe/0:U/00h5KF`0]F`03PE]K02EK0@00025K00GoFe]KP@0SF`03PE]K01]K00>1Fe/0
5e/00h5KF`0@F`03ode=00A=01?oC4e<COm=C4go`<c0c<3<`<co01UK00>1Fe/0:U/00h5KF`0]F`03
PE]K02EK0@00025K00GoFe]KP@0SF`03PE]K01]K00>1Fe/05e/00h5KF`0AF`03ofIV00AV00?oCDd0
0Td03Om<C4coc0g<3L`=c?l06E/00h5KF`0ZF`03PE]K02eK00>1Fe/09E/100008E/01OmKFe^1029K
00>1Fe/06e/00h5KF`0HF`03PE]K019K00?oCDd00dd04_m=C4e<oda=C?o<`<c0c<3<oaUK00>1Fe/0
:U/00h5KF`0]F`03PE]K02EK0@00025K00GoFe]KP@0RF`03PE]K01]K00>1Fe/065/00h5KF`0BF`03
ofIV00AV00?oCDd00Td03?m<C4co3L`=c0g<oaUK00>1Fe/0:U/00h5KF`0]F`03PE]K02EK0@00025K
0_l2F`03PE]K021K00>1Fe/06e/00h5KF`0HF`03PE]K01=K00?oCDd014d04?m=C4goCDa=C?o<`<c0
c?lIF`03PE]K02YK00>1Fe/0;E/00h5KF`0UF`40000QF`05oe]KFh408U/00h5KF`0KF`03PE]K01QK
00>1Fe/055/00omVIP03IP03ode=009=00_oC4a<ol`=c0g<o`0IF`03PE]K02YK00>1Fe/0;U/00h5K
F`0TF`40000QF`05oe]KFh408U/00h5KF`0KF`03PE]K01QK00>1Fe/055/00h7oC@04C@0?oda=C?m<
CDa=ol3<`<co01UK00>1Fe/0:U/00h5KF`0^F`03PE]K02AK0@00025K00GoFe]KP@0RF`03PE]K01]K
00>1Fe/065/00h5KF`0DF`03POmV00AV00?oCDd00Td02_m<C4co3L`=c?lIF`03PE]K02YK00>1Fe/0
;U/00h5KF`0TF`400018F`03PE]K01]K00>1Fe/065/00h5KF`0DF`03PE_o00E=00goCDa=C?m<CDco
c<3o01YK00>1Fe/0:U/00h5KF`0^F`03PE]K02AK0@0004QK00>1Fe/06e/00h5KF`0HF`03PE]K01AK
00B1Fe_o1FH01Om=CDgo00=<00Coc0go6U/00h5KF`0ZF`03PE]K02iK00>1Fe/095/10000B5/00h5K
F`0KF`03PE]K01QK00>1Fe/055/01H5KFe_o00A=00coC4e<COm=C4go`?lJF`03PE]K02YK00>1Fe/0
;U/00h5KF`0TF`400018F`03PE]K01]K00>1Fe/065/00h5KF`0DF`05PE]KFol01FH01Om=CDgo00=<
00?o3Ol06U/00h5KF`0ZF`03PE]K02iK00>1Fe/095/10000IU/00h5KF`0HF`03PE]K01AK00>1Fe/0
0U/00om=C@02C@09ode<CDcoC4e<00;o6U/00h5KF`0ZF`03PE]K02iK00>1Fe/095/10000IU/00h5K
F`0HF`03PE]K01AK00>1Fe/00e/00omVIP02IP05ode=COl00d`2oaYK00>1Fe/0:U/00h5KF`0^F`03
PE]K02AK0@0006IK00>1Fe/065/00h5KF`0DF`03PE]K00=K00>1ool03?lJF`03PE]K02YK00>1Fe/0
;U/00h5KF`0TF`400021F`03PE]K01AK00>1Fe/00e/00h5KF`0VF`03PE]K02YK00>1Fe/0EE/10000
PE/00h5KF`0DF`03PE]K00=K00>1Fe/09U/00h5KF`0ZF`03PE]K05EK0@0009QK00>1Fe/00e/00h5K
F`0VF`03PE]K089K0@0009QK00>1Fe/00e/00h5KF`2[F`40002HF`03PE]K00=K00>1Fe/0Ze/10000
oe]=F`40003oFdeK0@000?mKCE/10000oe]=F`40003oFdeK0@000?mKCE/10000oe]=F`40003oFdeK
0@000?mKCE/10000oe]=F`40003oFdeK0@000=YK0_m`F`40003KF`;o0e/00omKF`1YF`40003LF`;o
0e/00omKF`1XF`40001DF`Go0e/3o`9K0_l4F`?o00=Kool00_l3F`Go1E/2o`EK0_l2F`Go0U/2o`9K
1?l3F`Co0e/4o`9K1?l3F`Co1U/2o`=K0_l00e_oo`02F`Co0e/3o`9K0ol2F`;o1E/3o`9K0_l7F`Co
00=Koe/01?l2F`;o0U/2o`9K0_l7F`;o0e/4ocaK0@0005=K0_l3F`;o00AKoomK0_l00e_oo`04F`;o
00=Kool00U/2o`03Fooo009K0_l5F`;o1E/2o`9K0_l00e_oo`02F`;o00=Kool00U/2o`03Fooo009K
0_l00e_oo`02F`Co0U/2o`03Fooo009K0_l5F`;o0e/2o`04FoooF`;o0U/2o`9K0_l2F`;o00AKoomK
0_l5F`?o0U/2o`IK0_l2F`Go0U/2o`03Fooo009K0_l2F`;o1e/2o`9K0_l2F`;o>e/10000De/2o`=K
1?l3F`Co15/2o`03Fooo00EK0_l2F`;o1E/2o`EK0_l2F`;o00=Kool00U/2o`03Fooo00QK0ol4F`Go
25/3o`EK0_l3F`;o00=Kool015/3o`9K0_l00e_oo`03F`Co15/2o`03Fooo00QK0_l4F`Co1E/2o`9K
0_l8F`Ko00=Kool00U/2oc]K0@0005MK1Ol3F`Co15/2o`03Fooo00Co00=Kool00U/2o`EK0_l5F`;o
0U/2o`03Fooo009K0_l00e_oo`04o`9K1?l3F`Co00=Kool01?l2F`Co1U/2o`=K0_l00e_oo`02F`Co
0e/2o`03Fooo00=K1?l4F`;o00=Kool025/2o`AK2?l00e_oo`02F`;o25/00omKF`02o`9K0_l2F`;o
>e/10000E5/5o`03Fooo00=K1?l4F`;o00=Kool00U/2o`03Fooo009K0_l5F`Go0U/2o`9K0_l00e_o
o`02F`;o00=Kool00U/2o`04Foooo`AK0ol3F`;o0U/2o`04Foooo`QK0_l3F`;o00AKoomK0ol5F`;o
00=Kool00e/4o`AK0_l00e_oo`08F`;o0U/6o`9K0_l00e_oo`02F`;o2E/01?mKool2F`;o0U/2oc]K
0@0005=K0ol5F`;o00AKoomK0ol3F`;o00=Kool00U/2o`03Fooo009K0_l5F`;o1E/2o`9K0_l00e_o
o`02F`;o00=Kool00U/2o`03Fooo009K0_l00e_oo`02F`Co0U/2o`03Fooo009K0_l5F`Oo00AKoomK
0_l2F`;o0U/2o`9K0_l015_ooe/3o`=K0_l00e_oo`08F`;o1U/2o`9K0_l00e_oo`02F`;o2E/01?mK
ool2F`;o0U/2oc]K0@0005=K0_l3F`;o0U/3o`9K0ol2F`Co00=Kool00_l3F`Go1E/2o`EK0_l00e_o
o`07o`=K1?l3F`Co0e/4o`9K1?l3F`Co1U/2o`=K0_l00e_oo`02F`Co0U/4o`9K0ol2F`?o0U/2o`=K
0_l7F`;o15/2o`03Fooo00;o0U/5o`]K0ol2F`;o0U/2oc]K0@0005=K0_l3F`;o3E/2o`aK0_l5F`;o
2E/2obiK0_l3F`;o35/2oaaK0_l2F`;o65/3o`9K0_l2F`;o>e/10000E5/5o`iK0_l<F`;o1E/6o`03
Fooo009K0_l^F`;o0e/2o`03Fooo00UK0_lMF`Co6U/2o`=K1?llF`40003oFdeK0@000?mKCE/10000
oe]=F`40003oFdeK0@000001\
\>"],
  ImageRangeCache->{{{0, 332}, {316, 0}} -> {-0.0772134, -0.0389858, 
  0.00305339, 0.00305339}}],

Cell[TextData[
"visualizeExpressions::fitnessesInfo: \n   Fitnesses: {176, 70, 40, 62, 26, \
84, 86, 50, 66, <<21>>, 34, 26, 176, \n     36, 36}"], "Message",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[
"visualizeExpressions::fitnessMax: Max. Fitness: 176"], "Message",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.0238095 0.952381 0.0147151 0.588604 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
% Start of sub-graphic
p
0.0238095 0.0147151 0.97619 0.603319 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.136054 0.0169173 0.136054 [
p
/Times findfont 14 scalefont setfont
[(Gen. 40)] .5 .71053 0 -2 Msboxa
P
[ 0 0 0 0 ]
[ 1 .71053 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
p
/Times findfont 14 scalefont setfont
[(Gen. 40)] .5 .71053 0 -2 Mshowa
P
P
0 0 m
1 0 L
1 .71053 L
0 .71053 L
closepath
clip
newpath
p
p
% Start of sub-graphic
p
0.0238095 0.0169173 0.149123 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.758303 2.5909 0.0163524 0.959656 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.86163 .35897 m
.76153 .3126 L
s
P
p
0 .4 1 r
.02 w
.86757 .42348 m
.86163 .35897 L
s
P
p
0 .4 1 r
.02 w
.76573 .3777 m
.86757 .42348 L
s
P
p
0 .4 1 r
.02 w
.76153 .3126 m
.76573 .3777 L
s
P
p
0 .4 1 r
.02 w
.76573 .3777 m
.65922 .32981 L
s
P
p
0 .4 1 r
.02 w
.65693 .26414 m
.65922 .32981 L
s
P
p
0 .4 1 r
.02 w
.5475 .21345 m
.65693 .26414 L
s
P
p
0 .4 1 r
.02 w
.65922 .32981 m
.6616 .39803 L
s
P
p
0 .4 1 r
.02 w
.5477 .27966 m
.5475 .21345 L
s
P
p
.2 1 0 r
.02 w
.86547 .63433 m
.75767 .59089 L
s
P
p
.2 1 0 r
.02 w
.87194 .70928 m
.86547 .63433 L
s
P
p
.2 1 0 r
.02 w
.75339 .51794 m
.64249 .47155 L
s
P
p
.2 1 0 r
.02 w
.75767 .59089 m
.75339 .51794 L
s
P
p
0 .4 1 r
.02 w
.6616 .39803 m
.66408 .46898 L
s
P
p
0 .4 1 r
.02 w
.54792 .34853 m
.5477 .27966 L
s
P
p
.2 1 0 r
.02 w
.76212 .66678 m
.87194 .70928 L
s
P
p
.2 1 0 r
.02 w
.64249 .47155 m
.64463 .54533 L
s
P
p
0 .4 1 r
.02 w
.66408 .46898 m
.66666 .5428 L
s
P
p
.2 1 0 r
.02 w
.52639 .35127 m
.40675 .29947 L
s
P
p
.2 1 0 r
.02 w
.52617 .4229 m
.52639 .35127 L
s
P
p
0 .4 1 r
.02 w
.54813 .4202 m
.54792 .34853 L
s
P
p
.2 1 0 r
.02 w
.64685 .62217 m
.76212 .66678 L
s
P
p
.2 1 0 r
.02 w
.64463 .54533 m
.52594 .49751 L
s
P
p
0 .4 1 r
.02 w
.66666 .5428 m
.54836 .49485 L
s
P
p
.2 1 0 r
.02 w
.52594 .49751 m
.52617 .4229 L
s
P
p
0 .4 1 r
.02 w
.54813 .4202 m
.42637 .36897 L
s
P
p
0 .4 1 r
.02 w
.54836 .49485 m
.54813 .4202 L
s
P
p
.2 1 0 r
.02 w
.40675 .29947 m
.40403 .37181 L
s
P
p
.2 1 0 r
.02 w
.76676 .7458 m
.64917 .70225 L
s
P
p
.2 1 0 r
.02 w
.77159 .82814 m
.76676 .7458 L
s
P
p
.2 1 0 r
.02 w
.64917 .70225 m
.64685 .62217 L
s
P
p
.2 1 0 r
.02 w
.40403 .37181 m
.27561 .31809 L
s
P
p
0 .4 1 r
.02 w
.42637 .36897 m
.29835 .31511 L
s
P
p
0 .4 1 r
.02 w
.42401 .44444 m
.42637 .36897 L
s
P
p
.2 1 0 r
.02 w
.65159 .78579 m
.77159 .82814 L
s
P
p
.2 1 0 r
.02 w
.40119 .44724 m
.39823 .52595 L
s
P
p
.2 1 0 r
.02 w
.26989 .39433 m
.40119 .44724 L
s
P
p
0 .4 1 r
.02 w
.29312 .39138 m
.42401 .44444 L
s
P
p
.01 w
.27561 .31809 Mdot
P
p
.2 1 0 r
.02 w
.27561 .31809 m
.26989 .39433 L
s
P
p
.01 w
.29835 .31511 Mdot
P
p
0 .4 1 r
.02 w
.29835 .31511 m
.29312 .39138 L
s
P
p
.2 1 0 r
.02 w
.65411 .87301 m
.65159 .78579 L
s
P
p
.2 1 0 r
.02 w
.52546 .65643 m
.5252 .74118 L
s
P
p
.2 1 0 r
.02 w
.39514 .60817 m
.52546 .65643 L
s
P
p
.2 1 0 r
.02 w
.39823 .52595 m
.26391 .47397 L
s
P
p
.2 1 0 r
.02 w
.52493 .82976 m
.65411 .87301 L
s
P
p
.2 1 0 r
.02 w
.5252 .74118 m
.52493 .82976 L
s
P
p
.2 1 0 r
.02 w
.3919 .69413 m
.39514 .60817 L
s
P
p
.2 1 0 r
.02 w
.26391 .47397 m
.12219 .41912 L
s
P
p
.2 1 0 r
.02 w
.25112 .64444 m
.3919 .69413 L
s
P
p
.2 1 0 r
.02 w
.25766 .55725 m
.25112 .64444 L
s
P
p
.2 1 0 r
.02 w
.11243 .50347 m
.25766 .55725 L
s
P
p
.2 1 0 r
.02 w
.12219 .41912 m
.11243 .50347 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.0169173 0.286967 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.498191 2.097 0.0245059 0.980236 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87882 .61174 m
.78846 .56381 L
s
P
p
.2 1 0 r
.02 w
.88591 .6918 m
.87882 .61174 L
s
P
p
.2 1 0 r
.02 w
.7834 .48613 m
.69015 .43471 L
s
P
p
.2 1 0 r
.02 w
.78846 .56381 m
.7834 .48613 L
s
P
p
.2 1 0 r
.02 w
.79374 .64494 m
.88591 .6918 L
s
P
p
.2 1 0 r
.02 w
.69015 .43471 m
.69327 .51333 L
s
P
p
.2 1 0 r
.02 w
.59099 .30448 m
.48962 .24655 L
s
P
p
.2 1 0 r
.02 w
.5919 .38054 m
.59099 .30448 L
s
P
p
.2 1 0 r
.02 w
.69652 .59553 m
.79374 .64494 L
s
P
p
.2 1 0 r
.02 w
.69327 .51333 m
.59285 .46007 L
s
P
p
.2 1 0 r
.02 w
.59285 .46007 m
.5919 .38054 L
s
P
p
.2 1 0 r
.02 w
.48962 .24655 m
.48822 .32337 L
s
P
p
0 .4 1 r
.02 w
.50847 .24332 m
.50751 .32019 L
s
P
p
0 .4 1 r
.02 w
.40185 .182 m
.50847 .24332 L
s
P
p
.2 1 0 r
.02 w
.79926 .72975 m
.69993 .68156 L
s
P
p
.2 1 0 r
.02 w
.80503 .8185 m
.79926 .72975 L
s
P
p
.2 1 0 r
.02 w
.69993 .68156 m
.69652 .59553 L
s
P
p
.2 1 0 r
.02 w
.48822 .32337 m
.37867 .26297 L
s
P
p
0 .4 1 r
.02 w
.50751 .32019 m
.39834 .2596 L
s
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.40185 .182 L
s
P
p
.2 1 0 r
.02 w
.7035 .77169 m
.80503 .8185 L
s
P
p
.2 1 0 r
.02 w
.48676 .40381 m
.48523 .48812 L
s
P
p
.2 1 0 r
.02 w
.37451 .34428 m
.48676 .40381 L
s
P
p
0 .4 1 r
.02 w
.5065 .40067 m
.50545 .48504 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.5065 .40067 L
s
P
p
.01 w
.37867 .26297 Mdot
P
p
.2 1 0 r
.02 w
.37867 .26297 m
.37451 .34428 L
s
P
p
.01 w
.39834 .2596 Mdot
P
p
0 .4 1 r
.02 w
.28278 .19546 m
.39834 .2596 L
s
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.28914 .11718 m
.28278 .19546 L
s
P
p
0 .4 1 r
.02 w
.16981 .04855 m
.28914 .11718 L
s
P
p
.2 1 0 r
.02 w
.70724 .86623 m
.7035 .77169 L
s
P
p
.2 1 0 r
.02 w
.59489 .63059 m
.59598 .72212 L
s
P
p
.2 1 0 r
.02 w
.48363 .5766 m
.59489 .63059 L
s
P
p
.2 1 0 r
.02 w
.48523 .48812 m
.37015 .42962 L
s
P
p
0 .4 1 r
.02 w
.50545 .48504 m
.39078 .42635 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.2761 .27766 L
s
P
p
0 .4 1 r
.02 w
.39078 .42635 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.28278 .19546 m
.16026 .12747 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.28278 .19546 L
s
P
p
.2 1 0 r
.02 w
.59713 .81827 m
.70724 .86623 L
s
P
p
0 .4 1 r
.02 w
.16026 .12747 m
.16981 .04855 L
s
P
p
.2 1 0 r
.02 w
.59598 .72212 m
.59713 .81827 L
s
P
p
.2 1 0 r
.02 w
.48194 .66955 m
.48363 .5766 L
s
P
p
.2 1 0 r
.02 w
.37015 .42962 m
.24801 .36753 L
s
P
p
0 .4 1 r
.02 w
.15022 .21045 m
.2761 .27766 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.26907 .36406 L
s
P
p
.2 1 0 r
.02 w
.36075 .61368 m
.48194 .66955 L
s
P
p
.2 1 0 r
.02 w
.36557 .51931 m
.36075 .61368 L
s
P
p
.2 1 0 r
.02 w
.24008 .45841 m
.36557 .51931 L
s
P
p
.2 1 0 r
.02 w
.24801 .36753 m
.24008 .45841 L
s
P
p
0 .4 1 r
.02 w
.26907 .36406 m
.13964 .29782 L
s
P
p
0 .4 1 r
.02 w
.13964 .29782 m
.15022 .21045 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.0169173 0.424812 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.0169173 0.562657 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.758303 2.5909 0.0163524 0.959656 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.65693 .26414 m
.65922 .32981 L
s
P
p
0 .4 1 r
.02 w
.5475 .21345 m
.65693 .26414 L
s
P
p
0 .4 1 r
.02 w
.65922 .32981 m
.5477 .27966 L
s
P
p
0 .4 1 r
.02 w
.5477 .27966 m
.5475 .21345 L
s
P
p
.2 1 0 r
.02 w
.86547 .63433 m
.75767 .59089 L
s
P
p
.2 1 0 r
.02 w
.87194 .70928 m
.86547 .63433 L
s
P
p
.2 1 0 r
.02 w
.75339 .51794 m
.64249 .47155 L
s
P
p
.2 1 0 r
.02 w
.75767 .59089 m
.75339 .51794 L
s
P
p
0 .4 1 r
.02 w
.5477 .27966 m
.54792 .34853 L
s
P
p
0 .4 1 r
.02 w
.43082 .22711 m
.5477 .27966 L
s
P
p
.2 1 0 r
.02 w
.76212 .66678 m
.87194 .70928 L
s
P
p
.2 1 0 r
.02 w
.64249 .47155 m
.64463 .54533 L
s
P
p
0 .4 1 r
.02 w
.66408 .46898 m
.66666 .5428 L
s
P
p
0 .4 1 r
.02 w
.54813 .4202 m
.66408 .46898 L
s
P
p
.2 1 0 r
.02 w
.52639 .35127 m
.40675 .29947 L
s
P
p
.2 1 0 r
.02 w
.52617 .4229 m
.52639 .35127 L
s
P
p
0 .4 1 r
.02 w
.54792 .34853 m
.54813 .4202 L
s
P
p
0 .4 1 r
.02 w
.30817 .17196 m
.43082 .22711 L
s
P
p
0 .4 1 r
.02 w
.31278 .10471 m
.30817 .17196 L
s
P
p
0 .4 1 r
.02 w
.1867 .04631 m
.31278 .10471 L
s
P
p
.2 1 0 r
.02 w
.64685 .62217 m
.76212 .66678 L
s
P
p
.2 1 0 r
.02 w
.64463 .54533 m
.52594 .49751 L
s
P
p
0 .4 1 r
.02 w
.66666 .5428 m
.54836 .49485 L
s
P
p
.2 1 0 r
.02 w
.52594 .49751 m
.52617 .4229 L
s
P
p
0 .4 1 r
.02 w
.54813 .4202 m
.42637 .36897 L
s
P
p
0 .4 1 r
.02 w
.54836 .49485 m
.54813 .4202 L
s
P
p
.2 1 0 r
.02 w
.40675 .29947 m
.40403 .37181 L
s
P
p
0 .4 1 r
.02 w
.30817 .17196 m
.17931 .11402 L
s
P
p
0 .4 1 r
.02 w
.30336 .24203 m
.30817 .17196 L
s
P
p
.2 1 0 r
.02 w
.76676 .7458 m
.64917 .70225 L
s
P
p
.2 1 0 r
.02 w
.77159 .82814 m
.76676 .7458 L
s
P
p
0 .4 1 r
.02 w
.17931 .11402 m
.1867 .04631 L
s
P
p
.2 1 0 r
.02 w
.64917 .70225 m
.64685 .62217 L
s
P
p
.2 1 0 r
.02 w
.40403 .37181 m
.27561 .31809 L
s
P
p
0 .4 1 r
.02 w
.42637 .36897 m
.29835 .31511 L
s
P
p
0 .4 1 r
.02 w
.29835 .31511 m
.30336 .24203 L
s
P
p
.2 1 0 r
.02 w
.65159 .78579 m
.77159 .82814 L
s
P
p
.2 1 0 r
.02 w
.40119 .44724 m
.39823 .52595 L
s
P
p
.2 1 0 r
.02 w
.26989 .39433 m
.40119 .44724 L
s
P
p
.01 w
.27561 .31809 Mdot
P
p
.2 1 0 r
.02 w
.27561 .31809 m
.26989 .39433 L
s
P
p
.01 w
.29835 .31511 Mdot
P
p
0 .4 1 r
.02 w
.16357 .2584 m
.29835 .31511 L
s
P
p
0 .4 1 r
.02 w
.29835 .31511 m
.29312 .39138 L
s
P
p
.2 1 0 r
.02 w
.65411 .87301 m
.65159 .78579 L
s
P
p
.2 1 0 r
.02 w
.52546 .65643 m
.5252 .74118 L
s
P
p
.2 1 0 r
.02 w
.39514 .60817 m
.52546 .65643 L
s
P
p
.2 1 0 r
.02 w
.39823 .52595 m
.26391 .47397 L
s
P
p
0 .4 1 r
.02 w
.29312 .39138 m
.15517 .33546 L
s
P
p
0 .4 1 r
.02 w
.15517 .33546 m
.16357 .2584 L
s
P
p
.2 1 0 r
.02 w
.52493 .82976 m
.65411 .87301 L
s
P
p
.2 1 0 r
.02 w
.5252 .74118 m
.52493 .82976 L
s
P
p
.2 1 0 r
.02 w
.3919 .69413 m
.39514 .60817 L
s
P
p
.2 1 0 r
.02 w
.26391 .47397 m
.12219 .41912 L
s
P
p
.2 1 0 r
.02 w
.25112 .64444 m
.3919 .69413 L
s
P
p
.2 1 0 r
.02 w
.25766 .55725 m
.25112 .64444 L
s
P
p
.2 1 0 r
.02 w
.11243 .50347 m
.25766 .55725 L
s
P
p
.2 1 0 r
.02 w
.12219 .41912 m
.11243 .50347 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.0169173 0.700501 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.0169173 0.838346 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.67141 .31411 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.0169173 0.97619 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.649333 2.38458 0.0238845 0.955379 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.77289 .40994 m
.66614 .35823 L
s
P
p
0 .4 1 r
.02 w
.7779 .48414 m
.77289 .40994 L
s
P
p
.2 1 0 r
.02 w
.86758 .61144 m
.76162 .56426 L
s
P
p
.2 1 0 r
.02 w
.87476 .6913 m
.86758 .61144 L
s
P
p
.2 1 0 r
.02 w
.75686 .48682 m
.64746 .43609 L
s
P
p
.2 1 0 r
.02 w
.76162 .56426 m
.75686 .48682 L
s
P
p
0 .4 1 r
.02 w
.6689 .43326 m
.7779 .48414 L
s
P
p
0 .4 1 r
.02 w
.66614 .35823 m
.6689 .43326 L
s
P
p
0 .4 1 r
.02 w
.55341 .23122 m
.43735 .17304 L
s
P
p
0 .4 1 r
.02 w
.55365 .30374 m
.55341 .23122 L
s
P
p
.2 1 0 r
.02 w
.76658 .64523 m
.87476 .6913 L
s
P
p
.2 1 0 r
.02 w
.64746 .43609 m
.64984 .5145 L
s
P
p
0 .4 1 r
.02 w
.6689 .43326 m
.55389 .37958 L
s
P
p
.2 1 0 r
.02 w
.53228 .30676 m
.41314 .24942 L
s
P
p
.2 1 0 r
.02 w
.53203 .38257 m
.53228 .30676 L
s
P
p
0 .4 1 r
.02 w
.55365 .30374 m
.55389 .37958 L
s
P
p
0 .4 1 r
.02 w
.43492 .24623 m
.55365 .30374 L
s
P
p
0 .4 1 r
.02 w
.43735 .17304 m
.43492 .24623 L
s
P
p
.2 1 0 r
.02 w
.65234 .59657 m
.76658 .64523 L
s
P
p
.2 1 0 r
.02 w
.64984 .5145 m
.53178 .46193 L
s
P
p
0 .4 1 r
.02 w
.67178 .51172 m
.55415 .459 L
s
P
p
0 .4 1 r
.02 w
.67479 .59386 m
.67178 .51172 L
s
P
p
.2 1 0 r
.02 w
.53178 .46193 m
.53203 .38257 L
s
P
p
0 .4 1 r
.02 w
.55389 .37958 m
.43237 .32286 L
s
P
p
0 .4 1 r
.02 w
.55415 .459 m
.55389 .37958 L
s
P
p
.2 1 0 r
.02 w
.41314 .24942 m
.41008 .32602 L
s
P
p
.2 1 0 r
.02 w
.77178 .72996 m
.65496 .68257 L
s
P
p
.2 1 0 r
.02 w
.77723 .81872 m
.77178 .72996 L
s
P
p
.2 1 0 r
.02 w
.65496 .68257 m
.65234 .59657 L
s
P
p
0 .4 1 r
.02 w
.55442 .54223 m
.67479 .59386 L
s
P
p
0 .4 1 r
.02 w
.55415 .459 m
.55442 .54223 L
s
P
p
.2 1 0 r
.02 w
.41008 .32602 m
.28102 .26618 L
s
P
p
0 .4 1 r
.02 w
.43237 .32286 m
.30375 .26284 L
s
P
p
0 .4 1 r
.02 w
.42969 .40321 m
.43237 .32286 L
s
P
p
.2 1 0 r
.02 w
.6577 .77278 m
.77723 .81872 L
s
P
p
.2 1 0 r
.02 w
.40687 .40632 m
.4035 .49059 L
s
P
p
.2 1 0 r
.02 w
.27451 .34738 m
.40687 .40632 L
s
P
p
0 .4 1 r
.02 w
.2978 .34409 m
.42969 .40321 L
s
P
p
.01 w
.28102 .26618 Mdot
P
p
.2 1 0 r
.02 w
.28102 .26618 m
.27451 .34738 L
s
P
p
.01 w
.30375 .26284 Mdot
P
p
0 .4 1 r
.02 w
.30375 .26284 m
.2978 .34409 L
s
P
p
.2 1 0 r
.02 w
.66058 .86753 m
.6577 .77278 L
s
P
p
.2 1 0 r
.02 w
.53123 .63238 m
.53093 .72406 L
s
P
p
.2 1 0 r
.02 w
.39996 .57913 m
.53123 .63238 L
s
P
p
.2 1 0 r
.02 w
.4035 .49059 m
.26766 .43273 L
s
P
p
.2 1 0 r
.02 w
.53062 .82049 m
.66058 .86753 L
s
P
p
.2 1 0 r
.02 w
.53093 .72406 m
.53062 .82049 L
s
P
p
.2 1 0 r
.02 w
.39624 .67229 m
.39996 .57913 L
s
P
p
.2 1 0 r
.02 w
.26766 .43273 m
.12324 .37122 L
s
P
p
.2 1 0 r
.02 w
.25286 .61718 m
.39624 .67229 L
s
P
p
.2 1 0 r
.02 w
.26046 .52254 m
.25286 .61718 L
s
P
p
.2 1 0 r
.02 w
.1119 .46228 m
.26046 .52254 L
s
P
p
.2 1 0 r
.02 w
.12324 .37122 m
.1119 .46228 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.154762 0.149123 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.758303 2.5909 0.0163524 0.959656 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.86757 .42348 m
.76573 .3777 L
s
P
p
0 .4 1 r
.02 w
.87372 .49041 m
.86757 .42348 L
s
P
p
0 .4 1 r
.02 w
.77009 .44528 m
.87372 .49041 L
s
P
p
0 .4 1 r
.02 w
.76573 .3777 m
.77009 .44528 L
s
P
p
0 .4 1 r
.02 w
.77009 .44528 m
.77462 .51548 L
s
P
p
0 .4 1 r
.02 w
.6616 .39803 m
.77009 .44528 L
s
P
p
0 .4 1 r
.02 w
.65922 .32981 m
.6616 .39803 L
s
P
p
0 .4 1 r
.02 w
.5477 .27966 m
.65922 .32981 L
s
P
p
0 .4 1 r
.02 w
.5475 .21345 m
.43291 .16036 L
s
P
p
0 .4 1 r
.02 w
.5477 .27966 m
.5475 .21345 L
s
P
p
.2 1 0 r
.02 w
.86547 .63433 m
.75767 .59089 L
s
P
p
.2 1 0 r
.02 w
.87194 .70928 m
.86547 .63433 L
s
P
p
.2 1 0 r
.02 w
.75339 .51794 m
.64249 .47155 L
s
P
p
.2 1 0 r
.02 w
.75767 .59089 m
.75339 .51794 L
s
P
p
0 .4 1 r
.02 w
.77462 .51548 m
.66408 .46898 L
s
P
p
0 .4 1 r
.02 w
.43082 .22711 m
.5477 .27966 L
s
P
p
0 .4 1 r
.02 w
.54792 .34853 m
.5477 .27966 L
s
P
p
0 .4 1 r
.02 w
.43291 .16036 m
.43082 .22711 L
s
P
p
.2 1 0 r
.02 w
.76212 .66678 m
.87194 .70928 L
s
P
p
0 .4 1 r
.02 w
.77932 .58848 m
.66666 .5428 L
s
P
p
0 .4 1 r
.02 w
.78422 .66442 m
.77932 .58848 L
s
P
p
.2 1 0 r
.02 w
.64249 .47155 m
.64463 .54533 L
s
P
p
0 .4 1 r
.02 w
.66408 .46898 m
.66666 .5428 L
s
P
p
.2 1 0 r
.02 w
.52639 .35127 m
.40675 .29947 L
s
P
p
.2 1 0 r
.02 w
.52617 .4229 m
.52639 .35127 L
s
P
p
0 .4 1 r
.02 w
.42864 .29659 m
.54792 .34853 L
s
P
p
.2 1 0 r
.02 w
.64685 .62217 m
.76212 .66678 L
s
P
p
0 .4 1 r
.02 w
.66934 .61969 m
.78422 .66442 L
s
P
p
.2 1 0 r
.02 w
.64463 .54533 m
.52594 .49751 L
s
P
p
0 .4 1 r
.02 w
.66666 .5428 m
.54836 .49485 L
s
P
p
0 .4 1 r
.02 w
.66666 .5428 m
.66934 .61969 L
s
P
p
.2 1 0 r
.02 w
.52594 .49751 m
.52617 .4229 L
s
P
p
0 .4 1 r
.02 w
.54813 .4202 m
.42637 .36897 L
s
P
p
0 .4 1 r
.02 w
.54836 .49485 m
.54813 .4202 L
s
P
p
.2 1 0 r
.02 w
.40675 .29947 m
.40403 .37181 L
s
P
p
0 .4 1 r
.02 w
.42637 .36897 m
.42864 .29659 L
s
P
p
.2 1 0 r
.02 w
.76676 .7458 m
.64917 .70225 L
s
P
p
.2 1 0 r
.02 w
.77159 .82814 m
.76676 .7458 L
s
P
p
.2 1 0 r
.02 w
.64917 .70225 m
.64685 .62217 L
s
P
p
.2 1 0 r
.02 w
.40403 .37181 m
.27561 .31809 L
s
P
p
0 .4 1 r
.02 w
.42637 .36897 m
.29835 .31511 L
s
P
p
0 .4 1 r
.02 w
.42401 .44444 m
.42637 .36897 L
s
P
p
.2 1 0 r
.02 w
.65159 .78579 m
.77159 .82814 L
s
P
p
.2 1 0 r
.02 w
.40119 .44724 m
.39823 .52595 L
s
P
p
.2 1 0 r
.02 w
.26989 .39433 m
.40119 .44724 L
s
P
p
0 .4 1 r
.02 w
.29312 .39138 m
.42401 .44444 L
s
P
p
.01 w
.27561 .31809 Mdot
P
p
.2 1 0 r
.02 w
.27561 .31809 m
.26989 .39433 L
s
P
p
.01 w
.29835 .31511 Mdot
P
p
0 .4 1 r
.02 w
.29835 .31511 m
.29312 .39138 L
s
P
p
.2 1 0 r
.02 w
.65411 .87301 m
.65159 .78579 L
s
P
p
.2 1 0 r
.02 w
.52546 .65643 m
.5252 .74118 L
s
P
p
.2 1 0 r
.02 w
.39514 .60817 m
.52546 .65643 L
s
P
p
.2 1 0 r
.02 w
.39823 .52595 m
.26391 .47397 L
s
P
p
.2 1 0 r
.02 w
.52493 .82976 m
.65411 .87301 L
s
P
p
.2 1 0 r
.02 w
.5252 .74118 m
.52493 .82976 L
s
P
p
.2 1 0 r
.02 w
.3919 .69413 m
.39514 .60817 L
s
P
p
.2 1 0 r
.02 w
.26391 .47397 m
.12219 .41912 L
s
P
p
.2 1 0 r
.02 w
.25112 .64444 m
.3919 .69413 L
s
P
p
.2 1 0 r
.02 w
.25766 .55725 m
.25112 .64444 L
s
P
p
.2 1 0 r
.02 w
.11243 .50347 m
.25766 .55725 L
s
P
p
.2 1 0 r
.02 w
.12219 .41912 m
.11243 .50347 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.154762 0.286967 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.43789 .35572 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43123 .54175 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.154762 0.424812 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.7753 .37106 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.67773 .47655 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.90676 .7578 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.154762 0.562657 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.67773 .47655 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.42759 .64327 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56304 .80672 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.29049 .47781 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.29049 .47781 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.139 .40899 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.12548 .51415 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.12548 .51415 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.154762 0.700501 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.247593 1.59439 0.0254887 1.01955 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.91969 .74949 m
.87916 .72074 L
s
P
p
.2 1 0 r
.02 w
.92298 .79949 m
.91969 .74949 L
s
P
p
.2 1 0 r
.02 w
.87625 .67135 m
.83518 .64171 L
s
P
p
.2 1 0 r
.02 w
.87916 .72074 m
.87625 .67135 L
s
P
p
.2 1 0 r
.02 w
.88212 .77102 m
.92298 .79949 L
s
P
p
.2 1 0 r
.02 w
.83518 .64171 m
.83775 .69137 L
s
P
p
.2 1 0 r
.02 w
.79104 .56239 m
.74853 .53119 L
s
P
p
.2 1 0 r
.02 w
.79322 .61143 m
.79104 .56239 L
s
P
p
.2 1 0 r
.02 w
.84037 .74193 m
.88212 .77102 L
s
P
p
.2 1 0 r
.02 w
.83775 .69137 m
.79544 .66135 L
s
P
p
.2 1 0 r
.02 w
.79544 .66135 m
.79322 .61143 L
s
P
p
.2 1 0 r
.02 w
.74853 .53119 m
.75034 .58048 L
s
P
p
.2 1 0 r
.02 w
.88514 .82222 m
.84303 .79342 L
s
P
p
.2 1 0 r
.02 w
.88821 .87435 m
.88514 .82222 L
s
P
p
.2 1 0 r
.02 w
.84303 .79342 m
.84037 .74193 L
s
P
p
.2 1 0 r
.02 w
.75034 .58048 m
.70652 .54885 L
s
P
p
.2 1 0 r
.02 w
.84575 .84586 m
.88821 .87435 L
s
P
p
.2 1 0 r
.02 w
.75219 .63067 m
.75407 .6818 L
s
P
p
.2 1 0 r
.02 w
.70798 .59931 m
.75219 .63067 L
s
P
p
.01 w
.70652 .54885 Mdot
P
p
.2 1 0 r
.02 w
.70652 .54885 m
.70798 .59931 L
s
P
p
.01 w
.71512 .54712 Mdot
P
p
0 .4 1 r
.02 w
.71512 .54712 m
.71666 .59759 L
s
P
p
.2 1 0 r
.02 w
.84852 .89929 m
.84575 .84586 L
s
P
p
.2 1 0 r
.02 w
.8 .76398 m
.80234 .81674 L
s
P
p
.2 1 0 r
.02 w
.75599 .73389 m
.8 .76398 L
s
P
p
.2 1 0 r
.02 w
.75407 .6818 m
.70946 .65072 L
s
P
p
0 .4 1 r
.02 w
.71666 .59759 m
.71823 .64902 L
s
P
p
.2 1 0 r
.02 w
.80473 .8705 m
.84852 .89929 L
s
P
p
.2 1 0 r
.02 w
.80234 .81674 m
.80473 .8705 L
s
P
p
.2 1 0 r
.02 w
.75794 .78696 m
.75599 .73389 L
s
P
p
.2 1 0 r
.02 w
.70946 .65072 m
.66384 .61893 L
s
P
p
0 .4 1 r
.02 w
.71823 .64902 m
.67268 .61719 L
s
P
p
0 .4 1 r
.02 w
.67152 .56548 m
.62534 .53263 L
s
P
p
0 .4 1 r
.02 w
.67268 .61719 m
.67152 .56548 L
s
P
p
.2 1 0 r
.02 w
.71253 .75649 m
.75794 .78696 L
s
P
p
.2 1 0 r
.02 w
.71098 .7031 m
.71253 .75649 L
s
P
p
.2 1 0 r
.02 w
.66494 .67161 m
.71098 .7031 L
s
P
p
.2 1 0 r
.02 w
.66384 .61893 m
.66494 .67161 L
s
P
p
0 .4 1 r
.02 w
.62534 .53263 m
.5781 .49903 L
s
P
p
0 .4 1 r
.02 w
.5781 .49903 m
.57838 .55129 L
s
P
p
0 .4 1 r
.02 w
.57838 .55129 m
.57866 .60459 L
s
P
p
0 .4 1 r
.02 w
.57866 .60459 m
.52936 .57077 L
s
P
p
0 .4 1 r
.02 w
.52956 .51718 m
.47957 .48225 L
s
P
p
0 .4 1 r
.02 w
.52936 .57077 m
.52956 .51718 L
s
P
p
0 .4 1 r
.02 w
.47957 .48225 m
.42837 .44648 L
s
P
p
0 .4 1 r
.02 w
.42837 .44648 m
.42714 .50066 L
s
P
p
0 .4 1 r
.02 w
.42714 .50066 m
.42588 .55595 L
s
P
p
0 .4 1 r
.02 w
.42588 .55595 m
.3723 .51991 L
s
P
p
0 .4 1 r
.02 w
.37413 .4643 m
.31979 .42703 L
s
P
p
0 .4 1 r
.02 w
.3723 .51991 m
.37413 .4643 L
s
P
p
0 .4 1 r
.02 w
.31979 .42703 m
.26408 .38882 L
s
P
p
0 .4 1 r
.02 w
.26408 .38882 m
.26102 .44504 L
s
P
p
0 .4 1 r
.02 w
.26102 .44504 m
.25791 .50249 L
s
P
p
0 .4 1 r
.02 w
.25791 .50249 m
.19943 .46392 L
s
P
p
0 .4 1 r
.02 w
.20322 .40615 m
.14389 .36624 L
s
P
p
0 .4 1 r
.02 w
.19943 .46392 m
.20322 .40615 L
s
P
p
0 .4 1 r
.02 w
.14389 .36624 m
.08298 .32526 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.154762 0.838346 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.154762 0.97619 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.16362 .21754 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
0 .4 1 r
.02 w
.16362 .21754 m
.15169 .31032 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.139 .40899 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.292607 0.149123 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.16362 .21754 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.29822 .38061 L
s
P
p
0 .4 1 r
.02 w
.16362 .21754 m
.15169 .31032 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.292607 0.286967 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.7753 .37106 m
.67141 .31411 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.7753 .37106 L
s
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
0 .4 1 r
.02 w
.67141 .31411 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.79284 .61791 L
s
P
p
0 .4 1 r
.02 w
.90676 .7578 m
.89777 .66825 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.90676 .7578 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.43465 .44607 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.292607 0.424812 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.292607 0.562657 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.292607 0.700501 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.516688 2.13426 0.0244391 0.977565 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.8137 .41303 m
.74415 .37372 L
s
P
p
0 .4 1 r
.02 w
.818 .46917 m
.8137 .41303 L
s
P
p
0 .4 1 r
.02 w
.82244 .52718 m
.818 .46917 L
s
P
p
0 .4 1 r
.02 w
.74415 .37372 m
.74738 .43032 L
s
P
p
0 .4 1 r
.02 w
.82703 .58714 m
.82244 .52718 L
s
P
p
0 .4 1 r
.02 w
.74738 .43032 m
.67387 .38989 L
s
P
p
0 .4 1 r
.02 w
.75416 .54939 m
.82703 .58714 L
s
P
p
0 .4 1 r
.02 w
.67387 .38989 m
.59731 .34778 L
s
P
p
0 .4 1 r
.02 w
.83177 .64916 m
.75773 .61205 L
s
P
p
0 .4 1 r
.02 w
.83669 .71334 m
.83177 .64916 L
s
P
p
0 .4 1 r
.02 w
.75773 .61205 m
.75416 .54939 L
s
P
p
.2 1 0 r
.02 w
.66132 .45114 m
.58324 .40962 L
s
P
p
.2 1 0 r
.02 w
.66327 .51222 m
.66132 .45114 L
s
P
p
.2 1 0 r
.02 w
.58267 .3501 m
.50263 .3063 L
s
P
p
.2 1 0 r
.02 w
.58324 .40962 m
.58267 .3501 L
s
P
p
0 .4 1 r
.02 w
.59731 .34778 m
.59814 .40732 L
s
P
p
0 .4 1 r
.02 w
.91509 .81393 m
.84177 .77981 L
s
P
p
0 .4 1 r
.02 w
.92155 .88194 m
.91509 .81393 L
s
P
p
0 .4 1 r
.02 w
.84177 .77981 m
.83669 .71334 L
s
P
p
.2 1 0 r
.02 w
.58382 .47128 m
.66327 .51222 L
s
P
p
0 .4 1 r
.02 w
.59814 .40732 m
.5169 .36392 L
s
P
p
.2 1 0 r
.02 w
.50263 .3063 m
.50177 .36631 L
s
P
p
0 .4 1 r
.02 w
.84704 .84868 m
.92155 .88194 L
s
P
p
0 .4 1 r
.02 w
.5175 .30387 m
.43422 .25806 L
s
P
p
0 .4 1 r
.02 w
.5169 .36392 m
.5175 .30387 L
s
P
p
.2 1 0 r
.02 w
.42146 .20224 m
.33589 .15411 L
s
P
p
.2 1 0 r
.02 w
.41913 .26059 m
.42146 .20224 L
s
P
p
.2 1 0 r
.02 w
.50088 .42853 m
.58382 .47128 L
s
P
p
.2 1 0 r
.02 w
.50177 .36631 m
.41671 .32109 L
s
P
p
.2 1 0 r
.02 w
.41671 .32109 m
.41913 .26059 L
s
P
p
0 .4 1 r
.02 w
.76923 .81394 m
.84704 .84868 L
s
P
p
0 .4 1 r
.02 w
.43422 .25806 m
.34724 .21022 L
s
P
p
.2 1 0 r
.02 w
.33589 .15411 m
.33192 .21286 L
s
P
p
.2 1 0 r
.02 w
.58443 .53518 m
.49996 .49307 L
s
P
p
.2 1 0 r
.02 w
.58507 .60147 m
.58443 .53518 L
s
P
p
.2 1 0 r
.02 w
.49996 .49307 m
.50088 .42853 L
s
P
p
.2 1 0 r
.02 w
.33192 .21286 m
.24076 .16297 L
s
P
p
0 .4 1 r
.02 w
.68788 .77763 m
.76923 .81394 L
s
P
p
0 .4 1 r
.02 w
.34724 .21022 m
.25631 .1602 L
s
P
p
0 .4 1 r
.02 w
.68533 .70701 m
.68788 .77763 L
s
P
p
0 .4 1 r
.02 w
.60176 .66812 m
.68533 .70701 L
s
P
p
.2 1 0 r
.02 w
.49899 .56007 m
.58507 .60147 L
s
P
p
.2 1 0 r
.02 w
.32781 .27383 m
.32354 .33714 L
s
P
p
.2 1 0 r
.02 w
.2348 .22438 m
.32781 .27383 L
s
P
p
0 .4 1 r
.02 w
.34341 .27121 m
.33944 .33455 L
s
P
p
0 .4 1 r
.02 w
.25064 .22164 m
.34341 .27121 L
s
P
p
.01 w
.24076 .16297 Mdot
P
p
.2 1 0 r
.02 w
.24076 .16297 m
.2348 .22438 L
s
P
p
.01 w
.25631 .1602 Mdot
P
p
0 .4 1 r
.02 w
.25631 .1602 m
.25064 .22164 L
s
P
p
0 .4 1 r
.02 w
.60276 .73963 m
.60176 .66812 L
s
P
p
.2 1 0 r
.02 w
.498 .62967 m
.49899 .56007 L
s
P
p
.2 1 0 r
.02 w
.4116 .44903 m
.4089 .51674 L
s
P
p
.2 1 0 r
.02 w
.3191 .40292 m
.4116 .44903 L
s
P
p
0 .4 1 r
.02 w
.42755 .44659 m
.42515 .51433 L
s
P
p
0 .4 1 r
.02 w
.3353 .40036 m
.42755 .44659 L
s
P
p
.2 1 0 r
.02 w
.32354 .33714 m
.2286 .28821 L
s
P
p
0 .4 1 r
.02 w
.33944 .33455 m
.3353 .40036 L
s
P
p
0 .4 1 r
.02 w
.51358 .69982 m
.60276 .73963 L
s
P
p
.2 1 0 r
.02 w
.40608 .58714 m
.498 .62967 L
s
P
p
.2 1 0 r
.02 w
.4089 .51674 m
.40608 .58714 L
s
P
p
0 .4 1 r
.02 w
.42515 .51433 m
.33101 .46881 L
s
P
p
.2 1 0 r
.02 w
.31449 .47133 m
.3191 .40292 L
s
P
p
.2 1 0 r
.02 w
.2286 .28821 m
.12908 .23693 L
s
P
p
0 .4 1 r
.02 w
.42006 .65807 m
.51358 .69982 L
s
P
p
.2 1 0 r
.02 w
.21545 .4237 m
.31449 .47133 L
s
P
p
0 .4 1 r
.02 w
.33101 .46881 m
.32653 .54004 L
s
P
p
.2 1 0 r
.02 w
.22216 .3546 m
.21545 .4237 L
s
P
p
.2 1 0 r
.02 w
.12043 .30389 m
.22216 .3546 L
s
P
p
.2 1 0 r
.02 w
.12908 .23693 m
.12043 .30389 L
s
P
p
0 .4 1 r
.02 w
.41736 .73441 m
.42006 .65807 L
s
P
p
0 .4 1 r
.02 w
.32653 .54004 m
.32188 .61424 L
s
P
p
0 .4 1 r
.02 w
.31702 .6916 m
.41736 .73441 L
s
P
p
0 .4 1 r
.02 w
.32188 .61424 m
.31702 .6916 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.292607 0.838346 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.292607 0.97619 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-1.27536 3.5938 -0.0119452 0.987264 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.82433 .35816 m
.723 .32476 L
s
P
p
.2 1 0 r
.02 w
.82788 .40573 m
.82433 .35816 L
s
P
p
.2 1 0 r
.02 w
.72066 .27802 m
.61762 .24341 L
s
P
p
.2 1 0 r
.02 w
.723 .32476 m
.72066 .27802 L
s
P
p
.2 1 0 r
.02 w
.72539 .37261 m
.82788 .40573 L
s
P
p
.2 1 0 r
.02 w
.61762 .24341 m
.61877 .29041 L
s
P
p
.2 1 0 r
.02 w
.51175 .16168 m
.40398 .12482 L
s
P
p
.2 1 0 r
.02 w
.51163 .20781 m
.51175 .16168 L
s
P
p
.2 1 0 r
.02 w
.61994 .33854 m
.72539 .37261 L
s
P
p
.2 1 0 r
.02 w
.61877 .29041 m
.51151 .25506 L
s
P
p
.2 1 0 r
.02 w
.51151 .25506 m
.51163 .20781 L
s
P
p
.2 1 0 r
.02 w
.40398 .12482 m
.40256 .17117 L
s
P
p
.2 1 0 r
.02 w
.72785 .42161 m
.62114 .38784 L
s
P
p
.2 1 0 r
.02 w
.73036 .47181 m
.72785 .42161 L
s
P
p
.2 1 0 r
.02 w
.62114 .38784 m
.61994 .33854 L
s
P
p
.2 1 0 r
.02 w
.40256 .17117 m
.29026 .13345 L
s
P
p
.2 1 0 r
.02 w
.62237 .43836 m
.73036 .47181 L
s
P
p
.2 1 0 r
.02 w
.40109 .21867 m
.3996 .26734 L
s
P
p
.2 1 0 r
.02 w
.28738 .18119 m
.40109 .21867 L
s
P
p
0 .4 1 r
.02 w
.42137 .21666 m
.42013 .26535 L
s
P
p
0 .4 1 r
.02 w
.30787 .17912 m
.42137 .21666 L
s
P
p
.01 w
.29026 .13345 Mdot
P
p
.2 1 0 r
.02 w
.29026 .13345 m
.28738 .18119 L
s
P
p
.01 w
.3105 .13138 Mdot
P
p
0 .4 1 r
.02 w
.3105 .13138 m
.30787 .17912 L
s
P
p
.2 1 0 r
.02 w
.62364 .49015 m
.62237 .43836 L
s
P
p
.2 1 0 r
.02 w
.51126 .35306 m
.51113 .40391 L
s
P
p
.2 1 0 r
.02 w
.39806 .31723 m
.51126 .35306 L
s
P
p
.2 1 0 r
.02 w
.3996 .26734 m
.28442 .23012 L
s
P
p
0 .4 1 r
.02 w
.42013 .26535 m
.41885 .31526 L
s
P
p
.2 1 0 r
.02 w
.511 .45605 m
.62364 .49015 L
s
P
p
.2 1 0 r
.02 w
.51113 .40391 m
.511 .45605 L
s
P
p
0 .4 1 r
.02 w
.53196 .40201 m
.53209 .45417 L
s
P
p
0 .4 1 r
.02 w
.41754 .36645 m
.53196 .40201 L
s
P
p
.2 1 0 r
.02 w
.39649 .3684 m
.39806 .31723 L
s
P
p
0 .4 1 r
.02 w
.41885 .31526 m
.41754 .36645 L
s
P
p
.2 1 0 r
.02 w
.28442 .23012 m
.16571 .19176 L
s
P
p
0 .4 1 r
.02 w
.53209 .45417 m
.53223 .50768 L
s
P
p
.2 1 0 r
.02 w
.27829 .33179 m
.39649 .3684 L
s
P
p
.2 1 0 r
.02 w
.28139 .28031 m
.27829 .33179 L
s
P
p
.2 1 0 r
.02 w
.16109 .24223 m
.28139 .28031 L
s
P
p
.2 1 0 r
.02 w
.16571 .19176 m
.16109 .24223 L
s
P
p
0 .4 1 r
.02 w
.64766 .59594 m
.6493 .65184 L
s
P
p
0 .4 1 r
.02 w
.53237 .56258 m
.64766 .59594 L
s
P
p
0 .4 1 r
.02 w
.53223 .50768 m
.53237 .56258 L
s
P
p
0 .4 1 r
.02 w
.6493 .65184 m
.65099 .70922 L
s
P
p
0 .4 1 r
.02 w
.76884 .79905 m
.77214 .859 L
s
P
p
0 .4 1 r
.02 w
.65272 .76814 m
.76884 .79905 L
s
P
p
0 .4 1 r
.02 w
.65099 .70922 m
.65272 .76814 L
s
P
p
0 .4 1 r
.02 w
.77214 .859 m
.77553 .92058 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.430451 0.149123 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.430451 0.286967 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.43465 .44607 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.43123 .54175 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.29822 .38061 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.15169 .31032 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.139 .40899 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.430451 0.424812 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.430451 0.562657 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.430451 0.700501 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.31889 .12085 m
.44385 .18936 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.31889 .12085 L
s
P
p
0 .4 1 r
.02 w
.18547 .04771 m
.31889 .12085 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.17486 .13016 L
s
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.17486 .13016 m
.18547 .04771 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.16362 .21754 L
s
P
p
0 .4 1 r
.02 w
.16362 .21754 m
.17486 .13016 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.430451 0.838346 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.16362 .21754 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.17486 .13016 m
.16362 .21754 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.430451 0.97619 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.568296 0.149123 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.568296 0.286967 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.67773 .47655 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.68474 .65693 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56304 .80672 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.139 .40899 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.12548 .51415 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.12548 .51415 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.568296 0.424812 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.568296 0.562657 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.8811 .50206 m
.78086 .44927 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.8811 .50206 L
s
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.89777 .66825 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.90676 .7578 m
.79931 .70898 L
s
P
p
0 .4 1 r
.02 w
.91622 .85211 m
.90676 .7578 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.9262 .95156 m
.91622 .85211 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.81335 .90655 m
.9262 .95156 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.81335 .90655 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.69258 .85839 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43123 .54175 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.42373 .75116 m
.56304 .80672 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.27351 .69125 m
.42373 .75116 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.27351 .69125 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.568296 0.700501 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.568296 0.838346 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.508603 2.11798 0.0244683 0.978733 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.80616 .41126 m
.72729 .36635 L
s
P
p
0 .4 1 r
.02 w
.81088 .4753 m
.80616 .41126 L
s
P
p
0 .4 1 r
.02 w
.81578 .54174 m
.81088 .4753 L
s
P
p
0 .4 1 r
.02 w
.72729 .36635 m
.73064 .43098 L
s
P
p
0 .4 1 r
.02 w
.7341 .49811 m
.81578 .54174 L
s
P
p
0 .4 1 r
.02 w
.73064 .43098 m
.64667 .38461 L
s
P
p
0 .4 1 r
.02 w
.82087 .61073 m
.73771 .56787 L
s
P
p
0 .4 1 r
.02 w
.82616 .68242 m
.82087 .61073 L
s
P
p
.2 1 0 r
.02 w
.71768 .50052 m
.63187 .45494 L
s
P
p
.2 1 0 r
.02 w
.72096 .57024 m
.71768 .50052 L
s
P
p
0 .4 1 r
.02 w
.73771 .56787 m
.7341 .49811 L
s
P
p
.2 1 0 r
.02 w
.63029 .38718 m
.54207 .33874 L
s
P
p
.2 1 0 r
.02 w
.63187 .45494 m
.63029 .38718 L
s
P
p
0 .4 1 r
.02 w
.64667 .38461 m
.55872 .33605 L
s
P
p
0 .4 1 r
.02 w
.91392 .79608 m
.83166 .75697 L
s
P
p
0 .4 1 r
.02 w
.92114 .87259 m
.91392 .79608 L
s
P
p
0 .4 1 r
.02 w
.83166 .75697 m
.82616 .68242 L
s
P
p
.2 1 0 r
.02 w
.6335 .52543 m
.72096 .57024 L
s
P
p
.2 1 0 r
.02 w
.54207 .33874 m
.5419 .40716 L
s
P
p
0 .4 1 r
.02 w
.55872 .33605 m
.55888 .40451 L
s
P
p
.2 1 0 r
.02 w
.45155 .22161 m
.35646 .16775 L
s
P
p
.2 1 0 r
.02 w
.44955 .28794 m
.45155 .22161 L
s
P
p
0 .4 1 r
.02 w
.83738 .83455 m
.92114 .87259 L
s
P
p
.2 1 0 r
.02 w
.54172 .4784 m
.6335 .52543 L
s
P
p
.2 1 0 r
.02 w
.5419 .40716 m
.44747 .35701 L
s
P
p
0 .4 1 r
.02 w
.55888 .40451 m
.46475 .35422 L
s
P
p
.2 1 0 r
.02 w
.44747 .35701 m
.44955 .28794 L
s
P
p
0 .4 1 r
.02 w
.46649 .28512 m
.36966 .23165 L
s
P
p
0 .4 1 r
.02 w
.46475 .35422 m
.46649 .28512 L
s
P
p
.2 1 0 r
.02 w
.35646 .16775 m
.35244 .23461 L
s
P
p
0 .4 1 r
.02 w
.74943 .7946 m
.83738 .83455 L
s
P
p
0 .4 1 r
.02 w
.74536 .71594 m
.74943 .7946 L
s
P
p
0 .4 1 r
.02 w
.65473 .67284 m
.74536 .71594 L
s
P
p
.2 1 0 r
.02 w
.63521 .5988 m
.54154 .55263 L
s
P
p
.2 1 0 r
.02 w
.63698 .67523 m
.63521 .5988 L
s
P
p
.2 1 0 r
.02 w
.54154 .55263 m
.54172 .4784 L
s
P
p
.2 1 0 r
.02 w
.35244 .23461 m
.25036 .17856 L
s
P
p
0 .4 1 r
.02 w
.36966 .23165 m
.26788 .17545 L
s
P
p
.2 1 0 r
.02 w
.54135 .63005 m
.63698 .67523 L
s
P
p
0 .4 1 r
.02 w
.65696 .75261 m
.65473 .67284 L
s
P
p
.2 1 0 r
.02 w
.34825 .30431 m
.34387 .37702 L
s
P
p
.2 1 0 r
.02 w
.24384 .24886 m
.34825 .30431 L
s
P
p
0 .4 1 r
.02 w
.36583 .30138 m
.36183 .37413 L
s
P
p
0 .4 1 r
.02 w
.26174 .24577 m
.36583 .30138 L
s
P
p
.01 w
.25036 .17856 Mdot
P
p
.2 1 0 r
.02 w
.25036 .17856 m
.24384 .24886 L
s
P
p
.01 w
.26788 .17545 Mdot
P
p
0 .4 1 r
.02 w
.26788 .17545 m
.26174 .24577 L
s
P
p
0 .4 1 r
.02 w
.55963 .7084 m
.65696 .75261 L
s
P
p
.2 1 0 r
.02 w
.54115 .71086 m
.54135 .63005 L
s
P
p
.2 1 0 r
.02 w
.44304 .50408 m
.44067 .58247 L
s
P
p
.2 1 0 r
.02 w
.33931 .45295 m
.44304 .50408 L
s
P
p
0 .4 1 r
.02 w
.46106 .50138 m
.45909 .57982 L
s
P
p
0 .4 1 r
.02 w
.35765 .4501 m
.46106 .50138 L
s
P
p
.2 1 0 r
.02 w
.34387 .37702 m
.23704 .32228 L
s
P
p
0 .4 1 r
.02 w
.36183 .37413 m
.35765 .4501 L
s
P
p
.2 1 0 r
.02 w
.4382 .66439 m
.54115 .71086 L
s
P
p
0 .4 1 r
.02 w
.45703 .6618 m
.55963 .7084 L
s
P
p
.2 1 0 r
.02 w
.44067 .58247 m
.4382 .66439 L
s
P
p
0 .4 1 r
.02 w
.45909 .57982 m
.35329 .52952 L
s
P
p
.2 1 0 r
.02 w
.33453 .53231 m
.33931 .45295 L
s
P
p
.2 1 0 r
.02 w
.23704 .32228 m
.12435 .26454 L
s
P
p
0 .4 1 r
.02 w
.45488 .74757 m
.45703 .6618 L
s
P
p
.2 1 0 r
.02 w
.22247 .47936 m
.33453 .53231 L
s
P
p
0 .4 1 r
.02 w
.35329 .52952 m
.34872 .61261 L
s
P
p
.2 1 0 r
.02 w
.22992 .39903 m
.22247 .47936 L
s
P
p
.2 1 0 r
.02 w
.1144 .3421 m
.22992 .39903 L
s
P
p
.2 1 0 r
.02 w
.12435 .26454 m
.1144 .3421 L
s
P
p
0 .4 1 r
.02 w
.34394 .69965 m
.45488 .74757 L
s
P
p
0 .4 1 r
.02 w
.34872 .61261 m
.34394 .69965 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.568296 0.97619 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.16362 .21754 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
0 .4 1 r
.02 w
.16362 .21754 m
.15169 .31032 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.139 .40899 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
P
MathSubEnd
P
% End of sub-graphic
p
/Times-Italic findfont 18 scalefont setfont
[(Fractals)] .02381 .57389 -1 0 Mshowa
P
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{413, 256},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006M000100P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0WP00003obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002M
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/10000
0?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040
003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002M
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000Jk/2aUBk0/KI^`400000`l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/_6bk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l_6b`03aP3Fbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40001Z^`05
a[^k^lH0D[/00lJk^`02^`03a[^k0=>k0@00001Zbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`;605G;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;60=Vkbk_6^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040001/^`;600>ka[/0D[/4a]Fk0@00001^bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2aP04bk_;^`;6053;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`;608C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2aP1>bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004jk
0/HJ^`;60k/2aP>k00?6^lH08k/00iG6aP02^`:E9K/00lJkaP02aPBk0/HO^`03ULK600:k0YDT^`03
UOo600:k0YDZ^`04a[_6aTbk0@00001@bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[/3aP0I^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_6^`02aP03blK;00C602RkblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kULJE0/H00iG;U@02U@0Wbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;00;6
00BkblK;0lH07l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^EaYD00/H00iG;U@02U@0Tbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^E0/H00iFkU@02U@1g^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004jk00?6^k/00[/00lJk
^`0D^`04a[^k^`;60k/01YG6a[^EaR6k00JEa[^kULH4^`03UK^k01Vk0lH3^`03a[^k00Bk0lH4^`03
a[^k01Vk00JEa[^kULH4^`03UK^k01jk00JE^k^kULH4^`03UK^k01jk00>Ea/H00[/00iG6aP02^`03
a[^k04Vk0@00001_bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^k
bk_;00;600RkbiG6ULJEaP:E022kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kU@;600>kbiD0
0/H08L^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkb`04aP08^l^kbk_;^l/2aP0P^l^ka[_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD2aP03^l^E00;602?;^iFkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`02U@04^l^kU@;602JkbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^iG6U@;600>EbiD01<H0B/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004Bk00>Ea/H00[/2U@>k00?6^k/00[/01<Jk
^k/2aQ2k0/H4^`03a[_600;60[/00iG6aP02^`03UK^k01Jk0YD5^`07aYG6a[_6^`03aQ^k00?6^k/0
0[/00iG6aP02^`:E0k/00lJkaP03aQFk0YD6^`03ULK600>k0lHJ^`:E1[/2U@Bk0lH4^`03a[^k01Vk
00JEa[^kULH4^`03ULJk04Vk0@000017bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^EaYD00lH02L^EUIG6^l^kb`02aP04^l_6b`;6
012kbk_;^l^kbk_;^l^kbk_;1<H01;_;^l/2aP0Q^l^Ea[_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^iFk00:E00O;^l_6bk^E00;601nkbk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;600K;^l^E
aYD3aP0Q^iFEULK;^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^iFk00:E02W;^l^kbk^Ea/^kbk^Ea/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Eb`02U@0c^l^kbk_;UL^kbk_;ULJkbk_6^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kULK;^l^E00;604k;^iG6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000A;/01<Jk^k/2U@;6
0[/00lJk^`02^`03a[_600;60k/00lJk^`0@^`03aYFk00:k00C6ULK61;/00iFk^`0F^`04UK^k^`:E
00>ka[/00[/00iG6aP02^`03ULJk01^k1<H3^`:E0/H2^`03a[^k01Rk00BE^k^k0YD5^`03ULJk00:k
00>Ea[/06;/019Fk^k/2U@Fk00>Ea/H00[/00iG6^`02^`03a[^k01Vk00>Ea/H00k/00lJkaP03aP>k
0/I5^`400000A<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^k0lH01K_;ULJk00?600Rkbk_;a/^kb`;601bkblK;^l^kbk_;^l^kbk_;
^l^kbk^E^iFkblK;0YD09<K;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kU@;600FkbiG6
^`04aP0Wbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^l^kUK_;00?6027;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;UL^kbk_;^iD00/H03;_;ULJkbk^Ea/^kb`;601Zkbk_;^l^kbk_;^l^kbk_;
^l^kUK_;^l^kb`:E00Jkbk^Ea//4aP0I^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^`02U@07bk_;^l^k
U@04aP04^l^kU@;600BkblK;0/H0@k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0003jk0YD6^`03ULK600;60k/00lJk^`02^`03
a[^k00>k0lHB^`06UK^kUK_60k/01IG6^k^E01Nk0YD7^`03ULK600;60k/019G6^k/2UAFk0YD5^`:E
1[/00iG6aP0H^`:E1[/00lJEaP03aP>k00REa/JkULJkaQ:k0YD7^`:E00>kULH00k/01YG6a[^EaQFk
00>E^iD00YD6^`03ULJk00:k00>Ea[/00lH3^`03a[^k042k0@000010bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^`:E037;^l^kbk^E^lJk
bk_6^l^kblK;^l^kbk_;a/^kbk_;^l^kbk_;^l^kbk_;UL^kbk^E00;600ZkbiG6^l^Ebk_;0YD05;_;
^l^kbk_;^l^kbk_;^l^kbk_;0YD01k_;^l^kbk/00YD2aP08bk^Ea/^kUK/3U@0D^l^kbk_;^l^kbk_;
^l^kbk_;UL/2U@05^l^kbk/00YD01l^kbk^Ea//00lH05l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00:E
00Nkbk_;a/^k00:E00C6^l^k0YD01<_6ULH2U@0Da[_;^l^kbk_;^l^kbk_;^l^kbk/2U@07bk_;^l^k
b`02U@0:a/^kbiG6^lJEaP>E01O;^l^kbk_;^l^kbk_;^l^kbiG;^l^kb`03U@0=bk_;UL^kbk^Ea/^k
U@02aP15^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^k0040000n^`05UK^k^iD01[/00iFk^`02^`06a[^k^iG66K/2U@Fk00>Ea/H0
0/H2^`:E0[/019FkUIDD^`:E1[/00iFk^`02aP03^lJE00>E0k/00iFk^`0?^`05UK^k^iD01[/01YFk
^k^EaP>k00>Ea[/05k/2U@03^lJk00>k00>E^k/01;/2U@;60k/00lJk^`0B^`:E1[/00iG6^`03^`03
aYFE00;60k/00iFk^`0>^`>E1[/4U@Bk00NEa/JkUK^E00?6@[/1000004?;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;00>E00S;^l^E
bk_;^`;600C;^iG60YD06L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00iD02l^kbk_;ULJkbk_;00>E
02C;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk/2aP0Nbk_;UL^kbiG;^l^kbk_;^l^k
bk_;^l^kUK_;^l^k0YD02L^kbk^E^l^kU@02aP04^l^EaP:E06^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^Ea[_;^l^kbk_;^l^kbk_;a/^kblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kblK;^l^ka[_;
^lJkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^`03U@0>^l^kbk_;UL^kbk_;aYD2aP17^l^kULK;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
0@0003fk0iD6^`BE1[/4aP:k00>E^k/06K/00iFk^`0:^`05UK^k^iD05K/00iFk^`09^`03a[^k00Fk
00>E^k/03[/3U@Fk19D6^`03ULK600;60[/00iFk^`0E^`03ULJk016k00>Ea[/05;/00iFk^`04^`03
a[^k00:k0/H6^`03UK^k01Bk00>E^k/02K/01LJk^iG600:k00>E^k/0@K/10000043;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0iD0G;_;
^l^kbiG;^l^kbk_;^iG6bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;
^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;0YD03;_;^l^kbk_;^l^kb`:E01:kbk_;^l^kbk_;
^l^kbk_;^l/3U@0bbk_;^l^Ebk_;^l^kbk_;ULJkbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^k
biD2aP0`bk_;^l^kbk_;^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^iG6bk_;^l^k0lH00k_;
^`02U@0Qbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk_;00;604VkblK;^l^Ebk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040
0013^`03UK^k016k00>E^k/06;/00iFk^`0>^`:E5;/00iFk^`03^`04UK^EU@Jk0YD4^`:E4k/00iFk
^`0A^`03UK^k01Bk00>Ea[/00k/00iG6U@02aPFk00>Ea/H00[/00lJEU@0C^`03UK^k00>k00BE^iFE
1[/00iG6aP03^`:E4k/00iFk^`0;^`?60k/2UD6k0@00001Gbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^k
bk_;00:E01jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l/2U@06^l^kbk_;0YD06;_;^l^Ebk_;
^l^kbk_;^l^kbk_;^l^kb`>E00o;^l^Ebk_;UL^kbk_;UL/00YD0:k_;^l^Ebk_;^l^kbk_;^l^kbk_;
^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk/00YD05/^kbk_;^l^kbk_;^l^kbk_;^l^kbiD3aP0?^l^Ea[_;
ULJkbk_;ULJE00?601FkbiG;^l^kbk_;^l^kbk_;^l^kbk/00iD04;_;^iFkbk^E^l^kbk^E^iD2aP0L
^l^kUK_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kb`:E00jkbk_;^l^kULK;^l^kb`:E03nkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004>k
00>E^k/00[/3U@Nk0YD5^`:E5k/2U@>k00BE^iFE1;/019FkUID3^`03UK^k01>k19D4^`03UK^k00:k
00BE^k^k0YD2^`03UK^k012k00>E^k/00[/2U@Rk0YD5^`:E5[/00iG6aP02aP>k00>Ea[/00[/01YG6
^k^EaP:k00>E^k/04k/4U@Bk00>E^k/00[/01YFk^k^EaP:k00>E^k/04;/2U@Bk00>E^iD00YD4^`03
UK^E00:E1;/00iFk^`0l^`400000@l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD01[_;^iFkb`>E00K;^l^kUK/3U@0M^l^kbiG;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/019D02l^kbiG;^l^Ebk_;00:E02ZkUK_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbiG;^l^kUK_;^l^Ebk_;^l/3U@0Bbk_;^l^kbk_;^l^kbk_;^l^k0YD01L^kbiG;00>E
00O;^l^kbiG;00>E02g;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^kULK;^l^Ea[_;^l/0
0iD0:<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;UL^kbk^E^l^kbk/3U@0D^l^kbk_;^l^kbk_;
^l^kbk_;^l/4U@0>^l^kbk^E^l^kUK_;^l/2U@11^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004Fk19D5^`05UK^k^iD01;/2U@:k
00>E^k/06K/01IFk^k^E00>k00>E^k/00k/3UAbk00>E^k/00[/2U@Jk00>E^k/04[/4U@Bk00>E^k/0
0[/00iFk^`02^`:E0[/00iFk^`0K^`03ULJk00:k00>Ea/H01K/00iFk^`0K^`03UK^k00:k0YD6^`03
UK^k01Fk00>E^k/00k/01IFk^k^E00Jk0iDn^`400000D/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^iFkbk/2U@05
bk_;^l/00iD08l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;00:E02Zkbk_;^l^Ebk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l/2U@0V^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbiG;^l^kUK_;^l/2U@05^l^kbk/00iD07[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kU@;6
00Fkbk_;U@02aP0Xbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^`:E02K;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^`:E04K;^l^kbk_;UL^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004jk00>E^k/0
0k/3U@Bk00>E^k/07K/00iFk^`03^`:E8K/00iFk^`06^`03UK^k01jk00>E^k/01;/3U@Bk00>E^k/0
6k/00iFk^`02aPBk00>Ea[/07k/00iFk^`06^`03UK^k01nk00>E^k/00k/3UD>k0@00003obk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kUK_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^k
bk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^Ebk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iFkbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000C[/00iFk
^`06^`03UK^k026k00BE^k^k0YD2^`03UK^k01jk00>E^k/00[/2U@:k00>E^k/07[/00iFk^`07^`03
UK^k01nk00>E^k/00[/01YG6a[^EaR2k00>E^k/00[/2U@:k00>E^k/07k/00iFk^`02^`:E0[/00iFk
^`10^`400000D/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk/4U@0[biG;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbiG;^l^Eb`03U@0Wbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^k
biG;00BE02Bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l/4U@0[^iFkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbiG;U@03aP0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^Ebk_;^iFk00BE02O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;UL/0
0iD0@/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`40001>^`:E0[/019Fk^k/2UB>k0YD2^`05UK^k^iD08;/2U@>k00>E^k/00[/00iFk
^`0M^`:E0k/019Fk^k/2UB6k0YD3^`03UK^k00:k00?6^k/07[/2U@>k00>E^k/00[/00iFk^`0N^`:E
0k/01IFk^k^E04:k0@00001@bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/4U@0Ybk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/019D09K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/019D09/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k19D0:<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/4U@0Wbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00BE02Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
19D0A/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/10000Dk/00iFk^`0Z^`03UK^k02Jk00>E^k/09k/00iFk^`0Y^`03UK^k02Rk
00>E^k/0:;/00iFk^`14^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002M
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/10000
0?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040
003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/1000004[;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;60?o;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/0057;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@0004Zk00C6^lK6ok]?^`400000M<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^ka[_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiGoa/^k0YD0:L^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iGoa[_;00:E02Fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^E00;605S;^iFEbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^k0YD09L^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD00/H0Dk_;UIFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040
001:^`;60[/00lJk^`0N^`03UK^E00;600>E^iD00YDQ^`03UK^E00;600>E^iD00YDQ^`03ULJE00;6
00>E^iD00YE<^`07ULJEUK^E^`03UAbk0lH2^`03ULJE00;600>E^iD00YE<^`400000C<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/3aP3@^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;ULJkbk_;UL^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^iG6bk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbiG6^l^Ea[_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkb`:E02>kbk_;UL^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kblK;^`04aP1Dbk^Ea/^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004jk0/HO^`03
ULK600:k00>Ea/H00[/00iFk^`0N^`:E0k/00iG6aP02^`03UK^k01jk00>Ea/H00[/00iG6^`02^`03
UK^k04Vk00>Ea[/00[/00iFk^`02^`03UK^k01Vk00?6^k/00[/00iG6aP02^`03ULK600:k00>E^k/0
BK/1000004G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^iD00/H00k_;U@02aP04bk_6^`?601Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
0YD01k_;^l^kaYD00/H00l_6b`03aP0Jbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2U@06bk_;^l^k
0YD01<^kbk/3aP0J^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2U@07^l^kbk_;U@02aP1;blK;^l^E
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;00:E00Jkbk_;^l/2U@0Z^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;
^l^kbk^E0/H00k_;^`03aP1;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00400014^`03ULJE00C600BEa/K61;/00lJk
^`0C^`04UK^EU@>k00C6^k^E0/H3^`03ULJk01Rk00BE^iFE1[/00iFk^`03^`03ULK601Rk00BE^iFE
1[/00iG6aP03^`03UK^k01Jk0lHZ^`04UK^EU@Jk00>E^k/00k/00iFk^`0H^`04ULJEU@Jk00>Ea[/0
0k/00iG6^`19^`400000B<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^`:E0/H08L^ka[_;^l_6bk_;^l^kbk_;^l^kbk_;^l^k
bk_;UL^kb`02U@0Y^lJkbk^Ea/^kbiG6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk/00YD01/^k
bk_;U@;600G;^iG6b`02aP0J^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l/2U@06^l^kbk^E0/H0C;_;
UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbiG;^l/2U@0Y^l^kbk^E^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk/0
0YD0E/^kbk_;ULJkbk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004Bk0lH2^`03ULJk00;600>E^k/00[/01<Jk
^k/2aPnk00>E^k/01;/00iG6aP02^`03UK^k00:k00>Ea[/00[/00lJk^`0B^`03UK^k00Bk0YD3^`03
ULJk00C60k/01LJk^k_6012k00>E^k/01;/00iG6aP02^`03ULJk00?67;/01<Jk^lHT^`03UK^k00Bk
0YD3^`03UK^k00:k00>E^k/05k/00iG6^`04^`03ULJk00:k00>E^k/00[/00iG6^`19^`400000?/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
0YD01l^kbk_;^iD01<H02;_;^lJkbk_;0lH00l_6b`02aP0=^l^kbk_;^l^kbk_;^`02U@08bk_;^l^k
aYD3aP05^l^kbiD00/H05l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;00:E00Nkbk_;^l^k00:E027;ULJk
bk^Ea/^kULK;^l_6bk_;^l^kbk_;^l^kbk_;^iD00/H01k_;^l^kaYD01<H01l^kbiG6^l/00YD06[_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;0/H08k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00:E00O;^l^kbk_;00:E00ZkUK_;^l^Ebk_;0YD05K_;^l^kbk_;^l^kbk_;^l^kbk_;U@02aP06
bk_;^l_60YD01l^Ebk_;^iD00/H0BK^EUL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0003jk00BE^iFE1[/00iFkaP03^`03
a[^k00Fk0lH2^`03a[^k00bk0YD4^`03a[^k00:E00C6^k^k0YD01;_6ULH3UA>k0YD7^`:E0/H2^`:E
0[/00iG6U@02U@03a[^k00nk00C6ULK60k/00lJk^`02U@06a[^k^iG60[/00iFkU@02UAFk00C6^lJk
0lHR^`:E1k/2U@Bk0YD2^`03UK^E00:E4k/00iG6aP03^`03a[^k00:E1;/01YG6^lJE^`>E@k/10000
05?;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iFkbk^E^l^kbk_;UL^kbk_6^l^kU@02aP04^l_6b`?6013;^l^kbk_;^l^kbk_;^l^k0YD03L_6
bk_;^iG6bk_;^l/00YD2aP0H^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;0YD02K_;^l^kbiG6^`02aP03
bk^E00:E01[6bk_;a/^kbk_;^l^kbk_;^l^kbk_;a/^kU@?600_;^l^kUK_;^l^kaP04U@0Q^l^kUK_;
^l^kbk_;^l^kbk_;^l^kbk_;a/_6bk_;^lJk00;6023;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`:E00g;^l^kbk^E^l^kbk_;00BE01Vkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^E00?600^kbk_;
UL^kbk_;aP02U@18aYG;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0003fk00>E^k/00k/3U@>k00>E^k/00[/2aP:k00>EaYD0
0lH3^`03a[^k012k00>Ea[/01;/00lJk^`06^`05a[^k^iD05[/00iFk^`04^`05a[^k^lH01;/01IG6
^k_6016k00?6^k/00[/019G6a/H8^`04a[^k^`;60[/00iFk^`0C^`;61;/01<Jka[/2aR2k00>E^k/0
3K/01IFk^k^E01Jk00>Ea[/02K/01LJk^k_600>k00>E^k/0@;/1000003g;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00>E00K;^l^kbk/4U@06
bk_;^l^k1<H09/^kULK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kblK;^l^k0/H0;l^ka[_;^iFk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^lJkbk_;a/^kbk_;00C6012kbk_;^l^kbk_;^l^kbk_;
0/H01k_;^iG6bk/00lH01K_;^l^k00;600C;^lJk0lH06[_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;
0/H0Yk_6^l^ka[_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;
^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkbk_;^l^kbk_;a/^kblK;^l^Ebk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00400010^`>E
1[/00iFk^`06^`05ULK6^iD05k/00iFk^`03^`03ULK600>k00?6^lH00lH2^`:E5K/00iFk^`03^`03
ULJk00>k00?6^k/01K/00iG6^`0A^`;600>kULH01;/00iG6^`05^`C60[/00iG6^`0J^`;60k/00lJk
aP02aP:k00?6UID05[/00iFk^`03^`:E3;/2UAFk00>Ea[/00k/00iG6aP07^`04a[^k^`:E@K/10000
05G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kblK;00;6022Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;
^iFkU@;600^ka[_;^iG6bk_;^`02U@0Kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbiG600:E00NkblK;
^l^E00;600?;^lH00YD04[_;^l^kbk_;^l^kbk_;^l^kb`?600K;^l^kULH2U@07bk_;^l^kU@02aP03
^l_600:E04K;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_6^lJkblK;aYFkUK_;^l^kbk_;^l^k
bk_;^l^kbk_;^iFkbk_;^iFk0YD01/^kbk_;^`:E00C;^l^k0YD07<^kbk_;^l^kbk_;^l^kbk_;^l^E
a[_;^l^EbiD2aP0;bk_;^l_6UK_;^l/00YD0?k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000@k/00iFk^`0=^`06a[^k^lJE5K/3U@>k
00FE^k^kU@02aP>k00BE^iFE1;/00iFk^`0@^`>E0k/01iG6^k^E^lH00k/00iG6U@03aP:k00>E^k/0
4;/00iG6U@03^`05ULJk^iD01K/00iG6U@03aP:k00>E^k/07;/2aP:k00K6^lJE^iDE^`>E0k/01IFk
^k^E00Fk00BE^iFE1;/00iFk^`0@^`04ULK6aP:k00JE^k^kULH4^`04a[^EU@Bk00>E^k/0?;/10000
04S;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;UL^kbk/3U@08^l^kbk_;^iD2aP04^l_6b`:E01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
19D01K_;^l^E00;600K;^iFkbk/2U@0Hbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^k19D01LJkbk^E00;6
022kbiG6^l^Ea[_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kb`BE00G6bk_;U@02aP0^bk^Ea/^kULK;^iFk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;U@;601_;^iFkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/019D03K_;^l^Ebk_;^iFkbk/00YD06L^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^iD00lH01L^k
bk^E00;600JkblK;^l/2U@11^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004>k0YD3^`03UK^k00>E1;/00iFkU@04aP:k00>E^k/0
5[/00iFk^`02^`03UK^k00?61K/3UARk00>Ea[/00[/00iFk^`04aPBk0iDH^`03ULK600:k00>Ea[/0
1<H4^`>E8[/029FkaYFkUK^E6K/00iFk^`02^`03UK^k00:k00>E^k/00k/3UARk00>Ea/H00[/00iG6
^`04aPBk0iDn^`400000AL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04U@1Q^l^kbk^E^l^kUK_;^l^Ea[_;UL^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk^Ea/^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^iFkbk_;U@02aP0Qbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00C6032kbk^Ea/^kbk_;
^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL/2U@03^iFE00:E02;;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^k0YD08/^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/4aP1:bk_;ULJkbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/10000B;/00iFk^`03^`04UK^k^`:E1K/3UAfk00>E^k/01;/2UB:k
00>E^k/01;/00iG6aP0Q^`03ULK600Bk0YDX^`03UK^E00>k0YDM^`03UK^k00Bk0YDR^`03ULJk00Bk
0YE3^`400000E<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^`>E05Nkbk_;UL^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;UL^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;
^l^kbiD00/H08/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ea[/2aP0cbk_;^iFkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;00:E09>kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;UL^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;
^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00@0004jk00>E^k/01[/00iFk^`0O^`03UK^k00Jk00>E^k/07k/00iFk^`06^`03
UK^k00;67K/00iG6^`02^`05a[^k^iD0:;/3U@:k00BE^k^E6k/00iFk^`06^`03UK^k01nk00>E^k/0
1[/00iFk^`10^`400000O/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^Ebk_;^`:E02W;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk^E^l^kb`02U@1F^l^Ebk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkbk^Ea/^kUK_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2U@03^iFk00BE023;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^Ebk_;^`:E02W;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk^E^l^kb`02U@15^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040001>^`04UK^k^`BE00>kUK/08;/00iFk^`02^`03UK^E00>E
8;/00iFk^`02^`03UK^E00>E8;/00iG6^`02^`03ULJE00>E:K/2U@05^iFE^iD06k/00iFk^`02^`03
UK^E00>E8;/00iFk^`02^`03UK^E00:E@[/1000004k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2U@06bk^E^l^k
0YD08L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02U@0Y^l^kUK_;^l^Ebk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00YD0:/^kbiG;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;U@;605?;^iG6bk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iFkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02U@0Y^l^kUK_;^l^Ebk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00YD0B/^kbiG;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@00052k19DW^`BE9k/4UBNk
00>Ea/H00/H^^`03UK^E00:E7[/4UBNk19E6^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kULK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`001L^kbk_;00>E
09FkUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000ok/7^`03UK^k09>k0@00003obk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`40
0000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
09g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;001<bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`>E04k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000k[/019G6
a[/2UE:k00>EaYD00iD2^`:EC;/100000?7;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULJE00;605BkUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD3aP1B
biG;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`400014^`03ULKo00>k0YDS^`03ULK600:k0YDT^`03ULK600:k
0YDT^`03ULK600:k0YDR^`05ULJk^iD00/H00iFk^`0S^`03ULK600:k0YDO^`BE0k/2U@;60k/00iFk
^`1:^`400000?l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`03aP05bk^EaYD00/H00k^E^`02U@0Tbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;ULJE0/H00iFkU@02U@0T^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULJE
0/H00iG;U@02U@0Tbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJE0/H00iFkU@02U@0K
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00:E00?;^iD00/H0;K_;^l_6bk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6U@02aP03UK^E00:E01bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;0YD00k_;U@03U@1C^l_6bk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0003nk00?6^k/01<H2^`03
ULJk00>k00>E^k/07[/01YG6^k^EaPBk00>E^k/07[/01YG6^k^EaPBk00>E^k/07[/01YG6^k^EaPBk
00>E^k/06;/019FkUID2^`03ULJk00:k00>Ea/H08k/01YG6^k^EaPBk00>E^k/06k/3U@>k0YD01<Jk
^k/3U@04^iFEUDJk0@00001`bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kbk^Ea/^kbiG6^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;U@;600?;^iD00/H09;_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kU@;6
00>kbiD00/H09<^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;U@;602K;^iG6bk_;UL^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^`:E02c;^lJkbiG;^lJkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;U@;600?;^iD00/H0;k_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kUK_;^l_6bk_;^l^k00:E04S;^iFEbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000?[/00iG6aP05^`:E0[/01LJk^k^E01Zk
0YD6^`03ULK600>k0lH4^`;65;/2U@Jk00>Ea/H00k/3aQZk0YD6^`05ULK6^lH00k/00iFk^`0H^`:E
1;/2U@04a[^kU@>k00?6UK/06K/2U@Jk00>Ea/H00k/3aR2k00JE^k^kULH;^`03UK^k04:k0@000011
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk^E^iD00/H0:;_;^l^kUK_6^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL/2U@0Y^l^kbk_;
ULJkbk_;ULJkbk_6^lJkbk_;^l^kbk_;^l^kbk_;^l^kUK/00YD0:L^kbk_;^iG6bk_;^iG6bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbiG;00:E00Nkbk_;^l^E00;6023;^l^Ebk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`:E00O;^l^ka[_;00>E01o;a/^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;00:E
02fkbk_;^l^Ea[_;^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00iD00k^EaP03U@04
^l^kb`:E00>kbiD00YD0@/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40000n^`05UK^k^iD00/H4^`03ULK600:k00>E^k/06;/019Fk
^k/2U@Fk00>Ea/H00[/00iG6^`02^`04a[^kaQ:k00BE^k^k0YD5^`03ULJk00:k00>Ea[/06;/019Fk
^k/2U@Fk00>Ea[/00[/00iFk^`0L^`05UK^k^lH01K/2U@03a[_600;65[/019Fk^k/2U@Fk00>Ea/H0
0[/00iG6^`0Q^`:E0/H2^`06UK^k^iFk0YD3^`:E@;/1000004c;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^iG6bk_;UL^k0lH08;_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;0YD01[_;^iFkb`C601nkbk_6^l^ka[_;^l^kbk_;
^l^kbk_;^l^Ebk_;^l^k00:E02W;^l^Ea[_;^iG6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^k
b`02U@0d^l^kUK_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^lJkbk_;^l^kb`;6
00FkblK6^`03aP0F^l^kbk_;^l^kbk_;^l^kUK_;^l^kb`:E00Jkbk^E^l/4aP0V^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/3aP03bk_;00>E04K;UIFEbiG;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0003fk0YD6^`05
aYFE^iD01;/00iG6^`02^`:E4k/2U@Nk0YD00k^E^`03^`03ULK600:k00G6UK^kaP0@^`:E1k/2U@03
^iG600>k00BEa[^k0YDD^`:E1k/2U@03^iFk00>k0YD2^`:E6;/01IFk^k^E00?61k/00lJE^`02^`;6
0[/00lJk^`0<^`:E1k/2U@03^iFk00>k00BEa[^k0YDT^`03ULJk00Bk0YD2^`:E@;/1000003o;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0YD01k_;^l_6bk/00YD2aP04bk_;aP:E00?;UL/00YD04k_;^l^kbk_;^l^kbk_;^l^kbk/00YD01l^k
bk_;^l/00YD2aP09^l^kaYG6^lJk00:E01?6^l^kbk_;^l^kbk_;^l^kbk_;00:E00Nkbk_;^l^k00:E
00K6^l^kblH3U@0G^iFEUK_;^l^kbk_;^l^kbk_;^l^kbk/00YD01l^kbk_;^l/00YD01[_;^l^kb`>E
01W;UIFEbk_;^l^kbk_;^l^kbk_;^l^kbk_;00>E00?;UL/00YD2aP03^l^E00:E01[;^iFkbk_6^l_6
bk_;^l^kbk_;^l^kbk_;^`:E00O;^l^kbk_;00:E00Jkbk_;^lH3U@0YbiFEUL^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbiG6^l/00iD0A/^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000@K/2U@03^lJk00>k00>Ea[/0
0/H01;_6^k/2U@>k00>E^k/04[/2U@Jk00>Ea[/00/H01;_6^k/2aP>k00?6^k/04[/2U@Jk00>Ea[/0
0k/00lJk^`02U@>k00>E^k/04[/2U@Jk00>E^k/01[/2U@>k00>E^k/05K/2U@;600>kULH00[/00iFk
^`02U@03^iFk00Bk00?6^k/04;/2U@Jk00>E^k/00k/00lJk^`02U@>k00>E^k/07[/01IG6UK^E00:k
0YE4^`400000A<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^E0lH01k_;^lJkbk/00/H0:L^kbiG;^l^Ebk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iFkbk_;^l_6bk_;00;600>kbk/00/H0M<^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^k
a[_;^l_6bk_;UL^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^iFkbk^E^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJk0lH01k^EUL^kbk/00YD0D/^kbk_;a/^kbk_;^l^kbk_;^l^k
bk_;^l^kUK_;^l^kbk_;^l^ka[_;^iFkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
a[/2U@18bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^k0@0004>k00BE^k^k1<H4^`03a[^k00Fk00>E^k/05;/00iFk^`04^`03
a[^k00:k0/H2^`03a[_600?65K/00iFk^`04^`03a[^k00:k00?6^k/01K/00iFk^`0D^`03UK^k016k
00>E^k/05k/01LJk^iG600>k0YD3^`03UK^k00>k00?6^k/04[/00iFk^`09^`;61[/00iFk^`0O^`03
a[^k04Vk0@00001Gbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbiG6^l^kbk_;^l^kbk_;00:E02>kbk_;^l^kbk_;^l^kbk_;
^l^kbk^E^l^kbk^Ea/^kbk_6^`04aP0]bk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbiG6^l^k
blK;^l^kbk_;00:E01^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk/00YD03<^kbk_;^l^kbk_;^`:E
02S;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^l^Ebk_;^l^kUK_;^l^k0/H07<_6bk_;^l^kbk_;^l^k
bk_;^l^kbk^E^l^kbk/2U@06bk_;^lJk0lH00k_;^`02U@1/bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004>k00>E^k/00k/019FkUID6^`:E1;/2UA>k00>E^k/0
0k/019G6UID2^`05a[^k^iD00/H3^`:E4k/00iFk^`03^`04ULJEU@:k00C6^k^k0YD4^`:E4k/00iFk
^`03^`04UK^EU@Jk0YD4^`:E5[/01<Jk^iD2^`:E0[/00iFk^`03^`04a[_6aQBk00>E^k/00k/019Fk
UID2^`05a[^k^iD00/H3^`:E7[/3aTVk0@000013bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03U@0?bk_;UL^kbiG;^l^kbiG;00:E
01Nkbk_;UL^kbk_;^l^kbk_;^l^kbk_;^`03U@0@^l^kULK;^iFka[_;^iG6U@;601Jkbk^E^l^kbk_;
^l^kbk_;^l^kbk_;0iD03l^kbiG6^l^EblK;^l^Eb`02U@0G^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk/0
0iD03k_;^iFkbk^E^l^kbk^E^`02U@0Mbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_6^l/00YD00k^E
^`03U@0M^l^kbk_;a/_6bk_;^l^kbk_;^l^kbk_;^l^kbk/00iD04;_;^iFkbk^E^lJkbk^E^iD2aP0T
^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0/H0Ak_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00400016^`BE
1;/00iFk^`02^`04UK^k^`:E0[/00iFk^`0C^`BE00K6^k^kULH3^`05ULJk^iD00/H00k^E^`0D^`BE
00G6^k^kU@02aP:k00BE^k^k0YD2^`03UK^k01>k19D4^`03UK^k00:k00BE^k^k0YD2^`03UK^k01>k
00?6^k/00[/2U@>k00>E^k/01;/2aQRk19D4^`03ULK600:k00JE^k^kULH2^`03UK^k01nk00?6^k/0
AK/1000005W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk^E^l^kbiG;^l^kb`03U@0Ibk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kU@02aP0>^l^Ea[_;^iG6bk_;^iD2aP0I^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;U@02aP05
bk^E^l/00lH01L^kbk_;00>E02S;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbiG;^l^kUK_;^l^k
0iD0Bk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;^iFkbk_;^l^kbk_;^l_6bk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk^E^l^kbiG;^`03aP05^l^kblH00iD0JK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`010000C[/00iFk^`02^`:E1[/00iFk^`0I^`C60k/00iG6aP05^`03
ULJk01Vk0lH4^`03ULJk00Fk00>E^k/06k/00iFk^`02^`:E1[/00iFk^`0B^`04a[^k^`?61;/2aPNk
00?6^k/07K/00iFk^`02^`03ULK600:k00C6^k^E8K/00lJk^`15^`400000EL^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iFkbk_;^l/00YD0:[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ea[_;^l^kU@;6
02:kbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E0/H01;_;^lH2U@0Y^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk/00YD06L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0/H01K_;a/^k00?600>ka[/00/H0;L^kbk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E
bk_;^l^kU@03aP1/bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
0@0004jk00>E^k/01[/00iFk^`0O^`03UK^k00Jk00>Ea/H00[/00lJk^`0J^`03UK^k00;600Fka[^k
U@0Q^`03UK^k00Jk00>E^k/06;/3aPFk0/H3^`03a[^k00>k00?6^k/07;/00iFk^`06^`03ULJk02>k
00?6^k/0AK/1000008G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kUK_;00?6027;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
UK_;^l/00/H0lK_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_;^iFkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kbk_;^lJkbk_6^l^kbk_6^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;UL^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00@0004jk00>E^k/00[/2U@:k00>E^k/07k/00iFk^`02^`:E0[/00iFk^`02^`03
a[^k01Zk00>E^k/00[/01IG6^k^E026k00>E^k/00[/2U@:k00>E^k/09K/2aPBk0/HM^`03UK^k00:k
0YD2^`03UK^k02>k1<I4^`400000EL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;UL/019D09k_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk^E^`04U@0Wbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk^E^l^kbiG;00BE02Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kUK/0
19D0D/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^l^kbk_6^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kUK/4U@0Xbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`;604;;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/10000C[/2U@>k00>E^k/00[/00iFk^`0N^`:E0k/00iFk^`02^`03
UK^k01jk0YD3^`03UK^k00:k00>E^k/07[/2U@>k00>E^k/00[/00iFk^`0W^`?60k/00lJk^`0I^`:E
0k/00iFk^`02^`03UK^k02Nk00?6^k/0@;/10000053;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`BE02O;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/019D09k_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`04U@0Wbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00BE036kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00C6
01g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04U@1a^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0005>k00>E^k/0:;/00iFk^`0X^`03UK^k02Rk
00>E^k/0<[/00lJk^`0N^`03UK^k02bk00?6^k/0@;/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^eZk00?6^k/0@;/100000?o;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk
0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00003/bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2aP2^bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@000>bk00C6^lK6[;/100000?o;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_6^l^kbk_;^l^k
bk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003/^`;60k/2aRBk
00?6^k/0P[/100000>k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^lJk0/H00l_6b`03aP2Vbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`40003[^`03a[^k00:k0/H4^`03a[^k01fk00?6^k/0Pk/1000004[;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6
ok_;^`:E02C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiD2aP0Ybk^EUL^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD00/H0:K_;UIFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^E00;602?;^iFEbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02aP04
^l^kU@;602>kbiG6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02aP04bk_;U@;602W;^iFE
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kU@02aP1C^l^EUK_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00@0004Bk00>EaYD00/H00k^E^`02UB6k00>EaYD00/H00iFkU@02UB6k00>EaYD00/H00iFk
U@02UB6k00>EaYD00/H00iFkU@02UAjk0/H01;^EaYD2aP03ULJE00:E7[/2aP04^iG6U@;600>E^iD0
0YDQ^`03ULJE00;600>E^iD00YE<^`400000kl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^iG6bk_;^iFkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^Ea[_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk^Ea/^kULK;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkbiG6^l^kbiG;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?600?;^iD00/H08k_;^iFkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^k00?607nkbiG6^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^iG6bk^Ea/^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00400014^`03ULK600:k00>Ea/H00[/00iFk^`0N^`03
ULK600:k00>Ea[/00[/00iFk^`0N^`03ULK600:k00>Ea/H00[/00iFk^`0N^`03ULK600:k00>Ea/H0
0[/00iFk^`0N^`03ULK600:k00>Ea[/00[/00iFk^`0N^`03ULK600:k00>Ea[/00[/00iFk^`0N^`03
ULK600:k00>Ea[/00[/00iFk^`19^`400000?/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0YD01l^kbk_;^iD00/H00k_;^`03aP0K^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^E00;600K;^l^kbiD2aP0PblK;^l^Ebk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/2U@07bk_;^l^kU@02aP03^l^k00?601Zkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`:E
00Nkbk_;^l^E00;600?;^l/00lH06/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0YD01l^kbk_;^iD0
0/H08K_6^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;U@02aP06bk_;^lJE0/H08<^kbk_;UL^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0YD01l^kbk_;^iD00/H0DK_6^l^kUK_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^`010000?[/019FkUID6^`03ULJk00>k00>Ea[/06;/00iG6U@02aPFk00>Ea/H00k/00iFk^`0H^`04
UK^EU@Jk00>Ea[/00k/00iG6^`0H^`04UK^EU@Jk00>Ea[/00k/00iG6^`0H^`04UK^EU@Jk00>Ea/H0
0k/00iFk^`0H^`03UK^E00;60[/01LJk^iG600Bk00>E^k/06;/019FkUID6^`03ULK600>k00>Ea/H0
BK/1000004;;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^iFkbk/2U@0Zbk_;^l^Ea[_;^iG6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^E
0/H0:<^kbk^Ea/^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk/2U@0Ybk_;^l^Ea[_;^iG6
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l/00YD0:K_;^l^kULK;^l^Ea[_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk^E^l^k00:E02[;^l^kbiG6^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^k
biD3aP0W^l^kULK;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^k00:E00K;^l^kbiD2aP05
bk^Ea//00/H0Ak_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040000m^`03UK^k00Bk0YD3^`03ULJk00:k00>Ea[/00[/2UA>k
00>Ea[/01;/00iG6aP02^`03ULJk00:k00BE^k^k0YDD^`03UK^k00Bk00>Ea/H00[/00iG6^`02^`05
ULJk^iD00/HC^`03UK^k00Bk00>Ea/H00[/00iG6^`02^`05ULJk^iD00/HC^`03UK^k00Bk0YD3^`03
UK^k00:k00BE^k^k0YDD^`03UK^k00Bk00>Ea[/00[/00iG6^`02^`04UK^k^`:E5;/00iFk^`04^`03
ULK600:k00>Ea[/01<H2^`03ULJk04Fk0@00000mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02U@07^l^kbk_;^`02U@07biG6^l^kU@02aP0H
^l^EbiG;^l^kbk_;^l^kbk_;^l^kbk^E0/H01k_;^l^kaYD01<H01<^kbiD2aP03biG;00:E01:kbk_;
^l^kbk_;^l^kbk_;^l/2U@08^l^kbk_;aYD4aP04^l^kU@;601NkULJEa/^kbk_;^l^kbk_;^l^kbk_;
^`02U@08bk_;^l^kaYD4aP04bk_;U@;601O;ULJEa[_;^l^kbk_;^l^kbk_;^l^kb`02U@07^l^kbk_;
^`02U@06biG;^l^k0YD01<^kUK/2U@0Bbk_;^l^kbk_;^l^kbk_;^l^k0YD01l^kbk_;^l/00YD01[^E
a/^kb`:E00BkbiG;0YD04[_;^l^kbk_;^l^kbk_;^l^kb`:E00Rkbk_;^l_6U@C600Bkbk^E0/H00k^E
aP02U@14bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/10000?k/2U@Nk0YD2aPBk00BEa[^E0[/00iFk^`0A^`03ULK600>k00?6^k/0
0YD2aP>k00C6ULJE0k/00iFk^`0A^`:E1;/00lJk^`02U@03a[^k00>k00BEaYG60[/00lJk^`0A^`:E
1;/00lJk^`02U@03a[^k00>k00BEaYG60[/00lJk^`0A^`:E1k/2U@Jk0iD3^`03UK^k016k0YD7^`:E
00?6^k/00k/3U@>k00>E^k/04K/2U@Bk00?6^k/00YD2aP>k00G6ULJEaP02^`03UK^k046k0@000011
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00YD02K_;^l^kbiG;^`02aP0Obk_;^lJEbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kU@03aP07
bk_;^iG6b`02aP0N^lJkblJE^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;0YD03k_6^l^kbiG;^l^kbk_;
^`02aP0Hbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^k0YD03l_6bk_;^iFkbk_;^l^kb`02aP0H^l^ka[_;
^l^kbk_;^l^kbk_;^l^kbk_;0YD03k_;^l^kbiG;^l^kbk_;^`02U@0Hbk_;UL^kbk_;^l^kbk_;^l^k
bk_;^l^k0YD03l^kbk_;^iFkbk_;^l^kb`02U@0H^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;0YD02K_6
^l^kbiG6^`02aP04blK;^`;604K;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004>k00>E^k/02;/00lJk^`02^`05a[^k^iD0
5[/00iG6^`04^`04a[^k^`;60k/01LJk^k^E01Jk00>Ea[/03K/01LJk^k_601Jk00>Ea[/03K/01LJk
^k_601Jk00>E^k/03K/01IFk^k^E01Jk00>E^k/03K/01IFk^k^E01Jk00BEa/K60k/01<Jk^k/2aP>k
00G6^k^kU@12^`400000Cl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l/00/H0:K_;a/^kbiG;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kUK_;^l^kblK;^l^k00;60<g;^lJkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^k
bk_;^l^kbk_;^l^kbk_;ULJkbk_;^l^kbk_;^l^kbk_;^l^kbk^Ea/^kbk_;^l^kbk_;^l^kbk_;^iG6
bk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;00C600Bkbk_;
0/H0BK_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/00@0004>k00>E^k/00k/2U@Jk1<H2^`:E5K/00iFk^`03^`03ULK600Fk
1<H2^`:E5K/00iG6^`03^`03ULK600^k00>Ea[/05;/00iG6^`03^`03ULK600^k00>Ea[/05;/00iFk
^`03^`:E3;/2UAFk00>E^k/00k/2U@bk0YDE^`03UK^k00>k00>Ea[/00k/01<Jka/H4^`:E@K/10000
04_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;UL^kbk_;UL/00YD03;_;^l^kbiG6^l^kb`:E01bkbk_;^l^kbk_;^l^kbk_;^l^kUK_;
^l^kULJE0lH02/^kbk^Ea/^kbk/2U@0Lbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^kbiG6U@?600Fkbk_;
U@02aP03bk_600:E01bkbk_;^l^kbk_;^l^kbk_;^l^kULK;^l^kULJE0lH01L^kbk^E00;600>kblH0
0YD06l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^Eb`02U@06^l^kbk_;0YD01;_;^l/2U@0K^l^kbk_;
^l^kbk_;^l^kbk_;^iFkbk_;^iFk00:E00K;^l^kbk/2U@04bk_;^`:E01_;^l^kbk_;^l^kbk_;^l^k
bk_;UL^kbk_;UL/00YD03;_;a/^kblJE^l^kb`:E03nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004>k0iD3^`05UK^k^iD01K/019Fk
UID4^`03UK^k012k0iD3^`07ULJk^iFkaP03^`04UK^EU@Bk00>E^k/04;/019G6a/H2^`07ULJk^iFk
aP03^`03ULJE00?60[/00iFk^`0@^`04ULK6aP:k00NEa[^kUK_600>k00>EaYD00lH2^`03UK^k012k
0iD3^`05UK^k^iD01K/019FkUID4^`03UK^k012k0iD3^`05UK^k^iD01K/019FkUID4^`03UK^k012k
0iD3^`06UK^k^iFk0/H2^`04a[^EU@Bk00>E^k/0?;/1000004K;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k19D03L^kbk^E^l^k
biG;^l/00YD06;_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kb`BE00g6bk_;ULJkbk^E^l^k00:E01W;^iFk
bk_;^l^kbk_;^l^kbk_;^l^kbk^E00C602Nkbk^Ea/^kbiG6^l^Ea[_;UL^kbk_;^l^kbk_;^l^kbk_;
^l^kbiD01<H09/^kbiG6^l^kULK;^iG6bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^k19D03L^kbk^E^l^k
biG;^l/00YD06;_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kb`BE00fkbk_;UL^kbk^E^l^k00:E01S;^iFk
bk_;^l^kbk_;^l^kbk_;^l^kbk/4U@07bk_;^iFkb`03aP03bk_;00:E046kbiG;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000BK/00iFk
^`02^`03UK^k00:k00>E^k/00k/3UARk00>Ea/H00[/00iG6^`02^`03UK^k00>k0iDH^`03ULJk00:k
00>Ea[/00[/00iG6^`03^`>E6;/00iG6^`02^`03ULJk00:k00>Ea[/00k/3UARk00>E^k/00[/00iFk
^`02^`03UK^k00>k0iDH^`03UK^k00:k00>E^k/00[/00iFk^`03^`>E6;/00iFk^`02^`03UK^k00:k
0/H4^`>E?[/1000005?;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kb`02U@0R^l^kbk_;UL^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kb`C600>kbk/00YD0:/^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iG6bk_;U@;602W;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^kU@02aP0X
^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kb`:E02Vkbk_;^l^Ebk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^`02U@1`bk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kUK_;^l^Ea[_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40001>^`03UK^k00Bk0YDR^`03ULJk00Bk0YDR^`03ULK600Bk
00>Ea/H08K/00iG6aP04^`03ULK6026k00>E^k/01;/2UB:k00>E^k/01;/2UB:k00>E^k/01;/2UD>k
0@00002Wbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbiG;^l^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l/00lH0:<^k
biG6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk/3aP37^l^kULK;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^Ebk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;UL^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^`010000C[/00iFk^`06^`03UK^k01nk00>E^k/01[/00iFk^`0O^`03UK^k00>k0/H00k^EaP0P^`03
UK^k00>k0/H00k^EaP0P^`03UK^k00Jk00>E^k/07k/00iFk^`06^`03UK^k01nk00>E^k/01[/00iFk
^`10^`400000Dl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;00:E02VkbiG;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^Ebk_;^`02U@0Ybk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
UK_;^l/00YD0:K_6a/Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^k00:E02W;a/K6
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kb`02U@0Y^l^Ebk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk/00YD0:L^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iFkbk_;00:E04FkbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004jk00>E^k/00[/00iFkU@03UB2k00>E^k/00[/00iFk
U@03UB2k00>E^k/00[/00iFkU@02U@03a[^k01jk00>E^k/00[/00iFkU@02U@03a[^k01jk00>E^k/0
0[/00iFkU@03UB2k00>E^k/00[/00iFkU@03UB2k00>E^k/00[/00iFkU@02UD:k0@00001>bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0YD0:L^kbiG;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00:E
02Vkbk^E^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02U@0Ybk_;UL^kbk^E^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD0:K_;^iFkbk_;UL^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^k00:E02W;^l^Ebk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`02U@0Y^l^kUK_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00YD0B/^kbiG;^l^E
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0@00052k19DW^`BE9k/4UBNk19DW^`BE9k/4UBNk19E6^`400000ol^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk
0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk
0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;000Obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02U@1l
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`400014^`03ULKo00>k0YDS^`03ULK600:k0YDT^`03ULK600:k0YDT^`03ULK600:k0YDT^`03
ULK600:k0YDS^`06a[_6aYFk0YDO^`;60k/00iG6aP02^`:ECk/1000004O;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6U@02aP03
^iFk00:E02C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^EaYD2aP03UK^E00:E02Bkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^EaYD2aP03UL^E00:E02C;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^EaYD2aP03UK^E00:E02Bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk^EaYD2aP03UL^E00:E02C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkbk/2aP0S
bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a//00/H01;^EaYD2aP03UL^E00:E04c;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0@0004Bk00JEa[^kULH4^`03UK^k01jk00JEa[^kULH4^`03UK^k01jk00JEa[^k
ULH4^`03UK^k01jk00JEa[^kULH4^`03UK^k01jk00JEa[^kULH4^`03UK^k01Rk0YD2^`03ULK600Bk
0/H00iFk^`0L^`04a[^k^`?60[/00iG6^`03^`03UK^k04Vk0@000015bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E00;600>kbiD0
0/H0Cl^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkbk^Ea/^kbiG;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD00/H0;[_;ULJkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^Ea[_;^iD2aP0T^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E0/H0:K_;
ULJkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^EbiG;^l^E00;602W;^l^Ea[_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kblK;^l^kU@02aP03^l^E00;604k;^iFkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000
?[/2U@Jk00>Ea/H00k/3aQZk0YD5^`03aYFE00:k00G6^k^kU@0J^`:E1[/01IG6a[_600>k00>E^k/0
6;/2U@Fk00?6UID01;/3aQZk0YD6^`05ULK6^lH00k/00iFk^`0G^`05UK^k^iD01K/01LJk^iG601fk
00>Ea[/01K/00iG6aP03^`?6Bk/10000043;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFk0YD0:L^kbk_;^iG6bk_;^iG6bk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbiG;00:E02Vkbk_6^l^EblK;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E
^`02U@07bk_;^l^kU@02aP04^l^kU@;601Zkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Eb`:E02Vkbk_6
^l^Ebk_;^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^`02U@07bk_;^l^kU@02aP0M^l^kUK_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00YD00l^kb`02U@0;^l^ka[_;ULJkbiD00/H06/^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^iG60YD0F<^kbk_;^iG6bk_;^iG6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000?[/019Fk
^k/2U@Fk00>Ea[/00[/00iG6^`0H^`04UK^k^`:E00>ka[/00[/00iG6aP02^`03UK^k01Rk00BE^k^k
0YD5^`03ULK600:k00>Ea[/00/HF^`04UK^k^`:E00>ka[/00[/00iFk^`02^`03ULJk01Rk00BE^k^k
0YD5^`03ULJk00:k00>E^k/06K/2U@>k0iD01<Jk^iD2aP05^iG6ULH00k/2aQ:k00BEa[^k0YD5^`03
ULJk00:k00>Ea[/0BK/1000004G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^iD00/H03;_;ULJkbk^Ea/^kb`;602:kbk_;^l^kbk_;
^l^kbk_;^l^kUK_;^l^kbiG6^l^kUK_;0lH00l^kb`02U@0L^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;
^l^kU@;600FkbiG6^`04aP0Pbk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbiD2aP0<bk^E^l^k
biG6^l^E0/H06/^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^k0YD03<^kbiG;^l^kUK_;^`:E02C;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbiG6^l^kbiD3aP0]^l_6a[_6^lJkbk_;^l^kbk_;^l^kbk_;
ULJkbk_;^iG6bk_;UL^kbk^Ea/^k00:E04K;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0003fk0YD6^`03aYG600?60k/00iG6
aP02^`04a[_6aQ6k00>Ea/H01K/01LJEUK^E00Bk00JEa/JkUK/2UA:k0YD6^`03aYG600?60k/01YG6
a[^EaP:E4[/2U@Nk00BEa/K61;/029G6a[^EaYG64[/2U@Nk0YD00k^E^`03^`:E0[/019FkUIDG^`03
UK^k00:k00?6^k/01;/01YG6^k^E^`;60[/00lJk^`0=^`03ULK600Fk00G6UIFkU@04^`06ULK6^iFk
0YE4^`400000?l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`02U@07^l^kblK;^`02U@0Qa[_;^l^kULK;a/^kULK;^l^kbk_;^l^kbk_;^l^k
blJE00;600Jkbk_6^l/2U@0P^l^kbk_;ULJEbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l/2U@07^l^kblK;
^`02U@;601k;^l_6ULJEa/^kUK_;^l^kbk_;^l^kbk_;^l^kbk/2U@07bk_;^l^kb`02U@0Pa/^kbk_;
ULJEa[_;a/^kbk_;^l^kbk_;^l^kbk_;^l/2U@07^l^kbk_;^`02U@06bk_;^l^k0iD0@k_;^iFkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_6^l^kbk_;^l^kbiG;^lJkblK;^l^kbk_;^l^kbk_;^l^kbiD0
0/H01/^kblK;^`:E053;^l^kblJEaYFkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`400011^`:E00>ka[/00k/00iFk^`06^`;6
0k/00iG6^`0?^`04a[^kU@?61;/00iFk^`06^`03aYFk00:k00>E^k/04[/2U@03^lJk00>k00>Ea[/0
0/H01;_6^k/2aP>k00>E^k/04[/2U@Jk00>Ea[/01[/2aP>k0/HC^`:E1[/00iFk^`06^`:E0k/00iFk
^`0C^`05UK^k^iD00/H9^`:E1K/00lJk^`0@^`04ULK6aPBk00>E^k/00k/01LJk^lJE00>k00>E^k/0
@;/1000007k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;ULJkbk_;^l^kbk_;^l^kblK;^l^Ea[_;^l^kbk_;^l^kbk_;^l_6bk_;^iG6
bk_;^l^kbk_;^l^kbk/2aP0Jbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiD3aP07^l^ka[_;^`02aP0O
bk_;a/^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kU@03aP0Bbk_;a/^kbk_;^l^ka[_;^iFk0/H0?L^k
bk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;UL^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0YD01K_;UL^E00;600?;^l/00YD01[_;^l^Eb`;606fka[_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkbk_;
^l^kbk_;a/^kblK;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k00400013^`03ULJk016k00>Ea[/03k/2aP>k00>E^k/03k/3aQJk
00BE^k^k1<H4^`;61[/00iFk^`0D^`04ULJk^`C63;/01IFk^k_601:k00>E^k/04K/00iFk^`0E^`>E
0k/01YG6^k^E^`:E0k/00iG6^`02aQBk00>Ea[/02K/01LJk^k_600>k00>E^k/0@;/1000004[;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;ULJkbk_;U@;601o;^l^kbk_;^l^kbiG6^l^kbk_;^l^kbk_;^l^kbk_;00;600NkUK_;^l^k00:E
037;^l^kbk_;^l^kbk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbiG6^l^kblK;00?600?;^l/0
0YD0:K_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk_;^iG6bk_;^l^kbk_;^l^k00:E01_;^lJkbk_;^l^k
bk_;^l^kbk_;^l^Ebk_;^l/00YD03;_;^l^kbk_;^l^kb`:E01Vkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^E00;600W;ULJkbiG;^l/019D07lK;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^kbiD00/H02l^k
bk_;^l_6bk_;00:E046kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`010000@k/00iG6^`03^`03ULJE00?61;/00iG6aP02^`03aYFE01:k
0/H5^`04UK^EU@Jk00>Ea/H00[/00lJEU@0C^`03UK^k00>k00BE^iFE0[/01/Jk^k^EaPBk0YDC^`03
ULJk00>k00BE^iFE1[/2U@Bk0YD00k_6^`0@^`03UK^k00>k00BE^iFE1[/2U@Bk0YDG^`03a[_600;6
0[/3U@Bk00>Ea/H05[/00iG6^`03^`03UK^E00?61;/00lJE^`03^`:E?k/1000004C;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;U@?6
00nkbiG6^l^EblK;^l^EaYD00lH05[_;UL^kbk_;^l^kbk_;^l^kbk_;^iD3aP0?bk^E^l^kUK_;^l^k
ULJE00?601G;^iFkbk_;^l^kbk_;^l^kbk_;^l/00iD02L^kbiG;^l^Eb`02aP04^l^EaP:E02Vkbk_;
UL^kbk_;^l^kbk_;^l^kbk_;^iG6UK_;^iFkbk^E^l^kbk^E^`02U@0Gbk_;^iG6bk_;^l^kbk_;^l^k
bk_;^l/00iD03l^kbiG;^l^Ebk_;^l^Eb`02U@0U^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;
ULJkbk_;^`02U@0Lbk_;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;U@?600RkbiG;^l^Eb`;600BkblK;
0YD0@k_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00@0004Jk00>Ea/H00/H3^`03ULJk00:k00JEa[^kULH2^`03UK^k01>k00BEa/K6
1;/00iFk^`02^`06ULJk^iG60[/00iFk^`0C^`BE1;/00iFk^`02aP04ULJk^`:E0[/00iFk^`0A^`03
a[^E00>E1;/00iFk^`02^`05UK^k^iD00/H00k^EaP0D^`BE1;/00iFk^`02^`04UK^k^`:E0[/00iFk
^`0D^`04a[^kU@Nk00>E^k/01;/00lJk^`0E^`04ULK6aPBk00>Ea[/00lH3^`:E0[/00iFk^`0l^`40
0000FL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^Ea[_;^iG6bk_;ULJkbk_;00>E01W;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk^E00;600fkbiG;^l^kULK;^l^k00>E02:kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^iFkbk_;
0/H01;_;^l/3U@0Ybk_;^l^kbk_;^l^kbk_;^l^kblK;^l^kUK_;^l^Ebk_;^iFkbk_;aYD00lH09l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk^E^l^kbiG;^l^kb`03U@0Mbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^lJkbiG;^l/00iD09<^Ebk_;^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;U@;600O;^iG6
bk_;00;600Bkbk_;0iD0?/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^k0@0004jk00>Ea[/00[/00iG6aP05^`03UK^k01Vk0lH4^`03ULJk00Fk
00>E^k/06k/00iFk^`02^`03ULJk00Fk00>E^k/04K/00lJk^`07^`03UK^k00:k0YD3^`05a[^kULH0
7;/00iFk^`02^`:E1[/00iFk^`0C^`05a[^k^iD00/H01K^E^k^E00;61K/00lJk^`0K^`C60k/00iG6
^`05^`03UK^k03bk0@00001?bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kU@02aP05^l^kbiD00/H0:<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^kblH2U@0Ybk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^iFkbk_;^l/00YD06;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;600Vkbk_;^l^kbiD0
0/H01<^kbk/2U@0YblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l/00YD06[_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0/H01K_;^lJE00;600G;^l_6b`02aP0Z^l^ka[_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^Ea/^kbk_;0YD0@k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004jk00>E^k/00lH3^`03
ULJk01nk00>Ea[/00k/01<Jk^iDQ^`03UK^k00Jk00>E^k/05k/3aPFk00>Ea[/00lH3^`03ULK601nk
00>E^k/01[/00iFk^`0I^`C60[/01YG6a/JkaP:k00C6^k_67k/00iFk^`06^`03UK^k042k0@00001D
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^k0/H0M<^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;ULJkbk_;a/^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbiG;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0/H03l^kbiG6^l^kblK;^iFkb`02aP1<^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;
^l^kb`;6076kblK;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;UL^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^`010000C[/00iFk^`02^`:E00Bka/K68;/00iG6^`02^`05ULJk^iD08K/00iFk^`02^`:E0[/00iFk
^`0L^`;600>kULH00k/01IG6^k^E00Bk00?6^k/06[/00iFk^`02^`:E0[/00iFk^`0W^`03a[^k00?6
7K/00iFk^`02^`:E0[/00iFk^`10^`400000EL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;UL/00iD0:<Jk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^kULH4U@0Wbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk^E^l^kbiG;00BE01nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?6
00Fkbk^EaP04U@0Wbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbiG;00BE02Rkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0/H01;_;^l/2aP0R^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kUK_;^l^Eb`>E04;;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000C[/2U@>k00>E^k/00[/00iFk^`0N^`03
ULK600:k00>Ea[/00[/00iFk^`0N^`:E0k/00iFk^`02^`03UK^k01jk00>Ea[/00[/00iG6^`02^`03
UK^k00:k00?6^k/06K/2U@>k00>E^k/00[/00iFk^`0X^`;60k/00lJk^`0I^`:E0k/01IFk^k^E04:k
0@00001@bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/4U@0Xbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;U@C602K;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`BE02O;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/019D09lK;^l^kbk_;^lJkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`04U@0abk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`04aP0M^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/019D0A/^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/10000Dk/00iFk^`0X^`03ULJk02Rk00>E^k/0:;/00iG6aP02aPFk00?6^k/07[/00iFk^`0b^`03
a[^k01jk00>E^k/0A;/100000=W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?6
0<3;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/10000g;/3a[fk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00003o
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000
ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;0040003o^ifk0@000009bk_;^l^kbk_;00Go00K;^l^kbk/2o`06bk_;^l^k
0_l01l_oooo;^l/00ol01<^kbk/3o`03^l^k00;o00K;oooobk/3o`03^l_o00?o0?nkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/005Zkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/100002[/2o`Rk0_l5^`;o00Nkoooo
^onk00;o0[/01?nk^k/2o`03^onk00;o00Nkoooo^onk00;o00Bkok_o0[/2oonkFK/1000000_;^l^k
bk_;^l^kb`02o`08^l^kbk_;^l/2o`04^l^kb`;o00>kbol00ol02[_ool^kboo;^l/2o`06^l_ook_;
1?l01K_;oonk00;o0?o;^ooobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/005g;^ooobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00@0000^k0_l8^`;o1;/2o`>k0_l2^`;o1k/2o`:k0_l3^`;o0k/2o`Fk0_oo^eVk0@00000;
bk_;^l^kbk_;^l/00_l02;_;^onkbk_;0ol01<^kbk/2o`06bk_ool^k0_l01l^kbk_;^l/00_l00k_;
^`02o`07bk_ool^kb`02o`04^l^kb`;o0?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/005Zkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l/100002k/2o`>k00?o^k/00[/3o`Bk0_l2^`;o0k/2o`:k0_l2^`;o0k/2o`:k
0_l3^`;o0k/2o`:k00?o^k/0ok]F^`4000003<^kbk_;^l^kbk_;^`Ko00C;^l^k0ol01;_o^l/2o`07
^ooook_;^`02o`06bk_o^l^k0_l00l^kb`02o`07^ooook_;^`02o`1kbk_ool^kok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00Go00C;^l^k0ol00k_;
o`02o`0Cbooool_obk_;^l^kbk_;ol^kb`04o`2k^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`0100003;/2o`>k00Co^k^k0ol00k_o
o`03^`;o00>kool01;/3o`:k1Ol3^`;o00>kool00k/2o`>k1?mc^`03ok^k00>k00Co^k_o0k/01?nk
^ol3^`03ok^k00Zk00Co^k_o1;/00onk^`2h^`4000003<^kbk_;^l^kbk_;^`;o023;^l_obk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o00c;^l^kbk_;^l^kbk/2o`2Gbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l^kbk_o^l_obk_;^l^k
ok_;^onkbk_;^l^kb`08o`2o^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0000bk0_lQ^`03ok^k00Zk0_mi^`03ok^k00Bk
00Co^k_o1[/01Onk^k_o00Rk00Go^k^ko`02^`03ok^k00:k00?o^k/0^;/1000000g;^l^kbk_;^l^k
bk_;00;o02jkbk_;ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l0O[_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;
^l^kb`?o00?;ool00ol0e/^kok_;^onkbk_;^l^kbk_o^l_obk_o^l^kboo;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/100003K/2o`Bk
00?o^k/09k/2ogRk00?o^k/01k/01Onk^k_o00:k0_l2^`03ok^k00Rk00?o^ol00[/00onk^`02^`03
ok^k0;Rk0@00000;bk_;^l^kbk_;^l/02Ol0:<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/3o`23^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;ol^kbk_;^l^kbk/00ol01K_;oonk00;o0=3;^l^kbk_;^l^kboo;ol^kok_;^l_o
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0@000;Nk00?o^k/01;/00onk^`0G^`;o0[/00onk^`02^`03ok^k0;Rk0@00002mbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^onk
bk_;00;o01Vkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o0<;;^onkbk_;ol^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40002i^`Co
00>kok/06K/01?nk^k/4ok^k0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
09g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000\
\>"],
  ImageRangeCache->{{{0, 412}, {255, 0}} -> {-0.0250052, -0.0257715, 
  0.00254857, 0.00412367}, {{9.8125, 402.188}, {248.75, 6.1875}} -> {-1.35563,
   -0.271688, 0.0235711, 0.0235711}, {{57.5, 96.5625}, {243.438, 204.375}} ->
   {-0.275471, -0.325492, 0.00988084, 0.0266765}, {{100.438, 139.562}, {
  243.438, 204.375}} -> {-0.988956, -0.326976, 0.012208, 0.0261164}, {{
  143.438, 182.5}, {243.438, 204.375}} -> {-1.4082, -0.330456, 0.0115687, 
  0.0264174}, {{186.438, 225.5}, {243.438, 204.375}} -> {-1.54948, -0.325492, 
  0.00988084, 0.0266765}, {{229.438, 268.5}, {243.438, 204.375}} -> {-2.40311,
   -0.330456, 0.0115687, 0.0264174}, {{272.375, 311.5}, {243.438, 204.375}} ->
   {-2.9002, -0.330456, 0.0115687, 0.0264174}, {{315.375, 354.438}, {243.438, 
  204.375}} -> {-3.11348, -0.334833, 0.0107358, 0.0267959}, {{57.5, 96.5625},
   {200.438, 161.375}} -> {-0.275471, -1.47258, 0.00988084, 0.0266765}, {{
  100.438, 139.562}, {200.438, 161.375}} -> {-0.911112, -1.4664, 0.0115687, 
  0.0264174}, {{143.438, 182.5}, {200.438, 161.375}} -> {-1.4082, -1.4664, 
  0.0115687, 0.0264174}, {{186.438, 225.5}, {200.438, 161.375}} -> {-1.90566,
   -1.4664, 0.0115687, 0.0264174}, {{229.438, 268.5}, {200.438, 161.375}} ->
   {-3.52867, -1.39503, 0.0160565, 0.0251094}, {{272.375, 311.5}, {200.438, 
  161.375}} -> {-2.9002, -1.4664, 0.0115687, 0.0264174}, {{315.375, 354.438},
   {200.438, 161.375}} -> {-3.3973, -1.4664, 0.0115687, 0.0264174}, {{57.5, 
  96.5625}, {157.5, 118.375}} -> {-0.414019, -2.60153, 0.0115687, 0.0264174},
   {{100.438, 139.562}, {157.5, 118.375}} -> {-0.908894, -2.59659, 0.0115502, 
  0.0263752}, {{143.438, 182.5}, {157.5, 118.375}} -> {-1.4082, -2.60153, 
  0.0115687, 0.0264174}, {{186.438, 225.5}, {157.5, 118.375}} -> {-1.90566,
   -2.60153, 0.0115687, 0.0264174}, {{229.438, 268.5}, {157.5, 118.375}} ->
   {-2.50999, -2.57913, 0.0119949, 0.0261878}, {{272.375, 311.5}, {157.5, 
  118.375}} -> {-2.89481, -2.59659, 0.0115502, 0.0263752}, {{315.375, 
  354.438}, {157.5, 118.375}} -> {-1.89168, -2.51694, 0.00712345, 0.0259305},
   {{57.5, 96.5625}, {114.5, 75.4375}} -> {-0.414019, -3.73665, 0.0115687, 
  0.0264174}, {{100.438, 139.562}, {114.5, 75.4375}} -> {-0.911112, -3.73665, 
  0.0115687, 0.0264174}, {{143.438, 182.5}, {114.5, 75.4375}} -> {-1.4082,
   -3.73665, 0.0115687, 0.0264174}, {{186.438, 225.5}, {114.5, 75.4375}} ->
   {-1.90566, -3.73665, 0.0115687, 0.0264174}, {{229.438, 268.5}, {114.5, 
  75.4375}} -> {-2.40311, -3.73665, 0.0115687, 0.0264174}, {{272.375, 311.5},
   {114.5, 75.4375}} -> {-2.9002, -3.73665, 0.0115687, 0.0264174}, {{315.375, 
  354.438}, {114.5, 75.4375}} -> {-3.3973, -3.73665, 0.0115687, 0.0264174}, {{
  57.5, 96.5625}, {71.5, 32.4375}} -> {-0.414019, -4.8726, 0.0115687, 
  0.0264174}, {{100.438, 139.562}, {71.5, 32.4375}} -> {-0.911112, -4.8726, 
  0.0115687, 0.0264174}, {{143.438, 182.5}, {71.5, 32.4375}} -> {-1.4082,
   -4.8726, 0.0115687, 0.0264174}, {{186.438, 225.5}, {71.5, 32.4375}} ->
   {-1.90566, -4.8726, 0.0115687, 0.0264174}, {{229.438, 268.5}, {71.5, 
  32.4375}} -> {-2.40311, -4.8726, 0.0115687, 0.0264174}, {{272.375, 311.5}, {
  71.5, 32.4375}} -> {-3.05247, -4.82473, 0.0120871, 0.0261565}, {{315.375, 
  354.438}, {71.5, 32.4375}} -> {-3.3973, -4.8726, 0.0115687, 0.0264174}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Generation 60"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .95229 
MathPictureStart
%% Graphics3D
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-3.75585e-05 1.06867 0.0267167 1.06867 [
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 60)] .5 .95229 0 -1.5 Msboxa
P
[(0)] .08595 .18034 -0.06484 1 Msboxa
[(10)] .23556 .13958 -0.04346 1 Msboxa
[(20)] .40028 .0947 -0.01962 1 Msboxa
[(30)] .58253 .04506 .00711 1 Msboxa
[(Indiv.)] .35928 .03957 -0.02584 1 Msboxa
[(Gen.)] .91594 .16872 -1 .22094 Msboxa
[(0)] .04482 .42044 1 -0.20167 Msboxa
[(100)] .02806 .66858 1 -0.12168 Msboxa
[(Fit.)] -0.0283 .53856 1 -0.16726 Msboxa
[ 0 0 0 0 ]
[ 1 .95229 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 60)] .5 .95229 0 -1.5 Mshowa
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.08509 .19367 m
.08465 .20033 L
s
P
[(0)] .08595 .18034 -0.06484 1 Mshowa
p
.002 w
.23498 .15292 m
.23469 .15959 L
s
P
[(10)] .23556 .13958 -0.04346 1 Mshowa
p
.002 w
.40002 .10806 m
.39989 .11474 L
s
P
[(20)] .40028 .0947 -0.01962 1 Mshowa
p
.002 w
.58262 .05842 m
.58267 .0651 L
s
P
[(30)] .58253 .04506 .00711 1 Mshowa
p
.001 w
.11395 .18582 m
.11371 .18982 L
s
P
p
.001 w
.14336 .17783 m
.14314 .18183 L
s
P
p
.001 w
.17332 .16968 m
.17311 .17368 L
s
P
p
.001 w
.20386 .16138 m
.20367 .16538 L
s
P
p
.001 w
.2667 .1443 m
.26655 .1483 L
s
P
p
.001 w
.29905 .1355 m
.29892 .13951 L
s
P
p
.001 w
.33204 .12654 m
.33192 .13054 L
s
P
p
.001 w
.36569 .11739 m
.36559 .1214 L
s
P
p
.001 w
.43505 .09854 m
.43499 .10254 L
s
P
p
.001 w
.4708 .08882 m
.47076 .09283 L
s
P
p
.001 w
.5073 .0789 m
.50728 .0829 L
s
P
p
.001 w
.54456 .06877 m
.54457 .07277 L
s
P
p
.001 w
.6215 .04785 m
.62155 .05186 L
s
P
p
.001 w
.66122 .03706 m
.6613 .04106 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
p
.002 w
.69926 .02672 m
.93852 .30206 L
s
P
[(Gen.)] .91594 .16872 -1 .22094 Mshowa
P
p
p
.002 w
.07262 .19706 m
.02672 .88626 L
s
P
p
.002 w
.05792 .4178 m
.06447 .41648 L
s
P
[(0)] .04482 .42044 1 -0.20167 Mshowa
p
.002 w
.04132 .66697 m
.04795 .66616 L
s
P
[(100)] .02806 .66858 1 -0.12168 Mshowa
p
.001 w
.05469 .46628 m
.05863 .46555 L
s
P
p
.001 w
.05142 .51543 m
.05537 .51476 L
s
P
p
.001 w
.0481 .56525 m
.05206 .56464 L
s
P
p
.001 w
.04473 .61576 m
.0487 .61521 L
s
P
p
.001 w
.0611 .36997 m
.06502 .36912 L
s
P
p
.001 w
.06425 .32277 m
.06815 .32186 L
s
P
p
.001 w
.06735 .2762 m
.07124 .27523 L
s
P
p
.001 w
.07041 .23023 m
.07429 .22922 L
s
P
p
.001 w
.03786 .7189 m
.04185 .71848 L
s
P
p
.001 w
.03436 .77157 m
.03835 .77122 L
s
P
p
.001 w
.0308 .82498 m
.0348 .8247 L
s
P
p
.001 w
.02719 .87916 m
.03119 .87895 L
s
P
[(Fit.)] -0.0283 .53856 1 -0.16726 Mshowa
P
0 0 m
1 0 L
1 .95229 L
0 .95229 L
closepath
clip
newpath
p
p
.4 g
.002 w
.05792 .4178 m
.427 .56884 L
s
P
p
.4 g
.002 w
.04132 .66697 m
.42419 .75998 L
s
P
p
.4 g
.002 w
.08367 .20324 m
.03923 .88751 L
s
P
p
.4 g
.002 w
.21692 .2778 m
.18865 .90238 L
s
P
p
.4 g
.002 w
.32839 .34018 m
.31167 .91462 L
s
P
p
.4 g
.002 w
.423 .39313 m
.4147 .92487 L
s
P
p
.4 g
.002 w
.44013 .39481 m
.43312 .92519 L
s
P
p
.4 g
.002 w
.56602 .37138 m
.56847 .92068 L
s
P
p
.4 g
.002 w
.70138 .34619 m
.71482 .91579 L
s
P
p
.4 g
.002 w
.84733 .31903 m
.87358 .91049 L
s
P
p
.4 g
.002 w
.427 .56884 m
.94975 .49749 L
s
P
p
.4 g
.002 w
.42419 .75998 m
.96232 .71624 L
s
P
P
p
.35214 .34791 m .45808 .39844 L .44573 .40071 L 1 0 0 r
F
P
p
.36515 .34525 m .47051 .39615 L .45808 .39844 L 1 0 0 r
F
P
p
.35214 .34791 m .36515 .34525 L .45808 .39844 L 1 0 0 r
F
P
p
.37825 .34256 m .48303 .39384 L .47051 .39615 L 1 0 .767 r
F
P
p
.36515 .34525 m .37825 .34256 L .47051 .39615 L 1 0 0 r
F
P
p
.39146 .33986 m .49564 .39152 L .48303 .39384 L 0 .42 1 r
F
P
p
.37825 .34256 m .39146 .33986 L .48303 .39384 L 1 0 .767 r
F
P
p
.40477 .33713 m .50835 .38918 L .49564 .39152 L 0 1 .693 r
F
P
p
.39146 .33986 m .40477 .33713 L .49564 .39152 L 0 .42 1 r
F
P
p
.41819 .33439 m .52114 .38683 L .50835 .38918 L 0 1 .591 r
F
P
p
.40477 .33713 m .41819 .33439 L .50835 .38918 L 0 1 .693 r
F
P
p
.43171 .33162 m .53403 .38446 L .52114 .38683 L 0 1 .233 r
F
P
p
.41819 .33439 m .43171 .33162 L .52114 .38683 L 0 1 .591 r
F
P
p
.44534 .32883 m .54701 .38207 L .53403 .38446 L .057 1 0 r
F
P
p
.43171 .33162 m .44534 .32883 L .53403 .38446 L 0 1 .233 r
F
P
p
.45907 .32601 m .56008 .37966 L .54701 .38207 L .159 1 0 r
F
P
p
.44534 .32883 m .45907 .32601 L .54701 .38207 L .057 1 0 r
F
P
p
.47292 .32318 m .57325 .37723 L .56008 .37966 L .244 1 0 r
F
P
p
.45907 .32601 m .47292 .32318 L .56008 .37966 L .159 1 0 r
F
P
p
.48687 .32032 m .58652 .37479 L .57325 .37723 L .347 1 0 r
F
P
p
.47292 .32318 m .48687 .32032 L .57325 .37723 L .244 1 0 r
F
P
p
.50093 .31744 m .59989 .37233 L .58652 .37479 L .449 1 0 r
F
P
p
.48687 .32032 m .50093 .31744 L .58652 .37479 L .347 1 0 r
F
P
p
.51511 .31454 m .61335 .36985 L .59989 .37233 L .483 1 0 r
F
P
p
.50093 .31744 m .51511 .31454 L .59989 .37233 L .449 1 0 r
F
P
p
.52941 .31161 m .62692 .36735 L .61335 .36985 L .551 1 0 r
F
P
p
.51511 .31454 m .52941 .31161 L .61335 .36985 L .483 1 0 r
F
P
p
.54381 .30866 m .64059 .36484 L .62692 .36735 L .602 1 0 r
F
P
p
.52941 .31161 m .54381 .30866 L .62692 .36735 L .551 1 0 r
F
P
p
.55834 .30568 m .65436 .3623 L .64059 .36484 L .619 1 0 r
F
P
p
.54381 .30866 m .55834 .30568 L .64059 .36484 L .602 1 0 r
F
P
p
.002 w
.48065 .72513 m .46592 .90937 L .36601 .89759 L p
1 0 .767 r
F P
0 0 0 r
s
P
p
.002 w
.36601 .89759 m .38021 .89699 L .48065 .72513 L p
1 0 .767 r
F P
0 0 0 r
s
P
p
.002 w
.49399 .69606 m .48065 .72513 L .38021 .89699 L p
0 .42 1 r
F P
0 0 0 r
s
P
p
.002 w
.50723 .69476 m .49399 .69606 L .3982 .69605 L p
0 1 .693 r
F P
0 0 0 r
s
P
p
.002 w
.38021 .89699 m .3982 .69605 L .49399 .69606 L p
0 .42 1 r
F P
0 0 0 r
s
P
p
.57298 .30268 m .66823 .35975 L .65436 .3623 L .67 1 0 r
F
P
p
.55834 .30568 m .57298 .30268 L .65436 .3623 L .619 1 0 r
F
P
p
.002 w
.52061 .67352 m .50723 .69476 L .41227 .69464 L p
0 1 .591 r
F P
0 0 0 r
s
P
p
.002 w
.3982 .69605 m .41227 .69464 L .50723 .69476 L p
0 1 .693 r
F P
0 0 0 r
s
P
p
.002 w
.53402 .64035 m .52061 .67352 L .42652 .68885 L p
0 1 .233 r
F P
0 0 0 r
s
P
p
.002 w
.42652 .68885 m .44121 .65685 L .53402 .64035 L p
0 1 .233 r
F P
0 0 0 r
s
P
p
.002 w
.54747 .63884 m .53402 .64035 L .44121 .65685 L p
.057 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41227 .69464 m .42652 .68885 L .52061 .67352 L p
0 1 .591 r
F P
0 0 0 r
s
P
p
.58775 .29966 m .68221 .35718 L .66823 .35975 L .705 1 0 r
F
P
p
.57298 .30268 m .58775 .29966 L .66823 .35975 L .67 1 0 r
F
P
p
.002 w
.56099 .62935 m .54747 .63884 L .45566 .64655 L p
.159 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44121 .65685 m .45566 .64655 L .54747 .63884 L p
.057 1 0 r
F P
0 0 0 r
s
P
p
.60263 .29661 m .69629 .35458 L .68221 .35718 L .739 1 0 r
F
P
p
.58775 .29966 m .60263 .29661 L .68221 .35718 L .705 1 0 r
F
P
p
.002 w
.5746 .6238 m .56099 .62935 L .47019 .63618 L p
.244 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45566 .64655 m .47019 .63618 L .56099 .62935 L p
.159 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45261 .90987 m .43941 .91037 L .33797 .89877 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61764 .29354 m .71048 .35197 L .69629 .35458 L .79 1 0 r
F
P
p
.60263 .29661 m .61764 .29354 L .69629 .35458 L .739 1 0 r
F
P
p
.002 w
.58834 .62221 m .5746 .6238 L .48476 .6345 L p
.347 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47019 .63618 m .48476 .6345 L .5746 .6238 L p
.244 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46592 .90937 m .45261 .90987 L .35193 .89818 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.33797 .89877 m .35193 .89818 L .45261 .90987 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.63277 .29044 m .72478 .34934 L .71048 .35197 L .841 1 0 r
F
P
p
.61764 .29354 m .63277 .29044 L .71048 .35197 L .79 1 0 r
F
P
p
.002 w
.60218 .62061 m .58834 .62221 L .49955 .61091 L p
.449 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48476 .6345 m .49955 .61091 L .58834 .62221 L p
.347 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35193 .89818 m .36601 .89759 L .46592 .90937 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64803 .28731 m .73919 .34669 L .72478 .34934 L .892 1 0 r
F
P
p
.63277 .29044 m .64803 .28731 L .72478 .34934 L .841 1 0 r
F
P
p
.002 w
.61613 .619 m .60218 .62061 L .51432 .60473 L p
.483 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49955 .61091 m .51432 .60473 L .60218 .62061 L p
.449 1 0 r
F P
0 0 0 r
s
P
p
.24172 .28562 m .36515 .34525 L .35214 .34791 L .449 0 1 r
F
P
p
.66342 .28416 m .75371 .34401 L .73919 .34669 L .943 1 0 r
F
P
p
.64803 .28731 m .66342 .28416 L .73919 .34669 L .892 1 0 r
F
P
p
.002 w
.63018 .61737 m .61613 .619 L .52921 .5985 L p
.551 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51432 .60473 m .52921 .5985 L .61613 .619 L p
.483 1 0 r
F P
0 0 0 r
s
P
p
.25544 .28246 m .37825 .34256 L .36515 .34525 L .159 0 1 r
F
P
p
.24172 .28562 m .25544 .28246 L .36515 .34525 L .449 0 1 r
F
P
p
.67894 .28099 m .76835 .34132 L .75371 .34401 L 1 .972 0 r
F
P
p
.66342 .28416 m .67894 .28099 L .75371 .34401 L .943 1 0 r
F
P
p
.002 w
.64434 .61574 m .63018 .61737 L .54419 .58344 L p
.602 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52921 .5985 m .54419 .58344 L .63018 .61737 L p
.551 1 0 r
F P
0 0 0 r
s
P
p
.26927 .27926 m .39146 .33986 L .37825 .34256 L .04 0 1 r
F
P
p
.25544 .28246 m .26927 .27926 L .37825 .34256 L .159 0 1 r
F
P
p
.69458 .27778 m .78309 .3386 L .76835 .34132 L 1 .869 0 r
F
P
p
.67894 .28099 m .69458 .27778 L .76835 .34132 L 1 .972 0 r
F
P
p
.002 w
.65862 .61408 m .64434 .61574 L .55928 .58151 L p
.619 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54419 .58344 m .55928 .58151 L .64434 .61574 L p
.602 1 0 r
F P
0 0 0 r
s
P
p
.28322 .27605 m .40477 .33713 L .39146 .33986 L 0 .744 1 r
F
P
p
.26927 .27926 m .28322 .27605 L .39146 .33986 L .04 0 1 r
F
P
p
.71036 .27455 m .79796 .33587 L .78309 .3386 L 1 .767 0 r
F
P
p
.69458 .27778 m .71036 .27455 L .78309 .3386 L 1 .869 0 r
F
P
p
.002 w
.67285 .60425 m .65862 .61408 L .57448 .57513 L p
.67 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55928 .58151 m .57448 .57513 L .65862 .61408 L p
.619 1 0 r
F P
0 0 0 r
s
P
p
.29729 .2728 m .41819 .33439 L .40477 .33713 L 0 1 .489 r
F
P
p
.28322 .27605 m .29729 .2728 L .40477 .33713 L 0 .744 1 r
F
P
p
.002 w
.68733 .60255 m .67285 .60425 L .58983 .57315 L p
.705 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57448 .57513 m .58983 .57315 L .67285 .60425 L p
.67 1 0 r
F P
0 0 0 r
s
P
p
.72627 .27129 m .81293 .33311 L .79796 .33587 L 1 .716 0 r
F
P
p
.71036 .27455 m .72627 .27129 L .79796 .33587 L 1 .767 0 r
F
P
p
.31148 .26953 m .43171 .33162 L .41819 .33439 L 0 1 .472 r
F
P
p
.29729 .2728 m .31148 .26953 L .41819 .33439 L 0 1 .489 r
F
P
p
.002 w
.70192 .60083 m .68733 .60255 L .6053 .57115 L p
.739 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58983 .57315 m .6053 .57115 L .68733 .60255 L p
.705 1 0 r
F P
0 0 0 r
s
P
p
.74232 .26801 m .82803 .33033 L .81293 .33311 L 1 .716 0 r
F
P
p
.72627 .27129 m .74232 .26801 L .81293 .33311 L 1 .716 0 r
F
P
p
.32579 .26622 m .44534 .32883 L .43171 .33162 L 0 1 .335 r
F
P
p
.31148 .26953 m .32579 .26622 L .43171 .33162 L 0 1 .472 r
F
P
p
.002 w
.71653 .59497 m .70192 .60083 L .6208 .5602 L p
.79 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6053 .57115 m .6208 .5602 L .70192 .60083 L p
.739 1 0 r
F P
0 0 0 r
s
P
p
.75851 .26469 m .84324 .32753 L .82803 .33033 L 1 .631 0 r
F
P
p
.74232 .26801 m .75851 .26469 L .82803 .33033 L 1 .716 0 r
F
P
p
.34022 .26289 m .45907 .32601 L .44534 .32883 L 0 1 .182 r
F
P
p
.32579 .26622 m .34022 .26289 L .44534 .32883 L 0 1 .335 r
F
P
p
.002 w
.73112 .58495 m .71653 .59497 L .63653 .55813 L p
.841 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6208 .5602 m .63653 .55813 L .71653 .59497 L p
.79 1 0 r
F P
0 0 0 r
s
P
p
.77484 .26135 m .85858 .32471 L .84324 .32753 L 1 .511 0 r
F
P
p
.75851 .26469 m .77484 .26135 L .84324 .32753 L 1 .631 0 r
F
P
p
.002 w
.74604 .58314 m .73112 .58495 L .65239 .55604 L p
.892 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63653 .55813 m .65239 .55604 L .73112 .58495 L p
.841 1 0 r
F P
0 0 0 r
s
P
p
.35478 .25953 m .47292 .32318 L .45907 .32601 L 0 1 .114 r
F
P
p
.34022 .26289 m .35478 .25953 L .45907 .32601 L 0 1 .182 r
F
P
p
.7913 .25797 m .87403 .32186 L .85858 .32471 L 1 .426 0 r
F
P
p
.77484 .26135 m .7913 .25797 L .85858 .32471 L 1 .511 0 r
F
P
p
.002 w
.76081 .57301 m .74604 .58314 L .6683 .54942 L p
.943 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65239 .55604 m .6683 .54942 L .74604 .58314 L p
.892 1 0 r
F P
0 0 0 r
s
P
p
.36947 .25615 m .48687 .32032 L .47292 .32318 L 0 1 .063 r
F
P
p
.35478 .25953 m .36947 .25615 L .47292 .32318 L 0 1 .114 r
F
P
p
.80791 .25457 m .88961 .31899 L .87403 .32186 L 1 .307 0 r
F
P
p
.7913 .25797 m .80791 .25457 L .87403 .32186 L 1 .426 0 r
F
P
p
.002 w
.77581 .56698 m .76081 .57301 L .68443 .54728 L p
1 .972 0 r
F P
0 0 0 r
s
P
p
.002 w
.6683 .54942 m .68443 .54728 L .76081 .57301 L p
.943 1 0 r
F P
0 0 0 r
s
P
p
.38428 .25273 m .50093 .31744 L .48687 .32032 L .193 1 0 r
F
P
p
.36947 .25615 m .38428 .25273 L .48687 .32032 L 0 1 .063 r
F
P
p
.002 w
.79091 .56091 m .77581 .56698 L .70048 .53603 L p
1 .869 0 r
F P
0 0 0 r
s
P
p
.002 w
.68443 .54728 m .70048 .53603 L .77581 .56698 L p
1 .972 0 r
F P
0 0 0 r
s
P
p
.82467 .25114 m .90532 .3161 L .88961 .31899 L 1 .222 0 r
F
P
p
.80791 .25457 m .82467 .25114 L .88961 .31899 L 1 .307 0 r
F
P
p
.39922 .24928 m .51511 .31454 L .50093 .31744 L .466 1 0 r
F
P
p
.38428 .25273 m .39922 .24928 L .50093 .31744 L .193 1 0 r
F
P
p
.002 w
.80581 .54645 m .79091 .56091 L .71664 .52471 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.70048 .53603 m .71664 .52471 L .79091 .56091 L p
1 .869 0 r
F P
0 0 0 r
s
P
p
.84157 .24768 m .92115 .31319 L .90532 .3161 L 1 .102 0 r
F
P
p
.82467 .25114 m .84157 .24768 L .90532 .3161 L 1 .222 0 r
F
P
p
.002 w
.82127 .54446 m .80581 .54645 L .73316 .52244 L p
1 .716 0 r
F P
0 0 0 r
s
P
p
.002 w
.71664 .52471 m .73316 .52244 L .80581 .54645 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.41429 .2458 m .52941 .31161 L .51511 .31454 L .517 1 0 r
F
P
p
.39922 .24928 m .41429 .2458 L .51511 .31454 L .466 1 0 r
F
P
p
.84157 .24768 m .85862 .24419 L .92115 .31319 L 1 .102 0 r
F
P
p
.002 w
.83685 .54245 m .82127 .54446 L .74981 .52014 L p
1 .716 0 r
F P
0 0 0 r
s
P
p
.002 w
.73316 .52244 m .74981 .52014 L .82127 .54446 L p
1 .716 0 r
F P
0 0 0 r
s
P
p
.4295 .24229 m .54381 .30866 L .52941 .31161 L .602 1 0 r
F
P
p
.41429 .2458 m .4295 .24229 L .52941 .31161 L .517 1 0 r
F
P
p
.002 w
.85182 .5236 m .83685 .54245 L .76662 .51783 L p
1 .631 0 r
F P
0 0 0 r
s
P
p
.002 w
.74981 .52014 m .76662 .51783 L .83685 .54245 L p
1 .716 0 r
F P
0 0 0 r
s
P
p
.44484 .23875 m .55834 .30568 L .54381 .30866 L .67 1 0 r
F
P
p
.4295 .24229 m .44484 .23875 L .54381 .30866 L .602 1 0 r
F
P
p
.002 w
.86762 .52149 m .85182 .5236 L .78342 .51088 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.76662 .51783 m .78342 .51088 L .85182 .5236 L p
1 .631 0 r
F P
0 0 0 r
s
P
p
.46032 .23518 m .57298 .30268 L .55834 .30568 L .756 1 0 r
F
P
p
.44484 .23875 m .46032 .23518 L .55834 .30568 L .67 1 0 r
F
P
p
.002 w
.88354 .51937 m .86762 .52149 L .80017 .49925 L p
1 .426 0 r
F P
0 0 0 r
s
P
p
.002 w
.78342 .51088 m .80017 .49925 L .86762 .52149 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.47593 .23158 m .58775 .29966 L .57298 .30268 L .858 1 0 r
F
P
p
.46032 .23518 m .47593 .23158 L .57298 .30268 L .756 1 0 r
F
P
p
.002 w
.89939 .51299 m .88354 .51937 L .81685 .48291 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.80017 .49925 m .81685 .48291 L .88354 .51937 L p
1 .426 0 r
F P
0 0 0 r
s
P
p
.002 w
.41227 .69464 m .3982 .69605 L .28616 .60177 L p
0 1 .489 r
F P
0 0 0 r
s
P
p
.002 w
.3982 .69605 m .38021 .89699 L .27149 .60371 L p
0 .744 1 r
F P
0 0 0 r
s
P
p
.002 w
.27149 .60371 m .28616 .60177 L .3982 .69605 L p
0 .744 1 r
F P
0 0 0 r
s
P
p
.49169 .22794 m .60263 .29661 L .58775 .29966 L .875 1 0 r
F
P
p
.47593 .23158 m .49169 .22794 L .58775 .29966 L .858 1 0 r
F
P
p
.002 w
.91534 .50656 m .89939 .51299 L .83362 .4665 L p
1 .222 0 r
F P
0 0 0 r
s
P
p
.002 w
.81685 .48291 m .83362 .4665 L .89939 .51299 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.42652 .68885 m .41227 .69464 L .30097 .59981 L p
0 1 .472 r
F P
0 0 0 r
s
P
p
.002 w
.28616 .60177 m .30097 .59981 L .41227 .69464 L p
0 1 .489 r
F P
0 0 0 r
s
P
p
.50759 .22428 m .61764 .29354 L .60263 .29661 L .909 1 0 r
F
P
p
.49169 .22794 m .50759 .22428 L .60263 .29661 L .875 1 0 r
F
P
p
.002 w
.93117 .49583 m .91534 .50656 L .85109 .4639 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.83362 .4665 m .85109 .4639 L .91534 .50656 L p
1 .222 0 r
F P
0 0 0 r
s
P
p
.002 w
.44121 .65685 m .42652 .68885 L .31591 .59783 L p
0 1 .335 r
F P
0 0 0 r
s
P
p
.002 w
.30097 .59981 m .31591 .59783 L .42652 .68885 L p
0 1 .472 r
F P
0 0 0 r
s
P
p
.002 w
.45566 .64655 m .44121 .65685 L .33099 .59583 L p
0 1 .182 r
F P
0 0 0 r
s
P
p
.002 w
.31591 .59783 m .33099 .59583 L .44121 .65685 L p
0 1 .335 r
F P
0 0 0 r
s
P
p
.002 w
.85109 .4639 m .86785 .44268 L .93117 .49583 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.35193 .89818 m .33797 .89877 L .22475 .69277 L p
.449 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47019 .63618 m .45566 .64655 L .3462 .59382 L p
0 1 .114 r
F P
0 0 0 r
s
P
p
.002 w
.33099 .59583 m .3462 .59382 L .45566 .64655 L p
0 1 .182 r
F P
0 0 0 r
s
P
p
.52363 .22057 m .63277 .29044 L .61764 .29354 L .994 1 0 r
F
P
p
.50759 .22428 m .52363 .22057 L .61764 .29354 L .909 1 0 r
F
P
p
.002 w
.48476 .6345 m .47019 .63618 L .36155 .59179 L p
0 1 .063 r
F P
0 0 0 r
s
P
p
.002 w
.3462 .59382 m .36155 .59179 L .47019 .63618 L p
0 1 .114 r
F P
0 0 0 r
s
P
p
.002 w
.36601 .89759 m .35193 .89818 L .24123 .63986 L p
.159 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.22475 .69277 m .24123 .63986 L .35193 .89818 L p
.449 0 1 r
F P
0 0 0 r
s
P
p
.53982 .21684 m .64803 .28731 L .63277 .29044 L 1 .92 0 r
F
P
p
.52363 .22057 m .53982 .21684 L .63277 .29044 L .994 1 0 r
F
P
p
.002 w
.49955 .61091 m .48476 .6345 L .37714 .58497 L p
.193 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36155 .59179 m .37714 .58497 L .48476 .6345 L p
0 1 .063 r
F P
0 0 0 r
s
P
p
.002 w
.38021 .89699 m .36601 .89759 L .25676 .61025 L p
.04 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.24123 .63986 m .25676 .61025 L .36601 .89759 L p
.159 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.51432 .60473 m .49955 .61091 L .3936 .54004 L p
.466 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37714 .58497 m .3936 .54004 L .49955 .61091 L p
.193 1 0 r
F P
0 0 0 r
s
P
p
.55616 .21307 m .66342 .28416 L .64803 .28731 L 1 .869 0 r
F
P
p
.53982 .21684 m .55616 .21307 L .64803 .28731 L 1 .92 0 r
F
P
p
.10948 .21103 m .25544 .28246 L .24172 .28562 L 0 1 .131 r
F
P
p
.002 w
.25676 .61025 m .27149 .60371 L .38021 .89699 L p
.04 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.52921 .5985 m .51432 .60473 L .40936 .533 L p
.517 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3936 .54004 m .40936 .533 L .51432 .60473 L p
.466 1 0 r
F P
0 0 0 r
s
P
p
.57265 .20927 m .67894 .28099 L .66342 .28416 L 1 .801 0 r
F
P
p
.55616 .21307 m .57265 .20927 L .66342 .28416 L 1 .869 0 r
F
P
p
.12396 .2072 m .26927 .27926 L .25544 .28246 L .278 1 0 r
F
P
p
.10948 .21103 m .12396 .2072 L .25544 .28246 L 0 1 .131 r
F
P
p
.002 w
.54419 .58344 m .52921 .5985 L .42517 .53066 L p
.602 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.40936 .533 m .42517 .53066 L .52921 .5985 L p
.517 1 0 r
F P
0 0 0 r
s
P
p
.58928 .20543 m .69458 .27778 L .67894 .28099 L 1 .699 0 r
F
P
p
.57265 .20927 m .58928 .20543 L .67894 .28099 L 1 .801 0 r
F
P
p
.002 w
.55928 .58151 m .54419 .58344 L .44119 .52352 L p
.67 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42517 .53066 m .44119 .52352 L .54419 .58344 L p
.602 1 0 r
F P
0 0 0 r
s
P
p
.13856 .20334 m .28322 .27605 L .26927 .27926 L .517 1 0 r
F
P
p
.12396 .2072 m .13856 .20334 L .26927 .27926 L .278 1 0 r
F
P
p
.60608 .20155 m .71036 .27455 L .69458 .27778 L 1 .614 0 r
F
P
p
.58928 .20543 m .60608 .20155 L .69458 .27778 L 1 .699 0 r
F
P
p
.002 w
.57448 .57513 m .55928 .58151 L .45728 .52113 L p
.756 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44119 .52352 m .45728 .52113 L .55928 .58151 L p
.67 1 0 r
F P
0 0 0 r
s
P
p
.1533 .19945 m .29729 .2728 L .28322 .27605 L .585 1 0 r
F
P
p
.13856 .20334 m .1533 .19945 L .28322 .27605 L .517 1 0 r
F
P
p
.62303 .19764 m .72627 .27129 L .71036 .27455 L 1 .563 0 r
F
P
p
.60608 .20155 m .62303 .19764 L .71036 .27455 L 1 .614 0 r
F
P
p
.002 w
.58983 .57315 m .57448 .57513 L .47369 .49947 L p
.858 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45728 .52113 m .47369 .49947 L .57448 .57513 L p
.756 1 0 r
F P
0 0 0 r
s
P
p
.16818 .19552 m .31148 .26953 L .29729 .2728 L .636 1 0 r
F
P
p
.1533 .19945 m .16818 .19552 L .29729 .2728 L .585 1 0 r
F
P
p
.64014 .19369 m .74232 .26801 L .72627 .27129 L 1 .528 0 r
F
P
p
.62303 .19764 m .64014 .19369 L .72627 .27129 L 1 .563 0 r
F
P
p
.002 w
.6053 .57115 m .58983 .57315 L .49007 .49213 L p
.875 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47369 .49947 m .49007 .49213 L .58983 .57315 L p
.858 1 0 r
F P
0 0 0 r
s
P
p
.18319 .19155 m .32579 .26622 L .31148 .26953 L .688 1 0 r
F
P
p
.16818 .19552 m .18319 .19155 L .31148 .26953 L .636 1 0 r
F
P
p
.65741 .18971 m .75851 .26469 L .74232 .26801 L 1 .511 0 r
F
P
p
.64014 .19369 m .65741 .18971 L .74232 .26801 L 1 .528 0 r
F
P
p
.002 w
.6208 .5602 m .6053 .57115 L .50657 .48956 L p
.909 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49007 .49213 m .50657 .48956 L .6053 .57115 L p
.875 1 0 r
F P
0 0 0 r
s
P
p
.19835 .18755 m .34022 .26289 L .32579 .26622 L .705 1 0 r
F
P
p
.18319 .19155 m .19835 .18755 L .32579 .26622 L .688 1 0 r
F
P
p
.002 w
.63653 .55813 m .6208 .5602 L .52322 .48696 L p
.994 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50657 .48956 m .52322 .48696 L .6208 .5602 L p
.909 1 0 r
F P
0 0 0 r
s
P
p
.67484 .18569 m .77484 .26135 L .75851 .26469 L 1 .477 0 r
F
P
p
.65741 .18971 m .67484 .18569 L .75851 .26469 L 1 .511 0 r
F
P
p
.21366 .1835 m .35478 .25953 L .34022 .26289 L .705 1 0 r
F
P
p
.19835 .18755 m .21366 .1835 L .34022 .26289 L .705 1 0 r
F
P
p
.002 w
.65239 .55604 m .63653 .55813 L .54002 .46975 L p
1 .92 0 r
F P
0 0 0 r
s
P
p
.002 w
.52322 .48696 m .54002 .46975 L .63653 .55813 L p
.994 1 0 r
F P
0 0 0 r
s
P
p
.69244 .18163 m .7913 .25797 L .77484 .26135 L 1 .392 0 r
F
P
p
.67484 .18569 m .69244 .18163 L .77484 .26135 L 1 .477 0 r
F
P
p
.2291 .17942 m .36947 .25615 L .35478 .25953 L .739 1 0 r
F
P
p
.21366 .1835 m .2291 .17942 L .35478 .25953 L .705 1 0 r
F
P
p
.002 w
.6683 .54942 m .65239 .55604 L .55693 .45731 L p
1 .869 0 r
F P
0 0 0 r
s
P
p
.002 w
.54002 .46975 m .55693 .45731 L .65239 .55604 L p
1 .92 0 r
F P
0 0 0 r
s
P
p
.71021 .17753 m .80791 .25457 L .7913 .25797 L 1 .29 0 r
F
P
p
.69244 .18163 m .71021 .17753 L .7913 .25797 L 1 .392 0 r
F
P
p
.2447 .1753 m .38428 .25273 L .36947 .25615 L .79 1 0 r
F
P
p
.2291 .17942 m .2447 .1753 L .36947 .25615 L .739 1 0 r
F
P
p
.002 w
.68443 .54728 m .6683 .54942 L .574 .45453 L p
1 .801 0 r
F P
0 0 0 r
s
P
p
.002 w
.55693 .45731 m .574 .45453 L .6683 .54942 L p
1 .869 0 r
F P
0 0 0 r
s
P
p
.72814 .17339 m .82467 .25114 L .80791 .25457 L 1 .188 0 r
F
P
p
.71021 .17753 m .72814 .17339 L .80791 .25457 L 1 .29 0 r
F
P
p
.26045 .17114 m .39922 .24928 L .38428 .25273 L .96 1 0 r
F
P
p
.2447 .1753 m .26045 .17114 L .38428 .25273 L .79 1 0 r
F
P
p
.002 w
.70048 .53603 m .68443 .54728 L .59112 .43704 L p
1 .699 0 r
F P
0 0 0 r
s
P
p
.002 w
.574 .45453 m .59112 .43704 L .68443 .54728 L p
1 .801 0 r
F P
0 0 0 r
s
P
p
.74625 .16921 m .84157 .24768 L .82467 .25114 L 1 .136 0 r
F
P
p
.72814 .17339 m .74625 .16921 L .82467 .25114 L 1 .188 0 r
F
P
p
.002 w
.71664 .52471 m .70048 .53603 L .60843 .42925 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.59112 .43704 m .60843 .42925 L .70048 .53603 L p
1 .699 0 r
F P
0 0 0 r
s
P
p
.27635 .16694 m .41429 .2458 L .39922 .24928 L 1 .835 0 r
F
P
p
.26045 .17114 m .27635 .16694 L .39922 .24928 L .96 1 0 r
F
P
p
.76454 .16499 m .85862 .24419 L .84157 .24768 L 1 .068 0 r
F
P
p
.74625 .16921 m .76454 .16499 L .84157 .24768 L 1 .136 0 r
F
P
p
.002 w
.73316 .52244 m .71664 .52471 L .62596 .4263 L p
1 .563 0 r
F P
0 0 0 r
s
P
p
.002 w
.60843 .42925 m .62596 .4263 L .71664 .52471 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.2924 .1627 m .4295 .24229 L .41429 .2458 L 1 .784 0 r
F
P
p
.27635 .16694 m .2924 .1627 L .41429 .2458 L 1 .835 0 r
F
P
p
.76454 .16499 m .783 .16073 L .85862 .24419 L 1 .068 0 r
F
P
p
.002 w
.25676 .61025 m .24123 .63986 L .10622 .50727 L p
.278 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24123 .63986 m .22475 .69277 L .0906 .51973 L p
0 1 .131 r
F P
0 0 0 r
s
P
p
.002 w
.0906 .51973 m .10622 .50727 L .24123 .63986 L p
0 1 .131 r
F P
0 0 0 r
s
P
p
.002 w
.74981 .52014 m .73316 .52244 L .64357 .41839 L p
1 .528 0 r
F P
0 0 0 r
s
P
p
.002 w
.62596 .4263 m .64357 .41839 L .73316 .52244 L p
1 .563 0 r
F P
0 0 0 r
s
P
p
.002 w
.27149 .60371 m .25676 .61025 L .12279 .47983 L p
.517 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.10622 .50727 m .12279 .47983 L .25676 .61025 L p
.278 1 0 r
F P
0 0 0 r
s
P
p
.30861 .15842 m .44484 .23875 L .4295 .24229 L 1 .767 0 r
F
P
p
.2924 .1627 m .30861 .15842 L .4295 .24229 L 1 .784 0 r
F
P
p
.002 w
.28616 .60177 m .27149 .60371 L .13859 .46717 L p
.585 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.12279 .47983 m .13859 .46717 L .27149 .60371 L p
.517 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.76662 .51783 m .74981 .52014 L .66133 .41041 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.64357 .41839 m .66133 .41041 L .74981 .52014 L p
1 .528 0 r
F P
0 0 0 r
s
P
p
.32497 .1541 m .46032 .23518 L .44484 .23875 L 1 .75 0 r
F
P
p
.30861 .15842 m .32497 .1541 L .44484 .23875 L 1 .767 0 r
F
P
p
.002 w
.30097 .59981 m .28616 .60177 L .15424 .4594 L p
.636 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.13859 .46717 m .15424 .4594 L .28616 .60177 L p
.585 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.78342 .51088 m .76662 .51783 L .67934 .40734 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.66133 .41041 m .67934 .40734 L .76662 .51783 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.3415 .14973 m .47593 .23158 L .46032 .23518 L 1 .665 0 r
F
P
p
.32497 .1541 m .3415 .14973 L .46032 .23518 L 1 .75 0 r
F
P
p
.002 w
.80017 .49925 m .78342 .51088 L .69742 .39924 L p
1 .392 0 r
F P
0 0 0 r
s
P
p
.002 w
.67934 .40734 m .69742 .39924 L .78342 .51088 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.31591 .59783 m .30097 .59981 L .17027 .44658 L p
.688 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.15424 .4594 m .17027 .44658 L .30097 .59981 L p
.636 1 0 r
F P
0 0 0 r
s
P
p
.3582 .14532 m .49169 .22794 L .47593 .23158 L 1 .545 0 r
F
P
p
.3415 .14973 m .3582 .14532 L .47593 .23158 L 1 .665 0 r
F
P
p
.002 w
.81685 .48291 m .80017 .49925 L .71564 .39108 L p
1 .29 0 r
F P
0 0 0 r
s
P
p
.002 w
.69742 .39924 m .71564 .39108 L .80017 .49925 L p
1 .392 0 r
F P
0 0 0 r
s
P
p
.002 w
.33099 .59583 m .31591 .59783 L .18617 .43866 L p
.705 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.17027 .44658 m .18617 .43866 L .31591 .59783 L p
.688 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.83362 .4665 m .81685 .48291 L .73416 .38787 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.002 w
.71564 .39108 m .73416 .38787 L .81685 .48291 L p
1 .29 0 r
F P
0 0 0 r
s
P
p
.37505 .14086 m .50759 .22428 L .49169 .22794 L 1 .511 0 r
F
P
p
.3582 .14532 m .37505 .14086 L .49169 .22794 L 1 .545 0 r
F
P
p
.002 w
.85109 .4639 m .83362 .4665 L .75287 .38462 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.73416 .38787 m .75287 .38462 L .83362 .4665 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.002 w
.3462 .59382 m .33099 .59583 L .20197 .43571 L p
.705 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.18617 .43866 m .20197 .43571 L .33099 .59583 L p
.705 1 0 r
F P
0 0 0 r
s
P
p
.39208 .13637 m .52363 .22057 L .50759 .22428 L 1 .511 0 r
F
P
p
.37505 .14086 m .39208 .13637 L .50759 .22428 L 1 .511 0 r
F
P
p
.002 w
.86785 .44268 m .85109 .4639 L .77176 .38135 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.75287 .38462 m .77176 .38135 L .85109 .4639 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.36155 .59179 m .3462 .59382 L .21792 .43272 L p
.739 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20197 .43571 m .21792 .43272 L .3462 .59382 L p
.705 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.77176 .38135 m .79084 .37804 L .86785 .44268 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.40928 .13182 m .53982 .21684 L .52363 .22057 L 1 .443 0 r
F
P
p
.39208 .13637 m .40928 .13182 L .52363 .22057 L 1 .511 0 r
F
P
p
.002 w
.37714 .58497 m .36155 .59179 L .23446 .41957 L p
.79 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.21792 .43272 m .23446 .41957 L .36155 .59179 L p
.739 1 0 r
F P
0 0 0 r
s
P
p
.42665 .12723 m .55616 .21307 L .53982 .21684 L 1 .341 0 r
F
P
p
.40928 .13182 m .42665 .12723 L .53982 .21684 L 1 .443 0 r
F
P
p
.002 w
.40936 .533 m .3936 .54004 L .26714 .41336 L p
1 .835 0 r
F P
0 0 0 r
s
P
p
.002 w
.3936 .54004 m .37714 .58497 L .25072 .41648 L p
.96 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25072 .41648 m .26714 .41336 L .3936 .54004 L p
.96 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.23446 .41957 m .25072 .41648 L .37714 .58497 L p
.79 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42517 .53066 m .40936 .533 L .28408 .39996 L p
1 .784 0 r
F P
0 0 0 r
s
P
p
.002 w
.26714 .41336 m .28408 .39996 L .40936 .533 L p
1 .835 0 r
F P
0 0 0 r
s
P
p
.4442 .1226 m .57265 .20927 L .55616 .21307 L 1 .29 0 r
F
P
p
.42665 .12723 m .4442 .1226 L .55616 .21307 L 1 .341 0 r
F
P
p
.002 w
.44119 .52352 m .42517 .53066 L .3008 .39673 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.28408 .39996 m .3008 .39673 L .42517 .53066 L p
1 .784 0 r
F P
0 0 0 r
s
P
p
.46193 .11791 m .58928 .20543 L .57265 .20927 L 1 .222 0 r
F
P
p
.4442 .1226 m .46193 .11791 L .57265 .20927 L 1 .29 0 r
F
P
p
.002 w
.45728 .52113 m .44119 .52352 L .3177 .39346 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.3008 .39673 m .3177 .39346 L .44119 .52352 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.47984 .11318 m .60608 .20155 L .58928 .20543 L 1 .153 0 r
F
P
p
.46193 .11791 m .47984 .11318 L .58928 .20543 L 1 .222 0 r
F
P
p
.002 w
.47369 .49947 m .45728 .52113 L .33477 .39016 L p
1 .665 0 r
F P
0 0 0 r
s
P
p
.002 w
.3177 .39346 m .33477 .39016 L .45728 .52113 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.49793 .1084 m .62303 .19764 L .60608 .20155 L 1 .136 0 r
F
P
p
.47984 .11318 m .49793 .1084 L .60608 .20155 L 1 .153 0 r
F
P
p
.002 w
.49007 .49213 m .47369 .49947 L .35215 .38163 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.33477 .39016 m .35215 .38163 L .47369 .49947 L p
1 .665 0 r
F P
0 0 0 r
s
P
p
.51621 .10357 m .64014 .19369 L .62303 .19764 L 1 .119 0 r
F
P
p
.49793 .1084 m .51621 .10357 L .62303 .19764 L 1 .136 0 r
F
P
p
.002 w
.50657 .48956 m .49007 .49213 L .36968 .37301 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.35215 .38163 m .36968 .37301 L .49007 .49213 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.53468 .09869 m .65741 .18971 L .64014 .19369 L 1 .085 0 r
F
P
p
.51621 .10357 m .53468 .09869 L .64014 .19369 L 1 .119 0 r
F
P
p
.002 w
.52322 .48696 m .50657 .48956 L .38726 .36956 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.36968 .37301 m .38726 .36956 L .50657 .48956 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.55335 .09376 m .67484 .18569 L .65741 .18971 L 1 .068 0 r
F
P
p
.53468 .09869 m .55335 .09376 L .65741 .18971 L 1 .085 0 r
F
P
p
.002 w
.54002 .46975 m .52322 .48696 L .40502 .36607 L p
1 .443 0 r
F P
0 0 0 r
s
P
p
.002 w
.38726 .36956 m .40502 .36607 L .52322 .48696 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.55693 .45731 m .54002 .46975 L .42304 .35726 L p
1 .341 0 r
F P
0 0 0 r
s
P
p
.002 w
.40502 .36607 m .42304 .35726 L .54002 .46975 L p
1 .443 0 r
F P
0 0 0 r
s
P
p
.57221 .08878 m .69244 .18163 L .67484 .18569 L 1 .051 0 r
F
P
p
.55335 .09376 m .57221 .08878 L .67484 .18569 L 1 .068 0 r
F
P
p
.002 w
.574 .45453 m .55693 .45731 L .44116 .35368 L p
1 .29 0 r
F P
0 0 0 r
s
P
p
.002 w
.42304 .35726 m .44116 .35368 L .55693 .45731 L p
1 .341 0 r
F P
0 0 0 r
s
P
p
.59127 .08374 m .71021 .17753 L .69244 .18163 L 1 .017 0 r
F
P
p
.57221 .08878 m .59127 .08374 L .69244 .18163 L 1 .051 0 r
F
P
p
.002 w
.59112 .43704 m .574 .45453 L .45953 .34472 L p
1 .222 0 r
F P
0 0 0 r
s
P
p
.002 w
.44116 .35368 m .45953 .34472 L .574 .45453 L p
1 .29 0 r
F P
0 0 0 r
s
P
p
.002 w
.60843 .42925 m .59112 .43704 L .47802 .34104 L p
1 .153 0 r
F P
0 0 0 r
s
P
p
.002 w
.45953 .34472 m .47802 .34104 L .59112 .43704 L p
1 .222 0 r
F P
0 0 0 r
s
P
p
.61053 .07865 m .72814 .17339 L .71021 .17753 L 1 0 0 r
F
P
p
.59127 .08374 m .61053 .07865 L .71021 .17753 L 1 .017 0 r
F
P
p
.002 w
.62596 .4263 m .60843 .42925 L .49671 .33731 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.47802 .34104 m .49671 .33731 L .60843 .42925 L p
1 .153 0 r
F P
0 0 0 r
s
P
p
.63 .07351 m .74625 .16921 L .72814 .17339 L 1 0 0 r
F
P
p
.61053 .07865 m .63 .07351 L .72814 .17339 L 1 0 0 r
F
P
p
.002 w
.64357 .41839 m .62596 .4263 L .5156 .33354 L p
1 .119 0 r
F P
0 0 0 r
s
P
p
.002 w
.49671 .33731 m .5156 .33354 L .62596 .4263 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.64968 .06831 m .76454 .16499 L .74625 .16921 L 1 0 0 r
F
P
p
.63 .07351 m .64968 .06831 L .74625 .16921 L 1 0 0 r
F
P
p
.002 w
.66133 .41041 m .64357 .41839 L .5347 .32974 L p
1 .085 0 r
F P
0 0 0 r
s
P
p
.002 w
.5156 .33354 m .5347 .32974 L .64357 .41839 L p
1 .119 0 r
F P
0 0 0 r
s
P
p
.66957 .06306 m .783 .16073 L .76454 .16499 L 1 0 0 r
F
P
p
.64968 .06831 m .66957 .06306 L .76454 .16499 L 1 0 0 r
F
P
p
.002 w
.67934 .40734 m .66133 .41041 L .554 .32589 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.5347 .32974 m .554 .32589 L .66133 .41041 L p
1 .085 0 r
F P
0 0 0 r
s
P
p
.66957 .06306 m .68968 .05774 L .783 .16073 L 1 0 0 r
F
P
p
.002 w
.69742 .39924 m .67934 .40734 L .5735 .322 L p
1 .051 0 r
F P
0 0 0 r
s
P
p
.002 w
.554 .32589 m .5735 .322 L .67934 .40734 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.71564 .39108 m .69742 .39924 L .59323 .31806 L p
1 .017 0 r
F P
0 0 0 r
s
P
p
.002 w
.5735 .322 m .59323 .31806 L .69742 .39924 L p
1 .051 0 r
F P
0 0 0 r
s
P
p
.002 w
.73416 .38787 m .71564 .39108 L .61317 .31409 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59323 .31806 m .61317 .31409 L .71564 .39108 L p
1 .017 0 r
F P
0 0 0 r
s
P
p
.002 w
.75287 .38462 m .73416 .38787 L .63333 .31007 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.61317 .31409 m .63333 .31007 L .73416 .38787 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77176 .38135 m .75287 .38462 L .65371 .306 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63333 .31007 m .65371 .306 L .75287 .38462 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79084 .37804 m .77176 .38135 L .67432 .30189 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65371 .306 m .67432 .30189 L .77176 .38135 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67432 .30189 m .69517 .29774 L .79084 .37804 L p
1 0 0 r
F P
0 0 0 r
s
P
p
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.08509 .19367 m
.08465 .20033 L
s
P
[(0)] .08595 .18034 -0.06484 1 Mshowa
p
.002 w
.23498 .15292 m
.23469 .15959 L
s
P
[(10)] .23556 .13958 -0.04346 1 Mshowa
p
.002 w
.40002 .10806 m
.39989 .11474 L
s
P
[(20)] .40028 .0947 -0.01962 1 Mshowa
p
.002 w
.58262 .05842 m
.58267 .0651 L
s
P
[(30)] .58253 .04506 .00711 1 Mshowa
p
.001 w
.11395 .18582 m
.11371 .18982 L
s
P
p
.001 w
.14336 .17783 m
.14314 .18183 L
s
P
p
.001 w
.17332 .16968 m
.17311 .17368 L
s
P
p
.001 w
.20386 .16138 m
.20367 .16538 L
s
P
p
.001 w
.2667 .1443 m
.26655 .1483 L
s
P
p
.001 w
.29905 .1355 m
.29892 .13951 L
s
P
p
.001 w
.33204 .12654 m
.33192 .13054 L
s
P
p
.001 w
.36569 .11739 m
.36559 .1214 L
s
P
p
.001 w
.43505 .09854 m
.43499 .10254 L
s
P
p
.001 w
.4708 .08882 m
.47076 .09283 L
s
P
p
.001 w
.5073 .0789 m
.50728 .0829 L
s
P
p
.001 w
.54456 .06877 m
.54457 .07277 L
s
P
p
.001 w
.6215 .04785 m
.62155 .05186 L
s
P
p
.001 w
.66122 .03706 m
.6613 .04106 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{333, 317},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005=0001?@P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0CP000?mKCE/10000oe]=F`40003oFdeK
0@000?mKCE/10000oe]=F`40003oFdeK0@000?mKCE/10000oe]=F`40001jF`03oe_o00=K00CoFe]K
0ol015_oFol4F`05oe]KFol0^5/10000NU/00omKo`03F`04oe]Ko`=K0_l00e_oF`02F`03oe_o0;]K
0@0007YK00?oFol00e/01?mKFol4F`03oe_o00=K00?oFol0=E/4o`=K1?mkF`40001jF`03oe_o00=K
00CoFe_o15/00omKo`03F`03oe_o03AK00?oFe/00U/00omKo`04F`03oe]K07QK0@0007YK00?oFol0
0e/01?mKFol4F`03oe_o00=K00?oFol0=5/00omKF`02F`03oe_o00AK00?oFe/06E/3oeaK0@0007YK
00CoFooo0U/01?mKFol3F`;o00EKoe]Ko`03F`03oe]K03IK00?oFol015/00omKF`0EF`Co0U/00omK
F`1JF`40001jF`04oe_oF`;o15/3o`04FomKo`9K00GoFe]Ko`0eF`?o0U/00omKF`02F`03oe]K019K
0ol7F`03oe]K05UK0@0007YK00?oFe/02e/00omKF`0oF`03oe_o00AK00?oFe/03U/4o`]K00?oFe/0
F5/10000NU/00omKF`0;F`03oe_o03YK00?oFe/00U/00omKo`04F`03oe]K00YK1?l00e_oF`0=F`03
oe]K05MK0@000<EK00?oFe/00U/00omKo`04F`03oe]K00MK0ol5F`03oe]K00eK00?oFe/0EU/10000
aU/4o`=K1?l6F`Co6E/00omKF`1EF`40003CF`Go7E/00omKF`1DF`40003@F`?o15/00omKF`0KF`03
oe]K05AK0@000<aK1?lVF`03oe]K05=K0@000<QK1?l[F`03oe]K059K0@000<EK0ol3F`03oe]K01]K
0b<<F`03oe]K055K0@000<5K1?l6F`03oe]K01MK22<<F`03oe]K051K0@0008eK1_l2F`Co95/4ob5K
32<<F`03oe]K04mK0@0008eK00?oFe/015/00omKF`02F`03oe]K01eK1?l3F`03oe]K01aK42<<F`03
oe]K04iK0@0008iK00?oFe/00e/00omKF`02F`03oe]K01YK0olSFa@S2e/00omKF`1>F`40002?F`;o
0e/00omKF`02F`03oe]K01IK1?lQFaXS2e/00omKF`1=F`40002AF`04oe]Ko`AK00?oFe/04U/4o`9K
00?oFe/075/27adS2e/00omKF`1<F`40002BF`03oe_o00AK00?oFe/03e/3ob9K1QlM8`]K00?oFe/0
Be/10000SE/00omKF`02F`03oe_o00AK00?oFe/02e/4ob1K31lM8`]K00?oFe/0BU/10000SE/00omK
F`02F`03oe_o00AK00?oFe/01e/4o`9K00?oFe/06e/02QmO7elOGamO7el77adS2e/00omKF`19F`40
002>F`Co0e/4o`MK0ol6F`03oe]K01QK00HOGamO7el?7adS2e/00omKF`18F`40002LF`Co85/04elO
GamO7elOGamO7elOGamO7el01alM8`YK00?oFe/0B5/10000V5/4o`9K00?oFe/06e/041mO7elOGamO
7elOGamO7el?7adS2U/00omKF`17F`40002EF`?o1U/00omKF`0HF`06GamO7elO0Ul051mO7elOGamO
7elOGamO7elOGamO1alM8`YK00?oFe/0AU/10000TE/4oamK1Al05ElOGamO7elOGamO7elOGamO7elO
G`0?7adS2U/00omKF`15F`40002=F`Co0U/00omKF`0JF`YO00LOGamO7elO009O01@OGamO7elOGamO
7elOGamO7elOG`LO7B<:F`03oe]K04AK0@0005iK00?oFe/00U/4ob9K1?l6F`03oe]K01MK00MO7elO
GamO00LO01EO7elOGamO7elOGamO7elOGamO7el03alL8`]K00?oFe/0@e/10000GU/01OmKFe_o00AK
00?oFe/075/4oamK00DOGamO7`0>G`077elOGamO7`02G`0D7elOGamO7elOGamO7elOGamO7el77a`S
2e/00omKF`12F`40001NF`05oe]KFol015/00omKF`0HF`Co0e/00omKF`0IF`AO00DOGamO7`02G`06
7elOGamO1al05ElOGamO7elOGamO7elOGamO7elOG`0?7a`S2U/00omKF`12F`40001NF`05oe]KFol0
15/00omKF`0DF`Co85/01QmO7elOG`8O00IO7elOGal>G`077elOGamO7`02G`0D7elOGamO7elOGamO
7elOGamO7el77a`S2U/00omKF`11F`40001NF`05oe]KFol015/00omKF`0AF`?o00=Koe/07U/00aMO
5`09G`057elOGal00Ul01QmO7elOG`LO01EO7elOGamO7elOGamO7elOGamO7el03alL8`YK00?oFe/0
@5/10000GU/01OmKFe_o00AK00?oFe/03E/4o`AK00?oFe/05e/01ALA5a4G00IO00HOGamO7el27`06
GamO7elO45l01AmO7elO009O01@OGamO7elOGamO7elOGamO7elOG`LO72<:F`03oe]K03mK0@0005aK
0ol3F`03oe]K009K00?oFe/02E/4oaiK00TG4ALG4ALA5a400QL015lGGaL9G`057elOGal00Ul01QmO
7elOG`TO01=O7elOGamO7elOGamO7elOGamO00lO72<:F`03oe]K03iK0@0005iK00GoFe]Ko`04F`03
oe]K00IK0ol00e_oF`0LF`PG00HA5a4G4AL6G`077elOGamO7`02G`057elOGal045l01QmO7elOG`8O
01=O7elOGamO7elOGamO7elOGamO00LO72<:F`03oe]K03eK0@0005iK00?oFe/00U/4o`EK1?l4F`03
oe]K01QK00XG4ALA5a4G4ALA0QL01A4G4ALA008G00IO5elGGaL7G`067elOGamO0Ql01ElOGamO00TO
01EO7elOGamO7elOGamO7elOGamO7el03AlL8`YK00?oFe/0?5/10000J5/4oamK00<G4AL03QL01Q4G
4ALA5`QO00DOGamO7`02G`057elOGal045l01QmO7elOG`8O01=O7elOGamO7elOGamO7elOGamO00LO
72<9F`03oe]K03aK0@0006EK0ol3F`03oe]K01YK1a403ALA5a4G4ALA5a4G4AL00Q4031LA5a4G4ElG
GaMO5`MO00HOGamO7el27`05GamO7el02Al05ElOGamO7elOGamO7elOGamO7elOG`0=7a`S2E/00omK
F`0kF`40001QF`Co1E/00omKF`0GF`FO00HG4ALA5a4?5`074ALA5a4G4@07G`067elOGamO0Ql015lO
Gal@G`067elOGamO0Ql04elOGamO7elOGamO7elOGamO7el01alL8`UK00?oFe/0>U/10000<E/4obQK
1OlMF`^O2A402aLA5a4G4ALA5a4G008A00`G4ALA5a5O5elGGaL9G`057elOGal00Ul01QmO7elOG`LO
01EO7elOGamO7elOGamO7elOGamO7el03AlL8`UK00?oFe/0>E/10000<5/00omKF`02F`03oe]K025K
1?l4F`03oe]K01MK00WOWmnOgioOWml01il021LA5a4G4ALA3AL01a4G4ALA5a401el01QmO7elOG`8O
00IO7elOGal>G`067elOGamO0Ql04elOGamO7elOGamO7elOGamO7el01alL8`UK00?oFe/08E/4o`03
FomK00Co0U/01OmKFe_o00=K0Ol1F`40000`F`03oe]K009K00?oFe/07U/3o`QK00?oFe/055/EW`PA
00`G4ALA5a4G4ALA5a425`054ALA5a400QL015lGGaL9G`057elOGal00Ul01QmO7elOG`LO01EO7elO
GamO7elOGamO7elOGamO7el03AlL8`UK00?oFe/07e/00omKF`02F`?o15/00omKo`03F`03oe]K00=K
0@00031K00?oFe/00U/00omKF`0JF`Co00=Koe/075/04MnOgioOWmnOgioOWmnOgioO00RO00LA5a4G
4ALA00lG00HA5a4G4AL6G`067elOGamO0Ql01UlOGamO7`iO00LOGamO7elO009O018OGamO7elOGamO
7elOGamO7el77aXS00=OFe/025/00omKF`0MF`03oe]K00AK0_l6F`05oe]KFol01E/10000<5/00omK
F`02F`03oe]K01IK1?l5F`03oe]K01IK00?OWml00Yl01MnOgioO01JO1a4031LA5a4G4ALA5a4G4@8G
00DA5a4G4@025`06GaMO5elG1el01AmO7elO009O00HOGamO7el77`0EGamO7elOGamO7elOGamO7elO
GamO00dO5R<01ElOGamO00YK00?oFe/075/00omKF`04F`Oo00=Koe/00U/00omKF`03F`40000`F`03
oe]K009K00?oFe/04e/4oaeK0ml6W`0EgioOWmnOgioOWmnOgioOWmnOgioO00NO00HG4ALA5a4?5`06
4ALA5a4G25l01AmO7elO009O00DOGamO7`0>G`077elOGamO7`02G`0B7elOGamO7elOGamO7elOGamO
1al@8`=O00POGamO7elOG`UK00?oFe/075/01?mKFe/5o`AK00?oFol00e/00omKF`03F`40000`F`03
oe]K009K00?oFe/03e/4o`=K00?oFe/06E/03=oNgmkOg]nOgioOW`;O00BOgioO5Yl74@0=5a4G4ALA
5a4G4ALA5`024@045a4G4@8G00IO5elGGaL7G`067elOGamO0Ql01ElOGamO00LO01EO7elOGamO7elO
GamO7elOGamO7el03Al:8`037elO00LO00MO7elOGamO00UK00?oFe/06e/00omKF`05F`03oe]K009K
00CoFooo0U/00omKF`03F`40000`F`03oe]K009K00?oFe/02e/4ob1K2ml7W`0CgioOWmnOgioOWmnO
gioOWmnOg`08W`074ALA5a4G4@0=5`074ALA5a4G4@07G`057elOGal00Ul01AmO7elO00iO00LOGamO
7elO009O018OGamO7elOGamO7elOGamO7el77`<S00=O7el01al6G`087elOGamO7el9F`03oe]K01YK
00?oFe/015/00omKo`03o`9K00CoFooo1U/10000<E/4o`]K0ol2F`03oe]K01YK00CNgmkO1]h03MoN
gmkOg]nOgioOWml00Yl01MnOgioO01FO21402aLA5a4G4ALA5a4G008A00`G4ALA5a5O5elGGaL7G`06
7elOGamO0Ql01ElOGamO00TO01=O7elOGamO7elOGamO7elOGamO00/O0QL6G`067elOGamO21l01elO
GamO7el02E/00omKF`0JF`03oe]K009K00?oFe/045/10000?5/4o`EK00?oFe/05E/02MkOg]oNgmkO
gP0?g`JO01GOWmnOgioOWmnOgioOWmnOgioOWml01il01QLA5a4G4@dG00LA5a4G4ALA00MO00HOGamO
7el27`04GamO7a1O00DOGamO7`02G`0O7elOGamO7elOGamO7elOGamO7elGGaMO5amO7elOG`077`IO
00POGamO7elOG`UK00?oFe/06U/4oa=K0@0003QK1OlLF`[N00GOg]oNg`08gP0<gmkOg]oNgioOWmnO
0]l019oOWmlFW`LA00`G4ALA5a4G4ALA5a425`0;4ALA5a5O5elGGaL02El011mO7el27`07GamO7elO
G`077`0CGamO7elOGamO7elOGamO7elOG`037`XG1Ul01QmO7elOG`PO00MO7elOGamO00UK00?oFe/0
<5/10000=E/3o`AK00?oFe/065/04mkOg]oNgmkOg]oNgmkOg]oNgmh03]l7W`0CgioOWmnOgioOWmnO
gioOWmnOg`07W`065a4G4ALA3aL01A4G4ALA00UO00@OGamO0Ql01UlOGamO7`iO00DOGamO7`02G`08
7elOGamO7el55`HA00aO5elGGaLOGamO7el77`IO00POGamO7elOG`UK00?oFe/0;e/10000<E/4oamK
00CNgmkO3Mh01moNgmkOg]l01]h03MoNgmkOg]nOgioOWml00Yl01MnOgioO01FO1Q4031LA5a4G4ALA
5a4G4@8G00DA5a4G4@025`06GaMO5elG1el01AmO7elO009O00HOGamO7el77`0DGamO7elOGamO4ALA
5a4G4ALA5a4<5`IO00HOGamO7el87`06GamO7elO2E/00omKF`0_F`40000_F`;o0U/00omKF`0IF`04
gW7NL@ON01;Og]oNgmkOg]oNgmkOg]oNgmh?g`JO01?OWmnOgioOWmnOgioOWmnOgioO00RO00DA5a4G
4@0?5`064ALA5a4G25l01AmO7elO009O00DOGamO7`0>G`067elOGaLA0QL01A4G4ALA00LG1Q4035lG
GaMO5amO7elOG`LO1Ul01amO7elOGal02E/00omKF`0^F`40000_F`05oe]KFol05U/01=iagW47gP05
gmkOg]l03mh01MoNgmkO00SN00cOg]oNgmkOWmnOgil2g`04WmnOgaFO21402aLA5a4G4ALA5a4G008A
00@G4ALA0QL01UlGGaMO5`MO00DOGamO7`02G`067elOGamO1al84@0<5a4G4ALA5a4G4ALA31L6G`06
7elOGamO21l01UlOGamO7`UK00?oFe/0;E/10000;e/01?mKFh4CF`GN00AagW7N0W401=iagW49gP0B
gmkOg]oNgmkOg]oNgmkOg]oN3]l7W`0CgioOWmnOgioOWmnOgioOWmnOg`07W`065a4G4ALA3AL01Q4G
4ALA5`QO00DOGamO7`02G`057elOGal02Ul02Q6O4IlG4ALA5a425`054ALA5a401aL64@0<GaMO5elG
7elOGamO1al6G`077elOGamO7`09F`03oe]K02aK0@0002mK00CoFe^13e/00iGMU@07L@04gW7NL@WN
00GOg]oNg`0?gP05gmkOg]l01]h03MoNgmkOg]nOgioOWml00Yl01MnOgioO01BO1a402aLA5a4G4ALA
5a4G008A00`G4ALA5a5O5elGGaL7G`057elOGal00Ul01amOWmnOgil03Q4031LA5a4G4ALA5a4G4@`G
1Ul01QmO7elOG`PO00IO7elOGal9F`03oe]K02]K0@0002mK00CoFe^13E/01g7MLMeagG401]h01G7N
LMia00;N00EagW7NL@07gP0BgmkOg]oNgmkOg]oNgmkOg]oN3ml8W`0AgioOWmnOgioOWmnOgioOWml0
29l01A4G4ALA00dG00LA5a4G4ALA00MO00DOGamO7`02G`037eoO00?O1il0316O4IlAWaLA5a4G4@8G
00DA5a4G4@075`HA00aO5elGGaLOGamO7el77`IO00LOGamO7elO00UK00?oFe/0:U/10000;e/01?mK
Fh4:F`CL00OMUMfEgIGM00Qa00CNLMia1mh01moNgmkOg]l03Mh01MoNgmkO00SN00cOg]oNgmkOWmnO
gil2g`04WmnOgaFO1Q4031LA5a4G4ALA5a4G4@8G00/A5a4G4ElGGaMO5`04G`CO1il01]nOgioOW`hA
00`G4ALA5a4G4ALA5a4<5`IO00HOGamO7el87`06GamO7elO2E/00omKF`0YF`40000_F`04oe]KP@UK
1n`01meagG7MLMd01mh0177NLMh2L@06gW7NLMia1mh04]oNgmkOg]oNgmkOg]oNgmkOgPkO1il04mnO
gioOWmnOgioOWmnOgioOWml01Yl01A4G4ALA00lG00DA5a4G4@05G`03WmnO00JO1]l7W`0<4IlAWa6O
5a4G4ALA0QL01A4G4ALA00LG1Q4035lGGaMO5amO7elOG`LO1Ul01amO7elOGal025/00omKF`0YF`40
000_F`04oe]KP@]K1]`029GMUMfEgIGM1W401]iagW7NL@ON00GOg]oNg`0?gP05gmkOg]l02=h02moN
gmkOg]nOgioO00:O00GOWmnOg`0DW`DA00`G4ALA5a4G4ALA5a425`0=4ALA5a5OWmnOgioOW`06g`NO
00KOWmnOgil>4@0<5a4G4ALA5a4G4ALA31L6G`067elOGamO21l01ElOGamO00UK00?oFe/0:5/10000
;e/01?mKFh4<F`O/00MagG7MLMea00SN00AagW7N0W401=iagW47gP0DgmkOg]oNgmkOg]oNgmkOg]oN
gmh=g`RO017OWmnOgioOWmnOgioOWmnOg`07W`065a4G4ALA3AL00a4Gg`03g`06WmnOgioO1il6g`NO
00`AWa6O4IlG4ALA5a425`054ALA5a401aL64@0<GaMO5elG7elOGamO1al6G`067elOGamO2E/00omK
F`0WF`40000^F`05oe]KFh403U/7g007UMfEgIGMU@07L@04gW7NL@ON00OOg]oNgmkO00gN00GOg]oN
g`08gP0<gmkOg]oNgioOWmnO0]l019oOWmlEW`HA00/G4ALA5a4G4MkOgP07g`07WmnOgioOW`06g`NO
00OOWmnOgioO00dA00`G4ALA5a4G4ALA5a4<5`IO00HOGamO7el87`05GamO7el02E/00omKF`0VF`40
000^F`?o00=KPE/03e/7k007LMeagG7ML@06gP05LMiagW400]h01G7NLMia00ON01;Og]oNgmkOg]oN
gmkOg]oNgmh>g`NO017OWmnOgioOWmnOgioOWmnOg`08W`054ALA5a400aL00moNg`02gP04gmkOgPOO
00JOgioOWml8W`KO29l0116O4Il24@045a4G4@8G00DA5a4G4@075`HA00aO5elGGaLOGamO7el77`IO
00HOGamO7el9F`03oe]K02EK0@0002iK00CoFe^14e/6g007gIGMUMfEg@08L@04gW7NL@ON00GOg]oN
g`0?gP05gmkOg]l02=h02moNgmkOg]nOgioO00:O00GOWmnOg`0CW`8A1=l02mkOg]oNgmkOg]oN00WO
00FOgioOW`07g`JO00OOWmnOgioO00dA00`G4ALA5a4G4ALA5a4<5`IO00HOGamO7el87`05GamO7el0
2E/00omKF`0TF`40000^F`04oe]KPAEK1^`01meagG7MLMd01mh0177NLMh2L@04gW7NL@WN01;Og]oN
gmkOg]oNgmkOg]oNgmh=g`RO017OWmnOgioOWmnOgioOWmnOg`03W`03gmkO00KN00GOg]oNg`02gP06
gmkOg]oN1ml01YoOWmnOg`JO1]l8W`044IlAW`8A00DG4ALA5`024@045a4G4@LG1Q4035lGGaMO5amO
7elOG`LO1Ul01QmO7elOG`UK00?oFe/08e/10000;U/01?mKFh4FF`OL00OMUMfEgIGM00Ia00KNLMia
gW47gP05gmkOg]l03Mh01MoNgmkO00SN00cOg]oNgmkOWmnOgil2g`04WmnOg`ZO2]h5g`0=g]oNgmkO
g]oNgmkOgP07g`05WmnOgil01ml8W`05gioOWml03A4031LA5a4G4ALA5a4G4@`G1Ul01QmO7elOG`PO
00EO7elOG`08F`03oe]K02=K0@0002iK00CoFe^165/7k006gG7MLMea2=h0177NLMh2L@04gW7NL@ON
01;Og]oNgmkOg]oNgmkOg]oNgmh>g`NO00_OWmnOgioOWg7NL@07gP05gmkOg]l02=h01=oNgmh2g`05
g]oNgmh01ml01YoOWmnOg`NO1]l7W`044IlAW`8A00DG4ALA5`024@045a4G4@LG1Q4035lGGaMO5amO
7elOG`LO1Ul01QmO7elOG`QK00?oFe/08U/10000;U/01?mKFh4JF`KL00NEgIGMUMfE00Ma00CNLMia
1mh01moNgmkOg]l03Mh01MoNgmkO00SN00_Og]oNgmkOWmnOg`02W`03gg5a009a4mh6g`0;g]oNgmkO
g]oNgmh01ml01ioOWmnOgil01]l7W`06gioOWmnO314031LA5a4G4ALA5a4G4@`G1Ul01QmO7elOG`PO
00EO7elOG`08F`03oe]K025K0@0002iK00CoFe^175/6k007LMeagG7ML@06gP05LMiagW400]h01G7N
LMia00ON01;Og]oNgmkOg]oNgmkOg]oNgmh=g`>O00CNLMia1Mh01G7NLMia00WN00GOg]oNg`06gP05
gmkOg]l00]h01=oNgmh7g`06WmnOgioO1il6g`NO00@AWa6O0Q401ALA5a4G008A00@G4ALA1aL64@0<
GaMO5elG7elOGamO1al6G`057elO7el02E/00omKF`0PF`40000^F`04oe]KPAiK1]`01YGMUMfEg@Qa
00CNLMia1mh01MoNgmkO00oN00?Og]l02=h01=oNgmh3U@05gW7NLMh01g4BgPKO00_NgmkOg]oNgmkO
gP09g`05WmnOgil01]l7W`06gioOWmnO314031LA5a4G4ALA5a4G4@`G1Ul01QmO7elOG`DO00=O7al0
11l9F`03oe]K01mK0@0002iK00CoFe^17e/6k007gG7MLMeag@07gP04LMiagP9a00CNLMia2Mh04=oN
gmkOg]oNgmkOg]oNgmh8g`JE00KNLMiagW47gP05LMiagW401mh01MoNgmkO00KN00GOg]oNg`02gP06
gmkOg]oN1ml019oOWml7W`OO1Yl02a6O4IlAWaLA5a4G008A00@G4ALA1aL64@0<GaMO5elG7elOGamO
0al4G`047elOG`8O00EO7elOG`09F`03oe]K01iK0@0002iK00CoFe^18E/6g007gIGMUMfEg@06L@06
gW7NLMia1mh01MoNgmkO00gN00GOg]oNg`03gPCL1iD01W7NLMiagPEa4mh7g`0;g]oNgmkOg]oNgmh0
1ml01IoOWmnO00OO1Yl01]nOgioOW``A00`G4ALA5a4G4ALA5a4<5`=O0aL031mO7elOGamO7elOG`HO
2E/00omKF`0MF`40000^F`04oe]KPB=K1^`01]eagG7ML@SN00AagW7N0W401=iagW47gP0AgmkOg]oN
gmkOg]oNgmkLk=`00^`01Mc/g>cL00NE00MagW7NLMia00GN00EagW7NL@07gP05gmkOg]l02=h01=oN
gmh2g`05g]oNgmh01ml01YoOWmnOg`JO1]l8W`094IlAWaLA5a4G008A00@G4ALA1aL64@03GaMO00<G
00HA5a4G4AL7G`047elOG`8O00EO7elOG`08F`03oe]K01eK0@0002iK00CoFe^19E/6g006gIGMUMfE
1g401=iagW47gP07gmkOg]oNg`08gP08g;OL]mc/g>`8g0NE00GNLMiagP06LA?N1]l02mkOg]oNgmkO
g]oN00OO00FOgioOW`07g`JO00OOWmnOgioO00/A00`G4ALA5a4G4ALA5a435`03Wa6O008A00@G4ALA
1QL031mO7elOGamO7elOG`HO25/00omKF`0LF`40000^F`04oe]KPBIK1^`01g7MLMeagG401]h01G7N
LMia00;N00EagW7NL@07gP03gnc/00?/00Zgk;O/]ncLk=c/0]`01NcLk=c/00NE00KNLMiagW47gP05
LMiagW401mh01MoNgmkO00KN00COg]oN0]l01MkOg]oN00OO00JOgioOWml6W`OO1il02A6O4IlG4ALA
5`024@045a4G4@@G00BOgioO1Q455`064ALA5a4G1el011mO7el27`05GamO7el025/00omKF`0KF`40
000^F`04oe]KPBQK1]`01YGMUMfEg@Qa00CNLMia1mh01]oN][Nf]`G/00cL]mbgg;OLk=c/g>`7g0NE
00IagW7NLMh5LA;N1]l02mkOg]oNgmkOg]oN00OO00FOgioOW`08g`NO00GOWmnOg`0;4@035a4G00^O
00@AWa6O0Q4011LA5a465`0<7elOGamO7elOGamO1Ql8F`03oe]K01YK0@0002eK0ol00e^1F`0YF`K/
00IagG7MLMd7gP04LMiagP9a00?N][H00[H01[Nf]kJg]PK/00^gk;O/]ncLk=c/g002k006g>cLk=c/
1YD01g7NLMiagW401Mh01G7NLMia00ON00GOg]oNg`06gP05gmkOg]l00]h01=oNgmh9g`04WmnOg`NO
1]l7W`0:4IlAWaLA5mnOg`:O00_OWmnOgioOWmnOg`064@DG00HA5a4G4AL7G`047elOG`8O00EO7elO
G`08F`03oe]K01UK0@0002eK00GoFe]KP@0YF`03PE]K00KL00JEgIGMUMd6L@0BgW7<`<c0]kJg][Nf
]kJg][Nf1^`03=bgg;OL]mc/g>cLk0KL1iD01MiagW7N00Ia4]h7g`0;g]oNgmkOg]oNgmh01ml01IoO
WmnO00KO1il01MnOgioO008A1=lCW`044IlAW`8A00@G4ALA1QL031mO7elOGamO7elOG`HO25/00omK
F`0HF`40000]F`05oe]KFh40:E/00h5KF`02F`G/00KMLMeagG43gPA<00K<3L`=c0d6]P06]kJg][Nf
1^`02[O/]nbgk=c/g>`2g006k=c/g>cL1YD01]iagW7NL@GN00EagW7NL@07gP05gmkOg]l02=h01=oN
gmh2g`05g]oNgmh01ml019oOWml7W`KO0il4g`FO00GOWmnOg`02W`0;gioOWmnOgioOWml01Q455`06
4ALA5a4G1el011mO7el27`05GamO7el025/00omKF`0GF`40000]F`04oe]KPBYK00>1Fe/00e/6g00N
gIE=C4e<CDa=C4e<CLc0c<3<][Nf]kJg][Nf]kJg1^`02kOL]mbgg>cLk=c/00OL1iD01W7NLMiagPEa
4Mh7g`0;g]oNgmkOg]oNgmh01ml01IoOWmnO00KO0il4g`05WmnOgil01]lCW`044IlAW`8A00@G4ALA
1QL031mO7elOGamO7elOG`DO25/00omKF`0GF`40000]F`04oe]KPBYK00>1Fe/01E/2k0AV1Td6C006
3L`=c0g<1KH01kNf]kJg][L01N`03;O/]nbgk;O/g>cLk0;L00G/g>cLk006U@05LMiagW401mh01G7N
LMia00ON00GOg]oNg`06gP04gmkOgP;O00GNgmkOgP07g`04WmnOg`BO00?Og]l00]h01=oNgmh7g`FO
00GOWmnOg`02W`0;gioOWmnOgioOWml01Q455`064ALA5a4G1el00amO7`02G`057elOGal025/00omK
F`0FF`40000]F`04oe]KPBYK00>1Fe/01e/7C@0LC4e<CDa=C4e<CDc0c<3<`<bf]kJg][Nf]kJg]PK/
00cL]mbgg;OLk=c/g>`6g0JE00IagW7NLMh5LA;N1]l02mkOg]oNgmkOg]oN00OO00^OgmkOg]oNgmkO
gP07g`05WmnOgil01]lCW`044IlAW`8A00@G4ALA1QL02QmO7elOGamO7el77`QK00?oFe/05E/10000
;E/01?mKFh4ZF`03PE]K00UK1FH6C@M<00H=c0g<3L`5]P06]kJg][Nf1^`02kO/]nbgk=c/g>cL00;/
00GLk=c/g006U@06gW7NLMia1Mh01G7NLMia00ON00GOg]oNg`08gP03gmkO00;N00COg]oN2=l5gP05
gmkOg]l00]h01=oNgmh7g`FO00GOWmnOg`02W`0;gioOWmnOgioOWml01Q455`064ALA5a4G1El01AmO
7elO009O00DOGamO7`08F`03oe]K01AK0@0002eK00CoFe^1:U/00h5KF`0:F`I=01i<CDa=C4e<CDa=
C4e<`<c0c<2g][Nf]kJg][Nf]kH5k00;]mbgg;OLk=c/g>`01m`6U@07gW7NLMiagP04LA;N1ml01]kO
g]oNg`;N00?Og]l01]h02]oNgmkOg]oNgmh4g`Co00COWmnO1]lCW`044IlAW`8A00@G4ALA1QL02QmO
7elOGamO7el77`QK00?oFe/04e/10000;E/01?mKFh4ZF`03PE]K00aK1VH6C@I<00K<3L`=c0d6]P05
]kJg][L01n`02[O/]nbgk=c/g>`2g005k=c/g>`01YD01G7NLMia00ON00=agW402Mh00moNg`08gP0:
gmkOg]oNgmkOgPOO1Mh01MoNgmkO00?o12<00ooOg`03g`NO00?OWml00Yl03=nOgioOWmnOgioOW`DA
1AL01Q4G4ALA5`EO00DOGamO7`02G`057elOGal025/00omKF`0BF`40000]F`04oe]KPBYK00>1Fe/0
3U/6C@0MC4e<CDa=C4e<CDa=c<3<`<c0]kJg][Nf]kJg][L01N`03=bgg;OL]mc/g>cLk0KL1YD01W7N
LMiagPEa4Mh3g`[N00GOg]oNg`06gP04gmkOgPGo22<01OoOWmnO00OO4Yl0116O4Il24@045a4G4@HG
00XOGamO7elOGamO1al8F`03oe]K015K0@0002eK00CoFe^1:U/00h5KF`0@F`IV1Dd7C006c0g<3L`=
1;H01[Nf]kJg]PK/00^gk;O/]ncLk=c/g002k005g>cLk=`01YD01]iagW7NL@GN00EagW7NL@07gP04
gg7NL@ON00[Og]oNgmkOg]oN1=l6o`hS00?ogml00ml7W`04gioOW`;O00^OgioOWmnOgioOW`054@DG
00HA5a4G4AL5G`057elOGal00Ul01AmO7elO01]K0@0002eK00CoFe^1:U/00h5KF`0BF`I=01a<CDa=
C4e<CDa=C4g<`<c0c;Jg][Nf]kJg][Nf1^`03=bgg;OLk=c/g>cLk0KL1ID01miagW7NLMh0174=gP03
LMia00gN00?Oool01?lE8`05omnOgil01mlBW`044IlAW`8A00@G4ALA1QL02QmO7elOGamO7el77aYK
0@0002eK00CoFe^1:U/00h5KF`0CF`IV1Td6C0063L`=c0g<1KH01[Nf]kJg]PK/00Zgk;O/]ncLk=c/
0]`01NcLk=c/00JE00EagW7NL@05gP03LMkN00?N00EagW7NL@02gP03LMia00WN1?lC8`03ob<S00HS
00?ogml01=l6W`04gioOW`;O00^OgioOWmnOgioOW`054@DG00HA5a4G4AL5G`057elOGal00Ul01AmO
7elO01UK0@0002eK00CoFe^1:U/00h5KF`0EF`M=01]<CDa=C4e<CDa=C<3<`<c0c;Jg][Nf]kJg][L0
1^`02kOL]mbgg>cLk=c/00OL1ID00g7NL@08L@04gW7NL@SN00EagW7NL@03gP?o0al>8`03ob<S00@S
00?o8b<01R<2o`05WmnOgil01MlBW`044IlAW`8A00@G4ALA1QL02QmO7elOGamO7el47a]K0@0002eK
00CoFe^1:E/00h5KF`0HF`IV1Td6C0053L`=c0d01[H01KNf]kJg00G/00bgk;O/]ncLk=c/g>`2g004
k=c/g0:E00UagG7MgW7NLMh00W400miagP07gP04LMiagP9a00?Nool00ol77`LS00?o8b<032<00olS
8`068`03omoO00?O1Yl01=nOgil2g`0;WmnOgioOWmnOgil01A455`064ALA5a4G1El00amO7`0PF`40
000/F`?o00=KPE/0:5/00h5KF`0JF`M=01Y<CDa=C4e<CDa=c<3<`<c0]kJg][Nf]kJg]PK/00cL]mbg
g;OLk=c/g>`2g003UMfE00;M00AagG7M37401MiagW7N00Ko3Al00olS8`058`03ob<S00@S00?o8b<0
12<00olS8`068`06oioOWmnO1]lAW`044IlAW`8A00@G4ALA1QL00amOF`0TF`40000/F`05oe]KFh40
:E/00h5KF`0LF`EV1Td6C006c0g<3L`=1;H01[Nf]kJg]PK/01Jgk;O/]ncLk9GLUMaaUG6ELMeagG7M
0W401=iagW42gP03LMko00Go00eO7elOGamO7elOGaoo00PO00?o8b<012<00olS8`048`03ob<S00@S
00?o8b<01R<00ooOg`03g`JO00COWmnO0]l02ioOWmnOgioOWmnO00DA1AL00a4G4@0YF`40000/F`05
oe]KFh40:E/00h5KF`0MF`I=01a<CDa=C4e<CDa=C4g<`<c0c<2g][Nf]kJg][Nf1N`01[OLUMbEg0JE
00[MUMfEgIEagG7M0g46o`0<7elOGamO7elOGamO1al00olO7`067`03ob<S00@S00?o8b<012<2o`DS
0_l78`06oioOWmnO1]lAW`034ImK009K00>1Fe/0;E/10000;5/01OmKFe^102UK00>1Fe/07e/6IPI=
1T`01L`=c0g<00Ff00Fg][Nf]`02k00?g>cLk=bEg9GLUMbEg9GL00:E00AaUG6E1_l011mO7el27`0F
GamO7elOGamO7elOGomO7elOGamOo`LO00?o8b<012<2o`HS00?o8b<012<00olS8`058`03omoO00?O
1Yl01=nOgil2g`08WmnOgioOWml7F`03PE]K02eK0@0002aK00CoFe^1:U/00h5KF`0QF`I=01M<CDa=
C4e<CDa=C<3<`<c0c;Jg][Nf]`04]PG/00GLUMbEg007U@Co1Al05ElOGamO7elOGamO7elOoamO7elO
G`02o`HO00?o7al01Al2o`HS00?o8b<012<00olS8`048`03ob<S00DS0_l01=nOgil6g`RO35/00h5K
F`0]F`40000/F`04oe]KPBYK00>1Fe/085/00h5KF`06IPE=1T`00`g<aP03aPVf00g/g>cLk=bEg9GL
UMbE00?o2Ul07AmO7elOGaooGamO7elOoamO7elOGaoo7elOGamO00;o1al00olS8`048`03ob<S00@S
0_l58`03ob<S00HS00?ogml00]l6W`03gimK011K00>1Fe/0;E/10000;5/01?mKFh4ZF`03PE]K021K
00>1Fe/00U/6C@07C4e<CDa=C004?`0:`<K0a/2e][Ff]@Ff1^`00mcoo`02o`07GamO7elOG`077`0G
oamO7elOGomO7elOGamOoelOGamO7ol01al00olO7`057`03ob<S00@S0_l68`03ob<S00<S0_l78`05
omnOgil00mlEF`03PE]K02eK0@0002aK00CoFe^1:U/00h5KF`0PF`03PE]K00=K1VH2C@@S00E??dlo
C`06aPZf00?/ool00_l00amO7`09G`03oemO00AO01ooGamO7elOGolOGamO7eooGamO7elOoamO7elO
Gaoo00LO0_l68`03ob<S00@S00?o8b<012<00olS8`058`03ommK01UK00>1Fe/0;E/10000;5/01?mK
Fh4ZF`03PE]K021K00>1Fe/01E/2C@XS1Cl02LK0a/36`;Ff]@03]P?o15l011mO7el27`08GamO7elO
Gol67`0GoamO7elOGaoo7elOGamOoelOGamO7ol01al2o`LO00?o8b<012<00olS8`048`03ob<S00@S
00?o8b<01B<00omKF`0HF`03PE]K02eK0@0002aK00CoFe^1:U/00h5KF`0PF`03PE]K00MK2b<01Sm?
?dloC`G60[H3o`067elOGamO0Ql01UlOGamOo`MO00?oGel015l2o`0D7elOGamOoamO7elOGomO7elO
Gal2o`08GamO7elOGol77`03ob<S00@S00?o8b<012<2o`DS00?o8b<01B<00omKF`0GF`03PE]K02eK
0@0002aK00CoFe^1:U/00h5KF`0PF`03PE]K00UK2b<5?`03`<K000?o00<GGaL025l03_lOGamO7omO
7elOGamO0_l67`0>oelOGamO7olOGamO7el2o`077elOGamOo`077`03oalO00DO00?o8b<012<2o`HS
00?o8b<00b<2o`HS00?oFe/05e/00h5KF`0/F`40000/F`04oe]KPBYK00>1Fe/085/00h5KF`0:F``S
00<oCcl00ol8G`0=7elOGamO7omO7elOG`02o`MO00?oGel015l01olOGamO7el00_l05ElOGamO7olO
GamO7eooGamO7elOG`02o`HO0_l68`03ob<S00@S00?o8b<012<00olS8`048`;o5e/00h5KF`0/F`40
000/F`04oe]KPBYK00>1Fe/085/00h5KF`0<F`XS0ol02a4G4ElGGaMO5elG00QO013o7elOGamOoamO
7elOGaoo1Ql05omO7elOGamOoelOGamO7olOGamO7eoo00PO00?o7al01Al00olS8`048`03ob<S00@S
0_l58`03ob<S00DS00?oFe/055/00h5KF`0/F`40000/F`04oe]KPBYK00>1Fe/085/00h5KF`0>F`@S
1?l01a4G4ALA5a4025l04?lOGamO7elOoelOGamO7ol7G`03oemO00AO01Ko7elOGamO7omO7elOGaoo
7elOGamO0_l021mO7elOGaoo1al00olS8`048`;o1R<00olS8`038`03ob<S00DS00?oFe/04e/00h5K
F`0/F`40000/F`;o00=KPE/0:E/00h5KF`0PF`03PE]K00eK1Ol05A4G4OlG4ALA5a4G4ElGGaMO5elG
o`07G`0@oamO7elOGolOGamO7elOo`HO00ooGamO7elOGomO7elOGal00_l01elOGamO7ol01al2o`HO
0_l68`03ob<S00@S00?o8b<00b<2o`HS00?oFe/04U/00h5KF`0/F`40000[F`05oe]KFh40:U/00h5K
F`0PF`03PE]K00UK1?l35`03oaLG00<G00[o5a4G4ALA5a7o1el04?lOGamO7elOoelOGamO7ol7G`03
oemO00AO0_l01UlOGamO7`;o01LOGamO7eooGamO7elOoamO7elOGamOo`077`03ob<S00@S00?o8b<0
12<00olS8`048`03ob<S00@S00?oFe/04E/00h5KF`0/F`40000[F`05oe]KFh40:U/00h5KF`0PF`03
PE]K00MK0_l24@0Noa4G4ALAoa4G4ALAoaLA5a4G4ALAoaMO5elGGaOo1el01olOGamO7el00_l01UlO
GamO7`;o1Ql05olOGamO7elOoamO7elOGomO7elOGaoo00PO00?o7al01Al00olS8`048`03ob<S00@S
0_l58`03ob<S00@S00?oFe/045/00h5KF`0/F`40000[F`05oe]KFh40:U/00h5KF`0PF`03PE]K00IK
00Oo5a4G4AOo00DG00?o5aL00aL02_lG4ALA5a4G4Ol7G`0AoamO7elOGaooGamO7elOGol01el00omO
G`04G`0FoelOGamO7eoo7elOGamOoelOGamO7`;o00MO7elOGamO00;o1Ql00olS8`048`;o1R<00olS
8`038`04ob<S8`Go45/00h5KF`0/F`40000[F`05oe]KFh40:U/00h5KF`0PF`03PE]K00AK0_l74@0N
oa4G4ALAoa4G4ALAoaLA5a4G4ALAoaMO5elGGaOo1el04OlOGamO7elOoelOGamO7eoo00HO00oo7elO
GamO7olOGamO7el00_l01amO7elOGol021l00olO7`047`;o1R<00olS8`048`04ob<S8`Go00HOGamO
7ol?F`03PE]K02aK0@0002]K00GoFe]KP@0ZF`03PE]K021K00>1Fe/00U/2o`>O00PG4ALA5a4Go`DG
00?o5aL00aL02_lG4ALA5a4G4Ol7G`0AoamO7elOGaooGamO7elOGol01el00omOG`04G`0QoelOGamO
7eoo7elOGamO7olOGamO7eooGamO7elOGaoo00LO00?o8b<012<01?lS8b<6o`=O00Wo7elOGamO7ol0
3U/00h5KF`0/F`40000[F`05oe]KFh40:U/00h5KF`0PF`03PE]K00;o1Yl74@0Moa4G4ALAoa4G4ALA
oaLA5a4G4ALAoaMO5elGGaL00_l6G`08oamO7elOGal2o`077elOGamOo`067`;o00IO7elOGal2o`0>
GamO7elOoamO7elOGol87`;o1Ql01?lS8b<6o`047elOo`HO00Wo7elOGamO7ol03E/00h5KF`0/F`40
000[F`04oe]KPB]K00>1Fe/085/3o`VO00PG4ALA5a4Go`DG00?o5aL00aL02_lG4ALA5a4G4Ol8G`0A
oelOGamO7omO7elOGamO7ol01Ul2o`IO027o7elOGamO7omO7elOGaoo7elOGamOoelOGamO7elOGol0
1Al4o`04GamOo`HO00?oGel015l02OlOGamO7elOo`0<F`03PE]K02aK0@0002]K00CoFe^1:e/00h5K
F`0KF`Go0Yl00onOW`08W`LA01oo4ALA5a7o4ALA5a7o5a4G4ALA5a7o5elGGaMO5eoo00IO01;o7elO
GamO7eoo7elOGamO7ol67`0FoelOGamO7eooGamO7elOoamO7elOG`;o21l00olOo`02o`035omO00EO
00SoGamO7elOo`HO00So7elOGamO7`;o2U/00h5KF`0/F`40000[F`04oe]KPBYK00>1Fe/05e/5o`09
WmoogioOWmoo00ZO00So4ALA5a4Go`DG00?o5aL00aL02_lG4ALA5a4G4Ol8G`07oelOGamO7`02o`08
7elOGamO7ol7G`03oemO00AO00oo7elOGamO7omO7elOGal00_l03UlOGamO7olOGamO7elO0_l03ElG
GaMOoamO7elOGol01Ql00omOG`04G`0:oamO7elOGamOo`UK00>1Fe/0;5/10000:e/01?mKFh4ZF`03
PE]K01=K1?l00mnOo`05W`03oinO00>O00?oWil029l00olA4@044@0Ooa4G4ALAoa4G4ALAoaLA5a4G
4ALAoaMO5elGGaMOo`07G`0AoelOGamO7eoo7elOGamO7ol01Ql02?mO7elOGamO0_l03QmO7elOGomO
7elOGaoo11l2o`035olG00DG00?oGel015l02?mO7elOGaoo1Ql02_lOGamO7elOGol8F`03PE]K02aK
0@0002]K00CoFe^1:U/00h5KF`0BF`0EoioogioOWmoogioOWmoogioOWmoo00ZO00So4ALA5a4Go`DG
00?o5aL00aL02_lG4ALA5a4G4Ol8G`0@oelOGamO7eoo7elOGamO7`;o1Ul00omOG`04G`0IoamO7elO
GamOoamO7elOGomO7elOGaoo7`02o`@A00oo5elGGaMOoamO7elOGol01Ql00omOG`04G`0:oamO7elO
GamOo`MK00>1Fe/0;5/10000:e/01?mKFh4ZF`03PE]K015K00_ogioOoioOWmnOo`05W`03oinO00>O
00?oWil029l00olA4@044@0Ooa4G4ALAoa4G4ALAoaLA5a4G4ALAoaMO5elGGaMOo`07G`0AoelOGamO
7elOoelOGamO7ol01Ql2o`0B7elOGamO7olOGamO7eooGamO1?l75`03oaLG00@G00?oGel015l02?mO
7elOGaoo1Ql02_lOGamO7elOGol6F`03PE]K02aK0@0002]K00CoFe^1:U/00h5KF`0@F`03oinO00>O
01?ogioOWmoogioOWmoogioOWmoo00ZO00So4ALA5a4Go`DG00?o5aL00aL02_lG4ALA5a4G4Ol8G`0B
oelOGamO7eoo7elOGamO7eoo1Ul2o`IO00koGamO7elOGolOGamO7`Co0aL00olA4@064@0?oaMO5elG
oelOGamO7eoo00HO00?oGel015l02OlOGamO7elOG`02o`AK00>1Fe/0;5/10000:e/01?mKFh4ZF`03
PE]K00eK0ol03]nOgioOWmooWmnOgioo1Il00onOW`03W`03oinO00RO00?o4A4011405OlA5a4G4OlA
5a4G4OlG4ALA5a4G4@02o`08GaMO5elGGol7G`0BoelOGamO7elOoelOGamO7eoo1Ql02_lOGamO7elO
oal3o`094OlA5a4G4AOo00LG00?o5aL011L00omOG`04G`09oamO7elOGaoo00HO00_o7elOGamO7elO
o`03F`03PE]K02aK0@00025K1?l6F`:100?oPE/0:E/00h5KF`08F`Go0]l00onOW`06W`0ComnOgioO
omnOgioOomnOgioOo`0:W`08oa4G4ALA5ol55`03oaLG00<G00_o5a4G4ALA5a4Go`07G`0BoelOGamO
7eoo7elOGamO7eoo1el00omOG`04G`07oelOGamO7`02o`065a4G4AOo1QL00olA4@054@0?oelGGaMO
5omO7elOGaoo00LO00?oGel015l02olOGamO7elOGaoo009K00>1Fe/0;5/1000085/00omKF`02F`03
oe]K009K00?oFe/00h4YF`03PE]K00AK1?l2gP0FomkOg]oNoioOWmnOgioOoioOWmnOo`FO00?oWil0
0il00onOW`08W`03oa4A00@A01ko4ALA5a7o4ALA5a7o5a4G4ALA5a4GoelGGaMO5el2o`IO00WoGamO
7elOGal00_l01amO7elOGol01Ql01?lOGal2o`0@4OlG4ALA5a7o4ALA5a4Go`LG00?o5aL011L00omO
G`04G`09oamO7elOGaoo00HO00_o7elOGamO7elOo`02F`03PE]K02]K0@00021K00?oFe/00U/00omK
F`02F`06oe]KFh5K0X4WF`03PE]K00=K00?ogml01Ml00ooOg`03g`03oinO00JO01?ogioOWmoogioO
WmoogioOWmoo00ZO00So4ALA5a4Go`DG00?o5aL00aL02olG4ALA5a4G4AOo00QO01;o7elOGamOoamO
7elOGamO7ol6G`03oemO00AO00ooGolA5a4Goa4G4ALA5ol01QL00olA4@054@0?oelGGaMOoamO7elO
Gaoo00LO00?oGel015l03OlOGamO7elOGaooFh40;E/1000085/00omKF`02F`03oe]K009K00GoFe]K
P@03F`>195/00h5KF`02F`04omoNg`KN01Kog]oNgmkoWmnOgioOWmooWmnOgioo1Il00onOW`03W`03
oinO00RO00?o4A4011408?lA5a4G4OlA5a4G4OlG4ALA5a4G4AOoGaMO5elGGaOo1Ul04_mO7elOGamO
7eoo7elOGamOo`<O1?l64@0>oaLA5a4G4OlA5a4G4Ol75`03oaLG00@G00?oGel01El02OlOGamO7elO
o`067`0:oamO7elOGamO7`;o;E/1000085/00omKF`02F`03oe]K009K00GoFe]KP@06F`:18U/02H5K
Fe_ogmkOgP07g`03omoO00?O00?oWil01Yl04ooOWmnOgooOWmnOgooOWmnOgol02Yl02?lA5a4G4AOo
1AL00olG5`035`0;oaLA5a4G4ALA5ol025l04_lOGamO7eoo7elOGamO7elOo`EO1?l04a6O4OlG4ALA
5a4Goa4G4ALA5ol01AL00olA4@054@0@oaMO5elGGolOGamO7elOo`LO00?oGel015l03?lOGamO7elO
GamOobaK0@00021K00?oFe/00U/00omKF`02F`05oe]KFh4025/3PAmK00^1oooogmkOg]oNg`05gP0G
omoNgmkOg_nOgioOWmnOgonOgioOWol01Il00onOW`03W`03oinO00RO00?o4A4011408?lA5a4G4OlA
5a4G4OlG4ALA5a4G4AOoGaMO5elGGaOo1Ul03?mO7elOGamO7eoo7`?o00>Ooa401A400olA4@054@0>
oaLA5a4G4OlA5a4G4Ol75`03oaLG00@G00?oGel01El02OlOGamO7elOo`067`0<oamO7elOGamO7eoo
:e/1000085/00omKF`02F`03oe]K009K00GoFe]KP@0;F`:16E/5o`0;gmkOg]oNgmkOg_l01Ml00ooO
g`04g`03oinO00JO01?ogioOWmoogioOWmoogioOWmoo00ZO00So4ALA5a4Go`DG00?o5aL00aL02olG
4ALA5a4G4AOo00QO01;o7elOGamOoamO7elOGamO7ol5W`0FoilAWa6O4OlG4ALA5a4Goa4G4ALAo`HG
00?o4A401A404?lGGaMO5eoo7elOGamO7ol77`03oemO00AO00co7elOGamO7elOGolZF`40000PF`03
oe]K009K00?oFe/00U/01OmKFe^100eK0X4CF`Co2=h02MoNgmkOg]oNo`05gP0GomoNgmkOg_nOgioO
WmnOgonOgioOWol01Il00onOW`03W`03oinO00RO00?o4A4011408?lA5a4G4OlA5a4G4OlG4ALA5a4G
4AOoGaMO5elGGaOo1Ul02?mO7elOGamO0_l01mnOgioOWol01Q400olA4@044@0?oa4G4ALA5olG4ALA
5a7o00HG00?o5aL011L00omOG`05G`0:oelOGamO7elOo`HO00co7elOGamO7elOGolYF`40000QF`Co
1E/01?mKFh4@F`>13E/3o`0Fg]oNgmkOg]oNgmkOg]oNgmkOg]oNo`GO00?ogml01=l00onOW`06W`0C
omnOgioOomnOgioOomnOgioOo`0:W`08oa4G4ALA5ol55`03oaLG00<G00_o5a4G4ALA5a4Go`08G`0>
oamO7elOGolOGamO7ol2g`03oinO00BO01KoWa6O4IlAoaLA5a4G4OlG4ALA5a7o1AL00olA4@054@0@
oelGGaMO5omO7elOGamOo`PO00?oGel015l02olOGamO7elOGamO00;o9e/10000:U/01?mKFh4CF`:1
2E/2o`04g]oNg`gN00OOg]oNgmkO00KN01Oog]oNgmkOg_nOgioOWmnOgonOgioOo`06W`03oinO00>O
00?oWil029l00olA4@044@0Poa4G4ALAoa4G4ALAoaLA5a4G4ALA5omO5elGGaMO5ol6G`05oelOGol0
19l02?oOWmnOgioo1Q400olA4@044@0>oa4G4ALA5olG4ALA5ol75`03oaLG00@G00?oGel01El02_mO
7elOGamO7ol67`0=oamO7elOGamO7olOo`0VF`40000ZF`04oe]KPAEK0h45F`03og7N00KN01COg]oN
gmkOg]oNgmkOg]oNgmkOo`GO00?ogml01Ml00onOW`06W`0ComnOgiooWmnOgioOomnOgioOo`0:W`08
oa4G4ALA5ol55`03oaLG00<G00_o5a4G4ALA5a4Go`08G`0:oamO7elOGolOo`KO00?oWil019l05_nO
4IlAWa7o5a4G4ALAoaLA5a4G4Ol55`03oa4A00DA013oGaMO5elGoelOGamO7eoo21l00omOG`04G`0=
oamO7elOGaooGamOo`0UF`40000ZF`04oe]KPAQK0X42F`03omkN00;N00GOg]oNg`0<gP09omoNgmkO
g]oo00GN01Oog]oNgmkOg_nOgioOWmnOgonOgioOo`06W`03oinO00>O00?oWil029l00olA4@044@0P
oa4G4ALAoa4G4ALAoaLA5a4G4ALA5omO5elGGaMO5ol3G`Co29l02?oOWmnOgioo1Q400olA4@044@0>
oa4G4ALA5olG4ALA5ol65`03oaLG00DG00?oGel01El02_mO7elOGamO7ol67`07oamO7elOo`057`03
oe]K029K0@0002YK00CoFe^16U/01h7oLMiagW401mh05=oNgmkOomoNgmkOomoNgmkOg]oo1Ml00ooO
g`05g`03oinO00JO01?ogioOWonOgioOWmoogioOWmoo00ZO00So4ALA5a4Go`DG00?o5aL00aL02olG
4ALA5a4G4AOo00MO1?l4W`03omoO00KO00?oWil019l05OnO4IlAWa7o5a4G4ALAoaLA5a4Go`065`03
oa4A00@A017o5elGGaMOoamO7elOGamOo`087`03oemO00AO00go7elOoelOGamO7eoo02=K0@0002YK
00CoFe^16E/2o`SN00GOg]oNg`06gP03omkN00?N00WogmkOg]oNgol01=h06?oOg]oNgmkOg_nOgioO
WmnOgonOgioOo`JO00?oWil00Yl00onOW`09W`03oa4A00@A023o4ALA5a7o4ALA5a7o5a4G4ALA5a4G
oelGGaMOomnOo`KO00?oWil01Yl01ooOWmnOgol01a400olA4@044@0=oa4G4ALAoa4G4ALAo`075`03
oaLG00@G00?oGel01Ul02_mO7elOGamO7ol67`03oaoo00TO0_lQF`40000ZF`04oe]KPAIK0ol02W7o
gW7NLMiagW46gP0DomoNgmkOomoNgmkOomoNgmkOg_l5g`03omoO00KO00?oWil01Yl04_oOWmnOoioO
WmnOoioOWmnOo`^O00So4ALA5a4Go`DG00?o5aL00aL02olG4ALA5a4G4AOo00=O00KogioOWol6W`03
omoO00GO00?oWil019l05_lAWa6O4Ioo4ALA5a4Goa4G4ALA5ol55`03oa4A00@A017oGaMO5elGGolO
GamO7elOo`097`04oemOG`Co00eO7elOGamO7elOGaoo021K0@0002YK0_l00e^1F`0CF`;o00KNLMia
g_l9gP06gmkOg]oo1Mh00ooNgP03gP08omoNgmkOg_l5gP0HomoNgmkOg]oNoioOWmnOgioOoioOWmoo
1Il00onOW`03W`03oinO00VO00?o4A4011408?lA5a4G4OlA5a4G4OlG4ALA5a4G4AOoGooOWmnOgioo
1]l00onOW`05W`08oioOWmnOgol64@03oa4A00@A00ko5a4G4ALAoa4G4ALAo`HG00?o5aL01AL00omO
G`05G`0:oamO7elOGamO7`?o00@OGamO3Al00omKF`0MF`40000YF`05oe]KFh404e/04_oNomiagW7N
LOoNLMiagW7NL@KN01CogmkOg]oogmkOg_oNgmkOg]oNo`GO00?ogml01]l00onOW`05W`0CoioOWmnO
oioOWmnOoioOWmnOo`0;W`08oa4G4ALA5ol55`03oaLG00<G01Co5a4G4ALA5a4GomnOgioOWmnOo`JO
00?ogml01Ml00onOW`04W`0Foa6O4IlAWolA5a4G4AOo4ALA5a4Go`DG00?o4A4011404OmO5elGGaMO
oamO7elOGaoo00LO00[oGemO7elOGamO0_l02elOGamO7elOGaoo01iK0@0002UK00GoFe]KP@0BF`0<
og5aLOmagW7NLMko1mh02?oNgmkOg]oo1=h00ooNgP03gP09omkOg]oNgmko00CN01Wog]oNgmkOg]oN
oioOWmnOgioogioOWmoo00FO00?oWil00il00onOW`09W`03oa4A00@A01Go4ALA5a7o4ALA5a7o5a4G
4ALA5ol00ml029oOWmnOgioo1]l00onOW`05W`08oioOWmnOgol64@03oa4A00@A00go5a4G4ALAoa4G
4AOo00LG00?o5aL011L00omOG`06G`0DoamO7elOoamO7eooGamO7elOGol:7`03oe]K01]K0@0002UK
00GoFe]KP@0AF`03omkN00?N013ogW7NLMiaomiagW7NLMko1]h04ooOg]oNomkOg]oNomkOg]oNgol0
1Ml00ooOg`07g`03oinO00FO01?oWmnOgiooWmnOgiooWmnOgioo00^O00So4ALA5a4Go`DG00?o5aL0
0aL01olG4ALA5ol01Ml029oOWmnOgioo1Yl00ooOg`05g`03oinO00BO01Ko4IlAWa6Ooa4G4ALA5olA
5a4G4AOo11L00olA4@044@0BoaMO5elGGaOoGamO7elOGaoo0al00omOG`05G`07oelOGamO7`02o`0:
7elOGamO7elOoaaK0@0002UK00GoFe]KP@0@F`03og5a00Ea00SoLMiagW7No`ON00Sog]oNgmkOo`CN
00?og]h00mh02?oNgmkOg]oo1Mh06OoNgmkOg]oNgmkoWmnOgioOWooOWmnOgol01Il00onOW`03W`03
oinO00VO00?o4A4011404OlA5a4G4OlA5a4G4OlG4AOo00OO00ROgioOWmnOo`KO00?oWil01Il02?nO
gioOWmoo1Q400olA4@044@0=oaLA5a4GoaLA5a4Go`065`03oaLG00DG00?oGel01Ul05OlOoamO7elO
GamO7olOGamO7elOo`097`;o6U/10000:E/01OmKFe^1011K00?ogMh01]h04?oNLMiagW7ogW7NLMia
g_l5gP0DomkOg]oNomkOg]oNomkOg]oNgol5g`03omoO00OO00?oWil01Il04onOgioOWonOgioOWonO
gioOWol02il02?lA5a4G4AOo1AL00olG5`035`03oaOo00SO00WoWmnOgioOWol01Yl00ooOg`05g`03
oinO00BO01Go4IlAWa6Ooa4G4ALAoaLA5a4G4Ol01AL00olA4@044@0BoaMO5elGGaOoGamO7elOGaoo
2el2o`067elOGamO0_l02UlOGamO7elOGolIF`40000YF`05oe]KFh403e/01?nEgID7L@08og7NLMia
g_l7gP07omkOg]oNo`05gP03omkN00;N00WogmkOg]oNgol01=h06_oOg]oNgmkOg]oNoioOWmnOgioo
gioOWmoo1Il00onOW`03W`03oinO00VO00?o4A4011402_lA5a4G4OlA5a43o`[O00WoWmnOgioOWol0
1]l00onOW`04W`08omnOgioOWol74@03oa4A00<A00ko4ALA5a4GoaLA5a4Go`HG00?o5aL011L00omO
G`05G`0HoaLG7elOGamO7elOGamOoelOGamO7eoo2Al00omKF`0FF`40000YF`05oe]KFh403e/01Oma
gG7M00ON013ogW7NLMiaomiagW7NLMko1Mh04ooNgmkOomoNgmkOomoNgmkOg_l01Ml00ooOg`08g`03
oinO00FO01?oWmnOgooOWmnOgiooWmnOgioo00^O00So4ALA5a4Go`<G1Ol01=oNgmh:g`09oioOWmnO
gioo00JO00?ogml01=l00onOW`04W`0FoilAWa6O4Ioo4ALA5a7o5a4G4ALAo`@G00?o4A4011405OmO
5elGGaMOoamO7elOoa4G4ALAo`0:G`;o015O7elOGaooGamO7elOGamOo`0GF`40000YF`05oe]KFh40
3U/01ooMUMfEgID01g402?magW7NLMko1]h02?oOg]oNgmko1=h00ooNgP03gP08omoNgmkOg_l5gP0I
omoNgmkOg]oNgmkoWmnOgioOWooOWmnOo`06W`03oinO00>O00?oWil02Il00olA4@034@Co00[Og]oN
gmkOg]oN2]l02OnOgioOWmnOo`06g`03oinO00BO00SogioOWmnOo`LA00?o4A400a403OlA5a4G4AOo
5a4G4Ol01QL00olG5`055`05oemOGol021L2o`0@7elOGamO7elOoamO7elOG`;o21l00omKF`0DF`40
000YF`04oe]KP@iK00WoLMeagG7MLMd01mh03ooNLMiagW7ogW7NLMiao`06gP0ComkOg]oogmkOg]oo
gmkOg]oNo`05g`03omoO00SO00?oWil01Il04onOgioOomnOgioOWonOgioOWol02il00olAo`02o`CN
00COg]oN0]l01]kOg]oNo`WO00WoWmnOgioOWol01Yl00ooOg`04g`03oinO00BO01KoWa6O4IlAoaLA
5a4G4OlG4ALA5a7o11L00olA4@044@0FoelGGaMO5eoo7olA5a4G4ALA5a4G4@;o25l2o`0>7elOGamO
oamO7elOGal2oaEK0@0002UK00CoFe^13U/02onEgIGMUMfEgIGo00Ia00SoLMiagW7No`KN00SogmkO
g]oNo`CN00?og]h00mh02?oOg]oNgmko1=h06_oNgmkOg]oNgmkOg_nOgioOWmnOomnOgioo1Yl00onO
W`03W`03oinO00VO00?ogml01]l03MkOg]oNomkOg]oNgol02=l2o`07gioOWmnOo`06g`03oinO00BO
00SogioOWmnOo`HA00?o4A4011403OlA5a4G4OlA5a4G4Ol01QL00olG5`045`;o3QL2o`0?7elOGamO
7eooGamO7elO00;o0al2o`=K1H4?F`40000YF`04oe]KP@eK00gogG7MLMeagG7MLMgo00KN00oogW7N
LMiaomiagW7NLOl01Mh04ooOg]oNgooOg]oNomkOg]oNgol01Ml00ooOg`09g`03oinO00FO01?oWmnO
gooOWmnOgiooWmnOgioo00ZO00?ogmh01]h03_oOg]oNgooNgmkOg]oo2Ml02?oOWmnOgioo1Yl00ooO
g`04g`03oinO00BO01GoWa6O4IlAoaLA5a4G4OlG4ALA5ol01AL00olA4@034@07oaMO5elGo`055`0>
4ALA5a4G4ALA5a4G4Ol8G`0;oamO7elOGaooGol01H4DF`40000YF`04oe]KP@eK00kogIGMUMfEgIGM
UMfEo`Ia00SoLMiagW7No`KN00OogmkOg]oo00CN00?og]h00mh02?oNgmkOg]oo1Mh06_oNgmkOg]oN
gmkOg_nOgioOWmnOomnOgioo1Yl00onOW`03W`03oinO00JO00Cog]kN1ml01_oNgmkOgP;o00KOg]oN
gol9g`08omnOgioOWol6g`03oinO00>O00WoWmnOgioOWol01Q400olA4@034@0=oaLA5a4G4OlA5a4G
o`065`0=oaLG5olA5a4G4ALA5`02o`XG0_l01elOGamO7el00_l01AmO7elO00;o6U/10000:E/01?mK
Fh4;F`;o00magG7MLMeagG7MLMeagOl01]h03ooNLMiag_magW7NLMiao`05gP0ComoNgmkog]oNgmko
g]oNgmkOo`04g`03omoO00[O00?oWil01Il04onOgioOomnOgioOWonOgioOWol01Yl01ooOg]oNgol0
1mh03?oNgmkOg_oOg]oNg`;o2=l02?oOWmnOgioo1Yl00ooOg`03g`03oinO00FO01GoWa6O4IlAoaLA
5a4Goa4G4ALA5ol011L00olA4@044@03oaOo00`G0ol0214G4ALA5a4G0_l7G`03oeoo00;o75/10000
:E/01?mKFh4:F`0ComcLg=fEgIGMUMfEgIGMUMfEo`06L@07og7NLMiao`07gP07omoNgmkOo`04gP03
omkN00?N00Sog]oNgmkOo`CN01_ogmkOg]oNgmkOg]oNoioOWmnOgioogioOWol01Yl00onOW`03W`03
oinO00:O00?og]h01]h7g`0>omoNgmkOomoNgmkOg_l8g`08omnOgioOWol6g`03oinO00>O00SoWmnO
gioOo`LA00?o4A400a403OlG4ALA5a7o4ALA5ol01AL2o`0@4ALA5a4G4ALA5a4G4ALA5`?o1aL2o`05
GamO7el00_lOF`40000YF`;o00=KPE/025/00oo/k003k00?LMeagG7MLMeagG7MLMgo00KN00kogW7N
LMkoLMiagW7No`KN01;ogmkOg_oNgmkOg_oNgmkOg_l5g`03omoO00[O00?oWil01Il04onOgioOomnO
gioOWonOgioOWol00il02ooNgmkOg]oNgmko00KN00kog]oNgmkogmkOg]oNo`SO00SogioOWmnOo`JO
00?ogml00ml00onOW`04W`0Foa6O4IlAWa7o5a4G4AOo4ALA5a4Go`@G00?o4Ol00_l54@03oaLG00dG
0ol01Q4G4ALA5`;o00=Oool08E/10000:5/01OmKFe^100QK00?og=`01M`03onEgIGMUMfEgIGMUMfE
o`06L@07og7NLMiao`06gP08omkOg]oNgol4gP03omkN00;N00SogmkOg]oNo`GN01_ogmkOg]oNgmkO
g]oNoioOWmnOgioogioOWol01Yl00onOW`03W`03oioo00_N0_l5g`;o00_NgmkOomoNgmkOgP02o`OO
00SogioOWmnOo`KO00?oWil00il02?nOgioOWmoo1a400olA4@034@04oaLA5`Wo00dAWa6O4IlAWa6O
4IlA00Go00TG4ALA5a4G4AL00ol35`03oaOo02=K0@0002QK00GoFe]KP@08F`03onc/00K/00oogG7M
LMeagG7MLMeagOl01]h03_oNLMiag_magW7NLMko1Mh04ooNgmkOomoNgmkOomoNgmkOg_l01=l00ooO
g`0;g`03oinO00FO013oWmnOgooOWmnOgiooWmnO0ol03mkOg]oNgmkOg]oNgmkOo`06gP05omoNgmh0
0_l01mkOg]oNgol01ml02?oOWmnOgioo1Yl00ooOg`03g`03oinO00BO00co4IlAWa6O4OlG4AL5o`0;
gioOWmoogioOWml00ol=4@Go1aL3obIK0@0002QK00GoFe]KP@09F`03omcL00KL00ooUMfEgIGMUMfE
gIGMUOl01W401omagW7NLOl01]h01ooNgmkOg_l01=h00ooNgP03gP08omoNgmkOg_l4gP0LomkOg]oN
gmkOg]oNgmkoWmnOgioOWooOWmnOo`FO1?lBgP03omoO00CO00kog]oNgmkog]oNgmkOo`OO00SogioO
WmnOo`KO00?oWil00il02?nOgioOWmoo1Q44o`BO00?oWil01Yl2o`BO0ol03a6O4IlAWa6O4IlAWa6O
4@05ob]K0@0002QK00GoFe]KP@0:F`03onc/00K/00oogG7MLMeagG7MLMeagOl01]h03_oNLMiag_ma
gW7NLMko1Mh04_oNgmkOomoNgmkOomoNgmkOo`GO00?ogml02ml00onOW`05W`07oioOWmoog`03o`03
LMia00ON00gOg]oNgmkOg]oNgmkO00;o1Mh03OoOg]oNgooNgmkOg]l00_l6g`;o00JOgioOWol6W`03
omoO00;O00?oWil01Il01?lAWa42o`>O00SogioOWmnOg`;o00OOWmnOgioO00;o00BOgioO0ol=4@03
oe^102aK0@0002QK00GoFe]KP@0;F`03omcL00KL00ooUMfEgIGMUMfEgIGMUOl01W401omagW7NLOl0
1]h01ooNgmkOg_l01=h00ooNgP02gP08omkOg]oNgol5gP0EomkOg]oNgmkOg]oNgmkoWmnOgioO00Oo
3]h2o`cN00?ogml00ml2o`0=gmkOg_oNgmkOg]oNo`07g`07oioOWmnOo`06g`03oinO00:O00_ogioO
WmnOgolAo`07g`;o1il3o`FO0ol4W`?o00XAWa6O4IlAWa7o0U/00h5KF`0ZF`4000000e_oF`04F`04
oe]KF`;o00=Koe/065/01OmKFe^100]K00?ok>`01n`03ooMLMeagG7MLMeagG7Mo`06gP0>omiagW7N
og7NLMiag_l5gP0BomkOg_oNgmkOg_oNgmkOg]oo1=l00ooOg`0<g`04oinOW`;o00=agW401Mh02G7N
LMiagW7No`06gP;o00_NgmkOg]oNgmkOgP02o`GN00kog]oNgooNgmkOg]oNo`OO00OoWmnOgioo00JO
00?ogml00]l00onOW`05W`03oinO00RO0_l029oOWmnOgioO0ol01IoOWmnO00;o00GOWmnOg`03o`DA
00GoFe]KP@0/F`4000000e_oF`04F`05oe]KFol075/01OmKFe^100aK00?og=`01m`03onEgIGMUMfE
gIGMUMfEo`06L@07og7NLMiao`05gP08omoNgmkOg_l3gP03omkN00?N00Sog]oNgmkOo`CN01WogmkO
g]oNgmkOg]oNgmkoWooNLMiagW7o00Aa00?og]h01]h00ooNgP04gP03omkN00[N00?ogml00ml01OoO
g]oN00;o00KOg]oNgmh2o`KO00OoWmnOgioo00KO00?oWil00Yl02_oOWmnOgonOgol:g`;o2Il3o`BO
0ol5W`?o00<Aoe/00e/00h5KF`0ZF`4000000e_oF`04F`05oe]KFol075/01OmKFe^100eK00?ok>`0
1n`03ooMLMeagG7MLMeagG7Mo`06gP0=omiagW7Nog7NLMiao`05gP0BomoNgmkog]oNgmkog]oNgmko
1Ml00ooOg`0<g`0;omiagW7NLMiag_l01=h2o`07gW7NLMiagP02o`CN0_l03=oNgmkOg]oNgmkOo`GN
00oog]oNgmkogmkOg]oNgol01]l01onOgioOWol01Yl00ooOg`02g`05oinOWol01]l00onOW`07W`?o
00WOWmnOgioOWml00ol019oOWml3o`06gioOomoo1E/00h5KF`0ZF`4000000e_oF`04F`05oe]KFol0
75/01OmKFe^100iK00?og=`01m`03onEgIGMUMfEgIGMUMfEo`06L@07og7NLMiao`05gP07omoNgmkO
o`04gP03omkN00?N00Oog]oNgmko00GN01[ogmkOg]oNgmkOg]oNgonEgW7NLMiagW7No`Ea00?og]h0
1]h2o`CN0_l:gP;o1=l03ooOg]oNgooOg]oNgmkOo`06g`07oioOWmnOo`06g`03oinO00:O00cogonO
gioOWmnOgil2o`WO0_l:W`?o0Yl00onOo`02o`QK00>1Fe/0:U/1000000=Kool01Ol3F`03oe]K01YK
00CoFe^145/00oo/k007k00?omeagG7MLMeagG7MLMgo00KN00gogW7NLMkoLMiagW7o00GN01;ogmkO
g_oNgmkOomoNgmkOg_l4g`03omoO00[O00ooUIFEog7NLMiagW7NLOl01=h2o`09LMiagW7NLMko00GN
0_l02moNgmkOg]oNgmko00CN0_l03MoNgmkogmkOg]oNgol01]l01onOgioOWol01Il7o`cO0ol8W`;o
00_OWmnOgioOWmnOg`02o`eK00>1Fe/0:U/1000000=Koe/015/01OmKFe_o01aK00CoFe^145/00ooL
g008g00?oiGMUMfEgIGMUMfEgIGo00Ia00OoLMiagW7o00GN00OogmkOg]oo00?N00?og]h00mh02?oO
g]oNgmko1=h03OoNgmkOg]oNgmkOg_l01ID02_oNLMiagW7NLOl5L@03omkN00KN0_l5gP03omkN00SN
00?ogml00ml03OoNgmkOomoNgmkOg]l00_l5g`08oioOWmnOoml3o`04g]oNo`CO00kogioOWmnOgioO
WmnOg`;o2=l2o`NO00?oFe/03e/00h5KF`0YF`4000000e_oF`04F`03oe]K00?o6e/01?mKFh4AF`03
onc/00S/00oogG7MLMeagG7MLMeagOl01]h03OoNLMiag_magW7NLOl01Mh04OoOg]oogmkOg]oogmkO
g]oo00GO00?ogml02=l00onEU@05U@08og7NLMiagW42o`CN0_l02=iagW7NLMia0_l4gP;o00WNgmkO
g]oNgmh00_l4gP05omoNgmh00_l02=kOg]oNgmko1Ml01?nOgil3o`08gmkOg]oNgmh2o`04g]oNg`?o
2]l3o`NO0_l01MnOgioo019K00>1Fe/0:E/1000000=Koe/025/00omKF`0JF`04oe]KPA9K00?og=`0
2=`03onEgIGMUMfEgIGMUMfEo`06L@06og7NLMko1]h01ooOg]oNgol00mh00ooNgP03gP07omoNgmkO
o`05gP0:omkOg]oNgmkOo`VE0_l02=iagW7NLMko1G42o`SN0_l4gP;o2Mh00ooOg`02g`0?omkOg]oN
omkOg]oNgmko00?O1Ol03MkOg]oogmkOg]oNgmh00_l5g`?o00[OWmnOgioOWmnO0_l7g`;o00>Ooe/0
4U/00h5KF`0YF`4000000e_oo`05o`=K00?oFe/06U/01?mKFh4CF`03onc/00S/00oogG7MLMeagG7M
LMeagOl01]h03?oNLMiaomiagW7No`GN01;og]oNgooOg]oNgooOg]oNgol4g`03omoO00KO00?oUID0
2ID02?oNLMiagW7N0_l5gP0;og7NLMiagW7NLOl01Mh2o`09g]oNgmkOg]oo00CN0_l02mkOg]oog]oN
gmkO00Co1=l00ooNgP05gP08omkOg]oNgmh2o`06g]oNgmkO0ol9g`;o1il00omKF`0BF`03PE]K02UK
0@0002QK0_l00e^1F`0BF`03omcL00WL00ooUMfEgIGMUMfEgIGMUOl01W401_magW7No`GN00Oog]oN
gmko00CN00?og]h00]h02?oNgmkOg]oo1=h02?oOg]oNgmko3ID2o`08LMiagW7NLOl5L@;o2=h2o`GN
00?og]h01]h2o`CO00WogmkOg_oNgmh00_l00mkOgP07gP;o00kOg]oNgmkOomoNgmkOgP?o1]l3o`08
gioOWmnOgil3o`03gooo01IK00>1Fe/0:E/10000:5/01?mKFh4DF`03onc/00W/00oogG7MLMeagG7M
LMeagOl01]h03?oNLMiaomiagW7No`GN017og]oNomkOg]oNomkOg]oNo`05g`03omoO00?O00?oUID0
3ID02?magW7NLMia0_l5gP0:omiagW7NLMiagP;o1=h2o`09gmkOg]oNgmko00CN013og]oNgooNomoN
gmkOg]oo1]l3o`KN0_l01]kOg]oNg`;o00OOg]oNgmkO00?o2=l00omKF`0FF`03PE]K02UK0@0002MK
00GoFe]KP@0EF`03omcL00WL00ooUMfEgIGMUMfEgIGMUOl01W401_magW7No`GN00Oog]oNgmko00?N
00?og]h00mh01ooNgmkOg_l01Mh01_oOg]oNoa2E0_l02=iagW7NLMko1G42o`WN0_l4gP;o1mh00ooO
g`02g`03omoN00?o00[Og]oNgmkOg]oN0_l6gP;o00ONgmkOg]oN00;o00GOg]oNg`02o`SO0ol01=oo
oolJF`03PE]K02UK0@0002MK00GoFe]KP@0FF`03onc/00W/0_l03G7MLMeagG7MLMeagOl01]h03?oN
LMiaomiagW7No`GN017og]oNomkOg]oNomkOg]oNo`04g`05omoOgol04iD2o`06LMiagW7N0_l5gP;o
00WNLMiagW7NLMh00_l4gP07omkOg]oNg`08o`0?gmkOg_oNgmkOg]oNgmkO00;o1]l2o`SN0_l01=kO
g]l2o`0:gmkOg]oNgmkOoaeK00>1Fe/0:E/100009e/01OmKFe^101MK00?og=`02]`03_oMUMfEgIGM
UMfEgIGo1W401_magW7No`GN00Oog]oNgmko00?N00?og]h00mh01ooNgmkOg_l01=h01?oNgolEU@09
og7NLMiagW7o00Ia00?og]h02=h00ooNgP02gP;o00SNoooogW7No`CN00?og]h01=h02_oNgmkOg]oN
gmh2o`KN0_l02=kOg]oNgmkO0ol00moNg`02o`CO0_lOF`03PE]K02UK0@0002MK00GoFe]KP@0GF`03
onc/00_/00koLMeagG7MLMeagG7Mo`KN00_ogW7NLOoNLMiao`05gP0AomoNgmkog]oNgooOg]oNgol0
1Ml00ooOo`0FU@;o00KNLMiagW42o`GN0_l02G7NLMiagW7NL@02o`;N0ol02=iagW7NLMia0_l4gP06
omoNgmkO0_l02=kOg]oNgmkO0ol5g`;o2Mh3o`06g]ooomoo8E/00h5KF`0YF`40000WF`05oe]KFh40
65/00ooLg00;g00>omfEgIGMUMfEgIGMUOl6L@06og7NLMko1=h01ooOg]oNgol00mh00ooNgP03gP07
omoNgmkOo`04gP;o6ID02OoNLMiagW7No`06L@03omkN00ON0ol4gP09og7NLMiagW7N00?o1=h00ooN
gP03gP;o00SNgmkOg]oNg`;o1Mh3o`09gmkOg]oNgmkO00?o00?Ooe/08E/00h5KF`0YF`40000WF`05
oe]KFh406E/00oo/k00;k00>og7MLMeagG7MLMeagOl6gP0;omiagW7ogW7NLOl01Mh04_oOg]oogmkO
g]oogmkOg]oog`;o00CLk=co69D2o`07LMiagW7No`06gP;o00ONLMiagW7o00?N013oLMiagW7Nog7N
LMiagW7N0_l5gP05omoNgmh00ol01mkOg]oNgmh00_l6g`;o1=h2obQK00>1Fe/0:E/100009e/01OmK
Fe^101YK00?og=`02m`03_oMUMfEgIGMUMfEgIGo1W401_magW7No`CN00OogmkOg]oo00?N00?og]h0
0mh01?oOg]l3o`OL0_lGU@07og7NLMiagP02o`Ia0_l3gP09og7NLMiagW7o00GN0_l01g7NLMiagW40
0_l6gP;o0mh2o`07gmkOg]oNg`02o`KN0_l00mooF`0YF`03PE]K02UK0@0002MK00GoFe]KP@0JF`03
onc/00c/00koLMeagG7MLMeagG7Mo`KN00_ogW7NLOoNLMiao`05gP08omoNgooOg]l5o`03g>cL00;/
00OLk=c/g>cL00;o5YD2o`07gW7NLMiao`07gP03og7o00_N00GoLMiagP03o`06LMiagW7N0_l6gP?o
00?Ngol00_l01]oNgmkOgP;o1Ml2ob]K00>1Fe/0:E/100009e/01OmKFe^101]K00?og=`03=`03_oM
UMfEgIGMUMfEgIGo1W401_magW7No`CN00CogmkO2Ol02kOL]mc/g>cLk=c/00SL0_lFU@;o00EagW7N
L@02o`Ea0_l03W7NLMiagW7NLMiagW7N0_l4gP;o00KNLMiagW42o`ON0ol2gP;o00KNgmkOg]l2o`03
g_oo02eK00>1Fe/0:E/100009e/01?mKFh4MF`03onc/00c/00koLMeagG7MLMeagG7Mo`KN00?ogW40
2_l01;Nf]kH4k00F]nbgk;O/]ooLk=c/g>cLoncLk=c/g0;o5YD02OmagW7NLMkogP03o`05LMiag_l0
3]h2o`03LMia00;o00IagW7NLMh2o`SN0ol03=kooooNgmkog_mKPBeK00>1Fe/0:E/100009e/01?mK
Fh4NF`03omcL00cL00kogIGMUMfEgIGMUMfEo`Ea0ol04<c0c<2g][Nf]kJg][Nf]ol4k007okOL]mbg
g002o`07k=c/g>cLo`06g0;o5ID2o`04gW7NL@;o2g42o`0;LMiagW7NLMiagW400ol2gP?o00EagW7N
L@03o`SN0ol01=koool4F`03PE]K02]K00>1Fe/0:E/100009e/01?mKFh4OF`03onc/00c/00ooLMea
gG7MLMeagG7Momh00ol024co3L`=c0g<1KH01kNf]kJg]_l01N`01oo/]nbgk;L00_l03NcLk=c/g>co
g>cLk=`00_lEU@08omkoog7NLMh2L@0;gW7NLMiagW7NLMh00ol9gP?o00Yag_oogW7NLMia0_l4gP03
oe]K00YK00>1Fe/0:e/00h5KF`0YF`40000WF`04oe]KPAmK00?og=`03M`09_oMUMfEgIGMUMfEgIGo
C4e<CDcoc<3<`<c0]kJg][Oo]kJg][Oo1^`2o`05g;OL]m`00_l01ncLk=c/g>`00_l4g0?o4iD00oma
L@0:L@;o2G43o`08gW7NLMiagW42o`;N0_l01W7NLMiagP;o00?Noe/035/00h5KF`0[F`03PE]K02UK
0@0002MK00CoFe^185/00oo/k00=k00=og7MLMeagG7MLMeao`05C009ol`=c0g<3Lco00Bf00Ko][Nf
]kH2o`K/00Ook;O/]nbg00;o00O/g>cLk=c/00;o00G/g>cLk002oa6E00CogG7M0_l03MiagW7NLMia
gW7NLMh00_l01]iagW7NL@Co1]h3o`0:g_ooog7NLOmao`iK00>1Fe/0:e/00h5KF`0YF`40000WF`;o
00=KPE/085/00ooLg00=g00WomfEgIGMUMfEgOm=C4e<CDcoc<3<`<c0c<3o][Nf]ong][Nf]kKo00K/
0_l01[OL]mbgg0;o00S/g>cLk=c/g0;o1=`2o`jE00cogG7MLMeagG7MLMd6o`Ma0ol4L@Co00GNLMia
gP07oa5K00>1Fe/0;5/00h5KF`0XF`40000VF`05oe]KFh408U/00oo/k00=k00;og7MLMeagG7Modd0
1T`02_l=c0g<3L`=c0d4]P;o00Jg][Nf]ol7k0;o00K/]nbgk;L3o`07g>cLk=c/g002o`04g>cLk0;o
2iD05?oMLMeagG7MLMeagG7MLMeagG7M1ol0177NLMh5o`04LOoooaYK00>1Fe/0;5/00h5KF`0XF`40
000VF`05oe]KFh408U/00ooLg00>g00WomfEgIGMUOm<COm=C4e<COo0c<3<`<c0c<3<okNf]kKo][Nf
]kKo00S/0_l01kOL]mbgg;L00_l01mc/g>cLk=`00ol3g0;o2ID06omagG7MLMeagG7MLMeagG7MLMea
gG7MLMeag@04ob=K00>1Fe/0;5/00h5KF`0XF`40000VF`05oe]KFh408e/00oo/k00>k007og7MLMea
o`03C@E<00go3L`=c0g<3L`=c0go00Bf00Ko]kJg][L2o`S/0_l01nbgk;O/]n`00_l02=c/g>cLk=c/
0_l00ncLk002o`JE01[oLMeagG7MLMeagG7MLMeagG7MLMeagG7MLBUK00>1Fe/0;5/00h5KF`0XF`40
000VF`05oe]KFh4095/00ooLg00>g00XomfEgIGoC4e<CDa=C4e<olc0c<3<`<c0c<3<okNf]kKo][Nf
]kJgo`W/0_l01kOL]mbgg;L00_l02=c/g>cLk=c/0_l3g0;o19D04_oMLMeagG7MLMeagG7MLMeag@Go
00>1Fe/0:E/00h5KF`0/F`03PE]K02QK0@0002IK00GoFe]KP@0UF`03onc/00k/00CoLMgo1Dd5C00=
ol`=c0g<3L`=c0g<3@02o`>f00So]kJg][Nfo`[/0_l01nbgk;O/]n`00_l02=c/g>cLk=c/0ol04=c/
oonEomeagG7MLMeagG45o`06UMbEg9Go0U/00h5KF`0YF`03PE]K02aK00>1Fe/0:5/100009U/01OmK
Fe^102EK00?og=`03m`0:?oMode<CDa=C4e<CDcoc<3<`<c0c<3<`<c0c<3o][NfokJg][Nf]ol;k0;o
00Ngg;OL]mbg00;o00SLk=c/g>cLk0Ko00?MLMd04ID01OmKFe^102]K00>1Fe/0;5/00h5KF`0XF`40
000VF`05oe]KFh409U/00oo/k00?k003ode=00A=00?oC4`00d`04?l=c0g<3L`=c0g<3L`=c?l3]P;o
00Jf]kJg]_l<k0;o00O/]nbgk;O/00;o00CLk=c/0_l04YGLUMbEg9GLUMbEg9GLUMbEg0So15/00h5K
F`0YF`03PE]K02aK00>1Fe/0:5/100009U/01OmKFe^102MK00?og=`03]`0:?m<CDa=C4e<CDa=C4go
`<c0c<3<`<c0c<3<`<c0okJg][Oo]kJg][L2o`c/00Wog;OL]mbgg;L00_l00mcoU@07U@co00CLUMbE
25/00h5KF`0YF`03PE]K02aK00>1Fe/0:5/100009U/01OmKFe^102QK00?ok>`03N`00om=C@05C@03
oda<00=<013oc0g<3L`=c0g<3L`=c0g<0_l3]P08okJg][Nf]ol<k0;o00Ngk;O/]nbg00;o00?LUOl0
0ol04MbEg9GLUMbEg9GLUMc/g>co00YK00>1Fe/0:E/00h5KF`0/F`03PE]K02QK0@0002IK00GoFe]K
P@0YF`03omcL00_L02goCDa=C4e<CDcoC4e<CDcoc<3<`<c0c<3<`<c0c<3<`<co]kJgokNf]kJg]_l0
3N`2o`0Bg;OL]onEg9GLUMbEg9GLUMbE2n`00omKF`09F`03PE]K02QK00>1Fe/0;5/00h5KF`0XF`40
000VF`04oe]KPBYK00?ok>`02n`00omVIP07C@E<01Coc0g<3L`=c0g<3L`=c0g<3L`=o`>f00So][Nf
]kJgo`k/0_l07;OoUMbEg9GLUMc/g>cLk=c/g>cLk=c/g>cLk?l;F`03PE]K02QK00>1Fe/0;5/00h5K
F`0XF`40000VF`04oe]KPB]K00?og=`02]`09om=CDe<CDa=C4goCDa=C4go`<c0c<3<`<c0c<3<`<c0
c<3<okNf]`02o`06][Nf]kKo3n`00onEg00Gk003oe]K00YK00>1Fe/0:5/00h5KF`0/F`03PE]K02QK
0@0002IK00CoFe^1;5/00oo/k008k005ofIVI_l01dd5C00Eo`g<3L`=c0g<3L`=c0g<3L`=c0go00Bf
00Ko]kJg][L2o`g/01_og>cLk=c/g>cLk=c/g>cLk=c/g>cLk=c/g?l035/00h5KF`0XF`03PE]K02aK
00>1Fe/0:5/100009U/01?mKFh4/F`03POoL00SL00?oCDd00Td08Da=C4e<CDcoC4e<COo0c<3<`<c0
c<3<`<c0c<3<`<c0c002o`0;][NfokJg][Nf]ol02n`00oo/k00Gk003oe]K00]K00>1Fe/0:5/00h5K
F`0/F`03PE]K02QK0@00011K00?oFe/00U/4o`9K1?l6F`>100=KPE/0:e/00h7ok008k003ofIV009V
00?oCDd014d00om<C003C00Gol`=c0g<3L`=c0g<3L`=c0g<3L`=c?l00kH02?ng][Nf]kKo2^`06oo/
g>cLk=c/g>cLk=c/g>cLk=c/g>cLk=c/o`0=F`03PE]K02QK00>1Fe/0;5/00h5KF`0XF`40000@F`05
oe]KFol015/2o`AK00?oFe/00e/00omKF`04PBYK00>1Fol01m`00om=C@05C@0^C4e<CDa=ode<CDco
c<3<`<c0c<3<`<c0c<3<`<c0c<3<`?nf]kKo][Nf]kJgo`W/00?ok>`05n`00omKF`0;F`03PE]K02QK
00>1Fe/0;5/00h5KF`0XF`40000@F`05oe]KFol015/2o`AK00?oFe/00e/01OmKFe^1009K184VF`04
PE]Ko`K/00?oIVH016H00om=C@04C@03oda<00=<01So3L`=c0g<3L`=c0g<3L`=c0g<3L`=c?l3]P07
okNf]kJg]P02o`K/01Oog>cLk=c/g>cLk=c/g>cLk=c/g>cLk004o`iK00>1Fe/0:5/00h5KF`0/F`03
PE]K02QK0@00011K00GoFe]Ko`04F`;o15/00omKF`03F`05oe]KFh401U/4PB9K00F1Fe]Ko`05g003
ode=00E=02Q<CDa=C4e<CDa=C4go`<c0c<3<`<c0c<3<`<c0c<3<`<c0c<3o][Nf0_l01kNf]kJg]_l0
1N`00oo/k00?k0Go0kH00omKF`0<F`03PE]K02QK00>1Fe/0;5/00h5KF`0XF`40000@F`05oe]KFol0
15/2o`AK00?oFe/00e/01OmKFe^100YK184NF`03PE]K009K00Gok>c/o`08IP03ode=00A=00?oC4`0
0T`06Ol=c0g<3L`=c0g<3L`=c0g<3L`=c0g<3L`00_l3]P08okJg][Nf]ol3k00=oncLk=c/g>cLk=c/
g006o`Nf00?oFe/03E/00h5KF`0XF`03PE]K02aK00>1Fe/0:5/1000045/01OmKFe_o00AK0_l4F`03
oe]K00=K00GoFe]KP@0>F`B16U/00h5KF`02F`05omcLg?l024d0<om=C4e<CDcoC4e<CDcoc<3<`<c0
c<3<`<c0c<3<`<c0c<3<`<c0c?ng][Oo]kJg][Nfo`02k003onc/00C/1_l=]P03oe]K00eK00>1Fe/0
:5/00h5KF`0/F`03PE]K02QK0@0000iK0ol3F`03oe]K009K0_l4F`03oe]K00=K00GoFe]KP@0BF`B1
5U/00h5KF`03F`04onc/o`UV1dd00om<C002C00Lol`=c0g<3L`=c0g<3L`=c0g<3L`=c0g<3L`=o`>f
00_o][Nf]kJgoncok005oa:f00?oFe/03U/00h5KF`0XF`03PE]K02eK00>1Fe/09e/1000045/01OmK
Fe_o00AK0_l4F`03oe]K00=K00GoFe]KP@0FF`F14E/00h5KF`04F`;o2Td0<_m<CDa=C4goCDa=C?o<
`<c0c<3<`<c0c<3<`<c0c<3<`<c0c<3<`<co]kJgokNf]kJg1?lF]P03oe]K00mK00>1Fe/0:5/00h5K
F`0]F`03PE]K02MK0@00011K00?oFe/00U/4o`9K1?l6F`05oe]KFh406e/4P@eK00>1Fe/01E/00omV
IP09IPI=00?oC4`00d`07Ol=c0g<3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0go00>f00?o]_l00_lJ]P03
oe]K00mK00>1Fe/0:5/00h5KF`0]F`03PE]K02MK0@0002EK00GoFe]KP@0OF`B12E/00h5KF`05F`a=
02WoCDa=C4e<oda=C4go`<c0c<3<`<c0c<3<`<c0c<3<`<c0c<3<`<c0c005o`03]_oo01[o4U/00h5K
F`0XF`03PE]K02eK00>1Fe/09e/100009E/01OmKFe^102=K1845F`03PE]K00IK36H6C@03oda<009<
01ko3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0g<3L`=c?lLaP03oe]K01AK00>1Fe/0:5/00h5KF`0]F`03
PE]K02MK0@0002EK00GoFe]KP@0WF`B100=KPE/01e/00om=C@09C@15oda=C4e<COm=C4e<olc0c<3<
`<c0c<3<`<c0c<3<`<c0c<3<`<c0c?o6`<K0a/36`<K0a/36`<K0a/36`<K0a/36`<K001MK00>1Fe/0
:5/00h5KF`0]F`03PE]K02MK0@0002EK00CoFe^1;5/4P@MK2fH00om=C@04C@03oda<009<01goc0g<
3L`=c0g<3L`=c0g<3L`=c0g<3L`=c0g<o`0KaP03oe]K01EK00>1Fe/0:E/00h5KF`0/F`03PE]K02MK
0@0002EK00CoFe^1;E/00h5KF`04P@=K00?oCDd02Dd0@om=C4e<COm=C4e<COo0c<3<`<c0c<3<`<c0
c<3<`<c0c<3<`<c0c?o6`<K0a/36`<K0a/36`<K0a/36`<K0a/36`<H065/00h5KF`0YF`03PE]K02aK
00>1Fe/09e/100009E/01?mKFh4/F`03PE]K00EK184;IP03ode=00A=00?oC4`00T`07?l=c0g<3L`=
c0g<3L`=c0g<3L`=c0g<3L`=c?lJaP03oe]K01IK00>1Fe/0:E/00h5KF`0/F`03PE]K02MK0@0002EK
00CoFe^1;5/00h5KF`09F`03ode=00U=04;oC4e<CDcoC4e<COo0c<3<`<c0c<3<`<c0c<3<`<c0c<3<
`<c0ol36`<K0a/36`<K0a/36`<K0a/36`<K0a/36`?lHF`03PE]K02UK00>1Fe/0;5/00h5KF`0WF`40
000TF`?o00=KPE/0:e/00h5KF`0:F`03ofIV00QV00?oCDd014d00om<C002C00Jol`=c0g<3L`=c0g<
3L`=c0g<3L`=c0g<3OlJaP03oe]K01MK00>1Fe/0:E/00h5KF`0/F`03PE]K01EK1h4;F`40000TF`05
oe]KFh40;5/00h5KF`0;F`]=043oCDa=C4goCDa=C?o<`<c0c<3<`<c0c<3<`<c0c<3<`<c0c<3o`<K0
a/36`<K0a/36`<K0a/36`<K0a/36`<Ko6E/00h5KF`0YF`03PE]K02aK00>1Fe/025/=PA9K0@0002AK
00GoFe]KP@0/F`03PE]K00]K00?oIVH026H00om=C@03C@03oda<009<01[oc0g<3L`=c0g<3L`=c0g<
3L`=c0g<3L`=oaW600?oFe/065/00h5KF`0YF`03PE]K02YK3H4OF`40000TF`05oe]KFh40;5/00h5K
F`0<F`03ode=00M=03ooCDa=C4e<oda=C4go`<c0c<3<`<c0c<3<`<c0c<3<`<c0c<3o`<K0a/36`<K0
a/36`<K0a/36`<K0a/36`?l06U/00h5KF`0YF`03PE]K01iK3842F`03PE]K02MK0@0002AK00GoFe]K
P@0/F`03PE]K00aK00?oIVH026H00om=C@03C@03oda<009<01Wo3L`=c0g<3L`=c0g<3L`=c0g<3L`=
c0go01S60_lJF`03PE]K02UK00>1Fe/04E/=P@iK00>1Fe/09e/1000095/01OmKFe^102aK00>1Fe/0
3E/00om=C@07C@0loda=C4e<oda=C4go`<c0c<3<`<c0c<3<`<c0c<3<`<c0c<3o`<K0a/36`<K0a/36
`<K0a/36`<K0a/360_lJF`03PE]K02UK00>1Fe/015/=PA]K00>1Fe/09e/1000095/01OmKFe^102aK
00>1Fe/03E/00omVIP08IP03ode=00==00?oC4`00T`06?o<3L`=c0g<3L`=c0g<3L`=c0g<3L`=oaO6
00?oCol06U/00h5KF`0SF`f1:5/00h5KF`0WF`40000TF`05oe]KFh40;5/00h5KF`0>F`03ode=00M=
03[oCDa=C4goCDa=C?o<`<c0c<3<`<c0c<3<`<c0c<3<`<c0ol36`<K0a/36`<K0a/36`<K0a/36`<Ko
0Sl00omKF`0HF`03PE]K01MK3846F`03PE]K02aK00>1Fe/09e/1000095/01OmKFe^102aK00>1Fe/0
3U/00omVIP08IP03ode=00==00?oC4`00T`05ol=c0g<3L`=c0g<3L`=c0g<3L`=c0go01K600Co?doo
6U/00h5KF`0:F`f14U/00h5KF`0/F`03PE]K02MK0@0002AK00GoFe]KP@0/F`03PE]K00mK00?oCDd0
1dd0>?m<CDa=C?m<CDa=ol3<`<c0c<3<`<c0c<3<`<c0c<3<olK0a/36`<K0a/36`<K0a/36`<K0a/3o
0cl00omKF`0HF`f17e/00h5KF`0/F`03PE]K02MK0@0002AK00GoFe]KP@0/F`03PE]K00mK00?oIVH0
1fH00om=C@03C@03oda<009<01Ko3L`=c0g<3L`=c0g<3L`=c0g<3Lco5/H01?m??ol?F`f1:e/00h5K
F`0]F`03PE]K02IK0@0002AK00GoFe]KP@0/F`03PE]K011K00?oCDd01dd0=_m=C4e<COm=C4e<olc0
c<3<`<c0c<3<`<c0c<3<`<coa/36`<K0a/36`<K0a/36`<K0a/36o`<o00?oFe/03H4<F`03PE]K02UK
00>1Fe/0;E/00h5KF`0VF`40000TF`05oe]KFh40;5/00h5KF`0@F`03ofIV00MV00?oCDd00dd00om<
C002C00Eol`=c0g<3L`=c0g<3L`=c0g<3Lco01C600KoCcm??ol2PAUK00>1Fe/0:E/00h5KF`0]F`03
PE]K02IK0@0002AK00CoFe^1;E/00h5KF`0AF`03ode=00M=03CoC4e<CDcoC4e<olc0c<3<`<c0c<3<
`<c0c<3<`<coa/36`<K0a/36`<K0a/36`<K0a/3o13l00omKF`0IF`03PE]K02UK00>1Fe/0;E/00h5K
F`0VF`40000TF`04oe]KPBeK00>1Fe/04E/00omVIP07IP03ode=00==00?oC4`00T`05?l=c0g<3L`=
c0g<3L`=c0g<3Lco4lH01oloCcm??ol06e/00h5KF`0YF`03PE]K02eK00>1Fe/09U/100008e/01OmK
Fe^102eK00>1Fe/04U/00om=C@07C@0bode<CDcoC4e<COo0c<3<`<c0c<3<`<c0c<3<`<coa/36`<K0
a/36`<K0a/36`<K0a_l5?`03oe]K01UK00>1Fe/0:E/00h5KF`0]F`03PE]K02IK0@0002=K0ol00e^1
F`0/F`03PE]K019K00?oIVH01fH00om=C@03C@03oda<009<01?oc0g<3L`=c0g<3L`=c0g<3Lco01;6
00SoCcm??dlooa]K00>1Fe/0:E/00h5KF`0]F`03PE]K02IK0@0002=K00GoFe]KP@0]F`03PE]K01=K
00?oCDd01Td0<Om=C4e<COm=C4e<olc0c<3<`<c0c<3<`<c0c<3<olK0a/36`<K0a/36`<K0a/36`?l0
1Sl00omKF`0IF`03PE]K02UK00>1Fe/0;E/00h5KF`0VF`40000SF`05oe]KFh40;E/00h5KF`0DF`03
ofIV00IV00?oCDd00dd05om<C4coc0g<3L`=c0g<3L`=c0g<3Lco017600Wo?dloCcm??ol06e/00h5K
F`0YF`03PE]K02eK00>1Fe/09U/100008e/01OmKFe^102eK00>1Fe/055/00om=C@06C@0^oda=C4e<
oda=C4go`<c0c<3<`<c0c<3<`<c0c?o6`<K0a/36`<K0a/36`<K0o`Po00?oFe/06E/00h5KF`0YF`03
PE]K02eK00>1Fe/09U/100008e/01OmKFe^102eK00>1Fe/05E/00omVIP06IP03ode=009=00?oC4`0
0T`04Ol=c0g<3L`=c0g<3L`=c0go017600[oCcm??dloCcoo6e/00h5KF`0YF`03PE]K02eK00>1Fe/0
9U/100008e/01OmKFe^102eK00>1Fe/05E/00om=C@06C@0/ode<CDa=ode<COo0c<3<`<c0c<3<`<c0
c<3o`<K0a/36`<K0a/36`<K0a_l9?`03oe]K01UK00>1Fe/0:E/00h5KF`0]F`03PE]K02IK0@0002=K
00GoFe]KP@0/F`03PE]K01MK00?oIVH01VH00om=C@02C@03oda<009<013oc0g<3L`=c0g<3L`=c0go
4<H02oloCcm??dloCcoo01]K00>1Fe/0:E/00h5KF`0]F`03PE]K02IK0@0002=K00GoFe]KP@0/F`03
PE]K01MK00?oCDd01Td0:_m<CDa=ode<CDcoc<3<`<c0c<3<`<c0c<3o`<K0a/36`<K0a/36`<K0o`Xo
00?oFe/06E/00h5KF`0YF`03PE]K02eK00>1Fe/09U/100008e/01OmKFe^102aK00>1Fe/065/00omV
IP05IP03ode=00==01CoC4a<ol`=c0g<3L`=c0g<3L`=o`k600co?dloCcm??dloColLF`03PE]K02UK
00>1Fe/0;E/00h5KF`0VF`40000SF`05oe]KFh40;5/00h5KF`0HF`03ode=00I=02SoCDa=C?m<CDa=
ol3<`<c0c<3<`<c0c<3o`<K0a/36`<K0a/36`<Ko2Sl00omKF`0JF`03PE]K02UK00>1Fe/0;E/00h5K
F`0VF`40000SF`05oe]KFh40;5/00h5KF`0IF`03ofIV00EV00?oCDd00dd04om<C4co3L`=c0g<3L`=
c0g<3Ol03LH03Om??dloCcm??dloCol075/00h5KF`0YF`03PE]K02eK00>1Fe/09U/100008e/01OmK
Fe^102aK00>1Fe/06E/00om=C@06C@0Voda=C4goCDa=C?o<`<c0c<3<`<c0c<3o`<K0a/36`<K0a/36
`?l;?`03oe]K01YK00>1Fe/0:E/00h5KF`0]F`03PE]K02IK0@0002=K00GoFe]KP@0/F`03PE]K01YK
00?oIVH01FH00om=C@02C@03oda<009<00koc0g<3L`=c0g<3L`=o`c600ko?dloCcm??dloCcm?oaaK
00>1Fe/0:E/00h5KF`0]F`03PE]K02IK0@0002=K00CoFe^1;E/00h5KF`0JF`03ode=00I=02?oCDa=
C?m<CDcoc<3<`<c0c<3<`<c0ol36`<K0a/36`<K0aP0=?`03oe]K01YK00>1Fe/0:E/00h5KF`0]F`03
PE]K02IK0@00029K00GoFe]KP@0]F`03PE]K01]K00?oIVH01FH00om=C@02C@03oda<009<00co3L`=
c0g<3L`=c?l<aP0?odloCcm??dloCcm??doo01aK00>1Fe/0:E/00h5KF`0^F`03PE]K02EK0@00029K
00GoFe]KP@0]F`03PE]K01]K00?oCDd01Dd08_m=C4e<COm=C4go`<c0c<3<`<c0c?o6`<K0a/36`<K0
a_l>?`03oe]K01YK00>1Fe/0:E/00h5KF`0^F`03PE]K02EK0@00029K00GoFe]KP@0]F`03PE]K01aK
00?oIVH01FH00om=C@02C@0@oda<C?l=c0g<3L`=c0g<o`_6013o?dloCcm??dloCcm??doo75/00h5K
F`0YF`03PE]K02iK00>1Fe/09E/100008U/2o`9K00>1Fe/0:e/00h5KF`0MF`03ode=00A=023oC4e<
COm=C4e<olc0c<3<`<c0c?o6`<K0a/36`<K0o`lo00?oFe/06U/00h5KF`0YF`03PE]K02iK00>1Fe/0
9E/100008U/01OmKFe^102eK00>1Fe/07E/00omVIP05IP03ode=009=00ooC4a<ol`=c0g<3L`=c?l0
2/H04Om??dloCcm??dloCcm??doo01aK00>1Fe/0:E/00h5KF`0^F`03PE]K02EK0@00029K00GoFe]K
P@0]F`03PE]K01iK00?oCDd014d07_m=C4e<oda=C?o<`<c0c<3<`<coa/36`<K0a/36oa0o00?oFe/0
6U/00h5KF`0YF`03PE]K02iK00>1Fe/09E/100008U/01OmKFe^102eK00>1Fe/07U/00omVIP05IP05
ode=COl014`02_l=c0g<3L`=c?l9aP0BCcm??dloCcm??dloCcm??doo75/00h5KF`0YF`03PE]K02iK
00>1Fe/09E/100008U/01OmKFe^102eK00>1Fe/07e/00om=C@04C@0Loda=C4goCDa=ol3<`<c0c<3<
olK0a/36`<K0oa4o00?oFe/06U/00h5KF`0YF`03PE]K02iK00>1Fe/09E/100008U/01OmKFe^102eK
00>1Fe/07e/00omVIP04IP03ode=009=00?oC4`00T`02Oo<3L`=c0g<o`07aP0Docm??dloCcm??dlo
Ccm??dloColLF`03PE]K02UK00>1Fe/0;U/00h5KF`0UF`40000RF`05oe]KFh40;E/00h5KF`0PF`03
ode=00A=01[oCDa=C?m<CDcoc<3<`<c0c?o6`<K0a/36oa4o00?oFe/06e/00h5KF`0YF`03PE]K02iK
00>1Fe/09E/100008U/01OmKFe^102eK00>1Fe/085/00omVIP04IP03ode=009=00coC4a<ol`=c0g<
3Ol7aP0DodloCcm??dloCcm??dloCcm??olMF`03PE]K02YK00>1Fe/0;E/00h5KF`0UF`40000RF`05
oe]KFh40;E/00h5KF`0QF`03ode=00A=01OoC4e<oda=C4go`<c0c<3o`<K0a/36`00C?`03oe]K01]K
00>1Fe/0:U/00h5KF`0]F`03PE]K02EK0@00029K00GoFe]KP@0]F`03PE]K025K00?oIVH016H00om=
C@02C@0;oda<C?l=c0g<3Ol01/H05OloCcm??dloCcm??dloCcm??dloo`0MF`03PE]K02YK00>1Fe/0
;E/00h5KF`0UF`40000RF`05oe]KFh40;E/00h5KF`0QF`03POm=00E=01GoCDa=ode<COo0c<3<`?o0
a/36`<H053l00omKF`0KF`03PE]K02YK00>1Fe/0;E/00h5KF`0UF`40000RF`05oe]KFh40;E/00h5K
F`0QF`03POmV00EV00?oCDd00Td02_m<C4coc0g<3Ol5aP0FodloCcm??dloCcm??dloCcm??dlooaeK
00>1Fe/0:U/00h5KF`0]F`03PE]K02EK0@00025K00GoFe]KP@0^F`03PE]K025K00>1Fol01Dd05?m=
C4e<oda=C?o<`<c0ol36`<Ko5Cl00omKF`0KF`03PE]K02YK00>1Fe/0;E/00h5KF`0UF`40000QF`05
oe]KFh40;E/00h5KF`0RF`03PE_o00IV00GoCDe=o`04C005o`g<3Ol01<H05oloCcm??dloCcm??dlo
Ccm??dloCcoo01eK00>1Fe/0:U/00h5KF`0]F`03PE]K02EK0@00025K00GoFe]KP@0]F`03PE]K029K
00B1Fe_o1Dd04_m<CDa=ode<COo0c<3o`<K0oaHo00?oFe/06e/00h5KF`0ZF`03PE]K02eK00>1Fe/0
9E/100008E/01OmKFe^102eK00>1Fe/08U/0185KFol6IP05ode=COl00d`01Ol=c0go00?601PoCcm?
?dloCcm??dloCcm??dloCcm??olMF`03PE]K02YK00>1Fe/0;E/00h5KF`0UF`40000QF`;o0U/00h5K
F`0[F`03PE]K029K00F1Fe]Ko`05C@0@ode<COm=C4e<olc0ol36oaLo00?oFe/06e/00h5KF`0ZF`03
PE]K02eK00>1Fe/09E/100008E/01OmKFe^102eK00>1Fe/08U/00h5KF`02F`03ofIV00=V00GoCDe=
o`03C004ol`=o`;601U??dloCcm??dloCcm??dloCcm??dloCcoo01eK00>1Fe/0:U/00h5KF`0^F`03
PE]K02AK0@00025K00GoFe]KP@0]F`03PE]K029K00>1Fe/00U/00om=C@03C@0>oda=C?m<CDcoc?o6
`?lH?`03oe]K01]K00>1Fe/0:U/00h5KF`0^F`03PE]K02AK0@00025K00GoFe]KP@0]F`03PE]K029K
00>1Fe/00e/00omVIP02IP03ode=009=00CoC4a<0_l2aP0J?dloCcm??dloCcm??dloCcm??dloCcm?
?olMF`03PE]K02YK00>1Fe/0;U/00h5KF`0TF`40001CF`03PE]K029K00>1Fe/00e/00om=C@03C@08
ode<COm=C4d2o`03aSlo01Lo00?oFe/075/00h5KF`0ZF`03PE]K02iK00>1Fe/095/10000De/00h5K
F`0RF`03PE]K00AK00?oIVH00VH01Om=CDgo00=<0ol06TloCcm??dloCcm??dloCcm??dloCcm??doo
7U/00h5KF`0ZF`03PE]K02iK00>1Fe/095/10000De/00h5KF`0RF`03PE]K00AK00CoCDe=2olJ?`03
oe]K01aK00>1Fe/0:U/00h5KF`0^F`03PE]K02AK0@0005=K00>1Fe/08U/00h5KF`05F`?o2b<8o`0C
?dloCcm??dloCcm??dloCcm?o`0NF`03PE]K02YK00>1Fe/0;U/00h5KF`0TF`40001CF`03PE]K029K
00>1Fe/02e/00olS8`098`04ob<S8`Oo2cl00omKF`0LF`03PE]K02YK00>1Fe/0;U/00h5KF`0TF`40
001hF`03PE]K01IK0_l68`?o00<Sool01_l014loColNF`03PE]K02YK00>1Fe/0;U/00h5KF`0TF`40
001hF`03PE]K01eK00>1Fe/01?l28`So7U/00h5KF`0ZF`03PE]K02iK00>1Fe/095/10000N5/00h5K
F`0MF`03PE]K00=K00>1Fe/09U/00h5KF`0ZF`03PE]K05EK0@0009QK00>1Fe/00e/00h5KF`0VF`03
PE]K02YK00>1Fe/0EE/10000V5/00h5KF`03F`03PE]K02IK00>1Fe/0PU/10000V5/00h5KF`03F`03
PE]K0:]K0@0009QK00>1Fe/00e/00h5KF`2[F`40003oFdeK0@000?mKCE/10000oe]=F`40003oFdeK
0@000?mKCE/10000oe]=F`40003oFdeK0@000?mKCE/10000oe]=F`40003oFdeK0@000?mKCE/10000
fU/2og1K0@000=]K0_l3F`03oe]K06UK0@000=aK0_l3F`03oe]K06QK0@0005AK1Ol3F`?o0U/2o`AK
0ol00e_oo`02o`=K1Ol5F`;o1E/2o`9K1Ol2F`;o0U/4o`=K1?l3F`Co0U/4o`=K1?l6F`;o0e/2o`03
Fooo009K1?l3F`?o0U/3o`9K0_l5F`?o0U/2o`MK1?l00e_oF`04o`9K0_l2F`;o0U/2o`EK1?l3F`Co
?5/10000De/2o`=K0_l015_ooe/2o`03Fooo00AK0_l00e_oo`02F`;o00=Kool00U/2o`EK0_l5F`;o
0U/2o`03Fooo009K0_l00e_oo`02F`;o00=Kool00U/2o`03Fooo009K1?l2F`;o00=Kool00U/2o`EK
0_l3F`;o00AKoomK0_l2F`;o0U/2o`9K0_l015_ooe/2o`EK0ol2F`;o1U/2o`9K1Ol2F`;o00=Kool0
0U/2o`9K0_l4F`;o0U/2o`03Fooo009K0_lkF`40001CF`;o0e/4o`=K1?l4F`;o00=Kool01E/2o`9K
0_l5F`;o1E/2o`9K0_l00e_oo`02F`;o00=Kool025/3o`AK1Ol8F`?o1E/2o`=K0_l00e_oo`04F`?o
0U/2o`03Fooo00=K1?l4F`;o00=Kool025/2o`AK1?l5F`;o0U/2o`QK0_l2F`;o00=Kool00U/2oc]K
0@0005MK1Ol3F`Co15/2o`03Fooo00Co00=Kool00U/2o`EK0_l5F`;o0U/2o`03Fooo009K0_l00e_o
o`04o`9K1?l3F`Co00=Kool01?l2F`Co1U/2o`=K0_l00e_oo`02F`Co0e/2o`03Fooo00=K1?l4F`;o
00=Kool025/2o`AK2?l00e_oo`02F`;o25/2o`9K0_l00e_oo`02F`;o>e/10000E5/5o`03Fooo00=K
1?l4F`;o00=Kool00U/2o`03Fooo009K0_l5F`Go0U/2o`9K0_l00e_oo`02F`;o00=Kool00U/2o`04
Foooo`AK0ol3F`;o0U/2o`04Foooo`QK0_l3F`;o00AKoomK0ol5F`;o00=Kool00e/4o`AK0_l00e_o
o`08F`;o0U/6o`9K0_l00e_oo`02F`;o25/2o`9K0_l00e_oo`02F`;o>e/10000De/3o`EK0_l015_o
oe/3o`=K0_l00e_oo`02F`;o00=Kool00U/2o`EK0_l5F`;o0U/2o`03Fooo009K0_l00e_oo`02F`;o
00=Kool00U/2o`03Fooo009K1?l2F`;o00=Kool00U/2o`EK1ol015_ooe/2o`9K0_l2F`;o0U/2o`04
FoooF`?o0e/2o`03Fooo00QK0_l6F`;o0U/2o`03Fooo009K0_l8F`Go0U/2o`9K0_lkF`40001CF`;o
0e/2o`9K0ol2F`?o0U/4o`03Fooo00;o0e/5o`EK0_l5F`;o00=Kool01ol3F`Co0e/4o`=K1?l2F`Co
0e/4o`IK0_l3F`;o00=Kool00U/4o`9K1?l2F`?o0U/3o`9K0_l3F`;o1e/2o`AK0_l00e_oo`02o`9K
1Ol9F`;o1E/2o`9K0_lkF`40001CF`;o0e/2o`eK0_l<F`;o1E/2o`UK0_l^F`;o0e/2o`aK0_lLF`;o
0U/2oaIK0_l2F`;o00=Kool00U/2oc]K0@0005AK1Ol>F`;o35/2o`EK1_l00e_oo`02F`;o;U/2o`=K
0_l00e_oo`09F`;o7E/4oaQK1?l3F`Co?5/10000oe]=F`40003oFdeK0@000?mKCE/10000oe]=F`40
0000\
\>"],
  ImageRangeCache->{{{0, 332}, {316, 0}} -> {-0.0772134, -0.0389858, 
  0.00305339, 0.00305339}}],

Cell[TextData[
"visualizeExpressions::fitnessesInfo: \n   Fitnesses: {176, 16, 24, 72, 36, \
30, 62, 46, 40, <<21>>, 176, 34, 176, \n     40, 16}"], "Message",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[
"visualizeExpressions::fitnessMax: Max. Fitness: 176"], "Message",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.0238095 0.952381 0.0147151 0.588604 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
% Start of sub-graphic
p
0.0238095 0.0147151 0.97619 0.603319 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.136054 0.0169173 0.136054 [
p
/Times findfont 14 scalefont setfont
[(Gen. 60)] .5 .71053 0 -2 Msboxa
P
[ 0 0 0 0 ]
[ 1 .71053 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
p
/Times findfont 14 scalefont setfont
[(Gen. 60)] .5 .71053 0 -2 Mshowa
P
P
0 0 m
1 0 L
1 .71053 L
0 .71053 L
closepath
clip
newpath
p
p
% Start of sub-graphic
p
0.0238095 0.0169173 0.149123 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.0169173 0.286967 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.0169173 0.424812 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.0169173 0.562657 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.0169173 0.700501 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.0169173 0.838346 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.0169173 0.97619 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.456888 2.01418 0.0247097 0.988389 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.89204 .63351 m
.83845 .60379 L
s
P
p
.2 1 0 r
.02 w
.89632 .68364 m
.89204 .63351 L
s
P
p
.2 1 0 r
.02 w
.83488 .55453 m
.78029 .52354 L
s
P
p
.2 1 0 r
.02 w
.83845 .60379 m
.83488 .55453 L
s
P
p
.2 1 0 r
.02 w
.84212 .6543 m
.89632 .68364 L
s
P
p
.2 1 0 r
.02 w
.78029 .52354 m
.78323 .57315 L
s
P
p
.2 1 0 r
.02 w
.72184 .44288 m
.66454 .40962 L
s
P
p
.2 1 0 r
.02 w
.72404 .49159 m
.72184 .44288 L
s
P
p
.2 1 0 r
.02 w
.78624 .62405 m
.84212 .6543 L
s
P
p
.2 1 0 r
.02 w
.78323 .57315 m
.72629 .54157 L
s
P
p
.2 1 0 r
.02 w
.72629 .54157 m
.72404 .49159 L
s
P
p
.2 1 0 r
.02 w
.66454 .40962 m
.66603 .45866 L
s
P
p
0 .4 1 r
.02 w
.67571 .40778 m
.67734 .45684 L
s
P
p
0 .4 1 r
.02 w
.61675 .37343 m
.67571 .40778 L
s
P
p
0 .4 1 r
.02 w
.61589 .32531 m
.61675 .37343 L
s
P
p
0 .4 1 r
.02 w
.55584 .28957 m
.61589 .32531 L
s
P
p
.2 1 0 r
.02 w
.84587 .70611 m
.78932 .67628 L
s
P
p
.2 1 0 r
.02 w
.84973 .75928 m
.84587 .70611 L
s
P
p
.2 1 0 r
.02 w
.78932 .67628 m
.78624 .62405 L
s
P
p
.2 1 0 r
.02 w
.66603 .45866 m
.60618 .42468 L
s
P
p
0 .4 1 r
.02 w
.67734 .45684 m
.61763 .42281 L
s
P
p
.2 1 0 r
.02 w
.79249 .7299 m
.84973 .75928 L
s
P
p
0 .4 1 r
.02 w
.55591 .33798 m
.55584 .28957 L
s
P
p
.2 1 0 r
.02 w
.66755 .50899 m
.66911 .56066 L
s
P
p
.2 1 0 r
.02 w
.60693 .47536 m
.66755 .50899 L
s
P
p
0 .4 1 r
.02 w
.67902 .50719 m
.68073 .55889 L
s
P
p
0 .4 1 r
.02 w
.61853 .47351 m
.67902 .50719 L
s
P
p
.01 w
.60618 .42468 Mdot
P
p
.2 1 0 r
.02 w
.60618 .42468 m
.60693 .47536 L
s
P
p
.01 w
.61763 .42281 Mdot
P
p
0 .4 1 r
.02 w
.61763 .42281 m
.61853 .47351 L
s
P
p
0 .4 1 r
.02 w
.49311 .30138 m
.55591 .33798 L
s
P
p
.2 1 0 r
.02 w
.79574 .78495 m
.79249 .7299 L
s
P
p
.2 1 0 r
.02 w
.73097 .6455 m
.7334 .69957 L
s
P
p
.2 1 0 r
.02 w
.67072 .61373 m
.73097 .6455 L
s
P
p
.2 1 0 r
.02 w
.66911 .56066 m
.6077 .52742 L
s
P
p
0 .4 1 r
.02 w
.68073 .55889 m
.6825 .61198 L
s
P
p
.2 1 0 r
.02 w
.7359 .75511 m
.79574 .78495 L
s
P
p
0 .4 1 r
.02 w
.42826 .26359 m
.49311 .30138 L
s
P
p
.2 1 0 r
.02 w
.7334 .69957 m
.7359 .75511 L
s
P
p
0 .4 1 r
.02 w
.7452 .6979 m
.74787 .75347 L
s
P
p
0 .4 1 r
.02 w
.68431 .66652 m
.7452 .6979 L
s
P
p
.2 1 0 r
.02 w
.67237 .66825 m
.67072 .61373 L
s
P
p
0 .4 1 r
.02 w
.6825 .61198 m
.68431 .66652 L
s
P
p
.2 1 0 r
.02 w
.6077 .52742 m
.54426 .49308 L
s
P
p
0 .4 1 r
.02 w
.36124 .22453 m
.42826 .26359 L
s
P
p
0 .4 1 r
.02 w
.74787 .75347 m
.68617 .72258 L
s
P
p
.2 1 0 r
.02 w
.6093 .63588 m
.67237 .66825 L
s
P
p
.2 1 0 r
.02 w
.60849 .5809 m
.6093 .63588 L
s
P
p
.2 1 0 r
.02 w
.54417 .54698 m
.60849 .5809 L
s
P
p
.2 1 0 r
.02 w
.54426 .49308 m
.54417 .54698 L
s
P
p
0 .4 1 r
.02 w
.35858 .27516 m
.36124 .22453 L
s
P
p
0 .4 1 r
.02 w
.68617 .72258 m
.68809 .78022 L
s
P
p
0 .4 1 r
.02 w
.28825 .23507 m
.35858 .27516 L
s
P
p
0 .4 1 r
.02 w
.68809 .78022 m
.62342 .74882 L
s
P
p
0 .4 1 r
.02 w
.29195 .18416 m
.28825 .23507 L
s
P
p
0 .4 1 r
.02 w
.22026 .14239 m
.29195 .18416 L
s
P
p
0 .4 1 r
.02 w
.62239 .69065 m
.55641 .65761 L
s
P
p
0 .4 1 r
.02 w
.62342 .74882 m
.62239 .69065 L
s
P
p
0 .4 1 r
.02 w
.21546 .19359 m
.22026 .14239 L
s
P
p
0 .4 1 r
.02 w
.55641 .65761 m
.5565 .71632 L
s
P
p
0 .4 1 r
.02 w
.14007 .15062 m
.21546 .19359 L
s
P
p
0 .4 1 r
.02 w
.5565 .71632 m
.48719 .68266 L
s
P
p
0 .4 1 r
.02 w
.2105 .2463 m
.1339 .20364 L
s
P
p
0 .4 1 r
.02 w
.2054 .30059 m
.2105 .2463 L
s
P
p
0 .4 1 r
.02 w
.1339 .20364 m
.14007 .15062 L
s
P
p
0 .4 1 r
.02 w
.48719 .68266 m
.41536 .64778 L
s
P
p
0 .4 1 r
.02 w
.20015 .35655 m
.2054 .30059 L
s
P
p
0 .4 1 r
.02 w
.41536 .64778 m
.34089 .61161 L
s
P
p
0 .4 1 r
.02 w
.27232 .45421 m
.19473 .41423 L
s
P
p
0 .4 1 r
.02 w
.26803 .51323 m
.27232 .45421 L
s
P
p
0 .4 1 r
.02 w
.19473 .41423 m
.20015 .35655 L
s
P
p
0 .4 1 r
.02 w
.34089 .61161 m
.33762 .67382 L
s
P
p
0 .4 1 r
.02 w
.18914 .47372 m
.26803 .51323 L
s
P
p
0 .4 1 r
.02 w
.33762 .67382 m
.25905 .63689 L
s
P
p
0 .4 1 r
.02 w
.26361 .57409 m
.18337 .53512 L
s
P
p
0 .4 1 r
.02 w
.25905 .63689 m
.26361 .57409 L
s
P
p
0 .4 1 r
.02 w
.18337 .53512 m
.18914 .47372 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.154762 0.149123 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.649333 2.38458 0.0238845 0.955379 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.77289 .40994 m
.66614 .35823 L
s
P
p
0 .4 1 r
.02 w
.7779 .48414 m
.77289 .40994 L
s
P
p
.2 1 0 r
.02 w
.86758 .61144 m
.76162 .56426 L
s
P
p
.2 1 0 r
.02 w
.87476 .6913 m
.86758 .61144 L
s
P
p
.2 1 0 r
.02 w
.75686 .48682 m
.64746 .43609 L
s
P
p
.2 1 0 r
.02 w
.76162 .56426 m
.75686 .48682 L
s
P
p
0 .4 1 r
.02 w
.6689 .43326 m
.7779 .48414 L
s
P
p
0 .4 1 r
.02 w
.66614 .35823 m
.6689 .43326 L
s
P
p
0 .4 1 r
.02 w
.55341 .23122 m
.43735 .17304 L
s
P
p
0 .4 1 r
.02 w
.55365 .30374 m
.55341 .23122 L
s
P
p
.2 1 0 r
.02 w
.76658 .64523 m
.87476 .6913 L
s
P
p
.2 1 0 r
.02 w
.64746 .43609 m
.64984 .5145 L
s
P
p
0 .4 1 r
.02 w
.6689 .43326 m
.55389 .37958 L
s
P
p
.2 1 0 r
.02 w
.53228 .30676 m
.41314 .24942 L
s
P
p
.2 1 0 r
.02 w
.53203 .38257 m
.53228 .30676 L
s
P
p
0 .4 1 r
.02 w
.55365 .30374 m
.55389 .37958 L
s
P
p
0 .4 1 r
.02 w
.43492 .24623 m
.55365 .30374 L
s
P
p
0 .4 1 r
.02 w
.43735 .17304 m
.43492 .24623 L
s
P
p
.2 1 0 r
.02 w
.65234 .59657 m
.76658 .64523 L
s
P
p
.2 1 0 r
.02 w
.64984 .5145 m
.53178 .46193 L
s
P
p
0 .4 1 r
.02 w
.67178 .51172 m
.55415 .459 L
s
P
p
0 .4 1 r
.02 w
.67479 .59386 m
.67178 .51172 L
s
P
p
.2 1 0 r
.02 w
.53178 .46193 m
.53203 .38257 L
s
P
p
0 .4 1 r
.02 w
.55389 .37958 m
.43237 .32286 L
s
P
p
0 .4 1 r
.02 w
.55415 .459 m
.55389 .37958 L
s
P
p
.2 1 0 r
.02 w
.41314 .24942 m
.41008 .32602 L
s
P
p
.2 1 0 r
.02 w
.77178 .72996 m
.65496 .68257 L
s
P
p
.2 1 0 r
.02 w
.77723 .81872 m
.77178 .72996 L
s
P
p
.2 1 0 r
.02 w
.65496 .68257 m
.65234 .59657 L
s
P
p
0 .4 1 r
.02 w
.55442 .54223 m
.67479 .59386 L
s
P
p
0 .4 1 r
.02 w
.55415 .459 m
.55442 .54223 L
s
P
p
.2 1 0 r
.02 w
.41008 .32602 m
.28102 .26618 L
s
P
p
0 .4 1 r
.02 w
.43237 .32286 m
.30375 .26284 L
s
P
p
0 .4 1 r
.02 w
.42969 .40321 m
.43237 .32286 L
s
P
p
.2 1 0 r
.02 w
.6577 .77278 m
.77723 .81872 L
s
P
p
.2 1 0 r
.02 w
.40687 .40632 m
.4035 .49059 L
s
P
p
.2 1 0 r
.02 w
.27451 .34738 m
.40687 .40632 L
s
P
p
0 .4 1 r
.02 w
.2978 .34409 m
.42969 .40321 L
s
P
p
.01 w
.28102 .26618 Mdot
P
p
.2 1 0 r
.02 w
.28102 .26618 m
.27451 .34738 L
s
P
p
.01 w
.30375 .26284 Mdot
P
p
0 .4 1 r
.02 w
.30375 .26284 m
.2978 .34409 L
s
P
p
.2 1 0 r
.02 w
.66058 .86753 m
.6577 .77278 L
s
P
p
.2 1 0 r
.02 w
.53123 .63238 m
.53093 .72406 L
s
P
p
.2 1 0 r
.02 w
.39996 .57913 m
.53123 .63238 L
s
P
p
.2 1 0 r
.02 w
.4035 .49059 m
.26766 .43273 L
s
P
p
.2 1 0 r
.02 w
.53062 .82049 m
.66058 .86753 L
s
P
p
.2 1 0 r
.02 w
.53093 .72406 m
.53062 .82049 L
s
P
p
.2 1 0 r
.02 w
.39624 .67229 m
.39996 .57913 L
s
P
p
.2 1 0 r
.02 w
.26766 .43273 m
.12324 .37122 L
s
P
p
.2 1 0 r
.02 w
.25286 .61718 m
.39624 .67229 L
s
P
p
.2 1 0 r
.02 w
.26046 .52254 m
.25286 .61718 L
s
P
p
.2 1 0 r
.02 w
.1119 .46228 m
.26046 .52254 L
s
P
p
.2 1 0 r
.02 w
.12324 .37122 m
.1119 .46228 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.154762 0.286967 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.37165 1.84319 0.0250572 1.00229 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.90221 .61294 m
.87106 .59342 L
s
P
p
.2 1 0 r
.02 w
.9047 .64494 m
.90221 .61294 L
s
P
p
.2 1 0 r
.02 w
.86881 .56173 m
.83734 .54175 L
s
P
p
.2 1 0 r
.02 w
.87106 .59342 m
.86881 .56173 L
s
P
p
.2 1 0 r
.02 w
.87335 .62556 m
.9047 .64494 L
s
P
p
.2 1 0 r
.02 w
.83734 .54175 m
.83938 .57357 L
s
P
p
.2 1 0 r
.02 w
.80351 .48994 m
.77116 .46914 L
s
P
p
.2 1 0 r
.02 w
.80532 .52143 m
.80351 .48994 L
s
P
p
.2 1 0 r
.02 w
.84146 .60584 m
.87335 .62556 L
s
P
p
.2 1 0 r
.02 w
.83938 .57357 m
.80715 .55337 L
s
P
p
.2 1 0 r
.02 w
.80715 .55337 m
.80532 .52143 L
s
P
p
.2 1 0 r
.02 w
.77116 .46914 m
.77275 .50075 L
s
P
p
.2 1 0 r
.02 w
.87566 .65815 m
.84356 .63857 L
s
P
p
.2 1 0 r
.02 w
.87801 .69122 m
.87566 .65815 L
s
P
p
.2 1 0 r
.02 w
.84356 .63857 m
.84146 .60584 L
s
P
p
.2 1 0 r
.02 w
.77275 .50075 m
.73962 .47972 L
s
P
p
.2 1 0 r
.02 w
.8457 .67179 m
.87801 .69122 L
s
P
p
.2 1 0 r
.02 w
.77437 .53283 m
.776 .56536 L
s
P
p
.2 1 0 r
.02 w
.741 .51192 m
.77437 .53283 L
s
P
p
0 .4 1 r
.02 w
.78094 .5317 m
.78263 .56425 L
s
P
p
0 .4 1 r
.02 w
.74762 .51078 m
.78094 .5317 L
s
P
p
.01 w
.73962 .47972 Mdot
P
p
.2 1 0 r
.02 w
.73962 .47972 m
.741 .51192 L
s
P
p
.01 w
.74618 .47857 Mdot
P
p
0 .4 1 r
.02 w
.74618 .47857 m
.74762 .51078 L
s
P
p
.2 1 0 r
.02 w
.84787 .70549 m
.8457 .67179 L
s
P
p
.2 1 0 r
.02 w
.8109 .61865 m
.81282 .65201 L
s
P
p
.2 1 0 r
.02 w
.77766 .59838 m
.8109 .61865 L
s
P
p
.2 1 0 r
.02 w
.776 .56536 m
.74241 .54459 L
s
P
p
0 .4 1 r
.02 w
.78263 .56425 m
.74907 .54346 L
s
P
p
.2 1 0 r
.02 w
.81476 .68587 m
.84787 .70549 L
s
P
p
.2 1 0 r
.02 w
.81282 .65201 m
.81476 .68587 L
s
P
p
.2 1 0 r
.02 w
.77935 .63189 m
.77766 .59838 L
s
P
p
.2 1 0 r
.02 w
.74241 .54459 m
.70821 .52345 L
s
P
p
0 .4 1 r
.02 w
.74907 .54346 m
.71492 .52229 L
s
P
p
.2 1 0 r
.02 w
.74528 .6114 m
.77935 .63189 L
s
P
p
.2 1 0 r
.02 w
.74383 .57775 m
.74528 .6114 L
s
P
p
.2 1 0 r
.02 w
.7094 .55675 m
.74383 .57775 L
s
P
p
.2 1 0 r
.02 w
.70821 .52345 m
.7094 .55675 L
s
P
p
0 .4 1 r
.02 w
.71492 .52229 m
.71616 .5556 L
s
P
p
0 .4 1 r
.02 w
.71616 .5556 m
.71741 .5894 L
s
P
p
0 .4 1 r
.02 w
.68016 .50075 m
.64476 .47881 L
s
P
p
0 .4 1 r
.02 w
.68114 .53419 m
.68016 .50075 L
s
P
p
0 .4 1 r
.02 w
.71741 .5894 m
.71868 .62372 L
s
P
p
0 .4 1 r
.02 w
.68214 .56814 m
.68114 .53419 L
s
P
p
0 .4 1 r
.02 w
.64476 .47881 m
.60872 .45648 L
s
P
p
0 .4 1 r
.02 w
.71868 .62372 m
.68315 .60262 L
s
P
p
0 .4 1 r
.02 w
.68315 .60262 m
.68214 .56814 L
s
P
p
0 .4 1 r
.02 w
.64549 .5124 m
.64622 .54649 L
s
P
p
0 .4 1 r
.02 w
.60917 .4902 m
.64549 .5124 L
s
P
p
0 .4 1 r
.02 w
.60872 .45648 m
.60917 .4902 L
s
P
p
0 .4 1 r
.02 w
.64622 .54649 m
.60963 .52444 L
s
P
p
0 .4 1 r
.02 w
.60963 .52444 m
.57235 .50197 L
s
P
p
0 .4 1 r
.02 w
.57235 .50197 m
.57253 .5369 L
s
P
p
0 .4 1 r
.02 w
.57253 .5369 m
.57271 .57239 L
s
P
p
0 .4 1 r
.02 w
.53437 .47908 m
.49566 .45575 L
s
P
p
0 .4 1 r
.02 w
.53425 .51416 m
.53437 .47908 L
s
P
p
0 .4 1 r
.02 w
.57271 .57239 m
.57289 .60844 L
s
P
p
0 .4 1 r
.02 w
.53412 .5498 m
.53425 .51416 L
s
P
p
0 .4 1 r
.02 w
.49566 .45575 m
.4562 .43197 L
s
P
p
0 .4 1 r
.02 w
.57289 .60844 m
.53399 .58603 L
s
P
p
0 .4 1 r
.02 w
.53399 .58603 m
.53412 .5498 L
s
P
p
0 .4 1 r
.02 w
.49522 .49098 m
.49478 .52678 L
s
P
p
0 .4 1 r
.02 w
.45544 .46735 m
.49522 .49098 L
s
P
p
0 .4 1 r
.02 w
.4562 .43197 m
.45544 .46735 L
s
P
p
0 .4 1 r
.02 w
.49478 .52678 m
.45467 .50331 L
s
P
p
0 .4 1 r
.02 w
.45467 .50331 m
.41376 .47937 L
s
P
p
0 .4 1 r
.02 w
.41376 .47937 m
.41262 .51609 L
s
P
p
0 .4 1 r
.02 w
.41262 .51609 m
.41147 .55343 L
s
P
p
0 .4 1 r
.02 w
.37203 .45495 m
.32946 .43004 L
s
P
p
0 .4 1 r
.02 w
.37053 .49184 m
.37203 .45495 L
s
P
p
0 .4 1 r
.02 w
.41147 .55343 m
.4103 .5914 L
s
P
p
0 .4 1 r
.02 w
.36901 .52935 m
.37053 .49184 L
s
P
p
0 .4 1 r
.02 w
.32946 .43004 m
.28602 .40461 L
s
P
p
0 .4 1 r
.02 w
.4103 .5914 m
.36746 .5675 L
s
P
p
0 .4 1 r
.02 w
.36746 .5675 m
.36901 .52935 L
s
P
p
0 .4 1 r
.02 w
.32758 .46709 m
.32568 .50477 L
s
P
p
0 .4 1 r
.02 w
.28375 .44183 m
.32758 .46709 L
s
P
p
0 .4 1 r
.02 w
.28602 .40461 m
.28375 .44183 L
s
P
p
0 .4 1 r
.02 w
.32568 .50477 m
.28144 .47969 L
s
P
p
0 .4 1 r
.02 w
.28144 .47969 m
.23628 .45407 L
s
P
p
0 .4 1 r
.02 w
.23628 .45407 m
.23351 .49278 L
s
P
p
0 .4 1 r
.02 w
.23351 .49278 m
.23069 .53217 L
s
P
p
0 .4 1 r
.02 w
.19016 .42792 m
.14304 .4012 L
s
P
p
0 .4 1 r
.02 w
.18694 .4668 m
.19016 .42792 L
s
P
p
0 .4 1 r
.02 w
.23069 .53217 m
.22782 .57227 L
s
P
p
0 .4 1 r
.02 w
.18367 .50638 m
.18694 .4668 L
s
P
p
0 .4 1 r
.02 w
.14304 .4012 m
.09491 .3739 L
s
P
p
0 .4 1 r
.02 w
.22782 .57227 m
.18034 .54669 L
s
P
p
0 .4 1 r
.02 w
.18034 .54669 m
.18367 .50638 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.154762 0.424812 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.154762 0.562657 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.498191 2.097 0.0245059 0.980236 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87882 .61174 m
.78846 .56381 L
s
P
p
.2 1 0 r
.02 w
.88591 .6918 m
.87882 .61174 L
s
P
p
.2 1 0 r
.02 w
.7834 .48613 m
.69015 .43471 L
s
P
p
.2 1 0 r
.02 w
.78846 .56381 m
.7834 .48613 L
s
P
p
.2 1 0 r
.02 w
.79374 .64494 m
.88591 .6918 L
s
P
p
.2 1 0 r
.02 w
.69015 .43471 m
.69327 .51333 L
s
P
p
.2 1 0 r
.02 w
.59099 .30448 m
.48962 .24655 L
s
P
p
.2 1 0 r
.02 w
.5919 .38054 m
.59099 .30448 L
s
P
p
.2 1 0 r
.02 w
.69652 .59553 m
.79374 .64494 L
s
P
p
.2 1 0 r
.02 w
.69327 .51333 m
.59285 .46007 L
s
P
p
.2 1 0 r
.02 w
.59285 .46007 m
.5919 .38054 L
s
P
p
.2 1 0 r
.02 w
.48962 .24655 m
.48822 .32337 L
s
P
p
0 .4 1 r
.02 w
.50847 .24332 m
.50751 .32019 L
s
P
p
0 .4 1 r
.02 w
.40185 .182 m
.50847 .24332 L
s
P
p
.2 1 0 r
.02 w
.79926 .72975 m
.69993 .68156 L
s
P
p
.2 1 0 r
.02 w
.80503 .8185 m
.79926 .72975 L
s
P
p
.2 1 0 r
.02 w
.69993 .68156 m
.69652 .59553 L
s
P
p
.2 1 0 r
.02 w
.48822 .32337 m
.37867 .26297 L
s
P
p
0 .4 1 r
.02 w
.50751 .32019 m
.39834 .2596 L
s
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.40185 .182 L
s
P
p
.2 1 0 r
.02 w
.7035 .77169 m
.80503 .8185 L
s
P
p
.2 1 0 r
.02 w
.48676 .40381 m
.48523 .48812 L
s
P
p
.2 1 0 r
.02 w
.37451 .34428 m
.48676 .40381 L
s
P
p
0 .4 1 r
.02 w
.5065 .40067 m
.50545 .48504 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.5065 .40067 L
s
P
p
.01 w
.37867 .26297 Mdot
P
p
.2 1 0 r
.02 w
.37867 .26297 m
.37451 .34428 L
s
P
p
.01 w
.39834 .2596 Mdot
P
p
0 .4 1 r
.02 w
.28278 .19546 m
.39834 .2596 L
s
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.28914 .11718 m
.28278 .19546 L
s
P
p
0 .4 1 r
.02 w
.16981 .04855 m
.28914 .11718 L
s
P
p
.2 1 0 r
.02 w
.70724 .86623 m
.7035 .77169 L
s
P
p
.2 1 0 r
.02 w
.59489 .63059 m
.59598 .72212 L
s
P
p
.2 1 0 r
.02 w
.48363 .5766 m
.59489 .63059 L
s
P
p
.2 1 0 r
.02 w
.48523 .48812 m
.37015 .42962 L
s
P
p
0 .4 1 r
.02 w
.50545 .48504 m
.39078 .42635 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.2761 .27766 L
s
P
p
0 .4 1 r
.02 w
.39078 .42635 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.28278 .19546 m
.16026 .12747 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.28278 .19546 L
s
P
p
.2 1 0 r
.02 w
.59713 .81827 m
.70724 .86623 L
s
P
p
0 .4 1 r
.02 w
.16026 .12747 m
.16981 .04855 L
s
P
p
.2 1 0 r
.02 w
.59598 .72212 m
.59713 .81827 L
s
P
p
.2 1 0 r
.02 w
.48194 .66955 m
.48363 .5766 L
s
P
p
.2 1 0 r
.02 w
.37015 .42962 m
.24801 .36753 L
s
P
p
0 .4 1 r
.02 w
.15022 .21045 m
.2761 .27766 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.26907 .36406 L
s
P
p
.2 1 0 r
.02 w
.36075 .61368 m
.48194 .66955 L
s
P
p
.2 1 0 r
.02 w
.36557 .51931 m
.36075 .61368 L
s
P
p
.2 1 0 r
.02 w
.24008 .45841 m
.36557 .51931 L
s
P
p
.2 1 0 r
.02 w
.24801 .36753 m
.24008 .45841 L
s
P
p
0 .4 1 r
.02 w
.26907 .36406 m
.13964 .29782 L
s
P
p
0 .4 1 r
.02 w
.13964 .29782 m
.15022 .21045 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.154762 0.700501 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.498191 2.097 0.0245059 0.980236 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87882 .61174 m
.78846 .56381 L
s
P
p
.2 1 0 r
.02 w
.88591 .6918 m
.87882 .61174 L
s
P
p
.2 1 0 r
.02 w
.7834 .48613 m
.69015 .43471 L
s
P
p
.2 1 0 r
.02 w
.78846 .56381 m
.7834 .48613 L
s
P
p
.2 1 0 r
.02 w
.79374 .64494 m
.88591 .6918 L
s
P
p
.2 1 0 r
.02 w
.69015 .43471 m
.69327 .51333 L
s
P
p
.2 1 0 r
.02 w
.59099 .30448 m
.48962 .24655 L
s
P
p
.2 1 0 r
.02 w
.5919 .38054 m
.59099 .30448 L
s
P
p
.2 1 0 r
.02 w
.69652 .59553 m
.79374 .64494 L
s
P
p
.2 1 0 r
.02 w
.69327 .51333 m
.59285 .46007 L
s
P
p
.2 1 0 r
.02 w
.59285 .46007 m
.5919 .38054 L
s
P
p
.2 1 0 r
.02 w
.48962 .24655 m
.48822 .32337 L
s
P
p
0 .4 1 r
.02 w
.50847 .24332 m
.50751 .32019 L
s
P
p
0 .4 1 r
.02 w
.40185 .182 m
.50847 .24332 L
s
P
p
.2 1 0 r
.02 w
.79926 .72975 m
.69993 .68156 L
s
P
p
.2 1 0 r
.02 w
.80503 .8185 m
.79926 .72975 L
s
P
p
.2 1 0 r
.02 w
.69993 .68156 m
.69652 .59553 L
s
P
p
.2 1 0 r
.02 w
.48822 .32337 m
.37867 .26297 L
s
P
p
0 .4 1 r
.02 w
.50751 .32019 m
.39834 .2596 L
s
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.40185 .182 L
s
P
p
.2 1 0 r
.02 w
.7035 .77169 m
.80503 .8185 L
s
P
p
.2 1 0 r
.02 w
.48676 .40381 m
.48523 .48812 L
s
P
p
.2 1 0 r
.02 w
.37451 .34428 m
.48676 .40381 L
s
P
p
0 .4 1 r
.02 w
.5065 .40067 m
.50545 .48504 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.5065 .40067 L
s
P
p
.01 w
.37867 .26297 Mdot
P
p
.2 1 0 r
.02 w
.37867 .26297 m
.37451 .34428 L
s
P
p
.01 w
.39834 .2596 Mdot
P
p
0 .4 1 r
.02 w
.28278 .19546 m
.39834 .2596 L
s
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.28914 .11718 m
.28278 .19546 L
s
P
p
0 .4 1 r
.02 w
.16981 .04855 m
.28914 .11718 L
s
P
p
.2 1 0 r
.02 w
.70724 .86623 m
.7035 .77169 L
s
P
p
.2 1 0 r
.02 w
.59489 .63059 m
.59598 .72212 L
s
P
p
.2 1 0 r
.02 w
.48363 .5766 m
.59489 .63059 L
s
P
p
.2 1 0 r
.02 w
.48523 .48812 m
.37015 .42962 L
s
P
p
0 .4 1 r
.02 w
.50545 .48504 m
.39078 .42635 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.2761 .27766 L
s
P
p
0 .4 1 r
.02 w
.39078 .42635 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.28278 .19546 m
.16026 .12747 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.28278 .19546 L
s
P
p
.2 1 0 r
.02 w
.59713 .81827 m
.70724 .86623 L
s
P
p
0 .4 1 r
.02 w
.16026 .12747 m
.16981 .04855 L
s
P
p
.2 1 0 r
.02 w
.59598 .72212 m
.59713 .81827 L
s
P
p
.2 1 0 r
.02 w
.48194 .66955 m
.48363 .5766 L
s
P
p
.2 1 0 r
.02 w
.37015 .42962 m
.24801 .36753 L
s
P
p
0 .4 1 r
.02 w
.15022 .21045 m
.2761 .27766 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.26907 .36406 L
s
P
p
.2 1 0 r
.02 w
.36075 .61368 m
.48194 .66955 L
s
P
p
.2 1 0 r
.02 w
.36557 .51931 m
.36075 .61368 L
s
P
p
.2 1 0 r
.02 w
.24008 .45841 m
.36557 .51931 L
s
P
p
.2 1 0 r
.02 w
.24801 .36753 m
.24008 .45841 L
s
P
p
0 .4 1 r
.02 w
.26907 .36406 m
.13964 .29782 L
s
P
p
0 .4 1 r
.02 w
.13964 .29782 m
.15022 .21045 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.154762 0.838346 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.466879 2.03426 0.024671 0.986839 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.89044 .61428 m
.84132 .58712 L
s
P
p
.2 1 0 r
.02 w
.89435 .65951 m
.89044 .61428 L
s
P
p
.2 1 0 r
.02 w
.838 .54262 m
.78804 .5144 L
s
P
p
.2 1 0 r
.02 w
.84132 .58712 m
.838 .54262 L
s
P
p
.2 1 0 r
.02 w
.84471 .63266 m
.89435 .65951 L
s
P
p
.2 1 0 r
.02 w
.78804 .5144 m
.79082 .5592 L
s
P
p
.2 1 0 r
.02 w
.73452 .44134 m
.68228 .41124 L
s
P
p
.2 1 0 r
.02 w
.73668 .48539 m
.73452 .44134 L
s
P
p
.2 1 0 r
.02 w
.79366 .60506 m
.84471 .63266 L
s
P
p
.2 1 0 r
.02 w
.79082 .5592 m
.73889 .53048 L
s
P
p
.2 1 0 r
.02 w
.73889 .53048 m
.73668 .48539 L
s
P
p
.2 1 0 r
.02 w
.68228 .41124 m
.68385 .45555 L
s
P
p
.2 1 0 r
.02 w
.84818 .67928 m
.79658 .65201 L
s
P
p
.2 1 0 r
.02 w
.85174 .72701 m
.84818 .67928 L
s
P
p
.2 1 0 r
.02 w
.79658 .65201 m
.79366 .60506 L
s
P
p
0 .4 1 r
.02 w
.74926 .5289 m
.69593 .49931 L
s
P
p
0 .4 1 r
.02 w
.75165 .57509 m
.74926 .5289 L
s
P
p
.2 1 0 r
.02 w
.68385 .45555 m
.62949 .42485 L
s
P
p
0 .4 1 r
.02 w
.6942 .45391 m
.63995 .42316 L
s
P
p
0 .4 1 r
.02 w
.69593 .49931 m
.6942 .45391 L
s
P
p
.2 1 0 r
.02 w
.79956 .7001 m
.85174 .72701 L
s
P
p
0 .4 1 r
.02 w
.69771 .54582 m
.75165 .57509 L
s
P
p
.2 1 0 r
.02 w
.68545 .50094 m
.6871 .54742 L
s
P
p
.2 1 0 r
.02 w
.63046 .47053 m
.68545 .50094 L
s
P
p
0 .4 1 r
.02 w
.69593 .49931 m
.69771 .54582 L
s
P
p
0 .4 1 r
.02 w
.64105 .46885 m
.69593 .49931 L
s
P
p
.01 w
.62949 .42485 Mdot
P
p
.2 1 0 r
.02 w
.62949 .42485 m
.63046 .47053 L
s
P
p
.01 w
.63995 .42316 Mdot
P
p
0 .4 1 r
.02 w
.63995 .42316 m
.58411 .39151 L
s
P
p
0 .4 1 r
.02 w
.64105 .46885 m
.63995 .42316 L
s
P
p
.2 1 0 r
.02 w
.80262 .74937 m
.79956 .7001 L
s
P
p
.2 1 0 r
.02 w
.74347 .62395 m
.74584 .67241 L
s
P
p
.2 1 0 r
.02 w
.68878 .59506 m
.74347 .62395 L
s
P
p
.2 1 0 r
.02 w
.6871 .54742 m
.63145 .51733 L
s
P
p
0 .4 1 r
.02 w
.64217 .51567 m
.69771 .54582 L
s
P
p
0 .4 1 r
.02 w
.64105 .46885 m
.64217 .51567 L
s
P
p
0 .4 1 r
.02 w
.58453 .43749 m
.64105 .46885 L
s
P
p
0 .4 1 r
.02 w
.58411 .39151 m
.58453 .43749 L
s
P
p
.2 1 0 r
.02 w
.74827 .72207 m
.80262 .74937 L
s
P
p
.2 1 0 r
.02 w
.74584 .67241 m
.74827 .72207 L
s
P
p
.2 1 0 r
.02 w
.69051 .64388 m
.68878 .59506 L
s
P
p
.2 1 0 r
.02 w
.63145 .51733 m
.57412 .48632 L
s
P
p
0 .4 1 r
.02 w
.64217 .51567 m
.58496 .48462 L
s
P
p
0 .4 1 r
.02 w
.64332 .56366 m
.64217 .51567 L
s
P
p
0 .4 1 r
.02 w
.58496 .48462 m
.58453 .43749 L
s
P
p
.2 1 0 r
.02 w
.6335 .61448 m
.69051 .64388 L
s
P
p
0 .4 1 r
.02 w
.40988 .2006 m
.34855 .16444 L
s
P
p
0 .4 1 r
.02 w
.4081 .24509 m
.40988 .2006 L
s
P
p
.2 1 0 r
.02 w
.63246 .5653 m
.6335 .61448 L
s
P
p
.2 1 0 r
.02 w
.57442 .53463 m
.63246 .5653 L
s
P
p
0 .4 1 r
.02 w
.5854 .53294 m
.64332 .56366 L
s
P
p
.2 1 0 r
.02 w
.57412 .48632 m
.57442 .53463 L
s
P
p
0 .4 1 r
.02 w
.46735 .32534 m
.46629 .37188 L
s
P
p
0 .4 1 r
.02 w
.40628 .29072 m
.46735 .32534 L
s
P
p
0 .4 1 r
.02 w
.4081 .24509 m
.40628 .29072 L
s
P
p
0 .4 1 r
.02 w
.34597 .20915 m
.4081 .24509 L
s
P
p
0 .4 1 r
.02 w
.34855 .16444 m
.34597 .20915 L
s
P
p
0 .4 1 r
.02 w
.52568 .50128 m
.5854 .53294 L
s
P
p
0 .4 1 r
.02 w
.526 .45262 m
.52568 .50128 L
s
P
p
0 .4 1 r
.02 w
.46521 .41962 m
.526 .45262 L
s
P
p
0 .4 1 r
.02 w
.46629 .37188 m
.46521 .41962 L
s
P
p
0 .4 1 r
.02 w
.34331 .25503 m
.40628 .29072 L
s
P
p
0 .4 1 r
.02 w
.40628 .29072 m
.40442 .33754 L
s
P
p
0 .4 1 r
.02 w
.34331 .25503 m
.34597 .20915 L
s
P
p
0 .4 1 r
.02 w
.34597 .20915 m
.28188 .17209 L
s
P
p
0 .4 1 r
.02 w
.64571 .66334 m
.58632 .63338 L
s
P
p
0 .4 1 r
.02 w
.64695 .71512 m
.64571 .66334 L
s
P
p
0 .4 1 r
.02 w
.52568 .50128 m
.52536 .55121 L
s
P
p
0 .4 1 r
.02 w
.4025 .38558 m
.46521 .41962 L
s
P
p
0 .4 1 r
.02 w
.40442 .33754 m
.34058 .30212 L
s
P
p
0 .4 1 r
.02 w
.27834 .21821 m
.34331 .25503 L
s
P
p
0 .4 1 r
.02 w
.34058 .30212 m
.34331 .25503 L
s
P
p
0 .4 1 r
.02 w
.64695 .71512 m
.58679 .68558 L
s
P
p
0 .4 1 r
.02 w
.64822 .76826 m
.64695 .71512 L
s
P
p
0 .4 1 r
.02 w
.28188 .17209 m
.27834 .21821 L
s
P
p
0 .4 1 r
.02 w
.58632 .63338 m
.58679 .68558 L
s
P
p
0 .4 1 r
.02 w
.52503 .60247 m
.58632 .63338 L
s
P
p
0 .4 1 r
.02 w
.52536 .55121 m
.46295 .51891 L
s
P
p
0 .4 1 r
.02 w
.40053 .43491 m
.4025 .38558 L
s
P
p
0 .4 1 r
.02 w
.2747 .26555 m
.34058 .30212 L
s
P
p
0 .4 1 r
.02 w
.58728 .73919 m
.64822 .76826 L
s
P
p
0 .4 1 r
.02 w
.27834 .21821 m
.2747 .26555 L
s
P
p
0 .4 1 r
.02 w
.58679 .68558 m
.58728 .73919 L
s
P
p
0 .4 1 r
.02 w
.58679 .68558 m
.5247 .6551 L
s
P
p
0 .4 1 r
.02 w
.5247 .6551 m
.52503 .60247 L
s
P
p
0 .4 1 r
.02 w
.46295 .51891 m
.39851 .48556 L
s
P
p
0 .4 1 r
.02 w
.46177 .57056 m
.46295 .51891 L
s
P
p
0 .4 1 r
.02 w
.33491 .40011 m
.40053 .43491 L
s
P
p
0 .4 1 r
.02 w
.39851 .48556 m
.40053 .43491 L
s
P
p
0 .4 1 r
.02 w
.58728 .73919 m
.52435 .70916 L
s
P
p
0 .4 1 r
.02 w
.58778 .79425 m
.58728 .73919 L
s
P
p
0 .4 1 r
.02 w
.5247 .6551 m
.46057 .62362 L
s
P
p
0 .4 1 r
.02 w
.52435 .70916 m
.5247 .6551 L
s
P
p
0 .4 1 r
.02 w
.46057 .62362 m
.46177 .57056 L
s
P
p
0 .4 1 r
.02 w
.26712 .36416 m
.33491 .40011 L
s
P
p
0 .4 1 r
.02 w
.52399 .76472 m
.58778 .79425 L
s
P
p
0 .4 1 r
.02 w
.52435 .70916 m
.52399 .76472 L
s
P
p
0 .4 1 r
.02 w
.33196 .45112 m
.32892 .50355 L
s
P
p
0 .4 1 r
.02 w
.26317 .41552 m
.33196 .45112 L
s
P
p
0 .4 1 r
.02 w
.26317 .41552 m
.26712 .36416 L
s
P
p
0 .4 1 r
.02 w
.32892 .50355 m
.25911 .46834 L
s
P
p
0 .4 1 r
.02 w
.3258 .55746 m
.32892 .50355 L
s
P
p
0 .4 1 r
.02 w
.19205 .37871 m
.26317 .41552 L
s
P
p
0 .4 1 r
.02 w
.25911 .46834 m
.26317 .41552 L
s
P
p
0 .4 1 r
.02 w
.25494 .52267 m
.3258 .55746 L
s
P
p
0 .4 1 r
.02 w
.25911 .46834 m
.18689 .43191 L
s
P
p
0 .4 1 r
.02 w
.25494 .52267 m
.25911 .46834 L
s
P
p
0 .4 1 r
.02 w
.18689 .43191 m
.19205 .37871 L
s
P
p
0 .4 1 r
.02 w
.19205 .37871 m
.11846 .34063 L
s
P
p
0 .4 1 r
.02 w
.18159 .48666 m
.25494 .52267 L
s
P
p
0 .4 1 r
.02 w
.18689 .43191 m
.18159 .48666 L
s
P
p
0 .4 1 r
.02 w
.11214 .39421 m
.18689 .43191 L
s
P
p
0 .4 1 r
.02 w
.11846 .34063 m
.11214 .39421 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.154762 0.97619 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-1.27536 3.5938 -0.0119452 0.987264 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.82433 .35816 m
.723 .32476 L
s
P
p
.2 1 0 r
.02 w
.82788 .40573 m
.82433 .35816 L
s
P
p
.2 1 0 r
.02 w
.72066 .27802 m
.61762 .24341 L
s
P
p
.2 1 0 r
.02 w
.723 .32476 m
.72066 .27802 L
s
P
p
.2 1 0 r
.02 w
.72539 .37261 m
.82788 .40573 L
s
P
p
.2 1 0 r
.02 w
.61762 .24341 m
.61877 .29041 L
s
P
p
.2 1 0 r
.02 w
.51175 .16168 m
.40398 .12482 L
s
P
p
.2 1 0 r
.02 w
.51163 .20781 m
.51175 .16168 L
s
P
p
.2 1 0 r
.02 w
.61994 .33854 m
.72539 .37261 L
s
P
p
.2 1 0 r
.02 w
.61877 .29041 m
.51151 .25506 L
s
P
p
.2 1 0 r
.02 w
.51151 .25506 m
.51163 .20781 L
s
P
p
.2 1 0 r
.02 w
.40398 .12482 m
.40256 .17117 L
s
P
p
.2 1 0 r
.02 w
.72785 .42161 m
.62114 .38784 L
s
P
p
.2 1 0 r
.02 w
.73036 .47181 m
.72785 .42161 L
s
P
p
.2 1 0 r
.02 w
.62114 .38784 m
.61994 .33854 L
s
P
p
.2 1 0 r
.02 w
.40256 .17117 m
.29026 .13345 L
s
P
p
.2 1 0 r
.02 w
.62237 .43836 m
.73036 .47181 L
s
P
p
.2 1 0 r
.02 w
.40109 .21867 m
.3996 .26734 L
s
P
p
.2 1 0 r
.02 w
.28738 .18119 m
.40109 .21867 L
s
P
p
0 .4 1 r
.02 w
.42137 .21666 m
.42013 .26535 L
s
P
p
0 .4 1 r
.02 w
.30787 .17912 m
.42137 .21666 L
s
P
p
.01 w
.29026 .13345 Mdot
P
p
.2 1 0 r
.02 w
.29026 .13345 m
.28738 .18119 L
s
P
p
.01 w
.3105 .13138 Mdot
P
p
0 .4 1 r
.02 w
.3105 .13138 m
.30787 .17912 L
s
P
p
.2 1 0 r
.02 w
.62364 .49015 m
.62237 .43836 L
s
P
p
.2 1 0 r
.02 w
.51126 .35306 m
.51113 .40391 L
s
P
p
.2 1 0 r
.02 w
.39806 .31723 m
.51126 .35306 L
s
P
p
.2 1 0 r
.02 w
.3996 .26734 m
.28442 .23012 L
s
P
p
0 .4 1 r
.02 w
.42013 .26535 m
.41885 .31526 L
s
P
p
.2 1 0 r
.02 w
.511 .45605 m
.62364 .49015 L
s
P
p
.2 1 0 r
.02 w
.51113 .40391 m
.511 .45605 L
s
P
p
.2 1 0 r
.02 w
.39649 .3684 m
.39806 .31723 L
s
P
p
0 .4 1 r
.02 w
.41885 .31526 m
.3024 .27828 L
s
P
p
.2 1 0 r
.02 w
.28442 .23012 m
.16571 .19176 L
s
P
p
.2 1 0 r
.02 w
.27829 .33179 m
.39649 .3684 L
s
P
p
0 .4 1 r
.02 w
.41754 .36645 m
.4162 .41896 L
s
P
p
0 .4 1 r
.02 w
.29956 .32978 m
.41754 .36645 L
s
P
p
.2 1 0 r
.02 w
.28139 .28031 m
.27829 .33179 L
s
P
p
.2 1 0 r
.02 w
.16109 .24223 m
.28139 .28031 L
s
P
p
0 .4 1 r
.02 w
.3024 .27828 m
.29956 .32978 L
s
P
p
.2 1 0 r
.02 w
.16571 .19176 m
.16109 .24223 L
s
P
p
0 .4 1 r
.02 w
.4162 .41896 m
.41482 .47284 L
s
P
p
0 .4 1 r
.02 w
.41482 .47284 m
.29366 .43689 L
s
P
p
0 .4 1 r
.02 w
.4134 .52815 m
.41195 .58495 L
s
P
p
0 .4 1 r
.02 w
.29059 .49261 m
.4134 .52815 L
s
P
p
0 .4 1 r
.02 w
.29366 .43689 m
.29059 .49261 L
s
P
p
0 .4 1 r
.02 w
.41195 .58495 m
.41046 .64329 L
s
P
p
0 .4 1 r
.02 w
.41046 .64329 m
.28419 .60868 L
s
P
p
0 .4 1 r
.02 w
.40892 .70325 m
.40735 .76489 L
s
P
p
0 .4 1 r
.02 w
.28086 .66916 m
.40892 .70325 L
s
P
p
0 .4 1 r
.02 w
.28419 .60868 m
.28086 .66916 L
s
P
p
0 .4 1 r
.02 w
.40735 .76489 m
.40572 .82827 L
s
P
p
0 .4 1 r
.02 w
.40572 .82827 m
.27391 .79537 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.292607 0.149123 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.7753 .37106 m
.67141 .31411 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.7753 .37106 L
s
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
0 .4 1 r
.02 w
.67141 .31411 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.79284 .61791 L
s
P
p
0 .4 1 r
.02 w
.90676 .7578 m
.89777 .66825 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.90676 .7578 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.43465 .44607 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.292607 0.286967 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.8811 .50206 m
.78086 .44927 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.8811 .50206 L
s
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.90676 .7578 m
.89777 .66825 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.90676 .7578 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.91622 .85211 m
.80614 .80506 L
s
P
p
0 .4 1 r
.02 w
.9262 .95156 m
.91622 .85211 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.81335 .90655 m
.9262 .95156 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.81335 .90655 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56304 .80672 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.42373 .75116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.27351 .69125 m
.42373 .75116 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.27351 .69125 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.292607 0.424812 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.498191 2.097 0.0245059 0.980236 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87882 .61174 m
.78846 .56381 L
s
P
p
.2 1 0 r
.02 w
.88591 .6918 m
.87882 .61174 L
s
P
p
.2 1 0 r
.02 w
.7834 .48613 m
.69015 .43471 L
s
P
p
.2 1 0 r
.02 w
.78846 .56381 m
.7834 .48613 L
s
P
p
.2 1 0 r
.02 w
.79374 .64494 m
.88591 .6918 L
s
P
p
.2 1 0 r
.02 w
.69015 .43471 m
.69327 .51333 L
s
P
p
.2 1 0 r
.02 w
.59099 .30448 m
.48962 .24655 L
s
P
p
.2 1 0 r
.02 w
.5919 .38054 m
.59099 .30448 L
s
P
p
.2 1 0 r
.02 w
.69652 .59553 m
.79374 .64494 L
s
P
p
.2 1 0 r
.02 w
.69327 .51333 m
.59285 .46007 L
s
P
p
.2 1 0 r
.02 w
.59285 .46007 m
.5919 .38054 L
s
P
p
.2 1 0 r
.02 w
.48962 .24655 m
.48822 .32337 L
s
P
p
0 .4 1 r
.02 w
.50847 .24332 m
.50751 .32019 L
s
P
p
0 .4 1 r
.02 w
.40185 .182 m
.50847 .24332 L
s
P
p
.2 1 0 r
.02 w
.79926 .72975 m
.69993 .68156 L
s
P
p
.2 1 0 r
.02 w
.80503 .8185 m
.79926 .72975 L
s
P
p
.2 1 0 r
.02 w
.69993 .68156 m
.69652 .59553 L
s
P
p
.2 1 0 r
.02 w
.48822 .32337 m
.37867 .26297 L
s
P
p
0 .4 1 r
.02 w
.50751 .32019 m
.39834 .2596 L
s
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.40185 .182 L
s
P
p
.2 1 0 r
.02 w
.7035 .77169 m
.80503 .8185 L
s
P
p
.2 1 0 r
.02 w
.48676 .40381 m
.48523 .48812 L
s
P
p
.2 1 0 r
.02 w
.37451 .34428 m
.48676 .40381 L
s
P
p
0 .4 1 r
.02 w
.5065 .40067 m
.50545 .48504 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.5065 .40067 L
s
P
p
.01 w
.37867 .26297 Mdot
P
p
.2 1 0 r
.02 w
.37867 .26297 m
.37451 .34428 L
s
P
p
.01 w
.39834 .2596 Mdot
P
p
0 .4 1 r
.02 w
.28278 .19546 m
.39834 .2596 L
s
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.28914 .11718 m
.28278 .19546 L
s
P
p
0 .4 1 r
.02 w
.16981 .04855 m
.28914 .11718 L
s
P
p
.2 1 0 r
.02 w
.70724 .86623 m
.7035 .77169 L
s
P
p
.2 1 0 r
.02 w
.59489 .63059 m
.59598 .72212 L
s
P
p
.2 1 0 r
.02 w
.48363 .5766 m
.59489 .63059 L
s
P
p
.2 1 0 r
.02 w
.48523 .48812 m
.37015 .42962 L
s
P
p
0 .4 1 r
.02 w
.50545 .48504 m
.39078 .42635 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.2761 .27766 L
s
P
p
0 .4 1 r
.02 w
.39078 .42635 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.28278 .19546 m
.16026 .12747 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.28278 .19546 L
s
P
p
.2 1 0 r
.02 w
.59713 .81827 m
.70724 .86623 L
s
P
p
0 .4 1 r
.02 w
.16026 .12747 m
.16981 .04855 L
s
P
p
.2 1 0 r
.02 w
.59598 .72212 m
.59713 .81827 L
s
P
p
.2 1 0 r
.02 w
.48194 .66955 m
.48363 .5766 L
s
P
p
.2 1 0 r
.02 w
.37015 .42962 m
.24801 .36753 L
s
P
p
0 .4 1 r
.02 w
.15022 .21045 m
.2761 .27766 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.26907 .36406 L
s
P
p
.2 1 0 r
.02 w
.36075 .61368 m
.48194 .66955 L
s
P
p
.2 1 0 r
.02 w
.36557 .51931 m
.36075 .61368 L
s
P
p
.2 1 0 r
.02 w
.24008 .45841 m
.36557 .51931 L
s
P
p
.2 1 0 r
.02 w
.24801 .36753 m
.24008 .45841 L
s
P
p
0 .4 1 r
.02 w
.26907 .36406 m
.13964 .29782 L
s
P
p
0 .4 1 r
.02 w
.13964 .29782 m
.15022 .21045 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.292607 0.562657 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.498191 2.097 0.0245059 0.980236 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87882 .61174 m
.78846 .56381 L
s
P
p
.2 1 0 r
.02 w
.88591 .6918 m
.87882 .61174 L
s
P
p
.2 1 0 r
.02 w
.7834 .48613 m
.69015 .43471 L
s
P
p
.2 1 0 r
.02 w
.78846 .56381 m
.7834 .48613 L
s
P
p
.2 1 0 r
.02 w
.79374 .64494 m
.88591 .6918 L
s
P
p
.2 1 0 r
.02 w
.69015 .43471 m
.69327 .51333 L
s
P
p
.2 1 0 r
.02 w
.59099 .30448 m
.48962 .24655 L
s
P
p
.2 1 0 r
.02 w
.5919 .38054 m
.59099 .30448 L
s
P
p
.2 1 0 r
.02 w
.69652 .59553 m
.79374 .64494 L
s
P
p
.2 1 0 r
.02 w
.69327 .51333 m
.59285 .46007 L
s
P
p
.2 1 0 r
.02 w
.59285 .46007 m
.5919 .38054 L
s
P
p
.2 1 0 r
.02 w
.48962 .24655 m
.48822 .32337 L
s
P
p
0 .4 1 r
.02 w
.50847 .24332 m
.50751 .32019 L
s
P
p
0 .4 1 r
.02 w
.40185 .182 m
.50847 .24332 L
s
P
p
.2 1 0 r
.02 w
.79926 .72975 m
.69993 .68156 L
s
P
p
.2 1 0 r
.02 w
.80503 .8185 m
.79926 .72975 L
s
P
p
.2 1 0 r
.02 w
.69993 .68156 m
.69652 .59553 L
s
P
p
.2 1 0 r
.02 w
.48822 .32337 m
.37867 .26297 L
s
P
p
0 .4 1 r
.02 w
.50751 .32019 m
.39834 .2596 L
s
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.40185 .182 L
s
P
p
.2 1 0 r
.02 w
.7035 .77169 m
.80503 .8185 L
s
P
p
.2 1 0 r
.02 w
.48676 .40381 m
.48523 .48812 L
s
P
p
.2 1 0 r
.02 w
.37451 .34428 m
.48676 .40381 L
s
P
p
0 .4 1 r
.02 w
.5065 .40067 m
.50545 .48504 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.5065 .40067 L
s
P
p
.01 w
.37867 .26297 Mdot
P
p
.2 1 0 r
.02 w
.37867 .26297 m
.37451 .34428 L
s
P
p
.01 w
.39834 .2596 Mdot
P
p
0 .4 1 r
.02 w
.28278 .19546 m
.39834 .2596 L
s
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.28914 .11718 m
.28278 .19546 L
s
P
p
0 .4 1 r
.02 w
.16981 .04855 m
.28914 .11718 L
s
P
p
.2 1 0 r
.02 w
.70724 .86623 m
.7035 .77169 L
s
P
p
.2 1 0 r
.02 w
.59489 .63059 m
.59598 .72212 L
s
P
p
.2 1 0 r
.02 w
.48363 .5766 m
.59489 .63059 L
s
P
p
.2 1 0 r
.02 w
.48523 .48812 m
.37015 .42962 L
s
P
p
0 .4 1 r
.02 w
.50545 .48504 m
.39078 .42635 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.2761 .27766 L
s
P
p
0 .4 1 r
.02 w
.39078 .42635 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.28278 .19546 m
.16026 .12747 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.28278 .19546 L
s
P
p
.2 1 0 r
.02 w
.59713 .81827 m
.70724 .86623 L
s
P
p
0 .4 1 r
.02 w
.16026 .12747 m
.16981 .04855 L
s
P
p
.2 1 0 r
.02 w
.59598 .72212 m
.59713 .81827 L
s
P
p
.2 1 0 r
.02 w
.48194 .66955 m
.48363 .5766 L
s
P
p
.2 1 0 r
.02 w
.37015 .42962 m
.24801 .36753 L
s
P
p
0 .4 1 r
.02 w
.15022 .21045 m
.2761 .27766 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.26907 .36406 L
s
P
p
.2 1 0 r
.02 w
.36075 .61368 m
.48194 .66955 L
s
P
p
.2 1 0 r
.02 w
.36557 .51931 m
.36075 .61368 L
s
P
p
.2 1 0 r
.02 w
.24008 .45841 m
.36557 .51931 L
s
P
p
.2 1 0 r
.02 w
.24801 .36753 m
.24008 .45841 L
s
P
p
0 .4 1 r
.02 w
.26907 .36406 m
.13964 .29782 L
s
P
p
0 .4 1 r
.02 w
.13964 .29782 m
.15022 .21045 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.292607 0.700501 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.292607 0.838346 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.536536 2.17425 0.0243672 0.974688 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.73632 .36403 m
.68646 .33635 L
s
P
p
0 .4 1 r
.02 w
.73844 .40204 m
.73632 .36403 L
s
P
p
0 .4 1 r
.02 w
.8417 .53251 m
.79296 .50698 L
s
P
p
0 .4 1 r
.02 w
.84505 .57272 m
.8417 .53251 L
s
P
p
0 .4 1 r
.02 w
.74062 .44093 m
.73844 .40204 L
s
P
p
0 .4 1 r
.02 w
.68646 .33635 m
.68804 .37457 L
s
P
p
0 .4 1 r
.02 w
.84849 .61388 m
.84505 .57272 L
s
P
p
0 .4 1 r
.02 w
.79296 .50698 m
.74285 .48073 L
s
P
p
0 .4 1 r
.02 w
.68965 .41369 m
.74062 .44093 L
s
P
p
0 .4 1 r
.02 w
.68804 .37457 m
.63621 .34633 L
s
P
p
0 .4 1 r
.02 w
.85201 .65601 m
.84849 .61388 L
s
P
p
0 .4 1 r
.02 w
.74285 .48073 m
.69131 .45374 L
s
P
p
0 .4 1 r
.02 w
.69131 .45374 m
.68965 .41369 L
s
P
p
0 .4 1 r
.02 w
.63621 .34633 m
.63723 .38567 L
s
P
p
0 .4 1 r
.02 w
.80166 .63133 m
.85201 .65601 L
s
P
p
0 .4 1 r
.02 w
.90929 .76662 m
.8593 .74331 L
s
P
p
0 .4 1 r
.02 w
.91362 .8115 m
.90929 .76662 L
s
P
p
0 .4 1 r
.02 w
.63723 .38567 m
.58329 .35684 L
s
P
p
0 .4 1 r
.02 w
.58289 .31728 m
.52803 .28738 L
s
P
p
0 .4 1 r
.02 w
.58329 .35684 m
.58289 .31728 L
s
P
p
0 .4 1 r
.02 w
.85561 .69914 m
.80471 .6748 L
s
P
p
0 .4 1 r
.02 w
.8593 .74331 m
.85561 .69914 L
s
P
p
0 .4 1 r
.02 w
.80471 .6748 m
.80166 .63133 L
s
P
p
0 .4 1 r
.02 w
.86307 .78857 m
.91362 .8115 L
s
P
p
0 .4 1 r
.02 w
.52803 .28738 m
.47154 .25661 L
s
P
p
0 .4 1 r
.02 w
.81102 .76496 m
.86307 .78857 L
s
P
p
0 .4 1 r
.02 w
.80783 .71932 m
.81102 .76496 L
s
P
p
0 .4 1 r
.02 w
.75482 .69462 m
.80783 .71932 L
s
P
p
0 .4 1 r
.02 w
.47154 .25661 m
.41337 .22491 L
s
P
p
0 .4 1 r
.02 w
.75739 .74063 m
.75482 .69462 L
s
P
p
0 .4 1 r
.02 w
.41337 .22491 m
.41163 .2651 L
s
P
p
.2 1 0 r
.02 w
.5166 .41132 m
.45783 .38128 L
s
P
p
.2 1 0 r
.02 w
.51617 .45415 m
.5166 .41132 L
s
P
p
.2 1 0 r
.02 w
.459 .33925 m
.39919 .30804 L
s
P
p
.2 1 0 r
.02 w
.45783 .38128 m
.459 .33925 L
s
P
p
0 .4 1 r
.02 w
.76003 .78782 m
.75739 .74063 L
s
P
p
0 .4 1 r
.02 w
.41163 .2651 m
.40985 .30632 L
s
P
p
.2 1 0 r
.02 w
.45663 .4244 m
.51617 .45415 L
s
P
p
0 .4 1 r
.02 w
.76274 .83623 m
.76003 .78782 L
s
P
p
.2 1 0 r
.02 w
.39919 .30804 m
.39723 .35032 L
s
P
p
0 .4 1 r
.02 w
.40985 .30632 m
.40803 .34861 L
s
P
p
.2 1 0 r
.02 w
.34025 .23442 m
.27749 .20099 L
s
P
p
.2 1 0 r
.02 w
.33751 .27585 m
.34025 .23442 L
s
P
p
.2 1 0 r
.02 w
.39521 .3937 m
.45663 .4244 L
s
P
p
0 .4 1 r
.02 w
.7061 .812 m
.76274 .83623 L
s
P
p
.2 1 0 r
.02 w
.39723 .35032 m
.33471 .31837 L
s
P
p
0 .4 1 r
.02 w
.40803 .34861 m
.34563 .31661 L
s
P
p
.2 1 0 r
.02 w
.33471 .31837 m
.33751 .27585 L
s
P
p
0 .4 1 r
.02 w
.34829 .27408 m
.28478 .24081 L
s
P
p
0 .4 1 r
.02 w
.34563 .31661 m
.34829 .27408 L
s
P
p
.2 1 0 r
.02 w
.27749 .20099 m
.27388 .24264 L
s
P
p
.2 1 0 r
.02 w
.4554 .46864 m
.39315 .43824 L
s
P
p
.2 1 0 r
.02 w
.45414 .51406 m
.4554 .46864 L
s
P
p
.2 1 0 r
.02 w
.39315 .43824 m
.39521 .3937 L
s
P
p
0 .4 1 r
.02 w
.64764 .78699 m
.7061 .812 L
s
P
p
.2 1 0 r
.02 w
.27388 .24264 m
.20821 .20836 L
s
P
p
0 .4 1 r
.02 w
.28478 .24081 m
.21922 .20647 L
s
P
p
.2 1 0 r
.02 w
.39102 .48399 m
.45414 .51406 L
s
P
p
0 .4 1 r
.02 w
.58728 .76118 m
.64764 .78699 L
s
P
p
0 .4 1 r
.02 w
.34289 .36028 m
.34008 .40513 L
s
P
p
0 .4 1 r
.02 w
.27757 .32752 m
.34289 .36028 L
s
P
p
.2 1 0 r
.02 w
.27018 .2854 m
.26638 .32932 L
s
P
p
.2 1 0 r
.02 w
.20356 .25135 m
.27018 .2854 L
s
P
p
0 .4 1 r
.02 w
.58679 .71144 m
.58728 .76118 L
s
P
p
0 .4 1 r
.02 w
.52527 .68432 m
.58679 .71144 L
s
P
p
0 .4 1 r
.02 w
.28122 .28358 m
.27757 .32752 L
s
P
p
0 .4 1 r
.02 w
.21472 .24948 m
.28122 .28358 L
s
P
p
.01 w
.20821 .20836 Mdot
P
p
.2 1 0 r
.02 w
.20821 .20836 m
.20356 .25135 L
s
P
p
.01 w
.21922 .20647 Mdot
P
p
0 .4 1 r
.02 w
.21922 .20647 m
.21472 .24948 L
s
P
p
.2 1 0 r
.02 w
.38884 .53098 m
.39102 .48399 L
s
P
p
.2 1 0 r
.02 w
.32887 .40686 m
.32583 .45292 L
s
P
p
.2 1 0 r
.02 w
.26248 .37444 m
.32887 .40686 L
s
P
p
0 .4 1 r
.02 w
.34008 .40513 m
.27381 .37266 L
s
P
p
.2 1 0 r
.02 w
.26638 .32932 m
.19877 .29553 L
s
P
p
0 .4 1 r
.02 w
.52492 .7345 m
.52527 .68432 L
s
P
p
0 .4 1 r
.02 w
.46292 .60704 m
.46171 .6563 L
s
P
p
0 .4 1 r
.02 w
.39814 .57766 m
.46292 .60704 L
s
P
p
.2 1 0 r
.02 w
.32271 .50027 m
.38884 .53098 L
s
P
p
.2 1 0 r
.02 w
.32583 .45292 m
.32271 .50027 L
s
P
p
.2 1 0 r
.02 w
.25846 .42083 m
.26248 .37444 L
s
P
p
0 .4 1 r
.02 w
.27381 .37266 m
.26995 .41906 L
s
P
p
.2 1 0 r
.02 w
.19877 .29553 m
.12889 .2606 L
s
P
p
0 .4 1 r
.02 w
.46046 .70693 m
.52492 .7345 L
s
P
p
0 .4 1 r
.02 w
.46171 .6563 m
.396 .62733 L
s
P
p
0 .4 1 r
.02 w
.33118 .54728 m
.39814 .57766 L
s
P
p
.2 1 0 r
.02 w
.1888 .38764 m
.25846 .42083 L
s
P
p
0 .4 1 r
.02 w
.26995 .41906 m
.26599 .46677 L
s
P
p
.2 1 0 r
.02 w
.19386 .34094 m
.1888 .38764 L
s
P
p
.2 1 0 r
.02 w
.1229 .30629 m
.19386 .34094 L
s
P
p
.2 1 0 r
.02 w
.12889 .2606 m
.1229 .30629 L
s
P
p
0 .4 1 r
.02 w
.45918 .75901 m
.46046 .70693 L
s
P
p
0 .4 1 r
.02 w
.396 .62733 m
.39379 .67842 L
s
P
p
0 .4 1 r
.02 w
.2619 .51585 m
.33118 .54728 L
s
P
p
0 .4 1 r
.02 w
.26599 .46677 m
.2619 .51585 L
s
P
p
0 .4 1 r
.02 w
.39153 .73099 m
.45918 .75901 L
s
P
p
0 .4 1 r
.02 w
.39379 .67842 m
.39153 .73099 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.292607 0.97619 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.430451 0.149123 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.430451 0.286967 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.498191 2.097 0.0245059 0.980236 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87882 .61174 m
.78846 .56381 L
s
P
p
.2 1 0 r
.02 w
.88591 .6918 m
.87882 .61174 L
s
P
p
.2 1 0 r
.02 w
.7834 .48613 m
.69015 .43471 L
s
P
p
.2 1 0 r
.02 w
.78846 .56381 m
.7834 .48613 L
s
P
p
.2 1 0 r
.02 w
.79374 .64494 m
.88591 .6918 L
s
P
p
.2 1 0 r
.02 w
.69015 .43471 m
.69327 .51333 L
s
P
p
.2 1 0 r
.02 w
.59099 .30448 m
.48962 .24655 L
s
P
p
.2 1 0 r
.02 w
.5919 .38054 m
.59099 .30448 L
s
P
p
.2 1 0 r
.02 w
.69652 .59553 m
.79374 .64494 L
s
P
p
.2 1 0 r
.02 w
.69327 .51333 m
.59285 .46007 L
s
P
p
.2 1 0 r
.02 w
.59285 .46007 m
.5919 .38054 L
s
P
p
.2 1 0 r
.02 w
.48962 .24655 m
.48822 .32337 L
s
P
p
0 .4 1 r
.02 w
.50847 .24332 m
.50751 .32019 L
s
P
p
0 .4 1 r
.02 w
.40185 .182 m
.50847 .24332 L
s
P
p
.2 1 0 r
.02 w
.79926 .72975 m
.69993 .68156 L
s
P
p
.2 1 0 r
.02 w
.80503 .8185 m
.79926 .72975 L
s
P
p
.2 1 0 r
.02 w
.69993 .68156 m
.69652 .59553 L
s
P
p
.2 1 0 r
.02 w
.48822 .32337 m
.37867 .26297 L
s
P
p
0 .4 1 r
.02 w
.50751 .32019 m
.39834 .2596 L
s
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.40185 .182 L
s
P
p
.2 1 0 r
.02 w
.7035 .77169 m
.80503 .8185 L
s
P
p
.2 1 0 r
.02 w
.48676 .40381 m
.48523 .48812 L
s
P
p
.2 1 0 r
.02 w
.37451 .34428 m
.48676 .40381 L
s
P
p
0 .4 1 r
.02 w
.5065 .40067 m
.50545 .48504 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.5065 .40067 L
s
P
p
.01 w
.37867 .26297 Mdot
P
p
.2 1 0 r
.02 w
.37867 .26297 m
.37451 .34428 L
s
P
p
.01 w
.39834 .2596 Mdot
P
p
0 .4 1 r
.02 w
.28278 .19546 m
.39834 .2596 L
s
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.28914 .11718 m
.28278 .19546 L
s
P
p
0 .4 1 r
.02 w
.16981 .04855 m
.28914 .11718 L
s
P
p
.2 1 0 r
.02 w
.70724 .86623 m
.7035 .77169 L
s
P
p
.2 1 0 r
.02 w
.59489 .63059 m
.59598 .72212 L
s
P
p
.2 1 0 r
.02 w
.48363 .5766 m
.59489 .63059 L
s
P
p
.2 1 0 r
.02 w
.48523 .48812 m
.37015 .42962 L
s
P
p
0 .4 1 r
.02 w
.50545 .48504 m
.39078 .42635 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.2761 .27766 L
s
P
p
0 .4 1 r
.02 w
.39078 .42635 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.28278 .19546 m
.16026 .12747 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.28278 .19546 L
s
P
p
.2 1 0 r
.02 w
.59713 .81827 m
.70724 .86623 L
s
P
p
0 .4 1 r
.02 w
.16026 .12747 m
.16981 .04855 L
s
P
p
.2 1 0 r
.02 w
.59598 .72212 m
.59713 .81827 L
s
P
p
.2 1 0 r
.02 w
.48194 .66955 m
.48363 .5766 L
s
P
p
.2 1 0 r
.02 w
.37015 .42962 m
.24801 .36753 L
s
P
p
0 .4 1 r
.02 w
.15022 .21045 m
.2761 .27766 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.26907 .36406 L
s
P
p
.2 1 0 r
.02 w
.36075 .61368 m
.48194 .66955 L
s
P
p
.2 1 0 r
.02 w
.36557 .51931 m
.36075 .61368 L
s
P
p
.2 1 0 r
.02 w
.24008 .45841 m
.36557 .51931 L
s
P
p
.2 1 0 r
.02 w
.24801 .36753 m
.24008 .45841 L
s
P
p
0 .4 1 r
.02 w
.26907 .36406 m
.13964 .29782 L
s
P
p
0 .4 1 r
.02 w
.13964 .29782 m
.15022 .21045 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.430451 0.424812 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.430451 0.562657 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.430451 0.700501 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.308424 1.71627 0.0252773 1.01109 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.91024 .71077 m
.85823 .67661 L
s
P
p
.2 1 0 r
.02 w
.91443 .76965 m
.91024 .71077 L
s
P
p
.2 1 0 r
.02 w
.85467 .61866 m
.80176 .58313 L
s
P
p
.2 1 0 r
.02 w
.85823 .67661 m
.85467 .61866 L
s
P
p
.2 1 0 r
.02 w
.86187 .73592 m
.91443 .76965 L
s
P
p
.2 1 0 r
.02 w
.80176 .58313 m
.80474 .64148 L
s
P
p
.2 1 0 r
.02 w
.74504 .48922 m
.68968 .45125 L
s
P
p
.2 1 0 r
.02 w
.74735 .54659 m
.74504 .48922 L
s
P
p
.2 1 0 r
.02 w
.8078 .70123 m
.86187 .73592 L
s
P
p
.2 1 0 r
.02 w
.80474 .64148 m
.74972 .60534 L
s
P
p
.2 1 0 r
.02 w
.74972 .60534 m
.74735 .54659 L
s
P
p
.2 1 0 r
.02 w
.68968 .45125 m
.69137 .509 L
s
P
p
.2 1 0 r
.02 w
.86559 .79665 m
.81092 .76242 L
s
P
p
.2 1 0 r
.02 w
.86941 .85885 m
.86559 .79665 L
s
P
p
.2 1 0 r
.02 w
.81092 .76242 m
.8078 .70123 L
s
P
p
.2 1 0 r
.02 w
.69137 .509 m
.63374 .4703 L
s
P
p
.2 1 0 r
.02 w
.81412 .82511 m
.86941 .85885 L
s
P
p
.2 1 0 r
.02 w
.69309 .56815 m
.69486 .62876 L
s
P
p
.2 1 0 r
.02 w
.63478 .52985 m
.69309 .56815 L
s
P
p
0 .4 1 r
.02 w
.70421 .5661 m
.70611 .62674 L
s
P
p
0 .4 1 r
.02 w
.64602 .52775 m
.70421 .5661 L
s
P
p
.01 w
.63374 .4703 Mdot
P
p
.2 1 0 r
.02 w
.63374 .4703 m
.63478 .52985 L
s
P
p
.01 w
.64484 .46817 Mdot
P
p
0 .4 1 r
.02 w
.64484 .46817 m
.64602 .52775 L
s
P
p
.2 1 0 r
.02 w
.8174 .88936 m
.81412 .82511 L
s
P
p
.2 1 0 r
.02 w
.75464 .72718 m
.75719 .79037 L
s
P
p
.2 1 0 r
.02 w
.69667 .69088 m
.75464 .72718 L
s
P
p
.2 1 0 r
.02 w
.69486 .62876 m
.63584 .59089 L
s
P
p
0 .4 1 r
.02 w
.70611 .62674 m
.64722 .58881 L
s
P
p
0 .4 1 r
.02 w
.64602 .52775 m
.58607 .48823 L
s
P
p
0 .4 1 r
.02 w
.64722 .58881 m
.64602 .52775 L
s
P
p
.2 1 0 r
.02 w
.7598 .85515 m
.8174 .88936 L
s
P
p
.2 1 0 r
.02 w
.75719 .79037 m
.7598 .85515 L
s
P
p
.2 1 0 r
.02 w
.69852 .75457 m
.69667 .69088 L
s
P
p
.2 1 0 r
.02 w
.63584 .59089 m
.57504 .55187 L
s
P
p
0 .4 1 r
.02 w
.58607 .48823 m
.5243 .44751 L
s
P
p
.2 1 0 r
.02 w
.63805 .71767 m
.69852 .75457 L
s
P
p
.2 1 0 r
.02 w
.63694 .65348 m
.63805 .71767 L
s
P
p
.2 1 0 r
.02 w
.57536 .61492 m
.63694 .65348 L
s
P
p
.2 1 0 r
.02 w
.57504 .55187 m
.57536 .61492 L
s
P
p
0 .4 1 r
.02 w
.58653 .54973 m
.58701 .6128 L
s
P
p
0 .4 1 r
.02 w
.52397 .50943 m
.58653 .54973 L
s
P
p
0 .4 1 r
.02 w
.5243 .44751 m
.52397 .50943 L
s
P
p
0 .4 1 r
.02 w
.58701 .6128 m
.52363 .57297 L
s
P
p
0 .4 1 r
.02 w
.52397 .50943 m
.45944 .46787 L
s
P
p
0 .4 1 r
.02 w
.52363 .57297 m
.52397 .50943 L
s
P
p
0 .4 1 r
.02 w
.45944 .46787 m
.39284 .42498 L
s
P
p
0 .4 1 r
.02 w
.45824 .53187 m
.45701 .59759 L
s
P
p
0 .4 1 r
.02 w
.39073 .48944 m
.45824 .53187 L
s
P
p
0 .4 1 r
.02 w
.39284 .42498 m
.39073 .48944 L
s
P
p
0 .4 1 r
.02 w
.45701 .59759 m
.38855 .55566 L
s
P
p
0 .4 1 r
.02 w
.39073 .48944 m
.32099 .44561 L
s
P
p
0 .4 1 r
.02 w
.38855 .55566 m
.39073 .48944 L
s
P
p
0 .4 1 r
.02 w
.32099 .44561 m
.24892 .40032 L
s
P
p
0 .4 1 r
.02 w
.31781 .51232 m
.31454 .58092 L
s
P
p
0 .4 1 r
.02 w
.24467 .46752 m
.31781 .51232 L
s
P
p
0 .4 1 r
.02 w
.24892 .40032 m
.24467 .46752 L
s
P
p
0 .4 1 r
.02 w
.31454 .58092 m
.24029 .53665 L
s
P
p
0 .4 1 r
.02 w
.24467 .46752 m
.169 .42117 L
s
P
p
0 .4 1 r
.02 w
.24029 .53665 m
.24467 .46752 L
s
P
p
0 .4 1 r
.02 w
.169 .42117 m
.09068 .37319 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.430451 0.838346 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.16362 .21754 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
0 .4 1 r
.02 w
.16362 .21754 m
.15169 .31032 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.139 .40899 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.430451 0.97619 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.568296 0.149123 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.568296 0.286967 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.568296 0.424812 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.869129 2.80349 0.00816909 0.96764 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8464 .45732 m
.74267 .41514 L
s
P
p
.2 1 0 r
.02 w
.85169 .52088 m
.8464 .45732 L
s
P
p
.2 1 0 r
.02 w
.73917 .35313 m
.6329 .30869 L
s
P
p
.2 1 0 r
.02 w
.74267 .41514 m
.73917 .35313 L
s
P
p
.2 1 0 r
.02 w
.74629 .47929 m
.85169 .52088 L
s
P
p
.2 1 0 r
.02 w
.6329 .30869 m
.63463 .37122 L
s
P
p
.2 1 0 r
.02 w
.52238 .2015 m
.40899 .15281 L
s
P
p
.2 1 0 r
.02 w
.5222 .26239 m
.52238 .2015 L
s
P
p
.2 1 0 r
.02 w
.63643 .43595 m
.74629 .47929 L
s
P
p
.2 1 0 r
.02 w
.63463 .37122 m
.52202 .32543 L
s
P
p
.2 1 0 r
.02 w
.52202 .32543 m
.5222 .26239 L
s
P
p
.2 1 0 r
.02 w
.40899 .15281 m
.4068 .21413 L
s
P
p
.2 1 0 r
.02 w
.75003 .54569 m
.63829 .503 L
s
P
p
.2 1 0 r
.02 w
.75391 .61446 m
.75003 .54569 L
s
P
p
.2 1 0 r
.02 w
.63829 .503 m
.63643 .43595 L
s
P
p
.2 1 0 r
.02 w
.4068 .21413 m
.28638 .16377 L
s
P
p
.2 1 0 r
.02 w
.64021 .57249 m
.75391 .61446 L
s
P
p
.2 1 0 r
.02 w
.40453 .27766 m
.40218 .34353 L
s
P
p
.2 1 0 r
.02 w
.28184 .22778 m
.40453 .27766 L
s
P
p
0 .4 1 r
.02 w
.42605 .27502 m
.4241 .34091 L
s
P
p
0 .4 1 r
.02 w
.3037 .22501 m
.42605 .27502 L
s
P
p
.01 w
.28638 .16377 Mdot
P
p
.2 1 0 r
.02 w
.28638 .16377 m
.28184 .22778 L
s
P
p
.01 w
.30785 .16098 Mdot
P
p
0 .4 1 r
.02 w
.30785 .16098 m
.3037 .22501 L
s
P
p
.2 1 0 r
.02 w
.64221 .64457 m
.64021 .57249 L
s
P
p
.2 1 0 r
.02 w
.52163 .45843 m
.52143 .52865 L
s
P
p
.2 1 0 r
.02 w
.39974 .41186 m
.52163 .45843 L
s
P
p
.2 1 0 r
.02 w
.40218 .34353 m
.27713 .29419 L
s
P
p
0 .4 1 r
.02 w
.4241 .34091 m
.29939 .29146 L
s
P
p
.2 1 0 r
.02 w
.52122 .60153 m
.64221 .64457 L
s
P
p
.2 1 0 r
.02 w
.52143 .52865 m
.52122 .60153 L
s
P
p
.2 1 0 r
.02 w
.3972 .4828 m
.39974 .41186 L
s
P
p
0 .4 1 r
.02 w
.42206 .40928 m
.41995 .48025 L
s
P
p
0 .4 1 r
.02 w
.29492 .36045 m
.42206 .40928 L
s
P
p
.2 1 0 r
.02 w
.27713 .29419 m
.14632 .24258 L
s
P
p
0 .4 1 r
.02 w
.29939 .29146 m
.29492 .36045 L
s
P
p
.2 1 0 r
.02 w
.26716 .4348 m
.3972 .4828 L
s
P
p
0 .4 1 r
.02 w
.41995 .48025 m
.29028 .43213 L
s
P
p
.2 1 0 r
.02 w
.27224 .36315 m
.26716 .4348 L
s
P
p
.2 1 0 r
.02 w
.13875 .31215 m
.27224 .36315 L
s
P
p
.2 1 0 r
.02 w
.14632 .24258 m
.13875 .31215 L
s
P
p
0 .4 1 r
.02 w
.41776 .55399 m
.41548 .63066 L
s
P
p
0 .4 1 r
.02 w
.28545 .50668 m
.41776 .55399 L
s
P
p
0 .4 1 r
.02 w
.29028 .43213 m
.28545 .50668 L
s
P
p
0 .4 1 r
.02 w
.41548 .63066 m
.28042 .58426 L
s
P
p
0 .4 1 r
.02 w
.4131 .71044 m
.41063 .79351 L
s
P
p
0 .4 1 r
.02 w
.27518 .66505 m
.4131 .71044 L
s
P
p
0 .4 1 r
.02 w
.28042 .58426 m
.27518 .66505 L
s
P
p
0 .4 1 r
.02 w
.41063 .79351 m
.26973 .74928 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.568296 0.562657 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.8811 .50206 m
.78086 .44927 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.8811 .50206 L
s
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.90676 .7578 m
.89777 .66825 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.90676 .7578 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.91622 .85211 m
.80614 .80506 L
s
P
p
0 .4 1 r
.02 w
.9262 .95156 m
.91622 .85211 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.81335 .90655 m
.9262 .95156 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.81335 .90655 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56304 .80672 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.42373 .75116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.27351 .69125 m
.42373 .75116 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.27351 .69125 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.568296 0.700501 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.67141 .31411 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.568296 0.838346 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.43789 .35572 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43123 .54175 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.568296 0.97619 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.8811 .50206 m
.78086 .44927 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.8811 .50206 L
s
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.89777 .66825 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.90676 .7578 m
.79931 .70898 L
s
P
p
0 .4 1 r
.02 w
.91622 .85211 m
.90676 .7578 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.9262 .95156 m
.91622 .85211 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.81335 .90655 m
.9262 .95156 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.81335 .90655 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.69258 .85839 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43123 .54175 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.42373 .75116 m
.56304 .80672 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.27351 .69125 m
.42373 .75116 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.27351 .69125 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
P
MathSubEnd
P
% End of sub-graphic
p
/Times-Italic findfont 18 scalefont setfont
[(Fractals)] .02381 .57389 -1 0 Mshowa
P
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{413, 256},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006M000100P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0WP00003obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002M
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/10000
0?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040
003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002M
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/10000
0?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040
003o^d6k0/H01;_6a/IF^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00@l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00/H0F<^ka[_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/10000A;/00iG6o`03^`:E8k/00iG6aP02^`:E9;/00iG6aP02^`:E
9;/00iG6aP02^`:E9;/00iG6aP02^`:E9;/00iG6aP02^`:E7[/2aP05^lJk^lH0EK/1000004O;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iG6U@02aP03^iFk00:E02C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^EaYD2aP03
UK^E00:E02Bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^EaYD2aP03UL^E00:E02C;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^EaYD2aP03UK^E00:E02Bkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk^EaYD2aP03UL^E00:E02C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^EaYD2aP03UK^E00:E026kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk/00/H0E<_6
a/K;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`400014^`06ULJk^iG61;/00iFk^`0N^`06ULJk^iG61;/00iFk
^`0N^`06ULJk^iG61;/00iFk^`0N^`06ULJk^iG61;/00iFk^`0N^`06ULJk^iG61;/00iFk^`0N^`06
ULJk^iG61;/00iFk^`0K^`03a[^k00:k0/H2^`03a[^k04fk0@000015bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E00;600>kbiD0
0/H09<^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;U@;602W;^iG6bk_;UL^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kU@02aP03^l^E00;602C;^iFkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbiD2aP03bk^E00;602BkbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^iD2aP03^l^E00;602C;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiD2aP1nbk^Ea/^k
biG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l^kblK;^l_6bk_;a/^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
0@0003jk0YD6^`03ULK600>k0lHJ^`:E1[/01IG6a[_600>k00>E^k/06;/2U@Jk00>Ea/H00k/3aQZk
0YD5^`07aYG6a[_6^`03aQZk0YD6^`03ULK600>k0lHJ^`:E1[/01IG6a[_600>k00>E^k/06k/00lJk
^`08^`G6BK/10000043;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^iFk0YD03L^kbk_;^iG6bk_;^iD00/H06[_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbiG;0YD01k_;^l^kbiD00/H08<^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFk0YD0:L^k
bk_;^iG6bk_;^iG6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;00:E00Nkbk_6^l^E00;6023;^l^E
a[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^`:E02W;^l^kbk^Ea/^kbk^Ea/^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^Eb`02U@07^l^kbk_;U@02aP04bk_;U@;607C;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l_6bk_;^l^kbk_;^l^kblK;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40000n^`04UK^k^`:E1K/00iG6^`02^`03
UK^k00;65[/019Fk^k/2U@Fk00>Ea[/00[/00iFk^`0H^`04UK^k^`:E1K/00iG6^`02^`03ULJk01Rk
00BE^k^k0YD00k_6^`02^`03ULK600:k00>Ea[/06;/019Fk^k/2U@Fk00>Ea[/00[/00iG6^`0H^`04
UK^k^`:E1K/00iG6aP02^`03ULJk00;66K/00lJk^`0=^`03a[^k04Jk0@000014bk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk/2U@0Y
bk_;ULJkbk^E^l^kblK;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l/00YD0:[_;^iFkbk_;UL^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kU@;600bkbiG6^l^kULK;^l/2aP0K^l^kbk_;^l^kbk_;
^l^kbk_;^iFkbk_;^l^E00;600G;^iG6b`04aP0P^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;
^iD2aP0<^l^Ea[_;^iG6bk_;0/H06k_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;U@02aP05bk^Ea//0
1<H0;;_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^l^kbk_;^l^kbk_;0/H0Ak_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k0040000m^`:E1k/2U@03^iG600>k00>E^k/00[/00lJE^`0B^`:E1k/2U@03^iFk00>k00BE^k^k
0YDD^`:E1[/00lJEaP03aP>k00REa/JkULJkaQ:k0YD7^`03ULK600;60k/019G6^k/2UABk0YD6^`03
aYG600?60k/029G6a[^Ea[_64[/2U@Jk00?6ULH00lH3^`06ULK6^iG65k/2aPnk00Co^lJEAK/10000
03o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00YD01k_;^l^kbk/00YD01<Jkbk/2U@05bk_;a//00YD04k_;^l^kbk_;^l^kbk_;^l^kbk/0
0YD01l^kbk_;^l/00YD01;_;^l/2U@04^l^Eb`>E01?;^l^kbk_;^l^kbk_;^l^kbk_;00:E00Nkbk_;
a/^k00:E00C6^l^k0YD01<_6ULH2U@0Da[_;^l^kbk_;^l^kbk_;^l^kbk/2U@07bk_;^l^kb`02U@;6
00RkbiG6^l^Eb`>E01?;^l^kbk_;^l^kbk_;^l^kbk_;00:E00Nkbk_;a/^k00:E00C6^l^k0YD01<_6
ULH2U@0Da[_;^l^kbk_;^l^kbk_;^l^kbk/2U@07bk_;^lJkb`02U@;600RkbiG6^lJEaP>E01K;^l^k
bk_;^l^kbk_;^l^kbk_;^l^k0/H03L^kbk_;^l^kbk_;^l/00lH0A/^Ebk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000@K/2U@Jk
00>Ea[/01;/3U@05a[^k^iD05;/2U@Jk00>E^k/01;/4U@>k00>E^k/04[/2U@03^lJk00>k00>E^k/0
1;/2U@;60k/00lJk^`0B^`:E1[/00iFk^`02aP03^lJE00>E0k/00iFk^`0B^`:E00>ka[/00k/00iFk
^`04^`:E0/H3^`03a[^k01:k0YD00k_6^`03^`03ULJk00;600BkaYFE0/H3^`03UK^k01Fk00?6^k/0
2[/01LJka[^E04Bk0@00003?bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_6^l^kbk_;^l_6bk_;UL^kbk_;^l^kbk_;^l^k
bk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kUK_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkbk_;^l^k
bk_;^l^kblK;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;00;604Zkbk^E^l^kUK_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^Ea[_;^l^kbk_;^l^kbk_;a/^kblK;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kU@?600O;^l_6bk_;00;601^kbk_6^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk/00lH02k_6^l^kbk_;
^l^k00:E04[;a/JkbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`400013^`03UK^k00Bk00?6^k/01[/01LJk^k^E01Jk00>E^k/0
4K/00iFk^`0D^`03ULJk016k00>Ea[/05;/00iFk^`09^`03a[^k00Fk00>E^k/05;/00iG6^`0A^`03
ULJk01Bk00BE^k^k1<H4^`;61[/00iFk^`0A^`04a[^kaPZk00>E^iD00[/00lJkU@14^`400000B/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^Ebk_;^l^E0/H02l^kbk_;^l^ka[_;00:E01^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk/0
0YD03<^kbk_;^l^kbk_;^`:E01c;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ea[_;^l^E0/H0:<^kbk_;^l^k
bk_;ULJkbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk/2U@0<bk_;^l^kbk_;^l^k0YD07<^kbk_;^l^k
bk_;^l^kbk_;^l^kbiG6^l^kbiD2aP0`bk_;^l^kbk_;^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^iFk
bk_;^iG6bk_;^lJk0lH00k_;^`02U@0Bbk_;^l^kbk_;^l^kbk_;^l^k0lH02k_;^l^kbk_;^l^k00:E
00G;UIG6b`04U@11^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/00@0004>k00>E^k/00k/00iFkU@02aPFk00>Ea/H00k/2UA>k00>E^k/0
0k/019FkUID6^`:E1;/2UA>k00>Ea[/00k/00iG6U@02aPFk00>Ea/H00[/00lJEU@0C^`03UK^k00>k
00BE^iFE1[/2U@Bk0YDC^`03ULJk00>k00>EaYD00/H5^`03ULK600:k00?6UID04k/00iFk^`03^`04
UK^EU@:k00K6^k^kULH4^`:E4k/00lJk^`0:^`04UK^kaP>k00>E^iD0@;/1000004?;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00>E
013;^l^Ebk_;ULJkbk_;UL^E0/H05/^kbiG;^l^kbk_;^l^kbk_;^l^kbk/3U@0?^l^kUK_;^iFkbk_;
^iFk00:E01S;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbiD3aP0?^l^Ea[_;ULJkbk_;ULJE00?601FkbiG;
^l^kbk_;^l^kbk_;^l^kbk/00iD03k_;^iFkbk^E^l^kbk^E^`02U@0Hbk_;^iFkbk_;^l^kbk_;^l^k
bk_;^l^E0lH03k_;ULJkbiG6^l^kbiG6U@03aP0E^l^Ebk_;^l^kbk_;^l^kbk_;^l^k00>E00nkbk^E
^l^kUK_6^l^kULH00YD0K/^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;a/^kbk_;^l^kbk_;^l^EblK;^l^k
biG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0@0004Jk19D4^`03ULK600:k00JE^k^kULH2^`03UK^k01>k19D4^`03UK^k00:k00BE^k^k
0YD2^`03UK^k01>k00>Ea/H00/H3^`03ULJk00:k00JEa[^kULH2^`03UK^k01>k19D4^`03UK^k00:k
00BE^k^k0YD2^`03UK^k01>k00>Ea/H00/H3^`03ULJk00:k00JEa[^kULH2^`03UK^k01>k19D4^`03
ULK600:k00BEa[^k0YD2^`03UK^k012k00?6^k/00lH8^`04UK^EaP>k00BE^iFE?[/10000057;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;UL^kbk^E^l/00lH01L^kbk_600>E02S;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^k
biG;^l^kUK_;^l^k0iD0:;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^kULK;^l^Ea[_;^l/3U@0X
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^Ebk_;^iFkbk_;^`>E02Rkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^Ea[_;^iG6bk_;ULJkbk_;0iD08<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;UL^k
1<H01<^kbk/3U@0B^l^kbk_;^l^kbk_;^l^kbk_;1<H02[_;a/Jkbk_;^l/3U@04aYG;^`:E043;^iFk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
0@0004jk00>E^k/00[/00iG6aP02^`04a[^kUAfk00>E^k/00[/2U@Jk00>E^k/06k/00iG6^`02^`03
ULK600Fk00>E^k/06k/00iFk^`02^`:E1[/00iFk^`0K^`03ULJk00:k00>Ea/H01K/00iFk^`0K^`03
UK^k00:k00>Ea[/01K/00iFk^`0C^`03a[^k00:k00C6^k^k0/H2^`03ULK600:k00>E^iD00YDm^`40
0000E/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^E0lH09k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;UL^kbk_;^`02U@0Sbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD00/H01K_;
^l^E00;602S;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^k0YD08l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E00;600Fkbk_;U@02aP0Xbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;UL^kbk_;^`:E023;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`C6
04[;a/^kbk_6^l^Ebk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`40001>^`03UK^k00Jk00>Ea[/07k/00iFk^`06^`03UK^k01nk00>E^k/0
0/H4^`03ULJk01nk00>E^k/01[/00iFk^`0O^`03UK^k00;61;/00iG6^`0O^`03UK^k00Jk00>E^k/0
8;/00lJkaP02^`?60k/00iFk^`0m^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbiG;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kUK_;^l_6bk_;ULJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^k
bk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kb`00E<^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iFkbk_;^`;600Fka[_6^`03U@0o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040001>^`03UK^k00:k0YD2^`03UK^k01nk00>E^k/0
0[/2U@:k00>E^k/07k/00iFk^`02^`06ULK6^iG68;/00iFk^`02^`:E0[/00iFk^`0O^`03UK^k00:k
00JEa/JkULHP^`03UK^k00:k0YD2^`03UK^k02Bk0/H01[^EUIFkUCnk0@00001Ebk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kUK_;^l^Eb`04U@0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^iFk00BE
02S;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;UL^E0lH09k_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk^E^`04U@0Xbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk^E^l^kbiG;U@?602Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kUK/019D0K<^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^iFkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40001>^`:E0k/00iFk
^`02^`03UK^k01jk0YD3^`03UK^k00:k00>E^k/07[/2U@>k00>E^k/00[/00lJk^`0N^`:E0k/00iFk
^`02^`03UK^k01jk0YD3^`03UK^k00:k00?6^k/07[/2U@>k00>E^k/00[/00iFk^`1Z^`400000D<^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^k19D09l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`04U@0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00BE02O;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/019D09k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^`04U@0Wbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00BE
076kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000
Dk/00iFk^`0X^`03UK^k02Rk00>E^k/0:;/00iFk^`0X^`03UK^k02Rk00>E^k/0Kk/100000?o;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk
0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`400000`L^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0/H0:K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;60:k;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000`K/00lJkaP0X^`03
a[_60:fk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kblK;^l_6bk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`010000`;/2aP>k00?6^k/08k/2aP>k00?6^k/0Dk/00iG6^`02^`>EC[/100000<;;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`;602W;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02aP1I
^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULH019D0D<^kUIG;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004Zk
0/Ih^`;61;/2aR>k0/H4^`;69;/2aP03^lK602Jk00>Ea/H00[/01IFk^k^E04bk0@00001<bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_6^`?6052kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^Ea/^kb`:E01nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^k00;600?;^l/00/H09;_;^lJka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;6
00>kbk/00/H0:l^kblK;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a//00/H08[_6
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/4U@04^l^kU@;6056kbk_;UL^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00@0004Zk00?6^k/00[/00lJk^`18^`07ULJEUK^E^`03UAbk00O6^lK6^lJk00?60k/00lJk
^`0K^`07a[_6a[_6^`03aP>k00?6^k/08;/3aP03^lK6022k00BE^k^k0iD3^`05a[^k^iD0C;/10000
04G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^iD00/H00k_;U@02aP1Bbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^`:E02C;^l^kUK_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk/2aP0Ybk_;a_nkbiG6^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kblK;^l/00/H0;;_;^lKobk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;
1<H08;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;19D00k_;^`02U@05blK;^l/00iD0B/^E
UIG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0@0004Bk00>EaYD00/H00iFkU@04aTZk00>Ea[/00[/00iFk^`02^`03UK^k01Rk
00?6^k/00k/2aP:k00K6^lK6ULH2UAVk00?6^k/00k/2aP:k00K6^lK6ULH2UB2k0/H2^`03a[^k02:k
0YD3aP03ULJk00Fk0YD2^`:EA;/1000009C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk^Ea/^kbk^Ea/^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0YD01/^k
bk_;^`:E027;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00/H01[_;^l_6b`?600?;^iD0
0/H06k_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02aP06bk_;^lJk0lH00k_;U@02aP0Sbk^E^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01LH0:<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^iG6bk/2aP1@bk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000A;/00iG6^`02^`03ULK600:k
00>Ea[/0@k/019FkUID6^`03UK^k00>k00>E^k/06[/4aPBk0/H2^`05ULJk^iD06[/4aPBk0/H2^`05
ULJk^iD06;/00lJk^`08^`03a[_602>k00JEa/K6UK/3U@Bk0YD2^`>E@[/1000004G;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD0
0/H01K_;^lJk00C600?;^l/00/H0@k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk/00YD0<L^kbk_;UL^kbk^E^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^lJEbk_;aYD00/H0:K_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l_6UK_;^lJE00;601g;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02aP03^l^k00;602k;^l^k
bk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E0/H02L^kbiG;^l^Eb`02U@03
^l^k00:E043;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0@0003jk0YD6^`03ULK600;60k/00iG6aP02^`04a[_6aQ6k0/HY^`03UK^k00Bk
0YD3^`03UK^k00:k00>E^k/07K/00iFkU@02^`05a[^EULH00k/00iFk^`0K^`03UK^E00:k00G6^iFE
aP03^`03UK^k01Fk0/H00k_6aP02aP03^lJk00:k0lH4^`03a[^k026k00G6^k^kU@03^`:E0[/3U@03
^iFk03nk0@000010bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk^E^`>E00jkbk_;^l^Ea[_;^iG6b`?601_;^l_6bk_;^l^kbk_;^l^kbk_;^l^k
a[_;^l/00/H08[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2U@07^l^kbk_;^`02U@0:
biG;^l^kUK_;^`:E06c;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbiG;a/^kbiG6^l^Ebk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk^E^lJkbk^Ea/^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/2aP05bk_6a//01<H01[_6^l^kb`;602cobiFE^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
a/^kbiG;^l^kb`:E00>kbk/00YD0@<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000?K/00iFk^`03^`>E0k/00iFk^`02^`05ULJk^iD0
0/H2^`03a[^k016k00C6^k^k1<H3^`03a[^k01bk0YD7^`:E1;/2U@:k00>E^iD00YDF^`03UK^k00:k
00>Ea/H00[/01IG6^k^E00>k0YDG^`03UK^k00:k00>Ea/H00[/01IG6^k^E00>k0YDE^`C600>ka[/0
0[/01<Jk^lH3^`C600>E^iD06;/2aP>k00G6^k^kU@03^`>E00>kUK/0@k/1000003g;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00>E00K;^l^k
bk/4U@05bk_;^iD00/H01;^E^iD3aP0Ebk_;^l^kbk_;^l^kbk_;^l^kblK;00;600NkblK;a/^k00?6
01jkbk_6^l^kbonE^l^kbk_;^l^kbk_;^l^kbk_;^l/2U@0=^l^kbk_;UL^kbk_;^`04U@0Ibk_;UL^k
bk_;^l^kbk_;^l^kbk_;^l^kb`02U@06^l^kbk^E1<H02;_;UIFkbiG;0YD05K_;^l^kbk_;^l^kbk_;
^l^kbk_;^`02U@06bk_;^l^E1<H02<^kUIG;^iFk0YD05/^kbk_;^l^kbk_;^l^kbk_;^l_6bk/2aP0/
blK;^lJkbk_6^l_6blK;a/^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[/4aP03bk_;00>E00C;UL^k
0YD0A<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0@00042k0iD6^`03UK^k00>k00C6ULK61;/00lJk^`0A^`04a[_6^`C600Nka/Jk
a[_600:k0lH2^`03aYFE01Fk00>E^k/03K/01IFk^k^E01Nk0iD5^`03ULJk00>k0iD3^`03UK^k01Bk
0iD5^`03ULJk00>k0iD3^`03UK^k012k1<H01;_6a[/3aP:k00?6^iD01LH00k^E^`0G^`;60k/00lJk
^`04^`:EB;/10000077;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk_;a/^kULK;^l^Ebk_;^l^kbk_;^l^kbk_;^l^k
blK;a/^kb`02aP03^lJk00;600O;a/K6blK;00?60YD0U/^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^k
bk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^kbiG;^l^E
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_;^l^kbk^E^l^kUK_;^l^kbk_;^l^kbk_;^l^k
bk_;^`;600S;a/^kbk_6^`?600>kblH00lH06iG;UIFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03aP1A
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k00400013^`03UK^k00Vk0/H2^`05a[^k^iD04k/3aPBk00?6^lH0
0[/01LJka/Jk00;600>ka/H00/H00iFkU@0C^`03UK^k00>k0YD<^`:E6K/00iFk^`0>^`03UK^k01Nk
00>E^k/03[/00iFk^`0E^`;61;/3aP03^iG600;600Bka[_60YD00k^E^`0H^`03a[^k04jk0@00001A
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbiG;^l^kbk_;^l^kbk_;00?600?;^l/00YD06K_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kbk/0
0lH01;_;^l/2aP04^l^kb`;600>kULH00iD06[_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbiG;0YD01[_;
^l^kb`:E00Bkbk_;0YD0:;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l/2U@0Y
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk/00YD09/^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;a/^kbk_6^lJkbk_;a/^k0/H0K/^EbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^k0@0004>k00>E^k/00k/2U@Nk00>Ea[/01;/2UAVk00?6^k/00[/2aPBk
0/H3U@:k00>E^k/04;/3U@>k00FE^k^kU@05^`04UK^EU@Bk00>E^k/05;/00iFk^`02^`:E1[/2U@Bk
00>E^k/05K/00iFk^`02^`:E1[/2U@Bk00>E^k/06K/00lJk^`04^`05UK^EULH00k/2UARk00?6^k/0
C[/1000004?;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00:E00Jkbk_;UL/3U@06bk_;^iFk0iD0:;_;^l^Ebk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^ka[_;^l/2aP:E00>kUID00YD05<^kbk_;^l^kbk_;^l^kbk_;^l^k19D03L^k
bk^E^l^kbiG;^l/00YD06K_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00YD01L^kbiG;00:E00Jkbk_;
UL/2U@0J^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2U@05^l^kUK/00YD01/^kbk^E^`:E023;^l^E
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^`?600>kbiD00YD00l^Eb`02U@0E^l^Ebk_;^l^kbk_;
^l^kbk_;^l^k00C605;;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004Fk19D5^`05UK^k^iD01;/2U@:k
00>E^k/09;/01YFkUIFkUANk00>E^k/00[/00iFk^`02^`03UK^k00>k0iDH^`BE0k/01IFk^k^E00>k
0YD00k^E^`0G^`BE0k/01IFk^k^E00>k0YD00k^E^`0J^`;60[/2aP:k00JE^iFkUK/3UA:k00C6^k^k
0/I@^`400000FL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^iFkbk_;UL^kbk_;00>E02S;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0iD08[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;
^l/2U@0`^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^Ebk_;UL^kbk_;0iD0:<^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^iFkbk^E^l^kbk/3U@0K^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^k00C600O;a/^kbiG;00:E01FkbiG;^l^kbk_;^l^kbk_;^l^kbk/00/H0E<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`40001>^`03UK^k00:k0YD6^`03UK^k02Jk0iDM^`03UK^k00Bk0YDT^`04
UK^k^`:E1[/00iFk^`0L^`04UK^k^`:E1[/00iFk^`0I^`03a[^k00?60k/00iFkU@02UAJk0lIA^`40
0000EL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l/00YD0P;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;
UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;0YD0:K_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^k00:E023;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`C600G;a/^kb`03U@1/biG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0@0004jk00>E^k/01[/00iFk^`1:^`03UK^k00Jk00>E^k/08K/00iFk^`05^`03UK^k022k
00>E^k/01K/00iFk^`0M^`03a[^k00?61K/00iFk^`0I^`03a[^k04jk0@00001Cbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kUK_;^l/00YD0E;_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kb`:E02ZkbiG;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l/2U@0Y^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^iFkbk/00YD08/^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/4aP1dblK;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000C[/00iFk
^`02^`03UK^E00:EC;/00iFk^`02^`03UK^E00>E8[/01YFk^k^E^`>E8[/01YFk^k^E^`>E8[/00lJk
^`0L^`C600>ka[/0Ck/1000004k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2U@1Dbk_;UL^kbiG;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0YD0:l^kbiG;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD0:K_;
UL^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00:E04c;^iFkbk^E^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
0/H0D<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@00052k19EB^`BE:K/4UBNk19FJ^`400000ol^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/10000
0?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040
003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002M
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000U[/2aRVk0/KI^`400000ol^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l_6blK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJka[_;^l/00@0009Fk
00G6^k^kaP0V^`05a[^k^lH0ek/1000009G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02aP0Y
^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00/H0f/^kblK;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0009Nk0/H00k_6^`0V^`;600>ka[/0eK/1000009W;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00/H01;_;^l/2aP0S^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/00/H01<^kbk/2aP3@bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40
0014^`03ULKo00>k0YDS^`03ULK600:k0YDO^`;60k/2aP>k00?6^lH07[/2aP>k0/H3^`03a[_602>k
00>Ea/H00[/2UB6k00?6olH00YDY^`03ULJk00:k0YE?^`400000Al^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULJE00;600>kUK/0
0YD09<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6U@;600>E^iD00YD07[_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_6b`;600>ka[/00lH08k_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^lJk00;600?;a//00lH0:L^kblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
ULJE00;600>EbiD00YD08L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkb`02aP03UL^k00;6
02K;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^EaP:E00?;UL/00iD0C<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/10000A;/01YG6^k^EaPBk00>E^k/07[/01YG6^k^EaPBk00>E^k/06K/01<Jk^k/2aP>k
00K6ok^kULHL^`04a[^k^`;60k/01/Ko^k^EaR6k00JEa[^kULH4^`03UK^k01Rk0YD01;_6a/H2^`05
a[^ka[/00lHQ^`04ULJk^`:E1;/00iFk^`19^`400000AL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kU@02aP03^l^E00;602C;^iFk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiD2aP03bk^E00;602>kbiG;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^lJkbk_;^`02aP04bk_6^`;602>EaYFEbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
blK;^l^kb`02aP04^l_6b`;602BEaYFE^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD2aP0b
^l^Ea[_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;UL^kULK;ULJka[_;^l/2aP1e^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk_;UL^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040000n^`:E
1[/00iG6aP03^`?61;/2aQBk0YD6^`03ULK600>k0lHJ^`;61;/00lJkaP02aP:k00>Ea/H00[/00iFk
^`0F^`;61;/00lJkaP02aP:k00>Ea/H00[/00iFk^`0F^`:E1[/01IG6a[_600>k00>E^k/06;/2U@06
^iFEULJk0/H00iG6U@05^`03a[^k01Jk0YD6^`:E1[/00iFk^`19^`400000@<^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK/2U@0Ybk_;^l^k
ULK;^l^kULK;^l_6blK;^l^kbk_;^l^kbk_;^l^kbk_;UL/00YD03K_;^l^kbiG6^l^kbiD00/H06/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k1<H01<^kbk/2aP0Qbk^Ea/^kUK_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;00C600Bkbk_;0/H08K_;ULJkbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^`02U@07
bk_;^l^kU@02aP04^l^kU@;601jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^iD2aP0>^iG6a[^E
^l^kblK;^l/2aP0E^l^kbk_;^l^kbk_;^l^kbk_;^iFk00:E05S;^l^kbk^E^l^kbk^E^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0@0003jk00BE^k^k0YD5^`03ULK600:k00>Ea[/00[/01<Jk^lHB^`04UK^k^`:E1K/00iG6
^`02^`03UK^k00;66k/00lJE^`02^`04a[_6aPBk00>E^k/06k/00lJE^`02^`04a[_6aPBk00>E^k/0
5[/019Fk^k/2U@Fk00>Ea/H00[/00iG6^`02aQRk00>E^k/00k/01/JkULJkU@Bk1LH00k_6^`0A^`04
UK^k^`:E1K/00iFk^`02^`03UK^k04Vk0@000014bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk/2U@06bk_;UL^k1<H08<^kblK;^l_6
bk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^E0/H0Ol^kULK;^l^Ebk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbiG;UL^ka[_;ULJkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^iFkblK;^iG6
bk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^iD00/H01K_;ULJk00C601_;^l_6bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/019D3aP04biFE^`:E02;;^l^kblK;a/_6bk_;^l^kbk_;^l^kbk_;^l^E
bk_;^l^k0YD0E<^kbiG;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40000m^`:E1k/2U@03^iFk00>k00>Ea/H0
0[/01LJE^k_6012k0YD6^`03aYG600?60k/2U@>k00?6UK/06;/01YFk^iFkaP>k00FEa[^kU@0M^`06
UK^kUK_60k/01IG6^k^E01Nk0YD6^`03aYG600?60k/01YG6a[^EaQZk00S6^k_6^iFkU@:k00>E^k/0
1;/3aQ6k0YD7^`:E00>kUK/00k/2U@:k0YE6^`400000?l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02U@07^l^kbk_;^`02U@;600W;^l_6
ULK;a//00YD04k_6^l^kbk_;^l^kbk_;^l^kbk/00YD01l^kbk_6^l/00YD01/K;^l^kb`:E00>ka[/0
0YD07<^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbiD2aP0:bk^Ea/^kUK_;^`:E01g;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbiG;^l^kU@02aP0:^l^Ea[_;UL^kb`:E01Bkbk_;^l^kbk_;^l^kbk_;^l^kb`:E
00Nkbk_;a/^k00:E0/H02<^kblJEaYG60iD07;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;UL/6U@0L
^l^kbk_;a/_6bk_;^l^kbk_;^l^kbk_;^l^kb`:E00Nkbk_;^l^k00:E00K;^l^kbk/3U@17^iFEUK_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00@00046k0YD6^`03ULJk00;600Bka[^k0/H3^`03ULJk01:k0YD00k_6^`03^`03UK^k00Jk
00>Ea[/00[/2aQBk0YD5^`03ULK600;60[/2U@:k00BE^iFE5K/2U@Fk00>Ea/H00/H2^`:E0[/019Fk
UIDD^`:E00>ka[/00k/00iG6^`02aP04^lJk^`;60k/00iFk^`0D^`04a[^kU@Bk00>E^iD01[/2aQJk
0YD6^`03UK^k00Jk0YD3^`03UK^k042k0@00001>bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_6^l^k0/H00l^kb`02aP0_
^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk_;^l^kbk_;^l^kbk^Ea/^ka[/00/H05<^kbk_;^l^k
bk_;^l^kbk_;^l^k0iD02k_;^l^kULK;^l^k00>E01Zkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`>E
00_;^l^kbiG6^l^kb`03U@0Jbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbiD3aP07^l^ka[_;^`02aP0S
bk_;a/^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;UL/019D02[_;^l^kbk_;^l/2aP1]^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^Ebk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000@k/00iFk^`04^`03
a[^k00:k0/H2^`03a[_600?65K/00iG6^`0?^`C60[/00lJk^`0D^`03UK^k00Zk00FE^k^kU@0I^`03
UK^k00Zk00FE^k^kU@0E^`04UK^k^`C61;/2aPJk00>E^k/05;/3aP>E0[/00iFk^`0:^`;65;/00iFk
^`0A^`03UK^k042k0@00001Abk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbiG6^l^kblK;00C601nkbiG6^l^kbk_;^l^kbk_;
^l^kbk_;^l^kULK;^l^k00:E08O;^l^kbk_;^l^kbk^Ea/^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E
bk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^E
bk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;ULJkbk_;a//00lH00l^kb`02U@16^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;a/^Ebk_;^l^kbk_;^l^kbk_;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kb`:E
00bkbk_;^l^kbk_;^l/2U@11^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004>k00>E^k/00k/019G6UID2^`05a[^k^iD00/H3^`:E
4k/00iG6^`03^`04UK^EU@Jk0YD4^`:E00>ka[/05;/00iFk^`0>^`:E6;/00iFk^`0>^`:E5;/00iFk
^`03^`04UK^EU@:k00K6^k^kULH4^`:E5k/00lJk^`0@^`03a[^k016k00>E^k/00k/019FkUID6^`:E
1;/2UCnk0@000013bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`03U@0@bk_;ULJkbiG;a/^kbiG6U@;602S;^l^Ebk_;^l^kbk_;^l^k
bk_;^l^kULJE^l^kUK_;^iFkbk_;^iFk0YD08<^kbk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^k
0YD01/^kbk_;^`:E027;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l/00YD01[_;^l^kb`:E
01Rkbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l/3U@0?bk_;UL^kbiG;a/^kbiG600:E01bkbk_;UL^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;0lH08l^kbk_;^l^kbk_;^l^kblK;^l^kbk_;^l^kbk_;^l^kbk_;00>E
00o;^l^Ebk_;UL^kbk_;UL/00YD0@k_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004Jk19D01/Jk^k^EaP>k00FEa[^kU@02aP03
^iFk01:k00?6^iD00iD4^`03UK^k00:k00BE^k^k0YD2^`03ULJk01Bk0YD3^`04UK^EU@Bk00BE^iFE
0k/00iFk^`0D^`:E0k/019FkUID4^`04UK^EU@>k00>E^k/04k/4U@Bk00>Ea/H00[/019G6^k/2U@:k
00>E^k/06;/00lJk^`0<^`03a[^k01Bk19D4^`03UK^k00:k00BE^k^k0YD2^`03UK^k03bk0@00001:
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbiD2aP0>bk^Ea/^kbiG6^l^kbiD2aP0Ibk_;^l^kbk_;^l^kbk_;^l^kblK;^l^k
U@02aP0=^l^Ebk_;^iFkbk_;^`03U@0Ha/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;19D02k_;^iFkbk^E
^l^k00:E01[;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`BE00_;^l^Ebk_;UL^kb`02U@0R^iFkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^iFkb`C600Bkbk_;0iD05l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00C600bkbk_;^l^kbk_;^l/3aP0Ybk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kUK_;^l^E
bk_;^l/00iD0?/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0@0004bk1<H3^`03ULK600Fk00>Ea[/04K/00lJk^`03^`03a[_600;61;/2U@Jk
00>Ea[/06K/01IFk^k^E00>k00>E^k/00k/3UAZk00FE^k^kU@03^`03UK^k00>k0iDL^`03UK^k00:k
00>Ea[/01K/00iFk^`0E^`04a[^kaPbk0lHN^`03UK^k00:k0YD6^`03UK^k03bk0@00001Fbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kULK;^l^kbiD2aP0Gbk_;^lJkbk_;^l^kbk_;^l^kbk_;^l/00lH03/^kblK;^l^E
a[_;^l^k0YD0:<^kbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk/2U@0Ybk_;^l^k
UK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l/00YD0:[_;^l^kbiG;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kUK_;^l^kb`:E026kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kbk/0
0lH01[_;^l^kb`;602RkblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;0YD0@k_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00@0004jk00>E^k/01[/00iG6aP02^`03a[^k01>k1<H3^`03ULJk00Jk00>Ea/H00[/00lJk
^`0L^`03UK^k00>k0YDS^`03UK^k00>k0YDQ^`03UK^k00Jk00>E^k/06K/00lJk^`03aP:k00?6^k/0
0k/01LJka[_601jk00>E^k/01[/00iFk^`10^`400000F/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^k
biG;^`?602Rkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;ULJkbk_;^l^kULK;0lH0Ul^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^Ebk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbiG;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01<H02k_6^l_6bk_;^l^k00;606c;a/Jkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000C[/00iFk^`02^`:E0[/00iFk^`02^`03
a[^k01Zk00>Ea[/00[/2U@:k00>Ea[/00[/00lJk^`0L^`04UK^k^`:E0[/00iFk^`0P^`04UK^k^`:E
0[/00iFk^`0N^`03UK^k00:k0YD2^`03UK^k01bk00?6^k/00[/2aPFk00K6^lK6^lHL^`03UK^k00:k
0YD2^`03UK^k042k0@00001Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^Eb`04U@0W^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^Ea[_;^iFk00>E0/H09k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^iFkbk^E^`03U@0X^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^Eb`>E
02O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;UL/019D09;_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?600K;^lJkbk/2aP0Sbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iFkbk_;UL/00iD0@/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40001>^`:E0k/00iFk^`02^`03UK^k01jk00>Ea/H00[/00iFk
^`02^`03UK_600;67[/2U@:k00FE^k^kU@0R^`:E0[/01IFk^k^E022k0YD3^`03UK^k00:k00>E^k/0
9K/3aPFk00?6^k/06K/2U@>k00FE^k^kU@12^`400000D<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k19D0:<^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiD3aP0Y^l^kbk_;^l^ka[_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/019D09l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`04U@0U^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`04U@1Bbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`BE04K;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0005>k00>E^k/0:;/00iG6aP02aPFk00?6^k/0
8;/00iFk^`0X^`03UK^k02Jk00>E^k/0Dk/00iFk^`14^`400000Pl^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?60?o;^lJk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/001O;^lJkbk_;^l^kbk_;^l^kbk_;^l^kb`010000Q[/3a_nk5;/100000?o;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk
0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00001[bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00/H0ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`00<;_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40001[^`03a[_60?nk;k/100000?o;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^lJkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
a[_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040001Z^`;6
0k/00lJk^`3o^b^k0@00001/bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0/H0ol_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00;l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;0040001^^`;61;/2a_nk9k/1000004[;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6ok_;^`:E01k;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2aP03bk_;00;602Zkbk_6^lJkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^iD2aP0]^l^EUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbiG6^l^k00:E04[;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;600C;^l^E0/H0;L^kUIG;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk^Ea/^kb`02U@1?^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000A;/00iG6
U@02aP03^iFk00:E7;/01lJka/Jka[/01<H2^`03a[^k022k00>EaYD00/H00iFkU@02UB6k00NEaYFE
^iFk00>EAk/02<Jka/JkULJE0/H00iFkU@02UB6k00NEaYFE^iFk00>EC;/1000006k;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6
bk^Ea/^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^`;600C;^l^E0/H0Dl^Ea[_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk^Ea/^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^Ea[_;00:E04nkbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^l^k00?602fkbiG6^l^kbiG;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk/00YD0D<^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004Bk
00>Ea/H00[/00iG6aP02^`03UK^k01Rk00?6^k/00k/2aP:k00JEaYG6ULH2UAnk00>Ea/H00[/00iG6
aP02^`03UK^k01jk00>Ea[/00[/00iFk^`02^`03UK^k04Bk00?6^k/00[/00iG6aP02^`03ULK600:k
00>E^k/07[/00iG6^`02^`03UK^k00:k00>E^k/0BK/1000003k;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`:E00O;^l^kblJE00;600>kbk/0
0lH06[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0/H01[_;^l_6b`?600?;^iD00/H06k_;UL^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`02U@07bk_;^l_6U@02aP03^l^k00?601Zkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`:E00Jkbk_;^lH2U@1E^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^kbk_;U@02aP03bk_;00?6
01[;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`:E00K;^l^kbk/2U@1Bbk_;^l^kUK_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`40000n^`04UK^EU@>k00G6^k^EaP04^`03ULK601Zk1<H4^`;60[/01IG6^k^E01Rk00BE^iFE
0k/01LJk^iG600Bk00>Ea/H06;/019FkUID3^`04a[^kU@Fk00>E^k/0@k/019G6UID6^`03ULJk00>k
00>Ea[/06;/019FkUID6^`03UK^k00>k00>E^k/0BK/1000004;;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk/2U@06blK;^l^E0/H01L^k
ULK;00;602:kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6UL^kblK;0/H08K_;^l^Ebk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kUK_;^`02U@06blK;^l^E0/H01L^kULK;00;601Zkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;UL^kb`:E05Bka[_;^iFkbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l/2U@0Y^l^kbk^Ea/^kbiG6^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk/00YD0E/^kbk_;UL^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0003fk
00>E^k/01;/00iG6^`02^`03ULJk00C60k/00lJE^`0H^`03UK^E00:k00G6^k^EaP03^`03UK^k01Fk
00>E^k/01;/00iG6^`02^`03ULJk00C60[/00iG6^`0C^`03UK^k00Bk00>Ea[/00[/00iFk^`02^`04
UK^k^`:E4k/3aRVk00>Ea[/01;/00iG6^`02^`03UK^k00:k00BEa[^k0YDD^`03UK^k00Bk0YD3^`03
UK^k00:k00BE^k^k0YE6^`400000?L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD01k_;^l^kblH00YD0Bl^Ea[_;^iG6bk_;a/^Ebk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kUK_;UL_6bk_;ULJkbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02U@07
^l^kbk_;aP02U@0<biG6^l^kULK;^iG60YD04/^kbk_;^l^kbk_;^l^kbk_;^`:E00O;^l^kbk_600:E
00JkUK_;^l/2U@04^l^Eb`:E01Bkbk_;^l^kbk_;^l^kbk_;^l^kb`;602RkblK6^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E0/H01[_;^l^kaP:E00NkUK_;^l^E00;600?;UL/00YD04[_;
^l^kbk_;^l^kbk_;^l^kb`:E00Nkbk_;^l^k00:E00K;UL^kbk/2U@04bk^E^`:E04C;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40
000o^`:E1;/00lJk^`02U@;60k/01LJEUK_600:k00>E^k/05;/00iFk^`02^`03ULK600:k00FEa[^k
U@03^`:E5;/2U@Bk00?6^k/00YD2aP>k00G6UIFEaP02^`03UK^k016k0YD4^`03a[^k00:E1[/3U@>k
00>E^k/04k/01<Jka[/2aP04^lK6aP:k0/HK^`03ULK600>k00?6^k/00YD5^`04aYG6U@>k00>E^k/0
4K/2U@Nk0YD6^`>E0k/00iFk^`11^`400000@L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00:E00Vka[_;^l^Ea[/00/H07l_6bk^Ea/^k
biG;^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD01[_;^l^kU@C600RkbiFE^l^Eb`:E01Bkbk_;^l^kbk_;
^l^kbk_;^l^kb`:E00Vka[_;^l^Ea[/00/H07/_6bk^Ea/^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^`:E
00o;a/^kbk^E^l^kbk_;^l/00YD06K_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk/00/H00l^kb`02aP0;
^l_6blK;a/^ka[/00YD05l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E00?602O;^l^kUK_;^l^ka[_;aYFk
bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD03k_;^l^kbiG;^l^kbk_;^`02U@16bk_;UL^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40
0013^`04ULK6aP>k00C6^k^k0/H3^`05a[^k^iD05k/3U@Fk00>Ea[/00k/3U@>k00>E^k/04k/019G6
a/H3^`04a[^k^`;60k/01LJk^k^E01Jk00>Ea[/03K/01IFk^k^E01Fk00?6^lH00k/2aP:k0/H2^`03
a[_600:E00>kUK/05[/00iG6^`09^`05a[^k^lH00k/00iFk^`0D^`03UK^k00fk00FE^k^kU@12^`40
0000Al^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^Ebk_;00C600Bkbk_;0/H0C;_;a/^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^iFkbk_;^l^kbk_;^l^Ebk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l/4aP04^l^kb`;605:kblK;
^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;
^l^kbk_;^lJkblK;^lJka[_;0lH0X<_6a[^E^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk_;^l^k
bk_;^lJkbk_6^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/10000@k/00iFk^`03^`03ULK600Fk1<H2^`:E6K/00iFk^`0>^`03UK^k01>k00>E^k/00k/00iG6
aP05^`C60[/2UAFk00>Ea[/00k/2U@bk0YDD^`;600Fka[^kaP02^`03a[_600:k00C6^lK60[/00iFk
^`0E^`03ULJk00>k00>Ea/H02;/00lJk^`02UAFk00>E^k/00k/2U@bk0YE1^`400000C<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E
bk_;^l^EbiD3aP0:^l^kbiG6^l^kb`:E02Rkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;
^l^kbk_;0YD07K_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;UL^E00?600Zkbk_;ULJkbk_;0YD06k_;
^l^kbk_;^l^kbk_;^l^kbk^Ea/^kbk^E^`02U@06bk_;^l^k0YD01<^kbk/2U@0Dbk_;^l^kbk_;^l^k
bk_;^l^kbk/2aP03bk_600?602_;a/JEaYG6^lJkUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^l^k
UK^E00?600[;^l^kULK;^l^k0YD06l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^Eb`02U@06^l^kbk_;
0YD01;_;^l/2U@0o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^k00400013^`>E0k/01YFk^k^E^`;60[/019G6UID4^`03UK^k01Bk00>E^k/0
0[/2U@Jk0YD4^`03UK^k016k0iD3^`06UK^k^iFk0/H2^`04ULJEU@Bk00>E^k/04;/00iG6U@03^`05
UK^k^iD01K/019FkUID4^`03UK^k01:k00?6^k/00k/01<Jk^k/2aP07^iG6a[^E^`02UABk00BEa/K6
0[/01YFk^k^E^`;60[/019G6UID4^`03UK^k012k0iD3^`05UK^k^iD01K/019FkUID4^`03UK^k03bk
0@000016bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`BE00O;^l^kUK_;00;600BEa[_;0YD06K_;UL^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00YD01L^kbiG;00:E00Jkbk_;UL/2U@0I^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^`04U@07
bk_;^iFkb`02aP04ULJkb`:E01RkbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l/4U@0=^l^kbiG;^l^kUK_;
^`02U@0Ubk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkb`02U@0MaYFEUK^E^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbiD00lH01k_;^l^Ea[/00/H019G6bk/2U@0Hbk^E^l^kbk_;^l^kbk_;^l^k
bk_;^l^k19D03L^kbk^E^l^kbiG;^l/00YD0@K_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00400019^`03UK^k00:k00>E^k/00[/2aPBk
0iDH^`BE0k/01IFk^k^E00>k0YD00k^E^`0G^`03UK^k00:k00>E^k/00[/2aPBk0iDH^`03UK^k00:k
00>E^k/00[/00iFk^`03^`>E8;/019Fk^iD3^`03UK^E01Vk00>Ea/H00[/00iG6^`02^`;61;/3UARk
00>E^k/00[/00iFk^`02^`03UK^k00>k0iDn^`400000QL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;ULJk
bk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbiG;^l^Ebk_;^l/00iD0C<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbiG6^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;UL^kbk/2U@1=bk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^k
UK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01<H0;[_;^iG6bk_;^l^kUK_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kUK_;^l/2U@15^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040001>^`03UK^k00Bk0YDT^`04UK^k^`:E
1[/00iFk^`0J^`03UK^k00Bk0YDR^`03UK^k00Bk0YDV^`04UK^EU@:k0YD00k^E^`0L^`03ULJk00Bk
0YDR^`03UK^k00Bk0YE3^`400000PL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbiG;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kb`02U@1k^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kUK_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_;
^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00>E09^kUK^E^iFkUK_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kUK_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`010000C[/00iFk^`06^`03UK^k026k00>E^k/01K/00iFk^`0N^`03
UK^k00Jk00>E^k/07k/00iFk^`06^`03UK^k02Fk00>E^iD00[/019FkUIDL^`03UK^k00Jk00>E^k/0
7k/00iFk^`06^`03UK^k042k0@00001Cbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l/00YD0:[_;UL^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kb`:E02RkbiG;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^iFkbk_;0YD0:K_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;
^l^k00:E02o;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Eb`02U@0S
^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk/00YD0:L^kUK_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^iFkbk_;00:E04FkbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004jk00>E^k/00[/00iFkU@03UB:k
00JE^k^kUK/3UB2k00>E^k/00[/00iFkU@03UB2k00>E^k/00[/00iFkU@03UBVk00FE^k^kU@0M^`03
UK^k00:k00>E^iD00iDP^`03UK^k00:k00>E^iD00YE2^`400000C/^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`:E
02_;^l^Ebk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00:E02NkbiG;^l^Ebk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00YD0:L^kbiG;^l^kUK_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00:E05Bkbk^E^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbiG;UL^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2U@0Y^l^kUK_;^l^Ebk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00YD0B/^kbiG;^l^Ebk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@00052k19DY^`BE
9K/4UBNk19D^^`03UK^E00:E7k/4UBNk19E6^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`001L^kbk_;00:E
09K;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000ok/6^`03UK^k09Bk0@00003obk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`40
0000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
09g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000V[/00iG6
^`02^`:Enk/1000009c;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULH4U@3lbiFE^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0@0004Bk00>Ea_l00k/2UB>k00>Ea[/00[/2UBBk00>Ea[/00[/01IFk^k^E026k00>Ea/H0
0[/2UBBk00>EolH00[/2UBBk00>EolH00[/2UBBk00>Ea/H00[/2UDnk0@000017bk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^EaYD0
0/H00k^E^`02U@0Sbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULH00YD00k^E^`03U@0L
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`:E00Bkbk^E0/H0:k_;^l^kbiG;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^EaYD00/H00iFkU@02U@0T^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kUK^E0/H00iG;U@02U@0Tbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^E
0/H00iFkU@02U@0T^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULJE0/H00iG;U@02U@1<
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`400014^`06ULJk^iG61;/00iFk^`0N^`04ULJk^`:E1;/00iFk^`0I^`03
UK^E00:E0[/019G6a/H3^`03UK^k01nk00JEa[^kULH4^`03UK^k01jk00JE^k^kULH4^`03UK^k01jk
00JE^k^kULH4^`03UK^k01jk00JEa[^kULH4^`03UK^k04Vk0@000015bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E00;600>kbiD0
0/H0Cl^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkbk^E^l^kbiG;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^iFkbk_;^iD00/H0:K_;ULJkbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^E00;600?;^iD00/H08k_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00:E
00C;^l^E0/H09<^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;U@;600?;^iD00/H0:K_;
UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^l^E00;604k;^iFkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/10000?[/2U@Jk00>Ea/H00k/3aQZk0YD5^`03aYFE00Jk00>E^k/06;/3U@Bk00?6ULH00lH2^`03
UK^k00:k0YDE^`:E1[/00iG6aP03^`?66[/2U@Jk0YD4^`?61;/00lJk^`0C^`:E1K/01lJEa/Jka[/0
0lHJ^`:E1K/00lJEU@04^`?6Bk/10000043;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFk0YD0:L^kbk_;^iG6bk_;^iG6bk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbiG;00:E02Zkbk_6^l^Ebk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l/3U@09a[_;^l^Ea[_;00BE00>kUK/00YD05L^kbk_;^l^kbk_;^l^kbk_;^l^Eb`02U@0=^l^kbk_;
ULJkbk_;U@02aP0Jbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK/2U@0Ybk_;^l^kUK_;^l^kULK;^l_6
bk_;^l^kbk_;^l^kbk_;^l^kbk_;UL/00YD01k_;^lJkbiD00/H08<^kbiG6^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^iFk0YD0F<^kblK;^iFkbk_;^iG6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000?[/019Fk^k/2U@Fk
00>Ea[/00[/00iG6^`0H^`04UK^k^`:E00>ka[/00[/00iFk^`02^`03UK^k01jk00>Ea[/02[/2U@>k
00>E^k/04;/019Fk^k/2U@Fk00>Ea[/00[/00iFk^`02aQJk00BE^k^k0YD5^`03ULK600:k00>Ea[/0
0[/00lJk^`0C^`04UK^k^`:E00>ka[/00[/00iG6^`02^`03ULJk01Rk00BE^k^k0YD00k_6^`02^`03
UK^k00:k00>Ea[/0BK/1000004G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^iD00/H03;_;ULJkbk^Ea/^kb`;602Rkbk_;^l^kbk_;
^l^kbk_;^l^kUK_;^l^kbiG6^l^kUK_;^l^Ebk_;0YD07K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^iFk00?602Nkbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbiD00/H0:<^kULK;^l^E
bk_;ULJkbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk/2U@06bk_;ULJk1<H08<^kULK;^l^kbk_;^l^k
bk_;^l^kbk_;^iFkbk_;^l^E0/H0:L^kUK_;^l^Ea[_;ULJkbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^k
bk^E00;600bkbiG;^l^kULK;^iD2aP15^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040000m^`:E1[/00lJEaP03aP>k00>Ea/H0
0[/01<Jka/HA^`:E1[/01LJEUK^E00Bk0YD2^`04UK^EUARk00>E^k/00k/00lJE^`0:^`:E4;/2U@Jk
00?6ULH00lH3^`:E0[/019G6UIDB^`:E1k/2U@03^iG600>k00JEa/JkULH2UA:k0YD6^`03aYG600;6
1;/01YG6a[^EaP:E4[/2U@Nk00BEa/K61;/029G6a[^EaYG6A;/1000003o;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD01k_;^l_6bk/0
0YD08<Jkbk_;^iG6blK;^iG6bk_;^l^kbk_;^l^kbk_;^l^k0YD01l^kbk_6^l/00YD01[_;^l^kb`>E
01c;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E0/H01L^kblK;00:E00Fkbk_;^`02U@04bk_;^`:E
013;^l^kbk_;^l^kbk_;^l^k0YD01l^kbk_6^l/00YD01/K;^l^kb`>E01O6^l^Ebk_;^l^kbk_;^l^k
bk_;^l^kb`02U@07^l^kbk_;^`02U@0Pa[_;^l_6ULJEa/^kUK_;^l^kbk_;^l^kbk_;^l^kbk/2U@07
bk_;^lJkb`02U@0Pa/^kbk_;ULJEa[_;UL^kbk_;^l^kbk_;^l^kbk_;^l/2U@07^l^kbk_;^`02U@1@
a[_;^l^kULJEa/^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/10000@K/2U@03^lJk00>k00>E^k/01[/2aP>k00>Ea[/04[/2U@03
^lJk00>k00>E^k/01[/2U@>k00>E^k/05K/00lJEaP03aP>k00>E^k/00[/019FkUID4^`03UK^k00nk
0YD00k_6^`03^`03UK^k00Jk00>Ea[/00[/2aQ>k0YD6^`03ULJk00>k00?6^k/00/H3^`03UK^k01:k
0YD00k_6^`03^`03ULJk00Jk0/H3^`03UK^k01:k0YD6^`03ULJk00Jk0/H3^`;6@K/100000:c;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;ULJkbk_;^l^kbk_;^l^kblK;^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk_;^l^kbk_;^l^k
bk^E^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;^iG6bk_;UL^kbk^E^l^k0iD0:k^E^l^kbk_;
^l^kbk_;^l^kbk_;^iG6bk_;^l^kbk_;^l^kbk^Ea/^ka[/00/H0J/^kbk_;^l^kbk_;^l^kbk_;^l^E
bk_;^l^ka[_;^l_6bk_;a/^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^l^kblK;^l^kbk_;^lJk
bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiD3aP0B^l^ka[_;^l^kbk_;a/^kbiG;0/H0?k_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000
@k/00iG6^`0A^`03ULJk01Bk00>Ea[/04K/00iFk^`0E^`;61k/00iFk^`02^`>E1;/2UA>k00>Ea[/0
3k/4aP:k00?6^k/04;/00iFk^`04^`03a[^k00:k0/H6^`03UK^k01Bk00>E^k/01;/00lJk^`02^`;6
0[/01LJk^k^E01Jk00BEa[^k1<H<^`05UK^k^lH0?[/1000004[;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkbk_;U@;602S;^l^k
bk_;^l^kbiG6^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^l^k0YD03<^kbk_;^l^kbk_;^`:E01S;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/3aP0<^l^kbiG;^l^kbk_;0YD07K_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kULK;^l^k00:E037;^l^kbk_;^l^kbk^Ea/^ka[_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbiG6^l^k
bk_;00?600?;^l/00YD07;_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^iD2aP05^l^ka[/01<H0;L^k
UIG;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ea[_;^l^Ea[_;^l^kbk_;^l^kb`02U@11^l_6bk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004>k
00>Ea[/00k/00iG6U@03aPBk00>Ea/H00[/00lJEU@0C^`03ULJk00>k00BE^iFE1[/2U@Bk0YDI^`05
a[^k^iD01;/2U@:k00>E^k/05K/00iG6^`03^`04UK^EU@Jk0YD4^`:E00>ka[/04;/00iFk^`03^`04
UK^EU@Jk00>Ea/H00k/2UA>k00>E^k/00k/00iFkU@04aP>k00>Ea[/00k/2UA>k00>Ea[/00k/019Fk
UID6^`:E1;/2U@03^lJk03bk0@000014bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiD3aP0?^l^Ea[_;UL_6bk_;ULJE00?602NkbiG;
^l^kbk_;^l^kbk_;^l^kbk^EaYFkbk^E^l^kUK_;^l^kUK/00YD06<^kbk^E^l^kbk_;^l^kbk_;^l^k
bk_;^`;600O;^l_6bk_;00:E00Fkbk^E^`03U@0Y^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^EaYFkbk^E
^l^kUK_;^l^kUK/00YD05l^kbk^Ea/^kbk_;^l^kbk_;^l^kbk_;00>E013;^l^Ebk_;UL^kbk_;UL^E
0/H05/^kbiG;^l^kbk_;^l^kbk_;^l^kbk/3U@09^l^kUK_;^iFk00;600C;^iFk0YD0:L^kbk^E^l^k
bk_;^l^kbk_;^l^kbk_;ULJEbk_;UL^kbiG;^l^kbiG;00:E04>kbk_;ULJkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00400016^`03ULK600;6
0k/00iG6^`02^`06ULJk^iG60[/00iFk^`0C^`BE1;/00iFk^`02^`04UK^k^`:E0[/00iFk^`0A^`03
a[_600?61K/4U@>k00>E^k/05[/00lJkU@03U@Bk00>E^k/00[/019Fk^k/2U@:k00>Ea[/04k/4U@Bk
00>E^k/00[/01YFk^k^EaP:k00>E^k/04k/4U@Bk00>E^k/00/H019Fk^k/2U@:k00>E^k/04K/00lJk
U@03U@Bk00>E^k/00[/01IFk^k^E00;600>kULH0?K/1000005W;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkbk^Ea/^k
biG6^l^kb`03U@0Xbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^Ebk_;^iFkbk_;^`>E04Bkbk_;
^l^kbk_;^l^kbk_;^l^ka[_;^l_6bk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;
^l^kU@;600fkbiG;^l^kUK_;^l^k00>E02S6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^iFkbk_;
UL^kbk_;0iD0:<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;UL^kbk_6^l^kbk/3U@0Y^l^kbk_;
^l^kbk_;^l^kbk_;^lJkbk_;UL^kbk^E^l^kbiG;^l^kaYD00lH0?K_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004jk00>Ea[/00[/00iG6
aP05^`03UK^k01^k00>E^k/00[/2U@Jk00>E^k/04K/2aRVk00?6^k/00k/00lJkaP02aPBk0YD6^`03
ULJk01^k00>E^k/00[/2U@Jk00>E^k/06k/00iFk^`02^`03ULJk00Fk00>E^k/04K/00lJk^`07^`03
UK^k00:k0YD3^`05a[^kULH0?K/1000004o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E00;600Fkbk_;U@02aP0X
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^`:E01[;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`?602Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;600nkbk_;
a/^kbiG6^l^kbk/00YD0:L^kbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;00:E
02Vkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^`02U@0Hbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0/H02L^kbk_;^l^kU@02aP04^l^kb`:E04>ka[_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040001>^`03UK^k00?6
0k/00iG6^`0O^`03UK^k00Jk00>E^k/06[/00lJk^`0U^`C61;/00iG6^`06^`03ULK600:k00?6^k/0
6[/00iFk^`06^`03UK^k01nk00>E^k/01[/00iFk^`0G^`?61K/00iG6^`03aP>k00>Ea/H0@;/10000
05C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk/2aP13biG6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^Ebk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03aP0obk_;a/^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;ULJkbk_;^l^kULK;00?606g;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
biG;^l^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;600nkbk^Ea/^kbk_6^l^Ebk/0
0/H0?/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0@0004jk00>E^k/00[/2U@04^lK6aR2k00>E^k/00[/2U@:k00>E^k/05k/4aRnk00>Ea[/0
0[/2U@:k00>Ea[/00[/00lJk^`0J^`03UK^k00:k0YD2^`03UK^k01nk00>E^k/00[/2U@:k00>E^k/0
7;/2aP03^iG600>k00FEa[^kU@04^`03a[^k03^k0@00001Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^E
b`03U@0Xa[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk^E^`BE05;;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^Ea[_;^iFk0iD2aP0V^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;UL/4U@0W
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^iFk00BE01o;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00?600G;^l^EaP03U@12bk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004jk0YD3^`03UK^k00:k00>E^k/0
7[/2U@>k00>E^k/00[/00iFk^`19^`03ULK600:k00>E^k/00[/00iFkaP02aQbk0YD3^`03UK^k00:k
00>E^k/07[/2U@>k00>E^k/00[/00iFk^`0N^`03ULJk00:k00FEa[^kU@05^`03a[^k03Zk0@00001@
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/4U@0Wbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00BE05>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;U@03aP0W^l^kbk_;^l^ka[_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^k00BE02O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
19D09k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`04U@16a[_;^l^kbk_;a/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40
001C^`03UK^k02Rk00>E^k/0Dk/00iG6aP02aPFk00?6^k/07[/00iFk^`0X^`03UK^k02Rk00>Ea/H0
0/H5^`03a[^k03Zk0@00003Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03aP1n
bk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0lH0?k_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^`010000g;/3aWjk0lHl^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
09g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`40
0000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0@000?nkWK/100000?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;0040003o^ifk0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`010000ok^M^`4000002L^kbk_;^l^kb`05o`06bk_;^l^k0_l01/^k
bk_;^`;o00O;oooobk_;00?o00C;^l^k0ol00k_;^`02o`06booool^k0ol00k_;o`03o`3o^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^k001J^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0@0000Zk0_l8^`;o1K/2o`07
^ooook_o^`02o`:k00Co^k^k0_l00k_o^`02o`07^ooook_o^`02o`04^onko`:k0_oo^eVk0@00000;
bk_;^l^kbk_;^l/00_l02;_;^l^kbk_;0_l01;_;^l/2o`03^l_o00?o00Zkooo;^l_obk_;0_l01[_;
oonkb`Co00Fkbooo^`02o`3obk_ool^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;001Mbk_ool^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;0040000;^`;o2;/2o`Bk0_l3^`;o0[/2o`Nk0_l2^`;o0k/2o`>k0_l5^`;ook]I^`40
00002l^kbk_;^l^kbk_;00;o00Rkbk_o^l^kb`?o00C;^l^k0_l01/^kooo;^`;o00O;^l^kbk_;00;o
00>kbk/00_l01l^kooo;^l/00_l01;_;^l/2o`3o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k001J^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;0@0000^k0_l3^`03ok^k00:k0ol4^`;o0[/2o`>k0_l2^`;o0[/2o`>k
0_l2^`;o0k/2o`>k0_l2^`03ok^k0?nkE[/1000000c;^l^kbk_;^l^kbk/6o`04bk_;^`?o00Bkok_;
0_l01k_ooonkbk/00_l01/^kok_;^`;o00?;^l/00_l01k_ooonkbk/00_l0Nl^kooo;^onkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`05o`04bk_;^`?o
00>kbol00_l03<_oooo;ol^kbk_;^`Co00?;^l/01?l0^k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0000bk0_l3^`04ok^k^`?o
00>kool00k/2o`03^ooo00Bk0ol2^`Go0k/2o`03^ooo00>k0_l3^`CoLk/00onk^`03^`04ok^ko`>k
00Co^k_o0k/00onk^`06^`03ok^k00:k00?o^ol01;/00onk^`2h^`4000003<^kbk_;^l^kbk_;^`;o
023;^l_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o00c;^l^kbk_;^l^kbk/2o`3obk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l^k
bk_o^l_obk_;^l^kok_;^onkbk_;^l^kboo;^l^kok_o^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;001Obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@0000bk0_lQ^`03
ok^k00Zk0_mi^`03ok^k00Bk00Co^k_o1[/01Onk^k_o00Rk00?o^k/00[/00onko`04^`03ok^k0;Rk
0@00000=bk_;^l^kbk_;^l^kb`02o`0^^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`;o07jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l_obk_;^l/3o`03booo00?o00o;^onkbk_o^l^kbk_;^l/00_l0aK_;^onkok_;
^l_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^k0040000=^`;o1;/00onk^`0W^`;oN;/00onk^`07^`05ok^k^ol00[/2o`:k00?o^k/0
1[/00onko`02o`:k00?o^k/00[/00onk^`2h^`4000002l^kbk_;^l^kbk_;00Wo02S;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol0Pk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l^kbk_;^l^k00?o00Fkbooo^`02o`3@
bk_;^l^kbk_;ol^kbk_;^onkbk_;ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40002g^`03ok^k00Bk00?o^k/05K/00onk^`03^`03
ok^k00:k00?o^k/0^;/100000;g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kok_;^l/00_l0gK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;
^l^kok_;^l_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^k0040002i^`Co00>kok/06;/3o`:k1?nk^`400000ol^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@000?nkWK/100000?o;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/009g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0040003o^ifk
0@00003obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;002Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`010000ok^M^`400000ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`00WL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/00@000001\
\>"],
  ImageRangeCache->{{{0, 412}, {255, 0}} -> {-0.0250052, -0.0257715, 
  0.00254857, 0.00412367}, {{9.8125, 402.188}, {248.75, 6.1875}} -> {-1.35563,
   -0.271688, 0.0235711, 0.0235711}, {{57.5, 96.5625}, {243.438, 204.375}} ->
   {-0.414019, -0.330456, 0.0115687, 0.0264174}, {{100.438, 139.562}, {
  243.438, 204.375}} -> {-0.911112, -0.330456, 0.0115687, 0.0264174}, {{
  143.438, 182.5}, {243.438, 204.375}} -> {-1.4082, -0.330456, 0.0115687, 
  0.0264174}, {{186.438, 225.5}, {243.438, 204.375}} -> {-1.90566, -0.330456, 
  0.0115687, 0.0264174}, {{229.438, 268.5}, {243.438, 204.375}} -> {-2.40311,
   -0.330456, 0.0115687, 0.0264174}, {{272.375, 311.5}, {243.438, 204.375}} ->
   {-2.9002, -0.330456, 0.0115687, 0.0264174}, {{315.375, 354.438}, {243.438, 
  204.375}} -> {-3.78159, -0.324485, 0.01271, 0.025901}, {{57.5, 96.5625}, {
  200.438, 161.375}} -> {-0.345003, -1.48706, 0.0107358, 0.0267959}, {{
  100.438, 139.562}, {200.438, 161.375}} -> {-1.19379, -1.41863, 0.0138891, 
  0.0255418}, {{143.438, 182.5}, {200.438, 161.375}} -> {-1.4082, -1.4664, 
  0.0115687, 0.0264174}, {{186.438, 225.5}, {200.438, 161.375}} -> {-2.03847,
   -1.44998, 0.012208, 0.0261164}, {{229.438, 268.5}, {200.438, 161.375}} ->
   {-2.56341, -1.44998, 0.012208, 0.0261164}, {{272.375, 311.5}, {200.438, 
  161.375}} -> {-3.19861, -1.44045, 0.0125846, 0.0259417}, {{315.375, 
  354.438}, {200.438, 161.375}} -> {-1.89168, -1.40274, 0.00712345, 
  0.0259305}, {{57.5, 96.5625}, {157.5, 118.375}} -> {-0.414019, -2.60153, 
  0.0115687, 0.0264174}, {{100.438, 139.562}, {157.5, 118.375}} -> {-0.908894,
   -2.59659, 0.0115502, 0.0263752}, {{143.438, 182.5}, {157.5, 118.375}} ->
   {-1.51352, -2.57217, 0.012208, 0.0261164}, {{186.438, 225.5}, {157.5, 
  118.375}} -> {-2.03847, -2.57217, 0.012208, 0.0261164}, {{229.438, 268.5}, {
  157.5, 118.375}} -> {-2.40311, -2.60153, 0.0115687, 0.0264174}, {{272.375, 
  311.5}, {157.5, 118.375}} -> {-2.95513, -2.58176, 0.0117555, 0.0262231}, {{
  315.375, 354.438}, {157.5, 118.375}} -> {-3.3973, -2.60153, 0.0115687, 
  0.0264174}, {{57.5, 96.5625}, {114.5, 75.4375}} -> {-0.414019, -3.73665, 
  0.0115687, 0.0264174}, {{100.438, 139.562}, {114.5, 75.4375}} -> {-0.988956,
   -3.69436, 0.012208, 0.0261164}, {{143.438, 182.5}, {114.5, 75.4375}} ->
   {-1.4082, -3.73665, 0.0115687, 0.0264174}, {{186.438, 225.5}, {114.5, 
  75.4375}} -> {-1.90566, -3.73665, 0.0115687, 0.0264174}, {{229.438, 268.5},
   {114.5, 75.4375}} -> {-3.24264, -3.58239, 0.0149162, 0.0253195}, {{272.375,
   311.5}, {114.5, 75.4375}} -> {-2.9002, -3.73665, 0.0115687, 0.0264174}, {{
  315.375, 354.438}, {114.5, 75.4375}} -> {-3.3973, -3.73665, 0.0115687, 
  0.0264174}, {{57.5, 96.5625}, {71.5, 32.4375}} -> {-0.414019, -4.8726, 
  0.0115687, 0.0264174}, {{100.438, 139.562}, {71.5, 32.4375}} -> {-0.911112,
   -4.8726, 0.0115687, 0.0264174}, {{143.438, 182.5}, {71.5, 32.4375}} ->
   {-0.999794, -4.86319, 0.00913157, 0.0264564}, {{186.438, 225.5}, {71.5, 
  32.4375}} -> {-1.90566, -4.8726, 0.0115687, 0.0264174}, {{229.438, 268.5}, {
  71.5, 32.4375}} -> {-2.40311, -4.8726, 0.0115687, 0.0264174}, {{272.375, 
  311.5}, {71.5, 32.4375}} -> {-2.9002, -4.8726, 0.0115687, 0.0264174}, {{
  315.375, 354.438}, {71.5, 32.4375}} -> {-3.3973, -4.8726, 0.0115687, 
  0.0264174}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Generation 80"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .95229 
MathPictureStart
%% Graphics3D
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-3.75585e-05 1.06867 0.0267167 1.06867 [
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 80)] .5 .95229 0 -1.5 Msboxa
P
[(0)] .08595 .18034 -0.06484 1 Msboxa
[(10)] .23556 .13958 -0.04346 1 Msboxa
[(20)] .40028 .0947 -0.01962 1 Msboxa
[(30)] .58253 .04506 .00711 1 Msboxa
[(Indiv.)] .35928 .03957 -0.02584 1 Msboxa
[(Gen.)] .91594 .16872 -1 .22094 Msboxa
[(-100)] .05455 .27684 1 -0.24757 Msboxa
[(0)] .04482 .42044 1 -0.20167 Msboxa
[(100)] .03471 .57006 1 -0.15355 Msboxa
[(200)] .02419 .72609 1 -0.10302 Msboxa
[(Fit.)] -0.0283 .53856 1 -0.16726 Msboxa
[ 0 0 0 0 ]
[ 1 .95229 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 80)] .5 .95229 0 -1.5 Mshowa
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.08509 .19367 m
.08465 .20033 L
s
P
[(0)] .08595 .18034 -0.06484 1 Mshowa
p
.002 w
.23498 .15292 m
.23469 .15959 L
s
P
[(10)] .23556 .13958 -0.04346 1 Mshowa
p
.002 w
.40002 .10806 m
.39989 .11474 L
s
P
[(20)] .40028 .0947 -0.01962 1 Mshowa
p
.002 w
.58262 .05842 m
.58267 .0651 L
s
P
[(30)] .58253 .04506 .00711 1 Mshowa
p
.001 w
.11395 .18582 m
.11371 .18982 L
s
P
p
.001 w
.14336 .17783 m
.14314 .18183 L
s
P
p
.001 w
.17332 .16968 m
.17311 .17368 L
s
P
p
.001 w
.20386 .16138 m
.20367 .16538 L
s
P
p
.001 w
.2667 .1443 m
.26655 .1483 L
s
P
p
.001 w
.29905 .1355 m
.29892 .13951 L
s
P
p
.001 w
.33204 .12654 m
.33192 .13054 L
s
P
p
.001 w
.36569 .11739 m
.36559 .1214 L
s
P
p
.001 w
.43505 .09854 m
.43499 .10254 L
s
P
p
.001 w
.4708 .08882 m
.47076 .09283 L
s
P
p
.001 w
.5073 .0789 m
.50728 .0829 L
s
P
p
.001 w
.54456 .06877 m
.54457 .07277 L
s
P
p
.001 w
.6215 .04785 m
.62155 .05186 L
s
P
p
.001 w
.66122 .03706 m
.6613 .04106 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
p
.002 w
.69926 .02672 m
.93852 .30206 L
s
P
[(Gen.)] .91594 .16872 -1 .22094 Mshowa
P
p
p
.002 w
.07262 .19706 m
.02672 .88626 L
s
P
p
.002 w
.06752 .27363 m
.07401 .27202 L
s
P
[(-100)] .05455 .27684 1 -0.24757 Mshowa
p
.002 w
.05792 .4178 m
.06447 .41648 L
s
P
[(0)] .04482 .42044 1 -0.20167 Mshowa
p
.002 w
.04791 .56804 m
.05451 .56702 L
s
P
[(100)] .03471 .57006 1 -0.15355 Mshowa
p
.002 w
.03748 .72472 m
.04412 .72403 L
s
P
[(200)] .02419 .72609 1 -0.10302 Mshowa
p
.001 w
.06563 .30199 m
.06953 .30106 L
s
P
p
.001 w
.06373 .33059 m
.06763 .3297 L
s
P
p
.001 w
.06181 .35943 m
.06572 .35856 L
s
P
p
.001 w
.05987 .38849 m
.06379 .38767 L
s
P
p
.001 w
.05595 .44735 m
.05989 .4466 L
s
P
p
.001 w
.05397 .47715 m
.05791 .47643 L
s
P
p
.001 w
.05196 .50719 m
.05591 .50651 L
s
P
p
.001 w
.04995 .53749 m
.0539 .53684 L
s
P
p
.001 w
.04586 .59884 m
.04983 .59827 L
s
P
p
.001 w
.04379 .62991 m
.04776 .62938 L
s
P
p
.001 w
.0417 .66124 m
.04568 .66075 L
s
P
p
.001 w
.0396 .69285 m
.04358 .69239 L
s
P
p
.001 w
.03534 .75686 m
.03933 .75649 L
s
P
p
.001 w
.03318 .78929 m
.03717 .78896 L
s
P
p
.001 w
.031 .82199 m
.03499 .82171 L
s
P
p
.001 w
.0288 .85499 m
.0328 .85474 L
s
P
p
.001 w
.0694 .24548 m
.07328 .24449 L
s
P
p
.001 w
.07126 .21757 m
.07513 .21654 L
s
P
[(Fit.)] -0.0283 .53856 1 -0.16726 Mshowa
P
0 0 m
1 0 L
1 .95229 L
0 .95229 L
closepath
clip
newpath
p
p
.4 g
.002 w
.06752 .27363 m
.42865 .45675 L
s
P
p
.4 g
.002 w
.05792 .4178 m
.427 .56884 L
s
P
p
.4 g
.002 w
.04791 .56804 m
.4253 .68447 L
s
P
p
.4 g
.002 w
.03748 .72472 m
.42355 .80382 L
s
P
p
.4 g
.002 w
.02658 .88827 m
.42174 .92708 L
s
P
p
.4 g
.002 w
.08367 .20324 m
.03923 .88751 L
s
P
p
.4 g
.002 w
.18588 .26044 m
.15408 .89894 L
s
P
p
.4 g
.002 w
.27503 .31032 m
.253 .90878 L
s
P
p
.4 g
.002 w
.35346 .35421 m
.3391 .91735 L
s
P
p
.4 g
.002 w
.423 .39313 m
.4147 .92487 L
s
P
p
.4 g
.002 w
.44013 .39481 m
.43312 .92519 L
s
P
p
.4 g
.002 w
.56602 .37138 m
.56847 .92068 L
s
P
p
.4 g
.002 w
.70138 .34619 m
.71482 .91579 L
s
P
p
.4 g
.002 w
.84733 .31903 m
.87358 .91049 L
s
P
p
.4 g
.002 w
.42865 .45675 m
.94243 .37002 L
s
P
p
.4 g
.002 w
.427 .56884 m
.94975 .49749 L
s
P
p
.4 g
.002 w
.4253 .68447 m
.95734 .62961 L
s
P
p
.4 g
.002 w
.42355 .80382 m
.96521 .76666 L
s
P
p
.4 g
.002 w
.42174 .92708 m
.97338 .9089 L
s
P
P
p
.37695 .36191 m .45808 .39844 L .44573 .40071 L .833 0 1 r
F
P
p
.38979 .35935 m .47051 .39615 L .45808 .39844 L .833 0 1 r
F
P
p
.37695 .36191 m .38979 .35935 L .45808 .39844 L .833 0 1 r
F
P
p
.40273 .35678 m .48303 .39384 L .47051 .39615 L .365 0 1 r
F
P
p
.38979 .35935 m .40273 .35678 L .47051 .39615 L .833 0 1 r
F
P
p
.41576 .35418 m .49564 .39152 L .48303 .39384 L 0 1 .781 r
F
P
p
.40273 .35678 m .41576 .35418 L .48303 .39384 L .365 0 1 r
F
P
p
.42889 .35157 m .50835 .38918 L .49564 .39152 L .344 1 0 r
F
P
p
.41576 .35418 m .42889 .35157 L .49564 .39152 L 0 1 .781 r
F
P
p
.44212 .34893 m .52114 .38683 L .50835 .38918 L .406 1 0 r
F
P
p
.42889 .35157 m .44212 .34893 L .50835 .38918 L .344 1 0 r
F
P
p
.45545 .34628 m .53403 .38446 L .52114 .38683 L .552 1 0 r
F
P
p
.44212 .34893 m .45545 .34628 L .52114 .38683 L .406 1 0 r
F
P
p
.46889 .3436 m .54701 .38207 L .53403 .38446 L .656 1 0 r
F
P
p
.45545 .34628 m .46889 .3436 L .53403 .38446 L .552 1 0 r
F
P
p
.48243 .3409 m .56008 .37966 L .54701 .38207 L .729 1 0 r
F
P
p
.46889 .3436 m .48243 .3409 L .54701 .38207 L .656 1 0 r
F
P
p
.49607 .33818 m .57325 .37723 L .56008 .37966 L .802 1 0 r
F
P
p
.48243 .3409 m .49607 .33818 L .56008 .37966 L .729 1 0 r
F
P
p
.50983 .33544 m .58652 .37479 L .57325 .37723 L .813 1 0 r
F
P
p
.49607 .33818 m .50983 .33544 L .57325 .37723 L .802 1 0 r
F
P
p
.52368 .33268 m .59989 .37233 L .58652 .37479 L .823 1 0 r
F
P
p
.50983 .33544 m .52368 .33268 L .58652 .37479 L .813 1 0 r
F
P
p
.53765 .3299 m .61335 .36985 L .59989 .37233 L .844 1 0 r
F
P
p
.52368 .33268 m .53765 .3299 L .59989 .37233 L .823 1 0 r
F
P
p
.55173 .3271 m .62692 .36735 L .61335 .36985 L .896 1 0 r
F
P
p
.53765 .3299 m .55173 .3271 L .61335 .36985 L .844 1 0 r
F
P
p
.56592 .32427 m .64059 .36484 L .62692 .36735 L .938 1 0 r
F
P
p
.55173 .3271 m .56592 .32427 L .62692 .36735 L .896 1 0 r
F
P
p
.002 w
.50737 .65623 m .49419 .66007 L .42496 .61537 L p
.344 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49419 .66007 m .47933 .90887 L .41107 .63476 L p
0 1 .781 r
F P
0 0 0 r
s
P
p
.002 w
.41107 .63476 m .42496 .61537 L .49419 .66007 L p
0 1 .781 r
F P
0 0 0 r
s
P
p
.58022 .32142 m .65436 .3623 L .64059 .36484 L .969 1 0 r
F
P
p
.56592 .32427 m .58022 .32142 L .64059 .36484 L .938 1 0 r
F
P
p
.002 w
.52064 .65479 m .50737 .65623 L .43867 .61368 L p
.406 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42496 .61537 m .43867 .61368 L .50737 .65623 L p
.344 1 0 r
F P
0 0 0 r
s
P
p
.59464 .31855 m .66823 .35975 L .65436 .3623 L 1 .969 0 r
F
P
p
.58022 .32142 m .59464 .31855 L .65436 .3623 L .969 1 0 r
F
P
p
.002 w
.53402 .65091 m .52064 .65479 L .45264 .59924 L p
.552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.43867 .61368 m .45264 .59924 L .52064 .65479 L p
.406 1 0 r
F P
0 0 0 r
s
P
p
.2993 .31811 m .38979 .35935 L .37695 .36191 L 0 .333 1 r
F
P
p
.002 w
.54748 .64701 m .53402 .65091 L .46673 .57711 L p
.656 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45264 .59924 m .46673 .57711 L .53402 .65091 L p
.552 1 0 r
F P
0 0 0 r
s
P
p
.60917 .31566 m .68221 .35718 L .66823 .35975 L 1 .938 0 r
F
P
p
.59464 .31855 m .60917 .31566 L .66823 .35975 L 1 .969 0 r
F
P
p
.31266 .31521 m .40273 .35678 L .38979 .35935 L 0 .333 1 r
F
P
p
.2993 .31811 m .31266 .31521 L .38979 .35935 L 0 .333 1 r
F
P
p
.002 w
.56101 .63576 m .54748 .64701 L .48071 .57526 L p
.729 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46673 .57711 m .48071 .57526 L .54748 .64701 L p
.656 1 0 r
F P
0 0 0 r
s
P
p
.62382 .31274 m .69629 .35458 L .68221 .35718 L 1 .906 0 r
F
P
p
.60917 .31566 m .62382 .31274 L .68221 .35718 L 1 .938 0 r
F
P
p
.32612 .31229 m .41576 .35418 L .40273 .35678 L 0 .802 1 r
F
P
p
.31266 .31521 m .32612 .31229 L .40273 .35678 L 0 .333 1 r
F
P
p
.002 w
.57466 .63422 m .56101 .63576 L .49483 .56827 L p
.802 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48071 .57526 m .49483 .56827 L .56101 .63576 L p
.729 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45261 .90987 m .43941 .91037 L .36826 .75413 L p
.833 0 1 r
F P
0 0 0 r
s
P
p
.63859 .3098 m .71048 .35197 L .69629 .35458 L 1 .865 0 r
F
P
p
.62382 .31274 m .63859 .3098 L .69629 .35458 L 1 .906 0 r
F
P
p
.3397 .30934 m .42889 .35157 L .41576 .35418 L 0 1 .188 r
F
P
p
.32612 .31229 m .3397 .30934 L .41576 .35418 L 0 .802 1 r
F
P
p
.002 w
.58842 .63267 m .57466 .63422 L .50904 .56381 L p
.813 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49483 .56827 m .50904 .56381 L .57466 .63422 L p
.802 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46592 .90937 m .45261 .90987 L .38177 .75299 L p
.833 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.36826 .75413 m .38177 .75299 L .45261 .90987 L p
.833 0 1 r
F P
0 0 0 r
s
P
p
.65347 .30683 m .72478 .34934 L .71048 .35197 L 1 .833 0 r
F
P
p
.63859 .3098 m .65347 .30683 L .71048 .35197 L 1 .865 0 r
F
P
p
.35338 .30637 m .44212 .34893 L .42889 .35157 L .354 1 0 r
F
P
p
.3397 .30934 m .35338 .30637 L .42889 .35157 L 0 1 .188 r
F
P
p
.002 w
.60225 .62865 m .58842 .63267 L .52334 .56188 L p
.823 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50904 .56381 m .52334 .56188 L .58842 .63267 L p
.813 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47933 .90887 m .46592 .90937 L .3954 .75185 L p
.365 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38177 .75299 m .3954 .75185 L .46592 .90937 L p
.833 0 1 r
F P
0 0 0 r
s
P
p
.66848 .30384 m .73919 .34669 L .72478 .34934 L 1 .813 0 r
F
P
p
.65347 .30683 m .66848 .30384 L .72478 .34934 L 1 .833 0 r
F
P
p
.36718 .30338 m .45545 .34628 L .44212 .34893 L .417 1 0 r
F
P
p
.35338 .30637 m .36718 .30338 L .44212 .34893 L .354 1 0 r
F
P
p
.002 w
.61619 .6246 m .60225 .62865 L .53776 .55994 L p
.844 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52334 .56188 m .53776 .55994 L .60225 .62865 L p
.823 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3954 .75185 m .41107 .63476 L .47933 .90887 L p
.365 0 1 r
F P
0 0 0 r
s
P
p
.68361 .30083 m .75371 .34401 L .73919 .34669 L 1 .792 0 r
F
P
p
.66848 .30384 m .68361 .30083 L .73919 .34669 L 1 .813 0 r
F
P
p
.38108 .30036 m .46889 .3436 L .45545 .34628 L .635 1 0 r
F
P
p
.36718 .30338 m .38108 .30036 L .45545 .34628 L .417 1 0 r
F
P
p
.002 w
.63013 .61311 m .61619 .6246 L .5523 .55798 L p
.896 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53776 .55994 m .5523 .55798 L .61619 .6246 L p
.844 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64428 .61145 m .63013 .61311 L .56696 .556 L p
.938 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5523 .55798 m .56696 .556 L .63013 .61311 L p
.896 1 0 r
F P
0 0 0 r
s
P
p
.69887 .29779 m .76835 .34132 L .75371 .34401 L 1 .719 0 r
F
P
p
.68361 .30083 m .69887 .29779 L .75371 .34401 L 1 .792 0 r
F
P
p
.39511 .29732 m .48243 .3409 L .46889 .3436 L .813 1 0 r
F
P
p
.38108 .30036 m .39511 .29732 L .46889 .3436 L .635 1 0 r
F
P
p
.002 w
.65842 .60234 m .64428 .61145 L .58174 .55401 L p
.969 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56696 .556 m .58174 .55401 L .64428 .61145 L p
.938 1 0 r
F P
0 0 0 r
s
P
p
.71425 .29472 m .78309 .3386 L .76835 .34132 L 1 .656 0 r
F
P
p
.69887 .29779 m .71425 .29472 L .76835 .34132 L 1 .719 0 r
F
P
p
.40924 .29425 m .49607 .33818 L .48243 .3409 L .875 1 0 r
F
P
p
.39511 .29732 m .40924 .29425 L .48243 .3409 L .813 1 0 r
F
P
p
.002 w
.67273 .59814 m .65842 .60234 L .59664 .55201 L p
1 .969 0 r
F P
0 0 0 r
s
P
p
.002 w
.58174 .55401 m .59664 .55201 L .65842 .60234 L p
.969 1 0 r
F P
0 0 0 r
s
P
p
.72976 .29163 m .79796 .33587 L .78309 .3386 L 1 .583 0 r
F
P
p
.71425 .29472 m .72976 .29163 L .78309 .3386 L 1 .656 0 r
F
P
p
.4235 .29116 m .50983 .33544 L .49607 .33818 L .927 1 0 r
F
P
p
.40924 .29425 m .4235 .29116 L .49607 .33818 L .875 1 0 r
F
P
p
.002 w
.6872 .59641 m .67273 .59814 L .6116 .54472 L p
1 .938 0 r
F P
0 0 0 r
s
P
p
.002 w
.59664 .55201 m .6116 .54472 L .67273 .59814 L p
1 .969 0 r
F P
0 0 0 r
s
P
p
.7454 .28852 m .81293 .33311 L .79796 .33587 L 1 .448 0 r
F
P
p
.72976 .29163 m .7454 .28852 L .79796 .33587 L 1 .583 0 r
F
P
p
.43787 .28804 m .52368 .33268 L .50983 .33544 L .99 1 0 r
F
P
p
.4235 .29116 m .43787 .28804 L .50983 .33544 L .927 1 0 r
F
P
p
.002 w
.70161 .58715 m .6872 .59641 L .62674 .54266 L p
1 .906 0 r
F P
0 0 0 r
s
P
p
.002 w
.6116 .54472 m .62674 .54266 L .6872 .59641 L p
1 .938 0 r
F P
0 0 0 r
s
P
p
.76117 .28538 m .82803 .33033 L .81293 .33311 L 1 .354 0 r
F
P
p
.7454 .28852 m .76117 .28538 L .81293 .33311 L 1 .448 0 r
F
P
p
.45237 .28489 m .53765 .3299 L .52368 .33268 L 1 .948 0 r
F
P
p
.43787 .28804 m .45237 .28489 L .52368 .33268 L .99 1 0 r
F
P
p
.002 w
.71629 .58537 m .70161 .58715 L .642 .54058 L p
1 .865 0 r
F P
0 0 0 r
s
P
p
.002 w
.62674 .54266 m .642 .54058 L .70161 .58715 L p
1 .906 0 r
F P
0 0 0 r
s
P
p
.77707 .28221 m .84324 .32753 L .82803 .33033 L 1 .292 0 r
F
P
p
.76117 .28538 m .77707 .28221 L .82803 .33033 L 1 .354 0 r
F
P
p
.46698 .28172 m .55173 .3271 L .53765 .3299 L 1 .927 0 r
F
P
p
.45237 .28489 m .46698 .28172 L .53765 .3299 L 1 .948 0 r
F
P
p
.002 w
.73108 .58357 m .71629 .58537 L .65735 .53583 L p
1 .833 0 r
F P
0 0 0 r
s
P
p
.002 w
.642 .54058 m .65735 .53583 L .71629 .58537 L p
1 .865 0 r
F P
0 0 0 r
s
P
p
.7931 .27902 m .85858 .32471 L .84324 .32753 L 1 .208 0 r
F
P
p
.77707 .28221 m .7931 .27902 L .84324 .32753 L 1 .292 0 r
F
P
p
.48172 .27852 m .56592 .32427 L .55173 .3271 L 1 .885 0 r
F
P
p
.46698 .28172 m .48172 .27852 L .55173 .3271 L 1 .927 0 r
F
P
p
.002 w
.41107 .63476 m .3954 .75185 L .31373 .73193 L p
0 .802 1 r
F P
0 0 0 r
s
P
p
.002 w
.31373 .73193 m .32806 .7306 L .41107 .63476 L p
0 .802 1 r
F P
0 0 0 r
s
P
p
.002 w
.42496 .61537 m .41107 .63476 L .32806 .7306 L p
0 1 .188 r
F P
0 0 0 r
s
P
p
.002 w
.746 .58176 m .73108 .58357 L .67276 .52837 L p
1 .813 0 r
F P
0 0 0 r
s
P
p
.002 w
.65735 .53583 m .67276 .52837 L .73108 .58357 L p
1 .833 0 r
F P
0 0 0 r
s
P
p
.002 w
.43867 .61368 m .42496 .61537 L .3457 .60528 L p
.354 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32806 .7306 m .3457 .60528 L .42496 .61537 L p
0 1 .188 r
F P
0 0 0 r
s
P
p
.80927 .2758 m .87403 .32186 L .85858 .32471 L 1 .167 0 r
F
P
p
.7931 .27902 m .80927 .2758 L .85858 .32471 L 1 .208 0 r
F
P
p
.002 w
.38177 .75299 m .36826 .75413 L .28543 .73454 L p
0 .333 1 r
F P
0 0 0 r
s
P
p
.49658 .2753 m .58022 .32142 L .56592 .32427 L 1 .854 0 r
F
P
p
.48172 .27852 m .49658 .2753 L .56592 .32427 L 1 .885 0 r
F
P
p
.002 w
.76103 .57993 m .746 .58176 L .6884 .52621 L p
1 .792 0 r
F P
0 0 0 r
s
P
p
.002 w
.67276 .52837 m .6884 .52621 L .746 .58176 L p
1 .813 0 r
F P
0 0 0 r
s
P
p
.002 w
.45264 .59924 m .43867 .61368 L .36005 .60343 L p
.417 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3457 .60528 m .36005 .60343 L .43867 .61368 L p
.354 1 0 r
F P
0 0 0 r
s
P
p
.82558 .27255 m .88961 .31899 L .87403 .32186 L 1 .115 0 r
F
P
p
.80927 .2758 m .82558 .27255 L .87403 .32186 L 1 .167 0 r
F
P
p
.002 w
.3954 .75185 m .38177 .75299 L .29952 .73324 L p
0 .333 1 r
F P
0 0 0 r
s
P
p
.002 w
.28543 .73454 m .29952 .73324 L .38177 .75299 L p
0 .333 1 r
F P
0 0 0 r
s
P
p
.002 w
.46673 .57711 m .45264 .59924 L .37458 .59883 L p
.635 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36005 .60343 m .37458 .59883 L .45264 .59924 L p
.417 1 0 r
F P
0 0 0 r
s
P
p
.51157 .27205 m .59464 .31855 L .58022 .32142 L 1 .844 0 r
F
P
p
.49658 .2753 m .51157 .27205 L .58022 .32142 L 1 .854 0 r
F
P
p
.002 w
.77584 .56791 m .76103 .57993 L .70404 .51866 L p
1 .719 0 r
F P
0 0 0 r
s
P
p
.002 w
.6884 .52621 m .70404 .51866 L .76103 .57993 L p
1 .792 0 r
F P
0 0 0 r
s
P
p
.002 w
.48071 .57526 m .46673 .57711 L .38955 .57781 L p
.813 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37458 .59883 m .38955 .57781 L .46673 .57711 L p
.635 1 0 r
F P
0 0 0 r
s
P
p
.84202 .26927 m .90532 .3161 L .88961 .31899 L 1 .052 0 r
F
P
p
.82558 .27255 m .84202 .26927 L .88961 .31899 L 1 .115 0 r
F
P
p
.002 w
.79109 .56601 m .77584 .56791 L .71986 .51375 L p
1 .656 0 r
F P
0 0 0 r
s
P
p
.002 w
.70404 .51866 m .71986 .51375 L .77584 .56791 L p
1 .719 0 r
F P
0 0 0 r
s
P
p
.002 w
.29952 .73324 m .31373 .73193 L .3954 .75185 L p
0 .333 1 r
F P
0 0 0 r
s
P
p
.52669 .26877 m .60917 .31566 L .59464 .31855 L 1 .813 0 r
F
P
p
.51157 .27205 m .52669 .26877 L .59464 .31855 L 1 .844 0 r
F
P
p
.21094 .26826 m .31266 .31521 L .2993 .31811 L 0 1 .719 r
F
P
p
.002 w
.49483 .56827 m .48071 .57526 L .40433 .57035 L p
.875 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.38955 .57781 m .40433 .57035 L .48071 .57526 L p
.813 1 0 r
F P
0 0 0 r
s
P
p
.85861 .26597 m .92115 .31319 L .90532 .3161 L 1 .021 0 r
F
P
p
.84202 .26927 m .85861 .26597 L .90532 .3161 L 1 .052 0 r
F
P
p
.002 w
.80618 .55643 m .79109 .56601 L .7358 .5088 L p
1 .583 0 r
F P
0 0 0 r
s
P
p
.002 w
.71986 .51375 m .7358 .5088 L .79109 .56601 L p
1 .656 0 r
F P
0 0 0 r
s
P
p
.54194 .26546 m .62382 .31274 L .60917 .31566 L 1 .792 0 r
F
P
p
.52669 .26877 m .54194 .26546 L .60917 .31566 L 1 .813 0 r
F
P
p
.002 w
.50904 .56381 m .49483 .56827 L .41921 .56284 L p
.927 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.40433 .57035 m .41921 .56284 L .49483 .56827 L p
.875 1 0 r
F P
0 0 0 r
s
P
p
.22484 .26495 m .32612 .31229 L .31266 .31521 L 0 1 .542 r
F
P
p
.21094 .26826 m .22484 .26495 L .31266 .31521 L 0 1 .719 r
F
P
p
.002 w
.82095 .53656 m .80618 .55643 L .75171 .49841 L p
1 .448 0 r
F P
0 0 0 r
s
P
p
.002 w
.7358 .5088 m .75171 .49841 L .80618 .55643 L p
1 .583 0 r
F P
0 0 0 r
s
P
p
.85861 .26597 m .87534 .26264 L .92115 .31319 L 1 .021 0 r
F
P
p
.55731 .26212 m .63859 .3098 L .62382 .31274 L 1 .771 0 r
F
P
p
.54194 .26546 m .55731 .26212 L .62382 .31274 L 1 .792 0 r
F
P
p
.002 w
.83631 .52941 m .82095 .53656 L .76798 .49608 L p
1 .354 0 r
F P
0 0 0 r
s
P
p
.002 w
.75171 .49841 m .76798 .49608 L .82095 .53656 L p
1 .448 0 r
F P
0 0 0 r
s
P
p
.002 w
.52334 .56188 m .50904 .56381 L .43413 .56077 L p
.99 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41921 .56284 m .43413 .56077 L .50904 .56381 L p
.927 1 0 r
F P
0 0 0 r
s
P
p
.23887 .2616 m .3397 .30934 L .32612 .31229 L 0 1 .469 r
F
P
p
.22484 .26495 m .23887 .2616 L .32612 .31229 L 0 1 .542 r
F
P
p
.002 w
.85198 .52733 m .83631 .52941 L .78438 .49372 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.76798 .49608 m .78438 .49372 L .83631 .52941 L p
1 .354 0 r
F P
0 0 0 r
s
P
p
.57282 .25875 m .65347 .30683 L .63859 .3098 L 1 .74 0 r
F
P
p
.55731 .26212 m .57282 .25875 L .63859 .3098 L 1 .771 0 r
F
P
p
.002 w
.53776 .55994 m .52334 .56188 L .44933 .54491 L p
1 .948 0 r
F P
0 0 0 r
s
P
p
.002 w
.43413 .56077 m .44933 .54491 L .52334 .56188 L p
.99 1 0 r
F P
0 0 0 r
s
P
p
.25301 .25823 m .35338 .30637 L .3397 .30934 L .01 1 0 r
F
P
p
.23887 .2616 m .25301 .25823 L .3397 .30934 L 0 1 .469 r
F
P
p
.002 w
.86732 .51495 m .85198 .52733 L .80053 .48043 L p
1 .208 0 r
F P
0 0 0 r
s
P
p
.002 w
.78438 .49372 m .80053 .48043 L .85198 .52733 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.58847 .25536 m .66848 .30384 L .65347 .30683 L 1 .708 0 r
F
P
p
.57282 .25875 m .58847 .25536 L .65347 .30683 L 1 .74 0 r
F
P
p
.002 w
.5523 .55798 m .53776 .55994 L .4645 .53999 L p
1 .927 0 r
F P
0 0 0 r
s
P
p
.002 w
.44933 .54491 m .4645 .53999 L .53776 .55994 L p
1 .948 0 r
F P
0 0 0 r
s
P
p
.26728 .25484 m .36718 .30338 L .35338 .30637 L .479 1 0 r
F
P
p
.25301 .25823 m .26728 .25484 L .35338 .30637 L .01 1 0 r
F
P
p
.002 w
.88323 .5128 m .86732 .51495 L .8172 .47799 L p
1 .167 0 r
F P
0 0 0 r
s
P
p
.002 w
.80053 .48043 m .8172 .47799 L .86732 .51495 L p
1 .208 0 r
F P
0 0 0 r
s
P
p
.60425 .25194 m .68361 .30083 L .66848 .30384 L 1 .677 0 r
F
P
p
.58847 .25536 m .60425 .25194 L .66848 .30384 L 1 .708 0 r
F
P
p
.002 w
.56696 .556 m .5523 .55798 L .4798 .53503 L p
1 .885 0 r
F P
0 0 0 r
s
P
p
.002 w
.4645 .53999 m .4798 .53503 L .5523 .55798 L p
1 .927 0 r
F P
0 0 0 r
s
P
p
.28167 .25141 m .38108 .30036 L .36718 .30338 L .49 1 0 r
F
P
p
.26728 .25484 m .28167 .25141 L .36718 .30338 L .479 1 0 r
F
P
p
.002 w
.89875 .50029 m .88323 .5128 L .83402 .47553 L p
1 .115 0 r
F P
0 0 0 r
s
P
p
.002 w
.8172 .47799 m .83402 .47553 L .88323 .5128 L p
1 .167 0 r
F P
0 0 0 r
s
P
p
.62017 .24848 m .69887 .29779 L .68361 .30083 L 1 .646 0 r
F
P
p
.60425 .25194 m .62017 .24848 L .68361 .30083 L 1 .677 0 r
F
P
p
.002 w
.58174 .55401 m .56696 .556 L .49524 .52448 L p
1 .854 0 r
F P
0 0 0 r
s
P
p
.002 w
.4798 .53503 m .49524 .52448 L .56696 .556 L p
1 .885 0 r
F P
0 0 0 r
s
P
p
.002 w
.91489 .49807 m .89875 .50029 L .85086 .47029 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.83402 .47553 m .85086 .47029 L .89875 .50029 L p
1 .115 0 r
F P
0 0 0 r
s
P
p
.29619 .24795 m .39511 .29732 L .38108 .30036 L .573 1 0 r
F
P
p
.28167 .25141 m .29619 .24795 L .38108 .30036 L .49 1 0 r
F
P
p
.63623 .245 m .71425 .29472 L .69887 .29779 L 1 .594 0 r
F
P
p
.62017 .24848 m .63623 .245 L .69887 .29779 L 1 .646 0 r
F
P
p
.002 w
.59664 .55201 m .58174 .55401 L .51076 .5222 L p
1 .844 0 r
F P
0 0 0 r
s
P
p
.002 w
.49524 .52448 m .51076 .5222 L .58174 .55401 L p
1 .854 0 r
F P
0 0 0 r
s
P
p
.002 w
.93117 .49583 m .91489 .49807 L .86783 .46501 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.002 w
.85086 .47029 m .86783 .46501 L .91489 .49807 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.31083 .24446 m .40924 .29425 L .39511 .29732 L .667 1 0 r
F
P
p
.29619 .24795 m .31083 .24446 L .39511 .29732 L .573 1 0 r
F
P
p
.65244 .24148 m .72976 .29163 L .71425 .29472 L 1 .531 0 r
F
P
p
.63623 .245 m .65244 .24148 L .71425 .29472 L 1 .594 0 r
F
P
p
.002 w
.6116 .54472 m .59664 .55201 L .52642 .51712 L p
1 .813 0 r
F P
0 0 0 r
s
P
p
.002 w
.51076 .5222 m .52642 .51712 L .59664 .55201 L p
1 .844 0 r
F P
0 0 0 r
s
P
p
.002 w
.86783 .46501 m .88481 .45691 L .93117 .49583 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.32561 .24094 m .4235 .29116 L .40924 .29425 L .708 1 0 r
F
P
p
.31083 .24446 m .32561 .24094 L .40924 .29425 L .667 1 0 r
F
P
p
.002 w
.62674 .54266 m .6116 .54472 L .54221 .51479 L p
1 .792 0 r
F P
0 0 0 r
s
P
p
.002 w
.52642 .51712 m .54221 .51479 L .6116 .54472 L p
1 .813 0 r
F P
0 0 0 r
s
P
p
.66878 .23793 m .7454 .28852 L .72976 .29163 L 1 .469 0 r
F
P
p
.65244 .24148 m .66878 .23793 L .72976 .29163 L 1 .531 0 r
F
P
p
.34051 .23738 m .43787 .28804 L .4235 .29116 L .74 1 0 r
F
P
p
.32561 .24094 m .34051 .23738 L .4235 .29116 L .708 1 0 r
F
P
p
.002 w
.642 .54058 m .62674 .54266 L .55814 .51245 L p
1 .771 0 r
F P
0 0 0 r
s
P
p
.002 w
.54221 .51479 m .55814 .51245 L .62674 .54266 L p
1 .792 0 r
F P
0 0 0 r
s
P
p
.68527 .23435 m .76117 .28538 L .7454 .28852 L 1 .438 0 r
F
P
p
.66878 .23793 m .68527 .23435 L .7454 .28852 L 1 .469 0 r
F
P
p
.35555 .2338 m .45237 .28489 L .43787 .28804 L .896 1 0 r
F
P
p
.34051 .23738 m .35555 .2338 L .43787 .28804 L .74 1 0 r
F
P
p
.002 w
.65735 .53583 m .642 .54058 L .57418 .50443 L p
1 .74 0 r
F P
0 0 0 r
s
P
p
.002 w
.55814 .51245 m .57418 .50443 L .642 .54058 L p
1 .771 0 r
F P
0 0 0 r
s
P
p
.70191 .23074 m .77707 .28221 L .76117 .28538 L 1 .438 0 r
F
P
p
.68527 .23435 m .70191 .23074 L .76117 .28538 L 1 .438 0 r
F
P
p
.37072 .23019 m .46698 .28172 L .45237 .28489 L 1 .938 0 r
F
P
p
.35555 .2338 m .37072 .23019 L .45237 .28489 L .896 1 0 r
F
P
p
.002 w
.67276 .52837 m .65735 .53583 L .59038 .50201 L p
1 .708 0 r
F P
0 0 0 r
s
P
p
.002 w
.57418 .50443 m .59038 .50201 L .65735 .53583 L p
1 .74 0 r
F P
0 0 0 r
s
P
p
.7187 .2271 m .7931 .27902 L .77707 .28221 L 1 .385 0 r
F
P
p
.70191 .23074 m .7187 .2271 L .77707 .28221 L 1 .438 0 r
F
P
p
.38603 .22654 m .48172 .27852 L .46698 .28172 L 1 .906 0 r
F
P
p
.37072 .23019 m .38603 .22654 L .46698 .28172 L 1 .938 0 r
F
P
p
.002 w
.6884 .52621 m .67276 .52837 L .60673 .49958 L p
1 .677 0 r
F P
0 0 0 r
s
P
p
.002 w
.59038 .50201 m .60673 .49958 L .67276 .52837 L p
1 .708 0 r
F P
0 0 0 r
s
P
p
.73564 .22343 m .80927 .2758 L .7931 .27902 L 1 .313 0 r
F
P
p
.7187 .2271 m .73564 .22343 L .7931 .27902 L 1 .385 0 r
F
P
p
.40148 .22286 m .49658 .2753 L .48172 .27852 L 1 .854 0 r
F
P
p
.38603 .22654 m .40148 .22286 L .48172 .27852 L 1 .906 0 r
F
P
p
.002 w
.70404 .51866 m .6884 .52621 L .6232 .49427 L p
1 .646 0 r
F P
0 0 0 r
s
P
p
.002 w
.60673 .49958 m .6232 .49427 L .6884 .52621 L p
1 .677 0 r
F P
0 0 0 r
s
P
p
.75274 .21972 m .82558 .27255 L .80927 .2758 L 1 .26 0 r
F
P
p
.73564 .22343 m .75274 .21972 L .80927 .2758 L 1 .313 0 r
F
P
p
.002 w
.29952 .73324 m .28543 .73454 L .19581 .59593 L p
0 1 .719 r
F P
0 0 0 r
s
P
p
.41707 .21914 m .51157 .27205 L .49658 .2753 L 1 .813 0 r
F
P
p
.40148 .22286 m .41707 .21914 L .49658 .2753 L 1 .854 0 r
F
P
p
.002 w
.36005 .60343 m .3457 .60528 L .25654 .53587 L p
.479 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3457 .60528 m .32806 .7306 L .24175 .53814 L p
.01 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24175 .53814 m .25654 .53587 L .3457 .60528 L p
.01 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71986 .51375 m .70404 .51866 L .63984 .49178 L p
1 .594 0 r
F P
0 0 0 r
s
P
p
.002 w
.6232 .49427 m .63984 .49178 L .70404 .51866 L p
1 .646 0 r
F P
0 0 0 r
s
P
p
.76999 .21597 m .84202 .26927 L .82558 .27255 L 1 .188 0 r
F
P
p
.75274 .21972 m .76999 .21597 L .82558 .27255 L 1 .26 0 r
F
P
p
.002 w
.31373 .73193 m .29952 .73324 L .21169 .56249 L p
0 1 .542 r
F P
0 0 0 r
s
P
p
.002 w
.19581 .59593 m .21169 .56249 L .29952 .73324 L p
0 1 .719 r
F P
0 0 0 r
s
P
p
.4328 .21539 m .52669 .26877 L .51157 .27205 L 1 .76 0 r
F
P
p
.41707 .21914 m .4328 .21539 L .51157 .27205 L 1 .813 0 r
F
P
p
.002 w
.37458 .59883 m .36005 .60343 L .27146 .53358 L p
.49 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25654 .53587 m .27146 .53358 L .36005 .60343 L p
.479 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7358 .5088 m .71986 .51375 L .65653 .48351 L p
1 .531 0 r
F P
0 0 0 r
s
P
p
.002 w
.63984 .49178 m .65653 .48351 L .71986 .51375 L p
1 .594 0 r
F P
0 0 0 r
s
P
p
.78739 .2122 m .85861 .26597 L .84202 .26927 L 1 .135 0 r
F
P
p
.76999 .21597 m .78739 .2122 L .84202 .26927 L 1 .188 0 r
F
P
p
.002 w
.38955 .57781 m .37458 .59883 L .28652 .53127 L p
.573 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27146 .53358 m .28652 .53127 L .37458 .59883 L p
.49 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32806 .7306 m .31373 .73193 L .22697 .54324 L p
0 1 .469 r
F P
0 0 0 r
s
P
p
.002 w
.21169 .56249 m .22697 .54324 L .31373 .73193 L p
0 1 .542 r
F P
0 0 0 r
s
P
p
.44868 .21161 m .54194 .26546 L .52669 .26877 L 1 .698 0 r
F
P
p
.4328 .21539 m .44868 .21161 L .52669 .26877 L 1 .76 0 r
F
P
p
.002 w
.75171 .49841 m .7358 .5088 L .67336 .47517 L p
1 .469 0 r
F P
0 0 0 r
s
P
p
.002 w
.65653 .48351 m .67336 .47517 L .7358 .5088 L p
1 .531 0 r
F P
0 0 0 r
s
P
p
.10948 .21103 m .22484 .26495 L .21094 .26826 L .698 1 0 r
F
P
p
.002 w
.40433 .57035 m .38955 .57781 L .30172 .52893 L p
.667 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28652 .53127 m .30172 .52893 L .38955 .57781 L p
.573 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.76798 .49608 m .75171 .49841 L .69043 .47256 L p
1 .438 0 r
F P
0 0 0 r
s
P
p
.002 w
.67336 .47517 m .69043 .47256 L .75171 .49841 L p
1 .469 0 r
F P
0 0 0 r
s
P
p
.80496 .20838 m .87534 .26264 L .85861 .26597 L 1 .063 0 r
F
P
p
.78739 .2122 m .80496 .20838 L .85861 .26597 L 1 .135 0 r
F
P
p
.002 w
.22697 .54324 m .24175 .53814 L .32806 .7306 L p
0 1 .469 r
F P
0 0 0 r
s
P
p
.4647 .20779 m .55731 .26212 L .54194 .26546 L 1 .688 0 r
F
P
p
.44868 .21161 m .4647 .20779 L .54194 .26546 L 1 .698 0 r
F
P
p
.12396 .2072 m .23887 .2616 L .22484 .26495 L .948 1 0 r
F
P
p
.10948 .21103 m .12396 .2072 L .22484 .26495 L .698 1 0 r
F
P
p
.002 w
.41921 .56284 m .40433 .57035 L .31706 .52658 L p
.708 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30172 .52893 m .31706 .52658 L .40433 .57035 L p
.667 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.78438 .49372 m .76798 .49608 L .70767 .46993 L p
1 .438 0 r
F P
0 0 0 r
s
P
p
.002 w
.69043 .47256 m .70767 .46993 L .76798 .49608 L p
1 .438 0 r
F P
0 0 0 r
s
P
p
.80496 .20838 m .82269 .20454 L .87534 .26264 L 1 .063 0 r
F
P
p
.002 w
.43413 .56077 m .41921 .56284 L .33254 .5242 L p
.74 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31706 .52658 m .33254 .5242 L .41921 .56284 L p
.708 1 0 r
F P
0 0 0 r
s
P
p
.48087 .20394 m .57282 .25875 L .55731 .26212 L 1 .667 0 r
F
P
p
.4647 .20779 m .48087 .20394 L .55731 .26212 L 1 .688 0 r
F
P
p
.13856 .20334 m .25301 .25823 L .23887 .2616 L 1 .906 0 r
F
P
p
.12396 .2072 m .13856 .20334 L .23887 .2616 L .948 1 0 r
F
P
p
.002 w
.80053 .48043 m .78438 .49372 L .72506 .46727 L p
1 .385 0 r
F P
0 0 0 r
s
P
p
.002 w
.70767 .46993 m .72506 .46727 L .78438 .49372 L p
1 .438 0 r
F P
0 0 0 r
s
P
p
.002 w
.44933 .54491 m .43413 .56077 L .34824 .51886 L p
.896 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33254 .5242 m .34824 .51886 L .43413 .56077 L p
.74 1 0 r
F P
0 0 0 r
s
P
p
.49719 .20005 m .58847 .25536 L .57282 .25875 L 1 .615 0 r
F
P
p
.48087 .20394 m .49719 .20005 L .57282 .25875 L 1 .667 0 r
F
P
p
.1533 .19945 m .26728 .25484 L .25301 .25823 L 1 .865 0 r
F
P
p
.13856 .20334 m .1533 .19945 L .25301 .25823 L 1 .906 0 r
F
P
p
.002 w
.8172 .47799 m .80053 .48043 L .74254 .46166 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.002 w
.72506 .46727 m .74254 .46166 L .80053 .48043 L p
1 .385 0 r
F P
0 0 0 r
s
P
p
.002 w
.4645 .53999 m .44933 .54491 L .36462 .48997 L p
1 .938 0 r
F P
0 0 0 r
s
P
p
.002 w
.34824 .51886 m .36462 .48997 L .44933 .54491 L p
.896 1 0 r
F P
0 0 0 r
s
P
p
.51366 .19613 m .60425 .25194 L .58847 .25536 L 1 .563 0 r
F
P
p
.49719 .20005 m .51366 .19613 L .58847 .25536 L 1 .615 0 r
F
P
p
.16818 .19552 m .28167 .25141 L .26728 .25484 L 1 .833 0 r
F
P
p
.1533 .19945 m .16818 .19552 L .26728 .25484 L 1 .865 0 r
F
P
p
.002 w
.4798 .53503 m .4645 .53999 L .38054 .48446 L p
1 .906 0 r
F P
0 0 0 r
s
P
p
.002 w
.36462 .48997 m .38054 .48446 L .4645 .53999 L p
1 .938 0 r
F P
0 0 0 r
s
P
p
.002 w
.83402 .47553 m .8172 .47799 L .76007 .45305 L p
1 .26 0 r
F P
0 0 0 r
s
P
p
.002 w
.74254 .46166 m .76007 .45305 L .8172 .47799 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.53029 .19217 m .62017 .24848 L .60425 .25194 L 1 .531 0 r
F
P
p
.51366 .19613 m .53029 .19217 L .60425 .25194 L 1 .563 0 r
F
P
p
.18319 .19155 m .29619 .24795 L .28167 .25141 L 1 .802 0 r
F
P
p
.16818 .19552 m .18319 .19155 L .28167 .25141 L 1 .833 0 r
F
P
p
.002 w
.49524 .52448 m .4798 .53503 L .39654 .48185 L p
1 .854 0 r
F P
0 0 0 r
s
P
p
.002 w
.38054 .48446 m .39654 .48185 L .4798 .53503 L p
1 .906 0 r
F P
0 0 0 r
s
P
p
.002 w
.85086 .47029 m .83402 .47553 L .77763 .44143 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.002 w
.76007 .45305 m .77763 .44143 L .83402 .47553 L p
1 .26 0 r
F P
0 0 0 r
s
P
p
.54707 .18817 m .63623 .245 L .62017 .24848 L 1 .49 0 r
F
P
p
.53029 .19217 m .54707 .18817 L .62017 .24848 L 1 .531 0 r
F
P
p
.002 w
.51076 .5222 m .49524 .52448 L .41274 .47625 L p
1 .813 0 r
F P
0 0 0 r
s
P
p
.002 w
.39654 .48185 m .41274 .47625 L .49524 .52448 L p
1 .854 0 r
F P
0 0 0 r
s
P
p
.19835 .18755 m .31083 .24446 L .29619 .24795 L 1 .792 0 r
F
P
p
.18319 .19155 m .19835 .18755 L .29619 .24795 L 1 .802 0 r
F
P
p
.002 w
.86783 .46501 m .85086 .47029 L .79532 .42973 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.002 w
.77763 .44143 m .79532 .42973 L .85086 .47029 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.56402 .18413 m .65244 .24148 L .63623 .245 L 1 .427 0 r
F
P
p
.54707 .18817 m .56402 .18413 L .63623 .245 L 1 .49 0 r
F
P
p
.002 w
.52642 .51712 m .51076 .5222 L .42903 .47358 L p
1 .76 0 r
F P
0 0 0 r
s
P
p
.002 w
.41274 .47625 m .42903 .47358 L .51076 .5222 L p
1 .813 0 r
F P
0 0 0 r
s
P
p
.21366 .1835 m .32561 .24094 L .31083 .24446 L 1 .792 0 r
F
P
p
.19835 .18755 m .21366 .1835 L .31083 .24446 L 1 .792 0 r
F
P
p
.002 w
.88481 .45691 m .86783 .46501 L .81348 .42683 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.79532 .42973 m .81348 .42683 L .86783 .46501 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.58112 .18005 m .66878 .23793 L .65244 .24148 L 1 .375 0 r
F
P
p
.56402 .18413 m .58112 .18005 L .65244 .24148 L 1 .427 0 r
F
P
p
.002 w
.54221 .51479 m .52642 .51712 L .44563 .45895 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.42903 .47358 m .44563 .45895 L .52642 .51712 L p
1 .76 0 r
F P
0 0 0 r
s
P
p
.002 w
.81348 .42683 m .83132 .41201 L .88481 .45691 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.2291 .17942 m .34051 .23738 L .32561 .24094 L 1 .771 0 r
F
P
p
.21366 .1835 m .2291 .17942 L .32561 .24094 L 1 .792 0 r
F
P
p
.59839 .17594 m .68527 .23435 L .66878 .23793 L 1 .344 0 r
F
P
p
.58112 .18005 m .59839 .17594 L .66878 .23793 L 1 .375 0 r
F
P
p
.002 w
.55814 .51245 m .54221 .51479 L .46224 .45318 L p
1 .688 0 r
F P
0 0 0 r
s
P
p
.002 w
.44563 .45895 m .46224 .45318 L .54221 .51479 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.2447 .1753 m .35555 .2338 L .34051 .23738 L 1 .74 0 r
F
P
p
.2291 .17942 m .2447 .1753 L .34051 .23738 L 1 .771 0 r
F
P
p
.61582 .17179 m .70191 .23074 L .68527 .23435 L 1 .323 0 r
F
P
p
.59839 .17594 m .61582 .17179 L .68527 .23435 L 1 .344 0 r
F
P
p
.002 w
.57418 .50443 m .55814 .51245 L .47897 .45037 L p
1 .667 0 r
F P
0 0 0 r
s
P
p
.002 w
.46224 .45318 m .47897 .45037 L .55814 .51245 L p
1 .688 0 r
F P
0 0 0 r
s
P
p
.26045 .17114 m .37072 .23019 L .35555 .2338 L 1 .635 0 r
F
P
p
.2447 .1753 m .26045 .17114 L .35555 .2338 L 1 .74 0 r
F
P
p
.002 w
.21169 .56249 m .19581 .59593 L .09307 .47945 L p
.698 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.22697 .54324 m .21169 .56249 L .10838 .47074 L p
.948 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.09307 .47945 m .10838 .47074 L .21169 .56249 L p
.698 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59038 .50201 m .57418 .50443 L .49587 .44753 L p
1 .615 0 r
F P
0 0 0 r
s
P
p
.002 w
.47897 .45037 m .49587 .44753 L .57418 .50443 L p
1 .667 0 r
F P
0 0 0 r
s
P
p
.63342 .16759 m .7187 .2271 L .70191 .23074 L 1 .313 0 r
F
P
p
.61582 .17179 m .63342 .16759 L .70191 .23074 L 1 .323 0 r
F
P
p
.002 w
.24175 .53814 m .22697 .54324 L .12432 .45294 L p
1 .906 0 r
F P
0 0 0 r
s
P
p
.002 w
.10838 .47074 m .12432 .45294 L .22697 .54324 L p
.948 1 0 r
F P
0 0 0 r
s
P
p
.27635 .16694 m .38603 .22654 L .37072 .23019 L 1 .51 0 r
F
P
p
.26045 .17114 m .27635 .16694 L .37072 .23019 L 1 .635 0 r
F
P
p
.002 w
.60673 .49958 m .59038 .50201 L .51295 .43558 L p
1 .563 0 r
F P
0 0 0 r
s
P
p
.002 w
.49587 .44753 m .51295 .43558 L .59038 .50201 L p
1 .615 0 r
F P
0 0 0 r
s
P
p
.65119 .16336 m .73564 .22343 L .7187 .2271 L 1 .292 0 r
F
P
p
.63342 .16759 m .65119 .16336 L .7187 .2271 L 1 .313 0 r
F
P
p
.002 w
.25654 .53587 m .24175 .53814 L .13986 .44407 L p
1 .865 0 r
F P
0 0 0 r
s
P
p
.002 w
.12432 .45294 m .13986 .44407 L .24175 .53814 L p
1 .906 0 r
F P
0 0 0 r
s
P
p
.2924 .1627 m .40148 .22286 L .38603 .22654 L 1 .479 0 r
F
P
p
.27635 .16694 m .2924 .1627 L .38603 .22654 L 1 .51 0 r
F
P
p
.002 w
.6232 .49427 m .60673 .49958 L .53015 .42658 L p
1 .531 0 r
F P
0 0 0 r
s
P
p
.002 w
.51295 .43558 m .53015 .42658 L .60673 .49958 L p
1 .563 0 r
F P
0 0 0 r
s
P
p
.66914 .15908 m .75274 .21972 L .73564 .22343 L 1 .24 0 r
F
P
p
.65119 .16336 m .66914 .15908 L .73564 .22343 L 1 .292 0 r
F
P
p
.002 w
.27146 .53358 m .25654 .53587 L .15536 .43816 L p
1 .833 0 r
F P
0 0 0 r
s
P
p
.002 w
.13986 .44407 m .15536 .43816 L .25654 .53587 L p
1 .865 0 r
F P
0 0 0 r
s
P
p
.30861 .15842 m .41707 .21914 L .40148 .22286 L 1 .469 0 r
F
P
p
.2924 .1627 m .30861 .15842 L .40148 .22286 L 1 .479 0 r
F
P
p
.002 w
.63984 .49178 m .6232 .49427 L .54751 .42359 L p
1 .49 0 r
F P
0 0 0 r
s
P
p
.002 w
.53015 .42658 m .54751 .42359 L .6232 .49427 L p
1 .531 0 r
F P
0 0 0 r
s
P
p
.68726 .15476 m .76999 .21597 L .75274 .21972 L 1 .177 0 r
F
P
p
.66914 .15908 m .68726 .15476 L .75274 .21972 L 1 .24 0 r
F
P
p
.002 w
.28652 .53127 m .27146 .53358 L .17115 .42916 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.15536 .43816 m .17115 .42916 L .27146 .53358 L p
1 .833 0 r
F P
0 0 0 r
s
P
p
.32497 .1541 m .4328 .21539 L .41707 .21914 L 1 .458 0 r
F
P
p
.30861 .15842 m .32497 .1541 L .41707 .21914 L 1 .469 0 r
F
P
p
.002 w
.65653 .48351 m .63984 .49178 L .56499 .41141 L p
1 .427 0 r
F P
0 0 0 r
s
P
p
.002 w
.54751 .42359 m .56499 .41141 L .63984 .49178 L p
1 .49 0 r
F P
0 0 0 r
s
P
p
.70556 .1504 m .78739 .2122 L .76999 .21597 L 1 .115 0 r
F
P
p
.68726 .15476 m .70556 .1504 L .76999 .21597 L 1 .177 0 r
F
P
p
.002 w
.30172 .52893 m .28652 .53127 L .18692 .42313 L p
1 .792 0 r
F P
0 0 0 r
s
P
p
.002 w
.17115 .42916 m .18692 .42313 L .28652 .53127 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.3415 .14973 m .44868 .21161 L .4328 .21539 L 1 .406 0 r
F
P
p
.32497 .1541 m .3415 .14973 L .4328 .21539 L 1 .458 0 r
F
P
p
.002 w
.67336 .47517 m .65653 .48351 L .58264 .40526 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.56499 .41141 m .58264 .40526 L .65653 .48351 L p
1 .427 0 r
F P
0 0 0 r
s
P
p
.72404 .146 m .80496 .20838 L .78739 .2122 L 1 .083 0 r
F
P
p
.70556 .1504 m .72404 .146 L .78739 .2122 L 1 .115 0 r
F
P
p
.002 w
.31706 .52658 m .30172 .52893 L .20269 .4201 L p
1 .792 0 r
F P
0 0 0 r
s
P
p
.002 w
.18692 .42313 m .20269 .4201 L .30172 .52893 L p
1 .792 0 r
F P
0 0 0 r
s
P
p
.3582 .14532 m .4647 .20779 L .44868 .21161 L 1 .333 0 r
F
P
p
.3415 .14973 m .3582 .14532 L .44868 .21161 L 1 .406 0 r
F
P
p
.002 w
.69043 .47256 m .67336 .47517 L .60048 .40212 L p
1 .344 0 r
F P
0 0 0 r
s
P
p
.002 w
.58264 .40526 m .60048 .40212 L .67336 .47517 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.7427 .14155 m .82269 .20454 L .80496 .20838 L 1 .042 0 r
F
P
p
.72404 .146 m .7427 .14155 L .80496 .20838 L 1 .083 0 r
F
P
p
.002 w
.33254 .5242 m .31706 .52658 L .21862 .41704 L p
1 .771 0 r
F P
0 0 0 r
s
P
p
.002 w
.20269 .4201 m .21862 .41704 L .31706 .52658 L p
1 .792 0 r
F P
0 0 0 r
s
P
p
.37505 .14086 m .48087 .20394 L .4647 .20779 L 1 .313 0 r
F
P
p
.3582 .14532 m .37505 .14086 L .4647 .20779 L 1 .333 0 r
F
P
p
.002 w
.70767 .46993 m .69043 .47256 L .61846 .39586 L p
1 .323 0 r
F P
0 0 0 r
s
P
p
.002 w
.60048 .40212 m .61846 .39586 L .69043 .47256 L p
1 .344 0 r
F P
0 0 0 r
s
P
p
.7427 .14155 m .76155 .13706 L .82269 .20454 L 1 .042 0 r
F
P
p
.002 w
.34824 .51886 m .33254 .5242 L .23496 .40779 L p
1 .74 0 r
F P
0 0 0 r
s
P
p
.002 w
.21862 .41704 m .23496 .40779 L .33254 .5242 L p
1 .771 0 r
F P
0 0 0 r
s
P
p
.39208 .13637 m .49719 .20005 L .48087 .20394 L 1 .313 0 r
F
P
p
.37505 .14086 m .39208 .13637 L .48087 .20394 L 1 .313 0 r
F
P
p
.002 w
.72506 .46727 m .70767 .46993 L .63661 .38955 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.002 w
.61846 .39586 m .63661 .38955 L .70767 .46993 L p
1 .323 0 r
F P
0 0 0 r
s
P
p
.002 w
.36462 .48997 m .34824 .51886 L .25119 .40464 L p
1 .635 0 r
F P
0 0 0 r
s
P
p
.002 w
.23496 .40779 m .25119 .40464 L .34824 .51886 L p
1 .74 0 r
F P
0 0 0 r
s
P
p
.40928 .13182 m .51366 .19613 L .49719 .20005 L 1 .271 0 r
F
P
p
.39208 .13637 m .40928 .13182 L .49719 .20005 L 1 .313 0 r
F
P
p
.002 w
.38054 .48446 m .36462 .48997 L .26758 .40147 L p
1 .51 0 r
F P
0 0 0 r
s
P
p
.002 w
.25119 .40464 m .26758 .40147 L .36462 .48997 L p
1 .635 0 r
F P
0 0 0 r
s
P
p
.002 w
.74254 .46166 m .72506 .46727 L .65497 .38629 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.63661 .38955 m .65497 .38629 L .72506 .46727 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.002 w
.39654 .48185 m .38054 .48446 L .28436 .39202 L p
1 .479 0 r
F P
0 0 0 r
s
P
p
.002 w
.26758 .40147 m .28436 .39202 L .38054 .48446 L p
1 .51 0 r
F P
0 0 0 r
s
P
p
.42665 .12723 m .53029 .19217 L .51366 .19613 L 1 .208 0 r
F
P
p
.40928 .13182 m .42665 .12723 L .51366 .19613 L 1 .271 0 r
F
P
p
.002 w
.76007 .45305 m .74254 .46166 L .67346 .37988 L p
1 .24 0 r
F P
0 0 0 r
s
P
p
.002 w
.65497 .38629 m .67346 .37988 L .74254 .46166 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.41274 .47625 m .39654 .48185 L .30107 .38875 L p
1 .469 0 r
F P
0 0 0 r
s
P
p
.002 w
.28436 .39202 m .30107 .38875 L .39654 .48185 L p
1 .479 0 r
F P
0 0 0 r
s
P
p
.4442 .1226 m .54707 .18817 L .53029 .19217 L 1 .177 0 r
F
P
p
.42665 .12723 m .4442 .1226 L .53029 .19217 L 1 .208 0 r
F
P
p
.002 w
.77763 .44143 m .76007 .45305 L .69211 .3734 L p
1 .177 0 r
F P
0 0 0 r
s
P
p
.002 w
.67346 .37988 m .69211 .3734 L .76007 .45305 L p
1 .24 0 r
F P
0 0 0 r
s
P
p
.002 w
.79532 .42973 m .77763 .44143 L .71102 .37001 L p
1 .115 0 r
F P
0 0 0 r
s
P
p
.002 w
.69211 .3734 m .71102 .37001 L .77763 .44143 L p
1 .177 0 r
F P
0 0 0 r
s
P
p
.002 w
.42903 .47358 m .41274 .47625 L .31794 .38544 L p
1 .458 0 r
F P
0 0 0 r
s
P
p
.002 w
.30107 .38875 m .31794 .38544 L .41274 .47625 L p
1 .469 0 r
F P
0 0 0 r
s
P
p
.46193 .11791 m .56402 .18413 L .54707 .18817 L 1 .135 0 r
F
P
p
.4442 .1226 m .46193 .11791 L .54707 .18817 L 1 .177 0 r
F
P
p
.002 w
.81348 .42683 m .79532 .42973 L .73012 .36659 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.002 w
.71102 .37001 m .73012 .36659 L .79532 .42973 L p
1 .115 0 r
F P
0 0 0 r
s
P
p
.002 w
.44563 .45895 m .42903 .47358 L .335 .38211 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.002 w
.31794 .38544 m .335 .38211 L .42903 .47358 L p
1 .458 0 r
F P
0 0 0 r
s
P
p
.47984 .11318 m .58112 .18005 L .56402 .18413 L 1 .094 0 r
F
P
p
.46193 .11791 m .47984 .11318 L .56402 .18413 L 1 .135 0 r
F
P
p
.002 w
.83132 .41201 m .81348 .42683 L .74942 .36313 L p
1 .042 0 r
F P
0 0 0 r
s
P
p
.002 w
.73012 .36659 m .74942 .36313 L .81348 .42683 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.002 w
.46224 .45318 m .44563 .45895 L .3523 .37556 L p
1 .333 0 r
F P
0 0 0 r
s
P
p
.002 w
.335 .38211 m .3523 .37556 L .44563 .45895 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.49793 .1084 m .59839 .17594 L .58112 .18005 L 1 .083 0 r
F
P
p
.47984 .11318 m .49793 .1084 L .58112 .18005 L 1 .094 0 r
F
P
p
.002 w
.74942 .36313 m .76891 .35963 L .83132 .41201 L p
1 .042 0 r
F P
0 0 0 r
s
P
p
.002 w
.47897 .45037 m .46224 .45318 L .36977 .36896 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.002 w
.3523 .37556 m .36977 .36896 L .46224 .45318 L p
1 .333 0 r
F P
0 0 0 r
s
P
p
.51621 .10357 m .61582 .17179 L .59839 .17594 L 1 .073 0 r
F
P
p
.49793 .1084 m .51621 .10357 L .59839 .17594 L 1 .083 0 r
F
P
p
.002 w
.49587 .44753 m .47897 .45037 L .38734 .36549 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.002 w
.36977 .36896 m .38734 .36549 L .47897 .45037 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.53468 .09869 m .63342 .16759 L .61582 .17179 L 1 .052 0 r
F
P
p
.51621 .10357 m .53468 .09869 L .61582 .17179 L 1 .073 0 r
F
P
p
.002 w
.51295 .43558 m .49587 .44753 L .40509 .36198 L p
1 .271 0 r
F P
0 0 0 r
s
P
p
.002 w
.38734 .36549 m .40509 .36198 L .49587 .44753 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.55335 .09376 m .65119 .16336 L .63342 .16759 L 1 .042 0 r
F
P
p
.53468 .09869 m .55335 .09376 L .63342 .16759 L 1 .052 0 r
F
P
p
.002 w
.53015 .42658 m .51295 .43558 L .42308 .35521 L p
1 .208 0 r
F P
0 0 0 r
s
P
p
.002 w
.40509 .36198 m .42308 .35521 L .51295 .43558 L p
1 .271 0 r
F P
0 0 0 r
s
P
p
.002 w
.54751 .42359 m .53015 .42658 L .44119 .35161 L p
1 .177 0 r
F P
0 0 0 r
s
P
p
.002 w
.42308 .35521 m .44119 .35161 L .53015 .42658 L p
1 .208 0 r
F P
0 0 0 r
s
P
p
.57221 .08878 m .66914 .15908 L .65119 .16336 L 1 .031 0 r
F
P
p
.55335 .09376 m .57221 .08878 L .65119 .16336 L 1 .042 0 r
F
P
p
.002 w
.56499 .41141 m .54751 .42359 L .45953 .34472 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.002 w
.44119 .35161 m .45953 .34472 L .54751 .42359 L p
1 .177 0 r
F P
0 0 0 r
s
P
p
.59127 .08374 m .68726 .15476 L .66914 .15908 L 1 .01 0 r
F
P
p
.57221 .08878 m .59127 .08374 L .66914 .15908 L 1 .031 0 r
F
P
p
.002 w
.58264 .40526 m .56499 .41141 L .47802 .34104 L p
1 .094 0 r
F P
0 0 0 r
s
P
p
.002 w
.45953 .34472 m .47802 .34104 L .56499 .41141 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.61053 .07865 m .70556 .1504 L .68726 .15476 L 1 0 0 r
F
P
p
.59127 .08374 m .61053 .07865 L .68726 .15476 L 1 .01 0 r
F
P
p
.002 w
.60048 .40212 m .58264 .40526 L .49671 .33731 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.002 w
.47802 .34104 m .49671 .33731 L .58264 .40526 L p
1 .094 0 r
F P
0 0 0 r
s
P
p
.63 .07351 m .72404 .146 L .70556 .1504 L 1 0 0 r
F
P
p
.61053 .07865 m .63 .07351 L .70556 .1504 L 1 0 0 r
F
P
p
.002 w
.61846 .39586 m .60048 .40212 L .5156 .33354 L p
1 .073 0 r
F P
0 0 0 r
s
P
p
.002 w
.49671 .33731 m .5156 .33354 L .60048 .40212 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.64968 .06831 m .7427 .14155 L .72404 .146 L 1 0 0 r
F
P
p
.63 .07351 m .64968 .06831 L .72404 .146 L 1 0 0 r
F
P
p
.002 w
.63661 .38955 m .61846 .39586 L .5347 .32974 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.5156 .33354 m .5347 .32974 L .61846 .39586 L p
1 .073 0 r
F P
0 0 0 r
s
P
p
.66957 .06306 m .76155 .13706 L .7427 .14155 L 1 0 0 r
F
P
p
.64968 .06831 m .66957 .06306 L .7427 .14155 L 1 0 0 r
F
P
p
.002 w
.65497 .38629 m .63661 .38955 L .554 .32589 L p
1 .042 0 r
F P
0 0 0 r
s
P
p
.002 w
.5347 .32974 m .554 .32589 L .63661 .38955 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.66957 .06306 m .68968 .05774 L .76155 .13706 L 1 0 0 r
F
P
p
.002 w
.67346 .37988 m .65497 .38629 L .5735 .322 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.554 .32589 m .5735 .322 L .65497 .38629 L p
1 .042 0 r
F P
0 0 0 r
s
P
p
.002 w
.69211 .3734 m .67346 .37988 L .59323 .31806 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.002 w
.5735 .322 m .59323 .31806 L .67346 .37988 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.71102 .37001 m .69211 .3734 L .61317 .31409 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59323 .31806 m .61317 .31409 L .69211 .3734 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.002 w
.73012 .36659 m .71102 .37001 L .63333 .31007 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.61317 .31409 m .63333 .31007 L .71102 .37001 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74942 .36313 m .73012 .36659 L .65371 .306 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63333 .31007 m .65371 .306 L .73012 .36659 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76891 .35963 m .74942 .36313 L .67432 .30189 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65371 .306 m .67432 .30189 L .74942 .36313 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67432 .30189 m .69517 .29774 L .76891 .35963 L p
1 0 0 r
F P
0 0 0 r
s
P
p
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.08509 .19367 m
.08465 .20033 L
s
P
[(0)] .08595 .18034 -0.06484 1 Mshowa
p
.002 w
.23498 .15292 m
.23469 .15959 L
s
P
[(10)] .23556 .13958 -0.04346 1 Mshowa
p
.002 w
.40002 .10806 m
.39989 .11474 L
s
P
[(20)] .40028 .0947 -0.01962 1 Mshowa
p
.002 w
.58262 .05842 m
.58267 .0651 L
s
P
[(30)] .58253 .04506 .00711 1 Mshowa
p
.001 w
.11395 .18582 m
.11371 .18982 L
s
P
p
.001 w
.14336 .17783 m
.14314 .18183 L
s
P
p
.001 w
.17332 .16968 m
.17311 .17368 L
s
P
p
.001 w
.20386 .16138 m
.20367 .16538 L
s
P
p
.001 w
.2667 .1443 m
.26655 .1483 L
s
P
p
.001 w
.29905 .1355 m
.29892 .13951 L
s
P
p
.001 w
.33204 .12654 m
.33192 .13054 L
s
P
p
.001 w
.36569 .11739 m
.36559 .1214 L
s
P
p
.001 w
.43505 .09854 m
.43499 .10254 L
s
P
p
.001 w
.4708 .08882 m
.47076 .09283 L
s
P
p
.001 w
.5073 .0789 m
.50728 .0829 L
s
P
p
.001 w
.54456 .06877 m
.54457 .07277 L
s
P
p
.001 w
.6215 .04785 m
.62155 .05186 L
s
P
p
.001 w
.66122 .03706 m
.6613 .04106 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{333, 317},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005=0001?@P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0CP000?mKCE/10000oe]=F`40003oFdeK
0@000?mKCE/10000oe]=F`40003oFdeK0@000?mKCE/10000oe]=F`40001jF`03oe_o00=K00CoFe]K
0ol015_oFol4F`05oe]KFol0^5/10000NU/00omKo`03F`04oe]Ko`=K0_l00e_oF`02F`03oe_o0;]K
0@0007YK00?oFol00e/01?mKFol4F`03oe_o00=K00?oFol0=E/4o`=K1?mkF`40001jF`03oe_o00=K
00CoFe_o15/00omKo`03F`03oe_o03AK00?oFe/00U/00omKo`04F`03oe]K07QK0@0007YK00?oFol0
0e/01?mKFol4F`03oe_o00=K00?oFol0=5/00omKF`02F`03oe_o00AK00?oFe/06E/3oeaK0@0007YK
00CoFooo0U/01?mKFol3F`;o00EKoe]Ko`03F`03oe]K03IK00?oFol015/00omKF`0EF`Co0U/00omK
F`1JF`40001jF`04oe_oF`;o15/3o`04FomKo`9K00GoFe]Ko`0eF`?o0U/00omKF`02F`03oe]K019K
0ol7F`03oe]K05UK0@0007YK00?oFe/02e/00omKF`0oF`03oe_o00AK00?oFe/03U/4o`]K00?oFe/0
F5/10000NU/00omKF`0;F`03oe_o03YK00?oFe/00U/00omKo`04F`03oe]K00YK1?l00e_oF`0=F`03
oe]K05MK0@000<EK00?oFe/00U/00omKo`04F`03oe]K00MK0ol5F`03oe]K00eK00?oFe/0EU/10000
aU/4o`=K1?l6F`Co6E/00omKF`1EF`40003CF`Go7E/00omKF`1DF`40003@F`?o15/00omKF`0KF`03
oe]K05AK0@000<aK1?lVF`03oe]K05=K0@000<QK1?l[F`03oe]K059K0@000<EK0ol3F`03oe]K01]K
0b<<F`03oe]K055K0@000<5K1?l6F`03oe]K01MK22<<F`03oe]K051K0@0008eK1_l2F`Co95/4ob5K
32<<F`03oe]K04mK0@0008eK00?oFe/015/00omKF`02F`03oe]K01eK1?l3F`03oe]K01aK42<<F`03
oe]K04iK0@0008iK00?oFe/00e/00omKF`02F`03oe]K01YK0olSFa@S2e/00omKF`1>F`40002?F`;o
0e/00omKF`02F`03oe]K01IK1?lQFaXS2e/00omKF`1=F`40002AF`04oe]Ko`AK00?oFe/04U/4o`9K
00?oFe/075/00alS8`0L8`]K00?oFe/0C5/10000TU/00omKo`04F`03oe]K00mK0olRF`DO7R<;F`03
oe]K04]K0@0008eK00?oFe/00U/00omKo`04F`03oe]K00]K1?lPF`05GamO7el01QlN8`]K00?oFe/0
BU/10000SE/00omKF`02F`03oe_o00AK00?oFe/01e/4o`9K00?oFe/06e/@7ahS2e/00omKF`19F`40
002>F`Co0e/4o`MK0ol6F`03oe]K01QK00hOGamO7elOGamO7elOG`HO7R<;F`03oe]K04QK0@0009aK
1?lPF`03GamO01HO7R<:F`03oe]K04QK0@0009QK1?l2F`03oe]K01]K00<OGal01Ql03elOGamO7elO
GamO7elOG`067adS2e/00omKF`17F`40002EF`?o1U/00omKF`0HF`0<7elOGamO7elOGamO5QlM8`]K
00?oFe/0AU/10000TE/4oamK00`OGamO7elOGamO7el77`0?GamO7elOGamO7elOGamO00HO7B<;F`03
oe]K04EK0@0008eK1?l2F`03oe]K01YK01LOGalOGamO7elOGamO7elOGamO7elOG`0F7adS2e/00omK
F`14F`40001NF`03oe]K009K1?lRF`Co1U/00omKF`0GF`PO00eO7elOGamO7elOGamO00LO00mO7elO
GamO7elOGamO7el01QlM8`]K00?oFe/0@e/10000GU/01OmKFe_o00AK00?oFe/075/4oamK1El01QmO
7elOG`8O01=O7elOGamO7elOGamO7elOGamO01HO7B<;F`03oe]K049K0@0005iK00GoFe]Ko`04F`03
oe]K01QK1?l3F`03oe]K01UK00<G7aL03al03ElOGamO7elOGamO7el02Al03ElOGamO7elOGamO7el0
1QlM8`YK00?oFe/0@U/10000GU/01OmKFe_o00AK00?oFe/055/4ob1K3Ul01QmO7elOG`8O01EO7elO
GamO7elOGamO7elOGamO7el051lM8`YK00?oFe/0@E/10000GU/01OmKFe_o00AK00?oFe/04E/3o`03
FomK01iK15l01aLO5alG7aL03al03ElOGamO7elOGamO7el02Al03ElOGamO7elOGamO7el01QlM8`YK
00?oFe/0@5/10000GU/01OmKFe_o00AK00?oFe/03E/4o`AK00?oFe/05e/01ElOGamO00HO3Ul01amO
7elOGal00Ul051mO7elOGamO7elOGamO7elOGamO51lM8`YK00?oFe/0?e/10000G5/3o`=K00?oFe/0
0U/00omKF`09F`Co7U/02AmO7elOGamO7`07G`075alG7aLO5`0?7`0=GamO7elOGamO7elOG`097`0=
GamO7elOGamO7elOG`067adS2U/00omKF`0nF`40001NF`05oe]KFol015/00omKF`06F`?o00=Koe/0
75/8G`067elOGamO1Ql@G`057elOGal00Ul051mO7elOGamO7elOGamO7elOGamO51lM8`YK00?oFe/0
?E/10000GU/00omKF`02F`Co1E/4o`AK00?oFe/065/04AmO7elOGamO7elOGamO7elO00QO00HO5alG
7aL?7`0?GamO7elOGamO7elOGamO00LO00eO7elOGamO7elOGamO00HO6B<00elOG`0;F`03oe]K03aK
0@0006QK1?lOFa5O00HOGamO7el77`mO00DOGamO7`02G`0D7elOGamO7elOGamO7elOGamO7elD7a@S
21l:F`03oe]K03aK0@0006EK0ol3F`03oe]K01YK1el05AmO7elOGamO7elOGamO7elOGamO7`06G`06
7aLO5alG4Al03ElOGamO7elOGamO7el01al03ElOGamO7elOGamO7el01Ql@8`0<7elOGamO7elOGamO
2U/00omKF`0kF`40001QF`Co1E/00omKF`0GF`DG5El01QmO7elOG`LO3el01QmO7elOG`8O01=O7elO
GamO7elOGamO7elOGamO01@O2b<02AmO7amO7elOG`087`YK00?oFe/0>U/10000<E/4obQK1OlMF`/G
2El04amO7elOGamO7elOGamO7elOGal01el01ALO5alG014O00eO7elOGamO7elOGamO00LO00eO7elO
GamO7elOGamO00HO1R<05QlG7elOGamO7elOGamO7elOGamO7el:F`03oe]K03UK0@00031K00?oFe/0
0U/00omKF`0QF`Co15/00omKF`0GF`094ALA5a4G4ALA00LG5el01QmO7elOG`HO3Ul01QmO7elOG`8O
01=O7elOGamO7elOGamO7elOGamO01@O0R<7G`047elOG`8O00EO7elOG`087`YK00?oFe/08E/4o`03
FomK00Co0U/01OmKFe_o00=K0Ol1F`40000`F`03oe]K009K00?oFe/07U/3o`QK00?oFe/055/01QLA
5a4G4@lG25l04amO7elOGamO7elOGamO7elOGal01el01aLO5alG7aL03al03ElOGamO7elOGamO7el0
1al03ElOGamO7elOGamO7el00al4G`0K5alG7aLO5amO7elOGamO7elOGamO7elOGamO00YK00?oFe/0
7e/00omKF`02F`?o15/00omKo`03F`03oe]K00=K0@00031K00?oFe/00U/00omKF`0JF`Co00=Koe/0
75/54@0<5a4G4ALA5a4G4ALA21LFG`067elOGamO1Ql>G`077elOGamO7`02G`0B7elOGamO7elOGamO
7elOGamO2Ql00elOG`027`06GamO7elO25l011mO7el27`05GamO7el021l:F`03oe]K01eK00?oFe/0
15/2o`IK00GoFe]Ko`05F`40000`F`03oe]K009K00?oFe/05U/4o`EK00?oFe/05U/00a4G4@085`07
4ALA5a4G4@0=5`QO01<OGamO7elOGamO7elOGamO7elO00MO00LG7aLO5alG00lO00eO7elOGamO7elO
GamO00LO00MO7emO7elO00eO01/G7aLO5alG7elOGamO7elOGamO7elOGamO7el02U/00omKF`0LF`03
oe]K00AK1ol00e_oF`02F`03oe]K00=K0@00031K00?oFe/00U/00omKF`0CF`Co7E/34@HG1a403QLA
5a4G4ALA5a4G4ALA1aLEG`067elOGamO1al?G`057elOGal00Ul04AmO7elOGamO7elOGamO7elO00YO
00@OGamO0Ql01UlOGamO7`QO00@OGamO0Ql01ElOGamO00PO2E/00omKF`0LF`04oe]KF`Go15/00omK
o`03F`03oe]K00=K0@00031K00?oFe/00U/00omKF`0?F`Co0e/00omKF`0IF`05Wa6O4Il00Q401QLA
5a4G4@HG00LA5a4G4ALA00hG1el05AmO7elOGamO7elOGamO7elOGamO7`06G`067aLO5alG3al03UlO
GamO7elOGamO7elO25l01AmO7elO00eO01/G7aLO5alG7elOGamO7elOGamO7elOGamO7el02E/00omK
F`0KF`03oe]K00EK00?oFe/00U/01?mKool2F`03oe]K00=K0@00031K00?oFe/00U/00omKF`0;F`Co
85/01=nOgil74@HG214031LA5a4G4ALA5a4G4@LG5El01QmO7elOG`LO3el01AmO7elO009O00LOGamO
7elO009O00<GGaL03el011mO7el27`06GamO7elO25l011mO7el27`05GamO7el01al:F`03oe]K01YK
00?oFe/015/00omKo`03o`9K00CoFooo1U/10000<E/4o`]K0ol2F`03oe]K01YK01NOgioOWa6O4IlA
Wa6O4IlAWaLA5a4G4@085`074ALA5a4G4@0=5`QO01<OGamO7elOGamO7elOGamO7elO00IO00HO5alG
7aL?7`07GamOGaMO5`0?G`057elOGal03El06QLO5alG7aLOGamO7elOGamO7elOGamO7elO2U/00omK
F`0JF`03oe]K009K00?oFe/045/10000?5/4o`EK00?oFe/05E/5g`0<WmnOgioOWmnOgioO1a465`LA
00`G4ALA5a4G4ALA5a485aIO00@OGamO21l>G`077elOGa4G4@065`06GaMO5elG3el011mO7el27`06
GamO7elO25l011mO7el27`05GamO7el01al:F`03oe]K01YK1?lCF`40000hF`Go75/:W`0BgioOWmnO
4IlAWa6O4IlAWa6O0Q4011LA5a485`074ALA5a4G4@0>5`MO01<OGamO7elOGamO7elOGamO7elO00MO
00DG7aLO5`097`LG00IO5elGGaL?G`057elOGal03El06QLO5alG7aLOGamO7elOGamO7elOGamO7elO
2U/00omKF`0`F`40000eF`?o15/00omKF`0HF`gO00fOgioOWmnOgioOWmnO00HA1aL84@0<5a4G4ALA
5a4G4ALA1aLEG`067elOGamO1Ql9G`HA00HG4ALA5a465`06GaMO5elG3el011mO7el27`06GamO7elO
25l011mO7el27`05GamO7el01al:F`03oe]K02mK0@00035K1?lOFa>O01SOWmnOgilAWa6O4IlAWa6O
4IlG4ALA5a485`074ALA5a4G4@0<5`MO01<OGamO7elOGamO7elOGamO7elO00MO00HG7aLA5a425`05
4ALA5a4021L01UlGGaMO5`mO00DOGamO7`0=G`0J5alG7aLO5amO7elOGamO7elOGamO7elOGal9F`03
oe]K02mK0@0002mK0_l2F`03oe]K01UK19lEg`0<WmnOgioOWmnOgioO1Q475`LA00`G4ALA5a4G4ALA
5a485aAO00HOGamO7el37`034ALA008G00@A5a4G2A401QLA5a4G4@HG00IO5elGGaL?G`047elOG`8O
00IO7elOGal8G`047elOG`8O00EO7elOG`077`UK00?oFe/0;U/10000;e/01OmKFe_o01IK1Ml01YoO
WmnOgaBO01;OWmnOgilAWa6O4IlAWa6O4Il24@045a4G4@XG00DA5a4G4@0=5`QO00lOGamO7elOGamO
7elOGal02a4011LA5a425`054ALA5a4021L01UlGGaMO5`mO00DOGamO7`0=G`0J5alG7aLO5amO7elO
GamO7elOGamO7elOGal9F`03oe]K02eK0@0002mK00CoFe^14e/00mnOg`0=WaCO00fOgioOWmnOgioO
WmnO00HA1aL84@0<5a4G4ALA5a4G4ALA1QLBG`BO00@AWa6O0Q4011LA5a425`044ALA5`TA00HG4ALA
5a485`04GaMO5`mO00@OGamO0Ql01UlOGamO7`QO00@OGamO0Ql01ElOGamO00LO2E/00omKF`0/F`40
000_F`04oe]KP@mK3ml01YoOWmnOgaJO01SOWmnOgilAWa6O4IlAWa6O4IlG4ALA5a485`054ALA5a40
3QL7G`067elOGamO1il=4@055a4G4AL00Q401QLA5a4G4@PG00AO5elG3el01AmO7elO00eO01XG7aLO
5alG7elOGamO7elOGamO7elOGamO7`UK00?oFe/0:e/10000;e/01?mKFh4=F`0=g]oNgmkOgYoOWmnO
g`0=WaCO00bOgioOWmnOgioOWml64@LG1a4031LA5a4G4ALA5a4G4@LG2El<W`044IlAW`8A00DG4ALA
5`024@055a4G4AL01a401QLA5a4G4@PG00IO5elGGaL=G`047elOG`8O00IO7elOGal8G`047elOG`8O
00EO7elOG`037`03GamO00YK00?oFe/0:U/10000;e/01?mKFh4:F`04gmkOgQCO00JOgioOWmlDW`0B
gioOWmnO4IlAWa6O4IlAWa6O0Q4011LA5a4:5`054ALA5a4031L3G`09gioOWmnOgioO00RO3A401ALA
5a4G008A00HG4ALA5a485`04GaMO5`mO00DOGamO7`0=G`0?5alG7aLO5amO7elOGamO00XO2U/00omK
F`0YF`40000_F`;o00=KPE/025/7gP06gmkOg]oN0]l01YoOWmnOg`bO5Ml02ioOWmnOgioOWmnO00HA
1QL94@0:5a4G4ALA5a4G4@@G00BOgioO59l02a6O4IlAWaLA5a4G008A00DG4ALA5`074@065a4G4ALA
21L01UlGGaMO5`eO00@OGamO0Ql01UlOGamO7`QO00@OGalO1el01QmO7elOG`UK00?oFe/0:E/10000
;e/01?mKFh4;F`07g]oNgmkOgP0Dg`06WmnOgioO59l04=nOgioOWa6O4IlAWa6O4Il24@065a4G4ALA
21L01A4G4ALA00<G00@Aga7O1Yl03MnOgioOWmnOgioOWml01il>4@045a4G4@8G00DA5a4G4@085`04
GaMO5`mO00DOGamO7`0=G`0<5alGGaMO7elOGamO3Al9F`03oe]K02QK0@0002mK00CoFe^13E/7gP0<
gmkOg]oNWmnOgioO3IlDg`0<WmnOgioOWmnOgioO1Q465`PA00<G4AL01Il00a6O4@02W`05gioOWml0
59l01Q6O4IlAW`8A00@G4ALA0QL0114G4AL94@045a4G4@PG00IO5elGGaL=G`047elOG`8O00AO7elO
0el011mO7el77`MO00HOGamO7el9F`03oe]K02MK0@0002iK00GoFe]KP@0>F`06gmkOg]oN5]l019oO
WmlDW`0HgioOWmnO4IlAWa6O4IlAWa6O5a4G4ALA1QL:g`054MlAga401il02mnOgioOWmnOgioO00RO
3A4011LA5a425`054ALA5a4021L01UlGGaMO5`eO00DOGamO7`07G`0B7elOGamO5elGGaMO7elOGamO
3Al9F`03oe]K02IK0@0002iK00GoFe]KP@0@F`SN00cOg]oNgmjOgioOWml=WaCO00^OgioOWmnOgioO
W`064@HG00PAgioOWmnOg`NO00XAWa6O4MnOgioO5Yl0116O4Il24@045a4G4@8G00HA5a4G4AL74@06
5a4G4ALA1QL01UlGGaMO5`eO00DOGaMO5`08G`047elOG`LO1el01QmO7elOG`UK00?oFe/09E/10000
;U/01?mKFh4CF`06gmkOg]oN5=l01YoOWmnOgaBO013OWmnOgilAWa6O4IlAWa6O0Q400aLAg`0Ag`06
4MlAga7O1Yl03MnOgioOWmnOgioOWml01Yl=4@055a4G4AL00Q401QLA5a4G4@HG00IO5elGGaL=G`05
7elA5a401aL04QmO7elOGaMO5elGGamO7elOG`dO2E/00omKF`0TF`40000^F`04oe]KPAEK2=h01=oN
gmh2g`06WmnOgioO39lCg`0<WmnOgioOWmnOgioO0Q402MoNgmjOgioOW`02g`06WmnOgioO1il01A6O
4IlA00:O00GOWmnOg`0DW`0;4IlAWa6O5a4G4AL00Q401ALA5a4G00LA00HG4ALA5a465`06GaMO5elG
0el02A4G4ALA5a4G4@025`04GaMO5`QO00@OGamO1al7G`067elOGamO2E/00omKF`0SF`40000^F`04
oe]KPAMK00KOg]oNgmhDg`06WmnOgioO59l01mnOgilAWa401=hKg`054MlAga401il02mnOgioOWmnO
gioO00NO31401QLA5a4G4@8G00DA5a4G4@065`06GaMO5elG0el03a4G4ALA5a4G4ALA5a4G4@075`0B
7elOGamO5elGGaMO7elOGamO31l9F`03oe]K02=K0@0002iK00CoFe^16E/6gP06gmkOg]oN0]l019oO
Wml=WaCO00BOg]oN0]l01=kOg]l2gP04gmkOgP;O00BOgioO0Yl01mnOgioOWml01il02Q6O4IlAgioO
WmlDW`0<4IlAWa6O5a4G4ALA0QL0114G4AL74@065a4G4ALA0aL00a4G4@025`044ALA5`8A00XG4ALA
5a4G4ALA0QL015lGGaL8G`047elOG`LO1el01AmO7elO00UK00?oFe/08U/10000;U/2o`03Fh5K01UK
00ONgmkOg]oN01CO00BOgioO49l@gQ[O00HAga7O4Ml6W`0;gioOWmnOgioOWml01il>4@045a4G4@8G
00DA5a4G4@035`@A00DG4ALA5`024@0@5a4G4ALA5a4G4ALA5a4G4@LG018OGamO7elGGaMO5elOGamO
7el<7`UK00?oFe/08E/10000;U/01?mKFh4LF`ON00cOg]oNgmjOgioOWml=W`SO1746gP05gmkOg]l0
0]h01=oNgmh2g`0;g]oNgmjOgioOWml00Yl01MnOgioO00NO00DAWa6O4@02W`05gioOWml059l0116O
4Il24@045a4G4@8G00@A5a4G1A400ilAW`074@045a4G4@8G00@A5a4G0Q402QLA5a4G4ALA5a425`04
GaMO5`QO00@OGamO1al7G`057elOGal02E/00omKF`0PF`40000^F`04oe]KPAiK00ONgmkOg]oN01;O
00JOgioOWml3W`03LMia01WN6Ml01Q7O4MlAg`JO00gOWmnOgioOWmnOgioO00JO3A400aLAW`03W`06
4IlAWa6O1Q401ALA5a4G008A010G4ALA5a4G4ALA5a4G4ALA1aL04QmO7elOGaMO5elGGamO7elOG``O
2E/00omKF`0OF`40000^F`04oe]KPB1K1mh03=oNgmkOgYoOWmnOg`RO00=agW400]h0177NLMh7L@ON
00COg]oN0]l01MkOg]oN00;O00?Ngmh00]l01IoOWmnO00;O00BOgioO2Il02Q6O4IlAgioOWmlDW`04
4IlAW`8A00DG4MnOg`07W`064IlAWa6O1a4011LA5a425`044ALA5`8A00XG4ALA5a4G4ALA0QL015lG
GaL8G`047elOG`LO1el01AmO7elO00UK00?oFe/07U/10000;U/01?mKFh4RF`05g]oNgmh04=l4g00<
gW7NLMiagW7NLMia6=hJg`054MlAga401il02mnOgioOWmnOgioO00JO11400ilAW`0<W`064IlAWa6O
1Q401ALA5a4G008A010G4ALA5a4G4ALA5a4G4ALA1aL04QmO7elOGaMO5elGGamO7elOG``O2E/00omK
F`0MF`40000^F`04oe]KPB1K00>1Fe/02=h01=oNgmh2g`05WkNf]kH01]`01MiagW7N009a00GNLMia
gP06L@SN00COg]oN0]l01=kOg]l2gP0:gmkOgYoOWmnOg`:O00GOWmnOg`07W`054IlAWa400Yl00mnO
g`0AW`08gioOWmnOgil2g`04WmnOg`NO00HAWa6O4Il74@045a4G4@8G00@A5a4G0Q402QLA5a4G4ALA
5a425`04GaMO5`QO00@OGamO1al7G`057elOGal025/00omKF`0MF`40000^F`04oe]KPB1K00>1Fe/0
0U/01]oNgmkOgP?O1;H01[Nf]kJg]PKL00]agW7NLMiagW7NL@0IgQWO00HAga7O4Ml6W`09gioOWmnO
gioO00FO00WOWmnO4IlAWa403Il01Q6O4IlAW`PA00<G4AL00Q4041LA5a4G4ALA5a4G4ALA5a475`0B
7elOGamO5elGGaMO7elOGamO31l8F`03oe]K01aK0@0002iK00CoFe^185/00h5KF`04F`?N00Vfo;Kl
][Nf]kH00[L01;Jg][L7g004gW7NL@;N00IagW7NLMh6L@KN00GOg]oNg`02gP04gmkOgP;O00?Ngmh0
0]l01IoOWmnO00;O00BOgioO1il0316O4IlAWa7OWmnOg`BO00<AWa401ml02IoOWmnOgioOW`02g`06
WmnOgioO1il0116O4Il74@055a4G4AL00Q4011LA5a425`094ALA5a4G4ALA008G00AO5elG25l011mO
7el77`MO00@OGalO2E/00omKF`0KF`40000^F`;o00=KPE/07e/00h5KF`06F`06][Ff]KJe1kH01KNf
]kJg00KL00cNLMiagW7NLMiagW4HgQ[O00DAga7O4@02W`0:gioOWmlAga7O4@NO00_OWmnOgilAWa6O
4@0=W`044IlAW`PA00@G4ALA0QL03a4G4ALA5a4G4ALA5a4G4@075`0B7elOGamO5elGGaMO7elOGamO
2al9F`03oe]K01YK0@0001UK00?oFe/00U/4o`9K1?l5F`:10U/00h5KF`0NF`03PE]K00QK00_l]_bf
o;Jg][Nf]`02]P05]kJg][L01]`01G7NLMia00;N00AagW7N1g47gP04gmkOgP;O00CNgmkO0]h01=oN
gmh2g`04WmnOg`:O00GOWmnOg`07W`034InO00VO00DAWa6O4@07g`0:WmnOgioOWmnOg`:O00GOWmnO
g`07W`044IlAW`LA00DG4ALA5`024@045a4G4@8G00TA5a4G4ALA5a400QL015lGGaL8G`047elOG`@O
00QO7amO7elOG`HO2E/00omKF`0IF`40000IF`05oe]KFol015/2o`AK00?oFe/00U/00omKP@02PB1K
00>1Fe/02E/01kFf]KJe][D01kH01;Nf]kH7g00<gW7NLMiagW7NLMia6=hDg`03WmnO00OO00^OgioO
WmlAga7O4@07W`0;gioOWmnO4IlAWa403Il0116O4Il84@045a4G4@8G00lA5a4G4ALA5a4G4ALA5a40
1aL04AmO7elOGaMO5amO7elOGamO00`O2E/00omKF`0HF`40000IF`05oe]KFol015/2o`AK00?oFe/0
0U/01?mKFe/2PAmK00>1Fe/02e/02kKl]_bfo;Jg][Nf00:g00Ff]kJg]P06g005gW7NLMh00W401Mia
gW7N00Ia1]h01MoNgmkO00;N00COg]oN0]l02]kOg]oNWmnOgil2g`:O00SOWmoOWmnOg`fO00HAWa6O
4Il6g`0:WmnOgioOWmnOg`:O00GOWmnOg`07W`044IlAW`TA00<G4AL00Q4011LA5a425`094ALA5a4G
4ALA008G00AO5elG15l37`IO00@OGamO0Ql01ElOGamO00HO2E/00omKF`0GF`40000BF`?o15/01OmK
Fe_o00AK0_l4F`03oe]K009K00CoFe^10U/2PAeK00>1Fe/03E/01KFf]KJe00Nf00Jg][Nf]kH6g00;
LMiagW7NLMiagW406Mh=g`0;WmnOgioOWmnOgil01ml02YoOWmlAga7O4Ml6W`0;gioOWmnO4IlAWa40
3Il01Q6O4IlAW`HA00@G4ALA0QL03a4G4ALA5a4G4ALA5a4G4@045`YO00XOGamO7elOGamO31l8F`03
oe]K01MK0@0001UK00GoFe]Ko`04F`;o15/00omKF`02F`04oe]KP@AK0X4KF`03PE]K00mK00^fo;Kl
]_bf]kJg]P02]`04][Nf]`KL00EagW7NL@02gP06LMiagW7N1G47gP05gmkOg]l00]h00moNg`02gPKO
00ZOgioOWmnOgioO0Yl01MnOgioO00^O00HAWa6O4Il6g`0;WmnOgioOWmnOgil00]l019oOWml7W`06
4IlAWa6O1a400aLA5`024@045a4G4@8G010A5a4G4ALAGaMO5elOGamO1Ql6G`047elOG`8O00EO7elO
G`067`QK00?oFe/05U/100006E/01OmKFe_o00AK0_l4F`03oe]K009K00CoFe^11U/2PAUK00>1Fe/0
45/01[Je][Ff]@Nf00Fg][Nf]`06g00<gW7NLMiagW7NLMia5Mh00moNg`0<g`0;WmnOgioOWmnOgil0
1ml02YoOWmnOga7O4Ml8W`09gioOWa6O4IlA00fO00HAWa6O4Il64@045a4G4@8G00DA5aLA5`024@0:
5a4G4ElGGaMO5`aO00XOGamO7elOGamO31l8F`03oe]K01EK0@0001MK0ol3F`03oe]K009K0_l4F`03
oe]K009K00CoFe^125/2PAMK00>1Fe/04U/02obfo;Kl][Nf]kJg00:f00Fg][Nf]`06g004LMiagP9a
00GNLMiagP07L@GN00KOg]oNgmh2g`03g]oN00OO00^OgioOWmnOgioOW`02g`04WmnOg`fO00DAWa6O
4@07g`09WmnOgioOWmnO00;O00JOgioOWml5W`064IlAWa6O1a401ALAWa6O00LA00lG4ALAGaMO5elG
GamO7el01Ql6G`047elOG`8O00EO7elOG`067`QK00?oFe/055/100006E/01OmKFe_o00AK0_l4F`03
oe]K009K00CoFe^12U/2PAAK00>1Fe/05E/01[Je][Ff]@Nf00Bg][Nf1]`03G7NLMiagW7NLMiagW40
1mh04=magg7Og]oNgmkOg]oNgmh=g`09WmnOgioOWmnO00OO00^OgioOWmlAga7O4@07W`0;gioOWmnO
4IlAWa402il00a6O4@04o`8A2Il01ALA5a4G008A00XG4ALAGaMO5elG35l02QmO7elOGamO7el<7`QK
00?oFe/04e/100006E/00omKF`02F`Co0U/4o`EK0_l00e^1F`0;F`:14U/00h5KF`0GF`0:o;Kl]_bf
]kJg]P:g00Ff]kJg]P06g005gW7NLMh00W401MiagW7N00=a00?NLMh01]h01MoNgmkO00;N00COg]oN
1ml02YoOWmnOgioOWml2W`05gioOWml02il01A6O4IlA00OO00ZOgioOWmnOgioO0Yl01MnOgioO00BO
0ol48`0<oioOWmnOgilAWa6O1a403aLA5a5O5elGGaMO7elOG`067`IO00@OGamO0Ql01ElOGamO00HO
25/00omKF`0BF`40000]F`04oe]KP@iK0X4@F`03PE]K01QK00Fe][Ff]@07]P06]kJg][Nf1]`0277N
LMiagW7N1745gP0ALMmagg7Og]oNgmkOg]oNgmh03Ml02ioOWmnOgioOWmnO00GO00^OgioOWmlAga7O
4@07W`0;gioOWmnO4IlAWa4019l5o`PS00?oWil02Il01ALA5a4G008A00XG4ALAGaMO5elG35l02QmO
7elOGamO7el<7`QK00?oFe/04E/10000;E/01?mKFh4@F`:13U/00h5KF`0JF`0;]_bfo;Kl][Nf]kH0
0[L01;Jg][L6g005LMkMLMd01g401]iagW7NL@GN00KOg]oNgmh2g`03g]oN00OO00ZOgioOWmnOgioO
0Yl01MnOgioO00^O00HAWa6O4Il6g`08WmnOgioOWml6o`hS00coWmnOgioOWa6O4Il74@0?5a4G4ElG
GaMO5elOGamO00HO1Ul011mO7el27`05GamO7el01QlKF`40000]F`04oe]KPA9K0X4<F`03PE]K01UK
00R1Fe^e][Ff]@Nf00Fg][Nf]`03g007k=c/LMeag@08L@KN015agg7OLMoNgmkOg]oNgmkOgP0;g`0;
WmnOgioOWmnOgil01ml02YoOWmlAga7O4Ml6W`03gooo00Co32<00olS8`068`03oinO00VO00DG4ALA
5`024@0:5a4G4ElGGaMO5`aO00XOGamO7elOGamO31lJF`40000]F`04oe]KPAAK0X4:F`03PE]K01UK
00>1Fe/00U/02[Kl]_bf]kJg][L2]P03]`d=008=1M`01W7MLMeag@Ma00CNLMia1mh01MoNgmkO00;N
00COg]oN1Ml02ioOWmnOgioOWmnO00;O00BOgioO3Il0116O4Il2g`Co32<00olS8`048`03ob<S00HS
00coWmnOgioOWa6O4Il74@045a4G4@8G00UO5elGGamO7el01Ql6G`047elOG`8O00EO7elOG`067aUK
0@0002eK00CoFe^15U/2P@QK00>1Fe/06E/00h5KF`03F`06][Ff]KJe0[H4S0G<00_/g>cLk=cMLMea
g@07L@KN013OLMmagmkOg]oNgmkOg]oN3Ml02ioOWmnOgioOWmnO00GO00ROgioOWmlAg`?o0al78`03
ob<S00@S00?o8b<012<2o`LS0_l;W`044ALA5`8A00@G4ALA0QL015lGGaL<G`0:7elOGamO7elOG`TO
6e/10000;E/01?mKFh4HF`:11U/00h5KF`0IF`03PE]K00EK00?l]X`02H`53@KL00AagG7M2G401=ia
gW47gP03gmkO00;N00COg]oN1ml02YoOWmnOgioOWml2W`05gioOWml01il5o`LO00?o8b<012<00olS
8`058`03ob<S00@S00?o8b<01R<02ooOWmnOgilAWa6O00LA00@G4ALA0QL02ElGGaMO7elOG`067`IO
00@OGamO0Ql00elOF`0OF`40000/F`05oe]KFh406U/2P@AK00>1Fe/06E/00h5KF`07F`^<1/`02ncL
k=c/LMeagG7M00Ia1]h03g7OLMmagmkOg]oNgmkOgP0=g`0;WmnOgioOWmnOgil01_l011mO7el97`03
ob<S00DS00?o8b<012<00olS8`048`03ob<S00HS00?oWil02Il0114G4AL24@045a4G4@8G00AO5elG
35l01amO7elOGal09E/10000;5/01OmKFe^101aK0X42F`03PE]K01UK00>1Fe/02E/;S0D=1]`01Mea
gG7M00Ma00CNLMia1mh01=oNgmh2g`05g]oNgmh01Ml02YoOWmnOgioOWml6o``O00?o7al01Al2o`HS
00?o8b<012<2o`DS0_l78`0;omnOgioOWa6O4Il01a4011LA5a425`09GaMO5elOGamO00HO0elYF`40
000/F`?o00=KPE/07E/3PA]K00>1Fe/02U/<S0G<00[Lk=c/g>aagG7M1g46gP0@gg7OLMoNgmkOg]oN
gmkOgPSO1_l57`0?GamO7elOGomO7elOGaoo00PO00?o8b<012<2o`HS00?o8b<012<00olS8`058`03
oinO00VO00@A5a4G0Q4011LA5a425`04GaMO5`=O0e/00h5KF`0]F`40000/F`05oe]KFh4085/2PAYK
00>1Fe/035/<S0D=1M`01W7MLMeag@Ma00CNLMia1mh00moNg`02gP05gmkOg]l01_l03ElOGamO7elO
GamO7ol01Ql00olO7`057`03oalO00DO00?o8b<01B<00olS8`048`03ob<S00@S00?o8b<01B<02ooO
WmnOgilAWa6O00LA00@G4ALA0QL00elGF`06F`03PE]K02eK0@0002aK00CoFe^18E/0185KPH4HF`03
PE]K00iK38`4c00;k=c/g>cLgG7MLMd01g45gP0;LMmagg7Og]oNgmh01?l03AmO7elOGamO7elOGol0
1Ql04?lOGamO7elOoamO7elOGol77`03ob<S00DS00?o8b<012<2o`DS00?o8b<01B<00onOW`09W`04
4ALA5`8A00<G4E/02e/00h5KF`0]F`40000/F`04oe]KPB5K00B1Fe]K0X4FF`03PE]K011K2h`53@KL
00AagG7M1g401]iagW7NL@GN00KOoooo7el27`0FGamO7elOGamO7elOGomO7elOGamOo`HO00?o7al0
11l2o`HO0_l68`;o1R<00olS8`038`;o1R<2o`09WmnOgilAWa6O00<A4E/00h5KF`0]F`40000/F`04
oe]KPB5K00>1Fe/00e/2PAAK00>1Fe/04U/;S0G<00_/g>cLk77MLMeag@06L@GN00?Oool00_l87`0=
GamO7elOoamO7elOG`02o`HO00OoGamO7elO00;o00MO7elOGaoo00LO00?o8b<01B<00olS8`048`03
ob<S00@S00?o8b<01B<00onOW`05WaEK00>1Fe/0;E/10000;5/01?mKFh4QF`03PE]K00EK0X4BF`03
PE]K01=K38`43@KL00GMLMeag@07L@Co1El03QmO7elOGaooGamO7elO0_l03ElOGamO7olOGamO7el0
0_l67`03oalO00@O00?o7al01Al00olS8`058`03ob<S00@S0_l58`03ob<S00DS00?oWe/06E/00h5K
F`0]F`40000/F`04oe]KPB5K00>1Fe/01e/2PA1K00>1Fe/05E/<S0C<00[Lk=c/g>aagG7M0g43o`03
5alG00HO00?o7al01Al2o`0>7elOGamOoelOGamO7ol77`0>oamO7elOGomO7elOGal2o`HO0_l68`;o
1R<00olS8`038`;o1R<00omKF`0HF`03PE]K02eK0@0002aK00CoFe^18E/00h5KF`09F`:13U/00h5K
F`0GF`^<1@d5g003LOoo00?o3El08?lOGamO7elOGolOGamO7eooGamO7elOoamO7elOGaoo1Ql2o`HO
00?o7al01Al00olS8`058`03ob<S00@S00?o8b<012<00olS8`048`03oe]K01MK00>1Fe/0;E/10000
;5/01?mKFh4QF`03PE]K00]K0X4;F`03PE]K01IK00B1Fe]K2h`4c003k?oo00;o1El02AlG7aLO5alG
o`067`03oalO00DO00ko7elOGamOoelOGamO7`;o1Ql2o`0>GamO7elOoamO7elOGol77`03ob<S00DS
00?o8b<012<2o`DS00?o8b<012<00omKF`0GF`03PE]K02aK0@0002aK0_l00e^1F`0OF`03PE]K00iK
0X49F`03PE]K01IK00>1Fe/00U/8S004Cd9?@P?o00=O7el01al8G`03oemO00AO00ooGamO7elOGolO
GamO7el00_l03amO7elOGomO7elOGamOo`067`03oalO00@O0_l67`03ob<S00DS0_l68`03ob<S00<S
00Co8b<S1OlGF`03PE]K02aK0@0002aK00CoFe^185/00h5KF`0@F`:11e/00h5KF`0FF`03PE]K00AK
0X`5@P?o00IO7elOGal8G`09oaLO5alG7aOo00HO00?o7al01Al2o`0>GamO7elOoamO7elOGol77`0@
oelOGamO7olOGamO7elOo`HO0_l78`03ob<S00@S00Co8b<S1Ol01UlOGamOoaIK00>1Fe/0;5/10000
;5/01?mKFh4PF`03PE]K019K00>1Fe/015/00h5KF`0FF`03PE]K00EK1_l5G`077elOGamOo`067`03
oemO00EO00?oGel015l2o`0N7elOGamO7omO7elOGaoo7elOGamOoelOGamO7eoo1Ql2o`HO00?o7al0
1Al00olS8`058`04ob<S8`Ko00AO7eoo1al00omKF`0CF`03PE]K02aK0@0002aK00CoFe^185/00h5K
F`0CF`:115/00h5KF`0FF`04PE]KF`Co01<OGamO7elOGamO7elOGamO7eoo00IO00Wo5alG7aLO5ol0
1al00olO7`057`0>oelOGamO7olOGamO7el2o`HO0_l03AmO7elOGomO7elOGal00_l67`03ob<S00@S
1?l04amO7eooGamO7eooGamO7elOGol055/00h5KF`0GF`B14E/10000:e/01OmKFe^1021K00>1Fe/0
5E/2P@9K00>1Fe/05U/0187oool@G`08oamO7elOGol67`;o1Ul2o`IO023o7elOGamO7omO7elOGaoo
7elOGamO7olOGamO7elOo`HO00?o7al01Al00olO7`047`03ob<S00?o011OoamO7elOGaooGamO7eoo
1al2oa9K00>1Fe/04E/6PAEK0@0002]K00GoFe]KP@0PF`03PE]K01MK0h4GF`;o1el05AmO7elOGamO
7elOGaoo7elOGamOo`07G`09oalG7aLO5aoo00HO0_l67`07oelOGamO7`02o`07GamO7elOo`077`07
oamO7elOG`02o`077elOGamOo`037`Go01dG7aLO5omO7elOGamOoelOGamOoelOGamO7elOo`0AF`03
PE]K00]K1X4KF`40000[F`05oe]KFh4085/00h5KF`0IF`:14e/3o`<G3Ul00omOG`03G`08oamO7elO
Gol77`03oemO00EO00?oGel01El01omO7elOGal00_l05AmO7elOGomO7elOGaoo7elOGamO7`02o`HO
00?o7al00al4o`04GamOo`MO00oo7elOGamO7omO7elOGol021l00omKF`0>F`03PE]K00IK1H4QF`40
000[F`05oe]KFh4085/00h5KF`0IF`04PE^1P@eK1?l75`MO01CoGamO7elOoamO7elOoamO7elOG`;o
1Ul02OlO5alG7aLOo`077`03oalO00DO00ko7elOGamOoelOGamO7`;o1al02OmO7elOGaoo7`03o`03
GomO00EO023o5alG7aLO5omO7elOGamOoelOGamOoelOGamO7elOo`mK00>1Fe/01X4VF`40000[F`05
oe]KFh4085/00h5KF`0IF`04PE]KF`:11U/5o`034ALA00TG1el00omOG`04G`03oemO00=O00Wo7elO
GamO7ol01Ql00omOG`05G`03oemO00EO023oGamO7elOGolOGamO7eooGamO7elOGomO7elOGamOo`<O
1?l03ElOGamOoamO7elOGol01el03olOGamO7elOoelOGamOo`087`;o2U/6PBaK0@0002]K0_l2F`03
PE]K01iK00>1Fe/06E/00h5KF`03F`03POoo00?o00@G4ALA3QL00omOG`04G`0FoelOGamO7olOGamO
7olOGamO7elOo`IO0_l01aLO5alG7ol01al2o`HO00Oo7elOGamO00;o00LOGamO7eoo00HO1?l011mO
7ol6G`03oemO00AO027o5alG7aLO5omO7elOGamOoelOGamOoelOGamO7elOGol00e/6P@=K00>1Fe/0
;5/10000:e/01?mKFh4QF`03PE]K01UK00>1Fe/01?l34@0>oa4G4ALA5a4G4ALA5ol75`03oemO00AO
00?oGel015l00omOG`03G`09oamO7elOGaoo00LO00?oGel015l00omOG`06G`07oamO7elOG`02o`0@
GamO7elOoamO7elOGomO7`?o00=Ooel01El03olOGamO7eoo7elOGamOo`07G`0?oamO7elOGaooGamO
7eoo00TO00?oPH402E/00h5KF`0/F`40000[F`04oe]KPB5K00>1Fe/06E/01X7ooaLAo`DG00Oo5a4G
4ALA00HG00?o5aL01AL00omOG`04G`0FoelOGamO7olOGamO7olOGamO7elOo`MO00So5alG7aLOo`PO
00?o7al01Al03OmO7elOGaoo7elOGal00ol5G`08oelOGamO7ol6G`03oemO00AO027o5alG7aLO5omO
7elOGamOoelOGamOoelOGamO7elOGol02U/00h5KF`0/F`40000[F`04oe]KPB5K00>1Fe/06E/00olG
5`035`03oa4A00<A00ko4ALA5a4G4ALA5a4Go`LG00?oGel015l00omOG`04G`03oemO00=O00Wo7elO
GamO7ol01al00omOG`04G`;o1el2o`0?GamO7elOoelOGamO7olO00?o00=Ooel01Ul00omOG`04G`0?
oamO7elOoelOGamO7eoo00MO00oo7elOGamO7omO7elOGol02Al2o`QK00>1Fe/0;5/10000:e/01?mK
Fh4QF`03PE]K01IK0ol0214G4ALA5a7o1AL02?lG4ALA5a7o1AL00olG5`055`03oemO00AO01KoGamO
7elOoamO7elOoamO7elOGaoo1el02OlG7aLO5alGo`087`03oalO00@O00CoGamO1?l5G`03oemO00EO
00SoGamO7elOo`EO00?oGel01El08_lG7aLO5alGoelOGamO7eooGamO7eooGamO7elOGamO7ol7F`03
PE]K02aK0@0002]K00CoFe^18E/00h5KF`0AF`Go11475`03oa4A00<A00ko4ALA5a4GoaLA5a4Go`LG
00?oGel015l00omOG`04G`03oemO00=O0_l01elOGamO7ol01al00omOG`05G`03oemO00IO00KoGamO
7el4o`<G00So5elGGaMOo`MO00?oGel015l03_lOGamO7omO7elOGaoo25l03olOGamO7elOoelOGamO
o`0:7`03oe]K00AK00>1Fe/0;5/10000:e/01?mKFh4QF`03PE]K00eK1?l02IlAoa6O4IlAW`024@07
5a4G4ALAo`055`08oaLA5a4G4Ol55`03oaLG00DG00?oGel015l01omO7elOGal00_l03ElOGamOoelO
GamO7ol01el2o`077aLO5alGo`087`03oaoo00;o00TGoelGGaMO5ol01Ul00omOG`05G`07oelOGamO
o`06G`03oemO00AO02?o7aLO5alG7olOGamO7elOGomO7elOGomO7elOGamO7elOo`05F`03PE]K02aK
0@0002]K00CoFe^18E/00h5KF`0;F`;o00ROoioOWmnOo`LA1aL00olA4@034@0>oa4G4ALA5olG4ALA
5ol75`03oemO00AO0_l6G`03oemO00=O00OoGamO7elO00;o1al00omOG`04G`03oemO00EO0_l01QLA
5a4Go`HG00So5elGGaMOo`MO00?oGel00el03omO7elOGaooGamO7elOo`07G`0@oelOGamO7elOoelO
GamOo`TO0ol3F`03PE]K02aK0@0002]K00CoFe^18E/00h5KF`0:F`0KoioOWmoo4IlAWa7o4IlAWa6O
4OlG4ALA5a7o00DG00So5a4G4ALAo`DG00?o5aL01AL00omOG`05G`0FoamO7elOGomO7elOGomO7elO
GamOo`MO00So7aLO5alGo`DO00?o4Ol01QL02?mO5elGGaOo1Ul00omOG`05G`07oelOGamOo`05G`03
oemO00EO023o7aLO5alG7olOGamO7elOGomO7elOGomO7elOGamOo`<O00CoFe^1;U/100008E/4o`IK
0X400on1F`0PF`03PE]K00MK0ol03MnOgioOWonOgioOWol01a400olG5`045`03oa4A00<A00ko4ALA
5a4GoaLA5a4Go`LG0_l6G`03oemO00AO00?oGel00el02OmO7elOGamOo`077`03oemO00AO00GoGemO
o`034@08oa4G4ALA5ol65`08oaMO5elGGol6G`03oemO00AO00ooGamO7eoo7elOGamO7ol01el04?mO
7elOGamO7omO7elOGol57`09oelOGamOoe^102iK0@00021K00?oFe/00U/00omKF`02F`03oe]K00>1
85/00h5KF`02F`Go0Yl07_oOWmnOgioOoa6O4IlAoa6O4IlAWa7o5a4G4ALAo`DG00So5a4G4ALAo`DG
00?o5aL01QL00omOG`04G`0FoamO7elOGomO7elOGomO7elOGamOo`MO013o7aLO5alGoaoo4ALA5a7o
1QL02?mO5elGGaOo1Ul00omOG`04G`08oamO7elOGol5G`03oemO00EO01co7aLO5alG7olOGamO7elO
GomO7elOGomO7eoo1al00omKP@0]F`40000PF`03oe]K009K00?oFe/00U/01_mKFe^1F`:17E/00h5K
o`03o`;O00?ogml00ml03onOgioOWmnOoioOWmnOo`074@03oaLG00@G00?o4A400a403_lA5a4G4AOo
5a4G4AOo21L00omOG`04G`03oemO00AO00?oGel00el02OmO7elOGamOo`077`04oemOG`Co1a402?lA
5a4G4AOo1QL02?lGGaMO5eoo1Ul00omOG`04G`0?oelOGamOoamO7elOGaoo00MO01goGamO7elOGaoo
GamO7eoo7omO7elOGamO7eooP@0]F`40000PF`03oe]K009K00?oFe/00U/01OmKFe^100=K0h4IF`?o
00>Ooil019l00onOW`03W`0NomnOgioOWmoo4IlAWa7o4IlAWa6O4OlG4ALA5a7o1AL02?lG4ALA5a7o
1AL00olG5`065`03oemO00AO01Ko7elOGamOoelOGamOoelOGamO7eoo1Ul4o`044ALA5`8A00LG4ALA
5a7o00HG00SoGaMO5elGo`IO00?oGel015l02?lOGamO7eoo1El00omOG`05G`0EoalG7aLO5aoo7elO
GamO7eooGamO00?o2al00omKF`0[F`40000PF`03oe]K009K00?oFe/00U/01OmKFe^100IK0X4EF`;o
1Ml00ooOg`03g`03omoO00?O00koWmnOgioOomnOgioOo`PA0_l55`03oa4A00<A00ko4ALA5a4GoaLA
5a4Go`PG00?oGel015l00omOG`04G`03oemO00=O00WoGamO7elOGol00al2o`0:5a4G5a4G4ALA5`LA
00So4ALA5a4Go`HG00So5elGGaMOo`IO00?oGel00el03olOGamO7eoo7elOGamOo`08G`08oelOGamO
7el4o`EO00/OGamO7elOGamOo`0/F`40000PF`03oe]K009K00?oFe/00U/01OmKFe^100QK0h4?F`?o
00?Ooil01Il00onOW`03W`03oinO00>O01kogioOWmnOoilAWa6OoilAWa6O4IlAWolA5a4G4Ol55`08
oaLA5a4G4Ol55`03oaLG00HG00?oGel015l06?lOGamO7eooGamO7eooGamO7elOGomOo`LA00DG4ALA
5`024@075a4G4ALAo`065`08oelGGaMO5ol6G`03oemO00AO00Oo7elOGaoo00EO00?oGel01El03_lG
7aLO5alG7olOGamO0_l00elOG`067`;o2Al2obYK0@00021K00?oFe/00U/00omKF`02F`05oe]KFh40
2e/2P@]K0_l5W`03omoO00CO00?ogml00ml00ooOg`03g`0>oioOWmnOgooOWmnOgol94@03oaLG00<G
00?o4A400a403_lA5a4G4AOo5a4G4AOo21L00omOG`04G`03oemO00AO00?oGel00el01omO7elOGal0
0_l01a4G4ALA5a400QL01a4G4ALA5ol01Q402?lA5a4G4AOo1QL01olGGaMO5ol01el00omOG`03G`0?
oamO7elOoelOGamO7eoo00QO00CoGooo1Ql00omOG`04G`0<oelOGamO7elOGaoo:E/1000085/00omK
F`02F`03oe]K009K00GoFe]KP@0=F`:11e/2o`CO00FOgioOo`06W`03oinO00>O00?oWil00il07_oO
WmnOgiooWa6O4IooWa6O4IlAWa6Ooa4G4ALAo`DG00So5a4G4ALAo`DG00?o5aL01QL00omOG`04G`0A
oamO7elOGomO7elOGomO7el00_l;4@0?oaLA5a4G4OlG4ALA5a7o00HG00SoGaMO5elGo`EO00?oGel0
1El01olOGamO7ol01El00omOG`05G`08oaLO5alG7aL2o`0;GamO7elOGamO7ol01Al00olO7`087`03
oe]K02IK0@00025K1?l5F`04oe]KPA1K0h42F`;o2il00ooOg`04g`03omoO00?O00?ogml00ml03_nO
gioOWmoogioOWmoo2A400olG5`035`03oa4A00<A00ko4ALA5a4GoaLA5a4Go`PG00?oGel015l00omO
G`04G`03oemO00=O00SoGonO4IlAW`8A00lG4ALA5a4Goa4G4ALA5ol01Q402?lA5a4G4AOo1QL01olG
GaMO5ol01el00omOG`03G`0?oamO7elOoelOGamO7eoo00EO00CoGamO2Ql00omOG`03G`;o00XOGamO
7elOGaoo9e/10000:U/2o`03Fh5K019K0_l:g`05WmnOgol01Yl00onOW`03W`03oinO00>O01kogioO
WmnOoilAWa6OoilAWa6O4IlAWolA5a4G4Ol55`08oaLA5a4G4Ol55`03oaLG00HG00?oGel015l02olO
GamO7eooGamO00?o21400olA4@054@0?oaLA5a4G4OlG4ALA5a7o00HG00SoGaMO5elGo`EO00?oGel0
15l02?mO7elOGaoo1El00omOG`05G`0:oaLO5olGGaMO5`;o00QO7elOGamO7`;o1Al00olO7`077`03
oe]K02AK0@0002YK00CoFe^14U/01onOgioOWml02il00ooOg`04g`03omoO00?O00?ogml00ml03_nO
gioOWonOgioOWmoo2A400olG5`035`03oa4A00<A00ko4ALA5a4GoaLA5a4Go`PG00?oGel015l01?mO
Gel6o`FO01LAWa6O4IlAoaLA5a4G4AOo4ALA5a4Go`064@08oa4G4ALA5ol65`07oaMO5elGo`06G`03
oemO00=O01_oGamO7eoo7elOGamO7eooGomO7elOGamO7ol02Al00omOG`03G`;o00UO7elOGamO7ol0
9E/10000:U/01?mKFh4AF`03omoO00gO00FOgioOo`06W`03oinO00>O00?oWil00il07_oOWmnOgolA
Wa6O4OlAWa6O4IlAWa6Ooa4G4ALAo`DG00So5a4G4ALAo`DG00?o5aL01QL00omOG`03G`Co00GOWmnO
g`06W`03oa4A00DA0_l64@0?oaLA5a4G4OlG4ALA5a7o00HG00SoGaMO5elGo`EO00?oGel015l01omO
7elOGol01El00omOG`05G`;o00XGGaMO5elGGaMO0_l021mO7elOGamO0_l57`03oalO00HO00?oFe/0
8U/10000:U/01?mKFh4@F`0;omoNWmnOgioOWml01Yl00onOW`02W`03omoO00CO00?ogml00ml00ooO
g`02g`0>omnOgioOWonOgioOWol:4@03oaLG00<G00?o4A400a403_lA5a4G4AOo5a4G4AOo21L00omO
o`02o`ZO00?oWil00il06?lAWa6O4IlAWolA5a4G4AOo4ALA5a4Go`DA00Wo5a4G4ALA5ol01QL01olG
GaMO5ol01Ul00omOG`03G`0;oelOGamOoamO7el00_l3G`0;oamO7elOGamO7el00_l87`03oemO00=O
00SoGamO7elOG`?o8U/10000:U/01?mKFh4?F`03omoO00[O00?ogml00ml01_nOgioOo`JO00?oWil0
0Yl00onOW`03W`0HoioOWmnOgolAWa6O4OlAWa6O4IlAWa6O0_l01ALA5a7o00DG00So5a4G4ALAo`DG
00?o5aL01AL2o`0?WmnOgioOWonOgioOWmoo00JO00?o4A401A400olA4@044@0>oaLA5a4G4OlG4ALA
5ol75`08oelGGaMO5ol5G`03oemO00AO00OoGamO7eoo00EO00_oGooo7elOGamO7`02o`0CGaMO5elG
GaMOoelOGamO7elOo`057`;o0al2o`<O00?oFe/07e/10000:U/01?mKFh4>F`0@omoNgmkOgYoOWmnO
gioOo`FO00?oWil00Yl00ooOg`04g`03omoO00;O00?ogml00ml03_oOWmnOgiooWmnOgioo2a400olG
5`025`03oa4A00<A00ko4ALA5a4GoaLA5a4Go`DG00?oWml029l00onOW`04W`;o1Il03onO4IlAWa6O
oa4G4ALA5`02o`065a4G4AOo1A402OlG4ALA5a4Go`065`07oaMO5elGo`06G`03oemO00=O00CoGamO
0ol;G`;o00QO7elOGamO7`;o1al2o`EO00?o7ol01Ql00omKF`0NF`40000ZF`04oe]KP@eK00?ogml0
1]l00ooOg`05g`03omoO00?O00KoWmnOgol6W`03oinO00:O00?oWil00il07onOgioOWmoo4IlAWa7o
4IlAWa6O4IlAWa7o5a4G4Ol01AL02?lG4ALA5a7o1AL01OlG5aOo00FO013ogioOWmnOgooOWmnOgioo
1Il2o`HA00?o4A401A403OlA5a4G4OlG4ALA5ol01aL02?mO5elGGaOo1El00omOG`04G`04oelOG`Go
1AL02amO7elOGamO7elO00?o014GGaMO5elGoamO7elOGamOo`037`?o21l00omKF`0MF`40000YF`05
oe]KFh402e/2o`0CgmkOg]oNgmkOg_oOWmnOgioOo`05W`03oinO00:O00?ogml01=l00ooOg`02g`03
omoO00?O00kogioOWmoogioOWmnOo`/A00?o5aL00QL00olA4@034@0Hoa4G4ALA5olG4ALA5olGoioO
WmnOgioo1il00onOW`04W`03oinO00BO00Oo4IlAWa6O00;o00dG4ALA5a7o5a4G4AOo00DA00Wo5a4G
4ALA5ol01QL01olGGaMO5ol00el6o`045a4G4@;o00MO5elGGaMO00;o2El2o`067elOGamO0_l67`Co
00@OGamO21l00omKF`0LF`40000YF`05oe]KFh402E/2o`03gmkO00[O00?ogml01Ml00ooOg`03g`06
oioOWmoo1Yl00onOW`02W`03oinO00>O01ooWmnOgiooWa6O4IlAoa6O4IlAWa6O4IlAoaLA5a7o00DG
00So5a4G4ALAo`<G0ol:W`07oioOWmnOg`02o`06WmnOgioo1Yl00olA4@054@03oa4A00@A00go4ALA
5a7o5a4G4AOo00LG00SoGaMO5elGo`=O1Ol0314G4ALAoa4G4ALA5`?o21L3o`067elOGamO0_l02AMO
5elGGomO7`03o`03GamO00HO00?o7al01Al00omKF`0KF`40000YF`?o00=KPE/01e/00ooNgP04gP0C
gmkOg]oNgmkOg_oOWmnOgioOo`05W`03oinO00:O00?ogml01=l00ooOg`02g`03omoO00?O00gogioO
WmoogioOWmoo00`A00?o5aL00QL00olA4@034@06oa4G4ALA1?l00a6O4@02W`09gioOWmnOgioO00;o
1Yl00onOW`03W`;o1Il2o`0DWa6O4IlAoaLA5a4G4OlG4ALA5ol54@09oaLA5a4G4AOo00DG1?l031LA
5a7o5a4G4ALA5`;o00HA5a4G4AL2o`0:5elGGaMO5elGG`?o15l2o`057elOoal00_l03amO7elOGaoo
GamO7elOo`067`;o6e/10000:E/01OmKFe^100MK00[og]oNgmkOg]oo2Ml00ooOg`05g`03omoO00?O
00KoWmnOgol6W`03oinO00:O00?oWil00il07onOgioOWonO4IlAWonO4IlAWa6O4IlAWa7o5a4G4Ol0
1AL00olGo`02o`?O00LAga7O4MlA00ZO00oogioOWmnOoioOWmnOgol01Yl00olA4@044@03oa4A00@A
00go4ALA5a7o5a4G4AOo00LG00?oGol00_l04a4G4OlG4ALA5a4GoaLA5a4G4AL00_l01A4G4ALA00;o
2aL5o`0BGooooamO7elOGamO7elOGaoo1Al00olO7`057`03oe]K01QK0@0002UK00GoFe]KP@07F`03
omkN00ON00[og]oNgmkOg]oN0_l01ioOWmnOgol01Il00onOW`02W`03omoO00?O00?ogml00ml00ooO
g`03g`0=omnOgioOomnOgioOo`0<4@03oaLG008G00Co4A4A0ol9W`0@4IlAWa7oWmnOgioOWmnOo`JO
0_l5W`03oinO00BO01GoWa6O4IlAoaLA5a4G4OlG4ALA5ol01A401olG4ALA5a400_l021LA5a4G4ALA
0_l01Q4G4ALA5`;o00HG4ALA5a42o`055a4G4AL00_l031MO5elGGaMOoelOG`DO1Ul02OlOGamO7elO
G`02o`04GamO7`;o1Ql00omKF`0GF`40000YF`05oe]KFh4025/02ooOg]oNgmkOg]oo00[O00?ogml0
1=l00ooOg`03g`06oioOWmoo1Il00onOW`03W`03oinO00>O01coWmnOgiooWa6O4IooWa6O4IlAWa6O
4IlAoaLA1Ol<g`07oa7O4MlAg`02o`NO0_l039oOWmnOgooOWmnOg`;o1Il2o`DA0_l54@0=oa4G4ALA
oaLA5a4Go`035`;o0a402OlG4ALA5a4G4@02o`064ALA5a4G0ol01ALA5a4G00;o00DA5a4G4@03o`@G
00?oGel00el00omOG`02G`06oelOGamO0_l021mO7elOGamO0_l47`03oalO00@O00?oFe/05U/10000
:E/01OmKFe^100UK00?og]h01mh04_oNgmkOg]oNgmkOoioOWmnOg`;o19l00onOW`02W`03omoO00?O
00?ogml00ml00ooOg`03g`0=omnOgiooWmnOgioOo`0<4@;o00?OWml00Yl01MnOgioO00;o1il2o`0?
4IlAWa7oWmnOgioOWmoo00JO00?oWil019l00onOW`04W`0Doa6O4IlAWolA5a4G4OlG4ALA5ol54@03
oaOo00LA0_l01a4G4ALA5a400_l01a4G4ALA5a400_l01A4G4ALA00?o00DA5a4G4@02o`0:GomO7elO
GamOo`DO00?oGel00el03omO7elOGamO7eoo7elOG`02o`DO00?oFe/05E/10000:E/01OmKFe^100YK
00[ogmkOg]oNgmkO0_l9g`03omoO00GO00?ogml00]l01_nOgioOo`FO00?oWil00il00onOW`02W`0J
omnOgioOoa6O4IlAWonO4IlAWa6O4IlAWol6g`03omoO00CO0_l7g`;o00CO4MlA0_l7W`;o00gOWmnO
gooOWmnOgioo00JO00?o4A4011400olA4@034@0:oa4G4ALAoaLA5`?o2Q42o`0@4ALA5a4G4OlG4ALA
5a4G4@;o00HG4ALA5a42o`065a4GoaOo2El00omOG`03G`;o00AO7elO0_l025lOGamO7elO0_l47`03
oalO00<O00?oFe/055/10000:E/01?mKFh4<F`03omkN00SN01?ogmkOg]oNgmkOoioOWmnOgioo00BO
00?oWil00Yl00ooOg`03g`03omoO00;O00?ogml00ml03_nOgioOWonOgioOWmoo2A404_oNgmkogioO
WmooWmnOgioOo`RO00KoWa6O4Il2o`08WmnOgioOWol5W`;o1Il00onOW`04W`;o00nO4IlAWolA5a4G
4OlG4AL01Ol01IlAWa7o00XA0_l01Q4G4ALA5`;o00PG4ALA5a4G4@?o00DG4AOo5`03o`0>GaMO5elO
GamO7elOGol67`03oemO00=O013o7elOGamO7elOoelOGaoo0al3oaEK0@0002UK00CoFe^13E/03?oO
g]oNgmkOg]oNo`WO00?ogml01Ml00ooOg`02g`06oioOWmoo1Il00onOW`02W`03oinO00>O01OogioO
Wmoo4IlAWa7o4IlAWa6O4IlAo`05g`03omoO00;O0_l5g`;o1ml2o`064MlAga7o1il03OoOWmnOgioo
WmnOgil00_l6W`03oa4A00<A00Co4A4A1Ol4W`09oa6O4IlAWa7o00TA00So5a4G4ALA5`;o00TG4ALA
5a4G4AL00ol02aLA5a5O5elGGaOo00QO00?oGel015l03omO7elOGomO7elOGamO7`09o`AK1H4?F`40
000YF`04oe]KP@iK00?og]h02=h04ooOg]oNgmkOg]ooWmnOgioOWol019l00onOW`02W`03omoO00?O
00?ogml00]l00ooOg`03g`0=oioOWmnOoioOWmnOo`074@08omoNgmkOg]l2o`0;gioOWooOWmnOgil0
0_l7W`;o00BO4IlA0_l01]nOgioOW`;o1Il00onOW`04W`03oinO00BO00CoWa6O1Ol01IoOWmoo00JO
0_l01Q6O4IlAW`?o1Q42o`075a4G4ALA5`02o`045a4G4@;o01TAoa4G4ALA5a7o5elGGaMOoelOGamO
7eoo00HO0_l4G`;o00IO7elOGol6F`N155/10000:E/2o`03Fh5K00iK00cogmkOg]oNgmkOg_l9g`03
omoO00GO00?ogml00]l01_nOgioOo`FO00?oWil00Yl00onOW`03W`0ComnOgioOoa6O4IlAoa6O4IlA
o`0:g`03omoO00;O0_l6g`03omoO00KO00Koga7O4Ml2o`JO00KoWmnOgil2o`06gioOWmoo1Il4o`05
Wa6O4Ol01Yl2o`JO0_l01Q6O4IlAW`;o1Q42o`075a4G4ALA5`02o`0E5olA5a4Goa4G4ALA5a7o5elG
GaMO00;o1Ul00omOG`05G`0;oamO7elOoamO7ol01h4KF`40000YF`04oe]KPA1K00?og]h02=h04ooO
g]oNgmkOg]ooWmnOgioOWol019l00onOW`02W`03omoO00?O00?ogml00]l00ooOg`03g`0=oioOWmoo
gioOWmnOo`044@0<omkOg]oNgmkOg]oN0_l02ioOWmooWmnOgioO00;o1il2o`0<4IlAWa7oWmnOgioO
0_l5W`03oinO00>O00?oWol00_l02YoOWmnOgioOWml2o`06gioOWmnO0_l5W`;o00JO4IlAWa43o`DA
0_l01QLA5a4G4@;o1Q402?lA5a4G4ALA0_l03UlGGaMO5olOGamO7eoo1al2o`AO00?oGol08e/10000
:E/01?mKFh4@F`0=omkOg]oNgmkOg]oNo`09g`03omoO00GO00?ogml00]l01_nOgioOo`FO00?oWil0
0Yl00onOW`03W`0@omnOgiooWa6O4IlAoa6Oo`kO00?ogml00]l2o`KO00?ogml01]l2o`04ga7O4@;o
1Yl02_oOWmnOgooOWml3o`0?gioOWmnOgiooWa6O4IlA00;o1Yl2o`FO0_l01a6O4IlAWa400_l54@;o
01hGooooWolG4ALA5a4Goa4G4ALA5a4GoelGGaMO5ol6G`03oemO00IO00?oGal00olTF`40000YF`04
oe]KPA5K00?og]h02Mh2o`08g]oNgmkOg]l2o`07gioOWmnOo`04W`03oinO00:O00?ogml00ml00ooO
g`02g`03omoO00?O01koWmnOgooOWmnOgioo4OoOg]oNgmkOg]oNgmkOg]l2o`04gioOW`;o00FOgioO
W`02o`RO0_l0116O4Il2o`06WmnOgioo0il5o`CO00VOgioOWmnOgil00_l01MnOgioO00;o00KOWmnO
gil2o`FO0_l01ilAWa6O4Il00ol24@09oa7o4IlAWa7o00LA013o4ALA5a4G4AOoGaMO5elG0_l01UlO
GamOo`LO0olWF`40000XF`05oe]KFh404U/03_oNgmkOg]oNgmkOg]oo2Ml00ooOg`04g`03omoO00;O
00KoWmnOgol5W`03oinO00:O00?oWil00il02ooOWmnOoilAWa6O00;o4]l2o`CO00?ogml01=l2o`SO
00Oo4MlAga7o00>O1Ol01A7O4Moo00NO00SOWmnOgioOW`;o00DAWa6O4@02o`JO0_l5W`?o00NO4IlA
Wa6O00;o2Il06_lG4ALA5a4Goa4G4ALA5a4GoelGGaMO5eoo1El00omOG`03G`03oe]K02QK0@0002QK
00GoFe]KP@0CF`03omkN00[N01;og]oNgmkOg]oNomnOgioOWol4W`03oinO00:O00?ogml00ml00ooO
g`02g`03omoO00?O00OoWmnOgooO00?o01_Og]oog]oNgmkOg]oNgmkOg]oNgmkOoioOWml00_l01mnO
gioOWol029l2o`03Wa7o00Co19l02OnO4IlAWa6Oo`06g`08oioOWmnOgil2o`05gioOWml00_l01]nO
gioOW`?o1Il2o`0B4OooomoogioOWmnO4IlAWa7o1a404OlA5a4G4ALA5omO5elGGaMO00;o00DOGamO
o`037`03oe]K02UK0@0002QK00GoFe]KP@0DF`0>omkOg]oNgmkOg]oNgol9g`03omoO00CO00?ogml0
0]l01_nOgioOo`FO00?oWil00Yl01?nOWil8o`SN0_l@g`;o1=l00ooOg`04g`;o1ml3o`CO00OogioO
WmnO00;o00KO4MlAga42o`FO0_l03MnOgioOWonO4IlAWa400_l7W`;o0il00onOo`05W`03oinO00VO
017o5a4G4ALA5olA5a4G4ALA5`02o`085elGGaMO5ol4G`03oeoo02aK0@0002QK00GoFe]KP@0EF`03
omkN00[N01;og]oNgmkOg]oNomnOgioOWol4W`03oinO00:O00?ogml00ml00ooOg`05o`CN00COg]oN
0]l02=kOg]oNgmkO0_l05MoNgmkOg]oNgmkOg]oNgmkogioOW`02o`06WmnOgioO0_l3W`;o00?OWml0
1Yl2o`JO0_l01IlAWa6O00?o1Ml2o`04WmnOg`;o00JOgioOWml2o`07gioOWmnOg`03o`044IlAo`GO
00gogioOWmnOoilAWa7o00LA017o4ALA5a4G4ALAoaMO5elGG`07o`03PE]K02YK0@0002QK00GoFe]K
P@0FF`0>omkOg]oNgmkOg]oNgol9g`03omoO00CO00?ogml00]l01_nOgioOo`>O1?l;gP03omkN00;N
00?og]h01]h2o`oO0_l4g`03omoO00GO00_ogooOWmnOgioOW`06g`;o00GOWmnOg`02o`064MlAga7O
0_l5W`;o00BOgioO0_l01YlAWa6O4@;o00fOoooogioO4MlAga7o00FO00?oWil019l00onOW`02W`0F
oaLA5a4G4AOo4ALA5a4G4ALAoaMO5`;o1e/00h5KF`0ZF`4000000e_oF`04F`04oe]KF`;o00=Koe/0
65/01OmKFe^101MK00?og]h02]h04_oNgmkOg]oNgmkogioOWmnOo`:O2_l00miagP07L@03omkN00CN
00Gog]oNg`02o`07gmkOg]oNg`02o`0DgmkOg]oNgmkOg]oNgmkOoioOWml2o`05gioOWml00_l039oO
WmnOgioOWmnOo`FO0_l5W`;o00JO4IlAWa42o`GO0ol00mnOg`02o`05WmnOgil00_l7W`064IlAWa7o
1Ml03OoOWmnOgiooWa6O4Ol01a403OlA5a4G4ALA5a7o5ol02E/00h5KF`0ZF`4000000e_oF`04F`05
oe]KFol075/2o`9K00>1Fe/05U/03OoNgmkOg]oNgmkOg]l00_l8g`03omoO00?O0ol4g00<gW7NLMia
gW7NLMko1]h00ooNgP04gP;o1=h2o`KN0_l>g`;o1=l00ooOo`02o`0AWmnOgioOWmnOgioOWmnOgol0
1=l2o`05gioOWml00_l01Q7O4MlAg`?o1Il2o`03gioO00;o00>Oool01=l039oOWmnOga7O4MlAo`FO
00?oWil019l00onOW`02W`0CoaLA5a4G4AOo4ALA5a4G4ALAo`0:F`03PE]K02YK0@000003FomK00AK
00GoFe]Ko`0LF`05oe]KFh4065/00ooNgP0<gP0;omoNgmkOg]oNoml00ol00kOog005g004gW7NL@;N
00EagW7NL@02o`Ea0_l6gP;o00COg]oN0_l01]kOg]oNg`;o017Og]oNgmkOg]oNgmkOg_oOW`03o`0:
WmnOgioOWmnOg`;o00WOWmnOgioOWml00_l3W`;o1Il3o`064IlAWa6O0_l3g`03omoo00Go3Il01_nO
4IlAo`GO00OogioOWmnO00;o00@AWa7o1a402_lA5a4G4ALA5ol:F`03PE]K02YK0@000003FomK00AK
00GoFe]Ko`0LF`05oe]KFh406E/04?oOg]oNgmkOg]oNgmkOg_l8g`07okJg][Nfo`06g00=og7NLMko
gW7NLMiao`06gP;o1]h2o`CN0_l6gP;o3Ml2o`GO00_oWmnOgioOWmnOg`03o`07gioOWmnOg`03o`;O
0ol01IoOWmnO00;o00KO4MlAga43o`oO00goWmnOgioOomlAga7o00FO00?oWil01Il05?nOWioo5a4G
4ALA5olA5a4G4AOo2e/00h5KF`0ZF`4000000e_oo`05o`=K00?oFe/06U/01?mKFh4KF`03omkN00cN
00oogmkOg]oNgonf]kJg]_l01m`03OmagW7NLOoNLMiag_l01g42o`KN00Kog]oNgmh2o`06g]oNgmkO
0_l02moNgmkOg]oNgmko00?O00SogioOWmnOg`;o00ROgioOWmnOg`?o00NOgioOWmnO00;o0il2o`FO
0_l00a7oo`03g`05WmnOgil00]l01IoOWmoo00FO00?oWil019l01_nO4IlAo`GO00gogioOWmnOgolA
Wa7o00LA00Ko4ALA5ol<F`03PE]K02YK0@000003FomK00AK00GoFe]Ko`0LF`04oe]KPAaK013ogmkO
g]oNgmkOg]oNgmko1Ml02Onf][Nf]kJgo`08g00<omiagW7oLMiagW7o2=h2o`GN0_l5gP;o1]h2o`OO
00?ogml01ml00ooOg`04g`?o00JOgioOWml3o`06gioOWmnO0ol2g`;o00>Ogil00ol01IoOWmnO00OO
00?ogml00]l00ooOg`03g`;o00_OWmnOgooO4MlAo`05W`03oinO00FO017oWinOoaLA5a4G4AOo4ALA
o`0=F`03PE]K02UK0@000003FomK00AK00?oFe/00olKF`04oe]KPAeK00?og]h03=h01_oOg]oo]`:f
00Jg][Nf]ol9g00;omiagW7ogW7NLMh00_l8L@03omkN00CN0_l01MkOg]oN00?o00GOg]oNg`02o`05
gmkOg_l03]l3o`03WmnO00Co00GOWmnOg`03o`06WmnOgooO1ol:g`0=omnOgioOoioOWmnOo`05W`03
oinO00>O00KoWa6O4Ol4g`0>oioOWmnOgioOoa6O4Ol74@03oa7o00iK00>1Fe/0:E/1000000=Koe/0
25/00omKF`0JF`04oe]KPAiK01;ogmkOg]oNgmkOg]oNgmkogol4]P06]kJg][Oo2]`2o`03LMia00;o
00KNLMiag_l8gP;o1]h2o`KN0_l5gP;o00?Ooml04]l4o`;O1?l019oOWml4o`SO00gNgmkOg]nOgioO
Wmoo00GO00?ogml00ml00ooOg`03g`0<omnOgioOomlAga7o19l00onOW`06W`0;oinOWolG4ALA5a40
0_l?F`03PE]K02UK0@000003Fooo00Go0e/00omKF`0JF`04oe]KPAmK00?og]h03=h01Ong][Nf00:g
00Jf]kJg]_l;g00<og7NLMkoLMiagW7o2G42o`KN0_l01]kOg]oNg`;o00?Og]l00olIg`Co00BOoooo
0mh01_oOg]oNg`;N00?Og]l01]l00ooOg`03g`0=omnOgioOoioOWmnOo`05W`03oinO00>O00KoWa6O
4Ol4g`0>oioOWmnOgioOoa6O4Ol34@;o4E/00h5KF`0YF`40000XF`04oe]KPB1K00oogmkOg]oNgmkO
g]oNgol01kH01KNf]kKo00cL00_oLMiag_oNLMiagP02o`WN0_l6gP;o1Mh4o`0?gmkOg]oNgmkOg]oN
gmkO00co00iagooOg]oNomkOg]oNo`[O00kogmkOg]oogioOWmnOo`CO00?ogml00ml2o`CO00cogioO
Wmooga7O4Ol4W`03oinO00JO00OoWinOoaOo01=K00>1Fe/0:E/100004U/00omKF`02F`Co0U/4o`IK
0h400on1F`0PF`03omkN00WN00oo][Nf]kJg]_ng][Nf]ol03=`01OmagW7N00;o00KNLMiag_l:L@;o
1]h2o`0Ag_oogmkOg]oNgmkOg]oNgmh03Ol2g`03omkN00;N00?og]h00]h00ooNgP03gP0<omoNgmkO
g_oOg]oo1Ml2o`GO00goWmnOgonOgioOWmoo00BO0_l4W`06oilAWa7o1=l02?nOgioOWmnO1_lDF`03
PE]K02UK0@00019K00GoFe]Ko`04F`;o15/00omKF`03F`03oe]K00>185/03_oNgmkOg]oNgmkOg_ne
1kH01[Nf]kJgo`gL0_l02miagW7oLMiagW7o00_N00?og]h01=h2o`0GgmkOg]oNgmkOg]oNgmkOg]oN
gmkOg]l00_l00moNo`04gP0Aog7OLMoogmkOg_oNgmkOg_l01]l04_oOgmoogmkOg]oNoioOWmnOo`CO
00?ogml01=l00ooOg`03g`0;oioOWmooga7O4Ol019l00onOW`03W`03oe]K01QK00>1Fe/0:E/10000
4U/01OmKFe_o00AK0_l4F`03oe]K00=K00KoFe]KPE/3PAeK00>1omh02=h04Ool]_bf]kJg][Oo][Nf
]kKo00kL00cogW7NLOoNLMiag_l;L@;o00CNoooo3]h;o`06g]oNgmko1=l00ooNgP02gP03omkN00;N
00?og]h00mh03?oOg]oNgmkogmkOo`KO00?ogml00ml03?nOgioOoioOWmnOg`;o19l00onOW`02W`06
oilAWa7o1=l01OnOgioo01]K00>1Fe/0:E/100004U/01OmKFe_o00AK0_l4F`03oe]K00=K00GoFe]K
P@04F`>16U/0485KomkOg]oNgmkOokJe]_l7]P05]kJg]_l03m`02ooNLMiaog7NLMia00;o2mh03_ma
gg7OLMmagg7OLMma3?l2gP08omoNgmkOg_l4gP0Aog7OLMoogmkOg_oNgmkOg_l01]l04_oOgmoogmkO
g]oNoioOWmnOo`CO00?ogml01Ml00ooOg`02g`0;oioOWmooga7O4Ol019l00onOo`0LF`03PE]K02UK
0@00019K00GoFe]Ko`04F`;o15/00omKF`03F`05oe]KFh401e/4PAIK00B1Fe_o1]h04onfo;Kl][Nf
]kJg]_ng][Nf]ol03m`01OoNLMia00;o00IagW7NLOl:L@0IomiagW7NLMiagW7NLMiagW7NLMiagW7N
o`04gP08omoNgmkOg_l4g`03omkN00;N00?og]h00]h00ooNgP03gP0;omoNgmkOg_oOg]l00_l5g`03
omoO00?O0_l03=nOgonOgioOWmnOo`BO00?oWil00Yl00onO4@08oaeK00>1Fe/0:E/100004U/01OmK
Fe_o00AK0_l4F`03oe]K00=K00GoFe]KP@0;F`>14e/04H5KFe_og]oNgmko]KJe][Go00Ff00Oo]kJg
][Oo013L0_l02g7NLMkogW7NLMko00SN00?og]h05Mh00omao`04gP08omoNgmkOg_l4gP0Aog7OLMoo
gmkOg_oNgmkOg_l01]l00ooOg`02g`0>omkOg]oNoioOWmnOgol3g`03omoO00GO00?ogml02OlUF`03
PE]K02UK0@00011K0ol3F`03oe]K009K0_l4F`03oe]K00=K00GoFe]KP@0>F`>145/00h5KF`02F`03
omkN00;N01?o]_bfo;Kl][Nf]kJgokJg][Oo01;L00_oLMiag_magW7NL@02o`Ia01WoLMiagW7NLMia
gW7NLMiagW7NLMiagW7o00;N00?og]h00]h02?oOg]oNgmko1=l00ooNgP02gP03omkN00;N00?og]h0
0mh03OoOg]oNgmkogmkOg_l01Ml2o`GO00_ogioOoioOWmnOg`03o`03PE]K02]K00>1Fe/0:E/10000
4U/01OmKFe_o00AK0_l4F`03oe]K00=K00GoFe]KP@0AF`>13E/00h5KF`03F`0<omkOokJe][Ff]KKo
1KH01onf]kJg]_l04]`01OmagW7N00;o00IagW7NLOl4gP03omkN01GN00Kogg7OLOl4gP08omoNgmkO
g_l4gP0Aog7OLMoogmkOg_oNgmkOg_l01]l00ooOg`02g`0>omkOg]oNgooOWmnOgol3g`04omoOg`;o
0e/00h5KF`0[F`03PE]K02UK0@00019K00?oFe/00U/4o`9K1?l6F`05oe]KFh4055/3P@YK00>1Fe/0
15/05ooNoobfo;Kl]_bfokJg][NfokNf]kKo01?L0_l02miagW7ogW7NLMko009a01WoLMiagW7NLMia
gW7NLMiagW7NLMiagW7o00KN00?og]h00]h02?oOg]oNgmko1=l00ooNgP02gP03omkN00;N00?og]h0
0mh03OoOg]oNgmkogmkOg_l01]l00ooOg`03g`07omnOgonOo`05F`03PE]K02]K00>1Fe/0:E/10000
9e/2o`9K00>1Fe/05E/4P@IK00>1Fe/01E/02one][Ff]KJe][Go00Ff00Oo]kJg][Oo01CL00kogW7N
LOmagW7NLOoNoaON00WoLMmagg7OLOl01=h02?oOg]oNgmko1=h04Omagg7OomoNgmkog]oNgmko00KO
00?ogml00]l03?oNgmkOg]oogioOW`Ko1U/00h5KF`0[F`03PE]K02UK0@0002MK00CoFe^175/3P@=K
00>1Fe/01E/05obfo;Kl]_bfo;KlokNf]kJgokJg][Oo01GL00WogW7NLOoNLMh00ol00mkoo`0Eo`WN
00?og]h00]h02?oOg]oNgmko1=l01OoNg]ko00CN00?og]h01=h03OoOg]oNgmkogmkOg_l01]l01?oO
ool<F`03PE]K02]K00>1Fe/0:E/100009e/01?mKFh4OF`B125/02kFf]KJe][Ff]KKo00Ff00Oo][Nf
]kKo01GL00?ogW401OlHL@03og5a009a00WOLMmagg7OLOl01=h02?oOg]oNgmko1=h04Omagg7og]oN
gooOg]oNgmko00KO00?ogml00]l01_oNgmkOgP;o3U/00h5KF`0[F`03PE]K02UK0@0002MK00CoFe^1
8U/3P@MK01Kl]_bfo;Kl]_bfokJg][NfokNf]kKo5]`2o`07gG7MLMeag@08o`ea00?oLG400g48gP03
omkN00?N00SogmkOg]oNo`CO00Gog]kNo`04gP03omkN00CN00kogmkOg]oNomoNgmkog`?o45/00h5K
F`0[F`03PE]K02UK0@0002MK00CoFe^18U/00h5KF`04P@=K00_o]KJe][Ff]KJeo`05]P06okNf]kKo
5]`01Oo/g>cL00?o00UagG7MLMeagG402?l4L@03og5a00Ea00Wogg7OLMmagol01Mh02?oOg]oNgmko
1=h04Omagg7og]oNgooOg]oNgmko00KO00?ogml00olCF`03PE]K02]K00>1Fe/0:E/100009e/01?mK
Fh4RF`03PE]K00AK0h405e^fo;Kl]_bfo;KlokNf]kJgokJg][Oo01GL00?og=`02]`8o`04LMeag@Co
2G400ooNgP05gP03omkN00?N00SogmkOg]oNo`CO00Gog]kNo`04gP03omkN00CN00KogmkOg]l3oaIK
00>1Fe/0:e/00h5KF`0YF`40000WF`04oe]KPB5K00>1Fe/025/2P@0:][Ff]KJe][Ffo`Ff00Ko][Nf
]olEg00EoncLk=c/g>cLk=c/g>cLk=c/g>cL00Go1=d9L@09ommagg7OLMoo00GN00SogmkOg]oNo`CN
017oLMmaomkOg]oogmkOg]oNo`03g`03oe]K01MK00>1Fe/0;5/00h5KF`0XF`40000VF`05oe]KFh40
8E/00h5KF`0:F`0FokKl]_bfo;Kl]_nf]kJg]_ng][Nfoa?L00?og=`05]`02?negG7MLMgo2742o`KN
00?og]h00mh02?oOg]oNgmko1=l01OoNg]ko00CN00?og]h01=h00ooOo`0JF`03PE]K02aK00>1Fe/0
:5/100009U/01OmKFe^1025K00>1Fe/02e/02_nf]KJe][Ff]Ol5]P06okNf]kKo4m`07OoLk=c/g>cL
k=c/g>cLk=c/g>cLk=c/g>cl]Oco00GM00?oLG401W402?magg7OLMoo1Mh02?oOg]oNgmko1=h03oma
gg7og]oNgooOg]oNg`02oa]K00>1Fe/0;5/00h5KF`0XF`40000VF`05oe]KFh408E/00h5KF`0;F`0F
oobfo;Kl]_bfo?ng][Nf]onf]kJgoa;L00?og=`05M`6]@07omeagG7Mo`07L@03omkN00CN00?og]h0
0mh02?oOg]oNgmko1=l01OoNg]ko00CN00?og_l00_lMF`03PE]K02aK00>1Fe/0:5/100009U/2o`9K
00>1Fe/07e/00h5KF`0<F`0:okFf]KJe][Ffo`Ff00Ko][Nf]olBg00Qomc/g>cLk=c/g>cLk=c/g>cL
k=c/g>co]Obeo;Gl]Oco00CM0_l6L@07og7OLMmao`06gP08omoNgmkOg_l4gP07og7OLOoNg`03ob1K
00>1Fe/0;5/00h5KF`0EF`J13E/100009U/01OmKFe^1025K00>1Fe/03E/05Ool]_bfo;Kl]_nf]kJg
]_ng][Nfo`0Ag003omcL01?L00?o]KD02;D2o`04gG7ML@;o1G400ooNgP03gP03omkN00CN00SogmkO
g]oNo`;O2?lSF`03PE]K02aK00>1Fe/035/9PA=K0@0002IK00GoFe]KP@0QF`03PE]K00eK00[o][Ff
]KJe][Go1KH01_ng][Nfoa7L02?og>cLk=c/g>cLk=c/g>cLk=c/g>co]Obeo;Gl]Obeo;Gl]@02o`CM
00?oLG400g42o`05gg7OLOl01]h01_oOg]oNg`?o:e/00h5KF`0/F`03PE]K009K2X4LF`40000VF`05
oe]KFh408E/00h5KF`0>F`0DokKl]_bfo;KlokNf]kJgokJg]_l@g003omcL01?L00?o]KD03KD01Oma
gG7M00;o1G400ooNgP02gP03omkN00CN00GogmkOo`02F`03PE]K02UK00>1Fe/09e/:PBIK0@0002IK
00GoFe]KP@0QF`03PE]K00mK00Wo][Ff]KJe]_l01KH01_nf]kJgo`oL01Gok=c/g>cLk=c/g>cLk=c/
g>cLk=`00_l04;Gl]Obeo;Gl]Obeo;Gl]O`2o`CM00?oLG400g401_oOLMmao`KN00?ogol00e/00h5K
F`0YF`03PE]K01iK2H45F`03PE]K02QK0@0002IK00GoFe]KP@0QF`03PE]K00mK01Coo;Kl]_bfo;Ko
][Nf]onf]kJgo`oL00?og=`04M`01?l=oolA]@05omeagG400_l4L@03omkN00;N00?og]h00mh2o`AK
00>1Fe/0:E/00h5KF`0DF`Z13U/00h5KF`0XF`40000VF`05oe]KFh408E/00h5KF`0@F`0:okFf]KJe
][Ffo`Bf00Ko]kJg]_l>g00ZoncLk=c/g>cLk=c/g>cLk=c/g?o<ofKoo;Gl]Obeo;Gl]Obeo;Gl]Obe
0_l4g@;o0g401ooOLMmaomh00ol7F`03PE]K02QK00>1Fe/02e/9PAQK00>1Fe/0:5/100009U/01?mK
Fh4RF`03PE]K015K01?oo;Kl]_bfo?ng][NfokNf]kKo00kL00?og=`03m`01_l=3Om=oaBe0_l01Mea
gG7o00=a00?og]h00ol:F`03PE]K02QK00B1Fe]K2X4QF`03PE]K02QK0@0002IK00CoFe^18U/00h5K
F`0AF`0:okJe][Ff]KJeo`Bf00Ko][Nf]ol=g00BoncLk=c/g>cLk=c/g>cLk=co0l`06_mVoobeo;Gl
]Obeo;Gl]Obeo;Gl]Obeo;Go0]d8o`eK00>1Fe/08U/:PB]K00>1Fe/0:5/100009U/01?mKFh4RF`03
PE]K019K01?o]_bfo;Kl]_nf]kJgokJg][Oo00gL00?og=`03M`00ol=3@023@04ode=oaJe0_lEF`03
PE]K01UK2H46F`03PE]K02aK00>1Fe/0:5/100009U/2o`03Fh5K025K00>1Fe/04e/02Onf]KJe][Ff
o`04]P06okNf]kKo2m`04OoLk=c/g>cLk=c/g>cLk=co00G<01_oITgo]Obeo;Gl]Obeo;Gl]Obeo;Gl
]Obeo?l05U/00h5KF`0?F`Z13e/00h5KF`0/F`03PE]K02QK0@0002IK00CoFe^18U/00h5KF`0CF`0C
oobfo;Kl]_co]kJg]_ng][Nfo`0;g003omcL00cL00?o3@d010d01?m=COlF]@03oe]K01AK00>1Fe/0
1U/9PAUK00>1Fe/0;5/00h5KF`0XF`40000UF`05oe]KFh408U/00h5KF`0DF`09okFf]KJe][Go00Bf
00Go][Nfo`0;g00?omc/g>cLk=c/g>cLk=c/00O<01_oITgo]Obeo;Gl]Obeo;Gl]Obeo;Gl]Obeo?l0
5E/:PB9K00>1Fe/0;5/00h5KF`0XF`40000UF`05oe]KFh408U/00h5KF`0DF`0CokKl]_bfo;Ko][Nf
]onf]kJgo`0:g003omcL00_L00?o3@d010d00om=C@02C@03okFe01>e00?oFe/02U/9P@03Fh5K02UK
00>1Fe/0;5/00h5KF`0XF`40000UF`05oe]KFh408U/00h5KF`0EF`09okJe][Ff]KKo00Bf00Go]kJg
o`0:g00>omc/g>cLk=c/g>cLk?l7c00LodeVCFKoo;Gl]Obeo;Gl]Obeo;Gl]Obeo;Glo`9K2X4:F`03
PE]K02QK00>1Fe/0;5/00h5KF`0XF`40000UF`05oe]KFh408E/00h5KF`0GF`0BokKl]_bfo?ng][Nf
okNf]kKo2M`00ooLg009g003o`d=00H=00?oCDd00Td00one]@0C]@03oh6101AK00>1Fe/0:5/00h5K
F`0/F`03PE]K02QK0@0002EK00GoFe]KP@0QF`03PE]K01MK00Wo]KJe][Ff]Ol01;H01Onf]kKo00SL
00gok=c/g>cLk=c/g>co00W<01coCFI=I_ol]Obeo;Gl]Obeo;Gl]Obeo;Gl]Oco5U/00h5KF`0XF`03
PE]K02aK00>1Fe/0:5/100009E/01OmKFe^1025K00>1Fe/065/04_ol]_bfo;Ko][Nf]onf]kJgo`OL
00?og=`02=`00ol=3@083@03ode=00==00?o]KD04[D00omKF`0DF`03PE]K02QK00>1Fe/0;E/00h5K
F`0WF`40000UF`05oe]KFh408E/00h5KF`0IF`08okFf]KJe]_l4]P05okNf]ol01m`02oo/g>cLk=c/
g>co00_<01coCFI=ITgo]Obeo;Gl]Obeo;Gl]Obeo;Gl]Oco5U/00h5KF`0XF`03PE]K02eK00>1Fe/0
9e/100009E/2o`9K00>1Fe/07e/00h5KF`0IF`0AokKl]_bfo?ng][NfokNf]ol01m`00ooLg007g0`=
00?oCDd00dd00one]@0B]@03oe]K01AK00>1Fe/0:5/00h5KF`0]F`03PE]K02MK0@0002EK00GoFe]K
P@0QF`03PE]K01YK00So][Ff]KJeo`Bf00Go][Nfo`06g009oncLk=c/g>cL00c<01coITeVCFI=okGl
]Obeo;Gl]Obeo;Gl]Obeo;Go5e/00h5KF`0XF`03PE]K02eK00>1Fe/09e/100009E/01OmKFe^1025K
00>1Fe/06U/04H7o]_bfo;Ko][Nf]onf]kKo00KL00?og=`01M`=3@03ode=00E=00?o]KD04;D00omK
F`0EF`03PE]K02QK00>1Fe/0;E/00h5KF`0WF`40000UF`05oe]KFh408E/00h5KF`0JF`09POne][Ff
]KKo00Bf00Go]kJgo`04g009omc/g>cLk=co00g<01coITeVCFI=I_ol]Obeo;Gl]Obeo;Gl]Obeo;Go
5e/00h5KF`0XF`03PE]K02eK00>1Fe/09e/100009E/01?mKFh4RF`03PE]K01YK01:1Fool]_bfo?ng
][NfokNf]ol4g003omcL00CL00?o3@d030d00om=C@05C@03okFe012e00?oFe/05E/00h5KF`0YF`03
PE]K02aK00>1Fe/09e/100009E/01?mKFh4RF`03PE]K01YK00Z1Fe_o]KJe][Go0kH01_ng][Nfo`?L
00Oog>cLk=co00o<01coITeVCFI=I_ol]Obeo;Gl]Obeo;Gl]Obeo;Go5e/00h5KF`0YF`03PE]K02aK
00>1Fe/09e/100009E/01?mKFh4RF`03PE]K01YK01>1Fe_o]_bfo;Ko][Nf]onf]kKo00?L00?og=`0
0]`00ol=3@0>3@03ode=00I=00?o]KD03kD00omKF`0EF`03PE]K02UK00>1Fe/0;5/00h5KF`0WF`40
000UF`04oe]KPB9K00>1Fe/06U/02h5KFe_o][Ff]KKo00>f00Ko][Nf]ol2g005omc/g>`04L`07?mV
CFI=ITeVCOneo;Gl]Obeo;Gl]Obeo;Gl]OlGF`03PE]K02UK00>1Fe/0;5/00h5KF`0WF`40000TF`05
oe]KFh408U/00h5KF`0JF`0DPE]KFool]_bfo?ng][NfokNf]ol2g004omcLg14=00?oCDd01dd00one
]@0?]@03oe]K01EK00>1Fe/0:E/00h5KF`0/F`03PE]K02MK0@0000aK1_l2F`Co0U/4o`IK00GoFe]K
P@0RF`03PE]K01YK00>1Fe/00U/01one][Ff]Ol00kH01Ong][Oo00;L00?og>`04/`07Om=ITeVCFI=
ITgo]Obeo;Gl]Obeo;Gl]Obeo;Go01MK00>1Fe/0:E/00h5KF`0/F`03PE]K02MK0@0000aK00?oFe/0
15/00omKF`02F`;o15/00omKF`03F`>100=KPE/08E/00h5KF`0JF`03PE]K00=K00koo;Kl]_nf]kJg
okJg]P;o0]`C3@03ode=00Q=00?o]KD03[D00omKF`0EF`03PE]K02UK00>1Fe/0;5/00h5KF`0WF`40
000=F`03oe]K00=K00?oFe/00U/2o`AK00?oFe/00e/00omKF`05PAmK00>1Fe/06U/00h5KF`03F`07
okJe][Ffo`03]P04okJg]P;o00?/c<`04/`07Om=ITeVCFI=ITeVoobeo;Gl]Obeo;Gl]Obeo;Go01MK
00>1Fe/0:E/00h5KF`0/F`03PE]K02MK0@0000iK0_l3F`03oe]K009K0_l4F`03oe]K00=K00GoFe]K
P@03F`F16U/00h5KF`0JF`03PE]K00AK00So]_bfo?ng]POo5@d00om=C@08C@03okFe00je00?oFe/0
5E/00h5KF`0YF`03PE]K02aK00>1Fe/09e/1000045/01?mKFol4F`;o15/00omKF`03F`05oe]KFh40
25/5PAEK00>1Fe/06U/00h5KF`05F`Oo1H`4oa?<01goCFI=ITeVCFI=I_ol]Obeo;Gl]Obeo;Gl]Obe
o`0GF`03PE]K02UK00>1Fe/0;5/00h5KF`0WF`40000AF`03oe_o00AK0_l4F`03oe]K00=K00GoFe]K
P@0=F`F145/00h5KF`0JF`03PE]K00QK00?oS8`00X`00on<S005S0Co3`d00om=C@09C@03okFe00fe
00?oFe/05E/00h5KF`0YF`03PE]K02aK00>1Fe/09e/1000035/00omKF`02F`03oe_o00AK0_l4F`03
oe]K00=K00GoFe]KP@0BF`F12e/00h5KF`0JF`03PE]K00eK00CoS8b<0ol5S0Go2L`07_mVCFI=ITeV
CFI=ITgo]Obeo;Gl]Obeo;Gl]ObeoaMK00>1Fe/0:E/00h5KF`0/F`03PE]K02MK0@0000aK00?oFe/0
0U/00omKo`04F`;o15/00omKF`03F`05oe]KFh405e/5P@EK00>1Fe/06e/00h5KF`0AF`;o0X`5o`B<
1?l53@03ode=00Y=00?o]KD03KD00omKF`0EF`03PE]K02UK00>1Fe/0;5/00h5KF`0WF`40000=F`Co
0e/4o`9K1?l6F`05oe]KFh4075/6PAeK00>1Fe/05E/3o`:<1?l4S0Co01o<ofI=ITeVCFI=ITeVCOne
o;Gl]Obeo;Gl]Obeo;Go01MK00>1Fe/0:E/00h5KF`0/F`03PE]K02MK0@0002AK00GoFe]KP@0QF`F1
6E/00h5KF`0GF`03PE]K00?o00><ool00_l4S0;o3Dd00one]@0<]@03oe]K01EK00>1Fe/0:E/00h5K
F`0]F`03PE]K02IK0@0002AK00GoFe]KP@0QF`03PE]K009K1H4DF`03PE]K01MK00>1Fe/015/7o`92
01i=ITeVCFI=ITeVCFI=I_ol]Obeo;Gl]Obeo;Gl]OlGF`03PE]K02UK00>1Fe/0;E/00h5KF`0VF`40
000TF`;o0U/00h5KF`0OF`03PE]K00MK1H4?F`03PE]K01MK00>1Fe/01E/02Dm2Cd9?@Tm2C`0=C@03
okFe00^e00?oFe/05U/00h5KF`0YF`03PE]K02eK00>1Fe/09U/1000095/01?mKFh4RF`03PE]K00aK
1H4:F`03PE]K01MK00>1Fe/01U/8@P0LITeVCFI=ITeVCFI=I_ol]Obeo;Gl]Obeo;GloaQK00>1Fe/0
:E/00h5KF`0]F`03PE]K02IK0@0002AK00CoFe^18U/00h5KF`0AF`F11E/00h5KF`0GF`03PE]K00IK
00U2Cd9?@Tm2Cd803Dd00one]@0:]@03oe]K01IK00>1Fe/0:E/00h5KF`0]F`03PE]K02IK0@0002=K
00GoFe]KP@0RF`03PE]K01IK1X4IF`03PE]K00MK24806deVCFI=ITeVCFI=ITgo]Obeo;Gl]Obeo;Gl
o`0HF`03PE]K02UK00>1Fe/0;E/00h5KF`0CF`V12U/100008e/01OmKFe^1029K00>1Fe/06e/5PAEK
00>1Fe/01e/02Dm2Cd9?@Tm2o`0<C@03okFe00Ze00?oFe/05U/00h5KF`0YF`03PE]K02eK00>1Fe/0
15/?PA=K0@0002=K00GoFe]KP@0RF`03PE]K01]K00>1Fe/00U/5PA1K00>1Fe/01e/00om2@P06@P0J
ITeVCFI=ITeVCFI=okGl]Obeo;Gl]Obeo?lHF`03PE]K02UK00>1Fe/09E/?PB9K0@0002=K00GoFe]K
P@0RF`03PE]K01]K00>1Fe/01e/5P@]K00>1Fe/025/02Om?@TooCd9?o`0<C@03okFe00Ve00?oFe/0
5U/00h5KF`0YF`03PE]K01IK3h48F`03PE]K02IK0@0002=K00GoFe]KP@0RF`03PE]K01]K00>1Fe/0
35/5P@IK00>1Fe/025/01Om2@T;o00A201WoITeVCFI=ITeVCFKoo;Gl]Obeo;Gl]Oco01QK00>1Fe/0
:E/00h5KF`07F`n15e/00h5KF`0VF`40000SF`05oe]KFh408U/00h5KF`0KF`03PE]K015K1H400e^1
F`0:F`09od9?@_m2Cd;o00]=00?o]KD02KD00omKF`0FF`03PE]K02AK3h4VF`03PE]K02IK0@0002=K
00GoFe]KP@0RF`03PE]K01YK00>1Fe/05e/5P@QK00Go@T92o`04@P0HodeVCFI=ITeVCFKoo;Gl]Obe
o;Gl]Oco65/00h5KF`0EF`n11E/00h5KF`0]F`03PE]K02IK0@0002=K0_l2F`03PE]K021K00>1Fe/0
6U/00h5KF`0HF`04PE]KF`F115/02Om?@TooCd9?o`0;C@03okFe00Re00?oFe/05U/00h5KF`06F`n1
55/00h5KF`0]F`03PE]K02IK0@0002=K00GoFe]KP@0RF`03PE]K01YK00>1Fe/065/00h5KF`06F`B1
00Go@T92o`04@P0GofI=ITeVCFI=ITgo]Obeo;Gl]Obeo?l04U/?PB=K00>1Fe/0;E/00h5KF`0VF`40
000SF`05oe]KFh408U/00h5KF`0JF`03PE]K01QK00>1Fe/02U/02_m?@Tm2od9?@_l:C@03okFe00Re
00CoFe]K3h46F`03PE]K02UK00>1Fe/0;E/00h5KF`0VF`40000SF`05oe]KFh408U/00h5KF`0JF`03
PE]K01QK00>1Fe/02e/01Om2@T;o00A201KoCFI=ITeVCFI=okGl]Obeo;Gl]Oco0h4EF`03PE]K02UK
00>1Fe/0;E/00h5KF`0VF`40000SF`05oe]KFh408U/00h5KF`0JF`03PE]K01QK00>1Fe/02e/02_m2
Cd9?odm2Col:C@03okFe00Ne00?oFe/05U/00h5KF`0YF`03PE]K02eK00>1Fe/09U/100008e/01OmK
Fe^1029K00>1Fe/06U/00h5KF`0HF`03PE]K00aK00Go@T92o`03@P0FodeVCFI=ITeVCFKoo;Gl]Obe
o;GloaQK00>1Fe/0:E/00h5KF`0]F`03PE]K02IK0@0002=K00GoFe]KP@0QF`03PE]K01]K00>1Fe/0
65/00h5KF`0<F`0:odm2Cd;o@Tm2o`U=00?o]KD01kD00omKF`0FF`03PE]K02UK00>1Fe/0;E/00h5K
F`0VF`40000SF`04oe]KPB9K00>1Fe/06e/00h5KF`0HF`03PE]K00eK00Go@T92o`03@P0EofI=ITeV
CFI=I_ol]Obeo;Gl]Oco01QK00>1Fe/0:E/00h5KF`0]F`03PE]K02IK0@00029K00GoFe]KP@0RF`03
PE]K01]K00>1Fe/065/00h5KF`0=F`0:od9?@_m2Cd9?o`U=00?o]KD01[D00omKF`0FF`03PE]K02UK
00>1Fe/0;U/00h5KF`0UF`40000RF`05oe]KFh408U/00h5KF`0KF`03PE]K01QK00>1Fe/03U/01Om2
@T;o00=201?oCFI=ITeVCFI=okGl]Obeo;Go01UK00>1Fe/0:E/00h5KF`0^F`03PE]K02EK0@00029K
0ol00e^1F`0QF`03PE]K01]K00>1Fe/065/00h5KF`0>F`0:odm2Com?@Tm2o`Q=00?o]KD01KD00omK
F`0GF`03PE]K02UK00>1Fe/0;U/00h5KF`0UF`40000RF`05oe]KFh408U/00h5KF`0KF`03PE]K01QK
00>1Fe/03U/00om2@P02@P0Fod92@_mVCFI=ITeVCOneo;Gl]ObeoaUK00>1Fe/0:E/00h5KF`0^F`03
PE]K02EK0@00029K00GoFe]KP@0RF`03PE]K01]K00>1Fe/065/00h5KF`0?F`0:od9?@_m2Cd9?o`Q=
00?o]KD01;D00omKF`0GF`03PE]K02UK00>1Fe/0;U/00h5KF`0UF`40000RF`05oe]KFh408U/00h5K
F`0KF`03PE]K01QK00>1Fe/03e/00om2@P02@P0Eod92@_m=ITeVCFI=I_ol]Obeo;Go01UK00>1Fe/0
:E/00h5KF`0^F`03PE]K02EK0@00029K00GoFe]KP@0RF`03PE]K01]K00>1Fe/065/00h5KF`0@F`09
odm2Com?@Too00Q=00?o]KD01;D00omKF`0GF`03PE]K02UK00>1Fe/0;U/00h5KF`0UF`40000RF`05
oe]KFh408U/00h5KF`0KF`03PE]K01QK00>1Fe/045/00om2@P02@P0Dod92@_mVCFI=ITeVoobeo;Gl
]OlIF`03PE]K02UK00>1Fe/0;U/00h5KF`0UF`40000RF`05oe]KFh408U/00h5KF`0KF`03PE]K01QK
00>1Fe/04E/02Om2Cd;o@Tm2o`08C@03okFe00>e00?oFe/05e/00h5KF`0YF`03PE]K02iK00>1Fe/0
9E/100008U/01OmKFe^1029K00>1Fe/06e/00h5KF`0HF`03PE]K015K00?o@T800T804om2@T;oCFI=
ITeVCOneo;Gl]Ol06E/00h5KF`0YF`03PE]K02iK00>1Fe/09E/100008U/01OmKFe^1029K00>1Fe/0
6e/00h5KF`0GF`03PE]K019K00[o@Tm2Com?@Too1dd00one]@03]@03oe]K01MK00>1Fe/0:U/00h5K
F`0]F`03PE]K02EK0@00029K00GoFe]KP@0RF`03PE]K01]K00>1Fe/05e/00h5KF`0CF`03od920092
01;o@T92ofI=ITeVCOneo;Gl]OlIF`03PE]K02YK00>1Fe/0;E/00h5KF`0UF`40000RF`;o0U/00h5K
F`0PF`03PE]K01]K00>1Fe/05e/00h5KF`0CF`0:odm2Cd;o@Tm2o`M=00?o]KD00[D00omKF`0GF`03
PE]K02YK00>1Fe/0;E/00h5KF`0UF`40000RF`05oe]KFh408U/00h5KF`0KF`03PE]K01MK00>1Fe/0
55/01Om2@T;o00A200goCFI=ITeVoobeo;Go01UK00>1Fe/0:U/00h5KF`0]F`03PE]K02EK0@00029K
00GoFe]KP@0RF`03PE]K01]K00>1Fe/05e/00h5KF`0DF`0:od9?@TooCd9?o`I=00?o]KD00[D00omK
F`0GF`03PE]K02YK00>1Fe/0;E/00h5KF`0UF`40000QF`05oe]KFh408e/00h5KF`0KF`03PE]K01MK
00>1Fe/055/00h7o@P02@P0Aod92@_m=ITeVCFKoo;Gl]Ol06E/00h5KF`0ZF`03PE]K02eK00>1Fe/0
9E/100008E/01OmKFe^102=K00>1Fe/06e/00h5KF`0GF`03PE]K01AK00^1odm2Cd;o@Tm2o`06C@05
okFe]Ol06E/00h5KF`0ZF`03PE]K02eK00>1Fe/09E/100008E/01OmKFe^1029K00>1Fe/06e/00h5K
F`0HF`03PE]K01AK00>1Fol00d804?m2@T;oITeVCFI=okGl]OlIF`03PE]K02YK00>1Fe/0;E/00h5K
F`0UF`40000QF`05oe]KFh408U/00h5KF`0KF`03PE]K01QK00>1Fe/055/0385Kod9?@TooCd9?o`E=
00Go]KFeo`0IF`03PE]K02YK00>1Fe/0;E/00h5KF`0UF`40000QF`05oe]KFh408U/00h5KF`0KF`03
PE]K01QK00>1Fe/055/00h5Ko`04@P0?od92@_m=ITeVCOneo;Go01UK00>1Fe/0:U/00h5KF`0]F`03
PE]K02EK0@00025K00GoFe]KP@0RF`03PE]K01]K00>1Fe/065/00h5KF`0DF`0=PE]Kodm2Cd;o@Tm2
o`05C@03okGo01YK00>1Fe/0:U/00h5KF`0^F`03PE]K02AK0@00025K00GoFe]KP@0RF`03PE]K01]K
00>1Fe/065/00h5KF`0DF`04PE]Ko`A200go@T92ofI=ITeVooco01YK00>1Fe/0:U/00h5KF`0^F`03
PE]K02AK0@00025K1X4QF`03PE]K01]K00>1Fe/065/00h5KF`0DF`0>PE]KFom2Cd9?odm2Col4C@03
okGo01YK00>1Fe/0:U/00h5KF`0^F`03PE]K02AK0@0002MK2X4GF`03PE]K01]K00>1Fe/065/00h5K
F`0DF`05PE]KFol014803?m2@T;oCFI=I_oloaYK00>1Fe/0:U/00h5KF`0^F`03PE]K02AK0@00035K
2X4=F`03PE]K01]K00>1Fe/065/00h5KF`0DF`03PE]K009K00[oCd9?odm2Cd;o14d2oaYK00>1Fe/0
:U/00h5KF`0^F`03PE]K02AK0@0003]K2X43F`03PE]K01]K00>1Fe/065/00h5KF`0DF`03PE]K009K
00?o@T800T802Om2@T;oITeVC@02oaYK00>1Fe/0:U/00h5KF`0^F`03PE]K02AK0@0004EK2X4GF`03
PE]K01QK00>1Fe/055/00h5KF`02F`0:odm2Cd;o@Tm2o`A=0_lJF`03PE]K02YK00>1Fe/0;U/00h5K
F`0TF`40001?F`Z13E/00h5KF`0HF`03PE]K01AK00>1Fe/00e/00om2@P02@P08od92@_m=ITd2oaYK
00>1Fe/0:U/00h5KF`0^F`03PE]K02AK0@0005UK2h42F`03PE]K01QK00>1Fe/055/00h5KF`03F`0:
od9?@TooCd9?o`A=00?oFe/065/00h5KF`0ZF`03PE]K02iK00>1Fe/095/10000I5/:PA=K00>1Fe/0
55/00h5KF`03F`03POoo00co6U/00h5KF`0ZF`03PE]K02iK00>1Fe/02U/BP@QK0@0006iK2X49F`03
PE]K01AK00>1Fe/00e/00h5KF`0VF`03PE]K02YK00>1Fe/06E/RPAYK0@0007QK2X4FF`03PE]K00=K
00>1Fe/09U/00h5KF`0TFb:1?5/10000PU/:P@aK00>1Fe/00e/00h5KF`0VF`03PE]K00=K8H5NF`40
002<F`Z10U/00h5KF`03F`03PE]K00YK8X5oF`40002FFaF1XE/10000oe]=F`40003oFdeK0@000?mK
CE/10000oe]=F`40003oFdeK0@000?mKCE/10000oe]=F`40003oFdeK0@000?mKCE/10000oe]=F`40
003oFdeK0@000=YK0_m`F`40003KF`;o0e/00omKF`1YF`40003LF`;o0e/00omKF`1XF`40001DF`Go
0e/3o`9K0_l4F`?o00=Kool00_l3F`Go1E/2o`EK0_l2F`Go0U/2o`9K1?l3F`Co0e/4o`9K1?l3F`Co
1U/2o`=K0_l00e_oo`02F`Co0e/3o`9K0ol2F`;o1E/3o`9K0_l7F`Co00=Koe/01?l2F`;o0U/2o`9K
0_l5F`Co0e/4ocaK0@0005=K0_l3F`;o00AKoomK0_l00e_oo`04F`;o00=Kool00U/2o`03Fooo009K
0_l5F`;o1E/2o`9K0_l00e_oo`02F`;o00=Kool00U/2o`03Fooo009K0_l00e_oo`02F`Co0U/2o`03
Fooo009K0_l5F`;o0e/2o`04FoooF`;o0U/2o`9K0_l2F`;o00AKoomK0_l5F`?o0U/2o`IK0_l2F`Go
0U/2o`03Fooo009K0_l2F`;o15/2o`9K0_l00e_oo`02F`;o>e/10000De/2o`=K1?l3F`Co15/2o`03
Fooo00EK0_l2F`;o1E/2o`EK0_l2F`;o00=Kool00U/2o`03Fooo00QK0ol4F`Go25/3o`EK0_l3F`;o
00=Kool015/3o`9K0_l00e_oo`03F`Co15/2o`03Fooo00QK0_l4F`Co1E/2o`9K0_l8F`;o0U/2o`03
Fooo009K0_lkF`40001GF`Go0e/4o`AK0_l00e_oo`04o`03Fooo009K0_l5F`;o1E/2o`9K0_l00e_o
o`02F`;o00=Kool01?l2F`Co0e/4o`03Fooo00Co0U/4o`IK0_l3F`;o00=Kool00U/4o`=K0_l00e_o
o`03F`Co15/2o`03Fooo00QK0_l4F`So00=Kool00U/2o`QK0_l2F`;o00=Kool00U/2oc]K0@0005AK
1Ol00e_oo`03F`Co15/2o`03Fooo009K0_l00e_oo`02F`;o1E/5o`9K0_l2F`;o00=Kool00U/2o`03
Fooo009K0_l015_oool4F`?o0e/2o`9K0_l015_oool8F`;o0e/2o`04FoooF`?o1E/2o`03Fooo00=K
1?l4F`;o00=Kool025/2o`9K1_l2F`;o00=Kool00U/2o`UK1?l2F`;o0U/2oc]K0@0005=K0ol5F`;o
00AKoomK0ol3F`;o00=Kool00U/2o`03Fooo009K0_l5F`;o1E/2o`9K0_l00e_oo`02F`;o00=Kool0
0U/2o`03Fooo009K0_l00e_oo`02F`Co0U/2o`03Fooo009K0_l5F`Oo00AKoomK0_l2F`;o0U/2o`9K
0_l015_ooe/3o`=K0_l00e_oo`08F`;o1U/2o`9K0_l00e_oo`02F`;o25/2o`9K0_l00e_oo`02F`;o
>e/10000De/2o`=K0_l2F`?o0U/3o`9K1?l00e_oo`02o`=K1Ol5F`;o1E/2o`03Fooo00Oo0e/4o`=K
1?l3F`Co0U/4o`=K1?l6F`;o0e/2o`03Fooo009K1?l2F`Co0U/3o`9K0ol2F`;o0e/2o`MK0_l4F`;o
00=Kool00_l2F`Go2E/2o`9K0_l00e_oo`02F`;o>e/10000De/2o`=K0_l=F`;o35/2o`EK0_l9F`;o
;U/2o`=K0_l<F`;o75/2o`9K0_lFF`;o0U/2o`03Fooo009K0_lkF`40001DF`Go3U/2o`aK0_l5F`Ko
00=Kool00U/2obiK0_l3F`;o00=Kool02E/2oaeK1?lHF`Co0e/4ocaK0@000?mKCE/10000oe]=F`40
003oFdeK0@000?mKCE/10000\
\>"],
  ImageRangeCache->{{{0, 332}, {316, 0}} -> {-0.0772134, -0.0389858, 
  0.00305339, 0.00305339}}],

Cell[TextData[
"visualizeExpressions::fitnessesInfo: \n   Fitnesses: {288, 0, 48, 54, 288, \
74, 48, 34, 54, 56, <<20>>, 62, 70, 82, \n     74, 0}"], "Message",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[
"visualizeExpressions::fitnessMax: Max. Fitness: 288"], "Message",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.0238095 0.952381 0.0147151 0.588604 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
% Start of sub-graphic
p
0.0238095 0.0147151 0.97619 0.603319 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.136054 0.0169173 0.136054 [
p
/Times findfont 14 scalefont setfont
[(Gen. 80)] .5 .71053 0 -2 Msboxa
P
[ 0 0 0 0 ]
[ 1 .71053 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
p
/Times findfont 14 scalefont setfont
[(Gen. 80)] .5 .71053 0 -2 Mshowa
P
P
0 0 m
1 0 L
1 .71053 L
0 .71053 L
closepath
clip
newpath
p
p
% Start of sub-graphic
p
0.0238095 0.0169173 0.149123 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.758303 2.5909 0.0163524 0.959656 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.65693 .26414 m
.65922 .32981 L
s
P
p
0 .4 1 r
.02 w
.5475 .21345 m
.65693 .26414 L
s
P
p
0 .4 1 r
.02 w
.65922 .32981 m
.5477 .27966 L
s
P
p
0 .4 1 r
.02 w
.5477 .27966 m
.5475 .21345 L
s
P
p
.2 1 0 r
.02 w
.86547 .63433 m
.75767 .59089 L
s
P
p
.2 1 0 r
.02 w
.87194 .70928 m
.86547 .63433 L
s
P
p
.2 1 0 r
.02 w
.75339 .51794 m
.64249 .47155 L
s
P
p
.2 1 0 r
.02 w
.75767 .59089 m
.75339 .51794 L
s
P
p
0 .4 1 r
.02 w
.5477 .27966 m
.43082 .22711 L
s
P
p
.2 1 0 r
.02 w
.76212 .66678 m
.87194 .70928 L
s
P
p
.2 1 0 r
.02 w
.64249 .47155 m
.64463 .54533 L
s
P
p
0 .4 1 r
.02 w
.66408 .46898 m
.66666 .5428 L
s
P
p
0 .4 1 r
.02 w
.54813 .4202 m
.66408 .46898 L
s
P
p
.2 1 0 r
.02 w
.52639 .35127 m
.40675 .29947 L
s
P
p
.2 1 0 r
.02 w
.52617 .4229 m
.52639 .35127 L
s
P
p
0 .4 1 r
.02 w
.54792 .34853 m
.42864 .29659 L
s
P
p
0 .4 1 r
.02 w
.54813 .4202 m
.54792 .34853 L
s
P
p
0 .4 1 r
.02 w
.43082 .22711 m
.42864 .29659 L
s
P
p
0 .4 1 r
.02 w
.31278 .10471 m
.30817 .17196 L
s
P
p
0 .4 1 r
.02 w
.1867 .04631 m
.31278 .10471 L
s
P
p
.2 1 0 r
.02 w
.64685 .62217 m
.76212 .66678 L
s
P
p
.2 1 0 r
.02 w
.64463 .54533 m
.52594 .49751 L
s
P
p
0 .4 1 r
.02 w
.66666 .5428 m
.54836 .49485 L
s
P
p
.2 1 0 r
.02 w
.52594 .49751 m
.52617 .4229 L
s
P
p
0 .4 1 r
.02 w
.54836 .49485 m
.54813 .4202 L
s
P
p
.2 1 0 r
.02 w
.40675 .29947 m
.40403 .37181 L
s
P
p
0 .4 1 r
.02 w
.42864 .29659 m
.42637 .36897 L
s
P
p
0 .4 1 r
.02 w
.30336 .24203 m
.42864 .29659 L
s
P
p
0 .4 1 r
.02 w
.30817 .17196 m
.30336 .24203 L
s
P
p
0 .4 1 r
.02 w
.30817 .17196 m
.17931 .11402 L
s
P
p
.2 1 0 r
.02 w
.76676 .7458 m
.64917 .70225 L
s
P
p
.2 1 0 r
.02 w
.77159 .82814 m
.76676 .7458 L
s
P
p
0 .4 1 r
.02 w
.17931 .11402 m
.1867 .04631 L
s
P
p
.2 1 0 r
.02 w
.64917 .70225 m
.64685 .62217 L
s
P
p
.2 1 0 r
.02 w
.40403 .37181 m
.27561 .31809 L
s
P
p
0 .4 1 r
.02 w
.42637 .36897 m
.29835 .31511 L
s
P
p
.2 1 0 r
.02 w
.65159 .78579 m
.77159 .82814 L
s
P
p
.2 1 0 r
.02 w
.40119 .44724 m
.39823 .52595 L
s
P
p
.2 1 0 r
.02 w
.26989 .39433 m
.40119 .44724 L
s
P
p
.01 w
.27561 .31809 Mdot
P
p
.2 1 0 r
.02 w
.27561 .31809 m
.26989 .39433 L
s
P
p
.01 w
.29835 .31511 Mdot
P
p
0 .4 1 r
.02 w
.16357 .2584 m
.29835 .31511 L
s
P
p
0 .4 1 r
.02 w
.29835 .31511 m
.29312 .39138 L
s
P
p
.2 1 0 r
.02 w
.65411 .87301 m
.65159 .78579 L
s
P
p
.2 1 0 r
.02 w
.52546 .65643 m
.5252 .74118 L
s
P
p
.2 1 0 r
.02 w
.39514 .60817 m
.52546 .65643 L
s
P
p
.2 1 0 r
.02 w
.39823 .52595 m
.26391 .47397 L
s
P
p
0 .4 1 r
.02 w
.29312 .39138 m
.15517 .33546 L
s
P
p
0 .4 1 r
.02 w
.15517 .33546 m
.16357 .2584 L
s
P
p
.2 1 0 r
.02 w
.52493 .82976 m
.65411 .87301 L
s
P
p
.2 1 0 r
.02 w
.5252 .74118 m
.52493 .82976 L
s
P
p
.2 1 0 r
.02 w
.3919 .69413 m
.39514 .60817 L
s
P
p
.2 1 0 r
.02 w
.26391 .47397 m
.12219 .41912 L
s
P
p
.2 1 0 r
.02 w
.25112 .64444 m
.3919 .69413 L
s
P
p
.2 1 0 r
.02 w
.25766 .55725 m
.25112 .64444 L
s
P
p
.2 1 0 r
.02 w
.11243 .50347 m
.25766 .55725 L
s
P
p
.2 1 0 r
.02 w
.12219 .41912 m
.11243 .50347 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.0169173 0.286967 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.7867 .53145 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.89777 .66825 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56304 .80672 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.15169 .31032 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.139 .40899 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.0169173 0.424812 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.17486 .13016 L
s
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
0 .4 1 r
.02 w
.16362 .21754 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.17486 .13016 m
.16362 .21754 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.0169173 0.562657 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.67773 .47655 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.68474 .65693 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.15169 .31032 L
s
P
p
0 .4 1 r
.02 w
.42373 .75116 m
.56304 .80672 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.42373 .75116 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.139 .40899 L
s
P
p
0 .4 1 r
.02 w
.12548 .51415 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.12548 .51415 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.0169173 0.700501 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.559341 2.21998 0.0242236 0.968945 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.86902 .56205 m
.78139 .51778 L
s
P
p
.2 1 0 r
.02 w
.87582 .63372 m
.86902 .56205 L
s
P
p
.2 1 0 r
.02 w
.77654 .44823 m
.68613 .40083 L
s
P
p
.2 1 0 r
.02 w
.78139 .51778 m
.77654 .44823 L
s
P
p
.2 1 0 r
.02 w
.78644 .59037 m
.87582 .63372 L
s
P
p
0 .4 1 r
.02 w
.89392 .63143 m
.80489 .58796 L
s
P
p
0 .4 1 r
.02 w
.90142 .70629 m
.89392 .63143 L
s
P
p
0 .4 1 r
.02 w
.79942 .51531 m
.7075 .46857 L
s
P
p
0 .4 1 r
.02 w
.80489 .58796 m
.79942 .51531 L
s
P
p
.2 1 0 r
.02 w
.68613 .40083 m
.68912 .47117 L
s
P
p
.2 1 0 r
.02 w
.59006 .28288 m
.49187 .22959 L
s
P
p
.2 1 0 r
.02 w
.59093 .35091 m
.59006 .28288 L
s
P
p
0 .4 1 r
.02 w
.60798 .28006 m
.51013 .22662 L
s
P
p
0 .4 1 r
.02 w
.60925 .34813 m
.60798 .28006 L
s
P
p
0 .4 1 r
.02 w
.81059 .66386 m
.90142 .70629 L
s
P
p
.2 1 0 r
.02 w
.69223 .54467 m
.78644 .59037 L
s
P
p
.2 1 0 r
.02 w
.68912 .47117 m
.59184 .42203 L
s
P
p
0 .4 1 r
.02 w
.7075 .46857 m
.61058 .41929 L
s
P
p
.2 1 0 r
.02 w
.59184 .42203 m
.59093 .35091 L
s
P
p
0 .4 1 r
.02 w
.61058 .41929 m
.60925 .34813 L
s
P
p
.2 1 0 r
.02 w
.49187 .22959 m
.49053 .29827 L
s
P
p
0 .4 1 r
.02 w
.51013 .22662 m
.50921 .29534 L
s
P
p
.2 1 0 r
.02 w
.79173 .66622 m
.6955 .62156 L
s
P
p
.2 1 0 r
.02 w
.79726 .74554 m
.79173 .66622 L
s
P
p
0 .4 1 r
.02 w
.71474 .61907 m
.81059 .66386 L
s
P
p
.2 1 0 r
.02 w
.6955 .62156 m
.69223 .54467 L
s
P
p
.2 1 0 r
.02 w
.49053 .29827 m
.38451 .24268 L
s
P
p
0 .4 1 r
.02 w
.50921 .29534 m
.40355 .23958 L
s
P
p
.2 1 0 r
.02 w
.69891 .70208 m
.79726 .74554 L
s
P
p
0 .4 1 r
.02 w
.71861 .69966 m
.71474 .61907 L
s
P
p
.2 1 0 r
.02 w
.48913 .37015 m
.48767 .44545 L
s
P
p
.2 1 0 r
.02 w
.38053 .31529 m
.48913 .37015 L
s
P
p
.01 w
.38451 .24268 Mdot
P
p
.2 1 0 r
.02 w
.38451 .24268 m
.38053 .31529 L
s
P
p
.01 w
.40355 .23958 Mdot
P
p
0 .4 1 r
.02 w
.40355 .23958 m
.40002 .31223 L
s
P
p
.2 1 0 r
.02 w
.70249 .78649 m
.69891 .70208 L
s
P
p
0 .4 1 r
.02 w
.72268 .78413 m
.71861 .69966 L
s
P
p
.2 1 0 r
.02 w
.59379 .57437 m
.59484 .65609 L
s
P
p
.2 1 0 r
.02 w
.48613 .52442 m
.59379 .57437 L
s
P
p
.2 1 0 r
.02 w
.48767 .44545 m
.37637 .39146 L
s
P
p
0 .4 1 r
.02 w
.40002 .31223 m
.39633 .38845 L
s
P
p
.2 1 0 r
.02 w
.59594 .74187 m
.70249 .78649 L
s
P
p
0 .4 1 r
.02 w
.61655 .73938 m
.72268 .78413 L
s
P
p
.2 1 0 r
.02 w
.59484 .65609 m
.59594 .74187 L
s
P
p
.2 1 0 r
.02 w
.48452 .60734 m
.48613 .52442 L
s
P
p
.2 1 0 r
.02 w
.37637 .39146 m
.25832 .3342 L
s
P
p
0 .4 1 r
.02 w
.39633 .38845 m
.27869 .331 L
s
P
p
0 .4 1 r
.02 w
.61824 .82962 m
.61655 .73938 L
s
P
p
.2 1 0 r
.02 w
.36738 .55557 m
.48452 .60734 L
s
P
p
0 .4 1 r
.02 w
.50506 .60461 m
.50389 .69186 L
s
P
p
0 .4 1 r
.02 w
.38836 .55268 m
.50506 .60461 L
s
P
p
.2 1 0 r
.02 w
.37199 .47146 m
.36738 .55557 L
s
P
p
.2 1 0 r
.02 w
.25075 .4152 m
.37199 .47146 L
s
P
p
.2 1 0 r
.02 w
.25832 .3342 m
.25075 .4152 L
s
P
p
0 .4 1 r
.02 w
.27869 .331 m
.15369 .26996 L
s
P
p
0 .4 1 r
.02 w
.50266 .7837 m
.61824 .82962 L
s
P
p
0 .4 1 r
.02 w
.50389 .69186 m
.50266 .7837 L
s
P
p
0 .4 1 r
.02 w
.2642 .49742 m
.38836 .55268 L
s
P
p
0 .4 1 r
.02 w
.27163 .41205 m
.2642 .49742 L
s
P
p
0 .4 1 r
.02 w
.14306 .35198 m
.27163 .41205 L
s
P
p
0 .4 1 r
.02 w
.15369 .26996 m
.14306 .35198 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.0169173 0.838346 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.559341 2.21998 0.0242236 0.968945 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.88673 .5597 m
.79942 .51531 L
s
P
p
0 .4 1 r
.02 w
.89392 .63143 m
.88673 .5597 L
s
P
p
0 .4 1 r
.02 w
.79419 .44573 m
.70412 .39819 L
s
P
p
0 .4 1 r
.02 w
.79942 .51531 m
.79419 .44573 L
s
P
p
0 .4 1 r
.02 w
.90142 .70629 m
.89392 .63143 L
s
P
p
.2 1 0 r
.02 w
.78139 .51778 m
.68912 .47117 L
s
P
p
.2 1 0 r
.02 w
.78644 .59037 m
.78139 .51778 L
s
P
p
.2 1 0 r
.02 w
.68613 .40083 m
.59093 .35091 L
s
P
p
.2 1 0 r
.02 w
.68912 .47117 m
.68613 .40083 L
s
P
p
0 .4 1 r
.02 w
.70412 .39819 m
.7075 .46857 L
s
P
p
0 .4 1 r
.02 w
.60798 .28006 m
.51013 .22662 L
s
P
p
0 .4 1 r
.02 w
.60925 .34813 m
.60798 .28006 L
s
P
p
0 .4 1 r
.02 w
.81059 .66386 m
.90142 .70629 L
s
P
p
.2 1 0 r
.02 w
.69223 .54467 m
.78644 .59037 L
s
P
p
0 .4 1 r
.02 w
.7075 .46857 m
.61058 .41929 L
s
P
p
.2 1 0 r
.02 w
.59093 .35091 m
.59184 .42203 L
s
P
p
0 .4 1 r
.02 w
.61058 .41929 m
.60925 .34813 L
s
P
p
.2 1 0 r
.02 w
.49187 .22959 m
.3883 .17339 L
s
P
p
.2 1 0 r
.02 w
.49053 .29827 m
.49187 .22959 L
s
P
p
0 .4 1 r
.02 w
.51013 .22662 m
.40691 .17026 L
s
P
p
0 .4 1 r
.02 w
.71474 .61907 m
.81059 .66386 L
s
P
p
.2 1 0 r
.02 w
.59279 .49644 m
.69223 .54467 L
s
P
p
.2 1 0 r
.02 w
.59184 .42203 m
.48913 .37015 L
s
P
p
.2 1 0 r
.02 w
.48913 .37015 m
.49053 .29827 L
s
P
p
.2 1 0 r
.02 w
.3883 .17339 m
.38451 .24268 L
s
P
p
0 .4 1 r
.02 w
.40691 .17026 m
.40355 .23958 L
s
P
p
0 .4 1 r
.02 w
.81656 .74325 m
.71861 .69966 L
s
P
p
0 .4 1 r
.02 w
.82281 .82637 m
.81656 .74325 L
s
P
p
.2 1 0 r
.02 w
.6955 .62156 m
.59379 .57437 L
s
P
p
.2 1 0 r
.02 w
.69891 .70208 m
.6955 .62156 L
s
P
p
0 .4 1 r
.02 w
.71861 .69966 m
.71474 .61907 L
s
P
p
.2 1 0 r
.02 w
.59379 .57437 m
.59279 .49644 L
s
P
p
.2 1 0 r
.02 w
.38451 .24268 m
.27237 .18389 L
s
P
p
0 .4 1 r
.02 w
.40355 .23958 m
.29178 .1806 L
s
P
p
0 .4 1 r
.02 w
.72268 .78413 m
.82281 .82637 L
s
P
p
.2 1 0 r
.02 w
.59484 .65609 m
.69891 .70208 L
s
P
p
.2 1 0 r
.02 w
.38053 .31529 m
.37637 .39146 L
s
P
p
.2 1 0 r
.02 w
.26551 .25719 m
.38053 .31529 L
s
P
p
0 .4 1 r
.02 w
.40002 .31223 m
.39633 .38845 L
s
P
p
0 .4 1 r
.02 w
.2854 .25395 m
.40002 .31223 L
s
P
p
.01 w
.27237 .18389 Mdot
P
p
.2 1 0 r
.02 w
.27237 .18389 m
.26551 .25719 L
s
P
p
.01 w
.29178 .1806 Mdot
P
p
0 .4 1 r
.02 w
.29178 .1806 m
.2854 .25395 L
s
P
p
0 .4 1 r
.02 w
.72694 .8728 m
.72268 .78413 L
s
P
p
.2 1 0 r
.02 w
.59594 .74187 m
.59484 .65609 L
s
P
p
.2 1 0 r
.02 w
.48613 .52442 m
.48452 .60734 L
s
P
p
.2 1 0 r
.02 w
.37199 .47146 m
.48613 .52442 L
s
P
p
.2 1 0 r
.02 w
.37637 .39146 m
.25832 .3342 L
s
P
p
0 .4 1 r
.02 w
.39633 .38845 m
.27869 .331 L
s
P
p
0 .4 1 r
.02 w
.61824 .82962 m
.72694 .8728 L
s
P
p
.2 1 0 r
.02 w
.48283 .69451 m
.59594 .74187 L
s
P
p
.2 1 0 r
.02 w
.48452 .60734 m
.48283 .69451 L
s
P
p
0 .4 1 r
.02 w
.50506 .60461 m
.50389 .69186 L
s
P
p
0 .4 1 r
.02 w
.38836 .55268 m
.50506 .60461 L
s
P
p
.2 1 0 r
.02 w
.36738 .55557 m
.37199 .47146 L
s
P
p
.2 1 0 r
.02 w
.25832 .3342 m
.13289 .27337 L
s
P
p
0 .4 1 r
.02 w
.27869 .331 m
.15369 .26996 L
s
P
p
0 .4 1 r
.02 w
.50266 .7837 m
.61824 .82962 L
s
P
p
0 .4 1 r
.02 w
.50389 .69186 m
.50266 .7837 L
s
P
p
.2 1 0 r
.02 w
.24277 .50051 m
.36738 .55557 L
s
P
p
0 .4 1 r
.02 w
.38406 .64132 m
.38836 .55268 L
s
P
p
.2 1 0 r
.02 w
.25075 .4152 m
.24277 .50051 L
s
P
p
.2 1 0 r
.02 w
.12173 .35534 m
.25075 .4152 L
s
P
p
.2 1 0 r
.02 w
.13289 .27337 m
.12173 .35534 L
s
P
p
0 .4 1 r
.02 w
.15369 .26996 m
.14306 .35198 L
s
P
p
0 .4 1 r
.02 w
.25636 .58746 m
.38406 .64132 L
s
P
p
0 .4 1 r
.02 w
.2642 .49742 m
.25636 .58746 L
s
P
p
0 .4 1 r
.02 w
.13185 .43852 m
.2642 .49742 L
s
P
p
0 .4 1 r
.02 w
.14306 .35198 m
.13185 .43852 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.0169173 0.97619 0.142231 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.494082 2.089 0.0245703 0.982813 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.88743 .49346 m
.85947 .47756 L
s
P
p
0 .4 1 r
.02 w
.88964 .51768 m
.88743 .49346 L
s
P
p
0 .4 1 r
.02 w
.89188 .54222 m
.88964 .51768 L
s
P
p
0 .4 1 r
.02 w
.85947 .47756 m
.83106 .46141 L
s
P
p
0 .4 1 r
.02 w
.82921 .43734 m
.83106 .46141 L
s
P
p
0 .4 1 r
.02 w
.80052 .42084 m
.82921 .43734 L
s
P
p
0 .4 1 r
.02 w
.86358 .5265 m
.89188 .54222 L
s
P
p
0 .4 1 r
.02 w
.83106 .46141 m
.83293 .4858 L
s
P
p
0 .4 1 r
.02 w
.83106 .46141 m
.80219 .445 L
s
P
p
0 .4 1 r
.02 w
.80052 .42084 m
.77137 .40409 L
s
P
p
0 .4 1 r
.02 w
.80219 .445 m
.80052 .42084 L
s
P
p
0 .4 1 r
.02 w
.86568 .55146 m
.86358 .5265 L
s
P
p
0 .4 1 r
.02 w
.83293 .4858 m
.80388 .46948 L
s
P
p
0 .4 1 r
.02 w
.80388 .46948 m
.80219 .445 L
s
P
p
0 .4 1 r
.02 w
.77137 .40409 m
.77286 .42832 L
s
P
p
0 .4 1 r
.02 w
.83674 .53558 m
.86568 .55146 L
s
P
p
0 .4 1 r
.02 w
.77286 .42832 m
.74305 .41138 L
s
P
p
0 .4 1 r
.02 w
.83869 .56097 m
.83674 .53558 L
s
P
p
0 .4 1 r
.02 w
.84067 .58672 m
.83869 .56097 L
s
P
p
0 .4 1 r
.02 w
.81088 .57078 m
.84067 .58672 L
s
P
p
0 .4 1 r
.02 w
.77744 .50304 m
.74705 .48636 L
s
P
p
0 .4 1 r
.02 w
.77901 .52863 m
.77744 .50304 L
s
P
p
0 .4 1 r
.02 w
.7806 .55458 m
.81088 .57078 L
s
P
p
0 .4 1 r
.02 w
.7806 .55458 m
.77901 .52863 L
s
P
p
0 .4 1 r
.02 w
.74705 .48636 m
.71615 .4694 L
s
P
p
0 .4 1 r
.02 w
.715 .44397 m
.71615 .4694 L
s
P
p
0 .4 1 r
.02 w
.68379 .42664 m
.715 .44397 L
s
P
p
0 .4 1 r
.02 w
.74981 .5381 m
.7806 .55458 L
s
P
p
0 .4 1 r
.02 w
.71615 .4694 m
.71732 .49519 L
s
P
p
0 .4 1 r
.02 w
.71615 .4694 m
.68473 .45216 L
s
P
p
0 .4 1 r
.02 w
.68379 .42664 m
.65205 .40901 L
s
P
p
0 .4 1 r
.02 w
.68473 .45216 m
.68379 .42664 L
s
P
p
0 .4 1 r
.02 w
.75122 .56452 m
.74981 .5381 L
s
P
p
0 .4 1 r
.02 w
.71732 .49519 m
.68569 .47804 L
s
P
p
0 .4 1 r
.02 w
.68569 .47804 m
.68473 .45216 L
s
P
p
0 .4 1 r
.02 w
.65205 .40901 m
.65278 .43462 L
s
P
p
0 .4 1 r
.02 w
.7197 .54787 m
.75122 .56452 L
s
P
p
0 .4 1 r
.02 w
.7185 .52134 m
.7197 .54787 L
s
P
p
0 .4 1 r
.02 w
.68665 .5043 m
.7185 .52134 L
s
P
p
0 .4 1 r
.02 w
.65278 .43462 m
.62027 .41678 L
s
P
p
0 .4 1 r
.02 w
.72092 .57478 m
.7197 .54787 L
s
P
p
0 .4 1 r
.02 w
.68763 .53093 m
.68665 .5043 L
s
P
p
0 .4 1 r
.02 w
.65351 .4606 m
.65425 .48696 L
s
P
p
0 .4 1 r
.02 w
.62077 .44286 m
.65351 .4606 L
s
P
p
0 .4 1 r
.02 w
.62027 .41678 m
.62077 .44286 L
s
P
p
0 .4 1 r
.02 w
.72215 .60207 m
.72092 .57478 L
s
P
p
0 .4 1 r
.02 w
.655 .5137 m
.68763 .53093 L
s
P
p
0 .4 1 r
.02 w
.65425 .48696 m
.655 .5137 L
s
P
p
0 .4 1 r
.02 w
.68963 .58536 m
.72215 .60207 L
s
P
p
0 .4 1 r
.02 w
.655 .5137 m
.6218 .49616 L
s
P
p
0 .4 1 r
.02 w
.65577 .54083 m
.655 .5137 L
s
P
p
0 .4 1 r
.02 w
.65654 .56836 m
.68963 .58536 L
s
P
p
0 .4 1 r
.02 w
.65654 .56836 m
.65577 .54083 L
s
P
p
0 .4 1 r
.02 w
.6218 .49616 m
.58801 .47832 L
s
P
p
0 .4 1 r
.02 w
.58774 .45137 m
.58801 .47832 L
s
P
p
0 .4 1 r
.02 w
.5536 .4331 m
.58774 .45137 L
s
P
p
0 .4 1 r
.02 w
.62286 .55105 m
.65654 .56836 L
s
P
p
0 .4 1 r
.02 w
.58801 .47832 m
.58829 .50567 L
s
P
p
0 .4 1 r
.02 w
.58801 .47832 m
.55362 .46015 L
s
P
p
0 .4 1 r
.02 w
.5536 .4331 m
.51884 .4145 L
s
P
p
0 .4 1 r
.02 w
.55362 .46015 m
.5536 .4331 L
s
P
p
0 .4 1 r
.02 w
.62341 .57911 m
.62286 .55105 L
s
P
p
0 .4 1 r
.02 w
.58829 .50567 m
.55365 .48761 L
s
P
p
0 .4 1 r
.02 w
.55365 .48761 m
.55362 .46015 L
s
P
p
0 .4 1 r
.02 w
.51884 .4145 m
.51861 .44166 L
s
P
p
0 .4 1 r
.02 w
.58887 .56161 m
.62341 .57911 L
s
P
p
0 .4 1 r
.02 w
.58858 .53343 m
.58887 .56161 L
s
P
p
0 .4 1 r
.02 w
.55367 .51549 m
.58858 .53343 L
s
P
p
0 .4 1 r
.02 w
.51861 .44166 m
.48296 .42283 L
s
P
p
0 .4 1 r
.02 w
.58916 .59022 m
.58887 .56161 L
s
P
p
0 .4 1 r
.02 w
.55369 .54379 m
.55367 .51549 L
s
P
p
0 .4 1 r
.02 w
.51837 .46923 m
.51812 .49722 L
s
P
p
0 .4 1 r
.02 w
.48244 .45051 m
.51837 .46923 L
s
P
p
0 .4 1 r
.02 w
.48296 .42283 m
.48244 .45051 L
s
P
p
0 .4 1 r
.02 w
.58946 .61926 m
.58916 .59022 L
s
P
p
0 .4 1 r
.02 w
.51787 .52564 m
.55369 .54379 L
s
P
p
0 .4 1 r
.02 w
.51812 .49722 m
.51787 .52564 L
s
P
p
0 .4 1 r
.02 w
.55375 .6017 m
.58946 .61926 L
s
P
p
0 .4 1 r
.02 w
.51787 .52564 m
.48139 .50715 L
s
P
p
0 .4 1 r
.02 w
.51762 .5545 m
.51787 .52564 L
s
P
p
0 .4 1 r
.02 w
.51737 .58381 m
.55375 .6017 L
s
P
p
0 .4 1 r
.02 w
.51737 .58381 m
.51762 .5545 L
s
P
p
0 .4 1 r
.02 w
.48139 .50715 m
.44421 .48832 L
s
P
p
0 .4 1 r
.02 w
.44504 .45966 m
.44421 .48832 L
s
P
p
0 .4 1 r
.02 w
.40746 .44035 m
.44504 .45966 L
s
P
p
0 .4 1 r
.02 w
.4803 .56559 m
.51737 .58381 L
s
P
p
0 .4 1 r
.02 w
.44421 .48832 m
.44337 .51743 L
s
P
p
0 .4 1 r
.02 w
.44421 .48832 m
.40633 .46913 L
s
P
p
0 .4 1 r
.02 w
.40746 .44035 m
.36917 .42067 L
s
P
p
0 .4 1 r
.02 w
.40633 .46913 m
.40746 .44035 L
s
P
p
0 .4 1 r
.02 w
.47974 .5955 m
.4803 .56559 L
s
P
p
0 .4 1 r
.02 w
.44337 .51743 m
.40518 .49837 L
s
P
p
0 .4 1 r
.02 w
.40518 .49837 m
.40633 .46913 L
s
P
p
0 .4 1 r
.02 w
.36917 .42067 m
.36772 .44957 L
s
P
p
0 .4 1 r
.02 w
.44165 .57706 m
.47974 .5955 L
s
P
p
0 .4 1 r
.02 w
.44252 .54701 m
.44165 .57706 L
s
P
p
0 .4 1 r
.02 w
.40401 .52808 m
.44252 .54701 L
s
P
p
0 .4 1 r
.02 w
.36772 .44957 m
.32837 .42963 L
s
P
p
0 .4 1 r
.02 w
.44077 .6076 m
.44165 .57706 L
s
P
p
0 .4 1 r
.02 w
.40283 .55827 m
.40401 .52808 L
s
P
p
0 .4 1 r
.02 w
.36625 .47893 m
.36476 .50877 L
s
P
p
0 .4 1 r
.02 w
.32657 .45912 m
.36625 .47893 L
s
P
p
0 .4 1 r
.02 w
.32837 .42963 m
.32657 .45912 L
s
P
p
0 .4 1 r
.02 w
.43988 .63864 m
.44077 .6076 L
s
P
p
0 .4 1 r
.02 w
.36324 .5391 m
.40283 .55827 L
s
P
p
0 .4 1 r
.02 w
.36476 .50877 m
.36324 .5391 L
s
P
p
0 .4 1 r
.02 w
.4004 .62014 m
.43988 .63864 L
s
P
p
0 .4 1 r
.02 w
.36013 .60128 m
.4004 .62014 L
s
P
p
.2 1 0 r
.02 w
.3547 .57098 m
.31393 .5516 L
s
P
p
.2 1 0 r
.02 w
.35307 .60231 m
.3547 .57098 L
s
P
p
.2 1 0 r
.02 w
.31588 .52063 m
.27465 .50071 L
s
P
p
.2 1 0 r
.02 w
.31393 .5516 m
.31588 .52063 L
s
P
p
.2 1 0 r
.02 w
.31194 .58309 m
.35307 .60231 L
s
P
p
0 .4 1 r
.02 w
.31904 .58203 m
.36013 .60128 L
s
P
p
.2 1 0 r
.02 w
.27465 .50071 m
.27233 .53183 L
s
P
p
.2 1 0 r
.02 w
.23524 .44966 m
.19271 .42879 L
s
P
p
.2 1 0 r
.02 w
.23259 .4804 m
.23524 .44966 L
s
P
p
.2 1 0 r
.02 w
.26997 .56347 m
.31194 .58309 L
s
P
p
0 .4 1 r
.02 w
.31708 .61406 m
.31904 .58203 L
s
P
p
.2 1 0 r
.02 w
.27233 .53183 m
.22989 .51166 L
s
P
p
.2 1 0 r
.02 w
.22989 .51166 m
.23259 .4804 L
s
P
p
.2 1 0 r
.02 w
.19271 .42879 m
.18966 .45967 L
s
P
p
.2 1 0 r
.02 w
.30992 .61511 m
.26757 .59565 L
s
P
p
.2 1 0 r
.02 w
.30787 .64768 m
.30992 .61511 L
s
P
p
0 .4 1 r
.02 w
.27478 .59459 m
.31708 .61406 L
s
P
p
.2 1 0 r
.02 w
.26757 .59565 m
.26997 .56347 L
s
P
p
0 .4 1 r
.02 w
.27712 .5624 m
.27478 .59459 L
s
P
p
0 .4 1 r
.02 w
.23434 .54235 m
.27712 .5624 L
s
P
p
.2 1 0 r
.02 w
.18966 .45967 m
.14586 .43851 L
s
P
p
.2 1 0 r
.02 w
.26513 .62839 m
.30787 .64768 L
s
P
p
0 .4 1 r
.02 w
.2316 .5747 m
.23434 .54235 L
s
P
p
.2 1 0 r
.02 w
.18657 .49107 m
.18342 .52301 L
s
P
p
.2 1 0 r
.02 w
.14235 .47005 m
.18657 .49107 L
s
P
p
0 .4 1 r
.02 w
.19376 .48994 m
.19067 .52189 L
s
P
p
0 .4 1 r
.02 w
.14958 .4689 m
.19376 .48994 L
s
P
p
.01 w
.14586 .43851 Mdot
P
p
.2 1 0 r
.02 w
.14586 .43851 m
.14235 .47005 L
s
P
p
.01 w
.15303 .43735 Mdot
P
p
0 .4 1 r
.02 w
.15303 .43735 m
.14958 .4689 L
s
P
p
.2 1 0 r
.02 w
.26265 .6617 m
.26513 .62839 L
s
P
p
.2 1 0 r
.02 w
.22434 .57579 m
.2215 .6087 L
s
P
p
.2 1 0 r
.02 w
.18021 .55552 m
.22434 .57579 L
s
P
p
0 .4 1 r
.02 w
.18752 .55441 m
.2316 .5747 L
s
P
p
.2 1 0 r
.02 w
.18342 .52301 m
.13878 .50215 L
s
P
p
0 .4 1 r
.02 w
.19067 .52189 m
.18752 .55441 L
s
P
p
.2 1 0 r
.02 w
.21861 .64219 m
.26265 .6617 L
s
P
p
.2 1 0 r
.02 w
.2215 .6087 m
.21861 .64219 L
s
P
p
.2 1 0 r
.02 w
.17695 .58859 m
.18021 .55552 L
s
P
p
.2 1 0 r
.02 w
.13878 .50215 m
.09319 .48084 L
s
P
p
.2 1 0 r
.02 w
.13144 .56806 m
.17695 .58859 L
s
P
p
.2 1 0 r
.02 w
.13514 .53481 m
.13144 .56806 L
s
P
p
.2 1 0 r
.02 w
.08911 .51366 m
.13514 .53481 L
s
P
p
.2 1 0 r
.02 w
.09319 .48084 m
.08911 .51366 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.154762 0.149123 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.154762 0.286967 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.8811 .50206 m
.78086 .44927 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.8811 .50206 L
s
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.31889 .12085 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.44385 .18936 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.31889 .12085 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.81335 .90655 m
.80614 .80506 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68855 .7548 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.81335 .90655 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43123 .54175 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.139 .40899 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.12548 .51415 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.12548 .51415 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.154762 0.424812 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.7867 .53145 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.89777 .66825 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56304 .80672 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.15169 .31032 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.139 .40899 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.154762 0.562657 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.79284 .61791 L
s
P
p
0 .4 1 r
.02 w
.90676 .7578 m
.89777 .66825 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.91622 .85211 m
.90676 .7578 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.91622 .85211 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68855 .7548 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.154762 0.700501 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.154762 0.838346 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.154762 0.97619 0.280075 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.8811 .50206 m
.78086 .44927 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.8811 .50206 L
s
P
p
0 .4 1 r
.02 w
.7753 .37106 m
.67141 .31411 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.7753 .37106 L
s
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.88923 .58311 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.67141 .31411 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.90676 .7578 m
.89777 .66825 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.7867 .53145 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.90676 .7578 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68855 .7548 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.43465 .44607 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.42759 .64327 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.292607 0.149123 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.308424 1.71627 0.0252773 1.01109 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.91024 .71077 m
.85823 .67661 L
s
P
p
.2 1 0 r
.02 w
.91443 .76965 m
.91024 .71077 L
s
P
p
.2 1 0 r
.02 w
.85467 .61866 m
.80176 .58313 L
s
P
p
.2 1 0 r
.02 w
.85823 .67661 m
.85467 .61866 L
s
P
p
.2 1 0 r
.02 w
.86187 .73592 m
.91443 .76965 L
s
P
p
.2 1 0 r
.02 w
.80176 .58313 m
.80474 .64148 L
s
P
p
.2 1 0 r
.02 w
.74504 .48922 m
.68968 .45125 L
s
P
p
.2 1 0 r
.02 w
.74735 .54659 m
.74504 .48922 L
s
P
p
.2 1 0 r
.02 w
.8078 .70123 m
.86187 .73592 L
s
P
p
.2 1 0 r
.02 w
.80474 .64148 m
.74972 .60534 L
s
P
p
.2 1 0 r
.02 w
.74972 .60534 m
.74735 .54659 L
s
P
p
.2 1 0 r
.02 w
.68968 .45125 m
.69137 .509 L
s
P
p
.2 1 0 r
.02 w
.86559 .79665 m
.81092 .76242 L
s
P
p
.2 1 0 r
.02 w
.86941 .85885 m
.86559 .79665 L
s
P
p
.2 1 0 r
.02 w
.81092 .76242 m
.8078 .70123 L
s
P
p
.2 1 0 r
.02 w
.69137 .509 m
.63374 .4703 L
s
P
p
0 .4 1 r
.02 w
.64369 .41004 m
.58518 .36977 L
s
P
p
0 .4 1 r
.02 w
.64484 .46817 m
.64369 .41004 L
s
P
p
.2 1 0 r
.02 w
.81412 .82511 m
.86941 .85885 L
s
P
p
.2 1 0 r
.02 w
.69309 .56815 m
.69486 .62876 L
s
P
p
.2 1 0 r
.02 w
.63478 .52985 m
.69309 .56815 L
s
P
p
0 .4 1 r
.02 w
.70421 .5661 m
.64602 .52775 L
s
P
p
.01 w
.63374 .4703 Mdot
P
p
.2 1 0 r
.02 w
.63374 .4703 m
.63478 .52985 L
s
P
p
.01 w
.64484 .46817 Mdot
P
p
0 .4 1 r
.02 w
.64602 .52775 m
.64484 .46817 L
s
P
p
0 .4 1 r
.02 w
.58518 .36977 m
.58562 .42827 L
s
P
p
.2 1 0 r
.02 w
.8174 .88936 m
.81412 .82511 L
s
P
p
.2 1 0 r
.02 w
.75464 .72718 m
.75719 .79037 L
s
P
p
.2 1 0 r
.02 w
.69667 .69088 m
.75464 .72718 L
s
P
p
.2 1 0 r
.02 w
.69486 .62876 m
.63584 .59089 L
s
P
p
0 .4 1 r
.02 w
.58562 .42827 m
.52462 .38715 L
s
P
p
.2 1 0 r
.02 w
.7598 .85515 m
.8174 .88936 L
s
P
p
0 .4 1 r
.02 w
.52493 .32829 m
.46285 .28556 L
s
P
p
0 .4 1 r
.02 w
.52462 .38715 m
.52493 .32829 L
s
P
p
.2 1 0 r
.02 w
.75719 .79037 m
.7598 .85515 L
s
P
p
.2 1 0 r
.02 w
.69852 .75457 m
.69667 .69088 L
s
P
p
.2 1 0 r
.02 w
.63584 .59089 m
.57504 .55187 L
s
P
p
0 .4 1 r
.02 w
.58607 .48823 m
.5243 .44751 L
s
P
p
0 .4 1 r
.02 w
.5243 .44751 m
.52462 .38715 L
s
P
p
0 .4 1 r
.02 w
.46285 .28556 m
.46174 .34478 L
s
P
p
.2 1 0 r
.02 w
.63805 .71767 m
.69852 .75457 L
s
P
p
.2 1 0 r
.02 w
.63694 .65348 m
.63805 .71767 L
s
P
p
.2 1 0 r
.02 w
.57536 .61492 m
.63694 .65348 L
s
P
p
.2 1 0 r
.02 w
.57504 .55187 m
.57536 .61492 L
s
P
p
0 .4 1 r
.02 w
.46174 .34478 m
.39691 .30109 L
s
P
p
0 .4 1 r
.02 w
.39887 .24152 m
.33289 .19611 L
s
P
p
0 .4 1 r
.02 w
.39691 .30109 m
.39887 .24152 L
s
P
p
0 .4 1 r
.02 w
.4606 .40553 m
.3949 .36222 L
s
P
p
0 .4 1 r
.02 w
.3949 .36222 m
.39691 .30109 L
s
P
p
0 .4 1 r
.02 w
.33289 .19611 m
.33003 .25602 L
s
P
p
0 .4 1 r
.02 w
.33003 .25602 m
.261 .2095 L
s
P
p
0 .4 1 r
.02 w
.26481 .14925 m
.19455 .10089 L
s
P
p
0 .4 1 r
.02 w
.261 .2095 m
.26481 .14925 L
s
P
p
0 .4 1 r
.02 w
.3271 .31753 m
.25708 .27138 L
s
P
p
0 .4 1 r
.02 w
.25708 .27138 m
.261 .2095 L
s
P
p
0 .4 1 r
.02 w
.19455 .10089 m
.18972 .16146 L
s
P
p
0 .4 1 r
.02 w
.18972 .16146 m
.11607 .11182 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.292607 0.286967 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.559341 2.21998 0.0242236 0.968945 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.88673 .5597 m
.79942 .51531 L
s
P
p
0 .4 1 r
.02 w
.89392 .63143 m
.88673 .5597 L
s
P
p
0 .4 1 r
.02 w
.80489 .58796 m
.89392 .63143 L
s
P
p
0 .4 1 r
.02 w
.79942 .51531 m
.7075 .46857 L
s
P
p
0 .4 1 r
.02 w
.70412 .39819 m
.60925 .34813 L
s
P
p
0 .4 1 r
.02 w
.7075 .46857 m
.70412 .39819 L
s
P
p
.2 1 0 r
.02 w
.78644 .59037 m
.69223 .54467 L
s
P
p
.2 1 0 r
.02 w
.79173 .66622 m
.78644 .59037 L
s
P
p
0 .4 1 r
.02 w
.71104 .54213 m
.80489 .58796 L
s
P
p
.2 1 0 r
.02 w
.68912 .47117 m
.59184 .42203 L
s
P
p
.2 1 0 r
.02 w
.69223 .54467 m
.68912 .47117 L
s
P
p
0 .4 1 r
.02 w
.60925 .34813 m
.61058 .41929 L
s
P
p
0 .4 1 r
.02 w
.51013 .22662 m
.40691 .17026 L
s
P
p
0 .4 1 r
.02 w
.50921 .29534 m
.51013 .22662 L
s
P
p
.2 1 0 r
.02 w
.6955 .62156 m
.79173 .66622 L
s
P
p
0 .4 1 r
.02 w
.81059 .66386 m
.71474 .61907 L
s
P
p
0 .4 1 r
.02 w
.81656 .74325 m
.81059 .66386 L
s
P
p
0 .4 1 r
.02 w
.71474 .61907 m
.71104 .54213 L
s
P
p
.2 1 0 r
.02 w
.59184 .42203 m
.59279 .49644 L
s
P
p
0 .4 1 r
.02 w
.61058 .41929 m
.50824 .36726 L
s
P
p
.2 1 0 r
.02 w
.49053 .29827 m
.38451 .24268 L
s
P
p
.2 1 0 r
.02 w
.48913 .37015 m
.49053 .29827 L
s
P
p
0 .4 1 r
.02 w
.50824 .36726 m
.50921 .29534 L
s
P
p
0 .4 1 r
.02 w
.40691 .17026 m
.40355 .23958 L
s
P
p
0 .4 1 r
.02 w
.71861 .69966 m
.81656 .74325 L
s
P
p
.2 1 0 r
.02 w
.59379 .57437 m
.6955 .62156 L
s
P
p
.2 1 0 r
.02 w
.59279 .49644 m
.48767 .44545 L
s
P
p
.2 1 0 r
.02 w
.48767 .44545 m
.48913 .37015 L
s
P
p
.2 1 0 r
.02 w
.38451 .24268 m
.38053 .31529 L
s
P
p
0 .4 1 r
.02 w
.40355 .23958 m
.40002 .31223 L
s
P
p
.2 1 0 r
.02 w
.69891 .70208 m
.59484 .65609 L
s
P
p
.2 1 0 r
.02 w
.70249 .78649 m
.69891 .70208 L
s
P
p
0 .4 1 r
.02 w
.72268 .78413 m
.71861 .69966 L
s
P
p
.2 1 0 r
.02 w
.59484 .65609 m
.59379 .57437 L
s
P
p
.2 1 0 r
.02 w
.38053 .31529 m
.26551 .25719 L
s
P
p
0 .4 1 r
.02 w
.40002 .31223 m
.2854 .25395 L
s
P
p
.2 1 0 r
.02 w
.59594 .74187 m
.70249 .78649 L
s
P
p
0 .4 1 r
.02 w
.72694 .8728 m
.72268 .78413 L
s
P
p
0 .4 1 r
.02 w
.61495 .65352 m
.61655 .73938 L
s
P
p
0 .4 1 r
.02 w
.50506 .60461 m
.61495 .65352 L
s
P
p
.2 1 0 r
.02 w
.37637 .39146 m
.37199 .47146 L
s
P
p
.2 1 0 r
.02 w
.25832 .3342 m
.37637 .39146 L
s
P
p
0 .4 1 r
.02 w
.39633 .38845 m
.39244 .4685 L
s
P
p
0 .4 1 r
.02 w
.27869 .331 m
.39633 .38845 L
s
P
p
.01 w
.26551 .25719 Mdot
P
p
.2 1 0 r
.02 w
.26551 .25719 m
.25832 .3342 L
s
P
p
.01 w
.2854 .25395 Mdot
P
p
0 .4 1 r
.02 w
.2854 .25395 m
.27869 .331 L
s
P
p
0 .4 1 r
.02 w
.61824 .82962 m
.72694 .8728 L
s
P
p
.2 1 0 r
.02 w
.59709 .83202 m
.59594 .74187 L
s
P
p
0 .4 1 r
.02 w
.61655 .73938 m
.61824 .82962 L
s
P
p
.2 1 0 r
.02 w
.48452 .60734 m
.48283 .69451 L
s
P
p
.2 1 0 r
.02 w
.36738 .55557 m
.48452 .60734 L
s
P
p
0 .4 1 r
.02 w
.50389 .69186 m
.50506 .60461 L
s
P
p
.2 1 0 r
.02 w
.37199 .47146 m
.25075 .4152 L
s
P
p
0 .4 1 r
.02 w
.39244 .4685 m
.27163 .41205 L
s
P
p
.2 1 0 r
.02 w
.48104 .78626 m
.59709 .83202 L
s
P
p
.2 1 0 r
.02 w
.48283 .69451 m
.48104 .78626 L
s
P
p
0 .4 1 r
.02 w
.38406 .64132 m
.50389 .69186 L
s
P
p
.2 1 0 r
.02 w
.36254 .64414 m
.36738 .55557 L
s
P
p
0 .4 1 r
.02 w
.38836 .55268 m
.38406 .64132 L
s
P
p
0 .4 1 r
.02 w
.2642 .49742 m
.38836 .55268 L
s
P
p
.2 1 0 r
.02 w
.25075 .4152 m
.12173 .35534 L
s
P
p
0 .4 1 r
.02 w
.27163 .41205 m
.14306 .35198 L
s
P
p
.2 1 0 r
.02 w
.23436 .59047 m
.36254 .64414 L
s
P
p
.2 1 0 r
.02 w
.24277 .50051 m
.23436 .59047 L
s
P
p
.2 1 0 r
.02 w
.10995 .44181 m
.24277 .50051 L
s
P
p
0 .4 1 r
.02 w
.13185 .43852 m
.2642 .49742 L
s
P
p
.2 1 0 r
.02 w
.12173 .35534 m
.10995 .44181 L
s
P
p
0 .4 1 r
.02 w
.14306 .35198 m
.13185 .43852 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.292607 0.424812 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.292607 0.562657 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.605781 2.3072 0.0240806 0.963223 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.86855 .46507 m
.83313 .44713 L
s
P
p
.2 1 0 r
.02 w
.87112 .49193 m
.86855 .46507 L
s
P
p
.2 1 0 r
.02 w
.83085 .42059 m
.79501 .40219 L
s
P
p
.2 1 0 r
.02 w
.83313 .44713 m
.83085 .42059 L
s
P
p
.2 1 0 r
.02 w
.83544 .47411 m
.87112 .49193 L
s
P
p
.2 1 0 r
.02 w
.79501 .40219 m
.79702 .42884 L
s
P
p
.2 1 0 r
.02 w
.75677 .3571 m
.7198 .33787 L
s
P
p
.2 1 0 r
.02 w
.75847 .38343 m
.75677 .3571 L
s
P
p
.2 1 0 r
.02 w
.79906 .45594 m
.83544 .47411 L
s
P
p
.2 1 0 r
.02 w
.79702 .42884 m
.7602 .4102 L
s
P
p
.2 1 0 r
.02 w
.7602 .4102 m
.75847 .38343 L
s
P
p
.2 1 0 r
.02 w
.7198 .33787 m
.72121 .3643 L
s
P
p
.2 1 0 r
.02 w
.8378 .50153 m
.80114 .48348 L
s
P
p
.2 1 0 r
.02 w
.84019 .5294 m
.8378 .50153 L
s
P
p
.2 1 0 r
.02 w
.80114 .48348 m
.79906 .45594 L
s
P
p
.2 1 0 r
.02 w
.72121 .3643 m
.68321 .3448 L
s
P
p
.2 1 0 r
.02 w
.80325 .51148 m
.84019 .5294 L
s
P
p
.2 1 0 r
.02 w
.72265 .39118 m
.72411 .4185 L
s
P
p
.2 1 0 r
.02 w
.68434 .37178 m
.72265 .39118 L
s
P
p
0 .4 1 r
.02 w
.73007 .39014 m
.73159 .41746 L
s
P
p
0 .4 1 r
.02 w
.69182 .37071 m
.73007 .39014 L
s
P
p
.01 w
.68321 .3448 Mdot
P
p
.2 1 0 r
.02 w
.68321 .3448 m
.68434 .37178 L
s
P
p
.01 w
.69062 .34373 Mdot
P
p
0 .4 1 r
.02 w
.69062 .34373 m
.69182 .37071 L
s
P
p
.2 1 0 r
.02 w
.8054 .53995 m
.80325 .51148 L
s
P
p
.2 1 0 r
.02 w
.76375 .46507 m
.76556 .4932 L
s
P
p
.2 1 0 r
.02 w
.7256 .44628 m
.76375 .46507 L
s
P
p
.2 1 0 r
.02 w
.72411 .4185 m
.68549 .39921 L
s
P
p
0 .4 1 r
.02 w
.73159 .41746 m
.69303 .39816 L
s
P
p
.2 1 0 r
.02 w
.76741 .5218 m
.8054 .53995 L
s
P
p
.2 1 0 r
.02 w
.76556 .4932 m
.76741 .5218 L
s
P
p
.2 1 0 r
.02 w
.72711 .47454 m
.7256 .44628 L
s
P
p
.2 1 0 r
.02 w
.68549 .39921 m
.64609 .37953 L
s
P
p
0 .4 1 r
.02 w
.69303 .39816 m
.65368 .37845 L
s
P
p
.2 1 0 r
.02 w
.68786 .4555 m
.72711 .47454 L
s
P
p
.2 1 0 r
.02 w
.68667 .42711 m
.68786 .4555 L
s
P
p
.2 1 0 r
.02 w
.64693 .40755 m
.68667 .42711 L
s
P
p
0 .4 1 r
.02 w
.69427 .42606 m
.69553 .45445 L
s
P
p
0 .4 1 r
.02 w
.65459 .40648 m
.69427 .42606 L
s
P
p
.2 1 0 r
.02 w
.64609 .37953 m
.64693 .40755 L
s
P
p
0 .4 1 r
.02 w
.65368 .37845 m
.65459 .40648 L
s
P
p
0 .4 1 r
.02 w
.69553 .45445 m
.69681 .48333 L
s
P
p
0 .4 1 r
.02 w
.65459 .40648 m
.61409 .38648 L
s
P
p
0 .4 1 r
.02 w
.65552 .43499 m
.65459 .40648 L
s
P
p
0 .4 1 r
.02 w
.69681 .48333 m
.65646 .46401 L
s
P
p
0 .4 1 r
.02 w
.65646 .46401 m
.65552 .43499 L
s
P
p
0 .4 1 r
.02 w
.61409 .38648 m
.61467 .41512 L
s
P
p
0 .4 1 r
.02 w
.61467 .41512 m
.57295 .39483 L
s
P
p
0 .4 1 r
.02 w
.61526 .44427 m
.61586 .47394 L
s
P
p
0 .4 1 r
.02 w
.57318 .42411 m
.61526 .44427 L
s
P
p
0 .4 1 r
.02 w
.57295 .39483 m
.57318 .42411 L
s
P
p
0 .4 1 r
.02 w
.61586 .47394 m
.5734 .45391 L
s
P
p
0 .4 1 r
.02 w
.5734 .45391 m
.53001 .43345 L
s
P
p
0 .4 1 r
.02 w
.57364 .48426 m
.57387 .51517 L
s
P
p
0 .4 1 r
.02 w
.52985 .46395 m
.57364 .48426 L
s
P
p
0 .4 1 r
.02 w
.53001 .43345 m
.52985 .46395 L
s
P
p
0 .4 1 r
.02 w
.57387 .51517 m
.57412 .54665 L
s
P
p
0 .4 1 r
.02 w
.52985 .46395 m
.48508 .44318 L
s
P
p
0 .4 1 r
.02 w
.52968 .49501 m
.52985 .46395 L
s
P
p
0 .4 1 r
.02 w
.57412 .54665 m
.52951 .52666 L
s
P
p
0 .4 1 r
.02 w
.52951 .52666 m
.52968 .49501 L
s
P
p
0 .4 1 r
.02 w
.48508 .44318 m
.48449 .4744 L
s
P
p
0 .4 1 r
.02 w
.48449 .4744 m
.43827 .45331 L
s
P
p
0 .4 1 r
.02 w
.48389 .50621 m
.48328 .53863 L
s
P
p
0 .4 1 r
.02 w
.43722 .48529 m
.48389 .50621 L
s
P
p
0 .4 1 r
.02 w
.43827 .45331 m
.43722 .48529 L
s
P
p
0 .4 1 r
.02 w
.48328 .53863 m
.43615 .51788 L
s
P
p
0 .4 1 r
.02 w
.43615 .51788 m
.38791 .49665 L
s
P
p
0 .4 1 r
.02 w
.43506 .55112 m
.43394 .58501 L
s
P
p
0 .4 1 r
.02 w
.38633 .53007 m
.43506 .55112 L
s
P
p
0 .4 1 r
.02 w
.38791 .49665 m
.38633 .53007 L
s
P
p
0 .4 1 r
.02 w
.43394 .58501 m
.43281 .61957 L
s
P
p
0 .4 1 r
.02 w
.38633 .53007 m
.33642 .50851 L
s
P
p
0 .4 1 r
.02 w
.38471 .56416 m
.38633 .53007 L
s
P
p
0 .4 1 r
.02 w
.43281 .61957 m
.38306 .59893 L
s
P
p
0 .4 1 r
.02 w
.38306 .59893 m
.38471 .56416 L
s
P
p
0 .4 1 r
.02 w
.33642 .50851 m
.33428 .5428 L
s
P
p
0 .4 1 r
.02 w
.33428 .5428 m
.28262 .52091 L
s
P
p
0 .4 1 r
.02 w
.3321 .57778 m
.32987 .61349 L
s
P
p
0 .4 1 r
.02 w
.27987 .5561 m
.3321 .57778 L
s
P
p
0 .4 1 r
.02 w
.28262 .52091 m
.27987 .5561 L
s
P
p
0 .4 1 r
.02 w
.32987 .61349 m
.27707 .59203 L
s
P
p
0 .4 1 r
.02 w
.27707 .59203 m
.22292 .57003 L
s
P
p
0 .4 1 r
.02 w
.2742 .62872 m
.27128 .66619 L
s
P
p
0 .4 1 r
.02 w
.21944 .60695 m
.2742 .62872 L
s
P
p
0 .4 1 r
.02 w
.22292 .57003 m
.21944 .60695 L
s
P
p
0 .4 1 r
.02 w
.27128 .66619 m
.26829 .70447 L
s
P
p
0 .4 1 r
.02 w
.21944 .60695 m
.16325 .58462 L
s
P
p
0 .4 1 r
.02 w
.21588 .64468 m
.21944 .60695 L
s
P
p
0 .4 1 r
.02 w
.26829 .70447 m
.21225 .68323 L
s
P
p
0 .4 1 r
.02 w
.21225 .68323 m
.21588 .64468 L
s
P
p
0 .4 1 r
.02 w
.16325 .58462 m
.15903 .6226 L
s
P
p
0 .4 1 r
.02 w
.15903 .6226 m
.10066 .59993 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.292607 0.700501 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.292607 0.838346 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.649333 2.38458 0.0238845 0.955379 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.77289 .40994 m
.66614 .35823 L
s
P
p
0 .4 1 r
.02 w
.7779 .48414 m
.77289 .40994 L
s
P
p
.2 1 0 r
.02 w
.86758 .61144 m
.76162 .56426 L
s
P
p
.2 1 0 r
.02 w
.87476 .6913 m
.86758 .61144 L
s
P
p
.2 1 0 r
.02 w
.75686 .48682 m
.64746 .43609 L
s
P
p
.2 1 0 r
.02 w
.76162 .56426 m
.75686 .48682 L
s
P
p
0 .4 1 r
.02 w
.6689 .43326 m
.7779 .48414 L
s
P
p
0 .4 1 r
.02 w
.66614 .35823 m
.6689 .43326 L
s
P
p
0 .4 1 r
.02 w
.66614 .35823 m
.55365 .30374 L
s
P
p
0 .4 1 r
.02 w
.55341 .23122 m
.43735 .17304 L
s
P
p
0 .4 1 r
.02 w
.55365 .30374 m
.55341 .23122 L
s
P
p
.2 1 0 r
.02 w
.76658 .64523 m
.87476 .6913 L
s
P
p
.2 1 0 r
.02 w
.64746 .43609 m
.64984 .5145 L
s
P
p
0 .4 1 r
.02 w
.6689 .43326 m
.55389 .37958 L
s
P
p
0 .4 1 r
.02 w
.67178 .51172 m
.6689 .43326 L
s
P
p
.2 1 0 r
.02 w
.53228 .30676 m
.41314 .24942 L
s
P
p
.2 1 0 r
.02 w
.53203 .38257 m
.53228 .30676 L
s
P
p
0 .4 1 r
.02 w
.55365 .30374 m
.43492 .24623 L
s
P
p
0 .4 1 r
.02 w
.55389 .37958 m
.55365 .30374 L
s
P
p
0 .4 1 r
.02 w
.43735 .17304 m
.43492 .24623 L
s
P
p
.2 1 0 r
.02 w
.65234 .59657 m
.76658 .64523 L
s
P
p
.2 1 0 r
.02 w
.64984 .5145 m
.53178 .46193 L
s
P
p
0 .4 1 r
.02 w
.67178 .51172 m
.55415 .459 L
s
P
p
0 .4 1 r
.02 w
.67479 .59386 m
.67178 .51172 L
s
P
p
.2 1 0 r
.02 w
.53178 .46193 m
.53203 .38257 L
s
P
p
0 .4 1 r
.02 w
.55415 .459 m
.55389 .37958 L
s
P
p
0 .4 1 r
.02 w
.55389 .37958 m
.43237 .32286 L
s
P
p
.2 1 0 r
.02 w
.41314 .24942 m
.41008 .32602 L
s
P
p
0 .4 1 r
.02 w
.43492 .24623 m
.43237 .32286 L
s
P
p
.2 1 0 r
.02 w
.77178 .72996 m
.65496 .68257 L
s
P
p
.2 1 0 r
.02 w
.77723 .81872 m
.77178 .72996 L
s
P
p
.2 1 0 r
.02 w
.65496 .68257 m
.65234 .59657 L
s
P
p
0 .4 1 r
.02 w
.55442 .54223 m
.67479 .59386 L
s
P
p
0 .4 1 r
.02 w
.55415 .459 m
.55442 .54223 L
s
P
p
0 .4 1 r
.02 w
.42969 .40321 m
.55415 .459 L
s
P
p
.2 1 0 r
.02 w
.41008 .32602 m
.28102 .26618 L
s
P
p
0 .4 1 r
.02 w
.43237 .32286 m
.30375 .26284 L
s
P
p
0 .4 1 r
.02 w
.43237 .32286 m
.42969 .40321 L
s
P
p
.2 1 0 r
.02 w
.6577 .77278 m
.77723 .81872 L
s
P
p
.2 1 0 r
.02 w
.40687 .40632 m
.4035 .49059 L
s
P
p
.2 1 0 r
.02 w
.27451 .34738 m
.40687 .40632 L
s
P
p
0 .4 1 r
.02 w
.2978 .34409 m
.42969 .40321 L
s
P
p
.01 w
.28102 .26618 Mdot
P
p
.2 1 0 r
.02 w
.28102 .26618 m
.27451 .34738 L
s
P
p
.01 w
.30375 .26284 Mdot
P
p
0 .4 1 r
.02 w
.30375 .26284 m
.2978 .34409 L
s
P
p
.2 1 0 r
.02 w
.66058 .86753 m
.6577 .77278 L
s
P
p
.2 1 0 r
.02 w
.53123 .63238 m
.53093 .72406 L
s
P
p
.2 1 0 r
.02 w
.39996 .57913 m
.53123 .63238 L
s
P
p
.2 1 0 r
.02 w
.4035 .49059 m
.26766 .43273 L
s
P
p
.2 1 0 r
.02 w
.53062 .82049 m
.66058 .86753 L
s
P
p
.2 1 0 r
.02 w
.53093 .72406 m
.53062 .82049 L
s
P
p
.2 1 0 r
.02 w
.39624 .67229 m
.39996 .57913 L
s
P
p
.2 1 0 r
.02 w
.26766 .43273 m
.12324 .37122 L
s
P
p
.2 1 0 r
.02 w
.25286 .61718 m
.39624 .67229 L
s
P
p
.2 1 0 r
.02 w
.26046 .52254 m
.25286 .61718 L
s
P
p
.2 1 0 r
.02 w
.1119 .46228 m
.26046 .52254 L
s
P
p
.2 1 0 r
.02 w
.12324 .37122 m
.1119 .46228 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.292607 0.97619 0.41792 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.451366 2.00297 0.0247151 0.988603 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.90323 .63152 m
.82303 .58655 L
s
P
p
0 .4 1 r
.02 w
.90991 .70714 m
.90323 .63152 L
s
P
p
0 .4 1 r
.02 w
.81794 .51289 m
.73548 .46504 L
s
P
p
0 .4 1 r
.02 w
.82303 .58655 m
.81794 .51289 L
s
P
p
0 .4 1 r
.02 w
.82831 .66306 m
.90991 .70714 L
s
P
p
.2 1 0 r
.02 w
.80642 .58904 m
.72219 .54209 L
s
P
p
.2 1 0 r
.02 w
.81137 .6655 m
.80642 .58904 L
s
P
p
.2 1 0 r
.02 w
.71891 .46769 m
.63231 .41772 L
s
P
p
.2 1 0 r
.02 w
.72219 .54209 m
.71891 .46769 L
s
P
p
0 .4 1 r
.02 w
.73548 .46504 m
.73908 .53949 L
s
P
p
0 .4 1 r
.02 w
.64726 .3426 m
.55852 .28944 L
s
P
p
0 .4 1 r
.02 w
.64915 .41495 m
.64726 .3426 L
s
P
p
.2 1 0 r
.02 w
.72559 .61944 m
.81137 .6655 L
s
P
p
0 .4 1 r
.02 w
.74282 .61688 m
.82831 .66306 L
s
P
p
0 .4 1 r
.02 w
.73908 .53949 m
.65112 .49017 L
s
P
p
.2 1 0 r
.02 w
.63231 .41772 m
.63394 .4929 L
s
P
p
0 .4 1 r
.02 w
.65112 .49017 m
.64915 .41495 L
s
P
p
.2 1 0 r
.02 w
.54173 .29238 m
.44844 .2368 L
s
P
p
.2 1 0 r
.02 w
.54156 .36536 m
.54173 .29238 L
s
P
p
0 .4 1 r
.02 w
.55852 .28944 m
.55869 .36245 L
s
P
p
.2 1 0 r
.02 w
.63564 .57114 m
.72559 .61944 L
s
P
p
0 .4 1 r
.02 w
.65317 .56845 m
.74282 .61688 L
s
P
p
.2 1 0 r
.02 w
.63394 .4929 m
.54138 .44132 L
s
P
p
.2 1 0 r
.02 w
.54138 .44132 m
.54156 .36536 L
s
P
p
0 .4 1 r
.02 w
.55869 .36245 m
.46378 .30738 L
s
P
p
.2 1 0 r
.02 w
.44844 .2368 m
.44636 .31043 L
s
P
p
.2 1 0 r
.02 w
.72914 .69991 m
.63741 .6526 L
s
P
p
.2 1 0 r
.02 w
.73283 .78369 m
.72914 .69991 L
s
P
p
0 .4 1 r
.02 w
.74672 .6974 m
.65531 .64998 L
s
P
p
0 .4 1 r
.02 w
.75078 .78125 m
.74672 .6974 L
s
P
p
.2 1 0 r
.02 w
.63741 .6526 m
.63564 .57114 L
s
P
p
0 .4 1 r
.02 w
.65531 .64998 m
.65317 .56845 L
s
P
p
.2 1 0 r
.02 w
.44636 .31043 m
.34637 .25274 L
s
P
p
0 .4 1 r
.02 w
.46378 .30738 m
.36409 .24953 L
s
P
p
.2 1 0 r
.02 w
.63926 .73752 m
.73283 .78369 L
s
P
p
0 .4 1 r
.02 w
.65753 .73495 m
.75078 .78125 L
s
P
p
.2 1 0 r
.02 w
.44419 .38714 m
.44193 .46712 L
s
P
p
.2 1 0 r
.02 w
.34201 .33019 m
.44419 .38714 L
s
P
p
0 .4 1 r
.02 w
.46198 .38413 m
.46009 .46416 L
s
P
p
0 .4 1 r
.02 w
.36011 .32702 m
.46198 .38413 L
s
P
p
.01 w
.34637 .25274 Mdot
P
p
.2 1 0 r
.02 w
.34637 .25274 m
.34201 .33019 L
s
P
p
.01 w
.36409 .24953 Mdot
P
p
0 .4 1 r
.02 w
.36409 .24953 m
.36011 .32702 L
s
P
p
.2 1 0 r
.02 w
.64118 .82609 m
.63926 .73752 L
s
P
p
0 .4 1 r
.02 w
.55943 .68623 m
.65753 .73495 L
s
P
p
.2 1 0 r
.02 w
.54101 .60289 m
.54082 .68894 L
s
P
p
.2 1 0 r
.02 w
.43958 .55058 m
.54101 .60289 L
s
P
p
.2 1 0 r
.02 w
.44193 .46712 m
.33746 .41102 L
s
P
p
0 .4 1 r
.02 w
.46009 .46416 m
.35594 .4079 L
s
P
p
.2 1 0 r
.02 w
.54061 .77879 m
.64118 .82609 L
s
P
p
.2 1 0 r
.02 w
.54082 .68894 m
.54061 .77879 L
s
P
p
0 .4 1 r
.02 w
.55964 .77616 m
.55943 .68623 L
s
P
p
.2 1 0 r
.02 w
.43712 .63776 m
.43958 .55058 L
s
P
p
0 .4 1 r
.02 w
.45813 .54767 m
.45608 .63491 L
s
P
p
0 .4 1 r
.02 w
.3516 .49239 m
.45813 .54767 L
s
P
p
.2 1 0 r
.02 w
.33746 .41102 m
.22734 .35189 L
s
P
p
0 .4 1 r
.02 w
.35594 .4079 m
.24617 .3486 L
s
P
p
0 .4 1 r
.02 w
.45394 .72613 m
.55964 .77616 L
s
P
p
.2 1 0 r
.02 w
.32773 .58377 m
.43712 .63776 L
s
P
p
0 .4 1 r
.02 w
.45608 .63491 m
.45394 .72613 L
s
P
p
.2 1 0 r
.02 w
.3327 .49546 m
.32773 .58377 L
s
P
p
.2 1 0 r
.02 w
.21993 .43731 m
.3327 .49546 L
s
P
p
0 .4 1 r
.02 w
.34705 .58077 m
.3516 .49239 L
s
P
p
.2 1 0 r
.02 w
.22734 .35189 m
.21993 .43731 L
s
P
p
0 .4 1 r
.02 w
.24617 .3486 m
.13031 .28601 L
s
P
p
0 .4 1 r
.02 w
.23185 .52356 m
.34705 .58077 L
s
P
p
0 .4 1 r
.02 w
.23918 .43407 m
.23185 .52356 L
s
P
p
0 .4 1 r
.02 w
.12037 .37243 m
.23918 .43407 L
s
P
p
0 .4 1 r
.02 w
.13031 .28601 m
.12037 .37243 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.430451 0.149123 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.430451 0.286967 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.498191 2.097 0.0245059 0.980236 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87882 .61174 m
.78846 .56381 L
s
P
p
.2 1 0 r
.02 w
.88591 .6918 m
.87882 .61174 L
s
P
p
.2 1 0 r
.02 w
.7834 .48613 m
.69015 .43471 L
s
P
p
.2 1 0 r
.02 w
.78846 .56381 m
.7834 .48613 L
s
P
p
.2 1 0 r
.02 w
.79374 .64494 m
.88591 .6918 L
s
P
p
.2 1 0 r
.02 w
.69015 .43471 m
.69327 .51333 L
s
P
p
.2 1 0 r
.02 w
.59099 .30448 m
.48962 .24655 L
s
P
p
.2 1 0 r
.02 w
.5919 .38054 m
.59099 .30448 L
s
P
p
.2 1 0 r
.02 w
.69652 .59553 m
.79374 .64494 L
s
P
p
.2 1 0 r
.02 w
.69327 .51333 m
.59285 .46007 L
s
P
p
.2 1 0 r
.02 w
.59285 .46007 m
.5919 .38054 L
s
P
p
.2 1 0 r
.02 w
.48962 .24655 m
.48822 .32337 L
s
P
p
.2 1 0 r
.02 w
.79926 .72975 m
.69993 .68156 L
s
P
p
.2 1 0 r
.02 w
.80503 .8185 m
.79926 .72975 L
s
P
p
.2 1 0 r
.02 w
.69993 .68156 m
.69652 .59553 L
s
P
p
.2 1 0 r
.02 w
.48822 .32337 m
.37867 .26297 L
s
P
p
0 .4 1 r
.02 w
.50751 .32019 m
.39834 .2596 L
s
P
p
.2 1 0 r
.02 w
.7035 .77169 m
.80503 .8185 L
s
P
p
.2 1 0 r
.02 w
.48676 .40381 m
.48523 .48812 L
s
P
p
.2 1 0 r
.02 w
.37451 .34428 m
.48676 .40381 L
s
P
p
0 .4 1 r
.02 w
.5065 .40067 m
.50545 .48504 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.5065 .40067 L
s
P
p
.01 w
.37867 .26297 Mdot
P
p
.2 1 0 r
.02 w
.37867 .26297 m
.37451 .34428 L
s
P
p
.01 w
.39834 .2596 Mdot
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.39834 .2596 L
s
P
p
.2 1 0 r
.02 w
.70724 .86623 m
.7035 .77169 L
s
P
p
.2 1 0 r
.02 w
.59489 .63059 m
.59598 .72212 L
s
P
p
.2 1 0 r
.02 w
.48363 .5766 m
.59489 .63059 L
s
P
p
.2 1 0 r
.02 w
.48523 .48812 m
.37015 .42962 L
s
P
p
0 .4 1 r
.02 w
.50545 .48504 m
.39078 .42635 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.39465 .34095 L
s
P
p
.2 1 0 r
.02 w
.59713 .81827 m
.70724 .86623 L
s
P
p
.2 1 0 r
.02 w
.59598 .72212 m
.59713 .81827 L
s
P
p
.2 1 0 r
.02 w
.48194 .66955 m
.48363 .5766 L
s
P
p
.2 1 0 r
.02 w
.37015 .42962 m
.24801 .36753 L
s
P
p
0 .4 1 r
.02 w
.39078 .42635 m
.26907 .36406 L
s
P
p
0 .4 1 r
.02 w
.15022 .21045 m
.2761 .27766 L
s
P
p
.2 1 0 r
.02 w
.36075 .61368 m
.48194 .66955 L
s
P
p
.2 1 0 r
.02 w
.36557 .51931 m
.36075 .61368 L
s
P
p
.2 1 0 r
.02 w
.24008 .45841 m
.36557 .51931 L
s
P
p
.2 1 0 r
.02 w
.24801 .36753 m
.24008 .45841 L
s
P
p
0 .4 1 r
.02 w
.26907 .36406 m
.13964 .29782 L
s
P
p
0 .4 1 r
.02 w
.26168 .45501 m
.26907 .36406 L
s
P
p
0 .4 1 r
.02 w
.13964 .29782 m
.15022 .21045 L
s
P
p
0 .4 1 r
.02 w
.1285 .38993 m
.26168 .45501 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.430451 0.424812 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.451366 2.00297 0.0247151 0.988603 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8869 .6339 m
.80642 .58904 L
s
P
p
.2 1 0 r
.02 w
.89326 .70947 m
.8869 .6339 L
s
P
p
.2 1 0 r
.02 w
.80165 .51543 m
.71891 .46769 L
s
P
p
.2 1 0 r
.02 w
.80642 .58904 m
.80165 .51543 L
s
P
p
.2 1 0 r
.02 w
.81137 .6655 m
.89326 .70947 L
s
P
p
.2 1 0 r
.02 w
.71891 .46769 m
.72219 .54209 L
s
P
p
.2 1 0 r
.02 w
.63074 .34541 m
.54173 .29238 L
s
P
p
.2 1 0 r
.02 w
.63231 .41772 m
.63074 .34541 L
s
P
p
.2 1 0 r
.02 w
.72559 .61944 m
.81137 .6655 L
s
P
p
.2 1 0 r
.02 w
.72219 .54209 m
.63394 .4929 L
s
P
p
.2 1 0 r
.02 w
.63394 .4929 m
.63231 .41772 L
s
P
p
.2 1 0 r
.02 w
.54173 .29238 m
.54156 .36536 L
s
P
p
.2 1 0 r
.02 w
.81652 .74497 m
.72914 .69991 L
s
P
p
.2 1 0 r
.02 w
.82188 .82764 m
.81652 .74497 L
s
P
p
.2 1 0 r
.02 w
.72914 .69991 m
.72559 .61944 L
s
P
p
.2 1 0 r
.02 w
.54156 .36536 m
.44636 .31043 L
s
P
p
0 .4 1 r
.02 w
.55869 .36245 m
.46378 .30738 L
s
P
p
0 .4 1 r
.02 w
.55886 .43845 m
.55869 .36245 L
s
P
p
0 .4 1 r
.02 w
.46551 .23371 m
.46378 .30738 L
s
P
p
0 .4 1 r
.02 w
.36792 .17524 m
.46551 .23371 L
s
P
p
.2 1 0 r
.02 w
.73283 .78369 m
.82188 .82764 L
s
P
p
.2 1 0 r
.02 w
.54138 .44132 m
.5412 .52043 L
s
P
p
.2 1 0 r
.02 w
.44419 .38714 m
.54138 .44132 L
s
P
p
0 .4 1 r
.02 w
.46198 .38413 m
.55886 .43845 L
s
P
p
0 .4 1 r
.02 w
.55886 .43845 m
.55904 .51761 L
s
P
p
.01 w
.44636 .31043 Mdot
P
p
.2 1 0 r
.02 w
.44636 .31043 m
.44419 .38714 L
s
P
p
.01 w
.46378 .30738 Mdot
P
p
0 .4 1 r
.02 w
.46378 .30738 m
.46198 .38413 L
s
P
p
0 .4 1 r
.02 w
.36409 .24953 m
.36792 .17524 L
s
P
p
0 .4 1 r
.02 w
.36792 .17524 m
.26538 .1138 L
s
P
p
.2 1 0 r
.02 w
.73667 .87101 m
.73283 .78369 L
s
P
p
.2 1 0 r
.02 w
.63741 .6526 m
.63926 .73752 L
s
P
p
.2 1 0 r
.02 w
.54101 .60289 m
.63741 .6526 L
s
P
p
.2 1 0 r
.02 w
.5412 .52043 m
.44193 .46712 L
s
P
p
0 .4 1 r
.02 w
.55904 .51761 m
.46009 .46416 L
s
P
p
0 .4 1 r
.02 w
.25926 .1887 m
.36409 .24953 L
s
P
p
.2 1 0 r
.02 w
.64118 .82609 m
.73667 .87101 L
s
P
p
0 .4 1 r
.02 w
.26538 .1138 m
.25926 .1887 L
s
P
p
.2 1 0 r
.02 w
.63926 .73752 m
.64118 .82609 L
s
P
p
.2 1 0 r
.02 w
.54082 .68894 m
.54101 .60289 L
s
P
p
.2 1 0 r
.02 w
.44193 .46712 m
.33746 .41102 L
s
P
p
0 .4 1 r
.02 w
.46009 .46416 m
.35594 .4079 L
s
P
p
0 .4 1 r
.02 w
.45813 .54767 m
.46009 .46416 L
s
P
p
0 .4 1 r
.02 w
.14886 .12464 m
.25926 .1887 L
s
P
p
.2 1 0 r
.02 w
.43712 .63776 m
.54082 .68894 L
s
P
p
.2 1 0 r
.02 w
.43958 .55058 m
.43712 .63776 L
s
P
p
.2 1 0 r
.02 w
.3327 .49546 m
.43958 .55058 L
s
P
p
0 .4 1 r
.02 w
.3516 .49239 m
.45813 .54767 L
s
P
p
.2 1 0 r
.02 w
.33746 .41102 m
.3327 .49546 L
s
P
p
0 .4 1 r
.02 w
.35594 .4079 m
.3516 .49239 L
s
P
p
0 .4 1 r
.02 w
.25286 .26689 m
.13979 .2035 L
s
P
p
0 .4 1 r
.02 w
.24617 .3486 m
.25286 .26689 L
s
P
p
0 .4 1 r
.02 w
.13979 .2035 m
.14886 .12464 L
s
P
p
0 .4 1 r
.02 w
.3516 .49239 m
.23918 .43407 L
s
P
p
0 .4 1 r
.02 w
.13031 .28601 m
.24617 .3486 L
s
P
p
0 .4 1 r
.02 w
.23918 .43407 m
.24617 .3486 L
s
P
p
0 .4 1 r
.02 w
.13979 .2035 m
.13031 .28601 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.430451 0.562657 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.562 .50716 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56233 .60132 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.430451 0.700501 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.498191 2.097 0.0245059 0.980236 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87882 .61174 m
.78846 .56381 L
s
P
p
.2 1 0 r
.02 w
.88591 .6918 m
.87882 .61174 L
s
P
p
.2 1 0 r
.02 w
.7834 .48613 m
.69015 .43471 L
s
P
p
.2 1 0 r
.02 w
.78846 .56381 m
.7834 .48613 L
s
P
p
.2 1 0 r
.02 w
.79374 .64494 m
.88591 .6918 L
s
P
p
.2 1 0 r
.02 w
.69015 .43471 m
.69327 .51333 L
s
P
p
.2 1 0 r
.02 w
.59099 .30448 m
.48962 .24655 L
s
P
p
.2 1 0 r
.02 w
.5919 .38054 m
.59099 .30448 L
s
P
p
0 .4 1 r
.02 w
.60949 .30142 m
.50847 .24332 L
s
P
p
0 .4 1 r
.02 w
.61082 .37752 m
.60949 .30142 L
s
P
p
.2 1 0 r
.02 w
.69652 .59553 m
.79374 .64494 L
s
P
p
0 .4 1 r
.02 w
.81278 .64233 m
.71594 .59277 L
s
P
p
0 .4 1 r
.02 w
.81874 .72721 m
.81278 .64233 L
s
P
p
.2 1 0 r
.02 w
.69327 .51333 m
.59285 .46007 L
s
P
p
0 .4 1 r
.02 w
.71225 .51052 m
.61221 .4571 L
s
P
p
0 .4 1 r
.02 w
.71594 .59277 m
.71225 .51052 L
s
P
p
.2 1 0 r
.02 w
.59285 .46007 m
.5919 .38054 L
s
P
p
0 .4 1 r
.02 w
.61221 .4571 m
.61082 .37752 L
s
P
p
.2 1 0 r
.02 w
.48962 .24655 m
.48822 .32337 L
s
P
p
0 .4 1 r
.02 w
.50847 .24332 m
.50751 .32019 L
s
P
p
.2 1 0 r
.02 w
.79926 .72975 m
.69993 .68156 L
s
P
p
.2 1 0 r
.02 w
.80503 .8185 m
.79926 .72975 L
s
P
p
0 .4 1 r
.02 w
.71981 .67887 m
.81874 .72721 L
s
P
p
.2 1 0 r
.02 w
.69993 .68156 m
.69652 .59553 L
s
P
p
0 .4 1 r
.02 w
.61366 .54042 m
.61221 .4571 L
s
P
p
.2 1 0 r
.02 w
.48822 .32337 m
.37867 .26297 L
s
P
p
0 .4 1 r
.02 w
.50751 .32019 m
.39834 .2596 L
s
P
p
.2 1 0 r
.02 w
.7035 .77169 m
.80503 .8185 L
s
P
p
0 .4 1 r
.02 w
.61518 .62774 m
.71981 .67887 L
s
P
p
.2 1 0 r
.02 w
.48676 .40381 m
.48523 .48812 L
s
P
p
.2 1 0 r
.02 w
.37451 .34428 m
.48676 .40381 L
s
P
p
0 .4 1 r
.02 w
.5065 .40067 m
.39465 .34095 L
s
P
p
.01 w
.37867 .26297 Mdot
P
p
.2 1 0 r
.02 w
.37867 .26297 m
.37451 .34428 L
s
P
p
.01 w
.39834 .2596 Mdot
P
p
0 .4 1 r
.02 w
.39834 .2596 m
.39465 .34095 L
s
P
p
.2 1 0 r
.02 w
.70724 .86623 m
.7035 .77169 L
s
P
p
.2 1 0 r
.02 w
.59489 .63059 m
.59598 .72212 L
s
P
p
.2 1 0 r
.02 w
.48363 .5766 m
.59489 .63059 L
s
P
p
0 .4 1 r
.02 w
.50434 .57358 m
.61518 .62774 L
s
P
p
0 .4 1 r
.02 w
.61677 .71936 m
.61518 .62774 L
s
P
p
.2 1 0 r
.02 w
.48523 .48812 m
.37015 .42962 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.2761 .27766 L
s
P
p
.2 1 0 r
.02 w
.59713 .81827 m
.70724 .86623 L
s
P
p
.2 1 0 r
.02 w
.59598 .72212 m
.59713 .81827 L
s
P
p
0 .4 1 r
.02 w
.50317 .66661 m
.61677 .71936 L
s
P
p
.2 1 0 r
.02 w
.48194 .66955 m
.48363 .5766 L
s
P
p
.2 1 0 r
.02 w
.37015 .42962 m
.24801 .36753 L
s
P
p
0 .4 1 r
.02 w
.39078 .42635 m
.38672 .51611 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.15022 .21045 L
s
P
p
.2 1 0 r
.02 w
.36075 .61368 m
.48194 .66955 L
s
P
p
0 .4 1 r
.02 w
.50195 .76448 m
.50317 .66661 L
s
P
p
.2 1 0 r
.02 w
.36557 .51931 m
.36075 .61368 L
s
P
p
.2 1 0 r
.02 w
.24008 .45841 m
.36557 .51931 L
s
P
p
0 .4 1 r
.02 w
.38672 .51611 m
.38244 .61055 L
s
P
p
0 .4 1 r
.02 w
.26168 .45501 m
.38672 .51611 L
s
P
p
.2 1 0 r
.02 w
.24801 .36753 m
.24008 .45841 L
s
P
p
0 .4 1 r
.02 w
.26907 .36406 m
.26168 .45501 L
s
P
p
0 .4 1 r
.02 w
.13964 .29782 m
.26907 .36406 L
s
P
p
0 .4 1 r
.02 w
.15022 .21045 m
.13964 .29782 L
s
P
p
0 .4 1 r
.02 w
.37793 .71007 m
.50195 .76448 L
s
P
p
0 .4 1 r
.02 w
.38244 .61055 m
.37793 .71007 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.430451 0.838346 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.430451 0.97619 0.555764 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.508603 2.11798 0.0244683 0.978733 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87797 .58565 m
.79963 .54405 L
s
P
p
.2 1 0 r
.02 w
.8841 .65383 m
.87797 .58565 L
s
P
p
.2 1 0 r
.02 w
.79504 .47764 m
.71453 .43343 L
s
P
p
.2 1 0 r
.02 w
.79963 .54405 m
.79504 .47764 L
s
P
p
.2 1 0 r
.02 w
.80441 .613 m
.8841 .65383 L
s
P
p
.2 1 0 r
.02 w
.71453 .43343 m
.71768 .50052 L
s
P
p
.2 1 0 r
.02 w
.62878 .32198 m
.54223 .27296 L
s
P
p
.2 1 0 r
.02 w
.63029 .38718 m
.62878 .32198 L
s
P
p
0 .4 1 r
.02 w
.64484 .31939 m
.55855 .27024 L
s
P
p
0 .4 1 r
.02 w
.64667 .38461 m
.64484 .31939 L
s
P
p
.2 1 0 r
.02 w
.72096 .57024 m
.80441 .613 L
s
P
p
.2 1 0 r
.02 w
.71768 .50052 m
.63187 .45494 L
s
P
p
.2 1 0 r
.02 w
.63187 .45494 m
.63029 .38718 L
s
P
p
0 .4 1 r
.02 w
.64857 .45241 m
.64667 .38461 L
s
P
p
.2 1 0 r
.02 w
.54223 .27296 m
.54207 .33874 L
s
P
p
0 .4 1 r
.02 w
.55855 .27024 m
.55872 .33605 L
s
P
p
.2 1 0 r
.02 w
.80936 .68464 m
.72437 .64275 L
s
P
p
.2 1 0 r
.02 w
.81452 .75913 m
.80936 .68464 L
s
P
p
0 .4 1 r
.02 w
.82616 .68242 m
.74146 .64042 L
s
P
p
0 .4 1 r
.02 w
.83166 .75697 m
.82616 .68242 L
s
P
p
.2 1 0 r
.02 w
.72437 .64275 m
.72096 .57024 L
s
P
p
0 .4 1 r
.02 w
.73771 .56787 m
.65054 .52294 L
s
P
p
0 .4 1 r
.02 w
.74146 .64042 m
.73771 .56787 L
s
P
p
0 .4 1 r
.02 w
.65054 .52294 m
.64857 .45241 L
s
P
p
.2 1 0 r
.02 w
.54207 .33874 m
.44955 .28794 L
s
P
p
0 .4 1 r
.02 w
.55872 .33605 m
.46649 .28512 L
s
P
p
.2 1 0 r
.02 w
.72792 .71821 m
.81452 .75913 L
s
P
p
0 .4 1 r
.02 w
.74536 .71594 m
.83166 .75697 L
s
P
p
.2 1 0 r
.02 w
.5419 .40716 m
.54172 .4784 L
s
P
p
.2 1 0 r
.02 w
.44747 .35701 m
.5419 .40716 L
s
P
p
.01 w
.44955 .28794 Mdot
P
p
.2 1 0 r
.02 w
.44955 .28794 m
.44747 .35701 L
s
P
p
.01 w
.46649 .28512 Mdot
P
p
0 .4 1 r
.02 w
.46649 .28512 m
.46475 .35422 L
s
P
p
.2 1 0 r
.02 w
.73162 .79682 m
.72792 .71821 L
s
P
p
0 .4 1 r
.02 w
.65473 .67284 m
.74536 .71594 L
s
P
p
.2 1 0 r
.02 w
.63521 .5988 m
.63698 .67523 L
s
P
p
.2 1 0 r
.02 w
.54154 .55263 m
.63521 .5988 L
s
P
p
.2 1 0 r
.02 w
.54172 .4784 m
.4453 .42899 L
s
P
p
0 .4 1 r
.02 w
.46475 .35422 m
.36583 .30138 L
s
P
p
.2 1 0 r
.02 w
.63883 .75494 m
.73162 .79682 L
s
P
p
.2 1 0 r
.02 w
.63698 .67523 m
.63883 .75494 L
s
P
p
0 .4 1 r
.02 w
.55943 .62753 m
.65473 .67284 L
s
P
p
.2 1 0 r
.02 w
.54135 .63005 m
.54154 .55263 L
s
P
p
.2 1 0 r
.02 w
.4453 .42899 m
.34387 .37702 L
s
P
p
0 .4 1 r
.02 w
.36583 .30138 m
.26174 .24577 L
s
P
p
.2 1 0 r
.02 w
.44067 .58247 m
.54135 .63005 L
s
P
p
0 .4 1 r
.02 w
.55963 .7084 m
.55943 .62753 L
s
P
p
.2 1 0 r
.02 w
.44304 .50408 m
.44067 .58247 L
s
P
p
.2 1 0 r
.02 w
.33931 .45295 m
.44304 .50408 L
s
P
p
.2 1 0 r
.02 w
.34387 .37702 m
.33931 .45295 L
s
P
p
0 .4 1 r
.02 w
.26174 .24577 m
.15207 .18719 L
s
P
p
0 .4 1 r
.02 w
.45703 .6618 m
.55963 .7084 L
s
P
p
0 .4 1 r
.02 w
.35765 .4501 m
.35329 .52952 L
s
P
p
0 .4 1 r
.02 w
.2486 .39603 m
.35765 .4501 L
s
P
p
0 .4 1 r
.02 w
.25532 .31923 m
.2486 .39603 L
s
P
p
0 .4 1 r
.02 w
.14296 .26132 m
.25532 .31923 L
s
P
p
0 .4 1 r
.02 w
.15207 .18719 m
.14296 .26132 L
s
P
p
0 .4 1 r
.02 w
.45488 .74757 m
.45703 .6618 L
s
P
p
0 .4 1 r
.02 w
.35329 .52952 m
.34872 .61261 L
s
P
p
0 .4 1 r
.02 w
.34394 .69965 m
.45488 .74757 L
s
P
p
0 .4 1 r
.02 w
.34872 .61261 m
.34394 .69965 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
p
% Start of sub-graphic
p
0.0238095 0.568296 0.149123 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.7867 .53145 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.89777 .66825 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56304 .80672 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.15169 .31032 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.139 .40899 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.161654 0.568296 0.286967 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.380258 1.86028 0.0250076 1.0003 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.89873 .67009 m
.8327 .63026 L
s
P
p
.2 1 0 r
.02 w
.904 .73799 m
.89873 .67009 L
s
P
p
.2 1 0 r
.02 w
.82848 .56377 m
.76097 .52188 L
s
P
p
.2 1 0 r
.02 w
.8327 .63026 m
.82848 .56377 L
s
P
p
.2 1 0 r
.02 w
.83706 .6988 m
.904 .73799 L
s
P
p
.2 1 0 r
.02 w
.76097 .52188 m
.76423 .58896 L
s
P
p
.2 1 0 r
.02 w
.6888 .41283 m
.61721 .36721 L
s
P
p
.2 1 0 r
.02 w
.69095 .47843 m
.6888 .41283 L
s
P
p
.2 1 0 r
.02 w
.76759 .65814 m
.83706 .6988 L
s
P
p
.2 1 0 r
.02 w
.76423 .58896 m
.69317 .54609 L
s
P
p
.2 1 0 r
.02 w
.69317 .54609 m
.69095 .47843 L
s
P
p
.2 1 0 r
.02 w
.61721 .36721 m
.61827 .43334 L
s
P
p
.2 1 0 r
.02 w
.84155 .76949 m
.77106 .72953 L
s
P
p
.2 1 0 r
.02 w
.84618 .84242 m
.84155 .76949 L
s
P
p
.2 1 0 r
.02 w
.77106 .72953 m
.76759 .65814 L
s
P
p
.2 1 0 r
.02 w
.61827 .43334 m
.54279 .3865 L
s
P
p
.2 1 0 r
.02 w
.77464 .80324 m
.84618 .84242 L
s
P
p
.2 1 0 r
.02 w
.61937 .50158 m
.6205 .57205 L
s
P
p
.2 1 0 r
.02 w
.54268 .45532 m
.61937 .50158 L
s
P
p
.01 w
.54279 .3865 Mdot
P
p
.2 1 0 r
.02 w
.54279 .3865 m
.54268 .45532 L
s
P
p
.01 w
.55698 .38391 Mdot
P
p
0 .4 1 r
.02 w
.5571 .45276 m
.55698 .38391 L
s
P
p
0 .4 1 r
.02 w
.47987 .26796 m
.39984 .21672 L
s
P
p
0 .4 1 r
.02 w
.47872 .33513 m
.47987 .26796 L
s
P
p
.2 1 0 r
.02 w
.77834 .87937 m
.77464 .80324 L
s
P
p
.2 1 0 r
.02 w
.69782 .68802 m
.70027 .7625 L
s
P
p
.2 1 0 r
.02 w
.62167 .64485 m
.69782 .68802 L
s
P
p
.2 1 0 r
.02 w
.6205 .57205 m
.54256 .52642 L
s
P
p
0 .4 1 r
.02 w
.63496 .56962 m
.55722 .5239 L
s
P
p
0 .4 1 r
.02 w
.63637 .64246 m
.63496 .56962 L
s
P
p
0 .4 1 r
.02 w
.55722 .5239 m
.5571 .45276 L
s
P
p
0 .4 1 r
.02 w
.5571 .45276 m
.47754 .40454 L
s
P
p
0 .4 1 r
.02 w
.47754 .40454 m
.47872 .33513 L
s
P
p
.2 1 0 r
.02 w
.70279 .83947 m
.77834 .87937 L
s
P
p
0 .4 1 r
.02 w
.39984 .21672 m
.39732 .28439 L
s
P
p
.2 1 0 r
.02 w
.70027 .7625 m
.70279 .83947 L
s
P
p
.2 1 0 r
.02 w
.62288 .72011 m
.62167 .64485 L
s
P
p
0 .4 1 r
.02 w
.55734 .59744 m
.63637 .64246 L
s
P
p
.2 1 0 r
.02 w
.54256 .52642 m
.46144 .47894 L
s
P
p
0 .4 1 r
.02 w
.39732 .28439 m
.31258 .23156 L
s
P
p
.2 1 0 r
.02 w
.54231 .67597 m
.62288 .72011 L
s
P
p
.2 1 0 r
.02 w
.54244 .59993 m
.54231 .67597 L
s
P
p
.2 1 0 r
.02 w
.45991 .55315 m
.54244 .59993 L
s
P
p
0 .4 1 r
.02 w
.47504 .55056 m
.55734 .59744 L
s
P
p
.2 1 0 r
.02 w
.46144 .47894 m
.45991 .55315 L
s
P
p
0 .4 1 r
.02 w
.31258 .23156 m
.30845 .30207 L
s
P
p
0 .4 1 r
.02 w
.22428 .17652 m
.31258 .23156 L
s
P
p
0 .4 1 r
.02 w
.55747 .67352 m
.47372 .62742 L
s
P
p
0 .4 1 r
.02 w
.47372 .62742 m
.47504 .55056 L
s
P
p
0 .4 1 r
.02 w
.30845 .30207 m
.2185 .24755 L
s
P
p
0 .4 1 r
.02 w
.38636 .57933 m
.47372 .62742 L
s
P
p
0 .4 1 r
.02 w
.2185 .24755 m
.12463 .19066 L
s
P
p
0 .4 1 r
.02 w
.38337 .65981 m
.38636 .57933 L
s
P
p
0 .4 1 r
.02 w
.29975 .45071 m
.29515 .52912 L
s
P
p
0 .4 1 r
.02 w
.20629 .39747 m
.29975 .45071 L
s
P
p
0 .4 1 r
.02 w
.2125 .32116 m
.20629 .39747 L
s
P
p
0 .4 1 r
.02 w
.11676 .26485 m
.2125 .32116 L
s
P
p
0 .4 1 r
.02 w
.12463 .19066 m
.11676 .26485 L
s
P
p
0 .4 1 r
.02 w
.29039 .61047 m
.38337 .65981 L
s
P
p
0 .4 1 r
.02 w
.29515 .52912 m
.29039 .61047 L
s
P
p
0 .4 1 r
.02 w
.19984 .47665 m
.20629 .39747 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.299499 0.568296 0.424812 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.564051 2.22952 0.0242196 0.968782 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.67113 .36663 m
.6732 .42081 L
s
P
p
0 .4 1 r
.02 w
.59643 .32711 m
.67113 .36663 L
s
P
p
.2 1 0 r
.02 w
.88595 .69985 m
.81527 .66701 L
s
P
p
.2 1 0 r
.02 w
.89172 .76008 m
.88595 .69985 L
s
P
p
.2 1 0 r
.02 w
.81077 .60816 m
.73828 .57329 L
s
P
p
.2 1 0 r
.02 w
.81527 .66701 m
.81077 .60816 L
s
P
p
0 .4 1 r
.02 w
.6732 .42081 m
.67533 .47687 L
s
P
p
0 .4 1 r
.02 w
.59723 .38173 m
.59643 .32711 L
s
P
p
.2 1 0 r
.02 w
.81992 .72794 m
.89172 .76008 L
s
P
p
.2 1 0 r
.02 w
.73828 .57329 m
.74159 .63278 L
s
P
p
.2 1 0 r
.02 w
.66076 .47892 m
.58326 .44043 L
s
P
p
.2 1 0 r
.02 w
.66271 .53694 m
.66076 .47892 L
s
P
p
0 .4 1 r
.02 w
.67533 .47687 m
.59806 .4383 L
s
P
p
0 .4 1 r
.02 w
.518 .34097 m
.59723 .38173 L
s
P
p
0 .4 1 r
.02 w
.51858 .28591 m
.518 .34097 L
s
P
p
0 .4 1 r
.02 w
.43738 .24295 m
.51858 .28591 L
s
P
p
.2 1 0 r
.02 w
.74502 .6944 m
.81992 .72794 L
s
P
p
0 .4 1 r
.02 w
.43937 .18942 m
.43738 .24295 L
s
P
p
0 .4 1 r
.02 w
.35617 .14422 m
.43937 .18942 L
s
P
p
.2 1 0 r
.02 w
.74159 .63278 m
.66473 .59706 L
s
P
p
.2 1 0 r
.02 w
.66473 .59706 m
.66271 .53694 L
s
P
p
.2 1 0 r
.02 w
.58326 .44043 m
.58385 .49902 L
s
P
p
0 .4 1 r
.02 w
.59806 .4383 m
.59891 .49691 L
s
P
p
.2 1 0 r
.02 w
.82474 .79104 m
.74858 .75828 L
s
P
p
.2 1 0 r
.02 w
.82974 .85645 m
.82474 .79104 L
s
P
p
.2 1 0 r
.02 w
.74858 .75828 m
.74502 .6944 L
s
P
p
0 .4 1 r
.02 w
.26929 .09702 m
.35617 .14422 L
s
P
p
.2 1 0 r
.02 w
.58385 .49902 m
.50149 .4594 L
s
P
p
0 .4 1 r
.02 w
.59891 .49691 m
.51679 .45721 L
s
P
p
.2 1 0 r
.02 w
.75227 .82454 m
.82974 .85645 L
s
P
p
0 .4 1 r
.02 w
.3526 .19809 m
.26402 .15122 L
s
P
p
0 .4 1 r
.02 w
.3489 .25398 m
.3526 .19809 L
s
P
p
0 .4 1 r
.02 w
.26402 .15122 m
.26929 .09702 L
s
P
p
.2 1 0 r
.02 w
.58446 .55976 m
.5851 .62279 L
s
P
p
.2 1 0 r
.02 w
.50056 .52078 m
.58446 .55976 L
s
P
p
0 .4 1 r
.02 w
.5998 .5577 m
.60073 .62076 L
s
P
p
0 .4 1 r
.02 w
.51615 .51862 m
.5998 .5577 L
s
P
p
.01 w
.50149 .4594 Mdot
P
p
.2 1 0 r
.02 w
.50149 .4594 m
.50056 .52078 L
s
P
p
.01 w
.51679 .45721 Mdot
P
p
0 .4 1 r
.02 w
.51679 .45721 m
.51615 .51862 L
s
P
p
.2 1 0 r
.02 w
.7561 .89332 m
.75227 .82454 L
s
P
p
0 .4 1 r
.02 w
.25854 .20749 m
.3489 .25398 L
s
P
p
.2 1 0 r
.02 w
.66899 .72405 m
.67125 .79117 L
s
P
p
.2 1 0 r
.02 w
.58575 .68824 m
.66899 .72405 L
s
P
p
.2 1 0 r
.02 w
.5851 .62279 m
.4996 .58451 L
s
P
p
0 .4 1 r
.02 w
.60073 .62076 m
.51549 .58239 L
s
P
p
.2 1 0 r
.02 w
.67359 .86091 m
.7561 .89332 L
s
P
p
.2 1 0 r
.02 w
.67125 .79117 m
.67359 .86091 L
s
P
p
0 .4 1 r
.02 w
.25285 .26595 m
.25854 .20749 L
s
P
p
.2 1 0 r
.02 w
.58644 .75624 m
.58575 .68824 L
s
P
p
.2 1 0 r
.02 w
.4996 .58451 m
.41007 .54443 L
s
P
p
0 .4 1 r
.02 w
.51549 .58239 m
.42621 .5422 L
s
P
p
0 .4 1 r
.02 w
.42862 .47773 m
.33693 .43489 L
s
P
p
0 .4 1 r
.02 w
.42621 .5422 m
.42862 .47773 L
s
P
p
0 .4 1 r
.02 w
.34108 .37225 m
.24694 .32673 L
s
P
p
0 .4 1 r
.02 w
.33693 .43489 m
.34108 .37225 L
s
P
p
0 .4 1 r
.02 w
.15623 .21771 m
.25285 .26595 L
s
P
p
.2 1 0 r
.02 w
.49756 .71963 m
.58644 .75624 L
s
P
p
.2 1 0 r
.02 w
.4986 .65075 m
.49756 .71963 L
s
P
p
.2 1 0 r
.02 w
.40724 .61145 m
.4986 .65075 L
s
P
p
.2 1 0 r
.02 w
.41007 .54443 m
.40724 .61145 L
s
P
p
0 .4 1 r
.02 w
.24694 .32673 m
.24079 .38998 L
s
P
p
0 .4 1 r
.02 w
.14821 .279 m
.15623 .21771 L
s
P
p
0 .4 1 r
.02 w
.24079 .38998 m
.13985 .34283 L
s
P
p
0 .4 1 r
.02 w
.13985 .34283 m
.14821 .279 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.437343 0.568296 0.562657 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.5614 .33371 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.67449 .39326 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.575188 0.568296 0.700501 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.7867 .53145 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.89777 .66825 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56304 .80672 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.15169 .31032 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.139 .40899 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.713033 0.568296 0.838346 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.559341 2.21998 0.0242236 0.968945 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.88673 .5597 m
.79942 .51531 L
s
P
p
0 .4 1 r
.02 w
.89392 .63143 m
.88673 .5597 L
s
P
p
0 .4 1 r
.02 w
.79419 .44573 m
.70412 .39819 L
s
P
p
0 .4 1 r
.02 w
.79942 .51531 m
.79419 .44573 L
s
P
p
0 .4 1 r
.02 w
.80489 .58796 m
.89392 .63143 L
s
P
p
.2 1 0 r
.02 w
.78139 .51778 m
.68912 .47117 L
s
P
p
.2 1 0 r
.02 w
.78644 .59037 m
.78139 .51778 L
s
P
p
.2 1 0 r
.02 w
.68613 .40083 m
.59093 .35091 L
s
P
p
.2 1 0 r
.02 w
.68912 .47117 m
.68613 .40083 L
s
P
p
0 .4 1 r
.02 w
.70412 .39819 m
.7075 .46857 L
s
P
p
.2 1 0 r
.02 w
.69223 .54467 m
.78644 .59037 L
s
P
p
0 .4 1 r
.02 w
.71104 .54213 m
.80489 .58796 L
s
P
p
0 .4 1 r
.02 w
.7075 .46857 m
.61058 .41929 L
s
P
p
.2 1 0 r
.02 w
.59093 .35091 m
.59184 .42203 L
s
P
p
.2 1 0 r
.02 w
.49187 .22959 m
.3883 .17339 L
s
P
p
.2 1 0 r
.02 w
.49053 .29827 m
.49187 .22959 L
s
P
p
0 .4 1 r
.02 w
.51013 .22662 m
.40691 .17026 L
s
P
p
0 .4 1 r
.02 w
.50921 .29534 m
.51013 .22662 L
s
P
p
.2 1 0 r
.02 w
.59279 .49644 m
.69223 .54467 L
s
P
p
0 .4 1 r
.02 w
.71474 .61907 m
.71104 .54213 L
s
P
p
.2 1 0 r
.02 w
.59184 .42203 m
.48913 .37015 L
s
P
p
0 .4 1 r
.02 w
.61058 .41929 m
.50824 .36726 L
s
P
p
.2 1 0 r
.02 w
.48913 .37015 m
.49053 .29827 L
s
P
p
0 .4 1 r
.02 w
.50824 .36726 m
.50921 .29534 L
s
P
p
.2 1 0 r
.02 w
.3883 .17339 m
.38451 .24268 L
s
P
p
0 .4 1 r
.02 w
.40691 .17026 m
.40355 .23958 L
s
P
p
0 .4 1 r
.02 w
.81656 .74325 m
.71861 .69966 L
s
P
p
0 .4 1 r
.02 w
.82281 .82637 m
.81656 .74325 L
s
P
p
.2 1 0 r
.02 w
.6955 .62156 m
.59379 .57437 L
s
P
p
.2 1 0 r
.02 w
.69891 .70208 m
.6955 .62156 L
s
P
p
0 .4 1 r
.02 w
.71861 .69966 m
.71474 .61907 L
s
P
p
.2 1 0 r
.02 w
.59379 .57437 m
.59279 .49644 L
s
P
p
.2 1 0 r
.02 w
.38451 .24268 m
.27237 .18389 L
s
P
p
0 .4 1 r
.02 w
.40355 .23958 m
.29178 .1806 L
s
P
p
0 .4 1 r
.02 w
.72268 .78413 m
.82281 .82637 L
s
P
p
.2 1 0 r
.02 w
.59484 .65609 m
.69891 .70208 L
s
P
p
.2 1 0 r
.02 w
.38053 .31529 m
.37637 .39146 L
s
P
p
.2 1 0 r
.02 w
.26551 .25719 m
.38053 .31529 L
s
P
p
0 .4 1 r
.02 w
.40002 .31223 m
.39633 .38845 L
s
P
p
0 .4 1 r
.02 w
.2854 .25395 m
.40002 .31223 L
s
P
p
.01 w
.27237 .18389 Mdot
P
p
.2 1 0 r
.02 w
.27237 .18389 m
.26551 .25719 L
s
P
p
.01 w
.29178 .1806 Mdot
P
p
0 .4 1 r
.02 w
.29178 .1806 m
.2854 .25395 L
s
P
p
0 .4 1 r
.02 w
.72694 .8728 m
.72268 .78413 L
s
P
p
.2 1 0 r
.02 w
.59594 .74187 m
.59484 .65609 L
s
P
p
0 .4 1 r
.02 w
.61495 .65352 m
.61655 .73938 L
s
P
p
0 .4 1 r
.02 w
.50506 .60461 m
.61495 .65352 L
s
P
p
.2 1 0 r
.02 w
.48613 .52442 m
.48452 .60734 L
s
P
p
.2 1 0 r
.02 w
.37199 .47146 m
.48613 .52442 L
s
P
p
.2 1 0 r
.02 w
.37637 .39146 m
.25832 .3342 L
s
P
p
0 .4 1 r
.02 w
.39633 .38845 m
.39244 .4685 L
s
P
p
0 .4 1 r
.02 w
.61824 .82962 m
.72694 .8728 L
s
P
p
.2 1 0 r
.02 w
.48283 .69451 m
.59594 .74187 L
s
P
p
0 .4 1 r
.02 w
.61655 .73938 m
.61824 .82962 L
s
P
p
.2 1 0 r
.02 w
.48452 .60734 m
.48283 .69451 L
s
P
p
0 .4 1 r
.02 w
.38836 .55268 m
.50506 .60461 L
s
P
p
.2 1 0 r
.02 w
.36738 .55557 m
.37199 .47146 L
s
P
p
0 .4 1 r
.02 w
.39244 .4685 m
.27163 .41205 L
s
P
p
.2 1 0 r
.02 w
.25832 .3342 m
.13289 .27337 L
s
P
p
.2 1 0 r
.02 w
.24277 .50051 m
.36738 .55557 L
s
P
p
0 .4 1 r
.02 w
.38406 .64132 m
.38836 .55268 L
s
P
p
.2 1 0 r
.02 w
.25075 .4152 m
.24277 .50051 L
s
P
p
.2 1 0 r
.02 w
.12173 .35534 m
.25075 .4152 L
s
P
p
0 .4 1 r
.02 w
.27163 .41205 m
.14306 .35198 L
s
P
p
.2 1 0 r
.02 w
.13289 .27337 m
.12173 .35534 L
s
P
p
0 .4 1 r
.02 w
.25636 .58746 m
.38406 .64132 L
s
P
p
0 .4 1 r
.02 w
.2642 .49742 m
.25636 .58746 L
s
P
p
0 .4 1 r
.02 w
.13185 .43852 m
.2642 .49742 L
s
P
p
0 .4 1 r
.02 w
.14306 .35198 m
.13185 .43852 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.850877 0.568296 0.97619 0.693609 MathSubStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.758303 2.5909 0.0163524 0.959656 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
0 .4 1 r
.02 w
.65693 .26414 m
.65922 .32981 L
s
P
p
0 .4 1 r
.02 w
.5475 .21345 m
.65693 .26414 L
s
P
p
0 .4 1 r
.02 w
.65922 .32981 m
.5477 .27966 L
s
P
p
0 .4 1 r
.02 w
.5477 .27966 m
.5475 .21345 L
s
P
p
.2 1 0 r
.02 w
.86547 .63433 m
.75767 .59089 L
s
P
p
.2 1 0 r
.02 w
.87194 .70928 m
.86547 .63433 L
s
P
p
.2 1 0 r
.02 w
.75339 .51794 m
.64249 .47155 L
s
P
p
.2 1 0 r
.02 w
.75767 .59089 m
.75339 .51794 L
s
P
p
0 .4 1 r
.02 w
.5477 .27966 m
.43082 .22711 L
s
P
p
.2 1 0 r
.02 w
.76212 .66678 m
.87194 .70928 L
s
P
p
.2 1 0 r
.02 w
.64249 .47155 m
.64463 .54533 L
s
P
p
0 .4 1 r
.02 w
.66408 .46898 m
.66666 .5428 L
s
P
p
0 .4 1 r
.02 w
.54813 .4202 m
.66408 .46898 L
s
P
p
.2 1 0 r
.02 w
.52639 .35127 m
.40675 .29947 L
s
P
p
.2 1 0 r
.02 w
.52617 .4229 m
.52639 .35127 L
s
P
p
0 .4 1 r
.02 w
.54792 .34853 m
.42864 .29659 L
s
P
p
0 .4 1 r
.02 w
.54813 .4202 m
.54792 .34853 L
s
P
p
0 .4 1 r
.02 w
.43082 .22711 m
.42864 .29659 L
s
P
p
0 .4 1 r
.02 w
.31278 .10471 m
.30817 .17196 L
s
P
p
0 .4 1 r
.02 w
.1867 .04631 m
.31278 .10471 L
s
P
p
.2 1 0 r
.02 w
.64685 .62217 m
.76212 .66678 L
s
P
p
.2 1 0 r
.02 w
.64463 .54533 m
.52594 .49751 L
s
P
p
0 .4 1 r
.02 w
.66666 .5428 m
.54836 .49485 L
s
P
p
.2 1 0 r
.02 w
.52594 .49751 m
.52617 .4229 L
s
P
p
0 .4 1 r
.02 w
.54836 .49485 m
.54813 .4202 L
s
P
p
.2 1 0 r
.02 w
.40675 .29947 m
.40403 .37181 L
s
P
p
0 .4 1 r
.02 w
.42864 .29659 m
.42637 .36897 L
s
P
p
0 .4 1 r
.02 w
.30336 .24203 m
.42864 .29659 L
s
P
p
0 .4 1 r
.02 w
.30817 .17196 m
.30336 .24203 L
s
P
p
0 .4 1 r
.02 w
.30817 .17196 m
.17931 .11402 L
s
P
p
.2 1 0 r
.02 w
.76676 .7458 m
.64917 .70225 L
s
P
p
.2 1 0 r
.02 w
.77159 .82814 m
.76676 .7458 L
s
P
p
0 .4 1 r
.02 w
.17931 .11402 m
.1867 .04631 L
s
P
p
.2 1 0 r
.02 w
.64917 .70225 m
.64685 .62217 L
s
P
p
.2 1 0 r
.02 w
.40403 .37181 m
.27561 .31809 L
s
P
p
0 .4 1 r
.02 w
.42637 .36897 m
.29835 .31511 L
s
P
p
.2 1 0 r
.02 w
.65159 .78579 m
.77159 .82814 L
s
P
p
.2 1 0 r
.02 w
.40119 .44724 m
.39823 .52595 L
s
P
p
.2 1 0 r
.02 w
.26989 .39433 m
.40119 .44724 L
s
P
p
.01 w
.27561 .31809 Mdot
P
p
.2 1 0 r
.02 w
.27561 .31809 m
.26989 .39433 L
s
P
p
.01 w
.29835 .31511 Mdot
P
p
0 .4 1 r
.02 w
.16357 .2584 m
.29835 .31511 L
s
P
p
0 .4 1 r
.02 w
.29835 .31511 m
.29312 .39138 L
s
P
p
.2 1 0 r
.02 w
.65411 .87301 m
.65159 .78579 L
s
P
p
.2 1 0 r
.02 w
.52546 .65643 m
.5252 .74118 L
s
P
p
.2 1 0 r
.02 w
.39514 .60817 m
.52546 .65643 L
s
P
p
.2 1 0 r
.02 w
.39823 .52595 m
.26391 .47397 L
s
P
p
0 .4 1 r
.02 w
.29312 .39138 m
.15517 .33546 L
s
P
p
0 .4 1 r
.02 w
.15517 .33546 m
.16357 .2584 L
s
P
p
.2 1 0 r
.02 w
.52493 .82976 m
.65411 .87301 L
s
P
p
.2 1 0 r
.02 w
.5252 .74118 m
.52493 .82976 L
s
P
p
.2 1 0 r
.02 w
.3919 .69413 m
.39514 .60817 L
s
P
p
.2 1 0 r
.02 w
.26391 .47397 m
.12219 .41912 L
s
P
p
.2 1 0 r
.02 w
.25112 .64444 m
.3919 .69413 L
s
P
p
.2 1 0 r
.02 w
.25766 .55725 m
.25112 .64444 L
s
P
p
.2 1 0 r
.02 w
.11243 .50347 m
.25766 .55725 L
s
P
p
.2 1 0 r
.02 w
.12219 .41912 m
.11243 .50347 L
s
P
p
P
p
P
MathSubEnd
P
% End of sub-graphic
P
P
MathSubEnd
P
% End of sub-graphic
p
/Times-Italic findfont 18 scalefont setfont
[(Fractals)] .02381 .57389 -1 0 Mshowa
P
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{413, 256},
  ImageMargins->{{33, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006M000100P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0WP00003nbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2b`2L
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0@000?nkWK/100000?k;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`;;09bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000ok^M^`400000o/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0//0W;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40003o^ifk
0@00003nbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/2b`2L^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
0@000?nkWK/100000?k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;;09bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l/10000ok^M^`400000o/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0//0W;_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kb`40003o^ifk0@00003nbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2b`2L^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0@00042k0/Ko^e^k0@000012bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJk0lH0o[_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;0[/0El^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000@;/00lJk^`02^`03a[^k0?nk
EK/10000043;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0/H0E<^kblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;60?k;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;;
00Bkbk_;0@0004:k1<I@^`04a[_6a_nk0k/1000007G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00/H0:K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_6^l^ka[_;^l^k00;607k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;a_nkbiD2aP1jbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000AK/00lJk^`06^`;67k/00iG6aP02^`03
ULJk00;67;/00lJk^`02^`03ULK600:k00>Ea[/00/HQ^`03ULK600:k0YE?^`03a[_600?600>Ea/H0
N;/1000004[;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_6bk_;^`;600C;^lJk0lH07k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^EaYD00/H00iG6U@02U@0La/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?600G;^iG6U@02aP03
ULJE00:E02C6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^EaYD2aP03UK^E00:E02Jkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`;602NkULK6^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^iG6bk/00YD01<JkbiD2aP1fbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40000o^`?60k/2aP>k00?6^lH00/H4^`03a[^k01Vk
00FEa[^kU@02aP>k00>Ea[/07;/4aP:k00>Ea/H00k/00iG6^`0N^`06ULJk^iG61;/00iFk^`0R^`07
ULJkaYG6U@02aQfk00>Ea/H00[/01IFk^k^E00:k0/Id^`400000@/^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^`?600>kblH00lH00k_;
^`02aP0Pbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiD2aP0Ybk^Ea/^kbiG6^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD00/H00k_;U@02aP0Ybk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^Ea[_;^iD00/H07[_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;600Vkbk_;
^l^kULH00YD2aP0Lbk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;U@;600G;^l^kU@03aP1lbk_;UL^k
bk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40
000o^`03a[^k00:k00>Ea/H00[/00iG6aP04^`C65K/00iG6aP05^`03ULK600Fk00>Ea[/06;/2U@Fk
00O6ULK6^lJk00C66K/00iG6aP04^`03aYFE00Bk0lHK^`03a[_600;61;/01YG6^k^EaP:k00>Ea[/0
5[/00iG6U@03aPBk00FEa[^kU@04^`03a[^k076k0@00000obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;600Jkbk^EaYD4aP0QULK6bk_;
^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJE00;602S;^l^kbiG6^l^kbiG6^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^iFk0YD01l^kblK;^iD00/H08K_;^iG6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6
U@02aP0/bk_6^l^Ebk_;^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kbiD2aP0Ybk_;aYFk
bk_;^iG6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^iD00/H0Ok_;ULJkbiG;^l^ka[_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@00046k1<H3^`:E
00G6^k^kaP0J^`05ULJk^iD00/H4^`03ULJk00:k00>Ea[/06;/019Fk^k/2U@03^lJk00:k00>Ea/H0
0[/00iG6^`0H^`05ULJk^iD00lH3^`03UK^k00:k00>Ea[/06K/2aP:k00>E^iD00lH2^`03UK^k00:k
00>Ea[/05[/00lJE^`04^`04ULK6aP>k00JE^k^kULIc^`400000L<^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kaYG;^l^Ebk_;^lJk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^l^kbiD2aP0<bk^Ea/^kbiG6^l^k0/H06l^kbk_;^l^k
bk_;^l^kbk_;^l^Ebk_;^l^kU@02aP05^l^Ea[/01<H0Al^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6
bk_;^l^Ea[_;^iFkbk_;ULJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?602O;^l^kaYG;^iFk
bk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a//00iD02L^kbk_;a/^kb`02U@04^l^EaP:E076kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000?[/2U@Jk
0YD6^`;66;/00iG6aP06^`03ULK600;60k/029G6a[^Ea[_64[/2U@Jk00?6ULH00lH3^`04ULK6^`:E
5;/00iG6^`06^`:E00>kUK/00k/019G6a[/2UAZk00>Ea[/01;/3U@>k00BEa/Jk0YDC^`03a[^k00:k
00>E^k/02;/3U@;600Bka/K66k/2aPBk0/H2^`?60[/3aT6k0@000010bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^`:E00k;^l^kbk^E^l^k
bk_6^`?601Rkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD2aP06^l^kbk_;0YD01<K;^l/2U@04^lJEaP:E
01C6bk_;^l^kbk_;^l^kbk_;^l^kb`:E00Nkbk_;a/^k00:E0/H02<^kULK;aYFk0iD04k_;^l^kbk_;
^l^kbk_;^l^kblH00YD01l^kbk_;^l/00YD01;_;^l/2U@04^lJEb`>E01W;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_600:E00Vkbk_;^iFkbk/00iD2aP0D^iFkbk_;^l^kbk_;^l^kbk_;^l/2aP0C^l^kUK_;
^l^kbk_;^l^kbiG;^`02aP0Fbk_6a/^kbk_;^l^kbk_;^l^kbk_;aP:E00C;^l^k0/H01<_6bk/2aP03
blK;00;600Bka/K;0lH0@<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/10000?[/01IFk^k^E00Jk00>E^k/00[/01/Jk^k^EaQRk00>Ea/H0
1K/00iFk^`04^`:E0/H3^`03a[^k01:k0YD00k_6^`03^`03ULJk00;600JkaYFEaYD3^`03UK^k00nk
00?6^k/00YD6^`03UK^k00Bk0YD00lJE^`02^`03UK^k01Bk00G6^k^kU@0;^`:E0/H00iFk^`0A^`?6
00BE^k^k0YD;^`05ULJk^lH04;/01IG6UK^E00>k0/H01;_6a[/2aP06^lK6^lJk0/H2^`;6@;/10000
04?;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;UL^kbk_;00>E00S;^l^Ebk_;^`;600C;^iG60YD0A<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6
bk_;^l^kbk_;^l^kbk_6^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E0lH01k_;^lJkbk/00/H0;/^k
blK;^l^Ebk_;^l^kbk_;^l^kbk_;^l_6bk_;^iFkbk_;^l^kbk_;^l^kbk/2aP0Ibk^E^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`02aP0_^l^Ebk_;^l^kbk_;^l^kbk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6
^l^kUK/00YD01L^kbk_;00:E02:kbk_;UL_6bk_;^l^kbk_;^l^kbk_;UL^ka[^E^l^kblK;0lH00l_6
b`04aP06^lK6a[_;1<H0?K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/00@0003fk0iD6^`BE1[/4aP:k00>E^k/05K/00iG6^`0A^`03ULJk01Bk
00BE^k^k1<H4^`;60[/01LJk^k^E016k0/H3^`03UK^k00nk0lHH^`;600>E^k/03K/00iG6^`0C^`03
ULJk00:k00FE^k^kU@04^`04UK^EU@>k00>Ea/H03K/4U@03a[^E00>E00>ka[/00/H01;_6a[/2aP03
^lK600;600>ka[/00k/00lJk^`0k^`400000@<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3U@0b^l^kbk_;UL^kbk_;^l^kULK;^iFkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk_;^iD2aP0<^l^kbk_;^l^kbk^E0/H08[_;^l^kbk_;^l^kbk_;
^l^kbk_;UL^kbk_;ULJkbk_;^l/4aP0F^l^EUK_;^l^kbk_;^l^kbk_;^l^kb`;600NkUK_;^l^k00:E
02c;^l^kbk_;^l^kbk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^`>E00Fkbk_;^`02U@03
bk_600:E01Bkbk_;^l^kbk_;^l^kbk_;^l^kaPBE00bkbk_;UL^kbiG;^l/2U@04^iFkb`;6016kbk_;
^l^kbk_;^l^kUK_6^`02aP:E00?;a/H00/H00k_;aP03aP03^lJk00C600?;^lH00/H0?K_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004>k
00>E^k/04K/00iFk^`0D^`03ULJk00>k00>EaYD00/H5^`03ULK600>k00>Ea/H04[/00iFk^`03^`04
UK^EU@Jk00>Ea[/00k/2UA:k0/H5^`04UK^EU@Jk0YD3^`03aYFE01Nk00>Ea/H00[/00iFk^`02U@>k
00FE^iFEaP02^`03UK^k012k00G6^k^kU@02aP:k00BE^k^k0YD4^`>E0k/00lJk^`0:^`>E0/H00iG6
U@02U@04^lK6^`;60[/4aP03^lK600G6?[/1000005O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l/0
0YD05[_;^l^kbk_;^l^kbk_;^l^kbk_;^iD3aP0?bk^Ea/^kULK;^l^kULJE00;601Jkbk^Ea/^kbk_;
^l^kbk_;^l^kbk_;0iD03l^kbiG;^l^Ebk_;^l^Eb`02U@0H^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk^E
0lH03/^kUK_;^iFkbk_;^iFk0YD07/_6bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;U@?6026kbk^E
^l^kUK_;^iG6biG;^l^kbk_;^l^kbk_;^l^kbk/00/H01L^kblK;00?600G;^l^kb`02U@0K^l^kbiG;
^l_6bk_;^l^kbk_;^l^kbk^E^lJE00?600>Ebk/01LH01K_6a/^k00;604C;^l^ka[_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`400013^`03
UK^k00:k0iD7^`:E1K/2UAJk00>Ea/H00/H3^`03ULJk00:k00FEa[^kU@02aP03^iG601Bk19D4^`03
UK^k00:k00BE^k^k0YD2^`03UK^k01>k00BEa/K61;/00iFk^`02^`06UK^k^iG60[/00iFk^`0I^`05
ULJk^iD00k/00iG6aP03^`;65;/4aP>k00>Ea[/01K/00iG6aP05^`03a[^k00jk00FE^k_6^`04aPBk
0/H4^`03a[^k04:k0@000013bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02U@06^l^kUK_;0iD01/^kbk^E^`>E02jkbk_;UL^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk_;ULJkbk^Ea/^kbk^E0lH09l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;UL^kbk^E^l^kbiG;^l^kb`03U@0Xbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^l^Ebk_;^iFk
bk_;aP>E02Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kUK_;^l_6U@;602VkbiG6^l^kbk_;
^l^kbk_;^l^kbk_;^l^kblK;^l^Ea[_;^l^kbiG6^`02aP0Cbk_;a/^kbk_;^l^kbk_;^l^kb`05U@1D
bk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004Fk19D5^`05UK^k^iD01;/2U@:k00>E^k/06k/00iG6
^`02^`03ULK600Fk00>Ea[/06k/00iFk^`02^`:E1[/00iFk^`0G^`05a[^k^iD01;/00iG6aP02^`04
a[^kUAbk00C6^k^E1;/01<Jk^iD2aP03^lJk01Vk00BEa[^k0iD00k^EaP03^`;600>ka[/04;/00iFk
^`1D^`400000D/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^iFkbk/2U@05bk_;^l/00iD09L^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;ULJkbk_;^iD00/H0:;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^iFkbk_;^l/2U@0Z^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kbiG;^l^kblJE0lH0;L^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk^E^l^kULK;^iFkb`02aP0Q^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^Ea[_;UL^k00:E0/H01<^kbk/2aP1Xbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/10000C[/00iFk^`03^`>E1;/00iFk^`0K^`03ULJk00Jk00>Ea[/0
7k/00iFk^`06^`03UK^k01Zk00?6^k/00[/00iFk^`03^`05a[^kULH07k/01<Jk^iD3^`03ULJE00:E
0k/00lJk^`0I^`04aYFEU@Jk0/H3^`03a[^k06Jk0@00003:bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^k
bk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^kbk_;^iG6bk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;6
037;^l^Ebk_;^l_6bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk^E00;609fkULK;
^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_;UL^kbk_;^l^ka[_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040001>^`03UK^k00Jk00>E^k/07k/00iG6
^`02^`06ULK6^iG68;/00iFk^`02^`:E0[/00iFk^`0L^`;600>kUK/00k/01IG6^k^E022k00K6^k^k
aYD3aR:k00?6^k/02K/00lJk^`1Y^`400000D/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk/4U@0[biG;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ea[_;^iG6U@03aP0Wbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk^E^l^kbiG;00BE01nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;6
00K;^l^kULH4U@0Obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03aP0XblK;^iG6bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?600Fkbk_;^`03aP1]^lJkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000C[/2U@:k00BE^k^k0YDQ^`03ULK600:k
00>Ea[/00[/00lJk^`0N^`:E0k/00iFk^`02^`03UK^k01jk00>Ea/H00[/00iG6^`02^`03UK^k022k
0/HY^`?60[/00lJk^`02aV^k0@00001@bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/4U@0Xbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;U@C602K;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`BE02S;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E1<H0E<^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?606nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/00@0005>k00>E^k/0:;/00iG6^`0X^`03UK^k02Rk00>Ea[/0EK/00lJk
^`1]^`400000o/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0//0W;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kb`40003o^ifk0@00003nbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2b`2L^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;0@000?nkWK/100000?k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;;09bkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l/10000ok^M^`400000o/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0//0W;_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40003o^ifk0@00003nbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2b`2L
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0@000?nkWK/100000?k;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`;;09bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000ok^M^`400000o/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0//0W;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40001`^`;6
ok/[^`400000L/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_6^`?60?jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`:k02O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00@00072k00?6^k/00[/00lJk^`0X^`;6Z[/2aTjk0@00001:bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^Ea_nkbk/2U@1?
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ea[_;^iG6bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kU@02aP05^l^Ea[/00/H08/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbiD2aP0Ybk^EUL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD00/H0:K_;
UIFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E00;602W;^iFEbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kU@02aP05^l^Ea[/00/H0C<^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000
A;/019G6UID2^`04UK^EUB6k00NEaYFE^iG600>E8K/00iG6U@02aP03ULJE00:E00?6^k/07[/00iG6
U@02aP03UK^E00:E8K/00iG6U@02aP03UK^E00:E8K/00iG6U@02aP03UK^E00:E8K/00iG6U@02aP03
ULJE00:E00?6^k/0BK/1000004S;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk/2U@0Ybk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbiG6^l/00YD0:/K;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E
a/^kU@;60:Zkbk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ea[_;ULJkbk_;UL^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^iG6bk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbiG6^l^Ea[_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^Ea/^kU@;6
00Bkbk^E0/H0BK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004Bk00>Ea[/00[/00iFk^`02^`03UK^k01jk00>Ea[/0
0[/00iG6^`02^`03UK^k01jk00>Ea/H00[/00iG6^`02^`03ULJk01jk00>Ea[/00[/00iG6aP02^`03
UK^k01jk00>Ea/H00[/00iG6^`02^`03UK^k01jk00>Ea/H00[/00iG6^`02^`03UK^k01jk00>Ea[/0
0[/00iG6^`02^`03ULJk00;6Ak/1000003k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`:E00K;^l^kblH2U@0Qbk_;^l^kUK_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00:E00Jkbk_;^lH2U@0R^l_6bk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kU@;600Jkbk_;^iD2aP0P^l^kbk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2U@06^l^kbk_6
0YD01;_;^l/3aP0Jbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2U@07bk_;^l^kU@02aP0P^lJkbk^E
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2U@07^l^kbk_;U@02aP0PblK;^l^Ebk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/2U@06bk_;^l_60YD02l^kbk_;^iG6bk_;00;604Fkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0003jk
00BE^iFE0k/01<Jk^iD5^`03UK^k01Rk00BE^iFE0k/01/Jk^iFkaP>k00>Ea/H06;/00iG6U@02aPFk
00>Ea[/00k/00iG6^`0H^`04UK^EU@>k00C6^k^E1K/00iG6^`0H^`04UK^EU@Jk00>Ea/H00k/00iG6
aP0H^`04UK^EU@Jk00>Ea/H00k/00iG6aP0H^`04UK^EU@>k00C6^k^E1K/00iG6aP04^`03a[^k04:k
0@000012bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk^E^l^k0YD0:L_6bk_;UL^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;00:E
00Jka[_;^iD2aP05^l^Ea[/00/H06l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^Ea/^kU@02aP0X^l^kbiG6
^l^kULK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kb`:E00Jka[_;^iD2aP0Q^l^Ea[_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk^E^l^k00:E00K;^l^kbiD2aP05bk^Ea//00/H06[_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^Ebk_;0YD01[_;^l^kU@;600FkbiG6^`02aP0Jbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFk
bk/2U@06blK;^l^E0/H01L^kULK;00;604Nkbk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000?K/00iFk^`04^`03ULJk00:k
00>E^k/00[/00iFk^`0G^`03UK^k00Bk00>Ea/H00[/00iFk^`04aP>k0/HC^`03ULJk00Bk00>Ea/H0
0[/00iG6^`02^`03ULJk00:k0/HC^`03UK^k00Bk00>Ea/H00[/00iG6^`04aQRk00>E^k/01;/00iG6
aP02^`03ULJk00C60k/00lJk^`0B^`03UK^k00Bk00>Ea/H00[/00iG6^`04aP>k00?6^k/04[/00iFk
^`04^`03ULK600:k00>Ea[/01<H3^`05a[^k^lH0@[/1000003g;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00:E00Nkbk_;^l_600:E00_;UL^k
bk^E^l^kb`02U@0D^l^kbk_;^l^kbk_;^l^kbk_;^iD2aP07^l^kbk_;U@03aP08^l^kbiG6^l/2U@0E
^lJkbk_;^l^kbk_;^l^kbk_;^l^E00;600O;^l^kbk^E00C600Bkbk^E0/H05k^Ea/_6bk_;^l^kbk_;
^l^kbk_;^l^k00:E00S;^l^kbk_;U@C600C;^l^E0/H05l^EUK_;^l^kbk_;^l^kbk_;^l^kbk_;00:E
00Rkbk_;^l_6U@C600Bkbk^E0/H05k^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^k00:E00S;^l^kbk_6U@C6
00C;^l^E0/H05l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;00:E00Rkbk_;^l_6U@C600Bkbk^E0/H0BK^E
a/^kblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00@0003nk0YD4^`03a[^k00:E1;/2U@>k00BE^iFE4[/01<JEa/H6^`:E00C6^k^k
0YD2^`05UK^EULH04k/00iG6aP06^`:E00C6^k^k0YD01;_6ULH2U@03a[^k016k0YD7^`:E00[6^k^k
ULJkaYFk0iDC^`:E1;/00lJk^`02U@;60[/01YG6^lJEaP>E4k/2U@Bk00?6^k/00YD2aP:k00JEa[_6
ULH3UA>k0YD4^`03a[^k00:E0/H2^`06ULJkaYG60iD00lJk^`10^`400000@L^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00:E00fka[_;
^l^Ebk_;^l^k00BE01W;^l^Ebk_;^l^kbk_;^l^kbk_;^l_6bk^E00;600bkbk_;^iG6bk_;^l/4U@03
^l^k00;601C;^l^kbk_;^l^kbk_;^l^kbk_;U@;600c;^l^kbiG;^l^kbk/2U@;601S;^l_6bk_;^l^k
bk_;^l^kbk_;^l^kbk/2U@0=bk_;^l^kUK_;^l^kaP02U@0JaYFkbk^E^l^kbk_;^l^kbk_;^l^kbk_;
^l/2U@09^lJkbk_;ULJk00;600C;aYFE0/H06<^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^`:E00W;a/^k
bk^Ea//00/H01;_6UID2aP0H^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;0YD02K_6^l^kbiG;^`02aP04
blJEU@;604K;^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^k0@0004>k00>Ea[/03K/01IFk^k^E016k00?6^k/00[/019G6a/H3^`03
a[^k00Jk0/H2^`04UK_6aQ>k00>Ea[/03K/01LJk^k_601Jk00>E^k/02K/01LJk^k_600>k00>E^k/0
5;/019G6a/H3^`04a[^k^`;60k/01LJk^k^E01Jk00BEa/K60k/01<Jk^k/2aP>k00G6^k^kU@0F^`04
ULK6aPNk0/H3^`;60[/019Fka/Ho^`400000JL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbiG;^l^k
bk_;^l^kbk_;^l^kb`02aP07^l^kUK_;^`04aP0:bk_;^l^kbk_6^`?6072kbk_6^l^kbk_;^l^kbk_;
^l^kbk_;ULJkbk_;^l^kbk_;^l^kbk_;^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;
^lJkbk_6^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;1<H01;_;^l/2aP0Q^l^kbk_;UL^kbk_;
^l^kbk_;^l^kbk_;^l^kbk^E^l^k00C600C;^l^k0/H08L^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;UL^kb`03aP05bk_;^l/00/H01;_;a//3aP12bk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004>k00>Ea[/00k/2U@bk0YDB^`;6
00>kUK/01;/00iG6^`08^`04a[^kU@;600>ka[/04K/00iG6^`03^`03ULK600^k00>Ea/H05;/00iFk
^`03^`:E1;/00lJk^`02^`03a[^k00:E5K/00iFk^`03^`03ULJk00>k00?6^lH00/H3^`:E5K/00iFk
^`03^`03ULJk00>k00?6^lH00/H3^`:E5K/00iFk^`03^`03ULJk00>k00?6^lH00/H3^`05ULK6^lH0
?[/1000004_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;ULJkbk_;UL/00YD01[_;^l^kb`:E00Bkbk_;0YD04[_;^l^kbk_;^l^kbk_;
^l^kb`;600Nkbk_;^iFk00:E00O;^l^kbk^E00;600Bkbk^E0lH06/^kbk_;^l^kbk_;^l^kbk_;ULJk
bk_;ULJE0/H01/^kbk_;U@;600C;^l^E0/H06/^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^iFk0YD03<^k
a[_;^iG6bk_;^`:E01_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;UL/00YD03;_;a/^kbiG6^l^kb`:E
01^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kUK/00YD03<^ka[_;^iG6bk_;^`:E01_;^l^kbk_;^l^k
bk_;^l^kbk_;UL^kbk_;ULH00YD01[_;a/^kb`;600Fkbk_6U@03aP0m^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000@k/00iG6U@03^`05
UK^k^iD01K/019FkUID4^`03UK^k012k00BEa/K60[/01IFk^k^E00Fk00>E^iD00/H3^`03ULJk012k
00BEa/K60[/01YG6^k^EaPBk00>EaYD00/H3^`03ULJk012k0iD3^`07UK^k^iFkaP03^`04ULJEU@Bk
00>E^k/04;/3U@>k00NE^k^kUK_600>k00BEaYFE1;/00iFk^`0@^`>E0k/01iFk^k^E^lH00k/019G6
UID4^`03UK^k012k0iD3^`07ULJk^iFkaP03^`03a[_600?60[/00iG6^`0l^`400000A/^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/4U@0=bk_;^iFkbk_;UL^kb`02U@0I^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;U@03aP05^l^kbiD0
0/H08L^kUK_;^iG6bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kU@04aP0=^l^kULK;^l^Ea[_;U@02aP0G
biG6^l^kbk_;^l^kbk_;^l^kbk_;^l/019D01K_;^l^E00;600O;^iG6bk^E00;601NkUK_;^l^kbk_;
^l^kbk_;^l^kbk_;^`04U@05bk_;^iD00/H01[_;ULJkb`:E01RkbiG;^l^kbk_;^l^kbk_;^l^kbk_;
^l/4U@05^l^kbiD00/H01/^kULK;^`:E01S;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk/4U@05a[_;^iD0
0/H0BK_;a/^kbiG6^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/00@0004Vk00>E^k/00[/00iFk^`02^`03UK^k00>k0iDH^`03ULK600:k
00>Ea[/00lH4^`04aYFEUARk00>Ea[/00[/00iG6^`02^`03ULJk00>k00BEa/K65k/00iFk^`02^`03
UK^k00C60k/01<JEa/HH^`03UK^k00:k00>E^k/01<H4^`>E6;/00iFk^`02^`03UK^k00C61;/3UARk
00>Ea/H00[/00iFk^`04aPBk0iD00lJk^`0k^`400000Dl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;00:E
02:kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;1<H0;k_;^iG6bk_;a/^kUK_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^l^E00;602W;^l^kbiG6^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbiG;^l^kU@02aP1g^l_6bk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbiG6
^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk^Ea/^kbk_;^iFkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/00lH0Bk_;^l^Ea[_;^l^kbiG6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000C[/00iFk^`04^`:E8[/00iG6
^`03^`05aYFE^lH08;/00iG6^`04^`03ULK6026k00>E^k/00k/00lJEaP02aP>k00?6^k/06[/00iFk
^`04^`:E8[/00iFk^`04^`:E8[/00iG6aP03^`03aYFE00Fk00?6^k/0>k/100000?k;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk^E^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;a/^k
ULK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk_;^l^kbiG6^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l_6bk^Ea/^kblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
UK_;^`;;05>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^`02aP05^lJkbiD00/H0@<^ka[_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000C[/00iFk
^`06^`03UK^k01nk00>E^k/00k/01LJk^iG6022k00>Ea[/01[/00iG6^`0O^`03UK^k00>k00C6^k^E
1;/00lJk^`0J^`03UK^k00Jk00>E^k/07k/00iFk^`06^`03UK^k01nk00>E^k/00[/2aP:k00>Ea[/0
0lHm^`400000Dl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;00:E05FkbiG;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^Ebk_;^iG6bk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;
^l^E00;602W;ULJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kU@02aP0X^iFkbk_;
a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kb`:E02VkbiG;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^Ebk_;^`02U@0Zbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
UK_;^l^E0/H0A<^Ea[_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^k0@0004jk00>E^k/00[/00iFkU@03UB2k00>E^k/00[/00iG6U@02U@03
a[^k01jk00>Ea[/00[/00iG6U@03aR2k00>E^k/00[/00iFkU@02aP05UK^k^lH07;/00iFk^`02^`03
UK^E00>E8;/00iFk^`02^`03UK^E00>E8;/00iFk^`02^`03UK^E00?6@K/1000004k;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/2U@0Ybk_;UL^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD0:[_;
^iG6bk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kU@;602RkbiG6^l^ka[_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0YD02;_;^iFkbk_;1<H07K_6^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^k00:E02W;^l^Ebk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02U@0Y
^l^kUK_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00YD0B/^kbiG;^l^Ea[_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
0@00052k19DW^`BE00G6^k^kaP0R^`03ULK600;69[/4U@Rk0/HM^`BE9k/4UBNk19E6^`400000Ol^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^iD01<H0o[_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0[/06LJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00@0008>k
0/Ko^aRk0@00003nbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2b`2L^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;0@000?nkWK/100000?k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;;09bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l/10000ok^M^`400000o/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0//0W;_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40003o^ifk0@00003nbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2b`2L^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0@000?nkWK/100000?k;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;;
09bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000ok^M^`400000o/^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0//0W;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40000n^`04a[^ka_nk
Fk/10000047;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l_6b`02aP3n^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2^`1Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00@00042k00C6^k_6ok]I^`400000M<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0/H0Zl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`02aP1i^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000@k/2aP04^lK6aR^k00C6^lK68[/00iG6^`02^`:E
Ck/00iG6^`02^`:E:[/00lJkaP02aWJk0@000015bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;00;605FkblK;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^iG600:E00?;UL/00iD0C/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^EaP:E00?;UL/00iD0D/^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^l^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l_obk/2U@1>bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004>k00C6^k_60[/00lJk^`0R^`03
ULK600:k00>EaYD00[/00lJk^`0O^`04ULJk^`:E1;/00iFk^`19^`04ULJk^`:E1;/00iFk^`0N^`03
ULK600:k00>Ea/H00k/00lJk^`0O^`06ULK6^iFk0YE<^`400000@l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00lH01L^kblK;00;6
02Bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^EaYD4aP2Y^iFka[_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk_;UL^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^l^Ebk_;^iFkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6U@02aP03ULJE00C601Vkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^k00;600W;^l^kbk^EaYD00/H01;_;^iD2aP19^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000A[/00lJk
^`03aP03^lJk01nk00>Ea[/00[/01YG6^k^EaQ^k0YD5^`03aYFE00Jk00>E^k/0@k/2U@Jk0YD6^`03
UK^k01jk00FEa[^kU@02aP>k00>Ea/H06;/00lJkaP05^`05ULJk^iD00/H01K^Ea[_604Rk0@00001_
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kblK;a/^ka[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E00;602Fkbk_;
^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFk00:E03k;^l_6bk^E^l^kbk^E^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;aP:E01C;^l^kbk_;^l^kbk_;^l^k
bk^E^`:E02k;^l^kbk^E^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E0/H00l^k
U@02aP05^l^Ea[/00/H07l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^l_6bk_;^iD00/H01;_;^l/3aP1:
bk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/10000B;/2aPBk00?6^lH06;/00iG6aP04^`03ULK600Bk00>Ea/H00[/2aQJk
00BE^k^k0YD00k_6^`02^`03UK^k00:k00>E^k/0;[/01<JE^iDA^`04UK^k^`:E1K/00iFk^`02^`03
UK^k01jk0YD01[_6a[_6^`C60k/2aQBk00C6^k^k0/H4^`03ULK600>k00FEa[^kaP17^`400000CL^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^ka[_;00;601fka/K;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6U@03aP0;^l^kblK;
^l^Ebk/00lH0Dk_6^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kULK;^l^Ebk_;^iFkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00O601VkUK_;^l^kbk_;^l^kbk_;^l^Ebk_;
^l^k00:E02?;^l^Ebk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02U@06^l^kbk_;0iD2aP04
bk_;U@;600C;^lJk0/H04/^kbk_;^l^kbk_;^l^kbk_;^`;600C;^iFk0lH0Dk_;^iG6bk^E^l^ka[_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^k0040001;^`04a[_6^`;600>ka[/05;/00iG6^`03^`03ULK600:k00G6^k^kU@04^`04
a[^kaQ>k0YD6^`05aYFE^iD01;/2U@:k0YDV^`04a[_6U@C60iD>^`:E1k/2U@03^iFk00>k0YD2^`:E
5K/00iFkU@02U@Jk00>Ea/H00[/00iG6^`03aP>k00?6^k/04K/2aPBk00JEa/JkULH2^`06UK^k^lJE
A[/1000006W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^lJka[_;^l^kbk_;^l^kbk_;^l^kbk_;^iD00/H01[_;
^l^kU@?600?;^l/00YD00k_;U@02U@0GblK;^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD01k_;^l_6bk/0
0YD01/^kbk_;^`>E02BkUIFE^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/6aP03^lK600:E
01?;UIFEbk_;^l^kbk_;^l^kbk_;00:E00Nkbk_;^l^k00:E00K;^l^kbk/3U@0K^iFEUK_;^l^kbk_;
^l^kbk_;^l^kUK_;^l^k00>E00Jkbk^E^l/4aP03^l^E00;601o;^lJkbk_;^l^kbk_;^l^kbk_;^l^k
biG6^l^kbk^E00?604k;^iFEbk_6^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000CK/3aP:k00C6oiFE5;/019G6a/H4^`03
ULJk00Bk0iD2^`:E0/HE^`:E00>ka[/00k/00iFk^`06^`:E0k/00iFk^`0K^`?600>ka/H00/H01K_6
aYFk00>E00>kUK/03k/2U@Jk00>E^k/01[/2U@>k00>E^k/03[/3U@Jk19D4^`07ULK6^iG6U@03aQFk
00C6UIFE1;/00iG6^`03^`:E00C6^k^E0/I2^`400000Dl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[_600:E
01VkUK_;^l^kbk_;^l^kbk_;^l^kbk_;^iFk00;605W;^l^kbk_;^l^kbiG;^l^Ebk_6^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbiG6^l^kbk_;^l^kbk_;^l^Ebk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`05aP0:blK6^lJkblJE^`FE03Zkbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;UL^kbiG;
^l^kbk_;^l^kbk_;^l^kbk_;0iD03/^kbk_;^iFkbk_;^lJE0lH07[_;ULJkbk_;^l^kbk_;^l^kbk_;
^l^kbk_6^l^kU@;6056kbk_;^l^kbk^Ea/^Ea[_6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0005:k00G6^iFkU@0F^`03UK^k00;6
3K/019Fk^k/2aQBk00>Ea[/04K/00iFk^`0E^`G600Fka/K6^`02aPNk19DC^`03UK^k016k00>E^k/0
5;/00iFk^`09^`05a[^kULH00[/00iFk^`0D^`;60[/00iG6^`02aPVk0lH2^`03a[^k03jk0@00001B
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?602^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^lJkbk_;
^l^kbk_;^l^E00;600?;^l/00/H06;_;^l^kbk_;^l^kbk_;^l^kbiG6^l^kb`:E00bkbk_;^l^kbk_;
^l/2U@0J^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;a//2aP04^l_6b`;602Bkbk_;^l^kbiG;UL^kbk_;
^l^kbk_;^l^kbk_;^l^Ebk_;^l/2U@0<^l^kbk_;^l^kbk_;0YD08K_;^l^kbk_;^l^kbk_;^l^kbk_;
^iFkbk_;^l^kbk_;^`02aP1dbk_6^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ka[^Ea/^kblK;^l^k
bk_;^l^Ea[_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/10000Ck/3U@:k00>EaYD05[/00iFk^`02^`03ULJk00Jk0YD3^`03aYG600Bk
00?6^k/03k/00iG6^`03^`04UK^EU@Jk0YD4^`:E4[/4aP:k00?6^lH08k/00iFk^`03^`04UK^EU@Jk
0YD4^`:E4k/00iFk^`0;^`?60k/2UANk0/H3^`03ULJk00Fk0/H3^`03UK_6042k0@00001Hbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbiG;^iFkUK^E^`:E01?;^l^kbk_;^l^kbk_;^l^kbk_;00:E00Fkbk^EaP03U@06
^l^kbiG;0YD01;_6^l/2aP0V^l_6bk_;^l^kbk_;^l^kbk_;^l^EaYG;^l^Ebk_;UL^kbk_;UL/2U@0A
^l^kbiG;^l^kbk_;^l^kbk/01/H01L_6a/K;00?602?;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`03U@0?bk_;UL^kbiG;^l^kbiG;00:E01fkbk_;UL^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;
^`02U@0>bk_;^l^kbiG6^l^kbk/2U@0Lbk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJEbk^EaP:E00K;^l^k
a[/2aP03bk^E00;603nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/00@0004nk0YD2^`:E00JkUIFE^iDD^`BE00G6^k^kU@02aP03^iFk00:k
00JEa/JkUK/3aQBk19D4^`03UK^k00:k00BE^k^k0YD2^`03UK^k00bk00?6^k/00/H2^`05a[^k^lH0
9[/4U@Bk00>E^k/00[/019Fk^k/2U@:k00>E^k/04;/2U@Bk00>E^iD00YD4^`03UK^E00:E1;/00iFk
^`0E^`>E00C6^k^E0k/01<Jk^iD2aP04UK^kaSjk0@00001cbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^k
UK_;^iFkUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kU@02aP05^l^Ea[/00/H01/^kbk_;U@;602_;^l_6
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^iFkbk_;UL^kbk_;00>E05?;^l^kbk_;^l^kbk_;^l^k
a[_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk^E^l^k
biG;^l^kb`03U@0Dbk_;^l^kbk_;^l^kbk_;^l^kbk/4U@0>bk_;^l^Ebk_;UL^kbk/2U@0Tbk^E^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk^E^l^k0/H0A/^kbiG6UL^ka[_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000D[/00iFk^`06^`03
UK^k01Nk1<H2^`03ULJE00Fk00>Ea[/07[/00iFk^`02^`:E1[/00iFk^`0>^`04a[^kaSBk00>E^k/0
0[/2U@Jk00>E^k/05K/00iFk^`03^`03UK^k00:k00>E^k/00k/3UAZk00C6^k^E0k/2U@;60k/2aP03
^lJk03bk0@00001Dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFk0YD0:<^kbiG;^iFkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbiG6^l^ka[/2U@;602W;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
UK_;^l^kb`02U@0E^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;603g;a/^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;00:E02Nkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk/00YD09L^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
blK;^iD00/H02[_;^l^Ea[_;^l/2aP0m^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000D[/01IFkUK^E00:k0YD2^`03UK^k01Nk00>E^k/0
0[/01/Jk^iG6^`?67k/00iFk^`06^`03UK^k01Bk00?6^k/0<k/00iFk^`06^`03UK^k01nk00>E^k/0
1;/2UAnk0/H01;^Ea[/2aP:k00>Ea[/01;/00lJk^`0k^`400000Dl^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00:E00JkUK_;UL/3U@3abk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^Ea[_;ULJkbk_6^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^k
bk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_;^iFkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`03aP03bk^E00;604FEa[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0005Bk00FE^k^E^`02U@:k
00>E^k/05k/01YFk^k^EaP>E00?6^k/08K/00iFk^`02^`:E0[/00iFk^`1:^`03UK^k00:k0YD2^`03
UK^k01nk00>E^k/00[/2U@:k00>E^k/07k/01iG6^k^E^iD00/I3^`400000Ml^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbiG;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00:E03:kbiG6^l^Ea[_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^Eb`BE05:kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E
^l^kbiG;19D09k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk^E^`03U@0S^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00iD0Ak_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040001G^`05UK^E^iD0
7K/3U@;60[/00lJk^`0Q^`:E0k/00iFk^`02^`03UK^k04Vk0YD3^`03UK^k00:k00>E^k/07[/2U@>k
00FE^k^kU@0U^`03UK^k04Fk0@00001Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL/00iD08/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk/3aP0U^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^`04U@1Bbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`BE02O;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/019D0LK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040001H^`:E00>kUK/08k/00lJk^`0V^`03UK^k05>k00>E^k/0
:;/00iFk^`1_^`400000o/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0//0W;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`40003o^ifk0@00003nbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2b`2L^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;0@000?nkWK/100000?k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;;09bkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000ok^M^`400000o/^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0//0W;_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40003o^ifk0@00003nbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/2b`2L^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0@000?nkWK/100000?k;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`;;09bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000ok^M^`40
0000VL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02aP3n^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2^`7;
0@0009Fk0/H2^`03a[_60?nk0K/1000009O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;00?6
0?k;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`;;0K/1aP40002D^`03a[^k00:k0/H2^`;6;;/00lJk^`1C^`;67[/2aUVk
0@00001:bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk^Ea_nkbk/2U@0Nbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0/H0:<^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2aP09bk_;^l_6blK;00;602Fkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E00;602?;^iG6bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`02aP0_^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbiD00/H01L^kULK;00;607Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/_6bk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`010000A;/00iG6U@02aP03^iFk00:E7;/01<Jka/HV^`03a[_600;6
0k/2aP>k00?6^k/08K/00iG6U@02aP03ULJE00:E7;/01<Jka/H/^`03ULJE00;600>EaYD00YD00lJk
^`0H^`05a[^k^lH0Ek/1000007C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk^Ea/^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^ka[_;^lJkbk_;U@;605C;UIFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^l^kblK;^l_6
bk_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkbiD2aP0]bk_;UL^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kblK;^l_6bk_;^lKobk^E00;602Fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbiG6^l^E00;601k;^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2aP03bk_;00;6
05Fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00400014^`03ULK600:k00>Ea/H00[/00iFk^`0H^`03
a[^k00>k0/H2^`06ULJEaYFk0YDI^`;60k/00lJk^`05^`03a[^k00:E7k/00iG6aP02^`03ULJk00:k
00>E^k/06;/00lJk^`03^`;60[/01lJka/JEaYD00/HN^`03ULK600:k00>Ea[/00[/00iG6^`0J^`?6
0[/2aP>k00FEa/JkU@03aTRk0@00000nbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2U@07bk_;^l_6U@02aP03^lJk00?601Zkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kb`;600Jkbk_;^l/3aP0Rbk^Ea/^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`;600W;a/^kbk_;^iD00/H00k^E^`02U@0Hbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E0/H01/^k
bk_;U@;6023;a/^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;600K;^l^kbk/3aP03^l^E00;6
01_;^iG6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD01k_;^l^kbiD00/H0:L^kbk_;ULJkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;00;600BkULJE0lH0BYFka[_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0003jk
00BE^iFE0k/01<Jk^iD2aP>k00>Ea[/06[/3aPFk0/H2^`05ULJk^iD07;/2aPJk00>EaYD00/H3^`03
UK^k01Bk00>E^iD00/H5^`03ULK600>k00>Ea/H06[/3aPFk0/H2^`06ULJk^iG65k/019FkUID6^`03
ULJk00>k00>Ea[/07K/00lJk^`03^`?60[/01IG6^iG604Nk0@000012bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^k0YD01/_6bk_;U@;6
02;;^iG6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0/H01L^kbk_;00;604fkbk_;UL^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kbk_;^iG6bk^Ea/^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^Ebk_;U@02aP05bk_;^iD00/H01K_;ULJk00;602;;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6
UK_;^l^k0/H08L^kbk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kb`02U@21^l^kbk^Ea/^kbiG6
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kbk_;^iG6bk_;^l^Ea[_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040
000m^`03UK^k00Bk00>Ea/H00[/00iG6^`04aP>k0YDD^`;60k/01<Jka/H4^`03ULJk00:k00>E^k/0
6k/00lJk^`04^`03ULK600:k00C6^k^E5K/00iFk^`04^`03ULK600:k00>Ea[/01<H2^`03ULJk01Vk
00?6^iD01K/00iG6^`02^`03ULJk01Fk00>E^k/01;/2U@>k00>Ea[/00[/019G6^k/2UAZk0/H00k^E
U@04^`:E0k/00iG6^`16^`400000?L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD02;_;^l^kbk^E1<H08;_;^iG6bk_;UL^Ebk_;^l^kbk_;
^l^kbk_;^l^kbk_;0/H0<;_6^l^Ea[_;^l^Ea[_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6
^l^kU@;600Bkbk^E0lH06<^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^`:E00S;^l^kbk_6U@C600C;^l^E
0/H00l^EaP02U@0m^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;a/^kUK_;^l^kULK;^iG6bk_;^l^kbk_;
^l^kbk_;^l^kbk_;^`02U@07bk_;^l^kb`02U@07^iG6bk_;U@02aP03biG;00:E01fkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kblJE^`02U@1@bk_;^iFkbiG6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000?k/2U@Nk0YD2aP>k
00G6UIFkU@02^`03UK^k01Bk0/H3^`03ULK600:k00FEa[^kU@03^`:E5k/2aP:k00>EaYD00/H3^`05
ULJk^iD05k/2U@Bk00?6^k/00YD2aP>k00G6ULJEaP02^`03UK^k01Bk00>Ea[/00[/00iG6^`02^`06
UK^k^iG60[/2UABk0YD7^`:E00?6^k/00k/00iG6U@03^`03UK^k01Rk00C6^k^k0YD2^`05UK^k^lH0
0[/2UD>k0@000011bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/00YD02K_;^l^kbiG;^`02aP04blK;^`:E027;^l^Ebk_;^l^kbk_;^l^k
bk_;^l^kbk_;ULJkbk_;^iD01<H02;_;UIFkbiG;0YD05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00C6
00?;^iD00/H02;^Ea/^kUK_;0YD05K_;^l^kbk_;^l^kbk_;^l^kbk_;^`02U@09blK;^l^kULK;00;6
00Bka[_;0/H06[_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk^E0/H01;_;^lH4U@04^l^kU@;600>kUK/0
0YD05<^kbk_;^l^kbk_;^l^kbk_;^l^k0YD0=<^kbk_;^iG6bk_;^l^kblJE^l^kUK_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk^Ea/^kbk/3U@1;^l^kaYG;UL^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00400013^`03UK^k00Rk0/H3^`05
UK^k^iD05k/3U@Fk00>Ea[/00k/3U@>k00>E^k/05[/00iG6aP02^`03aYG600;60[/2U@04^iFkUAJk
00BEa/K60k/01<Jk^k/2aP>k0/H2^`03UK^k01Fk00>Ea/H00/H3^`03UK^k00:k00C6ULK60k/00iFk
^`0C^`03UK^k00Bk00?6^k/01[/01LJk^k^E01Zk00?6UID01;/01YFk^k_6^`:E0[/00iFk^`0o^`40
0000Wl^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l_6bk_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFk
bk_;^l^kbk_;^l^Ebk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kU@03aP08bk^Ea/^kbk/2U@0L
bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^`C600C;^l^k0/H01<^kbk/3aP1=^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^Ea[_;^l^kbk_;a/^kULK;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;
a/^kbk/00/H0;<^ka[_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^iFkbk_;^l^k0/H0A/^E
bk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/10000@k/00iFk^`03^`:E3;/2UAVk00>E^k/03[/00iFk^`0I^`03UK_600Vk00BE^k^E
5K/00iFk^`03^`03ULJk00>k00?6^lH00/H3^`03ULJk01Rk00>Ea[/01k/01LJk^k_600:k00>E^k/0
4k/00iFk^`03^`03ULK600>k00?6^lH00lH2^`:E6K/01<Jk^iD9^`;60[/2UD2k0@00001;bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
biG;^l^kbiG;00:E00Jkbk_;^l/2U@04^l^kb`:E02Rkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;
^l^kbk_;^l^kbk_;0YD0Ak_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^l^kbk_;^l^kUK_;
^l^kbk_;^l^kbk_;^l^kbk_;^iFkbk_;^iFk00:E00c;^lJkbk^Ea/^kbk/2U@0Mbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^Ea[_;^l/00/H02K_;^l^kblK;^`02U@0Mbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^k
bk^E^iD01<H02K_;^iG6bk_;^`02U@0Nbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk^E^l^k0iD0BK_;
^l^Ea[_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00@0004>k0iD3^`05UK^k^iD01K/019FkUID4^`03UK^k01Bk00>E^k/00[/2U@Jk
0YD4^`03UK^k01Rk00>E^k/02k/2UABk0iD3^`06UK^k^iFk0/H2^`04ULJEU@Bk00>E^k/05;/00iG6
^`02^`:E00>ka[/00k/00iG6aP03^`03UK^k016k0iD3^`07UK^k^iFkaP03^`04UK^EU@Bk00>E^k/0
4k/01<Jk^k/2U@:k00>E^k/00YD2^`03ULJE00>k00>E^k/0?;/1000004K;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k19D03L^k
bk^E^l^kbiG;^l/00YD06K_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00YD01L^kbiG;00:E00Jkbk_;
UL/2U@0Q^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^k00>E00Bkbk_;0YD00k_;^`02U@0E
bk_;^l^kbk_;^l^kbk_;^l^kbk_;00BE00Nkbk_;ULJk00;600BEa/^k0YD08<^kUK_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^Ea[_;^iFk0YD01lJkbk^E^iD00/H06;_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kb`BE
00fkbk_;UL^kbk^E^l^k00:E01k;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_6^l^kbk/3U@09^l^kUK_;
ULJk00:E043;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0@0004Vk00>E^k/00[/00iFk^`02^`03UK^k00>k0iDH^`BE0k/01IFk^k^E00>k
0YD00k^E^`0H^`:E0[/00iFk^`02U@:k00BE^iFE0k/00iFk^`0E^`03UK^k00:k00>Ea[/00[/2aPBk
0iDG^`03aYFE00:E0k/01IG6a[^E00>k00BEa[^E6;/00iFk^`02^`03UK^k00:k00>E^k/00k/3UAFk
00?6^k/01K/01IG6a/JE00:k00>Ea/H00[/2UCjk0@00001Cbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l/0
0YD0<;_;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;UL^kbiG;^l^kb`>E01[;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`>E00Zkbk^E^l^Ebk_;0YD0B;^E^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbiG6^l^kULK;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6^l^kU@;600BkULK;
0/H01K_;^l_600>E026kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk/00YD08L^kbk_;^iFk
bk_;^l^kbk_;^l^kbk_;^l^kbk_6^l^kb`02aP05^l_6bk/00/H0A/^kbiG6^l^Ebk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000C[/00iFk
^`04^`:E9;/019Fk^k/2U@Jk00>E^k/06[/01IFk^k^E00:k0YD4^`:E7;/00iG6^`04^`:E7;/00lJk
^`02^`03a[_600;60[/01YG6a/JkaP:k00>E^k/06[/00iFk^`04^`:E6[/2aP>k00?6^lH00/H2^`04
UK_6aP:k00>Ea[/0?k/10000087;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^Ebk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l/00YD0:[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk^E^l^kb`:E04Fkbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG;^l^kbk_;
^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00/H03<^kblK;^iG6bk_;^`:E0/H0A<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
1<H02/^kblK;^iFkbiD2aP12ULK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004jk00>E^k/01[/00iFk^`0Q^`03UK^k00Fk00>E^k/0
8[/00iFk^`04^`03UK^k01fk00>E^k/01[/00iFk^`0K^`C60[/00iFk^`05^`03UK^k01jk00>E^k/0
1[/00iFk^`0L^`03a[^k00Bk0YD01;^E^iD2aT2k0@00001Cbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l/0
0YD0:[_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kb`:E05>kbiG;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^Ebk_;^`02U@0Zbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk^E^l^k
0YD0:<^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk/2U@0Zbk^E^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0YD0A<^kblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0004jk00>E^k/00[/00iFk
U@03UB:k00JE^k^kUK/3UBBk00BE^k^k19DO^`03UK^k00:k00>E^iD00iDR^`06UK^k^iFk0iDP^`03
UK^k00:k00>E^iD00iDW^`03UK^k04:k0@00001>bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0YD0:l^kbiG;^l^k
UK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD0:k_;UL^kbiG;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00YD09L^kUK_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00YD0:k_;^iFkbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00YD09l^k
UK_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02U@1e^l^kUK_;^l^Ebk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040001@^`BE:K/4UBVk0iDT^`BE
:K/4UBFk19Ea^`400000o/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0//0W;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`40003o^ifk0@00003nbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2b`2L^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;0@000?nkWK/100000?k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;;09bkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000ok^M^`400000o/^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0//0W;_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40003o^ifk0@00003nbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/2b`2L^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0@000?nkWK/100000?k;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`;;09bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000ok]3^`;6
F;/100000?k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;;04Bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?605Fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k0040002I^`;6Yk/2aP>k00?6^k/0D[/1000009_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l_6b`02aP2W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
0/H0E/_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0009Vk0/H2^`?6Y[/2aUBk0@00001:bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/2aP0Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00/H0<;_;a/Jkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;602jkbk_6^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0/H0:K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^k00;602S;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblKo^l^E0/H0N/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
0@0004Bk00>Ea_l00k/01<JEa/HK^`03a[_600>k00?6^k/00[/2aR>k0/H2^`04a[^kaRBk00>Ea/H0
0[/00iG6^`02aR6k00>Ea/H00[/00iG6^`02aR6k00?6^lH00lH00iG6aP0S^`03a[^k00Jk0/I:^`40
0000Al^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kULJE00;600>ka[/00YD08/Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kblK;^lJk
bk/2aP0Sbk_6^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00lH00l_6b`03aP0Zbk_6a/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJE0/H00iG6U@02U@0Ta/^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kULJE0/H00iG6U@02U@1=a[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk^Ea/^kbiG6^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00/H00k_;
^`02aP04bk_6^`?604Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`010000A;/01IG6^k^E00;60k/00iG6^`0H^`04a[^k^`;6
00>ka[/00/H3^`03a[^k01^k00?6^k/00/H3^`03a[^k00:k00?6^k/08;/01IG6^k^E00;60k/00iG6
^`0N^`05ULJk^iD00/H3^`03ULJk01fk00>Ea/H01[/00iG6^`0K^`?61K/2aP03^lJk00?61;/00lJk
^`14^`400000AL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kU@02aP0X^l^Ea[_;^iG6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6
^l^kb`;605FkblK;^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk_;^l^kbk_;^l^kblK;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E00;600?;^iD00/H09;_;ULJkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kU@;602:kbiG6^l^kULK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
0YD01[_;^l^kU@?602C;^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_6bk/3aP04^l^kb`;6
00>kbk/00/H0B/^kblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0003jk00>Ea/H01K/00iG6aP05^`03ULJk01Zk00?6^k/0
0[/00lJk^`04^`03a[^k01^k00?6^k/02k/00lJk^`0I^`:E1[/01YG6a[_6^`C66K/00iG6aP05^`03
ULK600Fk00>Ea[/06;/00iFkU@02U@Fk00JEa[^kULHL^`03a[^k00:k00>Ea/H00[/00iG6aP04^`C6
A[/10000047;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^iG6U@02aP1A^l^kbk^Ea/^kbk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_6
^l^kbk_;^l^kblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;600?;^l/00/H02;_;^l^kbk_;
0/H07;_6a/Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL/2U@07^l^kbk_;U@02aP04bk_;U@;601_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk^EaYD00/H0:k_;^l^kULK;^l^kULK;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;UL^kbk/00YD09L^kbiG6^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00/H01[_;
^iG6U@C604nEa/K;^l^kblK;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0040000n^`05ULJk^iD00/H4^`03ULJk00:k00>Ea[/0
6k/00lJk^`08^`03a[^k00:k0YDH^`;600Bka[_62K/2aP:k00?6^k/04k/019Fk^k/2U@Fk00>Ea/H0
0[/00iG6^`02aQJk00FEa[^kU@02aPBk00>Ea[/00[/00iG6^`0H^`?61;/3U@05a[^k^iD00/H00k^E
U@0J^`C60k/2U@05a[^kULH0Bk/1000004G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkbk_;^iD00/H03;_;ULJkbk^Ea/^kb`;6072kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;^l^kbk_;a/^Ea[^E^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^ka[_;^lJkbk_;^l^kbk_6^l_6bk_;^l^kbk_;^l^kbk_;^l^kbk^E^l^kbk_;0YD01[_;^iG6b`C6
022kbiG6^l^kbk_;^l^kbk_;^l^kbk_;^l^Ea[_;^l^kU@;600bkbiG6^l^kULK;^iD2aP0G^l^kbk_;
^l^kbk_;^l^kbk_;^l_6biD00lH02k_;^l_6bk_;^l^E00;607C;UIFkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbiG6UL^kbiG;^l^Ea[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40000m^`03ULK600Jk00>Ea/H00/H3^`03
ULK600:k00C6^lK65K/2aPVk0/H019G6UID2^`03UK^k01Zk00?6^k/02[/00lJk^`0B^`:E1k/2U@03
^iG600>k00JEa/JkULH2UA:k00>Ea/H01[/00iG6aP02aP>k00REa/JkULJEaQ>k00?6^k/00[/00iG6
aP02^`03a[^k00Fk00BEa/Jk0lHB^`:E1[/3U@Bk00>Ea/H0B[/10000043;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^E0/H01/^kbk_;^`:E
02C6^l^kbk^Ea/_6bk^Ea/^kbk_;^l^kbk_;^l^kbk_;^l^ka[/2aP09bk_;^l^kbk_;00;6026kUK_;
UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00/H02<^kbk_;^l^k0/H06<_6bk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`:E00O;^l^kbk_;00:E0/H07k_;^lJEaYG6^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbiD0
0/H01/^kbk_;^`:E01o6^l^kbk^EaYG6bk_6^l^kbk_;^l^kbk_;^l^kbk_;00;600Jkbk^E^l/3aP0:
bk_;^l^kbk_;^`;601K;^lK6bk_;^l^kbk_;^l^kbk_;^iFk0YD03/^kbk_;^l^Ebk_;ULJk0lH0Ak_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^k00400011^`03ULK600Fk00>E^k/01[/2aP>k00>Ea[/04[/01LJk^k_600Rk00>Ea[/0
0k/00iFk^`0L^`;60k/4aP03^lK601Rk0YD6^`03UK^k00;600Bka[^k0/H3^`03UK^k01:k00>Ea/H0
1K/00iFk^`06^`;60k/00lJk^`0A^`?600JE^k^kULH;^`05ULJk^lH04;/01IFk^k^E00Jk00JE^k^k
ULH3^`03ULJk04Fk0@00001fbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^kbk_;^l^kbk_;^l_6bk_;ULJkbk_;^l^kbk_;^l^k
bk_;^l^ka[_;^lJkbk_;^`:E05O;^lJEbk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
a[_;a/^ka[_;a/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^kbk_;^l/00/H0Ck_;^lJkbk^E
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^kbk_;^l^kbk_;^l_6bk_;a/^kbk_;^l^kbk_;^l^kbk_;
^l^kbiG6^l^kUK/00iD01;_;^l/2U@0L^l^kbiG;a/^kbk_;^l^kbk_;^l^kbiG;^l^kb`:E00Vkbk_;
UL^kbiD00/H01<^kULH2U@14bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000@k/00iG6^`0A^`03ULJk01Jk00?6^k/00k/019Fk
UK/2aP04UK^kU@:k00>E^k/06k/00lJkU@02aPBk00>E^k/06;/00iFk^`09^`03a[^k00Fk00>E^k/0
5;/00iG6^`0A^`03ULJk01>k00>Ea[/00[/00iFk^`02^`06UK^k^iFk0YD3^`03ULK600jk0iD5^`BE
1[/00iG6aP02aP:k00>E^k/0@K/1000004[;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkbk_;U@;600c;^l^kbk_;^l^kbiD2aP0O
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^lJkbk_;^iFkb`03U@03a[_;00:E01nkUIG;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^E00;602S;^iG6bk_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^k
0YD03<^kbk_;^l^kbk_;^`:E01c;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ea[_;^l^E0/H03<^kbk_;^l^k
bk_;U@;601G;^l^kbk_;^l^kbk_;^l^kbk_;^lH019D03K_;^l^Ebk_;UL^kbiD00/H00iFkb`02aP0?
^l^kbk_;^l^kbk_;^l^k00>E05Nkbk_;^iFkbk_;^l^kbk^Ea/^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004>k00>Ea[/0
0k/00iG6U@03aPBk00>Ea/H00k/00iG6aP0D^`03a[^k00>k00BEa/K60[/00iG6^`02^`:E00>kUK/0
6K/019FkULH3^`04a[^kU@:k0YDF^`03UK^k00>k00BE^iFE1[/2U@Bk0YDC^`03ULJk00>k00>EaYD0
0lH4^`03ULK600>k00>Ea/H04[/01LJk^k^E00;60[/019Fk^k/2U@>k00C6ULJE0k/00lJk^`0?^`03
UK^k012k00>E^k/0@K/1000004C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;U@?600nkbiG6^l^EblK;^l^EaYD00/H06l^kbiG6^l^k
bk_;^l^kbk_;^l^kbk_;a/^kb`02aP05^l_6biD00/H09l_6bk_;^iFkUK_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;UL^kU@04aP0M^l^EUK^E^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk/00iD03k_;^iFkbk^E
^l^kbk^E^`02U@0Hbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^E0lH03k_;ULJkbiG;a/^kbiG6U@02aP0F
bk_;ULJkbk_;^l^kbk_;^l^kbk_;^`;600G;^l_6b`03aP05bk_;^l/00YD01;_6^l/2aP0W^l_6bk_;
^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^k00:E04;;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/10000A[/00iG6aP02aP>k
00>Ea[/00[/01IG6^k^E00;600>kULH04[/2aP:k00C6^lK60[/00iFk^`02aPJk00>E^k/06;/3U@>k
00>Ea[/00k/2U@:k00>E^k/05K/4U@Bk00>E^k/00[/019Fk^k/2U@:k00>E^k/04k/00iG6aP02aP>k
00>Ea[/00[/01IG6^k^E00;600>kULH04k/4aP>k00>Ea/H01K/00iG6^`03^`?64K/00iFk^`02^`:E
2;/2U@Bk0iDo^`400000F/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ea[_;^iG6bk_;ULJkbk_;U@?601Bkbk_;^l^kbk_;
^l^kbk_;^l^kb`?600?;^lH00/H02iG;^iG6bk_;^l^k00>E05>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk^E^l^kbk_;^l^kUK_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kUK_;^l^Ebk_;^iFkbk_;
^`03U@0Y^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ULJkbk^Ea/^kbiG6^l^kbiD00lH07K_;^l^kbk_;
^l^kbk_;^l^kbk_;^l_6bk_;UL^k00;601g;^l^Ea[_;^l^kblK;^l^kbk_;^l^kbk_;^l^kb`02U@05
^l^kUK/00iD01k_;^l^kUK/00iD0@k_;^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@0004jk00>Ea[/00[/00iG6aP05^`03ULJk01Fk
00?6^k/00k/2aP04^iFkU@>k0iD2^`03UK^k01Rk00>E^k/02[/3UAfk00>E^k/00[/2U@Jk00>E^k/0
6k/00iG6^`02^`03ULK600Fk00>Ea[/06K/02YFk^k^EaYFkULHJ^`BE1;/00iFk^`02^`03UK^k00:k
0YD2^`03UK^k03bk0@00001Fbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kULK;^l^kbiD2aP0Sbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD0:K_;UL^kUK_;UL^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk^E^l^k00>E00>kbk/00iD09k_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;
^`02U@0Zbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk_;^l^E0/H07l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00YD01K_;ULJk00:E0/H09/^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk^E^l^kbiG;^l^k0YD01L^kbk_;00>E03k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40001>^`03ULJk00Jk00>Ea[/08[/019Fk
^iD2^`:E0[/2UAZk0YD2^`04UK^kU@:k00>E^k/00YD00k^E^`0K^`03UK^k00Jk00>E^k/07k/00iG6
^`06^`03ULJk01nk0iD00lJk^`03^`;67k/00iFk^`04^`>E1;/00iFk^`0l^`400000E<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^iG6bk_;^`;604k;ULJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
biG;^l^kUK_;UL^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3U@0:^l^Ebk^E^l^kb`:E04fkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk_;^l^kUK_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^iG6bk_;^`02aP2JbiG6^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbiG6^l^k
bk_;^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^l^kbk_;UL^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`40001>^`03
ULJk00:k00>Ea[/00lHV^`03UK^k00>k00>E^k/07[/019Fk^iD2^`>E0k/00iFk^`0J^`03UK^k00:k
0YD2^`03UK^k01nk00>Ea[/00[/00iG6^`03aR>k00?6^k/01K/00lJk^`0L^`03UK^k00Nk00>E^k/0
@;/1000005G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^Ea/^kbiG600>E02[6^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^Ebk/2U@1BbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
biG;^l^kbiG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;UL^kbk^E^`BE02O;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^iG6bk_;ULH00iD0:<Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^lJkbk/3aP0U^lJkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^Ebk_;^`04U@14
biG;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/10000C[/00iG6aP02^`03ULJk00:k00>E^k/09;/01IFk^iFk00:E8k/00iFk^`04UAnk
0YD3^`03UK^k00:k00>E^k/07[/00iG6aP02^`03ULJk00:k00>E^k/08K/2aP:k00?6^k/00/HN^`:E
0k/019Fk^k/2UD:k0@00001Abk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk^E00C602Zkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/4U@1>^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^Ebk^E^l^Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;19D0:;_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^iD4aP0Y^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/00lH09;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`BE
04Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^`010000Dk/00iG6^`0/^`03UK^k02Bk19DW^`03UK^k02Rk00>Ea[/0:[/00lJk
^`0U^`03UK^k04Fk0@00003nbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^iFkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2b`2L^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;0@000?nkWK/100000?k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;;09bkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l/10000ok^M^`400000o/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0//0W;_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40003o^ifk0@00003nbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2b`2L
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0@000?nkWK/100000?k;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`;;09bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/10000ok^M^`400000o/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0//0W;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40003o^ifk
0@00003nbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/2b`2L^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
0@000?nkWK/1000000W;^l^kbk_;^l/01Ol01/^kbk_;^`;o00K;^l^kbk/2o`07booool^kb`03o`04
bk_;^`?o00>kbk/00_l01/_oooo;^`?o00>kbol00ol0o[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0[/0FL^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;0040000:^`;o2;/2o`Fk0_l01k_ooonkok/00_l2^`04ok^k^`;o
00>kok/00_l01k_ooonkok/00_l01;_o^ol2^`;ook]I^`4000002l^kbk_;^l^kbk_;00;o00Rkbk_;
^l^kb`;o00Bkbk_;0_l00k_;o`03o`0:^ooobk_;ol^kb`;o00Jkbooo^l/4o`05^l_ook/00_l0o/^k
ooo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0//0G;_ool^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0@0000^k0_l8^`;o
1;/2o`>k0_l2^`;o1k/2o`:k0_l3^`;o0k/2o`Fk0_oo^eVk0@00000;bk_;^l^kbk_;^l/00_l02;_;
^onkbk_;0ol01<^kbk/2o`06bk_ool^k0_l01l^kbk_;^l/00_l00k_;^`02o`07bk_ool^kb`02o`04
^l^kb`;o0?jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`:k05W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`010000
2k/2o`>k00?o^k/00[/3o`Bk0_l2^`;o0k/2o`:k0_l2^`;o0k/2o`:k0_l3^`;o0k/2o`:k00?o^k/0
ok]F^`4000003<^kbk_;^l^kbk_;^`Ko00C;^l^k0ol01;_o^l/2o`07^ooook_;^`02o`06bk_o^l^k
0_l00l^kb`02o`07^ooook_;^`02o`1kbk_ool^kok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00Go00C;^l^k0ol00k_;o`02o`0<booool_obk_;^l^k
1?l00l^kb`04o`2k^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`0100003;/2o`>k00Co^k^k0ol00k_oo`03^`;o00>kool01;/3o`:k
1Ol3^`;o00>kool00k/2o`>k1?mc^`03ok^k00>k00Co^k_o0k/01?nk^ol3^`03ok^k00Jk00?o^k/0
0[/00onko`04^`03ok^k0;Rk0@00000<bk_;^l^kbk_;^l^k0_l08<^kboo;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0_l03<^kbk_;^l^kbk_;^`;o0?k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kbk_;^onkboo;^l^kbk_o^l^kok_;^l^k
bk_;ol^kbk_o^onkbk_;ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;;05jkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0@0000bk0_lQ^`03ok^k00Zk0_mi^`03ok^k00Bk00Co^k_o
1[/01Onk^k_o00Rk00?o^k/00[/00onko`04^`03ok^k0;Rk0@00000=bk_;^l^kbk_;^l^kb`02o`0^
^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;o07jkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;^l/3o`03
booo00?o0=K;^onkbk_o^l^kbk_;^l^kok_;ol^kok_;^l_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@0000fk0_l4^`03ok^k02Nk
0_mh^`03ok^k00Nk00Go^k^ko`02^`;o0[/00onk^`08^`;o0k/00onk^`02^`03ok^k0;Rk0@00000;
bk_;^l^kbk_;^l/02Ol0:<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3o`23
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
ol^kbk_;^l^kbk/00ol01K_;oonk00;o0=3;^l^kbk_;^l^kok_;ol^kok_;^l_obk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0@000;Nk
00?o^k/01;/00onk^`0D^`03ok^k00:k00?o^ol01;/00onk^`2h^`400000_L^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o^l^kb`02o`3M
^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l^kok_o^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00@000;Vk1?l00k_o^`0F^`Co
0k/4ok^k0@00003nbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2b`2L^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;0@000?nkWK/100000?k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;;09bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l/10000ok^M^`400000o/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0//0W;_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`40003o^ifk0@00003nbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2b`2L^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0@000001\
\>"],
  ImageRangeCache->{{{0, 412}, {255, 0}} -> {-0.0250052, -0.0257715, \
0.00254857, 0.00412367}, {{9.8125, 402.188}, {248.75, 6.1875}} -> {-1.35563, \
-0.271688, 0.0235711, 0.0235711}, {{57.5, 96.5625}, {243.438, 204.375}} -> \
{-0.275471, -0.325492, 0.00988084, 0.0266765}, {{100.438, 139.562}, {243.438, \
204.375}} -> {-0.911112, -0.330456, 0.0115687, 0.0264174}, {{143.438, 182.5}, \
{243.438, 204.375}} -> {-1.4082, -0.330456, 0.0115687, 0.0264174}, {{186.438, \
225.5}, {243.438, 204.375}} -> {-1.90566, -0.330456, 0.0115687, 0.0264174}, \
{{229.438, 268.5}, {243.438, 204.375}} -> {-2.39386, -0.330495, 0.0115318, \
0.0264208}, {{272.375, 311.5}, {243.438, 204.375}} -> {-2.88937, -0.330495, \
0.0115318, 0.0264208}, {{315.375, 354.438}, {243.438, 204.375}} -> {-3.62834, \
-0.326184, 0.0122548, 0.0260479}, {{57.5, 96.5625}, {200.438, 161.375}} -> \
{-0.414019, -1.4664, 0.0115687, 0.0264174}, {{100.438, 139.562}, {200.438, \
161.375}} -> {-0.911112, -1.4664, 0.0115687, 0.0264174}, {{143.438, 182.5}, \
{200.438, 161.375}} -> {-1.4082, -1.4664, 0.0115687, 0.0264174}, {{186.438, \
225.5}, {200.438, 161.375}} -> {-1.90566, -1.4664, 0.0115687, 0.0264174}, \
{{229.438, 268.5}, {200.438, 161.375}} -> {-2.40311, -1.4664, 0.0115687, \
0.0264174}, {{272.375, 311.5}, {200.438, 161.375}} -> {-2.9002, -1.4664, \
0.0115687, 0.0264174}, {{315.375, 354.438}, {200.438, 161.375}} -> {-3.3973, \
-1.4664, 0.0115687, 0.0264174}, {{57.5, 96.5625}, {157.5, 118.375}} -> \
{-0.677979, -2.49444, 0.0149162, 0.0253195}, {{100.438, 139.562}, {157.5, \
118.375}} -> {-0.904415, -2.59691, 0.0115133, 0.0263785}, {{143.438, 182.5}, \
{157.5, 118.375}} -> {-1.4082, -2.60153, 0.0115687, 0.0264174}, {{186.438, \
225.5}, {157.5, 118.375}} -> {-1.80612, -2.61716, 0.0110958, 0.0265777}, \
{{229.438, 268.5}, {157.5, 118.375}} -> {-2.40311, -2.60153, 0.0115687, \
0.0264174}, {{272.375, 311.5}, {157.5, 118.375}} -> {-2.64718, -2.63343, \
0.0107186, 0.0267531}, {{315.375, 354.438}, {157.5, 118.375}} -> {-3.80551, \
-2.55061, 0.0127811, 0.0258954}, {{57.5, 96.5625}, {114.5, 75.4375}} -> \
{-0.414019, -3.73665, 0.0115687, 0.0264174}, {{100.438, 139.562}, {114.5, \
75.4375}} -> {-0.988956, -3.69436, 0.012208, 0.0261164}, {{143.438, 182.5}, \
{114.5, 75.4375}} -> {-1.60795, -3.66331, 0.0127811, 0.0258954}, {{186.438, \
225.5}, {114.5, 75.4375}} -> {-1.90566, -3.73665, 0.0115687, 0.0264174}, \
{{229.438, 268.5}, {114.5, 75.4375}} -> {-2.56341, -3.69436, 0.012208, \
0.0261164}, {{272.375, 311.5}, {114.5, 75.4375}} -> {-2.9002, -3.73665, \
0.0115687, 0.0264174}, {{315.375, 354.438}, {114.5, 75.4375}} -> {-3.57184, \
-3.7, 0.0120871, 0.0261565}, {{57.5, 96.5625}, {71.5, 32.4375}} -> \
{-0.414019, -4.8726, 0.0115687, 0.0264174}, {{100.438, 139.562}, {71.5, \
32.4375}} -> {-1.17819, -4.72124, 0.0137615, 0.0255926}, {{143.438, 182.5}, \
{71.5, 32.4375}} -> {-1.39402, -4.87403, 0.0114824, 0.0264252}, {{186.438, \
225.5}, {71.5, 32.4375}} -> {-1.90566, -4.8726, 0.0115687, 0.0264174}, \
{{229.438, 268.5}, {71.5, 32.4375}} -> {-2.40311, -4.8726, 0.0115687, \
0.0264174}, {{272.375, 311.5}, {71.5, 32.4375}} -> {-2.88937, -4.87321, \
0.0115318, 0.0264208}, {{315.375, 354.438}, {71.5, 32.4375}} -> {-2.82349, \
-4.91218, 0.00988084, 0.0266765}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Fitnesses"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Basic directory"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \($basicDirectory = \[IndentingNewLine]ToFileName[{EvolvicaDirectory, \
\[IndentingNewLine]"\<EvolutionPrograms\>", "\<GLP\>", \
"\<FractalEvolution\>"}]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Extracting fitnesses from files"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
getFitnesses[dir_,exp_,gen_] :=
Module[{},
  
  Get[dir <> $PathnameSeparator <> \"Examples\" <>
      $PathnameSeparator <> exp <> 
      $PathnameSeparator <> exp <> \".\" <>
                   ToString[gen] <> \".fit\"]
                   
];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Fitnesses of generation 0"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["getFitnesses[$basicDirectory,\"Fractals-10-1\",0]"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
{0, 12, 6, 6, 6, 0, 6, 2, 8, 0, 16, 0, 2, 2, 0, 0, 2, 4, 0, 0, 0, 0, 0, \
0, 
 
  0, 0, 6, 0, 16, 0, 0, 0, 0, 0, 0}\
\>", 
"\<\
{0, 12, 6, 6, 6, 0, 6, 2, 8, 0, 16, 0, 2, 2, 0, 0, 2, 4, 0, 0, 0, 0, 0, \
0, 
 
  0, 0, 6, 0, 16, 0, 0, 0, 0, 0, 0}\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Fitness graphics"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Reading fitnesses of all generations"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(allFitnessesSorted = 
        Table[\(getFitnesses[$basicDirectory, "\<Fractals-10-1\>", i] // 
              Sort\) // Reverse, {i, 0, 80}];\)\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Generations 0 to 20"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Fitnesses-Gen20"],

Cell[CellGroupData[{

Cell[TextData[
"fitnessChart3D[Map[Reverse[Sort[#]]&,Take[allFitnesses,21]],\n  GenIndices \
-> {{5,5},{10,10},{20,20}}];"], "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .95229 
MathPictureStart
%% Graphics3D
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-3.75585e-05 1.06867 0.0267167 1.06867 [
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 20)] .5 .95229 0 -1.5 Msboxa
P
[(0)] .08595 .18034 -0.06484 1 Msboxa
[(10)] .23556 .13958 -0.04346 1 Msboxa
[(20)] .40028 .0947 -0.01962 1 Msboxa
[(30)] .58253 .04506 .00711 1 Msboxa
[(Indiv.)] .35928 .03957 -0.02584 1 Msboxa
[(5)] .7875 .11017 -1 .2437 Msboxa
[(10)] .84539 .17697 -1 .22283 Msboxa
[(20)] .93936 .28542 -1 .19025 Msboxa
[(Gen.)] .91594 .16872 -1 .22094 Msboxa
[(-20)] .05417 .28247 1 -0.24578 Msboxa
[(0)] .04482 .42044 1 -0.20167 Msboxa
[(20)] .03512 .56396 1 -0.15552 Msboxa
[(40)] .02505 .71336 1 -0.10715 Msboxa
[(60)] .01458 .86902 1 -0.05642 Msboxa
[(Fit.)] -0.0283 .53856 1 -0.16726 Msboxa
[ 0 0 0 0 ]
[ 1 .95229 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 20)] .5 .95229 0 -1.5 Mshowa
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.08509 .19367 m
.08465 .20033 L
s
P
[(0)] .08595 .18034 -0.06484 1 Mshowa
p
.002 w
.23498 .15292 m
.23469 .15959 L
s
P
[(10)] .23556 .13958 -0.04346 1 Mshowa
p
.002 w
.40002 .10806 m
.39989 .11474 L
s
P
[(20)] .40028 .0947 -0.01962 1 Mshowa
p
.002 w
.58262 .05842 m
.58267 .0651 L
s
P
[(30)] .58253 .04506 .00711 1 Mshowa
p
.001 w
.11395 .18582 m
.11371 .18982 L
s
P
p
.001 w
.14336 .17783 m
.14314 .18183 L
s
P
p
.001 w
.17332 .16968 m
.17311 .17368 L
s
P
p
.001 w
.20386 .16138 m
.20367 .16538 L
s
P
p
.001 w
.2667 .1443 m
.26655 .1483 L
s
P
p
.001 w
.29905 .1355 m
.29892 .13951 L
s
P
p
.001 w
.33204 .12654 m
.33192 .13054 L
s
P
p
.001 w
.36569 .11739 m
.36559 .1214 L
s
P
p
.001 w
.43505 .09854 m
.43499 .10254 L
s
P
p
.001 w
.4708 .08882 m
.47076 .09283 L
s
P
p
.001 w
.5073 .0789 m
.50728 .0829 L
s
P
p
.001 w
.54456 .06877 m
.54457 .07277 L
s
P
p
.001 w
.6215 .04785 m
.62155 .05186 L
s
P
p
.001 w
.66122 .03706 m
.6613 .04106 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
p
.002 w
.69926 .02672 m
.93852 .30206 L
s
P
p
.002 w
.77452 .11333 m
.76803 .11491 L
s
P
[(5)] .7875 .11017 -1 .2437 Mshowa
p
.002 w
.83235 .17988 m
.82583 .18133 L
s
P
[(10)] .84539 .17697 -1 .22283 Mshowa
p
.002 w
.92624 .28792 m
.91967 .28917 L
s
P
[(20)] .93936 .28542 -1 .19025 Mshowa
[(Gen.)] .91594 .16872 -1 .22094 Mshowa
P
p
p
.002 w
.07262 .19706 m
.02672 .88626 L
s
P
p
.002 w
.06715 .27928 m
.07363 .27769 L
s
P
[(-20)] .05417 .28247 1 -0.24578 Mshowa
p
.002 w
.05792 .4178 m
.06447 .41648 L
s
P
[(0)] .04482 .42044 1 -0.20167 Mshowa
p
.002 w
.04832 .56191 m
.05492 .56088 L
s
P
[(20)] .03512 .56396 1 -0.15552 Mshowa
p
.002 w
.03833 .71194 m
.04497 .71122 L
s
P
[(40)] .02505 .71336 1 -0.10715 Mshowa
p
.002 w
.02792 .86826 m
.03458 .86789 L
s
P
[(60)] .01458 .86902 1 -0.05642 Mshowa
p
.001 w
.06533 .30655 m
.06923 .30563 L
s
P
p
.001 w
.0635 .33404 m
.0674 .33315 L
s
P
p
.001 w
.06165 .36174 m
.06557 .36088 L
s
P
p
.001 w
.05979 .38966 m
.06371 .38884 L
s
P
p
.001 w
.05603 .44617 m
.05996 .44541 L
s
P
p
.001 w
.05413 .47476 m
.05807 .47403 L
s
P
p
.001 w
.05221 .50357 m
.05615 .50289 L
s
P
p
.001 w
.05027 .53262 m
.05423 .53197 L
s
P
p
.001 w
.04635 .59143 m
.05032 .59085 L
s
P
p
.001 w
.04437 .62119 m
.04834 .62064 L
s
P
p
.001 w
.04237 .65119 m
.04635 .65069 L
s
P
p
.001 w
.04036 .68144 m
.04434 .68097 L
s
P
p
.001 w
.03628 .74268 m
.04027 .7423 L
s
P
p
.001 w
.03421 .77369 m
.03821 .77334 L
s
P
p
.001 w
.03213 .80495 m
.03613 .80464 L
s
P
p
.001 w
.03003 .83648 m
.03403 .83621 L
s
P
p
.001 w
.06895 .25222 m
.07283 .25123 L
s
P
p
.001 w
.07074 .22536 m
.07461 .22434 L
s
P
p
.001 w
.07251 .19871 m
.07638 .19766 L
s
P
[(Fit.)] -0.0283 .53856 1 -0.16726 Mshowa
P
0 0 m
1 0 L
1 .95229 L
0 .95229 L
closepath
clip
newpath
p
p
.4 g
.002 w
.06715 .27928 m
.42858 .46117 L
s
P
p
.4 g
.002 w
.05792 .4178 m
.427 .56884 L
s
P
p
.4 g
.002 w
.04832 .56191 m
.42537 .67977 L
s
P
p
.4 g
.002 w
.03833 .71194 m
.42369 .79413 L
s
P
p
.4 g
.002 w
.02792 .86826 m
.42196 .91207 L
s
P
p
.4 g
.002 w
.08367 .20324 m
.03923 .88751 L
s
P
p
.4 g
.002 w
.18133 .25789 m
.149 .89843 L
s
P
p
.4 g
.002 w
.26703 .30585 m
.24418 .9079 L
s
P
p
.4 g
.002 w
.34284 .34827 m
.32749 .91619 L
s
P
p
.4 g
.002 w
.41037 .38606 m
.40102 .92351 L
s
P
p
.4 g
.002 w
.44013 .39481 m
.43312 .92519 L
s
P
p
.4 g
.002 w
.56602 .37138 m
.56847 .92068 L
s
P
p
.4 g
.002 w
.70138 .34619 m
.71482 .91579 L
s
P
p
.4 g
.002 w
.84733 .31903 m
.87358 .91049 L
s
P
p
.4 g
.002 w
.42858 .46117 m
.94271 .37503 L
s
P
p
.4 g
.002 w
.427 .56884 m
.94975 .49749 L
s
P
p
.4 g
.002 w
.42537 .67977 m
.95703 .62424 L
s
P
p
.4 g
.002 w
.42369 .79413 m
.96457 .75551 L
s
P
p
.4 g
.002 w
.42196 .91207 m
.97239 .89154 L
s
P
P
p
.43324 .39367 m .45808 .39844 L .44573 .40071 L 1 0 0 r
F
P
p
.44568 .39134 m .47051 .39615 L .45808 .39844 L 1 0 0 r
F
P
p
.43324 .39367 m .44568 .39134 L .45808 .39844 L 1 0 0 r
F
P
p
.45821 .389 m .48303 .39384 L .47051 .39615 L 1 0 .05 r
F
P
p
.44568 .39134 m .45821 .389 L .47051 .39615 L 1 0 0 r
F
P
p
.47082 .38665 m .49564 .39152 L .48303 .39384 L 1 0 .5 r
F
P
p
.45821 .389 m .47082 .38665 L .48303 .39384 L 1 0 .05 r
F
P
p
.42048 .38646 m .44568 .39134 L .43324 .39367 L 1 0 0 r
F
P
p
.48353 .38427 m .50835 .38918 L .49564 .39152 L 1 0 1 r
F
P
p
.47082 .38665 m .48353 .38427 L .49564 .39152 L 1 0 .5 r
F
P
p
.43301 .38409 m .45821 .389 L .44568 .39134 L 1 0 .05 r
F
P
p
.42048 .38646 m .43301 .38409 L .44568 .39134 L 1 0 0 r
F
P
p
.49633 .38188 m .52114 .38683 L .50835 .38918 L .7 0 1 r
F
P
p
.48353 .38427 m .49633 .38188 L .50835 .38918 L 1 0 1 r
F
P
p
.44563 .3817 m .47082 .38665 L .45821 .389 L 1 0 .55 r
F
P
p
.43301 .38409 m .44563 .3817 L .45821 .389 L 1 0 .05 r
F
P
p
.50923 .37947 m .53403 .38446 L .52114 .38683 L .1 0 1 r
F
P
p
.49633 .38188 m .50923 .37947 L .52114 .38683 L .7 0 1 r
F
P
p
.45834 .37929 m .48353 .38427 L .47082 .38665 L .4 0 1 r
F
P
p
.44563 .3817 m .45834 .37929 L .47082 .38665 L 1 0 .55 r
F
P
p
.40743 .3791 m .43301 .38409 L .42048 .38646 L 1 0 0 r
F
P
p
.52221 .37705 m .54701 .38207 L .53403 .38446 L 0 .65 1 r
F
P
p
.50923 .37947 m .52221 .37705 L .53403 .38446 L .1 0 1 r
F
P
p
.47115 .37686 m .49633 .38188 L .48353 .38427 L 0 .3 1 r
F
P
p
.45834 .37929 m .47115 .37686 L .48353 .38427 L .4 0 1 r
F
P
p
.42005 .37667 m .44563 .3817 L .43301 .38409 L 1 0 .1 r
F
P
p
.40743 .3791 m .42005 .37667 L .43301 .38409 L 1 0 0 r
F
P
p
.5353 .3746 m .56008 .37966 L .54701 .38207 L 0 1 .8 r
F
P
p
.52221 .37705 m .5353 .3746 L .54701 .38207 L 0 .65 1 r
F
P
p
.48405 .37441 m .50923 .37947 L .49633 .38188 L 0 .8 1 r
F
P
p
.47115 .37686 m .48405 .37441 L .49633 .38188 L 0 .3 1 r
F
P
p
.43276 .37423 m .45834 .37929 L .44563 .3817 L .9 0 1 r
F
P
p
.42005 .37667 m .43276 .37423 L .44563 .3817 L 1 0 .1 r
F
P
p
.54848 .37214 m .57325 .37723 L .56008 .37966 L 0 1 .45 r
F
P
p
.5353 .3746 m .54848 .37214 L .56008 .37966 L 0 1 .8 r
F
P
p
.49704 .37195 m .52221 .37705 L .50923 .37947 L 0 1 .75 r
F
P
p
.48405 .37441 m .49704 .37195 L .50923 .37947 L 0 .8 1 r
F
P
p
.44557 .37176 m .47115 .37686 L .45834 .37929 L 0 .2 1 r
F
P
p
.43276 .37423 m .44557 .37176 L .45834 .37929 L .9 0 1 r
F
P
p
.39408 .37157 m .42005 .37667 L .40743 .3791 L 1 0 0 r
F
P
p
.56176 .36966 m .58652 .37479 L .57325 .37723 L 0 1 .25 r
F
P
p
.54848 .37214 m .56176 .36966 L .57325 .37723 L 0 1 .45 r
F
P
p
.51013 .36947 m .5353 .3746 L .52221 .37705 L 0 1 .4 r
F
P
p
.49704 .37195 m .51013 .36947 L .52221 .37705 L 0 1 .75 r
F
P
p
.45848 .36928 m .48405 .37441 L .47115 .37686 L 0 .5 1 r
F
P
p
.44557 .37176 m .45848 .36928 L .47115 .37686 L 0 .2 1 r
F
P
p
.40679 .36909 m .43276 .37423 L .42005 .37667 L 1 0 .1 r
F
P
p
.39408 .37157 m .40679 .36909 L .42005 .37667 L 1 0 0 r
F
P
p
.57514 .36716 m .59989 .37233 L .58652 .37479 L 0 1 .15 r
F
P
p
.56176 .36966 m .57514 .36716 L .58652 .37479 L 0 1 .25 r
F
P
p
.52332 .36697 m .54848 .37214 L .5353 .3746 L 0 1 .05 r
F
P
p
.51013 .36947 m .52332 .36697 L .5353 .3746 L 0 1 .4 r
F
P
p
.47148 .36678 m .49704 .37195 L .48405 .37441 L 0 .9 1 r
F
P
p
.45848 .36928 m .47148 .36678 L .48405 .37441 L 0 .5 1 r
F
P
p
.4196 .36658 m .44557 .37176 L .43276 .37423 L 1 0 .7 r
F
P
p
.40679 .36909 m .4196 .36658 L .43276 .37423 L 1 0 .1 r
F
P
p
.58861 .36464 m .61335 .36985 L .59989 .37233 L 0 1 .05 r
F
P
p
.57514 .36716 m .58861 .36464 L .59989 .37233 L 0 1 .15 r
F
P
p
.53661 .36445 m .56176 .36966 L .54848 .37214 L .05 1 0 r
F
P
p
.52332 .36697 m .53661 .36445 L .54848 .37214 L 0 1 .05 r
F
P
p
.48458 .36426 m .51013 .36947 L .49704 .37195 L 0 1 .8 r
F
P
p
.47148 .36678 m .48458 .36426 L .49704 .37195 L 0 .9 1 r
F
P
p
.43251 .36406 m .45848 .36928 L .44557 .37176 L .8 0 1 r
F
P
p
.4196 .36658 m .43251 .36406 L .44557 .37176 L 1 0 .7 r
F
P
p
.38042 .36387 m .40679 .36909 L .39408 .37157 L 1 0 0 r
F
P
p
.60219 .36211 m .62692 .36735 L .61335 .36985 L .15 1 0 r
F
P
p
.58861 .36464 m .60219 .36211 L .61335 .36985 L 0 1 .05 r
F
P
p
.55 .36191 m .57514 .36716 L .56176 .36966 L .15 1 0 r
F
P
p
.53661 .36445 m .55 .36191 L .56176 .36966 L .05 1 0 r
F
P
p
.49777 .36172 m .52332 .36697 L .51013 .36947 L 0 1 .7 r
F
P
p
.48458 .36426 m .49777 .36172 L .51013 .36947 L 0 1 .8 r
F
P
p
.44552 .36152 m .47148 .36678 L .45848 .36928 L .2 0 1 r
F
P
p
.43251 .36406 m .44552 .36152 L .45848 .36928 L .8 0 1 r
F
P
p
.39323 .36132 m .4196 .36658 L .40679 .36909 L 1 0 .05 r
F
P
p
.38042 .36387 m .39323 .36132 L .40679 .36909 L 1 0 0 r
F
P
p
.61587 .35955 m .64059 .36484 L .62692 .36735 L .4 1 0 r
F
P
p
.60219 .36211 m .61587 .35955 L .62692 .36735 L .15 1 0 r
F
P
p
.56349 .35935 m .58861 .36464 L .57514 .36716 L .3 1 0 r
F
P
p
.55 .36191 m .56349 .35935 L .57514 .36716 L .15 1 0 r
F
P
p
.51107 .35916 m .53661 .36445 L .52332 .36697 L 0 1 .55 r
F
P
p
.49777 .36172 m .51107 .35916 L .52332 .36697 L 0 1 .7 r
F
P
p
.45862 .35896 m .48458 .36426 L .47148 .36678 L 0 .4 1 r
F
P
p
.44552 .36152 m .45862 .35896 L .47148 .36678 L .2 0 1 r
F
P
p
.40614 .35876 m .43251 .36406 L .4196 .36658 L 1 0 .15 r
F
P
p
.39323 .36132 m .40614 .35876 L .4196 .36658 L 1 0 .05 r
F
P
p
.62966 .35698 m .65436 .3623 L .64059 .36484 L .6 1 0 r
F
P
p
.61587 .35955 m .62966 .35698 L .64059 .36484 L .4 1 0 r
F
P
p
.57708 .35678 m .60219 .36211 L .58861 .36464 L .5 1 0 r
F
P
p
.56349 .35935 m .57708 .35678 L .58861 .36464 L .3 1 0 r
F
P
p
.52446 .35658 m .55 .36191 L .53661 .36445 L 0 1 .45 r
F
P
p
.51107 .35916 m .52446 .35658 L .53661 .36445 L 0 1 .55 r
F
P
p
.47182 .35638 m .49777 .36172 L .48458 .36426 L 0 .4 1 r
F
P
p
.45862 .35896 m .47182 .35638 L .48458 .36426 L 0 .4 1 r
F
P
p
.41915 .35618 m .44552 .36152 L .43251 .36406 L 1 0 .2 r
F
P
p
.40614 .35876 m .41915 .35618 L .43251 .36406 L 1 0 .15 r
F
P
p
.36644 .35598 m .39323 .36132 L .38042 .36387 L 1 0 .05 r
F
P
p
.64355 .35438 m .66823 .35975 L .65436 .3623 L .75 1 0 r
F
P
p
.62966 .35698 m .64355 .35438 L .65436 .3623 L .6 1 0 r
F
P
p
.59077 .35418 m .61587 .35955 L .60219 .36211 L .7 1 0 r
F
P
p
.57708 .35678 m .59077 .35418 L .60219 .36211 L .5 1 0 r
F
P
p
.53796 .35398 m .56349 .35935 L .55 .36191 L 0 1 .4 r
F
P
p
.52446 .35658 m .53796 .35398 L .55 .36191 L 0 1 .45 r
F
P
p
.48512 .35378 m .51107 .35916 L .49777 .36172 L 0 .55 1 r
F
P
p
.47182 .35638 m .48512 .35378 L .49777 .36172 L 0 .4 1 r
F
P
p
.43225 .35358 m .45862 .35896 L .44552 .36152 L 1 0 .7 r
F
P
p
.41915 .35618 m .43225 .35358 L .44552 .36152 L 1 0 .2 r
F
P
p
.37935 .35338 m .40614 .35876 L .39323 .36132 L 1 0 .7 r
F
P
p
.36644 .35598 m .37935 .35338 L .39323 .36132 L 1 0 .05 r
F
P
p
.65754 .35177 m .68221 .35718 L .66823 .35975 L .8 1 0 r
F
P
p
.64355 .35438 m .65754 .35177 L .66823 .35975 L .75 1 0 r
F
P
p
.60457 .35157 m .62966 .35698 L .61587 .35955 L .85 1 0 r
F
P
p
.59077 .35418 m .60457 .35157 L .61587 .35955 L .7 1 0 r
F
P
p
.55156 .35137 m .57708 .35678 L .56349 .35935 L 0 1 .35 r
F
P
p
.53796 .35398 m .55156 .35137 L .56349 .35935 L 0 1 .4 r
F
P
p
.49853 .35116 m .52446 .35658 L .51107 .35916 L 0 .8 1 r
F
P
p
.48512 .35378 m .49853 .35116 L .51107 .35916 L 0 .55 1 r
F
P
p
.44546 .35096 m .47182 .35638 L .45862 .35896 L .8 0 1 r
F
P
p
.43225 .35358 m .44546 .35096 L .45862 .35896 L 1 0 .7 r
F
P
p
.39236 .35076 m .41915 .35618 L .40614 .35876 L .65 0 1 r
F
P
p
.37935 .35338 m .39236 .35076 L .40614 .35876 L 1 0 .7 r
F
P
p
.67164 .34913 m .69629 .35458 L .68221 .35718 L .85 1 0 r
F
P
p
.65754 .35177 m .67164 .34913 L .68221 .35718 L .8 1 0 r
F
P
p
.61847 .34893 m .64355 .35438 L .62966 .35698 L 1 1 0 r
F
P
p
.60457 .35157 m .61847 .34893 L .62966 .35698 L .85 1 0 r
F
P
p
.56527 .34873 m .59077 .35418 L .57708 .35678 L .1 1 0 r
F
P
p
.55156 .35137 m .56527 .34873 L .57708 .35678 L 0 1 .35 r
F
P
p
.51203 .34852 m .53796 .35398 L .52446 .35658 L 0 .95 1 r
F
P
p
.49853 .35116 m .51203 .34852 L .52446 .35658 L 0 .8 1 r
F
P
p
.45877 .34832 m .48512 .35378 L .47182 .35638 L .8 0 1 r
F
P
p
.44546 .35096 m .45877 .34832 L .47182 .35638 L .8 0 1 r
F
P
p
.40547 .34812 m .43225 .35358 L .41915 .35618 L .3 0 1 r
F
P
p
.39236 .35076 m .40547 .34812 L .41915 .35618 L .65 0 1 r
F
P
p
.35214 .34791 m .37935 .35338 L .36644 .35598 L 1 0 .05 r
F
P
p
.002 w
.45261 .90987 m .43941 .91037 L .42594 .90883 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68585 .34648 m .71048 .35197 L .69629 .35458 L 1 .9 0 r
F
P
p
.67164 .34913 m .68585 .34648 L .69629 .35458 L .85 1 0 r
F
P
p
.63248 .34628 m .65754 .35177 L .64355 .35438 L 1 .9 0 r
F
P
p
.61847 .34893 m .63248 .34628 L .64355 .35438 L 1 1 0 r
F
P
p
.57908 .34607 m .60457 .35157 L .59077 .35418 L .5 1 0 r
F
P
p
.56527 .34873 m .57908 .34607 L .59077 .35418 L .1 1 0 r
F
P
p
.52564 .34587 m .55156 .35137 L .53796 .35398 L 0 1 .95 r
F
P
p
.51203 .34852 m .52564 .34587 L .53796 .35398 L 0 .95 1 r
F
P
p
.47217 .34566 m .49853 .35116 L .48512 .35378 L .3 0 1 r
F
P
p
.45877 .34832 m .47217 .34566 L .48512 .35378 L .8 0 1 r
F
P
p
.41868 .34545 m .44546 .35096 L .43225 .35358 L 0 .05 1 r
F
P
p
.40547 .34812 m .41868 .34545 L .43225 .35358 L .3 0 1 r
F
P
p
.36515 .34525 m .39236 .35076 L .37935 .35338 L 1 0 .7 r
F
P
p
.35214 .34791 m .36515 .34525 L .37935 .35338 L 1 0 .05 r
F
P
p
.002 w
.46592 .90937 m .45261 .90987 L .43925 .90832 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.42594 .90883 m .43925 .90832 L .45261 .90987 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70017 .34381 m .72478 .34934 L .71048 .35197 L 1 .65 0 r
F
P
p
.68585 .34648 m .70017 .34381 L .71048 .35197 L 1 .9 0 r
F
P
p
.6466 .3436 m .67164 .34913 L .65754 .35177 L 1 .9 0 r
F
P
p
.63248 .34628 m .6466 .3436 L .65754 .35177 L 1 .9 0 r
F
P
p
.59299 .34339 m .61847 .34893 L .60457 .35157 L .5 1 0 r
F
P
p
.57908 .34607 m .59299 .34339 L .60457 .35157 L .5 1 0 r
F
P
p
.53936 .34319 m .56527 .34873 L .55156 .35137 L 0 1 .85 r
F
P
p
.52564 .34587 m .53936 .34319 L .55156 .35137 L 0 1 .95 r
F
P
p
.48569 .34298 m .51203 .34852 L .49853 .35116 L 0 .65 1 r
F
P
p
.47217 .34566 m .48569 .34298 L .49853 .35116 L .3 0 1 r
F
P
p
.43199 .34277 m .45877 .34832 L .44546 .35096 L 0 .1 1 r
F
P
p
.41868 .34545 m .43199 .34277 L .44546 .35096 L 0 .05 1 r
F
P
p
.37825 .34256 m .40547 .34812 L .39236 .35076 L .65 0 1 r
F
P
p
.36515 .34525 m .37825 .34256 L .39236 .35076 L 1 0 .7 r
F
P
p
.002 w
.47933 .90887 m .46592 .90937 L .45267 .90781 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.43925 .90832 m .45267 .90781 L .46592 .90937 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7146 .34111 m .73919 .34669 L .72478 .34934 L 1 .5 0 r
F
P
p
.70017 .34381 m .7146 .34111 L .72478 .34934 L 1 .65 0 r
F
P
p
.66083 .3409 m .68585 .34648 L .67164 .34913 L 1 .8 0 r
F
P
p
.6466 .3436 m .66083 .3409 L .67164 .34913 L 1 .9 0 r
F
P
p
.60702 .34069 m .63248 .34628 L .61847 .34893 L .55 1 0 r
F
P
p
.59299 .34339 m .60702 .34069 L .61847 .34893 L .5 1 0 r
F
P
p
.55318 .34049 m .57908 .34607 L .56527 .34873 L 0 1 .5 r
F
P
p
.53936 .34319 m .55318 .34049 L .56527 .34873 L 0 1 .85 r
F
P
p
.4993 .34028 m .52564 .34587 L .51203 .34852 L 0 1 .75 r
F
P
p
.48569 .34298 m .4993 .34028 L .51203 .34852 L 0 .65 1 r
F
P
p
.4454 .34007 m .47217 .34566 L .45877 .34832 L 0 .1 1 r
F
P
p
.43199 .34277 m .4454 .34007 L .45877 .34832 L 0 .1 1 r
F
P
p
.39146 .33986 m .41868 .34545 L .40547 .34812 L .3 0 1 r
F
P
p
.37825 .34256 m .39146 .33986 L .40547 .34812 L .65 0 1 r
F
P
p
.33749 .33965 m .36515 .34525 L .35214 .34791 L 1 0 .05 r
F
P
p
.002 w
.575 .6968 m .56132 .72196 L .54907 .67008 L p
0 1 .45 r
F P
0 0 0 r
s
P
p
.002 w
.56132 .72196 m .5477 .77114 L .53534 .67151 L p
0 1 .8 r
F P
0 0 0 r
s
P
p
.002 w
.53534 .67151 m .54907 .67008 L .56132 .72196 L p
0 1 .8 r
F P
0 0 0 r
s
P
p
.002 w
.58888 .69548 m .575 .6968 L .56287 .65669 L p
0 1 .25 r
F P
0 0 0 r
s
P
p
.002 w
.54907 .67008 m .56287 .65669 L .575 .6968 L p
0 1 .45 r
F P
0 0 0 r
s
P
p
.002 w
.49284 .90836 m .47933 .90887 L .46629 .8949 L p
1 0 .5 r
F P
0 0 0 r
s
P
p
.002 w
.45267 .90781 m .46629 .8949 L .47933 .90887 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.43925 .90832 m .42594 .90883 L .41216 .90725 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.52161 .73266 m .53534 .67151 L .5477 .77114 L p
0 .65 1 r
F P
0 0 0 r
s
P
p
.002 w
.54907 .67008 m .53534 .67151 L .52288 .65508 L p
0 1 .05 r
F P
0 0 0 r
s
P
p
.002 w
.53534 .67151 m .52161 .73266 L .50912 .66854 L p
0 1 .4 r
F P
0 0 0 r
s
P
p
.002 w
.50912 .66854 m .52288 .65508 L .53534 .67151 L p
0 1 .4 r
F P
0 0 0 r
s
P
p
.72915 .33839 m .75371 .34401 L .73919 .34669 L 1 .35 0 r
F
P
p
.7146 .34111 m .72915 .33839 L .73919 .34669 L 1 .5 0 r
F
P
p
.002 w
.5477 .77114 m .53401 .7963 L .52161 .73266 L p
0 .65 1 r
F P
0 0 0 r
s
P
p
.002 w
.53401 .7963 m .52022 .88259 L .50793 .74586 L p
.1 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.50793 .74586 m .52161 .73266 L .53401 .7963 L p
.1 0 1 r
F P
0 0 0 r
s
P
p
.67516 .33818 m .70017 .34381 L .68585 .34648 L 1 .65 0 r
F
P
p
.66083 .3409 m .67516 .33818 L .68585 .34648 L 1 .8 0 r
F
P
p
.62115 .33797 m .6466 .3436 L .63248 .34628 L .6 1 0 r
F
P
p
.60702 .34069 m .62115 .33797 L .63248 .34628 L .55 1 0 r
F
P
p
.002 w
.50646 .90785 m .49284 .90836 L .48059 .79623 L p
1 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48059 .79623 m .49426 .77106 L .50646 .90785 L p
1 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46629 .8949 m .48059 .79623 L .49284 .90836 L p
1 0 .5 r
F P
0 0 0 r
s
P
p
.002 w
.49426 .77106 m .48059 .79623 L .46788 .74464 L p
0 .3 1 r
F P
0 0 0 r
s
P
p
.002 w
.48059 .79623 m .46629 .8949 L .45391 .79426 L p
.4 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45391 .79426 m .46788 .74464 L .48059 .79623 L p
.4 0 1 r
F P
0 0 0 r
s
P
p
.5671 .33776 m .59299 .34339 L .57908 .34607 L 0 1 .1 r
F
P
p
.55318 .34049 m .5671 .33776 L .57908 .34607 L 0 1 .5 r
F
P
p
.51303 .33755 m .53936 .34319 L .52564 .34587 L 0 1 .45 r
F
P
p
.4993 .34028 m .51303 .33755 L .52564 .34587 L 0 1 .75 r
F
P
p
.002 w
.52022 .88259 m .50646 .90785 L .49426 .77106 L p
.7 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.49426 .77106 m .50793 .74586 L .52022 .88259 L p
.7 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.50793 .74586 m .49426 .77106 L .48144 .74349 L p
0 .8 1 r
F P
0 0 0 r
s
P
p
.002 w
.46788 .74464 m .48144 .74349 L .49426 .77106 L p
0 .3 1 r
F P
0 0 0 r
s
P
p
.45892 .33734 m .48569 .34298 L .47217 .34566 L 0 .55 1 r
F
P
p
.4454 .34007 m .45892 .33734 L .47217 .34566 L 0 .1 1 r
F
P
p
.40477 .33713 m .43199 .34277 L .41868 .34545 L 0 .05 1 r
F
P
p
.39146 .33986 m .40477 .33713 L .41868 .34545 L .3 0 1 r
F
P
p
.002 w
.52161 .73266 m .50793 .74586 L .49548 .66997 L p
0 1 .75 r
F P
0 0 0 r
s
P
p
.002 w
.48144 .74349 m .49548 .66997 L .50793 .74586 L p
0 .8 1 r
F P
0 0 0 r
s
P
p
.3506 .33692 m .37825 .34256 L .36515 .34525 L 1 0 .7 r
F
P
p
.33749 .33965 m .3506 .33692 L .36515 .34525 L 1 0 .05 r
F
P
p
.002 w
.60286 .69414 m .58888 .69548 L .57672 .64323 L p
0 1 .15 r
F P
0 0 0 r
s
P
p
.002 w
.56287 .65669 m .57672 .64323 L .58888 .69548 L p
0 1 .25 r
F P
0 0 0 r
s
P
p
.002 w
.45267 .90781 m .43925 .90832 L .42557 .90673 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.41216 .90725 m .42557 .90673 L .43925 .90832 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56287 .65669 m .54907 .67008 L .5367 .64157 L p
.05 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52288 .65508 m .5367 .64157 L .54907 .67008 L p
0 1 .05 r
F P
0 0 0 r
s
P
p
.7438 .33566 m .76835 .34132 L .75371 .34401 L 1 .25 0 r
F
P
p
.72915 .33839 m .7438 .33566 L .75371 .34401 L 1 .35 0 r
F
P
p
.002 w
.50912 .66854 m .52161 .73266 L p
.49766 .6752 L 0 1 .75 r
F P
0 0 0 r
s
P
p
.002 w
.50912 .66854 m .49584 .73752 L p
.52066 .66183 L 0 1 .7 r
F P
0 0 0 r
s
P
p
.002 w
.52288 .65508 m .50912 .66854 L p
.52066 .66183 L 0 1 .7 r
F P
0 0 0 r
s
P
p
.002 w
.49548 .66997 m .50912 .66854 L p
.49766 .6752 L 0 1 .75 r
F P
0 0 0 r
s
P
p
.002 w
.49548 .66997 m .48144 .74349 L .46818 .7399 L p
0 .9 1 r
F P
0 0 0 r
s
P
p
.002 w
.50912 .66854 m .49548 .66997 L .48195 .73872 L p
0 1 .8 r
F P
0 0 0 r
s
P
p
.002 w
.46818 .7399 m .48195 .73872 L .49548 .66997 L p
0 .9 1 r
F P
0 0 0 r
s
P
p
.68961 .33544 m .7146 .34111 L .70017 .34381 L 1 .6 0 r
F
P
p
.67516 .33818 m .68961 .33544 L .70017 .34381 L 1 .65 0 r
F
P
p
.63539 .33523 m .66083 .3409 L .6466 .3436 L .6 1 0 r
F
P
p
.62115 .33797 m .63539 .33523 L .6466 .3436 L .6 1 0 r
F
P
p
.58114 .33502 m .60702 .34069 L .59299 .34339 L .05 1 0 r
F
P
p
.5671 .33776 m .58114 .33502 L .59299 .34339 L 0 1 .1 r
F
P
p
.52686 .33481 m .55318 .34049 L .53936 .34319 L 0 1 .2 r
F
P
p
.51303 .33755 m .52686 .33481 L .53936 .34319 L 0 1 .45 r
F
P
p
.47254 .3346 m .4993 .34028 L .48569 .34298 L 0 1 .65 r
F
P
p
.45892 .33734 m .47254 .3346 L .48569 .34298 L 0 .55 1 r
F
P
p
.41819 .33439 m .4454 .34007 L .43199 .34277 L 0 .3 1 r
F
P
p
.40477 .33713 m .41819 .33439 L .43199 .34277 L 0 .05 1 r
F
P
p
.36381 .33417 m .39146 .33986 L .37825 .34256 L .65 0 1 r
F
P
p
.3506 .33692 m .36381 .33417 L .37825 .34256 L 1 0 .7 r
F
P
p
.002 w
.57672 .64323 m .56287 .65669 L .55061 .64001 L p
.15 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5367 .64157 m .55061 .64001 L .56287 .65669 L p
.05 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46788 .74464 m .45391 .79426 L .44064 .76669 L p
0 .2 1 r
F P
0 0 0 r
s
P
p
.002 w
.48144 .74349 m .46788 .74464 L .45425 .76561 L p
0 .5 1 r
F P
0 0 0 r
s
P
p
.002 w
.43925 .89371 m .45391 .79426 L .46629 .8949 L p
1 0 .55 r
F P
0 0 0 r
s
P
p
.002 w
.45391 .79426 m .43925 .89371 L .42537 .89192 L p
.9 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42537 .89192 m .44064 .76669 L .45391 .79426 L p
.9 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45425 .76561 m .43892 .88887 L p
.46246 .76903 L .2 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45425 .76561 m .46788 .74464 L p
.44614 .76224 L 0 .2 1 r
F P
0 0 0 r
s
P
p
.002 w
.45425 .76561 m .46818 .7399 L .48144 .74349 L p
0 .5 1 r
F P
0 0 0 r
s
P
p
.002 w
.46818 .7399 m .45425 .76561 L p
.46246 .76903 L .2 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44064 .76669 m .45425 .76561 L p
.44614 .76224 L 0 .2 1 r
F P
0 0 0 r
s
P
p
.002 w
.61681 .68076 m .60286 .69414 L .59064 .62971 L p
0 1 .05 r
F P
0 0 0 r
s
P
p
.002 w
.57672 .64323 m .59064 .62971 L .60286 .69414 L p
0 1 .15 r
F P
0 0 0 r
s
P
p
.002 w
.46629 .8949 m .45267 .90781 L .43925 .89371 L p
1 0 .55 r
F P
0 0 0 r
s
P
p
.002 w
.42557 .90673 m .43925 .89371 L .45267 .90781 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.75857 .3329 m .78309 .3386 L .76835 .34132 L 1 .15 0 r
F
P
p
.7438 .33566 m .75857 .3329 L .76835 .34132 L 1 .25 0 r
F
P
p
.002 w
.48195 .73872 m .49584 .73752 L .50912 .66854 L p
0 1 .8 r
F P
0 0 0 r
s
P
p
.70418 .33268 m .72915 .33839 L .7146 .34111 L 1 .5 0 r
F
P
p
.68961 .33544 m .70418 .33268 L .7146 .34111 L 1 .6 0 r
F
P
p
.002 w
.59064 .62971 m .57672 .64323 L .56463 .63844 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56463 .63844 m .57672 .64323 L p
.55437 .64047 L .15 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56463 .63844 m .55243 .70762 L p
.575 .63639 L 0 1 .35 r
F P
0 0 0 r
s
P
p
.002 w
.57869 .62475 m .59064 .62971 L p
.56791 .63734 L .3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56463 .63844 m .57869 .62475 L p
.56791 .63734 L .3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60474 .62811 m .59064 .62971 L .57869 .62475 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57869 .62475 m .59272 .59892 L .60474 .62811 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57869 .62475 m .56683 .70628 L p
.58955 .61207 L .1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59272 .59892 m .57869 .62475 L p
.58955 .61207 L .1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57869 .62475 m .56463 .63844 L p
.575 .63639 L 0 1 .35 r
F P
0 0 0 r
s
P
p
.002 w
.55061 .64001 m .56463 .63844 L p
.55437 .64047 L .15 1 0 r
F P
0 0 0 r
s
P
p
.64975 .33247 m .67516 .33818 L .66083 .3409 L .8 1 0 r
F
P
p
.63539 .33523 m .64975 .33247 L .66083 .3409 L .6 1 0 r
F
P
p
.59529 .33226 m .62115 .33797 L .60702 .34069 L .15 1 0 r
F
P
p
.58114 .33502 m .59529 .33226 L .60702 .34069 L .05 1 0 r
F
P
p
.002 w
.63083 .66732 m .61681 .68076 L .60474 .62811 L p
.15 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59064 .62971 m .60474 .62811 L .61681 .68076 L p
0 1 .05 r
F P
0 0 0 r
s
P
p
.54079 .33204 m .5671 .33776 L .55318 .34049 L 0 1 .1 r
F
P
p
.52686 .33481 m .54079 .33204 L .55318 .34049 L 0 1 .2 r
F
P
p
.48627 .33183 m .51303 .33755 L .4993 .34028 L 0 1 .1 r
F
P
p
.47254 .3346 m .48627 .33183 L .4993 .34028 L 0 1 .65 r
F
P
p
.43171 .33162 m .45892 .33734 L .4454 .34007 L 0 .9 1 r
F
P
p
.41819 .33439 m .43171 .33162 L .4454 .34007 L 0 .3 1 r
F
P
p
.37712 .3314 m .40477 .33713 L .39146 .33986 L .6 0 1 r
F
P
p
.36381 .33417 m .37712 .3314 L .39146 .33986 L .65 0 1 r
F
P
p
.32249 .33119 m .3506 .33692 L .33749 .33965 L 1 0 .05 r
F
P
p
.002 w
.5367 .64157 m .52288 .65508 L .50987 .72393 L p
0 1 .55 r
F P
0 0 0 r
s
P
p
.002 w
.49584 .73752 m .50987 .72393 L p
.50042 .72356 L 0 1 .7 r
F P
0 0 0 r
s
P
p
.002 w
.50987 .72393 m .49584 .73752 L .48231 .7589 L p
0 .55 1 r
F P
0 0 0 r
s
P
p
.002 w
.49584 .73752 m .48195 .73872 L .46826 .76002 L p
0 .4 1 r
F P
0 0 0 r
s
P
p
.002 w
.48231 .7589 m .49584 .73752 L p
.47383 .75548 L 0 .4 1 r
F P
0 0 0 r
s
P
p
.002 w
.46826 .76002 m .48231 .7589 L p
.47383 .75548 L 0 .4 1 r
F P
0 0 0 r
s
P
p
.002 w
.48231 .7589 m .46744 .88505 L p
.4909 .76236 L .3 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.49453 .7434 m .4966 .73256 L .50987 .72393 L p
0 .55 1 r
F P
0 0 0 r
s
P
p
.002 w
.4966 .73256 m .48231 .7589 L p
.4909 .76236 L .3 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.50987 .72393 m .4966 .73256 L p
.51943 .7243 L 0 .8 1 r
F P
0 0 0 r
s
P
p
.002 w
.52396 .72267 m .50987 .72393 L p
.51943 .7243 L 0 .8 1 r
F P
0 0 0 r
s
P
p
.002 w
.50987 .72393 m .52288 .65508 L p
.50042 .72356 L 0 1 .7 r
F P
0 0 0 r
s
P
p
.002 w
.64491 .65381 m .63083 .66732 L .61867 .60249 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60474 .62811 m .61867 .60249 L .63083 .66732 L p
.15 1 0 r
F P
0 0 0 r
s
P
p
.77346 .33012 m .79796 .33587 L .78309 .3386 L 1 .05 0 r
F
P
p
.75857 .3329 m .77346 .33012 L .78309 .3386 L 1 .15 0 r
F
P
p
.002 w
.42557 .90673 m .41216 .90725 L .39804 .90564 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.71885 .3299 m .7438 .33566 L .72915 .33839 L 1 .35 0 r
F
P
p
.70418 .33268 m .71885 .3299 L .72915 .33839 L 1 .5 0 r
F
P
p
.66422 .32969 m .68961 .33544 L .67516 .33818 L 1 .9 0 r
F
P
p
.64975 .33247 m .66422 .32969 L .67516 .33818 L .8 1 0 r
F
P
p
.002 w
.55061 .64001 m .5367 .64157 L .52396 .72267 L p
0 1 .45 r
F P
0 0 0 r
s
P
p
.002 w
.50987 .72393 m .52396 .72267 L .5367 .64157 L p
0 1 .55 r
F P
0 0 0 r
s
P
p
.60955 .32947 m .63539 .33523 L .62115 .33797 L .2 1 0 r
F
P
p
.59529 .33226 m .60955 .32947 L .62115 .33797 L .15 1 0 r
F
P
p
.55484 .32926 m .58114 .33502 L .5671 .33776 L 0 1 0 r
F
P
p
.54079 .33204 m .55484 .32926 L .5671 .33776 L 0 1 .1 r
F
P
p
.50011 .32904 m .52686 .33481 L .51303 .33755 L .25 1 0 r
F
P
p
.48627 .33183 m .50011 .32904 L .51303 .33755 L 0 1 .1 r
F
P
p
.44534 .32883 m .47254 .3346 L .45892 .33734 L 0 1 .65 r
F
P
p
.43171 .33162 m .44534 .32883 L .45892 .33734 L 0 .9 1 r
F
P
p
.002 w
.65906 .64025 m .64491 .65381 L .63278 .58879 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61867 .60249 m .63278 .58879 L .64491 .65381 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.39053 .32861 m .41819 .33439 L .40477 .33713 L .6 0 1 r
F
P
p
.37712 .3314 m .39053 .32861 L .40477 .33713 L .6 0 1 r
F
P
p
.3357 .32839 m .36381 .33417 L .3506 .33692 L 1 0 .75 r
F
P
p
.32249 .33119 m .3357 .32839 L .3506 .33692 L 1 0 .05 r
F
P
p
.002 w
.61867 .60249 m .60474 .62811 L .59272 .59892 L p
.7 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63278 .58879 m .61867 .60249 L .607 .59717 L p
.85 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59272 .59892 m .607 .59717 L .61867 .60249 L p
.7 1 0 r
F P
0 0 0 r
s
P
p
.78846 .32731 m .81293 .33311 L .79796 .33587 L 1 0 0 r
F
P
p
.77346 .33012 m .78846 .32731 L .79796 .33587 L 1 .05 0 r
F
P
p
.002 w
.43925 .89371 m .42557 .90673 L .41156 .9051 L p
1 0 .1 r
F P
0 0 0 r
s
P
p
.002 w
.39804 .90564 m .41156 .9051 L .42557 .90673 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67327 .62662 m .65906 .64025 L .64695 .57502 L p
.75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63278 .58879 m .64695 .57502 L .65906 .64025 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.73365 .3271 m .75857 .3329 L .7438 .33566 L 1 .25 0 r
F
P
p
.71885 .3299 m .73365 .3271 L .7438 .33566 L 1 .35 0 r
F
P
p
.6788 .32688 m .70418 .33268 L .68961 .33544 L 1 .8 0 r
F
P
p
.66422 .32969 m .6788 .32688 L .68961 .33544 L 1 .9 0 r
F
P
p
.002 w
.56463 .63844 m .55061 .64001 L .53815 .70895 L p
0 1 .4 r
F P
0 0 0 r
s
P
p
.002 w
.53815 .70895 m .55061 .64001 L p
.52783 .71066 L 0 1 .45 r
F P
0 0 0 r
s
P
p
.002 w
.53815 .70895 m .55243 .70762 L .56463 .63844 L p
0 1 .4 r
F P
0 0 0 r
s
P
p
.002 w
.53815 .70895 m .5252 .70483 L p
.54857 .70723 L 0 1 .95 r
F P
0 0 0 r
s
P
p
.002 w
.55243 .70762 m .53815 .70895 L p
.54857 .70723 L 0 1 .95 r
F P
0 0 0 r
s
P
p
.002 w
.52396 .72267 m .53815 .70895 L p
.52783 .71066 L 0 1 .45 r
F P
0 0 0 r
s
P
p
.62392 .32666 m .64975 .33247 L .63539 .33523 L .2 1 0 r
F
P
p
.60955 .32947 m .62392 .32666 L .63539 .33523 L .2 1 0 r
F
P
p
.569 .32645 m .59529 .33226 L .58114 .33502 L .2 1 0 r
F
P
p
.55484 .32926 m .569 .32645 L .58114 .33502 L 0 1 0 r
F
P
p
.51405 .32623 m .54079 .33204 L .52686 .33481 L .5 1 0 r
F
P
p
.50011 .32904 m .51405 .32623 L .52686 .33481 L .25 1 0 r
F
P
p
.002 w
.6214 .59542 m .63278 .58879 L p
.61565 .59436 L .85 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.607 .59717 m .6214 .59542 L p
.61565 .59436 L .85 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6214 .59542 m .60996 .62697 L p
.62723 .59649 L .55 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64695 .57502 m .63278 .58879 L .6214 .59542 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6214 .59542 m .63574 .58148 L .64695 .57502 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63574 .58148 m .6214 .59542 L p
.62723 .59649 L .55 1 0 r
F P
0 0 0 r
s
P
p
.45907 .32601 m .48627 .33183 L .47254 .3346 L 0 1 .5 r
F
P
p
.44534 .32883 m .45907 .32601 L .47254 .3346 L 0 1 .65 r
F
P
p
.002 w
.44064 .76669 m .42537 .89192 L .41115 .89009 L p
1 0 .7 r
F P
0 0 0 r
s
P
p
.002 w
.45425 .76561 m .44064 .76669 L .42498 .88948 L p
.8 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41115 .89009 m .42498 .88948 L .44064 .76669 L p
1 0 .7 r
F P
0 0 0 r
s
P
p
.40406 .3258 m .43171 .33162 L .41819 .33439 L .3 0 1 r
F
P
p
.39053 .32861 m .40406 .3258 L .41819 .33439 L .6 0 1 r
F
P
p
.002 w
.41156 .9051 m .42537 .89192 L .43925 .89371 L p
1 0 .1 r
F P
0 0 0 r
s
P
p
.34901 .32558 m .37712 .3314 L .36381 .33417 L 0 0 1 r
F
P
p
.3357 .32839 m .34901 .32558 L .36381 .33417 L 1 0 .75 r
F
P
p
.002 w
.6878 .625 m .67327 .62662 L .66139 .57319 L p
.8 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64695 .57502 m .66139 .57319 L .67327 .62662 L p
.75 1 0 r
F P
0 0 0 r
s
P
p
.80358 .32449 m .82803 .33033 L .81293 .33311 L 1 0 0 r
F
P
p
.78846 .32731 m .80358 .32449 L .81293 .33311 L 1 0 0 r
F
P
p
.002 w
.66139 .57319 m .64695 .57502 L .63574 .58148 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.74856 .32427 m .77346 .33012 L .75857 .3329 L 1 .1 0 r
F
P
p
.73365 .3271 m .74856 .32427 L .75857 .3329 L 1 .25 0 r
F
P
p
.69349 .32405 m .71885 .3299 L .70418 .33268 L 1 .75 0 r
F
P
p
.6788 .32688 m .69349 .32405 L .70418 .33268 L 1 .8 0 r
F
P
p
.6384 .32383 m .66422 .32969 L .64975 .33247 L .4 1 0 r
F
P
p
.62392 .32666 m .6384 .32383 L .64975 .33247 L .2 1 0 r
F
P
p
.58327 .32362 m .60955 .32947 L .59529 .33226 L .35 1 0 r
F
P
p
.569 .32645 m .58327 .32362 L .59529 .33226 L .2 1 0 r
F
P
p
.52811 .3234 m .55484 .32926 L .54079 .33204 L .65 1 0 r
F
P
p
.51405 .32623 m .52811 .3234 L .54079 .33204 L .5 1 0 r
F
P
p
.47292 .32318 m .50011 .32904 L .48627 .33183 L 0 1 .15 r
F
P
p
.45907 .32601 m .47292 .32318 L .48627 .33183 L 0 1 .5 r
F
P
p
.002 w
.42498 .88948 m .43892 .88887 L .45425 .76561 L p
.8 0 1 r
F P
0 0 0 r
s
P
p
.41769 .32296 m .44534 .32883 L .43171 .33162 L 0 .6 1 r
F
P
p
.40406 .3258 m .41769 .32296 L .43171 .33162 L .3 0 1 r
F
P
p
.36242 .32274 m .39053 .32861 L .37712 .3314 L 0 .65 1 r
F
P
p
.34901 .32558 m .36242 .32274 L .37712 .3314 L 0 0 1 r
F
P
p
.002 w
.70244 .62336 m .6878 .625 L .67595 .57135 L p
.85 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66139 .57319 m .67595 .57135 L p
.6658 .58184 L .8 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.67595 .57135 m .66139 .57319 L .65034 .57965 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.66506 .57781 m .67595 .57135 L p
.65679 .57756 L 1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.65034 .57965 m .66506 .57781 L p
.65679 .57756 L 1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.67595 .57135 m .6878 .625 L p
.6658 .58184 L .8 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66506 .57781 m .65716 .61073 L p
.67344 .57805 L .8 1 0 r
F P
0 0 0 r
s
P
p
.66296 .60228 m .67344 .57805 L .65716 .61073 L .8 1 0 r
F
P
p
.002 w
.67595 .57135 m .66506 .57781 L p
.68619 .56077 L 1 .8 0 r
F P
0 0 0 r
s
P
p
.002 w
.69037 .5574 m .67595 .57135 L p
.68619 .56077 L 1 .8 0 r
F P
0 0 0 r
s
P
p
.002 w
.67595 .57135 m .69037 .5574 L .70244 .62336 L p
.85 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66506 .57781 m .67966 .56368 L .69037 .5574 L p
1 .8 0 r
F P
0 0 0 r
s
P
p
.002 w
.67966 .56368 m .66506 .57781 L p
.67344 .57805 L .8 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71629 .58537 m .70244 .62336 L .69037 .5574 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.70485 .54339 m .69037 .5574 L .67966 .56368 L p
1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.69037 .5574 m .70485 .54339 L .71629 .58537 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.67966 .56368 m .69459 .56176 L .70485 .54339 L p
1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.65716 .61073 m .65448 .62191 L p
.66296 .60228 L .8 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65448 .62191 m .66887 .58259 L .67966 .56368 L p
.8 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69459 .56176 m .67966 .56368 L .66887 .58259 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.66887 .58259 m .68348 .55575 L .69184 .56027 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.69184 .56027 m .69459 .56176 L p
.68608 .56865 L 1 .9 0 r
F P
0 0 0 r
s
P
p
.66887 .58259 m .69184 .56027 L .68608 .56865 L 1 .9 0 r
F
P
p
.002 w
.43892 .88887 m .45433 .76114 L .46818 .7399 L p
.2 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48195 .73872 m .46818 .7399 L .45433 .76114 L p
0 .4 1 r
F P
0 0 0 r
s
P
p
.30713 .32252 m .3357 .32839 L .32249 .33119 L 1 0 0 r
F
P
p
.002 w
.55243 .70762 m .56683 .70628 L .57869 .62475 L p
0 1 .35 r
F P
0 0 0 r
s
P
p
.002 w
.56683 .70628 m .58087 .63028 L .59272 .59892 L p
.1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.607 .59717 m .59272 .59892 L .58087 .63028 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.81883 .32164 m .84324 .32753 L .82803 .33033 L 1 0 0 r
F
P
p
.80358 .32449 m .81883 .32164 L .82803 .33033 L 1 0 0 r
F
P
p
.002 w
.63574 .58148 m .65034 .57965 L .66139 .57319 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.76358 .32142 m .78846 .32731 L .77346 .33012 L 1 0 0 r
F
P
p
.74856 .32427 m .76358 .32142 L .77346 .33012 L 1 .1 0 r
F
P
p
.002 w
.41156 .9051 m .39804 .90564 L .38357 .90398 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70831 .3212 m .73365 .3271 L .71885 .3299 L 1 .7 0 r
F
P
p
.69349 .32405 m .70831 .3212 L .71885 .3299 L 1 .75 0 r
F
P
p
.653 .32098 m .6788 .32688 L .66422 .32969 L .75 1 0 r
F
P
p
.6384 .32383 m .653 .32098 L .66422 .32969 L .4 1 0 r
F
P
p
.59766 .32076 m .62392 .32666 L .60955 .32947 L .5 1 0 r
F
P
p
.58327 .32362 m .59766 .32076 L .60955 .32947 L .35 1 0 r
F
P
p
.002 w
.73076 .57149 m .71629 .58537 L .70485 .54339 L p
1 .65 0 r
F P
0 0 0 r
s
P
p
.54228 .32054 m .569 .32645 L .55484 .32926 L .7 1 0 r
F
P
p
.52811 .3234 m .54228 .32054 L .55484 .32926 L .65 1 0 r
F
P
p
.48687 .32032 m .51405 .32623 L .50011 .32904 L .2 1 0 r
F
P
p
.47292 .32318 m .48687 .32032 L .50011 .32904 L 0 1 .15 r
F
P
p
.43142 .3201 m .45907 .32601 L .44534 .32883 L 0 1 .75 r
F
P
p
.41769 .32296 m .43142 .3201 L .44534 .32883 L 0 .6 1 r
F
P
p
.37595 .31988 m .40406 .3258 L .39053 .32861 L 0 .75 1 r
F
P
p
.36242 .32274 m .37595 .31988 L .39053 .32861 L 0 .65 1 r
F
P
p
.002 w
.45433 .76114 m .46826 .76002 L .48195 .73872 L p
0 .4 1 r
F P
0 0 0 r
s
P
p
.32043 .31966 m .34901 .32558 L .3357 .32839 L 1 0 .05 r
F
P
p
.30713 .32252 m .32043 .31966 L .3357 .32839 L 1 0 0 r
F
P
p
.002 w
.6214 .59542 m .607 .59717 L .59536 .62863 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58087 .63028 m .59536 .62863 L .607 .59717 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7453 .55755 m .73076 .57149 L .71971 .54142 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.71971 .54142 m .73076 .57149 L p
.71005 .54904 L 1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.71971 .54142 m .73435 .52728 L .7453 .55755 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.71971 .54142 m .70964 .55982 L p
.72946 .53372 L 1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.73435 .52728 m .71971 .54142 L p
.72946 .53372 L 1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.70485 .54339 m .71971 .54142 L p
.71005 .54904 L 1 .65 0 r
F P
0 0 0 r
s
P
p
.83419 .31877 m .85858 .32471 L .84324 .32753 L 1 0 0 r
F
P
p
.81883 .32164 m .83419 .31877 L .84324 .32753 L 1 0 0 r
F
P
p
.77873 .31855 m .80358 .32449 L .78846 .32731 L 1 0 0 r
F
P
p
.76358 .32142 m .77873 .31855 L .78846 .32731 L 1 0 0 r
F
P
p
.002 w
.42537 .89192 m .41156 .9051 L .3972 .90344 L p
1 0 .1 r
F P
0 0 0 r
s
P
p
.002 w
.38357 .90398 m .3972 .90344 L .41156 .9051 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.72324 .31833 m .74856 .32427 L .73365 .3271 L 1 .5 0 r
F
P
p
.70831 .3212 m .72324 .31833 L .73365 .3271 L 1 .7 0 r
F
P
p
.66772 .31811 m .69349 .32405 L .6788 .32688 L .95 1 0 r
F
P
p
.653 .32098 m .66772 .31811 L .6788 .32688 L .75 1 0 r
F
P
p
.61216 .31788 m .6384 .32383 L .62392 .32666 L .6 1 0 r
F
P
p
.59766 .32076 m .61216 .31788 L .62392 .32666 L .5 1 0 r
F
P
p
.55656 .31766 m .58327 .32362 L .569 .32645 L .75 1 0 r
F
P
p
.54228 .32054 m .55656 .31766 L .569 .32645 L .7 1 0 r
F
P
p
.50093 .31744 m .52811 .3234 L .51405 .32623 L .35 1 0 r
F
P
p
.48687 .32032 m .50093 .31744 L .51405 .32623 L .2 1 0 r
F
P
p
.002 w
.76027 .55563 m .7453 .55755 L .73435 .52728 L p
1 .35 0 r
F P
0 0 0 r
s
P
p
.44527 .31722 m .47292 .32318 L .45907 .32601 L 0 1 .55 r
F
P
p
.43142 .3201 m .44527 .31722 L .45907 .32601 L 0 1 .75 r
F
P
p
.38958 .31699 m .41769 .32296 L .40406 .3258 L 0 .9 1 r
F
P
p
.37595 .31988 m .38958 .31699 L .40406 .3258 L 0 .75 1 r
F
P
p
.002 w
.3972 .90344 m .41115 .89009 L .42537 .89192 L p
1 0 .1 r
F P
0 0 0 r
s
P
p
.33385 .31677 m .36242 .32274 L .34901 .32558 L 1 0 .7 r
F
P
p
.32043 .31966 m .33385 .31677 L .34901 .32558 L 1 0 .05 r
F
P
p
.002 w
.59536 .62863 m .60996 .62697 L .6214 .59542 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.84968 .31588 m .87403 .32186 L .85858 .32471 L 1 0 0 r
F
P
p
.83419 .31877 m .84968 .31588 L .85858 .32471 L 1 0 0 r
F
P
p
.794 .31566 m .81883 .32164 L .80358 .32449 L 1 0 0 r
F
P
p
.77873 .31855 m .794 .31566 L .80358 .32449 L 1 0 0 r
F
P
p
.73829 .31543 m .76358 .32142 L .74856 .32427 L 1 .15 0 r
F
P
p
.72324 .31833 m .73829 .31543 L .74856 .32427 L 1 .5 0 r
F
P
p
.002 w
.71971 .54142 m .70485 .54339 L .69459 .56176 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.68255 .31521 m .70831 .3212 L .69349 .32405 L 1 1 0 r
F
P
p
.66772 .31811 m .68255 .31521 L .69349 .32405 L .95 1 0 r
F
P
p
.62677 .31498 m .653 .32098 L .6384 .32383 L .7 1 0 r
F
P
p
.61216 .31788 m .62677 .31498 L .6384 .32383 L .6 1 0 r
F
P
p
.57096 .31476 m .59766 .32076 L .58327 .32362 L .85 1 0 r
F
P
p
.55656 .31766 m .57096 .31476 L .58327 .32362 L .75 1 0 r
F
P
p
.51511 .31454 m .54228 .32054 L .52811 .3234 L .45 1 0 r
F
P
p
.50093 .31744 m .51511 .31454 L .52811 .3234 L .35 1 0 r
F
P
p
.002 w
.65034 .57965 m .63574 .58148 L .62468 .6253 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60996 .62697 m .62468 .6253 L .63574 .58148 L p
.55 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.77497 .54157 m .76027 .55563 L .74906 .51308 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.73435 .52728 m .74906 .51308 L .76027 .55563 L p
1 .35 0 r
F P
0 0 0 r
s
P
p
.45923 .31431 m .48687 .32032 L .47292 .32318 L 0 1 .2 r
F
P
p
.44527 .31722 m .45923 .31431 L .47292 .32318 L 0 1 .55 r
F
P
p
.40332 .31409 m .43142 .3201 L .41769 .32296 L 0 1 .7 r
F
P
p
.38958 .31699 m .40332 .31409 L .41769 .32296 L 0 .9 1 r
F
P
p
.34737 .31386 m .37595 .31988 L .36242 .32274 L .6 0 1 r
F
P
p
.33385 .31677 m .34737 .31386 L .36242 .32274 L 1 0 .7 r
F
P
p
.29138 .31364 m .32043 .31966 L .30713 .32252 L 1 0 0 r
F
P
p
.86529 .31296 m .88961 .31899 L .87403 .32186 L 1 0 0 r
F
P
p
.84968 .31588 m .86529 .31296 L .87403 .32186 L 1 0 0 r
F
P
p
.8094 .31274 m .83419 .31877 L .81883 .32164 L 1 0 0 r
F
P
p
.794 .31566 m .8094 .31274 L .81883 .32164 L 1 0 0 r
F
P
p
.002 w
.78974 .52744 m .77497 .54157 L .76422 .51096 L p
1 .15 0 r
F P
0 0 0 r
s
P
p
.002 w
.74906 .51308 m .76422 .51096 L .77497 .54157 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.3972 .90344 m .38357 .90398 L .36875 .90229 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.75347 .31251 m .77873 .31855 L .76358 .32142 L 1 0 0 r
F
P
p
.73829 .31543 m .75347 .31251 L .76358 .32142 L 1 .15 0 r
F
P
p
.002 w
.69459 .56176 m .70964 .55982 L .71971 .54142 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.53815 .70895 m .52396 .72267 L .51091 .70618 L p
0 .95 1 r
F P
0 0 0 r
s
P
p
.002 w
.4966 .73256 m .51091 .70618 L .52396 .72267 L p
0 .8 1 r
F P
0 0 0 r
s
P
p
.6975 .31229 m .72324 .31833 L .70831 .3212 L 1 .95 0 r
F
P
p
.68255 .31521 m .6975 .31229 L .70831 .3212 L 1 1 0 r
F
P
p
.64151 .31206 m .66772 .31811 L .653 .32098 L .9 1 0 r
F
P
p
.62677 .31498 m .64151 .31206 L .653 .32098 L .7 1 0 r
F
P
p
.58547 .31184 m .61216 .31788 L .59766 .32076 L 1 1 0 r
F
P
p
.57096 .31476 m .58547 .31184 L .59766 .32076 L .85 1 0 r
F
P
p
.52941 .31161 m .55656 .31766 L .54228 .32054 L .5 1 0 r
F
P
p
.51511 .31454 m .52941 .31161 L .54228 .32054 L .45 1 0 r
F
P
p
.002 w
.66506 .57781 m .65034 .57965 L .63952 .62361 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62468 .6253 m .63952 .62361 L .65034 .57965 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.4733 .31138 m .50093 .31744 L .48687 .32032 L .1 1 0 r
F
P
p
.45923 .31431 m .4733 .31138 L .48687 .32032 L 0 1 .2 r
F
P
p
.002 w
.45433 .76114 m .43892 .88887 L .42457 .88696 L p
1 0 .7 r
F P
0 0 0 r
s
P
p
.002 w
.46826 .76002 m .45433 .76114 L .43875 .88633 L p
.8 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42457 .88696 m .43875 .88633 L .45433 .76114 L p
1 0 .7 r
F P
0 0 0 r
s
P
p
.41717 .31116 m .44527 .31722 L .43142 .3201 L 0 1 .3 r
F
P
p
.40332 .31409 m .41717 .31116 L .43142 .3201 L 0 1 .7 r
F
P
p
.361 .31093 m .38958 .31699 L .37595 .31988 L 0 .15 1 r
F
P
p
.34737 .31386 m .361 .31093 L .37595 .31988 L .6 0 1 r
F
P
p
.002 w
.80457 .51324 m .78974 .52744 L .77951 .50883 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.002 w
.76422 .51096 m .77951 .50883 L .78974 .52744 L p
1 .15 0 r
F P
0 0 0 r
s
P
p
.30479 .3107 m .33385 .31677 L .32043 .31966 L 1 0 .05 r
F
P
p
.29138 .31364 m .30479 .3107 L .32043 .31966 L 1 0 0 r
F
P
p
.002 w
.74906 .51308 m .73435 .52728 L .72449 .54551 L p
1 .35 0 r
F P
0 0 0 r
s
P
p
.002 w
.70964 .55982 m .72449 .54551 L p
.72207 .54344 L 1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.72449 .54551 m .70964 .55982 L .69868 .55377 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.72449 .54551 m .714 .55177 L p
.72694 .54761 L 1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.73975 .54349 m .72449 .54551 L p
.72694 .54761 L 1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.72449 .54551 m .73435 .52728 L p
.72207 .54344 L 1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.51091 .70618 m .5252 .70483 L .53815 .70895 L p
0 .95 1 r
F P
0 0 0 r
s
P
p
.88103 .31002 m .90532 .3161 L .88961 .31899 L 1 0 0 r
F
P
p
.86529 .31296 m .88103 .31002 L .88961 .31899 L 1 0 0 r
F
P
p
.82491 .3098 m .84968 .31588 L .83419 .31877 L 1 0 0 r
F
P
p
.8094 .31274 m .82491 .3098 L .83419 .31877 L 1 0 0 r
F
P
p
.76876 .30957 m .794 .31566 L .77873 .31855 L 1 0 0 r
F
P
p
.75347 .31251 m .76876 .30957 L .77873 .31855 L 1 0 0 r
F
P
p
.002 w
.41115 .89009 m .3972 .90344 L .38249 .90173 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.36875 .90229 m .38249 .90173 L .3972 .90344 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.71258 .30934 m .73829 .31543 L .72324 .31833 L 1 .7 0 r
F
P
p
.6975 .31229 m .71258 .30934 L .72324 .31833 L 1 .95 0 r
F
P
p
.002 w
.81995 .51113 m .80457 .51324 L .79492 .50668 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77951 .50883 m .79492 .50668 L .80457 .51324 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.002 w
.58087 .63028 m .56683 .70628 L .55407 .67684 L p
0 1 .5 r
F P
0 0 0 r
s
P
p
.002 w
.59536 .62863 m .58087 .63028 L .56867 .67536 L p
0 1 .1 r
F P
0 0 0 r
s
P
p
.002 w
.55407 .67684 m .56867 .67536 L .58087 .63028 L p
0 1 .5 r
F P
0 0 0 r
s
P
p
.65636 .30911 m .68255 .31521 L .66772 .31811 L 1 .95 0 r
F
P
p
.64151 .31206 m .65636 .30911 L .66772 .31811 L .9 1 0 r
F
P
p
.002 w
.76422 .51096 m .74906 .51308 L .73975 .54349 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.72449 .54551 m .73975 .54349 L .74906 .51308 L p
1 .35 0 r
F P
0 0 0 r
s
P
p
.6001 .30889 m .62677 .31498 L .61216 .31788 L 1 .9 0 r
F
P
p
.58547 .31184 m .6001 .30889 L .61216 .31788 L 1 1 0 r
F
P
p
.54381 .30866 m .57096 .31476 L .55656 .31766 L .5 1 0 r
F
P
p
.52941 .31161 m .54381 .30866 L .55656 .31766 L .5 1 0 r
F
P
p
.002 w
.63952 .62361 m .65448 .62191 L .66506 .57781 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.48749 .30843 m .51511 .31454 L .50093 .31744 L .2 1 0 r
F
P
p
.4733 .31138 m .48749 .30843 L .50093 .31744 L .1 1 0 r
F
P
p
.002 w
.48231 .7589 m .46826 .76002 L .45303 .8857 L p
.8 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43875 .88633 m .45303 .8857 L .46826 .76002 L p
.8 0 1 r
F P
0 0 0 r
s
P
p
.43113 .3082 m .45923 .31431 L .44527 .31722 L 0 1 .1 r
F
P
p
.41717 .31116 m .43113 .3082 L .44527 .31722 L 0 1 .3 r
F
P
p
.37474 .30797 m .40332 .31409 L .38958 .31699 L 0 1 1 r
F
P
p
.361 .31093 m .37474 .30797 L .38958 .31699 L 0 .15 1 r
F
P
p
.002 w
.42498 .88948 m .41115 .89009 L .39634 .90116 L p
1 0 .15 r
F P
0 0 0 r
s
P
p
.002 w
.38249 .90173 m .39634 .90116 L .41115 .89009 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.31831 .30775 m .34737 .31386 L .33385 .31677 L 1 0 .1 r
F
P
p
.30479 .3107 m .31831 .30775 L .33385 .31677 L 1 0 .05 r
F
P
p
.002 w
.56683 .70628 m .55243 .70762 L .5396 .69087 L p
0 1 .85 r
F P
0 0 0 r
s
P
p
.002 w
.5252 .70483 m .5396 .69087 L .55243 .70762 L p
0 1 .95 r
F P
0 0 0 r
s
P
p
.89689 .30706 m .92115 .31319 L .90532 .3161 L 1 0 0 r
F
P
p
.88103 .31002 m .89689 .30706 L .90532 .3161 L 1 0 0 r
F
P
p
.84056 .30683 m .86529 .31296 L .84968 .31588 L 1 0 0 r
F
P
p
.82491 .3098 m .84056 .30683 L .84968 .31588 L 1 0 0 r
F
P
p
.78418 .3066 m .8094 .31274 L .794 .31566 L 1 0 0 r
F
P
p
.76876 .30957 m .78418 .3066 L .794 .31566 L 1 0 0 r
F
P
p
.72778 .30637 m .75347 .31251 L .73829 .31543 L 1 .45 0 r
F
P
p
.71258 .30934 m .72778 .30637 L .73829 .31543 L 1 .7 0 r
F
P
p
.002 w
.83546 .50899 m .81995 .51113 L .81045 .50451 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79492 .50668 m .81045 .50451 L .81995 .51113 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58322 .64859 m .59536 .62863 L p
.57318 .66747 L 0 1 .1 r
F P
0 0 0 r
s
P
p
.002 w
.56867 .67536 m .58322 .64859 L p
.57318 .66747 L 0 1 .1 r
F P
0 0 0 r
s
P
p
.002 w
.58322 .64859 m .57037 .60557 L p
.59333 .62958 L .2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60996 .62697 m .59536 .62863 L .58322 .64859 L p
.05 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5979 .63436 m .58322 .64859 L p
.59333 .62958 L .2 1 0 r
F P
0 0 0 r
s
P
p
.67133 .30614 m .6975 .31229 L .68255 .31521 L 1 .85 0 r
F
P
p
.65636 .30911 m .67133 .30614 L .68255 .31521 L 1 .95 0 r
F
P
p
.002 w
.43875 .88633 m .42457 .88696 L .42368 .86807 L p
0 .05 1 r
F P
0 0 0 r
s
P
p
.002 w
.42368 .86807 m .41592 .70322 L p
.43041 .81944 L 0 .05 1 r
F P
0 0 0 r
s
P
p
.43041 .81944 m .43875 .88633 L .42368 .86807 L 0 .05 1 r
F
P
p
.41829 .69769 m .43875 .88633 L .41592 .70322 L 0 .05 1 r
F
P
p
.002 w
.41363 .65464 m .42768 .64065 L .43875 .88633 L p
0 .05 1 r
F P
0 0 0 r
s
P
p
.002 w
.45303 .8857 m .43875 .88633 L .42768 .64065 L p
0 .1 1 r
F P
0 0 0 r
s
P
p
.002 w
.42768 .64065 m .44164 .63903 L .44207 .64834 L p
0 .1 1 r
F P
0 0 0 r
s
P
p
.002 w
.44207 .64834 m .45303 .8857 L p
.42952 .6584 L 0 .1 1 r
F P
0 0 0 r
s
P
p
.42768 .64065 m .44207 .64834 L .42952 .6584 L 0 .1 1 r
F
P
p
.002 w
.45303 .8857 m .46744 .88505 L .48231 .7589 L p
.8 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46744 .88505 m .45303 .8857 L .44164 .63903 L p
0 .1 1 r
F P
0 0 0 r
s
P
p
.002 w
.44164 .63903 m .45572 .6374 L .4571 .6666 L p
0 .1 1 r
F P
0 0 0 r
s
P
p
.002 w
.4571 .6666 m .46744 .88505 L p
.44633 .68371 L 0 .1 1 r
F P
0 0 0 r
s
P
p
.44164 .63903 m .4571 .6666 L .44633 .68371 L 0 .1 1 r
F
P
p
.002 w
.48269 .77989 m .46744 .88505 L .45572 .6374 L p
0 .55 1 r
F P
0 0 0 r
s
P
p
.002 w
.45572 .6374 m .47002 .62322 L .48269 .77989 L p
0 .55 1 r
F P
0 0 0 r
s
P
p
.002 w
.49758 .68934 m .48269 .77989 L .47002 .62322 L p
0 1 .65 r
F P
0 0 0 r
s
P
p
.002 w
.4843 .62152 m .49758 .68934 L p
.47231 .62873 L 0 1 .65 r
F P
0 0 0 r
s
P
p
.002 w
.47002 .62322 m .4843 .62152 L p
.47231 .62873 L 0 1 .65 r
F P
0 0 0 r
s
P
p
.002 w
.51209 .65006 m .49758 .68934 L .4843 .62152 L p
0 1 .1 r
F P
0 0 0 r
s
P
p
.002 w
.4843 .62152 m .49876 .60721 L .51209 .65006 L p
0 1 .1 r
F P
0 0 0 r
s
P
p
.002 w
.4843 .62152 m .4697 .69328 L p
.49638 .61425 L 0 1 .15 r
F P
0 0 0 r
s
P
p
.002 w
.49876 .60721 m .4843 .62152 L p
.49638 .61425 L 0 1 .15 r
F P
0 0 0 r
s
P
p
.002 w
.45487 .72068 m .4697 .69328 L .48373 .62433 L p
0 1 .5 r
F P
0 0 0 r
s
P
p
.002 w
.48373 .62433 m .4843 .62152 L p
.48323 .62511 L 0 1 .5 r
F P
0 0 0 r
s
P
p
.45487 .72068 m .48373 .62433 L .48323 .62511 L 0 1 .5 r
F
P
p
.002 w
.45572 .6374 m .44164 .63903 L .4245 .82814 L p
0 .9 1 r
F P
0 0 0 r
s
P
p
.002 w
.44038 .72201 m .45512 .64071 L p
.43671 .75343 L 0 .9 1 r
F P
0 0 0 r
s
P
p
.002 w
.4245 .82814 m .44038 .72201 L p
.43671 .75343 L 0 .9 1 r
F P
0 0 0 r
s
P
p
.002 w
.3985 .73112 m .41363 .65464 L .42457 .88696 L p
.3 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41052 .88759 m .39634 .90116 L .38843 .78627 L p
.65 0 1 r
F P
0 0 0 r
s
P
p
.39214 .77705 m .41052 .88759 L .38843 .78627 L .65 0 1 r
F
P
p
.002 w
.3985 .73112 m .40071 .75991 L p
.39388 .74815 L .65 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.40071 .75991 m .41052 .88759 L p
.39214 .77705 L .65 0 1 r
F P
0 0 0 r
s
P
p
.38472 .73236 m .40071 .75991 L .39214 .77705 L .65 0 1 r
F
P
p
.002 w
.36769 .88692 m .38472 .73236 L .39634 .90116 L p
1 0 .7 r
F P
0 0 0 r
s
P
p
.002 w
.42457 .88696 m .41052 .88759 L .40071 .75991 L p
.3 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.40071 .75991 m .3985 .73112 L p
.40266 .756 L .3 0 1 r
F P
0 0 0 r
s
P
p
.40266 .756 m .42457 .88696 L .40071 .75991 L .3 0 1 r
F
P
p
.4348 .69172 m .43987 .65861 L .43895 .6609 L 0 .3 1 r
F
P
p
.40919 .88233 m .43553 .69027 L .4348 .69172 L 0 .3 1 r
F
P
p
.43553 .69027 m .43987 .65861 L .4348 .69172 L 0 .3 1 r
F
P
p
.002 w
.3985 .73112 m .38048 .88365 L p
.4072 .69902 L .3 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41363 .65464 m .3985 .73112 L p
.4072 .69902 L .3 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38472 .73236 m .3985 .73112 L p
.39388 .74815 L .65 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.40919 .88233 m .4245 .82814 L .43732 .68668 L p
0 .3 1 r
F P
0 0 0 r
s
P
p
.002 w
.43732 .68668 m .43987 .65861 L p
.43553 .69027 L 0 .3 1 r
F P
0 0 0 r
s
P
p
.40919 .88233 m .43732 .68668 L .43553 .69027 L 0 .3 1 r
F
P
p
.002 w
.43987 .65861 m .44114 .64455 L p
.43895 .6609 L 0 .3 1 r
F P
0 0 0 r
s
P
p
.002 w
.38843 .78627 m .38472 .73236 L p
.39214 .77705 L .65 0 1 r
F P
0 0 0 r
s
P
p
.40919 .88233 m .44114 .64455 L .4408 .64535 L 0 .3 1 r
F
P
p
.002 w
.41592 .70322 m .41363 .65464 L p
.41829 .69769 L 0 .05 1 r
F P
0 0 0 r
s
P
p
.002 w
.42768 .64065 m .41363 .65464 L .39478 .883 L p
0 .05 1 r
F P
0 0 0 r
s
P
p
.002 w
.44164 .63903 m .42768 .64065 L .40919 .88233 L p
0 .3 1 r
F P
0 0 0 r
s
P
p
.002 w
.39478 .883 m .40919 .88233 L .42768 .64065 L p
0 .05 1 r
F P
0 0 0 r
s
P
p
.002 w
.44038 .72201 m .42676 .63992 L p
.44415 .68988 L 0 1 .75 r
F P
0 0 0 r
s
P
p
.002 w
.45512 .64071 m .45572 .6374 L p
.4548 .64299 L 0 .9 1 r
F P
0 0 0 r
s
P
p
.43364 .7723 m .45512 .64071 L .4548 .64299 L 0 .9 1 r
F
P
p
.4245 .82814 m .4337 .77181 L .43364 .7723 L 0 .9 1 r
F
P
p
.4337 .77181 m .45512 .64071 L .43364 .7723 L 0 .9 1 r
F
P
p
.002 w
.44114 .64455 m .44164 .63903 L p
.4408 .64535 L 0 .3 1 r
F P
0 0 0 r
s
P
p
.002 w
.42676 .63992 m .44138 .62536 L .44716 .66623 L p
0 1 .75 r
F P
0 0 0 r
s
P
p
.002 w
.45572 .6374 m .44038 .72201 L p
.46894 .6268 L 0 1 .65 r
F P
0 0 0 r
s
P
p
.002 w
.44038 .72201 m .45487 .72068 L .47002 .62322 L p
0 1 .65 r
F P
0 0 0 r
s
P
p
.002 w
.44716 .66623 m .4539 .71388 L p
.44415 .68988 L 0 1 .75 r
F P
0 0 0 r
s
P
p
.002 w
.4539 .71388 m .45487 .72068 L p
.45286 .71491 L 0 1 .75 r
F P
0 0 0 r
s
P
p
.44415 .68988 m .4539 .71388 L .45286 .71491 L 0 1 .75 r
F
P
p
.42676 .63992 m .44716 .66623 L .44415 .68988 L 0 1 .75 r
F
P
p
.002 w
.45487 .72068 m .44038 .72201 L p
.44415 .68988 L 0 1 .75 r
F P
0 0 0 r
s
P
p
.002 w
.47002 .62322 m .45572 .6374 L p
.46894 .6268 L 0 1 .65 r
F P
0 0 0 r
s
P
p
.002 w
.38048 .88365 m .39478 .883 L .41363 .65464 L p
.3 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.77951 .50883 m .76422 .51096 L .75477 .52905 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73975 .54349 m .75477 .52905 L .76422 .51096 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.61485 .30591 m .64151 .31206 L .62677 .31498 L 1 .75 0 r
F
P
p
.6001 .30889 m .61485 .30591 L .62677 .31498 L 1 .9 0 r
F
P
p
.55834 .30568 m .58547 .31184 L .57096 .31476 L .6 1 0 r
F
P
p
.54381 .30866 m .55834 .30568 L .57096 .31476 L .5 1 0 r
F
P
p
.50179 .30545 m .52941 .31161 L .51511 .31454 L .2 1 0 r
F
P
p
.48749 .30843 m .50179 .30545 L .51511 .31454 L .2 1 0 r
F
P
p
.44521 .30522 m .4733 .31138 L .45923 .31431 L 0 1 0 r
F
P
p
.43113 .3082 m .44521 .30522 L .45923 .31431 L 0 1 .1 r
F
P
p
.38859 .30499 m .41717 .31116 L .40332 .31409 L 0 1 .7 r
F
P
p
.37474 .30797 m .38859 .30499 L .40332 .31409 L 0 1 1 r
F
P
p
.002 w
.46744 .88505 m .48269 .77989 L .4966 .73256 L p
.3 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.51091 .70618 m .4966 .73256 L .48269 .77989 L p
0 .65 1 r
F P
0 0 0 r
s
P
p
.002 w
.43892 .88887 m .42498 .88948 L .41052 .88759 L p
1 0 .2 r
F P
0 0 0 r
s
P
p
.002 w
.39634 .90116 m .41052 .88759 L .42498 .88948 L p
1 0 .15 r
F P
0 0 0 r
s
P
p
.33193 .30476 m .361 .31093 L .34737 .31386 L 1 0 .95 r
F
P
p
.31831 .30775 m .33193 .30476 L .34737 .31386 L 1 0 .1 r
F
P
p
.002 w
.5396 .69087 m .55407 .67684 L .56683 .70628 L p
0 1 .85 r
F P
0 0 0 r
s
P
p
.27524 .30453 m .30479 .3107 L .29138 .31364 L 1 0 0 r
F
P
p
.002 w
.36769 .88692 m .35355 .90055 L .33797 .89877 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.33797 .89877 m .35193 .89818 L .36769 .88692 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.38472 .73236 m .36769 .88692 L .35316 .8973 L p
1 0 .7 r
F P
0 0 0 r
s
P
p
.002 w
.35316 .8973 m .35193 .89818 L p
.35328 .89135 L 1 0 .7 r
F P
0 0 0 r
s
P
p
.35328 .89135 m .38472 .73236 L .35316 .8973 L 1 0 .7 r
F
P
p
.002 w
.39634 .90116 m .38249 .90173 L .36769 .88692 L p
1 0 .7 r
F P
0 0 0 r
s
P
p
.002 w
.35355 .90055 m .36769 .88692 L .38249 .90173 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.3985 .73112 m .38472 .73236 L .36601 .89759 L p
.65 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.35193 .89818 m .36601 .89759 L .38472 .73236 L p
1 0 .7 r
F P
0 0 0 r
s
P
p
.002 w
.38048 .88365 m .3985 .73112 L p
.36735 .89073 L .65 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.36601 .89759 m .38048 .88365 L p
.36735 .89073 L .65 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38048 .88365 m .3684 .72323 L p
.39371 .87653 L .6 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39478 .883 m .38048 .88365 L p
.39371 .87653 L .6 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.3684 .72323 m .38048 .88365 L p
.35645 .73713 L .65 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.35439 .72454 m .35672 .72432 L p
.35645 .73713 L .65 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.35672 .72432 m .3684 .72323 L p
.35645 .73713 L .65 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.5252 .70483 m .51091 .70618 L .49758 .68934 L p
0 1 .75 r
F P
0 0 0 r
s
P
p
.002 w
.48269 .77989 m .49758 .68934 L .51091 .70618 L p
0 .65 1 r
F P
0 0 0 r
s
P
p
.89689 .30706 m .91289 .30407 L .92115 .31319 L 1 0 0 r
F
P
p
.85633 .30384 m .88103 .31002 L .86529 .31296 L 1 0 0 r
F
P
p
.84056 .30683 m .85633 .30384 L .86529 .31296 L 1 0 0 r
F
P
p
.002 w
.70964 .55982 m .69459 .56176 L .68348 .55575 L p
1 .8 0 r
F P
0 0 0 r
s
P
p
.79973 .30361 m .82491 .3098 L .8094 .31274 L 1 0 0 r
F
P
p
.78418 .3066 m .79973 .30361 L .8094 .31274 L 1 0 0 r
F
P
p
.002 w
.38249 .90173 m .36875 .90229 L .35355 .90055 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.7431 .30338 m .76876 .30957 L .75347 .31251 L 1 .4 0 r
F
P
p
.72778 .30637 m .7431 .30338 L .75347 .31251 L 1 .45 0 r
F
P
p
.002 w
.85109 .50684 m .83546 .50899 L .82611 .50232 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81045 .50451 m .82611 .50232 L .83546 .50899 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58322 .64859 m .5979 .63436 L .60996 .62697 L p
.05 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62468 .6253 m .60996 .62697 L .5979 .63436 L p
.15 1 0 r
F P
0 0 0 r
s
P
p
.68643 .30315 m .71258 .30934 L .6975 .31229 L 1 .75 0 r
F
P
p
.67133 .30614 m .68643 .30315 L .6975 .31229 L 1 .85 0 r
F
P
p
.002 w
.79492 .50668 m .77951 .50883 L .76946 .50215 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75477 .52905 m .76946 .50215 L .77951 .50883 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.62972 .30292 m .65636 .30911 L .64151 .31206 L 1 .55 0 r
F
P
p
.61485 .30591 m .62972 .30292 L .64151 .31206 L 1 .75 0 r
F
P
p
.57298 .30268 m .6001 .30889 L .58547 .31184 L .7 1 0 r
F
P
p
.55834 .30568 m .57298 .30268 L .58547 .31184 L .6 1 0 r
F
P
p
.51621 .30245 m .54381 .30866 L .52941 .31161 L .3 1 0 r
F
P
p
.50179 .30545 m .51621 .30245 L .52941 .31161 L .2 1 0 r
F
P
p
.4594 .30222 m .48749 .30843 L .4733 .31138 L .05 1 0 r
F
P
p
.44521 .30522 m .4594 .30222 L .4733 .31138 L 0 1 0 r
F
P
p
.40255 .30199 m .43113 .3082 L .41717 .31116 L 0 1 .45 r
F
P
p
.38859 .30499 m .40255 .30199 L .41717 .31116 L 0 1 .7 r
F
P
p
.002 w
.41052 .88759 m .42457 .88696 L .43892 .88887 L p
1 0 .2 r
F P
0 0 0 r
s
P
p
.34567 .30176 m .37474 .30797 L .361 .31093 L 0 .45 1 r
F
P
p
.33193 .30476 m .34567 .30176 L .361 .31093 L 1 0 .95 r
F
P
p
.28875 .30152 m .31831 .30775 L .30479 .3107 L 1 0 .05 r
F
P
p
.27524 .30453 m .28875 .30152 L .30479 .3107 L 1 0 0 r
F
P
p
.002 w
.5396 .69087 m .5252 .70483 L .51209 .65006 L p
0 1 .45 r
F P
0 0 0 r
s
P
p
.002 w
.49758 .68934 m .51209 .65006 L .5252 .70483 L p
0 1 .75 r
F P
0 0 0 r
s
P
p
.87223 .30083 m .89689 .30706 L .88103 .31002 L 1 0 0 r
F
P
p
.85633 .30384 m .87223 .30083 L .88103 .31002 L 1 0 0 r
F
P
p
.002 w
.68348 .55575 m .69868 .55377 L .70964 .55982 L p
1 .8 0 r
F P
0 0 0 r
s
P
p
.8154 .30059 m .84056 .30683 L .82491 .3098 L 1 0 0 r
F
P
p
.79973 .30361 m .8154 .30059 L .82491 .3098 L 1 0 0 r
F
P
p
.75854 .30036 m .78418 .3066 L .76876 .30957 L 1 .4 0 r
F
P
p
.7431 .30338 m .75854 .30036 L .76876 .30957 L 1 .4 0 r
F
P
p
.002 w
.86684 .50468 m .85109 .50684 L .8419 .50012 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82611 .50232 m .8419 .50012 L .85109 .50684 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63952 .62361 m .62468 .6253 L .61264 .62007 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5979 .63436 m .61264 .62007 L .62468 .6253 L p
.15 1 0 r
F P
0 0 0 r
s
P
p
.70165 .30013 m .72778 .30637 L .71258 .30934 L 1 .6 0 r
F
P
p
.68643 .30315 m .70165 .30013 L .71258 .30934 L 1 .75 0 r
F
P
p
.002 w
.81045 .50451 m .79492 .50668 L .78502 .49995 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76946 .50215 m .78502 .49995 L .79492 .50668 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64472 .29989 m .67133 .30614 L .65636 .30911 L 1 .5 0 r
F
P
p
.62972 .30292 m .64472 .29989 L .65636 .30911 L 1 .55 0 r
F
P
p
.002 w
.55407 .67684 m .5396 .69087 L .52655 .62335 L p
0 1 .2 r
F P
0 0 0 r
s
P
p
.002 w
.51209 .65006 m .52655 .62335 L .5396 .69087 L p
0 1 .45 r
F P
0 0 0 r
s
P
p
.58775 .29966 m .61485 .30591 L .6001 .30889 L .7 1 0 r
F
P
p
.57298 .30268 m .58775 .29966 L .6001 .30889 L .7 1 0 r
F
P
p
.53074 .29943 m .55834 .30568 L .54381 .30866 L .45 1 0 r
F
P
p
.51621 .30245 m .53074 .29943 L .54381 .30866 L .3 1 0 r
F
P
p
.47371 .29919 m .50179 .30545 L .48749 .30843 L .15 1 0 r
F
P
p
.4594 .30222 m .47371 .29919 L .48749 .30843 L .05 1 0 r
F
P
p
.002 w
.69868 .55377 m .714 .55177 L .72449 .54551 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.41663 .29896 m .44521 .30522 L .43113 .3082 L 0 1 .25 r
F
P
p
.40255 .30199 m .41663 .29896 L .43113 .3082 L 0 1 .45 r
F
P
p
.35952 .29873 m .38859 .30499 L .37474 .30797 L 0 1 .7 r
F
P
p
.34567 .30176 m .35952 .29873 L .37474 .30797 L 0 .45 1 r
F
P
p
.30237 .29849 m .33193 .30476 L .31831 .30775 L 1 0 .15 r
F
P
p
.28875 .30152 m .30237 .29849 L .31831 .30775 L 1 0 .05 r
F
P
p
.002 w
.56867 .67536 m .55407 .67684 L .54105 .60911 L p
0 1 .1 r
F P
0 0 0 r
s
P
p
.002 w
.52655 .62335 m .54105 .60911 L .55407 .67684 L p
0 1 .2 r
F P
0 0 0 r
s
P
p
.88826 .29779 m .91289 .30407 L .89689 .30706 L 1 0 0 r
F
P
p
.87223 .30083 m .88826 .29779 L .89689 .30706 L 1 0 0 r
F
P
p
.8312 .29755 m .85633 .30384 L .84056 .30683 L 1 0 0 r
F
P
p
.8154 .30059 m .8312 .29755 L .84056 .30683 L 1 0 0 r
F
P
p
.77411 .29732 m .79973 .30361 L .78418 .3066 L 1 .4 0 r
F
P
p
.75854 .30036 m .77411 .29732 L .78418 .3066 L 1 .4 0 r
F
P
p
.002 w
.52655 .62335 m .51209 .65006 L .49876 .60721 L p
.25 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.88273 .50249 m .86684 .50468 L .85782 .4979 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8419 .50012 m .85782 .4979 L .86684 .50468 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65448 .62191 m .63952 .62361 L .62762 .61834 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61264 .62007 m .62762 .61834 L .63952 .62361 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.71699 .29708 m .7431 .30338 L .72778 .30637 L 1 .45 0 r
F
P
p
.70165 .30013 m .71699 .29708 L .72778 .30637 L 1 .6 0 r
F
P
p
.002 w
.82611 .50232 m .81045 .50451 L .80071 .49773 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78502 .49995 m .80071 .49773 L .81045 .50451 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.65983 .29685 m .68643 .30315 L .67133 .30614 L 1 .4 0 r
F
P
p
.64472 .29989 m .65983 .29685 L .67133 .30614 L 1 .5 0 r
F
P
p
.002 w
.54105 .60911 m .52655 .62335 L .51329 .59283 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49876 .60721 m .51329 .59283 L .52655 .62335 L p
.25 1 0 r
F P
0 0 0 r
s
P
p
.60263 .29661 m .62972 .30292 L .61485 .30591 L .8 1 0 r
F
P
p
.58775 .29966 m .60263 .29661 L .61485 .30591 L .7 1 0 r
F
P
p
.002 w
.4843 .62152 m .47002 .62322 L .45487 .72068 L p
0 1 .5 r
F P
0 0 0 r
s
P
p
.5454 .29638 m .57298 .30268 L .55834 .30568 L .55 1 0 r
F
P
p
.53074 .29943 m .5454 .29638 L .55834 .30568 L .45 1 0 r
F
P
p
.48813 .29614 m .51621 .30245 L .50179 .30545 L .2 1 0 r
F
P
p
.47371 .29919 m .48813 .29614 L .50179 .30545 L .15 1 0 r
F
P
p
.002 w
.714 .55177 m .72944 .54975 L .73975 .54349 L p
1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.75477 .52905 m .73975 .54349 L .72944 .54975 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.43083 .29591 m .4594 .30222 L .44521 .30522 L 0 1 .15 r
F
P
p
.41663 .29896 m .43083 .29591 L .44521 .30522 L 0 1 .25 r
F
P
p
.37348 .29567 m .40255 .30199 L .38859 .30499 L 0 1 .45 r
F
P
p
.35952 .29873 m .37348 .29567 L .38859 .30499 L 0 1 .7 r
F
P
p
.31611 .29543 m .34567 .30176 L .33193 .30476 L .3 0 1 r
F
P
p
.30237 .29849 m .31611 .29543 L .33193 .30476 L 1 0 .15 r
F
P
p
.25869 .2952 m .28875 .30152 L .27524 .30453 L 1 0 0 r
F
P
p
.002 w
.54105 .60911 m .55565 .60735 L .56867 .67536 L p
0 1 .1 r
F P
0 0 0 r
s
P
p
.002 w
.55565 .60735 m .54105 .60911 L .52789 .57839 L p
.65 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51329 .59283 m .52789 .57839 L .54105 .60911 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66887 .58259 m .65448 .62191 L .64272 .61659 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64272 .61659 m .65773 .6021 L .66887 .58259 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68348 .55575 m .66887 .58259 L .65773 .6021 L p
.75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58322 .64859 m .56867 .67536 L .55565 .60735 L p
0 1 0 r
F P
0 0 0 r
s
P
p
.88826 .29779 m .90442 .29472 L .91289 .30407 L 1 0 0 r
F
P
p
.84714 .29449 m .87223 .30083 L .85633 .30384 L 1 0 0 r
F
P
p
.8312 .29755 m .84714 .29449 L .85633 .30384 L 1 0 0 r
F
P
p
.002 w
.69868 .55377 m .68348 .55575 L .67281 .58754 L p
.95 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65773 .6021 m .67281 .58754 L .68348 .55575 L p
.75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55565 .60735 m .57037 .60557 L .58322 .64859 L p
0 1 0 r
F P
0 0 0 r
s
P
p
.78982 .29425 m .8154 .30059 L .79973 .30361 L 1 .2 0 r
F
P
p
.77411 .29732 m .78982 .29425 L .79973 .30361 L 1 .4 0 r
F
P
p
.002 w
.76946 .50215 m .75477 .52905 L .74392 .51003 L p
1 .15 0 r
F P
0 0 0 r
s
P
p
.002 w
.72944 .54975 m .74392 .51003 L .75477 .52905 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.89875 .50029 m .88273 .50249 L .87387 .49566 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85782 .4979 m .87387 .49566 L .88273 .50249 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62762 .61834 m .64272 .61659 L .65448 .62191 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.73246 .29401 m .75854 .30036 L .7431 .30338 L 1 .4 0 r
F
P
p
.71699 .29708 m .73246 .29401 L .7431 .30338 L 1 .45 0 r
F
P
p
.002 w
.8419 .50012 m .82611 .50232 L .81653 .49548 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80071 .49773 m .81653 .49548 L .82611 .50232 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67507 .29378 m .70165 .30013 L .68643 .30315 L 1 .3 0 r
F
P
p
.65983 .29685 m .67507 .29378 L .68643 .30315 L 1 .4 0 r
F
P
p
.002 w
.78502 .49995 m .76946 .50215 L .75915 .49531 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74392 .51003 m .75915 .49531 L .76946 .50215 L p
1 .15 0 r
F P
0 0 0 r
s
P
p
.61764 .29354 m .64472 .29989 L .62972 .30292 L .9 1 0 r
F
P
p
.60263 .29661 m .61764 .29354 L .62972 .30292 L .8 1 0 r
F
P
p
.56018 .2933 m .58775 .29966 L .57298 .30268 L .65 1 0 r
F
P
p
.5454 .29638 m .56018 .2933 L .57298 .30268 L .55 1 0 r
F
P
p
.50268 .29306 m .53074 .29943 L .51621 .30245 L .3 1 0 r
F
P
p
.48813 .29614 m .50268 .29306 L .51621 .30245 L .2 1 0 r
F
P
p
.44514 .29283 m .47371 .29919 L .4594 .30222 L 0 1 .05 r
F
P
p
.43083 .29591 m .44514 .29283 L .4594 .30222 L 0 1 .15 r
F
P
p
.38756 .29259 m .41663 .29896 L .40255 .30199 L 0 1 .25 r
F
P
p
.37348 .29567 m .38756 .29259 L .40255 .30199 L 0 1 .45 r
F
P
p
.002 w
.61264 .62007 m .5979 .63436 L .58513 .59113 L p
.35 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57037 .60557 m .58513 .59113 L .5979 .63436 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.32995 .29235 m .35952 .29873 L .34567 .30176 L 0 1 .7 r
F
P
p
.31611 .29543 m .32995 .29235 L .34567 .30176 L .3 0 1 r
F
P
p
.27231 .29211 m .30237 .29849 L .28875 .30152 L 1 0 0 r
F
P
p
.25869 .2952 m .27231 .29211 L .28875 .30152 L 1 0 0 r
F
P
p
.002 w
.57037 .60557 m .55565 .60735 L .54256 .56387 L p
.7 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52789 .57839 m .54256 .56387 L .55565 .60735 L p
.65 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48472 .64005 m .49876 .60721 L p
.48074 .66059 L 0 1 .15 r
F P
0 0 0 r
s
P
p
.002 w
.4697 .69328 m .48472 .64005 L p
.48074 .66059 L 0 1 .15 r
F P
0 0 0 r
s
P
p
.002 w
.48472 .64005 m .47073 .60892 L p
.48874 .6193 L .1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51329 .59283 m .49876 .60721 L .48472 .64005 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49948 .62549 m .51329 .59283 L p
.48954 .63208 L .2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48472 .64005 m .49948 .62549 L p
.48954 .63208 L .2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52789 .57839 m .51329 .59283 L .49948 .62549 L p
.35 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49948 .62549 m .51427 .62375 L .52789 .57839 L p
.35 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49948 .62549 m .48559 .59414 L p
.50951 .61884 L .2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51427 .62375 m .49948 .62549 L p
.50951 .61884 L .2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49948 .62549 m .48472 .64005 L p
.48874 .6193 L .1 1 0 r
F P
0 0 0 r
s
P
p
.8632 .2914 m .88826 .29779 L .87223 .30083 L 1 0 0 r
F
P
p
.84714 .29449 m .8632 .2914 L .87223 .30083 L 1 0 0 r
F
P
p
.002 w
.714 .55177 m .69868 .55377 L .68797 .57291 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68797 .57291 m .69868 .55377 L p
.67717 .58185 L .95 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68797 .57291 m .67566 .52843 L p
.69887 .56389 L 1 .85 0 r
F P
0 0 0 r
s
P
p
.002 w
.68797 .57291 m .70349 .57096 L .714 .55177 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70349 .57096 m .68797 .57291 L p
.69887 .56389 L 1 .85 0 r
F P
0 0 0 r
s
P
p
.002 w
.67281 .58754 m .68797 .57291 L p
.67717 .58185 L .95 1 0 r
F P
0 0 0 r
s
P
p
.80565 .29116 m .8312 .29755 L .8154 .30059 L 1 0 0 r
F
P
p
.78982 .29425 m .80565 .29116 L .8154 .30059 L 1 .2 0 r
F
P
p
.002 w
.91489 .49807 m .89875 .50029 L .89005 .4934 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.87387 .49566 m .89005 .4934 L .89875 .50029 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.74806 .29092 m .77411 .29732 L .75854 .30036 L 1 .4 0 r
F
P
p
.73246 .29401 m .74806 .29092 L .75854 .30036 L 1 .4 0 r
F
P
p
.002 w
.85782 .4979 m .8419 .50012 L .83248 .49322 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81653 .49548 m .83248 .49322 L .8419 .50012 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62762 .61834 m .61264 .62007 L .60007 .58927 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58513 .59113 m .60007 .58927 L .61264 .62007 L p
.35 1 0 r
F P
0 0 0 r
s
P
p
.69044 .29068 m .71699 .29708 L .70165 .30013 L 1 .2 0 r
F
P
p
.67507 .29378 m .69044 .29068 L .70165 .30013 L 1 .3 0 r
F
P
p
.002 w
.80071 .49773 m .78502 .49995 L .77487 .49305 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75915 .49531 m .77487 .49305 L .78502 .49995 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.63277 .29044 m .65983 .29685 L .64472 .29989 L 1 .9 0 r
F
P
p
.61764 .29354 m .63277 .29044 L .64472 .29989 L .9 1 0 r
F
P
p
.57508 .2902 m .60263 .29661 L .58775 .29966 L .7 1 0 r
F
P
p
.56018 .2933 m .57508 .2902 L .58775 .29966 L .65 1 0 r
F
P
p
.51734 .28996 m .5454 .29638 L .53074 .29943 L .5 1 0 r
F
P
p
.50268 .29306 m .51734 .28996 L .53074 .29943 L .3 1 0 r
F
P
p
.45957 .28972 m .48813 .29614 L .47371 .29919 L .05 1 0 r
F
P
p
.44514 .29283 m .45957 .28972 L .47371 .29919 L 0 1 .05 r
F
P
p
.40176 .28948 m .43083 .29591 L .41663 .29896 L 0 1 0 r
F
P
p
.38756 .29259 m .40176 .28948 L .41663 .29896 L 0 1 .25 r
F
P
p
.34392 .28924 m .37348 .29567 L .35952 .29873 L 0 1 .55 r
F
P
p
.32995 .29235 m .34392 .28924 L .35952 .29873 L 0 1 .7 r
F
P
p
.28603 .289 m .31611 .29543 L .30237 .29849 L 1 0 .1 r
F
P
p
.27231 .29211 m .28603 .289 L .30237 .29849 L 1 0 0 r
F
P
p
.002 w
.58513 .59113 m .57037 .60557 L .55733 .5619 L p
.75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54256 .56387 m .55733 .5619 L .57037 .60557 L p
.7 1 0 r
F P
0 0 0 r
s
P
p
.8794 .28828 m .90442 .29472 L .88826 .29779 L 1 0 0 r
F
P
p
.8632 .2914 m .8794 .28828 L .88826 .29779 L 1 0 0 r
F
P
p
.002 w
.72944 .54975 m .714 .55177 L .70349 .57096 L p
1 .95 0 r
F P
0 0 0 r
s
P
p
.82161 .28804 m .84714 .29449 L .8312 .29755 L 1 0 0 r
F
P
p
.80565 .29116 m .82161 .28804 L .8312 .29755 L 1 0 0 r
F
P
p
.002 w
.54256 .56387 m .52789 .57839 L .51427 .62375 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.93117 .49583 m .91489 .49807 L .90637 .49112 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.89005 .4934 m .90637 .49112 L .91489 .49807 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.76379 .2878 m .78982 .29425 L .77411 .29732 L 1 .4 0 r
F
P
p
.74806 .29092 m .76379 .2878 L .77411 .29732 L 1 .4 0 r
F
P
p
.002 w
.87387 .49566 m .85782 .4979 L .84856 .49094 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83248 .49322 m .84856 .49094 L .85782 .4979 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64272 .61659 m .62762 .61834 L .61485 .56205 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60007 .58927 m .61485 .56205 L .62762 .61834 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.70593 .28756 m .73246 .29401 L .71699 .29708 L 1 .05 0 r
F
P
p
.69044 .29068 m .70593 .28756 L .71699 .29708 L 1 .2 0 r
F
P
p
.002 w
.81653 .49548 m .80071 .49773 L .79072 .49077 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77487 .49305 m .79072 .49077 L .80071 .49773 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64803 .28731 m .67507 .29378 L .65983 .29685 L 1 .6 0 r
F
P
p
.63277 .29044 m .64803 .28731 L .65983 .29685 L 1 .9 0 r
F
P
p
.5901 .28707 m .61764 .29354 L .60263 .29661 L .7 1 0 r
F
P
p
.57508 .2902 m .5901 .28707 L .60263 .29661 L .7 1 0 r
F
P
p
.002 w
.60007 .58927 m .58513 .59113 L .57224 .55991 L p
.85 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57224 .55991 m .58513 .59113 L p
.56082 .56557 L .75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57224 .55991 m .58717 .54519 L .60007 .58927 L p
.85 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57224 .55991 m .55941 .61844 L p
.58376 .5542 L .6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58717 .54519 m .57224 .55991 L p
.58376 .5542 L .6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55733 .5619 m .57224 .55991 L p
.56082 .56557 L .75 1 0 r
F P
0 0 0 r
s
P
p
.53213 .28683 m .56018 .2933 L .5454 .29638 L .6 1 0 r
F
P
p
.51734 .28996 m .53213 .28683 L .5454 .29638 L .5 1 0 r
F
P
p
.47412 .28659 m .50268 .29306 L .48813 .29614 L .15 1 0 r
F
P
p
.45957 .28972 m .47412 .28659 L .48813 .29614 L .05 1 0 r
F
P
p
.41608 .28635 m .44514 .29283 L .43083 .29591 L .15 1 0 r
F
P
p
.40176 .28948 m .41608 .28635 L .43083 .29591 L 0 1 0 r
F
P
p
.002 w
.55733 .5619 m .54256 .56387 L .52919 .62199 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51427 .62375 m .52919 .62199 L .54256 .56387 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.35799 .28611 m .38756 .29259 L .37348 .29567 L 0 1 .4 r
F
P
p
.34392 .28924 m .35799 .28611 L .37348 .29567 L 0 1 .55 r
F
P
p
.29987 .28586 m .32995 .29235 L .31611 .29543 L .5 0 1 r
F
P
p
.28603 .289 m .29987 .28586 L .31611 .29543 L 1 0 .1 r
F
P
p
.002 w
.75915 .49531 m .74392 .51003 L .73423 .54135 L p
1 .45 0 r
F P
0 0 0 r
s
P
p
.002 w
.74392 .51003 m .72944 .54975 L .71883 .55619 L p
1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.73423 .54135 m .74392 .51003 L p
.72246 .54951 L 1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.73423 .54135 m .75009 .53925 L .75915 .49531 L p
1 .45 0 r
F P
0 0 0 r
s
P
p
.002 w
.73423 .54135 m .72216 .49622 L p
.74612 .53312 L 1 .45 0 r
F P
0 0 0 r
s
P
p
.002 w
.75009 .53925 m .73423 .54135 L p
.74612 .53312 L 1 .45 0 r
F P
0 0 0 r
s
P
p
.002 w
.71883 .55619 m .73423 .54135 L p
.72246 .54951 L 1 .7 0 r
F P
0 0 0 r
s
P
p
.24172 .28562 m .27231 .29211 L .25869 .2952 L 1 0 0 r
F
P
p
.002 w
.38048 .88365 m .36601 .89759 L .35439 .72454 L p
.65 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.33641 .88294 m .35439 .72454 L .36601 .89759 L p
1 0 .7 r
F P
0 0 0 r
s
P
p
.002 w
.33641 .88294 m .32199 .89694 L .30697 .89522 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.30697 .89522 m .30559 .89506 L p
.30818 .89405 L 1 0 .05 r
F P
0 0 0 r
s
P
p
.30818 .89405 m .33641 .88294 L .30697 .89522 L 1 0 .05 r
F
P
p
.002 w
.30559 .89506 m .31978 .89444 L .33641 .88294 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.35439 .72454 m .33641 .88294 L .31978 .89444 L p
1 0 .75 r
F P
0 0 0 r
s
P
p
.002 w
.33445 .8802 m .33617 .86682 L p
.31978 .89444 L 1 0 .75 r
F P
0 0 0 r
s
P
p
.002 w
.33617 .86682 m .35439 .72454 L p
.32275 .87987 L 1 0 .75 r
F P
0 0 0 r
s
P
p
.31978 .89444 m .33617 .86682 L .32275 .87987 L 1 0 .75 r
F
P
p
.002 w
.3684 .72323 m .35439 .72454 L .33445 .8802 L p
0 0 1 r
F P
0 0 0 r
s
P
p
.8794 .28828 m .89573 .28514 L .90442 .29472 L 1 0 0 r
F
P
p
.002 w
.70349 .57096 m .71883 .55619 L .72944 .54975 L p
1 .95 0 r
F P
0 0 0 r
s
P
p
.83771 .28489 m .8632 .2914 L .84714 .29449 L 1 0 0 r
F
P
p
.82161 .28804 m .83771 .28489 L .84714 .29449 L 1 0 0 r
F
P
p
.002 w
.90637 .49112 m .92283 .48882 L .93117 .49583 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.77965 .28465 m .80565 .29116 L .78982 .29425 L 1 .2 0 r
F
P
p
.76379 .2878 m .77965 .28465 L .78982 .29425 L 1 .4 0 r
F
P
p
.002 w
.89005 .4934 m .87387 .49566 L .86478 .48864 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84856 .49094 m .86478 .48864 L .87387 .49566 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65773 .6021 m .64272 .61659 L .62999 .56006 L p
.7 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61485 .56205 m .62999 .56006 L .64272 .61659 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35193 .89818 m .33797 .89877 L .32199 .89694 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.72155 .28441 m .74806 .29092 L .73246 .29401 L 1 0 0 r
F
P
p
.70593 .28756 m .72155 .28441 L .73246 .29401 L 1 .05 0 r
F
P
p
.002 w
.83248 .49322 m .81653 .49548 L .8067 .48847 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79072 .49077 m .8067 .48847 L .81653 .49548 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66342 .28416 m .69044 .29068 L .67507 .29378 L 1 .5 0 r
F
P
p
.64803 .28731 m .66342 .28416 L .67507 .29378 L 1 .6 0 r
F
P
p
.002 w
.77487 .49305 m .75915 .49531 L .75009 .53925 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.60525 .28392 m .63277 .29044 L .61764 .29354 L .75 1 0 r
F
P
p
.5901 .28707 m .60525 .28392 L .61764 .29354 L .7 1 0 r
F
P
p
.002 w
.61485 .56205 m .60007 .58927 L .58717 .54519 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.54704 .28368 m .57508 .2902 L .56018 .2933 L .7 1 0 r
F
P
p
.53213 .28683 m .54704 .28368 L .56018 .2933 L .6 1 0 r
F
P
p
.48879 .28343 m .51734 .28996 L .50268 .29306 L .2 1 0 r
F
P
p
.47412 .28659 m .48879 .28343 L .50268 .29306 L .15 1 0 r
F
P
p
.002 w
.62999 .56006 m .61485 .56205 L .60229 .54312 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.58717 .54519 m .60229 .54312 L .61485 .56205 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.43051 .28319 m .45957 .28972 L .44514 .29283 L .25 1 0 r
F
P
p
.41608 .28635 m .43051 .28319 L .44514 .29283 L .15 1 0 r
F
P
p
.002 w
.57224 .55991 m .55733 .5619 L .54424 .62022 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52919 .62199 m .54424 .62022 L .55733 .5619 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.37219 .28294 m .40176 .28948 L .38756 .29259 L 0 1 .15 r
F
P
p
.35799 .28611 m .37219 .28294 L .38756 .29259 L 0 1 .4 r
F
P
p
.31383 .2827 m .34392 .28924 L .32995 .29235 L 0 1 1 r
F
P
p
.29987 .28586 m .31383 .2827 L .32995 .29235 L .5 0 1 r
F
P
p
.002 w
.67281 .58754 m .65773 .6021 L .64506 .54535 L p
.9 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62999 .56006 m .64506 .54535 L .65773 .6021 L p
.7 1 0 r
F P
0 0 0 r
s
P
p
.25544 .28246 m .28603 .289 L .27231 .29211 L 1 0 0 r
F
P
p
.24172 .28562 m .25544 .28246 L .27231 .29211 L 1 0 0 r
F
P
p
.002 w
.3684 .72323 m .38253 .72191 L .39478 .883 L p
.6 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38253 .72191 m .3684 .72323 L .35277 .71914 L p
0 .65 1 r
F P
0 0 0 r
s
P
p
.002 w
.33445 .8802 m .35277 .71914 L .3684 .72323 L p
0 0 1 r
F P
0 0 0 r
s
P
p
.85394 .28172 m .8794 .28828 L .8632 .2914 L 1 0 0 r
F
P
p
.83771 .28489 m .85394 .28172 L .8632 .2914 L 1 0 0 r
F
P
p
.79564 .28148 m .82161 .28804 L .80565 .29116 L 1 0 0 r
F
P
p
.77965 .28465 m .79564 .28148 L .80565 .29116 L 1 .2 0 r
F
P
p
.002 w
.90637 .49112 m .89005 .4934 L .88114 .48633 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.86478 .48864 m .88114 .48633 L .89005 .4934 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.73731 .28123 m .76379 .2878 L .74806 .29092 L 1 0 0 r
F
P
p
.72155 .28441 m .73731 .28123 L .74806 .29092 L 1 0 0 r
F
P
p
.002 w
.36601 .89759 m .35193 .89818 L .33641 .88294 L p
1 0 .7 r
F P
0 0 0 r
s
P
p
.002 w
.32199 .89694 m .33641 .88294 L .35193 .89818 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.84856 .49094 m .83248 .49322 L .82282 .48615 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8067 .48847 m .82282 .48615 L .83248 .49322 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67894 .28099 m .70593 .28756 L .69044 .29068 L 1 .3 0 r
F
P
p
.66342 .28416 m .67894 .28099 L .69044 .29068 L 1 .5 0 r
F
P
p
.002 w
.79072 .49077 m .77487 .49305 L .76609 .53713 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.75009 .53925 m .76609 .53713 L .77487 .49305 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.68797 .57291 m .67281 .58754 L .6602 .53057 L p
1 .95 0 r
F P
0 0 0 r
s
P
p
.002 w
.64506 .54535 m .6602 .53057 L .67281 .58754 L p
.9 1 0 r
F P
0 0 0 r
s
P
p
.62053 .28074 m .64803 .28731 L .63277 .29044 L 1 1 0 r
F
P
p
.60525 .28392 m .62053 .28074 L .63277 .29044 L .75 1 0 r
F
P
p
.56208 .2805 m .5901 .28707 L .57508 .2902 L .8 1 0 r
F
P
p
.54704 .28368 m .56208 .2805 L .57508 .2902 L .7 1 0 r
F
P
p
.50359 .28025 m .53213 .28683 L .51734 .28996 L .25 1 0 r
F
P
p
.48879 .28343 m .50359 .28025 L .51734 .28996 L .2 1 0 r
F
P
p
.002 w
.64506 .54535 m .62999 .56006 L .61754 .54103 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.61754 .54103 m .62999 .56006 L p
.60925 .54738 L 1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.61754 .54103 m .63258 .51334 L .64506 .54535 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.61754 .54103 m .60558 .59979 L p
.62593 .53461 L .8 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63258 .51334 m .61754 .54103 L p
.62593 .53461 L .8 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60229 .54312 m .61754 .54103 L p
.60925 .54738 L 1 .9 0 r
F P
0 0 0 r
s
P
p
.44507 .28 m .47412 .28659 L .45957 .28972 L .3 1 0 r
F
P
p
.43051 .28319 m .44507 .28 L .45957 .28972 L .25 1 0 r
F
P
p
.002 w
.54424 .62022 m .55941 .61844 L .57224 .55991 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.38651 .27976 m .41608 .28635 L .40176 .28948 L .1 1 0 r
F
P
p
.37219 .28294 m .38651 .27976 L .40176 .28948 L 0 1 .15 r
F
P
p
.32791 .27951 m .35799 .28611 L .34392 .28924 L 0 1 .65 r
F
P
p
.31383 .2827 m .32791 .27951 L .34392 .28924 L 0 1 1 r
F
P
p
.002 w
.44038 .72201 m .4245 .82814 L .41157 .69317 L p
0 .6 1 r
F P
0 0 0 r
s
P
p
.002 w
.41157 .69317 m .42676 .63992 L .44038 .72201 L p
0 .6 1 r
F P
0 0 0 r
s
P
p
.26927 .27926 m .29987 .28586 L .28603 .289 L 1 0 .05 r
F
P
p
.25544 .28246 m .26927 .27926 L .28603 .289 L 1 0 0 r
F
P
p
.002 w
.40919 .88233 m .39478 .883 L .38253 .72191 L p
.6 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38253 .72191 m .39677 .72058 L .40919 .88233 L p
.6 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39677 .72058 m .38253 .72191 L .36731 .70467 L p
0 .75 1 r
F P
0 0 0 r
s
P
p
.002 w
.35277 .71914 m .36731 .70467 L .38253 .72191 L p
0 .65 1 r
F P
0 0 0 r
s
P
p
.002 w
.6602 .53057 m .67566 .52843 L .68797 .57291 L p
1 .95 0 r
F P
0 0 0 r
s
P
p
.87031 .27852 m .89573 .28514 L .8794 .28828 L 1 0 0 r
F
P
p
.85394 .28172 m .87031 .27852 L .8794 .28828 L 1 0 0 r
F
P
p
.81177 .27828 m .83771 .28489 L .82161 .28804 L 1 0 0 r
F
P
p
.79564 .28148 m .81177 .27828 L .82161 .28804 L 1 0 0 r
F
P
p
.002 w
.6602 .53057 m .64506 .54535 L .63258 .51334 L p
1 .55 0 r
F P
0 0 0 r
s
P
p
.002 w
.92283 .48882 m .90637 .49112 L .89763 .48399 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.88114 .48633 m .89763 .48399 L .90637 .49112 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7532 .27803 m .77965 .28465 L .76379 .2878 L 1 0 0 r
F
P
p
.73731 .28123 m .7532 .27803 L .76379 .2878 L 1 0 0 r
F
P
p
.002 w
.60229 .54312 m .58717 .54519 L .57464 .60354 L p
.7 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57464 .60354 m .58717 .54519 L p
.56223 .61099 L .6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57464 .60354 m .59004 .60168 L .60229 .54312 L p
.7 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57464 .60354 m .5611 .54519 L p
.58715 .59604 L .65 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59004 .60168 m .57464 .60354 L p
.58715 .59604 L .65 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55941 .61844 m .57464 .60354 L p
.56223 .61099 L .6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48472 .64005 m .4697 .69328 L .45608 .61072 L p
0 1 .2 r
F P
0 0 0 r
s
P
p
.002 w
.47073 .60892 m .48472 .64005 L p
.46183 .61661 L 0 1 .2 r
F P
0 0 0 r
s
P
p
.002 w
.47073 .60892 m .48559 .59414 L .49948 .62549 L p
.1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44138 .62536 m .45608 .61072 L .4697 .69328 L p
0 1 .55 r
F P
0 0 0 r
s
P
p
.002 w
.47073 .60892 m .45591 .62951 L p
.47972 .60114 L .05 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48559 .59414 m .47073 .60892 L p
.47972 .60114 L .05 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45608 .61072 m .47073 .60892 L p
.46183 .61661 L 0 1 .2 r
F P
0 0 0 r
s
P
p
.002 w
.86478 .48864 m .84856 .49094 L .83907 .48381 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82282 .48615 m .83907 .48381 L .84856 .49094 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69458 .27778 m .72155 .28441 L .70593 .28756 L 1 .1 0 r
F
P
p
.67894 .28099 m .69458 .27778 L .70593 .28756 L 1 .3 0 r
F
P
p
.002 w
.42676 .63992 m .41157 .69317 L .39636 .68865 L p
0 1 .7 r
F P
0 0 0 r
s
P
p
.002 w
.41135 .66084 m .42676 .63992 L p
.4066 .67223 L 0 1 .7 r
F P
0 0 0 r
s
P
p
.002 w
.39636 .68865 m .41135 .66084 L p
.4066 .67223 L 0 1 .7 r
F P
0 0 0 r
s
P
p
.002 w
.41135 .66084 m .39593 .65583 L p
.41617 .64931 L 0 1 .45 r
F P
0 0 0 r
s
P
p
.002 w
.44138 .62536 m .42676 .63992 L .41135 .66084 L p
0 1 .3 r
F P
0 0 0 r
s
P
p
.002 w
.41135 .66084 m .42618 .64609 L .44138 .62536 L p
0 1 .3 r
F P
0 0 0 r
s
P
p
.002 w
.42618 .64609 m .41135 .66084 L p
.41617 .64931 L 0 1 .45 r
F P
0 0 0 r
s
P
p
.002 w
.8067 .48847 m .79072 .49077 L .78222 .53499 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.76609 .53713 m .78222 .53499 L .79072 .49077 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.63593 .27753 m .66342 .28416 L .64803 .28731 L 1 .75 0 r
F
P
p
.62053 .28074 m .63593 .27753 L .64803 .28731 L 1 1 0 r
F
P
p
.57724 .27729 m .60525 .28392 L .5901 .28707 L .8 1 0 r
F
P
p
.56208 .2805 m .57724 .27729 L .5901 .28707 L .8 1 0 r
F
P
p
.51851 .27704 m .54704 .28368 L .53213 .28683 L .3 1 0 r
F
P
p
.50359 .28025 m .51851 .27704 L .53213 .28683 L .25 1 0 r
F
P
p
.45975 .27679 m .48879 .28343 L .47412 .28659 L .35 1 0 r
F
P
p
.44507 .28 m .45975 .27679 L .47412 .28659 L .3 1 0 r
F
P
p
.40094 .27654 m .43051 .28319 L .41608 .28635 L .3 1 0 r
F
P
p
.38651 .27976 m .40094 .27654 L .41608 .28635 L .1 1 0 r
F
P
p
.002 w
.67566 .52843 m .6602 .53057 L .64803 .51111 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.63258 .51334 m .64803 .51111 L .6602 .53057 L p
1 .55 0 r
F P
0 0 0 r
s
P
p
.3421 .27629 m .37219 .28294 L .35799 .28611 L 0 1 .45 r
F
P
p
.32791 .27951 m .3421 .27629 L .35799 .28611 L 0 1 .65 r
F
P
p
.002 w
.4697 .69328 m .45487 .72068 L .44138 .62536 L p
0 1 .55 r
F P
0 0 0 r
s
P
p
.28322 .27605 m .31383 .2827 L .29987 .28586 L 1 0 .7 r
F
P
p
.26927 .27926 m .28322 .27605 L .29987 .28586 L 1 0 .05 r
F
P
p
.002 w
.4245 .82814 m .40919 .88233 L .39677 .72058 L p
.3 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39677 .72058 m .41157 .69317 L .4245 .82814 L p
.3 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41157 .69317 m .39677 .72058 L .38192 .69013 L p
0 .9 1 r
F P
0 0 0 r
s
P
p
.002 w
.36731 .70467 m .38192 .69013 L .39677 .72058 L p
0 .75 1 r
F P
0 0 0 r
s
P
p
.2243 .2758 m .25544 .28246 L .24172 .28562 L 1 0 0 r
F
P
p
.002 w
.45608 .61072 m .44138 .62536 L .42618 .64609 L p
0 1 .1 r
F P
0 0 0 r
s
P
p
.002 w
.71883 .55619 m .70349 .57096 L .69097 .51351 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.67566 .52843 m .69097 .51351 L .70349 .57096 L p
1 .85 0 r
F P
0 0 0 r
s
P
p
.002 w
.38192 .69013 m .39636 .68865 L .41157 .69317 L p
0 .9 1 r
F P
0 0 0 r
s
P
p
.87031 .27852 m .88682 .2753 L .89573 .28514 L 1 0 0 r
F
P
p
.82804 .27505 m .85394 .28172 L .83771 .28489 L 1 0 0 r
F
P
p
.81177 .27828 m .82804 .27505 L .83771 .28489 L 1 0 0 r
F
P
p
.002 w
.89763 .48399 m .91426 .48163 L .92283 .48882 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.76922 .2748 m .79564 .28148 L .77965 .28465 L 1 0 0 r
F
P
p
.7532 .27803 m .76922 .2748 L .77965 .28465 L 1 0 0 r
F
P
p
.002 w
.61754 .54103 m .60229 .54312 L .59004 .60168 L p
.7 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.88114 .48633 m .86478 .48864 L .85546 .48145 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83907 .48381 m .85546 .48145 L .86478 .48864 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.71036 .27455 m .73731 .28123 L .72155 .28441 L 1 .05 0 r
F
P
p
.69458 .27778 m .71036 .27455 L .72155 .28441 L 1 .1 0 r
F
P
p
.002 w
.82282 .48615 m .8067 .48847 L .79849 .53283 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.78222 .53499 m .79849 .53283 L .8067 .48847 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.65147 .2743 m .67894 .28099 L .66342 .28416 L 1 .65 0 r
F
P
p
.63593 .27753 m .65147 .2743 L .66342 .28416 L 1 .75 0 r
F
P
p
.59253 .27405 m .62053 .28074 L .60525 .28392 L .95 1 0 r
F
P
p
.57724 .27729 m .59253 .27405 L .60525 .28392 L .8 1 0 r
F
P
p
.002 w
.47073 .60892 m .45608 .61072 L .44108 .63126 L p
0 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44108 .63126 m .45608 .61072 L p
.43624 .63419 L 0 1 .1 r
F P
0 0 0 r
s
P
p
.002 w
.44108 .63126 m .45591 .62951 L .47073 .60892 L p
0 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44108 .63126 m .42597 .62583 L p
.44599 .62829 L 0 1 .15 r
F P
0 0 0 r
s
P
p
.002 w
.45591 .62951 m .44108 .63126 L p
.44599 .62829 L 0 1 .15 r
F P
0 0 0 r
s
P
p
.002 w
.42618 .64609 m .44108 .63126 L p
.43624 .63419 L 0 1 .1 r
F P
0 0 0 r
s
P
p
.002 w
.73423 .54135 m .71883 .55619 L .70667 .51129 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.69097 .51351 m .70667 .51129 L .71883 .55619 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.53356 .2738 m .56208 .2805 L .54704 .28368 L .35 1 0 r
F
P
p
.51851 .27704 m .53356 .2738 L .54704 .28368 L .3 1 0 r
F
P
p
.47455 .27355 m .50359 .28025 L .48879 .28343 L .4 1 0 r
F
P
p
.45975 .27679 m .47455 .27355 L .48879 .28343 L .35 1 0 r
F
P
p
.4155 .2733 m .44507 .28 L .43051 .28319 L .4 1 0 r
F
P
p
.40094 .27654 m .4155 .2733 L .43051 .28319 L .3 1 0 r
F
P
p
.002 w
.69097 .51351 m .67566 .52843 L .66362 .50887 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.66362 .50887 m .67566 .52843 L p
.65359 .5146 L 1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.66362 .50887 m .67907 .49373 L .69097 .51351 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.64803 .51111 m .66362 .50887 L p
.65359 .5146 L 1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.66362 .50887 m .64803 .51111 L .63706 .59597 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.65214 .54107 m .66362 .50887 L p
.64715 .56287 L 1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.63706 .59597 m .65214 .54107 L p
.64715 .56287 L 1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.64803 .51111 m .63258 .51334 L .62125 .59789 L p
.9 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62125 .59789 m .63706 .59597 L .64803 .51111 L p
.9 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65214 .54107 m .63927 .50782 L p
.65719 .51905 L 1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.66362 .50887 m .65214 .54107 L p
.67376 .50308 L 1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.66786 .52573 m .67907 .49373 L p
.6576 .53148 L 1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.65214 .54107 m .66786 .52573 L p
.6576 .53148 L 1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.70667 .51129 m .69097 .51351 L .67907 .49373 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.6949 .4914 m .70667 .51129 L p
.68462 .49726 L 1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.67907 .49373 m .6949 .4914 L p
.68462 .49726 L 1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.72216 .49622 m .70667 .51129 L .6949 .4914 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.6949 .4914 m .71054 .47612 L .72216 .49622 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.6949 .4914 m .68394 .52349 L p
.70529 .48547 L 1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.71054 .47612 m .6949 .4914 L p
.70529 .48547 L 1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.6949 .4914 m .67907 .49373 L .66786 .52573 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.66786 .52573 m .68394 .52349 L .6949 .4914 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.66786 .52573 m .65533 .50549 L p
.67825 .51991 L 1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.68394 .52349 m .66786 .52573 L p
.67825 .51991 L 1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.66786 .52573 m .65214 .54107 L p
.65719 .51905 L 1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.67907 .49373 m .66362 .50887 L p
.67376 .50308 L 1 .6 0 r
F P
0 0 0 r
s
P
p
.35642 .27305 m .38651 .27976 L .37219 .28294 L 0 1 .2 r
F
P
p
.3421 .27629 m .35642 .27305 L .37219 .28294 L 0 1 .45 r
F
P
p
.29729 .2728 m .32791 .27951 L .31383 .2827 L 0 0 1 r
F
P
p
.28322 .27605 m .29729 .2728 L .31383 .2827 L 1 0 .7 r
F
P
p
.002 w
.52919 .62199 m .51427 .62375 L .50047 .59225 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48559 .59414 m .50047 .59225 L .51427 .62375 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.23813 .27255 m .26927 .27926 L .25544 .28246 L 1 0 0 r
F
P
p
.2243 .2758 m .23813 .27255 L .25544 .28246 L 1 0 0 r
F
P
p
.002 w
.33445 .8802 m .31978 .89444 L .30567 .89281 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.30567 .89281 m .30307 .8925 L p
.30794 .89059 L 1 0 .05 r
F P
0 0 0 r
s
P
p
.30794 .89059 m .33445 .8802 L .30567 .89281 L 1 0 .05 r
F
P
p
.002 w
.30307 .8925 m .3175 .89186 L .33445 .8802 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.35277 .71914 m .33445 .8802 L .31893 .89088 L p
1 0 .7 r
F P
0 0 0 r
s
P
p
.002 w
.31893 .89088 m .3175 .89186 L p
.35277 .71914 L 1 0 .7 r
F P
0 0 0 r
s
P
p
.002 w
.36731 .70467 m .35277 .71914 L .33913 .83246 L p
.6 0 1 r
F P
0 0 0 r
s
P
p
.3444 .81877 m .36731 .70467 L .33913 .83246 L .6 0 1 r
F
P
p
.33764 .86168 m .36731 .70467 L .33534 .86391 L .6 0 1 r
F
P
p
.002 w
.38192 .69013 m .36731 .70467 L .34708 .87665 L p
0 .15 1 r
F P
0 0 0 r
s
P
p
.002 w
.33205 .89121 m .34708 .87665 L .36731 .70467 L p
.6 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.34708 .87665 m .36558 .71214 L .38192 .69013 L p
0 .15 1 r
F P
0 0 0 r
s
P
p
.002 w
.39636 .68865 m .38192 .69013 L .36558 .71214 L p
0 1 1 r
F P
0 0 0 r
s
P
p
.002 w
.36558 .71214 m .38129 .65747 L .39536 .68659 L p
0 1 1 r
F P
0 0 0 r
s
P
p
.002 w
.39536 .68659 m .39636 .68865 L p
.39382 .69058 L 0 1 1 r
F P
0 0 0 r
s
P
p
.36558 .71214 m .39536 .68659 L .39382 .69058 L 0 1 1 r
F
P
p
.002 w
.33913 .83246 m .33534 .86391 L p
.3444 .81877 L .6 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.33534 .86391 m .33205 .89121 L p
.33764 .86168 L .6 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.3175 .89186 m .33205 .89121 L .35277 .71914 L p
1 0 .7 r
F P
0 0 0 r
s
P
p
.002 w
.70667 .51129 m .72216 .49622 L .73423 .54135 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.84444 .27179 m .87031 .27852 L .85394 .28172 L 1 0 0 r
F
P
p
.82804 .27505 m .84444 .27179 L .85394 .28172 L 1 0 0 r
F
P
p
.78538 .27154 m .81177 .27828 L .79564 .28148 L 1 0 0 r
F
P
p
.76922 .2748 m .78538 .27154 L .79564 .28148 L 1 0 0 r
F
P
p
.002 w
.59004 .60168 m .60558 .59979 L .61754 .54103 L p
.7 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.89763 .48399 m .88114 .48633 L .87198 .47907 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85546 .48145 m .87198 .47907 L .88114 .48633 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.72627 .27129 m .7532 .27803 L .73731 .28123 L 1 0 0 r
F
P
p
.71036 .27455 m .72627 .27129 L .73731 .28123 L 1 .05 0 r
F
P
p
.002 w
.83907 .48381 m .82282 .48615 L .8129 .47889 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79849 .53283 m .8129 .47889 L .82282 .48615 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.66713 .27104 m .69458 .27778 L .67894 .28099 L 1 .35 0 r
F
P
p
.65147 .2743 m .66713 .27104 L .67894 .28099 L 1 .65 0 r
F
P
p
.002 w
.60558 .59979 m .62125 .59789 L .63258 .51334 L p
.8 1 0 r
F P
0 0 0 r
s
P
p
.60796 .27079 m .63593 .27753 L .62053 .28074 L 1 .85 0 r
F
P
p
.59253 .27405 m .60796 .27079 L .62053 .28074 L .95 1 0 r
F
P
p
.54874 .27054 m .57724 .27729 L .56208 .2805 L .55 1 0 r
F
P
p
.53356 .2738 m .54874 .27054 L .56208 .2805 L .35 1 0 r
F
P
p
.48948 .27028 m .51851 .27704 L .50359 .28025 L .4 1 0 r
F
P
p
.47455 .27355 m .48948 .27028 L .50359 .28025 L .4 1 0 r
F
P
p
.43019 .27003 m .45975 .27679 L .44507 .28 L .4 1 0 r
F
P
p
.4155 .2733 m .43019 .27003 L .44507 .28 L .4 1 0 r
F
P
p
.37085 .26978 m .40094 .27654 L .38651 .27976 L 0 1 0 r
F
P
p
.35642 .27305 m .37085 .26978 L .38651 .27976 L 0 1 .2 r
F
P
p
.31148 .26953 m .3421 .27629 L .32791 .27951 L 0 .85 1 r
F
P
p
.29729 .2728 m .31148 .26953 L .32791 .27951 L 0 0 1 r
F
P
p
.002 w
.54424 .62022 m .52919 .62199 L .51547 .59035 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50047 .59225 m .51547 .59035 L p
.51007 .6022 L .2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51547 .59035 m .50047 .59225 L .48605 .61271 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48605 .61271 m .50125 .61086 L .51547 .59035 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51547 .59035 m .50125 .61086 L p
.52093 .57835 L .3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53061 .56236 m .51547 .59035 L p
.52093 .57835 L .3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51547 .59035 m .52919 .62199 L p
.51007 .6022 L .2 1 0 r
F P
0 0 0 r
s
P
p
.25207 .26927 m .28322 .27605 L .26927 .27926 L 1 0 .05 r
F
P
p
.23813 .27255 m .25207 .26927 L .26927 .27926 L 1 0 0 r
F
P
p
.002 w
.50047 .59225 m .48559 .59414 L .47088 .62775 L p
.15 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45591 .62951 m .47088 .62775 L .48559 .59414 L p
.05 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.76609 .53713 m .75009 .53925 L .73774 .48108 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.72216 .49622 m .73774 .48108 L .75009 .53925 L p
1 .45 0 r
F P
0 0 0 r
s
P
p
.86098 .26851 m .88682 .2753 L .87031 .27852 L 1 0 0 r
F
P
p
.84444 .27179 m .86098 .26851 L .87031 .27852 L 1 0 0 r
F
P
p
.80167 .26826 m .82804 .27505 L .81177 .27828 L 1 0 0 r
F
P
p
.78538 .27154 m .80167 .26826 L .81177 .27828 L 1 0 0 r
F
P
p
.002 w
.91426 .48163 m .89763 .48399 L .88865 .47667 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.87198 .47907 m .88865 .47667 L .89763 .48399 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.74232 .26801 m .76922 .2748 L .7532 .27803 L 1 0 0 r
F
P
p
.72627 .27129 m .74232 .26801 L .7532 .27803 L 1 0 0 r
F
P
p
.002 w
.85546 .48145 m .83907 .48381 L .82932 .47649 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8129 .47889 m .82932 .47649 L .83907 .48381 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68294 .26775 m .71036 .27455 L .69458 .27778 L 1 .1 0 r
F
P
p
.66713 .27104 m .68294 .26775 L .69458 .27778 L 1 .35 0 r
F
P
p
.62351 .2675 m .65147 .2743 L .63593 .27753 L 1 .8 0 r
F
P
p
.60796 .27079 m .62351 .2675 L .63593 .27753 L 1 .85 0 r
F
P
p
.56404 .26724 m .59253 .27405 L .57724 .27729 L .7 1 0 r
F
P
p
.54874 .27054 m .56404 .26724 L .57724 .27729 L .55 1 0 r
F
P
p
.50454 .26699 m .53356 .2738 L .51851 .27704 L .45 1 0 r
F
P
p
.48948 .27028 m .50454 .26699 L .51851 .27704 L .4 1 0 r
F
P
p
.44499 .26673 m .47455 .27355 L .45975 .27679 L .4 1 0 r
F
P
p
.43019 .27003 m .44499 .26673 L .45975 .27679 L .4 1 0 r
F
P
p
.38541 .26648 m .4155 .2733 L .40094 .27654 L .1 1 0 r
F
P
p
.37085 .26978 m .38541 .26648 L .40094 .27654 L 0 1 0 r
F
P
p
.32579 .26622 m .35642 .27305 L .3421 .27629 L 0 1 .95 r
F
P
p
.31148 .26953 m .32579 .26622 L .3421 .27629 L 0 .85 1 r
F
P
p
.002 w
.55941 .61844 m .54424 .62022 L .53061 .56236 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51547 .59035 m .53061 .56236 L .54424 .62022 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.26613 .26597 m .29729 .2728 L .28322 .27605 L 1 0 .65 r
F
P
p
.25207 .26927 m .26613 .26597 L .28322 .27605 L 1 0 .05 r
F
P
p
.002 w
.73774 .48108 m .72216 .49622 L .71054 .47612 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.20643 .26571 m .23813 .27255 L .2243 .2758 L 1 0 0 r
F
P
p
.002 w
.48605 .61271 m .50047 .59225 L p
.47835 .61878 L .15 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48605 .61271 m .47149 .59359 L p
.49385 .60657 L .15 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50125 .61086 m .48605 .61271 L p
.49385 .60657 L .15 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47088 .62775 m .48605 .61271 L p
.47835 .61878 L .15 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41135 .66084 m .39636 .68865 L .38129 .65747 L p
0 1 .7 r
F P
0 0 0 r
s
P
p
.002 w
.78222 .53499 m .76609 .53713 L .75377 .4787 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.73774 .48108 m .75377 .4787 L .76609 .53713 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.86098 .26851 m .87767 .2652 L .88682 .2753 L 1 0 0 r
F
P
p
.81811 .26495 m .84444 .27179 L .82804 .27505 L 1 0 0 r
F
P
p
.80167 .26826 m .81811 .26495 L .82804 .27505 L 1 0 0 r
F
P
p
.002 w
.38129 .65747 m .39593 .65583 L .41135 .66084 L p
0 1 .7 r
F P
0 0 0 r
s
P
p
.002 w
.88865 .47667 m .90547 .47425 L .91426 .48163 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.75851 .26469 m .78538 .27154 L .76922 .2748 L 1 0 0 r
F
P
p
.74232 .26801 m .75851 .26469 L .76922 .2748 L 1 0 0 r
F
P
p
.002 w
.87198 .47907 m .85546 .48145 L .84589 .47406 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82932 .47649 m .84589 .47406 L .85546 .48145 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.31978 .89444 m .30559 .89506 L .28876 .89314 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69887 .26443 m .72627 .27129 L .71036 .27455 L 1 .05 0 r
F
P
p
.68294 .26775 m .69887 .26443 L .71036 .27455 L 1 .1 0 r
F
P
p
.6392 .26418 m .66713 .27104 L .65147 .2743 L 1 .65 0 r
F
P
p
.62351 .2675 m .6392 .26418 L .65147 .2743 L 1 .8 0 r
F
P
p
.002 w
.75377 .4787 m .73774 .48108 L .7266 .47369 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71054 .47612 m .7266 .47369 L .73774 .48108 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.57948 .26392 m .60796 .27079 L .59253 .27405 L .85 1 0 r
F
P
p
.56404 .26724 m .57948 .26392 L .59253 .27405 L .7 1 0 r
F
P
p
.51973 .26366 m .54874 .27054 L .53356 .2738 L .55 1 0 r
F
P
p
.50454 .26699 m .51973 .26366 L .53356 .2738 L .45 1 0 r
F
P
p
.45993 .26341 m .48948 .27028 L .47455 .27355 L .4 1 0 r
F
P
p
.44499 .26673 m .45993 .26341 L .47455 .27355 L .4 1 0 r
F
P
p
.4001 .26315 m .43019 .27003 L .4155 .2733 L .2 1 0 r
F
P
p
.38541 .26648 m .4001 .26315 L .4155 .2733 L .1 1 0 r
F
P
p
.002 w
.44108 .63126 m .42618 .64609 L .41113 .62761 L p
0 1 .25 r
F P
0 0 0 r
s
P
p
.002 w
.39593 .65583 m .41113 .62761 L .42618 .64609 L p
0 1 .45 r
F P
0 0 0 r
s
P
p
.34022 .26289 m .37085 .26978 L .35642 .27305 L 0 1 .8 r
F
P
p
.32579 .26622 m .34022 .26289 L .35642 .27305 L 0 1 .95 r
F
P
p
.002 w
.57464 .60354 m .55941 .61844 L .5458 .5473 L p
.55 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53061 .56236 m .5458 .5473 L .55941 .61844 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.28031 .26264 m .31148 .26953 L .29729 .2728 L .2 0 1 r
F
P
p
.26613 .26597 m .28031 .26264 L .29729 .2728 L 1 0 .65 r
F
P
p
.22036 .26238 m .25207 .26927 L .23813 .27255 L 1 0 0 r
F
P
p
.20643 .26571 m .22036 .26238 L .23813 .27255 L 1 0 0 r
F
P
p
.002 w
.79849 .53283 m .78222 .53499 L .76995 .4763 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.75377 .4787 m .76995 .4763 L .78222 .53499 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.83469 .2616 m .86098 .26851 L .84444 .27179 L 1 0 0 r
F
P
p
.81811 .26495 m .83469 .2616 L .84444 .27179 L 1 0 0 r
F
P
p
.002 w
.5458 .5473 m .53061 .56236 L .51657 .609 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50125 .61086 m .51657 .609 L .53061 .56236 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.77484 .26135 m .80167 .26826 L .78538 .27154 L 1 0 0 r
F
P
p
.75851 .26469 m .77484 .26135 L .78538 .27154 L 1 0 0 r
F
P
p
.002 w
.88865 .47667 m .87198 .47907 L .86259 .47162 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84589 .47406 m .86259 .47162 L .87198 .47907 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.71495 .26109 m .74232 .26801 L .72627 .27129 L 1 0 0 r
F
P
p
.69887 .26443 m .71495 .26109 L .72627 .27129 L 1 .05 0 r
F
P
p
.002 w
.28876 .89314 m .30307 .8925 L .31978 .89444 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.41113 .62761 m .42597 .62583 L .44108 .63126 L p
0 1 .25 r
F P
0 0 0 r
s
P
p
.002 w
.82932 .47649 m .8129 .47889 L .80272 .47143 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8129 .47889 m .79849 .53283 L .78626 .47388 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.78626 .47388 m .80272 .47143 L .8129 .47889 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.5611 .54519 m .57464 .60354 L p
.54901 .55356 L .55 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5611 .54519 m .57647 .52998 L .59004 .60168 L p
.65 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5611 .54519 m .5476 .59179 L p
.57331 .53674 L .7 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57647 .52998 m .5611 .54519 L p
.57331 .53674 L .7 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5458 .5473 m .5611 .54519 L p
.54901 .55356 L .55 1 0 r
F P
0 0 0 r
s
P
p
.65502 .26083 m .68294 .26775 L .66713 .27104 L 1 .4 0 r
F
P
p
.6392 .26418 m .65502 .26083 L .66713 .27104 L 1 .65 0 r
F
P
p
.002 w
.76995 .4763 m .75377 .4787 L .74281 .47125 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7266 .47369 m .74281 .47125 L .75377 .4787 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.59505 .26057 m .62351 .2675 L .60796 .27079 L 1 .9 0 r
F
P
p
.57948 .26392 m .59505 .26057 L .60796 .27079 L .85 1 0 r
F
P
p
.53504 .26031 m .56404 .26724 L .54874 .27054 L .8 1 0 r
F
P
p
.51973 .26366 m .53504 .26031 L .54874 .27054 L .55 1 0 r
F
P
p
.475 .26005 m .50454 .26699 L .48948 .27028 L .4 1 0 r
F
P
p
.45993 .26341 m .475 .26005 L .48948 .27028 L .4 1 0 r
F
P
p
.41491 .25979 m .44499 .26673 L .43019 .27003 L .2 1 0 r
F
P
p
.4001 .26315 m .41491 .25979 L .43019 .27003 L .2 1 0 r
F
P
p
.002 w
.5611 .54519 m .5458 .5473 L .53203 .59374 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53203 .59374 m .5458 .5473 L p
.52152 .59856 L .5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53203 .59374 m .5476 .59179 L .5611 .54519 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53203 .59374 m .51784 .57419 L p
.54267 .58887 L .3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5476 .59179 m .53203 .59374 L p
.54267 .58887 L .3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51657 .609 m .53203 .59374 L p
.52152 .59856 L .5 1 0 r
F P
0 0 0 r
s
P
p
.35478 .25953 m .38541 .26648 L .37085 .26978 L 0 1 .35 r
F
P
p
.34022 .26289 m .35478 .25953 L .37085 .26978 L 0 1 .8 r
F
P
p
.29461 .25927 m .32579 .26622 L .31148 .26953 L 0 .55 1 r
F
P
p
.28031 .26264 m .29461 .25927 L .31148 .26953 L .2 0 1 r
F
P
p
.23441 .25901 m .26613 .26597 L .25207 .26927 L 1 0 .1 r
F
P
p
.22036 .26238 m .23441 .25901 L .25207 .26927 L 1 0 0 r
F
P
p
.002 w
.76995 .4763 m .78626 .47388 L .79849 .53283 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.85141 .25823 m .87767 .2652 L .86098 .26851 L 1 0 0 r
F
P
p
.83469 .2616 m .85141 .25823 L .86098 .26851 L 1 0 0 r
F
P
p
.7913 .25797 m .81811 .26495 L .80167 .26826 L 1 0 0 r
F
P
p
.77484 .26135 m .7913 .25797 L .80167 .26826 L 1 0 0 r
F
P
p
.002 w
.39593 .65583 m .38129 .65747 L .36563 .639 L p
0 1 .45 r
F P
0 0 0 r
s
P
p
.002 w
.38129 .65747 m .36558 .71214 L .35102 .64073 L p
0 1 .7 r
F P
0 0 0 r
s
P
p
.002 w
.35102 .64073 m .36563 .639 L p
.36116 .64634 L 0 1 .7 r
F P
0 0 0 r
s
P
p
.002 w
.33618 .6557 m .35102 .64073 L .36558 .71214 L p
0 .45 1 r
F P
0 0 0 r
s
P
p
.002 w
.36558 .71214 m .34708 .87665 L .33618 .6557 L p
0 .45 1 r
F P
0 0 0 r
s
P
p
.002 w
.31553 .87515 m .33618 .6557 L .34708 .87665 L p
1 0 .95 r
F P
0 0 0 r
s
P
p
.002 w
.33618 .6557 m .31553 .87515 L .29818 .87287 L p
.3 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.29818 .87287 m .31875 .67754 L .33618 .6557 L p
.3 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.36563 .639 m .35102 .64073 L .3338 .66237 L p
0 1 .55 r
F P
0 0 0 r
s
P
p
.002 w
.36563 .639 m .34893 .64712 L p
.37016 .63157 L 0 1 .4 r
F P
0 0 0 r
s
P
p
.002 w
.38065 .62389 m .36563 .639 L p
.37016 .63157 L 0 1 .4 r
F P
0 0 0 r
s
P
p
.002 w
.36563 .639 m .38129 .65747 L p
.36116 .64634 L 0 1 .7 r
F P
0 0 0 r
s
P
p
.002 w
.90547 .47425 m .88865 .47667 L .87944 .46916 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.86259 .47162 m .87944 .46916 L .88865 .47667 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.73116 .25771 m .75851 .26469 L .74232 .26801 L 1 0 0 r
F
P
p
.71495 .26109 m .73116 .25771 L .74232 .26801 L 1 0 0 r
F
P
p
.002 w
.47088 .62775 m .45591 .62951 L .44111 .61072 L p
0 1 .05 r
F P
0 0 0 r
s
P
p
.002 w
.42597 .62583 m .44111 .61072 L .45591 .62951 L p
0 1 .15 r
F P
0 0 0 r
s
P
p
.002 w
.84589 .47406 m .82932 .47649 L .81932 .46897 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80272 .47143 m .81932 .46897 L .82932 .47649 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60558 .59979 m .59004 .60168 L .57647 .52998 L p
.7 1 0 r
F P
0 0 0 r
s
P
p
.67098 .25745 m .69887 .26443 L .68294 .26775 L 1 .3 0 r
F
P
p
.65502 .26083 m .67098 .25745 L .68294 .26775 L 1 .4 0 r
F
P
p
.002 w
.78626 .47388 m .76995 .4763 L .75915 .46878 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74281 .47125 m .75915 .46878 L .76995 .4763 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61076 .25719 m .6392 .26418 L .62351 .2675 L 1 .8 0 r
F
P
p
.59505 .26057 m .61076 .25719 L .62351 .2675 L 1 .9 0 r
F
P
p
.002 w
.69924 .48168 m .71054 .47612 L p
.7 .49488 L 1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.68394 .52349 m .69924 .48168 L p
.7 .49488 L 1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.69924 .48168 m .68703 .46086 L p
.69847 .46824 L 1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7266 .47369 m .71054 .47612 L .69924 .48168 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69924 .48168 m .7155 .47924 L .7266 .47369 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7155 .47924 m .69924 .48168 L p
.69847 .46824 L 1 .1 0 r
F P
0 0 0 r
s
P
p
.55049 .25693 m .57948 .26392 L .56404 .26724 L 1 1 0 r
F
P
p
.53504 .26031 m .55049 .25693 L .56404 .26724 L .8 1 0 r
F
P
p
.49019 .25667 m .51973 .26366 L .50454 .26699 L .45 1 0 r
F
P
p
.475 .26005 m .49019 .25667 L .50454 .26699 L .4 1 0 r
F
P
p
.42985 .25641 m .45993 .26341 L .44499 .26673 L .3 1 0 r
F
P
p
.41491 .25979 m .42985 .25641 L .44499 .26673 L .2 1 0 r
F
P
p
.36947 .25615 m .4001 .26315 L .38541 .26648 L .1 1 0 r
F
P
p
.35478 .25953 m .36947 .25615 L .38541 .26648 L 0 1 .35 r
F
P
p
.30904 .25588 m .34022 .26289 L .32579 .26622 L 0 1 1 r
F
P
p
.29461 .25927 m .30904 .25588 L .32579 .26622 L 0 .55 1 r
F
P
p
.24858 .25562 m .28031 .26264 L .26613 .26597 L .4 0 1 r
F
P
p
.23441 .25901 m .24858 .25562 L .26613 .26597 L 1 0 .1 r
F
P
p
.18807 .25536 m .22036 .26238 L .20643 .26571 L 1 0 .9 r
F
P
p
.85141 .25823 m .86827 .25484 L .87767 .2652 L 1 0 0 r
F
P
p
.80791 .25457 m .83469 .2616 L .81811 .26495 L 1 0 0 r
F
P
p
.7913 .25797 m .80791 .25457 L .81811 .26495 L 1 0 0 r
F
P
p
.002 w
.41113 .62761 m .39593 .65583 L .38065 .62389 L p
0 1 .25 r
F P
0 0 0 r
s
P
p
.002 w
.36563 .639 m .38065 .62389 L .39593 .65583 L p
0 1 .45 r
F P
0 0 0 r
s
P
p
.002 w
.87944 .46916 m .89644 .46667 L .90547 .47425 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.74752 .25431 m .77484 .26135 L .75851 .26469 L 1 0 0 r
F
P
p
.73116 .25771 m .74752 .25431 L .75851 .26469 L 1 0 0 r
F
P
p
.002 w
.57647 .52998 m .59201 .52778 L .60558 .59979 L p
.7 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59201 .52778 m .57647 .52998 L .56325 .57639 L p
.8 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56325 .57639 m .57647 .52998 L p
.55346 .57925 L .7 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56325 .57639 m .57906 .57434 L .59201 .52778 L p
.8 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56325 .57639 m .54935 .57004 L p
.57316 .57349 L .55 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57906 .57434 m .56325 .57639 L p
.57316 .57349 L .55 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5476 .59179 m .56325 .57639 L p
.55346 .57925 L .7 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35102 .64073 m .33618 .6557 L .31875 .67754 L p
0 1 .7 r
F P
0 0 0 r
s
P
p
.002 w
.48605 .61271 m .47088 .62775 L .45632 .59553 L p
.05 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44111 .61072 m .45632 .59553 L .47088 .62775 L p
0 1 .05 r
F P
0 0 0 r
s
P
p
.002 w
.86259 .47162 m .84589 .47406 L .83606 .46648 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81932 .46897 m .83606 .46648 L .84589 .47406 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62125 .59789 m .60558 .59979 L .59201 .52778 L p
.7 1 0 r
F P
0 0 0 r
s
P
p
.68708 .25405 m .71495 .26109 L .69887 .26443 L 1 .15 0 r
F
P
p
.67098 .25745 m .68708 .25405 L .69887 .26443 L 1 .3 0 r
F
P
p
.002 w
.30307 .8925 m .28876 .89314 L .27148 .89116 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.42597 .62583 m .41113 .62761 L .39574 .60871 L p
0 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.38065 .62389 m .39574 .60871 L .41113 .62761 L p
0 1 .25 r
F P
0 0 0 r
s
P
p
.002 w
.80272 .47143 m .78626 .47388 L .77564 .46629 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75915 .46878 m .77564 .46629 L .78626 .47388 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.6266 .25378 m .65502 .26083 L .6392 .26418 L 1 .7 0 r
F
P
p
.61076 .25719 m .6266 .25378 L .6392 .26418 L 1 .8 0 r
F
P
p
.002 w
.74281 .47125 m .7266 .47369 L .7155 .47924 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.56608 .25352 m .59505 .26057 L .57948 .26392 L 1 .95 0 r
F
P
p
.55049 .25693 m .56608 .25352 L .57948 .26392 L 1 1 0 r
F
P
p
.50552 .25326 m .53504 .26031 L .51973 .26366 L .55 1 0 r
F
P
p
.49019 .25667 m .50552 .25326 L .51973 .26366 L .45 1 0 r
F
P
p
.44492 .25299 m .475 .26005 L .45993 .26341 L .4 1 0 r
F
P
p
.42985 .25641 m .44492 .25299 L .45993 .26341 L .3 1 0 r
F
P
p
.38428 .25273 m .41491 .25979 L .4001 .26315 L .2 1 0 r
F
P
p
.36947 .25615 m .38428 .25273 L .4001 .26315 L .1 1 0 r
F
P
p
.3236 .25246 m .35478 .25953 L .34022 .26289 L 0 1 .6 r
F
P
p
.30904 .25588 m .3236 .25246 L .34022 .26289 L 0 1 1 r
F
P
p
.002 w
.31875 .67754 m .3338 .66237 L .35102 .64073 L p
0 1 .7 r
F P
0 0 0 r
s
P
p
.26287 .2522 m .29461 .25927 L .28031 .26264 L 0 1 .85 r
F
P
p
.24858 .25562 m .26287 .2522 L .28031 .26264 L .4 0 1 r
F
P
p
.002 w
.45632 .59553 m .47149 .59359 L .48605 .61271 L p
.05 1 0 r
F P
0 0 0 r
s
P
p
.20211 .25194 m .23441 .25901 L .22036 .26238 L .05 0 1 r
F
P
p
.18807 .25536 m .20211 .25194 L .22036 .26238 L 1 0 .9 r
F
P
p
.82467 .25114 m .85141 .25823 L .83469 .2616 L 1 0 0 r
F
P
p
.80791 .25457 m .82467 .25114 L .83469 .2616 L 1 0 0 r
F
P
p
.76401 .25088 m .7913 .25797 L .77484 .26135 L 1 0 0 r
F
P
p
.74752 .25431 m .76401 .25088 L .77484 .26135 L 1 0 0 r
F
P
p
.002 w
.60769 .52556 m .62125 .59789 L p
.59494 .53479 L .7 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63706 .59597 m .62125 .59789 L .60769 .52556 L p
.75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60769 .52556 m .62334 .51014 L .63706 .59597 L p
.75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60769 .52556 m .59501 .57228 L p
.62056 .51625 L .95 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62334 .51014 m .60769 .52556 L p
.62056 .51625 L .95 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59201 .52778 m .60769 .52556 L p
.59494 .53479 L .7 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60769 .52556 m .59201 .52778 L .57906 .57434 L p
.8 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.87944 .46916 m .86259 .47162 L .85295 .46397 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83606 .46648 m .85295 .46397 L .86259 .47162 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70332 .25061 m .73116 .25771 L .71495 .26109 L 1 0 0 r
F
P
p
.68708 .25405 m .70332 .25061 L .71495 .26109 L 1 .15 0 r
F
P
p
.002 w
.3175 .89186 m .30307 .8925 L .2859 .89051 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.27148 .89116 m .2859 .89051 L .30307 .8925 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.44111 .61072 m .42597 .62583 L .41113 .58011 L p
.15 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39574 .60871 m .41113 .58011 L .42597 .62583 L p
0 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.81932 .46897 m .80272 .47143 L .79226 .46378 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77564 .46629 m .79226 .46378 L .80272 .47143 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64258 .25034 m .67098 .25745 L .65502 .26083 L 1 .55 0 r
F
P
p
.6266 .25378 m .64258 .25034 L .65502 .26083 L 1 .7 0 r
F
P
p
.002 w
.75915 .46878 m .74281 .47125 L .73154 .46359 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7155 .47924 m .73154 .46359 L .74281 .47125 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.5818 .25008 m .61076 .25719 L .59505 .26057 L 1 .8 0 r
F
P
p
.56608 .25352 m .5818 .25008 L .59505 .26057 L 1 .95 0 r
F
P
p
.52098 .24981 m .55049 .25693 L .53504 .26031 L .65 1 0 r
F
P
p
.50552 .25326 m .52098 .24981 L .53504 .26031 L .55 1 0 r
F
P
p
.002 w
.65214 .54107 m .63706 .59597 L .62334 .51014 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62334 .51014 m .63927 .50782 L .65214 .54107 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.46012 .24955 m .49019 .25667 L .475 .26005 L .4 1 0 r
F
P
p
.44492 .25299 m .46012 .24955 L .475 .26005 L .4 1 0 r
F
P
p
.39922 .24928 m .42985 .25641 L .41491 .25979 L .2 1 0 r
F
P
p
.38428 .25273 m .39922 .24928 L .41491 .25979 L .2 1 0 r
F
P
p
.33828 .24901 m .36947 .25615 L .35478 .25953 L 0 1 .15 r
F
P
p
.3236 .25246 m .33828 .24901 L .35478 .25953 L 0 1 .6 r
F
P
p
.002 w
.3338 .66237 m .34893 .64712 L .36563 .639 L p
0 1 .55 r
F P
0 0 0 r
s
P
p
.27729 .24875 m .30904 .25588 L .29461 .25927 L 0 1 .6 r
F
P
p
.26287 .2522 m .27729 .24875 L .29461 .25927 L 0 1 .85 r
F
P
p
.002 w
.51657 .609 m .50125 .61086 L .48688 .57826 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47149 .59359 m .48688 .57826 L .50125 .61086 L p
.15 1 0 r
F P
0 0 0 r
s
P
p
.21627 .24848 m .24858 .25562 L .23441 .25901 L 0 .2 1 r
F
P
p
.20211 .25194 m .21627 .24848 L .23441 .25901 L .05 0 1 r
F
P
p
.002 w
.45632 .59553 m .44111 .61072 L .42615 .5781 L p
.25 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41113 .58011 m .42615 .5781 L .44111 .61072 L p
.15 1 0 r
F P
0 0 0 r
s
P
p
.84157 .24768 m .86827 .25484 L .85141 .25823 L 1 0 0 r
F
P
p
.82467 .25114 m .84157 .24768 L .85141 .25823 L 1 0 0 r
F
P
p
.002 w
.65533 .50549 m .66786 .52573 L p
.64646 .51232 L 1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.65533 .50549 m .67128 .48984 L .68394 .52349 L p
1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.65533 .50549 m .64311 .52515 L p
.66432 .49857 L 1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.67128 .48984 m .65533 .50549 L p
.66432 .49857 L 1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.63927 .50782 m .65533 .50549 L p
.64646 .51232 L 1 .75 0 r
F P
0 0 0 r
s
P
p
.78066 .24741 m .80791 .25457 L .7913 .25797 L 1 0 0 r
F
P
p
.76401 .25088 m .78066 .24741 L .7913 .25797 L 1 0 0 r
F
P
p
.002 w
.57906 .57434 m .59501 .57228 L .60769 .52556 L p
.8 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.89644 .46667 m .87944 .46916 L .86998 .46144 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85295 .46397 m .86998 .46144 L .87944 .46916 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7197 .24714 m .74752 .25431 L .73116 .25771 L 1 0 0 r
F
P
p
.70332 .25061 m .7197 .24714 L .73116 .25771 L 1 0 0 r
F
P
p
.002 w
.33205 .89121 m .3175 .89186 L .30088 .87587 L p
1 0 .1 r
F P
0 0 0 r
s
P
p
.002 w
.2859 .89051 m .30088 .87587 L .3175 .89186 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.83606 .46648 m .81932 .46897 L .80904 .46125 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79226 .46378 m .80904 .46125 L .81932 .46897 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.6587 .24688 m .68708 .25405 L .67098 .25745 L 1 .5 0 r
F
P
p
.64258 .25034 m .6587 .24688 L .67098 .25745 L 1 .55 0 r
F
P
p
.002 w
.39574 .60871 m .38065 .62389 L .36413 .6318 L p
0 1 .15 r
F P
0 0 0 r
s
P
p
.002 w
.34893 .64712 m .36413 .6318 L .38065 .62389 L p
0 1 .4 r
F P
0 0 0 r
s
P
p
.002 w
.77564 .46629 m .75915 .46878 L .74806 .46105 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73154 .46359 m .74806 .46105 L .75915 .46878 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.59766 .24661 m .6266 .25378 L .61076 .25719 L 1 .7 0 r
F
P
p
.5818 .25008 m .59766 .24661 L .61076 .25719 L 1 .8 0 r
F
P
p
.002 w
.47149 .59359 m .45632 .59553 L .4413 .57607 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42615 .5781 m .4413 .57607 L .45632 .59553 L p
.25 1 0 r
F P
0 0 0 r
s
P
p
.53658 .24634 m .56608 .25352 L .55049 .25693 L .75 1 0 r
F
P
p
.52098 .24981 m .53658 .24634 L .55049 .25693 L .65 1 0 r
F
P
p
.47546 .24607 m .50552 .25326 L .49019 .25667 L .4 1 0 r
F
P
p
.46012 .24955 m .47546 .24607 L .49019 .25667 L .4 1 0 r
F
P
p
.41429 .2458 m .44492 .25299 L .42985 .25641 L .3 1 0 r
F
P
p
.39922 .24928 m .41429 .2458 L .42985 .25641 L .2 1 0 r
F
P
p
.35309 .24553 m .38428 .25273 L .36947 .25615 L .3 1 0 r
F
P
p
.33828 .24901 m .35309 .24553 L .36947 .25615 L 0 1 .15 r
F
P
p
.002 w
.63927 .50782 m .62334 .51014 L .61082 .54316 L p
1 .85 0 r
F P
0 0 0 r
s
P
p
.002 w
.61082 .54316 m .62334 .51014 L p
.59981 .56177 L .95 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61082 .54316 m .59721 .5091 L p
.62192 .5244 L 1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.62682 .52744 m .63927 .50782 L p
.61658 .53601 L 1 .85 0 r
F P
0 0 0 r
s
P
p
.002 w
.61082 .54316 m .62682 .52744 L p
.61658 .53601 L 1 .85 0 r
F P
0 0 0 r
s
P
p
.002 w
.65533 .50549 m .63927 .50782 L .62682 .52744 L p
1 .8 0 r
F P
0 0 0 r
s
P
p
.002 w
.62682 .52744 m .61334 .49314 L p
.63718 .51878 L 1 .8 0 r
F P
0 0 0 r
s
P
p
.002 w
.62682 .52744 m .64311 .52515 L .65533 .50549 L p
1 .8 0 r
F P
0 0 0 r
s
P
p
.002 w
.64311 .52515 m .62682 .52744 L p
.63718 .51878 L 1 .8 0 r
F P
0 0 0 r
s
P
p
.002 w
.62682 .52744 m .61082 .54316 L p
.62192 .5244 L 1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.59501 .57228 m .61082 .54316 L p
.59981 .56177 L .95 1 0 r
F P
0 0 0 r
s
P
p
.29184 .24527 m .3236 .25246 L .30904 .25588 L 0 1 .15 r
F
P
p
.27729 .24875 m .29184 .24527 L .30904 .25588 L 0 1 .6 r
F
P
p
.002 w
.53203 .59374 m .51657 .609 L .5023 .57623 L p
.25 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48688 .57826 m .5023 .57623 L .51657 .609 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.23055 .245 m .26287 .2522 L .24858 .25562 L 0 1 .85 r
F
P
p
.21627 .24848 m .23055 .245 L .24858 .25562 L 0 .2 1 r
F
P
p
.002 w
.69924 .48168 m .68394 .52349 L .67128 .48984 L p
1 .35 0 r
F P
0 0 0 r
s
P
p
.002 w
.67128 .48984 m .68703 .46086 L .69924 .48168 L p
1 .35 0 r
F P
0 0 0 r
s
P
p
.16922 .24473 m .20211 .25194 L .18807 .25536 L 0 .85 1 r
F
P
p
.002 w
.41113 .58011 m .39574 .60871 L .3797 .60286 L p
.1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36413 .6318 m .3797 .60286 L .39574 .60871 L p
0 1 .15 r
F P
0 0 0 r
s
P
p
.84157 .24768 m .85862 .24419 L .86827 .25484 L 1 0 0 r
F
P
p
.002 w
.42615 .5781 m .41113 .58011 L .39477 .60092 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3797 .60286 m .39477 .60092 L .41113 .58011 L p
.1 1 0 r
F P
0 0 0 r
s
P
p
.79744 .24392 m .82467 .25114 L .80791 .25457 L 1 0 0 r
F
P
p
.78066 .24741 m .79744 .24392 L .80791 .25457 L 1 0 0 r
F
P
p
.002 w
.86998 .46144 m .88717 .45889 L .89644 .46667 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.73622 .24365 m .76401 .25088 L .74752 .25431 L 1 0 0 r
F
P
p
.7197 .24714 m .73622 .24365 L .74752 .25431 L 1 0 0 r
F
P
p
.002 w
.34708 .87665 m .33205 .89121 L .31553 .87515 L p
1 0 .95 r
F P
0 0 0 r
s
P
p
.002 w
.30088 .87587 m .31553 .87515 L .33205 .89121 L p
1 0 .1 r
F P
0 0 0 r
s
P
p
.002 w
.85295 .46397 m .83606 .46648 L .82596 .4587 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80904 .46125 m .82596 .4587 L .83606 .46648 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67496 .24338 m .70332 .25061 L .68708 .25405 L 1 .35 0 r
F
P
p
.6587 .24688 m .67496 .24338 L .68708 .25405 L 1 .5 0 r
F
P
p
.002 w
.2859 .89051 m .27148 .89116 L .25373 .88913 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79226 .46378 m .77564 .46629 L .76472 .4585 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74806 .46105 m .76472 .4585 L .77564 .46629 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5023 .57623 m .51784 .57419 L .53203 .59374 L p
.25 1 0 r
F P
0 0 0 r
s
P
p
.61366 .24311 m .64258 .25034 L .6266 .25378 L 1 .7 0 r
F
P
p
.59766 .24661 m .61366 .24311 L .6266 .25378 L 1 .7 0 r
F
P
p
.002 w
.48688 .57826 m .47149 .59359 L .45659 .57403 L p
.35 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4413 .57607 m .45659 .57403 L .47149 .59359 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.55231 .24284 m .5818 .25008 L .56608 .25352 L .8 1 0 r
F
P
p
.53658 .24634 m .55231 .24284 L .56608 .25352 L .75 1 0 r
F
P
p
.49093 .24257 m .52098 .24981 L .50552 .25326 L .45 1 0 r
F
P
p
.47546 .24607 m .49093 .24257 L .50552 .25326 L .4 1 0 r
F
P
p
.4295 .24229 m .46012 .24955 L .44492 .25299 L .4 1 0 r
F
P
p
.41429 .2458 m .4295 .24229 L .44492 .25299 L .3 1 0 r
F
P
p
.36803 .24202 m .39922 .24928 L .38428 .25273 L .4 1 0 r
F
P
p
.35309 .24553 m .36803 .24202 L .38428 .25273 L .3 1 0 r
F
P
p
.30652 .24175 m .33828 .24901 L .3236 .25246 L .3 1 0 r
F
P
p
.29184 .24527 m .30652 .24175 L .3236 .25246 L 0 1 .15 r
F
P
p
.24496 .24148 m .27729 .24875 L .26287 .2522 L .1 1 0 r
F
P
p
.23055 .245 m .24496 .24148 L .26287 .2522 L 0 1 .85 r
F
P
p
.002 w
.73154 .46359 m .7155 .47924 L .70343 .4583 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.002 w
.68703 .46086 m .70343 .4583 L .7155 .47924 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.18337 .24121 m .21627 .24848 L .20211 .25194 L .1 1 0 r
F
P
p
.16922 .24473 m .18337 .24121 L .20211 .25194 L 0 .85 1 r
F
P
p
.002 w
.5023 .57623 m .48688 .57826 L .47201 .57196 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45659 .57403 m .47201 .57196 L .48688 .57826 L p
.35 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4413 .57607 m .42615 .5781 L .41044 .5718 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39477 .60092 m .41044 .5718 L .42615 .5781 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31875 .67754 m .29818 .87287 L .28035 .87054 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.28035 .87054 m .30072 .70013 L .31875 .67754 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.31875 .67754 m .30072 .70013 L p
.32119 .67676 L 0 1 1 r
F P
0 0 0 r
s
P
p
.002 w
.3338 .66237 m .32627 .66996 L p
.32119 .67676 L 0 1 1 r
F P
0 0 0 r
s
P
p
.002 w
.32627 .66996 m .31875 .67754 L p
.32119 .67676 L 0 1 1 r
F P
0 0 0 r
s
P
p
.002 w
.30072 .70013 m .31679 .6572 L .3338 .66237 L p
0 1 1 r
F P
0 0 0 r
s
P
p
.002 w
.28035 .87054 m .26494 .88566 L .25504 .88449 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.2601 .87827 m .28035 .87054 L .25504 .88449 L 1 0 .05 r
F
P
p
.002 w
.25504 .88449 m .24644 .88348 L p
.2601 .87827 L 1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.24644 .88348 m .26149 .88275 L .28035 .87054 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.30072 .70013 m .29155 .77683 L p
.28796 .76662 L 1 0 .7 r
F P
0 0 0 r
s
P
p
.002 w
.26626 .87966 m .26149 .88275 L p
.30072 .70013 L 1 0 .7 r
F P
0 0 0 r
s
P
p
.002 w
.28035 .87054 m .26626 .87966 L p
.28796 .76662 L 1 0 .7 r
F P
0 0 0 r
s
P
p
.002 w
.29155 .77683 m .28035 .87054 L p
.28796 .76662 L 1 0 .7 r
F P
0 0 0 r
s
P
p
.002 w
.30088 .87587 m .2859 .89051 L .26827 .88846 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.26827 .88846 m .28294 .88778 L .30088 .87587 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.29818 .87287 m .28294 .88778 L .26494 .88566 L p
1 0 .1 r
F P
0 0 0 r
s
P
p
.002 w
.26494 .88566 m .28035 .87054 L .29818 .87287 L p
1 0 .1 r
F P
0 0 0 r
s
P
p
.002 w
.26149 .88275 m .27668 .88202 L .30072 .70013 L p
1 0 .7 r
F P
0 0 0 r
s
P
p
.002 w
.27989 .68895 m .29708 .72208 L p
.26662 .70602 L .2 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.26426 .70478 m .26568 .70334 L p
.26662 .70602 L .2 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.26568 .70334 m .27989 .68895 L p
.26662 .70602 L .2 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.31679 .6572 m .30072 .70013 L .2805 .85312 L p
0 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.2805 .85312 m .27668 .88202 L p
.28222 .851 L 0 0 1 r
F P
0 0 0 r
s
P
p
.28222 .851 m .31679 .6572 L .2805 .85312 L 0 0 1 r
F
P
p
.002 w
.29708 .72208 m .27989 .68895 L p
.29345 .69618 L 0 .55 1 r
F P
0 0 0 r
s
P
p
.002 w
.29708 .72208 m .30375 .70012 L p
.29873 .73386 L 0 0 1 r
F P
0 0 0 r
s
P
p
.29596 .774 m .30375 .70012 L .31083 .69065 L 0 0 1 r
F
P
p
.27668 .88202 m .29539 .75634 L .29596 .774 L 0 0 1 r
F
P
p
.29539 .75634 m .30375 .70012 L .29596 .774 L 0 0 1 r
F
P
p
.002 w
.30375 .70012 m .31679 .6572 L p
.31083 .69065 L 0 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.34893 .64712 m .3338 .66237 L .31679 .6572 L p
0 1 .65 r
F P
0 0 0 r
s
P
p
.002 w
.31679 .6572 m .33246 .62803 L .34893 .64712 L p
0 1 .65 r
F P
0 0 0 r
s
P
p
.002 w
.33246 .62803 m .31679 .6572 L .29708 .72208 L p
0 .85 1 r
F P
0 0 0 r
s
P
p
.002 w
.29708 .72208 m .31268 .70643 L .33246 .62803 L p
0 .85 1 r
F P
0 0 0 r
s
P
p
.002 w
.29606 .65881 m .31268 .70643 L p
.29345 .69618 L 0 .55 1 r
F P
0 0 0 r
s
P
p
.002 w
.27989 .68895 m .29246 .66552 L p
.29345 .69618 L 0 .55 1 r
F P
0 0 0 r
s
P
p
.002 w
.29246 .66552 m .29606 .65881 L p
.29345 .69618 L 0 .55 1 r
F P
0 0 0 r
s
P
p
.002 w
.31268 .70643 m .29708 .72208 L p
.29345 .69618 L 0 .55 1 r
F P
0 0 0 r
s
P
p
.002 w
.27668 .88202 m .29708 .72208 L p
.29873 .73386 L 0 0 1 r
F P
0 0 0 r
s
P
p
.81438 .24039 m .84157 .24768 L .82467 .25114 L 1 0 0 r
F
P
p
.79744 .24392 m .81438 .24039 L .82467 .25114 L 1 0 0 r
F
P
p
.7529 .24012 m .78066 .24741 L .76401 .25088 L 1 0 0 r
F
P
p
.73622 .24365 m .7529 .24012 L .76401 .25088 L 1 0 0 r
F
P
p
.002 w
.86998 .46144 m .85295 .46397 L .84304 .45612 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82596 .4587 m .84304 .45612 L .85295 .46397 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69137 .23985 m .7197 .24714 L .70332 .25061 L 1 .15 0 r
F
P
p
.67496 .24338 m .69137 .23985 L .70332 .25061 L 1 .35 0 r
F
P
p
.002 w
.25373 .88913 m .26827 .88846 L .2859 .89051 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80904 .46125 m .79226 .46378 L .78153 .45592 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76472 .4585 m .78153 .45592 L .79226 .46378 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56325 .57639 m .5476 .59179 L .53353 .57212 L p
.35 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51784 .57419 m .53353 .57212 L .5476 .59179 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.6298 .23957 m .6587 .24688 L .64258 .25034 L 1 .6 0 r
F
P
p
.61366 .24311 m .6298 .23957 L .64258 .25034 L 1 .7 0 r
F
P
p
.002 w
.74806 .46105 m .73154 .46359 L .71997 .45572 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70343 .4583 m .71997 .45572 L .73154 .46359 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.56819 .2393 m .59766 .24661 L .5818 .25008 L .85 1 0 r
F
P
p
.55231 .24284 m .56819 .2393 L .5818 .25008 L .8 1 0 r
F
P
p
.50654 .23903 m .53658 .24634 L .52098 .24981 L .6 1 0 r
F
P
p
.49093 .24257 m .50654 .23903 L .52098 .24981 L .45 1 0 r
F
P
p
.44484 .23875 m .47546 .24607 L .46012 .24955 L .4 1 0 r
F
P
p
.4295 .24229 m .44484 .23875 L .46012 .24955 L .4 1 0 r
F
P
p
.3831 .23848 m .41429 .2458 L .39922 .24928 L .4 1 0 r
F
P
p
.36803 .24202 m .3831 .23848 L .39922 .24928 L .4 1 0 r
F
P
p
.32132 .23821 m .35309 .24553 L .33828 .24901 L .4 1 0 r
F
P
p
.30652 .24175 m .32132 .23821 L .33828 .24901 L .3 1 0 r
F
P
p
.2595 .23793 m .29184 .24527 L .27729 .24875 L .2 1 0 r
F
P
p
.24496 .24148 m .2595 .23793 L .27729 .24875 L .1 1 0 r
F
P
p
.002 w
.31553 .87515 m .30088 .87587 L .28294 .88778 L p
1 0 .15 r
F P
0 0 0 r
s
P
p
.19764 .23766 m .23055 .245 L .21627 .24848 L .35 1 0 r
F
P
p
.18337 .24121 m .19764 .23766 L .21627 .24848 L .1 1 0 r
F
P
p
.002 w
.53353 .57212 m .54935 .57004 L .56325 .57639 L p
.35 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51784 .57419 m .5023 .57623 L .48756 .56988 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47201 .57196 m .48756 .56988 L .5023 .57623 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45659 .57403 m .4413 .57607 L .42573 .56972 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41044 .5718 m .42573 .56972 L .4413 .57607 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.83147 .23684 m .85862 .24419 L .84157 .24768 L 1 0 0 r
F
P
p
.81438 .24039 m .83147 .23684 L .84157 .24768 L 1 0 0 r
F
P
p
.76972 .23656 m .79744 .24392 L .78066 .24741 L 1 0 0 r
F
P
p
.7529 .24012 m .76972 .23656 L .78066 .24741 L 1 0 0 r
F
P
p
.002 w
.36413 .6318 m .34893 .64712 L .33246 .62803 L p
0 1 .45 r
F P
0 0 0 r
s
P
p
.002 w
.88717 .45889 m .86998 .46144 L .86026 .45352 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84304 .45612 m .86026 .45352 L .86998 .46144 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70792 .23629 m .73622 .24365 L .7197 .24714 L 1 .05 0 r
F
P
p
.69137 .23985 m .70792 .23629 L .7197 .24714 L 1 .15 0 r
F
P
p
.002 w
.68703 .46086 m .67128 .48984 L .65907 .49577 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.65907 .49577 m .64627 .48819 L p
.6561 .48991 L 1 .55 0 r
F P
0 0 0 r
s
P
p
.002 w
.65907 .49577 m .67128 .48984 L p
.66198 .5015 L 1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.65907 .49577 m .67559 .49333 L .68703 .46086 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.67559 .49333 m .65907 .49577 L p
.6561 .48991 L 1 .55 0 r
F P
0 0 0 r
s
P
p
.002 w
.64311 .52515 m .65907 .49577 L p
.66198 .5015 L 1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.82596 .4587 m .80904 .46125 L .79848 .45332 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78153 .45592 m .79848 .45332 L .80904 .46125 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64608 .23601 m .67496 .24338 L .6587 .24688 L 1 .5 0 r
F
P
p
.6298 .23957 m .64608 .23601 L .6587 .24688 L 1 .6 0 r
F
P
p
.002 w
.76472 .4585 m .74806 .46105 L .73666 .45312 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71997 .45572 m .73666 .45312 L .74806 .46105 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5842 .23574 m .61366 .24311 L .59766 .24661 L 1 1 0 r
F
P
p
.56819 .2393 m .5842 .23574 L .59766 .24661 L .85 1 0 r
F
P
p
.002 w
.70343 .4583 m .68703 .46086 L .67559 .49333 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.52228 .23546 m .55231 .24284 L .53658 .24634 L .8 1 0 r
F
P
p
.50654 .23903 m .52228 .23546 L .53658 .24634 L .6 1 0 r
F
P
p
.46032 .23518 m .49093 .24257 L .47546 .24607 L .4 1 0 r
F
P
p
.44484 .23875 m .46032 .23518 L .47546 .24607 L .4 1 0 r
F
P
p
.39831 .23491 m .4295 .24229 L .41429 .2458 L .4 1 0 r
F
P
p
.3831 .23848 m .39831 .23491 L .41429 .2458 L .4 1 0 r
F
P
p
.33626 .23463 m .36803 .24202 L .35309 .24553 L .4 1 0 r
F
P
p
.32132 .23821 m .33626 .23463 L .35309 .24553 L .4 1 0 r
F
P
p
.002 w
.3797 .60286 m .36413 .6318 L .34745 .62619 L p
0 1 .2 r
F P
0 0 0 r
s
P
p
.002 w
.34745 .62619 m .36413 .6318 L p
.34157 .62912 L 0 1 .45 r
F P
0 0 0 r
s
P
p
.002 w
.34745 .62619 m .32836 .69068 L p
.35342 .62323 L 0 1 .8 r
F P
0 0 0 r
s
P
p
.002 w
.34745 .62619 m .36322 .59685 L .3797 .60286 L p
0 1 .2 r
F P
0 0 0 r
s
P
p
.002 w
.36322 .59685 m .34745 .62619 L p
.35342 .62323 L 0 1 .8 r
F P
0 0 0 r
s
P
p
.002 w
.33246 .62803 m .34745 .62619 L p
.34157 .62912 L 0 1 .45 r
F P
0 0 0 r
s
P
p
.27417 .23435 m .30652 .24175 L .29184 .24527 L .3 1 0 r
F
P
p
.2595 .23793 m .27417 .23435 L .29184 .24527 L .2 1 0 r
F
P
p
.002 w
.28294 .88778 m .29818 .87287 L .31553 .87515 L p
1 0 .15 r
F P
0 0 0 r
s
P
p
.21204 .23408 m .24496 .24148 L .23055 .245 L .4 1 0 r
F
P
p
.19764 .23766 m .21204 .23408 L .23055 .245 L .35 1 0 r
F
P
p
.002 w
.59501 .57228 m .57906 .57434 L .56515 .52727 L p
.7 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54935 .57004 m .56515 .52727 L .57906 .57434 L p
.55 1 0 r
F P
0 0 0 r
s
P
p
.14986 .2338 m .18337 .24121 L .16922 .24473 L .15 1 0 r
F
P
p
.002 w
.39477 .60092 m .3797 .60286 L .36322 .59685 L p
0 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53353 .57212 m .51784 .57419 L .50326 .56778 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48756 .56988 m .50326 .56778 L .51784 .57419 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47201 .57196 m .45659 .57403 L .44116 .56762 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42573 .56972 m .44116 .56762 L .45659 .57403 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.83147 .23684 m .84871 .23325 L .85862 .24419 L 1 0 0 r
F
P
p
.78669 .23297 m .81438 .24039 L .79744 .24392 L 1 0 0 r
F
P
p
.76972 .23656 m .78669 .23297 L .79744 .24392 L 1 0 0 r
F
P
p
.002 w
.86026 .45352 m .87764 .4509 L .88717 .45889 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.72462 .23269 m .7529 .24012 L .73622 .24365 L 1 0 0 r
F
P
p
.70792 .23629 m .72462 .23269 L .73622 .24365 L 1 .05 0 r
F
P
p
.002 w
.84304 .45612 m .82596 .4587 L .81559 .45069 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79848 .45332 m .81559 .45069 L .82596 .4587 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.26827 .88846 m .25373 .88913 L .23549 .88705 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66251 .23241 m .69137 .23985 L .67496 .24338 L 1 .5 0 r
F
P
p
.64608 .23601 m .66251 .23241 L .67496 .24338 L 1 .5 0 r
F
P
p
.002 w
.78153 .45592 m .76472 .4585 L .7535 .45049 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73666 .45312 m .7535 .45049 L .76472 .4585 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60036 .23214 m .6298 .23957 L .61366 .24311 L 1 .85 0 r
F
P
p
.5842 .23574 m .60036 .23214 L .61366 .24311 L 1 1 0 r
F
P
p
.002 w
.71997 .45572 m .70343 .4583 L .69226 .49087 L p
1 .15 0 r
F P
0 0 0 r
s
P
p
.002 w
.67559 .49333 m .69226 .49087 L .70343 .4583 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.53817 .23186 m .56819 .2393 L .55231 .24284 L .95 1 0 r
F
P
p
.52228 .23546 m .53817 .23186 L .55231 .24284 L .8 1 0 r
F
P
p
.47593 .23158 m .50654 .23903 L .49093 .24257 L .55 1 0 r
F
P
p
.46032 .23518 m .47593 .23158 L .49093 .24257 L .4 1 0 r
F
P
p
.41366 .2313 m .44484 .23875 L .4295 .24229 L .4 1 0 r
F
P
p
.39831 .23491 m .41366 .2313 L .4295 .24229 L .4 1 0 r
F
P
p
.35133 .23102 m .3831 .23848 L .36803 .24202 L .4 1 0 r
F
P
p
.33626 .23463 m .35133 .23102 L .36803 .24202 L .4 1 0 r
F
P
p
.28897 .23074 m .32132 .23821 L .30652 .24175 L .4 1 0 r
F
P
p
.27417 .23435 m .28897 .23074 L .30652 .24175 L .3 1 0 r
F
P
p
.22656 .23047 m .2595 .23793 L .24496 .24148 L .4 1 0 r
F
P
p
.21204 .23408 m .22656 .23047 L .24496 .24148 L .4 1 0 r
F
P
p
.002 w
.61082 .54316 m .59501 .57228 L .58117 .52498 L p
.85 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56515 .52727 m .58117 .52498 L .59501 .57228 L p
.7 1 0 r
F P
0 0 0 r
s
P
p
.16411 .23019 m .19764 .23766 L .18337 .24121 L .45 1 0 r
F
P
p
.14986 .2338 m .16411 .23019 L .18337 .24121 L .15 1 0 r
F
P
p
.002 w
.41044 .5718 m .39477 .60092 L .37843 .59486 L p
.1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36322 .59685 m .37843 .59486 L .39477 .60092 L p
0 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54935 .57004 m .53353 .57212 L .51913 .55199 L p
.55 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50326 .56778 m .51913 .55199 L .53353 .57212 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48756 .56988 m .47201 .57196 L .45672 .5655 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44116 .56762 m .45672 .5655 L .47201 .57196 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58117 .52498 m .59721 .5091 L .61082 .54316 L p
.85 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42573 .56972 m .41044 .5718 L .39377 .59285 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37843 .59486 m .39377 .59285 L .41044 .5718 L p
.1 1 0 r
F P
0 0 0 r
s
P
p
.80381 .22935 m .83147 .23684 L .81438 .24039 L 1 0 0 r
F
P
p
.78669 .23297 m .80381 .22935 L .81438 .24039 L 1 0 0 r
F
P
p
.74147 .22907 m .76972 .23656 L .7529 .24012 L 1 0 0 r
F
P
p
.72462 .23269 m .74147 .22907 L .7529 .24012 L 1 0 0 r
F
P
p
.002 w
.86026 .45352 m .84304 .45612 L .83285 .44804 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81559 .45069 m .83285 .44804 L .84304 .45612 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.28294 .88778 m .26827 .88846 L .25015 .88636 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.23549 .88705 m .25015 .88636 L .26827 .88846 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67909 .22879 m .70792 .23629 L .69137 .23985 L 1 .45 0 r
F
P
p
.66251 .23241 m .67909 .22879 L .69137 .23985 L 1 .5 0 r
F
P
p
.002 w
.79848 .45332 m .78153 .45592 L .77049 .44784 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7535 .45049 m .77049 .44784 L .78153 .45592 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61667 .22851 m .64608 .23601 L .6298 .23957 L 1 .75 0 r
F
P
p
.60036 .23214 m .61667 .22851 L .6298 .23957 L 1 .85 0 r
F
P
p
.002 w
.73666 .45312 m .71997 .45572 L .70808 .44764 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69226 .49087 m .70808 .44764 L .71997 .45572 L p
1 .15 0 r
F P
0 0 0 r
s
P
p
.5542 .22823 m .5842 .23574 L .56819 .2393 L 1 1 0 r
F
P
p
.53817 .23186 m .5542 .22823 L .56819 .2393 L .95 1 0 r
F
P
p
.49169 .22794 m .52228 .23546 L .50654 .23903 L .85 1 0 r
F
P
p
.47593 .23158 m .49169 .22794 L .50654 .23903 L .55 1 0 r
F
P
p
.002 w
.59721 .5091 m .61334 .49314 L .62682 .52744 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.42914 .22766 m .46032 .23518 L .44484 .23875 L .4 1 0 r
F
P
p
.41366 .2313 m .42914 .22766 L .44484 .23875 L .4 1 0 r
F
P
p
.002 w
.58117 .52498 m .56515 .52727 L .5511 .52016 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56515 .52727 m .54935 .57004 L .53507 .53612 L p
.8 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53507 .53612 m .5511 .52016 L .56515 .52727 L p
.8 1 0 r
F P
0 0 0 r
s
P
p
.36654 .22738 m .39831 .23491 L .3831 .23848 L .4 1 0 r
F
P
p
.35133 .23102 m .36654 .22738 L .3831 .23848 L .4 1 0 r
F
P
p
.3039 .2271 m .33626 .23463 L .32132 .23821 L .4 1 0 r
F
P
p
.28897 .23074 m .3039 .2271 L .32132 .23821 L .4 1 0 r
F
P
p
.002 w
.34745 .62619 m .33246 .62803 L .31268 .70643 L p
0 1 .95 r
F P
0 0 0 r
s
P
p
.24122 .22682 m .27417 .23435 L .2595 .23793 L .4 1 0 r
F
P
p
.22656 .23047 m .24122 .22682 L .2595 .23793 L .4 1 0 r
F
P
p
.17849 .22654 m .21204 .23408 L .19764 .23766 L .7 1 0 r
F
P
p
.16411 .23019 m .17849 .22654 L .19764 .23766 L .45 1 0 r
F
P
p
.002 w
.51913 .55199 m .53507 .53612 L .54935 .57004 L p
.55 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50326 .56778 m .48756 .56988 L .47242 .56336 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45672 .5655 m .47242 .56336 L .48756 .56988 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44116 .56762 m .42573 .56972 L .40926 .59082 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39377 .59285 m .40926 .59082 L .42573 .56972 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.82109 .22569 m .84871 .23325 L .83147 .23684 L 1 0 0 r
F
P
p
.80381 .22935 m .82109 .22569 L .83147 .23684 L 1 0 0 r
F
P
p
.75848 .22541 m .78669 .23297 L .76972 .23656 L 1 0 0 r
F
P
p
.74147 .22907 m .75848 .22541 L .76972 .23656 L 1 0 0 r
F
P
p
.002 w
.87764 .4509 m .86026 .45352 L .85027 .44537 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83285 .44804 m .85027 .44537 L .86026 .45352 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.25015 .88636 m .26494 .88566 L .28294 .88778 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69582 .22513 m .72462 .23269 L .70792 .23629 L 1 .3 0 r
F
P
p
.67909 .22879 m .69582 .22513 L .70792 .23629 L 1 .45 0 r
F
P
p
.002 w
.81559 .45069 m .79848 .45332 L .78763 .44517 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77049 .44784 m .78763 .44517 L .79848 .45332 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.63312 .22484 m .66251 .23241 L .64608 .23601 L 1 .6 0 r
F
P
p
.61667 .22851 m .63312 .22484 L .64608 .23601 L 1 .75 0 r
F
P
p
.002 w
.7535 .45049 m .73666 .45312 L .72495 .44496 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70808 .44764 m .72495 .44496 L .73666 .45312 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.57038 .22456 m .60036 .23214 L .5842 .23574 L 1 .85 0 r
F
P
p
.5542 .22823 m .57038 .22456 L .5842 .23574 L 1 1 0 r
F
P
p
.50759 .22428 m .53817 .23186 L .52228 .23546 L 1 .95 0 r
F
P
p
.49169 .22794 m .50759 .22428 L .52228 .23546 L .85 1 0 r
F
P
p
.002 w
.65907 .49577 m .64311 .52515 L .62973 .49068 L p
1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.61334 .49314 m .62973 .49068 L .64311 .52515 L p
1 .8 0 r
F P
0 0 0 r
s
P
p
.44476 .22399 m .47593 .23158 L .46032 .23518 L .5 1 0 r
F
P
p
.42914 .22766 m .44476 .22399 L .46032 .23518 L .4 1 0 r
F
P
p
.002 w
.59721 .5091 m .58117 .52498 L .56728 .51781 L p
1 .95 0 r
F P
0 0 0 r
s
P
p
.002 w
.5511 .52016 m .56728 .51781 L .58117 .52498 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.38189 .22371 m .41366 .2313 L .39831 .23491 L .4 1 0 r
F
P
p
.36654 .22738 m .38189 .22371 L .39831 .23491 L .4 1 0 r
F
P
p
.002 w
.62973 .49068 m .64627 .48819 L p
.64447 .49323 L 1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.64627 .48819 m .62973 .49068 L .61654 .49676 L p
1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.61654 .49676 m .63329 .49427 L .64627 .48819 L p
1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.64627 .48819 m .63329 .49427 L p
.6481 .48305 L 1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.66271 .47199 m .64627 .48819 L p
.6481 .48305 L 1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.64627 .48819 m .65907 .49577 L p
.64447 .49323 L 1 .7 0 r
F P
0 0 0 r
s
P
p
.31897 .22343 m .35133 .23102 L .33626 .23463 L .4 1 0 r
F
P
p
.3039 .2271 m .31897 .22343 L .33626 .23463 L .4 1 0 r
F
P
p
.002 w
.32836 .69068 m .34745 .62619 L p
.3154 .70013 L 0 1 .95 r
F P
0 0 0 r
s
P
p
.002 w
.32836 .69068 m .34376 .68908 L .36322 .59685 L p
0 1 .8 r
F P
0 0 0 r
s
P
p
.002 w
.32836 .69068 m .31353 .5864 L p
.34142 .68115 L 0 1 .6 r
F P
0 0 0 r
s
P
p
.002 w
.34376 .68908 m .32836 .69068 L p
.34142 .68115 L 0 1 .6 r
F P
0 0 0 r
s
P
p
.002 w
.31268 .70643 m .32836 .69068 L p
.3154 .70013 L 0 1 .95 r
F P
0 0 0 r
s
P
p
.25601 .22314 m .28897 .23074 L .27417 .23435 L .4 1 0 r
F
P
p
.24122 .22682 m .25601 .22314 L .27417 .23435 L .4 1 0 r
F
P
p
.193 .22286 m .22656 .23047 L .21204 .23408 L .85 1 0 r
F
P
p
.17849 .22654 m .193 .22286 L .21204 .23408 L .7 1 0 r
F
P
p
.12995 .22257 m .16411 .23019 L .14986 .2338 L .4 1 0 r
F
P
p
.002 w
.37843 .59486 m .36322 .59685 L .34376 .68908 L p
0 1 .35 r
F P
0 0 0 r
s
P
p
.002 w
.51913 .55199 m .50326 .56778 L .48827 .5612 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47242 .56336 m .48827 .5612 L .50326 .56778 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45672 .5655 m .44116 .56762 L .42488 .58878 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.40926 .59082 m .42488 .58878 L .44116 .56762 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.82109 .22569 m .83852 .222 L .84871 .23325 L 1 0 0 r
F
P
p
.77563 .22172 m .80381 .22935 L .78669 .23297 L 1 0 0 r
F
P
p
.75848 .22541 m .77563 .22172 L .78669 .23297 L 1 0 0 r
F
P
p
.002 w
.58361 .51544 m .59721 .5091 L p
.58233 .51343 L 1 .95 0 r
F P
0 0 0 r
s
P
p
.002 w
.56728 .51781 m .58361 .51544 L p
.58233 .51343 L 1 .95 0 r
F P
0 0 0 r
s
P
p
.002 w
.58361 .51544 m .56963 .53601 L p
.58491 .51749 L .85 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61334 .49314 m .59721 .5091 L .58361 .51544 L p
1 .8 0 r
F P
0 0 0 r
s
P
p
.002 w
.58361 .51544 m .59995 .49924 L .61334 .49314 L p
1 .8 0 r
F P
0 0 0 r
s
P
p
.002 w
.59995 .49924 m .58361 .51544 L p
.58491 .51749 L .85 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.85027 .44537 m .86785 .44268 L .87764 .4509 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7127 .22143 m .74147 .22907 L .72462 .23269 L 1 .1 0 r
F
P
p
.69582 .22513 m .7127 .22143 L .72462 .23269 L 1 .3 0 r
F
P
p
.002 w
.83285 .44804 m .81559 .45069 L .80493 .44247 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78763 .44517 m .80493 .44247 L .81559 .45069 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.25015 .88636 m .23549 .88705 L .21674 .8849 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64972 .22115 m .67909 .22879 L .66251 .23241 L 1 .5 0 r
F
P
p
.63312 .22484 m .64972 .22115 L .66251 .23241 L 1 .6 0 r
F
P
p
.002 w
.77049 .44784 m .7535 .45049 L .74197 .44226 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72495 .44496 m .74197 .44226 L .7535 .45049 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5867 .22086 m .61667 .22851 L .60036 .23214 L 1 .65 0 r
F
P
p
.57038 .22456 m .5867 .22086 L .60036 .23214 L 1 .85 0 r
F
P
p
.52363 .22057 m .5542 .22823 L .53817 .23186 L 1 .8 0 r
F
P
p
.50759 .22428 m .52363 .22057 L .53817 .23186 L 1 .95 0 r
F
P
p
.002 w
.48827 .5612 m .50426 .55902 L .51913 .55199 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53507 .53612 m .51913 .55199 L .50426 .55902 L p
.55 1 0 r
F P
0 0 0 r
s
P
p
.46052 .22029 m .49169 .22794 L .47593 .23158 L .85 1 0 r
F
P
p
.44476 .22399 m .46052 .22029 L .47593 .23158 L .5 1 0 r
F
P
p
.39737 .22 m .42914 .22766 L .41366 .2313 L .4 1 0 r
F
P
p
.38189 .22371 m .39737 .22 L .41366 .2313 L .4 1 0 r
F
P
p
.002 w
.69226 .49087 m .67559 .49333 L .66271 .47199 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.64627 .48819 m .66271 .47199 L .67559 .49333 L p
1 .55 0 r
F P
0 0 0 r
s
P
p
.33417 .21972 m .36654 .22738 L .35133 .23102 L .4 1 0 r
F
P
p
.31897 .22343 m .33417 .21972 L .35133 .23102 L .4 1 0 r
F
P
p
.002 w
.62973 .49068 m .61334 .49314 L .59995 .49924 L p
1 .7 0 r
F P
0 0 0 r
s
P
p
.27093 .21943 m .3039 .2271 L .28897 .23074 L .4 1 0 r
F
P
p
.25601 .22314 m .27093 .21943 L .28897 .23074 L .4 1 0 r
F
P
p
.20764 .21914 m .24122 .22682 L .22656 .23047 L .9 1 0 r
F
P
p
.193 .22286 m .20764 .21914 L .22656 .23047 L .85 1 0 r
F
P
p
.14431 .21886 m .17849 .22654 L .16411 .23019 L .6 1 0 r
F
P
p
.12995 .22257 m .14431 .21886 L .16411 .23019 L .4 1 0 r
F
P
p
.002 w
.39377 .59285 m .37843 .59486 L .36163 .58862 L p
.1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34376 .68908 m .36163 .58862 L .37843 .59486 L p
0 1 .35 r
F P
0 0 0 r
s
P
p
.002 w
.47242 .56336 m .45672 .5655 L .44101 .55885 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42488 .58878 m .44101 .55885 L .45672 .5655 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5511 .52016 m .53507 .53612 L .5204 .55682 L p
.65 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50426 .55902 m .5204 .55682 L .53507 .53612 L p
.55 1 0 r
F P
0 0 0 r
s
P
p
.79294 .21799 m .82109 .22569 L .80381 .22935 L 1 0 0 r
F
P
p
.77563 .22172 m .79294 .21799 L .80381 .22935 L 1 0 0 r
F
P
p
.72973 .2177 m .75848 .22541 L .74147 .22907 L 1 0 0 r
F
P
p
.7127 .22143 m .72973 .2177 L .74147 .22907 L 1 .1 0 r
F
P
p
.002 w
.85027 .44537 m .83285 .44804 L .82239 .43975 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80493 .44247 m .82239 .43975 L .83285 .44804 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66647 .21742 m .69582 .22513 L .67909 .22879 L 1 .4 0 r
F
P
p
.64972 .22115 m .66647 .21742 L .67909 .22879 L 1 .5 0 r
F
P
p
.002 w
.26494 .88566 m .25015 .88636 L .23152 .88419 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.21674 .8849 m .23152 .88419 L .25015 .88636 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78763 .44517 m .77049 .44784 L .75915 .43954 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74197 .44226 m .75915 .43954 L .77049 .44784 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60317 .21713 m .63312 .22484 L .61667 .22851 L 1 .5 0 r
F
P
p
.5867 .22086 m .60317 .21713 L .61667 .22851 L 1 .65 0 r
F
P
p
.002 w
.70808 .44764 m .69226 .49087 L .67952 .4694 L p
1 .35 0 r
F P
0 0 0 r
s
P
p
.002 w
.72495 .44496 m .70808 .44764 L .69648 .46679 L p
1 .15 0 r
F P
0 0 0 r
s
P
p
.002 w
.67952 .4694 m .69648 .46679 L .70808 .44764 L p
1 .35 0 r
F P
0 0 0 r
s
P
p
.53982 .21684 m .57038 .22456 L .5542 .22823 L 1 .7 0 r
F
P
p
.52363 .22057 m .53982 .21684 L .5542 .22823 L 1 .8 0 r
F
P
p
.47643 .21655 m .50759 .22428 L .49169 .22794 L 1 .85 0 r
F
P
p
.46052 .22029 m .47643 .21655 L .49169 .22794 L .85 1 0 r
F
P
p
.41299 .21626 m .44476 .22399 L .42914 .22766 L .45 1 0 r
F
P
p
.39737 .22 m .41299 .21626 L .42914 .22766 L .4 1 0 r
F
P
p
.002 w
.56728 .51781 m .5511 .52016 L .53668 .5546 L p
.75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5204 .55682 m .53668 .5546 L .5511 .52016 L p
.65 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66271 .47199 m .67952 .4694 L .69226 .49087 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.34951 .21597 m .38189 .22371 L .36654 .22738 L .45 1 0 r
F
P
p
.33417 .21972 m .34951 .21597 L .36654 .22738 L .4 1 0 r
F
P
p
.002 w
.59995 .49924 m .61654 .49676 L .62973 .49068 L p
1 .7 0 r
F P
0 0 0 r
s
P
p
.28599 .21568 m .31897 .22343 L .3039 .2271 L .4 1 0 r
F
P
p
.27093 .21943 m .28599 .21568 L .3039 .2271 L .4 1 0 r
F
P
p
.22242 .21539 m .25601 .22314 L .24122 .22682 L .9 1 0 r
F
P
p
.20764 .21914 m .22242 .21539 L .24122 .22682 L .9 1 0 r
F
P
p
.15881 .2151 m .193 .22286 L .17849 .22654 L 1 1 0 r
F
P
p
.14431 .21886 m .15881 .2151 L .17849 .22654 L .6 1 0 r
F
P
p
.002 w
.40926 .59082 m .39377 .59285 L .37771 .55868 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36163 .58862 m .37771 .55868 L .39377 .59285 L p
.1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48827 .5612 m .47242 .56336 L .45686 .55665 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44101 .55885 m .45686 .55665 L .47242 .56336 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.81041 .21423 m .83852 .222 L .82109 .22569 L 1 0 0 r
F
P
p
.79294 .21799 m .81041 .21423 L .82109 .22569 L 1 0 0 r
F
P
p
.74692 .21394 m .77563 .22172 L .75848 .22541 L 1 0 0 r
F
P
p
.72973 .2177 m .74692 .21394 L .75848 .22541 L 1 0 0 r
F
P
p
.002 w
.86785 .44268 m .85027 .44537 L .84 .437 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82239 .43975 m .84 .437 L .85027 .44537 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.23152 .88419 m .24644 .88348 L .26494 .88566 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68338 .21365 m .7127 .22143 L .69582 .22513 L 1 .25 0 r
F
P
p
.66647 .21742 m .68338 .21365 L .69582 .22513 L 1 .4 0 r
F
P
p
.002 w
.80493 .44247 m .78763 .44517 L .77648 .43679 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75915 .43954 m .77648 .43679 L .78763 .44517 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61979 .21336 m .64972 .22115 L .63312 .22484 L 1 .3 0 r
F
P
p
.60317 .21713 m .61979 .21336 L .63312 .22484 L 1 .5 0 r
F
P
p
.002 w
.69648 .46679 m .71325 .45034 L .72495 .44496 L p
1 .15 0 r
F P
0 0 0 r
s
P
p
.002 w
.74197 .44226 m .72495 .44496 L .71325 .45034 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.55616 .21307 m .5867 .22086 L .57038 .22456 L 1 .65 0 r
F
P
p
.53982 .21684 m .55616 .21307 L .57038 .22456 L 1 .7 0 r
F
P
p
.49248 .21278 m .52363 .22057 L .50759 .22428 L 1 .75 0 r
F
P
p
.47643 .21655 m .49248 .21278 L .50759 .22428 L 1 .85 0 r
F
P
p
.42876 .21249 m .46052 .22029 L .44476 .22399 L .65 1 0 r
F
P
p
.41299 .21626 m .42876 .21249 L .44476 .22399 L .45 1 0 r
F
P
p
.002 w
.58361 .51544 m .56728 .51781 L .55308 .53833 L p
.8 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55308 .53833 m .56728 .51781 L p
.54184 .54839 L .75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55308 .53833 m .53831 .48881 L p
.56443 .52817 L .95 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55308 .53833 m .56963 .53601 L .58361 .51544 L p
.8 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56963 .53601 m .55308 .53833 L p
.56443 .52817 L .95 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53668 .5546 m .55308 .53833 L p
.54184 .54839 L .75 1 0 r
F P
0 0 0 r
s
P
p
.365 .2122 m .39737 .22 L .38189 .22371 L .55 1 0 r
F
P
p
.34951 .21597 m .365 .2122 L .38189 .22371 L .45 1 0 r
F
P
p
.30119 .2119 m .33417 .21972 L .31897 .22343 L .45 1 0 r
F
P
p
.28599 .21568 m .30119 .2119 L .31897 .22343 L .4 1 0 r
F
P
p
.23733 .21161 m .27093 .21943 L .25601 .22314 L .9 1 0 r
F
P
p
.22242 .21539 m .23733 .21161 L .25601 .22314 L .9 1 0 r
F
P
p
.17343 .21132 m .20764 .21914 L .193 .22286 L 1 .7 0 r
F
P
p
.15881 .2151 m .17343 .21132 L .193 .22286 L 1 1 0 r
F
P
p
.002 w
.42488 .58878 m .40926 .59082 L .39328 .55648 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37771 .55868 m .39328 .55648 L .40926 .59082 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50426 .55902 m .48827 .5612 L .47286 .55443 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45686 .55665 m .47286 .55443 L .48827 .5612 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.81041 .21423 m .82804 .21044 L .83852 .222 L 1 0 0 r
F
P
p
.76426 .21015 m .79294 .21799 L .77563 .22172 L 1 0 0 r
F
P
p
.74692 .21394 m .76426 .21015 L .77563 .22172 L 1 0 0 r
F
P
p
.002 w
.84 .437 m .85778 .43423 L .86785 .44268 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70043 .20985 m .72973 .2177 L .7127 .22143 L 1 .1 0 r
F
P
p
.68338 .21365 m .70043 .20985 L .7127 .22143 L 1 .25 0 r
F
P
p
.002 w
.63329 .49427 m .64996 .47782 L .66271 .47199 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.67952 .4694 m .66271 .47199 L .64996 .47782 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.82239 .43975 m .80493 .44247 L .79397 .43401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77648 .43679 m .79397 .43401 L .80493 .44247 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.63656 .20956 m .66647 .21742 L .64972 .22115 L 1 .2 0 r
F
P
p
.61979 .21336 m .63656 .20956 L .64972 .22115 L 1 .3 0 r
F
P
p
.002 w
.23152 .88419 m .21674 .8849 L .19746 .8827 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75915 .43954 m .74197 .44226 L .73012 .4338 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71325 .45034 m .73012 .4338 L .74197 .44226 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.57265 .20927 m .60317 .21713 L .5867 .22086 L 1 .55 0 r
F
P
p
.55616 .21307 m .57265 .20927 L .5867 .22086 L 1 .65 0 r
F
P
p
.50868 .20897 m .53982 .21684 L .52363 .22057 L 1 .65 0 r
F
P
p
.49248 .21278 m .50868 .20897 L .52363 .22057 L 1 .75 0 r
F
P
p
.44467 .20868 m .47643 .21655 L .46052 .22029 L .95 1 0 r
F
P
p
.42876 .21249 m .44467 .20868 L .46052 .22029 L .65 1 0 r
F
P
p
.38062 .20838 m .41299 .21626 L .39737 .22 L .6 1 0 r
F
P
p
.365 .2122 m .38062 .20838 L .39737 .22 L .55 1 0 r
F
P
p
.31652 .20809 m .34951 .21597 L .33417 .21972 L .55 1 0 r
F
P
p
.30119 .2119 m .31652 .20809 L .33417 .21972 L .45 1 0 r
F
P
p
.002 w
.29708 .72208 m .27668 .88202 L .26426 .70478 L p
.2 0 1 r
F P
0 0 0 r
s
P
p
.25238 .20779 m .28599 .21568 L .27093 .21943 L .9 1 0 r
F
P
p
.23733 .21161 m .25238 .20779 L .27093 .21943 L .9 1 0 r
F
P
p
.18819 .2075 m .22242 .21539 L .20764 .21914 L 1 .6 0 r
F
P
p
.17343 .21132 m .18819 .2075 L .20764 .21914 L 1 .7 0 r
F
P
p
.002 w
.44101 .55885 m .42488 .58878 L .40899 .55426 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39328 .55648 m .40899 .55426 L .42488 .58878 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37771 .55868 m .36163 .58862 L .34508 .55409 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36163 .58862 m .34376 .68908 L .32965 .55631 L p
0 1 .15 r
F P
0 0 0 r
s
P
p
.002 w
.32965 .55631 m .34508 .55409 L .36163 .58862 L p
0 1 .15 r
F P
0 0 0 r
s
P
p
.002 w
.5204 .55682 m .50426 .55902 L .489 .55219 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47286 .55443 m .489 .55219 L .50426 .55902 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45686 .55665 m .44101 .55885 L .42485 .55202 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.40899 .55426 m .42485 .55202 L .44101 .55885 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39328 .55648 m .37771 .55868 L .36065 .55184 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34508 .55409 m .36065 .55184 L .37771 .55868 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.78177 .20632 m .81041 .21423 L .79294 .21799 L 1 0 0 r
F
P
p
.76426 .21015 m .78177 .20632 L .79294 .21799 L 1 0 0 r
F
P
p
.002 w
.61654 .49676 m .59995 .49924 L .58634 .53367 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56963 .53601 m .58634 .53367 L .59995 .49924 L p
.85 1 0 r
F P
0 0 0 r
s
P
p
.71765 .20602 m .74692 .21394 L .72973 .2177 L 1 0 0 r
F
P
p
.70043 .20985 m .71765 .20602 L .72973 .2177 L 1 .1 0 r
F
P
p
.002 w
.69648 .46679 m .67952 .4694 L .66698 .47522 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.64996 .47782 m .66698 .47522 L .67952 .4694 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.84 .437 m .82239 .43975 L .81162 .43121 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79397 .43401 m .81162 .43121 L .82239 .43975 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.32836 .69068 m .31268 .70643 L .29606 .65881 L p
0 1 1 r
F P
0 0 0 r
s
P
p
.65349 .20572 m .68338 .21365 L .66647 .21742 L 1 .1 0 r
F
P
p
.63656 .20956 m .65349 .20572 L .66647 .21742 L 1 .2 0 r
F
P
p
.002 w
.24644 .88348 m .23152 .88419 L .21237 .88197 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.19746 .8827 m .21237 .88197 L .23152 .88419 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77648 .43679 m .75915 .43954 L .74748 .43099 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73012 .4338 m .74748 .43099 L .75915 .43954 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.58928 .20543 m .61979 .21336 L .60317 .21713 L 1 .4 0 r
F
P
p
.57265 .20927 m .58928 .20543 L .60317 .21713 L 1 .55 0 r
F
P
p
.52503 .20513 m .55616 .21307 L .53982 .21684 L 1 .6 0 r
F
P
p
.50868 .20897 m .52503 .20513 L .53982 .21684 L 1 .65 0 r
F
P
p
.46073 .20483 m .49248 .21278 L .47643 .21655 L 1 .9 0 r
F
P
p
.44467 .20868 m .46073 .20483 L .47643 .21655 L .95 1 0 r
F
P
p
.39639 .20454 m .42876 .21249 L .41299 .21626 L .65 1 0 r
F
P
p
.38062 .20838 m .39639 .20454 L .41299 .21626 L .6 1 0 r
F
P
p
.332 .20424 m .365 .2122 L .34951 .21597 L .65 1 0 r
F
P
p
.31652 .20809 m .332 .20424 L .34951 .21597 L .55 1 0 r
F
P
p
.26757 .20394 m .30119 .2119 L .28599 .21568 L .95 1 0 r
F
P
p
.25238 .20779 m .26757 .20394 L .28599 .21568 L .9 1 0 r
F
P
p
.20309 .20364 m .23733 .21161 L .22242 .21539 L 1 .6 0 r
F
P
p
.18819 .2075 m .20309 .20364 L .22242 .21539 L 1 .6 0 r
F
P
p
.002 w
.29606 .65881 m .31353 .5864 L .32836 .69068 L p
0 1 1 r
F P
0 0 0 r
s
P
p
.002 w
.53668 .5546 m .5204 .55682 L .50535 .53583 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.489 .55219 m .50535 .53583 L .5204 .55682 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31353 .5864 m .32965 .55631 L .34376 .68908 L p
0 1 .6 r
F P
0 0 0 r
s
P
p
.002 w
.32965 .55631 m .31353 .5864 L .2964 .55167 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31353 .5864 m .29606 .65881 L .28014 .58205 L p
0 1 .15 r
F P
0 0 0 r
s
P
p
.002 w
.28014 .58205 m .2964 .55167 L .31353 .5864 L p
0 1 .15 r
F P
0 0 0 r
s
P
p
.002 w
.47286 .55443 m .45686 .55665 L .44085 .54975 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42485 .55202 m .44085 .54975 L .45686 .55665 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.40899 .55426 m .39328 .55648 L .37636 .54958 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36065 .55184 m .37636 .54958 L .39328 .55648 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.79943 .20245 m .82804 .21044 L .81041 .21423 L 1 0 0 r
F
P
p
.78177 .20632 m .79943 .20245 L .81041 .21423 L 1 0 0 r
F
P
p
.002 w
.34508 .55409 m .32965 .55631 L .31182 .5494 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.2964 .55167 m .31182 .5494 L .32965 .55631 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58634 .53367 m .60293 .50305 L .61654 .49676 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63329 .49427 m .61654 .49676 L .60293 .50305 L p
1 .85 0 r
F P
0 0 0 r
s
P
p
.73503 .20215 m .76426 .21015 L .74692 .21394 L 1 0 0 r
F
P
p
.71765 .20602 m .73503 .20215 L .74692 .21394 L 1 0 0 r
F
P
p
.002 w
.66698 .47522 m .68416 .47259 L .69648 .46679 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.71325 .45034 m .69648 .46679 L .68416 .47259 L p
1 .45 0 r
F P
0 0 0 r
s
P
p
.002 w
.85778 .43423 m .84 .437 L .82944 .42838 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81162 .43121 m .82944 .42838 L .84 .437 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67058 .20185 m .70043 .20985 L .68338 .21365 L 1 0 0 r
F
P
p
.65349 .20572 m .67058 .20185 L .68338 .21365 L 1 .1 0 r
F
P
p
.002 w
.26149 .88275 m .24644 .88348 L .22741 .88123 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.21237 .88197 m .22741 .88123 L .24644 .88348 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79397 .43401 m .77648 .43679 L .76501 .42817 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74748 .43099 m .76501 .42817 L .77648 .43679 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.24315 .86566 m .26426 .70478 L .27668 .88202 L p
1 0 .65 r
F P
0 0 0 r
s
P
p
.002 w
.27989 .68895 m .26426 .70478 L .2488 .61435 L p
0 1 .85 r
F P
0 0 0 r
s
P
p
.002 w
.26426 .70478 m .24315 .86566 L .22375 .86312 L p
.4 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.22375 .86312 m .2488 .61435 L .26426 .70478 L p
.4 0 1 r
F P
0 0 0 r
s
P
p
.60608 .20155 m .63656 .20956 L .61979 .21336 L 1 .25 0 r
F
P
p
.58928 .20543 m .60608 .20155 L .61979 .21336 L 1 .4 0 r
F
P
p
.54153 .20125 m .57265 .20927 L .55616 .21307 L 1 .55 0 r
F
P
p
.52503 .20513 m .54153 .20125 L .55616 .21307 L 1 .6 0 r
F
P
p
.47694 .20095 m .50868 .20897 L .49248 .21278 L 1 .85 0 r
F
P
p
.46073 .20483 m .47694 .20095 L .49248 .21278 L 1 .9 0 r
F
P
p
.41231 .20065 m .44467 .20868 L .42876 .21249 L .75 1 0 r
F
P
p
.39639 .20454 m .41231 .20065 L .42876 .21249 L .65 1 0 r
F
P
p
.34762 .20035 m .38062 .20838 L .365 .2122 L .75 1 0 r
F
P
p
.332 .20424 m .34762 .20035 L .365 .2122 L .65 1 0 r
F
P
p
.002 w
.22375 .86312 m .20782 .87892 L .20163 .56995 L p
0 .2 1 r
F P
0 0 0 r
s
P
p
.002 w
.20163 .56995 m .21712 .55374 L .22375 .86312 L p
0 .2 1 r
F P
0 0 0 r
s
P
p
.002 w
.18489 .6142 m .20163 .56995 L .20782 .87892 L p
.05 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.21712 .55374 m .20163 .56995 L .1826 .54905 L p
.35 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20163 .56995 m .18489 .6142 L .16706 .56543 L p
.1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.16706 .56543 m .1826 .54905 L .20163 .56995 L p
.1 1 0 r
F P
0 0 0 r
s
P
p
.2829 .20005 m .31652 .20809 L .30119 .2119 L 1 .9 0 r
F
P
p
.26757 .20394 m .2829 .20005 L .30119 .2119 L .95 1 0 r
F
P
p
.21812 .19975 m .25238 .20779 L .23733 .21161 L 1 .6 0 r
F
P
p
.20309 .20364 m .21812 .19975 L .23733 .21161 L 1 .6 0 r
F
P
p
.002 w
.73012 .4338 m .71325 .45034 L .7015 .46994 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.68416 .47259 m .7015 .46994 L .71325 .45034 L p
1 .45 0 r
F P
0 0 0 r
s
P
p
.002 w
.2488 .61435 m .26495 .58415 L .27989 .68895 L p
0 1 .85 r
F P
0 0 0 r
s
P
p
.002 w
.26495 .58415 m .2488 .61435 L .23211 .55149 L p
.1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.2488 .61435 m .22375 .86312 L .21712 .55374 L p
0 1 .85 r
F P
0 0 0 r
s
P
p
.002 w
.21712 .55374 m .23211 .55149 L .2488 .61435 L p
0 1 .85 r
F P
0 0 0 r
s
P
p
.002 w
.55308 .53833 m .53668 .5546 L .52182 .50535 L p
.8 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50535 .53583 m .52182 .50535 L .53668 .5546 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29606 .65881 m .27989 .68895 L .26495 .58415 L p
0 1 .6 r
F P
0 0 0 r
s
P
p
.002 w
.20782 .87892 m .19266 .87968 L .18489 .6142 L p
.05 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.15723 .8781 m .18489 .6142 L .19266 .87968 L p
1 0 .9 r
F P
0 0 0 r
s
P
p
.002 w
.18489 .6142 m .15723 .8781 L .15011 .61009 L p
0 .85 1 r
F P
0 0 0 r
s
P
p
.002 w
.15011 .61009 m .16706 .56543 L .18489 .6142 L p
0 .85 1 r
F P
0 0 0 r
s
P
p
.002 w
.489 .55219 m .47286 .55443 L .457 .54747 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44085 .54975 m .457 .54747 L .47286 .55443 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26495 .58415 m .28014 .58205 L .29606 .65881 L p
0 1 .6 r
F P
0 0 0 r
s
P
p
.002 w
.28014 .58205 m .26495 .58415 L .24723 .54923 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.23211 .55149 m .24723 .54923 L .26495 .58415 L p
.1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42485 .55202 m .40899 .55426 L .39222 .54729 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37636 .54958 m .39222 .54729 L .40899 .55426 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.79943 .20245 m .81727 .19855 L .82804 .21044 L 1 0 0 r
F
P
p
.002 w
.36065 .55184 m .34508 .55409 L .32738 .54711 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31182 .5494 m .32738 .54711 L .34508 .55409 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64996 .47782 m .63329 .49427 L .61972 .48644 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.60293 .50305 m .61972 .48644 L .63329 .49427 L p
1 .85 0 r
F P
0 0 0 r
s
P
p
.75257 .19825 m .78177 .20632 L .76426 .21015 L 1 0 0 r
F
P
p
.73503 .20215 m .75257 .19825 L .76426 .21015 L 1 0 0 r
F
P
p
.002 w
.82944 .42838 m .84742 .42553 L .85778 .43423 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68782 .19794 m .71765 .20602 L .70043 .20985 L 1 0 0 r
F
P
p
.67058 .20185 m .68782 .19794 L .70043 .20985 L 1 0 0 r
F
P
p
.002 w
.27668 .88202 m .26149 .88275 L .24315 .86566 L p
1 0 .65 r
F P
0 0 0 r
s
P
p
.002 w
.22741 .88123 m .24315 .86566 L .26149 .88275 L p
1 0 .05 r
F P
0 0 0 r
s
P
p
.002 w
.23211 .55149 m .21712 .55374 L .19757 .54676 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.1826 .54905 m .19757 .54676 L .21712 .55374 L p
.35 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.81162 .43121 m .79397 .43401 L .78269 .42531 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76501 .42817 m .78269 .42531 L .79397 .43401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.62303 .19764 m .65349 .20572 L .63656 .20956 L 1 .2 0 r
F
P
p
.60608 .20155 m .62303 .19764 L .63656 .20956 L 1 .25 0 r
F
P
p
.002 w
.21237 .88197 m .19746 .8827 L .17763 .88043 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74748 .43099 m .73012 .4338 L .71864 .45315 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7015 .46994 m .71864 .45315 L .73012 .4338 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.55819 .19734 m .58928 .20543 L .57265 .20927 L 1 .45 0 r
F
P
p
.54153 .20125 m .55819 .19734 L .57265 .20927 L 1 .55 0 r
F
P
p
.002 w
.52182 .50535 m .53831 .48881 L .55308 .53833 L p
.8 1 0 r
F P
0 0 0 r
s
P
p
.4933 .19704 m .52503 .20513 L .50868 .20897 L 1 .7 0 r
F
P
p
.47694 .20095 m .4933 .19704 L .50868 .20897 L 1 .85 0 r
F
P
p
.42837 .19673 m .46073 .20483 L .44467 .20868 L .8 1 0 r
F
P
p
.41231 .20065 m .42837 .19673 L .44467 .20868 L .75 1 0 r
F
P
p
.36339 .19643 m .39639 .20454 L .38062 .20838 L .9 1 0 r
F
P
p
.34762 .20035 m .36339 .19643 L .38062 .20838 L .75 1 0 r
F
P
p
.002 w
.66698 .47522 m .64996 .47782 L .6368 .48384 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.61972 .48644 m .6368 .48384 L .64996 .47782 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.29837 .19613 m .332 .20424 L .31652 .20809 L 1 .75 0 r
F
P
p
.2829 .20005 m .29837 .19613 L .31652 .20809 L 1 .9 0 r
F
P
p
.2333 .19582 m .26757 .20394 L .25238 .20779 L 1 .6 0 r
F
P
p
.21812 .19975 m .2333 .19582 L .25238 .20779 L 1 .6 0 r
F
P
p
.002 w
.50535 .53583 m .489 .55219 L .47331 .54516 L p
.55 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.457 .54747 m .47331 .54516 L .489 .55219 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.2964 .55167 m .28014 .58205 L .2625 .54694 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24723 .54923 m .2625 .54694 L .28014 .58205 L p
.2 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44085 .54975 m .42485 .55202 L .40822 .54498 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39222 .54729 m .40822 .54498 L .42485 .55202 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37636 .54958 m .36065 .55184 L .34309 .5448 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32738 .54711 m .34309 .5448 L .36065 .55184 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.77027 .1943 m .79943 .20245 L .78177 .20632 L 1 0 0 r
F
P
p
.75257 .19825 m .77027 .1943 L .78177 .20632 L 1 0 0 r
F
P
p
.002 w
.31182 .5494 m .2964 .55167 L .27791 .54463 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.2625 .54694 m .27791 .54463 L .2964 .55167 L p
.3 1 0 r
F P
0 0 0 r
s
P
p
.70523 .194 m .73503 .20215 L .71765 .20602 L 1 0 0 r
F
P
p
.68782 .19794 m .70523 .194 L .71765 .20602 L 1 0 0 r
F
P
p
.002 w
.24723 .54923 m .23211 .55149 L .21269 .54445 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.19757 .54676 m .21269 .54445 L .23211 .55149 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.82944 .42838 m .81162 .43121 L .80055 .42243 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78269 .42531 m .80055 .42243 L .81162 .43121 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64014 .19369 m .67058 .20185 L .65349 .20572 L 1 .1 0 r
F
P
p
.62303 .19764 m .64014 .19369 L .65349 .20572 L 1 .2 0 r
F
P
p
.002 w
.22741 .88123 m .21237 .88197 L .19266 .87968 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.17763 .88043 m .19266 .87968 L .21237 .88197 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76501 .42817 m .74748 .43099 L .73548 .42221 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71864 .45315 m .73548 .42221 L .74748 .43099 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.575 .19339 m .60608 .20155 L .58928 .20543 L 1 .4 0 r
F
P
p
.55819 .19734 m .575 .19339 L .58928 .20543 L 1 .45 0 r
F
P
p
.002 w
.58634 .53367 m .56963 .53601 L .5549 .47218 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53831 .48881 m .5549 .47218 L .56963 .53601 L p
.95 1 0 r
F P
0 0 0 r
s
P
p
.50982 .19308 m .54153 .20125 L .52503 .20513 L 1 .6 0 r
F
P
p
.4933 .19704 m .50982 .19308 L .52503 .20513 L 1 .7 0 r
F
P
p
.002 w
.52182 .50535 m .50535 .53583 L .48994 .51433 L p
.85 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47331 .54516 m .48994 .51433 L .50535 .53583 L p
.55 1 0 r
F P
0 0 0 r
s
P
p
.44459 .19278 m .47694 .20095 L .46073 .20483 L .95 1 0 r
F
P
p
.42837 .19673 m .44459 .19278 L .46073 .20483 L .8 1 0 r
F
P
p
.37931 .19247 m .41231 .20065 L .39639 .20454 L 1 .95 0 r
F
P
p
.36339 .19643 m .37931 .19247 L .39639 .20454 L .9 1 0 r
F
P
p
.002 w
.53831 .48881 m .52182 .50535 L .50654 .49762 L p
1 .95 0 r
F P
0 0 0 r
s
P
p
.002 w
.48994 .51433 m .50654 .49762 L .52182 .50535 L p
.85 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68416 .47259 m .66698 .47522 L .65357 .45294 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.6368 .48384 m .65357 .45294 L .66698 .47522 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.31399 .19217 m .34762 .20035 L .332 .20424 L 1 .7 0 r
F
P
p
.29837 .19613 m .31399 .19217 L .332 .20424 L 1 .75 0 r
F
P
p
.002 w
.1826 .54905 m .16706 .56543 L .14742 .54427 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.16706 .56543 m .15011 .61009 L .1326 .54658 L p
.15 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.1326 .54658 m .14742 .54427 L .16706 .56543 L p
.15 1 0 r
F P
0 0 0 r
s
P
p
.24861 .19186 m .2829 .20005 L .26757 .20394 L 1 .5 0 r
F
P
p
.2333 .19582 m .24861 .19186 L .26757 .20394 L 1 .6 0 r
F
P
p
.002 w
.457 .54747 m .44085 .54975 L .42438 .54265 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.40822 .54498 m .42438 .54265 L .44085 .54975 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39222 .54729 m .37636 .54958 L .35895 .54247 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34309 .5448 m .35895 .54247 L .37636 .54958 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.78814 .19032 m .81727 .19855 L .79943 .20245 L 1 0 0 r
F
P
p
.77027 .1943 m .78814 .19032 L .79943 .20245 L 1 0 0 r
F
P
p
.002 w
.32738 .54711 m .31182 .5494 L .29347 .54229 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27791 .54463 m .29347 .54229 L .31182 .5494 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.7228 .19002 m .75257 .19825 L .73503 .20215 L 1 0 0 r
F
P
p
.70523 .194 m .7228 .19002 L .73503 .20215 L 1 0 0 r
F
P
p
.002 w
.2625 .54694 m .24723 .54923 L .22794 .54211 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.21269 .54445 m .22794 .54211 L .24723 .54923 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50654 .49762 m .52321 .49506 L .53831 .48881 L p
1 .95 0 r
F P
0 0 0 r
s
P
p
.002 w
.5549 .47218 m .53831 .48881 L .52321 .49506 L p
1 .8 0 r
F P
0 0 0 r
s
P
p
.002 w
.84742 .42553 m .82944 .42838 L .81857 .41952 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80055 .42243 m .81857 .41952 L .82944 .42838 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.65741 .18971 m .68782 .19794 L .67058 .20185 L 1 0 0 r
F
P
p
.64014 .19369 m .65741 .18971 L .67058 .20185 L 1 .1 0 r
F
P
p
.002 w
.24315 .86566 m .22741 .88123 L .20782 .87892 L p
1 0 .1 r
F P
0 0 0 r
s
P
p
.002 w
.19266 .87968 m .20782 .87892 L .22741 .88123 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.19757 .54676 m .1826 .54905 L .16383 .51338 L p
.7 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.14742 .54427 m .16383 .51338 L .1826 .54905 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.78269 .42531 m .76501 .42817 L .7532 .4193 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73548 .42221 m .7532 .4193 L .76501 .42817 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.59197 .1894 m .62303 .19764 L .60608 .20155 L 1 .3 0 r
F
P
p
.575 .19339 m .59197 .1894 L .60608 .20155 L 1 .4 0 r
F
P
p
.002 w
.60293 .50305 m .58634 .53367 L .57165 .46953 L p
1 .85 0 r
F P
0 0 0 r
s
P
p
.002 w
.5549 .47218 m .57165 .46953 L p
.56015 .48245 L 1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54003 .47818 m .5549 .47218 L p
.53121 .48928 L 1 .8 0 r
F P
0 0 0 r
s
P
p
.002 w
.52321 .49506 m .54003 .47818 L p
.53121 .48928 L 1 .8 0 r
F P
0 0 0 r
s
P
p
.002 w
.54003 .47818 m .52472 .44106 L p
.54895 .46693 L 1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.57165 .46953 m .5549 .47218 L .54003 .47818 L p
1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.54003 .47818 m .55698 .4755 L .57165 .46953 L p
1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.55698 .4755 m .54003 .47818 L p
.54895 .46693 L 1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.57165 .46953 m .55698 .4755 L p
.58326 .45648 L 1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.58844 .45273 m .57165 .46953 L p
.58326 .45648 L 1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.57165 .46953 m .58634 .53367 L p
.56015 .48245 L 1 1 0 r
F P
0 0 0 r
s
P
p
.52649 .18909 m .55819 .19734 L .54153 .20125 L 1 .5 0 r
F
P
p
.50982 .19308 m .52649 .18909 L .54153 .20125 L 1 .6 0 r
F
P
p
.46096 .18878 m .4933 .19704 L .47694 .20095 L 1 .9 0 r
F
P
p
.44459 .19278 m .46096 .18878 L .47694 .20095 L .95 1 0 r
F
P
p
.002 w
.61972 .48644 m .60293 .50305 L .58844 .45273 L p
1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.57165 .46953 m .58844 .45273 L .60293 .50305 L p
1 .85 0 r
F P
0 0 0 r
s
P
p
.39538 .18848 m .42837 .19673 L .41231 .20065 L 1 .9 0 r
F
P
p
.37931 .19247 m .39538 .18848 L .41231 .20065 L 1 .95 0 r
F
P
p
.002 w
.7015 .46994 m .68416 .47259 L .6709 .45017 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.65357 .45294 m .6709 .45017 L .68416 .47259 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.32975 .18817 m .36339 .19643 L .34762 .20035 L 1 .7 0 r
F
P
p
.31399 .19217 m .32975 .18817 L .34762 .20035 L 1 .7 0 r
F
P
p
.26408 .18786 m .29837 .19613 L .2829 .20005 L 1 .3 0 r
F
P
p
.24861 .19186 m .26408 .18786 L .2829 .20005 L 1 .5 0 r
F
P
p
.002 w
.20782 .87892 m .22375 .86312 L .24315 .86566 L p
1 0 .1 r
F P
0 0 0 r
s
P
p
.002 w
.47331 .54516 m .457 .54747 L .44069 .5403 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42438 .54265 m .44069 .5403 L .457 .54747 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.40822 .54498 m .39222 .54729 L .37495 .54012 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35895 .54247 m .37495 .54012 L .39222 .54729 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.78814 .19032 m .80618 .18631 L .81727 .19855 L 1 0 0 r
F
P
p
.002 w
.34309 .5448 m .32738 .54711 L .30917 .53994 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29347 .54229 m .30917 .53994 L .32738 .54711 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6368 .48384 m .61972 .48644 L .60547 .44996 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.58844 .45273 m .60547 .44996 L p
.601 .46626 L 1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.60547 .44996 m .58844 .45273 L .5741 .47281 L p
1 .55 0 r
F P
0 0 0 r
s
P
p
.002 w
.60547 .44996 m .59127 .45565 L p
.61002 .43343 L 1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.62232 .41885 m .60547 .44996 L p
.61002 .43343 L 1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.60547 .44996 m .61972 .48644 L p
.601 .46626 L 1 .65 0 r
F P
0 0 0 r
s
P
p
.74053 .186 m .77027 .1943 L .75257 .19825 L 1 0 0 r
F
P
p
.7228 .19002 m .74053 .186 L .75257 .19825 L 1 0 0 r
F
P
p
.002 w
.27791 .54463 m .2625 .54694 L .24334 .53976 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.22794 .54211 m .24334 .53976 L .2625 .54694 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.81857 .41952 m .83676 .41659 L .84742 .42553 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67484 .18569 m .70523 .194 L .68782 .19794 L 1 0 0 r
F
P
p
.65741 .18971 m .67484 .18569 L .68782 .19794 L 1 0 0 r
F
P
p
.002 w
.21269 .54445 m .19757 .54676 L .18027 .48244 L p
.85 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.16383 .51338 m .18027 .48244 L .19757 .54676 L p
.7 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.80055 .42243 m .78269 .42531 L .77109 .41636 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7532 .4193 m .77109 .41636 L .78269 .42531 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.19266 .87968 m .17763 .88043 L .15723 .8781 L p
1 0 .9 r
F P
0 0 0 r
s
P
p
.6091 .18538 m .64014 .19369 L .62303 .19764 L 1 .2 0 r
F
P
p
.59197 .1894 m .6091 .18538 L .62303 .19764 L 1 .3 0 r
F
P
p
.002 w
.14742 .54427 m .1326 .54658 L .11154 .53939 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.54331 .18506 m .575 .19339 L .55819 .19734 L 1 .4 0 r
F
P
p
.52649 .18909 m .54331 .18506 L .55819 .19734 L 1 .5 0 r
F
P
p
.47748 .18475 m .50982 .19308 L .4933 .19704 L 1 .8 0 r
F
P
p
.46096 .18878 m .47748 .18475 L .4933 .19704 L 1 .9 0 r
F
P
p
.41159 .18444 m .44459 .19278 L .42837 .19673 L 1 .9 0 r
F
P
p
.39538 .18848 m .41159 .18444 L .42837 .19673 L 1 .9 0 r
F
P
p
.002 w
.71864 .45315 m .7015 .46994 L .68778 .41907 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.6709 .45017 m .68778 .41907 L .7015 .46994 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.34566 .18413 m .37931 .19247 L .36339 .19643 L 1 .55 0 r
F
P
p
.32975 .18817 m .34566 .18413 L .36339 .19643 L 1 .7 0 r
F
P
p
.27968 .18382 m .31399 .19217 L .29837 .19613 L 1 .2 0 r
F
P
p
.26408 .18786 m .27968 .18382 L .29837 .19613 L 1 .3 0 r
F
P
p
.002 w
.48994 .51433 m .47331 .54516 L .45746 .50916 L p
.85 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44069 .5403 m .45746 .50916 L .47331 .54516 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42438 .54265 m .40822 .54498 L .39111 .53775 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37495 .54012 m .39111 .53775 L .40822 .54498 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35895 .54247 m .34309 .5448 L .32502 .53756 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30917 .53994 m .32502 .53756 L .34309 .5448 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50654 .49762 m .48994 .51433 L .47437 .46372 L p
1 .85 0 r
F P
0 0 0 r
s
P
p
.002 w
.45746 .50916 m .47437 .46372 L .48994 .51433 L p
.85 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65357 .45294 m .6368 .48384 L .62232 .41885 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.60547 .44996 m .62232 .41885 L .6368 .48384 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.75844 .18194 m .78814 .19032 L .77027 .1943 L 1 0 0 r
F
P
p
.74053 .186 m .75844 .18194 L .77027 .1943 L 1 0 0 r
F
P
p
.002 w
.29347 .54229 m .27791 .54463 L .25889 .53738 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24334 .53976 m .25889 .53738 L .27791 .54463 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73548 .42221 m .71864 .45315 L .70537 .41613 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68778 .41907 m .70537 .41613 L .71864 .45315 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.69244 .18163 m .7228 .19002 L .70523 .194 L 1 0 0 r
F
P
p
.67484 .18569 m .69244 .18163 L .70523 .194 L 1 0 0 r
F
P
p
.002 w
.22794 .54211 m .21269 .54445 L .19607 .4656 L p
.9 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.18027 .48244 m .19607 .4656 L .21269 .54445 L p
.85 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6709 .45017 m .65357 .45294 L .6396 .4159 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.62232 .41885 m .6396 .4159 L .65357 .45294 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.81857 .41952 m .80055 .42243 L .78915 .41339 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77109 .41636 m .78915 .41339 L .80055 .42243 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.62639 .18131 m .65741 .18971 L .64014 .19369 L 1 .1 0 r
F
P
p
.6091 .18538 m .62639 .18131 L .64014 .19369 L 1 .2 0 r
F
P
p
.002 w
.16383 .51338 m .14742 .54427 L .12647 .53701 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.11154 .53939 m .12647 .53701 L .14742 .54427 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55698 .4755 m .5741 .47281 L .58844 .45273 L p
1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.7532 .4193 m .73548 .42221 L .72312 .41316 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70537 .41613 m .72312 .41316 L .73548 .42221 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.5603 .181 m .59197 .1894 L .575 .19339 L 1 .4 0 r
F
P
p
.54331 .18506 m .5603 .181 L .575 .19339 L 1 .4 0 r
F
P
p
.49416 .18068 m .52649 .18909 L .50982 .19308 L 1 .7 0 r
F
P
p
.47748 .18475 m .49416 .18068 L .50982 .19308 L 1 .8 0 r
F
P
p
.002 w
.18027 .48244 m .16383 .51338 L .14311 .50566 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.12647 .53701 m .14311 .50566 L .16383 .51338 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.42797 .18037 m .46096 .18878 L .44459 .19278 L 1 .75 0 r
F
P
p
.41159 .18444 m .42797 .18037 L .44459 .19278 L 1 .9 0 r
F
P
p
.36173 .18005 m .39538 .18848 L .37931 .19247 L 1 .35 0 r
F
P
p
.34566 .18413 m .36173 .18005 L .37931 .19247 L 1 .55 0 r
F
P
p
.002 w
.19607 .4656 m .18027 .48244 L .15977 .47426 L p
1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.14311 .50566 m .15977 .47426 L .18027 .48244 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52321 .49506 m .50654 .49762 L .49099 .46099 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.49099 .46099 m .50654 .49762 L p
.47976 .4694 L 1 .85 0 r
F P
0 0 0 r
s
P
p
.002 w
.49099 .46099 m .50782 .44391 L .52321 .49506 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.49099 .46099 m .4745 .4961 L p
.50235 .45248 L 1 .85 0 r
F P
0 0 0 r
s
P
p
.002 w
.50782 .44391 m .49099 .46099 L p
.50235 .45248 L 1 .85 0 r
F P
0 0 0 r
s
P
p
.002 w
.47437 .46372 m .49099 .46099 L p
.47976 .4694 L 1 .85 0 r
F P
0 0 0 r
s
P
p
.29544 .17974 m .32975 .18817 L .31399 .19217 L 1 .2 0 r
F
P
p
.27968 .18382 m .29544 .17974 L .31399 .19217 L 1 .2 0 r
F
P
p
.002 w
.44069 .5403 m .42438 .54265 L .40743 .53535 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39111 .53775 m .40743 .53535 L .42438 .54265 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37495 .54012 m .35895 .54247 L .34103 .53516 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32502 .53756 m .34103 .53516 L .35895 .54247 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.77651 .17784 m .80618 .18631 L .78814 .19032 L 1 0 0 r
F
P
p
.75844 .18194 m .77651 .17784 L .78814 .19032 L 1 0 0 r
F
P
p
.002 w
.30917 .53994 m .29347 .54229 L .27458 .53498 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25889 .53738 m .27458 .53498 L .29347 .54229 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.71021 .17753 m .74053 .186 L .7228 .19002 L 1 0 0 r
F
P
p
.69244 .18163 m .71021 .17753 L .7228 .19002 L 1 0 0 r
F
P
p
.002 w
.19607 .4656 m .21131 .46288 L .22794 .54211 L p
.9 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.21131 .46288 m .19607 .4656 L .17574 .45716 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.15977 .47426 m .17574 .45716 L .19607 .4656 L p
1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.24334 .53976 m .22794 .54211 L .21131 .46288 L p
.9 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68778 .41907 m .6709 .45017 L .65705 .41293 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6396 .4159 m .65705 .41293 L .6709 .45017 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.83676 .41659 m .81857 .41952 L .80738 .4104 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78915 .41339 m .80738 .4104 L .81857 .41952 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64385 .17721 m .67484 .18569 L .65741 .18971 L 1 0 0 r
F
P
p
.62639 .18131 m .64385 .17721 L .65741 .18971 L 1 .1 0 r
F
P
p
.002 w
.59127 .45565 m .57632 .41783 L p
.60063 .44413 L 1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.59127 .45565 m .60547 .44996 L p
.58203 .46704 L 1 .55 0 r
F P
0 0 0 r
s
P
p
.002 w
.59127 .45565 m .60868 .45284 L .62232 .41885 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.60868 .45284 m .59127 .45565 L p
.60063 .44413 L 1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.5741 .47281 m .59127 .45565 L p
.58203 .46704 L 1 .55 0 r
F P
0 0 0 r
s
P
p
.002 w
.77109 .41636 m .7532 .4193 L .74105 .41017 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72312 .41316 m .74105 .41017 L .7532 .4193 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.57745 .17689 m .6091 .18538 L .59197 .1894 L 1 .25 0 r
F
P
p
.5603 .181 m .57745 .17689 L .59197 .1894 L 1 .4 0 r
F
P
p
.002 w
.70537 .41613 m .68778 .41907 L .67466 .40993 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65705 .41293 m .67466 .40993 L .68778 .41907 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.511 .17658 m .54331 .18506 L .52649 .18909 L 1 .65 0 r
F
P
p
.49416 .18068 m .511 .17658 L .52649 .18909 L 1 .7 0 r
F
P
p
.002 w
.6396 .4159 m .62232 .41885 L .60868 .45284 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.4445 .17626 m .47748 .18475 L .46096 .18878 L 1 .6 0 r
F
P
p
.42797 .18037 m .4445 .17626 L .46096 .18878 L 1 .75 0 r
F
P
p
.37795 .17594 m .41159 .18444 L .39538 .18848 L 1 .3 0 r
F
P
p
.36173 .18005 m .37795 .17594 L .39538 .18848 L 1 .35 0 r
F
P
p
.002 w
.54003 .47818 m .52321 .49506 L .50782 .44391 L p
1 .65 0 r
F P
0 0 0 r
s
P
p
.31135 .17562 m .34566 .18413 L .32975 .18817 L 1 .2 0 r
F
P
p
.29544 .17974 m .31135 .17562 L .32975 .18817 L 1 .2 0 r
F
P
p
.002 w
.47437 .46372 m .45746 .50916 L .4409 .50132 L p
.95 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49099 .46099 m .47437 .46372 L .45762 .49872 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.4409 .50132 m .45762 .49872 L .47437 .46372 L p
.95 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45746 .50916 m .44069 .5403 L .42411 .51838 L p
.65 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.40743 .53535 m .42411 .51838 L .44069 .5403 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39111 .53775 m .37495 .54012 L .35754 .51819 L p
.55 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34103 .53516 m .35754 .51819 L .37495 .54012 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.77651 .17784 m .79476 .17371 L .80618 .18631 L 1 0 0 r
F
P
p
.002 w
.32502 .53756 m .30917 .53994 L .29043 .53255 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27458 .53498 m .29043 .53255 L .30917 .53994 L p
.4 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42411 .51838 m .4409 .50132 L .45746 .50916 L p
.65 1 0 r
F P
0 0 0 r
s
P
p
.72814 .17339 m .75844 .18194 L .74053 .186 L 1 0 0 r
F
P
p
.71021 .17753 m .72814 .17339 L .74053 .186 L 1 0 0 r
F
P
p
.002 w
.21131 .46288 m .22671 .46014 L .24334 .53976 L p
.9 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.22671 .46014 m .21131 .46288 L .19112 .45436 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.17574 .45716 m .19112 .45436 L .21131 .46288 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.25889 .53738 m .24334 .53976 L .22671 .46014 L p
.9 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50782 .44391 m .52472 .44106 L .54003 .47818 L p
1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.80738 .4104 m .82579 .40737 L .83676 .41659 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66148 .17307 m .69244 .18163 L .67484 .18569 L 1 0 0 r
F
P
p
.64385 .17721 m .66148 .17307 L .67484 .18569 L 1 0 0 r
F
P
p
.002 w
.78915 .41339 m .77109 .41636 L .75914 .40714 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74105 .41017 m .75914 .40714 L .77109 .41636 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.59476 .17275 m .62639 .18131 L .6091 .18538 L 1 .1 0 r
F
P
p
.57745 .17689 m .59476 .17275 L .6091 .18538 L 1 .25 0 r
F
P
p
.002 w
.72312 .41316 m .70537 .41613 L .69245 .40691 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67466 .40993 m .69245 .40691 L .70537 .41613 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.528 .17243 m .5603 .181 L .54331 .18506 L 1 .6 0 r
F
P
p
.511 .17658 m .528 .17243 L .54331 .18506 L 1 .65 0 r
F
P
p
.002 w
.65705 .41293 m .6396 .4159 L .62607 .4355 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.62607 .4355 m .6396 .4159 L p
.61494 .44536 L 1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.62607 .4355 m .61139 .39717 L p
.63734 .42552 L 1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.62607 .4355 m .64379 .43257 L .65705 .41293 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.64379 .43257 m .62607 .4355 L p
.63734 .42552 L 1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.60868 .45284 m .62607 .4355 L p
.61494 .44536 L 1 .25 0 r
F P
0 0 0 r
s
P
p
.46118 .17211 m .49416 .18068 L .47748 .18475 L 1 .6 0 r
F
P
p
.4445 .17626 m .46118 .17211 L .47748 .18475 L 1 .6 0 r
F
P
p
.39432 .17179 m .42797 .18037 L .41159 .18444 L 1 .3 0 r
F
P
p
.37795 .17594 m .39432 .17179 L .41159 .18444 L 1 .3 0 r
F
P
p
.32741 .17146 m .36173 .18005 L .34566 .18413 L 1 .1 0 r
F
P
p
.31135 .17562 m .32741 .17146 L .34566 .18413 L 1 .2 0 r
F
P
p
.002 w
.45762 .49872 m .4745 .4961 L .49099 .46099 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.40743 .53535 m .39111 .53775 L .37414 .50112 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35754 .51819 m .37414 .50112 L .39111 .53775 L p
.55 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34103 .53516 m .32502 .53756 L .30688 .51548 L p
.55 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29043 .53255 m .30688 .51548 L .32502 .53756 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.74625 .16921 m .77651 .17784 L .75844 .18194 L 1 0 0 r
F
P
p
.72814 .17339 m .74625 .16921 L .75844 .18194 L 1 0 0 r
F
P
p
.002 w
.22671 .46014 m .24224 .45737 L .25889 .53738 L p
.9 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24224 .45737 m .22671 .46014 L .20664 .45153 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.19112 .45436 m .20664 .45153 L .22671 .46014 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.27458 .53498 m .25889 .53738 L .24224 .45737 L p
.9 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5741 .47281 m .55698 .4755 L .54178 .43818 L p
1 .55 0 r
F P
0 0 0 r
s
P
p
.002 w
.54178 .43818 m .55698 .4755 L p
.5312 .44798 L 1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.54178 .43818 m .55896 .42083 L .5741 .47281 L p
1 .55 0 r
F P
0 0 0 r
s
P
p
.002 w
.54178 .43818 m .52618 .45849 L p
.55249 .42826 L 1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.55896 .42083 m .54178 .43818 L p
.55249 .42826 L 1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.52472 .44106 m .54178 .43818 L p
.5312 .44798 L 1 .6 0 r
F P
0 0 0 r
s
P
p
.67927 .16889 m .71021 .17753 L .69244 .18163 L 1 0 0 r
F
P
p
.66148 .17307 m .67927 .16889 L .69244 .18163 L 1 0 0 r
F
P
p
.002 w
.80738 .4104 m .78915 .41339 L .77741 .40409 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75914 .40714 m .77741 .40409 L .78915 .41339 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61224 .16856 m .64385 .17721 L .62639 .18131 L 1 .1 0 r
F
P
p
.59476 .17275 m .61224 .16856 L .62639 .18131 L 1 .1 0 r
F
P
p
.002 w
.74105 .41017 m .72312 .41316 L .7104 .40385 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69245 .40691 m .7104 .40385 L .72312 .41316 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.54516 .16824 m .57745 .17689 L .5603 .181 L 1 .5 0 r
F
P
p
.528 .17243 m .54516 .16824 L .5603 .181 L 1 .6 0 r
F
P
p
.002 w
.52472 .44106 m .50782 .44391 L .49155 .49345 L p
1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.4745 .4961 m .49155 .49345 L .50782 .44391 L p
1 .85 0 r
F P
0 0 0 r
s
P
p
.002 w
.67466 .40993 m .65705 .41293 L .64379 .43257 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.47803 .16792 m .511 .17658 L .49416 .18068 L 1 .6 0 r
F
P
p
.46118 .17211 m .47803 .16792 L .49416 .18068 L 1 .6 0 r
F
P
p
.41085 .16759 m .4445 .17626 L .42797 .18037 L 1 .3 0 r
F
P
p
.39432 .17179 m .41085 .16759 L .42797 .18037 L 1 .3 0 r
F
P
p
.34362 .16727 m .37795 .17594 L .36173 .18005 L 1 0 0 r
F
P
p
.32741 .17146 m .34362 .16727 L .36173 .18005 L 1 .1 0 r
F
P
p
.002 w
.42411 .51838 m .40743 .53535 L .39055 .49852 L p
.65 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37414 .50112 m .39055 .49852 L .40743 .53535 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35754 .51819 m .34103 .53516 L .32343 .49832 L p
.65 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30688 .51548 m .32343 .49832 L .34103 .53516 L p
.55 1 0 r
F P
0 0 0 r
s
P
p
.76454 .16499 m .79476 .17371 L .77651 .17784 L 1 0 0 r
F
P
p
.74625 .16921 m .76454 .16499 L .77651 .17784 L 1 0 0 r
F
P
p
.002 w
.24224 .45737 m .25793 .45458 L .27458 .53498 L p
.9 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25793 .45458 m .24224 .45737 L .22231 .44868 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.20664 .45153 m .22231 .44868 L .24224 .45737 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.29043 .53255 m .27458 .53498 L .25793 .45458 L p
.95 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59127 .45565 m .5741 .47281 L .55896 .42083 L p
1 .45 0 r
F P
0 0 0 r
s
P
p
.69724 .16466 m .72814 .17339 L .71021 .17753 L 1 0 0 r
F
P
p
.67927 .16889 m .69724 .16466 L .71021 .17753 L 1 0 0 r
F
P
p
.002 w
.82579 .40737 m .80738 .4104 L .79586 .401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77741 .40409 m .79586 .401 L .80738 .4104 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.62989 .16434 m .66148 .17307 L .64385 .17721 L 1 .1 0 r
F
P
p
.61224 .16856 m .62989 .16434 L .64385 .17721 L 1 .1 0 r
F
P
p
.002 w
.75914 .40714 m .74105 .41017 L .72853 .40076 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7104 .40385 m .72853 .40076 L .74105 .41017 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.56249 .16401 m .59476 .17275 L .57745 .17689 L 1 .3 0 r
F
P
p
.54516 .16824 m .56249 .16401 L .57745 .17689 L 1 .5 0 r
F
P
p
.002 w
.50887 .46133 m .52472 .44106 L p
.50496 .47227 L 1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.49155 .49345 m .50887 .46133 L p
.50496 .47227 L 1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.50887 .46133 m .49267 .43768 L p
.51284 .45021 L 1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.54178 .43818 m .52472 .44106 L .50887 .46133 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.50887 .46133 m .52618 .45849 L .54178 .43818 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.52618 .45849 m .50887 .46133 L p
.51284 .45021 L 1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.69245 .40691 m .67466 .40993 L .66116 .40053 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64379 .43257 m .66116 .40053 L .67466 .40993 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.49504 .16368 m .528 .17243 L .511 .17658 L 1 .6 0 r
F
P
p
.47803 .16792 m .49504 .16368 L .511 .17658 L 1 .6 0 r
F
P
p
.42755 .16336 m .46118 .17211 L .4445 .17626 L 1 .3 0 r
F
P
p
.41085 .16759 m .42755 .16336 L .4445 .17626 L 1 .3 0 r
F
P
p
.002 w
.4409 .50132 m .42411 .51838 L .40711 .4959 L p
.75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39055 .49852 m .40711 .4959 L .42411 .51838 L p
.65 1 0 r
F P
0 0 0 r
s
P
p
.36 .16303 m .39432 .17179 L .37795 .17594 L 1 0 0 r
F
P
p
.34362 .16727 m .36 .16303 L .37795 .17594 L 1 0 0 r
F
P
p
.002 w
.37414 .50112 m .35754 .51819 L .33967 .49569 L p
.75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32343 .49832 m .33967 .49569 L .35754 .51819 L p
.65 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55896 .42083 m .57632 .41783 L .59127 .45565 L p
1 .45 0 r
F P
0 0 0 r
s
P
p
.76454 .16499 m .783 .16073 L .79476 .17371 L 1 0 0 r
F
P
p
.002 w
.25793 .45458 m .2743 .43729 L .29043 .53255 L p
.95 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.2743 .43729 m .25793 .45458 L .23814 .4458 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.22231 .44868 m .23814 .4458 L .25793 .45458 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.30688 .51548 m .29043 .53255 L .2743 .43729 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.45762 .49872 m .4409 .50132 L .42384 .49324 L p
.8 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.40711 .4959 m .42384 .49324 L .4409 .50132 L p
.75 1 0 r
F P
0 0 0 r
s
P
p
.71538 .1604 m .74625 .16921 L .72814 .17339 L 1 0 0 r
F
P
p
.69724 .16466 m .71538 .1604 L .72814 .17339 L 1 0 0 r
F
P
p
.002 w
.39055 .49852 m .37414 .50112 L .35608 .49304 L p
.9 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33967 .49569 m .35608 .49304 L .37414 .50112 L p
.75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.79586 .401 m .81449 .39789 L .82579 .40737 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64771 .16007 m .67927 .16889 L .66148 .17307 L 1 .1 0 r
F
P
p
.62989 .16434 m .64771 .16007 L .66148 .17307 L 1 .1 0 r
F
P
p
.002 w
.77741 .40409 m .75914 .40714 L .74684 .39765 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72853 .40076 m .74684 .39765 L .75914 .40714 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.57999 .15974 m .61224 .16856 L .59476 .17275 L 1 .15 0 r
F
P
p
.56249 .16401 m .57999 .15974 L .59476 .17275 L 1 .3 0 r
F
P
p
.002 w
.7104 .40385 m .69245 .40691 L .67914 .39741 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66116 .40053 m .67914 .39741 L .69245 .40691 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.51222 .15941 m .54516 .16824 L .528 .17243 L 1 .6 0 r
F
P
p
.49504 .16368 m .51222 .15941 L .528 .17243 L 1 .6 0 r
F
P
p
.4444 .15908 m .47803 .16792 L .46118 .17211 L 1 .3 0 r
F
P
p
.42755 .16336 m .4444 .15908 L .46118 .17211 L 1 .3 0 r
F
P
p
.37653 .15875 m .41085 .16759 L .39432 .17179 L 1 0 0 r
F
P
p
.36 .16303 m .37653 .15875 L .39432 .17179 L 1 0 0 r
F
P
p
.002 w
.2743 .43729 m .29075 .41991 L .30688 .51548 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.29075 .41991 m .2743 .43729 L .25469 .42823 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.23814 .4458 m .25469 .42823 L .2743 .43729 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.32343 .49832 m .30688 .51548 L .29075 .41991 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.62607 .4355 m .60868 .45284 L .59385 .4148 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.59385 .4148 m .60868 .45284 L p
.58282 .42487 L 1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.59385 .4148 m .61139 .39717 L .62607 .4355 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.59385 .4148 m .57906 .43492 L p
.60501 .40462 L 1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.61139 .39717 m .59385 .4148 L p
.60501 .40462 L 1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.57632 .41783 m .59385 .4148 L p
.58282 .42487 L 1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.57632 .41783 m .55896 .42083 L .54365 .44086 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.54365 .44086 m .55896 .42083 L p
.53723 .4458 L 1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.54365 .44086 m .52776 .43167 L p
.55017 .43584 L 1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.54365 .44086 m .56127 .43791 L .57632 .41783 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.56127 .43791 m .54365 .44086 L p
.55017 .43584 L 1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.52618 .45849 m .54365 .44086 L p
.53723 .4458 L 1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.4745 .4961 m .45762 .49872 L .44073 .49057 L p
.95 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42384 .49324 m .44073 .49057 L .45762 .49872 L p
.8 1 0 r
F P
0 0 0 r
s
P
p
.7337 .1561 m .76454 .16499 L .74625 .16921 L 1 0 0 r
F
P
p
.71538 .1604 m .7337 .1561 L .74625 .16921 L 1 0 0 r
F
P
p
.002 w
.40711 .4959 m .39055 .49852 L .3733 .46089 L p
1 .95 0 r
F P
0 0 0 r
s
P
p
.002 w
.35608 .49304 m .3733 .46089 L .39055 .49852 L p
.9 1 0 r
F P
0 0 0 r
s
P
p
.66571 .15576 m .69724 .16466 L .67927 .16889 L 1 .05 0 r
F
P
p
.64771 .16007 m .66571 .15576 L .67927 .16889 L 1 .1 0 r
F
P
p
.002 w
.29075 .41991 m .30684 .4169 L .32343 .49832 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.30684 .4169 m .29075 .41991 L .27134 .41056 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.25469 .42823 m .27134 .41056 L .29075 .41991 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.33967 .49569 m .32343 .49832 L .30684 .4169 L p
1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.79586 .401 m .77741 .40409 L .76532 .3945 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74684 .39765 m .76532 .3945 L .77741 .40409 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.59766 .15543 m .62989 .16434 L .61224 .16856 L 1 .1 0 r
F
P
p
.57999 .15974 m .59766 .15543 L .61224 .16856 L 1 .15 0 r
F
P
p
.002 w
.72853 .40076 m .7104 .40385 L .6973 .39426 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67914 .39741 m .6973 .39426 L .7104 .40385 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.52957 .1551 m .56249 .16401 L .54516 .16824 L 1 .4 0 r
F
P
p
.51222 .15941 m .52957 .1551 L .54516 .16824 L 1 .6 0 r
F
P
p
.46142 .15476 m .49504 .16368 L .47803 .16792 L 1 .3 0 r
F
P
p
.4444 .15908 m .46142 .15476 L .47803 .16792 L 1 .3 0 r
F
P
p
.39322 .15443 m .42755 .16336 L .41085 .16759 L 1 0 0 r
F
P
p
.37653 .15875 m .39322 .15443 L .41085 .16759 L 1 0 0 r
F
P
p
.002 w
.59385 .4148 m .57632 .41783 L .56127 .43791 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.49155 .49345 m .4745 .4961 L .45826 .44357 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.44073 .49057 m .45826 .44357 L .4745 .4961 L p
.95 1 0 r
F P
0 0 0 r
s
P
p
.7522 .15175 m .783 .16073 L .76454 .16499 L 1 0 0 r
F
P
p
.7337 .1561 m .7522 .15175 L .76454 .16499 L 1 0 0 r
F
P
p
.002 w
.42384 .49324 m .40711 .4959 L .39026 .44334 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.3733 .46089 m .39026 .44334 L .40711 .4959 L p
1 .95 0 r
F P
0 0 0 r
s
P
p
.68388 .15141 m .71538 .1604 L .69724 .16466 L 1 0 0 r
F
P
p
.66571 .15576 m .68388 .15141 L .69724 .16466 L 1 .05 0 r
F
P
p
.002 w
.30684 .4169 m .32308 .41387 L .33967 .49569 L p
1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.32308 .41387 m .30684 .4169 L .28757 .40747 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.27134 .41056 m .28757 .40747 L .30684 .4169 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.35608 .49304 m .33967 .49569 L .32308 .41387 L p
1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.66116 .40053 m .64379 .43257 L .62923 .39401 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61139 .39717 m .62923 .39401 L .64379 .43257 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.81449 .39789 m .79586 .401 L .78399 .39132 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76532 .3945 m .78399 .39132 L .79586 .401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61551 .15108 m .64771 .16007 L .62989 .16434 L 1 .1 0 r
F
P
p
.59766 .15543 m .61551 .15108 L .62989 .16434 L 1 .1 0 r
F
P
p
.002 w
.74684 .39765 m .72853 .40076 L .71564 .39108 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6973 .39426 m .71564 .39108 L .72853 .40076 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.54709 .15074 m .57999 .15974 L .56249 .16401 L 1 .2 0 r
F
P
p
.52957 .1551 m .54709 .15074 L .56249 .16401 L 1 .4 0 r
F
P
p
.002 w
.67914 .39741 m .66116 .40053 L .64724 .39083 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62923 .39401 m .64724 .39083 L .66116 .40053 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.47861 .1504 m .51222 .15941 L .49504 .16368 L 1 .3 0 r
F
P
p
.46142 .15476 m .47861 .1504 L .49504 .16368 L 1 .3 0 r
F
P
p
.41008 .15007 m .4444 .15908 L .42755 .16336 L 1 0 0 r
F
P
p
.39322 .15443 m .41008 .15007 L .42755 .16336 L 1 0 0 r
F
P
p
.002 w
.56127 .43791 m .57906 .43492 L .59385 .4148 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.50887 .46133 m .49155 .49345 L .47538 .44064 L p
1 .8 0 r
F P
0 0 0 r
s
P
p
.002 w
.45826 .44357 m .47538 .44064 L .49155 .49345 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.7522 .15175 m .77088 .14736 L .783 .16073 L 1 0 0 r
F
P
p
.002 w
.44073 .49057 m .42384 .49324 L .40706 .44041 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.002 w
.39026 .44334 m .40706 .44041 L .42384 .49324 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.70223 .14702 m .7337 .1561 L .71538 .1604 L 1 0 0 r
F
P
p
.68388 .15141 m .70223 .14702 L .71538 .1604 L 1 0 0 r
F
P
p
.002 w
.32308 .41387 m .33948 .4108 L .35608 .49304 L p
1 .7 0 r
F P
0 0 0 r
s
P
p
.002 w
.33948 .4108 m .32308 .41387 L .30397 .40434 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.28757 .40747 m .30397 .40434 L .32308 .41387 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.3733 .46089 m .35608 .49304 L .33948 .4108 L p
1 .55 0 r
F P
0 0 0 r
s
P
p
.002 w
.47538 .44064 m .49267 .43768 L .50887 .46133 L p
1 .8 0 r
F P
0 0 0 r
s
P
p
.002 w
.78399 .39132 m .80284 .38811 L .81449 .39789 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.63353 .14668 m .66571 .15576 L .64771 .16007 L 1 .1 0 r
F
P
p
.61551 .15108 m .63353 .14668 L .64771 .16007 L 1 .1 0 r
F
P
p
.002 w
.76532 .3945 m .74684 .39765 L .73416 .38787 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71564 .39108 m .73416 .38787 L .74684 .39765 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.56478 .14634 m .59766 .15543 L .57999 .15974 L 1 .15 0 r
F
P
p
.54709 .15074 m .56478 .14634 L .57999 .15974 L 1 .2 0 r
F
P
p
.002 w
.39026 .44334 m .3733 .46089 L .35641 .39304 L p
1 .35 0 r
F P
0 0 0 r
s
P
p
.002 w
.33948 .4108 m .35641 .39304 L .3733 .46089 L p
1 .55 0 r
F P
0 0 0 r
s
P
p
.002 w
.6973 .39426 m .67914 .39741 L .66543 .38762 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64724 .39083 m .66543 .38762 L .67914 .39741 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.49597 .146 m .52957 .1551 L .51222 .15941 L 1 .3 0 r
F
P
p
.47861 .1504 m .49597 .146 L .51222 .15941 L 1 .3 0 r
F
P
p
.002 w
.59677 .40215 m .61139 .39717 L p
.60073 .40961 L 1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.57906 .43492 m .59677 .40215 L p
.60073 .40961 L 1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.59677 .40215 m .58153 .39226 L p
.59271 .39451 L 1 .15 0 r
F P
0 0 0 r
s
P
p
.002 w
.62923 .39401 m .61139 .39717 L .59677 .40215 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59677 .40215 m .61484 .39897 L .62923 .39401 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61484 .39897 m .59677 .40215 L p
.59271 .39451 L 1 .15 0 r
F P
0 0 0 r
s
P
p
.42711 .14566 m .46142 .15476 L .4444 .15908 L 1 0 0 r
F
P
p
.41008 .15007 m .42711 .14566 L .4444 .15908 L 1 0 0 r
F
P
p
.002 w
.47538 .44064 m .45826 .44357 L .44114 .43446 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.45826 .44357 m .44073 .49057 L .42401 .43745 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.42401 .43745 m .44114 .43446 L .45826 .44357 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.40706 .44041 m .39026 .44334 L .37311 .38985 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.35641 .39304 m .37311 .38985 L .39026 .44334 L p
1 .35 0 r
F P
0 0 0 r
s
P
p
.002 w
.40706 .44041 m .42401 .43745 L .44073 .49057 L p
1 .9 0 r
F P
0 0 0 r
s
P
p
.72077 .14258 m .7522 .15175 L .7337 .1561 L 1 0 0 r
F
P
p
.70223 .14702 m .72077 .14258 L .7337 .1561 L 1 0 0 r
F
P
p
.002 w
.35641 .39304 m .33948 .4108 L .32053 .40118 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30397 .40434 m .32053 .40118 L .33948 .4108 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.54365 .44086 m .52618 .45849 L .51013 .43469 L p
1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.49267 .43768 m .51013 .43469 L .52618 .45849 L p
1 .7 0 r
F P
0 0 0 r
s
P
p
.65173 .14224 m .68388 .15141 L .66571 .15576 L 1 .05 0 r
F
P
p
.63353 .14668 m .65173 .14224 L .66571 .15576 L 1 .1 0 r
F
P
p
.002 w
.78399 .39132 m .76532 .3945 L .75287 .38462 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73416 .38787 m .75287 .38462 L .76532 .3945 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.58264 .1419 m .61551 .15108 L .59766 .15543 L 1 .05 0 r
F
P
p
.56478 .14634 m .58264 .1419 L .59766 .15543 L 1 .15 0 r
F
P
p
.002 w
.71564 .39108 m .6973 .39426 L .6838 .38437 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66543 .38762 m .6838 .38437 L .6973 .39426 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5135 .14155 m .54709 .15074 L .52957 .1551 L 1 .2 0 r
F
P
p
.49597 .146 m .5135 .14155 L .52957 .1551 L 1 .3 0 r
F
P
p
.002 w
.64724 .39083 m .62923 .39401 L .61484 .39897 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.4443 .14121 m .47861 .1504 L .46142 .15476 L 1 0 0 r
F
P
p
.42711 .14566 m .4443 .14121 L .46142 .15476 L 1 0 0 r
F
P
p
.002 w
.37311 .38985 m .35641 .39304 L .33766 .38311 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.32053 .40118 m .33766 .38311 L .35641 .39304 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51013 .43469 m .52776 .43167 L .54365 .44086 L p
1 .65 0 r
F P
0 0 0 r
s
P
p
.002 w
.49267 .43768 m .47538 .44064 L .45844 .43144 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.44114 .43446 m .45844 .43144 L .47538 .44064 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.42401 .43745 m .40706 .44041 L .38997 .38662 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.37311 .38985 m .38997 .38662 L .40706 .44041 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.73949 .1381 m .77088 .14736 L .7522 .15175 L 1 0 0 r
F
P
p
.72077 .14258 m .73949 .1381 L .7522 .15175 L 1 0 0 r
F
P
p
.67011 .13776 m .70223 .14702 L .68388 .15141 L 1 0 0 r
F
P
p
.65173 .14224 m .67011 .13776 L .68388 .15141 L 1 .05 0 r
F
P
p
.002 w
.80284 .38811 m .78399 .39132 L .77176 .38135 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75287 .38462 m .77176 .38135 L .78399 .39132 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60068 .13741 m .63353 .14668 L .61551 .15108 L 1 0 0 r
F
P
p
.58264 .1419 m .60068 .13741 L .61551 .15108 L 1 .05 0 r
F
P
p
.002 w
.73416 .38787 m .71564 .39108 L .70235 .38109 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6838 .38437 m .70235 .38109 L .71564 .39108 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5312 .13706 m .56478 .14634 L .54709 .15074 L 1 .1 0 r
F
P
p
.5135 .14155 m .5312 .13706 L .54709 .15074 L 1 .2 0 r
F
P
p
.002 w
.66543 .38762 m .64724 .39083 L .6331 .39576 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61484 .39897 m .6331 .39576 L .64724 .39083 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.46167 .13671 m .49597 .146 L .47861 .1504 L 1 0 0 r
F
P
p
.4443 .14121 m .46167 .13671 L .47861 .1504 L 1 0 0 r
F
P
p
.002 w
.38997 .38662 m .37311 .38985 L .35452 .37982 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.33766 .38311 m .35452 .37982 L .37311 .38985 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.57906 .43492 m .56127 .43791 L .54557 .42862 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.52776 .43167 m .54557 .42862 L .56127 .43791 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.51013 .43469 m .49267 .43768 L .47591 .42839 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.45844 .43144 m .47591 .42839 L .49267 .43768 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.44114 .43446 m .42401 .43745 L .40699 .38337 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.38997 .38662 m .40699 .38337 L .42401 .43745 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.73949 .1381 m .75839 .13358 L .77088 .14736 L 1 0 0 r
F
P
p
.68868 .13323 m .72077 .14258 L .70223 .14702 L 1 0 0 r
F
P
p
.67011 .13776 m .68868 .13323 L .70223 .14702 L 1 0 0 r
F
P
p
.002 w
.77176 .38135 m .79084 .37804 L .80284 .38811 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61891 .13288 m .65173 .14224 L .63353 .14668 L 1 0 0 r
F
P
p
.60068 .13741 m .61891 .13288 L .63353 .14668 L 1 0 0 r
F
P
p
.002 w
.75287 .38462 m .73416 .38787 L .72109 .37778 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70235 .38109 m .72109 .37778 L .73416 .38787 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.54909 .13252 m .58264 .1419 L .56478 .14634 L 1 .1 0 r
F
P
p
.5312 .13706 m .54909 .13252 L .56478 .14634 L 1 .1 0 r
F
P
p
.002 w
.6838 .38437 m .66543 .38762 L .65154 .39251 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6331 .39576 m .65154 .39251 L .66543 .38762 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.47921 .13217 m .5135 .14155 L .49597 .146 L 1 0 0 r
F
P
p
.46167 .13671 m .47921 .13217 L .49597 .146 L 1 0 0 r
F
P
p
.002 w
.40699 .38337 m .38997 .38662 L .37155 .3765 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.35452 .37982 m .37155 .3765 L .38997 .38662 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59677 .40215 m .57906 .43492 L .56344 .39551 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.54557 .42862 m .56344 .39551 L .57906 .43492 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.52776 .43167 m .51013 .43469 L .49356 .4253 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.47591 .42839 m .49356 .4253 L .51013 .43469 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.45844 .43144 m .44114 .43446 L .42419 .38008 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.40699 .38337 m .42419 .38008 L .44114 .43446 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.56344 .39551 m .58153 .39226 L .59677 .40215 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.70743 .12865 m .73949 .1381 L .72077 .14258 L 1 0 0 r
F
P
p
.68868 .13323 m .70743 .12865 L .72077 .14258 L 1 0 0 r
F
P
p
.63732 .1283 m .67011 .13776 L .65173 .14224 L 1 0 0 r
F
P
p
.61891 .13288 m .63732 .1283 L .65173 .14224 L 1 0 0 r
F
P
p
.002 w
.77176 .38135 m .75287 .38462 L .74002 .37444 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72109 .37778 m .74002 .37444 L .75287 .38462 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.56715 .12794 m .60068 .13741 L .58264 .1419 L 1 .05 0 r
F
P
p
.54909 .13252 m .56715 .12794 L .58264 .1419 L 1 .1 0 r
F
P
p
.002 w
.70235 .38109 m .6838 .38437 L .67016 .38923 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.002 w
.65154 .39251 m .67016 .38923 L .6838 .38437 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.49693 .12759 m .5312 .13706 L .5135 .14155 L 1 0 0 r
F
P
p
.47921 .13217 m .49693 .12759 L .5135 .14155 L 1 0 0 r
F
P
p
.002 w
.42419 .38008 m .40699 .38337 L .38875 .37314 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.37155 .3765 m .38875 .37314 L .40699 .38337 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.54557 .42862 m .52776 .43167 L .51138 .42219 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.49356 .4253 m .51138 .42219 L .52776 .43167 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.47591 .42839 m .45844 .43144 L .44156 .37676 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.42419 .38008 m .44156 .37676 L .45844 .43144 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.6331 .39576 m .61484 .39897 L .59967 .37392 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58153 .39226 m .59967 .37392 L .61484 .39897 L p
1 .15 0 r
F P
0 0 0 r
s
P
p
.72638 .12403 m .75839 .13358 L .73949 .1381 L 1 0 0 r
F
P
p
.70743 .12865 m .72638 .12403 L .73949 .1381 L 1 0 0 r
F
P
p
.65591 .12367 m .68868 .13323 L .67011 .13776 L 1 0 0 r
F
P
p
.63732 .1283 m .65591 .12367 L .67011 .13776 L 1 0 0 r
F
P
p
.002 w
.79084 .37804 m .77176 .38135 L .75914 .37106 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74002 .37444 m .75914 .37106 L .77176 .38135 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5854 .12331 m .61891 .13288 L .60068 .13741 L 1 0 0 r
F
P
p
.56715 .12794 m .5854 .12331 L .60068 .13741 L 1 .05 0 r
F
P
p
.002 w
.72109 .37778 m .70235 .38109 L .68865 .3708 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67016 .38923 m .68865 .3708 L .70235 .38109 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.51483 .12296 m .54909 .13252 L .5312 .13706 L 1 0 0 r
F
P
p
.49693 .12759 m .51483 .12296 L .5312 .13706 L 1 0 0 r
F
P
p
.002 w
.44156 .37676 m .42419 .38008 L .40612 .36975 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.38875 .37314 m .40612 .36975 L .42419 .38008 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56344 .39551 m .54557 .42862 L .52939 .41905 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.002 w
.51138 .42219 m .52939 .41905 L .54557 .42862 L p
1 .6 0 r
F P
0 0 0 r
s
P
p
.002 w
.49356 .4253 m .47591 .42839 L .45911 .3734 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.44156 .37676 m .45911 .3734 L .47591 .42839 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.65154 .39251 m .6331 .39576 L .6181 .37054 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59967 .37392 m .6181 .37054 L .6331 .39576 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58153 .39226 m .56344 .39551 L .54752 .38541 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.52939 .41905 m .54752 .38541 L .56344 .39551 L p
1 .4 0 r
F P
0 0 0 r
s
P
p
.72638 .12403 m .74551 .11936 L .75839 .13358 L 1 0 0 r
F
P
p
.6747 .119 m .70743 .12865 L .68868 .13323 L 1 0 0 r
F
P
p
.65591 .12367 m .6747 .119 L .68868 .13323 L 1 0 0 r
F
P
p
.002 w
.75914 .37106 m .77846 .36765 L .79084 .37804 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60383 .11864 m .63732 .1283 L .61891 .13288 L 1 0 0 r
F
P
p
.5854 .12331 m .60383 .11864 L .61891 .13288 L 1 0 0 r
F
P
p
.002 w
.74002 .37444 m .72109 .37778 L .70761 .36738 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68865 .3708 m .70761 .36738 L .72109 .37778 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.53291 .11828 m .56715 .12794 L .54909 .13252 L 1 0 0 r
F
P
p
.51483 .12296 m .53291 .11828 L .54909 .13252 L 1 0 0 r
F
P
p
.002 w
.45911 .3734 m .44156 .37676 L .42367 .36632 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.40612 .36975 m .42367 .36632 L .44156 .37676 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.51138 .42219 m .49356 .4253 L .47683 .37001 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.45911 .3734 m .47683 .37001 L .49356 .4253 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.67016 .38923 m .65154 .39251 L .63671 .36712 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6181 .37054 m .63671 .36712 L .65154 .39251 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59967 .37392 m .58153 .39226 L .56582 .38206 L p
1 .15 0 r
F P
0 0 0 r
s
P
p
.002 w
.54752 .38541 m .56582 .38206 L .58153 .39226 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.69368 .11428 m .72638 .12403 L .70743 .12865 L 1 0 0 r
F
P
p
.6747 .119 m .69368 .11428 L .70743 .12865 L 1 0 0 r
F
P
p
.62245 .11391 m .65591 .12367 L .63732 .1283 L 1 0 0 r
F
P
p
.60383 .11864 m .62245 .11391 L .63732 .1283 L 1 0 0 r
F
P
p
.002 w
.75914 .37106 m .74002 .37444 L .72677 .36393 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70761 .36738 m .72677 .36393 L .74002 .37444 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.55117 .11355 m .5854 .12331 L .56715 .12794 L 1 0 0 r
F
P
p
.53291 .11828 m .55117 .11355 L .56715 .12794 L 1 0 0 r
F
P
p
.002 w
.6181 .37054 m .59967 .37392 L .58431 .37867 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.002 w
.56582 .38206 m .58431 .37867 L .59967 .37392 L p
1 .15 0 r
F P
0 0 0 r
s
P
p
.002 w
.47683 .37001 m .45911 .3734 L .4414 .36286 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.42367 .36632 m .4414 .36286 L .45911 .3734 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.52939 .41905 m .51138 .42219 L .49474 .36659 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.47683 .37001 m .49474 .36659 L .51138 .42219 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.68865 .3708 m .67016 .38923 L .65551 .36366 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.002 w
.63671 .36712 m .65551 .36366 L .67016 .38923 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.71285 .10951 m .74551 .11936 L .72638 .12403 L 1 0 0 r
F
P
p
.69368 .11428 m .71285 .10951 L .72638 .12403 L 1 0 0 r
F
P
p
.64127 .10914 m .6747 .119 L .65591 .12367 L 1 0 0 r
F
P
p
.62245 .11391 m .64127 .10914 L .65591 .12367 L 1 0 0 r
F
P
p
.002 w
.77846 .36765 m .75914 .37106 L .74612 .36044 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72677 .36393 m .74612 .36044 L .75914 .37106 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.56963 .10877 m .60383 .11864 L .5854 .12331 L 1 0 0 r
F
P
p
.55117 .11355 m .56963 .10877 L .5854 .12331 L 1 0 0 r
F
P
p
.002 w
.70761 .36738 m .68865 .3708 L .67451 .36017 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65551 .36366 m .67451 .36017 L .68865 .3708 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.002 w
.63671 .36712 m .6181 .37054 L .60283 .3599 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58431 .37867 m .60283 .3599 L .6181 .37054 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.002 w
.49474 .36659 m .47683 .37001 L .45932 .35936 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.4414 .36286 m .45932 .35936 L .47683 .37001 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.54752 .38541 m .52939 .41905 L .51283 .36313 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.49474 .36659 m .51283 .36313 L .52939 .41905 L p
1 .3 0 r
F P
0 0 0 r
s
P
p
.002 w
.56582 .38206 m .54752 .38541 L .5311 .35963 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51283 .36313 m .5311 .35963 L .54752 .38541 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.71285 .10951 m .73222 .10469 L .74551 .11936 L 1 0 0 r
F
P
p
.66027 .10432 m .69368 .11428 L .6747 .119 L 1 0 0 r
F
P
p
.64127 .10914 m .66027 .10432 L .6747 .119 L 1 0 0 r
F
P
p
.002 w
.74612 .36044 m .76568 .35692 L .77846 .36765 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.58827 .10395 m .62245 .11391 L .60383 .11864 L 1 0 0 r
F
P
p
.56963 .10877 m .58827 .10395 L .60383 .11864 L 1 0 0 r
F
P
p
.002 w
.72677 .36393 m .70761 .36738 L .6937 .35665 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67451 .36017 m .6937 .35665 L .70761 .36738 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65551 .36366 m .63671 .36712 L .62166 .35638 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60283 .3599 m .62166 .35638 L .63671 .36712 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.51283 .36313 m .49474 .36659 L .47742 .35583 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.45932 .35936 m .47742 .35583 L .49474 .36659 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58431 .37867 m .56582 .38206 L .54957 .3561 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5311 .35963 m .54957 .3561 L .56582 .38206 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.67948 .09945 m .71285 .10951 L .69368 .11428 L 1 0 0 r
F
P
p
.66027 .10432 m .67948 .09945 L .69368 .11428 L 1 0 0 r
F
P
p
.60711 .09907 m .64127 .10914 L .62245 .11391 L 1 0 0 r
F
P
p
.58827 .10395 m .60711 .09907 L .62245 .11391 L 1 0 0 r
F
P
p
.002 w
.74612 .36044 m .72677 .36393 L .71309 .35309 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6937 .35665 m .71309 .35309 L .72677 .36393 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67451 .36017 m .65551 .36366 L .64069 .35281 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62166 .35638 m .64069 .35281 L .65551 .36366 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5311 .35963 m .51283 .36313 L .49571 .35226 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.47742 .35583 m .49571 .35226 L .51283 .36313 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60283 .3599 m .58431 .37867 L .56823 .35254 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.002 w
.54957 .3561 m .56823 .35254 L .58431 .37867 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.69889 .09452 m .73222 .10469 L .71285 .10951 L 1 0 0 r
F
P
p
.67948 .09945 m .69889 .09452 L .71285 .10951 L 1 0 0 r
F
P
p
.62615 .09414 m .66027 .10432 L .64127 .10914 L 1 0 0 r
F
P
p
.60711 .09907 m .62615 .09414 L .64127 .10914 L 1 0 0 r
F
P
p
.002 w
.76568 .35692 m .74612 .36044 L .73269 .34949 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71309 .35309 m .73269 .34949 L .74612 .36044 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6937 .35665 m .67451 .36017 L .65991 .34921 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64069 .35281 m .65991 .34921 L .67451 .36017 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62166 .35638 m .60283 .3599 L .58708 .34893 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56823 .35254 m .58708 .34893 L .60283 .3599 L p
1 .05 0 r
F P
0 0 0 r
s
P
p
.002 w
.54957 .3561 m .5311 .35963 L .51419 .34865 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.49571 .35226 m .51419 .34865 L .5311 .35963 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69889 .09452 m .7185 .08955 L .73222 .10469 L 1 0 0 r
F
P
p
.64538 .08916 m .67948 .09945 L .66027 .10432 L 1 0 0 r
F
P
p
.62615 .09414 m .64538 .08916 L .66027 .10432 L 1 0 0 r
F
P
p
.002 w
.73269 .34949 m .75249 .34585 L .76568 .35692 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71309 .35309 m .6937 .35665 L .67934 .34557 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65991 .34921 m .67934 .34557 L .6937 .35665 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64069 .35281 m .62166 .35638 L .60613 .34529 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58708 .34893 m .60613 .34529 L .62166 .35638 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56823 .35254 m .54957 .3561 L .53286 .34501 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.51419 .34865 m .53286 .34501 L .54957 .3561 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66482 .08413 m .69889 .09452 L .67948 .09945 L 1 0 0 r
F
P
p
.64538 .08916 m .66482 .08413 L .67948 .09945 L 1 0 0 r
F
P
p
.002 w
.73269 .34949 m .71309 .35309 L .69897 .34189 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67934 .34557 m .69897 .34189 L .71309 .35309 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65991 .34921 m .64069 .35281 L .62538 .34161 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60613 .34529 m .62538 .34161 L .64069 .35281 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58708 .34893 m .56823 .35254 L .55173 .34132 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.53286 .34501 m .55173 .34132 L .56823 .35254 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68447 .07905 m .7185 .08955 L .69889 .09452 L 1 0 0 r
F
P
p
.66482 .08413 m .68447 .07905 L .69889 .09452 L 1 0 0 r
F
P
p
.002 w
.75249 .34585 m .73269 .34949 L .71881 .33817 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69897 .34189 m .71881 .33817 L .73269 .34949 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67934 .34557 m .65991 .34921 L .64484 .33789 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62538 .34161 m .64484 .33789 L .65991 .34921 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60613 .34529 m .58708 .34893 L .57081 .3376 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.55173 .34132 m .57081 .3376 L .58708 .34893 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68447 .07905 m .70433 .07391 L .7185 .08955 L 1 0 0 r
F
P
p
.002 w
.71881 .33817 m .73887 .33442 L .75249 .34585 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69897 .34189 m .67934 .34557 L .66451 .33413 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64484 .33789 m .66451 .33413 L .67934 .34557 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62538 .34161 m .60613 .34529 L .59009 .33383 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.57081 .3376 m .59009 .33383 L .60613 .34529 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71881 .33817 m .69897 .34189 L .68439 .33032 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66451 .33413 m .68439 .33032 L .69897 .34189 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64484 .33789 m .62538 .34161 L .60957 .33003 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59009 .33383 m .60957 .33003 L .62538 .34161 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73887 .33442 m .71881 .33817 L .70448 .32648 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68439 .33032 m .70448 .32648 L .71881 .33817 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66451 .33413 m .64484 .33789 L .62927 .32619 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60957 .33003 m .62927 .32619 L .64484 .33789 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70448 .32648 m .72479 .3226 L .73887 .33442 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68439 .33032 m .66451 .33413 L .64918 .3223 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62927 .32619 m .64918 .3223 L .66451 .33413 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70448 .32648 m .68439 .33032 L .66931 .31837 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64918 .3223 m .66931 .31837 L .68439 .33032 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72479 .3226 m .70448 .32648 L .68966 .3144 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66931 .31837 m .68966 .3144 L .70448 .32648 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68966 .3144 m .71023 .31038 L .72479 .3226 L p
1 0 0 r
F P
0 0 0 r
s
P
p
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.08509 .19367 m
.08465 .20033 L
s
P
[(0)] .08595 .18034 -0.06484 1 Mshowa
p
.002 w
.23498 .15292 m
.23469 .15959 L
s
P
[(10)] .23556 .13958 -0.04346 1 Mshowa
p
.002 w
.40002 .10806 m
.39989 .11474 L
s
P
[(20)] .40028 .0947 -0.01962 1 Mshowa
p
.002 w
.58262 .05842 m
.58267 .0651 L
s
P
[(30)] .58253 .04506 .00711 1 Mshowa
p
.001 w
.11395 .18582 m
.11371 .18982 L
s
P
p
.001 w
.14336 .17783 m
.14314 .18183 L
s
P
p
.001 w
.17332 .16968 m
.17311 .17368 L
s
P
p
.001 w
.20386 .16138 m
.20367 .16538 L
s
P
p
.001 w
.2667 .1443 m
.26655 .1483 L
s
P
p
.001 w
.29905 .1355 m
.29892 .13951 L
s
P
p
.001 w
.33204 .12654 m
.33192 .13054 L
s
P
p
.001 w
.36569 .11739 m
.36559 .1214 L
s
P
p
.001 w
.43505 .09854 m
.43499 .10254 L
s
P
p
.001 w
.4708 .08882 m
.47076 .09283 L
s
P
p
.001 w
.5073 .0789 m
.50728 .0829 L
s
P
p
.001 w
.54456 .06877 m
.54457 .07277 L
s
P
p
.001 w
.6215 .04785 m
.62155 .05186 L
s
P
p
.001 w
.66122 .03706 m
.6613 .04106 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{266, 253},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004:0000o@P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l02`000?mK2U/10000oe/:F`40003oF`YK
0@000?mK2U/10000oe/:F`40003oF`YK0@000?mK2U/10000oe/:F`40003oF`YK0@0005iK00?oFol0
0e/01?mKFe/3o`04FomKo`AK00GoFe]Ko`2AF`40001NF`03oe_o00=K00CoFe_o0e/2o`03FomK009K
00?oFol09E/4o`=K1?mTF`40001NF`03oe_o00=K00CoFe_o15/00omKo`03F`03oe_o02AK00?oFe/0
0U/00omKo`04F`03oe]K065K0@0005iK00?oFol00e/01?mKFol4F`03oe_o00=K00?oFol095/00omK
F`02F`03oe_o00AK00?oFe/0HE/10000GU/00omKo`03F`04oe]Ko`AK00?oFol00e/00omKo`0YF`03
oe_o00AK00?oFe/04E/3odeK0@0005iK00CoFooo0U/01?mKFol3F`;o00EKoe]Ko`03F`03oe]K02=K
0ol2F`03oe]K009K00?oFe/03U/3o`9K00?oFe/0Be/10000GU/01?mKoe/2o`AK0ol015_oFol2F`05
oe]KFol0:5/00omKo`04F`03oe]K00YK1?l6F`03oe]K04YK0@0005iK00?oFe/02e/00omKF`0ZF`03
oe]K009K00?oFol015/00omKF`06F`Co00=Koe/025/00omKF`19F`40001NF`03oe]K00]K00?oFol0
:U/00omKF`02F`03oe_o00AK00?oFe/00e/3o`EK00?oFe/025/00omKF`18F`40002JF`Co0e/4o`9K
1?lDF`03oe]K04MK0@000:AK0ol2F`03oe]K01AK00?oFe/0AU/10000X5/4oaeK00?oFe/0AE/10000
WE/4ob5K00?oFe/0A5/10000KU/6o`9K1?lOF`Co0e/00omKF`0OF`03oe]K04AK0@0006iK00?oFe/0
15/00omKF`02F`03oe]K01QK1?l7F`03oe]K021K00?oFe/0@e/10000Ke/00omKF`03F`03oe]K009K
00?oFe/05E/3o`9K00?oFe/0:U/00omKF`12F`40001`F`;o0e/00omKF`02F`03oe]K015K1?lcF`03
oe]K045K0@00079K00CoFe_o15/00omKF`0>F`Co;5/38`QK00?oFe/0@5/10000Le/00omKo`04F`03
oe]K00YK1?l3F`03oe]K02EK2B<8F`03oe]K03mK0@0006iK00?oFe/00U/00omKo`04F`03oe]K00IK
1?lZF`lS25/00omKF`0nF`40001^F`03oe]K009K00?oFol015/00omKF`03F`?o0e/00omKF`0TFa<S
2E/00omKF`0mF`40001_F`Co0e/4o`9K1?lYFaPS25/00omKF`05F`Co=5/10000NE/3o`03FomK02QK
6b<8F`03oe]K00=K00?oFe/00U/00omKF`0aF`40001;F`03oe]K009K1?lQF`Co:e/O8`QK00?oFe/0
1e/00omKF`0aF`40001;F`05oe]KFol015/00omKF`0JF`Go:E/U8`QK00?oFe/01U/00omKF`0aF`40
001;F`05oe]KFol015/00omKF`0GF`?o15/00omKF`0SFbXS1e/2o`9K00?oFe/00U/00omKF`0aF`40
001;F`05oe]KFol015/00omKF`0CF`Co:E/_8`QK00?oFol01?ldF`40001;F`05oe]KFol015/00omK
F`0@F`?o0e/00omKF`0RFc@S2E/2ocQK0@0004]K00GoFe]Ko`04F`03oe]K00aK1?lWFa4S0QlV8`UK
0_lgF`400019F`?o0e/00omKF`02F`03oe]K00UK0ol2F`03oe]K029K42<021mO7amO7elO9R<8F`Ko
<e/10000Be/01OmKFe_o00AK00?oFe/01E/4obIK42<=7bHS25/00omKF`0eF`40001;F`03oe]K009K
1?l4F`Co00=Koe/08e/A8`8O00UO7elOGamO7el00Ql015lOGalV8`QK00?oFe/0=5/10000EE/3obIK
4b<5Ga0O3B<37aDS25/00omKF`0cF`40000YF`Co95/4o`03FomK02AK4R<4G`DO00IO7elOGal6G`04
7elOG`LS00<OGal00Ul011mO7elE8`QK00?oFe/0<U/10000:5/00omKF`02F`03oe]K01iK0olXFa4S
00QO7elOGamO7`IO0Ql4G`047elOG`HO0R<>7aDS25/00omKF`0aF`40000XF`03oe]K009K00?oFe/0
6U/5obIK4B<>G`8O0aL57`MO0Ql035lOGamO7elOGamO7`9O00@OGamO5B<8F`03oe]K01UK1?l00e_o
F`04o`9K00GoFe]Ko`03F`7o0E/10000:5/00omKF`02F`03oe]K01IK1?l4F`03oe]K021K42<04AmO
7elOGamO7elOGamO7elO00<A1AL6G`047elOGaHO5B<8F`03oe]K01MK00?oFe/00U/3o`AK00?oFol0
0e/00omKF`03F`40000XF`03oe]K009K00?oFe/04e/3o`03FomK02EK3b<@G`TA1AL27`UO00lOGamO
7elOGamO7elOGal00Ul011mO7elE8`QK00?oFe/01U/00omKF`02F`Co1U/00omKF`04F`;o1U/01OmK
Fe_o00EK0@0002QK00?oFe/00U/00omKF`0?F`Co9e/@8`0?GamO7elOGamO7elOGamO00hA0QL0214G
4ALOGamO0Ql00elOG`0C7aPS1e/00omKF`06F`05oe]KFol015/00omKF`03F`03oe]K00AK1ol00e_o
F`02F`03oe]K00=K0@0002QK00?oFe/00U/00omKF`0<F`?o00=Koe/095/011mO7el<8`mO6A48G`0?
7elOGamO7elOGamO7elO01dS1e/00omKF`05F`05oe]KFol015/00omKF`03F`04oe]KF`Go15/00omK
o`03F`03oe]K00=K0@0002QK00?oFe/00U/00omKF`08F`Co9U/4G`DO1b<03elOGamO7elOGamO7elO
G`0A4@03Wa6O00DA00HG4ALA5al4G`dO8R<7F`03oe]K00AK00GoFe]Ko`04F`03oe]K00=K00?oFe/0
1E/00omKF`02F`04oe_oo`9K00?oFe/00e/10000:E/4o`QK0ol00e_oF`0SF`TO00EO7elOG`028`03
5elG00eO00>Ogil03145W`044IlAW`LA0aL015lOGal2G`0:7elOGamO7elOGb@S1E/3o`EK00GoFe]K
o`04F`03oe]K00=K00?oFe/015/00omKo`03o`9K00CoFooo1U/10000<E/4ob9K00<OGal03Ul27`@A
00aO5elGGamO7elOGal3g`FO1a44W`0:gioOWmnO4IlAW`8A21L5G`8O15l57b@S1e/00omKF`02F`05
oe]KFol015/00omKF`04F`03oe]K009K00?oFe/045/10000;E/4o`03FomK01mK1145G`XO19l02A4G
4ALAGaMO5`03G`07gioOWmnOg`02W`04gioOW`8A00>Ogil01]l6W`@A2QL00elOG`03G`DO00EO7elO
G`0S8`QK00?oFol00_l3F`03oe]K009K00?oFe/01E/4oa=K0@0002YK0olSF`@A00PG4ALAGamO7`=O
19l02MnOgioOWmnOg`044@03GaOO00cO0Yl9g`FO00?OWa400Q4011LA5a4<5`04GamO7`IO1AlS8`QK
00CoFe_o0e/00omKF`02F`03oe]K01aK0@0002QK0_l00e_oF`0OF`dA0Ul00ioOW`02g`04WmnOg`NO
00cOg]oOg]oNWmnOgil2g`05WmnOgil01=l00mkOgP02g`03WmnO00?O0il:4@8G00<A5a401QL5G`DO
00EO7elOG`0S8`QK00?oFol015/4oamK0@0002QK00?oFh407U/=4@035a7O00OO1Il01MnOLMia00GN
1ml01=iagW49gPKO00>Ogil00]l00ioOW`054@035a4A00<A00@G4ALA1QL00elOG`07G`DO8b<7F`03
oe]K02MK0@0002QK00?oFh406U/?4@03gmkO00;N00OOg]oNWmnO00;O00>Og]h02=h01=oNgml2gP03
LMia00GN00COg]oN0ml01mkOgYoOWml02Il74@085a4G4ALA5a475`03GamO00HO00EO7elOG`0S8`MK
00?oFe/09U/10000:5/00omKP@0GF`03WmnO00`A3ml3L@04gW7NL@;N00=agW401=h00g7NgP04gP05
LMiagW400mh00g7Ng`09g`03WmnO00>O00<AWa4021400ilAW`054@DG2Ul47`LS11lH8`MK00?oFe/0
9E/10000:5/00omKP@0CF`@51Il64@0<g]oNgmkOg]oNgmkO0]h00mmaL@02L@04gW7NL@ON00=agW40
1Mh01G7NLMia00?N00=agW401Mh01]oNgmjOg`BO00?OWml00Yl0116O4Il24@BO00TAWa6O4ALA5a40
0QL34@EO1Ql00elOG`028`03GamO008O00AO7elO62<7F`03oe]K02AK0@0002QK00?oFh4045/3gPD5
00GOWmnOg`024@oO37400miaL@09L@03gW7N00;N2W400miagP02g`08g]oNgioOWml6W`0>4InOWmnO
gioOWa6O4Il34@0<Wa4G4ALA5amO7elO0Ul00aLA5`055`EO11lI8`MK00?oFe/08e/100009e/2o`03
Fh5K00]K1G401=iagW441@:O1=h02moNgmkOg]oNgmkO00ea00?NLG401g401=iagW43gPUa00CNLMia
0]h00g7NL@05gPFO00COWmnO1Ml6W`084InOWa6O4Il64@9O21455`037emO009O00@OGamO6B<7F`03
oe]K029K0@0002QK00?oFh4035/6L@CN0PD02MoNgmoNgmkOgP06gbma00oNLMiag]oNgmkOWmoNgmh0
1Ml4W`03gil5008500cOWmnOga6O4IlA5a43W`DA00@G4ALA0aL01Q4G4ElOG`HO6B<7F`03oe]K025K
0@0002MK00CoFe^13e/2L@06UMbELMia2MhhL@04gW7NL@[N00COWmnO0ml00mkOgP041@FO00<AWil0
0Yl01MnOgioO00/A00@G4ALA1El00alS8`0J8`MK00?oFe/085/100009e/01?mKFh4AF`FE17401]oN
LMeag@]a0iD0176ELIDVL@03gW5a00=a00WNLMiag]oNgmh00]l4gPCO10D00mnO1@031@03gioO00JO
0a403ALA5a4G4ALA5a4G4El00alM8`MK00?oFe/085/100009e/00omKP@0DF`06UMbEg=ia0iD01Mea
gG7M00Ia2ID_L@?N00MagW7NLMia00KO00?Ngmh00PD3gPD519l00mnO4@0=4@085emOGamO7elM8`MK
00?oFe/07e/100009e/00omKP@0EF`:E00c<3LcLUMbEg77MLMd2L@>e00GLUMbEg006U@08LMc/g76E
LID7L@03UG6E00]a00>ELID04g4@gP04gmkOgP8500NOgioOWmnO00DA00PG4ALA5a5O5`9O00@OGamO
11lM8`MK00?oFe/07U/100009e/2o`03PE]K01EK1<`5U@03LMe<009<00D=]@fe3@06U@Bf1>`6L@C/
2g43UAAa00CNLMia1Mh01=oNgmh5g`;N0ml9W`<A00<G4A4011400aMO5`03Gb@S1e/00omKF`0MF`40
000WF`03oe^101UK00G<3LcLU@04C0F<1;D00iGL]@02]@Jf00GLk=aaU@03]P09g>cLk=aaUG6E009a
29D0176ELIDBL@05gW5agW402=h3g`JO00SOWmnOgioOW`DA00@G4ALA0QL2G`037b<S02@S1e/00omK
F`0LF`40000WF`03oe^101MK00b1Fe]K?dloCDa=C4d3C0<R00U=ITeV3KD=]@d00[H01<36`<H3]0Ff
1>`2L@bE47401=iagW49gP03g`D5008500>Ogil01]l2W`?O19l0114G4AL34@MO9B<8F`03oe]K01]K
0@0002MK00?oFh405e/00h5KF`02F`E?0T`38`097b8O8TeVCFI=00:e0dd5`0Bd0[H3]@09k;O/]mbE
g9GL00ZE00AaUG6E3W400miagP02L@CN1@D4g`:O1=l4W`04gioOW`8A11L00amO7`02G`037elO02DS
25/00omKF`0JF`40000WF`03oe^101MK00>1Fe/00e/00cm?8`078`@R00I=ISlP?b04C005a/36`<H0
0[@00kD=]@04]@05k;O/]n`03YD>L@04gW7NL@GN1Ml21@ON00FOgioOW`04g`054IlAWa401AL2G`07
7emO7elOG`0T8`QK00?oFe/06E/100009e/00omKP@0GF`03PE]K00EK2B<02alR7b8O83lP?b0o00==
0/001`g<3L`=]@d01KD00nbgg004g003UMbE00JE5G401=iagW43gP06LMiagmkO0]h01=oNgmh3g`03
WmnO00>O00DAWa6O4@025`03GaLO00TO9B<6F`03oe]K00AK1_l2F`Co2E/100009e/00omKP@0GF`03
PE]K00QK22<01b8O8QlR?b0013l3dPG<00<=]@d00kD8g0JE5g402=iag]iagG7M2mh00moNg`04W`CO
00dAWa6O4IlGGaMO7elO009O00@OGamO9B<6F`03oe]K00=K00?oFe/015/00omKF`02F`03oe]K00IK
0@0001IK1_l2F`Co1E/3PAMK00>1Fe/02U/88`0:7b8O8Qm??dloC`CB00T=c?bfo;Jg][L01N`3g006
UMaaUG6E1g401iEagG7MLMd01g4049EaUG6ELMeagG7MgW7NLMl4gPGO00BOgioO1Yl01a6O4IlGGaL0
2QlU8`IK00?oFe/00e/00omKF`03F`03oe]K009K00?oFe/01U/100005U/00omKF`04F`03oe]K009K
00?oFe/00U/01?mKPH4FF`03PE]K00aK22<0128O8Ql5?`;B0k@02;Kl]_bf]kJg0]`4k0BE1g400iEa
U@03L@05gG7MLMd00W44U@03LIEa00Ia00?Mg]h02]l01=kOg]l41@04WmnOg`:O0a45G`047elOG`8O
00=O8b<02b<37aLS1U/00omKF`03F`;o0e/00omKF`02F`03oe]K00IK0@0001MK00?oFe/00e/00omK
F`02F`03oe]K009K00CoFh5K0X4DF`03PE]K00iK22<02AlR7dloCTe>C@05]004o;Kl]PBg00[Lk=c/
g9GLUMaa1ID02G6ELIEaUG7ML@09U@05LIEaUG401Mh00moNgP07gP03gmkN00?N10D2W`DA00LG4ElO
GamO00DO2b<25`EO5R<5F`?o1U/01?mKFol4F`03oe]K00IK0@00019K0ol3F`;o0e/00omKF`02F`03
oe]K009K00?oFh400e/2PA9K00>1Fe/03e/98`<R1Dh2]0>f00Bg][Nf1KL3k003g>cL00CL012Eg9GL
LIG/g9GLUMbEg9GL0iD4L@07gW7NgW7NL@04gP;O2Mh00moNg`021@03gioO00PA0Ul57`03GamO00HS
1aL57aHS1e/00omKF`04F`03oe_o00AK00?oFe/01U/100006U/01?mKFol4F`05oe]KFol00U/00h5K
F`03F`:145/00h5KF`0@F`TS00`R7b8OCTe<CDbe][D6]P:g00>f]kH01>`4g0:E00CLk=c/0m`019GL
UM`6U@08LIEaUMiagW43gP0<LMiaLMiag]oNgmkO0mh9g`8A0QL015lOGal6G`8O00<G4AL031L5GaHS
1e/2o`AK00?oFol015/00omKF`06F`40000KF`03oe_o00AK00GoFe]Ko`02F`03PE]K00EK0X4>F`03
PE]K019K22<38P037b9=00A=0kH00kNf]P03]P08]kJg][O/g>`3g003k=c/00C/00WLk=bEg9GLUM`0
19D5L@;N00=ag]h03Mh4g`06g]oNgioO0a435`EO0Ql34@045a4G4@dG1AlF8`MK00?oFe/00U/00omK
o`04F`03oe]K00IK0@0001IK00?oFe/00U/00omKo`04F`04oe]KF`;o00=KPE/025/2P@aK00>1Fe/0
4U/00h5K8`048`038QlR00DR00=<CDl00Tl04LK0a[Je][Ff]kJe][Ff]kJg00G/00?Lk=`00]`00iGL
U@09U@04LIEaU@Ia1=h02MoNgmkOg]oNg`03gP;O0a4011LA5a445`03GanO00>O114011LA5a4=5`9O
6B<7F`Co0e/4o`UK0@0001IK00?oFe/00U/00omKo`04F`07oe]KFomKP@0<F`:12E/00h5KF`0CF`04
PE]KF`DS00DO8QlR7`038P08Ccm??do0a/02]P>d1KH01;Nf]n`2g003k=c/00CL00JEg9GLUM`6U@Ia
0]h01W7NgW7NL@KN00[OWmoOWmnO5a4G0a400mnOg`05W`04goooo`8A0il00a4G4@075b4S6U/10000
5e/4o`=K1?l4F`03oe^100iK0X47F`03PE]K01=K00>1Fe/00U/68`088QlR7b8O8Ql2C`9V00B<C8a<
1K@01kFf]KK/g>`02]`019GLUM`8U@0:LIGNLMiagW7NL@CN00?OgPD00PD4g`BO0Q47g`Go0b<02OnO
gioOWa4G4@025bHS6E/100009U/00omKP@0@F`:11E/00h5KF`0CF`03PE]K00AK1B<00b8O8P028P@o
0fH5S0:d00?<3L`00kH5k005g>bf]kH00m`7U@05gG7MgW400]h01G7NLMia00;N00?Og]h00mh41@05
WmmagW401=h00moNo`04o`@S00?o8b<00R<00onOW`024@EO92<KF`40000VF`03oe^1019K0X43F`03
PE]K01=K00>1Fe/01U/58`087b8OCcm??dl3IP03S4c<00?<10d02;Je]^cL]KJe1KH3k003UMbE00>E
00AagG7M17401MiagmkO00CN00COg]oN0PD00g7NL@04gP03gooo00;o12<00olS8`038`05ob<Sob<0
0_l0214G4AmO7elO72<RF`40000VF`03oe^101AK0X400e^1F`0DF`03PE]K00QK12<011lR7b82?`?B
00O0c<0=c0g<008=00C<CDe=0l001[Je][Ff]`Bf0n`5U@05LMeagW402=h00moNU@02U@07LMeagW7N
L@05o`<S00?o8b<00b<01_lS8b?o8`;o12<01?lA4A43G`037elS01HS9U/100009U/00omKP@0FF`:1
5E/00h5KF`0:F`<S00<O8Sl00Sl5dP03c<3<00;<0fH014e<CD`4`00=]KKl]_bf]kJgk=c/g002U@06
LIEaLMia0]h0177Ngmh4g0BE00=aool00ol48`03ob<S008S00Ko8b<Sob<3o`<S00?o8b<00b<01?mO
Gel57`8S0al:8`9K00>1Fe/0:5/100009U/2o`03PE]K01EK0h4CF`03PE]K00aK00LO8QloCcm?00;B
00AVCVI>1fH2C@><00P=c0g<]_bfo0>f00cl]^cLk=bELIEagW44g003k=cL00CL1?l48`03ob<S00<S
00Go8b?o8`03o`<S00?o8b<00b<02OlS8b?o8omO7`02G`037emO009O00@OGamO1B<6F`03PE]K02QK
0@0002IK00?oFh405e/00h5KF`02PA5K00>1Fe/03E/00alR7`02?`08Ccm?CVI>ITh5IPA<00B<C8a<
0`d00kKl`002`004o;Kl]PCL00FELKNf]`04k0;L1Ol48`03ob<S008S00Ko8b<Sob<2o`@S00?o8b<0
0R<01_lS8b?o8`?o0b<00omOG`03G`037elO008O3E/00h5KF`0XF`40000VF`03oe^101MK00>1Fe/0
0U/2P@mK00>1Fe/03e/00b8O8P05?`05ITiVCVH00dd018a<S4`4S00BC8a<S4c6`<K0o;K<`<bf]KJe
2Ol48`03ob<S00<S00Go8b?o8`03o`@S00?o8b<00R<01OlS8olS00?o0b<00olS8`038`05oelOGal0
0Ul@F`03PE]K02QK0@0002IK00?oFh405e/00h5KF`04F`:13E/00h5KF`0?F`0APE/O8Qm??dloCdiV
CVI=C4d03D`2`006CDa=`<c01?l48`03ob<S008S0_l48`Co00<Sool012<2o`@S1?l00b?oo`048`03
ob<S008S00Ko8b<Sob<2oaAK00>1Fe/0:5/100009U/00omKP@0GF`03PE]K00IK0X4;F`03PE]K00mK
00R1Fe]K8QlR7`<o00E>ITiVCP04C@03S4b<009<00><@T801482C@Co12<00olS8`028`06ob<S8olS
0_l01AmO7eoo00@S00?o8b<00b<2o`@S00?o8b<00R<00olS8`038`?o00@Soooo12<00omKF`0AF`03
PE]K02QK0@0002IK00?oFh405e/00h5KF`08F`:12E/00h5KF`0?F`03PE]K009K00lR7b8O8Sm??fI>
ITiVCD`00b800dloC`03@PGo12<00olS8`028`05ob<Sob<00ol27`03oalO00@O00Go8b?o8`03o`<S
00?o8b<00b<01OlS8olS00?o0b<00olS8`028`;o12<00omKF`0@F`03PE]K02QK0@0002EK0_l00e^1
F`0FF`03PE]K00YK0X46F`03PE]K011K00>1Fe/015/011lR7b83?`06IThR7b8O12800cooo`02o`@S
00?o8b<00b<01OlS8olS00;o00lOGomO7elOGolOGamO7el00_l48`03ob<S008S00Ko8b<Sob<2o`<S
00?o8b<00b<01_lS8b?o8`;o0b<00omKF`0?F`03PE]K02QK0@0002EK00CoFe^15e/00h5KF`0<F`:1
15/00h5KF`0@F`03PE]K00EK00<O8R<00R<0128O8R88o`@S00?o8b<00R<01_lS8b?o8`;o0Ul00olO
7`027`03oalO008O00?o7al00Ql01OlO7aoo00@S00Go8b?o8`03o`<O00?o8b<00R<01_lS8b?o8`?o
0b<00olS8`028`03oe]K00mK00>1Fe/09e/100009E/01?mKFh4GF`03PE]K00iK0X42F`03PE]K011K
00>1Fe/01e/28`Go12<01?lS8b<2o`@S0ol012?oool2G`03oalO008O01?o7elOGomO7elOoelOoamO
7elO00Co00dSoomO7omO7elOGaoo008S00?o8ol00_l48`03ob<S008S00Go8b?o8`02o`mK00>1Fe/0
9e/100009E/01?mKFh4GF`03PE]K011K00>1Fh404U/00h5KF`05F`Co12<00olS8`038`05ob<Sob<0
0_l031mO7elOGamO7elOo`EO00Go7alOo`047`03oaoo00HO00?o7al00Ql00olO7`027`03oalO00@O
0_l48`;o12<4o`038ooo00@S00?oFe/035/00h5KF`0WF`40000UF`03oe^101QK00>1Fe/04E/2PA9K
00B1Fe]K1?l48`03ob<S00<S00Go8b?o8`02o`IO00GoGemOo`05G`03oalO008O00SoGamO7olOG`?o
01/OGeooGamO7olOGamOoelOGaooGamO7olOGol01B<2o`<S00?o8b<00b<00olS8`028`03oe]K00]K
00>1Fe/045/4PA=K0@0002EK00?oFh4065/00h5KF`0BF`>13U/6o`@S0ol48`?o01PSoolOGamO7eoo
GamO7olOGaoo7elOGol5G`03oalO00Co00POGamO7olOo`@O00Go7alOo`047`05oalO7ol011l3o`<S
00?o8b<00R<01_lS8b?o8`;o0b<00omKF`0:F`03PE]K00YK1X4GF`40000UF`03oe^101QK00>1Fe/0
4U/00h5KF`02P@aK00?oGol00b<3o`@S0_l:G`03oemO009O00GoGemOo`03G`03oemO009O00?o7al0
11l2o`@O00GoGemOo`03G`0DoelOGomO7elOoamO7eoo7olOGal48`03ob<S008S00Go8b?o8`03o`<S
00?o8b<00R<00omKF`09F`03PE]K00AK1X4MF`40000UF`;o00>1Fe/05U/00h5KF`0BF`03PE]K009K
0X49F`03oalO008O00Go8b?o8`02o`0Q7elOGamOoelOGomO7elOoamO7olOGaoo7elOoamO7eoo00IO
00?o5ol015l02?lOoamO7eoo11l01OlO7aoo00<O0ol01AlS8b?o00@S1?l00b?oo`048`03ob<S008S
1?l00b?oo`09F`N18e/100009E/00omKP@0HF`03PE]K019K00>1Fe/015/2P@IK00OoGamO7elO00;o
00=O5el00el00omOG`02G`05oemOGol00el01OmOGeoo00AO00GoGemOo`04G`03oalO008O00Co5aLG
1?l00aooG`05G`03oamO00Wo0b<01OlS8olS00;o0b<00olS8`038`03ob<S008S0_l38`03ob<S00<S
00CoFe]K1X4YF`40000UF`03oe^101MK00>1Fe/04e/00h5KF`06F`:10e/00olO7`047`0YoaMO5eoo
GamO7olOGaoo7elOoamO7olOGamOoelOGomO7eooGamO7ol00el00olG5`025`0=oelOGamO7omO7elO
G`02o`03GolO00@O00Ko8b<Sob<2o`@S00Go8b<So`038`04ob?oo`@S00Go8b<So`038`03ob?o00:1
1E/00h5KF`0WF`40000UF`03oe^101MK00>1Fe/04e/00h5KF`05F`Ko00iO7elOGaoo4OlGGaMOo`=O
00GoGemOo`03G`03oemO009O00GoGemOo`03G`05oemOGol015l01OlO7aoo00<G00?o4Ol01Ul3o`03
GalO00<O00KoGamO7el3o`@S00?o8b<00R<3o`048oooo`@S00?o8b<00R<3o`048oooo`<S00?oFe/0
15/00h5KF`0WF`40000UF`03oe^101MK00>1Fe/04e/0185KFe/4o`=O00CoGemO0ol00aoo4@024@0W
oaMO5olOGaoo7elOGomO7eooGamOoelOGomO7elOoamO7olOGaoo009O00?o5aL00QL02_lAoamO7elO
Gol3G`037emO009O00?o7al00al01?lOool48`;o0b<00olS8`028`03ob<S00<S0_l38`03ob<S008S
00?o8b<00R<2o`AK00>1Fe/09e/100009E/00omKP@0GF`03PE]K01=K00B1Fooo11l00olO7`027`0?
oalOoaoo4ALA5omO5eoo00AO00GoGemOo`03G`05oemOGol015l01OmOGeoo00=O00GoGemOo`027`05
oaLG5ol00Q400omOG`03G`03oamO00=O00ko7alOoelOGaoo7elOG`;o12<01OlS8b?o008S00?o8ol0
0_l38`03ob<S008S00Go8b?o8`02o`@S00GoFe]KP@0YF`40000LF`Co1E/2o`03PE]K01EK00>1Fe/0
4e/0187o7el2o`AO0ol01EooomnO00DA02Oo5elGGomO7eooGamOoelOGomO7elOoamO7olOGaoo7elO
oamO7el00_l45`0:oaLA5omO7elOo`9O00@OGaoo15l01OlO7aoo00HO00?o8b<00R<3o`038ooo00@S
00?o8b<00R<4o`038ooo00@S00?o8b<00R<01?mKFh4YF`40000KF`03oe]K009K00CoFe]K0X400e^1
F`0FF`03PE]K01=K00?oGel00el2o`03ginO00NO00_o4ALA5omO5elGo`03G`03oemO009O00GoGemO
o`03G`05oemOGol015l01_mOGeooG`Co0aL00olA4@024@07oemOGomO7`05G`0@oalO7olOGomO7elO
GamO7`;o00TOGolOGamO7ol012<2o`@S00Go8b<So`058`;o0b<00omKP@0YF`40000KF`03oe]K009K
00KoFe]Koe/3PAIK00>1Fe/04U/01olOGamO7ol019l02_nOgiooWmnOgol44@0LoelGGomO7elOoamO
7olOGaoo7elOoamO7eooG`So1142o`0C5olA5a4G4OlOGomO5olOGamOo`03G`03oaoo008O00=Ooal0
11l00omOG`02G`03oalO00<O0_l48`03ob<S008S0ol012?oool38`03ob<S008S0_lYF`40000KF`03
oe]K009K00GoFe]Ko`02F`04PE^1PAAK00>1Fe/04E/00omOG`03G`07omooWmnOg`08W`0;oaLA5a7o
5elGGol00el01OmOGeoo00=O00?oGel00Ul00omOo`03o`@A00Co4A4A0_l44@03oa4A00@A00CoGolO
0QL00omOG`02G`03oalO008O0_l37`05oamO7el00_l03ElOGaooGamO7eooGol012<2o`@S00Go8b<S
o`048`;o12<00omKF`0VF`40000KF`03oe]K009K00GoFe]Ko`02F`04PE]KF`>14E/00h5KF`0@F`03
oa4G00;o00DOomoOo`05W`08gioOomnOgol44@0DoelGGaOo7elOoamO7eooGamOoel4o`@A00?o4A40
0Q401OlA4OlA00;o11402?lG4ALAoaoo0aL02?lOGamO7omO1?l4G`07oalO7olGo`03G`03oalO008O
00Co7alO0_l48`03ob<S008S0ol00b?oo`048`03ob<S008S00?oFe/09E/100006e/00omKF`02F`05
oe]KFol00U/00h5KF`04F`:13e/00h5KF`0?F`03oa4A00<A00CogioO0Yl01=nOgol3W`0?oinOWolG
4ALAoaMO5eoo00AO00?oGol01ol44@;o1143o`074OooWa6O4@02o`@A0ol00a7oo`045`03oemO009O
0_l3G`03oalO008O00CoGaoo0QL03?lOGamOoamO7olOG`<S00?o8b<00R<2o`<S00Go8b<So`058`;o
0b<00omKF`0TF`40000KF`03oe]K009K00GoFe]Ko`02F`03PE]K00IK0h4<F`03PE]K00iK00Oo4ALA
5a4G00GO00goWinOomnOgooOWmoo00DA00Oo5elGGomO00Co0]l00onOW`03W`;o1142o`:O00coWmnO
oilAWa6O4Il2o`8A00Oo5a4G4AOo00<G00CoGamO0_l01AmO7eoo00AO00?o7ol00aL00omOG`02G`04
oalOo`<O0ol00b?oo`038`03ob<S008S1ol38`03ob<S008S00?oFe/08e/100006e/00omKF`02F`04
oe]KF`;o00>1Fe/02U/2P@YK00>1Fe/02e/3o`HA0_l02MnOgioogioOo`03W`03oinO00:O00[o4ALA
5omO5elG0_l03YoOWmnOgonOgioOWmnO0_l00ioOo`04g`0FoinOWonO4IlAWolG4ALA5olG4ALAo`<G
00KoGeoo4Ol5G`03oalO008O0_l35`08oamO7eoo7ol27`<S00Go8b<So`048`;o12<01OlS8b?o00@S
0_l38`03oe]K029K0@0001aK1?l4F`03oe^100iK0h47F`03PE]K00MK1?l44@?o00@Gomoo1=l00onO
W`02W`09oioOWonOgioo00@A00Go5elGo`09g`03oinO00BO00?ogml00]l00onOW`02W`0;oioOWonO
4Ioo4Ol011401_lA5a4Go`@G0_l02ALA5omO7elOo`02G`?o1AL00omOG`02G`;o00<Sob<00b<6o`@S
00?o8b<00R<3o`038ooo00<S00?o8b<00R<2ob9K0@0002AK00?oFh404E/2P@EK00>1Fe/01ol44@?o
11400ooOgP02g`09WmnOomnOgioo00>O00koWinOoa4G4AOoGaOoW`;O00jOgiooWmnOomnOgioOo`;O
00BOgioo1=l00onOW`02W`03oioo00<A00[o5a4GoaLA5a4G1Ol44@03oemO00=O0_l24@03oaLG00<G
00KoGamO7ol38`;o12<01OlS8b?o00@S0_l38`05ob<S8ol012<2o`@S00?oFe/07e/1000095/00omK
P@0CF`>10U/00h7oo`044@03oa4A00?o1142o`KO00GogmoOo`04W`09oioOWonOgioo00DA0_l3g`05
omoOgol00ml00onOW`03W`03omoo00?O00?oWil00il00ooOW`04o`<A00?o4A400Q401OlG4ALA00;o
01>O4OlA5a4GoelOGamOoaLA5a7o00@G00CoGemO0ol48`03ob<S008S0ol00b?oo`038`03ob<S008S
1_l48`03ob<S008S00?oFe/07U/1000095/00omKP@0FF`:100?oWil00ol44@;o01LAoooOg]oNgmko
gmkOoioOWmooWmnOo`03W`0UoinOWolA5a4G4OnOgioOoioOWmoogioOoioOWmoogonOgioOo`05g`;o
00BO4Ioo0a402OlG4ALAoa4G4@02o`04Wa6Oo`DA00OoGemOoa7o00<A00?o5aL00QL01?mO7ol2G`04
7eooo`8S0_l38`03ob<S008S0_l28`;o12<00olS8`028`;o0R<2o`<S00?oFe/07E/1000095/00omK
P@0GF`07omnOgioOW`02o`WO00GogmoOo`03g`03omoO00;O00koWinOoioOWonOgioOo`@A00?ogml0
0ml01OoOgmoo00?O00GoWinOo`03g`05omoOgol01Il2o`044IlAo`@A01So4A4AoaLAoioo4IlAWolG
4ALAoamO7ol24@05oaLA5ol011L2o`057elO7ol00Ql01OlS8b?o00<S0_l48`05ob<S8ol012<2o`<S
00Go8b<So`048`03oe]K01aK0@0002AK00?oFh405U/00onOW`04W`0@omkOg]oogmkog]oNgmkOgP;O
00gNgonOgioOoioOWmoo00>O02CoWinOoaLA5ooNomnOgioogioOomnOgonOgioog]oNomnOgol4g`08
omooWa6O4Ol34@05oa4G4AL00_l2W`06oilAWa7o11401?mOGol34@05oa4A4Ol00QL3o`9O00LOGomO
7elO00?o00<Sool00b<00olS8`028`?o00<Sool00b<00olS8`028`Ko0b<00omKF`0KF`40000TF`03
oe^101EK00[ogioOWmnOomoo0ml00ooOg`09g`04omoOo`CO00?oWil00Yl02OoOWmoogioOo`034@03
omoo00CO00?ogml00]l01OoOgmoo00:O00GogmoOo`04g`0=oinOWonOoa6O4Ioo4@08o`0@WmnOgonO
4Ioo5a4G4OlOo`DA1_l01elGoeoo7ol00al38`03ob<S008S0_l28`;o0el00olS8`028`;o0R<2o`<S
00?o8b<00R<2o`8S00?oFe/06U/1000095/00omKP@0EF`03o`Go00;o00>Oomh00]h07MoNgmkOg]oo
gmkOomoNgooNgmkogioOoioOWmoo00>O02GoWinOoaLAomoNgonOgioOoioOWonOgioogooOg]oNgonO
gioo00;O00WoWmnOoa6O4Il01?l31@03oinO00>O00Ko4IlAWol44@;o11400aOo4@024@05oelGoel0
0ol01ElOGaoo00<S0_l65`03oalO00<O0_l38`05ob<S8ol012<2o`<S00Go8b<So`0KF`40000SF`04
oe]KPAAK00?o1@D00`D01OoOg]oN00CO00Cogmoo0ml01OoOgmoo00?O00?ogml00]l03onOWioogioO
omnOgolAo`04g`03omoO00;O00GogmoOo`03g`03oioo00GO00OogmoOoioo00BO00OoWa6Ooioo00;O
017o1@D5oioOWmooWa6O4OlA5`03o`034Ooo00@A00Oo5a4Goeoo008O00=Ooal011l2o`DG00Go5aLG
o`05G`03oeoo00<S1_l38`03ob<S008S1_lIF`40000SF`04oe]KPAAK00?o1@D00`D00ooNgP02gP0M
omkOg_oNgooOg]oogmkOomkOg_oOWmnOomnOgol00il00onOW`02W`;o01;NgmkOoioOWmooWmnOgooO
Wml2o`0:gmkOg]ooWmnOg`?o00JOgioo4Il3o`04gmkOo`<500?oWil00il01OnO4IlA00;o00?OWml0
0_l01Q4G4ALAo`<A00Co5omO0al01OlOGolA00<G00?o5aL01QL00olO7`027`03oalO00;o0b<01?lS
8b<2o`8S0_l38`03ob<S008S00?oFe/05U/100008e/01?mKFh4CF`03o`D500<50_l01MoNgmko00?O
00Cogmoo1=l01?oOgol3g`03omoO00;O00?oWil00Yl01_nOgiooW`?o1]l00ooOg`02g`03omoo00Ko
1ml00ooOo`02o`03gonO00>O1?l4g`0Hoe/51OnOgioOWolAWa7oWmooWonOgioo0U/24@Go00<OGel0
0Ul01_lOoa4Go`LG00Go5aLGo`03G`04oemOG`8S0_l28`;o0b<01?lS8b<2o`8S0_l38`03oe]K01EK
0@0002=K00CoFe^14U/00ol51@041@03omkN00?N01oog]oNomkOg_oNgmkog]oNomoNomnOgioogioO
WonO00Co00cOg]oNomoNgmkogil4o`05gmkOg_l00ml2o`04gmkOgP?o19l5o`08gooOomoNgol31@03
oinO00>O00CoWa7o19l01?nOWil2F`;o00LAoaMO5eoo009O11l01OlA5a7o00<G00Go5aLGo`035`05
oalO7ol00al38`03ob<S008S0_l28`;o0R<01OlS8b?o00@S00?oPH400X4BF`40000SF`04oe]KPA9K
00?o1@D00`D02OoNgooNgmkOo`02g`05omoOgol00ml01OoOgmoo00?O00GogmoOo`04W`;o00=ag_l0
1mh3o`06goooLMko1mh3o`0>g_oog]oNgooOWmoogmh2o`03gooN00;N00KogmoOoh421@06omnOgioO
0_l00ioOW`02W`0@omnOgioOoa6O4OlGGaOo7`AO00Oo4ALA5a7o008G00Go5aLGo`035`05oemOGol0
0Ul00olS8`028`;o0b<01OlS8b?o00<S1_l2PAMK0@0002=K0_l00e^1F`0@F`;o10D01OoNg]ko00CN
01_ogmkOomoNomkOg_oNgmkogmkOoioOWooOWml00_l4gP06omoNgmkO0_l01=iag_l4gP07omoNgmkO
o`02gP;o00?Oomh00mh01?nOWol5gP03omoO00;O00Gog]oNo`031@03oinO00>O00CoW`Go0ml00onO
W`02W`09oa6O4IooGaOo009O00_o7aoo4OlA5a4Go`025`05oaLG5ol00aL01OlO7aoo008O0ol38`03
ob<S008S1_l2PAiK0@0002=K00CoFe^14E/00ooNo`02o`0;1OoOg]oog]oNgol00ml01?oOgol3g`05
omoOgol00ml00ooOg`02g`0;oiooLMkoLMiag_l00mh01?mag_l3gP06og7NLMko0mh03OoNLMiag_oO
g]oNgmh00_l01moNgmkOg_l01=h01OoOgmoo00<500[ogioOWmoo1Moo0il04ooOWmnOoilAWa6Ooeoo
GaooGol00a401OlA5a7o008G00?o5aL00QL01olG5aOoGol00Ul00olS8`028`03ob<S00;o0h4UF`40
000SF`03oe^1015K00OogW7NLMko00GN01cog]kNomoNgooOg]oogmkOomoNomoNgonOgioO0_l3gP03
omkN00?N00?ogol00mh01OmagW7o00GN00?ogol01]h00ooNgP04gP03omkN00CN0_l4g`06omiKg]oo
0`D02_nOWioo1MnOgol3g`0<oinOoiooWa6O4OlG1Ol44@05oaLA5ol00aL01OlG5aOo00<G00?o7ol0
0Ql00b?oo`03P@=K00>1Fe/09U/100008e/00omKP@0AF`03omkN00?N00cog]oNgmkogmkOg_l2g`05
omoOgol00ml01?oOgol3g`03omoO00;O01?oLMiagW7ogW7NLMkoLMiagW7o00?N01oogW7NLMkogW7N
LMiaomkog]oNgmkog]oNgmkOomko00CN00GogmoOo`031@07oioOWooOF`02g`07oinOWonOo`03W`04
oilAW`;o00DOWinOo`044@05oa4G4Ol00aL01OlG5aOo00<G00CoGomO2U/00h5KF`0VF`40000SF`03
oe^1015K00SogW7NLOmao`CN00?og]h00]h05_oNgooOg]oogmkOomoNomoNgonOgil2o`GN00?og]h0
0]h2o`GN00GogW7No`04gP;o1]h00ooNo`04gP03omko00CN00CoLMko1=l01OoOg]oo00<500?oWil0
0_l01IoOWmoo00?O00WoWonOgioo4Il00ol01Ioogioo00DA00Co4AOo0aL01OlG5aOo00<G00?o7ol0
2e/00h5KF`0VF`40000SF`03oe^1011K00?og]h00mh03OmaomoNgmkOomkOg_l00]l01OoOgmoo00?O
00GogmoOo`03g`03omoo009a00[ogW7NLMkoLMko0W401_oNLMiao`CN00CoLMko0W405?magW7Nog7N
omkOg]ooLMkog]oo0mh00ooNgP02gP05omoOgol00`D01_nOo`GOo`?O1_l5W`;o00DGomnOo`03W`03
oa4A008A00Co5a7o0aL01OlG5aOo00<G00?oGol02e/00h5KF`0VF`40000SF`;o00>1Fe/03U/02_ma
gW7Nomiag_l4gP0GomkNg_oNgooOg]oogmkOomoNgooNgmh00_l01G7NLMko00CN00Sog_magW7No`CN
00coLMiaomkoLMiag_l2gP06omiagW7o0]h00ooNgP02gP07omkogW7No`04g`06omoNgmko0`D2o`;N
00GogioOW`02o`<500CoWmnO1?l4W`04oioOo`@A00Go4ALAo`025`03oaLG008G00Go5aLGo`0<F`03
PE]K02IK0@000003FomK00AK00CoFe]K0_l00e_oF`0CF`03oe^1011K00?og]h00]h00omaL@02L@09
omoNgooNgmko00?O00GogmoOo`03g`03omoo00Go1W400ooNL@03o`Ia00GogW7No`02gP?o1W404Oma
omiagW7ogmkogW7NLMko00GN00?og]h00]h00ooOo`06o`05gmkOg_l00]l00ooNo`031@04oinOo`CO
00FOgioOo`02W`03oa4A008A00Go5a4Go`035`03oaOo00Ko3E/00h5KF`0UF`4000000e_oF`04F`05
oe]KFol05e/00omKP@0;F`So00Qag_oNLMiao`?N00?og]h00]h01OoOg_oN00So0g43o`=a00CogW7N
0_l4L@;o00AagW7N1_l4L@;o00eagW7Nog7NLMiaomko00GN0_l01W7NLMiao`CO0ol00mkogP02gP03
omkN00;N00KoWooOg_l31@08oiooomnOgol4W`05oioOWol011400olGo`08oa9K00>1Fe/09E/10000
00=Koe/015/01OmKFe_o01MK00?oFh403E/3o`=a0_l6L@06omkOg_oO1ol4L@?o0W42o`=a0_l4L@03
og5a00?o0g42o`Aa00CoLG5a0_l4L@;o17401OmagW7N00;o00EagW7No`02L@03omkN00;N00Gog]kN
o`02gP0=og7og]oNomoNgmkOo`03gP03o`D5008500Cogmoo0ml01OoOWmoo00>O00Co4A4A0ol015lG
Gol3G`03oe]K015K00>1Fe/09E/1000000=Koe/015/01OmKFe_o01IK00CoFe^145/2o`0:UMcoLMia
gW7No`;N0ol4L@03og5a00?o1742o`=a00CoLG5a0_l4L@?o00=aool00g42o`Aa0ol00g7oo`04L@;o
0g43o`04g_ooo`;N00[ogW7NLOmagW7o0]l01?oOgol2gP05omkNg_l01Mh01OoNgmko00@500Sog]oo
WmnOo`>O00GoWmnOo`024@;o00TAoaMO5omO7ol055/00h5KF`0UF`4000000e_oo`05o`=K00?oFe/0
55/01?mKFh4@F`03oiFE00:E00?oLG401742o`03gG7M00?o0g43o`03LOoo00:E00SoUG6ELIEaU@;o
00=aool01742o`=a0_l2L@;o1742o`=a0_l3L@;o0g42o`=a0_l5L@03omkN00;N0_l3gP0<omiag_oO
g]oog]oN0_l3gP03o`D5008500Cogmoo0ml01OoOWmoo00BO1?l01QOoGaMO5`;o5E/00h5KF`0UF`40
00000e_oF`04F`05oe]KFol05U/01?mKFh4@F`0;ombEg9GLog7NLOl00YD01omagG7MLMd00_l00kGo
U@02U@03oiFE00:E00?oLG4017400omaL@03L@;o0g42o`Aa0_l2L@;o0g42o`Aa0_l3L@;o0W42o`Aa
0_l00miagP05o`04g_oOo`CN00Gog]kNo`03gP;o00GNgmkOo`021@0:omoNgonOgioOo`:O00GoWmnO
g`02o`@A00?oGol00_lFF`03PE]K02EK0@000003FomK00AK00?oFe/00ol5F`Ko0U/4o`AK0ol00h5K
F`0?F`03oiFE00>E00goLOoLUMbEog7MLOn<00>e00Kog9GLUOl3U@0Jog6ELIEaoncoLIEaUG7ok=c/
og6ELIEaUG42o`03UOnE00:E00SoUG6ELIEaU@;o0g42o`=a0_l3L@;o0W405_oNLMiaomkoLMiag_oO
g]oog]oog_l4gP03o`D500;o0]l00ooOg`02g`05oioOWol00Yl01ooO4OlA5a400_lIF`03PE]K02EK
0@000003FomK00QK00?oFe/015/00omKF`04F`03oe]K009K00CoFe]K184AF`08oiGLUMbEg?l6U@03
og7o009<00Go3KD=o`03U@03oiFE00:E00?oLG400W400oo/o`04L@;o1>`00omaL@04L@05oiFEUOl0
0iD00omaL@04L@03og5a00;o0W42o`Aa00SoLOmagW7No`?N00?ogol01=h01ooNg]kog_l00mh01OoO
g]oo00850_l02=kOg_oOWmoo0il01ooOoilAWol00Q400omKF`0IF`03PE]K02EK0@000003Fooo00Go
0e/00omKF`05F`03oe]K00=K00?oFe/00U/01OmKFe_o009K0h4?F`03oiFE00BE00WoUMbEg9GLUOl0
0h`02_ne]KGoUMbEg?l3U@0<oiEaUOoLk=coUG6E0_l03NcLk=coUG6ELIGog?l00YD03OnEUIGoLIEa
UG7oLID00g42o`=a0_l2L@03og5a00=a00?oLMh00ol02]iagW7NLOoNgmh2o`04gmkOo`?N00?o1@D0
0_l3g`03omoO00;O00?ogil00ol01Q6O4OlAoaaK00>1Fe/09E/1000055/2o`=K00?oFe/00U/01OmK
Fe_o009K00>1Fe/00h4<F`09oiGLUMbEolco00JE00WoC4a<o`fe3Ol019D00onEU@02U@03og7o00C/
00KoLG7o]_l5k003og5a009a00?oUOl00iD01OnEUIGo00Aa00CoLG5a0_l2L@;o17401?maLG42o`0;
gW7oog7MLMgog]l00]h6o`?N017ogmkOo`Gog_oNgmkogioOW`04o`05WonO4Il00_lMF`03PE]K02EK
0@0001IK00CoFe_o15/01OmKFe_o009K00>1Fe/00e/4P@UK00?oUID00YD02?l=ombEg9GL0_l3S00;
okFe]OnEg9GLUOl00iD02omaoncLk=c/og7o00:f00kog>cLk?maUG7oUMbEo`:E00[oUIFEoiEaUOnE
0_l0277oLMeagG7M0_l2L@;o00aaUOnELOmagG7MLMd3o`0;gW7NomkOomoNgol00mh01_l5omoNo`;O
00OogmoOomko00CO00?oWol07e/00h5KF`0UF`40000GF`03oe_o00AK00GoFe]Ko`02F`03PE]K00MK
0h46F`08ombEg9Goc?l5U@;o0d`01_l=]@feo`BE00?oUID00ol6k003og7o00:f00?ok>`00n`00oma
o`04U@05oiFEUOl00iD00omao`02L@0;og5aLOmagG7MLOl00iD01_maUG6Eo`9a00WoLMeagG7og_l0
0mh01?oNg_l3gP07omoNgol5o`02gP07omoNomnOo`02gP05oioOWml00_lPF`03PE]K02EK0@00019K
00?oFe/00U/00omKo`04F`07oe]KFomKP@0=F`>10e/03OnEUIGoc0g<oiGLUM`00_l3S003okFe00:e
00Kog9GLUM`2o`:f00Wog>cLk=c/g?l00kH03ooLk=c/g?nEombEg9GLo`02U@0CoiFEUOmaog6ELOma
UG7oLMeao`05U@0Kog6ELIGoUG7oLMeaomiaomkog_oNgooOg]oo00CN0_l00moNo`03g`;o00CNgmko
1=l00omKF`0OF`03PE]K02EK0@00019K00?oFe/00U/00omKo`04F`04oe]KF`;o00>1Fe/03U/3P@05
FonEg?l00l`01onEUIGoC?l00d`01_l=]@feo`FE1;H00oo/k005k005okJf]_l01^`00onEU@04U@03
oiFE00Oo00FELIEao`03L@06og7oUMco0iD01_nELIEao`=a00?oLOl00mh01OoNg]ko00?N00Sog]kN
omkOgP;o0]h01ooOg]oogol00]h01_nOgioOob5K00>1Fe/09E/100004e/4o`=K1?l4F`03oe^101=K
00n1oiFEol`=c?nEg9GoC?l00h`00one]@03]@04oiGLU@;o1;H02?o/g>cLk=co0kH02_oLk=c/g>co
]n`2o`03UMbE00;o00BEomco0iD01OnELIEa00Go19D02OnEUOmaUG6EL@06o`0@LMiaomiagW7ogmko
g]oNo`?N00Gog]oNo`02g`08omkNomoNgol2g`03oe]K021K00>1Fe/09E/100008U/00omKP@0DF`03
oiGo00G<00KoUIGoC?l3C007o`fe3KD=o`03U@;o1;H00oo/k003k0;o0kH00oo/k004k004onbgk0;L
0_l00iGoo`02g00CoiGLUOmaUG6EombEg?oLUMbEo`03U@05og6ELOl00W401OmagW7o00?N00Kog]kN
omh:o`CN0ol2g`08omkNg_oOWolRF`03PE]K02EK0@00029K00?oFh4055/02onEo`g<3L`=omco009<
00GoS8b<o`05]@04oiGLo`:e00[o][JfoncLk=c/0_l3]P0<omc/g>cLk?ngk;Oo0m`2o`?L00?oUID0
0YD02_maUOoLombEg?l4U@0;oiFEoiEaog6ELOl00g401?oNLMh6o`07gOmagW7No`02gP04omkOgPCo
0mh01?oNgol2g`03oe]K021K00>1Fe/09E/100008U/00omKP@0EF`;o1L`01_nEode<o`=<00go3KD=
]@goUOl=]@go00>f00?ok>`00n`00ond]P02]P03onc/00?/00Oo]nbgg?o/00;o00>Eom`00m`04ooL
UMcoUOoLk?nEg9GLombEg?l00YD00omao`04L@05og7NLOl00mh04?nEUIGogG7Momiag_mag_l2gP05
og7ogol00ml01_oNg_oOob=K00>1Fe/09E/100008E/01?mKFh4EF`08ol`=c0g<3L`2o`9<00GoS8b<
o`06]@;o0kD03Onf][Kok=c/g>co]?l00kH03oo/g>cLonbgk?oLk=c/o`05g003oiFE00:E00?og=`0
0]`01OnEg9Go00:E1_l01YGoLIEao`=a00CogW7o19D02OmagG7ogW7No`03gP;o0W400ooNo`03gP06
omkOomoo8e/00h5KF`0UF`40000QF`04oe]KPAEK00?oc<`01L`01Om<CDco00=<00go3KD=]@feokD=
]@go00Bf00Gok>c/o`02]005okJf]_l01>`01Ongk;Oo00?/00?Lk?l01=`01?oLUM`2o`09k=c/g?oL
UMbE00?o0iD01?nEUOl4L@04omiagP?o1ID02_magOoNLMiaomh3o`9a00?ogol00ml01?oNg]h2ob=K
00>1Fe/09E/100008E/2o`03Fh5K01AK00Woc0g<3L`=c?l00d`01On<S8co00Je00?o]KD00[D00onf
]P02]P05omc/g?l00[@03onf][Kok=c/g?o/]oo/g005k005omcLg?l00YD01?oLk?l4g007ombEoiGL
o`03U@06oiFEog6E1ol2g003oiFE00:E00CogG7M1_l3U@;o0mh02OoNg]kogmkoP@0TF`03PE]K02AK
0@00025K00CoFe^15E/00oo<c005c005oda=C?l00d`03Ol=]@fe3KGo]@fe3Ol01;H01Oo/k>co00:d
00Go][Jfo`04k00=okO/oncog>cLk=c/o`03g0;o1>`01oo/g>coUOl00iD00onEU@07o`07g?o/g>cL
o`02g003oiFE00:E00SoLMeaoiGLo`:E0_l2U@06omkOg_oO1_l00h5KF`0RF`03PE]K00iK1X4@F`40
000QF`04oe]KPAEK00Woc0g<3L`=c?l00d`01On<S8co00Je00?o]KD00kD02Onf][Kog>cLo`02]00?
oe^f]_o/g>cLonbgoe_o00O/1?l01]c/g>cLk0Go00G/oiGLU@02o`06UG6ELIGo0n`01OoLg=co00;L
00?oUID00YD01?oMLOl2U@03og5a009a00Cog]ko0mh2o`IK00>1Fe/08U/00h5KF`05F`V15U/10000
8E/01?mKFh4EF`03olc<00G<00GoC4e<o`03C007o`fe3KD=]@02o`053KD=]Ol01;H01?o/k?l2]005
okJf]_l00n`05?o/]omKokKok=c/g>cLomc/g>cL0ol00kNfo`04g00:oiFEomc/oiEaU@;o0m`01OoL
k=co00?L00?oUID00YD2o`04UMbEo`Aa00OoLMiaomoo00QK00>1Fe/085/:PAmK0@00025K00CoFe^1
5E/02Oo<3L`=c0g<o`03C005ohb<S?l01[D2o`Be00?o][H00[H00oo/o`03]00@okJf]_o/g>co]nbg
okJgo`G/00?o]ol00n`00ooLo`03]P03onc/00;/00?oUOl00m`01_maUOngo`?/00Gog=cLo`03g003
oiFE00Co19D01OmaLG7o00?N0_l:F`03PE]K01EK2X42F`03PE]K02AK0@00025K00CoFe^15E/00oo<
c004c0;o00A<CDco0d`03_l=]@fe3Om=o`fe3KGo1;H00oo/o`04]0;o0[H07Oo/k?o/]onf]kJgomc/
g>co][Oog?ne]_nf]kKo00GL0_l02^cLk?nELOnf]ol2g005omc/g?l00m`03?nEoooLk=cog9GLo`=a
00GoLMiao`0;F`03PE]K00aK2H4<F`03PE]K02AK0@00025K00CoFe^15E/01oo<3L`=c0d00_l3C005
ohb<S?l01KD00omVo`04]@03okJf00:f00?ok?l01;@04?nf][Kog>co]kFfokJg]_l3k009okJg][Oo
]KJe00;o0[H00oo/k003k0;o1=`2o`04][Nfo`;/00?og=`00]`01?oLg=`2o`CL00GoUIFEo`04L@03
omko00aK00>1Fe/00U/:PAEK00>1Fe/095/100008E/2o`03Fh5K01AK00?oc<`01<`2o`05C4e<COl0
0T`03_l=]@fe3Om=o`fe3KGo1;H00oo/o`04]005okJf]_l00^`06_o/]U^fokJg]_o/okJg][NfokJe
][Go]kKo1=`03OoloncLk=co][Nf]ol00m`01Oo/g>co00?L00_ok>cok=cog9GLo`04L@;o25/:PAmK
00>1Fe/095/100008E/00omKP@0FF`07ol`=c0g<3@02o`A<00CoS8co1KD01?mVCOl4]@03okJf00:f
00?o];@00k@07_nf]KKog?o/][Ff]E_o][Ook?ngFkNfol3o][Ffo`>f00Ook>c/okKo00CL00Jf]kJg
]_l3k005omcLg?l00m`01?o/g?l2g005oiFEUOl00g42o`V11E/00h5KF`0QF`03PE]K02AK0@00025K
00?oFh405U/00oo<c004c0;o00E<CDa=o`02C00?o`fe3KD=odeVokD=]@go00Bf00?o];@00k@02?nf
3KKok?ng1[H6o`0>]kKool3o]KJeokNf]ol3g00=oocok=c/g?nf]kJgo`03g005oncLk?l00]`03oo/
k>cok=c/oiGLUOmao`02P@iK00>1Fe/08E/00h5KF`0TF`40000QF`03oe^101IK00Ooc0g<3L`=00;o
14`01?n<S?l5]@04ofI=o`Be00?o][H00[H00ond]003]00DokJf]_oLonbf]KJe][Go]KJe][D2o`08
]_o0okJe]_l3]P08onc/oobfo?l2g008okKo][Nf]ol2k005omcLg?l00]`2o`03k=co00?L00CoUIFE
0_lAF`03PE]K025K00>1Fe/095/100008E/00omKP@0FF`03olc<00C<0_l01Da=C4go009<00oo3KD=
]@goCFKo]@fe3Ol00kH2o`Fd00Ko][Jfon`2o`Jf0_l5]P0=okKo`?ne][Go]kJgo`02g00?okKl]_oL
k?neokNf]kKo00;L00Gok=c/g002o`03g?o/00;/00Sog>coUMbEoa9K00>1Fe/08E/00h5KF`0TF`40
000PF`04oe]KPAIK00Ooc0g<3L`=00;o14`01?n<S?l5]@04ofI=o`Be00Oo][Jfol3o00Bd01Oo][Je
omcoa_ne][FfokCo][Ff]Oneo`02`005okJe]_l00kH02?o/k?ol]_co0]`02?nfokJg][Oo0n`01?oL
g=`2o`06k?o/g>co0]`01OnEUIGo019K00>1Fe/08E/00h5KF`0TF`40000PF`04oe]KPAIK00?oc<`0
1<`2o`05C4e<COl00T`03ol=]@fe3Om=ITgo3KD=o`02]P04ol36o`Bd00Go][Je]P02o`03`?nf00>f
00Co];Co0[H01?nf]_l3`003okJe00;o01Bf]ooLoobfo;Kog?nf]Ong][Nfo`?L00?og?l00ol00mco
k002k007omc/oiGLo`0CF`03PE]K025K00>1Fe/095/1000085/01?mKFh4FF`07ol`=c0g<3@02o`A<
00CoS8co1;D01_m=ITeVo`Be0_l3`003okBd00>d00go][Jfol36okFf]KKo00:d00Oo]KKo][Go00?0
00?o]KH00_l2]P0Bonco]_bfFooLokFf]Ong][Oo0n`2o`0:][Nfoncok=c/o`?L0_lDF`03PE]K025K
00>1Fe/095/1000085/2o`03Fh5K01IK00?oc<`00/`02?loCom=C4go0T`03ol=]@feofI=ITgo3KD=
]@02o`04a/36o`Fd00So][JeolK0o`>f00Oo];BdokKo00>f00co`<30okJe]_nf]kH2o`05o;Kl]_`0
0_l02[Je]_nf]kJgom`2o`>f00Cok=co0n`01OoLk=co01EK00>1Fe/08E/00h5KF`0TF`40000PF`04
oe]KPAMK00Ko3L`=c?l2C`05oda<C?l00X`00one]@02]@06odeVCFKo1;D00oo0`003`003okBd00:d
00?o]_l00_l01l36okFf]Ol01;@3o`03]_o000?000Go]KJeo`03]P;o00nfo;Kl]_nf]KJeokNf]kH0
0_l2]@04okJgo`?/00Oog>cLomco01IK00>1Fe/08E/00h5KF`0TF`40000PF`04oe]KPAMK00?oc<`0
0/`02?loCom=C4go0T`03_l=]@feofI=ITgo3KD=0_l01/36`<K0o`Bd0ol01/K0a/36o`:f00?o];@0
0[@00`g<3@02o`C000So][FfokJg]P;o00kl]_bfo?ne][FfokJg]P;o00@=]@go0[H2o`03g>co00?/
0_lGF`03PE]K025K00>1Fe/095/1000085/01?mKFh4GF`06o`g<3Lco0Tl01Om<C4co00:<00?o]KD0
0[D02Om=ITeVCOneo`02C@03ol3000;000Ko];Bdodd2o`08`<K0a/3o]_l4]0D=00?o`<000l001?nf
]Ol3]P;o012fo;Kl]_nf]KJeokNfokGo1;D00ongo`08oaQK00>1Fe/08E/00h5KF`0TF`40000PF`04
oe]KPAMK00?oc<`00/`02?loCom=C4go0T`02ol=]@feofI=ITeV00;o0d`01_o6`<K0o`:d00goCDgo
?oo0a/36okKo00>d00Goc0g<3@02o`G000ko]KKo][Ooa_ol]_bfo0;o00Bf]KJe0_l02KD=]One3KGo
]P02oamK00>1Fe/08E/00h5KF`0TF`40000PF`04oe]KPAMK00Ko3L`=c?l2C`05oda<C?l00X`00one
]@02]@07odeVCFI=o`05C@03ol3000;00_l04De<COm?olK0a/3o]_ndC<co00@=0_l5`004okJeo`:f
00go`<3oo;Kl]_o0okJe00;o00Je3KD=]Ol2]@?o85/00h5KF`0RF`03PE]K02=K0@0001=K00CoFe]K
1?l5F`04oe]KPAMK00?oc<`00/`02?loCom=C4go0T`03_l=]@feofI=ITeVodaK0d`01Oo0a/3600;o
0dd02_lool36`<K0ok@2S0083Lco3LcoCOl5`004okFf]@;o00_0a/3o]_bfol3<`002o`043L`=c0;o
00<=]Ol01?lPF`03PE]K029K00>1Fe/08e/100004e/01?mKFol4F`03oe]K009K184GF`06o`g<3Lco
0Tl01Om<C4co00><00_o]KFeodeVCFI=o`03C@04Fde=o`;0017oCOm=C4goCoo6`<K0a_m<S003c006
o`goCDco1L001?nf]KH2o`?000Soo;Klolc0c0;o0`d00oo0o`03]@04okKoPB1K00>1Fe/08U/00h5K
F`0SF`40000?F`Ko00=Koe/00e/00omKF`02F`03oe]K00F14e/00oo<c002c008ocm?ode<COl3C00;
okD=]OmVCFI=I_l01T`00oo6o`02CP0=ode=COlool36`<K0o`02S006o`g<o`go0dd00oo0`003`003
okJe00;o00_0a/3o]_bfol3<`0023@06olco`<co1;D2o`03PE]K01iK00>1Fe/08U/00h5KF`0SF`40
000?F`05oe]KFol00U/00omKF`02F`03oe]K009K00?oFh401E/5P@iK00Ko3L`=c?l2C`05oda<C?l0
0h`02one]OmVCFI=ITgo00M=01CodTi=ode<COm?olK0a/36odb<c0Co00E<CDa=o`05`0Go0l002?ol
]_coc<3o0l`2o`03c<3o00Be00?oFh4085/00h5KF`0RF`03PE]K02=K0@00011K00CoFe_o0U/00omK
F`02F`03oe]K009K00?oFh402U/5P@UK00?oc<`00/`02?loCom=C4go0d`02One3Om=ITeVC@02o`M<
00GodTi>o`02C@0:odlool36`<K0o`:<16H5C@03ol3000?00_l03Ha<ol36`?nfo;Ko`<`010d01_o<
`<c0o`>e00?oFh4085/00h5KF`0RF`03PE]K02=K0@00015K00?oFol00U/00omKF`02F`03oe]K009K
00?oFh403e/5P@AK00Go3L`=o`03C`05oda<C?l00h`02One]OmVCFI=IP02o`M=00SoCDi=ode<o`9?
00Woa/36`<KoC8`016H01Te<CDa=o`G00_l2C00;ol30`?ol]_o0c<000/`02;Ffol3<`<co0kD00omK
P@0PF`03PE]K029K00>1Fe/08e/100004E/00omKo`02F`03oe]K009K00GoFe]Ko`02F`03PE]K019K
18403Oo<c<coCcm?ode<COl00d`02One3Om=ITeVC@02o`M<00GoCTi>o`02C@0;odlool36`<K0oh`0
1FH00om=C@02C@03ol3000?00_l048a<ol36`?nfo?o<`<K0]KH2o`05c<3<`?l00[D01?mKFh4PF`03
PE]K029K00>1Fe/08e/100004U/2o`9K00?oFe/00U/01OmKFe_o009K00>1Fe/05U/01Ol=c0go00=?
00GoC4a<o`03S00<okFeofI=ITeVob3o1Td02?m=CTgoCDco0Tl02?o6`<K0oha<0VH02OmVI_m<CDa=
o`04`003odco009<01Go`<30oobfol3<`?nfodco`<c0c?l00[D01?mKFh4PF`03PE]K029K00>1Fe/0
8e/100004e/01?mKFe/4o`AK0_l00e^1F`0GF`0=olc<c?m??dooCDa=o`03C00<okD=odeVCFI=ocoo
1D`01OoBCTko00==00WoCcoo`<K0a_l00X`2IP04ofIVo`A=00?o`<000/004?n<oha<ol36`?nfo?o<
o`d2o`08C4goc<3<`?l2]@04oe]KPB1K00>1Fe/08U/00h5KF`0SF`40000OF`04oe]KPAQK00Go3L`=
o`03C`05oda<C?l00h`03?ne]OmVCFI=I_lPo`E=00WodTe>oda=C?l00Tl02?o6`<K0oha<0VH02OmV
I_m<CDa=o`04`003odco009<00Wo`<30oobfol000/`00om<C002C005olc0c?l00[D01?mKFh4PF`03
PE]K029K00>1Fe/08e/100007e/01?mKFh4HF`0=olc<c?m??dooCDa=o`03C00<okD=odeVCFI=ocoo
1D`2o`9>00goCDe=odlool36`<Ko00:<1VH01Om=CDgo00C000koS?n<C?o0a/3o]_o0o`8=00coCDa=
C?o0c<3o]Ol3F`03PE]K01iK00>1Fe/08U/00h5KF`0SF`40000OF`04oe]KPAQK00Go3L`=o`03C`05
oda<C?l00h`03?ne]OmVCFI=oclPo`E=00WoCTe>oda=C?l00Tl02?o6`<K0oha<1VH01Om=C4go00C0
00?oC?l00T`01oo0`<3oo?l00l`2o`A<00Ooc<3<okGo00=K00>1Fe/07U/00h5KF`0RF`03PE]K00eK
284>F`40000OF`04oe]KPAQK00goc<c<odloCom=C4go00=<00co]@goCFI=I_lP?ol5C005odi>C_l0
0dd02om??oo0a/36ohco00IV00GoCDe=o`04`00:ohcoS4co`<K0aP;o00?03@d00_l02De<CDco`<c0
c002o`=K00>1Fe/07U/00h5KF`0RF`03PE^100f15U/100007e/01?mKFh4HF`05o`g<3Ol00dl01Om<
C4co00><00co]Om=ITeVCOlo8?l5C@09odi=C_m<CDco009?00Soa/36`?n<o`=V00WoIVKoCDa=C?l0
0/001?m<C?l2C0;o0l03o`04c?mVo`A<00Goc<3<`002o`=K00>1Fe/07U/00h5KF`0FF`j195/10000
7e/01?mKFh4HF`0=olc<c?m??dooCDa=o`03C00<okGoITeVCFKo83oo1D`01Om>CTko009=00go?dlo
ol36`<KoS6Ko009V00CoIVKo14d02Oo0`?m<S?n<C002o`03a/3600;o00m=3OmVode<CDa=olc0c?l0
15/00h5KF`0NF`03PE]K00QK3X4<F`03PE]K02=K0@0001mK0_l00e^1F`0GF`04o`g<o`A?00GoC4a<
o`03S00<okGoCFI=ITgo?b3o14d2o`07CTe>oda=o`04C`08ol36`?n<C_l2IP09ofIVode<CDco00;0
00CoC4co0T`2o`?00_l01Tgo@VI2o`A<00Go`<c0o`04F`03PE]K01YK3h4JF`03PE]K02=K0@0001mK
00CoFe^165/03Oo<c?loCcm?ode<COl00d`03?neofI=ITeVob0oo`A<0_l3CP0@ode=ocm??dooa/36
ohaVo`9V00CoIVKo14d02Oo0`?m<S?n<C002o`03a/3600;o00><IVH00VH02_m<CDa=olc0c?l4F`03
PE]K00aK3X44F`03PE]K029K00>1Fe/08e/100007e/01?mKFh4HF`04o`g<o`A?00GoC4a<o`03S00<
okGoCFI=ITgo?b3o14d2o`07CTgoCDa=o`04C`08ol36odaVC_l2IP09ofIVode<CDco00;000CoC4co
0d`03?o0`<3oC?mV@VI2o`A<00Co`<co1E/?PA9K00>1Fe/08U/00h5KF`0SF`40000OF`04oe]KPAQK
00goc<co?dloCom=C4go00=<00co]OmVCFI=I_lP?ol4C0;o0Th04Om=CDgo?dloCoo6`?n<CVKo009V
00CoIVKo14d04?o0`?m<S?n<C8coa/36odd2o`=V00WoC4e<COo<`?l01X4PF`03PE]K029K00>1Fe/0
8e/100007e/00omKP@0IF`04o`g<o`A?00GoC4a<o`03S00<okGoCFI=I_lP?b3o14d02Om=CTgoCDa=
o`04C`08ol36odaVC_l2IP09ofIVode<CDco00;000CoC4co0d`03?o0`<3oC4oo@VI2o`E<0_l6F`03
PE]K01iK00>1Fe/08e/00h5KF`0RF`40000OF`03oe^101UK00goc<co?dloCom=C4go00=<00co]OmV
CFI=oclP?ol4C005odi>C_l00dd03OloCcm?olK0oha>I_l00VH01?mVI_l4C@0Bol3oodb<oha<S?o6
`<KoCDoo0fH01_m<CDa=C0;o1U/00h5KF`0NF`03PE]K02=K00>1Fe/08U/100007U/01?mKFh4IF`04
o`g<o`A?00GoC4a<o`03S00=okGoCFI=I_lP?b0oo`03C@09ode>COm=C4go00A?00So`<KoC6I>o`9V
00[oIVKoCDa=C?o00_l2C005oda<C?l00l002?m?Cdm2IT;o1D`00omKF`05F`03PE]K01iK00>1Fe/0
8e/00h5KF`0RF`40000NF`04oe]KPAUK00goc<co?dloCom=C4go00=<0_l02deVCFI=oclP?b3o00=<
00GoCTi>o`03C@0=ocm??dooa/3oS4iVo`02IP04ofIVo`A=00oo`?ooC8coS4b<olK0odd00dl02_mV
I_m<CDa=C?l7F`03PE]K01iK00>1Fe/08e/00h5KF`0RF`40000NF`;o00=KPE/065/01?l=c?l4C`03
oda<009<00?oS8`00_l02fI=ITeVob0o83oo009=0_l024e>COm=C4go14l02?o0a_m>ITko0fH02OmV
I_m<CDco`002o`9<00GoC4a<o`02`003ode?009?00CoIT;o1D`00omKF`05F`03PE]K01iK00>1Fe/0
8e/00h5KF`0RF`40000NF`04oe]KPAUK00koc<co?dloCom=C4e<o`9<0_l02deVCFI=oclP?b3o009<
0_l3CP0Aode=COloCcm?olK0ofI>I_l00fH01?mVI_l4C@?o00]<S?n<C8coa/3oC@03C`09ofIVoda=
C4go00QK00>1Fe/07U/00h5KF`0SF`03PE]K029K0@0001iK00CoFe^16E/00h7oo`06C`05oda<C?l0
0X`2o`0;ITeVCFKo83lP?ol00Td2o`07CDi=ode<o`05C`03ol3600;o00=KC_l00fH02?mVI_m<CDa=
0ol2C005oda<C?l00/000om=C`02C`04ofI2o`A<00?oFe/01U/00h5KF`0NF`03PE]K02=K00>1Fe/0
8U/100007U/01?mKFh4IF`0>POooCcm??dlooda=C?l2C0;o00]=ITeVCOlo83lPo`02C0;o0Th04_m=
CDgoCcm??dooa_n<ocmVo`=V00CoIVKo14d03on<odb<oha<S?o6`?lPo`02C`09ofIVI_m=C4go00QK
00>1Fe/07U/00h5KF`0SF`03PE]K029K0@0001iK00CoFe^16E/00h7oo`06C`05oda<C?l00X`2o`0;
ITeVCOlo83lP?ol00Td02Om>CDkoC4e<o`05C`08ol3oS?mVC_l3IP0;ofIVoda=C4goC?l00T`01Om<
C4co00;000?o8Ol00Tl01OmV@VKo00=<00?oFe/01U/00h5KF`0NF`03PE]K02=K00>1Fe/08U/10000
7U/01?mKFh4IF`0>POooCcm??dlooda=C?l2C0;o00]=ITeVob0o83lPo`02C005odi>C_l00dd03_m?
?dloCoo6ocooCVKo0fH01?mVI_l4C@05oha<oh`00_l024b<olK0ob3o0Tl02OmVIVKoCDa=o`08F`03
PE]K01mK00>1Fe/08U/00h5KF`0RF`40000NF`04oe]KPAUK00>1ool01Tl01Om<C4co00:<0_l02fI=
ITgo?b0o83oo009=00WoCTe>oda=C?l01Dl02?o0odooITko0fH03?mVI_m<CDa=ocm<o`9<00CoC4co
0/000olQo`02C`05ofI2I_l00T`00omKF`07F`03PE]K01mK00>1Fe/08U/00h5KF`0RF`40000NF`;o
00=KPE/065/03X7oodloCcm??om<CDco0T`2o`0;CFI=I_lP?b0o8?l00T`01Om>CTko00==00koCcm?
?dooa_loodiVo`=V00CoIVKo14d03oloC?n<C?m<S?o6oddPo`02C`08ofIVI_m=C?l9F`03PE]K01mK
00>1Fe/08U/00h5KF`0RF`40000NF`04oe]KPAUK00>1ool01Tl01Om<C4co00:<0_l036I=ITgo?b0o
83ooC@;o00Q>CDkoC4e<o`E?00So`?m?ofI>o`=V00OoIVKoC4e<00;o0T`01?m<C?l2C006ol3oob7o
0Tl01OmV@VKo009<00?oFe/01e/00h5KF`0OF`03PE]K029K00>1Fe/08U/100007U/01?mKFh4IF`0>
POooCcm??dlooda=C?l2C00>ofI=ITeVob0o83lPod`2o`=>00_oCDe=odloCcm??`02o`03?om>00;o
0fH01?mVI_l3C@;o00Z<C?n<C?m<S?o60_l00b3oC`02C`07ofIVode<o`09F`03PE]K01mK00>1Fe/0
8U/00h5KF`0RF`40000NF`04oe]KPAUK00>1ool01Tl01Om<C4co00:<00koCFI=ITgo?b0o83ooC@;o
00Q>CDkoC4e<o`I?0_l01TooITiVo`9V00OoIVKoC4e<00;o0T`01?m<C?l2C0?o00<P8Ol00dl01?m2
I_l2C003oe]K00MK00>1Fe/07e/00h5KF`0RF`03PE]K029K0@0001iK00CoFe^16E/03X7oodloCcm?
?om<CDco0T`03_mVCFI=oclP?b0o8?m<0_l3CP0;ode=COm??dloCcl00_l01SooCVI>o`9V00CoIVKo
0Td03?m=oha<oha<odb<C0;o0R001Om?Cdoo009V00?oCOl02U/00h5KF`0OF`03PE]K029K00>1Fe/0
8U/100007U/00omKP@0IF`04PE_oo`I?00GoC4a<o`02S00=odeVCFKo83lP?b0o8002o`08CDi=ode<
COl7C`;o00I?ofI>I_l2IP09ofIVoda=odgo009<00CoC4co0d`2o`04824Po`9?00Ko@VKoC?l:F`03
PE]K01mK00>1Fe/08U/00h5KF`0RF`40000>F`Co0e/4o`AK00CoFe^16E/03h5Kocm??dloCcooC4e<
o`02C0Co00U=oclP?b0o83l00_l3CP0=ode=COloCcm??dloo`02?`05odiVC_l00fH04OmVI_m=odgo
S4coS4coC8a<00;o0b001?m?Col2IP03odgo00YK00>1Fe/07e/00h5KF`0RF`03PE]K029K0@0000eK
00?oFe/00U/00omKo`04F`05oe]KFol00U/00h5KF`0GF`03PE_o00M?00GoC4a<o`02S004oalR7`;o
00LP?b0o83lP00;o00Q=CTgoCDa=o`M?00So?dooITiVo`=V00?oIVH00_l00da=o`02C004oda<o`=<
0_l0120Q8?l2C`04od9V@P;o2U/00h5KF`0OF`03PE]K029K00>1Fe/08U/100003E/00omKF`02F`03
oe_o00AK00CoFe]K1X4GF`0APE_o?dloCcm??om<CDcoC?l012802OlRob0o83lP?`04o`03C_m=009=
00Wo?dloCcm??ol00Sl01Om>ITko00=V00?oIVH00_l2C@0:oh`ooha<odb<C0;o0b001?m?Col3IP;o
2U/00h5KF`0OF`03PE]K029K00>1Fe/08U/100003E/00omKF`02F`03oe_o00AK00GoFe]Ko`02F`03
PE]K00V13U/00h5Ko`07C`04oda<C0;o018O8QlRob8O8_lP?b0o8?lR7b86o`M?00So?dloodiVo`=V
00?oIVH00_l00da=o`02C004oda<o`=<0_l0120Q8?l2C`05od9V@_l02e/00h5KF`0OF`03PE]K02=K
00>1Fe/08E/100003E/2o`=K00?oFol015/01OmKFe_o009K00>1Fe/02E/9P@EK00>1Fol00ol00dlo
C`08o`8R00co8QlR7b;o83lP?ol28P05ob8O8Ql00R801_m??dloC`;o0cl01?mVC_l3IP04ofIVo`==
00[oS4coS4coC8a<0_l38004odm?o`=V00?oFe/02E/00h5KF`0OF`03PE]K02=K00>1Fe/08E/10000
3E/00omKo`02o`9K00?oFe/00U/01OmKFe_o009K00>1Fe/04U/:P@04Foooo`DS00?o8b<00_l01b8O
8QlR7b801Ol00b;o8P028P067b;o8Qoo0dl02OloCcm??om>IP08o`04CDa=o`9<00CoC4co0d`01_lQ
824Po`9?00Go@VI2o`0;F`03PE]K01mK00>1Fe/08e/00h5KF`0QF`40000=F`03oe]K00AK00?oFe/0
0U/01OmKFe_o009K00>1Fe/05e/00h5KF`02F`V100AKoooo1B<00olS8`06o`088_lR7b8O8_l28P04
odooo`Do00CoITko0cl00om>IP0?o`@P00CoCdoo0fH00omKF`09F`03PE]K01mK00>1Fe/08e/00h5K
F`0QF`40000>F`07oe]KFomKo`04F`03oe]K01iK00>1Fe/02e/9P@04Foooo`@S0_l01b8O8QlR7b80
1?l04AlRodloCcooC_loCcm?ofKo00<R0_l28P03ob0P00@P00Ko8B0Q8?l3C`03ofKo00aK00>1Fe/0
7e/00h5KF`0SF`03PE]K00MK3X4<F`40000?F`?o0e/4ob5K00>1Fe/04e/:P@?o12<3o`068QlR7b;o
0cl3o`@o0_l01B8O8R;o00<R00Ko8B0Q8242o`DP00KoCdooI_l<F`03PE]K01mK00>1Fe/04e/JPAYK
0@0003YK00>1Fe/04e/00h5KF`07F`^100EKoolO8P04o`057b;oCcl00_l02b8O8Qoo7b8Ooaoo00<P
00Wo7b;o824P8Ol00Tl2o`eK00>1Fe/06e/JPA1K00>1Fe/08E/10000D5/00h5KF`0AF`V13?l03b;o
8_lO8Qoo8OlO8QlRo`038003odm?00;o3E/0185KFe/JP@AK00>1Fe/08e/00h5KF`0QF`40001@F`03
PE]K015K00>1Fe/01U/9P@9K013o8b?o7b8O8Qoo7b8O8QlR1olBPAiK00>1Fe/08e/00h5KF`0QF`40
001TF`03PE]K00iK2H42o`N15U/00h5KF`0OF`03PE]K02=K00>1Fe/08E/10000I5/00h5KF`0>F`03
PE]K00EK00>1Fe/07E/00h5KF`0OF`03PE]K04MK0@0007EK00>1Fe/01E/00h5KF`0MF`03PE]K06UK
0@0007EK00>1Fe/01E/00h5KF`29F`40003oF`YK0@000?mK2U/10000oe/:F`40003oF`YK0@000?mK
2U/10000oe/:F`40003oF`YK0@000?mK2U/10000oe/:F`40002eF`;oDU/10000]U/2o`=K00?oFe/0
Be/10000]e/2o`=K00?oFe/0BU/10000;e/5o`=K0ol2F`;o15/3o`03Fooo00;o0e/5o`EK0_l5F`;o
0U/5o`9K0_l2F`Co0e/4o`=K1?l2F`Co0e/4o`IK0_l3F`;o00=Kool00U/4o`=K0ol2F`?o0U/2o`EK
0ol2F`;o1e/4o`03FomK00Co0U/2o`9K0_l2F`;o15/6o`9K1?lNF`40000^F`;o0e/2o`04FoooF`;o
00=Kool015/2o`03Fooo009K0_l00e_oo`02F`;o1E/2o`EK0_l2F`;o00=Kool00U/2o`03Fooo009K
0_l00e_oo`02F`;o00=Kool00U/4o`9K0_l00e_oo`02F`;o1E/2o`=K0_l015_ooe/2o`9K0_l2F`;o
0U/2o`04FoooF`;o1E/3o`9K0_l6F`;o0U/5o`9K0_l00e_oo`02F`;o0U/2o`AK0_l5F`;o0U/2oaeK
0@0002iK0_l3F`Co0e/4o`AK0_l00e_oo`05F`;o0U/2o`EK0_l5F`;o0U/2o`03Fooo009K0_l00e_o
o`08F`?o15/5o`QK0ol5F`;o0e/2o`03Fooo00AK0ol2F`;o00=Kool00e/4o`AK0_l00e_oo`08F`;o
15/4o`EK0_l2F`;o2E/2o`AK0_l2F`;o7E/10000<U/5o`=K1?l4F`;o00=Kool01?l00e_oo`02F`;o
1E/2o`EK0_l2F`;o00=Kool00U/2o`03Fooo00Co0U/4o`=K1?l00e_oo`04o`9K1?l6F`;o0e/2o`03
Fooo009K1?l3F`;o00=Kool00e/4o`AK0_l00e_oo`08F`;o15/8o`03Fooo009K0_l:F`;o0e/2o`9K
0_lMF`40000_F`Go00=Kool00e/4o`AK0_l00e_oo`02F`;o00=Kool00U/2o`EK1Ol2F`;o0U/2o`03
Fooo009K0_l00e_oo`02F`;o00AKoooo15/3o`=K0_l2F`;o00AKoooo25/2o`=K0_l015_ooe/3o`EK
0_l00e_oo`03F`Co15/2o`03Fooo00QK0_l2F`Ko0U/2o`03Fooo009K0_l;F`;o0U/2o`9K0_lMF`40
000^F`?o1E/2o`04FoooF`?o0e/2o`03Fooo009K0_l00e_oo`02F`;o1E/2o`EK0_l2F`;o00=Kool0
0U/2o`03Fooo009K0_l00e_oo`02F`;o00=Kool00U/4o`9K0_l00e_oo`02F`;o1E/7o`04FoooF`;o
0U/2o`9K0_l2F`;o00AKoomK0ol3F`;o00=Kool025/2o`IK0_l2F`;o00=Kool00U/2o`aK0_l00e_o
o`02F`;o7E/10000;U/2o`=K0_l2F`?o0U/3o`9K1?l00e_oo`02o`=K1Ol5F`;o1E/2o`03Fooo00Oo
0e/4o`=K1?l3F`Co0U/4o`=K1?l6F`;o0e/2o`03Fooo009K1?l2F`Co0U/3o`9K0ol2F`;o0e/2o`MK
0_l4F`;o00=Kool00_l2F`Go2E/2o`9K0_l00e_oo`02F`;o7E/10000;U/2o`=K0_l=F`;o35/2o`EK
0_l9F`;o;U/2o`=K0_l<F`;o75/2o`9K0_lFF`;o0U/2o`03Fooo009K0_lMF`40000_F`Go3U/2o`aK
0_l5F`Ko00=Kool00U/2obiK0_l3F`;o00=Kool02E/2oaeK1?lHF`Co0e/4oaiK0@000?mK2U/10000
oe/:F`40003oF`YK0@000?mK2U/10000oe/:F`400000\
\>"],
  ImageRangeCache->{{{0, 265}, {252, 0}} -> {-0.0925078, -0.0556196, 
  0.00397335, 0.00397335}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Generations 20 to 40"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Fitnesses-Gen40"],

Cell[CellGroupData[{

Cell[TextData[
"fitnessChart3D[Take[allFitnessesSorted,{21,41}],\n  DisplayGeneration -> 40,\
\n  GenIndices -> {{1,20},{11,30},{21,40}}];"], "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .95229 
MathPictureStart
%% Graphics3D
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-3.75585e-05 1.06867 0.0267167 1.06867 [
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 40)] .5 .95229 0 -1.5 Msboxa
P
[(0)] .08595 .18034 -0.06484 1 Msboxa
[(10)] .23556 .13958 -0.04346 1 Msboxa
[(20)] .40028 .0947 -0.01962 1 Msboxa
[(30)] .58253 .04506 .00711 1 Msboxa
[(Indiv.)] .35928 .03957 -0.02584 1 Msboxa
[(20)] .73432 .0488 -1 .26344 Msboxa
[(30)] .85598 .1892 -1 .21908 Msboxa
[(40)] .94747 .29479 -1 .1875 Msboxa
[(Gen.)] .91594 .16872 -1 .22094 Msboxa
[(-50)] .05685 .24303 1 -0.25833 Msboxa
[(0)] .04482 .42044 1 -0.20167 Msboxa
[(50)] .03221 .60712 1 -0.14158 Msboxa
[(100)] .01896 .80382 1 -0.07771 Msboxa
[(Fit.)] -0.0283 .53856 1 -0.16726 Msboxa
[ 0 0 0 0 ]
[ 1 .95229 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 40)] .5 .95229 0 -1.5 Mshowa
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.08509 .19367 m
.08465 .20033 L
s
P
[(0)] .08595 .18034 -0.06484 1 Mshowa
p
.002 w
.23498 .15292 m
.23469 .15959 L
s
P
[(10)] .23556 .13958 -0.04346 1 Mshowa
p
.002 w
.40002 .10806 m
.39989 .11474 L
s
P
[(20)] .40028 .0947 -0.01962 1 Mshowa
p
.002 w
.58262 .05842 m
.58267 .0651 L
s
P
[(30)] .58253 .04506 .00711 1 Mshowa
p
.001 w
.11395 .18582 m
.11371 .18982 L
s
P
p
.001 w
.14336 .17783 m
.14314 .18183 L
s
P
p
.001 w
.17332 .16968 m
.17311 .17368 L
s
P
p
.001 w
.20386 .16138 m
.20367 .16538 L
s
P
p
.001 w
.2667 .1443 m
.26655 .1483 L
s
P
p
.001 w
.29905 .1355 m
.29892 .13951 L
s
P
p
.001 w
.33204 .12654 m
.33192 .13054 L
s
P
p
.001 w
.36569 .11739 m
.36559 .1214 L
s
P
p
.001 w
.43505 .09854 m
.43499 .10254 L
s
P
p
.001 w
.4708 .08882 m
.47076 .09283 L
s
P
p
.001 w
.5073 .0789 m
.50728 .0829 L
s
P
p
.001 w
.54456 .06877 m
.54457 .07277 L
s
P
p
.001 w
.6215 .04785 m
.62155 .05186 L
s
P
p
.001 w
.66122 .03706 m
.6613 .04106 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
p
.002 w
.69926 .02672 m
.93852 .30206 L
s
P
p
.002 w
.7214 .0522 m
.71494 .0539 L
s
P
[(20)] .73432 .0488 -1 .26344 Mshowa
p
.002 w
.84293 .19206 m
.83641 .19349 L
s
P
[(30)] .85598 .1892 -1 .21908 Mshowa
p
.002 w
.93434 .29725 m
.92778 .29848 L
s
P
[(40)] .94747 .29479 -1 .1875 Mshowa
[(Gen.)] .91594 .16872 -1 .22094 Mshowa
P
p
p
.002 w
.07262 .19706 m
.02672 .88626 L
s
P
p
.002 w
.06978 .23969 m
.07625 .23802 L
s
P
[(-50)] .05685 .24303 1 -0.25833 Mshowa
p
.002 w
.05792 .4178 m
.06447 .41648 L
s
P
[(0)] .04482 .42044 1 -0.20167 Mshowa
p
.002 w
.04543 .60525 m
.05205 .60431 L
s
P
[(50)] .03221 .60712 1 -0.14158 Mshowa
p
.002 w
.03228 .80279 m
.03894 .80227 L
s
P
[(100)] .01896 .80382 1 -0.07771 Mshowa
p
.001 w
.06746 .2746 m
.07135 .27364 L
s
P
p
.001 w
.06511 .30986 m
.06901 .30894 L
s
P
p
.001 w
.06274 .34548 m
.06665 .3446 L
s
P
p
.001 w
.06034 .38146 m
.06426 .38062 L
s
P
p
.001 w
.05547 .45452 m
.05941 .45377 L
s
P
p
.001 w
.053 .49162 m
.05695 .49092 L
s
P
p
.001 w
.05051 .5291 m
.05446 .52845 L
s
P
p
.001 w
.04798 .56698 m
.05194 .56637 L
s
P
p
.001 w
.04286 .64392 m
.04683 .64341 L
s
P
p
.001 w
.04025 .68301 m
.04424 .68255 L
s
P
p
.001 w
.03762 .72251 m
.04161 .7221 L
s
P
p
.001 w
.03496 .76243 m
.03896 .76207 L
s
P
p
.001 w
.07208 .20513 m
.07595 .20409 L
s
P
p
.001 w
.02956 .84358 m
.03356 .84332 L
s
P
p
.001 w
.02681 .88481 m
.03082 .88461 L
s
P
[(Fit.)] -0.0283 .53856 1 -0.16726 Mshowa
P
0 0 m
1 0 L
1 .95229 L
0 .95229 L
closepath
clip
newpath
p
p
.4 g
.002 w
.06978 .23969 m
.42904 .43021 L
s
P
p
.4 g
.002 w
.05792 .4178 m
.427 .56884 L
s
P
p
.4 g
.002 w
.04543 .60525 m
.42488 .71293 L
s
P
p
.4 g
.002 w
.03228 .80279 m
.42268 .86283 L
s
P
p
.4 g
.002 w
.08367 .20324 m
.03923 .88751 L
s
P
p
.4 g
.002 w
.18133 .25789 m
.149 .89843 L
s
P
p
.4 g
.002 w
.26703 .30585 m
.24418 .9079 L
s
P
p
.4 g
.002 w
.34284 .34827 m
.32749 .91619 L
s
P
p
.4 g
.002 w
.41037 .38606 m
.40102 .92351 L
s
P
p
.4 g
.002 w
.44013 .39481 m
.43312 .92519 L
s
P
p
.4 g
.002 w
.56602 .37138 m
.56847 .92068 L
s
P
p
.4 g
.002 w
.70138 .34619 m
.71482 .91579 L
s
P
p
.4 g
.002 w
.84733 .31903 m
.87358 .91049 L
s
P
p
.4 g
.002 w
.42904 .43021 m
.9407 .33992 L
s
P
p
.4 g
.002 w
.427 .56884 m
.94975 .49749 L
s
P
p
.4 g
.002 w
.42488 .71293 m
.95921 .66223 L
s
P
p
.4 g
.002 w
.42268 .86283 m
.96912 .83466 L
s
P
P
p
.43324 .39367 m .45808 .39844 L .44573 .40071 L 1 0 0 r
F
P
p
.44568 .39134 m .47051 .39615 L .45808 .39844 L 1 0 .905 r
F
P
p
.43324 .39367 m .44568 .39134 L .45808 .39844 L 1 0 0 r
F
P
p
.45821 .389 m .48303 .39384 L .47051 .39615 L .06 0 1 r
F
P
p
.44568 .39134 m .45821 .389 L .47051 .39615 L 1 0 .905 r
F
P
p
.47082 .38665 m .49564 .39152 L .48303 .39384 L 0 1 1 r
F
P
p
.45821 .389 m .47082 .38665 L .48303 .39384 L .06 0 1 r
F
P
p
.42048 .38646 m .44568 .39134 L .43324 .39367 L 1 0 0 r
F
P
p
.48353 .38427 m .50835 .38918 L .49564 .39152 L .034 1 0 r
F
P
p
.47082 .38665 m .48353 .38427 L .49564 .39152 L 0 1 1 r
F
P
p
.43301 .38409 m .45821 .389 L .44568 .39134 L .241 0 1 r
F
P
p
.42048 .38646 m .43301 .38409 L .44568 .39134 L 1 0 0 r
F
P
p
.49633 .38188 m .52114 .38683 L .50835 .38918 L .345 1 0 r
F
P
p
.48353 .38427 m .49633 .38188 L .50835 .38918 L .034 1 0 r
F
P
p
.44563 .3817 m .47082 .38665 L .45821 .389 L 0 1 .224 r
F
P
p
.43301 .38409 m .44563 .3817 L .45821 .389 L .241 0 1 r
F
P
p
.50923 .37947 m .53403 .38446 L .52114 .38683 L .552 1 0 r
F
P
p
.49633 .38188 m .50923 .37947 L .52114 .38683 L .345 1 0 r
F
P
p
.45834 .37929 m .48353 .38427 L .47082 .38665 L .112 1 0 r
F
P
p
.44563 .3817 m .45834 .37929 L .47082 .38665 L 0 1 .224 r
F
P
p
.40743 .3791 m .43301 .38409 L .42048 .38646 L 1 0 0 r
F
P
p
.52221 .37705 m .54701 .38207 L .53403 .38446 L .629 1 0 r
F
P
p
.50923 .37947 m .52221 .37705 L .53403 .38446 L .552 1 0 r
F
P
p
.47115 .37686 m .49633 .38188 L .48353 .38427 L .371 1 0 r
F
P
p
.45834 .37929 m .47115 .37686 L .48353 .38427 L .112 1 0 r
F
P
p
.42005 .37667 m .44563 .3817 L .43301 .38409 L 1 0 .853 r
F
P
p
.40743 .3791 m .42005 .37667 L .43301 .38409 L 1 0 0 r
F
P
p
.5353 .3746 m .56008 .37966 L .54701 .38207 L .707 1 0 r
F
P
p
.52221 .37705 m .5353 .3746 L .54701 .38207 L .629 1 0 r
F
P
p
.48405 .37441 m .50923 .37947 L .49633 .38188 L .629 1 0 r
F
P
p
.47115 .37686 m .48405 .37441 L .49633 .38188 L .371 1 0 r
F
P
p
.43276 .37423 m .45834 .37929 L .44563 .3817 L .164 0 1 r
F
P
p
.42005 .37667 m .43276 .37423 L .44563 .3817 L 1 0 .853 r
F
P
p
.54848 .37214 m .57325 .37723 L .56008 .37966 L .784 1 0 r
F
P
p
.5353 .3746 m .54848 .37214 L .56008 .37966 L .707 1 0 r
F
P
p
.49704 .37195 m .52221 .37705 L .50923 .37947 L .707 1 0 r
F
P
p
.48405 .37441 m .49704 .37195 L .50923 .37947 L .629 1 0 r
F
P
p
.44557 .37176 m .47115 .37686 L .45834 .37929 L .034 0 1 r
F
P
p
.43276 .37423 m .44557 .37176 L .45834 .37929 L .164 0 1 r
F
P
p
.39408 .37157 m .42005 .37667 L .40743 .3791 L 1 0 0 r
F
P
p
.56176 .36966 m .58652 .37479 L .57325 .37723 L .888 1 0 r
F
P
p
.54848 .37214 m .56176 .36966 L .57325 .37723 L .784 1 0 r
F
P
p
.51013 .36947 m .5353 .3746 L .52221 .37705 L .759 1 0 r
F
P
p
.49704 .37195 m .51013 .36947 L .52221 .37705 L .707 1 0 r
F
P
p
.45848 .36928 m .48405 .37441 L .47115 .37686 L 0 .793 1 r
F
P
p
.44557 .37176 m .45848 .36928 L .47115 .37686 L .034 0 1 r
F
P
p
.40679 .36909 m .43276 .37423 L .42005 .37667 L 1 0 0 r
F
P
p
.39408 .37157 m .40679 .36909 L .42005 .37667 L 1 0 0 r
F
P
p
.57514 .36716 m .59989 .37233 L .58652 .37479 L .991 1 0 r
F
P
p
.56176 .36966 m .57514 .36716 L .58652 .37479 L .888 1 0 r
F
P
p
.52332 .36697 m .54848 .37214 L .5353 .3746 L .81 1 0 r
F
P
p
.51013 .36947 m .52332 .36697 L .5353 .3746 L .759 1 0 r
F
P
p
.47148 .36678 m .49704 .37195 L .48405 .37441 L 0 1 .25 r
F
P
p
.45848 .36928 m .47148 .36678 L .48405 .37441 L 0 .793 1 r
F
P
p
.4196 .36658 m .44557 .37176 L .43276 .37423 L 1 0 0 r
F
P
p
.40679 .36909 m .4196 .36658 L .43276 .37423 L 1 0 0 r
F
P
p
.58861 .36464 m .61335 .36985 L .59989 .37233 L 1 .828 0 r
F
P
p
.57514 .36716 m .58861 .36464 L .59989 .37233 L .991 1 0 r
F
P
p
.53661 .36445 m .56176 .36966 L .54848 .37214 L .836 1 0 r
F
P
p
.52332 .36697 m .53661 .36445 L .54848 .37214 L .81 1 0 r
F
P
p
.48458 .36426 m .51013 .36947 L .49704 .37195 L 0 1 .095 r
F
P
p
.47148 .36678 m .48458 .36426 L .49704 .37195 L 0 1 .25 r
F
P
p
.43251 .36406 m .45848 .36928 L .44557 .37176 L 1 0 0 r
F
P
p
.4196 .36658 m .43251 .36406 L .44557 .37176 L 1 0 0 r
F
P
p
.38042 .36387 m .40679 .36909 L .39408 .37157 L 1 0 0 r
F
P
p
.60219 .36211 m .62692 .36735 L .61335 .36985 L 1 .698 0 r
F
P
p
.58861 .36464 m .60219 .36211 L .61335 .36985 L 1 .828 0 r
F
P
p
.55 .36191 m .57514 .36716 L .56176 .36966 L .888 1 0 r
F
P
p
.53661 .36445 m .55 .36191 L .56176 .36966 L .836 1 0 r
F
P
p
.49777 .36172 m .52332 .36697 L .51013 .36947 L .06 1 0 r
F
P
p
.48458 .36426 m .49777 .36172 L .51013 .36947 L 0 1 .095 r
F
P
p
.44552 .36152 m .47148 .36678 L .45848 .36928 L .448 0 1 r
F
P
p
.43251 .36406 m .44552 .36152 L .45848 .36928 L 1 0 0 r
F
P
p
.39323 .36132 m .4196 .36658 L .40679 .36909 L 1 0 0 r
F
P
p
.38042 .36387 m .39323 .36132 L .40679 .36909 L 1 0 0 r
F
P
p
.61587 .35955 m .64059 .36484 L .62692 .36735 L 1 .647 0 r
F
P
p
.60219 .36211 m .61587 .35955 L .62692 .36735 L 1 .698 0 r
F
P
p
.56349 .35935 m .58861 .36464 L .57514 .36716 L .966 1 0 r
F
P
p
.55 .36191 m .56349 .35935 L .57514 .36716 L .888 1 0 r
F
P
p
.51107 .35916 m .53661 .36445 L .52332 .36697 L .216 1 0 r
F
P
p
.49777 .36172 m .51107 .35916 L .52332 .36697 L .06 1 0 r
F
P
p
.45862 .35896 m .48458 .36426 L .47148 .36678 L 0 1 .638 r
F
P
p
.44552 .36152 m .45862 .35896 L .47148 .36678 L .448 0 1 r
F
P
p
.40614 .35876 m .43251 .36406 L .4196 .36658 L 1 0 0 r
F
P
p
.39323 .36132 m .40614 .35876 L .4196 .36658 L 1 0 0 r
F
P
p
.62966 .35698 m .65436 .3623 L .64059 .36484 L 1 .621 0 r
F
P
p
.61587 .35955 m .62966 .35698 L .64059 .36484 L 1 .647 0 r
F
P
p
.57708 .35678 m .60219 .36211 L .58861 .36464 L 1 .931 0 r
F
P
p
.56349 .35935 m .57708 .35678 L .58861 .36464 L .966 1 0 r
F
P
p
.52446 .35658 m .55 .36191 L .53661 .36445 L .371 1 0 r
F
P
p
.51107 .35916 m .52446 .35658 L .53661 .36445 L .216 1 0 r
F
P
p
.47182 .35638 m .49777 .36172 L .48458 .36426 L 0 1 .353 r
F
P
p
.45862 .35896 m .47182 .35638 L .48458 .36426 L 0 1 .638 r
F
P
p
.41915 .35618 m .44552 .36152 L .43251 .36406 L 1 0 0 r
F
P
p
.40614 .35876 m .41915 .35618 L .43251 .36406 L 1 0 0 r
F
P
p
.36644 .35598 m .39323 .36132 L .38042 .36387 L 1 0 0 r
F
P
p
.002 w
.50725 .69037 m .49395 .70373 L .48171 .63928 L p
.034 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49395 .70373 m .47933 .90887 L .4684 .65877 L p
0 1 1 r
F P
0 0 0 r
s
P
p
.002 w
.4684 .65877 m .48171 .63928 L .49395 .70373 L p
0 1 1 r
F P
0 0 0 r
s
P
p
.64355 .35438 m .66823 .35975 L .65436 .3623 L 1 .595 0 r
F
P
p
.62966 .35698 m .64355 .35438 L .65436 .3623 L 1 .621 0 r
F
P
p
.59077 .35418 m .61587 .35955 L .60219 .36211 L 1 .879 0 r
F
P
p
.57708 .35678 m .59077 .35418 L .60219 .36211 L 1 .931 0 r
F
P
p
.53796 .35398 m .56349 .35935 L .55 .36191 L .552 1 0 r
F
P
p
.52446 .35658 m .53796 .35398 L .55 .36191 L .371 1 0 r
F
P
p
.002 w
.53402 .65744 m .52064 .65888 L .50843 .60613 L p
.552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52064 .65888 m .50725 .69037 L .49503 .62573 L p
.345 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49503 .62573 m .50843 .60613 L .52064 .65888 L p
.345 1 0 r
F P
0 0 0 r
s
P
p
.48512 .35378 m .51107 .35916 L .49777 .36172 L 0 1 .069 r
F
P
p
.47182 .35638 m .48512 .35378 L .49777 .36172 L 0 1 .353 r
F
P
p
.002 w
.45499 .69027 m .4684 .65877 L .47933 .90887 L p
.06 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48171 .63928 m .4684 .65877 L .45527 .66648 L p
.112 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4684 .65877 m .45499 .69027 L .44168 .6984 L p
0 1 .224 r
F P
0 0 0 r
s
P
p
.002 w
.44168 .6984 m .45527 .66648 L .4684 .65877 L p
0 1 .224 r
F P
0 0 0 r
s
P
p
.002 w
.48171 .63928 m .49503 .62573 L .50725 .69037 L p
.034 1 0 r
F P
0 0 0 r
s
P
p
.43225 .35358 m .45862 .35896 L .44552 .36152 L .06 0 1 r
F
P
p
.41915 .35618 m .43225 .35358 L .44552 .36152 L 1 0 0 r
F
P
p
.002 w
.47933 .90887 m .46592 .90937 L .45499 .69027 L p
.06 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43925 .90832 m .45499 .69027 L .46592 .90937 L p
1 0 .905 r
F P
0 0 0 r
s
P
p
.002 w
.45499 .69027 m .43925 .90832 L .42557 .90673 L p
.241 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42557 .90673 m .44168 .6984 L .45499 .69027 L p
.241 0 1 r
F P
0 0 0 r
s
P
p
.37935 .35338 m .40614 .35876 L .39323 .36132 L 1 0 0 r
F
P
p
.36644 .35598 m .37935 .35338 L .39323 .36132 L 1 0 0 r
F
P
p
.002 w
.48171 .63928 m .46859 .66505 L p
.48483 .64089 L .371 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46576 .70764 m .45278 .90348 L p
.47696 .68132 L 0 .793 1 r
F P
0 0 0 r
s
P
p
.002 w
.46859 .66505 m .46576 .70764 L p
.47849 .66726 L 0 .793 1 r
F P
0 0 0 r
s
P
p
.47696 .68132 m .47849 .66726 L .46576 .70764 L 0 .793 1 r
F
P
p
.002 w
.46859 .66505 m .48171 .63928 L p
.45879 .66286 L .112 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49503 .62573 m .48757 .63332 L p
.48483 .64089 L .371 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48757 .63332 m .48171 .63928 L p
.48483 .64089 L .371 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46859 .66505 m .48222 .63303 L .49503 .62573 L p
.371 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48222 .63303 m .46859 .66505 L p
.47849 .66726 L 0 .793 1 r
F P
0 0 0 r
s
P
p
.002 w
.46828 .72807 m .47849 .65847 L p
.4679 .75939 L 0 .793 1 r
F P
0 0 0 r
s
P
p
.002 w
.45278 .90348 m .46828 .72807 L p
.4679 .75939 L 0 .793 1 r
F P
0 0 0 r
s
P
p
.002 w
.46859 .66505 m .45527 .66648 L .43893 .90403 L p
.034 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43893 .90403 m .45278 .90348 L .46859 .66505 L p
.034 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46828 .72807 m .45513 .68604 L p
.46874 .69065 L 0 1 .638 r
F P
0 0 0 r
s
P
p
.46782 .76525 m .47849 .65847 L .47986 .65466 L 0 .793 1 r
F
P
p
.45278 .90348 m .4679 .75939 L .46782 .76525 L 0 .793 1 r
F
P
p
.4679 .75939 m .47849 .65847 L .46782 .76525 L 0 .793 1 r
F
P
p
.002 w
.48226 .69522 m .47832 .69389 L p
.46828 .72807 L 0 1 .25 r
F P
0 0 0 r
s
P
p
.002 w
.48004 .68803 m .48226 .69522 L .49324 .64307 L p
0 1 .25 r
F P
0 0 0 r
s
P
p
.47359 .70935 m .49324 .64307 L .4907 .64904 L 0 1 .25 r
F
P
p
.46828 .72807 m .47395 .70876 L .47359 .70935 L 0 1 .25 r
F
P
p
.47395 .70876 m .49324 .64307 L .47359 .70935 L 0 1 .25 r
F
P
p
.002 w
.47849 .65847 m .48222 .63303 L p
.47986 .65466 L 0 .793 1 r
F P
0 0 0 r
s
P
p
.002 w
.49568 .63146 m .48222 .63303 L .46828 .72807 L p
0 1 .25 r
F P
0 0 0 r
s
P
p
.002 w
.50925 .62989 m .49568 .63146 L .48226 .69522 L p
0 1 .095 r
F P
0 0 0 r
s
P
p
.002 w
.48226 .69522 m .4961 .68754 L .50925 .62989 L p
0 1 .095 r
F P
0 0 0 r
s
P
p
.002 w
.48226 .69522 m .46921 .65297 L p
.49099 .68098 L 0 1 .353 r
F P
0 0 0 r
s
P
p
.002 w
.4961 .68754 m .48226 .69522 L p
.49099 .68098 L 0 1 .353 r
F P
0 0 0 r
s
P
p
.002 w
.46921 .65297 m .48226 .69522 L p
.46874 .69065 L 0 1 .638 r
F P
0 0 0 r
s
P
p
.002 w
.45527 .66648 m .46859 .66505 L p
.45879 .66286 L .112 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45513 .68604 m .46921 .65297 L p
.46874 .69065 L 0 1 .638 r
F P
0 0 0 r
s
P
p
.002 w
.48226 .69522 m .46828 .72807 L p
.46874 .69065 L 0 1 .638 r
F P
0 0 0 r
s
P
p
.002 w
.49324 .64307 m .49568 .63146 L p
.4907 .64904 L 0 1 .25 r
F P
0 0 0 r
s
P
p
.65754 .35177 m .68221 .35718 L .66823 .35975 L 1 .491 0 r
F
P
p
.64355 .35438 m .65754 .35177 L .66823 .35975 L 1 .595 0 r
F
P
p
.60457 .35157 m .62966 .35698 L .61587 .35955 L 1 .828 0 r
F
P
p
.59077 .35418 m .60457 .35157 L .61587 .35955 L 1 .879 0 r
F
P
p
.55156 .35137 m .57708 .35678 L .56349 .35935 L .629 1 0 r
F
P
p
.53796 .35398 m .55156 .35137 L .56349 .35935 L .552 1 0 r
F
P
p
.002 w
.50843 .60613 m .49503 .62573 L .48222 .63303 L p
.629 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54746 .63788 m .53402 .65744 L .52183 .60448 L p
.629 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50843 .60613 m .52183 .60448 L .53402 .65744 L p
.552 1 0 r
F P
0 0 0 r
s
P
p
.49853 .35116 m .52446 .35658 L .51107 .35916 L .241 1 0 r
F
P
p
.48512 .35378 m .49853 .35116 L .51107 .35916 L 0 1 .069 r
F
P
p
.44546 .35096 m .47182 .35638 L .45862 .35896 L .034 1 0 r
F
P
p
.43225 .35358 m .44546 .35096 L .45862 .35896 L .06 0 1 r
F
P
p
.39236 .35076 m .41915 .35618 L .40614 .35876 L 1 0 .724 r
F
P
p
.37935 .35338 m .39236 .35076 L .40614 .35876 L 1 0 0 r
F
P
p
.002 w
.52183 .60448 m .50843 .60613 L .49568 .63146 L p
.707 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48222 .63303 m .49568 .63146 L .50843 .60613 L p
.629 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56101 .63635 m .54746 .63788 L .53533 .60282 L p
.707 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52183 .60448 m .53533 .60282 L .54746 .63788 L p
.629 1 0 r
F P
0 0 0 r
s
P
p
.67164 .34913 m .69629 .35458 L .68221 .35718 L 1 .414 0 r
F
P
p
.65754 .35177 m .67164 .34913 L .68221 .35718 L 1 .491 0 r
F
P
p
.61847 .34893 m .64355 .35438 L .62966 .35698 L 1 .776 0 r
F
P
p
.60457 .35157 m .61847 .34893 L .62966 .35698 L 1 .828 0 r
F
P
p
.56527 .34873 m .59077 .35418 L .57708 .35678 L .681 1 0 r
F
P
p
.55156 .35137 m .56527 .34873 L .57708 .35678 L .629 1 0 r
F
P
p
.51203 .34852 m .53796 .35398 L .52446 .35658 L .448 1 0 r
F
P
p
.49853 .35116 m .51203 .34852 L .52446 .35658 L .241 1 0 r
F
P
p
.45877 .34832 m .48512 .35378 L .47182 .35638 L .19 1 0 r
F
P
p
.44546 .35096 m .45877 .34832 L .47182 .35638 L .034 1 0 r
F
P
p
.40547 .34812 m .43225 .35358 L .41915 .35618 L .552 0 1 r
F
P
p
.39236 .35076 m .40547 .34812 L .41915 .35618 L 1 0 .724 r
F
P
p
.35214 .34791 m .37935 .35338 L .36644 .35598 L 1 0 .724 r
F
P
p
.002 w
.53533 .60282 m .52183 .60448 L .50925 .62989 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49568 .63146 m .50925 .62989 L .52183 .60448 L p
.707 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57457 .61666 m .56101 .63635 L .54894 .60115 L p
.784 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53533 .60282 m .54894 .60115 L .56101 .63635 L p
.707 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45261 .90987 m .43941 .91037 L .42594 .90883 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58829 .61505 m .57457 .61666 L .56265 .59947 L p
.888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56265 .59947 m .57457 .61666 L p
.55409 .60427 L .784 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56265 .59947 m .57643 .59167 L .58829 .61505 L p
.888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56265 .59947 m .55054 .60653 L p
.57129 .59462 L .888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57643 .59167 m .56265 .59947 L p
.57129 .59462 L .888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54894 .60115 m .56265 .59947 L p
.55409 .60427 L .784 1 0 r
F P
0 0 0 r
s
P
p
.68585 .34648 m .71048 .35197 L .69629 .35458 L 1 .362 0 r
F
P
p
.67164 .34913 m .68585 .34648 L .69629 .35458 L 1 .414 0 r
F
P
p
.63248 .34628 m .65754 .35177 L .64355 .35438 L 1 .724 0 r
F
P
p
.61847 .34893 m .63248 .34628 L .64355 .35438 L 1 .776 0 r
F
P
p
.57908 .34607 m .60457 .35157 L .59077 .35418 L .759 1 0 r
F
P
p
.56527 .34873 m .57908 .34607 L .59077 .35418 L .681 1 0 r
F
P
p
.52564 .34587 m .55156 .35137 L .53796 .35398 L .655 1 0 r
F
P
p
.51203 .34852 m .52564 .34587 L .53796 .35398 L .448 1 0 r
F
P
p
.47217 .34566 m .49853 .35116 L .48512 .35378 L .371 1 0 r
F
P
p
.45877 .34832 m .47217 .34566 L .48512 .35378 L .19 1 0 r
F
P
p
.41868 .34545 m .44546 .35096 L .43225 .35358 L 0 .897 1 r
F
P
p
.40547 .34812 m .41868 .34545 L .43225 .35358 L .552 0 1 r
F
P
p
.36515 .34525 m .39236 .35076 L .37935 .35338 L .552 0 1 r
F
P
p
.35214 .34791 m .36515 .34525 L .37935 .35338 L 1 0 .724 r
F
P
p
.002 w
.54894 .60115 m .53533 .60282 L .52294 .61601 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50925 .62989 m .52294 .61601 L .53533 .60282 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44168 .6984 m .42557 .90673 L .41156 .9051 L p
1 0 .853 r
F P
0 0 0 r
s
P
p
.002 w
.45527 .66648 m .44168 .6984 L .42519 .90457 L p
.164 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42519 .90457 m .43893 .90403 L .45527 .66648 L p
.164 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46592 .90937 m .45261 .90987 L .43925 .90832 L p
1 0 .905 r
F P
0 0 0 r
s
P
p
.002 w
.42594 .90883 m .43925 .90832 L .45261 .90987 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.41156 .9051 m .42519 .90457 L .44168 .6984 L p
1 0 .853 r
F P
0 0 0 r
s
P
p
.002 w
.602 .60128 m .58829 .61505 L .57643 .59167 L p
.991 1 0 r
F P
0 0 0 r
s
P
p
.70017 .34381 m .72478 .34934 L .71048 .35197 L 1 .31 0 r
F
P
p
.68585 .34648 m .70017 .34381 L .71048 .35197 L 1 .362 0 r
F
P
p
.6466 .3436 m .67164 .34913 L .65754 .35177 L 1 .569 0 r
F
P
p
.63248 .34628 m .6466 .3436 L .65754 .35177 L 1 .724 0 r
F
P
p
.59299 .34339 m .61847 .34893 L .60457 .35157 L .914 1 0 r
F
P
p
.57908 .34607 m .59299 .34339 L .60457 .35157 L .759 1 0 r
F
P
p
.53936 .34319 m .56527 .34873 L .55156 .35137 L .707 1 0 r
F
P
p
.52564 .34587 m .53936 .34319 L .55156 .35137 L .655 1 0 r
F
P
p
.48569 .34298 m .51203 .34852 L .49853 .35116 L .655 1 0 r
F
P
p
.47217 .34566 m .48569 .34298 L .49853 .35116 L .371 1 0 r
F
P
p
.43199 .34277 m .45877 .34832 L .44546 .35096 L .526 1 0 r
F
P
p
.41868 .34545 m .43199 .34277 L .44546 .35096 L 0 .897 1 r
F
P
p
.002 w
.61571 .5814 m .602 .60128 L .59029 .58383 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.57643 .59167 m .59029 .58383 L .602 .60128 L p
.991 1 0 r
F P
0 0 0 r
s
P
p
.37825 .34256 m .40547 .34812 L .39236 .35076 L 0 .172 1 r
F
P
p
.36515 .34525 m .37825 .34256 L .39236 .35076 L .552 0 1 r
F
P
p
.002 w
.56265 .59947 m .54894 .60115 L .53669 .61436 L p
.836 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52294 .61601 m .53669 .61436 L .54894 .60115 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62961 .57357 m .61571 .5814 L .60424 .57594 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.59029 .58383 m .60424 .57594 L .61571 .5814 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.7146 .34111 m .73919 .34669 L .72478 .34934 L 1 .259 0 r
F
P
p
.70017 .34381 m .7146 .34111 L .72478 .34934 L 1 .31 0 r
F
P
p
.66083 .3409 m .68585 .34648 L .67164 .34913 L 1 .466 0 r
F
P
p
.6466 .3436 m .66083 .3409 L .67164 .34913 L 1 .569 0 r
F
P
p
.60702 .34069 m .63248 .34628 L .61847 .34893 L 1 .983 0 r
F
P
p
.59299 .34339 m .60702 .34069 L .61847 .34893 L .914 1 0 r
F
P
p
.55318 .34049 m .57908 .34607 L .56527 .34873 L .759 1 0 r
F
P
p
.53936 .34319 m .55318 .34049 L .56527 .34873 L .707 1 0 r
F
P
p
.4993 .34028 m .52564 .34587 L .51203 .34852 L .862 1 0 r
F
P
p
.48569 .34298 m .4993 .34028 L .51203 .34852 L .655 1 0 r
F
P
p
.4454 .34007 m .47217 .34566 L .45877 .34832 L .707 1 0 r
F
P
p
.43199 .34277 m .4454 .34007 L .45877 .34832 L .526 1 0 r
F
P
p
.39146 .33986 m .41868 .34545 L .40547 .34812 L 0 1 .922 r
F
P
p
.37825 .34256 m .39146 .33986 L .40547 .34812 L 0 .172 1 r
F
P
p
.002 w
.53669 .61436 m .55054 .60653 L .56265 .59947 L p
.836 1 0 r
F P
0 0 0 r
s
P
p
.33749 .33965 m .36515 .34525 L .35214 .34791 L 0 .172 1 r
F
P
p
.002 w
.64369 .57177 m .62961 .57357 L .61834 .57413 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.61834 .57413 m .62961 .57357 L p
.61275 .57514 L 1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.61834 .57413 m .63247 .56616 L .64369 .57177 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.61834 .57413 m .6069 .58717 L p
.62401 .57311 L 1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.63247 .56616 m .61834 .57413 L p
.62401 .57311 L 1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.60424 .57594 m .61834 .57413 L p
.61275 .57514 L 1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.43925 .90832 m .42594 .90883 L .41216 .90725 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.72915 .33839 m .75371 .34401 L .73919 .34669 L 1 .207 0 r
F
P
p
.7146 .34111 m .72915 .33839 L .73919 .34669 L 1 .259 0 r
F
P
p
.67516 .33818 m .70017 .34381 L .68585 .34648 L 1 .388 0 r
F
P
p
.66083 .3409 m .67516 .33818 L .68585 .34648 L 1 .466 0 r
F
P
p
.62115 .33797 m .6466 .3436 L .63248 .34628 L 1 .957 0 r
F
P
p
.60702 .34069 m .62115 .33797 L .63248 .34628 L 1 .983 0 r
F
P
p
.5671 .33776 m .59299 .34339 L .57908 .34607 L .862 1 0 r
F
P
p
.55318 .34049 m .5671 .33776 L .57908 .34607 L .759 1 0 r
F
P
p
.51303 .33755 m .53936 .34319 L .52564 .34587 L .966 1 0 r
F
P
p
.4993 .34028 m .51303 .33755 L .52564 .34587 L .862 1 0 r
F
P
p
.002 w
.59029 .58383 m .57643 .59167 L .5645 .60484 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55054 .60653 m .5645 .60484 L .57643 .59167 L p
.888 1 0 r
F P
0 0 0 r
s
P
p
.45892 .33734 m .48569 .34298 L .47217 .34566 L .707 1 0 r
F
P
p
.4454 .34007 m .45892 .33734 L .47217 .34566 L .707 1 0 r
F
P
p
.40477 .33713 m .43199 .34277 L .41868 .34545 L 0 1 .121 r
F
P
p
.39146 .33986 m .40477 .33713 L .41868 .34545 L 0 1 .922 r
F
P
p
.3506 .33692 m .37825 .34256 L .36515 .34525 L 0 .897 1 r
F
P
p
.33749 .33965 m .3506 .33692 L .36515 .34525 L 0 .172 1 r
F
P
p
.002 w
.65787 .56996 m .64369 .57177 L .63247 .56616 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.52294 .61601 m .50925 .62989 L .4961 .68754 L p
.06 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41216 .90725 m .42557 .90673 L .43925 .90832 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7438 .33566 m .76835 .34132 L .75371 .34401 L 1 .103 0 r
F
P
p
.72915 .33839 m .7438 .33566 L .75371 .34401 L 1 .207 0 r
F
P
p
.68961 .33544 m .7146 .34111 L .70017 .34381 L 1 .31 0 r
F
P
p
.67516 .33818 m .68961 .33544 L .70017 .34381 L 1 .388 0 r
F
P
p
.002 w
.60424 .57594 m .59029 .58383 L .57852 .59692 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.002 w
.5645 .60484 m .57852 .59692 L .59029 .58383 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.63539 .33523 m .66083 .3409 L .6466 .3436 L 1 .879 0 r
F
P
p
.62115 .33797 m .63539 .33523 L .6466 .3436 L 1 .957 0 r
F
P
p
.58114 .33502 m .60702 .34069 L .59299 .34339 L .991 1 0 r
F
P
p
.5671 .33776 m .58114 .33502 L .59299 .34339 L .862 1 0 r
F
P
p
.002 w
.53669 .61436 m .52294 .61601 L .51006 .6672 L p
.216 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51006 .6672 m .52294 .61601 L p
.49882 .68027 L .06 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51006 .6672 m .52404 .6594 L .53669 .61436 L p
.216 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51006 .6672 m .49724 .60568 L p
.52137 .65404 L .241 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52404 .6594 m .51006 .6672 L p
.52137 .65404 L .241 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4961 .68754 m .51006 .6672 L p
.49882 .68027 L .06 1 0 r
F P
0 0 0 r
s
P
p
.52686 .33481 m .55318 .34049 L .53936 .34319 L .966 1 0 r
F
P
p
.51303 .33755 m .52686 .33481 L .53936 .34319 L .966 1 0 r
F
P
p
.47254 .3346 m .4993 .34028 L .48569 .34298 L .836 1 0 r
F
P
p
.45892 .33734 m .47254 .3346 L .48569 .34298 L .707 1 0 r
F
P
p
.41819 .33439 m .4454 .34007 L .43199 .34277 L .681 1 0 r
F
P
p
.40477 .33713 m .41819 .33439 L .43199 .34277 L 0 1 .121 r
F
P
p
.36381 .33417 m .39146 .33986 L .37825 .34256 L 0 1 .974 r
F
P
p
.3506 .33692 m .36381 .33417 L .37825 .34256 L 0 .897 1 r
F
P
p
.002 w
.67217 .56814 m .65787 .56996 L .64678 .5643 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.64678 .5643 m .65787 .56996 L p
.63886 .56711 L 1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.6611 .55624 m .67217 .56814 L p
.65189 .56507 L 1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.64678 .5643 m .6611 .55624 L p
.65189 .56507 L 1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.68644 .56015 m .67217 .56814 L .6611 .55624 L p
1 .491 0 r
F P
0 0 0 r
s
P
p
.002 w
.6611 .55624 m .67538 .54194 L .68644 .56015 L p
1 .491 0 r
F P
0 0 0 r
s
P
p
.002 w
.6611 .55624 m .65018 .56915 L p
.67039 .54732 L 1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.67538 .54194 m .6611 .55624 L p
.67039 .54732 L 1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.64678 .5643 m .63568 .57729 L p
.6548 .56146 L 1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.6611 .55624 m .64678 .5643 L p
.6548 .56146 L 1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.63247 .56616 m .64678 .5643 L p
.63886 .56711 L 1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.61834 .57413 m .60424 .57594 L .59264 .58895 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.57852 .59692 m .59264 .58895 L .60424 .57594 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.75857 .3329 m .78309 .3386 L .76835 .34132 L 1 0 0 r
F
P
p
.7438 .33566 m .75857 .3329 L .76835 .34132 L 1 .103 0 r
F
P
p
.70418 .33268 m .72915 .33839 L .7146 .34111 L 1 .233 0 r
F
P
p
.68961 .33544 m .70418 .33268 L .7146 .34111 L 1 .31 0 r
F
P
p
.64975 .33247 m .67516 .33818 L .66083 .3409 L 1 .776 0 r
F
P
p
.63539 .33523 m .64975 .33247 L .66083 .3409 L 1 .879 0 r
F
P
p
.59529 .33226 m .62115 .33797 L .60702 .34069 L 1 .931 0 r
F
P
p
.58114 .33502 m .59529 .33226 L .60702 .34069 L .991 1 0 r
F
P
p
.002 w
.55054 .60653 m .53669 .61436 L .52404 .6594 L p
.371 1 0 r
F P
0 0 0 r
s
P
p
.54079 .33204 m .5671 .33776 L .55318 .34049 L 1 .931 0 r
F
P
p
.52686 .33481 m .54079 .33204 L .55318 .34049 L .966 1 0 r
F
P
p
.48627 .33183 m .51303 .33755 L .4993 .34028 L 1 .983 0 r
F
P
p
.47254 .3346 m .48627 .33183 L .4993 .34028 L .836 1 0 r
F
P
p
.43171 .33162 m .45892 .33734 L .4454 .34007 L .914 1 0 r
F
P
p
.41819 .33439 m .43171 .33162 L .4454 .34007 L .681 1 0 r
F
P
p
.37712 .3314 m .40477 .33713 L .39146 .33986 L 0 1 .612 r
F
P
p
.36381 .33417 m .37712 .3314 L .39146 .33986 L 0 1 .974 r
F
P
p
.32249 .33119 m .3506 .33692 L .33749 .33965 L 0 .897 1 r
F
P
p
.002 w
.59264 .58895 m .6069 .58717 L .61834 .57413 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.77346 .33012 m .79796 .33587 L .78309 .3386 L 1 0 0 r
F
P
p
.75857 .3329 m .77346 .33012 L .78309 .3386 L 1 0 0 r
F
P
p
.002 w
.42557 .90673 m .41216 .90725 L .39804 .90564 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5645 .60484 m .55054 .60653 L .53811 .63262 L p
.552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53811 .63262 m .55054 .60653 L p
.52788 .65174 L .371 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53811 .63262 m .52535 .58329 L p
.54839 .61339 L .655 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55221 .61839 m .5645 .60484 L p
.54344 .62701 L .552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53811 .63262 m .55221 .61839 L p
.54344 .62701 L .552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57852 .59692 m .5645 .60484 L .55221 .61839 L p
.629 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55221 .61839 m .53953 .58147 L p
.56107 .60969 L .707 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55221 .61839 m .56644 .61671 L .57852 .59692 L p
.629 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56644 .61671 m .55221 .61839 L p
.56107 .60969 L .707 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55221 .61839 m .53811 .63262 L p
.54839 .61339 L .655 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52404 .6594 m .53811 .63262 L p
.52788 .65174 L .371 1 0 r
F P
0 0 0 r
s
P
p
.71885 .3299 m .7438 .33566 L .72915 .33839 L 1 .155 0 r
F
P
p
.70418 .33268 m .71885 .3299 L .72915 .33839 L 1 .233 0 r
F
P
p
.66422 .32969 m .68961 .33544 L .67516 .33818 L 1 .647 0 r
F
P
p
.64975 .33247 m .66422 .32969 L .67516 .33818 L 1 .776 0 r
F
P
p
.60955 .32947 m .63539 .33523 L .62115 .33797 L 1 .931 0 r
F
P
p
.59529 .33226 m .60955 .32947 L .62115 .33797 L 1 .931 0 r
F
P
p
.55484 .32926 m .58114 .33502 L .5671 .33776 L 1 .828 0 r
F
P
p
.54079 .33204 m .55484 .32926 L .5671 .33776 L 1 .931 0 r
F
P
p
.002 w
.70095 .55828 m .68644 .56015 L .67538 .54194 L p
1 .414 0 r
F P
0 0 0 r
s
P
p
.50011 .32904 m .52686 .33481 L .51303 .33755 L 1 .931 0 r
F
P
p
.48627 .33183 m .50011 .32904 L .51303 .33755 L 1 .983 0 r
F
P
p
.44534 .32883 m .47254 .3346 L .45892 .33734 L .966 1 0 r
F
P
p
.43171 .33162 m .44534 .32883 L .45892 .33734 L .914 1 0 r
F
P
p
.39053 .32861 m .41819 .33439 L .40477 .33713 L .034 1 0 r
F
P
p
.37712 .3314 m .39053 .32861 L .40477 .33713 L 0 1 .612 r
F
P
p
.3357 .32839 m .36381 .33417 L .3506 .33692 L 0 .897 1 r
F
P
p
.32249 .33119 m .3357 .32839 L .3506 .33692 L 0 .897 1 r
F
P
p
.002 w
.64678 .5643 m .63247 .56616 L .62121 .57912 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.62121 .57912 m .63247 .56616 L p
.61549 .58011 L 1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.62121 .57912 m .63568 .57729 L .64678 .5643 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.62121 .57912 m .60947 .57977 L p
.627 .57811 L 1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.63568 .57729 m .62121 .57912 L p
.627 .57811 L 1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.6069 .58717 m .62121 .57912 L p
.61549 .58011 L 1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.39804 .90564 m .41156 .9051 L .42557 .90673 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.78846 .32731 m .81293 .33311 L .79796 .33587 L 1 0 0 r
F
P
p
.77346 .33012 m .78846 .32731 L .79796 .33587 L 1 0 0 r
F
P
p
.73365 .3271 m .75857 .3329 L .7438 .33566 L 1 .078 0 r
F
P
p
.71885 .3299 m .73365 .3271 L .7438 .33566 L 1 .155 0 r
F
P
p
.6788 .32688 m .70418 .33268 L .68961 .33544 L 1 .569 0 r
F
P
p
.66422 .32969 m .6788 .32688 L .68961 .33544 L 1 .647 0 r
F
P
p
.62392 .32666 m .64975 .33247 L .63539 .33523 L 1 .931 0 r
F
P
p
.60955 .32947 m .62392 .32666 L .63539 .33523 L 1 .931 0 r
F
P
p
.569 .32645 m .59529 .33226 L .58114 .33502 L 1 .828 0 r
F
P
p
.55484 .32926 m .569 .32645 L .58114 .33502 L 1 .828 0 r
F
P
p
.002 w
.71526 .54404 m .70095 .55828 L .68999 .53997 L p
1 .362 0 r
F P
0 0 0 r
s
P
p
.002 w
.67538 .54194 m .68999 .53997 L .70095 .55828 L p
1 .414 0 r
F P
0 0 0 r
s
P
p
.51405 .32623 m .54079 .33204 L .52686 .33481 L 1 .931 0 r
F
P
p
.50011 .32904 m .51405 .32623 L .52686 .33481 L 1 .931 0 r
F
P
p
.45907 .32601 m .48627 .33183 L .47254 .3346 L 1 .957 0 r
F
P
p
.44534 .32883 m .45907 .32601 L .47254 .3346 L .966 1 0 r
F
P
p
.40406 .3258 m .43171 .33162 L .41819 .33439 L .526 1 0 r
F
P
p
.39053 .32861 m .40406 .3258 L .41819 .33439 L .034 1 0 r
F
P
p
.34901 .32558 m .37712 .3314 L .36381 .33417 L 0 1 .845 r
F
P
p
.3357 .32839 m .34901 .32558 L .36381 .33417 L 0 .897 1 r
F
P
p
.002 w
.59264 .58895 m .57852 .59692 L .56644 .61671 L p
.681 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72997 .54209 m .71526 .54404 L .70472 .53799 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.68999 .53997 m .70472 .53799 L .71526 .54404 L p
1 .362 0 r
F P
0 0 0 r
s
P
p
.80358 .32449 m .82803 .33033 L .81293 .33311 L 1 0 0 r
F
P
p
.78846 .32731 m .80358 .32449 L .81293 .33311 L 1 0 0 r
F
P
p
.74856 .32427 m .77346 .33012 L .75857 .3329 L 1 0 0 r
F
P
p
.73365 .3271 m .74856 .32427 L .75857 .3329 L 1 .078 0 r
F
P
p
.69349 .32405 m .71885 .3299 L .70418 .33268 L 1 .44 0 r
F
P
p
.6788 .32688 m .69349 .32405 L .70418 .33268 L 1 .569 0 r
F
P
p
.002 w
.46828 .72807 m .45278 .90348 L .43876 .90177 L p
.448 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43876 .90177 m .45513 .68604 L .46828 .72807 L p
.448 0 1 r
F P
0 0 0 r
s
P
p
.6384 .32383 m .66422 .32969 L .64975 .33247 L 1 .828 0 r
F
P
p
.62392 .32666 m .6384 .32383 L .64975 .33247 L 1 .931 0 r
F
P
p
.58327 .32362 m .60955 .32947 L .59529 .33226 L 1 .828 0 r
F
P
p
.569 .32645 m .58327 .32362 L .59529 .33226 L 1 .828 0 r
F
P
p
.52811 .3234 m .55484 .32926 L .54079 .33204 L 1 .879 0 r
F
P
p
.51405 .32623 m .52811 .3234 L .54079 .33204 L 1 .931 0 r
F
P
p
.002 w
.63568 .57729 m .65018 .56915 L .6611 .55624 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.47292 .32318 m .50011 .32904 L .48627 .33183 L 1 .853 0 r
F
P
p
.45907 .32601 m .47292 .32318 L .48627 .33183 L 1 .957 0 r
F
P
p
.41769 .32296 m .44534 .32883 L .43171 .33162 L .707 1 0 r
F
P
p
.40406 .3258 m .41769 .32296 L .43171 .33162 L .526 1 0 r
F
P
p
.002 w
.6069 .58717 m .59264 .58895 L .58078 .61502 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56644 .61671 m .58078 .61502 L .59264 .58895 L p
.681 1 0 r
F P
0 0 0 r
s
P
p
.36242 .32274 m .39053 .32861 L .37712 .3314 L 0 1 .534 r
F
P
p
.34901 .32558 m .36242 .32274 L .37712 .3314 L 0 1 .845 r
F
P
p
.30713 .32252 m .3357 .32839 L .32249 .33119 L 0 .897 1 r
F
P
p
.002 w
.51006 .6672 m .4961 .68754 L .48306 .65144 L p
0 1 .069 r
F P
0 0 0 r
s
P
p
.002 w
.46921 .65297 m .48306 .65144 L .4961 .68754 L p
0 1 .353 r
F P
0 0 0 r
s
P
p
.002 w
.74443 .52772 m .72997 .54209 L .71957 .53599 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.70472 .53799 m .71957 .53599 L .72997 .54209 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.81883 .32164 m .84324 .32753 L .82803 .33033 L 1 0 0 r
F
P
p
.80358 .32449 m .81883 .32164 L .82803 .33033 L 1 0 0 r
F
P
p
.002 w
.68999 .53997 m .67538 .54194 L .66465 .55466 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.65018 .56915 m .66465 .55466 L .67538 .54194 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.41156 .9051 m .39804 .90564 L .38357 .90398 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.76358 .32142 m .78846 .32731 L .77346 .33012 L 1 0 0 r
F
P
p
.74856 .32427 m .76358 .32142 L .77346 .33012 L 1 0 0 r
F
P
p
.70831 .3212 m .73365 .3271 L .71885 .3299 L 1 .233 0 r
F
P
p
.69349 .32405 m .70831 .3212 L .71885 .3299 L 1 .44 0 r
F
P
p
.653 .32098 m .6788 .32688 L .66422 .32969 L 1 .647 0 r
F
P
p
.6384 .32383 m .653 .32098 L .66422 .32969 L 1 .828 0 r
F
P
p
.002 w
.48306 .65144 m .49724 .60568 L .51006 .6672 L p
0 1 .069 r
F P
0 0 0 r
s
P
p
.59766 .32076 m .62392 .32666 L .60955 .32947 L 1 .828 0 r
F
P
p
.58327 .32362 m .59766 .32076 L .60955 .32947 L 1 .828 0 r
F
P
p
.54228 .32054 m .569 .32645 L .55484 .32926 L 1 .828 0 r
F
P
p
.52811 .3234 m .54228 .32054 L .55484 .32926 L 1 .879 0 r
F
P
p
.48687 .32032 m .51405 .32623 L .50011 .32904 L 1 .828 0 r
F
P
p
.47292 .32318 m .48687 .32032 L .50011 .32904 L 1 .853 0 r
F
P
p
.002 w
.75935 .5257 m .74443 .52772 L .73453 .53397 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.71957 .53599 m .73453 .53397 L .74443 .52772 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.43142 .3201 m .45907 .32601 L .44534 .32883 L .836 1 0 r
F
P
p
.41769 .32296 m .43142 .3201 L .44534 .32883 L .707 1 0 r
F
P
p
.002 w
.62121 .57912 m .6069 .58717 L .59513 .6006 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58078 .61502 m .59513 .6006 L .6069 .58717 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.37595 .31988 m .40406 .3258 L .39053 .32861 L 0 1 .121 r
F
P
p
.36242 .32274 m .37595 .31988 L .39053 .32861 L 0 1 .534 r
F
P
p
.32043 .31966 m .34901 .32558 L .3357 .32839 L 0 1 .974 r
F
P
p
.30713 .32252 m .32043 .31966 L .3357 .32839 L 0 .897 1 r
F
P
p
.002 w
.48306 .65144 m .46921 .65297 L .45591 .61645 L p
.19 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46921 .65297 m .45513 .68604 L .44203 .62444 L p
.034 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44203 .62444 m .45591 .61645 L .46921 .65297 L p
.034 1 0 r
F P
0 0 0 r
s
P
p
.83419 .31877 m .85858 .32471 L .84324 .32753 L 1 0 0 r
F
P
p
.81883 .32164 m .83419 .31877 L .84324 .32753 L 1 0 0 r
F
P
p
.002 w
.45513 .68604 m .43876 .90177 L .42439 .90002 L p
.06 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42439 .90002 m .44203 .62444 L .45513 .68604 L p
.06 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.70472 .53799 m .68999 .53997 L .67944 .55272 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.002 w
.66465 .55466 m .67944 .55272 L .68999 .53997 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.53811 .63262 m .52404 .6594 L .51125 .59766 L p
.448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49724 .60568 m .51125 .59766 L .52404 .6594 L p
.241 1 0 r
F P
0 0 0 r
s
P
p
.77873 .31855 m .80358 .32449 L .78846 .32731 L 1 0 0 r
F
P
p
.76358 .32142 m .77873 .31855 L .78846 .32731 L 1 0 0 r
F
P
p
.002 w
.42519 .90457 m .41156 .9051 L .3972 .90344 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.38357 .90398 m .3972 .90344 L .41156 .9051 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.72324 .31833 m .74856 .32427 L .73365 .3271 L 1 .155 0 r
F
P
p
.70831 .3212 m .72324 .31833 L .73365 .3271 L 1 .233 0 r
F
P
p
.002 w
.51125 .59766 m .52535 .58329 L .53811 .63262 L p
.448 1 0 r
F P
0 0 0 r
s
P
p
.66772 .31811 m .69349 .32405 L .6788 .32688 L 1 .569 0 r
F
P
p
.653 .32098 m .66772 .31811 L .6788 .32688 L 1 .647 0 r
F
P
p
.61216 .31788 m .6384 .32383 L .62392 .32666 L 1 .828 0 r
F
P
p
.59766 .32076 m .61216 .31788 L .62392 .32666 L 1 .828 0 r
F
P
p
.55656 .31766 m .58327 .32362 L .569 .32645 L 1 .776 0 r
F
P
p
.54228 .32054 m .55656 .31766 L .569 .32645 L 1 .828 0 r
F
P
p
.002 w
.59513 .6006 m .60947 .57977 L .62121 .57912 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49724 .60568 m .48306 .65144 L .46981 .61476 L p
.371 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46981 .61476 m .48383 .61305 L .49724 .60568 L p
.371 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51125 .59766 m .49724 .60568 L .48383 .61305 L p
.655 1 0 r
F P
0 0 0 r
s
P
p
.50093 .31744 m .52811 .3234 L .51405 .32623 L 1 .828 0 r
F
P
p
.48687 .32032 m .50093 .31744 L .51405 .32623 L 1 .828 0 r
F
P
p
.002 w
.77417 .51742 m .75935 .5257 L .74962 .53194 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.002 w
.73453 .53397 m .74962 .53194 L .75935 .5257 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.44527 .31722 m .47292 .32318 L .45907 .32601 L .966 1 0 r
F
P
p
.43142 .3201 m .44527 .31722 L .45907 .32601 L .836 1 0 r
F
P
p
.38958 .31699 m .41769 .32296 L .40406 .3258 L .345 1 0 r
F
P
p
.37595 .31988 m .38958 .31699 L .40406 .3258 L 0 1 .121 r
F
P
p
.33385 .31677 m .36242 .32274 L .34901 .32558 L 0 1 .716 r
F
P
p
.32043 .31966 m .33385 .31677 L .34901 .32558 L 0 1 .974 r
F
P
p
.002 w
.52535 .58329 m .53953 .58147 L .55221 .61839 L p
.655 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45591 .61645 m .46981 .61476 L .48306 .65144 L p
.19 1 0 r
F P
0 0 0 r
s
P
p
.84968 .31588 m .87403 .32186 L .85858 .32471 L 1 0 0 r
F
P
p
.83419 .31877 m .84968 .31588 L .85858 .32471 L 1 0 0 r
F
P
p
.002 w
.71957 .53599 m .70472 .53799 L .69393 .53179 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.67944 .55272 m .69393 .53179 L .70472 .53799 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.794 .31566 m .81883 .32164 L .80358 .32449 L 1 0 0 r
F
P
p
.77873 .31855 m .794 .31566 L .80358 .32449 L 1 0 0 r
F
P
p
.002 w
.43893 .90403 m .42519 .90457 L .41094 .90289 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.3972 .90344 m .41094 .90289 L .42519 .90457 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.45591 .61645 m .44203 .62444 L .42799 .6193 L p
.526 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44203 .62444 m .42439 .90002 L .4127 .71113 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.4127 .71113 m .42799 .6193 L .44203 .62444 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.73829 .31543 m .76358 .32142 L .74856 .32427 L 1 .155 0 r
F
P
p
.72324 .31833 m .73829 .31543 L .74856 .32427 L 1 .155 0 r
F
P
p
.002 w
.52535 .58329 m .51125 .59766 L .49806 .59219 L p
.862 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48383 .61305 m .49806 .59219 L .51125 .59766 L p
.655 1 0 r
F P
0 0 0 r
s
P
p
.68255 .31521 m .70831 .3212 L .69349 .32405 L 1 .517 0 r
F
P
p
.66772 .31811 m .68255 .31521 L .69349 .32405 L 1 .569 0 r
F
P
p
.002 w
.78931 .51534 m .77417 .51742 L .76422 .51096 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74962 .53194 m .76422 .51096 L .77417 .51742 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.62677 .31498 m .653 .32098 L .6384 .32383 L 1 .776 0 r
F
P
p
.61216 .31788 m .62677 .31498 L .6384 .32383 L 1 .828 0 r
F
P
p
.57096 .31476 m .59766 .32076 L .58327 .32362 L 1 .724 0 r
F
P
p
.55656 .31766 m .57096 .31476 L .58327 .32362 L 1 .776 0 r
F
P
p
.002 w
.65018 .56915 m .63568 .57729 L .6241 .57792 L p
1 .957 0 r
F P
0 0 0 r
s
P
p
.002 w
.60947 .57977 m .6241 .57792 L .63568 .57729 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.51511 .31454 m .54228 .32054 L .52811 .3234 L 1 .828 0 r
F
P
p
.50093 .31744 m .51511 .31454 L .52811 .3234 L 1 .828 0 r
F
P
p
.45923 .31431 m .48687 .32032 L .47292 .32318 L 1 .879 0 r
F
P
p
.44527 .31722 m .45923 .31431 L .47292 .32318 L .966 1 0 r
F
P
p
.40332 .31409 m .43142 .3201 L .41769 .32296 L .5 1 0 r
F
P
p
.38958 .31699 m .40332 .31409 L .41769 .32296 L .345 1 0 r
F
P
p
.34737 .31386 m .37595 .31988 L .36242 .32274 L 0 1 .586 r
F
P
p
.33385 .31677 m .34737 .31386 L .36242 .32274 L 0 1 .716 r
F
P
p
.002 w
.53953 .58147 m .52535 .58329 L .5123 .57764 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49806 .59219 m .5123 .57764 L .52535 .58329 L p
.862 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58078 .61502 m .56644 .61671 L .55381 .57963 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53953 .58147 m .55381 .57963 L .56644 .61671 L p
.707 1 0 r
F P
0 0 0 r
s
P
p
.29138 .31364 m .32043 .31966 L .30713 .32252 L 0 1 .974 r
F
P
p
.002 w
.46981 .61476 m .45591 .61645 L .44239 .57935 L p
.707 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42799 .6193 m .44239 .57935 L .45591 .61645 L p
.526 1 0 r
F P
0 0 0 r
s
P
p
.86529 .31296 m .88961 .31899 L .87403 .32186 L 1 0 0 r
F
P
p
.84968 .31588 m .86529 .31296 L .87403 .32186 L 1 0 0 r
F
P
p
.002 w
.73453 .53397 m .71957 .53599 L .70891 .52974 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.70891 .52974 m .71957 .53599 L p
.70359 .53337 L 1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.70891 .52974 m .72352 .50866 L .73453 .53397 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.70891 .52974 m .69871 .55549 L p
.71431 .52606 L 1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.72352 .50866 m .70891 .52974 L p
.71431 .52606 L 1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.69393 .53179 m .70891 .52974 L p
.70359 .53337 L 1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.45278 .90348 m .43893 .90403 L .42479 .90233 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.41094 .90289 m .42479 .90233 L .43893 .90403 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.8094 .31274 m .83419 .31877 L .81883 .32164 L 1 0 0 r
F
P
p
.794 .31566 m .8094 .31274 L .81883 .32164 L 1 0 0 r
F
P
p
.002 w
.3972 .90344 m .38357 .90398 L .36875 .90229 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.75347 .31251 m .77873 .31855 L .76358 .32142 L 1 .155 0 r
F
P
p
.73829 .31543 m .75347 .31251 L .76358 .32142 L 1 .155 0 r
F
P
p
.002 w
.6241 .57792 m .63884 .57606 L .65018 .56915 L p
1 .957 0 r
F P
0 0 0 r
s
P
p
.002 w
.66465 .55466 m .65018 .56915 L .63884 .57606 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.6975 .31229 m .72324 .31833 L .70831 .3212 L 1 .388 0 r
F
P
p
.68255 .31521 m .6975 .31229 L .70831 .3212 L 1 .517 0 r
F
P
p
.002 w
.80457 .51324 m .78931 .51534 L .77951 .50883 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76422 .51096 m .77951 .50883 L .78931 .51534 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64151 .31206 m .66772 .31811 L .653 .32098 L 1 .621 0 r
F
P
p
.62677 .31498 m .64151 .31206 L .653 .32098 L 1 .776 0 r
F
P
p
.58547 .31184 m .61216 .31788 L .59766 .32076 L 1 .698 0 r
F
P
p
.57096 .31476 m .58547 .31184 L .59766 .32076 L 1 .724 0 r
F
P
p
.52941 .31161 m .55656 .31766 L .54228 .32054 L 1 .828 0 r
F
P
p
.51511 .31454 m .52941 .31161 L .54228 .32054 L 1 .828 0 r
F
P
p
.4733 .31138 m .50093 .31744 L .48687 .32032 L 1 .828 0 r
F
P
p
.45923 .31431 m .4733 .31138 L .48687 .32032 L 1 .879 0 r
F
P
p
.41717 .31116 m .44527 .31722 L .43142 .3201 L .578 1 0 r
F
P
p
.40332 .31409 m .41717 .31116 L .43142 .3201 L .5 1 0 r
F
P
p
.361 .31093 m .38958 .31699 L .37595 .31988 L 0 1 .379 r
F
P
p
.34737 .31386 m .361 .31093 L .37595 .31988 L 0 1 .586 r
F
P
p
.002 w
.67944 .55272 m .66465 .55466 L .6537 .57417 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.63884 .57606 m .6537 .57417 L .66465 .55466 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.55381 .57963 m .53953 .58147 L .5266 .57577 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5123 .57764 m .5266 .57577 L .53953 .58147 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59513 .6006 m .58078 .61502 L .56816 .56508 L p
.862 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55381 .57963 m .56816 .56508 L .58078 .61502 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.30479 .3107 m .33385 .31677 L .32043 .31966 L 0 1 .716 r
F
P
p
.29138 .31364 m .30479 .3107 L .32043 .31966 L 0 1 .974 r
F
P
p
.002 w
.48383 .61305 m .46981 .61476 L .45636 .57749 L p
.707 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44239 .57935 m .45636 .57749 L .46981 .61476 L p
.707 1 0 r
F P
0 0 0 r
s
P
p
.88103 .31002 m .90532 .3161 L .88961 .31899 L 1 0 0 r
F
P
p
.86529 .31296 m .88103 .31002 L .88961 .31899 L 1 0 0 r
F
P
p
.002 w
.74962 .53194 m .73453 .53397 L .72352 .50866 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.42479 .90233 m .43876 .90177 L .45278 .90348 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.82491 .3098 m .84968 .31588 L .83419 .31877 L 1 0 0 r
F
P
p
.8094 .31274 m .82491 .3098 L .83419 .31877 L 1 0 0 r
F
P
p
.76876 .30957 m .794 .31566 L .77873 .31855 L 1 .155 0 r
F
P
p
.75347 .31251 m .76876 .30957 L .77873 .31855 L 1 .155 0 r
F
P
p
.002 w
.41094 .90289 m .3972 .90344 L .38249 .90173 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.36875 .90229 m .38249 .90173 L .3972 .90344 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.71258 .30934 m .73829 .31543 L .72324 .31833 L 1 .31 0 r
F
P
p
.6975 .31229 m .71258 .30934 L .72324 .31833 L 1 .388 0 r
F
P
p
.002 w
.81995 .51113 m .80457 .51324 L .79492 .50668 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77951 .50883 m .79492 .50668 L .80457 .51324 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.65636 .30911 m .68255 .31521 L .66772 .31811 L 1 .414 0 r
F
P
p
.64151 .31206 m .65636 .30911 L .66772 .31811 L 1 .621 0 r
F
P
p
.002 w
.60947 .57977 m .59513 .6006 L .58265 .56316 L p
.991 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56816 .56508 m .58265 .56316 L .59513 .6006 L p
.862 1 0 r
F P
0 0 0 r
s
P
p
.6001 .30889 m .62677 .31498 L .61216 .31788 L 1 .672 0 r
F
P
p
.58547 .31184 m .6001 .30889 L .61216 .31788 L 1 .698 0 r
F
P
p
.54381 .30866 m .57096 .31476 L .55656 .31766 L 1 .776 0 r
F
P
p
.52941 .31161 m .54381 .30866 L .55656 .31766 L 1 .828 0 r
F
P
p
.48749 .30843 m .51511 .31454 L .50093 .31744 L 1 .828 0 r
F
P
p
.4733 .31138 m .48749 .30843 L .50093 .31744 L 1 .828 0 r
F
P
p
.43113 .3082 m .45923 .31431 L .44527 .31722 L .759 1 0 r
F
P
p
.41717 .31116 m .43113 .3082 L .44527 .31722 L .578 1 0 r
F
P
p
.002 w
.6241 .57792 m .60947 .57977 L .59726 .56123 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.002 w
.58265 .56316 m .59726 .56123 L .60947 .57977 L p
.991 1 0 r
F P
0 0 0 r
s
P
p
.37474 .30797 m .40332 .31409 L .38958 .31699 L 0 1 .121 r
F
P
p
.361 .31093 m .37474 .30797 L .38958 .31699 L 0 1 .379 r
F
P
p
.002 w
.69393 .53179 m .67944 .55272 L .66844 .55943 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.66844 .55943 m .65669 .54039 L p
.67461 .5518 L 1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.66844 .55943 m .67944 .55272 L p
.66234 .56696 L 1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.66844 .55943 m .68352 .55747 L .69393 .53179 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.68352 .55747 m .66844 .55943 L p
.67461 .5518 L 1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.6537 .57417 m .66844 .55943 L p
.66234 .56696 L 1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.56816 .56508 m .55381 .57963 L .54102 .57388 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.002 w
.5266 .57577 m .54102 .57388 L .55381 .57963 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.31831 .30775 m .34737 .31386 L .33385 .31677 L 0 1 .534 r
F
P
p
.30479 .3107 m .31831 .30775 L .33385 .31677 L 0 1 .716 r
F
P
p
.002 w
.44239 .57935 m .42799 .6193 L .41391 .59471 L p
.681 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42801 .58645 m .44239 .57935 L p
.42823 .58699 L .681 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41391 .59471 m .42801 .58645 L p
.42823 .58699 L .681 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39884 .66109 m .41391 .59471 L .42799 .6193 L p
0 1 .121 r
F P
0 0 0 r
s
P
p
.002 w
.41391 .59471 m .39884 .66109 L .38386 .65628 L p
.034 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39872 .61518 m .41391 .59471 L p
.39902 .62523 L .034 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.38386 .65628 m .39872 .61518 L p
.39902 .62523 L .034 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39872 .61518 m .38357 .60973 L p
.39841 .60499 L .345 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42801 .58645 m .41391 .59471 L .39872 .61518 L p
.526 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4131 .6003 m .39872 .61518 L p
.40873 .6017 L .345 1 0 r
F P
0 0 0 r
s
P
p
.39841 .60499 m .40873 .6017 L .39872 .61518 L .345 1 0 r
F
P
p
.002 w
.42801 .58645 m .4131 .6003 L p
.42779 .5859 L .707 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44228 .57169 m .42801 .58645 L p
.42779 .5859 L .707 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45636 .57749 m .44239 .57935 L .42801 .58645 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49806 .59219 m .48383 .61305 L .47043 .57562 L p
.836 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45636 .57749 m .47043 .57562 L .48383 .61305 L p
.707 1 0 r
F P
0 0 0 r
s
P
p
.89689 .30706 m .92115 .31319 L .90532 .3161 L 1 0 0 r
F
P
p
.88103 .31002 m .89689 .30706 L .90532 .3161 L 1 0 0 r
F
P
p
.002 w
.76422 .51096 m .74962 .53194 L .73871 .50651 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.72352 .50866 m .73871 .50651 L .74962 .53194 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.84056 .30683 m .86529 .31296 L .84968 .31588 L 1 0 0 r
F
P
p
.82491 .3098 m .84056 .30683 L .84968 .31588 L 1 0 0 r
F
P
p
.002 w
.70891 .52974 m .69393 .53179 L .68352 .55747 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.78418 .3066 m .8094 .31274 L .794 .31566 L 1 .078 0 r
F
P
p
.76876 .30957 m .78418 .3066 L .794 .31566 L 1 .155 0 r
F
P
p
.002 w
.42479 .90233 m .41094 .90289 L .39634 .90116 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.38249 .90173 m .39634 .90116 L .41094 .90289 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.42799 .6193 m .4127 .71113 L .39884 .66109 L p
0 1 .121 r
F P
0 0 0 r
s
P
p
.72778 .30637 m .75347 .31251 L .73829 .31543 L 1 .31 0 r
F
P
p
.71258 .30934 m .72778 .30637 L .73829 .31543 L 1 .31 0 r
F
P
p
.002 w
.5123 .57764 m .49806 .59219 L .48471 .56093 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.47043 .57562 m .48471 .56093 L .49806 .59219 L p
.836 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.83546 .50899 m .81995 .51113 L .81045 .50451 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79492 .50668 m .81045 .50451 L .81995 .51113 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67133 .30614 m .6975 .31229 L .68255 .31521 L 1 .31 0 r
F
P
p
.65636 .30911 m .67133 .30614 L .68255 .31521 L 1 .414 0 r
F
P
p
.002 w
.58265 .56316 m .56816 .56508 L .55551 .55913 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.54102 .57388 m .55551 .55913 L .56816 .56508 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.002 w
.77951 .50883 m .76422 .51096 L .75402 .50434 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73871 .50651 m .75402 .50434 L .76422 .51096 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.61485 .30591 m .64151 .31206 L .62677 .31498 L 1 .621 0 r
F
P
p
.6001 .30889 m .61485 .30591 L .62677 .31498 L 1 .672 0 r
F
P
p
.55834 .30568 m .58547 .31184 L .57096 .31476 L 1 .724 0 r
F
P
p
.54381 .30866 m .55834 .30568 L .57096 .31476 L 1 .776 0 r
F
P
p
.50179 .30545 m .52941 .31161 L .51511 .31454 L 1 .828 0 r
F
P
p
.48749 .30843 m .50179 .30545 L .51511 .31454 L 1 .828 0 r
F
P
p
.44521 .30522 m .4733 .31138 L .45923 .31431 L .94 1 0 r
F
P
p
.43113 .3082 m .44521 .30522 L .45923 .31431 L .759 1 0 r
F
P
p
.002 w
.63884 .57606 m .6241 .57792 L .61199 .55928 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.002 w
.59726 .56123 m .61199 .55928 L .6241 .57792 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.38859 .30499 m .41717 .31116 L .40332 .31409 L .138 1 0 r
F
P
p
.37474 .30797 m .38859 .30499 L .40332 .31409 L 0 1 .121 r
F
P
p
.33193 .30476 m .361 .31093 L .34737 .31386 L 0 1 .483 r
F
P
p
.31831 .30775 m .33193 .30476 L .34737 .31386 L 0 1 .534 r
F
P
p
.002 w
.5266 .57577 m .5123 .57764 L .49899 .55898 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.002 w
.48471 .56093 m .49899 .55898 L .5123 .57764 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.27524 .30453 m .30479 .3107 L .29138 .31364 L 0 1 .845 r
F
P
p
.002 w
.47043 .57562 m .45636 .57749 L .44228 .57169 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42801 .58645 m .44228 .57169 L .45636 .57749 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.89689 .30706 m .91289 .30407 L .92115 .31319 L 1 0 0 r
F
P
p
.85633 .30384 m .88103 .31002 L .86529 .31296 L 1 0 0 r
F
P
p
.84056 .30683 m .85633 .30384 L .86529 .31296 L 1 0 0 r
F
P
p
.002 w
.68352 .55747 m .69871 .55549 L .70891 .52974 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.79973 .30361 m .82491 .3098 L .8094 .31274 L 1 0 0 r
F
P
p
.78418 .3066 m .79973 .30361 L .8094 .31274 L 1 .078 0 r
F
P
p
.002 w
.43876 .90177 m .42479 .90233 L .41031 .90059 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.39634 .90116 m .41031 .90059 L .42479 .90233 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7431 .30338 m .76876 .30957 L .75347 .31251 L 1 .259 0 r
F
P
p
.72778 .30637 m .7431 .30338 L .75347 .31251 L 1 .31 0 r
F
P
p
.002 w
.38249 .90173 m .36875 .90229 L .35355 .90055 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.42439 .90002 m .41031 .90059 L .39884 .71246 L p
.552 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39884 .71246 m .4127 .71113 L .42439 .90002 L p
.552 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38137 .8994 m .39884 .71246 L .41031 .90059 L p
1 0 .724 r
F P
0 0 0 r
s
P
p
.002 w
.4127 .71113 m .39884 .71246 L .38402 .70834 L p
0 1 .922 r
F P
0 0 0 r
s
P
p
.002 w
.39884 .71246 m .38137 .8994 L .37016 .70969 L p
0 .172 1 r
F P
0 0 0 r
s
P
p
.002 w
.37016 .70969 m .38402 .70834 L .39884 .71246 L p
0 .172 1 r
F P
0 0 0 r
s
P
p
.002 w
.85109 .50684 m .83546 .50899 L .82611 .50232 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81045 .50451 m .82611 .50232 L .83546 .50899 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68643 .30315 m .71258 .30934 L .6975 .31229 L 1 .31 0 r
F
P
p
.67133 .30614 m .68643 .30315 L .6975 .31229 L 1 .31 0 r
F
P
p
.002 w
.59726 .56123 m .58265 .56316 L .57014 .55717 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.55551 .55913 m .57014 .55717 L .58265 .56316 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.79492 .50668 m .77951 .50883 L .76946 .50215 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75402 .50434 m .76946 .50215 L .77951 .50883 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.62972 .30292 m .65636 .30911 L .64151 .31206 L 1 .543 0 r
F
P
p
.61485 .30591 m .62972 .30292 L .64151 .31206 L 1 .621 0 r
F
P
p
.002 w
.73871 .50651 m .72352 .50866 L .71372 .54055 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.69871 .55549 m .71372 .54055 L .72352 .50866 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.57298 .30268 m .6001 .30889 L .58547 .31184 L 1 .647 0 r
F
P
p
.55834 .30568 m .57298 .30268 L .58547 .31184 L 1 .724 0 r
F
P
p
.51621 .30245 m .54381 .30866 L .52941 .31161 L 1 .802 0 r
F
P
p
.50179 .30545 m .51621 .30245 L .52941 .31161 L 1 .828 0 r
F
P
p
.4594 .30222 m .48749 .30843 L .4733 .31138 L 1 .983 0 r
F
P
p
.44521 .30522 m .4594 .30222 L .4733 .31138 L .94 1 0 r
F
P
p
.002 w
.6537 .57417 m .63884 .57606 L .62684 .55732 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.002 w
.61199 .55928 m .62684 .55732 L .63884 .57606 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.40255 .30199 m .43113 .3082 L .41717 .31116 L .397 1 0 r
F
P
p
.38859 .30499 m .40255 .30199 L .41717 .31116 L .138 1 0 r
F
P
p
.34567 .30176 m .37474 .30797 L .361 .31093 L 0 1 .353 r
F
P
p
.33193 .30476 m .34567 .30176 L .361 .31093 L 0 1 .483 r
F
P
p
.002 w
.54102 .57388 m .5266 .57577 L .51339 .55702 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.002 w
.49899 .55898 m .51339 .55702 L .5266 .57577 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.28875 .30152 m .31831 .30775 L .30479 .3107 L 0 1 .276 r
F
P
p
.27524 .30453 m .28875 .30152 L .30479 .3107 L 0 1 .845 r
F
P
p
.002 w
.48471 .56093 m .47043 .57562 L .45647 .56977 L p
1 .957 0 r
F P
0 0 0 r
s
P
p
.002 w
.44228 .57169 m .45647 .56977 L p
.45172 .57301 L .966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42756 .58535 m .44228 .57169 L p
.42779 .5859 L .707 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4131 .6003 m .42756 .58535 L p
.42779 .5859 L .707 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42756 .58535 m .4131 .6003 L .3981 .59464 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3981 .59464 m .41249 .59277 L .42756 .58535 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42756 .58535 m .41249 .59277 L p
.42732 .58478 L .578 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45647 .56977 m .44228 .57169 L .42756 .58535 L p
.836 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44199 .57688 m .42756 .58535 L p
.42933 .5837 L .578 1 0 r
F P
0 0 0 r
s
P
p
.42732 .58478 m .42933 .5837 L .42756 .58535 L .578 1 0 r
F
P
p
.002 w
.45647 .56977 m .44199 .57688 L p
.4613 .56649 L .966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47084 .56135 m .45647 .56977 L p
.4613 .56649 L .966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45647 .56977 m .47043 .57562 L p
.45172 .57301 L .966 1 0 r
F P
0 0 0 r
s
P
p
.87223 .30083 m .89689 .30706 L .88103 .31002 L 1 0 0 r
F
P
p
.85633 .30384 m .87223 .30083 L .88103 .31002 L 1 0 0 r
F
P
p
.002 w
.41031 .90059 m .42439 .90002 L .43876 .90177 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.8154 .30059 m .84056 .30683 L .82491 .3098 L 1 0 0 r
F
P
p
.79973 .30361 m .8154 .30059 L .82491 .3098 L 1 0 0 r
F
P
p
.75854 .30036 m .78418 .3066 L .76876 .30957 L 1 .207 0 r
F
P
p
.7431 .30338 m .75854 .30036 L .76876 .30957 L 1 .259 0 r
F
P
p
.002 w
.39634 .90116 m .38249 .90173 L .3674 .89998 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.35355 .90055 m .3674 .89998 L .38249 .90173 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.38402 .70834 m .39884 .66109 L .4127 .71113 L p
0 1 .922 r
F P
0 0 0 r
s
P
p
.002 w
.86684 .50468 m .85109 .50684 L .8419 .50012 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82611 .50232 m .8419 .50012 L .85109 .50684 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70165 .30013 m .72778 .30637 L .71258 .30934 L 1 .31 0 r
F
P
p
.68643 .30315 m .70165 .30013 L .71258 .30934 L 1 .31 0 r
F
P
p
.002 w
.38137 .8994 m .3674 .89998 L .35641 .71103 L p
.552 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.35641 .71103 m .37016 .70969 L .38137 .8994 L p
.552 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.33797 .89877 m .35641 .71103 L .3674 .89998 L p
1 0 .724 r
F P
0 0 0 r
s
P
p
.002 w
.37016 .70969 m .35641 .71103 L .34099 .70688 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.35641 .71103 m .33797 .89877 L .32724 .70824 L p
0 .172 1 r
F P
0 0 0 r
s
P
p
.002 w
.32724 .70824 m .34099 .70688 L .35641 .71103 L p
0 .172 1 r
F P
0 0 0 r
s
P
p
.002 w
.61199 .55928 m .59726 .56123 L .58488 .55519 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.57014 .55717 m .58488 .55519 L .59726 .56123 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.81045 .50451 m .79492 .50668 L .78502 .49995 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76946 .50215 m .78502 .49995 L .79492 .50668 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64472 .29989 m .67133 .30614 L .65636 .30911 L 1 .414 0 r
F
P
p
.62972 .30292 m .64472 .29989 L .65636 .30911 L 1 .543 0 r
F
P
p
.002 w
.72862 .51908 m .73871 .50651 L p
.7263 .52342 L 1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.71372 .54055 m .72862 .51908 L p
.7263 .52342 L 1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.72862 .51908 m .71772 .51241 L p
.73098 .51468 L 1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.75402 .50434 m .73871 .50651 L .72862 .51908 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.72862 .51908 m .74412 .51693 L .75402 .50434 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.74412 .51693 m .72862 .51908 L p
.73098 .51468 L 1 .31 0 r
F P
0 0 0 r
s
P
p
.58775 .29966 m .61485 .30591 L .6001 .30889 L 1 .543 0 r
F
P
p
.57298 .30268 m .58775 .29966 L .6001 .30889 L 1 .647 0 r
F
P
p
.002 w
.49899 .55898 m .48471 .56093 L .47084 .56135 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.45647 .56977 m .47084 .56135 L .48471 .56093 L p
1 .957 0 r
F P
0 0 0 r
s
P
p
.53074 .29943 m .55834 .30568 L .54381 .30866 L 1 .698 0 r
F
P
p
.51621 .30245 m .53074 .29943 L .54381 .30866 L 1 .802 0 r
F
P
p
.47371 .29919 m .50179 .30545 L .48749 .30843 L 1 .905 0 r
F
P
p
.4594 .30222 m .47371 .29919 L .48749 .30843 L 1 .983 0 r
F
P
p
.002 w
.66844 .55943 m .6537 .57417 L .64181 .55534 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.62684 .55732 m .64181 .55534 L .6537 .57417 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.41663 .29896 m .44521 .30522 L .43113 .3082 L .526 1 0 r
F
P
p
.40255 .30199 m .41663 .29896 L .43113 .3082 L .397 1 0 r
F
P
p
.35952 .29873 m .38859 .30499 L .37474 .30797 L 0 1 .198 r
F
P
p
.34567 .30176 m .35952 .29873 L .37474 .30797 L 0 1 .353 r
F
P
p
.002 w
.55551 .55913 m .54102 .57388 L .52791 .55503 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.51339 .55702 m .52791 .55503 L .54102 .57388 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.30237 .29849 m .33193 .30476 L .31831 .30775 L .19 1 0 r
F
P
p
.28875 .30152 m .30237 .29849 L .31831 .30775 L 0 1 .276 r
F
P
p
.88826 .29779 m .91289 .30407 L .89689 .30706 L 1 0 0 r
F
P
p
.87223 .30083 m .88826 .29779 L .89689 .30706 L 1 0 0 r
F
P
p
.8312 .29755 m .85633 .30384 L .84056 .30683 L 1 0 0 r
F
P
p
.8154 .30059 m .8312 .29755 L .84056 .30683 L 1 0 0 r
F
P
p
.77411 .29732 m .79973 .30361 L .78418 .3066 L 1 .103 0 r
F
P
p
.75854 .30036 m .77411 .29732 L .78418 .3066 L 1 .207 0 r
F
P
p
.002 w
.41031 .90059 m .39634 .90116 L .38137 .8994 L p
1 0 .724 r
F P
0 0 0 r
s
P
p
.002 w
.3674 .89998 m .38137 .8994 L .39634 .90116 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64181 .55534 m .65669 .54039 L .66844 .55943 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.88273 .50249 m .86684 .50468 L .85782 .4979 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8419 .50012 m .85782 .4979 L .86684 .50468 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.71699 .29708 m .7431 .30338 L .72778 .30637 L 1 .284 0 r
F
P
p
.70165 .30013 m .71699 .29708 L .72778 .30637 L 1 .31 0 r
F
P
p
.002 w
.38402 .70834 m .37016 .70969 L .35485 .7055 L p
0 1 .974 r
F P
0 0 0 r
s
P
p
.002 w
.34099 .70688 m .35485 .7055 L .37016 .70969 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.62684 .55732 m .61199 .55928 L .59974 .55319 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.58488 .55519 m .59974 .55319 L .61199 .55928 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.82611 .50232 m .81045 .50451 L .80071 .49773 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78502 .49995 m .80071 .49773 L .81045 .50451 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.65983 .29685 m .68643 .30315 L .67133 .30614 L 1 .31 0 r
F
P
p
.64472 .29989 m .65983 .29685 L .67133 .30614 L 1 .414 0 r
F
P
p
.002 w
.57014 .55717 m .55551 .55913 L .54254 .55304 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.52791 .55503 m .54254 .55304 L .55551 .55913 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.39872 .61518 m .4131 .6003 L .42801 .58645 L p
.526 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.76946 .50215 m .75402 .50434 L .74412 .51693 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.60263 .29661 m .62972 .30292 L .61485 .30591 L 1 .44 0 r
F
P
p
.58775 .29966 m .60263 .29661 L .61485 .30591 L 1 .543 0 r
F
P
p
.002 w
.51339 .55702 m .49899 .55898 L .48531 .55288 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.47084 .56135 m .48531 .55288 L .49899 .55898 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.5454 .29638 m .57298 .30268 L .55834 .30568 L 1 .595 0 r
F
P
p
.53074 .29943 m .5454 .29638 L .55834 .30568 L 1 .698 0 r
F
P
p
.48813 .29614 m .51621 .30245 L .50179 .30545 L 1 .879 0 r
F
P
p
.47371 .29919 m .48813 .29614 L .50179 .30545 L 1 .905 0 r
F
P
p
.43083 .29591 m .4594 .30222 L .44521 .30522 L .603 1 0 r
F
P
p
.41663 .29896 m .43083 .29591 L .44521 .30522 L .526 1 0 r
F
P
p
.37348 .29567 m .40255 .30199 L .38859 .30499 L .086 1 0 r
F
P
p
.35952 .29873 m .37348 .29567 L .38859 .30499 L 0 1 .198 r
F
P
p
.002 w
.39884 .66109 m .38402 .70834 L .36956 .67101 L p
0 1 .612 r
F P
0 0 0 r
s
P
p
.002 w
.36956 .67101 m .38386 .65628 L .39884 .66109 L p
0 1 .612 r
F P
0 0 0 r
s
P
p
.31611 .29543 m .34567 .30176 L .33193 .30476 L .371 1 0 r
F
P
p
.30237 .29849 m .31611 .29543 L .33193 .30476 L .19 1 0 r
F
P
p
.25869 .2952 m .28875 .30152 L .27524 .30453 L 0 1 .974 r
F
P
p
.88826 .29779 m .90442 .29472 L .91289 .30407 L 1 0 0 r
F
P
p
.84714 .29449 m .87223 .30083 L .85633 .30384 L 1 0 0 r
F
P
p
.8312 .29755 m .84714 .29449 L .85633 .30384 L 1 0 0 r
F
P
p
.78982 .29425 m .8154 .30059 L .79973 .30361 L 1 0 0 r
F
P
p
.77411 .29732 m .78982 .29425 L .79973 .30361 L 1 .103 0 r
F
P
p
.002 w
.69871 .55549 m .68352 .55747 L .67151 .51892 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.65669 .54039 m .67151 .51892 L .68352 .55747 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.89875 .50029 m .88273 .50249 L .87387 .49566 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85782 .4979 m .87387 .49566 L .88273 .50249 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.73246 .29401 m .75854 .30036 L .7431 .30338 L 1 .181 0 r
F
P
p
.71699 .29708 m .73246 .29401 L .7431 .30338 L 1 .284 0 r
F
P
p
.002 w
.3674 .89998 m .35355 .90055 L .33797 .89877 L p
1 0 .724 r
F P
0 0 0 r
s
P
p
.002 w
.35485 .7055 m .36956 .67101 L .38402 .70834 L p
0 1 .974 r
F P
0 0 0 r
s
P
p
.002 w
.64181 .55534 m .62684 .55732 L .61473 .55118 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.59974 .55319 m .61473 .55118 L .62684 .55732 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.8419 .50012 m .82611 .50232 L .81653 .49548 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80071 .49773 m .81653 .49548 L .82611 .50232 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67507 .29378 m .70165 .30013 L .68643 .30315 L 1 .233 0 r
F
P
p
.65983 .29685 m .67507 .29378 L .68643 .30315 L 1 .31 0 r
F
P
p
.002 w
.34099 .70688 m .32724 .70824 L .31132 .70401 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.58488 .55519 m .57014 .55717 L .5573 .55102 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.54254 .55304 m .5573 .55102 L .57014 .55717 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.78502 .49995 m .76946 .50215 L .75976 .51476 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.74412 .51693 m .75976 .51476 L .76946 .50215 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.61764 .29354 m .64472 .29989 L .62972 .30292 L 1 .362 0 r
F
P
p
.60263 .29661 m .61764 .29354 L .62972 .30292 L 1 .44 0 r
F
P
p
.002 w
.52791 .55503 m .51339 .55702 L .49983 .55087 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.48531 .55288 m .49983 .55087 L .51339 .55702 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.56018 .2933 m .58775 .29966 L .57298 .30268 L 1 .517 0 r
F
P
p
.5454 .29638 m .56018 .2933 L .57298 .30268 L 1 .595 0 r
F
P
p
.50268 .29306 m .53074 .29943 L .51621 .30245 L 1 .828 0 r
F
P
p
.48813 .29614 m .50268 .29306 L .51621 .30245 L 1 .879 0 r
F
P
p
.44514 .29283 m .47371 .29919 L .4594 .30222 L .655 1 0 r
F
P
p
.43083 .29591 m .44514 .29283 L .4594 .30222 L .603 1 0 r
F
P
p
.38756 .29259 m .41663 .29896 L .40255 .30199 L .397 1 0 r
F
P
p
.37348 .29567 m .38756 .29259 L .40255 .30199 L .086 1 0 r
F
P
p
.32995 .29235 m .35952 .29873 L .34567 .30176 L .526 1 0 r
F
P
p
.31611 .29543 m .32995 .29235 L .34567 .30176 L .371 1 0 r
F
P
p
.27231 .29211 m .30237 .29849 L .28875 .30152 L 0 1 .534 r
F
P
p
.25869 .2952 m .27231 .29211 L .28875 .30152 L 0 1 .974 r
F
P
p
.002 w
.42756 .58535 m .44199 .57688 L p
.44691 .57493 L .836 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41249 .59277 m .42699 .59088 L .44199 .57688 L p
.578 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44199 .57688 m .42699 .59088 L p
.43698 .57888 L .759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45667 .55523 m .44199 .57688 L p
.43698 .57888 L .759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44199 .57688 m .45647 .56977 L p
.44691 .57493 L .836 1 0 r
F P
0 0 0 r
s
P
p
.8632 .2914 m .88826 .29779 L .87223 .30083 L 1 0 0 r
F
P
p
.84714 .29449 m .8632 .2914 L .87223 .30083 L 1 0 0 r
F
P
p
.80565 .29116 m .8312 .29755 L .8154 .30059 L 1 0 0 r
F
P
p
.78982 .29425 m .80565 .29116 L .8154 .30059 L 1 0 0 r
F
P
p
.002 w
.71372 .54055 m .69871 .55549 L .68679 .51677 L p
1 .517 0 r
F P
0 0 0 r
s
P
p
.002 w
.67151 .51892 m .68679 .51677 L .69871 .55549 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.91489 .49807 m .89875 .50029 L .89005 .4934 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.87387 .49566 m .89005 .4934 L .89875 .50029 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.74806 .29092 m .77411 .29732 L .75854 .30036 L 1 .078 0 r
F
P
p
.73246 .29401 m .74806 .29092 L .75854 .30036 L 1 .181 0 r
F
P
p
.002 w
.65669 .54039 m .64181 .55534 L .63287 .55071 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.63886 .54621 m .65669 .54039 L .63287 .55071 L 1 .776 0 r
F
P
p
.002 w
.63287 .55071 m .62984 .54915 L p
.63886 .54621 L 1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.62984 .54915 m .64508 .5471 L .65669 .54039 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.67151 .51892 m .65669 .54039 L .64508 .5471 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.64508 .5471 m .66033 .53845 L .66875 .52374 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.66875 .52374 m .67151 .51892 L p
.66278 .52823 L 1 .621 0 r
F P
0 0 0 r
s
P
p
.64508 .5471 m .66875 .52374 L .66278 .52823 L 1 .621 0 r
F
P
p
.002 w
.61473 .55118 m .62984 .54915 L .64181 .55534 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.85782 .4979 m .8419 .50012 L .83248 .49322 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81653 .49548 m .83248 .49322 L .8419 .50012 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69044 .29068 m .71699 .29708 L .70165 .30013 L 1 .155 0 r
F
P
p
.67507 .29378 m .69044 .29068 L .70165 .30013 L 1 .233 0 r
F
P
p
.002 w
.35485 .7055 m .34099 .70688 L .32518 .70262 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.31132 .70401 m .32518 .70262 L .34099 .70688 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.59974 .55319 m .58488 .55519 L .57211 .53593 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.5573 .55102 m .57211 .53593 L .58488 .55519 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.80071 .49773 m .78502 .49995 L .77552 .51258 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.75976 .51476 m .77552 .51258 L .78502 .49995 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.63277 .29044 m .65983 .29685 L .64472 .29989 L 1 .336 0 r
F
P
p
.61764 .29354 m .63277 .29044 L .64472 .29989 L 1 .362 0 r
F
P
p
.002 w
.54254 .55304 m .52791 .55503 L .51448 .54883 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.49983 .55087 m .51448 .54883 L .52791 .55503 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.57508 .2902 m .60263 .29661 L .58775 .29966 L 1 .414 0 r
F
P
p
.56018 .2933 m .57508 .2902 L .58775 .29966 L 1 .517 0 r
F
P
p
.51734 .28996 m .5454 .29638 L .53074 .29943 L 1 .698 0 r
F
P
p
.50268 .29306 m .51734 .28996 L .53074 .29943 L 1 .828 0 r
F
P
p
.45957 .28972 m .48813 .29614 L .47371 .29919 L .862 1 0 r
F
P
p
.44514 .29283 m .45957 .28972 L .47371 .29919 L .655 1 0 r
F
P
p
.40176 .28948 m .43083 .29591 L .41663 .29896 L .603 1 0 r
F
P
p
.38756 .29259 m .40176 .28948 L .41663 .29896 L .397 1 0 r
F
P
p
.002 w
.48531 .55288 m .47084 .56135 L .45667 .55523 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.44199 .57688 m .45667 .55523 L .47084 .56135 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72862 .51908 m .71372 .54055 L .70219 .5146 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.002 w
.68679 .51677 m .70219 .5146 L .71372 .54055 L p
1 .517 0 r
F P
0 0 0 r
s
P
p
.34392 .28924 m .37348 .29567 L .35952 .29873 L .681 1 0 r
F
P
p
.32995 .29235 m .34392 .28924 L .35952 .29873 L .526 1 0 r
F
P
p
.28603 .289 m .31611 .29543 L .30237 .29849 L 0 1 .121 r
F
P
p
.27231 .29211 m .28603 .289 L .30237 .29849 L 0 1 .534 r
F
P
p
.8794 .28828 m .90442 .29472 L .88826 .29779 L 1 0 0 r
F
P
p
.8632 .2914 m .8794 .28828 L .88826 .29779 L 1 0 0 r
F
P
p
.002 w
.70219 .5146 m .71772 .51241 L .72862 .51908 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.82161 .28804 m .84714 .29449 L .8312 .29755 L 1 0 0 r
F
P
p
.80565 .29116 m .82161 .28804 L .8312 .29755 L 1 0 0 r
F
P
p
.002 w
.68679 .51677 m .67151 .51892 L .66033 .53845 L p
1 .414 0 r
F P
0 0 0 r
s
P
p
.002 w
.93117 .49583 m .91489 .49807 L .90637 .49112 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.89005 .4934 m .90637 .49112 L .91489 .49807 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.76379 .2878 m .78982 .29425 L .77411 .29732 L 1 .026 0 r
F
P
p
.74806 .29092 m .76379 .2878 L .77411 .29732 L 1 .078 0 r
F
P
p
.002 w
.38386 .65628 m .36956 .67101 L .35406 .66628 L p
0 1 .534 r
F P
0 0 0 r
s
P
p
.002 w
.36956 .67101 m .35485 .7055 L .33915 .70121 L p
0 1 .845 r
F P
0 0 0 r
s
P
p
.002 w
.33915 .70121 m .35406 .66628 L .36956 .67101 L p
0 1 .845 r
F P
0 0 0 r
s
P
p
.002 w
.87387 .49566 m .85782 .4979 L .84856 .49094 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83248 .49322 m .84856 .49094 L .85782 .4979 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70593 .28756 m .73246 .29401 L .71699 .29708 L 1 .129 0 r
F
P
p
.69044 .29068 m .70593 .28756 L .71699 .29708 L 1 .155 0 r
F
P
p
.002 w
.32518 .70262 m .33915 .70121 L .35485 .7055 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.61473 .55118 m .59974 .55319 L .58709 .53383 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.57211 .53593 m .58709 .53383 L p
.57767 .5394 L 1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.57211 .53593 m .5573 .55102 L .54413 .54472 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.58709 .53383 m .57211 .53593 L .55915 .54264 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.55915 .54264 m .57429 .54053 L .58709 .53383 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.58709 .53383 m .57429 .54053 L p
.59661 .5282 L 1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.60212 .52516 m .58709 .53383 L p
.59661 .5282 L 1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.58709 .53383 m .59974 .55319 L p
.57767 .5394 L 1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.81653 .49548 m .80071 .49773 L .79141 .51037 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.77552 .51258 m .79141 .51037 L .80071 .49773 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.64803 .28731 m .67507 .29378 L .65983 .29685 L 1 .284 0 r
F
P
p
.63277 .29044 m .64803 .28731 L .65983 .29685 L 1 .336 0 r
F
P
p
.002 w
.5573 .55102 m .54254 .55304 L .52924 .54679 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.51448 .54883 m .52924 .54679 L .54254 .55304 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.5901 .28707 m .61764 .29354 L .60263 .29661 L 1 .297 0 r
F
P
p
.57508 .2902 m .5901 .28707 L .60263 .29661 L 1 .414 0 r
F
P
p
.002 w
.49983 .55087 m .48531 .55288 L .47127 .54663 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.45667 .55523 m .47127 .54663 L .48531 .55288 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.35406 .66628 m .36821 .66471 L .38386 .65628 L p
0 1 .534 r
F P
0 0 0 r
s
P
p
.002 w
.39872 .61518 m .38386 .65628 L .36821 .66471 L p
0 1 .121 r
F P
0 0 0 r
s
P
p
.002 w
.36821 .66471 m .38357 .60973 L .39872 .61518 L p
0 1 .121 r
F P
0 0 0 r
s
P
p
.53213 .28683 m .56018 .2933 L .5454 .29638 L 1 .595 0 r
F
P
p
.51734 .28996 m .53213 .28683 L .5454 .29638 L 1 .698 0 r
F
P
p
.47412 .28659 m .50268 .29306 L .48813 .29614 L 1 .983 0 r
F
P
p
.45957 .28972 m .47412 .28659 L .48813 .29614 L .862 1 0 r
F
P
p
.41608 .28635 m .44514 .29283 L .43083 .29591 L .784 1 0 r
F
P
p
.40176 .28948 m .41608 .28635 L .43083 .29591 L .603 1 0 r
F
P
p
.35799 .28611 m .38756 .29259 L .37348 .29567 L .759 1 0 r
F
P
p
.34392 .28924 m .35799 .28611 L .37348 .29567 L .681 1 0 r
F
P
p
.29987 .28586 m .32995 .29235 L .31611 .29543 L .009 1 0 r
F
P
p
.28603 .289 m .29987 .28586 L .31611 .29543 L 0 1 .121 r
F
P
p
.24172 .28562 m .27231 .29211 L .25869 .2952 L 0 .897 1 r
F
P
p
.002 w
.38357 .60973 m .3981 .59464 L .4131 .6003 L p
.345 1 0 r
F P
0 0 0 r
s
P
p
.8794 .28828 m .89573 .28514 L .90442 .29472 L 1 0 0 r
F
P
p
.002 w
.75976 .51476 m .74412 .51693 L .73338 .5102 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.71772 .51241 m .73338 .5102 L .74412 .51693 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.83771 .28489 m .8632 .2914 L .84714 .29449 L 1 0 0 r
F
P
p
.82161 .28804 m .83771 .28489 L .84714 .29449 L 1 0 0 r
F
P
p
.002 w
.70219 .5146 m .68679 .51677 L .6753 .51003 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.66033 .53845 m .6753 .51003 L .68679 .51677 L p
1 .414 0 r
F P
0 0 0 r
s
P
p
.002 w
.90637 .49112 m .92283 .48882 L .93117 .49583 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.77965 .28465 m .80565 .29116 L .78982 .29425 L 1 0 0 r
F
P
p
.76379 .2878 m .77965 .28465 L .78982 .29425 L 1 .026 0 r
F
P
p
.002 w
.89005 .4934 m .87387 .49566 L .86478 .48864 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84856 .49094 m .86478 .48864 L .87387 .49566 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.72155 .28441 m .74806 .29092 L .73246 .29401 L 1 .078 0 r
F
P
p
.70593 .28756 m .72155 .28441 L .73246 .29401 L 1 .129 0 r
F
P
p
.002 w
.62984 .54915 m .61473 .55118 L .60212 .52516 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.58709 .53383 m .60212 .52516 L .61473 .55118 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.83248 .49322 m .81653 .49548 L .8067 .48847 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79141 .51037 m .8067 .48847 L .81653 .49548 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.66342 .28416 m .69044 .29068 L .67507 .29378 L 1 .181 0 r
F
P
p
.64803 .28731 m .66342 .28416 L .67507 .29378 L 1 .284 0 r
F
P
p
.002 w
.32518 .70262 m .31132 .70401 L .29499 .69968 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.52924 .54679 m .54413 .54472 L .5573 .55102 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.60525 .28392 m .63277 .29044 L .61764 .29354 L 1 .22 0 r
F
P
p
.5901 .28707 m .60525 .28392 L .61764 .29354 L 1 .297 0 r
F
P
p
.002 w
.51448 .54883 m .49983 .55087 L .48592 .54456 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.47127 .54663 m .48592 .54456 L .49983 .55087 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.54704 .28368 m .57508 .2902 L .56018 .2933 L 1 .569 0 r
F
P
p
.53213 .28683 m .54704 .28368 L .56018 .2933 L 1 .595 0 r
F
P
p
.48879 .28343 m .51734 .28996 L .50268 .29306 L 1 .957 0 r
F
P
p
.47412 .28659 m .48879 .28343 L .50268 .29306 L 1 .983 0 r
F
P
p
.43051 .28319 m .45957 .28972 L .44514 .29283 L .81 1 0 r
F
P
p
.41608 .28635 m .43051 .28319 L .44514 .29283 L .784 1 0 r
F
P
p
.37219 .28294 m .40176 .28948 L .38756 .29259 L .81 1 0 r
F
P
p
.35799 .28611 m .37219 .28294 L .38756 .29259 L .759 1 0 r
F
P
p
.31383 .2827 m .34392 .28924 L .32995 .29235 L .06 1 0 r
F
P
p
.29987 .28586 m .31383 .2827 L .32995 .29235 L .009 1 0 r
F
P
p
.25544 .28246 m .28603 .289 L .27231 .29211 L 0 .922 1 r
F
P
p
.24172 .28562 m .25544 .28246 L .27231 .29211 L 0 .897 1 r
F
P
p
.002 w
.54413 .54472 m .55915 .54264 L .57211 .53593 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.77552 .51258 m .75976 .51476 L .74917 .50797 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.73338 .5102 m .74917 .50797 L .75976 .51476 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.85394 .28172 m .8794 .28828 L .8632 .2914 L 1 0 0 r
F
P
p
.83771 .28489 m .85394 .28172 L .8632 .2914 L 1 0 0 r
F
P
p
.002 w
.71772 .51241 m .70219 .5146 L .69085 .5078 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.6753 .51003 m .69085 .5078 L .70219 .5146 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.79564 .28148 m .82161 .28804 L .80565 .29116 L 1 0 0 r
F
P
p
.77965 .28465 m .79564 .28148 L .80565 .29116 L 1 0 0 r
F
P
p
.002 w
.90637 .49112 m .89005 .4934 L .88114 .48633 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.86478 .48864 m .88114 .48633 L .89005 .4934 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.73731 .28123 m .76379 .2878 L .74806 .29092 L 1 .026 0 r
F
P
p
.72155 .28441 m .73731 .28123 L .74806 .29092 L 1 .078 0 r
F
P
p
.002 w
.64508 .5471 m .62984 .54915 L .61734 .523 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.60212 .52516 m .61734 .523 L .62984 .54915 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.84856 .49094 m .83248 .49322 L .82282 .48615 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8067 .48847 m .82282 .48615 L .83248 .49322 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67894 .28099 m .70593 .28756 L .69044 .29068 L 1 .052 0 r
F
P
p
.66342 .28416 m .67894 .28099 L .69044 .29068 L 1 .181 0 r
F
P
p
.002 w
.33915 .70121 m .32518 .70262 L .30896 .69824 L p
0 1 .974 r
F P
0 0 0 r
s
P
p
.002 w
.29499 .69968 m .30896 .69824 L .32518 .70262 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.62053 .28074 m .64803 .28731 L .63277 .29044 L 1 .181 0 r
F
P
p
.60525 .28392 m .62053 .28074 L .63277 .29044 L 1 .22 0 r
F
P
p
.002 w
.52924 .54679 m .51448 .54883 L .5007 .54247 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.48592 .54456 m .5007 .54247 L .51448 .54883 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.56208 .2805 m .5901 .28707 L .57508 .2902 L 1 .543 0 r
F
P
p
.54704 .28368 m .56208 .2805 L .57508 .2902 L 1 .569 0 r
F
P
p
.50359 .28025 m .53213 .28683 L .51734 .28996 L 1 .905 0 r
F
P
p
.48879 .28343 m .50359 .28025 L .51734 .28996 L 1 .957 0 r
F
P
p
.44507 .28 m .47412 .28659 L .45957 .28972 L .94 1 0 r
F
P
p
.43051 .28319 m .44507 .28 L .45957 .28972 L .81 1 0 r
F
P
p
.38651 .27976 m .41608 .28635 L .40176 .28948 L 1 .983 0 r
F
P
p
.37219 .28294 m .38651 .27976 L .40176 .28948 L .81 1 0 r
F
P
p
.002 w
.42699 .59088 m .44187 .5689 L .45667 .55523 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47127 .54663 m .45667 .55523 L .44187 .5689 L p
.94 1 0 r
F P
0 0 0 r
s
P
p
.32791 .27951 m .35799 .28611 L .34392 .28924 L .086 1 0 r
F
P
p
.31383 .2827 m .32791 .27951 L .34392 .28924 L .06 1 0 r
F
P
p
.26927 .27926 m .29987 .28586 L .28603 .289 L 0 1 .948 r
F
P
p
.25544 .28246 m .26927 .27926 L .28603 .289 L 0 .922 1 r
F
P
p
.002 w
.79141 .51037 m .77552 .51258 L .76467 .49254 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.74917 .50797 m .76467 .49254 L .77552 .51258 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.87031 .27852 m .89573 .28514 L .8794 .28828 L 1 0 0 r
F
P
p
.85394 .28172 m .87031 .27852 L .8794 .28828 L 1 0 0 r
F
P
p
.002 w
.73338 .5102 m .71772 .51241 L .70653 .50556 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.69085 .5078 m .70653 .50556 L .71772 .51241 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.81177 .27828 m .83771 .28489 L .82161 .28804 L 1 0 0 r
F
P
p
.79564 .28148 m .81177 .27828 L .82161 .28804 L 1 0 0 r
F
P
p
.002 w
.92283 .48882 m .90637 .49112 L .89763 .48399 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.88114 .48633 m .89763 .48399 L .90637 .49112 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7532 .27803 m .77965 .28465 L .76379 .2878 L 1 0 0 r
F
P
p
.73731 .28123 m .7532 .27803 L .76379 .2878 L 1 .026 0 r
F
P
p
.002 w
.36821 .66471 m .35406 .66628 L .33815 .66142 L p
0 1 .586 r
F P
0 0 0 r
s
P
p
.002 w
.35406 .66628 m .33915 .70121 L .324 .66301 L p
0 1 .716 r
F P
0 0 0 r
s
P
p
.002 w
.324 .66301 m .33815 .66142 L .35406 .66628 L p
0 1 .716 r
F P
0 0 0 r
s
P
p
.002 w
.66033 .53845 m .64508 .5471 L .6325 .50763 L p
1 .543 0 r
F P
0 0 0 r
s
P
p
.002 w
.61734 .523 m .6325 .50763 L .64508 .5471 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.86478 .48864 m .84856 .49094 L .83907 .48381 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82282 .48615 m .83907 .48381 L .84856 .49094 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69458 .27778 m .72155 .28441 L .70593 .28756 L 1 0 0 r
F
P
p
.67894 .28099 m .69458 .27778 L .70593 .28756 L 1 .052 0 r
F
P
p
.002 w
.30896 .69824 m .324 .66301 L .33915 .70121 L p
0 1 .974 r
F P
0 0 0 r
s
P
p
.63593 .27753 m .66342 .28416 L .64803 .28731 L 1 .129 0 r
F
P
p
.62053 .28074 m .63593 .27753 L .64803 .28731 L 1 .181 0 r
F
P
p
.002 w
.54413 .54472 m .52924 .54679 L .5156 .54037 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.5007 .54247 m .5156 .54037 L .52924 .54679 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.57724 .27729 m .60525 .28392 L .5901 .28707 L 1 .427 0 r
F
P
p
.56208 .2805 m .57724 .27729 L .5901 .28707 L 1 .543 0 r
F
P
p
.002 w
.48592 .54456 m .47127 .54663 L .45658 .56691 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.44187 .5689 m .45658 .56691 L .47127 .54663 L p
.94 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.38357 .60973 m .36821 .66471 L .35241 .65981 L p
0 1 .379 r
F P
0 0 0 r
s
P
p
.002 w
.3981 .59464 m .38357 .60973 L .3668 .65819 L p
0 1 .121 r
F P
0 0 0 r
s
P
p
.002 w
.35241 .65981 m .3668 .65819 L .38357 .60973 L p
0 1 .379 r
F P
0 0 0 r
s
P
p
.51851 .27704 m .54704 .28368 L .53213 .28683 L 1 .853 0 r
F
P
p
.50359 .28025 m .51851 .27704 L .53213 .28683 L 1 .905 0 r
F
P
p
.45975 .27679 m .48879 .28343 L .47412 .28659 L 1 .905 0 r
F
P
p
.44507 .28 m .45975 .27679 L .47412 .28659 L .94 1 0 r
F
P
p
.002 w
.61734 .523 m .60212 .52516 L .58946 .5251 L p
1 .543 0 r
F P
0 0 0 r
s
P
p
.002 w
.57429 .54053 m .58946 .5251 L .60212 .52516 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.40094 .27654 m .43051 .28319 L .41608 .28635 L 1 .724 0 r
F
P
p
.38651 .27976 m .40094 .27654 L .41608 .28635 L 1 .983 0 r
F
P
p
.3421 .27629 m .37219 .28294 L .35799 .28611 L .241 1 0 r
F
P
p
.32791 .27951 m .3421 .27629 L .35799 .28611 L .086 1 0 r
F
P
p
.28322 .27605 m .31383 .2827 L .29987 .28586 L 0 1 .845 r
F
P
p
.26927 .27926 m .28322 .27605 L .29987 .28586 L 0 1 .948 r
F
P
p
.2243 .2758 m .25544 .28246 L .24172 .28562 L 0 .897 1 r
F
P
p
.002 w
.8067 .48847 m .79141 .51037 L .78069 .49023 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.002 w
.76467 .49254 m .78069 .49023 L .79141 .51037 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.6753 .51003 m .66033 .53845 L .64794 .50538 L p
1 .414 0 r
F P
0 0 0 r
s
P
p
.002 w
.6325 .50763 m .64794 .50538 L .66033 .53845 L p
1 .543 0 r
F P
0 0 0 r
s
P
p
.002 w
.41249 .59277 m .3981 .59464 L .38131 .65656 L p
.138 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3668 .65819 m .38131 .65656 L .3981 .59464 L p
0 1 .121 r
F P
0 0 0 r
s
P
p
.87031 .27852 m .88682 .2753 L .89573 .28514 L 1 0 0 r
F
P
p
.002 w
.74917 .50797 m .73338 .5102 L .72235 .50329 L p
1 .284 0 r
F P
0 0 0 r
s
P
p
.002 w
.70653 .50556 m .72235 .50329 L .73338 .5102 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.82804 .27505 m .85394 .28172 L .83771 .28489 L 1 0 0 r
F
P
p
.81177 .27828 m .82804 .27505 L .83771 .28489 L 1 0 0 r
F
P
p
.002 w
.69085 .5078 m .6753 .51003 L .66351 .50312 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.64794 .50538 m .66351 .50312 L .6753 .51003 L p
1 .414 0 r
F P
0 0 0 r
s
P
p
.002 w
.89763 .48399 m .91426 .48163 L .92283 .48882 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.76922 .2748 m .79564 .28148 L .77965 .28465 L 1 0 0 r
F
P
p
.7532 .27803 m .76922 .2748 L .77965 .28465 L 1 0 0 r
F
P
p
.002 w
.33815 .66142 m .35241 .65981 L .36821 .66471 L p
0 1 .586 r
F P
0 0 0 r
s
P
p
.002 w
.88114 .48633 m .86478 .48864 L .85546 .48145 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83907 .48381 m .85546 .48145 L .86478 .48864 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.71036 .27455 m .73731 .28123 L .72155 .28441 L 1 0 0 r
F
P
p
.69458 .27778 m .71036 .27455 L .72155 .28441 L 1 0 0 r
F
P
p
.002 w
.82282 .48615 m .8067 .48847 L .79662 .48127 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78069 .49023 m .79662 .48127 L .8067 .48847 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.65147 .2743 m .67894 .28099 L .66342 .28416 L 1 .103 0 r
F
P
p
.63593 .27753 m .65147 .2743 L .66342 .28416 L 1 .129 0 r
F
P
p
.002 w
.30896 .69824 m .29499 .69968 L .27823 .69523 L p
0 1 .974 r
F P
0 0 0 r
s
P
p
.002 w
.55915 .54264 m .54413 .54472 L .53063 .53158 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.5156 .54037 m .53063 .53158 L .54413 .54472 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.59253 .27405 m .62053 .28074 L .60525 .28392 L 1 .297 0 r
F
P
p
.57724 .27729 m .59253 .27405 L .60525 .28392 L 1 .427 0 r
F
P
p
.002 w
.45658 .56691 m .47153 .55146 L .48592 .54456 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.5007 .54247 m .48592 .54456 L .47153 .55146 L p
1 .905 0 r
F P
0 0 0 r
s
P
p
.53356 .2738 m .56208 .2805 L .54704 .28368 L 1 .828 0 r
F
P
p
.51851 .27704 m .53356 .2738 L .54704 .28368 L 1 .853 0 r
F
P
p
.47455 .27355 m .50359 .28025 L .48879 .28343 L 1 .853 0 r
F
P
p
.45975 .27679 m .47455 .27355 L .48879 .28343 L 1 .905 0 r
F
P
p
.002 w
.6325 .50763 m .61734 .523 L .60477 .51624 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.58946 .5251 m .60477 .51624 L .61734 .523 L p
1 .543 0 r
F P
0 0 0 r
s
P
p
.4155 .2733 m .44507 .28 L .43051 .28319 L 1 .672 0 r
F
P
p
.40094 .27654 m .4155 .2733 L .43051 .28319 L 1 .724 0 r
F
P
p
.35642 .27305 m .38651 .27976 L .37219 .28294 L .397 1 0 r
F
P
p
.3421 .27629 m .35642 .27305 L .37219 .28294 L .241 1 0 r
F
P
p
.29729 .2728 m .32791 .27951 L .31383 .2827 L 0 1 .819 r
F
P
p
.28322 .27605 m .29729 .2728 L .31383 .2827 L 0 1 .845 r
F
P
p
.23813 .27255 m .26927 .27926 L .25544 .28246 L 0 .922 1 r
F
P
p
.2243 .2758 m .23813 .27255 L .25544 .28246 L 0 .897 1 r
F
P
p
.002 w
.38131 .65656 m .39696 .60041 L .41249 .59277 L p
.138 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42699 .59088 m .41249 .59277 L .39696 .60041 L p
.397 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.76467 .49254 m .74917 .50797 L .73811 .49435 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.72235 .50329 m .73811 .49435 L .74917 .50797 L p
1 .284 0 r
F P
0 0 0 r
s
P
p
.84444 .27179 m .87031 .27852 L .85394 .28172 L 1 0 0 r
F
P
p
.82804 .27505 m .84444 .27179 L .85394 .28172 L 1 0 0 r
F
P
p
.002 w
.70653 .50556 m .69085 .5078 L .67922 .50083 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.66351 .50312 m .67922 .50083 L .69085 .5078 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.78538 .27154 m .81177 .27828 L .79564 .28148 L 1 0 0 r
F
P
p
.76922 .2748 m .78538 .27154 L .79564 .28148 L 1 0 0 r
F
P
p
.002 w
.64794 .50538 m .6325 .50763 L .62018 .50732 L p
1 .362 0 r
F P
0 0 0 r
s
P
p
.002 w
.60477 .51624 m .62018 .50732 L .6325 .50763 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.89763 .48399 m .88114 .48633 L .87198 .47907 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85546 .48145 m .87198 .47907 L .88114 .48633 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.72627 .27129 m .7532 .27803 L .73731 .28123 L 1 0 0 r
F
P
p
.71036 .27455 m .72627 .27129 L .73731 .28123 L 1 0 0 r
F
P
p
.002 w
.33815 .66142 m .324 .66301 L .30756 .65807 L p
0 1 .534 r
F P
0 0 0 r
s
P
p
.002 w
.324 .66301 m .30896 .69824 L .29342 .65969 L p
0 1 .716 r
F P
0 0 0 r
s
P
p
.002 w
.29342 .65969 m .30756 .65807 L .324 .66301 L p
0 1 .716 r
F P
0 0 0 r
s
P
p
.002 w
.83907 .48381 m .82282 .48615 L .8129 .47889 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79662 .48127 m .8129 .47889 L .82282 .48615 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66713 .27104 m .69458 .27778 L .67894 .28099 L 1 .052 0 r
F
P
p
.65147 .2743 m .66713 .27104 L .67894 .28099 L 1 .103 0 r
F
P
p
.002 w
.27823 .69523 m .29342 .65969 L .30896 .69824 L p
0 1 .974 r
F P
0 0 0 r
s
P
p
.002 w
.57429 .54053 m .55915 .54264 L .54574 .50941 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.53063 .53158 m .54574 .50941 L .55915 .54264 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.60796 .27079 m .63593 .27753 L .62053 .28074 L 1 .259 0 r
F
P
p
.59253 .27405 m .60796 .27079 L .62053 .28074 L 1 .297 0 r
F
P
p
.002 w
.5156 .54037 m .5007 .54247 L .48651 .54266 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.47153 .55146 m .48651 .54266 L .5007 .54247 L p
1 .905 0 r
F P
0 0 0 r
s
P
p
.54874 .27054 m .57724 .27729 L .56208 .2805 L 1 .828 0 r
F
P
p
.53356 .2738 m .54874 .27054 L .56208 .2805 L 1 .828 0 r
F
P
p
.48948 .27028 m .51851 .27704 L .50359 .28025 L 1 .776 0 r
F
P
p
.47455 .27355 m .48948 .27028 L .50359 .28025 L 1 .853 0 r
F
P
p
.002 w
.78069 .49023 m .76467 .49254 L .75398 .48536 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.73811 .49435 m .75398 .48536 L .76467 .49254 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.43019 .27003 m .45975 .27679 L .44507 .28 L 1 .672 0 r
F
P
p
.4155 .2733 m .43019 .27003 L .44507 .28 L 1 .672 0 r
F
P
p
.37085 .26978 m .40094 .27654 L .38651 .27976 L .603 1 0 r
F
P
p
.35642 .27305 m .37085 .26978 L .38651 .27976 L .397 1 0 r
F
P
p
.31148 .26953 m .3421 .27629 L .32791 .27951 L 0 1 .638 r
F
P
p
.29729 .2728 m .31148 .26953 L .32791 .27951 L 0 1 .819 r
F
P
p
.25207 .26927 m .28322 .27605 L .26927 .27926 L 0 1 .922 r
F
P
p
.23813 .27255 m .25207 .26927 L .26927 .27926 L 0 .922 1 r
F
P
p
.002 w
.44187 .5689 m .42699 .59088 L .41185 .58497 L p
.526 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39696 .60041 m .41185 .58497 L .42699 .59088 L p
.397 1 0 r
F P
0 0 0 r
s
P
p
.86098 .26851 m .88682 .2753 L .87031 .27852 L 1 0 0 r
F
P
p
.84444 .27179 m .86098 .26851 L .87031 .27852 L 1 0 0 r
F
P
p
.002 w
.72235 .50329 m .70653 .50556 L .69461 .47852 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.67922 .50083 m .69461 .47852 L .70653 .50556 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.80167 .26826 m .82804 .27505 L .81177 .27828 L 1 0 0 r
F
P
p
.78538 .27154 m .80167 .26826 L .81177 .27828 L 1 0 0 r
F
P
p
.002 w
.66351 .50312 m .64794 .50538 L .63578 .50504 L p
1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.62018 .50732 m .63578 .50504 L .64794 .50538 L p
1 .362 0 r
F P
0 0 0 r
s
P
p
.002 w
.91426 .48163 m .89763 .48399 L .88865 .47667 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.87198 .47907 m .88865 .47667 L .89763 .48399 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.74232 .26801 m .76922 .2748 L .7532 .27803 L 1 0 0 r
F
P
p
.72627 .27129 m .74232 .26801 L .7532 .27803 L 1 0 0 r
F
P
p
.002 w
.35241 .65981 m .33815 .66142 L .32221 .64278 L p
0 1 .483 r
F P
0 0 0 r
s
P
p
.002 w
.30756 .65807 m .32221 .64278 L .33815 .66142 L p
0 1 .534 r
F P
0 0 0 r
s
P
p
.002 w
.85546 .48145 m .83907 .48381 L .82932 .47649 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8129 .47889 m .82932 .47649 L .83907 .48381 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68294 .26775 m .71036 .27455 L .69458 .27778 L 1 0 0 r
F
P
p
.66713 .27104 m .68294 .26775 L .69458 .27778 L 1 .052 0 r
F
P
p
.002 w
.58946 .5251 m .57429 .54053 L .56094 .50048 L p
1 .517 0 r
F P
0 0 0 r
s
P
p
.002 w
.54574 .50941 m .56094 .50048 L .57429 .54053 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.45658 .56691 m .44187 .5689 L .4266 .58302 L p
.603 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41185 .58497 m .4266 .58302 L .44187 .5689 L p
.526 1 0 r
F P
0 0 0 r
s
P
p
.62351 .2675 m .65147 .2743 L .63593 .27753 L 1 .194 0 r
F
P
p
.60796 .27079 m .62351 .2675 L .63593 .27753 L 1 .259 0 r
F
P
p
.002 w
.53063 .53158 m .5156 .54037 L .50156 .54053 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.48651 .54266 m .50156 .54053 L .5156 .54037 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.56404 .26724 m .59253 .27405 L .57724 .27729 L 1 .75 0 r
F
P
p
.54874 .27054 m .56404 .26724 L .57724 .27729 L 1 .828 0 r
F
P
p
.50454 .26699 m .53356 .2738 L .51851 .27704 L 1 .672 0 r
F
P
p
.48948 .27028 m .50454 .26699 L .51851 .27704 L 1 .776 0 r
F
P
p
.002 w
.79662 .48127 m .78069 .49023 L .76995 .4763 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.75398 .48536 m .76995 .4763 L .78069 .49023 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.44499 .26673 m .47455 .27355 L .45975 .27679 L 1 .647 0 r
F
P
p
.43019 .27003 m .44499 .26673 L .45975 .27679 L 1 .672 0 r
F
P
p
.38541 .26648 m .4155 .2733 L .40094 .27654 L .888 1 0 r
F
P
p
.37085 .26978 m .38541 .26648 L .40094 .27654 L .603 1 0 r
F
P
p
.32579 .26622 m .35642 .27305 L .3421 .27629 L 0 1 .224 r
F
P
p
.31148 .26953 m .32579 .26622 L .3421 .27629 L 0 1 .638 r
F
P
p
.26613 .26597 m .29729 .2728 L .28322 .27605 L 0 1 .69 r
F
P
p
.25207 .26927 m .26613 .26597 L .28322 .27605 L 0 1 .922 r
F
P
p
.002 w
.60477 .51624 m .58946 .5251 L .57628 .49817 L p
1 .414 0 r
F P
0 0 0 r
s
P
p
.002 w
.57628 .49817 m .58946 .5251 L p
.56413 .50323 L 1 .517 0 r
F P
0 0 0 r
s
P
p
.002 w
.59171 .48913 m .60477 .51624 L p
.57779 .49913 L 1 .414 0 r
F P
0 0 0 r
s
P
p
.002 w
.57628 .49817 m .59171 .48913 L p
.57779 .49913 L 1 .414 0 r
F P
0 0 0 r
s
P
p
.002 w
.62018 .50732 m .60477 .51624 L .59171 .48913 L p
1 .297 0 r
F P
0 0 0 r
s
P
p
.002 w
.59171 .48913 m .6072 .47667 L .62018 .50732 L p
1 .297 0 r
F P
0 0 0 r
s
P
p
.002 w
.59171 .48913 m .57874 .52272 L p
.60572 .47906 L 1 .427 0 r
F P
0 0 0 r
s
P
p
.002 w
.6072 .47667 m .59171 .48913 L p
.60572 .47906 L 1 .427 0 r
F P
0 0 0 r
s
P
p
.002 w
.57628 .49817 m .56305 .52497 L p
.58856 .49306 L 1 .543 0 r
F P
0 0 0 r
s
P
p
.002 w
.59171 .48913 m .57628 .49817 L p
.58856 .49306 L 1 .543 0 r
F P
0 0 0 r
s
P
p
.002 w
.56094 .50048 m .57628 .49817 L p
.56413 .50323 L 1 .517 0 r
F P
0 0 0 r
s
P
p
.20643 .26571 m .23813 .27255 L .2243 .2758 L 0 .897 1 r
F
P
p
.86098 .26851 m .87767 .2652 L .88682 .2753 L 1 0 0 r
F
P
p
.002 w
.73811 .49435 m .72235 .50329 L .71054 .47612 L p
1 .129 0 r
F P
0 0 0 r
s
P
p
.002 w
.69461 .47852 m .71054 .47612 L .72235 .50329 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.81811 .26495 m .84444 .27179 L .82804 .27505 L 1 0 0 r
F
P
p
.80167 .26826 m .81811 .26495 L .82804 .27505 L 1 0 0 r
F
P
p
.002 w
.67922 .50083 m .66351 .50312 L .65141 .49602 L p
1 .284 0 r
F P
0 0 0 r
s
P
p
.002 w
.63578 .50504 m .65141 .49602 L .66351 .50312 L p
1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.54574 .50941 m .53063 .53158 L .51676 .53161 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.50156 .54053 m .51676 .53161 L .53063 .53158 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.88865 .47667 m .90547 .47425 L .91426 .48163 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.75851 .26469 m .78538 .27154 L .76922 .2748 L 1 0 0 r
F
P
p
.74232 .26801 m .75851 .26469 L .76922 .2748 L 1 0 0 r
F
P
p
.002 w
.3668 .65819 m .35241 .65981 L .33657 .64108 L p
0 1 .353 r
F P
0 0 0 r
s
P
p
.002 w
.32221 .64278 m .33657 .64108 L .35241 .65981 L p
0 1 .483 r
F P
0 0 0 r
s
P
p
.002 w
.87198 .47907 m .85546 .48145 L .84589 .47406 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82932 .47649 m .84589 .47406 L .85546 .48145 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69887 .26443 m .72627 .27129 L .71036 .27455 L 1 0 0 r
F
P
p
.68294 .26775 m .69887 .26443 L .71036 .27455 L 1 0 0 r
F
P
p
.002 w
.30756 .65807 m .29342 .65969 L .27643 .65466 L p
0 1 .276 r
F P
0 0 0 r
s
P
p
.002 w
.29342 .65969 m .27823 .69523 L .26103 .69066 L p
0 1 .845 r
F P
0 0 0 r
s
P
p
.002 w
.26103 .69066 m .27643 .65466 L .29342 .65969 L p
0 1 .845 r
F P
0 0 0 r
s
P
p
.002 w
.4266 .58302 m .44148 .58105 L .45658 .56691 L p
.603 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47153 .55146 m .45658 .56691 L .44148 .58105 L p
.655 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.8129 .47889 m .79662 .48127 L .78626 .47388 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76995 .4763 m .78626 .47388 L .79662 .48127 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.6392 .26418 m .66713 .27104 L .65147 .2743 L 1 .065 0 r
F
P
p
.62351 .2675 m .6392 .26418 L .65147 .2743 L 1 .194 0 r
F
P
p
.57948 .26392 m .60796 .27079 L .59253 .27405 L 1 .647 0 r
F
P
p
.56404 .26724 m .57948 .26392 L .59253 .27405 L 1 .75 0 r
F
P
p
.002 w
.56094 .50048 m .54574 .50941 L .53205 .52942 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.51676 .53161 m .53205 .52942 L .54574 .50941 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.51973 .26366 m .54874 .27054 L .53356 .2738 L 1 .595 0 r
F
P
p
.50454 .26699 m .51973 .26366 L .53356 .2738 L 1 .672 0 r
F
P
p
.45993 .26341 m .48948 .27028 L .47455 .27355 L 1 .595 0 r
F
P
p
.44499 .26673 m .45993 .26341 L .47455 .27355 L 1 .647 0 r
F
P
p
.4001 .26315 m .43019 .27003 L .4155 .2733 L 1 .957 0 r
F
P
p
.38541 .26648 m .4001 .26315 L .4155 .2733 L .888 1 0 r
F
P
p
.34022 .26289 m .37085 .26978 L .35642 .27305 L .034 1 0 r
F
P
p
.32579 .26622 m .34022 .26289 L .35642 .27305 L 0 1 .224 r
F
P
p
.28031 .26264 m .31148 .26953 L .29729 .2728 L 0 1 .431 r
F
P
p
.26613 .26597 m .28031 .26264 L .29729 .2728 L 0 1 .69 r
F
P
p
.002 w
.75398 .48536 m .73811 .49435 L .7266 .47369 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.71054 .47612 m .7266 .47369 L .73811 .49435 L p
1 .129 0 r
F P
0 0 0 r
s
P
p
.002 w
.48651 .54266 m .47153 .55146 L .45649 .57906 L p
.862 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44148 .58105 m .45649 .57906 L .47153 .55146 L p
.655 1 0 r
F P
0 0 0 r
s
P
p
.22036 .26238 m .25207 .26927 L .23813 .27255 L 0 .897 1 r
F
P
p
.20643 .26571 m .22036 .26238 L .23813 .27255 L 0 .897 1 r
F
P
p
.83469 .2616 m .86098 .26851 L .84444 .27179 L 1 0 0 r
F
P
p
.81811 .26495 m .83469 .2616 L .84444 .27179 L 1 0 0 r
F
P
p
.002 w
.69461 .47852 m .67922 .50083 L .66715 .48694 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.65141 .49602 m .66715 .48694 L .67922 .50083 L p
1 .284 0 r
F P
0 0 0 r
s
P
p
.77484 .26135 m .80167 .26826 L .78538 .27154 L 1 0 0 r
F
P
p
.75851 .26469 m .77484 .26135 L .78538 .27154 L 1 0 0 r
F
P
p
.002 w
.38131 .65656 m .3668 .65819 L .3519 .60518 L p
0 1 .198 r
F P
0 0 0 r
s
P
p
.002 w
.33657 .64108 m .3519 .60518 L .3668 .65819 L p
0 1 .353 r
F P
0 0 0 r
s
P
p
.002 w
.88865 .47667 m .87198 .47907 L .86259 .47162 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84589 .47406 m .86259 .47162 L .87198 .47907 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.71495 .26109 m .74232 .26801 L .72627 .27129 L 1 0 0 r
F
P
p
.69887 .26443 m .71495 .26109 L .72627 .27129 L 1 0 0 r
F
P
p
.002 w
.32221 .64278 m .30756 .65807 L .29338 .57116 L p
.19 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27643 .65466 m .29338 .57116 L .30756 .65807 L p
0 1 .276 r
F P
0 0 0 r
s
P
p
.002 w
.57628 .49817 m .56094 .50048 L .54748 .5272 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.53205 .52942 m .54748 .5272 L .56094 .50048 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.82932 .47649 m .8129 .47889 L .80272 .47143 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78626 .47388 m .80272 .47143 L .8129 .47889 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.65502 .26083 m .68294 .26775 L .66713 .27104 L 1 0 0 r
F
P
p
.6392 .26418 m .65502 .26083 L .66713 .27104 L 1 .065 0 r
F
P
p
.002 w
.63578 .50504 m .62018 .50732 L .6072 .47667 L p
1 .22 0 r
F P
0 0 0 r
s
P
p
.59505 .26057 m .62351 .2675 L .60796 .27079 L 1 .582 0 r
F
P
p
.57948 .26392 m .59505 .26057 L .60796 .27079 L 1 .647 0 r
F
P
p
.002 w
.41185 .58497 m .39696 .60041 L .38154 .5809 L p
.397 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39696 .60041 m .38131 .65656 L .3666 .59648 L p
.086 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3666 .59648 m .38154 .5809 L .39696 .60041 L p
.086 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71054 .47612 m .69461 .47852 L .68313 .48454 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.66715 .48694 m .68313 .48454 L .69461 .47852 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.53504 .26031 m .56404 .26724 L .54874 .27054 L 1 .569 0 r
F
P
p
.51973 .26366 m .53504 .26031 L .54874 .27054 L 1 .595 0 r
F
P
p
.475 .26005 m .50454 .26699 L .48948 .27028 L 1 .517 0 r
F
P
p
.45993 .26341 m .475 .26005 L .48948 .27028 L 1 .595 0 r
F
P
p
.002 w
.76995 .4763 m .75398 .48536 L .74281 .47125 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.7266 .47369 m .74281 .47125 L .75398 .48536 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.41491 .25979 m .44499 .26673 L .43019 .27003 L 1 .853 0 r
F
P
p
.4001 .26315 m .41491 .25979 L .43019 .27003 L 1 .957 0 r
F
P
p
.002 w
.50156 .54053 m .48651 .54266 L .47192 .54284 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.45649 .57906 m .47192 .54284 L .48651 .54266 L p
.862 1 0 r
F P
0 0 0 r
s
P
p
.35478 .25953 m .38541 .26648 L .37085 .26978 L .293 1 0 r
F
P
p
.34022 .26289 m .35478 .25953 L .37085 .26978 L .034 1 0 r
F
P
p
.002 w
.29338 .57116 m .30845 .54217 L .32221 .64278 L p
.19 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30845 .54217 m .29338 .57116 L .27211 .68286 L p
0 1 .121 r
F P
0 0 0 r
s
P
p
.002 w
.27643 .65466 m .26103 .69066 L .24337 .68598 L p
0 1 .974 r
F P
0 0 0 r
s
P
p
.002 w
.24337 .68598 m .25768 .68443 L .27643 .65466 L p
0 1 .974 r
F P
0 0 0 r
s
P
p
.002 w
.29338 .57116 m .27643 .65466 L .25768 .68443 L p
0 1 .534 r
F P
0 0 0 r
s
P
p
.002 w
.25768 .68443 m .27211 .68286 L .29338 .57116 L p
0 1 .534 r
F P
0 0 0 r
s
P
p
.29461 .25927 m .32579 .26622 L .31148 .26953 L 0 1 .069 r
F
P
p
.28031 .26264 m .29461 .25927 L .31148 .26953 L 0 1 .431 r
F
P
p
.002 w
.33657 .64108 m .32221 .64278 L .30845 .54217 L p
.371 1 0 r
F P
0 0 0 r
s
P
p
.23441 .25901 m .26613 .26597 L .25207 .26927 L 0 .922 1 r
F
P
p
.22036 .26238 m .23441 .25901 L .25207 .26927 L 0 .897 1 r
F
P
p
.002 w
.30845 .54217 m .32295 .53329 L .33657 .64108 L p
.371 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32295 .53329 m .30845 .54217 L .28667 .68129 L p
.009 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27211 .68286 m .28667 .68129 L .30845 .54217 L p
0 1 .121 r
F P
0 0 0 r
s
P
p
.002 w
.4266 .58302 m .41185 .58497 L .3963 .57891 L p
.603 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.38154 .5809 m .3963 .57891 L .41185 .58497 L p
.397 1 0 r
F P
0 0 0 r
s
P
p
.85141 .25823 m .87767 .2652 L .86098 .26851 L 1 0 0 r
F
P
p
.83469 .2616 m .85141 .25823 L .86098 .26851 L 1 0 0 r
F
P
p
.7913 .25797 m .81811 .26495 L .80167 .26826 L 1 0 0 r
F
P
p
.77484 .26135 m .7913 .25797 L .80167 .26826 L 1 0 0 r
F
P
p
.002 w
.3519 .60518 m .3666 .59648 L .38131 .65656 L p
0 1 .198 r
F P
0 0 0 r
s
P
p
.002 w
.90547 .47425 m .88865 .47667 L .87944 .46916 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.86259 .47162 m .87944 .46916 L .88865 .47667 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.73116 .25771 m .75851 .26469 L .74232 .26801 L 1 0 0 r
F
P
p
.71495 .26109 m .73116 .25771 L .74232 .26801 L 1 0 0 r
F
P
p
.002 w
.54748 .5272 m .56305 .52497 L .57628 .49817 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.84589 .47406 m .82932 .47649 L .81932 .46897 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80272 .47143 m .81932 .46897 L .82932 .47649 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67098 .25745 m .69887 .26443 L .68294 .26775 L 1 0 0 r
F
P
p
.65502 .26083 m .67098 .25745 L .68294 .26775 L 1 0 0 r
F
P
p
.002 w
.78626 .47388 m .76995 .4763 L .75915 .46878 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74281 .47125 m .75915 .46878 L .76995 .4763 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.65141 .49602 m .63578 .50504 L .62286 .47087 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.6072 .47667 m .62286 .47087 L .63578 .50504 L p
1 .22 0 r
F P
0 0 0 r
s
P
p
.61076 .25719 m .6392 .26418 L .62351 .2675 L 1 .466 0 r
F
P
p
.59505 .26057 m .61076 .25719 L .62351 .2675 L 1 .582 0 r
F
P
p
.002 w
.7266 .47369 m .71054 .47612 L .69894 .46859 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68313 .48454 m .69894 .46859 L .71054 .47612 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.55049 .25693 m .57948 .26392 L .56404 .26724 L 1 .543 0 r
F
P
p
.53504 .26031 m .55049 .25693 L .56404 .26724 L 1 .569 0 r
F
P
p
.49019 .25667 m .51973 .26366 L .50454 .26699 L 1 .414 0 r
F
P
p
.475 .26005 m .49019 .25667 L .50454 .26699 L 1 .517 0 r
F
P
p
.42985 .25641 m .45993 .26341 L .44499 .26673 L 1 .828 0 r
F
P
p
.41491 .25979 m .42985 .25641 L .44499 .26673 L 1 .853 0 r
F
P
p
.002 w
.51676 .53161 m .50156 .54053 L .48713 .54068 L p
1 .957 0 r
F P
0 0 0 r
s
P
p
.002 w
.47192 .54284 m .48713 .54068 L .50156 .54053 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.3519 .60518 m .33657 .64108 L .32295 .53329 L p
.526 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32295 .53329 m .33736 .53111 L .3519 .60518 L p
.526 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33736 .53111 m .32295 .53329 L .30136 .67969 L p
.06 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28667 .68129 m .30136 .67969 L .32295 .53329 L p
.009 1 0 r
F P
0 0 0 r
s
P
p
.36947 .25615 m .4001 .26315 L .38541 .26648 L .629 1 0 r
F
P
p
.35478 .25953 m .36947 .25615 L .38541 .26648 L .293 1 0 r
F
P
p
.002 w
.3666 .59648 m .3519 .60518 L .33736 .53111 L p
.681 1 0 r
F P
0 0 0 r
s
P
p
.30904 .25588 m .34022 .26289 L .32579 .26622 L .241 1 0 r
F
P
p
.29461 .25927 m .30904 .25588 L .32579 .26622 L 0 1 .069 r
F
P
p
.24858 .25562 m .28031 .26264 L .26613 .26597 L 0 1 .948 r
F
P
p
.23441 .25901 m .24858 .25562 L .26613 .26597 L 0 .922 1 r
F
P
p
.18807 .25536 m .22036 .26238 L .20643 .26571 L 0 .897 1 r
F
P
p
.002 w
.44148 .58105 m .4266 .58302 L .41187 .53587 L p
.784 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3963 .57891 m .41187 .53587 L .4266 .58302 L p
.603 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56305 .52497 m .57874 .52272 L .59171 .48913 L p
1 .543 0 r
F P
0 0 0 r
s
P
p
.85141 .25823 m .86827 .25484 L .87767 .2652 L 1 0 0 r
F
P
p
.80791 .25457 m .83469 .2616 L .81811 .26495 L 1 0 0 r
F
P
p
.7913 .25797 m .80791 .25457 L .81811 .26495 L 1 0 0 r
F
P
p
.002 w
.66715 .48694 m .65141 .49602 L .6387 .4684 L p
1 .129 0 r
F P
0 0 0 r
s
P
p
.002 w
.62286 .47087 m .6387 .4684 L .65141 .49602 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.87944 .46916 m .89644 .46667 L .90547 .47425 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.74752 .25431 m .77484 .26135 L .75851 .26469 L 1 0 0 r
F
P
p
.73116 .25771 m .74752 .25431 L .75851 .26469 L 1 0 0 r
F
P
p
.002 w
.86259 .47162 m .84589 .47406 L .83606 .46648 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81932 .46897 m .83606 .46648 L .84589 .47406 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68708 .25405 m .71495 .26109 L .69887 .26443 L 1 0 0 r
F
P
p
.67098 .25745 m .68708 .25405 L .69887 .26443 L 1 0 0 r
F
P
p
.002 w
.80272 .47143 m .78626 .47388 L .77564 .46629 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75915 .46878 m .77564 .46629 L .78626 .47388 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.6266 .25378 m .65502 .26083 L .6392 .26418 L 1 .323 0 r
F
P
p
.61076 .25719 m .6266 .25378 L .6392 .26418 L 1 .466 0 r
F
P
p
.002 w
.53205 .52942 m .51676 .53161 L .50246 .5385 L p
1 .905 0 r
F P
0 0 0 r
s
P
p
.002 w
.48713 .54068 m .50246 .5385 L .51676 .53161 L p
1 .957 0 r
F P
0 0 0 r
s
P
p
.002 w
.74281 .47125 m .7266 .47369 L .71517 .4661 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69894 .46859 m .71517 .4661 L .7266 .47369 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.56608 .25352 m .59505 .26057 L .57948 .26392 L 1 .517 0 r
F
P
p
.55049 .25693 m .56608 .25352 L .57948 .26392 L 1 .543 0 r
F
P
p
.002 w
.38154 .5809 m .3666 .59648 L .3519 .52891 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33736 .53111 m .3519 .52891 L .3666 .59648 L p
.681 1 0 r
F P
0 0 0 r
s
P
p
.50552 .25326 m .53504 .26031 L .51973 .26366 L 1 .336 0 r
F
P
p
.49019 .25667 m .50552 .25326 L .51973 .26366 L 1 .414 0 r
F
P
p
.44492 .25299 m .475 .26005 L .45993 .26341 L 1 .776 0 r
F
P
p
.42985 .25641 m .44492 .25299 L .45993 .26341 L 1 .828 0 r
F
P
p
.002 w
.3519 .52891 m .33736 .53111 L .31639 .67096 L p
.086 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31639 .67096 m .33736 .53111 L p
.30278 .67381 L .06 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31639 .67096 m .33133 .6693 L .3519 .52891 L p
.086 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31639 .67096 m .29979 .63706 L p
.33012 .66807 L 0 1 .638 r
F P
0 0 0 r
s
P
p
.002 w
.33133 .6693 m .31639 .67096 L p
.33012 .66807 L 0 1 .638 r
F P
0 0 0 r
s
P
p
.002 w
.30136 .67969 m .31639 .67096 L p
.30278 .67381 L .06 1 0 r
F P
0 0 0 r
s
P
p
.38428 .25273 m .41491 .25979 L .4001 .26315 L .81 1 0 r
F
P
p
.36947 .25615 m .38428 .25273 L .4001 .26315 L .629 1 0 r
F
P
p
.002 w
.62286 .47087 m .6072 .47667 L .59447 .50668 L p
1 .297 0 r
F P
0 0 0 r
s
P
p
.002 w
.59447 .50668 m .6072 .47667 L p
.58399 .51423 L 1 .427 0 r
F P
0 0 0 r
s
P
p
.002 w
.61034 .49745 m .62286 .47087 L p
.60164 .49763 L 1 .297 0 r
F P
0 0 0 r
s
P
p
.002 w
.59447 .50668 m .61034 .49745 L p
.60164 .49763 L 1 .297 0 r
F P
0 0 0 r
s
P
p
.002 w
.59447 .50668 m .58105 .50635 L p
.60506 .49905 L 1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.61034 .49745 m .59447 .50668 L p
.60506 .49905 L 1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.61034 .49745 m .59717 .50397 L p
.61916 .49726 L 1 .582 0 r
F P
0 0 0 r
s
P
p
.002 w
.62641 .49505 m .61034 .49745 L p
.61916 .49726 L 1 .582 0 r
F P
0 0 0 r
s
P
p
.002 w
.57874 .52272 m .59447 .50668 L p
.58399 .51423 L 1 .427 0 r
F P
0 0 0 r
s
P
p
.3236 .25246 m .35478 .25953 L .34022 .26289 L .397 1 0 r
F
P
p
.30904 .25588 m .3236 .25246 L .34022 .26289 L .241 1 0 r
F
P
p
.26287 .2522 m .29461 .25927 L .28031 .26264 L 0 1 .69 r
F
P
p
.24858 .25562 m .26287 .2522 L .28031 .26264 L 0 1 .948 r
F
P
p
.20211 .25194 m .23441 .25901 L .22036 .26238 L 0 .897 1 r
F
P
p
.18807 .25536 m .20211 .25194 L .22036 .26238 L 0 .897 1 r
F
P
p
.002 w
.68313 .48454 m .66715 .48694 L .65467 .46591 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.002 w
.6387 .4684 m .65467 .46591 L .66715 .48694 L p
1 .129 0 r
F P
0 0 0 r
s
P
p
.002 w
.45649 .57906 m .44148 .58105 L .42691 .52686 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41187 .53587 m .42691 .52686 L .44148 .58105 L p
.784 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3963 .57891 m .38154 .5809 L .36656 .52669 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3519 .52891 m .36656 .52669 L .38154 .5809 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.82467 .25114 m .85141 .25823 L .83469 .2616 L 1 0 0 r
F
P
p
.80791 .25457 m .82467 .25114 L .83469 .2616 L 1 0 0 r
F
P
p
.76401 .25088 m .7913 .25797 L .77484 .26135 L 1 0 0 r
F
P
p
.74752 .25431 m .76401 .25088 L .77484 .26135 L 1 0 0 r
F
P
p
.002 w
.87944 .46916 m .86259 .47162 L .85295 .46397 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83606 .46648 m .85295 .46397 L .86259 .47162 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70332 .25061 m .73116 .25771 L .71495 .26109 L 1 0 0 r
F
P
p
.68708 .25405 m .70332 .25061 L .71495 .26109 L 1 0 0 r
F
P
p
.002 w
.81932 .46897 m .80272 .47143 L .79226 .46378 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77564 .46629 m .79226 .46378 L .80272 .47143 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64258 .25034 m .67098 .25745 L .65502 .26083 L 1 .207 0 r
F
P
p
.6266 .25378 m .64258 .25034 L .65502 .26083 L 1 .323 0 r
F
P
p
.002 w
.54748 .5272 m .53205 .52942 L .51794 .52942 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.50246 .5385 m .51794 .52942 L .53205 .52942 L p
1 .905 0 r
F P
0 0 0 r
s
P
p
.002 w
.75915 .46878 m .74281 .47125 L .73154 .46359 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71517 .4661 m .73154 .46359 L .74281 .47125 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5818 .25008 m .61076 .25719 L .59505 .26057 L 1 .478 0 r
F
P
p
.56608 .25352 m .5818 .25008 L .59505 .26057 L 1 .517 0 r
F
P
p
.52098 .24981 m .55049 .25693 L .53504 .26031 L 1 .284 0 r
F
P
p
.50552 .25326 m .52098 .24981 L .53504 .26031 L 1 .336 0 r
F
P
p
.002 w
.6387 .4684 m .62286 .47087 L .61034 .49745 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.46012 .24955 m .49019 .25667 L .475 .26005 L 1 .672 0 r
F
P
p
.44492 .25299 m .46012 .24955 L .475 .26005 L 1 .776 0 r
F
P
p
.002 w
.36656 .52669 m .3519 .52891 L .33133 .6693 L p
.241 1 0 r
F P
0 0 0 r
s
P
p
.39922 .24928 m .42985 .25641 L .41491 .25979 L .94 1 0 r
F
P
p
.38428 .25273 m .39922 .24928 L .41491 .25979 L .81 1 0 r
F
P
p
.33828 .24901 m .36947 .25615 L .35478 .25953 L .552 1 0 r
F
P
p
.3236 .25246 m .33828 .24901 L .35478 .25953 L .397 1 0 r
F
P
p
.002 w
.42691 .52686 m .41187 .53587 L .39653 .50848 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.41187 .53587 m .3963 .57891 L .38135 .52445 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.38135 .52445 m .39653 .50848 L .41187 .53587 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.27729 .24875 m .30904 .25588 L .29461 .25927 L 0 1 .457 r
F
P
p
.26287 .2522 m .27729 .24875 L .29461 .25927 L 0 1 .69 r
F
P
p
.002 w
.48713 .54068 m .47192 .54284 L .45714 .52237 L p
1 .905 0 r
F P
0 0 0 r
s
P
p
.002 w
.47192 .54284 m .45649 .57906 L .44196 .52463 L p
.94 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44196 .52463 m .45714 .52237 L .47192 .54284 L p
.94 1 0 r
F P
0 0 0 r
s
P
p
.21627 .24848 m .24858 .25562 L .23441 .25901 L 0 .922 1 r
F
P
p
.20211 .25194 m .21627 .24848 L .23441 .25901 L 0 .897 1 r
F
P
p
.002 w
.69894 .46859 m .68313 .48454 L .67078 .46339 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.65467 .46591 m .67078 .46339 L .68313 .48454 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.002 w
.42691 .52686 m .44196 .52463 L .45649 .57906 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.38135 .52445 m .3963 .57891 L p
.36904 .53105 L .81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.38135 .52445 m .36261 .62291 L p
.39377 .51779 L .603 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39653 .50848 m .38135 .52445 L p
.39377 .51779 L .603 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36656 .52669 m .38135 .52445 L p
.36904 .53105 L .81 1 0 r
F P
0 0 0 r
s
P
p
.84157 .24768 m .86827 .25484 L .85141 .25823 L 1 0 0 r
F
P
p
.82467 .25114 m .84157 .24768 L .85141 .25823 L 1 0 0 r
F
P
p
.78066 .24741 m .80791 .25457 L .7913 .25797 L 1 0 0 r
F
P
p
.76401 .25088 m .78066 .24741 L .7913 .25797 L 1 0 0 r
F
P
p
.002 w
.89644 .46667 m .87944 .46916 L .86998 .46144 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85295 .46397 m .86998 .46144 L .87944 .46916 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7197 .24714 m .74752 .25431 L .73116 .25771 L 1 0 0 r
F
P
p
.70332 .25061 m .7197 .24714 L .73116 .25771 L 1 0 0 r
F
P
p
.002 w
.83606 .46648 m .81932 .46897 L .80904 .46125 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79226 .46378 m .80904 .46125 L .81932 .46897 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.6587 .24688 m .68708 .25405 L .67098 .25745 L 1 .155 0 r
F
P
p
.64258 .25034 m .6587 .24688 L .67098 .25745 L 1 .207 0 r
F
P
p
.002 w
.56305 .52497 m .54748 .5272 L .53354 .52027 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.51794 .52942 m .53354 .52027 L .54748 .5272 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.77564 .46629 m .75915 .46878 L .74806 .46105 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73154 .46359 m .74806 .46105 L .75915 .46878 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.59766 .24661 m .6266 .25378 L .61076 .25719 L 1 .375 0 r
F
P
p
.5818 .25008 m .59766 .24661 L .61076 .25719 L 1 .478 0 r
F
P
p
.002 w
.71517 .4661 m .69894 .46859 L .68703 .46086 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67078 .46339 m .68703 .46086 L .69894 .46859 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.53658 .24634 m .56608 .25352 L .55049 .25693 L 1 .259 0 r
F
P
p
.52098 .24981 m .53658 .24634 L .55049 .25693 L 1 .284 0 r
F
P
p
.002 w
.44196 .52463 m .42691 .52686 L .41167 .49928 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.39653 .50848 m .41167 .49928 L .42691 .52686 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.65467 .46591 m .6387 .4684 L .62641 .49505 L p
1 .194 0 r
F P
0 0 0 r
s
P
p
.002 w
.61034 .49745 m .62641 .49505 L .6387 .4684 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.47546 .24607 m .50552 .25326 L .49019 .25667 L 1 .569 0 r
F
P
p
.46012 .24955 m .47546 .24607 L .49019 .25667 L 1 .672 0 r
F
P
p
.002 w
.38135 .52445 m .36656 .52669 L .34749 .62477 L p
.397 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34749 .62477 m .36656 .52669 L p
.33879 .63911 L .241 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34749 .62477 m .36261 .62291 L .38135 .52445 L p
.397 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34749 .62477 m .33193 .56186 L p
.35627 .61029 L .034 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36261 .62291 m .34749 .62477 L p
.35627 .61029 L .034 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33133 .6693 m .34749 .62477 L p
.33879 .63911 L .241 1 0 r
F P
0 0 0 r
s
P
p
.41429 .2458 m .44492 .25299 L .42985 .25641 L .966 1 0 r
F
P
p
.39922 .24928 m .41429 .2458 L .42985 .25641 L .94 1 0 r
F
P
p
.35309 .24553 m .38428 .25273 L .36947 .25615 L .681 1 0 r
F
P
p
.33828 .24901 m .35309 .24553 L .36947 .25615 L .552 1 0 r
F
P
p
.29184 .24527 m .3236 .25246 L .30904 .25588 L 0 1 .121 r
F
P
p
.27729 .24875 m .29184 .24527 L .30904 .25588 L 0 1 .457 r
F
P
p
.002 w
.50246 .5385 m .48713 .54068 L .47251 .5132 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.45714 .52237 m .47251 .5132 L .48713 .54068 L p
1 .905 0 r
F P
0 0 0 r
s
P
p
.23055 .245 m .26287 .2522 L .24858 .25562 L 0 .948 1 r
F
P
p
.21627 .24848 m .23055 .245 L .24858 .25562 L 0 .922 1 r
F
P
p
.16922 .24473 m .20211 .25194 L .18807 .25536 L 0 .922 1 r
F
P
p
.84157 .24768 m .85862 .24419 L .86827 .25484 L 1 0 0 r
F
P
p
.79744 .24392 m .82467 .25114 L .80791 .25457 L 1 0 0 r
F
P
p
.78066 .24741 m .79744 .24392 L .80791 .25457 L 1 0 0 r
F
P
p
.002 w
.86998 .46144 m .88717 .45889 L .89644 .46667 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.73622 .24365 m .76401 .25088 L .74752 .25431 L 1 0 0 r
F
P
p
.7197 .24714 m .73622 .24365 L .74752 .25431 L 1 0 0 r
F
P
p
.002 w
.85295 .46397 m .83606 .46648 L .82596 .4587 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80904 .46125 m .82596 .4587 L .83606 .46648 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67496 .24338 m .70332 .25061 L .68708 .25405 L 1 .155 0 r
F
P
p
.6587 .24688 m .67496 .24338 L .68708 .25405 L 1 .155 0 r
F
P
p
.002 w
.57874 .52272 m .56305 .52497 L .54925 .51797 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.53354 .52027 m .54925 .51797 L .56305 .52497 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.79226 .46378 m .77564 .46629 L .76472 .4585 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74806 .46105 m .76472 .4585 L .77564 .46629 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61366 .24311 m .64258 .25034 L .6266 .25378 L 1 .284 0 r
F
P
p
.59766 .24661 m .61366 .24311 L .6266 .25378 L 1 .375 0 r
F
P
p
.002 w
.25768 .68443 m .24337 .68598 L .22523 .68116 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.73154 .46359 m .71517 .4661 L .70343 .4583 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68703 .46086 m .70343 .4583 L .71517 .4661 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.55231 .24284 m .5818 .25008 L .56608 .25352 L 1 .259 0 r
F
P
p
.53658 .24634 m .55231 .24284 L .56608 .25352 L 1 .259 0 r
F
P
p
.002 w
.45714 .52237 m .44196 .52463 L .42681 .49689 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.41167 .49928 m .42681 .49689 L .44196 .52463 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.62641 .49505 m .64236 .47532 L .65467 .46591 L p
1 .194 0 r
F P
0 0 0 r
s
P
p
.002 w
.67078 .46339 m .65467 .46591 L .64236 .47532 L p
1 .065 0 r
F P
0 0 0 r
s
P
p
.49093 .24257 m .52098 .24981 L .50552 .25326 L 1 .466 0 r
F
P
p
.47546 .24607 m .49093 .24257 L .50552 .25326 L 1 .569 0 r
F
P
p
.4295 .24229 m .46012 .24955 L .44492 .25299 L 1 .957 0 r
F
P
p
.41429 .2458 m .4295 .24229 L .44492 .25299 L .966 1 0 r
F
P
p
.36803 .24202 m .39922 .24928 L .38428 .25273 L .746 1 0 r
F
P
p
.35309 .24553 m .36803 .24202 L .38428 .25273 L .681 1 0 r
F
P
p
.30652 .24175 m .33828 .24901 L .3236 .25246 L .293 1 0 r
F
P
p
.29184 .24527 m .30652 .24175 L .3236 .25246 L 0 1 .121 r
F
P
p
.002 w
.51794 .52942 m .50246 .5385 L .48799 .50397 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.47251 .5132 m .48799 .50397 L .50246 .5385 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.24496 .24148 m .27729 .24875 L .26287 .2522 L 0 .948 1 r
F
P
p
.23055 .245 m .24496 .24148 L .26287 .2522 L 0 .948 1 r
F
P
p
.18337 .24121 m .21627 .24848 L .20211 .25194 L 0 .948 1 r
F
P
p
.16922 .24473 m .18337 .24121 L .20211 .25194 L 0 .922 1 r
F
P
p
.002 w
.41167 .49928 m .39653 .50848 L .37878 .5783 L p
.888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37878 .5783 m .39653 .50848 L p
.36921 .60066 L .603 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37878 .5783 m .39436 .56203 L .41167 .49928 L p
.888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37878 .5783 m .36303 .52906 L p
.38842 .55578 L .629 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39436 .56203 m .37878 .5783 L p
.38842 .55578 L .629 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36261 .62291 m .37878 .5783 L p
.36921 .60066 L .603 1 0 r
F P
0 0 0 r
s
P
p
.81438 .24039 m .84157 .24768 L .82467 .25114 L 1 0 0 r
F
P
p
.79744 .24392 m .81438 .24039 L .82467 .25114 L 1 0 0 r
F
P
p
.7529 .24012 m .78066 .24741 L .76401 .25088 L 1 0 0 r
F
P
p
.73622 .24365 m .7529 .24012 L .76401 .25088 L 1 0 0 r
F
P
p
.002 w
.86998 .46144 m .85295 .46397 L .84304 .45612 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82596 .4587 m .84304 .45612 L .85295 .46397 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69137 .23985 m .7197 .24714 L .70332 .25061 L 1 .155 0 r
F
P
p
.67496 .24338 m .69137 .23985 L .70332 .25061 L 1 .155 0 r
F
P
p
.002 w
.59447 .50668 m .57874 .52272 L .5651 .51566 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.54925 .51797 m .5651 .51566 L .57874 .52272 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.80904 .46125 m .79226 .46378 L .78153 .45592 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76472 .4585 m .78153 .45592 L .79226 .46378 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.6298 .23957 m .6587 .24688 L .64258 .25034 L 1 .207 0 r
F
P
p
.61366 .24311 m .6298 .23957 L .64258 .25034 L 1 .284 0 r
F
P
p
.002 w
.27211 .68286 m .25768 .68443 L .23965 .67957 L p
0 .922 1 r
F P
0 0 0 r
s
P
p
.002 w
.22523 .68116 m .23965 .67957 L .25768 .68443 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.74806 .46105 m .73154 .46359 L .71997 .45572 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70343 .4583 m .71997 .45572 L .73154 .46359 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.56819 .2393 m .59766 .24661 L .5818 .25008 L 1 .207 0 r
F
P
p
.55231 .24284 m .56819 .2393 L .5818 .25008 L 1 .259 0 r
F
P
p
.002 w
.47251 .5132 m .45714 .52237 L .44209 .49449 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.42681 .49689 m .44209 .49449 L .45714 .52237 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.68703 .46086 m .67078 .46339 L .65838 .45552 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64236 .47532 m .65838 .45552 L .67078 .46339 L p
1 .065 0 r
F P
0 0 0 r
s
P
p
.50654 .23903 m .53658 .24634 L .52098 .24981 L 1 .388 0 r
F
P
p
.49093 .24257 m .50654 .23903 L .52098 .24981 L 1 .466 0 r
F
P
p
.44484 .23875 m .47546 .24607 L .46012 .24955 L 1 .853 0 r
F
P
p
.4295 .24229 m .44484 .23875 L .46012 .24955 L 1 .957 0 r
F
P
p
.002 w
.53354 .52027 m .51794 .52942 L .50357 .49468 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.48799 .50397 m .50357 .49468 L .51794 .52942 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.3831 .23848 m .41429 .2458 L .39922 .24928 L .823 1 0 r
F
P
p
.36803 .24202 m .3831 .23848 L .39922 .24928 L .746 1 0 r
F
P
p
.32132 .23821 m .35309 .24553 L .33828 .24901 L .448 1 0 r
F
P
p
.30652 .24175 m .32132 .23821 L .33828 .24901 L .293 1 0 r
F
P
p
.2595 .23793 m .29184 .24527 L .27729 .24875 L 0 1 .767 r
F
P
p
.24496 .24148 m .2595 .23793 L .27729 .24875 L 0 .948 1 r
F
P
p
.002 w
.5651 .51566 m .58105 .50635 L .59447 .50668 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.42681 .49689 m .41167 .49928 L .39436 .56203 L p
1 .957 0 r
F P
0 0 0 r
s
P
p
.19764 .23766 m .23055 .245 L .21627 .24848 L 0 1 .922 r
F
P
p
.18337 .24121 m .19764 .23766 L .21627 .24848 L 0 .948 1 r
F
P
p
.83147 .23684 m .85862 .24419 L .84157 .24768 L 1 0 0 r
F
P
p
.81438 .24039 m .83147 .23684 L .84157 .24768 L 1 0 0 r
F
P
p
.76972 .23656 m .79744 .24392 L .78066 .24741 L 1 0 0 r
F
P
p
.7529 .24012 m .76972 .23656 L .78066 .24741 L 1 0 0 r
F
P
p
.002 w
.48799 .50397 m .47251 .5132 L .4575 .49207 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.44209 .49449 m .4575 .49207 L .47251 .5132 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.88717 .45889 m .86998 .46144 L .86026 .45352 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84304 .45612 m .86026 .45352 L .86998 .46144 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70792 .23629 m .73622 .24365 L .7197 .24714 L 1 .078 0 r
F
P
p
.69137 .23985 m .70792 .23629 L .7197 .24714 L 1 .155 0 r
F
P
p
.002 w
.82596 .4587 m .80904 .46125 L .79848 .45332 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78153 .45592 m .79848 .45332 L .80904 .46125 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64608 .23601 m .67496 .24338 L .6587 .24688 L 1 .155 0 r
F
P
p
.6298 .23957 m .64608 .23601 L .6587 .24688 L 1 .207 0 r
F
P
p
.002 w
.28667 .68129 m .27211 .68286 L .25447 .67083 L p
0 1 .948 r
F P
0 0 0 r
s
P
p
.002 w
.23965 .67957 m .25447 .67083 L .27211 .68286 L p
0 .922 1 r
F P
0 0 0 r
s
P
p
.002 w
.54925 .51797 m .53354 .52027 L .51926 .48532 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.50357 .49468 m .51926 .48532 L .53354 .52027 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.76472 .4585 m .74806 .46105 L .73666 .45312 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71997 .45572 m .73666 .45312 L .74806 .46105 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5842 .23574 m .61366 .24311 L .59766 .24661 L 1 .103 0 r
F
P
p
.56819 .2393 m .5842 .23574 L .59766 .24661 L 1 .207 0 r
F
P
p
.002 w
.70343 .4583 m .68703 .46086 L .6748 .45292 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65838 .45552 m .6748 .45292 L .68703 .46086 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.52228 .23546 m .55231 .24284 L .53658 .24634 L 1 .362 0 r
F
P
p
.50654 .23903 m .52228 .23546 L .53658 .24634 L 1 .388 0 r
F
P
p
.46032 .23518 m .49093 .24257 L .47546 .24607 L 1 .802 0 r
F
P
p
.44484 .23875 m .46032 .23518 L .47546 .24607 L 1 .853 0 r
F
P
p
.002 w
.58105 .50635 m .59717 .50397 L .61034 .49745 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.39831 .23491 m .4295 .24229 L .41429 .2458 L .862 1 0 r
F
P
p
.3831 .23848 m .39831 .23491 L .41429 .2458 L .823 1 0 r
F
P
p
.33626 .23463 m .36803 .24202 L .35309 .24553 L .526 1 0 r
F
P
p
.32132 .23821 m .33626 .23463 L .35309 .24553 L .448 1 0 r
F
P
p
.27417 .23435 m .30652 .24175 L .29184 .24527 L 0 1 .224 r
F
P
p
.2595 .23793 m .27417 .23435 L .29184 .24527 L 0 1 .767 r
F
P
p
.002 w
.44209 .49449 m .42681 .49689 L .41015 .5386 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.41015 .5386 m .42681 .49689 L p
.39986 .551 L 1 .957 0 r
F P
0 0 0 r
s
P
p
.002 w
.42577 .52924 m .44209 .49449 L p
.41375 .53363 L 1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.41015 .5386 m .42577 .52924 L p
.41375 .53363 L 1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.4575 .49207 m .44209 .49449 L .42577 .52924 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.42577 .52924 m .44142 .52692 L .4575 .49207 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.42577 .52924 m .40979 .50772 L p
.43792 .5248 L .966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44142 .52692 m .42577 .52924 L p
.43792 .5248 L .966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41015 .5386 m .39417 .51014 L p
.42054 .52607 L .94 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42577 .52924 m .41015 .5386 L p
.42054 .52607 L .94 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39436 .56203 m .41015 .5386 L p
.39986 .551 L 1 .957 0 r
F P
0 0 0 r
s
P
p
.21204 .23408 m .24496 .24148 L .23055 .245 L 0 1 .534 r
F
P
p
.19764 .23766 m .21204 .23408 L .23055 .245 L 0 1 .922 r
F
P
p
.14986 .2338 m .18337 .24121 L .16922 .24473 L 0 .922 1 r
F
P
p
.002 w
.50357 .49468 m .48799 .50397 L .47305 .48962 L p
1 .517 0 r
F P
0 0 0 r
s
P
p
.002 w
.47305 .48962 m .48799 .50397 L p
.46262 .49407 L 1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.47305 .48962 m .48878 .48016 L .50357 .49468 L p
1 .517 0 r
F P
0 0 0 r
s
P
p
.002 w
.47305 .48962 m .45735 .51032 L p
.48361 .48513 L 1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.48878 .48016 m .47305 .48962 L p
.48361 .48513 L 1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.4575 .49207 m .47305 .48962 L p
.46262 .49407 L 1 .595 0 r
F P
0 0 0 r
s
P
p
.83147 .23684 m .84871 .23325 L .85862 .24419 L 1 0 0 r
F
P
p
.78669 .23297 m .81438 .24039 L .79744 .24392 L 1 0 0 r
F
P
p
.76972 .23656 m .78669 .23297 L .79744 .24392 L 1 0 0 r
F
P
p
.002 w
.86026 .45352 m .87764 .4509 L .88717 .45889 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.72462 .23269 m .7529 .24012 L .73622 .24365 L 1 0 0 r
F
P
p
.70792 .23629 m .72462 .23269 L .73622 .24365 L 1 .078 0 r
F
P
p
.002 w
.84304 .45612 m .82596 .4587 L .81559 .45069 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79848 .45332 m .81559 .45069 L .82596 .4587 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66251 .23241 m .69137 .23985 L .67496 .24338 L 1 .155 0 r
F
P
p
.64608 .23601 m .66251 .23241 L .67496 .24338 L 1 .155 0 r
F
P
p
.002 w
.30136 .67969 m .28667 .68129 L .27016 .64065 L p
0 1 .845 r
F P
0 0 0 r
s
P
p
.002 w
.25447 .67083 m .27016 .64065 L .28667 .68129 L p
0 1 .948 r
F P
0 0 0 r
s
P
p
.002 w
.5651 .51566 m .54925 .51797 L .53507 .47589 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.51926 .48532 m .53507 .47589 L .54925 .51797 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.78153 .45592 m .76472 .4585 L .7535 .45049 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73666 .45312 m .7535 .45049 L .76472 .4585 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60036 .23214 m .6298 .23957 L .61366 .24311 L 1 .026 0 r
F
P
p
.5842 .23574 m .60036 .23214 L .61366 .24311 L 1 .103 0 r
F
P
p
.002 w
.23965 .67957 m .22523 .68116 L .20659 .67622 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.71997 .45572 m .70343 .4583 L .69137 .45029 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6748 .45292 m .69137 .45029 L .70343 .4583 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.53817 .23186 m .56819 .2393 L .55231 .24284 L 1 .336 0 r
F
P
p
.52228 .23546 m .53817 .23186 L .55231 .24284 L 1 .362 0 r
F
P
p
.47593 .23158 m .50654 .23903 L .49093 .24257 L 1 .698 0 r
F
P
p
.46032 .23518 m .47593 .23158 L .49093 .24257 L 1 .802 0 r
F
P
p
.002 w
.64236 .47532 m .62641 .49505 L .61331 .49104 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.59717 .50397 m .61331 .49104 L .62641 .49505 L p
1 .582 0 r
F P
0 0 0 r
s
P
p
.41366 .2313 m .44484 .23875 L .4295 .24229 L .914 1 0 r
F
P
p
.39831 .23491 m .41366 .2313 L .4295 .24229 L .862 1 0 r
F
P
p
.35133 .23102 m .3831 .23848 L .36803 .24202 L .694 1 0 r
F
P
p
.33626 .23463 m .35133 .23102 L .36803 .24202 L .526 1 0 r
F
P
p
.002 w
.51926 .48532 m .50357 .49468 L .48878 .48016 L p
1 .414 0 r
F P
0 0 0 r
s
P
p
.28897 .23074 m .32132 .23821 L .30652 .24175 L .241 1 0 r
F
P
p
.27417 .23435 m .28897 .23074 L .30652 .24175 L 0 1 .224 r
F
P
p
.22656 .23047 m .2595 .23793 L .24496 .24148 L 0 1 .25 r
F
P
p
.21204 .23408 m .22656 .23047 L .24496 .24148 L 0 1 .534 r
F
P
p
.16411 .23019 m .19764 .23766 L .18337 .24121 L 0 .974 1 r
F
P
p
.14986 .2338 m .16411 .23019 L .18337 .24121 L 0 .922 1 r
F
P
p
.002 w
.62965 .48505 m .64236 .47532 L p
.61541 .4899 L 1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.61331 .49104 m .62965 .48505 L p
.61541 .4899 L 1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.65838 .45552 m .64236 .47532 L .62965 .48505 L p
1 .323 0 r
F P
0 0 0 r
s
P
p
.002 w
.62965 .48505 m .64618 .48254 L .65838 .45552 L p
1 .323 0 r
F P
0 0 0 r
s
P
p
.002 w
.62965 .48505 m .616 .4489 L p
.64403 .48015 L 1 .284 0 r
F P
0 0 0 r
s
P
p
.002 w
.64618 .48254 m .62965 .48505 L p
.64403 .48015 L 1 .284 0 r
F P
0 0 0 r
s
P
p
.80381 .22935 m .83147 .23684 L .81438 .24039 L 1 0 0 r
F
P
p
.78669 .23297 m .80381 .22935 L .81438 .24039 L 1 0 0 r
F
P
p
.74147 .22907 m .76972 .23656 L .7529 .24012 L 1 0 0 r
F
P
p
.72462 .23269 m .74147 .22907 L .7529 .24012 L 1 0 0 r
F
P
p
.002 w
.86026 .45352 m .84304 .45612 L .83285 .44804 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81559 .45069 m .83285 .44804 L .84304 .45612 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67909 .22879 m .70792 .23629 L .69137 .23985 L 1 .155 0 r
F
P
p
.66251 .23241 m .67909 .22879 L .69137 .23985 L 1 .155 0 r
F
P
p
.002 w
.31639 .67096 m .30136 .67969 L .28491 .63887 L p
0 1 .819 r
F P
0 0 0 r
s
P
p
.002 w
.27016 .64065 m .28491 .63887 L .30136 .67969 L p
0 1 .845 r
F P
0 0 0 r
s
P
p
.002 w
.58105 .50635 m .5651 .51566 L .551 .47337 L p
1 .543 0 r
F P
0 0 0 r
s
P
p
.002 w
.53507 .47589 m .551 .47337 L .5651 .51566 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.79848 .45332 m .78153 .45592 L .77049 .44784 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7535 .45049 m .77049 .44784 L .78153 .45592 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61667 .22851 m .64608 .23601 L .6298 .23957 L 1 0 0 r
F
P
p
.60036 .23214 m .61667 .22851 L .6298 .23957 L 1 .026 0 r
F
P
p
.002 w
.25447 .67083 m .23965 .67957 L .22113 .67458 L p
0 .922 1 r
F P
0 0 0 r
s
P
p
.002 w
.20659 .67622 m .22113 .67458 L .23965 .67957 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.73666 .45312 m .71997 .45572 L .70808 .44764 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69137 .45029 m .70808 .44764 L .71997 .45572 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5542 .22823 m .5842 .23574 L .56819 .2393 L 1 .259 0 r
F
P
p
.53817 .23186 m .5542 .22823 L .56819 .2393 L 1 .336 0 r
F
P
p
.002 w
.6748 .45292 m .65838 .45552 L .64618 .48254 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.53507 .47589 m .51926 .48532 L .50462 .47063 L p
1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.48878 .48016 m .50462 .47063 L .51926 .48532 L p
1 .414 0 r
F P
0 0 0 r
s
P
p
.49169 .22794 m .52228 .23546 L .50654 .23903 L 1 .543 0 r
F
P
p
.47593 .23158 m .49169 .22794 L .50654 .23903 L 1 .698 0 r
F
P
p
.42914 .22766 m .46032 .23518 L .44484 .23875 L .991 1 0 r
F
P
p
.41366 .2313 m .42914 .22766 L .44484 .23875 L .914 1 0 r
F
P
p
.36654 .22738 m .39831 .23491 L .3831 .23848 L .823 1 0 r
F
P
p
.35133 .23102 m .36654 .22738 L .3831 .23848 L .694 1 0 r
F
P
p
.3039 .2271 m .33626 .23463 L .32132 .23821 L .448 1 0 r
F
P
p
.28897 .23074 m .3039 .2271 L .32132 .23821 L .241 1 0 r
F
P
p
.002 w
.47305 .48962 m .4575 .49207 L .44142 .52692 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.24122 .22682 m .27417 .23435 L .2595 .23793 L .06 1 0 r
F
P
p
.22656 .23047 m .24122 .22682 L .2595 .23793 L 0 1 .25 r
F
P
p
.17849 .22654 m .21204 .23408 L .19764 .23766 L 0 1 .534 r
F
P
p
.16411 .23019 m .17849 .22654 L .19764 .23766 L 0 .974 1 r
F
P
p
.002 w
.28491 .63887 m .29979 .63706 L .31639 .67096 L p
0 1 .819 r
F P
0 0 0 r
s
P
p
.002 w
.59717 .50397 m .58105 .50635 L .56707 .47083 L p
1 .517 0 r
F P
0 0 0 r
s
P
p
.002 w
.551 .47337 m .56707 .47083 L .58105 .50635 L p
1 .543 0 r
F P
0 0 0 r
s
P
p
.82109 .22569 m .84871 .23325 L .83147 .23684 L 1 0 0 r
F
P
p
.80381 .22935 m .82109 .22569 L .83147 .23684 L 1 0 0 r
F
P
p
.002 w
.27016 .64065 m .25447 .67083 L .2358 .67293 L p
0 1 .922 r
F P
0 0 0 r
s
P
p
.002 w
.22113 .67458 m .2358 .67293 L .25447 .67083 L p
0 .922 1 r
F P
0 0 0 r
s
P
p
.75848 .22541 m .78669 .23297 L .76972 .23656 L 1 0 0 r
F
P
p
.74147 .22907 m .75848 .22541 L .76972 .23656 L 1 0 0 r
F
P
p
.002 w
.87764 .4509 m .86026 .45352 L .85027 .44537 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83285 .44804 m .85027 .44537 L .86026 .45352 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69582 .22513 m .72462 .23269 L .70792 .23629 L 1 .078 0 r
F
P
p
.67909 .22879 m .69582 .22513 L .70792 .23629 L 1 .155 0 r
F
P
p
.002 w
.28491 .63887 m .27016 .64065 L .25088 .664 L p
0 1 .69 r
F P
0 0 0 r
s
P
p
.002 w
.2358 .67293 m .25088 .664 L .27016 .64065 L p
0 1 .922 r
F P
0 0 0 r
s
P
p
.002 w
.551 .47337 m .53507 .47589 L .52057 .46806 L p
1 .284 0 r
F P
0 0 0 r
s
P
p
.002 w
.50462 .47063 m .52057 .46806 L p
.51483 .4724 L 1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.52057 .46806 m .50462 .47063 L .48938 .49113 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.52057 .46806 m .5056 .47428 L p
.52638 .46365 L 1 .388 0 r
F P
0 0 0 r
s
P
p
.002 w
.53665 .45841 m .52057 .46806 L p
.52638 .46365 L 1 .388 0 r
F P
0 0 0 r
s
P
p
.002 w
.52057 .46806 m .53507 .47589 L p
.51483 .4724 L 1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.81559 .45069 m .79848 .45332 L .78763 .44517 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77049 .44784 m .78763 .44517 L .79848 .45332 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.63312 .22484 m .66251 .23241 L .64608 .23601 L 1 0 0 r
F
P
p
.61667 .22851 m .63312 .22484 L .64608 .23601 L 1 0 0 r
F
P
p
.002 w
.7535 .45049 m .73666 .45312 L .72495 .44496 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70808 .44764 m .72495 .44496 L .73666 .45312 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.57038 .22456 m .60036 .23214 L .5842 .23574 L 1 .181 0 r
F
P
p
.5542 .22823 m .57038 .22456 L .5842 .23574 L 1 .259 0 r
F
P
p
.002 w
.69137 .45029 m .6748 .45292 L .6626 .46586 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.6626 .46586 m .6748 .45292 L p
.65341 .47506 L 1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.6626 .46586 m .6493 .43636 L p
.67191 .45656 L 1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.6626 .46586 m .6794 .46325 L .69137 .45029 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.6794 .46325 m .6626 .46586 L p
.67191 .45656 L 1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.64618 .48254 m .6626 .46586 L p
.65341 .47506 L 1 .207 0 r
F P
0 0 0 r
s
P
p
.50759 .22428 m .53817 .23186 L .52228 .23546 L 1 .44 0 r
F
P
p
.49169 .22794 m .50759 .22428 L .52228 .23546 L 1 .543 0 r
F
P
p
.44476 .22399 m .47593 .23158 L .46032 .23518 L 1 .957 0 r
F
P
p
.42914 .22766 m .44476 .22399 L .46032 .23518 L .991 1 0 r
F
P
p
.38189 .22371 m .41366 .2313 L .39831 .23491 L .888 1 0 r
F
P
p
.36654 .22738 m .38189 .22371 L .39831 .23491 L .823 1 0 r
F
P
p
.31897 .22343 m .35133 .23102 L .33626 .23463 L .552 1 0 r
F
P
p
.3039 .2271 m .31897 .22343 L .33626 .23463 L .448 1 0 r
F
P
p
.002 w
.34749 .62477 m .33133 .6693 L .31608 .59233 L p
0 1 .224 r
F P
0 0 0 r
s
P
p
.002 w
.31608 .59233 m .33193 .56186 L .34749 .62477 L p
0 1 .224 r
F P
0 0 0 r
s
P
p
.002 w
.45735 .51032 m .47305 .48962 L p
.44675 .52063 L 1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.45735 .51032 m .44155 .49561 L p
.46806 .49991 L 1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.45735 .51032 m .47331 .50076 L .48878 .48016 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.47331 .50076 m .45735 .51032 L p
.46806 .49991 L 1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.44142 .52692 m .45735 .51032 L p
.44675 .52063 L 1 .776 0 r
F P
0 0 0 r
s
P
p
.25601 .22314 m .28897 .23074 L .27417 .23435 L .371 1 0 r
F
P
p
.24122 .22682 m .25601 .22314 L .27417 .23435 L .06 1 0 r
F
P
p
.193 .22286 m .22656 .23047 L .21204 .23408 L .241 1 0 r
F
P
p
.17849 .22654 m .193 .22286 L .21204 .23408 L 0 1 .534 r
F
P
p
.12995 .22257 m .16411 .23019 L .14986 .2338 L 0 .897 1 r
F
P
p
.002 w
.29979 .63706 m .31608 .59233 L .33133 .6693 L p
0 1 .638 r
F P
0 0 0 r
s
P
p
.002 w
.61331 .49104 m .59717 .50397 L .58328 .46826 L p
1 .478 0 r
F P
0 0 0 r
s
P
p
.002 w
.56707 .47083 m .58328 .46826 L .59717 .50397 L p
1 .517 0 r
F P
0 0 0 r
s
P
p
.82109 .22569 m .83852 .222 L .84871 .23325 L 1 0 0 r
F
P
p
.77563 .22172 m .80381 .22935 L .78669 .23297 L 1 0 0 r
F
P
p
.75848 .22541 m .77563 .22172 L .78669 .23297 L 1 0 0 r
F
P
p
.002 w
.85027 .44537 m .86785 .44268 L .87764 .4509 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7127 .22143 m .74147 .22907 L .72462 .23269 L 1 0 0 r
F
P
p
.69582 .22513 m .7127 .22143 L .72462 .23269 L 1 .078 0 r
F
P
p
.002 w
.29979 .63706 m .28491 .63887 L .26686 .63327 L p
0 1 .431 r
F P
0 0 0 r
s
P
p
.002 w
.25088 .664 m .26686 .63327 L .28491 .63887 L p
0 1 .69 r
F P
0 0 0 r
s
P
p
.002 w
.56707 .47083 m .551 .47337 L .53665 .45841 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.52057 .46806 m .53665 .45841 L .551 .47337 L p
1 .284 0 r
F P
0 0 0 r
s
P
p
.002 w
.83285 .44804 m .81559 .45069 L .80493 .44247 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78763 .44517 m .80493 .44247 L .81559 .45069 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64972 .22115 m .67909 .22879 L .66251 .23241 L 1 0 0 r
F
P
p
.63312 .22484 m .64972 .22115 L .66251 .23241 L 1 0 0 r
F
P
p
.002 w
.77049 .44784 m .7535 .45049 L .74197 .44226 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72495 .44496 m .74197 .44226 L .7535 .45049 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5867 .22086 m .61667 .22851 L .60036 .23214 L 1 .103 0 r
F
P
p
.57038 .22456 m .5867 .22086 L .60036 .23214 L 1 .181 0 r
F
P
p
.002 w
.22113 .67458 m .20659 .67622 L .18744 .67113 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.37878 .5783 m .36261 .62291 L .34708 .55971 L p
.293 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34708 .55971 m .36303 .52906 L .37878 .5783 L p
.293 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70808 .44764 m .69137 .45029 L .6794 .46325 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.52363 .22057 m .5542 .22823 L .53817 .23186 L 1 .362 0 r
F
P
p
.50759 .22428 m .52363 .22057 L .53817 .23186 L 1 .44 0 r
F
P
p
.002 w
.50462 .47063 m .48878 .48016 L .47331 .50076 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.46052 .22029 m .49169 .22794 L .47593 .23158 L 1 .879 0 r
F
P
p
.44476 .22399 m .46052 .22029 L .47593 .23158 L 1 .957 0 r
F
P
p
.39737 .22 m .42914 .22766 L .41366 .2313 L .94 1 0 r
F
P
p
.38189 .22371 m .39737 .22 L .41366 .2313 L .888 1 0 r
F
P
p
.33417 .21972 m .36654 .22738 L .35133 .23102 L .784 1 0 r
F
P
p
.31897 .22343 m .33417 .21972 L .35133 .23102 L .552 1 0 r
F
P
p
.002 w
.62965 .48505 m .61331 .49104 L .59965 .46566 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.58328 .46826 m .59965 .46566 L .61331 .49104 L p
1 .478 0 r
F P
0 0 0 r
s
P
p
.002 w
.33193 .56186 m .34708 .55971 L .36261 .62291 L p
.034 1 0 r
F P
0 0 0 r
s
P
p
.27093 .21943 m .3039 .2271 L .28897 .23074 L .5 1 0 r
F
P
p
.25601 .22314 m .27093 .21943 L .28897 .23074 L .371 1 0 r
F
P
p
.20764 .21914 m .24122 .22682 L .22656 .23047 L .578 1 0 r
F
P
p
.193 .22286 m .20764 .21914 L .22656 .23047 L .241 1 0 r
F
P
p
.14431 .21886 m .17849 .22654 L .16411 .23019 L 0 .922 1 r
F
P
p
.12995 .22257 m .14431 .21886 L .16411 .23019 L 0 .897 1 r
F
P
p
.002 w
.33193 .56186 m .31608 .59233 L .29887 .57168 L p
.241 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31608 .59233 m .29979 .63706 L .28334 .58812 L p
0 1 .069 r
F P
0 0 0 r
s
P
p
.002 w
.28334 .58812 m .29887 .57168 L .31608 .59233 L p
0 1 .069 r
F P
0 0 0 r
s
P
p
.002 w
.41015 .5386 m .39436 .56203 L .37855 .51963 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36303 .52906 m .37855 .51963 L .39436 .56203 L p
.629 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34708 .55971 m .33193 .56186 L .31403 .56955 L p
.397 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29887 .57168 m .31403 .56955 L .33193 .56186 L p
.241 1 0 r
F P
0 0 0 r
s
P
p
.79294 .21799 m .82109 .22569 L .80381 .22935 L 1 0 0 r
F
P
p
.77563 .22172 m .79294 .21799 L .80381 .22935 L 1 0 0 r
F
P
p
.72973 .2177 m .75848 .22541 L .74147 .22907 L 1 0 0 r
F
P
p
.7127 .22143 m .72973 .2177 L .74147 .22907 L 1 0 0 r
F
P
p
.002 w
.26686 .63327 m .28334 .58812 L .29979 .63706 L p
0 1 .431 r
F P
0 0 0 r
s
P
p
.002 w
.58328 .46826 m .56707 .47083 L .55286 .45576 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.53665 .45841 m .55286 .45576 L .56707 .47083 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.85027 .44537 m .83285 .44804 L .82239 .43975 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80493 .44247 m .82239 .43975 L .83285 .44804 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66647 .21742 m .69582 .22513 L .67909 .22879 L 1 0 0 r
F
P
p
.64972 .22115 m .66647 .21742 L .67909 .22879 L 1 0 0 r
F
P
p
.002 w
.47331 .50076 m .48938 .49113 L .50462 .47063 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.37855 .51963 m .39417 .51014 L .41015 .5386 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.78763 .44517 m .77049 .44784 L .75915 .43954 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74197 .44226 m .75915 .43954 L .77049 .44784 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60317 .21713 m .63312 .22484 L .61667 .22851 L 1 .026 0 r
F
P
p
.5867 .22086 m .60317 .21713 L .61667 .22851 L 1 .103 0 r
F
P
p
.002 w
.2358 .67293 m .22113 .67458 L .20209 .66945 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.18744 .67113 m .20209 .66945 L .22113 .67458 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.72495 .44496 m .70808 .44764 L .69634 .46061 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.6794 .46325 m .69634 .46061 L .70808 .44764 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.53982 .21684 m .57038 .22456 L .5542 .22823 L 1 .31 0 r
F
P
p
.52363 .22057 m .53982 .21684 L .5542 .22823 L 1 .362 0 r
F
P
p
.47643 .21655 m .50759 .22428 L .49169 .22794 L 1 .724 0 r
F
P
p
.46052 .22029 m .47643 .21655 L .49169 .22794 L 1 .879 0 r
F
P
p
.002 w
.59965 .46566 m .616 .4489 L .62965 .48505 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.41299 .21626 m .44476 .22399 L .42914 .22766 L 1 .983 0 r
F
P
p
.39737 .22 m .41299 .21626 L .42914 .22766 L .94 1 0 r
F
P
p
.34951 .21597 m .38189 .22371 L .36654 .22738 L .914 1 0 r
F
P
p
.33417 .21972 m .34951 .21597 L .36654 .22738 L .784 1 0 r
F
P
p
.28599 .21568 m .31897 .22343 L .3039 .2271 L .655 1 0 r
F
P
p
.27093 .21943 m .28599 .21568 L .3039 .2271 L .5 1 0 r
F
P
p
.22242 .21539 m .25601 .22314 L .24122 .22682 L .655 1 0 r
F
P
p
.20764 .21914 m .22242 .21539 L .24122 .22682 L .578 1 0 r
F
P
p
.15881 .2151 m .193 .22286 L .17849 .22654 L 0 1 .69 r
F
P
p
.14431 .21886 m .15881 .2151 L .17849 .22654 L 0 .922 1 r
F
P
p
.002 w
.36303 .52906 m .34708 .55971 L .32975 .55294 L p
.552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31403 .56955 m .32975 .55294 L .34708 .55971 L p
.397 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39417 .51014 m .40979 .50772 L .42577 .52924 L p
.94 1 0 r
F P
0 0 0 r
s
P
p
.81041 .21423 m .83852 .222 L .82109 .22569 L 1 0 0 r
F
P
p
.79294 .21799 m .81041 .21423 L .82109 .22569 L 1 0 0 r
F
P
p
.002 w
.37855 .51963 m .36303 .52906 L .34517 .55071 L p
.681 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32975 .55294 m .34517 .55071 L .36303 .52906 L p
.552 1 0 r
F P
0 0 0 r
s
P
p
.74692 .21394 m .77563 .22172 L .75848 .22541 L 1 0 0 r
F
P
p
.72973 .2177 m .74692 .21394 L .75848 .22541 L 1 0 0 r
F
P
p
.002 w
.59965 .46566 m .58328 .46826 L .56923 .45309 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.55286 .45576 m .56923 .45309 L p
.56509 .46079 L 1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.56923 .45309 m .55286 .45576 L .5383 .46904 L p
1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.56923 .45309 m .55486 .45915 L p
.57343 .44527 L 1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.58564 .43615 m .56923 .45309 L p
.57343 .44527 L 1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.56923 .45309 m .58328 .46826 L p
.56509 .46079 L 1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.86785 .44268 m .85027 .44537 L .84 .437 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82239 .43975 m .84 .437 L .85027 .44537 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68338 .21365 m .7127 .22143 L .69582 .22513 L 1 0 0 r
F
P
p
.66647 .21742 m .68338 .21365 L .69582 .22513 L 1 0 0 r
F
P
p
.002 w
.48938 .49113 m .5056 .47428 L .52057 .46806 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.80493 .44247 m .78763 .44517 L .77648 .43679 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75915 .43954 m .77648 .43679 L .78763 .44517 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61979 .21336 m .64972 .22115 L .63312 .22484 L 1 0 0 r
F
P
p
.60317 .21713 m .61979 .21336 L .63312 .22484 L 1 .026 0 r
F
P
p
.002 w
.25088 .664 m .2358 .67293 L .21688 .66775 L p
0 .922 1 r
F P
0 0 0 r
s
P
p
.002 w
.20209 .66945 m .21688 .66775 L .2358 .67293 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.74197 .44226 m .72495 .44496 L .71344 .45795 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.69634 .46061 m .71344 .45795 L .72495 .44496 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.55616 .21307 m .5867 .22086 L .57038 .22456 L 1 .284 0 r
F
P
p
.53982 .21684 m .55616 .21307 L .57038 .22456 L 1 .31 0 r
F
P
p
.49248 .21278 m .52363 .22057 L .50759 .22428 L 1 .595 0 r
F
P
p
.47643 .21655 m .49248 .21278 L .50759 .22428 L 1 .724 0 r
F
P
p
.002 w
.6626 .46586 m .64618 .48254 L .63253 .43911 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.616 .4489 m .63253 .43911 L .64618 .48254 L p
1 .284 0 r
F P
0 0 0 r
s
P
p
.42876 .21249 m .46052 .22029 L .44476 .22399 L 1 .905 0 r
F
P
p
.41299 .21626 m .42876 .21249 L .44476 .22399 L 1 .983 0 r
F
P
p
.365 .2122 m .39737 .22 L .38189 .22371 L .991 1 0 r
F
P
p
.34951 .21597 m .365 .2122 L .38189 .22371 L .914 1 0 r
F
P
p
.30119 .2119 m .33417 .21972 L .31897 .22343 L .733 1 0 r
F
P
p
.28599 .21568 m .30119 .2119 L .31897 .22343 L .655 1 0 r
F
P
p
.23733 .21161 m .27093 .21943 L .25601 .22314 L .784 1 0 r
F
P
p
.22242 .21539 m .23733 .21161 L .25601 .22314 L .655 1 0 r
F
P
p
.17343 .21132 m .20764 .21914 L .193 .22286 L 0 1 .276 r
F
P
p
.15881 .2151 m .17343 .21132 L .193 .22286 L 0 1 .69 r
F
P
p
.002 w
.39417 .51014 m .37855 .51963 L .36073 .54845 L p
.746 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34517 .55071 m .36073 .54845 L .37855 .51963 L p
.681 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31403 .56955 m .29887 .57168 L .27767 .65334 L p
0 1 .121 r
F P
0 0 0 r
s
P
p
.002 w
.32975 .55294 m .31403 .56955 L .30998 .57129 L p
.293 1 0 r
F P
0 0 0 r
s
P
p
.29083 .59153 m .29887 .57168 L .27871 .60434 L 0 1 .457 r
F
P
p
.002 w
.26206 .66256 m .27767 .65334 L .29887 .57168 L p
0 1 .457 r
F P
0 0 0 r
s
P
p
.002 w
.30998 .57129 m .29556 .57748 L p
.32223 .55834 L .293 1 0 r
F P
0 0 0 r
s
P
p
.32223 .55834 m .32975 .55294 L .30998 .57129 L .293 1 0 r
F
P
p
.002 w
.29887 .57168 m .28334 .58812 L .27871 .60434 L p
0 1 .457 r
F P
0 0 0 r
s
P
p
.002 w
.27871 .60434 m .26206 .66256 L p
.29083 .59153 L 0 1 .457 r
F P
0 0 0 r
s
P
p
.002 w
.26686 .63327 m .25088 .664 L .2318 .66604 L p
0 1 .948 r
F P
0 0 0 r
s
P
p
.002 w
.2318 .66604 m .24686 .66431 L .26686 .63327 L p
0 1 .948 r
F P
0 0 0 r
s
P
p
.002 w
.28334 .58812 m .26686 .63327 L .24686 .66431 L p
0 1 .69 r
F P
0 0 0 r
s
P
p
.002 w
.24686 .66431 m .26206 .66256 L .28334 .58812 L p
0 1 .69 r
F P
0 0 0 r
s
P
p
.002 w
.55286 .45576 m .53665 .45841 L .52188 .47167 L p
1 .362 0 r
F P
0 0 0 r
s
P
p
.002 w
.5056 .47428 m .52188 .47167 L .53665 .45841 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.002 w
.45735 .51032 m .44142 .52692 L .42555 .50528 L p
1 .957 0 r
F P
0 0 0 r
s
P
p
.002 w
.42555 .50528 m .44142 .52692 L p
.41434 .51048 L .966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42555 .50528 m .44155 .49561 L .45735 .51032 L p
1 .957 0 r
F P
0 0 0 r
s
P
p
.002 w
.42555 .50528 m .40854 .52684 L p
.43689 .50001 L .914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44155 .49561 m .42555 .50528 L p
.43689 .50001 L .914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.40979 .50772 m .42555 .50528 L p
.41434 .51048 L .966 1 0 r
F P
0 0 0 r
s
P
p
.81041 .21423 m .82804 .21044 L .83852 .222 L 1 0 0 r
F
P
p
.002 w
.63253 .43911 m .6493 .43636 L .6626 .46586 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.21688 .66775 m .2318 .66604 L .25088 .664 L p
0 .922 1 r
F P
0 0 0 r
s
P
p
.76426 .21015 m .79294 .21799 L .77563 .22172 L 1 0 0 r
F
P
p
.74692 .21394 m .76426 .21015 L .77563 .22172 L 1 0 0 r
F
P
p
.002 w
.616 .4489 m .59965 .46566 L .58564 .43615 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.002 w
.56923 .45309 m .58564 .43615 L .59965 .46566 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.84 .437 m .85778 .43423 L .86785 .44268 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70043 .20985 m .72973 .2177 L .7127 .22143 L 1 0 0 r
F
P
p
.68338 .21365 m .70043 .20985 L .7127 .22143 L 1 0 0 r
F
P
p
.002 w
.82239 .43975 m .80493 .44247 L .79397 .43401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77648 .43679 m .79397 .43401 L .80493 .44247 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.63656 .20956 m .66647 .21742 L .64972 .22115 L 1 0 0 r
F
P
p
.61979 .21336 m .63656 .20956 L .64972 .22115 L 1 0 0 r
F
P
p
.002 w
.75915 .43954 m .74197 .44226 L .73012 .4338 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71344 .45795 m .73012 .4338 L .74197 .44226 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.57265 .20927 m .60317 .21713 L .5867 .22086 L 1 .181 0 r
F
P
p
.55616 .21307 m .57265 .20927 L .5867 .22086 L 1 .284 0 r
F
P
p
.002 w
.20209 .66945 m .18744 .67113 L .16774 .6659 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.50868 .20897 m .53982 .21684 L .52363 .22057 L 1 .517 0 r
F
P
p
.49248 .21278 m .50868 .20897 L .52363 .22057 L 1 .595 0 r
F
P
p
.44467 .20868 m .47643 .21655 L .46052 .22029 L 1 .853 0 r
F
P
p
.42876 .21249 m .44467 .20868 L .46052 .22029 L 1 .905 0 r
F
P
p
.38062 .20838 m .41299 .21626 L .39737 .22 L 1 .905 0 r
F
P
p
.365 .2122 m .38062 .20838 L .39737 .22 L .991 1 0 r
F
P
p
.31652 .20809 m .34951 .21597 L .33417 .21972 L .81 1 0 r
F
P
p
.30119 .2119 m .31652 .20809 L .33417 .21972 L .733 1 0 r
F
P
p
.002 w
.40979 .50772 m .39417 .51014 L .37651 .54252 L p
.823 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36073 .54845 m .37651 .54252 L .39417 .51014 L p
.746 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63253 .43911 m .616 .4489 L .60227 .43337 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.58564 .43615 m .60227 .43337 L .616 .4489 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.25238 .20779 m .28599 .21568 L .27093 .21943 L .862 1 0 r
F
P
p
.23733 .21161 m .25238 .20779 L .27093 .21943 L .784 1 0 r
F
P
p
.18819 .2075 m .22242 .21539 L .20764 .21914 L 0 1 .224 r
F
P
p
.17343 .21132 m .18819 .2075 L .20764 .21914 L 0 1 .276 r
F
P
p
.002 w
.52188 .47167 m .5383 .46904 L .55286 .45576 L p
1 .362 0 r
F P
0 0 0 r
s
P
p
.002 w
.69634 .46061 m .6794 .46325 L .66622 .43358 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.6493 .43636 m .66622 .43358 L .6794 .46325 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.78177 .20632 m .81041 .21423 L .79294 .21799 L 1 0 0 r
F
P
p
.76426 .21015 m .78177 .20632 L .79294 .21799 L 1 0 0 r
F
P
p
.71765 .20602 m .74692 .21394 L .72973 .2177 L 1 0 0 r
F
P
p
.70043 .20985 m .71765 .20602 L .72973 .2177 L 1 0 0 r
F
P
p
.002 w
.84 .437 m .82239 .43975 L .81162 .43121 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79397 .43401 m .81162 .43121 L .82239 .43975 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.65349 .20572 m .68338 .21365 L .66647 .21742 L 1 0 0 r
F
P
p
.63656 .20956 m .65349 .20572 L .66647 .21742 L 1 0 0 r
F
P
p
.002 w
.77648 .43679 m .75915 .43954 L .74748 .43099 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73012 .4338 m .74748 .43099 L .75915 .43954 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.58928 .20543 m .61979 .21336 L .60317 .21713 L 1 .052 0 r
F
P
p
.57265 .20927 m .58928 .20543 L .60317 .21713 L 1 .181 0 r
F
P
p
.002 w
.21688 .66775 m .20209 .66945 L .18251 .66417 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.16774 .6659 m .18251 .66417 L .20209 .66945 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.48938 .49113 m .47331 .50076 L .45758 .49309 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.44155 .49561 m .45758 .49309 L .47331 .50076 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.52503 .20513 m .55616 .21307 L .53982 .21684 L 1 .466 0 r
F
P
p
.50868 .20897 m .52503 .20513 L .53982 .21684 L 1 .517 0 r
F
P
p
.002 w
.27767 .65334 m .29556 .57748 L .31403 .56955 L p
0 1 .121 r
F P
0 0 0 r
s
P
p
.002 w
.6493 .43636 m .63253 .43911 L .61906 .43056 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60227 .43337 m .61906 .43056 L .63253 .43911 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.46073 .20483 m .49248 .21278 L .47643 .21655 L 1 .776 0 r
F
P
p
.44467 .20868 m .46073 .20483 L .47643 .21655 L 1 .853 0 r
F
P
p
.39639 .20454 m .42876 .21249 L .41299 .21626 L 1 .853 0 r
F
P
p
.38062 .20838 m .39639 .20454 L .41299 .21626 L 1 .905 0 r
F
P
p
.332 .20424 m .365 .2122 L .34951 .21597 L .862 1 0 r
F
P
p
.31652 .20809 m .332 .20424 L .34951 .21597 L .81 1 0 r
F
P
p
.002 w
.42555 .50528 m .40979 .50772 L .39257 .52923 L p
.862 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39257 .52923 m .40979 .50772 L p
.38183 .53695 L .823 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39257 .52923 m .40854 .52684 L .42555 .50528 L p
.862 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39257 .52923 m .376 .49233 L p
.40342 .52142 L .888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.40854 .52684 m .39257 .52923 L p
.40342 .52142 L .888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37651 .54252 m .39257 .52923 L p
.38183 .53695 L .823 1 0 r
F P
0 0 0 r
s
P
p
.26757 .20394 m .30119 .2119 L .28599 .21568 L .914 1 0 r
F
P
p
.25238 .20779 m .26757 .20394 L .28599 .21568 L .862 1 0 r
F
P
p
.20309 .20364 m .23733 .21161 L .22242 .21539 L 0 1 .147 r
F
P
p
.18819 .2075 m .20309 .20364 L .22242 .21539 L 0 1 .224 r
F
P
p
.002 w
.55486 .45915 m .56923 .45309 L p
.54455 .46582 L 1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.55486 .45915 m .57158 .45644 L .58564 .43615 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.55486 .45915 m .54 .4361 L p
.5653 .45239 L 1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.57158 .45644 m .55486 .45915 L p
.5653 .45239 L 1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.5383 .46904 m .55486 .45915 L p
.54455 .46582 L 1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.34517 .55071 m .32975 .55294 L .31192 .54599 L p
.448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29556 .57748 m .31192 .54599 L .32975 .55294 L p
.293 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71344 .45795 m .69634 .46061 L .68329 .43078 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.66622 .43358 m .68329 .43078 L .69634 .46061 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.79943 .20245 m .82804 .21044 L .81041 .21423 L 1 0 0 r
F
P
p
.78177 .20632 m .79943 .20245 L .81041 .21423 L 1 0 0 r
F
P
p
.002 w
.5056 .47428 m .48938 .49113 L .47376 .49055 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.45758 .49309 m .47376 .49055 L p
.47357 .49211 L 1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.47376 .49055 m .45758 .49309 L .44111 .50724 L p
1 .957 0 r
F P
0 0 0 r
s
P
p
.002 w
.47376 .49055 m .45758 .49732 L p
.47397 .48896 L 1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.49014 .4807 m .47376 .49055 L p
.47397 .48896 L 1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.47376 .49055 m .48938 .49113 L p
.47357 .49211 L 1 .802 0 r
F P
0 0 0 r
s
P
p
.73503 .20215 m .76426 .21015 L .74692 .21394 L 1 0 0 r
F
P
p
.71765 .20602 m .73503 .20215 L .74692 .21394 L 1 0 0 r
F
P
p
.002 w
.85778 .43423 m .84 .437 L .82944 .42838 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81162 .43121 m .82944 .42838 L .84 .437 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67058 .20185 m .70043 .20985 L .68338 .21365 L 1 0 0 r
F
P
p
.65349 .20572 m .67058 .20185 L .68338 .21365 L 1 0 0 r
F
P
p
.002 w
.79397 .43401 m .77648 .43679 L .76501 .42817 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74748 .43099 m .76501 .42817 L .77648 .43679 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60608 .20155 m .63656 .20956 L .61979 .21336 L 1 0 0 r
F
P
p
.58928 .20543 m .60608 .20155 L .61979 .21336 L 1 .052 0 r
F
P
p
.002 w
.2318 .66604 m .21688 .66775 L .19742 .66243 L p
0 .922 1 r
F P
0 0 0 r
s
P
p
.002 w
.18251 .66417 m .19742 .66243 L .21688 .66775 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.54153 .20125 m .57265 .20927 L .55616 .21307 L 1 .44 0 r
F
P
p
.52503 .20513 m .54153 .20125 L .55616 .21307 L 1 .466 0 r
F
P
p
.002 w
.66622 .43358 m .6493 .43636 L .636 .42773 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.61906 .43056 m .636 .42773 L .6493 .43636 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.47694 .20095 m .50868 .20897 L .49248 .21278 L 1 .698 0 r
F
P
p
.46073 .20483 m .47694 .20095 L .49248 .21278 L 1 .776 0 r
F
P
p
.002 w
.60227 .43337 m .58564 .43615 L .57158 .45644 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.41231 .20065 m .44467 .20868 L .42876 .21249 L 1 .802 0 r
F
P
p
.39639 .20454 m .41231 .20065 L .42876 .21249 L 1 .853 0 r
F
P
p
.34762 .20035 m .38062 .20838 L .365 .2122 L .966 1 0 r
F
P
p
.332 .20424 m .34762 .20035 L .365 .2122 L .862 1 0 r
F
P
p
.002 w
.47376 .49055 m .49014 .4807 L .5056 .47428 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.52188 .47167 m .5056 .47428 L .49014 .4807 L p
1 .543 0 r
F P
0 0 0 r
s
P
p
.2829 .20005 m .31652 .20809 L .30119 .2119 L .966 1 0 r
F
P
p
.26757 .20394 m .2829 .20005 L .30119 .2119 L .914 1 0 r
F
P
p
.21812 .19975 m .25238 .20779 L .23733 .21161 L .164 1 0 r
F
P
p
.20309 .20364 m .21812 .19975 L .23733 .21161 L 0 1 .147 r
F
P
p
.002 w
.36073 .54845 m .34517 .55071 L .32748 .54369 L p
.526 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31192 .54599 m .32748 .54369 L .34517 .55071 L p
.448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73012 .4338 m .71344 .45795 L .70053 .42795 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.68329 .43078 m .70053 .42795 L .71344 .45795 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.79943 .20245 m .81727 .19855 L .82804 .21044 L 1 0 0 r
F
P
p
.75257 .19825 m .78177 .20632 L .76426 .21015 L 1 0 0 r
F
P
p
.73503 .20215 m .75257 .19825 L .76426 .21015 L 1 0 0 r
F
P
p
.002 w
.82944 .42838 m .84742 .42553 L .85778 .43423 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68782 .19794 m .71765 .20602 L .70043 .20985 L 1 0 0 r
F
P
p
.67058 .20185 m .68782 .19794 L .70043 .20985 L 1 0 0 r
F
P
p
.002 w
.81162 .43121 m .79397 .43401 L .78269 .42531 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76501 .42817 m .78269 .42531 L .79397 .43401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.62303 .19764 m .65349 .20572 L .63656 .20956 L 1 0 0 r
F
P
p
.60608 .20155 m .62303 .19764 L .63656 .20956 L 1 0 0 r
F
P
p
.002 w
.24686 .66431 m .2318 .66604 L .21279 .6532 L p
0 .948 1 r
F P
0 0 0 r
s
P
p
.002 w
.19742 .66243 m .21279 .6532 L .2318 .66604 L p
0 .922 1 r
F P
0 0 0 r
s
P
p
.002 w
.74748 .43099 m .73012 .4338 L .71792 .42509 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70053 .42795 m .71792 .42509 L .73012 .4338 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.55819 .19734 m .58928 .20543 L .57265 .20927 L 1 .336 0 r
F
P
p
.54153 .20125 m .55819 .19734 L .57265 .20927 L 1 .44 0 r
F
P
p
.002 w
.18251 .66417 m .16774 .6659 L .14747 .66053 L p
0 .922 1 r
F P
0 0 0 r
s
P
p
.002 w
.45758 .49309 m .44155 .49561 L .42477 .51708 L p
.991 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.40854 .52684 m .42477 .51708 L .44155 .49561 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68329 .43078 m .66622 .43358 L .6531 .42487 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.636 .42773 m .6531 .42487 L .66622 .43358 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.4933 .19704 m .52503 .20513 L .50868 .20897 L 1 .647 0 r
F
P
p
.47694 .20095 m .4933 .19704 L .50868 .20897 L 1 .698 0 r
F
P
p
.002 w
.61906 .43056 m .60227 .43337 L .5884 .44641 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.002 w
.57158 .45644 m .5884 .44641 L .60227 .43337 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.42837 .19673 m .46073 .20483 L .44467 .20868 L 1 .776 0 r
F
P
p
.41231 .20065 m .42837 .19673 L .44467 .20868 L 1 .802 0 r
F
P
p
.36339 .19643 m .39639 .20454 L .38062 .20838 L 1 .905 0 r
F
P
p
.34762 .20035 m .36339 .19643 L .38062 .20838 L .966 1 0 r
F
P
p
.002 w
.5383 .46904 m .52188 .47167 L .5067 .45623 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.49014 .4807 m .5067 .45623 L .52188 .47167 L p
1 .543 0 r
F P
0 0 0 r
s
P
p
.29837 .19613 m .332 .20424 L .31652 .20809 L .966 1 0 r
F
P
p
.2829 .20005 m .29837 .19613 L .31652 .20809 L .966 1 0 r
F
P
p
.2333 .19582 m .26757 .20394 L .25238 .20779 L .448 1 0 r
F
P
p
.21812 .19975 m .2333 .19582 L .25238 .20779 L .164 1 0 r
F
P
p
.002 w
.37651 .54252 m .36073 .54845 L .34376 .51933 L p
.694 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32748 .54369 m .34376 .51933 L .36073 .54845 L p
.526 1 0 r
F P
0 0 0 r
s
P
p
.77027 .1943 m .79943 .20245 L .78177 .20632 L 1 0 0 r
F
P
p
.75257 .19825 m .77027 .1943 L .78177 .20632 L 1 0 0 r
F
P
p
.70523 .194 m .73503 .20215 L .71765 .20602 L 1 0 0 r
F
P
p
.68782 .19794 m .70523 .194 L .71765 .20602 L 1 0 0 r
F
P
p
.002 w
.82944 .42838 m .81162 .43121 L .80055 .42243 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78269 .42531 m .80055 .42243 L .81162 .43121 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64014 .19369 m .67058 .20185 L .65349 .20572 L 1 0 0 r
F
P
p
.62303 .19764 m .64014 .19369 L .65349 .20572 L 1 0 0 r
F
P
p
.002 w
.26206 .66256 m .24686 .66431 L .22796 .65139 L p
0 .948 1 r
F P
0 0 0 r
s
P
p
.002 w
.21279 .6532 m .22796 .65139 L .24686 .66431 L p
0 .948 1 r
F P
0 0 0 r
s
P
p
.002 w
.76501 .42817 m .74748 .43099 L .73548 .42221 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71792 .42509 m .73548 .42221 L .74748 .43099 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.575 .19339 m .60608 .20155 L .58928 .20543 L 1 .233 0 r
F
P
p
.55819 .19734 m .575 .19339 L .58928 .20543 L 1 .336 0 r
F
P
p
.002 w
.19742 .66243 m .18251 .66417 L .16274 .65125 L p
0 .948 1 r
F P
0 0 0 r
s
P
p
.002 w
.14747 .66053 m .16274 .65125 L .18251 .66417 L p
0 .922 1 r
F P
0 0 0 r
s
P
p
.002 w
.42477 .51708 m .44111 .50724 L .45758 .49309 L p
.991 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70053 .42795 m .68329 .43078 L .67036 .42198 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6531 .42487 m .67036 .42198 L .68329 .43078 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.50982 .19308 m .54153 .20125 L .52503 .20513 L 1 .595 0 r
F
P
p
.4933 .19704 m .50982 .19308 L .52503 .20513 L 1 .647 0 r
F
P
p
.002 w
.636 .42773 m .61906 .43056 L .60527 .42903 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.5884 .44641 m .60527 .42903 L .61906 .43056 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.44459 .19278 m .47694 .20095 L .46073 .20483 L 1 .75 0 r
F
P
p
.42837 .19673 m .44459 .19278 L .46073 .20483 L 1 .776 0 r
F
P
p
.37931 .19247 m .41231 .20065 L .39639 .20454 L 1 .853 0 r
F
P
p
.36339 .19643 m .37931 .19247 L .39639 .20454 L 1 .905 0 r
F
P
p
.002 w
.55486 .45915 m .5383 .46904 L .52329 .4462 L p
1 .362 0 r
F P
0 0 0 r
s
P
p
.002 w
.5067 .45623 m .52329 .4462 L .5383 .46904 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.31399 .19217 m .34762 .20035 L .332 .20424 L .991 1 0 r
F
P
p
.29837 .19613 m .31399 .19217 L .332 .20424 L .966 1 0 r
F
P
p
.24861 .19186 m .2829 .20005 L .26757 .20394 L .603 1 0 r
F
P
p
.2333 .19582 m .24861 .19186 L .26757 .20394 L .448 1 0 r
F
P
p
.002 w
.39257 .52923 m .37651 .54252 L .36009 .49489 L p
.823 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34376 .51933 m .36009 .49489 L .37651 .54252 L p
.694 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31192 .54599 m .29556 .57748 L .27699 .57078 L p
.241 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29556 .57748 m .27767 .65334 L .26153 .57298 L p
0 1 .224 r
F P
0 0 0 r
s
P
p
.002 w
.26153 .57298 m .27699 .57078 L .29556 .57748 L p
0 1 .224 r
F P
0 0 0 r
s
P
p
.002 w
.32748 .54369 m .31192 .54599 L .29358 .53884 L p
.448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27699 .57078 m .29358 .53884 L .31192 .54599 L p
.241 1 0 r
F P
0 0 0 r
s
P
p
.78814 .19032 m .81727 .19855 L .79943 .20245 L 1 0 0 r
F
P
p
.77027 .1943 m .78814 .19032 L .79943 .20245 L 1 0 0 r
F
P
p
.7228 .19002 m .75257 .19825 L .73503 .20215 L 1 0 0 r
F
P
p
.70523 .194 m .7228 .19002 L .73503 .20215 L 1 0 0 r
F
P
p
.002 w
.84742 .42553 m .82944 .42838 L .81857 .41952 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80055 .42243 m .81857 .41952 L .82944 .42838 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.65741 .18971 m .68782 .19794 L .67058 .20185 L 1 0 0 r
F
P
p
.64014 .19369 m .65741 .18971 L .67058 .20185 L 1 0 0 r
F
P
p
.002 w
.27767 .65334 m .26206 .66256 L .24328 .64956 L p
0 1 .767 r
F P
0 0 0 r
s
P
p
.002 w
.22796 .65139 m .24328 .64956 L .26206 .66256 L p
0 .948 1 r
F P
0 0 0 r
s
P
p
.002 w
.78269 .42531 m .76501 .42817 L .7532 .4193 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73548 .42221 m .7532 .4193 L .76501 .42817 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.59197 .1894 m .62303 .19764 L .60608 .20155 L 1 .181 0 r
F
P
p
.575 .19339 m .59197 .1894 L .60608 .20155 L 1 .233 0 r
F
P
p
.002 w
.21279 .6532 m .19742 .66243 L .17776 .64942 L p
0 1 .922 r
F P
0 0 0 r
s
P
p
.002 w
.16274 .65125 m .17776 .64942 L .19742 .66243 L p
0 .948 1 r
F P
0 0 0 r
s
P
p
.002 w
.44111 .50724 m .45758 .49732 L .47376 .49055 L p
1 .957 0 r
F P
0 0 0 r
s
P
p
.002 w
.71792 .42509 m .70053 .42795 L .68778 .41907 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67036 .42198 m .68778 .41907 L .70053 .42795 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.52329 .4462 m .54 .4361 L .55486 .45915 L p
1 .362 0 r
F P
0 0 0 r
s
P
p
.52649 .18909 m .55819 .19734 L .54153 .20125 L 1 .517 0 r
F
P
p
.50982 .19308 m .52649 .18909 L .54153 .20125 L 1 .595 0 r
F
P
p
.002 w
.6531 .42487 m .636 .42773 L .62232 .41885 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60527 .42903 m .62232 .41885 L .636 .42773 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.46096 .18878 m .4933 .19704 L .47694 .20095 L 1 .672 0 r
F
P
p
.44459 .19278 m .46096 .18878 L .47694 .20095 L 1 .75 0 r
F
P
p
.002 w
.376 .49233 m .39257 .52923 L p
.36417 .4992 L .823 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.376 .49233 m .3922 .48238 L .40854 .52684 L p
.888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.376 .49233 m .35782 .50669 L p
.38796 .48538 L .991 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3922 .48238 m .376 .49233 L p
.38796 .48538 L .991 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36009 .49489 m .376 .49233 L p
.36417 .4992 L .823 1 0 r
F P
0 0 0 r
s
P
p
.39538 .18848 m .42837 .19673 L .41231 .20065 L 1 .802 0 r
F
P
p
.37931 .19247 m .39538 .18848 L .41231 .20065 L 1 .853 0 r
F
P
p
.32975 .18817 m .36339 .19643 L .34762 .20035 L 1 .905 0 r
F
P
p
.31399 .19217 m .32975 .18817 L .34762 .20035 L .991 1 0 r
F
P
p
.26408 .18786 m .29837 .19613 L .2829 .20005 L .759 1 0 r
F
P
p
.24861 .19186 m .26408 .18786 L .2829 .20005 L .603 1 0 r
F
P
p
.002 w
.34376 .51933 m .32748 .54369 L .30928 .53647 L p
.552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29358 .53884 m .30928 .53647 L .32748 .54369 L p
.448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24328 .64956 m .26153 .57298 L .27767 .65334 L p
0 1 .767 r
F P
0 0 0 r
s
P
p
.78814 .19032 m .80618 .18631 L .81727 .19855 L 1 0 0 r
F
P
p
.002 w
.22796 .65139 m .21279 .6532 L .1943 .61749 L p
0 1 .534 r
F P
0 0 0 r
s
P
p
.002 w
.17776 .64942 m .1943 .61749 L .21279 .6532 L p
0 1 .922 r
F P
0 0 0 r
s
P
p
.002 w
.5067 .45623 m .49014 .4807 L .47418 .48734 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.45758 .49732 m .47418 .48734 L .49014 .4807 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.74053 .186 m .77027 .1943 L .75257 .19825 L 1 0 0 r
F
P
p
.7228 .19002 m .74053 .186 L .75257 .19825 L 1 0 0 r
F
P
p
.002 w
.81857 .41952 m .83676 .41659 L .84742 .42553 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67484 .18569 m .70523 .194 L .68782 .19794 L 1 0 0 r
F
P
p
.65741 .18971 m .67484 .18569 L .68782 .19794 L 1 0 0 r
F
P
p
.002 w
.80055 .42243 m .78269 .42531 L .77109 .41636 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7532 .4193 m .77109 .41636 L .78269 .42531 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.6091 .18538 m .64014 .19369 L .62303 .19764 L 1 .078 0 r
F
P
p
.59197 .1894 m .6091 .18538 L .62303 .19764 L 1 .181 0 r
F
P
p
.002 w
.36009 .49489 m .34376 .51933 L .32534 .52662 L p
.784 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30928 .53647 m .32534 .52662 L .34376 .51933 L p
.552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73548 .42221 m .71792 .42509 L .70537 .41613 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68778 .41907 m .70537 .41613 L .71792 .42509 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5884 .44641 m .57158 .45644 L .55685 .43325 L p
1 .284 0 r
F P
0 0 0 r
s
P
p
.002 w
.54 .4361 m .55685 .43325 L .57158 .45644 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.54331 .18506 m .575 .19339 L .55819 .19734 L 1 .388 0 r
F
P
p
.52649 .18909 m .54331 .18506 L .55819 .19734 L 1 .517 0 r
F
P
p
.002 w
.16274 .65125 m .14747 .66053 L .12662 .65499 L p
0 .922 1 r
F P
0 0 0 r
s
P
p
.002 w
.67036 .42198 m .6531 .42487 L .6396 .4159 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62232 .41885 m .6396 .4159 L .6531 .42487 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.52329 .4462 m .5067 .45623 L .49089 .47728 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.49089 .47728 m .5067 .45623 L p
.47888 .48284 L 1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.49089 .47728 m .5077 .47459 L .52329 .4462 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.49089 .47728 m .47485 .4539 L p
.50304 .47165 L 1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.5077 .47459 m .49089 .47728 L p
.50304 .47165 L 1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.47418 .48734 m .49089 .47728 L p
.47888 .48284 L 1 .724 0 r
F P
0 0 0 r
s
P
p
.47748 .18475 m .50982 .19308 L .4933 .19704 L 1 .621 0 r
F
P
p
.46096 .18878 m .47748 .18475 L .4933 .19704 L 1 .672 0 r
F
P
p
.002 w
.42477 .51708 m .40854 .52684 L .3922 .48238 L p
.94 1 0 r
F P
0 0 0 r
s
P
p
.41159 .18444 m .44459 .19278 L .42837 .19673 L 1 .724 0 r
F
P
p
.39538 .18848 m .41159 .18444 L .42837 .19673 L 1 .802 0 r
F
P
p
.34566 .18413 m .37931 .19247 L .36339 .19643 L 1 .802 0 r
F
P
p
.32975 .18817 m .34566 .18413 L .36339 .19643 L 1 .905 0 r
F
P
p
.27968 .18382 m .31399 .19217 L .29837 .19613 L .81 1 0 r
F
P
p
.26408 .18786 m .27968 .18382 L .29837 .19613 L .759 1 0 r
F
P
p
.002 w
.34172 .50923 m .36009 .49489 L p
.33538 .51745 L .784 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32534 .52662 m .34172 .50923 L p
.33538 .51745 L .784 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34172 .50923 m .32378 .48626 L p
.34815 .50089 L .862 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.376 .49233 m .36009 .49489 L .34172 .50923 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34172 .50923 m .35782 .50669 L .376 .49233 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35782 .50669 m .34172 .50923 L p
.34815 .50089 L .862 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27699 .57078 m .26153 .57298 L .24407 .52144 L p
.371 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26153 .57298 m .24328 .64956 L .2284 .53126 L p
.06 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.2284 .53126 m .24407 .52144 L .26153 .57298 L p
.06 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24328 .64956 m .22796 .65139 L .21284 .54101 L p
0 1 .25 r
F P
0 0 0 r
s
P
p
.002 w
.1943 .61749 m .21284 .54101 L .22796 .65139 L p
0 1 .534 r
F P
0 0 0 r
s
P
p
.002 w
.21284 .54101 m .2284 .53126 L .24328 .64956 L p
0 1 .25 r
F P
0 0 0 r
s
P
p
.002 w
.2284 .53126 m .21284 .54101 L .19357 .51879 L p
.578 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.21284 .54101 m .1943 .61749 L .17763 .5361 L p
.241 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.17763 .5361 m .19357 .51879 L .21284 .54101 L p
.241 1 0 r
F P
0 0 0 r
s
P
p
.75844 .18194 m .78814 .19032 L .77027 .1943 L 1 0 0 r
F
P
p
.74053 .186 m .75844 .18194 L .77027 .1943 L 1 0 0 r
F
P
p
.002 w
.60527 .42903 m .5884 .44641 L .57387 .43036 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.57387 .43036 m .5884 .44641 L p
.56215 .43546 L 1 .284 0 r
F P
0 0 0 r
s
P
p
.002 w
.57387 .43036 m .59099 .42007 L .60527 .42903 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.57387 .43036 m .55906 .45129 L p
.58573 .42521 L 1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.59099 .42007 m .57387 .43036 L p
.58573 .42521 L 1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.55685 .43325 m .57387 .43036 L p
.56215 .43546 L 1 .284 0 r
F P
0 0 0 r
s
P
p
.002 w
.17776 .64942 m .16274 .65125 L .14163 .65316 L p
0 .974 1 r
F P
0 0 0 r
s
P
p
.002 w
.12662 .65499 m .14163 .65316 L .16274 .65125 L p
0 .922 1 r
F P
0 0 0 r
s
P
p
.69244 .18163 m .7228 .19002 L .70523 .194 L 1 0 0 r
F
P
p
.67484 .18569 m .69244 .18163 L .70523 .194 L 1 0 0 r
F
P
p
.002 w
.54 .4361 m .52329 .4462 L .5077 .47459 L p
1 .517 0 r
F P
0 0 0 r
s
P
p
.002 w
.44111 .50724 m .42477 .51708 L .4084 .47974 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.3922 .48238 m .4084 .47974 L .42477 .51708 L p
.94 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.81857 .41952 m .80055 .42243 L .78915 .41339 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77109 .41636 m .78915 .41339 L .80055 .42243 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.62639 .18131 m .65741 .18971 L .64014 .19369 L 1 0 0 r
F
P
p
.6091 .18538 m .62639 .18131 L .64014 .19369 L 1 .078 0 r
F
P
p
.002 w
.7532 .4193 m .73548 .42221 L .72312 .41316 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70537 .41613 m .72312 .41316 L .73548 .42221 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5603 .181 m .59197 .1894 L .575 .19339 L 1 .31 0 r
F
P
p
.54331 .18506 m .5603 .181 L .575 .19339 L 1 .388 0 r
F
P
p
.002 w
.68778 .41907 m .67036 .42198 L .65705 .41293 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6396 .4159 m .65705 .41293 L .67036 .42198 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.49416 .18068 m .52649 .18909 L .50982 .19308 L 1 .595 0 r
F
P
p
.47748 .18475 m .49416 .18068 L .50982 .19308 L 1 .621 0 r
F
P
p
.42797 .18037 m .46096 .18878 L .44459 .19278 L 1 .647 0 r
F
P
p
.41159 .18444 m .42797 .18037 L .44459 .19278 L 1 .724 0 r
F
P
p
.36173 .18005 m .39538 .18848 L .37931 .19247 L 1 .698 0 r
F
P
p
.34566 .18413 m .36173 .18005 L .37931 .19247 L 1 .802 0 r
F
P
p
.29544 .17974 m .32975 .18817 L .31399 .19217 L .836 1 0 r
F
P
p
.27968 .18382 m .29544 .17974 L .31399 .19217 L .81 1 0 r
F
P
p
.002 w
.62232 .41885 m .60527 .42903 L .59099 .42007 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.24407 .52144 m .2284 .53126 L .20892 .51631 L p
.655 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20892 .51631 m .2284 .53126 L p
.19542 .51945 L .578 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.1943 .61749 m .17776 .64942 L .15717 .64367 L p
0 1 .534 r
F P
0 0 0 r
s
P
p
.002 w
.15717 .64367 m .17763 .5361 L .1943 .61749 L p
0 1 .534 r
F P
0 0 0 r
s
P
p
.002 w
.22473 .5063 m .24407 .52144 L p
.21089 .51659 L .655 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20892 .51631 m .22473 .5063 L p
.21089 .51659 L .655 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25987 .51155 m .24407 .52144 L .22473 .5063 L p
.784 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.22473 .5063 m .24097 .48871 L .25987 .51155 L p
.784 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.22473 .5063 m .19887 .62193 L p
.2387 .49591 L .164 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24097 .48871 m .22473 .5063 L p
.2387 .49591 L .164 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20892 .51631 m .18227 .63966 L p
.22256 .51313 L 0 1 .147 r
F P
0 0 0 r
s
P
p
.002 w
.22473 .5063 m .20892 .51631 L p
.22256 .51313 L 0 1 .147 r
F P
0 0 0 r
s
P
p
.002 w
.19357 .51879 m .20892 .51631 L p
.19542 .51945 L .578 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29358 .53884 m .27699 .57078 L .25987 .51155 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24407 .52144 m .25987 .51155 L .27699 .57078 L p
.371 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55685 .43325 m .54 .4361 L .52469 .46439 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.52469 .46439 m .54 .4361 L p
.5118 .46971 L 1 .517 0 r
F P
0 0 0 r
s
P
p
.002 w
.52469 .46439 m .54181 .46162 L .55685 .43325 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.52469 .46439 m .50894 .44065 L p
.53773 .45901 L 1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.54181 .46162 m .52469 .46439 L p
.53773 .45901 L 1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.5077 .47459 m .52469 .46439 L p
.5118 .46971 L 1 .517 0 r
F P
0 0 0 r
s
P
p
.002 w
.45758 .49732 m .44111 .50724 L .42486 .46965 L p
1 .905 0 r
F P
0 0 0 r
s
P
p
.002 w
.4084 .47974 m .42486 .46965 L .44111 .50724 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.30928 .53647 m .29358 .53884 L .27551 .50903 L p
.655 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25987 .51155 m .27551 .50903 L .29358 .53884 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.77651 .17784 m .80618 .18631 L .78814 .19032 L 1 0 0 r
F
P
p
.75844 .18194 m .77651 .17784 L .78814 .19032 L 1 0 0 r
F
P
p
.002 w
.14163 .65316 m .15717 .64367 L .17776 .64942 L p
0 .974 1 r
F P
0 0 0 r
s
P
p
.71021 .17753 m .74053 .186 L .7228 .19002 L 1 0 0 r
F
P
p
.69244 .18163 m .71021 .17753 L .7228 .19002 L 1 0 0 r
F
P
p
.002 w
.83676 .41659 m .81857 .41952 L .80738 .4104 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78915 .41339 m .80738 .4104 L .81857 .41952 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64385 .17721 m .67484 .18569 L .65741 .18971 L 1 0 0 r
F
P
p
.62639 .18131 m .64385 .17721 L .65741 .18971 L 1 0 0 r
F
P
p
.002 w
.77109 .41636 m .7532 .4193 L .74105 .41017 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72312 .41316 m .74105 .41017 L .7532 .4193 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.57745 .17689 m .6091 .18538 L .59197 .1894 L 1 .284 0 r
F
P
p
.5603 .181 m .57745 .17689 L .59197 .1894 L 1 .31 0 r
F
P
p
.002 w
.70537 .41613 m .68778 .41907 L .67466 .40993 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65705 .41293 m .67466 .40993 L .68778 .41907 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.511 .17658 m .54331 .18506 L .52649 .18909 L 1 .44 0 r
F
P
p
.49416 .18068 m .511 .17658 L .52649 .18909 L 1 .595 0 r
F
P
p
.002 w
.35782 .50669 m .37441 .48912 L .3922 .48238 L p
.991 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4084 .47974 m .3922 .48238 L .37441 .48912 L p
1 .905 0 r
F P
0 0 0 r
s
P
p
.002 w
.6396 .4159 m .62232 .41885 L .60823 .4097 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59099 .42007 m .60823 .4097 L .62232 .41885 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.4445 .17626 m .47748 .18475 L .46096 .18878 L 1 .595 0 r
F
P
p
.42797 .18037 m .4445 .17626 L .46096 .18878 L 1 .647 0 r
F
P
p
.37795 .17594 m .41159 .18444 L .39538 .18848 L 1 .621 0 r
F
P
p
.36173 .18005 m .37795 .17594 L .39538 .18848 L 1 .698 0 r
F
P
p
.31135 .17562 m .34566 .18413 L .32975 .18817 L .914 1 0 r
F
P
p
.29544 .17974 m .31135 .17562 L .32975 .18817 L .836 1 0 r
F
P
p
.002 w
.47418 .48734 m .45758 .49732 L .44134 .46693 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.42486 .46965 m .44134 .46693 L .45758 .49732 L p
1 .905 0 r
F P
0 0 0 r
s
P
p
.002 w
.57387 .43036 m .55685 .43325 L .54181 .46162 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.32534 .52662 m .30928 .53647 L .2918 .49155 L p
.733 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27551 .50903 m .2918 .49155 L .30928 .53647 L p
.655 1 0 r
F P
0 0 0 r
s
P
p
.77651 .17784 m .79476 .17371 L .80618 .18631 L 1 0 0 r
F
P
p
.002 w
.17763 .5361 m .15717 .64367 L .13555 .6455 L p
0 1 .69 r
F P
0 0 0 r
s
P
p
.002 w
.19357 .51879 m .17763 .5361 L .15097 .64357 L p
0 1 .276 r
F P
0 0 0 r
s
P
p
.002 w
.13555 .6455 m .15097 .64357 L .17763 .5361 L p
0 1 .69 r
F P
0 0 0 r
s
P
p
.72814 .17339 m .75844 .18194 L .74053 .186 L 1 0 0 r
F
P
p
.71021 .17753 m .72814 .17339 L .74053 .186 L 1 0 0 r
F
P
p
.002 w
.80738 .4104 m .82579 .40737 L .83676 .41659 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66148 .17307 m .69244 .18163 L .67484 .18569 L 1 0 0 r
F
P
p
.64385 .17721 m .66148 .17307 L .67484 .18569 L 1 0 0 r
F
P
p
.002 w
.78915 .41339 m .77109 .41636 L .75914 .40714 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74105 .41017 m .75914 .40714 L .77109 .41636 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.59476 .17275 m .62639 .18131 L .6091 .18538 L 1 .181 0 r
F
P
p
.57745 .17689 m .59476 .17275 L .6091 .18538 L 1 .284 0 r
F
P
p
.002 w
.72312 .41316 m .70537 .41613 L .69245 .40691 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67466 .40993 m .69245 .40691 L .70537 .41613 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.528 .17243 m .5603 .181 L .54331 .18506 L 1 .259 0 r
F
P
p
.511 .17658 m .528 .17243 L .54331 .18506 L 1 .44 0 r
F
P
p
.002 w
.14163 .65316 m .12662 .65499 L .10515 .64929 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.42486 .46965 m .4084 .47974 L .39094 .47895 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.37441 .48912 m .39094 .47895 L .4084 .47974 L p
1 .905 0 r
F P
0 0 0 r
s
P
p
.002 w
.27551 .50903 m .25987 .51155 L .24097 .48871 L p
.862 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65705 .41293 m .6396 .4159 L .6257 .40667 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60823 .4097 m .6257 .40667 L .6396 .4159 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.46118 .17211 m .49416 .18068 L .47748 .18475 L 1 .543 0 r
F
P
p
.4445 .17626 m .46118 .17211 L .47748 .18475 L 1 .595 0 r
F
P
p
.39432 .17179 m .42797 .18037 L .41159 .18444 L 1 .569 0 r
F
P
p
.37795 .17594 m .39432 .17179 L .41159 .18444 L 1 .621 0 r
F
P
p
.002 w
.49089 .47728 m .47418 .48734 L .45799 .46418 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.44134 .46693 m .45799 .46418 L .47418 .48734 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.32741 .17146 m .36173 .18005 L .34566 .18413 L 1 .983 0 r
F
P
p
.31135 .17562 m .32741 .17146 L .34566 .18413 L .914 1 0 r
F
P
p
.002 w
.20892 .51631 m .19357 .51879 L .16655 .64163 L p
0 1 .224 r
F P
0 0 0 r
s
P
p
.002 w
.15097 .64357 m .16655 .64163 L .19357 .51879 L p
0 1 .276 r
F P
0 0 0 r
s
P
p
.002 w
.34172 .50923 m .32534 .52662 L .30771 .48891 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.2918 .49155 m .30771 .48891 L .32534 .52662 L p
.733 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54181 .46162 m .55906 .45129 L .57387 .43036 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.74625 .16921 m .77651 .17784 L .75844 .18194 L 1 0 0 r
F
P
p
.72814 .17339 m .74625 .16921 L .75844 .18194 L 1 0 0 r
F
P
p
.002 w
.44134 .46693 m .42486 .46965 L .40746 .47624 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.39094 .47895 m .40746 .47624 L .42486 .46965 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.67927 .16889 m .71021 .17753 L .69244 .18163 L 1 0 0 r
F
P
p
.66148 .17307 m .67927 .16889 L .69244 .18163 L 1 0 0 r
F
P
p
.002 w
.80738 .4104 m .78915 .41339 L .77741 .40409 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75914 .40714 m .77741 .40409 L .78915 .41339 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61224 .16856 m .64385 .17721 L .62639 .18131 L 1 .052 0 r
F
P
p
.59476 .17275 m .61224 .16856 L .62639 .18131 L 1 .181 0 r
F
P
p
.002 w
.45799 .46418 m .47485 .4539 L .49089 .47728 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.30771 .48891 m .32378 .48626 L .34172 .50923 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74105 .41017 m .72312 .41316 L .7104 .40385 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69245 .40691 m .7104 .40385 L .72312 .41316 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.54516 .16824 m .57745 .17689 L .5603 .181 L 1 .181 0 r
F
P
p
.528 .17243 m .54516 .16824 L .5603 .181 L 1 .259 0 r
F
P
p
.002 w
.15717 .64367 m .14163 .65316 L .12028 .6474 L p
0 .922 1 r
F P
0 0 0 r
s
P
p
.002 w
.10515 .64929 m .12028 .6474 L .14163 .65316 L p
0 .897 1 r
F P
0 0 0 r
s
P
p
.002 w
.2918 .49155 m .27551 .50903 L .25672 .48605 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24097 .48871 m .25672 .48605 L .27551 .50903 L p
.862 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.67466 .40993 m .65705 .41293 L .64334 .40361 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6257 .40667 m .64334 .40361 L .65705 .41293 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.47803 .16792 m .511 .17658 L .49416 .18068 L 1 .44 0 r
F
P
p
.46118 .17211 m .47803 .16792 L .49416 .18068 L 1 .543 0 r
F
P
p
.41085 .16759 m .4445 .17626 L .42797 .18037 L 1 .44 0 r
F
P
p
.39432 .17179 m .41085 .16759 L .42797 .18037 L 1 .569 0 r
F
P
p
.34362 .16727 m .37795 .17594 L .36173 .18005 L 1 .853 0 r
F
P
p
.32741 .17146 m .34362 .16727 L .36173 .18005 L 1 .983 0 r
F
P
p
.002 w
.16655 .64163 m .18227 .63966 L .20892 .51631 L p
0 1 .224 r
F P
0 0 0 r
s
P
p
.002 w
.57641 .43334 m .59099 .42007 L p
.56828 .44227 L 1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.55906 .45129 m .57641 .43334 L p
.56828 .44227 L 1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.57641 .43334 m .56116 .40893 L p
.58465 .42429 L 1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.60823 .4097 m .59099 .42007 L .57641 .43334 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.57641 .43334 m .59398 .43039 L .60823 .4097 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.59398 .43039 m .57641 .43334 L p
.58465 .42429 L 1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.30771 .48891 m .2918 .49155 L .27262 .48337 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25672 .48605 m .27262 .48337 L .2918 .49155 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.76454 .16499 m .79476 .17371 L .77651 .17784 L 1 0 0 r
F
P
p
.74625 .16921 m .76454 .16499 L .77651 .17784 L 1 0 0 r
F
P
p
.002 w
.12028 .6474 m .13555 .6455 L .15717 .64367 L p
0 .922 1 r
F P
0 0 0 r
s
P
p
.002 w
.45799 .46418 m .44134 .46693 L .42426 .46593 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.40746 .47624 m .42426 .46593 L .44134 .46693 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.69724 .16466 m .72814 .17339 L .71021 .17753 L 1 0 0 r
F
P
p
.67927 .16889 m .69724 .16466 L .71021 .17753 L 1 0 0 r
F
P
p
.002 w
.82579 .40737 m .80738 .4104 L .79586 .401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77741 .40409 m .79586 .401 L .80738 .4104 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.62989 .16434 m .66148 .17307 L .64385 .17721 L 1 0 0 r
F
P
p
.61224 .16856 m .62989 .16434 L .64385 .17721 L 1 .052 0 r
F
P
p
.002 w
.52469 .46439 m .5077 .47459 L .49185 .44355 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.47485 .4539 m .49185 .44355 L .5077 .47459 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.37441 .48912 m .35782 .50669 L .34 .48358 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32378 .48626 m .34 .48358 L .35782 .50669 L p
.862 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.75914 .40714 m .74105 .41017 L .72853 .40076 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7104 .40385 m .72853 .40076 L .74105 .41017 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.56249 .16401 m .59476 .17275 L .57745 .17689 L 1 .155 0 r
F
P
p
.54516 .16824 m .56249 .16401 L .57745 .17689 L 1 .181 0 r
F
P
p
.002 w
.69245 .40691 m .67466 .40993 L .66116 .40053 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64334 .40361 m .66116 .40053 L .67466 .40993 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.49504 .16368 m .528 .17243 L .511 .17658 L 1 .259 0 r
F
P
p
.47803 .16792 m .49504 .16368 L .511 .17658 L 1 .44 0 r
F
P
p
.002 w
.18227 .63966 m .19887 .62193 L .22473 .5063 L p
0 1 .147 r
F P
0 0 0 r
s
P
p
.002 w
.6257 .40667 m .60823 .4097 L .59398 .43039 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.42755 .16336 m .46118 .17211 L .4445 .17626 L 1 .362 0 r
F
P
p
.41085 .16759 m .42755 .16336 L .4445 .17626 L 1 .44 0 r
F
P
p
.36 .16303 m .39432 .17179 L .37795 .17594 L 1 .75 0 r
F
P
p
.34362 .16727 m .36 .16303 L .37795 .17594 L 1 .853 0 r
F
P
p
.002 w
.39094 .47895 m .37441 .48912 L .35675 .46572 L p
1 .905 0 r
F P
0 0 0 r
s
P
p
.002 w
.34 .48358 m .35675 .46572 L .37441 .48912 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32378 .48626 m .30771 .48891 L .28868 .48066 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27262 .48337 m .28868 .48066 L .30771 .48891 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25672 .48605 m .24097 .48871 L .21726 .56501 L p
.448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.19887 .62193 m .21726 .56501 L .24097 .48871 L p
.164 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49185 .44355 m .50894 .44065 L p
.49846 .44775 L 1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.47485 .4539 m .45799 .46418 L .44109 .46313 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.44109 .46313 m .45808 .46031 L .47485 .4539 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.49185 .44355 m .47485 .4539 L .45808 .46031 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.4753 .4498 m .49185 .44355 L p
.46377 .45748 L 1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.45808 .46031 m .4753 .4498 L p
.46377 .45748 L 1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.4753 .4498 m .45859 .41755 L p
.48697 .44202 L 1 .543 0 r
F P
0 0 0 r
s
P
p
.002 w
.50894 .44065 m .49185 .44355 L .4753 .4498 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.4753 .4498 m .49261 .44688 L .50894 .44065 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.49261 .44688 m .4753 .4498 L p
.48697 .44202 L 1 .543 0 r
F P
0 0 0 r
s
P
p
.002 w
.50894 .44065 m .49261 .44688 L p
.51957 .43347 L 1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.52621 .43016 m .50894 .44065 L p
.51957 .43347 L 1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.50894 .44065 m .52469 .46439 L p
.49846 .44775 L 1 .647 0 r
F P
0 0 0 r
s
P
p
.76454 .16499 m .783 .16073 L .79476 .17371 L 1 0 0 r
F
P
p
.002 w
.42426 .46593 m .44109 .46313 L .45799 .46418 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.71538 .1604 m .74625 .16921 L .72814 .17339 L 1 0 0 r
F
P
p
.69724 .16466 m .71538 .1604 L .72814 .17339 L 1 0 0 r
F
P
p
.002 w
.79586 .401 m .81449 .39789 L .82579 .40737 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64771 .16007 m .67927 .16889 L .66148 .17307 L 1 0 0 r
F
P
p
.62989 .16434 m .64771 .16007 L .66148 .17307 L 1 0 0 r
F
P
p
.002 w
.77741 .40409 m .75914 .40714 L .74684 .39765 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72853 .40076 m .74684 .39765 L .75914 .40714 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.57999 .15974 m .61224 .16856 L .59476 .17275 L 1 .129 0 r
F
P
p
.56249 .16401 m .57999 .15974 L .59476 .17275 L 1 .155 0 r
F
P
p
.002 w
.7104 .40385 m .69245 .40691 L .67914 .39741 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66116 .40053 m .67914 .39741 L .69245 .40691 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.51222 .15941 m .54516 .16824 L .528 .17243 L 1 .129 0 r
F
P
p
.49504 .16368 m .51222 .15941 L .528 .17243 L 1 .259 0 r
F
P
p
.002 w
.64334 .40361 m .6257 .40667 L .61164 .41982 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.59398 .43039 m .61164 .41982 L .6257 .40667 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.4444 .15908 m .47803 .16792 L .46118 .17211 L 1 .259 0 r
F
P
p
.42755 .16336 m .4444 .15908 L .46118 .17211 L 1 .362 0 r
F
P
p
.37653 .15875 m .41085 .16759 L .39432 .17179 L 1 .698 0 r
F
P
p
.36 .16303 m .37653 .15875 L .39432 .17179 L 1 .75 0 r
F
P
p
.002 w
.40746 .47624 m .39094 .47895 L .37326 .46292 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.35675 .46572 m .37326 .46292 L .39094 .47895 L p
1 .905 0 r
F P
0 0 0 r
s
P
p
.002 w
.34 .48358 m .32378 .48626 L .3049 .47793 L p
.991 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3049 .47793 m .32378 .48626 L p
.29752 .48207 L .966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3049 .47793 m .3215 .46751 L .34 .48358 L p
.991 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3049 .47793 m .28463 .49262 L p
.31238 .47372 L .836 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3215 .46751 m .3049 .47793 L p
.31238 .47372 L .836 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28868 .48066 m .3049 .47793 L p
.29752 .48207 L .966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27262 .48337 m .25672 .48605 L .23396 .54706 L p
.603 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.21726 .56501 m .23396 .54706 L .25672 .48605 L p
.448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55906 .45129 m .54181 .46162 L .52621 .43016 L p
1 .517 0 r
F P
0 0 0 r
s
P
p
.002 w
.50894 .44065 m .52621 .43016 L .54181 .46162 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.7337 .1561 m .76454 .16499 L .74625 .16921 L 1 0 0 r
F
P
p
.71538 .1604 m .7337 .1561 L .74625 .16921 L 1 0 0 r
F
P
p
.66571 .15576 m .69724 .16466 L .67927 .16889 L 1 0 0 r
F
P
p
.64771 .16007 m .66571 .15576 L .67927 .16889 L 1 0 0 r
F
P
p
.002 w
.79586 .401 m .77741 .40409 L .76532 .3945 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74684 .39765 m .76532 .3945 L .77741 .40409 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.59766 .15543 m .62989 .16434 L .61224 .16856 L 1 .052 0 r
F
P
p
.57999 .15974 m .59766 .15543 L .61224 .16856 L 1 .129 0 r
F
P
p
.002 w
.72853 .40076 m .7104 .40385 L .6973 .39426 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67914 .39741 m .6973 .39426 L .7104 .40385 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.52957 .1551 m .56249 .16401 L .54516 .16824 L 1 .078 0 r
F
P
p
.51222 .15941 m .52957 .1551 L .54516 .16824 L 1 .129 0 r
F
P
p
.002 w
.66116 .40053 m .64334 .40361 L .62923 .39401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.61164 .41982 m .62923 .39401 L .64334 .40361 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.46142 .15476 m .49504 .16368 L .47803 .16792 L 1 .078 0 r
F
P
p
.4444 .15908 m .46142 .15476 L .47803 .16792 L 1 .259 0 r
F
P
p
.39322 .15443 m .42755 .16336 L .41085 .16759 L 1 .621 0 r
F
P
p
.37653 .15875 m .39322 .15443 L .41085 .16759 L 1 .698 0 r
F
P
p
.002 w
.42426 .46593 m .40746 .47624 L .39008 .45247 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.37326 .46292 m .39008 .45247 L .40746 .47624 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.57641 .43334 m .55906 .45129 L .54362 .41958 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.002 w
.52621 .43016 m .54362 .41958 L .55906 .45129 L p
1 .517 0 r
F P
0 0 0 r
s
P
p
.002 w
.35675 .46572 m .34 .48358 L .3215 .46751 L p
1 .905 0 r
F P
0 0 0 r
s
P
p
.002 w
.23396 .54706 m .25136 .51349 L .27262 .48337 L p
.603 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28868 .48066 m .27262 .48337 L .25136 .51349 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.7522 .15175 m .783 .16073 L .76454 .16499 L 1 0 0 r
F
P
p
.7337 .1561 m .7522 .15175 L .76454 .16499 L 1 0 0 r
F
P
p
.68388 .15141 m .71538 .1604 L .69724 .16466 L 1 0 0 r
F
P
p
.66571 .15576 m .68388 .15141 L .69724 .16466 L 1 0 0 r
F
P
p
.002 w
.81449 .39789 m .79586 .401 L .78399 .39132 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76532 .3945 m .78399 .39132 L .79586 .401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61551 .15108 m .64771 .16007 L .62989 .16434 L 1 0 0 r
F
P
p
.59766 .15543 m .61551 .15108 L .62989 .16434 L 1 .052 0 r
F
P
p
.002 w
.74684 .39765 m .72853 .40076 L .71564 .39108 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6973 .39426 m .71564 .39108 L .72853 .40076 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.54362 .41958 m .56116 .40893 L .57641 .43334 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.54709 .15074 m .57999 .15974 L .56249 .16401 L 1 .052 0 r
F
P
p
.52957 .1551 m .54709 .15074 L .56249 .16401 L 1 .078 0 r
F
P
p
.002 w
.44109 .46313 m .42426 .46593 L .40689 .44957 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.39008 .45247 m .40689 .44957 L .42426 .46593 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.67914 .39741 m .66116 .40053 L .64724 .39083 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62923 .39401 m .64724 .39083 L .66116 .40053 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.47861 .1504 m .51222 .15941 L .49504 .16368 L 1 0 0 r
F
P
p
.46142 .15476 m .47861 .1504 L .49504 .16368 L 1 .078 0 r
F
P
p
.002 w
.37326 .46292 m .35675 .46572 L .33822 .45701 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.3215 .46751 m .33822 .45701 L .35675 .46572 L p
1 .905 0 r
F P
0 0 0 r
s
P
p
.41008 .15007 m .4444 .15908 L .42755 .16336 L 1 .569 0 r
F
P
p
.39322 .15443 m .41008 .15007 L .42755 .16336 L 1 .621 0 r
F
P
p
.002 w
.25136 .51349 m .26822 .49534 L .28868 .48066 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3049 .47793 m .28868 .48066 L .26822 .49534 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.7522 .15175 m .77088 .14736 L .783 .16073 L 1 0 0 r
F
P
p
.70223 .14702 m .7337 .1561 L .71538 .1604 L 1 0 0 r
F
P
p
.68388 .15141 m .70223 .14702 L .71538 .1604 L 1 0 0 r
F
P
p
.002 w
.78399 .39132 m .80284 .38811 L .81449 .39789 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.63353 .14668 m .66571 .15576 L .64771 .16007 L 1 0 0 r
F
P
p
.61551 .15108 m .63353 .14668 L .64771 .16007 L 1 0 0 r
F
P
p
.002 w
.76532 .3945 m .74684 .39765 L .73416 .38787 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71564 .39108 m .73416 .38787 L .74684 .39765 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.61164 .41982 m .59398 .43039 L .57888 .40581 L p
1 .284 0 r
F P
0 0 0 r
s
P
p
.002 w
.56116 .40893 m .57888 .40581 L .59398 .43039 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.56478 .14634 m .59766 .15543 L .57999 .15974 L 1 .026 0 r
F
P
p
.54709 .15074 m .56478 .14634 L .57999 .15974 L 1 .052 0 r
F
P
p
.002 w
.45808 .46031 m .44109 .46313 L .42411 .43132 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.40689 .44957 m .42411 .43132 L .44109 .46313 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.6973 .39426 m .67914 .39741 L .66543 .38762 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64724 .39083 m .66543 .38762 L .67914 .39741 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.54362 .41958 m .52621 .43016 L .5101 .44393 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.49261 .44688 m .5101 .44393 L .52621 .43016 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.49597 .146 m .52957 .1551 L .51222 .15941 L 1 0 0 r
F
P
p
.47861 .1504 m .49597 .146 L .51222 .15941 L 1 0 0 r
F
P
p
.002 w
.39008 .45247 m .37326 .46292 L .35508 .44643 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.35508 .44643 m .37326 .46292 L p
.34411 .458 L 1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.35508 .44643 m .37224 .42807 L .39008 .45247 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.35508 .44643 m .3353 .46856 L p
.36617 .43473 L 1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.37224 .42807 m .35508 .44643 L p
.36617 .43473 L 1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.33822 .45701 m .35508 .44643 L p
.34411 .458 L 1 .802 0 r
F P
0 0 0 r
s
P
p
.42711 .14566 m .46142 .15476 L .4444 .15908 L 1 .414 0 r
F
P
p
.41008 .15007 m .42711 .14566 L .4444 .15908 L 1 .569 0 r
F
P
p
.002 w
.26822 .49534 m .28463 .49262 L .3049 .47793 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62923 .39401 m .61164 .41982 L .59677 .40266 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.57888 .40581 m .59677 .40266 L .61164 .41982 L p
1 .284 0 r
F P
0 0 0 r
s
P
p
.72077 .14258 m .7522 .15175 L .7337 .1561 L 1 0 0 r
F
P
p
.70223 .14702 m .72077 .14258 L .7337 .1561 L 1 0 0 r
F
P
p
.002 w
.56116 .40893 m .54362 .41958 L .52778 .41009 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.5101 .44393 m .52778 .41009 L .54362 .41958 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.40689 .44957 m .39008 .45247 L .37224 .42807 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.65173 .14224 m .68388 .15141 L .66571 .15576 L 1 0 0 r
F
P
p
.63353 .14668 m .65173 .14224 L .66571 .15576 L 1 0 0 r
F
P
p
.002 w
.78399 .39132 m .76532 .3945 L .75287 .38462 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73416 .38787 m .75287 .38462 L .76532 .3945 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.58264 .1419 m .61551 .15108 L .59766 .15543 L 1 0 0 r
F
P
p
.56478 .14634 m .58264 .1419 L .59766 .15543 L 1 .026 0 r
F
P
p
.002 w
.4753 .4498 m .45808 .46031 L .44132 .42063 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.42411 .43132 m .44132 .42063 L .45808 .46031 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.71564 .39108 m .6973 .39426 L .6838 .38437 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66543 .38762 m .6838 .38437 L .6973 .39426 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5135 .14155 m .54709 .15074 L .52957 .1551 L 1 0 0 r
F
P
p
.49597 .146 m .5135 .14155 L .52957 .1551 L 1 0 0 r
F
P
p
.002 w
.64724 .39083 m .62923 .39401 L .61485 .39948 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.59677 .40266 m .61485 .39948 L .62923 .39401 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.4443 .14121 m .47861 .1504 L .46142 .15476 L 1 .233 0 r
F
P
p
.42711 .14566 m .4443 .14121 L .46142 .15476 L 1 .414 0 r
F
P
p
.002 w
.33822 .45701 m .3215 .46751 L .30121 .48988 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28463 .49262 m .30121 .48988 L .3215 .46751 L p
.836 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57888 .40581 m .56116 .40893 L .54553 .39924 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.52778 .41009 m .54553 .39924 L .56116 .40893 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.44132 .42063 m .45859 .41755 L .4753 .4498 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.73949 .1381 m .77088 .14736 L .7522 .15175 L 1 0 0 r
F
P
p
.72077 .14258 m .73949 .1381 L .7522 .15175 L 1 0 0 r
F
P
p
.002 w
.42411 .43132 m .40689 .44957 L .38919 .42502 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.37224 .42807 m .38919 .42502 L .40689 .44957 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.67011 .13776 m .70223 .14702 L .68388 .15141 L 1 0 0 r
F
P
p
.65173 .14224 m .67011 .13776 L .68388 .15141 L 1 0 0 r
F
P
p
.002 w
.80284 .38811 m .78399 .39132 L .77176 .38135 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75287 .38462 m .77176 .38135 L .78399 .39132 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60068 .13741 m .63353 .14668 L .61551 .15108 L 1 0 0 r
F
P
p
.58264 .1419 m .60068 .13741 L .61551 .15108 L 1 0 0 r
F
P
p
.002 w
.73416 .38787 m .71564 .39108 L .70235 .38109 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6838 .38437 m .70235 .38109 L .71564 .39108 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5312 .13706 m .56478 .14634 L .54709 .15074 L 1 0 0 r
F
P
p
.5135 .14155 m .5312 .13706 L .54709 .15074 L 1 0 0 r
F
P
p
.002 w
.66543 .38762 m .64724 .39083 L .63289 .38084 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.61485 .39948 m .63289 .38084 L .64724 .39083 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.46167 .13671 m .49597 .146 L .47861 .1504 L 1 .181 0 r
F
P
p
.4443 .14121 m .46167 .13671 L .47861 .1504 L 1 .233 0 r
F
P
p
.002 w
.35508 .44643 m .33822 .45701 L .31819 .47926 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.30121 .48988 m .31819 .47926 L .33822 .45701 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44132 .42063 m .42411 .43132 L .4063 .42194 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.38919 .42502 m .4063 .42194 L p
.40324 .42756 L 1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.4063 .42194 m .38919 .42502 L .36993 .4469 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.36993 .4469 m .38746 .43594 L .4063 .42194 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.4063 .42194 m .38746 .43594 L p
.40942 .41622 L 1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.42383 .40328 m .4063 .42194 L p
.40942 .41622 L 1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.4063 .42194 m .42411 .43132 L p
.40324 .42756 L 1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.59677 .40266 m .57888 .40581 L .56341 .3883 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.54553 .39924 m .56341 .3883 L .57888 .40581 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.5101 .44393 m .49261 .44688 L .47609 .4067 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.45859 .41755 m .47609 .4067 L .49261 .44688 L p
1 .543 0 r
F P
0 0 0 r
s
P
p
.73949 .1381 m .75839 .13358 L .77088 .14736 L 1 0 0 r
F
P
p
.68868 .13323 m .72077 .14258 L .70223 .14702 L 1 0 0 r
F
P
p
.67011 .13776 m .68868 .13323 L .70223 .14702 L 1 0 0 r
F
P
p
.002 w
.31819 .47926 m .3353 .46856 L .35508 .44643 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.77176 .38135 m .79084 .37804 L .80284 .38811 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61891 .13288 m .65173 .14224 L .63353 .14668 L 1 0 0 r
F
P
p
.60068 .13741 m .61891 .13288 L .63353 .14668 L 1 0 0 r
F
P
p
.002 w
.75287 .38462 m .73416 .38787 L .72109 .37778 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70235 .38109 m .72109 .37778 L .73416 .38787 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.54909 .13252 m .58264 .1419 L .56478 .14634 L 1 0 0 r
F
P
p
.5312 .13706 m .54909 .13252 L .56478 .14634 L 1 0 0 r
F
P
p
.002 w
.6838 .38437 m .66543 .38762 L .65129 .37753 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63289 .38084 m .65129 .37753 L .66543 .38762 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.47921 .13217 m .5135 .14155 L .49597 .146 L 1 .155 0 r
F
P
p
.46167 .13671 m .47921 .13217 L .49597 .146 L 1 .181 0 r
F
P
p
.002 w
.45859 .41755 m .44132 .42063 L .42383 .40328 L p
1 .362 0 r
F P
0 0 0 r
s
P
p
.002 w
.4063 .42194 m .42383 .40328 L .44132 .42063 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.38919 .42502 m .37224 .42807 L .35255 .45777 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.3353 .46856 m .35255 .45777 L .37224 .42807 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.61485 .39948 m .59677 .40266 L .58149 .38502 L p
1 .129 0 r
F P
0 0 0 r
s
P
p
.002 w
.56341 .3883 m .58149 .38502 L .59677 .40266 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.52778 .41009 m .5101 .44393 L .49381 .38033 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.47609 .4067 m .49381 .38033 L .5101 .44393 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.70743 .12865 m .73949 .1381 L .72077 .14258 L 1 0 0 r
F
P
p
.68868 .13323 m .70743 .12865 L .72077 .14258 L 1 0 0 r
F
P
p
.002 w
.54553 .39924 m .52778 .41009 L .51153 .37701 L p
1 .129 0 r
F P
0 0 0 r
s
P
p
.002 w
.49381 .38033 m .51153 .37701 L .52778 .41009 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.63732 .1283 m .67011 .13776 L .65173 .14224 L 1 0 0 r
F
P
p
.61891 .13288 m .63732 .1283 L .65173 .14224 L 1 0 0 r
F
P
p
.002 w
.77176 .38135 m .75287 .38462 L .74002 .37444 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72109 .37778 m .74002 .37444 L .75287 .38462 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.56715 .12794 m .60068 .13741 L .58264 .1419 L 1 0 0 r
F
P
p
.54909 .13252 m .56715 .12794 L .58264 .1419 L 1 0 0 r
F
P
p
.002 w
.70235 .38109 m .6838 .38437 L .66987 .37418 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65129 .37753 m .66987 .37418 L .6838 .38437 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.49693 .12759 m .5312 .13706 L .5135 .14155 L 1 .129 0 r
F
P
p
.47921 .13217 m .49693 .12759 L .5135 .14155 L 1 .155 0 r
F
P
p
.002 w
.47609 .4067 m .45859 .41755 L .44126 .40006 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.44126 .40006 m .45859 .41755 L p
.43549 .40806 L 1 .362 0 r
F P
0 0 0 r
s
P
p
.002 w
.44126 .40006 m .45911 .3734 L .47609 .4067 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.44126 .40006 m .42268 .42971 L p
.44712 .39193 L 1 .414 0 r
F P
0 0 0 r
s
P
p
.002 w
.45911 .3734 m .44126 .40006 L p
.44712 .39193 L 1 .414 0 r
F P
0 0 0 r
s
P
p
.002 w
.42383 .40328 m .44126 .40006 L p
.43549 .40806 L 1 .362 0 r
F P
0 0 0 r
s
P
p
.002 w
.35255 .45777 m .36993 .4469 L .38919 .42502 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.63289 .38084 m .61485 .39948 L .59967 .37392 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.58149 .38502 m .59967 .37392 L .61485 .39948 L p
1 .129 0 r
F P
0 0 0 r
s
P
p
.002 w
.56341 .3883 m .54553 .39924 L .52942 .37366 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.51153 .37701 m .52942 .37366 L .54553 .39924 L p
1 .129 0 r
F P
0 0 0 r
s
P
p
.72638 .12403 m .75839 .13358 L .73949 .1381 L 1 0 0 r
F
P
p
.70743 .12865 m .72638 .12403 L .73949 .1381 L 1 0 0 r
F
P
p
.65591 .12367 m .68868 .13323 L .67011 .13776 L 1 0 0 r
F
P
p
.63732 .1283 m .65591 .12367 L .67011 .13776 L 1 0 0 r
F
P
p
.002 w
.49381 .38033 m .47609 .4067 L .45911 .3734 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.79084 .37804 m .77176 .38135 L .75914 .37106 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74002 .37444 m .75914 .37106 L .77176 .38135 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5854 .12331 m .61891 .13288 L .60068 .13741 L 1 0 0 r
F
P
p
.56715 .12794 m .5854 .12331 L .60068 .13741 L 1 0 0 r
F
P
p
.002 w
.72109 .37778 m .70235 .38109 L .68865 .3708 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66987 .37418 m .68865 .3708 L .70235 .38109 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.51483 .12296 m .54909 .13252 L .5312 .13706 L 1 .078 0 r
F
P
p
.49693 .12759 m .51483 .12296 L .5312 .13706 L 1 .129 0 r
F
P
p
.002 w
.65129 .37753 m .63289 .38084 L .6181 .37054 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59967 .37392 m .6181 .37054 L .63289 .38084 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.51153 .37701 m .49381 .38033 L .47683 .37001 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.45911 .3734 m .47683 .37001 L .49381 .38033 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.58149 .38502 m .56341 .3883 L .54749 .37027 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.52942 .37366 m .54749 .37027 L .56341 .3883 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.72638 .12403 m .74551 .11936 L .75839 .13358 L 1 0 0 r
F
P
p
.6747 .119 m .70743 .12865 L .68868 .13323 L 1 0 0 r
F
P
p
.65591 .12367 m .6747 .119 L .68868 .13323 L 1 0 0 r
F
P
p
.002 w
.75914 .37106 m .77846 .36765 L .79084 .37804 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60383 .11864 m .63732 .1283 L .61891 .13288 L 1 0 0 r
F
P
p
.5854 .12331 m .60383 .11864 L .61891 .13288 L 1 0 0 r
F
P
p
.002 w
.44126 .40006 m .42383 .40328 L .40498 .43284 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.38746 .43594 m .40498 .43284 L .42383 .40328 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.74002 .37444 m .72109 .37778 L .70761 .36738 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68865 .3708 m .70761 .36738 L .72109 .37778 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.53291 .11828 m .56715 .12794 L .54909 .13252 L 1 .026 0 r
F
P
p
.51483 .12296 m .53291 .11828 L .54909 .13252 L 1 .078 0 r
F
P
p
.002 w
.66987 .37418 m .65129 .37753 L .63671 .36712 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6181 .37054 m .63671 .36712 L .65129 .37753 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.52942 .37366 m .51153 .37701 L .49474 .36659 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.47683 .37001 m .49474 .36659 L .51153 .37701 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59967 .37392 m .58149 .38502 L .56575 .36685 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.54749 .37027 m .56575 .36685 L .58149 .38502 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.69368 .11428 m .72638 .12403 L .70743 .12865 L 1 0 0 r
F
P
p
.6747 .119 m .69368 .11428 L .70743 .12865 L 1 0 0 r
F
P
p
.62245 .11391 m .65591 .12367 L .63732 .1283 L 1 0 0 r
F
P
p
.60383 .11864 m .62245 .11391 L .63732 .1283 L 1 0 0 r
F
P
p
.002 w
.40498 .43284 m .42268 .42971 L .44126 .40006 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.75914 .37106 m .74002 .37444 L .72677 .36393 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70761 .36738 m .72677 .36393 L .74002 .37444 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.55117 .11355 m .5854 .12331 L .56715 .12794 L 1 0 0 r
F
P
p
.53291 .11828 m .55117 .11355 L .56715 .12794 L 1 .026 0 r
F
P
p
.002 w
.68865 .3708 m .66987 .37418 L .65551 .36366 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63671 .36712 m .65551 .36366 L .66987 .37418 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6181 .37054 m .59967 .37392 L .5842 .3634 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56575 .36685 m .5842 .3634 L .59967 .37392 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.54749 .37027 m .52942 .37366 L .51283 .36313 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.49474 .36659 m .51283 .36313 L .52942 .37366 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.47683 .37001 m .45911 .3734 L .44088 .40253 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.42268 .42971 m .44088 .40253 L .45911 .3734 L p
1 .414 0 r
F P
0 0 0 r
s
P
p
.71285 .10951 m .74551 .11936 L .72638 .12403 L 1 0 0 r
F
P
p
.69368 .11428 m .71285 .10951 L .72638 .12403 L 1 0 0 r
F
P
p
.64127 .10914 m .6747 .119 L .65591 .12367 L 1 0 0 r
F
P
p
.62245 .11391 m .64127 .10914 L .65591 .12367 L 1 0 0 r
F
P
p
.002 w
.77846 .36765 m .75914 .37106 L .74612 .36044 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72677 .36393 m .74612 .36044 L .75914 .37106 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.56963 .10877 m .60383 .11864 L .5854 .12331 L 1 0 0 r
F
P
p
.55117 .11355 m .56963 .10877 L .5854 .12331 L 1 0 0 r
F
P
p
.002 w
.70761 .36738 m .68865 .3708 L .67451 .36017 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65551 .36366 m .67451 .36017 L .68865 .3708 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63671 .36712 m .6181 .37054 L .60283 .3599 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5842 .3634 m .60283 .3599 L .6181 .37054 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56575 .36685 m .54749 .37027 L .5311 .35963 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.51283 .36313 m .5311 .35963 L .54749 .37027 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.49474 .36659 m .47683 .37001 L .45898 .39121 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.44088 .40253 m .45898 .39121 L .47683 .37001 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.71285 .10951 m .73222 .10469 L .74551 .11936 L 1 0 0 r
F
P
p
.66027 .10432 m .69368 .11428 L .6747 .119 L 1 0 0 r
F
P
p
.64127 .10914 m .66027 .10432 L .6747 .119 L 1 0 0 r
F
P
p
.002 w
.74612 .36044 m .76568 .35692 L .77846 .36765 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.58827 .10395 m .62245 .11391 L .60383 .11864 L 1 0 0 r
F
P
p
.56963 .10877 m .58827 .10395 L .60383 .11864 L 1 0 0 r
F
P
p
.002 w
.72677 .36393 m .70761 .36738 L .6937 .35665 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67451 .36017 m .6937 .35665 L .70761 .36738 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65551 .36366 m .63671 .36712 L .62166 .35638 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60283 .3599 m .62166 .35638 L .63671 .36712 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5842 .3634 m .56575 .36685 L .54957 .3561 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5311 .35963 m .54957 .3561 L .56575 .36685 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.51283 .36313 m .49474 .36659 L .47722 .3798 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.45898 .39121 m .47722 .3798 L .49474 .36659 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.67948 .09945 m .71285 .10951 L .69368 .11428 L 1 0 0 r
F
P
p
.66027 .10432 m .67948 .09945 L .69368 .11428 L 1 0 0 r
F
P
p
.60711 .09907 m .64127 .10914 L .62245 .11391 L 1 0 0 r
F
P
p
.58827 .10395 m .60711 .09907 L .62245 .11391 L 1 0 0 r
F
P
p
.002 w
.74612 .36044 m .72677 .36393 L .71309 .35309 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6937 .35665 m .71309 .35309 L .72677 .36393 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67451 .36017 m .65551 .36366 L .64069 .35281 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62166 .35638 m .64069 .35281 L .65551 .36366 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60283 .3599 m .5842 .3634 L .56823 .35254 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.54957 .3561 m .56823 .35254 L .5842 .3634 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5311 .35963 m .51283 .36313 L .49557 .37634 L p
1 .129 0 r
F P
0 0 0 r
s
P
p
.002 w
.47722 .3798 m .49557 .37634 L .51283 .36313 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.69889 .09452 m .73222 .10469 L .71285 .10951 L 1 0 0 r
F
P
p
.67948 .09945 m .69889 .09452 L .71285 .10951 L 1 0 0 r
F
P
p
.62615 .09414 m .66027 .10432 L .64127 .10914 L 1 0 0 r
F
P
p
.60711 .09907 m .62615 .09414 L .64127 .10914 L 1 0 0 r
F
P
p
.002 w
.76568 .35692 m .74612 .36044 L .73269 .34949 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71309 .35309 m .73269 .34949 L .74612 .36044 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6937 .35665 m .67451 .36017 L .65991 .34921 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64069 .35281 m .65991 .34921 L .67451 .36017 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62166 .35638 m .60283 .3599 L .58708 .34893 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56823 .35254 m .58708 .34893 L .60283 .3599 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.49557 .37634 m .51414 .36477 L .5311 .35963 L p
1 .129 0 r
F P
0 0 0 r
s
P
p
.002 w
.54957 .3561 m .5311 .35963 L .51414 .36477 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.69889 .09452 m .7185 .08955 L .73222 .10469 L 1 0 0 r
F
P
p
.64538 .08916 m .67948 .09945 L .66027 .10432 L 1 0 0 r
F
P
p
.62615 .09414 m .64538 .08916 L .66027 .10432 L 1 0 0 r
F
P
p
.002 w
.73269 .34949 m .75249 .34585 L .76568 .35692 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71309 .35309 m .6937 .35665 L .67934 .34557 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65991 .34921 m .67934 .34557 L .6937 .35665 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64069 .35281 m .62166 .35638 L .60613 .34529 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58708 .34893 m .60613 .34529 L .62166 .35638 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56823 .35254 m .54957 .3561 L .53286 .35309 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.51414 .36477 m .53286 .35309 L .54957 .3561 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.66482 .08413 m .69889 .09452 L .67948 .09945 L 1 0 0 r
F
P
p
.64538 .08916 m .66482 .08413 L .67948 .09945 L 1 0 0 r
F
P
p
.002 w
.73269 .34949 m .71309 .35309 L .69897 .34189 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67934 .34557 m .69897 .34189 L .71309 .35309 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65991 .34921 m .64069 .35281 L .62538 .34161 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60613 .34529 m .62538 .34161 L .64069 .35281 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58708 .34893 m .56823 .35254 L .55173 .34132 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.53286 .35309 m .55173 .34132 L .56823 .35254 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.68447 .07905 m .7185 .08955 L .69889 .09452 L 1 0 0 r
F
P
p
.66482 .08413 m .68447 .07905 L .69889 .09452 L 1 0 0 r
F
P
p
.002 w
.75249 .34585 m .73269 .34949 L .71881 .33817 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69897 .34189 m .71881 .33817 L .73269 .34949 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67934 .34557 m .65991 .34921 L .64484 .33789 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62538 .34161 m .64484 .33789 L .65991 .34921 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60613 .34529 m .58708 .34893 L .57081 .3376 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.55173 .34132 m .57081 .3376 L .58708 .34893 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68447 .07905 m .70433 .07391 L .7185 .08955 L 1 0 0 r
F
P
p
.002 w
.71881 .33817 m .73887 .33442 L .75249 .34585 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69897 .34189 m .67934 .34557 L .66451 .33413 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64484 .33789 m .66451 .33413 L .67934 .34557 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62538 .34161 m .60613 .34529 L .59009 .33383 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.57081 .3376 m .59009 .33383 L .60613 .34529 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71881 .33817 m .69897 .34189 L .68439 .33032 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66451 .33413 m .68439 .33032 L .69897 .34189 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64484 .33789 m .62538 .34161 L .60957 .33003 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59009 .33383 m .60957 .33003 L .62538 .34161 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73887 .33442 m .71881 .33817 L .70448 .32648 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68439 .33032 m .70448 .32648 L .71881 .33817 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66451 .33413 m .64484 .33789 L .62927 .32619 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60957 .33003 m .62927 .32619 L .64484 .33789 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70448 .32648 m .72479 .3226 L .73887 .33442 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68439 .33032 m .66451 .33413 L .64918 .3223 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62927 .32619 m .64918 .3223 L .66451 .33413 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70448 .32648 m .68439 .33032 L .66931 .31837 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64918 .3223 m .66931 .31837 L .68439 .33032 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72479 .3226 m .70448 .32648 L .68966 .3144 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66931 .31837 m .68966 .3144 L .70448 .32648 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68966 .3144 m .71023 .31038 L .72479 .3226 L p
1 0 0 r
F P
0 0 0 r
s
P
p
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.08509 .19367 m
.08465 .20033 L
s
P
[(0)] .08595 .18034 -0.06484 1 Mshowa
p
.002 w
.23498 .15292 m
.23469 .15959 L
s
P
[(10)] .23556 .13958 -0.04346 1 Mshowa
p
.002 w
.40002 .10806 m
.39989 .11474 L
s
P
[(20)] .40028 .0947 -0.01962 1 Mshowa
p
.002 w
.58262 .05842 m
.58267 .0651 L
s
P
[(30)] .58253 .04506 .00711 1 Mshowa
p
.001 w
.11395 .18582 m
.11371 .18982 L
s
P
p
.001 w
.14336 .17783 m
.14314 .18183 L
s
P
p
.001 w
.17332 .16968 m
.17311 .17368 L
s
P
p
.001 w
.20386 .16138 m
.20367 .16538 L
s
P
p
.001 w
.2667 .1443 m
.26655 .1483 L
s
P
p
.001 w
.29905 .1355 m
.29892 .13951 L
s
P
p
.001 w
.33204 .12654 m
.33192 .13054 L
s
P
p
.001 w
.36569 .11739 m
.36559 .1214 L
s
P
p
.001 w
.43505 .09854 m
.43499 .10254 L
s
P
p
.001 w
.4708 .08882 m
.47076 .09283 L
s
P
p
.001 w
.5073 .0789 m
.50728 .0829 L
s
P
p
.001 w
.54456 .06877 m
.54457 .07277 L
s
P
p
.001 w
.6215 .04785 m
.62155 .05186 L
s
P
p
.001 w
.66122 .03706 m
.6613 .04106 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{266, 253},
  ImageMargins->{{34, Inherited}, {Inherited, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004:0000o@P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l02`000?mK2U/10000oe/:F`40003oF`YK
0@000?mK2U/10000oe/:F`40003oF`YK0@000?mK2U/10000oe/:F`40003oF`YK0@0005iK00?oFol0
0e/01?mKFe/3o`04FomKo`AK00GoFe]Ko`2AF`40001NF`03oe_o00=K00CoFe_o0e/2o`03FomK009K
00?oFol09E/4o`=K1?mTF`40001NF`03oe_o00=K00CoFe_o15/00omKo`03F`03oe_o02AK00?oFe/0
0U/00omKo`04F`03oe]K065K0@0005iK00?oFol00e/01?mKFol4F`03oe_o00=K00?oFol095/00omK
F`02F`03oe_o00AK00?oFe/0HE/10000GU/00omKo`03F`04oe]Ko`AK00?oFol00e/00omKo`0YF`03
oe_o00AK00?oFe/04E/3odeK0@0005iK00CoFooo0U/01?mKFol3F`;o00EKoe]Ko`03F`03oe]K02=K
0ol2F`03oe]K009K00?oFe/03U/3o`9K00?oFe/0Be/10000GU/01?mKoe/2o`AK0ol015_oFol2F`05
oe]KFol0:5/00omKo`04F`03oe]K00YK1?l6F`03oe]K00EK1_l2F`Co>E/10000GU/00omKF`0;F`03
oe]K02YK00?oFe/00U/00omKo`04F`03oe]K00IK1?l00e_oF`08F`03oe]K00AK00?oFe/015/00omK
F`02F`03oe]K03IK0@0005iK00?oFe/02e/00omKo`0ZF`03oe]K009K00?oFol015/00omKF`03F`?o
1E/00omKF`08F`03oe]K00AK00?oFe/00e/00omKF`02F`03oe]K03IK0@0009YK1?l3F`Co0U/4oaAK
00?oFe/015/2o`=K00?oFe/00U/00omKF`0fF`40002TF`?o0U/00omKF`0DF`;o1U/01?mKFol4F`03
oe]K03IK0@000:1K1?lKF`03oe_o00MK00?oFol015/00omKF`0fF`40002MF`Co8E/00omKo`04F`03
oe_o00AK00?oFe/0=U/10000KU/6o`9K1?lOF`Co0e/00omKF`0OF`03oe_o00AK00?oFol015/00omK
F`0fF`40001^F`03oe]K00AK00?oFe/00U/00omKF`0HF`Co1e/00omKF`0PF`03oe_o00?o0e/4ocUK
0@0006mK00?oFe/00e/00omKF`02F`03oe]K01EK0ol2F`03oe]K02YK00?oFe/0@U/10000L5/2o`=K
00?oFe/00U/00omKF`0AF`Co<e/00omKF`11F`40001bF`04oe]Ko`AK00?oFe/03U/4obaK0b<8F`03
oe]K041K0@0007=K00?oFol015/00omKF`0:F`Co0e/00omKF`0UF`TS25/00omKF`0oF`40001^F`03
oe]K009K00?oFol015/00omKF`06F`Co:U/?8`QK00?oFe/0?U/10000KU/00omKF`02F`03oe_o00AK
00?oFe/00e/3o`=K00?oFe/095/C8`UK00?oFe/0?E/10000Ke/4o`=K1?l2F`Co:E/H8`QK00?oFe/0
?E/10000NE/3o`03FomK02QK6b<8F`03oe]K03aK0@0004]K00?oFe/00U/4ob5K1?l[FalS25/00omK
F`0kF`40001;F`05oe]KFol015/00omKF`0JF`Go:E/U8`QK00?oFe/0>U/10000Be/01OmKFe_o00AK
00?oFe/05e/3o`AK00?oFe/08e/Z8`QK00?oFe/0>E/10000Be/01OmKFe_o00AK00?oFe/04e/4obUK
00=O7el0;2<8F`03oe]K03QK0@0004]K00GoFe]Ko`04F`03oe]K011K0ol3F`03oe]K029K00=O7el0
1Ql[8`UK00?oFe/0=e/10000Be/01OmKFe_o00AK00?oFe/035/4obMK00hOGamO7elOGamO7elOGb/S
2E/00omKF`0fF`400019F`?o0e/00omKF`02F`03oe]K00UK0ol2F`03oe]K029K15l011mO7el27`03
GamO00<O;R<8F`03oe]K03IK0@0004]K00GoFe]Ko`04F`03oe]K00EK1?lVF`0@7aLOGamO7elOGamO
7elOGc<S25/00omKF`0eF`40001;F`03oe]K009K1?l4F`Co00=Koe/08e/01elOGelGGaL01el00amO
7`0g8`QK00?oFe/0=5/10000EE/3obIK00<G4El01El02alG7aLOGamO7elO03XS25/00omKF`0cF`40
000YF`Co95/4o`03FomK02AK1AL01AmO7elO009O00<GGaL00el@8`@O:R<8F`03oe]K039K0@0002QK
00?oFe/00U/00omKF`0NF`?o:5/54@045a4G4@IO00<O5b<03b<37`06GamO7elO:R<8F`03oe]K035K
0@0002QK00?oFe/00U/00omKF`0JF`Go9U/00ilAW`024@045a4G4@DG00HOGamO7el=8`07GamO7elO
G`077`8S00=O7el09B<8F`03oe]K01UK1?l00e_oF`04o`9K00GoFe]Ko`03F`7o0E/10000:5/00omK
F`02F`03oe]K01IK1?l4F`03oe]K021K00?OWml00Yl0116O4Il64@8G00QO5emO7elOG`PS00POGamO
7elOG`DO00EO7elOG`067bDS25/00omKF`0GF`03oe]K009K0ol4F`03oe_o00=K00?oFe/00e/10000
:5/00omKF`02F`03oe]K01=K0ol00e_oF`0UF`03WmnO00NO00@AWa4A1AL02QmO7elOGamO7el28`03
7elO009O00<OGal00Ul01AmO7elO00IO00<OGal00Ul011mO7elU8`QK00?oFe/05E/00omKF`04F`;o
1U/01OmKFe_o00EK0@0002QK00?oFe/00U/00omKF`0?F`Co9e/4g`FO00[OWmnOga6O5a4G1Ul00aMO
5`02G`047a4G4@8G01QO5elG7elOGamO7aLO5amO7elOGamO7el67bDS1e/00omKF`0EF`03oe]K00AK
1ol00e_oF`02F`03oe]K00=K0@0002QK00?oFe/00U/00omKF`0<F`?o00=Koe/095/4g`FO00GOWmnO
g`02W`035a4G008A00<G4AL01AL03amO5a4G4ALA5a4GGamO7`02G`8O00MO7emO5elG00MO00<OGaL0
0Ul011mO7elU8`MK00?oFe/01E/4o`=K1?l4F`04oe]KF`Go15/00omKo`03F`03oe]K00=K0@0002QK
00?oFe/00U/00omKF`08F`Co9U/01=oNgmh:g`:O00@AWa6O1Q400aLA5`02G`TA00@G4ALA0QL015lA
5a425`0;GaMO5alG7aLOGal00el011lG7aL67bDS1e/00omKF`03F`03oe]K009K00?oFol015/01OmK
Fe_o00MK00?oFe/00U/01?mKool2F`03oe]K00=K0@0002UK1?l8F`?o00=Koe/08e/5gP04gmkOgPGO
1Yl0116O4Il24@035a4G008A00<G4Il01a401ALA5a4G00DA00TG4ALA5elOGal00Ul03AMOGelOGamO
7elGGaL00Ul00alS8`0V8`MK00?oFe/00U/00omKF`02F`03oe_o00AK00GoFe]Ko`06F`03oe_o00?o
0U/01?mKool6F`40000aF`Co8U/4gP0=gmkOgmkOg]oNgmkOgP02g`FO00?OWml00Yl0116O4Il24@>O
00@AWa6O21400ilAW`064@045a4G4@8G0Ul01QMOGamO7`IO00HO5amO7elY8`MK00?oFe/01U/00omK
o`04F`03oe]K009K00?oFe/00U/00omKF`0@F`40000]F`Co00=Koe/07e/0277NLMkOg]oN1]l4gP;O
00>Ogil01Ml5W`034IoO00CO00NOgilAWa6O00<A1Il0116O4Il54@035a4G008G00AO5elG1Ul01AmO
5elG009O00@OGamO:2<8F`03oe]K009K0ol2F`03oe]K009K00?oFe/00e/4oa=K0@0002YK0olSF`=a
2]h01MoNg]oN00[O1Il5g`VO00<AWil029l0116O4Il;4@04GaMO5`9O00<OGel00Ul02QlG7aLOGamO
7elX8`IK00?oFol01U/00omKo`04F`03oe]K01YK0@0002QK0_l00e_oF`0OF`0?g9GLUMiagW7NLMia
g]oN00kO00>Ogml00ml00ioOW`06W`GO0Yl01mnOgioOWml01Yl0116O4Il54@DG00=O5el015l00amO
7`02G`035elG009O00<O8b<0:B<8F`;o15/00omKo`04F`03oe]K01YK0@0002QK0_l00h5KF`0LF`?L
00FEg9GLU@05L@;N00cOg]oNgmkOg]oNgmh7g`03g]oN00cO1Il00mnOg`07W`08gioOWa6O4Il74@04
5a4G4@YO00<O5b<0;b<7F`;o15/00omKo`04F`03oe]K01YK0@0002QK00?oFh406U/00mc/g006k006
g9GLUMia1Mh01=oNgmh:g`GN1Ml019oOWml6W`GO00>Ogil00Yl00mnOg`08W`074IlA4ALA5`024@05
5a4G4AL01El01AmO7elO034S1e/5o`=K1?lMF`40000XF`03oe^101MK0n`01=c/g>`7g003UMoN00KO
00KNgmkOg]l2gP06gmkOg]oN1]l00mkOg`0<g`:O2=l01ioOWmnOgil01a4021LA5a4G4ALA0el01ALO
5alG00DO<B<7F`03oe]K02EK0@0002QK00?oFh404e/4]P04g>cLk0;L00?/g>`00^`4gP05gmkOg]l0
1Mh00moNgP02gP04gmkOgPGO0]h01=oNgmh4g`04WmnOg`>O1Ml00ioOW`05W`05ginOgil01A465`03
4EmO009O00/OGamO5elGGaLOG`037c4S1e/00omKF`0TF`40000XF`03oe^1011K00S<3Lbe][Ff]@K/
00?LgW401mh01=oNgmh2g`03gW7N00GN00WOg]oNgmkOg]l00]h01=oNgmhEg`04WmnOg`BO1a43G`05
7elOGal01El00aLO7`037`04GamO7c4S1e/00omKF`0SF`40000XF`03oe^100aK00?<3L`00Pd01<`=
c0d4]P0:g>cMUMfEgW7NL@GN00?OgW400g401=iagW45gP03gmkN00;N00[Og]oNgmkOg]oN0]l02=kO
g]kOg]oN1]l03IoOgmnOgioOWmnOgil00a400aLA5`045`IO00POGaMO7elOG`HO4B<00amO8`0M8`MK
00?oFe/08U/10000:5/00omKP@0<F`H=01?<3L`=][Fg][NELIEaUG7NLMia00;N00OLUMaagG7M009a
00?NLMh00]h5L@07gg7OLMoNg`02gP08gmkOg]oNgmh;g`0:WmnOgioOWmnOg`:O0a401ALA5a4G00AO
00TOGaMO5alG7aL01al00elS8`0=8`07GamO7elOG`0N8`MK00?oFe/08E/100009e/01?mKFh4?F`05
3Lc<3L`010d05;Nf]kJg]YGM]kJgk=c/g9GLUMbE17402miaUMfEgW7NLMia00GN00?Og]h01]h00moN
g`02gP04gmkOgP[O00>Ogil00il021LA5a4G4ALA0aL3G`037elO009O00HGGaMO7el37``S25l011mO
7elN8`MK00?oFe/085/100009e/3o`03PE]K00mK01<=c0g<3L`=c0fg][D=]@fg][Nf00G/00gLUKGl
]Mc/g>aaUG6E00Qa00ONLMkNgmkO00;N00COg]oN1Ml01MkOg]oN00?O00>Ogil00il01MnOgioO00@A
00<G4El025l01AMO5alG00DO00=O7el01b<04ElOGamO7elOGamO7elOGamO01dS1e/00omKF`0PF`40
000HF`Co0e/4o`AK0h4DF`03c0g<00<=02C<3Lbe3KD=]KJg][O/g<`=c0gl]Obeo=c/g>bEgG7MLMia
gW47gP03gmkO00_N1=l4W`GO0Yl01aLA5aMO5el01QL4G`037elO00<O00=O7el01Al28`@O3Ul011mO
7elM8`MK00?oFe/07e/100005e/00omKF`02F`03oe_o00AK00KoFe]Koe/2PAAK00G<3L`=c0053@06
]@fe3KNf20d01_beo;Glk0;L00K/g76ELID6L@WN00COg]oN0ml01mkOg]nOgil01Ml2W`<A00TG4ALA
5elGGaL00Ul01aMO5elGGaL01Ul27`03GaMO00UO018OGamO7elOGamO7elOGamO7elM8`MK00?oFe/0
7U/1000075/00omKo`04F`08oe]KFomKPE/2PAAK00P=c0g<3L`=c08=01fec0g<3L`=c0g<3L`=o;Fg
][Nfg>cLk=eagG7NL@09gP03gmkO00?N00?Og]l02Ml5W`085a4G4ALA5a425`9O00/OGelOGamO7elO
G`037`<A11L01ElOGamO00DO2elT8`MK00?oFe/07E/100004e/3o`IK00?oFol015/01omKFe_oFh40
0e/2PAAK00?<3L`01`d00l`=c0073@03][Ff00Jg00GLk=aaU@04L@04gg7OL@KN00COg]oN1=l01]kO
g]oNg`:O00?OWil00il54@035a5O00IO00LGGaMO5elG00<A1AL015lGGaL:G`077elOGamO7`0X8`MK
00?oFe/075/100005e/00omKF`02F`03oe_o00AK00OoFe]Koe^100EK0X4@F`0<PE]KFl`=c0g<3L`=
0/`020g<3L`=]@fe1KH02KNfk=c/g=fEg@05L@KN00=agW401ml01=kOgml5W`03gioO00BO00<G4AL0
0aL4G`037elO009O00@O4ALA1AL54@8G00<A5a4015l57`9O;2<8F`03oe]K01]K0@0001MK1Ol2F`03
oe]K009K00OoFe]Koe^100MK00>1Fe/03E/00h5KF`02F`/=00[<3L`=]@fe3KJe0kL02Mc/g>cLLIEa
U@02L@?L00BELIEa1Mh01MoNWmnO00GO00<Aga400]l00ilA4@054@055a4G4AL01Ul<4@<G00LA5a4A
5a4G00IO<B<8F`03oe]K01YK0@0001MK00?oFe/015/00omKF`02F`07oe]KFomKP@08F`:13E/00h5K
F`03F`09c0g<3L`=c0g<008=00G<3L`=]@04]P0F]kJg]]c/g>cLgIG/g>cLUMbELMeag@9a00?Ngmh0
1Ml7W`034IlA00@A1aL2W`HA00<G4AL00Q401aNOga6O4Il01Q402ALA7amO7elOG`0b8`QK00?oFe/0
6E/1000065/00omKF`03F`03oe]K009K00OoFe]Koe^100YK0X4;F`03PE]K00EK2Pd02/`=]@ff]KJe
][D3]`03g>cl00?l00?/g>`01M`00iEagP03gP08gmkOg]nOgil2g`FO00<AWa401Q4019oOWml3W`LA
00?O4Ml019l0116O4Il24@035elG00EO1Al28`8O;b<6F`03oe]K01UK0@0001QK1Ol2F`Co15/2o`03
PE]K00YK0X49F`03PE]K00QK00@=c0g<0Pd01l`=3KD=]@d00[H00`fe3@02]@033KFf00Bf00KLk=c/
g9D3L@04gW7NL@;N00?Og]l00]l9W`034IlA008A19l00mnOg`04W`8A2Il01MnOga6O00EO00<OGal0
11l01ElO7elO009O00<OGb<0;R<6F`03oe]K01QK0@0002MK00?oFh403U/2P@MK00>1Fe/02U/53@08
c0g<3KD=]@d9]@;l0m`0176ELID5L@;N0ml;W`cO00>Ogml01]l0217O4MlAga7O0Yl35`08GamO7elG
GaL4G`037elO00LO;b<6F`03oe]K01MK0@0002MK00?oFh4045/2P@EK00>1Fe/035/040g<3@g<3L`=
]@fe3KD=]@d2]@043MbEg0BE00CMUMfE0W49g`03WmnO00:O1=l01mkOgYoOWml00il3g`04WmnOg`NO
00/G4A4G4ALA5a4G4@02G`0E7elO5elGGamO7elOGamO5amO7elO00LS00<OGal011lP8`IK00?oFe/0
1e/01?mKFe/4o`MK0@0002MK00?oFh404U/2P@=K00>1Fe/03U/33@08c0g<3L`=]@d2]@CL00FEg9GL
U@03g003LIGN00?N00COg]oN1=l2W`08gmkOg]oNgmh:g`03WmnO00KO31425`0=GamO7elOGaLO5amO
7`04G`035alG00DO0R<035lOGamO7elOGamO7`8S00=O7b<06R<7F`03oe]K00IK00CoFe_o15/00omK
F`04F`40000WF`03oe^101AK0X400e^1F`0@F`03c0g<008=00K<]kJgg>`6g003UMcN00KN00COg]oN
0ml4L@07gW7NgmkOgP03g`KN1ml7W`HA00<G4A401AL5G`047elO5`EO00POGamO5elG7`IO00LOGalO
GamO00<O00=O7al00alK8`MK00CoFe]K1_l00e_oF`03F`03oe]K00AK0@0002IK00CoFe^15U/2PA9K
0`d02KD=]kJg]^cLk003g006LMeaLMia2=h3g0Aa1Mh00moNgP05gPSO00FOga7O4@02g`03WmnO00TA
00TG4ALA5amO4AL035l00amOG`04G`057elOGal00el03AlG7aLOGamO7elOGal06b<5F`?o0U/01OmK
Fe_o009K00?oFe/00U/00omKF`04F`40000VF`04oe]KPAMK0X4CF`D=00Fg][OLk003U@Ea1Mh4g0FE
1745gP03LMia00KN00OOWmnOgioO00ZO1A465`054ALA5a401QL2G`<G0el01AmO7elO00IO00TOGamO
5elG7el011l00elOG`0K8`MK00CoFe_o0U/01?mKFol4F`03oe]K00AK0@0002IK00CoFe^15e/0185K
PH4AF`03PE/=00Be0n`01iGLUMbELMd00kL00nbgk005k0;L00BEg9GL0g401=iagW43gP_O00BOga7O
1Yl00mnOg`024@>O00@AWa6O1A400aLA5`02G`<A00PG4ALA5amO7`=O00LOGamO7elO00AO00@O5elG
1El47a/S2U/00omKo`02F`03oe]K009K00?oFe/015/100009U/2o`03PE]K01EK00>1Fe/00U/2P@mK
00b1Fe]K]@fe3KG/g>`2U@03][Nf00Ff00>gk;L00]`02>cLk9GLUMbE0g43gP06gmkOg]oN1]l7W`GO
0Yl03MnOgmnOgilAWa6O4AL019l01a6O4ALA5a401QL5G`?o25l011mO7el37`=O00<OGal06b<9F`03
oe_o009K00?oFe/00U/00omKF`04F`40000VF`03oe^101MK00>1Fe/015/2P@eK00>1Fe/00U/3]@05
3KD=][D00[H01;Nf]kH3]`0=]^bgk;O/g>cLk9GLL@02gP03LMia00GN1]l02Q7O4MlAga7O4Ml2W`03
4MlA00;O00>Ogil019l01A6OgioO00BO00@AWa6O0a401YlA4ALA5`Go0b<05_mO7elOGamO7elG7elO
GamO7elOGalK8`UK0_l2F`03oe]K009K00?oFe/015/100009U/00omKP@0GF`03PE]K00IK0X4;F`03
PE]K00AK1@d02;Kl][Nfo;Kl1;H03;O/]nbgk=cMLMeagP9a00GNLMiagP04g`03WmnO01>O00?OWml0
0Yl00mnOg`0:W`05gioO4Il01Ol48`03ob<S008S00?oGel045l00alS8`0H8`aK00CoFe]K1?l7F`40
000VF`03oe^101MK00>1Fe/025/2P@UK00>1Fe/01U/00kD=3@033@06]@ff]KJe0[H02;Nfk;O/g>cL
1=d09miag]iagmkOg]oNgmkOWmlAga7O4MlAga7O4MlAga7O4MlAWmnOg`05W`;O00DAga7O4@02g`Co
12<00olS8`038`05ob<Sob<00_l02UlOGamO7elOGalJ8b9K0@0002IK00?oFh405e/00h5KF`0:F`:1
1e/00h5KF`08F`03c0g<00D=00ol]Pfe3KJg]^cLk=c/LMd01=h00moNgP04gPGO2il01=nOWml6W`03
ginO00VO1Ol38`03ob<S00<S00Ko8b<Sob<2o`@S00?oGel00elJ8bIK0@0002IK00?oFh405e/00h5K
F`0<F`:11E/00h5KF`0:F`@=00Be3@d=1KD01;Jg]^`4g003LMia00GN00SOg]oNgioOW`GO01LAgioO
WmnOgioOWmlAga7O4MlAga7O4@05o`@S00?o8b<00R<01_lS8b?o8`?o0b<00olS8`038`04oelOGa@S
0U/00h5KF`0XF`40000VF`03oe^101MK00>1Fe/03U/2P@=K00>1Fe/035/02<`=c0g<3Lbe1@d01obf
o=bEg9D01]h00moNg`06g`?N1Ml01IoOWmnO00?O00>Ogil01Il4o`@S00?o8b<00b<01OlS8olS00?o
0b<00olS8`038`0:ob<S8olSoelOG`lS1U/00h5KF`0XF`40000VF`03oe^101MK00>1Fe/045/0185K
Fh4?F`T=00Ne3KD=o;Kl00?L00?/g=h01=h01MoNgmkO00?N00COg]oN1Ml02YoOg]oNgmkOWml5o`@S
00?o8b<00R<01_lS8b?o8`;o12<00olS8`028`06ob<S8olS0ol38`03oalO008O1R<=F`03PE]K011K
184DF`40000VF`03oe^101MK00>1Fe/04E/3PA5K0h`01L`=c0g<008=0h`02;D=]Mc/g>cL1Mh01moN
gmkOg]l02Mh6g`?o12<00olS8`038`05ob<Sob<00ol48`03ob<S008S00Go8b?o8`03o`<S00?o8b<0
0b<01OlOGamO008S45/00h5KF`0;F`F165/100009U/00omKP@0GF`03PE]K01=K0X4@F`05PE]<aT`0
0Pd034eVCDc6C<H=]@g/g0@=00CNLMia1Mh00meag@04gPCO00?Ngol00_l00amO7`02o`@S1?l00b?o
o`048`;o12<4o`038ooo00@S00?o8b<00R<01_lS8b?o8`;o55/00h5KF`05F`J17E/100009U/00omK
P@0GF`03PE]K01=K00B1Fh613U/02h5KFe]??dloCFI=00:<00/oCcm=ITeV3L`=c002gP03UMbE00>E
1742gP05gIGMLMh00_l87`;o12<00olS8`028`03ob<S00<S0_l48`03ob<S008S00?o8b<00b<3o`04
8oooo`@S00?oFe/04E/00h5KF`05PB=K0@0002IK00?oFh405e/00h5KF`0CF`04PE]KF`:135/00h5K
F`02F`8o1R<5?`03ITdS008S0d`4g00AUMbELMg/g>bELIEaoelOGal01?l38`03ob<S00<S00Go8b?o
8`03o`<S00?o8b<00b<01OlS8olS00?o0b<00olS8`028`;o12<00omKF`0=F`J1:5/100009E/01?mK
Fh4GF`03PE]K019K00>1Fe/015/2P@YK00>1Fe/015/78`03CclS00LS00E=C4gLU@03]P03]nbg00;/
00WLk9GMoelOGal012<00olS8`028`06ob<S8olS0_l48`03ob<S008S00Ko8b<Sob<2o`<S00?o8b<0
0b<01_lS8b?o8`;o0b<00omKF`07F`F10e/00h5KF`0XF`40000UF`04oe]KPAMK00>1Fe/04U/00h5K
F`06F`:125/00h5KF`05Fa8S0dd4o003]ncL00;L0ol00elO8`028`03ob<S008S00Go8b?o8`03o`@S
00?o8b<00R<01OlS8olS00?o0b<00olS8`028`06ob<S8olS0ol38`03ob<S008S00CoFe]K1H49F`03
PE]K02MK0@0002EK00CoFe^15e/00h5KF`0BF`03PE]K00QK0X46F`03PE]K00MK4B<2IP[o00AO7b?o
1B<3o`038ooo00@O0_l48`Co00<Sool012<00olS8`028`05ob<Sob<00ol48`03ob<S008S00Go8b?o
8`02o`03PE]K00aK00>1Fe/09e/100009E/01?mKFh4GF`03PE]K019K00>1Fe/02U/2P@AK00>1Fe/0
2E/>8`03C?oo009O00So7olOGaoo7`@S0ol00amOo`047`07oamO7elOG`02o`@O00?o8b<00R<00olS
8`038`?o00<Sool012<2o`@S1?l00b?oo`048`03oe]K00aK00>1Fe/09e/100009E/00omKP@0HF`03
PE]K019K00>1Fe/035/01H5KFe^100iK1B<3?`==00Q<oelOoeooG`Co014SoomO7omO7elOGomO7elO
o`037`0:oeoo7elOGamOo`8S00?o8ol00_l38`03ob<S008S00?o8b<00b<2o`<S00?o8b<00b<00olS
8`028`03oe]K00]K00>1Fe/09e/100009E/2o`03PE]K01IK00>1Fe/04U/00h5KF`0=F`:100=KPE/0
3e/38`A?00=<COl00Ul5o`0A7ooo5eoo7elOGomO7elOGol011l01olOoamO7ol01Ql2o`@S00?o8b<0
0R<01OlS8olS00?o0b<00olS8`028`06ob<S8olS0_l38`03oe]K00YK00>1Fe/09e/100009E/00omK
P@0HF`03PE]K019K00>1Fe/03e/2P@iK00>1Fe/00b<2?`05C4gooal00_l065lOGamOoelOGaooGamO
7omO7elOoamO7`?o00iO7elOGolOGamOoelOo`DS0ol00b?oo`048`03ob<S008S00Go8b?o8`03o`<S
00?o8b<00R<00omKF`09F`03PE]K02MK0@0002EK00?oFh4065/00h5KF`0BF`03PE]K011K0h4<F`03
PE]K009K12<02TgooomOoamO7el2o`0>GaMO5omO7elOoamO7el4o`097eooGamO7eoo00<O00?o7al0
0Ql3o`<S00?o8b<00R<00olS8`028`Co00<Sool012<00olS8`028`Co00<Sool02E/00h5KF`0WF`40
000UF`03oe^101QK00>1Fe/04U/00h5KF`0@F`03PE]K00:12U/00h5KF`03F`<S0_l05UlOGomO7eoo
4AOo7elOGolOGamOoal2o`035eoo00AO00co7elOGaooGomO7el38`03ob<S00<S00Go8b?o8`02o`<S
00?o8b<00b<00olS8`028`;o0b<00olS8`038`03oe]K00IK00>1Fe/09e/100009E/00omKP@0GF`03
PE]K01=K00>1Fe/045/00h5KF`02F`:125/00h5KF`03F`Co01DGGaMO5omO7olG4OlGGaMOoamO7el0
0_l03QlG7aLOoamO7eooGamO0ol27`03oaoo00<S00Ko8b<Sob<2o`@S00Go8b<So`038`04ob?oo`@S
00Go8b<So`038`03ob?o00MK00>1Fe/09e/100009E/00omKP@0GF`03PE]K01=K00>1Fe/045/00h5K
F`04F`:11U/0185KFe/2o`0R4AOoGamO7elOoaoo5a4GoamO7elOoelOoelOGolGGaMOo`9O1Ol021MO
5eoo7elO0ol012?oool48`03ob<S008S0ol012?oool48`03ob<S008S0ol012?oool38`03oe]K00AK
00>1Fe/09e/100009E/00omKP@0GF`03PE]K01=K00>1Fe/045/00h5KF`06F`:115/01H5KFa7o008A
024GoolGGaMO5eoo5a4G4OlGGaMO5omOoaMO5elGoaLOoal00_l3G`09oaLO5aoo7elO00<S00Co8b<S
0_l48`;o0b<00olS8`028`03ob<S00<S0_l38`03ob<S008S00?o8b<00R<2o`AK00>1Fe/09e/10000
9E/00omKP@0GF`03PE]K01=K00>1Fe/045/00h5KF`08F`:10U/01X5KWolA5`;o0QL06_mO7eoo4ALA
5a4G4OmO7elOGomO7elOGamO0_l2G`0>oamO7elOoaMO5omO8ol58`?o00<Sool012<01OlS8b?o008S
00?o8ol00_l38`03ob<S008S00Go8b?o8`02o`@S00GoFe]KP@0YF`40000LF`Co1E/2o`03PE]K01EK
00>1Fe/04e/00h5KF`0@F`03PE]K00YK00F1Fh4Ao`024@?o0el00olGo`034@0=5a4G4AOoGaMO5eoo
5`02o`0:5ooo5omO7elOo`EO00Co5omO0b<3o`<S00?o8b<00R<00olS8`028`?o00<Sool012<00olS
8`028`Co00<Sool012<00olS8`028`04oe]KPBUK0@0001]K00?oFe/00U/01?mKFe/2P@03Fh5K01IK
00>1Fe/04e/00h5KF`0@F`03PE]K00]K00V1WolA5a7o5a401Ol06A4G4AOo5a4G4OmO7elOoaLA5a7o
GaMO5ol015l01OlOGamO00;o00=Oool012<00olS8`028`05ob<Sob<00_l48`05ob<S8ol012<2o`@S
00Go8b<So`058`;o0b<00omKP@0YF`40000KF`03oe]K009K00KoFe]Koe/3PAIK00>1Fe/04e/00h5K
F`0?F`03PE]K00IK1_l00a6Oo`024@05oaOoWol00a400olA4@034@0<oaLA5a7o5elGoa4G0Q402olG
GaMO5omO7eoo00=O0ol00amO7`02o`@S0ol00b?oo`048`03ob<S008S0ol00b?oo`048`03ob<S008S
0ol012?oool38`03ob<S008S0_lYF`40000KF`03oe]K009K00GoFe]Ko`02F`04PE^1PAAK00>1Fe/0
4e/00h5KF`0?F`03PE]K00AK0_l01ioOoiooWa401?l01QOoWa6Oo`<A017o5a4G4OlA5a4GoamOoa4G
4@035`07oaMO5elGo`03G`04oeooo`LO0_l48`05ob<S8ol012<2o`05GamO7ol00b<00olS8`028`;o
12<01OlS8b?o00@S0_l48`03oe]K02IK0@0001]K00?oFe/00U/01OmKFe_o009K00B1Fe]K0h4AF`03
PE]K01=K00>1Fe/03e/00h5KF`03F`;o0Yl00onOo`04o`<A00KoWa6O4Ol34@03oa4A008A00[o5a4G
4OlGGolG1A401_mO5elGG`Oo0al3o`@S00?o8b<00R<3o`0<8ooo7eooGamO7elO0ol00b?oo`048`03
ob<S008S0ol00b?oo`048`03ob<S008S00?oFe/09E/100006e/00omKF`02F`05oe]KFol00U/00h5K
F`04F`:13e/00h5KF`0CF`03PE]K00mK00>1Fe/00U/2o`03Wmoo00Co00DA5a4G4@02o`054IlAWol0
11403olA5e/GoaLA5olOoaLAo`055`0?oelGGomOoaMO5olOGamO00<O00?o8b<00R<2o`9O00GoGemO
o`04G`09oelOGamOoeoo00<S00?o8b<00R<2o`<S00Go8b<So`058`;o0b<00omKF`0TF`40000KF`03
oe]K009K00GoFe]Ko`02F`03PE]K00IK0h4<F`03PE]K01=K00>1Fe/03e/0285KFe_ogonO0_l01IlA
Wa7o00<A00WoWioo4IlAWol011402OlA4E_o4ALA5`02o`<A00?o4A400Q401?lGGol3G`03oaOo00<O
00KoGamO7el2o`9O01KoFamO7olOGaoo7elOoamO7eooGamO0ol00b?oo`038`03ob<S008S1ol38`03
ob<S008S00?oFe/08e/100006e/00omKF`02F`07oe]KFomKP@0<F`:12U/00h5KF`0CF`03PE]K00mK
00F1FoooW`03o`:O017o4IlAWolAoioOWonO4IlAo`044@03oaLA00Oo11400olG5`025`07oeoo7elO
G`03o`06GamO7olO0_l00eoo7`037`05oe]OGol00el00omOG`02G`07oamOoelOG`028`05ob<S8ol0
12<2o`@S00Go8b<So`048`;o0b<00omKF`0RF`40000LF`Co15/00omKP@0>F`>11e/00h5KF`0CF`03
PE]K00mK00>1oml00ol02=nOgioOoilA0ol5W`06oilAWa7o0a43o`:O00KoWa6O4Ol44@04oa4A4@;o
00DOoemOo`02G`03oalO00<O00GoGemOo`04G`0CoamK7eooGamOoelOGomO7olOo`048`Ko12<00olS
8`028`?o00<Sool00b<00olS8`028`;o8U/1000095/2o`03PE]K00mK0X45F`03PE]K01=K00>1Fe/0
3e/01ooOoioogol01Il2o`?O00_oWmnOgiooWa6Oo`024@03oioo00BO00GoWa6Oo`044@04oaLGo`=O
00?oGol011l02olOGaoo7elOGaoo00@O00GoGomOo`03G`08oemOGolOoal28`;o12<01OlS8b?o00@S
0_l38`05ob<S8ol012<2o`@S00?oFe/07e/1000095/00omKP@0CF`>10U/00h5KF`0BF`03PE]K00iK
0_l01=ooool3W`06omooomoo1Il00onOW`02W`06oa6O4OlA0_l039ooWmnOgolAWa6Oo`<A00Co4OmO
1_l4G`05oalOoaL01El00omOG`02G`03oelO00;o00IO7eooGal5o`@S00?o8b<00R<3o`038ooo00<S
00?o8b<00R<6o`@S00?o8b<00R<00omKF`0NF`40000TF`03oe^101IK0h4DF`03PE]K00eK00CogooO
0ol01MmKgmoo00BO00?ogml00ml00onOg`08o`04gioOo`BO00Go4IlAo`024@?o00TGoeoo7elOGol0
0al00olOo`035`05oamO7ol011l00omOG`08o`038olS00<S0_l28`;o0b<00olS8`028`;o0R<2o`@S
00?o8b<00R<2o`8S0_l38`03oe]K01eK0@0002AK00?oFh4065/3PA9K00>1Fe/02e/2o`04gooOo`?O
0_l3g`03omoO00;O00?oWil00Yl3o`05gioOWml00_l03IoOWmoogioOWonO4Il00ol031OoGomO5eoo
GaOo5`Go00DGGaMOo`04G`03oemO009O0ol47`03ob<S008S0_l48`05ob<S8ol00b<2o`@S00Go8b<S
o`048`;o0b<01OlS8b?o00@S00?oFe/075/1000095/00omKP@0HF`03PE]K00:145/00h5KF`0:F`03
omko00?o00>Ogil00_l01]nOgioOo`BO00Cogooo0ml00ioOo`03W`07oioOWmnOo`03W`05oa7ooaL0
1Ol015oo7el3o`8G00Go4A4Ao`055`05oelOGol00al02OmO7eoo7elOG`02o`@S00?o8b<00R<3o`03
8ooo00<S00?o8b<00R<3o`038ooo00<S00?o8b<00R<6o`<S00?oFe/06e/1000095/00omKP@0HF`03
PE]K009K0h4=F`03PE]K00UK00?og_l00ol3g`04omoNo`GO00?ogml00ol019oogol4g`0<omoOgooO
WmnOoioO0ol01Q5OGemKG`?o00=Oool01Q402_lG5aOoGaMO5ol3G`03oemO00;o11l01?lO7ol37`;o
0R<2o`087eooGamO7el2o`8S0_l38`03ob<S008S0_l28`;o0b<00olS8`028`;o0R<00omKF`0JF`40
000TF`03oe^101QK00>1Fe/01E/2P@]K00>1Fe/00U/6o`;N0_l3g`03oioo00CO00GogioOW`06o`CO
00GoWmnOo`04W`04oioOW`?o00JOoaLGoel2o`8A00LG4AOo4ALA00@G00Go4A4Ao`045`05oelOGal0
0_l02elOoamO7omOoelO009O00[oGamOoamO7eoo0Ql00olOo`047`03ob<S008S0_l38`05ob<S8ol0
12<2o`<S00Go8b<So`0KF`40000SF`04oe]KPAQK00>1Fe/01e/3P@QK00>1ool00ol01]kOoooOgP?o
1=l02OoOg]oNgmkog`02o`GO00?ogml00]l00ooOg`02g`06omoOgonO0_l02MnOgolA5a4Go`034@05
oa4A4Ol00a401OlA4A7o00@G00Co5elG1_l011mO7ol27`?o01POoelOGaoo7elOoamO7olOoamO7olO
Gal3o`@S00Co8b<S1_l38`03ob<S008S1_lIF`40000SF`04oe]KPAQK00>1Fe/02U/2P@9K1Ol0177N
ool2g`04omkNgP;o0]l2o`;N00?ogml01Ml02_oOgmoog]oNgol4g`06omnOgioo0Yl3o`>O00Ko5aLG
oil54@09oa4G4OlG4AOo00<G00Ko4A4AoaL2o`095a7oGaOo7elO00?o00HGGaOoGol3G`08oamO7eoo
7el2o`0<7elOGaoo7omO7elO0_l28`;o0b<01?lS8b<2o`8S0_l38`03ob<S008S00?oFe/05U/10000
8e/2o`03Fh5K01IK00>1Fe/03E/00h7oo`02L@03omkN00[o00CNgmko1=l03OoNgmkOg]oogmkOg_l0
0ml00ooOg`02g`03omoO00;O00CogonO1Ol0117o4Ol3W`@A00Go4A4Ao`034@05oa4A4Ol00aL2o`09
5olGoalG7olO00;o0Ul01?lO5ol2G`0@oamO7eooGamOoeoo5alG7`;o00=O7ol01Al2o`@S0_l28`;o
0b<01?lS8b<2o`8S0_l38`03oe]K01EK0@0002=K00CoFe^15e/00h5KF`0=F`;o00GNLOmagP03o`09
g]oNomoNgmko00?O00?og]h00]h00ooOg`02g`0<omoOg]oNomoNgmko0ml01OoOWmnO00Co00?Oool0
11L00onOW`02W`0>oa4A4OlA5a7o5a4G4Ol25`04oa4Ao`@A00Go7omO5`02o`0<GamO7eooGolOGaoo
0el01?mO7el2o`045elGG`;o0al02?lOGamOoamO0_l38`03ob<S008S0_l28`;o0R<01OlS8b?o00@S
00?oPH400X4BF`40000SF`04oe]KPAMK00>1Fe/035/00onEo`02L@03omko00;o00CNgmko0]h02MoN
gooOg]oNo`03g`0<omoNgooOg_oNgmko1=l00ooOg`02g`04omoOo`CO00So4A7o4OnOo`BO00?o4A40
0Q401OlA4A7o00<A00Co4A4A0_l02QLA5olOGaoo5ol3G`03oemO009O00?oGel00Ul01_mO7eooG`;o
00UOoalG7omO5ol00el01_lO7olOG`8S00?o8b<00R<2o`<S00Go8b<So`038`Ko0X4GF`40000SF`04
oe]KPAMK00>1Fe/02U/2o`08UMcogW7oLOl2gP03omko00?N00GogmkOo`04g`07omkog_oOo`03gP0:
omkOg]oog]oNo`CO00KoWooOoil2o`<A0_l01=nOgol4W`0<oa4A4OlG4AOo4ALA1Ol01a5OGeoo7el0
0ol5G`;o0el01OlOGamO00Go00/OGamOoeoo7elOo`037`04oeoo7`8S1Ol38`03ob<S008S1_l2PAiK
0@0002=K00CoFe^15e/00h5KF`09F`05omcog?l00W400ooNo`02g`?o1=h02_oNgmkog]oNgmh5o`0:
g_oOg]oogmkOo`CO00CogmoO0_l01mnOgonOoa400_l01]oogioOo`BO00Go4A4Ao`034@04oa4Ao`BO
0_l00amO7`03o`0>Gooo4OlG4ALA5a7o7el2o`0:7elOGomO7elOo`9O00KoGaMO5ol2G`Go0b<00olS
8`028`03ob<S00;o0h4UF`40000SF`03oe^101QK00>1Fe/025/02?o/k?nEog7N0_l01W7oog7No`GN
00Cog]oo1=l01OoOg]oo00;N00oog]kNomoNgmkogmkOoml00_l4g`03oilA00;o19l01OnOgioo00>O
00?o4A400Q401?lA5a42o`04WmnOo`8G00goGooo4AOoWa4G4AOo00DG00?o5ol00el2o`9O0_l3G`03
oemO009O00?o7el00_l00b?o8`028`;o0R<2o`>10e/00h5KF`0VF`40000SF`03oe^101QK00>1Fe/0
0e/5o`;L00CoUMco0W42o`07LOoNLMiao`04gP0IomoNgooOg_oNgmkog]oNomoNgooOg]oNo`03g`;o
00OOomnOgonO00;o00?Ooml00ml01OnOgioo00BO00?o4Ol01_l00iooW`02o`0:5a7ooaOo5olAW`@A
00Wo4ALA5olG4AL00_l01a7oGaMO5el00_l01elOoolOGol00Ql2o`8S0_l2P@]K00>1Fe/09U/10000
8e/00omKP@0HF`03PE]K00=K00Gog>cLo`02k005omcogW400_l2L@06omiagW7o1=h02?oNgmkogooO
0ol5gP0:omkNg_oNgmkog`;o0]l01?oOoml3o`05WmnOgol00il01_nOgioOo`:O0ol4W`03oinO00:O
01;o5olGoa4G4AOoWa6O4OlA5ol45`05oaLG5ol00aL01_mO5elGo`=O00Ko7eoo7el2PA9K00>1Fe/0
9U/100008e/00omKP@0HF`03PE]K009K0_l01=c/g?l2g003oiGo009a0_l02MeagOmagW7No`04gP04
omkOgP?o00magooOg]oNgooNgmkog]l00ol2g`03omkO00Co00?Ooml00ml00ooOg`02g`07omnOgonO
o`04g`;o00<Agol00_l44@03oa4A00;o00NOoilAWa7o00<A00Ko5a7o4AL24@0>oa4A4OlGGaOoGolO
Gal2o`037omK01AK00>1Fe/09U/100008e/2o`03PE]K01IK00B1Fe]K0_l01>cLk?l2k007g_oLomia
o`04L@07og7NLMiao`03gP04omoNo`CN00?og_l01=h01?oNg]h3o`05gooOg]l00ol2g`0:omkOg_oO
WmnOo`>O00CogioO0_l3W`05oinOWol00a401_lG5aOo4@:O01KoWinOoa6O4Ioo5a7o5olGWolA5a7o
0aL01_lGGomOo`9O0olGF`03PE]K02IK0@000003FomK00AK00CoFe]K0_l00e_oF`0CF`03oe^101QK
00Z1Fe_ok?o/g>co0m`2o`9a0ol02]eagOmagW7NLOl3gP0ComkoLMmagooNLMkogmkOomkOo`02g`04
g]oog`;o00KNomkOg_l4g`03omoO00;O00Gogmoog`02o`?O0Yl01OnOgioo00<A00[o4A7o4IoOWmoo
0Yl01_lAWa6Oo`8A00Ko5onO4Ol34@06oa4A4OmO0_l2G`;o6e/00h5KF`0UF`4000000e_oF`04F`05
oe]KFol05e/00omKP@0HF`0:PE]Komcok=c/o`;/00SoUOmag_nEo`Aa00KogW7NLMh7o`;N00?og]h0
0]h00ooNgP02gP;o00?Ngml00ml2o`03gmkO00CO00[ogmkOg_oOWmoo0Yl2o`03gioo00GO00CoWioo
1142o`034OnO00>O00_oWinOoilAWolG4@02o`08Wa6O4OlG4Ol35`07oaOoGolOo`0LF`03PE]K02EK
0@000003FomK00AK00GoFe]Ko`0GF`03oe^101QK00^1Fe_ok?o/g>cog002o`0Cg?maLOoLUOmagG7o
gW7NLMkoL@02o`=a0_l02MiagW7NLOoNg`02o`;N00GogmkOgP02o`08gmkOomoNgol5g`Wo00@Aga7o
19l9o`:O00KogioOWol2W`05oilAWa400ol01YlAWa6Oo`8A00Co4A4A0ol00amOo`0MF`03PE]K02EK
0@000003FomK00AK00GoFe]Ko`0FF`04oe]KPAQK00Z1Foo/g?o/g>co0^`2o`07gW7og9GLo`03L@0:
omiagW7ogIGMU@;o00CNLMia0_l4gP;o00EagW7No`03g`;o00GNomkOo`03g`07omoNgmkOo`02gP04
Wmooo`>O00?oWil00_l4W`0;oiooWmnOgonOgol00il01_nOWonO4@Co00ZOoilAWa7o5a7o0QL00olG
o`0QF`03PE]K02EK0@000003Fooo00Go0e/00omKF`0DF`04oe]KPAQK00V1Foo/omc/g?l00m`2o`0G
LOoLUMbEog7MLOoNLMiaoiEaUG7oLID00_l3L@?o00AaUG7o1=h00ooNg`02o`09g_oNgmkog]oo00CO
00CogmoO0_l02a7OoolAga7o4MlA00;o00WO4OoOWmnOgol00Yl;o`0;WooO4MooWa6O4Ol00Q42o`03
GomK025K00>1Fe/09E/1000000=Koe/015/01OmKFe_o01IK00CoFe^165/0385Koncog>cLoncok0?o
00OLombEg9Go00=a00ooLMkoUMfEgOoMLMgLog400ol03=koLMeaomiagW7og`;o00Mag_oNgmko00?O
00Gog]oNo`02gP>O00?oWil00Yl00onOW`02o`05WmnOgol00il2o`04giooo`>O00CoWinO0_l2W`03
oinO00:O00?o4Ol01_l00aOoF`0RF`03PE]K02EK0@000003FomK00AK00?oFe/00olEF`04oe]KPAQK
00V1]_o/omc/g?l00]`3o`;/01CoUMbEg?oMLMgoLMkoLIEaUOnEL@;o1G401_nELIEao`CN00Cog_oo
0]h02OoNgmkog]oNo`02g`03omoO00GO0_l03=nOoioOomnOgioOW`;o00OO4Mooga7O00;o00lAgooo
WonOgioo4MlAga400_l00aLAo`04o`03PE]K025K00>1Fe/09E/1000000=Koe/025/00omKF`0DF`04
oe]KPAQK00V1omc/omc/g?l00^`2o`09g>cLombEg9Go00=a00coLOoMUMfEog7Mg=d4L@0<g9GogG7M
LMgoLMia0_l02]ooLMiaomoNgol2g`05omkOomh00ml05OoOgooOWmnOoioOoioOWooOWmnOo`02W`;o
00kOoioOWonOgiooWmnOo`>O00CoWa7o1U/00h5KF`0QF`03PE]K02EK0@000003Fooo00Go0e/00omK
F`0DF`;o00=KPE/05e/02KGok>cog>cLo`02g0;o0n`02_nEg9GLUOmagG42o`05UG6EoiD00ol2L@03
UOoL00;L00OoUG6ELIGo00;N0_l00moogP03gP08omoNgooOg_l2g`07oioOWooNo`02g`0@omnOgioo
WmoogooOWmnOo`?O01KogmoOoioOWonOgiooWmnOoa7oga7o1e/00h5KF`0QF`03PE]K02EK0@00029K
00CoFe^165/02;Kog?o/g>co0n`2o`09g>cLombEg9GL00Oo00>EgOl00_l01=bEgID2o`0IUMbEg?ma
gG7Mog7ogooOomiagW7ogmkOo`02g`07omkog_oOo`02gP0;omoOgooOWmoogil00_l01mnOgioog_l0
0mh03_oOgmooWmnOoioOomnO0ol;F`03PE]K025K00>1Fe/09E/100008U/01?mKFh4HF`08onc/oncL
k?l2g0?o0n`03OnEg9GLUOoLk=c/g>`00_l02>cLk=aaUG7o1M`01_maUG6EL@;o00CNgooo1=h02?oO
g]oNomkO0ol01]kog]oNo`CO1_l01]kOg_nOo`?N00Cogmoo0ml00ooOW`07o`iK00>1Fe/08E/00h5K
F`0UF`40000RF`04oe]KPAMK00VfoncLoncLk?l00^`3o`0Ug>cLombEg9GLomc/g>cLk=cok=c/gIGM
oncLombEg?magG7ML@05o`08LMiagW7Nomh6o`04g]oNo`CN00KogmoOomh2o`?O00Wogmoog]oNgol0
0]h00ooOg`02g`;o00?Oool04U/00h5KF`0QF`03PE]K02EK0@00029K00?oFh4065/02kKok>cok=c/
oiGL00?o0n`06OnEg9GLokGok=c/g>cLoncLk9Eaomc/g?l00m`01OmaUG6E00?o1G42o`;N0_l2gP03
omkN00GN00GogmkOo`02g`03omoO00;O0_l9gP05omoOgol00ml00ooNo`0DF`03PE]K025K00>1Fe/0
9E/100008U/00omKP@0HF`09]_o/g?o/g>co00;/01Ko]ooLk=cog9GLUOoloncLk=c/omc/0]`04?nE
omc/g>coUMcoLMeagOl2U@03og5a009a00GoLG5ao`02gP0:omkOg]oogmkOo`?N00?ogol00mh00ooN
gP04gP07gmkNgmkOo`03gP06omoOomko5E/00h5KF`0QF`03PE]K02EK0@00029K00?oFh405e/02KGo
k>cog>cLo`03g003okOo00C/01Wog9GLokGok=c/g>cog>cLk=cok=c/g>co00?L00GoUG6Eo`03g004
og5ao`=a00Oog]kNomko00;N00kog]kNomoNgmkogooOo`9a00Gog]kNo`02gP03omkN00;N00Sogmoo
gooNoaIK00>1Fe/08E/00h5KF`0UF`40000RF`03oe^101MK00^fomc/omc/g?nEk002o`0E]ooLk=c/
oiGLUOoloncLk=c/omc/00;L00o/oncLk=c/oiGLUOoMLOl019D01omaog7LLOl01=h02ooNomkOg_oN
gmko00?N00Wog]kogW7NLOl00]h02OoOg_oOg]oNo`03gP;o00>Ooe/05E/00h5KF`0QF`03PE]K02EK
0@00019K1?l3F`Co1E/00omKP@0FF`03][Go00;/00Gog>cLo`02g0;o00>g]_l00n`04OoLUMco]Oo/
g>cLk?oLk=c/00;o00K/g>cLk?l3g004oiEao`GL00Cog9GL0_l3gP05og7NLOl00]h02?oNg]kog]oo
0]h00iEaL@03L@05omkNg_l00]h01OoNg]ko00?O0olGF`03PE]K025K00>1Fe/09E/100004E/00omK
F`02F`03oe_o00AK00CoFe]K184FF`:f00S/g>cog>cLo`;/01Ko][NfoncLk?nEg?neo;Gog>cLk?oL
0^`04=co]_oLk=c/g?oLUOoMLOl5U@03ombE00;o00G/omkNo`03gP0:omoNomkOg_oNo`;N00REgOoN
LMiao`?N00Sog]oog]oNo`;N0_lIF`03PE]K025K00>1Fe/09E/100005U/00omKo`04F`05oe]KFol0
0U/3PAAK00>fon`00^`01OoLk=co00;L00Go][Nfo`03k00JombEoobeo?oLk=cok=c/g>coo?oLk=c/
g?l2g004oiGoo`GL00Oog9Gog>co00;N00GoLMiao`03gP04omkNgP;o00Iaog6ELOl4L@04omkNo`;N
00?og]h00]h3oaYK00>1Fe/08E/00h5KF`0UF`40000FF`03oe_o00AK00GoFe]Ko`02F`03PE]K00B1
3e/2]P08oncLoncLk?l3k00EokJg]_o/g>coUMco]Obeomc/g?o/00;L00k/okJfomc/g>cLombEg0?o
19D02?nEg9Gog>cL0_l5gPSo0W402_nEgIGoLMiag_l3gP03omoo00Ko6e/00h5KF`0QF`03PE]K02EK
0@00015K00?oFe/00U/00omKo`04F`05oe]KFol00U/00h5KF`04F`B12e/00kFfk002k005oncLk?l0
0]`01_ng][Nfo`?/017og9Goo;Glomc/g?o/oncLo`02o008omc/g>cLk?l2g0?o1=`07_nEg=cog>cL
k?oNLMkog9GLUOoMLMeagOoLLIEao`Aa00Cog]kN0_l01=oNgolNF`03PE]K029K00>1Fe/095/10000
4E/5o`9K00?oFe/00U/01OmKFe_o009K00>1Fe/025/3P@MK0[H02OoLk=cok=c/o`02k00IokNf]kKo
k=c/oiGoo;Gl]OoLk=cok?oLo`03]P07omc/g>cLk004o`;L01?oUIFEoiGLUOoLk=c/ol`=oiGL00BE
00?oLG400W402oo/omfEog7NLMko00;N00Kog_oOg_lOF`03PE]K029K00>1Fe/095/100004E/00omK
F`04F`03oe]K009K00GoFe]Ko`02F`03PE]K00]K1843F`03][Go00?/00Cok=c/0]`01onf]kJg]_l0
0n`04?oLokGl]Obeoncog;Ook?l4o009oncLk=c/onco00?/00Kog=cLoiD2g006omc/g>co0Pd04_oL
g=coUMcoLMeagOoLoiEao`Ea0_l2gP03omoo021K00>1Fe/08U/00h5KF`0TF`40000BF`03oe]K00=K
00?oFe/00U/01OmKFe_o009K00>1Fe/03e/3P@:f00?/g>`00]`04>cLk>co]Ong][NfoncLk=`2o`0;
o;Gl]Ocok?oL]kH00_l4]P09oncLk=cok;Oo00?L01GoUIGog?oLoncLk=c/ol`=oiGLUOl00iD03oma
LOoLk?oMUMgogW7NL@02o`05gmkogol085/00h5KF`0RF`03PE]K02AK0@00019K1Ol2F`Co15/01?mK
Fh4CF`03]KJe00?/00Cog>cL0_l020fe3Onf]kKo1>`2o`08]Obeo;Gok?l3]`03oocl00?l00[ok=c/
g?ngk;Oo0^`01?oLg?l3g006oncLk=co0`d2o`?L00kog9GogG7ok=coUG6Eo`Aa00?og_l00ol00h5K
F`0OF`03PE]K025K00>1Fe/095/100008E/01?mKFh4CF`:f00?ok?l01_l03KD=]@go][Nf]ooLk=`0
0_l01obeo;Glon`00ol00`go]P04]P0:oncLk=cok;O/o`?L00ooUOoLUMcok=c/g?l=c0d00_l01=bE
g?l2U@0Bog5aomc/g?nEgOoNLMkoLMko0e/00h5KF`0OF`03PE]K025K00>1Fe/095/100008E/2o`03
Fh5K00mK2ol03KJgokD=]@feokNf]ol00n`02Ool]Obeo;Gok002o`>e00?oo?`00o`02OoLk?o/]nbg
o`03k003omco00?L00Kok=c/g?l33@;o0m`03_oLUMcoLOo/g>coLIGo0W401?oNg_l4F`03PE]K01mK
00>1Fe/08E/00h5KF`0TF`40000QF`04oe]KP@]K1Ol010g<3L`2o`D=0_l030fe3KD=]Ong][Oog0?o
00jeo;Gl]Obeo`feo`feo`Ff00Wog>co]nbgk?l00m`03onEombEg?o/g>cLo`g<3@02o`05g9GLUOl0
0YD2o`0=k=c/g?nEgOoNLOoNo`06F`03PE]K01iK00>1Fe/08E/00h5KF`0TF`40000QF`03oe^1011K
00?o3@d00_l01<`=c0d2o`@=00Ko3KD=]@d5o`@=0_l01KGl]Oco00:e00Go]KFeo`04o003omc/00;o
00Fgk;O/o`03k0;o0]`01ooLk=c/g?l00`d2o`CL1Ol02=c/g>coLIEa0_l00g7oo`06F`03PE]K01iK
00>1Fe/08E/00h5KF`0TF`40000QF`03oe^101=K0ol03<coc0g<ol`=c0go]@;o00k<3L`=c0go3L`=
c0go]@;o00Re3KD=okD=o`Bf00?og?l00[H00ongk008o`0MUOoLk=c/ol`=c0goCOnEg9Go]nbgoncL
k=coUMd01Ol7F`03PE]K01iK00>1Fe/08E/00h5KF`0TF`40000QF`03oe^101IK00Soc0g<3L`=o`<=
00So3L`=c0g<o`<=00Wo3@go3Ol=]Ol00kD01One]KGo00?l00?og?l01_l01ncooool]_`00_l01Mc/
g>co00<=00CoC4co0]`2o`09k;O/]oo/g>cL00?o2e/00h5KF`0NF`03PE]K025K00>1Fe/03e/6P@mK
0@00025K00?oFh406E/2o`033L`=00;o00T=c0g<3Oo<3L`01_l03[Go3KD=o`fe3One3KGo1;H2o`04
o;Koo`:f0ol05?bfo;Klomc/g>coc0g<oda=oiGL0ol02>bgk?oLk=c/0_l<F`03PE]K01iK00>1Fe/0
8E/00h5KF`04F`^15E/1000085/01?mKFh4IF`03PE]K009K00?o3@d00ol43@;o00<=ool00ol01Pfe
3KD=o`>e00?o]KD01_l01KFf]KKo00:e0_l01Obfo;Kl00;o00GLk=c/o`033@04oda<o`;L00_oo?ng
k;Ook=c/g002o`aK00>1Fe/07U/00h5KF`0NF`Z185/1000085/01?mKFh4HF`03PE]K00MK0_l01Pg<
ol`=c0Co03;<3L`=]@feokD=]Ol=okKlo`goo;Kl]_ne3KD=okKl]_bfokGok=c/ol`=c?m<COnEo`:f
00_ok>c/]oo/g?oMo`0<F`03PE]K01iK00>1Fe/04e/;P@=K00>1Fe/095/1000085/01?mKFh4HF`03
PE]K00YK0ol23@;o00X=c0g<3Lco]@go0[D3o`0;][FfokD=okFf]Ol00kD03_l=okKl]_co]Oo/g>co
0`d01?m<C4`2o`?l00Wok?o/omcogOl03E/00h5KF`0NF`03PE]K00UK2X4>F`03PE]K02AK0@00021K
0_l00e^1F`0GF`03PE]K00eK0_l010g<3L`2o`03c0g<00Go0Pd01?ol]_l33@0MokKl]_ne3KGo3Ool
]_co3KGok=co3L`=c?m<CD`00_l3]P06okO/g?o/0ol=F`03PE]K01iK384HF`03PE]K02AK0@00021K
00CoFe^165/00h5KF`0@F`Co00>e3Ol00kD04?l=]@feokJeo`fe3One]_l3]@0>okD=okKl]_l=]Oo/
g?l43@05oda<C?l01?`01?o/]n`2o`03g?oo00eK00>1Fe/05E/:PB=K00>1Fe/095/1000085/01?mK
Fh4HF`03PE]K01=K00>1ool00_l00`feo`053@03okKo00@=00Ooo?l=]@go00<=01?o]_co3KD=omco
3L`=c?m<CDco00Ff0ol01=bEg?l>F`03PE]K00YK2h49F`03PE]K025K00>1Fe/095/1000085/01?mK
Fh4HF`03PE]K01=K00>1Fe/00U/2o`06]@fe3KD=0_l02;D=]@feokKo0[D03ol=]@feooco]@fe3OoL
o`043@05oda<C?l01O`01_nd]?oLo`mK00>1Fe/02X4DF`03PE]K025K00>1Fe/095/1000085/01?mK
Fh4HF`03PE]K01=K00>1Fe/01U/2o`<=00?o3@d010d3o`03]Ol=00<=01;o]_ne3KD=omco3L`=c?m<
CD`2o`Bf00?o];@00_l8F`^17U/00h5KF`0QF`03PE]K02AK0@00021K00CoFe^165/00h5KF`0CF`03
PE]K00YK0_l23@;o1@d01one3KD=]@d00_l01;D=]@d2o`D=00CoC4a<0_l3o005okBd]?l02H48F`03
PE]K01iK00>1Fe/08U/00h5KF`0SF`40000PF`04oe]KPAQK00>1Fe/04e/00h5KF`0>F`;o00S<oooo
c0g<3@;o0Pd04Ol=]@fe3KGoc0g<3LcoC4e<00;o0kH01Ond];Co015K00>1Fe/07U/00h5KF`0RF`03
PE]K02=K0@00021K00CoFe^165/00h5KF`0CF`03PE]K00mK00KoaTc6C<H3o`07COo6C<I<aP02o`03
3KGo00D=00OoC4a<odgo00;l00Go];Bdo`0AF`03PE]K01iK00>1Fe/08U/00h5KF`0SF`40000PF`04
oe]KPAQK00>1Fe/04e/00h5KF`0?F`03ohb<00B<00CoCFKo1X`03Om=I_o<3L`=c?m<COl00VH00onf
o`04]003oe]K00mK00>1Fe/07U/00h5KF`0RF`03PE]K02=K0@00021K0_l00h5KF`0GF`03PE]K01=K
00>1Fe/03e/05Oo6C<I<aTcoITgoaTc6C<I<ofI=o`053@04oda<o`9=00?oo?l01;@00omKF`0?F`03
PE]K01iK00>1Fe/08U/00h5KF`0SF`40000PF`03oe^101UK00>1Fe/04e/00h5KF`0?F`03ohb<00B<
00CoCFKo1X`03Om=I_o<3L`=c?m<COl00fH2o`Bd00?oFe/03e/00h5KF`0NF`03PE]K029K00>1Fe/0
8e/1000085/00omKP@0IF`03PE]K01=K00>1Fe/03e/05Oo6C<I<aTcoITgoaTc6C<I<ofI=o`043@05
oda<C?l00dd2o`Bd00?oFe/03e/00h5KF`0NF`03PE]K029K00>1Fe/08e/100007e/01?mKFh4IF`03
PE]K01=K00>1Fe/03e/00on<S003S0;o00==I_l01X`03Om=I_o<3L`=ode<COl00fH2o`Bd00?oFe/0
3e/00h5KF`0NF`03PE]K029K00>1Fe/08e/100007e/01?mKFh4IF`03PE]K01=K00>1Fe/03e/01_o6
C<I<aP;o00QVCOo6C<I<aP;o00=VCOl010d01Om<C4co00==0_l4]003oe]K00mK00>1Fe/07U/00h5K
F`0RF`03PE]K02=K0@0001mK00CoFe^16E/00h5KF`0CF`03PE]K00mK00?oS8`00h`2o`04CFI=o`B<
0_l034eVol`=c0goCDa=o`=V0_l3]003oe]K011K00>1Fe/07U/00h5KF`0RF`03PE]K02=K0@0001mK
00CoFe^16E/00h5KF`0CF`03PE]K00mK00KoaTc6C<H2o`08ITeVodc6C<H2o`04ITeVo`<=00GoC4a<
o`03C@;o0k@00omKF`0@F`03PE]K01iK00>1Fe/08U/00h5KF`0SF`40000OF`04oe]KPAUK00>1Fe/0
4e/00h5KF`0?F`03ohb<00><0_l014eVCOl4S0;o00a=ITgo3L`=ode<COl3IP;o0k@00omKF`0@F`03
PE]K01iK00>1Fe/08U/00h5KF`0SF`40000OF`04oe]KPAUK00>1Fe/04e/00h5KF`0?F`06olI<aTc6
0_l026I=I_m<aTc60_l016I=I_l33@05oda<C?l00Td00om<o`03]003oe]K011K00>1Fe/07U/00h5K
F`0RF`03PE]K02=K0@0001mK00CoFe^16E/00h5KF`0BF`03PE]K015K00?oS8`00X`2o`04CFI=o`B<
0_l034eVCOl=c0goCDa=o`9V00?oC?l00k@00omKF`0@F`03PE]K01iK00>1Fe/08U/00h5KF`0SF`40
000OF`;o00=KPE/065/00h5KF`0BF`03PE]K015K01GoC<I<a_loodeVodc6C<Ko?om=I_l00`d01Om<
C4co009=00?oC?l00k@00omKF`0@F`03PE]K01iK00>1Fe/08U/00h5KF`0SF`40000OF`04oe]KPAQK
00>1Fe/04e/00h5KF`0AF`03ohb<00:<00Ko?omVCOl4S00>ocooITgo3L`=ode<COl2IP03odco00>d
00?oFe/045/00h5KF`0NF`03PE]K029K00>1Fe/08e/100007e/01?mKFh4HF`03PE]K01=K00>1Fe/0
4E/01Om<aTco008o00koCFKoC<I<a_loodeVo`<=00CoC4co0dd00om<o`03]003oe]K011K00>1Fe/0
7U/00h5KF`0RF`03PE]K02=K0@0001mK00CoFe^165/00h5KF`0CF`03PE]K015K00_oS8b<odloofI=
o`04S00=ocooITgo3L`=ode<o`03IP03odco00>d00?oFe/045/00h5KF`0NF`03PE]K029K00>1Fe/0
8e/100007e/01?mKFh4HF`03PE]K01=K00>1Fe/04E/01Om<aTco008o00koCFKoC<I<a_loodeVo`<=
00CoC4co0dd00om<o`03]003oe]K011K00>1Fe/07U/00h5KF`0RF`03PE]K02=K0@0001mK00CoFe^1
65/00h5KF`0CF`03PE]K015K00_oS8b<odloofI=o`03S00>odloofI=o`g<3Om=C?l3IP04oda=o`:d
00?oFe/045/00h5KF`0NF`03PE]K029K00>1Fe/08e/100007e/00omKP@0IF`03PE]K01=K00>1Fe/0
4E/01Om<aTco008o00SoCFKoC<I<o`8o00CoCFKo0`d01?m<C?l3C@04oda<o`:d00?oFe/045/00h5K
F`0NF`03PE]K02=K00>1Fe/08U/100007e/00omKP@0IF`03PE]K01=K00>1Fe/04E/02on<S8coCcoo
ITgo00><00koCcooITgo3L`=ode<o`=V00CoC4go0[@00omKF`0@F`03PE]K01iK00>1Fe/08e/00h5K
F`0RF`40000:F`03oe]K009K1?l2F`Co1E/01?mKFh4IF`03PE]K01=K00>1Fe/04E/01Om<aTco008o
00SoCFKoC<I<o`8o00CoCFKo0`d01?m<C?l2C@05oda<C?l00[@00omKF`0@F`03PE]K01iK00>1Fe/0
8e/00h5KF`0RF`40000:F`05oe]KFol015/2o`AK00?oFe/00U/4PAUK00>1Fe/04e/00h5KF`0AF`0;
ohb<S?m??omVCOl00h`03_m??omVCOl=c?m<CDco0VH2o`03C4go00:d00?oFe/045/00h5KF`0NF`03
PE]K02=K00>1Fe/08U/100002U/01OmKFe_o00AK0_l4F`03oe]K009K00?oFe/0284BF`03PE]K01=K
00>1Fe/04E/01Om<aTco008o00SoCFI=olI<o`8o00CoCFKo0Pd01Om<C4co009=0_l2C004okBdoa9K
00>1Fe/07U/00h5KF`0SF`03PE]K029K0@0000YK00GoFe]Ko`04F`;o15/00omKF`02F`04oe]KP@MK
1X4<F`03PE]K01=K00>1Fe/04E/03?n<S?loCcooITeVo`:<00koCcooITeVolcoC4e<o`9V0_l01Da=
okCo01=K00>1Fe/07U/00h5KF`0SF`03PE]K029K0@0000YK00GoFe]Ko`04F`;o15/00omKF`02F`04
oe]KP@eK1h45F`03PE]K01=K00>1Fe/04E/01?m<a_l3?`08odeVCOo6C?l2?`07odeVCOl=o`03C003
ode=00;o0T`00ondo`0CF`03PE]K01iK00>1Fe/08e/00h5KF`0RF`40000:F`05oe]KFol015/2o`AK
00?oFe/00U/01?mKFh4DF`N155/00h5KF`0AF`0<ohb<ocm??omVCFKo0X`03_m??omVCFKoc?m<CDco
0VH2o`05C4go]?l04e/00h5KF`0NF`03PE]K02=K00>1Fe/08U/1000025/3o`=K00?oFe/00U/2o`AK
00?oFe/00U/01?mKFh4IF`03PE^100F13U/00h5KF`0AF`04odc6o`<o00SoCFI=olI<o`8o00OoCFI=
o`go00=<00?oCDd00_l2C003okCo01=K00>1Fe/07U/00h5KF`0SF`03PE]K029K0@0000YK00GoFe]K
o`04F`;o15/00omKF`02F`04oe]KPAUK00>1Fe/01E/7P@MK00>1Fe/04E/03?n<S?loCcooITeVo`:<
00goCcooITeVolcoC4go00=V0_l01Da=okCo01=K00>1Fe/07e/00h5KF`0RF`03PE]K029K0@0000YK
00?oFe/00U/4o`9K1?l5F`04oe]KPAUK00>1Fe/035/6P@03Fh5K019K00CoC<Ko0cl01om=ITgoa_l0
0cl01om=ITgo3Ol00T`01?m=CDd2o`9<00?o]?l04e/00h5KF`0OF`03PE]K029K00>1Fe/08U/10000
7U/01?mKFh4IF`03PE]K019K1h4>F`0Kohb<ocm??omVCFKoS?loCcooITeVolcoC4go00=V0_l01Da=
okCo01=K00>1Fe/07e/00h5KF`0RF`03PE]K00UK384=F`40000NF`04oe]KPAUK00>1Fe/04e/00h5K
F`03F`J125/01?m<a_l3?`07odeVCOo6o`03?`07odeVCOl=o`02C004ode=C@;o0T`00ondo`0CF`03
PE]K01mK00>1Fe/06E/EPAUK0@0001iK0_l00e^1F`0HF`03PE]K01=K00>1Fe/02E/7P@0LFon<S?lo
CcooITeVohco?dloofI=I_o<oda=o`9V00So?om<COndoa=K00>1Fe/07e/00h5KF`03FaJ12E/00h5K
F`0RF`40000NF`04oe]KPAUK00>1Fe/04e/00h5KF`0@F`04POm<o`@o00OoCFI=olKo00<o00OoCFI=
o`go009<00KoCDgoCol2C003okCo01=K00>1Fe/045/EPAmK00>1Fe/08U/100007U/01?mKFh4IF`03
PE]K01=K00>1Fe/045/0787oS?m??dloofI=I_n<ocm??omVCFKoc?m<COl2IP08ocooC4go]?l@FaJ1
3e/00h5KF`0RF`03PE]K029K0@0001iK00?oFh406E/00h5KF`0DF`03PE]K011K00B1Fooo1Cl01_mV
COo6o`@o00KoITgo3Ol2C006ode=odoo0T`00ondo`0@P@=K00>1Fe/07e/00h5KF`0RF`03PE]K029K
0@0001eK00CoFe^16E/00h5KF`0CF`03PE]K015K01b1FoooCcm??dooCFKoS?loCcm?odeVolcoC4go
0VH02?looda=okCo4e/00h5KF`0OF`03PE]K029K00>1Fe/08U/100007E/01?mKFh4IF`03PE]K01=K
00>1Fe/04E/0185Kool5?`06ofI=olKo13l01_mVCOl=o`9<00KoCDgoCol2C003okCo01=K00>1Fe/0
7e/00h5KF`0RF`03PE]K029K0@0001eK00CoFe^16E/00h5KF`0CF`03PE]K015K00f1FoooCcm??doo
CFI=00;o00LoCcm?odeV00;o00A=C4go0VH01_looda=C0;o4e/00h5KF`0OF`03PE]K029K00>1Fe/0
8U/100007E/01?mKFh4IF`03PE]K01=K00>1Fe/04E/0185Kool5?`04ofI=IP;o13l01OmVCFKo00=<
00CoCDgo0Tl00om<C002oa=K00>1Fe/07e/00h5KF`0SF`03PE]K025K0@0001eK00CoFe^16E/00h5K
F`0CF`03PE]K015K01b1FoooCcm??dooCFI=odloCcm?odeVCOm=C4go0VH01oloCom=C?l055/00h5K
F`0OF`03PE]K02=K00>1Fe/08E/100007E/01?mKFh4IF`03PE]K01=K00>1Fe/04E/0185Kool5?`05
ofI=I_l01Cl01OmVCFKo009<00GoCDe=o`02C`04oda<oaAK00>1Fe/07e/00h5KF`0SF`03PE]K025K
0@0001eK0_l00e^1F`0HF`03PE]K01=K00>1Fe/04E/06h5Kocm??dloCom=ITgoCcm??dooCFI=ode<
o`02IP08odloCom=C?lDF`03PE]K01mK00>1Fe/08e/00h5KF`0QF`40000jF`03PE]K01=K00>1Fe/0
4E/00h5Ko`06?`05ofI=I_l01Cl01OmVCFKo009<00CoCDgo0dl01?m<C?lDF`03PE]K01mK00>1Fe/0
8e/00h5KF`0QF`40000jF`03PE]K01=K00>1Fe/04E/06h5Kocm??dloCom=ITgoCcm??dooCFI=ode<
o`02IP08odloCom=C?lDF`03PE]K01mK00>1Fe/08e/00h5KF`0QF`40000jF`03PE]K01=K00>1Fe/0
4E/00h5Ko`0Ho`9=00GoCdm?o`02C003oe]K019K00>1Fe/07e/00h5KF`0SF`03PE]K025K0@00051K
00>1Fe/04E/00h5KF`06F`;o00@Soooo12<2o`038ooo008S1?l01dloCom=C?l055/00h5KF`0OF`03
PE]K02=K00>1Fe/08E/10000D5/00h5KF`0AF`03PE]K00iK00B1Fe_o0R<>oaAK00>1Fe/07e/00h5K
F`0SF`03PE]K025K0@0006AK00>1Fe/03U/00h5KF`05F`03POoo01eK00>1Fe/07e/00h5KF`0SF`03
PE]K025K0@0006AK00>1Fe/03U/00h5KF`05F`03PE]K01eK00>1Fe/07e/00h5KF`17F`40001eF`03
PE]K00EK00>1Fe/07E/00h5KF`1YF`40001eF`03PE]K00EK00>1Fe/0RE/10000oe/:F`40003oF`YK
0@000?mK2U/10000oe/:F`40003oF`YK0@000?mK2U/10000oe/:F`40003oF`YK0@000?mK2U/10000
]E/2oe9K0@000;IK0_l3F`03oe]K04]K0@000;MK0_l3F`03oe]K04YK0@0002mK1Ol3F`?o0U/2o`AK
0ol00e_oo`02o`=K1Ol5F`;o1E/2o`9K1Ol2F`;o0U/4o`=K1?l3F`Co0U/4o`=K1?l6F`;o0e/2o`03
Fooo009K1?l3F`?o0U/3o`9K0_l5F`?o0U/2o`MK1?l00e_oF`04o`9K0_l2F`;o0U/2o`MK0_l3F`Co
7U/10000;U/2o`=K0_l015_ooe/2o`03Fooo00AK0_l00e_oo`02F`;o00=Kool00U/2o`EK0_l5F`;o
0U/2o`03Fooo009K0_l00e_oo`02F`;o00=Kool00U/2o`03Fooo009K1?l2F`;o00=Kool00U/2o`EK
0_l3F`;o00AKoomK0_l2F`;o0U/2o`9K0_l015_ooe/2o`EK0ol2F`;o1U/2o`9K1Ol2F`;o00=Kool0
0U/2o`9K0_l7F`;o0U/2o`9K0_lMF`40000^F`;o0e/4o`=K1?l4F`;o00=Kool01E/2o`9K0_l5F`;o
1E/2o`9K0_l00e_oo`02F`;o00=Kool025/3o`AK1Ol8F`?o1E/2o`=K0_l00e_oo`04F`?o0U/2o`03
Fooo00=K1?l4F`;o00=Kool025/2o`AK1?l5F`;o0U/2o`QK1_l00e_oo`02F`;o7E/10000<U/5o`=K
1?l4F`;o00=Kool01?l00e_oo`02F`;o1E/2o`EK0_l2F`;o00=Kool00U/2o`03Fooo00Co0U/4o`=K
1?l00e_oo`04o`9K1?l6F`;o0e/2o`03Fooo009K1?l3F`;o00=Kool00e/4o`AK0_l00e_oo`08F`;o
15/8o`03Fooo009K0_l8F`03oe]K00;o0U/2o`9K0_lMF`40000_F`Go00=Kool00e/4o`AK0_l00e_o
o`02F`;o00=Kool00U/2o`EK1Ol2F`;o0U/2o`03Fooo009K0_l00e_oo`02F`;o00AKoooo15/3o`=K
0_l2F`;o00AKoooo25/2o`=K0_l015_ooe/3o`EK0_l00e_oo`03F`Co15/2o`03Fooo00QK0_l2F`Ko
0U/2o`03Fooo009K0_l9F`04oe_oo`9K0_l2F`;o7E/10000;U/3o`EK0_l015_ooe/3o`=K0_l00e_o
o`02F`;o00=Kool00U/2o`EK0_l5F`;o0U/2o`03Fooo009K0_l00e_oo`02F`;o00=Kool00U/2o`03
Fooo009K1?l2F`;o00=Kool00U/2o`EK1ol015_ooe/2o`9K0_l2F`;o0U/2o`04FoooF`?o0e/2o`03
Fooo00QK0_l6F`;o0U/2o`03Fooo009K0_l9F`04oe_oo`9K0_l2F`;o7E/10000;U/2o`=K0_l2F`?o
0U/3o`9K1?l00e_oo`02o`=K1Ol5F`;o1E/2o`03Fooo00Oo0e/4o`=K1?l3F`Co0U/4o`=K1?l6F`;o
0e/2o`03Fooo009K1?l2F`Co0U/3o`9K0ol2F`;o0e/2o`MK0_l4F`;o00=Kool00_l2F`Go2e/3o`9K
0_l2F`;o7E/10000;U/2o`=K0_l=F`;o35/2o`EK0_l9F`;o;U/2o`=K0_l<F`;o75/2o`9K0_lHF`?o
0U/2o`9K0_lMF`40000_F`Go3U/2o`aK0_l5F`Ko00=Kool00U/2obiK0_l3F`;o00=Kool02E/2oaeK
1?lJF`;o0e/4oaiK0@000?mK2U/10000oe/:F`40003oF`YK0@000?mK2U/10000oe/:F`400000\
\>"],
  ImageRangeCache->{{{0, 265}, {252, 0}} -> {-0.0925078, -0.0556196, 
  0.00397335, 0.00397335}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Generations 40 to 60"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Fitnesses-Gen60"],

Cell[CellGroupData[{

Cell[TextData[
"fitnessChart3D[Take[allFitnessesSorted,{41,61}],\n  DisplayGeneration -> 60,\
\n  GenIndices -> {{1,40},{11,50},{21,60}}];"], "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .95229 
MathPictureStart
%% Graphics3D
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-3.75585e-05 1.06867 0.0267167 1.06867 [
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 60)] .5 .95229 0 -1.5 Msboxa
P
[(0)] .08595 .18034 -0.06484 1 Msboxa
[(10)] .23556 .13958 -0.04346 1 Msboxa
[(20)] .40028 .0947 -0.01962 1 Msboxa
[(30)] .58253 .04506 .00711 1 Msboxa
[(Indiv.)] .35928 .03957 -0.02584 1 Msboxa
[(40)] .73432 .0488 -1 .26344 Msboxa
[(50)] .85598 .1892 -1 .21908 Msboxa
[(60)] .94747 .29479 -1 .1875 Msboxa
[(Gen.)] .91594 .16872 -1 .22094 Msboxa
[(-50)] .05685 .24303 1 -0.25833 Msboxa
[(0)] .04482 .42044 1 -0.20167 Msboxa
[(50)] .03221 .60712 1 -0.14158 Msboxa
[(100)] .01896 .80382 1 -0.07771 Msboxa
[(Fit.)] -0.0283 .53856 1 -0.16726 Msboxa
[ 0 0 0 0 ]
[ 1 .95229 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 60)] .5 .95229 0 -1.5 Mshowa
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.08509 .19367 m
.08465 .20033 L
s
P
[(0)] .08595 .18034 -0.06484 1 Mshowa
p
.002 w
.23498 .15292 m
.23469 .15959 L
s
P
[(10)] .23556 .13958 -0.04346 1 Mshowa
p
.002 w
.40002 .10806 m
.39989 .11474 L
s
P
[(20)] .40028 .0947 -0.01962 1 Mshowa
p
.002 w
.58262 .05842 m
.58267 .0651 L
s
P
[(30)] .58253 .04506 .00711 1 Mshowa
p
.001 w
.11395 .18582 m
.11371 .18982 L
s
P
p
.001 w
.14336 .17783 m
.14314 .18183 L
s
P
p
.001 w
.17332 .16968 m
.17311 .17368 L
s
P
p
.001 w
.20386 .16138 m
.20367 .16538 L
s
P
p
.001 w
.2667 .1443 m
.26655 .1483 L
s
P
p
.001 w
.29905 .1355 m
.29892 .13951 L
s
P
p
.001 w
.33204 .12654 m
.33192 .13054 L
s
P
p
.001 w
.36569 .11739 m
.36559 .1214 L
s
P
p
.001 w
.43505 .09854 m
.43499 .10254 L
s
P
p
.001 w
.4708 .08882 m
.47076 .09283 L
s
P
p
.001 w
.5073 .0789 m
.50728 .0829 L
s
P
p
.001 w
.54456 .06877 m
.54457 .07277 L
s
P
p
.001 w
.6215 .04785 m
.62155 .05186 L
s
P
p
.001 w
.66122 .03706 m
.6613 .04106 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
p
.002 w
.69926 .02672 m
.93852 .30206 L
s
P
p
.002 w
.7214 .0522 m
.71494 .0539 L
s
P
[(40)] .73432 .0488 -1 .26344 Mshowa
p
.002 w
.84293 .19206 m
.83641 .19349 L
s
P
[(50)] .85598 .1892 -1 .21908 Mshowa
p
.002 w
.93434 .29725 m
.92778 .29848 L
s
P
[(60)] .94747 .29479 -1 .1875 Mshowa
[(Gen.)] .91594 .16872 -1 .22094 Mshowa
P
p
p
.002 w
.07262 .19706 m
.02672 .88626 L
s
P
p
.002 w
.06978 .23969 m
.07625 .23802 L
s
P
[(-50)] .05685 .24303 1 -0.25833 Mshowa
p
.002 w
.05792 .4178 m
.06447 .41648 L
s
P
[(0)] .04482 .42044 1 -0.20167 Mshowa
p
.002 w
.04543 .60525 m
.05205 .60431 L
s
P
[(50)] .03221 .60712 1 -0.14158 Mshowa
p
.002 w
.03228 .80279 m
.03894 .80227 L
s
P
[(100)] .01896 .80382 1 -0.07771 Mshowa
p
.001 w
.06746 .2746 m
.07135 .27364 L
s
P
p
.001 w
.06511 .30986 m
.06901 .30894 L
s
P
p
.001 w
.06274 .34548 m
.06665 .3446 L
s
P
p
.001 w
.06034 .38146 m
.06426 .38062 L
s
P
p
.001 w
.05547 .45452 m
.05941 .45377 L
s
P
p
.001 w
.053 .49162 m
.05695 .49092 L
s
P
p
.001 w
.05051 .5291 m
.05446 .52845 L
s
P
p
.001 w
.04798 .56698 m
.05194 .56637 L
s
P
p
.001 w
.04286 .64392 m
.04683 .64341 L
s
P
p
.001 w
.04025 .68301 m
.04424 .68255 L
s
P
p
.001 w
.03762 .72251 m
.04161 .7221 L
s
P
p
.001 w
.03496 .76243 m
.03896 .76207 L
s
P
p
.001 w
.07208 .20513 m
.07595 .20409 L
s
P
p
.001 w
.02956 .84358 m
.03356 .84332 L
s
P
p
.001 w
.02681 .88481 m
.03082 .88461 L
s
P
[(Fit.)] -0.0283 .53856 1 -0.16726 Mshowa
P
0 0 m
1 0 L
1 .95229 L
0 .95229 L
closepath
clip
newpath
p
p
.4 g
.002 w
.06978 .23969 m
.42904 .43021 L
s
P
p
.4 g
.002 w
.05792 .4178 m
.427 .56884 L
s
P
p
.4 g
.002 w
.04543 .60525 m
.42488 .71293 L
s
P
p
.4 g
.002 w
.03228 .80279 m
.42268 .86283 L
s
P
p
.4 g
.002 w
.08367 .20324 m
.03923 .88751 L
s
P
p
.4 g
.002 w
.18133 .25789 m
.149 .89843 L
s
P
p
.4 g
.002 w
.26703 .30585 m
.24418 .9079 L
s
P
p
.4 g
.002 w
.34284 .34827 m
.32749 .91619 L
s
P
p
.4 g
.002 w
.41037 .38606 m
.40102 .92351 L
s
P
p
.4 g
.002 w
.44013 .39481 m
.43312 .92519 L
s
P
p
.4 g
.002 w
.56602 .37138 m
.56847 .92068 L
s
P
p
.4 g
.002 w
.70138 .34619 m
.71482 .91579 L
s
P
p
.4 g
.002 w
.84733 .31903 m
.87358 .91049 L
s
P
p
.4 g
.002 w
.42904 .43021 m
.9407 .33992 L
s
P
p
.4 g
.002 w
.427 .56884 m
.94975 .49749 L
s
P
p
.4 g
.002 w
.42488 .71293 m
.95921 .66223 L
s
P
p
.4 g
.002 w
.42268 .86283 m
.96912 .83466 L
s
P
P
p
.43324 .39367 m .45808 .39844 L .44573 .40071 L 1 0 0 r
F
P
p
.44568 .39134 m .47051 .39615 L .45808 .39844 L 1 0 0 r
F
P
p
.43324 .39367 m .44568 .39134 L .45808 .39844 L 1 0 0 r
F
P
p
.45821 .389 m .48303 .39384 L .47051 .39615 L 1 0 .698 r
F
P
p
.44568 .39134 m .45821 .389 L .47051 .39615 L 1 0 0 r
F
P
p
.47082 .38665 m .49564 .39152 L .48303 .39384 L 0 .095 1 r
F
P
p
.45821 .389 m .47082 .38665 L .48303 .39384 L 1 0 .698 r
F
P
p
.42048 .38646 m .44568 .39134 L .43324 .39367 L 1 0 0 r
F
P
p
.48353 .38427 m .50835 .38918 L .49564 .39152 L 0 1 .741 r
F
P
p
.47082 .38665 m .48353 .38427 L .49564 .39152 L 0 .095 1 r
F
P
p
.43301 .38409 m .45821 .389 L .44568 .39134 L 1 0 0 r
F
P
p
.42048 .38646 m .43301 .38409 L .44568 .39134 L 1 0 0 r
F
P
p
.49633 .38188 m .52114 .38683 L .50835 .38918 L 0 1 .017 r
F
P
p
.48353 .38427 m .49633 .38188 L .50835 .38918 L 0 1 .741 r
F
P
p
.44563 .3817 m .47082 .38665 L .45821 .389 L 1 0 0 r
F
P
p
.43301 .38409 m .44563 .3817 L .45821 .389 L 1 0 0 r
F
P
p
.50923 .37947 m .53403 .38446 L .52114 .38683 L .345 1 0 r
F
P
p
.49633 .38188 m .50923 .37947 L .52114 .38683 L 0 1 .017 r
F
P
p
.45834 .37929 m .48353 .38427 L .47082 .38665 L 1 0 .698 r
F
P
p
.44563 .3817 m .45834 .37929 L .47082 .38665 L 1 0 0 r
F
P
p
.40743 .3791 m .43301 .38409 L .42048 .38646 L 1 0 0 r
F
P
p
.52221 .37705 m .54701 .38207 L .53403 .38446 L .526 1 0 r
F
P
p
.50923 .37947 m .52221 .37705 L .53403 .38446 L .345 1 0 r
F
P
p
.47115 .37686 m .49633 .38188 L .48353 .38427 L .474 0 1 r
F
P
p
.45834 .37929 m .47115 .37686 L .48353 .38427 L 1 0 .698 r
F
P
p
.42005 .37667 m .44563 .3817 L .43301 .38409 L 1 0 0 r
F
P
p
.40743 .3791 m .42005 .37667 L .43301 .38409 L 1 0 0 r
F
P
p
.5353 .3746 m .56008 .37966 L .54701 .38207 L .733 1 0 r
F
P
p
.52221 .37705 m .5353 .3746 L .54701 .38207 L .526 1 0 r
F
P
p
.48405 .37441 m .50923 .37947 L .49633 .38188 L 0 .664 1 r
F
P
p
.47115 .37686 m .48405 .37441 L .49633 .38188 L .474 0 1 r
F
P
p
.43276 .37423 m .45834 .37929 L .44563 .3817 L 1 0 0 r
F
P
p
.42005 .37667 m .43276 .37423 L .44563 .3817 L 1 0 0 r
F
P
p
.54848 .37214 m .57325 .37723 L .56008 .37966 L .888 1 0 r
F
P
p
.5353 .3746 m .54848 .37214 L .56008 .37966 L .733 1 0 r
F
P
p
.49704 .37195 m .52221 .37705 L .50923 .37947 L 0 1 .095 r
F
P
p
.48405 .37441 m .49704 .37195 L .50923 .37947 L 0 .664 1 r
F
P
p
.44557 .37176 m .47115 .37686 L .45834 .37929 L 1 0 0 r
F
P
p
.43276 .37423 m .44557 .37176 L .45834 .37929 L 1 0 0 r
F
P
p
.39408 .37157 m .42005 .37667 L .40743 .3791 L 1 0 0 r
F
P
p
.56176 .36966 m .58652 .37479 L .57325 .37723 L .94 1 0 r
F
P
p
.54848 .37214 m .56176 .36966 L .57325 .37723 L .888 1 0 r
F
P
p
.51013 .36947 m .5353 .3746 L .52221 .37705 L .216 1 0 r
F
P
p
.49704 .37195 m .51013 .36947 L .52221 .37705 L 0 1 .095 r
F
P
p
.45848 .36928 m .48405 .37441 L .47115 .37686 L 1 0 0 r
F
P
p
.44557 .37176 m .45848 .36928 L .47115 .37686 L 1 0 0 r
F
P
p
.40679 .36909 m .43276 .37423 L .42005 .37667 L 1 0 0 r
F
P
p
.39408 .37157 m .40679 .36909 L .42005 .37667 L 1 0 0 r
F
P
p
.57514 .36716 m .59989 .37233 L .58652 .37479 L .966 1 0 r
F
P
p
.56176 .36966 m .57514 .36716 L .58652 .37479 L .94 1 0 r
F
P
p
.52332 .36697 m .54848 .37214 L .5353 .3746 L .422 1 0 r
F
P
p
.51013 .36947 m .52332 .36697 L .5353 .3746 L .216 1 0 r
F
P
p
.47148 .36678 m .49704 .37195 L .48405 .37441 L .216 0 1 r
F
P
p
.45848 .36928 m .47148 .36678 L .48405 .37441 L 1 0 0 r
F
P
p
.4196 .36658 m .44557 .37176 L .43276 .37423 L 1 0 0 r
F
P
p
.40679 .36909 m .4196 .36658 L .43276 .37423 L 1 0 0 r
F
P
p
.58861 .36464 m .61335 .36985 L .59989 .37233 L 1 .983 0 r
F
P
p
.57514 .36716 m .58861 .36464 L .59989 .37233 L .966 1 0 r
F
P
p
.53661 .36445 m .56176 .36966 L .54848 .37214 L .552 1 0 r
F
P
p
.52332 .36697 m .53661 .36445 L .54848 .37214 L .422 1 0 r
F
P
p
.48458 .36426 m .51013 .36947 L .49704 .37195 L 0 1 .276 r
F
P
p
.47148 .36678 m .48458 .36426 L .49704 .37195 L .216 0 1 r
F
P
p
.43251 .36406 m .45848 .36928 L .44557 .37176 L 1 0 0 r
F
P
p
.4196 .36658 m .43251 .36406 L .44557 .37176 L 1 0 0 r
F
P
p
.38042 .36387 m .40679 .36909 L .39408 .37157 L 1 0 0 r
F
P
p
.60219 .36211 m .62692 .36735 L .61335 .36985 L 1 .879 0 r
F
P
p
.58861 .36464 m .60219 .36211 L .61335 .36985 L 1 .983 0 r
F
P
p
.55 .36191 m .57514 .36716 L .56176 .36966 L .629 1 0 r
F
P
p
.53661 .36445 m .55 .36191 L .56176 .36966 L .552 1 0 r
F
P
p
.49777 .36172 m .52332 .36697 L .51013 .36947 L 0 1 .069 r
F
P
p
.48458 .36426 m .49777 .36172 L .51013 .36947 L 0 1 .276 r
F
P
p
.44552 .36152 m .47148 .36678 L .45848 .36928 L 1 0 0 r
F
P
p
.43251 .36406 m .44552 .36152 L .45848 .36928 L 1 0 0 r
F
P
p
.39323 .36132 m .4196 .36658 L .40679 .36909 L 1 0 0 r
F
P
p
.38042 .36387 m .39323 .36132 L .40679 .36909 L 1 0 0 r
F
P
p
.61587 .35955 m .64059 .36484 L .62692 .36735 L 1 .828 0 r
F
P
p
.60219 .36211 m .61587 .35955 L .62692 .36735 L 1 .879 0 r
F
P
p
.56349 .35935 m .58861 .36464 L .57514 .36716 L .759 1 0 r
F
P
p
.55 .36191 m .56349 .35935 L .57514 .36716 L .629 1 0 r
F
P
p
.51107 .35916 m .53661 .36445 L .52332 .36697 L .06 1 0 r
F
P
p
.49777 .36172 m .51107 .35916 L .52332 .36697 L 0 1 .069 r
F
P
p
.45862 .35896 m .48458 .36426 L .47148 .36678 L .086 0 1 r
F
P
p
.44552 .36152 m .45862 .35896 L .47148 .36678 L 1 0 0 r
F
P
p
.40614 .35876 m .43251 .36406 L .4196 .36658 L 1 0 0 r
F
P
p
.39323 .36132 m .40614 .35876 L .4196 .36658 L 1 0 0 r
F
P
p
.62966 .35698 m .65436 .3623 L .64059 .36484 L 1 .776 0 r
F
P
p
.61587 .35955 m .62966 .35698 L .64059 .36484 L 1 .828 0 r
F
P
p
.57708 .35678 m .60219 .36211 L .58861 .36464 L .888 1 0 r
F
P
p
.56349 .35935 m .57708 .35678 L .58861 .36464 L .759 1 0 r
F
P
p
.52446 .35658 m .55 .36191 L .53661 .36445 L .138 1 0 r
F
P
p
.51107 .35916 m .52446 .35658 L .53661 .36445 L .06 1 0 r
F
P
p
.002 w
.50736 .66031 m .49375 .74012 L .48102 .73659 L p
0 1 .741 r
F P
0 0 0 r
s
P
p
.002 w
.52067 .64089 m .50736 .66031 L .49944 .68782 L p
0 1 .017 r
F P
0 0 0 r
s
P
p
.50589 .67705 m .52067 .64089 L .49944 .68782 L 0 1 .017 r
F
P
p
.002 w
.49944 .68782 m .49461 .70463 L p
.50589 .67705 L 0 1 .017 r
F P
0 0 0 r
s
P
p
.002 w
.49461 .70463 m .50824 .6605 L .52067 .64089 L p
0 1 .017 r
F P
0 0 0 r
s
P
p
.002 w
.53402 .63939 m .52067 .64089 L .50824 .6605 L p
.345 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50824 .6605 m .52178 .6347 L .52946 .63764 L p
.345 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52946 .63764 m .53402 .63939 L p
.52304 .64838 L .345 1 0 r
F P
0 0 0 r
s
P
p
.50824 .6605 m .52946 .63764 L .52304 .64838 L .345 1 0 r
F
P
p
.002 w
.48102 .73659 m .49461 .70463 L .50736 .66031 L p
0 1 .741 r
F P
0 0 0 r
s
P
p
.47182 .35638 m .49777 .36172 L .48458 .36426 L .138 1 0 r
F
P
p
.45862 .35896 m .47182 .35638 L .48458 .36426 L .086 0 1 r
F
P
p
.41915 .35618 m .44552 .36152 L .43251 .36406 L 1 0 0 r
F
P
p
.40614 .35876 m .41915 .35618 L .43251 .36406 L 1 0 0 r
F
P
p
.36644 .35598 m .39323 .36132 L .38042 .36387 L 1 0 0 r
F
P
p
.002 w
.49375 .74012 m .48053 .74124 L .46618 .90729 L p
0 .095 1 r
F P
0 0 0 r
s
P
p
.002 w
.48053 .74124 m .46592 .90937 L .45267 .90781 L p
1 0 .698 r
F P
0 0 0 r
s
P
p
.002 w
.45267 .90781 m .46618 .90729 L .48053 .74124 L p
1 0 .698 r
F P
0 0 0 r
s
P
p
.64355 .35438 m .66823 .35975 L .65436 .3623 L 1 .724 0 r
F
P
p
.62966 .35698 m .64355 .35438 L .65436 .3623 L 1 .776 0 r
F
P
p
.59077 .35418 m .61587 .35955 L .60219 .36211 L 1 .983 0 r
F
P
p
.57708 .35678 m .59077 .35418 L .60219 .36211 L .888 1 0 r
F
P
p
.53796 .35398 m .56349 .35935 L .55 .36191 L .319 1 0 r
F
P
p
.52446 .35658 m .53796 .35398 L .55 .36191 L .138 1 0 r
F
P
p
.48512 .35378 m .51107 .35916 L .49777 .36172 L .5 1 0 r
F
P
p
.47182 .35638 m .48512 .35378 L .49777 .36172 L .138 1 0 r
F
P
p
.43225 .35358 m .45862 .35896 L .44552 .36152 L 1 0 0 r
F
P
p
.41915 .35618 m .43225 .35358 L .44552 .36152 L 1 0 0 r
F
P
p
.37935 .35338 m .40614 .35876 L .39323 .36132 L 1 0 0 r
F
P
p
.36644 .35598 m .37935 .35338 L .39323 .36132 L 1 0 0 r
F
P
p
.002 w
.54746 .63788 m .53402 .63939 L .52178 .6347 L p
.526 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46618 .90729 m .48102 .73659 L .49375 .74012 L p
0 .095 1 r
F P
0 0 0 r
s
P
p
.65754 .35177 m .68221 .35718 L .66823 .35975 L 1 .595 0 r
F
P
p
.64355 .35438 m .65754 .35177 L .66823 .35975 L 1 .724 0 r
F
P
p
.60457 .35157 m .62966 .35698 L .61587 .35955 L 1 .879 0 r
F
P
p
.59077 .35418 m .60457 .35157 L .61587 .35955 L 1 .983 0 r
F
P
p
.55156 .35137 m .57708 .35678 L .56349 .35935 L .578 1 0 r
F
P
p
.53796 .35398 m .55156 .35137 L .56349 .35935 L .319 1 0 r
F
P
p
.49853 .35116 m .52446 .35658 L .51107 .35916 L .578 1 0 r
F
P
p
.48512 .35378 m .49853 .35116 L .51107 .35916 L .5 1 0 r
F
P
p
.44546 .35096 m .47182 .35638 L .45862 .35896 L .345 0 1 r
F
P
p
.43225 .35358 m .44546 .35096 L .45862 .35896 L 1 0 0 r
F
P
p
.39236 .35076 m .41915 .35618 L .40614 .35876 L 1 0 0 r
F
P
p
.37935 .35338 m .39236 .35076 L .40614 .35876 L 1 0 0 r
F
P
p
.002 w
.56095 .61826 m .54746 .63788 L .53533 .61492 L p
.733 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52178 .6347 m .53533 .61492 L .54746 .63788 L p
.526 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57453 .61063 m .56095 .61826 L .54894 .60115 L p
.888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53533 .61492 m .54894 .60115 L .56095 .61826 L p
.733 1 0 r
F P
0 0 0 r
s
P
p
.67164 .34913 m .69629 .35458 L .68221 .35718 L 1 .466 0 r
F
P
p
.65754 .35177 m .67164 .34913 L .68221 .35718 L 1 .595 0 r
F
P
p
.61847 .34893 m .64355 .35438 L .62966 .35698 L 1 .828 0 r
F
P
p
.60457 .35157 m .61847 .34893 L .62966 .35698 L 1 .879 0 r
F
P
p
.56527 .34873 m .59077 .35418 L .57708 .35678 L .707 1 0 r
F
P
p
.55156 .35137 m .56527 .34873 L .57708 .35678 L .578 1 0 r
F
P
p
.51203 .34852 m .53796 .35398 L .52446 .35658 L .629 1 0 r
F
P
p
.49853 .35116 m .51203 .34852 L .52446 .35658 L .578 1 0 r
F
P
p
.45877 .34832 m .48512 .35378 L .47182 .35638 L 0 1 .405 r
F
P
p
.44546 .35096 m .45877 .34832 L .47182 .35638 L .345 0 1 r
F
P
p
.40547 .34812 m .43225 .35358 L .41915 .35618 L 1 0 0 r
F
P
p
.39236 .35076 m .40547 .34812 L .41915 .35618 L 1 0 0 r
F
P
p
.35214 .34791 m .37935 .35338 L .36644 .35598 L 1 0 0 r
F
P
p
.002 w
.5882 .60295 m .57453 .61063 L .56265 .59947 L p
.94 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54894 .60115 m .56265 .59947 L .57453 .61063 L p
.888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45261 .90987 m .43941 .91037 L .42594 .90883 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68585 .34648 m .71048 .35197 L .69629 .35458 L 1 .466 0 r
F
P
p
.67164 .34913 m .68585 .34648 L .69629 .35458 L 1 .466 0 r
F
P
p
.63248 .34628 m .65754 .35177 L .64355 .35438 L 1 .776 0 r
F
P
p
.61847 .34893 m .63248 .34628 L .64355 .35438 L 1 .828 0 r
F
P
p
.57908 .34607 m .60457 .35157 L .59077 .35418 L .81 1 0 r
F
P
p
.56527 .34873 m .57908 .34607 L .59077 .35418 L .707 1 0 r
F
P
p
.52564 .34587 m .55156 .35137 L .53796 .35398 L .759 1 0 r
F
P
p
.51203 .34852 m .52564 .34587 L .53796 .35398 L .629 1 0 r
F
P
p
.47217 .34566 m .49853 .35116 L .48512 .35378 L 0 1 .121 r
F
P
p
.45877 .34832 m .47217 .34566 L .48512 .35378 L 0 1 .405 r
F
P
p
.41868 .34545 m .44546 .35096 L .43225 .35358 L 1 0 0 r
F
P
p
.40547 .34812 m .41868 .34545 L .43225 .35358 L 1 0 0 r
F
P
p
.002 w
.602 .60128 m .5882 .60295 L .57646 .59777 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56265 .59947 m .57646 .59777 L .5882 .60295 L p
.94 1 0 r
F P
0 0 0 r
s
P
p
.36515 .34525 m .39236 .35076 L .37935 .35338 L 1 0 0 r
F
P
p
.35214 .34791 m .36515 .34525 L .37935 .35338 L 1 0 0 r
F
P
p
.002 w
.49461 .70463 m .4803 .90461 L p
.50728 .66888 L 0 .664 1 r
F P
0 0 0 r
s
P
p
.002 w
.50824 .6605 m .50143 .68254 L p
.50728 .66888 L 0 .664 1 r
F P
0 0 0 r
s
P
p
.002 w
.50143 .68254 m .49461 .70463 L p
.50728 .66888 L 0 .664 1 r
F P
0 0 0 r
s
P
p
.002 w
.50184 .67974 m .50824 .6605 L p
.50547 .68463 L 0 .664 1 r
F P
0 0 0 r
s
P
p
.002 w
.49532 .69933 m .50184 .67974 L p
.49988 .7335 L 0 .664 1 r
F P
0 0 0 r
s
P
p
.49988 .7335 m .50184 .67974 L .50547 .68463 L 0 .664 1 r
F
P
p
.002 w
.50912 .66689 m .52034 .63835 L p
.50659 .67186 L 0 1 .095 r
F P
0 0 0 r
s
P
p
.002 w
.49532 .69933 m .50912 .66689 L p
.50659 .67186 L 0 1 .095 r
F P
0 0 0 r
s
P
p
.49532 .69933 m .52034 .63835 L .51899 .64152 L 0 1 .095 r
F
P
p
.002 w
.52178 .6347 m .50824 .6605 L .49532 .69933 L p
0 1 .095 r
F P
0 0 0 r
s
P
p
.002 w
.53533 .61492 m .52178 .6347 L .50912 .66689 L p
.216 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50912 .66689 m .52286 .66544 L .53533 .61492 L p
.216 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50912 .66689 m .49626 .65612 L p
.51182 .66157 L 0 1 .069 r
F P
0 0 0 r
s
P
p
.002 w
.52286 .66544 m .50912 .66689 L p
.51182 .66157 L 0 1 .069 r
F P
0 0 0 r
s
P
p
.002 w
.49626 .65612 m .50912 .66689 L p
.49072 .6648 L 0 1 .276 r
F P
0 0 0 r
s
P
p
.002 w
.48248 .66386 m .4878 .66087 L p
.49072 .6648 L 0 1 .276 r
F P
0 0 0 r
s
P
p
.002 w
.4878 .66087 m .49626 .65612 L p
.49072 .6648 L 0 1 .276 r
F P
0 0 0 r
s
P
p
.002 w
.4803 .90461 m .49532 .69933 L p
.49988 .7335 L 0 .664 1 r
F P
0 0 0 r
s
P
p
.002 w
.49532 .69933 m .48248 .66386 L p
.49072 .6648 L 0 1 .276 r
F P
0 0 0 r
s
P
p
.002 w
.50912 .66689 m .49532 .69933 L p
.49072 .6648 L 0 1 .276 r
F P
0 0 0 r
s
P
p
.002 w
.52034 .63835 m .52178 .6347 L p
.51899 .64152 L 0 1 .095 r
F P
0 0 0 r
s
P
p
.002 w
.46592 .90937 m .45261 .90987 L .43925 .90832 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.42594 .90883 m .43925 .90832 L .45261 .90987 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.54894 .60115 m .53533 .61492 L .52286 .66544 L p
.422 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49461 .70463 m .48102 .73659 L .46645 .90515 L p
.474 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46645 .90515 m .4803 .90461 L .49461 .70463 L p
.474 0 1 r
F P
0 0 0 r
s
P
p
.70017 .34381 m .72478 .34934 L .71048 .35197 L 1 .388 0 r
F
P
p
.68585 .34648 m .70017 .34381 L .71048 .35197 L 1 .466 0 r
F
P
p
.002 w
.48102 .73659 m .46618 .90729 L .45272 .90568 L p
1 0 .698 r
F P
0 0 0 r
s
P
p
.002 w
.45272 .90568 m .46645 .90515 L .48102 .73659 L p
1 0 .698 r
F P
0 0 0 r
s
P
p
.6466 .3436 m .67164 .34913 L .65754 .35177 L 1 .647 0 r
F
P
p
.63248 .34628 m .6466 .3436 L .65754 .35177 L 1 .776 0 r
F
P
p
.59299 .34339 m .61847 .34893 L .60457 .35157 L .966 1 0 r
F
P
p
.57908 .34607 m .59299 .34339 L .60457 .35157 L .81 1 0 r
F
P
p
.53936 .34319 m .56527 .34873 L .55156 .35137 L .888 1 0 r
F
P
p
.52564 .34587 m .53936 .34319 L .55156 .35137 L .759 1 0 r
F
P
p
.48569 .34298 m .51203 .34852 L .49853 .35116 L .19 1 0 r
F
P
p
.47217 .34566 m .48569 .34298 L .49853 .35116 L 0 1 .121 r
F
P
p
.43199 .34277 m .45877 .34832 L .44546 .35096 L .345 0 1 r
F
P
p
.41868 .34545 m .43199 .34277 L .44546 .35096 L 1 0 0 r
F
P
p
.002 w
.61591 .5996 m .602 .60128 L .59038 .59606 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.59038 .59606 m .602 .60128 L p
.58673 .59918 L .966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59038 .59606 m .6043 .58206 L .61591 .5996 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.59038 .59606 m .5786 .60935 L p
.59409 .5929 L .888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6043 .58206 m .59038 .59606 L p
.59409 .5929 L .888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57646 .59777 m .59038 .59606 L p
.58673 .59918 L .966 1 0 r
F P
0 0 0 r
s
P
p
.37825 .34256 m .40547 .34812 L .39236 .35076 L 1 0 0 r
F
P
p
.36515 .34525 m .37825 .34256 L .39236 .35076 L 1 0 0 r
F
P
p
.002 w
.56265 .59947 m .54894 .60115 L .5367 .64529 L p
.552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5367 .64529 m .54894 .60115 L p
.53006 .64768 L .422 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5367 .64529 m .55062 .64375 L .56265 .59947 L p
.552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5367 .64529 m .52407 .6405 L p
.54342 .64287 L .138 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55062 .64375 m .5367 .64529 L p
.54342 .64287 L .138 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52286 .66544 m .5367 .64529 L p
.53006 .64768 L .422 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.43925 .90832 m .45267 .90781 L .46592 .90937 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7146 .34111 m .73919 .34669 L .72478 .34934 L 1 .31 0 r
F
P
p
.70017 .34381 m .7146 .34111 L .72478 .34934 L 1 .388 0 r
F
P
p
.66083 .3409 m .68585 .34648 L .67164 .34913 L 1 .569 0 r
F
P
p
.6466 .3436 m .66083 .3409 L .67164 .34913 L 1 .647 0 r
F
P
p
.60702 .34069 m .63248 .34628 L .61847 .34893 L 1 .931 0 r
F
P
p
.59299 .34339 m .60702 .34069 L .61847 .34893 L .966 1 0 r
F
P
p
.55318 .34049 m .57908 .34607 L .56527 .34873 L .94 1 0 r
F
P
p
.53936 .34319 m .55318 .34049 L .56527 .34873 L .888 1 0 r
F
P
p
.4993 .34028 m .52564 .34587 L .51203 .34852 L .578 1 0 r
F
P
p
.48569 .34298 m .4993 .34028 L .51203 .34852 L .19 1 0 r
F
P
p
.4454 .34007 m .47217 .34566 L .45877 .34832 L 0 1 .638 r
F
P
p
.43199 .34277 m .4454 .34007 L .45877 .34832 L .345 0 1 r
F
P
p
.002 w
.62993 .5979 m .61591 .5996 L .6043 .58206 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.39146 .33986 m .41868 .34545 L .40547 .34812 L 1 0 0 r
F
P
p
.37825 .34256 m .39146 .33986 L .40547 .34812 L 1 0 0 r
F
P
p
.002 w
.57646 .59777 m .56265 .59947 L .55062 .64375 L p
.629 1 0 r
F P
0 0 0 r
s
P
p
.33749 .33965 m .36515 .34525 L .35214 .34791 L 1 0 0 r
F
P
p
.002 w
.43925 .90832 m .42594 .90883 L .41216 .90725 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.72915 .33839 m .75371 .34401 L .73919 .34669 L 1 .31 0 r
F
P
p
.7146 .34111 m .72915 .33839 L .73919 .34669 L 1 .31 0 r
F
P
p
.67516 .33818 m .70017 .34381 L .68585 .34648 L 1 .569 0 r
F
P
p
.66083 .3409 m .67516 .33818 L .68585 .34648 L 1 .569 0 r
F
P
p
.62115 .33797 m .6466 .3436 L .63248 .34628 L 1 .879 0 r
F
P
p
.60702 .34069 m .62115 .33797 L .63248 .34628 L 1 .931 0 r
F
P
p
.5671 .33776 m .59299 .34339 L .57908 .34607 L 1 .983 0 r
F
P
p
.55318 .34049 m .5671 .33776 L .57908 .34607 L .94 1 0 r
F
P
p
.51303 .33755 m .53936 .34319 L .52564 .34587 L .733 1 0 r
F
P
p
.4993 .34028 m .51303 .33755 L .52564 .34587 L .578 1 0 r
F
P
p
.45892 .33734 m .48569 .34298 L .47217 .34566 L 0 1 .457 r
F
P
p
.4454 .34007 m .45892 .33734 L .47217 .34566 L 0 1 .638 r
F
P
p
.002 w
.64405 .59619 m .62993 .5979 L .61827 .568 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.6043 .58206 m .61827 .568 L .62993 .5979 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.40477 .33713 m .43199 .34277 L .41868 .34545 L 1 0 0 r
F
P
p
.39146 .33986 m .40477 .33713 L .41868 .34545 L 1 0 0 r
F
P
p
.002 w
.59038 .59606 m .57646 .59777 L .56457 .62347 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56457 .62347 m .57646 .59777 L p
.55436 .6371 L .629 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56457 .62347 m .5522 .6121 L p
.57486 .60974 L .578 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5786 .60935 m .59038 .59606 L p
.57109 .61655 L .759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56457 .62347 m .5786 .60935 L p
.57109 .61655 L .759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59274 .60141 m .6043 .58206 L p
.58379 .60384 L .888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5786 .60935 m .59274 .60141 L p
.58379 .60384 L .888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61827 .568 m .6043 .58206 L .59274 .60141 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.59274 .60141 m .60703 .59968 L .61827 .568 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.59274 .60141 m .58066 .59604 L p
.60179 .59895 L .81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60703 .59968 m .59274 .60141 L p
.60179 .59895 L .81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5786 .60935 m .56638 .60409 L p
.58619 .60208 L .707 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59274 .60141 m .5786 .60935 L p
.58619 .60208 L .707 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5786 .60935 m .56457 .62347 L p
.57486 .60974 L .578 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55062 .64375 m .56457 .62347 L p
.55436 .6371 L .629 1 0 r
F P
0 0 0 r
s
P
p
.3506 .33692 m .37825 .34256 L .36515 .34525 L 1 0 0 r
F
P
p
.33749 .33965 m .3506 .33692 L .36515 .34525 L 1 0 0 r
F
P
p
.002 w
.45267 .90781 m .43925 .90832 L .42557 .90673 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.41216 .90725 m .42557 .90673 L .43925 .90832 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7438 .33566 m .76835 .34132 L .75371 .34401 L 1 .31 0 r
F
P
p
.72915 .33839 m .7438 .33566 L .75371 .34401 L 1 .31 0 r
F
P
p
.68961 .33544 m .7146 .34111 L .70017 .34381 L 1 .569 0 r
F
P
p
.67516 .33818 m .68961 .33544 L .70017 .34381 L 1 .569 0 r
F
P
p
.63539 .33523 m .66083 .3409 L .6466 .3436 L 1 .828 0 r
F
P
p
.62115 .33797 m .63539 .33523 L .6466 .3436 L 1 .879 0 r
F
P
p
.58114 .33502 m .60702 .34069 L .59299 .34339 L 1 .828 0 r
F
P
p
.5671 .33776 m .58114 .33502 L .59299 .34339 L 1 .983 0 r
F
P
p
.52686 .33481 m .55318 .34049 L .53936 .34319 L .81 1 0 r
F
P
p
.51303 .33755 m .52686 .33481 L .53936 .34319 L .733 1 0 r
F
P
p
.47254 .3346 m .4993 .34028 L .48569 .34298 L .034 1 0 r
F
P
p
.45892 .33734 m .47254 .3346 L .48569 .34298 L 0 1 .457 r
F
P
p
.002 w
.65808 .5822 m .64405 .59619 L .63247 .56616 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.61827 .568 m .63247 .56616 L .64405 .59619 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.41819 .33439 m .4454 .34007 L .43199 .34277 L 1 0 .957 r
F
P
p
.40477 .33713 m .41819 .33439 L .43199 .34277 L 1 0 0 r
F
P
p
.36381 .33417 m .39146 .33986 L .37825 .34256 L 1 0 0 r
F
P
p
.3506 .33692 m .36381 .33417 L .37825 .34256 L 1 0 0 r
F
P
p
.002 w
.46618 .90729 m .45267 .90781 L .43909 .90621 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.42557 .90673 m .43909 .90621 L .45267 .90781 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.75857 .3329 m .78309 .3386 L .76835 .34132 L 1 .259 0 r
F
P
p
.7438 .33566 m .75857 .3329 L .76835 .34132 L 1 .31 0 r
F
P
p
.002 w
.6724 .58042 m .65808 .5822 L .64678 .5643 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.63247 .56616 m .64678 .5643 L .65808 .5822 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.49532 .69933 m .4803 .90461 L .46674 .90293 L p
.216 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46674 .90293 m .48248 .66386 L .49532 .69933 L p
.216 0 1 r
F P
0 0 0 r
s
P
p
.70418 .33268 m .72915 .33839 L .7146 .34111 L 1 .466 0 r
F
P
p
.68961 .33544 m .70418 .33268 L .7146 .34111 L 1 .569 0 r
F
P
p
.64975 .33247 m .67516 .33818 L .66083 .3409 L 1 .828 0 r
F
P
p
.63539 .33523 m .64975 .33247 L .66083 .3409 L 1 .828 0 r
F
P
p
.59529 .33226 m .62115 .33797 L .60702 .34069 L 1 .698 0 r
F
P
p
.58114 .33502 m .59529 .33226 L .60702 .34069 L 1 .828 0 r
F
P
p
.54079 .33204 m .5671 .33776 L .55318 .34049 L .81 1 0 r
F
P
p
.52686 .33481 m .54079 .33204 L .55318 .34049 L .81 1 0 r
F
P
p
.48627 .33183 m .51303 .33755 L .4993 .34028 L .448 1 0 r
F
P
p
.47254 .3346 m .48627 .33183 L .4993 .34028 L .034 1 0 r
F
P
p
.43171 .33162 m .45892 .33734 L .4454 .34007 L 0 .793 1 r
F
P
p
.41819 .33439 m .43171 .33162 L .4454 .34007 L 1 0 .957 r
F
P
p
.37712 .3314 m .40477 .33713 L .39146 .33986 L 1 0 0 r
F
P
p
.36381 .33417 m .37712 .3314 L .39146 .33986 L 1 0 0 r
F
P
p
.32249 .33119 m .3506 .33692 L .33749 .33965 L 1 0 0 r
F
P
p
.002 w
.63247 .56616 m .61827 .568 L .60703 .59968 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.43909 .90621 m .45272 .90568 L .46618 .90729 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5367 .64529 m .52286 .66544 L .51014 .64207 L p
.06 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49626 .65612 m .51014 .64207 L .52286 .66544 L p
0 1 .069 r
F P
0 0 0 r
s
P
p
.77346 .33012 m .79796 .33587 L .78309 .3386 L 1 .155 0 r
F
P
p
.75857 .3329 m .77346 .33012 L .78309 .3386 L 1 .259 0 r
F
P
p
.002 w
.42557 .90673 m .41216 .90725 L .39804 .90564 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68657 .5663 m .6724 .58042 L .66121 .56243 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.64678 .5643 m .66121 .56243 L p
.6578 .57123 L 1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.66121 .56243 m .64678 .5643 L .63577 .58357 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.66121 .56243 m .65018 .56915 L p
.66466 .55352 L 1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.67538 .54194 m .66121 .56243 L p
.66466 .55352 L 1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.66121 .56243 m .6724 .58042 L p
.6578 .57123 L 1 .724 0 r
F P
0 0 0 r
s
P
p
.71885 .3299 m .7438 .33566 L .72915 .33839 L 1 .336 0 r
F
P
p
.70418 .33268 m .71885 .3299 L .72915 .33839 L 1 .466 0 r
F
P
p
.66422 .32969 m .68961 .33544 L .67516 .33818 L 1 .802 0 r
F
P
p
.64975 .33247 m .66422 .32969 L .67516 .33818 L 1 .828 0 r
F
P
p
.60955 .32947 m .63539 .33523 L .62115 .33797 L 1 .621 0 r
F
P
p
.59529 .33226 m .60955 .32947 L .62115 .33797 L 1 .698 0 r
F
P
p
.55484 .32926 m .58114 .33502 L .5671 .33776 L .914 1 0 r
F
P
p
.54079 .33204 m .55484 .32926 L .5671 .33776 L .81 1 0 r
F
P
p
.002 w
.51014 .64207 m .52407 .6405 L .5367 .64529 L p
.06 1 0 r
F P
0 0 0 r
s
P
p
.50011 .32904 m .52686 .33481 L .51303 .33755 L .603 1 0 r
F
P
p
.48627 .33183 m .50011 .32904 L .51303 .33755 L .448 1 0 r
F
P
p
.44534 .32883 m .47254 .3346 L .45892 .33734 L 0 1 .095 r
F
P
p
.43171 .33162 m .44534 .32883 L .45892 .33734 L 0 .793 1 r
F
P
p
.39053 .32861 m .41819 .33439 L .40477 .33713 L 1 0 0 r
F
P
p
.37712 .3314 m .39053 .32861 L .40477 .33713 L 1 0 0 r
F
P
p
.002 w
.70109 .56445 m .68657 .5663 L .67538 .54194 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.66121 .56243 m .67538 .54194 L .68657 .5663 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.3357 .32839 m .36381 .33417 L .3506 .33692 L 1 0 0 r
F
P
p
.32249 .33119 m .3357 .32839 L .3506 .33692 L 1 0 0 r
F
P
p
.002 w
.64678 .5643 m .63247 .56616 L .62128 .58538 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.62128 .58538 m .63247 .56616 L p
.61345 .59121 L 1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.62128 .58538 m .63577 .58357 L .64678 .5643 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.62128 .58538 m .60934 .56712 L p
.6292 .57948 L 1 .931 0 r
F P
0 0 0 r
s
P
p
.002 w
.63577 .58357 m .62128 .58538 L p
.6292 .57948 L 1 .931 0 r
F P
0 0 0 r
s
P
p
.002 w
.60703 .59968 m .62128 .58538 L p
.61345 .59121 L 1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.43909 .90621 m .42557 .90673 L .41156 .9051 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.39804 .90564 m .41156 .9051 L .42557 .90673 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.78846 .32731 m .81293 .33311 L .79796 .33587 L 1 .103 0 r
F
P
p
.77346 .33012 m .78846 .32731 L .79796 .33587 L 1 .155 0 r
F
P
p
.002 w
.49626 .65612 m .48248 .66386 L .46915 .65928 L p
.138 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48248 .66386 m .46674 .90293 L .45283 .90121 L p
.086 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45283 .90121 m .46915 .65928 L .48248 .66386 L p
.086 0 1 r
F P
0 0 0 r
s
P
p
.73365 .3271 m .75857 .3329 L .7438 .33566 L 1 .31 0 r
F
P
p
.71885 .3299 m .73365 .3271 L .7438 .33566 L 1 .336 0 r
F
P
p
.6788 .32688 m .70418 .33268 L .68961 .33544 L 1 .672 0 r
F
P
p
.66422 .32969 m .6788 .32688 L .68961 .33544 L 1 .802 0 r
F
P
p
.62392 .32666 m .64975 .33247 L .63539 .33523 L 1 .569 0 r
F
P
p
.60955 .32947 m .62392 .32666 L .63539 .33523 L 1 .621 0 r
F
P
p
.569 .32645 m .59529 .33226 L .58114 .33502 L 1 .905 0 r
F
P
p
.55484 .32926 m .569 .32645 L .58114 .33502 L .914 1 0 r
F
P
p
.002 w
.56457 .62347 m .55062 .64375 L .53811 .63892 L p
.319 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52407 .6405 m .53811 .63892 L .55062 .64375 L p
.138 1 0 r
F P
0 0 0 r
s
P
p
.51405 .32623 m .54079 .33204 L .52686 .33481 L .759 1 0 r
F
P
p
.50011 .32904 m .51405 .32623 L .52686 .33481 L .603 1 0 r
F
P
p
.45907 .32601 m .48627 .33183 L .47254 .3346 L .448 1 0 r
F
P
p
.44534 .32883 m .45907 .32601 L .47254 .3346 L 0 1 .095 r
F
P
p
.40406 .3258 m .43171 .33162 L .41819 .33439 L 1 0 0 r
F
P
p
.39053 .32861 m .40406 .3258 L .41819 .33439 L 1 0 0 r
F
P
p
.002 w
.71572 .56258 m .70109 .56445 L .68999 .53997 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.67538 .54194 m .68999 .53997 L .70109 .56445 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.34901 .32558 m .37712 .3314 L .36381 .33417 L 1 0 0 r
F
P
p
.3357 .32839 m .34901 .32558 L .36381 .33417 L 1 0 0 r
F
P
p
.002 w
.53811 .63892 m .5522 .6121 L .56457 .62347 L p
.319 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51014 .64207 m .49626 .65612 L .48349 .58868 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46915 .65928 m .48349 .58868 L .49626 .65612 L p
.138 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45272 .90568 m .43909 .90621 L .42519 .90457 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.41156 .9051 m .42519 .90457 L .43909 .90621 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.80358 .32449 m .82803 .33033 L .81293 .33311 L 1 .078 0 r
F
P
p
.78846 .32731 m .80358 .32449 L .81293 .33311 L 1 .103 0 r
F
P
p
.74856 .32427 m .77346 .33012 L .75857 .3329 L 1 .284 0 r
F
P
p
.73365 .3271 m .74856 .32427 L .75857 .3329 L 1 .31 0 r
F
P
p
.69349 .32405 m .71885 .3299 L .70418 .33268 L 1 .466 0 r
F
P
p
.6788 .32688 m .69349 .32405 L .70418 .33268 L 1 .672 0 r
F
P
p
.6384 .32383 m .66422 .32969 L .64975 .33247 L 1 .569 0 r
F
P
p
.62392 .32666 m .6384 .32383 L .64975 .33247 L 1 .569 0 r
F
P
p
.002 w
.5522 .6121 m .56638 .60409 L .5786 .60935 L p
.578 1 0 r
F P
0 0 0 r
s
P
p
.58327 .32362 m .60955 .32947 L .59529 .33226 L 1 .802 0 r
F
P
p
.569 .32645 m .58327 .32362 L .59529 .33226 L 1 .905 0 r
F
P
p
.52811 .3234 m .55484 .32926 L .54079 .33204 L .81 1 0 r
F
P
p
.51405 .32623 m .52811 .3234 L .54079 .33204 L .759 1 0 r
F
P
p
.002 w
.52407 .6405 m .51014 .64207 L .49734 .5869 L p
.578 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49734 .5869 m .51014 .64207 L p
.48438 .59046 L .5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49734 .5869 m .51131 .57884 L .52407 .6405 L p
.578 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49734 .5869 m .48312 .71645 L p
.51039 .58331 L .19 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51131 .57884 m .49734 .5869 L p
.51039 .58331 L .19 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48349 .58868 m .49734 .5869 L p
.48438 .59046 L .5 1 0 r
F P
0 0 0 r
s
P
p
.47292 .32318 m .50011 .32904 L .48627 .33183 L .784 1 0 r
F
P
p
.45907 .32601 m .47292 .32318 L .48627 .33183 L .448 1 0 r
F
P
p
.41769 .32296 m .44534 .32883 L .43171 .33162 L .241 0 1 r
F
P
p
.40406 .3258 m .41769 .32296 L .43171 .33162 L 1 0 0 r
F
P
p
.002 w
.72997 .54209 m .71572 .56258 L .70472 .53799 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.002 w
.68999 .53997 m .70472 .53799 L .71572 .56258 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.36242 .32274 m .39053 .32861 L .37712 .3314 L 1 0 0 r
F
P
p
.34901 .32558 m .36242 .32274 L .37712 .3314 L 1 0 0 r
F
P
p
.002 w
.65018 .56915 m .63866 .56331 L p
.65182 .5653 L 1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.65018 .56915 m .66121 .56243 L p
.64856 .57294 L 1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.65018 .56915 m .66487 .56727 L .67538 .54194 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.66487 .56727 m .65018 .56915 L p
.65182 .5653 L 1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.63577 .58357 m .65018 .56915 L p
.64856 .57294 L 1 .776 0 r
F P
0 0 0 r
s
P
p
.30713 .32252 m .3357 .32839 L .32249 .33119 L 1 0 0 r
F
P
p
.002 w
.49734 .5869 m .48349 .58868 L .46891 .71776 L p
0 1 .121 r
F P
0 0 0 r
s
P
p
.002 w
.48349 .58868 m .46915 .65928 L .45481 .71906 L p
0 1 .405 r
F P
0 0 0 r
s
P
p
.002 w
.46915 .65928 m .45283 .90121 L .43858 .89944 L p
.345 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45481 .71906 m .46915 .65928 L p
.45645 .7591 L .345 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43858 .89944 m .45481 .71906 L p
.45645 .7591 L .345 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45481 .71906 m .44151 .64979 L p
.45316 .67871 L 0 1 .638 r
F P
0 0 0 r
s
P
p
.002 w
.45481 .71906 m .46891 .71776 L .48349 .58868 L p
0 1 .405 r
F P
0 0 0 r
s
P
p
.002 w
.46891 .71776 m .45481 .71906 L p
.45316 .67871 L 0 1 .638 r
F P
0 0 0 r
s
P
p
.002 w
.74479 .54012 m .72997 .54209 L .71957 .53599 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.70472 .53799 m .71957 .53599 L .72997 .54209 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.81883 .32164 m .84324 .32753 L .82803 .33033 L 1 .026 0 r
F
P
p
.80358 .32449 m .81883 .32164 L .82803 .33033 L 1 .078 0 r
F
P
p
.002 w
.46645 .90515 m .45272 .90568 L .43893 .90403 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.42519 .90457 m .43893 .90403 L .45272 .90568 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68999 .53997 m .67538 .54194 L .66487 .56727 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.56638 .60409 m .58066 .59604 L .59274 .60141 L p
.707 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41156 .9051 m .39804 .90564 L .38357 .90398 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.76358 .32142 m .78846 .32731 L .77346 .33012 L 1 .181 0 r
F
P
p
.74856 .32427 m .76358 .32142 L .77346 .33012 L 1 .284 0 r
F
P
p
.70831 .3212 m .73365 .3271 L .71885 .3299 L 1 .336 0 r
F
P
p
.69349 .32405 m .70831 .3212 L .71885 .3299 L 1 .466 0 r
F
P
p
.653 .32098 m .6788 .32688 L .66422 .32969 L 1 .543 0 r
F
P
p
.6384 .32383 m .653 .32098 L .66422 .32969 L 1 .569 0 r
F
P
p
.59766 .32076 m .62392 .32666 L .60955 .32947 L 1 .724 0 r
F
P
p
.58327 .32362 m .59766 .32076 L .60955 .32947 L 1 .802 0 r
F
P
p
.54228 .32054 m .569 .32645 L .55484 .32926 L .914 1 0 r
F
P
p
.52811 .3234 m .54228 .32054 L .55484 .32926 L .81 1 0 r
F
P
p
.002 w
.53811 .63892 m .52407 .6405 L .51131 .57884 L p
.629 1 0 r
F P
0 0 0 r
s
P
p
.48687 .32032 m .51405 .32623 L .50011 .32904 L .862 1 0 r
F
P
p
.47292 .32318 m .48687 .32032 L .50011 .32904 L .784 1 0 r
F
P
p
.43142 .3201 m .45907 .32601 L .44534 .32883 L 0 1 .353 r
F
P
p
.41769 .32296 m .43142 .3201 L .44534 .32883 L .241 0 1 r
F
P
p
.37595 .31988 m .40406 .3258 L .39053 .32861 L 1 0 0 r
F
P
p
.36242 .32274 m .37595 .31988 L .39053 .32861 L 1 0 0 r
F
P
p
.32043 .31966 m .34901 .32558 L .3357 .32839 L 1 0 0 r
F
P
p
.30713 .32252 m .32043 .31966 L .3357 .32839 L 1 0 0 r
F
P
p
.002 w
.46891 .71776 m .48312 .71645 L .49734 .5869 L p
0 1 .121 r
F P
0 0 0 r
s
P
p
.002 w
.75973 .53814 m .74479 .54012 L .73453 .53397 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.71957 .53599 m .73453 .53397 L .74479 .54012 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.83419 .31877 m .85858 .32471 L .84324 .32753 L 1 0 0 r
F
P
p
.81883 .32164 m .83419 .31877 L .84324 .32753 L 1 .026 0 r
F
P
p
.002 w
.4803 .90461 m .46645 .90515 L .45278 .90348 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.43893 .90403 m .45278 .90348 L .46645 .90515 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70472 .53799 m .68999 .53997 L .67969 .56537 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.66487 .56727 m .67969 .56537 L .68999 .53997 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.62128 .58538 m .60703 .59968 L .59497 .58161 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58066 .59604 m .59497 .58161 L .60703 .59968 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.77873 .31855 m .80358 .32449 L .78846 .32731 L 1 .078 0 r
F
P
p
.76358 .32142 m .77873 .31855 L .78846 .32731 L 1 .181 0 r
F
P
p
.002 w
.42519 .90457 m .41156 .9051 L .3972 .90344 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.38357 .90398 m .3972 .90344 L .41156 .9051 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.72324 .31833 m .74856 .32427 L .73365 .3271 L 1 .31 0 r
F
P
p
.70831 .3212 m .72324 .31833 L .73365 .3271 L 1 .336 0 r
F
P
p
.66772 .31811 m .69349 .32405 L .6788 .32688 L 1 .388 0 r
F
P
p
.653 .32098 m .66772 .31811 L .6788 .32688 L 1 .543 0 r
F
P
p
.61216 .31788 m .6384 .32383 L .62392 .32666 L 1 .621 0 r
F
P
p
.59766 .32076 m .61216 .31788 L .62392 .32666 L 1 .724 0 r
F
P
p
.55656 .31766 m .58327 .32362 L .569 .32645 L 1 .905 0 r
F
P
p
.54228 .32054 m .55656 .31766 L .569 .32645 L .914 1 0 r
F
P
p
.002 w
.5522 .6121 m .53811 .63892 L .52537 .57073 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51131 .57884 m .52537 .57073 L .53811 .63892 L p
.629 1 0 r
F P
0 0 0 r
s
P
p
.50093 .31744 m .52811 .3234 L .51405 .32623 L .991 1 0 r
F
P
p
.48687 .32032 m .50093 .31744 L .51405 .32623 L .862 1 0 r
F
P
p
.44527 .31722 m .47292 .32318 L .45907 .32601 L .009 1 0 r
F
P
p
.43142 .3201 m .44527 .31722 L .45907 .32601 L 0 1 .353 r
F
P
p
.002 w
.4978 .64346 m .51131 .57884 L p
.49204 .67293 L .19 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48312 .71645 m .4978 .64346 L p
.49204 .67293 L .19 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4978 .64346 m .48458 .58016 L p
.50361 .61381 L .448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52537 .57073 m .51131 .57884 L .4978 .64346 L p
.578 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4978 .64346 m .51215 .62891 L .52537 .57073 L p
.578 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51215 .62891 m .4978 .64346 L p
.50361 .61381 L .448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56638 .60409 m .5522 .6121 L .53952 .56886 L p
.888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52537 .57073 m .53952 .56886 L .5522 .6121 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59497 .58161 m .60934 .56712 L .62128 .58538 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.38958 .31699 m .41769 .32296 L .40406 .3258 L 1 0 .931 r
F
P
p
.37595 .31988 m .38958 .31699 L .40406 .3258 L 1 0 0 r
F
P
p
.33385 .31677 m .36242 .32274 L .34901 .32558 L 1 0 0 r
F
P
p
.32043 .31966 m .33385 .31677 L .34901 .32558 L 1 0 0 r
F
P
p
.002 w
.77479 .53614 m .75973 .53814 L .74962 .53194 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.73453 .53397 m .74962 .53194 L .75973 .53814 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.45278 .90348 m .46674 .90293 L .4803 .90461 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.84968 .31588 m .87403 .32186 L .85858 .32471 L 1 0 0 r
F
P
p
.83419 .31877 m .84968 .31588 L .85858 .32471 L 1 0 0 r
F
P
p
.002 w
.71957 .53599 m .70472 .53799 L .69462 .56346 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.67969 .56537 m .69462 .56346 L .70472 .53799 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.794 .31566 m .81883 .32164 L .80358 .32449 L 1 .052 0 r
F
P
p
.77873 .31855 m .794 .31566 L .80358 .32449 L 1 .078 0 r
F
P
p
.002 w
.43893 .90403 m .42519 .90457 L .41094 .90289 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.3972 .90344 m .41094 .90289 L .42519 .90457 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.73829 .31543 m .76358 .32142 L .74856 .32427 L 1 .31 0 r
F
P
p
.72324 .31833 m .73829 .31543 L .74856 .32427 L 1 .31 0 r
F
P
p
.68255 .31521 m .70831 .3212 L .69349 .32405 L 1 .233 0 r
F
P
p
.66772 .31811 m .68255 .31521 L .69349 .32405 L 1 .388 0 r
F
P
p
.62677 .31498 m .653 .32098 L .6384 .32383 L 1 .569 0 r
F
P
p
.61216 .31788 m .62677 .31498 L .6384 .32383 L 1 .621 0 r
F
P
p
.002 w
.53952 .56886 m .52537 .57073 L .51215 .62891 L p
.733 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58066 .59604 m .56638 .60409 L .55378 .56698 L p
.94 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53952 .56886 m .55378 .56698 L .56638 .60409 L p
.888 1 0 r
F P
0 0 0 r
s
P
p
.57096 .31476 m .59766 .32076 L .58327 .32362 L 1 .828 0 r
F
P
p
.55656 .31766 m .57096 .31476 L .58327 .32362 L 1 .905 0 r
F
P
p
.51511 .31454 m .54228 .32054 L .52811 .3234 L 1 .931 0 r
F
P
p
.50093 .31744 m .51511 .31454 L .52811 .3234 L .991 1 0 r
F
P
p
.45923 .31431 m .48687 .32032 L .47292 .32318 L .345 1 0 r
F
P
p
.44527 .31722 m .45923 .31431 L .47292 .32318 L .009 1 0 r
F
P
p
.002 w
.65018 .56915 m .63577 .58357 L .62394 .56522 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.60934 .56712 m .62394 .56522 L .63577 .58357 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.40332 .31409 m .43142 .3201 L .41769 .32296 L 0 .819 1 r
F
P
p
.38958 .31699 m .40332 .31409 L .41769 .32296 L 1 0 .931 r
F
P
p
.34737 .31386 m .37595 .31988 L .36242 .32274 L 1 0 0 r
F
P
p
.33385 .31677 m .34737 .31386 L .36242 .32274 L 1 0 0 r
F
P
p
.29138 .31364 m .32043 .31966 L .30713 .32252 L 1 0 0 r
F
P
p
.002 w
.78975 .52786 m .77479 .53614 L .76482 .5299 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.74962 .53194 m .76482 .5299 L .77479 .53614 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.86529 .31296 m .88961 .31899 L .87403 .32186 L 1 0 0 r
F
P
p
.84968 .31588 m .86529 .31296 L .87403 .32186 L 1 0 0 r
F
P
p
.002 w
.73453 .53397 m .71957 .53599 L .70968 .56153 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.69462 .56346 m .70968 .56153 L .71957 .53599 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.45278 .90348 m .43893 .90403 L .42479 .90233 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.41094 .90289 m .42479 .90233 L .43893 .90403 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.8094 .31274 m .83419 .31877 L .81883 .32164 L 1 .026 0 r
F
P
p
.794 .31566 m .8094 .31274 L .81883 .32164 L 1 .052 0 r
F
P
p
.002 w
.59497 .58161 m .58066 .59604 L .56816 .56508 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.55378 .56698 m .56816 .56508 L .58066 .59604 L p
.94 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3972 .90344 m .38357 .90398 L .36875 .90229 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.75347 .31251 m .77873 .31855 L .76358 .32142 L 1 .181 0 r
F
P
p
.73829 .31543 m .75347 .31251 L .76358 .32142 L 1 .31 0 r
F
P
p
.002 w
.62394 .56522 m .63866 .56331 L .65018 .56915 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.6975 .31229 m .72324 .31833 L .70831 .3212 L 1 .181 0 r
F
P
p
.68255 .31521 m .6975 .31229 L .70831 .3212 L 1 .233 0 r
F
P
p
.64151 .31206 m .66772 .31811 L .653 .32098 L 1 .569 0 r
F
P
p
.62677 .31498 m .64151 .31206 L .653 .32098 L 1 .569 0 r
F
P
p
.002 w
.55378 .56698 m .53952 .56886 L .52657 .60785 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52657 .60785 m .53952 .56886 L p
.5177 .61674 L .733 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52657 .60785 m .54105 .60609 L .55378 .56698 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52657 .60785 m .51335 .56992 L p
.53553 .59888 L .759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54105 .60609 m .52657 .60785 L p
.53553 .59888 L .759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51215 .62891 m .52657 .60785 L p
.5177 .61674 L .733 1 0 r
F P
0 0 0 r
s
P
p
.58547 .31184 m .61216 .31788 L .59766 .32076 L 1 .802 0 r
F
P
p
.57096 .31476 m .58547 .31184 L .59766 .32076 L 1 .828 0 r
F
P
p
.52941 .31161 m .55656 .31766 L .54228 .32054 L 1 .828 0 r
F
P
p
.51511 .31454 m .52941 .31161 L .54228 .32054 L 1 .931 0 r
F
P
p
.4733 .31138 m .50093 .31744 L .48687 .32032 L .526 1 0 r
F
P
p
.45923 .31431 m .4733 .31138 L .48687 .32032 L .345 1 0 r
F
P
p
.41717 .31116 m .44527 .31722 L .43142 .3201 L 0 1 .121 r
F
P
p
.40332 .31409 m .41717 .31116 L .43142 .3201 L 0 .819 1 r
F
P
p
.002 w
.60934 .56712 m .59497 .58161 L .58265 .56316 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.58265 .56316 m .59497 .58161 L p
.57586 .56982 L 1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.58265 .56316 m .59715 .54847 L .60934 .56712 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.56816 .56508 m .58265 .56316 L p
.57586 .56982 L 1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.58265 .56316 m .56816 .56508 L .55564 .60431 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57023 .57654 m .58265 .56316 L p
.56473 .59046 L .914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55564 .60431 m .57023 .57654 L p
.56473 .59046 L .914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56816 .56508 m .55378 .56698 L .54105 .60609 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54105 .60609 m .55564 .60431 L .56816 .56508 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57023 .57654 m .5573 .55102 L p
.57579 .56246 L 1 .905 0 r
F P
0 0 0 r
s
P
p
.002 w
.58265 .56316 m .57023 .57654 L p
.58953 .55642 L 1 .905 0 r
F P
0 0 0 r
s
P
p
.002 w
.58497 .56814 m .59715 .54847 L p
.57326 .57338 L 1 .905 0 r
F P
0 0 0 r
s
P
p
.002 w
.57023 .57654 m .58497 .56814 L p
.57326 .57338 L 1 .905 0 r
F P
0 0 0 r
s
P
p
.002 w
.59715 .54847 m .58265 .56316 L p
.58953 .55642 L 1 .905 0 r
F P
0 0 0 r
s
P
p
.002 w
.62394 .56522 m .60934 .56712 L .59715 .54847 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.61179 .54009 m .62394 .56522 L p
.60015 .55034 L 1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.59715 .54847 m .61179 .54009 L p
.60015 .55034 L 1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.63866 .56331 m .62394 .56522 L .61179 .54009 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.61179 .54009 m .62644 .52527 L .63866 .56331 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.61179 .54009 m .59986 .56619 L p
.62352 .52976 L 1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.62644 .52527 m .61179 .54009 L p
.62352 .52976 L 1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.61179 .54009 m .59715 .54847 L .58497 .56814 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.58497 .56814 m .59986 .56619 L .61179 .54009 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.58497 .56814 m .57211 .53593 L p
.59679 .56284 L 1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.59986 .56619 m .58497 .56814 L p
.59679 .56284 L 1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.58497 .56814 m .57023 .57654 L p
.57579 .56246 L 1 .905 0 r
F P
0 0 0 r
s
P
p
.361 .31093 m .38958 .31699 L .37595 .31988 L 1 0 0 r
F
P
p
.34737 .31386 m .361 .31093 L .37595 .31988 L 1 0 0 r
F
P
p
.002 w
.8048 .51952 m .78975 .52786 L .77994 .52149 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.76482 .5299 m .77994 .52149 L .78975 .52786 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.30479 .3107 m .33385 .31677 L .32043 .31966 L 1 0 0 r
F
P
p
.29138 .31364 m .30479 .3107 L .32043 .31966 L 1 0 0 r
F
P
p
.88103 .31002 m .90532 .3161 L .88961 .31899 L 1 0 0 r
F
P
p
.86529 .31296 m .88103 .31002 L .88961 .31899 L 1 0 0 r
F
P
p
.002 w
.74962 .53194 m .73453 .53397 L .72419 .53403 L p
1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.70968 .56153 m .72419 .53403 L .73453 .53397 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.46674 .90293 m .45278 .90348 L .43876 .90177 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.42479 .90233 m .43876 .90177 L .45278 .90348 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.82491 .3098 m .84968 .31588 L .83419 .31877 L 1 0 0 r
F
P
p
.8094 .31274 m .82491 .3098 L .83419 .31877 L 1 .026 0 r
F
P
p
.76876 .30957 m .794 .31566 L .77873 .31855 L 1 .026 0 r
F
P
p
.75347 .31251 m .76876 .30957 L .77873 .31855 L 1 .181 0 r
F
P
p
.002 w
.41094 .90289 m .3972 .90344 L .38249 .90173 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.36875 .90229 m .38249 .90173 L .3972 .90344 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67969 .56537 m .66487 .56727 L .65349 .56138 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.63866 .56331 m .65349 .56138 L .66487 .56727 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.71258 .30934 m .73829 .31543 L .72324 .31833 L 1 .155 0 r
F
P
p
.6975 .31229 m .71258 .30934 L .72324 .31833 L 1 .181 0 r
F
P
p
.65636 .30911 m .68255 .31521 L .66772 .31811 L 1 .466 0 r
F
P
p
.64151 .31206 m .65636 .30911 L .66772 .31811 L 1 .569 0 r
F
P
p
.6001 .30889 m .62677 .31498 L .61216 .31788 L 1 .698 0 r
F
P
p
.58547 .31184 m .6001 .30889 L .61216 .31788 L 1 .802 0 r
F
P
p
.54381 .30866 m .57096 .31476 L .55656 .31766 L 1 .647 0 r
F
P
p
.52941 .31161 m .54381 .30866 L .55656 .31766 L 1 .828 0 r
F
P
p
.002 w
.8202 .51743 m .8048 .51952 L .79514 .51303 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.002 w
.77994 .52149 m .79514 .51303 L .8048 .51952 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.48749 .30843 m .51511 .31454 L .50093 .31744 L .655 1 0 r
F
P
p
.4733 .31138 m .48749 .30843 L .50093 .31744 L .526 1 0 r
F
P
p
.43113 .3082 m .45923 .31431 L .44527 .31722 L 0 1 .017 r
F
P
p
.41717 .31116 m .43113 .3082 L .44527 .31722 L 0 1 .121 r
F
P
p
.37474 .30797 m .40332 .31409 L .38958 .31699 L .034 0 1 r
F
P
p
.361 .31093 m .37474 .30797 L .38958 .31699 L 1 0 0 r
F
P
p
.31831 .30775 m .34737 .31386 L .33385 .31677 L 1 0 0 r
F
P
p
.30479 .3107 m .31831 .30775 L .33385 .31677 L 1 0 0 r
F
P
p
.89689 .30706 m .92115 .31319 L .90532 .3161 L 1 0 0 r
F
P
p
.88103 .31002 m .89689 .30706 L .90532 .3161 L 1 0 0 r
F
P
p
.002 w
.76482 .5299 m .74962 .53194 L .73925 .52559 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.72419 .53403 m .73925 .52559 L .74962 .53194 L p
1 .336 0 r
F P
0 0 0 r
s
P
p
.84056 .30683 m .86529 .31296 L .84968 .31588 L 1 0 0 r
F
P
p
.82491 .3098 m .84056 .30683 L .84968 .31588 L 1 0 0 r
F
P
p
.002 w
.43876 .90177 m .45283 .90121 L .46674 .90293 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.78418 .3066 m .8094 .31274 L .794 .31566 L 1 0 0 r
F
P
p
.76876 .30957 m .78418 .3066 L .794 .31566 L 1 .026 0 r
F
P
p
.002 w
.42479 .90233 m .41094 .90289 L .39634 .90116 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.38249 .90173 m .39634 .90116 L .41094 .90289 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69462 .56346 m .67969 .56537 L .66844 .55943 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.65349 .56138 m .66844 .55943 L .67969 .56537 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.72778 .30637 m .75347 .31251 L .73829 .31543 L 1 .155 0 r
F
P
p
.71258 .30934 m .72778 .30637 L .73829 .31543 L 1 .155 0 r
F
P
p
.67133 .30614 m .6975 .31229 L .68255 .31521 L 1 .284 0 r
F
P
p
.65636 .30911 m .67133 .30614 L .68255 .31521 L 1 .466 0 r
F
P
p
.61485 .30591 m .64151 .31206 L .62677 .31498 L 1 .595 0 r
F
P
p
.6001 .30889 m .61485 .30591 L .62677 .31498 L 1 .698 0 r
F
P
p
.55834 .30568 m .58547 .31184 L .57096 .31476 L 1 .569 0 r
F
P
p
.54381 .30866 m .55834 .30568 L .57096 .31476 L 1 .647 0 r
F
P
p
.002 w
.83546 .50899 m .8202 .51743 L .81069 .51088 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.79514 .51303 m .81069 .51088 L .8202 .51743 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.50179 .30545 m .52941 .31161 L .51511 .31454 L .836 1 0 r
F
P
p
.48749 .30843 m .50179 .30545 L .51511 .31454 L .655 1 0 r
F
P
p
.44521 .30522 m .4733 .31138 L .45923 .31431 L .06 1 0 r
F
P
p
.43113 .3082 m .44521 .30522 L .45923 .31431 L 0 1 .017 r
F
P
p
.38859 .30499 m .41717 .31116 L .40332 .31409 L 0 1 .043 r
F
P
p
.37474 .30797 m .38859 .30499 L .40332 .31409 L .034 0 1 r
F
P
p
.33193 .30476 m .361 .31093 L .34737 .31386 L 1 0 .491 r
F
P
p
.31831 .30775 m .33193 .30476 L .34737 .31386 L 1 0 0 r
F
P
p
.27524 .30453 m .30479 .3107 L .29138 .31364 L 1 0 0 r
F
P
p
.89689 .30706 m .91289 .30407 L .92115 .31319 L 1 0 0 r
F
P
p
.002 w
.77994 .52149 m .76482 .5299 L .7546 .5235 L p
1 .284 0 r
F P
0 0 0 r
s
P
p
.002 w
.73925 .52559 m .7546 .5235 L .76482 .5299 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.85633 .30384 m .88103 .31002 L .86529 .31296 L 1 0 0 r
F
P
p
.84056 .30683 m .85633 .30384 L .86529 .31296 L 1 0 0 r
F
P
p
.79973 .30361 m .82491 .3098 L .8094 .31274 L 1 0 0 r
F
P
p
.78418 .3066 m .79973 .30361 L .8094 .31274 L 1 0 0 r
F
P
p
.002 w
.43876 .90177 m .42479 .90233 L .41031 .90059 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.39634 .90116 m .41031 .90059 L .42479 .90233 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70968 .56153 m .69462 .56346 L .68338 .55104 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.66844 .55943 m .68338 .55104 L .69462 .56346 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.7431 .30338 m .76876 .30957 L .75347 .31251 L 1 .078 0 r
F
P
p
.72778 .30637 m .7431 .30338 L .75347 .31251 L 1 .155 0 r
F
P
p
.002 w
.38249 .90173 m .36875 .90229 L .35355 .90055 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65349 .56138 m .63866 .56331 L .62644 .52527 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.85109 .50684 m .83546 .50899 L .82637 .50872 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.81069 .51088 m .82637 .50872 L .83546 .50899 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.68643 .30315 m .71258 .30934 L .6975 .31229 L 1 .181 0 r
F
P
p
.67133 .30614 m .68643 .30315 L .6975 .31229 L 1 .284 0 r
F
P
p
.002 w
.45481 .71906 m .43858 .89944 L .42396 .89763 L p
.345 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42396 .89763 m .44151 .64979 L .45481 .71906 L p
.345 0 1 r
F P
0 0 0 r
s
P
p
.62972 .30292 m .65636 .30911 L .64151 .31206 L 1 .569 0 r
F
P
p
.61485 .30591 m .62972 .30292 L .64151 .31206 L 1 .595 0 r
F
P
p
.57298 .30268 m .6001 .30889 L .58547 .31184 L 1 .543 0 r
F
P
p
.55834 .30568 m .57298 .30268 L .58547 .31184 L 1 .569 0 r
F
P
p
.51621 .30245 m .54381 .30866 L .52941 .31161 L 1 .931 0 r
F
P
p
.50179 .30545 m .51621 .30245 L .52941 .31161 L .836 1 0 r
F
P
p
.4594 .30222 m .48749 .30843 L .4733 .31138 L .397 1 0 r
F
P
p
.44521 .30522 m .4594 .30222 L .4733 .31138 L .06 1 0 r
F
P
p
.40255 .30199 m .43113 .3082 L .41717 .31116 L .267 1 0 r
F
P
p
.38859 .30499 m .40255 .30199 L .41717 .31116 L 0 1 .043 r
F
P
p
.34567 .30176 m .37474 .30797 L .361 .31093 L .888 0 1 r
F
P
p
.33193 .30476 m .34567 .30176 L .361 .31093 L 1 0 .491 r
F
P
p
.002 w
.79514 .51303 m .77994 .52149 L .77008 .52138 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.7546 .5235 m .77008 .52138 L .77994 .52149 L p
1 .284 0 r
F P
0 0 0 r
s
P
p
.28875 .30152 m .31831 .30775 L .30479 .3107 L 1 0 0 r
F
P
p
.27524 .30453 m .28875 .30152 L .30479 .3107 L 1 0 0 r
F
P
p
.002 w
.4978 .64346 m .48312 .71645 L .47021 .60128 L p
.034 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47021 .60128 m .48458 .58016 L .4978 .64346 L p
.034 1 0 r
F P
0 0 0 r
s
P
p
.87223 .30083 m .89689 .30706 L .88103 .31002 L 1 0 0 r
F
P
p
.85633 .30384 m .87223 .30083 L .88103 .31002 L 1 0 0 r
F
P
p
.002 w
.45283 .90121 m .43876 .90177 L .42439 .90002 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.41031 .90059 m .42439 .90002 L .43876 .90177 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.8154 .30059 m .84056 .30683 L .82491 .3098 L 1 0 0 r
F
P
p
.79973 .30361 m .8154 .30059 L .82491 .3098 L 1 0 0 r
F
P
p
.002 w
.72419 .53403 m .70968 .56153 L .69799 .52333 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.68338 .55104 m .69799 .52333 L .70968 .56153 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.75854 .30036 m .78418 .3066 L .76876 .30957 L 1 0 0 r
F
P
p
.7431 .30338 m .75854 .30036 L .76876 .30957 L 1 .078 0 r
F
P
p
.002 w
.39634 .90116 m .38249 .90173 L .3674 .89998 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.35355 .90055 m .3674 .89998 L .38249 .90173 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66844 .55943 m .65349 .56138 L .64134 .52317 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.62644 .52527 m .64134 .52317 L .65349 .56138 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.86684 .50468 m .85109 .50684 L .8419 .50012 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82637 .50872 m .8419 .50012 L .85109 .50684 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.45574 .63525 m .46891 .71776 L p
.44524 .65906 L 0 1 .638 r
F P
0 0 0 r
s
P
p
.002 w
.44151 .64979 m .45574 .63525 L p
.44524 .65906 L 0 1 .638 r
F P
0 0 0 r
s
P
p
.002 w
.44151 .64979 m .42396 .89763 L .40897 .89577 L p
1 0 .957 r
F P
0 0 0 r
s
P
p
.002 w
.45574 .63525 m .44151 .64979 L .42353 .89516 L p
0 .793 1 r
F P
0 0 0 r
s
P
p
.002 w
.48312 .71645 m .46891 .71776 L .46515 .69422 L p
0 1 .457 r
F P
0 0 0 r
s
P
p
.002 w
.46515 .69422 m .45574 .63525 L p
.46763 .67051 L 0 1 .457 r
F P
0 0 0 r
s
P
p
.46763 .67051 m .48312 .71645 L .46515 .69422 L 0 1 .457 r
F
P
p
.002 w
.45574 .63525 m .47021 .60128 L .48312 .71645 L p
0 1 .457 r
F P
0 0 0 r
s
P
p
.002 w
.44096 .67623 m .45574 .63525 L p
.44694 .70628 L 0 .793 1 r
F P
0 0 0 r
s
P
p
.002 w
.42353 .89516 m .44096 .67623 L p
.44694 .70628 L 0 .793 1 r
F P
0 0 0 r
s
P
p
.002 w
.40897 .89577 m .42353 .89516 L .44151 .64979 L p
1 0 .957 r
F P
0 0 0 r
s
P
p
.002 w
.44096 .67623 m .42669 .6448 L p
.43491 .64576 L 0 1 .353 r
F P
0 0 0 r
s
P
p
.002 w
.45574 .63525 m .44096 .67623 L p
.46629 .61133 L 0 1 .095 r
F P
0 0 0 r
s
P
p
.002 w
.44096 .67623 m .45564 .6482 L .47021 .60128 L p
0 1 .095 r
F P
0 0 0 r
s
P
p
.43491 .64576 m .45325 .64792 L .44096 .67623 L 0 1 .353 r
F
P
p
.002 w
.45564 .6482 m .44096 .67623 L p
.45325 .64792 L 0 1 .353 r
F P
0 0 0 r
s
P
p
.002 w
.47021 .60128 m .45574 .63525 L p
.46629 .61133 L 0 1 .095 r
F P
0 0 0 r
s
P
p
.002 w
.47021 .60128 m .45564 .6482 L p
.48142 .5876 L .448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48458 .58016 m .47739 .59072 L p
.48142 .5876 L .448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47739 .59072 m .47021 .60128 L p
.48142 .5876 L .448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45564 .6482 m .47062 .58736 L .47665 .58425 L p
.448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47665 .58425 m .48458 .58016 L p
.47463 .60354 L .448 1 0 r
F P
0 0 0 r
s
P
p
.45564 .6482 m .47665 .58425 L .47463 .60354 L .448 1 0 r
F
P
p
.002 w
.48458 .58016 m .4989 .57828 L .51215 .62891 L p
.448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4989 .57828 m .48458 .58016 L .47062 .58736 L p
.784 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47062 .58736 m .48513 .57895 L .49304 .57856 L p
.784 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49304 .57856 m .4989 .57828 L p
.48954 .58129 L .784 1 0 r
F P
0 0 0 r
s
P
p
.47062 .58736 m .49304 .57856 L .48954 .58129 L .784 1 0 r
F
P
p
.002 w
.73925 .52559 m .72419 .53403 L .71324 .52122 L p
1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.69799 .52333 m .71324 .52122 L .72419 .53403 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.70165 .30013 m .72778 .30637 L .71258 .30934 L 1 .155 0 r
F
P
p
.68643 .30315 m .70165 .30013 L .71258 .30934 L 1 .181 0 r
F
P
p
.64472 .29989 m .67133 .30614 L .65636 .30911 L 1 .491 0 r
F
P
p
.62972 .30292 m .64472 .29989 L .65636 .30911 L 1 .569 0 r
F
P
p
.58775 .29966 m .61485 .30591 L .6001 .30889 L 1 .44 0 r
F
P
p
.57298 .30268 m .58775 .29966 L .6001 .30889 L 1 .543 0 r
F
P
p
.53074 .29943 m .55834 .30568 L .54381 .30866 L 1 .802 0 r
F
P
p
.51621 .30245 m .53074 .29943 L .54381 .30866 L 1 .931 0 r
F
P
p
.002 w
.52657 .60785 m .51215 .62891 L .4989 .57828 L p
.603 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.81069 .51088 m .79514 .51303 L .78524 .50637 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.77008 .52138 m .78524 .50637 L .79514 .51303 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.47371 .29919 m .50179 .30545 L .48749 .30843 L .681 1 0 r
F
P
p
.4594 .30222 m .47371 .29919 L .48749 .30843 L .397 1 0 r
F
P
p
.41663 .29896 m .44521 .30522 L .43113 .3082 L .552 1 0 r
F
P
p
.40255 .30199 m .41663 .29896 L .43113 .3082 L .267 1 0 r
F
P
p
.35952 .29873 m .38859 .30499 L .37474 .30797 L 0 .483 1 r
F
P
p
.34567 .30176 m .35952 .29873 L .37474 .30797 L .888 0 1 r
F
P
p
.30237 .29849 m .33193 .30476 L .31831 .30775 L 1 0 0 r
F
P
p
.28875 .30152 m .30237 .29849 L .31831 .30775 L 1 0 0 r
F
P
p
.002 w
.4989 .57828 m .51335 .56992 L .52657 .60785 L p
.603 1 0 r
F P
0 0 0 r
s
P
p
.88826 .29779 m .91289 .30407 L .89689 .30706 L 1 0 0 r
F
P
p
.87223 .30083 m .88826 .29779 L .89689 .30706 L 1 0 0 r
F
P
p
.002 w
.7546 .5235 m .73925 .52559 L .72862 .51908 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.71324 .52122 m .72862 .51908 L .73925 .52559 L p
1 .336 0 r
F P
0 0 0 r
s
P
p
.8312 .29755 m .85633 .30384 L .84056 .30683 L 1 0 0 r
F
P
p
.8154 .30059 m .8312 .29755 L .84056 .30683 L 1 0 0 r
F
P
p
.002 w
.42439 .90002 m .43858 .89944 L .45283 .90121 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.77411 .29732 m .79973 .30361 L .78418 .3066 L 1 0 0 r
F
P
p
.75854 .30036 m .77411 .29732 L .78418 .3066 L 1 0 0 r
F
P
p
.002 w
.41031 .90059 m .39634 .90116 L .38137 .8994 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.3674 .89998 m .38137 .8994 L .39634 .90116 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64134 .52317 m .62644 .52527 L .61488 .56423 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.59986 .56619 m .61488 .56423 L .62644 .52527 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.68338 .55104 m .66844 .55943 L .65637 .52105 L p
1 .543 0 r
F P
0 0 0 r
s
P
p
.002 w
.64134 .52317 m .65637 .52105 L .66844 .55943 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.88273 .50249 m .86684 .50468 L .85782 .4979 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8419 .50012 m .85782 .4979 L .86684 .50468 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.71699 .29708 m .7431 .30338 L .72778 .30637 L 1 .155 0 r
F
P
p
.70165 .30013 m .71699 .29708 L .72778 .30637 L 1 .155 0 r
F
P
p
.65983 .29685 m .68643 .30315 L .67133 .30614 L 1 .362 0 r
F
P
p
.64472 .29989 m .65983 .29685 L .67133 .30614 L 1 .491 0 r
F
P
p
.60263 .29661 m .62972 .30292 L .61485 .30591 L 1 .336 0 r
F
P
p
.58775 .29966 m .60263 .29661 L .61485 .30591 L 1 .44 0 r
F
P
p
.5454 .29638 m .57298 .30268 L .55834 .30568 L 1 .724 0 r
F
P
p
.53074 .29943 m .5454 .29638 L .55834 .30568 L 1 .802 0 r
F
P
p
.002 w
.82637 .50872 m .81069 .51088 L .80071 .49773 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.78524 .50637 m .80071 .49773 L .81069 .51088 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.48813 .29614 m .51621 .30245 L .50179 .30545 L .888 1 0 r
F
P
p
.47371 .29919 m .48813 .29614 L .50179 .30545 L .681 1 0 r
F
P
p
.43083 .29591 m .4594 .30222 L .44521 .30522 L .603 1 0 r
F
P
p
.41663 .29896 m .43083 .29591 L .44521 .30522 L .552 1 0 r
F
P
p
.37348 .29567 m .40255 .30199 L .38859 .30499 L 0 1 .121 r
F
P
p
.35952 .29873 m .37348 .29567 L .38859 .30499 L 0 .483 1 r
F
P
p
.31611 .29543 m .34567 .30176 L .33193 .30476 L .681 0 1 r
F
P
p
.30237 .29849 m .31611 .29543 L .33193 .30476 L 1 0 0 r
F
P
p
.002 w
.55564 .60431 m .54105 .60609 L .52791 .55503 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51335 .56992 m .52791 .55503 L .54105 .60609 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.25869 .2952 m .28875 .30152 L .27524 .30453 L 1 0 0 r
F
P
p
.002 w
.69799 .52333 m .68338 .55104 L .67151 .51892 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.002 w
.67151 .51892 m .68338 .55104 L p
.65908 .52407 L 1 .543 0 r
F P
0 0 0 r
s
P
p
.002 w
.67151 .51892 m .68665 .51029 L .69799 .52333 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.002 w
.67151 .51892 m .66045 .54504 L p
.68407 .51372 L 1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.68665 .51029 m .67151 .51892 L p
.68407 .51372 L 1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.65637 .52105 m .67151 .51892 L p
.65908 .52407 L 1 .543 0 r
F P
0 0 0 r
s
P
p
.88826 .29779 m .90442 .29472 L .91289 .30407 L 1 0 0 r
F
P
p
.002 w
.77008 .52138 m .7546 .5235 L .74412 .51693 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.72862 .51908 m .74412 .51693 L .7546 .5235 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.51335 .56992 m .4989 .57828 L .48513 .57895 L p
.862 1 0 r
F P
0 0 0 r
s
P
p
.84714 .29449 m .87223 .30083 L .85633 .30384 L 1 0 0 r
F
P
p
.8312 .29755 m .84714 .29449 L .85633 .30384 L 1 0 0 r
F
P
p
.002 w
.71324 .52122 m .69799 .52333 L .68665 .51029 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.78982 .29425 m .8154 .30059 L .79973 .30361 L 1 0 0 r
F
P
p
.77411 .29732 m .78982 .29425 L .79973 .30361 L 1 0 0 r
F
P
p
.002 w
.42439 .90002 m .41031 .90059 L .39545 .89881 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.38137 .8994 m .39545 .89881 L .41031 .90059 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65637 .52105 m .64134 .52317 L .62984 .54915 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.62984 .54915 m .64134 .52317 L p
.61975 .55667 L 1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.62984 .54915 m .64508 .5471 L .65637 .52105 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.62984 .54915 m .61726 .51642 L p
.64004 .54155 L 1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.64508 .5471 m .62984 .54915 L p
.64004 .54155 L 1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.61488 .56423 m .62984 .54915 L p
.61975 .55667 L 1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.89875 .50029 m .88273 .50249 L .87387 .49566 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85782 .4979 m .87387 .49566 L .88273 .50249 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.73246 .29401 m .75854 .30036 L .7431 .30338 L 1 .155 0 r
F
P
p
.71699 .29708 m .73246 .29401 L .7431 .30338 L 1 .155 0 r
F
P
p
.002 w
.3674 .89998 m .35355 .90055 L .33797 .89877 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67507 .29378 m .70165 .30013 L .68643 .30315 L 1 .31 0 r
F
P
p
.65983 .29685 m .67507 .29378 L .68643 .30315 L 1 .362 0 r
F
P
p
.61764 .29354 m .64472 .29989 L .62972 .30292 L 1 .31 0 r
F
P
p
.60263 .29661 m .61764 .29354 L .62972 .30292 L 1 .336 0 r
F
P
p
.56018 .2933 m .58775 .29966 L .57298 .30268 L 1 .672 0 r
F
P
p
.5454 .29638 m .56018 .2933 L .57298 .30268 L 1 .724 0 r
F
P
p
.002 w
.8419 .50012 m .82637 .50872 L .81653 .49548 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.80071 .49773 m .81653 .49548 L .82637 .50872 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.50268 .29306 m .53074 .29943 L .51621 .30245 L 1 .905 0 r
F
P
p
.48813 .29614 m .50268 .29306 L .51621 .30245 L .888 1 0 r
F
P
p
.44514 .29283 m .47371 .29919 L .4594 .30222 L .862 1 0 r
F
P
p
.43083 .29591 m .44514 .29283 L .4594 .30222 L .603 1 0 r
F
P
p
.38756 .29259 m .41663 .29896 L .40255 .30199 L .293 1 0 r
F
P
p
.37348 .29567 m .38756 .29259 L .40255 .30199 L 0 1 .121 r
F
P
p
.32995 .29235 m .35952 .29873 L .34567 .30176 L 0 .767 1 r
F
P
p
.31611 .29543 m .32995 .29235 L .34567 .30176 L .681 0 1 r
F
P
p
.002 w
.52791 .55503 m .51335 .56992 L .49974 .57047 L p
.991 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48513 .57895 m .49974 .57047 L .51335 .56992 L p
.862 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57023 .57654 m .55564 .60431 L .54254 .55304 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52791 .55503 m .54254 .55304 L .55564 .60431 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.27231 .29211 m .30237 .29849 L .28875 .30152 L 1 0 0 r
F
P
p
.25869 .2952 m .27231 .29211 L .28875 .30152 L 1 0 0 r
F
P
p
.002 w
.54254 .55304 m .5573 .55102 L .57023 .57654 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.78524 .50637 m .77008 .52138 L .75976 .51476 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.74412 .51693 m .75976 .51476 L .77008 .52138 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.8632 .2914 m .88826 .29779 L .87223 .30083 L 1 0 0 r
F
P
p
.84714 .29449 m .8632 .2914 L .87223 .30083 L 1 0 0 r
F
P
p
.002 w
.72862 .51908 m .71324 .52122 L .70189 .50161 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.68665 .51029 m .70189 .50161 L .71324 .52122 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.80565 .29116 m .8312 .29755 L .8154 .30059 L 1 0 0 r
F
P
p
.78982 .29425 m .80565 .29116 L .8154 .30059 L 1 0 0 r
F
P
p
.002 w
.43858 .89944 m .42439 .90002 L .40965 .89822 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.39545 .89881 m .40965 .89822 L .42439 .90002 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67151 .51892 m .65637 .52105 L .64508 .5471 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.91489 .49807 m .89875 .50029 L .89005 .4934 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.87387 .49566 m .89005 .4934 L .89875 .50029 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.74806 .29092 m .77411 .29732 L .75854 .30036 L 1 .155 0 r
F
P
p
.73246 .29401 m .74806 .29092 L .75854 .30036 L 1 .155 0 r
F
P
p
.002 w
.38137 .8994 m .3674 .89998 L .35193 .89818 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.33797 .89877 m .35193 .89818 L .3674 .89998 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85782 .4979 m .8419 .50012 L .83248 .49322 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81653 .49548 m .83248 .49322 L .8419 .50012 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.69044 .29068 m .71699 .29708 L .70165 .30013 L 1 .31 0 r
F
P
p
.67507 .29378 m .69044 .29068 L .70165 .30013 L 1 .31 0 r
F
P
p
.63277 .29044 m .65983 .29685 L .64472 .29989 L 1 .31 0 r
F
P
p
.61764 .29354 m .63277 .29044 L .64472 .29989 L 1 .31 0 r
F
P
p
.002 w
.49974 .57047 m .51444 .56194 L .52791 .55503 L p
.991 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54254 .55304 m .52791 .55503 L .51444 .56194 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.57508 .2902 m .60263 .29661 L .58775 .29966 L 1 .621 0 r
F
P
p
.56018 .2933 m .57508 .2902 L .58775 .29966 L 1 .672 0 r
F
P
p
.51734 .28996 m .5454 .29638 L .53074 .29943 L 1 .828 0 r
F
P
p
.50268 .29306 m .51734 .28996 L .53074 .29943 L 1 .905 0 r
F
P
p
.002 w
.80071 .49773 m .78524 .50637 L .77487 .49305 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.75976 .51476 m .77487 .49305 L .78524 .50637 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.45957 .28972 m .48813 .29614 L .47371 .29919 L 1 .931 0 r
F
P
p
.44514 .29283 m .45957 .28972 L .47371 .29919 L .862 1 0 r
F
P
p
.40176 .28948 m .43083 .29591 L .41663 .29896 L .552 1 0 r
F
P
p
.38756 .29259 m .40176 .28948 L .41663 .29896 L .293 1 0 r
F
P
p
.002 w
.5573 .55102 m .57211 .53593 L .58497 .56814 L p
1 .905 0 r
F P
0 0 0 r
s
P
p
.34392 .28924 m .37348 .29567 L .35952 .29873 L 0 1 .69 r
F
P
p
.32995 .29235 m .34392 .28924 L .35952 .29873 L 0 .767 1 r
F
P
p
.28603 .289 m .31611 .29543 L .30237 .29849 L 1 0 0 r
F
P
p
.27231 .29211 m .28603 .289 L .30237 .29849 L 1 0 0 r
F
P
p
.8794 .28828 m .90442 .29472 L .88826 .29779 L 1 0 0 r
F
P
p
.8632 .2914 m .8794 .28828 L .88826 .29779 L 1 0 0 r
F
P
p
.002 w
.74412 .51693 m .72862 .51908 L .71722 .49287 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.70189 .50161 m .71722 .49287 L .72862 .51908 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.82161 .28804 m .84714 .29449 L .8312 .29755 L 1 0 0 r
F
P
p
.80565 .29116 m .82161 .28804 L .8312 .29755 L 1 0 0 r
F
P
p
.002 w
.40965 .89822 m .42396 .89763 L .43858 .89944 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64508 .5471 m .66045 .54504 L .67151 .51892 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.93117 .49583 m .91489 .49807 L .90637 .49112 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.89005 .4934 m .90637 .49112 L .91489 .49807 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.76379 .2878 m .78982 .29425 L .77411 .29732 L 1 .103 0 r
F
P
p
.74806 .29092 m .76379 .2878 L .77411 .29732 L 1 .155 0 r
F
P
p
.002 w
.39545 .89881 m .38137 .8994 L .36601 .89759 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.35193 .89818 m .36601 .89759 L .38137 .8994 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.87387 .49566 m .85782 .4979 L .84856 .49094 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83248 .49322 m .84856 .49094 L .85782 .4979 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70593 .28756 m .73246 .29401 L .71699 .29708 L 1 .31 0 r
F
P
p
.69044 .29068 m .70593 .28756 L .71699 .29708 L 1 .31 0 r
F
P
p
.002 w
.81653 .49548 m .80071 .49773 L .79072 .49077 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77487 .49305 m .79072 .49077 L .80071 .49773 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.64803 .28731 m .67507 .29378 L .65983 .29685 L 1 .31 0 r
F
P
p
.63277 .29044 m .64803 .28731 L .65983 .29685 L 1 .31 0 r
F
P
p
.002 w
.5573 .55102 m .54254 .55304 L .52923 .55995 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.51444 .56194 m .52923 .55995 L .54254 .55304 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.5901 .28707 m .61764 .29354 L .60263 .29661 L 1 .491 0 r
F
P
p
.57508 .2902 m .5901 .28707 L .60263 .29661 L 1 .621 0 r
F
P
p
.53213 .28683 m .56018 .2933 L .5454 .29638 L 1 .672 0 r
F
P
p
.51734 .28996 m .53213 .28683 L .5454 .29638 L 1 .828 0 r
F
P
p
.002 w
.47062 .58736 m .45564 .6482 L .44124 .63646 L p
.009 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48513 .57895 m .47062 .58736 L .45582 .63477 L p
.345 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44124 .63646 m .45582 .63477 L .47062 .58736 L p
.009 1 0 r
F P
0 0 0 r
s
P
p
.47412 .28659 m .50268 .29306 L .48813 .29614 L 1 .879 0 r
F
P
p
.45957 .28972 m .47412 .28659 L .48813 .29614 L 1 .931 0 r
F
P
p
.41608 .28635 m .44514 .29283 L .43083 .29591 L .681 1 0 r
F
P
p
.40176 .28948 m .41608 .28635 L .43083 .29591 L .552 1 0 r
F
P
p
.002 w
.61488 .56423 m .59986 .56619 L .58709 .53383 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.57211 .53593 m .58709 .53383 L .59986 .56619 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.35799 .28611 m .38756 .29259 L .37348 .29567 L 0 1 .121 r
F
P
p
.34392 .28924 m .35799 .28611 L .37348 .29567 L 0 1 .69 r
F
P
p
.29987 .28586 m .32995 .29235 L .31611 .29543 L 1 0 .828 r
F
P
p
.28603 .289 m .29987 .28586 L .31611 .29543 L 1 0 0 r
F
P
p
.24172 .28562 m .27231 .29211 L .25869 .2952 L 1 0 0 r
F
P
p
.002 w
.67556 .52316 m .68665 .51029 L p
.66487 .53918 L 1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.66045 .54504 m .67556 .52316 L p
.66487 .53918 L 1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.67556 .52316 m .66351 .50312 L p
.68633 .50703 L 1 .362 0 r
F P
0 0 0 r
s
P
p
.002 w
.70189 .50161 m .68665 .51029 L .67556 .52316 L p
1 .284 0 r
F P
0 0 0 r
s
P
p
.002 w
.69085 .5078 m .67556 .52316 L p
.68633 .50703 L 1 .362 0 r
F P
0 0 0 r
s
P
p
.8794 .28828 m .89573 .28514 L .90442 .29472 L 1 0 0 r
F
P
p
.002 w
.75976 .51476 m .74412 .51693 L .73284 .49059 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.71722 .49287 m .73284 .49059 L .74412 .51693 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.83771 .28489 m .8632 .2914 L .84714 .29449 L 1 0 0 r
F
P
p
.82161 .28804 m .83771 .28489 L .84714 .29449 L 1 0 0 r
F
P
p
.002 w
.90637 .49112 m .92283 .48882 L .93117 .49583 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.77965 .28465 m .80565 .29116 L .78982 .29425 L 1 .026 0 r
F
P
p
.76379 .2878 m .77965 .28465 L .78982 .29425 L 1 .103 0 r
F
P
p
.002 w
.40965 .89822 m .39545 .89881 L .38021 .89699 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.36601 .89759 m .38021 .89699 L .39545 .89881 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.89005 .4934 m .87387 .49566 L .86478 .48864 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84856 .49094 m .86478 .48864 L .87387 .49566 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.72155 .28441 m .74806 .29092 L .73246 .29401 L 1 .31 0 r
F
P
p
.70593 .28756 m .72155 .28441 L .73246 .29401 L 1 .31 0 r
F
P
p
.002 w
.35193 .89818 m .33797 .89877 L .32199 .89694 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.49974 .57047 m .48513 .57895 L .47069 .61293 L p
.526 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47069 .61293 m .48513 .57895 L p
.46007 .62668 L .345 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48557 .59771 m .49974 .57047 L p
.47315 .60934 L .526 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47069 .61293 m .48557 .59771 L p
.47315 .60934 L .526 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51444 .56194 m .49974 .57047 L .48557 .59771 L p
.655 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48557 .59771 m .50048 .58912 L .51444 .56194 L p
.655 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48557 .59771 m .47153 .55146 L p
.49808 .586 L .681 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50048 .58912 m .48557 .59771 L p
.49808 .586 L .681 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47069 .61293 m .45615 .60732 L p
.4814 .59907 L .397 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48557 .59771 m .47069 .61293 L p
.4814 .59907 L .397 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45582 .63477 m .47069 .61293 L p
.46007 .62668 L .345 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.83248 .49322 m .81653 .49548 L .8067 .48847 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79072 .49077 m .8067 .48847 L .81653 .49548 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.44096 .67623 m .42353 .89516 L .40826 .89324 L p
.241 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.40826 .89324 m .42669 .6448 L .44096 .67623 L p
.241 0 1 r
F P
0 0 0 r
s
P
p
.66342 .28416 m .69044 .29068 L .67507 .29378 L 1 .31 0 r
F
P
p
.64803 .28731 m .66342 .28416 L .67507 .29378 L 1 .31 0 r
F
P
p
.002 w
.57211 .53593 m .5573 .55102 L .54412 .53156 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.52923 .55995 m .54412 .53156 L .5573 .55102 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.60525 .28392 m .63277 .29044 L .61764 .29354 L 1 .362 0 r
F
P
p
.5901 .28707 m .60525 .28392 L .61764 .29354 L 1 .491 0 r
F
P
p
.002 w
.42669 .6448 m .44124 .63646 L .45564 .6482 L p
0 1 .353 r
F P
0 0 0 r
s
P
p
.54704 .28368 m .57508 .2902 L .56018 .2933 L 1 .569 0 r
F
P
p
.53213 .28683 m .54704 .28368 L .56018 .2933 L 1 .672 0 r
F
P
p
.48879 .28343 m .51734 .28996 L .50268 .29306 L 1 .802 0 r
F
P
p
.47412 .28659 m .48879 .28343 L .50268 .29306 L 1 .879 0 r
F
P
p
.43051 .28319 m .45957 .28972 L .44514 .29283 L .81 1 0 r
F
P
p
.41608 .28635 m .43051 .28319 L .44514 .29283 L .681 1 0 r
F
P
p
.002 w
.71722 .49287 m .70189 .50161 L .69085 .5078 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.69085 .5078 m .67922 .50083 L p
.69294 .5032 L 1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.69085 .5078 m .70189 .50161 L p
.6888 .51232 L 1 .284 0 r
F P
0 0 0 r
s
P
p
.002 w
.69085 .5078 m .70653 .50556 L .71722 .49287 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.70653 .50556 m .69085 .5078 L p
.69294 .5032 L 1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.67556 .52316 m .69085 .5078 L p
.6888 .51232 L 1 .284 0 r
F P
0 0 0 r
s
P
p
.002 w
.62984 .54915 m .61488 .56423 L .60212 .52516 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.58709 .53383 m .60212 .52516 L .61488 .56423 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.37219 .28294 m .40176 .28948 L .38756 .29259 L .086 1 0 r
F
P
p
.35799 .28611 m .37219 .28294 L .38756 .29259 L 0 1 .121 r
F
P
p
.31383 .2827 m .34392 .28924 L .32995 .29235 L 0 .483 1 r
F
P
p
.29987 .28586 m .31383 .2827 L .32995 .29235 L 1 0 .828 r
F
P
p
.25544 .28246 m .28603 .289 L .27231 .29211 L 1 0 0 r
F
P
p
.24172 .28562 m .25544 .28246 L .27231 .29211 L 1 0 0 r
F
P
p
.002 w
.58709 .53383 m .57211 .53593 L .55908 .52283 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.54412 .53156 m .55908 .52283 L .57211 .53593 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.77487 .49305 m .75976 .51476 L .74858 .48829 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.73284 .49059 m .74858 .48829 L .75976 .51476 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.85394 .28172 m .8794 .28828 L .8632 .2914 L 1 0 0 r
F
P
p
.83771 .28489 m .85394 .28172 L .8632 .2914 L 1 0 0 r
F
P
p
.79564 .28148 m .82161 .28804 L .80565 .29116 L 1 0 0 r
F
P
p
.77965 .28465 m .79564 .28148 L .80565 .29116 L 1 .026 0 r
F
P
p
.002 w
.42396 .89763 m .40965 .89822 L .39453 .89638 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.38021 .89699 m .39453 .89638 L .40965 .89822 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.90637 .49112 m .89005 .4934 L .88114 .48633 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.86478 .48864 m .88114 .48633 L .89005 .4934 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.73731 .28123 m .76379 .2878 L .74806 .29092 L 1 .233 0 r
F
P
p
.72155 .28441 m .73731 .28123 L .74806 .29092 L 1 .31 0 r
F
P
p
.002 w
.36601 .89759 m .35193 .89818 L .33607 .89634 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.32199 .89694 m .33607 .89634 L .35193 .89818 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60212 .52516 m .61726 .51642 L .62984 .54915 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.84856 .49094 m .83248 .49322 L .82282 .48615 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8067 .48847 m .82282 .48615 L .83248 .49322 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67894 .28099 m .70593 .28756 L .69044 .29068 L 1 .259 0 r
F
P
p
.66342 .28416 m .67894 .28099 L .69044 .29068 L 1 .31 0 r
F
P
p
.002 w
.79072 .49077 m .77487 .49305 L .76446 .48597 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74858 .48829 m .76446 .48597 L .77487 .49305 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.62053 .28074 m .64803 .28731 L .63277 .29044 L 1 .31 0 r
F
P
p
.60525 .28392 m .62053 .28074 L .63277 .29044 L 1 .362 0 r
F
P
p
.002 w
.73284 .49059 m .71722 .49287 L .70653 .50556 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.56208 .2805 m .5901 .28707 L .57508 .2902 L 1 .569 0 r
F
P
p
.54704 .28368 m .56208 .2805 L .57508 .2902 L 1 .569 0 r
F
P
p
.50359 .28025 m .53213 .28683 L .51734 .28996 L 1 .724 0 r
F
P
p
.48879 .28343 m .50359 .28025 L .51734 .28996 L 1 .802 0 r
F
P
p
.44507 .28 m .47412 .28659 L .45957 .28972 L .81 1 0 r
F
P
p
.43051 .28319 m .44507 .28 L .45957 .28972 L .81 1 0 r
F
P
p
.38651 .27976 m .41608 .28635 L .40176 .28948 L .216 1 0 r
F
P
p
.37219 .28294 m .38651 .27976 L .40176 .28948 L .086 1 0 r
F
P
p
.32791 .27951 m .35799 .28611 L .34392 .28924 L 0 1 .276 r
F
P
p
.31383 .2827 m .32791 .27951 L .34392 .28924 L 0 .483 1 r
F
P
p
.002 w
.52923 .55995 m .51444 .56194 L .50048 .58912 L p
.836 1 0 r
F P
0 0 0 r
s
P
p
.26927 .27926 m .29987 .28586 L .28603 .289 L 1 0 .698 r
F
P
p
.25544 .28246 m .26927 .27926 L .28603 .289 L 1 0 0 r
F
P
p
.002 w
.60212 .52516 m .58709 .53383 L .57418 .52065 L p
1 .543 0 r
F P
0 0 0 r
s
P
p
.002 w
.55908 .52283 m .57418 .52065 L .58709 .53383 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.87031 .27852 m .89573 .28514 L .8794 .28828 L 1 0 0 r
F
P
p
.85394 .28172 m .87031 .27852 L .8794 .28828 L 1 0 0 r
F
P
p
.81177 .27828 m .83771 .28489 L .82161 .28804 L 1 0 0 r
F
P
p
.79564 .28148 m .81177 .27828 L .82161 .28804 L 1 0 0 r
F
P
p
.002 w
.39453 .89638 m .40897 .89577 L .42396 .89763 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.92283 .48882 m .90637 .49112 L .89763 .48399 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.88114 .48633 m .89763 .48399 L .90637 .49112 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7532 .27803 m .77965 .28465 L .76379 .2878 L 1 .103 0 r
F
P
p
.73731 .28123 m .7532 .27803 L .76379 .2878 L 1 .233 0 r
F
P
p
.002 w
.38021 .89699 m .36601 .89759 L .35026 .89573 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.33607 .89634 m .35026 .89573 L .36601 .89759 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66045 .54504 m .64508 .5471 L .6325 .50763 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.61726 .51642 m .6325 .50763 L .64508 .5471 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.86478 .48864 m .84856 .49094 L .83907 .48381 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82282 .48615 m .83907 .48381 L .84856 .49094 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69458 .27778 m .72155 .28441 L .70593 .28756 L 1 .181 0 r
F
P
p
.67894 .28099 m .69458 .27778 L .70593 .28756 L 1 .259 0 r
F
P
p
.002 w
.8067 .48847 m .79072 .49077 L .78047 .48363 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76446 .48597 m .78047 .48363 L .79072 .49077 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.63593 .27753 m .66342 .28416 L .64803 .28731 L 1 .31 0 r
F
P
p
.62053 .28074 m .63593 .27753 L .64803 .28731 L 1 .31 0 r
F
P
p
.002 w
.74858 .48829 m .73284 .49059 L .72235 .50329 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.70653 .50556 m .72235 .50329 L .73284 .49059 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.57724 .27729 m .60525 .28392 L .5901 .28707 L 1 .491 0 r
F
P
p
.56208 .2805 m .57724 .27729 L .5901 .28707 L 1 .569 0 r
F
P
p
.002 w
.44124 .63646 m .42669 .6448 L .41182 .63292 L p
0 1 .121 r
F P
0 0 0 r
s
P
p
.002 w
.42669 .6448 m .40826 .89324 L .39724 .64134 L p
0 .819 1 r
F P
0 0 0 r
s
P
p
.002 w
.39724 .64134 m .41182 .63292 L .42669 .6448 L p
0 .819 1 r
F P
0 0 0 r
s
P
p
.51851 .27704 m .54704 .28368 L .53213 .28683 L 1 .569 0 r
F
P
p
.50359 .28025 m .51851 .27704 L .53213 .28683 L 1 .724 0 r
F
P
p
.45975 .27679 m .48879 .28343 L .47412 .28659 L .862 1 0 r
F
P
p
.44507 .28 m .45975 .27679 L .47412 .28659 L .81 1 0 r
F
P
p
.002 w
.61726 .51642 m .60212 .52516 L .58941 .51845 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.58941 .51845 m .60212 .52516 L p
.58542 .52246 L 1 .543 0 r
F P
0 0 0 r
s
P
p
.002 w
.58941 .51845 m .60464 .50294 L .61726 .51642 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.58941 .51845 m .57648 .53178 L p
.59347 .51438 L 1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.60464 .50294 m .58941 .51845 L p
.59347 .51438 L 1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.57418 .52065 m .58941 .51845 L p
.58542 .52246 L 1 .543 0 r
F P
0 0 0 r
s
P
p
.40094 .27654 m .43051 .28319 L .41608 .28635 L .371 1 0 r
F
P
p
.38651 .27976 m .40094 .27654 L .41608 .28635 L .216 1 0 r
F
P
p
.3421 .27629 m .37219 .28294 L .35799 .28611 L .19 1 0 r
F
P
p
.32791 .27951 m .3421 .27629 L .35799 .28611 L 0 1 .276 r
F
P
p
.002 w
.54412 .53156 m .52923 .55995 L .51556 .55369 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.002 w
.50048 .58912 m .51556 .55369 L .52923 .55995 L p
.836 1 0 r
F P
0 0 0 r
s
P
p
.28322 .27605 m .31383 .2827 L .29987 .28586 L .267 0 1 r
F
P
p
.26927 .27926 m .28322 .27605 L .29987 .28586 L 1 0 .698 r
F
P
p
.2243 .2758 m .25544 .28246 L .24172 .28562 L 1 0 0 r
F
P
p
.002 w
.55908 .52283 m .54412 .53156 L .53062 .55162 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.51556 .55369 m .53062 .55162 L .54412 .53156 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.87031 .27852 m .88682 .2753 L .89573 .28514 L 1 0 0 r
F
P
p
.82804 .27505 m .85394 .28172 L .83771 .28489 L 1 0 0 r
F
P
p
.81177 .27828 m .82804 .27505 L .83771 .28489 L 1 0 0 r
F
P
p
.002 w
.89763 .48399 m .91426 .48163 L .92283 .48882 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.76922 .2748 m .79564 .28148 L .77965 .28465 L 1 .026 0 r
F
P
p
.7532 .27803 m .76922 .2748 L .77965 .28465 L 1 .103 0 r
F
P
p
.002 w
.39453 .89638 m .38021 .89699 L .36458 .89511 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.35026 .89573 m .36458 .89511 L .38021 .89699 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67556 .52316 m .66045 .54504 L .64794 .50538 L p
1 .491 0 r
F P
0 0 0 r
s
P
p
.002 w
.6325 .50763 m .64794 .50538 L .66045 .54504 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.88114 .48633 m .86478 .48864 L .85546 .48145 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83907 .48381 m .85546 .48145 L .86478 .48864 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.45582 .63477 m .44124 .63646 L .42669 .61098 L p
0 1 .017 r
F P
0 0 0 r
s
P
p
.002 w
.41182 .63292 m .42669 .61098 L .44124 .63646 L p
0 1 .121 r
F P
0 0 0 r
s
P
p
.71036 .27455 m .73731 .28123 L .72155 .28441 L 1 .155 0 r
F
P
p
.69458 .27778 m .71036 .27455 L .72155 .28441 L 1 .181 0 r
F
P
p
.002 w
.33607 .89634 m .32199 .89694 L .30559 .89506 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82282 .48615 m .8067 .48847 L .79662 .48127 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78047 .48363 m .79662 .48127 L .8067 .48847 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.65147 .2743 m .67894 .28099 L .66342 .28416 L 1 .259 0 r
F
P
p
.63593 .27753 m .65147 .2743 L .66342 .28416 L 1 .31 0 r
F
P
p
.002 w
.76446 .48597 m .74858 .48829 L .7383 .50101 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.72235 .50329 m .7383 .50101 L .74858 .48829 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.6325 .50763 m .61726 .51642 L .60464 .50294 L p
1 .336 0 r
F P
0 0 0 r
s
P
p
.59253 .27405 m .62053 .28074 L .60525 .28392 L 1 .31 0 r
F
P
p
.57724 .27729 m .59253 .27405 L .60525 .28392 L 1 .491 0 r
F
P
p
.53356 .2738 m .56208 .2805 L .54704 .28368 L 1 .388 0 r
F
P
p
.51851 .27704 m .53356 .2738 L .54704 .28368 L 1 .569 0 r
F
P
p
.002 w
.64794 .50538 m .66351 .50312 L .67556 .52316 L p
1 .491 0 r
F P
0 0 0 r
s
P
p
.47455 .27355 m .50359 .28025 L .48879 .28343 L .991 1 0 r
F
P
p
.45975 .27679 m .47455 .27355 L .48879 .28343 L .862 1 0 r
F
P
p
.4155 .2733 m .44507 .28 L .43051 .28319 L .5 1 0 r
F
P
p
.40094 .27654 m .4155 .2733 L .43051 .28319 L .371 1 0 r
F
P
p
.002 w
.57418 .52065 m .55908 .52283 L .5458 .54954 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.53062 .55162 m .5458 .54954 L .55908 .52283 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.35642 .27305 m .38651 .27976 L .37219 .28294 L .267 1 0 r
F
P
p
.3421 .27629 m .35642 .27305 L .37219 .28294 L .19 1 0 r
F
P
p
.29729 .2728 m .32791 .27951 L .31383 .2827 L 0 .922 1 r
F
P
p
.28322 .27605 m .29729 .2728 L .31383 .2827 L .267 0 1 r
F
P
p
.23813 .27255 m .26927 .27926 L .25544 .28246 L 1 0 0 r
F
P
p
.2243 .2758 m .23813 .27255 L .25544 .28246 L 1 0 0 r
F
P
p
.84444 .27179 m .87031 .27852 L .85394 .28172 L 1 0 0 r
F
P
p
.82804 .27505 m .84444 .27179 L .85394 .28172 L 1 0 0 r
F
P
p
.002 w
.66351 .50312 m .67922 .50083 L .69085 .5078 L p
1 .362 0 r
F P
0 0 0 r
s
P
p
.78538 .27154 m .81177 .27828 L .79564 .28148 L 1 0 0 r
F
P
p
.76922 .2748 m .78538 .27154 L .79564 .28148 L 1 .026 0 r
F
P
p
.002 w
.40897 .89577 m .39453 .89638 L .37902 .89449 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.36458 .89511 m .37902 .89449 L .39453 .89638 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64794 .50538 m .6325 .50763 L .6201 .50065 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.60464 .50294 m .6201 .50065 L .6325 .50763 L p
1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.89763 .48399 m .88114 .48633 L .87198 .47907 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85546 .48145 m .87198 .47907 L .88114 .48633 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.47069 .61293 m .45582 .63477 L .44136 .60916 L p
.06 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42669 .61098 m .44136 .60916 L .45582 .63477 L p
0 1 .017 r
F P
0 0 0 r
s
P
p
.72627 .27129 m .7532 .27803 L .73731 .28123 L 1 .078 0 r
F
P
p
.71036 .27455 m .72627 .27129 L .73731 .28123 L 1 .155 0 r
F
P
p
.002 w
.35026 .89573 m .33607 .89634 L .31978 .89444 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.30559 .89506 m .31978 .89444 L .33607 .89634 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83907 .48381 m .82282 .48615 L .8129 .47889 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79662 .48127 m .8129 .47889 L .82282 .48615 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66713 .27104 m .69458 .27778 L .67894 .28099 L 1 .155 0 r
F
P
p
.65147 .2743 m .66713 .27104 L .67894 .28099 L 1 .259 0 r
F
P
p
.002 w
.78047 .48363 m .76446 .48597 L .75438 .4987 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.7383 .50101 m .75438 .4987 L .76446 .48597 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.60796 .27079 m .63593 .27753 L .62053 .28074 L 1 .181 0 r
F
P
p
.59253 .27405 m .60796 .27079 L .62053 .28074 L 1 .31 0 r
F
P
p
.54874 .27054 m .57724 .27729 L .56208 .2805 L 1 .31 0 r
F
P
p
.53356 .2738 m .54874 .27054 L .56208 .2805 L 1 .388 0 r
F
P
p
.002 w
.37778 .89191 m .39724 .64134 L .40826 .89324 L p
1 0 .931 r
F P
0 0 0 r
s
P
p
.002 w
.41182 .63292 m .39724 .64134 L .38229 .60902 L p
0 1 .043 r
F P
0 0 0 r
s
P
p
.002 w
.39724 .64134 m .37778 .89191 L .36155 .8899 L p
.034 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.36155 .8899 m .38229 .60902 L .39724 .64134 L p
.034 0 1 r
F P
0 0 0 r
s
P
p
.48948 .27028 m .51851 .27704 L .50359 .28025 L 1 .879 0 r
F
P
p
.47455 .27355 m .48948 .27028 L .50359 .28025 L .991 1 0 r
F
P
p
.002 w
.44136 .60916 m .45615 .60732 L .47069 .61293 L p
.06 1 0 r
F P
0 0 0 r
s
P
p
.43019 .27003 m .45975 .27679 L .44507 .28 L .578 1 0 r
F
P
p
.4155 .2733 m .43019 .27003 L .44507 .28 L .5 1 0 r
F
P
p
.002 w
.56106 .53396 m .57418 .52065 L p
.55154 .5437 L 1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.5458 .54954 m .56106 .53396 L p
.55154 .5437 L 1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.56106 .53396 m .54742 .49331 L p
.57069 .52411 L 1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.58941 .51845 m .57418 .52065 L .56106 .53396 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.56106 .53396 m .57648 .53178 L .58941 .51845 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.57648 .53178 m .56106 .53396 L p
.57069 .52411 L 1 .569 0 r
F P
0 0 0 r
s
P
p
.37085 .26978 m .40094 .27654 L .38651 .27976 L .474 1 0 r
F
P
p
.35642 .27305 m .37085 .26978 L .38651 .27976 L .267 1 0 r
F
P
p
.31148 .26953 m .3421 .27629 L .32791 .27951 L .034 1 0 r
F
P
p
.29729 .2728 m .31148 .26953 L .32791 .27951 L 0 .922 1 r
F
P
p
.25207 .26927 m .28322 .27605 L .26927 .27926 L .603 0 1 r
F
P
p
.23813 .27255 m .25207 .26927 L .26927 .27926 L 1 0 0 r
F
P
p
.86098 .26851 m .88682 .2753 L .87031 .27852 L 1 0 0 r
F
P
p
.84444 .27179 m .86098 .26851 L .87031 .27852 L 1 0 0 r
F
P
p
.002 w
.72235 .50329 m .70653 .50556 L .69506 .49853 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.67922 .50083 m .69506 .49853 L .70653 .50556 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.45615 .60732 m .47153 .55146 L .48557 .59771 L p
.397 1 0 r
F P
0 0 0 r
s
P
p
.80167 .26826 m .82804 .27505 L .81177 .27828 L 1 0 0 r
F
P
p
.78538 .27154 m .80167 .26826 L .81177 .27828 L 1 0 0 r
F
P
p
.002 w
.42353 .89516 m .40897 .89577 L .39358 .89387 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.37902 .89449 m .39358 .89387 L .40897 .89577 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66351 .50312 m .64794 .50538 L .63569 .49835 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.6201 .50065 m .63569 .49835 L .64794 .50538 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.91426 .48163 m .89763 .48399 L .88865 .47667 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.87198 .47907 m .88865 .47667 L .89763 .48399 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.36458 .89511 m .35026 .89573 L .33409 .89382 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.31978 .89444 m .33409 .89382 L .35026 .89573 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.74232 .26801 m .76922 .2748 L .7532 .27803 L 1 0 0 r
F
P
p
.72627 .27129 m .74232 .26801 L .7532 .27803 L 1 .078 0 r
F
P
p
.002 w
.85546 .48145 m .83907 .48381 L .82932 .47649 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8129 .47889 m .82932 .47649 L .83907 .48381 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.42669 .61098 m .41182 .63292 L .39684 .60718 L p
.267 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.38229 .60902 m .39684 .60718 L p
.4005 .62376 L 0 1 .043 r
F P
0 0 0 r
s
P
p
.002 w
.38229 .60902 m .36155 .8899 L .34916 .71569 L p
0 .483 1 r
F P
0 0 0 r
s
P
p
.002 w
.36519 .65837 m .35018 .59744 L p
.37744 .61321 L 0 1 .121 r
F P
0 0 0 r
s
P
p
.002 w
.36519 .65837 m .37211 .63839 L p
.35467 .69712 L 0 .483 1 r
F P
0 0 0 r
s
P
p
.002 w
.37211 .63839 m .38229 .60902 L p
.37005 .64843 L 0 .483 1 r
F P
0 0 0 r
s
P
p
.34916 .71569 m .37211 .63839 L .37005 .64843 L 0 .483 1 r
F
P
p
.002 w
.39684 .60718 m .38229 .60902 L .36519 .65837 L p
0 1 .121 r
F P
0 0 0 r
s
P
p
.002 w
.38083 .61516 m .36519 .65837 L p
.38028 .61484 L 0 1 .121 r
F P
0 0 0 r
s
P
p
.37744 .61321 m .38028 .61484 L .36519 .65837 L 0 1 .121 r
F
P
p
.002 w
.34916 .71569 m .36519 .65837 L p
.35467 .69712 L 0 .483 1 r
F P
0 0 0 r
s
P
p
.002 w
.39684 .60718 m .38083 .61516 L p
.39311 .59033 L .293 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41241 .5513 m .39684 .60718 L p
.39311 .59033 L .293 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39591 .59951 m .41241 .5513 L p
.38724 .6022 L .293 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.38083 .61516 m .39591 .59951 L p
.38724 .6022 L .293 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39684 .60718 m .41241 .5513 L .42669 .61098 L p
.267 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44136 .60916 m .42669 .61098 L .41241 .5513 L p
.552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4271 .54922 m .44136 .60916 L p
.41563 .55774 L .552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41241 .5513 m .4271 .54922 L p
.41563 .55774 L .552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45615 .60732 m .44136 .60916 L .4271 .54922 L p
.603 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4271 .54922 m .44208 .53362 L .45615 .60732 L p
.603 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4271 .54922 m .41084 .59759 L p
.43867 .54062 L .681 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44208 .53362 m .4271 .54922 L p
.43867 .54062 L .681 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4271 .54922 m .41241 .5513 L .39591 .59951 L p
.552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39591 .59951 m .41084 .59759 L .4271 .54922 L p
.552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39591 .59951 m .37989 .59354 L p
.40469 .59679 L .216 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41084 .59759 m .39591 .59951 L p
.40469 .59679 L .216 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39591 .59951 m .38083 .61516 L .37769 .61127 L p
.086 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37769 .61127 m .36497 .5955 L p
.38051 .59752 L .086 1 0 r
F P
0 0 0 r
s
P
p
.38051 .59752 m .39591 .59951 L .37769 .61127 L .086 1 0 r
F
P
p
.002 w
.39684 .60718 m .41182 .63292 L p
.4005 .62376 L 0 1 .043 r
F P
0 0 0 r
s
P
p
.68294 .26775 m .71036 .27455 L .69458 .27778 L 1 .052 0 r
F
P
p
.66713 .27104 m .68294 .26775 L .69458 .27778 L 1 .155 0 r
F
P
p
.002 w
.79662 .48127 m .78047 .48363 L .77061 .49638 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.002 w
.75438 .4987 m .77061 .49638 L .78047 .48363 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.62351 .2675 m .65147 .2743 L .63593 .27753 L 1 .155 0 r
F
P
p
.60796 .27079 m .62351 .2675 L .63593 .27753 L 1 .181 0 r
F
P
p
.56404 .26724 m .59253 .27405 L .57724 .27729 L 1 .31 0 r
F
P
p
.54874 .27054 m .56404 .26724 L .57724 .27729 L 1 .31 0 r
F
P
p
.50454 .26699 m .53356 .2738 L .51851 .27704 L 1 .776 0 r
F
P
p
.48948 .27028 m .50454 .26699 L .51851 .27704 L 1 .879 0 r
F
P
p
.44499 .26673 m .47455 .27355 L .45975 .27679 L .707 1 0 r
F
P
p
.43019 .27003 m .44499 .26673 L .45975 .27679 L .578 1 0 r
F
P
p
.38541 .26648 m .4155 .2733 L .40094 .27654 L .681 1 0 r
F
P
p
.37085 .26978 m .38541 .26648 L .40094 .27654 L .474 1 0 r
F
P
p
.32579 .26622 m .35642 .27305 L .3421 .27629 L .448 1 0 r
F
P
p
.31148 .26953 m .32579 .26622 L .3421 .27629 L .034 1 0 r
F
P
p
.002 w
.53062 .55162 m .51556 .55369 L .50159 .53379 L p
1 .905 0 r
F P
0 0 0 r
s
P
p
.002 w
.51556 .55369 m .50048 .58912 L .48647 .54938 L p
.888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48647 .54938 m .50159 .53379 L .51556 .55369 L p
.888 1 0 r
F P
0 0 0 r
s
P
p
.26613 .26597 m .29729 .2728 L .28322 .27605 L 0 1 .845 r
F
P
p
.25207 .26927 m .26613 .26597 L .28322 .27605 L .603 0 1 r
F
P
p
.002 w
.47153 .55146 m .48647 .54938 L .50048 .58912 L p
.681 1 0 r
F P
0 0 0 r
s
P
p
.20643 .26571 m .23813 .27255 L .2243 .2758 L 1 0 0 r
F
P
p
.86098 .26851 m .87767 .2652 L .88682 .2753 L 1 0 0 r
F
P
p
.002 w
.7383 .50101 m .72235 .50329 L .71103 .4962 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.69506 .49853 m .71103 .4962 L .72235 .50329 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.81811 .26495 m .84444 .27179 L .82804 .27505 L 1 0 0 r
F
P
p
.80167 .26826 m .81811 .26495 L .82804 .27505 L 1 0 0 r
F
P
p
.002 w
.39358 .89387 m .40826 .89324 L .42353 .89516 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67922 .50083 m .66351 .50312 L .65141 .49602 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.63569 .49835 m .65141 .49602 L .66351 .50312 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.88865 .47667 m .90547 .47425 L .91426 .48163 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.75851 .26469 m .78538 .27154 L .76922 .2748 L 1 0 0 r
F
P
p
.74232 .26801 m .75851 .26469 L .76922 .2748 L 1 0 0 r
F
P
p
.002 w
.37902 .89449 m .36458 .89511 L .34853 .89319 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.33409 .89382 m .34853 .89319 L .36458 .89511 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6201 .50065 m .60464 .50294 L .59203 .52959 L p
1 .491 0 r
F P
0 0 0 r
s
P
p
.002 w
.57648 .53178 m .59203 .52959 L .60464 .50294 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.87198 .47907 m .85546 .48145 L .84589 .47406 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82932 .47649 m .84589 .47406 L .85546 .48145 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69887 .26443 m .72627 .27129 L .71036 .27455 L 1 0 0 r
F
P
p
.68294 .26775 m .69887 .26443 L .71036 .27455 L 1 .052 0 r
F
P
p
.002 w
.31978 .89444 m .30559 .89506 L .28876 .89314 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8129 .47889 m .79662 .48127 L .7865 .48059 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.77061 .49638 m .7865 .48059 L .79662 .48127 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.6392 .26418 m .66713 .27104 L .65147 .2743 L 1 .103 0 r
F
P
p
.62351 .2675 m .6392 .26418 L .65147 .2743 L 1 .155 0 r
F
P
p
.57948 .26392 m .60796 .27079 L .59253 .27405 L 1 .259 0 r
F
P
p
.56404 .26724 m .57948 .26392 L .59253 .27405 L 1 .31 0 r
F
P
p
.51973 .26366 m .54874 .27054 L .53356 .2738 L 1 .647 0 r
F
P
p
.50454 .26699 m .51973 .26366 L .53356 .2738 L 1 .776 0 r
F
P
p
.45993 .26341 m .48948 .27028 L .47455 .27355 L .94 1 0 r
F
P
p
.44499 .26673 m .45993 .26341 L .47455 .27355 L .707 1 0 r
F
P
p
.4001 .26315 m .43019 .27003 L .4155 .2733 L .759 1 0 r
F
P
p
.38541 .26648 m .4001 .26315 L .4155 .2733 L .681 1 0 r
F
P
p
.34022 .26289 m .37085 .26978 L .35642 .27305 L .629 1 0 r
F
P
p
.32579 .26622 m .34022 .26289 L .35642 .27305 L .448 1 0 r
F
P
p
.002 w
.5458 .54954 m .53062 .55162 L .51677 .52486 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.50159 .53379 m .51677 .52486 L .53062 .55162 L p
1 .905 0 r
F P
0 0 0 r
s
P
p
.28031 .26264 m .31148 .26953 L .29729 .2728 L 0 1 .224 r
F
P
p
.26613 .26597 m .28031 .26264 L .29729 .2728 L 0 1 .845 r
F
P
p
.002 w
.48647 .54938 m .47153 .55146 L .457 .53145 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.002 w
.47153 .55146 m .45615 .60732 L .44208 .53362 L p
.862 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44208 .53362 m .457 .53145 L .47153 .55146 L p
.862 1 0 r
F P
0 0 0 r
s
P
p
.22036 .26238 m .25207 .26927 L .23813 .27255 L 1 0 0 r
F
P
p
.20643 .26571 m .22036 .26238 L .23813 .27255 L 1 0 0 r
F
P
p
.002 w
.75438 .4987 m .7383 .50101 L .72714 .49386 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.71103 .4962 m .72714 .49386 L .7383 .50101 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.83469 .2616 m .86098 .26851 L .84444 .27179 L 1 0 0 r
F
P
p
.81811 .26495 m .83469 .2616 L .84444 .27179 L 1 0 0 r
F
P
p
.002 w
.69506 .49853 m .67922 .50083 L .66727 .49367 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.65141 .49602 m .66727 .49367 L .67922 .50083 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.77484 .26135 m .80167 .26826 L .78538 .27154 L 1 0 0 r
F
P
p
.75851 .26469 m .77484 .26135 L .78538 .27154 L 1 0 0 r
F
P
p
.002 w
.39358 .89387 m .37902 .89449 L .36309 .89255 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.34853 .89319 m .36309 .89255 L .37902 .89449 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59203 .52959 m .6075 .50701 L .6201 .50065 L p
1 .491 0 r
F P
0 0 0 r
s
P
p
.002 w
.63569 .49835 m .6201 .50065 L .6075 .50701 L p
1 .362 0 r
F P
0 0 0 r
s
P
p
.002 w
.88865 .47667 m .87198 .47907 L .86259 .47162 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84589 .47406 m .86259 .47162 L .87198 .47907 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.71495 .26109 m .74232 .26801 L .72627 .27129 L 1 0 0 r
F
P
p
.69887 .26443 m .71495 .26109 L .72627 .27129 L 1 0 0 r
F
P
p
.002 w
.33409 .89382 m .31978 .89444 L .30307 .8925 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.28876 .89314 m .30307 .8925 L .31978 .89444 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82932 .47649 m .8129 .47889 L .80272 .47143 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7865 .48059 m .80272 .47143 L .8129 .47889 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.65502 .26083 m .68294 .26775 L .66713 .27104 L 1 .052 0 r
F
P
p
.6392 .26418 m .65502 .26083 L .66713 .27104 L 1 .103 0 r
F
P
p
.59505 .26057 m .62351 .2675 L .60796 .27079 L 1 .103 0 r
F
P
p
.57948 .26392 m .59505 .26057 L .60796 .27079 L 1 .259 0 r
F
P
p
.53504 .26031 m .56404 .26724 L .54874 .27054 L 1 .517 0 r
F
P
p
.51973 .26366 m .53504 .26031 L .54874 .27054 L 1 .647 0 r
F
P
p
.475 .26005 m .50454 .26699 L .48948 .27028 L 1 .879 0 r
F
P
p
.45993 .26341 m .475 .26005 L .48948 .27028 L .94 1 0 r
F
P
p
.41491 .25979 m .44499 .26673 L .43019 .27003 L .888 1 0 r
F
P
p
.4001 .26315 m .41491 .25979 L .43019 .27003 L .759 1 0 r
F
P
p
.002 w
.36519 .65837 m .38083 .61516 L .39684 .60718 L p
0 1 .121 r
F P
0 0 0 r
s
P
p
.35478 .25953 m .38541 .26648 L .37085 .26978 L .784 1 0 r
F
P
p
.34022 .26289 m .35478 .25953 L .37085 .26978 L .629 1 0 r
F
P
p
.002 w
.56106 .53396 m .5458 .54954 L .53206 .50913 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.51677 .52486 m .53206 .50913 L .5458 .54954 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.29461 .25927 m .32579 .26622 L .31148 .26953 L .241 1 0 r
F
P
p
.28031 .26264 m .29461 .25927 L .31148 .26953 L 0 1 .224 r
F
P
p
.002 w
.50159 .53379 m .48647 .54938 L .47204 .52925 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.457 .53145 m .47204 .52925 L .48647 .54938 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.23441 .25901 m .26613 .26597 L .25207 .26927 L 1 0 .698 r
F
P
p
.22036 .26238 m .23441 .25901 L .25207 .26927 L 1 0 0 r
F
P
p
.002 w
.77061 .49638 m .75438 .4987 L .74339 .49149 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.72714 .49386 m .74339 .49149 L .75438 .4987 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.85141 .25823 m .87767 .2652 L .86098 .26851 L 1 0 0 r
F
P
p
.83469 .2616 m .85141 .25823 L .86098 .26851 L 1 0 0 r
F
P
p
.002 w
.71103 .4962 m .69506 .49853 L .68327 .49131 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.66727 .49367 m .68327 .49131 L .69506 .49853 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.7913 .25797 m .81811 .26495 L .80167 .26826 L 1 0 0 r
F
P
p
.77484 .26135 m .7913 .25797 L .80167 .26826 L 1 0 0 r
F
P
p
.002 w
.40826 .89324 m .39358 .89387 L .37778 .89191 L p
1 0 .931 r
F P
0 0 0 r
s
P
p
.002 w
.36309 .89255 m .37778 .89191 L .39358 .89387 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65141 .49602 m .63569 .49835 L .62311 .49113 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.6075 .50701 m .62311 .49113 L .63569 .49835 L p
1 .362 0 r
F P
0 0 0 r
s
P
p
.002 w
.90547 .47425 m .88865 .47667 L .87944 .46916 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.86259 .47162 m .87944 .46916 L .88865 .47667 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.34853 .89319 m .33409 .89382 L .3175 .89186 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.30307 .8925 m .3175 .89186 L .33409 .89382 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.73116 .25771 m .75851 .26469 L .74232 .26801 L 1 0 0 r
F
P
p
.71495 .26109 m .73116 .25771 L .74232 .26801 L 1 0 0 r
F
P
p
.002 w
.84589 .47406 m .82932 .47649 L .81932 .46897 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80272 .47143 m .81932 .46897 L .82932 .47649 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67098 .25745 m .69887 .26443 L .68294 .26775 L 1 .026 0 r
F
P
p
.65502 .26083 m .67098 .25745 L .68294 .26775 L 1 .052 0 r
F
P
p
.002 w
.53206 .50913 m .54742 .49331 L .56106 .53396 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.61076 .25719 m .6392 .26418 L .62351 .2675 L 1 0 0 r
F
P
p
.59505 .26057 m .61076 .25719 L .62351 .2675 L 1 .103 0 r
F
P
p
.002 w
.51677 .52486 m .50159 .53379 L .48722 .52703 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.47204 .52925 m .48722 .52703 L .50159 .53379 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.55049 .25693 m .57948 .26392 L .56404 .26724 L 1 .388 0 r
F
P
p
.53504 .26031 m .55049 .25693 L .56404 .26724 L 1 .517 0 r
F
P
p
.002 w
.457 .53145 m .44208 .53362 L .4262 .57488 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4262 .57488 m .44208 .53362 L p
.42033 .57815 L .681 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4262 .57488 m .44134 .57284 L .457 .53145 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4262 .57488 m .4105 .56854 L p
.43215 .57156 L .5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44134 .57284 m .4262 .57488 L p
.43215 .57156 L .5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41084 .59759 m .4262 .57488 L p
.42033 .57815 L .681 1 0 r
F P
0 0 0 r
s
P
p
.49019 .25667 m .51973 .26366 L .50454 .26699 L 1 .828 0 r
F
P
p
.475 .26005 m .49019 .25667 L .50454 .26699 L 1 .879 0 r
F
P
p
.42985 .25641 m .45993 .26341 L .44499 .26673 L 1 .983 0 r
F
P
p
.41491 .25979 m .42985 .25641 L .44499 .26673 L .888 1 0 r
F
P
p
.36947 .25615 m .4001 .26315 L .38541 .26648 L .94 1 0 r
F
P
p
.35478 .25953 m .36947 .25615 L .38541 .26648 L .784 1 0 r
F
P
p
.30904 .25588 m .34022 .26289 L .32579 .26622 L .603 1 0 r
F
P
p
.29461 .25927 m .30904 .25588 L .32579 .26622 L .241 1 0 r
F
P
p
.24858 .25562 m .28031 .26264 L .26613 .26597 L 0 .121 1 r
F
P
p
.23441 .25901 m .24858 .25562 L .26613 .26597 L 1 0 .698 r
F
P
p
.18807 .25536 m .22036 .26238 L .20643 .26571 L 1 0 0 r
F
P
p
.002 w
.7865 .48059 m .77061 .49638 L .75915 .46878 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.002 w
.74339 .49149 m .75915 .46878 L .77061 .49638 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.85141 .25823 m .86827 .25484 L .87767 .2652 L 1 0 0 r
F
P
p
.002 w
.72714 .49386 m .71103 .4962 L .6991 .47535 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.68327 .49131 m .6991 .47535 L .71103 .4962 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.80791 .25457 m .83469 .2616 L .81811 .26495 L 1 0 0 r
F
P
p
.7913 .25797 m .80791 .25457 L .81811 .26495 L 1 0 0 r
F
P
p
.002 w
.66727 .49367 m .65141 .49602 L .63899 .48874 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.62311 .49113 m .63899 .48874 L .65141 .49602 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.53206 .50913 m .51677 .52486 L .50252 .5248 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.48722 .52703 m .50252 .5248 L .51677 .52486 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.87944 .46916 m .89644 .46667 L .90547 .47425 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.74752 .25431 m .77484 .26135 L .75851 .26469 L 1 0 0 r
F
P
p
.73116 .25771 m .74752 .25431 L .75851 .26469 L 1 0 0 r
F
P
p
.002 w
.36309 .89255 m .34853 .89319 L .33205 .89121 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.3175 .89186 m .33205 .89121 L .34853 .89319 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.86259 .47162 m .84589 .47406 L .83606 .46648 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81932 .46897 m .83606 .46648 L .84589 .47406 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68708 .25405 m .71495 .26109 L .69887 .26443 L 1 0 0 r
F
P
p
.67098 .25745 m .68708 .25405 L .69887 .26443 L 1 .026 0 r
F
P
p
.002 w
.30307 .8925 m .28876 .89314 L .27148 .89116 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59203 .52959 m .57648 .53178 L .56291 .49094 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.54742 .49331 m .56291 .49094 L .57648 .53178 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.6266 .25378 m .65502 .26083 L .6392 .26418 L 1 0 0 r
F
P
p
.61076 .25719 m .6266 .25378 L .6392 .26418 L 1 0 0 r
F
P
p
.56608 .25352 m .59505 .26057 L .57948 .26392 L 1 .31 0 r
F
P
p
.55049 .25693 m .56608 .25352 L .57948 .26392 L 1 .388 0 r
F
P
p
.002 w
.47204 .52925 m .457 .53145 L .44134 .57284 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.50552 .25326 m .53504 .26031 L .51973 .26366 L 1 .828 0 r
F
P
p
.49019 .25667 m .50552 .25326 L .51973 .26366 L 1 .828 0 r
F
P
p
.002 w
.80272 .47143 m .7865 .48059 L .77564 .46629 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.75915 .46878 m .77564 .46629 L .7865 .48059 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.44492 .25299 m .475 .26005 L .45993 .26341 L 1 .879 0 r
F
P
p
.42985 .25641 m .44492 .25299 L .45993 .26341 L 1 .983 0 r
F
P
p
.38428 .25273 m .41491 .25979 L .4001 .26315 L 1 .983 0 r
F
P
p
.36947 .25615 m .38428 .25273 L .4001 .26315 L .94 1 0 r
F
P
p
.002 w
.50252 .5248 m .51796 .52254 L .53206 .50913 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.54742 .49331 m .53206 .50913 L .51796 .52254 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.3236 .25246 m .35478 .25953 L .34022 .26289 L .759 1 0 r
F
P
p
.30904 .25588 m .3236 .25246 L .34022 .26289 L .603 1 0 r
F
P
p
.26287 .2522 m .29461 .25927 L .28031 .26264 L 0 1 .897 r
F
P
p
.24858 .25562 m .26287 .2522 L .28031 .26264 L 0 .121 1 r
F
P
p
.20211 .25194 m .23441 .25901 L .22036 .26238 L .888 0 1 r
F
P
p
.18807 .25536 m .20211 .25194 L .22036 .26238 L 1 0 0 r
F
P
p
.002 w
.74339 .49149 m .72714 .49386 L .71517 .4661 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.6991 .47535 m .71517 .4661 L .72714 .49386 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.82467 .25114 m .85141 .25823 L .83469 .2616 L 1 0 0 r
F
P
p
.80791 .25457 m .82467 .25114 L .83469 .2616 L 1 0 0 r
F
P
p
.002 w
.68327 .49131 m .66727 .49367 L .65501 .48633 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.63899 .48874 m .65501 .48633 L .66727 .49367 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.76401 .25088 m .7913 .25797 L .77484 .26135 L 1 0 0 r
F
P
p
.74752 .25431 m .76401 .25088 L .77484 .26135 L 1 0 0 r
F
P
p
.002 w
.37778 .89191 m .36309 .89255 L .34674 .89056 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.33205 .89121 m .34674 .89056 L .36309 .89255 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.87944 .46916 m .86259 .47162 L .85295 .46397 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83606 .46648 m .85295 .46397 L .86259 .47162 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70332 .25061 m .73116 .25771 L .71495 .26109 L 1 0 0 r
F
P
p
.68708 .25405 m .70332 .25061 L .71495 .26109 L 1 0 0 r
F
P
p
.002 w
.3175 .89186 m .30307 .8925 L .2859 .89051 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.27148 .89116 m .2859 .89051 L .30307 .8925 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.51796 .52254 m .53354 .5065 L .54742 .49331 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.56291 .49094 m .54742 .49331 L .53354 .5065 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.002 w
.6075 .50701 m .59203 .52959 L .57853 .48855 L p
1 .491 0 r
F P
0 0 0 r
s
P
p
.002 w
.56291 .49094 m .57853 .48855 L .59203 .52959 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.81932 .46897 m .80272 .47143 L .79226 .46378 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77564 .46629 m .79226 .46378 L .80272 .47143 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.64258 .25034 m .67098 .25745 L .65502 .26083 L 1 0 0 r
F
P
p
.6266 .25378 m .64258 .25034 L .65502 .26083 L 1 0 0 r
F
P
p
.5818 .25008 m .61076 .25719 L .59505 .26057 L 1 .233 0 r
F
P
p
.56608 .25352 m .5818 .25008 L .59505 .26057 L 1 .31 0 r
F
P
p
.002 w
.48722 .52703 m .47204 .52925 L .45662 .57078 L p
.862 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44134 .57284 m .45662 .57078 L .47204 .52925 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.52098 .24981 m .55049 .25693 L .53504 .26031 L 1 .776 0 r
F
P
p
.50552 .25326 m .52098 .24981 L .53504 .26031 L 1 .828 0 r
F
P
p
.46012 .24955 m .49019 .25667 L .475 .26005 L 1 .776 0 r
F
P
p
.44492 .25299 m .46012 .24955 L .475 .26005 L 1 .879 0 r
F
P
p
.002 w
.62311 .49113 m .6075 .50701 L .5943 .48614 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.57853 .48855 m .5943 .48614 L .6075 .50701 L p
1 .491 0 r
F P
0 0 0 r
s
P
p
.39922 .24928 m .42985 .25641 L .41491 .25979 L 1 .879 0 r
F
P
p
.38428 .25273 m .39922 .24928 L .41491 .25979 L 1 .983 0 r
F
P
p
.33828 .24901 m .36947 .25615 L .35478 .25953 L .81 1 0 r
F
P
p
.3236 .25246 m .33828 .24901 L .35478 .25953 L .759 1 0 r
F
P
p
.27729 .24875 m .30904 .25588 L .29461 .25927 L 0 1 .302 r
F
P
p
.26287 .2522 m .27729 .24875 L .29461 .25927 L 0 1 .897 r
F
P
p
.21627 .24848 m .24858 .25562 L .23441 .25901 L 0 .379 1 r
F
P
p
.20211 .25194 m .21627 .24848 L .23441 .25901 L .888 0 1 r
F
P
p
.002 w
.75915 .46878 m .74339 .49149 L .73154 .46359 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.71517 .4661 m .73154 .46359 L .74339 .49149 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.35018 .59744 m .36497 .5955 L .38083 .61516 L p
0 1 .121 r
F P
0 0 0 r
s
P
p
.84157 .24768 m .86827 .25484 L .85141 .25823 L 1 0 0 r
F
P
p
.82467 .25114 m .84157 .24768 L .85141 .25823 L 1 0 0 r
F
P
p
.002 w
.6991 .47535 m .68327 .49131 L .67091 .47021 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.65501 .48633 m .67091 .47021 L .68327 .49131 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.78066 .24741 m .80791 .25457 L .7913 .25797 L 1 0 0 r
F
P
p
.76401 .25088 m .78066 .24741 L .7913 .25797 L 1 0 0 r
F
P
p
.002 w
.34674 .89056 m .36155 .8899 L .37778 .89191 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63899 .48874 m .62311 .49113 L .61005 .47002 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.5943 .48614 m .61005 .47002 L .62311 .49113 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.89644 .46667 m .87944 .46916 L .86998 .46144 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85295 .46397 m .86998 .46144 L .87944 .46916 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7197 .24714 m .74752 .25431 L .73116 .25771 L 1 0 0 r
F
P
p
.70332 .25061 m .7197 .24714 L .73116 .25771 L 1 0 0 r
F
P
p
.002 w
.33205 .89121 m .3175 .89186 L .30045 .88985 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.2859 .89051 m .30045 .88985 L .3175 .89186 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.57853 .48855 m .56291 .49094 L .54918 .48352 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.53354 .5065 m .54918 .48352 L .56291 .49094 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.002 w
.83606 .46648 m .81932 .46897 L .80904 .46125 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79226 .46378 m .80904 .46125 L .81932 .46897 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.6587 .24688 m .68708 .25405 L .67098 .25745 L 1 0 0 r
F
P
p
.64258 .25034 m .6587 .24688 L .67098 .25745 L 1 0 0 r
F
P
p
.002 w
.77564 .46629 m .75915 .46878 L .74806 .46105 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73154 .46359 m .74806 .46105 L .75915 .46878 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.36519 .65837 m .34916 .71569 L .334 .6549 L p
0 1 .69 r
F P
0 0 0 r
s
P
p
.002 w
.334 .6549 m .35018 .59744 L .36519 .65837 L p
0 1 .69 r
F P
0 0 0 r
s
P
p
.59766 .24661 m .6266 .25378 L .61076 .25719 L 1 .103 0 r
F
P
p
.5818 .25008 m .59766 .24661 L .61076 .25719 L 1 .233 0 r
F
P
p
.002 w
.50252 .5248 m .48722 .52703 L .47215 .55475 L p
.991 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45662 .57078 m .47215 .55475 L .48722 .52703 L p
.862 1 0 r
F P
0 0 0 r
s
P
p
.53658 .24634 m .56608 .25352 L .55049 .25693 L 1 .595 0 r
F
P
p
.52098 .24981 m .53658 .24634 L .55049 .25693 L 1 .776 0 r
F
P
p
.47546 .24607 m .50552 .25326 L .49019 .25667 L 1 .724 0 r
F
P
p
.46012 .24955 m .47546 .24607 L .49019 .25667 L 1 .776 0 r
F
P
p
.41429 .2458 m .44492 .25299 L .42985 .25641 L 1 .776 0 r
F
P
p
.39922 .24928 m .41429 .2458 L .42985 .25641 L 1 .879 0 r
F
P
p
.002 w
.36497 .5955 m .37989 .59354 L .39591 .59951 L p
.086 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71517 .4661 m .6991 .47535 L .68718 .46771 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.67091 .47021 m .68718 .46771 L .6991 .47535 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.35309 .24553 m .38428 .25273 L .36947 .25615 L .914 1 0 r
F
P
p
.33828 .24901 m .35309 .24553 L .36947 .25615 L .81 1 0 r
F
P
p
.29184 .24527 m .3236 .25246 L .30904 .25588 L .138 1 0 r
F
P
p
.27729 .24875 m .29184 .24527 L .30904 .25588 L 0 1 .302 r
F
P
p
.23055 .245 m .26287 .2522 L .24858 .25562 L 0 1 .741 r
F
P
p
.21627 .24848 m .23055 .245 L .24858 .25562 L 0 .379 1 r
F
P
p
.16922 .24473 m .20211 .25194 L .18807 .25536 L 1 0 0 r
F
P
p
.84157 .24768 m .85862 .24419 L .86827 .25484 L 1 0 0 r
F
P
p
.002 w
.33359 .75217 m .34916 .71569 L .36155 .8899 L p
.888 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.34916 .71569 m .33359 .75217 L .31936 .65658 L p
0 .767 1 r
F P
0 0 0 r
s
P
p
.002 w
.31936 .65658 m .334 .6549 L .34916 .71569 L p
0 .767 1 r
F P
0 0 0 r
s
P
p
.79744 .24392 m .82467 .25114 L .80791 .25457 L 1 0 0 r
F
P
p
.78066 .24741 m .79744 .24392 L .80791 .25457 L 1 0 0 r
F
P
p
.002 w
.65501 .48633 m .63899 .48874 L .62597 .46066 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.61005 .47002 m .62597 .46066 L .63899 .48874 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.36155 .8899 m .34674 .89056 L .33359 .75217 L p
.888 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.31513 .88918 m .33359 .75217 L .34674 .89056 L p
1 0 .491 r
F P
0 0 0 r
s
P
p
.002 w
.33359 .75217 m .31513 .88918 L .29774 .8871 L p
.681 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.29774 .8871 m .31936 .65658 L .33359 .75217 L p
.681 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.86998 .46144 m .88717 .45889 L .89644 .46667 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.73622 .24365 m .76401 .25088 L .74752 .25431 L 1 0 0 r
F
P
p
.7197 .24714 m .73622 .24365 L .74752 .25431 L 1 0 0 r
F
P
p
.002 w
.34674 .89056 m .33205 .89121 L .31513 .88918 L p
1 0 .491 r
F P
0 0 0 r
s
P
p
.002 w
.30045 .88985 m .31513 .88918 L .33205 .89121 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5943 .48614 m .57853 .48855 L .56495 .48106 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.54918 .48352 m .56495 .48106 L .57853 .48855 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.85295 .46397 m .83606 .46648 L .82596 .4587 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80904 .46125 m .82596 .4587 L .83606 .46648 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67496 .24338 m .70332 .25061 L .68708 .25405 L 1 0 0 r
F
P
p
.6587 .24688 m .67496 .24338 L .68708 .25405 L 1 0 0 r
F
P
p
.002 w
.2859 .89051 m .27148 .89116 L .25373 .88913 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79226 .46378 m .77564 .46629 L .76472 .4585 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74806 .46105 m .76472 .4585 L .77564 .46629 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61366 .24311 m .64258 .25034 L .6266 .25378 L 1 .026 0 r
F
P
p
.59766 .24661 m .61366 .24311 L .6266 .25378 L 1 .103 0 r
F
P
p
.002 w
.47215 .55475 m .48781 .53168 L .50252 .5248 L p
.991 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51796 .52254 m .50252 .5248 L .48781 .53168 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.73154 .46359 m .71517 .4661 L .70343 .4583 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68718 .46771 m .70343 .4583 L .71517 .4661 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.31936 .65658 m .29774 .8871 L .27987 .88496 L p
1 0 .828 r
F P
0 0 0 r
s
P
p
.002 w
.334 .6549 m .31936 .65658 L .29493 .88425 L p
0 .483 1 r
F P
0 0 0 r
s
P
p
.002 w
.27987 .88496 m .29493 .88425 L .31936 .65658 L p
1 0 .828 r
F P
0 0 0 r
s
P
p
.55231 .24284 m .5818 .25008 L .56608 .25352 L 1 .466 0 r
F
P
p
.53658 .24634 m .55231 .24284 L .56608 .25352 L 1 .595 0 r
F
P
p
.49093 .24257 m .52098 .24981 L .50552 .25326 L 1 .724 0 r
F
P
p
.47546 .24607 m .49093 .24257 L .50552 .25326 L 1 .724 0 r
F
P
p
.4295 .24229 m .46012 .24955 L .44492 .25299 L 1 .724 0 r
F
P
p
.41429 .2458 m .4295 .24229 L .44492 .25299 L 1 .776 0 r
F
P
p
.002 w
.4262 .57488 m .41084 .59759 L .39535 .57062 L p
.371 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37989 .59354 m .39535 .57062 L .41084 .59759 L p
.216 1 0 r
F P
0 0 0 r
s
P
p
.36803 .24202 m .39922 .24928 L .38428 .25273 L 1 .931 0 r
F
P
p
.35309 .24553 m .36803 .24202 L .38428 .25273 L .914 1 0 r
F
P
p
.002 w
.36497 .5955 m .35018 .59744 L .33346 .59142 L p
.19 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35018 .59744 m .334 .6549 L .31702 .64964 L p
0 1 .276 r
F P
0 0 0 r
s
P
p
.002 w
.31702 .64964 m .33346 .59142 L .35018 .59744 L p
0 1 .276 r
F P
0 0 0 r
s
P
p
.30652 .24175 m .33828 .24901 L .3236 .25246 L .319 1 0 r
F
P
p
.29184 .24527 m .30652 .24175 L .3236 .25246 L .138 1 0 r
F
P
p
.24496 .24148 m .27729 .24875 L .26287 .2522 L .009 1 0 r
F
P
p
.23055 .245 m .24496 .24148 L .26287 .2522 L 0 1 .741 r
F
P
p
.18337 .24121 m .21627 .24848 L .20211 .25194 L .19 0 1 r
F
P
p
.16922 .24473 m .18337 .24121 L .20211 .25194 L 1 0 0 r
F
P
p
.002 w
.39535 .57062 m .4105 .56854 L .4262 .57488 L p
.371 1 0 r
F P
0 0 0 r
s
P
p
.81438 .24039 m .84157 .24768 L .82467 .25114 L 1 0 0 r
F
P
p
.79744 .24392 m .81438 .24039 L .82467 .25114 L 1 0 0 r
F
P
p
.002 w
.67091 .47021 m .65501 .48633 L .6421 .4581 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.002 w
.62597 .46066 m .6421 .4581 L .65501 .48633 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.7529 .24012 m .78066 .24741 L .76401 .25088 L 1 0 0 r
F
P
p
.73622 .24365 m .7529 .24012 L .76401 .25088 L 1 0 0 r
F
P
p
.002 w
.61005 .47002 m .5943 .48614 L .58087 .47859 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.56495 .48106 m .58087 .47859 L .5943 .48614 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.86998 .46144 m .85295 .46397 L .84304 .45612 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82596 .4587 m .84304 .45612 L .85295 .46397 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69137 .23985 m .7197 .24714 L .70332 .25061 L 1 0 0 r
F
P
p
.67496 .24338 m .69137 .23985 L .70332 .25061 L 1 0 0 r
F
P
p
.002 w
.30045 .88985 m .2859 .89051 L .26827 .88846 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.25373 .88913 m .26827 .88846 L .2859 .89051 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80904 .46125 m .79226 .46378 L .78153 .45592 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76472 .4585 m .78153 .45592 L .79226 .46378 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.6298 .23957 m .6587 .24688 L .64258 .25034 L 1 0 0 r
F
P
p
.61366 .24311 m .6298 .23957 L .64258 .25034 L 1 .026 0 r
F
P
p
.002 w
.53354 .5065 m .51796 .52254 L .50348 .51548 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.48781 .53168 m .50348 .51548 L .51796 .52254 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.74806 .46105 m .73154 .46359 L .71997 .45572 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70343 .4583 m .71997 .45572 L .73154 .46359 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.29493 .88425 m .31702 .64964 L .334 .6549 L p
0 .483 1 r
F P
0 0 0 r
s
P
p
.56819 .2393 m .59766 .24661 L .5818 .25008 L 1 .466 0 r
F
P
p
.55231 .24284 m .56819 .2393 L .5818 .25008 L 1 .466 0 r
F
P
p
.50654 .23903 m .53658 .24634 L .52098 .24981 L 1 .647 0 r
F
P
p
.49093 .24257 m .50654 .23903 L .52098 .24981 L 1 .724 0 r
F
P
p
.44484 .23875 m .47546 .24607 L .46012 .24955 L 1 .647 0 r
F
P
p
.4295 .24229 m .44484 .23875 L .46012 .24955 L 1 .724 0 r
F
P
p
.3831 .23848 m .41429 .2458 L .39922 .24928 L 1 .828 0 r
F
P
p
.36803 .24202 m .3831 .23848 L .39922 .24928 L 1 .931 0 r
F
P
p
.002 w
.37989 .59354 m .36497 .5955 L .34874 .57538 L p
.267 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33346 .59142 m .34874 .57538 L .36497 .5955 L p
.19 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68718 .46771 m .67091 .47021 L .65838 .45552 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.6421 .4581 m .65838 .45552 L .67091 .47021 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.32132 .23821 m .35309 .24553 L .33828 .24901 L .629 1 0 r
F
P
p
.30652 .24175 m .32132 .23821 L .33828 .24901 L .319 1 0 r
F
P
p
.002 w
.58087 .47859 m .59692 .47609 L .61005 .47002 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.62597 .46066 m .61005 .47002 L .59692 .47609 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.2595 .23793 m .29184 .24527 L .27729 .24875 L .216 1 0 r
F
P
p
.24496 .24148 m .2595 .23793 L .27729 .24875 L .009 1 0 r
F
P
p
.19764 .23766 m .23055 .245 L .21627 .24848 L 0 1 .069 r
F
P
p
.18337 .24121 m .19764 .23766 L .21627 .24848 L .19 0 1 r
F
P
p
.002 w
.50348 .51548 m .51921 .51314 L .53354 .5065 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.54918 .48352 m .53354 .5065 L .51921 .51314 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.45662 .57078 m .44134 .57284 L .42599 .55243 L p
.578 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4105 .56854 m .42599 .55243 L .44134 .57284 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.83147 .23684 m .85862 .24419 L .84157 .24768 L 1 0 0 r
F
P
p
.81438 .24039 m .83147 .23684 L .84157 .24768 L 1 0 0 r
F
P
p
.76972 .23656 m .79744 .24392 L .78066 .24741 L 1 0 0 r
F
P
p
.7529 .24012 m .76972 .23656 L .78066 .24741 L 1 0 0 r
F
P
p
.002 w
.88717 .45889 m .86998 .46144 L .86026 .45352 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84304 .45612 m .86026 .45352 L .86998 .46144 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70792 .23629 m .73622 .24365 L .7197 .24714 L 1 0 0 r
F
P
p
.69137 .23985 m .70792 .23629 L .7197 .24714 L 1 0 0 r
F
P
p
.002 w
.31513 .88918 m .30045 .88985 L .28294 .88778 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.26827 .88846 m .28294 .88778 L .30045 .88985 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56495 .48106 m .54918 .48352 L .53507 .51079 L p
1 .517 0 r
F P
0 0 0 r
s
P
p
.002 w
.51921 .51314 m .53507 .51079 L .54918 .48352 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.82596 .4587 m .80904 .46125 L .79848 .45332 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78153 .45592 m .79848 .45332 L .80904 .46125 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64608 .23601 m .67496 .24338 L .6587 .24688 L 1 0 0 r
F
P
p
.6298 .23957 m .64608 .23601 L .6587 .24688 L 1 0 0 r
F
P
p
.002 w
.76472 .4585 m .74806 .46105 L .73666 .45312 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71997 .45572 m .73666 .45312 L .74806 .46105 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5842 .23574 m .61366 .24311 L .59766 .24661 L 1 .336 0 r
F
P
p
.56819 .2393 m .5842 .23574 L .59766 .24661 L 1 .466 0 r
F
P
p
.52228 .23546 m .55231 .24284 L .53658 .24634 L 1 .517 0 r
F
P
p
.50654 .23903 m .52228 .23546 L .53658 .24634 L 1 .647 0 r
F
P
p
.002 w
.6421 .4581 m .62597 .46066 L .6129 .45271 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59692 .47609 m .6129 .45271 L .62597 .46066 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.46032 .23518 m .49093 .24257 L .47546 .24607 L 1 .543 0 r
F
P
p
.44484 .23875 m .46032 .23518 L .47546 .24607 L 1 .647 0 r
F
P
p
.39831 .23491 m .4295 .24229 L .41429 .2458 L 1 .776 0 r
F
P
p
.3831 .23848 m .39831 .23491 L .41429 .2458 L 1 .828 0 r
F
P
p
.002 w
.39535 .57062 m .37989 .59354 L .36393 .56628 L p
.474 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34874 .57538 m .36393 .56628 L .37989 .59354 L p
.267 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70343 .4583 m .68718 .46771 L .6748 .45292 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.65838 .45552 m .6748 .45292 L .68718 .46771 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.33626 .23463 m .36803 .24202 L .35309 .24553 L .914 1 0 r
F
P
p
.32132 .23821 m .33626 .23463 L .35309 .24553 L .629 1 0 r
F
P
p
.27417 .23435 m .30652 .24175 L .29184 .24527 L .448 1 0 r
F
P
p
.2595 .23793 m .27417 .23435 L .29184 .24527 L .216 1 0 r
F
P
p
.21204 .23408 m .24496 .24148 L .23055 .245 L .267 1 0 r
F
P
p
.19764 .23766 m .21204 .23408 L .23055 .245 L 0 1 .069 r
F
P
p
.002 w
.47215 .55475 m .45662 .57078 L .44147 .54324 L p
.707 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42599 .55243 m .44147 .54324 L .45662 .57078 L p
.578 1 0 r
F P
0 0 0 r
s
P
p
.14986 .2338 m .18337 .24121 L .16922 .24473 L 1 0 0 r
F
P
p
.002 w
.4105 .56854 m .39535 .57062 L .37968 .53606 L p
.681 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36393 .56628 m .37968 .53606 L .39535 .57062 L p
.474 1 0 r
F P
0 0 0 r
s
P
p
.83147 .23684 m .84871 .23325 L .85862 .24419 L 1 0 0 r
F
P
p
.78669 .23297 m .81438 .24039 L .79744 .24392 L 1 0 0 r
F
P
p
.76972 .23656 m .78669 .23297 L .79744 .24392 L 1 0 0 r
F
P
p
.002 w
.86026 .45352 m .87764 .4509 L .88717 .45889 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.72462 .23269 m .7529 .24012 L .73622 .24365 L 1 0 0 r
F
P
p
.70792 .23629 m .72462 .23269 L .73622 .24365 L 1 0 0 r
F
P
p
.002 w
.28294 .88778 m .29774 .8871 L .31513 .88918 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.53507 .51079 m .55104 .49435 L .56495 .48106 L p
1 .517 0 r
F P
0 0 0 r
s
P
p
.002 w
.58087 .47859 m .56495 .48106 L .55104 .49435 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.002 w
.84304 .45612 m .82596 .4587 L .81559 .45069 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79848 .45332 m .81559 .45069 L .82596 .4587 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66251 .23241 m .69137 .23985 L .67496 .24338 L 1 0 0 r
F
P
p
.64608 .23601 m .66251 .23241 L .67496 .24338 L 1 0 0 r
F
P
p
.002 w
.26827 .88846 m .25373 .88913 L .23549 .88705 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78153 .45592 m .76472 .4585 L .7535 .45049 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73666 .45312 m .7535 .45049 L .76472 .4585 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60036 .23214 m .6298 .23957 L .61366 .24311 L 1 .181 0 r
F
P
p
.5842 .23574 m .60036 .23214 L .61366 .24311 L 1 .336 0 r
F
P
p
.002 w
.71997 .45572 m .70343 .4583 L .69137 .45029 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6748 .45292 m .69137 .45029 L .70343 .4583 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.53817 .23186 m .56819 .2393 L .55231 .24284 L 1 .466 0 r
F
P
p
.52228 .23546 m .53817 .23186 L .55231 .24284 L 1 .517 0 r
F
P
p
.002 w
.48781 .53168 m .47215 .55475 L .45713 .52696 L p
.94 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44147 .54324 m .45713 .52696 L .47215 .55475 L p
.707 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65838 .45552 m .6421 .4581 L .62919 .45008 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6129 .45271 m .62919 .45008 L .6421 .4581 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.47593 .23158 m .50654 .23903 L .49093 .24257 L 1 .491 0 r
F
P
p
.46032 .23518 m .47593 .23158 L .49093 .24257 L 1 .543 0 r
F
P
p
.41366 .2313 m .44484 .23875 L .4295 .24229 L 1 .724 0 r
F
P
p
.39831 .23491 m .41366 .2313 L .4295 .24229 L 1 .776 0 r
F
P
p
.35133 .23102 m .3831 .23848 L .36803 .24202 L 1 .957 0 r
F
P
p
.33626 .23463 m .35133 .23102 L .36803 .24202 L .914 1 0 r
F
P
p
.002 w
.34874 .57538 m .33346 .59142 L .31692 .564 L p
.448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33346 .59142 m .31702 .64964 L .3016 .5802 L p
.034 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3016 .5802 m .31692 .564 L .33346 .59142 L p
.034 1 0 r
F P
0 0 0 r
s
P
p
.28897 .23074 m .32132 .23821 L .30652 .24175 L .603 1 0 r
F
P
p
.27417 .23435 m .28897 .23074 L .30652 .24175 L .448 1 0 r
F
P
p
.002 w
.50348 .51548 m .48781 .53168 L .47287 .5106 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.45713 .52696 m .47287 .5106 L .48781 .53168 L p
.94 1 0 r
F P
0 0 0 r
s
P
p
.22656 .23047 m .2595 .23793 L .24496 .24148 L .293 1 0 r
F
P
p
.21204 .23408 m .22656 .23047 L .24496 .24148 L .267 1 0 r
F
P
p
.16411 .23019 m .19764 .23766 L .18337 .24121 L 1 0 .698 r
F
P
p
.14986 .2338 m .16411 .23019 L .18337 .24121 L 1 0 0 r
F
P
p
.002 w
.42599 .55243 m .4105 .56854 L .39504 .52678 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37968 .53606 m .39504 .52678 L .4105 .56854 L p
.681 1 0 r
F P
0 0 0 r
s
P
p
.80381 .22935 m .83147 .23684 L .81438 .24039 L 1 0 0 r
F
P
p
.78669 .23297 m .80381 .22935 L .81438 .24039 L 1 0 0 r
F
P
p
.74147 .22907 m .76972 .23656 L .7529 .24012 L 1 0 0 r
F
P
p
.72462 .23269 m .74147 .22907 L .7529 .24012 L 1 0 0 r
F
P
p
.002 w
.59692 .47609 m .58087 .47859 L .56707 .47083 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.55104 .49435 m .56707 .47083 L .58087 .47859 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.002 w
.86026 .45352 m .84304 .45612 L .83285 .44804 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81559 .45069 m .83285 .44804 L .84304 .45612 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.36393 .56628 m .34874 .57538 L .33271 .53363 L p
.629 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31692 .564 m .33271 .53363 L .34874 .57538 L p
.448 1 0 r
F P
0 0 0 r
s
P
p
.67909 .22879 m .70792 .23629 L .69137 .23985 L 1 0 0 r
F
P
p
.66251 .23241 m .67909 .22879 L .69137 .23985 L 1 0 0 r
F
P
p
.002 w
.28294 .88778 m .26827 .88846 L .25015 .88636 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.23549 .88705 m .25015 .88636 L .26827 .88846 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79848 .45332 m .78153 .45592 L .77049 .44784 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7535 .45049 m .77049 .44784 L .78153 .45592 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61667 .22851 m .64608 .23601 L .6298 .23957 L 1 .155 0 r
F
P
p
.60036 .23214 m .61667 .22851 L .6298 .23957 L 1 .181 0 r
F
P
p
.002 w
.51921 .51314 m .50348 .51548 L .4886 .50822 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.47287 .5106 m .4886 .50822 L .50348 .51548 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.73666 .45312 m .71997 .45572 L .70808 .44764 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69137 .45029 m .70808 .44764 L .71997 .45572 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.31702 .64964 m .29493 .88425 L .28659 .58927 L p
0 .922 1 r
F P
0 0 0 r
s
P
p
.002 w
.3016 .5802 m .31702 .64964 L p
.28876 .59359 L 0 .922 1 r
F P
0 0 0 r
s
P
p
.002 w
.26863 .68352 m .28659 .58927 L .29493 .88425 L p
.267 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.28659 .58927 m .3016 .5802 L p
.28876 .59359 L 0 .922 1 r
F P
0 0 0 r
s
P
p
.002 w
.28659 .58927 m .26863 .68352 L .25032 .67854 L p
0 1 .845 r
F P
0 0 0 r
s
P
p
.002 w
.3016 .5802 m .28659 .58927 L .26554 .66958 L p
0 1 .224 r
F P
0 0 0 r
s
P
p
.002 w
.25032 .67854 m .26554 .66958 L .28659 .58927 L p
0 1 .845 r
F P
0 0 0 r
s
P
p
.002 w
.26554 .66958 m .28285 .60249 L .3016 .5802 L p
0 1 .224 r
F P
0 0 0 r
s
P
p
.002 w
.2876 .59684 m .28285 .60249 L p
.28669 .59816 L .241 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3016 .5802 m .2876 .59684 L p
.31452 .56671 L .241 1 0 r
F P
0 0 0 r
s
P
p
.28669 .59816 m .31452 .56671 L .2876 .59684 L .241 1 0 r
F
P
p
.002 w
.31692 .564 m .3016 .5802 L p
.31452 .56671 L .241 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28285 .60249 m .29933 .55736 L .31692 .564 L p
.241 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28285 .60249 m .26554 .66958 L .24741 .67162 L p
0 1 .897 r
F P
0 0 0 r
s
P
p
.002 w
.24741 .67162 m .24658 .67171 L p
.24773 .66951 L 0 1 .897 r
F P
0 0 0 r
s
P
p
.24773 .66951 m .28285 .60249 L .24741 .67162 L 0 1 .897 r
F
P
p
.002 w
.23434 .49753 m .24937 .49503 L .25763 .60399 L p
.009 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24658 .67171 m .26206 .66256 L .28285 .60249 L p
0 1 .897 r
F P
0 0 0 r
s
P
p
.002 w
.25763 .60399 m .26206 .66256 L p
.25507 .62092 L .009 1 0 r
F P
0 0 0 r
s
P
p
.23434 .49753 m .25763 .60399 L .25507 .62092 L .009 1 0 r
F
P
p
.002 w
.29933 .55736 m .28285 .60249 L .26647 .64982 L p
0 1 .302 r
F P
0 0 0 r
s
P
p
.002 w
.26647 .64982 m .26206 .66256 L p
.26885 .6434 L 0 1 .302 r
F P
0 0 0 r
s
P
p
.26885 .6434 m .29933 .55736 L .26647 .64982 L 0 1 .302 r
F
P
p
.28299 .60348 m .2801 .60764 L .29933 .55736 L 0 1 .302 r
F
P
p
.002 w
.27921 .60893 m .28116 .60392 L p
.2801 .60764 L 0 1 .302 r
F P
0 0 0 r
s
P
p
.002 w
.28116 .60392 m .29933 .55736 L p
.2801 .60764 L 0 1 .302 r
F P
0 0 0 r
s
P
p
.002 w
.27984 .48996 m .29145 .56786 L p
.26582 .49611 L .448 1 0 r
F P
0 0 0 r
s
P
p
.26453 .49251 m .29145 .56786 L .28961 .57432 L .448 1 0 r
F
P
p
.002 w
.33271 .53363 m .31692 .564 L .29933 .55736 L p
.603 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29933 .55736 m .3149 .54084 L .33271 .53363 L p
.603 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3149 .54084 m .29933 .55736 L .27921 .60893 L p
.138 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27921 .60893 m .26453 .49251 L p
.29179 .58146 L .448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27921 .60893 m .26206 .66256 L .24937 .49503 L p
.216 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24937 .49503 m .26453 .49251 L .27921 .60893 L p
.216 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33015 .53856 m .3149 .54084 L .29508 .59217 L p
.319 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26206 .66256 m .27921 .60893 L p
.28299 .60348 L 0 1 .302 r
F P
0 0 0 r
s
P
p
.002 w
.27921 .60893 m .29508 .59217 L .3149 .54084 L p
.138 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29508 .59217 m .31125 .56797 L .33015 .53856 L p
.319 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31125 .56797 m .29508 .59217 L .27984 .48996 L p
.603 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27984 .48996 m .29553 .4801 L .31125 .56797 L p
.603 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27984 .48996 m .25731 .57899 L p
.29414 .48368 L .552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29553 .4801 m .27984 .48996 L p
.29414 .48368 L .552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26453 .49251 m .27984 .48996 L p
.26582 .49611 L .448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29145 .56786 m .29508 .59217 L p
.28961 .57432 L .448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29508 .59217 m .28317 .60475 L p
.29179 .58146 L .448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28317 .60475 m .27921 .60893 L p
.29179 .58146 L .448 1 0 r
F P
0 0 0 r
s
P
p
.5542 .22823 m .5842 .23574 L .56819 .2393 L 1 .466 0 r
F
P
p
.53817 .23186 m .5542 .22823 L .56819 .2393 L 1 .466 0 r
F
P
p
.002 w
.6748 .45292 m .65838 .45552 L .64563 .44743 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62919 .45008 m .64563 .44743 L .65838 .45552 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.49169 .22794 m .52228 .23546 L .50654 .23903 L 1 .388 0 r
F
P
p
.47593 .23158 m .49169 .22794 L .50654 .23903 L 1 .491 0 r
F
P
p
.002 w
.44147 .54324 m .42599 .55243 L .41039 .52448 L p
.888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39504 .52678 m .41039 .52448 L .42599 .55243 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.42914 .22766 m .46032 .23518 L .44484 .23875 L 1 .698 0 r
F
P
p
.41366 .2313 m .42914 .22766 L .44484 .23875 L 1 .724 0 r
F
P
p
.36654 .22738 m .39831 .23491 L .3831 .23848 L 1 .853 0 r
F
P
p
.35133 .23102 m .36654 .22738 L .3831 .23848 L 1 .957 0 r
F
P
p
.3039 .2271 m .33626 .23463 L .32132 .23821 L .914 1 0 r
F
P
p
.28897 .23074 m .3039 .2271 L .32132 .23821 L .603 1 0 r
F
P
p
.24122 .22682 m .27417 .23435 L .2595 .23793 L .345 1 0 r
F
P
p
.22656 .23047 m .24122 .22682 L .2595 .23793 L .293 1 0 r
F
P
p
.17849 .22654 m .21204 .23408 L .19764 .23766 L 0 .405 1 r
F
P
p
.16411 .23019 m .17849 .22654 L .19764 .23766 L 1 0 .698 r
F
P
p
.002 w
.37968 .53606 m .36393 .56628 L .3478 .53136 L p
.784 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33271 .53363 m .3478 .53136 L p
.33719 .53832 L .629 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3478 .53136 m .33271 .53363 L .3149 .54084 L p
.759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33015 .53856 m .3478 .53136 L p
.3232 .53845 L .759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3149 .54084 m .33015 .53856 L p
.3232 .53845 L .759 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33015 .53856 m .31125 .56797 L p
.33721 .53867 L .629 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3478 .53136 m .33015 .53856 L p
.35853 .52432 L .81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3478 .53136 m .36393 .56628 L p
.33719 .53832 L .629 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33015 .53856 m .34573 .52905 L .3632 .52198 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34573 .52905 m .33015 .53856 L p
.33721 .53867 L .629 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3632 .52198 m .3478 .53136 L p
.35853 .52432 L .81 1 0 r
F P
0 0 0 r
s
P
p
.82109 .22569 m .84871 .23325 L .83147 .23684 L 1 0 0 r
F
P
p
.80381 .22935 m .82109 .22569 L .83147 .23684 L 1 0 0 r
F
P
p
.002 w
.39504 .52678 m .37968 .53606 L .3632 .52198 L p
.94 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3478 .53136 m .3632 .52198 L .37968 .53606 L p
.784 1 0 r
F P
0 0 0 r
s
P
p
.75848 .22541 m .78669 .23297 L .76972 .23656 L 1 0 0 r
F
P
p
.74147 .22907 m .75848 .22541 L .76972 .23656 L 1 0 0 r
F
P
p
.002 w
.6129 .45271 m .59692 .47609 L .58328 .46826 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.56707 .47083 m .58328 .46826 L .59692 .47609 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.87764 .4509 m .86026 .45352 L .85027 .44537 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83285 .44804 m .85027 .44537 L .86026 .45352 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69582 .22513 m .72462 .23269 L .70792 .23629 L 1 0 0 r
F
P
p
.67909 .22879 m .69582 .22513 L .70792 .23629 L 1 0 0 r
F
P
p
.002 w
.29774 .8871 m .28294 .88778 L .26494 .88566 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.25015 .88636 m .26494 .88566 L .28294 .88778 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.45713 .52696 m .44147 .54324 L .42609 .50804 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.41039 .52448 m .42609 .50804 L .44147 .54324 L p
.888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.81559 .45069 m .79848 .45332 L .78763 .44517 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77049 .44784 m .78763 .44517 L .79848 .45332 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.63312 .22484 m .66251 .23241 L .64608 .23601 L 1 .103 0 r
F
P
p
.61667 .22851 m .63312 .22484 L .64608 .23601 L 1 .155 0 r
F
P
p
.002 w
.53507 .51079 m .51921 .51314 L .50448 .50582 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.4886 .50822 m .50448 .50582 L .51921 .51314 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.7535 .45049 m .73666 .45312 L .72495 .44496 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70808 .44764 m .72495 .44496 L .73666 .45312 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.57038 .22456 m .60036 .23214 L .5842 .23574 L 1 .388 0 r
F
P
p
.5542 .22823 m .57038 .22456 L .5842 .23574 L 1 .466 0 r
F
P
p
.002 w
.69137 .45029 m .6748 .45292 L .66223 .44475 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64563 .44743 m .66223 .44475 L .6748 .45292 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.50759 .22428 m .53817 .23186 L .52228 .23546 L 1 .31 0 r
F
P
p
.49169 .22794 m .50759 .22428 L .52228 .23546 L 1 .388 0 r
F
P
p
.002 w
.62919 .45008 m .6129 .45271 L .59965 .46566 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.002 w
.58328 .46826 m .59965 .46566 L .6129 .45271 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.44476 .22399 m .47593 .23158 L .46032 .23518 L 1 .647 0 r
F
P
p
.42914 .22766 m .44476 .22399 L .46032 .23518 L 1 .698 0 r
F
P
p
.38189 .22371 m .41366 .2313 L .39831 .23491 L 1 .828 0 r
F
P
p
.36654 .22738 m .38189 .22371 L .39831 .23491 L 1 .853 0 r
F
P
p
.31897 .22343 m .35133 .23102 L .33626 .23463 L 1 .853 0 r
F
P
p
.3039 .2271 m .31897 .22343 L .33626 .23463 L .914 1 0 r
F
P
p
.25601 .22314 m .28897 .23074 L .27417 .23435 L .448 1 0 r
F
P
p
.24122 .22682 m .25601 .22314 L .27417 .23435 L .345 1 0 r
F
P
p
.002 w
.47287 .5106 m .45713 .52696 L .44169 .50564 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.42609 .50804 m .44169 .50564 L .45713 .52696 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.193 .22286 m .22656 .23047 L .21204 .23408 L 0 1 .457 r
F
P
p
.17849 .22654 m .193 .22286 L .21204 .23408 L 0 .405 1 r
F
P
p
.002 w
.41039 .52448 m .39504 .52678 L .37855 .51963 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.002 w
.3632 .52198 m .37855 .51963 L .39504 .52678 L p
.94 1 0 r
F P
0 0 0 r
s
P
p
.12995 .22257 m .16411 .23019 L .14986 .2338 L 1 0 0 r
F
P
p
.82109 .22569 m .83852 .222 L .84871 .23325 L 1 0 0 r
F
P
p
.77563 .22172 m .80381 .22935 L .78669 .23297 L 1 0 0 r
F
P
p
.75848 .22541 m .77563 .22172 L .78669 .23297 L 1 0 0 r
F
P
p
.002 w
.85027 .44537 m .86785 .44268 L .87764 .4509 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.26494 .88566 m .27987 .88496 L .29774 .8871 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7127 .22143 m .74147 .22907 L .72462 .23269 L 1 0 0 r
F
P
p
.69582 .22513 m .7127 .22143 L .72462 .23269 L 1 0 0 r
F
P
p
.002 w
.83285 .44804 m .81559 .45069 L .80493 .44247 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78763 .44517 m .80493 .44247 L .81559 .45069 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64972 .22115 m .67909 .22879 L .66251 .23241 L 1 .026 0 r
F
P
p
.63312 .22484 m .64972 .22115 L .66251 .23241 L 1 .103 0 r
F
P
p
.002 w
.25015 .88636 m .23549 .88705 L .21674 .8849 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.53026 .50835 m .5205 .5034 L p
.54094 .49734 L 1 .776 0 r
F P
0 0 0 r
s
P
p
.54094 .49734 m .55104 .49435 L .53026 .50835 L 1 .776 0 r
F
P
p
.002 w
.5205 .5034 m .53666 .50095 L .55104 .49435 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.55294 .48419 m .53829 .45464 L p
.56164 .47492 L 1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.55294 .48419 m .56241 .47523 L p
.54529 .49233 L 1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.56241 .47523 m .56707 .47083 L p
.55703 .48077 L 1 .595 0 r
F P
0 0 0 r
s
P
p
.53666 .50095 m .56241 .47523 L .55703 .48077 L 1 .595 0 r
F
P
p
.002 w
.56707 .47083 m .55104 .49435 L .53666 .50095 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.58328 .46826 m .56707 .47083 L .55294 .48419 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.55294 .48419 m .56937 .48163 L .58328 .46826 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.56937 .48163 m .55294 .48419 L p
.56164 .47492 L 1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.53666 .50095 m .55294 .48419 L p
.54529 .49233 L 1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.55104 .49435 m .53507 .51079 L .53026 .50835 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.50448 .50582 m .5205 .5034 L .53507 .51079 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.77049 .44784 m .7535 .45049 L .74197 .44226 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72495 .44496 m .74197 .44226 L .7535 .45049 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5867 .22086 m .61667 .22851 L .60036 .23214 L 1 .233 0 r
F
P
p
.57038 .22456 m .5867 .22086 L .60036 .23214 L 1 .388 0 r
F
P
p
.002 w
.4886 .50822 m .47287 .5106 L .45743 .50321 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.44169 .50564 m .45743 .50321 L .47287 .5106 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.70808 .44764 m .69137 .45029 L .67897 .44205 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66223 .44475 m .67897 .44205 L .69137 .45029 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.52363 .22057 m .5542 .22823 L .53817 .23186 L 1 .272 0 r
F
P
p
.50759 .22428 m .52363 .22057 L .53817 .23186 L 1 .31 0 r
F
P
p
.002 w
.64563 .44743 m .62919 .45008 L .616 .4489 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.59965 .46566 m .616 .4489 L .62919 .45008 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.002 w
.29493 .88425 m .27987 .88496 L .26863 .68352 L p
.267 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.24644 .88348 m .26863 .68352 L .27987 .88496 L p
1 0 .698 r
F P
0 0 0 r
s
P
p
.002 w
.26863 .68352 m .24644 .88348 L .22741 .88123 L p
.603 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.22741 .88123 m .25032 .67854 L .26863 .68352 L p
.603 0 1 r
F P
0 0 0 r
s
P
p
.46052 .22029 m .49169 .22794 L .47593 .23158 L 1 .595 0 r
F
P
p
.44476 .22399 m .46052 .22029 L .47593 .23158 L 1 .647 0 r
F
P
p
.39737 .22 m .42914 .22766 L .41366 .2313 L 1 .828 0 r
F
P
p
.38189 .22371 m .39737 .22 L .41366 .2313 L 1 .828 0 r
F
P
p
.33417 .21972 m .36654 .22738 L .35133 .23102 L 1 .802 0 r
F
P
p
.31897 .22343 m .33417 .21972 L .35133 .23102 L 1 .853 0 r
F
P
p
.27093 .21943 m .3039 .2271 L .28897 .23074 L .552 1 0 r
F
P
p
.25601 .22314 m .27093 .21943 L .28897 .23074 L .448 1 0 r
F
P
p
.20764 .21914 m .24122 .22682 L .22656 .23047 L 0 1 .276 r
F
P
p
.193 .22286 m .20764 .21914 L .22656 .23047 L 0 1 .457 r
F
P
p
.002 w
.42609 .50804 m .41039 .52448 L .39431 .50302 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.37855 .51963 m .39431 .50302 L .41039 .52448 L p
1 .983 0 r
F P
0 0 0 r
s
P
p
.14431 .21886 m .17849 .22654 L .16411 .23019 L 1 0 0 r
F
P
p
.12995 .22257 m .14431 .21886 L .16411 .23019 L 1 0 0 r
F
P
p
.79294 .21799 m .82109 .22569 L .80381 .22935 L 1 0 0 r
F
P
p
.77563 .22172 m .79294 .21799 L .80381 .22935 L 1 0 0 r
F
P
p
.72973 .2177 m .75848 .22541 L .74147 .22907 L 1 0 0 r
F
P
p
.7127 .22143 m .72973 .2177 L .74147 .22907 L 1 0 0 r
F
P
p
.002 w
.85027 .44537 m .83285 .44804 L .82239 .43975 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80493 .44247 m .82239 .43975 L .83285 .44804 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66647 .21742 m .69582 .22513 L .67909 .22879 L 1 0 0 r
F
P
p
.64972 .22115 m .66647 .21742 L .67909 .22879 L 1 .026 0 r
F
P
p
.002 w
.26494 .88566 m .25015 .88636 L .23152 .88419 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.21674 .8849 m .23152 .88419 L .25015 .88636 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78763 .44517 m .77049 .44784 L .75915 .43954 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74197 .44226 m .75915 .43954 L .77049 .44784 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60317 .21713 m .63312 .22484 L .61667 .22851 L 1 .155 0 r
F
P
p
.5867 .22086 m .60317 .21713 L .61667 .22851 L 1 .233 0 r
F
P
p
.002 w
.50448 .50582 m .4886 .50822 L .47343 .48652 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.45743 .50321 m .47343 .48652 L .4886 .50822 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.72495 .44496 m .70808 .44764 L .69586 .43932 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67897 .44205 m .69586 .43932 L .70808 .44764 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.53982 .21684 m .57038 .22456 L .5542 .22823 L 1 .22 0 r
F
P
p
.52363 .22057 m .53982 .21684 L .5542 .22823 L 1 .272 0 r
F
P
p
.002 w
.44169 .50564 m .42609 .50804 L .40991 .50057 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.39431 .50302 m .40991 .50057 L .42609 .50804 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.66223 .44475 m .64563 .44743 L .63253 .43911 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.616 .4489 m .63253 .43911 L .64563 .44743 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.47643 .21655 m .50759 .22428 L .49169 .22794 L 1 .569 0 r
F
P
p
.46052 .22029 m .47643 .21655 L .49169 .22794 L 1 .595 0 r
F
P
p
.41299 .21626 m .44476 .22399 L .42914 .22766 L 1 .828 0 r
F
P
p
.39737 .22 m .41299 .21626 L .42914 .22766 L 1 .828 0 r
F
P
p
.34951 .21597 m .38189 .22371 L .36654 .22738 L 1 .724 0 r
F
P
p
.33417 .21972 m .34951 .21597 L .36654 .22738 L 1 .802 0 r
F
P
p
.28599 .21568 m .31897 .22343 L .3039 .2271 L .655 1 0 r
F
P
p
.27093 .21943 m .28599 .21568 L .3039 .2271 L .552 1 0 r
F
P
p
.22242 .21539 m .25601 .22314 L .24122 .22682 L 0 1 .095 r
F
P
p
.20764 .21914 m .22242 .21539 L .24122 .22682 L 0 1 .276 r
F
P
p
.15881 .2151 m .193 .22286 L .17849 .22654 L 1 0 .853 r
F
P
p
.14431 .21886 m .15881 .2151 L .17849 .22654 L 1 0 0 r
F
P
p
.002 w
.37855 .51963 m .3632 .52198 L .34573 .52905 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.81041 .21423 m .83852 .222 L .82109 .22569 L 1 0 0 r
F
P
p
.79294 .21799 m .81041 .21423 L .82109 .22569 L 1 0 0 r
F
P
p
.74692 .21394 m .77563 .22172 L .75848 .22541 L 1 0 0 r
F
P
p
.72973 .2177 m .74692 .21394 L .75848 .22541 L 1 0 0 r
F
P
p
.002 w
.59965 .46566 m .58328 .46826 L .56937 .48163 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.86785 .44268 m .85027 .44537 L .84 .437 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82239 .43975 m .84 .437 L .85027 .44537 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68338 .21365 m .7127 .22143 L .69582 .22513 L 1 0 0 r
F
P
p
.66647 .21742 m .68338 .21365 L .69582 .22513 L 1 0 0 r
F
P
p
.002 w
.27987 .88496 m .26494 .88566 L .24644 .88348 L p
1 0 .698 r
F P
0 0 0 r
s
P
p
.002 w
.23152 .88419 m .24644 .88348 L .26494 .88566 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80493 .44247 m .78763 .44517 L .77648 .43679 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75915 .43954 m .77648 .43679 L .78763 .44517 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61979 .21336 m .64972 .22115 L .63312 .22484 L 1 .103 0 r
F
P
p
.60317 .21713 m .61979 .21336 L .63312 .22484 L 1 .155 0 r
F
P
p
.002 w
.5205 .5034 m .50448 .50582 L .48943 .48399 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.47343 .48652 m .48943 .48399 L .50448 .50582 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.74197 .44226 m .72495 .44496 L .71291 .43657 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69586 .43932 m .71291 .43657 L .72495 .44496 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.55616 .21307 m .5867 .22086 L .57038 .22456 L 1 .207 0 r
F
P
p
.53982 .21684 m .55616 .21307 L .57038 .22456 L 1 .22 0 r
F
P
p
.002 w
.45743 .50321 m .44169 .50564 L .42587 .4838 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.40991 .50057 m .42587 .4838 L .44169 .50564 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.67897 .44205 m .66223 .44475 L .6493 .43636 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63253 .43911 m .6493 .43636 L .66223 .44475 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.49248 .21278 m .52363 .22057 L .50759 .22428 L 1 .569 0 r
F
P
p
.47643 .21655 m .49248 .21278 L .50759 .22428 L 1 .569 0 r
F
P
p
.42876 .21249 m .46052 .22029 L .44476 .22399 L 1 .828 0 r
F
P
p
.41299 .21626 m .42876 .21249 L .44476 .22399 L 1 .828 0 r
F
P
p
.365 .2122 m .39737 .22 L .38189 .22371 L 1 .621 0 r
F
P
p
.34951 .21597 m .365 .2122 L .38189 .22371 L 1 .724 0 r
F
P
p
.30119 .2119 m .33417 .21972 L .31897 .22343 L .81 1 0 r
F
P
p
.28599 .21568 m .30119 .2119 L .31897 .22343 L .655 1 0 r
F
P
p
.23733 .21161 m .27093 .21943 L .25601 .22314 L .138 1 0 r
F
P
p
.22242 .21539 m .23733 .21161 L .25601 .22314 L 0 1 .095 r
F
P
p
.17343 .21132 m .20764 .21914 L .193 .22286 L 0 .69 1 r
F
P
p
.15881 .2151 m .17343 .21132 L .193 .22286 L 1 0 .853 r
F
P
p
.002 w
.39431 .50302 m .37855 .51963 L .36159 .51228 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.002 w
.34573 .52905 m .36159 .51228 L .37855 .51963 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.81041 .21423 m .82804 .21044 L .83852 .222 L 1 0 0 r
F
P
p
.76426 .21015 m .79294 .21799 L .77563 .22172 L 1 0 0 r
F
P
p
.74692 .21394 m .76426 .21015 L .77563 .22172 L 1 0 0 r
F
P
p
.002 w
.56937 .48163 m .58595 .47906 L .59965 .46566 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.616 .4489 m .59965 .46566 L .58595 .47906 L p
1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.84 .437 m .85778 .43423 L .86785 .44268 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70043 .20985 m .72973 .2177 L .7127 .22143 L 1 0 0 r
F
P
p
.68338 .21365 m .70043 .20985 L .7127 .22143 L 1 0 0 r
F
P
p
.002 w
.82239 .43975 m .80493 .44247 L .79397 .43401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77648 .43679 m .79397 .43401 L .80493 .44247 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.63656 .20956 m .66647 .21742 L .64972 .22115 L 1 .026 0 r
F
P
p
.61979 .21336 m .63656 .20956 L .64972 .22115 L 1 .103 0 r
F
P
p
.002 w
.23152 .88419 m .21674 .8849 L .19746 .8827 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.53666 .50095 m .5205 .5034 L .50557 .48144 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.48943 .48399 m .50557 .48144 L .5205 .5034 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.75915 .43954 m .74197 .44226 L .73012 .4338 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71291 .43657 m .73012 .4338 L .74197 .44226 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.57265 .20927 m .60317 .21713 L .5867 .22086 L 1 .129 0 r
F
P
p
.55616 .21307 m .57265 .20927 L .5867 .22086 L 1 .207 0 r
F
P
p
.002 w
.47343 .48652 m .45743 .50321 L .44173 .48124 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.42587 .4838 m .44173 .48124 L p
.43222 .4877 L 1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.42587 .4838 m .40991 .50057 L .39328 .49289 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.44173 .48124 m .42587 .4838 L .40917 .49035 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.40917 .49035 m .42521 .48779 L .44173 .48124 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.44173 .48124 m .42521 .48779 L p
.45136 .4747 L 1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.45781 .47147 m .44173 .48124 L p
.45136 .4747 L 1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.44173 .48124 m .45743 .50321 L p
.43222 .4877 L 1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.69586 .43932 m .67897 .44205 L .66622 .43358 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6493 .43636 m .66622 .43358 L .67897 .44205 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.50868 .20897 m .53982 .21684 L .52363 .22057 L 1 .53 0 r
F
P
p
.49248 .21278 m .50868 .20897 L .52363 .22057 L 1 .569 0 r
F
P
p
.002 w
.40991 .50057 m .39431 .50302 L .37753 .49541 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.36159 .51228 m .37753 .49541 L .39431 .50302 L p
1 .931 0 r
F P
0 0 0 r
s
P
p
.002 w
.25032 .67854 m .22741 .88123 L .20782 .87892 L p
1 0 .698 r
F P
0 0 0 r
s
P
p
.002 w
.26554 .66958 m .25032 .67854 L .22313 .87816 L p
0 .121 1 r
F P
0 0 0 r
s
P
p
.002 w
.20782 .87892 m .22313 .87816 L .25032 .67854 L p
1 0 .698 r
F P
0 0 0 r
s
P
p
.44467 .20868 m .47643 .21655 L .46052 .22029 L 1 .828 0 r
F
P
p
.42876 .21249 m .44467 .20868 L .46052 .22029 L 1 .828 0 r
F
P
p
.38062 .20838 m .41299 .21626 L .39737 .22 L 1 .543 0 r
F
P
p
.365 .2122 m .38062 .20838 L .39737 .22 L 1 .621 0 r
F
P
p
.31652 .20809 m .34951 .21597 L .33417 .21972 L .914 1 0 r
F
P
p
.30119 .2119 m .31652 .20809 L .33417 .21972 L .81 1 0 r
F
P
p
.002 w
.63253 .43911 m .616 .4489 L .60248 .45485 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.60248 .45485 m .5884 .44641 L p
.60084 .44872 L 1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.60248 .45485 m .616 .4489 L p
.60408 .46086 L 1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.60248 .45485 m .61931 .45213 L .63253 .43911 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.61931 .45213 m .60248 .45485 L p
.60084 .44872 L 1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.58595 .47906 m .60248 .45485 L p
.60408 .46086 L 1 .336 0 r
F P
0 0 0 r
s
P
p
.25238 .20779 m .28599 .21568 L .27093 .21943 L .267 1 0 r
F
P
p
.23733 .21161 m .25238 .20779 L .27093 .21943 L .138 1 0 r
F
P
p
.18819 .2075 m .22242 .21539 L .20764 .21914 L 0 1 .224 r
F
P
p
.17343 .21132 m .18819 .2075 L .20764 .21914 L 0 .69 1 r
F
P
p
.002 w
.48943 .48399 m .47343 .48652 L .45781 .47147 L p
1 .543 0 r
F P
0 0 0 r
s
P
p
.002 w
.44173 .48124 m .45781 .47147 L .47343 .48652 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.78177 .20632 m .81041 .21423 L .79294 .21799 L 1 0 0 r
F
P
p
.76426 .21015 m .78177 .20632 L .79294 .21799 L 1 0 0 r
F
P
p
.71765 .20602 m .74692 .21394 L .72973 .2177 L 1 0 0 r
F
P
p
.70043 .20985 m .71765 .20602 L .72973 .2177 L 1 0 0 r
F
P
p
.002 w
.84 .437 m .82239 .43975 L .81162 .43121 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79397 .43401 m .81162 .43121 L .82239 .43975 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.65349 .20572 m .68338 .21365 L .66647 .21742 L 1 0 0 r
F
P
p
.63656 .20956 m .65349 .20572 L .66647 .21742 L 1 .026 0 r
F
P
p
.002 w
.24644 .88348 m .23152 .88419 L .21237 .88197 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.19746 .8827 m .21237 .88197 L .23152 .88419 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.22313 .87816 m .24658 .67171 L .26554 .66958 L p
0 .121 1 r
F P
0 0 0 r
s
P
p
.002 w
.55294 .48419 m .53666 .50095 L .5219 .45733 L p
1 .517 0 r
F P
0 0 0 r
s
P
p
.002 w
.50557 .48144 m .5219 .45733 L .53666 .50095 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.77648 .43679 m .75915 .43954 L .74748 .43099 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73012 .4338 m .74748 .43099 L .75915 .43954 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.58928 .20543 m .61979 .21336 L .60317 .21713 L 1 .052 0 r
F
P
p
.57265 .20927 m .58928 .20543 L .60317 .21713 L 1 .129 0 r
F
P
p
.002 w
.71291 .43657 m .69586 .43932 L .68329 .43078 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66622 .43358 m .68329 .43078 L .69586 .43932 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.52503 .20513 m .55616 .21307 L .53982 .21684 L 1 .349 0 r
F
P
p
.50868 .20897 m .52503 .20513 L .53982 .21684 L 1 .53 0 r
F
P
p
.002 w
.37753 .49541 m .39328 .49289 L .40991 .50057 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.6493 .43636 m .63253 .43911 L .61931 .45213 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.46073 .20483 m .49248 .21278 L .47643 .21655 L 1 .75 0 r
F
P
p
.44467 .20868 m .46073 .20483 L .47643 .21655 L 1 .828 0 r
F
P
p
.39639 .20454 m .42876 .21249 L .41299 .21626 L 1 .504 0 r
F
P
p
.38062 .20838 m .39639 .20454 L .41299 .21626 L 1 .543 0 r
F
P
p
.332 .20424 m .365 .2122 L .34951 .21597 L .991 1 0 r
F
P
p
.31652 .20809 m .332 .20424 L .34951 .21597 L .914 1 0 r
F
P
p
.26757 .20394 m .30119 .2119 L .28599 .21568 L .371 1 0 r
F
P
p
.25238 .20779 m .26757 .20394 L .28599 .21568 L .267 1 0 r
F
P
p
.20309 .20364 m .23733 .21161 L .22242 .21539 L .086 1 0 r
F
P
p
.18819 .2075 m .20309 .20364 L .22242 .21539 L 0 1 .224 r
F
P
p
.002 w
.5219 .45733 m .53829 .45464 L .55294 .48419 L p
1 .517 0 r
F P
0 0 0 r
s
P
p
.002 w
.24658 .67171 m .22313 .87816 L .21914 .50716 L p
0 1 .741 r
F P
0 0 0 r
s
P
p
.002 w
.21914 .50716 m .23434 .49753 L .24658 .67171 L p
0 1 .741 r
F P
0 0 0 r
s
P
p
.002 w
.20242 .5526 m .21914 .50716 L .22313 .87816 L p
0 .379 1 r
F P
0 0 0 r
s
P
p
.002 w
.22313 .87816 m .20782 .87892 L .20242 .5526 L p
0 .379 1 r
F P
0 0 0 r
s
P
p
.002 w
.17237 .87732 m .20242 .5526 L .20782 .87892 L p
.888 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.20242 .5526 m .17237 .87732 L .15149 .8749 L p
.19 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.23434 .49753 m .21914 .50716 L .1943 .61749 L p
.267 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.15149 .8749 m .17703 .66449 L .20242 .5526 L p
.19 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.21914 .50716 m .20242 .5526 L .18673 .62173 L p
0 1 .069 r
F P
0 0 0 r
s
P
p
.18878 .62058 m .21914 .50716 L .18673 .62173 L 0 1 .069 r
F
P
p
.002 w
.17703 .66449 m .1943 .61749 L .21914 .50716 L p
0 1 .069 r
F P
0 0 0 r
s
P
p
.002 w
.1943 .61749 m .20955 .61548 L .23434 .49753 L p
.267 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.1943 .61749 m .17395 .61127 L p
.19991 .61434 L 0 1 .457 r
F P
0 0 0 r
s
P
p
.002 w
.20955 .61548 m .1943 .61749 L p
.19991 .61434 L 0 1 .457 r
F P
0 0 0 r
s
P
p
.002 w
.18673 .62173 m .17703 .66449 L p
.18878 .62058 L 0 1 .069 r
F P
0 0 0 r
s
P
p
.002 w
.50557 .48144 m .48943 .48399 L .47401 .46163 L p
1 .491 0 r
F P
0 0 0 r
s
P
p
.002 w
.45781 .47147 m .47401 .46163 L .48943 .48399 L p
1 .543 0 r
F P
0 0 0 r
s
P
p
.002 w
.39328 .49289 m .40917 .49035 L .42587 .4838 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.79943 .20245 m .82804 .21044 L .81041 .21423 L 1 0 0 r
F
P
p
.78177 .20632 m .79943 .20245 L .81041 .21423 L 1 0 0 r
F
P
p
.73503 .20215 m .76426 .21015 L .74692 .21394 L 1 0 0 r
F
P
p
.71765 .20602 m .73503 .20215 L .74692 .21394 L 1 0 0 r
F
P
p
.002 w
.85778 .43423 m .84 .437 L .82944 .42838 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81162 .43121 m .82944 .42838 L .84 .437 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67058 .20185 m .70043 .20985 L .68338 .21365 L 1 0 0 r
F
P
p
.65349 .20572 m .67058 .20185 L .68338 .21365 L 1 0 0 r
F
P
p
.002 w
.21237 .88197 m .22741 .88123 L .24644 .88348 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79397 .43401 m .77648 .43679 L .76501 .42817 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74748 .43099 m .76501 .42817 L .77648 .43679 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60608 .20155 m .63656 .20956 L .61979 .21336 L 1 .026 0 r
F
P
p
.58928 .20543 m .60608 .20155 L .61979 .21336 L 1 .052 0 r
F
P
p
.002 w
.36159 .51228 m .34573 .52905 L .32852 .5072 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31125 .56797 m .32852 .5072 L .34573 .52905 L p
.629 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73012 .4338 m .71291 .43657 L .70053 .42795 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68329 .43078 m .70053 .42795 L .71291 .43657 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.54153 .20125 m .57265 .20927 L .55616 .21307 L 1 .207 0 r
F
P
p
.52503 .20513 m .54153 .20125 L .55616 .21307 L 1 .349 0 r
F
P
p
.002 w
.66622 .43358 m .6493 .43636 L .63631 .44939 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.002 w
.61931 .45213 m .63631 .44939 L .6493 .43636 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.47694 .20095 m .50868 .20897 L .49248 .21278 L 1 .621 0 r
F
P
p
.46073 .20483 m .47694 .20095 L .49248 .21278 L 1 .75 0 r
F
P
p
.41231 .20065 m .44467 .20868 L .42876 .21249 L 1 .478 0 r
F
P
p
.39639 .20454 m .41231 .20065 L .42876 .21249 L 1 .504 0 r
F
P
p
.34762 .20035 m .38062 .20838 L .365 .2122 L 1 .828 0 r
F
P
p
.332 .20424 m .34762 .20035 L .365 .2122 L .991 1 0 r
F
P
p
.002 w
.26206 .66256 m .24658 .67171 L .23434 .49753 L p
.009 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24937 .49503 m .23434 .49753 L .20955 .61548 L p
.293 1 0 r
F P
0 0 0 r
s
P
p
.2829 .20005 m .31652 .20809 L .30119 .2119 L .526 1 0 r
F
P
p
.26757 .20394 m .2829 .20005 L .30119 .2119 L .371 1 0 r
F
P
p
.21812 .19975 m .25238 .20779 L .23733 .21161 L .345 1 0 r
F
P
p
.20309 .20364 m .21812 .19975 L .23733 .21161 L .086 1 0 r
F
P
p
.002 w
.58595 .47906 m .56937 .48163 L .55484 .45192 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.53829 .45464 m .55484 .45192 L .56937 .48163 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.5219 .45733 m .50557 .48144 L .49032 .45171 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.002 w
.47401 .46163 m .49032 .45171 L .50557 .48144 L p
1 .491 0 r
F P
0 0 0 r
s
P
p
.002 w
.37753 .49541 m .36159 .51228 L .34414 .50471 L p
1 .957 0 r
F P
0 0 0 r
s
P
p
.002 w
.32852 .5072 m .34414 .50471 L .36159 .51228 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.79943 .20245 m .81727 .19855 L .82804 .21044 L 1 0 0 r
F
P
p
.75257 .19825 m .78177 .20632 L .76426 .21015 L 1 0 0 r
F
P
p
.73503 .20215 m .75257 .19825 L .76426 .21015 L 1 0 0 r
F
P
p
.002 w
.82944 .42838 m .84742 .42553 L .85778 .43423 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68782 .19794 m .71765 .20602 L .70043 .20985 L 1 0 0 r
F
P
p
.67058 .20185 m .68782 .19794 L .70043 .20985 L 1 0 0 r
F
P
p
.002 w
.53829 .45464 m .5219 .45733 L .50673 .44897 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.49032 .45171 m .50673 .44897 L .5219 .45733 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.002 w
.81162 .43121 m .79397 .43401 L .78269 .42531 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76501 .42817 m .78269 .42531 L .79397 .43401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.62303 .19764 m .65349 .20572 L .63656 .20956 L 1 0 0 r
F
P
p
.60608 .20155 m .62303 .19764 L .63656 .20956 L 1 .026 0 r
F
P
p
.002 w
.21237 .88197 m .19746 .8827 L .17763 .88043 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74748 .43099 m .73012 .4338 L .71792 .42509 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70053 .42795 m .71792 .42509 L .73012 .4338 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.55819 .19734 m .58928 .20543 L .57265 .20927 L 1 .207 0 r
F
P
p
.54153 .20125 m .55819 .19734 L .57265 .20927 L 1 .207 0 r
F
P
p
.002 w
.68329 .43078 m .66622 .43358 L .65322 .43211 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.63631 .44939 m .65322 .43211 L .66622 .43358 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.4933 .19704 m .52503 .20513 L .50868 .20897 L 1 .569 0 r
F
P
p
.47694 .20095 m .4933 .19704 L .50868 .20897 L 1 .621 0 r
F
P
p
.002 w
.39328 .49289 m .37753 .49541 L .36009 .49489 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.34414 .50471 m .36009 .49489 L .37753 .49541 L p
1 .957 0 r
F P
0 0 0 r
s
P
p
.42837 .19673 m .46073 .20483 L .44467 .20868 L 1 .44 0 r
F
P
p
.41231 .20065 m .42837 .19673 L .44467 .20868 L 1 .478 0 r
F
P
p
.36339 .19643 m .39639 .20454 L .38062 .20838 L 1 .672 0 r
F
P
p
.34762 .20035 m .36339 .19643 L .38062 .20838 L 1 .828 0 r
F
P
p
.002 w
.26453 .49251 m .24937 .49503 L .22494 .61346 L p
.345 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20955 .61548 m .22494 .61346 L .24937 .49503 L p
.293 1 0 r
F P
0 0 0 r
s
P
p
.29837 .19613 m .332 .20424 L .31652 .20809 L .655 1 0 r
F
P
p
.2829 .20005 m .29837 .19613 L .31652 .20809 L .526 1 0 r
F
P
p
.002 w
.47401 .46163 m .45781 .47147 L .4414 .4852 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.002 w
.42521 .48779 m .4414 .4852 L .45781 .47147 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.2333 .19582 m .26757 .20394 L .25238 .20779 L .474 1 0 r
F
P
p
.21812 .19975 m .2333 .19582 L .25238 .20779 L .345 1 0 r
F
P
p
.002 w
.60248 .45485 m .58595 .47906 L .57154 .44918 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.002 w
.55484 .45192 m .57154 .44918 L .58595 .47906 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.77027 .1943 m .79943 .20245 L .78177 .20632 L 1 0 0 r
F
P
p
.75257 .19825 m .77027 .1943 L .78177 .20632 L 1 0 0 r
F
P
p
.002 w
.57154 .44918 m .5884 .44641 L .60248 .45485 L p
1 .388 0 r
F P
0 0 0 r
s
P
p
.70523 .194 m .73503 .20215 L .71765 .20602 L 1 0 0 r
F
P
p
.68782 .19794 m .70523 .194 L .71765 .20602 L 1 0 0 r
F
P
p
.002 w
.55484 .45192 m .53829 .45464 L .52329 .4462 L p
1 .272 0 r
F P
0 0 0 r
s
P
p
.002 w
.52329 .4462 m .53829 .45464 L p
.51407 .45029 L 1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.52329 .4462 m .53999 .43245 L .55484 .45192 L p
1 .272 0 r
F P
0 0 0 r
s
P
p
.002 w
.52329 .4462 m .5077 .47459 L p
.53264 .44205 L 1 .53 0 r
F P
0 0 0 r
s
P
p
.002 w
.53999 .43245 m .52329 .4462 L p
.53264 .44205 L 1 .53 0 r
F P
0 0 0 r
s
P
p
.002 w
.50673 .44897 m .52329 .4462 L p
.51407 .45029 L 1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.82944 .42838 m .81162 .43121 L .80055 .42243 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78269 .42531 m .80055 .42243 L .81162 .43121 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64014 .19369 m .67058 .20185 L .65349 .20572 L 1 0 0 r
F
P
p
.62303 .19764 m .64014 .19369 L .65349 .20572 L 1 0 0 r
F
P
p
.002 w
.22741 .88123 m .21237 .88197 L .19266 .87968 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.17763 .88043 m .19266 .87968 L .21237 .88197 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76501 .42817 m .74748 .43099 L .73548 .42221 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71792 .42509 m .73548 .42221 L .74748 .43099 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.575 .19339 m .60608 .20155 L .58928 .20543 L 1 .207 0 r
F
P
p
.55819 .19734 m .575 .19339 L .58928 .20543 L 1 .207 0 r
F
P
p
.002 w
.70053 .42795 m .68329 .43078 L .67036 .42198 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65322 .43211 m .67036 .42198 L .68329 .43078 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.50982 .19308 m .54153 .20125 L .52503 .20513 L 1 .44 0 r
F
P
p
.4933 .19704 m .50982 .19308 L .52503 .20513 L 1 .569 0 r
F
P
p
.002 w
.40917 .49035 m .39328 .49289 L .37616 .485 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.36009 .49489 m .37616 .485 L .39328 .49289 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.49032 .45171 m .47401 .46163 L .45774 .48258 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.4414 .4852 m .45774 .48258 L .47401 .46163 L p
1 .647 0 r
F P
0 0 0 r
s
P
p
.44459 .19278 m .47694 .20095 L .46073 .20483 L 1 .336 0 r
F
P
p
.42837 .19673 m .44459 .19278 L .46073 .20483 L 1 .44 0 r
F
P
p
.37931 .19247 m .41231 .20065 L .39639 .20454 L 1 .556 0 r
F
P
p
.36339 .19643 m .37931 .19247 L .39639 .20454 L 1 .672 0 r
F
P
p
.002 w
.27984 .48996 m .26453 .49251 L .24108 .59627 L p
.448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.22494 .61346 m .24108 .59627 L .26453 .49251 L p
.345 1 0 r
F P
0 0 0 r
s
P
p
.31399 .19217 m .34762 .20035 L .332 .20424 L .81 1 0 r
F
P
p
.29837 .19613 m .31399 .19217 L .332 .20424 L .655 1 0 r
F
P
p
.24861 .19186 m .2829 .20005 L .26757 .20394 L .578 1 0 r
F
P
p
.2333 .19582 m .24861 .19186 L .26757 .20394 L .474 1 0 r
F
P
p
.002 w
.34414 .50471 m .32852 .5072 L .31111 .47747 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.32852 .5072 m .31125 .56797 L .29553 .4801 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31111 .47747 m .32852 .5072 L p
.29774 .48192 L .914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31111 .47747 m .32704 .46748 L .34414 .50471 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.31111 .47747 m .28978 .55171 L p
.32461 .47298 L .81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32704 .46748 m .31111 .47747 L p
.32461 .47298 L .81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29553 .4801 m .31111 .47747 L p
.29774 .48192 L .914 1 0 r
F P
0 0 0 r
s
P
p
.78814 .19032 m .81727 .19855 L .79943 .20245 L 1 0 0 r
F
P
p
.77027 .1943 m .78814 .19032 L .79943 .20245 L 1 0 0 r
F
P
p
.002 w
.63631 .44939 m .61931 .45213 L .6052 .42176 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.5884 .44641 m .6052 .42176 L .61931 .45213 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.7228 .19002 m .75257 .19825 L .73503 .20215 L 1 0 0 r
F
P
p
.70523 .194 m .7228 .19002 L .73503 .20215 L 1 0 0 r
F
P
p
.002 w
.57154 .44918 m .55484 .45192 L .53999 .43245 L p
1 .22 0 r
F P
0 0 0 r
s
P
p
.002 w
.84742 .42553 m .82944 .42838 L .81857 .41952 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80055 .42243 m .81857 .41952 L .82944 .42838 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.65741 .18971 m .68782 .19794 L .67058 .20185 L 1 0 0 r
F
P
p
.64014 .19369 m .65741 .18971 L .67058 .20185 L 1 0 0 r
F
P
p
.002 w
.19266 .87968 m .20782 .87892 L .22741 .88123 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.50673 .44897 m .49032 .45171 L .47424 .47994 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.45774 .48258 m .47424 .47994 L .49032 .45171 L p
1 .595 0 r
F P
0 0 0 r
s
P
p
.002 w
.78269 .42531 m .76501 .42817 L .7532 .4193 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73548 .42221 m .7532 .4193 L .76501 .42817 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.59197 .1894 m .62303 .19764 L .60608 .20155 L 1 .181 0 r
F
P
p
.575 .19339 m .59197 .1894 L .60608 .20155 L 1 .207 0 r
F
P
p
.002 w
.71792 .42509 m .70053 .42795 L .68778 .41907 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67036 .42198 m .68778 .41907 L .70053 .42795 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.52649 .18909 m .55819 .19734 L .54153 .20125 L 1 .31 0 r
F
P
p
.50982 .19308 m .52649 .18909 L .54153 .20125 L 1 .44 0 r
F
P
p
.002 w
.42521 .48779 m .40917 .49035 L .3922 .48238 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.37616 .485 m .3922 .48238 L .40917 .49035 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.46096 .18878 m .4933 .19704 L .47694 .20095 L 1 .207 0 r
F
P
p
.44459 .19278 m .46096 .18878 L .47694 .20095 L 1 .336 0 r
F
P
p
.39538 .18848 m .42837 .19673 L .41231 .20065 L 1 .478 0 r
F
P
p
.37931 .19247 m .39538 .18848 L .41231 .20065 L 1 .556 0 r
F
P
p
.002 w
.25731 .57899 m .27984 .48996 L p
.24289 .59132 L .448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25731 .57899 m .27336 .56918 L .29553 .4801 L p
.552 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25731 .57899 m .24006 .51127 L p
.27185 .56656 L .267 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27336 .56918 m .25731 .57899 L p
.27185 .56656 L .267 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24108 .59627 m .25731 .57899 L p
.24289 .59132 L .448 1 0 r
F P
0 0 0 r
s
P
p
.32975 .18817 m .36339 .19643 L .34762 .20035 L .966 1 0 r
F
P
p
.31399 .19217 m .32975 .18817 L .34762 .20035 L .81 1 0 r
F
P
p
.26408 .18786 m .29837 .19613 L .2829 .20005 L .681 1 0 r
F
P
p
.24861 .19186 m .26408 .18786 L .2829 .20005 L .578 1 0 r
F
P
p
.002 w
.36009 .49489 m .34414 .50471 L .32704 .46748 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.78814 .19032 m .80618 .18631 L .81727 .19855 L 1 0 0 r
F
P
p
.002 w
.65322 .43211 m .63631 .44939 L .62232 .41885 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.002 w
.6052 .42176 m .62232 .41885 L .63631 .44939 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.74053 .186 m .77027 .1943 L .75257 .19825 L 1 0 0 r
F
P
p
.7228 .19002 m .74053 .186 L .75257 .19825 L 1 0 0 r
F
P
p
.002 w
.5884 .44641 m .57154 .44918 L .55683 .42593 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.53999 .43245 m .55683 .42593 L .57154 .44918 L p
1 .22 0 r
F P
0 0 0 r
s
P
p
.002 w
.81857 .41952 m .83676 .41659 L .84742 .42553 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67484 .18569 m .70523 .194 L .68782 .19794 L 1 0 0 r
F
P
p
.65741 .18971 m .67484 .18569 L .68782 .19794 L 1 0 0 r
F
P
p
.002 w
.52329 .4462 m .50673 .44897 L .49089 .47728 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.47424 .47994 m .49089 .47728 L .50673 .44897 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.80055 .42243 m .78269 .42531 L .77109 .41636 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7532 .4193 m .77109 .41636 L .78269 .42531 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.6091 .18538 m .64014 .19369 L .62303 .19764 L 1 .129 0 r
F
P
p
.59197 .1894 m .6091 .18538 L .62303 .19764 L 1 .181 0 r
F
P
p
.002 w
.19266 .87968 m .17763 .88043 L .15723 .8781 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.31111 .47747 m .29553 .4801 L .27336 .56918 L p
.655 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73548 .42221 m .71792 .42509 L .70537 .41613 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68778 .41907 m .70537 .41613 L .71792 .42509 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.54331 .18506 m .575 .19339 L .55819 .19734 L 1 .31 0 r
F
P
p
.52649 .18909 m .54331 .18506 L .55819 .19734 L 1 .31 0 r
F
P
p
.002 w
.4414 .4852 m .42521 .48779 L .4084 .47974 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.3922 .48238 m .4084 .47974 L .42521 .48779 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.47748 .18475 m .50982 .19308 L .4933 .19704 L 1 .155 0 r
F
P
p
.46096 .18878 m .47748 .18475 L .4933 .19704 L 1 .207 0 r
F
P
p
.41159 .18444 m .44459 .19278 L .42837 .19673 L 1 .44 0 r
F
P
p
.39538 .18848 m .41159 .18444 L .42837 .19673 L 1 .478 0 r
F
P
p
.34566 .18413 m .37931 .19247 L .36339 .19643 L 1 .957 0 r
F
P
p
.32975 .18817 m .34566 .18413 L .36339 .19643 L .966 1 0 r
F
P
p
.002 w
.67036 .42198 m .65322 .43211 L .6396 .4159 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.62232 .41885 m .6396 .4159 L .65322 .43211 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.27968 .18382 m .31399 .19217 L .29837 .19613 L .81 1 0 r
F
P
p
.26408 .18786 m .27968 .18382 L .29837 .19613 L .681 1 0 r
F
P
p
.002 w
.37616 .485 m .36009 .49489 L .3429 .46478 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.3429 .46478 m .36009 .49489 L p
.3296 .4696 L 1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.35909 .45466 m .37616 .485 L p
.34569 .46647 L 1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.3429 .46478 m .35909 .45466 L p
.34569 .46647 L 1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.3922 .48238 m .37616 .485 L .35909 .45466 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.35909 .45466 m .37556 .43707 L .3922 .48238 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.35909 .45466 m .33939 .50633 L p
.3726 .44273 L 1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.37556 .43707 m .35909 .45466 L p
.3726 .44273 L 1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.3429 .46478 m .32268 .52408 L p
.35634 .4599 L .991 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35909 .45466 m .3429 .46478 L p
.35634 .4599 L .991 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32704 .46748 m .3429 .46478 L p
.3296 .4696 L 1 .802 0 r
F P
0 0 0 r
s
P
p
.75844 .18194 m .78814 .19032 L .77027 .1943 L 1 0 0 r
F
P
p
.74053 .186 m .75844 .18194 L .77027 .1943 L 1 0 0 r
F
P
p
.002 w
.6052 .42176 m .5884 .44641 L .57383 .42301 L p
1 .129 0 r
F P
0 0 0 r
s
P
p
.002 w
.55683 .42593 m .57383 .42301 L .5884 .44641 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.69244 .18163 m .7228 .19002 L .70523 .194 L 1 0 0 r
F
P
p
.67484 .18569 m .69244 .18163 L .70523 .194 L 1 0 0 r
F
P
p
.002 w
.49089 .47728 m .5077 .47459 L .52329 .4462 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.81857 .41952 m .80055 .42243 L .78915 .41339 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77109 .41636 m .78915 .41339 L .80055 .42243 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.62639 .18131 m .65741 .18971 L .64014 .19369 L 1 .091 0 r
F
P
p
.6091 .18538 m .62639 .18131 L .64014 .19369 L 1 .129 0 r
F
P
p
.002 w
.20782 .87892 m .19266 .87968 L .17237 .87732 L p
.888 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.15723 .8781 m .17237 .87732 L .19266 .87968 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.27336 .56918 m .28978 .55171 L .31111 .47747 L p
.655 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7532 .4193 m .73548 .42221 L .72312 .41316 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70537 .41613 m .72312 .41316 L .73548 .42221 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5603 .181 m .59197 .1894 L .575 .19339 L 1 .31 0 r
F
P
p
.54331 .18506 m .5603 .181 L .575 .19339 L 1 .31 0 r
F
P
p
.002 w
.45774 .48258 m .4414 .4852 L .42474 .47707 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.4084 .47974 m .42474 .47707 L .4414 .4852 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.68778 .41907 m .67036 .42198 L .65705 .41293 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6396 .4159 m .65705 .41293 L .67036 .42198 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.49416 .18068 m .52649 .18909 L .50982 .19308 L 1 .155 0 r
F
P
p
.47748 .18475 m .49416 .18068 L .50982 .19308 L 1 .155 0 r
F
P
p
.002 w
.62232 .41885 m .6052 .42176 L .59099 .42007 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.57383 .42301 m .59099 .42007 L .6052 .42176 L p
1 .129 0 r
F P
0 0 0 r
s
P
p
.42797 .18037 m .46096 .18878 L .44459 .19278 L 1 .336 0 r
F
P
p
.41159 .18444 m .42797 .18037 L .44459 .19278 L 1 .44 0 r
F
P
p
.36173 .18005 m .39538 .18848 L .37931 .19247 L 1 .879 0 r
F
P
p
.34566 .18413 m .36173 .18005 L .37931 .19247 L 1 .957 0 r
F
P
p
.29544 .17974 m .32975 .18817 L .31399 .19217 L .966 1 0 r
F
P
p
.27968 .18382 m .29544 .17974 L .31399 .19217 L .81 1 0 r
F
P
p
.002 w
.55683 .42593 m .53999 .43245 L .52468 .47187 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.5077 .47459 m .52468 .47187 L .53999 .43245 L p
1 .53 0 r
F P
0 0 0 r
s
P
p
.002 w
.3429 .46478 m .32704 .46748 L .30653 .52657 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30653 .52657 m .32704 .46748 L p
.29737 .53457 L .81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30653 .52657 m .32268 .52408 L .3429 .46478 L p
.914 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30653 .52657 m .28816 .49588 L p
.31581 .51847 L .655 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32268 .52408 m .30653 .52657 L p
.31581 .51847 L .655 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28978 .55171 m .30653 .52657 L p
.29737 .53457 L .81 1 0 r
F P
0 0 0 r
s
P
p
.77651 .17784 m .80618 .18631 L .78814 .19032 L 1 0 0 r
F
P
p
.75844 .18194 m .77651 .17784 L .78814 .19032 L 1 0 0 r
F
P
p
.71021 .17753 m .74053 .186 L .7228 .19002 L 1 0 0 r
F
P
p
.69244 .18163 m .71021 .17753 L .7228 .19002 L 1 0 0 r
F
P
p
.002 w
.83676 .41659 m .81857 .41952 L .80738 .4104 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78915 .41339 m .80738 .4104 L .81857 .41952 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64385 .17721 m .67484 .18569 L .65741 .18971 L 1 .065 0 r
F
P
p
.62639 .18131 m .64385 .17721 L .65741 .18971 L 1 .091 0 r
F
P
p
.002 w
.17703 .66449 m .15149 .8749 L .12997 .8724 L p
1 0 .698 r
F P
0 0 0 r
s
P
p
.002 w
.1943 .61749 m .17703 .66449 L .14552 .87157 L p
0 .405 1 r
F P
0 0 0 r
s
P
p
.002 w
.12997 .8724 m .14552 .87157 L .17703 .66449 L p
1 0 .698 r
F P
0 0 0 r
s
P
p
.002 w
.14552 .87157 m .17395 .61127 L .1943 .61749 L p
0 .405 1 r
F P
0 0 0 r
s
P
p
.002 w
.77109 .41636 m .7532 .4193 L .74105 .41017 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72312 .41316 m .74105 .41017 L .7532 .4193 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.57745 .17689 m .6091 .18538 L .59197 .1894 L 1 .31 0 r
F
P
p
.5603 .181 m .57745 .17689 L .59197 .1894 L 1 .31 0 r
F
P
p
.002 w
.47424 .47994 m .45774 .48258 L .44125 .47438 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.42474 .47707 m .44125 .47438 L .45774 .48258 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.70537 .41613 m .68778 .41907 L .67466 .40993 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65705 .41293 m .67466 .40993 L .68778 .41907 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.511 .17658 m .54331 .18506 L .52649 .18909 L 1 .155 0 r
F
P
p
.49416 .18068 m .511 .17658 L .52649 .18909 L 1 .155 0 r
F
P
p
.002 w
.4084 .47974 m .3922 .48238 L .37556 .43707 L p
1 .543 0 r
F P
0 0 0 r
s
P
p
.002 w
.6396 .4159 m .62232 .41885 L .60831 .4171 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.59099 .42007 m .60831 .4171 L p
.60674 .41946 L 1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.60831 .4171 m .59099 .42007 L .57637 .42583 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.57637 .42583 m .59392 .42284 L .60831 .4171 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.60831 .4171 m .59392 .42284 L p
.60991 .4147 L 1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.6257 .40667 m .60831 .4171 L p
.60991 .4147 L 1 .181 0 r
F P
0 0 0 r
s
P
p
.002 w
.60831 .4171 m .62232 .41885 L p
.60674 .41946 L 1 .052 0 r
F P
0 0 0 r
s
P
p
.4445 .17626 m .47748 .18475 L .46096 .18878 L 1 .207 0 r
F
P
p
.42797 .18037 m .4445 .17626 L .46096 .18878 L 1 .336 0 r
F
P
p
.37795 .17594 m .41159 .18444 L .39538 .18848 L 1 .776 0 r
F
P
p
.36173 .18005 m .37795 .17594 L .39538 .18848 L 1 .879 0 r
F
P
p
.31135 .17562 m .34566 .18413 L .32975 .18817 L 1 .853 0 r
F
P
p
.29544 .17974 m .31135 .17562 L .32975 .18817 L .966 1 0 r
F
P
p
.002 w
.54177 .43173 m .55683 .42593 L p
.54775 .43889 L 1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.52468 .47187 m .54177 .43173 L p
.54775 .43889 L 1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.54177 .43173 m .52622 .42261 L p
.53565 .42439 L 1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.57383 .42301 m .55683 .42593 L .54177 .43173 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.54177 .43173 m .55899 .42879 L .57383 .42301 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.55899 .42879 m .54177 .43173 L p
.53565 .42439 L 1 .31 0 r
F P
0 0 0 r
s
P
p
.77651 .17784 m .79476 .17371 L .80618 .18631 L 1 0 0 r
F
P
p
.72814 .17339 m .75844 .18194 L .74053 .186 L 1 0 0 r
F
P
p
.71021 .17753 m .72814 .17339 L .74053 .186 L 1 0 0 r
F
P
p
.002 w
.80738 .4104 m .82579 .40737 L .83676 .41659 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66148 .17307 m .69244 .18163 L .67484 .18569 L 1 .052 0 r
F
P
p
.64385 .17721 m .66148 .17307 L .67484 .18569 L 1 .065 0 r
F
P
p
.002 w
.22494 .61346 m .20955 .61548 L .1911 .57126 L p
0 1 .276 r
F P
0 0 0 r
s
P
p
.002 w
.17395 .61127 m .1911 .57126 L .20955 .61548 L p
0 1 .457 r
F P
0 0 0 r
s
P
p
.002 w
.78915 .41339 m .77109 .41636 L .75914 .40714 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74105 .41017 m .75914 .40714 L .77109 .41636 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.59476 .17275 m .62639 .18131 L .6091 .18538 L 1 .284 0 r
F
P
p
.57745 .17689 m .59476 .17275 L .6091 .18538 L 1 .31 0 r
F
P
p
.002 w
.17237 .87732 m .15723 .8781 L .13622 .87569 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.49089 .47728 m .47424 .47994 L .45791 .47166 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.44125 .47438 m .45791 .47166 L .47424 .47994 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.72312 .41316 m .70537 .41613 L .69245 .40691 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67466 .40993 m .69245 .40691 L .70537 .41613 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.528 .17243 m .5603 .181 L .54331 .18506 L 1 .155 0 r
F
P
p
.511 .17658 m .528 .17243 L .54331 .18506 L 1 .155 0 r
F
P
p
.002 w
.42474 .47707 m .4084 .47974 L .39197 .42678 L p
1 .504 0 r
F P
0 0 0 r
s
P
p
.002 w
.37556 .43707 m .39197 .42678 L .4084 .47974 L p
1 .543 0 r
F P
0 0 0 r
s
P
p
.002 w
.65705 .41293 m .6396 .4159 L .6257 .40667 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60831 .4171 m .6257 .40667 L .6396 .4159 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.46118 .17211 m .49416 .18068 L .47748 .18475 L 1 .155 0 r
F
P
p
.4445 .17626 m .46118 .17211 L .47748 .18475 L 1 .207 0 r
F
P
p
.39432 .17179 m .42797 .18037 L .41159 .18444 L 1 .724 0 r
F
P
p
.37795 .17594 m .39432 .17179 L .41159 .18444 L 1 .776 0 r
F
P
p
.32741 .17146 m .36173 .18005 L .34566 .18413 L 1 .75 0 r
F
P
p
.31135 .17562 m .32741 .17146 L .34566 .18413 L 1 .853 0 r
F
P
p
.002 w
.59099 .42007 m .57383 .42301 L .55899 .42879 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.32268 .52408 m .33939 .50633 L .35909 .45466 L p
.991 1 0 r
F P
0 0 0 r
s
P
p
.74625 .16921 m .77651 .17784 L .75844 .18194 L 1 0 0 r
F
P
p
.72814 .17339 m .74625 .16921 L .75844 .18194 L 1 0 0 r
F
P
p
.67927 .16889 m .71021 .17753 L .69244 .18163 L 1 .026 0 r
F
P
p
.66148 .17307 m .67927 .16889 L .69244 .18163 L 1 .052 0 r
F
P
p
.002 w
.24108 .59627 m .22494 .61346 L .20723 .55387 L p
0 1 .095 r
F P
0 0 0 r
s
P
p
.002 w
.1911 .57126 m .20723 .55387 L p
.19372 .57452 L 0 1 .276 r
F P
0 0 0 r
s
P
p
.002 w
.17395 .61127 m .14552 .87157 L .12348 .86897 L p
1 0 .853 r
F P
0 0 0 r
s
P
p
.002 w
.17395 .61127 m .13931 .86811 L p
.18946 .58068 L 0 .69 1 r
F P
0 0 0 r
s
P
p
.002 w
.1911 .57126 m .18253 .59126 L p
.18946 .58068 L 0 .69 1 r
F P
0 0 0 r
s
P
p
.002 w
.18253 .59126 m .17395 .61127 L p
.18946 .58068 L 0 .69 1 r
F P
0 0 0 r
s
P
p
.002 w
.12348 .86897 m .13931 .86811 L .17395 .61127 L p
1 0 .853 r
F P
0 0 0 r
s
P
p
.002 w
.13931 .86811 m .16848 .60274 L .1911 .57126 L p
0 .69 1 r
F P
0 0 0 r
s
P
p
.002 w
.1911 .57126 m .16848 .60274 L p
.20723 .55387 L 0 1 .224 r
F P
0 0 0 r
s
P
p
.002 w
.16848 .60274 m .18488 .58509 L .20723 .55387 L p
0 1 .224 r
F P
0 0 0 r
s
P
p
.002 w
.20723 .55387 m .20488 .55716 L p
.22083 .5331 L .086 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20488 .55716 m .18488 .58509 L p
.21738 .53808 L .086 1 0 r
F P
0 0 0 r
s
P
p
.21738 .53808 m .22083 .5331 L .20488 .55716 L .086 1 0 r
F
P
p
.002 w
.22377 .52884 m .20723 .55387 L p
.22083 .5331 L .086 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20723 .55387 m .22494 .61346 L p
.19372 .57452 L 0 1 .276 r
F P
0 0 0 r
s
P
p
.002 w
.80738 .4104 m .78915 .41339 L .77741 .40409 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75914 .40714 m .77741 .40409 L .78915 .41339 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61224 .16856 m .64385 .17721 L .62639 .18131 L 1 .246 0 r
F
P
p
.59476 .17275 m .61224 .16856 L .62639 .18131 L 1 .284 0 r
F
P
p
.002 w
.13622 .87569 m .15149 .8749 L .17237 .87732 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5077 .47459 m .49089 .47728 L .47491 .44642 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.45791 .47166 m .47491 .44642 L .49089 .47728 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.74105 .41017 m .72312 .41316 L .7104 .40385 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69245 .40691 m .7104 .40385 L .72312 .41316 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.54516 .16824 m .57745 .17689 L .5603 .181 L 1 .155 0 r
F
P
p
.528 .17243 m .54516 .16824 L .5603 .181 L 1 .155 0 r
F
P
p
.002 w
.39197 .42678 m .37556 .43707 L .35619 .48847 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.35619 .48847 m .37556 .43707 L p
.34246 .50045 L 1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.35619 .48847 m .37292 .47814 L .39197 .42678 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.35619 .48847 m .33822 .45701 L p
.37005 .47639 L 1 .957 0 r
F P
0 0 0 r
s
P
p
.002 w
.37292 .47814 m .35619 .48847 L p
.37005 .47639 L 1 .957 0 r
F P
0 0 0 r
s
P
p
.002 w
.33939 .50633 m .35619 .48847 L p
.34246 .50045 L 1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.44125 .47438 m .42474 .47707 L .40845 .42012 L p
1 .478 0 r
F P
0 0 0 r
s
P
p
.002 w
.39197 .42678 m .40845 .42012 L .42474 .47707 L p
1 .504 0 r
F P
0 0 0 r
s
P
p
.002 w
.67466 .40993 m .65705 .41293 L .64334 .40361 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6257 .40667 m .64334 .40361 L .65705 .41293 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.47803 .16792 m .511 .17658 L .49416 .18068 L 1 .155 0 r
F
P
p
.46118 .17211 m .47803 .16792 L .49416 .18068 L 1 .155 0 r
F
P
p
.41085 .16759 m .4445 .17626 L .42797 .18037 L 1 .621 0 r
F
P
p
.39432 .17179 m .41085 .16759 L .42797 .18037 L 1 .724 0 r
F
P
p
.34362 .16727 m .37795 .17594 L .36173 .18005 L 1 .724 0 r
F
P
p
.32741 .17146 m .34362 .16727 L .36173 .18005 L 1 .75 0 r
F
P
p
.002 w
.55899 .42879 m .57637 .42583 L .59099 .42007 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.25731 .57899 m .24108 .59627 L .22377 .52884 L p
.138 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20723 .55387 m .22377 .52884 L .24108 .59627 L p
0 1 .095 r
F P
0 0 0 r
s
P
p
.76454 .16499 m .79476 .17371 L .77651 .17784 L 1 0 0 r
F
P
p
.74625 .16921 m .76454 .16499 L .77651 .17784 L 1 0 0 r
F
P
p
.002 w
.40845 .42012 m .39197 .42678 L .37292 .47814 L p
1 .556 0 r
F P
0 0 0 r
s
P
p
.69724 .16466 m .72814 .17339 L .71021 .17753 L 1 0 0 r
F
P
p
.67927 .16889 m .69724 .16466 L .71021 .17753 L 1 .026 0 r
F
P
p
.002 w
.82579 .40737 m .80738 .4104 L .79586 .401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77741 .40409 m .79586 .401 L .80738 .4104 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.62989 .16434 m .66148 .17307 L .64385 .17721 L 1 .142 0 r
F
P
p
.61224 .16856 m .62989 .16434 L .64385 .17721 L 1 .246 0 r
F
P
p
.002 w
.52468 .47187 m .5077 .47459 L .49193 .42857 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.47491 .44642 m .49193 .42857 L .5077 .47459 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.75914 .40714 m .74105 .41017 L .72853 .40076 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7104 .40385 m .72853 .40076 L .74105 .41017 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.22377 .52884 m .24006 .51127 L .25731 .57899 L p
.138 1 0 r
F P
0 0 0 r
s
P
p
.56249 .16401 m .59476 .17275 L .57745 .17689 L 1 .155 0 r
F
P
p
.54516 .16824 m .56249 .16401 L .57745 .17689 L 1 .155 0 r
F
P
p
.002 w
.45791 .47166 m .44125 .47438 L .42506 .41341 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.42506 .41341 m .44125 .47438 L p
.40958 .422 L 1 .478 0 r
F P
0 0 0 r
s
P
p
.002 w
.42506 .41341 m .44187 .4029 L .45791 .47166 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.42506 .41341 m .40676 .45723 L p
.44068 .40474 L 1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.44187 .4029 m .42506 .41341 L p
.44068 .40474 L 1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.40845 .42012 m .42506 .41341 L p
.40958 .422 L 1 .478 0 r
F P
0 0 0 r
s
P
p
.002 w
.69245 .40691 m .67466 .40993 L .66116 .40053 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64334 .40361 m .66116 .40053 L .67466 .40993 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.49504 .16368 m .528 .17243 L .511 .17658 L 1 .155 0 r
F
P
p
.47803 .16792 m .49504 .16368 L .511 .17658 L 1 .155 0 r
F
P
p
.42755 .16336 m .46118 .17211 L .4445 .17626 L 1 .414 0 r
F
P
p
.41085 .16759 m .42755 .16336 L .4445 .17626 L 1 .621 0 r
F
P
p
.36 .16303 m .39432 .17179 L .37795 .17594 L 1 .672 0 r
F
P
p
.34362 .16727 m .36 .16303 L .37795 .17594 L 1 .724 0 r
F
P
p
.002 w
.42506 .41341 m .40845 .42012 L .38993 .46009 L p
1 .478 0 r
F P
0 0 0 r
s
P
p
.002 w
.38993 .46009 m .40845 .42012 L p
.3814 .46429 L 1 .556 0 r
F P
0 0 0 r
s
P
p
.002 w
.38993 .46009 m .40676 .45723 L .42506 .41341 L p
1 .478 0 r
F P
0 0 0 r
s
P
p
.002 w
.38993 .46009 m .37172 .45121 L p
.39858 .45582 L 1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.40676 .45723 m .38993 .46009 L p
.39858 .45582 L 1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.37292 .47814 m .38993 .46009 L p
.3814 .46429 L 1 .556 0 r
F P
0 0 0 r
s
P
p
.002 w
.24006 .51127 m .22377 .52884 L .20242 .54419 L p
.345 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.18488 .58509 m .20242 .54419 L .22377 .52884 L p
.086 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28978 .55171 m .27336 .56918 L .25585 .50871 L p
.371 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24006 .51127 m .25585 .50871 L p
.24339 .51707 L .267 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25585 .50871 m .27336 .56918 L p
.24339 .51707 L .267 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25585 .50871 m .24006 .51127 L .21827 .54175 L p
.474 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20242 .54419 m .21827 .54175 L .24006 .51127 L p
.345 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25585 .50871 m .23524 .51608 L p
.26844 .50026 L .578 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27208 .49853 m .25585 .50871 L p
.26844 .50026 L .578 1 0 r
F P
0 0 0 r
s
P
p
.76454 .16499 m .783 .16073 L .79476 .17371 L 1 0 0 r
F
P
p
.71538 .1604 m .74625 .16921 L .72814 .17339 L 1 0 0 r
F
P
p
.69724 .16466 m .71538 .1604 L .72814 .17339 L 1 0 0 r
F
P
p
.002 w
.54177 .43173 m .52468 .47187 L .509 .4256 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.509 .4256 m .52622 .42261 L .54177 .43173 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.79586 .401 m .81449 .39789 L .82579 .40737 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64771 .16007 m .67927 .16889 L .66148 .17307 L 1 .052 0 r
F
P
p
.62989 .16434 m .64771 .16007 L .66148 .17307 L 1 .142 0 r
F
P
p
.002 w
.49193 .42857 m .509 .4256 L .52468 .47187 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.77741 .40409 m .75914 .40714 L .74684 .39765 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72853 .40076 m .74684 .39765 L .75914 .40714 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.57999 .15974 m .61224 .16856 L .59476 .17275 L 1 .155 0 r
F
P
p
.56249 .16401 m .57999 .15974 L .59476 .17275 L 1 .155 0 r
F
P
p
.002 w
.15149 .8749 m .13622 .87569 L .11458 .87322 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.47491 .44642 m .45791 .47166 L .44187 .4029 L p
1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.7104 .40385 m .69245 .40691 L .67914 .39741 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66116 .40053 m .67914 .39741 L .69245 .40691 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.51222 .15941 m .54516 .16824 L .528 .17243 L 1 .129 0 r
F
P
p
.49504 .16368 m .51222 .15941 L .528 .17243 L 1 .155 0 r
F
P
p
.002 w
.64334 .40361 m .6257 .40667 L .61164 .41982 L p
1 .129 0 r
F P
0 0 0 r
s
P
p
.002 w
.59392 .42284 m .61164 .41982 L .6257 .40667 L p
1 .181 0 r
F P
0 0 0 r
s
P
p
.4444 .15908 m .47803 .16792 L .46118 .17211 L 1 .31 0 r
F
P
p
.42755 .16336 m .4444 .15908 L .46118 .17211 L 1 .414 0 r
F
P
p
.37653 .15875 m .41085 .16759 L .39432 .17179 L 1 .621 0 r
F
P
p
.36 .16303 m .37653 .15875 L .39432 .17179 L 1 .672 0 r
F
P
p
.002 w
.30653 .52657 m .28978 .55171 L .27208 .49853 L p
.526 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25585 .50871 m .27208 .49853 L .28978 .55171 L p
.371 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49193 .42857 m .47491 .44642 L .45872 .39981 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.44187 .4029 m .45872 .39981 L .47491 .44642 L p
1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.27208 .49853 m .28816 .49588 L .30653 .52657 L p
.526 1 0 r
F P
0 0 0 r
s
P
p
.7337 .1561 m .76454 .16499 L .74625 .16921 L 1 0 0 r
F
P
p
.71538 .1604 m .7337 .1561 L .74625 .16921 L 1 0 0 r
F
P
p
.002 w
.57637 .42583 m .55899 .42879 L .54362 .41958 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.52622 .42261 m .54362 .41958 L .55899 .42879 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.66571 .15576 m .69724 .16466 L .67927 .16889 L 1 .026 0 r
F
P
p
.64771 .16007 m .66571 .15576 L .67927 .16889 L 1 .052 0 r
F
P
p
.002 w
.509 .4256 m .49193 .42857 L .47574 .39668 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.45872 .39981 m .47574 .39668 L .49193 .42857 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.79586 .401 m .77741 .40409 L .76532 .3945 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74684 .39765 m .76532 .3945 L .77741 .40409 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.59766 .15543 m .62989 .16434 L .61224 .16856 L 1 .155 0 r
F
P
p
.57999 .15974 m .59766 .15543 L .61224 .16856 L 1 .155 0 r
F
P
p
.002 w
.11458 .87322 m .12997 .8724 L .15149 .8749 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72853 .40076 m .7104 .40385 L .6973 .39426 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67914 .39741 m .6973 .39426 L .7104 .40385 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.52957 .1551 m .56249 .16401 L .54516 .16824 L 1 .078 0 r
F
P
p
.51222 .15941 m .52957 .1551 L .54516 .16824 L 1 .129 0 r
F
P
p
.002 w
.62943 .40917 m .64334 .40361 L p
.6223 .41437 L 1 .129 0 r
F P
0 0 0 r
s
P
p
.002 w
.61164 .41982 m .62943 .40917 L p
.6223 .41437 L 1 .129 0 r
F P
0 0 0 r
s
P
p
.002 w
.62943 .40917 m .61494 .40719 L p
.63668 .40388 L 1 .246 0 r
F P
0 0 0 r
s
P
p
.002 w
.66116 .40053 m .64334 .40361 L .62943 .40917 L p
1 .091 0 r
F P
0 0 0 r
s
P
p
.002 w
.64742 .40224 m .62943 .40917 L p
.63668 .40388 L 1 .246 0 r
F P
0 0 0 r
s
P
p
.46142 .15476 m .49504 .16368 L .47803 .16792 L 1 .31 0 r
F
P
p
.4444 .15908 m .46142 .15476 L .47803 .16792 L 1 .31 0 r
F
P
p
.39322 .15443 m .42755 .16336 L .41085 .16759 L 1 .569 0 r
F
P
p
.37653 .15875 m .39322 .15443 L .41085 .16759 L 1 .621 0 r
F
P
p
.002 w
.21827 .54175 m .23524 .51608 L .25585 .50871 L p
.474 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45872 .39981 m .44187 .4029 L .42375 .45434 L p
1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.40676 .45723 m .42375 .45434 L .44187 .4029 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.33939 .50633 m .32268 .52408 L .3049 .47793 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28816 .49588 m .3049 .47793 L .32268 .52408 L p
.655 1 0 r
F P
0 0 0 r
s
P
p
.7522 .15175 m .783 .16073 L .76454 .16499 L 1 0 0 r
F
P
p
.7337 .1561 m .7522 .15175 L .76454 .16499 L 1 0 0 r
F
P
p
.002 w
.59392 .42284 m .57637 .42583 L .56119 .41653 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.54362 .41958 m .56119 .41653 L .57637 .42583 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.68388 .15141 m .71538 .1604 L .69724 .16466 L 1 0 0 r
F
P
p
.66571 .15576 m .68388 .15141 L .69724 .16466 L 1 .026 0 r
F
P
p
.002 w
.52622 .42261 m .509 .4256 L .49292 .39353 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.47574 .39668 m .49292 .39353 L .509 .4256 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.81449 .39789 m .79586 .401 L .78399 .39132 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76532 .3945 m .78399 .39132 L .79586 .401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61551 .15108 m .64771 .16007 L .62989 .16434 L 1 .078 0 r
F
P
p
.59766 .15543 m .61551 .15108 L .62989 .16434 L 1 .155 0 r
F
P
p
.002 w
.74684 .39765 m .72853 .40076 L .71564 .39108 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6973 .39426 m .71564 .39108 L .72853 .40076 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.54709 .15074 m .57999 .15974 L .56249 .16401 L 1 .026 0 r
F
P
p
.52957 .1551 m .54709 .15074 L .56249 .16401 L 1 .078 0 r
F
P
p
.002 w
.28816 .49588 m .27208 .49853 L .25136 .51349 L p
.681 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.23524 .51608 m .25136 .51349 L .27208 .49853 L p
.578 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.67914 .39741 m .66116 .40053 L .64742 .40224 L p
1 .065 0 r
F P
0 0 0 r
s
P
p
.002 w
.62943 .40917 m .64742 .40224 L .66116 .40053 L p
1 .091 0 r
F P
0 0 0 r
s
P
p
.47861 .1504 m .51222 .15941 L .49504 .16368 L 1 .31 0 r
F
P
p
.46142 .15476 m .47861 .1504 L .49504 .16368 L 1 .31 0 r
F
P
p
.41008 .15007 m .4444 .15908 L .42755 .16336 L 1 .466 0 r
F
P
p
.39322 .15443 m .41008 .15007 L .42755 .16336 L 1 .569 0 r
F
P
p
.002 w
.35619 .48847 m .33939 .50633 L .32172 .45987 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3049 .47793 m .32172 .45987 L .33939 .50633 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47574 .39668 m .45872 .39981 L .44122 .42831 L p
1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.44122 .42831 m .45872 .39981 L p
.42967 .44511 L 1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.44122 .42831 m .42359 .41883 L p
.45288 .41133 L 1 .414 0 r
F P
0 0 0 r
s
P
p
.002 w
.45867 .40985 m .44122 .42831 L p
.45288 .41133 L 1 .414 0 r
F P
0 0 0 r
s
P
p
.002 w
.42375 .45434 m .44122 .42831 L p
.42967 .44511 L 1 .336 0 r
F P
0 0 0 r
s
P
p
.002 w
.32172 .45987 m .33822 .45701 L .35619 .48847 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.7522 .15175 m .77088 .14736 L .783 .16073 L 1 0 0 r
F
P
p
.002 w
.61164 .41982 m .59392 .42284 L .57893 .41345 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.56119 .41653 m .57893 .41345 L .59392 .42284 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.70223 .14702 m .7337 .1561 L .71538 .1604 L 1 0 0 r
F
P
p
.68388 .15141 m .70223 .14702 L .71538 .1604 L 1 0 0 r
F
P
p
.002 w
.54362 .41958 m .52622 .42261 L .51028 .39034 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.49292 .39353 m .51028 .39034 L .52622 .42261 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.78399 .39132 m .80284 .38811 L .81449 .39789 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.63353 .14668 m .66571 .15576 L .64771 .16007 L 1 0 0 r
F
P
p
.61551 .15108 m .63353 .14668 L .64771 .16007 L 1 .078 0 r
F
P
p
.002 w
.76532 .3945 m .74684 .39765 L .73416 .38787 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71564 .39108 m .73416 .38787 L .74684 .39765 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.56478 .14634 m .59766 .15543 L .57999 .15974 L 1 0 0 r
F
P
p
.54709 .15074 m .56478 .14634 L .57999 .15974 L 1 .026 0 r
F
P
p
.002 w
.12997 .8724 m .11458 .87322 L .09228 .87067 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.3049 .47793 m .28816 .49588 L .2685 .48759 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25136 .51349 m .2685 .48759 L .28816 .49588 L p
.681 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6973 .39426 m .67914 .39741 L .66557 .39525 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.64742 .40224 m .66557 .39525 L .67914 .39741 L p
1 .065 0 r
F P
0 0 0 r
s
P
p
.49597 .146 m .52957 .1551 L .51222 .15941 L 1 .233 0 r
F
P
p
.47861 .1504 m .49597 .146 L .51222 .15941 L 1 .31 0 r
F
P
p
.42711 .14566 m .46142 .15476 L .4444 .15908 L 1 .362 0 r
F
P
p
.41008 .15007 m .42711 .14566 L .4444 .15908 L 1 .466 0 r
F
P
p
.002 w
.45867 .40985 m .47574 .39668 L p
.45516 .41554 L 1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.44122 .42831 m .45867 .40985 L p
.45516 .41554 L 1 .207 0 r
F P
0 0 0 r
s
P
p
.002 w
.45867 .40985 m .44126 .40006 L p
.46224 .40406 L 1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.49292 .39353 m .47574 .39668 L .45867 .40985 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.45867 .40985 m .47609 .4067 L .49292 .39353 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.47609 .4067 m .45867 .40985 L p
.46224 .40406 L 1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.38993 .46009 m .37292 .47814 L .35489 .45412 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.002 w
.33822 .45701 m .35489 .45412 L .37292 .47814 L p
1 .957 0 r
F P
0 0 0 r
s
P
p
.002 w
.2685 .48759 m .2849 .48484 L .3049 .47793 L p
.81 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32172 .45987 m .3049 .47793 L .2849 .48484 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62943 .40917 m .61164 .41982 L .59684 .41033 L p
1 .284 0 r
F P
0 0 0 r
s
P
p
.002 w
.57893 .41345 m .59684 .41033 L .61164 .41982 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.72077 .14258 m .7522 .15175 L .7337 .1561 L 1 0 0 r
F
P
p
.70223 .14702 m .72077 .14258 L .7337 .1561 L 1 0 0 r
F
P
p
.002 w
.56119 .41653 m .54362 .41958 L .5278 .38712 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.51028 .39034 m .5278 .38712 L .54362 .41958 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.65173 .14224 m .68388 .15141 L .66571 .15576 L 1 0 0 r
F
P
p
.63353 .14668 m .65173 .14224 L .66571 .15576 L 1 0 0 r
F
P
p
.002 w
.78399 .39132 m .76532 .3945 L .75287 .38462 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73416 .38787 m .75287 .38462 L .76532 .3945 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.58264 .1419 m .61551 .15108 L .59766 .15543 L 1 0 0 r
F
P
p
.56478 .14634 m .58264 .1419 L .59766 .15543 L 1 0 0 r
F
P
p
.002 w
.14552 .87157 m .12997 .8724 L .1078 .86982 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.09228 .87067 m .1078 .86982 L .12997 .8724 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71564 .39108 m .6973 .39426 L .68396 .39204 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.66557 .39525 m .68396 .39204 L .6973 .39426 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.5135 .14155 m .54709 .15074 L .52957 .1551 L 1 .103 0 r
F
P
p
.49597 .146 m .5135 .14155 L .52957 .1551 L 1 .233 0 r
F
P
p
.002 w
.35489 .45412 m .37172 .45121 L .38993 .46009 L p
1 .879 0 r
F P
0 0 0 r
s
P
p
.4443 .14121 m .47861 .1504 L .46142 .15476 L 1 .31 0 r
F
P
p
.42711 .14566 m .4443 .14121 L .46142 .15476 L 1 .362 0 r
F
P
p
.002 w
.2849 .48484 m .30196 .46649 L .32172 .45987 L p
.966 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33822 .45701 m .32172 .45987 L .30196 .46649 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.51028 .39034 m .49292 .39353 L .47609 .4067 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.59684 .41033 m .61494 .40719 L .62943 .40917 L p
1 .284 0 r
F P
0 0 0 r
s
P
p
.73949 .1381 m .77088 .14736 L .7522 .15175 L 1 0 0 r
F
P
p
.72077 .14258 m .73949 .1381 L .7522 .15175 L 1 0 0 r
F
P
p
.002 w
.57893 .41345 m .56119 .41653 L .5455 .38387 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.5278 .38712 m .5455 .38387 L .56119 .41653 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.67011 .13776 m .70223 .14702 L .68388 .15141 L 1 0 0 r
F
P
p
.65173 .14224 m .67011 .13776 L .68388 .15141 L 1 0 0 r
F
P
p
.002 w
.80284 .38811 m .78399 .39132 L .77176 .38135 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75287 .38462 m .77176 .38135 L .78399 .39132 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60068 .13741 m .63353 .14668 L .61551 .15108 L 1 0 0 r
F
P
p
.58264 .1419 m .60068 .13741 L .61551 .15108 L 1 0 0 r
F
P
p
.002 w
.1078 .86982 m .12348 .86897 L .14552 .87157 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73416 .38787 m .71564 .39108 L .70235 .38109 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68396 .39204 m .70235 .38109 L .71564 .39108 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.5312 .13706 m .56478 .14634 L .54709 .15074 L 1 .026 0 r
F
P
p
.5135 .14155 m .5312 .13706 L .54709 .15074 L 1 .103 0 r
F
P
p
.002 w
.42375 .45434 m .40676 .45723 L .38903 .43275 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.37172 .45121 m .38903 .43275 L .40676 .45723 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.46167 .13671 m .49597 .146 L .47861 .1504 L 1 .259 0 r
F
P
p
.4443 .14121 m .46167 .13671 L .47861 .1504 L 1 .31 0 r
F
P
p
.002 w
.35489 .45412 m .33822 .45701 L .31936 .44027 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.30196 .46649 m .31936 .44027 L .33822 .45701 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.5278 .38712 m .51028 .39034 L .49368 .40352 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.47609 .4067 m .49368 .40352 L .51028 .39034 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.66557 .39525 m .64742 .40224 L .63321 .40401 L p
1 .142 0 r
F P
0 0 0 r
s
P
p
.002 w
.61494 .40719 m .63321 .40401 L .64742 .40224 L p
1 .246 0 r
F P
0 0 0 r
s
P
p
.73949 .1381 m .75839 .13358 L .77088 .14736 L 1 0 0 r
F
P
p
.002 w
.59684 .41033 m .57893 .41345 L .56338 .38059 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.5455 .38387 m .56338 .38059 L .57893 .41345 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.68868 .13323 m .72077 .14258 L .70223 .14702 L 1 0 0 r
F
P
p
.67011 .13776 m .68868 .13323 L .70223 .14702 L 1 0 0 r
F
P
p
.002 w
.77176 .38135 m .79084 .37804 L .80284 .38811 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61891 .13288 m .65173 .14224 L .63353 .14668 L 1 0 0 r
F
P
p
.60068 .13741 m .61891 .13288 L .63353 .14668 L 1 0 0 r
F
P
p
.002 w
.75287 .38462 m .73416 .38787 L .72109 .37778 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70235 .38109 m .72109 .37778 L .73416 .38787 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.54909 .13252 m .58264 .1419 L .56478 .14634 L 1 0 0 r
F
P
p
.5312 .13706 m .54909 .13252 L .56478 .14634 L 1 .026 0 r
F
P
p
.002 w
.44122 .42831 m .42375 .45434 L .40617 .4297 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.38903 .43275 m .40617 .4297 L .42375 .45434 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.47921 .13217 m .5135 .14155 L .49597 .146 L 1 .155 0 r
F
P
p
.46167 .13671 m .47921 .13217 L .49597 .146 L 1 .259 0 r
F
P
p
.002 w
.37172 .45121 m .35489 .45412 L .33638 .42947 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.31936 .44027 m .33638 .42947 L .35489 .45412 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.5455 .38387 m .5278 .38712 L .51145 .40031 L p
1 .129 0 r
F P
0 0 0 r
s
P
p
.002 w
.49368 .40352 m .51145 .40031 L .5278 .38712 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.68396 .39204 m .66557 .39525 L .65129 .37753 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.63321 .40401 m .65129 .37753 L .66557 .39525 L p
1 .142 0 r
F P
0 0 0 r
s
P
p
.002 w
.40617 .4297 m .42359 .41883 L .44122 .42831 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.61494 .40719 m .59684 .41033 L .58143 .37727 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.56338 .38059 m .58143 .37727 L .59684 .41033 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.70743 .12865 m .73949 .1381 L .72077 .14258 L 1 0 0 r
F
P
p
.68868 .13323 m .70743 .12865 L .72077 .14258 L 1 0 0 r
F
P
p
.63732 .1283 m .67011 .13776 L .65173 .14224 L 1 0 0 r
F
P
p
.61891 .13288 m .63732 .1283 L .65173 .14224 L 1 0 0 r
F
P
p
.002 w
.42359 .41883 m .44126 .40006 L .45867 .40985 L p
1 .414 0 r
F P
0 0 0 r
s
P
p
.002 w
.77176 .38135 m .75287 .38462 L .74002 .37444 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72109 .37778 m .74002 .37444 L .75287 .38462 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.56715 .12794 m .60068 .13741 L .58264 .1419 L 1 0 0 r
F
P
p
.54909 .13252 m .56715 .12794 L .58264 .1419 L 1 0 0 r
F
P
p
.49693 .12759 m .5312 .13706 L .5135 .14155 L 1 .052 0 r
F
P
p
.47921 .13217 m .49693 .12759 L .5135 .14155 L 1 .155 0 r
F
P
p
.002 w
.38903 .43275 m .37172 .45121 L .35334 .42639 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.33638 .42947 m .35334 .42639 L .37172 .45121 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.51145 .40031 m .52941 .38925 L .5455 .38387 L p
1 .129 0 r
F P
0 0 0 r
s
P
p
.002 w
.56338 .38059 m .5455 .38387 L .52941 .38925 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.70235 .38109 m .68396 .39204 L .66987 .37418 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.65129 .37753 m .66987 .37418 L .68396 .39204 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.40617 .4297 m .38903 .43275 L .37048 .42328 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.35334 .42639 m .37048 .42328 L .38903 .43275 L p
1 .672 0 r
F P
0 0 0 r
s
P
p
.002 w
.63321 .40401 m .61494 .40719 L .59967 .37392 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.58143 .37727 m .59967 .37392 L .61494 .40719 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.72638 .12403 m .75839 .13358 L .73949 .1381 L 1 0 0 r
F
P
p
.70743 .12865 m .72638 .12403 L .73949 .1381 L 1 0 0 r
F
P
p
.65591 .12367 m .68868 .13323 L .67011 .13776 L 1 0 0 r
F
P
p
.63732 .1283 m .65591 .12367 L .67011 .13776 L 1 0 0 r
F
P
p
.002 w
.49368 .40352 m .47609 .4067 L .45886 .39681 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.44126 .40006 m .45886 .39681 L .47609 .4067 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.79084 .37804 m .77176 .38135 L .75914 .37106 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74002 .37444 m .75914 .37106 L .77176 .38135 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5854 .12331 m .61891 .13288 L .60068 .13741 L 1 0 0 r
F
P
p
.56715 .12794 m .5854 .12331 L .60068 .13741 L 1 0 0 r
F
P
p
.002 w
.72109 .37778 m .70235 .38109 L .68865 .3708 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66987 .37418 m .68865 .3708 L .70235 .38109 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.51483 .12296 m .54909 .13252 L .5312 .13706 L 1 0 0 r
F
P
p
.49693 .12759 m .51483 .12296 L .5312 .13706 L 1 .052 0 r
F
P
p
.002 w
.58143 .37727 m .56338 .38059 L .54751 .37809 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.52941 .38925 m .54751 .37809 L .56338 .38059 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.42359 .41883 m .40617 .4297 L .38778 .42014 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.002 w
.37048 .42328 m .38778 .42014 L .40617 .4297 L p
1 .621 0 r
F P
0 0 0 r
s
P
p
.002 w
.65129 .37753 m .63321 .40401 L .6181 .37054 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.59967 .37392 m .6181 .37054 L .63321 .40401 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.72638 .12403 m .74551 .11936 L .75839 .13358 L 1 0 0 r
F
P
p
.6747 .119 m .70743 .12865 L .68868 .13323 L 1 0 0 r
F
P
p
.65591 .12367 m .6747 .119 L .68868 .13323 L 1 0 0 r
F
P
p
.002 w
.51145 .40031 m .49368 .40352 L .47664 .39353 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.45886 .39681 m .47664 .39353 L .49368 .40352 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.75914 .37106 m .77846 .36765 L .79084 .37804 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60383 .11864 m .63732 .1283 L .61891 .13288 L 1 0 0 r
F
P
p
.5854 .12331 m .60383 .11864 L .61891 .13288 L 1 0 0 r
F
P
p
.002 w
.74002 .37444 m .72109 .37778 L .70761 .36738 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68865 .3708 m .70761 .36738 L .72109 .37778 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.53291 .11828 m .56715 .12794 L .54909 .13252 L 1 0 0 r
F
P
p
.51483 .12296 m .53291 .11828 L .54909 .13252 L 1 0 0 r
F
P
p
.002 w
.66987 .37418 m .65129 .37753 L .63671 .36712 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6181 .37054 m .63671 .36712 L .65129 .37753 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.59967 .37392 m .58143 .37727 L .56575 .36685 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.54751 .37809 m .56575 .36685 L .58143 .37727 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.44126 .40006 m .42359 .41883 L .40541 .40905 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.38778 .42014 m .40541 .40905 L .42359 .41883 L p
1 .569 0 r
F P
0 0 0 r
s
P
p
.69368 .11428 m .72638 .12403 L .70743 .12865 L 1 0 0 r
F
P
p
.6747 .119 m .69368 .11428 L .70743 .12865 L 1 0 0 r
F
P
p
.002 w
.52941 .38925 m .51145 .40031 L .49461 .39022 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.47664 .39353 m .49461 .39022 L .51145 .40031 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.62245 .11391 m .65591 .12367 L .63732 .1283 L 1 0 0 r
F
P
p
.60383 .11864 m .62245 .11391 L .63732 .1283 L 1 0 0 r
F
P
p
.002 w
.45886 .39681 m .44126 .40006 L .42306 .40581 L p
1 .362 0 r
F P
0 0 0 r
s
P
p
.002 w
.40541 .40905 m .42306 .40581 L .44126 .40006 L p
1 .466 0 r
F P
0 0 0 r
s
P
p
.002 w
.75914 .37106 m .74002 .37444 L .72677 .36393 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70761 .36738 m .72677 .36393 L .74002 .37444 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.55117 .11355 m .5854 .12331 L .56715 .12794 L 1 0 0 r
F
P
p
.53291 .11828 m .55117 .11355 L .56715 .12794 L 1 0 0 r
F
P
p
.002 w
.68865 .3708 m .66987 .37418 L .65551 .36366 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63671 .36712 m .65551 .36366 L .66987 .37418 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6181 .37054 m .59967 .37392 L .5842 .3634 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56575 .36685 m .5842 .3634 L .59967 .37392 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.54751 .37809 m .52941 .38925 L .5128 .37102 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.002 w
.49461 .39022 m .5128 .37102 L .52941 .38925 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.71285 .10951 m .74551 .11936 L .72638 .12403 L 1 0 0 r
F
P
p
.69368 .11428 m .71285 .10951 L .72638 .12403 L 1 0 0 r
F
P
p
.64127 .10914 m .6747 .119 L .65591 .12367 L 1 0 0 r
F
P
p
.62245 .11391 m .64127 .10914 L .65591 .12367 L 1 0 0 r
F
P
p
.002 w
.47664 .39353 m .45886 .39681 L .44109 .38661 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.42306 .40581 m .44109 .38661 L .45886 .39681 L p
1 .362 0 r
F P
0 0 0 r
s
P
p
.002 w
.77846 .36765 m .75914 .37106 L .74612 .36044 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72677 .36393 m .74612 .36044 L .75914 .37106 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.56963 .10877 m .60383 .11864 L .5854 .12331 L 1 0 0 r
F
P
p
.55117 .11355 m .56963 .10877 L .5854 .12331 L 1 0 0 r
F
P
p
.002 w
.70761 .36738 m .68865 .3708 L .67451 .36017 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65551 .36366 m .67451 .36017 L .68865 .3708 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63671 .36712 m .6181 .37054 L .60283 .3599 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5842 .3634 m .60283 .3599 L .6181 .37054 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56575 .36685 m .54751 .37809 L .5311 .35963 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.002 w
.5128 .37102 m .5311 .35963 L .54751 .37809 L p
1 .103 0 r
F P
0 0 0 r
s
P
p
.71285 .10951 m .73222 .10469 L .74551 .11936 L 1 0 0 r
F
P
p
.66027 .10432 m .69368 .11428 L .6747 .119 L 1 0 0 r
F
P
p
.64127 .10914 m .66027 .10432 L .6747 .119 L 1 0 0 r
F
P
p
.002 w
.49461 .39022 m .47664 .39353 L .45906 .38322 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.44109 .38661 m .45906 .38322 L .47664 .39353 L p
1 .31 0 r
F P
0 0 0 r
s
P
p
.002 w
.74612 .36044 m .76568 .35692 L .77846 .36765 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.58827 .10395 m .62245 .11391 L .60383 .11864 L 1 0 0 r
F
P
p
.56963 .10877 m .58827 .10395 L .60383 .11864 L 1 0 0 r
F
P
p
.002 w
.72677 .36393 m .70761 .36738 L .6937 .35665 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67451 .36017 m .6937 .35665 L .70761 .36738 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65551 .36366 m .63671 .36712 L .62166 .35638 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60283 .3599 m .62166 .35638 L .63671 .36712 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5842 .3634 m .56575 .36685 L .54957 .3561 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5311 .35963 m .54957 .3561 L .56575 .36685 L p
1 .026 0 r
F P
0 0 0 r
s
P
p
.67948 .09945 m .71285 .10951 L .69368 .11428 L 1 0 0 r
F
P
p
.66027 .10432 m .67948 .09945 L .69368 .11428 L 1 0 0 r
F
P
p
.002 w
.5128 .37102 m .49461 .39022 L .47735 .3638 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.002 w
.45906 .38322 m .47735 .3638 L .49461 .39022 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.60711 .09907 m .64127 .10914 L .62245 .11391 L 1 0 0 r
F
P
p
.58827 .10395 m .60711 .09907 L .62245 .11391 L 1 0 0 r
F
P
p
.002 w
.74612 .36044 m .72677 .36393 L .71309 .35309 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6937 .35665 m .71309 .35309 L .72677 .36393 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67451 .36017 m .65551 .36366 L .64069 .35281 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62166 .35638 m .64069 .35281 L .65551 .36366 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60283 .3599 m .5842 .3634 L .56823 .35254 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.54957 .3561 m .56823 .35254 L .5842 .3634 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5311 .35963 m .5128 .37102 L .49566 .36027 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.47735 .3638 m .49566 .36027 L .5128 .37102 L p
1 .155 0 r
F P
0 0 0 r
s
P
p
.69889 .09452 m .73222 .10469 L .71285 .10951 L 1 0 0 r
F
P
p
.67948 .09945 m .69889 .09452 L .71285 .10951 L 1 0 0 r
F
P
p
.62615 .09414 m .66027 .10432 L .64127 .10914 L 1 0 0 r
F
P
p
.60711 .09907 m .62615 .09414 L .64127 .10914 L 1 0 0 r
F
P
p
.002 w
.76568 .35692 m .74612 .36044 L .73269 .34949 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71309 .35309 m .73269 .34949 L .74612 .36044 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6937 .35665 m .67451 .36017 L .65991 .34921 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64069 .35281 m .65991 .34921 L .67451 .36017 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62166 .35638 m .60283 .3599 L .58708 .34893 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56823 .35254 m .58708 .34893 L .60283 .3599 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.54957 .3561 m .5311 .35963 L .51419 .34865 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.49566 .36027 m .51419 .34865 L .5311 .35963 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.69889 .09452 m .7185 .08955 L .73222 .10469 L 1 0 0 r
F
P
p
.64538 .08916 m .67948 .09945 L .66027 .10432 L 1 0 0 r
F
P
p
.62615 .09414 m .64538 .08916 L .66027 .10432 L 1 0 0 r
F
P
p
.002 w
.73269 .34949 m .75249 .34585 L .76568 .35692 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71309 .35309 m .6937 .35665 L .67934 .34557 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65991 .34921 m .67934 .34557 L .6937 .35665 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64069 .35281 m .62166 .35638 L .60613 .34529 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58708 .34893 m .60613 .34529 L .62166 .35638 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56823 .35254 m .54957 .3561 L .53286 .34501 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.51419 .34865 m .53286 .34501 L .54957 .3561 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66482 .08413 m .69889 .09452 L .67948 .09945 L 1 0 0 r
F
P
p
.64538 .08916 m .66482 .08413 L .67948 .09945 L 1 0 0 r
F
P
p
.002 w
.73269 .34949 m .71309 .35309 L .69897 .34189 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67934 .34557 m .69897 .34189 L .71309 .35309 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65991 .34921 m .64069 .35281 L .62538 .34161 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60613 .34529 m .62538 .34161 L .64069 .35281 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58708 .34893 m .56823 .35254 L .55173 .34132 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.53286 .34501 m .55173 .34132 L .56823 .35254 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68447 .07905 m .7185 .08955 L .69889 .09452 L 1 0 0 r
F
P
p
.66482 .08413 m .68447 .07905 L .69889 .09452 L 1 0 0 r
F
P
p
.002 w
.75249 .34585 m .73269 .34949 L .71881 .33817 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69897 .34189 m .71881 .33817 L .73269 .34949 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67934 .34557 m .65991 .34921 L .64484 .33789 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62538 .34161 m .64484 .33789 L .65991 .34921 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60613 .34529 m .58708 .34893 L .57081 .3376 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.55173 .34132 m .57081 .3376 L .58708 .34893 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68447 .07905 m .70433 .07391 L .7185 .08955 L 1 0 0 r
F
P
p
.002 w
.71881 .33817 m .73887 .33442 L .75249 .34585 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69897 .34189 m .67934 .34557 L .66451 .33413 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64484 .33789 m .66451 .33413 L .67934 .34557 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62538 .34161 m .60613 .34529 L .59009 .33383 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.57081 .3376 m .59009 .33383 L .60613 .34529 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71881 .33817 m .69897 .34189 L .68439 .33032 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66451 .33413 m .68439 .33032 L .69897 .34189 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64484 .33789 m .62538 .34161 L .60957 .33003 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59009 .33383 m .60957 .33003 L .62538 .34161 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73887 .33442 m .71881 .33817 L .70448 .32648 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68439 .33032 m .70448 .32648 L .71881 .33817 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66451 .33413 m .64484 .33789 L .62927 .32619 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60957 .33003 m .62927 .32619 L .64484 .33789 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70448 .32648 m .72479 .3226 L .73887 .33442 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68439 .33032 m .66451 .33413 L .64918 .3223 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62927 .32619 m .64918 .3223 L .66451 .33413 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70448 .32648 m .68439 .33032 L .66931 .31837 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64918 .3223 m .66931 .31837 L .68439 .33032 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72479 .3226 m .70448 .32648 L .68966 .3144 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66931 .31837 m .68966 .3144 L .70448 .32648 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68966 .3144 m .71023 .31038 L .72479 .3226 L p
1 0 0 r
F P
0 0 0 r
s
P
p
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.08509 .19367 m
.08465 .20033 L
s
P
[(0)] .08595 .18034 -0.06484 1 Mshowa
p
.002 w
.23498 .15292 m
.23469 .15959 L
s
P
[(10)] .23556 .13958 -0.04346 1 Mshowa
p
.002 w
.40002 .10806 m
.39989 .11474 L
s
P
[(20)] .40028 .0947 -0.01962 1 Mshowa
p
.002 w
.58262 .05842 m
.58267 .0651 L
s
P
[(30)] .58253 .04506 .00711 1 Mshowa
p
.001 w
.11395 .18582 m
.11371 .18982 L
s
P
p
.001 w
.14336 .17783 m
.14314 .18183 L
s
P
p
.001 w
.17332 .16968 m
.17311 .17368 L
s
P
p
.001 w
.20386 .16138 m
.20367 .16538 L
s
P
p
.001 w
.2667 .1443 m
.26655 .1483 L
s
P
p
.001 w
.29905 .1355 m
.29892 .13951 L
s
P
p
.001 w
.33204 .12654 m
.33192 .13054 L
s
P
p
.001 w
.36569 .11739 m
.36559 .1214 L
s
P
p
.001 w
.43505 .09854 m
.43499 .10254 L
s
P
p
.001 w
.4708 .08882 m
.47076 .09283 L
s
P
p
.001 w
.5073 .0789 m
.50728 .0829 L
s
P
p
.001 w
.54456 .06877 m
.54457 .07277 L
s
P
p
.001 w
.6215 .04785 m
.62155 .05186 L
s
P
p
.001 w
.66122 .03706 m
.6613 .04106 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{266, 253},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004:0000o@P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l02`000?mK2U/10000oe/:F`40003oF`YK
0@000?mK2U/10000oe/:F`40003oF`YK0@000?mK2U/10000oe/:F`40003oF`YK0@0005iK00?oFol0
0e/01?mKFe/3o`04FomKo`AK00GoFe]Ko`2AF`40001NF`03oe_o00=K00CoFe_o0e/2o`03FomK009K
00?oFol09E/4o`=K1?mTF`40001NF`03oe_o00=K00CoFe_o15/00omKo`03F`03oe_o02AK00?oFe/0
0U/00omKo`04F`03oe]K065K0@0005iK00?oFol00e/01?mKFol4F`03oe_o00=K00?oFol095/00omK
F`02F`03oe_o00AK00?oFe/0HE/10000GU/00omKo`03F`04oe]Ko`AK00?oFol00e/00omKo`0YF`03
oe_o00AK00?oFe/04E/3odeK0@0005iK00CoFooo0U/01?mKFol3F`;o00EKoe]Ko`03F`03oe]K02=K
0ol2F`03oe]K009K00?oFe/03U/3o`9K00?oFe/0Be/10000GU/01?mKoe/2o`AK0ol015_oFol2F`05
oe]KFol0:5/00omKo`04F`03oe]K00YK1?l6F`03oe]K00UK00CoFe]K1?liF`40001NF`03oe]K00]K
00?oFe/0:U/00omKF`02F`03oe_o00AK00?oFe/01U/4o`03FomK00QK00?oFe/025/01?mKFol4F`03
oe]K03IK0@0005iK00?oFe/02e/00omKo`0ZF`03oe]K009K00?oFol015/00omKF`03F`?o1E/00omK
F`08F`03oe]K00=K1_l00e_oF`03F`03oe]K03IK0@0009YK1?l3F`Co0U/4oaAK00?oFe/00U/01OmK
Fe_o009K00?oFe/00U/00omKF`0fF`40002TF`?o0U/00omKF`0DF`;o0e/01?mKFol2F`03oe]K009K
00?oFe/0=U/10000X5/4oa]K00?oFol015/00omKo`02F`03oe]K009K00?oFe/0=U/10000WE/4ob5K
00OoFe]Koe_o009K00?oFe/00U/00omKF`0fF`40001^F`Ko0U/4oamK1?l3F`03oe]K01mK00?oFe/0
0U/2o`9K00?oFe/00U/00omKF`0fF`40001^F`03oe]K00AK00?oFe/00U/00omKF`0HF`Co1e/00omK
F`0PF`03oe]K009K00CoFe]K1?liF`40001_F`03oe]K00=K00?oFe/00U/00omKF`0EF`?o0U/00omK
F`0ZF`03oe]K049K0@00071K0_l3F`03oe]K009K00?oFe/04E/4oc=K00?oFe/0@E/10000LU/01?mK
Fol4F`03oe]K00iK1?l/F`<S25/00omKF`10F`40001cF`03oe_o00AK00?oFe/02U/4o`=K00?oFe/0
9E/98`QK00?oFe/0?e/10000KU/00omKF`02F`03oe_o00AK00?oFe/01U/4obYK3b<8F`03oe]K03iK
0@0006iK00?oFe/00U/00omKo`04F`03oe]K00=K0ol3F`03oe]K02AK4b<9F`03oe]K03eK0@0006mK
1?l3F`Co0U/4obUK62<8F`03oe]K03eK0@0007UK0ol00e_oF`0XFa/S25/00omKF`0lF`40001;F`03
oe]K009K1?lQF`Co:e/O8`QK00?oFe/0>e/10000Be/01OmKFe_o00AK00?oFe/06U/5obUK9B<8F`03
oe]K03YK0@0004]K00GoFe]Ko`04F`03oe]K01MK0ol4F`03oe]K02=K:R<8F`03oe]K03UK0@0004]K
00GoFe]Ko`04F`03oe]K01=K1?lYFblS25/00omKF`0hF`40001;F`05oe]KFol015/00omKF`0@F`?o
0e/00omKF`0RFc@S2E/00omKF`0gF`40001;F`05oe]KFol015/00omKF`0<F`Co9e/47cDS2E/00omK
F`0fF`400019F`?o0e/00omKF`02F`03oe]K00UK0ol2F`03oe]K029K0el01QmO7elOGcDS25/00omK
F`0fF`40001;F`05oe]KFol015/00omKF`05F`Co9U/025lGGelOGamO1Ql28`037elO030S25/00omK
F`0eF`40001;F`03oe]K009K1?l4F`Co00=Koe/08e/3G`057elOGal01El00amO7`02G`HO<2<8F`03
oe]K03AK0@0005EK0olVF`=O00TOGamO7elGGaL00Ul011mO7el77`04GamO7c0S25/00omKF`0cF`40
000YF`Co95/4o`03FomK02AK1AL6G`057elOGal00el01amO7amO7el01Ql`8`QK00?oFe/0<U/10000
:5/00omKF`02F`03oe]K01iK0olXF`044ALA5`IO00TOGamO7elGGal01el67`04GamO7`dS00<OGal0
82<8F`03oe]K035K0@0002QK00?oFe/00U/00omKF`0JF`Go9U/02A4G4ALA5a4G4@055`aO00@OGamO
0Ql2G`037elO00@O22<3G`057elOGal022<37aDS25/00omKF`0IF`Co00=Koe/01?l2F`05oe]KFol0
0e/1o`5K0@0002QK00?oFe/00U/00omKF`0FF`Co15/00omKF`0PF`03Wa6O00HA00DG4ALA5`02G`0=
7elOGamO7elOGamO7`04G`0=7elOGamO7elOGamO7`038`0=7elOGamO7elOGamO7`038`<O00EO7elO
G`0E8`QK00?oFe/05e/00omKF`02F`?o15/00omKo`03F`03oe]K00=K0@0002QK00?oFe/00U/00omK
F`0CF`?o00=Koe/09E/4W`044IlAW`8A00@G4ALA1ALAG`037elO009O00@OGamO0Ql>G`037emO00=O
00@OGamO1QlE8`QK00?oFe/05E/00omKF`04F`;o1U/01OmKFe_o00EK0@0002QK00?oFe/00U/00omK
F`0?F`Co9e/:W`044IlAW`<A00fO4A4G4ALAGamO7elO009O01lOGamO7elOGamO7elOGamO7elOGamO
7elOGamO7elO00=O2al01ElOGamO01DS1e/00omKF`0EF`03oe]K00AK1ol00e_oF`02F`03oe]K00=K
0@0002QK00?oFe/00U/00omKF`0<F`?o00=Koe/095/00ioOW`02g`04WmnOg`FO00XAWmnOgilAWa6O
1ALAG`037emO00mO00HOGelOGal7G`047elOG`HO5B<7F`03oe]K00EK1?l3F`Co15/01?mKFe/5o`AK
00?oFol00e/00omKF`03F`40000XF`03oe]K009K00?oFe/025/4obIK1=l=W`03gioO00JO00DAWa4A
5`05G`0J7elOGamO7elOGamO7elOGamO7elOGamO7el27`03GamO00UO2al01ElOGamO01DS1e/00omK
F`03F`03oe]K009K00?oFol015/01OmKFe_o00MK00?oFe/00U/01?mKool2F`03oe]K00=K0@0002UK
1?l8F`?o00=Koe/08e/4g`FO00COWmnO0]l019oOWml2W`03gioO00:O00KOWmnO4Il3G`DO85l00amO
7`02G`0>7elOGamO7elOGamO7el37aPS1e/00omKF`07F`03oe_o00AK00GoFe]Ko`06F`03oe_o00?o
0U/01?mKool6F`40000aF`Co8U/4gP07gmkOgmkOgP06g`:O00SOWmnOgioOW`;O00BOgioO0Yl00aLA
5`0;G`0@7elOGamO7elOGamO7elOG`8O00aO7elOGamO7elOGal2G`087elOGalG7aL87adS1e/00omK
F`06F`03oe_o00AK00?oFe/00U/00omKF`02F`03oe]K011K0@0002eK1?l00e_oF`0OF`03LMia00KN
2=l2W`WO00BOgioO0Yl00mlA4@034@035a4G00EO1QlKG`085elGGamO7el27`06GamO7elO8B<8F`04
oe]Ko`AK00?oFol015/00omKF`03F`Co4e/10000:U/3ob=K00QagW5agW7NL@GN00?Og]h00mh04]oN
gmoNgmkOg]nOgioOWa4G4@HG00@A5a4G2el05QmO7elOGalA5a5O7elOGamO7elOGal4G`0<7aLO5amO
7elOGalG9R<6F`04oe_oF`Go0U/00omKF`02F`03oe]K01YK0@0002QK0_l00e_oF`0OF`0<LMeagMia
gW7NLMia3=h7g`NO00DG4ALA5`064@045a4G4@EO1Al2G`084ALA4ALA5a47G`TO00MO5elGGamO02/S
25/2o`IK00?oFe/00U/00omKF`0JF`40000XF`;o00>1Fe/075/3g0GM00CNLMia0]h0277MLMgNLMia
1]h00moNg`03g`044MlAg`FO00DA5a4G4@065`044ALA5`IO00>O4Il01Q401QLA5a5O7`iO00DO5amO
7`0]8`MK00?oFol01E/00omKF`02F`03oe]K01YK0@0002QK00?oFh406U/01=c/g>`5U@06LMeagMia
1=d5L@KN00COg]oN1Ml6W`034ALA00HG1Q401aNOWioOWml00Yl0116O4Il24@035a4A008G00=O5el0
31l00elOG`057bdS1e/6o`9K1?lMF`40000XF`03oe^101MK00O<3LcLk=c/00KL0]d03=bEg9GMUMfE
LMeag@9a0]h01moNg]oNgmh01Ml01A7OWa6O00DA00@G4ALA0aL02=lAga7O4MlA1Yl54@095a4GGaMO
5elG00IO00@OGamO1Al015lOGal28`04GamO7bLS1e/00omKF`0UF`40000XF`03oe^101=K13l5c004
g>cLk0:E00?/g>`00]`019GLUM`4g@9a1=h4g`05g]oNgmh00]l039oOWmnO4IlA5a4G4@<G3Il02MnO
4ALA5a4G4@025`034ALA008G0Ul00amO7`057`03GamO008O15l011mO7el67bLS1e/00omKF`0TF`40
000XF`03oe^1011K0b<5C`073L`=c0g/g003k0GL00ZEg9GLUMfEgg7O1Mh00moNg`02gP03ginO00NO
00@AWa6O0Q403mlAga7O4MlAga7O4MlAg`0>4@095elOGamO7elO00IO00POGemO7elOG`LO00AO7elO
9b<7F`03oe]K02=K0@0002QK00?oFh4035/98`@o0/`03;Nf]kKLk=c/g>cLk0;L00BELMia2]h2g`>O
1]l01YoOWmnO4@nO00<AWa401A401QLA5a4G4@AO00<OGal00Ul011mO7el27`075elGGamO7`06G`04
7elOG`HO9b<7F`03oe]K029K0@0002QK00?oFh4035/:8`9?0lH6]`C/0]`3g@Ia00?OLMl00]h01=oN
gmh5g`JO1=l04Q7O4MlAga7O4MlAWmnO4IlAW`PA01IO5emO7elOGamO7elOGa4G4AMO5elG1El011mO
7el77`04GamO7bLS1e/00omKF`0QF`40000WF`04oe]KP@mK1B<4?`K600>f]md00md01g7MLG7MLMd0
0W400miagP02gP09LMiag]oNgmkO00BO1Ml;W`03gioO00FO00@AWa6O1a400aMO5`06G`087elG4ALA
5a425`09GaMO5elO5elG00EO00@OGamO0alZ8`MK00?oFe/085/100009e/3o`03PE]K00mK1B<014lo
Ccl2aP0=k=c/g=fEgIEaUG6EL@02g@03UMfE00Aa1Mh00moNgP03gP08gmkOg]nOgil5g`054MoOWml0
1il01=nO4Il54@075a4G4AMO5`02G`037a4A008A00TG4ALA5a4G4AL01El021lG7aLOGamO0al^8`MK
00?oFe/085/1000065/4o`=K1?l4F`>155/48`8o0d`01Mc/g>cL00GM00=ag=`00]`5U@0BLMiagW7N
UG6ELMiagW7Og]oN0ml00ioOW`04W`04gioOW`;O00fOgioOWa6O4ALA5a4G008A00SOWmnO4IlAW`DG
00TA5a4G4ALA5a401Ul00aMO5`02Gc<S1e/00omKF`0OF`40000GF`03oe]K009K00?oFol015/01_mK
Fe_oF`:155/58`0>CDa=C4g/g>cLgIFf]KH5g005gIGMUMd00W401iGLUG7MLMd01Mh05=oNgmkOWmnO
gioO4MlAWmnOgioO1Il0116O4Il24@RO00@AWa6O1A402QLA5a4G4ALA5a42G`<O00AO7elO=2<7F`03
oe]K01iK0@0001aK00?oFol015/02?mKFe_oFh5K0X4DF`@S1D`02^cLaXc6o;Gl]O`4g0:E1>`02YGL
UMaaUG6ELMh4g`08g]oNgioOWml4W`06ginOgioO0Yl01mnOgilAgil00]l03IoOWmnOgioOWa7OWml0
1Q4021LA5a4G4ElO0Ul00amO7`057c@S1e/00omKF`0MF`40000CF`?o1U/00omKo`04F`07oe]KFomK
P@03F`:155/38`0?CDa?@Tm2aXc6S<Jf]KJe00;L00je3KG/g>cLk=bEg9Eag@CN00?Og]l00]h01=oN
gil5g`03WmnO00;O00BOgioO0Yl01]nOgmnOg`RO00OO4MoOWmnO00DA00@G4ElO1Ul57`03Gb<S03DS
1e/00omKF`0LF`40000GF`03oe]K009K00?oFol015/01omKFe_oFh401E/2PA1K00B1Fe]K0b<6@P03
aX`o008o00B<C8a<1KD2k00;gIGMUMiag]oNgmh01Ml01MkOg]oN00KO00BOginO1]l00ioOW`02g`03
WmoO00ZO00?OWml00Q4015lGGaL5G`037elO009O00<O8b<032<37bTS25/00omKF`0KF`40000GF`Go
0U/00omKF`02F`07oe]KFomKP@07F`03PE]K00eK00>1Fe/00U/58`03@TlS008S01<oCcm?C8a<S4be
3Mc/g9EaUG6E00[N00?Og]l01ml3gP04gmkOgPGO00>Ogml00ml02ioOWmlAga7O4MlA00;O00bO4A4A
5elGGaLOGal3G`@O2R<47`04GamO7bTS25/00omKF`0JF`40000GF`03oe]K00AK00?oFe/00U/01omK
Fe_oFh4025/2P@eK00>1Fe/00e/:8`@o01><C0fe3KGLk=c/UMfEgIGNLMia00;N00YagW7Og]oNgmkO
0mh00moNg`02gP04gmkOgP?O00[NgmoNgmjOgioO19l01]lAWa6O4@DG00=O5el00Ul00amO7`02G`04
7elOG`8S0Ul011mO7el27`03GamO00<O00=O7b<0:2<8F`03oe]K01UK0@0001QK00?oFe/00e/00omK
F`02F`07oe]KFomKP@0:F`:12e/00h5KF`05F`TS00<oCfH00VH6]@05g>cLUG401=`4L@GN00COLMia
2Mh01]oNgW7NL@CN1Ml019oOWml2W`06gilAWa6O0a4035lOGamO7elGGaMO5`<O00DG7elOG`097`03
GalO00<O1b<00amO8`0P8`IK00?oFe/06E/1000065/5o`9K1?l4F`;o00>1Fe/02U/2P@UK00>1Fe/0
25/88`EV014=]De<CD`=c0fEg9GLUG7NL@02gP08LMgMgMiagW45gP04gmkNL@;N00=agW400]h01MoN
gmoN00CO00>Ogil00]l029oO4ImO5elG2El00amOG`02G`035elG00EO00HOGelOGal3G`057elOGal0
0R<3G`047elOG`LS0alG8`IK00?oFe/065/100009e/00omKP@0>F`:11e/00h5KF`0:F`PS0VH033m?
?da=C4e<3L`=c0;L0n`05]bEg9GMUMfEgG7NUMfELMeagMiagW42gP03LMkO00WO00>Ogil00Yl44@0H
5elGGaLOGamO7elA5a5O7elOGaLO5amO0Ql01UlOGaMO5`9O00<OGal00Ql02aLO5amO7elOGamO008S
0al01ElOGamO01LS1U/00omKF`0GF`40000WF`03oe^1011K0X45F`03PE]K00aK22<4?`07C4e<CD`=
c003`004g>cLk0BE0]d8U@Ea00?Ngml01Ml5gPGO00ZOgioO4ALA5a5O0QL01Q4G4ALA5`@A0Ul35`UO
00hOGemO7elOGalGGaMO5`AO00@OGamO0Ql00elOG`057aLS1U/00omKF`04F`Co0e/4o`MK0@0002MK
00?oFh404U/2P@=K00>1Fe/03U/88`09?dloC4dPCb1?00G60n`01MbEk=c/00GL00KMUMfELMd4gP06
gmkOg]oN1=l00ioOW`08W`8A19l84@055a4G4AL015l04amO7elOGamO7elOGamO5elGGaL00Ql01UlO
GamO7`EO11l01ElOGamO01HS1e/00omKF`02F`03oe]K009K00?oFol015/00omKF`04F`40000WF`03
oe^101AK0X400e^1F`0@F``S1Cl2`003c0g<00Bf00G/g>cLk002U@03gG7M00WN0]l2gP03WmnO00;O
00>Ogil00ml00ioOW`09W`044ALA5`8A00>O4Il011445`eO00<OGel02el00amOG`02G`047elOG`DO
5R<7F`05oe]KFol015/00omKo`04F`03oe]K00AK0@0002IK00CoFe^15U/2PA9K3B<01B1?ITiV00C<
00fe][Ff]NcLk=c/UG6E009a00?OLMl01]h3g`09WmnOgioOWmoN00GO00@Aga7O2Il0116O4Il24@0>
5emO7elOGamO7elOGal3G`0:7elOGamO7elOG`8O00UO7elOGamO7el01Al00elO8`0H8`EK0ol2F`03
oe]K009K00?oFol015/00omKF`04F`40000VF`04oe]KPAMK0X4CF`dS00Q2IT9V@/`=c0:f1<002>cL
k=c/gG7M1]h00g7NL@04gP03WmoN00?N00OOg]oNgioO00>O0ml019oOWml5W`054ALA5a402Ul34@<G
55lR8`MK00CoFooo0e/00omKo`04F`03oe]K00AK0@0002IK00CoFe^15e/0185KPH4AF`03PE/S00`S
00QVCR0Q84m2C`G600kLk=c/g>bEgIGOLMmag`;N00?LUG400g46gP07gmkOWmnOg`07W`PA00@G4ALA
0el00amO4@024@055a4G4AL015l27`0@5alG7elOGamO7elOGamO7b<S25/00omKo`02o`9K00?oFe/0
0U/00omKF`04F`40000VF`;o00>1Fe/05E/00h5KF`02F`:13e/0185KFe/=8`DP0d82`0=<1M`3g@;N
1=`00iGLU@05L@SN00FOgioOW`02g`06Wa6O5a4G0Q401ALA5a4G00>O1A400aLA5`034@085a4GGamO
5el3o`QO00DOGamO7`028`8O7b<7F`03oe]K00AK00?oFe/00U/00omKF`04F`40000VF`03oe^101MK
00>1Fe/015/2P@eK00>1Fe/00U/>8`03824S00DS00e=C4e<CMc/3L3Lk=c/00GL00>Eg9D00g400mia
gP04gP0=gmkOWmlAga7O4IlAW`064@BO00?OWml02Q400aLA5`05o`<S01;o7elOGamO7elOGalG7elO
Gal68`03GamO01HS1e/01omKFe_oFol015/00omKF`04F`40000VF`03oe^101MK00>1Fe/01U/2P@]K
00>1Fe/015/F8`9<00]??do0c<3/g>cLk005g003gG7M00ON0ml00ioOW`05W`054IoOWml019l4g`>O
00PAWaLA5a4G4@Go12<00olS8`028`03oemO00MO00@GGaMO11l28`03GamO00@O4b<:F`?o0e/4o`MK
0@0002IK00?oFh405e/00h5KF`08F`:12E/00h5KF`06FaHS00PoCcm?`0g0g0;/00>gk;L01=`3g@03
gW7O00OO00VOgioO4MoNgmh01Ml00a7O4@06W`044IlA4@Co12<00olS8`038`05ob<Sob<00_l03amO
7elOGamO5alG7elOG`077`03GamO00/S8U/100009U/00omKP@0GF`03PE]K00YK0X47F`03PE]K00QK
5B<00cm?8`028`08C4e<]nbgk;L2g005LMiag]l01]h2g`03g]oN00?O00[NgmkOgYoOWmnO0ml019oO
Wml5o`<S00?o8b<00b<01_lS8b?o8`;o12<00omOG`04G`057elGGaL00Ul021mO7elOGamO11l68bIK
0@0002IK00?oFh405e/00h5KF`0<F`:11E/00h5KF`0:FaTS14d00nbgg002g0Aa00COg]oN0]l8gP07
gmkNgmkOgP05g`03Wooo00?o12<00olS8`028`06ob<S8olS0ol38`03ob<S00<S00Co7elO1El01ALO
GamO00<O00MO7elOGamO009K00>1Fe/0:5/100009U/00omKP@0GF`03PE]K00iK0X43F`03PE]K00aK
5R<3C`@=01?Lk=c/gW6Eg9EagW7NLMiag]oN00OO00CNgmkO1?l48`03ob<S00<S00Go8b?o8`03o`<S
00?o8b<00b<01olS8b?o8ol015l27`03GamO00EO00@OGelO1U/00h5KF`0XF`40000VF`03oe^101MK
00>1Fe/045/0185KFh4?FaDS00DoCcm??`03c0;L0kL4g0Aa0mh02=oNgmkOg]oN1Ol48`03ob<S008S
00Ko8b<Sob<2o`@S00?o8b<00R<01_lS8b?o8`?o0b<02?lOGamO5elG0Ul00amKF`0;F`03PE]K011K
184DF`40000VF`03oe^101MK00>1Fe/04E/3PA5K5B<2C`==1;H01;Nf]m`4U@04gW7NL@Wo12<00olS
8`038`05ob<Sob<00ol48`03ob<S008S00Go8b?o8`03o`<S00?o8b<00b<00omOG`03G`037e]K00iK
00>1Fe/02e/5PAQK0@0002IK00?oFh405e/00h5KF`0CF`:145/00h5K8`0D8`A=0o`2]`07g>cLg9GL
U@03o`@S00?o8b<00R<2o`@S1?l00b?oo`048`;o12<4o`038ooo00@S00?o8b<00R<01_lS8b?o8`;o
55/00h5KF`05F`J17E/100009U/00omKP@0GF`03PE]K01=K00B1Fh613U/0185KFe/D8`E=0kL01=c/
g>`2U@05oamO7ol012<01_lS8b?o8`;o12<00olS8`028`03ob<S00<S0_l48`03ob<S008S00?o8b<0
0b<3o`048oooo`@S00?oFe/04E/00h5KF`05PB=K0@0002IK00?oFh405e/00h5KF`0CF`04PE]KF`:1
35/00h5KF`02FaDS14d3]`05k=cNLOl01Al01OlS8olS00?o0b<00olS8`038`05ob<Sob<00ol38`03
ob<S00<S00Go8b?o8`03o`<S00?o8b<00R<2o`@S00?oFe/03E/6PBQK0@0002EK00CoFe^15e/00h5K
F`0BF`03PE]K00AK0X4:F`03PE]K00AK52<2C@05C4e<UM`00ol01amO7elOGal00_l47`03ob<S008S
00Ko8b<Sob<2o`@S00?o8b<00R<01_lS8b?o8`;o0b<00olS8`038`06ob<S8olS0_l38`03oe]K00MK
1H43F`03PE]K02QK0@0002EK00CoFe^15e/00h5KF`0BF`03PE]K00IK0X48F`03PE]K00EK5B<00de<
o`02o`057elOGol00al02_lO7olOGamO7ol28`03ob?o00;o12<00olS8`028`05ob<Sob<00ol38`03
ob<S008S00Ko8b<Sob<3o`<S00?o8b<00R<01?mKFe/5P@UK00>1Fe/09e/100009E/01?mKFh4GF`03
PE]K019K00>1Fe/025/2P@IK00>1Fe/01e/D8`;o1el02?mOoamO7eoo1Al2o`@S0_l48`Co00<Sool0
12<00olS8`028`05ob<Sob<00ol48`03ob<S008S00Go8b?o8`02o`03PE]K00aK00>1Fe/09e/10000
9E/01?mKFh4GF`03PE]K019K00>1Fe/02U/2P@AK00>1Fe/02E/A8`0<oelGoelOGamO7eoo1Ql01olO
oomO7el00_l48`;o00XOGomO7elOGaoo1B<3o`038ooo00@S0_l48`Co00<Sool012<00omKF`0<F`03
PE]K02MK0@0002EK00?oFh4065/00h5KF`0BF`03PE]K00aK00F1Fe]KP@0>F`dS00Ko7elOGol4G`0;
oaooGamO7elOGol01al2o`9O00?oGel00Ul01omO7elOGal00ol00amOo`057`03ob<S00<S0_l38`03
ob<S00<S00?o8b<00R<00omKF`0;F`03PE]K02MK0@0002EK0_l00h5KF`0FF`03PE]K019K00>1Fe/0
3E/2P@03Fh5K00mK22<3o`0:GaMO5eoo7elOo`=O00Co7alO0_l015lOGal3o`0B7eooGamO7olOGaoo
7elOGamO0_l47`06oelOGamO0ol38`03ob<S008S00Ko8b<Sob<2o`<S00?oFe/02U/00h5KF`0WF`40
000UF`03oe^101QK00>1Fe/04U/00h5KF`0?F`:13U/00h5KF`058`;o15l04omO7elOoeoo7elOGaoo
GolOGal00el00omOG`03G`05oemOGol015l01_lOGamOo`9O00Ko7elOGol27`05oalO7ol012<01OlS
8olS00?o0b<00olS8`028`03oe]K00UK00>1Fe/09e/100009E/00omKP@0HF`03PE]K019K00>1Fe/0
45/3P@aK00>1Fe/00U/28`0>oemOoelOGaoo5eooGol7G`0LoamO7olOGamOoelOGaoo7elOGomO7eoo
GamOo`@O00co7alOoaoo7elOGal4o`038ooo00@S00?o8b<00R<4o`038ooo00UK00>1Fe/09e/10000
9E/00omKP@0HF`03PE]K019K00>1Fe/045/00h5KF`02P@YK00>1Fe/00e/00olG5`025`05oemOoel0
0_l4G`;o00HOoolOGol3G`05oemOGol015l00omOG`02G`03oemO009O00CoGaoo1El5o`<O00Go8b<S
o`058`03ob<S008S0_l38`03ob<S00<S00?oFe/01U/00h5KF`0WF`40000UF`03oe^101MK00>1Fe/0
4e/00h5KF`0@F`03PE]K009K0X48F`03PE]K009K00?oGel015l2o`047elOG`;o00@OGamO0_l07ElO
GomO7eooGamO7olOGamOoelOGaoo7elOoaoo00@O00?o7al00Ql2o`@S00Go8b<So`038`04ob?oo`@S
00Go8b<So`038`03ob?o00MK00>1Fe/09e/100009E/00omKP@0GF`03PE]K01=K00>1Fe/045/00h5K
F`04F`:11U/01H5KFe_o00DG00CoGemO0_l4G`;o0el00omOG`02G`05oemOGol00el00omOG`02G`03
oemO009O00?oGel00ol01UoooelOG`;o12<00olS8`028`?o00@Soooo12<00olS8`028`?o00@Soooo
0b<00omKF`04F`03PE]K02MK0@0002EK00?oFh405e/00h5KF`0CF`03PE]K011K00>1Fe/01U/2P@AK
0121ooooGaLAoa4G4OlOGomO0_l07ElOGomO7elOoamO7olOGamOoelOGomO7eooGamO00Co0Ul2o`03
7aOo00<S0_l48`;o0b<00olS8`028`03ob<S00<S0_l38`03ob<S008S00?o8b<00R<2o`AK00>1Fe/0
9e/100009E/00omKP@0GF`03PE]K01=K00>1Fe/045/00h5KF`08F`:10ol01QLA5a4Go`DG0_l37`03
oemO009O00GoGemOo`04G`05oemOGol00el00omOG`05o`077elOGaooG`058`?o00<Sool012<01OlS
8b?o008S00?o8ol00_l38`03ob<S008S00Go8b?o8`02o`@S00GoFe]KP@0YF`40000LF`Co1E/2o`03
PE]K01EK00>1Fe/04e/00h5KF`0@F`03PE]K00QK0_l34@?o00XAoa4G4ALAoeoo15l04?lOGamOoelO
GomO7eooGal8o`047elOG`;o00IOoolOGal3o`047elOo`@S00?o8b<00R<3o`038ooo00@S00?o8b<0
0R<4o`038ooo00@S00?o8b<00R<01?mKFh4YF`40000KF`03oe]K009K00CoFe]K0X400e^1F`0FF`03
PE]K01=K00>1Fe/045/00h5KF`05F`?o00TA5a4G4ALA5ol01AL01OmOGeoo00@O00GoGemOo`03G`03
oemO00Co15l01?mOGel2o`AO00SoGoooGamOo`DO00Go8b?o8`02o`@S00Go8b<So`048`;o12<01OlS
8b?o00DS0_l38`03oe^102UK0@0001]K00?oFe/00U/01_mKFe_oF`>15U/00h5KF`0CF`03PE]K00mK
00>1Fe/00U/4o`044IlAW`;o00LAoooo4IlA00;o00<Aoel00el00omOG`02G`03oelO00So00XOGamO
oelOGamO0ol00eooo`02o`03Gaoo00DO00Ko7elOGal2o`@S00?o8b<00R<3o`038ooo00@S00?o8b<0
0R<3o`048oooo`<S00?o8b<00R<2obUK0@0001]K00?oFe/00U/01OmKFe_o009K00B1Fh6155/00h5K
F`0CF`03PE]K00eK1ol4W`;o00dAWa6OoilAWa6O4IlA00;o15l00olO7`037`;o00TA5olA5a4G4Ol0
15l3o`097omO7elOGaoo00AO00SoGamO7eoo7`;o0al00olS8`028`;o12<01OlS8b?o00@S0_l48`05
ob<S8ol012<2o`@S00?oFe/09U/100006e/00omKF`02F`05oe]KFol00U/0185KFe/3PA5K00>1Fe/0
4e/00h5KF`0<F`03oioo00>O00?oWil01Il2o`:O00coWa6O4IlAWa7o5ol4G`05oemOGol011401olG
4ALA5a400_l00elGo`04G`0<oamO7eooGomO7eoo1Ql01olOGamO7el00_l48`03ob<S008S0ol00b?o
o`048`03ob<S008S0ol00b?oo`048`03ob<S008S00?oFe/09E/100006e/00omKF`02F`05oe]KFol0
0U/00h5KF`04F`:13e/00h5KF`0CF`03PE]K00]K00WoWmnOomnOgol01Il2o`0?WmnOgolAWa6O4Ioo
5a7o00AO01?o7aoo4OlG4ALAoaLA5a4GoelG009O00?o7al00Ql01omO7omO7ol015l02?lOGamOoelO
0b<01OlS8b?o00@S0_l48`05ob<S8ol012<2o`<S00Go8b<So`058`;o0b<00omKF`0TF`40000KF`03
oe]K009K00GoFe]Ko`02F`03PE]K00IK0h4<F`03PE]K01=K00>1Fe/02U/00onOW`03W`05oinOWol0
0il01?oOWol4W`0:oilAWa7o5a4Go`AO00OoGonO4Ioo00<A00go4ALA5omO5elOGaoo00=O00?oGol0
15l01_lOGamOo`8O00Co7b?o12<3o`038ooo00@S00?o8b<00R<3o`038ooo00<S00?o8b<00R<7o`<S
00?o8b<00R<00omKF`0SF`40000KF`03oe]K009K00OoFe]Koe^100aK0X4:F`03PE]K01=K00>1Fe/0
2U/2o`0NWmnOgonOgioOoiooWmnOgonOgioOoa6O4OlA5a7o1El05_lAWa6Ooa4G4OlG4ALAoaMOoamO
7ol27`?o00MO7elOGaoo00=O00CoGomO0b<2o`@S00Go8b<So`048`;o0b<01OlS8b?o00@S0_l48`05
ob<S8ol012<2o`<S00?oFe/08U/1000075/4o`AK00?oFh403U/3P@MK00>1Fe/04e/00h5KF`09F`04
omoOo`BO00?oWil00ol01mnOgioOWol019l02OnOoolG4ALAo`04G`06oa6O4Ioo11402_lG4OlGGaOo
7el4o`05GaMO5ol015l00omO7`03o`037ooo00@S00?o8b<00R<3o`038ooo00<S00?o8b<00R<6o`@S
00?o8b<00R<3o`038ooo00<S00?o8b<00R<2ob9K0@0002AK0_l00h5KF`0?F`:11E/00h5KF`0CF`03
PE]K00QK00?oWil00Yl00onOg`04o`0=gioOWooOWmnOgonOg`03o`074OlA5a4Go`03G`0ComooWa6O
4OlG4AOo4AOoGaOo7`02o`0:4AOoGaMO5elGG`?o00=Oool00R<00olS8`028`;o0R<2o`<O00Go8b<S
o`048`;o12<01OlS8b?o00@S0_l38`05ob<S8ol012<2o`@S00?oFe/07e/1000095/00omKP@0CF`>1
0U/00h5KF`0BF`03PE]K00UK00?ogml00ml2o`0<giooWmnOgioOWooO0_l019ooool45`05oa4G4Ol0
0Ul02OnOWonO4IlAo`034@0FoaLAoaOo4AOo5a4G4OmO5elGGaOoG`8O00?o8b<00R<2o`8O00?o7al0
0Ql01OlOGamO00Ko12<00olS8`028`?o00<Sool00b<00olS8`028`Ko12<00olS8`028`03oe]K01iK
0@0002AK00?oFh405U/3PAAK00>1Fe/025/00onOW`02W`03omoo00CO00SogioOWmnOg`;o00<GoaL0
0QL02OlA4A7o5a4Go`02G`0?oioOoilAWa7o5a4Goa7o00<G01?o5a7o4ALAoaMO5elGoelOGamO00;o
0Ul04OmO7elOoelOGaoo7olOGaoo00@S0_l28`;o0b<00olS8`028`;o0R<2o`@S00?o8b<00R<2o`8S
0_l38`03oe]K01eK0@0002AK00?oFh4065/3PA9K00>1Fe/01e/01?oOomh2o`0?gmkOomnOgiooWmnO
gioo00<A00Go5a4Go`035`05oa4G4AL00_l4W`05oa6O4Ol01142o`<A00oo5a7o4ALA5olGGaOoGol0
0al01aOoGamO7ol011l00olO7`03o`DO0_l02ElOoamO7elOo`038`;o00EO7elOo`038`03ob<S008S
0_l38`05ob<S8ol012<00omKF`0LF`40000TF`03oe^101QK00>1Fe/00X4@F`03PE]K00IK00GogmoO
o`02g`05omoOgol01=l01?oOWml2o`045a4Go`<G00?o4A400Q400olAo`02o`0<WmnOgioo4IlAWolA
1?l45`0;oa4GoaLA5a7o5el00_l01eooGaMO5ol00el01_lOGamO7`;o0el01_lOoolGo`AO00Ko7elO
Gal2o`037eoo00DO0ol00b?oo`038`03ob<S008S1_l38`03oe]K01]K0@0002AK00?oFh4065/00h5K
F`02F`>13E/00h5KF`05F`0GomkOg_oOg]oog]oNgooOWmnOoiooWol011401_lA5a7o5`Co00DAga7O
o`03W`03oa6O00Go00<AWol011402_lA5a7o4ALAoel3o`0<5olG7aLOoamO7eoo0al2o`0E7elOGaoo
7aLO5omO7eooGamO7eoo00@O00Oo7oooGaoo00@S0_l28`;o0b<00olS8`028`;o0R<00omKF`0JF`40
000TF`03oe^101QK00>1Fe/01E/2P@]K00>1Fe/015/00ooOo`02o`CO00?ogml00]l00ooOg`02g`;o
00DAWolG4@08o`BO0_l3W`?o00_OoolAoeoo4IlAo`045`07oa7o4OlA5`03o`0;GamOoeoo5elGGol0
0el01omO7omO7ol015l01_lGGaMOo`AO00coGamOoeoo7elOGol57`;o0b<01OlS8b?o00@S0_l38`05
ob<S8ol06e/100008e/01?mKFh4HF`03PE]K00MK0h48F`04PE]KF`Go00oOoooNgmkOg_oOg]oNoil0
0_l00iooo`04o`044MlAg`;o00<Aga400_l00mlAg`03o`8A1ol01Q6O4IlAo`@A1_l0:QmO7olGoamO
7olG7aOoGamOoaoo5elGGolOGolGoaLO5aoo7elOoamOo`9O00Go7alOo`027`;o12<01?lS8b<6o`<S
00?o8b<00R<6oaUK0@0002=K00CoFe^165/00h5KF`0:F`:11U/0185Kool5g`04omkNo`CO00?ogml0
0ml01?oOWol2W`04oinOW`;o19l2o`09Wmoo4IlAWa6O00;o00gOWonOgiooWa6O4Ioo00<G00Co4OlG
0el3o`03GomO00AO00?o5el01_l045lOGamOoeooGamOoaMO5ol3G`0<oeooGamOoamOoelO12<2o`8S
0_l38`04ob<S8`;o0R<2o`<S00?o8b<00R<00omKF`0FF`40000SF`;o00=KPE/05U/00h5KF`0=F`>1
0e/3o`06g_ooomoo0mh02_oOg]oNgooNgmh2o`03WooO00CO0ol04MoooonOgonOPIoo4IlAWa7o00BO
00[oWinOoilAWa7o0Q401_lA4OmOo`8A00_o5a4GoelOGamO7`02o`08GamOoelOGal2o`0>GaOo5elG
GolO5aoo7el3o`EO0_l00alS8`02o`<S00?o8b<00R<2o`8S0_l38`04ob<S8`;o0R<2o`<S00?oFe/0
5E/100008e/01?mKFh4GF`03PE]K00aK1ol00g7ogP04gP03omkN00;N00?ogml00ml01OoOgooO00;o
0il2o`>O0_l07]oogioOWooOWmoo4IlAoioogioOWonOgiooWa6O4@Go00HG4ALA5ol44@03oemO009O
00Co5aOo0el2o`AO00SoGeooGamO7`Ko0el01OmO7elO00?o11l2o`8S0_l37`03ob<S008S0_l28`;o
0R<01OlS8b?o00@S00?oPH400X4BF`40000SF`04oe]KPAMK00>1Fe/02e/02OoMog6ELOoMo`05gP03
LOoN00CN00Oog]oNgooN00?o00NOgioOomnO00;o00_O4MooWmnOgioOo`03W`07oa7ogioOo`04W`06
oinOoa6O1_l74@09oa4G4AOoGaoo00AO0_l021mO7olOGamO1Ol035lOGaoo7elOGomO7`;o00XOGolG
7olOoaoo0al01_lOGamO7`;o0b<01OlS8b?o00<S1_l2PAMK0@0002=K00CoFe^15e/00h5KF`0:F`0:
omgMog7MLOoMo`ON00?og]h00]h00ooOg`03g`;o1Ml01_oOWmnOg`;o00?OWml00_l01=nOgil5o`08
WmnOgioogil8o`03Wmoo00:O00So5a7o4ALAo`@A00?oGol00aL01?mOGel2o`9O0_l35`03oeoo009O
0_l2G`;o00=Ooel00el04OmOoaMO5eoo7elOoamO7olO00;o0Ql00olS8`028`Ko0X4NF`40000SF`04
oe]KPAMK00>1Fe/02E/01ooMUOnELID00ol02MiagG7ogW7No`04gP09omkOg]oNomoN00;o00OOomnO
gioO00;o00JOgioOWml2o`;O00OogioOWmnO00;o00bOgoooga7O4OlAga42o`>O00GoFa4Ao`024@07
oa4G4ALAo`05G`;o00HAoaLA5ol5G`;o0Ul06OlO5aoo7elOoamO7olOoalG7olOoamO7ol00Ql2o`05
7elOGal00_l3PBEK0@0002=K00?oFh4065/00h5KF`09F`05omgMomd01?l5L@03omkN00;N00?og]h0
0]h04OoOgmoogmkOg]oogioOWmoo00;O00GogioOW`02o`CO00GoWmnOg`02o`06WmnOgioo19l4o`BO
00Wo5e/GoaLA5ol01142o`08Gooo4ALA5ol44@05oaLG5ol00Ul021mO7omO5eoo0Ul00omOG`03o`07
GaMOoelGG`06o`03Gooo00:10e/00h5KF`0VF`40000SF`03oe^101QK00>1Fe/025/2o`03gIGo00;o
00magIGogG7MLOoNLMiag_l00mh03?oOg_oOg]oNgooOgP;o00?Ooml00ml01onOgooOg_l01=l01?oO
Wol2g`06omnOgioO0ol01IoOoa7o00FO00CoFa7o0a402?lG4AOo5a7o1a402olA5a4Goeoo5eoo00=O
00?o5al01ol035lOGolOoalG7elOo`@O00?oFe/01E/00h5KF`0VF`40000SF`03oe^101QK00>1Fe/0
25/2o`?M00?oLMd00md00omaL@02L@03omkN00;N01?og]kNomoog_oOg]oogmkOg]oo00GO00OoWooN
gmko00CO00oogooNgmkOoioOWonOgil00_l3W`03oinO00:O00So4OlAoa4Go`8A00Go5onOo`044@04
oaLAo`DA00Go4ElGG`06o`=O00?oGel00Ul01_mOGomOo`EO0_l:F`03PE]K02IK0@0002=K00?oFh40
65/00h5KF`08F`0FoiGMgOmag?oMUMgoLMeagOmagW7NL@Go0mh02?oOomoNgmko1=l2o`;O00OogmkO
g]oo00CO00?ogml01=l01_oOomnOg`;o00DAga7Oo`04W`03oa4A00;o0a42o`064OnOgioo0a404olA
4OlA5a4G4OmO5elGoaLA5ol01El2o`0<7elOoeoo5elGoeoo3E/00h5KF`0VF`40000SF`;o00>1Fe/0
5U/00h5KF`07F`;o00MagOmaUMco00?M00?oLG400W400ooNgP03gP0BomkOg_magW7NomoNgmkOg_oN
0_l02mkogmkogmkOg]oo00CO00[ogmkOg]oNgonO0]l00onOo`04W`03oinO00>O2Ol00mooW`02W`03
oa4A008A00Co4AOo0a42o`0;5elGoioo4ALAoel00_l3G`;o0Ul01omO7elOGol03U/00h5KF`0VF`40
00000e_oF`04F`04oe]KF`;o00=Koe/04e/00omKP@0HF`03PE]K00MK01_ogMgMombEg?oMUMfEomea
gG7ogW7NomkOg_l01]h02?oNgmkOg]oo0mh02ooNg]kog]oNgmko00;O00?og_l01]l01?oOgol3g`06
omlAga7o19l2o`034Ooo00;o19l01?oOWol44@0Doa4AoaLAoa7oGaMOoioo4ALA5ol2G`;o00MO7eoo
GamO00;o4U/00h5KF`0UF`4000000e_oF`04F`05oe]KFol05e/00omKP@0HF`03PE]K00IK00coLMea
oiGLUMcogG42g@03og5a009a01Oog]kog_oNgooNLMiagW7NomoNgmkOo`04gP0GomkOg_oOg]oNomoo
g]oog]oNgmkogil00_l01MnOgioo00>O00SoWinOoilAo`>O00?ogml00]l01OnOWioo00<A00Co4AOo
0Q401_lG4OmOo`:O00So4ALA5olG4@9O0_l2G`;o5E/00h5KF`0UF`4000000e_oF`04F`05oe]KFol0
5e/00omKP@0HF`03PE]K00EK1Ol06=cog9GLUOnEgIGogG7MLOoNLOoNomoNo`ON00OogmkOg_ma00CN
00Wog]kNomoNgmh00_l4gP05omoOgol00]l01?oOg_l3g`05oa7O4Ol00Yl01?nO4Ol2g`044MlAo`>O
00GogioOo`044@03oa4A00;o0a400olGo`03W`06oaLAoa4G0_lLF`03PE]K02EK0@000003FomK00AK
00GoFe]Ko`0FF`04oe]KPAQK00>1Fe/01E/03?nEUOoLk?oLUMbEo`?M00?oLG400g42o`0ELMkog]oo
gW7NomiagW7og]oNomko00?N00Oog]oNgooN00;o01KNomoNgmkOomkOoioog]oNgooOWmoo0il3o`06
4OoOWmoo0Yl00ooOg`02g`04oinOo`8A1ol01Q4G4OmOo`>O00Oo5a7o4Eoo01eK00>1Fe/09E/10000
00=Kool01Ol3F`03oe]K01AK00CoFe^165/00h5KF`04F`05omcLg?l00]`04?oLUMbEoiGMUMgoLMea
gOl3gP03omoo00?N00=aomh00mh02?oNgmkoLMko0mh00ooNgP02gP06omiagW7o1=h00ooOo`02o`06
gmkOg]oo0]l6o`03ga7o00CO00Coga7o19l01?nOgil2o`<A00Co4A7o0a42o`BO00Ko5olGGolNF`03
PE]K02EK0@000003FomK00AK00GoFe]Ko`0FF`04oe]KPAQK00>1Fe/015/03OnEUOo/g>cLoiGLUOl0
1=d01?maLG42o`07gW7NomkoL@02gP0>LMkoLMiaomkOog7NLOl3gP04omoNg`;o00_NLMiaomkOg]oN
o`02gP07omoNgmkOgP03o`03gonO00:O00WNgonOgioOWol00Yl01OoOgmoo00:O00[oWolA5a4GoaLA
0ol00mooW`04W`;o00=Ooe/07U/00h5KF`0UF`4000000e_oF`04F`03oe]K00?o5E/01?mKFh4HF`03
PE]K00AK00?og?l01M`03onEg9GLomfEgomagOmao`04gP;o00?NLG400W400ooNgP02gP07omoogW7N
o`03gP0<omkNog7Nog7NLMko0mh2o`?N00[og]oNgmkog]oo0]l02=kogmkOommK0]l01?lAgol4W`;o
00DAWa7o4@06o`BO00?oWil01OlPF`03PE]K02EK0@000003FomK00QK00?oFe/055/01?mKFh4HF`03
PE]K00=K00?oUOl00_l02^cLk=coUMbEg?l4g@;o00Qag_oNLMiao`;N015agW7NLOoNLMkogomagW7N
o`03gP;o00_NLMiaomiag_oOgP02o`0:LOoNg_oNgmkOo`?N00?ogml00]l02OoOg_oOWonOo`02W`03
omoO00Wo0il00onOW`02W`03omoO00Ko8E/00h5KF`0UF`4000000e_oo`05o`=K00?oFe/055/2o`03
Fh5K01MK00>1Fe/00e/00ooLo`02k003omcL00;L00Sog9GLomfEg@?o0W400ooNgP02gP;o1W401?oN
g]h2o`06LMiagW7o0]h2o`0@LMiagW7Nog7Nomkogomao`?N00SogmkOomoNg`;N00SOg]oog]oNo`?O
2?l02mnOoioOWmnOoa7O00;o0a42o`=K00>1Fe/08E/00h5KF`0UF`40000RF`04oe]KPAQK00>1Fe/0
0U/04?nEomc/g?oLk=c/ombEg?l2g@0EoiFEog7NomiagW7og?magW7NLOoN00;o00SMomiagW7NL@;o
0g42o`04gW7NL@Co0]h02omaomiKg_oOg]oo00?N00?Ooml00]l01_oOg]ooW`;o00?Ooil00Yl2o`0>
gioOWooOWmnOoioOWol24@03oe]K00=K00>1Fe/08E/00h5KF`0UF`40000RF`04oe]KPAQK00>1Fe/0
0U/2o`C/00?og=`00]`01OoLUMbE00;o00CMUMgo0W401_oNg]koU@;L00?oLG400W42o`0AUMfEgOoN
LMiag_magG7MLMd00ol3gP04omoOo`=a00Wog]kogmkog]l00mh02_oOg]oog]oNgol4g`0@oa7og]oo
gioOWonOgonOo`:O00?o4Ol01U/00h5KF`0QF`03PE]K02EK0@00029K00CoFe^15e/00h5KF`03F`0@
omc/g>cLk?o/g>cLoiGLU@;o0iD00omagP02o`0;LOnEUMbEomiag_l00YD03?oMgMgoLMiag_nEo`Ea
00Oog_oNLMko00;N00GoLG5ao`03gP03omko00;N00Cog]oo1=l01?oNgmh2o`CO00?ogml00]l02_oO
WmooWooOWml4o`MK00>1Fe/08E/00h5KF`0UF`40000RF`03oe^101QK00>1Fe/00U/00ol=]`05k003
omcL00;L00CoUMbE0_l01=fEgOl3L@03omko00GL01[oLOoLUMbEoiGMUOmag_oMUMgoLMeaommao`?N
00Cogmoo0g401ooNg]kog_l00]h03ooNg]kog]oNomoNomkOo`03g`06omoNgmkO1Ol019oOWol;F`03
PE]K025K00>1Fe/09E/100008U/00omKP@0HF`05PE]KFol00/`03[Oog>cLk?o/g>cLoiGL0ol3U@04
og7NL@?o00OLUMbEg9Go00JE00KogMgog_l4U@03og5a00;o0]h01ooNLMkog_l017401?oNg]h2o`08
gW7NLOoOg_l3g`07omkOomoNo`02g`03omoo00?O00?oWol00Yl01?nOgol<F`03PE]K025K00>1Fe/0
9E/100008U/00omKP@0HF`06PE]Ko`g<0kL01Oo/k>co00GL0_l01mcoomfEgOl00g400oo<o`06g008
oncoombEg9D4o`08gIGMUMfEomd2o`04gg7Oo`;N00?ogol01G43o`03LOoN00?N00[og]kog]oNomoo
0ml03ooOomkOg_oOomnOoa7O4@02o`eK00>1Fe/08E/00h5KF`0UF`40000RF`03oe^101QK00>1Fol0
0l`03[Jg]_o/g>cLomc/g>co0]`2o`BE013og_oo3LcoUMbEg9Gog>cL0_l00ncLo`02U@9K00>Eool0
0iD00ooMo`03gP04og7NL@;o1G42o`0;LMkogW7NLOoOg_l00ml01OoNomkO00?o1Ml00ooOo`06o`iK
00>1Fe/08E/00h5KF`0UF`40000BF`Co0e/4o`EK00?oFh4065/01X7o3L`=c0Bg00Gok>c/o`03g0;o
0]`2o`04gIGMU@?o00@=c0go1=`00oo/k002k006omc/g>co1=`2o`0:gIGMUMgogg7Oo`?N00?oLG40
1742o`9a00?og]h00mh01ooNg_oOg]l01?l4gP;o00?Oool05U/00h5KF`0QF`03PE]K02EK0@00015K
00?oFe/00U/00omKo`04F`04oe]KF`B165/00h7oc003c00>][Nf]ooLk=cog>coo?l2g0;o19D2o`0E
g<`=c?nEg9GLoncLk=cog>cLk=co00:E0ol6g@06omkNg_oN0_l5L@0;omcoLMiaog7NLMh02?l01W7N
LOoNoaaK00>1Fe/08E/00h5KF`0UF`40000FF`03oe_o00AK00GoFe]Ko`02F`>15U/01X7o3L`=c0Bg
00?ok>`00^`2o`03]KKo00;L0_l02mfEgIGok=aKc0go00CL00gok>c/okKok=c/g?oL00;o00S/omfE
gIGMU@Ko00>Eg9D00_l02G7og=coLIEao`04gP03omko00?N00OogW7NLMko01eK00>1Fe/08E/00h5K
F`0UF`40000FF`03oe_o00AK00GoFe]Ko`02F`03PE]K00B14U/00h7oc003c0;o00>f]kH01Ol01?be
o?l2g0;o19D07Oo/3L`=c?nEg9Gog>cLk?nfoncLk=c/oncLk=co00GM01kog=cLoiGLUMbEg?oLUMbE
omiaog7NLOoNLOoNgmh2o`04LMiaoaiK00>1Fe/08E/00h5KF`0UF`40000AF`03oe]K009K00?oFol0
15/01OmKFe_o009K00>1Fe/015/4P@iK00F1o`g<3@03aP;o00Z<aXco][Ff]KKo0m`03OoMUMgog>c<
3E/=c?l00]`00oo/k002k00EokKok=c/g>cok=c/g>cogIGMonco00?L00OoUMbEg9Go00CL00CoLOoo
0]h01OoNg]ko00;N00KoLMgog_lOF`03PE]K029K00>1Fe/095/100004E/5o`9K00?oFe/00U/01OmK
Fe_o009K00>1Fe/025/3P@]K00>1ol`00/`3aP;o00Z<aXcoo;Gl]Oco0m`05?nEUIGog?l=c0g<3OoL
UOoLk=co0kH01ooLk=c/on`01=`02?oMgOoLk=co0]`03ooLUMbEokOoUMbEomiagP03o`0;LMiaomkO
oiEaUOl085/00h5KF`0RF`03PE]K02AK0@00015K00?oFe/015/00omKF`02F`05oe]KFol00U/00h5K
F`0;F`B11e/01Oo<3L`=00?600a2ohc6S?nf]KJe]_l3g00=omfEgOoLol`=c0g<o`02g00Konc/k?ne
][Gog>cLomc/C?oLk=coUOoLk=co00?L00Cog9Go0[L01OoLg=co00=a00?og_l00mh02?oNomeagG7o
85/00h5KF`0RF`03PE]K02AK0@00019K00?oFe/00e/00omKF`02F`05oe]KFol00U/00h5KF`0?F`>1
15/00oo<c002c0?600a2ohc6S?ol]Obeo?l3g00DoiFEona=o`g<3L`=omcok=c/g?l3]P09omc/g?oL
odco00?L0_l01^cLk=c/o`;L01GoUOoo][OoUMbEomiag_oNog7NLMh00_l01G6ELOn1021K00>1Fe/0
8U/00h5KF`0TF`40000BF`Go0U/4o`AK00CoFe^155/4P@05ol`=c0d00/H03Om2Coo6S?nf]KJe]_l0
0m`2o`0=UOo/C?o<3L`=c?oLo`03k00?okJe][Gog>cLomcoC?oL00;o00S03OoLk=c/g0Go0kL00ooL
g002g007og7oomiao`03gP;o00GMLOmKP@0QF`03PE]K025K00>1Fe/095/100008E/01?mKFh4HF`03
olc<00;<0/H03Om2@_o6S?ol]Obeo?l00m`2o`0;UOo/COl=c0g<3L`00_l01>cLk?l5]P06oncok<3o
0T`02?o<`<c0c?o/0_l00kO/o`02g009okNf]onEg9GL00;o00=aool01ol01G7oFe^1025K00>1Fe/0
8E/00h5KF`0TF`40000QF`;o00=KPE/05e/01?o<3L`3aP0>od9?olJ<okJe][Ff]Ol2g0Go00U<ol`=
c0g<3Ol01>`06onf]KJe]_o/oncoCDa=ol0=`0g03Oo/]nbgk003o`>g00?og=`00]`03OoNLOoLUMbE
g?nEg?l00e/00h5KF`0OF`03PE]K025K00>1Fe/095/100008E/01?mKFh4HF`04olc<c0?600ko@T;o
aXcoo;Gl]Obeo`?L0_l02]coCOl=c0g<3L`3o`03g?nf00Ff00Gok?o0o`03C00Rolc0c<3<`?ngk;O/
]nco][Nf]onEg9GLomkog?oLUMbEo`MK00>1Fe/07U/00h5KF`0QF`03PE]K02AK0@00025K00?oFh40
6E/01?o<3L`3aP0>od9?olJ<okJe][Ff]Ol3g0?o00Y=C?o<3L`=c0go0/H2o`07]KJe][Ff]@02o`0<
a_m=C4go`0g03L0=0_l01[O/]nbgo`Bg00?og=`00]`2o`07g>coUMbEo`08F`03PE]K01iK00>1Fe/0
8E/00h5KF`0TF`40000QF`03oe^101UK00Coc<c<0/H03dco@T;oaXcoo;Gl]Obeo`03g0?o00Y<COl=
c0g<3Lco0l000onf]P05]P04ol30o`=<00Ooc<3<`<c000;o01O/]nbgokKo]kJgoiGLUMcog>cLk?nE
o`09F`03PE]K01iK00>1Fe/08E/00h5KF`0TF`40000QF`03oe^101UK00Coc0g<0/H03dco@TooaXco
][Ff]KJeo`02g0Co00Y=C?o<3L`=c0go0lH02One][Ff]KJeo`02aP0Dode<COo03L0=`0goCOo/]nco
o?l4]`04omcLo`;/00Kok=cog?l9F`03PE]K01iK00>1Fe/08E/00h5KF`0?F`J13e/100008E/00omK
P@0IF`03olc<00?600i<od92olJ<oobeo;Gl]@?o00jeokGoC4e<ol`=c0g<o`?000<=okH01KH01?o0
`?l3C00=olc0c<3<`?m=C?o/o`02]P0<okNf]kKog9Gog>cL1?l:F`03PE]K01iK00>1Fe/08E/00h5K
F`04F`^15E/1000085/01?mKFh4IF`03ol`=00?600koCd9?olJ<okJe][Ff]@Go00beode<COl=c0g<
3Ol3aP08c?nf]KJe]_l3aP0<ode<COo03L0=`0go0Td00ongo`02o003okNg00:g00Cog=co0n`00omK
F`0;F`03PE]K01iK00>1Fe/07U/:PB1K0@00021K00CoFe^165/01?o<c<`3aP0Nod92@_o6S?ol]Obe
o;GoC8a<3Om=C4e<ol`=c0go0l000l`=o`05]P05ol30`?l00T`2o`0<c<3<`<c0ode<COl=0[H03?ng
][NfombEomc/o`iK00>1Fe/07U/00h5KF`0CF`^10e/00h5KF`0TF`40000PF`04oe]KPAQK00Co3L`=
0/H07dgoCd9?olJ<okJe][Ff]Om<S4beoda=C4go3L`=c?l00lH2c007okJe][Ffo`03aP03ode<00;o
00K03L0=`?l4C@05olclo?l01;L01?oLg?l2k003oe]K00aK00>1Fe/07U/00h5KF`09F`Z13U/00h5K
F`0TF`40000PF`;o00=KPE/05e/01?o<c<`2aP03C?m2009200koaXcoo;Gl]Obeodb<C0;o00Y=C4e<
ol`=c0go0l001<`=c?l3]P03ol3000;000?oC4`00_l03<c0c<3<oda=C4go3@>f00[o][Nfomcok=co
3e/00h5KF`0NF`b165/00h5KF`0TF`40000PF`04oe]KPAQK00Co3L`=0/H04TgoCd9?olJ<okJe][Ff
]Om<S09V00_oC4e<COl=c0g<o`03aP?<00Go]KJeo`04aP0;ode<odoo3L0=`?l014d00oo<o`02o007
okNg]ooLo`02k003oe]K00eK00>1Fe/05E/:PB=K00>1Fe/095/1000085/01?mKFh4HF`03olc<00?6
00=<od800T803Oo6S?ol]Obeo?n<C8`00VH02om=C4e<ol`=c0go00?000C<3Lco0kH00oo0`002`00B
oda<ocoo`<c0c?m<CDa=o`go0[H02[Nf]kKog?o/ol`?F`03PE]K00YK2h49F`03PE]K025K00>1Fe/0
95/1000085/01?mKFh4HF`03o`g<00?6019=odm2Coo6S<Ko]KJe]_n<C8`2IP0;oda=C4go3L`=c?l0
0lH4c004okJeo`C600_oCDcoCol=`0g0o`04C@03olco00;l1;L01_oLoncoc0mK00>1Fe/02X4DF`03
PE]K025K00>1Fe/095/1000085/01?mKFh4HF`03olc<00;60T`04Om2@T;oaXc6okGl]OcoS4b<009V
00_oCDa=C?o<3L`=o`02`008ol`=c0go]_l4`00Coda<C?lool3<`<coC4e<COm=o`02]P05okJg][L0
0ol2c0MK2h4NF`03PE]K025K00>1Fe/095/1000085/01?mKFh4HF`03o`g<00;601=<COm?@TooaXc6
okFf]KKoS4b<009V00_oC4e<COl=c0g<o`02aP03olc<00;<00?o]_l01<H03?m<CDcoCol=`0g0o`==
00Coc4go0_`00ong]`02]`?o0/`7P@QK00>1Fe/07U/00h5KF`0RF`03PE]K02=K0@00021K00CoFe^1
65/00oo<c002aP9<013o@T92olJ<a_neo;Gloha<0VH2o`0:CDa=C?o<3L`=o`;000Q2o`g<3Onfo`C0
01?oC4a<ocoo`<c0c?m<CDco3Dgo00>f00Oo]kJgodgo00;<3e/00h5KF`0NF`03PE]K029K00>1Fe/0
8e/1000085/01?mKFh4HF`03o`g<00;6019<COm?@TooaXc6okFf]KKoS4`2IP;o00Y<CDa=o`g<3Lco
0/H00fKoc003c003olK600?600coC4e<odoo3L0=`?l3C@05ola=COl00_`01ong]kOoCOl00/`?F`03
PE]K01iK00>1Fe/08U/00h5KF`0SF`40000PF`04oe]KPAMK00?oc<`00lH00dco@P03@P0<olJ<a_ne
o;Gloha<0VH2o`0:CDa=C?o<3L`=o`;000M2o`g<3Lco00G0017oC4a<ocoo`<c0c?m<CDco3@02C@03
okKo00Go00==ol`045/00h5KF`0NF`03PE]K029K00>1Fe/08e/1000085/2o`03PE]K01IK00?oc0d0
0/H04de<od9?@TooaXc6okFf]KKoS4`00VH02oloode<COl=c0go00?600=Vol`00l`00oo6aP03aP0<
oda=C?m?o`g03L3o0dd01?o<CDd3o`08CDcoCDa=ol`@F`03PE]K01iK00>1Fe/08U/00h5KF`0SF`40
000PF`03oe^101QK00?oc<`00/H2C003od92009200coaXc6okGl]Om<S4`2IP0;ocooC4e<ol`=c?l0
0/001VI2o`g<3@;o1L004Om<C4co?oo0c<3<oda=C?l=009=00_oCOm<COm=C4goc00@F`03PE]K01iK
00>1Fe/08U/00h5KF`0SF`40000PF`03oe^101QK00?oc0d00/H04Te<od9?@TooaXc6okFf]Om<S0=V
00_o?om=C4go3L`=o`02aP03CVKo00?<0_l5aP0<oda=C?m?o`g03L3o0dd03oo<CDgoCOm=C?m=C4go
c00@F`03PE]K01iK00>1Fe/08U/00h5KF`0SF`40000OF`04oe]KPAQK00?oc<`00/H2C003od920092
00_oaXc6okGl]Om<S003IP0;ocooC4e<ol`=c?l00/0026I2o`g<od;o1L004Om<C4co?oo0c<3<oda=
C?l=009=00_oCOm<COm=C4goc00@F`03PE]K01iK00>1Fe/08U/00h5KF`0SF`40000OF`04oe]KPAMK
00A?ol`=0/H04Te<od9?@TooaXc6okFf]Om<S0=V00_o?om=C4go3L`=o`02aP08CVI>olcoCol5aP0<
oda=ocm?o`g03L3o0dd03?m=CDgoCOm=C?m=C0;o00?<Fe/03U/00h5KF`0NF`03PE]K029K00>1Fe/0
8e/100007e/01?mKFh4GF`03?oo<00;60d`00om2@P02@P0;olJ<a_neo;GoC8`00fH02olooda=C?o<
3Lco00;000=V@VH00_l2@P03ol3000?0013oC4coCcoo`<c0ode<CDco0dd02Om=oda=ode<o`02c11K
00>1Fe/07U/00h5KF`0RF`03PE]K02=K0@0001mK00CoFe^15e/00dooc002aP0CC4e<od9?@TooaXc6
okFf]Om<S002IP0<odloode<COl=c0go0/H00diVCP02o`03@Too00G600_oC4go?doo3L0=o`04C@04
ode=o`9=00OoCDcoCDco00;<45/00h5KF`0NF`03PE]K029K00>1Fe/08e/100007e/01?mKFh4GF`03
?oo<00;60d`00om2@P02@P0:olJ<a_neo;GoC0=V01;o?cooC4e<ol`=c?o0@VI2I_l4@P03ol3000;0
013oC4coCcoo`<c0ode<CDco0Td02_m=ode<COm=C?l2c11K00>1Fe/07U/00h5KF`0RF`03PE]K02=K
0@0001mK00CoFe^15e/00dooc002aP0BC4e<od9?@TooaXc6okFf]Om<0fH05om??om=C4go3L`=olIV
CVI>odm2Cd;o00?600coCDa=ocm?o`g03Ol4C@0=ode=odgoC4e<ode<o`02c11K00>1Fe/07U/00h5K
F`0RF`03PE]K02=K0@0001mK00CoFe^15U/2?`04olc6aP=<00?o@T800T802_o6S<Ko]OcoS4`3IP0B
oclooda=C?o<3Lco`49V@VKo14801Oo0`<3o00=<00goCcoo`<c0ode<COl=009=00_oCOm=C4goCDco
c00AF`03PE]K01iK00>1Fe/08U/00h5KF`0SF`40000OF`;o00=KPE/05E/064oo3Lc6CDa=odm2Cd9?
olJ<a_ne]_n<C0=V01OoCcooCDa=o`g<3Oo6ITiVC_m?@Tm2o`03aP0<ode<COloCol=`0go0dd03oo<
CDgoCOm<CDcoCDcoc00AF`03PE]K01iK00>1Fe/08U/00h5KF`0SF`40000OF`04oe]KPAIK00Doolco
aP03C003od9200=200[oaXc6okGloha<0fH02olo?om<CDcoc0go00;000E2IT9Vo`04@P05ol30`?l0
0d`03Om??oo0c<3oCDa=o`d00Td02om=ode<COm=C?o<015K00>1Fe/07U/00h5KF`0RF`03PE]K02=K
0@0001mK00CoFe^15U/05doo3Oo6CDa=odm2Cd9?olJ<a_ne]_n<00AV00_oCcooCDa=o`g<o`02aP03
ITiV00;o00E?@Tm2o`03aP0<ode<COloCcoo`0go0dd03om=CDgoCOm<CDcoCDcoc00AF`03PE]K01iK
00>1Fe/08U/00h5KF`0SF`40000OF`04oe]KPAIK00DoolcoaP03C003od9200=200WoaXc6okGloh`0
16H04olo?om<CDcoc0go`6I2IT;o8?l00d801Oo0`<3o00=<00coCcm?olc0ode<COl3C@0;odgoCDa=
ode<ol`04E/00h5KF`0NF`03PE]K029K00>1Fe/08e/100007e/01?mKFh4EF`9?01Ko3LK6CDa=odm2
Cd9?olJ<a_ne]_n<16H05om??om=C4go3LcoaTiVCVKo8?m2Cd;o00?600coCDa=ocm??oo03Ol3C@0?
ode=COm=oda=C?m=C?o<015K00>1Fe/07U/00h5KF`0RF`03PE]K02=K0@0001mK00CoFe^15E/2?`04
olc6o`=<00?o@T800d802Oo6S<Ko]OcoS003IP0Doclo?om<CDcoc0go`6I2IT;o8?l3@P05ol30`?l0
0d`03?m??dooc<3oCDa=o`==00_oCOm=C4goCDcoc00AF`03PE]K01iK00>1Fe/08U/00h5KF`0SF`40
000OF`03oe^101IK0Tl05_l=a_m=C4goCd9?@TooaXc6okFfoh`3IP0Hocm??dooC4go3LcoaTiVCVKo
8?m2Cd;o0lH03?m=C4go?dlool0=o`==00ooCDe=odgoC4goC4e<ol`04E/00h5KF`0NF`03PE]K02=K
00>1Fe/08U/100007e/00omKP@0FF`8o0_l00lI<C002C003od9200=200OoaXc6okGl00;o0fH00olo
?`02?`0?ode<ol`=ol1V@VI2ob3o00=200Go`<30o`03C00<odloCoo<`?m=C4go0Td02om=COm=C?m<
CDco019K00>1Fe/07U/00h5KF`0SF`03PE]K029K0@0000YK00?oFe/00U/4o`9K1?l5F`04oe]KPAIK
0Tl2o`0DaTa=C4goCd9?@TooaXc6okGoC?l3IP0Hocm??dooC4go3LcoaTiVCVKo8?m2Cd;o0lH03?m=
C4go?dlool0=o`==00CoCDgo0Td02?m<COm<CDco4U/00h5KF`0NF`03PE]K02=K00>1Fe/08U/10000
2U/01OmKFe_o00AK0_l4F`03oe]K009K184EF`<o0_l00lI<C002C003od9200A200OoS<Ko]Om<00AV
00?o?cl00Sl01_m=C?o<3@;o00MV@VI2ob3o00=200Go`<30o`02C00=ocm??dooc<3oCDa=o`02C@0;
ode=ode<oda=C?l04U/00h5KF`0NF`03PE]K02=K00>1Fe/08U/100002U/01OmKFe_o00AK0_l4F`03
oe]K009K00?oFe/0284>F`9?01Koc?ooC4e<COm?@Tm2Cd;oS<Ko]Om<16H02oloCcm?oda=o`g<00;o
00a>ITko8B3o@Tm2Col2aP0;ode<odloCcoo`?l014d01?m=COl2C@08oda=oda=ol`BF`03PE]K01iK
00>1Fe/08e/00h5KF`0RF`40000:F`05oe]KFol015/2o`AK00?oFe/00U/01?mKFh47F`J125/2?`04
olcoo`=<00?o@T801D801on<a_neod`016H00olo?`02?`06ode<ol`=0_l016I2I_l28003od920092
00?o`?l00d`03OloCcm?olcoC4e<COl00Td02om=COm=C?m<COo<019K00>1Fe/07U/00h5KF`0SF`03
PE]K029K0@0000YK00GoFe]Ko`04F`;o15/00omKF`02F`04oe]KP@eK1h400e]?C`04o`0@C4e<od9?
@Tm2Cd;oS<Ko]@;o16H02OloCcm?oda=C002o`0Ka_m>ITko8B3o@Tm2Coo6oda=C?m??dlool3o00==
00ooCDe=odgoCDa=oda=ol`04U/00h5KF`0NF`03PE]K02=K00>1Fe/08U/100002U/01OmKFe_o00AK
0_l4F`03oe]K009K00CoFe^155/00h4o?`02o`03a_m<009<00?o@T801D801On<a_ne00;o16H00olo
?`02?`04ode<C@;o00K0ofI2I_l28003od92009200?o`?l00d`03?loCcm?olcoC4e<o`==00_oCOm<
CDcoC4goc00BF`03PE]K01iK00>1Fe/08e/00h5KF`0RF`400008F`?o0e/00omKF`02F`;o15/00omK
F`02F`04oe]KPAAK0dl2o`0Ba_m<CDco@Tm2Cd9?@_n<a_ne0_l4IP09ocm??dooC4e<00;o01_6ITiV
C_lQ827oCd9?olKoC4e<odloCcoo`?l00dd03om=CDgoCOm=C4goC4goc00BF`03PE]K01iK00>1Fe/0
8e/00h5KF`0RF`40000:F`05oe]KFol015/2o`AK00?oFe/00U/01?mKFh4DF`<o0ol4C003od9200E2
00GoS<Ko]@02o`=V00?o?cl00cl01?m=C4d3o`05@VI2I_l00b001om2@T;o`?l00d`03?loCcm?olco
C4e<o`==00[oCOm<CDcoC4go4e/00h5KF`0OF`03PE]K029K00>1Fe/08U/100002U/00omKF`02F`Co
0U/4o`EK00CoFe^155/3C`?o00m=C4e<od9?@Tm2Cd;oS<H00_l00hcoIP02IP0:odloCcm?oda=C0?o
01YVCVI>ob4P8Om?@Tooa_m<CDcoCcm??oo0o`==00koCDe=odgoCDa=oda=oa=K00>1Fe/07e/00h5K
F`0RF`03PE]K029K0@0001iK00CoFe^155/3?`?o14`00om2@P05@P03ohc600?o16H00olo?`03?`04
ode<C@?o00E2IT9Vo`038007od92@_o0o`03C00<ocm??dooc?m<CDco0Td02om=COm<CDcoC4go01=K
00>1Fe/07e/00h5KF`0RF`03PE]K00UK384=F`40000NF`04oe]KPAAK0dl3o`0?CDa=C?m2Cd9?@Tm2
ohc600?o16H02_m??dloCom<CD`3o`0JITiVC_lQ827oCd9?olKoC4e<odloCcoo`?l3C@04ode=o`9=
00SoCDa=oda=oa=K00>1Fe/07e/00h5KF`0IFaF16E/100007U/2o`03Fh5K019K13l3o`A<00?o@T80
1D800on<aP03o`AV00?o?cl00cl01?m=C4d3o`04@VI2o`@P00Oo@T92ol3o00=<00co?dloCoo<oda=
C?l2C@0;ode=oda=C?m<COl04e/00h5KF`0OF`03PE]K00=K5X49F`03PE]K029K0@0001iK00CoFe^1
4e/4C`?o00m=C4e<od9?@Tm2Cd;oS<H00ol4IP0:odloCcm?oda=C0?o01YVCVKo824P8Om?@Tooa_m<
CDcoCcm??oo0o`==00CoCDgo0Td02?m=C4goC4go4e/00h5KF`0@FaF17e/00h5KF`0RF`40000NF`04
oe]KPA=K0cl4o`A<00?o@T801D800on<aP03o`AV00?o?cl00cl01?m=C4d3o`04@VI2o`@P00Oo@T92
ol3o00=<00co?dloCoo<oda=C?l2C@0;ode=oda=C?m<COl045/FP@mK00>1Fe/08U/00h5KF`0RF`40
000NF`03oe^101AK0dl4o`0?CDa=odm2Cd9?@Tm2ohc600?o16H02_m??dloCcooCD`3o`0HITiVob0Q
827oCd9?olKoC4e<odloCcm?0_l3C@04ode=o`9=00SoCDa=oda=oa210e/00h5KF`0OF`03PE]K029K
00>1Fe/08U/100007E/01?mKFh4DF`<o0ol4C003od9200I200?oS<H00ol4IP03oclo00@o00?oC4d0
0ol0149V@_l48007od92@_o0o`03C006ocm??dlo0_l014a=C?l2C@0;ode=oda=C?m<COl04e/00h5K
F`0OF`03PE]K029K00>1Fe/08U/100007E/01?mKFh4CF`A?0ol044a=C4goCd9?@Tm2Cd;oS<H3o`=V
00_o?dloCcm??om=C003o`0HITiVob0Q827oCd9?@_m=C4go?dloCcm?0_l3C@04ode=o`9=00SoCDa=
oda=oa=K00>1Fe/07e/00h5KF`0RF`03PE]K029K0@0001eK00CoFe^135/>o`A<00?o@T801T800on<
aP02o`AV00?o?cl01Cl00om<C@02o`05IT9V@_l01B001Om2@T;o00=<00_oCcm??dloode<C@02o`9=
00_oCDgoC4goCDa=o`0CF`03PE]K01mK00>1Fe/08U/00h5KF`0RF`40000MF`04oe]KPA1K00?o8b<0
2_l03DgoCd9?@Tm2Cd;oS<H00_l4IP0;ocm??dloCcooCD`00_l06TiVCVKo824P8B3o@Tm2ode<COlo
Ccm??doo0dd03_m=CDgoCOm<CDcoCDco55/00h5KF`0OF`03PE]K02=K00>1Fe/08E/100007E/01?mK
Fh4IF`04POlS8`oo16H00olo?`05?`03oda=00;o00AV@VKo1R001Om2@T;o00=<00coCcm??dloode<
COl3C@0:odgoCDa=ode<oaAK00>1Fe/07e/00h5KF`0SF`03PE]K025K0@0001eK00CoFe^16E/00h5K
F`03F`?o1B<00olS8`09o`07?dloCcooC@03o`0JCVI>ob4P8B0Q8?m2Cd;oCDa=ocm??dloCol3C@04
ode=o`9=00SoC4e<ode<oaAK00>1Fe/07e/00h5KF`0SF`03PE]K025K0@0001eK0_l00e^1F`0HF`03
PE]K00aK0ol58`03ob<S00co00=Vob001B001Om2@T;o00=<00coCcm??dloode<COl2C@0;ode=ode<
COm=C?l055/00h5KF`0OF`03PE]K02=K00>1Fe/08E/10000>U/00h5KF`0CF`03PE_o00;o12<2o`8S
00?o8b<04ol01Cm??doo00==00CoCDgo0Td02?m<CDcoCDco55/00h5KF`0OF`03PE]K02=K00>1Fe/0
8E/10000>U/00h5KF`0CF`03PE]K00MK0ol48`;o0R<2o`048oooo`@S0_l28`Wo0Td02om=COm=C4go
CDco01AK00>1Fe/07e/00h5KF`0SF`03PE]K025K0@0003YK00>1Fe/04e/00h5KF`0AF`05PE_oob<0
0_l012?oool48`;o0R<2o`038ooo00So00E<ode<o`0DF`03PE]K01mK00>1Fe/08e/00h5KF`0QF`40
001@F`03PE]K015K00>1Fe/01U/2o`048oooo`@S0_l00b?oo`028`;o12<5oaAK00>1Fe/07e/00h5K
F`0SF`03PE]K025K0@00051K00>1Fe/04E/00h5KF`0>F`04PE]Ko`8S00?o8b<00_l48`;o5e/00h5K
F`0OF`03PE]K02=K00>1Fe/08E/10000I5/00h5KF`0>F`03PE]K00EK00>1ool07E/00h5KF`0OF`03
PE]K02=K00>1Fe/08E/10000I5/00h5KF`0>F`03PE]K00EK00>1Fe/07E/00h5KF`0OF`03PE]K04MK
0@0007EK00>1Fe/01E/00h5KF`0MF`03PE]K06UK0@0007EK00>1Fe/01E/00h5KF`29F`40003oF`YK
0@000?mK2U/10000oe/:F`40003oF`YK0@000?mK2U/10000oe/:F`40003oF`YK0@000?mK2U/10000
oe/:F`40002eF`;oDU/10000]U/2o`=K00?oFe/0Be/10000]e/2o`=K00?oFe/0BU/10000;e/5o`=K
0ol2F`;o15/3o`03Fooo00;o0e/5o`EK0_l5F`;o0U/5o`9K0_l2F`Co0e/4o`=K1?l2F`Co0e/4o`IK
0_l3F`;o00=Kool00U/4o`=K0ol2F`?o0U/2o`EK0ol2F`;o1e/4o`03FomK00Co0U/2o`9K0_l2F`;o
1E/4o`=K1?lNF`40000^F`;o0e/2o`04FoooF`;o00=Kool015/2o`03Fooo009K0_l00e_oo`02F`;o
1E/2o`EK0_l2F`;o00=Kool00U/2o`03Fooo009K0_l00e_oo`02F`;o00=Kool00U/4o`9K0_l00e_o
o`02F`;o1E/2o`=K0_l015_ooe/2o`9K0_l2F`;o0U/2o`04FoooF`;o1E/3o`9K0_l6F`;o0U/5o`9K
0_l00e_oo`02F`;o0U/2o`AK0_l2F`;o00=Kool00U/2oaeK0@0002iK0_l3F`Co0e/4o`AK0_l00e_o
o`05F`;o0U/2o`EK0_l5F`;o0U/2o`03Fooo009K0_l00e_oo`08F`?o15/5o`QK0ol5F`;o0e/2o`03
Fooo00AK0ol2F`;o00=Kool00e/4o`AK0_l00e_oo`08F`;o15/4o`EK0_l2F`;o25/2o`9K0_l00e_o
o`02F`;o7E/10000<U/5o`=K1?l4F`;o00=Kool01?l00e_oo`02F`;o1E/2o`EK0_l2F`;o00=Kool0
0U/2o`03Fooo00Co0U/4o`=K1?l00e_oo`04o`9K1?l6F`;o0e/2o`03Fooo009K1?l3F`;o00=Kool0
0e/4o`AK0_l00e_oo`08F`;o15/8o`03Fooo009K0_l8F`;o0U/2o`03Fooo009K0_lMF`40000_F`Go
00=Kool00e/4o`AK0_l00e_oo`02F`;o00=Kool00U/2o`EK1Ol2F`;o0U/2o`03Fooo009K0_l00e_o
o`02F`;o00AKoooo15/3o`=K0_l2F`;o00AKoooo25/2o`=K0_l015_ooe/3o`EK0_l00e_oo`03F`Co
15/2o`03Fooo00QK0_l2F`Ko0U/2o`03Fooo009K0_l8F`;o0U/2o`03Fooo009K0_lMF`40000^F`?o
1E/2o`04FoooF`?o0e/2o`03Fooo009K0_l00e_oo`02F`;o1E/2o`EK0_l2F`;o00=Kool00U/2o`03
Fooo009K0_l00e_oo`02F`;o00=Kool00U/4o`9K0_l00e_oo`02F`;o1E/7o`04FoooF`;o0U/2o`9K
0_l2F`;o00AKoomK0ol3F`;o00=Kool025/2o`IK0_l2F`;o00=Kool00U/2o`QK1Ol2F`;o0U/2oaeK
0@0002iK0_l3F`;o0U/3o`9K0ol2F`Co00=Kool00_l3F`Go1E/2o`EK0_l00e_oo`07o`=K1?l3F`Co
0e/4o`9K1?l3F`Co1U/2o`=K0_l00e_oo`02F`Co0U/4o`9K0ol2F`?o0U/2o`=K0_l7F`;o15/2o`03
Fooo00;o0U/5o`UK0_l5F`;o0U/2oaeK0@0002iK0_l3F`;o3E/2o`aK0_l5F`;o2E/2obiK0_l3F`;o
35/2oaaK0_l2F`;o5U/2o`9K0_l00e_oo`02F`;o7E/10000;e/5o`iK0_l<F`;o1E/6o`03Fooo009K
0_l^F`;o0e/2o`03Fooo00UK0_lMF`Co65/4o`=K1?lNF`40003oF`YK0@000?mK2U/10000oe/:F`40
003oF`YK0@000?mK2U/10000\
\>"],
  ImageRangeCache->{{{0, 265}, {252, 0}} -> {-0.0925078, -0.0556196, 
  0.00397335, 0.00397335}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Generations 60 to 80"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Fitnesses-Gen80"],

Cell[CellGroupData[{

Cell[TextData[
"fitnessChart3D[Take[allFitnessesSorted,{61,81}],\n  DisplayGeneration -> 80,\
\n  GenIndices -> {{1,60},{11,70},{21,80}}];"], "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .95229 
MathPictureStart
%% Graphics3D
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-3.75585e-05 1.06867 0.0267167 1.06867 [
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 80)] .5 .95229 0 -1.5 Msboxa
P
[(0)] .08595 .18034 -0.06484 1 Msboxa
[(10)] .23556 .13958 -0.04346 1 Msboxa
[(20)] .40028 .0947 -0.01962 1 Msboxa
[(30)] .58253 .04506 .00711 1 Msboxa
[(Indiv.)] .35928 .03957 -0.02584 1 Msboxa
[(60)] .73432 .0488 -1 .26344 Msboxa
[(70)] .85598 .1892 -1 .21908 Msboxa
[(80)] .94747 .29479 -1 .1875 Msboxa
[(Gen.)] .91594 .16872 -1 .22094 Msboxa
[(-100)] .05455 .27684 1 -0.24757 Msboxa
[(0)] .04482 .42044 1 -0.20167 Msboxa
[(100)] .03471 .57006 1 -0.15355 Msboxa
[(200)] .02419 .72609 1 -0.10302 Msboxa
[(Fit.)] -0.0283 .53856 1 -0.16726 Msboxa
[ 0 0 0 0 ]
[ 1 .95229 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 80)] .5 .95229 0 -1.5 Mshowa
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.08509 .19367 m
.08465 .20033 L
s
P
[(0)] .08595 .18034 -0.06484 1 Mshowa
p
.002 w
.23498 .15292 m
.23469 .15959 L
s
P
[(10)] .23556 .13958 -0.04346 1 Mshowa
p
.002 w
.40002 .10806 m
.39989 .11474 L
s
P
[(20)] .40028 .0947 -0.01962 1 Mshowa
p
.002 w
.58262 .05842 m
.58267 .0651 L
s
P
[(30)] .58253 .04506 .00711 1 Mshowa
p
.001 w
.11395 .18582 m
.11371 .18982 L
s
P
p
.001 w
.14336 .17783 m
.14314 .18183 L
s
P
p
.001 w
.17332 .16968 m
.17311 .17368 L
s
P
p
.001 w
.20386 .16138 m
.20367 .16538 L
s
P
p
.001 w
.2667 .1443 m
.26655 .1483 L
s
P
p
.001 w
.29905 .1355 m
.29892 .13951 L
s
P
p
.001 w
.33204 .12654 m
.33192 .13054 L
s
P
p
.001 w
.36569 .11739 m
.36559 .1214 L
s
P
p
.001 w
.43505 .09854 m
.43499 .10254 L
s
P
p
.001 w
.4708 .08882 m
.47076 .09283 L
s
P
p
.001 w
.5073 .0789 m
.50728 .0829 L
s
P
p
.001 w
.54456 .06877 m
.54457 .07277 L
s
P
p
.001 w
.6215 .04785 m
.62155 .05186 L
s
P
p
.001 w
.66122 .03706 m
.6613 .04106 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
p
.002 w
.69926 .02672 m
.93852 .30206 L
s
P
p
.002 w
.7214 .0522 m
.71494 .0539 L
s
P
[(60)] .73432 .0488 -1 .26344 Mshowa
p
.002 w
.84293 .19206 m
.83641 .19349 L
s
P
[(70)] .85598 .1892 -1 .21908 Mshowa
p
.002 w
.93434 .29725 m
.92778 .29848 L
s
P
[(80)] .94747 .29479 -1 .1875 Mshowa
[(Gen.)] .91594 .16872 -1 .22094 Mshowa
P
p
p
.002 w
.07262 .19706 m
.02672 .88626 L
s
P
p
.002 w
.06752 .27363 m
.07401 .27202 L
s
P
[(-100)] .05455 .27684 1 -0.24757 Mshowa
p
.002 w
.05792 .4178 m
.06447 .41648 L
s
P
[(0)] .04482 .42044 1 -0.20167 Mshowa
p
.002 w
.04791 .56804 m
.05451 .56702 L
s
P
[(100)] .03471 .57006 1 -0.15355 Mshowa
p
.002 w
.03748 .72472 m
.04412 .72403 L
s
P
[(200)] .02419 .72609 1 -0.10302 Mshowa
p
.001 w
.06563 .30199 m
.06953 .30106 L
s
P
p
.001 w
.06373 .33059 m
.06763 .3297 L
s
P
p
.001 w
.06181 .35943 m
.06572 .35856 L
s
P
p
.001 w
.05987 .38849 m
.06379 .38767 L
s
P
p
.001 w
.05595 .44735 m
.05989 .4466 L
s
P
p
.001 w
.05397 .47715 m
.05791 .47643 L
s
P
p
.001 w
.05196 .50719 m
.05591 .50651 L
s
P
p
.001 w
.04995 .53749 m
.0539 .53684 L
s
P
p
.001 w
.04586 .59884 m
.04983 .59827 L
s
P
p
.001 w
.04379 .62991 m
.04776 .62938 L
s
P
p
.001 w
.0417 .66124 m
.04568 .66075 L
s
P
p
.001 w
.0396 .69285 m
.04358 .69239 L
s
P
p
.001 w
.03534 .75686 m
.03933 .75649 L
s
P
p
.001 w
.03318 .78929 m
.03717 .78896 L
s
P
p
.001 w
.031 .82199 m
.03499 .82171 L
s
P
p
.001 w
.0288 .85499 m
.0328 .85474 L
s
P
p
.001 w
.0694 .24548 m
.07328 .24449 L
s
P
p
.001 w
.07126 .21757 m
.07513 .21654 L
s
P
[(Fit.)] -0.0283 .53856 1 -0.16726 Mshowa
P
0 0 m
1 0 L
1 .95229 L
0 .95229 L
closepath
clip
newpath
p
p
.4 g
.002 w
.06752 .27363 m
.42865 .45675 L
s
P
p
.4 g
.002 w
.05792 .4178 m
.427 .56884 L
s
P
p
.4 g
.002 w
.04791 .56804 m
.4253 .68447 L
s
P
p
.4 g
.002 w
.03748 .72472 m
.42355 .80382 L
s
P
p
.4 g
.002 w
.02658 .88827 m
.42174 .92708 L
s
P
p
.4 g
.002 w
.08367 .20324 m
.03923 .88751 L
s
P
p
.4 g
.002 w
.18133 .25789 m
.149 .89843 L
s
P
p
.4 g
.002 w
.26703 .30585 m
.24418 .9079 L
s
P
p
.4 g
.002 w
.34284 .34827 m
.32749 .91619 L
s
P
p
.4 g
.002 w
.41037 .38606 m
.40102 .92351 L
s
P
p
.4 g
.002 w
.44013 .39481 m
.43312 .92519 L
s
P
p
.4 g
.002 w
.56602 .37138 m
.56847 .92068 L
s
P
p
.4 g
.002 w
.70138 .34619 m
.71482 .91579 L
s
P
p
.4 g
.002 w
.84733 .31903 m
.87358 .91049 L
s
P
p
.4 g
.002 w
.42865 .45675 m
.94243 .37002 L
s
P
p
.4 g
.002 w
.427 .56884 m
.94975 .49749 L
s
P
p
.4 g
.002 w
.4253 .68447 m
.95734 .62961 L
s
P
p
.4 g
.002 w
.42355 .80382 m
.96521 .76666 L
s
P
p
.4 g
.002 w
.42174 .92708 m
.97338 .9089 L
s
P
P
p
.43324 .39367 m .45808 .39844 L .44573 .40071 L 1 0 0 r
F
P
p
.44568 .39134 m .47051 .39615 L .45808 .39844 L 1 0 0 r
F
P
p
.43324 .39367 m .44568 .39134 L .45808 .39844 L 1 0 0 r
F
P
p
.45821 .389 m .48303 .39384 L .47051 .39615 L 1 0 0 r
F
P
p
.44568 .39134 m .45821 .389 L .47051 .39615 L 1 0 0 r
F
P
p
.47082 .38665 m .49564 .39152 L .48303 .39384 L .729 0 1 r
F
P
p
.45821 .389 m .47082 .38665 L .48303 .39384 L 1 0 0 r
F
P
p
.42048 .38646 m .44568 .39134 L .43324 .39367 L 1 0 0 r
F
P
p
.48353 .38427 m .50835 .38918 L .49564 .39152 L 0 .542 1 r
F
P
p
.47082 .38665 m .48353 .38427 L .49564 .39152 L .729 0 1 r
F
P
p
.43301 .38409 m .45821 .389 L .44568 .39134 L 1 0 0 r
F
P
p
.42048 .38646 m .43301 .38409 L .44568 .39134 L 1 0 0 r
F
P
p
.49633 .38188 m .52114 .38683 L .50835 .38918 L 0 .552 1 r
F
P
p
.48353 .38427 m .49633 .38188 L .50835 .38918 L 0 .542 1 r
F
P
p
.44563 .3817 m .47082 .38665 L .45821 .389 L 1 0 0 r
F
P
p
.43301 .38409 m .44563 .3817 L .45821 .389 L 1 0 0 r
F
P
p
.50923 .37947 m .53403 .38446 L .52114 .38683 L 0 .573 1 r
F
P
p
.49633 .38188 m .50923 .37947 L .52114 .38683 L 0 .552 1 r
F
P
p
.45834 .37929 m .48353 .38427 L .47082 .38665 L 1 0 0 r
F
P
p
.44563 .3817 m .45834 .37929 L .47082 .38665 L 1 0 0 r
F
P
p
.40743 .3791 m .43301 .38409 L .42048 .38646 L 1 0 0 r
F
P
p
.52221 .37705 m .54701 .38207 L .53403 .38446 L 0 1 .51 r
F
P
p
.50923 .37947 m .52221 .37705 L .53403 .38446 L 0 .573 1 r
F
P
p
.47115 .37686 m .49633 .38188 L .48353 .38427 L 1 0 0 r
F
P
p
.45834 .37929 m .47115 .37686 L .48353 .38427 L 1 0 0 r
F
P
p
.42005 .37667 m .44563 .3817 L .43301 .38409 L 1 0 0 r
F
P
p
.40743 .3791 m .42005 .37667 L .43301 .38409 L 1 0 0 r
F
P
p
.5353 .3746 m .56008 .37966 L .54701 .38207 L .635 1 0 r
F
P
p
.52221 .37705 m .5353 .3746 L .54701 .38207 L 0 1 .51 r
F
P
p
.48405 .37441 m .50923 .37947 L .49633 .38188 L 1 0 .896 r
F
P
p
.47115 .37686 m .48405 .37441 L .49633 .38188 L 1 0 0 r
F
P
p
.43276 .37423 m .45834 .37929 L .44563 .3817 L 1 0 0 r
F
P
p
.42005 .37667 m .43276 .37423 L .44563 .3817 L 1 0 0 r
F
P
p
.54848 .37214 m .57325 .37723 L .56008 .37966 L .979 1 0 r
F
P
p
.5353 .3746 m .54848 .37214 L .56008 .37966 L .635 1 0 r
F
P
p
.49704 .37195 m .52221 .37705 L .50923 .37947 L .208 0 1 r
F
P
p
.48405 .37441 m .49704 .37195 L .50923 .37947 L 1 0 .896 r
F
P
p
.44557 .37176 m .47115 .37686 L .45834 .37929 L 1 0 0 r
F
P
p
.43276 .37423 m .44557 .37176 L .45834 .37929 L 1 0 0 r
F
P
p
.39408 .37157 m .42005 .37667 L .40743 .3791 L 1 0 .896 r
F
P
p
.56176 .36966 m .58652 .37479 L .57325 .37723 L 1 .813 0 r
F
P
p
.54848 .37214 m .56176 .36966 L .57325 .37723 L .979 1 0 r
F
P
p
.51013 .36947 m .5353 .3746 L .52221 .37705 L 0 .927 1 r
F
P
p
.49704 .37195 m .51013 .36947 L .52221 .37705 L .208 0 1 r
F
P
p
.45848 .36928 m .48405 .37441 L .47115 .37686 L 1 0 .896 r
F
P
p
.44557 .37176 m .45848 .36928 L .47115 .37686 L 1 0 0 r
F
P
p
.40679 .36909 m .43276 .37423 L .42005 .37667 L .208 0 1 r
F
P
p
.39408 .37157 m .40679 .36909 L .42005 .37667 L 1 0 .896 r
F
P
p
.57514 .36716 m .59989 .37233 L .58652 .37479 L 1 .698 0 r
F
P
p
.56176 .36966 m .57514 .36716 L .58652 .37479 L 1 .813 0 r
F
P
p
.52332 .36697 m .54848 .37214 L .5353 .3746 L .313 1 0 r
F
P
p
.51013 .36947 m .52332 .36697 L .5353 .3746 L 0 .927 1 r
F
P
p
.47148 .36678 m .49704 .37195 L .48405 .37441 L 0 .688 1 r
F
P
p
.45848 .36928 m .47148 .36678 L .48405 .37441 L 1 0 .896 r
F
P
p
.4196 .36658 m .44557 .37176 L .43276 .37423 L .208 0 1 r
F
P
p
.40679 .36909 m .4196 .36658 L .43276 .37423 L .208 0 1 r
F
P
p
.58861 .36464 m .61335 .36985 L .59989 .37233 L 1 .615 0 r
F
P
p
.57514 .36716 m .58861 .36464 L .59989 .37233 L 1 .698 0 r
F
P
p
.53661 .36445 m .56176 .36966 L .54848 .37214 L .656 1 0 r
F
P
p
.52332 .36697 m .53661 .36445 L .54848 .37214 L .313 1 0 r
F
P
p
.48458 .36426 m .51013 .36947 L .49704 .37195 L 0 1 .417 r
F
P
p
.47148 .36678 m .48458 .36426 L .49704 .37195 L 0 .688 1 r
F
P
p
.002 w
.50756 .60598 m .49447 .60759 L .47981 .90677 L p
0 .542 1 r
F P
0 0 0 r
s
P
p
.002 w
.49447 .60759 m .47933 .90887 L .46618 .90729 L p
.729 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46618 .90729 m .47981 .90677 L .49447 .60759 L p
.729 0 1 r
F P
0 0 0 r
s
P
p
.43251 .36406 m .45848 .36928 L .44557 .37176 L .208 0 1 r
F
P
p
.4196 .36658 m .43251 .36406 L .44557 .37176 L .208 0 1 r
F
P
p
.38042 .36387 m .40679 .36909 L .39408 .37157 L 0 .688 1 r
F
P
p
.60219 .36211 m .62692 .36735 L .61335 .36985 L 1 .531 0 r
F
P
p
.58861 .36464 m .60219 .36211 L .61335 .36985 L 1 .615 0 r
F
P
p
.55 .36191 m .57514 .36716 L .56176 .36966 L .875 1 0 r
F
P
p
.53661 .36445 m .55 .36191 L .56176 .36966 L .656 1 0 r
F
P
p
.49777 .36172 m .52332 .36697 L .51013 .36947 L 0 1 .177 r
F
P
p
.48458 .36426 m .49777 .36172 L .51013 .36947 L 0 1 .417 r
F
P
p
.002 w
.52074 .60198 m .50756 .60598 L .49353 .90625 L p
0 .552 1 r
F P
0 0 0 r
s
P
p
.002 w
.47981 .90677 m .49353 .90625 L .50756 .60598 L p
0 .542 1 r
F P
0 0 0 r
s
P
p
.44552 .36152 m .47148 .36678 L .45848 .36928 L 0 .688 1 r
F
P
p
.43251 .36406 m .44552 .36152 L .45848 .36928 L .208 0 1 r
F
P
p
.39323 .36132 m .4196 .36658 L .40679 .36909 L 0 1 .417 r
F
P
p
.38042 .36387 m .39323 .36132 L .40679 .36909 L 0 .688 1 r
F
P
p
.61587 .35955 m .64059 .36484 L .62692 .36735 L 1 .5 0 r
F
P
p
.60219 .36211 m .61587 .35955 L .62692 .36735 L 1 .531 0 r
F
P
p
.56349 .35935 m .58861 .36464 L .57514 .36716 L 1 .885 0 r
F
P
p
.55 .36191 m .56349 .35935 L .57514 .36716 L .875 1 0 r
F
P
p
.002 w
.53402 .59795 m .52074 .60198 L .50737 .90572 L p
0 .573 1 r
F P
0 0 0 r
s
P
p
.002 w
.49353 .90625 m .50737 .90572 L .52074 .60198 L p
0 .552 1 r
F P
0 0 0 r
s
P
p
.51107 .35916 m .53661 .36445 L .52332 .36697 L .073 1 0 r
F
P
p
.49777 .36172 m .51107 .35916 L .52332 .36697 L 0 1 .177 r
F
P
p
.45862 .35896 m .48458 .36426 L .47148 .36678 L 0 1 .135 r
F
P
p
.44552 .36152 m .45862 .35896 L .47148 .36678 L 0 .688 1 r
F
P
p
.40614 .35876 m .43251 .36406 L .4196 .36658 L 0 1 .417 r
F
P
p
.39323 .36132 m .40614 .35876 L .4196 .36658 L 0 1 .417 r
F
P
p
.62966 .35698 m .65436 .3623 L .64059 .36484 L 1 .448 0 r
F
P
p
.61587 .35955 m .62966 .35698 L .64059 .36484 L 1 .5 0 r
F
P
p
.54067 .67414 m .54739 .59389 L .52889 .722 L 0 1 .51 r
F
P
p
.002 w
.52889 .722 m .52132 .90519 L p
.54067 .67414 L 0 1 .51 r
F P
0 0 0 r
s
P
p
.002 w
.54204 .63408 m .54739 .59389 L p
.54379 .63684 L 0 1 .51 r
F P
0 0 0 r
s
P
p
.002 w
.56085 .59221 m .54739 .59389 L .54204 .63408 L p
.635 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53534 .68442 m .54204 .63408 L p
.53478 .74441 L 0 1 .51 r
F P
0 0 0 r
s
P
p
.53478 .74441 m .54204 .63408 L .54379 .63684 L 0 1 .51 r
F
P
p
.002 w
.54204 .63408 m .53534 .68442 L p
.54986 .63193 L .635 1 0 r
F P
0 0 0 r
s
P
p
.54986 .63193 m .56085 .59221 L .54204 .63408 L .635 1 0 r
F
P
p
.002 w
.54739 .59389 m .53402 .59795 L .52889 .722 L p
0 1 .51 r
F P
0 0 0 r
s
P
p
.002 w
.53669 .61864 m .54899 .62607 L p
.5359 .6244 L .313 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50737 .90572 m .52132 .90519 L .53402 .59795 L p
0 .573 1 r
F P
0 0 0 r
s
P
p
.002 w
.52293 .62275 m .53296 .61976 L p
.5359 .6244 L .313 1 0 r
F P
0 0 0 r
s
P
p
.53309 .61997 m .53669 .61864 L .5359 .6244 L .313 1 0 r
F
P
p
.002 w
.53534 .68442 m .52293 .62275 L p
.5359 .6244 L .313 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54899 .62607 m .53534 .68442 L p
.5359 .6244 L .313 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54899 .62607 m .53669 .61864 L p
.54975 .61415 L .656 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54899 .62607 m .56075 .59252 L p
.54823 .63778 L .635 1 0 r
F P
0 0 0 r
s
P
p
.55272 .62162 m .56075 .59252 L .56056 .59326 L .635 1 0 r
F
P
p
.53534 .68442 m .55271 .6216 L .55272 .62162 L .635 1 0 r
F
P
p
.55271 .6216 m .56075 .59252 L .55272 .62162 L .635 1 0 r
F
P
p
.002 w
.56075 .59252 m .56085 .59221 L p
.56056 .59326 L .635 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57437 .58087 m .56085 .59221 L .54899 .62607 L p
.979 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54899 .62607 m .56269 .60971 L .57437 .58087 L p
.979 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55055 .60953 m .56269 .60971 L p
.54975 .61415 L .656 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53669 .61864 m .54846 .6109 L p
.54975 .61415 L .656 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54846 .6109 m .55055 .60953 L p
.54975 .61415 L .656 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56269 .60971 m .54899 .62607 L p
.54975 .61415 L .656 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53534 .68442 m .54899 .62607 L p
.54823 .63778 L .635 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50907 .68155 m .52293 .62275 L .53534 .68442 L p
0 .927 1 r
F P
0 0 0 r
s
P
p
.002 w
.53669 .61864 m .52402 .67434 L p
.54861 .61425 L .396 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55055 .60953 m .53669 .61864 L p
.54861 .61425 L .396 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53296 .61976 m .53669 .61864 L p
.53309 .61997 L .313 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52132 .90519 m .53534 .68442 L p
.53478 .74441 L 0 1 .51 r
F P
0 0 0 r
s
P
p
.57708 .35678 m .60219 .36211 L .58861 .36464 L 1 .729 0 r
F
P
p
.56349 .35935 m .57708 .35678 L .58861 .36464 L 1 .885 0 r
F
P
p
.52446 .35658 m .55 .36191 L .53661 .36445 L .396 1 0 r
F
P
p
.51107 .35916 m .52446 .35658 L .53661 .36445 L .073 1 0 r
F
P
p
.47182 .35638 m .49777 .36172 L .48458 .36426 L .146 1 0 r
F
P
p
.45862 .35896 m .47182 .35638 L .48458 .36426 L 0 1 .135 r
F
P
p
.41915 .35618 m .44552 .36152 L .43251 .36406 L 0 1 .417 r
F
P
p
.40614 .35876 m .41915 .35618 L .43251 .36406 L 0 1 .417 r
F
P
p
.36644 .35598 m .39323 .36132 L .38042 .36387 L 0 1 .417 r
F
P
p
.64355 .35438 m .66823 .35975 L .65436 .3623 L 1 .406 0 r
F
P
p
.62966 .35698 m .64355 .35438 L .65436 .3623 L 1 .448 0 r
F
P
p
.59077 .35418 m .61587 .35955 L .60219 .36211 L 1 .656 0 r
F
P
p
.57708 .35678 m .59077 .35418 L .60219 .36211 L 1 .729 0 r
F
P
p
.53796 .35398 m .56349 .35935 L .55 .36191 L .833 1 0 r
F
P
p
.52446 .35658 m .53796 .35398 L .55 .36191 L .396 1 0 r
F
P
p
.48512 .35378 m .51107 .35916 L .49777 .36172 L .177 1 0 r
F
P
p
.47182 .35638 m .48512 .35378 L .49777 .36172 L .146 1 0 r
F
P
p
.43225 .35358 m .45862 .35896 L .44552 .36152 L 0 1 .135 r
F
P
p
.41915 .35618 m .43225 .35358 L .44552 .36152 L 0 1 .417 r
F
P
p
.37935 .35338 m .40614 .35876 L .39323 .36132 L 0 1 .417 r
F
P
p
.36644 .35598 m .37935 .35338 L .39323 .36132 L 0 1 .417 r
F
P
p
.65754 .35177 m .68221 .35718 L .66823 .35975 L 1 .385 0 r
F
P
p
.64355 .35438 m .65754 .35177 L .66823 .35975 L 1 .406 0 r
F
P
p
.60457 .35157 m .62966 .35698 L .61587 .35955 L 1 .594 0 r
F
P
p
.59077 .35418 m .60457 .35157 L .61587 .35955 L 1 .656 0 r
F
P
p
.55156 .35137 m .57708 .35678 L .56349 .35935 L 1 .906 0 r
F
P
p
.53796 .35398 m .55156 .35137 L .56349 .35935 L .833 1 0 r
F
P
p
.49853 .35116 m .52446 .35658 L .51107 .35916 L .281 1 0 r
F
P
p
.48512 .35378 m .49853 .35116 L .51107 .35916 L .177 1 0 r
F
P
p
.44546 .35096 m .47182 .35638 L .45862 .35896 L .563 1 0 r
F
P
p
.43225 .35358 m .44546 .35096 L .45862 .35896 L 0 1 .135 r
F
P
p
.39236 .35076 m .41915 .35618 L .40614 .35876 L 0 1 .417 r
F
P
p
.37935 .35338 m .39236 .35076 L .40614 .35876 L 0 1 .417 r
F
P
p
.002 w
.58802 .57913 m .57437 .58087 L .56269 .60971 L p
1 .813 0 r
F P
0 0 0 r
s
P
p
.67164 .34913 m .69629 .35458 L .68221 .35718 L 1 .375 0 r
F
P
p
.65754 .35177 m .67164 .34913 L .68221 .35718 L 1 .385 0 r
F
P
p
.61847 .34893 m .64355 .35438 L .62966 .35698 L 1 .5 0 r
F
P
p
.60457 .35157 m .61847 .34893 L .62966 .35698 L 1 .594 0 r
F
P
p
.56527 .34873 m .59077 .35418 L .57708 .35678 L 1 .76 0 r
F
P
p
.55156 .35137 m .56527 .34873 L .57708 .35678 L 1 .906 0 r
F
P
p
.51203 .34852 m .53796 .35398 L .52446 .35658 L .646 1 0 r
F
P
p
.49853 .35116 m .51203 .34852 L .52446 .35658 L .281 1 0 r
F
P
p
.45877 .34832 m .48512 .35378 L .47182 .35638 L .979 1 0 r
F
P
p
.44546 .35096 m .45877 .34832 L .47182 .35638 L .563 1 0 r
F
P
p
.40547 .34812 m .43225 .35358 L .41915 .35618 L 0 1 .417 r
F
P
p
.39236 .35076 m .40547 .34812 L .41915 .35618 L 0 1 .417 r
F
P
p
.35214 .34791 m .37935 .35338 L .36644 .35598 L 0 1 .417 r
F
P
p
.002 w
.56269 .60971 m .57638 .58347 L .58802 .57913 L p
1 .813 0 r
F P
0 0 0 r
s
P
p
.002 w
.60176 .57495 m .58802 .57913 L .57638 .58347 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.45261 .90987 m .43941 .91037 L .42594 .90883 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68585 .34648 m .71048 .35197 L .69629 .35458 L 1 .354 0 r
F
P
p
.67164 .34913 m .68585 .34648 L .69629 .35458 L 1 .375 0 r
F
P
p
.63248 .34628 m .65754 .35177 L .64355 .35438 L 1 .427 0 r
F
P
p
.61847 .34893 m .63248 .34628 L .64355 .35438 L 1 .5 0 r
F
P
p
.57908 .34607 m .60457 .35157 L .59077 .35418 L 1 .698 0 r
F
P
p
.56527 .34873 m .57908 .34607 L .59077 .35418 L 1 .76 0 r
F
P
p
.52564 .34587 m .55156 .35137 L .53796 .35398 L 1 .927 0 r
F
P
p
.51203 .34852 m .52564 .34587 L .53796 .35398 L .646 1 0 r
F
P
p
.47217 .34566 m .49853 .35116 L .48512 .35378 L 1 .958 0 r
F
P
p
.45877 .34832 m .47217 .34566 L .48512 .35378 L .979 1 0 r
F
P
p
.41868 .34545 m .44546 .35096 L .43225 .35358 L 0 1 .135 r
F
P
p
.40547 .34812 m .41868 .34545 L .43225 .35358 L 0 1 .417 r
F
P
p
.36515 .34525 m .39236 .35076 L .37935 .35338 L 0 1 .417 r
F
P
p
.35214 .34791 m .36515 .34525 L .37935 .35338 L 0 1 .417 r
F
P
p
.002 w
.57638 .58347 m .59027 .58171 L .60176 .57495 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.61554 .56588 m .60864 .57042 L p
.60927 .56981 L 1 .615 0 r
F P
0 0 0 r
s
P
p
.002 w
.60418 .57008 m .61554 .56588 L p
.60927 .56981 L 1 .615 0 r
F P
0 0 0 r
s
P
p
.002 w
.59027 .58171 m .60418 .57008 L p
.60927 .56981 L 1 .615 0 r
F P
0 0 0 r
s
P
p
.002 w
.60418 .57008 m .59027 .58171 L .57838 .57372 L p
1 .729 0 r
F P
0 0 0 r
s
P
p
.002 w
.57838 .57372 m .5925 .57189 L .60418 .57008 L p
1 .729 0 r
F P
0 0 0 r
s
P
p
.002 w
.60418 .57008 m .5925 .57189 L p
.59899 .57035 L 1 .656 0 r
F P
0 0 0 r
s
P
p
.002 w
.62949 .56407 m .61554 .56588 L .60418 .57008 L p
1 .531 0 r
F P
0 0 0 r
s
P
p
.002 w
.61825 .56578 m .60418 .57008 L p
.61143 .5674 L 1 .656 0 r
F P
0 0 0 r
s
P
p
.59899 .57035 m .61143 .5674 L .60418 .57008 L 1 .656 0 r
F
P
p
.002 w
.61825 .56578 m .62949 .56407 L p
.61055 .56856 L 1 .531 0 r
F P
0 0 0 r
s
P
p
.002 w
.60418 .57008 m .6112 .56793 L p
.61055 .56856 L 1 .531 0 r
F P
0 0 0 r
s
P
p
.002 w
.6112 .56793 m .61825 .56578 L p
.61055 .56856 L 1 .531 0 r
F P
0 0 0 r
s
P
p
.002 w
.60176 .57495 m .59027 .58171 L p
.60927 .56981 L 1 .615 0 r
F P
0 0 0 r
s
P
p
.002 w
.60864 .57042 m .60176 .57495 L p
.60927 .56981 L 1 .615 0 r
F P
0 0 0 r
s
P
p
.002 w
.46592 .90937 m .45261 .90987 L .43925 .90832 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.42594 .90883 m .43925 .90832 L .45261 .90987 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70017 .34381 m .72478 .34934 L .71048 .35197 L 1 .313 0 r
F
P
p
.68585 .34648 m .70017 .34381 L .71048 .35197 L 1 .354 0 r
F
P
p
.6466 .3436 m .67164 .34913 L .65754 .35177 L 1 .406 0 r
F
P
p
.63248 .34628 m .6466 .3436 L .65754 .35177 L 1 .427 0 r
F
P
p
.59299 .34339 m .61847 .34893 L .60457 .35157 L 1 .615 0 r
F
P
p
.57908 .34607 m .59299 .34339 L .60457 .35157 L 1 .698 0 r
F
P
p
.53936 .34319 m .56527 .34873 L .55156 .35137 L 1 .75 0 r
F
P
p
.52564 .34587 m .53936 .34319 L .55156 .35137 L 1 .927 0 r
F
P
p
.48569 .34298 m .51203 .34852 L .49853 .35116 L 1 .823 0 r
F
P
p
.47217 .34566 m .48569 .34298 L .49853 .35116 L 1 .958 0 r
F
P
p
.43199 .34277 m .45877 .34832 L .44546 .35096 L .281 1 0 r
F
P
p
.41868 .34545 m .43199 .34277 L .44546 .35096 L 0 1 .135 r
F
P
p
.37825 .34256 m .40547 .34812 L .39236 .35076 L 0 1 .417 r
F
P
p
.36515 .34525 m .37825 .34256 L .39236 .35076 L 0 1 .417 r
F
P
p
.002 w
.47933 .90887 m .46592 .90937 L .45267 .90781 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.43925 .90832 m .45267 .90781 L .46592 .90937 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7146 .34111 m .73919 .34669 L .72478 .34934 L 1 .271 0 r
F
P
p
.70017 .34381 m .7146 .34111 L .72478 .34934 L 1 .313 0 r
F
P
p
.66083 .3409 m .68585 .34648 L .67164 .34913 L 1 .396 0 r
F
P
p
.6466 .3436 m .66083 .3409 L .67164 .34913 L 1 .406 0 r
F
P
p
.60702 .34069 m .63248 .34628 L .61847 .34893 L 1 .51 0 r
F
P
p
.59299 .34339 m .60702 .34069 L .61847 .34893 L 1 .615 0 r
F
P
p
.55318 .34049 m .57908 .34607 L .56527 .34873 L 1 .677 0 r
F
P
p
.53936 .34319 m .55318 .34049 L .56527 .34873 L 1 .75 0 r
F
P
p
.002 w
.64351 .55979 m .62949 .56407 L .61825 .56578 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.4993 .34028 m .52564 .34587 L .51203 .34852 L 1 .719 0 r
F
P
p
.48569 .34298 m .4993 .34028 L .51203 .34852 L 1 .823 0 r
F
P
p
.4454 .34007 m .47217 .34566 L .45877 .34832 L .76 1 0 r
F
P
p
.43199 .34277 m .4454 .34007 L .45877 .34832 L .281 1 0 r
F
P
p
.39146 .33986 m .41868 .34545 L .40547 .34812 L 0 1 .417 r
F
P
p
.37825 .34256 m .39146 .33986 L .40547 .34812 L 0 1 .417 r
F
P
p
.33749 .33965 m .36515 .34525 L .35214 .34791 L 0 1 .417 r
F
P
p
.002 w
.45267 .90781 m .46618 .90729 L .47933 .90887 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.57638 .58347 m .56269 .60971 L .55055 .60953 L p
.875 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.43925 .90832 m .42594 .90883 L .41216 .90725 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.72915 .33839 m .75371 .34401 L .73919 .34669 L 1 .219 0 r
F
P
p
.7146 .34111 m .72915 .33839 L .73919 .34669 L 1 .271 0 r
F
P
p
.002 w
.59027 .58171 m .57638 .58347 L .56449 .60286 L p
1 .885 0 r
F P
0 0 0 r
s
P
p
.002 w
.55055 .60953 m .56449 .60286 L .57638 .58347 L p
.875 1 0 r
F P
0 0 0 r
s
P
p
.67516 .33818 m .70017 .34381 L .68585 .34648 L 1 .365 0 r
F
P
p
.66083 .3409 m .67516 .33818 L .68585 .34648 L 1 .396 0 r
F
P
p
.62115 .33797 m .6466 .3436 L .63248 .34628 L 1 .406 0 r
F
P
p
.60702 .34069 m .62115 .33797 L .63248 .34628 L 1 .51 0 r
F
P
p
.002 w
.65763 .55549 m .64351 .55979 L .63241 .56146 L p
1 .448 0 r
F P
0 0 0 r
s
P
p
.002 w
.61825 .56578 m .63241 .56146 L .64351 .55979 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.5671 .33776 m .59299 .34339 L .57908 .34607 L 1 .615 0 r
F
P
p
.55318 .34049 m .5671 .33776 L .57908 .34607 L 1 .677 0 r
F
P
p
.51303 .33755 m .53936 .34319 L .52564 .34587 L 1 .656 0 r
F
P
p
.4993 .34028 m .51303 .33755 L .52564 .34587 L 1 .719 0 r
F
P
p
.45892 .33734 m .48569 .34298 L .47217 .34566 L 1 .844 0 r
F
P
p
.4454 .34007 m .45892 .33734 L .47217 .34566 L .76 1 0 r
F
P
p
.002 w
.53534 .68442 m .52132 .90519 L .50907 .68155 L p
0 .927 1 r
F P
0 0 0 r
s
P
p
.40477 .33713 m .43199 .34277 L .41868 .34545 L 0 1 .417 r
F
P
p
.39146 .33986 m .40477 .33713 L .41868 .34545 L 0 1 .417 r
F
P
p
.3506 .33692 m .37825 .34256 L .36515 .34525 L 0 1 .417 r
F
P
p
.33749 .33965 m .3506 .33692 L .36515 .34525 L 0 1 .417 r
F
P
p
.002 w
.45267 .90781 m .43925 .90832 L .42557 .90673 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.41216 .90725 m .42557 .90673 L .43925 .90832 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7438 .33566 m .76835 .34132 L .75371 .34401 L 1 .167 0 r
F
P
p
.72915 .33839 m .7438 .33566 L .75371 .34401 L 1 .219 0 r
F
P
p
.002 w
.56449 .60286 m .57838 .57372 L .59027 .58171 L p
1 .885 0 r
F P
0 0 0 r
s
P
p
.002 w
.67189 .55361 m .65763 .55549 L .64663 .55462 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.002 w
.63241 .56146 m .64663 .55462 L .65763 .55549 L p
1 .448 0 r
F P
0 0 0 r
s
P
p
.68961 .33544 m .7146 .34111 L .70017 .34381 L 1 .323 0 r
F
P
p
.67516 .33818 m .68961 .33544 L .70017 .34381 L 1 .365 0 r
F
P
p
.63539 .33523 m .66083 .3409 L .6466 .3436 L 1 .344 0 r
F
P
p
.62115 .33797 m .63539 .33523 L .6466 .3436 L 1 .406 0 r
F
P
p
.58114 .33502 m .60702 .34069 L .59299 .34339 L 1 .542 0 r
F
P
p
.5671 .33776 m .58114 .33502 L .59299 .34339 L 1 .615 0 r
F
P
p
.52686 .33481 m .55318 .34049 L .53936 .34319 L 1 .573 0 r
F
P
p
.51303 .33755 m .52686 .33481 L .53936 .34319 L 1 .656 0 r
F
P
p
.47254 .3346 m .4993 .34028 L .48569 .34298 L 1 .719 0 r
F
P
p
.45892 .33734 m .47254 .3346 L .48569 .34298 L 1 .844 0 r
F
P
p
.41819 .33439 m .4454 .34007 L .43199 .34277 L 0 1 .417 r
F
P
p
.40477 .33713 m .41819 .33439 L .43199 .34277 L 0 1 .417 r
F
P
p
.002 w
.52293 .62275 m .50907 .68155 L .49615 .67721 L p
0 1 .177 r
F P
0 0 0 r
s
P
p
.002 w
.53669 .61864 m .52293 .62275 L .51003 .67578 L p
.073 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49615 .67721 m .51003 .67578 L .52293 .62275 L p
0 1 .177 r
F P
0 0 0 r
s
P
p
.002 w
.52132 .90519 m .50737 .90572 L .49541 .68293 L p
.208 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.49541 .68293 m .50907 .68155 L .52132 .90519 L p
.208 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.4803 .90461 m .49541 .68293 L .50737 .90572 L p
1 0 .896 r
F P
0 0 0 r
s
P
p
.002 w
.50907 .68155 m .49541 .68293 L .48237 .67863 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.49541 .68293 m .4803 .90461 L .46871 .68004 L p
0 .688 1 r
F P
0 0 0 r
s
P
p
.002 w
.46871 .68004 m .48237 .67863 L .49541 .68293 L p
0 .688 1 r
F P
0 0 0 r
s
P
p
.36381 .33417 m .39146 .33986 L .37825 .34256 L 0 1 .417 r
F
P
p
.3506 .33692 m .36381 .33417 L .37825 .34256 L 0 1 .417 r
F
P
p
.002 w
.46618 .90729 m .45267 .90781 L .43909 .90621 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.42557 .90673 m .43909 .90621 L .45267 .90781 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.75857 .3329 m .78309 .3386 L .76835 .34132 L 1 .104 0 r
F
P
p
.7438 .33566 m .75857 .3329 L .76835 .34132 L 1 .167 0 r
F
P
p
.002 w
.68622 .54925 m .67189 .55361 L .66099 .55023 L p
1 .385 0 r
F P
0 0 0 r
s
P
p
.002 w
.64663 .55462 m .66099 .55023 L .67189 .55361 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.70418 .33268 m .72915 .33839 L .7146 .34111 L 1 .281 0 r
F
P
p
.68961 .33544 m .70418 .33268 L .7146 .34111 L 1 .323 0 r
F
P
p
.64975 .33247 m .67516 .33818 L .66083 .3409 L 1 .281 0 r
F
P
p
.63539 .33523 m .64975 .33247 L .66083 .3409 L 1 .344 0 r
F
P
p
.59529 .33226 m .62115 .33797 L .60702 .34069 L 1 .448 0 r
F
P
p
.58114 .33502 m .59529 .33226 L .60702 .34069 L 1 .542 0 r
F
P
p
.54079 .33204 m .5671 .33776 L .55318 .34049 L 1 .5 0 r
F
P
p
.52686 .33481 m .54079 .33204 L .55318 .34049 L 1 .573 0 r
F
P
p
.48627 .33183 m .51303 .33755 L .4993 .34028 L 1 .615 0 r
F
P
p
.47254 .3346 m .48627 .33183 L .4993 .34028 L 1 .719 0 r
F
P
p
.002 w
.51003 .67578 m .52402 .67434 L .53669 .61864 L p
.073 1 0 r
F P
0 0 0 r
s
P
p
.43171 .33162 m .45892 .33734 L .4454 .34007 L .229 1 0 r
F
P
p
.41819 .33439 m .43171 .33162 L .4454 .34007 L 0 1 .417 r
F
P
p
.002 w
.48237 .67863 m .49615 .67721 L .50907 .68155 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.37712 .3314 m .40477 .33713 L .39146 .33986 L 0 1 .417 r
F
P
p
.36381 .33417 m .37712 .3314 L .39146 .33986 L 0 1 .417 r
F
P
p
.002 w
.63241 .56146 m .61825 .56578 L .60668 .56505 L p
1 .594 0 r
F P
0 0 0 r
s
P
p
.002 w
.5925 .57189 m .60668 .56505 L .61825 .56578 L p
1 .656 0 r
F P
0 0 0 r
s
P
p
.32249 .33119 m .3506 .33692 L .33749 .33965 L 0 1 .417 r
F
P
p
.002 w
.42519 .90457 m .41156 .9051 L .40119 .68133 L p
.208 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.40119 .68133 m .41454 .67994 L .42519 .90457 L p
.208 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38357 .90398 m .40119 .68133 L .41156 .9051 L p
1 0 .896 r
F P
0 0 0 r
s
P
p
.002 w
.41454 .67994 m .40119 .68133 L .38696 .677 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.40119 .68133 m .38357 .90398 L .3736 .67842 L p
0 .688 1 r
F P
0 0 0 r
s
P
p
.002 w
.3736 .67842 m .38696 .677 L .40119 .68133 L p
0 .688 1 r
F P
0 0 0 r
s
P
p
.002 w
.47981 .90677 m .46618 .90729 L .45272 .90568 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.43909 .90621 m .45272 .90568 L .46618 .90729 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7007 .54734 m .68622 .54925 L .67551 .5483 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.66099 .55023 m .67551 .5483 L .68622 .54925 L p
1 .385 0 r
F P
0 0 0 r
s
P
p
.002 w
.42557 .90673 m .41216 .90725 L .39804 .90564 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.77346 .33012 m .79796 .33587 L .78309 .3386 L 1 .063 0 r
F
P
p
.75857 .3329 m .77346 .33012 L .78309 .3386 L 1 .104 0 r
F
P
p
.71885 .3299 m .7438 .33566 L .72915 .33839 L 1 .25 0 r
F
P
p
.70418 .33268 m .71885 .3299 L .72915 .33839 L 1 .281 0 r
F
P
p
.002 w
.56449 .60286 m .55055 .60953 L .53809 .60431 L p
.833 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52402 .67434 m .53809 .60431 L .55055 .60953 L p
.396 1 0 r
F P
0 0 0 r
s
P
p
.66422 .32969 m .68961 .33544 L .67516 .33818 L 1 .24 0 r
F
P
p
.64975 .33247 m .66422 .32969 L .67516 .33818 L 1 .281 0 r
F
P
p
.60955 .32947 m .63539 .33523 L .62115 .33797 L 1 .365 0 r
F
P
p
.59529 .33226 m .60955 .32947 L .62115 .33797 L 1 .448 0 r
F
P
p
.55484 .32926 m .58114 .33502 L .5671 .33776 L 1 .458 0 r
F
P
p
.54079 .33204 m .55484 .32926 L .5671 .33776 L 1 .5 0 r
F
P
p
.50011 .32904 m .52686 .33481 L .51303 .33755 L 1 .542 0 r
F
P
p
.48627 .33183 m .50011 .32904 L .51303 .33755 L 1 .615 0 r
F
P
p
.44534 .32883 m .47254 .3346 L .45892 .33734 L .927 1 0 r
F
P
p
.43171 .33162 m .44534 .32883 L .45892 .33734 L .229 1 0 r
F
P
p
.002 w
.64663 .55462 m .63241 .56146 L .62096 .55816 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.60668 .56505 m .62096 .55816 L .63241 .56146 L p
1 .594 0 r
F P
0 0 0 r
s
P
p
.39053 .32861 m .41819 .33439 L .40477 .33713 L 0 1 .083 r
F
P
p
.37712 .3314 m .39053 .32861 L .40477 .33713 L 0 1 .417 r
F
P
p
.002 w
.45278 .90348 m .46871 .68004 L .4803 .90461 L p
1 0 .896 r
F P
0 0 0 r
s
P
p
.002 w
.48237 .67863 m .46871 .68004 L .45524 .67567 L p
0 1 .135 r
F P
0 0 0 r
s
P
p
.002 w
.46871 .68004 m .45278 .90348 L .44157 .6771 L p
0 .688 1 r
F P
0 0 0 r
s
P
p
.002 w
.44157 .6771 m .45524 .67567 L .46871 .68004 L p
0 .688 1 r
F P
0 0 0 r
s
P
p
.3357 .32839 m .36381 .33417 L .3506 .33692 L 0 1 .417 r
F
P
p
.32249 .33119 m .3357 .32839 L .3506 .33692 L 0 1 .417 r
F
P
p
.002 w
.43893 .90403 m .42519 .90457 L .41454 .67994 L p
.208 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41454 .67994 m .428 .67853 L .43893 .90403 L p
.208 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.428 .67853 m .41454 .67994 L .40042 .67556 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.38696 .677 m .40042 .67556 L .41454 .67994 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.49353 .90625 m .47981 .90677 L .46645 .90515 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.45272 .90568 m .46645 .90515 L .47981 .90677 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.57838 .57372 m .56449 .60286 L .55211 .57742 L p
1 .906 0 r
F P
0 0 0 r
s
P
p
.002 w
.53809 .60431 m .55211 .57742 L .56449 .60286 L p
.833 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71529 .54541 m .7007 .54734 L .69013 .54636 L p
1 .354 0 r
F P
0 0 0 r
s
P
p
.002 w
.67551 .5483 m .69013 .54636 L .7007 .54734 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.43909 .90621 m .42557 .90673 L .41156 .9051 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.39804 .90564 m .41156 .9051 L .42557 .90673 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.78846 .32731 m .81293 .33311 L .79796 .33587 L 1 .052 0 r
F
P
p
.77346 .33012 m .78846 .32731 L .79796 .33587 L 1 .063 0 r
F
P
p
.002 w
.5925 .57189 m .57838 .57372 L .56624 .57056 L p
1 .76 0 r
F P
0 0 0 r
s
P
p
.002 w
.55211 .57742 m .56624 .57056 L .57838 .57372 L p
1 .906 0 r
F P
0 0 0 r
s
P
p
.73365 .3271 m .75857 .3329 L .7438 .33566 L 1 .198 0 r
F
P
p
.71885 .3299 m .73365 .3271 L .7438 .33566 L 1 .25 0 r
F
P
p
.6788 .32688 m .70418 .33268 L .68961 .33544 L 1 .229 0 r
F
P
p
.66422 .32969 m .6788 .32688 L .68961 .33544 L 1 .24 0 r
F
P
p
.62392 .32666 m .64975 .33247 L .63539 .33523 L 1 .313 0 r
F
P
p
.60955 .32947 m .62392 .32666 L .63539 .33523 L 1 .365 0 r
F
P
p
.569 .32645 m .59529 .33226 L .58114 .33502 L 1 .406 0 r
F
P
p
.55484 .32926 m .569 .32645 L .58114 .33502 L 1 .458 0 r
F
P
p
.002 w
.66099 .55023 m .64663 .55462 L .63525 .54621 L p
1 .427 0 r
F P
0 0 0 r
s
P
p
.002 w
.62096 .55816 m .63525 .54621 L .64663 .55462 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.51405 .32623 m .54079 .33204 L .52686 .33481 L 1 .469 0 r
F
P
p
.50011 .32904 m .51405 .32623 L .52686 .33481 L 1 .542 0 r
F
P
p
.45907 .32601 m .48627 .33183 L .47254 .3346 L 1 .885 0 r
F
P
p
.44534 .32883 m .45907 .32601 L .47254 .3346 L .927 1 0 r
F
P
p
.40406 .3258 m .43171 .33162 L .41819 .33439 L .302 1 0 r
F
P
p
.39053 .32861 m .40406 .3258 L .41819 .33439 L 0 1 .083 r
F
P
p
.002 w
.49615 .67721 m .48237 .67863 L .46962 .60589 L p
.146 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45524 .67567 m .46962 .60589 L .48237 .67863 L p
0 1 .135 r
F P
0 0 0 r
s
P
p
.34901 .32558 m .37712 .3314 L .36381 .33417 L 0 1 .417 r
F
P
p
.3357 .32839 m .34901 .32558 L .36381 .33417 L 0 1 .417 r
F
P
p
.002 w
.45278 .90348 m .43893 .90403 L .428 .67853 L p
.208 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.428 .67853 m .44157 .6771 L .45278 .90348 L p
.208 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44157 .6771 m .428 .67853 L .41398 .67412 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.40042 .67556 m .41398 .67412 L .428 .67853 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.38696 .677 m .3736 .67842 L .35891 .67401 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.50737 .90572 m .49353 .90625 L .4803 .90461 L p
1 0 .896 r
F P
0 0 0 r
s
P
p
.002 w
.46645 .90515 m .4803 .90461 L .49353 .90625 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72994 .54097 m .71529 .54541 L .70476 .53937 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.002 w
.69013 .54636 m .70476 .53937 L .71529 .54541 L p
1 .354 0 r
F P
0 0 0 r
s
P
p
.002 w
.45272 .90568 m .43909 .90621 L .42519 .90457 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.41156 .9051 m .42519 .90457 L .43909 .90621 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.80358 .32449 m .82803 .33033 L .81293 .33311 L 1 .021 0 r
F
P
p
.78846 .32731 m .80358 .32449 L .81293 .33311 L 1 .052 0 r
F
P
p
.002 w
.60668 .56505 m .5925 .57189 L .58047 .56618 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.56624 .57056 m .58047 .56618 L .5925 .57189 L p
1 .76 0 r
F P
0 0 0 r
s
P
p
.74856 .32427 m .77346 .33012 L .75857 .3329 L 1 .135 0 r
F
P
p
.73365 .3271 m .74856 .32427 L .75857 .3329 L 1 .198 0 r
F
P
p
.69349 .32405 m .71885 .3299 L .70418 .33268 L 1 .198 0 r
F
P
p
.6788 .32688 m .69349 .32405 L .70418 .33268 L 1 .229 0 r
F
P
p
.6384 .32383 m .66422 .32969 L .64975 .33247 L 1 .24 0 r
F
P
p
.62392 .32666 m .6384 .32383 L .64975 .33247 L 1 .313 0 r
F
P
p
.002 w
.67551 .5483 m .66099 .55023 L .64978 .54425 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.002 w
.63525 .54621 m .64978 .54425 L .66099 .55023 L p
1 .427 0 r
F P
0 0 0 r
s
P
p
.002 w
.46962 .60589 m .48339 .60418 L .49615 .67721 L p
.146 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48339 .60418 m .46962 .60589 L .45643 .56776 L p
.979 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46962 .60589 m .45524 .67567 L .44231 .60233 L p
.563 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44231 .60233 m .45643 .56776 L .46962 .60589 L p
.563 1 0 r
F P
0 0 0 r
s
P
p
.58327 .32362 m .60955 .32947 L .59529 .33226 L 1 .354 0 r
F
P
p
.569 .32645 m .58327 .32362 L .59529 .33226 L 1 .406 0 r
F
P
p
.52811 .3234 m .55484 .32926 L .54079 .33204 L 1 .406 0 r
F
P
p
.51405 .32623 m .52811 .3234 L .54079 .33204 L 1 .469 0 r
F
P
p
.47292 .32318 m .50011 .32904 L .48627 .33183 L 1 .688 0 r
F
P
p
.45907 .32601 m .47292 .32318 L .48627 .33183 L 1 .885 0 r
F
P
p
.41769 .32296 m .44534 .32883 L .43171 .33162 L .667 1 0 r
F
P
p
.40406 .3258 m .41769 .32296 L .43171 .33162 L .302 1 0 r
F
P
p
.002 w
.51003 .67578 m .49615 .67721 L .48339 .60418 L p
.177 1 0 r
F P
0 0 0 r
s
P
p
.36242 .32274 m .39053 .32861 L .37712 .3314 L 0 1 .042 r
F
P
p
.34901 .32558 m .36242 .32274 L .37712 .3314 L 0 1 .417 r
F
P
p
.002 w
.45524 .67567 m .44157 .6771 L .42766 .67266 L p
0 1 .135 r
F P
0 0 0 r
s
P
p
.002 w
.41398 .67412 m .42766 .67266 L .44157 .6771 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.30713 .32252 m .3357 .32839 L .32249 .33119 L 0 1 .417 r
F
P
p
.002 w
.40042 .67556 m .38696 .677 L .37238 .67255 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.35891 .67401 m .37238 .67255 L .38696 .677 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.62096 .55816 m .60668 .56505 L .59476 .5567 L p
1 .615 0 r
F P
0 0 0 r
s
P
p
.002 w
.58047 .56618 m .59476 .5567 L .60668 .56505 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.74469 .5365 m .72994 .54097 L .71954 .53486 L p
1 .271 0 r
F P
0 0 0 r
s
P
p
.002 w
.70476 .53937 m .71954 .53486 L .72994 .54097 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.81883 .32164 m .84324 .32753 L .82803 .33033 L 1 0 0 r
F
P
p
.80358 .32449 m .81883 .32164 L .82803 .33033 L 1 .021 0 r
F
P
p
.002 w
.46645 .90515 m .45272 .90568 L .43893 .90403 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.42519 .90457 m .43893 .90403 L .45272 .90568 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.41156 .9051 m .39804 .90564 L .38357 .90398 L p
1 0 .896 r
F P
0 0 0 r
s
P
p
.76358 .32142 m .78846 .32731 L .77346 .33012 L 1 .115 0 r
F
P
p
.74856 .32427 m .76358 .32142 L .77346 .33012 L 1 .135 0 r
F
P
p
.70831 .3212 m .73365 .3271 L .71885 .3299 L 1 .156 0 r
F
P
p
.69349 .32405 m .70831 .3212 L .71885 .3299 L 1 .198 0 r
F
P
p
.002 w
.55211 .57742 m .53809 .60431 L .52537 .57108 L p
1 .927 0 r
F P
0 0 0 r
s
P
p
.002 w
.53809 .60431 m .52402 .67434 L .51132 .57545 L p
.646 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51132 .57545 m .52537 .57108 L .53809 .60431 L p
.646 1 0 r
F P
0 0 0 r
s
P
p
.653 .32098 m .6788 .32688 L .66422 .32969 L 1 .167 0 r
F
P
p
.6384 .32383 m .653 .32098 L .66422 .32969 L 1 .24 0 r
F
P
p
.002 w
.69013 .54636 m .67551 .5483 L .66438 .53975 L p
1 .396 0 r
F P
0 0 0 r
s
P
p
.002 w
.64978 .54425 m .66438 .53975 L .67551 .5483 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.002 w
.48339 .60418 m .4973 .59489 L .51003 .67578 L p
.177 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4973 .59489 m .48339 .60418 L .47024 .56589 L p
1 .958 0 r
F P
0 0 0 r
s
P
p
.002 w
.47024 .56589 m .48339 .60418 L p
.45995 .57253 L .979 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47024 .56589 m .48422 .55641 L .4973 .59489 L p
1 .958 0 r
F P
0 0 0 r
s
P
p
.002 w
.45643 .56776 m .47024 .56589 L p
.45995 .57253 L .979 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42766 .67266 m .44231 .60233 L .45524 .67567 L p
0 1 .135 r
F P
0 0 0 r
s
P
p
.002 w
.47024 .56589 m .45643 .56776 L .44131 .66509 L p
.76 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45635 .57794 m .47024 .56589 L p
.46774 .57446 L .76 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44131 .66509 m .45635 .57794 L p
.46774 .57446 L .76 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44231 .60233 m .42766 .67266 L .41341 .66811 L p
0 1 .135 r
F P
0 0 0 r
s
P
p
.002 w
.44231 .60233 m .4273 .66661 L p
.45222 .58202 L .281 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45643 .56776 m .45001 .58347 L p
.45222 .58202 L .281 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45001 .58347 m .44231 .60233 L p
.45222 .58202 L .281 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47024 .56589 m .45635 .57794 L p
.48062 .55919 L 1 .844 0 r
F P
0 0 0 r
s
P
p
.002 w
.4273 .66661 m .44131 .66509 L .45643 .56776 L p
.281 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45635 .57794 m .47047 .57092 L .48422 .55641 L p
1 .844 0 r
F P
0 0 0 r
s
P
p
.44467 .5815 m .46717 .57227 L .45635 .57794 L .927 1 0 r
F
P
p
.002 w
.47047 .57092 m .46533 .57348 L p
.46717 .57227 L .927 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46533 .57348 m .45635 .57794 L p
.46717 .57227 L .927 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45635 .57794 m .44214 .58253 L p
.44467 .5815 L .927 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48422 .55641 m .47024 .56589 L p
.48062 .55919 L 1 .844 0 r
F P
0 0 0 r
s
P
p
.59766 .32076 m .62392 .32666 L .60955 .32947 L 1 .333 0 r
F
P
p
.58327 .32362 m .59766 .32076 L .60955 .32947 L 1 .354 0 r
F
P
p
.002 w
.56624 .57056 m .55211 .57742 L .53951 .56161 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.52537 .57108 m .53951 .56161 L .55211 .57742 L p
1 .927 0 r
F P
0 0 0 r
s
P
p
.54228 .32054 m .569 .32645 L .55484 .32926 L 1 .354 0 r
F
P
p
.52811 .3234 m .54228 .32054 L .55484 .32926 L 1 .406 0 r
F
P
p
.48687 .32032 m .51405 .32623 L .50011 .32904 L 1 .563 0 r
F
P
p
.47292 .32318 m .48687 .32032 L .50011 .32904 L 1 .688 0 r
F
P
p
.43142 .3201 m .45907 .32601 L .44534 .32883 L 1 .938 0 r
F
P
p
.41769 .32296 m .43142 .3201 L .44534 .32883 L .667 1 0 r
F
P
p
.002 w
.52402 .67434 m .51003 .67578 L .4973 .59489 L p
.281 1 0 r
F P
0 0 0 r
s
P
p
.37595 .31988 m .40406 .3258 L .39053 .32861 L .667 1 0 r
F
P
p
.36242 .32274 m .37595 .31988 L .39053 .32861 L 0 1 .042 r
F
P
p
.002 w
.63525 .54621 m .62096 .55816 L .60919 .55224 L p
1 .51 0 r
F P
0 0 0 r
s
P
p
.002 w
.59476 .5567 m .60919 .55224 L .62096 .55816 L p
1 .615 0 r
F P
0 0 0 r
s
P
p
.32043 .31966 m .34901 .32558 L .3357 .32839 L 0 1 .417 r
F
P
p
.30713 .32252 m .32043 .31966 L .3357 .32839 L 0 1 .417 r
F
P
p
.002 w
.41398 .67412 m .40042 .67556 L .38594 .67108 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.37238 .67255 m .38594 .67108 L .40042 .67556 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.75939 .52699 m .74469 .5365 L .73443 .53031 L p
1 .219 0 r
F P
0 0 0 r
s
P
p
.002 w
.71954 .53486 m .73443 .53031 L .74469 .5365 L p
1 .271 0 r
F P
0 0 0 r
s
P
p
.002 w
.4803 .90461 m .46645 .90515 L .45278 .90348 L p
1 0 .896 r
F P
0 0 0 r
s
P
p
.002 w
.43893 .90403 m .45278 .90348 L .46645 .90515 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.83419 .31877 m .85858 .32471 L .84324 .32753 L 1 0 0 r
F
P
p
.81883 .32164 m .83419 .31877 L .84324 .32753 L 1 0 0 r
F
P
p
.002 w
.4973 .59489 m .51132 .57545 L .52402 .67434 L p
.281 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51132 .57545 m .4973 .59489 L .48422 .55641 L p
1 .823 0 r
F P
0 0 0 r
s
P
p
.77873 .31855 m .80358 .32449 L .78846 .32731 L 1 .073 0 r
F
P
p
.76358 .32142 m .77873 .31855 L .78846 .32731 L 1 .115 0 r
F
P
p
.72324 .31833 m .74856 .32427 L .73365 .3271 L 1 .104 0 r
F
P
p
.70831 .3212 m .72324 .31833 L .73365 .3271 L 1 .156 0 r
F
P
p
.002 w
.58047 .56618 m .56624 .57056 L .55375 .55463 L p
1 .677 0 r
F P
0 0 0 r
s
P
p
.002 w
.53951 .56161 m .55375 .55463 L .56624 .57056 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.66772 .31811 m .69349 .32405 L .6788 .32688 L 1 .135 0 r
F
P
p
.653 .32098 m .66772 .31811 L .6788 .32688 L 1 .167 0 r
F
P
p
.002 w
.70476 .53937 m .69013 .54636 L .67914 .53775 L p
1 .365 0 r
F P
0 0 0 r
s
P
p
.002 w
.66438 .53975 m .67914 .53775 L .69013 .54636 L p
1 .396 0 r
F P
0 0 0 r
s
P
p
.61216 .31788 m .6384 .32383 L .62392 .32666 L 1 .333 0 r
F
P
p
.59766 .32076 m .61216 .31788 L .62392 .32666 L 1 .333 0 r
F
P
p
.002 w
.64978 .54425 m .63525 .54621 L .62366 .54266 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.002 w
.60919 .55224 m .62366 .54266 L .63525 .54621 L p
1 .51 0 r
F P
0 0 0 r
s
P
p
.002 w
.41341 .66811 m .4273 .66661 L .44231 .60233 L p
0 1 .135 r
F P
0 0 0 r
s
P
p
.55656 .31766 m .58327 .32362 L .569 .32645 L 1 .333 0 r
F
P
p
.54228 .32054 m .55656 .31766 L .569 .32645 L 1 .354 0 r
F
P
p
.002 w
.52537 .57108 m .51132 .57545 L .49824 .55448 L p
1 .719 0 r
F P
0 0 0 r
s
P
p
.002 w
.48422 .55641 m .49824 .55448 L .51132 .57545 L p
1 .823 0 r
F P
0 0 0 r
s
P
p
.50093 .31744 m .52811 .3234 L .51405 .32623 L 1 .469 0 r
F
P
p
.48687 .32032 m .50093 .31744 L .51405 .32623 L 1 .563 0 r
F
P
p
.44527 .31722 m .47292 .32318 L .45907 .32601 L 1 .771 0 r
F
P
p
.43142 .3201 m .44527 .31722 L .45907 .32601 L 1 .938 0 r
F
P
p
.002 w
.77442 .52495 m .75939 .52699 L .74951 .52827 L p
1 .167 0 r
F P
0 0 0 r
s
P
p
.002 w
.73443 .53031 m .74951 .52827 L .75939 .52699 L p
1 .219 0 r
F P
0 0 0 r
s
P
p
.38958 .31699 m .41769 .32296 L .40406 .3258 L 1 .906 0 r
F
P
p
.37595 .31988 m .38958 .31699 L .40406 .3258 L .667 1 0 r
F
P
p
.33385 .31677 m .36242 .32274 L .34901 .32558 L 0 1 .417 r
F
P
p
.32043 .31966 m .33385 .31677 L .34901 .32558 L 0 1 .417 r
F
P
p
.002 w
.42766 .67266 m .41398 .67412 L .39962 .6696 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.38594 .67108 m .39962 .6696 L .41398 .67412 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.37238 .67255 m .35891 .67401 L .34387 .66949 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.84968 .31588 m .87403 .32186 L .85858 .32471 L 1 0 0 r
F
P
p
.83419 .31877 m .84968 .31588 L .85858 .32471 L 1 0 0 r
F
P
p
.002 w
.71954 .53486 m .70476 .53937 L .69396 .53319 L p
1 .323 0 r
F P
0 0 0 r
s
P
p
.002 w
.67914 .53775 m .69396 .53319 L .70476 .53937 L p
1 .365 0 r
F P
0 0 0 r
s
P
p
.794 .31566 m .81883 .32164 L .80358 .32449 L 1 .021 0 r
F
P
p
.77873 .31855 m .794 .31566 L .80358 .32449 L 1 .073 0 r
F
P
p
.002 w
.59476 .5567 m .58047 .56618 L .56808 .54759 L p
1 .615 0 r
F P
0 0 0 r
s
P
p
.002 w
.55375 .55463 m .56808 .54759 L .58047 .56618 L p
1 .677 0 r
F P
0 0 0 r
s
P
p
.73829 .31543 m .76358 .32142 L .74856 .32427 L 1 .063 0 r
F
P
p
.72324 .31833 m .73829 .31543 L .74856 .32427 L 1 .104 0 r
F
P
p
.68255 .31521 m .70831 .3212 L .69349 .32405 L 1 .115 0 r
F
P
p
.66772 .31811 m .68255 .31521 L .69349 .32405 L 1 .135 0 r
F
P
p
.62677 .31498 m .653 .32098 L .6384 .32383 L 1 .313 0 r
F
P
p
.61216 .31788 m .62677 .31498 L .6384 .32383 L 1 .333 0 r
F
P
p
.002 w
.66438 .53975 m .64978 .54425 L .63822 .53303 L p
1 .344 0 r
F P
0 0 0 r
s
P
p
.002 w
.62366 .54266 m .63822 .53303 L .64978 .54425 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.002 w
.53951 .56161 m .52537 .57108 L .5124 .54744 L p
1 .656 0 r
F P
0 0 0 r
s
P
p
.002 w
.49824 .55448 m .5124 .54744 L .52537 .57108 L p
1 .719 0 r
F P
0 0 0 r
s
P
p
.57096 .31476 m .59766 .32076 L .58327 .32362 L 1 .333 0 r
F
P
p
.55656 .31766 m .57096 .31476 L .58327 .32362 L 1 .333 0 r
F
P
p
.51511 .31454 m .54228 .32054 L .52811 .3234 L 1 .406 0 r
F
P
p
.50093 .31744 m .51511 .31454 L .52811 .3234 L 1 .469 0 r
F
P
p
.45923 .31431 m .48687 .32032 L .47292 .32318 L 1 .635 0 r
F
P
p
.44527 .31722 m .45923 .31431 L .47292 .32318 L 1 .771 0 r
F
P
p
.002 w
.78931 .51534 m .77442 .52495 L .76454 .52112 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.002 w
.74951 .52827 m .76454 .52112 L .77442 .52495 L p
1 .167 0 r
F P
0 0 0 r
s
P
p
.40332 .31409 m .43142 .3201 L .41769 .32296 L 1 .771 0 r
F
P
p
.38958 .31699 m .40332 .31409 L .41769 .32296 L 1 .906 0 r
F
P
p
.34737 .31386 m .37595 .31988 L .36242 .32274 L 0 1 .042 r
F
P
p
.33385 .31677 m .34737 .31386 L .36242 .32274 L 0 1 .417 r
F
P
p
.002 w
.39962 .6696 m .41341 .66811 L .42766 .67266 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.29138 .31364 m .32043 .31966 L .30713 .32252 L 0 1 .417 r
F
P
p
.002 w
.38594 .67108 m .37238 .67255 L .35743 .66799 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.34387 .66949 m .35743 .66799 L .37238 .67255 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.60919 .55224 m .59476 .5567 L .58254 .54561 L p
1 .542 0 r
F P
0 0 0 r
s
P
p
.002 w
.56808 .54759 m .58254 .54561 L .59476 .5567 L p
1 .615 0 r
F P
0 0 0 r
s
P
p
.002 w
.73443 .53031 m .71954 .53486 L .70895 .53115 L p
1 .281 0 r
F P
0 0 0 r
s
P
p
.002 w
.69396 .53319 m .70895 .53115 L .71954 .53486 L p
1 .323 0 r
F P
0 0 0 r
s
P
p
.002 w
.49824 .55448 m .48422 .55641 L .47047 .57092 L p
1 .719 0 r
F P
0 0 0 r
s
P
p
.86529 .31296 m .88961 .31899 L .87403 .32186 L 1 0 0 r
F
P
p
.84968 .31588 m .86529 .31296 L .87403 .32186 L 1 0 0 r
F
P
p
.002 w
.55375 .55463 m .53951 .56161 L .52663 .54546 L p
1 .573 0 r
F P
0 0 0 r
s
P
p
.002 w
.5124 .54744 m .52663 .54546 L .53951 .56161 L p
1 .656 0 r
F P
0 0 0 r
s
P
p
.8094 .31274 m .83419 .31877 L .81883 .32164 L 1 0 0 r
F
P
p
.794 .31566 m .8094 .31274 L .81883 .32164 L 1 .021 0 r
F
P
p
.75347 .31251 m .77873 .31855 L .76358 .32142 L 1 .052 0 r
F
P
p
.73829 .31543 m .75347 .31251 L .76358 .32142 L 1 .063 0 r
F
P
p
.002 w
.67914 .53775 m .66438 .53975 L .65291 .52589 L p
1 .281 0 r
F P
0 0 0 r
s
P
p
.002 w
.63822 .53303 m .65291 .52589 L .66438 .53975 L p
1 .344 0 r
F P
0 0 0 r
s
P
p
.6975 .31229 m .72324 .31833 L .70831 .3212 L 1 .083 0 r
F
P
p
.68255 .31521 m .6975 .31229 L .70831 .3212 L 1 .115 0 r
F
P
p
.002 w
.80457 .51324 m .78931 .51534 L .77977 .51647 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.76454 .52112 m .77977 .51647 L .78931 .51534 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.64151 .31206 m .66772 .31811 L .653 .32098 L 1 .271 0 r
F
P
p
.62677 .31498 m .64151 .31206 L .653 .32098 L 1 .313 0 r
F
P
p
.58547 .31184 m .61216 .31788 L .59766 .32076 L 1 .313 0 r
F
P
p
.57096 .31476 m .58547 .31184 L .59766 .32076 L 1 .333 0 r
F
P
p
.52941 .31161 m .55656 .31766 L .54228 .32054 L 1 .375 0 r
F
P
p
.51511 .31454 m .52941 .31161 L .54228 .32054 L 1 .406 0 r
F
P
p
.4733 .31138 m .50093 .31744 L .48687 .32032 L 1 .563 0 r
F
P
p
.45923 .31431 m .4733 .31138 L .48687 .32032 L 1 .635 0 r
F
P
p
.41717 .31116 m .44527 .31722 L .43142 .3201 L 1 .656 0 r
F
P
p
.40332 .31409 m .41717 .31116 L .43142 .3201 L 1 .771 0 r
F
P
p
.361 .31093 m .38958 .31699 L .37595 .31988 L .698 1 0 r
F
P
p
.34737 .31386 m .361 .31093 L .37595 .31988 L 0 1 .042 r
F
P
p
.002 w
.62366 .54266 m .60919 .55224 L .59705 .53594 L p
1 .448 0 r
F P
0 0 0 r
s
P
p
.002 w
.58254 .54561 m .59705 .53594 L .60919 .55224 L p
1 .542 0 r
F P
0 0 0 r
s
P
p
.30479 .3107 m .33385 .31677 L .32043 .31966 L 0 1 .417 r
F
P
p
.29138 .31364 m .30479 .3107 L .32043 .31966 L 0 1 .417 r
F
P
p
.002 w
.39962 .6696 m .38594 .67108 L .37111 .66649 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.35743 .66799 m .37111 .66649 L .38594 .67108 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.74951 .52827 m .73443 .53031 L .72392 .52397 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.70895 .53115 m .72392 .52397 L .73443 .53031 L p
1 .281 0 r
F P
0 0 0 r
s
P
p
.002 w
.56808 .54759 m .55375 .55463 L .54098 .53578 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.52663 .54546 m .54098 .53578 L .55375 .55463 L p
1 .573 0 r
F P
0 0 0 r
s
P
p
.002 w
.5124 .54744 m .49824 .55448 L .48478 .551 L p
1 .615 0 r
F P
0 0 0 r
s
P
p
.002 w
.47047 .57092 m .48478 .551 L .49824 .55448 L p
1 .719 0 r
F P
0 0 0 r
s
P
p
.88103 .31002 m .90532 .3161 L .88961 .31899 L 1 0 0 r
F
P
p
.86529 .31296 m .88103 .31002 L .88961 .31899 L 1 0 0 r
F
P
p
.82491 .3098 m .84968 .31588 L .83419 .31877 L 1 0 0 r
F
P
p
.8094 .31274 m .82491 .3098 L .83419 .31877 L 1 0 0 r
F
P
p
.76876 .30957 m .794 .31566 L .77873 .31855 L 1 .021 0 r
F
P
p
.75347 .31251 m .76876 .30957 L .77873 .31855 L 1 .052 0 r
F
P
p
.002 w
.69396 .53319 m .67914 .53775 L .66765 .51615 L p
1 .24 0 r
F P
0 0 0 r
s
P
p
.002 w
.65291 .52589 m .66765 .51615 L .67914 .53775 L p
1 .281 0 r
F P
0 0 0 r
s
P
p
.71258 .30934 m .73829 .31543 L .72324 .31833 L 1 .047 0 r
F
P
p
.6975 .31229 m .71258 .30934 L .72324 .31833 L 1 .083 0 r
F
P
p
.002 w
.81995 .51113 m .80457 .51324 L .79519 .51435 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.77977 .51647 m .79519 .51435 L .80457 .51324 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.65636 .30911 m .68255 .31521 L .66772 .31811 L 1 .229 0 r
F
P
p
.64151 .31206 m .65636 .30911 L .66772 .31811 L 1 .271 0 r
F
P
p
.6001 .30889 m .62677 .31498 L .61216 .31788 L 1 .292 0 r
F
P
p
.58547 .31184 m .6001 .30889 L .61216 .31788 L 1 .313 0 r
F
P
p
.54381 .30866 m .57096 .31476 L .55656 .31766 L 1 .375 0 r
F
P
p
.52941 .31161 m .54381 .30866 L .55656 .31766 L 1 .375 0 r
F
P
p
.002 w
.63822 .53303 m .62366 .54266 L .61167 .52877 L p
1 .365 0 r
F P
0 0 0 r
s
P
p
.002 w
.59705 .53594 m .61167 .52877 L .62366 .54266 L p
1 .448 0 r
F P
0 0 0 r
s
P
p
.48749 .30843 m .51511 .31454 L .50093 .31744 L 1 .479 0 r
F
P
p
.4733 .31138 m .48749 .30843 L .50093 .31744 L 1 .563 0 r
F
P
p
.43113 .3082 m .45923 .31431 L .44527 .31722 L 1 .563 0 r
F
P
p
.41717 .31116 m .43113 .3082 L .44527 .31722 L 1 .656 0 r
F
P
p
.37474 .30797 m .40332 .31409 L .38958 .31699 L 1 .885 0 r
F
P
p
.361 .31093 m .37474 .30797 L .38958 .31699 L .698 1 0 r
F
P
p
.002 w
.58254 .54561 m .56808 .54759 L .55544 .53374 L p
1 .458 0 r
F P
0 0 0 r
s
P
p
.002 w
.54098 .53578 m .55544 .53374 L .56808 .54759 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.31831 .30775 m .34737 .31386 L .33385 .31677 L 0 1 .417 r
F
P
p
.30479 .3107 m .31831 .30775 L .33385 .31677 L 0 1 .417 r
F
P
p
.002 w
.52663 .54546 m .5124 .54744 L .49905 .54644 L p
1 .542 0 r
F P
0 0 0 r
s
P
p
.002 w
.48478 .551 m .49905 .54644 L .5124 .54744 L p
1 .615 0 r
F P
0 0 0 r
s
P
p
.002 w
.41341 .66811 m .39962 .6696 L .3849 .66497 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.37111 .66649 m .3849 .66497 L .39962 .6696 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.35743 .66799 m .34387 .66949 L .32844 .66486 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.76454 .52112 m .74951 .52827 L .73914 .52188 L p
1 .198 0 r
F P
0 0 0 r
s
P
p
.002 w
.72392 .52397 m .73914 .52188 L .74951 .52827 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.89689 .30706 m .92115 .31319 L .90532 .3161 L 1 0 0 r
F
P
p
.88103 .31002 m .89689 .30706 L .90532 .3161 L 1 0 0 r
F
P
p
.84056 .30683 m .86529 .31296 L .84968 .31588 L 1 0 0 r
F
P
p
.82491 .3098 m .84056 .30683 L .84968 .31588 L 1 0 0 r
F
P
p
.002 w
.70895 .53115 m .69396 .53319 L .68263 .51402 L p
1 .229 0 r
F P
0 0 0 r
s
P
p
.002 w
.66765 .51615 m .68263 .51402 L .69396 .53319 L p
1 .24 0 r
F P
0 0 0 r
s
P
p
.78418 .3066 m .8094 .31274 L .794 .31566 L 1 0 0 r
F
P
p
.76876 .30957 m .78418 .3066 L .794 .31566 L 1 .021 0 r
F
P
p
.002 w
.65291 .52589 m .63822 .53303 L .62645 .52669 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.002 w
.61167 .52877 m .62645 .52669 L .63822 .53303 L p
1 .365 0 r
F P
0 0 0 r
s
P
p
.72778 .30637 m .75347 .31251 L .73829 .31543 L 1 .016 0 r
F
P
p
.71258 .30934 m .72778 .30637 L .73829 .31543 L 1 .047 0 r
F
P
p
.002 w
.83546 .50899 m .81995 .51113 L .81065 .50964 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.002 w
.79519 .51435 m .81065 .50964 L .81995 .51113 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.67133 .30614 m .6975 .31229 L .68255 .31521 L 1 .208 0 r
F
P
p
.65636 .30911 m .67133 .30614 L .68255 .31521 L 1 .229 0 r
F
P
p
.61485 .30591 m .64151 .31206 L .62677 .31498 L 1 .292 0 r
F
P
p
.6001 .30889 m .61485 .30591 L .62677 .31498 L 1 .292 0 r
F
P
p
.55834 .30568 m .58547 .31184 L .57096 .31476 L 1 .354 0 r
F
P
p
.54381 .30866 m .55834 .30568 L .57096 .31476 L 1 .375 0 r
F
P
p
.50179 .30545 m .52941 .31161 L .51511 .31454 L 1 .417 0 r
F
P
p
.48749 .30843 m .50179 .30545 L .51511 .31454 L 1 .479 0 r
F
P
p
.44521 .30522 m .4733 .31138 L .45923 .31431 L 1 .521 0 r
F
P
p
.43113 .3082 m .44521 .30522 L .45923 .31431 L 1 .563 0 r
F
P
p
.38859 .30499 m .41717 .31116 L .40332 .31409 L 1 .802 0 r
F
P
p
.37474 .30797 m .38859 .30499 L .40332 .31409 L 1 .885 0 r
F
P
p
.002 w
.77977 .51647 m .76454 .52112 L .75426 .51204 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.002 w
.73914 .52188 m .75426 .51204 L .76454 .52112 L p
1 .198 0 r
F P
0 0 0 r
s
P
p
.002 w
.59705 .53594 m .58254 .54561 L .56998 .52653 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.002 w
.55544 .53374 m .56998 .52653 L .58254 .54561 L p
1 .458 0 r
F P
0 0 0 r
s
P
p
.33193 .30476 m .361 .31093 L .34737 .31386 L 0 1 .417 r
F
P
p
.31831 .30775 m .33193 .30476 L .34737 .31386 L 0 1 .417 r
F
P
p
.002 w
.54098 .53578 m .52663 .54546 L .51346 .5341 L p
1 .469 0 r
F P
0 0 0 r
s
P
p
.002 w
.49905 .54644 m .51346 .5341 L .52663 .54546 L p
1 .542 0 r
F P
0 0 0 r
s
P
p
.002 w
.4273 .66661 m .41341 .66811 L .3988 .66344 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.3849 .66497 m .3988 .66344 L .41341 .66811 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.27524 .30453 m .30479 .3107 L .29138 .31364 L 0 1 .417 r
F
P
p
.002 w
.37111 .66649 m .35743 .66799 L .34212 .66333 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.32844 .66486 m .34212 .66333 L .35743 .66799 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.45635 .57794 m .44131 .66509 L .42694 .66035 L p
.229 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42694 .66035 m .44214 .58253 L .45635 .57794 L p
.229 1 0 r
F P
0 0 0 r
s
P
p
.89689 .30706 m .91289 .30407 L .92115 .31319 L 1 0 0 r
F
P
p
.002 w
.66765 .51615 m .65291 .52589 L .64136 .5246 L p
1 .24 0 r
F P
0 0 0 r
s
P
p
.002 w
.62645 .52669 m .64136 .5246 L .65291 .52589 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.85633 .30384 m .88103 .31002 L .86529 .31296 L 1 0 0 r
F
P
p
.84056 .30683 m .85633 .30384 L .86529 .31296 L 1 0 0 r
F
P
p
.002 w
.72392 .52397 m .70895 .53115 L .69773 .51188 L p
1 .198 0 r
F P
0 0 0 r
s
P
p
.002 w
.68263 .51402 m .69773 .51188 L .70895 .53115 L p
1 .229 0 r
F P
0 0 0 r
s
P
p
.79973 .30361 m .82491 .3098 L .8094 .31274 L 1 0 0 r
F
P
p
.78418 .3066 m .79973 .30361 L .8094 .31274 L 1 0 0 r
F
P
p
.7431 .30338 m .76876 .30957 L .75347 .31251 L 1 0 0 r
F
P
p
.72778 .30637 m .7431 .30338 L .75347 .31251 L 1 .016 0 r
F
P
p
.002 w
.85109 .50684 m .83546 .50899 L .82611 .50232 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81065 .50964 m .82611 .50232 L .83546 .50899 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.68643 .30315 m .71258 .30934 L .6975 .31229 L 1 .188 0 r
F
P
p
.67133 .30614 m .68643 .30315 L .6975 .31229 L 1 .208 0 r
F
P
p
.62972 .30292 m .65636 .30911 L .64151 .31206 L 1 .292 0 r
F
P
p
.61485 .30591 m .62972 .30292 L .64151 .31206 L 1 .292 0 r
F
P
p
.57298 .30268 m .6001 .30889 L .58547 .31184 L 1 .313 0 r
F
P
p
.55834 .30568 m .57298 .30268 L .58547 .31184 L 1 .354 0 r
F
P
p
.002 w
.61167 .52877 m .59705 .53594 L .58467 .52443 L p
1 .354 0 r
F P
0 0 0 r
s
P
p
.002 w
.56998 .52653 m .58467 .52443 L .59705 .53594 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.51621 .30245 m .54381 .30866 L .52941 .31161 L 1 .396 0 r
F
P
p
.50179 .30545 m .51621 .30245 L .52941 .31161 L 1 .417 0 r
F
P
p
.002 w
.55544 .53374 m .54098 .53578 L .52793 .53203 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.002 w
.51346 .5341 m .52793 .53203 L .54098 .53578 L p
1 .469 0 r
F P
0 0 0 r
s
P
p
.4594 .30222 m .48749 .30843 L .4733 .31138 L 1 .5 0 r
F
P
p
.44521 .30522 m .4594 .30222 L .4733 .31138 L 1 .521 0 r
F
P
p
.002 w
.79519 .51435 m .77977 .51647 L .76971 .50989 L p
1 .115 0 r
F P
0 0 0 r
s
P
p
.002 w
.75426 .51204 m .76971 .50989 L .77977 .51647 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.40255 .30199 m .43113 .3082 L .41717 .31116 L 1 .729 0 r
F
P
p
.38859 .30499 m .40255 .30199 L .41717 .31116 L 1 .802 0 r
F
P
p
.002 w
.48478 .551 m .47047 .57092 L .45644 .57283 L p
1 .885 0 r
F P
0 0 0 r
s
P
p
.002 w
.44214 .58253 m .45644 .57283 L .47047 .57092 L p
.927 1 0 r
F P
0 0 0 r
s
P
p
.34567 .30176 m .37474 .30797 L .361 .31093 L 0 1 .052 r
F
P
p
.33193 .30476 m .34567 .30176 L .361 .31093 L 0 1 .417 r
F
P
p
.002 w
.68263 .51402 m .66765 .51615 L .6563 .51731 L p
1 .167 0 r
F P
0 0 0 r
s
P
p
.002 w
.64136 .5246 m .6563 .51731 L .66765 .51615 L p
1 .24 0 r
F P
0 0 0 r
s
P
p
.002 w
.44131 .66509 m .4273 .66661 L .41281 .6619 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.3988 .66344 m .41281 .6619 L .4273 .66661 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.28875 .30152 m .31831 .30775 L .30479 .3107 L 0 1 .135 r
F
P
p
.27524 .30453 m .28875 .30152 L .30479 .3107 L 0 1 .417 r
F
P
p
.002 w
.3849 .66497 m .37111 .66649 L .3559 .66178 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.34212 .66333 m .3559 .66178 L .37111 .66649 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.73914 .52188 m .72392 .52397 L .71289 .50714 L p
1 .156 0 r
F P
0 0 0 r
s
P
p
.002 w
.69773 .51188 m .71289 .50714 L .72392 .52397 L p
1 .198 0 r
F P
0 0 0 r
s
P
p
.87223 .30083 m .89689 .30706 L .88103 .31002 L 1 0 0 r
F
P
p
.85633 .30384 m .87223 .30083 L .88103 .31002 L 1 0 0 r
F
P
p
.002 w
.49905 .54644 m .48478 .551 L .4709 .55524 L p
1 .688 0 r
F P
0 0 0 r
s
P
p
.002 w
.45644 .57283 m .4709 .55524 L .48478 .551 L p
1 .885 0 r
F P
0 0 0 r
s
P
p
.8154 .30059 m .84056 .30683 L .82491 .3098 L 1 0 0 r
F
P
p
.79973 .30361 m .8154 .30059 L .82491 .3098 L 1 0 0 r
F
P
p
.75854 .30036 m .78418 .3066 L .76876 .30957 L 1 0 0 r
F
P
p
.7431 .30338 m .75854 .30036 L .76876 .30957 L 1 0 0 r
F
P
p
.002 w
.86684 .50468 m .85109 .50684 L .8419 .50012 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82611 .50232 m .8419 .50012 L .85109 .50684 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62645 .52669 m .61167 .52877 L .59947 .52232 L p
1 .333 0 r
F P
0 0 0 r
s
P
p
.002 w
.58467 .52443 m .59947 .52232 L .61167 .52877 L p
1 .354 0 r
F P
0 0 0 r
s
P
p
.70165 .30013 m .72778 .30637 L .71258 .30934 L 1 .161 0 r
F
P
p
.68643 .30315 m .70165 .30013 L .71258 .30934 L 1 .188 0 r
F
P
p
.64472 .29989 m .67133 .30614 L .65636 .30911 L 1 .271 0 r
F
P
p
.62972 .30292 m .64472 .29989 L .65636 .30911 L 1 .292 0 r
F
P
p
.58775 .29966 m .61485 .30591 L .6001 .30889 L 1 .292 0 r
F
P
p
.57298 .30268 m .58775 .29966 L .6001 .30889 L 1 .313 0 r
F
P
p
.53074 .29943 m .55834 .30568 L .54381 .30866 L 1 .375 0 r
F
P
p
.51621 .30245 m .53074 .29943 L .54381 .30866 L 1 .396 0 r
F
P
p
.002 w
.56998 .52653 m .55544 .53374 L .54251 .52216 L p
1 .354 0 r
F P
0 0 0 r
s
P
p
.002 w
.52793 .53203 m .54251 .52216 L .55544 .53374 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.47371 .29919 m .50179 .30545 L .48749 .30843 L 1 .458 0 r
F
P
p
.4594 .30222 m .47371 .29919 L .48749 .30843 L 1 .5 0 r
F
P
p
.002 w
.81065 .50964 m .79519 .51435 L .7852 .50512 L p
1 .073 0 r
F P
0 0 0 r
s
P
p
.002 w
.76971 .50989 m .7852 .50512 L .79519 .51435 L p
1 .115 0 r
F P
0 0 0 r
s
P
p
.41663 .29896 m .44521 .30522 L .43113 .3082 L 1 .667 0 r
F
P
p
.40255 .30199 m .41663 .29896 L .43113 .3082 L 1 .729 0 r
F
P
p
.35952 .29873 m .38859 .30499 L .37474 .30797 L .479 1 0 r
F
P
p
.34567 .30176 m .35952 .29873 L .37474 .30797 L 0 1 .052 r
F
P
p
.002 w
.69773 .51188 m .68263 .51402 L .67135 .50997 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.002 w
.6563 .51731 m .67135 .50997 L .68263 .51402 L p
1 .167 0 r
F P
0 0 0 r
s
P
p
.002 w
.41281 .6619 m .42694 .66035 L .44131 .66509 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.30237 .29849 m .33193 .30476 L .31831 .30775 L .24 1 0 r
F
P
p
.28875 .30152 m .30237 .29849 L .31831 .30775 L 0 1 .135 r
F
P
p
.002 w
.3988 .66344 m .3849 .66497 L .3698 .66023 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.3559 .66178 m .3698 .66023 L .3849 .66497 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.34212 .66333 m .32844 .66486 L .31263 .66011 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.75426 .51204 m .73914 .52188 L .72817 .50236 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.002 w
.71289 .50714 m .72817 .50236 L .73914 .52188 L p
1 .156 0 r
F P
0 0 0 r
s
P
p
.002 w
.51346 .5341 m .49905 .54644 L .48539 .54019 L p
1 .563 0 r
F P
0 0 0 r
s
P
p
.002 w
.4709 .55524 m .48539 .54019 L .49905 .54644 L p
1 .688 0 r
F P
0 0 0 r
s
P
p
.88826 .29779 m .91289 .30407 L .89689 .30706 L 1 0 0 r
F
P
p
.87223 .30083 m .88826 .29779 L .89689 .30706 L 1 0 0 r
F
P
p
.8312 .29755 m .85633 .30384 L .84056 .30683 L 1 0 0 r
F
P
p
.8154 .30059 m .8312 .29755 L .84056 .30683 L 1 0 0 r
F
P
p
.77411 .29732 m .79973 .30361 L .78418 .3066 L 1 0 0 r
F
P
p
.75854 .30036 m .77411 .29732 L .78418 .3066 L 1 0 0 r
F
P
p
.002 w
.88273 .50249 m .86684 .50468 L .85782 .4979 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8419 .50012 m .85782 .4979 L .86684 .50468 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64136 .5246 m .62645 .52669 L .61439 .52019 L p
1 .333 0 r
F P
0 0 0 r
s
P
p
.002 w
.59947 .52232 m .61439 .52019 L .62645 .52669 L p
1 .333 0 r
F P
0 0 0 r
s
P
p
.71699 .29708 m .7431 .30338 L .72778 .30637 L 1 .109 0 r
F
P
p
.70165 .30013 m .71699 .29708 L .72778 .30637 L 1 .161 0 r
F
P
p
.002 w
.58467 .52443 m .56998 .52653 L .5572 .52002 L p
1 .333 0 r
F P
0 0 0 r
s
P
p
.002 w
.54251 .52216 m .5572 .52002 L .56998 .52653 L p
1 .354 0 r
F P
0 0 0 r
s
P
p
.65983 .29685 m .68643 .30315 L .67133 .30614 L 1 .25 0 r
F
P
p
.64472 .29989 m .65983 .29685 L .67133 .30614 L 1 .271 0 r
F
P
p
.60263 .29661 m .62972 .30292 L .61485 .30591 L 1 .292 0 r
F
P
p
.58775 .29966 m .60263 .29661 L .61485 .30591 L 1 .292 0 r
F
P
p
.002 w
.82611 .50232 m .81065 .50964 L .80071 .49773 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.002 w
.7852 .50512 m .80071 .49773 L .81065 .50964 L p
1 .073 0 r
F P
0 0 0 r
s
P
p
.5454 .29638 m .57298 .30268 L .55834 .30568 L 1 .354 0 r
F
P
p
.53074 .29943 m .5454 .29638 L .55834 .30568 L 1 .375 0 r
F
P
p
.48813 .29614 m .51621 .30245 L .50179 .30545 L 1 .417 0 r
F
P
p
.47371 .29919 m .48813 .29614 L .50179 .30545 L 1 .458 0 r
F
P
p
.43083 .29591 m .4594 .30222 L .44521 .30522 L 1 .594 0 r
F
P
p
.41663 .29896 m .43083 .29591 L .44521 .30522 L 1 .667 0 r
F
P
p
.002 w
.76971 .50989 m .75426 .51204 L .74356 .49755 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.72817 .50236 m .74356 .49755 L .75426 .51204 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.002 w
.52793 .53203 m .51346 .5341 L .49992 .5329 L p
1 .469 0 r
F P
0 0 0 r
s
P
p
.002 w
.48539 .54019 m .49992 .5329 L .51346 .5341 L p
1 .563 0 r
F P
0 0 0 r
s
P
p
.37348 .29567 m .40255 .30199 L .38859 .30499 L .865 1 0 r
F
P
p
.35952 .29873 m .37348 .29567 L .38859 .30499 L .479 1 0 r
F
P
p
.002 w
.71289 .50714 m .69773 .51188 L .68655 .50518 L p
1 .115 0 r
F P
0 0 0 r
s
P
p
.002 w
.67135 .50997 m .68655 .50518 L .69773 .51188 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.31611 .29543 m .34567 .30176 L .33193 .30476 L .354 1 0 r
F
P
p
.30237 .29849 m .31611 .29543 L .33193 .30476 L .24 1 0 r
F
P
p
.002 w
.41281 .6619 m .3988 .66344 L .38382 .65866 L p
0 1 .083 r
F P
0 0 0 r
s
P
p
.002 w
.3698 .66023 m .38382 .65866 L .3988 .66344 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.25869 .2952 m .28875 .30152 L .27524 .30453 L 0 1 .417 r
F
P
p
.002 w
.3559 .66178 m .34212 .66333 L .32642 .65854 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.31263 .66011 m .32642 .65854 L .34212 .66333 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.88826 .29779 m .90442 .29472 L .91289 .30407 L 1 0 0 r
F
P
p
.84714 .29449 m .87223 .30083 L .85633 .30384 L 1 0 0 r
F
P
p
.8312 .29755 m .84714 .29449 L .85633 .30384 L 1 0 0 r
F
P
p
.78982 .29425 m .8154 .30059 L .79973 .30361 L 1 0 0 r
F
P
p
.77411 .29732 m .78982 .29425 L .79973 .30361 L 1 0 0 r
F
P
p
.002 w
.89875 .50029 m .88273 .50249 L .87387 .49566 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85782 .4979 m .87387 .49566 L .88273 .50249 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6563 .51731 m .64136 .5246 L .62944 .51804 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.002 w
.61439 .52019 m .62944 .51804 L .64136 .5246 L p
1 .333 0 r
F P
0 0 0 r
s
P
p
.73246 .29401 m .75854 .30036 L .7431 .30338 L 1 .063 0 r
F
P
p
.71699 .29708 m .73246 .29401 L .7431 .30338 L 1 .109 0 r
F
P
p
.002 w
.45644 .57283 m .44214 .58253 L .42803 .55309 L p
1 .938 0 r
F P
0 0 0 r
s
P
p
.002 w
.44214 .58253 m .42694 .66035 L .41381 .55769 L p
.667 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41381 .55769 m .42803 .55309 L .44214 .58253 L p
.667 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.8419 .50012 m .82611 .50232 L .81653 .49548 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80071 .49773 m .81653 .49548 L .82611 .50232 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.002 w
.59947 .52232 m .58467 .52443 L .57202 .51787 L p
1 .333 0 r
F P
0 0 0 r
s
P
p
.002 w
.5572 .52002 m .57202 .51787 L .58467 .52443 L p
1 .333 0 r
F P
0 0 0 r
s
P
p
.67507 .29378 m .70165 .30013 L .68643 .30315 L 1 .219 0 r
F
P
p
.65983 .29685 m .67507 .29378 L .68643 .30315 L 1 .25 0 r
F
P
p
.61764 .29354 m .64472 .29989 L .62972 .30292 L 1 .292 0 r
F
P
p
.60263 .29661 m .61764 .29354 L .62972 .30292 L 1 .292 0 r
F
P
p
.56018 .2933 m .58775 .29966 L .57298 .30268 L 1 .323 0 r
F
P
p
.5454 .29638 m .56018 .2933 L .57298 .30268 L 1 .354 0 r
F
P
p
.50268 .29306 m .53074 .29943 L .51621 .30245 L 1 .396 0 r
F
P
p
.48813 .29614 m .50268 .29306 L .51621 .30245 L 1 .417 0 r
F
P
p
.002 w
.72817 .50236 m .71289 .50714 L .70192 .50296 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.002 w
.70192 .50296 m .71289 .50714 L p
.69318 .50567 L 1 .115 0 r
F P
0 0 0 r
s
P
p
.002 w
.70192 .50296 m .71736 .49811 L .72817 .50236 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.002 w
.70192 .50296 m .69083 .50661 L p
.71078 .50022 L 1 .188 0 r
F P
0 0 0 r
s
P
p
.002 w
.71736 .49811 m .70192 .50296 L p
.71078 .50022 L 1 .188 0 r
F P
0 0 0 r
s
P
p
.002 w
.68655 .50518 m .70192 .50296 L p
.69318 .50567 L 1 .115 0 r
F P
0 0 0 r
s
P
p
.44514 .29283 m .47371 .29919 L .4594 .30222 L 1 .542 0 r
F
P
p
.43083 .29591 m .44514 .29283 L .4594 .30222 L 1 .594 0 r
F
P
p
.002 w
.7852 .50512 m .76971 .50989 L .75915 .49531 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.74356 .49755 m .75915 .49531 L .76971 .50989 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.54251 .52216 m .52793 .53203 L .51455 .52294 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.002 w
.49992 .5329 m .51455 .52294 L .52793 .53203 L p
1 .469 0 r
F P
0 0 0 r
s
P
p
.38756 .29259 m .41663 .29896 L .40255 .30199 L 1 .875 0 r
F
P
p
.37348 .29567 m .38756 .29259 L .40255 .30199 L .865 1 0 r
F
P
p
.32995 .29235 m .35952 .29873 L .34567 .30176 L .396 1 0 r
F
P
p
.31611 .29543 m .32995 .29235 L .34567 .30176 L .354 1 0 r
F
P
p
.002 w
.42694 .66035 m .41281 .6619 L .3995 .57268 L p
.302 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.38382 .65866 m .3995 .57268 L .41281 .6619 L p
0 1 .083 r
F P
0 0 0 r
s
P
p
.27231 .29211 m .30237 .29849 L .28875 .30152 L 0 1 .135 r
F
P
p
.25869 .2952 m .27231 .29211 L .28875 .30152 L 0 1 .417 r
F
P
p
.002 w
.3698 .66023 m .3559 .66178 L .34031 .65696 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.32642 .65854 m .34031 .65696 L .3559 .66178 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.4709 .55524 m .45644 .57283 L .44249 .53797 L p
1 .771 0 r
F P
0 0 0 r
s
P
p
.002 w
.42803 .55309 m .44249 .53797 L .45644 .57283 L p
1 .938 0 r
F P
0 0 0 r
s
P
p
.002 w
.67135 .50997 m .6563 .51731 L .64461 .51587 L p
1 .271 0 r
F P
0 0 0 r
s
P
p
.002 w
.62944 .51804 m .64461 .51587 L .6563 .51731 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.8632 .2914 m .88826 .29779 L .87223 .30083 L 1 0 0 r
F
P
p
.84714 .29449 m .8632 .2914 L .87223 .30083 L 1 0 0 r
F
P
p
.002 w
.3995 .57268 m .41381 .55769 L .42694 .66035 L p
.302 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41381 .55769 m .3995 .57268 L .38467 .55618 L p
1 .906 0 r
F P
0 0 0 r
s
P
p
.002 w
.3995 .57268 m .38382 .65866 L .3706 .55817 L p
.667 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3706 .55817 m .38467 .55618 L .3995 .57268 L p
.667 1 0 r
F P
0 0 0 r
s
P
p
.80565 .29116 m .8312 .29755 L .8154 .30059 L 1 0 0 r
F
P
p
.78982 .29425 m .80565 .29116 L .8154 .30059 L 1 0 0 r
F
P
p
.002 w
.91489 .49807 m .89875 .50029 L .89005 .4934 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.87387 .49566 m .89005 .4934 L .89875 .50029 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.74806 .29092 m .77411 .29732 L .75854 .30036 L 1 .063 0 r
F
P
p
.73246 .29401 m .74806 .29092 L .75854 .30036 L 1 .063 0 r
F
P
p
.002 w
.85782 .4979 m .8419 .50012 L .83248 .49322 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81653 .49548 m .83248 .49322 L .8419 .50012 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.61439 .52019 m .59947 .52232 L .58695 .51571 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.002 w
.57202 .51787 m .58695 .51571 L .59947 .52232 L p
1 .333 0 r
F P
0 0 0 r
s
P
p
.69044 .29068 m .71699 .29708 L .70165 .30013 L 1 .177 0 r
F
P
p
.67507 .29378 m .69044 .29068 L .70165 .30013 L 1 .219 0 r
F
P
p
.002 w
.5572 .52002 m .54251 .52216 L .52926 .52079 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.51455 .52294 m .52926 .52079 L .54251 .52216 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.63277 .29044 m .65983 .29685 L .64472 .29989 L 1 .229 0 r
F
P
p
.61764 .29354 m .63277 .29044 L .64472 .29989 L 1 .292 0 r
F
P
p
.57508 .2902 m .60263 .29661 L .58775 .29966 L 1 .302 0 r
F
P
p
.56018 .2933 m .57508 .2902 L .58775 .29966 L 1 .323 0 r
F
P
p
.002 w
.48539 .54019 m .4709 .55524 L .45693 .53063 L p
1 .635 0 r
F P
0 0 0 r
s
P
p
.002 w
.44249 .53797 m .45693 .53063 L .4709 .55524 L p
1 .771 0 r
F P
0 0 0 r
s
P
p
.002 w
.74356 .49755 m .72817 .50236 L .71736 .49811 L p
1 .047 0 r
F P
0 0 0 r
s
P
p
.002 w
.80071 .49773 m .7852 .50512 L .77487 .49305 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.002 w
.75915 .49531 m .77487 .49305 L .7852 .50512 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.51734 .28996 m .5454 .29638 L .53074 .29943 L 1 .375 0 r
F
P
p
.50268 .29306 m .51734 .28996 L .53074 .29943 L 1 .396 0 r
F
P
p
.45957 .28972 m .48813 .29614 L .47371 .29919 L 1 .531 0 r
F
P
p
.44514 .29283 m .45957 .28972 L .47371 .29919 L 1 .542 0 r
F
P
p
.002 w
.42803 .55309 m .41381 .55769 L .39905 .54361 L p
1 .771 0 r
F P
0 0 0 r
s
P
p
.002 w
.38467 .55618 m .39905 .54361 L .41381 .55769 L p
1 .906 0 r
F P
0 0 0 r
s
P
p
.40176 .28948 m .43083 .29591 L .41663 .29896 L 1 .792 0 r
F
P
p
.38756 .29259 m .40176 .28948 L .41663 .29896 L 1 .875 0 r
F
P
p
.34392 .28924 m .37348 .29567 L .35952 .29873 L .573 1 0 r
F
P
p
.32995 .29235 m .34392 .28924 L .35952 .29873 L .396 1 0 r
F
P
p
.28603 .289 m .31611 .29543 L .30237 .29849 L .24 1 0 r
F
P
p
.27231 .29211 m .28603 .289 L .30237 .29849 L 0 1 .135 r
F
P
p
.002 w
.68655 .50518 m .67135 .50997 L .6599 .51369 L p
1 .229 0 r
F P
0 0 0 r
s
P
p
.002 w
.64461 .51587 m .6599 .51369 L .67135 .50997 L p
1 .271 0 r
F P
0 0 0 r
s
P
p
.002 w
.38382 .65866 m .3698 .66023 L .35432 .65536 L p
0 1 .042 r
F P
0 0 0 r
s
P
p
.002 w
.34031 .65696 m .35432 .65536 L .3698 .66023 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.32642 .65854 m .31263 .66011 L .29642 .65524 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.49992 .5329 m .48539 .54019 L .47142 .52851 L p
1 .563 0 r
F P
0 0 0 r
s
P
p
.002 w
.45693 .53063 m .47142 .52851 L .48539 .54019 L p
1 .635 0 r
F P
0 0 0 r
s
P
p
.8794 .28828 m .90442 .29472 L .88826 .29779 L 1 0 0 r
F
P
p
.8632 .2914 m .8794 .28828 L .88826 .29779 L 1 0 0 r
F
P
p
.82161 .28804 m .84714 .29449 L .8312 .29755 L 1 0 0 r
F
P
p
.80565 .29116 m .82161 .28804 L .8312 .29755 L 1 0 0 r
F
P
p
.002 w
.93117 .49583 m .91489 .49807 L .90637 .49112 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.89005 .4934 m .90637 .49112 L .91489 .49807 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.76379 .2878 m .78982 .29425 L .77411 .29732 L 1 .063 0 r
F
P
p
.74806 .29092 m .76379 .2878 L .77411 .29732 L 1 .063 0 r
F
P
p
.002 w
.87387 .49566 m .85782 .4979 L .84856 .49094 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83248 .49322 m .84856 .49094 L .85782 .4979 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62944 .51804 m .61439 .52019 L .60197 .50826 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.58695 .51571 m .60197 .50826 L .61439 .52019 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.70593 .28756 m .73246 .29401 L .71699 .29708 L 1 .125 0 r
F
P
p
.69044 .29068 m .70593 .28756 L .71699 .29708 L 1 .177 0 r
F
P
p
.002 w
.81653 .49548 m .80071 .49773 L .79072 .49077 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77487 .49305 m .79072 .49077 L .80071 .49773 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.002 w
.57202 .51787 m .5572 .52002 L .5441 .51862 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.52926 .52079 m .5441 .51862 L .5572 .52002 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.64803 .28731 m .67507 .29378 L .65983 .29685 L 1 .167 0 r
F
P
p
.63277 .29044 m .64803 .28731 L .65983 .29685 L 1 .229 0 r
F
P
p
.002 w
.75915 .49531 m .74356 .49755 L .73295 .49453 L p
1 .016 0 r
F P
0 0 0 r
s
P
p
.002 w
.73295 .49453 m .74356 .49755 L p
.72395 .49797 L 1 .047 0 r
F P
0 0 0 r
s
P
p
.002 w
.73295 .49453 m .74858 .48829 L .75915 .49531 L p
1 .016 0 r
F P
0 0 0 r
s
P
p
.002 w
.73295 .49453 m .72225 .49942 L p
.74205 .49105 L 1 .109 0 r
F P
0 0 0 r
s
P
p
.002 w
.74858 .48829 m .73295 .49453 L p
.74205 .49105 L 1 .109 0 r
F P
0 0 0 r
s
P
p
.002 w
.71736 .49811 m .73295 .49453 L p
.72395 .49797 L 1 .047 0 r
F P
0 0 0 r
s
P
p
.5901 .28707 m .61764 .29354 L .60263 .29661 L 1 .281 0 r
F
P
p
.57508 .2902 m .5901 .28707 L .60263 .29661 L 1 .302 0 r
F
P
p
.53213 .28683 m .56018 .2933 L .5454 .29638 L 1 .375 0 r
F
P
p
.51734 .28996 m .53213 .28683 L .5454 .29638 L 1 .375 0 r
F
P
p
.002 w
.44249 .53797 m .42803 .55309 L .41347 .53362 L p
1 .656 0 r
F P
0 0 0 r
s
P
p
.002 w
.39905 .54361 m .41347 .53362 L .42803 .55309 L p
1 .771 0 r
F P
0 0 0 r
s
P
p
.47412 .28659 m .50268 .29306 L .48813 .29614 L 1 .51 0 r
F
P
p
.45957 .28972 m .47412 .28659 L .48813 .29614 L 1 .531 0 r
F
P
p
.41608 .28635 m .44514 .29283 L .43083 .29591 L 1 .688 0 r
F
P
p
.40176 .28948 m .41608 .28635 L .43083 .29591 L 1 .792 0 r
F
P
p
.35799 .28611 m .38756 .29259 L .37348 .29567 L .948 1 0 r
F
P
p
.34392 .28924 m .35799 .28611 L .37348 .29567 L .573 1 0 r
F
P
p
.002 w
.70192 .50296 m .68655 .50518 L .67528 .50885 L p
1 .208 0 r
F P
0 0 0 r
s
P
p
.002 w
.67528 .50885 m .68655 .50518 L p
.66374 .51246 L 1 .229 0 r
F P
0 0 0 r
s
P
p
.002 w
.67528 .50885 m .6634 .49658 L p
.68693 .50519 L 1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.67528 .50885 m .69083 .50661 L .70192 .50296 L p
1 .208 0 r
F P
0 0 0 r
s
P
p
.002 w
.69083 .50661 m .67528 .50885 L p
.68693 .50519 L 1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.6599 .51369 m .67528 .50885 L p
.66374 .51246 L 1 .229 0 r
F P
0 0 0 r
s
P
p
.002 w
.35432 .65536 m .3706 .55817 L .38382 .65866 L p
0 1 .042 r
F P
0 0 0 r
s
P
p
.002 w
.3706 .55817 m .35432 .65536 L .33844 .65037 L p
0 1 .042 r
F P
0 0 0 r
s
P
p
.002 w
.38467 .55618 m .3706 .55817 L .35269 .64872 L p
.698 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33844 .65037 m .35269 .64872 L .3706 .55817 L p
0 1 .042 r
F P
0 0 0 r
s
P
p
.29987 .28586 m .32995 .29235 L .31611 .29543 L .354 1 0 r
F
P
p
.28603 .289 m .29987 .28586 L .31611 .29543 L .24 1 0 r
F
P
p
.002 w
.51455 .52294 m .49992 .5329 L .48604 .52637 L p
1 .479 0 r
F P
0 0 0 r
s
P
p
.002 w
.47142 .52851 m .48604 .52637 L .49992 .5329 L p
1 .563 0 r
F P
0 0 0 r
s
P
p
.24172 .28562 m .27231 .29211 L .25869 .2952 L 0 1 .417 r
F
P
p
.002 w
.34031 .65696 m .32642 .65854 L .31031 .65363 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.29642 .65524 m .31031 .65363 L .32642 .65854 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.8794 .28828 m .89573 .28514 L .90442 .29472 L 1 0 0 r
F
P
p
.002 w
.45693 .53063 m .44249 .53797 L .42794 .52621 L p
1 .563 0 r
F P
0 0 0 r
s
P
p
.002 w
.41347 .53362 m .42794 .52621 L .44249 .53797 L p
1 .656 0 r
F P
0 0 0 r
s
P
p
.83771 .28489 m .8632 .2914 L .84714 .29449 L 1 0 0 r
F
P
p
.82161 .28804 m .83771 .28489 L .84714 .29449 L 1 0 0 r
F
P
p
.002 w
.90637 .49112 m .92283 .48882 L .93117 .49583 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.77965 .28465 m .80565 .29116 L .78982 .29425 L 1 .031 0 r
F
P
p
.76379 .2878 m .77965 .28465 L .78982 .29425 L 1 .063 0 r
F
P
p
.002 w
.89005 .4934 m .87387 .49566 L .86478 .48864 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84856 .49094 m .86478 .48864 L .87387 .49566 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64461 .51587 m .62944 .51804 L .61714 .50603 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.60197 .50826 m .61714 .50603 L .62944 .51804 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.72155 .28441 m .74806 .29092 L .73246 .29401 L 1 .073 0 r
F
P
p
.70593 .28756 m .72155 .28441 L .73246 .29401 L 1 .125 0 r
F
P
p
.002 w
.83248 .49322 m .81653 .49548 L .8067 .48847 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79072 .49077 m .8067 .48847 L .81653 .49548 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58695 .51571 m .57202 .51787 L .55906 .51644 L p
1 .354 0 r
F P
0 0 0 r
s
P
p
.002 w
.5441 .51862 m .55906 .51644 L .57202 .51787 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.66342 .28416 m .69044 .29068 L .67507 .29378 L 1 .146 0 r
F
P
p
.64803 .28731 m .66342 .28416 L .67507 .29378 L 1 .167 0 r
F
P
p
.002 w
.77487 .49305 m .75915 .49531 L .74858 .48829 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60525 .28392 m .63277 .29044 L .61764 .29354 L 1 .271 0 r
F
P
p
.5901 .28707 m .60525 .28392 L .61764 .29354 L 1 .281 0 r
F
P
p
.54704 .28368 m .57508 .2902 L .56018 .2933 L 1 .344 0 r
F
P
p
.53213 .28683 m .54704 .28368 L .56018 .2933 L 1 .375 0 r
F
P
p
.48879 .28343 m .51734 .28996 L .50268 .29306 L 1 .49 0 r
F
P
p
.47412 .28659 m .48879 .28343 L .50268 .29306 L 1 .51 0 r
F
P
p
.002 w
.52926 .52079 m .51455 .52294 L .50082 .51627 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.002 w
.48604 .52637 m .50082 .51627 L .51455 .52294 L p
1 .479 0 r
F P
0 0 0 r
s
P
p
.43051 .28319 m .45957 .28972 L .44514 .29283 L 1 .604 0 r
F
P
p
.41608 .28635 m .43051 .28319 L .44514 .29283 L 1 .688 0 r
F
P
p
.37219 .28294 m .40176 .28948 L .38756 .29259 L 1 .781 0 r
F
P
p
.35799 .28611 m .37219 .28294 L .38756 .29259 L .948 1 0 r
F
P
p
.002 w
.39905 .54361 m .38467 .55618 L .36919 .55259 L p
1 .885 0 r
F P
0 0 0 r
s
P
p
.002 w
.35269 .64872 m .36919 .55259 L .38467 .55618 L p
.698 1 0 r
F P
0 0 0 r
s
P
p
.31383 .2827 m .34392 .28924 L .32995 .29235 L .677 1 0 r
F
P
p
.29987 .28586 m .31383 .2827 L .32995 .29235 L .354 1 0 r
F
P
p
.25544 .28246 m .28603 .289 L .27231 .29211 L 0 1 .417 r
F
P
p
.24172 .28562 m .25544 .28246 L .27231 .29211 L 0 1 .417 r
F
P
p
.002 w
.47142 .52851 m .45693 .53063 L .44244 .52405 L p
1 .521 0 r
F P
0 0 0 r
s
P
p
.002 w
.42794 .52621 m .44244 .52405 L p
.43627 .52748 L 1 .563 0 r
F P
0 0 0 r
s
P
p
.002 w
.44244 .52405 m .42794 .52621 L .41263 .5383 L p
1 .667 0 r
F P
0 0 0 r
s
P
p
.002 w
.44244 .52405 m .42737 .53076 L p
.44869 .52058 L 1 .594 0 r
F P
0 0 0 r
s
P
p
.002 w
.45712 .51655 m .44244 .52405 L p
.44869 .52058 L 1 .594 0 r
F P
0 0 0 r
s
P
p
.002 w
.44244 .52405 m .45693 .53063 L p
.43627 .52748 L 1 .563 0 r
F P
0 0 0 r
s
P
p
.002 w
.35432 .65536 m .34031 .65696 L .32432 .652 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.31031 .65363 m .32432 .652 L .34031 .65696 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.85394 .28172 m .8794 .28828 L .8632 .2914 L 1 0 0 r
F
P
p
.83771 .28489 m .85394 .28172 L .8632 .2914 L 1 0 0 r
F
P
p
.79564 .28148 m .82161 .28804 L .80565 .29116 L 1 0 0 r
F
P
p
.77965 .28465 m .79564 .28148 L .80565 .29116 L 1 .031 0 r
F
P
p
.002 w
.90637 .49112 m .89005 .4934 L .88114 .48633 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.86478 .48864 m .88114 .48633 L .89005 .4934 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6599 .51369 m .64461 .51587 L .63245 .50379 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.61714 .50603 m .63245 .50379 L .64461 .51587 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.73731 .28123 m .76379 .2878 L .74806 .29092 L 1 .063 0 r
F
P
p
.72155 .28441 m .73731 .28123 L .74806 .29092 L 1 .073 0 r
F
P
p
.002 w
.84856 .49094 m .83248 .49322 L .82282 .48615 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8067 .48847 m .82282 .48615 L .83248 .49322 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60197 .50826 m .58695 .51571 L .57412 .50892 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.002 w
.55906 .51644 m .57412 .50892 L .58695 .51571 L p
1 .354 0 r
F P
0 0 0 r
s
P
p
.67894 .28099 m .70593 .28756 L .69044 .29068 L 1 .115 0 r
F
P
p
.66342 .28416 m .67894 .28099 L .69044 .29068 L 1 .146 0 r
F
P
p
.002 w
.79072 .49077 m .77487 .49305 L .76446 .48597 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74858 .48829 m .76446 .48597 L .77487 .49305 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.62053 .28074 m .64803 .28731 L .63277 .29044 L 1 .208 0 r
F
P
p
.60525 .28392 m .62053 .28074 L .63277 .29044 L 1 .271 0 r
F
P
p
.002 w
.41347 .53362 m .39905 .54361 L .38356 .54786 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.36919 .55259 m .38356 .54786 L .39905 .54361 L p
1 .885 0 r
F P
0 0 0 r
s
P
p
.56208 .2805 m .5901 .28707 L .57508 .2902 L 1 .302 0 r
F
P
p
.54704 .28368 m .56208 .2805 L .57508 .2902 L 1 .344 0 r
F
P
p
.50359 .28025 m .53213 .28683 L .51734 .28996 L 1 .479 0 r
F
P
p
.48879 .28343 m .50359 .28025 L .51734 .28996 L 1 .49 0 r
F
P
p
.002 w
.5441 .51862 m .52926 .52079 L .51566 .51406 L p
1 .396 0 r
F P
0 0 0 r
s
P
p
.002 w
.50082 .51627 m .51566 .51406 L .52926 .52079 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.002 w
.73295 .49453 m .71736 .49811 L .70644 .5017 L p
1 .161 0 r
F P
0 0 0 r
s
P
p
.002 w
.70644 .5017 m .71736 .49811 L p
.69417 .50554 L 1 .188 0 r
F P
0 0 0 r
s
P
p
.002 w
.70644 .5017 m .69479 .48656 L p
.71884 .49783 L 1 .177 0 r
F P
0 0 0 r
s
P
p
.002 w
.70644 .5017 m .72225 .49942 L .73295 .49453 L p
1 .161 0 r
F P
0 0 0 r
s
P
p
.002 w
.72225 .49942 m .70644 .5017 L p
.71884 .49783 L 1 .177 0 r
F P
0 0 0 r
s
P
p
.002 w
.69083 .50661 m .70644 .5017 L p
.69417 .50554 L 1 .188 0 r
F P
0 0 0 r
s
P
p
.44507 .28 m .47412 .28659 L .45957 .28972 L 1 .563 0 r
F
P
p
.43051 .28319 m .44507 .28 L .45957 .28972 L 1 .604 0 r
F
P
p
.38651 .27976 m .41608 .28635 L .40176 .28948 L 1 .708 0 r
F
P
p
.37219 .28294 m .38651 .27976 L .40176 .28948 L 1 .781 0 r
F
P
p
.32791 .27951 m .35799 .28611 L .34392 .28924 L 1 .927 0 r
F
P
p
.31383 .2827 m .32791 .27951 L .34392 .28924 L .677 1 0 r
F
P
p
.26927 .27926 m .29987 .28586 L .28603 .289 L 0 1 .417 r
F
P
p
.25544 .28246 m .26927 .27926 L .28603 .289 L 0 1 .417 r
F
P
p
.002 w
.48604 .52637 m .47142 .52851 L .45712 .51655 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.44244 .52405 m .45712 .51655 L .47142 .52851 L p
1 .521 0 r
F P
0 0 0 r
s
P
p
.002 w
.32432 .652 m .33844 .65037 L .35432 .65536 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.31031 .65363 m .29642 .65524 L .27978 .65024 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.87031 .27852 m .89573 .28514 L .8794 .28828 L 1 0 0 r
F
P
p
.85394 .28172 m .87031 .27852 L .8794 .28828 L 1 0 0 r
F
P
p
.002 w
.61714 .50603 m .60197 .50826 L .58932 .50668 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.57412 .50892 m .58932 .50668 L .60197 .50826 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.002 w
.42794 .52621 m .41347 .53362 L .39799 .54578 L p
1 .729 0 r
F P
0 0 0 r
s
P
p
.002 w
.38356 .54786 m .39799 .54578 L .41347 .53362 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.81177 .27828 m .83771 .28489 L .82161 .28804 L 1 0 0 r
F
P
p
.79564 .28148 m .81177 .27828 L .82161 .28804 L 1 0 0 r
F
P
p
.002 w
.92283 .48882 m .90637 .49112 L .89763 .48399 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.88114 .48633 m .89763 .48399 L .90637 .49112 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67528 .50885 m .6599 .51369 L .64788 .50153 L p
1 .271 0 r
F P
0 0 0 r
s
P
p
.002 w
.63245 .50379 m .64788 .50153 L .6599 .51369 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.7532 .27803 m .77965 .28465 L .76379 .2878 L 1 .063 0 r
F
P
p
.73731 .28123 m .7532 .27803 L .76379 .2878 L 1 .063 0 r
F
P
p
.002 w
.86478 .48864 m .84856 .49094 L .83907 .48381 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82282 .48615 m .83907 .48381 L .84856 .49094 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69458 .27778 m .72155 .28441 L .70593 .28756 L 1 .073 0 r
F
P
p
.67894 .28099 m .69458 .27778 L .70593 .28756 L 1 .115 0 r
F
P
p
.002 w
.8067 .48847 m .79072 .49077 L .78047 .48363 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76446 .48597 m .78047 .48363 L .79072 .49077 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.63593 .27753 m .66342 .28416 L .64803 .28731 L 1 .135 0 r
F
P
p
.62053 .28074 m .63593 .27753 L .64803 .28731 L 1 .208 0 r
F
P
p
.57724 .27729 m .60525 .28392 L .5901 .28707 L 1 .281 0 r
F
P
p
.56208 .2805 m .57724 .27729 L .5901 .28707 L 1 .302 0 r
F
P
p
.51851 .27704 m .54704 .28368 L .53213 .28683 L 1 .458 0 r
F
P
p
.50359 .28025 m .51851 .27704 L .53213 .28683 L 1 .479 0 r
F
P
p
.002 w
.55906 .51644 m .5441 .51862 L .53064 .5065 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.51566 .51406 m .53064 .5065 L .5441 .51862 L p
1 .396 0 r
F P
0 0 0 r
s
P
p
.45975 .27679 m .48879 .28343 L .47412 .28659 L 1 .521 0 r
F
P
p
.44507 .28 m .45975 .27679 L .47412 .28659 L 1 .563 0 r
F
P
p
.40094 .27654 m .43051 .28319 L .41608 .28635 L 1 .656 0 r
F
P
p
.38651 .27976 m .40094 .27654 L .41608 .28635 L 1 .708 0 r
F
P
p
.3421 .27629 m .37219 .28294 L .35799 .28611 L 1 .792 0 r
F
P
p
.32791 .27951 m .3421 .27629 L .35799 .28611 L 1 .927 0 r
F
P
p
.28322 .27605 m .31383 .2827 L .29987 .28586 L 0 1 .104 r
F
P
p
.26927 .27926 m .28322 .27605 L .29987 .28586 L 0 1 .417 r
F
P
p
.002 w
.50082 .51627 m .48604 .52637 L .47185 .51434 L p
1 .458 0 r
F P
0 0 0 r
s
P
p
.002 w
.45712 .51655 m .47185 .51434 L p
.46128 .51796 L 1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.44225 .52047 m .45712 .51655 L p
.4402 .52463 L 1 .594 0 r
F P
0 0 0 r
s
P
p
.002 w
.42737 .53076 m .44225 .52047 L p
.4402 .52463 L 1 .594 0 r
F P
0 0 0 r
s
P
p
.002 w
.44225 .52047 m .4271 .51354 L p
.44433 .51623 L 1 .604 0 r
F P
0 0 0 r
s
P
p
.002 w
.47185 .51434 m .45712 .51655 L .44225 .52047 L p
1 .542 0 r
F P
0 0 0 r
s
P
p
.002 w
.44225 .52047 m .45714 .51824 L .47185 .51434 L p
1 .542 0 r
F P
0 0 0 r
s
P
p
.002 w
.45714 .51824 m .44225 .52047 L p
.44433 .51623 L 1 .604 0 r
F P
0 0 0 r
s
P
p
.002 w
.47185 .51434 m .45714 .51824 L p
.48254 .51067 L 1 .531 0 r
F P
0 0 0 r
s
P
p
.002 w
.48673 .50942 m .47185 .51434 L p
.48254 .51067 L 1 .531 0 r
F P
0 0 0 r
s
P
p
.002 w
.47185 .51434 m .48604 .52637 L p
.46128 .51796 L 1 .5 0 r
F P
0 0 0 r
s
P
p
.2243 .2758 m .25544 .28246 L .24172 .28562 L 0 1 .417 r
F
P
p
.002 w
.39799 .54578 m .41263 .5383 L .42794 .52621 L p
1 .729 0 r
F P
0 0 0 r
s
P
p
.002 w
.32432 .652 m .31031 .65363 L .29378 .64859 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.27978 .65024 m .29378 .64859 L .31031 .65363 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.87031 .27852 m .88682 .2753 L .89573 .28514 L 1 0 0 r
F
P
p
.002 w
.63245 .50379 m .61714 .50603 L .60465 .50442 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.58932 .50668 m .60465 .50442 L .61714 .50603 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.64788 .50153 m .6634 .49658 L .67528 .50885 L p
1 .271 0 r
F P
0 0 0 r
s
P
p
.82804 .27505 m .85394 .28172 L .83771 .28489 L 1 0 0 r
F
P
p
.81177 .27828 m .82804 .27505 L .83771 .28489 L 1 0 0 r
F
P
p
.002 w
.89763 .48399 m .91426 .48163 L .92283 .48882 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.76922 .2748 m .79564 .28148 L .77965 .28465 L 1 .031 0 r
F
P
p
.7532 .27803 m .76922 .2748 L .77965 .28465 L 1 .063 0 r
F
P
p
.002 w
.88114 .48633 m .86478 .48864 L .85546 .48145 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83907 .48381 m .85546 .48145 L .86478 .48864 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.71036 .27455 m .73731 .28123 L .72155 .28441 L 1 .021 0 r
F
P
p
.69458 .27778 m .71036 .27455 L .72155 .28441 L 1 .073 0 r
F
P
p
.002 w
.82282 .48615 m .8067 .48847 L .79662 .48127 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78047 .48363 m .79662 .48127 L .8067 .48847 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.65147 .2743 m .67894 .28099 L .66342 .28416 L 1 .125 0 r
F
P
p
.63593 .27753 m .65147 .2743 L .66342 .28416 L 1 .135 0 r
F
P
p
.002 w
.76446 .48597 m .74858 .48829 L .73796 .4891 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.72225 .49942 m .73796 .4891 L .74858 .48829 L p
1 .109 0 r
F P
0 0 0 r
s
P
p
.59253 .27405 m .62053 .28074 L .60525 .28392 L 1 .271 0 r
F
P
p
.57724 .27729 m .59253 .27405 L .60525 .28392 L 1 .281 0 r
F
P
p
.53356 .2738 m .56208 .2805 L .54704 .28368 L 1 .406 0 r
F
P
p
.51851 .27704 m .53356 .2738 L .54704 .28368 L 1 .458 0 r
F
P
p
.002 w
.57412 .50892 m .55906 .51644 L .54573 .50424 L p
1 .354 0 r
F P
0 0 0 r
s
P
p
.002 w
.53064 .5065 m .54573 .50424 L .55906 .51644 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.47455 .27355 m .50359 .28025 L .48879 .28343 L 1 .479 0 r
F
P
p
.45975 .27679 m .47455 .27355 L .48879 .28343 L 1 .521 0 r
F
P
p
.002 w
.51566 .51406 m .50082 .51627 L .48673 .50942 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.002 w
.47185 .51434 m .48673 .50942 L .50082 .51627 L p
1 .458 0 r
F P
0 0 0 r
s
P
p
.4155 .2733 m .44507 .28 L .43051 .28319 L 1 .583 0 r
F
P
p
.40094 .27654 m .4155 .2733 L .43051 .28319 L 1 .656 0 r
F
P
p
.35642 .27305 m .38651 .27976 L .37219 .28294 L 1 .698 0 r
F
P
p
.3421 .27629 m .35642 .27305 L .37219 .28294 L 1 .792 0 r
F
P
p
.29729 .2728 m .32791 .27951 L .31383 .2827 L .542 1 0 r
F
P
p
.28322 .27605 m .29729 .2728 L .31383 .2827 L 0 1 .104 r
F
P
p
.002 w
.36919 .55259 m .35269 .64872 L .33651 .64355 L p
0 1 .052 r
F P
0 0 0 r
s
P
p
.002 w
.38356 .54786 m .36919 .55259 L .35099 .64184 L p
.479 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33651 .64355 m .35099 .64184 L .36919 .55259 L p
0 1 .052 r
F P
0 0 0 r
s
P
p
.23813 .27255 m .26927 .27926 L .25544 .28246 L 0 1 .417 r
F
P
p
.2243 .2758 m .23813 .27255 L .25544 .28246 L 0 1 .417 r
F
P
p
.002 w
.41263 .5383 m .42737 .53076 L .44244 .52405 L p
1 .667 0 r
F P
0 0 0 r
s
P
p
.002 w
.33844 .65037 m .32432 .652 L .3079 .64692 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.29378 .64859 m .3079 .64692 L .32432 .652 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.64788 .50153 m .63245 .50379 L .62012 .50213 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.60465 .50442 m .62012 .50213 L .63245 .50379 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.70644 .5017 m .69083 .50661 L .67909 .49427 L p
1 .219 0 r
F P
0 0 0 r
s
P
p
.002 w
.6634 .49658 m .67909 .49427 L .69083 .50661 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.84444 .27179 m .87031 .27852 L .85394 .28172 L 1 0 0 r
F
P
p
.82804 .27505 m .84444 .27179 L .85394 .28172 L 1 0 0 r
F
P
p
.78538 .27154 m .81177 .27828 L .79564 .28148 L 1 0 0 r
F
P
p
.76922 .2748 m .78538 .27154 L .79564 .28148 L 1 .031 0 r
F
P
p
.002 w
.89763 .48399 m .88114 .48633 L .87198 .47907 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85546 .48145 m .87198 .47907 L .88114 .48633 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.72627 .27129 m .7532 .27803 L .73731 .28123 L 1 0 0 r
F
P
p
.71036 .27455 m .72627 .27129 L .73731 .28123 L 1 .021 0 r
F
P
p
.002 w
.83907 .48381 m .82282 .48615 L .8129 .47889 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79662 .48127 m .8129 .47889 L .82282 .48615 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58932 .50668 m .57412 .50892 L .56095 .50196 L p
1 .323 0 r
F P
0 0 0 r
s
P
p
.002 w
.54573 .50424 m .56095 .50196 L .57412 .50892 L p
1 .354 0 r
F P
0 0 0 r
s
P
p
.66713 .27104 m .69458 .27778 L .67894 .28099 L 1 .125 0 r
F
P
p
.65147 .2743 m .66713 .27104 L .67894 .28099 L 1 .125 0 r
F
P
p
.002 w
.78047 .48363 m .76446 .48597 L .75402 .48675 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.73796 .4891 m .75402 .48675 L .76446 .48597 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.60796 .27079 m .63593 .27753 L .62053 .28074 L 1 .26 0 r
F
P
p
.59253 .27405 m .60796 .27079 L .62053 .28074 L 1 .271 0 r
F
P
p
.54874 .27054 m .57724 .27729 L .56208 .2805 L 1 .375 0 r
F
P
p
.53356 .2738 m .54874 .27054 L .56208 .2805 L 1 .406 0 r
F
P
p
.48948 .27028 m .51851 .27704 L .50359 .28025 L 1 .448 0 r
F
P
p
.47455 .27355 m .48948 .27028 L .50359 .28025 L 1 .479 0 r
F
P
p
.002 w
.53064 .5065 m .51566 .51406 L .50171 .50716 L p
1 .396 0 r
F P
0 0 0 r
s
P
p
.002 w
.48673 .50942 m .50171 .50716 L .51566 .51406 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.43019 .27003 m .45975 .27679 L .44507 .28 L 1 .521 0 r
F
P
p
.4155 .2733 m .43019 .27003 L .44507 .28 L 1 .583 0 r
F
P
p
.37085 .26978 m .40094 .27654 L .38651 .27976 L 1 .635 0 r
F
P
p
.35642 .27305 m .37085 .26978 L .38651 .27976 L 1 .698 0 r
F
P
p
.002 w
.39799 .54578 m .38356 .54786 L .36655 .59866 L p
.865 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35099 .64184 m .36655 .59866 L .38356 .54786 L p
.479 1 0 r
F P
0 0 0 r
s
P
p
.31148 .26953 m .3421 .27629 L .32791 .27951 L .99 1 0 r
F
P
p
.29729 .2728 m .31148 .26953 L .32791 .27951 L .542 1 0 r
F
P
p
.25207 .26927 m .28322 .27605 L .26927 .27926 L 0 1 .417 r
F
P
p
.23813 .27255 m .25207 .26927 L .26927 .27926 L 0 1 .417 r
F
P
p
.002 w
.35269 .64872 m .33844 .65037 L .32214 .64524 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.3079 .64692 m .32214 .64524 L .33844 .65037 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.29378 .64859 m .27978 .65024 L .26271 .64511 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.67909 .49427 m .69479 .48656 L .70644 .5017 L p
1 .219 0 r
F P
0 0 0 r
s
P
p
.002 w
.6634 .49658 m .64788 .50153 L .63571 .49983 L p
1 .229 0 r
F P
0 0 0 r
s
P
p
.002 w
.62012 .50213 m .63571 .49983 L .64788 .50153 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.86098 .26851 m .88682 .2753 L .87031 .27852 L 1 0 0 r
F
P
p
.84444 .27179 m .86098 .26851 L .87031 .27852 L 1 0 0 r
F
P
p
.80167 .26826 m .82804 .27505 L .81177 .27828 L 1 0 0 r
F
P
p
.78538 .27154 m .80167 .26826 L .81177 .27828 L 1 0 0 r
F
P
p
.002 w
.91426 .48163 m .89763 .48399 L .88865 .47667 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.87198 .47907 m .88865 .47667 L .89763 .48399 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.74232 .26801 m .76922 .2748 L .7532 .27803 L 1 0 0 r
F
P
p
.72627 .27129 m .74232 .26801 L .7532 .27803 L 1 0 0 r
F
P
p
.002 w
.85546 .48145 m .83907 .48381 L .82932 .47649 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8129 .47889 m .82932 .47649 L .83907 .48381 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60465 .50442 m .58932 .50668 L .57628 .49696 L p
1 .302 0 r
F P
0 0 0 r
s
P
p
.002 w
.56095 .50196 m .57628 .49696 L .58932 .50668 L p
1 .323 0 r
F P
0 0 0 r
s
P
p
.68294 .26775 m .71036 .27455 L .69458 .27778 L 1 .104 0 r
F
P
p
.66713 .27104 m .68294 .26775 L .69458 .27778 L 1 .125 0 r
F
P
p
.002 w
.79662 .48127 m .78047 .48363 L .77021 .48437 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.75402 .48675 m .77021 .48437 L .78047 .48363 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.54573 .50424 m .53064 .5065 L .51682 .50488 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.50171 .50716 m .51682 .50488 L .53064 .5065 L p
1 .396 0 r
F P
0 0 0 r
s
P
p
.62351 .2675 m .65147 .2743 L .63593 .27753 L 1 .198 0 r
F
P
p
.60796 .27079 m .62351 .2675 L .63593 .27753 L 1 .26 0 r
F
P
p
.56404 .26724 m .59253 .27405 L .57724 .27729 L 1 .354 0 r
F
P
p
.54874 .27054 m .56404 .26724 L .57724 .27729 L 1 .375 0 r
F
P
p
.50454 .26699 m .53356 .2738 L .51851 .27704 L 1 .417 0 r
F
P
p
.48948 .27028 m .50454 .26699 L .51851 .27704 L 1 .448 0 r
F
P
p
.44499 .26673 m .47455 .27355 L .45975 .27679 L 1 .49 0 r
F
P
p
.43019 .27003 m .44499 .26673 L .45975 .27679 L 1 .521 0 r
F
P
p
.38541 .26648 m .4155 .2733 L .40094 .27654 L 1 .615 0 r
F
P
p
.37085 .26978 m .38541 .26648 L .40094 .27654 L 1 .635 0 r
F
P
p
.002 w
.41263 .5383 m .39799 .54578 L .38241 .53926 L p
1 .875 0 r
F P
0 0 0 r
s
P
p
.002 w
.36655 .59866 m .38241 .53926 L .39799 .54578 L p
.865 1 0 r
F P
0 0 0 r
s
P
p
.32579 .26622 m .35642 .27305 L .3421 .27629 L 1 .823 0 r
F
P
p
.31148 .26953 m .32579 .26622 L .3421 .27629 L .99 1 0 r
F
P
p
.26613 .26597 m .29729 .2728 L .28322 .27605 L 0 1 .104 r
F
P
p
.25207 .26927 m .26613 .26597 L .28322 .27605 L 0 1 .417 r
F
P
p
.002 w
.32214 .64524 m .33651 .64355 L .35269 .64872 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.20643 .26571 m .23813 .27255 L .2243 .2758 L 0 1 .417 r
F
P
p
.002 w
.67909 .49427 m .6634 .49658 L .65122 .48401 L p
1 .167 0 r
F P
0 0 0 r
s
P
p
.002 w
.63571 .49983 m .65122 .48401 L .6634 .49658 L p
1 .229 0 r
F P
0 0 0 r
s
P
p
.002 w
.3079 .64692 m .29378 .64859 L .27682 .64342 L p
0 1 .135 r
F P
0 0 0 r
s
P
p
.002 w
.26271 .64511 m .27682 .64342 L .29378 .64859 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.73796 .4891 m .72225 .49942 L .71067 .4815 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.69479 .48656 m .71067 .4815 L .72225 .49942 L p
1 .177 0 r
F P
0 0 0 r
s
P
p
.86098 .26851 m .87767 .2652 L .88682 .2753 L 1 0 0 r
F
P
p
.81811 .26495 m .84444 .27179 L .82804 .27505 L 1 0 0 r
F
P
p
.80167 .26826 m .81811 .26495 L .82804 .27505 L 1 0 0 r
F
P
p
.002 w
.88865 .47667 m .90547 .47425 L .91426 .48163 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.75851 .26469 m .78538 .27154 L .76922 .2748 L 1 0 0 r
F
P
p
.74232 .26801 m .75851 .26469 L .76922 .2748 L 1 0 0 r
F
P
p
.002 w
.87198 .47907 m .85546 .48145 L .84589 .47406 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82932 .47649 m .84589 .47406 L .85546 .48145 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62012 .50213 m .60465 .50442 L .59173 .49192 L p
1 .281 0 r
F P
0 0 0 r
s
P
p
.002 w
.57628 .49696 m .59173 .49192 L .60465 .50442 L p
1 .302 0 r
F P
0 0 0 r
s
P
p
.69887 .26443 m .72627 .27129 L .71036 .27455 L 1 .073 0 r
F
P
p
.68294 .26775 m .69887 .26443 L .71036 .27455 L 1 .104 0 r
F
P
p
.002 w
.8129 .47889 m .79662 .48127 L .78655 .48198 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.77021 .48437 m .78655 .48198 L .79662 .48127 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.56095 .50196 m .54573 .50424 L .53206 .50257 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.51682 .50488 m .53206 .50257 L .54573 .50424 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.6392 .26418 m .66713 .27104 L .65147 .2743 L 1 .135 0 r
F
P
p
.62351 .2675 m .6392 .26418 L .65147 .2743 L 1 .198 0 r
F
P
p
.57948 .26392 m .60796 .27079 L .59253 .27405 L 1 .302 0 r
F
P
p
.56404 .26724 m .57948 .26392 L .59253 .27405 L 1 .354 0 r
F
P
p
.51973 .26366 m .54874 .27054 L .53356 .2738 L 1 .344 0 r
F
P
p
.50454 .26699 m .51973 .26366 L .53356 .2738 L 1 .417 0 r
F
P
p
.002 w
.42737 .53076 m .41263 .5383 L .39719 .53165 L p
1 .792 0 r
F P
0 0 0 r
s
P
p
.002 w
.38241 .53926 m .39719 .53165 L .41263 .5383 L p
1 .875 0 r
F P
0 0 0 r
s
P
p
.45993 .26341 m .48948 .27028 L .47455 .27355 L 1 .469 0 r
F
P
p
.44499 .26673 m .45993 .26341 L .47455 .27355 L 1 .49 0 r
F
P
p
.002 w
.50171 .50716 m .48673 .50942 L .47216 .51599 L p
1 .51 0 r
F P
0 0 0 r
s
P
p
.002 w
.45714 .51824 m .47216 .51599 L .48673 .50942 L p
1 .531 0 r
F P
0 0 0 r
s
P
p
.4001 .26315 m .43019 .27003 L .4155 .2733 L 1 .573 0 r
F
P
p
.38541 .26648 m .4001 .26315 L .4155 .2733 L 1 .615 0 r
F
P
p
.002 w
.75402 .48675 m .73796 .4891 L .72668 .47639 L p
1 .073 0 r
F P
0 0 0 r
s
P
p
.002 w
.71067 .4815 m .72668 .47639 L .73796 .4891 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.34022 .26289 m .37085 .26978 L .35642 .27305 L 1 .698 0 r
F
P
p
.32579 .26622 m .34022 .26289 L .35642 .27305 L 1 .823 0 r
F
P
p
.28031 .26264 m .31148 .26953 L .29729 .2728 L .26 1 0 r
F
P
p
.26613 .26597 m .28031 .26264 L .29729 .2728 L 0 1 .104 r
F
P
p
.22036 .26238 m .25207 .26927 L .23813 .27255 L 0 1 .271 r
F
P
p
.20643 .26571 m .22036 .26238 L .23813 .27255 L 0 1 .417 r
F
P
p
.002 w
.69479 .48656 m .67909 .49427 L .66705 .48161 L p
1 .146 0 r
F P
0 0 0 r
s
P
p
.002 w
.65122 .48401 m .66705 .48161 L .67909 .49427 L p
1 .167 0 r
F P
0 0 0 r
s
P
p
.002 w
.32214 .64524 m .3079 .64692 L .2935 .5677 L p
.24 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27682 .64342 m .2935 .5677 L .3079 .64692 L p
0 1 .135 r
F P
0 0 0 r
s
P
p
.83469 .2616 m .86098 .26851 L .84444 .27179 L 1 0 0 r
F
P
p
.81811 .26495 m .83469 .2616 L .84444 .27179 L 1 0 0 r
F
P
p
.77484 .26135 m .80167 .26826 L .78538 .27154 L 1 0 0 r
F
P
p
.75851 .26469 m .77484 .26135 L .78538 .27154 L 1 0 0 r
F
P
p
.002 w
.88865 .47667 m .87198 .47907 L .86259 .47162 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84589 .47406 m .86259 .47162 L .87198 .47907 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63571 .49983 m .62012 .50213 L .6073 .48685 L p
1 .271 0 r
F P
0 0 0 r
s
P
p
.002 w
.59173 .49192 m .6073 .48685 L .62012 .50213 L p
1 .281 0 r
F P
0 0 0 r
s
P
p
.71495 .26109 m .74232 .26801 L .72627 .27129 L 1 .031 0 r
F
P
p
.69887 .26443 m .71495 .26109 L .72627 .27129 L 1 .073 0 r
F
P
p
.002 w
.82932 .47649 m .8129 .47889 L .80272 .47143 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78655 .48198 m .80272 .47143 L .8129 .47889 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.57628 .49696 m .56095 .50196 L .54743 .50025 L p
1 .344 0 r
F P
0 0 0 r
s
P
p
.002 w
.53206 .50257 m .54743 .50025 L .56095 .50196 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.65502 .26083 m .68294 .26775 L .66713 .27104 L 1 .125 0 r
F
P
p
.6392 .26418 m .65502 .26083 L .66713 .27104 L 1 .135 0 r
F
P
p
.002 w
.44225 .52047 m .42737 .53076 L .41207 .52399 L p
1 .688 0 r
F P
0 0 0 r
s
P
p
.002 w
.39719 .53165 m .41207 .52399 L .42737 .53076 L p
1 .792 0 r
F P
0 0 0 r
s
P
p
.59505 .26057 m .62351 .2675 L .60796 .27079 L 1 .25 0 r
F
P
p
.57948 .26392 m .59505 .26057 L .60796 .27079 L 1 .302 0 r
F
P
p
.53504 .26031 m .56404 .26724 L .54874 .27054 L 1 .292 0 r
F
P
p
.51973 .26366 m .53504 .26031 L .54874 .27054 L 1 .344 0 r
F
P
p
.475 .26005 m .50454 .26699 L .48948 .27028 L 1 .417 0 r
F
P
p
.45993 .26341 m .475 .26005 L .48948 .27028 L 1 .469 0 r
F
P
p
.002 w
.47216 .51599 m .48732 .51098 L .50171 .50716 L p
1 .51 0 r
F P
0 0 0 r
s
P
p
.002 w
.51682 .50488 m .50171 .50716 L .48732 .51098 L p
1 .49 0 r
F P
0 0 0 r
s
P
p
.002 w
.2935 .5677 m .30848 .54123 L .32214 .64524 L p
.24 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.2935 .5677 m .27682 .64342 L .2594 .63811 L p
0 1 .135 r
F P
0 0 0 r
s
P
p
.002 w
.30848 .54123 m .2935 .5677 L .27375 .63635 L p
.24 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.2594 .63811 m .27375 .63635 L .2935 .5677 L p
0 1 .135 r
F P
0 0 0 r
s
P
p
.41491 .25979 m .44499 .26673 L .43019 .27003 L 1 .542 0 r
F
P
p
.4001 .26315 m .41491 .25979 L .43019 .27003 L 1 .573 0 r
F
P
p
.002 w
.77021 .48437 m .75402 .48675 L .74281 .47125 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.72668 .47639 m .74281 .47125 L .75402 .48675 L p
1 .073 0 r
F P
0 0 0 r
s
P
p
.35478 .25953 m .38541 .26648 L .37085 .26978 L 1 .615 0 r
F
P
p
.34022 .26289 m .35478 .25953 L .37085 .26978 L 1 .698 0 r
F
P
p
.002 w
.71067 .4815 m .69479 .48656 L .68302 .4792 L p
1 .115 0 r
F P
0 0 0 r
s
P
p
.002 w
.66705 .48161 m .68302 .4792 L .69479 .48656 L p
1 .146 0 r
F P
0 0 0 r
s
P
p
.29461 .25927 m .32579 .26622 L .31148 .26953 L .333 1 0 r
F
P
p
.28031 .26264 m .29461 .25927 L .31148 .26953 L .26 1 0 r
F
P
p
.002 w
.33651 .64355 m .32214 .64524 L .30848 .54123 L p
.354 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30848 .54123 m .32294 .53366 L .33651 .64355 L p
.354 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32294 .53366 m .30848 .54123 L .28823 .63458 L p
.354 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27375 .63635 m .28823 .63458 L .30848 .54123 L p
.24 1 0 r
F P
0 0 0 r
s
P
p
.23441 .25901 m .26613 .26597 L .25207 .26927 L .115 1 0 r
F
P
p
.22036 .26238 m .23441 .25901 L .25207 .26927 L 0 1 .271 r
F
P
p
.002 w
.27682 .64342 m .26271 .64511 L .24518 .63985 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.41207 .52399 m .4271 .51354 L .44225 .52047 L p
1 .688 0 r
F P
0 0 0 r
s
P
p
.85141 .25823 m .87767 .2652 L .86098 .26851 L 1 0 0 r
F
P
p
.83469 .2616 m .85141 .25823 L .86098 .26851 L 1 0 0 r
F
P
p
.7913 .25797 m .81811 .26495 L .80167 .26826 L 1 0 0 r
F
P
p
.77484 .26135 m .7913 .25797 L .80167 .26826 L 1 0 0 r
F
P
p
.002 w
.59173 .49192 m .57628 .49696 L .56292 .49245 L p
1 .302 0 r
F P
0 0 0 r
s
P
p
.002 w
.54743 .50025 m .56292 .49245 L .57628 .49696 L p
1 .344 0 r
F P
0 0 0 r
s
P
p
.002 w
.90547 .47425 m .88865 .47667 L .87944 .46916 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.86259 .47162 m .87944 .46916 L .88865 .47667 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65122 .48401 m .63571 .49983 L .62303 .48445 L p
1 .208 0 r
F P
0 0 0 r
s
P
p
.002 w
.6073 .48685 m .62303 .48445 L .63571 .49983 L p
1 .271 0 r
F P
0 0 0 r
s
P
p
.73116 .25771 m .75851 .26469 L .74232 .26801 L 1 0 0 r
F
P
p
.71495 .26109 m .73116 .25771 L .74232 .26801 L 1 .031 0 r
F
P
p
.002 w
.84589 .47406 m .82932 .47649 L .81932 .46897 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80272 .47143 m .81932 .46897 L .82932 .47649 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67098 .25745 m .69887 .26443 L .68294 .26775 L 1 .125 0 r
F
P
p
.65502 .26083 m .67098 .25745 L .68294 .26775 L 1 .125 0 r
F
P
p
.61076 .25719 m .6392 .26418 L .62351 .2675 L 1 .188 0 r
F
P
p
.59505 .26057 m .61076 .25719 L .62351 .2675 L 1 .25 0 r
F
P
p
.55049 .25693 m .57948 .26392 L .56404 .26724 L 1 .26 0 r
F
P
p
.53504 .26031 m .55049 .25693 L .56404 .26724 L 1 .292 0 r
F
P
p
.49019 .25667 m .51973 .26366 L .50454 .26699 L 1 .365 0 r
F
P
p
.475 .26005 m .49019 .25667 L .50454 .26699 L 1 .417 0 r
F
P
p
.002 w
.53206 .50257 m .51682 .50488 L .5026 .50594 L p
1 .479 0 r
F P
0 0 0 r
s
P
p
.002 w
.48732 .51098 m .5026 .50594 L .51682 .50488 L p
1 .49 0 r
F P
0 0 0 r
s
P
p
.002 w
.72668 .47639 m .71067 .4815 L .69913 .47676 L p
1 .073 0 r
F P
0 0 0 r
s
P
p
.002 w
.68302 .4792 m .69913 .47676 L .71067 .4815 L p
1 .115 0 r
F P
0 0 0 r
s
P
p
.42985 .25641 m .45993 .26341 L .44499 .26673 L 1 .51 0 r
F
P
p
.41491 .25979 m .42985 .25641 L .44499 .26673 L 1 .542 0 r
F
P
p
.002 w
.78655 .48198 m .77021 .48437 L .75915 .46878 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.74281 .47125 m .75915 .46878 L .77021 .48437 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.32958 .5875 m .32294 .53366 L p
.3319 .56821 L .396 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32294 .53366 m .3375 .52604 L .35099 .64184 L p
.396 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3375 .52604 m .32294 .53366 L .31775 .55922 L p
.677 1 0 r
F P
0 0 0 r
s
P
p
.32552 .55291 m .3375 .52604 L .31775 .55922 L .677 1 0 r
F
P
p
.32613 .56105 m .3375 .52604 L .31361 .57963 L .677 1 0 r
F
P
p
.002 w
.31775 .55922 m .31361 .57963 L p
.32552 .55291 L .677 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31361 .57963 m .30283 .63279 L p
.32613 .56105 L .677 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30283 .63279 m .3198 .55512 L .33681 .52716 L p
.677 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33681 .52716 m .3375 .52604 L p
.33663 .52871 L .677 1 0 r
F P
0 0 0 r
s
P
p
.30283 .63279 m .33681 .52716 L .33663 .52871 L .677 1 0 r
F
P
p
.002 w
.36655 .59866 m .35099 .64184 L .3375 .52604 L p
.573 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3375 .52604 m .35202 .52382 L .36655 .59866 L p
.573 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35202 .52382 m .3375 .52604 L .3198 .55512 L p
1 .927 0 r
F P
0 0 0 r
s
P
p
.002 w
.3198 .55512 m .3352 .52794 L .35105 .52406 L p
1 .927 0 r
F P
0 0 0 r
s
P
p
.002 w
.35105 .52406 m .35202 .52382 L p
.34967 .52611 L 1 .927 0 r
F P
0 0 0 r
s
P
p
.3198 .55512 m .35105 .52406 L .34967 .52611 L 1 .927 0 r
F
P
p
.002 w
.38241 .53926 m .36655 .59866 L .35202 .52382 L p
.948 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35202 .52382 m .36668 .52158 L .38241 .53926 L p
.948 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36668 .52158 m .35202 .52382 L .3352 .52794 L p
1 .792 0 r
F P
0 0 0 r
s
P
p
.002 w
.3352 .52794 m .35028 .51457 L .36497 .52085 L p
1 .792 0 r
F P
0 0 0 r
s
P
p
.002 w
.36497 .52085 m .36668 .52158 L p
.36321 .52228 L 1 .792 0 r
F P
0 0 0 r
s
P
p
.3352 .52794 m .36497 .52085 L .36321 .52228 L 1 .792 0 r
F
P
p
.002 w
.35099 .64184 m .33651 .64355 L .32958 .5875 L p
.396 1 0 r
F P
0 0 0 r
s
P
p
.3319 .56821 m .35099 .64184 L .32958 .5875 L .396 1 0 r
F
P
p
.002 w
.28823 .63458 m .30283 .63279 L .32294 .53366 L p
.354 1 0 r
F P
0 0 0 r
s
P
p
.36947 .25615 m .4001 .26315 L .38541 .26648 L 1 .552 0 r
F
P
p
.35478 .25953 m .36947 .25615 L .38541 .26648 L 1 .615 0 r
F
P
p
.002 w
.39719 .53165 m .38241 .53926 L .36668 .52158 L p
1 .781 0 r
F P
0 0 0 r
s
P
p
.30904 .25588 m .34022 .26289 L .32579 .26622 L .385 1 0 r
F
P
p
.29461 .25927 m .30904 .25588 L .32579 .26622 L .333 1 0 r
F
P
p
.002 w
.66705 .48161 m .65122 .48401 L .63885 .47931 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.002 w
.62303 .48445 m .63885 .47931 L .65122 .48401 L p
1 .208 0 r
F P
0 0 0 r
s
P
p
.24858 .25562 m .28031 .26264 L .26613 .26597 L .365 1 0 r
F
P
p
.23441 .25901 m .24858 .25562 L .26613 .26597 L .115 1 0 r
F
P
p
.18807 .25536 m .22036 .26238 L .20643 .26571 L 0 1 .271 r
F
P
p
.002 w
.24518 .63985 m .2594 .63811 L .27682 .64342 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.47216 .51599 m .45714 .51824 L .4422 .50576 L p
1 .563 0 r
F P
0 0 0 r
s
P
p
.002 w
.4271 .51354 m .4422 .50576 L .45714 .51824 L p
1 .604 0 r
F P
0 0 0 r
s
P
p
.85141 .25823 m .86827 .25484 L .87767 .2652 L 1 0 0 r
F
P
p
.002 w
.6073 .48685 m .59173 .49192 L .57854 .49006 L p
1 .281 0 r
F P
0 0 0 r
s
P
p
.002 w
.56292 .49245 m .57854 .49006 L .59173 .49192 L p
1 .302 0 r
F P
0 0 0 r
s
P
p
.80791 .25457 m .83469 .2616 L .81811 .26495 L 1 0 0 r
F
P
p
.7913 .25797 m .80791 .25457 L .81811 .26495 L 1 0 0 r
F
P
p
.002 w
.87944 .46916 m .89644 .46667 L .90547 .47425 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.74752 .25431 m .77484 .26135 L .75851 .26469 L 1 0 0 r
F
P
p
.73116 .25771 m .74752 .25431 L .75851 .26469 L 1 0 0 r
F
P
p
.002 w
.86259 .47162 m .84589 .47406 L .83606 .46648 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81932 .46897 m .83606 .46648 L .84589 .47406 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68708 .25405 m .71495 .26109 L .69887 .26443 L 1 .125 0 r
F
P
p
.67098 .25745 m .68708 .25405 L .69887 .26443 L 1 .125 0 r
F
P
p
.6266 .25378 m .65502 .26083 L .6392 .26418 L 1 .135 0 r
F
P
p
.61076 .25719 m .6266 .25378 L .6392 .26418 L 1 .188 0 r
F
P
p
.56608 .25352 m .59505 .26057 L .57948 .26392 L 1 .198 0 r
F
P
p
.55049 .25693 m .56608 .25352 L .57948 .26392 L 1 .26 0 r
F
P
p
.002 w
.74281 .47125 m .72668 .47639 L .71524 .46883 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.002 w
.69913 .47676 m .71524 .46883 L .72668 .47639 L p
1 .073 0 r
F P
0 0 0 r
s
P
p
.50552 .25326 m .53504 .26031 L .51973 .26366 L 1 .302 0 r
F
P
p
.49019 .25667 m .50552 .25326 L .51973 .26366 L 1 .365 0 r
F
P
p
.002 w
.54743 .50025 m .53206 .50257 L .518 .50361 L p
1 .458 0 r
F P
0 0 0 r
s
P
p
.002 w
.5026 .50594 m .518 .50361 L .53206 .50257 L p
1 .479 0 r
F P
0 0 0 r
s
P
p
.002 w
.41207 .52399 m .39719 .53165 L .38163 .51107 L p
1 .708 0 r
F P
0 0 0 r
s
P
p
.002 w
.36668 .52158 m .38163 .51107 L .39719 .53165 L p
1 .781 0 r
F P
0 0 0 r
s
P
p
.44492 .25299 m .475 .26005 L .45993 .26341 L 1 .458 0 r
F
P
p
.42985 .25641 m .44492 .25299 L .45993 .26341 L 1 .51 0 r
F
P
p
.002 w
.80272 .47143 m .78655 .48198 L .77564 .46629 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.75915 .46878 m .77564 .46629 L .78655 .48198 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.38428 .25273 m .41491 .25979 L .4001 .26315 L 1 .5 0 r
F
P
p
.36947 .25615 m .38428 .25273 L .4001 .26315 L 1 .552 0 r
F
P
p
.3236 .25246 m .35478 .25953 L .34022 .26289 L .594 1 0 r
F
P
p
.30904 .25588 m .3236 .25246 L .34022 .26289 L .385 1 0 r
F
P
p
.002 w
.68302 .4792 m .66705 .48161 L .65481 .47412 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.63885 .47931 m .65481 .47412 L .66705 .48161 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.26287 .2522 m .29461 .25927 L .28031 .26264 L .396 1 0 r
F
P
p
.24858 .25562 m .26287 .2522 L .28031 .26264 L .365 1 0 r
F
P
p
.20211 .25194 m .23441 .25901 L .22036 .26238 L .156 1 0 r
F
P
p
.18807 .25536 m .20211 .25194 L .22036 .26238 L 0 1 .271 r
F
P
p
.002 w
.62303 .48445 m .6073 .48685 L .59431 .48766 L p
1 .271 0 r
F P
0 0 0 r
s
P
p
.002 w
.57854 .49006 m .59431 .48766 L .6073 .48685 L p
1 .281 0 r
F P
0 0 0 r
s
P
p
.002 w
.48732 .51098 m .47216 .51599 L .4574 .49793 L p
1 .521 0 r
F P
0 0 0 r
s
P
p
.002 w
.4422 .50576 m .4574 .49793 L .47216 .51599 L p
1 .563 0 r
F P
0 0 0 r
s
P
p
.82467 .25114 m .85141 .25823 L .83469 .2616 L 1 0 0 r
F
P
p
.80791 .25457 m .82467 .25114 L .83469 .2616 L 1 0 0 r
F
P
p
.76401 .25088 m .7913 .25797 L .77484 .26135 L 1 0 0 r
F
P
p
.74752 .25431 m .76401 .25088 L .77484 .26135 L 1 0 0 r
F
P
p
.002 w
.87944 .46916 m .86259 .47162 L .85295 .46397 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83606 .46648 m .85295 .46397 L .86259 .47162 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70332 .25061 m .73116 .25771 L .71495 .26109 L 1 .073 0 r
F
P
p
.68708 .25405 m .70332 .25061 L .71495 .26109 L 1 .125 0 r
F
P
p
.002 w
.81932 .46897 m .80272 .47143 L .79226 .46378 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77564 .46629 m .79226 .46378 L .80272 .47143 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.64258 .25034 m .67098 .25745 L .65502 .26083 L 1 .125 0 r
F
P
p
.6266 .25378 m .64258 .25034 L .65502 .26083 L 1 .135 0 r
F
P
p
.002 w
.4271 .51354 m .41207 .52399 L .39653 .50876 L p
1 .656 0 r
F P
0 0 0 r
s
P
p
.002 w
.38163 .51107 m .39653 .50876 L .41207 .52399 L p
1 .708 0 r
F P
0 0 0 r
s
P
p
.002 w
.75915 .46878 m .74281 .47125 L .73154 .46359 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71524 .46883 m .73154 .46359 L .74281 .47125 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.5818 .25008 m .61076 .25719 L .59505 .26057 L 1 .146 0 r
F
P
p
.56608 .25352 m .5818 .25008 L .59505 .26057 L 1 .198 0 r
F
P
p
.52098 .24981 m .55049 .25693 L .53504 .26031 L 1 .25 0 r
F
P
p
.50552 .25326 m .52098 .24981 L .53504 .26031 L 1 .302 0 r
F
P
p
.002 w
.56292 .49245 m .54743 .50025 L .53354 .49574 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.002 w
.518 .50361 m .53354 .49574 L .54743 .50025 L p
1 .458 0 r
F P
0 0 0 r
s
P
p
.46012 .24955 m .49019 .25667 L .475 .26005 L 1 .406 0 r
F
P
p
.44492 .25299 m .46012 .24955 L .475 .26005 L 1 .458 0 r
F
P
p
.39922 .24928 m .42985 .25641 L .41491 .25979 L 1 .479 0 r
F
P
p
.38428 .25273 m .39922 .24928 L .41491 .25979 L 1 .5 0 r
F
P
p
.33828 .24901 m .36947 .25615 L .35478 .25953 L .958 1 0 r
F
P
p
.3236 .25246 m .33828 .24901 L .35478 .25953 L .594 1 0 r
F
P
p
.002 w
.69913 .47676 m .68302 .4792 L .67094 .47164 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.65481 .47412 m .67094 .47164 L .68302 .4792 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.27729 .24875 m .30904 .25588 L .29461 .25927 L .448 1 0 r
F
P
p
.26287 .2522 m .27729 .24875 L .29461 .25927 L .396 1 0 r
F
P
p
.21627 .24848 m .24858 .25562 L .23441 .25901 L .844 1 0 r
F
P
p
.20211 .25194 m .21627 .24848 L .23441 .25901 L .156 1 0 r
F
P
p
.002 w
.5026 .50594 m .48732 .51098 L .47268 .4928 L p
1 .479 0 r
F P
0 0 0 r
s
P
p
.002 w
.4574 .49793 m .47268 .4928 L .48732 .51098 L p
1 .521 0 r
F P
0 0 0 r
s
P
p
.002 w
.63885 .47931 m .62303 .48445 L .61021 .48523 L p
1 .26 0 r
F P
0 0 0 r
s
P
p
.002 w
.59431 .48766 m .61021 .48523 L .62303 .48445 L p
1 .271 0 r
F P
0 0 0 r
s
P
p
.002 w
.2594 .63811 m .24518 .63985 L .22718 .63444 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.4422 .50576 m .4271 .51354 L .41155 .50643 L p
1 .583 0 r
F P
0 0 0 r
s
P
p
.002 w
.39653 .50876 m .41155 .50643 L .4271 .51354 L p
1 .656 0 r
F P
0 0 0 r
s
P
p
.84157 .24768 m .86827 .25484 L .85141 .25823 L 1 0 0 r
F
P
p
.82467 .25114 m .84157 .24768 L .85141 .25823 L 1 0 0 r
F
P
p
.78066 .24741 m .80791 .25457 L .7913 .25797 L 1 0 0 r
F
P
p
.76401 .25088 m .78066 .24741 L .7913 .25797 L 1 0 0 r
F
P
p
.002 w
.89644 .46667 m .87944 .46916 L .86998 .46144 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85295 .46397 m .86998 .46144 L .87944 .46916 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7197 .24714 m .74752 .25431 L .73116 .25771 L 1 .021 0 r
F
P
p
.70332 .25061 m .7197 .24714 L .73116 .25771 L 1 .073 0 r
F
P
p
.002 w
.83606 .46648 m .81932 .46897 L .80904 .46125 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79226 .46378 m .80904 .46125 L .81932 .46897 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.57854 .49006 m .56292 .49245 L .54919 .49058 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.53354 .49574 m .54919 .49058 L .56292 .49245 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.6587 .24688 m .68708 .25405 L .67098 .25745 L 1 .125 0 r
F
P
p
.64258 .25034 m .6587 .24688 L .67098 .25745 L 1 .125 0 r
F
P
p
.002 w
.77564 .46629 m .75915 .46878 L .74806 .46105 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73154 .46359 m .74806 .46105 L .75915 .46878 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.59766 .24661 m .6266 .25378 L .61076 .25719 L 1 .104 0 r
F
P
p
.5818 .25008 m .59766 .24661 L .61076 .25719 L 1 .146 0 r
F
P
p
.002 w
.38163 .51107 m .36668 .52158 L .35028 .51457 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.53658 .24634 m .56608 .25352 L .55049 .25693 L 1 .229 0 r
F
P
p
.52098 .24981 m .53658 .24634 L .55049 .25693 L 1 .25 0 r
F
P
p
.47546 .24607 m .50552 .25326 L .49019 .25667 L 1 .333 0 r
F
P
p
.46012 .24955 m .47546 .24607 L .49019 .25667 L 1 .406 0 r
F
P
p
.41429 .2458 m .44492 .25299 L .42985 .25641 L 1 .438 0 r
F
P
p
.39922 .24928 m .41429 .2458 L .42985 .25641 L 1 .479 0 r
F
P
p
.35309 .24553 m .38428 .25273 L .36947 .25615 L 1 .76 0 r
F
P
p
.33828 .24901 m .35309 .24553 L .36947 .25615 L .958 1 0 r
F
P
p
.002 w
.71524 .46883 m .69913 .47676 L .68721 .46914 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.002 w
.67094 .47164 m .68721 .46914 L .69913 .47676 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.29184 .24527 m .3236 .25246 L .30904 .25588 L .479 1 0 r
F
P
p
.27729 .24875 m .29184 .24527 L .30904 .25588 L .448 1 0 r
F
P
p
.002 w
.518 .50361 m .5026 .50594 L .48809 .48762 L p
1 .448 0 r
F P
0 0 0 r
s
P
p
.002 w
.47268 .4928 m .48809 .48762 L .5026 .50594 L p
1 .479 0 r
F P
0 0 0 r
s
P
p
.23055 .245 m .26287 .2522 L .24858 .25562 L 1 .74 0 r
F
P
p
.21627 .24848 m .23055 .245 L .24858 .25562 L .844 1 0 r
F
P
p
.002 w
.61021 .48523 m .62625 .48278 L .63885 .47931 L p
1 .26 0 r
F P
0 0 0 r
s
P
p
.002 w
.65481 .47412 m .63885 .47931 L .62625 .48278 L p
1 .198 0 r
F P
0 0 0 r
s
P
p
.002 w
.4574 .49793 m .4422 .50576 L .42679 .49852 L p
1 .521 0 r
F P
0 0 0 r
s
P
p
.002 w
.41155 .50643 m .42679 .49852 L .4422 .50576 L p
1 .583 0 r
F P
0 0 0 r
s
P
p
.16922 .24473 m .20211 .25194 L .18807 .25536 L 0 1 .271 r
F
P
p
.002 w
.27375 .63635 m .2594 .63811 L .24152 .63266 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.22718 .63444 m .24152 .63266 L .2594 .63811 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.84157 .24768 m .85862 .24419 L .86827 .25484 L 1 0 0 r
F
P
p
.002 w
.39653 .50876 m .38163 .51107 L .36532 .50668 L p
1 .635 0 r
F P
0 0 0 r
s
P
p
.002 w
.35028 .51457 m .36532 .50668 L .38163 .51107 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.79744 .24392 m .82467 .25114 L .80791 .25457 L 1 0 0 r
F
P
p
.78066 .24741 m .79744 .24392 L .80791 .25457 L 1 0 0 r
F
P
p
.002 w
.86998 .46144 m .88717 .45889 L .89644 .46667 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.73622 .24365 m .76401 .25088 L .74752 .25431 L 1 .01 0 r
F
P
p
.7197 .24714 m .73622 .24365 L .74752 .25431 L 1 .021 0 r
F
P
p
.002 w
.85295 .46397 m .83606 .46648 L .82596 .4587 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80904 .46125 m .82596 .4587 L .83606 .46648 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59431 .48766 m .57854 .49006 L .56498 .48815 L p
1 .354 0 r
F P
0 0 0 r
s
P
p
.002 w
.54919 .49058 m .56498 .48815 L .57854 .49006 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.67496 .24338 m .70332 .25061 L .68708 .25405 L 1 .125 0 r
F
P
p
.6587 .24688 m .67496 .24338 L .68708 .25405 L 1 .125 0 r
F
P
p
.002 w
.79226 .46378 m .77564 .46629 L .76472 .4585 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74806 .46105 m .76472 .4585 L .77564 .46629 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61366 .24311 m .64258 .25034 L .6266 .25378 L 1 .083 0 r
F
P
p
.59766 .24661 m .61366 .24311 L .6266 .25378 L 1 .104 0 r
F
P
p
.55231 .24284 m .5818 .25008 L .56608 .25352 L 1 .198 0 r
F
P
p
.53658 .24634 m .55231 .24284 L .56608 .25352 L 1 .229 0 r
F
P
p
.002 w
.73154 .46359 m .71524 .46883 L .70363 .46661 L p
1 .073 0 r
F P
0 0 0 r
s
P
p
.002 w
.68721 .46914 m .70363 .46661 L .71524 .46883 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.49093 .24257 m .52098 .24981 L .50552 .25326 L 1 .26 0 r
F
P
p
.47546 .24607 m .49093 .24257 L .50552 .25326 L 1 .333 0 r
F
P
p
.4295 .24229 m .46012 .24955 L .44492 .25299 L 1 .365 0 r
F
P
p
.41429 .2458 m .4295 .24229 L .44492 .25299 L 1 .438 0 r
F
P
p
.36803 .24202 m .39922 .24928 L .38428 .25273 L 1 .604 0 r
F
P
p
.35309 .24553 m .36803 .24202 L .38428 .25273 L 1 .76 0 r
F
P
p
.002 w
.47268 .4928 m .4574 .49793 L .44207 .49613 L p
1 .49 0 r
F P
0 0 0 r
s
P
p
.002 w
.42679 .49852 m .44207 .49613 L .4574 .49793 L p
1 .521 0 r
F P
0 0 0 r
s
P
p
.30652 .24175 m .33828 .24901 L .3236 .25246 L .635 1 0 r
F
P
p
.29184 .24527 m .30652 .24175 L .3236 .25246 L .479 1 0 r
F
P
p
.002 w
.67094 .47164 m .65481 .47412 L .64227 .46919 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.002 w
.62625 .48278 m .64227 .46919 L .65481 .47412 L p
1 .198 0 r
F P
0 0 0 r
s
P
p
.002 w
.53354 .49574 m .518 .50361 L .50362 .48241 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.002 w
.48809 .48762 m .50362 .48241 L .518 .50361 L p
1 .448 0 r
F P
0 0 0 r
s
P
p
.24496 .24148 m .27729 .24875 L .26287 .2522 L 1 .688 0 r
F
P
p
.23055 .245 m .24496 .24148 L .26287 .2522 L 1 .74 0 r
F
P
p
.18337 .24121 m .21627 .24848 L .20211 .25194 L .01 1 0 r
F
P
p
.16922 .24473 m .18337 .24121 L .20211 .25194 L 0 1 .271 r
F
P
p
.002 w
.28823 .63458 m .27375 .63635 L .25598 .63085 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.24152 .63266 m .25598 .63085 L .27375 .63635 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.41155 .50643 m .39653 .50876 L .38041 .50152 L p
1 .615 0 r
F P
0 0 0 r
s
P
p
.002 w
.36532 .50668 m .38041 .50152 L .39653 .50876 L p
1 .635 0 r
F P
0 0 0 r
s
P
p
.81438 .24039 m .84157 .24768 L .82467 .25114 L 1 0 0 r
F
P
p
.79744 .24392 m .81438 .24039 L .82467 .25114 L 1 0 0 r
F
P
p
.7529 .24012 m .78066 .24741 L .76401 .25088 L 1 0 0 r
F
P
p
.73622 .24365 m .7529 .24012 L .76401 .25088 L 1 .01 0 r
F
P
p
.002 w
.86998 .46144 m .85295 .46397 L .84304 .45612 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82596 .4587 m .84304 .45612 L .85295 .46397 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.61021 .48523 m .59431 .48766 L .58088 .48012 L p
1 .302 0 r
F P
0 0 0 r
s
P
p
.002 w
.56498 .48815 m .58088 .48012 L .59431 .48766 L p
1 .354 0 r
F P
0 0 0 r
s
P
p
.69137 .23985 m .7197 .24714 L .70332 .25061 L 1 .104 0 r
F
P
p
.67496 .24338 m .69137 .23985 L .70332 .25061 L 1 .125 0 r
F
P
p
.002 w
.80904 .46125 m .79226 .46378 L .78153 .45592 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76472 .4585 m .78153 .45592 L .79226 .46378 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.6298 .23957 m .6587 .24688 L .64258 .25034 L 1 .083 0 r
F
P
p
.61366 .24311 m .6298 .23957 L .64258 .25034 L 1 .083 0 r
F
P
p
.002 w
.74806 .46105 m .73154 .46359 L .72019 .46406 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.70363 .46661 m .72019 .46406 L .73154 .46359 L p
1 .073 0 r
F P
0 0 0 r
s
P
p
.56819 .2393 m .59766 .24661 L .5818 .25008 L 1 .156 0 r
F
P
p
.55231 .24284 m .56819 .2393 L .5818 .25008 L 1 .198 0 r
F
P
p
.50654 .23903 m .53658 .24634 L .52098 .24981 L 1 .229 0 r
F
P
p
.49093 .24257 m .50654 .23903 L .52098 .24981 L 1 .26 0 r
F
P
p
.002 w
.3352 .52794 m .3198 .55512 L .30332 .52604 L p
.99 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3198 .55512 m .30283 .63279 L .28818 .54227 L p
.542 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28818 .54227 m .30332 .52604 L .3198 .55512 L p
.542 1 0 r
F P
0 0 0 r
s
P
p
.44484 .23875 m .47546 .24607 L .46012 .24955 L 1 .313 0 r
F
P
p
.4295 .24229 m .44484 .23875 L .46012 .24955 L 1 .365 0 r
F
P
p
.002 w
.48809 .48762 m .47268 .4928 L .45748 .49371 L p
1 .469 0 r
F P
0 0 0 r
s
P
p
.002 w
.44207 .49613 m .45748 .49371 L .47268 .4928 L p
1 .49 0 r
F P
0 0 0 r
s
P
p
.002 w
.54919 .49058 m .53354 .49574 L .51928 .47993 L p
1 .344 0 r
F P
0 0 0 r
s
P
p
.002 w
.50362 .48241 m .51928 .47993 L .53354 .49574 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.3831 .23848 m .41429 .2458 L .39922 .24928 L 1 .531 0 r
F
P
p
.36803 .24202 m .3831 .23848 L .39922 .24928 L 1 .604 0 r
F
P
p
.32132 .23821 m .35309 .24553 L .33828 .24901 L 1 1 0 r
F
P
p
.30652 .24175 m .32132 .23821 L .33828 .24901 L .635 1 0 r
F
P
p
.002 w
.68721 .46914 m .67094 .47164 L .65852 .46387 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.64227 .46919 m .65852 .46387 L .67094 .47164 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.002 w
.35028 .51457 m .3352 .52794 L .31829 .51814 L p
1 .823 0 r
F P
0 0 0 r
s
P
p
.002 w
.31829 .51814 m .3352 .52794 L p
.30414 .52609 L .99 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31829 .51814 m .33344 .50736 L .35028 .51457 L p
1 .823 0 r
F P
0 0 0 r
s
P
p
.002 w
.27058 .62903 m .28818 .54227 L .30283 .63279 L p
0 1 .104 r
F P
0 0 0 r
s
P
p
.002 w
.31829 .51814 m .29739 .61761 L p
.33254 .51012 L .385 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33344 .50736 m .31829 .51814 L p
.33254 .51012 L .385 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30332 .52604 m .31829 .51814 L p
.30414 .52609 L .99 1 0 r
F P
0 0 0 r
s
P
p
.2595 .23793 m .29184 .24527 L .27729 .24875 L 1 .615 0 r
F
P
p
.24496 .24148 m .2595 .23793 L .27729 .24875 L 1 .688 0 r
F
P
p
.19764 .23766 m .23055 .245 L .21627 .24848 L .313 1 0 r
F
P
p
.18337 .24121 m .19764 .23766 L .21627 .24848 L .01 1 0 r
F
P
p
.002 w
.30283 .63279 m .28823 .63458 L .27058 .62903 L p
0 1 .104 r
F P
0 0 0 r
s
P
p
.002 w
.25598 .63085 m .27058 .62903 L .28823 .63458 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.24152 .63266 m .22718 .63444 L .20869 .62889 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.42679 .49852 m .41155 .50643 L .39562 .49632 L p
1 .573 0 r
F P
0 0 0 r
s
P
p
.002 w
.38041 .50152 m .39562 .49632 L .41155 .50643 L p
1 .615 0 r
F P
0 0 0 r
s
P
p
.83147 .23684 m .85862 .24419 L .84157 .24768 L 1 0 0 r
F
P
p
.81438 .24039 m .83147 .23684 L .84157 .24768 L 1 0 0 r
F
P
p
.76972 .23656 m .79744 .24392 L .78066 .24741 L 1 0 0 r
F
P
p
.7529 .24012 m .76972 .23656 L .78066 .24741 L 1 0 0 r
F
P
p
.002 w
.88717 .45889 m .86998 .46144 L .86026 .45352 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84304 .45612 m .86026 .45352 L .86998 .46144 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62625 .48278 m .61021 .48523 L .59686 .46925 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.58088 .48012 m .59686 .46925 L .61021 .48523 L p
1 .302 0 r
F P
0 0 0 r
s
P
p
.70792 .23629 m .73622 .24365 L .7197 .24714 L 1 .052 0 r
F
P
p
.69137 .23985 m .70792 .23629 L .7197 .24714 L 1 .104 0 r
F
P
p
.002 w
.82596 .4587 m .80904 .46125 L .79848 .45332 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78153 .45592 m .79848 .45332 L .80904 .46125 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64608 .23601 m .67496 .24338 L .6587 .24688 L 1 .078 0 r
F
P
p
.6298 .23957 m .64608 .23601 L .6587 .24688 L 1 .083 0 r
F
P
p
.002 w
.76472 .4585 m .74806 .46105 L .73666 .45312 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72019 .46406 m .73666 .45312 L .74806 .46105 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.5842 .23574 m .61366 .24311 L .59766 .24661 L 1 .104 0 r
F
P
p
.56819 .2393 m .5842 .23574 L .59766 .24661 L 1 .156 0 r
F
P
p
.002 w
.36532 .50668 m .35028 .51457 L .33344 .50736 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.45748 .49371 m .47304 .49127 L .48809 .48762 L p
1 .469 0 r
F P
0 0 0 r
s
P
p
.002 w
.50362 .48241 m .48809 .48762 L .47304 .49127 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.52228 .23546 m .55231 .24284 L .53658 .24634 L 1 .219 0 r
F
P
p
.50654 .23903 m .52228 .23546 L .53658 .24634 L 1 .229 0 r
F
P
p
.002 w
.56498 .48815 m .54919 .49058 L .53507 .46626 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.51928 .47993 m .53507 .46626 L .54919 .49058 L p
1 .344 0 r
F P
0 0 0 r
s
P
p
.46032 .23518 m .49093 .24257 L .47546 .24607 L 1 .25 0 r
F
P
p
.44484 .23875 m .46032 .23518 L .47546 .24607 L 1 .313 0 r
F
P
p
.39831 .23491 m .4295 .24229 L .41429 .2458 L 1 .51 0 r
F
P
p
.3831 .23848 m .39831 .23491 L .41429 .2458 L 1 .531 0 r
F
P
p
.33626 .23463 m .36803 .24202 L .35309 .24553 L 1 .719 0 r
F
P
p
.32132 .23821 m .33626 .23463 L .35309 .24553 L 1 1 0 r
F
P
p
.002 w
.70363 .46661 m .68721 .46914 L .67496 .4613 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.65852 .46387 m .67496 .4613 L .68721 .46914 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.27417 .23435 m .30652 .24175 L .29184 .24527 L 1 .563 0 r
F
P
p
.2595 .23793 m .27417 .23435 L .29184 .24527 L 1 .615 0 r
F
P
p
.21204 .23408 m .24496 .24148 L .23055 .245 L .76 1 0 r
F
P
p
.19764 .23766 m .21204 .23408 L .23055 .245 L .313 1 0 r
F
P
p
.002 w
.44207 .49613 m .42679 .49852 L .41096 .49108 L p
1 .542 0 r
F P
0 0 0 r
s
P
p
.002 w
.39562 .49632 m .41096 .49108 L .42679 .49852 L p
1 .573 0 r
F P
0 0 0 r
s
P
p
.14986 .2338 m .18337 .24121 L .16922 .24473 L 0 1 .417 r
F
P
p
.002 w
.25598 .63085 m .24152 .63266 L .22314 .62705 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.20869 .62889 m .22314 .62705 L .24152 .63266 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.83147 .23684 m .84871 .23325 L .85862 .24419 L 1 0 0 r
F
P
p
.78669 .23297 m .81438 .24039 L .79744 .24392 L 1 0 0 r
F
P
p
.76972 .23656 m .78669 .23297 L .79744 .24392 L 1 0 0 r
F
P
p
.002 w
.86026 .45352 m .87764 .4509 L .88717 .45889 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64227 .46919 m .62625 .48278 L .61299 .4611 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.002 w
.59686 .46925 m .61299 .4611 L .62625 .48278 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.38041 .50152 m .36532 .50668 L .3487 .49652 L p
1 .615 0 r
F P
0 0 0 r
s
P
p
.002 w
.33344 .50736 m .3487 .49652 L .36532 .50668 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.72462 .23269 m .7529 .24012 L .73622 .24365 L 1 .01 0 r
F
P
p
.70792 .23629 m .72462 .23269 L .73622 .24365 L 1 .052 0 r
F
P
p
.002 w
.84304 .45612 m .82596 .4587 L .81559 .45069 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79848 .45332 m .81559 .45069 L .82596 .4587 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66251 .23241 m .69137 .23985 L .67496 .24338 L 1 .068 0 r
F
P
p
.64608 .23601 m .66251 .23241 L .67496 .24338 L 1 .078 0 r
F
P
p
.002 w
.28818 .54227 m .27058 .62903 L .25244 .62333 L p
0 1 .104 r
F P
0 0 0 r
s
P
p
.002 w
.30332 .52604 m .28818 .54227 L .26728 .62144 L p
.26 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25244 .62333 m .26728 .62144 L .28818 .54227 L p
0 1 .104 r
F P
0 0 0 r
s
P
p
.002 w
.78153 .45592 m .76472 .4585 L .7535 .45049 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73666 .45312 m .7535 .45049 L .76472 .4585 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.51928 .47993 m .50362 .48241 L .48878 .48035 L p
1 .365 0 r
F P
0 0 0 r
s
P
p
.002 w
.47304 .49127 m .48878 .48035 L .50362 .48241 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.60036 .23214 m .6298 .23957 L .61366 .24311 L 1 .083 0 r
F
P
p
.5842 .23574 m .60036 .23214 L .61366 .24311 L 1 .104 0 r
F
P
p
.53817 .23186 m .56819 .2393 L .55231 .24284 L 1 .198 0 r
F
P
p
.52228 .23546 m .53817 .23186 L .55231 .24284 L 1 .219 0 r
F
P
p
.002 w
.58088 .48012 m .56498 .48815 L .55097 .4637 L p
1 .26 0 r
F P
0 0 0 r
s
P
p
.002 w
.53507 .46626 m .55097 .4637 L p
.5378 .46826 L 1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.53507 .46626 m .51928 .47993 L .50461 .47501 L p
1 .302 0 r
F P
0 0 0 r
s
P
p
.002 w
.52056 .46962 m .53507 .46626 L p
.50768 .47413 L 1 .302 0 r
F P
0 0 0 r
s
P
p
.002 w
.50461 .47501 m .52056 .46962 L p
.50768 .47413 L 1 .302 0 r
F P
0 0 0 r
s
P
p
.002 w
.52056 .46962 m .50571 .44726 L p
.53358 .46507 L 1 .229 0 r
F P
0 0 0 r
s
P
p
.002 w
.53537 .46621 m .53507 .46626 L .52056 .46962 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.55097 .4637 m .53537 .46621 L p
.52056 .46962 L 1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.52056 .46962 m .53665 .46703 L .55097 .4637 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.53665 .46703 m .52056 .46962 L p
.53358 .46507 L 1 .229 0 r
F P
0 0 0 r
s
P
p
.002 w
.55097 .4637 m .53665 .46703 L p
.56428 .45909 L 1 .229 0 r
F P
0 0 0 r
s
P
p
.002 w
.56701 .4583 m .55097 .4637 L p
.56428 .45909 L 1 .229 0 r
F P
0 0 0 r
s
P
p
.002 w
.55097 .4637 m .56498 .48815 L p
.5378 .46826 L 1 .292 0 r
F P
0 0 0 r
s
P
p
.47593 .23158 m .50654 .23903 L .49093 .24257 L 1 .177 0 r
F
P
p
.46032 .23518 m .47593 .23158 L .49093 .24257 L 1 .25 0 r
F
P
p
.41366 .2313 m .44484 .23875 L .4295 .24229 L 1 .49 0 r
F
P
p
.39831 .23491 m .41366 .2313 L .4295 .24229 L 1 .51 0 r
F
P
p
.35133 .23102 m .3831 .23848 L .36803 .24202 L 1 .573 0 r
F
P
p
.33626 .23463 m .35133 .23102 L .36803 .24202 L 1 .719 0 r
F
P
p
.002 w
.72019 .46406 m .70363 .46661 L .69155 .4587 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.67496 .4613 m .69155 .4587 L .70363 .46661 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.28897 .23074 m .32132 .23821 L .30652 .24175 L 1 .531 0 r
F
P
p
.27417 .23435 m .28897 .23074 L .30652 .24175 L 1 .563 0 r
F
P
p
.22656 .23047 m .2595 .23793 L .24496 .24148 L 1 .771 0 r
F
P
p
.21204 .23408 m .22656 .23047 L .24496 .24148 L .76 1 0 r
F
P
p
.002 w
.65852 .46387 m .64227 .46919 L .6293 .4585 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.002 w
.61299 .4611 m .6293 .4585 L .64227 .46919 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.002 w
.45748 .49371 m .44207 .49613 L .42638 .48862 L p
1 .51 0 r
F P
0 0 0 r
s
P
p
.002 w
.41096 .49108 m .42638 .48862 L .44207 .49613 L p
1 .542 0 r
F P
0 0 0 r
s
P
p
.002 w
.31829 .51814 m .30332 .52604 L .28227 .61954 L p
.333 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26728 .62144 m .28227 .61954 L .30332 .52604 L p
.26 1 0 r
F P
0 0 0 r
s
P
p
.16411 .23019 m .19764 .23766 L .18337 .24121 L 0 1 .417 r
F
P
p
.14986 .2338 m .16411 .23019 L .18337 .24121 L 0 1 .417 r
F
P
p
.002 w
.27058 .62903 m .25598 .63085 L .23772 .6252 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.22314 .62705 m .23772 .6252 L .25598 .63085 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.39562 .49632 m .38041 .50152 L .36399 .48843 L p
1 .552 0 r
F P
0 0 0 r
s
P
p
.002 w
.3487 .49652 m .36399 .48843 L .38041 .50152 L p
1 .615 0 r
F P
0 0 0 r
s
P
p
.80381 .22935 m .83147 .23684 L .81438 .24039 L 1 0 0 r
F
P
p
.78669 .23297 m .80381 .22935 L .81438 .24039 L 1 0 0 r
F
P
p
.74147 .22907 m .76972 .23656 L .7529 .24012 L 1 0 0 r
F
P
p
.72462 .23269 m .74147 .22907 L .7529 .24012 L 1 .01 0 r
F
P
p
.002 w
.86026 .45352 m .84304 .45612 L .83285 .44804 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81559 .45069 m .83285 .44804 L .84304 .45612 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59686 .46925 m .58088 .48012 L .56701 .4583 L p
1 .198 0 r
F P
0 0 0 r
s
P
p
.002 w
.55097 .4637 m .56701 .4583 L .58088 .48012 L p
1 .26 0 r
F P
0 0 0 r
s
P
p
.67909 .22879 m .70792 .23629 L .69137 .23985 L 1 .063 0 r
F
P
p
.66251 .23241 m .67909 .22879 L .69137 .23985 L 1 .068 0 r
F
P
p
.002 w
.79848 .45332 m .78153 .45592 L .77049 .44784 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7535 .45049 m .77049 .44784 L .78153 .45592 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.48878 .48035 m .50461 .47501 L .51928 .47993 L p
1 .365 0 r
F P
0 0 0 r
s
P
p
.61667 .22851 m .64608 .23601 L .6298 .23957 L 1 .083 0 r
F
P
p
.60036 .23214 m .61667 .22851 L .6298 .23957 L 1 .083 0 r
F
P
p
.5542 .22823 m .5842 .23574 L .56819 .2393 L 1 .156 0 r
F
P
p
.53817 .23186 m .5542 .22823 L .56819 .2393 L 1 .198 0 r
F
P
p
.49169 .22794 m .52228 .23546 L .50654 .23903 L 1 .135 0 r
F
P
p
.47593 .23158 m .49169 .22794 L .50654 .23903 L 1 .177 0 r
F
P
p
.42914 .22766 m .46032 .23518 L .44484 .23875 L 1 .438 0 r
F
P
p
.41366 .2313 m .42914 .22766 L .44484 .23875 L 1 .49 0 r
F
P
p
.36654 .22738 m .39831 .23491 L .3831 .23848 L 1 .49 0 r
F
P
p
.35133 .23102 m .36654 .22738 L .3831 .23848 L 1 .573 0 r
F
P
p
.002 w
.73666 .45312 m .72019 .46406 L .70829 .45609 L p
1 .073 0 r
F P
0 0 0 r
s
P
p
.002 w
.69155 .4587 m .70829 .45609 L .72019 .46406 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.28227 .61954 m .29739 .61761 L .31829 .51814 L p
.333 1 0 r
F P
0 0 0 r
s
P
p
.3039 .2271 m .33626 .23463 L .32132 .23821 L 1 .469 0 r
F
P
p
.28897 .23074 m .3039 .2271 L .32132 .23821 L 1 .531 0 r
F
P
p
.002 w
.67496 .4613 m .65852 .46387 L .64577 .45588 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.6293 .4585 m .64577 .45588 L .65852 .46387 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.24122 .22682 m .27417 .23435 L .2595 .23793 L 1 .583 0 r
F
P
p
.22656 .23047 m .24122 .22682 L .2595 .23793 L 1 .771 0 r
F
P
p
.002 w
.47304 .49127 m .45748 .49371 L .44205 .47764 L p
1 .458 0 r
F P
0 0 0 r
s
P
p
.002 w
.42638 .48862 m .44205 .47764 L .45748 .49371 L p
1 .51 0 r
F P
0 0 0 r
s
P
p
.17849 .22654 m .21204 .23408 L .19764 .23766 L 0 1 .417 r
F
P
p
.16411 .23019 m .17849 .22654 L .19764 .23766 L 0 1 .417 r
F
P
p
.002 w
.23772 .6252 m .25244 .62333 L .27058 .62903 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.61299 .4611 m .59686 .46925 L .5832 .45568 L p
1 .146 0 r
F P
0 0 0 r
s
P
p
.002 w
.56701 .4583 m .5832 .45568 L .59686 .46925 L p
1 .198 0 r
F P
0 0 0 r
s
P
p
.002 w
.22314 .62705 m .20869 .62889 L .18968 .62318 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.41096 .49108 m .39562 .49632 L .37939 .48028 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.36399 .48843 m .37939 .48028 L .39562 .49632 L p
1 .552 0 r
F P
0 0 0 r
s
P
p
.82109 .22569 m .84871 .23325 L .83147 .23684 L 1 0 0 r
F
P
p
.80381 .22935 m .82109 .22569 L .83147 .23684 L 1 0 0 r
F
P
p
.75848 .22541 m .78669 .23297 L .76972 .23656 L 1 0 0 r
F
P
p
.74147 .22907 m .75848 .22541 L .76972 .23656 L 1 0 0 r
F
P
p
.002 w
.87764 .4509 m .86026 .45352 L .85027 .44537 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83285 .44804 m .85027 .44537 L .86026 .45352 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69582 .22513 m .72462 .23269 L .70792 .23629 L 1 .031 0 r
F
P
p
.67909 .22879 m .69582 .22513 L .70792 .23629 L 1 .063 0 r
F
P
p
.002 w
.81559 .45069 m .79848 .45332 L .78763 .44517 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77049 .44784 m .78763 .44517 L .79848 .45332 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.63312 .22484 m .66251 .23241 L .64608 .23601 L 1 .078 0 r
F
P
p
.61667 .22851 m .63312 .22484 L .64608 .23601 L 1 .083 0 r
F
P
p
.002 w
.7535 .45049 m .73666 .45312 L .72503 .44779 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.002 w
.70829 .45609 m .72503 .44779 L .73666 .45312 L p
1 .073 0 r
F P
0 0 0 r
s
P
p
.57038 .22456 m .60036 .23214 L .5842 .23574 L 1 .125 0 r
F
P
p
.5542 .22823 m .57038 .22456 L .5842 .23574 L 1 .156 0 r
F
P
p
.002 w
.3487 .49652 m .33344 .50736 L .31264 .61567 L p
.594 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29739 .61761 m .31264 .61567 L .33344 .50736 L p
.385 1 0 r
F P
0 0 0 r
s
P
p
.50759 .22428 m .53817 .23186 L .52228 .23546 L 1 .125 0 r
F
P
p
.49169 .22794 m .50759 .22428 L .52228 .23546 L 1 .135 0 r
F
P
p
.44476 .22399 m .47593 .23158 L .46032 .23518 L 1 .385 0 r
F
P
p
.42914 .22766 m .44476 .22399 L .46032 .23518 L 1 .438 0 r
F
P
p
.38189 .22371 m .41366 .2313 L .39831 .23491 L 1 .458 0 r
F
P
p
.36654 .22738 m .38189 .22371 L .39831 .23491 L 1 .49 0 r
F
P
p
.31897 .22343 m .35133 .23102 L .33626 .23463 L 1 .417 0 r
F
P
p
.3039 .2271 m .31897 .22343 L .33626 .23463 L 1 .469 0 r
F
P
p
.002 w
.69155 .4587 m .67496 .4613 L .66238 .45324 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.64577 .45588 m .66238 .45324 L .67496 .4613 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.25601 .22314 m .28897 .23074 L .27417 .23435 L 1 .552 0 r
F
P
p
.24122 .22682 m .25601 .22314 L .27417 .23435 L 1 .583 0 r
F
P
p
.002 w
.6293 .4585 m .61299 .4611 L .59953 .45304 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.002 w
.5832 .45568 m .59953 .45304 L .61299 .4611 L p
1 .146 0 r
F P
0 0 0 r
s
P
p
.002 w
.48878 .48035 m .47304 .49127 L .45779 .46942 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.002 w
.44205 .47764 m .45779 .46942 L .47304 .49127 L p
1 .458 0 r
F P
0 0 0 r
s
P
p
.193 .22286 m .22656 .23047 L .21204 .23408 L .146 1 0 r
F
P
p
.17849 .22654 m .193 .22286 L .21204 .23408 L 0 1 .417 r
F
P
p
.002 w
.42638 .48862 m .41096 .49108 L .39486 .4749 L p
1 .479 0 r
F P
0 0 0 r
s
P
p
.002 w
.37939 .48028 m .39486 .4749 L .41096 .49108 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.12995 .22257 m .16411 .23019 L .14986 .2338 L 0 1 .417 r
F
P
p
.002 w
.23772 .6252 m .22314 .62705 L .20425 .62129 L p
0 1 .271 r
F P
0 0 0 r
s
P
p
.002 w
.18968 .62318 m .20425 .62129 L .22314 .62705 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.82109 .22569 m .83852 .222 L .84871 .23325 L 1 0 0 r
F
P
p
.002 w
.36399 .48843 m .3487 .49652 L .32919 .57262 L p
.958 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33301 .55775 m .3487 .49652 L p
.32353 .57971 L .594 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34586 .52386 m .32974 .46408 L p
.35889 .49778 L 1 .719 0 r
F P
0 0 0 r
s
P
p
.002 w
.32919 .57262 m .34586 .52386 L .34728 .52108 L p
.958 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34728 .52108 m .36399 .48843 L p
.34159 .54262 L .958 1 0 r
F P
0 0 0 r
s
P
p
.32919 .57262 m .34728 .52108 L .34159 .54262 L .958 1 0 r
F
P
p
.002 w
.37939 .48028 m .36399 .48843 L .34995 .51586 L p
1 .76 0 r
F P
0 0 0 r
s
P
p
.35528 .51092 m .37939 .48028 L .34995 .51586 L 1 .76 0 r
F
P
p
.34882 .52001 m .37939 .48028 L .34728 .52108 L 1 .76 0 r
F
P
p
.002 w
.34995 .51586 m .34728 .52108 L p
.35528 .51092 L 1 .76 0 r
F P
0 0 0 r
s
P
p
.002 w
.34728 .52108 m .34586 .52386 L p
.34882 .52001 L 1 .76 0 r
F P
0 0 0 r
s
P
p
.002 w
.36185 .5012 m .37939 .48028 L p
.34882 .52001 L 1 .76 0 r
F P
0 0 0 r
s
P
p
.002 w
.34586 .52386 m .36185 .5012 L p
.34882 .52001 L 1 .76 0 r
F P
0 0 0 r
s
P
p
.002 w
.36185 .5012 m .35615 .48751 L p
.37311 .48494 L 1 .573 0 r
F P
0 0 0 r
s
P
p
.002 w
.37593 .4844 m .36185 .5012 L p
.38833 .4801 L 1 .604 0 r
F P
0 0 0 r
s
P
p
.38833 .4801 m .39486 .4749 L .37593 .4844 L 1 .604 0 r
F
P
p
.002 w
.37777 .48423 m .39299 .47592 L p
.36949 .49499 L 1 .604 0 r
F P
0 0 0 r
s
P
p
.002 w
.36185 .5012 m .37777 .48423 L p
.36949 .49499 L 1 .604 0 r
F P
0 0 0 r
s
P
p
.002 w
.39486 .4749 m .37939 .48028 L .37593 .4844 L p
1 .604 0 r
F P
0 0 0 r
s
P
p
.002 w
.37777 .48423 m .36111 .4529 L p
.38638 .47305 L 1 .49 0 r
F P
0 0 0 r
s
P
p
.36185 .5012 m .39299 .47592 L .38942 .47923 L 1 .604 0 r
F
P
p
.002 w
.4104 .47233 m .42638 .48862 L p
.39838 .47644 L 1 .479 0 r
F P
0 0 0 r
s
P
p
.002 w
.39486 .4749 m .4104 .47233 L p
.39838 .47644 L 1 .479 0 r
F P
0 0 0 r
s
P
p
.002 w
.44205 .47764 m .42638 .48862 L .4104 .47233 L p
1 .438 0 r
F P
0 0 0 r
s
P
p
.002 w
.4104 .47233 m .42613 .46688 L .44205 .47764 L p
1 .438 0 r
F P
0 0 0 r
s
P
p
.002 w
.4104 .47233 m .39355 .47876 L p
.42254 .46819 L 1 .51 0 r
F P
0 0 0 r
s
P
p
.002 w
.42613 .46688 m .4104 .47233 L p
.42254 .46819 L 1 .51 0 r
F P
0 0 0 r
s
P
p
.002 w
.39355 .47876 m .40707 .4736 L p
.38056 .48322 L 1 .531 0 r
F P
0 0 0 r
s
P
p
.002 w
.37777 .48423 m .39355 .47876 L p
.38056 .48322 L 1 .531 0 r
F P
0 0 0 r
s
P
p
.002 w
.40707 .4736 m .4104 .47233 L p
.40394 .47469 L 1 .531 0 r
F P
0 0 0 r
s
P
p
.37777 .48423 m .40707 .4736 L .40394 .47469 L 1 .531 0 r
F
P
p
.002 w
.39299 .47592 m .39486 .4749 L p
.38942 .47923 L 1 .604 0 r
F P
0 0 0 r
s
P
p
.002 w
.4104 .47233 m .39486 .4749 L .37777 .48423 L p
1 .531 0 r
F P
0 0 0 r
s
P
p
.002 w
.39355 .47876 m .40941 .47616 L .42613 .46688 L p
1 .51 0 r
F P
0 0 0 r
s
P
p
.002 w
.39355 .47876 m .37693 .45016 L p
.40693 .47417 L 1 .458 0 r
F P
0 0 0 r
s
P
p
.002 w
.40941 .47616 m .39355 .47876 L p
.40693 .47417 L 1 .458 0 r
F P
0 0 0 r
s
P
p
.002 w
.39355 .47876 m .37777 .48423 L p
.38638 .47305 L 1 .49 0 r
F P
0 0 0 r
s
P
p
.002 w
.37777 .48423 m .36185 .5012 L p
.37583 .48453 L 1 .573 0 r
F P
0 0 0 r
s
P
p
.37311 .48494 m .37583 .48453 L .36185 .5012 L 1 .573 0 r
F
P
p
.002 w
.35615 .48751 m .34528 .46142 L p
.36027 .47194 L 1 .573 0 r
F P
0 0 0 r
s
P
p
.36027 .47194 m .37777 .48423 L .35615 .48751 L 1 .573 0 r
F
P
p
.002 w
.36185 .5012 m .35043 .51739 L p
.35889 .49778 L 1 .719 0 r
F P
0 0 0 r
s
P
p
.002 w
.35043 .51739 m .34586 .52386 L p
.35889 .49778 L 1 .719 0 r
F P
0 0 0 r
s
P
p
.002 w
.31264 .61567 m .32919 .57262 L .33301 .55775 L p
.594 1 0 r
F P
0 0 0 r
s
P
p
.31264 .61567 m .33301 .55775 L .32353 .57971 L .594 1 0 r
F
P
p
.77563 .22172 m .80381 .22935 L .78669 .23297 L 1 0 0 r
F
P
p
.75848 .22541 m .77563 .22172 L .78669 .23297 L 1 0 0 r
F
P
p
.002 w
.85027 .44537 m .86785 .44268 L .87764 .4509 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.7127 .22143 m .74147 .22907 L .72462 .23269 L 1 0 0 r
F
P
p
.69582 .22513 m .7127 .22143 L .72462 .23269 L 1 .031 0 r
F
P
p
.002 w
.83285 .44804 m .81559 .45069 L .80493 .44247 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78763 .44517 m .80493 .44247 L .81559 .45069 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64972 .22115 m .67909 .22879 L .66251 .23241 L 1 .036 0 r
F
P
p
.63312 .22484 m .64972 .22115 L .66251 .23241 L 1 .078 0 r
F
P
p
.002 w
.77049 .44784 m .7535 .45049 L .74205 .4451 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.002 w
.72503 .44779 m .74205 .4451 L .7535 .45049 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.5867 .22086 m .61667 .22851 L .60036 .23214 L 1 .125 0 r
F
P
p
.57038 .22456 m .5867 .22086 L .60036 .23214 L 1 .125 0 r
F
P
p
.52363 .22057 m .5542 .22823 L .53817 .23186 L 1 .125 0 r
F
P
p
.50759 .22428 m .52363 .22057 L .53817 .23186 L 1 .125 0 r
F
P
p
.46052 .22029 m .49169 .22794 L .47593 .23158 L 1 .354 0 r
F
P
p
.44476 .22399 m .46052 .22029 L .47593 .23158 L 1 .385 0 r
F
P
p
.002 w
.50461 .47501 m .48878 .48035 L .4736 .46683 L p
1 .333 0 r
F P
0 0 0 r
s
P
p
.002 w
.45779 .46942 m .4736 .46683 L .48878 .48035 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.39737 .22 m .42914 .22766 L .41366 .2313 L 1 .417 0 r
F
P
p
.38189 .22371 m .39737 .22 L .41366 .2313 L 1 .458 0 r
F
P
p
.33417 .21972 m .36654 .22738 L .35133 .23102 L 1 .396 0 r
F
P
p
.31897 .22343 m .33417 .21972 L .35133 .23102 L 1 .417 0 r
F
P
p
.002 w
.70829 .45609 m .69155 .4587 L .67914 .45057 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.66238 .45324 m .67914 .45057 L .69155 .4587 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.27093 .21943 m .3039 .2271 L .28897 .23074 L 1 .49 0 r
F
P
p
.25601 .22314 m .27093 .21943 L .28897 .23074 L 1 .552 0 r
F
P
p
.002 w
.64577 .45588 m .6293 .4585 L .61595 .44468 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.002 w
.59953 .45304 m .61595 .44468 L .6293 .4585 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.20764 .21914 m .24122 .22682 L .22656 .23047 L .875 1 0 r
F
P
p
.193 .22286 m .20764 .21914 L .22656 .23047 L .146 1 0 r
F
P
p
.002 w
.53665 .46703 m .55288 .46157 L .56701 .4583 L p
1 .229 0 r
F P
0 0 0 r
s
P
p
.002 w
.5832 .45568 m .56701 .4583 L .55288 .46157 L p
1 .198 0 r
F P
0 0 0 r
s
P
p
.14431 .21886 m .17849 .22654 L .16411 .23019 L 0 1 .417 r
F
P
p
.12995 .22257 m .14431 .21886 L .16411 .23019 L 0 1 .417 r
F
P
p
.002 w
.25244 .62333 m .23772 .6252 L .22069 .5788 L p
.115 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20425 .62129 m .22069 .5788 L .23772 .6252 L p
0 1 .271 r
F P
0 0 0 r
s
P
p
.79294 .21799 m .82109 .22569 L .80381 .22935 L 1 0 0 r
F
P
p
.77563 .22172 m .79294 .21799 L .80381 .22935 L 1 0 0 r
F
P
p
.72973 .2177 m .75848 .22541 L .74147 .22907 L 1 0 0 r
F
P
p
.7127 .22143 m .72973 .2177 L .74147 .22907 L 1 0 0 r
F
P
p
.002 w
.85027 .44537 m .83285 .44804 L .82239 .43975 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80493 .44247 m .82239 .43975 L .83285 .44804 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66647 .21742 m .69582 .22513 L .67909 .22879 L 1 0 0 r
F
P
p
.64972 .22115 m .66647 .21742 L .67909 .22879 L 1 .036 0 r
F
P
p
.002 w
.78763 .44517 m .77049 .44784 L .75915 .43954 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74205 .4451 m .75915 .43954 L .77049 .44784 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.60317 .21713 m .63312 .22484 L .61667 .22851 L 1 .125 0 r
F
P
p
.5867 .22086 m .60317 .21713 L .61667 .22851 L 1 .125 0 r
F
P
p
.002 w
.52056 .46962 m .50461 .47501 L .4896 .45566 L p
1 .26 0 r
F P
0 0 0 r
s
P
p
.002 w
.4736 .46683 m .4896 .45566 L .50461 .47501 L p
1 .333 0 r
F P
0 0 0 r
s
P
p
.53982 .21684 m .57038 .22456 L .5542 .22823 L 1 .115 0 r
F
P
p
.52363 .22057 m .53982 .21684 L .5542 .22823 L 1 .125 0 r
F
P
p
.47643 .21655 m .50759 .22428 L .49169 .22794 L 1 .313 0 r
F
P
p
.46052 .22029 m .47643 .21655 L .49169 .22794 L 1 .354 0 r
F
P
p
.41299 .21626 m .44476 .22399 L .42914 .22766 L 1 .365 0 r
F
P
p
.39737 .22 m .41299 .21626 L .42914 .22766 L 1 .417 0 r
F
P
p
.002 w
.45779 .46942 m .44205 .47764 L .42613 .46688 L p
1 .365 0 r
F P
0 0 0 r
s
P
p
.34951 .21597 m .38189 .22371 L .36654 .22738 L 1 .365 0 r
F
P
p
.33417 .21972 m .34951 .21597 L .36654 .22738 L 1 .396 0 r
F
P
p
.002 w
.72503 .44779 m .70829 .45609 L .69605 .44788 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.002 w
.67914 .45057 m .69605 .44788 L .70829 .45609 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.28599 .21568 m .31897 .22343 L .3039 .2271 L 1 .438 0 r
F
P
p
.27093 .21943 m .28599 .21568 L .3039 .2271 L 1 .49 0 r
F
P
p
.002 w
.66238 .45324 m .64577 .45588 L .63257 .44197 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.002 w
.61595 .44468 m .63257 .44197 L .64577 .45588 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.002 w
.26728 .62144 m .25244 .62333 L .23815 .51072 L p
.365 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.23815 .51072 m .25303 .50547 L .26728 .62144 L p
.365 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.22069 .5788 m .23815 .51072 L .25244 .62333 L p
.115 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25303 .50547 m .23815 .51072 L .22006 .48604 L p
1 .74 0 r
F P
0 0 0 r
s
P
p
.002 w
.23815 .51072 m .22069 .5788 L .20324 .53451 L p
.844 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20324 .53451 m .22006 .48604 L .23815 .51072 L p
.844 1 0 r
F P
0 0 0 r
s
P
p
.22242 .21539 m .25601 .22314 L .24122 .22682 L 1 .854 0 r
F
P
p
.20764 .21914 m .22242 .21539 L .24122 .22682 L .875 1 0 r
F
P
p
.002 w
.59953 .45304 m .5832 .45568 L .56924 .45605 L p
1 .156 0 r
F P
0 0 0 r
s
P
p
.002 w
.55288 .46157 m .56924 .45605 L .5832 .45568 L p
1 .198 0 r
F P
0 0 0 r
s
P
p
.15881 .2151 m .193 .22286 L .17849 .22654 L 0 1 .135 r
F
P
p
.14431 .21886 m .15881 .2151 L .17849 .22654 L 0 1 .417 r
F
P
p
.002 w
.20425 .62129 m .18968 .62318 L .17015 .61732 L p
0 1 .271 r
F P
0 0 0 r
s
P
p
.81041 .21423 m .83852 .222 L .82109 .22569 L 1 0 0 r
F
P
p
.79294 .21799 m .81041 .21423 L .82109 .22569 L 1 0 0 r
F
P
p
.74692 .21394 m .77563 .22172 L .75848 .22541 L 1 0 0 r
F
P
p
.72973 .2177 m .74692 .21394 L .75848 .22541 L 1 0 0 r
F
P
p
.002 w
.86785 .44268 m .85027 .44537 L .84 .437 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82239 .43975 m .84 .437 L .85027 .44537 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68338 .21365 m .7127 .22143 L .69582 .22513 L 1 0 0 r
F
P
p
.66647 .21742 m .68338 .21365 L .69582 .22513 L 1 0 0 r
F
P
p
.002 w
.80493 .44247 m .78763 .44517 L .77648 .43679 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75915 .43954 m .77648 .43679 L .78763 .44517 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.4896 .45566 m .50571 .44726 L .52056 .46962 L p
1 .26 0 r
F P
0 0 0 r
s
P
p
.61979 .21336 m .64972 .22115 L .63312 .22484 L 1 .104 0 r
F
P
p
.60317 .21713 m .61979 .21336 L .63312 .22484 L 1 .125 0 r
F
P
p
.002 w
.4736 .46683 m .45779 .46942 L .44198 .46138 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.002 w
.44198 .46138 m .45779 .46942 L p
.43012 .4672 L 1 .365 0 r
F P
0 0 0 r
s
P
p
.002 w
.44198 .46138 m .45801 .45296 L .4736 .46683 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.002 w
.44198 .46138 m .42542 .47353 L p
.45398 .4555 L 1 .438 0 r
F P
0 0 0 r
s
P
p
.002 w
.45801 .45296 m .44198 .46138 L p
.45398 .4555 L 1 .438 0 r
F P
0 0 0 r
s
P
p
.002 w
.42613 .46688 m .44198 .46138 L p
.43012 .4672 L 1 .365 0 r
F P
0 0 0 r
s
P
p
.55616 .21307 m .5867 .22086 L .57038 .22456 L 1 .094 0 r
F
P
p
.53982 .21684 m .55616 .21307 L .57038 .22456 L 1 .115 0 r
F
P
p
.002 w
.74205 .4451 m .72503 .44779 L .71312 .44517 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.69605 .44788 m .71312 .44517 L .72503 .44779 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.49248 .21278 m .52363 .22057 L .50759 .22428 L 1 .292 0 r
F
P
p
.47643 .21655 m .49248 .21278 L .50759 .22428 L 1 .313 0 r
F
P
p
.42876 .21249 m .46052 .22029 L .44476 .22399 L 1 .323 0 r
F
P
p
.41299 .21626 m .42876 .21249 L .44476 .22399 L 1 .365 0 r
F
P
p
.365 .2122 m .39737 .22 L .38189 .22371 L 1 .323 0 r
F
P
p
.34951 .21597 m .365 .2122 L .38189 .22371 L 1 .365 0 r
F
P
p
.002 w
.28227 .61954 m .26728 .62144 L .25303 .50547 L p
.396 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25303 .50547 m .26815 .49732 L .28227 .61954 L p
.396 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26815 .49732 m .25303 .50547 L .23493 .48351 L p
1 .688 0 r
F P
0 0 0 r
s
P
p
.002 w
.23493 .48351 m .25303 .50547 L p
.22295 .48774 L 1 .74 0 r
F P
0 0 0 r
s
P
p
.002 w
.23493 .48351 m .25015 .47517 L .26815 .49732 L p
1 .688 0 r
F P
0 0 0 r
s
P
p
.002 w
.22006 .48604 m .23493 .48351 L p
.22295 .48774 L 1 .74 0 r
F P
0 0 0 r
s
P
p
.002 w
.22069 .5788 m .20425 .62129 L .18807 .57788 L p
.156 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.18807 .57788 m .18678 .57443 L p
.18916 .57474 L .156 1 0 r
F P
0 0 0 r
s
P
p
.18916 .57474 m .22069 .5788 L .18807 .57788 L .156 1 0 r
F
P
p
.002 w
.20324 .53451 m .22069 .5788 L p
.18916 .57474 L .156 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.18678 .57443 m .20324 .53451 L p
.18916 .57474 L .156 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.17015 .61732 m .18678 .57443 L .20425 .62129 L p
0 1 .271 r
F P
0 0 0 r
s
P
p
.002 w
.20324 .53451 m .17979 .60727 L p
.21732 .49429 L .313 1 0 r
F P
0 0 0 r
s
P
p
.21732 .49429 m .21915 .48879 L .20324 .53451 L .313 1 0 r
F
P
p
.002 w
.22006 .48604 m .21166 .51026 L p
.21915 .48879 L .313 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.21166 .51026 m .20324 .53451 L p
.21915 .48879 L .313 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.23493 .48351 m .22006 .48604 L .19487 .60523 L p
.76 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.19487 .60523 m .21366 .52252 L .23493 .48351 L p
.76 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.23493 .48351 m .21366 .52252 L p
.24703 .47922 L 1 .771 0 r
F P
0 0 0 r
s
P
p
.002 w
.25015 .47517 m .23493 .48351 L p
.24703 .47922 L 1 .771 0 r
F P
0 0 0 r
s
P
p
.30119 .2119 m .33417 .21972 L .31897 .22343 L 1 .417 0 r
F
P
p
.28599 .21568 m .30119 .2119 L .31897 .22343 L 1 .438 0 r
F
P
p
.002 w
.67914 .45057 m .66238 .45324 L .64934 .43922 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.63257 .44197 m .64934 .43922 L .66238 .45324 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.23733 .21161 m .27093 .21943 L .25601 .22314 L 1 .708 0 r
F
P
p
.22242 .21539 m .23733 .21161 L .25601 .22314 L 1 .854 0 r
F
P
p
.002 w
.61595 .44468 m .59953 .45304 L .5857 .44475 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.002 w
.56924 .45605 m .5857 .44475 L .59953 .45304 L p
1 .156 0 r
F P
0 0 0 r
s
P
p
.17343 .21132 m .20764 .21914 L .193 .22286 L .427 1 0 r
F
P
p
.15881 .2151 m .17343 .21132 L .193 .22286 L 0 1 .135 r
F
P
p
.81041 .21423 m .82804 .21044 L .83852 .222 L 1 0 0 r
F
P
p
.76426 .21015 m .79294 .21799 L .77563 .22172 L 1 0 0 r
F
P
p
.74692 .21394 m .76426 .21015 L .77563 .22172 L 1 0 0 r
F
P
p
.002 w
.84 .437 m .85778 .43423 L .86785 .44268 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70043 .20985 m .72973 .2177 L .7127 .22143 L 1 0 0 r
F
P
p
.68338 .21365 m .70043 .20985 L .7127 .22143 L 1 0 0 r
F
P
p
.002 w
.82239 .43975 m .80493 .44247 L .79397 .43401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77648 .43679 m .79397 .43401 L .80493 .44247 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.55288 .46157 m .53665 .46703 L .52192 .44454 L p
1 .219 0 r
F P
0 0 0 r
s
P
p
.002 w
.50571 .44726 m .52192 .44454 L .53665 .46703 L p
1 .229 0 r
F P
0 0 0 r
s
P
p
.63656 .20956 m .66647 .21742 L .64972 .22115 L 1 .042 0 r
F
P
p
.61979 .21336 m .63656 .20956 L .64972 .22115 L 1 .104 0 r
F
P
p
.002 w
.4896 .45566 m .4736 .46683 L .45801 .45296 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.57265 .20927 m .60317 .21713 L .5867 .22086 L 1 .073 0 r
F
P
p
.55616 .21307 m .57265 .20927 L .5867 .22086 L 1 .094 0 r
F
P
p
.002 w
.75915 .43954 m .74205 .4451 L .73012 .4338 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.002 w
.71312 .44517 m .73012 .4338 L .74205 .4451 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.50868 .20897 m .53982 .21684 L .52363 .22057 L 1 .281 0 r
F
P
p
.49248 .21278 m .50868 .20897 L .52363 .22057 L 1 .292 0 r
F
P
p
.002 w
.29739 .61761 m .28227 .61954 L .26815 .49732 L p
.448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26815 .49732 m .28347 .48624 L .29739 .61761 L p
.448 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28347 .48624 m .26815 .49732 L .25015 .47517 L p
1 .615 0 r
F P
0 0 0 r
s
P
p
.44467 .20868 m .47643 .21655 L .46052 .22029 L 1 .292 0 r
F
P
p
.42876 .21249 m .44467 .20868 L .46052 .22029 L 1 .323 0 r
F
P
p
.002 w
.63257 .44197 m .61595 .44468 L .60235 .442 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.002 w
.5857 .44475 m .60235 .442 L .61595 .44468 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.38062 .20838 m .41299 .21626 L .39737 .22 L 1 .25 0 r
F
P
p
.365 .2122 m .38062 .20838 L .39737 .22 L 1 .323 0 r
F
P
p
.31652 .20809 m .34951 .21597 L .33417 .21972 L 1 .417 0 r
F
P
p
.30119 .2119 m .31652 .20809 L .33417 .21972 L 1 .417 0 r
F
P
p
.002 w
.69605 .44788 m .67914 .45057 L .66624 .43502 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.64934 .43922 m .66624 .43502 L .67914 .45057 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.25238 .20779 m .28599 .21568 L .27093 .21943 L 1 .604 0 r
F
P
p
.23733 .21161 m .25238 .20779 L .27093 .21943 L 1 .708 0 r
F
P
p
.18819 .2075 m .22242 .21539 L .20764 .21914 L .844 1 0 r
F
P
p
.17343 .21132 m .18819 .2075 L .20764 .21914 L .427 1 0 r
F
P
p
.002 w
.50571 .44726 m .4896 .45566 L .47413 .44735 L p
1 .177 0 r
F P
0 0 0 r
s
P
p
.002 w
.45801 .45296 m .47413 .44735 L .4896 .45566 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.78177 .20632 m .81041 .21423 L .79294 .21799 L 1 0 0 r
F
P
p
.76426 .21015 m .78177 .20632 L .79294 .21799 L 1 0 0 r
F
P
p
.002 w
.56924 .45605 m .55288 .46157 L .53829 .44179 L p
1 .198 0 r
F P
0 0 0 r
s
P
p
.002 w
.52192 .44454 m .53829 .44179 L .55288 .46157 L p
1 .219 0 r
F P
0 0 0 r
s
P
p
.002 w
.31264 .61567 m .29739 .61761 L .28347 .48624 L p
.479 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28347 .48624 m .29862 .4837 L .31264 .61567 L p
.479 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29862 .4837 m .28347 .48624 L .26528 .47256 L p
1 .563 0 r
F P
0 0 0 r
s
P
p
.002 w
.25015 .47517 m .26528 .47256 L .28347 .48624 L p
1 .615 0 r
F P
0 0 0 r
s
P
p
.71765 .20602 m .74692 .21394 L .72973 .2177 L 1 0 0 r
F
P
p
.70043 .20985 m .71765 .20602 L .72973 .2177 L 1 0 0 r
F
P
p
.002 w
.84 .437 m .82239 .43975 L .81162 .43121 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79397 .43401 m .81162 .43121 L .82239 .43975 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.17979 .60727 m .19487 .60523 L .22006 .48604 L p
.313 1 0 r
F P
0 0 0 r
s
P
p
.65349 .20572 m .68338 .21365 L .66647 .21742 L 1 0 0 r
F
P
p
.63656 .20956 m .65349 .20572 L .66647 .21742 L 1 .042 0 r
F
P
p
.002 w
.77648 .43679 m .75915 .43954 L .74748 .43099 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73012 .4338 m .74748 .43099 L .75915 .43954 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.58928 .20543 m .61979 .21336 L .60317 .21713 L 1 .063 0 r
F
P
p
.57265 .20927 m .58928 .20543 L .60317 .21713 L 1 .073 0 r
F
P
p
.52503 .20513 m .55616 .21307 L .53982 .21684 L 1 .26 0 r
F
P
p
.50868 .20897 m .52503 .20513 L .53982 .21684 L 1 .281 0 r
F
P
p
.002 w
.44198 .46138 m .42613 .46688 L .40941 .47616 L p
1 .49 0 r
F P
0 0 0 r
s
P
p
.46073 .20483 m .49248 .21278 L .47643 .21655 L 1 .26 0 r
F
P
p
.44467 .20868 m .46073 .20483 L .47643 .21655 L 1 .292 0 r
F
P
p
.002 w
.64934 .43922 m .63257 .44197 L .61916 .43923 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.002 w
.60235 .442 m .61916 .43923 L .63257 .44197 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.39639 .20454 m .42876 .21249 L .41299 .21626 L 1 .188 0 r
F
P
p
.38062 .20838 m .39639 .20454 L .41299 .21626 L 1 .25 0 r
F
P
p
.002 w
.18678 .57443 m .17015 .61732 L .15005 .61128 L p
0 1 .271 r
F P
0 0 0 r
s
P
p
.002 w
.15005 .61128 m .16485 .60928 L .18678 .57443 L p
0 1 .271 r
F P
0 0 0 r
s
P
p
.002 w
.20324 .53451 m .18678 .57443 L .16485 .60928 L p
.01 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.16485 .60928 m .17979 .60727 L .20324 .53451 L p
.01 1 0 r
F P
0 0 0 r
s
P
p
.332 .20424 m .365 .2122 L .34951 .21597 L 1 .406 0 r
F
P
p
.31652 .20809 m .332 .20424 L .34951 .21597 L 1 .417 0 r
F
P
p
.002 w
.71312 .44517 m .69605 .44788 L .68329 .43078 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.66624 .43502 m .68329 .43078 L .69605 .44788 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.26757 .20394 m .30119 .2119 L .28599 .21568 L 1 .531 0 r
F
P
p
.25238 .20779 m .26757 .20394 L .28599 .21568 L 1 .604 0 r
F
P
p
.20309 .20364 m .23733 .21161 L .22242 .21539 L 1 .885 0 r
F
P
p
.18819 .2075 m .20309 .20364 L .22242 .21539 L .844 1 0 r
F
P
p
.002 w
.52192 .44454 m .50571 .44726 L .49038 .4417 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.002 w
.47413 .44735 m .49038 .4417 L .50571 .44726 L p
1 .177 0 r
F P
0 0 0 r
s
P
p
.002 w
.5857 .44475 m .56924 .45605 L .5548 .43902 L p
1 .156 0 r
F P
0 0 0 r
s
P
p
.002 w
.53829 .44179 m .5548 .43902 L .56924 .45605 L p
1 .198 0 r
F P
0 0 0 r
s
P
p
.79943 .20245 m .82804 .21044 L .81041 .21423 L 1 0 0 r
F
P
p
.78177 .20632 m .79943 .20245 L .81041 .21423 L 1 0 0 r
F
P
p
.002 w
.32919 .57262 m .31264 .61567 L .29862 .4837 L p
.635 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29862 .4837 m .31399 .47826 L .32919 .57262 L p
.635 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31399 .47826 m .29862 .4837 L .28075 .46411 L p
1 .531 0 r
F P
0 0 0 r
s
P
p
.002 w
.26528 .47256 m .28075 .46411 L .29862 .4837 L p
1 .563 0 r
F P
0 0 0 r
s
P
p
.73503 .20215 m .76426 .21015 L .74692 .21394 L 1 0 0 r
F
P
p
.71765 .20602 m .73503 .20215 L .74692 .21394 L 1 0 0 r
F
P
p
.002 w
.34586 .52386 m .32919 .57262 L .31399 .47826 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31399 .47826 m .32974 .46408 L .34586 .52386 L p
1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.85778 .43423 m .84 .437 L .82944 .42838 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81162 .43121 m .82944 .42838 L .84 .437 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67058 .20185 m .70043 .20985 L .68338 .21365 L 1 0 0 r
F
P
p
.65349 .20572 m .67058 .20185 L .68338 .21365 L 1 0 0 r
F
P
p
.002 w
.79397 .43401 m .77648 .43679 L .76501 .42817 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74748 .43099 m .76501 .42817 L .77648 .43679 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60608 .20155 m .63656 .20956 L .61979 .21336 L 1 .042 0 r
F
P
p
.58928 .20543 m .60608 .20155 L .61979 .21336 L 1 .063 0 r
F
P
p
.002 w
.40941 .47616 m .42542 .47353 L .44198 .46138 L p
1 .49 0 r
F P
0 0 0 r
s
P
p
.54153 .20125 m .57265 .20927 L .55616 .21307 L 1 .24 0 r
F
P
p
.52503 .20513 m .54153 .20125 L .55616 .21307 L 1 .26 0 r
F
P
p
.47694 .20095 m .50868 .20897 L .49248 .21278 L 1 .24 0 r
F
P
p
.46073 .20483 m .47694 .20095 L .49248 .21278 L 1 .26 0 r
F
P
p
.002 w
.66624 .43502 m .64934 .43922 L .63612 .43644 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.002 w
.61916 .43923 m .63612 .43644 L .64934 .43922 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.41231 .20065 m .44467 .20868 L .42876 .21249 L 1 .135 0 r
F
P
p
.39639 .20454 m .41231 .20065 L .42876 .21249 L 1 .188 0 r
F
P
p
.002 w
.32974 .46408 m .34528 .46142 L .36185 .5012 L p
1 .719 0 r
F P
0 0 0 r
s
P
p
.34762 .20035 m .38062 .20838 L .365 .2122 L 1 .365 0 r
F
P
p
.332 .20424 m .34762 .20035 L .365 .2122 L 1 .406 0 r
F
P
p
.002 w
.73012 .4338 m .71312 .44517 L .70053 .42795 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.68329 .43078 m .70053 .42795 L .71312 .44517 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.2829 .20005 m .31652 .20809 L .30119 .2119 L 1 .5 0 r
F
P
p
.26757 .20394 m .2829 .20005 L .30119 .2119 L 1 .531 0 r
F
P
p
.21812 .19975 m .25238 .20779 L .23733 .21161 L 1 .719 0 r
F
P
p
.20309 .20364 m .21812 .19975 L .23733 .21161 L 1 .885 0 r
F
P
p
.002 w
.60235 .442 m .5857 .44475 L .57147 .43622 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.5548 .43902 m .57147 .43622 L .5857 .44475 L p
1 .156 0 r
F P
0 0 0 r
s
P
p
.002 w
.53829 .44179 m .52192 .44454 L .50678 .43601 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.49038 .4417 m .50678 .43601 L .52192 .44454 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.002 w
.26528 .47256 m .25015 .47517 L .23086 .47292 L p
1 .583 0 r
F P
0 0 0 r
s
P
p
.002 w
.21366 .52252 m .23086 .47292 L .25015 .47517 L p
1 .771 0 r
F P
0 0 0 r
s
P
p
.002 w
.32974 .46408 m .31399 .47826 L .29615 .46143 L p
1 .469 0 r
F P
0 0 0 r
s
P
p
.002 w
.28075 .46411 m .29615 .46143 L .31399 .47826 L p
1 .531 0 r
F P
0 0 0 r
s
P
p
.79943 .20245 m .81727 .19855 L .82804 .21044 L 1 0 0 r
F
P
p
.002 w
.34528 .46142 m .36111 .4529 L .37777 .48423 L p
1 .573 0 r
F P
0 0 0 r
s
P
p
.75257 .19825 m .78177 .20632 L .76426 .21015 L 1 0 0 r
F
P
p
.73503 .20215 m .75257 .19825 L .76426 .21015 L 1 0 0 r
F
P
p
.002 w
.47413 .44735 m .45801 .45296 L .44166 .46501 L p
1 .385 0 r
F P
0 0 0 r
s
P
p
.002 w
.44166 .46501 m .45801 .45296 L p
.42889 .47134 L 1 .438 0 r
F P
0 0 0 r
s
P
p
.002 w
.44166 .46501 m .45796 .46231 L .47413 .44735 L p
1 .385 0 r
F P
0 0 0 r
s
P
p
.002 w
.44166 .46501 m .4255 .427 L p
.45456 .45861 L 1 .323 0 r
F P
0 0 0 r
s
P
p
.002 w
.45796 .46231 m .44166 .46501 L p
.45456 .45861 L 1 .323 0 r
F P
0 0 0 r
s
P
p
.002 w
.42542 .47353 m .44166 .46501 L p
.42889 .47134 L 1 .438 0 r
F P
0 0 0 r
s
P
p
.002 w
.82944 .42838 m .84742 .42553 L .85778 .43423 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.68782 .19794 m .71765 .20602 L .70043 .20985 L 1 0 0 r
F
P
p
.67058 .20185 m .68782 .19794 L .70043 .20985 L 1 0 0 r
F
P
p
.002 w
.81162 .43121 m .79397 .43401 L .78269 .42531 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76501 .42817 m .78269 .42531 L .79397 .43401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.62303 .19764 m .65349 .20572 L .63656 .20956 L 1 .01 0 r
F
P
p
.60608 .20155 m .62303 .19764 L .63656 .20956 L 1 .042 0 r
F
P
p
.002 w
.74748 .43099 m .73012 .4338 L .71792 .42509 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70053 .42795 m .71792 .42509 L .73012 .4338 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.55819 .19734 m .58928 .20543 L .57265 .20927 L 1 .198 0 r
F
P
p
.54153 .20125 m .55819 .19734 L .57265 .20927 L 1 .24 0 r
F
P
p
.4933 .19704 m .52503 .20513 L .50868 .20897 L 1 .219 0 r
F
P
p
.47694 .20095 m .4933 .19704 L .50868 .20897 L 1 .24 0 r
F
P
p
.002 w
.68329 .43078 m .66624 .43502 L .65325 .43362 L p
1 .036 0 r
F P
0 0 0 r
s
P
p
.002 w
.63612 .43644 m .65325 .43362 L .66624 .43502 L p
1 .078 0 r
F P
0 0 0 r
s
P
p
.42837 .19673 m .46073 .20483 L .44467 .20868 L 1 .094 0 r
F
P
p
.41231 .20065 m .42837 .19673 L .44467 .20868 L 1 .135 0 r
F
P
p
.36339 .19643 m .39639 .20454 L .38062 .20838 L 1 .302 0 r
F
P
p
.34762 .20035 m .36339 .19643 L .38062 .20838 L 1 .365 0 r
F
P
p
.29837 .19613 m .332 .20424 L .31652 .20809 L 1 .479 0 r
F
P
p
.2829 .20005 m .29837 .19613 L .31652 .20809 L 1 .5 0 r
F
P
p
.002 w
.34528 .46142 m .32974 .46408 L .31178 .4558 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.002 w
.29615 .46143 m .31178 .4558 L .32974 .46408 L p
1 .469 0 r
F P
0 0 0 r
s
P
p
.2333 .19582 m .26757 .20394 L .25238 .20779 L 1 .656 0 r
F
P
p
.21812 .19975 m .2333 .19582 L .25238 .20779 L 1 .719 0 r
F
P
p
.002 w
.61916 .43923 m .60235 .442 L .5883 .4334 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.57147 .43622 m .5883 .4334 L .60235 .442 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.5548 .43902 m .53829 .44179 L .52331 .43318 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.50678 .43601 m .52331 .43318 L .53829 .44179 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.28075 .46411 m .26528 .47256 L .24612 .47026 L p
1 .552 0 r
F P
0 0 0 r
s
P
p
.002 w
.24612 .47026 m .26528 .47256 L p
.2378 .47285 L 1 .583 0 r
F P
0 0 0 r
s
P
p
.002 w
.24612 .47026 m .26164 .46463 L .28075 .46411 L p
1 .552 0 r
F P
0 0 0 r
s
P
p
.002 w
.23086 .47292 m .24612 .47026 L p
.2378 .47285 L 1 .583 0 r
F P
0 0 0 r
s
P
p
.002 w
.23086 .47292 m .21366 .52252 L .19375 .51497 L p
.875 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24612 .47026 m .23086 .47292 L .20909 .51247 L p
1 .854 0 r
F P
0 0 0 r
s
P
p
.002 w
.19375 .51497 m .20909 .51247 L .23086 .47292 L p
.875 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20909 .51247 m .22586 .47986 L .24612 .47026 L p
1 .854 0 r
F P
0 0 0 r
s
P
p
.002 w
.24612 .47026 m .22586 .47986 L p
.25456 .46764 L 1 .708 0 r
F P
0 0 0 r
s
P
p
.002 w
.26164 .46463 m .24612 .47026 L p
.25456 .46764 L 1 .708 0 r
F P
0 0 0 r
s
P
p
.002 w
.36111 .4529 m .37693 .45016 L .39355 .47876 L p
1 .49 0 r
F P
0 0 0 r
s
P
p
.002 w
.49038 .4417 m .47413 .44735 L .45796 .46231 L p
1 .354 0 r
F P
0 0 0 r
s
P
p
.77027 .1943 m .79943 .20245 L .78177 .20632 L 1 0 0 r
F
P
p
.75257 .19825 m .77027 .1943 L .78177 .20632 L 1 0 0 r
F
P
p
.70523 .194 m .73503 .20215 L .71765 .20602 L 1 0 0 r
F
P
p
.68782 .19794 m .70523 .194 L .71765 .20602 L 1 0 0 r
F
P
p
.002 w
.82944 .42838 m .81162 .43121 L .80055 .42243 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78269 .42531 m .80055 .42243 L .81162 .43121 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64014 .19369 m .67058 .20185 L .65349 .20572 L 1 0 0 r
F
P
p
.62303 .19764 m .64014 .19369 L .65349 .20572 L 1 .01 0 r
F
P
p
.002 w
.76501 .42817 m .74748 .43099 L .73548 .42221 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71792 .42509 m .73548 .42221 L .74748 .43099 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.575 .19339 m .60608 .20155 L .58928 .20543 L 1 .167 0 r
F
P
p
.55819 .19734 m .575 .19339 L .58928 .20543 L 1 .198 0 r
F
P
p
.002 w
.70053 .42795 m .68329 .43078 L .67036 .42198 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65325 .43362 m .67036 .42198 L .68329 .43078 L p
1 .036 0 r
F P
0 0 0 r
s
P
p
.50982 .19308 m .54153 .20125 L .52503 .20513 L 1 .208 0 r
F
P
p
.4933 .19704 m .50982 .19308 L .52503 .20513 L 1 .219 0 r
F
P
p
.44459 .19278 m .47694 .20095 L .46073 .20483 L 1 .083 0 r
F
P
p
.42837 .19673 m .44459 .19278 L .46073 .20483 L 1 .094 0 r
F
P
p
.37931 .19247 m .41231 .20065 L .39639 .20454 L 1 .25 0 r
F
P
p
.36339 .19643 m .37931 .19247 L .39639 .20454 L 1 .302 0 r
F
P
p
.31399 .19217 m .34762 .20035 L .332 .20424 L 1 .458 0 r
F
P
p
.29837 .19613 m .31399 .19217 L .332 .20424 L 1 .479 0 r
F
P
p
.002 w
.36111 .4529 m .34528 .46142 L .32746 .45305 L p
1 .396 0 r
F P
0 0 0 r
s
P
p
.002 w
.31178 .4558 m .32746 .45305 L .34528 .46142 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.24861 .19186 m .2829 .20005 L .26757 .20394 L 1 .594 0 r
F
P
p
.2333 .19582 m .24861 .19186 L .26757 .20394 L 1 .656 0 r
F
P
p
.002 w
.63612 .43644 m .61916 .43923 L .60528 .43055 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.5883 .4334 m .60528 .43055 L .61916 .43923 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.57147 .43622 m .5548 .43902 L .53999 .43033 L p
1 .115 0 r
F P
0 0 0 r
s
P
p
.002 w
.53999 .43033 m .5548 .43902 L p
.52728 .43392 L 1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.53999 .43033 m .55682 .4245 L .57147 .43622 L p
1 .115 0 r
F P
0 0 0 r
s
P
p
.002 w
.53999 .43033 m .52472 .44226 L p
.55286 .4267 L 1 .26 0 r
F P
0 0 0 r
s
P
p
.002 w
.55682 .4245 m .53999 .43033 L p
.55286 .4267 L 1 .26 0 r
F P
0 0 0 r
s
P
p
.002 w
.52331 .43318 m .53999 .43033 L p
.52728 .43392 L 1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.29615 .46143 m .28075 .46411 L .26164 .46463 L p
1 .49 0 r
F P
0 0 0 r
s
P
p
.002 w
.50678 .43601 m .49038 .4417 L .47443 .45662 L p
1 .313 0 r
F P
0 0 0 r
s
P
p
.002 w
.45796 .46231 m .47443 .45662 L .49038 .4417 L p
1 .354 0 r
F P
0 0 0 r
s
P
p
.002 w
.16485 .60928 m .15005 .61128 L .12937 .60507 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.42542 .47353 m .40941 .47616 L .39301 .44152 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.002 w
.37693 .45016 m .39301 .44152 L .40941 .47616 L p
1 .458 0 r
F P
0 0 0 r
s
P
p
.78814 .19032 m .81727 .19855 L .79943 .20245 L 1 0 0 r
F
P
p
.77027 .1943 m .78814 .19032 L .79943 .20245 L 1 0 0 r
F
P
p
.7228 .19002 m .75257 .19825 L .73503 .20215 L 1 0 0 r
F
P
p
.70523 .194 m .7228 .19002 L .73503 .20215 L 1 0 0 r
F
P
p
.002 w
.84742 .42553 m .82944 .42838 L .81857 .41952 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80055 .42243 m .81857 .41952 L .82944 .42838 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.65741 .18971 m .68782 .19794 L .67058 .20185 L 1 0 0 r
F
P
p
.64014 .19369 m .65741 .18971 L .67058 .20185 L 1 0 0 r
F
P
p
.002 w
.78269 .42531 m .76501 .42817 L .7532 .4193 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73548 .42221 m .7532 .4193 L .76501 .42817 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.59197 .1894 m .62303 .19764 L .60608 .20155 L 1 .115 0 r
F
P
p
.575 .19339 m .59197 .1894 L .60608 .20155 L 1 .167 0 r
F
P
p
.002 w
.71792 .42509 m .70053 .42795 L .68778 .41907 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67036 .42198 m .68778 .41907 L .70053 .42795 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.52649 .18909 m .55819 .19734 L .54153 .20125 L 1 .208 0 r
F
P
p
.50982 .19308 m .52649 .18909 L .54153 .20125 L 1 .208 0 r
F
P
p
.002 w
.37693 .45016 m .36111 .4529 L .34328 .45028 L p
1 .365 0 r
F P
0 0 0 r
s
P
p
.002 w
.32746 .45305 m .34328 .45028 L .36111 .4529 L p
1 .396 0 r
F P
0 0 0 r
s
P
p
.46096 .18878 m .4933 .19704 L .47694 .20095 L 1 .073 0 r
F
P
p
.44459 .19278 m .46096 .18878 L .47694 .20095 L 1 .083 0 r
F
P
p
.39538 .18848 m .42837 .19673 L .41231 .20065 L 1 .208 0 r
F
P
p
.37931 .19247 m .39538 .18848 L .41231 .20065 L 1 .25 0 r
F
P
p
.32975 .18817 m .36339 .19643 L .34762 .20035 L 1 .406 0 r
F
P
p
.31399 .19217 m .32975 .18817 L .34762 .20035 L 1 .458 0 r
F
P
p
.26408 .18786 m .29837 .19613 L .2829 .20005 L 1 .531 0 r
F
P
p
.24861 .19186 m .26408 .18786 L .2829 .20005 L 1 .594 0 r
F
P
p
.002 w
.65325 .43362 m .63612 .43644 L .62243 .42767 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.002 w
.60528 .43055 m .62243 .42767 L .63612 .43644 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.5883 .4334 m .57147 .43622 L .55682 .4245 L p
1 .094 0 r
F P
0 0 0 r
s
P
p
.002 w
.31178 .4558 m .29615 .46143 L .27751 .45303 L p
1 .438 0 r
F P
0 0 0 r
s
P
p
.002 w
.26164 .46463 m .27751 .45303 L .29615 .46143 L p
1 .49 0 r
F P
0 0 0 r
s
P
p
.002 w
.52331 .43318 m .50678 .43601 L .49105 .45089 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.49105 .45089 m .50678 .43601 L p
.47616 .45552 L 1 .313 0 r
F P
0 0 0 r
s
P
p
.002 w
.49105 .45089 m .5078 .44808 L .52331 .43318 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.49105 .45089 m .4752 .41222 L p
.50609 .4462 L 1 .24 0 r
F P
0 0 0 r
s
P
p
.002 w
.5078 .44808 m .49105 .45089 L p
.50609 .4462 L 1 .24 0 r
F P
0 0 0 r
s
P
p
.002 w
.47443 .45662 m .49105 .45089 L p
.47616 .45552 L 1 .313 0 r
F P
0 0 0 r
s
P
p
.002 w
.17979 .60727 m .16485 .60928 L .14429 .60301 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.12937 .60507 m .14429 .60301 L .16485 .60928 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.44166 .46501 m .42542 .47353 L .40921 .43282 L p
1 .365 0 r
F P
0 0 0 r
s
P
p
.002 w
.39301 .44152 m .40921 .43282 L .42542 .47353 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.78814 .19032 m .80618 .18631 L .81727 .19855 L 1 0 0 r
F
P
p
.74053 .186 m .77027 .1943 L .75257 .19825 L 1 0 0 r
F
P
p
.7228 .19002 m .74053 .186 L .75257 .19825 L 1 0 0 r
F
P
p
.002 w
.81857 .41952 m .83676 .41659 L .84742 .42553 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67484 .18569 m .70523 .194 L .68782 .19794 L 1 0 0 r
F
P
p
.65741 .18971 m .67484 .18569 L .68782 .19794 L 1 0 0 r
F
P
p
.002 w
.80055 .42243 m .78269 .42531 L .77109 .41636 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7532 .4193 m .77109 .41636 L .78269 .42531 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.6091 .18538 m .64014 .19369 L .62303 .19764 L 1 .052 0 r
F
P
p
.59197 .1894 m .6091 .18538 L .62303 .19764 L 1 .115 0 r
F
P
p
.002 w
.73548 .42221 m .71792 .42509 L .70537 .41613 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68778 .41907 m .70537 .41613 L .71792 .42509 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.54331 .18506 m .575 .19339 L .55819 .19734 L 1 .188 0 r
F
P
p
.52649 .18909 m .54331 .18506 L .55819 .19734 L 1 .208 0 r
F
P
p
.002 w
.39301 .44152 m .37693 .45016 L .35933 .44452 L p
1 .323 0 r
F P
0 0 0 r
s
P
p
.002 w
.34328 .45028 m .35933 .44452 L .37693 .45016 L p
1 .365 0 r
F P
0 0 0 r
s
P
p
.47748 .18475 m .50982 .19308 L .4933 .19704 L 1 .063 0 r
F
P
p
.46096 .18878 m .47748 .18475 L .4933 .19704 L 1 .073 0 r
F
P
p
.41159 .18444 m .44459 .19278 L .42837 .19673 L 1 .156 0 r
F
P
p
.39538 .18848 m .41159 .18444 L .42837 .19673 L 1 .208 0 r
F
P
p
.002 w
.21366 .52252 m .19487 .60523 L .17456 .59884 L p
.146 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.17456 .59884 m .19375 .51497 L .21366 .52252 L p
.146 1 0 r
F P
0 0 0 r
s
P
p
.34566 .18413 m .37931 .19247 L .36339 .19643 L 1 .365 0 r
F
P
p
.32975 .18817 m .34566 .18413 L .36339 .19643 L 1 .406 0 r
F
P
p
.27968 .18382 m .31399 .19217 L .29837 .19613 L 1 .49 0 r
F
P
p
.26408 .18786 m .27968 .18382 L .29837 .19613 L 1 .531 0 r
F
P
p
.002 w
.32746 .45305 m .31178 .4558 L .29329 .44727 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.002 w
.27751 .45303 m .29329 .44727 L .31178 .4558 L p
1 .438 0 r
F P
0 0 0 r
s
P
p
.002 w
.67036 .42198 m .65325 .43362 L .63965 .41886 L p
1 .042 0 r
F P
0 0 0 r
s
P
p
.002 w
.62243 .42767 m .63965 .41886 L .65325 .43362 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.002 w
.60528 .43055 m .5883 .4334 L .5738 .41863 L p
1 .073 0 r
F P
0 0 0 r
s
P
p
.002 w
.55682 .4245 m .5738 .41863 L .5883 .4334 L p
1 .094 0 r
F P
0 0 0 r
s
P
p
.002 w
.40921 .43282 m .4255 .427 L .44166 .46501 L p
1 .365 0 r
F P
0 0 0 r
s
P
p
.002 w
.53999 .43033 m .52331 .43318 L .5078 .44808 L p
1 .281 0 r
F P
0 0 0 r
s
P
p
.002 w
.19487 .60523 m .17979 .60727 L .15935 .60094 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.14429 .60301 m .15935 .60094 L .17979 .60727 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.75844 .18194 m .78814 .19032 L .77027 .1943 L 1 0 0 r
F
P
p
.74053 .186 m .75844 .18194 L .77027 .1943 L 1 0 0 r
F
P
p
.69244 .18163 m .7228 .19002 L .70523 .194 L 1 0 0 r
F
P
p
.67484 .18569 m .69244 .18163 L .70523 .194 L 1 0 0 r
F
P
p
.002 w
.40921 .43282 m .39301 .44152 L .37552 .43871 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.35933 .44452 m .37552 .43871 L .39301 .44152 L p
1 .323 0 r
F P
0 0 0 r
s
P
p
.002 w
.81857 .41952 m .80055 .42243 L .78915 .41339 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77109 .41636 m .78915 .41339 L .80055 .42243 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.62639 .18131 m .65741 .18971 L .64014 .19369 L 1 .031 0 r
F
P
p
.6091 .18538 m .62639 .18131 L .64014 .19369 L 1 .052 0 r
F
P
p
.002 w
.7532 .4193 m .73548 .42221 L .72312 .41316 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70537 .41613 m .72312 .41316 L .73548 .42221 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5603 .181 m .59197 .1894 L .575 .19339 L 1 .167 0 r
F
P
p
.54331 .18506 m .5603 .181 L .575 .19339 L 1 .188 0 r
F
P
p
.002 w
.68778 .41907 m .67036 .42198 L .65705 .41293 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63965 .41886 m .65705 .41293 L .67036 .42198 L p
1 .042 0 r
F P
0 0 0 r
s
P
p
.49416 .18068 m .52649 .18909 L .50982 .19308 L 1 .042 0 r
F
P
p
.47748 .18475 m .49416 .18068 L .50982 .19308 L 1 .063 0 r
F
P
p
.42797 .18037 m .46096 .18878 L .44459 .19278 L 1 .125 0 r
F
P
p
.41159 .18444 m .42797 .18037 L .44459 .19278 L 1 .156 0 r
F
P
p
.36173 .18005 m .39538 .18848 L .37931 .19247 L 1 .344 0 r
F
P
p
.34566 .18413 m .36173 .18005 L .37931 .19247 L 1 .365 0 r
F
P
p
.29544 .17974 m .32975 .18817 L .31399 .19217 L 1 .458 0 r
F
P
p
.27968 .18382 m .29544 .17974 L .31399 .19217 L 1 .49 0 r
F
P
p
.002 w
.34328 .45028 m .32746 .45305 L .30911 .44445 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.002 w
.29329 .44727 m .30911 .44445 L .32746 .45305 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.002 w
.62243 .42767 m .60528 .43055 L .59093 .4127 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.5738 .41863 m .59093 .4127 L .60528 .43055 L p
1 .073 0 r
F P
0 0 0 r
s
P
p
.002 w
.47443 .45662 m .45796 .46231 L .44193 .42113 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.4255 .427 m .44193 .42113 L .45796 .46231 L p
1 .323 0 r
F P
0 0 0 r
s
P
p
.002 w
.52472 .44226 m .53999 .43033 L p
.50961 .44708 L 1 .281 0 r
F P
0 0 0 r
s
P
p
.002 w
.52472 .44226 m .54178 .43938 L .55682 .4245 L p
1 .26 0 r
F P
0 0 0 r
s
P
p
.002 w
.52472 .44226 m .50908 .40314 L p
.53998 .43738 L 1 .208 0 r
F P
0 0 0 r
s
P
p
.002 w
.54178 .43938 m .52472 .44226 L p
.53998 .43738 L 1 .208 0 r
F P
0 0 0 r
s
P
p
.002 w
.5078 .44808 m .52472 .44226 L p
.50961 .44708 L 1 .281 0 r
F P
0 0 0 r
s
P
p
.002 w
.15935 .60094 m .17456 .59884 L .19487 .60523 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.14429 .60301 m .12937 .60507 L .10809 .59868 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.4255 .427 m .40921 .43282 L .39191 .42987 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.002 w
.37552 .43871 m .39191 .42987 L .40921 .43282 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.27751 .45303 m .26164 .46463 L .24181 .46816 L p
1 .604 0 r
F P
0 0 0 r
s
P
p
.002 w
.22586 .47986 m .24181 .46816 L .26164 .46463 L p
1 .708 0 r
F P
0 0 0 r
s
P
p
.77651 .17784 m .80618 .18631 L .78814 .19032 L 1 0 0 r
F
P
p
.75844 .18194 m .77651 .17784 L .78814 .19032 L 1 0 0 r
F
P
p
.71021 .17753 m .74053 .186 L .7228 .19002 L 1 0 0 r
F
P
p
.69244 .18163 m .71021 .17753 L .7228 .19002 L 1 0 0 r
F
P
p
.002 w
.83676 .41659 m .81857 .41952 L .80738 .4104 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78915 .41339 m .80738 .4104 L .81857 .41952 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64385 .17721 m .67484 .18569 L .65741 .18971 L 1 .01 0 r
F
P
p
.62639 .18131 m .64385 .17721 L .65741 .18971 L 1 .031 0 r
F
P
p
.002 w
.77109 .41636 m .7532 .4193 L .74105 .41017 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72312 .41316 m .74105 .41017 L .7532 .4193 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.57745 .17689 m .6091 .18538 L .59197 .1894 L 1 .115 0 r
F
P
p
.5603 .181 m .57745 .17689 L .59197 .1894 L 1 .167 0 r
F
P
p
.002 w
.70537 .41613 m .68778 .41907 L .67466 .40993 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65705 .41293 m .67466 .40993 L .68778 .41907 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.511 .17658 m .54331 .18506 L .52649 .18909 L 1 .01 0 r
F
P
p
.49416 .18068 m .511 .17658 L .52649 .18909 L 1 .042 0 r
F
P
p
.4445 .17626 m .47748 .18475 L .46096 .18878 L 1 .125 0 r
F
P
p
.42797 .18037 m .4445 .17626 L .46096 .18878 L 1 .125 0 r
F
P
p
.37795 .17594 m .41159 .18444 L .39538 .18848 L 1 .333 0 r
F
P
p
.36173 .18005 m .37795 .17594 L .39538 .18848 L 1 .344 0 r
F
P
p
.31135 .17562 m .34566 .18413 L .32975 .18817 L 1 .427 0 r
F
P
p
.29544 .17974 m .31135 .17562 L .32975 .18817 L 1 .458 0 r
F
P
p
.002 w
.35933 .44452 m .34328 .45028 L .32508 .4416 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.002 w
.30911 .44445 m .32508 .4416 L .34328 .45028 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.002 w
.49105 .45089 m .47443 .45662 L .4585 .41521 L p
1 .26 0 r
F P
0 0 0 r
s
P
p
.002 w
.44193 .42113 m .4585 .41521 L .47443 .45662 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.5738 .41863 m .55682 .4245 L .54178 .43938 L p
1 .24 0 r
F P
0 0 0 r
s
P
p
.002 w
.63965 .41886 m .62243 .42767 L .60823 .4097 L p
1 .042 0 r
F P
0 0 0 r
s
P
p
.002 w
.59093 .4127 m .60823 .4097 L .62243 .42767 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.29329 .44727 m .27751 .45303 L .25786 .45638 L p
1 .531 0 r
F P
0 0 0 r
s
P
p
.002 w
.24181 .46816 m .25786 .45638 L .27751 .45303 L p
1 .604 0 r
F P
0 0 0 r
s
P
p
.002 w
.44193 .42113 m .4255 .427 L .40838 .42394 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.002 w
.39191 .42987 m .40838 .42394 L .4255 .427 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.002 w
.15935 .60094 m .14429 .60301 L .12313 .59656 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.002 w
.10809 .59868 m .12313 .59656 L .14429 .60301 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.77651 .17784 m .79476 .17371 L .80618 .18631 L 1 0 0 r
F
P
p
.72814 .17339 m .75844 .18194 L .74053 .186 L 1 0 0 r
F
P
p
.71021 .17753 m .72814 .17339 L .74053 .186 L 1 0 0 r
F
P
p
.002 w
.80738 .4104 m .82579 .40737 L .83676 .41659 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66148 .17307 m .69244 .18163 L .67484 .18569 L 1 0 0 r
F
P
p
.64385 .17721 m .66148 .17307 L .67484 .18569 L 1 .01 0 r
F
P
p
.002 w
.78915 .41339 m .77109 .41636 L .75914 .40714 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74105 .41017 m .75914 .40714 L .77109 .41636 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.59476 .17275 m .62639 .18131 L .6091 .18538 L 1 .052 0 r
F
P
p
.57745 .17689 m .59476 .17275 L .6091 .18538 L 1 .115 0 r
F
P
p
.002 w
.72312 .41316 m .70537 .41613 L .69245 .40691 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67466 .40993 m .69245 .40691 L .70537 .41613 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.528 .17243 m .5603 .181 L .54331 .18506 L 1 0 0 r
F
P
p
.511 .17658 m .528 .17243 L .54331 .18506 L 1 .01 0 r
F
P
p
.46118 .17211 m .49416 .18068 L .47748 .18475 L 1 .125 0 r
F
P
p
.4445 .17626 m .46118 .17211 L .47748 .18475 L 1 .125 0 r
F
P
p
.002 w
.65705 .41293 m .63965 .41886 L .6257 .40667 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.002 w
.60823 .4097 m .6257 .40667 L .63965 .41886 L p
1 .042 0 r
F P
0 0 0 r
s
P
p
.002 w
.37552 .43871 m .35933 .44452 L .34121 .43872 L p
1 .365 0 r
F P
0 0 0 r
s
P
p
.002 w
.32508 .4416 m .34121 .43872 L .35933 .44452 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.39432 .17179 m .42797 .18037 L .41159 .18444 L 1 .229 0 r
F
P
p
.37795 .17594 m .39432 .17179 L .41159 .18444 L 1 .333 0 r
F
P
p
.002 w
.4585 .41521 m .4752 .41222 L .49105 .45089 L p
1 .26 0 r
F P
0 0 0 r
s
P
p
.002 w
.59093 .4127 m .5738 .41863 L .55901 .43648 L p
1 .198 0 r
F P
0 0 0 r
s
P
p
.002 w
.54178 .43938 m .55901 .43648 L .5738 .41863 L p
1 .24 0 r
F P
0 0 0 r
s
P
p
.002 w
.20909 .51247 m .19375 .51497 L .17325 .50719 L p
.844 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.19375 .51497 m .17456 .59884 L .15793 .50975 L p
.427 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.15793 .50975 m .17325 .50719 L .19375 .51497 L p
.427 1 0 r
F P
0 0 0 r
s
P
p
.32741 .17146 m .36173 .18005 L .34566 .18413 L 1 .417 0 r
F
P
p
.31135 .17562 m .32741 .17146 L .34566 .18413 L 1 .427 0 r
F
P
p
.002 w
.30911 .44445 m .29329 .44727 L .27371 .45356 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.25786 .45638 m .27371 .45356 L .29329 .44727 L p
1 .531 0 r
F P
0 0 0 r
s
P
p
.002 w
.4585 .41521 m .44193 .42113 L .42504 .41496 L p
1 .094 0 r
F P
0 0 0 r
s
P
p
.002 w
.40838 .42394 m .42504 .41496 L .44193 .42113 L p
1 .135 0 r
F P
0 0 0 r
s
P
p
.002 w
.17456 .59884 m .15935 .60094 L .13831 .59442 L p
0 1 .135 r
F P
0 0 0 r
s
P
p
.002 w
.12313 .59656 m .13831 .59442 L .15935 .60094 L p
0 1 .417 r
F P
0 0 0 r
s
P
p
.74625 .16921 m .77651 .17784 L .75844 .18194 L 1 0 0 r
F
P
p
.72814 .17339 m .74625 .16921 L .75844 .18194 L 1 0 0 r
F
P
p
.67927 .16889 m .71021 .17753 L .69244 .18163 L 1 0 0 r
F
P
p
.66148 .17307 m .67927 .16889 L .69244 .18163 L 1 0 0 r
F
P
p
.002 w
.80738 .4104 m .78915 .41339 L .77741 .40409 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75914 .40714 m .77741 .40409 L .78915 .41339 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61224 .16856 m .64385 .17721 L .62639 .18131 L 1 .031 0 r
F
P
p
.59476 .17275 m .61224 .16856 L .62639 .18131 L 1 .052 0 r
F
P
p
.002 w
.74105 .41017 m .72312 .41316 L .7104 .40385 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69245 .40691 m .7104 .40385 L .72312 .41316 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.54516 .16824 m .57745 .17689 L .5603 .181 L 1 0 0 r
F
P
p
.528 .17243 m .54516 .16824 L .5603 .181 L 1 0 0 r
F
P
p
.002 w
.67466 .40993 m .65705 .41293 L .64334 .40361 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6257 .40667 m .64334 .40361 L .65705 .41293 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.002 w
.39191 .42987 m .37552 .43871 L .35764 .42977 L p
1 .302 0 r
F P
0 0 0 r
s
P
p
.002 w
.34121 .43872 m .35764 .42977 L .37552 .43871 L p
1 .365 0 r
F P
0 0 0 r
s
P
p
.47803 .16792 m .511 .17658 L .49416 .18068 L 1 .104 0 r
F
P
p
.46118 .17211 m .47803 .16792 L .49416 .18068 L 1 .125 0 r
F
P
p
.002 w
.60823 .4097 m .59093 .4127 L .57638 .4275 L p
1 .167 0 r
F P
0 0 0 r
s
P
p
.002 w
.57638 .4275 m .59093 .4127 L p
.5626 .43381 L 1 .198 0 r
F P
0 0 0 r
s
P
p
.002 w
.57638 .4275 m .59393 .42451 L .60823 .4097 L p
1 .167 0 r
F P
0 0 0 r
s
P
p
.002 w
.57638 .4275 m .5611 .39377 L p
.5903 .42112 L 1 .167 0 r
F P
0 0 0 r
s
P
p
.002 w
.59393 .42451 m .57638 .4275 L p
.5903 .42112 L 1 .167 0 r
F P
0 0 0 r
s
P
p
.002 w
.55901 .43648 m .57638 .4275 L p
.5626 .43381 L 1 .198 0 r
F P
0 0 0 r
s
P
p
.41085 .16759 m .4445 .17626 L .42797 .18037 L 1 .125 0 r
F
P
p
.39432 .17179 m .41085 .16759 L .42797 .18037 L 1 .229 0 r
F
P
p
.002 w
.52472 .44226 m .5078 .44808 L .49207 .4062 L p
1 .219 0 r
F P
0 0 0 r
s
P
p
.002 w
.4752 .41222 m .49207 .4062 L .5078 .44808 L p
1 .24 0 r
F P
0 0 0 r
s
P
p
.002 w
.22586 .47986 m .20909 .51247 L .1906 .4652 L p
1 .885 0 r
F P
0 0 0 r
s
P
p
.002 w
.17325 .50719 m .1906 .4652 L .20909 .51247 L p
.844 1 0 r
F P
0 0 0 r
s
P
p
.34362 .16727 m .37795 .17594 L .36173 .18005 L 1 .417 0 r
F
P
p
.32741 .17146 m .34362 .16727 L .36173 .18005 L 1 .417 0 r
F
P
p
.002 w
.32508 .4416 m .30911 .44445 L .28991 .44466 L p
1 .479 0 r
F P
0 0 0 r
s
P
p
.002 w
.27371 .45356 m .28991 .44466 L .30911 .44445 L p
1 .5 0 r
F P
0 0 0 r
s
P
p
.002 w
.24181 .46816 m .22586 .47986 L .20656 .45335 L p
1 .719 0 r
F P
0 0 0 r
s
P
p
.002 w
.1906 .4652 m .20656 .45335 L .22586 .47986 L p
1 .885 0 r
F P
0 0 0 r
s
P
p
.002 w
.4752 .41222 m .4585 .41521 L .44175 .41194 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.002 w
.42504 .41496 m .44175 .41194 L .4585 .41521 L p
1 .094 0 r
F P
0 0 0 r
s
P
p
.002 w
.13831 .59442 m .15793 .50975 L .17456 .59884 L p
0 1 .135 r
F P
0 0 0 r
s
P
p
.76454 .16499 m .79476 .17371 L .77651 .17784 L 1 0 0 r
F
P
p
.74625 .16921 m .76454 .16499 L .77651 .17784 L 1 0 0 r
F
P
p
.69724 .16466 m .72814 .17339 L .71021 .17753 L 1 0 0 r
F
P
p
.67927 .16889 m .69724 .16466 L .71021 .17753 L 1 0 0 r
F
P
p
.002 w
.40838 .42394 m .39191 .42987 L .37413 .42379 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.35764 .42977 m .37413 .42379 L .39191 .42987 L p
1 .302 0 r
F P
0 0 0 r
s
P
p
.002 w
.82579 .40737 m .80738 .4104 L .79586 .401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77741 .40409 m .79586 .401 L .80738 .4104 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.62989 .16434 m .66148 .17307 L .64385 .17721 L 1 .01 0 r
F
P
p
.61224 .16856 m .62989 .16434 L .64385 .17721 L 1 .031 0 r
F
P
p
.002 w
.75914 .40714 m .74105 .41017 L .72853 .40076 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7104 .40385 m .72853 .40076 L .74105 .41017 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.56249 .16401 m .59476 .17275 L .57745 .17689 L 1 0 0 r
F
P
p
.54516 .16824 m .56249 .16401 L .57745 .17689 L 1 0 0 r
F
P
p
.002 w
.69245 .40691 m .67466 .40993 L .66116 .40053 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64334 .40361 m .66116 .40053 L .67466 .40993 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.49504 .16368 m .528 .17243 L .511 .17658 L 1 .052 0 r
F
P
p
.47803 .16792 m .49504 .16368 L .511 .17658 L 1 .104 0 r
F
P
p
.002 w
.49207 .4062 m .50908 .40314 L .52472 .44226 L p
1 .219 0 r
F P
0 0 0 r
s
P
p
.002 w
.25786 .45638 m .24181 .46816 L .22223 .4505 L p
1 .656 0 r
F P
0 0 0 r
s
P
p
.002 w
.20656 .45335 m .22223 .4505 L .24181 .46816 L p
1 .719 0 r
F P
0 0 0 r
s
P
p
.002 w
.6257 .40667 m .60823 .4097 L .59393 .42451 L p
1 .115 0 r
F P
0 0 0 r
s
P
p
.42755 .16336 m .46118 .17211 L .4445 .17626 L 1 .125 0 r
F
P
p
.41085 .16759 m .42755 .16336 L .4445 .17626 L 1 .125 0 r
F
P
p
.36 .16303 m .39432 .17179 L .37795 .17594 L 1 .396 0 r
F
P
p
.34362 .16727 m .36 .16303 L .37795 .17594 L 1 .417 0 r
F
P
p
.002 w
.34121 .43872 m .32508 .4416 L .30605 .44176 L p
1 .458 0 r
F P
0 0 0 r
s
P
p
.002 w
.28991 .44466 m .30605 .44176 L .32508 .4416 L p
1 .479 0 r
F P
0 0 0 r
s
P
p
.002 w
.49207 .4062 m .4752 .41222 L .45862 .40888 L p
1 .073 0 r
F P
0 0 0 r
s
P
p
.002 w
.44175 .41194 m .45862 .40888 L .4752 .41222 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.76454 .16499 m .783 .16073 L .79476 .17371 L 1 0 0 r
F
P
p
.002 w
.42504 .41496 m .40838 .42394 L .39078 .41774 L p
1 .208 0 r
F P
0 0 0 r
s
P
p
.002 w
.37413 .42379 m .39078 .41774 L .40838 .42394 L p
1 .25 0 r
F P
0 0 0 r
s
P
p
.002 w
.27371 .45356 m .25786 .45638 L .23806 .44763 L p
1 .594 0 r
F P
0 0 0 r
s
P
p
.002 w
.22223 .4505 m .23806 .44763 L .25786 .45638 L p
1 .656 0 r
F P
0 0 0 r
s
P
p
.71538 .1604 m .74625 .16921 L .72814 .17339 L 1 0 0 r
F
P
p
.69724 .16466 m .71538 .1604 L .72814 .17339 L 1 0 0 r
F
P
p
.002 w
.79586 .401 m .81449 .39789 L .82579 .40737 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64771 .16007 m .67927 .16889 L .66148 .17307 L 1 0 0 r
F
P
p
.62989 .16434 m .64771 .16007 L .66148 .17307 L 1 .01 0 r
F
P
p
.002 w
.77741 .40409 m .75914 .40714 L .74684 .39765 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72853 .40076 m .74684 .39765 L .75914 .40714 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.57999 .15974 m .61224 .16856 L .59476 .17275 L 1 0 0 r
F
P
p
.56249 .16401 m .57999 .15974 L .59476 .17275 L 1 0 0 r
F
P
p
.002 w
.7104 .40385 m .69245 .40691 L .67914 .39741 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66116 .40053 m .67914 .39741 L .69245 .40691 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.51222 .15941 m .54516 .16824 L .528 .17243 L 1 .021 0 r
F
P
p
.49504 .16368 m .51222 .15941 L .528 .17243 L 1 .052 0 r
F
P
p
.002 w
.55901 .43648 m .54178 .43938 L .52625 .40005 L p
1 .208 0 r
F P
0 0 0 r
s
P
p
.002 w
.50908 .40314 m .52625 .40005 L .54178 .43938 L p
1 .208 0 r
F P
0 0 0 r
s
P
p
.002 w
.64334 .40361 m .6257 .40667 L .61149 .40627 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.59393 .42451 m .61149 .40627 L .6257 .40667 L p
1 .115 0 r
F P
0 0 0 r
s
P
p
.4444 .15908 m .47803 .16792 L .46118 .17211 L 1 .125 0 r
F
P
p
.42755 .16336 m .4444 .15908 L .46118 .17211 L 1 .125 0 r
F
P
p
.37653 .15875 m .41085 .16759 L .39432 .17179 L 1 .302 0 r
F
P
p
.36 .16303 m .37653 .15875 L .39432 .17179 L 1 .396 0 r
F
P
p
.002 w
.50908 .40314 m .49207 .4062 L .47566 .4058 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.45862 .40888 m .47566 .4058 L .49207 .4062 L p
1 .073 0 r
F P
0 0 0 r
s
P
p
.002 w
.35764 .42977 m .34121 .43872 L .32252 .43273 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.002 w
.30605 .44176 m .32252 .43273 L .34121 .43872 L p
1 .458 0 r
F P
0 0 0 r
s
P
p
.002 w
.44175 .41194 m .42504 .41496 L .40751 .4147 L p
1 .156 0 r
F P
0 0 0 r
s
P
p
.002 w
.39078 .41774 m .40751 .4147 L .42504 .41496 L p
1 .208 0 r
F P
0 0 0 r
s
P
p
.002 w
.28991 .44466 m .27371 .45356 L .25441 .43556 L p
1 .531 0 r
F P
0 0 0 r
s
P
p
.002 w
.23806 .44763 m .25441 .43556 L .27371 .45356 L p
1 .594 0 r
F P
0 0 0 r
s
P
p
.7337 .1561 m .76454 .16499 L .74625 .16921 L 1 0 0 r
F
P
p
.71538 .1604 m .7337 .1561 L .74625 .16921 L 1 0 0 r
F
P
p
.66571 .15576 m .69724 .16466 L .67927 .16889 L 1 0 0 r
F
P
p
.64771 .16007 m .66571 .15576 L .67927 .16889 L 1 0 0 r
F
P
p
.002 w
.79586 .401 m .77741 .40409 L .76532 .3945 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74684 .39765 m .76532 .3945 L .77741 .40409 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.59766 .15543 m .62989 .16434 L .61224 .16856 L 1 0 0 r
F
P
p
.57999 .15974 m .59766 .15543 L .61224 .16856 L 1 0 0 r
F
P
p
.002 w
.72853 .40076 m .7104 .40385 L .6973 .39426 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67914 .39741 m .6973 .39426 L .7104 .40385 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.52957 .1551 m .56249 .16401 L .54516 .16824 L 1 .021 0 r
F
P
p
.51222 .15941 m .52957 .1551 L .54516 .16824 L 1 .021 0 r
F
P
p
.002 w
.57638 .4275 m .55901 .43648 L .54359 .39692 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.002 w
.52625 .40005 m .54359 .39692 L .55901 .43648 L p
1 .208 0 r
F P
0 0 0 r
s
P
p
.002 w
.66116 .40053 m .64334 .40361 L .62931 .40011 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.61149 .40627 m .62931 .40011 L .64334 .40361 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.37413 .42379 m .35764 .42977 L .33905 .42669 L p
1 .365 0 r
F P
0 0 0 r
s
P
p
.002 w
.32252 .43273 m .33905 .42669 L .35764 .42977 L p
1 .406 0 r
F P
0 0 0 r
s
P
p
.46142 .15476 m .49504 .16368 L .47803 .16792 L 1 .115 0 r
F
P
p
.4444 .15908 m .46142 .15476 L .47803 .16792 L 1 .125 0 r
F
P
p
.39322 .15443 m .42755 .16336 L .41085 .16759 L 1 .208 0 r
F
P
p
.37653 .15875 m .39322 .15443 L .41085 .16759 L 1 .302 0 r
F
P
p
.002 w
.52625 .40005 m .50908 .40314 L .49287 .40268 L p
1 .042 0 r
F P
0 0 0 r
s
P
p
.002 w
.47566 .4058 m .49287 .40268 L .50908 .40314 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.45862 .40888 m .44175 .41194 L .42455 .40244 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.40751 .4147 m .42455 .40244 L .44175 .41194 L p
1 .156 0 r
F P
0 0 0 r
s
P
p
.002 w
.30605 .44176 m .28991 .44466 L .27064 .42952 L p
1 .49 0 r
F P
0 0 0 r
s
P
p
.002 w
.25441 .43556 m .27064 .42952 L .28991 .44466 L p
1 .531 0 r
F P
0 0 0 r
s
P
p
.7522 .15175 m .783 .16073 L .76454 .16499 L 1 0 0 r
F
P
p
.7337 .1561 m .7522 .15175 L .76454 .16499 L 1 0 0 r
F
P
p
.002 w
.54359 .39692 m .5611 .39377 L .57638 .4275 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.68388 .15141 m .71538 .1604 L .69724 .16466 L 1 0 0 r
F
P
p
.66571 .15576 m .68388 .15141 L .69724 .16466 L 1 0 0 r
F
P
p
.002 w
.81449 .39789 m .79586 .401 L .78399 .39132 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76532 .3945 m .78399 .39132 L .79586 .401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61551 .15108 m .64771 .16007 L .62989 .16434 L 1 0 0 r
F
P
p
.59766 .15543 m .61551 .15108 L .62989 .16434 L 1 0 0 r
F
P
p
.002 w
.39078 .41774 m .37413 .42379 L .35565 .42366 L p
1 .344 0 r
F P
0 0 0 r
s
P
p
.002 w
.33905 .42669 m .35565 .42366 L .37413 .42379 L p
1 .365 0 r
F P
0 0 0 r
s
P
p
.002 w
.74684 .39765 m .72853 .40076 L .71564 .39108 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6973 .39426 m .71564 .39108 L .72853 .40076 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.54709 .15074 m .57999 .15974 L .56249 .16401 L 1 .01 0 r
F
P
p
.52957 .1551 m .54709 .15074 L .56249 .16401 L 1 .021 0 r
F
P
p
.002 w
.67914 .39741 m .66116 .40053 L .64729 .39389 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.002 w
.62931 .40011 m .64729 .39389 L .66116 .40053 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.47861 .1504 m .51222 .15941 L .49504 .16368 L 1 .083 0 r
F
P
p
.46142 .15476 m .47861 .1504 L .49504 .16368 L 1 .115 0 r
F
P
p
.41008 .15007 m .4444 .15908 L .42755 .16336 L 1 .188 0 r
F
P
p
.39322 .15443 m .41008 .15007 L .42755 .16336 L 1 .208 0 r
F
P
p
.002 w
.54359 .39692 m .52625 .40005 L .51027 .3934 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.002 w
.49287 .40268 m .51027 .3934 L .52625 .40005 L p
1 .042 0 r
F P
0 0 0 r
s
P
p
.002 w
.47566 .4058 m .45862 .40888 L .4416 .39929 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.42455 .40244 m .4416 .39929 L .45862 .40888 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.32252 .43273 m .30605 .44176 L .28702 .42343 L p
1 .458 0 r
F P
0 0 0 r
s
P
p
.002 w
.27064 .42952 m .28702 .42343 L .30605 .44176 L p
1 .49 0 r
F P
0 0 0 r
s
P
p
.7522 .15175 m .77088 .14736 L .783 .16073 L 1 0 0 r
F
P
p
.002 w
.61149 .40627 m .59393 .42451 L .57878 .39059 L p
1 .115 0 r
F P
0 0 0 r
s
P
p
.002 w
.5611 .39377 m .57878 .39059 L .59393 .42451 L p
1 .167 0 r
F P
0 0 0 r
s
P
p
.70223 .14702 m .7337 .1561 L .71538 .1604 L 1 0 0 r
F
P
p
.68388 .15141 m .70223 .14702 L .71538 .1604 L 1 0 0 r
F
P
p
.002 w
.40751 .4147 m .39078 .41774 L .37241 .42061 L p
1 .333 0 r
F P
0 0 0 r
s
P
p
.002 w
.35565 .42366 m .37241 .42061 L .39078 .41774 L p
1 .344 0 r
F P
0 0 0 r
s
P
p
.002 w
.78399 .39132 m .80284 .38811 L .81449 .39789 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.63353 .14668 m .66571 .15576 L .64771 .16007 L 1 0 0 r
F
P
p
.61551 .15108 m .63353 .14668 L .64771 .16007 L 1 0 0 r
F
P
p
.002 w
.76532 .3945 m .74684 .39765 L .73416 .38787 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71564 .39108 m .73416 .38787 L .74684 .39765 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.56478 .14634 m .59766 .15543 L .57999 .15974 L 1 0 0 r
F
P
p
.54709 .15074 m .56478 .14634 L .57999 .15974 L 1 .01 0 r
F
P
p
.002 w
.6973 .39426 m .67914 .39741 L .66543 .38762 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64729 .39389 m .66543 .38762 L .67914 .39741 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.49597 .146 m .52957 .1551 L .51222 .15941 L 1 .063 0 r
F
P
p
.47861 .1504 m .49597 .146 L .51222 .15941 L 1 .083 0 r
F
P
p
.42711 .14566 m .46142 .15476 L .4444 .15908 L 1 .188 0 r
F
P
p
.41008 .15007 m .42711 .14566 L .4444 .15908 L 1 .188 0 r
F
P
p
.002 w
.5611 .39377 m .54359 .39692 L .5278 .38712 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.51027 .3934 m .5278 .38712 L .54359 .39692 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.002 w
.62931 .40011 m .61149 .40627 L .59664 .38737 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.57878 .39059 m .59664 .38737 L .61149 .40627 L p
1 .115 0 r
F P
0 0 0 r
s
P
p
.002 w
.33905 .42669 m .32252 .43273 L .30345 .42037 L p
1 .427 0 r
F P
0 0 0 r
s
P
p
.002 w
.28702 .42343 m .30345 .42037 L .32252 .43273 L p
1 .458 0 r
F P
0 0 0 r
s
P
p
.002 w
.49287 .40268 m .47566 .4058 L .45881 .39611 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.4416 .39929 m .45881 .39611 L .47566 .4058 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.72077 .14258 m .7522 .15175 L .7337 .1561 L 1 0 0 r
F
P
p
.70223 .14702 m .72077 .14258 L .7337 .1561 L 1 0 0 r
F
P
p
.002 w
.42455 .40244 m .40751 .4147 L .38934 .41752 L p
1 .229 0 r
F P
0 0 0 r
s
P
p
.002 w
.37241 .42061 m .38934 .41752 L .40751 .4147 L p
1 .333 0 r
F P
0 0 0 r
s
P
p
.65173 .14224 m .68388 .15141 L .66571 .15576 L 1 0 0 r
F
P
p
.63353 .14668 m .65173 .14224 L .66571 .15576 L 1 0 0 r
F
P
p
.002 w
.78399 .39132 m .76532 .3945 L .75287 .38462 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73416 .38787 m .75287 .38462 L .76532 .3945 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.58264 .1419 m .61551 .15108 L .59766 .15543 L 1 0 0 r
F
P
p
.56478 .14634 m .58264 .1419 L .59766 .15543 L 1 0 0 r
F
P
p
.002 w
.71564 .39108 m .6973 .39426 L .6838 .38437 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66543 .38762 m .6838 .38437 L .6973 .39426 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5135 .14155 m .54709 .15074 L .52957 .1551 L 1 .052 0 r
F
P
p
.49597 .146 m .5135 .14155 L .52957 .1551 L 1 .063 0 r
F
P
p
.4443 .14121 m .47861 .1504 L .46142 .15476 L 1 .146 0 r
F
P
p
.42711 .14566 m .4443 .14121 L .46142 .15476 L 1 .188 0 r
F
P
p
.002 w
.57878 .39059 m .5611 .39377 L .5455 .38387 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5278 .38712 m .5455 .38387 L .5611 .39377 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64729 .39389 m .62931 .40011 L .61468 .38412 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.59664 .38737 m .61468 .38412 L .62931 .40011 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.35565 .42366 m .33905 .42669 L .32004 .41728 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.002 w
.30345 .42037 m .32004 .41728 L .33905 .42669 L p
1 .427 0 r
F P
0 0 0 r
s
P
p
.002 w
.51027 .3934 m .49287 .40268 L .4762 .3929 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.002 w
.45881 .39611 m .4762 .3929 L .49287 .40268 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.4416 .39929 m .42455 .40244 L .40683 .39265 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.38934 .41752 m .40683 .39265 L .42455 .40244 L p
1 .229 0 r
F P
0 0 0 r
s
P
p
.73949 .1381 m .77088 .14736 L .7522 .15175 L 1 0 0 r
F
P
p
.72077 .14258 m .73949 .1381 L .7522 .15175 L 1 0 0 r
F
P
p
.67011 .13776 m .70223 .14702 L .68388 .15141 L 1 0 0 r
F
P
p
.65173 .14224 m .67011 .13776 L .68388 .15141 L 1 0 0 r
F
P
p
.002 w
.80284 .38811 m .78399 .39132 L .77176 .38135 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75287 .38462 m .77176 .38135 L .78399 .39132 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60068 .13741 m .63353 .14668 L .61551 .15108 L 1 0 0 r
F
P
p
.58264 .1419 m .60068 .13741 L .61551 .15108 L 1 0 0 r
F
P
p
.002 w
.73416 .38787 m .71564 .39108 L .70235 .38109 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6838 .38437 m .70235 .38109 L .71564 .39108 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5312 .13706 m .56478 .14634 L .54709 .15074 L 1 .021 0 r
F
P
p
.5135 .14155 m .5312 .13706 L .54709 .15074 L 1 .052 0 r
F
P
p
.46167 .13671 m .49597 .146 L .47861 .1504 L 1 .104 0 r
F
P
p
.4443 .14121 m .46167 .13671 L .47861 .1504 L 1 .146 0 r
F
P
p
.002 w
.59664 .38737 m .57878 .39059 L .56338 .38059 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5455 .38387 m .56338 .38059 L .57878 .39059 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66543 .38762 m .64729 .39389 L .63289 .38084 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.002 w
.61468 .38412 m .63289 .38084 L .64729 .39389 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.37241 .42061 m .35565 .42366 L .3368 .41417 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.002 w
.32004 .41728 m .3368 .41417 L .35565 .42366 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.002 w
.5278 .38712 m .51027 .3934 L .49376 .38965 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.4762 .3929 m .49376 .38965 L .51027 .3934 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.002 w
.45881 .39611 m .4416 .39929 L .42405 .3894 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.40683 .39265 m .42405 .3894 L .4416 .39929 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.73949 .1381 m .75839 .13358 L .77088 .14736 L 1 0 0 r
F
P
p
.68868 .13323 m .72077 .14258 L .70223 .14702 L 1 0 0 r
F
P
p
.67011 .13776 m .68868 .13323 L .70223 .14702 L 1 0 0 r
F
P
p
.002 w
.77176 .38135 m .79084 .37804 L .80284 .38811 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61891 .13288 m .65173 .14224 L .63353 .14668 L 1 0 0 r
F
P
p
.60068 .13741 m .61891 .13288 L .63353 .14668 L 1 0 0 r
F
P
p
.002 w
.75287 .38462 m .73416 .38787 L .72109 .37778 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70235 .38109 m .72109 .37778 L .73416 .38787 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.54909 .13252 m .58264 .1419 L .56478 .14634 L 1 0 0 r
F
P
p
.5312 .13706 m .54909 .13252 L .56478 .14634 L 1 .021 0 r
F
P
p
.002 w
.6838 .38437 m .66543 .38762 L .65129 .37753 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63289 .38084 m .65129 .37753 L .66543 .38762 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.47921 .13217 m .5135 .14155 L .49597 .146 L 1 .104 0 r
F
P
p
.46167 .13671 m .47921 .13217 L .49597 .146 L 1 .104 0 r
F
P
p
.002 w
.61468 .38412 m .59664 .38737 L .58143 .37727 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56338 .38059 m .58143 .37727 L .59664 .38737 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5455 .38387 m .5278 .38712 L .51152 .38013 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.002 w
.49376 .38965 m .51152 .38013 L .5278 .38712 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.38934 .41752 m .37241 .42061 L .35373 .41102 L p
1 .396 0 r
F P
0 0 0 r
s
P
p
.002 w
.3368 .41417 m .35373 .41102 L .37241 .42061 L p
1 .417 0 r
F P
0 0 0 r
s
P
p
.002 w
.4762 .3929 m .45881 .39611 L .44144 .38612 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.42405 .3894 m .44144 .38612 L .45881 .39611 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.70743 .12865 m .73949 .1381 L .72077 .14258 L 1 0 0 r
F
P
p
.68868 .13323 m .70743 .12865 L .72077 .14258 L 1 0 0 r
F
P
p
.63732 .1283 m .67011 .13776 L .65173 .14224 L 1 0 0 r
F
P
p
.61891 .13288 m .63732 .1283 L .65173 .14224 L 1 0 0 r
F
P
p
.002 w
.77176 .38135 m .75287 .38462 L .74002 .37444 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72109 .37778 m .74002 .37444 L .75287 .38462 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.56715 .12794 m .60068 .13741 L .58264 .1419 L 1 0 0 r
F
P
p
.54909 .13252 m .56715 .12794 L .58264 .1419 L 1 0 0 r
F
P
p
.002 w
.70235 .38109 m .6838 .38437 L .66987 .37418 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65129 .37753 m .66987 .37418 L .6838 .38437 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.49693 .12759 m .5312 .13706 L .5135 .14155 L 1 .094 0 r
F
P
p
.47921 .13217 m .49693 .12759 L .5135 .14155 L 1 .104 0 r
F
P
p
.002 w
.63289 .38084 m .61468 .38412 L .59967 .37392 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58143 .37727 m .59967 .37392 L .61468 .38412 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56338 .38059 m .5455 .38387 L .52942 .37679 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.002 w
.51152 .38013 m .52942 .37679 L .5455 .38387 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.002 w
.40683 .39265 m .38934 .41752 L .37097 .40155 L p
1 .302 0 r
F P
0 0 0 r
s
P
p
.002 w
.35373 .41102 m .37097 .40155 L .38934 .41752 L p
1 .396 0 r
F P
0 0 0 r
s
P
p
.002 w
.49376 .38965 m .4762 .3929 L .45901 .38281 L p
1 .115 0 r
F P
0 0 0 r
s
P
p
.002 w
.44144 .38612 m .45901 .38281 L .4762 .3929 L p
1 .125 0 r
F P
0 0 0 r
s
P
p
.002 w
.42405 .3894 m .40683 .39265 L .38823 .3983 L p
1 .208 0 r
F P
0 0 0 r
s
P
p
.002 w
.37097 .40155 m .38823 .3983 L .40683 .39265 L p
1 .302 0 r
F P
0 0 0 r
s
P
p
.72638 .12403 m .75839 .13358 L .73949 .1381 L 1 0 0 r
F
P
p
.70743 .12865 m .72638 .12403 L .73949 .1381 L 1 0 0 r
F
P
p
.65591 .12367 m .68868 .13323 L .67011 .13776 L 1 0 0 r
F
P
p
.63732 .1283 m .65591 .12367 L .67011 .13776 L 1 0 0 r
F
P
p
.002 w
.79084 .37804 m .77176 .38135 L .75914 .37106 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74002 .37444 m .75914 .37106 L .77176 .38135 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.5854 .12331 m .61891 .13288 L .60068 .13741 L 1 0 0 r
F
P
p
.56715 .12794 m .5854 .12331 L .60068 .13741 L 1 0 0 r
F
P
p
.002 w
.72109 .37778 m .70235 .38109 L .68865 .3708 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66987 .37418 m .68865 .3708 L .70235 .38109 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.51483 .12296 m .54909 .13252 L .5312 .13706 L 1 .063 0 r
F
P
p
.49693 .12759 m .51483 .12296 L .5312 .13706 L 1 .094 0 r
F
P
p
.002 w
.65129 .37753 m .63289 .38084 L .6181 .37054 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59967 .37392 m .6181 .37054 L .63289 .38084 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58143 .37727 m .56338 .38059 L .5475 .37342 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.002 w
.52942 .37679 m .5475 .37342 L .56338 .38059 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.002 w
.51152 .38013 m .49376 .38965 L .47678 .37631 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.002 w
.45901 .38281 m .47678 .37631 L .49376 .38965 L p
1 .115 0 r
F P
0 0 0 r
s
P
p
.002 w
.44144 .38612 m .42405 .3894 L .40578 .38869 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.002 w
.38823 .3983 m .40578 .38869 L .42405 .3894 L p
1 .208 0 r
F P
0 0 0 r
s
P
p
.72638 .12403 m .74551 .11936 L .75839 .13358 L 1 0 0 r
F
P
p
.6747 .119 m .70743 .12865 L .68868 .13323 L 1 0 0 r
F
P
p
.65591 .12367 m .6747 .119 L .68868 .13323 L 1 0 0 r
F
P
p
.002 w
.75914 .37106 m .77846 .36765 L .79084 .37804 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60383 .11864 m .63732 .1283 L .61891 .13288 L 1 0 0 r
F
P
p
.5854 .12331 m .60383 .11864 L .61891 .13288 L 1 0 0 r
F
P
p
.002 w
.74002 .37444 m .72109 .37778 L .70761 .36738 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68865 .3708 m .70761 .36738 L .72109 .37778 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.53291 .11828 m .56715 .12794 L .54909 .13252 L 1 .031 0 r
F
P
p
.51483 .12296 m .53291 .11828 L .54909 .13252 L 1 .063 0 r
F
P
p
.002 w
.66987 .37418 m .65129 .37753 L .63671 .36712 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6181 .37054 m .63671 .36712 L .65129 .37753 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59967 .37392 m .58143 .37727 L .56575 .36685 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5475 .37342 m .56575 .36685 L .58143 .37727 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.002 w
.52942 .37679 m .51152 .38013 L .4947 .37292 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.47678 .37631 m .4947 .37292 L .51152 .38013 L p
1 .083 0 r
F P
0 0 0 r
s
P
p
.002 w
.45901 .38281 m .44144 .38612 L .42337 .38535 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.002 w
.40578 .38869 m .42337 .38535 L .44144 .38612 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.69368 .11428 m .72638 .12403 L .70743 .12865 L 1 0 0 r
F
P
p
.6747 .119 m .69368 .11428 L .70743 .12865 L 1 0 0 r
F
P
p
.62245 .11391 m .65591 .12367 L .63732 .1283 L 1 0 0 r
F
P
p
.60383 .11864 m .62245 .11391 L .63732 .1283 L 1 0 0 r
F
P
p
.002 w
.75914 .37106 m .74002 .37444 L .72677 .36393 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70761 .36738 m .72677 .36393 L .74002 .37444 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.55117 .11355 m .5854 .12331 L .56715 .12794 L 1 .021 0 r
F
P
p
.53291 .11828 m .55117 .11355 L .56715 .12794 L 1 .031 0 r
F
P
p
.002 w
.68865 .3708 m .66987 .37418 L .65551 .36366 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63671 .36712 m .65551 .36366 L .66987 .37418 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6181 .37054 m .59967 .37392 L .5842 .3634 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56575 .36685 m .5842 .3634 L .59967 .37392 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5475 .37342 m .52942 .37679 L .51281 .36949 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.4947 .37292 m .51281 .36949 L .52942 .37679 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.47678 .37631 m .45901 .38281 L .44115 .38198 L p
1 .146 0 r
F P
0 0 0 r
s
P
p
.002 w
.42337 .38535 m .44115 .38198 L .45901 .38281 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.71285 .10951 m .74551 .11936 L .72638 .12403 L 1 0 0 r
F
P
p
.69368 .11428 m .71285 .10951 L .72638 .12403 L 1 0 0 r
F
P
p
.64127 .10914 m .6747 .119 L .65591 .12367 L 1 0 0 r
F
P
p
.62245 .11391 m .64127 .10914 L .65591 .12367 L 1 0 0 r
F
P
p
.002 w
.77846 .36765 m .75914 .37106 L .74612 .36044 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72677 .36393 m .74612 .36044 L .75914 .37106 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.56963 .10877 m .60383 .11864 L .5854 .12331 L 1 .01 0 r
F
P
p
.55117 .11355 m .56963 .10877 L .5854 .12331 L 1 .021 0 r
F
P
p
.002 w
.70761 .36738 m .68865 .3708 L .67451 .36017 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65551 .36366 m .67451 .36017 L .68865 .3708 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63671 .36712 m .6181 .37054 L .60283 .3599 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5842 .3634 m .60283 .3599 L .6181 .37054 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56575 .36685 m .5475 .37342 L .5311 .36283 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.002 w
.51281 .36949 m .5311 .36283 L .5475 .37342 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.4947 .37292 m .47678 .37631 L .45922 .36895 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.002 w
.44115 .38198 m .45922 .36895 L .47678 .37631 L p
1 .146 0 r
F P
0 0 0 r
s
P
p
.71285 .10951 m .73222 .10469 L .74551 .11936 L 1 0 0 r
F
P
p
.66027 .10432 m .69368 .11428 L .6747 .119 L 1 0 0 r
F
P
p
.64127 .10914 m .66027 .10432 L .6747 .119 L 1 0 0 r
F
P
p
.002 w
.74612 .36044 m .76568 .35692 L .77846 .36765 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.58827 .10395 m .62245 .11391 L .60383 .11864 L 1 0 0 r
F
P
p
.56963 .10877 m .58827 .10395 L .60383 .11864 L 1 .01 0 r
F
P
p
.002 w
.72677 .36393 m .70761 .36738 L .6937 .35665 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67451 .36017 m .6937 .35665 L .70761 .36738 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65551 .36366 m .63671 .36712 L .62166 .35638 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60283 .3599 m .62166 .35638 L .63671 .36712 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5842 .3634 m .56575 .36685 L .54957 .3561 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5311 .36283 m .54957 .3561 L .56575 .36685 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.002 w
.51281 .36949 m .4947 .37292 L .47734 .36547 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.002 w
.45922 .36895 m .47734 .36547 L .4947 .37292 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.67948 .09945 m .71285 .10951 L .69368 .11428 L 1 0 0 r
F
P
p
.66027 .10432 m .67948 .09945 L .69368 .11428 L 1 0 0 r
F
P
p
.60711 .09907 m .64127 .10914 L .62245 .11391 L 1 0 0 r
F
P
p
.58827 .10395 m .60711 .09907 L .62245 .11391 L 1 0 0 r
F
P
p
.002 w
.74612 .36044 m .72677 .36393 L .71309 .35309 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6937 .35665 m .71309 .35309 L .72677 .36393 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67451 .36017 m .65551 .36366 L .64069 .35281 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62166 .35638 m .64069 .35281 L .65551 .36366 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60283 .3599 m .5842 .3634 L .56823 .35254 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.54957 .3561 m .56823 .35254 L .5842 .3634 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5311 .36283 m .51281 .36949 L .49565 .36194 L p
1 .094 0 r
F P
0 0 0 r
s
P
p
.002 w
.47734 .36547 m .49565 .36194 L .51281 .36949 L p
1 .104 0 r
F P
0 0 0 r
s
P
p
.69889 .09452 m .73222 .10469 L .71285 .10951 L 1 0 0 r
F
P
p
.67948 .09945 m .69889 .09452 L .71285 .10951 L 1 0 0 r
F
P
p
.62615 .09414 m .66027 .10432 L .64127 .10914 L 1 0 0 r
F
P
p
.60711 .09907 m .62615 .09414 L .64127 .10914 L 1 0 0 r
F
P
p
.002 w
.76568 .35692 m .74612 .36044 L .73269 .34949 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71309 .35309 m .73269 .34949 L .74612 .36044 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6937 .35665 m .67451 .36017 L .65991 .34921 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64069 .35281 m .65991 .34921 L .67451 .36017 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62166 .35638 m .60283 .3599 L .58708 .34893 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56823 .35254 m .58708 .34893 L .60283 .3599 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.54957 .3561 m .5311 .36283 L .51416 .35838 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.49565 .36194 m .51416 .35838 L .5311 .36283 L p
1 .094 0 r
F P
0 0 0 r
s
P
p
.69889 .09452 m .7185 .08955 L .73222 .10469 L 1 0 0 r
F
P
p
.64538 .08916 m .67948 .09945 L .66027 .10432 L 1 0 0 r
F
P
p
.62615 .09414 m .64538 .08916 L .66027 .10432 L 1 0 0 r
F
P
p
.002 w
.73269 .34949 m .75249 .34585 L .76568 .35692 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71309 .35309 m .6937 .35665 L .67934 .34557 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65991 .34921 m .67934 .34557 L .6937 .35665 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64069 .35281 m .62166 .35638 L .60613 .34529 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58708 .34893 m .60613 .34529 L .62166 .35638 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56823 .35254 m .54957 .3561 L .53286 .35152 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.51416 .35838 m .53286 .35152 L .54957 .3561 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.66482 .08413 m .69889 .09452 L .67948 .09945 L 1 0 0 r
F
P
p
.64538 .08916 m .66482 .08413 L .67948 .09945 L 1 0 0 r
F
P
p
.002 w
.73269 .34949 m .71309 .35309 L .69897 .34189 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67934 .34557 m .69897 .34189 L .71309 .35309 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65991 .34921 m .64069 .35281 L .62538 .34161 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60613 .34529 m .62538 .34161 L .64069 .35281 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58708 .34893 m .56823 .35254 L .55174 .34459 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.002 w
.53286 .35152 m .55174 .34459 L .56823 .35254 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.68447 .07905 m .7185 .08955 L .69889 .09452 L 1 0 0 r
F
P
p
.66482 .08413 m .68447 .07905 L .69889 .09452 L 1 0 0 r
F
P
p
.002 w
.75249 .34585 m .73269 .34949 L .71881 .33817 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69897 .34189 m .71881 .33817 L .73269 .34949 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67934 .34557 m .65991 .34921 L .64484 .33789 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62538 .34161 m .64484 .33789 L .65991 .34921 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60613 .34529 m .58708 .34893 L .57082 .34088 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.002 w
.55174 .34459 m .57082 .34088 L .58708 .34893 L p
1 .021 0 r
F P
0 0 0 r
s
P
p
.68447 .07905 m .70433 .07391 L .7185 .08955 L 1 0 0 r
F
P
p
.002 w
.71881 .33817 m .73887 .33442 L .75249 .34585 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69897 .34189 m .67934 .34557 L .66451 .33413 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64484 .33789 m .66451 .33413 L .67934 .34557 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62538 .34161 m .60613 .34529 L .59009 .33383 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.57082 .34088 m .59009 .33383 L .60613 .34529 L p
1 .01 0 r
F P
0 0 0 r
s
P
p
.002 w
.71881 .33817 m .69897 .34189 L .68439 .33032 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66451 .33413 m .68439 .33032 L .69897 .34189 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64484 .33789 m .62538 .34161 L .60957 .33003 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59009 .33383 m .60957 .33003 L .62538 .34161 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73887 .33442 m .71881 .33817 L .70448 .32648 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68439 .33032 m .70448 .32648 L .71881 .33817 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66451 .33413 m .64484 .33789 L .62927 .32619 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60957 .33003 m .62927 .32619 L .64484 .33789 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70448 .32648 m .72479 .3226 L .73887 .33442 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68439 .33032 m .66451 .33413 L .64918 .3223 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62927 .32619 m .64918 .3223 L .66451 .33413 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70448 .32648 m .68439 .33032 L .66931 .31837 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64918 .3223 m .66931 .31837 L .68439 .33032 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72479 .3226 m .70448 .32648 L .68966 .3144 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66931 .31837 m .68966 .3144 L .70448 .32648 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68966 .3144 m .71023 .31038 L .72479 .3226 L p
1 0 0 r
F P
0 0 0 r
s
P
p
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.08509 .19367 m
.08465 .20033 L
s
P
[(0)] .08595 .18034 -0.06484 1 Mshowa
p
.002 w
.23498 .15292 m
.23469 .15959 L
s
P
[(10)] .23556 .13958 -0.04346 1 Mshowa
p
.002 w
.40002 .10806 m
.39989 .11474 L
s
P
[(20)] .40028 .0947 -0.01962 1 Mshowa
p
.002 w
.58262 .05842 m
.58267 .0651 L
s
P
[(30)] .58253 .04506 .00711 1 Mshowa
p
.001 w
.11395 .18582 m
.11371 .18982 L
s
P
p
.001 w
.14336 .17783 m
.14314 .18183 L
s
P
p
.001 w
.17332 .16968 m
.17311 .17368 L
s
P
p
.001 w
.20386 .16138 m
.20367 .16538 L
s
P
p
.001 w
.2667 .1443 m
.26655 .1483 L
s
P
p
.001 w
.29905 .1355 m
.29892 .13951 L
s
P
p
.001 w
.33204 .12654 m
.33192 .13054 L
s
P
p
.001 w
.36569 .11739 m
.36559 .1214 L
s
P
p
.001 w
.43505 .09854 m
.43499 .10254 L
s
P
p
.001 w
.4708 .08882 m
.47076 .09283 L
s
P
p
.001 w
.5073 .0789 m
.50728 .0829 L
s
P
p
.001 w
.54456 .06877 m
.54457 .07277 L
s
P
p
.001 w
.6215 .04785 m
.62155 .05186 L
s
P
p
.001 w
.66122 .03706 m
.6613 .04106 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{266, 253},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004:0000o@P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l02`000?mK2U/10000oe/:F`40003oF`YK
0@000?mK2U/10000oe/:F`40003oF`YK0@000?mK2U/10000oe/:F`40003oF`YK0@0005iK00?oFol0
0e/01?mKFe/3o`04FomKo`AK00GoFe]Ko`2AF`40001NF`03oe_o00=K00CoFe_o0e/2o`03FomK009K
00?oFol09E/4o`=K1?mTF`40001NF`03oe_o00=K00CoFe_o15/00omKo`03F`03oe_o02AK00?oFe/0
0U/00omKo`04F`03oe]K065K0@0005iK00?oFol00e/01?mKFol4F`03oe_o00=K00?oFol095/00omK
F`02F`03oe_o00AK00?oFe/0HE/10000GU/00omKo`03F`04oe]Ko`AK00?oFol00e/00omKo`0YF`03
oe_o00AK00?oFe/04E/3odeK0@0005iK00CoFooo0U/01?mKFol3F`;o00EKoe]Ko`03F`03oe]K02=K
0ol2F`03oe]K009K00?oFe/03U/3o`9K00?oFe/0Be/10000GU/01?mKoe/2o`AK0ol015_oFol2F`05
oe]KFol0:5/00omKo`04F`03oe]K00YK1?l6F`03oe]K00IK1?l3F`Co>E/10000GU/00omKF`0;F`03
oe]K02YK00?oFe/00U/00omKo`04F`03oe]K00IK1?l00e_oF`08F`03oe]K00AK00?oFe/00U/00omK
o`04F`03oe]K03IK0@0005iK00?oFe/02e/00omKo`0ZF`03oe]K009K00?oFol015/00omKF`03F`?o
1E/00omKF`08F`03oe]K00=K00?oFe/00U/00omKo`04F`03oe]K03IK0@0009YK1?l3F`Co0U/4oaAK
00?oFe/00U/00omKF`02F`03oe_o00AK00?oFe/0=U/10000Y5/3o`9K00?oFe/055/2o`9K0_l3F`03
oe_o00AK00?oFe/0=U/10000X5/4oa]K00?oFol00U/00omKo`02o`9K00?oFe/00U/00omKF`0fF`40
002MF`Co8E/00omKo`06F`03oe]K009K00?oFe/0=U/10000KU/6o`9K1?lOF`Co0e/00omKF`0OF`04
oe]Ko`=K00?oFol015/00omKF`0fF`40001^F`03oe]K00AK00?oFe/00U/00omKF`0HF`Co1e/00omK
F`0PF`03oe]K00?o0e/4ocUK0@0006mK00?oFe/00e/00omKF`02F`03oe]K01EK0ol2F`03oe]K02YK
00?oFe/0@U/10000L5/2o`=K00?oFe/00U/00omKF`0AF`Co<e/00omKF`11F`40001bF`04oe]Ko`AK
00?oFe/03U/4obaK0b<8F`03oe]K041K0@0007=K00?oFol015/00omKF`0:F`Co0e/00omKF`0UF`TS
25/00omKF`0oF`40001^F`03oe]K009K00?oFol015/00omKF`06F`Co:U/?8`QK00?oFe/0?U/10000
KU/00omKF`02F`03oe_o00AK00?oFe/00e/3o`=K00?oFe/095/C8`UK00?oFe/0?E/10000Ke/4o`=K
1?l2F`Co:E/H8`QK00?oFe/0?E/10000NE/3o`03FomK02QK6b<8F`03oe]K03aK0@0004]K00?oFe/0
0U/4ob5K1?l[FalS25/00omKF`0kF`40001;F`05oe]KFol015/00omKF`0JF`Go:E/47b4S25/00omK
F`0jF`40001;F`05oe]KFol015/00omKF`0GF`?o15/00omKF`0SF`TO8B<8F`03oe]K03UK0@0004]K
00GoFe]Ko`04F`03oe]K01=K1?lYF`03GamO00/O8B<8F`03oe]K03QK0@0004]K00GoFe]Ko`04F`03
oe]K011K0ol3F`03oe]K029K00=O7el03QlS8`UK00?oFe/0=e/10000Be/01OmKFe_o00AK00?oFe/0
35/4obMK2Al01ElOGamO00<O:2<9F`03oe]K03IK0@0004UK0ol3F`03oe]K009K00?oFe/02E/3o`9K
00?oFe/08U/021mO7elOGamO0Ql00elOG`037bhS25/00omKF`0fF`40001;F`05oe]KFol015/00omK
F`05F`Co9U/C7c0S25/00omKF`0eF`40001;F`03oe]K009K1?l4F`Co00=Koe/08e/4G`0<7elOGamO
7elOGamO0Ql00elO7`037c0S25/00omKF`0dF`40001EF`?o9U/00elO7`0J7c0S25/00omKF`0cF`40
000YF`Co95/4o`03FomK02AK1Al7G`057elOGal00Ul021mO7elOGamO1Al`8`QK00?oFe/0<U/10000
:5/00omKF`02F`03oe]K01iK0olXF`087elOGamO7el:7`03GalO00lO<2<8F`03oe]K035K0@0002QK
00?oFe/00U/00omKF`0JF`Go9U/>7`=O00lOGalOGamO7elOGamO7el02Al`8`QK00?oFe/06E/4o`03
FomK00Co0U/01OmKFe_o00=K0Ol1F`40000XF`03oe]K009K00?oFe/05U/4o`AK00?oFe/085/00amO
7`07G`057elOGal00Ul031mO7elOGamO7elOGa4O<2<8F`03oe]K01MK00?oFe/00U/3o`AK00?oFol0
0e/00omKF`03F`40000XF`03oe]K009K00?oFe/04e/3o`03FomK02EK0aL6G`HO00eO7elOGamO7elO
GamO008O00EO7elOG`0<7a0S11lO8`QK00?oFe/05E/00omKF`04F`;o1U/01OmKFe_o00EK0@0002QK
00?oFe/00U/00omKF`0?F`Co9e/03QLA5a4GGaMO5amO7elO0Ul03QmO7elOGamO7elOGamO4Al@8`03
GamO00HO7b<7F`03oe]K01EK00?oFe/015/7o`03FomK009K00?oFe/00e/10000:5/00omKF`02F`03
oe]K00aK0ol00e_oF`0TF`hG0el05QmO7amO7elOGamO7elOGamO7elOGal2G`047elOG`8O42<00amO
7`0;7alS1e/00omKF`05F`03oe]K00AK1?l4F`04oe]KF`Go15/00omKo`03F`03oe]K00=K0@0002QK
00?oFe/00U/00omKF`08F`Co9U/55`0:4ALA5a4G4ALA5`IO00<OGal00Ul03QmO7elOGamO7elOGamO
2al<8`03GamO00DO00EO7elOG`067alS1e/00omKF`04F`03oe]K00=K00?oFe/00U/01OmKFe_o00MK
00?oFe/00U/01?mKool2F`03oe]K00=K0@0002UK1?l8F`?o00=Koe/08e/00aLA5`024@045a4G4@PG
00=O5el01El011mO7el27`0?GamO7elOGamO7elOGamO00XO1b<3G`047elOG`8O00=O7el031lO8`MK
00?oFe/015/00omKF`02F`03oe]K009K00GoFe]Ko`06F`03oe_o00?o0U/01?mKool6F`40000aF`Co
8U/00aLA5`024@035a4G00XG00DAGaMO5`0;G`8O00eO7elOGamO7elOGamO00DO00EO7elOG`057`8S
00dOGalOGamO7elOGamO00LO00=O7el01QlO8`MK00?oFe/00e/00omKF`02F`03oe]K009K00?oFe/0
0U/00omKF`02F`03oe]K011K0@0002eK1?l00e_oF`0OF`@A00DG4ALA5`064@035a4A00XG00AO5elG
0el47`AO00HOGamO7el27`07GamO7elOG`0@7`EO00DOGamO7`02G`047elOG`LO8B<8F`03oe]K00=K
00GoFe]Ko`04F`03oe]K00=K1?lCF`40000ZF`?o8e/3W`HA00<G4AL00Q4>5`04GaMO5`aO00hOGamO
7elOGamO7elOG`DO00=O7el01el011mO7el27`09GamO7elOGamO00LO00=O8b<092<6F`03oe_o00AK
00GoFe]Ko`04F`03oe]K01YK0@0002QK0_l00e_oF`0OF`08gioOWa6O4Il54@035a4A00PA00@G4ALA
1QL5G`047elOG`DO0Ul04AmO7amO7elOGamO7elOGamO014O1Ul00amO7`02G`@O:2<8F`03oe]K009K
00CoFe_o15/00omKF`0JF`40000XF`03oe^101iK00>Ogil02Yl34@075a4A5a4G4@0<5`08GaMO7elO
Gal3G`037elO00TO00IO7elOGal4G`037elO019O00POGamO7elOG`HO:2<7F`03oe]K00=K00?oFol0
15/00omKF`0JF`40000XF`03oe^101YK1=h02ioOWmnOgioOWa6O00DA00<G4AL01a4=5`=O00<OGal0
1Al5G`047elOG`8O00]O7elOGamO7elOG`037`09GamO7elOGamO00DO0el00amO7`097bPS1e/6o`9K
1?lMF`40000XF`03oe^101MK00eagW7NgmkOg]nOgioO00FO00TAWa6O4ALA5a400QL02A4G4ALA5a4G
4@065`UO00@OGamO0al9G`035elG00]O00DGGaMO5`02G`<O00EO7elOG`057`03GamO00<O00AO7elO
9b<7F`03oe]K02EK0@0002QK00?oFh404e/4k0Ea1=h00ioOW`04W`04gioOW`DA00@G4ALA41L4G`04
7elOG`<O11L4G`047elOG`8O15l02AmO7elOGamO7`02G`8O00IO7elOGal2G`057elOGal00Ul01QmO
7elOG`HO9b<7F`03oe]K02AK0@0002QK00?oFh4045/00kJg]P05g009gW7NLMkOg]oN00KO1Yl24@0@
5a4G4ALA5a4G4ALA5elGG`8G00AO5elG1Ul021LA5a5O5elG1el01aMO5elOGal025l021mO7elOGamO
1Al02ElOGamO7elOG`077`04GamO7bLS1e/00omKF`0SF`40000XF`03oe^100aK2KL4k09a00VEg9GL
gmkOg]l01Il01MlA5a4G00@A00@G4ALA41L2G`034ALA00XG0Ul01aMO5elGGaL01El07amO7elOGamO
7elOGamO7elOGamO7elOGamO7elOGal00Ul00amO7`047`LS0QlN8`MK00?oFe/08U/10000:5/00omK
P@0<F`0:][Nf]kJg][Nf]`;L00>f]kH01YD01=oNgmh2g`074ALA5a4G4@025`0A4ALA5a4G4ALA5a4G
4AMO5el00QL015lA5a455`064ALA5a5O0QL00a4G5`045`07GaMO5elOG`047`0VGamO7elOGamO7elO
GamO7elOGamO7elOGamO7elOGamO7elOGal28`@O00=O7el07R<7F`03oe]K025K0@0002MK00CoFe^1
3e/?]`09g9GOg]nOgioO00HA00<G4AL00Q402ALA5aLA5a4G4@075`034ALA00@A00@G4ALA0QL54@0:
5a4G5elGGaMO5`UO00HOGamO7el37`EO00DOGamO7`02G`0<7elOGamO7elOGamO0al01elOGamO7el0
11l28`<O6B<7F`03oe]K021K0@0002MK00CoFe^14E/02kNf]kJg][Nf]kJg00CM1=h01mnOgioO4AL0
1a4011LA5a425`034@D5008519l64@035a4G00<G00XA5aLA5a4G4ALA0aL4G`055alG7aL01Al2G`03
7elO00AO00HOGamO7el57`0AGamO7elOGamO7elOGamO7el01al00elO7`057aPS1e/00omKF`0PF`40
000WF`03oe^101AK1[L3g00;UG6ELIGNgmkOWml019l0116O4Il24@085a4G5a7NLMh51@06WmnOga4G
114011LA5a455`8A0aL4G`057elOGal00el031mO7elOGamO7elOG`@O1El011mO7el27`0CGamO7elO
GamO7elOGamO7elOG`027`06GalOGamO1AlH8`MK00?oFe/07e/100009e/2o`03PE]K01=K00Bf]mc/
1]`4g@;N00PAWa6OgioOW`LA00=agW401=h51@JO00TAWa6O4ALA5a400QL02a4G4ElGGaMO7elO00MO
00dGGaMO7elOGamO7elO00IO00@OGamO1Al04ElOGamO7elOGamO7elOGamO010O5b<7F`03oe]K01iK
0@0002MK00?oFh405e/00ncLk006g003LIGN00;N00GOWmnOg`04W`094IoNLMiagW7N009a00?NLMh0
0PD4g`04WmnOg`DA00<G4A400a4011LA5a445`9O0aL5G`0>7elOGamO7elOGamO7el57`IO00TOGalO
GamO7el00Ql035lOGamO7elOGamO7`9O00<OGal02AlG8`MK00?oFe/07E/100009e/00omKP@0IF`03
g>cL00;L19D03]oNgmkO4IlAWmnOgG7M1g400miagP04gP05gmkOg]l01Il24@035a4G00@G00HA5a4G
4El85`IO00<GGal01El01AmO7elO00EO2Ql05elO7amO7elOGamO7elOGamO7elOGamO00LO6R<7F`03
oe]K01aK0@0002MK00?oFh405e/03H5KFe_/g>bEg9GLUM`00]h3U@Ua00?NLMd00md0277MLG7NLMia
1=l01IoO5a4G00XA1QL00a4G4@045`9O11L5G`087elOGamO7el57`IO11l4G`0=7elOGamO7elOGamO
7`02G`047elOG`8O7R<8F`03oe]K01]K0@0002MK00?oFh405e/00h5KF`02F`05k=c/g>`00YD01]c/
g=cMg0;M00=agG400]d2L@03UG7M00CM1742gP03gioO00DA00<G4AL00Q400aLA4@064@045a4G4@8G
00lA5a4G4ALAGaMO5elOGal01el00aMO5`05G`8O15l011mO7el47`0DGamO7elOGamO7elOGamO7elO
GalO8`QK00?oFe/06U/100009e/00omKP@0GF`03PE]K00=K00?/g;L00kL01>cLk=`4U@9a00S/g>cL
gIGMU@GM00=agIl01il01A6O4IlG008A00FO4A4G4@025`034ALA00<G11400aLA5`0:5`08GaMO5elO
Gal2G`037aMO00EO00@OGamO1Al6G`077elOGamO7`02G`047elOG`DO7b<8F`03oe]K01UK0@0002MK
0_l00h5KF`0EF`03PE]K00EK00Rf]kJg][OLk0;L00CM]kJg1]`00g6EL@02g@GO00LAga6OgioO008A
00>O4Il03a404ALA5a4G4ALA5a4G4ALA5a4G00QO00/GGaMO5elOGamO7`03G`035emO00=O1Ql00elO
G`057`07GamO7elOG`0S8`IK00?oFe/06E/100004e/00omKF`02F`Co0U/4o`EK0h4GF`03PE]K00QK
3KL01^cLk=c/g0?N1Ml9W`DA00>O4Il00Q4011LA4A455`DA00<G4A400Q4011LA5a445`03GaLG00LG
00=O5el00Ul00amO7`02G`037elO00@O0Ul02amO7elOGamO7elO009O11l;8`<O5b<6F`03oe]K01QK
0@0001=K00GoFe]Ko`04F`;o15/00omKF`02F`04oe^1PAIK00>1Fe/02U/03KNf]kJg][Nf]kJg][L0
1M`0177NLMh3g`03WmnO00>O00OOWmnOgilA00NO00DG4ALA5`094@@G00<A5aL031L015lGGaL5G`07
7elOGaMO5`03G`@O00MO7elOGamO00<O00=O7el011l68`<O00EO7elOG`0G8`IK00?oFe/05e/10000
4e/01OmKFe_o00AK0_l4F`03oe]K009K00CoFh5K0X4DF`03PE]K00aK3;L01Mc/g>cL00GN00>Ogil0
1Ml3W`0;gioOgioOWa6O4Il01Q400aLA5`055`XA00@G4ALA0aL7G`087elOGamO7el47`IO00LOGemO
7elO009O00@OGamO0al02ElOGamO7elOG`067aLS1U/00omKF`04F`Co0e/4o`MK0@0000aK0ol4F`05
oe]KFol015/2o`AK00?oFe/00U/00omKP@03F`:14U/00h5KF`0>F`0;]kJg][Nf]kJg][L00]`0177M
LMd5gP03gioO00:O0ml019oOWml7W`07gioO4IlAW`074@075a4G5a4G4@065`04GaMO5`=O00DOGamO
7`05G`037elO00EO0Ql00elOG`057`0=GamO7elOGamO7elOG`097`05GamO7el05R<7F`03oe]K009K
00?oFe/00U/00omKo`04F`03oe]K00AK0@0001=K00GoFe]Ko`04F`;o15/00omKF`02F`03oe^100EK
0X4@F`03PE]K00mK1[L3k008gIGMgG7MLMd2gPMa00KOg]oNgil2g`03WmoO00?O1Il34@045a4G4@HG
0Q4<5`03GaMO00IO00POGamO7elOG`8O00=O7el02El00amOG`03G`0?7elO7elOGamO7elOGamO00HO
5R<7F`05oe]KFol015/00omKo`04F`03oe]K00AK0@0001=K00GoFe]Ko`04F`;o15/01OmKFe_o009K
00>1Fe/01E/2P@iK00>1Fe/045/01KNf]kJg00CL00QaUG6ELMeag@9a00?MLMd01Mh6g`03WmnO00FO
00?O4A401A401QLA5a4G4@8G00DA5elGG`025`08GaMO5elGGaL5G`037elO00]O00@OGalO15l03AmO
7elG7aLO5amO7el03Al00elO8`0H8`EK0ol2F`03oe]K009K00?oFol015/00omKF`04F`40000AF`?o
0e/00omKF`02F`;o15/01?mKFe/2o`03Fh5K00QK0X4<F`03PE]K019K1KL3k004gIGMU@;M00AagG7M
1W400miagP05gP03gioO00;O0il54@045a4G4@8G00<A5a403AL015lGGaL7G`0:7elOGamO7elOG`8O
0Ul02QmOGamO7elOGal6G`097elO7elOGamO028S1e/00omKF`04o`9K00?oFe/00U/00omKF`04F`40
000CF`05oe]KFol015/2o`AK00GoFe]Ko`02F`03PE]K00UK0X4:F`03PE]K019K00N1FkNf]kJg00?L
00ZELIEaUG7M][Nf0m`01MiagW7N00;O1Il00mnOW`04W`@A00@G4ALA1AL0214G4AMO5elG0Ul02aMO
5elGGaMO7elO00mO00<OGal01El011mO7el27`07GamO7elOG`027bHS25/00omKF`02F`03oe_o00AK
00?oFe/015/100004e/00omKF`02F`Co0U/4o`AK00?oFh403U/2P@MK00>1Fe/04e/0185KFe/5]`?/
00?MUKL01kL02>cLk77NWmnO1Ml00ioOW`02W`045a4G4@<G1A400aLA4@024@hG00=O5el015l03QmO
7elOGamO7elOGamO0Ql00elOG`057`?o0Ul00amO7`037`LS0QlO8`MK00?oFe/00U/00omKo`04F`03
oe]K00AK0@0002IK00?oFh4045/2P@EK00>1Fe/04e/00h5KF`02F`0J][Nf]kJg][Nf]kJg][Nf]ncL
gmkOgYoOWml4W`03ginO00:O21400aLA4@034@DG00<A5el00QL045lGGaMO5elGGaMO7elOGal;G`06
7elOGamO1Ol38`03oalO00HO0R<77alS1U/00omKF`02F`03oe_o00AK00?oFe/015/100009U/00omK
P@0BF`:10e/00h5KF`0CF`03PE]K00AK3[L3g0GN00BOgioO0Yl03=nOWa6O4IlG4IoOW`<A00DG4ALA
5`034@035a4G00TG35l00amOG`05G`037eoo00Co12<00olS8`028`04oamOG`8O00MO7elOGamO00DO
0R<37aLS2E/4o`=K1?l7F`40000VF`03oe^101AK0X400e^1F`0DF`03PE]K00IK016f]kJg][Nf]kJg
][Nfg>cLg`05gPGO00BOginO1=l01ioOWmnO4Il01a400aLA5`055`04GaMO5`UO00<OGel01El00aoo
o`02o`@S00?o8b<00b<01OlS8olS00;o2Ql01ElOGamO00HO3b<RF`40000VF`03oe^101IK0X4EF`03
PE]K00QK3KL3g0GN00?OWg400W43gP06WmnOgioO0Yl00mnOW`02W`094ALA5a4G4ALA00DG00AO5elG
0Ul45`03GaMO00=O1Ol38`03ob<S00<S00Ko8b<Sob<2o`@S00?o7el00Ql4G`037elO009O00<OGal0
1Al:8bIK0@0002IK0_l00h5KF`0EF`>14e/00h5KF`0:F`0@][Nf]kJg][Nf]kJg]]c/g0;N00O/g>bE
LIEa00CN0ml01MkOWmnO00;O00>Ogil01A4011LA5a445`03GaLG00LG1Ol48`03ob<S008S00Ko8b<S
ob<3o`<S00?o8b<00b<01?mOGel57`03GalO00XO0R<2F`03PE]K02QK0@0002IK00?oFh405e/00h5K
F`02PA5K00>1Fe/035/@]`04g>cLk09a0kL01mfEgIGNgmh00]l02ioOWmnO4IlA5a4G008A00<G4AL0
1A4011LA5a44o`@S00?o8b<00b<01OlS8olS00?o0b<00olS8`038`07ob<S8olSo`037`=O00TOGelO
GamO7el00al6F`03PE]K02QK0@0002IK00?oFh405e/00h5KF`02F`:13e/00h5KF`0=F`0J]kJg][Nf
]kJg][Nf]kJg]]c/]kJg][Nf]kH3U@04g]nOg`FO1Q43W`DA00<Gool00ol47`03ob<S008S00Ko8b<S
ob<2o`@S00?o8b<00R<01_lS8b?o8`?o0b<01?mO7el77`eK00>1Fe/0:5/100009U/00omKP@0GF`03
PE]K00AK0X4=F`03PE]K00mK5kL01]eagMkOgPFO00kOWinOgioOWa6O4IlG4@?o11l00olO7`037`05
ob<Sob<00ol48`03ob<S008S00Go8b?o8`03o`<S00?o8b<00b<00omOG`02G`037emK00mK00>1Fe/0
:5/100009U/00omKP@0GF`03PE]K00IK0X4;F`03PE]K00mK01>1FkNf]kJg][Nf]kJg][Nf]kJg00CL
00AaUG6E0mh02MnOgioO4MlAg`06W`?o00<OGal00_l47`Co00<Oool012<2o`@S1?l00b?oo`048`03
ob<S008S00Ko8b<Sob<2oaAK00>1Fe/0:5/100009U/00omKP@0GF`03PE]K00QK0X49F`03PE]K00mK
00B1Fe]K4;L4k003LMea009a1ml2W`03LMea00;N0_l87`;o12<00olS8`028`03ob<S00<S0_l48`03
ob<S008S00?o8b<00b<3o`048oooo`@S00?oFe/04E/00h5KF`0XF`40000VF`03oe^101MK00>1Fe/0
2U/2P@MK00>1Fe/03e/00h5KF`02F`0B][Nf]kJg][Nf]kJg][Nf]kJg0m`4gP?O00>OgiD00iD0176E
ool47`Co0b<00olS8`038`05ob<Sob<00ol38`03ob<S00<S00Go8b?o8`03o`<S00?o8b<00R<2o`@S
00?oFe/045/00h5KF`0XF`40000UF`;o00=KPE/05U/00h5KF`0<F`:115/00h5KF`0@F`03PE]K00AK
4KL3k09a0n`00iGLo`06o`047elOG`;o0al00olS8`028`06ob<S8olS0_l48`03ob<S008S00Ko8b<S
ob<2o`<S00?o8b<00b<01_lS8b?o8`;o0b<00omKF`0?F`03PE]K02QK0@0002EK00CoFe^15e/00h5K
F`0>F`:10U/00h5KF`0@F`03PE]K00EK00ng]/`=c;Jg][Nf]kJg][L00dd00l`=c005o`@O0_l37`;o
1Ql01OlS8olS00?o12<00olS8`028`05ob<Sob<00ol38`03ob<S008S00Ko8b<Sob<3o`<S00?o8b<0
0R<00omKF`0?F`03PE]K02MK0@0002EK00CoFe^15e/00h5KF`0@F`03PE^1019K00>1Fe/01e/5c0Fg
1T`3o`04GamO7`;o00EO7elOG`02o`04GamO7`;o11l2o`@S0_l48`Co00<Sool012<00olS8`028`05
ob<Sob<00ol48`03ob<S008S00Go8b?o8`02o`mK00>1Fe/045/4PA=K0@0002EK00CoFe^15e/00h5K
F`0AF`:14U/00h5KF`09F`03c0e?009?24d01?lO7al2o`@O0ol47`03oalO00<O0_l47`;o12<2o`@S
00?o8b<00R<00olS8`038`?o00<Sool012<2o`@S1?l00b?oo`048`03oe]K00aK00>1Fe/02U/6PAMK
0@0002EK00?oFh4065/00h5KF`0BF`>145/00h5KF`0<F`03?dlo009<12<00omOG`04G`;o00@OGamO
0_l011mO7el3o`@O00?o7al00al2o`@S00?o8b<00R<01OlS8olS00?o0b<00olS8`028`03ob<S00<S
0_l38`03ob<S00<S00?o8b<00R<00omKF`0;F`03PE]K00EK1H4MF`40000UF`03oe^101QK00>1Fe/0
4U/00h5KF`02P@iK00>1Fe/03U/48`?o0al2o`0:GamO7olOGamO7`;o11l2o`@O0ol48`03ob<S008S
00Go8b?o8`02o`@O00?o8b<00R<01OlS8olS00?o0b<00olS8`028`06ob<S8olS0_l38`03oe]K00YK
00>1Fh401H4RF`40000UF`03oe^101QK00>1Fe/04U/00h5KF`02F`:135/00h5KF`0<F`03POoo00?o
0Ql2o`0;GamO7olOGamOoal00_l015lOGal2o`<O0_l48`;o12<4o`038ooo00<O00?o7al011l3o`03
8ooo00@S00?o8b<00R<01OlS8olS00?o0b<00olS8`028`03oe]K00EK1X4XF`40000UF`;o00>1Fe/0
5U/00h5KF`0BF`03PE]K00AK0X4:F`03PE]K00YK0ol00elOG`02o`0?GamO7olOGamOoelOoaoo00@O
0_l37`04ob<S8`;o12<2o`03Gaoo00DO00Oo7elOGolO00?o0Ql00olS8`028`03ob<S008S1?l00b?o
o`048`03ob<S008S1?l00b?oo`05P@AK00>1Fe/09e/100009E/00omKP@0HF`03PE]K019K00>1Fe/0
1U/2P@QK00>1Fe/025/2o`@O00AO7elO0_l015lOGal3o`087oooGamO7el2o`HO00Go8b?o8`02o`9O
00co7elOGolOGamO7ol27`03oaoo00HO00Go8b?o8`02o`<S00?o8b<00b<00olS8`028`;o0b<00olS
8`038`03oe]K00IK00>1Fe/09e/100009E/00omKP@0GF`03PE]K01=K00>1Fe/025/2P@IK00>1Fe/0
1E/3o`06GolOGomO0_l015lOGal2o`08GamO7olOGal2o`077ooo7elOG`02o`<O0_l03AmOoamO7eoo
GamO7ol011l3o`05GamO7ol01Al2o`@S00Go8b<So`038`04ob?oo`@S00Go8b<So`038`03ob?o00MK
00>1Fe/09e/100009E/00omKP@0GF`03PE]K01=K00>1Fe/02U/2P@AK00>1Fe/00U/3o`IO00Go7elO
G`02o`0?GamO7olOGamOoelOoaoo00<O0_l67`03oalO008O00coGemOoelOGamOoal2o`04GamO7`;o
0Ql3o`@S00?o8b<00R<3o`048oooo`@S00?o8b<00R<3o`048oooo`<S00?oFe/015/00h5KF`0WF`40
000UF`03oe^101MK00>1Fe/04e/00h5KF`0<F`:10U/00h5KF`02o`0<GaOoGamO7eooGamO0Ql025lO
oomO7elO0ol00aooo`027`;o00<OGel00el00omOG`02G`0@oamO7omO7elOoamO7elOo`<O00?o7al0
0Ql01?lS8b<2o`@S0_l38`03ob<S008S00?o8b<00b<2o`<S00?o8b<00R<00olS8`028`;o15/00h5K
F`0WF`40000UF`03oe^101MK00>1Fe/04e/00h5KF`0>F`:10ol55`09oemOGolOGaoo00IO0_l01AmO
7elO00?o00HOGamO7el57`05oalO7ol011l02omOGeoo7elOGomO00<O00?o7al011l3o`038ooo00@S
00Go8b<So`028`03ob?o00;o0b<00olS8`028`05ob<Sob<00_l48`05oe]KFh40:E/1000075/4o`EK
0_l00h5KF`0EF`03PE]K01=K00>1Fe/025/8o`0=5a4G4OmO5elGoeooG`03o`037elO00;o1Al3o`03
5emO00=O00KoGamO7ol3G`0JoemOGolOGamOoamO7eooGaoo7elOGamOoal3o`03Gaoo00@S00?o8b<0
0R<3o`038ooo00@S00?o8b<00R<4o`038ooo00@S00?o8b<00R<01?mKFh4YF`40000KF`03oe]K009K
00CoFe]K0X400e^1F`0FF`03PE]K01=K00>1Fe/015/4o`054ALA5ol00aL3o`<G0ol011Ooool37`;o
15l3o`0@GalOGamO7elOGaoo7elOo`<O00?o7al00Ql00olO7`027`07oemOGomOo`02G`03oalO00<O
00?o7al011l01OlS8olS00;o12<01OlS8b?o00@S0_l48`05ob<S8ol01B<2o`<S00?oFh40:E/10000
6e/00omKF`02F`06oe]KFomK0h4FF`03PE]K01=K00B1Fe]K0ol45`03oaLG00<G00Go4AOo5`02o`9O
0_l5G`;o11l2o`MO00@GGaOo0el01_lOGamOo`=O00coGemOoelOGaooGal4o`<O00CoGooo0al01_lO
GamO7`;o12<00olS8`028`?o00<Sool012<00olS8`028`?o00@Soooo0b<00olS8`028`;o:E/10000
6e/00omKF`02F`05oe]KFol00U/0185KPH4DF`03PE]K01=K00B1oooo0a402olA5a4G4OlG4OlA00;o
0QL2o`EO0ol57`;o15l04QmO7eoo7elOoamO7olOGamOo`<O00Go7alOo`047`?o00HOGaoo7el3o`08
7elOGamOoal2o`<O00?o8b<00R<2o`@O00Go8b<So`048`;o12<01OlS8b?o00@S0_l48`03oe]K02IK
0@0001]K00?oFe/00U/01OmKFe_o009K00B1Fe]K0h4AF`03PE]K019K0_l0214Goa4G4AOo1AL2o`@G
00WoGaMOoelOGol015l3o`035eoo00AO00[oGemOoaMO5eoo0el01OmO7eoo00=O00?oGel00Ul4o`03
7olO00Ko00AO7elO0_l47`07oamO7elOG`02o`8O00OoGamO7elO00?o00<Sool012<00olS8`028`?o
00<Sool012<00olS8`028`03oe]K02EK0@0001]K00?oFe/00U/01OmKFe_o009K00>1Fe/015/2P@mK
00>1Fe/045/2o`064ALA5a7o11401olAoolG4AL00_l00aOo5`045`0:oeoo7elOGolGo`@G01OoGemO
oelOGaooGamOoelOGomO7elOo`037`03oaoo00;o00aO7oooGamO7olOGal2o`04GamO7`;o00DOGamO
7`02o`08Gaoo7elOGol37`04oelOo`@O00?o8b<00R<2o`<S00Go8b<So`058`;o0b<00omKF`0TF`40
000KF`03oe]K009K00GoFe]Ko`02F`03PE]K00IK0h4<F`03PE]K00mK00co4A7o5a4G4AOo4AL3o`LG
00[oGaMO5elGGomO0ol02ALA5a7o5elGo`04G`09oemOGomO5eoo00=O00CoGamO2_l015lOGal2o`04
GamO7`?o00POoomO7elOG`;o00POGaoo7elOo`@O00?oGol011l01OlO7olO00;o0b<00olS8`028`Oo
0b<00olS8`028`03oe]K02=K0@0001]K00?oFe/00U/01?mKFe/2o`03PE]K00YK0X4:F`03PE]K00iK
00?o4A400Q401_lA5a4G4@;o0Q43o`<G0ol25`?o15l00olGo`045`03oaLG008G017oGemOoamO7eoo
7elOoamO7`03o`06GoooGaoo0al00omOG`04G`;o00EO7elOG`02o`0CGaoo7elOGomO7elOoamO7olO
G`03o`06GamO7elO0_l37`03ob<S008S0_l48`05ob<S8ol012<2o`<S00?oFe/08U/1000075/4o`AK
00?oFh403U/3P@MK00>1Fe/01e/7o`HA00co5ooo5a4G4ALA5a42o`045a4G4@;o00EO5elGG`02o`<G
00[o4ALAoaMO5eoo15l01omOGeoo5el01ol025lOoamO7eoo0el02_lOGaoo7elOoal2o`8O00ko7elO
oamO7eooGaoo7`Ko1Al2o`@O0_l27`;o12<00olS8`028`?o00<Sool00b<00olS8`028`;o8U/10000
95/00omKP@0AF`:11E/00h5KF`05F`;o00ROgioOoa6O4@?o0a401olAoa4G4AL00_l45`;o1AL3o`8A
00Go4ALAo`045`05oaLG5ol015l01_mO7eoo7`;o00mOoolOoamO7eooGamO7ol00al00omOo`05G`0=
oelOGamOoamO7olOG`04o`0:GamO7olOGaoo7`;o00<OGal00_l48`05ob<S8ol012<2o`<S00Go8b<S
o`048`;o12<00omKF`0OF`40000TF`03oe^101=K0h42F`03PE]K00AK0_l6W`03oinO00>O0_l24@03
5a7o00;o00<A5a400_l011LA5a42o`0:5ooo4OlA5a4Go`<G00[o5a4GoelGGaOo0el00omOG`03o`9O
00oo5elGGomOFelOoamO7ol00Ul3o`047elOo`@O00?o7al00Ql6o`09GamO7olOGamO00?o00AOoelO
0_l015lOGol48`?o00<Sool00b<00olS8`028`Ko12<00olS8`028`03oe]K01iK0@0002AK00?oFh40
5U/3P@EK00cogiooWmnOgioOoa42o`8A00?o4A401A42o`044ALA5`;o0aL01_lA5a4Go`<A00Go5a4G
o`045`05oaLG5ol00Ul5o`03Gooo009O00coGamO7olOGaoo7el4o`HO00?oGel00el2o`<O00?oGel0
0el2o`0=7eoooamO7eooGamOo`067`;o0b<00olS8`028`;o0R<2o`@S00?o8b<00R<2o`8S0_l38`03
oe]K01eK0@0002AK00?oFh4065/3P@9K00KoWmnOgol5W`Ko00@A5a4G0_l02QLA5olA5a4G4Ol3W`03
oa4A008A00Ko5a4G4Ol35`08oa4G4OlGGaL5o`047elOo`EO00Oo5elGoamO00Co0Ul01OmO5eoo00AO
00go7oooGomO7elOGolO00;o0al02OmO7eooGamO7`02o`03Gooo00<O00Go8b<So`038`;o00EO7elO
o`038`03ob<S008S0_l38`05ob<S8ol012<00omKF`0LF`40000TF`03oe^101QK00>1Fe/00X404OnO
gioOWonOgiooWmnOga4G00;o00`A5a7o5a4G4OlG4AL2o`0:WmnOgolG4ALAo`<A00Go4ALAo`035`04
oaOoo`8G00=K5aL00_l35`03oemO009O00?oGal01?l02aOo7elOGolOGaoo00<O0_l01ElOGaoo00DO
00?oGel015l3o`087oooGamO7ol67`?o00DSoomOo`067`?o00<Sool00b<00olS8`028`Ko0b<00omK
F`0KF`40000TF`03oe^101QK00n1Fe]KomoogioOWmooWol00Yl01=lGool74@08oa4G4AOo4Ol21@05
oinOWol01A401?lG4Ol25`Oo00@G4OlG0_l00aOo5`045`05oemOoel00ol00aooG`02G`0>oemOGolG
GaMOoeooGal5G`04oelOo`AO0_l025lOGaoo7elO0_l01ElOGamO00;o00<OGol00al03?lO7aooGamO
oelOo`@S0_l28`;o0b<00olS8`028`;o0R<00omKF`0JF`40000TF`03oe^101QK00j1Fe]KomkogioO
WmnOo`BO00kOoilAWa6Ooa4G4OlG4@?o0`D03?oOWmnOoa4G4AOo4@Go00mK4A7o4ALA5a7o5a4G4Ol0
1AL2o`DG00ko5elGGomO7elOoelOG`;o1El01_lOGolOo`<O15l01OlOGamO00;o00DOGaooG`02o`0A
GaooGamOoelOGomO7eoo7ol011l2o`<S00Go8b<So`048`;o0b<01OlS8b?o01]K0@0002=K00CoFe^1
65/03X5KFe_ogooOWmnOgioo0ml019oOWol54@03oa4A00?o0]h41@03oinO00:O00?o4A400a42o`05
5a4G4Ol00aL01olAoolA5a4011L02?lG5olA5a4G0_l00a4Go`05G`06oemOGomO0_l021MO5olOGamO
1?l5G`;o0Ql2o`<O00oo7elOGomO7elOGomO7ol00Ql7o`03Gaoo00@S00Co8b<S1_l38`03ob<S008S
1_lIF`40000SF`04oe]KPAQK00B1Fe_o0mh01_nOgioOo`>O00?OWil00Yl01OnO4IlA00?o0]h0177N
LOl31@0;omnOgioo4ALA5ol00Q400olA4@024@03oa4A00;o1QL01_lA5olGo`<G00?o4Ol011L02?mO
5elGoamO0ol01UlGGaMO5`;o00IO7olOGol57`;o0el00omOG`02G`;o0Ul01omO7elOGal01Ol00elO
o`038`03ob<S008S0_l28`;o0b<01?lS8b<2o`8S0_l38`03ob<S008S00?oFe/05U/100008e/01?mK
Fh4GF`0>PE]KFooNgmkoWmnOgol2g`09WmnOgioOWolA00;o0W400miao`03gP03o`D5008500?oWil0
0Yl02olA4OnO4ALAoaLA00Co0a42o`045a4G4@Co00dA5aOo4ALAoa4G4AOo009O1?l01ElGGaMO00;o
0Ul02OmOGeooGamOo`03G`0GoelOoelOGolOoamOoalG7olOGaoo7el00al01?lS8b<2o`8S0_l38`03
ob<S008S0_l28`;o0b<01?lS8b<2o`8S0_l38`03oe]K01EK0@0002=K00CoFe^15e/0185KFol4gP05
oioOWol00Yl01=nOgol4W`;o00]agW7NLMkoLMiao`041@05oioOWml00ol01Q7o5a7o4@;o00TG4ALA
oaLA5a400_l24@;o00<Goa400a401OlA5a7o00<G0ol35`05oaMO5el00ol2G`0@oamO7eooGamOoaoo
7elOG`Go00EO7elOo`03G`04oeooG`HO0_l00elOo`047`;o0R<2o`<S00?o8b<00R<2o`8S0_l28`05
ob<S8ol012<00on1P@02PA9K0@0002=K00CoFe^15e/05H5KFooOg]oNgooOWooOWmnO4IooW`02o`03
gG5a009a00CogW7o1=h01Ol51@Go00FO00CoWa4A0_l44@;o0a42o`<A0_l00a7o4@024@03oaLG008G
00Oo4ALAoa7o00@G0_l3G`09oemOGolOGaoo009O00?oGol01?l01elOoamO7ol00Ul01_mO7elOG`Go
00EKoolOo`037`03oalO008O00Ko7olOGol37`03ob<S008S0_l38`05ob<S8ol00b<6o`:15e/10000
8e/2o`03Fh5K01IK00B1Fe_o1Mh02_oOoiooWmkogil2o`=a00gNLMiaog7Nog7NLMko00@500SogioO
WonOo`<A0_l0116O4Il2o`@A0_l01ALA5a7o00<G00Co4A4A1_l011LA5ol25`06oelGGaOo0el00omO
G`03o`05GamO7el00_l031mOoelOGaooGaoo7`;o018OoelOGaooGamO7omO7eooGal3o`057elOGol0
0Ql3o`<S00?o8b<00R<6o`:17U/100008e/01?mKFh4EF`Go00SNgmkOg]oog`;o00COWmkO0_l2L@04
gG7Mo`=a00GogW7No`03gP03o`D5008500goWinOoiooWa6O4IlA00;o19l01olGoolAWol011403?lA
4A7o5olG4AMO5`;o00]O5omO5olGGaMO5`03o`04GoooG`;o0Ul01OmOGeoo00=O00GoGaoo7`05o`04
Gaoo7`;o00=Ooal00al00olO7`04o`087elOoamO7el2o`@O00?o8b<00_l3PBEK0@0002=K00?oFh40
5U/00omaL@04L@;o0mh01?oNoml3gP03og5a00Aa00goLMiagW7NLOoNLMko00@500Cogioo1Il3o`09
Wmoo4IlAWa7o00DA00Go5a4Go`025`?o00<AoaL00QL00olG5`035`05oaLGoaL00_l01ElGGomO00;o
00eOoamO7eooGamOoelO00?o15l00omOG`02o`8O00SoGemOoamO7`?o0el01OlOGamO00;o00AO7elO
0_l3P@=K00>1Fe/09U/100008e/00omKP@0FF`0:omiagW7NLMkoU@?o00kNomkOg]oogG7ogG7Mo`Aa
00CNLMko0mh00ol51@021@03oioo00?o00GOoonOo`04W`07oinOWooOW`02o`03Fa6O00Ko1AL2o`08
4ALAoelGGaL4o`0<5elGGaMOoelOGaoo0Ul9o`047elOo`9O00Co7eoo15l01omO7eoo7ol00el01?lO
7al2o`037ooo00:12e/00h5KF`0VF`40000SF`03oe^101EK0_l7L@08ombEg9Gog]l2gP;o27402mia
g_oNLOoNLMko00D50_l3g`0=oioOWmooWmnOgolAo`05W`;o0aL01_mK4A7o4@;o11400olG5`02o`DG
0_l3G`03oemO009O00?oGel00_l4G`05oeooGal00Ul02OlOGamOoelOo`037`03oemO00?o1Al2o`03
Gooo011K00>1Fe/09U/100008e/00omKP@0EF`09omcoLMiagW7o00FE00Gog]kOgP02o`08gG7MgG7M
LOl3L@04og7No`?N00?o1@D00`D01?oNWol2g`06omnOgioo0Yl3o`03gioO00Co1A400olG4@02o`DG
00Go5a7o5`02o`8G00Ko5elGGol2G`;o00EO5elGo`03G`;o0Ul01?mOool3G`09oemOGomO7eoo009O
0ol3G`08oeoooamO7olBF`03PE]K02IK0@0002=K00?oFh405E/00oo/o`05L@07oiGLUMbEo`04gP03
oiGo00Ia00gogW7NomiaomiagW7o00@500coLOoOg]oNoioOWml2o`GO0_l01IlG4E/A00;o0QL2o`03
5a4G00;o00LAoa4G4AOo00DG00Go5olGo`045`05oelGGaL00_l35`0@oeoooaOo7elOGolOGomO7`Co
00POGamOoamOo`9O5U/00h5KF`0VF`4000000e_oF`04F`04oe]KF`;o00=Koe/04e/00omKP@0EF`09
omcoLMiagW7o00BE0_l2gP0<gmkogOmagOmagG7o0g401?mag_l4gP08o`D51OoOg_l5g`06omooWmnO
0_l00iooW`03W`0;oa7ogolAWa6O4Ol011400olG4@02o`045a4G4@;o0QL01OlG5aOo00@G0_l02A4G
4OlGGaMOo`04G`05oemOGol00Ul3o`AO0_l01UlOGomOoaUK00>1Fe/09E/1000000=Koe/015/01OmK
Fe_o01MK00?oFh4055/01?o/k?l5L@05oiGLUM`00_l3gP04oiFEo`9a017oLG5aomiag_oNLOoNLMia
o`031@0Aog5aomoNgmkOg_oOWmnOgil00_l02Q6O4IlAoioOWol54@;o00XA5a7o5a7o5a4G0_l44@05
oaLA5ol00QL2o`084ALA5a7o5ol35`04oaMO5`Ko11L2o`=O00GoGamOo`0JF`03PE]K02EK0@000003
FomK00AK00GoFe]Ko`0GF`03oe^101AK00[og=coLMiagW7o19D04?oNgmkOomcMog7Mog7MLOl3L@04
og7No`CN00Go1@D5o`03gP03omoO00?O00[ogoooWooOWmoo0il2o`0>WmnOgolAWa6Ooioo4Ol44@03
oa7o008A00Ko5a4G4Ol25`03oaOo008A00Oo4ALA5a7o00DG0_l35`05oaMOoaL00_l01elGoamO7el0
0_lLF`03PE]K02EK0@000003FomK00AK00GoFe]Ko`0FF`04oe]KPAAK00Gok>c/o`03L@08ombEg9GL
oml3gP04oiFEo`9a017oLG5aomiag_oNLOoNLMiao`021@;o0g401ooNgmkOg_l00mh04?nOgioOWolA
oioOomnOgol34@0AoinOWolG4ALA5a7o5a4G4Ol00a45o`065a4G4OlA0_l35`;o00@A5a7o11L4o`05
5elGGaL00_lPF`03PE]K02EK0@000003Fooo00Go0e/00omKF`0DF`04oe]KPAAK00Wog=cLomiag_l0
1ID04?oNgmkOomcMog7MLOoMLOl3L@05og7NLOl00mh00ol51@02o`?N00?ogml00]l00ooOg`03g`07
omnOgioOo`03g`0;omnOgiooWonOgil00Q400onOo`04W`06oa4A4OlA0_l00ioo4@034@0=oa4A4OlG
4ALAoaLAo`035`;o11L2o`=K00>1Fe/08E/00h5KF`0UF`4000000e_oF`04F`05oe]KFol05U/01?mK
Fh4CF`03onc/00;/00WoLG5aombEg9D00ol3gP04oiFEo`=a013oLG7ogW7NLOmag_magW7o0PD2o`=a
00Kog]oNgol4gP04WmooW`;o01gNomnOgooOWmnOgonOgooOWonOgiooWa6O4OlG4@02o`BO00CoWa6O
0ol01YlAWolGo`@A0_l45`;o1U/00h5KF`0QF`03PE]K02EK0@000003FomK00AK00?oFe/00olEF`04
oe]KPA=K00?og=`00]`01OoNLMko00BE01;og_oOg_oMg=goLMeaomeagOl3L@04omiao`CN0_l00g7o
gP02gP03omoO00;O00?ogml01Ml00ooNgP02gP0<omoOgonOgioogioo0Yl00a7oW`03W`03oinO00:O
0_l00iooW`03W`08oa4AoioOWol34@03oaLA00;o00<Goe/035/00h5KF`0QF`03PE]K02EK0@000003
FomK00QK00CoFe_o15/4o`9K1?l5F`04oe]KPA=K00?ok>`00^`03?maLG7og9GLUOoNo`;N00GoUIFE
o`03L@0@og5aLOmagW7oLMkoLMiagP;o00=aog400g401?oOg_l3gP04omnOg`;o1=h03_nOgiooWmoo
Wmoogioo0Yl02?oOWmoo4IlA0_l01=nOgol3W`03oioo00FO0_l00a7o4@02oa1K00>1Fe/08E/00h5K
F`0UF`4000000e_oo`05o`=K00CoFe_o0e/00omKF`02F`;o15/00omKF`02F`B14e/00ooLg003g003
og7o00FE01;oUIGog_oMg=gLomeaomeagOl3L@04omiao`CN0_l00g7ogP03gP04omoOo`?O00KNomoo
LOl5gP0AomoOoioogioOomnOoa7O4Ol00il01_nOoioOo`>O00?oWil00_l00ioOW`02o`:O00?o4E/0
4e/00h5KF`0QF`03PE]K02EK0@0000iK00GoFe]Ko`04F`;o15/00omKF`02F`03oe]K00>145/00oo/
k004k00>og7oUMbEg9GoUMcog_l4U@04og5ao`=a00goLMiaog7Nog7NLMko009a00?oLG400W401?oO
g_l5gP04og5ao`GN00?ogil01_l3g`07oinOWonOg`03o`07WmnOgooOW`03o`09WmnOgonO4Ioo01IK
00>1Fe/08E/00h5KF`0UF`40000>F`05oe]KFol015/2o`AK00?oFe/00U/01?mKFh42F`>13E/00ooL
g004g003og7o00BE0_l2U@;o00gLgMcMg?oMLOoMLMgo00=a00CogW7o1=h01?oMLOl4gP05omoOoml0
1=h01?nELOl5gP05omoog]l00mh02MoogioOomlAg`02o`08LMkogioOWml2o`CO00CogonO0olGF`03
PE]K025K00>1Fe/09E/100003U/01OmKFe_o00AK0_l4F`03oe]K009K00CoFe^11E/4P@UK00?ok>`0
1>`03OmaoiGLUMcog9GLUOl01ID01OmaLG7o009a00_oLMiaog7Nog7NL@02o`9a00?oLG400W400ooO
o`06gP05og5aLOl01Mh01_oNUOoOgP;O00GogmoOo`03W`03omkN00;N00kogioOWooOWmnOoioOW`;o
6E/00h5KF`0QF`03PE]K02EK0@0000iK00GoFe]Ko`04F`;o15/00omKF`02F`03oe^100YK0h46F`03
omcL00CL00?oLOl019D00onEU@02U@0>omcMg=gLomeagOmagOl3L@04omiao`?N00KoLMeagOl3gP04
omoog`CN0_l019EaUOl5gP04oiFEo`;N0ml01_nOgooO4@;o00_NLMiaoioOWooNo`03g`03oioO01aK
00>1Fe/08E/00h5KF`0UF`40000<F`?o0e/00omKF`02F`;o15/00omKF`02F`03oe^100eK0h42F`03
onc/00K/00cog9GLUMcog9GLon`5U@05og5aLOl00W403?magW7oLMkoLMiao`Aa00?oLG400W43o`CN
00?og7400W400ooNgP03gP06omfEomoN0ml01?oOgml2o`03LOoN00?N00gogioOomkoWmoogilA01aK
00>1Fe/08E/00h5KF`0UF`40000>F`05oe]KFol015/2o`AK00?oFe/00U/00omKP@0@F`03POoo00SL
00?oUID00iD04onEUIGog?oMg=gLomeagOmagOl00g401?oNLOl2gP07og5agG7Mo`04gP03omoo00CN
00Kok9EaUOl4gP04oiFEo`;N00OogmoOoioO00;o01=aUOoNLMiag_oOomoNgooOomlA01eK00>1Fe/0
8E/00h5KF`0UF`40000>F`03oe]K009K1?l2F`Co1E/2o`03PE]K00UK1_l3]`?o1>`2o`03UMbE00;o
00KLUMcok?l4U@05og5aLOl00W403OmagW7oLMiaomkogOl00g400omaL@02L@03omco00CN00?og?l0
0W400ooNgP02gP07oiGMomkOo`04g`;o00JELMeagOl4gP03oioo00?N00CogolA7U/00h5KF`0QF`03
PE]K02EK0@00029K00?oFh403E/3o`07][NfokJg]P02o`04]kJg]PCo0iD04Oo/g>cog=gLomeagOma
gG7o00=a00?oLMh00_l01meaomeagOl01=h00ooLo`04gP06oncoLIGo1=h01?nEUOl3gP03omoo00;o
0iD03g6ELOmagW7NomoogmkOgP02oamK00>1Fe/08E/00h5KF`0UF`40000RF`03oe^1011K0_l4]`?o
0[L2o`>g0_l01mbEomc/g?l019D01?maLOl3L@07omiag_oNL@02o`03LMea00=a00SoLG5aomkLo`?N
00Cok=co0W400ooNgP02gP07oiGMomkOL@02o`0:g9FEg9GogG7Mo`GN00?og]h00_l00mkoF`0OF`03
PE]K025K00>1Fe/09E/100008E/01?mKFh4DF`;o00>f]kH00ol06Mc/g>cLoiGog>cLk=cogMcMog7M
LOoMLOl00g400omagP03o`06LMgoLMgo0mh01Oo/g>co00;N00Oog>coLIGo00CN00CoUIGo0mh01OnE
UIGo00>E00]aUG7oLMiagW7og@04o`03PE]K01iK00>1Fe/08E/00h5KF`0UF`40000QF`04oe]KPAMK
0ol04>cok=c/g>cog?o/g>cLk?l3U@05og5aLOl00W401_oNLMkogP;o00FEomeao`02L@05og5aLOl0
0m`01ooNg_o/g?l00g402OoNg_oMUMgogP02L@0<oiGLUOoLUMcMLMgo1Mh00omagP02gP03oh5K01mK
00>1Fe/08E/00h5KF`0UF`40000QF`04oe]KPAQK00Z1Foo/g>cLk=c/0_l03mc/g>cLomgLgOmagG7o
g@08o`09UG7oLMgoLMgo00;N00Kog^cLk?l2gP08omc/g?nELOl2gP05oiFEUOl00mh00onEU@05U@0;
oiEaog7NLMkoLMd00]h00omKP@0PF`03PE]K029K00>1Fe/095/100008E/01?mKFh4HF`03PE]K009K
0_l02mc/g?oLk=c/g>cL00Wo00KLk=c/g>`2o`06gIGogG7o0g400omao`04g008omkNoncLk?l2L@08
omkNomfEoml2L@0=onbEg9GLoiGLog7Mo`04gP05og5ag_l00U/00h5KF`0NF`03PE]K029K00>1Fe/0
95/100008E/2o`03Fh5K01MK00>1Fe/01e/00ong]P03o`04][Nf]`;o00>f]kH00ol5g00;og6ELOma
gOmagG400ol03mc/g>cog_o/g>cLoiEao`02gP04oiFEo`?N00?og?l00iD03onEUOnELIGogW7Nog7M
o`03F`03PE]K01iK00>1Fe/08U/00h5KF`0>F`J145/100008E/01?mKFh4HF`03PE]K00YK0_l3]`04
okNg]`;o1;L2o`0;k=cooiGMUOoMLOl00g43o`CL00Sog_oLk=c/o`9a00Sog]kogIGog`9a00kok?oL
UMcoUMcoLMeao`?N00CoLIGo0e/00h5KF`0NF`03PE]K029K00>1Fe/01E/9PAIK0@00025K00CoFe^1
65/00h5KF`0<F`;o00Fg][Nf]`02o`06]_oo]kJg0_l03=coLIEaUOoMLOoML@?o017Lk=c/omkok=c/
g?nELOoNo`03U@07omkNg_oLo`03U@0;oiFEUOmaUOoNLOl00md01OmKFe^1025K00>1Fe/07e/:PAmK
0@00025K00CoFe^165/00h5KF`0@F`?o0kL3o`K/00WogIGMog7Mog401?l4g008omkog>cLk?l2L@06
omkoUMfE0_l2L@0>oncog9GLoiGLUOoMLOl2gP04og5ao`AK00>1Fe/07e/00h5KF`0EF`Z10U/00h5K
F`0TF`40000QF`04oe]KPAQK00>1Fe/04e/01X7ookNfo`KL00?oUOl01ol02=coomc/g>cL0_l02^cL
k=coUG7og_l3U@;o00?Nom`00]`01OnEUIGo00:E00OoLIGogW7o00;M00?oFe/00U/00h5KF`0OF`03
PE]K00aK2H4<F`03PE]K02AK0@00025K00CoFe^165/00h5KF`0CF`03PE]K009K0_l00kOoo`02k0;o
1KL2o`03]ooo00KL00Sok=c/g>cLo`9a0_l00iGMU@02o`03LOo/00;/00_oUMbEombEomeao`02gP04
oiEao`EK00>1Fe/07U/00h5KF`02F`Z15E/00h5KF`0TF`40000QF`03oe^101UK00>1Fe/04e/00h5K
F`05F`;o00Ff]ooo]P03o`03][Nf00?o013/g>cLk=cog>cLk=c/og6E0_l2U@05omcog_l00m`01OnE
UIGo00:E00OoLIGog_ma00;M00?oFe/00e/00h5KF`0IF`Z17e/00h5KF`0TF`40000QF`03oe^101UK
00>1Fe/04e/00h5KF`07F`;o1;L2o`03]ooo00:g00?og=`01=`02?o/g>cLk=co0W402OoMUMgok?ma
o`03k00<oiGLUOoLUOoMLOoN0_l00iGoF`05F`03PE]K011K2H45F`03PE]K025K00>1Fe/095/10000
8E/2o`03PE]K01MK00>1Fe/04U/00h5KF`0;F`;o00Fg][Nf]`02o`04]_oo]`?o00Bg][Nf0_l00mc/
o`05o`06UOoLomko0m`01OnEUIGo00:E00CoLIEa0ol00mgoF`05F`03PE]K00IK2X4>F`03PE]K025K
00>1Fe/095/100008E/00omKP@0IF`03PE]K019K00>1Fe/03U/3o`>g0_l3]`03okNg00;o1;L01?ng
]kL2o`03]ooo00;/00?ok>`00^`02onEg9Gog9GLog7M00?o00>Eoe/01E/9PAQK00>1Fe/08E/00h5K
F`0TF`40000PF`04oe]KPAUK00>1Fe/04U/00h5KF`0AF`05POoo][L00_l01;Jg][L2o`05]_oo]kH0
0ol00mcog004g003omcL00?L00GoUIFEo`02U@08oiEaolcogOl7PB1K00>1Fe/08E/00h5KF`0TF`40
000PF`04oe]KPAQK00>1Fe/04e/00h5KF`0AF`03PE]K009K00?o]kL00_l5]`03okNg00;o00>gool0
1N`00oo/k003k006ombEg?nE1Ol010goUOl6F`03PE]K01iK00>1Fe/08E/00h5KF`0TF`40000PF`04
oe]KPAQK00>1Fe/04e/00h5KF`0AF`03PE]K00EK0_l02;Oooong][Nf0_l01KOookJg00;o00D=c0g<
o`02g0So00H=c0g<3Ol7F`03PE]K01iK00>1Fe/08E/00h5KF`0TF`40000PF`04oe]KPAQK00>1Fe/0
4e/00h5KF`0AF`03PE]K00IK00?oc<`00l`2o`Q<00?oc<`00l`00oo<c003c0;o0[L01oo<3L`=c?l0
1e/00h5KF`0NF`03PE]K025K00>1Fe/095/1000085/01?mKFh4HF`03PE]K01=K00>1Fe/04E/00h5K
F`06F`07ol`=c0g<o`09C@0=ol`=c0g<ol`=c0g<o`03C@07o`g<3L`=o`07F`03PE]K01iK00>1Fe/0
8E/00h5KF`0TF`40000PF`;o00=KPE/05e/00h5KF`0CF`03PE]K015K00>1Fe/01U/00oo<c003c003
oda<00M<00?oc<`00l`00oo<c003c00;oda<C?o<3L`=c?l01e/00h5KF`0NF`03PE]K025K00>1Fe/0
95/1000085/01?mKFh4HF`03PE]K01=K00>1Fe/04E/00h5KF`06F`07ol`=c0g<o`09C@0=ol`=c0g<
ol`=c0g<o`03C@07o`g<3L`=o`07F`03PE]K01iK00>1Fe/08E/00h5KF`0TF`40000PF`04oe]KPAQK
00>1Fe/04e/00h5KF`0AF`03PE]K00IK00?oc<`00l`01?m<C?l6C003olc<00?<00?oc<`00l`02om<
C4coc0g<3Lco00MK00>1Fe/07U/00h5KF`0QF`03PE]K02AK0@00021K00CoFe^165/00h5KF`0CF`03
PE]K015K00>1Fe/01U/01oo<3L`=c?l00Td01Om=CDgo009=00goc0g<3Lcoc0g<3Lco00==00Oo3L`=
c0go00MK00>1Fe/07U/00h5KF`0RF`03PE]K02=K0@00021K00CoFe^165/00h5KF`0CF`03PE]K011K
00>1Fe/01e/00oo<c003c004oda<o`=<00CoC4co1L`00oo<c003c00;oda<C?o<3L`=c?l01e/00h5K
F`0NF`03PE]K029K00>1Fe/08e/1000085/01?mKFh4HF`03PE]K01=K00>1Fe/045/00h5KF`07F`05
ol`=c0d00_l2C@05ode=COl00Td01Oo<3L`=00;o00K<3L`=c?l3C@07o`g<3L`=o`07F`03PE]K01iK
00>1Fe/08U/00h5KF`0SF`40000PF`04oe]KPAQK00>1Fe/04e/00h5KF`0@F`03PE]K00MK00?oc<`0
0/`2o`9<00GoC4a<o`02C003olc<00;<0_l5c00;oda<C?o<3L`=c?l01e/00h5KF`0NF`03PE]K029K
00>1Fe/08e/1000025/6o`9K1?l2F`Co1U/00omKP@0IF`03PE]K01=K00>1Fe/045/00h5KF`07F`05
ol`=c0d00_l6C@0@ode=ol`=c0goCol=c0g<o`==00Oo3L`=c0go00MK00>1Fe/07U/00h5KF`0RF`03
PE]K02=K0@0000QK00?oFe/015/00omKF`02F`;o15/00omKF`03F`>16E/00h5KF`0CF`03PE]K011K
00>1Fe/01e/00oo<c002c003ocoo00E<00CoC4co1<`00oloo`03c003ocoo00=<00Go3L`=o`08F`03
PE]K01iK00>1Fe/08U/00h5KF`0SF`400009F`03oe]K00=K00?oFe/00U/2o`AK00?oFe/00e/00omK
P@05PAAK00>1Fe/04e/00h5KF`0@F`03PE]K00MK00Soc0g<3Om?o`E=017oCDgoc0g<3Om?o`g<3Om?
o`03C@05ol`=c?l025/00h5KF`0NF`03PE]K029K00>1Fe/08e/100002U/2o`=K00?oFe/00U/2o`AK
00?oFe/00U/01?mKFh45F`F13e/00h5KF`0CF`03PE]K011K00>1Fe/01e/00oo<c002c003ocoo00E<
00CoC4co1<`00oloo`03c003ocoo00=<00Go3L`=o`08F`03PE]K01iK00>1Fe/08U/00h5KF`0SF`40
000<F`04oe]Ko`AK0_l4F`03oe]K009K00CoFe^12U/5P@YK00>1Fe/04e/00h5KF`0@F`03PE]K00QK
00Oo3L`=odoo009=00?oCDd014d03Ol=c0goCol=c0goCol00dd01Oo<3Lco00QK00>1Fe/07U/00h5K
F`0RF`03PE]K02=K0@0000eK00?oFol015/2o`AK00?oFe/00U/01?mKFh4?F`F11E/00h5KF`0CF`03
PE]K011K00>1Fe/025/01oo<c<co?ol00T`00om<C004C007olc<c?loo`03c003ocoo00=<00Go3L`=
o`08F`03PE]K01iK00>1Fe/08U/00h5KF`0SF`400008F`03oe]K009K00?oFol015/2o`AK00?oFe/0
0U/01?mKFh4DF`B100=KPE/055/00h5KF`0@F`03PE]K00QK00Oo3L`=odoo009=00?oCDd014d03Ol=
c0goCol=c0goCol00dd01Oo<3Lco00QK00>1Fe/07U/00h5KF`0RF`03PE]K02=K0@0000QK00?oFe/0
0U/00omKo`04F`;o15/00omKF`02F`04oe]KPAQK1H4BF`03PE]K011K00>1Fe/025/01oo<c<co?ol0
0T`01Om<C4co009<00Ooc<c<ocoo00?<00?o?ol00d`01Ol=c0go00QK00>1Fe/07U/00h5KF`0RF`03
PE]K02=K0@0000UK1?l3F`Co0U/4o`EK0_l00e^1F`0HF`04PE]KF`F13E/00h5KF`0@F`03PE]K00QK
00Oo3L`=odoo009=00GoCDe=o`02C@0=o`g<3Om?o`g<3Om?o`03C@05ol`=c?l025/00h5KF`0NF`03
PE]K029K00>1Fe/08e/100007e/01?mKFh4IF`03PE]K00IK1H47F`03PE]K015K00>1Fe/025/01oo<
c<co?ol00T`01Om<C4co009<00Ooc<c<ocoo00?<00?o?ol00d`01Ol=c0go00QK00>1Fe/07U/00h5K
F`0RF`03PE]K02=K0@0001mK00CoFe^16E/00h5KF`0;F`F10U/00h5KF`0AF`03PE]K00QK00Oo3L`=
odoo009=00GoCDe=o`02C@0=o`g<3Om?o`g<3Om?o`03C@05ol`=c?l025/00h5KF`0NF`03PE]K029K
00>1Fe/08e/100007e/01?mKFh4HF`03PE]K015K184BF`03PE]K00QK00Ooc<coCcoo009<00GoC4a<
o`02C007olc<odloo`03c003ocoo00=<00Go3L`=o`08F`03PE]K01iK00>1Fe/08U/00h5KF`0=F`R1
3U/100007e/01?mKFh4HF`03PE]K01=K00>1Fh40184=F`03PE]K00QK00Co3Lco0Tl01?m=COl3C@07
ode=o`g<o`02C`07o`g<3Om?o`03C@05ol`=c?l025/00h5KF`0NF`03PE]K029K00>1Fh403H4FF`40
000OF`04oe]KPAQK00>1Fe/04e/00h5KF`04F`F125/00h5KF`08F`07olc<odloo`02C005oda<C?l0
0T`01oo<c?m??ol00l`00oloo`03C005o`g<3Ol025/00h5KF`0NF`03PE]K01IK3X4TF`40000OF`04
oe]KPAQK00>1Fe/04e/00h5KF`09F`F10e/00h5KF`08F`04o`g<o`9?00CoCDgo0dd01om=COl=c?l0
0Tl01ol=c0goCol00dd01Oo<3Lco00QK00>1Fe/07U/00h5KF`08F`j135/00h5KF`0SF`40000OF`04
oe]KPAQK00>1Fe/04e/00h5KF`0>F`B12U/01oo<c?m??ol00T`01Om<C4co009<00Ooc<coCcoo00?<
00?o?ol00d`01Ol=c0go00QK00>1Fe/06U/?PAYK00>1Fe/08e/100007e/2o`03PE]K01MK00>1Fe/0
4e/00h5KF`0AF`J11E/01?l=c?l2C`04ode=o`==00OoCDgo3Lco009?00Oo3L`=odoo00==00Goc0g<
o`08F`03PE]K00aK3X44F`03PE]K02=K00>1Fe/08U/100007e/00omKP@0IF`03PE]K01=K00>1Fe/0
4E/00h5KF`03F`F100Ooc<coCcoo00=<00CoC4co0T`02?o<c?m??doo0/`00oloo`03C005o`g<3Ol0
25/?PA9K00>1Fe/08e/00h5KF`0RF`40000NF`04oe]KPAUK00>1Fe/04e/00h5KF`0AF`03PE]K00QK
00Co3Lco0dl01?m=COl2C@07ode=o`g<o`03C`03olco00=?00OoCDe=o`go00Z185/00h5KF`0SF`03
PE]K029K0@0001iK00CoFe^16E/00h5KF`0CF`03PE]K015K00>1Fe/025/02?o<c?m??doo0T`01?m<
C?l2C00>olc<odloCoo<odloCol3C003olco00UK00>1Fe/07U/00h5KF`0SF`03PE]K029K0@0001iK
00CoFe^16E/00h5KF`0CF`03PE]K015K00>1Fe/025/01?l=c?l3C`04ode=o`9=00OoCDgo3Lco00=?
00?oc?l00dl01om=CDgo3Ol02E/00h5KF`0NF`03PE]K02=K00>1Fe/08U/100007U/01?mKFh4IF`03
PE]K01=K00>1Fe/04E/00h5KF`08F`08olc<odloCol2C004oda<o`9<00koc<coCcm?olcoCcm?o`=<
00?oc?l02E/00h5KF`0NF`03PE]K02=K00>1Fe/08U/100007U/01?mKFh4IF`03PE]K01=K00>1Fe/0
4E/00h5KF`08F`04o`g<o`=?00CoCDgo0Td01om=COl=c?l00dl00oo<o`03C`07ode=COl=o`09F`03
PE]K01iK00>1Fe/08e/00h5KF`0RF`40000NF`04oe]KPAUK00>1Fe/04e/00h5KF`0AF`03PE]K00QK
00Soc<coCcm?o`9<00CoC4co0T`03_o<c?m??dooc?m??doo0d`00oo<o`09F`03PE]K01iK00>1Fe/0
8e/00h5KF`0RF`40000NF`;o00=KPE/065/00h5KF`0CF`03PE]K015K00>1Fe/025/00ol=o`04C`04
ode=o`9=00KoCDgo3Ol4C`03olco00=?00OoCDe=o`go00UK00>1Fe/07U/00h5KF`0SF`03PE]K029K
0@0001iK00CoFe^16E/00h5KF`0CF`03PE]K015K00>1Fe/025/02?o<ocm??doo0T`01?m<C?l2C00>
olco?dloCoo<odloCol3C003olco00UK00>1Fe/07e/00h5KF`0RF`03PE]K029K0@0001iK00CoFe^1
6E/00h5KF`0CF`03PE]K015K00>1Fe/025/00ol=o`04C`04ode=o`9=00KoCDgo3Ol4C`03olco00=?
00OoCDe=o`go00UK00>1Fe/07e/00h5KF`0RF`03PE]K029K0@0001iK00CoFe^16E/00h5KF`0CF`03
PE]K015K00>1Fe/025/02?o<ocm??doo0T`01?m<C?l2C00>olco?dloCoo<odloCol3C003olco00UK
00>1Fe/07e/00h5KF`0RF`03PE]K029K0@0001iK00CoFe^16E/00h5KF`0CF`03PE]K015K00>1Fe/0
25/00ol=o`04C`04ode=o`9=00KoCDgo3Ol4C`03olco00=?00OoCDe=o`go00UK00>1Fe/07e/00h5K
F`0RF`03PE]K029K0@0001iK00CoFe^16E/00h5KF`0CF`03PE]K015K00>1Fe/025/02?o<ocm??doo
0T`01?m<C?l2C00>olco?dloCoo<odloCol3C003olco00UK00>1Fe/07e/00h5KF`0RF`03PE]K029K
0@0001iK00CoFe^16E/00h5KF`0CF`03PE]K011K00>1Fe/02E/00ol=o`04C`04ode=o`9=00KoCDgo
3Ol4C`03olco00=?00OoCDe=o`go00UK00>1Fe/07e/00h5KF`0RF`03PE]K029K0@0001iK0_l00e^1
F`0HF`03PE]K01=K00>1Fe/045/00h5KF`0:F`;o00DoCcm?o`02C005oda<C?l00T`2o`0;?dloCoo<
odloCol00d`00oo<o`09F`03PE]K01mK00>1Fe/08U/00h5KF`0RF`40000NF`03oe^101UK00>1Fe/0
55/00h5KF`0@F`03PE]K00YK0_l4C`04ode=o`==00?oCDd00_l4C`03olco00=?00OoCDe=o`go00UK
00>1Fe/07e/00h5KF`0RF`03PE]K029K0@0001eK00CoFe^16E/00h5KF`0CF`03PE]K015K00>1Fe/0
2U/2o`05?dloCol00T`01Om<C4co009<0_l02cm??dooc?m??doo00=<00?oc?l02E/00h5KF`0OF`03
PE]K029K00>1Fe/08U/100007E/01?mKFh4IF`03PE]K01=K00>1Fe/04E/00h5KF`0:F`;o14l01?m=
COl3C@03ode=00;o14l00oo<o`03C`07ode=COl=o`09F`03PE]K01mK00>1Fe/08U/00h5KF`0RF`40
000MF`04oe]KPAUK00>1Fe/04e/00h5KF`0AF`03PE]K00YK0_l01Sm??dloo`9<00CoC4co0T`2o`0;
?dloCcoo?dloCol014`00omKF`08F`03PE]K01mK00>1Fe/08U/00h5KF`0RF`40000MF`04oe]KPAUK
00>1Fe/04e/00h5KF`0AF`03PE]K00YK0_l5C`04ode=o`9=00?oCDd00_l5C`03odm?00=?00GoCDe=
o`0:F`03PE]K01mK00>1Fe/08e/00h5KF`0QF`40000MF`04oe]KPAUK00>1Fe/04e/00h5KF`0AF`03
PE]K00YK00SoCcm??dloo`9<00CoC4co0T`03_m??dloCcoo?dloCcoo0d`00omKF`08F`03PE]K01mK
00>1Fe/08e/00h5KF`0QF`40000MF`04oe]KPAUK00>1Fe/04e/00h5KF`0AF`03PE]K00YK00?oCdl0
14l01?m=COl2C@04ode=o`I?00?oCdl00dl01Om=CDgo00YK00>1Fe/07e/00h5KF`0SF`03PE]K025K
0@0001eK1X4GF`03PE]K01=K00>1Fe/04E/00h5KF`0:F`08odloCcm??ol2C004oda<o`9<00koCcm?
?dloocm??dloo`=<00?oFe/025/00h5KF`0OF`03PE]K02=K00>1Fe/08E/100008e/9P@iK00>1Fe/0
4e/00h5KF`0AF`03PE]K00YK00?oCdl014l01?m=COl2C@04ode=o`I?00?oCdl00dl01Om=CDgo00YK
00>1Fe/07e/00h5KF`0SF`03PE]K025K0@0002aK2H45F`03PE]K01=K00>1Fe/04E/00h5KF`0:F`08
odloCcm??ol2C004oda<o`9<00koCcm??dloocm??dloo`=<00?oFe/025/00h5KF`0OF`03PE]K02=K
00>1Fe/08E/10000=E/:PA5K00>1Fe/04E/00h5KF`0:F`03odm?00A?00CoCDgo0Td01?m=COl6C`03
odm?00=?00GoCDe=o`0:F`03PE]K01mK00>1Fe/08e/00h5KF`0QF`40000oF`V125/00h5KF`0AF`03
PE]K00YK6_l01Cm??om<00?o2U/00h5KF`0OF`03PE]K02=K00>1Fe/08E/10000B5/9PA=K00>1Fe/0
3U/0185KFol28`03ob<S00;o12<2o`8S00?o8b<01Ol=F`03PE]K01mK00>1Fe/08e/00h5KF`07F`j1
35/10000DE/9P@YK00>1Fe/03U/00h5KF`05F`03POoo01eK00>1Fe/07e/00h5KF`0CFaZ16U/10000
FU/;PA1K00>1Fe/01E/00h5KF`0MF`03PE]K01]K6X4dF`40001TF`V125/00h5KF`05F`03PE]K01eK
00B1Fe]K6X5>F`40001]F`V11e/00h5KF`07FaZ1J5/10000MU/APH9K0@000?mK2U/10000oe/:F`40
003oF`YK0@000?mK2U/10000oe/:F`40003oF`YK0@000?mK2U/10000oe/:F`40002eF`;oDU/10000
]U/2o`=K00?oFe/0Be/10000]e/2o`=K00?oFe/0BU/10000;e/5o`=K0ol2F`;o15/3o`03Fooo00;o
0e/5o`EK0_l5F`;o0U/5o`9K0_l2F`Co0e/4o`=K1?l2F`Co0e/4o`IK0_l3F`;o00=Kool00U/4o`=K
0ol2F`?o0U/2o`EK0ol2F`;o1e/4o`03FomK00Co0U/2o`9K0_l2F`;o1E/4o`=K1?lNF`40000^F`;o
0e/2o`04FoooF`;o00=Kool015/2o`03Fooo009K0_l00e_oo`02F`;o1E/2o`EK0_l2F`;o00=Kool0
0U/2o`03Fooo009K0_l00e_oo`02F`;o00=Kool00U/4o`9K0_l00e_oo`02F`;o1E/2o`=K0_l015_o
oe/2o`9K0_l2F`;o0U/2o`04FoooF`;o1E/3o`9K0_l6F`;o0U/5o`9K0_l00e_oo`02F`;o0U/2o`AK
0_l2F`;o00=Kool00U/2oaeK0@0002iK0_l3F`Co0e/4o`AK0_l00e_oo`05F`;o0U/2o`EK0_l5F`;o
0U/2o`03Fooo009K0_l00e_oo`08F`?o15/5o`QK0ol5F`;o0e/2o`03Fooo00AK0ol2F`;o00=Kool0
0e/4o`AK0_l00e_oo`08F`;o15/4o`EK0_l2F`;o25/2o`9K0_l00e_oo`02F`;o7E/10000<U/5o`=K
1?l4F`;o00=Kool01?l00e_oo`02F`;o1E/2o`EK0_l2F`;o00=Kool00U/2o`03Fooo00Co0U/4o`=K
1?l00e_oo`04o`9K1?l6F`;o0e/2o`03Fooo009K1?l3F`;o00=Kool00e/4o`AK0_l00e_oo`08F`;o
15/8o`03Fooo009K0_l8F`;o0U/2o`03Fooo009K0_lMF`40000_F`Go00=Kool00e/4o`AK0_l00e_o
o`02F`;o00=Kool00U/2o`EK1Ol2F`;o0U/2o`03Fooo009K0_l00e_oo`02F`;o00AKoooo15/3o`=K
0_l2F`;o00AKoooo25/2o`=K0_l015_ooe/3o`EK0_l00e_oo`03F`Co15/2o`03Fooo00QK0_l2F`Ko
0U/2o`03Fooo009K0_l9F`Co0U/2o`9K0_lMF`40000^F`?o1E/2o`04FoooF`?o0e/2o`03Fooo009K
0_l00e_oo`02F`;o1E/2o`EK0_l2F`;o00=Kool00U/2o`03Fooo009K0_l00e_oo`02F`;o00=Kool0
0U/4o`9K0_l00e_oo`02F`;o1E/7o`04FoooF`;o0U/2o`9K0_l2F`;o00AKoomK0ol3F`;o00=Kool0
25/2o`IK0_l2F`;o00=Kool00U/2o`QK0_l2F`;o00=Kool00U/2oaeK0@0002iK0_l3F`;o0U/3o`9K
0ol2F`Co00=Kool00_l3F`Go1E/2o`EK0_l00e_oo`07o`=K1?l3F`Co0e/4o`9K1?l3F`Co1U/2o`=K
0_l00e_oo`02F`Co0U/4o`9K0ol2F`?o0U/2o`=K0_l7F`;o15/2o`03Fooo00;o0U/5o`UK0_l2F`;o
00=Kool00U/2oaeK0@0002iK0_l3F`;o3E/2o`aK0_l5F`;o2E/2obiK0_l3F`;o35/2oaaK0_l2F`;o
5U/2o`9K0_l00e_oo`02F`;o7E/10000;e/5o`iK0_l<F`;o1E/6o`03Fooo009K0_l^F`;o0e/2o`03
Fooo00UK0_lMF`Co65/4o`=K1?lNF`40003oF`YK0@000?mK2U/10000oe/:F`40003oF`YK0@000?mK
2U/10000\
\>"],
  ImageRangeCache->{{{0, 265}, {252, 0}} -> {-0.0925078, -0.0556196, 
  0.00397335, 0.00397335}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Min, max, and average fitnesses"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Needs[\"Graphics`FilledPlot`\"]

Needs[\"Graphics`Legend`\"]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[TextData[
"bestFits = Map[Max,allFitnessesSorted];\nmeanFits = \
Map[Mean,allFitnessesSorted];\nminFits  = Map[Min,allFitnessesSorted];"], 
  "Input",
  AspectRatioFixed->True],

Cell[TextData[
"ShowLegend[\n  ListFilledPlot[\n    bestFits,\n    meanFits,\n    \
Table[0,{81}],\n    Fills -> {GrayLevel[0.4],GrayLevel[0.8]},\n    AxesLabel \
-> {\"Gen.\",\"Fit.\"},\n    PlotRange -> All,\n    DisplayFunction -> \
Identity\n  ],\n  {{{GrayLevel[0.4],\"Best\"},\n    {GrayLevel[0.8],\"Mean\"}\
\n    (*{GrayLevel[1.0],\"Worst\"}*)},\n   LegendPosition -> {1.1, -0.4},\n   \
LegendSize -> {0.3,0.4}},\n  DisplayFunction -> $DisplayFunction\n];"], 
  "Input",
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"MinMaxAverage-Fitnesses"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .50452 
MathPictureStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.412536 0.388727 0.252259 0.388727 [
[ 0 0 0 0 ]
[ 1 .50452 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
% Start of sub-graphic
p
0.0238095 0.0120123 0.801263 0.492505 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 1 0 0.618034 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
% Start of sub-graphic
p
0 0 1 0.618034 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0119048 0.0119048 0.0147151 0.00204376 [
[(20)] .25 .01472 0 2 Msboxa
[(40)] .4881 .01472 0 2 Msboxa
[(60)] .72619 .01472 0 2 Msboxa
[(80)] .96429 .01472 0 2 Msboxa
[(Gen.)] 1.025 .01472 -1 0 Msboxa
[(50)] -0.0006 .1169 1 0 Msboxa
[(100)] -0.0006 .21909 1 0 Msboxa
[(150)] -0.0006 .32128 1 0 Msboxa
[(200)] -0.0006 .42347 1 0 Msboxa
[(250)] -0.0006 .52566 1 0 Msboxa
[(Fit.)] .0119 .61803 0 -4 Msboxa
[ -0.001 -0.001 0 0 ]
[ 1.001 .61903 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
p
.002 w
.25 .01472 m
.25 .02097 L
s
P
[(20)] .25 .01472 0 2 Mshowa
p
.002 w
.4881 .01472 m
.4881 .02097 L
s
P
[(40)] .4881 .01472 0 2 Mshowa
p
.002 w
.72619 .01472 m
.72619 .02097 L
s
P
[(60)] .72619 .01472 0 2 Mshowa
p
.002 w
.96429 .01472 m
.96429 .02097 L
s
P
[(80)] .96429 .01472 0 2 Mshowa
p
.001 w
.05952 .01472 m
.05952 .01847 L
s
P
p
.001 w
.10714 .01472 m
.10714 .01847 L
s
P
p
.001 w
.15476 .01472 m
.15476 .01847 L
s
P
p
.001 w
.20238 .01472 m
.20238 .01847 L
s
P
p
.001 w
.29762 .01472 m
.29762 .01847 L
s
P
p
.001 w
.34524 .01472 m
.34524 .01847 L
s
P
p
.001 w
.39286 .01472 m
.39286 .01847 L
s
P
p
.001 w
.44048 .01472 m
.44048 .01847 L
s
P
p
.001 w
.53571 .01472 m
.53571 .01847 L
s
P
p
.001 w
.58333 .01472 m
.58333 .01847 L
s
P
p
.001 w
.63095 .01472 m
.63095 .01847 L
s
P
p
.001 w
.67857 .01472 m
.67857 .01847 L
s
P
p
.001 w
.77381 .01472 m
.77381 .01847 L
s
P
p
.001 w
.82143 .01472 m
.82143 .01847 L
s
P
p
.001 w
.86905 .01472 m
.86905 .01847 L
s
P
p
.001 w
.91667 .01472 m
.91667 .01847 L
s
P
[(Gen.)] 1.025 .01472 -1 0 Mshowa
p
.002 w
0 .01472 m
1 .01472 L
s
P
p
.002 w
.0119 .1169 m
.01815 .1169 L
s
P
[(50)] -0.0006 .1169 1 0 Mshowa
p
.002 w
.0119 .21909 m
.01815 .21909 L
s
P
[(100)] -0.0006 .21909 1 0 Mshowa
p
.002 w
.0119 .32128 m
.01815 .32128 L
s
P
[(150)] -0.0006 .32128 1 0 Mshowa
p
.002 w
.0119 .42347 m
.01815 .42347 L
s
P
[(200)] -0.0006 .42347 1 0 Mshowa
p
.002 w
.0119 .52566 m
.01815 .52566 L
s
P
[(250)] -0.0006 .52566 1 0 Mshowa
p
.001 w
.0119 .03515 m
.01565 .03515 L
s
P
p
.001 w
.0119 .05559 m
.01565 .05559 L
s
P
p
.001 w
.0119 .07603 m
.01565 .07603 L
s
P
p
.001 w
.0119 .09647 m
.01565 .09647 L
s
P
p
.001 w
.0119 .13734 m
.01565 .13734 L
s
P
p
.001 w
.0119 .15778 m
.01565 .15778 L
s
P
p
.001 w
.0119 .17822 m
.01565 .17822 L
s
P
p
.001 w
.0119 .19865 m
.01565 .19865 L
s
P
p
.001 w
.0119 .23953 m
.01565 .23953 L
s
P
p
.001 w
.0119 .25997 m
.01565 .25997 L
s
P
p
.001 w
.0119 .2804 m
.01565 .2804 L
s
P
p
.001 w
.0119 .30084 m
.01565 .30084 L
s
P
p
.001 w
.0119 .34172 m
.01565 .34172 L
s
P
p
.001 w
.0119 .36215 m
.01565 .36215 L
s
P
p
.001 w
.0119 .38259 m
.01565 .38259 L
s
P
p
.001 w
.0119 .40303 m
.01565 .40303 L
s
P
p
.001 w
.0119 .44391 m
.01565 .44391 L
s
P
p
.001 w
.0119 .46434 m
.01565 .46434 L
s
P
p
.001 w
.0119 .48478 m
.01565 .48478 L
s
P
p
.001 w
.0119 .50522 m
.01565 .50522 L
s
P
p
.001 w
.0119 .54609 m
.01565 .54609 L
s
P
p
.001 w
.0119 .56653 m
.01565 .56653 L
s
P
p
.001 w
.0119 .58697 m
.01565 .58697 L
s
P
p
.001 w
.0119 .60741 m
.01565 .60741 L
s
P
[(Fit.)] .0119 .61803 0 -4 Mshowa
p
.002 w
.0119 0 m
.0119 .61803 L
s
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
p
p
.4 g
.02381 .04742 m
.03571 .04742 L
.04762 .06377 L
.05952 .13734 L
.07143 .13734 L
.08333 .13734 L
.09524 .13734 L
.10714 .13734 L
.11905 .13734 L
.13095 .13734 L
.14286 .13734 L
.15476 .13734 L
.16667 .13734 L
.17857 .13734 L
.19048 .13734 L
.20238 .13734 L
.21429 .13734 L
.22619 .13734 L
.2381 .13734 L
.25 .13734 L
.2619 .13734 L
.27381 .13734 L
.28571 .13734 L
.29762 .13734 L
.30952 .13734 L
.32143 .13734 L
.33333 .13734 L
.34524 .13734 L
.35714 .13734 L
.36905 .13734 L
.38095 .13734 L
.39286 .13734 L
.40476 .13734 L
.41667 .25179 L
.42857 .25179 L
.44048 .25179 L
.45238 .25179 L
.46429 .25179 L
.47619 .25179 L
.4881 .25179 L
.5 .25179 L
.5119 .25179 L
.52381 .25179 L
.53571 .25179 L
.54762 .25179 L
.55952 .25179 L
.57143 .25179 L
.58333 .25179 L
.59524 .25179 L
.60714 .25179 L
.61905 .25179 L
.63095 .25179 L
.64286 .25179 L
.65476 .25179 L
.66667 .25179 L
.67857 .25179 L
.69048 .25179 L
.70238 .25179 L
.71429 .25179 L
.72619 .25179 L
.7381 .25179 L
.75 .25179 L
.7619 .25179 L
.77381 .25179 L
.78571 .25179 L
.79762 .25179 L
.80952 .25179 L
.82143 .25179 L
.83333 .25179 L
.84524 .25179 L
.85714 .25179 L
.86905 .25179 L
.88095 .25179 L
.89286 .25179 L
.90476 .25179 L
.91667 .25179 L
.92857 .60332 L
.94048 .60332 L
.95238 .60332 L
.96429 .60332 L
.97619 .60332 L
.97619 .11235 L
.96429 .18219 L
.95238 .16058 L
.94048 .15077 L
.92857 .09372 L
.91667 .07626 L
.90476 .08233 L
.89286 .08502 L
.88095 .07276 L
.86905 .06902 L
.85714 .07836 L
.84524 .07842 L
.83333 .06178 L
.82143 .07171 L
.80952 .06435 L
.79762 .09997 L
.78571 .05162 L
.77381 .048 L
.7619 .06178 L
.75 .06832 L
.7381 .064 L
.72619 .06528 L
.71429 .08222 L
.70238 .07941 L
.69048 .0689 L
.67857 .08631 L
.66667 .07346 L
.65476 .07895 L
.64286 .0835 L
.63095 .07287 L
.61905 .0696 L
.60714 .07252 L
.59524 .06972 L
.58333 .06762 L
.57143 .05542 L
.55952 .06371 L
.54762 .0689 L
.53571 .0393 L
.52381 .06283 L
.5119 .05839 L
.5 .06482 L
.4881 .04987 L
.47619 .05571 L
.46429 .08187 L
.45238 .07124 L
.44048 .06972 L
.42857 .05699 L
.41667 .05057 L
.40476 .04455 L
.39286 .05121 L
.38095 .05752 L
.36905 .04531 L
.35714 .03387 L
.34524 .05804 L
.33333 .05045 L
.32143 .0581 L
.30952 .05629 L
.29762 .05711 L
.28571 .04566 L
.27381 .04239 L
.2619 .05979 L
.25 .04742 L
.2381 .04555 L
.22619 .05349 L
.21429 .06038 L
.20238 .05594 L
.19048 .03901 L
.17857 .05816 L
.16667 .04321 L
.15476 .05057 L
.14286 .05115 L
.13095 .04812 L
.11905 .0501 L
.10714 .04765 L
.09524 .05267 L
.08333 .04555 L
.07143 .04601 L
.05952 .03574 L
.04762 .03153 L
.03571 .0202 L
.02381 .0202 L
F
P
p
p
.004 w
.02381 .04742 m
.03571 .04742 L
.04762 .06377 L
.05952 .13734 L
.07143 .13734 L
.08333 .13734 L
.09524 .13734 L
.10714 .13734 L
.11905 .13734 L
.13095 .13734 L
.14286 .13734 L
.15476 .13734 L
.16667 .13734 L
.17857 .13734 L
.19048 .13734 L
.20238 .13734 L
.21429 .13734 L
.22619 .13734 L
.2381 .13734 L
.25 .13734 L
.2619 .13734 L
.27381 .13734 L
.28571 .13734 L
.29762 .13734 L
.30952 .13734 L
.32143 .13734 L
.33333 .13734 L
.34524 .13734 L
.35714 .13734 L
.36905 .13734 L
.38095 .13734 L
.39286 .13734 L
.40476 .13734 L
.41667 .25179 L
.42857 .25179 L
.44048 .25179 L
.45238 .25179 L
.46429 .25179 L
.47619 .25179 L
.4881 .25179 L
.5 .25179 L
.5119 .25179 L
.52381 .25179 L
.53571 .25179 L
.54762 .25179 L
.55952 .25179 L
.57143 .25179 L
.58333 .25179 L
.59524 .25179 L
.60714 .25179 L
Mistroke
.61905 .25179 L
.63095 .25179 L
.64286 .25179 L
.65476 .25179 L
.66667 .25179 L
.67857 .25179 L
.69048 .25179 L
.70238 .25179 L
.71429 .25179 L
.72619 .25179 L
.7381 .25179 L
.75 .25179 L
.7619 .25179 L
.77381 .25179 L
.78571 .25179 L
.79762 .25179 L
.80952 .25179 L
.82143 .25179 L
.83333 .25179 L
.84524 .25179 L
.85714 .25179 L
.86905 .25179 L
.88095 .25179 L
.89286 .25179 L
.90476 .25179 L
.91667 .25179 L
.92857 .60332 L
.94048 .60332 L
.95238 .60332 L
.96429 .60332 L
.97619 .60332 L
Mfstroke
P
p
.004 w
.02381 .0202 m
.03571 .0202 L
.04762 .03153 L
.05952 .03574 L
.07143 .04601 L
.08333 .04555 L
.09524 .05267 L
.10714 .04765 L
.11905 .0501 L
.13095 .04812 L
.14286 .05115 L
.15476 .05057 L
.16667 .04321 L
.17857 .05816 L
.19048 .03901 L
.20238 .05594 L
.21429 .06038 L
.22619 .05349 L
.2381 .04555 L
.25 .04742 L
.2619 .05979 L
.27381 .04239 L
.28571 .04566 L
.29762 .05711 L
.30952 .05629 L
.32143 .0581 L
.33333 .05045 L
.34524 .05804 L
.35714 .03387 L
.36905 .04531 L
.38095 .05752 L
.39286 .05121 L
.40476 .04455 L
.41667 .05057 L
.42857 .05699 L
.44048 .06972 L
.45238 .07124 L
.46429 .08187 L
.47619 .05571 L
.4881 .04987 L
.5 .06482 L
.5119 .05839 L
.52381 .06283 L
.53571 .0393 L
.54762 .0689 L
.55952 .06371 L
.57143 .05542 L
.58333 .06762 L
.59524 .06972 L
.60714 .07252 L
Mistroke
.61905 .0696 L
.63095 .07287 L
.64286 .0835 L
.65476 .07895 L
.66667 .07346 L
.67857 .08631 L
.69048 .0689 L
.70238 .07941 L
.71429 .08222 L
.72619 .06528 L
.7381 .064 L
.75 .06832 L
.7619 .06178 L
.77381 .048 L
.78571 .05162 L
.79762 .09997 L
.80952 .06435 L
.82143 .07171 L
.83333 .06178 L
.84524 .07842 L
.85714 .07836 L
.86905 .06902 L
.88095 .07276 L
.89286 .08502 L
.90476 .08233 L
.91667 .07626 L
.92857 .09372 L
.94048 .15077 L
.95238 .16058 L
.96429 .18219 L
.97619 .11235 L
Mfstroke
P
P
P
p
p
.8 g
.02381 .0202 m
.03571 .0202 L
.04762 .03153 L
.05952 .03574 L
.07143 .04601 L
.08333 .04555 L
.09524 .05267 L
.10714 .04765 L
.11905 .0501 L
.13095 .04812 L
.14286 .05115 L
.15476 .05057 L
.16667 .04321 L
.17857 .05816 L
.19048 .03901 L
.20238 .05594 L
.21429 .06038 L
.22619 .05349 L
.2381 .04555 L
.25 .04742 L
.2619 .05979 L
.27381 .04239 L
.28571 .04566 L
.29762 .05711 L
.30952 .05629 L
.32143 .0581 L
.33333 .05045 L
.34524 .05804 L
.35714 .03387 L
.36905 .04531 L
.38095 .05752 L
.39286 .05121 L
.40476 .04455 L
.41667 .05057 L
.42857 .05699 L
.44048 .06972 L
.45238 .07124 L
.46429 .08187 L
.47619 .05571 L
.4881 .04987 L
.5 .06482 L
.5119 .05839 L
.52381 .06283 L
.53571 .0393 L
.54762 .0689 L
.55952 .06371 L
.57143 .05542 L
.58333 .06762 L
.59524 .06972 L
.60714 .07252 L
.61905 .0696 L
.63095 .07287 L
.64286 .0835 L
.65476 .07895 L
.66667 .07346 L
.67857 .08631 L
.69048 .0689 L
.70238 .07941 L
.71429 .08222 L
.72619 .06528 L
.7381 .064 L
.75 .06832 L
.7619 .06178 L
.77381 .048 L
.78571 .05162 L
.79762 .09997 L
.80952 .06435 L
.82143 .07171 L
.83333 .06178 L
.84524 .07842 L
.85714 .07836 L
.86905 .06902 L
.88095 .07276 L
.89286 .08502 L
.90476 .08233 L
.91667 .07626 L
.92857 .09372 L
.94048 .15077 L
.95238 .16058 L
.96429 .18219 L
.97619 .11235 L
.97619 .01472 L
.96429 .01472 L
.95238 .01472 L
.94048 .01472 L
.92857 .01472 L
.91667 .01472 L
.90476 .01472 L
.89286 .01472 L
.88095 .01472 L
.86905 .01472 L
.85714 .01472 L
.84524 .01472 L
.83333 .01472 L
.82143 .01472 L
.80952 .01472 L
.79762 .01472 L
.78571 .01472 L
.77381 .01472 L
.7619 .01472 L
.75 .01472 L
.7381 .01472 L
.72619 .01472 L
.71429 .01472 L
.70238 .01472 L
.69048 .01472 L
.67857 .01472 L
.66667 .01472 L
.65476 .01472 L
.64286 .01472 L
.63095 .01472 L
.61905 .01472 L
.60714 .01472 L
.59524 .01472 L
.58333 .01472 L
.57143 .01472 L
.55952 .01472 L
.54762 .01472 L
.53571 .01472 L
.52381 .01472 L
.5119 .01472 L
.5 .01472 L
.4881 .01472 L
.47619 .01472 L
.46429 .01472 L
.45238 .01472 L
.44048 .01472 L
.42857 .01472 L
.41667 .01472 L
.40476 .01472 L
.39286 .01472 L
.38095 .01472 L
.36905 .01472 L
.35714 .01472 L
.34524 .01472 L
.33333 .01472 L
.32143 .01472 L
.30952 .01472 L
.29762 .01472 L
.28571 .01472 L
.27381 .01472 L
.2619 .01472 L
.25 .01472 L
.2381 .01472 L
.22619 .01472 L
.21429 .01472 L
.20238 .01472 L
.19048 .01472 L
.17857 .01472 L
.16667 .01472 L
.15476 .01472 L
.14286 .01472 L
.13095 .01472 L
.11905 .01472 L
.10714 .01472 L
.09524 .01472 L
.08333 .01472 L
.07143 .01472 L
.05952 .01472 L
.04762 .01472 L
.03571 .01472 L
.02381 .01472 L
F
P
p
p
.004 w
.02381 .0202 m
.03571 .0202 L
.04762 .03153 L
.05952 .03574 L
.07143 .04601 L
.08333 .04555 L
.09524 .05267 L
.10714 .04765 L
.11905 .0501 L
.13095 .04812 L
.14286 .05115 L
.15476 .05057 L
.16667 .04321 L
.17857 .05816 L
.19048 .03901 L
.20238 .05594 L
.21429 .06038 L
.22619 .05349 L
.2381 .04555 L
.25 .04742 L
.2619 .05979 L
.27381 .04239 L
.28571 .04566 L
.29762 .05711 L
.30952 .05629 L
.32143 .0581 L
.33333 .05045 L
.34524 .05804 L
.35714 .03387 L
.36905 .04531 L
.38095 .05752 L
.39286 .05121 L
.40476 .04455 L
.41667 .05057 L
.42857 .05699 L
.44048 .06972 L
.45238 .07124 L
.46429 .08187 L
.47619 .05571 L
.4881 .04987 L
.5 .06482 L
.5119 .05839 L
.52381 .06283 L
.53571 .0393 L
.54762 .0689 L
.55952 .06371 L
.57143 .05542 L
.58333 .06762 L
.59524 .06972 L
.60714 .07252 L
Mistroke
.61905 .0696 L
.63095 .07287 L
.64286 .0835 L
.65476 .07895 L
.66667 .07346 L
.67857 .08631 L
.69048 .0689 L
.70238 .07941 L
.71429 .08222 L
.72619 .06528 L
.7381 .064 L
.75 .06832 L
.7619 .06178 L
.77381 .048 L
.78571 .05162 L
.79762 .09997 L
.80952 .06435 L
.82143 .07171 L
.83333 .06178 L
.84524 .07842 L
.85714 .07836 L
.86905 .06902 L
.88095 .07276 L
.89286 .08502 L
.90476 .08233 L
.91667 .07626 L
.92857 .09372 L
.94048 .15077 L
.95238 .16058 L
.96429 .18219 L
.97619 .11235 L
Mfstroke
P
p
.004 w
.02381 .01472 m
.03571 .01472 L
.04762 .01472 L
.05952 .01472 L
.07143 .01472 L
.08333 .01472 L
.09524 .01472 L
.10714 .01472 L
.11905 .01472 L
.13095 .01472 L
.14286 .01472 L
.15476 .01472 L
.16667 .01472 L
.17857 .01472 L
.19048 .01472 L
.20238 .01472 L
.21429 .01472 L
.22619 .01472 L
.2381 .01472 L
.25 .01472 L
.2619 .01472 L
.27381 .01472 L
.28571 .01472 L
.29762 .01472 L
.30952 .01472 L
.32143 .01472 L
.33333 .01472 L
.34524 .01472 L
.35714 .01472 L
.36905 .01472 L
.38095 .01472 L
.39286 .01472 L
.40476 .01472 L
.41667 .01472 L
.42857 .01472 L
.44048 .01472 L
.45238 .01472 L
.46429 .01472 L
.47619 .01472 L
.4881 .01472 L
.5 .01472 L
.5119 .01472 L
.52381 .01472 L
.53571 .01472 L
.54762 .01472 L
.55952 .01472 L
.57143 .01472 L
.58333 .01472 L
.59524 .01472 L
.60714 .01472 L
Mistroke
.61905 .01472 L
.63095 .01472 L
.64286 .01472 L
.65476 .01472 L
.66667 .01472 L
.67857 .01472 L
.69048 .01472 L
.70238 .01472 L
.71429 .01472 L
.72619 .01472 L
.7381 .01472 L
.75 .01472 L
.7619 .01472 L
.77381 .01472 L
.78571 .01472 L
.79762 .01472 L
.80952 .01472 L
.82143 .01472 L
.83333 .01472 L
.84524 .01472 L
.85714 .01472 L
.86905 .01472 L
.88095 .01472 L
.89286 .01472 L
.90476 .01472 L
.91667 .01472 L
.92857 .01472 L
.94048 .01472 L
.95238 .01472 L
.96429 .01472 L
.97619 .01472 L
Mfstroke
P
P
P
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0 0 1 0.618034 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0119048 0.0119048 0.0147151 0.00204376 [
[(20)] .25 .01472 0 2 Msboxa
[(40)] .4881 .01472 0 2 Msboxa
[(60)] .72619 .01472 0 2 Msboxa
[(80)] .96429 .01472 0 2 Msboxa
[(Gen.)] 1.025 .01472 -1 0 Msboxa
[(50)] -0.0006 .1169 1 0 Msboxa
[(100)] -0.0006 .21909 1 0 Msboxa
[(150)] -0.0006 .32128 1 0 Msboxa
[(200)] -0.0006 .42347 1 0 Msboxa
[(250)] -0.0006 .52566 1 0 Msboxa
[(Fit.)] .0119 .61803 0 -4 Msboxa
[ -0.001 -0.001 0 0 ]
[ 1.001 .61903 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
p
.002 w
.25 .01472 m
.25 .02097 L
s
P
[(20)] .25 .01472 0 2 Mshowa
p
.002 w
.4881 .01472 m
.4881 .02097 L
s
P
[(40)] .4881 .01472 0 2 Mshowa
p
.002 w
.72619 .01472 m
.72619 .02097 L
s
P
[(60)] .72619 .01472 0 2 Mshowa
p
.002 w
.96429 .01472 m
.96429 .02097 L
s
P
[(80)] .96429 .01472 0 2 Mshowa
p
.001 w
.05952 .01472 m
.05952 .01847 L
s
P
p
.001 w
.10714 .01472 m
.10714 .01847 L
s
P
p
.001 w
.15476 .01472 m
.15476 .01847 L
s
P
p
.001 w
.20238 .01472 m
.20238 .01847 L
s
P
p
.001 w
.29762 .01472 m
.29762 .01847 L
s
P
p
.001 w
.34524 .01472 m
.34524 .01847 L
s
P
p
.001 w
.39286 .01472 m
.39286 .01847 L
s
P
p
.001 w
.44048 .01472 m
.44048 .01847 L
s
P
p
.001 w
.53571 .01472 m
.53571 .01847 L
s
P
p
.001 w
.58333 .01472 m
.58333 .01847 L
s
P
p
.001 w
.63095 .01472 m
.63095 .01847 L
s
P
p
.001 w
.67857 .01472 m
.67857 .01847 L
s
P
p
.001 w
.77381 .01472 m
.77381 .01847 L
s
P
p
.001 w
.82143 .01472 m
.82143 .01847 L
s
P
p
.001 w
.86905 .01472 m
.86905 .01847 L
s
P
p
.001 w
.91667 .01472 m
.91667 .01847 L
s
P
[(Gen.)] 1.025 .01472 -1 0 Mshowa
p
.002 w
0 .01472 m
1 .01472 L
s
P
p
.002 w
.0119 .1169 m
.01815 .1169 L
s
P
[(50)] -0.0006 .1169 1 0 Mshowa
p
.002 w
.0119 .21909 m
.01815 .21909 L
s
P
[(100)] -0.0006 .21909 1 0 Mshowa
p
.002 w
.0119 .32128 m
.01815 .32128 L
s
P
[(150)] -0.0006 .32128 1 0 Mshowa
p
.002 w
.0119 .42347 m
.01815 .42347 L
s
P
[(200)] -0.0006 .42347 1 0 Mshowa
p
.002 w
.0119 .52566 m
.01815 .52566 L
s
P
[(250)] -0.0006 .52566 1 0 Mshowa
p
.001 w
.0119 .03515 m
.01565 .03515 L
s
P
p
.001 w
.0119 .05559 m
.01565 .05559 L
s
P
p
.001 w
.0119 .07603 m
.01565 .07603 L
s
P
p
.001 w
.0119 .09647 m
.01565 .09647 L
s
P
p
.001 w
.0119 .13734 m
.01565 .13734 L
s
P
p
.001 w
.0119 .15778 m
.01565 .15778 L
s
P
p
.001 w
.0119 .17822 m
.01565 .17822 L
s
P
p
.001 w
.0119 .19865 m
.01565 .19865 L
s
P
p
.001 w
.0119 .23953 m
.01565 .23953 L
s
P
p
.001 w
.0119 .25997 m
.01565 .25997 L
s
P
p
.001 w
.0119 .2804 m
.01565 .2804 L
s
P
p
.001 w
.0119 .30084 m
.01565 .30084 L
s
P
p
.001 w
.0119 .34172 m
.01565 .34172 L
s
P
p
.001 w
.0119 .36215 m
.01565 .36215 L
s
P
p
.001 w
.0119 .38259 m
.01565 .38259 L
s
P
p
.001 w
.0119 .40303 m
.01565 .40303 L
s
P
p
.001 w
.0119 .44391 m
.01565 .44391 L
s
P
p
.001 w
.0119 .46434 m
.01565 .46434 L
s
P
p
.001 w
.0119 .48478 m
.01565 .48478 L
s
P
p
.001 w
.0119 .50522 m
.01565 .50522 L
s
P
p
.001 w
.0119 .54609 m
.01565 .54609 L
s
P
p
.001 w
.0119 .56653 m
.01565 .56653 L
s
P
p
.001 w
.0119 .58697 m
.01565 .58697 L
s
P
p
.001 w
.0119 .60741 m
.01565 .60741 L
s
P
[(Fit.)] .0119 .61803 0 -4 Mshowa
p
.002 w
.0119 0 m
.0119 .61803 L
s
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
P
MathSubEnd
P
% End of sub-graphic
P
MathSubEnd
P
% End of sub-graphic
p
p
.85957 .07733 m
.85957 .23282 L
.97619 .23282 L
.97619 .07733 L
F
1 g
.84014 .09677 m
.84014 .25226 L
.95675 .25226 L
.95675 .09677 L
F
0 g
.001 w
.84014 .09677 m
.95675 .09677 L
.95675 .25226 L
.84014 .25226 L
.84014 .09677 L
s
% Start of sub-graphic
p
0.840136 0.096768 0.956754 0.252259 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0297619 0.297619 0.0529101 0.529101 [
[ 0 0 0 0 ]
[ 1 1.33333 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
P
0 0 m
1 0 L
1 1.33333 L
0 1.33333 L
closepath
clip
newpath
p
p
p
p
.8 g
.05357 .09524 m
.05357 .62434 L
.35119 .62434 L
.35119 .09524 L
F
P
[(Mean)] .38988 .35979 -1 0 Mshowa
P
p
p
.4 g
.05357 .70899 m
.05357 1.2381 L
.35119 1.2381 L
.35119 .70899 L
F
P
[(Best)] .38988 .97354 -1 0 Mshowa
P
P
p
P
P
MathSubEnd
P
% End of sub-graphic
P
P
P
0 0 m
1 0 L
1 .50452 L
0 .50452 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{394, 198},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006:0000aPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0R`000?l0R`000?l0R`000?l0R`000?l0
R`000?l0R`000?l0R`000?l0R`0005X01?l300;o<P03o`<00_lb00;o1002oc800_l400;oN@0005/0
00?o00000P001?l00?lb0005o`000?l00P000ol0000^0004o`00o`8000Co003o<0001?l00?l20004
o`00ogP0001L0005o`000?l00P000ol0000^00Co0P001?l00?l`0004o`00o`8000Co003o<0001?l0
0?l20004o`00ogP0001M0004o`00o`8000?o0000;P000ol0o`030004o`00oc000ol30004o`00oc40
0_l30004o`00ogP0001J0004o`00o`8000Co003o<0000ol0o`030004o`00oc0000?o00000`001?l0
0?l`0004o`00o`8000Co003oN00005/00_l400;o<P02o`@00_lb00?o0`02oc800_l400;oN@000?l0
R`000?l0R`000?l0R`0002@000?o0000o`1T000090000ol0003f00Co0`04o`040?oo00;o0P02oeP0
000T0003o`000?D000Go0000o`020003o`0000<000Co003o0`02oeP0000R0?Go1@000ol0o`02o`80
1Ol01@3o003o05d0000T0003o`0000UK00?oFe/02E/00omKF`08F`03oe]K00UK00?oFe/02E/00omK
F`08F`03oe]K00UK00?oFe/02E/00omKF`08F`03oe]K00UK00?oFe/02E/00omKF`08F`03oe]K00UK
00?oFe/02E/00omKF`08F`03oe]K00UK00?oFe/025/00omKF`09F`03oe]K00UK00?oFe/025/00omK
F`0<0003o`0000@000Oo0000o`3o008000?o0000F`0002@000?o00001OlcF`03oe]K03MK00?oFe/0
=e/00omKF`0gF`03oe]K00`000Go0000o`0300?o00<0ool00omM000090000ol00005P@03oe]K0>5K
3@04ofT0000T0003o`0000J10ooPFgX0000T00;o00<0PH401h400omKF`16F`03oe]K09AKNP0002@0
00?o00002X400omKF`0LF`03oe]K02IK0_lZF`03oe]K06QKNP0002@000?o00002h400omKF`0DF`;o
1E/00omKF`0BF`;o4E/01?n1POlYF`03oe]K06QKNP0002@000?o00001?l8P@Go0e/4o`9K0ol4F`03
oh7o00AK00?oPOl02E/5o`EK00?oPOl045/01On1PH7o00MK0olMF`;o>E/3obiKNP0002@000?o0000
0`000on1P@0;P@03oe_o00B10_l3P@Co0h401?mKFol3P@03oe]K00EK00?oPH400h401OmKFe_o00>1
00?oFe/01e/3o`9K00?oPH400h401?mKFe/3o`>10_l?F`;o2U/00on1o`0hF`04oh61obeKNP0002@0
0_l50003oh6100^100?oPH4048400omKo`04P@?o0U/2o`N100?oFol01H400omKF`04o`03Fon100:1
00?oFol01X400omKo`08P@03oe]K00YK0_l00h7oF`08F`04oh61o`EK0_l`F`05oh61POl0;E]j0000
90000ol000050003oh6101j100?oPH401X42o`Z100?oPH401H42o`B100?oPH400h400on1P@06P@03
oh6100R100?oFe/02E/01On1PH7o00=K1?l01E_oPH7o00AK00CoPH7o;U/00on1P@02P@03oe]K02]K
NP0002@000?o00001P000on1P@1KP@03oe]K00MK00?oPH400h400omKo`04P@05oh61POl00U/2o`B1
00?oFe/08e/4o`9K0_l6P@03oe]K009K00CoFe]K0_lRFd00;_l<000090000ol000060003oh6105b1
00?oFe/01U/00on1P@04P@03oh6100R10_l7P@?o85/2o`B10_l8P@03oe]K009K0_l015_oPOlRFd00
;_l<000090000ol000060003oh6105f11?l3F`03oh61012100?oPH402H4:o`eK0_l7F`03oh6100f1
00GoFe]Ko`02P@05oh61POl01U/5oaIK@00^o``0000T00;o1`000on1P@1QP@04oe]KobR100?oFe/0
15/2o`AK00?oPOl01E/00on1P@0>P@05oe]KFol01h400omKF`02F`03oh6100>100?oFe/015/2o`eK
@00^o``0000T0003o`0000L000?oPH40HH400omKo`0YP@03oe]K00?o0X401?mKFol3P@?o00=Koh40
4H401?mKFol8P@Co1h400omKF`02F`03oh7o00eK@00^o``0000T0003o`0000L000?oPH40HX400on1
P@0YP@;o1X400omKo`06P@03oh61016100?oFol05H44o`>100?oFe/02U]002ko300002@000?o0000
1`000on1P@2GP@03oh6101V100?oFol07H400omKF`09FcT0=Ol<000090000ol000070003oh610;>1
00?oFol07H400omKF`09FcT000?o0000:P08o``0000T00;o20000on1P@2dP@03oh6101f100?oFe/0
25/i0003o`0002X02?l<000090000ol000070003oh610;B100?oPH407H400omKF`08FcT000?o0000
:P08o``0000T0003o`0000P000?oPH40dh400omKF`08FcT000?o0000:P08o``0000F00?o1002o`D0
00?o000020000on1P@3DP@03oe]K00MK>@000ol0000Z00So300001T000Co003o0P000ol000020003
o`0000P000?oPH40e8400omKF`07F`03o`0003H000?o05/03E/M00So300001T000Co003o0P000ol0
000200?o20000on1P@3DP@03oe]K00MK00?o0000=P000ol0F`0=Fad02?l<00005P03o`<000Co003o
10000ol000080003oh610=B100?oFe/01e/00ol0000f0003o`1K00eK7@08o``0000F0003o`0000<0
00Co003o10000ol000080003oh610=B100?oFe/01e/00ol0000f0003o`1K00eK7@08o``0000F00Co
0`02o`D000?o00002@000on1P@3DP@03oe]K00EK00?o0000=`000ol0F`0=Fad02?l<000090000ol0
00090003oh610=B100?oFe/01E/00ol0000g0003o`1K00eK7@08o``0000T00;o2P1Foh6100?oFe/0
1E/00ol0000g0003o`1K00eK7@08o``0000T0003o`0005h000?oPH40Oh400omKF`05F`03o`0003L0
00?o05/03E/M00So300002@000?o0000GP000on1P@1oP@03oe]K00EK00?o0000=`000ol0F`0=Fad0
2?l<000090000ol0001N0003oh61082100?oFe/00e/00on1000h0003o`1K00eK0`001Ol0003o0080
1?l00`3oo`03o`040?oo00;o0`08o``0000T0003o`0005h000?oPH40P8400omKF`03F`03oh4003P0
00?o05/03E/30007o`000?l0o`050004o`00o`8000Co003o1008o``0000T00;oG`000on1P@21P@03
oe]K009K00?oP@00>0000ol0F`0=F`<000Ko0?l0o`05o`030?oo00;o0P001?l00?l400So300002@0
00?o0000GP000on1P@22P@06oe]KFon1>@000ol0F`0=F`<000Oo0?l0o`3o00<000?o00000P001?l0
0?l20003o`0000802?l<000090000ol0001N0003oh6108:100KoFe]Koh4i0003o`1K00eK0`02o`03
0?oo00800ol300?o00<0ool00ol400So300002@000?o0000G`000on1P@22P@05oe]Koh40>@000ol0
F`0=F`800_l300;o5008o``0000T0003o`0005l000?oPH40Ph42o`:1>@000ol0F`0=Fad02?l<0000
9002of0000?oPH40Ph42o`:1>@000ol0F`0=Fad02?l<000090000ol0001O0003oh6108B100?oPH40
>@000ol0F`0=Fad02?l<000090000ol0001O0003oh6108N1>@000ol0F`0=Fad02?l<000090000ol0
001O0003oh6108N1>@000ol0F`0=Fad02?l<000090000ol0001O0003oh6108N1>@000ol0F`0=Fad0
2?l<00009002of0000?oPH40Qh4i0003o`1K00eK7@08o``0000T0003o`0005l000?oPH40Qh4i0003
o`1K00eK7@08o``0000T0003o`0005l000?oPH40Qh4i0003o`1K00eK7@08o``0000@00?o1002o`@0
0_l50003o`0005l000?oPH40Qh4i0003o`0002X02?l<00004@000ol000020004o`00o`8000Co003o
10000ol0001O0003oh6108N1>@000ol0000Z00So3000014000?o00000P001?l00?l20004o`00o`@0
0omO0003oh6108N1>@000ol0000Z00So3000014000?o00000P001?l00?l20004o`00o`@000?o0000
G`000on1P@27PCT000?o0000:P08o``0000A0003o`00008000Co003o0P001?l00?l40003o`000600
00?oPH40QX4i0003o`2100f17@08o``0000@00;o1@02o`@00_l50003o`00060000?oPH40QX4i0003
o`2100f17@08o``0000T0003o`00060000?oPH40QX4i0003o`2100f17@08o``0000T00;oH@000on1
P@26PCT000?o08403H4M00So300002@000?o0000H0000on1P@26PCT000?o08403H4M00So300002@0
00?o0000H0000on1P@26PCT000?o08403H4M00So300002@000?o0000H01lo`f1>@000ol0P@0=PAd0
2?l<000090000ol0003K0003oh6100^1>@000ol0P@0=PAd02?l<00009002om`000?oPH402h4i0003
o`2100f17@08o``0000T0003o`000=/000?oPH402h4i0003o`2100f10P04o`@01?l00`3oo`02o`<0
0ol400So300002@000?o0000f`000on1P@0;PCT000?o08403H430004o`00o`8000?o00001P001Ol0
003o008000Co00002?l<000090000ol0003K0003oh6100^1>@000ol0P@0=P@<000Co003o0P05o`03
0?oo00;o0`000ol0000400So300002@000?o0000f`000on1P@0;PCT000?o08403H4300?o0`001ol0
003o0?l01P000ol0000400So300002@00_oL0003oh6100^1>@000ol0P@0=P@<000Co003o0`03o`80
1?l200Co1008o``0000T0003o`000=/000?oPH402h4i0003o`2100f10P04oa0000?o00001008o``0
000T0003o`000=/000?oPH402h4i0003o`2100f15P000ol0000400So300002@000?o0000f`000on1
P@0;PCT000?o08403H4M00So300002@000?o0000f`000on1P@0;PCT000?o08403H4M00So300002@0
0_oL0003oh6100^1>@000ol0P@0=PAd02?l<000090000ol0003K0003oh6100^1>@000ol0P@0=PAd0
2?l<000090000ol0003K0003oh6100^1>@000ol0P@0=PAd000?o00004@0001000ol300?o1002o`D0
00?o0000g0000on1P@0:PCT000?o08403H4M0003o`000140000A0003o`0000D000Co003o0P000ol0
00020003o`000=`000?oPH402X4i0003o`2100f17@000ol0000A00004@000ol000050004o`00o`80
00?o00000P03om`000?oPH402X4i0003o`2100f17@000ol0000A00004@000ol0000200?o0`001?l0
0?l40003o`000=`000?oPH402X4i0003o`0002X000?o00004@00014000?o00000P000ol000030004
o`00o`@000?o0000g0000on1P@0:PCT000?o0000:P000ol0000A00004002o`@01?l300;o1@000ol0
003L0003oh6100Z1>@000ol0000Z0003o`000140000T0003o`000=`000?oPH402X4i02ko4`0002@0
0_oM0003oh6100Z1NP0002@000?o0000g0000on1P@0:PGX0000T0003o`000=`000?oPH402X5j0000
90000ol0003L0003oh6100Z1NP0002@000?o0000g0000on1P@0:PGX0000T00;og@000on1P@0:PGX0
000T0003o`000=`000?oPH402X5j000090000ol0003L0003oh6100Z1NP0002@000?o0000g0000on1
P@0:PGX0000T0003o`000=`000?oPH402X5j00009002omd000?oPH402X5j000090000ol0003L0003
oh6100Z1NP0002@000?o0000g0000on1P@0:PGX0000T0003o`000=`000?oPH402X5j000090000ol0
003L0003oh6100Z1NP0002@00_oM0003oh6100Z1NP0002@000?o0000g0000on1P@0:PGX0000T0003
o`000=`000?oPH402X5j00004004o`<00_l400;o1@000ol0003L0003oh6100Z1NP00014000?o0000
0P001?l00?l20004o`00o`@000?o0000g0000on1P@0:PGX0000B0005o`000?l00P001?l00?l20003
o`0000800ooL0003oh6100Z1NP0001<000Co003o0P001?l00?l20003o`00008000?o0000g0000on1
P@0:PGX0000@0004o`00o`8000Co003o0P001?l00?l40003o`000=d000?oPH402H5j00004@02o`@0
0_l400;o1@000ol0003M0003oh6100V1NP0002@000?o0000g@000on1P@09PGX0000T00;ogP000on1
P@09PGX0000T0003o`000=d000?oPH402H5j000090000ol0003M0003oh6100V1NP0002@000?o0000
g@000on1P@09PGX0000T0003o`000=d000?oPH402H5j00009002omh000?oPH402H5j000090000ol0
003M0003oh6100V1NP0002@000?o0000g@000on1P@09PGX0000T0003o`000=d000?oPH402H5j0000
90000ol0003M0003oh6100V1NP0002@00_oN0003oh6100V1NP0002@000?o0000g@000on1P@09PGX0
000T0003o`000=d000?oPH402H5j000090000ol0003M0003oh6100V1NP0002@000?o0000g@000on1
P@09PGX0000T00;ogP000on1P@09PGX0000T0003o`000=d000?oPH402H5j000090000ol0003M0003
oh6100V1NP0001001?l200?o1002o`D000?o0000g@000on1P@09PGX0000A0003o`0000D000Co003o
0P000ol000020003o`000=d000?oPH402H5j00004P000ol000040004o`00o`8000?o00000P03omd0
00?oPH402H5j00004`000ol00003o`<000Co003o10000ol0003M0003oh6100V1NP00010000Co003o
0P000ol000030004o`00o`@000?o0000g@000on1P@09PGX0000A00;o0`04o`<00_l50003o`000=d0
00?oPH402H5j000090000ol0003M0003oh6100V1NP0002@00_oN0003oh6100V1NP0002@000?o0000
gP000on1P@08PGX0000T0003o`000=h000?oPH40285j000090000ol0003N0003oh6100R1NP0002@0
00?o0000gP000on1P@08PGX0000T00;og`000on1P@08PGX0000T0003o`000=h000?oPH40285j0000
90000ol0003N0003oh6100R1NP0002@000?o0000gP000on1P@08PGX0000T0003o`000=h000?oPH40
285j00009002oml000?oPH40285j000090000ol0003N0003oh6100R1NP0002@000?o0000gP000on1
P@08PGX0000T0003o`000=h000?oPH40285j000090000ol0003N00coN@0002@00_oo06D0000T0003
o`000?l0I00002@000?o0000o`1T000090000ol0003o06@0003o08/0003o08/0003o08/0003o08/0
003o08/0003o08/0003o08/0003o08/0003o08/0003o08/0003o08/0003o08/0003o08/0003o08/0
003o08/0003o08/0003o08/0000H00?o1005o`800ol300;oo`1M00006@000ol000050003o`000080
00Co003o0P02ool0G@0001T000?o00001@000ol000020003o`000?l0HP0001T00ol50003o`000080
00?o0000o`1R00006@000ol0000400;o0`04ool0HP0001P01Ol90003o`000?l0HP00024000?o0000
0P000ol0003o0680003o08/0003o08/0003o08/0003o08/0003o08/00000\
\>"],
  ImageRangeCache->{{{0, 393}, {197, 0}} -> {-1.0696, -0.648943, 0.00658828, 
  0.00658828}, {{10.5625, 314.125}, {192.25, 4.6875}} -> {-0.0349327,
   -0.0253247, 0.00329506, 0.00533152}, {{10.5625, 314.062}, {192.25, 4.6875}}
   -> {-12.6891, -39.509, 0.343437, 2.0005}, {{10.5625, 314.062}, {192.25, 
  4.6875}} -> {-12.6891, -39.509, 0.343437, 2.0005}, {{329.312, 374.812}, {
  159.188, 98.5}} -> {-24.4187, -1.67114, 0.0738469, 0.0415388}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["L-Systems"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[
"A list of the best fitness of each generation"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["bestFitnesses = Map[First,allFitnessesSorted]"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
{16, 16, 24, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, \

 
  60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 116, 116, 
 
  116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 
 
  116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 
 
  116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 288, 
 
  288, 288, 288, 288}\
\>", 
"\<\
{16, 16, 24, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, \

 
  60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 116, 116, 
 
  116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 
 
  116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 
 
  116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 116, 288, 
 
  288, 288, 288, 288}\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"Extracting the generations when new champions were evolved (best fitness \
increase)"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[
"The champs were generated in the following generations:\n{1), {2, 3, 33, 76}\
\nFitnesses are: {16}, {24, 60, 116, 288}"], "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[
"bestFitGens = \n  Position[Partition[bestFitnesses,2,1],{x_,y_}/;y>x]+1"], 
  "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
{{3}, {4}, {34}, {77}}\
\>", 
"\<\
{{3}, {4}, {34}, {77}}\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["PrependTo[bestFitGens,{2}]"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
{{2}, {3}, {4}, {34}, {77}}\
\>", 
"\<\
{{2}, {3}, {4}, {34}, {77}}\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[TextData[
"bestFitGens contains the generations where the champs appear at position one \
for the first time.\nbestFitGens-1 are the generations where the champs were \
created."], "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[
"Map[\n  getFitnesses[$basicDirectory,\"Fractals-10-1\",#//First]&,\n  \
bestFitGens\n]"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
{{16, 12, 12, 0, 8, 6, 0, 16, 0, 6, 16, 18, 6, 16, 16, 0, 16, 14, 12, 6, \
6, 
 
   0, 6, 16, 2, 6, 2, 2, 0, 6, 0, 24, 6, 16, 0}, 
 
  {24, 12, 16, 6, 18, 16, 16, 16, 0, 16, 14, 0, 6, 6, 2, 0, 6, 16, 2, 12, 
 
   16, 0, 6, 0, 0, 6, 0, 0, 60, 12, 12, 16, 16, 0, 12}, 
 
  {60, 16, 2, 0, 6, 8, 8, 16, 16, 16, 12, 2, 6, 2, 0, 2, 12, 2, 0, 20, 20, 
 
   24, 16, 16, 60, 6, 60, 16, 0, 12, 0, 58, 12, 16, 14}, 
 
  {116, 6, 0, 20, 12, 0, 0, 116, 20, 16, 20, 60, 60, 16, 0, 12, 0, 16, 32, 
 
   0, 10, 0, 0, 6, 116, 16, 16, 10, 0, 6, 0, 0, 6, 0, 16}, 
 
  {288, 6, 6, 0, 0, 0, 12, 2, 16, 0, 6, 4, 0, 116, 288, 288, 288, 0, 116, 
 
   42, 116, 28, 0, 116, 288, 0, 0, 22, 36, 116, 62, 38, 0, 0, 30}}\
\>", 
"\<\
{{16, 12, 12, 0, 8, 6, 0, 16, 0, 6, 16, 18, 6, 16, 16, 0, 16, 14, 12, 6, \
6, 
 
   0, 6, 16, 2, 6, 2, 2, 0, 6, 0, 24, 6, 16, 0}, 
 
  {24, 12, 16, 6, 18, 16, 16, 16, 0, 16, 14, 0, 6, 6, 2, 0, 6, 16, 2, 12, 
 
   16, 0, 6, 0, 0, 6, 0, 0, 60, 12, 12, 16, 16, 0, 12}, 
 
  {60, 16, 2, 0, 6, 8, 8, 16, 16, 16, 12, 2, 6, 2, 0, 2, 12, 2, 0, 20, 20, 
 
   24, 16, 16, 60, 6, 60, 16, 0, 12, 0, 58, 12, 16, 14}, 
 
  {116, 6, 0, 20, 12, 0, 0, 116, 20, 16, 20, 60, 60, 16, 0, 12, 0, 16, 32, 
 
   0, 10, 0, 0, 6, 116, 16, 16, 10, 0, 6, 0, 0, 6, 0, 16}, 
 
  {288, 6, 6, 0, 0, 0, 12, 2, 16, 0, 6, 4, 0, 116, 288, 288, 288, 0, 116, 
 
   42, 116, 28, 0, 116, 288, 0, 0, 22, 36, 116, 62, 38, 0, 0, 30}}\
\>"], 
  "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Extracting the chamption L-systems"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
getExpressions[dir_,exp_,gen_] :=
Module[{},
  
  Get[dir <> $PathnameSeparator <> \"Examples\" <>
      $PathnameSeparator <> exp <> 
      $PathnameSeparator <> exp <> \".\" <>
                   ToString[gen] <> \".pop\"]
                   
];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
getExpression[dir_,exp_,gen_,index_] :=
Module[{},
  
  Get[dir <> $PathnameSeparator <> \"Examples\" <>
      $PathnameSeparator <> exp <> 
      $PathnameSeparator <> exp <> \".\" <>
                   ToString[gen] <> \".pop\"][[index]]
                   
];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(getExpression\)\" is \
similar to existing symbol \"\!\(getExpressions\)\"."\)], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"champLSystems =\nMap[\n  \
getExpression[$basicDirectory,\"Fractals-10-1\",#//First,1]&,\n  bestFitGens\n\
]"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
{LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], \

 
   LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], SUCC[SEQ[FO[1], RR[90]]]]]], 
 
  LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
   LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
     SUCC[SEQ[SEQ[FO[1], RR[90]], SEQ[FO[1], RL[90]]], SEQ[FO[1], RR[90]], 
 
      SEQ[FO[1], RL[90]]]]]], LSystem[AXIOM[seq[FO[1], RL[90], FO[1], 
 
     RL[90], FO[1], RL[90], FO[1]]], 
 
   LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
     SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
       SEQ[FO[1]], FO[1]]]]]], 
 
  LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
   LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
     SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
       SEQ[FO[1], RL[90], FO[1]], FO[1]]]]]], 
 
  LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
   LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
     SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
       SEQ[FO[1], SEQ[FO[1], RL[90]], SEQ[FO[1], RL[90]], 
 
        SEQ[FO[1], RR[90]]], FO[1]]]]]]}\
\>", 
"\<\
{LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], \

 
   LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], SUCC[SEQ[FO[1], RR[90]]]]]], 
 
  LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
   LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
     SUCC[SEQ[SEQ[FO[1], RR[90]], SEQ[FO[1], RL[90]]], SEQ[FO[1], RR[90]], 
 
      SEQ[FO[1], RL[90]]]]]], LSystem[AXIOM[seq[FO[1], RL[90], FO[1], 
 
     RL[90], FO[1], RL[90], FO[1]]], 
 
   LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
     SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
       SEQ[FO[1]], FO[1]]]]]], 
 
  LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
   LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
     SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
       SEQ[FO[1], RL[90], FO[1]], FO[1]]]]]], 
 
  LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
   LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
     SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
       SEQ[FO[1], SEQ[FO[1], RL[90]], SEQ[FO[1], RL[90]], 
 
        SEQ[FO[1], RR[90]]], FO[1]]]]]]}\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Print[%]"], "Input",
  AspectRatioFixed->True],

Cell[TextData[
"{LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], \n \
\n   LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], SUCC[SEQ[FO[1], RR[90]]]]]], \
\n \n  LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], \
FO[1]]], \n \n   LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], \n \n     \
SUCC[SEQ[SEQ[FO[1], RR[90]], SEQ[FO[1], RL[90]]], SEQ[FO[1], RR[90]], \n \n   \
   SEQ[FO[1], RL[90]]]]]], LSystem[AXIOM[seq[FO[1], RL[90], FO[1], \n \n     \
RL[90], FO[1], RL[90], FO[1]]], \n \n   LRULES[LRule[LEFT[], PRED[FO[1]], \
RIGHT[], \n \n     SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], \
SEQ[FO[1], RR[90]], \n \n       SEQ[FO[1]], FO[1]]]]]], \n \n  \
LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], \n \n \
  LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], \n \n     SUCC[SEQ[SEQ[FO[1], \
RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], \n \n       SEQ[FO[1], \
RL[90], FO[1]], FO[1]]]]]], \n \n  LSystem[AXIOM[seq[FO[1], RL[90], FO[1], \
RL[90], FO[1], RL[90], FO[1]]], \n \n   LRULES[LRule[LEFT[], PRED[FO[1]], \
RIGHT[], \n \n     SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], \
SEQ[FO[1], RR[90]], \n \n       SEQ[FO[1], SEQ[FO[1], RL[90]], SEQ[FO[1], \
RL[90]], \n \n        SEQ[FO[1], RR[90]]], FO[1]]]]]]}"], "Print",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Displaying the champion L-systems"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[
"MapThread[\n  Show[\n    {turtleInterpretation[\n       \
Last[runKLSystem[#1,1]] /. interpretTable,\n       GraphicOptions -> \
{AspectRatio -> 1,\n                          Axes -> False,\n                \
          Boxed -> False,\n                          PlotRange -> All,\n      \
                    DisplayFunction -> Identity\n                         }\n \
      (**DefaultDrawColor -> 0.3**)\n     ], kochGraphicMoved},\n     \
PlotLabel -> \"Gen.\" <> ToString[(#2//First)-1],\n     DisplayFunction -> \
$DisplayFunction\n   ]&,\n   {champLSystems,bestFitGens}\n];"], "Input",
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Champion-L-systems"],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[(Gen.1)] .5 1 0 -1.5 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.1)] .5 1 0 -1.5 Mshowa
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{266, 266},
  ImageMargins->{{33, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004:00012PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`0006h01YFF0000KP08UI@0001^00ZETP0005<01LHF00bET00004d01YD5aQH0
3IF?0000C@06U@G65P0?UHd0001=00JE1LHF016ER`0004d01YD5aP03U@0001<01ID00`2EU@0;UHT0
001=00JE1LH3UA<01ID300fEQ`0004d01ID6aPFE4@05U@@03YF50000C006U@K61iD?00FE1P0>UH<0
001<00JE1/H9U@d01ID800jEP@0004`01YD6aP^E2`05U@X03IF00000C006U@G63ID:00FE300=UGh0
001<00FE00<0a/H00lH200fE2005U@h03IEl0000C005U@030<K600?6100=U@H01ID@00fENP0004`0
1ID00`36aP03aPH03ID400FE4P0<UGT0001<00FE00<0a/H00lH800fE0P05UA<02iEi0000C005U@03
0<K600?62@0CUAD02IEi0000C005U@030<K600?62`0AUAL01iEi0000C005U@K63@0?UAT01IEi0000
B`06U@K63`0=UAT01IEi0000B`06U@K64@0;UAT01IEi0000B`06U@K64`09UAT01IEi0000B`06U@G6
5P07UAT01IEi0000B`06U@G66005UAT01IEi0000B`06U@G6=P05UGT0001;00JE1LHf00FEN@0004/0
1YD5aP03U@0003<01IEi0000B`06U@G60iDc00FEN@0004d019D5aPFE<@05UGT0000T00JE9@000iG6
aP04aPNE;`05UGT0000T00RE9006aPVE;@05UGT0000T00ZE8P06aP^E:`05UGT0000T00bE8006aPfE
:@05UGT0000S00nE7P05aP803YDW00FEN@0002<04IDL00G6100>UBD01IEi00008`0CUAX01LH600jE
8`05UGT0000S00JE00<0UID039DH00G6200>UB401IEi00008`05U@@03YDF00G62P0>UAl01IEi0000
8`05U@H03iDC00G6300>UAd01IEi00008P06U@P03iDA00G63P0>UA/01IEi00008P06U@X03iD?00G6
400=UAX01IEi00008P06U@`03iD<00K64P0;UAX01IEi00008P06U@h03iD:00K65009UAX01IEi0000
8P05UA803YD800K65P07UAX01IEi00008P05UA@03YD600K66005UAX01IEi00008P05UAH03YD400G6
6@05UAX01IEi00008@06UAP03YD200G66@05UAX01IEi00008@06UAX03YD5aQT01IDJ00FEN@000240
1YDL00bE1LHI00FE6P05UGT0000Q00JE7P0:U@G66@05UAX01IEi00008@05UB4029D5aP:E5`05UAX0
1IDH00JEF`0002401IDS00JE1LH4UAD01IDJ00FE6008UET0000P00JE9@04U@G61YDB00JE6P05UAP0
2YEG00008006UBL000>Ea/H01<H8UA001YDJ00FE600<UED0000P00JE:006aPZE3P06UAX01IDH00jE
D`00020029DV00K63ID;00JE6P05UAP049EA0000800;UB<01/H?U@T01IDK00JE5`0BUDl0000P00fE
8@05aP<03iD700FE6`08UAD01ID00`2EU@0;UDh0000P00nE7`05aPD03iD500FE6`0:UA<01ID300fE
C000028049DL00G61`0?U@<01IDK00bE4@05U@D03IE:0000900@UAX01LH:01BE6`0>U@l01ID700fE
B00002L03iDH00G6300BUAd03YD=00FE2@0=UDH0000Y012E5@05aPh049DO00jE2`05U@X03YE40000
:`0@UA<01LH@00jE8@0>U@T01ID<00jE@P0002h03iDA00G64P0<UB<03ID800FE3P0=UD40000`00nE
3P06aQD02IDU00fE1P05UA002iE10000<P0@U@/01/HG00NE9`0=U@@01IDB00VE@@0003D03iD900K6
6@05UBT03ID200FE5007UD40000g00nE1`06aTT04YDF00FE@@0003T049D400G6B`0AUAH01IE10000
>`0@U@801LI=00nE5P05UD40000n00jE00<0a/H00lI?00fE5P05UD40001000bE00<0a/H00lIA00^E
5P05UD40001200ZE00<0a/H00lIC00VE5P05UD40001500NE00<0a/H00lIE00NE5P05UD40001700FE
00<0a/H00lIG00FE5P06UD00001700FE00<0a/H00lIb00JE@00004L01ID6aW801YE00000AP06U@K6
LP06UD00001600JE1/Ic00FE@00004H01YD6aW<01IE00000AP06U@G6M005UD00001600FE00<0a/H0
0lId00FE@00004H01ID00`36aP03aW@01IE00000AP05U@030<K600?6M006UCl0001600FE00<0a/H0
0lId00RE?@0004H01ID00`36aP03aW@02YDk0000AP05U@030<K600?66P06UE@039Di0000AP05U@03
0<K600?66P08UE803YDg0000AP05U@030<K600?66P0;UE403YDe0000AP05U@K66P0=UE403YDc0000
A@06U@K66P0?UE403YDa0000A@06U@K66P0AUE403YD_0000A@06U@K66P0CUB`01YDO00jE;@0004D0
1YD5aQX01YD200nE:@08UAl03YD[0000A@05U@030<K600?66P06U@@03iDW00ZE7`0>UBT0001500FE
00<0a/H00lHJ00JE1P0?UBD03IDN00jE9`0004D01YD5aQX01YD800nE8`0?UAh03IDV0000A@06U@G6
6P05U@/03iDQ016E7P0;UBH0001500JE1LHJ00FE3P0?UAh04iDN00VE9P0004D01YD5aP:E6005UA00
3iDL00FE00<0UID03IDN00NE9P0004D03iDF00FE4P0?UAX01ID400jE7P05UBH0001700nE5005UA@0
3YDI00FE1P0>UA`01IDV0000B@0@UA401IDF00bE6@05U@P03iDI00JE9@0004`03iD?00FE6@09UAT0
1ID:00nE5`06UBD0001>00nE3@05UA/01iDI00JE2`0?UAD01YDU0000D00?U@/01IDM00FE6@06U@d0
3iDC00JE9@00058049D700JE7@05UAT01YD?00nE4P05UBD0001E00nE1@06UAd01IDI00JE4P0>UA00
1IDU0000E`0?U@<01YDM00FE6P05UA@03YD>00FE9@0005T03iD00`2EU@04UAd01IDJ00FE5P0>U@`0
1IDU0000F`0CUAh01IDJ00FE600>U@X01IDU0000GP0@UAh01IDJ00FE6P0?U@L01IDU0000H00>UAh0
1IDJ00FE700?U@D01IDU0000HP0<UAh01IDJ00FE7P0?U@<01YDT0000I00:UAh01IDJ00FE800?U@03
09FE00BE900006L01iDN00FE6P06UB4059DT0000J@05UAh01IDJ00RE8P0AUB@0002<00FE6P0;UB40
3iDT0000S005UAX03IDQ00fE900008`01IDJ00nE8@0;UB@0002<00FE700?UB402IDT0000S005UAh0
49DP00NE900008`01IDQ00nE8005UB@0002<00FE8`0?UDL0002<00FE9@0?UDD0002<00FE9`0?UD<0
002<00FE:P0?UD00002<00FE;00?UCh0002<00FE;P0>UCd0002<00FE<00<UCd0002<00FE<P0:UCd0
002<00FE=@07UCd0002<00FE=`05UCd0002<00FE=`05UCd0002<00FE=`05UCd0002<00FE=`06UC`0
002<00FE=`06UC`0002<00FE=`06UC`0002<00FE=`06UC`0002<00FE>005UC`0002<00FE6`06UAL0
1IDl0000S005UA/02IDD00FE?00008`01IDK00^E4P05UC`0002<00FE6`0>U@l01IDl0000S005UA/0
49D=00FE?00008`01IDK01>E2P05UC`0002<00FE6`0EU@P01IDl0000S005UA/01ID2016E1@06UC/0
002<00FE6`05U@D049D300JE>`0008`01IDK00FE1`0GUC/0002<00FE6`05U@X059Dk0000S005UA/0
1ID<01:E>`0008`01IDK00FE3`0?UC/0002<00JE6P05UA403IDk0000S009UAL01YDC00ZE>`0008`0
2iDE00JE5@08UC/0002<00jE4P06UAP01IDk0000S00@UA001YEH0000SP0AU@h01IEH0000T@0AU@/0
1IEH0000T`0AU@T01IEH0000UP0AU@H01IEH0000V00AU@@01IEH0000V`0AU@0309FE00>EF00009h0
59EH0000X00BUEP0002S00nEF0000:D03IEH0000Z00:UEP0002Z00REF0000:d01IEH0000o`0;0000
o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000
o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000
o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000
o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000MP04o`<01?l0103oo`02o`800_l300?o
N@0007D000Go0000o`020003o`0000<000Co003o0`02o`@000?o0000N00007D000?o0?l00_l200Go
00D0o`00o`090003o`0007P0001e0003o`0000@000Oo0000o`3o008000?o00001`000ol0001h0000
M@001Ol0003o00<00ol00`3oo`03o`T000?o0000N00007H01?lD00;oNP000?l02`000?l02`000001
\
\>"],
  ImageRangeCache->{{{0, 265}, {265, 0}} -> {0.239995, -0.0250052, 0.00178971,
   0.00408685}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.498191 2.097 0.0245059 0.980236 [
[(Gen.2)] .5 1 0 -1.5 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.2)] .5 1 0 -1.5 Mshowa
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87882 .61174 m
.78846 .56381 L
s
P
p
.2 1 0 r
.02 w
.88591 .6918 m
.87882 .61174 L
s
P
p
.2 1 0 r
.02 w
.7834 .48613 m
.69015 .43471 L
s
P
p
.2 1 0 r
.02 w
.78846 .56381 m
.7834 .48613 L
s
P
p
.2 1 0 r
.02 w
.79374 .64494 m
.88591 .6918 L
s
P
p
.2 1 0 r
.02 w
.69015 .43471 m
.69327 .51333 L
s
P
p
.2 1 0 r
.02 w
.59099 .30448 m
.48962 .24655 L
s
P
p
.2 1 0 r
.02 w
.5919 .38054 m
.59099 .30448 L
s
P
p
.2 1 0 r
.02 w
.69652 .59553 m
.79374 .64494 L
s
P
p
.2 1 0 r
.02 w
.69327 .51333 m
.59285 .46007 L
s
P
p
.2 1 0 r
.02 w
.59285 .46007 m
.5919 .38054 L
s
P
p
.2 1 0 r
.02 w
.48962 .24655 m
.48822 .32337 L
s
P
p
.2 1 0 r
.02 w
.79926 .72975 m
.69993 .68156 L
s
P
p
.2 1 0 r
.02 w
.80503 .8185 m
.79926 .72975 L
s
P
p
.2 1 0 r
.02 w
.69993 .68156 m
.69652 .59553 L
s
P
p
.2 1 0 r
.02 w
.48822 .32337 m
.37867 .26297 L
s
P
p
.2 1 0 r
.02 w
.7035 .77169 m
.80503 .8185 L
s
P
p
0 .4 1 r
.02 w
.61366 .54042 m
.50545 .48504 L
s
P
p
.2 1 0 r
.02 w
.48676 .40381 m
.48523 .48812 L
s
P
p
.2 1 0 r
.02 w
.37451 .34428 m
.48676 .40381 L
s
P
p
0 .4 1 r
.02 w
.5065 .40067 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.50545 .48504 m
.5065 .40067 L
s
P
p
.01 w
.37867 .26297 Mdot
P
p
.2 1 0 r
.02 w
.37867 .26297 m
.37451 .34428 L
s
P
p
.01 w
.39834 .2596 Mdot
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.39834 .2596 L
s
P
p
.2 1 0 r
.02 w
.70724 .86623 m
.7035 .77169 L
s
P
p
.2 1 0 r
.02 w
.59489 .63059 m
.59598 .72212 L
s
P
p
.2 1 0 r
.02 w
.48363 .5766 m
.59489 .63059 L
s
P
p
.2 1 0 r
.02 w
.48523 .48812 m
.37015 .42962 L
s
P
p
0 .4 1 r
.02 w
.50434 .57358 m
.50545 .48504 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.2761 .27766 L
s
P
p
.2 1 0 r
.02 w
.59713 .81827 m
.70724 .86623 L
s
P
p
.2 1 0 r
.02 w
.59598 .72212 m
.59713 .81827 L
s
P
p
.2 1 0 r
.02 w
.48194 .66955 m
.48363 .5766 L
s
P
p
0 .4 1 r
.02 w
.38672 .51611 m
.50434 .57358 L
s
P
p
.2 1 0 r
.02 w
.37015 .42962 m
.24801 .36753 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.26907 .36406 L
s
P
p
.2 1 0 r
.02 w
.36075 .61368 m
.48194 .66955 L
s
P
p
.2 1 0 r
.02 w
.36557 .51931 m
.36075 .61368 L
s
P
p
.2 1 0 r
.02 w
.24008 .45841 m
.36557 .51931 L
s
P
p
0 .4 1 r
.02 w
.38244 .61055 m
.38672 .51611 L
s
P
p
0 .4 1 r
.02 w
.26168 .45501 m
.38672 .51611 L
s
P
p
.2 1 0 r
.02 w
.24801 .36753 m
.24008 .45841 L
s
P
p
0 .4 1 r
.02 w
.26907 .36406 m
.26168 .45501 L
s
P
p
0 .4 1 r
.02 w
.13964 .29782 m
.26907 .36406 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{266, 266},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004:00012PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`0007l01YF50000O`08UH<0001o00ZE
P@0006P01LHB00bEO`0006<01ID5aQ803IEn0000H`05U@G64P0?UG`0001S00FE1LHB016ENP0006<0
1ID5aP:E4005U@0309FE00^EN00004T01/HD00FE1LH3U@l01ID300fEMP0004T02<HB00FE1LH5U@d0
1ID400jEM00004T02/H@00FE1LH7U@/01ID600jELP0004T03<H>00FE1LH9U@T01ID800fEL@0004T0
3LH=00FE1LH;U@L01ID:00fEK`0002L01/HL00o62`05U@G63ID500FE300=UFd0000W00S66P0AaPT0
19D6aP0309FE00bE0`05U@h039E/00009`0:aQP01LH00`36aP0;aPH01ID6aP<03ID200FE400:UF`0
000W00c65P05aP<03LH400FE1/H501:E4@09UF`0000W00k65005aP@03/H200FE1/H7012E4`07UF`0
000Y00k64P05aPH03/H5U@G62P0>UAD01IE/0000:`0>aPl01/H800k60iD5aP`039DE00FEK00002d0
3/H=00K62P0=aP:E1LH=00^E5@05UF`0000_00o62P06aP`04/H?00VE5@05UF`0000a00o62006aPh0
4<HA00NE5@05UF`0000c00o61P05aQ403/HC00FE5@05UF`0000e00o61005aQ<03LH/00FEK00003L0
3lH200G6500>aRX01IE/0000>P0CaQD000>Ea/H03<HX00FEK00003`04LHE00>E3/HV00FEK00003h0
3lHE00FE3/HT00FEK00004003LHG00FE3/HR00FEK00004802lHI00FE3/HP00FEK00004800YD9aQ/0
1ID>aQh01IE/0000@P04U@O67@05U@g67@05UF`0001200JE1LH00iD0000L00FE3LHK00FEK0000480
1YD5aP>E7P05U@g66@05UF`0001200JE1LH5UAh01ID=aQL01IE/0000@P05U@K61iDN00FE3LHE00FE
K00004401YD6aPVE7@05U@k64`05UF`0001100JE1/H:UAh01ID>aQ401IE/0000@@06U@K639DN00FE
3LH@00FEK00004401YD5aP803IDN00FE2lH@00FEK00004401ID00`36aP03aP@03IDN00FE2LH@00FE
K00004401ID00`36aP03aPH03IDN00FE1lH@00FEK00004401ID00`36aP03aPL03YDN00FE1LH@00FE
K00004401ID00`36aP03aPT03YDL00FE1LH@00FEK00004401ID00`36aP03aP/03YDJ00FE1LH@00FE
K00004401ID00`36aP03aPd03YDH00FE1LH@00FEK00004401ID6aPl03YDF00FE1LH@00FE5006UE80
001000JE1/HA00jE5005U@G64005UA@029E@0000@006U@K64`0>UA801ID5aQ001IDD00ZECP000400
1YD6aQD03YD@00BE1/H@00FE500;UDd0001000JE1LHH00jE3@05U@K64005UA@03IE;0000@005U@03
0<K600C66@0>U@/01ID6aQ001IDD00nEB@0004001YD8aQT03YD900FE1/H@00FE500AUDL0001000JE
2/HI00fE2005U@G64@06UA<01ID00`2EU@0;UDD0001000JE3<HI00fE1P05U@G64@08UA401ID200jE
@`0004001YD>aQT03ID400FE1LHA00ZE3`05U@@03YE10000@008U@k66@0=U@801ID5aQ4039D=00FE
1P0=UD00001200RE3/HI01:E1LHA00jE2`06U@L03IDn0000A008U@k6600AU@G64`0>U@T01YD900fE
?00004H029D=aQT03iD6aQ@03YD700JE2`0<UC/0001800RE3LHI00fE2<HD00jE1@06U@d02YDk0000
BP08U@g66@0;U@[6500>U@@01ID>00VE>`0004`029D=aQT02ID<aQ@03YD200FE4007UC/0001>00RE
3LHI00NE3/HD01>E4P05UC/0001@00NE3/HI00FE4<HD016E4P05UC/0001B00NE3/HL01;6500?UA80
1IDk0000E007U@k66P05aP030<K600c6500=UA801IDk0000EP07U@k66005aP<03/HD00^E4P05UC/0
001H00NE3/HF00G61@0>aQ@02IDB00FE>`0005X01iD>aQ@01LH700k65007UA801IDk0000G007U@o6
4@05aPT03/HD00FE4P06UCX0001N00NE3lH?00G62`0>aRT01YDj0000H005UA763@05aPd03/HW00JE
>P0006001IDCaP/01LH?00g69P06UCX0001P00FE1LH00`36aP0=aPT01LHA00_69`05UCX0001P00FE
1LH400k61`05aQ<02LHW00FE>P0006001ID5aPH03/H500G65@07aRL01IDj0000H005U@G6200?aP80
1LHG00G69`05UCX0001P00FE1LH:01C6@`05UCX0001P00FE1LH<01;6@`06UCT0001O00FE1/H>0136
@`08UCL0001O00FE1/H@00k6@`0:UCD0001O00FE1/HC00_6@`0<UC<0001O00FE1/HD0003ULK600O6
@`0>UC40001O00FE1LHE00>E1lI500jE;`0005l01ID5aQD01ID5aP:EA@0=UBh0001O00FE1LHE00jE
A@0=UB`0001O00FE1LHE012E9P06UAT03IDZ0000G`05U@G65@0BUB@029DI00fE:00005l01ID5aQD0
1ID00`2EU@0<UB802YDI00fE9P0005l01ID5aQD01ID300jE800<UAP03YDT0000G`05U@G65@05U@D0
3YDN00jE600=UB<0001O00FE1LHE00FE1`0>UA`049DH00^E8`0005l01ID5aQD01ID900jE6P0BUAP0
2IDS0000G`05U@G60YDC00FE2`0>UAP01ID00`2EU@0<UAP01iDS0000G`05U@G619D@00JE3@0>UAH0
1ID300jE6005UB<0001Q00jE3P06U@l03IDE00FE1@0>UAH01IDS0000H`0>U@`01YDA00^E5@05U@L0
3YDD00FE8`0006D03YD:00JE4`09UAD01ID900jE4P05UB<0001W00jE2005UAH01iDE00FE2`0>UA00
1IDS0000J@0>U@H01IDH00FE5@05U@d03YD>00FE8`0006/03YD400FE6005UAD01ID?00jE3005UB<0
001]00jE0P05UAP01IDE00FE4@0>U@X01YDR0000K`0CUAP01IDE00FE4`0>U@P01YDR0000L@0AUAP0
1IDE00FE5@0>U@H01YDR0000L`0?UAP01IDE00FE5`0=U@D01YDR0000M@0=UAP01IDE00FE6@0=U@@0
1IDR0000M`0;UAP01IDE00FE6`0=U@801IDR0000N@09UAP01IDE00FE7@0BUB80001k00NE6005UAD0
1YDN012E8P0007d01IDH00FE5@08UAd03iDR0000VP05UAD02YDM00fE8P0009X01IDE00fE700;UB80
002J00FE5@0?UA`02IDR0000VP05UAL03iDL00NE8P0009X01IDI00nE7005UB80002J00FE6`0?UD40
002J00FE7P0>UCl0002J00FE800?UC`0002J00FE8P0?UCX0002J00FE900?UCP0002J00FE9P0>UCL0
002J00FE:00<UCL0002J00FE:`09UCL0002J00FE;@07UCL0002J00FE;`05UCL0002J00FE;`05UCL0
002J00FE;`05UCL0002J00FE;`05UCL0002J00FE;`05UCL0002J00FE;`05UCL0002J00FE5P06UA<0
1IDg0000VP06UAD029DA00FE=`0009X01YDE00ZE3`06UCH0002J00JE5@0=U@`01YDf0000VP06UAD0
3iD:00JE=P0009/01IDE016E2006UCH0002K00FE5@0CU@L01IDf0000V`05UAD01ID00`2EU@0=U@D0
1IDf0000V`05UAD01ID400jE0`05UCH0002K00FE5@05U@H059Df0000V`05UAD01ID801:E=P0009/0
1IDE00FE2P0@UCH0002K00JE5005U@`03YDf0000V`08UA801YD=00bE=P0009/02iD?00JE4009UCH0
002K00fE3@06UA801iDf0000V`0?U@/01YDD00FE=P0009d03iD:00FEC`0009l049D700FEC`000:80
3iD500FEC`000:@03iD300FEC`000:H03iD00`2EU@03UDl0002X01>EC`000:/049E?0000[@0>UDl0
002_00bEC`000;402YE?0000]007UDl0002f00FEC`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`0007H01?l300Co00@0ool00_l200;o0`04ogP0001e0005o`000?l00P000ol000030004
o`00o`<00_l40003o`0007P0001e0003o`3o00;o0P05o`050?l00?l02P000ol0001g0000M@000ol0
00040007o`000?l0o`020003o`0000T000?o0000MP0007D000Go0000o`0300?o00<0ool00ol80004
o`00ogP0001f00Co5@02ogT0003o00/0003o00/00000\
\>"],
  ImageRangeCache->{{{0, 265}, {265, 0}} -> {0.225767, -0.0250051, 0.00188862,
   0.00404029}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.564051 2.22952 0.0242196 0.968782 [
[(Gen.3)] .5 1 0 -1.5 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.3)] .5 1 0 -1.5 Mshowa
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.86973 .53081 m
.80222 .49625 L
s
P
p
.2 1 0 r
.02 w
.87496 .58531 m
.86973 .53081 L
s
P
p
.2 1 0 r
.02 w
.79815 .44302 m
.729 .40661 L
s
P
p
.2 1 0 r
.02 w
.80222 .49625 m
.79815 .44302 L
s
P
p
.2 1 0 r
.02 w
.80642 .55127 m
.87496 .58531 L
s
P
p
.2 1 0 r
.02 w
.729 .40661 m
.73199 .46031 L
s
P
p
.2 1 0 r
.02 w
.65529 .31637 m
.58161 .27653 L
s
P
p
.2 1 0 r
.02 w
.65705 .36873 m
.65529 .31637 L
s
P
p
.2 1 0 r
.02 w
.73508 .51583 m
.80642 .55127 L
s
P
p
.2 1 0 r
.02 w
.73199 .46031 m
.65887 .42288 L
s
P
p
.2 1 0 r
.02 w
.65887 .42288 m
.65705 .36873 L
s
P
p
.2 1 0 r
.02 w
.58161 .27653 m
.58214 .32929 L
s
P
p
.2 1 0 r
.02 w
.81077 .60816 m
.73828 .57329 L
s
P
p
.2 1 0 r
.02 w
.81527 .66701 m
.81077 .60816 L
s
P
p
.2 1 0 r
.02 w
.73828 .57329 m
.73508 .51583 L
s
P
p
.2 1 0 r
.02 w
.58214 .32929 m
.50408 .28819 L
s
P
p
.2 1 0 r
.02 w
.74159 .63278 m
.81527 .66701 L
s
P
p
.2 1 0 r
.02 w
.58269 .38389 m
.58326 .44043 L
s
P
p
.2 1 0 r
.02 w
.50325 .34322 m
.58269 .38389 L
s
P
p
0 .4 1 r
.02 w
.59723 .38173 m
.59806 .4383 L
s
P
p
0 .4 1 r
.02 w
.518 .34097 m
.59723 .38173 L
s
P
p
.01 w
.50408 .28819 Mdot
P
p
.2 1 0 r
.02 w
.50408 .28819 m
.50325 .34322 L
s
P
p
.01 w
.51858 .28591 Mdot
P
p
0 .4 1 r
.02 w
.51858 .28591 m
.518 .34097 L
s
P
p
.2 1 0 r
.02 w
.74502 .6944 m
.74159 .63278 L
s
P
p
.2 1 0 r
.02 w
.66271 .53694 m
.66473 .59706 L
s
P
p
.2 1 0 r
.02 w
.58385 .49902 m
.66271 .53694 L
s
P
p
.2 1 0 r
.02 w
.58326 .44043 m
.50239 .40026 L
s
P
p
0 .4 1 r
.02 w
.59806 .4383 m
.51741 .39803 L
s
P
p
.2 1 0 r
.02 w
.66682 .65939 m
.74502 .6944 L
s
P
p
.2 1 0 r
.02 w
.66473 .59706 m
.66682 .65939 L
s
P
p
.2 1 0 r
.02 w
.58446 .55976 m
.58385 .49902 L
s
P
p
.2 1 0 r
.02 w
.50239 .40026 m
.4179 .3583 L
s
P
p
0 .4 1 r
.02 w
.51741 .39803 m
.43316 .35597 L
s
P
p
.2 1 0 r
.02 w
.50056 .52078 m
.58446 .55976 L
s
P
p
.2 1 0 r
.02 w
.50149 .4594 m
.50056 .52078 L
s
P
p
.2 1 0 r
.02 w
.41539 .41799 m
.50149 .4594 L
s
P
p
0 .4 1 r
.02 w
.51679 .45721 m
.51615 .51862 L
s
P
p
0 .4 1 r
.02 w
.43093 .41569 m
.51679 .45721 L
s
P
p
.2 1 0 r
.02 w
.4179 .3583 m
.41539 .41799 L
s
P
p
0 .4 1 r
.02 w
.43316 .35597 m
.43093 .41569 L
s
P
p
0 .4 1 r
.02 w
.51615 .51862 m
.42862 .47773 L
s
P
p
0 .4 1 r
.02 w
.42862 .47773 m
.33693 .43489 L
s
P
p
0 .4 1 r
.02 w
.42621 .5422 m
.42371 .60927 L
s
P
p
0 .4 1 r
.02 w
.33262 .50007 m
.42621 .5422 L
s
P
p
0 .4 1 r
.02 w
.33693 .43489 m
.33262 .50007 L
s
P
p
0 .4 1 r
.02 w
.42371 .60927 m
.32813 .56792 L
s
P
p
0 .4 1 r
.02 w
.32813 .56792 m
.2277 .52448 L
s
P
p
0 .4 1 r
.02 w
.32345 .63863 m
.31857 .71238 L
s
P
p
0 .4 1 r
.02 w
.22074 .59608 m
.32345 .63863 L
s
P
p
0 .4 1 r
.02 w
.2277 .52448 m
.22074 .59608 L
s
P
p
0 .4 1 r
.02 w
.31857 .71238 m
.21346 .67084 L
s
P
p
0 .4 1 r
.02 w
.21346 .67084 m
.10265 .62705 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{266, 266},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004:00012PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`0009L01YE]0000U`08UF/0002G00ZEJ@0008<019D5aP/02iEX0000
P`04U@G62`0=UFH0002300BE1LH00iD0000800nEI00008<019D5aP:E2@0AUF80002300BE1LH4U@L0
1ID00`2EU@0;UF00002300BE1LH6U@D01ID200fEG`0008<019D5aPRE0`05U@@03IEM0000P`04U@G6
2YD00`2EU@03U@H039EL0000P`04U@G649D800ZEG00008<019D5aQ2E2P08UE`0002300BE1LH200jE
2`07UE`0002300BE1LH400bE3@05UE`0002300BE1LH600ZE3@05UE`0002300BE1LH700VE3@05UE`0
002300BE1/H800NE3@05UE`0002300BE2<H800FE3@06UE/0002300BE2/HH00JEF`0007401/H<00BE
3<HF00JEF`0006d019D8aPX019D>aQ@01YEK0000K@04U@[62P04U@k64`05UE/0001]00BE3<H:00BE
3/HA00FEF`0006d019D>aPX019D>aPl01IEK0000K@04UA362P04U@k63@05UE/0001]00BE4LH;00BE
3/H;00FEF`0006d019D5aP03ULK600_62`04U@g62P05UE/0001]00BE1LH3U@g62`04U@_62P05UE/0
001]00BE1LH5U@g62`04U@W62P05UE/0001]00BE1LH00`2EU@04U@g62`04U@O62P05UE/0001]00BE
1LH300FE3/H;00BE1LH:00FEF`0006d019D5aPD01ID>aPT019D5aPX01IEK0000K@04U@G61`05U@k6
1`04U@G62P05U@d01YE80000K@04U@G62@05U@k61@04U@G62P05U@d029E60000K@04U@K62P05U@k6
0`04U@G62P05U@d02YE40000K@04U@S62P05U@o619D5aPX01ID=00bE@P0006d019D:aPX01ID?aP:E
1LH:00JE300>UD00001]00BE3<H:00FE5<H:00RE2P0?UCl0001]00BE3/H:00FE4/H:00ZE200AUCd0
001I00K63P06U@k62P05UA362P0<U@H01ID00`2EU@0;UC/0001I00S63P06U@g62`06U@g62P0>U@@0
1YD200fE>@0005T02/H>00JE3LH;00JE2lH<00fE0`06U@@039Dh0000F@0<aPh01YD=aP/01YD9aPh0
3ID00`2EU@04U@D02iDh0000F@0>aPh01YD=aP/01YD7aQ004YD700VE>00005T04LH=00JE3LH;00JE
1LHB012E2@07UCP0001I01?63P04U@g63005UAP03YD;00FE>00005T01LH00`36aP0=aPh019D;aRX0
3ID;00FE>00005T01LH300o63P04U@W6;00;U@/01IDh0000F006aPD03lH>00BE1lH^00VE2`05UCP0
001H00K6200>aPh019D5aS001iD;00JE=`0005P01/H:00k63004U@G6<P05U@/01YDg0000F006aP`0
3/H:00BE1LI200JE=`0005P01LH?00o61`04U@G6@P06UCL0001H00G64@0?aPD019D5aT<01IDg0000
F005aQ<03lH300BE1LI300FE=`0005P01LHE00o600<0UID00YD5aT<01YDf0000F006aQH03lH3U@G6
3006UC4029Dd0000F008aQL05<H<00RE;`0:UC80001H00_65P0BaP`02iD/00bE<00005P03LHF0136
300=UBX03YD^0000F00?aQH03/H<00nE5`06U@d03ID]0000FP0@aQD03<H<016E5@08U@d03ID[0000
?@06aQT04<HF00W6300CUA<02YD=00fE:@0003d02LHI00o65002U@O600>E00002@05U@803iD@00bE
3@0=UBL0000m00_66@0@aQ4019D5aP>E2@05U@@03iD>00jE3@0<UBH0000m00g66@0@aPl03YD700FE
1P0>U@d049D<00^E9P0003d04<HI00k6400?U@@01ID800bE3@0BU@`02IDV0000?00CaQT03<HB00nE
0P05U@X02YD=00FE00<0UID039D<00NE9P0003`05LHI00[6500DU@d01iD=00JE0P0>U@`01YDU0000
?006aP804<HI00O65P0BU@l01ID=00JE100>U@X01YDU0000?006aP@04<HI00G6600@U@l01ID=00JE
1P0>U@P01YDU0000?005aPP03lHG00G66`0=U@l01ID=00JE200?U@D01YDU0000?005aPX04<HD00G6
7@0;U@l01ID>00FE2P0?U@@01IDU0000?005aP`04<HB00G67`09U@l01YD=00FE300?U@801IDU0000
?005aPl04<H?00G68@07U@l01YD=00JE3@0DUBD0000l00G64@0@aPd01LHS00FE3`06U@d029D=01>E
900003/01/HC01362`05aSL01YD=00ZE3P0@UB@0000k00K65P0@aPP01LHh00FE3@0<U@h03YDT0000
>`06aQP04<H600G6>005U@d03YD>00bE900003/01/HK01360`05aSP01ID?00jE3P0:UB@0000k00K6
7@0@aP030<K600?6>005UA403YD?00NE900003/02LHL01C6>005UA<03YD?00FE900003/02lHM0176
>005UAD03YDf0000>`0=aQd03lHh00FE5`0=UCD0000k01367@0<aSP01IDI00^E=@0003d04<HM00[6
>005UA/02IDe0000@00?aQd02<Hh00FE7@07UCD0001201367@05aSP01IDO00FE=@0001h01/HP0136
F005UAl01YDd00007P09aR003lIF00FE3P06U@/01YDd00007P0;aR004<IC00FE3P08U@T01YDd0000
7P0>aQl03lIB00FE3P0:U@L01YDd00007P0@aR003<IB00FE3P0<U@H01IDd0000800AaQl02/IB00FE
3P0?U@<01IDd00008`0AaQh02<IB00FE3P0AU@0309FE00>E=00002D04LHO00G6DP05U@h069Dc0000
:00AaQ`01LIB00JE3@05U@0309FE012E<`0002X04LHJ00G6DP08U@/01ID3012E<`0002d04LHG00G6
DP0;U@P01YD500fE<`0003004<HE00G6DP0=U@H01YD700^E<`0003804LHB00G6DP0?U@@01YD900VE
<`0003D04LH>00K6E00?U@801YD;00NE<`0003L04LH<00K6EP0?U@0309FE00>E3@05UC<0000j0176
2@06aUT04YE50000?00AaPL01/IK012EA@0003l04LH400G6GP0>UDD00012017600<0a/H00lIP00bE
A@0004@05LIR00ZEA@0004L04/IU00NEA@0004T04<IW00FEA@0004`03LJa0000C`0:a[40001A00S6
/@0005@01LJa0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000
o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000
o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000
o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000
o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000
o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000
o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000
o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000o`0;0000MP04o`<01?l0103oo`02o`80
0_l300?oN@0007D000Go0000o`020003o`0000<000Co003o0`02o`H000?o0000MP0007D000?o0?l0
0_l200Go00D0o`00o`0;0003o`0007H0001e0003o`0000@000Oo0000o`3o008000?o00001`02ogT0
001e0005o`000?l00`03o`030?oo00?o2`000ol0001f0000MP04oa@00omi0000o`0;0000o`0;0000
\
\>"],
  ImageRangeCache->{{{0, 265}, {265, 0}} -> {0.241888, -0.0250052, 0.00177636,
   0.00408806}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[(Gen.33)] .5 1 0 -1.5 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.33)] .5 1 0 -1.5 Mshowa
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{266, 266},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004:00012PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`0006h01YFF0000KP08UI@0001^00ZETP0005<01/HE00bET00004d01YD8aQ<0
3IF?0000C@06U@[64@0?UHd0001=00JE3<H?016ER`0004d01YD=aPh01ID00`2EU@0;UHT0001=00JE
3lH<00FE0`0=UHL0001=00FE4/H:00FE100>UHD0001<00JE1/H00iG6aP0;aPP01ID600jEP`0004`0
1YD6aP>E3LH600FE200>UH40001<00JE1/H4U@k61005U@X03IF00000C006U@G61iD>aP801ID<00fE
OP0004`01ID00`36aP03aP801iD>aPFE3P0=UG`0001<00FE00<0a/H00lH400NE3/H3UA003IEj0000
C005U@030<K600?61P07U@g60YDB00bEN@0004`01ID00`36aP03aPP01iD=aQ<02iEi0000C005U@03
0<K600?62@08U@g64`09UGT0001<00FE00<0a/H00lH;00RE3LHC00NEN@0004`01ID6aPd029D=aQ<0
1IEi0000B`06U@K63`07U@k64@05UGT0001;00JE1/HA00NE3/H?00FEN@0004/01YD6aQ<01iD>aPd0
1IEi0000B`06U@K65@07U@k62`05UGT0001;00JE2<HE00FE0P0>aPT01IEi0000B`06U@[6700>aPL0
1IEi0000B`06U@c6700>aPD01IEi0000B`06U@k6700=aP@01IEi0000B`08U@k6700=aP801IEi0000
C@08U@k6700=aPFEN@0002@01YDU00RE3/HL00g60iEi00009008UBD029D>aQ`03LH00iD0001g0000
900:UBD029D=aQ`03/Ih0000900<UBD029D=aQ`03/If00008`0?UBD029D=aQ`03/Id00008`0AUBD0
29D=aQ`03LIc00008`0CUBD029D=aQ`02lIc00008`06U@0309FE00bE9@07U@k66P02U@W6L`0002<0
1ID400jE9@07U@k66004U@O6L`0002<01ID600nE9007U@k65P05U@030<K600?6L`0002801YD800nE
9007U@g65@05U@030<K600?6L`0002801YD:00nE9007U@_65@05U@030<K600?6L`0002801YD<00nE
9007U@W65@05U@030<K600?6L`0002801YD>00nE9007U@O65@05U@030<K600?6L`0002801IDB00jE
9007U@G65@05U@030<K600?6L`0002801IDD00jE9005U@G65@05U@030<K600?6L`0002801IDF00jE
8P05U@G65@05U@030<K600?6L`0002401YDH00jE0P06aQP01ID5aQD01ID00`36aP03aW<0000Q00JE
6P0>U@S65P05U@G65@05U@030<K600?6L`0002401YDL00bE2/HD00FE1LHE00FE00<0a/H00lIc0000
8@06UAh02YD=aQ401ID5aQD01ID00`36aP03aQL01/IF00008@05UB4029D?aPl01ID5aQD01ID00`36
aP03aQ801ID8aU@0000Q00FE8`06UA763@05U@G65@05U@030<K600?64P05U@[6DP0002001YDU00BE
4lH:00JE1LHE00FE00<0a/H00lHB00FE3<I@00008006UBL000>Ea/H01<H00iG6aP0=aPP01YD5aQD0
1ID00`36aP03aQ801ID>aTh0000P00JE:006aPBE3lH500JE1LHE00FE00<0a/H00lHB00FE4<I<0000
8008UBH01/H6U@o60`06U@G65@05U@030<K600C64@05UA;6BP0002002iDS00K629D?aP0309FE00>E
00<0a/H00lHE00JE2<H?00FE1LH00iG6aP0;aTT0000P00fE8@05aP<029D?aPBE00<0a/H00lHE00JE
2/H=00FE1LH3U@g6A`0002003iDO00G61@08U@o60YD00`36aP03aQD01YD<aP/01ID5aPFE3LI50000
8P0@UA`01LH700VE5<HE00JE3/H900FE1LH7U@g6@`0002@049DJ00G62P08UA;65@08U@k61`05U@K6
00<0UID01ID=aT40000W00nE6005aP`029D@aQL029D>aPD01ID6aP<01YD>aSl0000Y012E5@05aPh0
29D>aQT029D>aP<01ID6aP@01iD>aSd0000[012E4`05aQ0029D<aQ/029D=aP801ID6aPH01iD=aS`0
000^00nE4@05aQ802ID9aQd029D=aPFE00<0a/H00lH800NE2lHl0000<00?U@h01/HE00RE1lHO00RE
3LH3U@030<K600?62P07U@W6?000038049D;00K65`07U@030<K600?68@08U@g600>E0<H01<H<00NE
1lHl0000=@0?U@T01/HI00FE:@08UA;63P07U@G6?00003L03iD700K6B@07UA764005U@G6?00003T0
49D400G6B`08U@o64005U@G6?00003/049D200G6C@08U@g64005U@G6?00003h03YD00`36aP03aTl0
29D;aQ001ID5aS`0001000bE00<0a/H00lIA00RE2LH@00FE1LHl0000@P0:U@030<K600?6D`08U@O6
4005U@G6?00004D01iD00`36aP03aUD01iD00`36aP03aQ001ID6aS/0001700FE00<0a/H00lIG00FE
5P05U@K6>`0004L01ID00`36aP03aW801ID6aS/0001700FE1/Ib00FE1/Hk0000AP06U@K6LP06U@G6
>`0004H01YD6aW<01ID5aS/0001600JE1/Ic00FE1LHk0000AP06U@G6M005U@G6>`0004H01ID00`36
aP03aW@01ID5aS/0001600FE00<0a/H00lId00FE1LHk0000AP05U@030<K600?6M005U@G6>`0004H0
1ID00`36aP03aW@01ID5aS/0001600FE00<0a/H00lHP00K6CP05U@G6>`0004H01ID00`36aP03aQX0
1YD8aT`01ID5aP:E>@0004H01ID00`36aP03aQX01YD;aTT01ID5aPBE=`0004H01ID00`36aP03aQX0
1YD=aTT00iD5aPJE=@0004H01ID6aQX01YD?aTT000>Ea/H01<H7UC<0001500JE1/HJ00JE4LI800K6
2IDa0000A@06U@K66P06UA?6;006aQ@01/H;UBl0001500JE1/HJ00JE1LH2U@o68`06U@S64P06aPfE
;@0004D01YD5aQX01YD00`36aP03aPBE3lHQ00JE2/HA00G600<0UID039D[0000A@05U@030<K600?6
6P06U@030<K600?61YD?aQl01YD<aPl01LH300jE:@0004D01ID00`36aP04aQT01YD00`36aP03aPRE
3lHM00JE3/H=00G61@0>UBL0001500JE2<HG00JE00<0a/H00lH200RE3lHK00JE4<H;00G61`0=UBH0
001500JE2lHD00FE0P05aP@02ID?aQP01YDBaPT01LH900^E9P0004D01YD=aQ801ID200G61`08U@o6
5P06U@G600>Ea/H03<H700G62`09UBH0001500JE3lH@00FE00<0a/H01<H900RE3lHD00FE00<0a/H0
0lH3U@k61@05aPd01iDV0000A@08UA363@05U@030<K600C62`08U@k64`05U@030<K600?61ID>aP<0
1/H>00FE9P0004L029D@aP/01ID00`36aP04aPd029D<aQ<01ID00`36aP03aPNE3/H00`36aP04aPh0
1IDV0000B@09U@o62@05U@030<K600C63`09U@W64`05U@030<K600?60P07UA?63P06UBD0001<00RE
4<H600FE00<0a/H00lHC00RE1lHC00FE00<0a/H01<H300NE4LH>00JE9@0004h029D@aP@01ID00`36
aP03aQD01iD00`36aP03aQ<01YD6aPD01iD?aPh01YDU0000D009U@o60P05U@030<K600?65`05U@03
0<K600?64`06U@K61`07U@g63P06UBD0001B00VE4<H4U@030<K600?65`05U@030<K600?64`06U@K6
2@07U@_63`05UBD0001E00RE4<H2U@030<K600?65`05U@030<K600?64`06U@030<K600?63006U@W6
3`05UBD0001G00VE3lH00`36aP03aQL01ID00`36aP03aQ@01ID00`36aP03aPh01YD7aP03U@0000`0
1IDU0000F@09UA?65`05U@030<K600?65005U@030<K600?64006U@G60iD<00FE9@0005/02IDAaQL0
1ID00`36aP03aQ@01ID00`36aP03aQ803YD:00FE9@0005h02ID>aQL01ID00`36aP03aQ@01ID00`36
aP03aQ@03iD700FE9@0006002ID<aQL01ID00`36aP03aQ@01ID00`36aP03aQH03iD500FE9@000680
2ID:aQL01ID00`36aP03aQ@01ID00`36aP03aQP03iD300JE900006@02YD7aQL01ID00`36aP03aQ@0
1ID00`36aP04aQT03iD00`2EU@04UB@0001W00NE0P05aQL01ID00`36aP03aQ@01YD8aQT059DT0000
J@05UAh01ID00`36aP03aQ@01YD:aQX04IDT0000S005U@030<K600?65006U@c66P0?UB@0002<00FE
00<0a/H00lHD00JE3/HJ00fE900008`01ID00`36aP03aQ@029D>aQX02iDT0000S005U@030<K600?6
5P08U@k66P09UB@0002<00FE00<0a/H00lHH00RE3lHI00NE900008`01ID00`36aP03aQ/01iD?aQT0
1IDT0000S005U@030<K600?67@07U@o6@00008`01ID00`36aP03aQl01iD?aSh0002<00FE00<0a/H0
0lHQ00NE3lHl0000S005U@030<K600C68`07U@k6>P0008`01ID00`36aP07aR801iD>aSP0002<00FE
00<0a/H02LHR00NE3LHg0000S005U@030<K600c68@07U@_6=`0008`01ID00`36aP0>aR401iD9aSL0
002<00FE0`0AaR401YD7aSL0002<00FE1P0@aR401ID00`36aP03aSL0002<00FE200@aQl01ID00`36
aP03aSL0002<00FE2`0@aQ`01ID00`36aP03aSL0002<00FE3@0@aQX01YD5aSL0002<00FE400@aQL0
1YD5aSL0002<00FE4P0@aQD01YD5aSL0002<00FE500AaQ801YD5aSL0002<00FE5`0@aQ401ID5aSL0
002<00FE6@0@aPl01ID5aSL0002<00FE6`000iG6aP0>aP`01ID6aSH0002<00FE6`03UA362P05U@K6
=P0008`01IDK00JE3lH800FE1/Hf0000S005UA/029D?aPH01ID6aSH0002<00FE6`0:UA360`05U@03
0<K600?6=P0008`01IDK00fE3lH00`2EU@03U@030<K600?6=P0008`01IDK00FE0P08U@o61ID5aSH0
002<00FE6`05U@D01iD?aP>E1LHf0000S005UA/01ID700NE3lH00iG6aP03aSH0002<00FE6`05U@X0
1iDBaSH0002<00FE6`05U@`01iD@aSH0002<00FE6`05U@l01YD>aSH0002<00JE6P05UA401YD<aSH0
002<00VE5`06UA<01ID:aSH0002<00^E5@06UAD01YD7aSH0002<00jE4P06UAP01ID5aSH0002<012E
4006UEP0002>016E3P05UEP0002A016E2`05UEP0002C016E2@05UEP0002F016E1P05UEP0002H016E
1005UEP0002K016E00<0UID00iEH0000WP0DUEP0002P01:EF0000:<03iEH0000Y@0=UEP0002X00ZE
F0000:X029EH0000[@05UEP0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0
003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0
003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0
003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0
001c00Co0`04o`040?oo00;o0P02o`<00ol300?oMP00078000Go0000o`020003o`0000<000Co003o
0`02o`H000?o00000`000ol0001c0000LP000ol0o`02o`801Ol01@3o003o00/000?o00000`000ol0
001c0000LP000ol000040007o`000?l0o`020003o`0000L00_l400;oMP00078000Go0000o`0300?o
00<0ool00ol;0003o`0000<000?o0000L`0007<01?lD00?o0`03ogH0003o00/0003o00/00000\
\>"],
  ImageRangeCache->{{{0, 265}, {265, 0}} -> {0.239995, -0.0250052, 0.00178971,
   0.00408685}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[(Gen.76)] .5 1 0 -1.5 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.76)] .5 1 0 -1.5 Mshowa
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.7867 .53145 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.89777 .66825 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56304 .80672 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.15169 .31032 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.139 .40899 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{266, 266},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004:00012PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l02`000?l0
2`000?l02`0007@01/J@0000KP06U@S6SP0006h01YD9aXd0001^00JE2lJ;0000D`06aQD01YD=aXT0
001=00JE2<HC00JE3/J80000C@06U@[64@06UA36QP0004d01YD<aPl01YDBaX@0001=00JE3LH>00FE
00<0a/H00lH2U@g6PP0004d01YD?aP`01ID00`36aP03aPBE3<J10000C@05UA;62P05U@030<K600?6
1ID=aWl0001<00JE1/H00iG6aP0;aPP01ID6aPNE3LIm0000C006U@K60iD=aPH01ID6aP801iD<aW`0
001<00JE1/H4U@k61005U@K61007U@c6NP0004`01YD5aPNE3/H200FE1/H600JE3LIh0000C005U@03
0<K600?60P07U@k61ID5aPT01YD<aWL0001<00FE00<0a/H00lH400NE3/H3U@G62`06U@c6M@0004`0
1ID00`36aP03aPH01iD=aP:E1LH=00FE3<Id0000C005U@030<K600?62007UA;63P06U@[6M00004`0
1ID00`36aP03aPT029D@aQ001YD8aW@0001<00FE00<0a/H00lH;00RE3/HB00FE1lId0000C005U@K6
3@08U@c65005U@G6M00004/01YD6aPl01iD;aQ@01ID5aW@0001;00JE1/HA00NE2LHD00FE1LId0000
B`06U@K64`07U@O65005U@G6M00004/01YD6aQD01iD5aQ@01ID5aW@0001;00JE2<HE00FE6@05U@G6
M00004/01YD:aS401ID5aW@0001;00JE3<H_00FE1/Ic0000B`06U@k6;@05U@K6L`0004/029D>aR/0
1ID6aW<0000Z00K67@08U@k6:@05U@K6L`0002@01YD8aQd029D>aRL01ID00`36aP03aW<0000T00JE
2/HM00RE3/HU00FE00<0a/H00lIc00009006U@c67@08U@g69005U@030<K600?6L`0002@01YD>aQd0
29D=aR801ID00`36aP03aW<0000S00JE4LHM00RE3LHP00FE00<0a/H00lIc00008`06UA?67@08U@g6
7P05U@030<K600?6L`0002<01YD6aP03ULK600c67@08U@g67005U@030<K600?6L`0002<01YD6aP>E
3/HM00NE3/HJ00FE00<0a/H00lIc00008`05U@030<K600?61YD?aQ`01iD>aQP01ID00`36aP03aW<0
000S00FE00<0a/H00lH8U@o67007U@k65P05U@030<K600?6L`0002801YD00`36aP03aP8029D?aQ`0
1iD=aQD01ID00`36aP03aW<0000R00JE00<0a/H00lH400RE3lHL00NE2lHE00FE00<0a/H00lIc0000
8P06U@K61P08U@o67007U@W65@05U@030<K600?6L`0002801YD6aPP02ID>aQ`01iD7aQD01ID00`36
aP03aW<0000R00FE00<0a/H01<H;00RE3/HL00NE1LHE00FE00<0a/H00lIc00008P05U@030<K600C6
3@08U@k67005U@G65@05U@030<K600?6L`0002801ID00`36aP03aQ0029D>aQX01ID5aQD01ID00`36
aP03aW<0000Q00JE00<0a/H00lHB00RE3/HH00FE1LHE00FE00<0a/H00lIc00008@06U@030<K600?6
5008U@k65P05U@G65@05U@030<K600?6L`0002401YD00`36aP03aQH029D>aQ@01ID5aQD01ID00`36
aP03aW<0000Q00JE00<0a/H00lHH00RE3lHA00FE1LHE00FE00<0a/H00lHG00K6EP0002401ID00`36
aP04aQX029D?aPl01ID5aQD01ID00`36aP03aQ801ID8aU@0000Q00FE00<0a/H01<HL00RE3lH=00FE
1LHE00FE00<0a/H00lHB00FE2/IB00008006U@030<K600C67P08U@o62P06U@G65@05U@030<K600?6
4P05U@c6D00002001YD00`36aP04aR0029D?aPP01YD5aQD01ID00`36aP03aQ801ID>aTh0000P00JE
00<0a/H01/HP00VE3lH500JE1LHE00FE00<0a/H00lHB00FE4<I<00008007U@_68008U@o60`06U@G6
5@05U@030<K600C64@05UA;6BP0002001iD=aR0029D?aP0309FE00>E00<0a/H00lHE00JE2<H?00FE
1LH00iG6aP0;aTT0000P00NE3lHP00RE3lH4U@030<K600?65@06U@[63@05U@G60iD=aTL0000P00VE
3lHP00RE3lH2U@030<K600?65@06U@c62`05U@G61ID=aTD0000R00VE4<HO00VE5<HE00JE3/H900FE
1LH7U@g6@`0002@02YD?aR0029DBaQD029D>aPL01ID6aP0309FE00FE3LI100009`09U@o68008UA36
5`08U@k61@05U@K60`06U@k6?`0002T02ID?aR0029D>aQT029D>aP<01ID6aP@01iD>aSd0000[00VE
3lHP00RE3<HK00RE3LH200FE1/H600NE3LHl0000;P09U@o67`09U@W67@08U@g61ID00`36aP03aPP0
1iD;aS`0000`00VE3lHP00RE1lHO00RE3LH3U@030<K600?62P07U@W6?00003802ID?aR001iD00`36
aP03aR4029D=aP03U@3600C63007U@O6?00003D029D?aR001IDY00RE4/H>00NE1LHl0000=`08UA36
C@07UA764005U@G6?00003T02ID?aT`029D?aQ001ID5aS`0000k00VE3/I=00RE3LH@00FE1LHl0000
?P08U@c6C`08U@_64005U@G6?000040029D:aU4029D9aQ001ID5aS`0001200VE1lIC00RE1lH@00FE
1LHl0000A@07U@030<K600?6E@07U@030<K600?64005U@K6>`0004L01ID00`36aP03aUL01IDF00FE
1/Hk0000A`05U@030<K600?6LP05U@K6>`0004L01ID6aW801ID6aS/0001600JE1/Ib00JE1LHk0000
AP06U@K6L`05U@G6>`0004H01YD6aW<01ID5aS/0001600JE1LId00FE1LHk0000AP05U@030<K600?6
M005U@G6>`0004H01ID00`36aP03aW@01ID5aS/0001600FE00<0a/H00lId00FE1/Hj0000AP05U@03
0<K600?6M005U@S6>00004H01ID00`36aP03aR001/I>00FE2/Hf0000AP05U@030<K600?66P06U@S6
C005U@c6=00004H01ID00`36aP03aQX01YD;aTT01ID>aS80001600FE00<0a/H00lHJ00JE3LI900FE
3/H`0000AP05U@K66P06U@o6B@05U@k6;P0004D01YD6aQX01YDAaTT01ID>aR`0001500JE1/HJ00JE
4lH/00K65`05U@k6:P0004D01YD6aQX01YD5aP:E3lHS00JE2<HG00FE3/HX0000A@06U@G66P06U@03
0<K600?619D?aR401YD:aQL01ID>aRH0001500FE00<0a/H00lHJ00JE00<0a/H00lH6U@o67`06U@c6
5`05U@k6900004D01ID00`36aP04aQT01YD00`36aP03aPRE3lHM00JE3/HG00FE3/HR0000A@06U@S6
5`06U@030<K600?60P08U@o66`06UA365`05U@g68@0004D01YD;aQ@01ID200G61009U@o66006UA;6
5`05U@_68@0004D01YD=aQ801ID200G61`08U@o65P06U@G600>Ea/H03<HG00FE2LHQ0000A@06U@o6
4005U@030<K600C62@08U@o65005U@030<K600?60iD>aQL01ID7aR40001500RE4<H=00FE00<0a/H0
1<H;00RE3/HC00FE00<0a/H00lH5U@k65`05U@G68@0004L029D@aP/01ID00`36aP04aPd029D<aQ<0
1ID00`36aP03aPNE3/HE00FE1LHQ0000B@09U@o62@05U@030<K600C63`09U@W64`05U@030<K600?6
0P07U@k64`05U@K6800004`029D@aPH01ID00`36aP03aQ<029D7aQ<01ID00`36aP04aP<01iD>aQ40
1ID6aR00001>00RE4<H400FE00<0a/H00lHE00NE00<0a/H00lHC00JE1/H500NE3/H?00FE1/HP0000
D009U@o60P05U@030<K600?65`05U@030<K600?64`06U@K61`07U@k63@05U@K6800005802ID@aPBE
00<0a/H00lHG00FE00<0a/H00lHC00JE1/H900NE3/H<00FE1LHP0000E@08UA360YD00`36aP03aQL0
1ID00`36aP03aQ<01YD00`36aP03aP`01YD>aPX01ID5aR00001G00VE3lH00`36aP03aQL01ID00`36
aP03aQ@01ID00`36aP03aPh01YD?aPL01ID5aR00001I00VE4lHG00FE00<0a/H00lHD00FE00<0a/H0
0lH@00JE3lH500FE1LHP0000F`09UA765`05U@030<K600?65005U@030<K600?64P06U@o60`05U@G6
800005h02ID>aQL01ID00`36aP03aQ@01ID00`36aP03aQ@01YD?aP0309FE00>E1LHP0000H009U@c6
5`05U@030<K600?65005U@030<K600?65P06U@o619D5aR00001R00VE2/HG00FE00<0a/H00lHD00FE
00<0a/H00lHH00NE3/H2U@K67`0006@02YD7aQL01ID00`36aP03aQ@01ID00`36aP04aQT01iDDaQl0
001W00NE0P05aQL01ID00`36aP03aQ@01YD8aQT01iDBaQl0001Y00FE7P05U@030<K600?65006U@[6
6P06UA367`0008`01ID00`36aP03aQ@01YD<aQX01YD>aQl0002<00FE00<0a/H00lHD00JE3/HJ00JE
3<HO0000S005U@030<K600?65008U@k66P07U@W67`0008`01ID00`36aP03aQH029D>aQX01iD7aQl0
002<00FE00<0a/H00lHH00RE3lHI00NE1LHO0000S005U@030<K600?66`07U@o66@05UB@0002<00FE
00<0a/H00lHM00NE3lI00000S005U@030<K600?67`07U@o6?P0008`01ID00`36aP03aR401iD?aS`0
002<00FE00<0a/H00lHT00NE3/Hj0000S005U@030<K600?69P07U@k6>00008`01ID00`36aP03aRP0
1iD=aSL0002<00FE00<0a/H00lHZ00NE2lHg0000S005U@030<K600?6;007U@W6=`0008`01ID00`36
aP03aRl01YD7aSL0002<00FE00<0a/H00lHa00FE00<0a/H00lHg0000S005U@030<K600?6<@05U@03
0<K600?6=`0008`01ID00`36aP03aS401ID00`36aP03aSL0002<00FE00<0a/H00lHa00JE1LHg0000
S005U@030<K600?6<@06U@G6=`0008`01ID00`36aP03aS401YD5aSL0002<00FE00<0a/H00lHa00JE
1LHg0000S005U@030<K600?66`06aQ401ID5aSL0002<00FE00<0a/H00lHE00JE2<H?00FE1LHg0000
S005U@030<K600?65@06U@_63005U@K6=P0008`01ID00`36aP03aQD01YD=aPX01ID6aSH0002<00FE
00<0a/H00lHE00JE3lH800FE1/Hf0000S005U@030<K600?65@06UA761P05U@K6=P0008`01ID00`36
aP03aQD01YDDaP<01ID00`36aP03aSH0002<00FE00<0a/H00lHE00JE1LH2U@o600<0UID00iD00`36
aP03aSH0002<00FE00<0a/H00lHE00FE00<0a/H00lH4U@o61ID5aSH0002<00FE00<0a/H00lHE00FE
00<0a/H00lH6U@o60iD5aSH0002<00FE00<0a/H00lHE00FE00<0a/H00lH00`2EU@05U@o600>Ea/H0
0lHf0000S005U@030<K600?65@05U@030<K600?61007UA;6=P0008`01ID00`36aP03aQD01ID00`36
aP03aPH01iD@aSH0002<00FE00<0a/H01<HD00FE00<0a/H00lH900JE3/Hf0000S006U@W64@05U@03
0<K600C62P06U@c6=P0008`01YD;aPl01YD6aPd01ID:aSH0002<00JE3/H<00JE1/H?00JE1lHf0000
S006UA362P06U@K64P05U@G6=P0008`029DAaPL01YD00`36aP03aU80002>00VE4LH500FE00<0a/H0
0lIB0000T@08UA760`05U@030<K600?6DP0009<02IDAaPFE00<0a/H00lIB0000UP08UA760iD00`36
aP03aU80002H00VE4LH00`36aP03aU80002K00VE5<IB0000WP08UA;6DP000:002ID?aU80002S00RE
3LIB0000Y@09U@[6DP000:P029D8aU80002Z00RE00<0a/H00lIB0000[@05UEP0003o00/0003o00/0
003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0
003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0
003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0003o00/0
003o00/0003o00/0003o00/0003o00/0003o00/0001c00Co0`04o`040?oo00;o0P02o`@000?o0000
0`02ogH0001b0005o`000?l00P000ol000030004o`00o`<00_l40003o`00008000Co003oM@000780
00?o0?l00_l200Go00D0o`00o`0:0005o`000?l00P000ol0001c0000LP000ol000040007o`000?l0
o`020003o`0000P000Co00000omf0000LP001Ol0003o00<00ol00`3oo`03o`/000Co003oN00007<0
1?lD00Co0`03ogD0003o00/0003o00/00000\
\>"],
  ImageRangeCache->{{{0, 265}, {265, 0}} -> {0.239995, -0.0250052, 0.00178971,
   0.00408685}}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Histories of L-system evolutions"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"EvolutionSteps"],

Cell[CellGroupData[{

Cell["Utility functions and definitions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
getHistory[dir_,exp_,gen_,index_] :=
Module[{},
  
  Get[dir <> $PathnameSeparator <> \"Examples\" <>
      $PathnameSeparator <> exp <> 
      $PathnameSeparator <> exp <> \".\" <>
                   ToString[gen] <> \".hist\"][[index]]
                   
];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[
"champIndices =\nFlatten[\nMapThread[\n  (Position[\n    \
getFitnesses[$basicDirectory,\"Fractals-10-1\",#1//First],\n    #2\n  \
]//First)&,\n  {bestFitGens-1,{16,24,60,116,288}}\n],Infinity]"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
{11, 32, 29, 29, 10}\
\>", 
"\<\
{11, 32, 29, 29, 10}\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[TextData["The new champ indices are: {11}, {32,29,29,10}"], "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["bestFitGens"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
{{2}, {3}, {4}, {34}, {77}}\
\>", 
"\<\
{{2}, {3}, {4}, {34}, {77}}\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["getFitnesses[$basicDirectory,\"Fractals-10-1\",1]"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
{0, 12, 6, 6, 6, 0, 6, 2, 8, 0, 16, 0, 2, 2, 0, 0, 2, 4, 0, 0, 0, 0, 0, \
0, 
 
  0, 0, 6, 0, 16, 0, 0, 0, 0, 0, 0}\
\>", 
"\<\
{0, 12, 6, 6, 6, 0, 6, 2, 8, 0, 16, 0, 2, 2, 0, 0, 2, 4, 0, 0, 0, 0, 0, \
0, 
 
  0, 0, 6, 0, 16, 0, 0, 0, 0, 0, 0}\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"MapThread[\n  getHistory[$basicDirectory,\"Fractals-10-1\",#1,#2]&,\n  \
{Flatten[bestFitGens-1],champIndices}\n]"], "Input",
  AspectRatioFixed->True],

Cell[TextData["Part::partw: Part 11 of {} does not exist."], "Message",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
{{}[[11]], {CROSS, {18, 11}, {{2, 1, 4, 1, 1}, {2, 1, 4, 1}, 
 
    SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]]}}, 
 
  {CROSS, {1, 18}, {{2, 1, 4, 1}, {2, 1, 4, 1}, 
 
    SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
     SEQ[FO[1]], FO[1]], SEQ[FO[1], RR[90]]}}, 
 
  {PERM, 26, {{2, 1, 4, 1, 4}, SEQ[FO[1], FO[1], RL[90]], 
 
    SEQ[FO[1], RL[90], FO[1]], RotateLeft}}, 
 
  {MUTAT, 3, {{2, 1, 4, 1, 4}, SEQ[FO[1], RL[90], FO[1]], 
 
    SEQ[FO[1], SEQ[FO[1], RL[90]], SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]]]}}
 
   }\
\>", "\<\
{{}[[11]], {CROSS, {18, 11}, {{2, 1, 4, 1, 1}, {2, 1, 4, 1}, 
 
    SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]]}}, 
 
  {CROSS, {1, 18}, {{2, 1, 4, 1}, {2, 1, 4, 1}, 
 
    SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
     SEQ[FO[1]], FO[1]], SEQ[FO[1], RR[90]]}}, 
 
  {PERM, 26, {{2, 1, 4, 1, 4}, SEQ[FO[1], FO[1], RL[90]], 
 
    SEQ[FO[1], RL[90], FO[1]], RotateLeft}}, 
 
  {MUTAT, 3, {{2, 1, 4, 1, 4}, SEQ[FO[1], RL[90], FO[1]], 
 
    SEQ[FO[1], SEQ[FO[1], RL[90]], SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]]]}}
 
   }\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["bestFitGens-2"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
{{0}, {1}, {2}, {32}, {75}}\
\>", 
"\<\
{{0}, {1}, {2}, {32}, {75}}\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[TextData[
"ClearAll[showKoch];\nshowKoch[lsys_,gen_,indiv_,iter_:1] :=\nShow[\n    \
{turtleInterpretation[\n       Last[runKLSystem[lsys,iter]] /. \
interpretTable,\n       GraphicOptions -> {AspectRatio -> 1,\n                \
          Axes -> False,\n                          Boxed -> False,\n         \
                 PlotRange -> All,\n                          DisplayFunction \
-> Identity\n                         }\n       (* DefaultDrawColor -> 0.1 *)\
\n     ], kochGraphicMoved},\n     PlotLabel -> \"Gen.\" <> ToString[gen] <> \
\n                  \", Ind.\" <> ToString[indiv],\n     DisplayFunction -> \
$DisplayFunction\n   ]"], "Input",
  AspectRatioFixed->True],

Cell[TextData[
"The champs were generated in the following generations:\n{1), {2,3,33,76}\n\
Fitnesses are: {16}, {24,60,116,288}"], "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData["The new champ indices are: {11}, {32,29,29,10}"], "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[
"getFitnesses[$basicDirectory,\"Fractals-10-1\",76][[10]]"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
288\
\>", "\<\
288\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"Gen. 1, Crossover 18,11 --> new champ in gen 2"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[
"getExpression[$basicDirectory,\"Fractals-10-1\",1,18]\n\
getFitnesses[$basicDirectory,\"Fractals-10-1\",1][[18]]"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
  LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
    SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RL[90]]], SEQ[FO[1], RR[90]], 
 
     SEQ[FO[1], RL[90]]]]]]\
\>", 
"\<\
LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
  LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
    SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RL[90]]], SEQ[FO[1], RR[90]], 
 
     SEQ[FO[1], RL[90]]]]]]\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
4\
\>", "\<\
4\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"getExpression[$basicDirectory,\"Fractals-10-1\",1,11]\n\
getFitnesses[$basicDirectory,\"Fractals-10-1\",1][[11]]"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
  LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], SUCC[SEQ[FO[1], RR[90]]]]]]\
\>",
 "\<\
LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], \

 
  LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], SUCC[SEQ[FO[1], \
RR[90]]]]]]\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
16\
\>", "\<\
16\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(showKoch[getExpression[$basicDirectory, "\<Fractals-10-1\>", 1, 18], 
        1, 18];\)\[IndentingNewLine]\), "\[IndentingNewLine]", 
    \(\(showKoch[getExpression[$basicDirectory, "\<Fractals-10-1\>", 1, 11], 
        1, 11];\)\)}], "Input"],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[(Gen.1, Ind.18)] .5 1 0 -1.5 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.1, Ind.18)] .5 1 0 -1.5 Mshowa
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.43789 .35572 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.30551 .28903 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{169, 169},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002Y0000Z@P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:T0002Y0000Z@000:T0002Y0000Z@000:T0
002Y0000Z@000:T0002Y0000Z@000:T0002Y0000Z@000:T0002Y0000Z@000:T0002Y0000Z@000:T0
002Y0000Z@000:T0002Y0000Z@000:T0002Y0000Z@0004H019EO0000=@03aPh01YEM0000<P03U@?6
3P08UE/0000b00>E0lH>00ZEF@0003800iD3aP:E3003U@0309FE00NEEP0003800iD3aPBE2P03U@<0
2IED0000<P03U@?61YD800>E1@09UE80000b00>E0lH8U@H00iD800RED00003800YD4aP8029D400>E
2P08UDh0000a00>E1<H400RE0P03U@`01iE=0000<@03U@?61`0;U@h01IE=0000<@03U@?62@09UA00
0iE=0000<@03U@?62`07U@C63003UDd0000a00>E0lH=00FE1/H:00>EC@0003400iD4aPh00iD8aPP0
0iE=0000<@03U@K63`0:aPH00iE=0000<@03U@S63@03aP030<K600O60`03UDd0000a00FE2<H;00?6
0`09aP0409FEUDd0000I00BE5P05U@S62@03aPD02LH2UDd0000I00JE5P05U@S61`03aPP02<I=0000
6@08UAH01ID7aPH00lH:00S6B`0001T02YDF00FE1lH400?63007aTX0000H00BE00<0UID01YDF00FE
1lH200?63@000iG6aP03aTX0000H00BE0`08UAH019D;aPd00iD3aTX0000H00>E1P08UAH019D9aPd0
0iE=00006003U@P029DF00BE2<H<00>EC@0001P00iD:00RE5P04U@S62P03UDd0000G00BE3008UAH0
0iD00`36aP06aPP00iE=00005`04U@h029DD00>E00<0a/H02<H600>EC@0001L00iDA00RE1<H>00>E
00D0a/K60008aP@00iE=00005`03UA<01YD6aP`00iD01036a/H300O60`03UDd0000G00>E5@04U@S6
2P03U@040<K6aPD01lH0102EUID>00BE>`0001H019DG00BE2<H800>E00@0a/K61`07aP:E3P06UCT0
000F00BE6@04U@S61P03U@C62008aPh029Dg00005P04UA`00iD9aP<00iD4aPX02<H<00ZE=@0001H0
1iDK00>E2LH0102EUID3aPd01lH;00>E00<0UID01YDc00005P09UA/00iD9aP:E0lH>0003ULK600?6
2`03U@<01iDb00006009UA/019D;aPh00iD3aP:E2@03U@D01iD`00006`09UAX019D9aQ0000BEa/K6
19D700BE1P07UBh0000M00VE6`03U@O64@03aPJE1@04U@L029D/00007`0:UAX00iD5aQ400lH8U@@0
0iD900NE:`0002802IDJ00>E0lHA00?60P08U@800iD;00FE:`0002@02ID_00?6100;U@d00iD[0000
9`09UB`00lH600VE3@03UB/0000Y00RE:`03aPP01iD=00>E:`0002/01YD[00?62P05U@d00iD[0000
;P03UB/00lH<00>E3@03UB/0000^00>E:`03aQ`019DZ0000;P03UB/00lHL00BE:P0002h00iD[00?6
7@03UBX0000^00>E:`03aQd00iDZ0000;P03UD/00iDZ0000;P03UD/00iDZ0000;@04UD/019DY0000
;@04UA<019Dd00JE9`0002d00iDD00NE<@08UBD0000]00>E5009UC4029DS0000;@03UA@02iDa00RE
8@0002d00iDD00>E0P09UAT019DC00RE7`0002d00iDD00>E1009UAL01YDC00RE7@0002d019DC00>E
1P09UAD02IDB00RE6`0002d01YDA00>E2@09UA802iDB00NE6P0002d02ID>00>E2`09UA000iD00`2E
U@07UA801IDJ0000;`09U@/019D=00RE3`03U@@029DB00>E6P0003402ID900BE4005U@l00iD600VE
3`03UAX0000d00RE1`03UA<00iD?00>E2009U@d00iDJ0000=P08U@D00iDC00>E3`04U@T02ID;00>E
6P0003P02ID200>E4`03U@l019D<00RE2@03UAX0000j00bE4`03UA000iD>00RE1`04UAT0000l00ZE
4`03UA000iD@00RE1@04UAT0000o00NE4`03UA000iDB00RE1003UAT0001100FE4`03UA000iDD00RE
0P03UAT0001300>E4P04UA0019DE00^E6@0005P019D@00JE5@09UAT0001H00>E4@09UA@01iDI0000
F003UA<02IDD00FE6@0005P00iDE00VE5003UAT0001H00>E6008UBh0001H00>E6P09UB/0001H00>E
7009UBT0001H00>E7P08UBP0001H00>E8@05UBP0001H00>E8`03UBP0001H00>E8`03UBP0001H00>E
8`03UBP0001H00>E8`03UBP0001H00>E8`03UBP0001H00>E4@04U@h00iDX0000F003UA401iD;00BE
9`0005P00iDA00VE2@04UBL0001H00>E4@0;U@P00iDW0000F003UA400iD200VE1@03UBL0001H00>E
4@03U@@02ID300>E9`0005P00iDA00>E1P09U@0409FEUBL0001H00>E4@03U@T02YDW0000F004UA00
0iD;00RE9`0005P01iD=00BE3006UBL0001H00ZE2P04U@l00iDW0000FP0:U@T00iDi0000G@0:U@H0
0iDi0000H009U@@00iDi0000HP0:U@0409FEUCT0001U00^E>@0006L02IDi0000JP06UCT0001]00>E
>@000:T0002Y0000Z@000:T0002Y0000Z@000:T0002Y0000Z@000:T0002Y0000Z@000:T0002Y0000
Z@000:T0002Y0000Z@000:T0002Y0000Z@000:T0002Y0000Z@0004d000?o0000F@0002h01?l300Co
00@0ool00_l200;o0`03o`@000?o00002005o`040?oo00;o0P05o`030?oo00<00ol400;o<00002d0
00Go0000o`020003o`0000<000Co003o0`02o`@000?o000010000ol000090005o`000?l00P001?l0
0?l30003o`0000;o10000ol000020004o`00obl0000]0003o`3o00;o0P05o`050?l00?l02@000ol0
000@0005o`000?l00P001?l00?l30003o`0000H000?o00000P001?l00?l_0000;@000ol000040007
o`000?l0o`020003o`0000L000?o000040001Ol0003o008000Co003o0`000ol000060003o`0000<0
0_l`0000;@001Ol0003o00<00ol00`3oo`03o`T000?o000040000ol00005o`<01?l80003o`000080
00Co003o;`0002h01?lD00;o4005o`/000?o00001@02o`D00_l`0000I`02od00002Y0000\
\>"],
  ImageRangeCache->{{{0, 168}, {168, 0}} -> {0.233018, -0.0250052, 0.00290612,
   0.0066362}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[(Gen.1, Ind.11)] .5 1 0 -1.5 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.1, Ind.11)] .5 1 0 -1.5 Mshowa
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{169, 169},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002Y0000Z@P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:T0002Y0000Z@000:T0002Y0000Z@000:T0
002Y0000Z@000:T0002Y0000Z@000:T0002Y0000Z@000:T0002Y0000Z@000:T0002Y0000Z@000:T0
002Y0000Z@000:T0002Y0000Z@000:T0002Y0000Z@0004H019EO0000=@03aPh01YEM0000<P03U@?6
3P08UE/0000b00>E0lH>00ZEF@0003800iD3aP:E3003U@0309FE00NEEP0003800iD3aPBE2P03U@<0
2IED0000<P03U@?61YD800>E1@09UE80000b00>E0lH8U@H00iD800RED00003800YD4aP8029D400>E
2P08UDh0000a00>E1<H400RE0P03U@`01iE=0000<@03U@?61`0;U@h01IE=0000<@03U@?62@09UA00
0iE=0000<@03U@?62`07UA000iE=0000<@03U@?63@05UA000iE=0000<@03U@?63`03UA000iE=0000
<@03U@?68P03UDd0000a00>E0lHR00>EC@0003400iD3aP:E8003UDd0000I00BE5P0019G6a/H4UAh0
0iE=00006@06UAD00lH6UA`00iE=00006@08UA<00lH8UAX00iE=00006@0:UA400lH200RE6003UDd0
000H00BE00<0UID01YD>00C61008UAH00iE=00006004U@<029D<00C61P08UA@00iE=00006003U@H0
29D:00?62@08UA800iE=00006003U@P029D800?62`07UA400iE=00006003U@X029D600?63@05UA40
0iE=00005`04U@`029D400?63`03UA400iE=00005`04U@h029D200?63`03UA400iE=00005`03UA40
29D3aPl00iDA00>EC@0001L00iDC00JE0lH?00>E4@03UDd0000G00>E5@04U@?60YD=00>E4@03U@h0
19Dk00005P04UAL00YD3aPBE2`03UA400iD>00JE>@0001H019DI00?61YD900>E4@03U@h029Dg0000
5P04UAT00lH8U@L00iDA00>E3P0:UCD0000F00NE5P03aP8029D500>E4@04U@d00iD00`2EU@06UC<0
000F00VE5003aP@02ID200>E4@06U@/00iD300NE<P0001P02IDA00C61P0<UA4029D900>E1@07UC00
000K00VE3P04aPP02YDC00RE1`04U@H01iD^00007@09U@`00lH<00NE5@08U@D019D700RE;00001l0
2YD900?63P05UAL029D400>E2@07UB/0000R00VE1`03aQ000iDI00RE0P03U@/01ID[00009009U@D0
0lH^00^E3@03UB/0000W00VE0P03aS002ID=00>E:`0002T029D01036a/Hb00NE3@03UB/0000[00JE
00@0a/K6=005U@d00iD[0000;P03U@040<K6aSH00iD=00>E:`0002h00iD01036a/I600BE:P0002h0
0iD01036a/I600BE:P0002h00iD01036a/I700>E:P0002h00iD01036a/I700>E:P0002h00iD01036
a/I700>E:P0002h00iD01036a/I700>E:P0002d019D4aTL019DY0000;@04U@C63`04UC@01YDW0000
;@03U@040<K6aQ001iDa00RE9@0002d00iD01036a/H@00VE<@08UB<0000]00>E00@0a/K6400;UC40
29DQ0000;@03U@040<K6aQ000iD200VE6@04UA<029DO0000;@03U@040<K6aQ000iD400VE5`06UA<0
29DM0000;@04U@?64003U@H02IDE00VE4P08UA/0000]00BE0lH@00>E2@09UA802iDB00NE6P0002d0
19D3aP:E3P03U@/02ID@00>E00<0UID01iDB00FE6P0002l02ID;00BE3@08U@l00iD400RE4P03UAX0
000a00VE2@04UA001ID?00>E1P09U@l00iDJ0000=008U@L00iDC00>E3`03U@P02ID=00>E6P0003H0
29D500>E4`03U@l019D900VE2`03UAX0000h00VE0P03UA<00iD?00BE3008U@T00iDJ0000>P0<UA<0
0iD@00>E3P08U@L019DI0000?00:UA<00iD@00>E4008U@D019DI0000?`07UA<00iD@00>E4P08U@@0
0iDI0000@@05UA<00iD@00>E5008U@800iDI0000@`03UA8019D@00BE5@0;UAT0001H00BE4006UAD0
2IDI0000F003UA402IDD00NE6@0005P00iDC00VE5005UAT0001H00>E5@09UA@00iDI0000F003UAP0
29D^0000F003UAX02ID[0000F003UA`02IDY0000F003UAh029DX0000F003UB401IDX0000F003UB<0
0iDX0000F003UB<00iDX0000F003UB<00iDX0000F003UB<00iDX0000F003UB<00iDX0000F003UA40
19D>00>E:00005P00iDA00NE2`04UBL0001H00>E4@09U@T019DW0000F003UA402iD800>E9`0005P0
0iDA00>E0P09U@D00iDW0000F003UA400iD400VE0`03UBL0001H00>E4@03U@H02ID0102EUIDW0000
F003UA400iD900ZE9`0005P019D@00>E2`08UBL0001H00NE3@04U@`01YDW0000F00:U@X019D?00>E
9`0005X02YD900>E>@0005d02YD600>E>@0006002ID400>E>@0006802YD0102EUIDi0000I@0;UCT0
001W00VE>@0006X01YDi0000K@03UCT0002Y0000Z@000:T0002Y0000Z@000:T0002Y0000Z@000:T0
002Y0000Z@000:T0002Y0000Z@000:T0002Y0000Z@000:T0002Y0000Z@000:T0002Y0000Z@000:T0
001=0003o`0005T0000^00Co0`04o`040?oo00;o0P02o`<00ol40003o`0000P01Ol0103oo`02o`80
1Ol00`3oo`0300?o0`03oc00000]0005o`000?l00P000ol000030004o`00o`<00_l40003o`0000@0
00?o00002@001Ol0003o008000Co003o0`000ol00002o`@000?o00000`000ol0000_0000;@000ol0
o`02o`801Ol01@3o003o00T000?o000040001Ol0003o008000Co003o0`000ol000060003o`0000<0
00?o0000;`0002d000?o000010001ol0003o0?l00P000ol000070003o`00010000Go0000o`020004
o`00o`<000?o00001P000ol000030003o`0002l0000]0005o`000?l00`03o`030?oo00?o2@000ol0
000@0003o`0000Go0`04o`P000?o00000`000ol0000_0000;P04oa@00_l@00Go2`000ol0000500;o
1002oc40001W00;o@0000:T00000\
\>"],
  ImageRangeCache->{{{0, 168}, {168, 0}} -> {0.233018, -0.0250052, 0.00290612,
   0.0066362}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(showKoch[getExpression[$basicDirectory, "\<Fractals-10-1\>", 2, 32], 
        2, 32];\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.498191 2.097 0.0245059 0.980236 [
[(Gen.2, Ind.32)] .5 1 0 -1.5 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.2, Ind.32)] .5 1 0 -1.5 Mshowa
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.87882 .61174 m
.78846 .56381 L
s
P
p
.2 1 0 r
.02 w
.88591 .6918 m
.87882 .61174 L
s
P
p
.2 1 0 r
.02 w
.7834 .48613 m
.69015 .43471 L
s
P
p
.2 1 0 r
.02 w
.78846 .56381 m
.7834 .48613 L
s
P
p
.2 1 0 r
.02 w
.79374 .64494 m
.88591 .6918 L
s
P
p
.2 1 0 r
.02 w
.69015 .43471 m
.69327 .51333 L
s
P
p
.2 1 0 r
.02 w
.59099 .30448 m
.48962 .24655 L
s
P
p
.2 1 0 r
.02 w
.5919 .38054 m
.59099 .30448 L
s
P
p
.2 1 0 r
.02 w
.69652 .59553 m
.79374 .64494 L
s
P
p
.2 1 0 r
.02 w
.69327 .51333 m
.59285 .46007 L
s
P
p
.2 1 0 r
.02 w
.59285 .46007 m
.5919 .38054 L
s
P
p
.2 1 0 r
.02 w
.48962 .24655 m
.48822 .32337 L
s
P
p
.2 1 0 r
.02 w
.79926 .72975 m
.69993 .68156 L
s
P
p
.2 1 0 r
.02 w
.80503 .8185 m
.79926 .72975 L
s
P
p
.2 1 0 r
.02 w
.69993 .68156 m
.69652 .59553 L
s
P
p
.2 1 0 r
.02 w
.48822 .32337 m
.37867 .26297 L
s
P
p
.2 1 0 r
.02 w
.7035 .77169 m
.80503 .8185 L
s
P
p
0 .4 1 r
.02 w
.61366 .54042 m
.50545 .48504 L
s
P
p
.2 1 0 r
.02 w
.48676 .40381 m
.48523 .48812 L
s
P
p
.2 1 0 r
.02 w
.37451 .34428 m
.48676 .40381 L
s
P
p
0 .4 1 r
.02 w
.5065 .40067 m
.39465 .34095 L
s
P
p
0 .4 1 r
.02 w
.50545 .48504 m
.5065 .40067 L
s
P
p
.01 w
.37867 .26297 Mdot
P
p
.2 1 0 r
.02 w
.37867 .26297 m
.37451 .34428 L
s
P
p
.01 w
.39834 .2596 Mdot
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.39834 .2596 L
s
P
p
.2 1 0 r
.02 w
.70724 .86623 m
.7035 .77169 L
s
P
p
.2 1 0 r
.02 w
.59489 .63059 m
.59598 .72212 L
s
P
p
.2 1 0 r
.02 w
.48363 .5766 m
.59489 .63059 L
s
P
p
.2 1 0 r
.02 w
.48523 .48812 m
.37015 .42962 L
s
P
p
0 .4 1 r
.02 w
.50434 .57358 m
.50545 .48504 L
s
P
p
0 .4 1 r
.02 w
.39465 .34095 m
.2761 .27766 L
s
P
p
.2 1 0 r
.02 w
.59713 .81827 m
.70724 .86623 L
s
P
p
.2 1 0 r
.02 w
.59598 .72212 m
.59713 .81827 L
s
P
p
.2 1 0 r
.02 w
.48194 .66955 m
.48363 .5766 L
s
P
p
0 .4 1 r
.02 w
.38672 .51611 m
.50434 .57358 L
s
P
p
.2 1 0 r
.02 w
.37015 .42962 m
.24801 .36753 L
s
P
p
0 .4 1 r
.02 w
.2761 .27766 m
.26907 .36406 L
s
P
p
.2 1 0 r
.02 w
.36075 .61368 m
.48194 .66955 L
s
P
p
.2 1 0 r
.02 w
.36557 .51931 m
.36075 .61368 L
s
P
p
.2 1 0 r
.02 w
.24008 .45841 m
.36557 .51931 L
s
P
p
0 .4 1 r
.02 w
.38244 .61055 m
.38672 .51611 L
s
P
p
0 .4 1 r
.02 w
.26168 .45501 m
.38672 .51611 L
s
P
p
.2 1 0 r
.02 w
.24801 .36753 m
.24008 .45841 L
s
P
p
0 .4 1 r
.02 w
.26907 .36406 m
.26168 .45501 L
s
P
p
0 .4 1 r
.02 w
.13964 .29782 m
.26907 .36406 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{139, 139},
  ImageMargins->{{34, Inherited}, {Inherited, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002;0000R`P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP0008/0002;0000R`0008/0002;0000R`0008/0
002;0000R`0008/0002;0000R`0008/0002;0000R`0008/0002;0000R`0008/0002;0000R`0008/0
002;0000R`0008/0002;0000R`0008/0002;0000R`0008/0001200>EAP00048019E50000=`02aPT0
1YE30000=003U@;62@02U@0309FE00>E@@0002L00lH:00>E0/H900:E0`04UD00000W00G62003U@;6
0YD700:E1@04UCh0000W00O61P02U@030<K600BE1@02U@H01IDl00005P03aPh00/H200G61002U@04
0<K600FE0`02U@P019Dk00005P05aP`00/H400C60`02U@?60`05U@0309FE00X00iDj00006005aPX0
0/H600C600<0UID00/H600JE2`02UCX0000J00G62002aPL01LH00iG6aP0800BE2`02UCX0000L00K6
1@02aPT01/H:00:E2`02UCX0000N00K60`02aP/01LHF00:E>P0002401LH00`36aP0;00:E1LHD00:E
>P0002<01/H;00BE1<HC00:E>P0002D01<H=00BE1<HA00:E>P0002@00iD2aPl00iD5aPl00YDj0000
9003U@;64@03U@G63@02UCX0000T00>E0/H2UA400iD4aP`00YDj00009002U@030<K600FE4003U@C6
2P02UCX0000T00:E00@0a/H01YD@00:E1<H900:E>P0002@00YD00`36aP0400FE4002U@;62@02UCX0
000S00>E0lH600FE3P02U@;62@02UCX0000S00:E00<0a/H02@05U@`00YD2aPT00YDj00008`02U@03
0<K600/01ID:00:E0/H900:E2P03UBd0000S00:E00<0a/H03@05U@P00YD2aPT00YD:00FE:`0002<0
0YD00`36aP0?00FE1P02U@;62@02U@X01YDZ00008`03U@?64004U@D00YD2aPT00iD900:E0P04UBP0
000S00>E1LH@00BE0`02U@;62@05U@L00YD300FE9P0002D00iD5aPl01ID00`2EU@02aP/01ID500:E
1@04UBD0000W00>E1/H>00JE0lH<00FE0`03U@H019DS0000:@03U@K63P04U@G63004U@<00YD700BE
8P0002/019D5aPh00YD7aP`019D00`2EU@0900:E8P0002d019D5aPh00/H200G62`06U@T00YDR0000
;`04U@G63002aP@01LH;00BE2@02UB80000a00BE1LH:00;61P05aP/00YD900:E8P0003<00YD7aPP0
0/H800G65003UB40000c00:E0/H200K61@02aPX01<HD00:E8@0003<00YD2aP@01/H300;63002aQ@0
0YDQ0000<`02U@;61`05aP030<K602800YDQ0000<`02U@;62@06aR800iDP0000<`02U@;62`04aR80
1IDN0000<P03U@;62P03U@;69005UA`0000b00:E00<0a/H02P05UBH019DK0000<P02U@030<K600X0
1iDD00>E3`04UAT0000b00:E00<0a/H02P02U@801IDB00FE3P05UAL0000b00:E00<0a/H02P02U@@0
1ID@00NE3P04UAH0000b00>E0/H:00:E1P05U@h00YD200FE3P02UAH0000b00FE2P02U@P01ID<00:E
1005U@`00YDF0000=005U@P00YD:00BE2`02U@H01ID:00:E5P0003H01YD500:E3002U@/00iD700FE
2002UAH0000h00JE0`02U@`00YD<00:E2@05U@H00YDF0000>`05U@0309FE00`00YD<00:E2`05U@@0
0iDE0000?@06U@`00YD<00:E3@05U@<00YDE0000?`04U@`00YD<00:E3`05U@0309FE01D0001100:E
3003U@/00iD@00JE5@0005000YD;00FE4004UAD0001@00:E3@05UA000YDE0000D002U@l01IDU0000
D002UA401IDS0000D002UA<01IDQ0000D002UAD019DP0000D002UAL00YDP0000D002UAL00YDP0000
D002UAL00YDP0000D002UAL00YDP0000D002U@/00iD900:E800005000YD;00FE1`03UAl0001@00:E
2`07U@H00YDO0000D002U@/00YD200JE0`02UAl0001@00:E2`02U@@01YD00`2EU@0O0000D002U@/0
0YD700JE7`0005000iD:00:E2@04UAl0001@00JE1`03U@X00YDO0000DP06U@H00YD[0000E@05U@@0
0YD[0000E`06U@0309FE02/0001I00NE:`0005`019D[0000GP02UB/0002;0000R`0008/0002;0000
R`0008/0002;0000R`0008/0002;0000R`0008/0002;0000R`0008/0002;0000R`0008/0002;0000
?P000ol0001:00007`04o`<01?l0103oo`02o`800_l300Co0`000ol0000800Go00@0ool00_l200Go
00<0ool00`03o`<01?lP00007P001Ol0003o008000?o00000`001?l00?l300;o10000ol000040003
o`0000T000Go0000o`020004o`00o`<000?o00000_l60005o`000?l08P0001h000?o0?l00_l200Go
00D0o`00o`0:0003o`0000l000Go0000o`020004o`00o`<000?o000020000ol000020003o`0001l0
000N0003o`0000@000Oo0000o`3o008000?o00002@000ol0000>0005o`000?l00P001?l00?l30003
o`0000H00_l60003o`0001h0000N0005o`000?l00`03o`030?oo00?o20001?l00?l@0003o`0000Go
0`04o`X000Co003o0P000ol0000N00007`04oaD00_l?00Go2`000ol0000500?o1002ob40001H00;o
<@0008/00000\
\>"],
  ImageRangeCache->{{{0, 138}, {138, 0}} -> {0.213822, -0.0250051, 0.00379981,
   0.00812887}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"Gen. 2, Crossover 1,18 --> new champ in gen 3"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[
"getExpression[$basicDirectory,\"Fractals-10-1\",2,1]\n\
getFitnesses[$basicDirectory,\"Fractals-10-1\",2][[1]]"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
  LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], SUCC[SEQ[FO[1], RR[90]]]]]]\
\>",
 "\<\
LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], \

 
  LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], SUCC[SEQ[FO[1], \
RR[90]]]]]]\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
16\
\>", "\<\
16\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[TextData[
"getExpression[$basicDirectory,\"Fractals-10-1\",2,18]\n\
getFitnesses[$basicDirectory,\"Fractals-10-1\",2][[18]]"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
  LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
    SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
      SEQ[FO[1]], FO[1]], SEQ[FO[1], FO[1]], SEQ[FO[1], RL[90]], 
 
     SEQ[FO[1], RL[90]]]]]]\
\>", 
"\<\
LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
  LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
    SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
      SEQ[FO[1]], FO[1]], SEQ[FO[1], FO[1]], SEQ[FO[1], RL[90]], 
 
     SEQ[FO[1], RL[90]]]]]]\
\>"], "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
14\
\>", "\<\
14\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(showKoch[getExpression[$basicDirectory, "\<Fractals-10-1\>", 2, 1], 
        2, 1];\)\[IndentingNewLine]\), "\[IndentingNewLine]", 
    \(\(showKoch[getExpression[$basicDirectory, "\<Fractals-10-1\>", 2, 18], 
        2, 18];\)\)}], "Input"],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[(Gen.2, Ind.1)] .5 1 0 -1.5 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.2, Ind.1)] .5 1 0 -1.5 Mshowa
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{143, 143},
  ImageMargins->{{34, Inherited}, {Inherited, 2}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002?0000S`P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP0008l0002?0000S`0008l0002?0000S`0008l0
002?0000S`0008l0002?0000S`0008l0002?0000S`0008l0002?0000S`0008l0002?0000S`0008l0
002?0000S`0008l0000k00>ED@0003/01IE?0000:P03U@;63006UDh0000Z00>E0/H<00:E0P04UD`0
000Z00>E0/H2U@X00YD300FEBP0002X00YD00`36aP04U@P00YD500FEB00002X00YD01036aP05U@H0
0YD700FEAP0002X00YD00`36aP0300BE1@02U@T019E50000:@03U@?61@04U@<00YD;00BE@`0002T0
0YD00`36aP0700FE00<0UID03004UD80000Y00:E00<0a/H02@06U@h00YE20000:@02U@030<K600/0
19D>00:E@P0002T00YD00`36aP0=00:E3P02UD80000Y00>E0/HM00:E@P0002T00iD2aQd00YE20000
:`000iG6aP02UA/00YE200005@03UA@00/H4UAT00YE200005@05UA800/H00`2EU@03UAL00YE20000
5@07UA000/H300FE5@02UD80000E00:E0P05U@h00/H500FE4`02UD80000D00>E1006U@X00lH700FE
4@02UD80000D00:E1`06U@P00/H:00FE3`02UD80000D00:E2P05U@H00/H<00BE3P02UD80000D00:E
3005U@@00/H>00:E3P02UD80000D00:E3P05U@800/H>00:E3P02UD80000D00:E4005U@;63P02U@h0
0YE200005002UA800iD2aPh00YD>00:E@P0001<00iDD0003ULK600:E3002U@h00YD<00>E<`0001<0
0YDF00;619D:00:E3P02U@`01IDa00004`03UAD00/H00`2EU@03U@L00iD>00:E3007UBl0000C00FE
4`02aP<01ID500:E3`03U@/00YD200FE;@0001D01YD@00;61@05U@<00YD?00FE2@02U@@01ID[0000
5`06U@d00lH700FE00<0UID04@05U@L00YD600FE:@0001X01ID;00;62P06UA<01ID500>E1`05UBL0
000L00FE2@02aP`019DE00BE1@02U@T019DV00007P05U@L00/H>00:E5`04U@<00YD;00:E9P000200
1YD400;6:005U@0309FE00/00YDV00008P06U@800/HZ00JE2`02UBH0000U00BE00<0a/H0;004U@/0
0YDV00009`02U@030<K602h00YD;00:E9P0002L00YD00`36aP0k00>E9@0002L00YD00`36aP0l00:E
9@0002L00YD00`36aP0l00:E9@0002L00YD00`36aP0l00:E9@0002L00YD00`36aP0l00:E9@0002H0
0iD3aS`00iDT00009P02U@030<K600h00iD/00FE8P0002H00YD00`36aP0>00FE;005UB00000V00:E
00<0a/H03P08UB/01YDM00009P02U@030<K600h00YD200JE5`03UA401YDK00009P02U@030<K600h0
0YD500FE5@05UA801IDI00009P03U@;63P02U@L01IDC00NE4P04UAP0000V00>E0/H00iD0000;00:E
2@06UA000YD200JE4@02UAP0000X00JE2`02U@/01YD>00:E1006U@l00YDH0000:`05U@T00YD>00BE
3@02U@L01ID=00:E600002d01YD600:E4002U@d00YD900FE2`02UAP0000_00JE1002UA000YD=00:E
2`05U@T00YDH0000<P05U@800YD@00:E3@02U@d01ID700>E5`0003@01iD@00:E3@02U@l01ID600:E
5`0003H01ID@00:E3@02UA401YD300:E5`0003T00YD@00:E3@02UA<01YD00`2EU@0G0000BP03U@d0
0iDE00JE5`0004X00YD>00FE5@04UAL0001:00:E4005UAD00YDG0000BP02UA801YD[0000BP02UA@0
1YDY0000BP02UAL01IDW0000BP02UAT01IDU0000BP02UA/019DT0000BP02UAd00YDT0000BP02UAd0
0YDT0000BP02UAd00YDT0000BP02UAd00YDT0000BP02UAd00YDT0000BP02U@l00iD;00:E900004X0
0YD?00JE2003UB<0001:00:E3`08U@L00YDS0000BP02U@l00YD300JE1002UB<0001:00:E3`02U@D0
1YD200:E8`0004X00YD?00:E2007UB<0001:00>E3P02U@X01IDS0000BP06U@/00YD=00:E8`0004`0
1YD900:E<P0004l01YD600:E<P0005401YD400:E<P0005@01ID200:E<P0005H01iDb0000F005UC80
001K00:E<P0008l0002?0000S`0008l0002?0000S`0008l0002?0000S`0008l0002?0000S`0008l0
002?0000S`0008l0002?0000S`0008l0002?0000@`000ol0001900009004o`<01?l0103oo`02o`80
0_l300Co0`000ol0000800Go00@0ool00_l200Go00<0ool00`03obH0000S0005o`000?l00P000ol0
00030004o`00o`<00_l40003o`0000@000?o00002@001Ol0003o008000Co003o0`000ol00002o`@0
00?o00009@0002<000?o0?l00_l200Go00D0o`00o`0:0003o`0000l000Go0000o`020004o`00o`<0
00?o00001P000ol0000U00008`000ol000040007o`000?l0o`020003o`0000T000?o00003P001Ol0
003o008000Co003o0`000ol000060003o`0002D0000S0005o`000?l00`03o`030?oo00?o20001?l0
0?l@0003o`0000Go0`04o`P000?o00009@0002@01?lE00;o3`05o`/000?o00001@02obL0001M00;o
<00008l00000\
\>"],
  ImageRangeCache->{{{0, 142}, {142, 0}} -> {0.229371, -0.0250052, 0.00348959,
   0.00796857}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.380258 1.86028 0.0250076 1.0003 [
[(Gen.2, Ind.18)] .5 1 0 -1.5 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.2, Ind.18)] .5 1 0 -1.5 Mshowa
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.89873 .67009 m
.8327 .63026 L
s
P
p
.2 1 0 r
.02 w
.904 .73799 m
.89873 .67009 L
s
P
p
.2 1 0 r
.02 w
.82848 .56377 m
.76097 .52188 L
s
P
p
.2 1 0 r
.02 w
.8327 .63026 m
.82848 .56377 L
s
P
p
.2 1 0 r
.02 w
.83706 .6988 m
.904 .73799 L
s
P
p
.2 1 0 r
.02 w
.76097 .52188 m
.76423 .58896 L
s
P
p
.2 1 0 r
.02 w
.6888 .41283 m
.61721 .36721 L
s
P
p
.2 1 0 r
.02 w
.69095 .47843 m
.6888 .41283 L
s
P
p
.2 1 0 r
.02 w
.76759 .65814 m
.83706 .6988 L
s
P
p
.2 1 0 r
.02 w
.76423 .58896 m
.69317 .54609 L
s
P
p
.2 1 0 r
.02 w
.69317 .54609 m
.69095 .47843 L
s
P
p
.2 1 0 r
.02 w
.61721 .36721 m
.61827 .43334 L
s
P
p
.2 1 0 r
.02 w
.84155 .76949 m
.77106 .72953 L
s
P
p
.2 1 0 r
.02 w
.84618 .84242 m
.84155 .76949 L
s
P
p
.2 1 0 r
.02 w
.77106 .72953 m
.76759 .65814 L
s
P
p
.2 1 0 r
.02 w
.61827 .43334 m
.54279 .3865 L
s
P
p
.2 1 0 r
.02 w
.77464 .80324 m
.84618 .84242 L
s
P
p
.2 1 0 r
.02 w
.61937 .50158 m
.6205 .57205 L
s
P
p
.2 1 0 r
.02 w
.54268 .45532 m
.61937 .50158 L
s
P
p
0 .4 1 r
.02 w
.63359 .49912 m
.63496 .56962 L
s
P
p
0 .4 1 r
.02 w
.5571 .45276 m
.63359 .49912 L
s
P
p
.01 w
.54279 .3865 Mdot
P
p
.2 1 0 r
.02 w
.54279 .3865 m
.54268 .45532 L
s
P
p
.01 w
.55698 .38391 Mdot
P
p
0 .4 1 r
.02 w
.5571 .45276 m
.55698 .38391 L
s
P
p
.2 1 0 r
.02 w
.77834 .87937 m
.77464 .80324 L
s
P
p
.2 1 0 r
.02 w
.69782 .68802 m
.70027 .7625 L
s
P
p
.2 1 0 r
.02 w
.62167 .64485 m
.69782 .68802 L
s
P
p
.2 1 0 r
.02 w
.6205 .57205 m
.54256 .52642 L
s
P
p
0 .4 1 r
.02 w
.63496 .56962 m
.55722 .5239 L
s
P
p
0 .4 1 r
.02 w
.47754 .40454 m
.5571 .45276 L
s
P
p
.2 1 0 r
.02 w
.70279 .83947 m
.77834 .87937 L
s
P
p
.2 1 0 r
.02 w
.70027 .7625 m
.70279 .83947 L
s
P
p
.2 1 0 r
.02 w
.62288 .72011 m
.62167 .64485 L
s
P
p
.2 1 0 r
.02 w
.54256 .52642 m
.46144 .47894 L
s
P
p
0 .4 1 r
.02 w
.55722 .5239 m
.47631 .47631 L
s
P
p
0 .4 1 r
.02 w
.39472 .35435 m
.47754 .40454 L
s
P
p
.2 1 0 r
.02 w
.54231 .67597 m
.62288 .72011 L
s
P
p
.2 1 0 r
.02 w
.54244 .59993 m
.54231 .67597 L
s
P
p
.2 1 0 r
.02 w
.45991 .55315 m
.54244 .59993 L
s
P
p
.2 1 0 r
.02 w
.46144 .47894 m
.45991 .55315 L
s
P
p
0 .4 1 r
.02 w
.47631 .47631 m
.39203 .42674 L
s
P
p
0 .4 1 r
.02 w
.30845 .30207 m
.39472 .35435 L
s
P
p
0 .4 1 r
.02 w
.39203 .42674 m
.30417 .37507 L
s
P
p
0 .4 1 r
.02 w
.2185 .24755 m
.30845 .30207 L
s
P
p
0 .4 1 r
.02 w
.30417 .37507 m
.2125 .32116 L
s
P
p
0 .4 1 r
.02 w
.12463 .19066 m
.2185 .24755 L
s
P
p
0 .4 1 r
.02 w
.2125 .32116 m
.11676 .26485 L
s
P
p
0 .4 1 r
.02 w
.20629 .39747 m
.2125 .32116 L
s
P
p
0 .4 1 r
.02 w
.11676 .26485 m
.12463 .19066 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{143, 143},
  ImageMargins->{{34, Inherited}, {Inherited, 2}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002?0000S`P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP0008l0002?0000S`0008l0002?0000S`0008l0
002?0000S`0008l0002?0000S`0008l0002?0000S`0008l0002?0000S`0008l0002?0000S`0008l0
002?0000S`0008l0000E00?6M`0001D01<If00005@06aW@0000E00;600<0a/H00/Ic00005@02aP<0
1<Ia00005@02aP@01<I`00005003aPH01<I^00005002aPP01<I]00005002aPX01<I[00005002aP/0
1LIY00005003aP`01<IX00005005aP`01<IV00005P04aP`01LIT00006004aP`01<IS00006@05aP`0
1<IQ00006`04aP`01LIO00007@04aP`01LIM00007P05aP`01LIK00008005aP`01<IJ00008006aPd0
1<IH00008002aP801<H<00G6EP0002000/H300G63005aU@0000P00;61@04aPd01<IC00007`03aPL0
1<H=00C65`03UCL0000O00;62@05aP`01LHE00BE=P0001l00/H;00G63004aP`00/H600JE=00001l0
0/H=00C63@04aPP00YD2aPH00YD00`2EU@02UC<0000O00;63`04aP`01<H700:E0/H00iD0000300:E
0`04UC40000O00;64005aP`01<H500:E0/H2U@@00YD400BE<00003<01<H<00G60`02U@;619D200:E
1P03UBl0000e00C63004aP800YD2aP0309FE00FE1`02UBl0000f00G63004aP:E0/H300FE1`02UBl0
000h00G62`07aPD00iD700:E;`0003X01<H<00G61P02U@L00YD_0000?004aP/000>Ea/H00/H>00:E
;`0003d01LH900:E1LH<00:E;`0003l01<H:00:E1<H;00:E;`0004401<H:00:E1<H900:E;`000440
00>Ea/H00lH900:E1LH700:E;`0004400iD5aPT00YD4aPH00YD_0000@@05U@C62P02U@?61@02UBl0
001100:E0P03U@C62@02U@;61@02UBl0001100:E0`03U@G61`02U@;61@03UBh0001000>E1@03U@G6
1@02U@;61P02U@H00iDU0000@002U@P00iD5aP<00YD2aPH00YD600BE900004000YD900BE1<H200:E
0/H600:E1P06UB80001000:E2`04U@C60YD2aPH00iD500:E00<0UID00YDQ0000@003U@`00iD7aPH0
19D400:E0`04UAl0001000FE2`04U@G62004U@800iD300BE7P0004801ID;00BE0lH900BE0P02U@D0
0iDM0000A004U@`00iD2aP/01YD600:E7@0004H019D;00:E3P05U@H00YDM0000A`05UA/00iD600:E
7@0004T019DK00:E1P02UAd0001;00:E8`03UA`0001;00:E9002UA`0001;00:E9002UA`0001;00:E
9003UA/0001;00:E9004UAX0001;00:E2003UA/019DH0000B`02U@P01IDJ00FE5P0004/00YD800JE
3@03U@/019DE0000B`02U@P00YD200BE2`05U@/00iDD0000B`03U@L00YD300FE2@07U@X00YDD0000
B`05U@D00YD500BE2002U@8019D900:E500004d019D400:E1`03U@L00YD400BE1`02UA@0001?00BE
0P02U@P00YD700>E1005U@D00YDD0000D007U@P00YD800:E1P05U@<00iDC0000DP05U@P00YD800:E
2005U@800YDC0000E003U@P00YD800:E2P04U@0309FE01<0001E00:E2002U@P00iD;00FE4`0005l0
0YD800FE2P04UA<0001O00:E2P05U@X00YDC0000G`02U@`019DN0000G`02U@h019DL0000G`02U@l0
19DK0000G`02UA400YDK0000G`02UA400YDK0000G`02UA400YDK0000G`02UA400YDK0000G`03U@L0
0iD600:E6`0006000YD700FE1002UA/0001P00:E1`07U@800YDK0000H002U@L00YD200BE00<0UID0
6`0006000iD600:E1005UA/0001P00FE1003U@@019DK0000HP05U@<00YD600:E6`0006@01ID00`2E
U@0S0000IP06UB<0001X00BE8`0006X00YDS0000S`0008l0002?0000S`0008l0002?0000S`0008l0
002?0000S`0008l0002?0000S`0008l0002?0000S`0008l0002?0000@0000ol0001<00008@04o`<0
1?l0103oo`02o`800_l300Co0`000ol0000800Go00@0ool00_l200Go00<0ool00`03o`@00_lS0000
80001Ol0003o008000?o00000`001?l00?l300;o10000ol000040003o`0000T000Go0000o`020004
o`00o`<000?o00000_l40003o`00008000Co003o8P00020000?o0?l00_l200Go00D0o`00o`0:0003
o`0000l000Go0000o`020004o`00o`<000?o00001P000ol000020004o`00ob80000P0003o`0000@0
00Oo0000o`3o008000?o00002@000ol0000>0005o`000?l00P001?l00?l30003o`0000H000?o0000
0`02ob<0000P0005o`000?l00`03o`030?oo00?o20001?l00?l@0003o`0000Go0`04o`P000?o0000
0P001?l00?lR00008@04oaD00_l?00Go2`000ol0000500;o1@02ob<0001J00;o<`0008l00000\
\>"],
  ImageRangeCache->{{{0, 142}, {142, 0}} -> {0.178462, -0.0250051, 0.00415103,
   0.00771977}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(showKoch[getExpression[$basicDirectory, "\<Fractals-10-1\>", 3, 29], 
        3, 29];\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.564051 2.22952 0.0242196 0.968782 [
[(Gen.3, Ind.29)] .5 1 0 -1.5 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.3, Ind.29)] .5 1 0 -1.5 Mshowa
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.86973 .53081 m
.80222 .49625 L
s
P
p
.2 1 0 r
.02 w
.87496 .58531 m
.86973 .53081 L
s
P
p
.2 1 0 r
.02 w
.79815 .44302 m
.729 .40661 L
s
P
p
.2 1 0 r
.02 w
.80222 .49625 m
.79815 .44302 L
s
P
p
.2 1 0 r
.02 w
.80642 .55127 m
.87496 .58531 L
s
P
p
.2 1 0 r
.02 w
.729 .40661 m
.73199 .46031 L
s
P
p
.2 1 0 r
.02 w
.65529 .31637 m
.58161 .27653 L
s
P
p
.2 1 0 r
.02 w
.65705 .36873 m
.65529 .31637 L
s
P
p
.2 1 0 r
.02 w
.73508 .51583 m
.80642 .55127 L
s
P
p
.2 1 0 r
.02 w
.73199 .46031 m
.65887 .42288 L
s
P
p
.2 1 0 r
.02 w
.65887 .42288 m
.65705 .36873 L
s
P
p
.2 1 0 r
.02 w
.58161 .27653 m
.58214 .32929 L
s
P
p
.2 1 0 r
.02 w
.81077 .60816 m
.73828 .57329 L
s
P
p
.2 1 0 r
.02 w
.81527 .66701 m
.81077 .60816 L
s
P
p
.2 1 0 r
.02 w
.73828 .57329 m
.73508 .51583 L
s
P
p
.2 1 0 r
.02 w
.58214 .32929 m
.50408 .28819 L
s
P
p
.2 1 0 r
.02 w
.74159 .63278 m
.81527 .66701 L
s
P
p
.2 1 0 r
.02 w
.58269 .38389 m
.58326 .44043 L
s
P
p
.2 1 0 r
.02 w
.50325 .34322 m
.58269 .38389 L
s
P
p
0 .4 1 r
.02 w
.59723 .38173 m
.59806 .4383 L
s
P
p
0 .4 1 r
.02 w
.518 .34097 m
.59723 .38173 L
s
P
p
.01 w
.50408 .28819 Mdot
P
p
.2 1 0 r
.02 w
.50408 .28819 m
.50325 .34322 L
s
P
p
.01 w
.51858 .28591 Mdot
P
p
0 .4 1 r
.02 w
.51858 .28591 m
.518 .34097 L
s
P
p
.2 1 0 r
.02 w
.74502 .6944 m
.74159 .63278 L
s
P
p
.2 1 0 r
.02 w
.66271 .53694 m
.66473 .59706 L
s
P
p
.2 1 0 r
.02 w
.58385 .49902 m
.66271 .53694 L
s
P
p
.2 1 0 r
.02 w
.58326 .44043 m
.50239 .40026 L
s
P
p
0 .4 1 r
.02 w
.59806 .4383 m
.51741 .39803 L
s
P
p
.2 1 0 r
.02 w
.66682 .65939 m
.74502 .6944 L
s
P
p
.2 1 0 r
.02 w
.66473 .59706 m
.66682 .65939 L
s
P
p
.2 1 0 r
.02 w
.58446 .55976 m
.58385 .49902 L
s
P
p
.2 1 0 r
.02 w
.50239 .40026 m
.4179 .3583 L
s
P
p
0 .4 1 r
.02 w
.51741 .39803 m
.43316 .35597 L
s
P
p
.2 1 0 r
.02 w
.50056 .52078 m
.58446 .55976 L
s
P
p
.2 1 0 r
.02 w
.50149 .4594 m
.50056 .52078 L
s
P
p
.2 1 0 r
.02 w
.41539 .41799 m
.50149 .4594 L
s
P
p
0 .4 1 r
.02 w
.51679 .45721 m
.51615 .51862 L
s
P
p
0 .4 1 r
.02 w
.43093 .41569 m
.51679 .45721 L
s
P
p
.2 1 0 r
.02 w
.4179 .3583 m
.41539 .41799 L
s
P
p
0 .4 1 r
.02 w
.43316 .35597 m
.43093 .41569 L
s
P
p
0 .4 1 r
.02 w
.51615 .51862 m
.42862 .47773 L
s
P
p
0 .4 1 r
.02 w
.42862 .47773 m
.33693 .43489 L
s
P
p
0 .4 1 r
.02 w
.42621 .5422 m
.42371 .60927 L
s
P
p
0 .4 1 r
.02 w
.33262 .50007 m
.42621 .5422 L
s
P
p
0 .4 1 r
.02 w
.33693 .43489 m
.33262 .50007 L
s
P
p
0 .4 1 r
.02 w
.42371 .60927 m
.32813 .56792 L
s
P
p
0 .4 1 r
.02 w
.32813 .56792 m
.2277 .52448 L
s
P
p
0 .4 1 r
.02 w
.32345 .63863 m
.31857 .71238 L
s
P
p
0 .4 1 r
.02 w
.22074 .59608 m
.32345 .63863 L
s
P
p
0 .4 1 r
.02 w
.2277 .52448 m
.22074 .59608 L
s
P
p
0 .4 1 r
.02 w
.31857 .71238 m
.21346 .67084 L
s
P
p
0 .4 1 r
.02 w
.21346 .67084 m
.10265 .62705 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{148, 148},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002D0000U0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP0009@0002D0000U00009@0002D0000U00009@0
002D0000U00009@0002D0000U00009@0002D0000U00009@0002D0000U00009@0002D0000U00009@0
002D0000U00009@0002D0000U00009@0002D0000U00009@0002D0000U00009@0002D0000U00009@0
002D0000D`03UCh0001900:E0/H600FE?00004T00YD2aP03U@0000<01iDj0000B@02U@;60YD400:E
0P05UCP0001900:E0/H4U@800YD400FE=P0004T000FEa/K60007U@H019De0000B002U@;61005U@P0
0YDe0000B002U@;61P03U@P00YDe0000B002U@?61P02U@P00YDe0000B002U@G63P02UCD0000o00?6
1P04U@G63002UCD0000m00:E1LH600BE1<H;00:E=@0003d00YD7aPH019D4aPT00YDe0000?@02U@;6
0YD4aPP00YD5aPL00YDe0000?@02U@;619D4aPP00YD4aPH00YDe0000?@02U@;60`02U@G62002U@;6
1P02UCD0000m00:E0/H500:E1LH600:E0/H600:E=@0003d00YD2aPL00YD5aP@00YD2aPH00YD800>E
:P0003d00YD3aPP00YD6aP0309FE00;61P02U@P01IDX0000?@02U@G62002U@K600>Ea/H01P03U@L0
1iDV0000?@04U@G62003U@K61P05U@D00YD200BE9@0003800lH:00BE1<H800BE1<H800FE0`02U@@0
19DS0000<P05aPX019D4aPP019D2aPX01ID00`2EU@0500BE8P0003801lH;00:E1LH800:E3P06U@L0
0YDR0000<P02aP801LH;00:E1<HI00BE1`02UB80000b00;61005aP/00YD2aQ/00YD700:E8P000340
0lH600G62@02U@;69003UB40000a00;62@05aPL00YD2aRD00YDQ0000<@02aP/01/H400:E0/HU00:E
8@0003400/H=00K60P02U@;69@03UB00000a00?63`05aP:E0/H700>E6`05UAh0000a00K63P07aPL0
1IDK00FE700003<01lH=00G61`08U@d00iD:00BE6`0002<00lH@00K63002U@;61`02U@801YD;00FE
2P04UAT0000S00K64006aPT01ID600:E1@05U@T01iD900BE600002<02<H@00G62P06U@<00YD700BE
2002U@8019D:00:E600002<00/H300G64@02aP`01YD00`2EU@0900:E2002U@@019D800:E600002<0
0/H500K63P02aPl01YD900:E2002U@D01ID600:E600002<00/H700K63002aQ4019D900:E2002U@L0
1ID400:E600002800lH:00G62P02aQ<00YD900:E2002U@T01YD00`2EU@0H00008P02aPd01/H700;6
7P02U@P00iD:00NE600002800/H?00O61002aQh00YD800JE2P04UAP0000R00;64P06aP800/HN00:E
2P06U@X00YDH00008P03aQ@01lHN00:E3@06UB40000R00K64`05aQh00YD?00FE800002@01lHC00;6
7P02UA800YDP00009`07aS000YDB00:E800001<00lHD00O6;@02UA800YDP00004`06aQ@01LH/00:E
2003U@L00YDP00005@06aQD00/H/00:E2006U@@00YDP00006005aQ<00/H/00:E2008U@800YDP0000
6P06aQ000/H/00>E1`02U@<01iDP00007006aPh00/H/00FE1@02U@D01IDP00007`06aP/00/H^00JE
0P03U@L00YDP00008@07aPP00/H`00JE00<0UID0:@0002@01lH500;6<`06UBT0000W00O60P02aSD0
19DY0000:P08aSL00YDY0000;@05aV80000`00;6HP0009@0002D0000U00009@0002D0000U00009@0
002D0000U00009@0002D0000U00009@0002D0000U00009@0002D0000U00009@0002D0000U00009@0
002D0000U00009@0002D0000U00009@0002D0000U00009@0002D0000U00009@0002D0000U00009@0
002D0000U00009@0002D0000@P000ol0001?00008`04o`<01?l0103oo`02o`800_l300?o10000ol0
000800Go00@0ool00_l200Go00<0ool00`04o`800olV00008P001Ol0003o008000?o00000`001?l0
0?l300;o1P000ol000020003o`0000T000Go0000o`020004o`00o`<000?o00000_l40003o`0000D0
00?o00008`00028000?o0?l00_l200Go00D0o`00o`0;0003o`0000h000Go0000o`020004o`00o`<0
00?o00001`000ol0000200?o9@00028000?o000010001ol0003o0?l00P000ol0000700;o4@001Ol0
003o008000Co003o0`000ol000080004o`00o`8000?o00008`00028000Go0000o`0300?o00<0ool0
0ol;0003o`0000h000?o00001Ol300Co1`001?l00?l20004o`00obD0000S00Co5003o`l01Ol;0003
o`0000H00_l400;o9P0005`00_lf0000U0000001\
\>"],
  ImageRangeCache->{{{0, 147}, {147, 0}} -> {0.232147, -0.0250052, 0.00333481,
   0.0076746}}]
}, Open  ]],

Cell[TextData[
"getExpression[$basicDirectory,\"Fractals-10-1\",3,29]\n\
getFitnesses[$basicDirectory,\"Fractals-10-1\",3][[29]]"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
  LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
    SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
      SEQ[FO[1]], FO[1]]]]]]\
\>", 
"\<\
LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
  LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
    SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
      SEQ[FO[1]], FO[1]]]]]]\
\>"], "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
60\
\>", "\<\
60\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["getHistory[$basicDirectory,\"Fractals-10-1\",3,29]"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
{CROSS, {1, 18}, {{2, 1, 4, 1}, {2, 1, 4, 1}, 
 
   SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
    SEQ[FO[1]], FO[1]], SEQ[FO[1], RR[90]]}}\
\>", 
"\<\
{CROSS, {1, 18}, {{2, 1, 4, 1}, {2, 1, 4, 1}, 
 
   SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
    SEQ[FO[1]], FO[1]], SEQ[FO[1], RR[90]]}}\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"Gen. 32, Permutation 26 --> new champ in gen 33"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[
"getExpression[$basicDirectory,\"Fractals-10-1\",32,26]\n\
getFitnesses[$basicDirectory,\"Fractals-10-1\",32][[26]]"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
  LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
    SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
      SEQ[FO[1], FO[1], RL[90]], FO[1]]]]]]\
\>", 
"\<\
LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
  LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
    SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
      SEQ[FO[1], FO[1], RL[90]], FO[1]]]]]]\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
46\
\>", "\<\
46\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(showKoch[getExpression[$basicDirectory, "\<Fractals-10-1\>", 32, 26], 
        32, 26];\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[(Gen.32, Ind.26)] .5 1 0 -1.5 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.32, Ind.26)] .5 1 0 -1.5 Mshowa
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.68114 .56432 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.562 .50716 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.562 .50716 m
.43465 .44607 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.43789 .35572 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.43123 .54175 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.43465 .44607 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.56267 .701 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.29822 .38061 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.15169 .31032 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.139 .40899 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{149, 149},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002E0000U@P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP0009D0002E0000U@0009D0002E0000U@0009D0
002E0000U@0009D0002E0000U@0009D0002E0000U@0009D0002E0000U@0009D0002E0000U@0009D0
002E0000U@0009D0002E0000U@0003h00iED0000;003U@?63005UE80000/00>E1LH:00NED00002`0
0iD7aPP00YD200FECP0002`00YD00`36aP02U@G61P02U@@01IE<0000;002U@040<K600>E1LH400:E
1P05UDX0000/00:E00<0a/H00P04U@G60P02U@P01IE80000;002U@030<K600@019D5aP:E2P05UDH0
000[00>E0lH600BE1LH<00BEA@0002/00YD00`36aP0900BE1LH<00:EA@0002/00YD00`36aP0;00BE
1<H;00:EA@0002/00YD00`36aP0<00BE00<0a/H02`02UDD0000[00:E00<0a/H03P02U@030<K600/0
0YE50000:`03U@?64002aP/00YE50000:`03U@G63P02aP/00YE50000;@03U@G63002aP/00YE50000
5P03U@?64`03U@G62P02aP/00YE500005P03U@G64`03U@G61`03aP/00YE500005P03U@S64P03U@G6
1@02aP`00YE500005P02U@030<K600:E1/HB00>E1LH300;63002UDD0000E00>E00@0a/H019D5aQ80
0iD5aP030<K600`00YE500005@02U@800/H300BE1LHB00>E1/H<00:EA@0001D00YD200;61@04U@G6
4P03U@C63002UDD0000E00:E00@0a/K61`04U@K64@02U@030<K600`00YE500005@02U@030<K600X0
19D6aPl00YD00`36aP0<00:EA@0001D00YD00`36aP0<00FE1LH=00:E00<0a/H03002UDD0000E00:E
00<0a/H03P05U@G62`02U@030<K600`00YE500005003U@030<K601000iD7aPT00YD00`36aP0<00:E
3@03UCD0000D00:E0P02aQ8000>Ea/H00YD5aPL00YD00`36aP0<00:E3@05UC<0000D00>E00@0a/K6
4P02aPBE1/H300>E00<0a/H03002U@d01iDa00005004U@G64002aP8019D6aP0309FE00800/H<00:E
00@0a/K62@02U@801ID_00005P04U@K63@02aP@01ID5aP03U@0000;63003U@G61`02U@@019D^0000
6004U@K62P03aPH01ID5aP030<K600`00iD7aPD00YD600BE;00001X01ID5aPP00/H900FE1/H>0003
ULK600:E1LH300>E1P05UBX0000L00FE1LH600;63004U@G63P02aPBE1LH200:E2005UBP0000N00FE
1LH400;63P02U@801LH<00;60P04U@G60YD:00BE9`00024019D6aP030<K601801lH:00;61004U@G6
3002UBL0000S00BE1lHB00;60P05aPP00/H600BE1LH:00:E9`0002D01ID4aQ800/H400K61@02aPT0
0iD4aPT00YDW00009`04U@030<K601800/H600K60`02aP/00YD00`36aP0900:E9`0002T00YDE00;6
2@05aP030<K600h00/H900:E9`0002T00YDD00?62`06aPh00/H900:E9`0002T00YDD00;63P05aPd0
0/H900:E9`0002T00YDD00;64005aP/00/H900:E9`0002T00YDD00;64P05aPT00/H900:E9`0002T0
0YDD00;65005aPL00/H900:E9`0002T00YDD00;65P05aPD00/H900>E9P0002P00iDA00>E0lHG00G6
0`02aPT01IDT0000:002UA800iD5aQL01LH00`36aP0;00FE8P0002P00YDB00>E2<HF00K63@05UB00
000X00:E4P02U@030<K600:E1/HE0003ULK600;63`05UAh0000X00:E4P02U@030<K600800iD5aQ<0
0iD2aQ401IDL0000:002UA800YD00`36aP0400>E1LHA00NE4@05UAX0000X00>E4@02U@030<K600H0
0iD6aPh00YD200FE4@04UAT0000X00JE3P02U@030<K600P00iD6aP`00YD400BE4P02UAT0000Z00JE
2`03U@030<K600/00iD4aP/00YD600BE4002UAT0000]00FE2@02U@800/H=00:E00<0a/H02`02U@L0
1ID>00:E6@0002l01YD600:E0P02aPd00YD00`36aP0;00:E2@05U@`00iDH0000<@06U@@00YD200;6
3@02U@030<K600/00YD;00FE2`02UAP0000d00FE0P02U@800/H=00:E00<0a/H02`02U@d01YD800:E
600003H01iD200;63@02U@030<K600/00YD?00JE1P02UAP0000h00FE0P03aP`00YD00`36aP0;00:E
4P06U@<00YDH0000>`02U@801/H900:E00<0a/H02`02UA@01YD0102EUIDG0000@@06aPL00YD00`36
aP0;00>E5P07UAL0001400K61002U@030<K600/01IDF00FE5`0004H01lH0102EU@02aPd01YDF00:E
5`0004T01/H019D0a/H?00JE;@0004`01lHB00FE:`0004h01LHD00JE:00004h00YD00`36aP0F00JE
9P0004h00YDL00BE9@0004h00YDN00:E9@0004h00YDN00:E9@0004h00YDN00:E9@0004h00YDN00:E
9@0004h00YDN00:E9@0004h00YD?00>E3002UBD0001>00:E3`05U@X00iDT0000CP02U@l029D800:E
900004h00YD?00:E0P06U@H00YDT0000CP02U@l00YD500FE1002UB@0001>00:E3`02U@L01YD00`2E
U@0T0000CP02U@l00YD900NE900004h00iD>00:E3004UB@0001>00JE2`02U@h00YDT0000D006U@T0
0YDd0000D`06U@H00YDd0000E@06U@@00YDd0000F005U@800YDd0000FP07UC@0001L00FE=00005l0
0YDd0000U@0009D0002E0000U@0009D0002E0000U@0009D0002E0000U@0009D0002E0000U@0009D0
002E0000U@0009D0002E0000U@0009D0002E0000AP000ol0001<00008@04o`<01?l0103oo`02o`80
0_l300?o0`04o`<000?o00002005o`040?oo00;o0P05o`030?oo00<01?l300;o8`00020000Go0000
o`020003o`0000<000Co003o0`02o`H000Go0000o`060003o`0000T000Go0000o`020004o`00o`<0
00?o00000_l40003o`00008000Co003o8P00020000?o0?l00_l200Go00D0o`00o`0;0003o`000080
00?o00003`001Ol0003o008000Co003o0`000ol000070005o`000?l00P000ol0000P000080000ol0
00040007o`000?l0o`020003o`0000L00_l60003o`0000h000Go0000o`020004o`00o`<000?o0000
20000ol00003ob<0000P0005o`000?l00`03o`030?oo00?o2`001?l00?l20003o`0000h000?o0000
1Ol300Co1`001?l00?l20003o`0002<0000Q00Co5003o`@00_l?00Go2`000ol0000600;o1003ob80
001P00;o<`0009D00000\
\>"],
  ImageRangeCache->{{{0, 148}, {148, 0}} -> {0.230337, -0.0250052, 0.00333507,
   0.00761572}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(showKoch[getExpression[$basicDirectory, "\<Fractals-10-1\>", 33, 29], 
        33, 29];\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[(Gen.33, Ind.29)] .5 1 0 -1.5 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.33, Ind.29)] .5 1 0 -1.5 Mshowa
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{142, 142},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002>0000SPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP0008h0002>0000SP0008h0002>0000SP0008h0
002>0000SP0008h0002>0000SP0008h0002>0000SP0008h0002>0000SP0008h0002>0000SP0008h0
002>0000SP0008h0000k00>ED00003/01IE>0000:P03U@?62`06UDd0000Z00>E1LH900:E0P04UD/0
000Z00>E1lH700:E0`05UDT0000Z00:E00<0a/H00YD5aPD00YD500BEB00002X00YD01036aP03U@G6
0`02U@L019E60000:P02U@030<K600<00iD5aP0309FE00P01IE40000:@03U@?61@03U@G600>E0000
2004UD<0000Y00:E00<0a/H01`04U@G62`03UD80000Y00:E00<0a/H02@04U@G62P02UD80000Y00:E
00<0a/H02`04U@G62002UD80000Y00:E00<0a/H03@02U@801LH600:E@P0002T00iD3aQ801LH400:E
@P0002T00iD5aQ801LH200:E@P0002/00iD5aQ801LH2UD80000E00>E5@03U@G64P05aT80000E00FE
5@03U@K64@05aT00000E00NE5@03U@K640000iG6aP02aSl0000E00:E0P05UAD019D5aPh00YD00`36
aP0o00005003U@@01YDC00FE1LH<00:E00<0a/H0?`0001@00YD700JE4`05U@C62`02U@030<K603l0
000D00:E2P05UA<019D00`36aP0;00:E00<0a/H0?`0001@00YD<00FE4`02U@030<K600/00YD00`36
aP0o00005002U@h01ID200?63002U@030<K600/00YD00`36aP0o00005002UA001ID5aPX00YD00`36
aP0;00:E00<0a/H0?`0001@00YDB00>E1lH800:E00<0a/H02`02U@030<K600X00YD3aS00000C00>E
50000iG6aP02U@G61P02U@030<K600/00YD00`36aP0:00:E1LH^00004`02UAH00/H4U@G61002U@03
0<K600/00YD00`36aP0:00:E1lH/00004`03UAD00/H200BE1LH200:E00<0a/H02`02U@040<K6aPT0
0YD2aP:E1LHZ00004`06UA800/H400BE1LH2U@030<K600/00iD5aPL00YD2aP0409FEU@G6:00001D0
1YD?00?61P04U@G600<0a/H02`05U@G61@02U@;60`03U@G69P0001P01YD<00;62@04U@K63@05U@G6
0`02U@?60`04U@G6900001X01YD:00;63003U@C63`05U@C60P02U@030<K600D019D4aR<0000M00JE
1`02aPh00YD00`36aP0A00FE1<H2U@030<K600L00iD00`36aP0S00007`06U@D00/HW00>E1LH00`36
aP0800:E00<0a/H08`0002801YD200;6:@03U@K62002U@030<K602<0000T00FE00<0a/H0:`03U@C6
2002U@030<K602<0000W00:E00<0a/H0;@02U@030<K600P00YD00`36aP0S00009`02U@030<K603X0
0YD01036a/HR00009`02U@030<K603X00iD00`36aP0R00009`02U@030<K603/00YD00`36aP0R0000
9`02U@030<K603/00YD00`36aP0R00009`02U@030<K603/00YD00`36aP0R00009`02U@?6>`03U@;6
8P0002H00iD2aQ400lHX00>E0/HR00009P02U@030<K600h00iD5aRP000>Ea/H00YDP00009P02U@03
0<K600h00iD7aRL00/H4UAh0000V00:E00<0a/H03P03U@;60YD5aQ@00iD3aP/00/H00`2EU@02UAd0
000V00:E00<0a/H03P02U@030<K600BE1/HA00>E1LH900;60`04UA/0000V00:E00@0a/K63@02U@03
0<K6008019D6aPl00iD7aPL00lH300FE6@0002H00iD6aPX00YD00`36aP0500BE1LH=00:E00<0a/H0
0YD6aPD00/H500BE600002H01ID6aPP00YD00`36aP0700BE1LH;00:E00@0a/H00iD6aP<00/H700:E
600002P01YD5aPH00YD00`36aP0900BE1<H:00:E00<0a/H01003U@G600<0a/H01`02UAP0000[00FE
1/H300:E00<0a/H03002U@030<K600X00YD00`36aP0600>E1/H700:E600002d01ID6aP0409FE00;6
3002U@030<K600X00iD3aPL00iD4aPL00YDH0000;`06U@G600BE0<K63002U@030<K600/00YD00`36
aP0900>E0/H700:E600003801ID7aP`00YD00`36aP0;00:E00<0a/H02`05U@D00iDG0000=005U@G6
3002U@030<K600/00YD00`36aP0=00FE1002UAL0000f00FE00<0a/H03002U@030<K600/00YD00`36
aP0?00BE0`02UAL0000i00:E3`02U@030<K600/00iD3aQ0019D00`2EU@0G0000BP02U@030<K600/0
0iD5aPl01YDG0000BP02U@030<K600d00iD5aPl019DG0000BP02U@030<K600l00iD5aPl00YDG0000
BP02U@030<K601400iD5aRH0001:00:E00<0a/H05002U@G6900004X00YD01036a/HE00:E1LHR0000
BP02U@030<K600C65002U@C68@0004X00YD300O64`02U@;68@0004X00YD600K64@02U@;68@0004X0
0YD900K63P02U@;68@0004X00YD;00O62`02U@;68@0004X00YD>00K62@02U@;68@0004X00YD>00>E
1LH700:E0/HQ0000BP02U@h01ID5aPD00YD3aR00001:00:E3P07U@K60P02U@030<K60200001:00:E
3P02U@<019D6aP:E00<0a/H0800004X00YD>00:E1@05U@G600<0a/H0800004X00YD>00:E2004U@K6
800004X00YD>00:E2P04U@C6800004X00iD=00>E3002U@030<K60200001:00JE2`02UC40001<00NE
2002UC40001?00NE1@02UC40001B00NE0P02UC40001E00RE<@0005P01IDa0000F`02UC40002>0000
SP0008h0002>0000SP0008h0002>0000SP0008h0002>0000SP0008h0002>0000SP0008h0002>0000
SP0008h0002>0000SP00048000?o0000B@0001d01?l300Co00@0ool00_l200;o0`03o`<00ol40003
o`0000P01Ol0103oo`02o`801Ol00`3oo`0300Co0P03ob00000L0005o`000?l00P000ol000030004
o`00o`<00_l60003o`0000<000?o00000P000ol000090005o`000?l00P001?l00?l30003o`0000;o
10000ol000050003o`0001d0000L0003o`3o00;o0P05o`050?l00?l02`000ol000030003o`0000h0
00Go0000o`020004o`00o`<000?o00001`000ol0000200?o7`0001`000?o000010001ol0003o0?l0
0P000ol0000700;o1002oa4000Go0000o`020004o`00o`<000?o000020001?l00?l20003o`0001d0
000L0005o`000?l00`03o`030?oo00?o2`000ol000030003o`0000h000?o00001Ol300Co1`001?l0
0?l20004o`00oal0000M00Co5003o`<00ol?00Go2`000ol0000600;o1002ob00001L00;o<00008h0
0000\
\>"],
  ImageRangeCache->{{{0, 141}, {141, 0}} -> {0.229201, -0.0250052, 0.00351675,
   0.00803058}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Gen. 75, Mutation 3 -> new champ in gen 76"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[
"getExpression[$basicDirectory,\"Fractals-10-1\",75,3]\n\
getFitnesses[$basicDirectory,\"Fractals-10-1\",75][[3]]"], "Input",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
  LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
    SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
      SEQ[FO[1], RL[90], FO[1]], FO[1]]]]]]\
\>", 
"\<\
LSystem[AXIOM[seq[FO[1], RL[90], FO[1], RL[90], FO[1], RL[90], FO[1]]], 
 
  LRULES[LRule[LEFT[], PRED[FO[1]], RIGHT[], 
 
    SUCC[SEQ[SEQ[FO[1], RL[90]], SEQ[FO[1], RR[90]], SEQ[FO[1], RR[90]], 
 
      SEQ[FO[1], RL[90], FO[1]], FO[1]]]]]]\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
116\
\>", "\<\
116\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(showKoch[getExpression[$basicDirectory, "\<Fractals-10-1\>", 75, 3], 
        75, 3];\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[(Gen.75, Ind.3)] .5 1 0 -1.5 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.75, Ind.3)] .5 1 0 -1.5 Mshowa
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.7867 .53145 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.44095 .27028 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{165, 165},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002U0000Y@P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:D0002U0000Y@000:D0002U0000Y@000:D0
002U0000Y@000:D0002U0000Y@000:D0002U0000Y@000:D0002U0000Y@000:D0002U0000Y@000:D0
002U0000Y@000:D0002U0000Y@000:D0002U0000A@04UE`0000d00C63@06UEX0000a00>E1/H;00RE
F00003400iD8aPT02YEF0000<@03U@[61`03U@0309FE00JEE00003400iD3aP03ULK600K61@03U@<0
29EB0000<@03U@?60iD8aP<00iD500RED00003400iD3aPFE2<H4U@L029E>0000<@02U@C60P05U@S6
0YD900REC00003000iD4aP@01ID8aP/01iE;0000<003U@?61P06U@S62`05UD/0000`00>E0lH800JE
2<H;00>EB`0003000iD3aPX01YD8aPT00iE;0000<003U@?63005U@030<K600K61`03UD/0000`00>E
1<H=00>E0`07aPH00iE;0000<003U@K64`07aP@00iE;0000<003U@S64`07aP800iE;0000<005U@S6
4P08aP>EB`0001P019DF00FE2<HB00S600>E0000B@0001P01YDF00FE2<HB00O6B`0001P029DF00FE
2<HB00O6B@0001P02YDF00FE2<HB00K6B00001P00iD00`2EU@06UAH01ID8aQ0000>Ea/H00lI80000
5`04U@<029DF00FE2<H>00>E0lI800005`04U@D029DF00FE1lH=00>E0lI800005`03U@P029DF00FE
1LH=00>E0lI800005`03U@X029DF00FE0lH=00>E0lI800005`03U@`029DF00>E0lH=00>E0lI80000
5`03U@h029D200C63P03U@?63@03U@?6B00001L00iD@00RE1/H<00>E0lH<00BE0lI800005P04UA80
1YD8aPX00iD3aP`019D3aPh01<Hf00005P04UA@019D:aPP00iD3aP`00iD01036a/H;00>E1/Hd0000
5P03UAL00YD3aP03ULK600K61P03U@?63003U@040<K6aP/00iD7aS<0000F00BE6003aP>E2LH200BE
0lH<00>E00@0a/K62`03U@W6<@0001H01YDF00?61ID9aPBE0lH<00BE1<H:00>E0lH00iG6aP05aRl0
000F00VE4`03aP0309FE00BE2LH00iD0aP02aP`019D6aPP00iD3aP:E2<H]00006009UA001<H300NE
2lH<00BE2<H600>E0lH4U@S6:`0001X02ID>00C61P06U@W63P04U@S61003U@?60P04U@O6:P0001d0
2ID;00?62@06U@O64004U@S60P03U@?61004U@O6:00001l02ID900?62`06U@G64P04U@O600@0UIFE
0lH600BE1/HW00008@09U@L00lH=00FE00@0a/K65004U@O60YD3aPP00iD5aRL0000T00VE1003aPl0
0iDJ00BE2/H:00>E0lHW00009P09U@800lH^00>E2LH:00>E0lHW0000:008U@040<K6aS000iD7aPX0
0iD3aRL0000[00FE00@0a/K6<P03U@G62P03U@?69`0002d00iD01036a/Hd00>E0lH:00>E0lHW0000
;@03U@040<K6aT@00iD4aRH0000]00>E00@0a/K6A003U@C69P0002d00iD01036a/I500>E0lHV0000
;@03U@040<K6aTD00iD3aRH0000]00>E00@0a/K6A@03U@?69P0002d00iD01036a/I500>E0lHV0000
;004U@C6A@03U@?69P0002`019D4aPh019D4aRl00iD3aP:E900002`00iD01036a/H?00BE1/H_0004
ULK6aPBE8P0002`00iD01036a/H?00BE2LH]00?61IDQ0000;003U@040<K6aPl019D;aQP00iD4aP`0
0lH7UAl0000/00>E00@0a/K63`03U@050<K6aYD02LHF00>E1/H:00?60P07UAd0000/00>E00@0a/K6
3`03U@040<K6aPBE2<HD00>E2<H800C60P08UA/0000/00BE1<H>00>E00@0a/K60P04U@S64P03U@[6
1P04aP@01iDJ0000;004U@O62`03U@040<K6aP@019D9aPl00iD3aP03ULK600O61003aPH01IDJ0000
;004U@W62@03U@040<K6aPH019D9aPd00iD3aP>E2LH200?62003UAX0000^00BE2/H600>E00@0a/K6
2004U@S63003U@?60P03U@c62003UAX0000a00BE2LH400>E00@0a/K62`04U@G63003U@?61004U@W6
2004UAT0000c00BE2LH200>E00@0a/K63@03U@040<K6aP`00iD3aPD01ID7aPP019DI0000=P04U@W6
0YD01036a/H=00>E00@0a/K63003U@?61`05U@G62@03UAT0000h00BE2LH01036a/H=00>E00@0a/K6
3003U@?62@05U@?62@03UAT0000j00BE2lH=00>E00@0a/K63003U@?62`09U@H00iDI0000?@04U@S6
3@03U@040<K6aP`00iD3aPd02ID400>E6@0003l019D6aPd00iD01036a/H<00>E0lH?00VE0P03UAT0
001200>E00@0a/K63@03U@040<K6aP`00iD4aQ4039DH0000EP03U@040<K6aP`00iD6aQ402YDH0000
EP03U@040<K6aP`00iD9aQ0029DH0000EP03U@040<K6aPh00iD9aQ401IDH0000EP03U@040<K6aQ00
0iD9aQ400iDH0000EP03U@040<K6aQ8019D8aRX0001F00>E00@0a/K65004U@W69`0005H00iD00`36
aP02aQH00iD9aRD0001F00>E00<0a/H01LHE00>E2<HT0000EP03U@030<K600O65@04U@G6900005H0
0iD300W65@03U@040<K6aR@0001F00>E1P09aQ800iD01036a/HT0000EP03U@P02LH@00>E00@0a/K6
900005H00iD:00W63P03U@040<K6aR@0001F00>E3@09aP/00iD01036a/HT0000EP03U@l02LH900>E
00@0a/K6900005H00iDA00[61P04U@C68`0005H00iDA00>E2LH400BE1<HS0000EP03UA401ID:aP80
0iD01036a/HS0000EP03UA400iD00`2EU@02U@[60YD01036a/HS0000EP03UA400iD300BE2/H01036
a/HS0000EP03UA400iD500FE2lHS0000EP03UA400iD800FE2<HS0000EP04UA000iD:00FE1/HS0000
EP07U@d00iD<00FE00@0a/K68`0005H02ID;00>E3P03UBL0001H00ZE2003UCP0001K00VE1P03UCP0
001M00ZE0`03UCP0001P00VE00@0UIFE>00006802iDh0000I@08UCP0001W00JE>00006X00iDh0000
Y@000:D0002U0000Y@000:D0002U0000Y@000:D0002U0000Y@000:D0002U0000Y@000:D0002U0000
Y@000:D0002U0000Y@000:D0002U0000Y@000:D0001A0003o`000540000/00Co0`04o`040?oo00;o
0P02o`@000?o00000P03o`@000?o00002005o`040?oo00;o0P05o`030?oo00<00ol^0000:`001Ol0
003o008000?o00000`001?l00?l300;o10000ol000050003o`00008000?o00002@001Ol0003o0080
00Co003o0`000ol00002o`H000?o0000:`0002/000?o0?l00_l200Go00D0o`00o`0:0003o`0000@0
00?o00003P001Ol0003o008000Co003o0`000ol000080003o`0002/0000[0003o`0000@000Oo0000
o`3o008000?o000020001?l00003oa4000Go0000o`020004o`00o`<000?o00001P02obh0000[0005
o`000?l00`03o`030?oo00?o2`001?l00?lC0003o`0000Go0`04o`X000?o0000:`0002`01?lD00Co
0P04o`h01Ol;0003o`0000D00ol^0000J`02ocP0002U0000\
\>"],
  ImageRangeCache->{{{0, 164}, {164, 0}} -> {0.232538, -0.0250052, 0.00298285,
   0.00681142}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(showKoch[getExpression[$basicDirectory, "\<Fractals-10-1\>", 76, 10], 
        76, 10];\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.555841 2.21289 0.0242267 0.969068 [
[(Gen.76, Ind.10)] .5 1 0 -1.5 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.76, Ind.10)] .5 1 0 -1.5 Mshowa
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
P
p
.2 1 0 r
.02 w
.8685 .58582 m
.76551 .53433 L
s
P
p
.2 1 0 r
.02 w
.87651 .67089 m
.8685 .58582 L
s
P
p
0 .4 1 r
.02 w
.88923 .58311 m
.7867 .53145 L
s
P
p
0 .4 1 r
.02 w
.89777 .66825 m
.88923 .58311 L
s
P
p
.2 1 0 r
.02 w
.7602 .45221 m
.65338 .39638 L
s
P
p
.2 1 0 r
.02 w
.76551 .53433 m
.7602 .45221 L
s
P
p
0 .4 1 r
.02 w
.78086 .44927 m
.67449 .39326 L
s
P
p
0 .4 1 r
.02 w
.7867 .53145 m
.78086 .44927 L
s
P
p
.2 1 0 r
.02 w
.77109 .62071 m
.87651 .67089 L
s
P
p
0 .4 1 r
.02 w
.79284 .61791 m
.89777 .66825 L
s
P
p
.2 1 0 r
.02 w
.65338 .39638 m
.65606 .47961 L
s
P
p
0 .4 1 r
.02 w
.67449 .39326 m
.67773 .47655 L
s
P
p
.2 1 0 r
.02 w
.5401 .25702 m
.42236 .19294 L
s
P
p
.2 1 0 r
.02 w
.53982 .33703 m
.5401 .25702 L
s
P
p
0 .4 1 r
.02 w
.56113 .25365 m
.44385 .18936 L
s
P
p
0 .4 1 r
.02 w
.5614 .33371 m
.56113 .25365 L
s
P
p
.2 1 0 r
.02 w
.65889 .56731 m
.77109 .62071 L
s
P
p
0 .4 1 r
.02 w
.68114 .56432 m
.79284 .61791 L
s
P
p
.2 1 0 r
.02 w
.65606 .47961 m
.53953 .42136 L
s
P
p
0 .4 1 r
.02 w
.67773 .47655 m
.56169 .41809 L
s
P
p
.2 1 0 r
.02 w
.53953 .42136 m
.53982 .33703 L
s
P
p
0 .4 1 r
.02 w
.56169 .41809 m
.5614 .33371 L
s
P
p
.2 1 0 r
.02 w
.42236 .19294 m
.41888 .27382 L
s
P
p
0 .4 1 r
.02 w
.44385 .18936 m
.44095 .27028 L
s
P
p
.2 1 0 r
.02 w
.77697 .71171 m
.66187 .65984 L
s
P
p
.2 1 0 r
.02 w
.78317 .80768 m
.77697 .71171 L
s
P
p
0 .4 1 r
.02 w
.79931 .70898 m
.68474 .65693 L
s
P
p
0 .4 1 r
.02 w
.80614 .80506 m
.79931 .70898 L
s
P
p
.2 1 0 r
.02 w
.66187 .65984 m
.65889 .56731 L
s
P
p
0 .4 1 r
.02 w
.68474 .65693 m
.68114 .56432 L
s
P
p
.2 1 0 r
.02 w
.41888 .27382 m
.28981 .20636 L
s
P
p
0 .4 1 r
.02 w
.44095 .27028 m
.31239 .20258 L
s
P
p
.2 1 0 r
.02 w
.66502 .75761 m
.78317 .80768 L
s
P
p
0 .4 1 r
.02 w
.68855 .7548 m
.80614 .80506 L
s
P
p
.2 1 0 r
.02 w
.41521 .35921 m
.41133 .44948 L
s
P
p
.2 1 0 r
.02 w
.28229 .29276 m
.41521 .35921 L
s
P
p
0 .4 1 r
.02 w
.43789 .35572 m
.43465 .44607 L
s
P
p
0 .4 1 r
.02 w
.30551 .28903 m
.43789 .35572 L
s
P
p
.01 w
.28981 .20636 Mdot
P
p
.2 1 0 r
.02 w
.28981 .20636 m
.28229 .29276 L
s
P
p
.01 w
.31239 .20258 Mdot
P
p
0 .4 1 r
.02 w
.31239 .20258 m
.30551 .28903 L
s
P
p
.2 1 0 r
.02 w
.66836 .86108 m
.66502 .75761 L
s
P
p
0 .4 1 r
.02 w
.69258 .85839 m
.68855 .7548 L
s
P
p
.2 1 0 r
.02 w
.5389 .60443 m
.53856 .70401 L
s
P
p
.2 1 0 r
.02 w
.40722 .54509 m
.5389 .60443 L
s
P
p
0 .4 1 r
.02 w
.56233 .60132 m
.56267 .701 L
s
P
p
0 .4 1 r
.02 w
.43123 .54175 m
.56233 .60132 L
s
P
p
.2 1 0 r
.02 w
.41133 .44948 m
.27433 .38428 L
s
P
p
0 .4 1 r
.02 w
.43465 .44607 m
.29822 .38061 L
s
P
p
.2 1 0 r
.02 w
.53819 .80962 m
.66836 .86108 L
s
P
p
0 .4 1 r
.02 w
.56304 .80672 m
.69258 .85839 L
s
P
p
.2 1 0 r
.02 w
.53856 .70401 m
.53819 .80962 L
s
P
p
0 .4 1 r
.02 w
.56267 .701 m
.56304 .80672 L
s
P
p
.2 1 0 r
.02 w
.40287 .6465 m
.40722 .54509 L
s
P
p
0 .4 1 r
.02 w
.42759 .64327 m
.43123 .54175 L
s
P
p
.2 1 0 r
.02 w
.27433 .38428 m
.12721 .31426 L
s
P
p
0 .4 1 r
.02 w
.29822 .38061 m
.15169 .31032 L
s
P
p
.2 1 0 r
.02 w
.2569 .58464 m
.40287 .6465 L
s
P
p
0 .4 1 r
.02 w
.28227 .58116 m
.42759 .64327 L
s
P
p
.2 1 0 r
.02 w
.26588 .4814 m
.2569 .58464 L
s
P
p
.2 1 0 r
.02 w
.11377 .41285 m
.26588 .4814 L
s
P
p
0 .4 1 r
.02 w
.29049 .47781 m
.28227 .58116 L
s
P
p
0 .4 1 r
.02 w
.139 .40899 m
.29049 .47781 L
s
P
p
.2 1 0 r
.02 w
.12721 .31426 m
.11377 .41285 L
s
P
p
0 .4 1 r
.02 w
.15169 .31032 m
.139 .40899 L
s
P
p
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{166, 166},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002V0000YPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:H0002V0000YP000:H0002V0000YP000:H0
002V0000YP000:H0002V0000YP000:H0002V0000YP000:H0002V0000YP000:H0002V0000YP000:H0
002V0000YP000:H0002V0000YP000:H0001800C6FP0004D00iD6aUP0000d00C63@03U@S6EP000340
0iD6aP/00iD9aUD0000a00>E2<H900>E0lH00iG6aP05aU<0000a00>E2LH800>E0lH3U@O6D@000340
0iD3aP03ULK600G61P03U@?619D8aTl0000a00>E0lH3U@O61003U@?600<0UID00iD8aTd0000a00>E
0lH4U@S60P03U@?60`05U@O6C00003400iD3aP8019D8aP>E0lH500FE1lI:0000<003U@C61004U@O6
0YD3aPL01ID6aTT0000`00>E1<H600BE2/H900BE1LI90000<003U@?62@04U@S62P05U@?6B@000300
0iD3aP/00iD7aP`00iD3aTT0000`00>E0lH=00>E1LH<00>E0lI90000<003U@?63`03U@?63003U@?6
B@0003000iD4aR000iD3aTT0000`00>E1/HN00>E0lI90000<003U@S67003U@?6B@0001P019D4aQ80
0iD8aQX00iD3aTT0000H00BE1/HB00>E2<HH00>E0lI900006004U@S64P03U@W65@03U@?6B@0001P0
19D:aQ800iD9aQ<00iD3aTT0000H00>E00D0a/K6U@08aQ800iD9aQ400iD3aTT0000G00BE1<H3U@S6
4P04U@S63`03U@?6B@0001L019D4aP0309FE00:E2<HB00BE2<H=00>E0lI900005`03U@040<K6aP@0
19D8aQ8019D7aP`00iD3aTT0000G00>E00@0a/K61`03U@S64P04U@G63003U@?6B@0001L00iD01036
a/H900>E2<HB00>E00@0a/K63003U@?6B@0001L00iD01036a/H;00>E2<H@00>E00@0a/K63003U@?6
B@0001L00iD01036a/H=00>E2<H>00>E00@0a/K63003U@?6B@0001H019D4aPl00iD8aP`00iD01036
a/H<00>E0lH?00C6=P0001H019D4aQ400iD8aPX00iD01036a/H<00>E0lH;00BE1/Hd00005P03U@04
0<K6aQ@00iD8aPP00iD01036a/H<00>E0lH;00BE1lHc00005P04U@C65@03U@S61@04U@C63003U@?6
2`04U@W6<@0001H019D6aQD00iD9aP8019D4aP`00iD4aPX019D3aP03ULK600G6;`0001H019D9aQ@0
0iD9aP>E00@0a/K63@03U@K62003U@040<K6aP:E2<H]00006004U@W65003U@W600>E0<H00/H=00>E
2<H600>E00@0a/K619D8aR/0000J00BE2LHD00BE2lH=00FE2<H400>E00D0a/K60005U@O6:P0001`0
1ID9aQ<019D9aPl01ID8aP8019D3aP@019D7aRP0000N00FE2LHC00BE1lHA00FE2<H4U@?61P04U@K6
9`0002001ID9aQ<019D5aQ<01ID8aP:E0lH800>E1LHW00008`05U@W64P03U@040<K6aQD01ID;aPX0
0iD3aRL0000U00FE2LH^00FE2LH:00>E0lHW00009`05U@S6;`05U@O62P03U@?69`0002T01YD5aS40
1ID5aPX00iD3aRL0000[00FE00@0a/K6<`05U@?62P03U@?69`0002d00iD01036a/He00>E3@03U@C6
9P0002d00iD01036a/I500>E1<HV0000;@03U@040<K6aTD00iD01036a/HV0000;@03U@040<K6aTD0
0iD01036a/HV0000;@03U@040<K6aTD00iD01036a/HV0000;@03U@040<K6aTD00iD01036a/HV0000
;@03U@C6A@04U@C69@0002`019D4aQ<01<H^00BE1/HS0000;004U@?64004U@K6;004U@S68@0002`0
0iD01036a/H@00BE2LH[00BE2LHN0000;003U@040<K6aQ0019D;aR/019D9aQ`0000/00>E00@0a/K6
4004U@?600>Ea/H01lHE00BE1<H>00BE2LHJ0000;003U@040<K6aQ000iD01036a/H4U@S64`04U@K6
3P05U@S6600002`00iD00`36aP02aPl00iD01036a/H6U@S64@04U@S63P05U@O65`0002`019D6aPd0
0iD01036a/H200JE2LH>00BE2/H>00FE1LHG0000;004U@W62P03U@040<K6aP@01YD9aP`00iD01@36
a/JE00W63@05U@?65`0002`01YD9aPL019D4aPH01YD8aP/00iD01036a/H3U@W63@03U@?65`0002h0
1YD9aPD019D4aPP01iD5aP/00iD01@36a/H000BE2LH;00>E1<HF0000<@06U@S60`03U@040<K6aP`0
1ID01036a/H;00>E00@0a/K61004U@S62@03U@C65P0003<01YD8aP0509FEU@000lH>00>E00@0a/K6
2`04U@?61P04U@S61`03U@040<K6aQH0000f00FE2LH00iD0aP02aPh00iD01036a/H;00BE0lH800BE
2<H500>E00@0a/K65P0003P01ID<aPh00iD01036a/H<00>E0lH:00BE2LH200BE0lHF0000>P05U@[6
3P03U@040<K6aP`00iD3aP`019D9aPBE0lHF0000?@05U@O63P03U@040<K6aP`00iD3aPh019D9aP:E
0lHF0000?`05U@G63P03U@040<K6aP`00iD3aQ001ID<aQD0001200>E00@0a/K63P03U@040<K6aP`0
0iD4aQ401ID:aQD0001G00>E00@0a/K63003U@K64@05U@S65@0005L00iD01036a/H<00>E2LH@00JE
1LHE0000E`03U@040<K6aPh00iD9aQ001ID01036a/HE0000E`03U@040<K6aQ000iD9aQ000iDI0000
E`03U@040<K6aQ8019D8aRX0001G00>E00@0a/K65004U@W69`0005L00iD01036a/HG00>E2LHU0000
E`03U@040<K6aQT00iD8aR@0001G00>E00@0a/K66`04U@G6900005L00iD01036a/HM00>E00@0a/K6
900005L00iD01036a/HM00>E00@0a/K6900005L00iD01036a/HM00>E00@0a/K6900005L00iD01036
a/HM00>E00@0a/K6900005L00iD01036a/HM00>E00@0a/K6900005L00iD01036a/H<00BE1<H900>E
00@0a/K6900005L00iD01036a/H<00BE1lH600BE1<HS0000E`03U@040<K6aP`019D9aP@019D4aR<0
001G00>E00@0a/K63004U@c60P03U@040<K6aR<0001G00>E00@0a/K63003U@040<K6aP:E2/H2U@04
0<K6aR<0001G00>E00@0a/K63003U@040<K6aPBE2/H01036a/HS0000E`03U@040<K6aP`00iD01036
a/H200FE2lHS0000E`03U@040<K6aP`00iD01036a/H400JE2<HS0000E`04U@C62`03U@040<K6aPH0
1YD6aR<0001G00BE1lH800BE0lH900FE00@0a/K68`0005L019D:aPD019D3aP/00iDW0000F@04U@_6
0`03U@?6=@0005`019D:aP0409FEU@?6=@0005h01ID:aP04ULK6aSD0001Q00FE2lHe0000H`05U@W6
=@0006H01ID6aSD0001X00JE0lHe0000J`03UCP0002V0000YP000:H0002V0000YP000:H0002V0000
YP000:H0002V0000YP000:H0002V0000YP000:H0002V0000YP000:H0002V0000YP000:H0002V0000
YP0004h000?o0000E@0002T01?l300Co00@0ool00_l200;o10000ol0000300;o10000ol0000800Go
00@0ool00_l200Go00<0ool00`03o`@00_l/0000:0001Ol0003o008000?o00000`001?l00?l300;o
10000ol000020004o`00o`@000?o00002@001Ol0003o008000Co003o0`000ol00002o`@000?o0000
0P001?l00?l[0000:0000ol0o`02o`801Ol01@3o003o00X000Go0000o`020003o`0000h000Go0000
o`020004o`00o`<000?o00001P000ol000020004o`00ob/0000X0003o`0000@000Oo0000o`3o0080
00?o000020001?l00003oa4000Go0000o`020004o`00o`<000?o00001P000ol000020004o`00ob/0
000X0005o`000?l00`03o`030?oo00?o2`001?l00?lC0003o`0000Go0`04o`P000?o00000P001?l0
0?l[0000:@04oa@01?l300?o3P05o`/000?o00001@02o`D00_l/0000J002oc`0002V0000\
\>"],
  ImageRangeCache->{{{0, 165}, {165, 0}} -> {0.23266, -0.0250052, 0.00296329, 
  0.00676675}}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Reference", "Subtitle"],

Cell[TextData[{
  "C. Jacob, ",
  StyleBox["Illustrating Evolutionary Computation with Mathematica.",
    FontWeight->"Bold"],
  " Morgan Kaufmann Publishers, San Fancisco, 2001. Chapter 10.\n"
}], "Text"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 746}},
AutoGeneratedPackage->None,
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{829, 692},
WindowMargins->{{Automatic, 114}, {Automatic, 14}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, 128}},
ShowCellBracket->False,
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
CharacterEncoding->"MacintoshAutomaticEncoding",
StyleDefinitions -> \
FrontEnd`FileName[{ParentDirectory[ParentDirectory[ParentDirectory[]]], \
"IEC-Setup"}, "EvolvicaStyle.nb", CharacterEncoding -> "MacintoshRoman"]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "EvolutionOverview"->{
    Cell[311302, 22484, 50, 1, 26, "Text",
      CellTags->"EvolutionOverview"]},
  "Fitnesses-Gen20"->{
    Cell[1804792, 119871, 48, 1, 26, "Text",
      CellTags->"Fitnesses-Gen20"]},
  "Fitnesses-Gen40"->{
    Cell[2069777, 138796, 48, 1, 26, "Text",
      CellTags->"Fitnesses-Gen40"]},
  "Fitnesses-Gen60"->{
    Cell[2328770, 157220, 48, 1, 26, "Text",
      CellTags->"Fitnesses-Gen60"]},
  "Fitnesses-Gen80"->{
    Cell[2591785, 175899, 48, 1, 26, "Text",
      CellTags->"Fitnesses-Gen80"]},
  "MinMaxAverage-Fitnesses"->{
    Cell[2851405, 194224, 56, 1, 26, "Text",
      CellTags->"MinMaxAverage-Fitnesses"]},
  "Champion-L-systems"->{
    Cell[2891554, 196253, 51, 1, 26, "Text",
      CellTags->"Champion-L-systems"]},
  "EvolutionSteps"->{
    Cell[2946226, 198761, 47, 1, 26, "Text",
      CellTags->"EvolutionSteps"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"EvolutionOverview", 3043251, 203895},
  {"Fitnesses-Gen20", 3043356, 203898},
  {"Fitnesses-Gen40", 3043461, 203901},
  {"Fitnesses-Gen60", 3043566, 203904},
  {"Fitnesses-Gen80", 3043671, 203907},
  {"MinMaxAverage-Fitnesses", 3043784, 203910},
  {"Champion-L-systems", 3043900, 203913},
  {"EvolutionSteps", 3044007, 203916}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 113, 5, 129, "Title",
  Evaluatable->False],
Cell[1892, 60, 115, 3, 62, "Subsubtitle"],
Cell[2010, 65, 180844, 16821, 340, 127144, 16151, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[182857, 16888, 598, 21, 62, "Text"],

Cell[CellGroupData[{
Cell[183480, 16913, 127, 3, 75, "Subtitle",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[183632, 16920, 95, 2, 56, "Subsection",
  Evaluatable->False],
Cell[183730, 16924, 208, 6, 26, "Text"],
Cell[183941, 16932, 361, 13, 26, "Text"],

Cell[CellGroupData[{
Cell[184327, 16949, 272, 6, 89, "Input",
  InitializationCell->True],
Cell[184602, 16957, 149, 2, 56, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[184800, 16965, 95, 2, 56, "Subsection",
  Evaluatable->False],
Cell[184898, 16969, 123, 2, 26, "Text",
  Evaluatable->False],
Cell[185024, 16973, 63, 1, 41, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[185124, 16979, 111, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[185260, 16985, 99, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[185362, 16989, 81, 1, 41, "Input"],
Cell[185446, 16992, 101, 2, 41, "Input",
  InitializationCell->True],
Cell[185550, 16996, 101, 2, 41, "Input",
  InitializationCell->True],
Cell[185654, 17000, 98, 2, 41, "Input",
  InitializationCell->True],
Cell[185755, 17004, 103, 2, 41, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[185895, 17011, 100, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[185998, 17015, 91, 2, 41, "Input",
  InitializationCell->True],
Cell[186092, 17019, 102, 2, 41, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[186231, 17026, 100, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[186334, 17030, 96, 2, 41, "Input",
  InitializationCell->True],
Cell[186433, 17034, 98, 2, 41, "Input",
  InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[186592, 17043, 99, 2, 76, "Subtitle",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[186716, 17049, 89, 2, 56, "Subsection",
  Evaluatable->False],
Cell[186808, 17053, 138, 8, 101, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[186983, 17066, 88, 2, 56, "Subsection",
  Evaluatable->False],
Cell[187074, 17070, 179, 11, 146, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[187290, 17086, 90, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[187405, 17092, 406, 14, 191, "Input",
  InitializationCell->True],
Cell[187814, 17108, 185, 3, 39, "Message"],
Cell[188002, 17113, 191, 3, 39, "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[188242, 17122, 79, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[188346, 17128, 91, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[188462, 17134, 119, 2, 41, "Input"],
Cell[188584, 17138, 417, 12, 23, "Print"],
Cell[189004, 17152, 153, 3, 23, "Print"],
Cell[189160, 17157, 171, 3, 23, "Print"],
Cell[189334, 17162, 167, 3, 23, "Print"],
Cell[189504, 17167, 257, 7, 23, "Print"],
Cell[189764, 17176, 51, 1, 23, "Print"],
Cell[189818, 17179, 51, 1, 23, "Print"],
Cell[189872, 17182, 51, 1, 23, "Print"],
Cell[189926, 17185, 51, 1, 23, "Print"],
Cell[189980, 17188, 51, 1, 23, "Print"],
Cell[190034, 17191, 51, 1, 23, "Print"],
Cell[190088, 17194, 51, 1, 23, "Print"],
Cell[190142, 17197, 314, 5, 88, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[190493, 17207, 624, 36, 521, "Input",
  InitializationCell->True],
Cell[191120, 17245, 179, 3, 39, "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[191348, 17254, 97, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[191448, 17258, 696, 32, 461, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[192181, 17295, 227, 8, 60, "Subsubsection",
  Evaluatable->False],
Cell[192411, 17305, 209, 13, 176, "Input",
  InitializationCell->True]
}, Open  ]],
Cell[192635, 17321, 73, 2, 60, "Subsubsection",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[192757, 17329, 91, 2, 76, "Subtitle",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[192873, 17335, 105, 2, 56, "Subsection",
  Evaluatable->False],
Cell[192981, 17339, 209, 4, 44, "Text",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[193215, 17347, 91, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[193309, 17351, 123, 7, 86, "Input",
  InitializationCell->True],
Cell[193435, 17360, 151, 5, 56, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[193623, 17370, 92, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[193718, 17374, 125, 7, 86, "Input",
  InitializationCell->True],
Cell[193846, 17383, 153, 5, 56, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[194036, 17393, 89, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[194128, 17397, 142, 7, 86, "Input",
  InitializationCell->True],
Cell[194273, 17406, 147, 5, 56, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[194457, 17416, 94, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[194554, 17420, 126, 7, 86, "Input",
  InitializationCell->True],
Cell[194683, 17429, 157, 5, 56, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[194877, 17439, 94, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[194974, 17443, 127, 7, 86, "Input",
  InitializationCell->True],
Cell[195104, 17452, 157, 5, 56, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[195298, 17462, 96, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[195397, 17466, 128, 7, 86, "Input",
  InitializationCell->True],
Cell[195528, 17475, 161, 5, 56, "Input",
  InitializationCell->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[195738, 17486, 97, 2, 56, "Subsection",
  Evaluatable->False],
Cell[195838, 17490, 774, 28, 191, "Input",
  InitializationCell->True],
Cell[196615, 17520, 231, 6, 71, "Input",
  InitializationCell->True],
Cell[196849, 17528, 140, 5, 56, "Input",
  InitializationCell->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[197038, 17539, 80, 2, 50, "Subtitle",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[197143, 17545, 94, 2, 78, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[197262, 17551, 94, 2, 56, "Subsection",
  Evaluatable->False],
Cell[197359, 17555, 296, 15, 206, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[197692, 17575, 97, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[197814, 17581, 102, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[197941, 17587, 8092, 157, 1833, "Input",
  InitializationCell->True],
Cell[206036, 17746, 199, 3, 39, "Message"],
Cell[206238, 17751, 197, 3, 39, "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[206484, 17760, 90, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[206577, 17764, 189, 9, 116, "Input",
  InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[206827, 17780, 98, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[206950, 17786, 208, 8, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[207183, 17798, 91, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[207277, 17802, 448, 25, 356, "Input",
  InitializationCell->True],
Cell[207728, 17829, 198, 8, 101, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[207951, 17841, 73, 1, 41, "Input"],
Cell[208027, 17844, 218, 9, 43, "Output",
  Evaluatable->False]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[208306, 17860, 212, 8, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[208543, 17872, 103, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[208671, 17878, 2361, 41, 941, "Input",
  InitializationCell->True],
Cell[211035, 17921, 188, 3, 39, "Message"],
Cell[211226, 17926, 191, 3, 39, "Message"],
Cell[211420, 17931, 200, 3, 39, "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[211669, 17940, 90, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[211762, 17944, 278, 10, 131, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[212077, 17959, 117, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[212197, 17963, 183, 14, 191, "Input",
  InitializationCell->True],
Cell[212383, 17979, 313, 17, 236, "Input",
  InitializationCell->True],
Cell[212699, 17998, 342, 15, 206, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[213078, 18018, 101, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[213182, 18022, 244, 12, 161, "Input",
  InitializationCell->True],
Cell[213429, 18036, 140, 6, 71, "Input",
  InitializationCell->True],
Cell[213572, 18044, 450, 14, 191, "Input",
  InitializationCell->True],
Cell[214025, 18060, 490, 15, 206, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[214540, 18079, 117, 2, 56, "Input"],
Cell[214660, 18083, 3570, 107, 196, 675, 66, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[218267, 18195, 117, 2, 56, "Input"],
Cell[218387, 18199, 5966, 314, 211, 2156, 262, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[224390, 18518, 117, 2, 56, "Input"],
Cell[224510, 18522, 23946, 1946, 336, 14953, 1830, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[248493, 20473, 133, 3, 56, "Input"],
Cell[248629, 20478, 10421, 573, 234, 4113, 490, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[259099, 21057, 101, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[259203, 21061, 422, 16, 221, "Input",
  InitializationCell->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[259674, 21083, 208, 8, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[259907, 21095, 91, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[260001, 21099, 1290, 26, 641, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[261328, 21130, 90, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[261443, 21136, 282, 12, 161, "Input",
  InitializationCell->True],
Cell[261728, 21150, 201, 3, 39, "Message"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[261990, 21160, 99, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[262114, 21166, 98, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[262215, 21170, 950, 19, 581, "Input",
  InitializationCell->True],
Cell[263168, 21191, 206, 10, 131, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[263411, 21206, 106, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[263520, 21210, 325, 14, 191, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[263870, 21228, 16065, 286, 4185, "Input",
  InitializationCell->True],
Cell[279938, 21516, 207, 3, 39, "Message"],
Cell[280148, 21521, 179, 3, 39, "Message"],
Cell[280330, 21526, 204, 3, 39, "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[280583, 21535, 90, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[280676, 21539, 463, 20, 281, "Input",
  InitializationCell->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[281188, 21565, 92, 2, 40, "Subsection",
  Evaluatable->False],
Cell[281283, 21569, 3351, 61, 601, "Input",
  InitializationCell->True],
Cell[284637, 21632, 117, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[284791, 21644, 89, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[284905, 21650, 100, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[285008, 21654, 1512, 53, 776, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[286557, 21712, 111, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[286671, 21716, 331, 12, 161, "Input",
  InitializationCell->True],
Cell[287005, 21730, 370, 14, 191, "Input",
  InitializationCell->True],
Cell[287378, 21746, 129, 7, 86, "Input",
  InitializationCell->True],
Cell[287510, 21755, 265, 13, 176, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[287812, 21773, 104, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[287919, 21777, 502, 25, 356, "Input",
  InitializationCell->True],
Cell[288424, 21804, 550, 20, 281, "Input",
  InitializationCell->True],
Cell[288977, 21826, 307, 15, 206, "Input",
  InitializationCell->True],
Cell[289287, 21843, 371, 17, 236, "Input",
  InitializationCell->True],
Cell[289661, 21862, 230, 12, 161, "Input",
  InitializationCell->True]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[289952, 21881, 90, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[290067, 21887, 104, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[290196, 21893, 98, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[290297, 21897, 1076, 21, 581, "Input",
  InitializationCell->True],
Cell[291376, 21920, 206, 10, 131, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[291619, 21935, 91, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[291713, 21939, 337, 14, 191, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[292075, 21957, 6402, 103, 1657, "Input",
  InitializationCell->True],
Cell[298480, 22062, 197, 3, 70, "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[298726, 22071, 90, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[298819, 22075, 331, 14, 191, "Input",
  InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[299211, 22096, 85, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[299321, 22102, 94, 2, 56, "Subsection",
  Evaluatable->False],
Cell[299418, 22106, 569, 25, 356, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[300012, 22135, 2326, 36, 1211, "Input",
  InitializationCell->True],
Cell[302341, 22173, 193, 3, 70, "Message"]
}, Open  ]],
Cell[302549, 22179, 155, 8, 101, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[302741, 22192, 95, 2, 56, "Subsection",
  Evaluatable->False],
Cell[302839, 22196, 131, 7, 86, "Input",
  InitializationCell->True],
Cell[302973, 22205, 1281, 20, 731, "Input",
  InitializationCell->True],
Cell[304257, 22227, 239, 4, 161, "Input"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[304557, 22238, 93, 2, 76, "Subtitle",
  Evaluatable->False],
Cell[304653, 22242, 196, 3, 73, "Input"],

Cell[CellGroupData[{
Cell[304874, 22249, 55, 1, 41, "Input"],
Cell[304932, 22252, 39, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[305008, 22258, 564, 27, 401, "Input"],
Cell[305575, 22287, 239, 4, 39, "Message"],
Cell[305817, 22293, 38, 1, 23, "Print"],
Cell[305858, 22296, 447, 8, 39, "Print"],
Cell[306308, 22306, 99, 2, 23, "Print"],
Cell[306410, 22310, 38, 1, 23, "Print"],
Cell[306451, 22313, 812, 15, 71, "Print"],
Cell[307266, 22330, 99, 2, 23, "Print"],
Cell[307368, 22334, 115, 2, 23, "Message"],
Cell[307486, 22338, 36, 1, 23, "Print"],
Cell[307525, 22341, 93, 1, 23, "Print"],
Cell[307621, 22344, 83, 1, 23, "Print"],
Cell[307707, 22347, 93, 1, 23, "Print"],
Cell[307803, 22350, 36, 1, 23, "Print"],
Cell[307842, 22353, 36, 1, 23, "Print"],
Cell[307881, 22356, 71, 1, 23, "Print"],
Cell[307955, 22359, 36, 1, 23, "Print"],
Cell[307994, 22362, 217, 7, 23, "Print"],
Cell[308214, 22371, 36, 1, 23, "Print"],
Cell[308253, 22374, 139, 3, 23, "Print"],
Cell[308395, 22379, 36, 1, 23, "Print"],
Cell[308434, 22382, 70, 1, 23, "Print"],
Cell[308507, 22385, 36, 1, 23, "Print"],
Cell[308546, 22388, 417, 12, 23, "Print"],
Cell[308966, 22402, 278, 7, 23, "Print"],
Cell[309247, 22411, 171, 3, 23, "Print"],
Cell[309421, 22416, 167, 3, 23, "Print"],
Cell[309591, 22421, 257, 7, 23, "Print"],
Cell[309851, 22430, 51, 1, 23, "Print"],
Cell[309905, 22433, 42, 1, 40, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[309996, 22440, 108, 2, 76, "Subtitle",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[310129, 22446, 104, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[310258, 22452, 77, 0, 60, "Subsubsection"],
Cell[310338, 22454, 184, 3, 73, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[310559, 22462, 156, 4, 60, "Subsubsection",
  Evaluatable->False],
Cell[310718, 22468, 449, 7, 281, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[311204, 22480, 95, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[311302, 22484, 50, 1, 26, "Text",
  CellTags->"EvolutionOverview"],
Cell[311355, 22487, 36605, 1414, 326, 11532, 1099, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[347963, 23903, 209, 4, 53, "Message",
  Evaluatable->False],
Cell[348175, 23909, 127, 2, 23, "Message",
  Evaluatable->False],
Cell[348305, 23913, 248663, 18295, 360, 132384, 16851, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[597005, 42213, 96, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[597104, 42217, 73854, 2074, 387, 15060, 1343, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[670961, 44293, 207, 4, 53, "Message",
  Evaluatable->False],
Cell[671171, 44299, 127, 2, 23, "Message",
  Evaluatable->False],
Cell[671301, 44303, 208432, 15910, 326, 116826, 14772, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[879770, 60218, 96, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[879869, 60222, 84375, 2862, 387, 24941, 2123, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[964247, 63086, 206, 4, 53, "Message",
  Evaluatable->False],
Cell[964456, 63092, 129, 3, 23, "Message",
  Evaluatable->False],
Cell[964588, 63097, 205440, 15130, 326, 110618, 13953, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[1170065, 78232, 96, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1170164, 78236, 94161, 3667, 387, 35071, 2932, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1264328, 81905, 207, 4, 53, "Message",
  Evaluatable->False],
Cell[1264538, 81911, 129, 3, 23, "Message",
  Evaluatable->False],
Cell[1264670, 81916, 210943, 15930, 326, 116655, 14758, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[1475650, 97851, 96, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1475749, 97855, 105036, 4582, 387, 46088, 3849, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1580788, 102439, 208, 4, 53, "Message",
  Evaluatable->False],
Cell[1580999, 102445, 129, 3, 23, "Message",
  Evaluatable->False],
Cell[1581131, 102450, 221502, 17324, 326, 127144, 16151, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1802682, 119780, 89, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1802796, 119786, 98, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1802897, 119790, 184, 3, 73, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1803118, 119798, 114, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1803235, 119802, 324, 12, 161, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[1803596, 119819, 108, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1803729, 119825, 102, 1, 41, "Input"],
Cell[1803834, 119828, 334, 14, 59, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1804229, 119849, 96, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1804350, 119855, 119, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1804472, 119859, 178, 3, 73, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1804687, 119867, 102, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1804792, 119871, 48, 1, 26, "Text",
  CellTags->"Fitnesses-Gen20"],

Cell[CellGroupData[{
Cell[1804865, 119876, 159, 3, 56, "Input"],
Cell[1805027, 119881, 264595, 18905, 323, 219478, 18343, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2069671, 138792, 103, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[2069777, 138796, 48, 1, 26, "Text",
  CellTags->"Fitnesses-Gen40"],

Cell[CellGroupData[{
Cell[2069850, 138801, 176, 3, 71, "Input"],
Cell[2070029, 138806, 258586, 18404, 324, 217576, 17893, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2328664, 157216, 103, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[2328770, 157220, 48, 1, 26, "Text",
  CellTags->"Fitnesses-Gen60"],

Cell[CellGroupData[{
Cell[2328843, 157225, 176, 3, 71, "Input"],
Cell[2329022, 157230, 262608, 18659, 323, 219779, 18125, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2591679, 175895, 103, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[2591785, 175899, 48, 1, 26, "Text",
  CellTags->"Fitnesses-Gen80"],

Cell[CellGroupData[{
Cell[2591858, 175904, 176, 3, 71, "Input"],
Cell[2592037, 175909, 258369, 18281, 323, 216690, 17761, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2850455, 194196, 114, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[2850572, 194200, 139, 6, 71, "Input",
  InitializationCell->True],
Cell[2850714, 194208, 181, 4, 71, "Input"],
Cell[2850898, 194214, 504, 8, 281, "Input"],
Cell[2851405, 194224, 56, 1, 26, "Text",
  CellTags->"MinMaxAverage-Fitnesses"],
Cell[2851464, 194227, 29883, 1679, 268, 18747, 1537, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2881396, 195912, 89, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2881510, 195918, 129, 3, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2881664, 195925, 98, 1, 41, "Input"],
Cell[2881765, 195928, 902, 30, 123, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2882716, 195964, 168, 4, 60, "Subsubsection",
  Evaluatable->False],
Cell[2882887, 195970, 194, 4, 62, "Text",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2883106, 195978, 128, 3, 56, "Input"],
Cell[2883237, 195983, 147, 7, 43, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[2883421, 195995, 79, 1, 41, "Input"],
Cell[2883503, 195998, 157, 7, 43, "Output",
  Evaluatable->False]
}, Open  ]],
Cell[2883675, 196008, 241, 5, 44, "Text",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2883941, 196017, 140, 3, 86, "Input"],
Cell[2884084, 196022, 1487, 47, 187, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2885620, 196075, 117, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[2885740, 196079, 326, 12, 161, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[2886091, 196095, 341, 12, 161, "Input",
  InitializationCell->True],
Cell[2886435, 196109, 200, 3, 70, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2886672, 196117, 162, 4, 101, "Input"],
Cell[2886837, 196123, 2482, 82, 331, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[2889356, 196210, 61, 1, 41, "Input"],
Cell[2889420, 196213, 1331, 19, 563, "Print",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2890800, 196238, 116, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[2890919, 196242, 632, 9, 281, "Input"],
Cell[2891554, 196253, 51, 1, 26, "Text",
  CellTags->"Champion-L-systems"],

Cell[CellGroupData[{
Cell[2891630, 196258, 9446, 388, 336, 2445, 296, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2901079, 196648, 9908, 444, 336, 2863, 352, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2910990, 197094, 9719, 493, 336, 3285, 408, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2920712, 197589, 12113, 547, 336, 3497, 436, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2932828, 198138, 13222, 612, 336, 3917, 492, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2946111, 198757, 112, 2, 56, "Subsection",
  Evaluatable->False],
Cell[2946226, 198761, 47, 1, 26, "Text",
  CellTags->"EvolutionSteps"],

Cell[CellGroupData[{
Cell[2946298, 198766, 106, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[2946407, 198770, 339, 12, 161, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[2946771, 198786, 246, 4, 161, "Input"],
Cell[2947020, 198792, 143, 7, 43, "Output",
  Evaluatable->False]
}, Open  ]],
Cell[2947178, 198802, 120, 2, 26, "Text",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2947323, 198808, 64, 1, 41, "Input"],
Cell[2947390, 198811, 157, 7, 43, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[2947584, 198823, 102, 1, 41, "Input"],
Cell[2947689, 198826, 334, 14, 59, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[2948060, 198845, 167, 3, 70, "Input"],
Cell[2948230, 198850, 119, 2, 70, "Message"],
Cell[2948352, 198854, 1179, 43, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2949568, 198902, 66, 1, 70, "Input"],
Cell[2949637, 198905, 157, 7, 43, "Output",
  Evaluatable->False]
}, Open  ]],
Cell[2949809, 198915, 691, 10, 281, "Input"],
Cell[2950503, 198927, 188, 4, 62, "Text",
  Evaluatable->False],
Cell[2950694, 198933, 120, 2, 26, "Text",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2950839, 198939, 110, 2, 41, "Input"],
Cell[2950952, 198943, 108, 6, 43, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2951109, 198955, 130, 3, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2951264, 198962, 166, 3, 56, "Input"],
Cell[2951433, 198967, 558, 20, 91, "Output",
  Evaluatable->False],
Cell[2951994, 198989, 104, 6, 43, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[2952135, 199000, 166, 3, 56, "Input"],
Cell[2952304, 199005, 402, 14, 59, "Output",
  Evaluatable->False],
Cell[2952709, 199021, 106, 6, 43, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[2952852, 199032, 266, 4, 73, "Input"],

Cell[CellGroupData[{
Cell[2953143, 199040, 7798, 392, 239, 2670, 324, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2960944, 199434, 7545, 364, 239, 2461, 296, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2968538, 199804, 122, 2, 57, "Input"],
Cell[2968663, 199808, 7454, 414, 210, 2879, 352, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2976166, 200228, 129, 3, 34, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2976320, 200235, 164, 3, 56, "Input"],
Cell[2976487, 200240, 402, 14, 56, "Output",
  Evaluatable->False],
Cell[2976892, 200256, 106, 6, 42, "Output",
  Evaluatable->False]
}, Open  ]],
Cell[2977013, 200265, 166, 3, 56, "Input"],
Cell[2977182, 200270, 690, 24, 99, "Text",
  Evaluatable->False],
Cell[2977875, 200296, 106, 6, 42, "Output",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2978006, 200306, 264, 4, 105, "Input"],

Cell[CellGroupData[{
Cell[2978295, 200314, 7034, 358, 215, 2459, 296, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2985332, 200674, 7478, 439, 215, 3082, 380, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2992859, 201119, 122, 2, 57, "Input"],
Cell[2992984, 201123, 7587, 466, 218, 3301, 408, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[3000586, 201592, 166, 3, 56, "Input"],
Cell[3000755, 201597, 556, 20, 81, "Text",
  Evaluatable->False],
Cell[3001314, 201619, 106, 6, 42, "Output",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3001445, 201629, 103, 1, 41, "Input"],
Cell[3001551, 201632, 429, 15, 70, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3002029, 201653, 131, 3, 34, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3002185, 201660, 168, 3, 56, "Input"],
Cell[3002356, 201665, 588, 20, 84, "Output",
  Evaluatable->False],
Cell[3002947, 201687, 106, 6, 42, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[3003090, 201698, 124, 2, 41, "Input"],
Cell[3003217, 201702, 8698, 480, 219, 3297, 408, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[3011952, 202187, 124, 2, 41, "Input"],
Cell[3012079, 202191, 8979, 509, 212, 3513, 436, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3021107, 202706, 125, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3021257, 202712, 166, 3, 56, "Input"],
Cell[3021426, 202717, 588, 20, 91, "Output",
  Evaluatable->False],
Cell[3022017, 202739, 108, 6, 43, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[3022162, 202750, 122, 2, 41, "Input"],
Cell[3022287, 202754, 9264, 512, 235, 3511, 436, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[3031588, 203271, 124, 2, 41, "Input"],
Cell[3031715, 203275, 10114, 573, 236, 3933, 492, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[3041902, 203856, 29, 0, 50, "Subtitle"],
Cell[3041934, 203858, 205, 5, 62, "Text"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

